"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Oe=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/nls","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","fs","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/base/node/pfs","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","os","vs/base/common/process","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/charCode","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/iterator","vs/platform/telemetry/common/telemetryUtils","vs/platform/contextkey/common/contextkey","vs/base/common/json","vs/base/common/stopwatch","vs/base/common/performance","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/editor/common/core/range","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc","vs/platform/files/common/watcher","vs/platform/terminal/common/terminal","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/severity","path","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/platform/product/common/product","vs/base/common/semver/semver","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/glob","vs/base/node/zip","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/storage/common/storage","vs/server/node/remoteLanguagePacks","vs/server/node/serverConnectionToken","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/encodedTokenAttributes","vs/nls.messages","vs/amdX","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/cssDev/node/cssDevService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/terminal/common/remote/terminal","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/collections","vs/base/common/equals","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/macAddress","vs/base/node/nls","vs/base/node/ports","vs/base/parts/request/common/request","vs/editor/common/core/editOperation","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/editor/common/languages","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/config/editorOptions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","cookie","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/chat/common/languageModels","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","readline","util","minimist","assert","@microsoft/1ds-core-js","vs/server/node/server.main"],Le=function(ue){for(var e=[],t=0,i=ue.length;t<i;t++)e[t]=Oe[ue[t]];return e};define(Oe[65],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=e.LoaderEventType=e.$W=e.$V=void 0,e.$V=!1,e.$W=!0;var t;(function(E){E[E.LoaderAvailable=1]="LoaderAvailable",E[E.BeginLoadingScript=10]="BeginLoadingScript",E[E.EndLoadingScriptOK=11]="EndLoadingScriptOK",E[E.EndLoadingScriptError=12]="EndLoadingScriptError",E[E.BeginInvokeFactory=21]="BeginInvokeFactory",E[E.EndInvokeFactory=22]="EndInvokeFactory",E[E.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",E[E.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",E[E.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",E[E.NodeEndNativeRequire=34]="NodeEndNativeRequire",E[E.CachedDataFound=60]="CachedDataFound",E[E.CachedDataMissed=61]="CachedDataMissed",E[E.CachedDataRejected=62]="CachedDataRejected",E[E.CachedDataCreated=63]="CachedDataCreated"})(t||(e.LoaderEventType=t={}));class i{static get(){const I=new Map,D=new Map,T=new Map,v=new Map;function s(a,c){a.has(c.detail)||a.set(c.detail,-c.timestamp)}function S(a,c){const m=a.get(c.detail);m&&(m>=0||a.set(c.detail,m+c.timestamp))}let y=[];typeof ue=="function"&&typeof ue.getStats=="function"&&(y=ue.getStats().slice(0).sort((a,c)=>a.timestamp-c.timestamp));for(const a of y)switch(a.type){case t.BeginLoadingScript:s(I,a);break;case t.EndLoadingScriptOK:case t.EndLoadingScriptError:S(I,a);break;case t.BeginInvokeFactory:s(D,a);break;case t.EndInvokeFactory:S(D,a);break;case t.NodeBeginNativeRequire:s(T,a);break;case t.NodeEndNativeRequire:S(T,a);break;case t.NodeBeginEvaluatingScript:s(v,a);break;case t.NodeEndEvaluatingScript:S(v,a);break}let p=0;T.forEach(a=>p+=a);function $(a){const c=[];return a.forEach((m,b)=>c.push([b,m])),c}return{amdLoad:$(I),amdInvoke:$(D),nodeRequire:$(T),nodeEval:$(v),nodeRequireTotal:p}}static toMarkdownTable(I,D){let T="";const v=[];return I.forEach((s,S)=>{v[S]=s.length}),D.forEach(s=>{s.forEach((S,y)=>{typeof S>"u"&&(S=s[y]="-");const p=S.toString().length;v[y]=Math.max(p,v[y])})}),I.forEach((s,S)=>{T+=`| ${s+" ".repeat(v[S]-s.toString().length)} `}),T+=`|
`,I.forEach((s,S)=>{T+=`| ${"-".repeat(v[S])} `}),T+=`|
`,D.forEach(s=>{s.forEach((S,y)=>{typeof S<"u"&&(T+=`| ${S+" ".repeat(v[y]-S.toString().length)} `)}),T+=`|
`}),T}}e.$X=i}),define(Oe[105],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=void 0,e.$jb=t,e.$kb=i,e.$lb=E,e.$mb=I,e.$nb=D,e.$ob=T,e.$pb=v,e.$rb=S,e.$sb=y,e.$tb=p,e.$ub=$,e.$vb=a;function t(c,m){const b=i(c,m);if(b!==-1)return c[b]}function i(c,m,b=c.length-1){for(let g=b;g>=0;g--){const d=c[g];if(m(d))return g}return-1}function E(c,m){const b=I(c,m);return b===-1?void 0:c[b]}function I(c,m,b=0,g=c.length){let d=b,w=g;for(;d<w;){const o=Math.floor((d+w)/2);m(c[o])?d=o+1:w=o}return d-1}function D(c,m){const b=T(c,m);return b===c.length?void 0:c[b]}function T(c,m,b=0,g=c.length){let d=b,w=g;for(;d<w;){const o=Math.floor((d+w)/2);m(c[o])?w=o:d=o+1}return d}function v(c,m,b=0,g=c.length){const d=T(c,m,b,g);return d===c.length?-1:d}class s{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(s.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!m(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const b=I(this.e,m,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}e.$qb=s;function S(c,m){if(c.length===0)return;let b=c[0];for(let g=1;g<c.length;g++){const d=c[g];m(d,b)>0&&(b=d)}return b}function y(c,m){if(c.length===0)return;let b=c[0];for(let g=1;g<c.length;g++){const d=c[g];m(d,b)>=0&&(b=d)}return b}function p(c,m){return S(c,(b,g)=>-m(b,g))}function $(c,m){if(c.length===0)return-1;let b=0;for(let g=1;g<c.length;g++){const d=c[g];m(d,c[b])>0&&(b=g)}return b}function a(c,m){for(const b of c){const g=m(b);if(g!==void 0)return g}}}),define(Oe[34],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var t;(function(i){i[i.Null=0]="Null",i[i.Backspace=8]="Backspace",i[i.Tab=9]="Tab",i[i.LineFeed=10]="LineFeed",i[i.CarriageReturn=13]="CarriageReturn",i[i.Space=32]="Space",i[i.ExclamationMark=33]="ExclamationMark",i[i.DoubleQuote=34]="DoubleQuote",i[i.Hash=35]="Hash",i[i.DollarSign=36]="DollarSign",i[i.PercentSign=37]="PercentSign",i[i.Ampersand=38]="Ampersand",i[i.SingleQuote=39]="SingleQuote",i[i.OpenParen=40]="OpenParen",i[i.CloseParen=41]="CloseParen",i[i.Asterisk=42]="Asterisk",i[i.Plus=43]="Plus",i[i.Comma=44]="Comma",i[i.Dash=45]="Dash",i[i.Period=46]="Period",i[i.Slash=47]="Slash",i[i.Digit0=48]="Digit0",i[i.Digit1=49]="Digit1",i[i.Digit2=50]="Digit2",i[i.Digit3=51]="Digit3",i[i.Digit4=52]="Digit4",i[i.Digit5=53]="Digit5",i[i.Digit6=54]="Digit6",i[i.Digit7=55]="Digit7",i[i.Digit8=56]="Digit8",i[i.Digit9=57]="Digit9",i[i.Colon=58]="Colon",i[i.Semicolon=59]="Semicolon",i[i.LessThan=60]="LessThan",i[i.Equals=61]="Equals",i[i.GreaterThan=62]="GreaterThan",i[i.QuestionMark=63]="QuestionMark",i[i.AtSign=64]="AtSign",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.OpenSquareBracket=91]="OpenSquareBracket",i[i.Backslash=92]="Backslash",i[i.CloseSquareBracket=93]="CloseSquareBracket",i[i.Caret=94]="Caret",i[i.Underline=95]="Underline",i[i.BackTick=96]="BackTick",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.OpenCurlyBrace=123]="OpenCurlyBrace",i[i.Pipe=124]="Pipe",i[i.CloseCurlyBrace=125]="CloseCurlyBrace",i[i.Tilde=126]="Tilde",i[i.NoBreakSpace=160]="NoBreakSpace",i[i.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",i[i.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",i[i.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",i[i.U_Combining_Tilde=771]="U_Combining_Tilde",i[i.U_Combining_Macron=772]="U_Combining_Macron",i[i.U_Combining_Overline=773]="U_Combining_Overline",i[i.U_Combining_Breve=774]="U_Combining_Breve",i[i.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",i[i.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",i[i.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",i[i.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",i[i.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",i[i.U_Combining_Caron=780]="U_Combining_Caron",i[i.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",i[i.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",i[i.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",i[i.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",i[i.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",i[i.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",i[i.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",i[i.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",i[i.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",i[i.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",i[i.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",i[i.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",i[i.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",i[i.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",i[i.U_Combining_Horn=795]="U_Combining_Horn",i[i.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",i[i.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",i[i.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",i[i.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",i[i.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",i[i.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",i[i.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",i[i.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",i[i.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",i[i.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",i[i.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",i[i.U_Combining_Cedilla=807]="U_Combining_Cedilla",i[i.U_Combining_Ogonek=808]="U_Combining_Ogonek",i[i.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",i[i.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",i[i.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",i[i.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",i[i.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",i[i.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",i[i.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",i[i.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",i[i.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",i[i.U_Combining_Low_Line=818]="U_Combining_Low_Line",i[i.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",i[i.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",i[i.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",i[i.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",i[i.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",i[i.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",i[i.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",i[i.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",i[i.U_Combining_Square_Below=827]="U_Combining_Square_Below",i[i.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",i[i.U_Combining_X_Above=829]="U_Combining_X_Above",i[i.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",i[i.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",i[i.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",i[i.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",i[i.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",i[i.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",i[i.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",i[i.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",i[i.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",i[i.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",i[i.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",i[i.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",i[i.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",i[i.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",i[i.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",i[i.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",i[i.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",i[i.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",i[i.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",i[i.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",i[i.U_Combining_Fermata=850]="U_Combining_Fermata",i[i.U_Combining_X_Below=851]="U_Combining_X_Below",i[i.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",i[i.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",i[i.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",i[i.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",i[i.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",i[i.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",i[i.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",i[i.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",i[i.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",i[i.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",i[i.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",i[i.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",i[i.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",i[i.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",i[i.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",i[i.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",i[i.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",i[i.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",i[i.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",i[i.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",i[i.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",i[i.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",i[i.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",i[i.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",i[i.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",i[i.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",i[i.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",i[i.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",i[i.LINE_SEPARATOR=8232]="LINE_SEPARATOR",i[i.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",i[i.NEXT_LINE=133]="NEXT_LINE",i[i.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",i[i.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",i[i.U_DIAERESIS=168]="U_DIAERESIS",i[i.U_MACRON=175]="U_MACRON",i[i.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",i[i.U_CEDILLA=184]="U_CEDILLA",i[i.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",i[i.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",i[i.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",i[i.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",i[i.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",i[i.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",i[i.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",i[i.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",i[i.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",i[i.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",i[i.U_BREVE=728]="U_BREVE",i[i.U_DOT_ABOVE=729]="U_DOT_ABOVE",i[i.U_RING_ABOVE=730]="U_RING_ABOVE",i[i.U_OGONEK=731]="U_OGONEK",i[i.U_SMALL_TILDE=732]="U_SMALL_TILDE",i[i.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",i[i.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",i[i.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",i[i.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",i[i.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",i[i.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",i[i.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",i[i.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",i[i.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",i[i.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",i[i.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",i[i.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",i[i.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",i[i.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",i[i.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",i[i.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",i[i.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",i[i.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",i[i.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",i[i.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",i[i.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",i[i.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",i[i.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",i[i.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",i[i.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",i[i.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",i[i.U_GREEK_TONOS=900]="U_GREEK_TONOS",i[i.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",i[i.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",i[i.U_GREEK_PSILI=8127]="U_GREEK_PSILI",i[i.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",i[i.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",i[i.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",i[i.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",i[i.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",i[i.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",i[i.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",i[i.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",i[i.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",i[i.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",i[i.U_GREEK_VARIA=8175]="U_GREEK_VARIA",i[i.U_GREEK_OXIA=8189]="U_GREEK_OXIA",i[i.U_GREEK_DASIA=8190]="U_GREEK_DASIA",i[i.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",i[i.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",i[i.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",i[i.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",i[i.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",i[i.U_OVERLINE=8254]="U_OVERLINE",i[i.UTF8_BOM=65279]="UTF8_BOM",i[i.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",i[i.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(t||(e.CharCode=t={}))}),define(Oe[159],Le([1,0]),function(ue,e){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$i=void 0,e.$e=i,e.$f=E,e.$g=I,e.$h=D;function i(v,s){const S=Object.create(null);for(const y of v){const p=s(y);let $=S[p];$||($=S[p]=[]),$.push(y)}return S}function E(v,s){const S=[],y=[];for(const p of v)s.has(p)||S.push(p);for(const p of s)v.has(p)||y.push(p);return{removed:S,added:y}}function I(v,s){const S=[],y=[];for(const[p,$]of v)s.has(p)||S.push($);for(const[p,$]of s)v.has(p)||y.push($);return{removed:S,added:y}}function D(v,s){const S=new Set;for(const y of s)v.has(y)&&S.add(y);return S}class T{static{t=Symbol.toStringTag}constructor(s,S){this.b=S,this.a=new Map,this[t]="SetWithKey";for(const y of s)this.add(y)}get size(){return this.a.size}add(s){const S=this.b(s);return this.a.set(S,s),this}delete(s){return this.a.delete(this.b(s))}has(s){return this.a.has(this.b(s))}*entries(){for(const s of this.a.values())yield[s,s]}keys(){return this.values()}*values(){for(const s of this.a.values())yield s}clear(){this.a.clear()}forEach(s,S){this.a.forEach(y=>s.call(S,y,y,this))}[Symbol.iterator](){return this.values()}}e.$i=T}),define(Oe[79],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=i,e.$di=E,e.$ei=I;function t(D){return(T,v,s)=>{let S=null,y=null;if(typeof s.value=="function"?(S="value",y=s.value):typeof s.get=="function"&&(S="get",y=s.get),!y)throw new Error("not supported");s[S]=D(y,v)}}function i(D,T,v){let s=null,S=null;if(typeof v.value=="function"?(s="value",S=v.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(s="get",S=v.get),!S)throw new Error("not supported");const y=`$memoize$${T}`;v[s]=function(...p){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,p)}),this[y]}}function E(D,T,v){return t((s,S)=>{const y=`$debounce$${S}`,p=`$debounce$result$${S}`;return function(...$){this[p]||(this[p]=v?v():void 0),clearTimeout(this[y]),T&&(this[p]=T(this[p],...$),$=[this[p]]),this[y]=setTimeout(()=>{s.apply(this,$),this[p]=v?v():void 0},D)}})}function I(D,T,v){return t((s,S)=>{const y=`$throttle$timer$${S}`,p=`$throttle$result$${S}`,$=`$throttle$lastRun$${S}`,a=`$throttle$pending$${S}`;return function(...c){if(this[p]||(this[p]=v?v():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),T&&(this[p]=T(this[p],...c)),this[a])return;const m=this[$]+D;m<=Date.now()?(this[$]=Date.now(),s.apply(this,[this[p]]),this[p]=v?v():void 0):(this[a]=!0,this[y]=setTimeout(()=>{this[a]=!1,this[$]=Date.now(),s.apply(this,[this[p]]),this[p]=v?v():void 0},m-Date.now()))}})}}),define(Oe[9],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=e.$fb=e.$eb=e.$db=e.$cb=e.$ab=e.$9=e.$1=e.$Z=void 0,e.setUnexpectedErrorHandler=i,e.$3=E,e.$4=I,e.$5=D,e.$6=T,e.$7=v,e.$8=S,e.$0=p,e.$$=$,e.$_=a,e.$bb=m;class t{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?w.isErrorNoTelemetry(n)?new w(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(u=>{u(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$Z=t,e.$1=new t;function i(l){e.$1.setUnexpectedErrorHandler(l)}function E(l){if(!l||typeof l!="object")return!1;const n=l;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function I(l){S(l)||e.$1.onUnexpectedError(l)}function D(l){S(l)||e.$1.onUnexpectedExternalError(l)}function T(l){if(l instanceof Error){const{name:n,message:u}=l,r=l.stacktrace||l.stack;return{$isError:!0,name:n,message:u,stack:r,noTelemetry:w.isErrorNoTelemetry(l)}}return l}function v(l){let n;return l.noTelemetry?n=new w:(n=new Error,n.name=l.name),n.message=l.message,n.stack=l.stack,n}const s="Canceled";function S(l){return l instanceof y?!0:l instanceof Error&&l.name===s&&l.message===s}class y extends Error{constructor(){super(s),this.name=this.message}}e.$9=y;function p(){const l=new Error(s);return l.name=l.message,l}function $(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function a(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class c extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$ab=c;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class b extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$cb=b;class g extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$db=g;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$eb=d;class w extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof w)return n;const u=new w;return u.message=n.message,u.stack=n.stack,u}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$fb=w;class o extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$gb=o}),define(Oe[17],Le([1,0,9,105]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.$cc=e.$ac=e.$_b=e.CompareResult=void 0,e.$wb=E,e.$xb=I,e.$yb=D,e.$zb=T,e.$Ab=v,e.$Bb=s,e.$Cb=S,e.$Db=y,e.$Eb=p,e.$Fb=$,e.$Gb=a,e.$Hb=c,e.$Ib=m,e.top=b,e.$Kb=g,e.$Lb=w,e.$Mb=o,e.$Nb=l,e.$Ob=n,e.$Pb=u,e.$Qb=r,e.$Rb=f,e.$Sb=h,e.$Tb=k,e.$Ub=P,e.$Vb=O,e.$Wb=C,e.$Xb=L,e.$Yb=R,e.$Zb=z,e.$1b=Q,e.$2b=J,e.$3b=x,e.$4b=ve,e.$5b=be,e.$6b=se,e.$7b=V,e.$8b=B,e.$9b=j,e.$0b=le,e.$$b=ye,e.$bc=X,e.$fc=pe;function E(ne,ie=0){return ne[ne.length-(1+ie)]}function I(ne){if(ne.length===0)throw new Error("Invalid tail call");return[ne.slice(0,ne.length-1),ne[ne.length-1]]}function D(ne,ie,G=(Z,ce)=>Z===ce){if(ne===ie)return!0;if(!ne||!ie||ne.length!==ie.length)return!1;for(let Z=0,ce=ne.length;Z<ce;Z++)if(!G(ne[Z],ie[Z]))return!1;return!0}function T(ne,ie){const G=ne.length-1;ie<G&&(ne[ie]=ne[G]),ne.pop()}function v(ne,ie,G){return s(ne.length,Z=>G(ne[Z],ie))}function s(ne,ie){let G=0,Z=ne-1;for(;G<=Z;){const ce=(G+Z)/2|0,we=ie(ce);if(we<0)G=ce+1;else if(we>0)Z=ce-1;else return ce}return-(G+1)}function S(ne,ie,G){if(ne=ne|0,ne>=ie.length)throw new TypeError("invalid index");const Z=ie[Math.floor(ie.length*Math.random())],ce=[],we=[],Ie=[];for(const Me of ie){const Be=G(Me,Z);Be<0?ce.push(Me):Be>0?we.push(Me):Ie.push(Me)}return ne<ce.length?S(ne,ce,G):ne<ce.length+Ie.length?Ie[0]:S(ne-(ce.length+Ie.length),we,G)}function y(ne,ie){const G=[];let Z;for(const ce of ne.slice(0).sort(ie))!Z||ie(Z[0],ce)!==0?(Z=[ce],G.push(Z)):Z.push(ce);return G}function*p(ne,ie){let G,Z;for(const ce of ne)Z!==void 0&&ie(Z,ce)?G.push(ce):(G&&(yield G),G=[ce]),Z=ce;G&&(yield G)}function $(ne,ie){for(let G=0;G<=ne.length;G++)ie(G===0?void 0:ne[G-1],G===ne.length?void 0:ne[G])}function a(ne,ie){for(let G=0;G<ne.length;G++)ie(G===0?void 0:ne[G-1],ne[G],G+1===ne.length?void 0:ne[G+1])}function c(ne,ie,G){const Z=[];function ce(Me,Be,De){if(Be===0&&De.length===0)return;const Ne=Z[Z.length-1];Ne&&Ne.start+Ne.deleteCount===Me?(Ne.deleteCount+=Be,Ne.toInsert.push(...De)):Z.push({start:Me,deleteCount:Be,toInsert:De})}let we=0,Ie=0;for(;;){if(we===ne.length){ce(we,0,ie.slice(Ie));break}if(Ie===ie.length){ce(we,ne.length-we,[]);break}const Me=ne[we],Be=ie[Ie],De=G(Me,Be);De===0?(we+=1,Ie+=1):De<0?(ce(we,1,[]),we+=1):De>0&&(ce(we,0,[Be]),Ie+=1)}return Z}function m(ne,ie,G){const Z=c(ne,ie,G),ce=[],we=[];for(const Ie of Z)ce.push(...ne.slice(Ie.start,Ie.start+Ie.deleteCount)),we.push(...Ie.toInsert);return{removed:ce,added:we}}function b(ne,ie,G){if(G===0)return[];const Z=ne.slice(0,G).sort(ie);return d(ne,ie,Z,G,ne.length),Z}function g(ne,ie,G,Z,ce){return G===0?Promise.resolve([]):new Promise((we,Ie)=>{(async()=>{const Me=ne.length,Be=ne.slice(0,G).sort(ie);for(let De=G,Ne=Math.min(G+Z,Me);De<Me;De=Ne,Ne=Math.min(Ne+Z,Me)){if(De>G&&await new Promise(Te=>setTimeout(Te)),ce&&ce.isCancellationRequested)throw new t.$9;d(ne,ie,Be,De,Ne)}return Be})().then(we,Ie)})}function d(ne,ie,G,Z,ce){for(const we=G.length;Z<ce;Z++){const Ie=ne[Z];if(ie(Ie,G[we-1])<0){G.pop();const Me=(0,i.$ob)(G,Be=>ie(Ie,Be)<0);G.splice(Me,0,Ie)}}}function w(ne){return ne.filter(ie=>!!ie)}function o(ne){let ie=0;for(let G=0;G<ne.length;G++)ne[G]&&(ne[ie]=ne[G],ie+=1);ne.length=ie}function l(ne,ie,G){ne.splice(G,0,ne.splice(ie,1)[0])}function n(ne){return!Array.isArray(ne)||ne.length===0}function u(ne){return Array.isArray(ne)&&ne.length>0}function r(ne,ie=G=>G){const G=new Set;return ne.filter(Z=>{const ce=ie(Z);return G.has(ce)?!1:(G.add(ce),!0)})}function f(ne){const ie=new Set;return G=>{const Z=ne(G);return ie.has(Z)?!1:(ie.add(Z),!0)}}function h(ne,ie){return ne.length>0?ne[0]:ie}function k(ne,ie){return ne.length>0?ne[ne.length-1]:ie}function P(ne,ie,G=(Z,ce)=>Z===ce){let Z=0;for(let ce=0,we=Math.min(ne.length,ie.length);ce<we&&G(ne[ce],ie[ce]);ce++)Z++;return Z}function O(ne,ie){let G=typeof ie=="number"?ne:0;typeof ie=="number"?G=ne:(G=0,ie=ne);const Z=[];if(G<=ie)for(let ce=G;ce<ie;ce++)Z.push(ce);else for(let ce=G;ce>ie;ce--)Z.push(ce);return Z}function C(ne,ie,G){return ne.reduce((Z,ce)=>(Z[ie(ce)]=G?G(ce):ce,Z),Object.create(null))}function L(ne,ie){return ne.push(ie),()=>R(ne,ie)}function R(ne,ie){const G=ne.indexOf(ie);if(G>-1)return ne.splice(G,1),ie}function z(ne,ie,G){const Z=ne.slice(0,ie),ce=ne.slice(ie);return Z.concat(G,ce)}function Q(ne,ie){let G;if(typeof ie=="number"){let Z=ie;G=()=>{const ce=Math.sin(Z++)*179426549;return ce-Math.floor(ce)}}else G=Math.random;for(let Z=ne.length-1;Z>0;Z-=1){const ce=Math.floor(G()*(Z+1)),we=ne[Z];ne[Z]=ne[ce],ne[ce]=we}}function J(ne,ie){const G=ne.indexOf(ie);G>-1&&(ne.splice(G,1),ne.unshift(ie))}function x(ne,ie){const G=ne.indexOf(ie);G>-1&&(ne.splice(G,1),ne.push(ie))}function ve(ne,ie){for(const G of ie)ne.push(G)}function be(ne,ie){return Array.isArray(ne)?ne.map(ie):ie(ne)}function se(ne){return Array.isArray(ne)?ne:[ne]}function V(ne){return ne[Math.floor(Math.random()*ne.length)]}function B(ne,ie,G){const Z=U(ne,ie),ce=ne.length,we=G.length;ne.length=ce+we;for(let Ie=ce-1;Ie>=Z;Ie--)ne[Ie+we]=ne[Ie];for(let Ie=0;Ie<we;Ie++)ne[Ie+Z]=G[Ie]}function j(ne,ie,G,Z){const ce=U(ne,ie);let we=ne.splice(ce,G);return we===void 0&&(we=[]),B(ne,ce,Z),we}function U(ne,ie){return ie<0?Math.max(ie+ne.length,0):Math.min(ie,ne.length)}var te;(function(ne){function ie(we){return we<0}ne.isLessThan=ie;function G(we){return we<=0}ne.isLessThanOrEqual=G;function Z(we){return we>0}ne.isGreaterThan=Z;function ce(we){return we===0}ne.isNeitherLessOrGreaterThan=ce,ne.greaterThan=1,ne.lessThan=-1,ne.neitherLessOrGreaterThan=0})(te||(e.CompareResult=te={}));function le(ne,ie){return(G,Z)=>ie(ne(G),ne(Z))}function ye(...ne){return(ie,G)=>{for(const Z of ne){const ce=Z(ie,G);if(!te.isNeitherLessOrGreaterThan(ce))return ce}return te.neitherLessOrGreaterThan}}const oe=(ne,ie)=>ne-ie;e.$_b=oe;const _=(ne,ie)=>(0,e.$_b)(ne?1:0,ie?1:0);e.$ac=_;function X(ne){return(ie,G)=>-ne(ie,G)}class M{constructor(ie){this.g=ie,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let G=this.c;for(;G<this.g.length&&ie(this.g[G]);)G++;const Z=G===this.c?null:this.g.slice(this.c,G);return this.c=G,Z}takeFromEndWhile(ie){let G=this.d;for(;G>=0&&ie(this.g[G]);)G--;const Z=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,Z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ie=this.g[this.c];return this.c++,ie}removeLast(){const ie=this.g[this.d];return this.d--,ie}takeCount(ie){const G=this.g.slice(this.c,this.c+ie);return this.c+=ie,G}}e.$cc=M;class A{static{this.empty=new A(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(G=>(ie(G),!0))}toArray(){const ie=[];return this.iterate(G=>(ie.push(G),!0)),ie}filter(ie){return new A(G=>this.iterate(Z=>ie(Z)?G(Z):!0))}map(ie){return new A(G=>this.iterate(Z=>G(ie(Z))))}some(ie){let G=!1;return this.iterate(Z=>(G=ie(Z),!G)),G}findFirst(ie){let G;return this.iterate(Z=>ie(Z)?(G=Z,!1):!0),G}findLast(ie){let G;return this.iterate(Z=>(ie(Z)&&(G=Z),!0)),G}findLastMaxBy(ie){let G,Z=!0;return this.iterate(ce=>((Z||te.isGreaterThan(ie(ce,G)))&&(Z=!1,G=ce),!0)),G}}e.$dc=A;class Y{constructor(ie){this.c=ie}static createSortPermutation(ie,G){const Z=Array.from(ie.keys()).sort((ce,we)=>G(ie[ce],ie[we]));return new Y(Z)}apply(ie){return ie.map((G,Z)=>ie[this.c[Z]])}inverse(){const ie=this.c.slice();for(let G=0;G<this.c.length;G++)ie[this.c[G]]=G;return new Y(ie)}}e.$ec=Y;async function pe(ne,ie){return(await Promise.all(ne.map(async(Z,ce)=>({element:Z,ok:await ie(Z,ce)})))).find(Z=>Z.ok)?.element}}),define(Oe[106],Le([1,0,9]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=i,e.$jd=E,e.$kd=I,e.$ld=D,e.$md=T,e.$nd=v;function i(s,S){if(!s)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}function E(s,S="Unreachable"){throw new Error(S)}function I(s,S="unexpected state"){if(!s)throw new t.$gb(`Assertion Failed: ${S}`)}function D(s){s||(0,t.$4)(new t.$gb("Soft Assertion Failed"))}function T(s){if(!s()){debugger;s(),(0,t.$4)(new t.$gb("Assertion Failed"))}}function v(s,S){let y=0;for(;y<s.length-1;){const p=s[y],$=s[y+1];if(!S(p,$))return!1;y++}return!0}});var Ci=this&&this.__createBinding||(Object.create?function(ue,e,t,i){i===void 0&&(i=t);var E=Object.getOwnPropertyDescriptor(e,t);(!E||("get"in E?!e.__esModule:E.writable||E.configurable))&&(E={enumerable:!0,get:function(){return e[t]}}),Object.defineProperty(ue,i,E)}:function(ue,e,t,i){i===void 0&&(i=t),ue[i]=e[t]}),Ni=this&&this.__setModuleDefault||(Object.create?function(ue,e){Object.defineProperty(ue,"default",{enumerable:!0,value:e})}:function(ue,e){ue.default=e}),We=this&&this.__importStar||function(ue){if(ue&&ue.__esModule)return ue;var e={};if(ue!=null)for(var t in ue)t!=="default"&&Object.prototype.hasOwnProperty.call(ue,t)&&Ci(e,ue,t);return Ni(e,ue),e};define(Oe[160],Le([1,0,17]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$c=void 0,e.$_c=E,e.$ad=I,e.$bd=D,e.$cd=T,e.$dd=v,e.$ed=s,t=We(t);const i=($,a)=>$===a;e.$$c=i;function E($=e.$$c){return(a,c)=>t.$yb(a,c,$)}function I(){return($,a)=>JSON.stringify($)===JSON.stringify(a)}function D(){return($,a)=>$.equals(a)}function T($,a,c){if(c!==void 0){const m=$;return m==null||a===void 0||a===null?a===m:c(m,a)}else{const m=$;return(b,g)=>b==null||g===void 0||g===null?g===b:m(b,g)}}function v($,a){if($===a)return!0;if(Array.isArray($)&&Array.isArray(a)){if($.length!==a.length)return!1;for(let c=0;c<$.length;c++)if(!v($[c],a[c]))return!1;return!0}if($&&typeof $=="object"&&a&&typeof a=="object"&&Object.getPrototypeOf($)===Object.prototype&&Object.getPrototypeOf(a)===Object.prototype){const c=$,m=a,b=Object.keys(c),g=Object.keys(m),d=new Set(g);if(b.length!==g.length)return!1;for(const w of b)if(!d.has(w)||!v(c[w],m[w]))return!1;return!0}return!1}function s($){return JSON.stringify(p($))}let S=0;const y=new WeakMap;function p($){if(Array.isArray($))return $.map(p);if($&&typeof $=="object")if(Object.getPrototypeOf($)===Object.prototype){const a=$,c=Object.create(null);for(const m of Object.keys(a).sort())c[m]=p(a[m]);return c}else{let a=y.get($);return a===void 0&&(a=S++,y.set($,a)),a+"----2b76a038c20c4bcc"}return $}}),define(Oe[80],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hb=t;function t(i,E){const I=this;let D=!1,T;return function(){if(D)return T;if(D=!0,E)try{T=i.apply(I,arguments)}finally{E()}else T=i.apply(I,arguments);return T}}}),define(Oe[39],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var t;(function(i){function E(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}i.is=E;const I=Object.freeze([]);function D(){return I}i.empty=D;function*T(n){yield n}i.single=T;function v(n){return E(n)?n:T(n)}i.wrap=v;function s(n){return n||I}i.from=s;function*S(n){for(let u=n.length-1;u>=0;u--)yield n[u]}i.reverse=S;function y(n){return!n||n[Symbol.iterator]().next().done===!0}i.isEmpty=y;function p(n){return n[Symbol.iterator]().next().value}i.first=p;function $(n,u){let r=0;for(const f of n)if(u(f,r++))return!0;return!1}i.some=$;function a(n,u){for(const r of n)if(u(r))return r}i.find=a;function*c(n,u){for(const r of n)u(r)&&(yield r)}i.filter=c;function*m(n,u){let r=0;for(const f of n)yield u(f,r++)}i.map=m;function*b(n,u){let r=0;for(const f of n)yield*u(f,r++)}i.flatMap=b;function*g(...n){for(const u of n)yield*u}i.concat=g;function d(n,u,r){let f=r;for(const h of n)f=u(f,h);return f}i.reduce=d;function*w(n,u,r=n.length){for(u<0&&(u+=n.length),r<0?r+=n.length:r>n.length&&(r=n.length);u<r;u++)yield n[u]}i.slice=w;function o(n,u=Number.POSITIVE_INFINITY){const r=[];if(u===0)return[r,n];const f=n[Symbol.iterator]();for(let h=0;h<u;h++){const k=f.next();if(k.done)return[r,i.empty()];r.push(k.value)}return[r,{[Symbol.iterator](){return f}}]}i.consume=o;async function l(n){const u=[];for await(const r of n)u.push(r);return Promise.resolve(u)}i.asyncToArray=l})(t||(e.Iterable=t={}))}),define(Oe[42],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$5n=D,e.$6n=y,e.$7n=p,e.$8n=$,e.$9n=a,e.$0n=c,e.$$n=m,e.$_n=b,e.$ao=g,e.$bo=d,e.$co=w;var t;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(t||(e.ScanError=t={}));var i;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(i||(e.SyntaxKind=i={}));var E;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(E||(e.ParseErrorCode=E={}));var I;(function(o){o.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function D(o,l=!1){let n=0;const u=o.length;let r="",f=0,h=i.Unknown,k=t.None;function P(J){let x=0,ve=0;for(;x<J;){const be=o.charCodeAt(n);if(be>=S._0&&be<=S._9)ve=ve*16+be-S._0;else if(be>=S.A&&be<=S.F)ve=ve*16+be-S.A+10;else if(be>=S.a&&be<=S.f)ve=ve*16+be-S.a+10;else break;n++,x++}return x<J&&(ve=-1),ve}function O(J){n=J,r="",f=0,h=i.Unknown,k=t.None}function C(){const J=n;if(o.charCodeAt(n)===S._0)n++;else for(n++;n<o.length&&s(o.charCodeAt(n));)n++;if(n<o.length&&o.charCodeAt(n)===S.dot)if(n++,n<o.length&&s(o.charCodeAt(n)))for(n++;n<o.length&&s(o.charCodeAt(n));)n++;else return k=t.UnexpectedEndOfNumber,o.substring(J,n);let x=n;if(n<o.length&&(o.charCodeAt(n)===S.E||o.charCodeAt(n)===S.e))if(n++,(n<o.length&&o.charCodeAt(n)===S.plus||o.charCodeAt(n)===S.minus)&&n++,n<o.length&&s(o.charCodeAt(n))){for(n++;n<o.length&&s(o.charCodeAt(n));)n++;x=n}else k=t.UnexpectedEndOfNumber;return o.substring(J,x)}function L(){let J="",x=n;for(;;){if(n>=u){J+=o.substring(x,n),k=t.UnexpectedEndOfString;break}const ve=o.charCodeAt(n);if(ve===S.doubleQuote){J+=o.substring(x,n),n++;break}if(ve===S.backslash){if(J+=o.substring(x,n),n++,n>=u){k=t.UnexpectedEndOfString;break}switch(o.charCodeAt(n++)){case S.doubleQuote:J+='"';break;case S.backslash:J+="\\";break;case S.slash:J+="/";break;case S.b:J+="\b";break;case S.f:J+="\f";break;case S.n:J+=`
`;break;case S.r:J+="\r";break;case S.t:J+="	";break;case S.u:{const se=P(4);se>=0?J+=String.fromCharCode(se):k=t.InvalidUnicode;break}default:k=t.InvalidEscapeCharacter}x=n;continue}if(ve>=0&&ve<=31)if(v(ve)){J+=o.substring(x,n),k=t.UnexpectedEndOfString;break}else k=t.InvalidCharacter;n++}return J}function R(){if(r="",k=t.None,f=n,n>=u)return f=u,h=i.EOF;let J=o.charCodeAt(n);if(T(J)){do n++,r+=String.fromCharCode(J),J=o.charCodeAt(n);while(T(J));return h=i.Trivia}if(v(J))return n++,r+=String.fromCharCode(J),J===S.carriageReturn&&o.charCodeAt(n)===S.lineFeed&&(n++,r+=`
`),h=i.LineBreakTrivia;switch(J){case S.openBrace:return n++,h=i.OpenBraceToken;case S.closeBrace:return n++,h=i.CloseBraceToken;case S.openBracket:return n++,h=i.OpenBracketToken;case S.closeBracket:return n++,h=i.CloseBracketToken;case S.colon:return n++,h=i.ColonToken;case S.comma:return n++,h=i.CommaToken;case S.doubleQuote:return n++,r=L(),h=i.StringLiteral;case S.slash:{const x=n-1;if(o.charCodeAt(n+1)===S.slash){for(n+=2;n<u&&!v(o.charCodeAt(n));)n++;return r=o.substring(x,n),h=i.LineCommentTrivia}if(o.charCodeAt(n+1)===S.asterisk){n+=2;const ve=u-1;let be=!1;for(;n<ve;){if(o.charCodeAt(n)===S.asterisk&&o.charCodeAt(n+1)===S.slash){n+=2,be=!0;break}n++}return be||(n++,k=t.UnexpectedEndOfComment),r=o.substring(x,n),h=i.BlockCommentTrivia}return r+=String.fromCharCode(J),n++,h=i.Unknown}case S.minus:if(r+=String.fromCharCode(J),n++,n===u||!s(o.charCodeAt(n)))return h=i.Unknown;case S._0:case S._1:case S._2:case S._3:case S._4:case S._5:case S._6:case S._7:case S._8:case S._9:return r+=C(),h=i.NumericLiteral;default:for(;n<u&&z(J);)n++,J=o.charCodeAt(n);if(f!==n){switch(r=o.substring(f,n),r){case"true":return h=i.TrueKeyword;case"false":return h=i.FalseKeyword;case"null":return h=i.NullKeyword}return h=i.Unknown}return r+=String.fromCharCode(J),n++,h=i.Unknown}}function z(J){if(T(J)||v(J))return!1;switch(J){case S.closeBrace:case S.closeBracket:case S.openBrace:case S.openBracket:case S.doubleQuote:case S.colon:case S.comma:case S.slash:return!1}return!0}function Q(){let J;do J=R();while(J>=i.LineCommentTrivia&&J<=i.Trivia);return J}return{setPosition:O,getPosition:()=>n,scan:l?Q:R,getToken:()=>h,getTokenValue:()=>r,getTokenOffset:()=>f,getTokenLength:()=>n-f,getTokenError:()=>k}}function T(o){return o===S.space||o===S.tab||o===S.verticalTab||o===S.formFeed||o===S.nonBreakingSpace||o===S.ogham||o>=S.enQuad&&o<=S.zeroWidthSpace||o===S.narrowNoBreakSpace||o===S.mathematicalSpace||o===S.ideographicSpace||o===S.byteOrderMark}function v(o){return o===S.lineFeed||o===S.carriageReturn||o===S.lineSeparator||o===S.paragraphSeparator}function s(o){return o>=S._0&&o<=S._9}var S;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(S||(S={}));function y(o,l){const n=[],u=new Object;let r;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function k(P,O,C,L){f.value=P,f.offset=O,f.length=C,f.type=L,f.colonOffset=void 0,r=f}try{d(o,{onObjectBegin:(P,O)=>{if(l<=P)throw u;r=void 0,h=l>P,n.push("")},onObjectProperty:(P,O,C)=>{if(l<O||(k(P,O,C,"property"),n[n.length-1]=P,l<=O+C))throw u},onObjectEnd:(P,O)=>{if(l<=P)throw u;r=void 0,n.pop()},onArrayBegin:(P,O)=>{if(l<=P)throw u;r=void 0,n.push(0)},onArrayEnd:(P,O)=>{if(l<=P)throw u;r=void 0,n.pop()},onLiteralValue:(P,O,C)=>{if(l<O||(k(P,O,C,w(P)),l<=O+C))throw u},onSeparator:(P,O,C)=>{if(l<=O)throw u;if(P===":"&&r&&r.type==="property")r.colonOffset=O,h=!1,r=void 0;else if(P===","){const L=n[n.length-1];typeof L=="number"?n[n.length-1]=L+1:(h=!0,n[n.length-1]=""),r=void 0}}})}catch(P){if(P!==u)throw P}return{path:n,previousNode:r,isAtPropertyKey:h,matches:P=>{let O=0;for(let C=0;O<P.length&&C<n.length;C++)if(P[O]===n[C]||P[O]==="*")O++;else if(P[O]!=="**")return!1;return O===P.length}}}function p(o,l=[],n=I.DEFAULT){let u=null,r=[];const f=[];function h(P){Array.isArray(r)?r.push(P):u!==null&&(r[u]=P)}return d(o,{onObjectBegin:()=>{const P={};h(P),f.push(r),r=P,u=null},onObjectProperty:P=>{u=P},onObjectEnd:()=>{r=f.pop()},onArrayBegin:()=>{const P=[];h(P),f.push(r),r=P,u=null},onArrayEnd:()=>{r=f.pop()},onLiteralValue:h,onError:(P,O,C)=>{l.push({error:P,offset:O,length:C})}},n),r[0]}function $(o,l=[],n=I.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(P){u.type==="property"&&(u.length=P-u.offset,u=u.parent)}function f(P){return u.children.push(P),P}d(o,{onObjectBegin:P=>{u=f({type:"object",offset:P,length:-1,parent:u,children:[]})},onObjectProperty:(P,O,C)=>{u=f({type:"property",offset:O,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:P,offset:O,length:C,parent:u})},onObjectEnd:(P,O)=>{u.length=P+O-u.offset,u=u.parent,r(P+O)},onArrayBegin:(P,O)=>{u=f({type:"array",offset:P,length:-1,parent:u,children:[]})},onArrayEnd:(P,O)=>{u.length=P+O-u.offset,u=u.parent,r(P+O)},onLiteralValue:(P,O,C)=>{f({type:w(P),offset:O,length:C,parent:u,value:P}),r(O+C)},onSeparator:(P,O,C)=>{u.type==="property"&&(P===":"?u.colonOffset=O:P===","&&r(O))},onError:(P,O,C)=>{l.push({error:P,offset:O,length:C})}},n);const k=u.children[0];return k&&delete k.parent,k}function a(o,l){if(!o)return;let n=o;for(const u of l)if(typeof u=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const f of n.children)if(Array.isArray(f.children)&&f.children[0].value===u){n=f.children[1],r=!0;break}if(!r)return}else{const r=u;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}function c(o){if(!o.parent||!o.parent.children)return[];const l=c(o.parent);if(o.parent.type==="property"){const n=o.parent.children[0].value;l.push(n)}else if(o.parent.type==="array"){const n=o.parent.children.indexOf(o);n!==-1&&l.push(n)}return l}function m(o){switch(o.type){case"array":return o.children.map(m);case"object":{const l=Object.create(null);for(const n of o.children){const u=n.children[1];u&&(l[n.children[0].value]=m(u))}return l}case"null":case"string":case"number":case"boolean":return o.value;default:return}}function b(o,l,n=!1){return l>=o.offset&&l<o.offset+o.length||n&&l===o.offset+o.length}function g(o,l,n=!1){if(b(o,l,n)){const u=o.children;if(Array.isArray(u))for(let r=0;r<u.length&&u[r].offset<=l;r++){const f=g(u[r],l,n);if(f)return f}return o}}function d(o,l,n=I.DEFAULT){const u=D(o,!1);function r(le){return le?()=>le(u.getTokenOffset(),u.getTokenLength()):()=>!0}function f(le){return le?ye=>le(ye,u.getTokenOffset(),u.getTokenLength()):()=>!0}const h=r(l.onObjectBegin),k=f(l.onObjectProperty),P=r(l.onObjectEnd),O=r(l.onArrayBegin),C=r(l.onArrayEnd),L=f(l.onLiteralValue),R=f(l.onSeparator),z=r(l.onComment),Q=f(l.onError),J=n&&n.disallowComments,x=n&&n.allowTrailingComma;function ve(){for(;;){const le=u.scan();switch(u.getTokenError()){case t.InvalidUnicode:be(E.InvalidUnicode);break;case t.InvalidEscapeCharacter:be(E.InvalidEscapeCharacter);break;case t.UnexpectedEndOfNumber:be(E.UnexpectedEndOfNumber);break;case t.UnexpectedEndOfComment:J||be(E.UnexpectedEndOfComment);break;case t.UnexpectedEndOfString:be(E.UnexpectedEndOfString);break;case t.InvalidCharacter:be(E.InvalidCharacter);break}switch(le){case i.LineCommentTrivia:case i.BlockCommentTrivia:J?be(E.InvalidCommentToken):z();break;case i.Unknown:be(E.InvalidSymbol);break;case i.Trivia:case i.LineBreakTrivia:break;default:return le}}}function be(le,ye=[],oe=[]){if(Q(le),ye.length+oe.length>0){let _=u.getToken();for(;_!==i.EOF;){if(ye.indexOf(_)!==-1){ve();break}else if(oe.indexOf(_)!==-1)break;_=ve()}}}function se(le){const ye=u.getTokenValue();return le?L(ye):k(ye),ve(),!0}function V(){switch(u.getToken()){case i.NumericLiteral:{let le=0;try{le=JSON.parse(u.getTokenValue()),typeof le!="number"&&(be(E.InvalidNumberFormat),le=0)}catch{be(E.InvalidNumberFormat)}L(le);break}case i.NullKeyword:L(null);break;case i.TrueKeyword:L(!0);break;case i.FalseKeyword:L(!1);break;default:return!1}return ve(),!0}function B(){return u.getToken()!==i.StringLiteral?(be(E.PropertyNameExpected,[],[i.CloseBraceToken,i.CommaToken]),!1):(se(!1),u.getToken()===i.ColonToken?(R(":"),ve(),te()||be(E.ValueExpected,[],[i.CloseBraceToken,i.CommaToken])):be(E.ColonExpected,[],[i.CloseBraceToken,i.CommaToken]),!0)}function j(){h(),ve();let le=!1;for(;u.getToken()!==i.CloseBraceToken&&u.getToken()!==i.EOF;){if(u.getToken()===i.CommaToken){if(le||be(E.ValueExpected,[],[]),R(","),ve(),u.getToken()===i.CloseBraceToken&&x)break}else le&&be(E.CommaExpected,[],[]);B()||be(E.ValueExpected,[],[i.CloseBraceToken,i.CommaToken]),le=!0}return P(),u.getToken()!==i.CloseBraceToken?be(E.CloseBraceExpected,[i.CloseBraceToken],[]):ve(),!0}function U(){O(),ve();let le=!1;for(;u.getToken()!==i.CloseBracketToken&&u.getToken()!==i.EOF;){if(u.getToken()===i.CommaToken){if(le||be(E.ValueExpected,[],[]),R(","),ve(),u.getToken()===i.CloseBracketToken&&x)break}else le&&be(E.CommaExpected,[],[]);te()||be(E.ValueExpected,[],[i.CloseBracketToken,i.CommaToken]),le=!0}return C(),u.getToken()!==i.CloseBracketToken?be(E.CloseBracketExpected,[i.CloseBracketToken],[]):ve(),!0}function te(){switch(u.getToken()){case i.OpenBracketToken:return U();case i.OpenBraceToken:return j();case i.StringLiteral:return se(!0);default:return V()}}return ve(),u.getToken()===i.EOF?n.allowEmptyContent?!0:(be(E.ValueExpected,[],[]),!1):te()?(u.getToken()!==i.EOF&&be(E.EndOfFileExpected,[],[]),!0):(be(E.ValueExpected,[],[]),!1)}function w(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}}),define(Oe[161],Le([1,0,42]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=i,e.$eo=E,e.$fo=T,e.$go=v;function i(s,S,y){let p,$,a,c,m;if(S){for(c=S.offset,m=c+S.length,a=c;a>0&&!v(s,a-1);)a--;let k=m;for(;k<s.length&&!v(s,k);)k++;$=s.substring(a,k),p=D($,y)}else $=s,p=0,a=0,c=0,m=s.length;const b=T(y,s);let g=!1,d=0,w;y.insertSpaces?w=I(" ",y.tabSize||4):w="	";const o=(0,t.$5n)($,!1);let l=!1;function n(){return b+I(w,p+d)}function u(){let k=o.scan();for(g=!1;k===t.SyntaxKind.Trivia||k===t.SyntaxKind.LineBreakTrivia;)g=g||k===t.SyntaxKind.LineBreakTrivia,k=o.scan();return l=k===t.SyntaxKind.Unknown||o.getTokenError()!==t.ScanError.None,k}const r=[];function f(k,P,O){!l&&P<m&&O>c&&s.substring(P,O)!==k&&r.push({offset:P,length:O-P,content:k})}let h=u();if(h!==t.SyntaxKind.EOF){const k=o.getTokenOffset()+a,P=I(w,p);f(P,a,k)}for(;h!==t.SyntaxKind.EOF;){let k=o.getTokenOffset()+o.getTokenLength()+a,P=u(),O="";for(;!g&&(P===t.SyntaxKind.LineCommentTrivia||P===t.SyntaxKind.BlockCommentTrivia);){const L=o.getTokenOffset()+a;f(" ",k,L),k=o.getTokenOffset()+o.getTokenLength()+a,O=P===t.SyntaxKind.LineCommentTrivia?n():"",P=u()}if(P===t.SyntaxKind.CloseBraceToken)h!==t.SyntaxKind.OpenBraceToken&&(d--,O=n());else if(P===t.SyntaxKind.CloseBracketToken)h!==t.SyntaxKind.OpenBracketToken&&(d--,O=n());else{switch(h){case t.SyntaxKind.OpenBracketToken:case t.SyntaxKind.OpenBraceToken:d++,O=n();break;case t.SyntaxKind.CommaToken:case t.SyntaxKind.LineCommentTrivia:O=n();break;case t.SyntaxKind.BlockCommentTrivia:g?O=n():O=" ";break;case t.SyntaxKind.ColonToken:O=" ";break;case t.SyntaxKind.StringLiteral:if(P===t.SyntaxKind.ColonToken){O="";break}case t.SyntaxKind.NullKeyword:case t.SyntaxKind.TrueKeyword:case t.SyntaxKind.FalseKeyword:case t.SyntaxKind.NumericLiteral:case t.SyntaxKind.CloseBraceToken:case t.SyntaxKind.CloseBracketToken:P===t.SyntaxKind.LineCommentTrivia||P===t.SyntaxKind.BlockCommentTrivia?O=" ":P!==t.SyntaxKind.CommaToken&&P!==t.SyntaxKind.EOF&&(l=!0);break;case t.SyntaxKind.Unknown:l=!0;break}g&&(P===t.SyntaxKind.LineCommentTrivia||P===t.SyntaxKind.BlockCommentTrivia)&&(O=n())}const C=o.getTokenOffset()+a;f(O,k,C),h=P}return r}function E(s,S){const y=JSON.stringify(s,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?y.replace(/\r\n|\r|\n/g,S.eol):y}function I(s,S){let y="";for(let p=0;p<S;p++)y+=s;return y}function D(s,S){let y=0,p=0;const $=S.tabSize||4;for(;y<s.length;){const a=s.charAt(y);if(a===" ")p++;else if(a==="	")p+=$;else break;y++}return Math.floor(p/$)}function T(s,S){for(let y=0;y<S.length;y++){const p=S.charAt(y);if(p==="\r")return y+1<S.length&&S.charAt(y+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return s&&s.eol||`
`}function v(s,S){return`\r
`.indexOf(s.charAt(S))!==-1}}),define(Oe[162],Le([1,0,42,161]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=E,e.$io=I,e.$jo=D,e.$ko=T,e.$lo=v;function E(s,S,y){return I(s,S,void 0,y)}function I(s,S,y,p,$){const a=S.slice(),c=[],m=(0,t.$8n)(s,c);let b,g;for(;a.length>0&&(g=a.pop(),b=(0,t.$9n)(m,a),b===void 0&&y!==void 0);)typeof g=="string"?y={[g]:y}:y=[y];if(b)if(b.type==="object"&&typeof g=="string"&&Array.isArray(b.children)){const d=(0,t.$9n)(b,[g]);if(d!==void 0)if(y===void 0){if(!d.parent)throw new Error("Malformed AST");const w=b.children.indexOf(d.parent);let o,l=d.parent.offset+d.parent.length;if(w>0){const n=b.children[w-1];o=n.offset+n.length}else o=b.offset+1,b.children.length>1&&(l=b.children[1].offset);return D(s,{offset:o,length:l-o,content:""},p)}else return D(s,{offset:d.offset,length:d.length,content:JSON.stringify(y)},p);else{if(y===void 0)return[];const w=`${JSON.stringify(g)}: ${JSON.stringify(y)}`,o=$?$(b.children.map(n=>n.children[0].value)):b.children.length;let l;if(o>0){const n=b.children[o-1];l={offset:n.offset+n.length,length:0,content:","+w}}else b.children.length===0?l={offset:b.offset+1,length:0,content:w}:l={offset:b.offset+1,length:0,content:w+","};return D(s,l,p)}}else if(b.type==="array"&&typeof g=="number"&&Array.isArray(b.children))if(y!==void 0){const d=`${JSON.stringify(y)}`;let w;if(b.children.length===0||g===0)w={offset:b.offset+1,length:0,content:b.children.length===0?d:d+","};else{const o=g===-1||g>b.children.length?b.children.length:g,l=b.children[o-1];w={offset:l.offset+l.length,length:0,content:","+d}}return D(s,w,p)}else{const d=g,w=b.children[d];let o;if(b.children.length===1)o={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===d){const l=b.children[d-1],n=l.offset+l.length,u=b.offset+b.length;o={offset:n,length:u-2-n,content:""}}else o={offset:w.offset,length:b.children[d+1].offset-w.offset,content:""};return D(s,o,p)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${b.type}`);else return y===void 0?[]:D(s,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(y)},p)}function D(s,S,y){let p=T(s,S),$=S.offset,a=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;$>0&&!(0,i.$go)(p,$-1);)$--;for(;a<p.length&&!(0,i.$go)(p,a);)a++}const c=(0,i.$do)(p,{offset:$,length:a-$},y);for(let b=c.length-1;b>=0;b--){const g=c[b];p=T(p,g),$=Math.min($,g.offset),a=Math.max(a,g.offset+g.length),a+=g.content.length-g.length}const m=s.length-(p.length-a)-$;return[{offset:$,length:m,content:p.substring($,a)}]}function T(s,S){return s.substring(0,S.offset)+S.content+s.substring(S.offset+S.length)}function v(s,S){const y=S.slice(0).sort(($,a)=>{const c=$.offset-a.offset;return c===0?$.length-a.length:c});let p=s.length;for(let $=y.length-1;$>=0;$--){const a=y[$];if(a.offset+a.length<=p)s=T(s,a);else throw new Error("Overlapping edit");p=a.offset}return s}}),define(Oe[163],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=t;function t(I){let D=!1;const T=new Map,v=new Map;if(E(I,c=>{if(I===c)return!0;const m=JSON.stringify(c);if(m.length<30)return!0;const b=T.get(m);if(!b){const g={schemas:[c]};return T.set(m,g),v.set(c,g),!0}return b.schemas.push(c),v.set(c,b),D=!0,!1}),T.clear(),!D)return JSON.stringify(I);let S="$defs";for(;I.hasOwnProperty(S);)S+="_";const y=[];function p(c){return JSON.stringify(c,(m,b)=>{if(b!==c){const g=v.get(b);if(g&&g.schemas.length>1)return g.id||(g.id=`_${y.length}`,y.push(g.schemas[0])),{$ref:`#/${S}/${g.id}`}}return b})}const $=p(I),a=[];for(let c=0;c<y.length;c++)a.push(`"_${c}":${p(y[c])}`);return a.length?`${$.substring(0,$.length-1)},"${S}":{${a.join(",")}}}`:$}function i(I){return typeof I=="object"&&I!==null}function E(I,D){if(!I||typeof I!="object")return;const T=(...$)=>{for(const a of $)i(a)&&y.push(a)},v=(...$)=>{for(const a of $)if(i(a))for(const c in a){const m=a[c];i(m)&&y.push(m)}},s=(...$)=>{for(const a of $)if(Array.isArray(a))for(const c of a)i(c)&&y.push(c)},S=$=>{if(Array.isArray($))for(const a of $)i(a)&&y.push(a);else i($)&&y.push($)},y=[I];let p=y.pop();for(;p;)D(p)&&(T(p.additionalItems,p.additionalProperties,p.not,p.contains,p.propertyNames,p.if,p.then,p.else,p.unevaluatedItems,p.unevaluatedProperties),v(p.definitions,p.$defs,p.properties,p.patternProperties,p.dependencies,p.dependentSchemas),s(p.anyOf,p.allOf,p.oneOf,p.prefixItems),S(p.items)),p=y.pop()}}),define(Oe[66],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y=void 0;class t{constructor(E){this.d=E,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$Y=t}),define(Oe[81],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=void 0;class t{static{this.Undefined=new t(void 0)}constructor(I){this.element=I,this.next=t.Undefined,this.prev=t.Undefined}}class i{constructor(){this.a=t.Undefined,this.b=t.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===t.Undefined}clear(){let I=this.a;for(;I!==t.Undefined;){const D=I.next;I.prev=t.Undefined,I.next=t.Undefined,I=D}this.a=t.Undefined,this.b=t.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,D){const T=new t(I);if(this.a===t.Undefined)this.a=T,this.b=T;else if(D){const s=this.b;this.b=T,T.prev=s,s.next=T}else{const s=this.a;this.a=T,T.next=s,s.prev=T}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(T))}}shift(){if(this.a!==t.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==t.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==t.Undefined&&I.next!==t.Undefined){const D=I.prev;D.next=I.next,I.next.prev=D}else I.prev===t.Undefined&&I.next===t.Undefined?(this.a=t.Undefined,this.b=t.Undefined):I.next===t.Undefined?(this.b=this.b.prev,this.b.next=t.Undefined):I.prev===t.Undefined&&(this.a=this.a.next,this.a.prev=t.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==t.Undefined;)yield I.element,I=I.next}}e.$0c=i}),define(Oe[25],Le([1,0]),function(ue,e){"use strict";var t,i,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.Touch=e.$Gc=e.$Fc=void 0,e.$Cc=I,e.$Dc=D,e.$Ec=T,e.$Nc=w;function I(o,l,n){let u=o.get(l);return u===void 0&&(u=n,o.set(l,u)),u}function D(o){const l=[];return o.forEach((n,u)=>{l.push(`${u} => ${n}`)}),`Map(${o.size}) {${l.join(", ")}}`}function T(o){const l=[];return o.forEach(n=>{l.push(n)}),`Set(${o.size}) {${l.join(", ")}}`}class v{constructor(l,n){this.uri=l,this.value=n}}function s(o){return Array.isArray(o)}class S{static{this.c=l=>l.toString()}constructor(l,n){if(this[t]="ResourceMap",l instanceof S)this.d=new Map(l.d),this.e=n??S.c;else if(s(l)){this.d=new Map,this.e=n??S.c;for(const[u,r]of l)this.set(u,r)}else this.d=new Map,this.e=l??S.c}set(l,n){return this.d.set(this.e(l),new v(l,n)),this}get(l){return this.d.get(this.e(l))?.value}has(l){return this.d.has(this.e(l))}get size(){return this.d.size}clear(){this.d.clear()}delete(l){return this.d.delete(this.e(l))}forEach(l,n){typeof n<"u"&&(l=l.bind(n));for(const[u,r]of this.d)l(r.value,r.uri,this)}*values(){for(const l of this.d.values())yield l.value}*keys(){for(const l of this.d.values())yield l.uri}*entries(){for(const l of this.d.values())yield[l.uri,l.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.d)yield[l.uri,l.value]}}e.$Fc=S;class y{constructor(l,n){this[i]="ResourceSet",!l||typeof l=="function"?this.c=new S(l):(this.c=new S(n),l.forEach(this.add,this))}get size(){return this.c.size}add(l){return this.c.set(l,l),this}clear(){this.c.clear()}delete(l){return this.c.delete(l)}forEach(l,n){this.c.forEach((u,r)=>l.call(n,r,r,this))}has(l){return this.c.has(l)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Gc=y;var p;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class ${constructor(){this[E]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(l){return this.c.has(l)}get(l,n=p.None){const u=this.c.get(l);if(u)return n!==p.None&&this.m(u,n),u.value}set(l,n,u=p.None){let r=this.c.get(l);if(r)r.value=n,u!==p.None&&this.m(r,u);else{switch(r={key:l,value:n,next:void 0,previous:void 0},u){case p.None:this.k(r);break;case p.AsOld:this.j(r);break;case p.AsNew:this.k(r);break;default:this.k(r);break}this.c.set(l,r),this.f++}return this}delete(l){return!!this.remove(l)}remove(l){const n=this.c.get(l);if(n)return this.c.delete(l),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const l=this.d;return this.c.delete(l.key),this.l(l),this.f--,l.value}forEach(l,n){const u=this.g;let r=this.d;for(;r;){if(n?l.bind(n)(r.value,r.key,this):l(r.value,r.key,this),this.g!==u)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const l=this,n=this.g;let u=this.d;const r={[Symbol.iterator](){return r},next(){if(l.g!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.key,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return r}values(){const l=this,n=this.g;let u=this.d;const r={[Symbol.iterator](){return r},next(){if(l.g!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.value,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return r}entries(){const l=this,n=this.g;let u=this.d;const r={[Symbol.iterator](){return r},next(){if(l.g!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:[u.key,u.value],done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return r}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(l){if(l>=this.size)return;if(l===0){this.clear();return}let n=this.d,u=this.size;for(;n&&u>l;)this.c.delete(n.key),n=n.next,u--;this.d=n,this.f=u,n&&(n.previous=void 0),this.g++}i(l){if(l>=this.size)return;if(l===0){this.clear();return}let n=this.e,u=this.size;for(;n&&u>l;)this.c.delete(n.key),n=n.previous,u--;this.e=n,this.f=u,n&&(n.next=void 0),this.g++}j(l){if(!this.d&&!this.e)this.e=l;else if(this.d)l.next=this.d,this.d.previous=l;else throw new Error("Invalid list");this.d=l,this.g++}k(l){if(!this.d&&!this.e)this.d=l;else if(this.e)l.previous=this.e,this.e.next=l;else throw new Error("Invalid list");this.e=l,this.g++}l(l){if(l===this.d&&l===this.e)this.d=void 0,this.e=void 0;else if(l===this.d){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.d=l.next}else if(l===this.e){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.e=l.previous}else{const n=l.next,u=l.previous;if(!n||!u)throw new Error("Invalid list");n.previous=u,u.next=n}l.next=void 0,l.previous=void 0,this.g++}m(l,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==p.AsOld&&n!==p.AsNew)){if(n===p.AsOld){if(l===this.d)return;const u=l.next,r=l.previous;l===this.e?(r.next=void 0,this.e=r):(u.previous=r,r.next=u),l.previous=void 0,l.next=this.d,this.d.previous=l,this.d=l,this.g++}else if(n===p.AsNew){if(l===this.e)return;const u=l.next,r=l.previous;l===this.d?(u.previous=void 0,this.d=u):(u.previous=r,r.next=u),l.next=void 0,l.previous=this.e,this.e.next=l,this.e=l,this.g++}}}toJSON(){const l=[];return this.forEach((n,u)=>{l.push([u,n])}),l}fromJSON(l){this.clear();for(const[n,u]of l)this.set(n,u)}}e.$Hc=$;class a extends ${constructor(l,n=1){super(),this.n=l,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(l){this.n=l,this.p()}get ratio(){return this.o}set ratio(l){this.o=Math.min(Math.max(0,l),1),this.p()}get(l,n=p.AsNew){return super.get(l,n)}peek(l){return super.get(l,p.None)}set(l,n){return super.set(l,n,p.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class c extends a{constructor(l,n=1){super(l,n)}q(l){this.h(l)}set(l,n){return super.set(l,n),this.p(),this}}e.$Ic=c;class m extends a{constructor(l,n=1){super(l,n)}q(l){this.i(l)}set(l,n){return this.n<=this.size&&!this.has(l)&&this.q(Math.round(this.n*this.o)-1),super.set(l,n),this}}e.$Jc=m;class b{constructor(){this.c=new Map}add(l){return this.c.set(l,(this.c.get(l)||0)+1),this}delete(l){let n=this.c.get(l)||0;return n===0?!1:(n--,n===0?this.c.delete(l):this.c.set(l,n),!0)}has(l){return this.c.has(l)}}e.$Kc=b;class g{constructor(l){if(this.c=new Map,this.d=new Map,l)for(const[n,u]of l)this.set(n,u)}clear(){this.c.clear(),this.d.clear()}set(l,n){this.c.set(l,n),this.d.set(n,l)}get(l){return this.c.get(l)}getKey(l){return this.d.get(l)}delete(l){const n=this.c.get(l);return n===void 0?!1:(this.c.delete(l),this.d.delete(n),!0)}forEach(l,n){this.c.forEach((u,r)=>{l.call(n,u,r,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Lc=g;class d{constructor(){this.c=new Map}add(l,n){let u=this.c.get(l);u||(u=new Set,this.c.set(l,u)),u.add(n)}delete(l,n){const u=this.c.get(l);u&&(u.delete(n),u.size===0&&this.c.delete(l))}forEach(l,n){const u=this.c.get(l);u&&u.forEach(n)}get(l){const n=this.c.get(l);return n||new Set}}e.$Mc=d;function w(o,l){if(o===l)return!0;if(o.size!==l.size)return!1;for(const[n,u]of o)if(!l.has(n)||l.get(n)!==u)return!1;for(const[n]of l)if(!o.has(n))return!1;return!0}}),define(Oe[2],Le([1,0,17,159,25,80,39]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Oc=void 0,e.$Pc=S,e.$Qc=y,e.$Rc=p,e.$Sc=c,e.$Tc=m,e.$Uc=b,e.$Vc=g,e.$Wc=d,e.$Xc=w,e.$8c=O;const T=!1;let v=null;class s{constructor(){this.b=new Map}static{this.a=0}c(R){let z=this.b.get(R);return z||(z={parent:null,source:null,isSingleton:!1,value:R,idx:s.a++},this.b.set(R,z)),z}trackDisposable(R){const z=this.c(R);z.source||(z.source=new Error().stack)}setParent(R,z){const Q=this.c(R);Q.parent=z}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,z){const Q=z.get(R);if(Q)return Q;const J=R.parent?this.f(this.c(R.parent),z):R;return z.set(R,J),J}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,Q])=>Q.source!==null&&!this.f(Q,R).isSingleton).flatMap(([Q])=>Q)}computeLeakingDisposables(R=10,z){let Q;if(z)Q=z;else{const se=new Map,V=[...this.b.values()].filter(j=>j.source!==null&&!this.f(j,se).isSingleton);if(V.length===0)return;const B=new Set(V.map(j=>j.value));if(Q=V.filter(j=>!(j.parent&&B.has(j.parent))),Q.length===0)throw new Error("There are cyclic diposable chains!")}if(!Q)return;function J(se){function V(j,U){for(;j.length>0&&U.some(te=>typeof te=="string"?te===j[0]:j[0].match(te));)j.shift()}const B=se.source.split(`
`).map(j=>j.trim().replace("at ","")).filter(j=>j!=="");return V(B,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),B.reverse()}const x=new E.$Mc;for(const se of Q){const V=J(se);for(let B=0;B<=V.length;B++)x.add(V.slice(0,B).join(`
`),se)}Q.sort((0,t.$0b)(se=>se.idx,t.$_b));let ve="",be=0;for(const se of Q.slice(0,R)){be++;const V=J(se),B=[];for(let j=0;j<V.length;j++){let U=V[j];U=`(shared with ${x.get(V.slice(0,j+1).join(`
`)).size}/${Q.length} leaks) at ${U}`;const le=x.get(V.slice(0,j).join(`
`)),ye=(0,i.$e)([...le].map(oe=>J(oe)[j]),oe=>oe);delete ye[V[j]];for(const[oe,_]of Object.entries(ye))B.unshift(`    - stacktraces of ${_.length} other leaks continue with ${oe}`);B.unshift(U)}ve+=`


==================== Leaking disposable ${be}/${Q.length}: ${se.value.constructor.name} ====================
${B.join(`
`)}
============================================================

`}return Q.length>R&&(ve+=`


... and ${Q.length-R} more leaking disposables

`),{leaks:Q,details:ve}}}e.$Oc=s;function S(L){v=L}if(T){const L="__is_disposable_tracked__";S(new class{trackDisposable(R){const z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[L]||console.log(z)},3e3)}setParent(R,z){if(R&&R!==l.None)try{R[L]=!0}catch{}}markAsDisposed(R){if(R&&R!==l.None)try{R[L]=!0}catch{}}markAsSingleton(R){}})}function y(L){return v?.trackDisposable(L),L}function p(L){v?.markAsDisposed(L)}function $(L,R){v?.setParent(L,R)}function a(L,R){if(v)for(const z of L)v.setParent(z,R)}function c(L){return v?.markAsSingleton(L),L}function m(L){return typeof L=="object"&&L!==null&&typeof L.dispose=="function"&&L.dispose.length===0}function b(L){if(D.Iterable.is(L)){const R=[];for(const z of L)if(z)try{z.dispose()}catch(Q){R.push(Q)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}function g(L){for(const R of L)m(R)&&R.dispose();return[]}function d(...L){const R=w(()=>b(L));return a(L,R),R}function w(L){const R=y({dispose:(0,I.$hb)(()=>{p(R),L()})});return R}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return $(R,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(R),R.dispose()}}deleteAndLeak(R){R&&this.f.has(R)&&(this.f.delete(R),$(R,null))}}e.$Yc=o;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,y(this),$(this.q,this)}dispose(){p(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}e.$Zc=l;class n{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&$(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&$(R,null),R}}e.$1c=n;class u{constructor(R){this.a=new n,this.b=!1,this.a.value=R}get value(){return this.a.value}set value(R){this.b||R===this.a.value||(this.a.value=R)}dispose(){this.b=!0,this.a.dispose()}}e.$2c=u;class r{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$3c=r;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(R){let z=R;return this.unset=()=>z=void 0,this.isset=()=>z!==void 0,this.dispose=()=>{z&&(z(),z=void 0,p(this))},this}}e.$4c=f;class h{constructor(){this.a=new Map}acquire(R,...z){let Q=this.a.get(R);Q||(Q={counter:0,object:this.b(R,...z)},this.a.set(R,Q));const{object:J}=Q,x=(0,I.$hb)(()=>{--Q.counter===0&&(this.c(R,Q.object),this.a.delete(R))});return Q.counter++,{object:J,dispose:x}}}e.$5c=h;class k{constructor(R){this.a=R}async acquire(R,...z){const Q=this.a.acquire(R,...z);try{return{object:await Q.object,dispose:()=>Q.dispose()}}catch(J){throw Q.dispose(),J}}}e.$6c=k;class P{constructor(R){this.object=R}dispose(){}}e.$7c=P;function O(L){const R=new o;try{L(R)}finally{R.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,z,Q=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Q||this.a.get(R)?.dispose(),this.a.set(R,z)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}deleteAndLeak(R){const z=this.a.get(R);return this.a.delete(R),z}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$9c=C}),function(ue,e){typeof define=="function"&&define.amd?define(Oe[164],Le([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ue=typeof globalThis<"u"?globalThis:ue||self,e(ue.marked={}))}(this,function(ue){"use strict";function e(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}ue.defaults=e();function t(Ye){ue.defaults=Ye}const i=/[&<>"']/,E=new RegExp(i.source,"g"),I=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,D=new RegExp(I.source,"g"),T={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=Ye=>T[Ye];function s(Ye,me){if(me){if(i.test(Ye))return Ye.replace(E,v)}else if(I.test(Ye))return Ye.replace(D,v);return Ye}const S=/(^|[^\[])\^/g;function y(Ye,me){let H=typeof Ye=="string"?Ye:Ye.source;me=me||"";const ee={replace:(ge,re)=>{let fe=typeof re=="string"?re:re.source;return fe=fe.replace(S,"$1"),H=H.replace(ge,fe),ee},getRegex:()=>new RegExp(H,me)};return ee}function p(Ye){try{Ye=encodeURI(Ye).replace(/%25/g,"%")}catch{return null}return Ye}const $={exec:()=>null};function a(Ye,me){const H=Ye.replace(/\|/g,(re,fe,W)=>{let K=!1,$e=fe;for(;--$e>=0&&W[$e]==="\\";)K=!K;return K?"|":" |"}),ee=H.split(/ \|/);let ge=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),me)if(ee.length>me)ee.splice(me);else for(;ee.length<me;)ee.push("");for(;ge<ee.length;ge++)ee[ge]=ee[ge].trim().replace(/\\\|/g,"|");return ee}function c(Ye,me,H){const ee=Ye.length;if(ee===0)return"";let ge=0;for(;ge<ee;){const re=Ye.charAt(ee-ge-1);if(re===me&&!H)ge++;else if(re!==me&&H)ge++;else break}return Ye.slice(0,ee-ge)}function m(Ye,me){if(Ye.indexOf(me[1])===-1)return-1;let H=0;for(let ee=0;ee<Ye.length;ee++)if(Ye[ee]==="\\")ee++;else if(Ye[ee]===me[0])H++;else if(Ye[ee]===me[1]&&(H--,H<0))return ee;return-1}function b(Ye,me,H,ee){const ge=me.href,re=me.title?s(me.title):null,fe=Ye[1].replace(/\\([\[\]])/g,"$1");if(Ye[0].charAt(0)!=="!"){ee.state.inLink=!0;const W={type:"link",raw:H,href:ge,title:re,text:fe,tokens:ee.inlineTokens(fe)};return ee.state.inLink=!1,W}return{type:"image",raw:H,href:ge,title:re,text:s(fe)}}function g(Ye,me){const H=Ye.match(/^(\s+)(?:```)/);if(H===null)return me;const ee=H[1];return me.split(`
`).map(ge=>{const re=ge.match(/^\s+/);if(re===null)return ge;const[fe]=re;return fe.length>=ee.length?ge.slice(ee.length):ge}).join(`
`)}class d{options;rules;lexer;constructor(me){this.options=me||ue.defaults}space(me){const H=this.rules.block.newline.exec(me);if(H&&H[0].length>0)return{type:"space",raw:H[0]}}code(me){const H=this.rules.block.code.exec(me);if(H){const ee=H[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:H[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:c(ee,`
`)}}}fences(me){const H=this.rules.block.fences.exec(me);if(H){const ee=H[0],ge=g(ee,H[3]||"");return{type:"code",raw:ee,lang:H[2]?H[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):H[2],text:ge}}}heading(me){const H=this.rules.block.heading.exec(me);if(H){let ee=H[2].trim();if(/#$/.test(ee)){const ge=c(ee,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(ee=ge.trim())}return{type:"heading",raw:H[0],depth:H[1].length,text:ee,tokens:this.lexer.inline(ee)}}}hr(me){const H=this.rules.block.hr.exec(me);if(H)return{type:"hr",raw:c(H[0],`
`)}}blockquote(me){const H=this.rules.block.blockquote.exec(me);if(H){let ee=c(H[0],`
`).split(`
`),ge="",re="";const fe=[];for(;ee.length>0;){let W=!1;const K=[];let $e;for($e=0;$e<ee.length;$e++)if(/^ {0,3}>/.test(ee[$e]))K.push(ee[$e]),W=!0;else if(!W)K.push(ee[$e]);else break;ee=ee.slice($e);const Fe=K.join(`
`),qe=Fe.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");ge=ge?`${ge}
${Fe}`:Fe,re=re?`${re}
${qe}`:qe;const xe=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(qe,fe,!0),this.lexer.state.top=xe,ee.length===0)break;const et=fe[fe.length-1];if(et?.type==="code")break;if(et?.type==="blockquote"){const it=et,ct=it.raw+`
`+ee.join(`
`),mt=this.blockquote(ct);fe[fe.length-1]=mt,ge=ge.substring(0,ge.length-it.raw.length)+mt.raw,re=re.substring(0,re.length-it.text.length)+mt.text;break}else if(et?.type==="list"){const it=et,ct=it.raw+`
`+ee.join(`
`),mt=this.list(ct);fe[fe.length-1]=mt,ge=ge.substring(0,ge.length-et.raw.length)+mt.raw,re=re.substring(0,re.length-it.raw.length)+mt.raw,ee=ct.substring(fe[fe.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:ge,tokens:fe,text:re}}}list(me){let H=this.rules.block.list.exec(me);if(H){let ee=H[1].trim();const ge=ee.length>1,re={type:"list",raw:"",ordered:ge,start:ge?+ee.slice(0,-1):"",loose:!1,items:[]};ee=ge?`\\d{1,9}\\${ee.slice(-1)}`:`\\${ee}`,this.options.pedantic&&(ee=ge?ee:"[*+-]");const fe=new RegExp(`^( {0,3}${ee})((?:[	 ][^\\n]*)?(?:\\n|$))`);let W=!1;for(;me;){let K=!1,$e="",Fe="";if(!(H=fe.exec(me))||this.rules.block.hr.test(me))break;$e=H[0],me=me.substring($e.length);let qe=H[2].split(`
`,1)[0].replace(/^\t+/,vt=>" ".repeat(3*vt.length)),xe=me.split(`
`,1)[0],et=!qe.trim(),it=0;if(this.options.pedantic?(it=2,Fe=qe.trimStart()):et?it=H[1].length+1:(it=H[2].search(/[^ ]/),it=it>4?1:it,Fe=qe.slice(it),it+=H[1].length),et&&/^ *$/.test(xe)&&($e+=xe+`
`,me=me.substring(xe.length+1),K=!0),!K){const vt=new RegExp(`^ {0,${Math.min(3,it-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),Ct=new RegExp(`^ {0,${Math.min(3,it-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),gt=new RegExp(`^ {0,${Math.min(3,it-1)}}(?:\`\`\`|~~~)`),bt=new RegExp(`^ {0,${Math.min(3,it-1)}}#`);for(;me;){const pt=me.split(`
`,1)[0];if(xe=pt,this.options.pedantic&&(xe=xe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),gt.test(xe)||bt.test(xe)||vt.test(xe)||Ct.test(me))break;if(xe.search(/[^ ]/)>=it||!xe.trim())Fe+=`
`+xe.slice(it);else{if(et||qe.search(/[^ ]/)>=4||gt.test(qe)||bt.test(qe)||Ct.test(qe))break;Fe+=`
`+xe}!et&&!xe.trim()&&(et=!0),$e+=pt+`
`,me=me.substring(pt.length+1),qe=xe.slice(it)}}re.loose||(W?re.loose=!0:/\n *\n *$/.test($e)&&(W=!0));let ct=null,mt;this.options.gfm&&(ct=/^\[[ xX]\] /.exec(Fe),ct&&(mt=ct[0]!=="[ ] ",Fe=Fe.replace(/^\[[ xX]\] +/,""))),re.items.push({type:"list_item",raw:$e,task:!!ct,checked:mt,loose:!1,text:Fe,tokens:[]}),re.raw+=$e}re.items[re.items.length-1].raw=re.items[re.items.length-1].raw.trimEnd(),re.items[re.items.length-1].text=re.items[re.items.length-1].text.trimEnd(),re.raw=re.raw.trimEnd();for(let K=0;K<re.items.length;K++)if(this.lexer.state.top=!1,re.items[K].tokens=this.lexer.blockTokens(re.items[K].text,[]),!re.loose){const $e=re.items[K].tokens.filter(qe=>qe.type==="space"),Fe=$e.length>0&&$e.some(qe=>/\n.*\n/.test(qe.raw));re.loose=Fe}if(re.loose)for(let K=0;K<re.items.length;K++)re.items[K].loose=!0;return re}}html(me){const H=this.rules.block.html.exec(me);if(H)return{type:"html",block:!0,raw:H[0],pre:H[1]==="pre"||H[1]==="script"||H[1]==="style",text:H[0]}}def(me){const H=this.rules.block.def.exec(me);if(H){const ee=H[1].toLowerCase().replace(/\s+/g," "),ge=H[2]?H[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",re=H[3]?H[3].substring(1,H[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):H[3];return{type:"def",tag:ee,raw:H[0],href:ge,title:re}}}table(me){const H=this.rules.block.table.exec(me);if(!H||!/[:|]/.test(H[2]))return;const ee=a(H[1]),ge=H[2].replace(/^\||\| *$/g,"").split("|"),re=H[3]&&H[3].trim()?H[3].replace(/\n[ \t]*$/,"").split(`
`):[],fe={type:"table",raw:H[0],header:[],align:[],rows:[]};if(ee.length===ge.length){for(const W of ge)/^ *-+: *$/.test(W)?fe.align.push("right"):/^ *:-+: *$/.test(W)?fe.align.push("center"):/^ *:-+ *$/.test(W)?fe.align.push("left"):fe.align.push(null);for(let W=0;W<ee.length;W++)fe.header.push({text:ee[W],tokens:this.lexer.inline(ee[W]),header:!0,align:fe.align[W]});for(const W of re)fe.rows.push(a(W,fe.header.length).map((K,$e)=>({text:K,tokens:this.lexer.inline(K),header:!1,align:fe.align[$e]})));return fe}}lheading(me){const H=this.rules.block.lheading.exec(me);if(H)return{type:"heading",raw:H[0],depth:H[2].charAt(0)==="="?1:2,text:H[1],tokens:this.lexer.inline(H[1])}}paragraph(me){const H=this.rules.block.paragraph.exec(me);if(H){const ee=H[1].charAt(H[1].length-1)===`
`?H[1].slice(0,-1):H[1];return{type:"paragraph",raw:H[0],text:ee,tokens:this.lexer.inline(ee)}}}text(me){const H=this.rules.block.text.exec(me);if(H)return{type:"text",raw:H[0],text:H[0],tokens:this.lexer.inline(H[0])}}escape(me){const H=this.rules.inline.escape.exec(me);if(H)return{type:"escape",raw:H[0],text:s(H[1])}}tag(me){const H=this.rules.inline.tag.exec(me);if(H)return!this.lexer.state.inLink&&/^<a /i.test(H[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(H[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(H[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(H[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:H[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:H[0]}}link(me){const H=this.rules.inline.link.exec(me);if(H){const ee=H[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;const fe=c(ee.slice(0,-1),"\\");if((ee.length-fe.length)%2===0)return}else{const fe=m(H[2],"()");if(fe>-1){const K=(H[0].indexOf("!")===0?5:4)+H[1].length+fe;H[2]=H[2].substring(0,fe),H[0]=H[0].substring(0,K).trim(),H[3]=""}}let ge=H[2],re="";if(this.options.pedantic){const fe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ge);fe&&(ge=fe[1],re=fe[3])}else re=H[3]?H[3].slice(1,-1):"";return ge=ge.trim(),/^</.test(ge)&&(this.options.pedantic&&!/>$/.test(ee)?ge=ge.slice(1):ge=ge.slice(1,-1)),b(H,{href:ge&&ge.replace(this.rules.inline.anyPunctuation,"$1"),title:re&&re.replace(this.rules.inline.anyPunctuation,"$1")},H[0],this.lexer)}}reflink(me,H){let ee;if((ee=this.rules.inline.reflink.exec(me))||(ee=this.rules.inline.nolink.exec(me))){const ge=(ee[2]||ee[1]).replace(/\s+/g," "),re=H[ge.toLowerCase()];if(!re){const fe=ee[0].charAt(0);return{type:"text",raw:fe,text:fe}}return b(ee,re,ee[0],this.lexer)}}emStrong(me,H,ee=""){let ge=this.rules.inline.emStrongLDelim.exec(me);if(!ge||ge[3]&&ee.match(/[\p{L}\p{N}]/u))return;if(!(ge[1]||ge[2]||"")||!ee||this.rules.inline.punctuation.exec(ee)){const fe=[...ge[0]].length-1;let W,K,$e=fe,Fe=0;const qe=ge[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(qe.lastIndex=0,H=H.slice(-1*me.length+fe);(ge=qe.exec(H))!=null;){if(W=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!W)continue;if(K=[...W].length,ge[3]||ge[4]){$e+=K;continue}else if((ge[5]||ge[6])&&fe%3&&!((fe+K)%3)){Fe+=K;continue}if($e-=K,$e>0)continue;K=Math.min(K,K+$e+Fe);const xe=[...ge[0]][0].length,et=me.slice(0,fe+ge.index+xe+K);if(Math.min(fe,K)%2){const ct=et.slice(1,-1);return{type:"em",raw:et,text:ct,tokens:this.lexer.inlineTokens(ct)}}const it=et.slice(2,-2);return{type:"strong",raw:et,text:it,tokens:this.lexer.inlineTokens(it)}}}}codespan(me){const H=this.rules.inline.code.exec(me);if(H){let ee=H[2].replace(/\n/g," ");const ge=/[^ ]/.test(ee),re=/^ /.test(ee)&&/ $/.test(ee);return ge&&re&&(ee=ee.substring(1,ee.length-1)),ee=s(ee,!0),{type:"codespan",raw:H[0],text:ee}}}br(me){const H=this.rules.inline.br.exec(me);if(H)return{type:"br",raw:H[0]}}del(me){const H=this.rules.inline.del.exec(me);if(H)return{type:"del",raw:H[0],text:H[2],tokens:this.lexer.inlineTokens(H[2])}}autolink(me){const H=this.rules.inline.autolink.exec(me);if(H){let ee,ge;return H[2]==="@"?(ee=s(H[1]),ge="mailto:"+ee):(ee=s(H[1]),ge=ee),{type:"link",raw:H[0],text:ee,href:ge,tokens:[{type:"text",raw:ee,text:ee}]}}}url(me){let H;if(H=this.rules.inline.url.exec(me)){let ee,ge;if(H[2]==="@")ee=s(H[0]),ge="mailto:"+ee;else{let re;do re=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])?.[0]??"";while(re!==H[0]);ee=s(H[0]),H[1]==="www."?ge="http://"+H[0]:ge=H[0]}return{type:"link",raw:H[0],text:ee,href:ge,tokens:[{type:"text",raw:ee,text:ee}]}}}inlineText(me){const H=this.rules.inline.text.exec(me);if(H){let ee;return this.lexer.state.inRawBlock?ee=H[0]:ee=s(H[0]),{type:"text",raw:H[0],text:ee}}}}const w=/^(?: *(?:\n|$))+/,o=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,l=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,n=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,u=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,r=/(?:[*+-]|\d{1,9}[.)])/,f=y(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,r).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),h=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,k=/^[^\n]+/,P=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O=y(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",P).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),C=y(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,r).getRegex(),L="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",R=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,z=y("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",R).replace("tag",L).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q=y(h).replace("hr",n).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L).getRegex(),x={blockquote:y(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",Q).getRegex(),code:o,def:O,fences:l,heading:u,hr:n,html:z,lheading:f,list:C,newline:w,paragraph:Q,table:$,text:k},ve=y("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",n).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L).getRegex(),be={...x,table:ve,paragraph:y(h).replace("hr",n).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",ve).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L).getRegex()},se={...x,html:y(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",R).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:y(h).replace("hr",n).replace("heading",` *#{1,6} *[^
]`).replace("lheading",f).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},V=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,B=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,j=/^( {2,}|\\)\n(?!\s*$)/,U=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,te="\\p{P}\\p{S}",le=y(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,te).getRegex(),ye=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,oe=y(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,te).getRegex(),_=y("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,te).getRegex(),X=y("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,te).getRegex(),M=y(/\\([punct])/,"gu").replace(/punct/g,te).getRegex(),A=y(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),Y=y(R).replace("(?:-->|$)","-->").getRegex(),pe=y("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",Y).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),ne=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie=y(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",ne).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),G=y(/^!?\[(label)\]\[(ref)\]/).replace("label",ne).replace("ref",P).getRegex(),Z=y(/^!?\[(ref)\](?:\[\])?/).replace("ref",P).getRegex(),ce=y("reflink|nolink(?!\\()","g").replace("reflink",G).replace("nolink",Z).getRegex(),we={_backpedal:$,anyPunctuation:M,autolink:A,blockSkip:ye,br:j,code:B,del:$,emStrongLDelim:oe,emStrongRDelimAst:_,emStrongRDelimUnd:X,escape:V,link:ie,nolink:Z,punctuation:le,reflink:G,reflinkSearch:ce,tag:pe,text:U,url:$},Ie={...we,link:y(/^!?\[(label)\]\((.*?)\)/).replace("label",ne).getRegex(),reflink:y(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne).getRegex()},Me={...we,escape:y(V).replace("])","~|])").getRegex(),url:y(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},Be={...Me,br:y(j).replace("{2,}","*").getRegex(),text:y(Me.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},De={normal:x,gfm:be,pedantic:se},Ne={normal:we,gfm:Me,breaks:Be,pedantic:Ie};class Te{tokens;options;state;tokenizer;inlineQueue;constructor(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||ue.defaults,this.options.tokenizer=this.options.tokenizer||new d,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const H={block:De.normal,inline:Ne.normal};this.options.pedantic?(H.block=De.pedantic,H.inline=Ne.pedantic):this.options.gfm&&(H.block=De.gfm,this.options.breaks?H.inline=Ne.breaks:H.inline=Ne.gfm),this.tokenizer.rules=H}static get rules(){return{block:De,inline:Ne}}static lex(me,H){return new Te(H).lex(me)}static lexInline(me,H){return new Te(H).inlineTokens(me)}lex(me){me=me.replace(/\r\n|\r/g,`
`),this.blockTokens(me,this.tokens);for(let H=0;H<this.inlineQueue.length;H++){const ee=this.inlineQueue[H];this.inlineTokens(ee.src,ee.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(me,H=[],ee=!1){this.options.pedantic?me=me.replace(/\t/g,"    ").replace(/^ +$/gm,""):me=me.replace(/^( *)(\t+)/gm,(W,K,$e)=>K+"    ".repeat($e.length));let ge,re,fe;for(;me;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(W=>(ge=W.call({lexer:this},me,H))?(me=me.substring(ge.raw.length),H.push(ge),!0):!1))){if(ge=this.tokenizer.space(me)){me=me.substring(ge.raw.length),ge.raw.length===1&&H.length>0?H[H.length-1].raw+=`
`:H.push(ge);continue}if(ge=this.tokenizer.code(me)){me=me.substring(ge.raw.length),re=H[H.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+ge.raw,re.text+=`
`+ge.text,this.inlineQueue[this.inlineQueue.length-1].src=re.text):H.push(ge);continue}if(ge=this.tokenizer.fences(me)){me=me.substring(ge.raw.length),H.push(ge);continue}if(ge=this.tokenizer.heading(me)){me=me.substring(ge.raw.length),H.push(ge);continue}if(ge=this.tokenizer.hr(me)){me=me.substring(ge.raw.length),H.push(ge);continue}if(ge=this.tokenizer.blockquote(me)){me=me.substring(ge.raw.length),H.push(ge);continue}if(ge=this.tokenizer.list(me)){me=me.substring(ge.raw.length),H.push(ge);continue}if(ge=this.tokenizer.html(me)){me=me.substring(ge.raw.length),H.push(ge);continue}if(ge=this.tokenizer.def(me)){me=me.substring(ge.raw.length),re=H[H.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+ge.raw,re.text+=`
`+ge.raw,this.inlineQueue[this.inlineQueue.length-1].src=re.text):this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(me)){me=me.substring(ge.raw.length),H.push(ge);continue}if(ge=this.tokenizer.lheading(me)){me=me.substring(ge.raw.length),H.push(ge);continue}if(fe=me,this.options.extensions&&this.options.extensions.startBlock){let W=1/0;const K=me.slice(1);let $e;this.options.extensions.startBlock.forEach(Fe=>{$e=Fe.call({lexer:this},K),typeof $e=="number"&&$e>=0&&(W=Math.min(W,$e))}),W<1/0&&W>=0&&(fe=me.substring(0,W+1))}if(this.state.top&&(ge=this.tokenizer.paragraph(fe))){re=H[H.length-1],ee&&re?.type==="paragraph"?(re.raw+=`
`+ge.raw,re.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):H.push(ge),ee=fe.length!==me.length,me=me.substring(ge.raw.length);continue}if(ge=this.tokenizer.text(me)){me=me.substring(ge.raw.length),re=H[H.length-1],re&&re.type==="text"?(re.raw+=`
`+ge.raw,re.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):H.push(ge);continue}if(me){const W="Infinite loop on byte: "+me.charCodeAt(0);if(this.options.silent){console.error(W);break}else throw new Error(W)}}return this.state.top=!0,H}inline(me,H=[]){return this.inlineQueue.push({src:me,tokens:H}),H}inlineTokens(me,H=[]){let ee,ge,re,fe=me,W,K,$e;if(this.tokens.links){const Fe=Object.keys(this.tokens.links);if(Fe.length>0)for(;(W=this.tokenizer.rules.inline.reflinkSearch.exec(fe))!=null;)Fe.includes(W[0].slice(W[0].lastIndexOf("[")+1,-1))&&(fe=fe.slice(0,W.index)+"["+"a".repeat(W[0].length-2)+"]"+fe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(W=this.tokenizer.rules.inline.blockSkip.exec(fe))!=null;)fe=fe.slice(0,W.index)+"["+"a".repeat(W[0].length-2)+"]"+fe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(W=this.tokenizer.rules.inline.anyPunctuation.exec(fe))!=null;)fe=fe.slice(0,W.index)+"++"+fe.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;me;)if(K||($e=""),K=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(Fe=>(ee=Fe.call({lexer:this},me,H))?(me=me.substring(ee.raw.length),H.push(ee),!0):!1))){if(ee=this.tokenizer.escape(me)){me=me.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.tag(me)){me=me.substring(ee.raw.length),ge=H[H.length-1],ge&&ee.type==="text"&&ge.type==="text"?(ge.raw+=ee.raw,ge.text+=ee.text):H.push(ee);continue}if(ee=this.tokenizer.link(me)){me=me.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.reflink(me,this.tokens.links)){me=me.substring(ee.raw.length),ge=H[H.length-1],ge&&ee.type==="text"&&ge.type==="text"?(ge.raw+=ee.raw,ge.text+=ee.text):H.push(ee);continue}if(ee=this.tokenizer.emStrong(me,fe,$e)){me=me.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.codespan(me)){me=me.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.br(me)){me=me.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.del(me)){me=me.substring(ee.raw.length),H.push(ee);continue}if(ee=this.tokenizer.autolink(me)){me=me.substring(ee.raw.length),H.push(ee);continue}if(!this.state.inLink&&(ee=this.tokenizer.url(me))){me=me.substring(ee.raw.length),H.push(ee);continue}if(re=me,this.options.extensions&&this.options.extensions.startInline){let Fe=1/0;const qe=me.slice(1);let xe;this.options.extensions.startInline.forEach(et=>{xe=et.call({lexer:this},qe),typeof xe=="number"&&xe>=0&&(Fe=Math.min(Fe,xe))}),Fe<1/0&&Fe>=0&&(re=me.substring(0,Fe+1))}if(ee=this.tokenizer.inlineText(re)){me=me.substring(ee.raw.length),ee.raw.slice(-1)!=="_"&&($e=ee.raw.slice(-1)),K=!0,ge=H[H.length-1],ge&&ge.type==="text"?(ge.raw+=ee.raw,ge.text+=ee.text):H.push(ee);continue}if(me){const Fe="Infinite loop on byte: "+me.charCodeAt(0);if(this.options.silent){console.error(Fe);break}else throw new Error(Fe)}}return H}}class Ce{options;parser;constructor(me){this.options=me||ue.defaults}space(me){return""}code({text:me,lang:H,escaped:ee}){const ge=(H||"").match(/^\S*/)?.[0],re=me.replace(/\n$/,"")+`
`;return ge?'<pre><code class="language-'+s(ge)+'">'+(ee?re:s(re,!0))+`</code></pre>
`:"<pre><code>"+(ee?re:s(re,!0))+`</code></pre>
`}blockquote({tokens:me}){return`<blockquote>
${this.parser.parse(me)}</blockquote>
`}html({text:me}){return me}heading({tokens:me,depth:H}){return`<h${H}>${this.parser.parseInline(me)}</h${H}>
`}hr(me){return`<hr>
`}list(me){const H=me.ordered,ee=me.start;let ge="";for(let W=0;W<me.items.length;W++){const K=me.items[W];ge+=this.listitem(K)}const re=H?"ol":"ul",fe=H&&ee!==1?' start="'+ee+'"':"";return"<"+re+fe+`>
`+ge+"</"+re+`>
`}listitem(me){let H="";if(me.task){const ee=this.checkbox({checked:!!me.checked});me.loose?me.tokens.length>0&&me.tokens[0].type==="paragraph"?(me.tokens[0].text=ee+" "+me.tokens[0].text,me.tokens[0].tokens&&me.tokens[0].tokens.length>0&&me.tokens[0].tokens[0].type==="text"&&(me.tokens[0].tokens[0].text=ee+" "+me.tokens[0].tokens[0].text)):me.tokens.unshift({type:"text",raw:ee+" ",text:ee+" "}):H+=ee+" "}return H+=this.parser.parse(me.tokens,!!me.loose),`<li>${H}</li>
`}checkbox({checked:me}){return"<input "+(me?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:me}){return`<p>${this.parser.parseInline(me)}</p>
`}table(me){let H="",ee="";for(let re=0;re<me.header.length;re++)ee+=this.tablecell(me.header[re]);H+=this.tablerow({text:ee});let ge="";for(let re=0;re<me.rows.length;re++){const fe=me.rows[re];ee="";for(let W=0;W<fe.length;W++)ee+=this.tablecell(fe[W]);ge+=this.tablerow({text:ee})}return ge&&(ge=`<tbody>${ge}</tbody>`),`<table>
<thead>
`+H+`</thead>
`+ge+`</table>
`}tablerow({text:me}){return`<tr>
${me}</tr>
`}tablecell(me){const H=this.parser.parseInline(me.tokens),ee=me.header?"th":"td";return(me.align?`<${ee} align="${me.align}">`:`<${ee}>`)+H+`</${ee}>
`}strong({tokens:me}){return`<strong>${this.parser.parseInline(me)}</strong>`}em({tokens:me}){return`<em>${this.parser.parseInline(me)}</em>`}codespan({text:me}){return`<code>${me}</code>`}br(me){return"<br>"}del({tokens:me}){return`<del>${this.parser.parseInline(me)}</del>`}link({href:me,title:H,tokens:ee}){const ge=this.parser.parseInline(ee),re=p(me);if(re===null)return ge;me=re;let fe='<a href="'+me+'"';return H&&(fe+=' title="'+H+'"'),fe+=">"+ge+"</a>",fe}image({href:me,title:H,text:ee}){const ge=p(me);if(ge===null)return ee;me=ge;let re=`<img src="${me}" alt="${ee}"`;return H&&(re+=` title="${H}"`),re+=">",re}text(me){return"tokens"in me&&me.tokens?this.parser.parseInline(me.tokens):me.text}}class de{strong({text:me}){return me}em({text:me}){return me}codespan({text:me}){return me}del({text:me}){return me}html({text:me}){return me}text({text:me}){return me}link({text:me}){return""+me}image({text:me}){return""+me}br(){return""}}class Se{options;renderer;textRenderer;constructor(me){this.options=me||ue.defaults,this.options.renderer=this.options.renderer||new Ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new de}static parse(me,H){return new Se(H).parse(me)}static parseInline(me,H){return new Se(H).parseInline(me)}parse(me,H=!0){let ee="";for(let ge=0;ge<me.length;ge++){const re=me[ge];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]){const W=re,K=this.options.extensions.renderers[W.type].call({parser:this},W);if(K!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(W.type)){ee+=K||"";continue}}const fe=re;switch(fe.type){case"space":{ee+=this.renderer.space(fe);continue}case"hr":{ee+=this.renderer.hr(fe);continue}case"heading":{ee+=this.renderer.heading(fe);continue}case"code":{ee+=this.renderer.code(fe);continue}case"table":{ee+=this.renderer.table(fe);continue}case"blockquote":{ee+=this.renderer.blockquote(fe);continue}case"list":{ee+=this.renderer.list(fe);continue}case"html":{ee+=this.renderer.html(fe);continue}case"paragraph":{ee+=this.renderer.paragraph(fe);continue}case"text":{let W=fe,K=this.renderer.text(W);for(;ge+1<me.length&&me[ge+1].type==="text";)W=me[++ge],K+=`
`+this.renderer.text(W);H?ee+=this.renderer.paragraph({type:"paragraph",raw:K,text:K,tokens:[{type:"text",raw:K,text:K}]}):ee+=K;continue}default:{const W='Token with "'+fe.type+'" type was not found.';if(this.options.silent)return console.error(W),"";throw new Error(W)}}}return ee}parseInline(me,H){H=H||this.renderer;let ee="";for(let ge=0;ge<me.length;ge++){const re=me[ge];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]){const W=this.options.extensions.renderers[re.type].call({parser:this},re);if(W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(re.type)){ee+=W||"";continue}}const fe=re;switch(fe.type){case"escape":{ee+=H.text(fe);break}case"html":{ee+=H.html(fe);break}case"link":{ee+=H.link(fe);break}case"image":{ee+=H.image(fe);break}case"strong":{ee+=H.strong(fe);break}case"em":{ee+=H.em(fe);break}case"codespan":{ee+=H.codespan(fe);break}case"br":{ee+=H.br(fe);break}case"del":{ee+=H.del(fe);break}case"text":{ee+=H.text(fe);break}default:{const W='Token with "'+fe.type+'" type was not found.';if(this.options.silent)return console.error(W),"";throw new Error(W)}}}return ee}}class Re{options;constructor(me){this.options=me||ue.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(me){return me}postprocess(me){return me}processAllTokens(me){return me}}class Ue{defaults=e();options=this.setOptions;parse=this.parseMarkdown(Te.lex,Se.parse);parseInline=this.parseMarkdown(Te.lexInline,Se.parseInline);Parser=Se;Renderer=Ce;TextRenderer=de;Lexer=Te;Tokenizer=d;Hooks=Re;constructor(...me){this.use(...me)}walkTokens(me,H){let ee=[];for(const ge of me)switch(ee=ee.concat(H.call(this,ge)),ge.type){case"table":{const re=ge;for(const fe of re.header)ee=ee.concat(this.walkTokens(fe.tokens,H));for(const fe of re.rows)for(const W of fe)ee=ee.concat(this.walkTokens(W.tokens,H));break}case"list":{const re=ge;ee=ee.concat(this.walkTokens(re.items,H));break}default:{const re=ge;this.defaults.extensions?.childTokens?.[re.type]?this.defaults.extensions.childTokens[re.type].forEach(fe=>{const W=re[fe].flat(1/0);ee=ee.concat(this.walkTokens(W,H))}):re.tokens&&(ee=ee.concat(this.walkTokens(re.tokens,H)))}}return ee}use(...me){const H=this.defaults.extensions||{renderers:{},childTokens:{}};return me.forEach(ee=>{const ge={...ee};if(ge.async=this.defaults.async||ge.async||!1,ee.extensions&&(ee.extensions.forEach(re=>{if(!re.name)throw new Error("extension name required");if("renderer"in re){const fe=H.renderers[re.name];fe?H.renderers[re.name]=function(...W){let K=re.renderer.apply(this,W);return K===!1&&(K=fe.apply(this,W)),K}:H.renderers[re.name]=re.renderer}if("tokenizer"in re){if(!re.level||re.level!=="block"&&re.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const fe=H[re.level];fe?fe.unshift(re.tokenizer):H[re.level]=[re.tokenizer],re.start&&(re.level==="block"?H.startBlock?H.startBlock.push(re.start):H.startBlock=[re.start]:re.level==="inline"&&(H.startInline?H.startInline.push(re.start):H.startInline=[re.start]))}"childTokens"in re&&re.childTokens&&(H.childTokens[re.name]=re.childTokens)}),ge.extensions=H),ee.renderer){const re=this.defaults.renderer||new Ce(this.defaults);for(const fe in ee.renderer){if(!(fe in re))throw new Error(`renderer '${fe}' does not exist`);if(["options","parser"].includes(fe))continue;const W=fe,K=ee.renderer[W],$e=re[W];re[W]=(...Fe)=>{let qe=K.apply(re,Fe);return qe===!1&&(qe=$e.apply(re,Fe)),qe||""}}ge.renderer=re}if(ee.tokenizer){const re=this.defaults.tokenizer||new d(this.defaults);for(const fe in ee.tokenizer){if(!(fe in re))throw new Error(`tokenizer '${fe}' does not exist`);if(["options","rules","lexer"].includes(fe))continue;const W=fe,K=ee.tokenizer[W],$e=re[W];re[W]=(...Fe)=>{let qe=K.apply(re,Fe);return qe===!1&&(qe=$e.apply(re,Fe)),qe}}ge.tokenizer=re}if(ee.hooks){const re=this.defaults.hooks||new Re;for(const fe in ee.hooks){if(!(fe in re))throw new Error(`hook '${fe}' does not exist`);if(fe==="options")continue;const W=fe,K=ee.hooks[W],$e=re[W];Re.passThroughHooks.has(fe)?re[W]=Fe=>{if(this.defaults.async)return Promise.resolve(K.call(re,Fe)).then(xe=>$e.call(re,xe));const qe=K.call(re,Fe);return $e.call(re,qe)}:re[W]=(...Fe)=>{let qe=K.apply(re,Fe);return qe===!1&&(qe=$e.apply(re,Fe)),qe}}ge.hooks=re}if(ee.walkTokens){const re=this.defaults.walkTokens,fe=ee.walkTokens;ge.walkTokens=function(W){let K=[];return K.push(fe.call(this,W)),re&&(K=K.concat(re.call(this,W))),K}}this.defaults={...this.defaults,...ge}}),this}setOptions(me){return this.defaults={...this.defaults,...me},this}lexer(me,H){return Te.lex(me,H??this.defaults)}parser(me,H){return Se.parse(me,H??this.defaults)}parseMarkdown(me,H){return(ge,re)=>{const fe={...re},W={...this.defaults,...fe},K=this.onError(!!W.silent,!!W.async);if(this.defaults.async===!0&&fe.async===!1)return K(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof ge>"u"||ge===null)return K(new Error("marked(): input parameter is undefined or null"));if(typeof ge!="string")return K(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected"));if(W.hooks&&(W.hooks.options=W),W.async)return Promise.resolve(W.hooks?W.hooks.preprocess(ge):ge).then($e=>me($e,W)).then($e=>W.hooks?W.hooks.processAllTokens($e):$e).then($e=>W.walkTokens?Promise.all(this.walkTokens($e,W.walkTokens)).then(()=>$e):$e).then($e=>H($e,W)).then($e=>W.hooks?W.hooks.postprocess($e):$e).catch(K);try{W.hooks&&(ge=W.hooks.preprocess(ge));let $e=me(ge,W);W.hooks&&($e=W.hooks.processAllTokens($e)),W.walkTokens&&this.walkTokens($e,W.walkTokens);let Fe=H($e,W);return W.hooks&&(Fe=W.hooks.postprocess(Fe)),Fe}catch($e){return K($e)}}}onError(me,H){return ee=>{if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,me){const ge="<p>An error occurred:</p><pre>"+s(ee.message+"",!0)+"</pre>";return H?Promise.resolve(ge):ge}if(H)return Promise.reject(ee);throw ee}}}const Ge=new Ue;function Qe(Ye,me){return Ge.parse(Ye,me)}Qe.options=Qe.setOptions=function(Ye){return Ge.setOptions(Ye),Qe.defaults=Ge.defaults,t(Qe.defaults),Qe},Qe.getDefaults=e,Qe.defaults=ue.defaults,Qe.use=function(...Ye){return Ge.use(...Ye),Qe.defaults=Ge.defaults,t(Qe.defaults),Qe},Qe.walkTokens=function(Ye,me){return Ge.walkTokens(Ye,me)},Qe.parseInline=Ge.parseInline,Qe.Parser=Se,Qe.parser=Se.parse,Qe.Renderer=Ce,Qe.TextRenderer=de,Qe.Lexer=Te,Qe.lexer=Te.lex,Qe.Tokenizer=d,Qe.Hooks=Re,Qe.parse=Qe;const Je=Qe.options,Xe=Qe.setOptions,tt=Qe.use,st=Qe.walkTokens,dt=Qe.parseInline,rt=Qe,ot=Se.parse,ut=Te.lex;ue.Hooks=Re,ue.Lexer=Te,ue.Marked=Ue,ue.Parser=Se,ue.Renderer=Ce,ue.TextRenderer=de,ue.Tokenizer=d,ue.getDefaults=e,ue.lexer=ut,ue.marked=Qe,ue.options=Je,ue.parse=rt,ue.parseInline=dt,ue.parser=ot,ue.setOptions=Xe,ue.use=tt,ue.walkTokens=st}),define(Oe[82],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var t;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadInstance=8]="CommentThreadInstance",i[i.CommentThreadReply=9]="CommentThreadReply",i[i.CommentNode=10]="CommentNode",i[i.CommentThreadNode=11]="CommentThreadNode",i[i.TimelineActionContext=12]="TimelineActionContext",i[i.NotebookCellActionContext=13]="NotebookCellActionContext",i[i.NotebookActionContext=14]="NotebookActionContext",i[i.TerminalContext=15]="TerminalContext",i[i.TestItemContext=16]="TestItemContext",i[i.Date=17]="Date",i[i.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(t||(e.MarshalledId=t={}))}),define(Oe[165],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=t;function t(c){const m=I(c);if(m&&m.length>0)return new Uint32Array(m)}let i=0;const E=new Uint32Array(10);function I(c){if(i=0,D(c,y,v.InitialConsonant),i>0||(D(c,p,v.Vowel),i>0)||(D(c,$,v.FinalConsonant),i>0)||(D(c,a,v.CompatibilityJamo),i))return E.subarray(0,i);if(c>=44032&&c<=55203){const m=c-44032,b=m%588,g=Math.floor(m/588),d=Math.floor(b/28),w=b%28-1;if(g<y.length?D(g,y,0):v.InitialConsonant+g-v.CompatibilityJamo<a.length&&D(v.InitialConsonant+g,a,v.CompatibilityJamo),d<p.length?D(d,p,0):v.Vowel+d-v.CompatibilityJamo<a.length&&D(v.Vowel+d-v.CompatibilityJamo,a,v.CompatibilityJamo),w>=0&&(w<$.length?D(w,$,0):v.FinalConsonant+w-v.CompatibilityJamo<a.length&&D(v.FinalConsonant+w-v.CompatibilityJamo,a,v.CompatibilityJamo)),i>0)return E.subarray(0,i)}}function D(c,m,b){c>=b&&c<b+m.length&&T(m[c-b])}function T(c){c!==s.NUL&&(E[i++]=c&255,c>>8&&(E[i++]=c>>8&255),c>>16&&(E[i++]=c>>16&255))}var v;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var s;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(s||(s={}));var S;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(S||(S={}));const y=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),p=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,S.hk,S.ho,S.hl,s.y,s.n,S.nj,S.np,S.nl,s.b,s.m,S.ml,s.l]),$=new Uint16Array([s.r,s.R,S.rt,s.s,S.sw,S.sg,s.e,s.f,S.fr,S.fa,S.fq,S.ft,S.fx,S.fv,S.fg,s.a,s.q,S.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),a=new Uint16Array([s.r,s.R,S.rt,s.s,S.sw,S.sg,s.e,s.E,s.f,S.fr,S.fa,S.fq,S.ft,S.fx,S.fv,S.fg,s.a,s.q,s.Q,S.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,S.hk,S.ho,S.hl,s.y,s.n,S.nj,S.np,S.nl,s.b,s.m,S.ml,s.l])}),define(Oe[107],Le([1,0,25]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=void 0,e.$sm=E,e.$tm=D;const i=new t.$Ic(1e4);function E(s){return v(s,"NFC",i)}const I=new t.$Ic(1e4);function D(s){return v(s,"NFD",I)}const T=/[^\u0000-\u0080]/;function v(s,S,y){if(!s)return s;const p=y.get(s);if(p)return p;let $;return T.test(s)?$=s.normalize(S):$=s,y.set(s,$),$}e.$um=function(){const s=/[\u0300-\u036f]/g;return function(S){return D(S).replace(s,"")}}()}),define(Oe[166],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Qm=t,e.rot=i,e.$Vm=T;function t(v,s,S){return Math.min(Math.max(v,s),S)}function i(v,s){return(s+v%s)%s}class E{constructor(){this.a=0}getNext(){return this.a++}}e.$Sm=E;class I{constructor(){this.a=1,this.b=0}update(s){return this.b=this.b+(s-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Tm=I;class D{constructor(s){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(s),this.c.fill(0,0,s)}update(s){const S=this.c[this.d];return this.c[this.d]=s,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=s,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Um=D;function T(v,s,S,y,p,$,a,c){const m=a-S,b=c-y,g=p-S,d=$-y,w=v-S,o=s-y,l=m*m+b*b,n=m*g+b*d,u=m*w+b*o,r=g*g+d*d,f=g*w+d*o,h=1/(l*r-n*n),k=(r*u-n*f)*h,P=(l*f-n*u)*h;return k>=0&&P>=0&&k+P<1}}),define(Oe[167],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fd=void 0,e.$gd=I,e.$hd=p;class t{constructor(a,c,m){this.owner=a,this.debugNameSource=c,this.referenceFn=m}getDebugName(a){return I(a,this)}}e.$fd=t;const i=new Map,E=new WeakMap;function I($,a){const c=E.get($);if(c)return c;const m=D($,a);if(m){let b=i.get(m)??0;b++,i.set(m,b);const g=b===1?m:`${m}#${b}`;return E.set($,g),g}}function D($,a){const c=E.get($);if(c)return c;const m=a.owner?S(a.owner)+".":"";let b;const g=a.debugNameSource;if(g!==void 0)if(typeof g=="function"){if(b=g(),b!==void 0)return m+b}else return m+g;const d=a.referenceFn;if(d!==void 0&&(b=p(d),b!==void 0))return m+b;if(a.owner!==void 0){const w=T(a.owner,$);if(w!==void 0)return m+w}}function T($,a){for(const c in $)if($[c]===a)return c}const v=new Map,s=new WeakMap;function S($){const a=s.get($);if(a)return a;const c=y($);let m=v.get(c)??0;m++,v.set(c,m);const b=m===1?c:`${c}#${m}`;return s.set($,b),b}function y($){const a=$.constructor;return a?a.name:"Object"}function p($){const a=$.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(a);return(m?m[1]:void 0)?.trim()}}),define(Oe[168],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0,e.$Pd=i,e.$Qd=E;let t;function i(c){t=c}function E(){return t}class I{constructor(){this.a=0,this.d=new WeakMap}b(m){return D([T($("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[T(" "),s(S(m.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),s(S(m.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),s(S(m.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(m,b){console.log(...this.b([v("observable value changed"),s(m.debugName,{color:"BlueViolet"}),...this.c(b)]))}formatChanges(m){if(m.size!==0)return s(" (changed deps: "+[...m].map(b=>b.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const b=m.handleChange;this.d.set(m,new Set),m.handleChange=(g,d)=>(this.d.get(m).add(g),b.apply(m,[g,d]))}handleDerivedRecomputed(m,b){const g=this.d.get(m);console.log(...this.b([v("derived recomputed"),s(m.debugName,{color:"BlueViolet"}),...this.c(b),this.formatChanges(g),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),g.clear()}handleFromEventObservableTriggered(m,b){console.log(...this.b([v("observable from event triggered"),s(m.debugName,{color:"BlueViolet"}),...this.c(b),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const b=m.handleChange;this.d.set(m,new Set),m.handleChange=(g,d)=>(this.d.get(m).add(g),b.apply(m,[g,d]))}handleAutorunTriggered(m){const b=this.d.get(m);console.log(...this.b([v("autorun"),s(m.debugName,{color:"BlueViolet"}),this.formatChanges(b),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),b.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let b=m.getDebugName();b===void 0&&(b=""),console.log(...this.b([v("transaction"),s(b,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Rd=I;function D(c){const m=new Array,b=[];let g="";function d(o){if("length"in o)for(const l of o)l&&d(l);else"text"in o?(g+=`%c${o.text}`,m.push(o.style),o.data&&b.push(...o.data)):"data"in o&&b.push(...o.data)}d(c);const w=[g,...m];return w.push(...b),w}function T(c){return s(c,{color:"black"})}function v(c){return s(a(`${c}: `,10),{color:"black",bold:!0})}function s(c,m={color:"black"}){function b(d){return Object.entries(d).reduce((w,[o,l])=>`${w}${o}:${l};`,"")}const g={color:m.color};return m.strikeThrough&&(g["text-decoration"]="line-through"),m.bold&&(g["font-weight"]="bold"),{text:c,style:b(g)}}function S(c,m){switch(typeof c){case"number":return""+c;case"string":return c.length+2<=m?`"${c}"`:`"${c.substr(0,m-7)}"+...`;case"boolean":return c?"true":"false";case"undefined":return"undefined";case"object":return c===null?"null":Array.isArray(c)?y(c,m):p(c,m);case"symbol":return c.toString();case"function":return`[[Function${c.name?" "+c.name:""}]]`;default:return""+c}}function y(c,m){let b="[ ",g=!0;for(const d of c){if(g||(b+=", "),b.length-5>m){b+="...";break}g=!1,b+=`${S(d,m-b.length)}`}return b+=" ]",b}function p(c,m){let b="{ ",g=!0;for(const[d,w]of Object.entries(c)){if(g||(b+=", "),b.length-5>m){b+="...";break}g=!1,b+=`${d}: ${S(w,m-b.length)}`}return b+=" }",b}function $(c,m){let b="";for(let g=1;g<=m;g++)b+=c;return b}function a(c,m){for(;c.length<m;)c+=" ";return c}}),define(Oe[169],Le([1,0,160,167,168]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$_d=e.$0d=e.$5d=e.$4d=void 0,e.$1d=D,e.$2d=v,e.$3d=S,e.$6d=$,e.$7d=c,e.$8d=m,e.$9d=b,e.$$d=d,e.$ae=o;let I;function D(n){I=n}let T;function v(n){T=n}let s;function S(n){s=n}class y{get TChange(){return null}reportChanges(){this.get()}read(u){return u?u.readObservable(this):this.get()}map(u,r){const f=r===void 0?void 0:u,h=r===void 0?u:r;return s({owner:f,debugName:()=>{const k=(0,i.$hd)(h);if(k!==void 0)return k;const O=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(h.toString());if(O)return`${this.debugName}.${O[2]}`;if(!f)return`${this.debugName} (mapped)`},debugReferenceFn:h},k=>h(this.read(k),k))}flatten(){return s({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},u=>this.read(u).read(u))}recomputeInitiallyAndOnChange(u,r){return u.add(I(this,r)),this}keepObserved(u){return u.add(T(this)),this}get a(){return this.get()}}e.$4d=y;class p extends y{constructor(){super(...arguments),this.b=new Set}addObserver(u){const r=this.b.size;this.b.add(u),r===0&&this.c()}removeObserver(u){this.b.delete(u)&&this.b.size===0&&this.f()}c(){}f(){}}e.$5d=p;function $(n,u){const r=new g(n,u);try{n(r)}finally{r.finish()}}let a;function c(n){if(a)n(a);else{const u=new g(n,void 0);a=u;try{n(u)}finally{u.finish(),a=void 0}}}async function m(n,u){const r=new g(n,u);try{await n(r)}finally{r.finish()}}function b(n,u,r){n?u(n):$(u,r)}class g{constructor(u,r){this._fn=u,this.b=r,this.a=[],(0,E.$Qd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,i.$hd)(this._fn)}updateObserver(u,r){this.a.push({observer:u,observable:r}),u.beginUpdate(r)}finish(){const u=this.a;for(let r=0;r<u.length;r++){const{observer:f,observable:h}=u[r];f.endUpdate(h)}this.a=null,(0,E.$Qd)()?.handleEndTransaction()}}e.$0d=g;function d(n,u){let r;return typeof n=="string"?r=new i.$fd(void 0,n,void 0):r=new i.$fd(n,void 0,void 0),new w(r,u,t.$$c)}class w extends p{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(u,r,f){super(),this.e=u,this.g=f,this.d=r}get(){return this.d}set(u,r,f){if(f===void 0&&this.g(this.d,u))return;let h;r||(r=h=new g(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(u),(0,E.$Qd)()?.handleObservableChanged(this,{oldValue:k,newValue:u,change:f,didChange:!0,hadValue:!0});for(const P of this.b)r.updateObserver(P,this),P.handleChange(this,f)}finally{h&&h.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(u){this.d=u}}e.$_d=w;function o(n,u){let r;return typeof n=="string"?r=new i.$fd(void 0,n,void 0):r=new i.$fd(n,void 0,void 0),new l(r,u,t.$$c)}class l extends w{h(u){this.d!==u&&(this.d&&this.d.dispose(),this.d=u)}dispose(){this.d?.dispose()}}e.$be=l}),function(){function ue(E){const I=[];typeof E=="number"&&I.push("code/timeOrigin",E);function D(v){I.push(v,Date.now())}function T(){const v=[];for(let s=0;s<I.length;s+=2)v.push({name:I[s],startTime:I[s+1]});return v}return{mark:D,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ue():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const D of performance.getEntriesByType("mark"))I.push({name:D.name,startTime:Math.round(E+D.startTime)});return I}};if(typeof process=="object"){const E=performance?.timeOrigin;return ue(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),ue()}function t(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return t(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=t(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=t(i))}(),define(Oe[170],Le([1,0,39]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=void 0;const i=Symbol("unset");class E{constructor(){this.a=new D,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||t.Iterable.empty()}get entries(){return this.a.children?.entries()||t.Iterable.empty()}insert(v,s,S){this.d(v,y=>y._value=s,S)}mutate(v,s){this.d(v,S=>S._value=s(S._value===i?void 0:S._value))}mutatePath(v,s){this.d(v,()=>{},S=>s(S))}delete(v){const s=this.c(v);if(!s)return;let S=s.length-1;const y=s[S].node._value;if(y!==i){for(this.b--,s[S].node._value=i;S>0;S--){const{node:p,part:$}=s[S];if(p.children?.size||p._value!==i)break;s[S-1].node.children.delete($)}return y}}*deleteRecursive(v){const s=this.c(v);if(!s)return;const S=s[s.length-1].node;for(let y=s.length-1;y>0;y--){const p=s[y-1];if(p.node.children.delete(s[y].part),p.node.children.size>0||p.node._value!==i)break}for(const y of I(S))y._value!==i&&(this.b--,yield y._value)}find(v){let s=this.a;for(const S of v){const y=s.children?.get(S);if(!y)return;s=y}return s._value===i?void 0:s._value}hasKeyOrParent(v){let s=this.a;for(const S of v){const y=s.children?.get(S);if(!y)return!1;if(y._value!==i)return!0;s=y}return!1}hasKeyOrChildren(v){let s=this.a;for(const S of v){const y=s.children?.get(S);if(!y)return!1;s=y}return!0}hasKey(v){let s=this.a;for(const S of v){const y=s.children?.get(S);if(!y)return!1;s=y}return s._value!==i}c(v){const s=[{part:"",node:this.a}];let S=0;for(const y of v){const p=s[S].node.children?.get(y);if(!p)return;s.push({part:y,node:p}),S++}return s}d(v,s,S){let y=this.a;for(const a of v){if(y.children)if(y.children.has(a))y=y.children.get(a);else{const c=new D;y.children.set(a,c),y=c}else{const c=new D;y.children=new Map([[a,c]]),y=c}S?.(y)}const p=y._value===i?0:1;s(y);const $=y._value===i?0:1;this.b+=$-p}*values(){for(const{_value:v}of I(this.a))v!==i&&(yield v)}}e.$sJ=E;function*I(T){const v=[T];for(;v.length>0;){const s=v.pop();if(yield s,s.children)for(const S of s.children.values())v.push(S)}}class D{constructor(){this._value=i}get value(){return this._value===i?void 0:this._value}set value(v){this._value=v===void 0?i:v}}}),function(ue,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var t=e();for(var i in t)(typeof exports=="object"?exports:ue)[i]=t[i]}}(typeof self<"u"?self:this,function(){return function(ue){var e={};function t(i){if(e[i])return e[i].exports;var E=e[i]={i,l:!1,exports:{}};return ue[i].call(E.exports,E,E.exports,t),E.l=!0,E.exports}return t.m=ue,t.c=e,t.d=function(i,E,I){t.o(i,E)||Object.defineProperty(i,E,{enumerable:!0,get:I})},t.r=function(i){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},t.t=function(i,E){if(1&E&&(i=t(i)),8&E||4&E&&typeof i=="object"&&i&&i.__esModule)return i;var I=Object.create(null);if(t.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:i}),2&E&&typeof i!="string")for(var D in i)t.d(I,D,function(T){return i[T]}.bind(null,D));return I},t.n=function(i){var E=i&&i.__esModule?function(){return i.default}:function(){return i};return t.d(E,"a",E),E},t.o=function(i,E){return Object.prototype.hasOwnProperty.call(i,E)},t.p="",t(t.s=0)}([function(ue,e,t){(function(i){var E;e=ue.exports=_,E=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var de=Array.prototype.slice.call(arguments,0);de.unshift("SEMVER"),console.log.apply(console,de)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],v=e.src=[],s=0,S=s++;v[S]="0|[1-9]\\d*";var y=s++;v[y]="[0-9]+";var p=s++;v[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=s++;v[$]="("+v[S]+")\\.("+v[S]+")\\.("+v[S]+")";var a=s++;v[a]="("+v[y]+")\\.("+v[y]+")\\.("+v[y]+")";var c=s++;v[c]="(?:"+v[S]+"|"+v[p]+")";var m=s++;v[m]="(?:"+v[y]+"|"+v[p]+")";var b=s++;v[b]="(?:-("+v[c]+"(?:\\."+v[c]+")*))";var g=s++;v[g]="(?:-?("+v[m]+"(?:\\."+v[m]+")*))";var d=s++;v[d]="[0-9A-Za-z-]+";var w=s++;v[w]="(?:\\+("+v[d]+"(?:\\."+v[d]+")*))";var o=s++,l="v?"+v[$]+v[b]+"?"+v[w]+"?";v[o]="^"+l+"$";var n="[v=\\s]*"+v[a]+v[g]+"?"+v[w]+"?",u=s++;v[u]="^"+n+"$";var r=s++;v[r]="((?:<|>)?=?)";var f=s++;v[f]=v[y]+"|x|X|\\*";var h=s++;v[h]=v[S]+"|x|X|\\*";var k=s++;v[k]="[v=\\s]*("+v[h]+")(?:\\.("+v[h]+")(?:\\.("+v[h]+")(?:"+v[b]+")?"+v[w]+"?)?)?";var P=s++;v[P]="[v=\\s]*("+v[f]+")(?:\\.("+v[f]+")(?:\\.("+v[f]+")(?:"+v[g]+")?"+v[w]+"?)?)?";var O=s++;v[O]="^"+v[r]+"\\s*"+v[k]+"$";var C=s++;v[C]="^"+v[r]+"\\s*"+v[P]+"$";var L=s++;v[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=s++;v[R]="(?:~>?)";var z=s++;v[z]="(\\s*)"+v[R]+"\\s+",T[z]=new RegExp(v[z],"g");var Q=s++;v[Q]="^"+v[R]+v[k]+"$";var J=s++;v[J]="^"+v[R]+v[P]+"$";var x=s++;v[x]="(?:\\^)";var ve=s++;v[ve]="(\\s*)"+v[x]+"\\s+",T[ve]=new RegExp(v[ve],"g");var be=s++;v[be]="^"+v[x]+v[k]+"$";var se=s++;v[se]="^"+v[x]+v[P]+"$";var V=s++;v[V]="^"+v[r]+"\\s*("+n+")$|^$";var B=s++;v[B]="^"+v[r]+"\\s*("+l+")$|^$";var j=s++;v[j]="(\\s*)"+v[r]+"\\s*("+n+"|"+v[k]+")",T[j]=new RegExp(v[j],"g");var U=s++;v[U]="^\\s*("+v[k]+")\\s+-\\s+("+v[k]+")\\s*$";var te=s++;v[te]="^\\s*("+v[P]+")\\s+-\\s+("+v[P]+")\\s*$";var le=s++;v[le]="(<|>)?=?\\s*\\*";for(var ye=0;ye<35;ye++)E(ye,v[ye]),T[ye]||(T[ye]=new RegExp(v[ye]));function oe(de,Se){if(de instanceof _)return de;if(typeof de!="string"||de.length>I||!(Se?T[u]:T[o]).test(de))return null;try{return new _(de,Se)}catch{return null}}function _(de,Se){if(de instanceof _){if(de.loose===Se)return de;de=de.version}else if(typeof de!="string")throw new TypeError("Invalid Version: "+de);if(de.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof _))return new _(de,Se);E("SemVer",de,Se),this.loose=Se;var Re=de.trim().match(Se?T[u]:T[o]);if(!Re)throw new TypeError("Invalid Version: "+de);if(this.raw=de,this.major=+Re[1],this.minor=+Re[2],this.patch=+Re[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");Re[4]?this.prerelease=Re[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var Ge=+Ue;if(Ge>=0&&Ge<D)return Ge}return Ue}):this.prerelease=[],this.build=Re[5]?Re[5].split("."):[],this.format()}e.parse=oe,e.valid=function(de,Se){var Re=oe(de,Se);return Re?Re.version:null},e.clean=function(de,Se){var Re=oe(de.trim().replace(/^[=v]+/,""),Se);return Re?Re.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(de){return E("SemVer.compare",this.version,this.loose,de),de instanceof _||(de=new _(de,this.loose)),this.compareMain(de)||this.comparePre(de)},_.prototype.compareMain=function(de){return de instanceof _||(de=new _(de,this.loose)),M(this.major,de.major)||M(this.minor,de.minor)||M(this.patch,de.patch)},_.prototype.comparePre=function(de){if(de instanceof _||(de=new _(de,this.loose)),this.prerelease.length&&!de.prerelease.length)return-1;if(!this.prerelease.length&&de.prerelease.length)return 1;if(!this.prerelease.length&&!de.prerelease.length)return 0;var Se=0;do{var Re=this.prerelease[Se],Ue=de.prerelease[Se];if(E("prerelease compare",Se,Re,Ue),Re===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(Re===void 0)return-1;if(Re!==Ue)return M(Re,Ue)}while(++Se)},_.prototype.inc=function(de,Se){switch(de){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Re=this.prerelease.length;--Re>=0;)typeof this.prerelease[Re]=="number"&&(this.prerelease[Re]++,Re=-2);Re===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+de)}return this.format(),this.raw=this.version,this},e.inc=function(de,Se,Re,Ue){typeof Re=="string"&&(Ue=Re,Re=void 0);try{return new _(de,Re).inc(Se,Ue).version}catch{return null}},e.diff=function(de,Se){if(ne(de,Se))return null;var Re=oe(de),Ue=oe(Se);if(Re.prerelease.length||Ue.prerelease.length){for(var Ge in Re)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&Re[Ge]!==Ue[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in Re)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&Re[Ge]!==Ue[Ge])return Ge},e.compareIdentifiers=M;var X=/^[0-9]+$/;function M(de,Se){var Re=X.test(de),Ue=X.test(Se);return Re&&Ue&&(de=+de,Se=+Se),Re&&!Ue?-1:Ue&&!Re?1:de<Se?-1:de>Se?1:0}function A(de,Se,Re){return new _(de,Re).compare(new _(Se,Re))}function Y(de,Se,Re){return A(de,Se,Re)>0}function pe(de,Se,Re){return A(de,Se,Re)<0}function ne(de,Se,Re){return A(de,Se,Re)===0}function ie(de,Se,Re){return A(de,Se,Re)!==0}function G(de,Se,Re){return A(de,Se,Re)>=0}function Z(de,Se,Re){return A(de,Se,Re)<=0}function ce(de,Se,Re,Ue){var Ge;switch(Se){case"===":typeof de=="object"&&(de=de.version),typeof Re=="object"&&(Re=Re.version),Ge=de===Re;break;case"!==":typeof de=="object"&&(de=de.version),typeof Re=="object"&&(Re=Re.version),Ge=de!==Re;break;case"":case"=":case"==":Ge=ne(de,Re,Ue);break;case"!=":Ge=ie(de,Re,Ue);break;case">":Ge=Y(de,Re,Ue);break;case">=":Ge=G(de,Re,Ue);break;case"<":Ge=pe(de,Re,Ue);break;case"<=":Ge=Z(de,Re,Ue);break;default:throw new TypeError("Invalid operator: "+Se)}return Ge}function we(de,Se){if(de instanceof we){if(de.loose===Se)return de;de=de.value}if(!(this instanceof we))return new we(de,Se);E("comparator",de,Se),this.loose=Se,this.parse(de),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}e.rcompareIdentifiers=function(de,Se){return M(Se,de)},e.major=function(de,Se){return new _(de,Se).major},e.minor=function(de,Se){return new _(de,Se).minor},e.patch=function(de,Se){return new _(de,Se).patch},e.compare=A,e.compareLoose=function(de,Se){return A(de,Se,!0)},e.rcompare=function(de,Se,Re){return A(Se,de,Re)},e.sort=function(de,Se){return de.sort(function(Re,Ue){return e.compare(Re,Ue,Se)})},e.rsort=function(de,Se){return de.sort(function(Re,Ue){return e.rcompare(Re,Ue,Se)})},e.gt=Y,e.lt=pe,e.eq=ne,e.neq=ie,e.gte=G,e.lte=Z,e.cmp=ce,e.Comparator=we;var Ie={};function Me(de,Se){if(de instanceof Me)return de.loose===Se?de:new Me(de.raw,Se);if(de instanceof we)return new Me(de.value,Se);if(!(this instanceof Me))return new Me(de,Se);if(this.loose=Se,this.raw=de,this.set=de.split(/\s*\|\|\s*/).map(function(Re){return this.parseRange(Re.trim())},this).filter(function(Re){return Re.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+de);this.format()}function Be(de){return!de||de.toLowerCase()==="x"||de==="*"}function De(de,Se,Re,Ue,Ge,Qe,Je,Xe,tt,st,dt,rt,ot){return((Se=Be(Re)?"":Be(Ue)?">="+Re+".0.0":Be(Ge)?">="+Re+"."+Ue+".0":">="+Se)+" "+(Xe=Be(tt)?"":Be(st)?"<"+(+tt+1)+".0.0":Be(dt)?"<"+tt+"."+(+st+1)+".0":rt?"<="+tt+"."+st+"."+dt+"-"+rt:"<="+Xe)).trim()}function Ne(de,Se){for(var Re=0;Re<de.length;Re++)if(!de[Re].test(Se))return!1;if(Se.prerelease.length){for(Re=0;Re<de.length;Re++)if(E(de[Re].semver),de[Re].semver!==Ie&&de[Re].semver.prerelease.length>0){var Ue=de[Re].semver;if(Ue.major===Se.major&&Ue.minor===Se.minor&&Ue.patch===Se.patch)return!0}return!1}return!0}function Te(de,Se,Re){try{Se=new Me(Se,Re)}catch{return!1}return Se.test(de)}function Ce(de,Se,Re,Ue){var Ge,Qe,Je,Xe,tt;switch(de=new _(de,Ue),Se=new Me(Se,Ue),Re){case">":Ge=Y,Qe=Z,Je=pe,Xe=">",tt=">=";break;case"<":Ge=pe,Qe=G,Je=Y,Xe="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(de,Se,Ue))return!1;for(var st=0;st<Se.set.length;++st){var dt=Se.set[st],rt=null,ot=null;if(dt.forEach(function(ut){ut.semver===Ie&&(ut=new we(">=0.0.0")),rt=rt||ut,ot=ot||ut,Ge(ut.semver,rt.semver,Ue)?rt=ut:Je(ut.semver,ot.semver,Ue)&&(ot=ut)}),rt.operator===Xe||rt.operator===tt||(!ot.operator||ot.operator===Xe)&&Qe(de,ot.semver)||ot.operator===tt&&Je(de,ot.semver))return!1}return!0}we.prototype.parse=function(de){var Se=this.loose?T[V]:T[B],Re=de.match(Se);if(!Re)throw new TypeError("Invalid comparator: "+de);this.operator=Re[1],this.operator==="="&&(this.operator=""),Re[2]?this.semver=new _(Re[2],this.loose):this.semver=Ie},we.prototype.toString=function(){return this.value},we.prototype.test=function(de){return E("Comparator.test",de,this.loose),this.semver===Ie||(typeof de=="string"&&(de=new _(de,this.loose)),ce(de,this.operator,this.semver,this.loose))},we.prototype.intersects=function(de,Se){if(!(de instanceof we))throw new TypeError("a Comparator is required");var Re;if(this.operator==="")return Re=new Me(de.value,Se),Te(this.value,Re,Se);if(de.operator==="")return Re=new Me(this.value,Se),Te(de.semver,Re,Se);var Ue=!(this.operator!==">="&&this.operator!==">"||de.operator!==">="&&de.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||de.operator!=="<="&&de.operator!=="<"),Qe=this.semver.version===de.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||de.operator!==">="&&de.operator!=="<="),Xe=ce(this.semver,"<",de.semver,Se)&&(this.operator===">="||this.operator===">")&&(de.operator==="<="||de.operator==="<"),tt=ce(this.semver,">",de.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(de.operator===">="||de.operator===">");return Ue||Ge||Qe&&Je||Xe||tt},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(de){return de.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(de){var Se=this.loose;de=de.trim(),E("range",de,Se);var Re=Se?T[te]:T[U];de=de.replace(Re,De),E("hyphen replace",de),de=de.replace(T[j],"$1$2$3"),E("comparator trim",de,T[j]),de=(de=(de=de.replace(T[z],"$1~")).replace(T[ve],"$1^")).split(/\s+/).join(" ");var Ue=Se?T[V]:T[B],Ge=de.split(" ").map(function(Qe){return function(Je,Xe){return E("comp",Je),Je=function(tt,st){return tt.trim().split(/\s+/).map(function(dt){return function(rt,ot){E("caret",rt,ot);var ut=ot?T[se]:T[be];return rt.replace(ut,function(Ye,me,H,ee,ge){var re;return E("caret",rt,Ye,me,H,ee,ge),Be(me)?re="":Be(H)?re=">="+me+".0.0 <"+(+me+1)+".0.0":Be(ee)?re=me==="0"?">="+me+"."+H+".0 <"+me+"."+(+H+1)+".0":">="+me+"."+H+".0 <"+(+me+1)+".0.0":ge?(E("replaceCaret pr",ge),ge.charAt(0)!=="-"&&(ge="-"+ge),re=me==="0"?H==="0"?">="+me+"."+H+"."+ee+ge+" <"+me+"."+H+"."+(+ee+1):">="+me+"."+H+"."+ee+ge+" <"+me+"."+(+H+1)+".0":">="+me+"."+H+"."+ee+ge+" <"+(+me+1)+".0.0"):(E("no pr"),re=me==="0"?H==="0"?">="+me+"."+H+"."+ee+" <"+me+"."+H+"."+(+ee+1):">="+me+"."+H+"."+ee+" <"+me+"."+(+H+1)+".0":">="+me+"."+H+"."+ee+" <"+(+me+1)+".0.0"),E("caret return",re),re})}(dt,st)}).join(" ")}(Je,Xe),E("caret",Je),Je=function(tt,st){return tt.trim().split(/\s+/).map(function(dt){return function(rt,ot){var ut=ot?T[J]:T[Q];return rt.replace(ut,function(Ye,me,H,ee,ge){var re;return E("tilde",rt,Ye,me,H,ee,ge),Be(me)?re="":Be(H)?re=">="+me+".0.0 <"+(+me+1)+".0.0":Be(ee)?re=">="+me+"."+H+".0 <"+me+"."+(+H+1)+".0":ge?(E("replaceTilde pr",ge),ge.charAt(0)!=="-"&&(ge="-"+ge),re=">="+me+"."+H+"."+ee+ge+" <"+me+"."+(+H+1)+".0"):re=">="+me+"."+H+"."+ee+" <"+me+"."+(+H+1)+".0",E("tilde return",re),re})}(dt,st)}).join(" ")}(Je,Xe),E("tildes",Je),Je=function(tt,st){return E("replaceXRanges",tt,st),tt.split(/\s+/).map(function(dt){return function(rt,ot){rt=rt.trim();var ut=ot?T[C]:T[O];return rt.replace(ut,function(Ye,me,H,ee,ge,re){E("xRange",rt,Ye,me,H,ee,ge,re);var fe=Be(H),W=fe||Be(ee),K=W||Be(ge);return me==="="&&K&&(me=""),fe?Ye=me===">"||me==="<"?"<0.0.0":"*":me&&K?(W&&(ee=0),K&&(ge=0),me===">"?(me=">=",W?(H=+H+1,ee=0,ge=0):K&&(ee=+ee+1,ge=0)):me==="<="&&(me="<",W?H=+H+1:ee=+ee+1),Ye=me+H+"."+ee+"."+ge):W?Ye=">="+H+".0.0 <"+(+H+1)+".0.0":K&&(Ye=">="+H+"."+ee+".0 <"+H+"."+(+ee+1)+".0"),E("xRange return",Ye),Ye})}(dt,st)}).join(" ")}(Je,Xe),E("xrange",Je),Je=function(tt,st){return E("replaceStars",tt,st),tt.trim().replace(T[le],"")}(Je,Xe),E("stars",Je),Je}(Qe,Se)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(Qe){return!!Qe.match(Ue)})),Ge=Ge.map(function(Qe){return new we(Qe,Se)})},Me.prototype.intersects=function(de,Se){if(!(de instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(Re){return Re.every(function(Ue){return de.set.some(function(Ge){return Ge.every(function(Qe){return Ue.intersects(Qe,Se)})})})})},e.toComparators=function(de,Se){return new Me(de,Se).set.map(function(Re){return Re.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(de){if(!de)return!1;typeof de=="string"&&(de=new _(de,this.loose));for(var Se=0;Se<this.set.length;Se++)if(Ne(this.set[Se],de))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(de,Se,Re){var Ue=null,Ge=null;try{var Qe=new Me(Se,Re)}catch{return null}return de.forEach(function(Je){Qe.test(Je)&&(Ue&&Ge.compare(Je)!==-1||(Ge=new _(Ue=Je,Re)))}),Ue},e.minSatisfying=function(de,Se,Re){var Ue=null,Ge=null;try{var Qe=new Me(Se,Re)}catch{return null}return de.forEach(function(Je){Qe.test(Je)&&(Ue&&Ge.compare(Je)!==1||(Ge=new _(Ue=Je,Re)))}),Ue},e.validRange=function(de,Se){try{return new Me(de,Se).range||"*"}catch{return null}},e.ltr=function(de,Se,Re){return Ce(de,Se,"<",Re)},e.gtr=function(de,Se,Re){return Ce(de,Se,">",Re)},e.outside=Ce,e.prerelease=function(de,Se){var Re=oe(de,Se);return Re&&Re.prerelease.length?Re.prerelease:null},e.intersects=function(de,Se,Re){return de=new Me(de,Re),Se=new Me(Se,Re),de.intersects(Se)},e.coerce=function(de){if(de instanceof _)return de;if(typeof de!="string")return null;var Se=de.match(T[L]);return Se==null?null:oe((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,t(1))},function(ue,e){var t,i,E=ue.exports={};function I(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function T(m){if(t===setTimeout)return setTimeout(m,0);if((t===I||!t)&&setTimeout)return t=setTimeout,setTimeout(m,0);try{return t(m,0)}catch{try{return t.call(null,m,0)}catch{return t.call(this,m,0)}}}(function(){try{t=typeof setTimeout=="function"?setTimeout:I}catch{t=I}try{i=typeof clearTimeout=="function"?clearTimeout:D}catch{i=D}})();var v,s=[],S=!1,y=-1;function p(){S&&v&&(S=!1,v.length?s=v.concat(s):y=-1,s.length&&$())}function $(){if(!S){var m=T(p);S=!0;for(var b=s.length;b;){for(v=s,s=[];++y<b;)v&&v[y].run();y=-1,b=s.length}v=null,S=!1,function(g){if(i===clearTimeout)return clearTimeout(g);if((i===D||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(g);try{i(g)}catch{try{return i.call(null,g)}catch{return i.call(this,g)}}}(m)}}function a(m,b){this.fun=m,this.array=b}function c(){}E.nextTick=function(m){var b=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)b[g-1]=arguments[g];s.push(new a(m,b)),s.length!==1||S||T($)},a.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=c,E.addListener=c,E.once=c,E.off=c,E.removeListener=c,E.removeAllListeners=c,E.emit=c,E.prependListener=c,E.prependOnceListener=c,E.listeners=function(m){return[]},E.binding=function(m){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(m){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(Oe[171],Le([1,0]),function(ue,e){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0;class i{constructor(T,v,s){this.level=T,this.key=v,this.value=s,this.forward=[]}}const E=void 0;class I{constructor(T,v=2**16){this.comparator=T,this[t]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new i(this.c,E,E)}get size(){return this.f}clear(){this.e=new i(this.c,E,E),this.f=0}has(T){return!!I.g(this,T,this.comparator)}get(T){return I.g(this,T,this.comparator)?.value}set(T,v){return I.h(this,T,v,this.comparator)&&(this.f+=1),this}delete(T){const v=I.k(this,T,this.comparator);return v&&(this.f-=1),v}forEach(T,v){let s=this.e.forward[0];for(;s;)T.call(v,s.value,s.key,this),s=s.forward[0]}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let T=this.e.forward[0];for(;T;)yield[T.key,T.value],T=T.forward[0]}*keys(){let T=this.e.forward[0];for(;T;)yield T.key,T=T.forward[0]}*values(){let T=this.e.forward[0];for(;T;)yield T.value,T=T.forward[0]}toString(){let T="[SkipList]:",v=this.e.forward[0];for(;v;)T+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return T}static g(T,v,s){let S=T.e;for(let y=T.d-1;y>=0;y--)for(;S.forward[y]&&s(S.forward[y].key,v)<0;)S=S.forward[y];if(S=S.forward[0],S&&s(S.key,v)===0)return S}static h(T,v,s,S){const y=[];let p=T.e;for(let $=T.d-1;$>=0;$--){for(;p.forward[$]&&S(p.forward[$].key,v)<0;)p=p.forward[$];y[$]=p}if(p=p.forward[0],p&&S(p.key,v)===0)return p.value=s,!1;{const $=I.j(T);if($>T.d){for(let a=T.d;a<$;a++)y[a]=T.e;T.d=$}p=new i($,v,s);for(let a=0;a<$;a++)p.forward[a]=y[a].forward[a],y[a].forward[a]=p;return!0}}static j(T,v=.5){let s=1;for(;Math.random()<v&&s<T.c;)s+=1;return s}static k(T,v,s){const S=[];let y=T.e;for(let p=T.d-1;p>=0;p--){for(;y.forward[p]&&s(y.forward[p].key,v)<0;)y=y.forward[p];S[p]=y}if(y=y.forward[0],!y||s(y.key,v)!==0)return!1;for(let p=0;p<T.d&&S[p].forward[p]===y;p++)S[p].forward[p]=y.forward[p];for(;T.d>0&&T.e.forward[T.d-1]===E;)T.d-=1;return!0}}e.$4s=I}),define(Oe[43],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=void 0;const t=globalThis.performance&&typeof globalThis.performance.now=="function";class i{static create(I){return new i(I)}constructor(I){this.c=t&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ke=i}),define(Oe[6],Le([1,0,9,80,2,81,43]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$me=e.Event=void 0,e.$ne=$;const T=!1,v=!1,s=!1;var S;(function(J){J.None=()=>E.$Zc.None;function x(Te){if(s){const{onDidAddListener:Ce}=Te,de=c.create();let Se=0;Te.onDidAddListener=()=>{++Se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),Ce?.()}}}function ve(Te,Ce){return _(Te,()=>{},0,void 0,!0,void 0,Ce)}J.defer=ve;function be(Te){return(Ce,de=null,Se)=>{let Re=!1,Ue;return Ue=Te(Ge=>{if(!Re)return Ue?Ue.dispose():Re=!0,Ce.call(de,Ge)},null,Se),Re&&Ue.dispose(),Ue}}J.once=be;function se(Te,Ce){return J.once(J.filter(Te,Ce))}J.onceIf=se;function V(Te,Ce,de){return ye((Se,Re=null,Ue)=>Te(Ge=>Se.call(Re,Ce(Ge)),null,Ue),de)}J.map=V;function B(Te,Ce,de){return ye((Se,Re=null,Ue)=>Te(Ge=>{Ce(Ge),Se.call(Re,Ge)},null,Ue),de)}J.forEach=B;function j(Te,Ce,de){return ye((Se,Re=null,Ue)=>Te(Ge=>Ce(Ge)&&Se.call(Re,Ge),null,Ue),de)}J.filter=j;function U(Te){return Te}J.signal=U;function te(...Te){return(Ce,de=null,Se)=>{const Re=(0,E.$Wc)(...Te.map(Ue=>Ue(Ge=>Ce.call(de,Ge))));return oe(Re,Se)}}J.any=te;function le(Te,Ce,de,Se){let Re=de;return V(Te,Ue=>(Re=Ce(Re,Ue),Re),Se)}J.reduce=le;function ye(Te,Ce){let de;const Se={onWillAddFirstListener(){de=Te(Re.fire,Re)},onDidRemoveLastListener(){de?.dispose()}};Ce||x(Se);const Re=new n(Se);return Ce?.add(Re),Re.event}function oe(Te,Ce){return Ce instanceof Array?Ce.push(Te):Ce&&Ce.add(Te),Te}function _(Te,Ce,de=100,Se=!1,Re=!1,Ue,Ge){let Qe,Je,Xe,tt=0,st;const dt={leakWarningThreshold:Ue,onWillAddFirstListener(){Qe=Te(ot=>{tt++,Je=Ce(Je,ot),Se&&!Xe&&(rt.fire(Je),Je=void 0),st=()=>{const ut=Je;Je=void 0,Xe=void 0,(!Se||tt>1)&&rt.fire(ut),tt=0},typeof de=="number"?(clearTimeout(Xe),Xe=setTimeout(st,de)):Xe===void 0&&(Xe=0,queueMicrotask(st))})},onWillRemoveListener(){Re&&tt>0&&st?.()},onDidRemoveLastListener(){st=void 0,Qe.dispose()}};Ge||x(dt);const rt=new n(dt);return Ge?.add(rt),rt.event}J.debounce=_;function X(Te,Ce=0,de){return J.debounce(Te,(Se,Re)=>Se?(Se.push(Re),Se):[Re],Ce,void 0,!0,void 0,de)}J.accumulate=X;function M(Te,Ce=(Se,Re)=>Se===Re,de){let Se=!0,Re;return j(Te,Ue=>{const Ge=Se||!Ce(Ue,Re);return Se=!1,Re=Ue,Ge},de)}J.latch=M;function A(Te,Ce,de){return[J.filter(Te,Ce,de),J.filter(Te,Se=>!Ce(Se),de)]}J.split=A;function Y(Te,Ce=!1,de=[],Se){let Re=de.slice(),Ue=Te(Je=>{Re?Re.push(Je):Qe.fire(Je)});Se&&Se.add(Ue);const Ge=()=>{Re?.forEach(Je=>Qe.fire(Je)),Re=null},Qe=new n({onWillAddFirstListener(){Ue||(Ue=Te(Je=>Qe.fire(Je)),Se&&Se.add(Ue))},onDidAddFirstListener(){Re&&(Ce?setTimeout(Ge):Ge())},onDidRemoveLastListener(){Ue&&Ue.dispose(),Ue=null}});return Se&&Se.add(Qe),Qe.event}J.buffer=Y;function pe(Te,Ce){return(Se,Re,Ue)=>{const Ge=Ce(new ie);return Te(function(Qe){const Je=Ge.evaluate(Qe);Je!==ne&&Se.call(Re,Je)},void 0,Ue)}}J.chain=pe;const ne=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(Ce){return this.f.push(Ce),this}forEach(Ce){return this.f.push(de=>(Ce(de),de)),this}filter(Ce){return this.f.push(de=>Ce(de)?de:ne),this}reduce(Ce,de){let Se=de;return this.f.push(Re=>(Se=Ce(Se,Re),Se)),this}latch(Ce=(de,Se)=>de===Se){let de=!0,Se;return this.f.push(Re=>{const Ue=de||!Ce(Re,Se);return de=!1,Se=Re,Ue?Re:ne}),this}evaluate(Ce){for(const de of this.f)if(Ce=de(Ce),Ce===ne)break;return Ce}}function G(Te,Ce,de=Se=>Se){const Se=(...Qe)=>Ge.fire(de(...Qe)),Re=()=>Te.on(Ce,Se),Ue=()=>Te.removeListener(Ce,Se),Ge=new n({onWillAddFirstListener:Re,onDidRemoveLastListener:Ue});return Ge.event}J.fromNodeEventEmitter=G;function Z(Te,Ce,de=Se=>Se){const Se=(...Qe)=>Ge.fire(de(...Qe)),Re=()=>Te.addEventListener(Ce,Se),Ue=()=>Te.removeEventListener(Ce,Se),Ge=new n({onWillAddFirstListener:Re,onDidRemoveLastListener:Ue});return Ge.event}J.fromDOMEventEmitter=Z;function ce(Te){return new Promise(Ce=>be(Te)(Ce))}J.toPromise=ce;function we(Te){const Ce=new n;return Te.then(de=>{Ce.fire(de)},()=>{Ce.fire(void 0)}).finally(()=>{Ce.dispose()}),Ce.event}J.fromPromise=we;function Ie(Te,Ce){return Te(de=>Ce.fire(de))}J.forward=Ie;function Me(Te,Ce,de){return Ce(de),Te(Se=>Ce(Se))}J.runAndSubscribe=Me;class Be{constructor(Ce,de){this._observable=Ce,this.f=0,this.g=!1;const Se={onWillAddFirstListener:()=>{Ce.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{Ce.removeObserver(this)}};de||x(Se),this.emitter=new n(Se),de&&de.add(this.emitter)}beginUpdate(Ce){this.f++}handlePossibleChange(Ce){}handleChange(Ce,de){this.g=!0}endUpdate(Ce){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function De(Te,Ce){return new Be(Te,Ce).emitter.event}J.fromObservable=De;function Ne(Te){return(Ce,de,Se)=>{let Re=0,Ue=!1;const Ge={beginUpdate(){Re++},endUpdate(){Re--,Re===0&&(Te.reportChanges(),Ue&&(Ue=!1,Ce.call(de)))},handlePossibleChange(){},handleChange(){Ue=!0}};Te.addObserver(Ge),Te.reportChanges();const Qe={dispose(){Te.removeObserver(Ge)}};return Se instanceof E.$Yc?Se.add(Qe):Array.isArray(Se)&&Se.push(Qe),Qe}}J.fromObservableLight=Ne})(S||(e.Event=S={}));class y{static{this.all=new Set}static{this.f=0}constructor(x){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${x}_${y.f++}`,y.all.add(this)}start(x){this.g=new D.$ke,this.listenerCount=x}stop(){if(this.g){const x=this.g.elapsed();this.durations.push(x),this.elapsedOverall+=x,this.invocationCount+=1,this.g=void 0}}}e.$me=y;let p=-1;function $(J){const x=p;return p=J,{dispose(){p=x}}}class a{static{this.f=1}constructor(x,ve,be=(a.f++).toString(16).padStart(3,"0")){this.j=x,this.threshold=ve,this.name=be,this.h=0}dispose(){this.g?.clear()}check(x,ve){const be=this.threshold;if(be<=0||ve<be)return;this.g||(this.g=new Map);const se=this.g.get(x.value)||0;if(this.g.set(x.value,se+1),this.h-=1,this.h<=0){this.h=be*.5;const[V,B]=this.getMostFrequentStack(),j=`[${this.name}] potential listener LEAK detected, having ${ve} listeners already. MOST frequent listener (${B}):`;console.warn(j),console.warn(V);const U=new m(j,V);this.j(U)}return()=>{const V=this.g.get(x.value)||0;this.g.set(x.value,V-1)}}getMostFrequentStack(){if(!this.g)return;let x,ve=0;for(const[be,se]of this.g)(!x||ve<se)&&(x=[be,se],ve=se);return x}}class c{static create(){const x=new Error;return new c(x.stack??"")}constructor(x){this.value=x}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(x,ve){super(x),this.name="ListenerLeakError",this.stack=ve}}e.$oe=m;class b extends Error{constructor(x,ve){super(x),this.name="ListenerRefusalError",this.stack=ve}}e.$pe=b;let g=0;class d{constructor(x){this.value=x,this.id=g++}}const w=2,o=(J,x)=>{if(J instanceof d)x(J);else for(let ve=0;ve<J.length;ve++){const be=J[ve];be&&x(be)}};let l;if(T){const J=[];setInterval(()=>{J.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(J.join(`
`)),J.length=0)},3e3),l=new FinalizationRegistry(x=>{typeof x=="string"&&J.push(x)})}class n{constructor(x){this.z=0,this.f=x,this.g=p>0||this.f?.leakWarningThreshold?new a(x?.onListenerError??t.$4,this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(v){const x=this.u;queueMicrotask(()=>{o(x,ve=>ve.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(x,ve,be)=>{if(this.g&&this.z>this.g.threshold**2){const U=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(U);const te=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],le=new b(`${U}. HINT: Stack shows most frequent listener (${te[1]}-times)`,te[0]);return(this.f?.onListenerError||t.$4)(le),E.$Zc.None}if(this.m)return E.$Zc.None;ve&&(x=x.bind(ve));const se=new d(x);let V,B;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(se.stack=c.create(),V=this.g.check(se.stack,this.z+1)),v&&(se.stack=B??c.create()),this.u?this.u instanceof d?(this.w??=new r,this.u=[this.u,se]):this.u.push(se):(this.f?.onWillAddFirstListener?.(this),this.u=se,this.f?.onDidAddFirstListener?.(this)),this.z++;const j=(0,E.$Xc)(()=>{l?.unregister(j),V?.(),this.A(se)});if(be instanceof E.$Yc?be.add(j):Array.isArray(be)&&be.push(j),l){const U=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),te=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(U);l.register(j,te?.[2]??U,j)}return j},this.q}A(x){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const ve=this.u,be=ve.indexOf(x);if(be===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,ve[be]=void 0;const se=this.w.current===this;if(this.z*w<=ve.length){let V=0;for(let B=0;B<ve.length;B++)ve[B]?ve[V++]=ve[B]:se&&(this.w.end--,V<this.w.i&&this.w.i--);ve.length=V}}B(x,ve){if(!x)return;const be=this.f?.onListenerError||t.$4;if(!be){x.value(ve);return}try{x.value(ve)}catch(se){be(se)}}C(x){const ve=x.current.u;for(;x.i<x.end;)this.B(ve[x.i++],x.value);x.reset()}fire(x){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof d)this.B(this.u,x);else{const ve=this.w;ve.enqueue(this,x,this.u.length),this.C(ve)}this.j?.stop()}hasListeners(){return this.z>0}}e.$qe=n;const u=()=>new r;e.$re=u;class r{constructor(){this.i=-1,this.end=0}enqueue(x,ve,be){this.i=0,this.end=be,this.current=x,this.value=ve}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class f extends n{async fireAsync(x,ve,be){if(this.u)for(this.h||(this.h=new I.$0c),o(this.u,se=>this.h.push([se.value,x]));this.h.size>0&&!ve.isCancellationRequested;){const[se,V]=this.h.shift(),B=[],j={...V,token:ve,waitUntil:U=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");be&&(U=be(U,se)),B.push(U)}};try{se(j)}catch(U){(0,t.$4)(U);continue}Object.freeze(B),await Promise.allSettled(B).then(U=>{for(const te of U)te.status==="rejected"&&(0,t.$4)(te.reason)})}}}e.$se=f;class h extends n{get isPaused(){return this.h!==0}constructor(x){super(x),this.h=0,this.s=new I.$0c,this.t=x?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const x=Array.from(this.s);this.s.clear(),super.fire(this.t(x))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(x){this.z&&(this.h!==0?this.s.push(x):super.fire(x))}}e.$te=h;class k extends h{constructor(x){super(x),this.k=x.delay??100}fire(x){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(x)}}e.$ue=k;class P extends n{constructor(x){super(x),this.h=[],this.k=x?.merge}fire(x){this.hasListeners()&&(this.h.push(x),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ve=>super.fire(ve)),this.h=[]}))}}e.$ve=P;class O{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(x){const ve={event:x,listener:null};this.h.push(ve),this.g&&this.m(ve);const be=()=>{this.g&&this.o(ve);const se=this.h.indexOf(ve);this.h.splice(se,1)};return(0,E.$Xc)((0,i.$hb)(be))}j(){this.g=!0,this.h.forEach(x=>this.m(x))}k(){this.g=!1,this.h.forEach(x=>this.o(x))}m(x){x.listener=x.event(ve=>this.f.fire(ve))}o(x){x.listener?.dispose(),x.listener=null}dispose(){this.f.dispose();for(const x of this.h)x.listener?.dispose();this.h=[]}}e.$we=O;class C{constructor(x,ve,be,se){this.f=new E.$Yc;const V=this.f.add(new O),B=this.f.add(new E.$9c);function j(U){B.set(U,V.add(se(U)))}for(const U of x)j(U);this.f.add(ve(U=>{j(U)})),this.f.add(be(U=>{B.deleteAndDispose(U)})),this.event=V.event}dispose(){this.f.dispose()}}e.$xe=C;class L{constructor(){this.f=[]}wrapEvent(x,ve,be){return(se,V,B)=>x(j=>{const U=this.f[this.f.length-1];if(!ve){U?U.buffers.push(()=>se.call(V,j)):se.call(V,j);return}const te=U;if(!te){se.call(V,ve(be,j));return}te.items??=[],te.items.push(j),te.buffers.length===0&&U.buffers.push(()=>{te.reducedResult??=be?te.items.reduce(ve,be):te.items.reduce(ve),se.call(V,te.reducedResult)})},void 0,B)}bufferEvents(x){const ve={buffers:new Array};this.f.push(ve);const be=x();return this.f.pop(),ve.buffers.forEach(se=>se()),be}}e.$ye=L;class R{constructor(){this.f=!1,this.g=S.None,this.h=E.$Zc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(x){this.g=x,this.f&&(this.h.dispose(),this.h=x(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ze=R;class z{static const(x){return new Q(x)}constructor(x){this.g=x,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(x){x!==this.g&&(this.g=x,this.f.fire(void 0))}}e.$Ae=z;class Q{constructor(x){this.value=x,this.onDidChange=S.None}}}),define(Oe[18],Le([1,0,6]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.CancellationToken=void 0,e.$Ce=T;const i=Object.freeze(function(v,s){const S=setTimeout(v.bind(s),0);return{dispose(){clearTimeout(S)}}});var E;(function(v){function s(S){return S===v.None||S===v.Cancelled||S instanceof I?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}v.isCancellationToken=s,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:t.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(E||(e.CancellationToken=E={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new t.$qe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(s){this.f=void 0,this.g=void 0,this.g=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=E.Cancelled}dispose(s=!1){s&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=E.None}}e.$Be=D;function T(v){const s=new D;return v.add({dispose(){s.cancel()}}),s.token}}),define(Oe[172],Le([1,0,18]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ef=e.$df=e.$bf=void 0,e.$cf=E;class i{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new t.$Be,s=this.b(v.token);return this.a={promise:s,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}e.$bf=i;function E(T){return T}class I{constructor(v,s){this.a=void 0,this.b=void 0,typeof v=="function"?(this.c=v,this.d=E):(this.c=s,this.d=v.getCacheKey)}get(v){const s=this.d(v);return this.b!==s&&(this.b=s,this.a=this.c(v)),this.a}}e.$df=I;class D{get cachedValues(){return this.a}constructor(v,s){this.a=new Map,this.b=new Map,typeof v=="function"?(this.c=v,this.d=E):(this.c=s,this.d=v.getCacheKey)}get(v){const s=this.d(v);if(this.b.has(s))return this.b.get(s);const S=this.c(v);return this.a.set(v,S),this.b.set(s,S),S}}e.$ef=D}),define(Oe[173],Le([1,0,6,2]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.$ot=e.$nt=e.ScrollbarVisibility=void 0;var E;(function($){$[$.Auto=1]="Auto",$[$.Hidden=2]="Hidden",$[$.Visible=3]="Visible"})(E||(e.ScrollbarVisibility=E={}));class I{constructor(a,c,m,b,g,d,w){this.c=a,this._scrollStateBrand=void 0,this.c&&(c=c|0,m=m|0,b=b|0,g=g|0,d=d|0,w=w|0),this.rawScrollLeft=b,this.rawScrollTop=w,c<0&&(c=0),b+c>m&&(b=m-c),b<0&&(b=0),g<0&&(g=0),w+g>d&&(w=d-g),w<0&&(w=0),this.width=c,this.scrollWidth=m,this.scrollLeft=b,this.height=g,this.scrollHeight=d,this.scrollTop=w}equals(a){return this.rawScrollLeft===a.rawScrollLeft&&this.rawScrollTop===a.rawScrollTop&&this.width===a.width&&this.scrollWidth===a.scrollWidth&&this.scrollLeft===a.scrollLeft&&this.height===a.height&&this.scrollHeight===a.scrollHeight&&this.scrollTop===a.scrollTop}withScrollDimensions(a,c){return new I(this.c,typeof a.width<"u"?a.width:this.width,typeof a.scrollWidth<"u"?a.scrollWidth:this.scrollWidth,c?this.rawScrollLeft:this.scrollLeft,typeof a.height<"u"?a.height:this.height,typeof a.scrollHeight<"u"?a.scrollHeight:this.scrollHeight,c?this.rawScrollTop:this.scrollTop)}withScrollPosition(a){return new I(this.c,this.width,this.scrollWidth,typeof a.scrollLeft<"u"?a.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof a.scrollTop<"u"?a.scrollTop:this.rawScrollTop)}createScrollEvent(a,c){const m=this.width!==a.width,b=this.scrollWidth!==a.scrollWidth,g=this.scrollLeft!==a.scrollLeft,d=this.height!==a.height,w=this.scrollHeight!==a.scrollHeight,o=this.scrollTop!==a.scrollTop;return{inSmoothScrolling:c,oldWidth:a.width,oldScrollWidth:a.scrollWidth,oldScrollLeft:a.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:a.height,oldScrollHeight:a.scrollHeight,oldScrollTop:a.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:b,scrollLeftChanged:g,heightChanged:d,scrollHeightChanged:w,scrollTopChanged:o}}}e.$nt=I;class D extends i.$Zc{constructor(a){super(),this._scrollableBrand=void 0,this.j=this.B(new t.$qe),this.onScroll=this.j.event,this.c=a.smoothScrollDuration,this.f=a.scheduleAtNextAnimationFrame,this.g=new I(a.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(a){this.c=a}validateScrollPosition(a){return this.g.withScrollPosition(a)}getScrollDimensions(){return this.g}setScrollDimensions(a,c){const m=this.g.withScrollDimensions(a,c);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(a){const c=this.g.withScrollPosition(a);this.h&&(this.h.dispose(),this.h=null),this.n(c,!1)}setScrollPositionSmooth(a,c){if(this.c===0)return this.setScrollPositionNow(a);if(this.h){a={scrollLeft:typeof a.scrollLeft>"u"?this.h.to.scrollLeft:a.scrollLeft,scrollTop:typeof a.scrollTop>"u"?this.h.to.scrollTop:a.scrollTop};const m=this.g.withScrollPosition(a);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let b;c?b=new S(this.h.from,m,this.h.startTime,this.h.duration):b=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=b}else{const m=this.g.withScrollPosition(a);this.h=S.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const a=this.h.tick(),c=this.g.withScrollPosition(a);if(this.n(c,!0),!!this.h){if(a.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(a,c){const m=this.g;m.equals(a)||(this.g=a,this.j.fire(this.g.createScrollEvent(m,c)))}}e.$ot=D;class T{constructor(a,c,m){this.scrollLeft=a,this.scrollTop=c,this.isDone=m}}e.$pt=T;function v($,a){const c=a-$;return function(m){return $+c*p(m)}}function s($,a,c){return function(m){return m<c?$(m/c):a((m-c)/(1-c))}}class S{constructor(a,c,m,b){this.from=a,this.to=c,this.duration=b,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(a,c,m){if(Math.abs(a-c)>2.5*m){let g,d;return a<c?(g=a+.75*m,d=c-.75*m):(g=a-.75*m,d=c+.75*m),s(v(a,g),v(d,c),.33)}return v(a,c)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(a){this.to=a.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(a){const c=(a-this.startTime)/this.duration;if(c<1){const m=this.c(c),b=this.d(c);return new T(m,b,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(a,c,m){return S.start(a,c,m)}static start(a,c,m){m=m+10;const b=Date.now()-10;return new S(a,c,b,m)}}e.$qt=S;function y($){return Math.pow($,3)}function p($){return 1-y(1-$)}}),define(Oe[56],Le([1,0,9,2]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=E,e.$Ee=I,e.$Fe=D,e.$Ge=T,e.$He=s,e.$Ie=S,e.$Je=y,e.$Ke=p,e.$Le=$,e.$Me=a,e.$Ne=c,e.$Oe=m,e.$Pe=b,e.$Qe=g,e.$Re=d;function E(w){const o=w;return o?typeof o.read=="function":!1}function I(w){const o=w;return o?[o.on,o.pause,o.resume,o.destroy].every(l=>typeof l=="function"):!1}function D(w){const o=w;return o?I(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function T(w,o){return new v(w,o)}class v{constructor(o,l){this.e=o,this.f=l,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(l=>this.d.push(l))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(l=>l(o))}h(o){this.c.error.length===0?(0,t.$4)(o):this.c.error.slice(0).forEach(l=>l(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,l){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(l),this.resume();break;case"end":this.c.end.push(l),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(l),this.a.flowing&&this.k();break}}removeListener(o,l){if(this.a.destroyed)return;let n;switch(o){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const u=n.indexOf(l);u>=0&&n.splice(u,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const l=[...this.d];this.d.length=0,l.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(w,o){const l=[];let n;for(;(n=w.read())!==null;)l.push(n);return o(l)}function S(w,o,l){const n=[];let u;for(;(u=w.read())!==null&&n.length<l;)n.push(u);return u===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof u<"u"){const r=u;return u=void 0,r}return w.read()}}}function y(w,o){return new Promise((l,n)=>{const u=[];p(w,{onData:r=>{o&&u.push(r)},onError:r=>{o?n(r):l(void 0)},onEnd:()=>{l(o?o(u):void 0)}})})}function p(w,o,l){w.on("error",n=>{l?.isCancellationRequested||o.onError(n)}),w.on("end",()=>{l?.isCancellationRequested||o.onEnd()}),w.on("data",n=>{l?.isCancellationRequested||o.onData(n)})}function $(w,o){return new Promise((l,n)=>{const u=new i.$Yc,r=[],f=P=>{if(r.push(P),r.length>o)return u.dispose(),w.pause(),l({stream:w,buffer:r,ended:!1})},h=P=>(u.dispose(),n(P)),k=()=>(u.dispose(),l({stream:w,buffer:r,ended:!0}));u.add((0,i.$Xc)(()=>w.removeListener("error",h))),w.on("error",h),u.add((0,i.$Xc)(()=>w.removeListener("end",k))),w.on("end",k),u.add((0,i.$Xc)(()=>w.removeListener("data",f))),w.on("data",f)})}function a(w,o){const l=T(o);return l.end(w),l}function c(){const w=T(()=>{throw new Error("not supported")});return w.end(),w}function m(w){let o=!1;return{read:()=>o?null:(o=!0,w)}}function b(w,o,l){const n=T(l);return p(w,{onData:u=>n.write(o.data(u)),onError:u=>n.error(o.error?o.error(u):u),onEnd:()=>n.end()}),n}function g(w,o,l){let n=!1;return{read:()=>{const u=o.read();return n?u:(n=!0,u!==null?l([w,u]):w)}}}function d(w,o,l){let n=!1;const u=T(l);return p(o,{onData:r=>n?u.write(r):(n=!0,u.write(l([w,r]))),onError:r=>u.error(r),onEnd:()=>{n||(n=!0,u.write(w)),u.end()}}),u}}),define(Oe[14],Le([1,0,66,56]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=void 0,e.$Te=s,e.$Ue=S,e.$Ve=y,e.$We=p,e.$Xe=$,e.$Ye=a,e.$Ze=c,e.$1e=m,e.$2e=b,e.$3e=g,e.$4e=d,e.$5e=w,e.$6e=o,e.$7e=l,e.$8e=n,e.$9e=u,e.$0e=r,e.$$e=f,e.$_e=h,e.$af=O,i=We(i);const E=typeof Buffer<"u",I=new t.$Y(()=>new Uint8Array(256));let D,T;class v{static alloc(L){return E?new v(Buffer.allocUnsafe(L)):new v(new Uint8Array(L))}static wrap(L){return E&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new v(L)}static fromString(L,R){return!(R?.dontUseNodeBuffer||!1)&&E?new v(Buffer.from(L)):(D||(D=new TextEncoder),new v(D.encode(L)))}static fromByteArray(L){const R=v.alloc(L.length);for(let z=0,Q=L.length;z<Q;z++)R.buffer[z]=L[z];return R}static concat(L,R){if(typeof R>"u"){R=0;for(let J=0,x=L.length;J<x;J++)R+=L[J].byteLength}const z=v.alloc(R);let Q=0;for(let J=0,x=L.length;J<x;J++){const ve=L[J];z.set(ve,Q),Q+=ve.byteLength}return z}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=v.alloc(this.byteLength);return L.set(this),L}toString(){return E?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(L,R){return new v(this.buffer.subarray(L,R))}set(L,R){if(L instanceof v)this.buffer.set(L.buffer,R);else if(L instanceof Uint8Array)this.buffer.set(L,R);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),R);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return p(this.buffer,L)}writeUInt32BE(L,R){$(this.buffer,L,R)}readUInt32LE(L){return a(this.buffer,L)}writeUInt32LE(L,R){c(this.buffer,L,R)}readUInt8(L){return m(this.buffer,L)}writeUInt8(L,R){b(this.buffer,L,R)}indexOf(L,R=0){return s(this.buffer,L instanceof v?L.buffer:L,R)}}e.$Se=v;function s(C,L,R=0){const z=L.byteLength,Q=C.byteLength;if(z===0)return 0;if(z===1)return C.indexOf(L[0]);if(z>Q-R)return-1;const J=I.value;J.fill(L.length);for(let se=0;se<L.length;se++)J[L[se]]=L.length-se-1;let x=R+L.length-1,ve=x,be=-1;for(;x<Q;)if(C[x]===L[ve]){if(ve===0){be=x;break}x--,ve--}else x+=Math.max(L.length-ve,J[C[x]]),ve=L.length-1;return be}function S(C,L){return C[L+0]<<0>>>0|C[L+1]<<8>>>0}function y(C,L,R){C[R+0]=L&255,L=L>>>8,C[R+1]=L&255}function p(C,L){return C[L]*2**24+C[L+1]*2**16+C[L+2]*2**8+C[L+3]}function $(C,L,R){C[R+3]=L,L=L>>>8,C[R+2]=L,L=L>>>8,C[R+1]=L,L=L>>>8,C[R]=L}function a(C,L){return C[L+0]<<0>>>0|C[L+1]<<8>>>0|C[L+2]<<16>>>0|C[L+3]<<24>>>0}function c(C,L,R){C[R+0]=L&255,L=L>>>8,C[R+1]=L&255,L=L>>>8,C[R+2]=L&255,L=L>>>8,C[R+3]=L&255}function m(C,L){return C[L]}function b(C,L,R){C[R]=L}function g(C){return i.$He(C,L=>v.concat(L))}function d(C){return i.$Oe(C)}function w(C){return i.$Je(C,L=>v.concat(L))}async function o(C){return C.ended?v.concat(C.buffer):v.concat([...C.buffer,await w(C.stream)])}function l(C){return i.$Me(C,L=>v.concat(L))}function n(C){return i.$Pe(C,{data:L=>typeof L=="string"?v.fromString(L):v.wrap(L)},L=>v.concat(L))}function u(C){return i.$Ge(L=>v.concat(L),C)}function r(C,L){return i.$Qe(C,L,R=>v.concat(R))}function f(C,L){return i.$Re(C,L,R=>v.concat(R))}function h(C){let L=0,R=0,z=0;const Q=new Uint8Array(Math.floor(C.length/4*3)),J=ve=>{switch(R){case 3:Q[z++]=L|ve,R=0;break;case 2:Q[z++]=L|ve>>>2,L=ve<<6,R=3;break;case 1:Q[z++]=L|ve>>>4,L=ve<<4,R=2;break;default:L=ve<<2,R=1}};for(let ve=0;ve<C.length;ve++){const be=C.charCodeAt(ve);if(be>=65&&be<=90)J(be-65);else if(be>=97&&be<=122)J(be-97+26);else if(be>=48&&be<=57)J(be-48+52);else if(be===43||be===45)J(62);else if(be===47||be===95)J(63);else{if(be===61)break;throw new SyntaxError(`Unexpected base64 character ${C[ve]}`)}}const x=z;for(;R>0;)J(0);return v.wrap(Q).slice(0,x)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:C},L=!0,R=!1){const z=R?P:k;let Q="";const J=C.byteLength%3;let x=0;for(;x<C.byteLength-J;x+=3){const ve=C[x+0],be=C[x+1],se=C[x+2];Q+=z[ve>>>2],Q+=z[(ve<<4|be>>>4)&63],Q+=z[(be<<2|se>>>6)&63],Q+=z[se&63]}if(J===1){const ve=C[x+0];Q+=z[ve>>>2],Q+=z[ve<<4&63],L&&(Q+="==")}else if(J===2){const ve=C[x+0],be=C[x+1];Q+=z[ve>>>2],Q+=z[(ve<<4|be>>>4)&63],Q+=z[be<<2&63],L&&(Q+="=")}return Q}}),define(Oe[174],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=void 0,e.$le=Symbol("MicrotaskDelay")}),define(Oe[10],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=t,e.$kg=i,e.$lg=E,e.$mg=I,e.$ng=D,e.$og=T,e.$pg=v,e.$qg=s,e.$rg=S,e.$sg=y,e.$tg=p,e.$ug=$,e.$vg=a,e.$wg=m,e.$xg=b,e.$yg=g,e.$zg=d,e.$Ag=w,e.$Bg=o;function t(l){return typeof l=="string"}function i(l){return Array.isArray(l)&&l.every(n=>t(n))}function E(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function I(l){const n=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof n}function D(l){return typeof l=="number"&&!isNaN(l)}function T(l){return!!l&&typeof l[Symbol.iterator]=="function"}function v(l){return l===!0||l===!1}function s(l){return typeof l>"u"}function S(l){return!y(l)}function y(l){return s(l)||l===null}function p(l,n){if(!l)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function $(l){if(y(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function a(...l){const n=[];for(let u=0;u<l.length;u++){const r=l[u];if(y(r))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);n.push(r)}return n}const c=Object.prototype.hasOwnProperty;function m(l){if(!E(l))return!1;for(const n in l)if(c.call(l,n))return!1;return!0}function b(l){return typeof l=="function"}function g(...l){return l.length>0&&l.every(b)}function d(l,n){const u=Math.min(l.length,n.length);for(let r=0;r<u;r++)w(l[r],n[r])}function w(l,n){if(t(n)){if(typeof l!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(b(n)){try{if(l instanceof n)return}catch{}if(!y(l)&&l.constructor===n||n.length===1&&n.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function o(l){return l}}),define(Oe[108],Le([1,0,10]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=E,e.$6j=I;const i=Object.create(null);function E(D,T){if((0,t.$jg)(T)){const v=i[T];if(v===void 0)throw new Error(`${D} references an unknown codicon: ${T}`);T=v}return i[D]=T,{id:D}}function I(){return i}}),define(Oe[175],Le([1,0,108]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=void 0,e.$7j={add:(0,t.$5j)("add",6e4),plus:(0,t.$5j)("plus",6e4),gistNew:(0,t.$5j)("gist-new",6e4),repoCreate:(0,t.$5j)("repo-create",6e4),lightbulb:(0,t.$5j)("lightbulb",60001),lightBulb:(0,t.$5j)("light-bulb",60001),repo:(0,t.$5j)("repo",60002),repoDelete:(0,t.$5j)("repo-delete",60002),gistFork:(0,t.$5j)("gist-fork",60003),repoForked:(0,t.$5j)("repo-forked",60003),gitPullRequest:(0,t.$5j)("git-pull-request",60004),gitPullRequestAbandoned:(0,t.$5j)("git-pull-request-abandoned",60004),recordKeys:(0,t.$5j)("record-keys",60005),keyboard:(0,t.$5j)("keyboard",60005),tag:(0,t.$5j)("tag",60006),gitPullRequestLabel:(0,t.$5j)("git-pull-request-label",60006),tagAdd:(0,t.$5j)("tag-add",60006),tagRemove:(0,t.$5j)("tag-remove",60006),person:(0,t.$5j)("person",60007),personFollow:(0,t.$5j)("person-follow",60007),personOutline:(0,t.$5j)("person-outline",60007),personFilled:(0,t.$5j)("person-filled",60007),gitBranch:(0,t.$5j)("git-branch",60008),gitBranchCreate:(0,t.$5j)("git-branch-create",60008),gitBranchDelete:(0,t.$5j)("git-branch-delete",60008),sourceControl:(0,t.$5j)("source-control",60008),mirror:(0,t.$5j)("mirror",60009),mirrorPublic:(0,t.$5j)("mirror-public",60009),star:(0,t.$5j)("star",60010),starAdd:(0,t.$5j)("star-add",60010),starDelete:(0,t.$5j)("star-delete",60010),starEmpty:(0,t.$5j)("star-empty",60010),comment:(0,t.$5j)("comment",60011),commentAdd:(0,t.$5j)("comment-add",60011),alert:(0,t.$5j)("alert",60012),warning:(0,t.$5j)("warning",60012),search:(0,t.$5j)("search",60013),searchSave:(0,t.$5j)("search-save",60013),logOut:(0,t.$5j)("log-out",60014),signOut:(0,t.$5j)("sign-out",60014),logIn:(0,t.$5j)("log-in",60015),signIn:(0,t.$5j)("sign-in",60015),eye:(0,t.$5j)("eye",60016),eyeUnwatch:(0,t.$5j)("eye-unwatch",60016),eyeWatch:(0,t.$5j)("eye-watch",60016),circleFilled:(0,t.$5j)("circle-filled",60017),primitiveDot:(0,t.$5j)("primitive-dot",60017),closeDirty:(0,t.$5j)("close-dirty",60017),debugBreakpoint:(0,t.$5j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,t.$5j)("debug-breakpoint-disabled",60017),debugHint:(0,t.$5j)("debug-hint",60017),terminalDecorationSuccess:(0,t.$5j)("terminal-decoration-success",60017),primitiveSquare:(0,t.$5j)("primitive-square",60018),edit:(0,t.$5j)("edit",60019),pencil:(0,t.$5j)("pencil",60019),info:(0,t.$5j)("info",60020),issueOpened:(0,t.$5j)("issue-opened",60020),gistPrivate:(0,t.$5j)("gist-private",60021),gitForkPrivate:(0,t.$5j)("git-fork-private",60021),lock:(0,t.$5j)("lock",60021),mirrorPrivate:(0,t.$5j)("mirror-private",60021),close:(0,t.$5j)("close",60022),removeClose:(0,t.$5j)("remove-close",60022),x:(0,t.$5j)("x",60022),repoSync:(0,t.$5j)("repo-sync",60023),sync:(0,t.$5j)("sync",60023),clone:(0,t.$5j)("clone",60024),desktopDownload:(0,t.$5j)("desktop-download",60024),beaker:(0,t.$5j)("beaker",60025),microscope:(0,t.$5j)("microscope",60025),vm:(0,t.$5j)("vm",60026),deviceDesktop:(0,t.$5j)("device-desktop",60026),file:(0,t.$5j)("file",60027),fileText:(0,t.$5j)("file-text",60027),more:(0,t.$5j)("more",60028),ellipsis:(0,t.$5j)("ellipsis",60028),kebabHorizontal:(0,t.$5j)("kebab-horizontal",60028),mailReply:(0,t.$5j)("mail-reply",60029),reply:(0,t.$5j)("reply",60029),organization:(0,t.$5j)("organization",60030),organizationFilled:(0,t.$5j)("organization-filled",60030),organizationOutline:(0,t.$5j)("organization-outline",60030),newFile:(0,t.$5j)("new-file",60031),fileAdd:(0,t.$5j)("file-add",60031),newFolder:(0,t.$5j)("new-folder",60032),fileDirectoryCreate:(0,t.$5j)("file-directory-create",60032),trash:(0,t.$5j)("trash",60033),trashcan:(0,t.$5j)("trashcan",60033),history:(0,t.$5j)("history",60034),clock:(0,t.$5j)("clock",60034),folder:(0,t.$5j)("folder",60035),fileDirectory:(0,t.$5j)("file-directory",60035),symbolFolder:(0,t.$5j)("symbol-folder",60035),logoGithub:(0,t.$5j)("logo-github",60036),markGithub:(0,t.$5j)("mark-github",60036),github:(0,t.$5j)("github",60036),terminal:(0,t.$5j)("terminal",60037),console:(0,t.$5j)("console",60037),repl:(0,t.$5j)("repl",60037),zap:(0,t.$5j)("zap",60038),symbolEvent:(0,t.$5j)("symbol-event",60038),error:(0,t.$5j)("error",60039),stop:(0,t.$5j)("stop",60039),variable:(0,t.$5j)("variable",60040),symbolVariable:(0,t.$5j)("symbol-variable",60040),array:(0,t.$5j)("array",60042),symbolArray:(0,t.$5j)("symbol-array",60042),symbolModule:(0,t.$5j)("symbol-module",60043),symbolPackage:(0,t.$5j)("symbol-package",60043),symbolNamespace:(0,t.$5j)("symbol-namespace",60043),symbolObject:(0,t.$5j)("symbol-object",60043),symbolMethod:(0,t.$5j)("symbol-method",60044),symbolFunction:(0,t.$5j)("symbol-function",60044),symbolConstructor:(0,t.$5j)("symbol-constructor",60044),symbolBoolean:(0,t.$5j)("symbol-boolean",60047),symbolNull:(0,t.$5j)("symbol-null",60047),symbolNumeric:(0,t.$5j)("symbol-numeric",60048),symbolNumber:(0,t.$5j)("symbol-number",60048),symbolStructure:(0,t.$5j)("symbol-structure",60049),symbolStruct:(0,t.$5j)("symbol-struct",60049),symbolParameter:(0,t.$5j)("symbol-parameter",60050),symbolTypeParameter:(0,t.$5j)("symbol-type-parameter",60050),symbolKey:(0,t.$5j)("symbol-key",60051),symbolText:(0,t.$5j)("symbol-text",60051),symbolReference:(0,t.$5j)("symbol-reference",60052),goToFile:(0,t.$5j)("go-to-file",60052),symbolEnum:(0,t.$5j)("symbol-enum",60053),symbolValue:(0,t.$5j)("symbol-value",60053),symbolRuler:(0,t.$5j)("symbol-ruler",60054),symbolUnit:(0,t.$5j)("symbol-unit",60054),activateBreakpoints:(0,t.$5j)("activate-breakpoints",60055),archive:(0,t.$5j)("archive",60056),arrowBoth:(0,t.$5j)("arrow-both",60057),arrowDown:(0,t.$5j)("arrow-down",60058),arrowLeft:(0,t.$5j)("arrow-left",60059),arrowRight:(0,t.$5j)("arrow-right",60060),arrowSmallDown:(0,t.$5j)("arrow-small-down",60061),arrowSmallLeft:(0,t.$5j)("arrow-small-left",60062),arrowSmallRight:(0,t.$5j)("arrow-small-right",60063),arrowSmallUp:(0,t.$5j)("arrow-small-up",60064),arrowUp:(0,t.$5j)("arrow-up",60065),bell:(0,t.$5j)("bell",60066),bold:(0,t.$5j)("bold",60067),book:(0,t.$5j)("book",60068),bookmark:(0,t.$5j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,t.$5j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,t.$5j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,t.$5j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,t.$5j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,t.$5j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,t.$5j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,t.$5j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,t.$5j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,t.$5j)("debug-breakpoint-log-disabled",60075),briefcase:(0,t.$5j)("briefcase",60076),broadcast:(0,t.$5j)("broadcast",60077),browser:(0,t.$5j)("browser",60078),bug:(0,t.$5j)("bug",60079),calendar:(0,t.$5j)("calendar",60080),caseSensitive:(0,t.$5j)("case-sensitive",60081),check:(0,t.$5j)("check",60082),checklist:(0,t.$5j)("checklist",60083),chevronDown:(0,t.$5j)("chevron-down",60084),chevronLeft:(0,t.$5j)("chevron-left",60085),chevronRight:(0,t.$5j)("chevron-right",60086),chevronUp:(0,t.$5j)("chevron-up",60087),chromeClose:(0,t.$5j)("chrome-close",60088),chromeMaximize:(0,t.$5j)("chrome-maximize",60089),chromeMinimize:(0,t.$5j)("chrome-minimize",60090),chromeRestore:(0,t.$5j)("chrome-restore",60091),circleOutline:(0,t.$5j)("circle-outline",60092),circle:(0,t.$5j)("circle",60092),debugBreakpointUnverified:(0,t.$5j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,t.$5j)("terminal-decoration-incomplete",60092),circleSlash:(0,t.$5j)("circle-slash",60093),circuitBoard:(0,t.$5j)("circuit-board",60094),clearAll:(0,t.$5j)("clear-all",60095),clippy:(0,t.$5j)("clippy",60096),closeAll:(0,t.$5j)("close-all",60097),cloudDownload:(0,t.$5j)("cloud-download",60098),cloudUpload:(0,t.$5j)("cloud-upload",60099),code:(0,t.$5j)("code",60100),collapseAll:(0,t.$5j)("collapse-all",60101),colorMode:(0,t.$5j)("color-mode",60102),commentDiscussion:(0,t.$5j)("comment-discussion",60103),creditCard:(0,t.$5j)("credit-card",60105),dash:(0,t.$5j)("dash",60108),dashboard:(0,t.$5j)("dashboard",60109),database:(0,t.$5j)("database",60110),debugContinue:(0,t.$5j)("debug-continue",60111),debugDisconnect:(0,t.$5j)("debug-disconnect",60112),debugPause:(0,t.$5j)("debug-pause",60113),debugRestart:(0,t.$5j)("debug-restart",60114),debugStart:(0,t.$5j)("debug-start",60115),debugStepInto:(0,t.$5j)("debug-step-into",60116),debugStepOut:(0,t.$5j)("debug-step-out",60117),debugStepOver:(0,t.$5j)("debug-step-over",60118),debugStop:(0,t.$5j)("debug-stop",60119),debug:(0,t.$5j)("debug",60120),deviceCameraVideo:(0,t.$5j)("device-camera-video",60121),deviceCamera:(0,t.$5j)("device-camera",60122),deviceMobile:(0,t.$5j)("device-mobile",60123),diffAdded:(0,t.$5j)("diff-added",60124),diffIgnored:(0,t.$5j)("diff-ignored",60125),diffModified:(0,t.$5j)("diff-modified",60126),diffRemoved:(0,t.$5j)("diff-removed",60127),diffRenamed:(0,t.$5j)("diff-renamed",60128),diff:(0,t.$5j)("diff",60129),diffSidebyside:(0,t.$5j)("diff-sidebyside",60129),discard:(0,t.$5j)("discard",60130),editorLayout:(0,t.$5j)("editor-layout",60131),emptyWindow:(0,t.$5j)("empty-window",60132),exclude:(0,t.$5j)("exclude",60133),extensions:(0,t.$5j)("extensions",60134),eyeClosed:(0,t.$5j)("eye-closed",60135),fileBinary:(0,t.$5j)("file-binary",60136),fileCode:(0,t.$5j)("file-code",60137),fileMedia:(0,t.$5j)("file-media",60138),filePdf:(0,t.$5j)("file-pdf",60139),fileSubmodule:(0,t.$5j)("file-submodule",60140),fileSymlinkDirectory:(0,t.$5j)("file-symlink-directory",60141),fileSymlinkFile:(0,t.$5j)("file-symlink-file",60142),fileZip:(0,t.$5j)("file-zip",60143),files:(0,t.$5j)("files",60144),filter:(0,t.$5j)("filter",60145),flame:(0,t.$5j)("flame",60146),foldDown:(0,t.$5j)("fold-down",60147),foldUp:(0,t.$5j)("fold-up",60148),fold:(0,t.$5j)("fold",60149),folderActive:(0,t.$5j)("folder-active",60150),folderOpened:(0,t.$5j)("folder-opened",60151),gear:(0,t.$5j)("gear",60152),gift:(0,t.$5j)("gift",60153),gistSecret:(0,t.$5j)("gist-secret",60154),gist:(0,t.$5j)("gist",60155),gitCommit:(0,t.$5j)("git-commit",60156),gitCompare:(0,t.$5j)("git-compare",60157),compareChanges:(0,t.$5j)("compare-changes",60157),gitMerge:(0,t.$5j)("git-merge",60158),githubAction:(0,t.$5j)("github-action",60159),githubAlt:(0,t.$5j)("github-alt",60160),globe:(0,t.$5j)("globe",60161),grabber:(0,t.$5j)("grabber",60162),graph:(0,t.$5j)("graph",60163),gripper:(0,t.$5j)("gripper",60164),heart:(0,t.$5j)("heart",60165),home:(0,t.$5j)("home",60166),horizontalRule:(0,t.$5j)("horizontal-rule",60167),hubot:(0,t.$5j)("hubot",60168),inbox:(0,t.$5j)("inbox",60169),issueReopened:(0,t.$5j)("issue-reopened",60171),issues:(0,t.$5j)("issues",60172),italic:(0,t.$5j)("italic",60173),jersey:(0,t.$5j)("jersey",60174),json:(0,t.$5j)("json",60175),kebabVertical:(0,t.$5j)("kebab-vertical",60176),key:(0,t.$5j)("key",60177),law:(0,t.$5j)("law",60178),lightbulbAutofix:(0,t.$5j)("lightbulb-autofix",60179),linkExternal:(0,t.$5j)("link-external",60180),link:(0,t.$5j)("link",60181),listOrdered:(0,t.$5j)("list-ordered",60182),listUnordered:(0,t.$5j)("list-unordered",60183),liveShare:(0,t.$5j)("live-share",60184),loading:(0,t.$5j)("loading",60185),location:(0,t.$5j)("location",60186),mailRead:(0,t.$5j)("mail-read",60187),mail:(0,t.$5j)("mail",60188),markdown:(0,t.$5j)("markdown",60189),megaphone:(0,t.$5j)("megaphone",60190),mention:(0,t.$5j)("mention",60191),milestone:(0,t.$5j)("milestone",60192),gitPullRequestMilestone:(0,t.$5j)("git-pull-request-milestone",60192),mortarBoard:(0,t.$5j)("mortar-board",60193),move:(0,t.$5j)("move",60194),multipleWindows:(0,t.$5j)("multiple-windows",60195),mute:(0,t.$5j)("mute",60196),noNewline:(0,t.$5j)("no-newline",60197),note:(0,t.$5j)("note",60198),octoface:(0,t.$5j)("octoface",60199),openPreview:(0,t.$5j)("open-preview",60200),package:(0,t.$5j)("package",60201),paintcan:(0,t.$5j)("paintcan",60202),pin:(0,t.$5j)("pin",60203),play:(0,t.$5j)("play",60204),run:(0,t.$5j)("run",60204),plug:(0,t.$5j)("plug",60205),preserveCase:(0,t.$5j)("preserve-case",60206),preview:(0,t.$5j)("preview",60207),project:(0,t.$5j)("project",60208),pulse:(0,t.$5j)("pulse",60209),question:(0,t.$5j)("question",60210),quote:(0,t.$5j)("quote",60211),radioTower:(0,t.$5j)("radio-tower",60212),reactions:(0,t.$5j)("reactions",60213),references:(0,t.$5j)("references",60214),refresh:(0,t.$5j)("refresh",60215),regex:(0,t.$5j)("regex",60216),remoteExplorer:(0,t.$5j)("remote-explorer",60217),remote:(0,t.$5j)("remote",60218),remove:(0,t.$5j)("remove",60219),replaceAll:(0,t.$5j)("replace-all",60220),replace:(0,t.$5j)("replace",60221),repoClone:(0,t.$5j)("repo-clone",60222),repoForcePush:(0,t.$5j)("repo-force-push",60223),repoPull:(0,t.$5j)("repo-pull",60224),repoPush:(0,t.$5j)("repo-push",60225),report:(0,t.$5j)("report",60226),requestChanges:(0,t.$5j)("request-changes",60227),rocket:(0,t.$5j)("rocket",60228),rootFolderOpened:(0,t.$5j)("root-folder-opened",60229),rootFolder:(0,t.$5j)("root-folder",60230),rss:(0,t.$5j)("rss",60231),ruby:(0,t.$5j)("ruby",60232),saveAll:(0,t.$5j)("save-all",60233),saveAs:(0,t.$5j)("save-as",60234),save:(0,t.$5j)("save",60235),screenFull:(0,t.$5j)("screen-full",60236),screenNormal:(0,t.$5j)("screen-normal",60237),searchStop:(0,t.$5j)("search-stop",60238),server:(0,t.$5j)("server",60240),settingsGear:(0,t.$5j)("settings-gear",60241),settings:(0,t.$5j)("settings",60242),shield:(0,t.$5j)("shield",60243),smiley:(0,t.$5j)("smiley",60244),sortPrecedence:(0,t.$5j)("sort-precedence",60245),splitHorizontal:(0,t.$5j)("split-horizontal",60246),splitVertical:(0,t.$5j)("split-vertical",60247),squirrel:(0,t.$5j)("squirrel",60248),starFull:(0,t.$5j)("star-full",60249),starHalf:(0,t.$5j)("star-half",60250),symbolClass:(0,t.$5j)("symbol-class",60251),symbolColor:(0,t.$5j)("symbol-color",60252),symbolConstant:(0,t.$5j)("symbol-constant",60253),symbolEnumMember:(0,t.$5j)("symbol-enum-member",60254),symbolField:(0,t.$5j)("symbol-field",60255),symbolFile:(0,t.$5j)("symbol-file",60256),symbolInterface:(0,t.$5j)("symbol-interface",60257),symbolKeyword:(0,t.$5j)("symbol-keyword",60258),symbolMisc:(0,t.$5j)("symbol-misc",60259),symbolOperator:(0,t.$5j)("symbol-operator",60260),symbolProperty:(0,t.$5j)("symbol-property",60261),wrench:(0,t.$5j)("wrench",60261),wrenchSubaction:(0,t.$5j)("wrench-subaction",60261),symbolSnippet:(0,t.$5j)("symbol-snippet",60262),tasklist:(0,t.$5j)("tasklist",60263),telescope:(0,t.$5j)("telescope",60264),textSize:(0,t.$5j)("text-size",60265),threeBars:(0,t.$5j)("three-bars",60266),thumbsdown:(0,t.$5j)("thumbsdown",60267),thumbsup:(0,t.$5j)("thumbsup",60268),tools:(0,t.$5j)("tools",60269),triangleDown:(0,t.$5j)("triangle-down",60270),triangleLeft:(0,t.$5j)("triangle-left",60271),triangleRight:(0,t.$5j)("triangle-right",60272),triangleUp:(0,t.$5j)("triangle-up",60273),twitter:(0,t.$5j)("twitter",60274),unfold:(0,t.$5j)("unfold",60275),unlock:(0,t.$5j)("unlock",60276),unmute:(0,t.$5j)("unmute",60277),unverified:(0,t.$5j)("unverified",60278),verified:(0,t.$5j)("verified",60279),versions:(0,t.$5j)("versions",60280),vmActive:(0,t.$5j)("vm-active",60281),vmOutline:(0,t.$5j)("vm-outline",60282),vmRunning:(0,t.$5j)("vm-running",60283),watch:(0,t.$5j)("watch",60284),whitespace:(0,t.$5j)("whitespace",60285),wholeWord:(0,t.$5j)("whole-word",60286),window:(0,t.$5j)("window",60287),wordWrap:(0,t.$5j)("word-wrap",60288),zoomIn:(0,t.$5j)("zoom-in",60289),zoomOut:(0,t.$5j)("zoom-out",60290),listFilter:(0,t.$5j)("list-filter",60291),listFlat:(0,t.$5j)("list-flat",60292),listSelection:(0,t.$5j)("list-selection",60293),selection:(0,t.$5j)("selection",60293),listTree:(0,t.$5j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,t.$5j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,t.$5j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,t.$5j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,t.$5j)("debug-stackframe-active",60297),circleSmallFilled:(0,t.$5j)("circle-small-filled",60298),debugStackframeDot:(0,t.$5j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,t.$5j)("terminal-decoration-mark",60298),debugStackframe:(0,t.$5j)("debug-stackframe",60299),debugStackframeFocused:(0,t.$5j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,t.$5j)("debug-breakpoint-unsupported",60300),symbolString:(0,t.$5j)("symbol-string",60301),debugReverseContinue:(0,t.$5j)("debug-reverse-continue",60302),debugStepBack:(0,t.$5j)("debug-step-back",60303),debugRestartFrame:(0,t.$5j)("debug-restart-frame",60304),debugAlt:(0,t.$5j)("debug-alt",60305),callIncoming:(0,t.$5j)("call-incoming",60306),callOutgoing:(0,t.$5j)("call-outgoing",60307),menu:(0,t.$5j)("menu",60308),expandAll:(0,t.$5j)("expand-all",60309),feedback:(0,t.$5j)("feedback",60310),gitPullRequestReviewer:(0,t.$5j)("git-pull-request-reviewer",60310),groupByRefType:(0,t.$5j)("group-by-ref-type",60311),ungroupByRefType:(0,t.$5j)("ungroup-by-ref-type",60312),account:(0,t.$5j)("account",60313),gitPullRequestAssignee:(0,t.$5j)("git-pull-request-assignee",60313),bellDot:(0,t.$5j)("bell-dot",60314),debugConsole:(0,t.$5j)("debug-console",60315),library:(0,t.$5j)("library",60316),output:(0,t.$5j)("output",60317),runAll:(0,t.$5j)("run-all",60318),syncIgnored:(0,t.$5j)("sync-ignored",60319),pinned:(0,t.$5j)("pinned",60320),githubInverted:(0,t.$5j)("github-inverted",60321),serverProcess:(0,t.$5j)("server-process",60322),serverEnvironment:(0,t.$5j)("server-environment",60323),pass:(0,t.$5j)("pass",60324),issueClosed:(0,t.$5j)("issue-closed",60324),stopCircle:(0,t.$5j)("stop-circle",60325),playCircle:(0,t.$5j)("play-circle",60326),record:(0,t.$5j)("record",60327),debugAltSmall:(0,t.$5j)("debug-alt-small",60328),vmConnect:(0,t.$5j)("vm-connect",60329),cloud:(0,t.$5j)("cloud",60330),merge:(0,t.$5j)("merge",60331),export:(0,t.$5j)("export",60332),graphLeft:(0,t.$5j)("graph-left",60333),magnet:(0,t.$5j)("magnet",60334),notebook:(0,t.$5j)("notebook",60335),redo:(0,t.$5j)("redo",60336),checkAll:(0,t.$5j)("check-all",60337),pinnedDirty:(0,t.$5j)("pinned-dirty",60338),passFilled:(0,t.$5j)("pass-filled",60339),circleLargeFilled:(0,t.$5j)("circle-large-filled",60340),circleLarge:(0,t.$5j)("circle-large",60341),circleLargeOutline:(0,t.$5j)("circle-large-outline",60341),combine:(0,t.$5j)("combine",60342),gather:(0,t.$5j)("gather",60342),table:(0,t.$5j)("table",60343),variableGroup:(0,t.$5j)("variable-group",60344),typeHierarchy:(0,t.$5j)("type-hierarchy",60345),typeHierarchySub:(0,t.$5j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,t.$5j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,t.$5j)("git-pull-request-create",60348),runAbove:(0,t.$5j)("run-above",60349),runBelow:(0,t.$5j)("run-below",60350),notebookTemplate:(0,t.$5j)("notebook-template",60351),debugRerun:(0,t.$5j)("debug-rerun",60352),workspaceTrusted:(0,t.$5j)("workspace-trusted",60353),workspaceUntrusted:(0,t.$5j)("workspace-untrusted",60354),workspaceUnknown:(0,t.$5j)("workspace-unknown",60355),terminalCmd:(0,t.$5j)("terminal-cmd",60356),terminalDebian:(0,t.$5j)("terminal-debian",60357),terminalLinux:(0,t.$5j)("terminal-linux",60358),terminalPowershell:(0,t.$5j)("terminal-powershell",60359),terminalTmux:(0,t.$5j)("terminal-tmux",60360),terminalUbuntu:(0,t.$5j)("terminal-ubuntu",60361),terminalBash:(0,t.$5j)("terminal-bash",60362),arrowSwap:(0,t.$5j)("arrow-swap",60363),copy:(0,t.$5j)("copy",60364),personAdd:(0,t.$5j)("person-add",60365),filterFilled:(0,t.$5j)("filter-filled",60366),wand:(0,t.$5j)("wand",60367),debugLineByLine:(0,t.$5j)("debug-line-by-line",60368),inspect:(0,t.$5j)("inspect",60369),layers:(0,t.$5j)("layers",60370),layersDot:(0,t.$5j)("layers-dot",60371),layersActive:(0,t.$5j)("layers-active",60372),compass:(0,t.$5j)("compass",60373),compassDot:(0,t.$5j)("compass-dot",60374),compassActive:(0,t.$5j)("compass-active",60375),azure:(0,t.$5j)("azure",60376),issueDraft:(0,t.$5j)("issue-draft",60377),gitPullRequestClosed:(0,t.$5j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,t.$5j)("git-pull-request-draft",60379),debugAll:(0,t.$5j)("debug-all",60380),debugCoverage:(0,t.$5j)("debug-coverage",60381),runErrors:(0,t.$5j)("run-errors",60382),folderLibrary:(0,t.$5j)("folder-library",60383),debugContinueSmall:(0,t.$5j)("debug-continue-small",60384),beakerStop:(0,t.$5j)("beaker-stop",60385),graphLine:(0,t.$5j)("graph-line",60386),graphScatter:(0,t.$5j)("graph-scatter",60387),pieChart:(0,t.$5j)("pie-chart",60388),bracket:(0,t.$5j)("bracket",60175),bracketDot:(0,t.$5j)("bracket-dot",60389),bracketError:(0,t.$5j)("bracket-error",60390),lockSmall:(0,t.$5j)("lock-small",60391),azureDevops:(0,t.$5j)("azure-devops",60392),verifiedFilled:(0,t.$5j)("verified-filled",60393),newline:(0,t.$5j)("newline",60394),layout:(0,t.$5j)("layout",60395),layoutActivitybarLeft:(0,t.$5j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,t.$5j)("layout-activitybar-right",60397),layoutPanelLeft:(0,t.$5j)("layout-panel-left",60398),layoutPanelCenter:(0,t.$5j)("layout-panel-center",60399),layoutPanelJustify:(0,t.$5j)("layout-panel-justify",60400),layoutPanelRight:(0,t.$5j)("layout-panel-right",60401),layoutPanel:(0,t.$5j)("layout-panel",60402),layoutSidebarLeft:(0,t.$5j)("layout-sidebar-left",60403),layoutSidebarRight:(0,t.$5j)("layout-sidebar-right",60404),layoutStatusbar:(0,t.$5j)("layout-statusbar",60405),layoutMenubar:(0,t.$5j)("layout-menubar",60406),layoutCentered:(0,t.$5j)("layout-centered",60407),target:(0,t.$5j)("target",60408),indent:(0,t.$5j)("indent",60409),recordSmall:(0,t.$5j)("record-small",60410),errorSmall:(0,t.$5j)("error-small",60411),terminalDecorationError:(0,t.$5j)("terminal-decoration-error",60411),arrowCircleDown:(0,t.$5j)("arrow-circle-down",60412),arrowCircleLeft:(0,t.$5j)("arrow-circle-left",60413),arrowCircleRight:(0,t.$5j)("arrow-circle-right",60414),arrowCircleUp:(0,t.$5j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,t.$5j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,t.$5j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,t.$5j)("layout-sidebar-left-off",60418),blank:(0,t.$5j)("blank",60419),heartFilled:(0,t.$5j)("heart-filled",60420),map:(0,t.$5j)("map",60421),mapHorizontal:(0,t.$5j)("map-horizontal",60421),foldHorizontal:(0,t.$5j)("fold-horizontal",60421),mapFilled:(0,t.$5j)("map-filled",60422),mapHorizontalFilled:(0,t.$5j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,t.$5j)("fold-horizontal-filled",60422),circleSmall:(0,t.$5j)("circle-small",60423),bellSlash:(0,t.$5j)("bell-slash",60424),bellSlashDot:(0,t.$5j)("bell-slash-dot",60425),commentUnresolved:(0,t.$5j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,t.$5j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,t.$5j)("git-pull-request-new-changes",60428),searchFuzzy:(0,t.$5j)("search-fuzzy",60429),commentDraft:(0,t.$5j)("comment-draft",60430),send:(0,t.$5j)("send",60431),sparkle:(0,t.$5j)("sparkle",60432),insert:(0,t.$5j)("insert",60433),mic:(0,t.$5j)("mic",60434),thumbsdownFilled:(0,t.$5j)("thumbsdown-filled",60435),thumbsupFilled:(0,t.$5j)("thumbsup-filled",60436),coffee:(0,t.$5j)("coffee",60437),snake:(0,t.$5j)("snake",60438),game:(0,t.$5j)("game",60439),vr:(0,t.$5j)("vr",60440),chip:(0,t.$5j)("chip",60441),piano:(0,t.$5j)("piano",60442),music:(0,t.$5j)("music",60443),micFilled:(0,t.$5j)("mic-filled",60444),repoFetch:(0,t.$5j)("repo-fetch",60445),copilot:(0,t.$5j)("copilot",60446),lightbulbSparkle:(0,t.$5j)("lightbulb-sparkle",60447),robot:(0,t.$5j)("robot",60448),sparkleFilled:(0,t.$5j)("sparkle-filled",60449),diffSingle:(0,t.$5j)("diff-single",60450),diffMultiple:(0,t.$5j)("diff-multiple",60451),surroundWith:(0,t.$5j)("surround-with",60452),share:(0,t.$5j)("share",60453),gitStash:(0,t.$5j)("git-stash",60454),gitStashApply:(0,t.$5j)("git-stash-apply",60455),gitStashPop:(0,t.$5j)("git-stash-pop",60456),vscode:(0,t.$5j)("vscode",60457),vscodeInsiders:(0,t.$5j)("vscode-insiders",60458),codeOss:(0,t.$5j)("code-oss",60459),runCoverage:(0,t.$5j)("run-coverage",60460),runAllCoverage:(0,t.$5j)("run-all-coverage",60461),coverage:(0,t.$5j)("coverage",60462),githubProject:(0,t.$5j)("github-project",60463),mapVertical:(0,t.$5j)("map-vertical",60464),foldVertical:(0,t.$5j)("fold-vertical",60464),mapVerticalFilled:(0,t.$5j)("map-vertical-filled",60465),foldVerticalFilled:(0,t.$5j)("fold-vertical-filled",60465),goToSearch:(0,t.$5j)("go-to-search",60466),percentage:(0,t.$5j)("percentage",60467),sortPercentage:(0,t.$5j)("sort-percentage",60467),attach:(0,t.$5j)("attach",60468)}}),define(Oe[57],Le([1,0,108,175]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=void 0,e.$8j=E;function E(){return Object.values(e.$0j)}e.$9j={dialogError:(0,t.$5j)("dialog-error","error"),dialogWarning:(0,t.$5j)("dialog-warning","warning"),dialogInfo:(0,t.$5j)("dialog-info","info"),dialogClose:(0,t.$5j)("dialog-close","close"),treeItemExpanded:(0,t.$5j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,t.$5j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,t.$5j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,t.$5j)("tree-filter-clear","close"),treeItemLoading:(0,t.$5j)("tree-item-loading","loading"),menuSelection:(0,t.$5j)("menu-selection","check"),menuSubmenu:(0,t.$5j)("menu-submenu","chevron-right"),menuBarMore:(0,t.$5j)("menubar-more","more"),scrollbarButtonLeft:(0,t.$5j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,t.$5j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,t.$5j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,t.$5j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,t.$5j)("toolbar-more","more"),quickInputBack:(0,t.$5j)("quick-input-back","arrow-left"),dropDownButton:(0,t.$5j)("drop-down-button",60084),symbolCustomColor:(0,t.$5j)("symbol-customcolor",60252),exportIcon:(0,t.$5j)("export",60332),workspaceUnspecified:(0,t.$5j)("workspace-unspecified",60355),newLine:(0,t.$5j)("newline",60394),thumbsDownFilled:(0,t.$5j)("thumbsdown-filled",60435),thumbsUpFilled:(0,t.$5j)("thumbsup-filled",60436),gitFetch:(0,t.$5j)("git-fetch",60445),lightbulbSparkleAutofix:(0,t.$5j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,t.$5j)("debug-breakpoint-pending",60377)},e.$0j={...i.$7j,...e.$9j}}),define(Oe[21],Le([1,0,10]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=i,e.$no=E,e.$oo=D,e.$po=v,e.$qo=s,e.$ro=S,e.$so=y,e.$to=p,e.$uo=$,e.$vo=a,e.$wo=c,e.$xo=m,e.$yo=b;function i(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const d=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([w,o])=>{d[w]=o&&typeof o=="object"?i(o):o}),d}function E(g){if(!g||typeof g!="object")return g;const d=[g];for(;d.length>0;){const w=d.shift();Object.freeze(w);for(const o in w)if(I.call(w,o)){const l=w[o];typeof l=="object"&&!Object.isFrozen(l)&&!(0,t.$mg)(l)&&d.push(l)}}return g}const I=Object.prototype.hasOwnProperty;function D(g,d){return T(g,d,new Set)}function T(g,d,w){if((0,t.$sg)(g))return g;const o=d(g);if(typeof o<"u")return o;if(Array.isArray(g)){const l=[];for(const n of g)l.push(T(n,d,w));return l}if((0,t.$lg)(g)){if(w.has(g))throw new Error("Cannot clone recursive data-structure");w.add(g);const l={};for(const n in g)I.call(g,n)&&(l[n]=T(g[n],d,w));return w.delete(g),l}return g}function v(g,d,w=!0){return(0,t.$lg)(g)?((0,t.$lg)(d)&&Object.keys(d).forEach(o=>{o in g?w&&((0,t.$lg)(g[o])&&(0,t.$lg)(d[o])?v(g[o],d[o],w):g[o]=d[o]):g[o]=d[o]}),g):d}function s(g,d){if(g===d)return!0;if(g==null||d===null||d===void 0||typeof g!=typeof d||typeof g!="object"||Array.isArray(g)!==Array.isArray(d))return!1;let w,o;if(Array.isArray(g)){if(g.length!==d.length)return!1;for(w=0;w<g.length;w++)if(!s(g[w],d[w]))return!1}else{const l=[];for(o in g)l.push(o);l.sort();const n=[];for(o in d)n.push(o);if(n.sort(),!s(l,n))return!1;for(w=0;w<l.length;w++)if(!s(g[l[w]],d[l[w]]))return!1}return!0}function S(g){const d=new Set;return JSON.stringify(g,(w,o)=>{if((0,t.$lg)(o)||Array.isArray(o)){if(d.has(o))return"[Circular]";d.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function y(g,d){const w=Object.create(null);return!g||!d||Object.keys(d).forEach(l=>{const n=g[l],u=d[l];s(n,u)||(w[l]=u)}),w}function p(g,d){const w=d.toLowerCase(),o=Object.keys(g).find(l=>l.toLowerCase()===w);return o?g[o]:g[d]}function $(g,d){const w=Object.create(null);for(const[o,l]of Object.entries(g))d(o,l)&&(w[o]=l);return w}function a(g){let d=[];for(;Object.prototype!==g;)d=d.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return d}function c(g){const d=[];for(const w of a(g))typeof g[w]=="function"&&d.push(w);return d}function m(g,d){const w=l=>function(){const n=Array.prototype.slice.call(arguments,0);return d(l,n)},o={};for(const l of g)o[l]=w(l);return o}function b(g,d){const w={};for(const[o,l]of Object.entries(g))w[o]=d(l,o);return w}}),define(Oe[83],Le([1,0,57]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$$j=E;var i;(function(D){function T(v){return v&&typeof v=="object"&&typeof v.id=="string"}D.isThemeColor=T})(i||(e.ThemeColor=i={}));function E(D){return{id:D}}var I;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function v(g){const d=T.exec(g.id);if(!d)return v(t.$0j.error);const[,w,o]=d,l=["codicon","codicon-"+w];return o&&l.push("codicon-modifier-"+o.substring(1)),l}D.asClassNameArray=v;function s(g){return v(g).join(" ")}D.asClassName=s;function S(g){return"."+v(g).join(".")}D.asCSSSelector=S;function y(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||i.isThemeColor(g.color))}D.isThemeIcon=y;const p=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function $(g){const d=p.exec(g);if(!d)return;const[,w]=d;return{id:w}}D.fromString=$;function a(g){return{id:g}}D.fromId=a;function c(g,d){let w=g.id;const o=w.lastIndexOf("~");return o!==-1&&(w=w.substring(0,o)),d&&(w=`${w}~${d}`),{id:w}}D.modify=c;function m(g){const d=g.id.lastIndexOf("~");if(d!==-1)return g.id.substring(d+1)}D.getModifier=m;function b(g,d){return g.id===d.id&&g.color?.id===d.color?.id}D.isEqual=b})(I||(e.ThemeIcon=I={}))}),define(Oe[109],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$ff=i,e.$gf=E;var t;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(t||(e.Constants=t={}));function i(I){return I<0?0:I>t.MAX_UINT_8?t.MAX_UINT_8:I|0}function E(I){return I<0?0:I>t.MAX_UINT_32?t.MAX_UINT_32:I|0}}),define(Oe[16],Le([1,0,172,34,66,109]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=e.GraphemeBreakType=e.$9f=e.$1f=e.$Tf=e.$Sf=void 0,e.$hf=D,e.$if=v,e.$jf=S,e.$kf=y,e.$lf=p,e.$mf=$,e.$nf=a,e.$of=c,e.$pf=m,e.$qf=b,e.$rf=g,e.$sf=d,e.$tf=w,e.$uf=o,e.$vf=l,e.$wf=n,e.$xf=u,e.$yf=r,e.$zf=f,e.$Af=h,e.$Bf=k,e.$Cf=P,e.$Df=O,e.$Ef=C,e.$Ff=L,e.$Gf=R,e.$Hf=z,e.$If=Q,e.$Jf=J,e.$Kf=x,e.$Lf=ve,e.$Mf=be,e.$Nf=se,e.$Of=V,e.$Pf=B,e.$Qf=j,e.$Rf=U,e.$Uf=oe,e.$Vf=_,e.$Wf=X,e.$Xf=M,e.$Yf=pe,e.$Zf=ie,e.$2f=G,e.$3f=Z,e.$4f=ce,e.$5f=we,e.$6f=Me,e.$7f=Be,e.$8f=Ne,e.$0f=Te,e.$$f=Ce,e.$_f=de,e.$ag=Se,e.$bg=Re,e.$cg=Ue,e.$dg=Ge,e.$eg=Qe,e.$fg=dt;function D(H){return!H||typeof H!="string"?!0:H.trim().length===0}const T=/{(\d+)}/g;function v(H,...ee){return ee.length===0?H:H.replace(T,function(ge,re){const fe=parseInt(re,10);return isNaN(fe)||fe<0||fe>=ee.length?ge:ee[fe]})}const s=/{([^}]+)}/g;function S(H,ee){return Object.keys(ee).length===0?H:H.replace(s,(ge,re)=>ee[re]??ge)}function y(H){return H.replace(/[<>"'&]/g,ee=>{switch(ee){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ee})}function p(H){return H.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}function $(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function a(H,ee){let ge=0,re=H.indexOf(ee);for(;re!==-1;)ge++,re=H.indexOf(ee,re+ee.length);return ge}function c(H,ee,ge="\u2026"){return H.length<=ee?H:`${H.substr(0,ee)}${ge}`}function m(H,ee,ge="\u2026"){if(H.length<=ee)return H;const re=Math.ceil(ee/2)-ge.length/2,fe=Math.floor(ee/2)-ge.length/2;return`${H.substr(0,re)}${ge}${H.substr(H.length-fe)}`}function b(H,ee=" "){const ge=g(H,ee);return d(ge,ee)}function g(H,ee){if(!H||!ee)return H;const ge=ee.length;if(ge===0||H.length===0)return H;let re=0;for(;H.indexOf(ee,re)===re;)re=re+ge;return H.substring(re)}function d(H,ee){if(!H||!ee)return H;const ge=ee.length,re=H.length;if(ge===0||re===0)return H;let fe=re,W=-1;for(;W=H.lastIndexOf(ee,fe-1),!(W===-1||W+ge!==fe);){if(W===0)return"";fe=W}return H.substring(0,fe)}function w(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function o(H){return H.replace(/\*/g,"")}function l(H,ee,ge={}){if(!H)throw new Error("Cannot create regex from empty string");ee||(H=$(H)),ge.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let re="";return ge.global&&(re+="g"),ge.matchCase||(re+="i"),ge.multiline&&(re+="m"),ge.unicode&&(re+="u"),new RegExp(H,re)}function n(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}function u(H){return H.split(/\r\n|\r|\n/)}function r(H){const ee=[],ge=H.split(/(\r\n|\r|\n)/);for(let re=0;re<Math.ceil(ge.length/2);re++)ee.push(ge[2*re]+(ge[2*re+1]??""));return ee}function f(H){for(let ee=0,ge=H.length;ee<ge;ee++){const re=H.charCodeAt(ee);if(re!==i.CharCode.Space&&re!==i.CharCode.Tab)return ee}return-1}function h(H,ee=0,ge=H.length){for(let re=ee;re<ge;re++){const fe=H.charCodeAt(re);if(fe!==i.CharCode.Space&&fe!==i.CharCode.Tab)return H.substring(ee,re)}return H.substring(ee,ge)}function k(H,ee=H.length-1){for(let ge=ee;ge>=0;ge--){const re=H.charCodeAt(ge);if(re!==i.CharCode.Space&&re!==i.CharCode.Tab)return ge}return-1}function P(H,ee,ge){const re=[];let fe=0;for(const W of H.matchAll(ee)){if(re.push(H.slice(fe,W.index)),W.index===void 0)throw new Error("match.index should be defined");fe=W.index+W[0].length,re.push(ge(W[0],...W.slice(1),W.index,H,W.groups))}return re.push(H.slice(fe)),Promise.all(re).then(W=>W.join(""))}function O(H,ee){return H<ee?-1:H>ee?1:0}function C(H,ee,ge=0,re=H.length,fe=0,W=ee.length){for(;ge<re&&fe<W;ge++,fe++){const Fe=H.charCodeAt(ge),qe=ee.charCodeAt(fe);if(Fe<qe)return-1;if(Fe>qe)return 1}const K=re-ge,$e=W-fe;return K<$e?-1:K>$e?1:0}function L(H,ee){return R(H,ee,0,H.length,0,ee.length)}function R(H,ee,ge=0,re=H.length,fe=0,W=ee.length){for(;ge<re&&fe<W;ge++,fe++){let Fe=H.charCodeAt(ge),qe=ee.charCodeAt(fe);if(Fe===qe)continue;if(Fe>=128||qe>=128)return C(H.toLowerCase(),ee.toLowerCase(),ge,re,fe,W);Q(Fe)&&(Fe-=32),Q(qe)&&(qe-=32);const xe=Fe-qe;if(xe!==0)return xe}const K=re-ge,$e=W-fe;return K<$e?-1:K>$e?1:0}function z(H){return H>=i.CharCode.Digit0&&H<=i.CharCode.Digit9}function Q(H){return H>=i.CharCode.a&&H<=i.CharCode.z}function J(H){return H>=i.CharCode.A&&H<=i.CharCode.Z}function x(H,ee){return H.length===ee.length&&R(H,ee)===0}function ve(H,ee){const ge=ee.length;return ee.length>H.length?!1:R(H,ee,0,ge)===0}function be(H,ee){const ge=Math.min(H.length,ee.length);let re;for(re=0;re<ge;re++)if(H.charCodeAt(re)!==ee.charCodeAt(re))return re;return ge}function se(H,ee){const ge=Math.min(H.length,ee.length);let re;const fe=H.length-1,W=ee.length-1;for(re=0;re<ge;re++)if(H.charCodeAt(fe-re)!==ee.charCodeAt(W-re))return re;return ge}function V(H){return 55296<=H&&H<=56319}function B(H){return 56320<=H&&H<=57343}function j(H,ee){return(H-55296<<10)+(ee-56320)+65536}function U(H,ee,ge){const re=H.charCodeAt(ge);if(V(re)&&ge+1<ee){const fe=H.charCodeAt(ge+1);if(B(fe))return j(re,fe)}return re}function te(H,ee){const ge=H.charCodeAt(ee-1);if(B(ge)&&ee>1){const re=H.charCodeAt(ee-2);if(V(re))return j(re,ge)}return ge}class le{get offset(){return this.e}constructor(ee,ge=0){this.c=ee,this.d=ee.length,this.e=ge}setOffset(ee){this.e=ee}prevCodePoint(){const ee=te(this.c,this.e);return this.e-=ee>=I.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ee}nextCodePoint(){const ee=U(this.c,this.d,this.e);return this.e+=ee>=I.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ee}eol(){return this.e>=this.d}}e.$Sf=le;class ye{get offset(){return this.c.offset}constructor(ee,ge=0){this.c=new le(ee,ge)}nextGraphemeLength(){const ee=tt.getInstance(),ge=this.c,re=ge.offset;let fe=ee.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const W=ge.offset,K=ee.getGraphemeBreakType(ge.nextCodePoint());if(Je(fe,K)){ge.setOffset(W);break}fe=K}return ge.offset-re}prevGraphemeLength(){const ee=tt.getInstance(),ge=this.c,re=ge.offset;let fe=ee.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const W=ge.offset,K=ee.getGraphemeBreakType(ge.prevCodePoint());if(Je(K,fe)){ge.setOffset(W);break}fe=K}return re-ge.offset}eol(){return this.c.eol()}}e.$Tf=ye;function oe(H,ee){return new ye(H,ee).nextGraphemeLength()}function _(H,ee){return new ye(H,ee).prevGraphemeLength()}function X(H,ee){ee>0&&B(H.charCodeAt(ee))&&ee--;const ge=ee+oe(H,ee);return[ge-_(H,ge),ge]}function M(H){const ee=new ye(H);let ge=0;for(;!ee.eol();)ge++,ee.nextGraphemeLength();return ge}let A;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function pe(H){return A||(A=Y()),A.test(H)}const ne=/^[\t\n\r\x20-\x7E]*$/;function ie(H){return ne.test(H)}e.$1f=/[\u2028\u2029]/;function G(H){return e.$1f.test(H)}function Z(H){return H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}function ce(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129008||H>=129280&&H<=129535||H>=129648&&H<=129782}function we(H,ee,ge=""){const re=H.trimStart();if(re.length<ee)return re;const fe=/\b/g;let W=0;for(;fe.test(re)&&!(re.length-fe.lastIndex<ee);)W=fe.lastIndex,fe.lastIndex+=1;return W===0?re:ge+re.substring(W).trimStart()}const Ie=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Me(H){let ee=0;for(const ge of H.matchAll(Ie))ee!==ge.index&&(yield{isCode:!1,str:H.substring(ee,ge.index)}),yield{isCode:!0,str:ge[0]},ee=ge.index+ge[0].length;ee!==H.length&&(yield{isCode:!1,str:H.substring(ee)})}function Be(H){return H&&(H=H.replace(Ie,"")),H}const De=/\\\[.*?\\\]/g;function Ne(H){return Be(H).replace(De,"")}e.$9f=String.fromCharCode(i.CharCode.UTF8_BOM);function Te(H){return!!(H&&H.length>0&&H.charCodeAt(0)===i.CharCode.UTF8_BOM)}function Ce(H){return Te(H)?H.substr(1):H}function de(H,ee){if(!H||!ee||H.length<ee.length)return!1;const ge=ee.length,re=H.toLowerCase();let fe=0,W=-1;for(;fe<ge;){const K=re.indexOf(ee[fe],W+1);if(K<0)return!1;W=K,fe++}return!0}function Se(H,ee=!1){return H?(ee&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}function Re(H){return H.charAt(0).toUpperCase()+H.slice(1)}function Ue(H,ee=1){if(ee===0)return"";let ge=-1;do ge=H.indexOf(`
`,ge+1),ee--;while(ee>0&&ge>=0);return ge===-1?H:(H[ge-1]==="\r"&&ge--,H.substr(0,ge))}function Ge(H){const ee=i.CharCode.Z-i.CharCode.A+1;return H=H%(2*ee),H<ee?String.fromCharCode(i.CharCode.a+H):String.fromCharCode(i.CharCode.A+H-ee)}function Qe(H){return tt.getInstance().getGraphemeBreakType(H)}function Je(H,ee){return H===Xe.Other?ee!==Xe.Extend&&ee!==Xe.SpacingMark:H===Xe.CR&&ee===Xe.LF?!1:H===Xe.Control||H===Xe.CR||H===Xe.LF||ee===Xe.Control||ee===Xe.CR||ee===Xe.LF?!0:!(H===Xe.L&&(ee===Xe.L||ee===Xe.V||ee===Xe.LV||ee===Xe.LVT)||(H===Xe.LV||H===Xe.V)&&(ee===Xe.V||ee===Xe.T)||(H===Xe.LVT||H===Xe.T)&&ee===Xe.T||ee===Xe.Extend||ee===Xe.ZWJ||ee===Xe.SpacingMark||H===Xe.Prepend||H===Xe.ZWJ&&ee===Xe.Extended_Pictographic||H===Xe.Regional_Indicator&&ee===Xe.Regional_Indicator)}var Xe;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(Xe||(e.GraphemeBreakType=Xe={}));class tt{static{this.c=null}static getInstance(){return tt.c||(tt.c=new tt),tt.c}constructor(){this.d=st()}getGraphemeBreakType(ee){if(ee<32)return ee===i.CharCode.LineFeed?Xe.LF:ee===i.CharCode.CarriageReturn?Xe.CR:Xe.Control;if(ee<127)return Xe.Other;const ge=this.d,re=ge.length/3;let fe=1;for(;fe<=re;)if(ee<ge[3*fe])fe=2*fe;else if(ee>ge[3*fe+1])fe=2*fe+1;else return ge[3*fe+2];return Xe.Other}}function st(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function dt(H,ee){if(H===0)return 0;const ge=rt(H,ee);if(ge!==void 0)return ge;const re=new le(ee,H);return re.prevCodePoint(),re.offset}function rt(H,ee){const ge=new le(ee,H);let re=ge.prevCodePoint();for(;ot(re)||re===ut.emojiVariantSelector||re===ut.enclosingKeyCap;){if(ge.offset===0)return;re=ge.prevCodePoint()}if(!ce(re))return;let fe=ge.offset;return fe>0&&ge.prevCodePoint()===ut.zwj&&(fe=ge.offset),fe}function ot(H){return 127995<=H&&H<=127999}var ut;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(ut||(ut={})),e.$gg="\xA0";class Ye{static{this.c=new E.$Y(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new t.$df({getCacheKey:JSON.stringify},ee=>{function ge(xe){const et=new Map;for(let it=0;it<xe.length;it+=2)et.set(xe[it],xe[it+1]);return et}function re(xe,et){const it=new Map(xe);for(const[ct,mt]of et)it.set(ct,mt);return it}function fe(xe,et){if(!xe)return et;const it=new Map;for(const[ct,mt]of xe)et.has(ct)&&it.set(ct,mt);return it}const W=this.c.value;let K=ee.filter(xe=>!xe.startsWith("_")&&xe in W);K.length===0&&(K=["_default"]);let $e;for(const xe of K){const et=ge(W[xe]);$e=fe($e,et)}const Fe=ge(W._common),qe=re(Fe,$e);return new Ye(qe)})}static getInstance(ee){return Ye.d.get(Array.from(ee))}static{this.e=new E.$Y(()=>Object.keys(Ye.c.value).filter(ee=>!ee.startsWith("_")))}static getLocales(){return Ye.e.value}constructor(ee){this.f=ee}isAmbiguous(ee){return this.f.has(ee)}containsAmbiguousCharacter(ee){for(let ge=0;ge<ee.length;ge++){const re=ee.codePointAt(ge);if(typeof re=="number"&&this.isAmbiguous(re))return!0}return!1}getPrimaryConfusable(ee){return this.f.get(ee)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hg=Ye;class me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(me.c())),this.d}static isInvisibleCharacter(ee){return me.e().has(ee)}static containsInvisibleCharacter(ee){for(let ge=0;ge<ee.length;ge++){const re=ee.codePointAt(ge);if(typeof re=="number"&&me.isInvisibleCharacter(re))return!0}return!1}static get codePoints(){return me.e()}}e.$ig=me}),define(Oe[176],Le([1,0,34,25,165,16]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.FuzzyScore=e.$Nk=e.$Mk=void 0,e.or=D,e.$Ok=v,e.$Pk=s,e.$Qk=p,e.$Rk=k,e.$Sk=P,e.$Tk=Q,e.$Uk=J,e.$Vk=x,e.$Wk=ve,e.$Xk=Y,e.$Zk=G,e.$1k=we,e.$2k=Ie,I=We(I);function D(...De){return function(Ne,Te){for(let Ce=0,de=De.length;Ce<de;Ce++){const Se=De[Ce](Ne,Te);if(Se)return Se}return null}}e.$Mk=T.bind(void 0,!1),e.$Nk=T.bind(void 0,!0);function T(De,Ne,Te){if(!Te||Te.length<Ne.length)return null;let Ce;return De?Ce=I.$Lf(Te,Ne):Ce=Te.indexOf(Ne)===0,Ce?Ne.length>0?[{start:0,end:Ne.length}]:[]:null}function v(De,Ne){const Te=Ne.toLowerCase().indexOf(De.toLowerCase());return Te===-1?null:[{start:Te,end:Te+De.length}]}function s(De,Ne){return S(De.toLowerCase(),Ne.toLowerCase(),0,0)}function S(De,Ne,Te,Ce){if(Te===De.length)return[];if(Ce===Ne.length)return null;if(De[Te]===Ne[Ce]){let de=null;return(de=S(De,Ne,Te+1,Ce+1))?o({start:Ce,end:Ce+1},de):null}return S(De,Ne,Te,Ce+1)}function y(De){return t.CharCode.a<=De&&De<=t.CharCode.z}function p(De){return t.CharCode.A<=De&&De<=t.CharCode.Z}function $(De){return t.CharCode.Digit0<=De&&De<=t.CharCode.Digit9}function a(De){return De===t.CharCode.Space||De===t.CharCode.Tab||De===t.CharCode.LineFeed||De===t.CharCode.CarriageReturn}const c=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(De=>c.add(De.charCodeAt(0)));function m(De){return a(De)||c.has(De)}function b(De,Ne){return De===Ne||m(De)&&m(Ne)}const g=new Map;function d(De){if(g.has(De))return g.get(De);let Ne;const Te=(0,E.$Kk)(De);return Te&&(Ne=Te),g.set(De,Ne),Ne}function w(De){return y(De)||p(De)||$(De)}function o(De,Ne){return Ne.length===0?Ne=[De]:De.end===Ne[0].start?Ne[0].start=De.start:Ne.unshift(De),Ne}function l(De,Ne){for(let Te=Ne;Te<De.length;Te++){const Ce=De.charCodeAt(Te);if(p(Ce)||$(Ce)||Te>0&&!w(De.charCodeAt(Te-1)))return Te}return De.length}function n(De,Ne,Te,Ce){if(Te===De.length)return[];if(Ce===Ne.length)return null;if(De[Te]!==Ne[Ce].toLowerCase())return null;{let de=null,Se=Ce+1;for(de=n(De,Ne,Te+1,Ce+1);!de&&(Se=l(Ne,Se))<Ne.length;)de=n(De,Ne,Te+1,Se),Se++;return de===null?null:o({start:Ce,end:Ce+1},de)}}function u(De){let Ne=0,Te=0,Ce=0,de=0,Se=0;for(let Je=0;Je<De.length;Je++)Se=De.charCodeAt(Je),p(Se)&&Ne++,y(Se)&&Te++,w(Se)&&Ce++,$(Se)&&de++;const Re=Ne/De.length,Ue=Te/De.length,Ge=Ce/De.length,Qe=de/De.length;return{upperPercent:Re,lowerPercent:Ue,alphaPercent:Ge,numericPercent:Qe}}function r(De){const{upperPercent:Ne,lowerPercent:Te}=De;return Te===0&&Ne>.6}function f(De){const{upperPercent:Ne,lowerPercent:Te,alphaPercent:Ce,numericPercent:de}=De;return Te>.2&&Ne<.8&&Ce>.6&&de<.2}function h(De){let Ne=0,Te=0,Ce=0,de=0;for(let Se=0;Se<De.length;Se++)Ce=De.charCodeAt(Se),p(Ce)&&Ne++,y(Ce)&&Te++,a(Ce)&&de++;return(Ne===0||Te===0)&&de===0?De.length<=30:Ne<=5}function k(De,Ne){if(!Ne||(Ne=Ne.trim(),Ne.length===0)||!h(De))return null;Ne.length>60&&(Ne=Ne.substring(0,60));const Te=u(Ne);if(!f(Te)){if(!r(Te))return null;Ne=Ne.toLowerCase()}let Ce=null,de=0;for(De=De.toLowerCase();de<Ne.length&&(Ce=n(De,Ne,0,de))===null;)de=l(Ne,de+1);return Ce}function P(De,Ne,Te=!1){if(!Ne||Ne.length===0)return null;let Ce=null,de=0;for(De=De.toLowerCase(),Ne=Ne.toLowerCase();de<Ne.length&&(Ce=O(De,Ne,0,de,Te),Ce===null);)de=C(Ne,de+1);return Ce}function O(De,Ne,Te,Ce,de){let Se=0;if(Te===De.length)return[];if(Ce===Ne.length)return null;if(!b(De.charCodeAt(Te),Ne.charCodeAt(Ce))){const Ge=d(De.charCodeAt(Te));if(!Ge)return null;for(let Qe=0;Qe<Ge.length;Qe++)if(!b(Ge[Qe],Ne.charCodeAt(Ce+Qe)))return null;Se+=Ge.length-1}let Re=null,Ue=Ce+Se+1;if(Re=O(De,Ne,Te+1,Ue,de),!de)for(;!Re&&(Ue=C(Ne,Ue))<Ne.length;)Re=O(De,Ne,Te+1,Ue,de),Ue++;if(!Re)return null;if(De.charCodeAt(Te)!==Ne.charCodeAt(Ce)){const Ge=d(De.charCodeAt(Te));if(!Ge)return Re;for(let Qe=0;Qe<Ge.length;Qe++)if(Ge[Qe]!==Ne.charCodeAt(Ce+Qe))return Re}return o({start:Ce,end:Ce+Se+1},Re)}function C(De,Ne){for(let Te=Ne;Te<De.length;Te++)if(m(De.charCodeAt(Te))||Te>0&&m(De.charCodeAt(Te-1)))return Te;return De.length}const L=D(e.$Nk,k,v),R=D(e.$Nk,k,s),z=new i.$Ic(1e4);function Q(De,Ne,Te=!1){if(typeof De!="string"||typeof Ne!="string")return null;let Ce=z.get(De);Ce||(Ce=new RegExp(I.$tf(De),"i"),z.set(De,Ce));const de=Ce.exec(Ne);return de?[{start:de.index,end:de.index+de[0].length}]:Te?R(De,Ne):L(De,Ne)}function J(De,Ne){const Te=G(De,De.toLowerCase(),0,Ne,Ne.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?ve(Te):null}function x(De,Ne,Te,Ce,de,Se){const Re=Math.min(13,De.length);for(;Te<Re;Te++){const Ue=G(De,Ne,Te,Ce,de,Se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ue)return Ue}return[0,Se]}function ve(De){if(typeof De>"u")return[];const Ne=[],Te=De[1];for(let Ce=De.length-1;Ce>1;Ce--){const de=De[Ce]+Te,Se=Ne[Ne.length-1];Se&&Se.end===de?Se.end=de+1:Ne.push({start:de,end:de+1})}return Ne}const be=128;function se(){const De=[],Ne=[];for(let Te=0;Te<=be;Te++)Ne[Te]=0;for(let Te=0;Te<=be;Te++)De.push(Ne.slice(0));return De}function V(De){const Ne=[];for(let Te=0;Te<=De;Te++)Ne[Te]=0;return Ne}const B=V(2*be),j=V(2*be),U=se(),te=se(),le=se(),ye=!1;function oe(De,Ne,Te,Ce,de){function Se(Ue,Ge,Qe=" "){for(;Ue.length<Ge;)Ue=Qe+Ue;return Ue}let Re=` |   |${Ce.split("").map(Ue=>Se(Ue,3)).join("|")}
`;for(let Ue=0;Ue<=Te;Ue++)Ue===0?Re+=" |":Re+=`${Ne[Ue-1]}|`,Re+=De[Ue].slice(0,de+1).map(Ge=>Se(Ge.toString(),3)).join("|")+`
`;return Re}function _(De,Ne,Te,Ce){De=De.substr(Ne),Te=Te.substr(Ce),console.log(oe(te,De,De.length,Te,Te.length)),console.log(oe(le,De,De.length,Te,Te.length)),console.log(oe(U,De,De.length,Te,Te.length))}function X(De,Ne){if(Ne<0||Ne>=De.length)return!1;const Te=De.codePointAt(Ne);switch(Te){case t.CharCode.Underline:case t.CharCode.Dash:case t.CharCode.Period:case t.CharCode.Space:case t.CharCode.Slash:case t.CharCode.Backslash:case t.CharCode.SingleQuote:case t.CharCode.DoubleQuote:case t.CharCode.Colon:case t.CharCode.DollarSign:case t.CharCode.LessThan:case t.CharCode.GreaterThan:case t.CharCode.OpenParen:case t.CharCode.CloseParen:case t.CharCode.OpenSquareBracket:case t.CharCode.CloseSquareBracket:case t.CharCode.OpenCurlyBrace:case t.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!I.$4f(Te)}}function M(De,Ne){if(Ne<0||Ne>=De.length)return!1;switch(De.charCodeAt(Ne)){case t.CharCode.Space:case t.CharCode.Tab:return!0;default:return!1}}function A(De,Ne,Te){return Ne[De]!==Te[De]}function Y(De,Ne,Te,Ce,de,Se,Re=!1){for(;Ne<Te&&de<Se;)De[Ne]===Ce[de]&&(Re&&(B[Ne]=de),Ne+=1),de+=1;return Ne===Te}var pe;(function(De){De[De.Diag=1]="Diag",De[De.Left=2]="Left",De[De.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var ne;(function(De){De.Default=[-100,0];function Ne(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}De.isDefault=Ne})(ne||(e.FuzzyScore=ne={}));class ie{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ne,Te){this.firstMatchCanBeWeak=Ne,this.boostFullMatch=Te}}e.$Yk=ie;function G(De,Ne,Te,Ce,de,Se,Re=ie.default){const Ue=De.length>be?be:De.length,Ge=Ce.length>be?be:Ce.length;if(Te>=Ue||Se>=Ge||Ue-Te>Ge-Se||!Y(Ne,Te,Ue,de,Se,Ge,!0))return;Z(Ue,Ge,Te,Se,Ne,de);let Qe=1,Je=1,Xe=Te,tt=Se;const st=[!1];for(Qe=1,Xe=Te;Xe<Ue;Qe++,Xe++){const Ye=B[Xe],me=j[Xe],H=Xe+1<Ue?j[Xe+1]:Ge;for(Je=Ye-Se+1,tt=Ye;tt<H;Je++,tt++){let ee=Number.MIN_SAFE_INTEGER,ge=!1;tt<=me&&(ee=ce(De,Ne,Xe,Te,Ce,de,tt,Ge,Se,U[Qe-1][Je-1]===0,st));let re=0;ee!==Number.MAX_SAFE_INTEGER&&(ge=!0,re=ee+te[Qe-1][Je-1]);const fe=tt>Ye,W=fe?te[Qe][Je-1]+(U[Qe][Je-1]>0?-5:0):0,K=tt>Ye+1&&U[Qe][Je-1]>0,$e=K?te[Qe][Je-2]+(U[Qe][Je-2]>0?-5:0):0;if(K&&(!fe||$e>=W)&&(!ge||$e>=re))te[Qe][Je]=$e,le[Qe][Je]=pe.LeftLeft,U[Qe][Je]=0;else if(fe&&(!ge||W>=re))te[Qe][Je]=W,le[Qe][Je]=pe.Left,U[Qe][Je]=0;else if(ge)te[Qe][Je]=re,le[Qe][Je]=pe.Diag,U[Qe][Je]=U[Qe-1][Je-1]+1;else throw new Error("not possible")}}if(ye&&_(De,Te,Ce,Se),!st[0]&&!Re.firstMatchCanBeWeak)return;Qe--,Je--;const dt=[te[Qe][Je],Se];let rt=0,ot=0;for(;Qe>=1;){let Ye=Je;do{const me=le[Qe][Ye];if(me===pe.LeftLeft)Ye=Ye-2;else if(me===pe.Left)Ye=Ye-1;else break}while(Ye>=1);rt>1&&Ne[Te+Qe-1]===de[Se+Je-1]&&!A(Ye+Se-1,Ce,de)&&rt+1>U[Qe][Ye]&&(Ye=Je),Ye===Je?rt++:rt=1,ot||(ot=Ye),Qe--,Je=Ye-1,dt.push(Je)}Ge-Se===Ue&&Re.boostFullMatch&&(dt[0]+=2);const ut=ot-Ue;return dt[0]-=ut,dt}function Z(De,Ne,Te,Ce,de,Se){let Re=De-1,Ue=Ne-1;for(;Re>=Te&&Ue>=Ce;)de[Re]===Se[Ue]&&(j[Re]=Ue,Re--),Ue--}function ce(De,Ne,Te,Ce,de,Se,Re,Ue,Ge,Qe,Je){if(Ne[Te]!==Se[Re])return Number.MIN_SAFE_INTEGER;let Xe=1,tt=!1;return Re===Te-Ce?Xe=De[Te]===de[Re]?7:5:A(Re,de,Se)&&(Re===0||!A(Re-1,de,Se))?(Xe=De[Te]===de[Re]?7:5,tt=!0):X(Se,Re)&&(Re===0||!X(Se,Re-1))?Xe=5:(X(Se,Re-1)||M(Se,Re-1))&&(Xe=5,tt=!0),Xe>1&&Te===Ce&&(Je[0]=!0),tt||(tt=A(Re,de,Se)||X(Se,Re-1)||M(Se,Re-1)),Te===Ce?Re>Ge&&(Xe-=tt?3:5):Qe?Xe+=tt?2:0:Xe+=tt?0:1,Re+1===Ue&&(Xe-=tt?3:5),Xe}function we(De,Ne,Te,Ce,de,Se,Re){return Me(De,Ne,Te,Ce,de,Se,!0,Re)}function Ie(De,Ne,Te,Ce,de,Se,Re){return Me(De,Ne,Te,Ce,de,Se,!1,Re)}function Me(De,Ne,Te,Ce,de,Se,Re,Ue){let Ge=G(De,Ne,Te,Ce,de,Se,Ue);if(Ge&&!Re)return Ge;if(De.length>=3){const Qe=Math.min(7,De.length-1);for(let Je=Te+1;Je<Qe;Je++){const Xe=Be(De,Je);if(Xe){const tt=G(Xe,Xe.toLowerCase(),Te,Ce,de,Se,Ue);tt&&(tt[0]-=3,(!Ge||tt[0]>Ge[0])&&(Ge=tt))}}}return Ge}function Be(De,Ne){if(Ne+1>=De.length)return;const Te=De[Ne],Ce=De[Ne+1];if(Te!==Ce)return De.slice(0,Ne)+Ce+Te+De.slice(Ne+2)}}),define(Oe[67],Le([1,0,16]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Cj=void 0,e.$yj=i,e.$zj=E,e.$Aj=I,e.$Bj=T,e.$Dj=c,t=We(t);function i(b){return E(b,0)}function E(b,g){switch(typeof b){case"object":return b===null?I(349,g):Array.isArray(b)?v(b,g):s(b,g);case"string":return T(b,g);case"boolean":return D(b,g);case"number":return I(b,g);case"undefined":return I(937,g);default:return I(617,g)}}function I(b,g){return(g<<5)-g+b|0}function D(b,g){return I(b?433:863,g)}function T(b,g){g=I(149417,g);for(let d=0,w=b.length;d<w;d++)g=I(b.charCodeAt(d),g);return g}function v(b,g){return g=I(104579,g),b.reduce((d,w)=>E(w,d),g)}function s(b,g){return g=I(181387,g),Object.keys(b).sort().reduce((d,w)=>(d=T(w,d),E(b[w],d)),g)}class S{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=E(g,this.g),this.g}}e.$Cj=S;var y;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function p(b,g,d=32){const w=d-g,o=~((1<<w)-1);return(b<<g|(o&b)>>>w)>>>0}function $(b,g=0,d=b.byteLength,w=0){for(let o=0;o<d;o++)b[g+o]=w}function a(b,g,d="0"){for(;b.length<g;)b=d+b;return b}function c(b,g=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(d=>d.toString(16).padStart(2,"0")).join(""):a((b>>>0).toString(16),g/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(y.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const d=g.length;if(d===0)return;const w=this.p;let o=this.r,l=this.u,n,u;for(l!==0?(n=l,u=-1,l=0):(n=g.charCodeAt(0),u=0);;){let r=n;if(t.$Of(n))if(u+1<d){const f=g.charCodeAt(u+1);t.$Pf(f)?(u++,r=t.$Qf(n,f)):r=y.UNICODE_REPLACEMENT}else{l=n;break}else t.$Pf(n)&&(r=y.UNICODE_REPLACEMENT);if(o=this.w(w,o,r),u++,u<d)n=g.charCodeAt(u);else break}this.r=o,this.u=l}w(g,d,w){return w<128?g[d++]=w:w<2048?(g[d++]=192|(w&1984)>>>6,g[d++]=128|(w&63)>>>0):w<65536?(g[d++]=224|(w&61440)>>>12,g[d++]=128|(w&4032)>>>6,g[d++]=128|(w&63)>>>0):(g[d++]=240|(w&1835008)>>>18,g[d++]=128|(w&258048)>>>12,g[d++]=128|(w&4032)>>>6,g[d++]=128|(w&63)>>>0),d>=y.BLOCK_SIZE&&(this.y(),d-=y.BLOCK_SIZE,this.t+=y.BLOCK_SIZE,g[0]=g[y.BLOCK_SIZE+0],g[1]=g[y.BLOCK_SIZE+1],g[2]=g[y.BLOCK_SIZE+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,y.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=m.g,d=this.q;for(let k=0;k<64;k+=4)g.setUint32(k,d.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)g.setUint32(k,p(g.getUint32(k-12,!1)^g.getUint32(k-32,!1)^g.getUint32(k-56,!1)^g.getUint32(k-64,!1),1),!1);let w=this.h,o=this.l,l=this.m,n=this.n,u=this.o,r,f,h;for(let k=0;k<80;k++)k<20?(r=o&l|~o&n,f=1518500249):k<40?(r=o^l^n,f=1859775393):k<60?(r=o&l|o&n|l&n,f=2400959708):(r=o^l^n,f=3395469782),h=p(w,5)+r+u+f+g.getUint32(k*4,!1)&4294967295,u=n,n=l,l=p(o,30),o=w,w=h;this.h=this.h+w&4294967295,this.l=this.l+o&4294967295,this.m=this.m+l&4294967295,this.n=this.n+n&4294967295,this.o=this.o+u&4294967295}}e.$Ej=m}),define(Oe[177],Le([1,0,176,16,83]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=v,e.$4k=S,e.$5k=p,e.$6k=$,e.$7k=c,e.$8k=m;const I="$(",D=new RegExp(`\\$\\(${E.ThemeIcon.iconNameExpression}(?:${E.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${D.source}`,"g");function v(b){return b.replace(T,(g,d)=>d?g:`\\${g}`)}const s=new RegExp(`\\\\${D.source}`,"g");function S(b){return b.replace(s,g=>`\\${g}`)}const y=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function p(b){return b.indexOf(I)===-1?b:b.replace(y,(g,d,w,o)=>w?g:d||o||"")}function $(b){return b?b.replace(/\$\((.*?)\)/g,(g,d)=>` ${d} `).trim():""}const a=new RegExp(`\\$\\(${E.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(b){a.lastIndex=0;let g="";const d=[];let w=0;for(;;){const o=a.lastIndex,l=a.exec(b),n=b.substring(o,l?.index);if(n.length>0){g+=n;for(let u=0;u<n.length;u++)d.push(w)}if(!l)break;w+=l[0].length}return{text:g,iconOffsets:d}}function m(b,g,d=!1){const{text:w,iconOffsets:o}=g;if(!o||o.length===0)return(0,t.$Tk)(b,w,d);const l=(0,i.$rf)(w," "),n=w.length-l.length,u=(0,t.$Tk)(b,l,d);if(u)for(const r of u){const f=o[r.start+n]+n;r.start+=f,r.end+=f}return u}}),define(Oe[58],Le([1,0,16]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),t=We(t);var i;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(i||(i={})),function(E){const I="error",D="warning",T="warn",v="info",s="ignore";function S(p){return p?t.$Kf(I,p)?E.Error:t.$Kf(D,p)||t.$Kf(T,p)?E.Warning:t.$Kf(v,p)?E.Info:E.Ignore:E.Ignore}E.fromValue=S;function y(p){switch(p){case E.Error:return I;case E.Warning:return D;case E.Info:return v;default:return s}}E.toString=y}(i||(i={})),e.default=i}),define(Oe[68],Le([1,0,17,34,16]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class I{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const c=a.charCodeAt(0),m=this.b.charCodeAt(this.c);return c-m}value(){return this.b[this.c]}}e.$Mi=I;class D{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===i.CharCode.Period)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,E.$Ef)(a,this.b,0,a.length,this.c,this.d):(0,E.$Gf)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ni=D;class T{constructor(a=!0,c=!0){this.f=a,this.g=c}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let c=a.length-1;c>=0;c--,this.c--){const m=this.b.charCodeAt(c);if(!(m===i.CharCode.Slash||this.f&&m===i.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===i.CharCode.Slash||this.f&&c===i.CharCode.Backslash)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,E.$Ef)(a,this.b,0,a.length,this.d,this.e):(0,E.$Gf)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Oi=T;var v;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(v||(v={}));class s{constructor(a,c){this.f=a,this.g=c,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(v.Scheme),this.c.authority&&this.d.push(v.Authority),this.c.path&&(this.b=new T(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(v.Path)),this.g(a)||(this.c.query&&this.d.push(v.Query),this.c.fragment&&this.d.push(v.Fragment)),this.e=0,this}next(){return this.d[this.e]===v.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===v.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===v.Scheme)return(0,E.$Ff)(a,this.c.scheme);if(this.d[this.e]===v.Authority)return(0,E.$Ff)(a,this.c.authority);if(this.d[this.e]===v.Path)return this.b.cmp(a);if(this.d[this.e]===v.Query)return(0,E.$Df)(a,this.c.query);if(this.d[this.e]===v.Fragment)return(0,E.$Df)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===v.Scheme)return this.c.scheme;if(this.d[this.e]===v.Authority)return this.c.authority;if(this.d[this.e]===v.Path)return this.b.value();if(this.d[this.e]===v.Query)return this.c.query;if(this.d[this.e]===v.Fragment)return this.c.fragment;throw new Error}}e.$Pi=s;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(y||(y={}));class p{static forUris(a=()=>!1,c=()=>!1){return new p(new s(a,c))}static forPaths(a=!1){return new p(new T(void 0,!a))}static forStrings(){return new p(new I)}static forConfigKeys(){return new p(new D)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,c){if(c){const m=c.slice(0);(0,t.$1b)(m);for(const b of m)this.set(b,a)}else{const m=a.slice(0);(0,t.$1b)(m);for(const b of m)this.set(b[0],b[1])}}set(a,c){const m=this.b.reset(a);let b;this.c||(this.c=new S,this.c.segment=m.value());const g=[];for(b=this.c;;){const w=m.cmp(b.segment);if(w>0)b.left||(b.left=new S,b.left.segment=m.value()),g.push([y.Left,b]),b=b.left;else if(w<0)b.right||(b.right=new S,b.right.segment=m.value()),g.push([y.Right,b]),b=b.right;else if(m.hasNext())m.next(),b.mid||(b.mid=new S,b.mid.segment=m.value()),g.push([y.Mid,b]),b=b.mid;else break}const d=b.value;b.value=c,b.key=a;for(let w=g.length-1;w>=0;w--){const o=g[w][1];o.updateHeight();const l=o.balanceFactor();if(l<-1||l>1){const n=g[w][0],u=g[w+1][0];if(n===y.Right&&u===y.Right)g[w][1]=o.rotateLeft();else if(n===y.Left&&u===y.Left)g[w][1]=o.rotateRight();else if(n===y.Right&&u===y.Left)o.right=g[w+1][1]=g[w+1][1].rotateRight(),g[w][1]=o.rotateLeft();else if(n===y.Left&&u===y.Right)o.left=g[w+1][1]=g[w+1][1].rotateLeft(),g[w][1]=o.rotateRight();else throw new Error;if(w>0)switch(g[w-1][0]){case y.Left:g[w-1][1].left=g[w][1];break;case y.Right:g[w-1][1].right=g[w][1];break;case y.Mid:g[w-1][1].mid=g[w][1];break}else this.c=g[0][1]}}return d}get(a){return this.d(a)?.value}d(a){const c=this.b.reset(a);let m=this.c;for(;m;){const b=c.cmp(m.segment);if(b>0)m=m.left;else if(b<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else break}return m}has(a){const c=this.d(a);return!(c?.value===void 0&&c?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,c){const m=this.b.reset(a),b=[];let g=this.c;for(;g;){const d=m.cmp(g.segment);if(d>0)b.push([y.Left,g]),g=g.left;else if(d<0)b.push([y.Right,g]),g=g.right;else if(m.hasNext())m.next(),b.push([y.Mid,g]),g=g.mid;else break}if(g){if(c?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const d=this.f(g.right);if(d.key){const{key:w,value:o,segment:l}=d;this.e(d.key,!1),g.key=w,g.value=o,g.segment=l}}else{const d=g.left??g.right;if(b.length>0){const[w,o]=b[b.length-1];switch(w){case y.Left:o.left=d;break;case y.Mid:o.mid=d;break;case y.Right:o.right=d;break}}else this.c=d}for(let d=b.length-1;d>=0;d--){const w=b[d][1];w.updateHeight();const o=w.balanceFactor();if(o>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),b[d][1]=w.rotateLeft()):o<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),b[d][1]=w.rotateRight()),d>0)switch(b[d-1][0]){case y.Left:b[d-1][1].left=b[d][1];break;case y.Right:b[d-1][1].right=b[d][1];break;case y.Mid:b[d-1][1].mid=b[d][1];break}else this.c=b[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const c=this.b.reset(a);let m=this.c,b;for(;m;){const g=c.cmp(m.segment);if(g>0)m=m.left;else if(g<0)m=m.right;else if(c.hasNext())c.next(),b=m.value||b,m=m.mid;else break}return m&&m.value||b}findSuperstr(a){return this.g(a,!1)}g(a,c){const m=this.b.reset(a);let b=this.c;for(;b;){const g=m.cmp(b.segment);if(g>0)b=b.left;else if(g<0)b=b.right;else if(m.hasNext())m.next(),b=b.mid;else return b.mid?this.h(b.mid):c?b.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[c,m]of this)a(m,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const c=[];return this.j(a,c),c[Symbol.iterator]()}j(a,c){a&&(a.left&&this.j(a.left,c),a.value&&c.push([a.key,a.value]),a.mid&&this.j(a.mid,c),a.right&&this.j(a.right,c))}_isBalanced(){const a=c=>{if(!c)return!0;const m=c.balanceFactor();return m<-1||m>1?!1:a(c.left)&&a(c.right)};return a(this.c)}}e.$Qi=p}),define(Oe[23],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=void 0,e.$6g=i;const t=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(E){return t.test(E)}e.$7g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(T){for(let v=0;v<T.length;v++)T[v]=Math.floor(Math.random()*256);return T};const I=new Uint8Array(16),D=[];for(let T=0;T<256;T++)D.push(T.toString(16).padStart(2,"0"));return function(){E(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let v=0,s="";return s+=D[I[v++]],s+=D[I[v++]],s+=D[I[v++]],s+=D[I[v++]],s+="-",s+=D[I[v++]],s+=D[I[v++]],s+="-",s+=D[I[v++]],s+=D[I[v++]],s+="-",s+=D[I[v++]],s+=D[I[v++]],s+="-",s+=D[I[v++]],s+=D[I[v++]],s+=D[I[v++]],s+=D[I[v++]],s+=D[I[v++]],s+=D[I[v++]],s}}()}),define(Oe[178],Le([1,0,17,39,23]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Du=e.$Bu=void 0,e.$zu=I,e.$Au=D,e.$Cu=s;function I(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function D(y,p,$){const a={id:(0,E.$7g)(),name:y,uri:p,data:$};return{asString:async()=>"",asFile:()=>a,value:void 0}}class T{constructor(){this.a=new Map}get size(){let p=0;for(const $ of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const $=[...this.a.keys()];return i.Iterable.some(this,([a,c])=>c.asFile())&&$.push("files"),S(v(p),$)}get(p){return this.a.get(this.b(p))?.[0]}append(p,$){const a=this.a.get(p);a?a.push($):this.a.set(this.b(p),[$])}replace(p,$){this.a.set(this.b(p),[$])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,$]of this.a)for(const a of $)yield[p,a]}b(p){return v(p)}}e.$Bu=T;function v(y){return y.toLowerCase()}function s(y,p){return S(v(y),p.map(v))}function S(y,p){if(y==="*/*")return p.length>0;if(p.includes(y))return!0;const $=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!$)return!1;const[a,c,m]=$;return m==="*"?p.some(b=>b.startsWith(c+"/")):!1}e.$Du=Object.freeze({create:y=>(0,t.$Qb)(y.map(p=>p.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$Du.split(y).filter(p=>!p.startsWith("#"))})}),define(Oe[179],Le([1,0,31]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=I;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function E(D){const T=D.replace(/\-/g,":").toLowerCase();return!i.has(T)}function I(){const D=(0,t.networkInterfaces)();for(const T in D){const v=D[T];if(v){for(const{mac:s}of v)if(E(s))return s}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),function(){function ue(e,t,i){async function E(S){try{return await t.promises.access(S),!0}catch{return!1}}function I(S){const y=new Date;return t.promises.utimes(S,y,y)}async function D(S){const y=e.join(S,"languagepacks.json");try{return JSON.parse(await t.promises.readFile(y,"utf-8"))}catch{return}}function T(S,y){try{for(;y;){if(S[y])return y;const p=y.lastIndexOf("-");if(p>0)y=y.substring(0,p);else return}}catch(p){console.error("Resolving language pack configuration failed.",p)}}function v(S,y,p){return i.mark("code/didGenerateNls"),{userLocale:S,osLocale:y,resolvedLanguage:"en",defaultMessagesFile:e.join(p,"nls.messages.json"),locale:S,availableLanguages:{}}}async function s({userLocale:S,osLocale:y,userDataPath:p,commit:$,nlsMetadataPath:a}){if(i.mark("code/willGenerateNls"),process.env.VSCODE_DEV||S==="pseudo"||S.startsWith("en")||!$||!p)return v(S,y,a);try{const c=await D(p);if(!c)return v(S,y,a);const m=T(c,S);if(!m)return v(S,y,a);const b=c[m],g=b?.translations?.vscode;if(!b||typeof b.hash!="string"||!b.translations||typeof g!="string"||!await E(g))return v(S,y,a);const d=`${b.hash}.${m}`,w=e.join(p,"clp",d),o=e.join(w,$),l=e.join(o,"nls.messages.json"),n=e.join(w,"tcf.json"),u=e.join(w,"corrupted.info");await E(u)&&await t.promises.rm(w,{recursive:!0,force:!0,maxRetries:3});const r={userLocale:S,osLocale:y,resolvedLanguage:m,defaultMessagesFile:e.join(a,"nls.messages.json"),languagePack:{translationsConfigFile:n,messagesFile:l,corruptMarkerFile:u},locale:S,availableLanguages:{"*":m},_languagePackId:d,_languagePackSupport:!0,_translationsConfigFile:n,_cacheRoot:w,_resolvedLanguagePackCoreLocation:o,_corruptedFile:u};if(await E(o))return I(o).catch(()=>{}),i.mark("code/didGenerateNls"),r;const[,f,h,k]=await Promise.all([t.promises.mkdir(o,{recursive:!0}),JSON.parse(await t.promises.readFile(e.join(a,"nls.keys.json"),"utf-8")),JSON.parse(await t.promises.readFile(e.join(a,"nls.messages.json"),"utf-8")),JSON.parse(await t.promises.readFile(g,"utf-8"))]),P=[];let O=0;for(const[C,L]of f){const R=k.contents[C];for(const z of L)P.push(R?.[z]||h[O]),O++}return await Promise.all([t.promises.writeFile(l,JSON.stringify(P),"utf-8"),t.promises.writeFile(n,JSON.stringify(b.translations),"utf-8")]),i.mark("code/didGenerateNls"),r}catch(c){console.error("Generating translation files failed.",c)}return v(S,y,a)}return{resolveNLSConfiguration:s}}if(typeof define=="function")define(Oe[180],Le([59,20,44]),function(e,t,i){return ue(e,t,i)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),t=require("fs"),i=require("../common/performance");module.exports=ue(e,t,i)}else throw new Error("vs/base/node/nls defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(Oe[181],Le([1,0,84]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=void 0,e.$9g=i,e.$$g=I,t=We(t);function i(T,v,s,S=1){let y=!1;return new Promise(p=>{const $=setTimeout(()=>{if(!y)return y=!0,p(0)},s);E(T,v,S,a=>{if(!y)return y=!0,clearTimeout($),p(a)})})}function E(T,v,s,S){if(v===0)return S(0);const y=new t.Socket;y.once("connect",()=>(D(y),E(T+s,v-1,s,S))),y.once("data",()=>{}),y.once("error",p=>(D(y),p.code!=="ECONNREFUSED"?E(T+s,v-1,s,S):S(T))),y.connect(T,"127.0.0.1")}e.$0g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(T,v,s,S="127.0.0.1"){let y=!1,p,$=1;const a=t.createServer({pauseOnConnect:!0});function c(m,b){y||(y=!0,a.removeAllListeners(),a.close(),p&&clearTimeout(p),b(m))}return new Promise(m=>{p=setTimeout(()=>{c(0,m)},s),a.on("listening",()=>{c(T,m)}),a.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&$<v?(T++,$++,a.listen(T,S)):c(0,m)}),a.on("close",()=>{c(0,m)}),a.listen(T,S)})}function D(T){try{T.removeAllListeners("connect"),T.removeAllListeners("error"),T.end(),T.destroy(),T.unref()}catch(v){console.error(v)}}}),function(){function ue(){function e(){return process.uncHostAllowlist}function t(v){const s=new Set;if(Array.isArray(v))for(const S of v)typeof S=="string"&&s.add(S);return Array.from(s)}function i(){const v=e();return v?Array.from(v):[]}function E(v){if(process.platform!=="win32")return;const s=e();if(s)if(typeof v=="string")s.add(v.toLowerCase());else for(const S of t(v))E(S)}function I(v){if(typeof v!="string")return;const s=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let S;for(const y of s){if(v.indexOf(y)!==0)continue;const $=v.indexOf("\\",y.length);if($===-1)continue;const a=v.substring(y.length,$);if(a){S=a;break}}return S}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function T(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:i,addUNCHostToAllowlist:E,getUNCHost:I,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:T}}typeof define=="function"?define("vs/base/node/unc",[],function(){return ue()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=ue():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(Oe[182],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=void 0,e.$ep=i;const t="Offline";function i(I){return I instanceof E?!0:I instanceof Error&&I.name===t&&I.message===t}class E extends Error{constructor(){super(t),this.name=this.message}}e.$fp=E}),define(Oe[85],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=void 0;class t{constructor(E,I){this.lineNumber=E,this.column=I}with(E=this.lineNumber,I=this.column){return E===this.lineNumber&&I===this.column?this:new t(E,I)}delta(E=0,I=0){return this.with(this.lineNumber+E,this.column+I)}equals(E){return t.equals(this,E)}static equals(E,I){return!E&&!I?!0:!!E&&!!I&&E.lineNumber===I.lineNumber&&E.column===I.column}isBefore(E){return t.isBefore(this,E)}static isBefore(E,I){return E.lineNumber<I.lineNumber?!0:I.lineNumber<E.lineNumber?!1:E.column<I.column}isBeforeOrEqual(E){return t.isBeforeOrEqual(this,E)}static isBeforeOrEqual(E,I){return E.lineNumber<I.lineNumber?!0:I.lineNumber<E.lineNumber?!1:E.column<=I.column}static compare(E,I){const D=E.lineNumber|0,T=I.lineNumber|0;if(D===T){const v=E.column|0,s=I.column|0;return v-s}return D-T}clone(){return new t(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(E){return new t(E.lineNumber,E.column)}static isIPosition(E){return E&&typeof E.lineNumber=="number"&&typeof E.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Xt=t}),define(Oe[48],Le([1,0,85]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yt=void 0;class i{constructor(I,D,T,v){I>T||I===T&&D>v?(this.startLineNumber=T,this.startColumn=v,this.endLineNumber=I,this.endColumn=D):(this.startLineNumber=I,this.startColumn=D,this.endLineNumber=T,this.endColumn=v)}isEmpty(){return i.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return i.containsPosition(this,I)}static containsPosition(I,D){return!(D.lineNumber<I.startLineNumber||D.lineNumber>I.endLineNumber||D.lineNumber===I.startLineNumber&&D.column<I.startColumn||D.lineNumber===I.endLineNumber&&D.column>I.endColumn)}static strictContainsPosition(I,D){return!(D.lineNumber<I.startLineNumber||D.lineNumber>I.endLineNumber||D.lineNumber===I.startLineNumber&&D.column<=I.startColumn||D.lineNumber===I.endLineNumber&&D.column>=I.endColumn)}containsRange(I){return i.containsRange(this,I)}static containsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>I.endColumn)}strictContainsRange(I){return i.strictContainsRange(this,I)}static strictContainsRange(I,D){return!(D.startLineNumber<I.startLineNumber||D.endLineNumber<I.startLineNumber||D.startLineNumber>I.endLineNumber||D.endLineNumber>I.endLineNumber||D.startLineNumber===I.startLineNumber&&D.startColumn<=I.startColumn||D.endLineNumber===I.endLineNumber&&D.endColumn>=I.endColumn)}plusRange(I){return i.plusRange(this,I)}static plusRange(I,D){let T,v,s,S;return D.startLineNumber<I.startLineNumber?(T=D.startLineNumber,v=D.startColumn):D.startLineNumber===I.startLineNumber?(T=D.startLineNumber,v=Math.min(D.startColumn,I.startColumn)):(T=I.startLineNumber,v=I.startColumn),D.endLineNumber>I.endLineNumber?(s=D.endLineNumber,S=D.endColumn):D.endLineNumber===I.endLineNumber?(s=D.endLineNumber,S=Math.max(D.endColumn,I.endColumn)):(s=I.endLineNumber,S=I.endColumn),new i(T,v,s,S)}intersectRanges(I){return i.intersectRanges(this,I)}static intersectRanges(I,D){let T=I.startLineNumber,v=I.startColumn,s=I.endLineNumber,S=I.endColumn;const y=D.startLineNumber,p=D.startColumn,$=D.endLineNumber,a=D.endColumn;return T<y?(T=y,v=p):T===y&&(v=Math.max(v,p)),s>$?(s=$,S=a):s===$&&(S=Math.min(S,a)),T>s||T===s&&v>S?null:new i(T,v,s,S)}equalsRange(I){return i.equalsRange(this,I)}static equalsRange(I,D){return!I&&!D?!0:!!I&&!!D&&I.startLineNumber===D.startLineNumber&&I.startColumn===D.startColumn&&I.endLineNumber===D.endLineNumber&&I.endColumn===D.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(I){return new t.$Xt(I.endLineNumber,I.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(I){return new t.$Xt(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,D){return new i(this.startLineNumber,this.startColumn,I,D)}setStartPosition(I,D){return new i(I,D,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(I){return new i(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return i.collapseToEnd(this)}static collapseToEnd(I){return new i(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new i(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,D=I){return new i(I.lineNumber,I.column,D.lineNumber,D.column)}static lift(I){return I?new i(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<I.startColumn)}static areIntersecting(I,D){return!(I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<=D.startColumn||D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,D){if(I&&D){const s=I.startLineNumber|0,S=D.startLineNumber|0;if(s===S){const y=I.startColumn|0,p=D.startColumn|0;if(y===p){const $=I.endLineNumber|0,a=D.endLineNumber|0;if($===a){const c=I.endColumn|0,m=D.endColumn|0;return c-m}return $-a}return y-p}return s-S}return(I?1:0)-(D?1:0)}static compareRangesUsingEnds(I,D){return I.endLineNumber===D.endLineNumber?I.endColumn===D.endColumn?I.startLineNumber===D.startLineNumber?I.startColumn-D.startColumn:I.startLineNumber-D.startLineNumber:I.endColumn-D.endColumn:I.endLineNumber-D.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$Yt=i}),define(Oe[183],Le([1,0,48]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zt=void 0;class i{static insert(I,D){return{range:new t.$Yt(I.lineNumber,I.column,I.lineNumber,I.column),text:D,forceMoveMarkers:!0}}static delete(I){return{range:I,text:null}}static replace(I,D){return{range:I,text:D}}static replaceMove(I,D){return{range:I,text:D,forceMoveMarkers:!0}}}e.$Zt=i}),define(Oe[184],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$vt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Oe[185],Le([1,0,39,2,81]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.$wt=void 0,e.$yt=D,e.$zt=v,e.$At=s,e.$wt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function I(y=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const $ of e.$wt)y.indexOf($)>=0||(p+="\\"+$);return p+="\\s]+)",new RegExp(p,"g")}e.$xt=I();function D(y){let p=e.$xt;if(y&&y instanceof RegExp)if(y.global)p=y;else{let $="g";y.ignoreCase&&($+="i"),y.multiline&&($+="m"),y.unicode&&($+="u"),p=new RegExp(y.source,$)}return p.lastIndex=0,p}const T=new E.$0c;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(y){const p=T.unshift(y);return(0,i.$Xc)(p)}function s(y,p,$,a,c){if(p=D(p),c||(c=t.Iterable.first(T)),$.length>c.maxLen){let w=y-c.maxLen/2;return w<0?w=0:a+=w,$=$.substring(w,y+c.maxLen/2),s(y,p,$,a,c)}const m=Date.now(),b=y-1-a;let g=-1,d=null;for(let w=1;!(Date.now()-m>=c.timeBudget);w++){const o=b-c.windowSize*w;p.lastIndex=Math.max(0,o);const l=S(p,$,b,g);if(!l&&d||(d=l,o<=0))break;g=o}if(d){const w={word:d[0],startColumn:a+1+d.index,endColumn:a+1+d.index+d[0].length};return p.lastIndex=0,w}return null}function S(y,p,$,a){let c;for(;c=y.exec(p);){const m=c.index||0;if(m<=$&&y.lastIndex>=$)return c;if(a>0&&m>a)return null}return null}}),define(Oe[110],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var t;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(t||(e.LanguageId=t={}));var i;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline",v[v.Strikethrough=8]="Strikethrough"})(i||(e.FontStyle=i={}));var E;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(E||(e.ColorId=E={}));var I;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=3]="RegEx"})(I||(e.StandardTokenType=I={}));var D;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",v[v.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",v[v.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",v[v.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(D||(e.MetadataConsts=D={}));class T{static getLanguageId(s){return(s&D.LANGUAGEID_MASK)>>>D.LANGUAGEID_OFFSET}static getTokenType(s){return(s&D.TOKEN_TYPE_MASK)>>>D.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(s){return(s&D.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(s){return(s&D.FONT_STYLE_MASK)>>>D.FONT_STYLE_OFFSET}static getForeground(s){return(s&D.FOREGROUND_MASK)>>>D.FOREGROUND_OFFSET}static getBackground(s){return(s&D.BACKGROUND_MASK)>>>D.BACKGROUND_OFFSET}static getClassNameFromMetadata(s){let y="mtk"+this.getForeground(s);const p=this.getFontStyle(s);return p&i.Italic&&(y+=" mtki"),p&i.Bold&&(y+=" mtkb"),p&i.Underline&&(y+=" mtku"),p&i.Strikethrough&&(y+=" mtks"),y}static getInlineStyleFromMetadata(s,S){const y=this.getForeground(s),p=this.getFontStyle(s);let $=`color: ${S[y]};`;p&i.Italic&&($+="font-style: italic;"),p&i.Bold&&($+="font-weight: bold;");let a="";return p&i.Underline&&(a+=" underline"),p&i.Strikethrough&&(a+=" line-through"),a&&($+=`text-decoration:${a};`),$}static getPresentationFromMetadata(s){const S=this.getForeground(s),y=this.getFontStyle(s);return{foreground:S,italic:!!(y&i.Italic),bold:!!(y&i.Bold),underline:!!(y&i.Underline),strikethrough:!!(y&i.Strikethrough)}}}e.$Fu=T}),define(Oe[186],Le([1,0,21]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$rw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$pw=e.$ow=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$qw=a,e.$uw=w;var i;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(i||(e.OverviewRulerLane=i={}));var E;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=3]="Right"})(E||(e.GlyphMarginLane=E={}));var I;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(I||(e.MinimapPosition=I={}));var D;(function(o){o[o.Normal=1]="Normal",o[o.Underlined=2]="Underlined"})(D||(e.MinimapSectionHeaderStyle=D={}));var T;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(T||(e.InjectedTextCursorStops=T={}));var v;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var s;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(s||(e.DefaultEndOfLine=s={}));var S;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(S||(e.EndOfLineSequence=S={}));class y{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,l.indentSize|0),this.a=!1),this.insertSpaces=!!l.insertSpaces,this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=!!l.trimAutoWhitespace,this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.a===l.a&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,t.$qo)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.$ow=y;class p{constructor(l,n){this._findMatchBrand=void 0,this.range=l,this.matches=n}}e.$pw=p;var $;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(e.TrackedRangeStickiness=$={}));function a(o){return o&&typeof o.read=="function"}var c;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(c||(e.PositionAffinity=c={}));var m;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class b{constructor(l,n,u,r,f,h){this.identifier=l,this.range=n,this.text=u,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=f,this._isTracked=h}}e.$rw=b;class g{constructor(l,n,u){this.regex=l,this.wordSeparators=n,this.simpleSearch=u}}e.$sw=g;class d{constructor(l,n,u){this.reverseEdits=l,this.changes=n,this.trimAutoWhitespaceLineNumbers=u}}e.$tw=d;function w(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}}),define(Oe[187],Le([1,0,6,2,110]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iu=void 0;class I{constructor(){this.a=new Map,this.b=new Map,this.c=new t.$qe,this.onDidChange=this.c.event,this.d=null}handleChange(v){this.c.fire({changedLanguages:v,changedColorMap:!1})}register(v,s){return this.a.set(v,s),this.handleChange([v]),(0,i.$Xc)(()=>{this.a.get(v)===s&&(this.a.delete(v),this.handleChange([v]))})}get(v){return this.a.get(v)||null}registerFactory(v,s){this.b.get(v)?.dispose();const S=new D(this,v,s);return this.b.set(v,S),(0,i.$Xc)(()=>{const y=this.b.get(v);!y||y!==S||(this.b.delete(v),y.dispose())})}async getOrCreate(v){const s=this.get(v);if(s)return s;const S=this.b.get(v);return!S||S.isResolved?null:(await S.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const S=this.b.get(v);return!!(!S||S.isResolved)}setColorMap(v){this.d=v,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>E.ColorId.DefaultBackground?this.d[E.ColorId.DefaultBackground]:null}}e.$Iu=I;class D extends i.$Zc{get isResolved(){return this.c}constructor(v,s,S){super(),this.f=v,this.g=s,this.h=S,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const v=await this.h.tokenizationSupport;this.c=!0,v&&!this.a&&this.B(this.f.register(this.g,v))}}}),define(Oe[111],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a=t,e.$b=i;function t(){return globalThis._VSCODE_NLS_MESSAGES}function i(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(Oe[7],Le([1,0,111,111]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=D,e.localize2=v,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return i.$b}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return i.$a}});const E=(0,t.$b)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function I(s,S){let y;return S.length===0?y=s:y=s.replace(/\{(\d+)\}/g,(p,$)=>{const a=$[0],c=S[a];let m=p;return typeof c=="string"?m=c:(typeof c=="number"||typeof c=="boolean"||c===void 0||c===null)&&(m=String(c)),m}),E&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function D(s,S,...y){return I(typeof s=="number"?T(s,S):S,y)}function T(s,S){const y=(0,t.$a)()?.[s];if(typeof y!="string"){if(typeof S=="string")return S;throw new Error(`!!! NLS MISSING: ${s} !!!`)}return y}function v(s,S,...y){let p;typeof s=="number"?p=T(s,S):p=S;const $=I(p,y);return{value:$,original:S===p?$:I(S,y)}}}),define(Oe[188],Le([1,0,6,2,7]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0,e.$uj=S,E=We(E);class I extends i.$Zc{constructor(p,$="",a="",c=!0,m){super(),this.j=this.B(new t.$qe),this.onDidChange=this.j.event,this.z=!0,this.m=p,this.n=$,this.w=a,this.z=c,this.D=m}get id(){return this.m}get label(){return this.n}set label(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.j.fire({label:p}))}get tooltip(){return this.u||""}set tooltip(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.j.fire({tooltip:p}))}get class(){return this.w}set class(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.j.fire({class:p}))}get enabled(){return this.z}set enabled(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.j.fire({enabled:p}))}get checked(){return this.C}set checked(p){this.J(p)}J(p){this.C!==p&&(this.C=p,this.j.fire({checked:p}))}async run(p,$){this.D&&await this.D(p)}}e.$pj=I;class D extends i.$Zc{constructor(){super(...arguments),this.f=this.B(new t.$qe),this.onWillRun=this.f.event,this.m=this.B(new t.$qe),this.onDidRun=this.m.event}async run(p,$){if(!p.enabled)return;this.f.fire({action:p});let a;try{await this.u(p,$)}catch(c){a=c}this.m.fire({action:p,error:a})}async u(p,$){await p.run($)}}e.$qj=D;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let $=[];for(const a of p)a.length&&($.length?$=[...$,new T,...a]:$=a);return $}static{this.ID="vs.actions.separator"}async run(){}}e.$rj=T;class v{get actions(){return this.a}constructor(p,$,a,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=$,this.class=c,this.a=a}async run(){}}e.$sj=v;class s extends I{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,E.localize(41,null),void 0,!1)}}e.$tj=s;function S(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...p)=>y.run(...p)}}}),define(Oe[189],Le([1,0,7]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=s,e.$0m=S,e.$$m=y,e.$_m=p;const i=60,E=i*60,I=E*24,D=I*7,T=I*30,v=I*365;function s($,a,c,m){typeof $!="number"&&($=$.getTime());const b=Math.round((new Date().getTime()-$)/1e3);if(b<-30)return(0,t.localize)(42,null,s(new Date().getTime()+b*1e3,!1));if(!m&&b<30)return(0,t.localize)(43,null);let g;return b<i?(g=b,a?g===1?c?(0,t.localize)(44,null,g):(0,t.localize)(45,null,g):c?(0,t.localize)(46,null,g):(0,t.localize)(47,null,g):g===1?c?(0,t.localize)(48,null,g):(0,t.localize)(49,null,g):c?(0,t.localize)(50,null,g):(0,t.localize)(51,null,g)):b<E?(g=Math.floor(b/i),a?g===1?c?(0,t.localize)(52,null,g):(0,t.localize)(53,null,g):c?(0,t.localize)(54,null,g):(0,t.localize)(55,null,g):g===1?c?(0,t.localize)(56,null,g):(0,t.localize)(57,null,g):c?(0,t.localize)(58,null,g):(0,t.localize)(59,null,g)):b<I?(g=Math.floor(b/E),a?g===1?c?(0,t.localize)(60,null,g):(0,t.localize)(61,null,g):c?(0,t.localize)(62,null,g):(0,t.localize)(63,null,g):g===1?c?(0,t.localize)(64,null,g):(0,t.localize)(65,null,g):c?(0,t.localize)(66,null,g):(0,t.localize)(67,null,g)):b<D?(g=Math.floor(b/I),a?g===1?(0,t.localize)(68,null,g):(0,t.localize)(69,null,g):g===1?(0,t.localize)(70,null,g):(0,t.localize)(71,null,g)):b<T?(g=Math.floor(b/D),a?g===1?c?(0,t.localize)(72,null,g):(0,t.localize)(73,null,g):c?(0,t.localize)(74,null,g):(0,t.localize)(75,null,g):g===1?c?(0,t.localize)(76,null,g):(0,t.localize)(77,null,g):c?(0,t.localize)(78,null,g):(0,t.localize)(79,null,g)):b<v?(g=Math.floor(b/T),a?g===1?c?(0,t.localize)(80,null,g):(0,t.localize)(81,null,g):c?(0,t.localize)(82,null,g):(0,t.localize)(83,null,g):g===1?c?(0,t.localize)(84,null,g):(0,t.localize)(85,null,g):c?(0,t.localize)(86,null,g):(0,t.localize)(87,null,g)):(g=Math.floor(b/v),a?g===1?c?(0,t.localize)(88,null,g):(0,t.localize)(89,null,g):c?(0,t.localize)(90,null,g):(0,t.localize)(91,null,g):g===1?c?(0,t.localize)(92,null,g):(0,t.localize)(93,null,g):c?(0,t.localize)(94,null,g):(0,t.localize)(95,null,g))}function S($,a,c){typeof $!="number"&&($=$.getTime());const m=new Date;m.setHours(0,0,0,0);const b=new Date(m.getTime());return b.setDate(b.getDate()-1),$>m.getTime()?(0,t.localize)(96,null):$>b.getTime()?(0,t.localize)(97,null):s($,a,c)}function y($,a){const c=Math.abs($/1e3);return c<1?a?(0,t.localize)(98,null,$):(0,t.localize)(99,null,$):c<i?a?(0,t.localize)(100,null,Math.round($)/1e3):(0,t.localize)(101,null,Math.round($)/1e3):c<E?a?(0,t.localize)(102,null,Math.round($/(1e3*i))):(0,t.localize)(103,null,Math.round($/(1e3*i))):c<I?a?(0,t.localize)(104,null,Math.round($/(1e3*E))):(0,t.localize)(105,null,Math.round($/(1e3*E))):(0,t.localize)(106,null,Math.round($/(1e3*I)))}function p($){return $.getFullYear()+"-"+String($.getMonth()+1).padStart(2,"0")+"-"+String($.getDate()).padStart(2,"0")+"T"+String($.getHours()).padStart(2,"0")+":"+String($.getMinutes()).padStart(2,"0")+":"+String($.getSeconds()).padStart(2,"0")+"."+($.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Oe[45],Le([1,0,17,10,7]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=v,e.$wj=s,e.$xj=S,t=We(t),i=We(i),E=We(E);function I(y,p){return p&&(y.stack||y.stacktrace)?E.localize(107,null,T(y),D(y.stack)||D(y.stacktrace)):T(y)}function D(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?E.localize(108,null,y.message):y.message||E.localize(109,null)}function v(y=null,p=!1){if(!y)return E.localize(110,null);if(Array.isArray(y)){const $=t.$Lb(y),a=v($[0],p);return $.length>1?E.localize(111,null,a,$.length):a}if(i.$jg(y))return y;if(y.detail){const $=y.detail;if($.error)return I($.error,p);if($.exception)return I($.exception,p)}return y.stack?I(y,p):y.message?y.message:E.localize(112,null)}function s(y){const p=y;return p instanceof Error&&Array.isArray(p.actions)}function S(y,p){let $;return typeof y=="string"?$=new Error(y):$=y,$.actions=p,$}}),define(Oe[190],Le([1,0,7,42]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=E;function E(I){switch(I){case i.ParseErrorCode.InvalidSymbol:return(0,t.localize)(113,null);case i.ParseErrorCode.InvalidNumberFormat:return(0,t.localize)(114,null);case i.ParseErrorCode.PropertyNameExpected:return(0,t.localize)(115,null);case i.ParseErrorCode.ValueExpected:return(0,t.localize)(116,null);case i.ParseErrorCode.ColonExpected:return(0,t.localize)(117,null);case i.ParseErrorCode.CommaExpected:return(0,t.localize)(118,null);case i.ParseErrorCode.CloseBraceExpected:return(0,t.localize)(119,null);case i.ParseErrorCode.CloseBracketExpected:return(0,t.localize)(120,null);case i.ParseErrorCode.EndOfFileExpected:return(0,t.localize)(121,null);default:return""}}}),define(Oe[3],Le([1,0,7]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=e.$H=e.OS=e.OperatingSystem=e.$E=e.$D=e.$C=e.$B=e.$A=e.Language=e.$z=e.$y=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.Platform=e.$j=void 0,e.$k=n,e.$G=P,e.$M=O,t=We(t),e.$j="en";let i=!1,E=!1,I=!1,D=!1,T=!1,v=!1,s=!1,S=!1,y=!1,p=!1,$,a=e.$j,c=e.$j,m,b;const g=globalThis;let d;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?d=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(d=process);const w=typeof d?.versions?.electron=="string",o=w&&d?.type==="renderer";if(typeof d=="object"){i=d.platform==="win32",E=d.platform==="darwin",I=d.platform==="linux",D=I&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,s=w,y=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$j,a=e.$j;const C=d.env.VSCODE_NLS_CONFIG;if(C)try{const L=JSON.parse(C);$=L.userLocale,c=L.osLocale,a=L.resolvedLanguage||e.$j,m=L.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!o?(b=navigator.userAgent,i=b.indexOf("Windows")>=0,E=b.indexOf("Macintosh")>=0,S=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=b.indexOf("Linux")>=0,p=b?.indexOf("Mobi")>=0,v=!0,a=t.getNLSLanguage()||e.$j,$=navigator.language.toLowerCase(),c=$):console.error("Unable to resolve platform.");var l;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(l||(e.Platform=l={}));function n(C){switch(C){case l.Web:return"Web";case l.Mac:return"Mac";case l.Linux:return"Linux";case l.Windows:return"Windows"}}let u=l.Web;E?u=l.Mac:i?u=l.Windows:I&&(u=l.Linux),e.$l=i,e.$m=E,e.$n=I,e.$o=D,e.$p=T,e.$q=s,e.$r=v,e.$s=v&&typeof g.importScripts=="function",e.$t=e.$s?g.origin:void 0,e.$u=S,e.$v=p,e.$w=y,e.$x=u,e.$y=b,e.$z=a;var r;(function(C){function L(){return e.$z}C.value=L;function R(){return e.$z.length===2?e.$z==="en":e.$z.length>=3?e.$z[0]==="e"&&e.$z[1]==="n"&&e.$z[2]==="-":!1}C.isDefaultVariant=R;function z(){return e.$z==="en"}C.isDefault=z})(r||(e.Language=r={})),e.$A=$,e.$B=c,e.$C=m,e.$D=typeof g.postMessage=="function"&&!g.importScripts,e.$E=(()=>{if(e.$D){const C=[];g.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let z=0,Q=C.length;z<Q;z++){const J=C[z];if(J.id===R.data.vscodeScheduleAsyncWork){C.splice(z,1),J.callback();return}}});let L=0;return R=>{const z=++L;C.push({id:z,callback:R}),g.postMessage({vscodeScheduleAsyncWork:z},"*")}}return C=>setTimeout(C)})();var f;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(f||(e.OperatingSystem=f={})),e.OS=E||S?f.Macintosh:i?f.Windows:f.Linux;let h=!0,k=!1;function P(){if(!k){k=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,h=new Uint16Array(C.buffer)[0]===513}return h}e.$H=!!(e.$y&&e.$y.indexOf("Chrome")>=0),e.$I=!!(e.$y&&e.$y.indexOf("Firefox")>=0),e.$J=!!(!e.$H&&e.$y&&e.$y.indexOf("Safari")>=0),e.$K=!!(e.$y&&e.$y.indexOf("Edg/")>=0),e.$L=!!(e.$y&&e.$y.indexOf("Android")>=0);function O(C){return parseFloat(C)>=20}}),define(Oe[32],Le([1,0,3]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jc=e.$ic=e.env=e.cwd=void 0;let i;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const I=E.process;i={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return t.$l?"win32":t.$m?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.$ic=i.platform,e.$jc=i.arch}),define(Oe[8],Le([1,0,32]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.sep=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=void 0,t=We(t);const i=65,E=97,I=90,D=122,T=46,v=47,s=92,S=58,y=63;class p extends Error{constructor(u,r,f){let h;typeof r=="string"&&r.indexOf("not ")===0?(h="must not be",r=r.replace(/^not /,"")):h="must be";const k=u.indexOf(".")!==-1?"property":"argument";let P=`The "${u}" ${k} ${h} of type ${r}`;P+=`. Received type ${typeof f}`,super(P),this.code="ERR_INVALID_ARG_TYPE"}}function $(n,u){if(n===null||typeof n!="object")throw new p(u,"Object",n)}function a(n,u){if(typeof n!="string")throw new p(u,"string",n)}const c=t.$ic==="win32";function m(n){return n===v||n===s}function b(n){return n===v}function g(n){return n>=i&&n<=I||n>=E&&n<=D}function d(n,u,r,f){let h="",k=0,P=-1,O=0,C=0;for(let L=0;L<=n.length;++L){if(L<n.length)C=n.charCodeAt(L);else{if(f(C))break;C=v}if(f(C)){if(!(P===L-1||O===1))if(O===2){if(h.length<2||k!==2||h.charCodeAt(h.length-1)!==T||h.charCodeAt(h.length-2)!==T){if(h.length>2){const R=h.lastIndexOf(r);R===-1?(h="",k=0):(h=h.slice(0,R),k=h.length-1-h.lastIndexOf(r)),P=L,O=0;continue}else if(h.length!==0){h="",k=0,P=L,O=0;continue}}u&&(h+=h.length>0?`${r}..`:"..",k=2)}else h.length>0?h+=`${r}${n.slice(P+1,L)}`:h=n.slice(P+1,L),k=L-P-1;P=L,O=0}else C===T&&O!==-1?++O:O=-1}return h}function w(n){return n?`${n[0]==="."?"":"."}${n}`:""}function o(n,u){$(u,"pathObject");const r=u.dir||u.root,f=u.base||`${u.name||""}${w(u.ext)}`;return r?r===u.root?`${r}${f}`:`${r}${n}${f}`:f}e.$kc={resolve(...n){let u="",r="",f=!1;for(let h=n.length-1;h>=-1;h--){let k;if(h>=0){if(k=n[h],a(k,`paths[${h}]`),k.length===0)continue}else u.length===0?k=t.cwd():(k=t.env[`=${u}`]||t.cwd(),(k===void 0||k.slice(0,2).toLowerCase()!==u.toLowerCase()&&k.charCodeAt(2)===s)&&(k=`${u}\\`));const P=k.length;let O=0,C="",L=!1;const R=k.charCodeAt(0);if(P===1)m(R)&&(O=1,L=!0);else if(m(R))if(L=!0,m(k.charCodeAt(1))){let z=2,Q=z;for(;z<P&&!m(k.charCodeAt(z));)z++;if(z<P&&z!==Q){const J=k.slice(Q,z);for(Q=z;z<P&&m(k.charCodeAt(z));)z++;if(z<P&&z!==Q){for(Q=z;z<P&&!m(k.charCodeAt(z));)z++;(z===P||z!==Q)&&(C=`\\\\${J}\\${k.slice(Q,z)}`,O=z)}}}else O=1;else g(R)&&k.charCodeAt(1)===S&&(C=k.slice(0,2),O=2,P>2&&m(k.charCodeAt(2))&&(L=!0,O=3));if(C.length>0)if(u.length>0){if(C.toLowerCase()!==u.toLowerCase())continue}else u=C;if(f){if(u.length>0)break}else if(r=`${k.slice(O)}\\${r}`,f=L,L&&u.length>0)break}return r=d(r,!f,"\\",m),f?`${u}\\${r}`:`${u}${r}`||"."},normalize(n){a(n,"path");const u=n.length;if(u===0)return".";let r=0,f,h=!1;const k=n.charCodeAt(0);if(u===1)return b(k)?"\\":n;if(m(k))if(h=!0,m(n.charCodeAt(1))){let O=2,C=O;for(;O<u&&!m(n.charCodeAt(O));)O++;if(O<u&&O!==C){const L=n.slice(C,O);for(C=O;O<u&&m(n.charCodeAt(O));)O++;if(O<u&&O!==C){for(C=O;O<u&&!m(n.charCodeAt(O));)O++;if(O===u)return`\\\\${L}\\${n.slice(C)}\\`;O!==C&&(f=`\\\\${L}\\${n.slice(C,O)}`,r=O)}}}else r=1;else g(k)&&n.charCodeAt(1)===S&&(f=n.slice(0,2),r=2,u>2&&m(n.charCodeAt(2))&&(h=!0,r=3));let P=r<u?d(n.slice(r),!h,"\\",m):"";return P.length===0&&!h&&(P="."),P.length>0&&m(n.charCodeAt(u-1))&&(P+="\\"),f===void 0?h?`\\${P}`:P:h?`${f}\\${P}`:`${f}${P}`},isAbsolute(n){a(n,"path");const u=n.length;if(u===0)return!1;const r=n.charCodeAt(0);return m(r)||u>2&&g(r)&&n.charCodeAt(1)===S&&m(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let u,r;for(let k=0;k<n.length;++k){const P=n[k];a(P,"path"),P.length>0&&(u===void 0?u=r=P:u+=`\\${P}`)}if(u===void 0)return".";let f=!0,h=0;if(typeof r=="string"&&m(r.charCodeAt(0))){++h;const k=r.length;k>1&&m(r.charCodeAt(1))&&(++h,k>2&&(m(r.charCodeAt(2))?++h:f=!1))}if(f){for(;h<u.length&&m(u.charCodeAt(h));)h++;h>=2&&(u=`\\${u.slice(h)}`)}return e.$kc.normalize(u)},relative(n,u){if(a(n,"from"),a(u,"to"),n===u)return"";const r=e.$kc.resolve(n),f=e.$kc.resolve(u);if(r===f||(n=r.toLowerCase(),u=f.toLowerCase(),n===u))return"";let h=0;for(;h<n.length&&n.charCodeAt(h)===s;)h++;let k=n.length;for(;k-1>h&&n.charCodeAt(k-1)===s;)k--;const P=k-h;let O=0;for(;O<u.length&&u.charCodeAt(O)===s;)O++;let C=u.length;for(;C-1>O&&u.charCodeAt(C-1)===s;)C--;const L=C-O,R=P<L?P:L;let z=-1,Q=0;for(;Q<R;Q++){const x=n.charCodeAt(h+Q);if(x!==u.charCodeAt(O+Q))break;x===s&&(z=Q)}if(Q!==R){if(z===-1)return f}else{if(L>R){if(u.charCodeAt(O+Q)===s)return f.slice(O+Q+1);if(Q===2)return f.slice(O+Q)}P>R&&(n.charCodeAt(h+Q)===s?z=Q:Q===2&&(z=3)),z===-1&&(z=0)}let J="";for(Q=h+z+1;Q<=k;++Q)(Q===k||n.charCodeAt(Q)===s)&&(J+=J.length===0?"..":"\\..");return O+=z,J.length>0?`${J}${f.slice(O,C)}`:(f.charCodeAt(O)===s&&++O,f.slice(O,C))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const u=e.$kc.resolve(n);if(u.length<=2)return n;if(u.charCodeAt(0)===s){if(u.charCodeAt(1)===s){const r=u.charCodeAt(2);if(r!==y&&r!==T)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(g(u.charCodeAt(0))&&u.charCodeAt(1)===S&&u.charCodeAt(2)===s)return`\\\\?\\${u}`;return n},dirname(n){a(n,"path");const u=n.length;if(u===0)return".";let r=-1,f=0;const h=n.charCodeAt(0);if(u===1)return m(h)?n:".";if(m(h)){if(r=f=1,m(n.charCodeAt(1))){let O=2,C=O;for(;O<u&&!m(n.charCodeAt(O));)O++;if(O<u&&O!==C){for(C=O;O<u&&m(n.charCodeAt(O));)O++;if(O<u&&O!==C){for(C=O;O<u&&!m(n.charCodeAt(O));)O++;if(O===u)return n;O!==C&&(r=f=O+1)}}}}else g(h)&&n.charCodeAt(1)===S&&(r=u>2&&m(n.charCodeAt(2))?3:2,f=r);let k=-1,P=!0;for(let O=u-1;O>=f;--O)if(m(n.charCodeAt(O))){if(!P){k=O;break}}else P=!1;if(k===-1){if(r===-1)return".";k=r}return n.slice(0,k)},basename(n,u){u!==void 0&&a(u,"suffix"),a(n,"path");let r=0,f=-1,h=!0,k;if(n.length>=2&&g(n.charCodeAt(0))&&n.charCodeAt(1)===S&&(r=2),u!==void 0&&u.length>0&&u.length<=n.length){if(u===n)return"";let P=u.length-1,O=-1;for(k=n.length-1;k>=r;--k){const C=n.charCodeAt(k);if(m(C)){if(!h){r=k+1;break}}else O===-1&&(h=!1,O=k+1),P>=0&&(C===u.charCodeAt(P)?--P===-1&&(f=k):(P=-1,f=O))}return r===f?f=O:f===-1&&(f=n.length),n.slice(r,f)}for(k=n.length-1;k>=r;--k)if(m(n.charCodeAt(k))){if(!h){r=k+1;break}}else f===-1&&(h=!1,f=k+1);return f===-1?"":n.slice(r,f)},extname(n){a(n,"path");let u=0,r=-1,f=0,h=-1,k=!0,P=0;n.length>=2&&n.charCodeAt(1)===S&&g(n.charCodeAt(0))&&(u=f=2);for(let O=n.length-1;O>=u;--O){const C=n.charCodeAt(O);if(m(C)){if(!k){f=O+1;break}continue}h===-1&&(k=!1,h=O+1),C===T?r===-1?r=O:P!==1&&(P=1):r!==-1&&(P=-1)}return r===-1||h===-1||P===0||P===1&&r===h-1&&r===f+1?"":n.slice(r,h)},format:o.bind(null,"\\"),parse(n){a(n,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return u;const r=n.length;let f=0,h=n.charCodeAt(0);if(r===1)return m(h)?(u.root=u.dir=n,u):(u.base=u.name=n,u);if(m(h)){if(f=1,m(n.charCodeAt(1))){let z=2,Q=z;for(;z<r&&!m(n.charCodeAt(z));)z++;if(z<r&&z!==Q){for(Q=z;z<r&&m(n.charCodeAt(z));)z++;if(z<r&&z!==Q){for(Q=z;z<r&&!m(n.charCodeAt(z));)z++;z===r?f=z:z!==Q&&(f=z+1)}}}}else if(g(h)&&n.charCodeAt(1)===S){if(r<=2)return u.root=u.dir=n,u;if(f=2,m(n.charCodeAt(2))){if(r===3)return u.root=u.dir=n,u;f=3}}f>0&&(u.root=n.slice(0,f));let k=-1,P=f,O=-1,C=!0,L=n.length-1,R=0;for(;L>=f;--L){if(h=n.charCodeAt(L),m(h)){if(!C){P=L+1;break}continue}O===-1&&(C=!1,O=L+1),h===T?k===-1?k=L:R!==1&&(R=1):k!==-1&&(R=-1)}return O!==-1&&(k===-1||R===0||R===1&&k===O-1&&k===P+1?u.base=u.name=n.slice(P,O):(u.name=n.slice(P,k),u.base=n.slice(P,O),u.ext=n.slice(k,O))),P>0&&P!==f?u.dir=n.slice(0,P-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(c){const n=/\\/g;return()=>{const u=t.cwd().replace(n,"/");return u.slice(u.indexOf("/"))}}return()=>t.cwd()})();e.$lc={resolve(...n){let u="",r=!1;for(let f=n.length-1;f>=-1&&!r;f--){const h=f>=0?n[f]:l();a(h,`paths[${f}]`),h.length!==0&&(u=`${h}/${u}`,r=h.charCodeAt(0)===v)}return u=d(u,!r,"/",b),r?`/${u}`:u.length>0?u:"."},normalize(n){if(a(n,"path"),n.length===0)return".";const u=n.charCodeAt(0)===v,r=n.charCodeAt(n.length-1)===v;return n=d(n,!u,"/",b),n.length===0?u?"/":r?"./":".":(r&&(n+="/"),u?`/${n}`:n)},isAbsolute(n){return a(n,"path"),n.length>0&&n.charCodeAt(0)===v},join(...n){if(n.length===0)return".";let u;for(let r=0;r<n.length;++r){const f=n[r];a(f,"path"),f.length>0&&(u===void 0?u=f:u+=`/${f}`)}return u===void 0?".":e.$lc.normalize(u)},relative(n,u){if(a(n,"from"),a(u,"to"),n===u||(n=e.$lc.resolve(n),u=e.$lc.resolve(u),n===u))return"";const r=1,f=n.length,h=f-r,k=1,P=u.length-k,O=h<P?h:P;let C=-1,L=0;for(;L<O;L++){const z=n.charCodeAt(r+L);if(z!==u.charCodeAt(k+L))break;z===v&&(C=L)}if(L===O)if(P>O){if(u.charCodeAt(k+L)===v)return u.slice(k+L+1);if(L===0)return u.slice(k+L)}else h>O&&(n.charCodeAt(r+L)===v?C=L:L===0&&(C=0));let R="";for(L=r+C+1;L<=f;++L)(L===f||n.charCodeAt(L)===v)&&(R+=R.length===0?"..":"/..");return`${R}${u.slice(k+C)}`},toNamespacedPath(n){return n},dirname(n){if(a(n,"path"),n.length===0)return".";const u=n.charCodeAt(0)===v;let r=-1,f=!0;for(let h=n.length-1;h>=1;--h)if(n.charCodeAt(h)===v){if(!f){r=h;break}}else f=!1;return r===-1?u?"/":".":u&&r===1?"//":n.slice(0,r)},basename(n,u){u!==void 0&&a(u,"ext"),a(n,"path");let r=0,f=-1,h=!0,k;if(u!==void 0&&u.length>0&&u.length<=n.length){if(u===n)return"";let P=u.length-1,O=-1;for(k=n.length-1;k>=0;--k){const C=n.charCodeAt(k);if(C===v){if(!h){r=k+1;break}}else O===-1&&(h=!1,O=k+1),P>=0&&(C===u.charCodeAt(P)?--P===-1&&(f=k):(P=-1,f=O))}return r===f?f=O:f===-1&&(f=n.length),n.slice(r,f)}for(k=n.length-1;k>=0;--k)if(n.charCodeAt(k)===v){if(!h){r=k+1;break}}else f===-1&&(h=!1,f=k+1);return f===-1?"":n.slice(r,f)},extname(n){a(n,"path");let u=-1,r=0,f=-1,h=!0,k=0;for(let P=n.length-1;P>=0;--P){const O=n.charCodeAt(P);if(O===v){if(!h){r=P+1;break}continue}f===-1&&(h=!1,f=P+1),O===T?u===-1?u=P:k!==1&&(k=1):u!==-1&&(k=-1)}return u===-1||f===-1||k===0||k===1&&u===f-1&&u===r+1?"":n.slice(u,f)},format:o.bind(null,"/"),parse(n){a(n,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return u;const r=n.charCodeAt(0)===v;let f;r?(u.root="/",f=1):f=0;let h=-1,k=0,P=-1,O=!0,C=n.length-1,L=0;for(;C>=f;--C){const R=n.charCodeAt(C);if(R===v){if(!O){k=C+1;break}continue}P===-1&&(O=!1,P=C+1),R===T?h===-1?h=C:L!==1&&(L=1):h!==-1&&(L=-1)}if(P!==-1){const R=k===0&&r?1:k;h===-1||L===0||L===1&&h===P-1&&h===k+1?u.base=u.name=n.slice(R,P):(u.name=n.slice(R,h),u.base=n.slice(R,P),u.ext=n.slice(h,P))}return k>0?u.dir=n.slice(0,k-1):r&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.$lc.win32=e.$kc.win32=e.$kc,e.$lc.posix=e.$kc.posix=e.$lc,e.$mc=c?e.$kc.normalize:e.$lc.normalize,e.$nc=c?e.$kc.isAbsolute:e.$lc.isAbsolute,e.$oc=c?e.$kc.join:e.$lc.join,e.$pc=c?e.$kc.resolve:e.$lc.resolve,e.$qc=c?e.$kc.relative:e.$lc.relative,e.$rc=c?e.$kc.dirname:e.$lc.dirname,e.$sc=c?e.$kc.basename:e.$lc.basename,e.$tc=c?e.$kc.extname:e.$lc.extname,e.$uc=c?e.$kc.format:e.$lc.format,e.$vc=c?e.$kc.parse:e.$lc.parse,e.$wc=c?e.$kc.toNamespacedPath:e.$lc.toNamespacedPath,e.sep=c?e.$kc.sep:e.$lc.sep,e.$yc=c?e.$kc.delimiter:e.$lc.delimiter}),define(Oe[36],Le([1,0,34,8,3,16,10]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=T,e.$Dg=v,e.$Eg=s,e.$Fg=S,e.$Gg=y,e.$Hg=c,e.$Ig=m,e.$Jg=b,e.$Kg=g,e.$Lg=d,e.$Mg=w,e.$Ng=o,e.$Og=l,e.$Pg=n,e.$Qg=u,e.$Rg=r,e.$Sg=k;function T(P){return P===t.CharCode.Slash||P===t.CharCode.Backslash}function v(P){return P.replace(/[\\/]/g,i.$lc.sep)}function s(P){return P.indexOf("/")===-1&&(P=v(P)),/^[a-zA-Z]:(\/|$)/.test(P)&&(P="/"+P),P}function S(P,O=i.$lc.sep){if(!P)return"";const C=P.length,L=P.charCodeAt(0);if(T(L)){if(T(P.charCodeAt(1))&&!T(P.charCodeAt(2))){let z=3;const Q=z;for(;z<C&&!T(P.charCodeAt(z));z++);if(Q!==z&&!T(P.charCodeAt(z+1))){for(z+=1;z<C;z++)if(T(P.charCodeAt(z)))return P.slice(0,z+1).replace(/[\\/]/g,O)}}return O}else if(g(L)&&P.charCodeAt(1)===t.CharCode.Colon)return T(P.charCodeAt(2))?P.slice(0,2)+O:P.slice(0,2);let R=P.indexOf("://");if(R!==-1){for(R+=3;R<C;R++)if(T(P.charCodeAt(R)))return P.slice(0,R+1)}return""}function y(P){if(!E.$l||!P||P.length<5)return!1;let O=P.charCodeAt(0);if(O!==t.CharCode.Backslash||(O=P.charCodeAt(1),O!==t.CharCode.Backslash))return!1;let C=2;const L=C;for(;C<P.length&&(O=P.charCodeAt(C),O!==t.CharCode.Backslash);C++);return!(L===C||(O=P.charCodeAt(C+1),isNaN(O)||O===t.CharCode.Backslash))}const p=/[\\/:\*\?"<>\|]/g,$=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(P,O=E.$l){const C=O?p:$;return!(!P||P.length===0||/^\s+$/.test(P)||(C.lastIndex=0,C.test(P))||O&&a.test(P)||P==="."||P===".."||O&&P[P.length-1]==="."||O&&P.length!==P.trim().length||P.length>255)}function m(P,O,C){const L=P===O;return!C||L?L:!P||!O?!1:(0,I.$Kf)(P,O)}function b(P,O,C,L=i.sep){if(P===O)return!0;if(!P||!O||O.length>P.length)return!1;if(C){if(!(0,I.$Lf)(P,O))return!1;if(O.length===P.length)return!0;let z=O.length;return O.charAt(O.length-1)===L&&z--,P.charAt(z)===L}return O.charAt(O.length-1)!==L&&(O+=L),P.indexOf(O)===0}function g(P){return P>=t.CharCode.A&&P<=t.CharCode.Z||P>=t.CharCode.a&&P<=t.CharCode.z}function d(P,O){return E.$l&&P.endsWith(":")&&(P+=i.sep),(0,i.$nc)(P)||(P=(0,i.$oc)(O,P)),P=(0,i.$mc)(P),w(P)}function w(P){return E.$l?(P=(0,I.$sf)(P,i.sep),P.endsWith(":")&&(P+=i.sep)):(P=(0,I.$sf)(P,i.sep),P||(P=i.sep)),P}function o(P){const O=(0,i.$mc)(P);return E.$l?P.length>3?!1:l(O)&&(P.length===2||O.charCodeAt(2)===t.CharCode.Backslash):O===i.$lc.sep}function l(P,O=E.$l){return O?g(P.charCodeAt(0))&&P.charCodeAt(1)===t.CharCode.Colon:!1}function n(P,O=E.$l){return l(P,O)?P[0]:void 0}function u(P,O,C){return O.length>P.length?-1:P===O?0:(C&&(P=P.toLowerCase(),O=O.toLowerCase()),P.indexOf(O))}function r(P){const O=P.split(":");let C,L,R;for(const z of O){const Q=Number(z);(0,D.$ng)(Q)?L===void 0?L=Q:R===void 0&&(R=Q):C=C?[C,z].join(":"):z}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:L!==void 0?L:void 0,column:R!==void 0?R:L!==void 0?1:void 0}}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function k(P,O,C=8){let L="";for(let z=0;z<C;z++){let Q;z===0&&E.$l&&!O&&(C===3||C===4)?Q=h:Q=f,L+=Q.charAt(Math.floor(Math.random()*Q.length))}let R;return O?R=`${O}-${L}`:R=L,P?(0,i.$oc)(P,R):R}}),define(Oe[69],Le([1,0,8]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=void 0,e.$jt=I,e.$kt=D,e.$lt=T,e.$mt=s,e.$it=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},E={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(S){const y=(0,t.$tc)(S),p=i[y.toLowerCase()];return p!==void 0?p:D(S)}function D(S){const y=(0,t.$tc)(S);return E[y.toLowerCase()]}function T(S){for(const y in E)if(E[y]===S)return y}const v=/^(.+)\/(.+?)(;.+)?$/;function s(S,y){const p=v.exec(S);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:y?void 0:S}}),define(Oe[70],Le([1,0,3]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=I,e.$rm=D;var i;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(i||(e.Source=i={}));var E;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function I(T,...v){const s=v.reduce((p,$)=>(p[$]=!0,p),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(T).filter(p=>!s[p]).forEach(p=>{for(let $=0;$<S.length;$++)if(p.search(S[$])!==-1){delete T[p];break}})}function D(T){T&&(delete T.DEBUG,t.$n&&delete T.LD_PRELOAD)}}),define(Oe[4],Le([1,0,34,82,8,3]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$Ac=m,e.$Bc=l,E=We(E);const D=/^\w[\w\d+.-]*$/,T=/^\//,v=/^\/\//;function s(h,k){if(!h.scheme&&k)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!D.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!T.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(h,k){return!h&&!k?"file":h}function y(h,k){switch(h){case"https":case"http":case"file":k?k[0]!==$&&(k=$+k):k=$;break}return k}const p="",$="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(k){return k instanceof c?!0:k?typeof k.authority=="string"&&typeof k.fragment=="string"&&typeof k.path=="string"&&typeof k.query=="string"&&typeof k.scheme=="string"&&typeof k.fsPath=="string"&&typeof k.with=="function"&&typeof k.toString=="function":!1}constructor(k,P,O,C,L,R=!1){typeof k=="object"?(this.scheme=k.scheme||p,this.authority=k.authority||p,this.path=k.path||p,this.query=k.query||p,this.fragment=k.fragment||p):(this.scheme=S(k,R),this.authority=P||p,this.path=y(this.scheme,O||p),this.query=C||p,this.fragment=L||p,s(this,R))}get fsPath(){return l(this,!1)}with(k){if(!k)return this;let{scheme:P,authority:O,path:C,query:L,fragment:R}=k;return P===void 0?P=this.scheme:P===null&&(P=p),O===void 0?O=this.authority:O===null&&(O=p),C===void 0?C=this.path:C===null&&(C=p),L===void 0?L=this.query:L===null&&(L=p),R===void 0?R=this.fragment:R===null&&(R=p),P===this.scheme&&O===this.authority&&C===this.path&&L===this.query&&R===this.fragment?this:new g(P,O,C,L,R)}static parse(k,P=!1){const O=a.exec(k);return O?new g(O[2]||p,f(O[4]||p),f(O[5]||p),f(O[7]||p),f(O[9]||p),P):new g(p,p,p,p,p)}static file(k){let P=p;if(I.$l&&(k=k.replace(/\\/g,$)),k[0]===$&&k[1]===$){const O=k.indexOf($,2);O===-1?(P=k.substring(2),k=$):(P=k.substring(2,O),k=k.substring(O)||$)}return new g("file",P,k,p,p)}static from(k,P){return new g(k.scheme,k.authority,k.path,k.query,k.fragment,P)}static joinPath(k,...P){if(!k.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let O;return I.$l&&k.scheme==="file"?O=c.file(E.$kc.join(l(k,!0),...P)).path:O=E.$lc.join(k.path,...P),k.with({path:O})}toString(k=!1){return n(this,k)}toJSON(){return this}static revive(k){if(k){if(k instanceof c)return k;{const P=new g(k);return P._formatted=k.external??null,P._fsPath=k._sep===b?k.fsPath??null:null,P}}else return k}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=c;function m(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const b=I.$l?1:void 0;class g extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(k=!1){return k?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const k={$mid:i.MarshalledId.Uri};return this._fsPath&&(k.fsPath=this._fsPath,k._sep=b),this._formatted&&(k.external=this._formatted),this.path&&(k.path=this.path),this.scheme&&(k.scheme=this.scheme),this.authority&&(k.authority=this.authority),this.query&&(k.query=this.query),this.fragment&&(k.fragment=this.fragment),k}}const d={[t.CharCode.Colon]:"%3A",[t.CharCode.Slash]:"%2F",[t.CharCode.QuestionMark]:"%3F",[t.CharCode.Hash]:"%23",[t.CharCode.OpenSquareBracket]:"%5B",[t.CharCode.CloseSquareBracket]:"%5D",[t.CharCode.AtSign]:"%40",[t.CharCode.ExclamationMark]:"%21",[t.CharCode.DollarSign]:"%24",[t.CharCode.Ampersand]:"%26",[t.CharCode.SingleQuote]:"%27",[t.CharCode.OpenParen]:"%28",[t.CharCode.CloseParen]:"%29",[t.CharCode.Asterisk]:"%2A",[t.CharCode.Plus]:"%2B",[t.CharCode.Comma]:"%2C",[t.CharCode.Semicolon]:"%3B",[t.CharCode.Equals]:"%3D",[t.CharCode.Space]:"%20"};function w(h,k,P){let O,C=-1;for(let L=0;L<h.length;L++){const R=h.charCodeAt(L);if(R>=t.CharCode.a&&R<=t.CharCode.z||R>=t.CharCode.A&&R<=t.CharCode.Z||R>=t.CharCode.Digit0&&R<=t.CharCode.Digit9||R===t.CharCode.Dash||R===t.CharCode.Period||R===t.CharCode.Underline||R===t.CharCode.Tilde||k&&R===t.CharCode.Slash||P&&R===t.CharCode.OpenSquareBracket||P&&R===t.CharCode.CloseSquareBracket||P&&R===t.CharCode.Colon)C!==-1&&(O+=encodeURIComponent(h.substring(C,L)),C=-1),O!==void 0&&(O+=h.charAt(L));else{O===void 0&&(O=h.substr(0,L));const z=d[R];z!==void 0?(C!==-1&&(O+=encodeURIComponent(h.substring(C,L)),C=-1),O+=z):C===-1&&(C=L)}}return C!==-1&&(O+=encodeURIComponent(h.substring(C))),O!==void 0?O:h}function o(h){let k;for(let P=0;P<h.length;P++){const O=h.charCodeAt(P);O===t.CharCode.Hash||O===t.CharCode.QuestionMark?(k===void 0&&(k=h.substr(0,P)),k+=d[O]):k!==void 0&&(k+=h[P])}return k!==void 0?k:h}function l(h,k){let P;return h.authority&&h.path.length>1&&h.scheme==="file"?P=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===t.CharCode.Slash&&(h.path.charCodeAt(1)>=t.CharCode.A&&h.path.charCodeAt(1)<=t.CharCode.Z||h.path.charCodeAt(1)>=t.CharCode.a&&h.path.charCodeAt(1)<=t.CharCode.z)&&h.path.charCodeAt(2)===t.CharCode.Colon?k?P=h.path.substr(1):P=h.path[1].toLowerCase()+h.path.substr(2):P=h.path,I.$l&&(P=P.replace(/\//g,"\\")),P}function n(h,k){const P=k?o:w;let O="",{scheme:C,authority:L,path:R,query:z,fragment:Q}=h;if(C&&(O+=C,O+=":"),(L||C==="file")&&(O+=$,O+=$),L){let J=L.indexOf("@");if(J!==-1){const x=L.substr(0,J);L=L.substr(J+1),J=x.lastIndexOf(":"),J===-1?O+=P(x,!1,!1):(O+=P(x.substr(0,J),!1,!1),O+=":",O+=P(x.substr(J+1),!1,!0)),O+="@"}L=L.toLowerCase(),J=L.lastIndexOf(":"),J===-1?O+=P(L,!1,!0):(O+=P(L.substr(0,J),!1,!0),O+=L.substr(J))}if(R){if(R.length>=3&&R.charCodeAt(0)===t.CharCode.Slash&&R.charCodeAt(2)===t.CharCode.Colon){const J=R.charCodeAt(1);J>=t.CharCode.A&&J<=t.CharCode.Z&&(R=`/${String.fromCharCode(J+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===t.CharCode.Colon){const J=R.charCodeAt(0);J>=t.CharCode.A&&J<=t.CharCode.Z&&(R=`${String.fromCharCode(J+32)}:${R.substr(2)}`)}O+=P(R,!0,!1)}return z&&(O+="?",O+=P(z,!1,!1)),Q&&(O+="#",O+=k?Q:w(Q,!1,!1)),O}function u(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+u(h.substr(3)):h}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(h){return h.match(r)?h.replace(r,k=>u(k)):h}}),define(Oe[191],Le([1,0,4]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=i,e.$or=E,e.$pr=I,e.log=T;function i(s){const S=s;return S&&typeof S.type=="string"&&typeof S.severity=="string"}function E(s){const S=[];let y;try{const p=JSON.parse(s.arguments),$=p[p.length-1];$&&$.__$stack&&(p.pop(),y=$.__$stack),S.push(...p)}catch{S.push("Unable to log remote console arguments",s.arguments)}return{args:S,stack:y}}function I(s){if(typeof s!="string")return I(E(s).stack);const S=s;if(S){const y=D(S),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(p&&p.length===4)return{uri:t.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function D(s){if(!s)return s;const S=s.indexOf(`
`);return S===-1?s:s.substring(0,S)}function T(s,S){const{args:y,stack:p}=E(s),$=typeof y[0]=="string"&&y.length===1;let a=D(p);a&&(a=`(${a.trim()})`);let c=[];if(typeof y[0]=="string"?a&&$?c=[`%c[${S}] %c${y[0]} %c${a}`,v("blue"),v(""),v("grey")]:c=[`%c[${S}] %c${y[0]}`,v("blue"),v(""),...y.slice(1)]:c=[`%c[${S}]%`,v("blue"),...y],a&&!$&&c.push(a),typeof console[s.severity]!="function")throw new Error("Unknown console method");console[s.severity].apply(console,c)}function v(s){return`color: ${s}`}}),define(Oe[49],Le([1,0,14,4,82]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=I,e.$gi=D,e.$hi=v;function I(s){return JSON.stringify(s,T)}function D(s){let S=JSON.parse(s);return S=v(S),S}function T(s,S){return S instanceof RegExp?{$mid:E.MarshalledId.Regexp,source:S.source,flags:S.flags}:S}function v(s,S=0){if(!s||S>200)return s;if(typeof s=="object"){switch(s.$mid){case E.MarshalledId.Uri:return i.URI.revive(s);case E.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case E.MarshalledId.Date:return new Date(s.source)}if(s instanceof t.$Se||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let y=0;y<s.length;++y)s[y]=v(s[y],S+1);else for(const y in s)Object.hasOwnProperty.call(s,y)&&(s[y]=v(s[y],S+1))}return s}}),define(Oe[12],Le([1,0,9,3,16,4,8]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Xg=e.$Wg=e.$Vg=e.Schemas=void 0,e.$Tg=v,e.$Ug=s,e.$Yg=y,t=We(t),i=We(i),D=We(D);var T;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",a.vscodeNotebookMetadata="vscode-notebook-metadata",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting",a.outputChannel="output"})(T||(e.Schemas=T={}));function v(a,c){return I.URI.isUri(a)?(0,E.$Kf)(a.scheme,c):(0,E.$Lf)(a,c+":")}function s(a,...c){return c.some(m=>v(a,m))}e.$Vg="vscode-tkn",e.$Wg="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,m){this.f=y(c,m)}getServerRootPath(){return this.f}get g(){return D.$lc.join(this.f,T.vscodeRemoteResource)}set(c,m,b){this.a[c]=m,this.b[c]=b}setConnectionToken(c,m){this.c[c]=m}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(o){return t.$4(o),c}const m=c.authority;let b=this.a[m];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const g=this.b[m],d=this.c[m];let w=`path=${encodeURIComponent(c.path)}`;return typeof d=="string"&&(w+=`&${e.$Wg}=${encodeURIComponent(d)}`),I.URI.from({scheme:i.$r?this.d:T.vscodeRemoteResource,authority:`${b}:${g}`,path:i.$r?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:w})}}e.$Xg=new S;function y(a,c){return D.$lc.join(c??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.$Zg="vs/../../extensions",e.$1g="vs/../../node_modules",e.$2g="vs/../../node_modules.asar",e.$3g="vs/../../node_modules.asar.unpacked",e.$4g="vscode-app";class p{static{this.a=e.$4g}asBrowserUri(c){const m=this.b(c,ue);return this.uriToBrowserUri(m)}uriToBrowserUri(c){return c.scheme===T.vscodeRemote?e.$Xg.rewrite(c):c.scheme===T.file&&(i.$p||i.$t===`${T.vscodeFileResource}://${p.a}`)?c.with({scheme:T.vscodeFileResource,authority:c.authority||p.a,query:null,fragment:null}):c}asFileUri(c){const m=this.b(c,ue);return this.uriToFileUri(m)}uriToFileUri(c){return c.scheme===T.vscodeFileResource?c.with({scheme:T.file,authority:c.authority!==p.a?c.authority:null,query:null,fragment:null}):c}b(c,m){if(I.URI.isUri(c))return c;if(globalThis._VSCODE_FILE_ROOT){const b=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(b))return I.URI.joinPath(I.URI.parse(b,!0),c);const g=D.$oc(b,c);return I.URI.file(g)}return I.URI.parse(m.toUrl(c))}}e.$5g=new p;var $;(function(a){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(c.get("3"));const m="vscode-coi";function b(d){let w;typeof d=="string"?w=new URL(d).searchParams:d instanceof URL?w=d.searchParams:I.URI.isUri(d)&&(w=new URL(d.toString(!0)).searchParams);const o=w?.get(m);if(o)return c.get(o)}a.getHeadersFromQuery=b;function g(d,w,o){if(!globalThis.crossOriginIsolated)return;const l=w&&o?"3":o?"2":"1";d instanceof URLSearchParams?d.set(m,l):d[m]=l}a.addSearchParam=g})($||(e.COI=$={}))}),define(Oe[112],Le([1,0,65,12,3,10,4]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=S,e.$Cq=y,E=We(E);class T{constructor($,a,c){this.id=$,this.dependencies=a,this.callback=c}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,a,c)=>{typeof $!="string"&&(c=a,a=$,$=null),(typeof a!="object"||!Array.isArray(a))&&(c=a,a=null),this.c.push(new T($,a,c))},globalThis.define.amd=!0,this.b?this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith(`${i.Schemas.vscodeFileResource}://${i.$4g}`))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const a=await(this.a?this.i($):this.b?this.h($):this.j($));if(!a){console.warn(`Did not receive a define call from script ${$}`);return}const c={},m=[],b=[];if(Array.isArray(a.dependencies))for(const g of a.dependencies)g==="exports"?m.push(c):b.push(g);if(b.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${b.join(", ")}`);return typeof a.callback=="function"?a.callback(...m)??c:a.callback}h($){return new Promise((a,c)=>{const m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript");const b=()=>{m.removeEventListener("load",g),m.removeEventListener("error",d)},g=w=>{b(),a(this.c.pop())},d=w=>{b(),c(w)};m.addEventListener("load",g),m.addEventListener("error",d),this.f&&($=this.f.createScriptURL($)),m.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(m)})}async i($){return this.f&&($=this.f.createScriptURL($)),t.$V?await new Promise((a,c)=>{ue([$],a,c)}).then(We):importScripts($),this.c.pop()}async j($){try{const a=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,m=globalThis._VSCODE_NODE_MODULES.module,b=D.URI.parse($).fsPath,g=a.readFileSync(b).toString(),d=m.wrap(g.replace(/^#!.*/,""));return new c.Script(d).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const s=new Map;async function S(p,$,a){if(t.$V){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit);const c=$?`${p}/${$}`:p;if(s.has(c))return s.get(c);let m;if(/^\w[\w\d+.-]*:\/\//.test(c))m=c;else{const w=`${t.$W&&a&&!E.$r?i.$2g:i.$1g}/${c}`;m=i.$5g.asBrowserUri(w).toString(!0)}const b=v.INSTANCE.load(m);return s.set(c,b),b}else return await new Promise((c,m)=>{ue([p],c,m)}).then(We)}function y(p,$){(0,I.$tg)(t.$V);const c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,m=t.$W&&c&&!E.$r,b=`${p}/${$}`,d=`${m?i.$2g:i.$1g}/${b}`;return i.$5g.asBrowserUri(d).toString(!0)}}),define(Oe[19],Le([1,0,34,36,12,8,3,16,4]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$_g=s,e.$uh=y,e.$vh=$,i=We(i),I=We(I);function s(a){return(0,v.$Bc)(a,!0)}class S{constructor(c){this.a=c}compare(c,m,b=!1){return c===m?0:(0,T.$Df)(this.getComparisonKey(c,b),this.getComparisonKey(m,b))}isEqual(c,m,b=!1){return c===m?!0:!c||!m?!1:this.getComparisonKey(c,b)===this.getComparisonKey(m,b)}getComparisonKey(c,m=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,m,b=!1){if(c.scheme===m.scheme){if(c.scheme===E.Schemas.file)return i.$Jg(s(c),s(m),this.a(c))&&c.query===m.query&&(b||c.fragment===m.fragment);if((0,e.$qh)(c.authority,m.authority))return i.$Jg(c.path,m.path,this.a(c),"/")&&c.query===m.query&&(b||c.fragment===m.fragment)}return!1}joinPath(c,...m){return v.URI.joinPath(c,...m)}basenameOrAuthority(c){return(0,e.$ih)(c)||c.authority}basename(c){return I.$lc.basename(c.path)}extname(c){return I.$lc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let m;return c.scheme===E.Schemas.file?m=v.URI.file(I.$rc(s(c))).path:(m=I.$lc.dirname(c.path),c.authority&&m.length&&m.charCodeAt(0)!==t.CharCode.Slash&&(console.error(`dirname("${c.toString})) resulted in a relative path`),m="/")),c.with({path:m})}normalizePath(c){if(!c.path.length)return c;let m;return c.scheme===E.Schemas.file?m=v.URI.file(I.$mc(s(c))).path:m=I.$lc.normalize(c.path),c.with({path:m})}relativePath(c,m){if(c.scheme!==m.scheme||!(0,e.$qh)(c.authority,m.authority))return;if(c.scheme===E.Schemas.file){const d=I.$qc(s(c),s(m));return D.$l?i.$Dg(d):d}let b=c.path||"/";const g=m.path||"/";if(this.a(c)){let d=0;for(const w=Math.min(b.length,g.length);d<w&&!(b.charCodeAt(d)!==g.charCodeAt(d)&&b.charAt(d).toLowerCase()!==g.charAt(d).toLowerCase());d++);b=g.substr(0,d)+b.substr(d)}return I.$lc.relative(b,g)}resolvePath(c,m){if(c.scheme===E.Schemas.file){const b=v.URI.file(I.$pc(s(c),m));return c.with({authority:b.authority,path:b.path})}return m=i.$Eg(m),c.with({path:I.$lc.resolve(c.path,m)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,m){return c===m||c!==void 0&&m!==void 0&&(0,T.$Kf)(c,m)}hasTrailingPathSeparator(c,m=I.sep){if(c.scheme===E.Schemas.file){const b=s(c);return b.length>i.$Fg(b).length&&b[b.length-1]===m}else{const b=c.path;return b.length>1&&b.charCodeAt(b.length-1)===t.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,m=I.sep){return(0,e.$rh)(c,m)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,m=I.sep){let b=!1;if(c.scheme===E.Schemas.file){const g=s(c);b=g!==void 0&&g.length===i.$Fg(g).length&&g[g.length-1]===m}else{m="/";const g=c.path;b=g.length===1&&g.charCodeAt(g.length-1)===t.CharCode.Slash}return!b&&!(0,e.$rh)(c,m)?c.with({path:c.path+"/"}):c}}e.$ah=S,e.$bh=new S(()=>!1),e.$ch=new S(a=>a.scheme===E.Schemas.file?!D.$n:!0),e.$dh=new S(a=>!0),e.$eh=e.$bh.isEqual.bind(e.$bh),e.$fh=e.$bh.isEqualOrParent.bind(e.$bh),e.$gh=e.$bh.getComparisonKey.bind(e.$bh),e.$hh=e.$bh.basenameOrAuthority.bind(e.$bh),e.$ih=e.$bh.basename.bind(e.$bh),e.$jh=e.$bh.extname.bind(e.$bh),e.$kh=e.$bh.dirname.bind(e.$bh),e.$lh=e.$bh.joinPath.bind(e.$bh),e.$mh=e.$bh.normalizePath.bind(e.$bh),e.$nh=e.$bh.relativePath.bind(e.$bh),e.$oh=e.$bh.resolvePath.bind(e.$bh),e.$ph=e.$bh.isAbsolutePath.bind(e.$bh),e.$qh=e.$bh.isEqualAuthority.bind(e.$bh),e.$rh=e.$bh.hasTrailingPathSeparator.bind(e.$bh),e.$sh=e.$bh.removeTrailingPathSeparator.bind(e.$bh),e.$th=e.$bh.addTrailingPathSeparator.bind(e.$bh);function y(a,c){const m=[];for(let b=0;b<a.length;b++){const g=c(a[b]);a.some((d,w)=>w===b?!1:(0,e.$fh)(g,c(d)))||m.push(a[b])}return m}var p;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function c(m){const b=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(w=>{const[o,l]=w.split(":");o&&l&&b.set(o,l)});const d=m.path.substring(0,m.path.indexOf(";"));return d&&b.set(a.META_DATA_MIME,d),b}a.parseMetaData=c})(p||(e.DataUri=p={}));function $(a,c,m){if(c){let b=a.path;return b&&b[0]!==I.$lc.sep&&(b=I.$lc.sep+b),a.with({scheme:m,authority:c,path:b})}return a.with({scheme:m})}}),define(Oe[13],Le([1,0,18,9,6,2,19,3,174,66]),function(ue,e,t,i,E,I,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$_h=e.$$h=e.$0h=e.$9h=e.Promises=e.$8h=e.$7h=e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0,e.$wh=S,e.$xh=y,e.$yh=p,e.$zh=$,e.$Ah=a,e.$Bh=c,e.$Ch=m,e.$Dh=b,e.$Lh=h,e.$Mh=k,e.$Nh=P,e.$Oh=O,e.$Ph=C,e.$5h=U,e.$ai=ne;function S(G){return!!G&&typeof G.then=="function"}function y(G){const Z=new t.$Be,ce=G(Z.token),we=new Promise((Ie,Me)=>{const Be=Z.token.onCancellationRequested(()=>{Be.dispose(),Me(new i.$9)});Promise.resolve(ce).then(De=>{Be.dispose(),Z.dispose(),Ie(De)},De=>{Be.dispose(),Z.dispose(),Me(De)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(Ie,Me){return we.then(Ie,Me)}catch(Ie){return this.then(void 0,Ie)}finally(Ie){return we.finally(Ie)}}}function p(G,Z,ce){return new Promise((we,Ie)=>{const Me=Z.onCancellationRequested(()=>{Me.dispose(),we(ce)});G.then(we,Ie).finally(()=>Me.dispose())})}function $(G,Z){return new Promise((ce,we)=>{const Ie=Z.onCancellationRequested(()=>{Ie.dispose(),we(new i.$9)});G.then(ce,we).finally(()=>Ie.dispose())})}async function a(G){let Z=-1;const ce=G.map((we,Ie)=>we.then(Me=>(Z=Ie,Me)));try{return await Promise.race(ce)}finally{G.forEach((we,Ie)=>{Ie!==Z&&we.cancel()})}}function c(G,Z,ce){let we;const Ie=setTimeout(()=>{we?.(void 0),ce?.()},Z);return Promise.race([G.finally(()=>clearTimeout(Ie)),new Promise(Me=>we=Me)])}function m(G){return new Promise((Z,ce)=>{const we=G();S(we)?we.then(Z,ce):Z(we)})}function b(){let G,Z;return{promise:new Promise((we,Ie)=>{G=we,Z=Ie}),resolve:G,reject:Z}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const ce=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(ce,ce).then(we)})}return new Promise((ce,we)=>{this.b.then(ce,we)})}return this.a=Z(),new Promise((ce,we)=>{this.a.then(Ie=>{this.a=null,ce(Ie)},Ie=>{this.a=null,we(Ie)})})}dispose(){this.f=!0}}e.$Eh=g;class d{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$Fh=d;class w{constructor(){this.a=new Map}queue(Z,ce){const Ie=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(ce).finally(()=>{this.a.get(Z)===Ie&&this.a.delete(Z)});return this.a.set(Z,Ie),Ie}}e.$Gh=w;const o=(G,Z)=>{let ce=!0;const we=setTimeout(()=>{ce=!1,Z()},G);return{isTriggered:()=>ce,dispose:()=>{clearTimeout(we),ce=!1}}},l=G=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,G())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class n{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,ce=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((Ie,Me)=>{this.d=Ie,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const Ie=this.g;return this.g=null,Ie()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=ce===v.$le?l(we):o(ce,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.$9),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Hh=n;class u{constructor(Z){this.a=new n(Z),this.b=new g}trigger(Z,ce){return this.a.trigger(()=>this.b.queue(Z),ce)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ih=u;class r{constructor(){this.a=!1,this.b=new Promise((Z,ce)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Jh=r;class f extends r{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Kh=f;function h(G,Z){return Z?new Promise((ce,we)=>{const Ie=setTimeout(()=>{Me.dispose(),ce()},G),Me=Z.onCancellationRequested(()=>{clearTimeout(Ie),Me.dispose(),we(new i.$9)})}):y(ce=>h(G,ce))}function k(G,Z=0,ce){const we=setTimeout(()=>{G(),ce&&Ie.dispose()},Z),Ie=(0,I.$Xc)(()=>{clearTimeout(we),ce?.deleteAndLeak(Ie)});return ce?.add(Ie),Ie}function P(G){const Z=[];let ce=0;const we=G.length;function Ie(){return ce<we?G[ce++]():null}function Me(Be){Be!=null&&Z.push(Be);const De=Ie();return De?De.then(Me):Promise.resolve(Z)}return Promise.resolve(null).then(Me)}function O(G,Z=we=>!!we,ce=null){let we=0;const Ie=G.length,Me=()=>{if(we>=Ie)return Promise.resolve(ce);const Be=G[we++];return Promise.resolve(Be()).then(Ne=>Z(Ne)?Promise.resolve(Ne):Me())};return Me()}function C(G,Z=we=>!!we,ce=null){if(G.length===0)return Promise.resolve(ce);let we=G.length;const Ie=()=>{we=-1;for(const Me of G)Me.cancel?.()};return new Promise((Me,Be)=>{for(const De of G)De.then(Ne=>{--we>=0&&Z(Ne)?(Ie(),Me(Ne)):we===0&&Me(ce)}).catch(Ne=>{--we>=0&&(Ie(),Be(Ne))})})}class L{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new E.$qe}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ce,we)=>{this.g.push({factory:Z,c:ce,e:we}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const ce=Z.factory();ce.then(Z.c,Z.e),ce.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Qh=L;class R extends L{constructor(){super(1)}}e.$Rh=R;class z{constructor(){this.a=new te,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Sh=z;class Q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new oe;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,ce=D.$bh){const we=ce.getComparisonKey(Z);return this.a.get(we)?.size??0}queueFor(Z,ce,we=D.$bh){const Ie=we.getComparisonKey(Z);let Me=this.a.get(Ie);if(!Me){Me=new R;const Be=this.f++,De=E.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(Ie),this.h(),this.d?.deleteAndDispose(Be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$9c),this.d.set(Be,De),this.a.set(Ie,Me)}return Me.queue(ce)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Th=Q;class J{constructor(Z,ce){this.b=!1,this.a=-1,typeof Z=="function"&&typeof ce=="number"&&this.setIfNotSet(Z,ce)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,ce){if(this.b)throw new i.$gb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},ce)}setIfNotSet(Z,ce){if(this.b)throw new i.$gb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},ce))}}e.$Uh=J;class x{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,ce,we=globalThis){if(this.f)throw new i.$gb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const Ie=we.setInterval(()=>{Z()},ce);this.d=(0,I.$Xc)(()=>{we.clearInterval(Ie),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Vh=x;class ve{constructor(Z,ce){this.b=-1,this.a=Z,this.d=ce,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Wh=ve;class be{constructor(Z,ce){ce%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ce}ms is not a multiple of 1000ms.`),this.a=Z,this.b=ce,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Xh=be;class se extends ve{constructor(Z,ce){super(Z,ce),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Yh=se;class V extends I.$Zc{constructor(Z,ce){super(),this.g=Z,this.h=ce,this.a=[],this.b=this.B(new I.$1c),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ce of Z)this.a.push(ce);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ve(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Zh=V,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$2h=(G,Z)=>{(0,T.$E)(()=>{if(ce)return;const we=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,we-Date.now())}}))});let ce=!1;return{dispose(){ce||(ce=!0)}}}:e.$2h=(G,Z,ce)=>{const we=G.requestIdleCallback(Z,typeof ce=="number"?{timeout:ce}:void 0);let Ie=!1;return{dispose(){Ie||(Ie=!0,G.cancelIdleCallback(we))}}},e.$1h=G=>(0,e.$2h)(globalThis,G)}();class B{constructor(Z,ce){this.g=!1,this.d=()=>{try{this.j=ce()}catch(we){this.l=we}finally{this.g=!0}},this.f=(0,e.$2h)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$3h=B;class j extends B{constructor(Z){super(globalThis,Z)}}e.$4h=j;async function U(G,Z,ce){let we;for(let Ie=0;Ie<ce;Ie++)try{return await G()}catch(Me){we=Me,await h(Z)}throw we}class te{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,ce,we){return this.a={taskId:Z,cancel:()=>we?.(),promise:ce},ce.then(()=>this.d(Z),()=>this.d(Z)),ce}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:ce,resolve:we,reject:Ie}=b();this.b={run:Z,promise:ce,promiseResolve:we,promiseReject:Ie}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$6h=te;class le{constructor(Z,ce=()=>Date.now()){this.d=Z,this.f=ce,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$7h=le;var ye;(function(G){G[G.Resolved=0]="Resolved",G[G.Rejected=1]="Rejected"})(ye||(ye={}));class oe{get isRejected(){return this.d?.outcome===ye.Rejected}get isResolved(){return this.d?.outcome===ye.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ye.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,ce)=>{this.a=Z,this.b=ce})}complete(Z){return new Promise(ce=>{this.a(Z),this.d={outcome:ye.Resolved,value:Z},ce()})}error(Z){return new Promise(ce=>{this.b(Z),this.d={outcome:ye.Rejected,value:Z},ce()})}cancel(){return this.error(new i.$9)}}e.$8h=oe;var _;(function(G){async function Z(we){let Ie;const Me=await Promise.all(we.map(Be=>Be.then(De=>De,De=>{Ie||(Ie=De)})));if(typeof Ie<"u")throw Ie;return Me}G.settled=Z;function ce(we){return new Promise(async(Ie,Me)=>{try{await we(Ie,Me)}catch(Be){Me(Be)}})}G.withAsyncBody=ce})(_||(e.Promises=_={}));class X{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(ce=>(this.a=ce,this.d=!0,ce),ce=>{throw this.b=ce,this.d=!0,ce})}requireValue(){if(!this.d)throw new i.$gb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$9h=X;class M{constructor(Z){this.b=Z,this.a=new s.$Y(()=>new X(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$0h=M;var A;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(A||(A={}));class Y{static fromArray(Z){return new Y(ce=>{ce.emitMany(Z)})}static fromPromise(Z){return new Y(async ce=>{ce.emitMany(await Z)})}static fromPromises(Z){return new Y(async ce=>{await Promise.all(Z.map(async we=>ce.emitOne(await we)))})}static merge(Z){return new Y(async ce=>{await Promise.all(Z.map(async we=>{for await(const Ie of we)ce.emitOne(Ie)}))})}static{this.EMPTY=Y.fromArray([])}constructor(Z,ce){this.a=A.Initial,this.b=[],this.d=null,this.f=ce,this.g=new E.$qe,queueMicrotask(async()=>{const we={emitOne:Ie=>this.h(Ie),emitMany:Ie=>this.j(Ie),reject:Ie=>this.l(Ie)};try{await Promise.resolve(Z(we)),this.k()}catch(Ie){this.l(Ie)}finally{we.emitOne=void 0,we.emitMany=void 0,we.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===A.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===A.DoneOK)return{done:!0,value:void 0};await E.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,ce){return new Y(async we=>{for await(const Ie of Z)we.emitOne(ce(Ie))})}map(Z){return Y.map(this,Z)}static filter(Z,ce){return new Y(async we=>{for await(const Ie of Z)ce(Ie)&&we.emitOne(Ie)})}filter(Z){return Y.filter(this,Z)}static coalesce(Z){return Y.filter(Z,ce=>!!ce)}coalesce(){return Y.coalesce(this)}static async toPromise(Z){const ce=[];for await(const we of Z)ce.push(we);return ce}toPromise(){return Y.toPromise(this)}h(Z){this.a===A.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===A.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===A.Initial&&(this.a=A.DoneOK,this.g.fire())}l(Z){this.a===A.Initial&&(this.a=A.DoneError,this.d=Z,this.g.fire())}}e.$$h=Y;class pe extends Y{constructor(Z,ce){super(ce),this.m=Z}cancel(){this.m.cancel()}}e.$_h=pe;function ne(G){const Z=new t.$Be,ce=G(Z.token);return new pe(Z,async we=>{const Ie=Z.token.onCancellationRequested(()=>{Ie.dispose(),Z.dispose(),we.reject(new i.$9)});try{for await(const Me of ce){if(Z.token.isCancellationRequested)return;we.emitOne(Me)}Ie.dispose(),Z.dispose()}catch(Me){Ie.dispose(),Z.dispose(),we.reject(Me)}})}class ie{constructor(Z){this.a=new oe,this.b=new Y(Ie=>{if(ce){Ie.reject(ce);return}return we&&Ie.emitMany(we),this.d=Me=>Ie.reject(Me),this.f=Me=>Ie.emitOne(Me),this.a.p},Z);let ce,we;this.f=Ie=>{we||(we=[]),we.push(Ie)},this.d=Ie=>{ce||(ce=Ie)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$bi=ie}),define(Oe[86],Le([1,0,17,13,34,36,25,8,3,16]),function(ue,e,t,i,E,I,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=void 0,e.$Ak=S,e.$Dk=c,e.$Ek=z,e.$Fk=Q,e.$Gk=J,e.$Hk=x,e.$Ik=ve,e.$Jk=B;function S(){return Object.create(null)}e.$Bk="**",e.$Ck="/";const y="[/\\\\]",p="[^/\\\\]",$=/\//g;function a(j,U){switch(j){case 0:return"";case 1:return`${p}*?`;default:return`(?:${y}|${p}+${y}${U?`|${y}${p}+`:""})*?`}}function c(j,U){if(!j)return[];const te=[];let le=!1,ye=!1,oe="";for(const _ of j){switch(_){case U:if(!le&&!ye){te.push(oe),oe="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}oe+=_}return oe&&te.push(oe),te}function m(j){if(!j)return"";let U="";const te=c(j,e.$Ck);if(te.every(le=>le===e.$Bk))U=".*";else{let le=!1;te.forEach((ye,oe)=>{if(ye===e.$Bk){if(le)return;U+=a(2,oe===te.length-1)}else{let _=!1,X="",M=!1,A="";for(const Y of ye){if(Y!=="}"&&_){X+=Y;continue}if(M&&(Y!=="]"||!A)){let pe;Y==="-"?pe=Y:(Y==="^"||Y==="!")&&!A?pe="^":Y===e.$Ck?pe="":pe=(0,s.$mf)(Y),A+=pe;continue}switch(Y){case"{":_=!0;continue;case"[":M=!0;continue;case"}":{const ne=`(?:${c(X,",").map(ie=>m(ie)).join("|")})`;U+=ne,_=!1,X="";break}case"]":{U+="["+A+"]",M=!1,A="";break}case"?":U+=p;continue;case"*":U+=a(1);continue;default:U+=(0,s.$mf)(Y)}}oe<te.length-1&&(te[oe+1]!==e.$Bk||oe+2<te.length)&&(U+=y)}le=ye===e.$Bk})}return U}const b=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new D.$Ic(1e4),u=function(){return!1},r=function(){return null};function f(j,U){if(!j)return r;let te;typeof j!="string"?te=j.pattern:te=j,te=te.trim();const le=`${te}_${!!U.trimForExclusions}`;let ye=n.get(le);if(ye)return h(ye,j);let oe;return b.test(te)?ye=P(te.substr(4),te):(oe=g.exec(k(te,U)))?ye=O(oe[1],te):(U.trimForExclusions?w:d).test(te)?ye=C(te,U):(oe=o.exec(k(te,U)))?ye=L(oe[1].substr(1),te,!0):(oe=l.exec(k(te,U)))?ye=L(oe[1],te,!1):ye=R(te),n.set(le,ye),h(ye,j)}function h(j,U){if(typeof U=="string")return j;const te=function(le,ye){return(0,I.$Jg)(le,U.base,!v.$n)?j((0,s.$rf)(le.substr(U.base.length),T.sep),ye):null};return te.allBasenames=j.allBasenames,te.allPaths=j.allPaths,te.basenames=j.basenames,te.patterns=j.patterns,te}function k(j,U){return U.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function P(j,U){return function(te,le){return typeof te=="string"&&te.endsWith(j)?U:null}}function O(j,U){const te=`/${j}`,le=`\\${j}`,ye=function(_,X){return typeof _!="string"?null:X?X===j?U:null:_===j||_.endsWith(te)||_.endsWith(le)?U:null},oe=[j];return ye.basenames=oe,ye.patterns=[U],ye.allBasenames=oe,ye}function C(j,U){const te=V(j.slice(1,-1).split(",").map(X=>f(X,U)).filter(X=>X!==r),j),le=te.length;if(!le)return r;if(le===1)return te[0];const ye=function(X,M){for(let A=0,Y=te.length;A<Y;A++)if(te[A](X,M))return j;return null},oe=te.find(X=>!!X.allBasenames);oe&&(ye.allBasenames=oe.allBasenames);const _=te.reduce((X,M)=>M.allPaths?X.concat(M.allPaths):X,[]);return _.length&&(ye.allPaths=_),ye}function L(j,U,te){const le=T.sep===T.$lc.sep,ye=le?j:j.replace($,T.sep),oe=T.sep+ye,_=T.$lc.sep+j;let X;return te?X=function(M,A){return typeof M=="string"&&(M===ye||M.endsWith(oe)||!le&&(M===j||M.endsWith(_)))?U:null}:X=function(M,A){return typeof M=="string"&&(M===ye||!le&&M===j)?U:null},X.allPaths=[(te?"*/":"./")+j],X}function R(j){try{const U=new RegExp(`^${m(j)}$`);return function(te){return U.lastIndex=0,typeof te=="string"&&U.test(te)?j:null}}catch{return r}}function z(j,U,te){return!j||typeof U!="string"?!1:Q(j)(U,void 0,te)}function Q(j,U={}){if(!j)return u;if(typeof j=="string"||J(j)){const te=f(j,U);if(te===r)return u;const le=function(ye,oe){return!!te(ye,oe)};return te.allBasenames&&(le.allBasenames=te.allBasenames),te.allPaths&&(le.allPaths=te.allPaths),le}return be(j,U)}function J(j){const U=j;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}function x(j){return j.allBasenames||[]}function ve(j){return j.allPaths||[]}function be(j,U){const te=V(Object.getOwnPropertyNames(j).map(X=>se(X,j[X],U)).filter(X=>X!==r)),le=te.length;if(!le)return r;if(!te.some(X=>!!X.requiresSiblings)){if(le===1)return te[0];const X=function(Y,pe){let ne;for(let ie=0,G=te.length;ie<G;ie++){const Z=te[ie](Y,pe);if(typeof Z=="string")return Z;(0,i.$wh)(Z)&&(ne||(ne=[]),ne.push(Z))}return ne?(async()=>{for(const ie of ne){const G=await ie;if(typeof G=="string")return G}return null})():null},M=te.find(Y=>!!Y.allBasenames);M&&(X.allBasenames=M.allBasenames);const A=te.reduce((Y,pe)=>pe.allPaths?Y.concat(pe.allPaths):Y,[]);return A.length&&(X.allPaths=A),X}const ye=function(X,M,A){let Y,pe;for(let ne=0,ie=te.length;ne<ie;ne++){const G=te[ne];G.requiresSiblings&&A&&(M||(M=(0,T.$sc)(X)),Y||(Y=M.substr(0,M.length-(0,T.$tc)(X).length)));const Z=G(X,M,Y,A);if(typeof Z=="string")return Z;(0,i.$wh)(Z)&&(pe||(pe=[]),pe.push(Z))}return pe?(async()=>{for(const ne of pe){const ie=await ne;if(typeof ie=="string")return ie}return null})():null},oe=te.find(X=>!!X.allBasenames);oe&&(ye.allBasenames=oe.allBasenames);const _=te.reduce((X,M)=>M.allPaths?X.concat(M.allPaths):X,[]);return _.length&&(ye.allPaths=_),ye}function se(j,U,te){if(U===!1)return r;const le=f(j,te);if(le===r)return r;if(typeof U=="boolean")return le;if(U){const ye=U.when;if(typeof ye=="string"){const oe=(_,X,M,A)=>{if(!A||!le(_,X))return null;const Y=ye.replace("$(basename)",()=>M),pe=A(Y);return(0,i.$wh)(pe)?pe.then(ne=>ne?j:null):pe?j:null};return oe.requiresSiblings=!0,oe}}return le}function V(j,U){const te=j.filter(X=>!!X.basenames);if(te.length<2)return j;const le=te.reduce((X,M)=>{const A=M.basenames;return A?X.concat(A):X},[]);let ye;if(U){ye=[];for(let X=0,M=le.length;X<M;X++)ye.push(U)}else ye=te.reduce((X,M)=>{const A=M.patterns;return A?X.concat(A):X},[]);const oe=function(X,M){if(typeof X!="string")return null;if(!M){let Y;for(Y=X.length;Y>0;Y--){const pe=X.charCodeAt(Y-1);if(pe===E.CharCode.Slash||pe===E.CharCode.Backslash)break}M=X.substr(Y)}const A=le.indexOf(M);return A!==-1?ye[A]:null};oe.basenames=le,oe.patterns=ye,oe.allBasenames=le;const _=j.filter(X=>!X.basenames);return _.push(oe),_}function B(j,U){return(0,t.$yb)(j,U,(te,le)=>typeof te=="string"&&typeof le=="string"?te===le:typeof te!="string"&&typeof le!="string"?te.base===le.base&&te.pattern===le.pattern:!1)}}),define(Oe[113],Le([1,0,9,177,19,16,4]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.MarkdownStringTextNewlineStyle=void 0,e.$0k=s,e.$$k=S,e.$_k=y,e.$al=p,e.$bl=$,e.$cl=a,e.$dl=c,e.$el=m;var T;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class v{constructor(g="",d=!1){if(this.value=g,typeof this.value!="string")throw(0,t.$$)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(g,d=T.Paragraph){return this.value+=p(this.supportThemeIcons?(0,i.$3k)(g):g).replace(/([ \t]+)/g,(w,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===T.Break?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,d){return this.value+=`
${$(d,g)}
`,this}appendLink(g,d,w){return this.value+="[",this.value+=this.c(d,"]"),this.value+="](",this.value+=this.c(String(g),")"),w&&(this.value+=` "${this.c(this.c(w,'"'),")")}"`),this.value+=")",this}c(g,d){const w=new RegExp((0,I.$mf)(d),"g");return g.replace(w,(o,l)=>g.charAt(l-1)!=="\\"?`\\${o}`:o)}}e.$9k=v;function s(b){return S(b)?!b.value:Array.isArray(b)?b.every(s):!0}function S(b){return b instanceof v?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||typeof b.isTrusted=="object"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}function y(b,g){return b===g?!0:!b||!g?!1:b.value===g.value&&b.isTrusted===g.isTrusted&&b.supportThemeIcons===g.supportThemeIcons&&b.supportHtml===g.supportHtml&&(b.baseUri===g.baseUri||!!b.baseUri&&!!g.baseUri&&(0,E.$eh)(D.URI.from(b.baseUri),D.URI.from(g.baseUri)))}function p(b){return b.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function $(b,g){const d=b.match(/^`+/gm)?.reduce((o,l)=>o.length>l.length?o:l).length??0,w=d>=3?d+1:3;return[`${"`".repeat(w)}${g}`,b,`${"`".repeat(w)}`].join(`
`)}function a(b){return b.replace(/"/g,"&quot;")}function c(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(b){const g=[],d=b.split("|").map(o=>o.trim());b=d[0];const w=d[1];if(w){const o=/height=(\d+)/.exec(w),l=/width=(\d+)/.exec(w),n=o?o[1]:"",u=l?l[1]:"",r=isFinite(parseInt(u)),f=isFinite(parseInt(n));r&&g.push(`width="${u}"`),f&&g.push(`height="${n}"`)}return{href:b,dimensions:g}}}),define(Oe[192],Le([1,0,17,36,8,3,19,16]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$w=v,e.$_w=S,e.$ax=p,e.$bx=$,e.$cx=b,e.$dx=d,e.$ex=w,e.$fx=o,e.$gx=l,e.$hx=n;function v(r,f){const{os:h,tildify:k,relative:P}=f;if(P){const L=s(r,P,h);if(typeof L=="string")return L}let O=r.fsPath;if(h===I.OperatingSystem.Windows&&!I.$l?O=O.replace(/\//g,"\\"):h!==I.OperatingSystem.Windows&&I.$l&&(O=O.replace(/\\/g,"/")),h!==I.OperatingSystem.Windows&&k?.userHome){const L=k.userHome.fsPath;let R;r.scheme!==k.userHome.scheme&&r.path[0]===E.$lc.sep&&r.path[1]!==E.$lc.sep?R=k.userHome.with({path:r.path}).fsPath:R=O,O=p(R,L,h)}return(h===I.OperatingSystem.Windows?E.$kc:E.$lc).normalize(S(O,h===I.OperatingSystem.Windows))}function s(r,f,h){const k=h===I.OperatingSystem.Windows?E.$kc:E.$lc,P=h===I.OperatingSystem.Linux?D.$bh:D.$dh,O=f.getWorkspace(),C=(0,t.$Sb)(O.folders);if(!C)return;r.scheme!==C.uri.scheme&&r.path[0]===E.$lc.sep&&r.path[1]!==E.$lc.sep&&(r=C.uri.with({path:r.path}));const L=f.getWorkspaceFolder(r);if(!L)return;let R;if(P.isEqual(L.uri,r)?R="":R=P.relativePath(L.uri,r)??"",R&&(R=k.normalize(R)),O.folders.length>1&&!f.noPrefix){const z=L.name?L.name:P.basenameOrAuthority(L.uri);R=R?`${z} \u2022 ${R}`:z}return R}function S(r,f=I.$l){return(0,i.$Og)(r,f)?r.charAt(0).toUpperCase()+r.slice(1):r}let y=Object.create(null);function p(r,f,h=I.OS){if(h===I.OperatingSystem.Windows||!r||!f)return r;let k=y.original===f?y.normalized:void 0;k||(k=f,I.$l&&(k=(0,i.$Dg)(k)),k=`${(0,T.$sf)(k,E.$lc.sep)}${E.$lc.sep}`,y={original:f,normalized:k});let P=r;return I.$l&&(P=(0,i.$Dg)(P)),(h===I.OperatingSystem.Linux?P.startsWith(k):(0,T.$Lf)(P,k))?`~/${P.substr(k.length)}`:r}function $(r,f){return r.replace(/^~($|\/|\\)/,`${f}$1`)}const a="\u2026",c="\\\\",m="~";function b(r,f=E.sep){const h=new Array(r.length);let k=!1;for(let P=0;P<r.length;P++){const O=r[P];if(O===""){h[P]=`.${f}`;continue}if(!O){h[P]=O;continue}k=!0;let C="",L=O;L.indexOf(c)===0?(C=L.substr(0,L.indexOf(c)+c.length),L=L.substr(L.indexOf(c)+c.length)):L.indexOf(f)===0?(C=L.substr(0,L.indexOf(f)+f.length),L=L.substr(L.indexOf(f)+f.length)):L.indexOf(m)===0&&(C=L.substr(0,L.indexOf(m)+m.length),L=L.substr(L.indexOf(m)+m.length));const R=L.split(f);for(let z=1;k&&z<=R.length;z++)for(let Q=R.length-z;k&&Q>=0;Q--){k=!1;let J=R.slice(Q,Q+z).join(f);for(let x=0;!k&&x<r.length;x++)if(x!==P&&r[x]&&r[x].indexOf(J)>-1){const ve=Q+z===R.length,be=Q>0&&r[x].indexOf(f)>-1?f+J:J,se=r[x].endsWith(be);k=!ve||se}if(!k){let x="";(R[0].endsWith(":")||C!=="")&&(Q===1&&(Q=0,z++,J=R[0]+f+J),Q>0&&(x=R[0]+f),x=C+x),Q>0&&(x=x+a+f),x=x+J,Q+z<R.length&&(x=x+f+a),h[P]=x}}k&&(h[P]=O)}return h}var g;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function d(r,f=Object.create(null)){const h=[];let k=!1,P="";for(const O of r)if(O==="$"||k&&O==="{")P&&h.push({value:P,type:g.TEXT}),P="",k=!0;else if(O==="}"&&k){const C=f[P];if(typeof C=="string")C.length&&h.push({value:C,type:g.VARIABLE});else if(C){const L=h[h.length-1];(!L||L.type!==g.SEPARATOR)&&h.push({value:C.label,type:g.SEPARATOR})}P="",k=!1}else P+=O;return P&&!k&&h.push({value:P,type:g.TEXT}),h.filter((O,C)=>{if(O.type===g.SEPARATOR){const L=h[C-1],R=h[C+1];return[L,R].every(z=>z&&(z.type===g.VARIABLE||z.type===g.TEXT)&&z.value.length>0)}return!0}).map(O=>O.value).join("")}function w(r,f){return I.$m||f?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$m?"&":"&&"):r.replace(/&&|&/g,h=>h==="&"?"&&":"&")}function o(r,f){return I.$m||f?r.replace(/\(&&\w\)|&&/g,""):I.$l?r.replace(/&&|&/g,h=>h==="&"?"&&":"&"):r.replace(/&&/g,"_")}function l(r){return r.replace(/&/g,"&&")}function n(r){if(r.endsWith("]")){const f=r.lastIndexOf(" [",r.length-2);if(f!==-1){const h=u(r.substring(0,f)),k=r.substring(f);return{name:h.name+k,parentPath:h.parentPath}}}return u(r)}function u(r){const f=r.indexOf("/")!==-1?E.$lc:E.$kc,h=f.basename(r),k=f.dirname(r);return h.length?{name:h,parentPath:k}:{name:k,parentPath:""}}}),define(Oe[60],Le([1,0,14,82,4]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=void 0,e.$Wn=v,e.$Xn=S,e.$Yn=y;function I(p){return p.toJSON()}class D{constructor($){this.a=$}transformIncoming($){const a=this.a.transformIncoming($);return a===$?$:I(E.URI.from(a))}transformOutgoing($){const a=this.a.transformOutgoing($);return a===$?$:I(E.URI.from(a))}transformOutgoingURI($){const a=this.a.transformOutgoing($);return a===$?$:E.URI.from(a)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Un=D,e.$Vn=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function T(p,$,a){if(!p||a>200)return null;if(typeof p=="object"){if(p instanceof E.URI)return $.transformOutgoing(p);for(const c in p)if(Object.hasOwnProperty.call(p,c)){const m=T(p[c],$,a+1);m!==null&&(p[c]=m)}}return null}function v(p,$){const a=T(p,$,0);return a===null?p:a}function s(p,$,a,c){if(!p||c>200)return null;if(typeof p=="object"){if(p.$mid===i.MarshalledId.Uri)return a?E.URI.revive($.transformIncoming(p)):$.transformIncoming(p);if(p instanceof t.$Se)return null;for(const m in p)if(Object.hasOwnProperty.call(p,m)){const b=s(p[m],$,a,c+1);b!==null&&(p[m]=b)}}return null}function S(p,$){const a=s(p,$,!1,0);return a===null?p:a}function y(p,$){const a=s(p,$,!0,0);return a===null?p:a}}),define(Oe[114],Le([1,0,31,68,23,179,3]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0,e.$2n=v,e.$3n=y,e.$4n=p,E=We(E),e.$1n=new class{c($){return this.a||(this.a=i.$Qi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,a=0;const c=(0,t.networkInterfaces)();for(const m in c){const b=c[m];if(b)for(const{mac:g,internal:d}of b)d||(a+=1,this.c(g.toUpperCase())&&($+=1))}this.b=a>0?$/a:0}return this.b}};let T;async function v($){return T||(T=(async()=>await s($)||E.$7g())()),T}async function s($){try{const a=await new Promise((m,b)=>{ue(["crypto"],m,b)}).then(We),c=(0,I.$Zn)();return a.createHash("sha256").update(c,"utf8").digest("hex")}catch(a){$(a);return}}const S="Software\\Microsoft\\SQMClient";async function y($){if(D.$l){const a=await new Promise((c,m)=>{ue(["@vscode/windows-registry"],c,m)}).then(We);try{return a.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(c){return $(c),""}}return""}async function p($){try{return await(await new Promise((m,b)=>{ue(["@vscode/deviceid"],m,b)}).then(We)).getDeviceId()}catch(a){return $(a),""}}}),define(Oe[193],Le([1,0,20,291,3]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=I,E=We(E);async function I(D){if(E.$m||E.$l)return;let T;for(const v of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{T=await t.promises.open(v,t.constants.R_OK);break}catch{}if(!T){D("Unable to retrieve release information from known identifier paths.");return}try{const v=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),s={id:"unknown"};for await(const S of(0,i.createInterface)({input:T.createReadStream(),crlfDelay:1/0})){if(!S.includes("="))continue;const y=S.split("=")[0].toUpperCase().trim();if(v.has(y)){const p=S.split("=")[1].replace(/"/g,"").toLowerCase().trim();y==="ID"||y==="DISTRIB_ID"?s.id=p:y==="ID_LIKE"?s.id_like=p:(y==="VERSION_ID"||y==="DISTRIB_RELEASE")&&(s.version_id=p)}}return s}catch(v){D(v)}}}),define(Oe[26],Le([1,0,20,31,292,13,36,107,8,3,19,4]),function(ue,e,t,i,E,I,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=d,e.whenDeleted=l,e.configureFlushOnWrite=h,e.writeFileSync=P,t=We(t);var p;(function(be){be[be.UNLINK=0]="UNLINK",be[be.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function $(be,se=p.UNLINK,V){if((0,D.$Ng)(be))throw new Error("rimraf - will refuse to recursively delete root");return se===p.UNLINK?c(be):a(be,V)}async function a(be,se=(0,D.$Sg)((0,i.tmpdir)())){try{try{await t.promises.rename(be,se)}catch(V){return V.code==="ENOENT"?void 0:c(be)}c(se).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function c(be){return t.promises.rm(be,{recursive:!0,force:!0,maxRetries:3})}function m(be){if((0,D.$Ng)(be))throw new Error("rimraf - will refuse to recursively delete root");t.rmSync(be,{recursive:!0,force:!0,maxRetries:3})}async function b(be,se){return w(await(se?g(be):t.promises.readdir(be)))}async function g(be){try{return await t.promises.readdir(be,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const se=[],V=await b(be);for(const B of V){let j=!1,U=!1,te=!1;try{const le=await t.promises.lstat((0,v.$oc)(be,B));j=le.isFile(),U=le.isDirectory(),te=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}se.push({name:B,isFile:()=>j,isDirectory:()=>U,isSymbolicLink:()=>te})}return se}function d(be){return w(t.readdirSync(be))}function w(be){return be.map(se=>typeof se=="string"?s.$m?(0,T.$sm)(se):se:(se.name=s.$m?(0,T.$sm)(se.name):se.name,se))}async function o(be){const se=await b(be),V=[];for(const B of se)await n.existsDirectory((0,v.$oc)(be,B))&&V.push(B);return V}function l(be,se=1e3){return new Promise(V=>{let B=!1;const j=setInterval(()=>{B||(B=!0,t.access(be,U=>{B=!1,U&&(clearInterval(j),V(void 0))}))},se)})}var n;(function(be){async function se(j){let U;try{if(U=await t.promises.lstat(j),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await t.promises.stat(j),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(s.$l&&te.code==="EACCES")try{return{stat:await t.promises.stat(await t.promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw le}throw te}}be.stat=se;async function V(j){try{const{stat:U,symbolicLink:te}=await be.stat(j);return U.isFile()&&te?.dangling!==!0}catch{}return!1}be.existsFile=V;async function B(j){try{const{stat:U,symbolicLink:te}=await be.stat(j);return U.isDirectory()&&te?.dangling!==!0}catch{}return!1}be.existsDirectory=B})(n||(e.SymlinkSupport=n={}));const u=new I.$Th;function r(be,se,V){return u.queueFor(y.URI.file(be),()=>{const B=O(V);return new Promise((j,U)=>k(be,se,B,te=>te?U(te):j()))},S.$ch)}let f=!0;function h(be){f=be}function k(be,se,V,B){if(!f)return t.writeFile(be,se,{mode:V.mode,flag:V.flag},B);t.open(be,V.flag,V.mode,(j,U)=>{if(j)return B(j);t.writeFile(U,se,te=>{if(te)return t.close(U,()=>B(te));t.fdatasync(U,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),h(!1)),t.close(U,ye=>B(ye))))})})}function P(be,se,V){const B=O(V);if(!f)return t.writeFileSync(be,se,{mode:B.mode,flag:B.flag});const j=t.openSync(be,B.flag,B.mode);try{t.writeFileSync(j,se);try{t.fdatasyncSync(j)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),h(!1)}}finally{t.closeSync(j)}}function O(be){return be?{mode:typeof be.mode=="number"?be.mode:438,flag:typeof be.flag=="string"?be.flag:"w"}:{mode:438,flag:"w"}}async function C(be,se,V=6e4){if(be!==se)try{s.$l&&typeof V=="number"?await L(be,se,Date.now(),V):await t.promises.rename(be,se)}catch(B){if(be.toLowerCase()!==se.toLowerCase()&&B.code==="EXDEV"||be.endsWith("."))await R(be,se,{preserveSymlinks:!1}),await $(be,p.MOVE);else throw B}}async function L(be,se,V,B,j=0){try{return await t.promises.rename(be,se)}catch(U){if(U.code!=="EACCES"&&U.code!=="EPERM"&&U.code!=="EBUSY")throw U;if(Date.now()-V>=B)throw console.error(`[node.js fs] rename failed after ${j} retries with error: ${U}`),U;if(j===0){let te=!1;try{const{stat:le}=await n.stat(se);le.isFile()||(te=!0)}catch{}if(te)throw U}return await(0,I.$Lh)(Math.min(100,j*10)),L(be,se,V,B,j+1)}}async function R(be,se,V){return Q(be,se,{root:{source:be,target:se},options:V,handledSourcePaths:new Set})}const z=511;async function Q(be,se,V){if(V.handledSourcePaths.has(be))return;V.handledSourcePaths.add(be);const{stat:B,symbolicLink:j}=await n.stat(be);if(j){if(V.options.preserveSymlinks)try{return await ve(be,se,V)}catch{}if(j.dangling)return}return B.isDirectory()?J(be,se,B.mode&z,V):x(be,se,B.mode&z)}async function J(be,se,V,B){await t.promises.mkdir(se,{recursive:!0,mode:V});const j=await b(be);for(const U of j)await Q((0,v.$oc)(be,U),(0,v.$oc)(se,U),B)}async function x(be,se,V){await t.promises.copyFile(be,se),await t.promises.chmod(se,V)}async function ve(be,se,V){let B=await t.promises.readlink(be);(0,D.$Jg)(B,V.root.source,!s.$n)&&(B=(0,v.$oc)(V.root.target,B.substr(V.root.source.length+1))),await t.promises.symlink(B,se)}e.Promises=new class{get read(){return(be,se,V,B,j)=>new Promise((U,te)=>{t.read(be,se,V,B,j,(le,ye,oe)=>le?te(le):U({bytesRead:ye,buffer:oe}))})}get write(){return(be,se,V,B,j)=>new Promise((U,te)=>{t.write(be,se,V,B,j,(le,ye,oe)=>le?te(le):U({bytesWritten:ye,buffer:oe}))})}get fdatasync(){return(0,E.promisify)(t.fdatasync)}get open(){return(0,E.promisify)(t.open)}get close(){return(0,E.promisify)(t.close)}get realpath(){return(0,E.promisify)(t.realpath)}async exists(be){try{return await t.promises.access(be),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return o}get writeFile(){return r}get rm(){return $}get rename(){return C}get copy(){return R}}}),define(Oe[194],Le([1,0,20,8,3,16,26]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=T,e.$wr=v,e.$xr=s,e.$yr=S,t=We(t);function T(p){if(E.$n)return p;const $=(0,i.$rc)(p);if(p===$)return p;const a=((0,i.$sc)(p)||p).toLowerCase();try{const m=(0,D.readdirSync)($).filter(b=>b.toLowerCase()===a);if(m.length===1){const b=T($);if(b)return(0,i.$oc)(b,m[0])}else if(m.length>1){const b=m.indexOf(a);if(b>=0){const g=T($);if(g)return(0,i.$oc)(g,m[b])}}}catch{}return null}async function v(p,$){if(E.$n)return p;const a=(0,i.$rc)(p);if(p===a)return p;const c=((0,i.$sc)(p)||p).toLowerCase();try{if($?.isCancellationRequested)return null;const b=(await D.Promises.readdir(a)).filter(g=>g.toLowerCase()===c);if(b.length===1){const g=await v(a,$);if(g)return(0,i.$oc)(g,b[0])}else if(b.length>1){const g=b.indexOf(c);if(g>=0){const d=await v(a,$);if(d)return(0,i.$oc)(d,b[g])}}}catch{}return null}async function s(p){try{return await D.Promises.realpath(p)}catch{const a=y(p);return await t.promises.access(a,t.constants.R_OK),a}}function S(p){try{return t.realpathSync(p)}catch{const a=y(p);return t.accessSync(a,t.constants.R_OK),a}}function y(p){return(0,I.$sf)((0,i.$mc)(p),i.sep)}}),define(Oe[115],Le([1,0,31,8,26]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=g,e.$Cm=d,t=We(t),i=We(i),E=We(E);const I=/^\d+$/,D=/^Microsoft.PowerShell_.*/,T=/^Microsoft.PowerShellPreview_.*/;var v;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(v||(v={}));let s;switch(process.arch){case"ia32":s=v.x86;break;case"arm":case"arm64":s=v.ARM;break;default:s=v.x64;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?v.ARM:v.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=v.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=v.x86:S=v.x64;class y{constructor(o,l,n){this.exePath=o,this.displayName=l,this.a=n}async exists(){return this.a===void 0&&(this.a=await E.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:w=!1}={}){return w?s===v.x64?process.env["ProgramFiles(x86)"]||null:S===v.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:w=!1,findPreview:o=!1}={}){const l=p({useAlternateBitness:w});if(!l)return null;const n=i.$oc(l,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(n))return null;let u=-1,r=null;for(const k of await E.Promises.readdir(n)){let P=-1;if(o){const C=k.indexOf("-");if(C<0)continue;const L=k.substring(0,C);if(!I.test(L)||k.substring(C+1)!=="preview")continue;P=parseInt(L,10)}else{if(!I.test(k))continue;P=parseInt(k,10)}if(P<=u)continue;const O=i.$oc(n,k,"pwsh.exe");await E.SymlinkSupport.existsFile(O)&&(r=O,u=P)}if(!r)return null;const f=l.includes("x86")?" (x86)":"",h=o?" Preview":"";return new y(r,`PowerShell${h}${f}`,!0)}async function a({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const o=i.$oc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:l,pwshMsixName:n}=w?{pwshMsixDirRegex:T,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const u of await E.Promises.readdir(o))if(l.test(u)){const r=i.$oc(o,u,"pwsh.exe");return new y(r,n)}return null}function c(){const w=i.$oc(t.homedir(),".dotnet","tools","pwsh.exe");return new y(w,".NET Core PowerShell Global Tool")}function m(){const w=i.$oc(process.env.windir,s===v.x86&&S!==v.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(w,"Windows PowerShell",!0)}async function*b(){let w=await $();w&&(yield w),w=await $({useAlternateBitness:!0}),w&&(yield w),w=await a(),w&&(yield w),w=c(),w&&(yield w),w=await $({findPreview:!0}),w&&(yield w),w=await a({findPreview:!0}),w&&(yield w),w=await $({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=m(),w&&(yield w)}async function*g(){for await(const w of b())await w.exists()&&(yield w)}async function d(){for await(const w of g())return w;return null}}),define(Oe[116],Le([1,0,20,8,3,32,70,10,26]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Dm=s,e.$Em=S,i=We(i),E=We(E),I=We(I),T=We(T),v=We(v),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function s(p=I.env){return p.comspec||"cmd.exe"}function S(p){let $=[],a=!1;const c=function(m){if(a){$.push(m);return}(!p.send(m,g=>{if(g&&console.error(g),a=!1,$.length>0){const d=$.slice(0);$=[],d.forEach(w=>c(w))}})||E.$l)&&(a=!0)};return{send:c}}var y;(function(p){async function $(a,c,m){if(i.$nc(a))return a;if(c===void 0&&(c=I.cwd()),i.$rc(a)!=="."||(m===void 0&&T.$jg(I.env.PATH)&&(m=I.env.PATH.split(i.$yc)),m===void 0||m.length===0))return i.$oc(c,a);async function g(d){if(await v.Promises.exists(d)){let w;try{w=await t.promises.stat(d)}catch(o){o.message.startsWith("EACCES")&&(w=await t.promises.lstat(d))}return w?!w.isDirectory():!1}return!1}for(const d of m){let w;if(i.$nc(d)?w=i.$oc(d,a):w=i.$oc(c,d,a),await g(w))return w;let o=w+".com";if(await g(o)||(o=w+".exe",await g(o)))return o}return i.$oc(c,a)}p.findExecutable=$})(y||(e.win32=y={}))}),define(Oe[117],Le([1,0,50,12]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=E;function E(D){return new Promise((T,v)=>{let s;const S=new Map;function y($,a,c,m,b){const g=S.get(a);if($===D||g){const d={name:p(c),cmd:c,pid:$,ppid:a,load:m,mem:b};S.set($,d),$===D&&(s=d),g&&(g.children||(g.children=[]),g.children.push(d),g.children.length>1&&(g.children=g.children.sort((w,o)=>w.pid-o.pid)))}}function p($){const a=/--utility-sub-type=network/i,c=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,b=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(c.exec($))return"electron-crash-reporter";if(m.exec($))return"winpty-agent";if(b.exec($))return"conpty-agent";let d=g.exec($);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?a.exec($)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const w=/[a-zA-Z-]+\.js/g;let o="";do d=w.exec($),d&&(o+=d+" ");while(d);return o&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${o})`:$}if(process.platform==="win32"){const $=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,c)=>{ue(["@vscode/windows-process-tree"],a,c)}).then(We).then(a=>{a.getProcessList(D,c=>{if(!c){v(new Error(`Root process ${D} not found`));return}a.getProcessCpuUsage(c,m=>{const b=new Map;m.forEach(g=>{const d=$(g.commandLine||"");b.set(g.pid,{name:p(d),cmd:d,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),s=b.get(D),s?(b.forEach(g=>{const d=b.get(g.ppid);d&&(d.children||(d.children=[]),d.children.push(g))}),b.forEach(g=>{g.children&&(g.children=g.children.sort((d,w)=>d.pid-w.pid))}),T(s)):v(new Error(`Root process ${D} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let $=function(){let a=[s];const c=[];for(;a.length;){const b=a.shift();b&&(c.push(b.pid),b.children&&(a=a.concat(b.children)))}let m=JSON.stringify(i.$5g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+c.join(" "),(0,t.exec)(m,{},(b,g,d)=>{if(b||d)v(b||new Error(d.toString()));else{const w=g.toString().split(`
`);for(let o=0;o<c.length;o++){const l=S.get(c[o]);l.load=parseFloat(w[o])}if(!s){v(new Error(`Root process ${D} not found`));return}T(s)}})};(0,t.exec)("which ps",{},(a,c,m)=>{if(a||m)if(process.platform!=="linux")v(a||new Error(m.toString()));else{const b=JSON.stringify(i.$5g.asFileUri("vs/base/node/ps.sh").fsPath);(0,t.exec)(b,{},(g,d,w)=>{g||w?v(g||new Error(w.toString())):(I(d,y),$())})}else{const b=c.toString().trim();(0,t.exec)(`${b} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,w,o)=>{d||o&&!o.includes("screen size is bogus")?v(d||new Error(o.toString())):(I(w,y),process.platform==="linux"?$():s?T(s):v(new Error(`Root process ${D} not found`)))})}})}})}function I(D,T){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,s=D.toString().split(`
`);for(const S of s){const y=v.exec(S.trim());y&&y.length===6&&T(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(Oe[118],Le([1,0,31,3,115,116]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=D,i=We(i),I=We(I);async function D(y,p){return y===i.OperatingSystem.Windows?i.$l?S():I.$Dm(p):v(y,p)}let T=null;function v(y,p){if(i.$n&&y===i.OperatingSystem.Macintosh||i.$m&&y===i.OperatingSystem.Linux)return"/bin/bash";if(!T){let $;if(i.$l)$="/bin/bash";else{if($=p.SHELL,!$)try{$=(0,t.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}T=$}return T}let s=null;async function S(){return s||(s=(await(0,E.$Cm)()).exePath),s}}),define(Oe[87],Le([1,0,20,13,8,10,26,7]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=void 0,e.zip=m,e.$Nq=b,e.$Oq=d,E=We(E),T=We(T),e.$Kq="end of central directory record signature not found";const v=new RegExp(e.$Kq);class s extends Error{constructor(o,l){let n=l.message;switch(o){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=o,this.cause=l}}e.$Lq=s;function S(w){const o=w.externalFileAttributes>>16||33188;return[448,56,7].map(l=>o&l).reduce((l,n)=>l+n,o&61440)}function y(w){if(w instanceof s)return w;let o;return v.test(w.message)&&(o="CorruptZip"),new s(o,w)}function p(w,o,l,n,u,r){const f=E.$rc(o),h=E.$oc(n,f);if(!h.startsWith(n))return Promise.reject(new Error(T.localize(142,null,o)));const k=E.$oc(n,o);let P;return r.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(t.promises.mkdir(h,{recursive:!0})).then(()=>new Promise((O,C)=>{if(!r.isCancellationRequested)try{P=(0,t.createWriteStream)(k,{mode:l}),P.once("close",()=>O()),P.once("error",C),w.once("error",C),w.pipe(P)}catch(L){C(L)}}))}function $(w,o,l,n){let u=(0,i.$xh)(()=>Promise.resolve()),r=0;const f=n.onCancellationRequested(()=>{u.cancel(),w.close()});return new Promise((h,k)=>{const P=new i.$Fh,O=C=>{C.isCancellationRequested||(r++,w.readEntry())};w.once("error",k),w.once("close",()=>u.then(()=>{n.isCancellationRequested||w.entryCount===r?h():k(new s("Incomplete",new Error(T.localize(143,null,r,w.entryCount))))},k)),w.readEntry(),w.on("entry",C=>{if(n.isCancellationRequested)return;if(!l.sourcePathRegex.test(C.fileName)){O(n);return}const L=C.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(L)){const Q=E.$oc(o,L);u=(0,i.$xh)(J=>t.promises.mkdir(Q,{recursive:!0}).then(()=>O(J)).then(void 0,k));return}const R=c(w,C),z=S(C);u=(0,i.$xh)(Q=>P.queue(()=>R.then(J=>p(J,L,z,o,l,Q).then(()=>O(Q)))).then(null,k))})}).finally(()=>f.dispose())}async function a(w,o=!1){const{open:l}=await new Promise((n,u)=>{ue(["yauzl"],n,u)}).then(We);return new Promise((n,u)=>{l(w,o?{lazyEntries:!0}:void 0,(r,f)=>{r?u(y(r)):n((0,I.$ug)(f))})})}function c(w,o){return new Promise((l,n)=>{w.openReadStream(o,(u,r)=>{u?n(y(u)):l((0,I.$ug)(r))})})}async function m(w,o){const{ZipFile:l}=await new Promise((n,u)=>{ue(["yazl"],n,u)}).then(We);return new Promise((n,u)=>{const r=new l;o.forEach(h=>{h.contents?r.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&r.addFile(h.localPath,h.path)}),r.end();const f=(0,t.createWriteStream)(w);r.outputStream.pipe(f),r.outputStream.once("error",u),f.once("error",u),f.once("finish",()=>n(w))})}function b(w,o,l={},n){const u=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let r=a(w,!0);return l.overwrite&&(r=r.then(f=>D.Promises.rm(o).then(()=>f))),r.then(f=>$(f,o,{sourcePathRegex:u},n))}function g(w,o){return a(w).then(l=>new Promise((n,u)=>{l.on("entry",r=>{r.fileName===o&&c(l,r).then(f=>n(f),f=>u(f))}),l.once("close",()=>u(new Error(T.localize(144,null,o))))}))}function d(w,o){return g(w,o).then(l=>new Promise((n,u)=>{const r=[];l.once("error",u),l.on("data",f=>r.push(f)),l.on("end",()=>n(Buffer.concat(r)))}))}});var Ve=this&&this.__decorate||function(ue,e,t,i){var E=arguments.length,I=E<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,t):i,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(ue,e,t,i);else for(var T=ue.length-1;T>=0;T--)(D=ue[T])&&(I=(E<3?D(I):E>3?D(e,t,I):D(e,t))||I);return E>3&&I&&Object.defineProperty(e,t,I),I};define(Oe[51],Le([1,0,17,13,14,18,79,9,6,2,49,16,10]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.ProxyChannel=e.$si=e.$pi=e.$oi=e.$ni=e.RequestInitiator=e.$mi=e.$ji=e.$ii=void 0,e.$ki=h,e.$li=k,e.$qi=z,e.$ri=Q,y=We(y);var $;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})($||($={}));function a(j){switch(j){case $.Promise:return"req";case $.PromiseCancel:return"cancel";case $.EventListen:return"subscribe";case $.EventDispose:return"unsubscribe"}}var c;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(c||(c={}));function m(j){switch(j){case c.Initialize:return"init";case c.PromiseSuccess:return"reply:";case c.PromiseError:case c.PromiseErrorObj:return"replyErr:";case c.EventFire:return"event:"}}var b;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(b||(b={}));function g(j){let U=0;for(let te=0;;te+=7){const le=j.read(1);if(U|=(le.buffer[0]&127)<<te,!(le.buffer[0]&128))return U}}const d=u(0);function w(j,U){if(U===0){j.write(d);return}let te=0;for(let ye=U;ye!==0;ye=ye>>>7)te++;const le=E.$Se.alloc(te);for(let ye=0;U!==0;ye++)le.buffer[ye]=U&127,U=U>>>7,U>0&&(le.buffer[ye]|=128);j.write(le)}class o{constructor(U){this.b=U,this.a=0}read(U){const te=this.b.slice(this.a,this.a+U);return this.a+=te.byteLength,te}}e.$ii=o;class l{constructor(){this.a=[]}get buffer(){return E.$Se.concat(this.a)}write(U){this.a.push(U)}}e.$ji=l;var n;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(n||(n={}));function u(j){const U=E.$Se.alloc(1);return U.writeUInt8(j,0),U}const r={Undefined:u(n.Undefined),String:u(n.String),Buffer:u(n.Buffer),VSBuffer:u(n.VSBuffer),Array:u(n.Array),Object:u(n.Object),Uint:u(n.Int)},f=typeof Buffer<"u";function h(j,U){if(typeof U>"u")j.write(r.Undefined);else if(typeof U=="string"){const te=E.$Se.fromString(U);j.write(r.String),w(j,te.byteLength),j.write(te)}else if(f&&Buffer.isBuffer(U)){const te=E.$Se.wrap(U);j.write(r.Buffer),w(j,te.byteLength),j.write(te)}else if(U instanceof E.$Se)j.write(r.VSBuffer),w(j,U.byteLength),j.write(U);else if(Array.isArray(U)){j.write(r.Array),w(j,U.length);for(const te of U)h(j,te)}else if(typeof U=="number"&&(U|0)===U)j.write(r.Uint),w(j,U);else{const te=E.$Se.fromString(JSON.stringify(U));j.write(r.Object),w(j,te.byteLength),j.write(te)}}function k(j){switch(j.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return j.read(g(j)).toString();case n.Buffer:return j.read(g(j)).buffer;case n.VSBuffer:return j.read(g(j));case n.Array:{const te=g(j),le=[];for(let ye=0;ye<te;ye++)le.push(k(j));return le}case n.Object:return JSON.parse(j.read(g(j)).toString());case n.Int:return g(j)}}class P{constructor(U,te,le=null,ye=1e3){this.h=U,this.j=te,this.k=le,this.l=ye,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:c.Initialize})}registerChannel(U,te){this.b.set(U,te),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case c.Initialize:{const te=this.o([U.type]);this.k?.logOutgoing(te,0,O.OtherSide,m(U.type));return}case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:{const te=this.o([U.type,U.id],U.data);this.k?.logOutgoing(te,U.id,O.OtherSide,m(U.type),U.data);return}}}o(U,te=void 0){const le=new l;return h(le,U),h(le,te),this.p(le.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const te=new o(U),le=k(te),ye=k(te),oe=le[0];switch(oe){case $.Promise:return this.k?.logIncoming(U.byteLength,le[1],O.OtherSide,`${a(oe)}: ${le[2]}.${le[3]}`,ye),this.s({type:oe,id:le[1],channelName:le[2],name:le[3],arg:ye});case $.EventListen:return this.k?.logIncoming(U.byteLength,le[1],O.OtherSide,`${a(oe)}: ${le[2]}.${le[3]}`,ye),this.t({type:oe,id:le[1],channelName:le[2],name:le[3],arg:ye});case $.PromiseCancel:return this.k?.logIncoming(U.byteLength,le[1],O.OtherSide,`${a(oe)}`),this.u({type:oe,id:le[1]});case $.EventDispose:return this.k?.logIncoming(U.byteLength,le[1],O.OtherSide,`${a(oe)}`),this.u({type:oe,id:le[1]})}}s(U){const te=this.b.get(U.channelName);if(!te){this.v(U);return}const le=new I.$Be;let ye;try{ye=te.call(this.j,U.name,U.arg,le.token)}catch(X){ye=Promise.reject(X)}const oe=U.id;ye.then(X=>{this.m({id:oe,data:X,type:c.PromiseSuccess})},X=>{X instanceof Error?this.m({id:oe,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split(`
`):void 0},type:c.PromiseError}):this.m({id:oe,data:X,type:c.PromiseErrorObj})}).finally(()=>{_.dispose(),this.d.delete(U.id)});const _=(0,s.$Xc)(()=>le.cancel());this.d.set(U.id,_)}t(U){const te=this.b.get(U.channelName);if(!te){this.v(U);return}const le=U.id,oe=te.listen(this.j,U.name,U.arg)(_=>this.m({id:le,data:_,type:c.EventFire}));this.d.set(U.id,oe)}u(U){const te=this.d.get(U.id);te&&(te.dispose(),this.d.delete(U.id))}v(U){let te=this.g.get(U.channelName);te||(te=[],this.g.set(U.channelName,te));const le=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===$.Promise&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:c.PromiseError})},this.l);te.push({request:U,timeoutTimer:le})}w(U){const te=this.g.get(U);if(te){for(const le of te)switch(clearTimeout(le.timeoutTimer),le.request.type){case $.Promise:this.s(le.request);break;case $.EventListen:this.t(le.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,s.$Uc)(this.d.values()),this.d.clear()}}e.$mi=P;var O;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(O||(e.RequestInitiator=O={}));class C{constructor(U,te=null){this.l=U,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.$qe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=te}getChannel(U){const te=this;return{call(le,ye,oe){return te.a?Promise.reject(new T.$9):te.m(U,le,ye,oe)},listen(le,ye){return te.a?v.Event.None:te.o(U,le,ye)}}}m(U,te,le,ye=I.CancellationToken.None){const oe=this.g++,_=$.Promise,X={id:oe,type:_,channelName:U,name:te,arg:le};if(ye.isCancellationRequested)return Promise.reject(new T.$9);let M;return new Promise((Y,pe)=>{if(ye.isCancellationRequested)return pe(new T.$9);const ne=()=>{const ce=we=>{switch(we.type){case c.PromiseSuccess:this.f.delete(oe),Y(we.data);break;case c.PromiseError:{this.f.delete(oe);const Ie=new Error(we.data.message);Ie.stack=Array.isArray(we.data.stack)?we.data.stack.join(`
`):we.data.stack,Ie.name=we.data.name,pe(Ie);break}case c.PromiseErrorObj:this.f.delete(oe),pe(we.data);break}};this.f.set(oe,ce),this.p(X)};let ie=null;this.b===b.Idle?ne():(ie=(0,i.$xh)(ce=>this.u()),ie.then(()=>{ie=null,ne()}));const G=()=>{ie?(ie.cancel(),ie=null):this.p({id:oe,type:$.PromiseCancel}),pe(new T.$9)},Z=ye.onCancellationRequested(G);M=(0,s.$Wc)((0,s.$Xc)(G),Z),this.d.add(M)}).finally(()=>{M.dispose(),this.d.delete(M)})}o(U,te,le){const ye=this.g++,oe=$.EventListen,_={id:ye,type:oe,channelName:U,name:te,arg:le};let X=null;const M=new v.$qe({onWillAddFirstListener:()=>{X=(0,i.$xh)(Y=>this.u()),X.then(()=>{X=null,this.d.add(M),this.p(_)})},onDidRemoveLastListener:()=>{X?(X.cancel(),X=null):(this.d.delete(M),this.p({id:ye,type:$.EventDispose}))}}),A=Y=>M.fire(Y.data);return this.f.set(ye,A),M.event}p(U){switch(U.type){case $.Promise:case $.EventListen:{const te=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(te,U.id,O.LocalSide,`${a(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case $.PromiseCancel:case $.EventDispose:{const te=this.q([U.type,U.id]);this.j?.logOutgoing(te,U.id,O.LocalSide,a(U.type));return}}}q(U,te=void 0){const le=new l;return h(le,U),h(le,te),this.r(le.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const te=new o(U),le=k(te),ye=k(te),oe=le[0];switch(oe){case c.Initialize:return this.j?.logIncoming(U.byteLength,0,O.LocalSide,m(oe)),this.t({type:le[0]});case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:return this.j?.logIncoming(U.byteLength,le[1],O.LocalSide,m(oe),ye),this.t({type:le[0],id:le[1],data:ye})}}t(U){if(U.type===c.Initialize){this.b=b.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,s.$Uc)(this.d.values()),this.d.clear()}}e.$ni=C,Ve([D.$ci],C.prototype,"onDidInitializePromise",null);class L{get connections(){const U=[];return this.f.forEach(te=>U.push(te)),U}constructor(U,te,le){this.a=new Map,this.f=new Set,this.g=new v.$qe,this.onDidAddConnection=this.g.event,this.h=new v.$qe,this.onDidRemoveConnection=this.h.event,this.j=new s.$Yc,this.j.add(U(({protocol:ye,onDidClientDisconnect:oe})=>{const _=v.Event.once(ye.onMessage);this.j.add(_(X=>{const M=new o(X),A=k(M),Y=new P(ye,A,te,le),pe=new C(ye,te);this.a.forEach((ie,G)=>Y.registerChannel(G,ie));const ne={channelServer:Y,channelClient:pe,ctx:A};this.f.add(ne),this.g.fire(ne),this.j.add(oe(()=>{Y.dispose(),pe.dispose(),this.f.delete(ne),this.h.fire(ne)}))}))}))}getChannel(U,te){const le=this;return{call(ye,oe,_){let X;if((0,p.$xg)(te)){const A=(0,t.$7b)(le.connections.filter(te));X=A?Promise.resolve(A):v.Event.toPromise(v.Event.filter(le.onDidAddConnection,te))}else X=te.routeCall(le,ye,oe);const M=X.then(A=>A.channelClient.getChannel(U));return z(M).call(ye,oe,_)},listen(ye,oe){if((0,p.$xg)(te))return le.k(U,te,ye,oe);const _=te.routeEvent(le,ye,oe).then(X=>X.channelClient.getChannel(U));return z(_).listen(ye,oe)}}}k(U,te,le,ye){const oe=this;let _;const X=new v.$qe({onWillAddFirstListener:()=>{_=new s.$Yc;const M=new v.$we,A=new Map,Y=ne=>{const G=ne.channelClient.getChannel(U).listen(le,ye),Z=M.add(G);A.set(ne,Z)},pe=ne=>{const ie=A.get(ne);ie&&(ie.dispose(),A.delete(ne))};oe.connections.filter(te).forEach(Y),v.Event.filter(oe.onDidAddConnection,te)(Y,void 0,_),oe.onDidRemoveConnection(pe,void 0,_),M.event(X.fire,X,_),_.add(M)},onDidRemoveLastListener:()=>{_?.dispose(),_=void 0}});return X.event}registerChannel(U,te){this.a.set(U,te);for(const le of this.f)le.channelServer.registerChannel(U,te)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$oi=L;class R{constructor(U,te,le=null){const ye=new l;h(ye,te),U.send(ye.buffer),this.a=new C(U,le),this.d=new P(U,te,le)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,te){this.d.registerChannel(U,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.$pi=R;function z(j){return{call(U,te,le){return j.then(ye=>ye.call(U,te,le))},listen(U,te){const le=new v.$ze;return j.then(ye=>le.input=ye.listen(U,te)),le.event}}}function Q(j){let U=!1;return{call(te,le,ye){return U?j.call(te,le,ye):(0,i.$Lh)(0).then(()=>U=!0).then(()=>j.call(te,le,ye))},listen(te,le){if(U)return j.listen(te,le);const ye=new v.$ze;return(0,i.$Lh)(0).then(()=>U=!0).then(()=>ye.input=j.listen(te,le)),ye.event}}}class J{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const te of U.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await v.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$si=J;var x;(function(j){function U(oe,_,X){const M=oe,A=X&&X.disableMarshalling,Y=new Map;for(const pe in M)le(pe)&&Y.set(pe,v.Event.buffer(M[pe],!0,void 0,_));return new class{listen(pe,ne,ie){const G=Y.get(ne);if(G)return G;const Z=M[ne];if(typeof Z=="function"){if(ye(ne))return Z.call(M,ie);if(le(ne))return Y.set(ne,v.Event.buffer(M[ne],!0,void 0,_)),Y.get(ne)}throw new T.$fb(`Event not found: ${ne}`)}call(pe,ne,ie){const G=M[ne];if(typeof G=="function"){if(!A&&Array.isArray(ie))for(let ce=0;ce<ie.length;ce++)ie[ce]=(0,S.$hi)(ie[ce]);let Z=G.apply(M,ie);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new T.$fb(`Method not found: ${ne}`)}}}j.fromService=U;function te(oe,_){const X=_&&_.disableMarshalling;return new Proxy({},{get(M,A){if(typeof A=="string")return _?.properties?.has(A)?_.properties.get(A):ye(A)?function(Y){return oe.listen(A,Y)}:le(A)?oe.listen(A):async function(...Y){let pe;_&&!(0,p.$sg)(_.context)?pe=[_.context,...Y]:pe=Y;const ne=await oe.call(A,pe);return X?ne:(0,S.$hi)(ne)};throw new T.$fb(`Property not found: ${String(A)}`)}})}j.toService=te;function le(oe){return oe[0]==="o"&&oe[1]==="n"&&y.$Jf(oe.charCodeAt(2))}function ye(oe){return/^onDynamic/.test(oe)&&y.$Jf(oe.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const ve=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function be(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const U=j.toString();if(U!=="[object Object]")return U}return j}function se(j){return Array.isArray(j)?j.map(be):be(j)}function V(j,U,te,le,ye,oe,_){_=se(_);const X=ve[ye],M=X[le%X.length];let A=[`%c[${j}]%c[${String(U).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(oe)?(A=A.concat(_),A.push(")")):A.push(_),console.log.apply(console,A)}class B{constructor(U,te){this.d=U,this.f=te,this.a=0,this.b=0}logOutgoing(U,te,le,ye,oe){this.b+=U,V(this.d,this.b,U,te,le,ye,oe)}logIncoming(U,te,le,ye,oe){this.a+=U,V(this.f,this.a,U,te,le,ye,oe)}}e.$ti=B}),define(Oe[61],Le([1,0,14,6,2,51]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.ProtocolConstants=e.$ui=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var T;(function(r){r.enableDiagnostics=!1,r.records=[];const f=new WeakMap;let h=0;function k(O,C){if(!f.has(O)){const L=String(++h);f.set(O,L)}return f.get(O)}function P(O,C,L,R){if(!r.enableDiagnostics)return;const z=k(O,C);if(R instanceof t.$Se||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const Q=t.$Se.alloc(R.byteLength);Q.set(R),r.records.push({timestamp:Date.now(),id:z,label:C,type:L,buff:Q})}else r.records.push({timestamp:Date.now(),id:z,label:C,type:L,data:R})}r.traceSocketEvent=P})(T||(e.SocketDiagnostics=T={}));var v;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let s=null;function S(){return s||(s=t.$Se.alloc(0)),s}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(f){this.a.push(f),this.b+=f.byteLength}read(f){return this.c(f,!0)}peek(f){return this.c(f,!1)}c(f,h){if(f===0)return S();if(f>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===f){const C=this.a[0];return h&&(this.a.shift(),this.b-=f),C}if(this.a[0].byteLength>f){const C=this.a[0].slice(0,f);return h&&(this.a[0]=this.a[0].slice(f),this.b-=f),C}const k=t.$Se.alloc(f);let P=0,O=0;for(;f>0;){const C=this.a[O];if(C.byteLength>f){const L=C.slice(0,f);k.set(L,P),P+=f,h&&(this.a[O]=C.slice(f),this.b-=f),f-=f}else k.set(C,P),P+=C.byteLength,h?(this.a.shift(),this.b-=C.byteLength):O++,f-=C.byteLength}return k}}e.$ui=y;var p;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(p||(p={}));function $(r){switch(r){case p.None:return"None";case p.Regular:return"Regular";case p.Control:return"Control";case p.Ack:return"Ack";case p.Disconnect:return"Disconnect";case p.ReplayRequest:return"ReplayRequest";case p.Pause:return"PauseWriting";case p.Resume:return"ResumeWriting";case p.KeepAlive:return"KeepAlive"}}var a;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",r[r.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(a||(e.ProtocolConstants=a={}));class c{constructor(f,h,k,P){this.type=f,this.id=h,this.ack=k,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends E.$Zc{constructor(f){super(),this.f=this.B(new i.$qe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:a.HeaderLength,messageType:p.None,id:0,ack:0},this.a=f,this.b=!1,this.c=new y,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(f){if(!(!f||f.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(f);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent(D.ProtocolHeaderRead,{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,P=this.g.id,O=this.g.ack;if(this.g.readHead=!0,this.g.readLen=a.HeaderLength,this.g.messageType=p.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(D.ProtocolMessageRead,h),this.f.fire(new c(k,P,O,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(f){this.k=null,this.a=!1,this.b=!1,this.c=f,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(f){if(this.a)return;f.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=t.$Se.alloc(a.HeaderLength);h.writeUInt8(f.type,0),h.writeUInt32BE(f.id,1),h.writeUInt32BE(f.ack,5),h.writeUInt32BE(f.data.byteLength,9),this.c.traceSocketEvent(D.ProtocolHeaderWrite,{messageType:$(f.type),id:f.id,ack:f.ack,messageSize:f.data.byteLength}),this.c.traceSocketEvent(D.ProtocolMessageWrite,f.data),this.j(h,f.data)}g(f,h){const k=this.f===0;return this.d.push(f,h),this.f+=f.byteLength+h.byteLength,k}h(){const f=t.$Se.concat(this.d,this.f);return this.d.length=0,this.f=0,f}j(f,h){this.g(f,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const f=this.h();this.c.traceSocketEvent(D.ProtocolWrite,{byteLength:f.byteLength}),this.c.write(f)}}class g extends E.$Zc{constructor(f){super(),this.f=new i.$qe,this.onMessage=this.f.event,this.g=new i.$qe,this.onDidDispose=this.g.event,this.a=f,this.b=this.B(new b(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(h=>{h.type===p.Regular&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(f){this.b.write(new c(p.Regular,0,0,f))}}e.$vi=g;class d extends I.$pi{static fromSocket(f,h){return new d(new g(f),h)}get onDidDispose(){return this.b.onDidDispose}constructor(f,h,k=null){super(f,h,k),this.b=f}dispose(){super.dispose();const f=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),f.end()}}e.$wi=d;class w{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new i.$qe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(f){this.b?this.d.length>0?this.d.push(f):this.a.fire(f):this.d.push(f)}flushBuffer(){this.d=[]}}e.$xi=w;class o{constructor(f){this.data=f,this.next=null}}class l{constructor(){this.a=null,this.b=null}length(){let f=0,h=this.a;for(;h;)h=h.next,f++;return f}peek(){return this.a?this.a.data:null}toArray(){const f=[];let h=0,k=this.a;for(;k;)f[h++]=k.data,k=k.next;return f}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(f){const h=new o(f);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const f=Date.now();for(let h=0;h<n.a;h++)this.c[h]=f-1e3*h;setInterval(()=>{for(let h=n.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const f=Date.now(),h=(1+n.a)*1e3;let k=0;for(let P=0;P<n.a;P++)f-this.c[P]<=h&&k++;return 1-k/n.a}hasHighLoad(){return this.d()>=.5}}class u{get unacknowledgedCount(){return this.d-this.f}constructor(f){this.v=new w,this.onControlMessage=this.v.event,this.w=new w,this.onMessage=this.w.event,this.x=new w,this.onDidDispose=this.x.event,this.y=new w,this.onSocketClose=this.y.event,this.z=new w,this.onSocketTimeout=this.z.event,this.t=f.loadEstimator??n.getInstance(),this.u=f.sendKeepAlive??!0,this.a=!1,this.c=new l,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new E.$Yc,this.p=f.socket,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(h=>this.A(h))),this.s.add(this.p.onClose(h=>this.y.fire(h))),f.initialChunk&&this.r.acceptChunk(f.initialChunk),this.u?this.m=setInterval(()=>{this.E()},a.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const f=new c(p.Disconnect,0,0,S());this.q.write(f),this.q.flush()}}sendPause(){const f=new c(p.Pause,0,0,S());this.q.write(f)}sendResume(){const f=new c(p.Resume,0,0,S());this.q.write(f)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(f,h){this.a=!0,this.s.dispose(),this.s=new E.$Yc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=f,this.q=this.s.add(new b(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(k=>this.A(k))),this.s.add(this.p.onClose(k=>this.y.fire(k))),this.r.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.j=this.h;const f=new c(p.Ack,0,this.j,S());this.q.write(f);const h=this.c.toArray();for(let k=0,P=h.length;k<P;k++)this.q.write(h[k]);this.C()}acceptDisconnect(){this.x.fire()}A(f){if(f.ack>this.f){this.f=f.ack;do{const h=this.c.peek();if(h&&h.id<=f.ack)this.c.pop();else break}while(!0)}switch(f.type){case p.None:break;case p.Regular:{if(f.id>this.h)if(f.id!==this.h+1){const h=Date.now();h-this.n>1e4&&(this.n=h,this.q.write(new c(p.ReplayRequest,0,0,S())))}else this.h=f.id,this.k=Date.now(),this.B(),this.w.fire(f.data);break}case p.Control:{this.v.fire(f.data);break}case p.Ack:break;case p.Disconnect:{this.x.fire();break}case p.ReplayRequest:{const h=this.c.toArray();for(let k=0,P=h.length;k<P;k++)this.q.write(h[k]);this.C();break}case p.Pause:{this.q.pause();break}case p.Resume:{this.q.resume();break}case p.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(f){const h=++this.d;this.j=this.h;const k=new c(p.Regular,h,this.j,f);this.c.push(k),this.a||(this.q.write(k),this.C())}sendControl(f){const h=new c(p.Control,0,0,f);this.q.write(h)}B(){if(this.h<=this.j||this.l)return;const f=Date.now()-this.k;if(f>=a.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},a.AcknowledgeTime-f+5)}C(){if(this.d<=this.f||this.g||this.a)return;const f=this.c.peek(),h=Date.now()-f.writtenTime,k=Date.now()-this.r.lastReadTime,P=Date.now()-this.o;if(h>=a.TimeoutTime&&k>=a.TimeoutTime&&P>=a.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:k});return}const O=Math.max(a.TimeoutTime-h,a.TimeoutTime-k,a.TimeoutTime-P,500);this.g=setTimeout(()=>{this.g=null,this.C()},O)}D(){if(this.h<=this.j)return;this.j=this.h;const f=new c(p.Ack,0,this.j,S());this.q.write(f)}E(){this.j=this.h;const f=new c(p.KeepAlive,0,this.j,S());this.q.write(f)}}e.$yi=u}),define(Oe[119],Le([1,0,50,13,14,18,191,9,6,2,21,116,70,51]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0,T=We(T);class a extends $.$mi{constructor(b){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",g=>E.$Se.wrap(Buffer.from(g,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.$rr=a;class c{constructor(b,g){this.i=b,this.j=g,this.c=new Set,this.g=new Map,this.h=new v.$qe,this.onDidProcessExit=this.h.event;const d=g&&g.timeout?g.timeout:6e4;this.b=new i.$Hh(d),this.d=null,this.f=null}getChannel(b){const g=this;return{call(d,w,o){return g.k(b,d,w,o)},listen(d,w){return g.l(b,d,w)}}}k(b,g,d,w=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(T.$0());this.b.cancel();const o=this.n(b),l=(0,i.$xh)(r=>o.call(g,d,r)),n=w.onCancellationRequested(()=>l.cancel()),u=(0,s.$Xc)(()=>l.cancel());return this.c.add(u),l.finally(()=>{n.dispose(),this.c.delete(u),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),l}l(b,g,d){if(!this.b)return v.Event.None;this.b.cancel();let w;const o=new v.$qe({onWillAddFirstListener:()=>{w=this.n(b).listen(g,d)(o.fire,o),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const b=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,S.$mo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,p.$rm)(g.env),this.d=(0,t.fork)(this.i,b,g);const d=new v.$qe,o=v.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,D.$nr)(h)){(0,D.log)(h,`IPC Library: ${this.j.serverName}`);return}d.fire(E.$Se.wrap(Buffer.from(h,"base64")))}),l=this.j.useQueue?(0,y.$Em)(this.d):this.d,n=h=>this.d&&this.d.connected&&l.send(h.buffer.toString("base64")),u=d.event,r={send:n,onMessage:u};this.f=new $.$ni(r);const f=()=>this.o();process.once("exit",f),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,k)=>{process.removeListener("exit",f),o.dispose(),this.c.forEach(P=>(0,s.$Uc)(P)),this.c.clear(),h!==0&&k!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+k),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:k})})}return this.f}n(b){let g=this.g.get(b);return g||(g=this.m.getChannel(b),this.g.set(b,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$sr=c}),define(Oe[195],Le([1,0,13,6,2,49,10]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=e.StorageState=e.StorageHint=void 0,e.$lq=v;var T;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function v(p){const $=p;return $?.changed instanceof Map||$?.deleted instanceof Set}var s;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(s||(e.StorageState=s={}));class S extends E.$Zc{static{this.a=100}constructor($,a=Object.create(null)){super(),this.r=$,this.s=a,this.b=this.B(new i.$te),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new t.$Ih(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((a,c)=>this.w(c,a)),$.deleted?.forEach(a=>this.w(a,void 0))}finally{this.b.resume()}}w($,a){if(this.c===s.Closed)return;let c=!1;(0,D.$sg)(a)?c=this.f.delete($):this.f.get($)!==a&&(this.f.set($,a),c=!0),c&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,a){const c=this.f.get($);return(0,D.$sg)(c)?a:c}getBoolean($,a){const c=this.get($);return(0,D.$sg)(c)?a:c==="true"}getNumber($,a){const c=this.get($);return(0,D.$sg)(c)?a:parseInt(c,10)}getObject($,a){const c=this.get($);return(0,D.$sg)(c)?a:(0,I.$gi)(c)}async set($,a,c=!1){if(this.c===s.Closed)return;if((0,D.$sg)(a))return this.delete($,c);const m=(0,D.$lg)(a)||Array.isArray(a)?(0,I.$fi)(a):String(a);if(this.f.get($)!==m)return this.f.set($,m),this.j.set($,m),this.h.delete($),this.b.fire({key:$,external:c}),this.D()}async delete($,a=!1){if(!(this.c===s.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:a}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===s.Closed||this.m))return this.D($)}async D($){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$mq=S;class y{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((a,c)=>this.a.set(c,a)),$.delete?.forEach(a=>this.a.delete(a))}async optimize(){}async close(){}}e.$nq=y}),define(Oe[196],Le([1,0,57,4,183,48,187,7]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$3u=e.$2u=e.$1u=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Zu=e.$Yu=e.SymbolKinds=e.SymbolTag=e.$Wu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Uu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Tu=e.$Su=e.$Ru=void 0,e.$Vu=u,e.$Xu=f;class v{constructor(U,te,le){this.offset=U,this.type=te,this.language=le,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Ru=v;class s{constructor(U,te){this.tokens=U,this.endState=te,this._tokenizationResultBrand=void 0}}e.$Su=s;class S{constructor(U,te){this.tokens=U,this.endState=te,this._encodedTokenizationResultBrand=void 0}}e.$Tu=S;var y;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(y||(e.HoverVerbosityAction=y={}));var p;(function(j){j[j.Method=0]="Method",j[j.Function=1]="Function",j[j.Constructor=2]="Constructor",j[j.Field=3]="Field",j[j.Variable=4]="Variable",j[j.Class=5]="Class",j[j.Struct=6]="Struct",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Event=10]="Event",j[j.Operator=11]="Operator",j[j.Unit=12]="Unit",j[j.Value=13]="Value",j[j.Constant=14]="Constant",j[j.Enum=15]="Enum",j[j.EnumMember=16]="EnumMember",j[j.Keyword=17]="Keyword",j[j.Text=18]="Text",j[j.Color=19]="Color",j[j.File=20]="File",j[j.Reference=21]="Reference",j[j.Customcolor=22]="Customcolor",j[j.Folder=23]="Folder",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue",j[j.Snippet=27]="Snippet"})(p||(e.CompletionItemKind=p={}));var $;(function(j){const U=new Map;U.set(p.Method,t.$0j.symbolMethod),U.set(p.Function,t.$0j.symbolFunction),U.set(p.Constructor,t.$0j.symbolConstructor),U.set(p.Field,t.$0j.symbolField),U.set(p.Variable,t.$0j.symbolVariable),U.set(p.Class,t.$0j.symbolClass),U.set(p.Struct,t.$0j.symbolStruct),U.set(p.Interface,t.$0j.symbolInterface),U.set(p.Module,t.$0j.symbolModule),U.set(p.Property,t.$0j.symbolProperty),U.set(p.Event,t.$0j.symbolEvent),U.set(p.Operator,t.$0j.symbolOperator),U.set(p.Unit,t.$0j.symbolUnit),U.set(p.Value,t.$0j.symbolValue),U.set(p.Enum,t.$0j.symbolEnum),U.set(p.Constant,t.$0j.symbolConstant),U.set(p.Enum,t.$0j.symbolEnum),U.set(p.EnumMember,t.$0j.symbolEnumMember),U.set(p.Keyword,t.$0j.symbolKeyword),U.set(p.Snippet,t.$0j.symbolSnippet),U.set(p.Text,t.$0j.symbolText),U.set(p.Color,t.$0j.symbolColor),U.set(p.File,t.$0j.symbolFile),U.set(p.Reference,t.$0j.symbolReference),U.set(p.Customcolor,t.$0j.symbolCustomColor),U.set(p.Folder,t.$0j.symbolFolder),U.set(p.TypeParameter,t.$0j.symbolTypeParameter),U.set(p.User,t.$0j.account),U.set(p.Issue,t.$0j.issues);function te(oe){let _=U.get(oe);return _||(console.info("No codicon found for CompletionItemKind "+oe),_=t.$0j.symbolProperty),_}j.toIcon=te;const le=new Map;le.set("method",p.Method),le.set("function",p.Function),le.set("constructor",p.Constructor),le.set("field",p.Field),le.set("variable",p.Variable),le.set("class",p.Class),le.set("struct",p.Struct),le.set("interface",p.Interface),le.set("module",p.Module),le.set("property",p.Property),le.set("event",p.Event),le.set("operator",p.Operator),le.set("unit",p.Unit),le.set("value",p.Value),le.set("constant",p.Constant),le.set("enum",p.Enum),le.set("enum-member",p.EnumMember),le.set("enumMember",p.EnumMember),le.set("keyword",p.Keyword),le.set("snippet",p.Snippet),le.set("text",p.Text),le.set("color",p.Color),le.set("file",p.File),le.set("reference",p.Reference),le.set("customcolor",p.Customcolor),le.set("folder",p.Folder),le.set("type-parameter",p.TypeParameter),le.set("typeParameter",p.TypeParameter),le.set("account",p.User),le.set("issue",p.Issue);function ye(oe,_){let X=le.get(oe);return typeof X>"u"&&!_&&(X=p.Property),X}j.fromString=ye})($||(e.CompletionItemKinds=$={}));var a;(function(j){j[j.Deprecated=1]="Deprecated"})(a||(e.CompletionItemTag=a={}));var c;(function(j){j[j.None=0]="None",j[j.KeepWhitespace=1]="KeepWhitespace",j[j.InsertAsSnippet=4]="InsertAsSnippet"})(c||(e.CompletionItemInsertTextRule=c={}));var m;(function(j){j[j.Word=0]="Word",j[j.Line=1]="Line",j[j.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var b;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b||(e.CompletionTriggerKind=b={}));var g;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class d{constructor(U,te,le,ye){this.range=U,this.text=te,this.completionKind=le,this.isSnippetText=ye}equals(U){return I.$Yt.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}e.$Uu=d;var w;(function(j){j[j.Invoke=1]="Invoke",j[j.Auto=2]="Auto"})(w||(e.CodeActionTriggerType=w={}));var o;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(o||(e.DocumentPasteTriggerKind=o={}));var l;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var n;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function u(j){return j&&i.URI.isUri(j.uri)&&I.$Yt.isIRange(j.range)&&(I.$Yt.isIRange(j.originSelectionRange)||I.$Yt.isIRange(j.targetSelectionRange))}var r;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(r||(e.SymbolKind=r={})),e.$Wu={[r.Array]:(0,T.localize)(788,null),[r.Boolean]:(0,T.localize)(789,null),[r.Class]:(0,T.localize)(790,null),[r.Constant]:(0,T.localize)(791,null),[r.Constructor]:(0,T.localize)(792,null),[r.Enum]:(0,T.localize)(793,null),[r.EnumMember]:(0,T.localize)(794,null),[r.Event]:(0,T.localize)(795,null),[r.Field]:(0,T.localize)(796,null),[r.File]:(0,T.localize)(797,null),[r.Function]:(0,T.localize)(798,null),[r.Interface]:(0,T.localize)(799,null),[r.Key]:(0,T.localize)(800,null),[r.Method]:(0,T.localize)(801,null),[r.Module]:(0,T.localize)(802,null),[r.Namespace]:(0,T.localize)(803,null),[r.Null]:(0,T.localize)(804,null),[r.Number]:(0,T.localize)(805,null),[r.Object]:(0,T.localize)(806,null),[r.Operator]:(0,T.localize)(807,null),[r.Package]:(0,T.localize)(808,null),[r.Property]:(0,T.localize)(809,null),[r.String]:(0,T.localize)(810,null),[r.Struct]:(0,T.localize)(811,null),[r.TypeParameter]:(0,T.localize)(812,null),[r.Variable]:(0,T.localize)(813,null)};function f(j,U){return(0,T.localize)(814,null,j,e.$Wu[U])}var h;(function(j){j[j.Deprecated=1]="Deprecated"})(h||(e.SymbolTag=h={}));var k;(function(j){const U=new Map;U.set(r.File,t.$0j.symbolFile),U.set(r.Module,t.$0j.symbolModule),U.set(r.Namespace,t.$0j.symbolNamespace),U.set(r.Package,t.$0j.symbolPackage),U.set(r.Class,t.$0j.symbolClass),U.set(r.Method,t.$0j.symbolMethod),U.set(r.Property,t.$0j.symbolProperty),U.set(r.Field,t.$0j.symbolField),U.set(r.Constructor,t.$0j.symbolConstructor),U.set(r.Enum,t.$0j.symbolEnum),U.set(r.Interface,t.$0j.symbolInterface),U.set(r.Function,t.$0j.symbolFunction),U.set(r.Variable,t.$0j.symbolVariable),U.set(r.Constant,t.$0j.symbolConstant),U.set(r.String,t.$0j.symbolString),U.set(r.Number,t.$0j.symbolNumber),U.set(r.Boolean,t.$0j.symbolBoolean),U.set(r.Array,t.$0j.symbolArray),U.set(r.Object,t.$0j.symbolObject),U.set(r.Key,t.$0j.symbolKey),U.set(r.Null,t.$0j.symbolNull),U.set(r.EnumMember,t.$0j.symbolEnumMember),U.set(r.Struct,t.$0j.symbolStruct),U.set(r.Event,t.$0j.symbolEvent),U.set(r.Operator,t.$0j.symbolOperator),U.set(r.TypeParameter,t.$0j.symbolTypeParameter);function te(le){let ye=U.get(le);return ye||(console.info("No codicon found for SymbolKind "+le),ye=t.$0j.symbolProperty),ye}j.toIcon=te})(k||(e.SymbolKinds=k={}));class P{static asEditOperation(U){return E.$Zt.replace(I.$Yt.lift(U.range),U.text)}}e.$Yu=P;class O{static{this.Comment=new O("comment")}static{this.Imports=new O("imports")}static{this.Region=new O("region")}static fromValue(U){switch(U){case"comment":return O.Comment;case"imports":return O.Imports;case"region":return O.Region}return new O(U)}constructor(U){this.value=U}}e.$Zu=O;var C;(function(j){j[j.AIGenerated=1]="AIGenerated"})(C||(e.NewSymbolNameTag=C={}));var L;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(L||(e.NewSymbolNameTriggerKind=L={}));var R;(function(j){function U(te){return!te||typeof te!="object"?!1:typeof te.id=="string"&&typeof te.title=="string"}j.is=U})(R||(e.Command=R={}));var z;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(z||(e.CommentThreadCollapsibleState=z={}));var Q;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Q||(e.CommentThreadState=Q={}));var J;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(J||(e.CommentThreadApplicability=J={}));var x;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(x||(e.CommentMode=x={}));var ve;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ve||(e.CommentState=ve={}));var be;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(be||(e.InlayHintKind=be={}));class se{constructor(U){this.b=U,this.a=null}dispose(){this.a&&this.a.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$1u=se,e.$2u=new D.$Iu,e.$3u=new D.$Iu;var V;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(V||(e.ExternalUriOpenerPriority=V={}));var B;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(Oe[197],Le([1,0,34,9,7]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.TokenType=void 0;var I;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(I||(e.TokenType=I={}));function D(...S){switch(S.length){case 1:return(0,E.localize)(1693,null,S[0]);case 2:return(0,E.localize)(1694,null,S[0],S[1]);case 3:return(0,E.localize)(1695,null,S[0],S[1],S[2]);default:return}}const T=(0,E.localize)(1696,null),v=(0,E.localize)(1697,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case I.LParen:return"(";case I.RParen:return")";case I.Neg:return"!";case I.Eq:return y.isTripleEq?"===":"==";case I.NotEq:return y.isTripleEq?"!==":"!=";case I.Lt:return"<";case I.LtEq:return"<=";case I.Gt:return">=";case I.GtEq:return">=";case I.RegexOp:return"=~";case I.RegexStr:return y.lexeme;case I.True:return"true";case I.False:return"false";case I.In:return"in";case I.Not:return"not";case I.And:return"&&";case I.Or:return"||";case I.Str:return y.lexeme;case I.QuotedStr:return y.lexeme;case I.Error:return y.lexeme;case I.EOF:return"EOF";default:throw(0,i.$_)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",I.Not],["in",I.In],["false",I.False],["true",I.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case t.CharCode.OpenParen:this.k(I.LParen);break;case t.CharCode.CloseParen:this.k(I.RParen);break;case t.CharCode.ExclamationMark:if(this.h(t.CharCode.Equals)){const p=this.h(t.CharCode.Equals);this.f.push({type:I.NotEq,offset:this.d,isTripleEq:p})}else this.k(I.Neg);break;case t.CharCode.SingleQuote:this.o();break;case t.CharCode.Slash:this.q();break;case t.CharCode.Equals:if(this.h(t.CharCode.Equals)){const p=this.h(t.CharCode.Equals);this.f.push({type:I.Eq,offset:this.d,isTripleEq:p})}else this.h(t.CharCode.Tilde)?this.k(I.RegexOp):this.l(D("==","=~"));break;case t.CharCode.LessThan:this.k(this.h(t.CharCode.Equals)?I.LtEq:I.Lt);break;case t.CharCode.GreaterThan:this.k(this.h(t.CharCode.Equals)?I.GtEq:I.Gt);break;case t.CharCode.Ampersand:this.h(t.CharCode.Ampersand)?this.k(I.And):this.l(D("&&"));break;case t.CharCode.Pipe:this.h(t.CharCode.Pipe)?this.k(I.Or):this.l(D("||"));break;case t.CharCode.Space:case t.CharCode.CarriageReturn:case t.CharCode.Tab:case t.CharCode.LineFeed:case t.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(I.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?t.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const p=this.d,$=this.c.substring(this.d,this.e),a={type:I.Error,offset:this.d,lexeme:$};this.g.push({offset:p,lexeme:$,additionalInfo:y}),this.f.push(a)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const p=this.c.substring(this.d,this.e),$=s.b.get(p);$?this.k($):this.f.push({type:I.Str,lexeme:p,offset:this.d})}}o(){for(;this.j()!==t.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:I.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,p=!1,$=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(v);return}const c=this.c.charCodeAt(y);if(p)p=!1;else if(c===t.CharCode.Slash&&!$){y++;break}else c===t.CharCode.OpenSquareBracket?$=!0:c===t.CharCode.Backslash?p=!0:c===t.CharCode.CloseSquareBracket&&($=!1);y++}for(;y<this.c.length&&s.a.has(this.c.charCodeAt(y));)y++;this.e=y;const a=this.c.substring(this.d,this.e);this.f.push({type:I.RegexStr,lexeme:a,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fj=s}),define(Oe[198],Le([1,0,6,2]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=void 0;class E{constructor(){this.a=new t.$qe,this.b=new t.$qe,this.c=new t.$qe,this.d=new t.$qe}static{this.ChannelName="extensionhostdebugservice"}call(T,v,s){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:s[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:s[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:s[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:s[0],port:s[1],subId:s[2]}))}throw new Error("Method not implemented.")}listen(T,v,s){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$8o=E;class I extends i.$Zc{constructor(T){super(),this.b=T}reload(T){this.b.call("reload",[T])}get onReload(){return this.b.listen("reload")}close(T){this.b.call("close",[T])}get onClose(){return this.b.listen("close")}attachSession(T,v,s){this.b.call("attach",[T,v,s])}get onAttachSession(){return this.b.listen("attach")}terminateSession(T,v){this.b.call("terminate",[T,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(T,v){return this.b.call("openExtensionDevelopmentHostWindow",[T,v])}}e.$9o=I}),define(Oe[199],Le([1,0,4]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=void 0;class i{constructor(D){this.a=D}listen(D,T,v){throw new Error("Invalid listen")}call(D,T,v){switch(T){case"download":return this.a.download(t.URI.revive(v[0]),t.URI.revive(v[1]))}throw new Error("Invalid call")}}e.$$o=i;class E{constructor(D,T){this.a=D,this.b=T}async download(D,T){const v=this.b();v&&(D=v.transformOutgoingURI(D),T=v.transformOutgoingURI(T)),await this.a.call("download",[D,T])}}e.$_o=E}),define(Oe[200],Le([1,0,189,79,12,8,32,19,4]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=void 0,e.$cn=S,e.$dn=y,e.$an=/^([^.]+\..+)[:=](.+)$/;class s{get appRoot(){return(0,I.$rc)(E.$5g.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,I.$oc)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,T.$lh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,T.$lh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,t.$_m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.$oc)(this.userDataPath,"logs",$)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.$lh)(v.URI.file((0,I.$oc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,T.$lh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,T.$lh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,T.$lh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=D.env.VSCODE_PORTABLE;return $?v.URI.file((0,I.$oc)($,"argv.json")):(0,T.$lh)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,I.$oc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,I.$pc)($):(0,I.$mc)((0,I.$oc)(E.$5g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?v.URI.file((0,I.$pc)($)):v.URI.file((0,I.$oc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,I.$pc)($);const a=D.env.VSCODE_EXTENSIONS;if(a)return a;const c=D.env.VSCODE_PORTABLE;return c?(0,I.$oc)(c,"extensions"):(0,T.$lh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(a=>/^[^:/?#]+?:\/\//.test(a)?v.URI.parse(a):v.URI.file((0,I.$mc)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?v.URI.parse($):v.URI.file((0,I.$mc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$an.test($))}get extensionLogLevel(){const $=[];for(const a of this.args.log||[]){const c=e.$an.exec(a);c&&c[1]&&c[2]&&$.push([c[1],c[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,T.$lh)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=D.env.VSCODE_PORTABLE;return $?v.URI.file((0,I.$oc)($,"policy.json")):(0,T.$lh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,a,c){this.a=$,this.b=a,this.c=c,this.editSessionId=this.args.editSessionId}}e.$bn=s,Ve([i.$ci],s.prototype,"appRoot",null),Ve([i.$ci],s.prototype,"userHome",null),Ve([i.$ci],s.prototype,"userDataPath",null),Ve([i.$ci],s.prototype,"appSettingsHome",null),Ve([i.$ci],s.prototype,"tmpDir",null),Ve([i.$ci],s.prototype,"cacheHome",null),Ve([i.$ci],s.prototype,"stateResource",null),Ve([i.$ci],s.prototype,"userRoamingDataHome",null),Ve([i.$ci],s.prototype,"userDataSyncHome",null),Ve([i.$ci],s.prototype,"sync",null),Ve([i.$ci],s.prototype,"machineSettingsResource",null),Ve([i.$ci],s.prototype,"workspaceStorageHome",null),Ve([i.$ci],s.prototype,"localHistoryHome",null),Ve([i.$ci],s.prototype,"keyboardLayoutResource",null),Ve([i.$ci],s.prototype,"argvResource",null),Ve([i.$ci],s.prototype,"isExtensionDevelopment",null),Ve([i.$ci],s.prototype,"untitledWorkspacesHome",null),Ve([i.$ci],s.prototype,"builtinExtensionsPath",null),Ve([i.$ci],s.prototype,"extensionsPath",null),Ve([i.$ci],s.prototype,"extensionDevelopmentLocationURI",null),Ve([i.$ci],s.prototype,"extensionDevelopmentKind",null),Ve([i.$ci],s.prototype,"extensionTestsLocationURI",null),Ve([i.$ci],s.prototype,"debugExtensionHost",null),Ve([i.$ci],s.prototype,"logLevel",null),Ve([i.$ci],s.prototype,"extensionLogLevel",null),Ve([i.$ci],s.prototype,"serviceMachineIdResource",null),Ve([i.$ci],s.prototype,"disableTelemetry",null),Ve([i.$ci],s.prototype,"disableWorkspaceTrust",null),Ve([i.$ci],s.prototype,"useInMemorySecretStorage",null),Ve([i.$ci],s.prototype,"policyFile",null);function S(p,$){return y(p["inspect-extensions"],p["inspect-brk-extensions"],5870,$,p.debugId,p.extensionEnvironment)}function y(p,$,a,c,m,b){const d=Number($||p)||(c?null:a),w=d?!!$:!1;let o;if(b)try{o=JSON.parse(b)}catch{}return{port:d,break:w,debugId:m,env:o}}});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[71],Le([1,0,293,3,7]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=void 0,e.$Im=T,e.$Jm=s,e.$Km=$,e.$Lm=a,t=$t(t);const I={o:(0,E.localize)(1713,null),e:(0,E.localize)(1714,null),t:(0,E.localize)(1715,null)};e.$Gm=["tunnel","serve-web"],e.$Hm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(1716,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(1717,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(1718,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(1719,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(1720,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(1721,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(1722,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(1723,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(1724,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(1725,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(1726,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(1727,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(1728,null)},"stdin-to-clipboard":{type:"boolean",cat:"o",alias:"c",description:(0,E.localize)(1729,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(1730,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(1731,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(1732,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(1733,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(1734,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(1735,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(1736,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(1737,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(1738,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(1739,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(1740,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(1741,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(1742,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(1743,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(1744,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(1745,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(1746,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(1747,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(1748,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,E.localize)(1749,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(1750,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(1751,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(1752,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function T(c,m,b=D){const g=c.find(h=>h.length>0&&h[0]!=="-"),d={},w=["_"],o=[],l={};let n;for(const h in m){const k=m[h];k.type==="subcommand"?h===g&&(n=k):(k.alias&&(d[h]=k.alias),k.type==="string"||k.type==="string[]"?(w.push(h),k.deprecates&&w.push(...k.deprecates)):k.type==="boolean"&&(o.push(h),k.deprecates&&o.push(...k.deprecates)),k.global&&(l[h]=k))}if(n&&g){const h=l;for(const C in n.options)h[C]=n.options[C];const k=c.filter(C=>C!==g),P=b.getSubcommandReporter?b.getSubcommandReporter(g):void 0,O=T(k,h,P);return{[g]:O,_:[]}}const u=(0,t.default)(c,{string:w,boolean:o,alias:d}),r={},f=u;r._=u._.map(h=>String(h)).filter(h=>h.length>0),delete f._;for(const h in m){const k=m[h];if(k.type==="subcommand")continue;k.alias&&delete f[k.alias];let P=f[h];if(k.deprecates)for(const O of k.deprecates)f.hasOwnProperty(O)&&(P||(P=f[O],P&&b.onDeprecatedOption(O,k.deprecationMessage||(0,E.localize)(1753,null,h))),delete f[O]);if(typeof P<"u"){if(k.type==="string[]"){if(Array.isArray(P)||(P=[P]),!k.allowEmptyValue){const O=P.filter(C=>C.length>0);O.length!==P.length&&(b.onEmptyValue(h),P=O.length>0?O:void 0)}}else k.type==="string"&&(Array.isArray(P)?(P=P.pop(),b.onMultipleValues(h,P)):!P&&!k.allowEmptyValue&&(b.onEmptyValue(h),P=void 0));r[h]=P,k.deprecationMessage&&b.onDeprecatedOption(h,k.deprecationMessage)}delete f[h]}for(const h in f)b.onUnknownOption(h);return r}function v(c,m){let b="";return m.args&&(Array.isArray(m.args)?b=` <${m.args.join("> <")}>`:b=` <${m.args}>`),m.alias?`-${m.alias} --${c}${b}`:`--${c}${b}`}function s(c,m){const b=[];for(const g in c){const d=c[g],w=v(g,d);b.push([w,d.description])}return S(b,m)}function S(c,m){const g=c.reduce((o,l)=>Math.max(o,l[0].length),12)+2+1;if(m-g<25)return c.reduce((o,l)=>o.concat([`  ${l[0]}`,`      ${l[1]}`]),[]);const d=m-g-1,w=[];for(const o of c){const l=o[0],n=p(o[1],d),u=y(g-l.length-2);w.push("  "+l+u+n[0]);for(let r=1;r<n.length;r++)w.push(y(g)+n[r])}return w}function y(c){return" ".repeat(c)}function p(c,m){const b=[];for(;c.length;){const g=c.length<m?c.length:c.lastIndexOf(" ",m),d=c.slice(0,g).trim();c=c.slice(g),b.push(d)}return b}function $(c,m,b,g,d){const w=process.stdout.isTTY&&process.stdout.columns||80,o=d?.noInputFiles!==!0?`[${(0,E.localize)(1754,null)}...]`:"",l=[`${c} ${b}`];l.push(""),l.push(`${(0,E.localize)(1755,null)}: ${m} [${(0,E.localize)(1756,null)}]${o}`),l.push(""),d?.noPipe!==!0&&(i.$l?l.push((0,E.localize)(1757,null,m)):l.push((0,E.localize)(1758,null,m)),l.push(""));const n={},u=[];for(const r in g){const f=g[r];if(f.type==="subcommand")f.description&&u.push({command:r,description:f.description});else if(f.description&&f.cat){let h=n[f.cat];h||(n[f.cat]=h={}),h[r]=f}}for(const r in n){const f=r,h=n[f];h&&(l.push(I[f]),l.push(...s(h,w)),l.push(""))}return u.length&&(l.push((0,E.localize)(1759,null)),l.push(...S(u.map(r=>[r.command,r.description]),w)),l.push("")),l.join(`
`)}function a(c,m){return`${c||(0,E.localize)(1760,null)}
${m||(0,E.localize)(1761,null)}
${process.arch}`}});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[201],Le([1,0,294,7,71]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=T,e.$Nm=v,e.$Om=s,e.$Pm=S,t=$t(t);function I(y,p){const $=(d,w)=>{console.warn((0,i.localize)(1762,null,d,w))},a=d=>{console.warn((0,i.localize)(1763,null,d))},c=(d,w)=>{console.warn((0,i.localize)(1764,null,d,w))},m=d=>({onUnknownOption:w=>{E.$Gm.includes(d)||console.warn((0,i.localize)(1765,null,w,d))},onMultipleValues:$,onEmptyValue:a,onDeprecatedOption:c,getSubcommandReporter:E.$Gm.includes(d)?m:void 0}),b={onUnknownOption:d=>{console.warn((0,i.localize)(1766,null,d))},onMultipleValues:$,onEmptyValue:a,onDeprecatedOption:c,getSubcommandReporter:m},g=(0,E.$Im)(y,E.$Hm,p?b:void 0);return g.goto&&g._.forEach(d=>(0,t.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(d),(0,i.localize)(1767,null))),g}function D(y){const p=y.findIndex($=>!/^-/.test($));if(p>-1)return[...y.slice(0,p),...y.slice(p+1)]}function T(y){let[,...p]=y;process.env.VSCODE_DEV&&(p=D(p)||[]);const $=!S(process.env);return I(p,$)}function v(y){let[,,...p]=y;return process.env.VSCODE_DEV&&(p=D(p)||[]),I(p,!0)}function s(y,...p){const $=y.indexOf("--");return $===-1?y.push(...p):y.splice($,0,...p),y}function S(y){return y.VSCODE_CLI==="1"}}),function(){function ue(e,t,i){function E(D,T){const v=I(D,T),s=[v];return e.isAbsolute(v)||s.unshift(i),e.resolve(...s)}function I(D,T){process.env.VSCODE_DEV&&(T="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let s=process.env.VSCODE_APPDATA;if(s)return e.join(s,T);const S=D["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(s=process.env.APPDATA,!s){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");s=e.join(y,"AppData","Roaming")}break;case"darwin":s=e.join(t.homedir(),"Library","Application Support");break;case"linux":s=process.env.XDG_CONFIG_HOME||e.join(t.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(s,T)}return{getUserDataPath:E}}if(typeof define=="function")define(Oe[202],Le([59,31,32]),function(e,t,i){return ue(e,t,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),t=require("os");module.exports=ue(e,t,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Oe[120],Le([1,0,31,200,202]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=void 0,e.$fn=D,e.$gn=T;class I extends i.$bn{constructor(s,S){super(s,{homeDir:(0,t.homedir)(),tmpDir:(0,t.tmpdir)(),userDataDir:(0,E.getUserDataPath)(s,S.nameShort)},S)}}e.$en=I;function D(v,s){return(0,i.$dn)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,s,v.extensionEnvironment)}function T(v,s){return(0,i.$dn)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,s,v.extensionEnvironment)}}),define(Oe[203],Le([1,0,10,7]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=E;function E(D,T,v,s){try{I(D,T,v,s)}catch(S){D.error(S?.message??S)}return T}function I(D,T,v,s){const S=(y,p,$)=>{const a=y[p];if((0,t.$jg)(a)){const c=a,m=c.length;if(m>1&&c[0]==="%"&&c[m-1]==="%"){const b=c.substr(1,m-2);let g=v[b];g===void 0&&s&&(g=s[b]);const d=typeof g=="string"?g:g?.message,w=s?.[b],o=typeof w=="string"?w:w?.message;if(!d){o||D.warn(`[${T.name}]: ${(0,i.localize)(1815,null,b)}`);return}if($&&(p==="title"||p==="category")&&o&&o!==d){const l={value:d,original:o};y[p]=l}else y[p]=d}}else if((0,t.$lg)(a))for(const c in a)a.hasOwnProperty(c)&&(c==="commands"?S(a,c,!0):S(a,c,$));else if(Array.isArray(a))for(let c=0;c<a.length;c++)S(a,c,$)};for(const y in T)T.hasOwnProperty(y)&&S(T,y)}}),define(Oe[121],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const t={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribChatParticipantDetection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribChatParticipantDetection.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(t)}),define(Oe[72],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=void 0;class t{constructor(E,I=[],D=!1){this.ctor=E,this.staticArguments=I,this.supportsDelayedInstantiation=D}}e.$Hi=t}),define(Oe[122],Le([1,0,72]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$2s=I,e.$3s=D;const i=[];var E;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(E||(e.InstantiationType=E={}));function I(T,v,s){v instanceof t.$Hi||(v=new t.$Hi(v,[],!!s)),i.push([T,v])}function D(){return i}}),define(Oe[204],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;class t{constructor(I,D){this.key=I,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$Er=t;class i{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const D of this.a.values())D.outgoing.size===0&&I.push(D);return I}insertEdge(I,D){const T=this.lookupOrInsertNode(I),v=this.lookupOrInsertNode(D);T.outgoing.set(v.key,v),v.incoming.set(T.key,T)}removeNode(I){const D=this.b(I);this.a.delete(D);for(const T of this.a.values())T.outgoing.delete(D),T.incoming.delete(D)}lookupOrInsertNode(I){const D=this.b(I);let T=this.a.get(D);return T||(T=new t(D,I),this.a.set(D,T)),T}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[D,T]of this.a)I.push(`${D}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,D]of this.a){const T=new Set([I]),v=this.c(D,T);if(v)return v}}c(I,D){for(const[T,v]of I.outgoing){if(D.has(T))return[...D,T].join(" -> ");D.add(T);const s=this.c(v,D);if(s)return s;D.delete(T)}}}e.$Fr=i}),define(Oe[5],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e._util=void 0,e.$Ki=E,e.$Li=I;var t;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function T(v){return v[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=T})(t||(e._util=t={})),e.$Ji=E("instantiationService");function i(D,T,v){T[t.DI_TARGET]===T?T[t.DI_DEPENDENCIES].push({id:D,index:v}):(T[t.DI_DEPENDENCIES]=[{id:D,index:v}],T[t.DI_TARGET]=T)}function E(D){if(t.serviceIds.has(D))return t.serviceIds.get(D);const T=function(v,s,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(T,v,S)};return T.toString=()=>D,t.serviceIds.set(D,T),T}function I(D){return D}}),define(Oe[28],Le([1,0,10,4,5]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$ej=void 0,e.$fj=I,e.$gj=D,e.$hj=v,e.$ij=s,e.$jj=S,e.$kj=y,e.$lj=p,e.$mj=a,e.$nj=c,e.$oj=m,t=We(t),e.$ej=(0,E.$Ki)("configurationService");function I(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof i.URI)}function D(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||Array.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof i.URI)}var T;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.USER=2]="USER",b[b.USER_LOCAL=3]="USER_LOCAL",b[b.USER_REMOTE=4]="USER_REMOTE",b[b.WORKSPACE=5]="WORKSPACE",b[b.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",b[b.DEFAULT=7]="DEFAULT",b[b.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function v(b){switch(b){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function s(b){return b.applicationValue!==void 0||b.userValue!==void 0||b.userLocalValue!==void 0||b.userRemoteValue!==void 0||b.workspaceValue!==void 0||b.workspaceFolderValue!==void 0}function S(b,g){const d=Object.create(null);for(const w in b)y(d,w,b[w],g);return d}function y(b,g,d,w){const o=g.split("."),l=o.pop();let n=b;for(let u=0;u<o.length;u++){const r=o[u];let f=n[r];switch(typeof f){case"undefined":f=n[r]=Object.create(null);break;case"object":if(f===null){w(`Ignoring ${g} as ${o.slice(0,u+1).join(".")} is null`);return}break;default:w(`Ignoring ${g} as ${o.slice(0,u+1).join(".")} is ${JSON.stringify(f)}`);return}n=f}if(typeof n=="object"&&n!==null)try{n[l]=d}catch{w(`Ignoring ${g} as ${o.join(".")} is ${JSON.stringify(n)}`)}else w(`Ignoring ${g} as ${o.join(".")} is ${JSON.stringify(n)}`)}function p(b,g){const d=g.split(".");$(b,d)}function $(b,g){const d=g.shift();if(g.length===0){delete b[d];return}if(Object.keys(b).indexOf(d)!==-1){const w=b[d];typeof w=="object"&&!Array.isArray(w)&&($(w,g),Object.keys(w).length===0&&delete b[d])}}function a(b,g,d){function w(n,u){let r=n;for(const f of u){if(typeof r!="object"||r===null)return;r=r[f]}return r}const o=g.split("."),l=w(b,o);return typeof l>"u"?d:l}function c(b,g,d){Object.keys(g).forEach(w=>{w!=="__proto__"&&(w in b?t.$lg(b[w])&&t.$lg(g[w])?c(b[w],g[w],d):d&&(b[w]=g[w]):b[w]=g[w])})}function m(b){return b.replace(/[\[\]]/g,"")}}),define(Oe[41],Le([1,0,34,3,16,197,5,7,9]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Ij=e.$Hj=e.ContextKeyExprType=void 0,e.$Gj=S,e.$Jj=u,e.$Kj=r,e.$4j=oe;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",i.$m),s.set("isLinux",i.$n),s.set("isWindows",i.$l),s.set("isWeb",i.$r),s.set("isMacNative",i.$m&&!i.$r),s.set("isEdge",i.$K),s.set("isFirefox",i.$I),s.set("isChrome",i.$H),s.set("isSafari",i.$J);function S(M,A){if(s.get(M)!==void 0)throw(0,v.$$)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(M,A)}const y=Object.prototype.hasOwnProperty;var p;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const $={regexParsingWithErrorRecovery:!0},a=(0,T.localize)(1673,null),c=(0,T.localize)(1674,null),m=(0,T.localize)(1675,null),b=(0,T.localize)(1676,null),g=(0,T.localize)(1677,null),d=(0,T.localize)(1678,null),w=(0,T.localize)(1679,null),o=(0,T.localize)(1680,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=$){this.k=A,this.d=new I.$Fj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:a,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const Y=this.l();if(!this.E()){const pe=this.D(),ne=pe.type===I.TokenType.Str?d:void 0;throw this.h.push({message:g,offset:pe.offset,lexeme:I.$Fj.getLexeme(pe),additionalInfo:ne}),l.c}return Y}catch(Y){if(Y!==l.c)throw Y;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(I.TokenType.Or);){const Y=this.o();A.push(Y)}return A.length===1?A[0]:n.or(...A)}o(){const A=[this.s()];for(;this.y(I.TokenType.And);){const Y=this.s();A.push(Y)}return A.length===1?A[0]:n.and(...A)}s(){if(this.y(I.TokenType.Neg)){const A=this.D();switch(A.type){case I.TokenType.True:return this.z(),h.INSTANCE;case I.TokenType.False:return this.z(),k.INSTANCE;case I.TokenType.LParen:{this.z();const Y=this.l();return this.A(I.TokenType.RParen,b),Y?.negate()}case I.TokenType.Str:return this.z(),z.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case I.TokenType.True:return this.z(),n.true();case I.TokenType.False:return this.z(),n.false();case I.TokenType.LParen:{this.z();const Y=this.l();return this.A(I.TokenType.RParen,b),Y}case I.TokenType.Str:{const Y=A.lexeme;if(this.z(),this.y(I.TokenType.RegexOp)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==I.TokenType.RegexStr)throw this.B("REGEX",ne);const ie=ne.lexeme,G=ie.lastIndexOf("/"),Z=G===ie.length-1?void 0:this.w(ie.substring(G+1));let ce;try{ce=new RegExp(ie.substring(1,G),Z)}catch{throw this.B("REGEX",ne)}return se.create(Y,ce)}switch(ne.type){case I.TokenType.RegexStr:case I.TokenType.Error:{const ie=[ne.lexeme];this.z();let G=this.D(),Z=0;for(let Be=0;Be<ne.lexeme.length;Be++)ne.lexeme.charCodeAt(Be)===t.CharCode.OpenParen?Z++:ne.lexeme.charCodeAt(Be)===t.CharCode.CloseParen&&Z--;for(;!this.E()&&G.type!==I.TokenType.And&&G.type!==I.TokenType.Or;){switch(G.type){case I.TokenType.LParen:Z++;break;case I.TokenType.RParen:Z--;break;case I.TokenType.RegexStr:case I.TokenType.QuotedStr:for(let Be=0;Be<G.lexeme.length;Be++)G.lexeme.charCodeAt(Be)===t.CharCode.OpenParen?Z++:ne.lexeme.charCodeAt(Be)===t.CharCode.CloseParen&&Z--}if(Z<0)break;ie.push(I.$Fj.getLexeme(G)),this.z(),G=this.D()}const ce=ie.join(""),we=ce.lastIndexOf("/"),Ie=we===ce.length-1?void 0:this.w(ce.substring(we+1));let Me;try{Me=new RegExp(ce.substring(1,we),Ie)}catch{throw this.B("REGEX",ne)}return n.regex(Y,Me)}case I.TokenType.QuotedStr:{const ie=ne.lexeme;this.z();let G=null;if(!(0,E.$hf)(ie)){const Z=ie.indexOf("/"),ce=ie.lastIndexOf("/");if(Z!==ce&&Z>=0){const we=ie.slice(Z+1,ce),Ie=ie[ce+1]==="i"?"i":"";try{G=new RegExp(we,Ie)}catch{throw this.B("REGEX",ne)}}}if(G===null)throw this.B("REGEX",ne);return se.create(Y,G)}default:throw this.B("REGEX",this.D())}}if(this.y(I.TokenType.Not)){this.A(I.TokenType.In,m);const ne=this.u();return n.notIn(Y,ne)}switch(this.D().type){case I.TokenType.Eq:{this.z();const ne=this.u();if(this.x().type===I.TokenType.QuotedStr)return n.equals(Y,ne);switch(ne){case"true":return n.has(Y);case"false":return n.not(Y);default:return n.equals(Y,ne)}}case I.TokenType.NotEq:{this.z();const ne=this.u();if(this.x().type===I.TokenType.QuotedStr)return n.notEquals(Y,ne);switch(ne){case"true":return n.not(Y);case"false":return n.has(Y);default:return n.notEquals(Y,ne)}}case I.TokenType.Lt:return this.z(),ve.create(Y,this.u());case I.TokenType.LtEq:return this.z(),be.create(Y,this.u());case I.TokenType.Gt:return this.z(),J.create(Y,this.u());case I.TokenType.GtEq:return this.z(),x.create(Y,this.u());case I.TokenType.In:return this.z(),n.in(Y,this.u());default:return n.has(Y)}}case I.TokenType.EOF:throw this.h.push({message:w,offset:A.offset,lexeme:"",additionalInfo:o}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case I.TokenType.Str:case I.TokenType.QuotedStr:return this.z(),A.lexeme;case I.TokenType.True:return this.z(),"true";case I.TokenType.False:return this.z(),"false";case I.TokenType.In:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,Y){if(this.C(A))return this.z();throw this.B(Y,this.D())}B(A,Y,pe){const ne=(0,T.localize)(1681,null,A,I.$Fj.getLexeme(Y)),ie=Y.offset,G=I.$Fj.getLexeme(Y);return this.h.push({message:ne,offset:ie,lexeme:G,additionalInfo:pe}),l.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===I.TokenType.EOF}}e.$Hj=l;class n{static false(){return h.INSTANCE}static true(){return k.INSTANCE}static has(A){return P.create(A)}static equals(A,Y){return O.create(A,Y)}static notEquals(A,Y){return R.create(A,Y)}static regex(A,Y){return se.create(A,Y)}static in(A,Y){return C.create(A,Y)}static notIn(A,Y){return L.create(A,Y)}static not(A){return z.create(A)}static and(...A){return j.create(A,null,!0)}static or(...A){return U.create(A,null,!0)}static greater(A,Y){return J.create(A,Y)}static greaterEquals(A,Y){return x.create(A,Y)}static smaller(A,Y){return ve.create(A,Y)}static smallerEquals(A,Y){return be.create(A,Y)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.$Ij=n;function u(M){const A=new l({regexParsingWithErrorRecovery:!1});return M.map(Y=>(A.parse(Y),A.lexingErrors.length>0?A.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,T.localize)(1682,null,pe.additionalInfo):(0,T.localize)(1683,null),offset:pe.offset,length:pe.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function r(M,A){const Y=M?M.substituteConstants():void 0,pe=A?A.substituteConstants():void 0;return!Y&&!pe?!0:!Y||!pe?!1:Y.equals(pe)}function f(M,A){return M.cmp(A)}class h{static{this.INSTANCE=new h}constructor(){this.type=p.False}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return k.INSTANCE}}e.$Lj=h;class k{static{this.INSTANCE=new k}constructor(){this.type=p.True}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return h.INSTANCE}}e.$Mj=k;class P{static create(A,Y=null){const pe=s.get(A);return typeof pe=="boolean"?pe?k.INSTANCE:h.INSTANCE:new P(A,Y)}constructor(A,Y){this.key=A,this.c=Y,this.type=p.Defined}cmp(A){return A.type!==this.type?this.type-A.type:le(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=s.get(this.key);return typeof A=="boolean"?A?k.INSTANCE:h.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=z.create(this.key,this)),this.c}}e.$Nj=P;class O{static create(A,Y,pe=null){if(typeof Y=="boolean")return Y?P.create(A,pe):z.create(A,pe);const ne=s.get(A);return typeof ne=="boolean"?Y===(ne?"true":"false")?k.INSTANCE:h.INSTANCE:new O(A,Y,pe)}constructor(A,Y,pe){this.c=A,this.d=Y,this.f=pe,this.type=p.Equals}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=s.get(this.c);if(typeof A=="boolean"){const Y=A?"true":"false";return this.d===Y?k.INSTANCE:h.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Oj=O;class C{static create(A,Y){return new C(A,Y)}constructor(A,Y){this.d=A,this.f=Y,this.type=p.In,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const Y=A.getValue(this.f),pe=A.getValue(this.d);return Array.isArray(Y)?Y.includes(pe):typeof pe=="string"&&typeof Y=="object"&&Y!==null?y.call(Y,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=L.create(this.d,this.f)),this.c}}e.$Pj=C;class L{static create(A,Y){return new L(A,Y)}constructor(A,Y){this.d=A,this.f=Y,this.type=p.NotIn,this.c=C.create(A,Y)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qj=L;class R{static create(A,Y,pe=null){if(typeof Y=="boolean")return Y?z.create(A,pe):P.create(A,pe);const ne=s.get(A);return typeof ne=="boolean"?Y===(ne?"true":"false")?h.INSTANCE:k.INSTANCE:new R(A,Y,pe)}constructor(A,Y,pe){this.c=A,this.d=Y,this.f=pe,this.type=p.NotEquals}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=s.get(this.c);if(typeof A=="boolean"){const Y=A?"true":"false";return this.d===Y?h.INSTANCE:k.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Rj=R;class z{static create(A,Y=null){const pe=s.get(A);return typeof pe=="boolean"?pe?h.INSTANCE:k.INSTANCE:new z(A,Y)}constructor(A,Y){this.c=A,this.d=Y,this.type=p.Not}cmp(A){return A.type!==this.type?this.type-A.type:le(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=s.get(this.c);return typeof A=="boolean"?A?h.INSTANCE:k.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=P.create(this.c,this)),this.d}}e.$Sj=z;function Q(M,A){if(typeof M=="string"){const Y=parseFloat(M);isNaN(Y)||(M=Y)}return typeof M=="string"||typeof M=="number"?A(M):h.INSTANCE}class J{static create(A,Y,pe=null){return Q(Y,ne=>new J(A,ne,pe))}constructor(A,Y,pe){this.c=A,this.d=Y,this.f=pe,this.type=p.Greater}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=be.create(this.c,this.d,this)),this.f}}e.$Tj=J;class x{static create(A,Y,pe=null){return Q(Y,ne=>new x(A,ne,pe))}constructor(A,Y,pe){this.c=A,this.d=Y,this.f=pe,this.type=p.GreaterEquals}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ve.create(this.c,this.d,this)),this.f}}e.$Uj=x;class ve{static create(A,Y,pe=null){return Q(Y,ne=>new ve(A,ne,pe))}constructor(A,Y,pe){this.c=A,this.d=Y,this.f=pe,this.type=p.Smaller}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Vj=ve;class be{static create(A,Y,pe=null){return Q(Y,ne=>new be(A,ne,pe))}constructor(A,Y,pe){this.c=A,this.d=Y,this.f=pe,this.type=p.SmallerEquals}cmp(A){return A.type!==this.type?this.type-A.type:ye(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Wj=be;class se{static create(A,Y){return new se(A,Y)}constructor(A,Y){this.d=A,this.f=Y,this.type=p.Regex,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const Y=this.f?this.f.source:"",pe=A.f?A.f.source:"";return Y<pe?-1:Y>pe?1:0}equals(A){if(A.type===this.type){const Y=this.f?this.f.source:"",pe=A.f?A.f.source:"";return this.d===A.d&&Y===pe}return!1}substituteConstants(){return this}evaluate(A){const Y=A.getValue(this.d);return this.f?this.f.test(Y):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$Xj=se;class V{static create(A){return new V(A)}constructor(A){this.c=A,this.type=p.NotRegex}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new V(this.c.map(A))}negate(){return this.c}}e.$Yj=V;function B(M){let A=null;for(let Y=0,pe=M.length;Y<pe;Y++){const ne=M[Y].substituteConstants();if(M[Y]!==ne&&A===null){A=[];for(let ie=0;ie<Y;ie++)A[ie]=M[ie]}A!==null&&(A[Y]=ne)}return A===null?M:A}class j{static create(A,Y,pe){return j.d(A,Y,pe)}constructor(A,Y){this.expr=A,this.c=Y,this.type=p.And}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let Y=0,pe=this.expr.length;Y<pe;Y++){const ne=f(this.expr[Y],A.expr[Y]);if(ne!==0)return ne}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let Y=0,pe=this.expr.length;Y<pe;Y++)if(!this.expr[Y].equals(A.expr[Y]))return!1;return!0}return!1}substituteConstants(){const A=B(this.expr);return A===this.expr?this:j.create(A,this.c,!1)}evaluate(A){for(let Y=0,pe=this.expr.length;Y<pe;Y++)if(!this.expr[Y].evaluate(A))return!1;return!0}static d(A,Y,pe){const ne=[];let ie=!1;for(const G of A)if(G){if(G.type===p.True){ie=!0;continue}if(G.type===p.False)return h.INSTANCE;if(G.type===p.And){ne.push(...G.expr);continue}ne.push(G)}if(ne.length===0&&ie)return k.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(f);for(let G=1;G<ne.length;G++)ne[G-1].equals(ne[G])&&(ne.splice(G,1),G--);if(ne.length===1)return ne[0];for(;ne.length>1;){const G=ne[ne.length-1];if(G.type!==p.Or)break;ne.pop();const Z=ne.pop(),ce=ne.length===0,we=U.create(G.expr.map(Ie=>j.create([Ie,Z],null,pe)),null,ce);we&&(ne.push(we),ne.sort(f))}if(ne.length===1)return ne[0];if(pe){for(let G=0;G<ne.length;G++)for(let Z=G+1;Z<ne.length;Z++)if(ne[G].negate().equals(ne[Z]))return h.INSTANCE;if(ne.length===1)return ne[0]}return new j(ne,Y)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const Y of this.expr)A.push(...Y.keys());return A}map(A){return new j(this.expr.map(Y=>Y.map(A)),null)}negate(){if(!this.c){const A=[];for(const Y of this.expr)A.push(Y.negate());this.c=U.create(A,this,!0)}return this.c}}e.$Zj=j;class U{static create(A,Y,pe){return U.d(A,Y,pe)}constructor(A,Y){this.expr=A,this.c=Y,this.type=p.Or}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let Y=0,pe=this.expr.length;Y<pe;Y++){const ne=f(this.expr[Y],A.expr[Y]);if(ne!==0)return ne}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let Y=0,pe=this.expr.length;Y<pe;Y++)if(!this.expr[Y].equals(A.expr[Y]))return!1;return!0}return!1}substituteConstants(){const A=B(this.expr);return A===this.expr?this:U.create(A,this.c,!1)}evaluate(A){for(let Y=0,pe=this.expr.length;Y<pe;Y++)if(this.expr[Y].evaluate(A))return!0;return!1}static d(A,Y,pe){let ne=[],ie=!1;if(A){for(let G=0,Z=A.length;G<Z;G++){const ce=A[G];if(ce){if(ce.type===p.False){ie=!0;continue}if(ce.type===p.True)return k.INSTANCE;if(ce.type===p.Or){ne=ne.concat(ce.expr);continue}ne.push(ce)}}if(ne.length===0&&ie)return h.INSTANCE;ne.sort(f)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let G=1;G<ne.length;G++)ne[G-1].equals(ne[G])&&(ne.splice(G,1),G--);if(ne.length===1)return ne[0];if(pe){for(let G=0;G<ne.length;G++)for(let Z=G+1;Z<ne.length;Z++)if(ne[G].negate().equals(ne[Z]))return k.INSTANCE;if(ne.length===1)return ne[0]}return new U(ne,Y)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const Y of this.expr)A.push(...Y.keys());return A}map(A){return new U(this.expr.map(Y=>Y.map(A)),null)}negate(){if(!this.c){const A=[];for(const Y of this.expr)A.push(Y.negate());for(;A.length>1;){const Y=A.shift(),pe=A.shift(),ne=[];for(const ie of X(Y))for(const G of X(pe))ne.push(j.create([ie,G],null,!1));A.unshift(U.create(ne,null,!1))}this.c=U.create(A,this,!0)}return this.c}}e.$1j=U;class te extends P{static{this.d=[]}static all(){return te.d.values()}constructor(A,Y,pe){super(A,null),this.f=Y,typeof pe=="object"?te.d.push({...pe,key:A}):pe!==!0&&te.d.push({key:A,description:pe,type:Y!=null?typeof Y:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return O.create(this.key,A)}notEqualsTo(A){return R.create(this.key,A)}}e.$2j=te,e.$3j=(0,D.$Ki)("contextKeyService");function le(M,A){return M<A?-1:M>A?1:0}function ye(M,A,Y,pe){return M<Y?-1:M>Y?1:A<pe?-1:A>pe?1:0}function oe(M,A){if(M.type===p.False||A.type===p.True)return!0;if(M.type===p.Or)return A.type===p.Or?_(M.expr,A.expr):!1;if(A.type===p.Or){for(const Y of A.expr)if(oe(M,Y))return!0;return!1}if(M.type===p.And){if(A.type===p.And)return _(A.expr,M.expr);for(const Y of M.expr)if(oe(Y,A))return!0;return!1}return M.equals(A)}function _(M,A){let Y=0,pe=0;for(;Y<M.length&&pe<A.length;){const ne=M[Y].cmp(A[pe]);if(ne<0)return!1;ne===0&&Y++,pe++}return Y===M.length}function X(M){return M.type===p.Or?M.expr:[M]}}),define(Oe[205],Le([1,0,41,5]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=e.$Ct=e.AccessibilitySupport=e.$Bt=void 0,e.$Dt=I,e.$Bt=(0,i.$Ki)("accessibilityService");var E;(function(D){D[D.Unknown=0]="Unknown",D[D.Disabled=1]="Disabled",D[D.Enabled=2]="Enabled"})(E||(e.AccessibilitySupport=E={})),e.$Ct=new t.$2j("accessibilityModeEnabled",!1);function I(D){return D&&typeof D=="object"&&typeof D.label=="string"&&(typeof D.role>"u"||typeof D.role=="string")}e.$Et="ACCESSIBLE_VIEW_SHOWN_"}),define(Oe[206],Le([1,0,17,21,3,173,109,184,185,7,205]),function(ue,e,t,i,E,I,D,T,v,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=d,e.clampedInt=o,e.clampedFloat=n,e.stringSet=f,e.cursorStyleToString=Q,e.filterValidationDecorations=Ne,t=We(t),i=We(i),E=We(E),s=We(s);var y;(function(W){W[W.None=0]="None",W[W.Keep=1]="Keep",W[W.Brackets=2]="Brackets",W[W.Advanced=3]="Advanced",W[W.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class p{constructor(K){this.c=K}hasChanged(K){return this.c[K]}}e.ConfigurationChangedEvent=p;class ${constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=$;class a{constructor(K,$e,Fe,qe){this.id=K,this.name=$e,this.defaultValue=Fe,this.schema=qe}applyUpdate(K,$e){return m(K,$e)}compute(K,$e,Fe){return Fe}}class c{constructor(K,$e){this.newValue=K,this.didChange=$e}}e.ApplyUpdateResult=c;function m(W,K){if(typeof W!="object"||typeof K!="object"||!W||!K)return new c(K,W!==K);if(Array.isArray(W)||Array.isArray(K)){const Fe=Array.isArray(W)&&Array.isArray(K)&&t.$yb(W,K);return new c(K,!Fe)}let $e=!1;for(const Fe in K)if(K.hasOwnProperty(Fe)){const qe=m(W[Fe],K[Fe]);qe.didChange&&(W[Fe]=qe.newValue,$e=!0)}return new c(W,$e)}class b{constructor(K){this.schema=void 0,this.id=K,this.name="_never_",this.defaultValue=void 0}applyUpdate(K,$e){return m(K,$e)}validate(K){return this.defaultValue}}class g{constructor(K,$e,Fe,qe){this.id=K,this.name=$e,this.defaultValue=Fe,this.schema=qe}applyUpdate(K,$e){return m(K,$e)}validate(K){return typeof K>"u"?this.defaultValue:K}compute(K,$e,Fe){return Fe}}function d(W,K){return typeof W>"u"?K:W==="false"?!1:!!W}class w extends g{constructor(K,$e,Fe,qe=void 0){typeof qe<"u"&&(qe.type="boolean",qe.default=Fe),super(K,$e,Fe,qe)}validate(K){return d(K,this.defaultValue)}}function o(W,K,$e,Fe){if(typeof W>"u")return K;let qe=parseInt(W,10);return isNaN(qe)?K:(qe=Math.max($e,qe),qe=Math.min(Fe,qe),qe|0)}class l extends g{static clampedInt(K,$e,Fe,qe){return o(K,$e,Fe,qe)}constructor(K,$e,Fe,qe,xe,et=void 0){typeof et<"u"&&(et.type="integer",et.default=Fe,et.minimum=qe,et.maximum=xe),super(K,$e,Fe,et),this.minimum=qe,this.maximum=xe}validate(K){return l.clampedInt(K,this.defaultValue,this.minimum,this.maximum)}}function n(W,K,$e,Fe){if(typeof W>"u")return K;const qe=u.float(W,K);return u.clamp(qe,$e,Fe)}class u extends g{static clamp(K,$e,Fe){return K<$e?$e:K>Fe?Fe:K}static float(K,$e){if(typeof K=="number")return K;if(typeof K>"u")return $e;const Fe=parseFloat(K);return isNaN(Fe)?$e:Fe}constructor(K,$e,Fe,qe,xe){typeof xe<"u"&&(xe.type="number",xe.default=Fe),super(K,$e,Fe,xe),this.validationFn=qe}validate(K){return this.validationFn(u.float(K,this.defaultValue))}}class r extends g{static string(K,$e){return typeof K!="string"?$e:K}constructor(K,$e,Fe,qe=void 0){typeof qe<"u"&&(qe.type="string",qe.default=Fe),super(K,$e,Fe,qe)}validate(K){return r.string(K,this.defaultValue)}}function f(W,K,$e,Fe){return typeof W!="string"?K:Fe&&W in Fe?Fe[W]:$e.indexOf(W)===-1?K:W}class h extends g{constructor(K,$e,Fe,qe,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.enum=qe,xe.default=Fe),super(K,$e,Fe,xe),this.c=qe}validate(K){return f(K,this.defaultValue,this.c)}}class k extends a{constructor(K,$e,Fe,qe,xe,et,it=void 0){typeof it<"u"&&(it.type="string",it.enum=xe,it.default=qe),super(K,$e,Fe,it),this.c=xe,this.d=et}validate(K){return typeof K!="string"?this.defaultValue:this.c.indexOf(K)===-1?this.defaultValue:this.d(K)}}function P(W){switch(W){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class O extends a{constructor(){super(fe.accessibilitySupport,"accessibilitySupport",S.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(302,null),s.localize(303,null),s.localize(304,null)],default:"auto",tags:["accessibility"],description:s.localize(305,null)})}validate(K){switch(K){case"auto":return S.AccessibilitySupport.Unknown;case"off":return S.AccessibilitySupport.Disabled;case"on":return S.AccessibilitySupport.Enabled}return this.defaultValue}compute(K,$e,Fe){return Fe===S.AccessibilitySupport.Unknown?K.accessibilitySupport:Fe}}class C extends a{constructor(){const K={insertSpace:!0,ignoreEmptyLines:!0};super(fe.comments,"comments",K,{"editor.comments.insertSpace":{type:"boolean",default:K.insertSpace,description:s.localize(306,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:K.ignoreEmptyLines,description:s.localize(307,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{insertSpace:d($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(W){W[W.Hidden=0]="Hidden",W[W.Blink=1]="Blink",W[W.Smooth=2]="Smooth",W[W.Phase=3]="Phase",W[W.Expand=4]="Expand",W[W.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function R(W){switch(W){case"blink":return L.Blink;case"smooth":return L.Smooth;case"phase":return L.Phase;case"expand":return L.Expand;case"solid":return L.Solid}}var z;(function(W){W[W.Line=1]="Line",W[W.Block=2]="Block",W[W.Underline=3]="Underline",W[W.LineThin=4]="LineThin",W[W.BlockOutline=5]="BlockOutline",W[W.UnderlineThin=6]="UnderlineThin"})(z||(e.TextEditorCursorStyle=z={}));function Q(W){switch(W){case z.Line:return"line";case z.Block:return"block";case z.Underline:return"underline";case z.LineThin:return"line-thin";case z.BlockOutline:return"block-outline";case z.UnderlineThin:return"underline-thin"}}function J(W){switch(W){case"line":return z.Line;case"block":return z.Block;case"underline":return z.Underline;case"line-thin":return z.LineThin;case"block-outline":return z.BlockOutline;case"underline-thin":return z.UnderlineThin}}class x extends b{constructor(){super(fe.editorClassName)}compute(K,$e,Fe){const qe=["monaco-editor"];return $e.get(fe.extraEditorClassName)&&qe.push($e.get(fe.extraEditorClassName)),K.extraEditorClassName&&qe.push(K.extraEditorClassName),$e.get(fe.mouseStyle)==="default"?qe.push("mouse-default"):$e.get(fe.mouseStyle)==="copy"&&qe.push("mouse-copy"),$e.get(fe.showUnused)&&qe.push("showUnused"),$e.get(fe.showDeprecated)&&qe.push("showDeprecated"),qe.join(" ")}}class ve extends w{constructor(){super(fe.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(308,null)})}compute(K,$e,Fe){return Fe&&K.emptySelectionClipboard}}class be extends a{constructor(){const K={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(fe.find,"find",K,{"editor.find.cursorMoveOnType":{type:"boolean",default:K.cursorMoveOnType,description:s.localize(309,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:K.seedSearchStringFromSelection,enumDescriptions:[s.localize(310,null),s.localize(311,null),s.localize(312,null)],description:s.localize(313,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:K.autoFindInSelection,enumDescriptions:[s.localize(314,null),s.localize(315,null),s.localize(316,null)],description:s.localize(317,null)},"editor.find.globalFindClipboard":{type:"boolean",default:K.globalFindClipboard,description:s.localize(318,null),included:E.$m},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:K.addExtraSpaceOnTop,description:s.localize(319,null)},"editor.find.loop":{type:"boolean",default:K.loop,description:s.localize(320,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{cursorMoveOnType:d($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof K.seedSearchStringFromSelection=="boolean"?K.seedSearchStringFromSelection?"always":"never":f($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof K.autoFindInSelection=="boolean"?K.autoFindInSelection?"always":"never":f($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d($e.loop,this.defaultValue.loop)}}}class se extends a{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(fe.fontLigatures,"fontLigatures",se.OFF,{anyOf:[{type:"boolean",description:s.localize(321,null)},{type:"string",description:s.localize(322,null)}],description:s.localize(323,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"||K.length===0?se.OFF:K==="true"?se.ON:K:K?se.ON:se.OFF}}e.EditorFontLigatures=se;class V extends a{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(fe.fontVariations,"fontVariations",V.OFF,{anyOf:[{type:"boolean",description:s.localize(324,null)},{type:"string",description:s.localize(325,null)}],description:s.localize(326,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"?V.OFF:K==="true"?V.TRANSLATE:K:K?V.TRANSLATE:V.OFF}compute(K,$e,Fe){return K.fontInfo.fontVariationSettings}}e.EditorFontVariations=V;class B extends b{constructor(){super(fe.fontInfo)}compute(K,$e,Fe){return K.fontInfo}}class j extends g{constructor(){super(fe.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(327,null)})}validate(K){const $e=u.float(K,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp($e,6,100)}compute(K,$e,Fe){return K.fontInfo.fontSize}}class U extends a{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(fe.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.d,maximum:U.e,errorMessage:s.localize(328,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(329,null)})}validate(K){return K==="normal"||K==="bold"?K:String(l.clampedInt(K,e.EDITOR_FONT_DEFAULTS.fontWeight,U.d,U.e))}}class te extends a{constructor(){const K={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:K.multiple,enumDescriptions:[s.localize(330,null),s.localize(331,null),s.localize(332,null)]},Fe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(fe.gotoLocation,"gotoLocation",K,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(333,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(334,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(335,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:s.localize(336,null),...$e},"editor.gotoLocation.multipleImplementations":{description:s.localize(337,null),...$e},"editor.gotoLocation.multipleReferences":{description:s.localize(338,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:K.alternativeDefinitionCommand,enum:Fe,description:s.localize(339,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:K.alternativeTypeDefinitionCommand,enum:Fe,description:s.localize(340,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:K.alternativeDeclarationCommand,enum:Fe,description:s.localize(341,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:K.alternativeImplementationCommand,enum:Fe,description:s.localize(342,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:K.alternativeReferenceCommand,enum:Fe,description:s.localize(343,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{multiple:f($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??f($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??f($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??f($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??f($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??f($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:$e.multipleTests??f($e.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:r.string($e.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class le extends a{constructor(){const K={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(fe.hover,"hover",K,{"editor.hover.enabled":{type:"boolean",default:K.enabled,description:s.localize(344,null)},"editor.hover.delay":{type:"number",default:K.delay,minimum:0,maximum:1e4,description:s.localize(345,null)},"editor.hover.sticky":{type:"boolean",default:K.sticky,description:s.localize(346,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:K.hidingDelay,description:s.localize(347,null)},"editor.hover.above":{type:"boolean",default:K.above,description:s.localize(348,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{enabled:d($e.enabled,this.defaultValue.enabled),delay:l.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:d($e.sticky,this.defaultValue.sticky),hidingDelay:l.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:d($e.above,this.defaultValue.above)}}}var ye;(function(W){W[W.None=0]="None",W[W.Text=1]="Text",W[W.Blocks=2]="Blocks"})(ye||(e.RenderMinimap=ye={}));class oe extends b{constructor(){super(fe.layoutInfo)}compute(K,$e,Fe){return oe.computeLayout($e,{memory:K.memory,outerWidth:K.outerWidth,outerHeight:K.outerHeight,isDominatedByLongLines:K.isDominatedByLongLines,lineHeight:K.fontInfo.lineHeight,viewLineCount:K.viewLineCount,lineNumbersDigitCount:K.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:K.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:K.fontInfo.maxDigitWidth,pixelRatio:K.pixelRatio,glyphMarginDecorationLaneCount:K.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(K){const $e=K.height/K.lineHeight,Fe=Math.floor(K.paddingTop/K.lineHeight);let qe=Math.floor(K.paddingBottom/K.lineHeight);K.scrollBeyondLastLine&&(qe=Math.max(qe,$e-1));const xe=(Fe+K.viewLineCount+qe)/(K.pixelRatio*K.height),et=Math.floor(K.viewLineCount/xe);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Fe,extraLinesBeyondLastLine:qe,desiredRatio:xe,minimapLineCount:et}}static c(K,$e){const Fe=K.outerWidth,qe=K.outerHeight,xe=K.pixelRatio;if(!K.minimap.enabled)return{renderMinimap:ye.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const et=$e.stableMinimapLayoutInput,it=et&&K.outerHeight===et.outerHeight&&K.lineHeight===et.lineHeight&&K.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&K.pixelRatio===et.pixelRatio&&K.scrollBeyondLastLine===et.scrollBeyondLastLine&&K.paddingTop===et.paddingTop&&K.paddingBottom===et.paddingBottom&&K.minimap.enabled===et.minimap.enabled&&K.minimap.side===et.minimap.side&&K.minimap.size===et.minimap.size&&K.minimap.showSlider===et.minimap.showSlider&&K.minimap.renderCharacters===et.minimap.renderCharacters&&K.minimap.maxColumn===et.minimap.maxColumn&&K.minimap.scale===et.minimap.scale&&K.verticalScrollbarWidth===et.verticalScrollbarWidth&&K.isViewportWrapping===et.isViewportWrapping,ct=K.lineHeight,mt=K.typicalHalfwidthCharacterWidth,vt=K.scrollBeyondLastLine,Ct=K.minimap.renderCharacters;let gt=xe>=2?Math.round(K.minimap.scale*2):K.minimap.scale;const bt=K.minimap.maxColumn,pt=K.minimap.size,Nt=K.minimap.side,jt=K.verticalScrollbarWidth,Ft=K.viewLineCount,Ht=K.remainingWidth,kt=K.isViewportWrapping,Wt=Ct?2:3;let Et=Math.floor(xe*qe);const ft=Et/xe;let wt=!1,Tt=!1,Mt=Wt*gt,Vt=gt/xe,Qt=1;if(pt==="fill"||pt==="fit"){const{typicalViewportLineCount:Gt,extraLinesBeforeFirstLine:Yt,extraLinesBeyondLastLine:Xt,desiredRatio:xt,minimapLineCount:Ut}=oe.computeContainedMinimapLineCount({viewLineCount:Ft,scrollBeyondLastLine:vt,paddingTop:K.paddingTop,paddingBottom:K.paddingBottom,height:qe,lineHeight:ct,pixelRatio:xe});if(Ft/Ut>1)wt=!0,Tt=!0,gt=1,Mt=1,Vt=gt/xe;else{let yt=!1,Bt=gt+1;if(pt==="fit"){const qt=Math.ceil((Yt+Ft+Xt)*Mt);kt&&it&&Ht<=$e.stableFitRemainingWidth?(yt=!0,Bt=$e.stableFitMaxMinimapScale):yt=qt>Et}if(pt==="fill"||yt){wt=!0;const qt=gt;Mt=Math.min(ct*xe,Math.max(1,Math.floor(1/xt))),kt&&it&&Ht<=$e.stableFitRemainingWidth&&(Bt=$e.stableFitMaxMinimapScale),gt=Math.min(Bt,Math.max(1,Math.floor(Mt/Wt))),gt>qt&&(Qt=Math.min(2,gt/qt)),Vt=gt/xe/Qt,Et=Math.ceil(Math.max(Gt,Yt+Ft+Xt)*Mt),kt?($e.stableMinimapLayoutInput=K,$e.stableFitRemainingWidth=Ht,$e.stableFitMaxMinimapScale=gt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const Jt=Math.floor(bt*Vt),It=Math.min(Jt,Math.max(0,Math.floor((Ht-jt-2)*Vt/(mt+Vt)))+e.MINIMAP_GUTTER_WIDTH);let Pt=Math.floor(xe*It);const Rt=Pt/xe;Pt=Math.floor(Pt*Qt);const zt=Ct?ye.Text:ye.Blocks,Ot=Nt==="left"?0:Fe-It-jt;return{renderMinimap:zt,minimapLeft:Ot,minimapWidth:It,minimapHeightIsEditorHeight:wt,minimapIsSampling:Tt,minimapScale:gt,minimapLineHeight:Mt,minimapCanvasInnerWidth:Pt,minimapCanvasInnerHeight:Et,minimapCanvasOuterWidth:Rt,minimapCanvasOuterHeight:ft}}static computeLayout(K,$e){const Fe=$e.outerWidth|0,qe=$e.outerHeight|0,xe=$e.lineHeight|0,et=$e.lineNumbersDigitCount|0,it=$e.typicalHalfwidthCharacterWidth,ct=$e.maxDigitWidth,mt=$e.pixelRatio,vt=$e.viewLineCount,Ct=K.get(fe.wordWrapOverride2),gt=Ct==="inherit"?K.get(fe.wordWrapOverride1):Ct,bt=gt==="inherit"?K.get(fe.wordWrap):gt,pt=K.get(fe.wordWrapColumn),Nt=$e.isDominatedByLongLines,jt=K.get(fe.glyphMargin),Ft=K.get(fe.lineNumbers).renderType!==Be.Off,Ht=K.get(fe.lineNumbersMinChars),kt=K.get(fe.scrollBeyondLastLine),Wt=K.get(fe.padding),Et=K.get(fe.minimap),ft=K.get(fe.scrollbar),wt=ft.verticalScrollbarSize,Tt=ft.verticalHasArrows,Mt=ft.arrowSize,Vt=ft.horizontalScrollbarSize,Qt=K.get(fe.folding),Jt=K.get(fe.showFoldingControls)!=="never";let It=K.get(fe.lineDecorationsWidth);Qt&&Jt&&(It+=16);let Pt=0;if(Ft){const ln=Math.max(et,Ht);Pt=Math.round(ln*ct)}let Rt=0;jt&&(Rt=xe*$e.glyphMarginDecorationLaneCount);let zt=0,Ot=zt+Rt,Gt=Ot+Pt,Yt=Gt+It;const Xt=Fe-Rt-Pt-It;let xt=!1,Ut=!1,Kt=-1;gt==="inherit"&&Nt?(xt=!0,Ut=!0):bt==="on"||bt==="bounded"?Ut=!0:bt==="wordWrapColumn"&&(Kt=pt);const yt=oe.c({outerWidth:Fe,outerHeight:qe,lineHeight:xe,typicalHalfwidthCharacterWidth:it,pixelRatio:mt,scrollBeyondLastLine:kt,paddingTop:Wt.top,paddingBottom:Wt.bottom,minimap:Et,verticalScrollbarWidth:wt,viewLineCount:vt,remainingWidth:Xt,isViewportWrapping:Ut},$e.memory||new $);yt.renderMinimap!==ye.None&&yt.minimapLeft===0&&(zt+=yt.minimapWidth,Ot+=yt.minimapWidth,Gt+=yt.minimapWidth,Yt+=yt.minimapWidth);const Bt=Xt-yt.minimapWidth,qt=Math.max(1,Math.floor((Bt-wt-2)/it)),an=Tt?Mt:0;return Ut&&(Kt=Math.max(1,qt),bt==="bounded"&&(Kt=Math.min(Kt,pt))),{width:Fe,height:qe,glyphMarginLeft:zt,glyphMarginWidth:Rt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Ot,lineNumbersWidth:Pt,decorationsLeft:Gt,decorationsWidth:It,contentLeft:Yt,contentWidth:Bt,minimap:yt,viewportColumn:qt,isWordWrapMinified:xt,isViewportWrapping:Ut,wrappingColumn:Kt,verticalScrollbarWidth:wt,horizontalScrollbarHeight:Vt,overviewRuler:{top:an,width:wt,height:qe-2*an,right:0}}}}e.EditorLayoutInfoComputer=oe;class _ extends a{constructor(){super(fe.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(349,null),s.localize(350,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(351,null)}})}validate(K){return f(K,"simple",["simple","advanced"])}compute(K,$e,Fe){return $e.get(fe.accessibilitySupport)===S.AccessibilitySupport.Enabled?"advanced":Fe}}var X;(function(W){W.Off="off",W.OnCode="onCode",W.On="on"})(X||(e.ShowLightbulbIconMode=X={}));class M extends a{constructor(){const K={enabled:X.OnCode};super(fe.lightbulb,"lightbulb",K,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[X.Off,X.OnCode,X.On],default:K.enabled,enumDescriptions:[s.localize(352,null),s.localize(353,null),s.localize(354,null)],description:s.localize(355,null)}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{enabled:f(K.enabled,this.defaultValue.enabled,[X.Off,X.OnCode,X.On])}}}class A extends a{constructor(){const K={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(fe.stickyScroll,"stickyScroll",K,{"editor.stickyScroll.enabled":{type:"boolean",default:K.enabled,description:s.localize(356,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:K.maxLineCount,minimum:1,maximum:20,description:s.localize(357,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:K.defaultModel,description:s.localize(358,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:K.scrollWithEditor,description:s.localize(359,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{enabled:d($e.enabled,this.defaultValue.enabled),maxLineCount:l.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:d($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Y extends a{constructor(){const K={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(fe.inlayHints,"inlayHints",K,{"editor.inlayHints.enabled":{type:"string",default:K.enabled,description:s.localize(360,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(361,null),s.localize(362,null,E.$m?"Ctrl+Option":"Ctrl+Alt"),s.localize(363,null,E.$m?"Ctrl+Option":"Ctrl+Alt"),s.localize(364,null)]},"editor.inlayHints.fontSize":{type:"number",default:K.fontSize,markdownDescription:s.localize(365,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:K.fontFamily,markdownDescription:s.localize(366,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:K.padding,description:s.localize(367,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:f($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:l.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string($e.fontFamily,this.defaultValue.fontFamily),padding:d($e.padding,this.defaultValue.padding)}}}class pe extends a{constructor(){super(fe.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(K){return typeof K=="string"&&/^\d+(\.\d+)?ch$/.test(K)?-parseFloat(K.substring(0,K.length-2)):l.clampedInt(K,this.defaultValue,0,1e3)}compute(K,$e,Fe){return Fe<0?l.clampedInt(-Fe*K.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Fe}}class ne extends u{constructor(){super(fe.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,K=>u.clamp(K,0,150),{markdownDescription:s.localize(368,null)})}compute(K,$e,Fe){return K.fontInfo.lineHeight}}class ie extends a{constructor(){const K={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(fe.minimap,"minimap",K,{"editor.minimap.enabled":{type:"boolean",default:K.enabled,description:s.localize(369,null)},"editor.minimap.autohide":{type:"boolean",default:K.autohide,description:s.localize(370,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(371,null),s.localize(372,null),s.localize(373,null)],default:K.size,description:s.localize(374,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:K.side,description:s.localize(375,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:K.showSlider,description:s.localize(376,null)},"editor.minimap.scale":{type:"number",default:K.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(377,null)},"editor.minimap.renderCharacters":{type:"boolean",default:K.renderCharacters,description:s.localize(378,null)},"editor.minimap.maxColumn":{type:"number",default:K.maxColumn,description:s.localize(379,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:K.showRegionSectionHeaders,description:s.localize(380,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:K.showMarkSectionHeaders,description:s.localize(381,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:K.sectionHeaderFontSize,description:s.localize(382,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:K.sectionHeaderLetterSpacing,description:s.localize(383,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{enabled:d($e.enabled,this.defaultValue.enabled),autohide:d($e.autohide,this.defaultValue.autohide),size:f($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:f($e.side,this.defaultValue.side,["right","left"]),showSlider:f($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d($e.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt($e.scale,1,1,3),maxColumn:l.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:d($e.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:d($e.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:u.clamp($e.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:u.clamp($e.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function G(W){return W==="ctrlCmd"?E.$m?"metaKey":"ctrlKey":"altKey"}class Z extends a{constructor(){super(fe.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(384,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(385,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{top:l.clampedInt($e.top,0,0,1e3),bottom:l.clampedInt($e.bottom,0,0,1e3)}}}class ce extends a{constructor(){const K={enabled:!0,cycle:!0};super(fe.parameterHints,"parameterHints",K,{"editor.parameterHints.enabled":{type:"boolean",default:K.enabled,description:s.localize(386,null)},"editor.parameterHints.cycle":{type:"boolean",default:K.cycle,description:s.localize(387,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{enabled:d($e.enabled,this.defaultValue.enabled),cycle:d($e.cycle,this.defaultValue.cycle)}}}class we extends b{constructor(){super(fe.pixelRatio)}compute(K,$e,Fe){return K.pixelRatio}}class Ie extends a{constructor(){super(fe.placeholder,"placeholder",void 0)}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K:this.defaultValue}}class Me extends a{constructor(){const K={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(388,null),s.localize(389,null),s.localize(390,null)]}];super(fe.quickSuggestions,"quickSuggestions",K,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:K.strings,description:s.localize(391,null)},comments:{anyOf:$e,default:K.comments,description:s.localize(392,null)},other:{anyOf:$e,default:K.other,description:s.localize(393,null)}},default:K,markdownDescription:s.localize(394,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=K}validate(K){if(typeof K=="boolean"){const mt=K?"on":"off";return{comments:mt,strings:mt,other:mt}}if(!K||typeof K!="object")return this.defaultValue;const{other:$e,comments:Fe,strings:qe}=K,xe=["on","inline","off"];let et,it,ct;return typeof $e=="boolean"?et=$e?"on":"off":et=f($e,this.defaultValue.other,xe),typeof Fe=="boolean"?it=Fe?"on":"off":it=f(Fe,this.defaultValue.comments,xe),typeof qe=="boolean"?ct=qe?"on":"off":ct=f(qe,this.defaultValue.strings,xe),{other:et,comments:it,strings:ct}}}var Be;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative",W[W.Interval=3]="Interval",W[W.Custom=4]="Custom"})(Be||(e.RenderLineNumbersType=Be={}));class De extends a{constructor(){super(fe.lineNumbers,"lineNumbers",{renderType:Be.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(395,null),s.localize(396,null),s.localize(397,null),s.localize(398,null)],default:"on",description:s.localize(399,null)})}validate(K){let $e=this.defaultValue.renderType,Fe=this.defaultValue.renderFn;return typeof K<"u"&&(typeof K=="function"?($e=Be.Custom,Fe=K):K==="interval"?$e=Be.Interval:K==="relative"?$e=Be.Relative:K==="on"?$e=Be.On:$e=Be.Off),{renderType:$e,renderFn:Fe}}}function Ne(W){const K=W.get(fe.renderValidationDecorations);return K==="editable"?W.get(fe.readOnly):K!=="on"}class Te extends a{constructor(){const K=[],$e={type:"number",description:s.localize(400,null)};super(fe.rulers,"rulers",K,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:s.localize(401,null),format:"color-hex"}}}]},default:K,description:s.localize(402,null)})}validate(K){if(Array.isArray(K)){const $e=[];for(const Fe of K)if(typeof Fe=="number")$e.push({column:l.clampedInt(Fe,0,0,1e4),color:null});else if(Fe&&typeof Fe=="object"){const qe=Fe;$e.push({column:l.clampedInt(qe.column,0,0,1e4),color:qe.color})}return $e.sort((Fe,qe)=>Fe.column-qe.column),$e}return this.defaultValue}}class Ce extends a{constructor(){super(fe.readOnlyMessage,"readOnlyMessage",void 0)}validate(K){return!K||typeof K!="object"?this.defaultValue:K}}function de(W,K){if(typeof W!="string")return K;switch(W){case"hidden":return I.ScrollbarVisibility.Hidden;case"visible":return I.ScrollbarVisibility.Visible;default:return I.ScrollbarVisibility.Auto}}class Se extends a{constructor(){const K={vertical:I.ScrollbarVisibility.Auto,horizontal:I.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(fe.scrollbar,"scrollbar",K,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(403,null),s.localize(404,null),s.localize(405,null)],default:"auto",description:s.localize(406,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(407,null),s.localize(408,null),s.localize(409,null)],default:"auto",description:s.localize(410,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:K.verticalScrollbarSize,description:s.localize(411,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:K.horizontalScrollbarSize,description:s.localize(412,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:K.scrollByPage,description:s.localize(413,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:K.ignoreHorizontalScrollbarInContentHeight,description:s.localize(414,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K,Fe=l.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=l.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:de($e.vertical,this.defaultValue.vertical),horizontal:de($e.horizontal,this.defaultValue.horizontal),useShadows:d($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:d($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Fe,horizontalSliderSize:l.clampedInt($e.horizontalSliderSize,Fe,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:l.clampedInt($e.verticalSliderSize,qe,0,1e3),scrollByPage:d($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:d($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Re extends a{constructor(){const K={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(fe.unicodeHighlighting,"unicodeHighlight",K,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.nonBasicASCII,description:s.localize(415,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:K.invisibleCharacters,description:s.localize(416,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:K.ambiguousCharacters,description:s.localize(417,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeComments,description:s.localize(418,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeStrings,description:s.localize(419,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:K.allowedCharacters,description:s.localize(420,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:K.allowedLocales,description:s.localize(421,null)}})}applyUpdate(K,$e){let Fe=!1;$e.allowedCharacters&&K&&(i.$qo(K.allowedCharacters,$e.allowedCharacters)||(K={...K,allowedCharacters:$e.allowedCharacters},Fe=!0)),$e.allowedLocales&&K&&(i.$qo(K.allowedLocales,$e.allowedLocales)||(K={...K,allowedLocales:$e.allowedLocales},Fe=!0));const qe=super.applyUpdate(K,$e);return Fe?new c(qe.newValue,!0):qe}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{nonBasicASCII:Xe($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Xe($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Xe($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(K.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(K.allowedLocales,this.defaultValue.allowedLocales)}}c(K,$e){if(typeof K!="object"||!K)return $e;const Fe={};for(const[qe,xe]of Object.entries(K))xe===!0&&(Fe[qe]=!0);return Fe}}class Ue extends a{constructor(){const K={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(fe.inlineSuggest,"inlineSuggest",K,{"editor.inlineSuggest.enabled":{type:"boolean",default:K.enabled,description:s.localize(422,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:K.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(423,null),s.localize(424,null),s.localize(425,null)],description:s.localize(426,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:K.suppressSuggestions,description:s.localize(427,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:K.fontFamily,description:s.localize(428,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{enabled:d($e.enabled,this.defaultValue.enabled),mode:f($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:d($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:d($e.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:r.string($e.fontFamily,this.defaultValue.fontFamily)}}}class Ge extends a{constructor(){const K={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(fe.inlineEdit,"experimentalInlineEdit",K,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:K.enabled,description:s.localize(429,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:K.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(430,null),s.localize(431,null),s.localize(432,null)],description:s.localize(433,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:K.fontFamily,description:s.localize(434,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{enabled:d($e.enabled,this.defaultValue.enabled),showToolbar:f($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:r.string($e.fontFamily,this.defaultValue.fontFamily),keepOnBlur:d($e.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Qe extends a{constructor(){const K={enabled:T.$vt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$vt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(fe.bracketPairColorization,"bracketPairColorization",K,{"editor.bracketPairColorization.enabled":{type:"boolean",default:K.enabled,markdownDescription:s.localize(435,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:K.independentColorPoolPerBracketType,description:s.localize(436,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{enabled:d($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Je extends a{constructor(){const K={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(fe.guides,"guides",K,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(437,null),s.localize(438,null),s.localize(439,null)],default:K.bracketPairs,description:s.localize(440,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(441,null),s.localize(442,null),s.localize(443,null)],default:K.bracketPairsHorizontal,description:s.localize(444,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:K.highlightActiveBracketPair,description:s.localize(445,null)},"editor.guides.indentation":{type:"boolean",default:K.indentation,description:s.localize(446,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(447,null),s.localize(448,null),s.localize(449,null)],default:K.highlightActiveIndentation,description:s.localize(450,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{bracketPairs:Xe($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Xe($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:Xe($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Xe(W,K,$e){const Fe=$e.indexOf(W);return Fe===-1?K:$e[Fe]}class tt extends a{constructor(){const K={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(fe.suggest,"suggest",K,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(451,null),s.localize(452,null)],default:K.insertMode,description:s.localize(453,null)},"editor.suggest.filterGraceful":{type:"boolean",default:K.filterGraceful,description:s.localize(454,null)},"editor.suggest.localityBonus":{type:"boolean",default:K.localityBonus,description:s.localize(455,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:K.shareSuggestSelections,markdownDescription:s.localize(456,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(457,null),s.localize(458,null),s.localize(459,null),s.localize(460,null)],default:K.selectionMode,markdownDescription:s.localize(461,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:K.snippetsPreventQuickSuggestions,description:s.localize(462,null)},"editor.suggest.showIcons":{type:"boolean",default:K.showIcons,description:s.localize(463,null)},"editor.suggest.showStatusBar":{type:"boolean",default:K.showStatusBar,description:s.localize(464,null)},"editor.suggest.preview":{type:"boolean",default:K.preview,description:s.localize(465,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:K.showInlineDetails,description:s.localize(466,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(467,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(468,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(469,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(470,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(471,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(472,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(473,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(474,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(475,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(476,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(477,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(478,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(479,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(480,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(481,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(482,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(483,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(484,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(485,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(486,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(487,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(488,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(489,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(490,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(491,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(492,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(493,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(494,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(495,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(496,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(497,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(498,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{insertMode:f($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d($e.showIcons,this.defaultValue.showIcons),showStatusBar:d($e.showStatusBar,this.defaultValue.showStatusBar),preview:d($e.preview,this.defaultValue.preview),previewMode:f($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d($e.showMethods,this.defaultValue.showMethods),showFunctions:d($e.showFunctions,this.defaultValue.showFunctions),showConstructors:d($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:d($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d($e.showFields,this.defaultValue.showFields),showVariables:d($e.showVariables,this.defaultValue.showVariables),showClasses:d($e.showClasses,this.defaultValue.showClasses),showStructs:d($e.showStructs,this.defaultValue.showStructs),showInterfaces:d($e.showInterfaces,this.defaultValue.showInterfaces),showModules:d($e.showModules,this.defaultValue.showModules),showProperties:d($e.showProperties,this.defaultValue.showProperties),showEvents:d($e.showEvents,this.defaultValue.showEvents),showOperators:d($e.showOperators,this.defaultValue.showOperators),showUnits:d($e.showUnits,this.defaultValue.showUnits),showValues:d($e.showValues,this.defaultValue.showValues),showConstants:d($e.showConstants,this.defaultValue.showConstants),showEnums:d($e.showEnums,this.defaultValue.showEnums),showEnumMembers:d($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d($e.showKeywords,this.defaultValue.showKeywords),showWords:d($e.showWords,this.defaultValue.showWords),showColors:d($e.showColors,this.defaultValue.showColors),showFiles:d($e.showFiles,this.defaultValue.showFiles),showReferences:d($e.showReferences,this.defaultValue.showReferences),showFolders:d($e.showFolders,this.defaultValue.showFolders),showTypeParameters:d($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d($e.showSnippets,this.defaultValue.showSnippets),showUsers:d($e.showUsers,this.defaultValue.showUsers),showIssues:d($e.showIssues,this.defaultValue.showIssues)}}}class st extends a{constructor(){super(fe.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(499,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(500,null),default:!0,type:"boolean"}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(K.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:d(K.selectSubwords,this.defaultValue.selectSubwords)}}}class dt extends a{constructor(){const K=[];super(fe.wordSegmenterLocales,"wordSegmenterLocales",K,{anyOf:[{description:s.localize(501,null),type:"string"},{description:s.localize(502,null),type:"array",items:{type:"string"}}]})}validate(K){if(typeof K=="string"&&(K=[K]),Array.isArray(K)){const $e=[];for(const Fe of K)if(typeof Fe=="string")try{Intl.Segmenter.supportedLocalesOf(Fe).length>0&&$e.push(Fe)}catch{}return $e}return this.defaultValue}}var rt;(function(W){W[W.None=0]="None",W[W.Same=1]="Same",W[W.Indent=2]="Indent",W[W.DeepIndent=3]="DeepIndent"})(rt||(e.WrappingIndent=rt={}));class ot extends a{constructor(){super(fe.wrappingIndent,"wrappingIndent",rt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(503,null),s.localize(504,null),s.localize(505,null),s.localize(506,null)],description:s.localize(507,null),default:"same"}})}validate(K){switch(K){case"none":return rt.None;case"same":return rt.Same;case"indent":return rt.Indent;case"deepIndent":return rt.DeepIndent}return rt.Same}compute(K,$e,Fe){return $e.get(fe.accessibilitySupport)===S.AccessibilitySupport.Enabled?rt.None:Fe}}class ut extends b{constructor(){super(fe.wrappingInfo)}compute(K,$e,Fe){const qe=$e.get(fe.layoutInfo);return{isDominatedByLongLines:K.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}class Ye extends a{constructor(){const K={enabled:!0,showDropSelector:"afterDrop"};super(fe.dropIntoEditor,"dropIntoEditor",K,{"editor.dropIntoEditor.enabled":{type:"boolean",default:K.enabled,markdownDescription:s.localize(508,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(509,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(510,null),s.localize(511,null)],default:"afterDrop"}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{enabled:d($e.enabled,this.defaultValue.enabled),showDropSelector:f($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class me extends a{constructor(){const K={enabled:!0,showPasteSelector:"afterPaste"};super(fe.pasteAs,"pasteAs",K,{"editor.pasteAs.enabled":{type:"boolean",default:K.enabled,markdownDescription:s.localize(512,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(513,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(514,null),s.localize(515,null)],default:"afterPaste"}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const $e=K;return{enabled:d($e.enabled,this.defaultValue.enabled),showPasteSelector:f($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const H="Consolas, 'Courier New', monospace",ee="Menlo, Monaco, 'Courier New', monospace",ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:E.$m?ee:E.$n?ge:H,fontWeight:"normal",fontSize:E.$m?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function re(W){return e.editorOptionsRegistry[W.id]=W,W}var fe;(function(W){W[W.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",W[W.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",W[W.accessibilitySupport=2]="accessibilitySupport",W[W.accessibilityPageSize=3]="accessibilityPageSize",W[W.ariaLabel=4]="ariaLabel",W[W.ariaRequired=5]="ariaRequired",W[W.autoClosingBrackets=6]="autoClosingBrackets",W[W.autoClosingComments=7]="autoClosingComments",W[W.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",W[W.autoClosingDelete=9]="autoClosingDelete",W[W.autoClosingOvertype=10]="autoClosingOvertype",W[W.autoClosingQuotes=11]="autoClosingQuotes",W[W.autoIndent=12]="autoIndent",W[W.automaticLayout=13]="automaticLayout",W[W.autoSurround=14]="autoSurround",W[W.bracketPairColorization=15]="bracketPairColorization",W[W.guides=16]="guides",W[W.codeLens=17]="codeLens",W[W.codeLensFontFamily=18]="codeLensFontFamily",W[W.codeLensFontSize=19]="codeLensFontSize",W[W.colorDecorators=20]="colorDecorators",W[W.colorDecoratorsLimit=21]="colorDecoratorsLimit",W[W.columnSelection=22]="columnSelection",W[W.comments=23]="comments",W[W.contextmenu=24]="contextmenu",W[W.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",W[W.cursorBlinking=26]="cursorBlinking",W[W.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",W[W.cursorStyle=28]="cursorStyle",W[W.cursorSurroundingLines=29]="cursorSurroundingLines",W[W.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",W[W.cursorWidth=31]="cursorWidth",W[W.disableLayerHinting=32]="disableLayerHinting",W[W.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",W[W.domReadOnly=34]="domReadOnly",W[W.dragAndDrop=35]="dragAndDrop",W[W.dropIntoEditor=36]="dropIntoEditor",W[W.emptySelectionClipboard=37]="emptySelectionClipboard",W[W.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",W[W.extraEditorClassName=39]="extraEditorClassName",W[W.fastScrollSensitivity=40]="fastScrollSensitivity",W[W.find=41]="find",W[W.fixedOverflowWidgets=42]="fixedOverflowWidgets",W[W.folding=43]="folding",W[W.foldingStrategy=44]="foldingStrategy",W[W.foldingHighlight=45]="foldingHighlight",W[W.foldingImportsByDefault=46]="foldingImportsByDefault",W[W.foldingMaximumRegions=47]="foldingMaximumRegions",W[W.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",W[W.fontFamily=49]="fontFamily",W[W.fontInfo=50]="fontInfo",W[W.fontLigatures=51]="fontLigatures",W[W.fontSize=52]="fontSize",W[W.fontWeight=53]="fontWeight",W[W.fontVariations=54]="fontVariations",W[W.formatOnPaste=55]="formatOnPaste",W[W.formatOnType=56]="formatOnType",W[W.glyphMargin=57]="glyphMargin",W[W.gotoLocation=58]="gotoLocation",W[W.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",W[W.hover=60]="hover",W[W.inDiffEditor=61]="inDiffEditor",W[W.inlineSuggest=62]="inlineSuggest",W[W.inlineEdit=63]="inlineEdit",W[W.letterSpacing=64]="letterSpacing",W[W.lightbulb=65]="lightbulb",W[W.lineDecorationsWidth=66]="lineDecorationsWidth",W[W.lineHeight=67]="lineHeight",W[W.lineNumbers=68]="lineNumbers",W[W.lineNumbersMinChars=69]="lineNumbersMinChars",W[W.linkedEditing=70]="linkedEditing",W[W.links=71]="links",W[W.matchBrackets=72]="matchBrackets",W[W.minimap=73]="minimap",W[W.mouseStyle=74]="mouseStyle",W[W.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",W[W.mouseWheelZoom=76]="mouseWheelZoom",W[W.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",W[W.multiCursorModifier=78]="multiCursorModifier",W[W.multiCursorPaste=79]="multiCursorPaste",W[W.multiCursorLimit=80]="multiCursorLimit",W[W.occurrencesHighlight=81]="occurrencesHighlight",W[W.overviewRulerBorder=82]="overviewRulerBorder",W[W.overviewRulerLanes=83]="overviewRulerLanes",W[W.padding=84]="padding",W[W.pasteAs=85]="pasteAs",W[W.parameterHints=86]="parameterHints",W[W.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",W[W.placeholder=88]="placeholder",W[W.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",W[W.quickSuggestions=90]="quickSuggestions",W[W.quickSuggestionsDelay=91]="quickSuggestionsDelay",W[W.readOnly=92]="readOnly",W[W.readOnlyMessage=93]="readOnlyMessage",W[W.renameOnType=94]="renameOnType",W[W.renderControlCharacters=95]="renderControlCharacters",W[W.renderFinalNewline=96]="renderFinalNewline",W[W.renderLineHighlight=97]="renderLineHighlight",W[W.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",W[W.renderValidationDecorations=99]="renderValidationDecorations",W[W.renderWhitespace=100]="renderWhitespace",W[W.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",W[W.roundedSelection=102]="roundedSelection",W[W.rulers=103]="rulers",W[W.scrollbar=104]="scrollbar",W[W.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",W[W.scrollBeyondLastLine=106]="scrollBeyondLastLine",W[W.scrollPredominantAxis=107]="scrollPredominantAxis",W[W.selectionClipboard=108]="selectionClipboard",W[W.selectionHighlight=109]="selectionHighlight",W[W.selectOnLineNumbers=110]="selectOnLineNumbers",W[W.showFoldingControls=111]="showFoldingControls",W[W.showUnused=112]="showUnused",W[W.snippetSuggestions=113]="snippetSuggestions",W[W.smartSelect=114]="smartSelect",W[W.smoothScrolling=115]="smoothScrolling",W[W.stickyScroll=116]="stickyScroll",W[W.stickyTabStops=117]="stickyTabStops",W[W.stopRenderingLineAfter=118]="stopRenderingLineAfter",W[W.suggest=119]="suggest",W[W.suggestFontSize=120]="suggestFontSize",W[W.suggestLineHeight=121]="suggestLineHeight",W[W.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",W[W.suggestSelection=123]="suggestSelection",W[W.tabCompletion=124]="tabCompletion",W[W.tabIndex=125]="tabIndex",W[W.unicodeHighlighting=126]="unicodeHighlighting",W[W.unusualLineTerminators=127]="unusualLineTerminators",W[W.useShadowDOM=128]="useShadowDOM",W[W.useTabStops=129]="useTabStops",W[W.wordBreak=130]="wordBreak",W[W.wordSegmenterLocales=131]="wordSegmenterLocales",W[W.wordSeparators=132]="wordSeparators",W[W.wordWrap=133]="wordWrap",W[W.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",W[W.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",W[W.wordWrapColumn=136]="wordWrapColumn",W[W.wordWrapOverride1=137]="wordWrapOverride1",W[W.wordWrapOverride2=138]="wordWrapOverride2",W[W.wrappingIndent=139]="wrappingIndent",W[W.wrappingStrategy=140]="wrappingStrategy",W[W.showDeprecated=141]="showDeprecated",W[W.inlayHints=142]="inlayHints",W[W.editorClassName=143]="editorClassName",W[W.pixelRatio=144]="pixelRatio",W[W.tabFocusMode=145]="tabFocusMode",W[W.layoutInfo=146]="layoutInfo",W[W.wrappingInfo=147]="wrappingInfo",W[W.defaultColorDecorators=148]="defaultColorDecorators",W[W.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",W[W.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(fe||(e.EditorOption=fe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:re(new w(fe.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(516,null)})),acceptSuggestionOnEnter:re(new h(fe.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(517,null),""],markdownDescription:s.localize(518,null)})),accessibilitySupport:re(new O),accessibilityPageSize:re(new l(fe.accessibilityPageSize,"accessibilityPageSize",10,1,D.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(519,null),tags:["accessibility"]})),ariaLabel:re(new r(fe.ariaLabel,"ariaLabel",s.localize(520,null))),ariaRequired:re(new w(fe.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:re(new w(fe.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(521,null),tags:["accessibility"]})),autoClosingBrackets:re(new h(fe.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(522,null),s.localize(523,null),""],description:s.localize(524,null)})),autoClosingComments:re(new h(fe.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(525,null),s.localize(526,null),""],description:s.localize(527,null)})),autoClosingDelete:re(new h(fe.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(528,null),""],description:s.localize(529,null)})),autoClosingOvertype:re(new h(fe.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(530,null),""],description:s.localize(531,null)})),autoClosingQuotes:re(new h(fe.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(532,null),s.localize(533,null),""],description:s.localize(534,null)})),autoIndent:re(new k(fe.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],P,{enumDescriptions:[s.localize(535,null),s.localize(536,null),s.localize(537,null),s.localize(538,null),s.localize(539,null)],description:s.localize(540,null)})),automaticLayout:re(new w(fe.automaticLayout,"automaticLayout",!1)),autoSurround:re(new h(fe.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(541,null),s.localize(542,null),s.localize(543,null),""],description:s.localize(544,null)})),bracketPairColorization:re(new Qe),bracketPairGuides:re(new Je),stickyTabStops:re(new w(fe.stickyTabStops,"stickyTabStops",!1,{description:s.localize(545,null)})),codeLens:re(new w(fe.codeLens,"codeLens",!0,{description:s.localize(546,null)})),codeLensFontFamily:re(new r(fe.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(547,null)})),codeLensFontSize:re(new l(fe.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(548,null)})),colorDecorators:re(new w(fe.colorDecorators,"colorDecorators",!0,{description:s.localize(549,null)})),colorDecoratorActivatedOn:re(new h(fe.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(550,null),s.localize(551,null),s.localize(552,null)],description:s.localize(553,null)})),colorDecoratorsLimit:re(new l(fe.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(554,null)})),columnSelection:re(new w(fe.columnSelection,"columnSelection",!1,{description:s.localize(555,null)})),comments:re(new C),contextmenu:re(new w(fe.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:re(new w(fe.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(556,null)})),cursorBlinking:re(new k(fe.cursorBlinking,"cursorBlinking",L.Blink,"blink",["blink","smooth","phase","expand","solid"],R,{description:s.localize(557,null)})),cursorSmoothCaretAnimation:re(new h(fe.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(558,null),s.localize(559,null),s.localize(560,null)],description:s.localize(561,null)})),cursorStyle:re(new k(fe.cursorStyle,"cursorStyle",z.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],J,{description:s.localize(562,null)})),cursorSurroundingLines:re(new l(fe.cursorSurroundingLines,"cursorSurroundingLines",0,0,D.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(563,null)})),cursorSurroundingLinesStyle:re(new h(fe.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(564,null),s.localize(565,null)],markdownDescription:s.localize(566,null)})),cursorWidth:re(new l(fe.cursorWidth,"cursorWidth",0,0,D.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(567,null)})),disableLayerHinting:re(new w(fe.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:re(new w(fe.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:re(new w(fe.domReadOnly,"domReadOnly",!1)),dragAndDrop:re(new w(fe.dragAndDrop,"dragAndDrop",!0,{description:s.localize(568,null)})),emptySelectionClipboard:re(new ve),dropIntoEditor:re(new Ye),stickyScroll:re(new A),experimentalWhitespaceRendering:re(new h(fe.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(569,null),s.localize(570,null),s.localize(571,null)],description:s.localize(572,null)})),extraEditorClassName:re(new r(fe.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:re(new u(fe.fastScrollSensitivity,"fastScrollSensitivity",5,W=>W<=0?5:W,{markdownDescription:s.localize(573,null)})),find:re(new be),fixedOverflowWidgets:re(new w(fe.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:re(new w(fe.folding,"folding",!0,{description:s.localize(574,null)})),foldingStrategy:re(new h(fe.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(575,null),s.localize(576,null)],description:s.localize(577,null)})),foldingHighlight:re(new w(fe.foldingHighlight,"foldingHighlight",!0,{description:s.localize(578,null)})),foldingImportsByDefault:re(new w(fe.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(579,null)})),foldingMaximumRegions:re(new l(fe.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(580,null)})),unfoldOnClickAfterEndOfLine:re(new w(fe.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(581,null)})),fontFamily:re(new r(fe.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(582,null)})),fontInfo:re(new B),fontLigatures2:re(new se),fontSize:re(new j),fontWeight:re(new U),fontVariations:re(new V),formatOnPaste:re(new w(fe.formatOnPaste,"formatOnPaste",!1,{description:s.localize(583,null)})),formatOnType:re(new w(fe.formatOnType,"formatOnType",!1,{description:s.localize(584,null)})),glyphMargin:re(new w(fe.glyphMargin,"glyphMargin",!0,{description:s.localize(585,null)})),gotoLocation:re(new te),hideCursorInOverviewRuler:re(new w(fe.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(586,null)})),hover:re(new le),inDiffEditor:re(new w(fe.inDiffEditor,"inDiffEditor",!1)),letterSpacing:re(new u(fe.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,W=>u.clamp(W,-5,20),{description:s.localize(587,null)})),lightbulb:re(new M),lineDecorationsWidth:re(new pe),lineHeight:re(new ne),lineNumbers:re(new De),lineNumbersMinChars:re(new l(fe.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:re(new w(fe.linkedEditing,"linkedEditing",!1,{description:s.localize(588,null)})),links:re(new w(fe.links,"links",!0,{description:s.localize(589,null)})),matchBrackets:re(new h(fe.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(590,null)})),minimap:re(new ie),mouseStyle:re(new h(fe.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:re(new u(fe.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,W=>W===0?1:W,{markdownDescription:s.localize(591,null)})),mouseWheelZoom:re(new w(fe.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:E.$m?s.localize(592,null):s.localize(593,null)})),multiCursorMergeOverlapping:re(new w(fe.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(594,null)})),multiCursorModifier:re(new k(fe.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],G,{markdownEnumDescriptions:[s.localize(595,null),s.localize(596,null)],markdownDescription:s.localize(597,null)})),multiCursorPaste:re(new h(fe.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(598,null),s.localize(599,null)],markdownDescription:s.localize(600,null)})),multiCursorLimit:re(new l(fe.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(601,null)})),occurrencesHighlight:re(new h(fe.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(602,null),s.localize(603,null),s.localize(604,null)],markdownDescription:s.localize(605,null)})),overviewRulerBorder:re(new w(fe.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(606,null)})),overviewRulerLanes:re(new l(fe.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:re(new Z),pasteAs:re(new me),parameterHints:re(new ce),peekWidgetDefaultFocus:re(new h(fe.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(607,null),s.localize(608,null)],description:s.localize(609,null)})),placeholder:re(new Ie),definitionLinkOpensInPeek:re(new w(fe.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(610,null)})),quickSuggestions:re(new Me),quickSuggestionsDelay:re(new l(fe.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,D.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(611,null)})),readOnly:re(new w(fe.readOnly,"readOnly",!1)),readOnlyMessage:re(new Ce),renameOnType:re(new w(fe.renameOnType,"renameOnType",!1,{description:s.localize(612,null),markdownDeprecationMessage:s.localize(613,null)})),renderControlCharacters:re(new w(fe.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(614,null),restricted:!0})),renderFinalNewline:re(new h(fe.renderFinalNewline,"renderFinalNewline",E.$n?"dimmed":"on",["off","on","dimmed"],{description:s.localize(615,null)})),renderLineHighlight:re(new h(fe.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(616,null)],description:s.localize(617,null)})),renderLineHighlightOnlyWhenFocus:re(new w(fe.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(618,null)})),renderValidationDecorations:re(new h(fe.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:re(new h(fe.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(619,null),s.localize(620,null),s.localize(621,null),""],description:s.localize(622,null)})),revealHorizontalRightPadding:re(new l(fe.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:re(new w(fe.roundedSelection,"roundedSelection",!0,{description:s.localize(623,null)})),rulers:re(new Te),scrollbar:re(new Se),scrollBeyondLastColumn:re(new l(fe.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,D.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(624,null)})),scrollBeyondLastLine:re(new w(fe.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(625,null)})),scrollPredominantAxis:re(new w(fe.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(626,null)})),selectionClipboard:re(new w(fe.selectionClipboard,"selectionClipboard",!0,{description:s.localize(627,null),included:E.$n})),selectionHighlight:re(new w(fe.selectionHighlight,"selectionHighlight",!0,{description:s.localize(628,null)})),selectOnLineNumbers:re(new w(fe.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:re(new h(fe.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(629,null),s.localize(630,null),s.localize(631,null)],description:s.localize(632,null)})),showUnused:re(new w(fe.showUnused,"showUnused",!0,{description:s.localize(633,null)})),showDeprecated:re(new w(fe.showDeprecated,"showDeprecated",!0,{description:s.localize(634,null)})),inlayHints:re(new Y),snippetSuggestions:re(new h(fe.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(635,null),s.localize(636,null),s.localize(637,null),s.localize(638,null)],description:s.localize(639,null)})),smartSelect:re(new st),smoothScrolling:re(new w(fe.smoothScrolling,"smoothScrolling",!1,{description:s.localize(640,null)})),stopRenderingLineAfter:re(new l(fe.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,D.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:re(new tt),inlineSuggest:re(new Ue),inlineEdit:re(new Ge),inlineCompletionsAccessibilityVerbose:re(new w(fe.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(641,null)})),suggestFontSize:re(new l(fe.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(642,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:re(new l(fe.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(643,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:re(new w(fe.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(644,null)})),suggestSelection:re(new h(fe.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(645,null),s.localize(646,null),s.localize(647,null)],description:s.localize(648,null)})),tabCompletion:re(new h(fe.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(649,null),s.localize(650,null),s.localize(651,null)],description:s.localize(652,null)})),tabIndex:re(new l(fe.tabIndex,"tabIndex",0,-1,D.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:re(new Re),unusualLineTerminators:re(new h(fe.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(653,null),s.localize(654,null),s.localize(655,null)],description:s.localize(656,null)})),useShadowDOM:re(new w(fe.useShadowDOM,"useShadowDOM",!0)),useTabStops:re(new w(fe.useTabStops,"useTabStops",!0,{description:s.localize(657,null)})),wordBreak:re(new h(fe.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(658,null),s.localize(659,null)],description:s.localize(660,null)})),wordSegmenterLocales:re(new dt),wordSeparators:re(new r(fe.wordSeparators,"wordSeparators",v.$wt,{description:s.localize(661,null)})),wordWrap:re(new h(fe.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(662,null),s.localize(663,null),s.localize(664,null),s.localize(665,null)],description:s.localize(666,null)})),wordWrapBreakAfterCharacters:re(new r(fe.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:re(new r(fe.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:re(new l(fe.wordWrapColumn,"wordWrapColumn",80,1,D.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(667,null)})),wordWrapOverride1:re(new h(fe.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:re(new h(fe.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:re(new x),defaultColorDecorators:re(new w(fe.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(668,null)})),pixelRatio:re(new we),tabFocusMode:re(new w(fe.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(669,null)})),layoutInfo:re(new oe),wrappingInfo:re(new ut),wrappingIndent:re(new ot),wrappingStrategy:re(new _)}}),define(Oe[207],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Ym=e.ID=void 0,e.$Zm=i,e.ID="diagnosticsService",e.$Ym=(0,t.$Ki)(e.ID);function i(I){return!!I.hostName&&!!I.errorMessage}class E{async getPerformanceInfo(D,T){return{}}async getSystemInfo(D,T){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,T){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$1m=E}),define(Oe[88],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=void 0,e.$0o=(0,t.$Ki)("downloadService")}),define(Oe[27],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=void 0,e.$Ri=(0,t.$Ki)("environmentService"),e.$Si=(0,t.$Li)(e.$Ri)}),define(Oe[15],Le([1,0,68,8,16,10,4,7,5,3,12,66]),function(ue,e,t,i,E,I,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Kl=e.FileKind=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.FileOperationResult=e.$Cl=e.$Bl=e.$Al=e.$yl=e.FileChangeType=e.$xl=e.FileOperation=e.$rl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$fl=void 0,e.$gl=p,e.$hl=m,e.$il=g,e.$jl=d,e.$kl=w,e.$ll=o,e.$ml=l,e.$nl=n,e.$ol=u,e.$pl=r,e.$ql=f,e.$sl=P,e.$tl=O,e.$ul=C,e.$vl=L,e.$wl=R,e.$zl=ve,e.$Ll=U,e.$Ml=te,e.$Ol=ye,e.$fl=(0,v.$Ki)("fileService");function p(oe){return oe.create===!0}var $;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var a;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var c;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(c||(e.FileChangeFilter=c={}));function m(oe){const _=oe;return!!_&&typeof _.onDidChange=="function"}var b;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function g(oe){return!!(oe.capabilities&b.FileReadWrite)}function d(oe){return!!(oe.capabilities&b.FileFolderCopy)}function w(oe){return!!(oe.capabilities&b.FileClone)}function o(oe){return!!(oe.capabilities&b.FileOpenReadWriteClose)}function l(oe){return!!(oe.capabilities&b.FileReadStream)}function n(oe){return g(oe)?!!(oe.capabilities&b.FileAtomicRead):!1}function u(oe){return g(oe)?!!(oe.capabilities&b.FileAtomicWrite):!1}function r(oe){return!!(oe.capabilities&b.FileAtomicDelete)}function f(oe){return!!(oe.capabilities&b.Readonly)}var h;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class k extends Error{static create(_,X){const M=new k(_.toString(),X);return C(M,X),M}constructor(_,X){super(_),this.code=X}}e.$rl=k;function P(oe,_){return k.create(oe,_)}function O(oe){return oe||P((0,T.localize)(1866,null),h.Unknown)}function C(oe,_){return oe.name=_?`${_} (FileSystemError)`:"FileSystemError",oe}function L(oe){if(!oe)return h.Unknown;if(oe instanceof k)return oe.code;const _=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!_)return h.Unknown;switch(_[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function R(oe){if(oe instanceof be)return oe.fileOperationResult;switch(L(oe)){case h.FileNotFound:return B.FILE_NOT_FOUND;case h.FileIsADirectory:return B.FILE_IS_DIRECTORY;case h.FileNotADirectory:return B.FILE_NOT_DIRECTORY;case h.FileWriteLocked:return B.FILE_WRITE_LOCKED;case h.NoPermissions:return B.FILE_PERMISSION_DENIED;case h.FileExists:return B.FILE_MOVE_CONFLICT;case h.FileTooLarge:return B.FILE_TOO_LARGE;default:return B.FILE_OTHER_ERROR}}var z;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(z||(e.FileOperation=z={}));class Q{constructor(_,X,M){this.resource=_,this.operation=X,this.target=M}isOperation(_){return this.operation===_}}e.$xl=Q;var J;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(J||(e.FileChangeType=J={}));class x{static{this.a=null}constructor(_,X){this.c=X,this.b=void 0,this.d=new y.$Y(()=>{const M=t.$Qi.forUris(()=>this.c);return M.fill(this.rawAdded.map(A=>[A,!0])),M}),this.f=new y.$Y(()=>{const M=t.$Qi.forUris(()=>this.c);return M.fill(this.rawUpdated.map(A=>[A,!0])),M}),this.g=new y.$Y(()=>{const M=t.$Qi.forUris(()=>this.c);return M.fill(this.rawDeleted.map(A=>[A,!0])),M}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const M of _){switch(M.type){case J.ADDED:this.rawAdded.push(M.resource);break;case J.UPDATED:this.rawUpdated.push(M.resource);break;case J.DELETED:this.rawDeleted.push(M.resource);break}this.b!==x.a&&(typeof M.cId=="number"?this.b===void 0?this.b=M.cId:this.b!==M.cId&&(this.b=x.a):this.b!==void 0&&(this.b=x.a))}}contains(_,...X){return this.h(_,{includeChildren:!1},...X)}affects(_,...X){return this.h(_,{includeChildren:!0},...X)}h(_,X,...M){if(!_)return!1;const A=M.length>0;return!!((!A||M.includes(J.ADDED))&&(this.d.value.get(_)||X.includeChildren&&this.d.value.findSuperstr(_))||(!A||M.includes(J.UPDATED))&&(this.f.value.get(_)||X.includeChildren&&this.f.value.findSuperstr(_))||(!A||M.includes(J.DELETED))&&(this.g.value.findSubstr(_)||X.includeChildren&&this.g.value.findSuperstr(_)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(_){return this.b===_}hasCorrelation(){return typeof this.b=="number"}}e.$yl=x;function ve(oe,_,X){return!oe||!_||oe===_||_.length>oe.length?!1:(_.charAt(_.length-1)!==i.sep&&(_+=i.sep),X?(0,E.$Lf)(oe,_):oe.indexOf(_)===0)}class be extends Error{constructor(_,X,M){super(_),this.fileOperationResult=X,this.options=M}}e.$Al=be;class se extends be{constructor(_,X,M,A){super(_,X,A),this.fileOperationResult=X,this.size=M}}e.$Bl=se;class V extends be{constructor(_,X,M){super(_,B.FILE_NOT_MODIFIED_SINCE,M),this.stat=X}}e.$Cl=V;var B;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(B||(e.FileOperationResult=B={})),e.$Dl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$El={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Fl="files.associations",e.$Gl="files.exclude",e.$Hl="files.readonlyInclude",e.$Il="files.readonlyExclude",e.$Jl="files.readonlyFromPermissions";var j;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(j||(e.FileKind=j={})),e.$Kl="";function U(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function te(oe,_){if(!_.hasProvider(D.URI.from({scheme:oe.scheme})))return new Promise(X=>{const M=_.onDidChangeFileSystemProviderRegistrations(A=>{A.scheme===oe.scheme&&A.added&&(M.dispose(),X())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(_){return(0,I.$ng)(_)||(_=0),_<le.KB?(0,T.localize)(1867,null,_.toFixed(0)):_<le.MB?(0,T.localize)(1868,null,(_/le.KB).toFixed(2)):_<le.GB?(0,T.localize)(1869,null,(_/le.MB).toFixed(2)):_<le.TB?(0,T.localize)(1870,null,(_/le.GB).toFixed(2)):(0,T.localize)(1871,null,(_/le.TB).toFixed(2))}}e.$Nl=le;function ye(oe){const _=typeof oe=="string"||oe?.scheme===S.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===S.Schemas.file?1024*le.MB:_?10*le.MB:s.$r?50*le.MB:1024*le.MB}}),define(Oe[123],Le([1,0,14,9,7,15]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=D;async function D(S,y,p,$,a,c){let m;try{await T(S,y,p,$,a,c)}catch(b){m=b}finally{m&&a.errorTransformer&&(m=a.errorTransformer(m)),typeof m<"u"&&p.error(m),p.end()}}async function T(S,y,p,$,a,c){v(c);const m=await S.open(y,{create:!1});try{v(c);let b=0,g=0,d=a&&typeof a.length=="number"?a.length:void 0,w=t.$Se.alloc(Math.min(a.bufferSize,typeof d=="number"?d:a.bufferSize)),o=a&&typeof a.position=="number"?a.position:0,l=0;do g=await S.read(m,o,w.buffer,l,w.byteLength-l),o+=g,l+=g,b+=g,typeof d=="number"&&(d-=g),l===w.byteLength&&(await p.write($(w)),w=t.$Se.alloc(Math.min(a.bufferSize,typeof d=="number"?d:a.bufferSize)),l=0);while(g>0&&(typeof d!="number"||d>0)&&v(c)&&s(b,a));if(l>0){let n=l;typeof d=="number"&&(n=Math.min(l,d)),p.write($(w.slice(0,n)))}}catch(b){throw(0,I.$tl)(b)}finally{await S.close(m)}}function v(S){if(S.isCancellationRequested)throw(0,i.$0)();return!0}function s(S,y){if(typeof y?.limits?.size=="number"&&S>y.limits.size)throw(0,I.$sl)((0,E.localize)(1899,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Oe[52],Le([1,0,86,2,8,3,4,15]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=void 0,e.$br=v,e.$cr=s,e.$gr=$,e.$hr=a,e.$ir=c,e.$jr=m,e.$kr=g,e.$lr=d;function v(w){return typeof w.correlationId=="number"}function s(w){return w.recursive===!0}class S extends i.$Zc{static{this.a=5}constructor(o,l,n,u){super(),this.h=o,this.j=l,this.m=n,this.n=u,this.c=this.B(new i.$1c),this.f=void 0,this.g=0}s(){const o=new i.$Yc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile(l=>this.h(l))),o.add(this.b.onDidLogMessage(l=>this.j(l))),o.add(this.b.onDidError(l=>this.t(l.error,l.request)))}t(o,l){this.u(o,l)?this.g<S.a&&this.f?(this.y(`restarting watcher after unexpected error: ${o}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${o}`):this.y(o)}u(o,l){return!(!this.n.restartOnError||l||o.indexOf("No space left on device")!==-1||o.indexOf("EMFILE")!==-1)}w(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}y(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}z(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$dr=S;class y extends S{constructor(o,l,n){super(o,l,n,{type:"node.js",restartOnError:!1})}}e.$er=y;class p extends S{constructor(o,l,n){super(o,l,n,{type:"universal",restartOnError:!0})}}e.$fr=p;function $(w){return w.map(o=>({type:o.type,resource:D.URI.revive(o.resource),cId:o.cId}))}function a(w){const o=new b;for(const l of w)o.processEvent(l);return o.coalesce()}function c(w,o){return typeof o=="string"&&!o.startsWith(t.$Bk)&&!(0,E.$nc)(o)?{base:w,pattern:o}:o}function m(w,o){const l=[];for(const n of o)l.push((0,t.$Fk)(c(w,n)));return l}class b{constructor(){this.a=new Set,this.b=new Map}c(o){return I.$n?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const l=this.b.get(this.c(o));let n=!1;if(l){const u=l.type,r=o.type;l.resource.fsPath!==o.resource.fsPath&&(o.type===T.FileChangeType.DELETED||o.type===T.FileChangeType.ADDED)?n=!0:u===T.FileChangeType.ADDED&&r===T.FileChangeType.DELETED?(this.b.delete(this.c(o)),this.a.delete(l)):u===T.FileChangeType.DELETED&&r===T.FileChangeType.ADDED?l.type=T.FileChangeType.UPDATED:u===T.FileChangeType.ADDED&&r===T.FileChangeType.UPDATED||(l.type=r)}else n=!0;n&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],l=[];return Array.from(this.a).filter(n=>n.type!==T.FileChangeType.DELETED?(o.push(n),!1):!0).sort((n,u)=>n.resource.fsPath.length-u.resource.fsPath.length).filter(n=>l.some(u=>(0,T.$zl)(n.resource.fsPath,u,!I.$n))?!1:(l.push(n.resource.fsPath),!0)).concat(o)}}function g(w,o){if(typeof o=="number")switch(w.type){case T.FileChangeType.ADDED:return(o&T.FileChangeFilter.ADDED)===0;case T.FileChangeType.DELETED:return(o&T.FileChangeFilter.DELETED)===0;case T.FileChangeType.UPDATED:return(o&T.FileChangeFilter.UPDATED)===0}return!1}function d(w){if(typeof w=="number"){const o=[];return w&T.FileChangeFilter.ADDED&&o.push("Added"),w&T.FileChangeFilter.DELETED&&o.push("Deleted"),w&T.FileChangeFilter.UPDATED&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(Oe[208],Le([1,0,14,45,9,6,2,56,23,15,52]),function(ue,e,t,i,E,I,D,T,v,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XR=e.$WR=void 0,e.$WR="localFilesystem";class y extends D.$Zc{constructor($,a){super(),this.a=$,this.b=a,this.onDidChangeCapabilities=I.Event.None,this.f=this.B(new I.$qe),this.onDidChangeFile=this.f.event,this.g=this.B(new I.$qe),this.onDidWatchError=this.g.event,this.h=(0,v.$7g)(),this.j()}get capabilities(){return this.c||(this.c=s.FileSystemProviderCapabilities.FileReadWrite|s.FileSystemProviderCapabilities.FileOpenReadWriteClose|s.FileSystemProviderCapabilities.FileReadStream|s.FileSystemProviderCapabilities.FileFolderCopy|s.FileSystemProviderCapabilities.FileWriteUnlock|s.FileSystemProviderCapabilities.FileAtomicRead|s.FileSystemProviderCapabilities.FileAtomicWrite|s.FileSystemProviderCapabilities.FileAtomicDelete|s.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=s.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=s.FileSystemProviderCapabilities.Trash)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,a){const{buffer:c}=await this.a.call("readFile",[$,a]);return c}readFileStream($,a,c){const m=(0,T.$Ge)(g=>t.$Se.concat(g.map(d=>t.$Se.wrap(d))).buffer),b=new D.$Yc;return b.add(this.a.listen("readFileStream",[$,a])(g=>{if(g instanceof t.$Se)m.write(g.buffer);else{if(g==="end")m.end();else{let d;if(g instanceof Error)d=g;else{const w=g;d=(0,s.$sl)(w.message??(0,i.$vj)(w),w.code??s.FileSystemProviderErrorCode.Unknown)}m.error(d),m.end()}b.dispose()}})),b.add(c.onCancellationRequested(()=>{m.error((0,E.$0)()),m.end(),b.dispose()})),m}writeFile($,a,c){return this.a.call("writeFile",[$,t.$Se.wrap(a),c])}open($,a){return this.a.call("open",[$,a])}close($){return this.a.call("close",[$])}async read($,a,c,m,b){const[g,d]=await this.a.call("read",[$,a,b]);return c.set(g.buffer.slice(0,d),m),d}write($,a,c,m,b){return this.a.call("write",[$,a,t.$Se.wrap(c),m,b])}mkdir($){return this.a.call("mkdir",[$])}delete($,a){return this.a.call("delete",[$,a])}rename($,a,c){return this.a.call("rename",[$,a,c])}copy($,a,c){return this.a.call("copy",[$,a,c])}cloneFile($,a){return this.a.call("cloneFile",[$,a])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const a=$;this.f.fire((0,S.$gr)(a))}else{const a=$;this.g.fire(a)}}))}watch($,a){const c=(0,v.$7g)();return this.a.call("watch",[this.h,c,$,a]),(0,D.$Xc)(()=>this.a.call("unwatch",[this.h,c]))}}e.$XR=y}),define(Oe[209],Le([1,0,20,2,52,6,15,4,13]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;class s extends i.$Zc{constructor(){super(),this.a=this.B(new I.$qe),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$qe),this.onDidLogMessage=this.b.event,this.c=this.B(new I.$qe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new i.$9c),this.m=new Set,this.n=this.B(new v.$Ih(this.y())),this.r=5007,this.s=new v.$8h,this.R=!1,this.B(this.f(y=>this.t(y)))}t(y){this.u(y)&&this.z(y)}u(y){return(0,E.$br)(y)}async watch(y){this.s.isSettled||this.s.complete(),this.s=new v.$8h;try{this.h.clear(),this.g.clear();for(const p of y)this.u(p)?this.h.set(p.correlationId,p):this.g.add(p);for(const[p]of this.j)this.h.has(p)||(this.j.deleteAndDispose(p),this.m.delete(p));return await this.w(!1)}finally{this.s.complete()}}w(y){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(p=>!this.j.has(p.correlationId))]),y?this.y():0)}y(){return 800}isSuspended(y){return typeof y.correlationId!="number"?!1:this.m.has(y.correlationId)?"polling":this.j.has(y.correlationId)}async z(y){if(this.j.has(y.correlationId))return;const p=new i.$Yc;this.j.set(y.correlationId,p),await this.s.p,!p.isDisposed&&(this.D(y,p),this.w(!0))}C(y){this.j.deleteAndDispose(y.correlationId),this.m.delete(y.correlationId),this.w(!1)}D(y,p){this.F(y,p)?(this.P(`reusing an existing recursive watcher to monitor ${y.path}`),this.m.delete(y.correlationId)):(this.G(y,p),this.m.add(y.correlationId))}F(y,p){const $=this.O?.subscribe(y.path,(a,c)=>{p.isDisposed||(a?this.D(y,p):c?.type===D.FileChangeType.ADDED&&this.H(y))});return $?(p.add($),!0):!1}G(y,p){let $=!1;const a=(c,m)=>{if(p.isDisposed)return;const b=this.I(c),g=this.I(m),d=$;$=b,!b&&(g||d)&&this.H(y)};this.P(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,t.watchFile)(y.path,{persistent:!1,interval:this.r},a)}catch(c){this.Q(`fs.watchFile() failed with error ${c} on path ${y.path} (correlationId: ${y.correlationId})`)}p.add((0,i.$Xc)(()=>{this.P(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,t.unwatchFile)(y.path,a)}catch(c){this.Q(`fs.unwatchFile() failed with error ${c} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}H(y){this.P(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const p={resource:T.URI.file(y.path),type:D.FileChangeType.ADDED,cId:y.correlationId};this.a.fire([p]),this.J(p,y),this.C(y)}I(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(y,p){if(this.R){const $=` >> normalized ${y.type===D.FileChangeType.ADDED?"[ADDED]":y.type===D.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.L($,p)}}L(y,p){this.R&&this.P(`${y}${typeof p.correlationId=="number"?` <${p.correlationId}> `:""}`)}M(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,E.$lr)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.R=y}}e.$ur=s}),define(Oe[210],Le([1,0,20,13,18,36,2,107,8,3,19,4,194,26,15,52]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0,e.$Ar=b;class m extends D.$Zc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(d,w,o,l,n,u){super(),this.s=d,this.t=w,this.u=o,this.w=l,this.y=n,this.z=u,this.c=this.B(new i.$Zh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.u(r))),this.f=this.B(new i.$Yh(r=>this.M(r),m.b)),this.g=(0,c.$jr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$jr)(this.s.path,this.s.includes):void 0,this.j=(0,c.$br)(this.s)?this.s.filter:void 0,this.m=new E.$Be,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const d=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const w=await t.promises.stat(d);if(this.m.token.isCancellationRequested)return;this.B(await this.G(d,w.isDirectory()))}catch(d){d.code!=="ENOENT"?this.O(d):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${d})`),this.D()}}D(){this.r=!0,this.w?.()}async F(d){let w=d.path;try{w=await $.Promises.realpath(d.path),d.path===w&&(w=await(0,p.$wr)(d.path,this.m.token)??d.path),d.path!==w&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${w})`)}catch{}return w}async G(d,w){const o=new D.$Yc;return this.H(d,w,o)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(d,w,o)),o}H(d,w,o){if(w)return!1;const l=y.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(u,r)=>{if(!o.isDisposed)if(u){const f=await this.G(d,w);o.isDisposed?f.dispose():o.add(f)}else r&&(typeof r.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:l,type:r.type,cId:this.s.correlationId},!0)});return n?(o.add(n),!0):!1}async I(d,w,o){if(s.$m&&(0,I.$Jg)(d,"/Volumes/",!0)){this.O(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const l=new E.$Be(this.m.token);o.add((0,D.$Xc)(()=>l.dispose(!0)));const n=new D.$Yc;o.add(n);try{const u=y.URI.file(this.s.path),r=(0,v.$sc)(d),f=(0,t.watch)(d);n.add((0,D.$Xc)(()=>{f.removeAllListeners(),f.close()})),this.Q(`Started watching: '${d}'`);const h=new Set;if(w)try{for(const P of await $.Promises.readdir(d))h.add(P)}catch(P){this.O(P)}if(l.token.isCancellationRequested)return;const k=new Map;n.add((0,D.$Xc)(()=>{for(const[,P]of k)P.dispose();k.clear()})),f.on("error",(P,O)=>{l.token.isCancellationRequested||(this.O(`Failed to watch ${d} for changes using fs.watch() (${P}, ${O})`),this.D())}),f.on("change",(P,O)=>{if(l.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${P}"] ${O}`);let C="";if(O&&(C=O.toString(),s.$m&&(C=(0,T.$sm)(C))),!(!C||P!=="change"&&P!=="rename"))if(w)if(P==="rename"){k.get(C)?.dispose();const L=setTimeout(async()=>{if(k.delete(C),C===r&&!await $.Promises.exists(d)){this.J(u);return}if(l.token.isCancellationRequested)return;const R=await this.N((0,v.$oc)(d,C));if(l.token.isCancellationRequested)return;let z;R?h.has(C)?z=a.FileChangeType.UPDATED:(z=a.FileChangeType.ADDED,h.add(C)):(h.delete(C),z=a.FileChangeType.DELETED),this.L({resource:(0,S.$lh)(u,C),type:z,cId:this.s.correlationId})},m.a);k.set(C,(0,D.$Xc)(()=>clearTimeout(L)))}else{let L;h.has(C)?L=a.FileChangeType.UPDATED:(L=a.FileChangeType.ADDED,h.add(C)),this.L({resource:(0,S.$lh)(u,C),type:L,cId:this.s.correlationId})}else if(P==="rename"||C!==r){const L=setTimeout(async()=>{const R=await $.Promises.exists(d);l.token.isCancellationRequested||(R?(this.L({resource:u,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(d,!1))):this.J(u))},m.a);n.clear(),n.add((0,D.$Xc)(()=>clearTimeout(L)))}else this.L({resource:u,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(u){l.token.isCancellationRequested||this.O(`Failed to watch ${d} for changes using fs.watch() (${u.toString()})`),this.D()}}J(d){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:d,type:a.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(d,w=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${d.type===a.FileChangeType.ADDED?"[ADDED]":d.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!w&&this.g.some(o=>o(d.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${d.resource.fsPath}`):!w&&this.h&&this.h.length>0&&!this.h.some(o=>o(d.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}M(d){const w=(0,c.$hr)(d),o=[];for(const n of w){if((0,c.$kr)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}o.push(n)}if(o.length===0)return;if(this.z)for(const n of o)this.R(` >> normalized ${n.type===a.FileChangeType.ADDED?"[ADDED]":n.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(o)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(d){if(s.$n)return $.Promises.exists(d);try{const w=(0,v.$sc)(d);return(await $.Promises.readdir((0,v.$rc)(d))).some(l=>l===w)}catch(w){return this.Q(w),!1}}setVerboseLogging(d){this.z=d}O(d){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}P(d){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}Q(d){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}R(d){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${d}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$zr=m;async function b(g,d,w,o,l=512){const n=await $.Promises.open(g,"r"),u=Buffer.allocUnsafe(l),r=new E.$Be(o);let f,h=!1;const k={path:g,excludes:[],recursive:!1},P=new m(k,void 0,O=>{(async()=>{for(const{type:C}of O)if(C===a.FileChangeType.UPDATED){if(h)return;h=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:L}=await $.Promises.read(n,u,0,l,null);if(!L||r.token.isCancellationRequested)break;d(u.slice(0,L))}}catch(L){f=new Error(L),r.dispose(!0)}finally{h=!1}}})()});return await P.ready,w(),new Promise((O,C)=>{r.token.onCancellationRequested(async()=>{P.dispose();try{await $.Promises.close(n)}catch(L){f=new Error(L)}f?C(f):O()})})}}),define(Oe[211],Le([1,0,6,86,209,3,210,36]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;class v extends E.$ur{constructor(S){super(),this.O=S,this.onDidError=t.Event.None,this.watchers=new Set}async N(S){S=this.Z(S);const y=[],p=new Set(Array.from(this.watchers));for(const $ of S){const a=this.W($);a&&(0,i.$Jk)(a.request.excludes,$.excludes)&&(0,i.$Jk)(a.request.includes,$.includes)?p.delete(a):y.push($)}y.length&&this.P(`Request to start watching: ${y.map($=>this.M($)).join(",")}`),p.size&&this.P(`Request to stop watching: ${Array.from(p).map($=>this.M($.request)).join(",")}`);for(const $ of p)this.Y($);for(const $ of y)this.X($)}W(S){for(const y of this.watchers)if(typeof S.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===S.correlationId)return y}else if((0,T.$Ig)(y.request.path,S.path,!I.$n))return y}X(S){const y=new D.$zr(S,this.O,$=>this.a.fire($),()=>this.c.fire(S),$=>this.b.fire($),this.R),p={request:S,instance:y};this.watchers.add(p)}async stop(){await super.stop();for(const S of this.watchers)this.Y(S)}Y(S){this.P("stopping file watcher",S),this.watchers.delete(S),S.instance.dispose()}Z(S){const y=new Map;for(const p of S){const $=I.$n?p.path:p.path.toLowerCase();let a=y.get(p.correlationId);a||(a=new Map,y.set(p.correlationId,a)),a.has($)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(p)}`),a.set($,p)}return Array.from(y.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(S){super.setVerboseLogging(S);for(const y of this.watchers)y.instance.setVerboseLogging(S)}P(S,y){this.R&&this.b.fire({type:"trace",message:this.bb(S,y)})}Q(S){this.b.fire({type:"warn",message:this.bb(S)})}bb(S,y){return y?`[File Watcher (node.js)] ${S} (${this.M(y.request)})`:`[File Watcher (node.js)] ${S}`}}e.$Br=v}),define(Oe[212],Le([1,0,52,211]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class E extends t.$er{constructor(D,T,v){super(D,T,v),this.s()}r(D){return D.add(new i.$Br(void 0))}}e.$Cr=E}),define(Oe[213],Le([1,0,12,51,119,52]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;class D extends I.$fr{constructor(v,s,S){super(v,s,S),this.s()}r(v){const s=v.add(new E.$sr(t.$5g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(s.onDidProcessExit(({code:S,signal:y})=>this.t(`terminated by itself with code ${S}, signal: ${y} (ETERM)`))),i.ProxyChannel.toService((0,i.$ri)(s.getChannel("watcher")))}}e.$tr=D}),define(Oe[89],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=void 0;class t{constructor(...E){this.a=new Map;for(const[I,D]of E)this.set(I,D)}set(E,I){const D=this.a.get(E);return this.a.set(E,I),D}has(E){return this.a.has(E)}get(E){return this.a.get(E)}}e.$Ii=t}),define(Oe[124],Le([1,0,13,9,2,72,204,5,89,81]),function(ue,e,t,i,E,I,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=void 0;const S=!1;class y extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class p{constructor(m=new v.$Ii,b=!1,g,d=S){this.i=m,this.j=b,this.k=g,this.l=d,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Ji,this),this._globalGraph=d?g?._globalGraph??new D.$Fr(w=>w):void 0}dispose(){if(!this.f){this.f=!0,(0,E.$Uc)(this.h),this.h.clear();for(const m of this.g)(0,E.$Tc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,b){this.m();const g=this,d=new class extends p{dispose(){g.h.delete(d),super.dispose()}}(m,this.j,this,this.l);return this.h.add(d),b?.add(d),d}invokeFunction(m,...b){this.m();const g=a.traceInvocation(this.l,m);let d=!1;try{return m({get:o=>{if(d)throw(0,i.$_)("service accessor is only valid during the invocation of its target method");const l=this.s(o,g);if(!l)throw new Error(`[invokeFunction] unknown service '${o}'`);return l}},...b)}finally{d=!0,g.stop()}}createInstance(m,...b){this.m();let g,d;return m instanceof I.$Hi?(g=a.traceCreation(this.l,m.ctor),d=this.o(m.ctor,m.staticArguments.concat(b),g)):(g=a.traceCreation(this.l,m),d=this.o(m,b,g)),g.stop(),d}o(m,b=[],g){const d=T._util.getServiceDependencies(m).sort((l,n)=>l.index-n.index),w=[];for(const l of d){const n=this.s(l.id,g);n||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${l.id}.`,!1),w.push(n)}const o=d.length>0?d[0].index:b.length;if(b.length!==o){console.trace(`[createInstance] First service dependency of ${m.name} at position ${o+1} conflicts with ${b.length} static arguments`);const l=o-b.length;l>0?b=b.concat(new Array(l)):b=b.slice(0,o)}return Reflect.construct(m,b.concat(w))}q(m,b){if(this.i.get(m)instanceof I.$Hi)this.i.set(m,b);else if(this.k)this.k.q(m,b);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const b=this.i.get(m);return!b&&this.k?this.k.r(m):b}s(m,b){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const g=this.r(m);return g instanceof I.$Hi?this.u(m,g,b.branch(m,!0)):(b.branch(m,!1),g)}u(m,b,g){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,b,g)}finally{this.t.delete(m)}}v(m,b,g){const d=new D.$Fr(n=>n.id.toString());let w=0;const o=[{id:m,desc:b,_trace:g}],l=new Set;for(;o.length;){const n=o.pop();if(!l.has(String(n.id))){if(l.add(String(n.id)),d.lookupOrInsertNode(n),w++>1e3)throw new y(d);for(const u of T._util.getServiceDependencies(n.desc.ctor)){const r=this.r(u.id);if(r||this.y(`[createInstance] ${m} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(u.id)),r instanceof I.$Hi){const f={id:u.id,desc:r,_trace:n._trace.branch(u.id,!0)};d.insertEdge(n,f),o.push(f)}}}}for(;;){const n=d.roots();if(n.length===0){if(!d.isEmpty())throw new y(d);break}for(const{data:u}of n){if(this.r(u.id)instanceof I.$Hi){const f=this.w(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.q(u.id,f)}d.removeNode(u)}}return this.r(m)}w(m,b,g=[],d,w){if(this.i.get(m)instanceof I.$Hi)return this.x(m,b,g,d,w,this.g);if(this.k)return this.k.w(m,b,g,d,w);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}x(m,b,g=[],d,w,o){if(d){const l=new p(void 0,this.j,this,this.l);l.c=String(m);const n=new Map,u=new t.$4h(()=>{const r=l.o(b,g,w);for(const[f,h]of n){const k=r[f];if(typeof k=="function")for(const P of h)P.disposable=k.apply(r,P.listener)}return n.clear(),o.add(r),r});return new Proxy(Object.create(null),{get(r,f){if(!u.isInitialized&&typeof f=="string"&&(f.startsWith("onDid")||f.startsWith("onWill"))){let P=n.get(f);return P||(P=new s.$0c,n.set(f,P)),(C,L,R)=>{if(u.isInitialized)return u.value[f](C,L,R);{const z={listener:[C,L,R],disposable:void 0},Q=P.push(z);return(0,E.$Xc)(()=>{Q(),z.disposable?.dispose()})}}}if(f in r)return r[f];const h=u.value;let k=h[f];return typeof k!="function"||(k=k.bind(h),r[f]=k),k},set(r,f,h){return u.value[f]=h,!0},getPrototypeOf(r){return b.prototype}})}else{const l=this.o(b,g,w);return o.add(l),l}}y(m,b){if(b&&console.warn(m),this.j)throw new Error(m)}}e.$Gr=p;var $;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})($||($={}));class a{static{this.all=new Set}static{this.c=new class extends a{constructor(){super($.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,b){return m?new a($.Invocation,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):a.c}static traceCreation(m,b){return m?new a($.Creation,b.name):a.c}static{this.f=0}constructor(m,b){this.type=m,this.name=b,this.g=Date.now(),this.h=[]}branch(m,b){const g=new a($.Branch,m.toString());return this.h.push([m,b,g]),g}stop(){const m=Date.now()-this.g;a.f+=m;let b=!1;function g(w,o){const l=[],n=new Array(w+1).join("	");for(const[u,r,f]of o.h)if(r&&f){b=!0,l.push(`${n}CREATES -> ${u}`);const h=g(w+1,f);h&&l.push(h)}else l.push(`${n}uses -> ${u}`);return l.join(`
`)}const d=[`${this.type===$.Creation?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${a.f.toFixed(2)}ms)`];(m>2||b)&&a.all.add(d.join(`
`))}}e.$Hr=a}),define(Oe[214],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$Dw=void 0,e.$Dw=(0,t.$Ki)("labelService");var i;(function(E){E[E.SHORT=0]="SHORT",E[E.MEDIUM=1]="MEDIUM",E[E.LONG=2]="LONG"})(i||(e.Verbosity=i={}))}),define(Oe[11],Le([1,0,7,45,6,67,2,25,3,19,10,4,41,5]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$ik=e.LogLevel=e.$gk=e.$fk=void 0,e.$hk=c,e.log=b,e.$tk=k,e.$uk=P,e.$vk=O,e.$wk=C,t=We(t),e.$fk=(0,$.$Ki)("logService"),e.$gk=(0,$.$Ki)("loggerService");function a(){return new Date().toISOString()}function c(L){return(0,S.$ng)(L)}var m;(function(L){L[L.Off=0]="Off",L[L.Trace=1]="Trace",L[L.Debug=2]="Debug",L[L.Info=3]="Info",L[L.Warning=4]="Warning",L[L.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$ik=m.Info;function b(L,R,z){switch(R){case m.Trace:L.trace(z);break;case m.Debug:L.debug(z);break;case m.Info:L.info(z);break;case m.Warning:L.warn(z);break;case m.Error:L.error(z);break;case m.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function g(L,R=!1){let z="";for(let Q=0;Q<L.length;Q++){let J=L[Q];if(J instanceof Error&&(J=(0,i.$vj)(J,R)),typeof J=="object")try{J=JSON.stringify(J)}catch{}z+=(Q>0?" ":"")+J}return z}class d extends D.$Zc{constructor(){super(...arguments),this.b=e.$ik,this.c=this.B(new E.$qe),this.onDidChangeLogLevel=this.c.event}setLevel(R){this.b!==R&&(this.b=R,this.c.fire(this.b))}getLevel(){return this.b}f(R){return this.b!==m.Off&&this.b<=R}}e.$kk=d;class w extends d{constructor(R){super(),this.h=R}f(R){return this.h||super.f(R)}trace(R,...z){this.f(m.Trace)&&this.g(m.Trace,g([R,...z],!0))}debug(R,...z){this.f(m.Debug)&&this.g(m.Debug,g([R,...z]))}info(R,...z){this.f(m.Info)&&this.g(m.Info,g([R,...z]))}warn(R,...z){this.f(m.Warning)&&this.g(m.Warning,g([R,...z]))}error(R,...z){if(this.f(m.Error))if(R instanceof Error){const Q=Array.prototype.slice.call(arguments);Q[0]=R.stack,this.g(m.Error,g(Q))}else this.g(m.Error,g([R,...z]))}flush(){}}e.$lk=w;class o extends d{constructor(R=e.$ik){super(),this.setLevel(R),this.g=!v.$l}trace(R,...z){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,R,...z):console.log(`[main ${a()}]`,R,...z))}debug(R,...z){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,R,...z):console.log(`[main ${a()}]`,R,...z))}info(R,...z){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,R,...z):console.log(`[main ${a()}]`,R,...z))}warn(R,...z){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,R,...z):console.warn(`[main ${a()}]`,R,...z))}error(R,...z){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,R,...z):console.error(`[main ${a()}]`,R,...z))}flush(){}}e.$mk=o;class l extends d{constructor(R=e.$ik,z=!0){super(),this.g=z,this.setLevel(R)}trace(R,...z){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",R,...z):console.log(R,...z))}debug(R,...z){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",R,...z):console.log(R,...z))}info(R,...z){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",R,...z):console.log(R,...z))}warn(R,...z){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",R,...z):console.log(R,...z))}error(R,...z){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",R,...z):console.error(R,...z))}flush(){}}e.$nk=l;class n extends d{constructor(R,z=e.$ik){super(),this.g=R,this.setLevel(z)}trace(R,...z){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(R),...z])}debug(R,...z){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(R),...z])}info(R,...z){this.f(m.Info)&&this.g.log(m.Info,[this.h(R),...z])}warn(R,...z){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(R),...z])}error(R,...z){this.f(m.Error)&&this.g.log(m.Error,[this.h(R),...z])}h(R){return typeof R=="string"?R:(0,i.$vj)(R,this.f(m.Trace))}flush(){}}e.$ok=n;class u extends d{constructor(R){super(),this.g=R,R.length&&this.setLevel(R[0].getLevel())}setLevel(R){for(const z of this.g)z.setLevel(R);super.setLevel(R)}trace(R,...z){for(const Q of this.g)Q.trace(R,...z)}debug(R,...z){for(const Q of this.g)Q.debug(R,...z)}info(R,...z){for(const Q of this.g)Q.info(R,...z)}warn(R,...z){for(const Q of this.g)Q.warn(R,...z)}error(R,...z){for(const Q of this.g)Q.error(R,...z)}flush(){for(const R of this.g)R.flush()}dispose(){for(const R of this.g)R.dispose();super.dispose()}}e.$pk=u;class r extends D.$Zc{constructor(R,z,Q){if(super(),this.h=R,this.j=z,this.b=new T.$Fc,this.c=this.B(new E.$qe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new E.$qe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new E.$qe),this.onDidChangeVisibility=this.g.event,Q)for(const J of Q)this.b.set(J.resource,{logger:void 0,info:J})}m(R){return(0,S.$jg)(R)?[...this.b.values()].find(z=>z.info.id===R):this.b.get(R)}getLogger(R){return this.m(R)?.logger}createLogger(R,z){const Q=this.n(R),J=(0,S.$jg)(R)?R:z?.id??(0,I.$yj)(Q.toString()).toString(16);let x=this.b.get(Q)?.logger;const ve=z?.logLevel==="always"?m.Trace:z?.logLevel;x||(x=this.s(Q,ve??this.getLogLevel(Q)??this.h,{...z,id:J}));const be={logger:x,info:{resource:Q,id:J,logLevel:ve,name:z?.name,hidden:z?.hidden,extensionId:z?.extensionId,when:z?.when}};return this.registerLogger(be.info),this.b.set(Q,be),x}n(R){return(0,S.$jg)(R)?(0,s.$lh)(this.j,`${R}.log`):R}setLogLevel(R,z){if(y.URI.isUri(R)){const Q=R,J=z,x=this.b.get(Q);x&&J!==x.info.logLevel&&(x.info.logLevel=J===this.h?void 0:J,x.logger?.setLevel(J),this.b.set(x.info.resource,x),this.f.fire([Q,J]))}else{this.h=R;for(const[Q,J]of this.b.entries())this.b.get(Q)?.info.logLevel===void 0&&J.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(R,z){const Q=this.m(R);Q&&z!==!Q.info.hidden&&(Q.info.hidden=!z,this.b.set(Q.info.resource,Q),this.g.fire([Q.info.resource,z]))}getLogLevel(R){let z;return R&&(z=this.b.get(R)?.info.logLevel),z??this.h}registerLogger(R){const z=this.b.get(R.resource);z?z.info.hidden!==R.hidden&&this.setVisibility(R.resource,!R.hidden):(this.b.set(R.resource,{info:R,logger:void 0}),this.c.fire({added:[R],removed:[]}))}deregisterLogger(R){const z=this.b.get(R);z&&(z.logger&&z.logger.dispose(),this.b.delete(R),this.c.fire({added:[],removed:[z.info]}))}*getRegisteredLoggers(){for(const R of this.b.values())yield R.info}getRegisteredLogger(R){return this.b.get(R)?.info}dispose(){this.b.forEach(R=>R.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qk=r;class f{constructor(){this.onDidChangeLogLevel=new E.$qe().event}setLevel(R){}getLevel(){return m.Info}trace(R,...z){}debug(R,...z){}info(R,...z){}warn(R,...z){}error(R,...z){}critical(R,...z){}dispose(){}flush(){}}e.$rk=f;class h extends f{}e.$sk=h;function k(L){if(L.verbose)return m.Trace;if(typeof L.logLevel=="string"){const R=C(L.logLevel.toLowerCase());if(R!==void 0)return R}return e.$ik}function P(L){switch(L){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function O(L){switch(L){case m.Trace:return{original:"Trace",value:t.localize(1960,null)};case m.Debug:return{original:"Debug",value:t.localize(1961,null)};case m.Info:return{original:"Info",value:t.localize(1962,null)};case m.Warning:return{original:"Warning",value:t.localize(1963,null)};case m.Error:return{original:"Error",value:t.localize(1964,null)};case m.Off:return{original:"Off",value:t.localize(1965,null)}}}function C(L){switch(L){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$xk=new p.$2j("logLevel",P(m.Info))});var je=this&&this.__param||function(ue,e){return function(t,i){e(t,i,ue)}};define(Oe[125],Le([1,0,50,59,65,12,43,27,5,11]),function(ue,e,t,i,E,I,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nS=e.$mS=void 0,e.$mS=(0,v.$Ki)("ICSSDevelopmentService");let S=class{constructor(p,$){this.b=p,this.c=$}get isEnabled(){return!this.b.isBuilt&&E.$V}getCssModules(){return this.a??=this.d(),this.a}async d(){if(!this.isEnabled)return[];const p=await new Promise(($,a)=>{ue(["@vscode/ripgrep"],$,a)}).then(We);return await new Promise($=>{const a=D.$ke.create(),c=[],m=new TextDecoder,b=I.$5g.asFileUri("").fsPath,g=(0,t.spawn)(p.rgPath,["-g","**/*.css","--files","--no-ignore",b],{});g.stdout.on("data",d=>{const w=m.decode(d,{stream:!0});c.push(w.split(`
`).filter(Boolean))}),g.on("error",d=>{this.c.error("[CSS_DEV] FAILED to compute CSS data",d),$([])}),g.on("close",()=>{const d=c.flat().map(w=>(0,i.relative)(b,w).replace(/\\/g,"/")).filter(Boolean).sort();$(d),this.c.info(`[CSS_DEV] DONE, ${d.length} css modules (${Math.round(a.elapsed())}ms)`)})})}};e.$nS=S,e.$nS=S=Ve([je(0,T.$Ri),je(1,s.$fk)],S)}),define(Oe[215],Le([1,0,17,13,9,6,36,2,8,52,11]),function(ue,e,t,i,E,I,D,T,v,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class y extends T.$Zc{constructor($,a){super(),this.a=$,this.b=a,this.c=this.B(new I.$qe),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$qe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new i.$Ih(0)),this.w=[],this.y=this.B(new i.$Ih(0))}watch($,a){return a.recursive||this.b?.watcher?.forceUniversal?this.n($,a):this.z($,a)}n($,a){const c={path:this.J($),excludes:a.excludes,includes:a.includes,recursive:a.recursive,filter:a.filter,correlationId:a.correlationId},m=(0,t.$Xb)(this.j,c);return this.r(),(0,T.$Xc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,E.$4)($))}s(){this.h||(this.h=this.B(this.t(a=>this.c.fire((0,s.$gr)(a)),a=>this.G(a),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const a of this.j)(0,s.$cr)(a)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const a of this.j)(0,s.$cr)(a)&&$.includes(a.path)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,a){const c={path:this.J($),excludes:a.excludes,includes:a.includes,recursive:!1,filter:a.filter,correlationId:a.correlationId},m=(0,t.$Xb)(this.w,c);return this.C(),(0,T.$Xc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,E.$4)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,s.$gr)($)),$=>this.G($),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,v.$mc)($.fsPath)}J($){const a=this.I($);return(0,D.$Mg)(a)}}e.$mr=y}),define(Oe[126],Le([1,0,17,13,14,18,6,67,39,2,68,12,44,19,56,7,15,123,11,9]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;let o=class extends s.$Zc{static{w=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new D.$qe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$qe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$qe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$qe),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$qe),this.Y=this.B(new D.$qe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$qe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new i.$Th)}registerProvider(n,u){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${n}`);const r=new s.$Yc;return this.h.set(n,u),this.c.fire({added:!0,scheme:n,provider:u}),r.add(u.onDidChangeFile(f=>{const h=new m.$yl(f,!this.S(u));this.X.fire(h),h.hasCorrelation()||this.Y.fire(h)})),typeof u.onDidWatchError=="function"&&r.add(u.onDidWatchError(f=>this.Z.fire(new Error(f)))),r.add(u.onDidChangeCapabilities(()=>this.g.fire({provider:u,scheme:n}))),(0,s.$Xc)(()=>{this.c.fire({added:!1,scheme:n,provider:u}),this.h.delete(n),(0,s.$Uc)(r)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const u=[];this.f.fire({scheme:n,join(r){u.push(r)}}),!this.h.has(n)&&await i.Promises.settled(u)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,u){const r=this.h.get(n.scheme);return!!(r&&r.capabilities&u)}listCapabilities(){return v.Iterable.map(this.h,([n,u])=>({scheme:n,capabilities:u.capabilities}))}async j(n){if(!(0,$.$ph)(n))throw new m.$Al((0,c.localize)(1872,null,this.sb(n)),m.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const u=this.h.get(n.scheme);if(!u){const r=new d.$fb;throw r.message=(0,c.localize)(1873,null,n.toString()),r}return u}async m(n){const u=await this.j(n);if((0,m.$ll)(u)||(0,m.$il)(u)||(0,m.$ml)(u))return u;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const u=await this.j(n);if((0,m.$ll)(u)||(0,m.$il)(u))return u;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,u){try{return await this.s(n,u)}catch(r){throw(0,m.$vl)(r)===m.FileSystemProviderErrorCode.FileNotFound?new m.$Al((0,c.localize)(1874,null,this.sb(n)),m.FileOperationResult.FILE_NOT_FOUND):(0,m.$tl)(r)}}async s(n,u){const r=await this.j(n),f=this.S(r),h=u?.resolveTo,k=u?.resolveSingleChildDescendants,P=u?.resolveMetadata,O=await r.stat(n);let C;return this.t(r,n,O,void 0,!!P,(L,R)=>(C||(C=S.$Qi.forUris(()=>!f),C.set(n,!0),h&&C.fill(!0,h)),C.get(L.resource)||C.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&k?R===1:!1))}async t(n,u,r,f,h,k){const{providerExtUri:P}=this.R(n),O={resource:u,name:P.basename(u),isFile:(r.type&m.FileType.File)!==0,isDirectory:(r.type&m.FileType.Directory)!==0,isSymbolicLink:(r.type&m.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&m.FilePermission.Readonly)||!!(n.capabilities&m.FileSystemProviderCapabilities.Readonly),locked:!!((r.permissions??0)&m.FilePermission.Locked),etag:(0,m.$Ll)({mtime:r.mtime,size:r.size}),children:void 0};if(O.isDirectory&&k(O,f)){try{const C=await n.readdir(u),L=await i.Promises.settled(C.map(async([R,z])=>{try{const Q=P.joinPath(u,R),J=h?await n.stat(Q):{type:z};return await this.t(n,Q,J,C.length,h,k)}catch(Q){return this.b.trace(Q),null}}));O.children=(0,t.$Lb)(L)}catch(C){this.b.trace(C),O.children=[]}return O}return O}async resolveAll(n){return i.Promises.settled(n.map(async u=>{try{return{stat:await this.s(u.resource,u.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(n){const u=await this.j(n),r=await u.stat(n);return this.t(u,n,r,void 0,!0,()=>!1)}async exists(n){const u=await this.j(n);try{return!!await u.stat(n)}catch{return!1}}async canCreateFile(n,u){try{await this.u(n,u)}catch(r){return r}return!0}async u(n,u){if(!u?.overwrite&&await this.exists(n))throw new m.$Al((0,c.localize)(1875,null,this.sb(n)),m.FileOperationResult.FILE_MODIFIED_SINCE,u)}async createFile(n,u=E.$Se.fromString(""),r){await this.u(n,r);const f=await this.writeFile(n,u);return this.r.fire(new m.$xl(n,m.FileOperation.CREATE,f)),f}async writeFile(n,u,r){const f=this.qb(await this.n(n),n),{providerExtUri:h}=this.R(f);let k=r;if((0,m.$ol)(f)&&!k?.atomic){const P=f.enforceAtomicWriteFile?.(n);P&&(k={...r,atomic:P})}try{await this.w(f,n,k)||await this.U(f,h.dirname(n));let O;if((0,m.$il)(f)&&!(u instanceof E.$Se))if((0,a.$Ee)(u)){const C=await(0,a.$Le)(u,3);C.ended?O=E.$Se.concat(C.buffer):O=C}else O=(0,a.$Ie)(u,C=>E.$Se.concat(C),3);else O=u;!(0,m.$ll)(f)||(0,m.$il)(f)&&O instanceof E.$Se||(0,m.$il)(f)&&(0,m.$ol)(f)&&k?.atomic?await this.hb(f,n,k,O):await this.db(f,n,k,O instanceof E.$Se?(0,E.$4e)(O):O),this.r.fire(new m.$xl(n,m.FileOperation.WRITE))}catch(P){throw new m.$Al((0,c.localize)(1876,null,this.sb(n),(0,m.$tl)(P).toString()),(0,m.$wl)(P),k)}return this.resolve(n,{resolveMetadata:!0})}async w(n,u,r){const f=!!r?.unlock;if(f&&!(n.capabilities&m.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,c.localize)(1877,null,this.sb(u)));if(!!r?.atomic){if(!(n.capabilities&m.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,c.localize)(1878,null,this.sb(u)));if(!(n.capabilities&m.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,c.localize)(1879,null,this.sb(u)));if(f)throw new Error((0,c.localize)(1880,null,this.sb(u)))}let k;try{k=await n.stat(u)}catch{return}if(k.type&m.FileType.Directory)throw new m.$Al((0,c.localize)(1881,null,this.sb(u)),m.FileOperationResult.FILE_IS_DIRECTORY,r);if(this.rb(u,k),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==m.$Kl&&typeof k.mtime=="number"&&typeof k.size=="number"&&r.mtime<k.mtime&&r.etag!==(0,m.$Ll)({mtime:r.mtime,size:k.size}))throw new m.$Al((0,c.localize)(1882,null),m.FileOperationResult.FILE_MODIFIED_SINCE,r);return k}async readFile(n,u,r){const f=await this.m(n);return u?.atomic?this.z(f,n,u,r):this.C(f,n,u,r)}async z(n,u,r,f){return new Promise((h,k)=>{this.cb.queueFor(u,async()=>{try{const P=await this.C(n,u,r,f);h(P)}catch(P){k(P)}},this.R(n).providerExtUri)})}async C(n,u,r,f){const h=await this.D(n,u,{...r,preferUnbuffered:!0},f);return{...h,value:await(0,E.$5e)(h.value)}}async readFileStream(n,u,r){const f=await this.m(n);return this.D(f,n,u,r)}async D(n,u,r,f){const h=new I.$Be(f);let k=r;(0,m.$nl)(n)&&n.enforceAtomicReadFile?.(u)&&(k={...r,atomic:!0});const P=this.J(u,k).then(C=>C,C=>{throw h.dispose(!0),C});let O;try{return typeof k?.etag=="string"&&k.etag!==m.$Kl&&await P,k?.atomic&&(0,m.$nl)(n)||!((0,m.$ll)(n)||(0,m.$ml)(n))||(0,m.$il)(n)&&k?.preferUnbuffered?O=this.I(n,u,k):(0,m.$ml)(n)?O=this.G(n,u,h.token,k):O=this.H(n,u,h.token,k),O.on("end",()=>h.dispose()),O.on("error",()=>h.dispose()),{...await P,value:O}}catch(C){throw O&&await(0,a.$Je)(O),this.F(C,u,k)}}F(n,u,r){const f=(0,c.localize)(1883,null,this.sb(u),(0,m.$tl)(n).toString());return n instanceof m.$Cl?new m.$Cl(f,n.stat,r):n instanceof m.$Bl?new m.$Bl(f,n.fileOperationResult,n.size,n.options):new m.$Al(f,(0,m.$wl)(n),r)}G(n,u,r,f=Object.create(null)){const h=n.readFileStream(u,f,r);return(0,a.$Pe)(h,{data:k=>k instanceof E.$Se?k:E.$Se.wrap(k),error:k=>this.F(k,u,f)},k=>E.$Se.concat(k))}H(n,u,r,f=Object.create(null)){const h=(0,E.$9e)();return(0,b.$_q)(n,u,h,k=>k,{...f,bufferSize:this.a,errorTransformer:k=>this.F(k,u,f)},r),h}I(n,u,r){const f=(0,a.$Ge)(h=>E.$Se.concat(h));return(async()=>{try{let h;r?.atomic&&(0,m.$nl)(n)?h=await n.readFile(u,{atomic:!0}):h=await n.readFile(u),typeof r?.position=="number"&&(h=h.slice(r.position)),typeof r?.length=="number"&&(h=h.slice(0,r.length)),this.L(u,h.byteLength,r),f.end(E.$Se.wrap(h))}catch(h){f.error(h),f.end()}})(),f}async J(n,u){const r=await this.resolve(n,{resolveMetadata:!0});if(r.isDirectory)throw new m.$Al((0,c.localize)(1884,null,this.sb(n)),m.FileOperationResult.FILE_IS_DIRECTORY,u);if(typeof u?.etag=="string"&&u.etag!==m.$Kl&&u.etag===r.etag)throw new m.$Cl((0,c.localize)(1885,null),r,u);return this.L(n,r.size,u),r}L(n,u,r){if(typeof r?.limits?.size=="number"&&u>r.limits.size)throw new m.$Bl((0,c.localize)(1886,null,this.sb(n)),m.FileOperationResult.FILE_TOO_LARGE,u,r)}async canMove(n,u,r){return this.M(n,u,"move",r)}async canCopy(n,u,r){return this.M(n,u,"copy",r)}async M(n,u,r,f){if(n.toString()!==u.toString())try{const h=r==="move"?this.qb(await this.n(n),n):await this.m(n),k=this.qb(await this.n(u),u);await this.Q(h,n,k,u,r,f)}catch(h){return h}return!0}async move(n,u,r){const f=this.qb(await this.n(n),n),h=this.qb(await this.n(u),u),k=await this.N(f,n,h,u,"move",!!r),P=await this.resolve(u,{resolveMetadata:!0});return this.r.fire(new m.$xl(n,k==="move"?m.FileOperation.MOVE:m.FileOperation.COPY,P)),P}async copy(n,u,r){const f=await this.m(n),h=this.qb(await this.n(u),u),k=await this.N(f,n,h,u,"copy",!!r),P=await this.resolve(u,{resolveMetadata:!0});return this.r.fire(new m.$xl(n,k==="copy"?m.FileOperation.COPY:m.FileOperation.MOVE,P)),P}async N(n,u,r,f,h,k){if(u.toString()===f.toString())return h;const{exists:P,isSameResourceWithDifferentPathCase:O}=await this.Q(n,u,r,f,h,k);if(P&&!O&&k&&await this.del(f,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(f)),h==="copy"){if(n===r&&(0,m.$jl)(n))await n.copy(u,f,{overwrite:k});else{const C=await this.resolve(u);C.isDirectory?await this.P(n,C,r,f):await this.O(n,u,r,f)}return h}else return n===r?(await n.rename(u,f,{overwrite:k}),h):(await this.N(n,u,r,f,"copy",k),await this.del(u,{recursive:!0}),"copy")}async O(n,u,r,f){if((0,m.$ll)(n)&&(0,m.$ll)(r))return this.jb(n,u,r,f);if((0,m.$ll)(n)&&(0,m.$il)(r))return this.pb(n,u,r,f);if((0,m.$il)(n)&&(0,m.$ll)(r))return this.nb(n,u,r,f);if((0,m.$il)(n)&&(0,m.$il)(r))return this.lb(n,u,r,f)}async P(n,u,r,f){await r.mkdir(f),Array.isArray(u.children)&&await i.Promises.settled(u.children.map(async h=>{const k=this.R(r).providerExtUri.joinPath(f,h.name);return h.isDirectory?this.P(n,await this.resolve(h.resource),r,k):this.O(n,h.resource,r,k)}))}async Q(n,u,r,f,h,k){let P=!1;if(n===r){const{providerExtUri:C,isPathCaseSensitive:L}=this.R(n);if(L||(P=C.isEqual(u,f)),P&&h==="copy")throw new Error((0,c.localize)(1887,null,this.sb(u),this.sb(f)));if(!P&&C.isEqualOrParent(f,u))throw new Error((0,c.localize)(1888,null,this.sb(u),this.sb(f)))}const O=await this.exists(f);if(O&&!P){if(!k)throw new m.$Al((0,c.localize)(1889,null,this.sb(u),this.sb(f)),m.FileOperationResult.FILE_MOVE_CONFLICT);if(n===r){const{providerExtUri:C}=this.R(n);if(C.isEqualOrParent(u,f))throw new Error((0,c.localize)(1890,null,this.sb(u),this.sb(f)))}}return{exists:O,isSameResourceWithDifferentPathCase:P}}R(n){const u=this.S(n);return{providerExtUri:u?$.$bh:$.$dh,isPathCaseSensitive:u}}S(n){return!!(n.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const u=this.qb(await this.j(n),n);await this.U(u,n);const r=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new m.$xl(n,m.FileOperation.CREATE,r)),r}async U(n,u){const r=[],{providerExtUri:f}=this.R(n);for(;!f.isEqual(u,f.dirname(u));)try{if(!((await n.stat(u)).type&m.FileType.Directory))throw new Error((0,c.localize)(1891,null,this.sb(u)));break}catch(h){if((0,m.$vl)(h)!==m.FileSystemProviderErrorCode.FileNotFound)throw h;r.push(f.basename(u)),u=f.dirname(u)}for(let h=r.length-1;h>=0;h--){u=f.joinPath(u,r[h]);try{await n.mkdir(u)}catch(k){if((0,m.$vl)(k)!==m.FileSystemProviderErrorCode.FileExists)throw k}}}async canDelete(n,u){try{await this.W(n,u)}catch(r){return r}return!0}async W(n,u){const r=this.qb(await this.j(n),n),f=!!u?.useTrash;if(f&&!(r.capabilities&m.FileSystemProviderCapabilities.Trash))throw new Error((0,c.localize)(1892,null,this.sb(n)));const h=u?.atomic;if(h&&!(r.capabilities&m.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,c.localize)(1893,null,this.sb(n)));if(f&&h)throw new Error((0,c.localize)(1894,null,this.sb(n)));let k;try{k=await r.stat(n)}catch{}if(k)this.rb(n,k);else throw new m.$Al((0,c.localize)(1895,null,this.sb(n)),m.FileOperationResult.FILE_NOT_FOUND);if(!!!u?.recursive){const O=await this.resolve(n);if(O.isDirectory&&Array.isArray(O.children)&&O.children.length>0)throw new Error((0,c.localize)(1896,null,this.sb(n)))}return r}async del(n,u){const r=await this.W(n,u);let f=u;if((0,m.$pl)(r)&&!f?.atomic){const O=r.enforceAtomicDelete?.(n);O&&(f={...u,atomic:O})}const h=!!f?.useTrash,k=!!f?.recursive,P=f?.atomic??!1;await r.delete(n,{recursive:k,useTrash:h,atomic:P}),this.r.fire(new m.$xl(n,m.FileOperation.DELETE))}async cloneFile(n,u){const r=await this.j(n),f=this.qb(await this.n(u),u);if(!(r===f&&this.R(r).providerExtUri.isEqual(n,u)))return r===f&&(0,m.$kl)(r)?r.cloneFile(n,u):(await this.U(f,this.R(f).providerExtUri.dirname(u)),r===f&&(0,m.$jl)(r)?this.cb.queueFor(n,()=>r.copy(n,u,{overwrite:!0}),this.R(r).providerExtUri):this.cb.queueFor(n,()=>this.O(r,n,f,u),this.R(r).providerExtUri))}static{this.ab=0}createWatcher(n,u){return this.watch(n,{...u,correlationId:w.ab++})}watch(n,u={recursive:!1,excludes:[]}){const r=new s.$Yc;let f=!1,h=()=>{f=!0};r.add((0,s.$Xc)(()=>h())),(async()=>{try{const P=await this.bb(n,u);f?(0,s.$Uc)(P):h=()=>(0,s.$Uc)(P)}catch(P){this.b.error(P)}})();const k=u.correlationId;if(typeof k=="number"){const P=r.add(new D.$qe);return r.add(this.X.event(C=>{C.correlates(k)&&P.fire(C)})),{onDidChange:P.event,dispose:()=>r.dispose()}}return r}async bb(n,u){const r=await this.j(n),f=(0,T.$yj)([this.R(r).providerExtUri.getComparisonKey(n),u]);let h=this.$.get(f);return h||(h={count:0,disposable:r.watch(n,u)},this.$.set(f,h)),h.count+=1,(0,s.$Xc)(()=>{h&&(h.count--,h.count===0&&((0,s.$Uc)(h.disposable),this.$.delete(f)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,s.$Uc)(n.disposable);this.$.clear()}async db(n,u,r,f){return this.cb.queueFor(u,async()=>{const h=await n.open(u,{create:!0,unlock:r?.unlock??!1});try{(0,a.$Ee)(f)||(0,a.$Fe)(f)?await this.eb(n,h,f):await this.fb(n,h,f)}catch(k){throw(0,m.$tl)(k)}finally{await n.close(h)}},this.R(n).providerExtUri)}async eb(n,u,r){let f=0,h;if((0,a.$Fe)(r)){if(r.buffer.length>0){const k=E.$Se.concat(r.buffer);await this.gb(n,u,k,k.byteLength,f,0),f+=k.byteLength}if(r.ended)return;h=r.stream}else h=r;return new Promise((k,P)=>{(0,a.$Ke)(h,{onData:async O=>{h.pause();try{await this.gb(n,u,O,O.byteLength,f,0)}catch(C){return P(C)}f+=O.byteLength,setTimeout(()=>h.resume())},onError:O=>P(O),onEnd:()=>k()})})}async fb(n,u,r){let f=0,h;for(;(h=r.read())!==null;)await this.gb(n,u,h,h.byteLength,f,0),f+=h.byteLength}async gb(n,u,r,f,h,k){let P=0;for(;P<f;){const O=await n.write(u,h+P,r.buffer,k+P,f-P);P+=O}}async hb(n,u,r,f){return this.cb.queueFor(u,()=>this.ib(n,u,r,f),this.R(n).providerExtUri)}async ib(n,u,r,f){let h;f instanceof E.$Se?h=f:(0,a.$Ee)(f)?h=await(0,E.$5e)(f):(0,a.$Fe)(f)?h=await(0,E.$6e)(f):h=(0,E.$3e)(f),await n.writeFile(u,h.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async jb(n,u,r,f){return this.cb.queueFor(f,()=>this.kb(n,u,r,f),this.R(r).providerExtUri)}async kb(n,u,r,f){let h,k;try{h=await n.open(u,{create:!1}),k=await r.open(f,{create:!0,unlock:!1});const P=E.$Se.alloc(this.a);let O=0,C=0,L=0;do L=await n.read(h,O,P.buffer,C,P.byteLength-C),await this.gb(r,k,P,L,O,C),O+=L,C+=L,C===P.byteLength&&(C=0);while(L>0)}catch(P){throw(0,m.$tl)(P)}finally{await i.Promises.settled([typeof h=="number"?n.close(h):Promise.resolve(),typeof k=="number"?r.close(k):Promise.resolve()])}}async lb(n,u,r,f){return this.cb.queueFor(f,()=>this.mb(n,u,r,f),this.R(r).providerExtUri)}async mb(n,u,r,f){return r.writeFile(f,await n.readFile(u),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,u,r,f){return this.cb.queueFor(f,()=>this.ob(n,u,r,f),this.R(r).providerExtUri)}async ob(n,u,r,f){const h=await r.open(f,{create:!0,unlock:!1});try{const k=await n.readFile(u);await this.gb(r,h,E.$Se.wrap(k),k.byteLength,0,0)}catch(k){throw(0,m.$tl)(k)}finally{await r.close(h)}}async pb(n,u,r,f){const h=await(0,E.$5e)(this.H(n,u,I.CancellationToken.None));await this.hb(r,f,void 0,h)}qb(n,u){if(n.capabilities&m.FileSystemProviderCapabilities.Readonly)throw new m.$Al((0,c.localize)(1897,null,this.sb(u)),m.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,u){if((u.permissions??0)&m.FilePermission.Readonly)throw new m.$Al((0,c.localize)(1898,null,this.sb(n)),m.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===y.Schemas.file?n.fsPath:n.toString(!0)}};e.$ar=o,e.$ar=o=w=Ve([je(0,g.$fk)],o)}),define(Oe[73],Le([1,0,20,13,25,14,6,36,2,8,3,19,56,26,7,15,123,215,213,212]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;class w extends b.$mr{static{this.L=!1}constructor(l,n){super(l,n),this.onDidChangeCapabilities=D.Event.None,this.P=new E.$Fc(u=>y.$ch.getComparisonKey(u)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,S.$n&&(this.M|=c.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(l){try{const{stat:n,symbolicLink:u}=await $.SymlinkSupport.stat(this.I(l));return{type:this.O(n,u),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:c.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(l){try{return await this.stat(l)}catch{return}}async readdir(l){try{const n=await $.Promises.readdir(this.I(l),{withFileTypes:!0}),u=[];return await Promise.all(n.map(async r=>{try{let f;r.isSymbolicLink()?f=(await this.stat((0,y.$lh)(l,r.name))).type:f=this.O(r),u.push([r.name,f])}catch(f){this.a.trace(f)}})),u}catch(n){throw this.hb(n)}}O(l,n){let u;return n?.dangling?u=c.FileType.Unknown:l.isFile()?u=c.FileType.File:l.isDirectory()?u=c.FileType.Directory:u=c.FileType.Unknown,n&&(u|=c.FileType.SymbolicLink),u}async Q(l){const n=this.I(l);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let u;for(;u=this.P.get(l);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await u.wait();const r=new i.$Jh;return this.P.set(l,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,v.$Xc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(l)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(l)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(l,n){let u;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(l)})`),u=await this.Q(l));const r=this.I(l);return await t.promises.readFile(r)}catch(r){throw this.hb(r)}finally{u?.dispose()}}R(l){w.L&&this.a.trace(l)}readFileStream(l,n,u){const r=(0,p.$Ge)(f=>I.$Se.concat(f.map(h=>I.$Se.wrap(h))).buffer);return(0,m.$_q)(this,l,r,f=>f.buffer,{...n,bufferSize:256*1024},u),r}async writeFile(l,n,u){return u?.atomic!==!1&&u?.atomic?.postfix&&await this.S(l)?this.U(l,(0,y.$lh)((0,y.$kh)(l),`${(0,y.$ih)(l)}${u.atomic.postfix}`),n,u):this.W(l,n,u)}async S(l){try{const n=this.I(l),{symbolicLink:u}=await $.SymlinkSupport.stat(n);if(u)return!1}catch{}return!0}async U(l,n,u,r){const f=new v.$Yc;try{f.add(await this.Q(l)),f.add(await this.Q(n)),await this.W(n,u,r,!0);try{await this.rename(n,l,{overwrite:!0})}catch(h){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw h}}finally{f.dispose()}}async W(l,n,u,r){let f;try{const h=this.I(l);if(!u.create||!u.overwrite){if(await $.Promises.exists(h)){if(!u.overwrite)throw(0,c.$sl)((0,a.localize)(1902,null),c.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,c.$sl)((0,a.localize)(1903,null),c.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(l,{create:!0,unlock:u.unlock},r),await this.write(f,0,n,0,n.byteLength)}catch(h){throw await this.ib(l,h)}finally{typeof f=="number"&&await this.close(f)}}static{this.$=!0}static configureFlushOnWrite(l){w.$=l}async open(l,n,u){const r=this.I(l);let f;(0,c.$gl)(n)&&!u&&(f=await this.Q(l));let h;try{if((0,c.$gl)(n)&&n.unlock)try{const{stat:P}=await $.SymlinkSupport.stat(r);P.mode&128||await t.promises.chmod(r,P.mode|128)}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}let k;if((0,c.$gl)(n)){if(S.$l)try{await t.promises.truncate(r,0),k="r+"}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}k||(k="w")}else k="r";h=await $.Promises.open(r,k)}catch(k){throw f?.dispose(),(0,c.$gl)(n)?await this.ib(l,k):this.hb(k)}if(this.X.set(h,0),(0,c.$gl)(n)&&this.Z.set(h,l),f){const k=this.Y.get(h);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${h} (${r})`),this.Y.set(h,f),k&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${h} (${r})`),k.dispose())}return h}async close(l){const n=this.Y.get(l);try{if(this.X.delete(l),this.Z.delete(l)&&w.$)try{await $.Promises.fdatasync(l)}catch(u){w.configureFlushOnWrite(!1),this.a.error(u)}return await $.Promises.close(l)}catch(u){throw this.hb(u)}finally{n&&(this.Y.get(l)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${l}`),this.Y.delete(l)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${l}`),n.dispose())}}async read(l,n,u,r,f){const h=this.ab(l,n);let k=null;try{k=(await $.Promises.read(l,u,r,f,h)).bytesRead}catch(P){throw this.hb(P)}finally{this.bb(l,h,k)}return k}ab(l,n){return n===this.X.get(l)?null:n}bb(l,n,u){const r=this.X.get(l);typeof r=="number"&&(typeof n=="number"||(typeof u=="number"?this.X.set(l,r+u):this.X.delete(l)))}async write(l,n,u,r,f){return(0,i.$5h)(()=>this.cb(l,n,u,r,f),100,3)}async cb(l,n,u,r,f){const h=this.ab(l,n);let k=null;try{k=(await $.Promises.write(l,u,r,f,h)).bytesWritten}catch(P){throw await this.ib(this.Z.get(l),P)}finally{this.bb(l,h,k)}return k}async mkdir(l){try{await t.promises.mkdir(this.I(l))}catch(n){throw this.hb(n)}}async delete(l,n){try{const u=this.I(l);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,s.$oc)((0,s.$rc)(u),`${(0,s.$sc)(u)}${n.atomic.postfix}`)),await $.Promises.rm(u,$.RimRafMode.MOVE,r)}else try{await t.promises.unlink(u)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let f=!1;try{const{stat:h,symbolicLink:k}=await $.SymlinkSupport.stat(u);f=h.isDirectory()&&!k}catch{}if(f)await t.promises.rmdir(u);else throw r}else throw r}}catch(u){throw this.hb(u)}}async rename(l,n,u){const r=this.I(l),f=this.I(n);if(r!==f)try{await this.db(l,n,"move",u.overwrite),await $.Promises.rename(r,f)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,a.localize)(1904,null,(0,s.$sc)(r),(0,s.$sc)((0,s.$rc)(f)),h.toString()))),this.hb(h)}}async copy(l,n,u){const r=this.I(l),f=this.I(n);if(r!==f)try{await this.db(l,n,"copy",u.overwrite),await $.Promises.copy(r,f,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,a.localize)(1905,null,(0,s.$sc)(r),(0,s.$sc)((0,s.$rc)(f)),h.toString()))),this.hb(h)}}async db(l,n,u,r){const f=this.I(l),h=this.I(n);let k=!1;if(!!(this.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive)||(k=(0,T.$Ig)(f,h,!0)),k){if(u==="copy")throw(0,c.$sl)((0,a.localize)(1906,null),c.FileSystemProviderErrorCode.FileExists);if(u==="move")return}const O=await this.N(l);if(!O)throw(0,c.$sl)((0,a.localize)(1907,null),c.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(n);if(C){if(!r)throw(0,c.$sl)((0,a.localize)(1908,null),c.FileSystemProviderErrorCode.FileExists);O.type&c.FileType.File&&C.type&c.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(l,n){return this.eb(l,n,!1)}async eb(l,n,u){const r=this.I(l),f=this.I(n),h=!!(this.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.$Ig)(r,f,!h))return;const k=new v.$Yc;try{k.add(await this.Q(l)),k.add(await this.Q(n)),u&&await t.promises.mkdir((0,s.$rc)(f),{recursive:!0}),await t.promises.copyFile(r,f)}catch(P){if(P.code==="ENOENT"&&!u)return this.eb(l,n,!0);throw this.hb(P)}finally{k.dispose()}}t(l,n,u){return new g.$tr(r=>l(r),r=>n(r),u)}F(l,n,u){return new d.$Cr(r=>l(r),r=>n(r),u)}hb(l){if(l instanceof c.$rl)return l;let n=l,u;switch(l.code){case"ENOENT":u=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,u=c.FileSystemProviderErrorCode.Unknown;break;default:u=c.FileSystemProviderErrorCode.Unknown}return(0,c.$sl)(n,u)}async ib(l,n){let u=this.hb(n);if(l&&u.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.I(l));r.mode&128||(u=(0,c.$sl)(n,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return u}}e.$Dr=w}),define(Oe[216],Le([1,0,6,73,2,14,56,18]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=void 0;class v extends E.$Zc{constructor(y,p){super(),this.a=y,this.b=p,this.F=new Map,this.G=new Map}call(y,p,$){const a=this.c(y);switch(p){case"stat":return this.g(a,$[0]);case"readdir":return this.h(a,$[0]);case"open":return this.r(a,$[0],$[1]);case"close":return this.s($[0]);case"read":return this.t($[0],$[1],$[2]);case"readFile":return this.j(a,$[0],$[1]);case"write":return this.u($[0],$[1],$[2],$[3],$[4]);case"writeFile":return this.n(a,$[0],$[1],$[2]);case"rename":return this.z(a,$[0],$[1],$[2]);case"copy":return this.C(a,$[0],$[1],$[2]);case"cloneFile":return this.D(a,$[0],$[1]);case"mkdir":return this.w(a,$[0]);case"delete":return this.y(a,$[0],$[1]);case"watch":return this.I(a,$[0],$[1],$[2],$[3]);case"unwatch":return this.J($[0],$[1])}throw new Error(`IPC Command ${p} not found`)}listen(y,p,$){const a=this.c(y);switch(p){case"fileChange":return this.H(a,$[0]);case"readFileStream":return this.m(a,$[0],$[1])}throw new Error(`Unknown event ${p}`)}g(y,p){const $=this.f(y,p,!0);return this.a.stat($)}h(y,p){const $=this.f(y,p);return this.a.readdir($)}async j(y,p,$){const a=this.f(y,p,!0);this.b.trace(`File action: readFile ${a.path}`);const c=await this.a.readFile(a,$);return I.$Se.wrap(c)}m(y,p,$){const a=this.f(y,p,!0),c=new T.$Be,m=new t.$qe({onDidRemoveLastListener:()=>{c.cancel()}});this.b.trace(`File action: readFileStream ${a.path}`);const b=this.a.readFileStream(a,$,c.token);return(0,D.$Ke)(b,{onData:g=>m.fire(I.$Se.wrap(g)),onError:g=>m.fire(g),onEnd:()=>{m.fire("end"),m.dispose(),c.dispose()}}),m.event}n(y,p,$,a){const c=this.f(y,p);return this.b.trace(`File action: writeFile ${c.path}`),this.a.writeFile(c,$.buffer,a)}r(y,p,$){const a=this.f(y,p,!0);return this.a.open(a,$)}s(y){return this.a.close(y)}async t(y,p,$){const a=I.$Se.alloc($),m=await this.a.read(y,p,a.buffer,0,$);return[a,m]}u(y,p,$,a,c){return this.a.write(y,p,$.buffer,a,c)}w(y,p){const $=this.f(y,p);return this.a.mkdir($)}y(y,p,$){const a=this.f(y,p);return this.a.delete(a,$)}z(y,p,$,a){const c=this.f(y,p),m=this.f(y,$);return this.a.rename(c,m,a)}C(y,p,$,a){const c=this.f(y,p),m=this.f(y,$);return this.a.copy(c,m,a)}D(y,p,$){const a=this.f(y,p),c=this.f(y,$);return this.a.cloneFile(a,c)}H(y,p){const $=new t.$qe({onWillAddFirstListener:()=>{this.F.set(p,this.L(y,$))},onDidRemoveLastListener:()=>{(0,E.$Uc)(this.F.get(p)),this.F.delete(p)}});return $.event}async I(y,p,$,a,c){const m=this.F.get(p);if(m){const b=this.f(y,a),g=m.watch($,b,c);this.G.set(p+$,g)}}async J(y,p){const $=y+p,a=this.G.get($);a&&((0,E.$Uc)(a),this.G.delete($))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$bt=v;class s extends E.$Zc{constructor(y,p,$,a){super(),this.c=y,this.f=$,this.g=a,this.a=new Map,this.b=this.B(new i.$Dr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(p)}h(y){const p=this.B(new t.$qe);this.B(p.event($=>{y.fire($.map(a=>({resource:this.c.transformOutgoingURI(a.resource),type:a.type,cId:a.cId})))})),this.B(this.b.onDidChangeFile($=>p.fire($))),this.B(this.b.onDidWatchError($=>y.fire($)))}j(y){}m(y){}watch(y,p,$){const a=this.m(this.g);return Array.isArray(a)&&($.excludes=[...$.excludes,...a]),this.a.set(y,this.b.watch(p,$)),(0,E.$Xc)(()=>{(0,E.$Uc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$ct=s}),define(Oe[127],Le([1,0,4,6,11,2]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=e.$Es=e.$Ds=void 0;class D extends E.$qk{constructor(y,p,$,a,c){super(p,$,a),this.r=y,this.t=c,this.B(c.listen("onDidChangeLogLevel",y)(m=>{(0,E.$hk)(m)?super.setLogLevel(m):super.setLogLevel(t.URI.revive(m[0]),m[1])})),this.B(c.listen("onDidChangeVisibility",y)(([m,b])=>super.setVisibility(t.URI.revive(m),b))),this.B(c.listen("onDidChangeLoggers",y)(({added:m,removed:b})=>{for(const g of m)super.registerLogger({...g,resource:t.URI.revive(g.resource)});for(const g of b)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new E.$ok({log:(y,p)=>{this.t.call("consoleLog",[y,p])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,p){super.setLogLevel(y,p),this.t.call("setLogLevel",[y,p])}setVisibility(y,p){super.setVisibility(y,p),this.t.call("setVisibility",[this.n(y),p])}s(y,p,$){return new T(this.t,y,p,$,this.r)}static setLogLevel(y,p,$){return y.call("setLogLevel",[p,$])}}e.$Ds=D;class T extends E.$lk{constructor(y,p,$,a,c){super(a?.logLevel==="always"),this.r=y,this.s=p,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[p,a,c]).then(()=>{this.u(this.n),this.m=!0})}g(y,p){const $=[[y,p]];this.m?this.u($):this.n.push(...$)}u(y){this.r.call("log",[this.s,y])}}class v{constructor(y,p){this.a=y,this.b=p}listen(y,p){const $=this.b(y);switch(p){case"onDidChangeLoggers":return i.Event.map(this.a.onDidChangeLoggers,a=>({added:[...a.added].map(c=>this.c(c,$)),removed:[...a.removed].map(c=>this.c(c,$))}));case"onDidChangeVisibility":return i.Event.map(this.a.onDidChangeVisibility,a=>[$.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return i.Event.map(this.a.onDidChangeLogLevel,a=>(0,E.$hk)(a)?a:[$.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${p}`)}async call(y,p,$){const a=this.b(y);switch(p){case"setLogLevel":return(0,E.$hk)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(t.URI.revive(a.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(c=>this.c(c,a)))}throw new Error(`Call not found: ${p}`)}c(y,p){return{...y,resource:p.transformOutgoingURI(y.resource)}}}e.$Es=v;class s extends I.$Zc{constructor(y,p){super(),p.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel($=>p.call("setLogLevel",[$]))),p.call("getRegisteredLoggers").then($=>{for(const a of $)y.registerLogger({...a,resource:t.URI.revive(a.resource)})}),this.B(p.listen("onDidChangeVisibility")(([$,a])=>y.setVisibility(t.URI.revive($),a))),this.B(p.listen("onDidChangeLoggers")(({added:$,removed:a})=>{for(const c of $)y.registerLogger({...c,resource:t.URI.revive(c.resource)});for(const c of a)y.deregisterLogger(c.resource)}))}}e.$Fs=s}),define(Oe[128],Le([1,0,2,11]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dS=void 0;class E extends t.$Zc{constructor(D,T=[]){super(),this.a=new i.$pk([D,...T]),this.B(D.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...T){this.a.trace(D,...T)}debug(D,...T){this.a.debug(D,...T)}info(D,...T){this.a.info(D,...T)}warn(D,...T){this.a.warn(D,...T)}error(D,...T){this.a.error(D,...T)}flush(){this.a.flush()}}e.$dS=E}),define(Oe[217],Le([1,0,15,11]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5R=void 0;var E;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(E||(E={}));async function I(s,S,y,p,$){try{const a=await new Promise((m,b)=>{ue(["@vscode/spdlog"],m,b)}).then(We);a.setFlushOn(E.Trace);const c=await a.createAsyncRotatingLogger(s,S,y,p);return $?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(a){console.error(a)}return null}function D(s,S,y){switch(S){case i.LogLevel.Trace:s.trace(y);break;case i.LogLevel.Debug:s.debug(y);break;case i.LogLevel.Info:s.info(y);break;case i.LogLevel.Warning:s.warn(y);break;case i.LogLevel.Error:s.error(y);break;case i.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function T(s,S){switch(S){case i.LogLevel.Trace:s.setLevel(E.Trace);break;case i.LogLevel.Debug:s.setLevel(E.Debug);break;case i.LogLevel.Info:s.setLevel(E.Info);break;case i.LogLevel.Warning:s.setLevel(E.Warning);break;case i.LogLevel.Error:s.setLevel(E.Error);break;case i.LogLevel.Off:s.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class v extends i.$lk{constructor(S,y,p,$,a){super(),this.m=[],this.setLevel(a),this.n=this.s(S,y,p,$),this.B(this.onDidChangeLogLevel(c=>{this.r&&T(this.r,c)}))}async s(S,y,p,$){const a=p?6:1,c=30/a*t.$Nl.MB,m=await I(S,y,c,a,$);if(m){this.r=m,T(this.r,this.getLevel());for(const{level:b,message:g}of this.m)D(this.r,b,g);this.m=[]}}g(S,y){this.r?D(this.r,S,y):this.getLevel()<=S&&this.m.push({level:S,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$5R=v}),define(Oe[129],Le([1,0,23,11,217]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6R=void 0;class I extends i.$qk{s(T,v,s){return new E.$5R((0,t.$7g)(),T.fsPath,!s?.donotRotate,!!s?.donotUseFormatters,v)}}e.$6R=I});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[218],Le([1,0,58,7,5]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,t=$t(t);var I;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var D;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(D||(e.MarkerSeverity=D={})),function(v){function s(a,c){return c-a}v.compare=s;const S=Object.create(null);S[v.Error]=(0,i.localize)(1966,null),S[v.Warning]=(0,i.localize)(1967,null),S[v.Info]=(0,i.localize)(1968,null);function y(a){return S[a]||""}v.toString=y;function p(a){switch(a){case t.default.Error:return v.Error;case t.default.Warning:return v.Warning;case t.default.Info:return v.Info;case t.default.Ignore:return v.Hint}}v.fromSeverity=p;function $(a){switch(a){case v.Error:return t.default.Error;case v.Warning:return t.default.Warning;case v.Info:return t.default.Info;case v.Hint:return t.default.Ignore}}v.toSeverity=$}(D||(e.MarkerSeverity=D={}));var T;(function(v){const s="";function S(p){return y(p,!0)}v.makeKey=S;function y(p,$){const a=[s];return p.source?a.push(p.source.replace("\xA6","\\\xA6")):a.push(s),p.code?typeof p.code=="string"?a.push(p.code.replace("\xA6","\\\xA6")):a.push(p.code.value.replace("\xA6","\\\xA6")):a.push(s),p.severity!==void 0&&p.severity!==null?a.push(D.toString(p.severity)):a.push(s),p.message&&$?a.push(p.message.replace("\xA6","\\\xA6")):a.push(s),p.startLineNumber!==void 0&&p.startLineNumber!==null?a.push(p.startLineNumber.toString()):a.push(s),p.startColumn!==void 0&&p.startColumn!==null?a.push(p.startColumn.toString()):a.push(s),p.endLineNumber!==void 0&&p.endLineNumber!==null?a.push(p.endLineNumber.toString()):a.push(s),p.endColumn!==void 0&&p.endColumn!==null?a.push(p.endColumn.toString()):a.push(s),a.push(s),a.join("\xA6")}v.makeKeyOptionalMessage=y})(T||(e.IMarkerData=T={})),e.$Qu=(0,E.$Ki)("markerService")}),define(Oe[74],Le([1,0,6,39,2,5]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=void 0,e.$Bo=(0,I.$Ki)("policy");class D extends E.$Zc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new t.$qe),this.onDidChange=this.h.event}async updatePolicyDefinitions(s){const S=Object.keys(this.f).length;return this.f={...s,...this.f},S!==Object.keys(this.f).length&&await this.j(s),i.Iterable.reduce(this.g.entries(),(y,[p,$])=>({...y,[p]:$}),{})}getPolicyValue(s){return this.g.get(s)}serialize(){return i.Iterable.reduce(Object.entries(this.f),(s,[S,y])=>({...s,[S]:{definition:y,value:this.g.get(S)}}),{})}}e.$Co=D;class T{constructor(){this.onDidChange=t.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Do=T}),define(Oe[62],Le([1,0,32]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const I=E.context.configuration();if(I)i=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(i=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`,serverDataFolderName:i.serverDataFolderName?`${i.serverDataFolderName}-dev`:void 0}),!i.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(i,{version:I.version})}Object.assign(i,{extensionsGallery:t.env.EXTENSIONS_GALLERY?JSON.parse(t.env.EXTENSIONS_GALLERY):i.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""},telemetryEndpoint:t.env.CS_TELEMETRY_URL||i.telemetryEndpoint||"https://v1.telemetry.coder.com/track"})}else i={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.3",sha256:"7380a890787452f14b2db7835dfa94de538caf358ebc263f9d46dd68ac52de93",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.93.0",sha256:"9339cb8e6b77f554df54d79e71f533279cb76b0f9b04c207f633bfd507442b6a",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.93.1",commit:"3542bd157b0ccc8bf732acdb03d4d69d85f48ea9",date:"2024-09-19T10:15:30.023Z"},Object.keys(i).length===0&&Object.assign(i,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=i}),define(Oe[29],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=void 0,e.$yk=(0,t.$Ki)("productService"),e.$zk="vscode://schemas/vscode-product"}),define(Oe[219],Le([1,0,13,18,2,5]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ow=e.$Nw=e.$Mw=e.$Lw=e.$Kw=e.$Jw=e.ProgressLocation=e.$Iw=void 0,e.$Iw=(0,I.$Ki)("progressService");var D;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(D||(e.ProgressLocation=D={})),e.$Jw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$Kw=T;class v{get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const $=this.d;this.d=()=>{$?.(),p()}}):Promise.resolve()}}e.$Lw=v;let s=class extends E.$Zc{constructor(p,$){super(),this.a=new t.$8h,$.withProgress(p,a=>(this.b=a,this.c&&a.report(this.c),this.a.p)),this.B((0,E.$Xc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$Mw=s,e.$Mw=s=Ve([je(1,e.$Iw)],s);class S extends E.$Zc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new E.$Yc)}start(p){this.stop();const $=++this.a,a=new i.$Be;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,E.$Xc)(()=>clearTimeout(this.f))),this.b.add((0,E.$Xc)(()=>a.cancel())),this.b.add((0,E.$Xc)(()=>this.c?this.c.done():void 0)),{id:$,token:a.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$Nw=S,e.$Ow=(0,I.$Ki)("editorProgressService")}),define(Oe[37],Le([1,0,106,10]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=void 0,t=We(t),i=We(i);class E{constructor(){this.a=new Map}add(D,T){t.ok(i.$jg(D)),t.ok(i.$lg(T)),t.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,T)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$zo=new E}),define(Oe[130],Le([1,0,6,163,37]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=void 0,E=We(E),e.$Ao={JSONContribution:"base.contributions.json"};function I(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class D{constructor(){this.b=new t.$qe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(s,S){this.a[I(s)]=S,this.b.fire(s)}notifySchemaChanged(s){this.b.fire(s)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(s){const S=this.a[s];return S?(0,i.$ak)(S):void 0}hasSchemaContent(s){return!!this.a[s]}}const T=new D;E.$zo.add(e.$Ao.JSONContribution,T)}),define(Oe[46],Le([1,0,17,6,10,7,28,130,37]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.ConfigurationScope=e.$Eo=e.EditPresentationTypes=void 0,e.$Po=c,e.$Qo=m,e.$Ro=b,e.$So=d,e.$To=w,e.$Uo=o,e.$Vo=l,E=We(E),I=We(I);var s;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$Eo={Configuration:"base.contributions.configuration"};var S;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho={properties:{},patternProperties:{}},e.$Io={properties:{},patternProperties:{}},e.$Jo={properties:{},patternProperties:{}},e.$Ko={properties:{},patternProperties:{}},e.$Lo="vscode://schemas/settings/resourceLanguage",e.$Mo="vscode://schemas/settings/configurationDefaults";const y=v.$zo.as(T.$Ao.JSONContribution);class p{constructor(){this.a=[],this.i=new Set,this.j=new i.$qe,this.onDidSchemaChange=this.j.event,this.k=new i.$qe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:I.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},y.registerSchema(e.$Lo,this.h),this.z()}registerConfiguration(u,r=!0){this.registerConfigurations([u],r)}registerConfigurations(u,r=!0){const f=new Set;this.r(u,r,f),y.registerSchema(e.$Lo,this.h),this.j.fire(),this.k.fire({properties:f})}deregisterConfigurations(u){const r=new Set;this.s(u,r),y.registerSchema(e.$Lo,this.h),this.j.fire(),this.k.fire({properties:r})}updateConfigurations({add:u,remove:r}){const f=new Set;this.s(r,f),this.r(u,!1,f),y.registerSchema(e.$Lo,this.h),this.j.fire(),this.k.fire({properties:f})}registerDefaultConfigurations(u){const r=new Set;this.l(u,r),this.j.fire(),this.k.fire({properties:r,defaultsOverrides:!0})}l(u,r){this.a.push(...u);const f=[];for(const{overrides:h,source:k}of u)for(const P in h){r.add(P);const O=this.b.get(P)??this.b.set(P,{configurationDefaultOverrides:[]}).get(P),C=h[P];if(O.configurationDefaultOverrides.push({value:C,source:k}),e.$Oo.test(P)){const L=this.o(P,C,k,O.configurationDefaultOverrideValue);if(!L)continue;O.configurationDefaultOverrideValue=L,this.n(P,L,k),f.push(...c(P))}else{const L=this.p(P,C,k,O.configurationDefaultOverrideValue);if(!L)continue;O.configurationDefaultOverrideValue=L;const R=this.e[P];R&&(this.A(P,R),this.w(P,R))}}this.q(f)}deregisterDefaultConfigurations(u){const r=new Set;this.m(u,r),this.j.fire(),this.k.fire({properties:r,defaultsOverrides:!0})}m(u,r){for(const f of u){const h=this.a.indexOf(f);h!==-1&&this.a.splice(h,1)}for(const{overrides:f,source:h}of u)for(const k in f){const P=this.b.get(k);if(!P)continue;const O=P.configurationDefaultOverrides.findIndex(C=>h?C.source?.id===h.id:C.value===f[k]);if(O!==-1){if(P.configurationDefaultOverrides.splice(O,1),P.configurationDefaultOverrides.length===0&&this.b.delete(k),e.$Oo.test(k)){let C;for(const L of P.configurationDefaultOverrides)C=this.o(k,L.value,L.source,C);C&&!E.$wg(C.value)?(P.configurationDefaultOverrideValue=C,this.n(k,C,h)):(this.b.delete(k),delete this.e[k],delete this.c.properties[k])}else{let C;for(const R of P.configurationDefaultOverrides)C=this.p(k,R.value,R.source,C);P.configurationDefaultOverrideValue=C;const L=this.e[k];L&&(this.A(k,L),this.w(k,L))}r.add(k)}}this.y()}n(u,r,f){const h={type:"object",default:r.value,description:I.localize(1663,null,(0,D.$oj)(u)),$ref:e.$Lo,defaultDefaultValue:r.value,source:f,defaultValueSource:f};this.e[u]=h,this.c.properties[u]=h}o(u,r,f,h){const k=h?.value||{},P=h?.source??new Map;if(!(P instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const O of Object.keys(r)){const C=r[O];if(E.$lg(C)&&(E.$qg(k[O])||E.$lg(k[O]))){if(k[O]={...k[O]??{},...C},f)for(const R in C)P.set(`${O}.${R}`,f)}else k[O]=C,f?P.set(O,f):P.delete(O)}return{value:k,source:P}}p(u,r,f,h){const k=this.e[u],P=h?.value??k?.defaultDefaultValue;let O=f;if(E.$lg(r)&&(k!==void 0&&k.type==="object"||k===void 0&&(E.$qg(P)||E.$lg(P)))){if(O=h?.source??new Map,!(O instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const L in r)f&&O.set(`${u}.${L}`,f);r={...E.$lg(P)?P:{},...r}}return{value:r,source:O}}deltaConfiguration(u){let r=!1;const f=new Set;u.removedDefaults&&(this.m(u.removedDefaults,f),r=!0),u.addedDefaults&&(this.l(u.addedDefaults,f),r=!0),u.removedConfigurations&&this.s(u.removedConfigurations,f),u.addedConfigurations&&this.r(u.addedConfigurations,!1,f),this.j.fire(),this.k.fire({properties:f,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...u){this.j.fire()}registerOverrideIdentifiers(u){this.q(u),this.j.fire()}q(u){for(const r of u)this.i.add(r);this.y()}r(u,r,f){u.forEach(h=>{this.u(h,r,h.extensionInfo,h.restrictedProperties,void 0,f),this.d.push(h),this.v(h)})}s(u,r){const f=h=>{if(h.properties)for(const k in h.properties){r.add(k);const P=this.e[k];P?.policy?.name&&this.f.delete(P.policy.name),delete this.e[k],this.x(k,h.properties[k])}h.allOf?.forEach(k=>f(k))};for(const h of u){f(h);const k=this.d.indexOf(h);k!==-1&&this.d.splice(k,1)}}u(u,r=!0,f,h,k=S.WINDOW,P){k=E.$sg(u.scope)?k:u.scope;const O=u.properties;if(O)for(const L in O){const R=O[L];if(r&&d(L,R)){delete O[L];continue}if(R.source=f,R.defaultDefaultValue=O[L].default,this.A(L,R),e.$Oo.test(L)?R.scope=void 0:(R.scope=E.$sg(R.scope)?k:R.scope,R.restricted=E.$sg(R.restricted)?!!h?.includes(L):R.restricted),O[L].hasOwnProperty("included")&&!O[L].included){this.g[L]=O[L],delete O[L];continue}else this.e[L]=O[L],O[L].policy?.name&&this.f.set(O[L].policy.name,L);!O[L].deprecationMessage&&O[L].markdownDeprecationMessage&&(O[L].deprecationMessage=O[L].markdownDeprecationMessage),P.add(L)}const C=u.allOf;if(C)for(const L of C)this.u(L,r,f,h,k,P)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const u=new Map;for(const[r,f]of this.b)f.configurationDefaultOverrideValue&&u.set(r,f.configurationDefaultOverrideValue);return u}v(u){const r=f=>{const h=f.properties;if(h)for(const P in h)this.w(P,h[P]);f.allOf?.forEach(r)};r(u)}w(u,r){switch(e.$Fo.properties[u]=r,r.scope){case S.APPLICATION:e.$Go.properties[u]=r;break;case S.MACHINE:e.$Ho.properties[u]=r;break;case S.MACHINE_OVERRIDABLE:e.$Io.properties[u]=r;break;case S.WINDOW:e.$Jo.properties[u]=r;break;case S.RESOURCE:e.$Ko.properties[u]=r;break;case S.LANGUAGE_OVERRIDABLE:e.$Ko.properties[u]=r,this.h.properties[u]=r;break}}x(u,r){switch(delete e.$Fo.properties[u],r.scope){case S.APPLICATION:delete e.$Go.properties[u];break;case S.MACHINE:delete e.$Ho.properties[u];break;case S.MACHINE_OVERRIDABLE:delete e.$Io.properties[u];break;case S.WINDOW:delete e.$Jo.properties[u];break;case S.RESOURCE:case S.LANGUAGE_OVERRIDABLE:delete e.$Ko.properties[u],delete this.h.properties[u];break}}y(){for(const u of this.i.values()){const r=`[${u}]`,f={type:"object",description:I.localize(1664,null),errorMessage:I.localize(1665,null),$ref:e.$Lo};this.A(r,f),e.$Fo.properties[r]=f,e.$Go.properties[r]=f,e.$Ho.properties[r]=f,e.$Io.properties[r]=f,e.$Jo.properties[r]=f,e.$Ko.properties[r]=f}}z(){const u={type:"object",description:I.localize(1666,null),errorMessage:I.localize(1667,null),$ref:e.$Lo};e.$Fo.patternProperties[e.$No]=u,e.$Go.patternProperties[e.$No]=u,e.$Ho.patternProperties[e.$No]=u,e.$Io.patternProperties[e.$No]=u,e.$Jo.patternProperties[e.$No]=u,e.$Ko.patternProperties[e.$No]=u,this.j.fire()}A(u,r){const f=this.b.get(u)?.configurationDefaultOverrideValue;let h,k;f&&(!r.disallowConfigurationDefault||!f.source)&&(h=f.value,k=f.source),E.$qg(h)&&(h=r.defaultDefaultValue,k=void 0),E.$qg(h)&&(h=b(r.type)),r.default=h,r.defaultValueSource=k}}const $="\\[([^\\]]+)\\]",a=new RegExp($,"g");e.$No=`^(${$})+$`,e.$Oo=new RegExp(e.$No);function c(n){const u=[];if(e.$Oo.test(n)){let r=a.exec(n);for(;r?.length;){const f=r[1].trim();f&&u.push(f),r=a.exec(n)}}return(0,t.$Qb)(u)}function m(n){return n.reduce((u,r)=>`${u}[${r}]`,"")}function b(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new p;v.$zo.add(e.$Eo.Configuration,g);function d(n,u){return n.trim()?e.$Oo.test(n)?I.localize(1669,null,n):g.getConfigurationProperties()[n]!==void 0?I.localize(1670,null,n):u.policy?.name&&g.getPolicyConfigurations().get(u.policy?.name)!==void 0?I.localize(1671,null,n,u.policy?.name,g.getPolicyConfigurations().get(u.policy?.name)):null:I.localize(1668,null)}function w(){const n=[],u=g.getConfigurationProperties();for(const r of Object.keys(u))n.push([r,u[r].scope]);return n.push(["launch",S.RESOURCE]),n.push(["task",S.RESOURCE]),n}function o(n){const u={};for(const r of n){const f=r.properties;if(E.$lg(f))for(const h in f)u[h]=f[h];r.allOf&&Object.assign(u,o(r.allOf))}return u}function l(n){switch(n){case"application":return S.APPLICATION;case"machine":return S.MACHINE;case"resource":return S.RESOURCE;case"machine-overridable":return S.MACHINE_OVERRIDABLE;case"language-overridable":return S.LANGUAGE_OVERRIDABLE;default:return S.WINDOW}}}),define(Oe[131],Le([1,0,17,6,42,2,25,21,10,4,28,46,15,37]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$1o=w,t=We(t),E=We(E),T=We(T),v=We(v);function a(u){return Object.isFrozen(u)?u:T.$no(u)}class c{static createEmptyModel(r){return new c({},[],[],void 0,r)}constructor(r,f,h,k,P){this.b=r,this.c=f,this.d=h,this.raw=k,this.f=P,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(f=>{if(f instanceof c)return f;const h=new m("",this.f);return h.parseRaw(f),h.configurationModel});this.g=r.reduce((f,h)=>h===f?h:f.merge(h),r[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,S.$mj)(this.contents,r):this.contents}inspect(r,f){const h=this;return{get value(){return a(h.rawConfiguration.getValue(r))},get override(){return f?a(h.rawConfiguration.getOverrideValue(r,f)):void 0},get merged(){return a(f?h.rawConfiguration.override(f).getValue(r):h.rawConfiguration.getValue(r))},get overrides(){const k=[];for(const{contents:P,identifiers:O,keys:C}of h.rawConfiguration.overrides){const L=new c(P,C,[],void 0,h.f).getValue(r);L!==void 0&&k.push({identifiers:O,value:L})}return k.length?a(k):void 0}}}getOverrideValue(r,f){const h=this.j(f);return h?r?(0,S.$mj)(h,r):h:void 0}getKeysForOverrideIdentifier(r){const f=[];for(const h of this.overrides)h.identifiers.includes(r)&&f.push(...h.keys);return t.$Qb(f)}getAllOverrideIdentifiers(){const r=[];for(const f of this.overrides)r.push(...f.identifiers);return t.$Qb(r)}override(r){let f=this.a.get(r);return f||(f=this.h(r),this.a.set(r,f)),f}merge(...r){const f=T.$mo(this.contents),h=T.$mo(this.overrides),k=[...this.keys],P=this.raw?.length?[...this.raw]:[this];for(const O of r)if(P.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.i(f,O.contents);for(const C of O.overrides){const[L]=h.filter(R=>t.$yb(R.identifiers,C.identifiers));L?(this.i(L.contents,C.contents),L.keys.push(...C.keys),L.keys=t.$Qb(L.keys)):h.push(T.$mo(C))}for(const C of O.keys)k.indexOf(C)===-1&&k.push(C)}return new c(f,k,h,P.every(O=>O instanceof c)?void 0:P,this.f)}h(r){const f=this.j(r);if(!f||typeof f!="object"||!Object.keys(f).length)return this;const h={};for(const k of t.$Qb([...Object.keys(this.contents),...Object.keys(f)])){let P=this.contents[k];const O=f[k];O&&(typeof P=="object"&&typeof O=="object"?(P=T.$mo(P),this.i(P,O)):P=O),h[k]=P}return new c(h,this.keys,this.overrides,void 0,this.f)}i(r,f){for(const h of Object.keys(f)){if(h in r&&v.$lg(r[h])&&v.$lg(f[h])){this.i(r[h],f[h]);continue}r[h]=T.$mo(f[h])}}j(r){let f=null,h=null;const k=P=>{P&&(h?this.i(h,P):h=T.$mo(P))};for(const P of this.overrides)P.identifiers.length===1&&P.identifiers[0]===r?f=P.contents:P.identifiers.includes(r)&&k(P.contents);return k(f),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,f){this.k(r,f,!0)}setValue(r,f){this.k(r,f,!1)}removeValue(r){const f=this.keys.indexOf(r);f!==-1&&(this.keys.splice(f,1),(0,S.$lj)(this.contents,r),y.$Oo.test(r)&&this.overrides.splice(this.overrides.findIndex(h=>t.$yb(h.identifiers,(0,y.$Po)(r))),1))}k(r,f,h){if((0,S.$kj)(this.contents,r,f,k=>this.f.error(k)),h=h||this.keys.indexOf(r)===-1,h&&this.keys.push(r),y.$Oo.test(r)){const k=(0,y.$Po)(r),P={identifiers:k,keys:Object.keys(this.contents[r]),contents:(0,S.$jj)(this.contents[r],C=>this.f.error(C))},O=this.overrides.findIndex(C=>t.$yb(C.identifiers,k));O!==-1?this.overrides[O]=P:this.overrides.push(P)}}}e.$Wo=c;class m{constructor(r,f){this.f=r,this.g=f,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,f){if(!v.$sg(r)){const h=this.h(r);this.parseRaw(h,f)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,f){this.a=r;const{contents:h,keys:k,overrides:P,restricted:O,hasExcludedProperties:C}=this.i(r,f);this.b=new c(h,k,P,C?[r]:void 0,this.g),this.c=O||[]}h(r){let f={},h=null,k=[];const P=[],O=[];function C(R){Array.isArray(k)?k.push(R):h!==null&&(k[h]=R)}const L={onObjectBegin:()=>{const R={};C(R),P.push(k),k=R,h=null},onObjectProperty:R=>{h=R},onObjectEnd:()=>{k=P.pop()},onArrayBegin:()=>{const R=[];C(R),P.push(k),k=R,h=null},onArrayEnd:()=>{k=P.pop()},onLiteralValue:C,onError:(R,z,Q)=>{O.push({error:R,offset:z,length:Q})}};if(r)try{E.$bo(r,L),f=k[0]||{}}catch(R){this.g.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return f}i(r,f){const h=$.$zo.as(y.$Eo.Configuration).getConfigurationProperties(),k=this.j(r,h,!0,f);r=k.raw;const P=(0,S.$jj)(r,L=>this.g.error(`Conflict in settings file ${this.f}: ${L}`)),O=Object.keys(r),C=this.l(r,L=>this.g.error(`Conflict in settings file ${this.f}: ${L}`));return{contents:P,keys:O,overrides:C,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(r,f,h,k){let P=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:P};const O={},C=[];for(const L in r)if(y.$Oo.test(L)&&h){const R=this.j(r[L],f,!1,k);O[L]=R.raw,P=P||R.hasExcludedProperties,C.push(...R.restricted)}else{const R=f[L],z=R?typeof R.scope<"u"?R.scope:y.ConfigurationScope.WINDOW:void 0;R?.restricted&&C.push(L),!k.exclude?.includes(L)&&(k.include?.includes(L)||(z===void 0||k.scopes===void 0||k.scopes.includes(z))&&!(k.skipRestricted&&R?.restricted))?O[L]=r[L]:P=!0}return{raw:O,restricted:C,hasExcludedProperties:P}}l(r,f){const h=[];for(const k of Object.keys(r))if(y.$Oo.test(k)){const P={};for(const O in r[k])P[O]=r[k][O];h.push({identifiers:(0,y.$Po)(k),keys:Object.keys(P),contents:(0,S.$jj)(P,f)})}return h}}e.$Xo=m;class b extends I.$Zc{constructor(r,f,h,k,P){super(),this.c=r,this.f=f,this.g=k,this.h=P,this.b=this.B(new i.$qe),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),P),this.B(this.g.watch(h.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(i.Event.any(i.Event.filter(this.g.onDidFilesChange,O=>O.contains(this.c)),i.Event.filter(this.g.onDidRunOperation,O=>(O.isOperation(p.FileOperation.CREATE)||O.isOperation(p.FileOperation.COPY)||O.isOperation(p.FileOperation.DELETE)||O.isOperation(p.FileOperation.WRITE))&&h.isEqual(O.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Yo=b;class g{constructor(r,f,h,k,P,O,C,L,R,z,Q,J,x){this.a=r,this.b=f,this.c=h,this.overrideIdentifiers=k,this.d=P,this.f=O,this.g=C,this.h=L,this.i=R,this.j=z,this.k=Q,this.l=J,this.m=x}get value(){return a(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class d{constructor(r,f,h,k,P,O,C,L,R,z){this.j=r,this.l=f,this.m=h,this.n=k,this.p=P,this.q=O,this.r=C,this.s=L,this.t=R,this.u=z,this.h=null,this.i=new D.$Fc,this.v=null}getValue(r,f,h){return this.w(r,f,h).getValue(r)}updateValue(r,f,h={}){let k;h.resource?(k=this.t.get(h.resource),k||(k=c.createEmptyModel(this.u),this.t.set(h.resource,k))):k=this.s,f===void 0?k.removeValue(r):k.setValue(r,f),h.resource||(this.h=null)}inspect(r,f,h){const k=this.w(r,f,h),P=this.A(f.resource,h),O=f.resource?this.t.get(f.resource)||this.s:this.s,C=new Set;for(const L of k.overrides)for(const R of L.identifiers)k.getOverrideValue(r,R)!==void 0&&C.add(R);return new g(r,f,k.getValue(r),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,h?this.q:void 0,P||void 0,O)}keys(r){const f=this.A(void 0,r);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:f?f.keys.slice(0):[]}}updateDefaultConfiguration(r){this.j=r,this.h=null,this.i.clear()}updatePolicyConfiguration(r){this.l=r}updateApplicationConfiguration(r){this.m=r,this.h=null,this.i.clear()}updateLocalUserConfiguration(r){this.n=r,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(r){this.p=r,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(r){this.q=r,this.h=null,this.i.clear()}updateFolderConfiguration(r,f){this.r.set(r,f),this.i.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.i.delete(r)}compareAndUpdateDefaultConfiguration(r,f){const h=[];if(!f){const{added:k,updated:P,removed:O}=l(this.j,r);f=[...k,...P,...O]}for(const k of f)for(const P of(0,y.$Po)(k)){const O=this.j.getKeysForOverrideIdentifier(P),C=r.getKeysForOverrideIdentifier(P),L=[...C.filter(R=>O.indexOf(R)===-1),...O.filter(R=>C.indexOf(R)===-1),...O.filter(R=>!T.$qo(this.j.override(P).getValue(R),r.override(P).getValue(R)))];h.push([P,L])}return this.updateDefaultConfiguration(r),{keys:f,overrides:h}}compareAndUpdatePolicyConfiguration(r){const{added:f,updated:h,removed:k}=l(this.l,r),P=[...f,...h,...k];return P.length&&this.updatePolicyConfiguration(r),{keys:P,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:f,updated:h,removed:k,overrides:P}=l(this.applicationConfiguration,r),O=[...f,...h,...k];return O.length&&this.updateApplicationConfiguration(r),{keys:O,overrides:P}}compareAndUpdateLocalUserConfiguration(r){const{added:f,updated:h,removed:k,overrides:P}=l(this.localUserConfiguration,r),O=[...f,...h,...k];return O.length&&this.updateLocalUserConfiguration(r),{keys:O,overrides:P}}compareAndUpdateRemoteUserConfiguration(r){const{added:f,updated:h,removed:k,overrides:P}=l(this.remoteUserConfiguration,r),O=[...f,...h,...k];return O.length&&this.updateRemoteUserConfiguration(r),{keys:O,overrides:P}}compareAndUpdateWorkspaceConfiguration(r){const{added:f,updated:h,removed:k,overrides:P}=l(this.workspaceConfiguration,r),O=[...f,...h,...k];return O.length&&this.updateWorkspaceConfiguration(r),{keys:O,overrides:P}}compareAndUpdateFolderConfiguration(r,f){const h=this.folderConfigurations.get(r),{added:k,updated:P,removed:O,overrides:C}=l(h,f),L=[...k,...P,...O];return(L.length||!h)&&this.updateFolderConfiguration(r,f),{keys:L,overrides:C}}compareAndDeleteFolderConfiguration(r){const f=this.folderConfigurations.get(r);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:h,updated:k,removed:P,overrides:O}=l(f,void 0);return{keys:[...h,...k,...P],overrides:O}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(r,f,h){let k=this.x(f,h);return f.overrideIdentifier&&(k=k.override(f.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(r)!==void 0&&(k=k.merge(this.l)),k}x({resource:r},f){let h=this.y();if(f&&r){const k=f.getFolder(r);k&&(h=this.z(k.uri)||h);const P=this.t.get(r);P&&(h=h.merge(P))}return h}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(r){let f=this.i.get(r);if(!f){const h=this.y(),k=this.r.get(r);k?(f=h.merge(k),this.i.set(r,f)):f=h}return f}A(r,f){if(f&&r){const h=f.getFolder(r);if(h)return this.r.get(h.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((r,f)=>{const{contents:h,overrides:k,keys:P}=this.r.get(f);return r.push([f,{contents:h,overrides:k,keys:P}]),r},[])}}allKeys(){const r=new Set;return this.j.keys.forEach(f=>r.add(f)),this.userConfiguration.keys.forEach(f=>r.add(f)),this.q.keys.forEach(f=>r.add(f)),this.r.forEach(f=>f.keys.forEach(h=>r.add(h))),[...r.values()]}B(){const r=new Set;return this.j.getAllOverrideIdentifiers().forEach(f=>r.add(f)),this.userConfiguration.getAllOverrideIdentifiers().forEach(f=>r.add(f)),this.q.getAllOverrideIdentifiers().forEach(f=>r.add(f)),this.r.forEach(f=>f.getAllOverrideIdentifiers().forEach(h=>r.add(h))),[...r.values()]}D(r){const f=new Set;return this.j.getKeysForOverrideIdentifier(r).forEach(h=>f.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(h=>f.add(h)),this.q.getKeysForOverrideIdentifier(r).forEach(h=>f.add(h)),this.r.forEach(h=>h.getKeysForOverrideIdentifier(r).forEach(k=>f.add(k))),[...f.values()]}static parse(r,f){const h=this.E(r.defaults,f),k=this.E(r.policy,f),P=this.E(r.application,f),O=this.E(r.user,f),C=this.E(r.workspace,f),L=r.folders.reduce((R,z)=>(R.set(s.URI.revive(z[0]),this.E(z[1],f)),R),new D.$Fc);return new d(h,k,P,O,c.createEmptyModel(f),C,L,c.createEmptyModel(f),new D.$Fc,f)}static E(r,f){return new c(r.contents,r.keys,r.overrides,void 0,f)}}e.$Zo=d;function w(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,f=new Map;for(const k of u)k.keys.forEach(P=>r.add(P)),k.overrides.forEach(([P,O])=>{const C=(0,D.$Cc)(f,P,new Set);O.forEach(L=>C.add(L))});const h=[];return f.forEach((k,P)=>h.push([P,[...k.values()]])),{keys:[...r.values()],overrides:h}}class o{constructor(r,f,h,k,P){this.change=r,this.f=f,this.g=h,this.h=k,this.i=P,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const O of r.keys)this.affectedKeys.add(O);for(const[,O]of r.overrides)for(const C of O)this.affectedKeys.add(C);this.d=this.a;for(const O of this.affectedKeys)this.d+=O+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=d.parse(this.f.data,this.i)),this.j}affectsConfiguration(r,f){const h=this.a+r,k=this.d.indexOf(h);if(k<0)return!1;const P=k+h.length;if(P>=this.d.length)return!1;const O=this.d.charCodeAt(P);if(O!==this.b&&O!==this.c)return!1;if(f){const C=this.previousConfiguration?this.previousConfiguration.getValue(r,f,this.f?.workspace):void 0,L=this.g.getValue(r,f,this.h);return!T.$qo(C,L)}return!0}}e.$2o=o;function l(u,r){const{added:f,removed:h,updated:k}=n(r?.rawConfiguration,u?.rawConfiguration),P=[],O=u?.getAllOverrideIdentifiers()||[],C=r?.getAllOverrideIdentifiers()||[];if(r){const L=C.filter(R=>!O.includes(R));for(const R of L)P.push([R,r.getKeysForOverrideIdentifier(R)])}if(u){const L=O.filter(R=>!C.includes(R));for(const R of L)P.push([R,u.getKeysForOverrideIdentifier(R)])}if(r&&u){for(const L of O)if(C.includes(L)){const R=n({contents:u.getOverrideValue(void 0,L)||{},keys:u.getKeysForOverrideIdentifier(L)},{contents:r.getOverrideValue(void 0,L)||{},keys:r.getKeysForOverrideIdentifier(L)});P.push([L,[...R.added,...R.removed,...R.updated]])}}return{added:f,removed:h,updated:k,overrides:P}}function n(u,r){const f=u?r?u.keys.filter(P=>r.keys.indexOf(P)===-1):[...u.keys]:[],h=r?u?r.keys.filter(P=>u.keys.indexOf(P)===-1):[...r.keys]:[],k=[];if(u&&r){for(const P of r.keys)if(u.keys.indexOf(P)!==-1){const O=(0,S.$mj)(r.contents,P),C=(0,S.$mj)(u.contents,P);T.$qo(O,C)||k.push(P)}}return{added:f,removed:h,updated:k}}}),define(Oe[220],Le([1,0,17,6,2,21,10,131,46,11,74,37]),function(ue,e,t,i,E,I,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=e.$3o=void 0;class p extends E.$Zc{get configurationModel(){return this.b}constructor(m){super(),this.c=m,this.a=this.B(new i.$qe),this.onDidChangeConfiguration=this.a.event,this.b=T.$Wo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(y.$zo.as(v.$Eo.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:b})=>this.f(Array.from(m),b))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(m,b){this.j(m,y.$zo.as(v.$Eo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}g(){return{}}h(){this.b=T.$Wo.createEmptyModel(this.c);const m=y.$zo.as(v.$Eo.Configuration).getConfigurationProperties();this.j(Object.keys(m),m)}j(m,b){const g=this.g();for(const d of m){const w=g[d],o=b[d];w!==void 0?this.b.setValue(d,w):o?this.b.setValue(d,o.default):this.b.removeValue(d)}}}e.$3o=p;class ${constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=T.$Wo.createEmptyModel(new s.$sk)}async initialize(){return this.configurationModel}}e.$4o=$;let a=class extends E.$Zc{get configurationModel(){return this.b}constructor(m,b,g){super(),this.c=m,this.f=b,this.g=g,this.a=this.B(new i.$qe),this.onDidChangeConfiguration=this.a.event,this.b=T.$Wo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const b={},g=[],d=y.$zo.as(v.$Eo.Configuration).getConfigurationProperties();for(const w of m){const o=d[w];if(!o){g.push(w);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.g.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}g.push(w),b[o.policy.name]={type:o.type}}}return(0,D.$wg)(b)||await this.f.updatePolicyDefinitions(b),g}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const b=y.$zo.as(v.$Eo.Configuration).getPolicyConfigurations(),g=(0,t.$Lb)(m.map(d=>b.get(d)));this.m(g,!0)}m(m,b){this.g.trace("PolicyConfiguration#update",m);const g=y.$zo.as(v.$Eo.Configuration).getConfigurationProperties(),d=[],w=this.b.isEmpty();for(const o of m){const l=g[o]?.policy?.name;if(l){const n=this.f.getPolicyValue(l);(w?n!==void 0:!(0,I.$qo)(this.b.getValue(o),n))&&d.push([o,n])}else this.b.getValue(o)!==void 0&&d.push([o,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const o=this.b;this.b=T.$Wo.createEmptyModel(this.g);for(const l of o.keys)this.b.setValue(l,o.getValue(l));for(const[l,n]of d)n===void 0?this.b.removeValue(l):this.b.setValue(l,n);b&&this.a.fire(this.b)}}};e.$5o=a,e.$5o=a=Ve([je(1,S.$Bo),je(2,s.$fk)],a)}),define(Oe[132],Le([1,0,17,13,14,6,42,162,2,25,21,3,19,28,131,46,220,15,74]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=void 0;class d extends v.$Zc{constructor(l,n,u,r){super(),this.m=l,this.n=r,this.h=this.B(new I.$qe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new m.$3o(r)),this.c=u instanceof g.$Do?new m.$4o:this.B(new m.$5o(this.b,u,r)),this.f=this.B(new a.$Yo(this.m,{},p.$ch,n,r)),this.a=new a.$Zo(this.b.configurationModel,this.c.configurationModel,a.$Wo.createEmptyModel(r),a.$Wo.createEmptyModel(r),a.$Wo.createEmptyModel(r),a.$Wo.createEmptyModel(r),new s.$Fc,a.$Wo.createEmptyModel(r),new s.$Fc,r),this.j=new w(l,n,this),this.g=this.B(new i.$Wh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:h})=>this.s(f,h))),this.B(this.c.onDidChangeConfiguration(f=>this.t(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[l,n,u]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new a.$Zo(l,n,a.$Wo.createEmptyModel(this.n),u,a.$Wo.createEmptyModel(this.n),a.$Wo.createEmptyModel(this.n),new s.$Fc,a.$Wo.createEmptyModel(this.n),new s.$Fc,this.n)}getConfigurationData(){return this.a.toData()}getValue(l,n){const u=typeof l=="string"?l:void 0,r=(0,$.$fj)(l)?l:(0,$.$fj)(n)?n:{};return this.a.getValue(u,r,void 0)}async updateValue(l,n,u,r,f){const h=(0,$.$gj)(u)?u:(0,$.$fj)(u)?{resource:u.resource,overrideIdentifiers:u.overrideIdentifier?[u.overrideIdentifier]:void 0}:void 0,k=h?r:u;if(k!==void 0&&k!==$.ConfigurationTarget.USER_LOCAL&&k!==$.ConfigurationTarget.USER)throw new Error(`Unable to write ${l} to target ${k}.`);h?.overrideIdentifiers&&(h.overrideIdentifiers=(0,t.$Qb)(h.overrideIdentifiers),h.overrideIdentifiers=h.overrideIdentifiers.length?h.overrideIdentifiers:void 0);const P=this.inspect(l,{resource:h?.resource,overrideIdentifier:h?.overrideIdentifiers?h.overrideIdentifiers[0]:void 0});if(P.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,S.$qo)(n,P.defaultValue)&&(n=void 0),h?.overrideIdentifiers?.length&&h.overrideIdentifiers.length>1){const C=h.overrideIdentifiers.sort(),L=this.a.localUserConfiguration.overrides.find(R=>(0,t.$yb)([...R.identifiers].sort(),C));L&&(h.overrideIdentifiers=L.identifiers)}const O=h?.overrideIdentifiers?.length?[(0,c.$Qo)(h.overrideIdentifiers),l]:[l];await this.j.write(O,n),await this.reloadConfiguration()}inspect(l,n={}){return this.a.inspect(l,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const l=await this.f.loadConfiguration();this.r(l)}r(l){const n=this.a.toData(),u=this.a.compareAndUpdateLocalUserConfiguration(l);this.u(u,n,$.ConfigurationTarget.USER)}s(l,n){const u=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(l,n);this.u(r,u,$.ConfigurationTarget.DEFAULT)}t(l){const n=this.a.toData(),u=this.a.compareAndUpdatePolicyConfiguration(l);this.u(u,n,$.ConfigurationTarget.DEFAULT)}u(l,n,u){const r=new a.$2o(l,{data:n},this.a,void 0,this.n);r.source=u,this.h.fire(r)}}e.$6o=d;class w{constructor(l,n,u){this.b=l,this.c=n,this.d=u,this.a=new i.$Rh}write(l,n){return this.a.queue(()=>this.e(l,n))}async e(l,n){let u;try{u=(await this.c.readFile(this.b)).value.toString()}catch(h){if(h.fileOperationResult===b.FileOperationResult.FILE_NOT_FOUND)u="{}";else throw h}const r=[];if((0,D.$7n)(u,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const f=this.f(u,l,n);u=(0,T.$lo)(u,f),await this.c.writeFile(this.b,E.$Se.fromString(u))}f(l,n,u){const{tabSize:r,insertSpaces:f,eol:h}=this.h;if(!n.length){const k=JSON.stringify(u,null,f?" ".repeat(r):"	");return[{content:k,length:k.length,offset:0}]}return(0,T.$io)(l,n,u,{tabSize:r,insertSpaces:f,eol:h})}get h(){if(!this.g){let l=y.OS===y.OperatingSystem.Linux||y.OS===y.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(l=n),this.g={eol:l,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(Oe[90],Le([1,0,9,5]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.RemoteAuthorityResolverErrorCode=e.$Yl=e.$Xl=e.RemoteConnectionType=e.$Wl=void 0,e.$1l=s,e.$Wl=(0,i.$Ki)("remoteAuthorityResolverService");var E;(function(S){S[S.WebSocket=0]="WebSocket",S[S.Managed=1]="Managed"})(E||(e.RemoteConnectionType=E={}));class I{constructor(y){this.id=y,this.type=E.Managed}toString(){return`Managed(${this.id})`}}e.$Xl=I;class D{constructor(y,p){this.host=y,this.port=p,this.type=E.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Yl=D;var T;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound",S.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class v extends t.$fb{static isNotAvailable(y){return y instanceof v&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof v&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof v&&y._code===T.NoResolverFound}static isInvalidAuthority(y){return y instanceof v&&y._code===T.InvalidAuthority}static isHandled(y){return y instanceof v&&y.isHandled}constructor(y,p=T.Unknown,$){super(y),this._message=y,this._code=p,this._detail=$,this.isHandled=p===T.NotAvailable&&$===!0,Object.setPrototypeOf(this,v.prototype)}}e.$Zl=v;function s(S){const y=S.indexOf("+");return y===-1?S:S.substring(0,y)}}),define(Oe[221],Le([1,0,13,14,18,9,6,2,12,44,43,23,61,90]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$6l=P,e.$7l=O,e.$8l=L,s=We(s);const a=30*1e3;var c;(function(X){X[X.Management=1]="Management",X[X.ExtensionHost=2]="ExtensionHost",X[X.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function m(X){switch(X){case c.Management:return"Management";case c.ExtensionHost:return"ExtensionHost";case c.Tunnel:return"Tunnel"}}function b(X){const M=new E.$Be;return setTimeout(()=>M.cancel(),X),M.token}function g(X,M){if(X.isCancellationRequested||M.isCancellationRequested)return E.CancellationToken.Cancelled;const A=new E.$Be;return X.onCancellationRequested(()=>A.cancel()),M.onCancellationRequested(()=>A.cancel()),A.token}class d{get didTimeout(){return this.c==="timedout"}constructor(M){this.c="pending",this.d=new T.$Yc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,t.$Dh)(),M.isCancellationRequested?this.h():this.d.add(M.onCancellationRequested(()=>this.h()))}registerDisposable(M){this.c==="pending"?this.d.add(M):M.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const M=new Error("Time limit reached");return M.code="ETIMEDOUT",M.syscall="connect",M}resolve(M){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(M))}reject(M){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(M))}}function w(X,M){const A=new d(M);return A.registerDisposable(X.onControlMessage(Y=>{const pe=JSON.parse(Y.toString()),ne=U(pe);ne?A.reject(ne):A.resolve(pe)})),A.promise}function o(X,M,A,Y,pe,ne,ie,G){const Z=new d(G),ce=S.$ke.create(!1);return X.info(`Creating a socket (${ie})...`),s.mark(`code/willCreateSocket/${ne}`),M.connect(A,Y,pe,ie).then(we=>{Z.didTimeout?(s.mark(`code/didCreateSocketError/${ne}`),X.info(`Creating a socket (${ie}) finished after ${ce.elapsed()} ms, but this is too late and has timed out already.`),we?.dispose()):(s.mark(`code/didCreateSocketOK/${ne}`),X.info(`Creating a socket (${ie}) was successful after ${ce.elapsed()} ms.`),Z.resolve(we))},we=>{s.mark(`code/didCreateSocketError/${ne}`),X.info(`Creating a socket (${ie}) returned an error after ${ce.elapsed()} ms.`),X.error(we),Z.reject(we)}),Z.promise}function l(X,M){const A=new d(M);return X.then(Y=>{A.didTimeout||A.resolve(Y)},Y=>{A.didTimeout||A.reject(Y)}),A.promise}async function n(X,M,A,Y){const pe=oe(X,M);X.logService.trace(`${pe} 1/6. invoking socketFactory.connect().`);let ne;try{ne=await o(X.logService,X.remoteSocketFactoryService,X.connectTo,v.$Xg.getServerRootPath(),`reconnectionToken=${X.reconnectionToken}&reconnection=${X.reconnectionProtocol?"true":"false"}`,m(M),`renderer-${m(M)}-${X.reconnectionToken}`,Y)}catch(we){throw X.logService.error(`${pe} socketFactory.connect() failed or timed out. Error:`),X.logService.error(we),we}X.logService.trace(`${pe} 2/6. socketFactory.connect() was successful.`);let ie,G;X.reconnectionProtocol?(X.reconnectionProtocol.beginAcceptReconnection(ne,null),ie=X.reconnectionProtocol,G=!1):(ie=new p.$yi({socket:ne}),G=!0),X.logService.trace(`${pe} 3/6. sending AuthRequest control message.`);const Z=await l(X.signService.createNewMessage((0,y.$7g)()),Y),ce={type:"auth",auth:X.connectionToken||"00000000000000000000",data:Z.data};ie.sendControl(i.$Se.fromString(JSON.stringify(ce)));try{const we=await w(ie,g(Y,b(1e4)));if(we.type!=="sign"||typeof we.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(X.logService.trace(`${pe} 4/6. received SignRequest control message.`),!await l(X.signService.validate(Z,we.signedData),Y)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Me=await l(X.signService.sign(we.data),Y),Be={type:"connectionType",commit:X.commit,signedData:Me,desiredConnectionType:M};return A&&(Be.args=A),X.logService.trace(`${pe} 5/6. sending ConnectionTypeRequest control message.`),ie.sendControl(i.$Se.fromString(JSON.stringify(Be))),{protocol:ie,ownsProtocol:G}}catch(we){throw we&&we.code==="ETIMEDOUT"&&(X.logService.error(`${pe} the handshake timed out. Error:`),X.logService.error(we)),we&&we.code==="VSCODE_CONNECTION_ERROR"&&(X.logService.error(`${pe} received error control message when negotiating connection. Error:`),X.logService.error(we)),G&&j(ie),we}}async function u(X,M,A,Y){const pe=Date.now(),ne=oe(X,M),{protocol:ie,ownsProtocol:G}=await n(X,M,A,Y),Z=new d(Y);return Z.registerDisposable(ie.onControlMessage(ce=>{const we=JSON.parse(ce.toString()),Ie=U(we);Ie?(X.logService.error(`${ne} received error control message when negotiating connection. Error:`),X.logService.error(Ie),G&&j(ie),Z.reject(Ie)):(X.reconnectionProtocol?.endAcceptReconnection(),X.logService.trace(`${ne} 6/6. handshake finished, connection is up and running after ${_(pe)}!`),Z.resolve({protocol:ie,firstMessage:we}))})),Z.promise}async function r(X,M){const{protocol:A}=await u(X,c.Management,void 0,M);return{protocol:A}}async function f(X,M,A){const{protocol:Y,firstMessage:pe}=await u(X,c.ExtensionHost,M,A),ne=pe&&pe.debugPort;return{protocol:Y,debugPort:ne}}async function h(X,M,A){const Y=Date.now(),pe=oe(X,c.Tunnel),{protocol:ne}=await n(X,c.Tunnel,M,A);return X.logService.trace(`${pe} 6/6. handshake finished, connection is up and running after ${_(Y)}!`),ne}async function k(X,M,A){const{connectTo:Y,connectionToken:pe}=await X.addressProvider.getAddress();return{commit:X.commit,quality:X.quality,connectTo:Y,connectionToken:pe,reconnectionToken:M,reconnectionProtocol:A,remoteSocketFactoryService:X.remoteSocketFactoryService,signService:X.signService,logService:X.logService}}async function P(X,M,A){return C(X,async Y=>{const{protocol:pe}=await r(Y,E.CancellationToken.None);return new V(X,M,A,Y.reconnectionToken,pe)})}async function O(X,M){return C(X,async A=>{const{protocol:Y,debugPort:pe}=await f(A,M,E.CancellationToken.None);return new B(X,M,A.reconnectionToken,Y,pe)})}async function C(X,M){for(let Y=1;;Y++)try{const pe=(0,y.$7g)(),ne=await k(X,pe,null);return await M(ne)}catch(pe){if(Y<5)X.logService.error(`[remote-connection][attempt ${Y}] An error occurred in initial connection! Will retry... Error:`),X.logService.error(pe);else throw X.logService.error(`[remote-connection][attempt ${Y}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),X.logService.error(pe),se.triggerPermanentFailure(0,0,$.$Zl.isHandled(pe)),pe}}async function L(X,M,A){const Y=await k(X,(0,y.$7g)(),null);return await h(Y,{host:M,port:A},E.CancellationToken.None)}function R(X){return(0,t.$xh)(M=>new Promise((A,Y)=>{const pe=setTimeout(A,X*1e3);M.onCancellationRequested(()=>{clearTimeout(pe),A()})}))}var z;(function(X){X[X.ConnectionLost=0]="ConnectionLost",X[X.ReconnectionWait=1]="ReconnectionWait",X[X.ReconnectionRunning=2]="ReconnectionRunning",X[X.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",X[X.ConnectionGain=4]="ConnectionGain"})(z||(e.PersistentConnectionEventType=z={}));class Q{constructor(M,A){this.reconnectionToken=M,this.millisSinceLastIncomingData=A,this.type=z.ConnectionLost}}e.$9l=Q;class J{constructor(M,A,Y,pe){this.reconnectionToken=M,this.millisSinceLastIncomingData=A,this.durationSeconds=Y,this.c=pe,this.type=z.ReconnectionWait}skipWait(){this.c.cancel()}}e.$0l=J;class x{constructor(M,A,Y){this.reconnectionToken=M,this.millisSinceLastIncomingData=A,this.attempt=Y,this.type=z.ReconnectionRunning}}e.$$l=x;class ve{constructor(M,A,Y){this.reconnectionToken=M,this.millisSinceLastIncomingData=A,this.attempt=Y,this.type=z.ConnectionGain}}e.$_l=ve;class be{constructor(M,A,Y,pe){this.reconnectionToken=M,this.millisSinceLastIncomingData=A,this.attempt=Y,this.handled=pe,this.type=z.ReconnectionPermanentFailure}}e.$am=be;class se extends T.$Zc{static triggerPermanentFailure(M,A,Y){this._permanentFailure=!0,this.f=M,this.g=A,this.h=Y,this.j.forEach(pe=>pe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(M=>M.y())}static debugPauseSocketWriting(){this.j.forEach(M=>M.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||se._permanentFailure}constructor(M,A,Y,pe,ne){super(),this.t=M,this.u=A,this.reconnectionToken=Y,this.protocol=pe,this.w=ne,this.m=this.B(new D.$qe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ve(this.reconnectionToken,0,0)),this.B(pe.onSocketClose(ie=>{const G=ye(this.t,this.reconnectionToken,!0);ie?ie.type===p.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${G} received socket close event (hadError: ${ie.hadError}).`),ie.error&&this.u.logService.error(ie.error)):(this.u.logService.info(`${G} received socket close event (wasClean: ${ie.wasClean}, code: ${ie.code}, reason: ${ie.reason}).`),ie.event&&this.u.logService.error(ie.event)):this.u.logService.info(`${G} received socket close event.`),this.y()})),this.B(pe.onSocketTimeout(ie=>{const G=ye(this.t,this.reconnectionToken,!0);this.u.logService.info(`${G} received socket timeout event (unacknowledgedMsgCount: ${ie.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ie.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ie.timeSinceLastReceivedSomeData}).`),this.y()})),se.j.push(this),this.B((0,T.$Xc)(()=>{const ie=se.j.indexOf(this);ie>=0&&se.j.splice(ie,1)})),this.n&&this.D(se.f,se.g,se.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const M=ye(this.t,this.reconnectionToken,!0);this.u.logService.info(`${M} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const A=[0,5,5,10,10,10,10,10,30];let Y=-1;do{Y++;const pe=Y<A.length?A[Y]:A[A.length-1];try{if(pe>0){const ie=R(pe);this.m.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe,ie)),this.u.logService.info(`${M} waiting for ${pe} seconds before reconnecting...`);try{await ie}catch{}}if(this.n){this.u.logService.error(`${M} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1)),this.u.logService.info(`${M} resolving connection...`);const ne=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${M} connecting to ${ne.connectTo}...`),await this.G(ne,b(a)),this.u.logService.info(`${M} reconnected!`),this.m.fire(new ve(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1));break}catch(ne){if(ne.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${M} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ne),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(Y>360){this.u.logService.error(`${M} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ne),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if($.$Zl.isTemporarilyNotAvailable(ne)){this.u.logService.info(`${M} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ne);continue}if((ne.code==="ETIMEDOUT"||ne.code==="ENETUNREACH"||ne.code==="ECONNREFUSED"||ne.code==="ECONNRESET")&&ne.syscall==="connect"){this.u.logService.info(`${M} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ne);continue}if((0,I.$8)(ne)){this.u.logService.info(`${M} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ne);continue}if(ne instanceof $.$Zl){this.u.logService.error(`${M} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ne),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,$.$Zl.isHandled(ne));break}this.u.logService.error(`${M} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ne),this.C(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}}while(!this.n&&!this.s)}C(M,A,Y){this.w?se.triggerPermanentFailure(M,A,Y):this.D(M,A,Y)}D(M,A,Y){this.m.fire(new be(this.reconnectionToken,M,A,Y)),j(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$bm=se;class V extends se{constructor(M,A,Y,pe,ne){super(c.Management,M,pe,ne,!0),this.client=this.B(new p.$wi(ne,{remoteAuthority:A,clientId:Y},M.ipcLogger))}async G(M,A){await r(M,A)}}e.$cm=V;class B extends se{constructor(M,A,Y,pe,ne){super(c.ExtensionHost,M,Y,pe,!1),this.H=A,this.debugPort=ne}async G(M,A){await f(M,this.H,A)}}e.$dm=B;function j(X){try{X.acceptDisconnect();const M=X.getSocket();X.dispose(),M.dispose()}catch(M){(0,I.$4)(M)}}function U(X){if(X&&X.type==="error"){const M=new Error(`Connection error: ${X.reason}`);return M.code="VSCODE_CONNECTION_ERROR",M}return null}function te(X,M){for(;X.length<M;)X+=" ";return X}function le(X,M){return`[remote-connection][${te(m(X),13)}][${M.substr(0,5)}\u2026]`}function ye(X,M,A){return`${le(X,M)}[${A?"reconnect":"initial"}]`}function oe(X,M){return`${ye(M,X.reconnectionToken,!!X.reconnectionProtocol)}[${X.connectTo}]`}function _(X){return`${Date.now()-X} ms`}}),define(Oe[222],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gS=e.$fS=void 0,e.$fS=(0,t.$Ki)("IRemoteExtensionsScannerService"),e.$gS="remoteExtensionsScanner"}),define(Oe[91],Le([1,0,12]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=i,e.$qn=E,e.$rn=I,e.$sn=D;function i(v){return v.scheme===t.Schemas.vscodeRemote?v.authority:void 0}function E(v){if(!v)return;const s=v.indexOf("+");return s<0?v:v.substr(0,s)}function I(v){const{host:s,port:S}=T(v);if(typeof S>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:S}}function D(v,s){let{host:S,port:y}=T(v);return typeof y>"u"&&(y=s),{host:S,port:y}}function T(v){const s=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const S=v.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const y=v.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:v,port:void 0}}}),define(Oe[22],Le([1,0,16,5,91]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=e.$Bn=e.$An=e.$zn=e.TargetPlatform=e.ExtensionType=e.$yn=e.$wn=e.$vn=e.$un=e.$tn=void 0,e.$xn=I,e.$Cn=y,e.$Dn=p,e.$En=$,e.$Fn=a,e.$Gn=c,e.$Hn=m,t=We(t),e.$tn="extensions.user.cache",e.$un="extensions.builtin.cache",e.$vn="undefined_publisher",e.$wn=["ui","workspace","web"];function I(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$yn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D||(e.ExtensionType=D={}));var T;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class v{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,d){if(typeof g>"u"||g===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof g=="string"||typeof d=="string"){const w=typeof g=="string"?g:g.value,o=typeof d=="string"?d:d.value;return t.$Kf(w,o)}return g._lower===d._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$zn=v;class s{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const d of g)this.add(d)}add(g){this.c.add(v.toKey(g))}delete(g){return this.c.delete(v.toKey(g))}has(g){return this.c.has(v.toKey(g))}}e.$An=s;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(v.toKey(g))}get(g){return this.c.get(v.toKey(g))}has(g){return this.c.has(v.toKey(g))}set(g,d){this.c.set(v.toKey(g),d)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Bn=S;function y(b){return p(b)}function p(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function $(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function a(b,g){if(g){const d=`onResolveRemoteAuthority:${(0,E.$qn)(g)}`;return!!b.activationEvents?.includes(d)}return!1}function c(b){return b.map(g=>{const[d,w]=g.split("@");return{proposalName:d,version:w?parseInt(w):void 0}})}function m(b){return b.map(g=>g.split("@")[0])}e.$In=(0,i.$Ki)("IBuiltinExtensionsScannerService")}),define(Oe[30],Le([1,0,3,7,22,5]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.ExtensionManagementErrorCode=e.$up=e.ExtensionGalleryErrorCode=e.$tp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=void 0,e.$np=T,e.$op=v,e.$pp=s,e.$qp=S,e.$rp=y,e.$sp=p,e.$gp="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$hp=new RegExp(e.$gp),e.$ip="__web_extension",e.$jp="skipWalkthrough",e.$kp="extensionInstallSource",e.$lp="dependecyOrPackExtensionInstall",e.$mp="clientTargetPlatform";var D;(function(o){o.COMMAND="command",o.SETTINGS_SYNC="settingsSync"})(D||(e.ExtensionInstallSource=D={}));function T(o){switch(o){case E.TargetPlatform.WIN32_X64:return"Windows 64 bit";case E.TargetPlatform.WIN32_ARM64:return"Windows ARM";case E.TargetPlatform.LINUX_X64:return"Linux 64 bit";case E.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case E.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case E.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case E.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case E.TargetPlatform.DARWIN_X64:return"Mac";case E.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case E.TargetPlatform.WEB:return"Web";case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;case E.TargetPlatform.UNKNOWN:return E.TargetPlatform.UNKNOWN;case E.TargetPlatform.UNDEFINED:return E.TargetPlatform.UNDEFINED}}function v(o){switch(o){case E.TargetPlatform.WIN32_X64:return E.TargetPlatform.WIN32_X64;case E.TargetPlatform.WIN32_ARM64:return E.TargetPlatform.WIN32_ARM64;case E.TargetPlatform.LINUX_X64:return E.TargetPlatform.LINUX_X64;case E.TargetPlatform.LINUX_ARM64:return E.TargetPlatform.LINUX_ARM64;case E.TargetPlatform.LINUX_ARMHF:return E.TargetPlatform.LINUX_ARMHF;case E.TargetPlatform.ALPINE_X64:return E.TargetPlatform.ALPINE_X64;case E.TargetPlatform.ALPINE_ARM64:return E.TargetPlatform.ALPINE_ARM64;case E.TargetPlatform.DARWIN_X64:return E.TargetPlatform.DARWIN_X64;case E.TargetPlatform.DARWIN_ARM64:return E.TargetPlatform.DARWIN_ARM64;case E.TargetPlatform.WEB:return E.TargetPlatform.WEB;case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;default:return E.TargetPlatform.UNKNOWN}}function s(o,l){switch(o){case t.Platform.Windows:return l==="x64"?E.TargetPlatform.WIN32_X64:l==="arm64"?E.TargetPlatform.WIN32_ARM64:E.TargetPlatform.UNKNOWN;case t.Platform.Linux:return l==="x64"?E.TargetPlatform.LINUX_X64:l==="arm64"?E.TargetPlatform.LINUX_ARM64:l==="arm"?E.TargetPlatform.LINUX_ARMHF:E.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?E.TargetPlatform.ALPINE_X64:l==="arm64"?E.TargetPlatform.ALPINE_ARM64:E.TargetPlatform.UNKNOWN;case t.Platform.Mac:return l==="x64"?E.TargetPlatform.DARWIN_X64:l==="arm64"?E.TargetPlatform.DARWIN_ARM64:E.TargetPlatform.UNKNOWN;case t.Platform.Web:return E.TargetPlatform.WEB}}function S(o,l){return l===E.TargetPlatform.WEB&&!o.includes(E.TargetPlatform.WEB)}function y(o,l,n){return S(l,n)?!1:o===E.TargetPlatform.UNDEFINED||o===E.TargetPlatform.UNIVERSAL?!0:o===E.TargetPlatform.UNKNOWN?!1:o===n}function p(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}var $;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var a;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var c;(function(o){o.Install="install",o.Uninstall="uninstall"})(c||(e.StatisticType=c={}));var m;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$tp=(0,I.$Ki)("extensionGalleryService");var b;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed",o.DownloadFailedWriting="DownloadFailedWriting",o.Offline="Offline"})(b||(e.ExtensionGalleryErrorCode=b={}));class g extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.$up=g;var d;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleApi="IncompatibleApi",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.DownloadFailedWriting="DownloadFailedWriting",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.ScanningExtension="ScanningExtension",o.ReadUninstalled="ReadUninstalled",o.UnsetUninstalled="UnsetUninstalled",o.Delete="Delete",o.Rename="Rename",o.IntializeDefaultProfile="IntializeDefaultProfile",o.AddToProfile="AddToProfile",o.InstalledExtensionNotFound="InstalledExtensionNotFound",o.PostInstall="PostInstall",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Cancelled="Cancelled",o.Unknown="Unknown",o.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));class w extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.$vp=w,e.$wp=(0,I.$Ki)("extensionManagementService"),e.$xp="extensionsIdentifiers/disabled",e.$yp="extensionsIdentifiers/enabled",e.$zp=(0,I.$Ki)("IGlobalExtensionEnablementService"),e.$Ap=(0,I.$Ki)("IExtensionTipsService"),e.$Bp=(0,i.localize2)(1781,"Extensions"),e.$Cp=(0,i.localize2)(1782,"Preferences")}),define(Oe[223],Le([1,0,6,2,21,4,60,30]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=e.$Hq=void 0;function v(m,b){return m?I.URI.revive(b?b.transformIncoming(m):m):void 0}function s(m,b){return b?b.transformOutgoingURI(m):m}function S(m,b){b=b||D.$Vn;const g=m.manifest;return{...(0,D.$Yn)({...m,manifest:void 0},b),manifest:g}}function y(m,b){return m?.profileLocation?(0,D.$Yn)(m,b??D.$Vn):m}function p(m,b){return b?(0,E.$oo)(m,g=>g instanceof I.URI?b.transformOutgoingURI(g):void 0):m}class ${constructor(b,g){this.a=b,this.b=g,this.onInstallExtension=t.Event.buffer(b.onInstallExtension,!0),this.onDidInstallExtensions=t.Event.buffer(b.onDidInstallExtensions,!0),this.onUninstallExtension=t.Event.buffer(b.onUninstallExtension,!0),this.onDidUninstallExtension=t.Event.buffer(b.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=t.Event.buffer(b.onDidUpdateExtensionMetadata,!0)}listen(b,g){const d=this.b(b);switch(g){case"onInstallExtension":return t.Event.map(this.onInstallExtension,w=>({...w,profileLocation:w.profileLocation?s(w.profileLocation,d):w.profileLocation}));case"onDidInstallExtensions":return t.Event.map(this.onDidInstallExtensions,w=>w.map(o=>({...o,local:o.local?p(o.local,d):o.local,profileLocation:o.profileLocation?s(o.profileLocation,d):o.profileLocation})));case"onUninstallExtension":return t.Event.map(this.onUninstallExtension,w=>({...w,profileLocation:w.profileLocation?s(w.profileLocation,d):w.profileLocation}));case"onDidUninstallExtension":return t.Event.map(this.onDidUninstallExtension,w=>({...w,profileLocation:w.profileLocation?s(w.profileLocation,d):w.profileLocation}));case"onDidUpdateExtensionMetadata":return t.Event.map(this.onDidUpdateExtensionMetadata,w=>({local:p(w.local,d),profileLocation:s(w.profileLocation,d)}))}throw new Error("Invalid listen")}async call(b,g,d){const w=this.b(b);switch(g){case"zip":{const o=S(d[0],w),l=await this.a.zip(o);return s(l,w)}case"install":return this.a.install(v(d[0],w),y(d[1],w));case"installFromLocation":return this.a.installFromLocation(v(d[0],w),v(d[1],w));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(d[0],v(d[1],w),v(d[2],w));case"getManifest":return this.a.getManifest(v(d[0],w));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],y(d[1],w));case"installGalleryExtensions":{const o=d[0];return this.a.installGalleryExtensions(o.map(({extension:l,options:n})=>({extension:l,options:y(n,w)??{}})))}case"uninstall":return this.a.uninstall(S(d[0],w),y(d[1],w));case"uninstallExtensions":{const o=d[0];return this.a.uninstallExtensions(o.map(({extension:l,options:n})=>({extension:S(l,w),options:y(n,w)})))}case"reinstallFromGallery":return this.a.reinstallFromGallery(S(d[0],w));case"getInstalled":return(await this.a.getInstalled(d[0],v(d[1],w),d[2])).map(l=>p(l,w));case"toggleAppliationScope":{const o=await this.a.toggleAppliationScope(S(d[0],w),v(d[1],w));return p(o,w)}case"copyExtensions":return this.a.copyExtensions(v(d[0],w),v(d[1],w));case"updateMetadata":{const o=await this.a.updateMetadata(S(d[0],w),d[1],v(d[2],w));return p(o,w)}case"resetPinnedStateForAllUserExtensions":return this.a.resetPinnedStateForAllUserExtensions(d[0]);case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1],d[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Hq=$;class a extends i.$Zc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(b){super(),this.m=b,this.c=this.B(new t.$qe),this.f=this.B(new t.$qe),this.g=this.B(new t.$qe),this.h=this.B(new t.$qe),this.j=this.B(new t.$qe),this.B(this.m.listen("onInstallExtension")(g=>this.n(this.c,{...g,source:this.r(g.source)?I.URI.revive(g.source):g.source,profileLocation:I.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(g=>this.n(this.f,g.map(d=>({...d,local:d.local?S(d.local,null):d.local,source:this.r(d.source)?I.URI.revive(d.source):d.source,profileLocation:I.URI.revive(d.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(g=>this.n(this.g,{...g,profileLocation:I.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(g=>this.n(this.h,{...g,profileLocation:I.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(g=>this.n(this.j,{profileLocation:I.URI.revive(g.profileLocation),local:S(g.local,null)})))}n(b,g){b.fire(g)}r(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(b){const g=await this.getTargetPlatform();return b.allTargetPlatforms.some(d=>(0,T.$rp)(d,b.allTargetPlatforms,g))}zip(b){return Promise.resolve(this.m.call("zip",[b]).then(g=>I.URI.revive(g)))}install(b,g){return Promise.resolve(this.m.call("install",[b,g])).then(d=>S(d,null))}installFromLocation(b,g){return Promise.resolve(this.m.call("installFromLocation",[b,g])).then(d=>S(d,null))}async installExtensionsFromProfile(b,g,d){return(await this.m.call("installExtensionsFromProfile",[b,g,d])).map(o=>S(o,null))}getManifest(b){return Promise.resolve(this.m.call("getManifest",[b]))}installFromGallery(b,g){return Promise.resolve(this.m.call("installFromGallery",[b,g])).then(d=>S(d,null))}async installGalleryExtensions(b){return(await this.m.call("installGalleryExtensions",[b])).map(d=>({...d,local:d.local?S(d.local,null):d.local,source:this.r(d.source)?I.URI.revive(d.source):d.source,profileLocation:I.URI.revive(d.profileLocation)}))}uninstall(b,g){if(b.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[b,g]))}uninstallExtensions(b){if(b.some(g=>g.extension.isWorkspaceScoped))throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstallExtensions",[b]))}reinstallFromGallery(b){return Promise.resolve(this.m.call("reinstallFromGallery",[b])).then(g=>S(g,null))}getInstalled(b=null,g,d){return Promise.resolve(this.m.call("getInstalled",[b,g,d])).then(w=>w.map(o=>S(o,null)))}updateMetadata(b,g,d){return Promise.resolve(this.m.call("updateMetadata",[b,g,d])).then(w=>S(w,null))}resetPinnedStateForAllUserExtensions(b){return this.m.call("resetPinnedStateForAllUserExtensions",[b])}toggleAppliationScope(b,g){return this.m.call("toggleAppliationScope",[b,g]).then(d=>S(d,null))}copyExtensions(b,g){return this.m.call("copyExtensions",[b,g])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(b,g,d){const w=await this.m.call("download",[b,g,d]);return I.URI.revive(w)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Iq=a;class c{constructor(b){this.a=b}listen(b,g){throw new Error("Invalid listen")}call(b,g,d){switch(g){case"getConfigBasedTips":return this.a.getConfigBasedTips(I.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Jq=c}),define(Oe[133],Le([1,0,9,22]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jH=e.$iH=void 0;class E{constructor(){this.a=new Map,this.b=new WeakMap}register(D,T){this.a.set(D,T)}readActivationEvents(D){return this.b.has(D)||this.b.set(D,this.c(D)),this.b.get(D)}createActivationEventsMap(D){const T=Object.create(null);for(const v of D){const s=this.readActivationEvents(v);s.length>0&&(T[i.$zn.toKey(v.identifier)]=s)}return T}c(D){if(typeof D.main>"u"&&typeof D.browser>"u")return[];const T=Array.isArray(D.activationEvents)?D.activationEvents.slice(0):[];for(let v=0;v<T.length;v++)T[v]==="onUri"&&(T[v]=`onUri:${i.$zn.toKey(D.identifier)}`);if(!D.contributes)return T;for(const v in D.contributes){const s=this.a.get(v);if(!s)continue;const S=D.contributes[v],y=Array.isArray(S)?S:[S];try{s(y,T)}catch(p){(0,t.$4)(p)}}return T}}e.$iH=E,e.$jH=new E}),define(Oe[224],Le([1,0,2,22,15]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;class I extends t.$Zc{constructor(T,v,s,S,y){super(),this.a=T,this.b=v,this.c=s,this.f=y,this.B(S.onDidInstallExtensions(p=>this.g(p))),this.B(S.onDidUninstallExtension(p=>this.h(p)))}g(T){for(const v of T)v.local&&this.invalidate(v.profileLocation)}h(T){T.error||this.invalidate(T.profileLocation)}async invalidate(T){if(T)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,T)&&await this.j(v);else await this.j(this.a.defaultProfile)}async j(T){try{await this.b.del(this.c.extUri.joinPath(T.cacheHome,i.$tn))}catch(v){(0,E.$wl)(v)!==E.FileOperationResult.FILE_NOT_FOUND&&this.f.error(v)}}}e.$7q=I});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[75],Le([1,0,19,58,7,63,22,121]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=S,e.$9p=y,e.$0p=p,e.$$p=$,e.$_p=a,e.$aq=c,e.$bq=m,e.$cq=b,i=$t(i),E=We(E),I=We(I);const v=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function S(w){return w=w.trim(),w==="*"||v.test(w)}function y(w){if(!S(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const o=w.match(v);return o?{hasCaret:o[1]==="^",hasGreaterEquals:o[1]===">=",majorBase:o[2]==="x"?0:parseInt(o[2],10),majorMustEqual:o[2]!=="x",minorBase:o[4]==="x"?0:parseInt(o[4],10),minorMustEqual:o[4]!=="x",patchBase:o[6]==="x"?0:parseInt(o[6],10),patchMustEqual:o[6]!=="x",preRelease:o[8]||null}:null}function p(w){if(!w)return null;const o=w.majorBase,l=w.majorMustEqual,n=w.minorBase;let u=w.minorMustEqual;const r=w.patchBase;let f=w.patchMustEqual;w.hasCaret&&(o===0||(u=!1),f=!1);let h=0;if(w.preRelease){const k=s.exec(w.preRelease);if(k){const[,P,O,C]=k;h=Date.UTC(Number(P),Number(O)-1,Number(C))}}return{majorBase:o,majorMustEqual:l,minorBase:n,minorMustEqual:u,patchBase:r,patchMustEqual:f,isMinimum:w.hasGreaterEquals,notBefore:h}}function $(w,o,l){let n;typeof w=="string"?n=p(y(w)):n=w;let u;o instanceof Date?u=o.getTime():typeof o=="string"&&(u=new Date(o).getTime());let r;if(typeof l=="string"?r=p(y(l)):r=l,!n||!r)return!1;const f=n.majorBase,h=n.minorBase,k=n.patchBase;let P=r.majorBase,O=r.minorBase,C=r.patchBase;const L=r.notBefore;let R=r.majorMustEqual,z=r.minorMustEqual,Q=r.patchMustEqual;return r.isMinimum?f>P?!0:f<P?!1:h>O?!0:h<O||u&&u<L?!1:k>=C:(f===1&&P===0&&(!R||!z||!Q)&&(P=1,O=0,C=0,R=!0,z=!1,Q=!1),f<P?!1:f>P?!R:h<O?!1:h>O?!z:k<C?!1:k>C?!Q:!(u&&u<L))}function a(w,o,l,n,u,r){const f=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return f.push([i.default.Error,E.localize(1833,null)]),f;if(typeof n.name!="string")return f.push([i.default.Error,E.localize(1834,null,"name")]),f;if(typeof n.version!="string")return f.push([i.default.Error,E.localize(1835,null,"version")]),f;if(!n.engines)return f.push([i.default.Error,E.localize(1836,null,"engines")]),f;if(typeof n.engines.vscode!="string")return f.push([i.default.Error,E.localize(1837,null,"engines.vscode")]),f;if(typeof n.extensionDependencies<"u"&&!d(n.extensionDependencies))return f.push([i.default.Error,E.localize(1838,null,"extensionDependencies")]),f;if(typeof n.activationEvents<"u"){if(!d(n.activationEvents))return f.push([i.default.Error,E.localize(1839,null,"activationEvents")]),f;if(typeof n.main>"u"&&typeof n.browser>"u")return f.push([i.default.Error,E.localize(1840,null,"activationEvents","main","browser")]),f}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&f.push([i.default.Warning,E.localize(1841,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return f.push([i.default.Error,E.localize(1842,null,"main")]),f;{const P=(0,t.$lh)(l,n.main);(0,t.$fh)(P,l)||f.push([i.default.Warning,E.localize(1843,null,P.path,l.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return f.push([i.default.Error,E.localize(1844,null,"browser")]),f;{const P=(0,t.$lh)(l,n.browser);(0,t.$fh)(P,l)||f.push([i.default.Warning,E.localize(1845,null,P.path,l.path)])}}if(!I.valid(n.version))return f.push([i.default.Error,E.localize(1846,null)]),f;const h=[];if(!c(w,o,n,u,h))for(const P of h)f.push([i.default.Error,P]);if(r&&n.enabledApiProposals?.length){const P=[];if(!b([...n.enabledApiProposals],P))for(const O of P)f.push([i.default.Error,O])}return f}function c(w,o,l,n,u){return n||typeof l.main>"u"&&typeof l.browser>"u"?!0:g(w,o,l.engines.vscode,u)}function m(w,o,l){return w==="*"||g(o,l,w)}function b(w,o){if(w.length===0)return!0;const l=Array.isArray(o)?o:void 0,n=(l?void 0:o)??T.allApiProposals,u=[],r=(0,D.$Gn)(w);for(const{proposalName:f,version:h}of r){const k=n[f];k&&h&&k.version!==h&&u.push(E.localize(1847,null,f))}return l?.push(...u),u.length===0}function g(w,o,l,n=[]){const u=p(y(l));if(!u)return n.push(E.localize(1848,null,l)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return n.push(E.localize(1849,null,l)),!1}else if(!u.majorMustEqual)return n.push(E.localize(1850,null,l)),!1;return $(w,o,u)?!0:(n.push(E.localize(1851,null,w,l)),!1)}function d(w){if(!Array.isArray(w))return!1;for(let o=0,l=w.length;o<l;o++)if(typeof w[o]!="string")return!1;return!0}}),define(Oe[92],Le([1,0,18,2,3,7,30,5]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=e.$js=void 0,e.$is=v;function v(S){return S.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.$js=(0,T.$Ki)("languagePackService");let s=class extends i.$Zc{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new t.$Be;setTimeout(()=>y.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const a=p.firstPage.filter(c=>c.properties.localizedLanguages?.length&&c.tags.some(m=>m.startsWith("lp-"))).map(c=>{const m=c.properties.localizedLanguages?.[0],b=v(c);return{...this.f(b,m,c),extensionId:c.identifier.id,galleryExtension:c}});return a.push(this.f("en","English")),a}f(y,p,$){const a=p??y;let c;if(a!==y&&(c=`(${y})`),y.toLowerCase()===E.$z.toLowerCase()&&(c??="",c+=(0,I.localize)(1929,null)),$?.installCount){c??="";const m=$.installCount;let b;m>1e6?b=`${Math.floor(m/1e5)/10}M`:m>1e3?b=`${Math.floor(m/1e3)}K`:b=String(m),c+=` $(cloud-download) ${b}`}return{id:y,label:a,description:c}}};e.$ks=s,e.$ks=s=Ve([je(0,D.$tp)],s)}),define(Oe[47],Le([1,0,14,9,2,7,46,5,11,37]),function(ue,e,t,i,E,I,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0,e.$fq=p,e.$gq=$,e.$hq=a,e.$iq=c,e.$jq=m,e.$kq=b,e.$dq=(0,T.$Ki)("requestService");class S{constructor(o){this.b=o}toJSON(){if(!this.a){const o=Object.create(null);for(const l in this.b)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?o[l]="*****":o[l]=this.b[l];this.a=o}return this.a}}class y extends E.$Zc{constructor(o){super(),this.b=0,this.a=o.createLogger("network",{name:(0,I.localize)(2051,null),when:v.$xk.isEqualTo((0,v.$uk)(v.LogLevel.Trace)).serialize()})}async c(o,l,n){const u=`${o} #${++this.b}: ${l.url}`;this.a.trace(`${u} - begin`,l.type,new S(l.headers??{}));try{const r=await n();return this.a.trace(`${u} - end`,l.type,r.res.statusCode,r.res.headers),r}catch(r){throw this.a.error(`${u} - error`,l.type,(0,i.$bb)(r)),r}}}e.$eq=y;function p(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}function $(w){return w.res.statusCode===204}async function a(w){return $(w)?null:(await(0,t.$5e)(w.stream)).toString()}async function c(w){if(!p(w))throw new Error("Server returned "+w.res.statusCode);return a(w)}async function m(w){if(!p(w))throw new Error("Server returned "+w.res.statusCode);if($(w))return null;const l=(await(0,t.$5e)(w.stream)).toString();try{return JSON.parse(l)}catch(n){throw n.message+=`:
`+l,n}}function b(w){d(w)}let g;function d(w){const o=s.$zo.as(D.$Eo.Configuration),l=g;g={id:"http",order:15,title:(0,I.localize)(2052,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(2053,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2054,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,I.localize)(2055,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,I.localize)(2056,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(2057,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(2058,null),(0,I.localize)(2059,null),(0,I.localize)(2060,null),(0,I.localize)(2061,null)],default:"override",description:(0,I.localize)(2062,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(2063,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,I.localize)(2064,null),restricted:!0}}},o.updateConfigurations({add:[g],remove:l?[l]:[]})}d(D.ConfigurationScope.APPLICATION)}),define(Oe[225],Le([1,0,18,12,15,47]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yS=void 0;let D=class{constructor(v,s){this.a=v,this.b=s}async download(v,s,S=t.CancellationToken.None){if(v.scheme===i.Schemas.file||v.scheme===i.Schemas.vscodeRemote){await this.b.copy(v,s);return}const y={type:"GET",url:v.toString(!0)},p=await this.a.request(y,S);if(p.res.statusCode===200)await this.b.writeFile(s,p.stream);else{const $=await(0,I.$iq)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${$}`)}}};e.$yS=D,e.$yS=D=Ve([je(0,I.$dq),je(1,E.$fl)],D)}),define(Oe[226],Le([1,0,14,18]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=e.$ms=void 0;class E{constructor(T){this.a=T}listen(T,v){throw new Error("Invalid listen")}call(T,v,s,S=i.CancellationToken.None){switch(v){case"request":return this.a.request(s[0],S).then(async({res:y,stream:p})=>{const $=await(0,t.$5e)(p);return[{statusCode:y.statusCode,headers:y.headers},$]});case"resolveProxy":return this.a.resolveProxy(s[0]);case"lookupAuthorization":return this.a.lookupAuthorization(s[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(s[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$ms=E;class I{constructor(T){this.a=T}async request(T,v){const[s,S]=await this.a.call("request",[T],v);return{res:s,stream:(0,t.$7e)(S)}}async resolveProxy(T){return this.a.call("resolveProxy",[T])}async lookupAuthorization(T){return this.a.call("lookupAuthorization",[T])}async lookupKerberosAuthorization(T){return this.a.call("lookupKerberosAuthorization",[T])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$ns=I}),define(Oe[227],Le([1,0,93,10]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=I;function E(D,T){return D.protocol==="http:"?T.HTTP_PROXY||T.http_proxy||null:D.protocol==="https:"&&(T.HTTPS_PROXY||T.https_proxy||T.HTTP_PROXY||T.http_proxy)||null}async function I(D,T,v={}){const s=(0,t.parse)(D),S=v.proxyUrl||E(s,T);if(!S)return null;const y=(0,t.parse)(S);if(!/^https?:$/.test(y.protocol||""))return null;const p={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,i.$pg)(v.strictSSL)?v.strictSSL:!0,keepAlive:!0};if(s.protocol==="http:"){const $=await new Promise((a,c)=>{ue(["http-proxy-agent"],a,c)}).then(We);return new $.HttpProxyAgent(S,p)}else{const $=await new Promise((a,c)=>{ue(["https-proxy-agent"],a,c)}).then(We);return new $.HttpsProxyAgent(S,p)}}}),define(Oe[94],Le([1,0,50,8,7,18,45,9,3,23,118,201,13,166]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=c;let a;async function c(b,g,d,w){return d["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.$l?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$Pm)(w)&&!d["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$Pm)(w)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),a||(a=p.Promises.withAsyncBody(async(o,l)=>{const n=new I.$Be;let u=1e4;const r=b.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(u=(0,$.$Qm)(r,1,120)*1e3);const f=setTimeout(()=>{n.dispose(!0),l(new Error((0,E.localize)(2065,null)))},u);try{o(await m(g,n.token))}catch(h){!(0,T.$8)(h)&&!n.token.isCancellationRequested?l(new Error((0,E.localize)(2066,null,(0,D.$vj)(h)))):o({})}finally{clearTimeout(f),n.dispose()}})),a)}async function m(b,g){const d=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",d);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",w);const o=(0,s.$7g)().replace(/-/g,"").substr(0,12),l=new RegExp(o+"({.*})"+o),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};b.trace("getUnixShellEnvironment#env",n);const u=await(0,S.$Fm)(v.OS,n);return b.trace("getUnixShellEnvironment#shell",u),new Promise((r,f)=>{if(g.isCancellationRequested)return f(new T.$9);const h=(0,i.$sc)(u);let k,P;const O="";/^pwsh(-preview)?$/.test(h)?(k=`& '${process.execPath}' ${O} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,P=["-Login","-Command"]):h==="nu"?(k=`^'${process.execPath}' ${O} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,P=["-i","-l","-c"]):h==="xonsh"?(k=`import os, json; print("${o}", json.dumps(dict(os.environ)), "${o}")`,P=["-i","-l","-c"]):(k=`'${process.execPath}' ${O} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,h==="tcsh"||h==="csh"?P=["-ic"]:P=["-i","-l","-c"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),k);const C=(0,t.spawn)(u,[...P,k],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});g.onCancellationRequested(()=>(C.kill(),f(new T.$9))),C.on("error",z=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,D.$vj)(z)),f(z)});const L=[];C.stdout.on("data",z=>L.push(z));const R=[];C.stderr.on("data",z=>R.push(z)),C.on("close",(z,Q)=>{const J=Buffer.concat(L).toString("utf8");b.trace("getUnixShellEnvironment#raw",J);const x=Buffer.concat(R).toString("utf8");if(x.trim()&&b.trace("getUnixShellEnvironment#stderr",x),z||Q)return f(new Error((0,E.localize)(2067,null,z,Q)));const ve=l.exec(J),be=ve?ve[1]:"{}";try{const se=JSON.parse(be);d?se.ELECTRON_RUN_AS_NODE=d:delete se.ELECTRON_RUN_AS_NODE,w?se.ELECTRON_NO_ATTACH_CONSOLE=w:delete se.ELECTRON_NO_ATTACH_CONSOLE,delete se.VSCODE_RESOLVING_ENVIRONMENT,delete se.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",se),r(se)}catch(se){b.error("getUnixShellEnvironment#errorCaught",(0,D.$vj)(se)),f(se)}})})}}),define(Oe[228],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8R=e.$7R=void 0,e.$7R=(0,t.$Ki)("stateReadService"),e.$8R=(0,t.$Ki)("stateService")}),define(Oe[229],Le([1,0,13,14,2,10,27,15,11]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$R=e.$0R=e.$9R=e.SaveStrategy=void 0;var s;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(s||(e.SaveStrategy=s={}));class S extends E.$Zc{constructor(a,c,m,b){super(),this.h=a,this.j=c,this.m=m,this.n=b,this.a=Object.create(null),this.b="",this.c=this.B(new t.$Ih(this.j===s.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(a){a.fileOperationResult!==T.FileOperationResult.FILE_NOT_FOUND&&this.m.error(a)}}getItem(a,c){const m=this.a[a];return(0,I.$sg)(m)?c:m}setItem(a,c){this.setItems([{key:a,data:c}])}setItems(a){let c=!1;for(const{key:m,data:b}of a)this.a[m]!==b&&((0,I.$sg)(b)?(0,I.$qg)(this.a[m])||(this.a[m]=void 0,c=!0):(this.a[m]=b,c=!0));c&&this.s()}removeItem(a){(0,I.$qg)(this.a[a])||(this.a[a]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const a=JSON.stringify(this.a,null,4);if(a!==this.b)try{await this.n.writeFile(this.h,i.$Se.fromString(a),{atomic:{postfix:".vsctmp"}}),this.b=a}catch(c){this.m.error(c)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$9R=S;let y=class extends E.$Zc{constructor(a,c,m,b){super(),this.a=this.B(new S(c.stateResource,a,m,b))}async init(){await this.a.init()}getItem(a,c){return this.a.getItem(a,c)}};e.$0R=y,e.$0R=y=Ve([je(1,D.$Ri),je(2,v.$fk),je(3,T.$fl)],y);class p extends y{setItem(a,c){this.a.setItem(a,c)}setItems(a){this.a.setItems(a)}removeItem(a){this.a.removeItem(a)}close(){return this.a.close()}}e.$$R=p}),define(Oe[134],Le([1,0,3,32,23]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=D,e.$Ep=T;function I(v){if(t.$x===t.Platform.Linux&&/^penguin(\.|$)/i.test(v))return"chromebook"}function D(v,s,S,y,p,$,a,c,m,b){const g=Object.create(null);g["common.machineId"]=$,g["common.sqmId"]=a,g["common.devDeviceId"]=c,g.sessionID=(0,E.$7g)()+Date.now(),g.commitHash=y,g.version=p,g["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,t.$k)(t.$x),g["common.nodePlatform"]=i.$ic,g["common.nodeArch"]=S,g["common.product"]=b||"desktop",m&&(g["common.msftInternal"]=m);let d=0;const w=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),t.$o&&(g["common.snap"]="true");const o=I(s);return o&&(g["common.platformDetail"]=o),g}function T(v){const s=i.env.USERDNSDOMAIN;if(!s)return!1;const S=s.toLowerCase();return v.some(y=>S===y)}}),define(Oe[230],Le([1,0,17,9,2,21,15]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var T;(function(s){function S(y,p){return y.callstack<p.callstack?-1:y.callstack>p.callstack?1:0}s.compare=S})(T||(e.ErrorEvent=T={}));class v{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(S,y=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new E.$Yc,this.c=S,this.d=y;const p=i.$1.addListener($=>this.j($));this.h.add((0,E.$Xc)(p)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(S){if(!S||S.code||(S.detail&&S.detail.stack&&(S=S.detail),i.$fb.isErrorNoTelemetry(S)||S instanceof D.$Al||typeof S?.message=="string"&&S.message.includes("Unable to read file")))return;const y=Array.isArray(S.stack)?S.stack.join(`
`):S.stack,p=S.message?S.message:(0,I.$ro)(S);y&&this.k({msg:p,callstack:y})}k(S){const y=(0,t.$Ab)(this.g,S,T.compare);y<0?(S.count=1,this.g.splice(~y,0,S)):(this.g[y].count||(this.g[y].count=0),this.g[y].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const S of this.g)this.c.publicLogError2("UnhandledError",S);this.g.length=0}}e.default=v}),define(Oe[24],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em=(0,t.$Ki)("telemetryService"),e.$fm=(0,t.$Ki)("customEndpointTelemetryService"),e.$gm="telemetry.currentSessionDate",e.$hm="telemetry.firstSessionDate",e.$im="telemetry.lastSessionDate",e.$jm="telemetry.machineId",e.$km="telemetry.sqmId",e.$lm="telemetry.devDeviceId",e.$mm="telemetry",e.$nm="telemetry.telemetryLevel",e.$om="telemetry.enableCrashReporter",e.$pm="telemetry.enableTelemetry";var i;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(i||(e.TelemetryLevel=i={}));var E;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(E||(e.TelemetryConfiguration=E={}))}),define(Oe[231],Le([1,0,20,31,13,42,12,8,3,43,4,114,26,117,207,15,29,24]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=void 0,e.$9s=d,e.$0s=o,e.$$s=l,t=We(t),i=We(i);const g=new Map;async function d(u,r){const f=`${u}::${r.join(":")}`,h=g.get(f);if(h)return h;const k=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i},{tag:"cursorrules",filePattern:/^\.cursorrules$/i}],P=new Map,O=new Map,C=2e4;function L(z,Q,J,x){const ve=Q.substring(z.length+1);return E.Promises.withAsyncBody(async be=>{let se;x.readdirCount++;try{se=await p.Promises.readdir(Q,{withFileTypes:!0})}catch{be();return}if(x.count>=C){x.count+=se.length,x.maxReached=!0,be();return}let V=se.length;if(V===0){be();return}let B=se;x.count+se.length>C&&(x.maxReached=!0,V=C-x.count,B=se.slice(0,V)),x.count+=se.length;for(const j of B)if(j.isDirectory()){if(J.includes(j.name)||await L(z,(0,T.$oc)(Q,j.name),J,x),--V===0){be();return}}else{const U=j.name.lastIndexOf(".");if(U>=0){const te=j.name.substring(U+1);te&&P.set(te,(P.get(te)??0)+1)}for(const te of k)te.relativePathPattern?.test(ve)!==!1&&te.filePattern.test(j.name)&&O.set(te.tag,(O.get(te.tag)??0)+1);if(--V===0){be();return}}})}const R=E.Promises.withAsyncBody(async z=>{const Q={count:0,maxReached:!1,readdirCount:0},J=new s.$ke(!0);await L(u,u,r,Q);const x=await l(u);z({configFiles:w(O),fileTypes:w(P),fileCount:Q.count,maxFilesReached:Q.maxReached,launchConfigFiles:x,totalScanTime:J.elapsed(),totalReaddirCount:Q.readdirCount})});return g.set(f,R),R}function w(u){return Array.from(u.entries(),([r,f])=>({name:r,count:f})).sort((r,f)=>f.count-r.count)}function o(){const u={os:`${i.type()} ${i.arch()} ${i.release()}`,memory:`${(i.totalmem()/c.$Nl.GB).toFixed(2)}GB (${(i.freemem()/c.$Nl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.$1n.value()*100)}%`},r=i.cpus();return r&&r.length>0&&(u.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),u}async function l(u){try{const r=new Map,f=(0,T.$oc)(u,".vscode","launch.json"),h=await t.promises.readFile(f),k=[],P=(0,I.$7n)(h.toString(),k);if(k.length)return console.log(`Unable to parse ${f}`),[];if((0,I.$co)(P)==="object"&&P.configurations)for(const O of P.configurations){const C=O.type;C&&(r.has(C)?r.set(C,r.get(C)+1):r.set(C,1))}return w(r)}catch{return[]}}let n=class{constructor(r,f){this.c=r,this.d=f}f(r){const f=[];return f.push(`OS Version:       ${r.os}`),f.push(`CPUs:             ${r.cpus}`),f.push(`Memory (System):  ${r.memory}`),f.push(`VM:               ${r.vmHint}`),f.join(`
`)}g(r){const f=[];f.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),f.push(`OS Version:       ${i.type()} ${i.arch()} ${i.release()}`);const h=i.cpus();return h&&h.length>0&&f.push(`CPUs:             ${h[0].model} (${h.length} x ${h[0].speed})`),f.push(`Memory (System):  ${(i.totalmem()/c.$Nl.GB).toFixed(2)}GB (${(i.freemem()/c.$Nl.GB).toFixed(2)}GB free)`),v.$l||f.push(`Load (avg):       ${i.loadavg().map(k=>Math.round(k)).join(", ")}`),f.push(`VM:               ${Math.round(y.$1n.value()*100)}%`),f.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),f.push(`Process Argv:     ${r.mainArguments.join(" ")}`),f.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),f.join(`
`)}async getPerformanceInfo(r,f){return Promise.all([(0,$.$8s)(r.mainPID),this.k(r)]).then(async h=>{let[k,P]=h,O=this.m(r,k);return f.forEach(C=>{if((0,a.$Zm)(C))O+=`
${C.errorMessage}`,P+=`
${C.errorMessage}`;else if(O+=`

Remote: ${C.hostName}`,C.processes&&(O+=`
${this.m(r,C.processes)}`),C.workspaceMetadata){P+=`
|  Remote: ${C.hostName}`;for(const L of Object.keys(C.workspaceMetadata)){const R=C.workspaceMetadata[L];let z=`${R.fileCount} files`;R.maxFilesReached&&(z=`more than ${z}`),P+=`|    Folder (${L}): ${z}`,P+=this.h(R)}}}),{processInfo:O,workspaceInfo:P}})}async getSystemInfo(r,f){const{memory:h,vmHint:k,os:P,cpus:O}=o(),C={os:P,memory:h,cpus:O,vmHint:k,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:f};return v.$l||(C.load=`${i.loadavg().map(L=>Math.round(L)).join(", ")}`),v.$n&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(r,f){const h=[];return(0,$.$8s)(r.mainPID).then(async k=>(h.push(""),h.push(this.g(r)),h.push(""),h.push(this.m(r,k)),r.windows.some(P=>P.folderURIs&&P.folderURIs.length>0&&!P.remoteAuthority)&&(h.push(""),h.push("Workspace Stats: "),h.push(await this.k(r))),f.forEach(P=>{if((0,a.$Zm)(P))h.push(`
${P.errorMessage}`);else if(h.push(`

`),h.push(`Remote:           ${P.hostName}`),h.push(this.f(P.machineInfo)),P.processes&&h.push(this.m(r,P.processes)),P.workspaceMetadata)for(const O of Object.keys(P.workspaceMetadata)){const C=P.workspaceMetadata[O];let L=`${C.fileCount} files`;C.maxFilesReached&&(L=`more than ${L}`),h.push(`Folder (${O}): ${L}`),h.push(this.h(C))}}),h.push(""),h.push(""),h.join(`
`)))}h(r){const f=[];let k=0;const P=(R,z)=>{const Q=` ${R}(${z})`;k+Q.length>60?(f.push(O),O="|                 ",k=O.length):k+=Q.length,O+=Q};let O="|      File types:";const C=10,L=r.fileTypes.length>C?C:r.fileTypes.length;for(let R=0;R<L;R++){const z=r.fileTypes[R];P(z.name,z.count)}if(f.push(O),r.configFiles.length>=0&&(O="|      Conf files:",k=0,r.configFiles.forEach(R=>{P(R.name,R.count)}),f.push(O)),r.launchConfigFiles.length>0){let R="|      Launch Configs:";r.launchConfigFiles.forEach(z=>{const Q=z.count>1?` ${z.name}(${z.count})`:` ${z.name}`;R+=Q}),f.push(R)}return f.join(`
`)}j(r){const f=Math.max(...Object.keys(r).map(h=>h.length));return Object.keys(r).map(h=>`${h}:  ${" ".repeat(f-h.length)}  ${r[h]}`).join(`
                  `)}k(r){const f=[],h=[];return r.windows.forEach(k=>{k.folderURIs.length===0||k.remoteAuthority||(f.push(`|  Window (${k.title})`),k.folderURIs.forEach(P=>{const O=S.URI.revive(P);if(O.scheme===D.Schemas.file){const C=O.fsPath;h.push(d(C,["node_modules",".git"]).then(L=>{let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),f.push(`|    Folder (${(0,T.$sc)(C)}): ${R}`),f.push(this.h(L))}).catch(L=>{f.push(`|      Error: Unable to collect workspace stats for folder ${C} (${L.toString()})`)}))}else f.push(`|    Folder (${O.toString()}): Workspace stats not available.`)}))}),Promise.all(h).then(k=>f.join(`
`)).catch(k=>`Unable to collect workspace stats: ${k}`)}m(r,f){const h=new Map;r.windows.forEach(P=>h.set(P.pid,`window [${P.id}] (${P.title})`)),r.pidToNames.forEach(({pid:P,name:O})=>h.set(P,O));const k=[];return k.push("CPU %	Mem MB	   PID	Process"),f&&this.n(r.mainPID,h,k,f,0),k.join(`
`)}n(r,f,h,k,P){const O=P===0;let C;O?C=k.pid===r?`${this.d.applicationName} main`:"remote agent":f.has(k.pid)?C=f.get(k.pid):C=`${"  ".repeat(P)} ${k.name}`;const L=process.platform==="win32"?k.mem:i.totalmem()*(k.mem/100);h.push(`${k.load.toFixed(0).padStart(5," ")}	${(L/c.$Nl.MB).toFixed(0).padStart(6," ")}	${k.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(k.children)&&k.children.forEach(R=>this.n(r,f,h,R,P+1))}async getWorkspaceFileExtensions(r){const f=new Set;for(const{uri:h}of r.folders){const k=S.URI.revive(h);if(k.scheme!==D.Schemas.file)continue;const P=k.fsPath;try{(await d(P,["node_modules",".git"])).fileTypes.forEach(C=>f.add(C.name))}catch{}}return{extensions:[...f]}}async reportWorkspaceStats(r){for(const{uri:f}of r.folders){const h=S.URI.revive(f);if(h.scheme!==D.Schemas.file)continue;const k=h.fsPath;try{const P=await d(k,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),P.fileTypes.forEach(O=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:O.name,count:O.count})}),P.launchConfigFiles.forEach(O=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:O.name,count:O.count})}),P.configFiles.forEach(O=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:O.name,count:O.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:P.totalScanTime,reachedLimit:P.maxFilesReached,fileCount:P.fileCount,readdirCount:P.totalReaddirCount})}catch{}}}};e.$_s=n,e.$_s=n=Ve([je(0,b.$em),je(1,m.$yk)],n)}),define(Oe[95],Le([1,0,112,9,5,11,24]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=e.ExtensionSignatureVerificationCode=e.$Dq=void 0,e.$Dq=(0,E.$Ki)("IExtensionSignatureVerificationService");var T;(function(S){S.Success="Success",S.RequiredArgumentMissing="RequiredArgumentMissing",S.InvalidArgument="InvalidArgument",S.PackageIsUnreadable="PackageIsUnreadable",S.UnhandledException="UnhandledException",S.SignatureManifestIsMissing="SignatureManifestIsMissing",S.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",S.SignatureIsMissing="SignatureIsMissing",S.SignatureIsUnreadable="SignatureIsUnreadable",S.CertificateIsUnreadable="CertificateIsUnreadable",S.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",S.FileAlreadyExists="FileAlreadyExists",S.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",S.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",S.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",S.SignatureIsInvalid="SignatureIsInvalid",S.SignatureManifestIsInvalid="SignatureManifestIsInvalid",S.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",S.EntryIsMissing="EntryIsMissing",S.EntryIsTampered="EntryIsTampered",S.Untrusted="Untrusted",S.CertificateRevoked="CertificateRevoked",S.SignatureIsNotValid="SignatureIsNotValid",S.UnknownError="UnknownError",S.PackageIsInvalidZip="PackageIsInvalidZip",S.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(T||(e.ExtensionSignatureVerificationCode=T={}));class v extends Error{constructor(y){super(y),this.code=y}}e.$Eq=v;let s=class{constructor(y,p){this.b=y,this.c=p}d(){return this.a||(this.a=this.f()),this.a}async f(){return(0,t.$Bq)("@vscode/vsce-sign","src/main.js")}async verify(y,p,$,a){let c;const m=y.identifier.id;try{c=await this.d()}catch(w){return this.b.error("Could not load vsce-sign module",(0,i.$bb)(w)),this.b.info(`Extension signature verification is not done: ${m}`),!1}const b=new Date().getTime();let g;try{this.b.trace(`Verifying extension signature for ${m}...`),g=await c.verify(p,$,this.b.getLevel()===I.LogLevel.Trace)}catch(w){g={code:T.UnknownError,didExecute:!1,output:(0,i.$bb)(w)}}const d=new Date().getTime()-b;if(this.b.info(`Extension signature verification result for ${m}: ${g.code}. Executed: ${g.didExecute}. Duration: ${d}ms.`),this.b.trace(`Extension signature verification output for ${m}:
${g.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:m,extensionVersion:y.version,code:g.code,internalCode:g.internalCode,duration:d,didExecute:g.didExecute,clientTargetPlatform:a}),g.code===T.Success)return!0;throw new v(g.code)}};e.$Fq=s,e.$Fq=s=Ve([je(0,I.$fk),je(1,D.$em)],s)}),define(Oe[232],Le([1,0,2,24]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=void 0;class E extends t.$Zc{constructor(D,T){super(),this.a=D,this.b=T}async call(D,T,v){switch(T){case"updateTelemetryLevel":{const{telemetryLevel:s}=v;return this.a.updateInjectedTelemetryLevel(s)}case"logTelemetry":{const{eventName:s,data:S}=v;return this.b?this.b.log(s,S):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${T} not found`)}listen(D,T,v){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(i.TelemetryLevel.NONE),super.dispose()}}e.$ht=E}),define(Oe[40],Le([1,0,21,10,91,134,24]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0,e.$Mp=S,e.$Np=y,e.$Op=p,e.$Pp=$,e.$Qp=c,e.$Rp=b,e.$Sp=g,e.$Tp=o;class T{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$Fp=T;class v{constructor(){this.telemetryLevel=D.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Gp=v,e.$Hp=new v;class s{async publicLog(n,u,r){}async publicLogError(n,u,r){}}e.$Ip=s,e.$Jp="telemetry",e.$Kp="extensionTelemetryLog",e.$Lp={log:()=>null,flush:()=>Promise.resolve(null)};function S(l,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!l.enableTelemetry)}function y(l,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function p(l){const n=l.getValue(D.$nm),u=l.getValue(D.$om);if(l.getValue(D.$pm)===!1||u===!1)return D.TelemetryLevel.NONE;switch(n??D.TelemetryConfiguration.ON){case D.TelemetryConfiguration.ON:return D.TelemetryLevel.USAGE;case D.TelemetryConfiguration.ERROR:return D.TelemetryLevel.ERROR;case D.TelemetryConfiguration.CRASH:return D.TelemetryLevel.CRASH;case D.TelemetryConfiguration.OFF:return D.TelemetryLevel.NONE}}function $(l){const n={},u={},r={};m(l,r);for(let f in r){f=f.length>150?f.substr(f.length-149):f;const h=r[f];typeof h=="number"?u[f]=h:typeof h=="boolean"?u[f]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${h.length}`),n[f]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(n[f]=h)}return{properties:n,measurements:u}}const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(l){if(!l)return"none";const n=(0,E.$qn)(l);return a.has(n)?n:"other"}function m(l,n,u=0,r){if(l)for(const f of Object.getOwnPropertyNames(l)){const h=l[f],k=r?r+f:f;Array.isArray(h)?n[k]=(0,t.$ro)(h):h instanceof Date?n[k]=h.toISOString():(0,i.$lg)(h)?u<2?m(h,n,u+1,k+"."):n[k]=(0,t.$ro)(h):n[k]=h}}function b(l,n){const u=l.msftInternalDomains||[],r=n.getValue("telemetry.internalTesting");return(0,I.$Ep)(u)||r}function g(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function d(l,n){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let u=l;const r=[];for(const P of n)for(;;){const O=P.exec(l);if(!O)break;r.push([O.index,P.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(u="";;){const P=h.exec(l);if(!P)break;const O=r.some(([C,L])=>P.index<L&&C<h.lastIndex);!f.test(P[0])&&!O&&(u+=l.substring(k,P.index)+"<REDACTED: user-file-path>",k=h.lastIndex)}return k<l.length&&(u+=l.substr(k)),u}function w(l){if(!l)return l;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of n)if(u.regex.test(l))return`<REDACTED: ${u.label}>`;return l}function o(l,n){return(0,t.$oo)(l,u=>{if(u instanceof T||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let r=u.replaceAll("%20"," ");r=d(r,n);for(const f of n)r=r.replace(f,"");return r=w(r),r}})}}),define(Oe[38],Le([1,0,16,30,22,3,4,9,32,40]),function(ue,e,t,i,E,I,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$Vp=void 0,e.$Up=S,e.$Wp=a,e.$Xp=c,e.$Yp=m,e.$Zp=b,e.$1p=g,e.$2p=d,e.$3p=w,e.$5p=o,e.$6p=n;function S(u,r){return u.uuid&&r.uuid?u.uuid===r.uuid:u.id===r.id?!0:(0,t.$Ff)(u.id,r.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(r){const f=r.manifest?r.manifest.version:r.version,h=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new p(r.identifier,f,h)}static parse(r){const f=y.exec(r);return f&&f[1]&&f[2]?new p({id:f[1]},f[2],f[4]||void 0):null}constructor(r,f,h=E.TargetPlatform.UNDEFINED){this.identifier=r,this.version=f,this.targetPlatform=h,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==E.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof p?S(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.$Vp=p;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function a(u){const r=$.exec(u);return r&&r[1]?[m(r[1]),r[2]]:[m(u),void 0]}function c(u,r){return`${u}.${r}`}function m(u){return u.toLowerCase()}function b(u,r){return m(c(u??E.$vn,r))}function g(u,r){const f=[],h=k=>{for(const P of f)if(P.some(O=>S(r(O),r(k))))return P;return null};for(const k of u){const P=h(k);P?P.push(k):f.push([k])}return f}function d(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}function w(u){return{id:new s.$Fp(u.identifier.id),name:new s.$Fp(u.name),version:u.version,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$4p=new E.$zn("pprice.better-merge");function o(u,r){const f=[],h=r.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const k=h.shift();if(k&&f.every(P=>!S(P.identifier,{id:k}))){const P=u.filter(O=>S(O.identifier,{id:k}));P.length===1&&(f.push(P[0]),h.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}async function l(u,r){if(!I.$n)return!1;let f;try{f=(await u.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{f=(await u.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){r.debug("Error while getting the os-release file.",(0,T.$bb)(k))}}return!!f&&(f.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(u,r){const f=await l(u,r),h=(0,i.$pp)(f?"alpine":I.$x,v.$jc);return r.debug("ComputeTargetPlatform:",h),h}}),define(Oe[135],Le([1,0,18,9,12,19,63,4,7,30,38,22]),function(ue,e,t,i,E,I,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=void 0;const p=c=>(0,v.localize)(1783,null,c),$=(0,v.localize)(1784,null,"ms-dotnettools.csharp");let a=class{constructor(m,b,g){this.a=m,this.b=b,this.d=g}get f(){}async listExtensions(m,b,g){let d=await this.b.getInstalled(y.ExtensionType.User,g);const w=y.$yn.map(l=>l.toLowerCase());if(b&&b!==""){if(w.indexOf(b.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}d=d.filter(l=>l.manifest.categories?l.manifest.categories.map(u=>u.toLowerCase()).indexOf(b.toLowerCase())>-1:!1)}else if(b===""){this.a.info("Possible Categories: "),w.forEach(l=>{this.a.info(l)});return}this.f&&this.a.info((0,v.localize)(1785,null,this.f)),d=d.sort((l,n)=>l.identifier.id.localeCompare(n.identifier.id));let o;for(const l of d)o!==l.identifier.id&&(o=l.identifier.id,this.a.info(m?`${o}@${l.manifest.version}`:o))}async installExtensions(m,b,g,d){const w=[];try{m.length&&this.a.info(this.f?(0,v.localize)(1786,null,this.f):(0,v.localize)(1787,null));const o=[],l=[],n=(r,f,h)=>{l.push({id:r,version:f!=="prerelease"?f:void 0,installOptions:{...g,isBuiltin:h,installPreReleaseVersion:f==="prerelease"||g.installPreReleaseVersion}})};for(const r of m)if(r instanceof T.URI)o.push({vsix:r,installOptions:g});else{const[f,h]=(0,S.$Wp)(r);n(f,h,!1)}for(const r of b)if(r instanceof T.URI)o.push({vsix:r,installOptions:{...g,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[f,h]=(0,S.$Wp)(r);n(f,h,!0)}const u=await this.b.getInstalled(void 0,g.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:f})=>{try{await this.h(r,f,d,u)}catch(h){this.a.error(h),w.push(r.toString())}})),l.length){const r=await this.g(l,u,d);w.push(...r)}}catch(o){throw this.a.error((0,v.localize)(1788,null,(0,i.$bb)(o))),o}if(w.length)throw new Error((0,v.localize)(1789,null,w.join(", ")))}async updateExtensions(m){const b=await this.b.getInstalled(y.ExtensionType.User,m),g=[];for(const l of b)l.identifier.uuid&&g.push({...l.identifier,preRelease:l.preRelease});this.a.trace((0,v.localize)(1790,null,g.length));const d=await this.d.getExtensions(g,{compatible:!0},t.CancellationToken.None),w=[];for(const l of d)for(const n of b)(0,S.$Up)(n.identifier,l.identifier)&&(0,D.gt)(l.version,n.manifest.version)&&w.push({extension:l,options:{operation:s.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:m,isApplicationScoped:n.isApplicationScoped}});if(!w.length){this.a.info((0,v.localize)(1791,null));return}this.a.info((0,v.localize)(1792,null,w.map(l=>l.extension.identifier.id).join(", ")));const o=await this.b.installGalleryExtensions(w);for(const l of o)l.error?this.a.error((0,v.localize)(1793,null,l.identifier.id,(0,i.$bb)(l.error))):this.a.info((0,v.localize)(1794,null,l.identifier.id,l.local?.manifest.version))}async g(m,b,g){if(m=m.filter(({id:l,version:n})=>{const u=b.find(r=>(0,S.$Up)(r.identifier,{id:l}));if(u){if(!g&&(!n||n==="prerelease"&&u.preRelease))return this.a.info((0,v.localize)(1795,null,l,u.manifest.version,l)),!1;if(n&&u.manifest.version===n)return this.a.info((0,v.localize)(1796,null,`${l}@${n}`)),!1}return!0}),!m.length)return[];const d=[],w=[],o=await this.j(m);if(await Promise.all(m.map(async({id:l,version:n,installOptions:u})=>{const r=o.get(l.toLowerCase());if(!r){this.a.error(`${p(n?`${l}@${n}`:l)}
${$}`),d.push(l);return}try{const h=await this.d.getManifest(r,t.CancellationToken.None);if(h&&!this.k(h))return}catch(h){this.a.error(h.message||h.stack||h),d.push(l);return}const f=b.find(h=>(0,S.$Up)(h.identifier,r.identifier));if(f){if(r.version===f.manifest.version){this.a.info((0,v.localize)(1797,null,n?`${l}@${n}`:l));return}this.a.info((0,v.localize)(1798,null,l,r.version))}u.isBuiltin?this.a.info(n?(0,v.localize)(1799,null,l,n):(0,v.localize)(1800,null,l)):this.a.info(n?(0,v.localize)(1801,null,l,n):(0,v.localize)(1802,null,l)),w.push({extension:r,options:{...u,installGivenVersion:!!n,isApplicationScoped:u.isApplicationScoped||f?.isApplicationScoped}})})),w.length){const l=await this.b.installGalleryExtensions(w);for(const n of l)n.error?(this.a.error((0,v.localize)(1803,null,n.identifier.id,(0,i.$bb)(n.error))),d.push(n.identifier.id)):this.a.info((0,v.localize)(1804,null,n.identifier.id,n.local?.manifest.version))}return d}async h(m,b,g,d){const w=await this.b.getManifest(m);if(!w)throw new Error("Invalid vsix");if(await this.l(w,g,b.profileLocation,d))try{await this.b.install(m,{...b,installGivenVersion:!0}),this.a.info((0,v.localize)(1805,null,(0,I.$ih)(m)))}catch(l){if((0,i.$8)(l))this.a.info((0,v.localize)(1806,null,(0,I.$ih)(m)));else throw l}}async j(m){const b=new Map,g=m.some(o=>o.installOptions.installPreReleaseVersion),d=await this.b.getTargetPlatform(),w=[];for(const o of m)s.$hp.test(o.id)&&w.push({...o,preRelease:g});if(w.length){const o=await this.d.getExtensions(w,{targetPlatform:d},t.CancellationToken.None);for(const l of o)b.set(l.identifier.id.toLowerCase(),l)}return b}k(m){return!0}async l(m,b,g,d){if(!b){const w={id:(0,S.$Zp)(m.publisher,m.name)},o=d.find(l=>(0,S.$Up)(w,l.identifier)&&(0,D.gt)(l.manifest.version,m.version));if(o)return this.a.info((0,v.localize)(1807,null,o.identifier.id,o.manifest.version,m.version)),!1}return this.k(m)}async uninstallExtensions(m,b,g){const d=async o=>{if(o instanceof T.URI){const l=await this.b.getManifest(o);return(0,S.$Xp)(l.publisher,l.name)}return o},w=[];for(const o of m){const l=await d(o),u=(await this.b.getInstalled(void 0,g)).filter(r=>(0,S.$Up)(r.identifier,{id:l}));if(!u.length)throw new Error(`${this.m(l)}
${$}`);if(u.some(r=>r.type===y.ExtensionType.System)){this.a.info((0,v.localize)(1808,null,l));return}if(!b&&u.some(r=>r.isBuiltin)){this.a.info((0,v.localize)(1809,null,l));return}this.a.info((0,v.localize)(1810,null,l));for(const r of u)await this.b.uninstall(r,{profileLocation:g}),w.push(r);this.f?this.a.info((0,v.localize)(1811,null,l,this.f)):this.a.info((0,v.localize)(1812,null,l))}}async locateExtension(m){const b=await this.b.getInstalled();m.forEach(g=>{b.forEach(d=>{if(d.identifier.id===g&&d.location.scheme===E.Schemas.file){this.a.info(d.location.fsPath);return}})})}m(m){return this.f?(0,v.localize)(1813,null,m,this.f):(0,v.localize)(1814,null,m)}};e.$Gq=a,e.$Gq=a=Ve([je(1,s.$wp),je(2,s.$tp)],a)}),define(Oe[233],Le([1,0,9,6,2,25,38,22,15]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class s extends E.$Zc{constructor(y,p,$,a,c,m,b){super(),this.f=y,this.g=p,this.h=$,this.j=a,this.m=c,this.n=m,this.r=b,this.a=this.B(new i.$qe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new E.$9c),this.s().then(null,g=>b.error("Error while initializing Extensions Watcher",(0,t.$bb)(g)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(y=>this.u(y.added))),this.B(this.j.onAddExtensions(y=>this.w(y))),this.B(this.j.onDidAddExtensions(y=>this.y(y))),this.B(this.j.onRemoveExtensions(y=>this.z(y))),this.B(this.j.onDidRemoveExtensions(y=>this.C(y))),this.B(this.n.onDidFilesChange(y=>this.D(y)))}async u(y){try{y.length&&await Promise.all(y.map(p=>(this.c.set(p.id,(0,E.$Wc)(this.n.watch(this.m.extUri.dirname(p.extensionsResource)),this.n.watch(p.extensionsResource))),this.G(p.extensionsResource))))}catch(p){throw this.r.error(p),p}}async w(y){for(const p of y.extensions)this.I(this.L(p.identifier,p.version),y.profileLocation)}async y(y){for(const p of y.extensions){const $=this.L(p.identifier,p.version);y.error?this.J($,y.profileLocation):this.I($,y.profileLocation)}}async z(y){for(const p of y.extensions)this.J(this.L(p.identifier,p.version),y.profileLocation)}async C(y){const p=[],$=[];for(const a of y.extensions){const c=this.L(a.identifier,a.version);y.error?this.I(c,y.profileLocation):(this.J(c,y.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",a.identifier.id,a.version),$.push(this.f.scanInstalledExtensionAtLocation(a.location).then(m=>{m?p.push(m):this.r.info("Extension not found at the location",a.location.toString())},m=>this.r.error(m)))))}try{await Promise.all($),p.length&&await this.H(p)}catch(a){this.r.error(a)}}D(y){for(const p of this.h.profiles)y.contains(p.extensionsResource,v.FileChangeType.UPDATED,v.FileChangeType.ADDED)&&this.F(p.extensionsResource)}async F(y){const p=[],$=[],a=await this.j.scanProfileExtensions(y),c=new Set,m=new Set;for(const[b,g]of this.b)g.has(y)&&m.add(b);for(const b of a){const g=this.L(b.identifier,b.version);c.add(g),m.has(g)||(p.push(b.identifier),this.I(g,y))}for(const b of m)if(!c.has(b)){const g=this.M(b);g&&($.push(g.identifier),this.J(b,y))}(p.length||$.length)&&this.a.fire({added:p.length?{extensions:p,profileLocation:y}:void 0,removed:$.length?{extensions:$,profileLocation:y}:void 0})}async G(y){const p=await this.j.scanProfileExtensions(y);for(const $ of p)this.I(this.L($.identifier,$.version),y)}async H(y){y||(y=(await this.f.scanAllUserInstalledExtensions()).filter($=>!this.b.has(this.L($.identifier,$.manifest.version)))),y.length&&await this.f.markAsUninstalled(...y)}I(y,p){let $=this.b.get(y);$||this.b.set(y,$=new I.$Gc(a=>this.m.extUri.getComparisonKey(a))),$.add(p)}J(y,p){const $=this.b.get(y);$&&$.delete(p),$?.size||this.b.delete(y)}L(y,p){return`${T.$zn.toKey(y.id)}@${p}`}M(y){const[p,$]=(0,D.$Wp)(y);return $?{identifier:{id:p},version:$}:void 0}}e.$8q=s}),define(Oe[136],Le([1,0,20,96,17,13,2,12,8,26,27,30,38,11,92,4]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=void 0,t=We(t);let m=class extends a.$ks{constructor(w,o,l,n){super(l),this.h=w,this.j=n,this.g=this.B(new b(o,n)),this.h.registerParticipant({postInstall:async u=>this.m(u),postUninstall:async u=>this.n(u)})}async getBuiltInExtensionTranslationsUri(w,o){const n=(await this.g.getLanguagePacks())[o];if(!n){this.j.warn(`No language pack found for ${o}`);return}const u=n.translations[w];return u?c.URI.file(u):void 0}async getInstalledLanguages(){const w=await this.g.getLanguagePacks(),o=Object.keys(w).map(l=>{const n=w[l];return{...this.f(l,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return o.push(this.f("en","English")),o.sort((l,n)=>l.label.localeCompare(n.label)),o}async m(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",w.identifier.id),await this.update())}async n(w){const o=await this.g.getLanguagePacks();Object.keys(o).some(l=>o[l]&&o[l].extensions.some(n=>(0,p.$Up)(n.extensionIdentifier,w.identifier)))&&(this.j.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,o]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(o);return!(0,E.$yb)(Object.keys(w),Object.keys(l))}};e.$ls=m,e.$ls=m=Ve([je(0,y.$wp),je(1,S.$Si),je(2,y.$tp),je(3,$.$fk)],m);let b=class extends D.$Zc{constructor(w,o){super(),this.j=o,this.c={},this.f=(0,v.$oc)(w.userDataPath,"languagepacks.json"),this.g=new I.$Rh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(w){return this.s(o=>{Object.keys(o).forEach(l=>delete o[l]),this.m(o,...w)}).then(()=>this.c)}m(w,...o){for(const l of o)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(w,l);Object.keys(w).forEach(l=>this.r(w[l]))}n(w,o){const l=o.identifier,n=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const u of n)if(o.location.scheme===T.Schemas.file&&g(u)){let r=w[u.languageId];r||(r={hash:"",extensions:[],translations:{},label:u.localizedLanguageName??u.languageName},w[u.languageId]=r);const f=r.extensions.filter(h=>(0,p.$Up)(h.extensionIdentifier,l))[0];f?f.version=o.manifest.version:r.extensions.push({extensionIdentifier:l,version:o.manifest.version});for(const h of u.translations)r.translations[h.id]=(0,v.$oc)(o.location.fsPath,h.path)}}r(w){if(w){const o=(0,i.createHash)("md5");for(const l of w.extensions)o.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);w.hash=o.digest("hex")}}s(w=()=>null){return this.g.queue(()=>{let o=null;return t.promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(o=w(l),l)).then(l=>{for(const u of Object.keys(l))l[u]||delete l[u];this.c=l,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),s.Promises.writeFile(this.f,n)}).then(()=>o,l=>this.j.error(l))})}};b=Ve([je(0,S.$Si),je(1,$.$fk)],b);function g(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const w of d.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(Oe[234],Le([1,0,112,9,21,3,40]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3R=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0",v="https://mobile.events.data.microsoft.com/ping";async function s(y,p,$){I.$r;const a=await(0,t.$Bq)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,t.$Bq)("@microsoft/1ds-post-js","dist/ms.post.js"),m=new a.AppInsightsCore,b=new c.PostChannel,g={instrumentationKey:y,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if($){g.extensionConfig={};const d={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:$};g.extensionConfig[b.identifier]=d}return m.initialize(g,[]),m.addTelemetryInitializer(d=>{d.ext=d.ext??{},d.ext.web=d.ext.web??{},d.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',p&&(d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),m}class S{constructor(p,$,a,c,m){this.e=p,this.f=$,this.g=a,this.h=m,this.c=T,this.d=v,this.g||(this.g={}),typeof c=="function"?this.a=c():this.a=c,this.b=null}i(p){if(this.a){if(typeof this.a!="string"){p(this.a);return}this.b||(this.b=s(this.a,this.e,this.h)),this.b.then($=>{p($)},$=>{(0,i.$4)($),console.error($)})}}log(p,$){if(!this.a)return;$=(0,E.$po)($,this.g),$=(0,D.$Pp)($);const a=this.f+"/"+p;try{this.i(c=>{c.pluginVersionString=$?.properties.version??"Unknown",c.track({name:a,baseData:{name:a,properties:$?.properties,measurements:$?.measurements}})})}catch{}}flush(){return this.a?new Promise(p=>{this.i($=>{$.unload(!0,()=>{this.a=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.$3R=S});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[235],Le([1,0,2,21,3,16,7,28,46,62,29,37,24,40]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0,s=$t(s);let a=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(b,g,d){this.k=g,this.l=d,this.d={},this.i=new t.$Yc,this.j=[],this.b=b.appenders,this.c=b.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=b.piiPaths||[],this.g=p.TelemetryLevel.USAGE,this.h=!!b.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,I.$mf)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,I.$mf)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(p.$nm)||w.affectsConfiguration(p.$pm)||w.affectsConfiguration(p.$om))&&this.m()}))}setExperimentProperty(b,g){this.d[b]=g}m(){let b=(0,$.$Op)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const d=g.usage?p.TelemetryLevel.USAGE:g.error?p.TelemetryLevel.ERROR:p.TelemetryLevel.NONE;b=Math.min(b,d)}this.g=b}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(b,g,d){this.g<g||(d=(0,i.$po)(d,this.d),d=(0,$.$Tp)(d,this.j),d=(0,i.$po)(d,this.c),this.b.forEach(w=>w.log(b,d)))}publicLog(b,g){this.n(b,p.TelemetryLevel.USAGE,g)}publicLog2(b,g){this.publicLog(b,g)}publicLogError(b,g){this.h&&this.n(b,p.TelemetryLevel.ERROR,g)}publicLogError2(b,g){this.publicLogError(b,g)}};e.$rs=a,e.$rs=a=Ve([je(1,T.$ej),je(2,S.$yk)],a);function c(){const m=(0,D.localize)(2069,null,s.default.nameLong),b=s.default.privacyStatementUrl?(0,D.localize)(2071,null,"https://aka.ms/vscode-telemetry",s.default.privacyStatementUrl):(0,D.localize)(2070,null,"https://aka.ms/vscode-telemetry"),g=E.$r?"":(0,D.localize)(2072,null),d=(0,D.localize)(2073,null),w=(0,D.localize)(2074,null),o=(0,D.localize)(2075,null),l=(0,D.localize)(2076,null),n=`
|       | ${d} | ${w} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,u=(0,D.localize)(2077,null);return`
${m} ${b} ${g}

&nbsp;

${l}
${n}

&nbsp;

${u}
`}y.$zo.as(v.$Eo.Configuration).registerConfiguration({id:p.$mm,order:1,type:"object",title:(0,D.localize)(2078,null),properties:{[p.$nm]:{type:"string",enum:[p.TelemetryConfiguration.ON,p.TelemetryConfiguration.ERROR,p.TelemetryConfiguration.CRASH,p.TelemetryConfiguration.OFF],enumDescriptions:[(0,D.localize)(2079,null),(0,D.localize)(2080,null),(0,D.localize)(2081,null),(0,D.localize)(2082,null)],markdownDescription:c(),default:p.TelemetryConfiguration.ON,restricted:!0,scope:v.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),y.$zo.as(v.$Eo.Configuration).registerConfiguration({id:p.$mm,order:110,type:"object",title:(0,D.localize)(2083,null),properties:{[p.$pm]:{type:"boolean",markdownDescription:s.default.privacyStatementUrl?(0,D.localize)(2085,null,s.default.nameLong,s.default.privacyStatementUrl):(0,D.localize)(2084,null,s.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(2086,null,`\`#${p.$nm}#\``),scope:v.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(Oe[236],Le([1,0,28,5,29,24,235,40]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=e.$et=void 0;let v=class extends D.$rs{constructor(S,y,p,$){super(S,p,$),this.o=y}publicLog(S,y){if(!(this.o<I.TelemetryLevel.USAGE))return super.publicLog(S,y)}publicLog2(S,y){return this.publicLog(S,y)}publicLogError(S,y){return this.o<I.TelemetryLevel.ERROR?Promise.resolve(void 0):super.publicLogError(S,y)}publicLogError2(S,y){return this.publicLogError(S,y)}async updateInjectedTelemetryLevel(S){if(S===void 0)throw this.o=I.TelemetryLevel.NONE,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,S):S,this.o===I.TelemetryLevel.NONE&&this.dispose()}};e.$et=v,e.$et=v=Ve([je(2,t.$ej),je(3,E.$yk)],v),e.$ft=new class extends T.$Gp{async updateInjectedTelemetryLevel(){}},e.$gt=(0,i.$Li)(I.$em)}),define(Oe[237],Le([1,0,14,18,238,234]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=void 0,E=We(E);async function D(S,y){const p=await y.request(S,i.CancellationToken.None),$=(await(0,t.$5e)(p.stream)).toString(),a=p.res.statusCode??200;return{headers:p.res.headers,statusCode:a,responseData:$}}async function T(S){const y={method:S.type,headers:S.headers};return new Promise(($,a)=>{const c=E.request(S.url??"",y,m=>{m.on("data",function(b){$({headers:m.headers,statusCode:m.statusCode??200,responseData:b.toString()})}),m.on("error",function(b){a(b)})});c.write(S.data,m=>{m&&a(m)}),c.end()})}async function v(S,y,p){const $=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),a={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:$};try{const c=S?await D(a,S):await T(a);p(c.statusCode,c.headers,c.responseData)}catch{p(0,{})}}class s extends I.$3R{constructor(y,p,$,a,c){const m={sendPOST:(b,g)=>{v(y,b,g)}};super(p,$,a,c,m)}}e.$4R=s});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[239],Le([1,0,9,230]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i=$t(i);class E extends i.default{i(){(0,t.setUnexpectedErrorHandler)(T=>console.error(T));const D=[];process.on("unhandledRejection",(T,v)=>{D.push(v),setTimeout(()=>{const s=D.indexOf(v);s>=0&&v.catch(S=>{D.splice(s,1),(0,t.$8)(S)||(console.warn(`rejected promise not handled within 1 second: ${S}`),S.stack&&console.warn(`stack trace: ${S.stack}`),T&&(0,t.$4)(T))})},1e3)}),process.on("rejectionHandled",T=>{const v=D.indexOf(T);v>=0&&D.splice(v,1)}),process.on("uncaughtException",T=>{(0,t.$3)(T)||(0,t.$4)(T)})}}e.default=E}),define(Oe[137],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var t;(function(i){i[i.Replace=1]="Replace",i[i.Append=2]="Append",i[i.Prepend=3]="Prepend"})(t||(e.EnvironmentVariableMutatorType=t={}))}),define(Oe[138],Le([1,0,3,137]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;const E=new Map([[i.EnvironmentVariableMutatorType.Append,"APPEND"],[i.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[i.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class I{constructor(S){this.collections=S,this.a=new Map,this.b=new Map,S.forEach((y,p)=>{this.d(y,p);const $=y.map.entries();let a=$.next();for(;!a.done;){const c=a.value[1],m=a.value[0];let b=this.a.get(m);if(b||(b=[],this.a.set(m,b)),b.length>0&&b[0].type===i.EnvironmentVariableMutatorType.Replace){a=$.next();continue}const g={extensionIdentifier:p,value:c.value,type:c.type,scope:c.scope,variable:c.variable,options:c.options};g.scope||delete g.scope,b.unshift(g),a=$.next()}})}async applyToProcessEnvironment(S,y,p){let $;t.$l&&($={},Object.keys(S).forEach(a=>$[a.toLowerCase()]=a));for(const[a,c]of this.getVariableMap(y)){const m=t.$l&&$[a.toLowerCase()]||a;for(const b of c){const g=p?await p(b.value):b.value;if(b.options?.applyAtProcessCreation??!0)switch(b.type){case i.EnvironmentVariableMutatorType.Append:S[m]=(S[m]||"")+g;break;case i.EnvironmentVariableMutatorType.Prepend:S[m]=g+(S[m]||"");break;case i.EnvironmentVariableMutatorType.Replace:S[m]=g;break}if(b.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${E.get(b.type)}`;S[d]=(S[d]?S[d]+":":"")+a+"="+this.c(g)}}}}c(S){return S.replaceAll(":","\\x3a")}diff(S,y){const p=new Map,$=new Map,a=new Map;if(S.getVariableMap(y).forEach((c,m)=>{const b=this.getVariableMap(y).get(m),g=T(c,b);g&&p.set(m,g)}),this.getVariableMap(y).forEach((c,m)=>{const b=S.getVariableMap(y).get(m),g=T(c,b);g&&a.set(m,g)}),this.getVariableMap(y).forEach((c,m)=>{const b=S.getVariableMap(y).get(m),g=v(c,b);g&&$.set(m,g)}),!(p.size===0&&$.size===0&&a.size===0))return{added:p,changed:$,removed:a}}getVariableMap(S){const y=new Map;for(const p of this.a.values()){const $=p.filter(a=>D(a,S));$.length>0&&y.set($[0].variable,$)}return y}getDescriptionMap(S){const y=new Map;for(const p of this.b.values()){const $=p.filter(a=>D(a,S,!0));for(const a of $)y.set(a.extensionIdentifier,a.description)}return y}d(S,y){if(!S.descriptionMap)return;const p=S.descriptionMap.entries();let $=p.next();for(;!$.done;){const a=$.value[1],c=$.value[0];let m=this.b.get(c);m||(m=[],this.b.set(c,m));const b={extensionIdentifier:y,scope:a.scope,description:a.description};b.scope||delete b.scope,m.push(b),$=p.next()}}}e.$Vs=I;function D(s,S,y=!1){return s.scope?!!(s.scope.workspaceFolder&&S?.workspaceFolder&&s.scope.workspaceFolder.index===S.workspaceFolder.index):y?S===s.scope:!0}function T(s,S){if(!S)return s;const y=new Set;S.forEach($=>y.add($.extensionIdentifier));const p=[];return s.forEach($=>{y.has($.extensionIdentifier)||p.push($)}),p.length===0?void 0:p}function v(s,S){if(!S)return;const y=new Map;S.forEach($=>y.set($.extensionIdentifier,$));const p=[];return s.forEach($=>{const a=y.get($.extensionIdentifier);a&&($.type!==a.type||$.value!==a.value||$.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&p.push(a)}),p.length===0?void 0:p}}),define(Oe[97],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=t,e.$Qs=i,e.$Rs=E,e.$Ss=I,e.$Ts=D,e.$Us=T;function t(v){return[...v.entries()]}function i(v){return v?[...v.entries()]:[]}function E(v){return new Map(v)}function I(v){return new Map(v??[])}function D(v){return Array.from(v.entries()).map(s=>[s[0],t(s[1].map),i(s[1].descriptionMap)])}function T(v){return new Map(v.map(s=>[s[0],{map:E(s[1]),descriptionMap:I(s[2])}]))}}),define(Oe[240],Le([1,0,13,18,6,2,11]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0;let T=class extends I.$Zc{constructor(s,S){super(),this.h=S,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new E.$qe),this.onCreateRequest=this.g.event,this.b=s===void 0?15e3:s,this.B((0,I.$Xc)(()=>{for(const y of this.f.values())(0,I.$Uc)(y)}))}createRequest(s){return new Promise((S,y)=>{const p=++this.a;this.c.set(p,S),this.g.fire({requestId:p,...s});const $=new i.$Be;(0,t.$Lh)(this.b,$.token).then(()=>y(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,I.$Xc)(()=>$.cancel())])})}acceptReply(s,S){const y=this.c.get(s);y?(this.c.delete(s),(0,I.$Uc)(this.f.get(s)||[]),this.f.delete(s),y(S)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${s}`)}};e.$Gs=T,e.$Gs=T=Ve([je(1,D.$fk)],T)}),define(Oe[53],Le([1,0,5,41,37]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=e.$Bs=e.$As=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$zs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ys=void 0,e.$ys=new i.$2j("terminalTabFocusMode",!1,!0);var I;(function(l){l.AutomationProfile="terminal.integrated.automationProfile.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(I||(e.TerminalSettingPrefix=I={}));var D;(function(l){l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.TabStopWidth="terminal.integrated.tabStopWidth",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorStyleInactive="terminal.integrated.cursorStyleInactive",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.MiddleClickBehavior="terminal.integrated.middleClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.EnableVisualBell="terminal.integrated.enableVisualBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.TabFocusMode="terminal.integrated.tabFocusMode",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.HideOnStartup="terminal.integrated.hideOnStartup",l.CustomGlyphs="terminal.integrated.customGlyphs",l.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.EnableImages="terminal.integrated.enableImages",l.SmoothScrolling="terminal.integrated.smoothScrolling",l.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",l.FocusAfterRun="terminal.integrated.focusAfterRun",l.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",l.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",l.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var T;(function(l){l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh"})(T||(e.PosixShellType=T={}));var v;(function(l){l.CommandPrompt="cmd",l.Wsl="wsl",l.GitBash="gitbash"})(v||(e.WindowsShellType=v={}));var s;(function(l){l.PowerShell="pwsh",l.Python="python",l.Julia="julia",l.NuShell="nu"})(s||(e.GeneralShellType=s={}));var S;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})(S||(e.TitleEventSource=S={}));var y;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.PtyHostWindow="ptyHostWindow",l.Logger="logger",l.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var p;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(p||(e.ProcessPropertyType=p={})),e.$zs=(0,t.$Ki)("ptyService");var $;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})($||(e.HeartbeatConstants=$={}));var a;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(a||(e.TerminalLocation=a={}));var c;(function(l){l.TerminalView="view",l.Editor="editor"})(c||(e.TerminalLocationString=c={}));var m;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var b;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(b||(e.FlowControlConstants=b={}));var g;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var d;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var w;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(w||(e.TerminalExitReason=w={})),e.$As={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(n){const u=this.b(n.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,n)}getTerminalBackend(n){return this.a.get(this.b(n))}b(n){return n?.toLowerCase()??""}}E.$zo.add(e.$As.Backend,new o),e.$Bs=(0,t.$Ki)("localPtyService"),e.$Cs=(0,t.$Ki)("terminalLogService")}),define(Oe[139],Le([1,0,3]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ER=i,e.$FR=E,e.$GR=I,e.$HR=D;function i(T){let v=T;v.includes("\\")&&(v=v.replace(/\\/g,"\\\\"));const s=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return v=v.replace(s,""),`'${v}'`}function E(T,v,s){if(!T)return"";if(!v)return T;v.match(/[\/\\]$/)&&(v=v.slice(0,v.length-1));const S=T.replace(/\\/g,"/").toLowerCase(),y=v.replace(/\\/g,"/").toLowerCase();return S.includes(y)?`~${s}${T.slice(v.length+1)}`:T}function I(T){return T.match(/^['"].*['"]$/)&&(T=T.substring(1,T.length-1)),t.OS===t.OperatingSystem.Windows&&T&&T[1]===":"?T[0].toUpperCase()+T.substring(1):T}function D(T){return!T.strictEnv}}),define(Oe[241],Le([1,0,57,4,7,83]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=D,e.$Is=s,e.$Js=S,e.$Ks=y;function D(p,$){const a=[{name:null,description:(0,E.localize)(2119,null)}];return a.push(...p.map(c=>({name:c.profileName,description:T(c)}))),$&&a.push(...$.map(c=>({name:c.title,description:v(c)}))),{values:a.map(c=>c.name),markdownDescriptions:a.map(c=>c.description)}}function T(p){let $=`$(${I.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:t.$0j.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?$+=`
- args: "${p.args}"`:$+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&($+=`
- overrideName: ${p.overrideName}`),p.color&&($+=`
- color: ${p.color}`),p.env&&($+=`
- env: ${JSON.stringify(p.env)}`),$}function v(p){return`$(${I.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:t.$0j.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function s(p,$){if(!p&&!$)return!0;if(typeof p=="string"&&typeof $=="string")return p===$;if(Array.isArray(p)&&Array.isArray($)){if(p.length!==$.length)return!1;for(let a=0;a<p.length;a++)if(p[a]!==$[a])return!1;return!0}return!1}function S(p,$){if(!p&&!$)return!0;if(!p||!$)return!1;if(I.ThemeIcon.isThemeIcon(p)&&I.ThemeIcon.isThemeIcon($))return p.id===$.id&&p.color===$.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof $=="object"&&"light"in $&&"dark"in $){const a=p,c=$;if((i.URI.isUri(a.light)||y(a.light))&&(i.URI.isUri(a.dark)||y(a.dark))&&(i.URI.isUri(c.light)||y(c.light))&&(i.URI.isUri(c.dark)||y(c.dark)))return a.light.path===c.light.path&&a.dark.path===c.dark.path}if(i.URI.isUri(p)&&i.URI.isUri($)||y(p)||y($)){const a=p,c=$;return a.path===c.path&&a.scheme===c.scheme}return!1}function y(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}}),define(Oe[242],Le([1,0,57,3,7,46,37,53,241]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=e.$Ls=void 0,e.$Ns=a,e.$Os=m,e.$Ls={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Ms={type:"string",enum:Array.from((0,t.$8j)(),b=>b.id),markdownEnumDescriptions:Array.from((0,t.$8j)(),b=>`$(${b.id})`)};const s={args:{description:(0,E.localize)(2088,null),type:"array",items:{type:"string"}},overrideName:{description:(0,E.localize)(2089,null),type:"boolean"},icon:{description:(0,E.localize)(2090,null),...e.$Ms},color:{description:(0,E.localize)(2091,null),...e.$Ls},env:{markdownDescription:(0,E.localize)(2092,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(2093,null),type:["string","array"],items:{type:"string"}},...s}},y={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(2094,null),type:["string"],items:{type:"string"}},...s}};function p(b){const g=b===i.Platform.Linux?"linux":b===i.Platform.Mac?"osx":"windows";return(0,E.localize)(2095,null,(0,i.$k)(b),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const $={id:"terminal",order:100,title:(0,E.localize)(2096,null),type:"object",properties:{[T.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(2097,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[T.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(2098,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[T.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(2099,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[T.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:p(i.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,E.localize)(2100,null),enum:["PowerShell","Git Bash"]},...s}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(2101,null),type:"string"},id:{description:(0,E.localize)(2102,null),type:"string"},title:{description:(0,E.localize)(2103,null),type:"string"},...s}},{type:"null"},S]}},[T.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:p(i.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(2104,null),type:"string"},id:{description:(0,E.localize)(2105,null),type:"string"},title:{description:(0,E.localize)(2106,null),type:"string"},...s}},{type:"null"},S]}},[T.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:p(i.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(2107,null),type:"string"},id:{description:(0,E.localize)(2108,null),type:"string"},title:{description:(0,E.localize)(2109,null),type:"string"},...s}},{type:"null"},S]}},[T.TerminalSettingId.UseWslProfiles]:{description:(0,E.localize)(2110,null),type:"boolean",default:!0},[T.TerminalSettingId.InheritEnv]:{scope:I.ConfigurationScope.APPLICATION,description:(0,E.localize)(2111,null),type:"boolean",default:!0},[T.TerminalSettingId.PersistentSessionScrollback]:{scope:I.ConfigurationScope.APPLICATION,markdownDescription:(0,E.localize)(2112,null),type:"number",default:100},[T.TerminalSettingId.ShowLinkHover]:{scope:I.ConfigurationScope.APPLICATION,description:(0,E.localize)(2113,null),type:"boolean",default:!0},[T.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,E.localize)(2114,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function a(){D.$zo.as(I.$Eo.Configuration).registerConfiguration($),m()}let c;function m(b,g){const d=D.$zo.as(I.$Eo.Configuration);let w;b&&(w=(0,v.$Hs)(b?.profiles,g));const o=c;c={id:"terminal",order:100,title:(0,E.localize)(2115,null),type:"object",properties:{[T.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(2116,null),type:["string","null"],default:null,enum:b?.os===i.OperatingSystem.Linux?w?.values:void 0,markdownEnumDescriptions:b?.os===i.OperatingSystem.Linux?w?.markdownDescriptions:void 0},[T.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(2117,null),type:["string","null"],default:null,enum:b?.os===i.OperatingSystem.Macintosh?w?.values:void 0,markdownEnumDescriptions:b?.os===i.OperatingSystem.Macintosh?w?.markdownDescriptions:void 0},[T.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(2118,null),type:["string","null"],default:null,enum:b?.os===i.OperatingSystem.Windows?w?.values:void 0,markdownEnumDescriptions:b?.os===i.OperatingSystem.Windows?w?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[c],remove:o?[o]:[]})}}),define(Oe[243],Le([1,0,2,12,119,27,120]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lS=void 0;let T=class extends t.$Zc{constructor(s,S){super(),this.a=s,this.b=S}start(){const s={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:i.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},S=(0,D.$fn)(this.b.args,this.b.isBuilt);S&&(S.break&&S.port?s.debugBrk=S.port:!S.break&&S.port&&(s.debug=S.port));const y=new E.$sr(i.$5g.asFileUri("bootstrap-fork").fsPath,s),p=new t.$Yc;return p.add(y),{client:y,store:p,onDidProcessExit:y.onDidProcessExit}}};e.$lS=T,e.$lS=T=Ve([je(1,I.$Ri)],T)}),define(Oe[244],Le([1,0,31,12,21,8,3,32,16,10,26,137,97,138]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=a,e.$Xs=c,e.$Ys=m,t=We(t),I=We(I),T=We(T),S=We(S);function a(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(t.release());let k=0;return h&&h.length===4&&(k=parseInt(h[3])),k}async function c(h,k,P,O=T.env,C=S.Promises.exists){if(I.$nc(h))return await C(h)?h:void 0;if(k===void 0&&(k=T.cwd()),I.$rc(h)!=="."){const Q=I.$oc(k,h);return await C(Q)?Q:void 0}const R=(0,E.$to)(O,"PATH");if(P===void 0&&(0,s.$jg)(R)&&(P=R.split(I.$yc)),P===void 0||P.length===0){const Q=I.$oc(k,h);return await C(Q)?Q:void 0}for(const Q of P){let J;if(I.$nc(Q)?J=I.$oc(Q,h):J=I.$oc(k,Q,h),await C(J))return J;if(D.$l){let x=J+".com";if(await C(x)||(x=J+".exe",await C(x)))return x}}const z=I.$oc(k,h);return await C(z)?z:void 0}function m(h,k,P,O,C){const L=D.$l&&(!k.windowsEnableConpty||a()<18309);if(!k.shellIntegration.enabled||!h.executable||h.isFeatureTerminal&&!h.forceShellIntegration||h.ignoreShellIntegration||L)return;const R=h.args,z=T.$ic==="win32"?I.$sc(h.executable).toLowerCase():I.$sc(h.executable),Q=I.$rc(i.$5g.asFileUri("").fsPath);let J;const x={VSCODE_INJECTION:"1"};if(k.shellIntegration.nonce&&(x.VSCODE_NONCE=k.shellIntegration.nonce),D.$l){if(z==="pwsh.exe"||z==="powershell.exe")return!R||r(R)?J=d.get(g.WindowsPwsh):u(R)&&(J=d.get(g.WindowsPwshLogin)),J?(J=[...J],J[J.length-1]=(0,v.$if)(J[J.length-1],Q,""),x.VSCODE_STABLE=C.quality==="stable"?"1":"0",k.shellIntegration.suggestEnabled&&(x.VSCODE_SUGGEST="1"),{newArgs:J,envMixin:x}):void 0;if(z==="bash.exe")return!R||R.length===0?J=d.get(g.Bash):f(R)&&(x.VSCODE_SHELL_LOGIN="1",b(k,x),J=d.get(g.Bash)),J?(J=[...J],J[J.length-1]=(0,v.$if)(J[J.length-1],Q),x.VSCODE_STABLE=C.quality==="stable"?"1":"0",{newArgs:J,envMixin:x}):void 0;O.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args);return}switch(z){case"bash":return!R||R.length===0?J=d.get(g.Bash):f(R)&&(x.VSCODE_SHELL_LOGIN="1",b(k,x),J=d.get(g.Bash)),J?(J=[...J],J[J.length-1]=(0,v.$if)(J[J.length-1],Q),x.VSCODE_STABLE=C.quality==="stable"?"1":"0",{newArgs:J,envMixin:x}):void 0;case"fish":{const ve=P?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",be=I.$oc(Q,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return x.XDG_DATA_DIRS=`${ve}:${be}`,b(k,x),{newArgs:void 0,envMixin:x}}case"pwsh":return!R||r(R)?J=d.get(g.Pwsh):u(R)&&(J=d.get(g.PwshLogin)),J?(k.shellIntegration.suggestEnabled&&(x.VSCODE_SUGGEST="1"),J=[...J],J[J.length-1]=(0,v.$if)(J[J.length-1],Q,""),x.VSCODE_STABLE=C.quality==="stable"?"1":"0",{newArgs:J,envMixin:x}):void 0;case"zsh":{if(!R||R.length===0?J=d.get(g.Zsh):f(R)?(J=d.get(g.ZshLogin),b(k,x)):(R===d.get(g.Zsh)||R===d.get(g.ZshLogin))&&(J=R),!J)return;J=[...J],J[J.length-1]=(0,v.$if)(J[J.length-1],Q);let ve;try{ve=t.userInfo().username}catch{ve="unknown"}const be=I.$oc(t.tmpdir(),`${ve}-${C.applicationName}-zsh`);x.ZDOTDIR=be;const se=P?.ZDOTDIR??t.homedir()??"~";x.USER_ZDOTDIR=se;const V=[];return V.push({source:I.$oc(Q,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:I.$oc(be,".zshrc")}),V.push({source:I.$oc(Q,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:I.$oc(be,".zprofile")}),V.push({source:I.$oc(Q,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:I.$oc(be,".zshenv")}),V.push({source:I.$oc(Q,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:I.$oc(be,".zlogin")}),{newArgs:J,envMixin:x,filesToCopy:V}}}O.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args)}function b(h,k){if(D.$m&&h.environmentVariableCollections){const P=(0,p.$Us)(h.environmentVariableCollections),C=new $.$Vs(P).getVariableMap({workspaceFolder:h.workspaceFolder}).get("PATH"),L=[];if(C)for(const R of C)R.type===y.EnvironmentVariableMutatorType.Prepend&&L.push(R.value);L.length>0&&(k.VSCODE_PATH_PREFIX=L.join(""))}}var g;(function(h){h.WindowsPwsh="windows-pwsh",h.WindowsPwshLogin="windows-pwsh-login",h.Pwsh="pwsh",h.PwshLogin="pwsh-login",h.Zsh="zsh",h.ZshLogin="zsh-login",h.Bash="bash"})(g||(g={}));const d=new Map;d.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(g.Zsh,["-i"]),d.set(g.ZshLogin,["-il"]),d.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const w=["-login","-l"],o=["--login","-l"],l=["-i","--interactive"],n=["-nol","-nologo"];function u(h){return typeof h=="string"?w.includes(h.toLowerCase()):h.length===1&&w.includes(h[0].toLowerCase())||h.length===2&&(w.includes(h[0].toLowerCase())||w.includes(h[1].toLowerCase()))&&(n.includes(h[0].toLowerCase())||n.includes(h[1].toLowerCase()))}function r(h){return typeof h=="string"?n.includes(h.toLowerCase()):h.length===0||h?.length===1&&n.includes(h[0].toLowerCase())}function f(h){return typeof h!="string"&&(h=h.filter(k=>!l.includes(k.toLowerCase()))),h==="string"&&o.includes(h.toLowerCase())||typeof h!="string"&&h.length===1&&o.includes(h[0].toLowerCase())}}),define(Oe[245],Le([1,0,20,50,57,8,3,10,26,115,53,244,59]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=m,t=We(t),i=We(i),v=We(v);var $;(function(P){P.UnixShellsPath="/etc/shells"})($||($={}));let a,c=!0;function m(P,O,C,L,R=process.env,z,Q,J,x){return z=z||{existsFile:v.SymlinkSupport.existsFile,readFile:t.promises.readFile},D.$l?b(C,z,R,Q,L.getValue(S.TerminalSettingId.UseWslProfiles)!==!1,P&&typeof P=="object"?{...P}:L.getValue(S.TerminalSettingId.ProfilesWindows),typeof O=="string"?O:L.getValue(S.TerminalSettingId.DefaultProfileWindows),x,J):f(z,Q,C,P&&typeof P=="object"?{...P}:L.getValue(D.$n?S.TerminalSettingId.ProfilesLinux:S.TerminalSettingId.ProfilesMacOs),typeof O=="string"?O:L.getValue(D.$n?S.TerminalSettingId.DefaultProfileLinux:S.TerminalSettingId.DefaultProfileMacOs),x,J,R)}async function b(P,O,C,L,R,z,Q,J,x){const ve=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),be=`${process.env.windir}\\${ve?"Sysnative":"System32"}`;let se=!1;(0,y.$Ws)()>=16299&&(se=!0),await o(J);const V=new Map;if(P){V.set("PowerShell",{source:S.ProfileSource.Pwsh,icon:E.$0j.terminalPowershell,isAutoDetected:!0}),V.set("Windows PowerShell",{path:`${be}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:E.$0j.terminalPowershell,isAutoDetected:!0}),V.set("Git Bash",{source:S.ProfileSource.GitBash,isAutoDetected:!0}),V.set("Command Prompt",{path:`${be}\\cmd.exe`,icon:E.$0j.terminalCmd,isAutoDetected:!0}),V.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),V.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:E.$0j.terminalBash,isAutoDetected:!0});const j=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;V.set("Cmder",{path:`${be}\\cmd.exe`,args:["/K",j],requiresPath:process.env.CMDER_ROOT?j:{path:j,isUnsafe:!0},isAutoDetected:!0})}h(z,V);const B=await g(V.entries(),Q,O,C,L,x);if(P&&R)try{const j=await u(`${be}\\${se?"wsl":"bash"}.exe`,Q);for(const U of j)(!z||!(U.profileName in z))&&B.push(U)}catch{c&&(L?.trace("WSL is not installed, so could not detect WSL profiles"),c=!1)}return B}async function g(P,O,C,L=process.env,R,z){const Q=[];for(const[J,x]of P)Q.push(d(J,x,O,C,L,R,z));return(await Promise.all(Q)).filter(J=>!!J)}async function d(P,O,C,L,R=process.env,z,Q){if(O===null)return;let J,x,ve;if("source"in O&&!("path"in O)){const B=a?.get(O.source);if(!B)return;J=B.paths,x=O.args||B.args,O.icon?ve=w(O.icon):B.icon&&(ve=B.icon)}else J=Array.isArray(O.path)?O.path:[O.path],x=D.$l||Array.isArray(O.args)?O.args:void 0,ve=w(O.icon);let be;if(Q){const B=J.map(U=>typeof U=="string"?U:U.path),j=await Q(B);be=new Array(J.length);for(let U=0;U<J.length;U++)typeof J[U]=="string"?be[U]=j[U]:be[U]={path:j[U],isUnsafe:!0}}else be=J.slice();let se;if(O.requiresPath){let B;if((0,T.$jg)(O.requiresPath)?B=O.requiresPath:(B=O.requiresPath.path,O.requiresPath.isUnsafe&&(se=B)),!await L.existsFile(B))return}const V=await k(P,C,be,L,R,x,O.env,O.overrideName,O.isAutoDetected,se);if(!V){z?.debug("Terminal profile not validated",P,J);return}return V.isAutoDetected=O.isAutoDetected,V.icon=ve,V.color=O.color,V}function w(P){return typeof P=="string"?{id:P}:P}async function o(P){if(a&&!P)return;const[O,C]=await Promise.all([l(),P||n()]);a=new Map,a.set(S.ProfileSource.GitBash,{profileName:"Git Bash",paths:O,args:["--login","-i"]}),a.set(S.ProfileSource.Pwsh,{profileName:"PowerShell",paths:C,icon:E.$0j.terminalPowershell})}async function l(){const P=new Set,O=await(0,y.$Xs)("git.exe");if(O){const R=(0,p.dirname)(O);P.add((0,p.resolve)(R,"../.."))}function C(R,z){z&&R.add(z)}C(P,process.env.ProgramW6432),C(P,process.env.ProgramFiles),C(P,process.env["ProgramFiles(X86)"]),C(P,`${process.env.LocalAppData}\\Program`);const L=[];for(const R of P)L.push(`${R}\\Git\\bin\\bash.exe`,`${R}\\Git\\usr\\bin\\bash.exe`,`${R}\\usr\\bin\\bash.exe`);return L.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),L.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),L}async function n(){const P=[];for await(const O of(0,s.$Bm)())P.push(O.exePath);return P}async function u(P,O){const C=[],L=await new Promise((Q,J)=>{i.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(x,ve)=>{if(x)return J("Problem occurred when getting wsl distros");Q(ve)})});if(!L)return[];const R=new RegExp(/[\r?\n]/),z=L.split(R).filter(Q=>Q.trim().length>0&&Q!=="");for(const Q of z){if(Q===""||Q.startsWith("docker-desktop"))continue;const J=`${Q} (WSL)`,x={profileName:J,path:P,args:["-d",`${Q}`],isDefault:J===O,icon:r(Q),isAutoDetected:!1};C.push(x)}return C}function r(P){return P.includes("Ubuntu")?E.$0j.terminalUbuntu:P.includes("Debian")?E.$0j.terminalDebian:E.$0j.terminalLinux}async function f(P,O,C,L,R,z,Q,J){const x=new Map;if(C&&await P.existsFile($.UnixShellsPath)){const ve=(await P.readFile($.UnixShellsPath)).toString(),be=(z||ve.split(`
`)).map(V=>{const B=V.indexOf("#");return B===-1?V:V.substring(0,B)}).filter(V=>V.trim().length>0),se=new Map;for(const V of be){let B=(0,I.$sc)(V),j=se.get(B)||0;j++,j>1&&(B=`${B} (${j})`),se.set(B,j),x.set(B,{path:V,isAutoDetected:!0})}}return h(L,x),await g(x.entries(),R,P,J,O,Q)}function h(P,O){if(P)for(const[C,L]of Object.entries(P))L===null||typeof L!="object"||!("path"in L)&&!("source"in L)?O.delete(C):(L.icon=L.icon||O.get(C)?.icon,O.set(C,L))}async function k(P,O,C,L,R,z,Q,J,x,ve){if(C.length===0)return Promise.resolve(void 0);const be=C.shift();if(be==="")return k(P,O,C,L,R,z,Q,J,x);const se=typeof be!="string"&&be.isUnsafe,V=typeof be=="string"?be:be.path,B={profileName:P,path:V,args:z,env:Q,overrideName:J,isAutoDetected:x,isDefault:P===O,isUnsafePath:se,requiresUnsafePath:ve};if((0,I.$sc)(V)===V){const U=R.PATH?R.PATH.split(I.$yc):void 0,te=await(0,y.$Xs)(V,void 0,U,void 0,L.existsFile);return te?(B.path=te,B.isFromPath=!0,B):k(P,O,C,L,R,z)}return await L.existsFile((0,I.$mc)(V))?B:k(P,O,C,L,R,z,Q,J,x)}}),define(Oe[246],Le([1,0,6,2,3,51,28,11,127,94,240,53,242,245,118,43]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=void 0;var m;(function(g){g[g.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let b=class extends i.$Zc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(d,w,o,l){super(),this.M=d,this.N=w,this.O=o,this.P=l,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new t.$qe),this.onPtyHostExit=this.u.event,this.w=this.B(new t.$qe),this.onPtyHostStart=this.w.event,this.y=this.B(new t.$qe),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new t.$qe),this.onPtyHostResponsive=this.z.event,this.C=this.B(new t.$qe),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new t.$qe),this.onProcessData=this.D.event,this.F=this.B(new t.$qe),this.onProcessReady=this.F.event,this.G=this.B(new t.$qe),this.onProcessReplay=this.G.event,this.H=this.B(new t.$qe),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new t.$qe),this.onDidRequestDetach=this.I.event,this.J=this.B(new t.$qe),this.onDidChangeProperty=this.J.event,this.L=this.B(new t.$qe),this.onProcessExit=this.L.event,(0,p.$Ns)(),this.B(this.M),this.B((0,i.$Xc)(()=>this.W())),this.j=this.B(new S.$Gs(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(t.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(y.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(E.$l)return process.env;try{return await(0,s.$Wm)(this.N,this.O,{_:[]},process.env)}catch(d){return this.O.error("ptyHost was unable to resolve shell environment",d),{}}}U(){const d=this.M.start(),w=d.client;this.O.getLevel()===T.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),I.ProxyChannel.toService(w.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(d.onDidProcessExit(n=>{this.u.fire(n.code),!this.m&&!this.q.isDisposed&&(this.n<=m.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${n.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${n.code}, giving up`))}));const l=I.ProxyChannel.toService(w.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(l.onProcessData(n=>this.D.fire(n))),this.B(l.onProcessReady(n=>this.F.fire(n))),this.B(l.onProcessExit(n=>this.L.fire(n))),this.B(l.onDidChangeProperty(n=>this.J.fire(n))),this.B(l.onProcessReplay(n=>this.G.fire(n))),this.B(l.onProcessOrphanQuestion(n=>this.H.fire(n))),this.B(l.onDidRequestDetach(n=>this.I.fire(n))),this.B(new v.$Fs(this.P,w.getChannel(y.TerminalIpcChannels.Logger))),this.a=d,this.b=l,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async n=>{n.affectsConfiguration(y.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[d,l]}async createProcess(d,w,o,l,n,u,r,f,h,k,P){const O=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),C=await this.f.createProcess(d,w,o,l,n,u,r,f,h,k,P);return clearTimeout(O),C}updateTitle(d,w,o){return this.f.updateTitle(d,w,o)}updateIcon(d,w,o,l){return this.f.updateIcon(d,w,o,l)}attachToProcess(d){return this.f.attachToProcess(d)}detachFromProcess(d,w){return this.f.detachFromProcess(d,w)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(d){return this.f.start(d)}shutdown(d,w){return this.f.shutdown(d,w)}input(d,w){return this.f.input(d,w)}processBinary(d,w){return this.f.processBinary(d,w)}resize(d,w,o){return this.f.resize(d,w,o)}clearBuffer(d){return this.f.clearBuffer(d)}acknowledgeDataEvent(d,w){return this.f.acknowledgeDataEvent(d,w)}setUnicodeVersion(d,w){return this.f.setUnicodeVersion(d,w)}getInitialCwd(d){return this.f.getInitialCwd(d)}getCwd(d){return this.f.getCwd(d)}async getLatency(){const d=new c.$ke,w=await this.f.getLatency();return d.stop(),[{label:"ptyhostservice<->ptyhost",latency:d.elapsed()},...w]}orphanQuestionReply(d){return this.f.orphanQuestionReply(d)}installAutoReply(d,w){return this.f.installAutoReply(d,w)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(d){return this.f.uninstallAutoReply(d)}getDefaultSystemShell(d){return this.g?.getDefaultSystemShell(d)??(0,a.$Fm)(d??E.OS,process.env)}async getProfiles(d,w,o,l=!1){const n=await this.S();return(0,$.$Zs)(w,o,l,this.N,n,void 0,this.O,this.bb.bind(this,d))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(d,w){return this.f.getWslPath(d,w)}getRevivedPtyNewId(d,w){return this.f.getRevivedPtyNewId(d,w)}setTerminalLayoutInfo(d){return this.f.setTerminalLayoutInfo(d)}async getTerminalLayoutInfo(d){return this.g?.getTerminalLayoutInfo(d)}async requestDetachInstance(d,w){return this.f.requestDetachInstance(d,w)}async acceptDetachInstanceReply(d,w){return this.f.acceptDetachInstanceReply(d,w)}async freePortKillProcess(d){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(d)}async serializeTerminalState(d){return this.f.serializeTerminalState(d)}async reviveTerminalProcesses(d,w,o){return this.f.reviveTerminalProcesses(d,w,o)}async refreshProperty(d,w){return this.f.refreshProperty(d,w)}async updateProperty(d,w,o){return this.f.updateProperty(d,w,o)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(d){this.ab(),this.s=setTimeout(()=>this.Y(),d?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(d,w){return this.j.createRequest({workspaceId:d,originalText:w})}async acceptPtyHostResolvedVariables(d,w){this.j.acceptReply(d,w)}};e.$1s=b,e.$1s=b=Ve([je(1,D.$ej),je(2,T.$fk),je(3,T.$gk)],b)}),define(Oe[35],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0,e.$Pl=(0,t.$Ki)("IUriIdentityService")}),define(Oe[140],Le([1,0,35,122,15,19,171,6,2]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0;class s{static{this._clock=0}constructor(p){this.uri=p,this.time=s._clock++}touch(){return this.time=s._clock++,this}}let S=class{constructor(p){this.g=p,this.c=new v.$Yc,this.f=2**16;const $=new Map,a=c=>{let m=$.get(c.scheme);return m===void 0&&(m=p.hasProvider(c)&&!this.g.hasCapability(c,E.FileSystemProviderCapabilities.PathCaseSensitive),$.set(c.scheme,m)),m};this.c.add(T.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(c=>{$.delete(c.scheme)})),this.extUri=new I.$ah(a),this.d=new D.$4s((c,m)=>this.extUri.compare(c,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,I.$mh)(p));const $=this.d.get(p);return $?$.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new s(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((a,c)=>a[1].time<c[1].time?1:a[1].time>c[1].time?-1:0);s._clock=0,this.d.clear();const $=this.f*.5;for(let a=0;a<$;a++)this.d.set(p[a][0],p[a][1].touch())}};e.$5s=S,e.$5s=S=Ve([je(0,E.$fl)],S),(0,i.$2s)(t.$Pl,S,i.InstantiationType.Delayed)}),define(Oe[98],Le([1,0,7,8,68,19,4,5,12]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$0i=e.$9i=e.$8i=e.$7i=e.$5i=e.$4i=e.WorkbenchState=e.$Xi=e.$Wi=e.$Ti=void 0,e.$Ui=s,e.$Vi=S,e.$Yi=y,e.$Zi=p,e.$1i=$,e.$2i=c,e.$3i=m,e.$6i=d,e.$$i=w,e.$_i=o,e.$bj=l,e.$cj=n,e.$dj=u,e.$Ti=(0,T.$Ki)("contextService");function s(r){const f=r;return typeof f?.id=="string"&&D.URI.isUri(f.uri)}function S(r){return typeof r?.id=="string"&&!s(r)&&!p(r)}e.$Wi={id:"ext-dev"},e.$Xi={id:"empty-window"};function y(r,f){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,i.$sc)(r)}:f?e.$Wi:e.$Xi;const h=r;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}function p(r){const f=r;return typeof f?.id=="string"&&D.URI.isUri(f.configPath)}function $(r){const f=r;if(f?.uri)return{id:f.id,uri:D.URI.revive(f.uri)};const h=r;if(h?.configPath)return{id:h.id,configPath:D.URI.revive(h.configPath)};if(r?.id)return{id:r.id}}var a;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(a||(e.WorkbenchState=a={}));function c(r){const f=r;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}function m(r){const f=r;return!!(f&&typeof f=="object"&&D.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}class b{constructor(f,h,k,P,O){this.h=f,this.j=k,this.k=P,this.l=O,this.c=E.$Qi.forUris(this.l,()=>!0),this.folders=h}update(f){this.h=f.id,this.k=f.configuration,this.j=f.transient,this.l=f.l,this.folders=f.folders}get folders(){return this.g}set folders(f){this.g=f,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(f){this.k=f}getFolder(f){return f&&this.c.findSubstr(f)||null}n(){this.c=E.$Qi.forUris(this.l,()=>!0);for(const f of this.folders)this.c.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$4i=b;class g{constructor(f,h){this.raw=h,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,I.$lh)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$5i=g;function d(r){return new g({uri:r,index:0,name:(0,I.$hh)(r)},{uri:r.toString()})}e.$7i="code-workspace",e.$8i=`.${e.$7i}`,e.$9i=[{name:(0,t.localize)(2490,null),extensions:[e.$7i]}],e.$0i="workspace.json";function w(r,f){return I.$ch.isEqualOrParent(r,f.untitledWorkspacesHome)}function o(r){let f;return D.URI.isUri(r)?f=r:f=r.configuration,f?.scheme===v.Schemas.tmp}e.$aj="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(r){return r.id===e.$aj}function n(r,f){return!w(r,f)&&!o(r)}function u(r){return(typeof r=="string"?(0,i.$tc)(r):(0,I.$jh)(r))===e.$8i}}),define(Oe[33],Le([1,0,67,6,2,19,4,7,27,15,5,11,98,25,35,13,23,16,10]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Rl=e.ProfileResourceType=void 0,e.$Ql=w,e.$Sl=o,e.$Tl=l;var d;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function w(r){const f=r;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&typeof f.isDefault=="boolean"&&typeof f.name=="string"&&D.URI.isUri(f.location)&&D.URI.isUri(f.globalStorageHome)&&D.URI.isUri(f.settingsResource)&&D.URI.isUri(f.keybindingsResource)&&D.URI.isUri(f.tasksResource)&&D.URI.isUri(f.snippetsHome)&&D.URI.isUri(f.extensionsResource))}e.$Rl=(0,S.$Ki)("IUserDataProfilesService");function o(r,f){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,icon:r.icon,location:D.URI.revive(r.location).with({scheme:f}),globalStorageHome:D.URI.revive(r.globalStorageHome).with({scheme:f}),settingsResource:D.URI.revive(r.settingsResource).with({scheme:f}),keybindingsResource:D.URI.revive(r.keybindingsResource).with({scheme:f}),tasksResource:D.URI.revive(r.tasksResource).with({scheme:f}),snippetsHome:D.URI.revive(r.snippetsHome).with({scheme:f}),extensionsResource:D.URI.revive(r.extensionsResource).with({scheme:f}),cacheHome:D.URI.revive(r.cacheHome).with({scheme:f}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}function l(r,f,h,k,P,O){return{id:r,name:f,location:h,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:O&&P?.useDefaultFlags?.globalState?O.globalStorageHome:(0,I.$lh)(h,"globalStorage"),settingsResource:O&&P?.useDefaultFlags?.settings?O.settingsResource:(0,I.$lh)(h,"settings.json"),keybindingsResource:O&&P?.useDefaultFlags?.keybindings?O.keybindingsResource:(0,I.$lh)(h,"keybindings.json"),tasksResource:O&&P?.useDefaultFlags?.tasks?O.tasksResource:(0,I.$lh)(h,"tasks.json"),snippetsHome:O&&P?.useDefaultFlags?.snippets?O.snippetsHome:(0,I.$lh)(h,"snippets"),extensionsResource:O&&P?.useDefaultFlags?.extensions?O.extensionsResource:(0,I.$lh)(h,"extensions.json"),cacheHome:(0,I.$lh)(k,r),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let n=class extends E.$Zc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(f,h,k,P){super(),this.t=f,this.u=h,this.w=k,this.y=P,this.f=!0,this.h=this.B(new i.$qe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new i.$qe),this.onWillCreateProfile=this.j.event,this.m=this.B(new i.$qe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new i.$qe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new $.$Fc,workspaces:new $.$Fc,emptyWindows:new Map},this.profilesHome=(0,I.$lh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$lh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(f){this.f!==f&&(this.z=void 0,this.f=f)}isEnabled(){return this.f}get C(){if(!this.z){const f=this.D(),h=[f];if(this.f)try{for(const O of this.O()){if(!O.name||!(0,g.$jg)(O.name)||!O.location){this.y.warn("Skipping the invalid stored profile",O.location||O.name);continue}h.push(l((0,I.$ih)(O.location),O.name,O.location,this.g,{shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags},f))}}catch(O){this.y.error(O)}const k=new $.$Fc,P=new Map;if(h.length)try{const O=this.Q();if(O.workspaces)for(const[C,L]of Object.entries(O.workspaces)){const R=D.URI.parse(C),z=h.find(Q=>Q.id===L);z&&k.set(R,z)}if(O.emptyWindows)for(const[C,L]of Object.entries(O.emptyWindows)){const R=h.find(z=>z.id===L);R&&P.set(C,R)}}catch(O){this.y.error(O)}this.z={profiles:h,workspaces:k,emptyWindows:P}}return this.z}D(){const f=l("__default__profile__",(0,T.localize)(2443,null),this.t.userRoamingDataHome,this.g);return{...f,extensionsResource:this.S()??f.extensionsResource,isDefault:!0}}async createTransientProfile(f){const h="Temp",k=new RegExp(`${(0,b.$mf)(h)}\\s(\\d+)`);let P=0;for(const C of this.profiles){const L=k.exec(C.name),R=L?parseInt(L[1]):0;P=R>P?R:P}const O=`${h} ${P+1}`;return this.createProfile((0,t.$yj)((0,m.$7g)()).toString(16),O,{transient:!0},f)}async createNamedProfile(f,h,k){return this.createProfile((0,t.$yj)((0,m.$7g)()).toString(16),f,h,k)}async createProfile(f,h,k,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const O=await this.F(f,h,k);return P&&await this.setProfileForWorkspace(P,O),O}async F(f,h,k){if(!(0,g.$jg)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(h);return P||(P=(async()=>{try{if(this.profiles.find(R=>R.name===h||R.id===f))throw new Error(`Profile with ${h} name already exists`);const C=l(f,h,(0,I.$lh)(this.profilesHome,f),this.g,k,this.defaultProfile);await this.u.createFolder(C.location);const L=[];return this.j.fire({profile:C,join(R){L.push(R)}}),await c.Promises.settled(L),this.I([C],[],[]),C}finally{this.r.delete(h)}})(),this.r.set(h,P)),P}async updateProfile(f,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(P=>P.id===f.id);if(!k)throw new Error(`Profile '${f.name}' does not exist`);return k=l(k.id,h.name??k.name,k.location,this.g,{shortName:h.shortName??k.shortName,icon:h.icon===null?void 0:h.icon??k.icon,transient:h.transient??k.isTransient,useDefaultFlags:h.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(f){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(f.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(P=>P.id===f.id);if(!h)throw new Error(`Profile '${f.name}' does not exist`);const k=[];this.m.fire({profile:h,join(P){k.push(P)}});try{await Promise.allSettled(k)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(P){(0,s.$wl)(P)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(P)}}async setProfileForWorkspace(f,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(P=>P.id===h.id);if(!k)throw new Error(`Profile '${h.name}' does not exist`);this.L(f,k)}unsetWorkspace(f,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(f,void 0,h)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const f=await this.u.resolve(this.profilesHome);await Promise.all((f.children||[]).filter(h=>h.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const f=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(f.map(h=>this.removeProfile(h)))}getProfileForWorkspace(f){const h=this.G(f),k=D.URI.isUri(h)?this.C.workspaces.get(h):this.C.emptyWindows.get(h);return k||((0,p.$Ui)(f)?this.s.folders.get(f.uri):(0,p.$Zi)(f)?this.s.workspaces.get(f.configPath):this.s.emptyWindows.get(f.id))}G(f){return(0,p.$Ui)(f)?f.uri:(0,p.$Zi)(f)?f.configPath:f.id}H(f){return!!([...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,f.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,f.location))||[...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,f.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,f.location))||[...this.s.folders.values()].some(h=>this.w.extUri.isEqual(h.location,f.location)))}I(f,h,k){const P=[...this.profiles,...f],O=[],C=this.s.profiles;this.s.profiles=[];for(let L of P){if(L.isDefault||h.some(z=>L.id===z.id))continue;L=k.find(z=>L.id===z.id)??L;const R=C.find(z=>L.id===z.id);if(L.isTransient)this.s.profiles.push(L);else{if(R){for(const[z,Q]of this.s.emptyWindows.entries())if(L.id===Q.id){this.L({id:z},L);break}for(const[z,Q]of this.s.workspaces.entries())if(L.id===Q.id){this.L({id:"",configPath:z},L);break}for(const[z,Q]of this.s.folders.entries())if(L.id===Q.id){this.L({id:"",uri:z},L);break}}O.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags})}}this.P(O),this.z=void 0,this.J(f,h,k)}J(f,h,k){this.h.fire({added:f,removed:h,updated:k,all:this.profiles})}L(f,h,k){if(k=h?.isTransient?!0:k,k)(0,p.$Ui)(f)?(this.s.folders.delete(f.uri),h&&this.s.folders.set(f.uri,h)):(0,p.$Zi)(f)?(this.s.workspaces.delete(f.configPath),h&&this.s.workspaces.set(f.configPath,h)):(this.s.emptyWindows.delete(f.id),h&&this.s.emptyWindows.set(f.id,h));else{this.L(f,void 0,!0);const P=this.G(f);D.URI.isUri(P)?(this.C.workspaces.delete(P),h&&this.C.workspaces.set(P,h)):(this.C.emptyWindows.delete(P),h&&this.C.emptyWindows.set(P,h)),this.M()}}M(){const f={};for(const[k,P]of this.C.workspaces.entries())f[k.toString()]=P.id;const h={};for(const[k,P]of this.C.emptyWindows.entries())h[k.toString()]=P.id;this.R({workspaces:f,emptyWindows:h}),this.z=void 0}N(f){const h={},k=this.D();if(f.workspaces)for(const[O,C]of Object.entries(f.workspaces)){const L=D.URI.parse(C);h[O]=this.w.extUri.isEqual(L,k.location)?k.id:this.w.extUri.basename(L)}const P={};if(f.emptyWindows)for(const[O,C]of Object.entries(f.emptyWindows)){const L=D.URI.parse(C);P[O]=this.w.extUri.isEqual(L,k.location)?k.id:this.w.extUri.basename(L)}return{workspaces:h,emptyWindows:P}}O(){return[]}P(f){throw new Error("not implemented")}Q(){return{}}R(f){throw new Error("not implemented")}S(){}};e.$Ul=n,e.$Ul=n=Ve([je(0,v.$Ri),je(1,s.$fl),je(2,a.$Pl),je(3,y.$fk)],n);class u extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(f){this.a=f}Q(){return this.X}R(f){this.X=f}}e.$Vl=u}),define(Oe[99],Le([1,0,17,13,18,9,6,2,25,3,10,4,7,30,38,22,75,11,29,24,35,33]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Pq=void 0,e.$Qq=n,p=We(p);let l=class extends T.$Zc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(h,k,P,O,C,L){super(),this.z=h,this.C=k,this.D=P,this.F=O,this.G=C,this.H=L,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$qe),this.s=this.B(new D.$qe),this.t=this.B(new D.$qe),this.u=this.B(new D.$qe),this.w=this.B(new D.$qe),this.y=[],this.B((0,T.$Xc)(()=>{this.j.forEach(({task:R})=>R.cancel()),this.m.forEach(R=>R.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(h){const k=await this.getTargetPlatform();return h.allTargetPlatforms.some(P=>(0,$.$rp)(P,h.allTargetPlatforms,k))}async installFromGallery(h,k={}){try{const O=(await this.installGalleryExtensions([{extension:h,options:k}])).find(({identifier:C})=>(0,a.$Up)(C,h.identifier));if(O?.local)return O?.local;throw O?.error?O.error:new $.$vp(`Unknown error while installing extension ${h.identifier.id}`,$.ExtensionManagementErrorCode.Unknown)}catch(P){throw n(P)}}async installGalleryExtensions(h){if(!this.z.isEnabled())throw new $.$vp(p.localize(1768,null),$.ExtensionManagementErrorCode.NotAllowed);const k=[],P=[];return await Promise.allSettled(h.map(async({extension:O,options:C})=>{try{const L=await this.N(O,!!C?.installGivenVersion,!!C?.installPreReleaseVersion,C.productVersion??{version:this.G.version,date:this.G.date});P.push({...L,options:C})}catch(L){k.push({identifier:O.identifier,operation:$.InstallOperation.Install,source:O,error:L,profileLocation:C.profileLocation??this.W()})}})),P.length&&k.push(...await this.I(P)),k}async uninstall(h,k){return this.F.trace("ExtensionManagementService#uninstall",h.identifier.id),this.uninstallExtensions([{extension:h,options:k}])}async toggleAppliationScope(h,k){if((0,c.$Cn)(h.manifest)||h.isBuiltin)return h;if(h.isApplicationScoped){let P=await this.updateMetadata(h,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(k,this.H.defaultProfile.extensionsResource)||(P=await this.Z(h,this.H.defaultProfile.extensionsResource,k));for(const O of this.H.profiles){const C=(await this.getInstalled(c.ExtensionType.User,O.extensionsResource)).find(L=>(0,a.$Up)(L.identifier,h.identifier));C?this.w.fire({local:C,profileLocation:O.extensionsResource}):this.u.fire({identifier:h.identifier,profileLocation:O.extensionsResource})}return P}else{const P=this.D.extUri.isEqual(k,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(h,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(h,k,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:P.identifier,operation:$.InstallOperation.Install,local:P,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),P}}getExtensionsControlManifest(){const h=new Date().getTime();return(!this.g||h-this.h>1e3*60*5)&&(this.g=this.U(),this.h=h),this.g}registerParticipant(h){this.y.push(h)}async resetPinnedStateForAllUserExtensions(h){try{await this.L(this.H.profiles.map(async k=>{const P=await this.getInstalled(c.ExtensionType.User,k.extensionsResource);await this.L(P.map(async O=>{O.pinned!==h&&await this.updateMetadata(O,{pinned:h},k.extensionsResource)}))}))}catch(k){throw this.F.error("Error while resetting pinned state for all user extensions",(0,I.$bb)(k)),k}}async I(h){const k=new Map,P=new Map,O=[],C=(R,z)=>`${a.$Vp.create(R).toString()}-${z.toString()}`,L=(R,z,Q,J)=>{const x=this.X(R,z,Q),ve=`${(0,a.$Zp)(R.publisher,R.name)}-${Q.profileLocation.toString()}`;P.set(ve,{task:x,root:J}),this.n.fire({identifier:x.identifier,source:z,profileLocation:Q.profileLocation}),this.F.info("Installing extension:",x.identifier.id,Q),y.URI.isUri(z)||this.j.set(C(z,Q.profileLocation),{task:x,waitingTasks:[]})};try{for(const{manifest:R,extension:z,options:Q}of h){const J=Q.isApplicationScoped||Q.isBuiltin||(0,c.$Cn)(R),x={...Q,installOnlyNewlyAddedFromExtensionPack:Q.installOnlyNewlyAddedFromExtensionPack??!y.URI.isUri(z),isApplicationScoped:J,profileLocation:J?this.H.defaultProfile.extensionsResource:Q.profileLocation??this.W(),productVersion:Q.productVersion??{version:this.G.version,date:this.G.date}},ve=y.URI.isUri(z)?void 0:this.j.get(C(z,x.profileLocation));ve?(this.F.info("Extension is already requested to install",ve.task.identifier.id,x.profileLocation.toString()),O.push(ve.task.waitUntilTaskIsFinished())):L(R,z,x,void 0)}return await Promise.all([...P.values()].map(async({task:R})=>{if(R.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",R.identifier.id);else try{const z=await this.M(R.identifier,R.manifest,!!R.options.installOnlyNewlyAddedFromExtensionPack,!!R.options.installPreReleaseVersion,R.options.profileLocation,R.options.productVersion),Q=await this.getInstalled(void 0,R.options.profileLocation,R.options.productVersion),J={...R.options,context:{...R.options.context,[$.$lp]:!0}};for(const{gallery:x,manifest:ve}of(0,t.$Qb)(z,({gallery:be})=>be.identifier.id)){if(P.has(`${x.identifier.id.toLowerCase()}-${J.profileLocation.toString()}`))continue;const be=this.j.get(C(x,J.profileLocation));if(be){if(this.J(R,be.task)){const se=be.task.identifier;this.F.info("Waiting for already requested installing extension",se.id,R.identifier.id,J.profileLocation.toString()),be.waitingTasks.push(R),O.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,V=>V.some(B=>(0,a.$Up)(B.identifier,se)))).then(V=>{if(this.F.info("Finished waiting for already requested installing extension",se.id,R.identifier.id,J.profileLocation.toString()),!V.find(j=>(0,a.$Up)(j.identifier,se))?.local)throw new Error(`Extension ${se.id} is not installed`)}))}}else Q.some(({identifier:se})=>(0,a.$Up)(se,x.identifier))||L(ve,x,J,R)}}catch(z){if(y.URI.isUri(R.source))(0,t.$Pb)(R.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",R.identifier.id,z.message),(0,t.$Pb)(R.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",R.identifier.id,z.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",R.identifier.id),z}})),await this.L([...P.entries()].map(async([R,{task:z}])=>{const Q=new Date().getTime();let J;try{J=await z.run(),await this.L(this.y.map(x=>x.postInstall(J,z.source,z.options,E.CancellationToken.None)),$.ExtensionManagementErrorCode.PostInstall)}catch(x){const ve=n(x);throw y.URI.isUri(z.source)||u(this.C,z.operation===$.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,a.$3p)(z.source),error:ve,source:z.options.context?.[$.$kp]}),k.set(R,{error:ve,identifier:z.identifier,operation:z.operation,source:z.source,context:z.options.context,profileLocation:z.options.profileLocation,applicationScoped:z.options.isApplicationScoped}),this.F.error("Error while installing the extension",z.identifier.id,(0,I.$bb)(ve),z.options.profileLocation.toString()),ve}if(!y.URI.isUri(z.source)){const x=z.operation===$.InstallOperation.Update,ve=x?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(u(this.C,x?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,a.$3p)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:ve,source:z.options.context?.[$.$kp]}),s.$r&&z.operation!==$.InstallOperation.Update)try{await this.z.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,$.StatisticType.Install)}catch{}}k.set(R,{local:J,identifier:z.identifier,operation:z.operation,source:z.source,context:z.options.context,profileLocation:z.options.profileLocation,applicationScoped:J.isApplicationScoped})})),O.length&&await this.L(O),[...k.values()]}catch(R){const z=(x,ve,be)=>{const se=[];x.manifest.extensionDependencies?.length&&se.push(...x.manifest.extensionDependencies),x.manifest.extensionPack?.length&&se.push(...x.manifest.extensionPack);for(const V of se){if(be.includes(V.toLowerCase()))continue;be.push(V.toLowerCase());const B=k.get(`${V.toLowerCase()}-${ve.toString()}`);B?.local&&(be=z(B.local,ve,be))}return be},Q=x=>({identifier:x.identifier,operation:$.InstallOperation.Install,source:x.source,context:x.options.context,profileLocation:x.options.profileLocation,error:R}),J=[];for(const[x,{task:ve,root:be}]of P){const se=k.get(x);se?se.local&&be&&!k.get(`${be.identifier.id.toLowerCase()}-${ve.options.profileLocation.toString()}`)?.local&&(J.push(this.Y(se.local,{versionOnly:!0,profileLocation:ve.options.profileLocation})),k.set(x,Q(ve))):(ve.cancel(),k.set(x,Q(ve)))}for(const[x,{task:ve}]of P){const be=k.get(x);if(!be?.local||ve.options.donotIncludePackAndDependencies)continue;z(be.local,ve.options.profileLocation,[be.local.identifier.id.toLowerCase()]).slice(1).some(V=>P.has(`${V.toLowerCase()}-${ve.options.profileLocation.toString()}`)&&!k.get(`${V.toLowerCase()}-${ve.options.profileLocation.toString()}`)?.local)&&(J.push(this.Y(be.local,{versionOnly:!0,profileLocation:ve.options.profileLocation})),k.set(x,Q(ve)))}throw J.length&&await Promise.allSettled(J.map(async x=>{try{await x.run(),this.F.info("Rollback: Uninstalled extension",x.extension.identifier.id)}catch(ve){this.F.warn("Rollback: Error while uninstalling extension",x.extension.identifier.id,(0,I.$bb)(ve))}})),R}finally{for(const{task:R}of P.values())R.source&&!y.URI.isUri(R.source)&&this.j.delete(C(R.source,R.options.profileLocation));if(k.size){const R=[...k.values()];for(const z of R)z.local&&this.F.info("Extension installed successfully:",z.identifier.id,z.profileLocation.toString());this.s.fire(R)}}}J(h,k){for(const[,{task:P,waitingTasks:O}]of this.j.entries())if(P===h&&(O.includes(k)||O.some(C=>this.J(C,k)))||P===k&&O[0]&&!this.J(h,O[0]))return!1;return!0}async L(h,k){const P=[],O=[],C=await Promise.allSettled(h);for(const R of C)R.status==="fulfilled"?P.push(R.value):O.push(n(R.reason,k));if(!O.length)return P;if(O.length===1)throw O[0];let L=new $.$vp("",$.ExtensionManagementErrorCode.Unknown);for(const R of O)L=new $.$vp(L.message?`${L.message}, ${R.message}`:R.message,R.code!==$.ExtensionManagementErrorCode.Unknown&&R.code!==$.ExtensionManagementErrorCode.Internal?R.code:L.code);throw L}async M(h,k,P,O,C,L){if(!this.z.isEnabled())return[];const R=await this.getInstalled(void 0,C,L),z=[],Q=[],J=async(x,ve)=>{z.push(x);const be=ve.extensionDependencies||[],se=[...be];if(ve.extensionPack){const V=P?R.find(B=>(0,a.$Up)(B.identifier,x)):void 0;for(const B of ve.extensionPack)V&&V.manifest.extensionPack&&V.manifest.extensionPack.some(j=>(0,a.$Up)({id:j},{id:B}))||se.every(j=>!(0,a.$Up)({id:j},{id:B}))&&se.push(B)}if(se.length){const V=se.filter(B=>z.every(j=>!(0,a.$Up)(j,{id:B})));if(V.length){const B=await this.z.getExtensions(V.map(j=>({id:j,preRelease:O})),E.CancellationToken.None);for(const j of B){if(z.find(le=>(0,a.$Up)(le,j.identifier)))continue;const U=be.some(le=>(0,a.$Up)({id:le},j.identifier));let te;try{te=await this.N(j,!1,O,L)}catch(le){if(U)throw le;this.F.info("Skipping the packed extension as it cannot be installed",j.identifier.id,(0,I.$bb)(le));continue}Q.push({gallery:te.extension,manifest:te.manifest}),await J(te.extension.identifier,te.manifest)}}}};return await J(h,k),Q}async N(h,k,P,O){let C;const L=await this.getExtensionsControlManifest();if(L.malicious.some(Q=>(0,a.$Up)(h.identifier,Q)))throw new $.$vp(p.localize(1769,null,h.identifier.id),$.ExtensionManagementErrorCode.Malicious);const R=L.deprecated[h.identifier.id.toLowerCase()];if(R?.extension?.autoMigrate){if(this.F.info(`The '${h.identifier.id}' extension is deprecated, fetching the compatible '${R.extension.id}' extension instead.`),C=(await this.z.getExtensions([{id:R.extension.id,preRelease:R.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:O},E.CancellationToken.None))[0],!C)throw new $.$vp(p.localize(1770,null,h.identifier.id,R.extension.id),$.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(h)){const Q=await this.getTargetPlatform();throw new $.$vp(p.localize(1771,null,h.identifier.id,this.G.nameLong,(0,$.$np)(Q)),$.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(C=await this.O(h,k,P,O),!C){const Q=[];throw(0,m.$cq)(h.properties.enabledApiProposals??[],Q)?!P&&h.properties.isPreReleaseVersion&&(await this.z.getExtensions([h.identifier],E.CancellationToken.None))[0]?new $.$vp(p.localize(1773,null,h.displayName??h.identifier.id),$.ExtensionManagementErrorCode.ReleaseVersionNotFound):new $.$vp(p.localize(1774,null,h.identifier.id,this.G.nameLong,this.G.version),$.ExtensionManagementErrorCode.Incompatible):new $.$vp(p.localize(1772,null,h.displayName??h.identifier.id,Q[0]),$.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",C.identifier.id);const z=await this.z.getManifest(C,E.CancellationToken.None);if(z===null)throw new $.$vp(`Missing manifest for extension ${C.identifier.id}`,$.ExtensionManagementErrorCode.Invalid);if(z.version!==C.version)throw new $.$vp(`Cannot install '${C.identifier.id}' extension because of version mismatch in Marketplace`,$.ExtensionManagementErrorCode.Invalid);return{extension:C,manifest:z}}async O(h,k,P,O){const C=await this.getTargetPlatform();let L=null;return!k&&h.hasPreReleaseVersion&&h.properties.isPreReleaseVersion!==P&&(L=(await this.z.getExtensions([{...h.identifier,preRelease:P}],{targetPlatform:C,compatible:!0,productVersion:O},E.CancellationToken.None))[0]||null),!L&&await this.z.isExtensionCompatible(h,P,C,O)&&(L=h),L||(k?L=(await this.z.getExtensions([{...h.identifier,version:h.version}],{targetPlatform:C,compatible:!0,productVersion:O},E.CancellationToken.None))[0]||null:L=await this.z.getCompatibleExtension(h,P,C,O)),L}async uninstallExtensions(h){const k=(Q,J)=>`${Q.identifier.id.toLowerCase()}${J.versionOnly?`-${Q.manifest.version}`:""}@${J.profileLocation.toString()}`,P=(Q,J)=>{const x=this.Y(Q,J);return this.m.set(k(x.extension,J),x),this.F.info("Uninstalling extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,J.profileLocation.toString()),this.t.fire({identifier:Q.identifier,profileLocation:J.profileLocation,applicationScoped:Q.isApplicationScoped}),x},O=(Q,J,x)=>{x?this.F.error("Failed to uninstall extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,J.profileLocation.toString(),x.message):this.F.info("Successfully uninstalled extension from the profile",`${Q.identifier.id}@${Q.manifest.version}`,J.profileLocation.toString()),u(this.C,"extensionGallery:uninstall",{extensionData:(0,a.$2p)(Q),error:x}),this.u.fire({identifier:Q.identifier,error:x?.code,profileLocation:J.profileLocation,applicationScoped:Q.isApplicationScoped})},C=[],L=[],R=[],z=new v.$Fc;for(const{extension:Q,options:J}of h){const x={...J,profileLocation:Q.isApplicationScoped?this.H.defaultProfile.extensionsResource:J?.profileLocation??this.W()},ve=this.m.get(k(Q,x));ve?(this.F.info("Extensions is already requested to uninstall",Q.identifier.id),R.push(ve.waitUntilTaskIsFinished())):C.push(P(Q,x))}try{for(const Q of C.slice(0)){let J=z.get(Q.options.profileLocation);if(J||z.set(Q.options.profileLocation,J=await this.getInstalled(c.ExtensionType.User,Q.options.profileLocation)),Q.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${Q.extension.identifier.id}@${Q.extension.manifest.version}`);else{const x=this.R(Q.extension,J);for(const ve of x)this.m.has(k(ve,Q.options))?this.F.info("Extensions is already requested to uninstall",ve.identifier.id):C.push(P(ve,Q.options))}Q.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${Q.extension.identifier.id}@${Q.extension.manifest.version}`):this.P(C.map(x=>x.extension),J,Q.extension)}await this.L(C.map(async Q=>{try{if(await Q.run(),await this.L(this.y.map(J=>J.postUninstall(Q.extension,Q.options,E.CancellationToken.None))),Q.extension.identifier.uuid)try{await this.z.reportStatistic(Q.extension.manifest.publisher,Q.extension.manifest.name,Q.extension.manifest.version,$.StatisticType.Uninstall)}catch{}}catch(J){const x=n(J);throw O(Q.extension,Q.options,x),x}finally{L.push(Q)}})),R.length&&await this.L(R);for(const Q of C)O(Q.extension,Q.options)}catch(Q){const J=n(Q);for(const x of C){try{x.cancel()}catch{}L.includes(x)||O(x.extension,x.options,J)}throw J}finally{for(const Q of C)this.m.delete(k(Q.extension,Q.options))||this.F.warn("Uninstallation task is not found in the cache",Q.extension.identifier.id)}}P(h,k,P){for(const O of h){const C=this.S(O,k);if(C.length){const L=C.filter(R=>!h.some(z=>(0,a.$Up)(z.identifier,R.identifier)));if(L.length)throw new Error(this.Q(O,L,P))}}}Q(h,k,P){return P===h?k.length===1?p.localize(1775,null,P.manifest.displayName||P.manifest.name,k[0].manifest.displayName||k[0].manifest.name):k.length===2?p.localize(1776,null,P.manifest.displayName||P.manifest.name,k[0].manifest.displayName||k[0].manifest.name,k[1].manifest.displayName||k[1].manifest.name):p.localize(1777,null,P.manifest.displayName||P.manifest.name,k[0].manifest.displayName||k[0].manifest.name,k[1].manifest.displayName||k[1].manifest.name):k.length===1?p.localize(1778,null,P.manifest.displayName||P.manifest.name,h.manifest.displayName||h.manifest.name,k[0].manifest.displayName||k[0].manifest.name):k.length===2?p.localize(1779,null,P.manifest.displayName||P.manifest.name,h.manifest.displayName||h.manifest.name,k[0].manifest.displayName||k[0].manifest.name,k[1].manifest.displayName||k[1].manifest.name):p.localize(1780,null,P.manifest.displayName||P.manifest.name,h.manifest.displayName||h.manifest.name,k[0].manifest.displayName||k[0].manifest.name,k[1].manifest.displayName||k[1].manifest.name)}R(h,k,P=[]){if(P.indexOf(h)!==-1)return[];P.push(h);const O=h.manifest.extensionPack?h.manifest.extensionPack:[];if(O.length){const C=k.filter(R=>!R.isBuiltin&&O.some(z=>(0,a.$Up)({id:z},R.identifier))),L=[];for(const R of C)L.push(...this.R(R,k,P));return[...C,...L]}return[]}S(h,k){return k.filter(P=>P.manifest.extensionDependencies&&P.manifest.extensionDependencies.some(O=>(0,a.$Up)({id:O},h.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(h){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,I.$bb)(h)),{malicious:[],deprecated:{},search:[]}}}};e.$Pq=l,e.$Pq=l=Ve([je(0,$.$tp),je(1,d.$em),je(2,w.$Pl),je(3,b.$fk),je(4,g.$yk),je(5,o.$Rl)],l);function n(f,h){if(f instanceof $.$vp)return f;let k;return f instanceof $.$up?k=new $.$vp(f.message,f.code===$.ExtensionGalleryErrorCode.DownloadFailedWriting?$.ExtensionManagementErrorCode.DownloadFailedWriting:$.ExtensionManagementErrorCode.Gallery):k=new $.$vp(f.message,(0,I.$8)(f)?$.ExtensionManagementErrorCode.Cancelled:h??$.ExtensionManagementErrorCode.Internal),k.stack=f.stack,k}function u(f,h,{extensionData:k,verificationStatus:P,duration:O,error:C,source:L,durationSinceUpdate:R}){let z,Q;(0,S.$rg)(P)&&(P===!0?P="Verified":(P===!1||(z=$.ExtensionManagementErrorCode.Signature,Q=P),P="Unverified")),C&&(z=C.code,C.code===$.ExtensionManagementErrorCode.Signature&&(Q=C.message)),f.publicLog(h,{...k,verificationStatus:P,success:!C,duration:O,errorcode:z,errorcodeDetail:Q,durationSinceUpdate:R,source:L})}class r{constructor(){this.d=new i.$Jh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,i.$xh)(h=>this.h(h))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,i.$xh)(h=>new Promise((k,P)=>{const O=h.onCancellationRequested(()=>{O.dispose(),P(new I.$9)})})),this.d.open()),this.g.cancel()}}e.$Rq=r}),define(Oe[54],Le([1,0,13,14,2,6,25,4,30,38,15,5,11,33,35,10,9,24]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class d extends Error{constructor(u,r){super(u),this.code=r}}e.$Sq=d,e.$Tq=(0,y.$Ki)("IExtensionsProfileScannerService");let w=class extends E.$Zc{constructor(u,r,f,h,k,P){super(),this.j=u,this.m=r,this.n=f,this.r=h,this.s=k,this.t=P,this.b=this.B(new I.$qe),this.onAddExtensions=this.b.event,this.c=this.B(new I.$qe),this.onDidAddExtensions=this.c.event,this.f=this.B(new I.$qe),this.onRemoveExtensions=this.f.event,this.g=this.B(new I.$qe),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Fc}scanProfileExtensions(u,r){return this.u(u,void 0,r)}async addExtensionsToProfile(u,r,f){const h=[],k=[];try{return await this.u(r,P=>{const O=[];if(f)O.push(...P);else for(const C of P)u.some(([L])=>(0,s.$Up)(L.identifier,C.identifier)&&L.manifest.version!==C.version)?h.push(C):O.push(C);for(const[C,L]of u){const R=O.findIndex(Q=>(0,s.$Up)(Q.identifier,C.identifier)&&Q.version===C.manifest.version),z={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:L};R===-1?(k.push(z),O.push(z)):O.splice(R,1,z)}return k.length&&this.b.fire({extensions:k,profileLocation:r}),h.length&&this.f.fire({extensions:h,profileLocation:r}),O}),k.length&&this.c.fire({extensions:k,profileLocation:r}),h.length&&this.g.fire({extensions:h,profileLocation:r}),k}catch(P){throw k.length&&this.c.fire({extensions:k,error:P,profileLocation:r}),h.length&&this.g.fire({extensions:h,error:P,profileLocation:r}),P}}async updateMetadata(u,r){const f=[];return await this.u(r,h=>{const k=[];for(const P of h){const O=u.find(([C])=>(0,s.$Up)(C.identifier,P.identifier)&&C.manifest.version===P.version);O&&(P.metadata={...P.metadata,...O[1]},f.push(P)),k.push(P)}return k}),f}async removeExtensionFromProfile(u,r){const f=[];try{await this.u(r,h=>{const k=[];for(const P of h)(0,s.$Up)(P.identifier,u.identifier)?f.push(P):k.push(P);return f.length&&this.f.fire({extensions:f,profileLocation:r}),k}),f.length&&this.g.fire({extensions:f,profileLocation:r})}catch(h){throw f.length&&this.g.fire({extensions:f,error:h,profileLocation:r}),h}}async u(u,r,f){return this.F(u).queue(async()=>{let h=[],k;try{const P=await this.m.readFile(u);k=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,S.$wl)(P)!==S.FileOperationResult.FILE_NOT_FOUND)throw P;if(this.r.extUri.isEqual(u,this.n.defaultProfile.extensionsResource)&&(k=await this.D()),!k&&f?.bailOutWhenFileNotFound)throw new d((0,m.$bb)(P),g.ERROR_PROFILE_NOT_FOUND)}if(k){Array.isArray(k)||this.w(u);let P=!1;for(const O of k){o(O)||this.w(u);let C;if((0,c.$jg)(O.relativeLocation)&&O.relativeLocation)C=this.z(O.relativeLocation);else if((0,c.$jg)(O.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${O.location}`);continue}else{C=T.URI.revive(O.location);const L=this.y(C);L&&(P=!0,O.relativeLocation=L)}(0,c.$qg)(O.metadata?.hasPreReleaseVersion)&&O.metadata?.preRelease&&(P=!0,O.metadata.hasPreReleaseVersion=!0),h.push({identifier:O.identifier,location:C,version:O.version,metadata:O.metadata})}P&&await this.m.writeFile(u,i.$Se.fromString(JSON.stringify(k)))}if(r){h=r(h);const P=h.map(O=>({identifier:O.identifier,version:O.version,location:O.location.toJSON(),relativeLocation:this.y(O.location),metadata:O.metadata}));await this.m.writeFile(u,i.$Se.fromString(JSON.stringify(P)))}return h})}w(u){const r=new d(`Invalid extensions content in ${u.toString()}`,g.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}y(u){return this.r.extUri.isEqual(this.r.extUri.dirname(u),this.j)?this.r.extUri.basename(u):void 0}z(u){return this.r.extUri.joinPath(this.j,u)}async D(){return this.C||(this.C=(async()=>{const u=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),r=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let f;try{f=(await this.m.readFile(u)).value.toString()}catch(k){if((0,S.$wl)(k)===S.FileOperationResult.FILE_NOT_FOUND)return;throw k}this.t.info("Migrating extensions from old default profile location",u.toString());let h;try{const k=JSON.parse(f);Array.isArray(k)&&k.every(P=>o(P))?h=k:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",k)}catch(k){this.t.error(k)}if(h)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,i.$Se.fromString(JSON.stringify(h)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",u.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(k){if((0,S.$wl)(k)===S.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",u.toString(),this.n.defaultProfile.extensionsResource.toString());else throw k}try{await this.m.del(u)}catch(k){(0,S.$wl)(k)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(k)}try{await this.m.del(r)}catch(k){(0,S.$wl)(k)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(k)}return h})()),this.C}F(u){let r=this.h.get(u);return r||(r=new t.$Rh,this.h.set(u,r)),r}};e.$Uq=w,e.$Uq=w=Ve([je(1,S.$fl),je(2,$.$Rl),je(3,a.$Pl),je(4,b.$em),je(5,p.$fk)],w);function o(n){return(0,c.$lg)(n)&&(0,v.$sp)(n.identifier)&&(l(n.location)||(0,c.$jg)(n.location)&&n.location)&&((0,c.$qg)(n.relativeLocation)||(0,c.$jg)(n.relativeLocation))&&n.version&&(0,c.$jg)(n.version)}function l(n){return n?(0,c.$jg)(n.path)&&(0,c.$jg)(n.scheme):!1}});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[64],Le([1,0,17,13,21,14,9,42,190,2,12,8,3,19,63,58,10,4,7,27,38,22,75,15,5,11,29,6,49,54,33,35,203]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d,w,o,l,n,u,r,f,h,k,P,O,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$Zq=e.$Yq=e.$Xq=e.Translations=void 0,e.$1q=ve,E=We(E),y=We(y),p=We(p),a=We(a),c=$t(c);var R;(function(se){function V(B,j){if(B===j)return!0;const U=Object.keys(B),te=new Set;for(const le of Object.keys(j))te.add(le);if(U.length!==te.size)return!1;for(const le of U){if(B[le]!==j[le])return!1;te.delete(le)}return te.size===0}se.equals=V})(R||(e.Translations=R={})),e.$Xq=(0,u.$Ki)("IExtensionsScannerService");let z=class extends s.$Zc{constructor(V,B,j,U,te,le,ye,oe,_,X,M,A){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=B,this.r=j,this.s=U,this.t=te,this.u=le,this.w=ye,this.y=oe,this.z=_,this.C=X,this.D=M,this.F=A,this.g=this.B(new h.$qe),this.onDidChangeCache=this.g.event,this.h=(0,$.$lh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(x,this.s,this.h)),this.m=this.B(this.F.createInstance(x,this.s,this.h)),this.n=this.B(this.F.createInstance(J,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(o.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(o.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,w.$6p)(this.w,this.y)),this.G}async scanAllExtensions(V,B,j){const[U,te]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(B)]),le=j?await this.scanExtensionsUnderDevelopment(V,[...U,...te]):[];return this.L(U,te,le,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const B=[];B.push(this.M(!!V.useCache,V.language)),B.push(this.N(V.language,!!V.checkControlFile));const[j,U]=await Promise.all(B);return this.J([...j,...U],o.ExtensionType.System,V,!1)}async scanUserExtensions(V){const B=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",B);const j=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(B,!!V.profileLocation,o.ExtensionType.User,!V.includeUninstalled,V.language,!0,j,V.productVersion??this.R()),te=V.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let le;try{le=await te.scanExtensions(U)}catch(ye){if(ye instanceof P.$Sq&&ye.code===P.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),le=await te.scanExtensions(U);else throw ye}return le=await this.J(le,o.ExtensionType.User,V,!0),this.y.trace("Scanned user extensions:",le.length),le}async scanExtensionsUnderDevelopment(V,B){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const j=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===S.Schemas.file).map(async U=>{const te=await this.P(U,!1,o.ExtensionType.User,!0,V.language,!1,void 0,V.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(te)).map(ye=>(ye.type=B.find(oe=>(0,w.$Up)(oe.identifier,ye.identifier))?.type??ye.type,this.n.validate(ye,te)))}))).flat();return this.J(j,"development",V,!0)}return[]}async scanExistingExtension(V,B,j){const U=await this.P(V,!1,B,!0,j.language,!0,void 0,j.productVersion??this.R()),te=await this.n.scanExtension(U);return!te||!j.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(V,B,j){const U=await this.P(V,!1,B,!0,j.language,!0,void 0,j.productVersion??this.R()),te=await this.n.scanOneOrMultipleExtensions(U);return this.J(te,B,j,!0)}async scanMultipleExtensions(V,B,j){const U=[];return await Promise.all(V.map(async te=>{const le=await this.scanOneOrMultipleExtensions(te,B,j);U.push(...le)})),this.J(U,B,j,!0)}async scanMetadata(V){const B=(0,$.$lh)(V,"package.json"),j=(await this.w.readFile(B)).value.toString();return JSON.parse(j).__metadata}async updateMetadata(V,B){const j=(0,$.$lh)(V,"package.json"),U=(await this.w.readFile(j)).value.toString(),te=JSON.parse(U);B.isMachineScoped===!1&&delete B.isMachineScoped,B.isBuiltin===!1&&delete B.isBuiltin,te.__metadata={...te.__metadata,...B},await this.w.writeFile((0,$.$lh)(V,"package.json"),I.$Se.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof P.$Sq&&V.code===P.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(B=>[B,B.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,I.$Se.fromString(JSON.stringify([])))}catch(B){(0,n.$wl)(B)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$bb)(B))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,B,j,U){return j.includeAllVersions||(V=this.L(B===o.ExtensionType.System?V:void 0,B===o.ExtensionType.User?V:void 0,B==="development"?V:void 0,await this.getTargetPlatform(),U)),j.includeInvalid||(V=V.filter(te=>te.isValid)),V.sort((te,le)=>{const ye=y.$sc(te.location.fsPath),oe=y.$sc(le.location.fsPath);return ye<oe?-1:ye>oe?1:0})}L(V,B,j,U,te){const le=(oe,_,X)=>{if(oe.isValid&&!_.isValid)return!1;if(oe.isValid===_.isValid){if(te&&a.gt(oe.manifest.version,_.manifest.version))return this.y.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(a.eq(oe.manifest.version,_.manifest.version)){if(oe.type===o.ExtensionType.System)return this.y.debug(`Skipping extension ${_.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===U)return this.y.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return X?this.y.warn(`Overwriting user extension ${oe.location.path} with ${_.location.path}.`):this.y.debug(`Overwriting user extension ${oe.location.path} with ${_.location.path}.`),!0},ye=new o.$Bn;return V?.forEach(oe=>{const _=ye.get(oe.identifier.id);(!_||le(_,oe,!1))&&ye.set(oe.identifier.id,oe)}),B?.forEach(oe=>{const _=ye.get(oe.identifier.id);if(!_&&V&&oe.type===o.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!_||le(_,oe,!1))&&ye.set(oe.identifier.id,oe)}),j?.forEach(oe=>{const _=ye.get(oe.identifier.id);(!_||le(_,oe,!0))&&ye.set(oe.identifier.id,oe),ye.set(oe.identifier.id,oe)}),[...ye.values()]}async M(V,B){this.y.trace("Started scanning system extensions");const j=await this.P(this.systemExtensionsLocation,!1,o.ExtensionType.System,!0,B,!0,void 0,this.R()),te=await(V&&!j.devMode?this.j:this.n).scanExtensions(j);return this.y.trace("Scanned system extensions:",te.length),te}async N(V,B){const j=this.z.isBuilt?[]:this.C.builtInExtensions;if(!j?.length)return[];this.y.trace("Started scanning dev system extensions");const U=B?await this.O():{},te=[],le=b.URI.file(y.$mc(y.$oc(S.$5g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of j){const _=U[oe.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":te.push((0,$.$lh)(le,oe.name));break;default:te.push(b.URI.file(_));break}}const ye=await Promise.all(te.map(async oe=>this.n.scanExtension(await this.P(oe,!1,o.ExtensionType.System,!0,V,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ye.length),(0,t.$Lb)(ye)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,B,j,U,te,le,ye,oe){const _=await this.f(te??p.$z),X=await this.Q(V),M=B&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,A=M?await this.Q(M):void 0;return new Q(V,X,M,A,B,ye,j,U,le,oe.version,oe.date,this.C.commit,!this.z.isBuilt,te,_)}async Q(V){try{const B=await this.w.stat(V);if(typeof B.mtime=="number")return B.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Yq=z,e.$Yq=z=Ve([je(4,O.$Rl),je(5,P.$Tq),je(6,n.$fl),je(7,r.$fk),je(8,d.$Ri),je(9,f.$yk),je(10,C.$Pl),je(11,u.$Ji)],z);class Q{constructor(V,B,j,U,te,le,ye,oe,_,X,M,A,Y,pe,ne){this.location=V,this.mtime=B,this.applicationExtensionslocation=j,this.applicationExtensionslocationMtime=U,this.profile=te,this.profileScanOptions=le,this.type=ye,this.excludeObsolete=oe,this.validate=_,this.productVersion=X,this.productDate=M,this.productCommit=A,this.devMode=Y,this.language=pe,this.translations=ne}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,B){return(0,$.$eh)(V.location,B.location)&&V.mtime===B.mtime&&(0,$.$eh)(V.applicationExtensionslocation,B.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&V.profile===B.profile&&E.$qo(V.profileScanOptions,B.profileScanOptions)&&V.type===B.type&&V.excludeObsolete===B.excludeObsolete&&V.validate===B.validate&&V.productVersion===B.productVersion&&V.productDate===B.productDate&&V.productCommit===B.productCommit&&V.devMode===B.devMode&&V.language===B.language&&R.equals(V.translations,B.translations)}}e.$Zq=Q;let J=class extends s.$Zc{constructor(V,B,j,U,te,le,ye){super(),this.g=V,this.h=B,this.j=j,this.m=U,this.n=le,this.r=ye,this.f=te.extensionsEnabledWithApiProposalVersion?.map(oe=>oe.toLowerCase())??[]}async scanExtensions(V){const B=V.profile?await this.t(V):await this.s(V);let j={};if(V.excludeObsolete&&V.type===o.ExtensionType.User)try{const U=(await this.m.readFile(this.g)).value.toString();j=JSON.parse(U)}catch{}return(0,m.$wg)(j)?B:B.filter(U=>!j[w.$Vp.create(U).toString()])}async s(V){const B=await this.m.resolve(V.location);if(!B.children?.length)return[];const j=await Promise.all(B.children.map(async U=>{if(!U.isDirectory||V.type===o.ExtensionType.User&&(0,$.$ih)(U.resource).indexOf(".")===0)return null;const te=new Q(U.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te)}));return(0,t.$Lb)(j).sort((U,te)=>U.location.path<te.location.path?-1:1)}async t(V){let B=await this.u(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.j.extUri.isEqual(V.location,V.applicationExtensionslocation)){B=B.filter(U=>!U.metadata?.isApplicationScoped);const j=await this.u(V.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,V);B.push(...j)}return B}async u(V,B,j){const U=await this.h.scanProfileExtensions(V,j.profileScanOptions);if(!U.length)return[];const te=await Promise.all(U.map(async le=>{if(B(le)){const ye=new Q(le.location,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(ye,le.metadata)}return null}));return(0,t.$Lb)(te)}async scanOneOrMultipleExtensions(V){try{if(await this.m.exists((0,$.$lh)(V.location,"package.json"))){const B=await this.scanExtension(V);return B?[B]:[]}else return await this.scanExtensions(V)}catch(B){return this.r.error(`Error scanning extensions at ${V.location.path}:`,(0,D.$bb)(B)),[]}}async scanExtension(V,B){try{let j=await this.w(V.location);if(j){j.publisher||(j.publisher=o.$vn),B=B??j.__metadata,delete j.__metadata;const U=(0,w.$Zp)(j.publisher,j.name),te=B?.id?{id:U,uuid:B.id}:{id:U},le=B?.isSystem?o.ExtensionType.System:V.type,ye=le===o.ExtensionType.System||!!B?.isBuiltin;j=await this.y(V.location,j,Q.createNlsConfiguration(V));let oe={type:le,identifier:te,manifest:j,location:V.location,isBuiltin:ye,targetPlatform:B?.targetPlatform??o.TargetPlatform.UNDEFINED,publisherDisplayName:B?.publisherDisplayName,metadata:B,isValid:!0,validations:[]};return V.validate&&(oe=this.validate(oe,V)),j.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(U.toLowerCase()))&&(j.originalEnabledApiProposals=j.enabledApiProposals,j.enabledApiProposals=(0,o.$Hn)([...j.enabledApiProposals])),oe}}catch(j){V.type!==o.ExtensionType.System&&this.r.error(j)}return null}validate(V,B){let j=!0;const U=this.n.isBuilt&&this.f.includes(V.identifier.id.toLowerCase()),te=(0,l.$_p)(B.productVersion,B.productDate,B.location,V.manifest,V.isBuiltin,U);for(const[le,ye]of te)le===c.default.Error&&(j=!1,this.r.error(this.F(B.location,ye)));return V.isValid=j,V.validations=te,V}async w(V){const B=(0,$.$lh)(V,"package.json");let j;try{j=(await this.m.readFile(B)).value.toString()}catch(te){return(0,n.$wl)(te)!==n.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(V,(0,g.localize)(1816,null,B.path,te.message))),null}let U;try{U=JSON.parse(j)}catch{const le=[];(0,T.$7n)(j,le);for(const ye of le)this.r.error(this.F(V,(0,g.localize)(1817,null,B.path,ye.offset,ye.length,(0,v.$Vq)(ye.error))));return null}return(0,T.$co)(U)!=="object"?(this.r.error(this.F(V,(0,g.localize)(1818,null,B.path))),null):U}async y(V,B,j){const U=await this.z(V,B,j);if(U)try{const te=[],le=await this.C(U.default,te);if(te.length>0)return te.forEach(oe=>{this.r.error(this.F(V,(0,g.localize)(1819,null,U.default?.path,(0,v.$Vq)(oe.error))))}),B;if((0,T.$co)(U)!=="object")return this.r.error(this.F(V,(0,g.localize)(1820,null,U.default?.path))),B;const ye=U.values||Object.create(null);return(0,L.$Wq)(this.r,B,ye,le)}catch{}return B}async z(V,B,j){const U=(0,$.$lh)(V,"package.nls.json"),te=(_,X)=>{X.forEach(M=>{this.r.error(this.F(V,(0,g.localize)(1821,null,_?.path,(0,v.$Vq)(M.error))))})},le=_=>{this.r.error(this.F(V,(0,g.localize)(1822,null,_?.path)))},ye=`${B.publisher}.${B.name}`,oe=j.translations[ye];if(oe)try{const _=b.URI.file(oe),X=(await this.m.readFile(_)).value.toString(),M=[],A=(0,T.$7n)(X,M);return M.length>0?(te(_,M),{values:void 0,default:U}):(0,T.$co)(A)!=="object"?(le(_),{values:void 0,default:U}):{values:A.contents?A.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.m.exists(U))return;let X;try{X=await this.D(V,j)}catch{return}if(!X.localized)return{values:void 0,default:X.original};try{const M=(await this.m.readFile(X.localized)).value.toString(),A=[],Y=(0,T.$7n)(M,A);return A.length>0?(te(X.localized,A),{values:void 0,default:X.original}):(0,T.$co)(Y)!=="object"?(le(X.localized),{values:void 0,default:X.original}):{values:Y,default:X.original}}catch{return{values:void 0,default:X.original}}}}async C(V,B){if(V)try{const j=(await this.m.readFile(V)).value.toString();return(0,T.$7n)(j,B)}catch{}}D(V,B){return new Promise((j,U)=>{const te=le=>{const ye=(0,$.$lh)(V,`package.nls.${le}.json`);this.m.exists(ye).then(oe=>{oe&&j({localized:ye,original:(0,$.$lh)(V,"package.nls.json")});const _=le.lastIndexOf("-");_===-1?j({localized:(0,$.$lh)(V,"package.nls.json"),original:null}):(le=le.substring(0,_),te(le))})};if(B.devMode||B.pseudo||!B.language)return j({localized:(0,$.$lh)(V,"package.nls.json"),original:null});te(B.language)})}F(V,B){return`[${V.path}]: ${B}`}};J=Ve([je(1,P.$Tq),je(2,C.$Pl),je(3,n.$fl),je(4,f.$yk),je(5,d.$Ri),je(6,r.$fk)],J);let x=class extends J{constructor(V,B,j,U,te,le,ye,oe,_){super(B,U,te,le,ye,oe,_),this.J=V,this.L=j,this.H=this.B(new i.$Ih(3e3)),this.I=this.B(new h.$qe),this.onDidChangeCache=this.I.event}async scanExtensions(V){const B=this.P(V),j=await this.M(B);if(this.G=V,j&&j.input&&Q.equals(j.input,this.G))return this.r.debug("Using cached extensions scan result",V.type===o.ExtensionType.System?"system":"user",V.location.toString()),this.H.trigger(()=>this.O()),j.result.map(te=>(te.location=b.URI.revive(te.location),te));const U=await super.scanExtensions(V);return await this.N(B,{input:V,result:U}),U}async M(V){try{const B=await this.m.readFile(V),j=JSON.parse(B.value.toString());return{result:j.result,input:(0,k.$hi)(j.input)}}catch(B){this.r.debug("Error while reading the extension cache file:",V.path,(0,D.$bb)(B))}return null}async N(V,B){try{await this.m.writeFile(V,I.$Se.fromString(JSON.stringify(B)))}catch(j){this.r.debug("Error while writing the extension cache file:",V.path,(0,D.$bb)(j))}}async O(){if(!this.G)return;const V=this.P(this.G),B=await this.M(V);if(!B)return;const j=B.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!E.$qo(U,j))try{this.r.info("Invalidating Cache",j,U),await this.m.del(V),this.I.fire()}catch(te){this.r.error(te)}}P(V){const B=this.Q(V);return this.j.extUri.joinPath(B.cacheHome,V.type===o.ExtensionType.System?o.$un:o.$tn)}Q(V){return V.type===o.ExtensionType.System?this.L.defaultProfile:V.profile?this.j.extUri.isEqual(V.location,this.J.extensionsResource)?this.J:this.L.profiles.find(B=>this.j.extUri.isEqual(V.location,B.extensionsResource))??this.J:this.L.defaultProfile}};x=Ve([je(2,O.$Rl),je(3,P.$Tq),je(4,C.$Pl),je(5,n.$fl),je(6,f.$yk),je(7,d.$Ri),je(8,r.$fk)],x);function ve(se,V){const B=(0,w.$Xp)(se.manifest.publisher,se.manifest.name);return{id:B,identifier:new o.$zn(B),isBuiltin:se.type===o.ExtensionType.System,isUserBuiltin:se.type===o.ExtensionType.User&&se.isBuiltin,isUnderDevelopment:V,extensionLocation:se.location,uuid:se.identifier.uuid,targetPlatform:se.targetPlatform,publisherDisplayName:se.publisherDisplayName,...se.manifest}}class be extends z{constructor(V,B,j,U,te,le,ye,oe,_,X,M,A){super(V,B,(0,$.$lh)(j,".vscode-oss-dev","extensions","control.json"),U,te,le,ye,oe,_,X,M,A),this.S=(async()=>{if(p.$C)try{const Y=await this.w.readFile(b.URI.file(p.$C));return JSON.parse(Y.value.toString())}catch{}return Object.create(null)})()}f(V){return this.S}}e.$2q=be}),define(Oe[247],Le([1,0,50,13,45,6,2,12,8,26,11,33]),function(ue,e,t,i,E,I,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;let p=class extends D.$Zc{constructor(a,c){super(),this.b=a,this.f=c,this.a=new i.$Qh(5)}async postUninstall(a){const c=this.g(a,"uninstall");c&&(this.f.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(c.script,"uninstall",c.args,!0,a),this.f.info("Finished running post uninstall script",a.identifier.id,a.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",a.identifier.id,a.manifest.version),this.f.error(m)}}));try{await s.Promises.rm(this.m(a))}catch(m){this.f.error("Error while removing extension storage path",a.identifier.id),this.f.error(m)}}g(a,c){const m=`vscode:${c}`;if(a.location.scheme===T.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[m]=="string"){const b=a.manifest.scripts[m].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.f.warn(a.identifier.id,a.manifest.version,`${m} should be a node script`),null):{script:(0,v.$oc)(a.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}h(a,c,m,b,g){return new Promise((d,w)=>{const o=this.j(a,c,m,g);let l;const n=u=>{l&&(clearTimeout(l),l=null),u?w(u):d(void 0)};o.on("error",u=>{n((0,E.$vj)(u)||"Unknown")}),o.on("exit",(u,r)=>{n(u?`post-${c} process exited with code ${u}`:void 0)}),b&&(l=setTimeout(()=>{l=null,o.kill(),w("timed out")},5e3))})}j(a,c,m,b){const g={silent:!0,execArgv:void 0},d=(0,t.fork)(a,[`--type=extension-post-${c}`,...m],g);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const w=I.Event.fromNodeEventEmitter(d.stdout,"data"),o=I.Event.fromNodeEventEmitter(d.stderr,"data");this.B(w(u=>this.f.info(b.identifier.id,b.manifest.version,`post-${c}`,u))),this.B(o(u=>this.f.error(b.identifier.id,b.manifest.version,`post-${c}`,u)));const l=I.Event.any(I.Event.map(w,u=>({data:`%c${u}`,format:[""]}),this.q),I.Event.map(o,u=>({data:`%c${u}`,format:["color: red"]}),this.q));return I.Event.debounce(l,(u,r)=>u?{data:u.data+r.data,format:[...u.format,...r.format]}:{data:r.data,format:r.format},100,void 0,void 0,void 0,this.q)(u=>{console.group(b.identifier.id),console.log(u.data,...u.format),console.groupEnd()}),d}m(a){return(0,v.$oc)(this.b.defaultProfile.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};e.$6q=p,e.$6q=p=Ve([je(0,y.$Rl),je(1,S.$fk)],p)}),define(Oe[141],Le([1,0,87,7,99,30]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=D,e.$4q=T;function D(v){let s=I.ExtensionManagementErrorCode.Extract;return v instanceof t.$Lq&&(v.type==="CorruptZip"?s=I.ExtensionManagementErrorCode.CorruptZip:v.type==="Incomplete"&&(s=I.ExtensionManagementErrorCode.IncompleteZip)),(0,E.$Qq)(v,s)}async function T(v){let s;try{s=await(0,t.$Oq)(v,"extension/package.json")}catch(S){throw D(S)}try{return JSON.parse(s.toString("utf8"))}catch{throw new I.$vp((0,i.localize)(1832,null),I.ExtensionManagementErrorCode.Invalid)}}}),define(Oe[248],Le([1,0,13,9,2,12,19,63,10,23,26,87,28,27,99,30,38,141,95,15,11,24]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d,w,o){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0,T=We(T);let n=class extends E.$Zc{static{l=this}static{this.c=".sigzip"}constructor(r,f,h,k,P,O,C){super(),this.h=f,this.j=h,this.m=k,this.n=P,this.r=O,this.t=C,this.extensionsDownloadDir=r.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(r,f,h,k){await this.g;const P=await this.w(r,f);let O=!1;if(h&&this.u(r)){let C;try{C=await this.y(r)}catch(L){try{await this.delete(P)}catch(R){this.t.error(R)}throw L}try{O=await this.n.verify(r,P.fsPath,C.fsPath,k)}catch(L){if(O=L.code,O===g.ExtensionSignatureVerificationCode.PackageIsInvalidZip||O===g.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(P)}catch(R){this.t.error(R)}throw new c.$vp(y.$Kq,c.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(C)}catch(L){this.t.error(L)}}}return{location:P,verificationStatus:O}}u(r){return r.isSigned||this.t.info(`Extension is not signed: ${r.identifier.id}`),!1}async w(r,f){try{const h=(0,D.$lh)(this.extensionsDownloadDir,this.G(r)),k=await this.C(r,"vsix",async()=>{await this.z(r,h,P=>this.j.download(r,P,f));try{await this.D(h.fsPath,"extension/package.json")}catch(P){try{await this.h.del(h)}catch(O){this.t.warn(`Error while deleting: ${h.path}`,(0,i.$bb)(O))}throw P}},2);return k>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:r.identifier.id,attempts:k}),h}catch(h){throw(0,a.$Qq)(h,c.ExtensionManagementErrorCode.Download)}}async y(r){try{const f=(0,D.$lh)(this.extensionsDownloadDir,`.${(0,s.$7g)()}`),h=await this.C(r,"sigzip",async()=>{await this.j.downloadSignatureArchive(r,f);try{await this.D(f.fsPath,".signature.p7s")}catch(k){try{await this.h.del(f)}catch(P){this.t.warn(`Error while deleting: ${f.path}`,(0,i.$bb)(P))}throw k}},2);return h>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:r.identifier.id,attempts:h}),f}catch(f){throw(0,a.$Qq)(f,c.ExtensionManagementErrorCode.DownloadSignature)}}async z(r,f,h){if(await this.h.exists(f))return;if(f.scheme!==I.Schemas.file){await h(f);return}const k=(0,D.$lh)(this.extensionsDownloadDir,`.${(0,s.$7g)()}`);try{await h(k)}catch(P){try{await this.h.del(k)}catch{}throw P}try{await S.Promises.rename(k.fsPath,f.fsPath,2*60*1e3)}catch(P){try{await this.h.del(k)}catch{}let O=!1;try{O=await this.h.exists(f)}catch{}if(O)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",r.identifier.id,f.path);else throw this.t.info(`Rename failed because of ${(0,i.$bb)(P)}. Deleted the file from downloaded location`,k.path),P}}async C(r,f,h,k){let P=1;for(;;)try{return await h(),P}catch(O){if(P++>k)throw O;this.t.warn(`Failed downloading ${f}. ${(0,i.$bb)(O)}. Retry again...`,r.identifier.id)}}async D(r,f){try{await(0,y.$Oq)(r,f)}catch(h){throw(0,b.$3q)(h)}}async delete(r){await this.g,await this.h.del(r)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const r=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(r.children){const f=[],h=[],k=[];for(const C of r.children)if(C.name.endsWith(l.c))k.push(C.resource);else{const L=m.$Vp.parse(C.name);L&&h.push([L,C])}const P=(0,m.$1p)(h,([C])=>C),O=[];for(const C of P)C.sort((L,R)=>T.rcompare(L[0].version,R[0].version)),f.push(...C.slice(1).map(L=>L[1].resource)),O.push(C[0][1]);O.sort((C,L)=>C.mtime-L.mtime),f.push(...O.slice(0,Math.max(0,O.length-this.f)).map(C=>C.resource)),f.push(...k),await t.Promises.settled(f.map(C=>(this.t.trace("Deleting from cache",C.path),this.h.del(C))))}}catch(r){this.t.error(r)}}G(r){return this.f?m.$Vp.create(r).toString().toLowerCase():(0,s.$7g)()}};e.$5q=n,e.$5q=n=l=Ve([je(0,$.$Si),je(1,d.$fl),je(2,c.$tp),je(3,p.$ej),je(4,g.$Dq),je(5,o.$em),je(6,w.$fk)],n)}),define(Oe[142],Le([1,0,20,13,14,18,45,9,6,67,2,25,12,8,19,63,10,4,23,26,87,7,88,27,99,30,38,54,64,248,247,141,224,233,22,75,15,5,11,29,24,35,33]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d,w,o,l,n,u,r,f,h,k,P,O,C,L,R,z,Q,J,x,ve,be,se,V,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=e.$9q=void 0,t=We(t),$=We($),c=We(c),d=We(d),o=We(o),e.$9q=(0,x.$Li)(r.$wp);const j=".vsctmp";let U=class extends u.$Pq{constructor(_,X,M,A,Y,pe,ne,ie,G,Z,ce,we){super(_,X,ce,M,Z,we),this.db=Y,this.eb=pe,this.fb=ne,this.gb=ie,this.hb=G,this.cb=new Map,this.sb=new y.$Gc;const Ie=this.B(ie.createInstance(O.$6q));this.$=this.B(ie.createInstance(te,Be=>Ie.postUninstall(Be))),this.ab=this.B(new L.$7q(we,G,ce,this,this.F)),this.bb=this.B(ie.createInstance(P.$5q));const Me=this.B(new R.$8q(this,this.db,we,pe,ce,G,M));this.B(Me.onDidChangeExtensionsByAnotherSource(Be=>this.rb(Be))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,f.$6p)(this.hb,this.F)),this.ib}async zip(_){this.F.trace("ExtensionManagementService#zip",_.identifier.id);const X=await this.qb(_),M=await(0,w.zip)((0,a.$lh)(this.bb.extensionsDownloadDir,(0,g.$7g)()).fsPath,X);return b.URI.file(M)}async getManifest(_){const{location:X,cleanup:M}=await this.kb(_),A=$.$pc(X.fsPath);try{return await(0,C.$4q)(A)}finally{await M()}}getInstalled(_,X=this.H.defaultProfile.extensionsResource,M={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(_??null,X,M)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(_){return this.$.scanUserExtensionAtLocation(_)}async install(_,X={}){this.F.trace("ExtensionManagementService#install",_.toString());const{location:M,cleanup:A}=await this.kb(_);try{const Y=await(0,C.$4q)($.$pc(M.fsPath)),pe=(0,f.$Zp)(Y.publisher,Y.name);if(Y.engines&&Y.engines.vscode&&!(0,Q.$bq)(Y.engines.vscode,this.G.version,this.G.date))throw new Error(o.localize(1823,null,pe,this.G.version));const ie=(await this.I([{manifest:Y,extension:M,options:X}])).find(({identifier:G})=>(0,f.$Up)(G,{id:pe}));if(ie?.local)return ie.local;throw ie?.error?ie.error:(0,u.$Qq)(new Error(`Unknown error while installing extension ${pe}`))}finally{await A()}}async installFromLocation(_,X){this.F.trace("ExtensionManagementService#installFromLocation",_.toString());const M=await this.$.scanUserExtensionAtLocation(_);if(!M||!M.manifest.name||!M.manifest.version)throw new Error(`Cannot find a valid extension from the location ${_.toString()}`);return await this.vb([[M,{source:"resource"}]],X),this.F.info("Successfully installed extension",M.identifier.id,X.toString()),M}async installExtensionsFromProfile(_,X,M){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",_,X.toString(),M.toString());const A=(await this.getInstalled(z.ExtensionType.User,X)).filter(Y=>_.some(pe=>(0,f.$Up)(pe,Y.identifier)));if(A.length){const Y=await Promise.all(A.map(pe=>this.$.scanMetadata(pe,X)));await this.vb(A.map((pe,ne)=>[pe,Y[ne]]),M),this.F.info("Successfully installed extensions",A.map(pe=>pe.identifier.id),M.toString())}return A}async updateMetadata(_,X,M){return this.F.trace("ExtensionManagementService#updateMetadata",_.identifier.id),X.isPreReleaseVersion&&(X.preRelease=!0,X.hasPreReleaseVersion=!0),X.isMachineScoped===!1&&(X.isMachineScoped=void 0),X.isBuiltin===!1&&(X.isBuiltin=void 0),X.pinned===!1&&(X.pinned=void 0),_=await this.$.updateMetadata(_,X,M),this.ab.invalidate(M),this.w.fire({local:_,profileLocation:M}),_}async reinstallFromGallery(_){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",_.identifier.id),!this.z.isEnabled())throw new Error(o.localize(1824,null));const X=await this.getTargetPlatform(),[M]=await this.z.getExtensions([{..._.identifier,preRelease:_.preRelease}],{targetPlatform:X,compatible:!0},I.CancellationToken.None);if(!M)throw new Error(o.localize(1825,null));await this.$.setUninstalled(_);try{await this.$.removeUninstalledExtension(_)}catch(A){throw new Error(o.localize(1826,null,(0,D.$vj)(A)))}return this.installFromGallery(M)}Z(_,X,M,A){return this.$.copyExtension(_,X,M,A)}copyExtensions(_,X){return this.$.copyExtensions(_,X,{version:this.G.version,date:this.G.date})}markAsUninstalled(..._){return this.$.setUninstalled(..._)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(_){this.F.error(_)}}async download(_,X,M){const{location:A}=await this.bb.download(_,X,!M);return A}async kb(_){if(_.scheme===p.Schemas.file)return{location:_,async cleanup(){}};this.F.trace("Downloading extension from",_.toString());const X=(0,a.$lh)(this.bb.extensionsDownloadDir,(0,g.$7g)());return await this.fb.download(_,X),this.F.info("Downloaded extension to",X.toString()),{location:X,cleanup:async()=>{try{await this.hb.del(X)}catch(A){this.F.error(A)}}}}W(){return this.H.defaultProfile.extensionsResource}X(_,X,M){const A=X instanceof b.URI?new f.$Vp({id:(0,f.$Zp)(_.publisher,_.name)},_.version):f.$Vp.create(X);return this.gb.createInstance(le,A,_,X,M,(Y,pe)=>{if(X instanceof b.URI)return this.pb(A,X,M,pe);let ne=this.cb.get(A.toString());return ne||(this.cb.set(A.toString(),ne=this.ob(A,X,Y,M,pe)),ne.finally(()=>this.cb.delete(A.toString()))),ne},this.$)}Y(_,X){return new ye(_,X,this.eb)}async ob(_,X,M,A,Y){const{verificationStatus:pe,location:ne}=await this.bb.download(X,M,!A.donotVerifySignature,A.context?.[r.$mp]);try{if(Y.isCancellationRequested)throw new T.$9;const ie=await(0,C.$4q)(ne.fsPath);if(!new f.$Vp(X.identifier,X.version).equals(new f.$Vp({id:(0,f.$Zp)(ie.publisher,ie.name)},ie.version)))throw new r.$vp(o.localize(1827,null,X.identifier.id),r.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(_,ne.fsPath,{id:X.identifier.uuid,publisherId:X.publisherId,publisherDisplayName:X.publisherDisplayName,targetPlatform:X.properties.targetPlatform,isApplicationScoped:A.isApplicationScoped,isMachineScoped:A.isMachineScoped,isBuiltin:A.isBuiltin,isPreReleaseVersion:X.properties.isPreReleaseVersion,hasPreReleaseVersion:X.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:A.installGivenVersion?!0:!!A.pinned,preRelease:(0,m.$pg)(A.preRelease)?A.preRelease:A.installPreReleaseVersion||X.properties.isPreReleaseVersion,source:"gallery"},!1,Y),verificationStatus:pe}}catch(ie){try{await this.bb.delete(ne)}catch(G){this.F.warn("Error while deleting the downloaded file",ne.toString(),(0,T.$bb)(G))}throw(0,u.$Qq)(ie)}}async pb(_,X,M,A){return{local:await this.$.extractUserExtension(_,$.$pc(X.fsPath),{isApplicationScoped:M.isApplicationScoped,isMachineScoped:M.isMachineScoped,isBuiltin:M.isBuiltin,installedTimestamp:Date.now(),pinned:M.installGivenVersion?!0:!!M.pinned,source:"vsix"},M.keepExisting??!0,A)}}async qb(_){const X=async A=>{let Y=await d.Promises.readdir(A);Y=Y.map(ie=>$.$oc(A,ie));const pe=await Promise.all(Y.map(ie=>t.promises.stat(ie)));let ne=Promise.resolve([]);return pe.forEach((ie,G)=>{const Z=Y[G];ie.isFile()&&(ne=ne.then(ce=>[...ce,Z])),ie.isDirectory()&&(ne=ne.then(ce=>X(Z).then(we=>[...ce,...we])))}),ne};return(await X(_.location.fsPath)).map(A=>({path:`extension/${$.$qc(_.location.fsPath,A)}`,localPath:A}))}async rb({added:_,removed:X}){if(X){const M=_&&this.D.extUri.isEqual(X.profileLocation,_.profileLocation)?X.extensions.filter(A=>_.extensions.every(Y=>!(0,f.$Up)(Y,A))):X.extensions;for(const A of M)this.F.info("Extensions removed from another source",A.id,X.profileLocation.toString()),this.u.fire({identifier:A,profileLocation:X.profileLocation})}if(_){const A=(await this.getInstalled(z.ExtensionType.User,_.profileLocation)).filter(Y=>_.extensions.some(pe=>(0,f.$Up)(pe,Y.identifier)));this.s.fire(A.map(Y=>(this.F.info("Extensions added from another source",Y.identifier.id,_.profileLocation.toString()),{identifier:Y.identifier,local:Y,profileLocation:_.profileLocation,operation:r.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(X=>this.sb.add(X)));const _=await this.hb.resolve(this.db.userExtensionsLocation);for(const X of _.children??[])X.isDirectory&&this.sb.add(X.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(X=>this.ub(X)))}async ub(_){if(!_.affects(this.db.userExtensionsLocation,J.FileChangeType.ADDED))return;const X=[];for(const M of _.rawAdded){if(this.sb.has(M)||!this.D.extUri.isEqual(this.D.extUri.dirname(M),this.db.userExtensionsLocation)||this.D.extUri.isEqual(M,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(M).startsWith(".")||!(await this.hb.stat(M)).isDirectory)continue;const A=await this.$.scanUserExtensionAtLocation(M);A&&A.installedTimestamp===void 0&&(this.sb.add(M),X.push(A))}X.length&&(await this.vb(X.map(M=>[M,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",X.map(M=>M.identifier.id)))}async vb(_,X){const M=_.map(A=>A[0]);await this.wb(M),await this.eb.addExtensionsToProfile(_,X),this.s.fire(M.map(A=>({local:A,identifier:A.identifier,operation:r.InstallOperation.None,profileLocation:X})))}async wb(_){const X=await this.$.getUninstalledExtensions();for(const M of _){const A=f.$Vp.create(M);X[A.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",A.id),await this.$.setInstalled(A),this.F.info("Removed the extension from uninstalled list:",A.id))}}};e.$0q=U,e.$0q=U=Ve([je(0,r.$tp),je(1,se.$em),je(2,ve.$fk),je(3,n.$Si),je(4,k.$Xq),je(5,h.$Tq),je(6,l.$0o),je(7,x.$Ji),je(8,J.$fl),je(9,be.$yk),je(10,V.$Pl),je(11,B.$Rl)],U);let te=class extends S.$Zc{constructor(_,X,M,A,Y,pe,ne){super(),this.n=_,this.s=X,this.t=M,this.u=A,this.w=Y,this.y=pe,this.z=ne,this.h=this.B(new v.$qe),this.onExtract=this.h.event,this.j=new y.$Fc,this.m=new y.$Fc,this.c=(0,a.$lh)(this.t.userExtensionsLocation,".obsolete"),this.g=new i.$Rh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(_,X,M){try{const A={includeInvalid:!0,profileLocation:X,productVersion:M};let Y=[];if(_===null||_===z.ExtensionType.System){let pe=this.j.get(X);pe||(pe=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},A,!1).finally(()=>this.j.delete(X)),this.j.set(X,pe)),Y.push(...await pe)}else if(_===z.ExtensionType.User){let pe=this.m.get(X);pe||(pe=this.t.scanUserExtensions(A).finally(()=>this.m.delete(X)),this.m.set(X,pe)),Y.push(...await pe)}return Y=_!==null?Y.filter(pe=>pe.type===_):Y,await Promise.all(Y.map(pe=>this.H(pe)))}catch(A){throw(0,u.$Qq)(A,r.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(_){try{const X=await this.t.scanUserExtensions({includeAllVersions:!_,includeInvalid:!0});return await Promise.all(X.map(M=>this.H(M)))}catch(X){throw(0,u.$Qq)(X,r.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(_){try{const X=await this.t.scanExistingExtension(_,z.ExtensionType.User,{includeInvalid:!0});if(X)return await this.H(X)}catch(X){this.z.error(X)}return null}async extractUserExtension(_,X,M,A,Y){const pe=_.toString(),ne=b.URI.file($.$oc(this.t.userExtensionsLocation.fsPath,`.${(0,g.$7g)()}`)),ie=b.URI.file($.$oc(this.t.userExtensionsLocation.fsPath,pe));if(await this.s.exists(ie)){if(!A)try{return await this.scanLocalExtension(ie,z.ExtensionType.User)}catch(G){this.z.warn(`Error while scanning the existing extension at ${ie.path}. Deleting the existing extension and extracting it.`,(0,T.$bb)(G))}try{await this.D(_.id,ie,"removeExisting")}catch{throw new r.$vp(o.localize(1828,null,ie.fsPath,_.id),r.ExtensionManagementErrorCode.Delete)}}try{if(Y.isCancellationRequested)throw new T.$9;try{this.z.trace(`Started extracting the extension from ${X} to ${ie.fsPath}`),await(0,w.$Nq)(X,ne.fsPath,{sourcePath:"extension",overwrite:!0},Y),this.z.info(`Extracted extension to ${ie}:`,_.id)}catch(G){throw(0,C.$3q)(G)}try{await this.t.updateMetadata(ne,M)}catch(G){throw this.y.publicLog2("extension:extract",{extensionId:_.id,code:`${(0,J.$wl)(G)}`}),(0,u.$Qq)(G,r.ExtensionManagementErrorCode.UpdateMetadata)}if(Y.isCancellationRequested)throw new T.$9;try{this.z.trace(`Started renaming the extension from ${ne.fsPath} to ${ie.fsPath}`),await this.G(ne.fsPath,ie.fsPath),this.z.info("Renamed to",ie.fsPath)}catch(G){if(G.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",_.id);try{await this.s.del(ne,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,T.$bb)(G)}. Deleted from extracted location`,ne),G}this.h.fire(ie)}catch(G){try{await this.s.del(ne,{recursive:!0})}catch{}throw G}return this.scanLocalExtension(ie,z.ExtensionType.User)}async scanMetadata(_,X){return X?(await this.C(_,X))?.metadata:this.t.scanMetadata(_.location)}async C(_,X){return(await this.u.scanProfileExtensions(X)).find(A=>(0,f.$Up)(A.identifier,_.identifier))}async updateMetadata(_,X,M){try{M?await this.u.updateMetadata([[_,X]],M):await this.t.updateMetadata(_.location,X)}catch(A){throw this.y.publicLog2("extension:extract",{extensionId:_.identifier.id,code:`${(0,J.$wl)(A)}`,isProfile:!!M}),(0,u.$Qq)(A,r.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(_.location,_.type,M)}async getUninstalledExtensions(){try{return await this.F()}catch(_){throw(0,u.$Qq)(_,r.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(..._){const X=_.map(M=>f.$Vp.create(M));await this.F(M=>X.forEach(A=>{M[A.toString()]=!0,this.z.info("Marked extension as uninstalled",A.toString())}))}async setInstalled(_){try{await this.F(X=>delete X[_.toString()])}catch(X){throw(0,u.$Qq)(X,r.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(_,X){if(this.w.extUri.isEqualOrParent(_.location,this.t.userExtensionsLocation))return this.D(_.identifier.id,_.location,X)}async removeUninstalledExtension(_){await this.removeExtension(_,"uninstalled"),await this.F(X=>delete X[f.$Vp.create(_).toString()])}async copyExtension(_,X,M,A){const Y=await this.C(_,X),pe=await this.C(_,M);if(A={...Y?.metadata,...A},pe)if(this.w.extUri.isEqual(pe.location,_.location))await this.u.updateMetadata([[_,{...pe.metadata,...A}]],M);else{const ne=await this.scanLocalExtension(pe.location,_.type,M);await this.u.removeExtensionFromProfile(ne,M),await this.u.addExtensionsToProfile([[_,{...pe.metadata,...A}]],M)}else await this.u.addExtensionsToProfile([[_,A]],M);return this.scanLocalExtension(_.location,_.type,M)}async copyExtensions(_,X,M){const A=await this.scanExtensions(z.ExtensionType.User,_,M),Y=await Promise.all(A.filter(pe=>!pe.isApplicationScoped).map(async pe=>[pe,await this.scanMetadata(pe,_)]));await this.u.addExtensionsToProfile(Y,X)}async D(_,X,M){this.z.trace(`Deleting ${M} extension from disk`,_,X.fsPath);const A=this.w.extUri.joinPath(this.w.extUri.dirname(X),`${this.w.extUri.basename(X)}.${(0,s.$yj)((0,g.$7g)()).toString(16)}${j}`);await this.G(X.fsPath,A.fsPath),await this.s.del(A,{recursive:!0}),this.z.info(`Deleted ${M} extension from disk`,_,X.fsPath)}F(_){return this.g.queue(async()=>{let X;try{X=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(A){if((0,J.$wl)(A)!==J.FileOperationResult.FILE_NOT_FOUND)throw A}let M={};if(X)try{M=JSON.parse(X)}catch{}return _&&(_(M),Object.keys(M).length?await this.s.writeFile(this.c,E.$Se.fromString(JSON.stringify(M))):await this.s.del(this.c)),M})}async G(_,X){try{await d.Promises.rename(_,X,2*60*1e3)}catch(M){throw(0,u.$Qq)(M,r.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(_,X,M){try{if(M){const Y=(await this.t.scanUserExtensions({profileLocation:M})).find(pe=>this.w.extUri.isEqual(pe.location,_));if(Y)return await this.H(Y)}else{const A=await this.t.scanExistingExtension(_,X,{includeInvalid:!0});if(A)return await this.H(A)}throw new r.$vp(o.localize(1829,null,_.path),r.ExtensionManagementErrorCode.ScanningExtension)}catch(A){throw(0,u.$Qq)(A,r.ExtensionManagementErrorCode.ScanningExtension)}}async H(_){const X=await this.s.resolve(_.location);let M,A;return X.children&&(M=X.children.find(({name:Y})=>/^readme(\.txt|\.md|)$/i.test(Y))?.resource,A=X.children.find(({name:Y})=>/^changelog(\.txt|\.md|)$/i.test(Y))?.resource),{identifier:_.identifier,type:_.type,isBuiltin:_.isBuiltin||!!_.metadata?.isBuiltin,location:_.location,manifest:_.manifest,targetPlatform:_.targetPlatform,validations:_.validations,isValid:_.isValid,readmeUrl:M,changelogUrl:A,publisherDisplayName:_.metadata?.publisherDisplayName,publisherId:_.metadata?.publisherId||null,isApplicationScoped:!!_.metadata?.isApplicationScoped,isMachineScoped:!!_.metadata?.isMachineScoped,isPreReleaseVersion:!!_.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!_.metadata?.hasPreReleaseVersion,preRelease:!!_.metadata?.preRelease,installedTimestamp:_.metadata?.installedTimestamp,updated:!!_.metadata?.updated,pinned:!!_.metadata?.pinned,isWorkspaceScoped:!1,source:_.metadata?.source??(_.identifier.uuid?"gallery":"vsix")}}async I(){const _=await this.getUninstalledExtensions();if(Object.keys(_).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(_));const X=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=new Set;for(const Y of X)_[f.$Vp.create(Y).toString()]||M.add(Y.identifier.id.toLowerCase());try{const Y=(0,f.$1p)(X,pe=>pe.identifier);await i.Promises.settled(Y.map(async pe=>{const ne=pe.sort((ie,G)=>c.rcompare(ie.manifest.version,G.manifest.version))[0];M.has(ne.identifier.id.toLowerCase())||await this.n(await this.H(ne))}))}catch(Y){this.z.error(Y)}const A=X.filter(Y=>Y.metadata&&_[f.$Vp.create(Y).toString()]);await Promise.allSettled(A.map(Y=>this.removeUninstalledExtension(Y)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let _;try{_=await this.s.resolve(this.t.userExtensionsLocation)}catch(X){(0,J.$wl)(X)!==J.FileOperationResult.FILE_NOT_FOUND&&this.z.error(X);return}if(_?.children)try{await Promise.allSettled(_.children.map(async X=>{if(!(!X.isDirectory||!X.name.endsWith(j))){this.z.trace("Deleting the temporarily deleted folder",X.resource.toString());try{await this.s.del(X.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",X.resource.toString())}catch(M){(0,J.$wl)(M)!==J.FileOperationResult.FILE_NOT_FOUND&&this.z.error(M)}}}))}catch{}}};e.$$q=te,e.$$q=te=Ve([je(1,J.$fl),je(2,k.$Xq),je(3,h.$Tq),je(4,V.$Pl),je(5,se.$em),je(6,ve.$fk)],te);let le=class extends u.$Rq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(_,X,M,A,Y,pe,ne,ie,G,Z,ce,we){super(),this.l=_,this.manifest=X,this.source=M,this.options=A,this.m=Y,this.n=pe,this.o=ne,this.p=ie,this.q=G,this.s=Z,this.t=ce,this.u=we,this.j=r.InstallOperation.Install,this.identifier=this.l.identifier}async h(_){const M=(await this.n.scanExtensions(z.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(ne=>(0,f.$Up)(ne.identifier,this.identifier));M&&(this.j=r.InstallOperation.Update);const A={isApplicationScoped:this.options.isApplicationScoped||M?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,isSystem:M?.type===z.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??M?.pinned,source:this.source instanceof b.URI?"vsix":"gallery"};let Y;if(this.source instanceof b.URI){if(M&&this.l.equals(new f.$Vp(M.identifier,M.manifest.version)))try{await this.n.removeExtension(M,"existing")}catch{throw new Error(o.localize(1830,null,this.manifest.displayName||this.manifest.name))}const ne=await this.w(this.l);if(ne)try{await this.n.removeExtension(ne,"existing")}catch{throw new Error(o.localize(1831,null,this.manifest.displayName||this.manifest.name))}}else{if(A.id=this.source.identifier.uuid,A.publisherId=this.source.publisherId,A.publisherDisplayName=this.source.publisherDisplayName,A.targetPlatform=this.source.properties.targetPlatform,A.updated=!!M,A.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,A.hasPreReleaseVersion=M?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,A.preRelease=(0,m.$pg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||M?.preRelease,M&&M.type!==z.ExtensionType.System&&M.manifest.version===this.source.version)return this.n.updateMetadata(M,A,this.options.profileLocation);Y=await this.w(this.l)}if(_.isCancellationRequested)throw(0,u.$Qq)(new T.$9);if(!Y){const ne=await this.m(this.operation,_);Y=ne.local,this.k=ne.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(ne){throw(0,u.$Qq)(ne,r.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(_.isCancellationRequested)throw(0,u.$Qq)(new T.$9);try{await this.t.addExtensionsToProfile([[Y,A]],this.options.profileLocation,!Y.isValid)}catch(ne){throw(0,u.$Qq)(ne,r.ExtensionManagementErrorCode.AddToProfile)}const pe=await this.n.scanLocalExtension(Y.location,z.ExtensionType.User,this.options.profileLocation);if(!pe)throw new r.$vp("Cannot find the installed extension",r.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof b.URI&&this.x(Y,_),pe}async w(_){return(await this.n.getUninstalledExtensions())[_.toString()]?(this.u.trace("Removing the extension from uninstalled list:",_.id),await this.n.setInstalled(_),this.u.info("Removed the extension from uninstalled list:",_.id),(await this.n.scanAllUserExtensions(!0)).find(A=>f.$Vp.create(A).equals(_))):void 0}async x(_,X){try{let[M]=await this.p.getExtensions([{id:_.identifier.id,version:_.manifest.version}],X);if(M||([M]=await this.p.getExtensions([{id:_.identifier.id}],X)),M){const A={id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,hasPreReleaseVersion:_.hasPreReleaseVersion||M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(_,A,this.options.profileLocation)}}catch{}}};le=Ve([je(6,V.$Pl),je(7,r.$tp),je(8,B.$Rl),je(9,k.$Xq),je(10,h.$Tq),je(11,ve.$fk)],le);class ye extends u.$Rq{constructor(_,X,M){super(),this.extension=_,this.options=X,this.j=M}async h(_){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(Oe[143],Le([1,0,11,33,35,24,54,15,27,4]),function(ue,e,t,i,E,I,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cS=void 0;let S=class extends D.$Uq{constructor(p,$,a,c,m,b){super(s.URI.file(p.extensionsPath),$,a,c,m,b)}};e.$cS=S,e.$cS=S=Ve([je(0,v.$Si),je(1,T.$fl),je(2,i.$Rl),je(3,E.$Pl),je(4,I.$em),je(5,t.$fk)],S)}),define(Oe[100],Le([1,0,13,6,2,44,10,195,5,33]),function(ue,e,t,i,E,I,D,T,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$sq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$qq=e.$pq=e.$oq=void 0,e.$rq=$,e.$tq=c,e.$vq=b,e.$oq="__$__isNewStorageMarker",e.$pq="__$__targetStorageMarker",e.$qq=(0,v.$Ki)("storageService");var S;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var y;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var p;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function $(g){const d=g.get(e.$pq);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}class a extends E.$Zc{static{this.a=60*1e3}constructor(d={flushInterval:a.a}){super(),this.m=d,this.b=this.B(new i.$te),this.c=this.B(new i.$te),this.onDidChangeTarget=this.c.event,this.f=this.B(new i.$qe),this.onWillSaveState=this.f.event,this.h=this.B(new t.$Wh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new E.$1c),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,w,o){return i.Event.filter(this.b.event,l=>l.scope===d&&(w===void 0||l.key===w),o)}n(){this.j.value=(0,t.$1h)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,E.$Uc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,w){const{key:o,external:l}=w;if(o===e.$pq){switch(d){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:o,target:this.J(d)[o],external:l})}w(d){this.f.fire({reason:d})}get(d,w,o){return this.P(w)?.get(d,o)}getBoolean(d,w,o){return this.P(w)?.getBoolean(d,o)}getNumber(d,w,o){return this.P(w)?.getNumber(d,o)}getObject(d,w,o){return this.P(w)?.getObject(d,o)}storeAll(d,w){this.y(()=>{for(const o of d)this.store(o.key,o.value,o.scope,o.target,w)})}store(d,w,o,l,n=!1){if((0,D.$sg)(w)){this.remove(d,o,n);return}this.y(()=>{this.z(d,o,l),this.P(o)?.set(d,w,n)})}remove(d,w,o=!1){this.y(()=>{this.z(d,w,void 0),this.P(w)?.delete(d,o)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,w){const o=[],l=this.J(d);for(const n of Object.keys(l))l[n]===w&&o.push(n);return o}z(d,w,o,l=!1){const n=this.J(w);typeof o=="number"?n[d]!==o&&(n[d]=o,this.P(w)?.set(e.$pq,JSON.stringify(n),l)):typeof n[d]=="number"&&(delete n[d],this.P(w)?.set(e.$pq,JSON.stringify(n),l))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(d){switch(d){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(d){const w=this.P(d);return w?$(w):Object.create(null)}isNew(d){return this.getBoolean(e.$oq,d)===!0}async flush(d=S.NONE){this.f.fire({reason:d});const w=this.P(y.APPLICATION),o=this.P(y.PROFILE),l=this.P(y.WORKSPACE);switch(d){case S.NONE:await t.Promises.settled([w?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await t.Promises.settled([w?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(y.APPLICATION)?.items??new Map,w=this.P(y.PROFILE)?.items??new Map,o=this.P(y.WORKSPACE)?.items??new Map;return b(d,w,o,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,w){return this.w(S.NONE),(0,s.$Ql)(d)?this.R(d,w):this.S(d,w)}M(d,w){return!(d.id===w.id||c(w)&&c(d))}N(d,w,o){this.y(()=>{const l=new Set;for(const[n,u]of d)l.add(n),w.get(n)!==u&&this.u(o,{key:n,external:!0});for(const[n]of w.items)l.has(n)||this.u(o,{key:n,external:!0})})}}e.$sq=a;function c(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class m extends a{constructor(){super(),this.U=this.B(new T.$mq(new T.$nq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$mq(new T.$nq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$mq(new T.$nq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(y.WORKSPACE,d))),this.B(this.W.onDidChangeStorage(d=>this.u(y.PROFILE,d))),this.B(this.U.onDidChangeStorage(d=>this.u(y.APPLICATION,d)))}P(d){switch(d){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(d){switch(d){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$uq=m;async function b(g,d,w,o,l,n){const u=R=>{try{return JSON.parse(R)}catch{return R}},r=new Map,f=new Map;g.forEach((R,z)=>{r.set(z,R),f.set(z,u(R))});const h=new Map,k=new Map;d.forEach((R,z)=>{h.set(z,R),k.set(z,u(R))});const P=new Map,O=new Map;w.forEach((R,z)=>{P.set(z,R),O.set(z,u(R))}),console.group(o!==l?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const C=[];if(r.forEach((R,z)=>{C.push({key:z,value:R})}),console.table(C),console.groupEnd(),console.log(f),o!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const R=[];h.forEach((z,Q)=>{R.push({key:Q,value:z})}),console.table(R),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${n})`);const L=[];P.forEach((R,z)=>{L.push({key:z,value:R})}),console.table(L),console.groupEnd(),console.log(O)}}),define(Oe[249],Le([1,0,14,23,100]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=I;async function I(D,T,v){let s=v&&v.get("storage.serviceMachineId",E.StorageScope.APPLICATION)||null;if(s)return s;try{const y=(await T.readFile(D.serviceMachineIdResource)).value.toString();s=(0,i.$6g)(y)?y:null}catch{s=null}if(!s){s=(0,i.$7g)();try{await T.writeFile(D.serviceMachineIdResource,t.$Se.fromString(s))}catch{}}return v?.store("storage.serviceMachineId",s,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE),s}}),define(Oe[250],Le([1,0,249,24,40]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=I;async function I(D,T,v,s,S,y,p){const $={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${T.nameShort})`};if((0,E.$Mp)(T,v)&&(0,E.$Op)(s)===i.TelemetryLevel.USAGE){const a=await(0,t.$wq)(v,S,y);$["X-Market-User-Id"]=a,$["VSCode-SessionId"]=p.machineId||a}return $}}),define(Oe[144],Le([1,0,17,18,9,3,32,10,4,182,28,27,30,38,22,75,15,11,29,47,250,100,24,43]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d,w,o,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0,e.$yq=X;const u=I.$r?a.TargetPlatform.WEB:(0,p.$pp)(I.$x,D.$jc),r="X-Market-Search-Activity-Id";var f;(function(ie){ie[ie.None=0]="None",ie[ie.IncludeVersions=1]="IncludeVersions",ie[ie.IncludeFiles=2]="IncludeFiles",ie[ie.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",ie[ie.IncludeSharedAccounts=8]="IncludeSharedAccounts",ie[ie.IncludeVersionProperties=16]="IncludeVersionProperties",ie[ie.ExcludeNonValidated=32]="ExcludeNonValidated",ie[ie.IncludeInstallationTargets=64]="IncludeInstallationTargets",ie[ie.IncludeAssetUri=128]="IncludeAssetUri",ie[ie.IncludeStatistics=256]="IncludeStatistics",ie[ie.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",ie[ie.Unpublished=4096]="Unpublished",ie[ie.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(f||(f={}));function h(...ie){return String(ie.reduce((G,Z)=>G|Z,0))}var k;(function(ie){ie[ie.Tag=1]="Tag",ie[ie.ExtensionId=4]="ExtensionId",ie[ie.Category=5]="Category",ie[ie.ExtensionName=7]="ExtensionName",ie[ie.Target=8]="Target",ie[ie.Featured=9]="Featured",ie[ie.SearchText=10]="SearchText",ie[ie.ExcludeWithFlags=12]="ExcludeWithFlags"})(k||(k={}));const P={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},O={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},L={pageNumber:1,pageSize:10,sortBy:p.SortBy.NoneOrRelevance,sortOrder:p.SortOrder.Default,flags:f.None,criteria:[],assetTypes:[]};class R{constructor(G=L){this.d=G}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(G,Z=this.d.pageSize){return new R({...this.d,pageNumber:G,pageSize:Z})}withFilter(G,...Z){const ce=[...this.d.criteria,...Z.length?Z.map(we=>({filterType:G,value:we})):[{filterType:G}]];return new R({...this.d,criteria:ce})}withSortBy(G){return new R({...this.d,sortBy:G})}withSortOrder(G){return new R({...this.d,sortOrder:G})}withFlags(...G){return new R({...this.d,flags:G.reduce((Z,ce)=>Z|ce,0)})}withAssetTypes(...G){return new R({...this.d,assetTypes:G})}withSource(G){return new R({...this.d,source:G})}get raw(){const{criteria:G,pageNumber:Z,pageSize:ce,sortBy:we,sortOrder:Ie,flags:Me,assetTypes:Be}=this.d;return{filters:[{criteria:G,pageNumber:Z,pageSize:ce,sortBy:we,sortOrder:Ie}],assetTypes:Be,flags:Me}}get searchText(){const G=this.d.criteria.filter(Z=>Z.filterType===k.SearchText)[0];return G&&G.value?G.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(G=>String(G.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function z(ie,G){const Z=(ie||[]).filter(ce=>ce.statisticName===G)[0];return Z?Z.value:0}function Q(ie){const G="Microsoft.VisualStudio.Code.Translation.";return ie.files.filter(ce=>ce.assetType.indexOf(G)===0).reduce((ce,we)=>{const Ie=ve(ie,we.assetType);return Ie&&ce.push([we.assetType.substring(G.length),Ie]),ce},[])}function J(ie){if(ie.properties){const G=ie.properties.filter(we=>we.key===P.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ce=G.filter(we=>Z.test(we.value))[0];return ce?{uri:ce.value,fallbackUri:ce.value}:null}return ve(ie,P.Repository)}function x(ie){return{uri:`${ie.fallbackAssetUri}/${P.VSIX}?redirect=true${ie.targetPlatform?`&targetPlatform=${ie.targetPlatform}`:""}`,fallbackUri:`${ie.fallbackAssetUri}/${P.VSIX}${ie.targetPlatform?`?targetPlatform=${ie.targetPlatform}`:""}`}}function ve(ie,G){return ie.files.filter(ce=>ce.assetType===G)[0]?{uri:`${ie.assetUri}/${G}${ie.targetPlatform?`?targetPlatform=${ie.targetPlatform}`:""}`,fallbackUri:`${ie.fallbackAssetUri}/${G}${ie.targetPlatform?`?targetPlatform=${ie.targetPlatform}`:""}`}:null}function be(ie,G){const Z=ie.properties?ie.properties.filter(we=>we.key===G):[],ce=Z.length>0&&Z[0].value;return ce?ce.split(",").map(we=>(0,$.$Yp)(we)):[]}function se(ie){const G=ie.properties?ie.properties.filter(Z=>Z.key===O.Engine):[];return G.length>0&&G[0].value||""}function V(ie){const G=ie.properties?ie.properties.filter(Z=>Z.key===O.PreRelease):[];return G.length>0&&G[0].value==="true"}function B(ie){const G=ie.properties?ie.properties.filter(Z=>Z.key===O.ExecutesCode):[];return G.length>0?G[0].value==="true":void 0}function j(ie){const G=ie.properties?ie.properties.filter(ce=>ce.key===O.EnabledApiProposals):[],Z=G.length>0&&G[0].value||"";return Z?Z.split(","):[]}function U(ie){const G=ie.properties?ie.properties.filter(ce=>ce.key===O.LocalizedLanguages):[],Z=G.length>0&&G[0].value||"";return Z?Z.split(","):[]}function te(ie){return ie.properties?.find(G=>G.key===O.SponsorLink)?.value}function le(ie){return ie.properties?.find(G=>G.key===O.SupportLink)?.value}function ye(ie){return ie.indexOf("preview")!==-1}function oe(ie){return ie.targetPlatform?(0,p.$op)(ie.targetPlatform):a.TargetPlatform.UNDEFINED}function _(ie){const G=(0,t.$Qb)(ie.versions.map(oe)),Z=!!ie.tags?.includes(p.$ip),ce=G.indexOf(a.TargetPlatform.WEB);return Z?ce===-1&&G.push(a.TargetPlatform.WEB):ce!==-1&&G.splice(ce,1),G}function X(ie,G){for(let Z=0;Z<ie.length;Z++){const ce=ie[Z];if(ce.version===ie[Z-1]?.version){let we=Z;if(oe(ce)===G)for(;we>0&&ie[we-1].version===ce.version;)we--;we!==Z&&(ie.splice(Z,1),ie.splice(we,0,ce))}}return ie}function M(ie,G,Z){ie.telemetryData={index:G,querySource:Z,queryActivityId:ie.queryContext?.[r]}}function A(ie,G,Z,ce){const we=ie.versions[0],Ie={manifest:ve(G,P.Manifest),readme:ve(G,P.Details),changelog:ve(G,P.Changelog),license:ve(G,P.License),repository:J(G),download:x(G),icon:ve(G,P.Icon),signature:ve(G,P.Signature),coreTranslations:Q(G)};return{type:"gallery",identifier:{id:(0,$.$Zp)(ie.publisher.publisherName,ie.extensionName),uuid:ie.extensionId},name:ie.extensionName,version:G.version,displayName:ie.displayName,publisherId:ie.publisher.publisherId,publisher:ie.publisher.publisherName,publisherDisplayName:ie.publisher.displayName,publisherDomain:ie.publisher.domain?{link:ie.publisher.domain,verified:!!ie.publisher.isDomainVerified}:void 0,publisherSponsorLink:te(we),description:ie.shortDescription??"",installCount:z(ie.statistics,"install"),rating:z(ie.statistics,"averagerating"),ratingCount:z(ie.statistics,"ratingcount"),categories:ie.categories||[],tags:ie.tags||[],releaseDate:Date.parse(ie.releaseDate),lastUpdated:Date.parse(ie.lastUpdated),allTargetPlatforms:Z,assets:Ie,properties:{dependencies:be(G,O.Dependency),extensionPack:be(G,O.ExtensionPack),engine:se(G),enabledApiProposals:j(G),localizedLanguages:U(G),targetPlatform:oe(G),isPreReleaseVersion:V(G),executesCode:B(G)},hasPreReleaseVersion:V(we),hasReleaseVersion:!0,preview:ye(ie.flags),isSigned:!!Ie.signature,queryContext:ce,supportLink:le(we)}}let Y=class{constructor(G,Z,ce,we,Ie,Me,Be,De){this.l=Z,this.n=ce,this.o=we,this.q=Ie,this.u=Me,this.w=Be,this.x=De;const Ne=Be.extensionsGallery,Te=Ne?.servicePPEUrl&&De.getValue("_extensionsGallery.enablePPE");this.d=Te?Ne.servicePPEUrl:Ne?.serviceUrl,this.g=Te?void 0:Ne?.searchUrl,this.h=Ne?.controlUrl,this.k=Be.extensionsEnabledWithApiProposalVersion?.map(Ce=>Ce.toLowerCase())??[],this.j=(0,w.$xq)(Be.version,Be,this.o,this.x,this.u,G,this.q)}y(G=""){return`${this.d}${G}`}isEnabled(){return!!this.d}async getExtensions(G,Z,ce){const we=i.CancellationToken.isCancellationToken(Z)?{}:Z,Ie=i.CancellationToken.isCancellationToken(Z)?Z:ce,Me=await this.z(G,we,Ie),Be=Me.map(Ne=>Ne.identifier.uuid),De=[];for(const Ne of G)Ne.uuid&&!Be.includes(Ne.uuid)&&De.push({...Ne,uuid:void 0});if(De.length){this.q.publicLog2("galleryService:additionalQueryByName",{count:De.length});const Ne=await this.z(De,we,Ie);Me.push(...Ne)}return Me}async z(G,Z,ce){const we=[],Ie=[],Me=[],Be=[];let De=!0;for(const Ce of G){Ce.uuid?Ie.push(Ce.uuid):we.push(Ce.id);const de=!!(Ce.version||Ce.preRelease);Me.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:de}),Ce.version&&Be.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),De=De&&!!Ce.hasPreRelease&&!de}if(!Ie.length&&!we.length)return[];let Ne=new R().withPage(1,G.length);Ie.length&&(Ne=Ne.withFilter(k.ExtensionId,...Ie)),we.length&&(Ne=Ne.withFilter(k.ExtensionName,...we)),(Z.queryAllVersions||De)&&(Ne=Ne.withFlags(Ne.flags,f.IncludeVersions)),Z.source&&(Ne=Ne.withSource(Z.source));const{extensions:Te}=await this.C(Ne,{targetPlatform:Z.targetPlatform??u,includePreRelease:Me,versions:Be,compatible:!!Z.compatible,productVersion:Z.productVersion??{version:this.w.version,date:this.w.date}},ce);return Z.source&&Te.forEach((Ce,de)=>M(Ce,de,Z.source)),Te}async getCompatibleExtension(G,Z,ce,we={version:this.w.version,date:this.w.date}){if((0,p.$qp)(G.allTargetPlatforms,ce))return null;if(await this.isExtensionCompatible(G,Z,ce))return G;const Ie=new R().withFlags(f.IncludeVersions).withPage(1,1).withFilter(k.ExtensionId,G.identifier.uuid),{extensions:Me}=await this.C(Ie,{targetPlatform:ce,compatible:!0,includePreRelease:Z,productVersion:we},i.CancellationToken.None);return Me[0]||null}async isExtensionCompatible(G,Z,ce,we={version:this.w.version,date:this.w.date}){if(!(0,p.$rp)(G.properties.targetPlatform,G.allTargetPlatforms,ce)||!Z&&G.properties.isPreReleaseVersion)return!1;let Ie=G.properties.engine;if(!Ie){const Me=await this.getManifest(G,i.CancellationToken.None);if(!Me)throw new Error("Manifest was not found");Ie=Me.engines.vscode}return!(!(0,c.$bq)(Ie,we.version,we.date)||!this.A(G.identifier,G.properties.enabledApiProposals))}A(G,Z){return!Z||!this.k.includes(G.id.toLowerCase())?!0:(0,c.$cq)(Z)}async B(G,Z,ce,we,Ie,Me,Be={version:this.w.version,date:this.w.date}){if(!(0,p.$rp)(oe(Z),Ie,Me)||ce!=="any"&&V(Z)!==(ce==="prerelease"))return!1;if(we)try{const De=await this.H(G,Z);if(!(0,c.$bq)(De,Be.version,Be.date))return!1}catch(De){return this.n.error(`Error while getting the engine for the version ${Z.version}.`,(0,E.$bb)(De)),!1}return!0}async query(G,Z){let ce=G.text||"";const we=G.pageSize??50;let Ie=new R().withPage(1,we);ce?(ce=ce.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Te,Ce,de)=>(Ie=Ie.withFilter(k.Category,de||Ce),"")),ce=ce.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Te,Ce,de)=>(Ie=Ie.withFilter(k.Tag,de||Ce),"")),ce=ce.replace(/\bfeatured(\s+|\b|$)/g,()=>(Ie=Ie.withFilter(k.Featured),"")),ce=ce.trim(),ce&&(ce=ce.length<200?ce:ce.substring(0,200),Ie=Ie.withFilter(k.SearchText,ce)),Ie=Ie.withSortBy(p.SortBy.NoneOrRelevance)):G.ids?Ie=Ie.withFilter(k.ExtensionId,...G.ids):G.names?Ie=Ie.withFilter(k.ExtensionName,...G.names):Ie=Ie.withSortBy(p.SortBy.InstallCount),typeof G.sortBy=="number"&&(Ie=Ie.withSortBy(G.sortBy)),typeof G.sortOrder=="number"&&(Ie=Ie.withSortOrder(G.sortOrder)),G.source&&(Ie=Ie.withSource(G.source));const Me=async(Te,Ce)=>{const{extensions:de,total:Se}=await this.C(Te,{targetPlatform:u,compatible:!1,includePreRelease:!!G.includePreRelease,productVersion:G.productVersion??{version:this.w.version,date:this.w.date}},Ce);return de.forEach((Re,Ue)=>M(Re,(Te.pageNumber-1)*Te.pageSize+Ue,G.source)),{extensions:de,total:Se}},{extensions:Be,total:De}=await Me(Ie,Z),Ne=async(Te,Ce)=>{if(Ce.isCancellationRequested)throw new E.$9;const{extensions:de}=await Me(Ie.withPage(Te+1),Ce);return de};return{firstPage:Be,total:De,pageSize:Ie.pageSize,getPage:Ne}}async C(G,Z,ce){const we=G.flags;G.flags&f.IncludeLatestVersionOnly&&G.flags&f.IncludeVersions&&(G=G.withFlags(G.flags&~f.IncludeVersions,f.IncludeLatestVersionOnly)),!(G.flags&f.IncludeLatestVersionOnly)&&!(G.flags&f.IncludeVersions)&&(G=G.withFlags(G.flags,f.IncludeLatestVersionOnly)),Z.versions?.length&&(G=G.withFlags(G.flags&~f.IncludeLatestVersionOnly,f.IncludeVersions)),G=G.withFlags(G.flags,f.IncludeAssetUri,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeStatistics,f.IncludeVersionProperties);const{galleryExtensions:Ie,total:Me,context:Be}=await this.E(G,ce);if(!(G.flags&f.IncludeLatestVersionOnly)){const Ce=[];for(const de of Ie){const Se=await this.D(de,Z,Be);Se&&Ce.push(Se)}return{extensions:Ce,total:Me}}const Ne=[],Te=new Map;for(let Ce=0;Ce<Ie.length;Ce++){const de=Ie[Ce],Se={id:(0,$.$Zp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Re=(0,T.$pg)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(Ge=>(0,$.$Up)(Ge,Se))?.includePreRelease;if(Z.compatible&&(0,p.$qp)(_(de),Z.targetPlatform))continue;const Ue=await this.D(de,Z,Be);!Ue||Ue.properties.isPreReleaseVersion&&(!Re||!Ue.hasReleaseVersion)||!Ue.properties.isPreReleaseVersion&&Ue.properties.targetPlatform!==Z.targetPlatform&&Ue.hasPreReleaseVersion?Te.set(de.extensionId,Ce):Ne.push([Ce,Ue])}if(Te.size){const Ce=new n.$ke,de=new R().withFlags(we&~f.IncludeLatestVersionOnly,f.IncludeVersions).withPage(1,Te.size).withFilter(k.ExtensionId,...Te.keys()),{extensions:Se}=await this.C(de,Z,ce);this.q.publicLog2("galleryService:additionalQuery",{duration:Ce.elapsed(),count:Te.size});for(const Re of Se){const Ue=Te.get(Re.identifier.uuid);Ne.push([Ue,Re])}}return{extensions:Ne.sort((Ce,de)=>Ce[0]-de[0]).map(([,Ce])=>Ce),total:Me}}async D(G,Z,ce){const we={id:(0,$.$Zp)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},Ie=Z.versions?.find(Ne=>(0,$.$Up)(Ne,we))?.version,Me=(0,T.$pg)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(Ne=>(0,$.$Up)(Ne,we))?.includePreRelease,Be=_(G),De=X(G.versions,Z.targetPlatform);if(Z.compatible&&(0,p.$qp)(Be,Z.targetPlatform))return null;for(let Ne=0;Ne<De.length;Ne++){const Te=De[Ne];if(!(Ie&&Te.version!==Ie)){if(await this.B(we.id,Te,Me?"any":"release",Z.compatible,Be,Z.targetPlatform,Z.productVersion)){if(Z.compatible&&!this.A(we,j(Te)))continue;return A(G,Te,Be,ce)}if(Ie&&Te.version===Ie)return null}}return Ie||Z.compatible?null:A(G,G.versions[0],Be)}async E(G,Z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");G=G.withFlags(G.flags,f.ExcludeNonValidated).withFilter(k.Target,"Microsoft.VisualStudio.Code").withFilter(k.ExcludeWithFlags,h(f.Unpublished));const ce=await this.j,we=JSON.stringify(G.raw),Ie={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(we.length)},Me=new n.$ke;let Be,De,Ne=0;try{if(Be=await this.l.request({type:"POST",url:this.g&&G.criteria.some(Ce=>Ce.filterType===k.SearchText)?this.g:this.y("/extensionquery"),data:we,headers:Ie},Z),Be.res.statusCode&&Be.res.statusCode>=400&&Be.res.statusCode<500)return{galleryExtensions:[],total:Ne};const Te=await(0,d.$jq)(Be);if(Te){const Ce=Te.results[0],de=Ce.extensions,Se=Ce.resultMetadata&&Ce.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return Ne=Se&&Se.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:Ne,context:Be.res.headers.activityid?{[r]:Be.res.headers.activityid}:{}}}return{galleryExtensions:[],total:Ne}}catch(Te){if((0,E.$8)(Te))throw De=p.ExtensionGalleryErrorCode.Cancelled,Te;{const Ce=(0,E.$bb)(Te);throw De=(0,s.$ep)(Te)?p.ExtensionGalleryErrorCode.Offline:Ce.startsWith("XHR timeout")?p.ExtensionGalleryErrorCode.Timeout:p.ExtensionGalleryErrorCode.Failed,new p.$up(Ce,De)}}finally{this.q.publicLog2("galleryService:query",{...G.telemetryData,requestBodySize:String(we.length),duration:Me.elapsed(),success:!!Be&&(0,d.$fq)(Be),responseBodySize:Be?.res.headers["Content-Length"],statusCode:Be?String(Be.res.statusCode):void 0,errorCode:De,count:String(Ne)})}}async reportStatistic(G,Z,ce,we){if(!this.isEnabled())return;const Ie=I.$r?this.y(`/itemName/${G}.${Z}/version/${ce}/statType/${we===p.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${G}/extensions/${Z}/${ce}/stats?statType=${we}`),Me=I.$r?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",De={...await this.j,Accept:Me};try{await this.l.request({type:"POST",url:Ie,headers:De},i.CancellationToken.None)}catch{}}async download(G,Z,ce){this.n.trace("ExtensionGalleryService#download",G.identifier.id);const we=(0,$.$3p)(G),Ie=new Date().getTime(),Me=ce===p.InstallOperation.Install?"install":ce===p.InstallOperation.Update?"update":"",Be=Me?{uri:`${G.assets.download.uri}${v.URI.parse(G.assets.download.uri).query?"&":"?"}${Me}=true`,fallbackUri:`${G.assets.download.fallbackUri}${v.URI.parse(G.assets.download.fallbackUri).query?"&":"?"}${Me}=true`}:G.assets.download,De=G.queryContext?.[r]?{[r]:G.queryContext[r]}:void 0,Ne=await this.G(G.identifier.id,Be,P.VSIX,De?{headers:De}:void 0);try{await this.u.writeFile(Z,Ne.stream)}catch(Te){try{await this.u.del(Z)}catch(Ce){this.n.warn(`Error while deleting the file ${Z.toString()}`,(0,E.$bb)(Ce))}throw new p.$up((0,E.$bb)(Te),p.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...we,duration:new Date().getTime()-Ie})}async downloadSignatureArchive(G,Z){if(!G.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",G.identifier.id);const ce=await this.G(G.identifier.id,G.assets.signature,P.Signature);try{await this.u.writeFile(Z,ce.stream)}catch(we){try{await this.u.del(Z)}catch(Ie){this.n.warn(`Error while deleting the file ${Z.toString()}`,(0,E.$bb)(Ie))}throw new p.$up((0,E.$bb)(we),p.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(G,Z){if(G.assets.readme){const ce=await this.G(G.identifier.id,G.assets.readme,P.Details,{},Z);return await(0,d.$iq)(ce)||""}return""}async getManifest(G,Z){if(G.assets.manifest){const ce=await this.G(G.identifier.id,G.assets.manifest,P.Manifest,{},Z),we=await(0,d.$iq)(ce);return we?JSON.parse(we):null}return null}async F(G,Z,ce){const we=ve(Z,P.Manifest);if(!we)throw new Error("Manifest was not found");const Ie={"Accept-Encoding":"gzip"},Me=await this.G(G,we,P.Manifest,{headers:Ie});return await(0,d.$jq)(Me)}async getCoreTranslation(G,Z){const ce=G.assets.coreTranslations.filter(we=>we[0]===Z.toUpperCase())[0];if(ce){const we=await this.G(G.identifier.id,ce[1],ce[0]),Ie=await(0,d.$iq)(we);return Ie?JSON.parse(Ie):null}return null}async getChangelog(G,Z){if(G.assets.changelog){const ce=await this.G(G.identifier.id,G.assets.changelog,P.Changelog,{},Z);return await(0,d.$iq)(ce)||""}return""}async getAllCompatibleVersions(G,Z,ce){let we=new R().withFlags(f.IncludeVersions,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1);G.uuid?we=we.withFilter(k.ExtensionId,G.uuid):we=we.withFilter(k.ExtensionName,G.id);const{galleryExtensions:Ie}=await this.E(we,i.CancellationToken.None);if(!Ie.length)return[];const Me=_(Ie[0]);if((0,p.$qp)(Me,ce))return[];const Be=[];await Promise.all(Ie[0].versions.map(async Te=>{try{await this.B(G.id,Te,Z?"any":"release",!0,Me,ce)&&this.A(G,j(Te))&&Be.push(Te)}catch{}}));const De=[],Ne=new Set;for(const Te of X(Be,ce))Ne.has(Te.version)||(Ne.add(Te.version),De.push({version:Te.version,date:Te.lastUpdated,isPreReleaseVersion:V(Te)}));return De}async G(G,Z,ce,we={},Ie=i.CancellationToken.None){const Me=await this.j,Be={type:"GET"},De={...Me,...we.headers||{}};we={...we,...Be,headers:De};const Ne=Z.uri,Te=Z.fallbackUri,Ce={...we,url:Ne};try{const de=await this.l.request(Ce,Ie);if(de.res.statusCode===200)return de;const Se=await(0,d.$iq)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${Se}`)}catch(de){if((0,E.$8)(de))throw de;const Se=(0,E.$bb)(de);this.q.publicLog2("galleryService:cdnFallback",{extension:G,assetType:ce,message:Se});const Re={...we,url:Te};return this.l.request(Re,Ie)}}async H(G,Z){let ce=se(Z);if(!ce){this.q.publicLog2("galleryService:engineFallback",{extension:G,version:Z.version});const we=await this.F(G,Z,i.CancellationToken.None);if(!we)throw new Error("Manifest was not found");ce=we.engines.vscode}return ce}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const G=await this.l.request({type:"GET",url:this.h},i.CancellationToken.None);if(G.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,d.$jq)(G),ce=[],we={},Ie=[],Me=[];if(Z){for(const Be of Z.malicious)ce.push({id:Be});if(Z.migrateToPreRelease)for(const[Be,De]of Object.entries(Z.migrateToPreRelease))(!De.engine||(0,c.$bq)(De.engine,this.w.version,this.w.date))&&(we[Be.toLowerCase()]={disallowInstall:!0,extension:{id:De.id,displayName:De.displayName,autoMigrate:{storage:!!De.migrateStorage},preRelease:!0}});if(Z.deprecated)for(const[Be,De]of Object.entries(Z.deprecated))De&&(we[Be.toLowerCase()]=(0,T.$pg)(De)?{}:De);if(Z.search)for(const Be of Z.search)Ie.push(Be);if(Array.isArray(Z.extensionsEnabledWithPreRelease))for(const Be of Z.extensionsEnabledWithPreRelease)Me.push(Be.toLowerCase())}return{malicious:ce,deprecated:we,search:Ie,extensionsEnabledWithPreRelease:Me}}};Y=Ve([je(1,d.$dq),je(2,b.$fk),je(3,y.$Ri),je(4,l.$em),je(5,m.$fl),je(6,g.$yk),je(7,S.$ej)],Y);let pe=class extends Y{constructor(G,Z,ce,we,Ie,Me,Be,De){super(G,Z,ce,we,Ie,Me,Be,De)}};e.$zq=pe,e.$zq=pe=Ve([je(0,o.$qq),je(1,d.$dq),je(2,b.$fk),je(3,y.$Ri),je(4,l.$em),je(5,m.$fl),je(6,g.$yk),je(7,S.$ej)],pe);let ne=class extends Y{constructor(G,Z,ce,we,Ie,Me,Be){super(void 0,G,Z,ce,we,Ie,Me,Be)}};e.$Aq=ne,e.$Aq=ne=Ve([je(0,d.$dq),je(1,b.$fk),je(2,y.$Ri),je(3,l.$em),je(4,m.$fl),je(5,g.$yk),je(6,S.$ej)],ne)}),define(Oe[251],Le([1,0,6,2,33,60]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kS=e.$jS=void 0;class D{constructor(s,S){this.a=s,this.b=S}listen(s,S){const y=this.b(s);switch(S){case"onDidChangeProfiles":return t.Event.map(this.a.onDidChangeProfiles,p=>({all:p.all.map($=>(0,I.$Wn)({...$},y)),added:p.added.map($=>(0,I.$Wn)({...$},y)),removed:p.removed.map($=>(0,I.$Wn)({...$},y)),updated:p.updated.map($=>(0,I.$Wn)({...$},y))}))}throw new Error(`Invalid listen ${S}`)}async call(s,S,y){const p=this.b(s);switch(S){case"createProfile":{const $=await this.a.createProfile(y[0],y[1],y[2]);return(0,I.$Wn)({...$},p)}case"updateProfile":{let $=(0,E.$Sl)((0,I.$Xn)(y[0],p),this.a.profilesHome.scheme);return $=await this.a.updateProfile($,y[1]),(0,I.$Wn)({...$},p)}case"removeProfile":{const $=(0,E.$Sl)((0,I.$Xn)(y[0],p),this.a.profilesHome.scheme);return this.a.removeProfile($)}}throw new Error(`Invalid call ${S}`)}}e.$jS=D;class T extends i.$Zc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(s,S,y){super(),this.profilesHome=S,this.f=y,this.a=[],this.b=this.B(new t.$qe),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=s.map(p=>(0,E.$Sl)(p,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(p=>{const $=p.added.map(m=>(0,E.$Sl)(m,this.profilesHome.scheme)),a=p.removed.map(m=>(0,E.$Sl)(m,this.profilesHome.scheme)),c=p.updated.map(m=>(0,E.$Sl)(m,this.profilesHome.scheme));this.a=p.all.map(m=>(0,E.$Sl)(m,this.profilesHome.scheme)),this.b.fire({added:$,removed:a,updated:c,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(s){this.c=s}isEnabled(){return this.c}async createNamedProfile(s,S,y){const p=await this.f.call("createNamedProfile",[s,S,y]);return(0,E.$Sl)(p,this.profilesHome.scheme)}async createProfile(s,S,y,p){const $=await this.f.call("createProfile",[s,S,y,p]);return(0,E.$Sl)($,this.profilesHome.scheme)}async createTransientProfile(s){const S=await this.f.call("createTransientProfile",[s]);return(0,E.$Sl)(S,this.profilesHome.scheme)}async setProfileForWorkspace(s,S){await this.f.call("setProfileForWorkspace",[s,S])}removeProfile(s){return this.f.call("removeProfile",[s])}async updateProfile(s,S){const y=await this.f.call("updateProfile",[s,S]);return(0,E.$Sl)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$kS=T}),define(Oe[145],Le([1,0,4,27,15,11,228,35,33,10,229]),function(ue,e,t,i,E,I,D,T,v,s,S){"use strict";var y,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$bS=e.$aS=e.$_R=void 0;let $=class extends v.$Ul{static{y=this}static{this.a="profileAssociationsMigration"}constructor(b,g,d,w,o){super(d,w,g,o),this.U=b,this.W=d}O(){return this.U.getItem(y.b,[]).map(g=>({...g,location:(0,s.$jg)(g.location)?this.w.extUri.joinPath(this.profilesHome,g.location):t.URI.revive(g.location)}))}Q(){const b=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?b:this.N(b)}S(){return this.w.extUri.joinPath(t.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$_R=$,e.$_R=$=y=Ve([je(0,D.$7R),je(1,T.$Pl),je(2,i.$Si),je(3,E.$fl),je(4,I.$fk)],$);let a=p=class extends ${constructor(b,g,d,w,o){super(b,g,d,w,o),this.$=b}P(b){b.length?this.$.setItem(p.b,b.map(g=>({...g,location:this.w.extUri.basename(g.location)}))):this.$.removeItem(p.b)}O(){const b=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(b),this.$.setItem("userDataProfilesMigration",!0)),b}R(b){b.emptyWindows||b.workspaces?this.$.setItem(p.c,b):this.$.removeItem(p.c)}Q(){const b="workspaceAndProfileInfo",g=this.$.getItem(b,void 0);if(g){this.$.removeItem(b);const w=g.reduce((o,{workspace:l,profile:n})=>(o[t.URI.revive(l).toString()]=t.URI.revive(n).toString(),o),{});this.$.setItem(p.c,{workspaces:w})}const d=super.Q();return this.$.getItem(p.a,!1)||(this.R(d),this.$.setItem(p.a,!0)),d}};e.$aS=a,e.$aS=a=p=Ve([je(0,D.$8R),je(1,T.$Pl),je(2,i.$Si),je(3,E.$fl),je(4,I.$fk)],a);let c=class extends a{constructor(b,g,d,w){super(new S.$$R(S.SaveStrategy.IMMEDIATE,g,w,d),b,g,d,w)}async init(){return await this.$.init(),super.init()}};e.$bS=c,e.$bS=c=Ve([je(0,T.$Pl),je(1,i.$Si),je(2,E.$fl),je(3,I.$fk)],c)}),define(Oe[146],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$4m=(0,t.$Ki)("extensionHostStatusService");class i{constructor(){this.a=new Map}setExitInfo(I,D){this.a.set(I,D)}getExitInfo(I){return this.a.get(I)||null}}e.$5m=i}),define(Oe[252],Le([1,0,61,6,13]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=void 0;function I(T){let v=0,s=0,S=0;T>=1e3&&(S=Math.floor(T/1e3),T-=S*1e3),S>=60&&(s=Math.floor(S/60),S-=s*60),s>=60&&(v=Math.floor(s/60),s-=v*60);const y=v?`${v}h`:"",p=s?`${s}m`:"",$=S?`${S}s`:"",a=T?`${T}ms`:"";return`${y}${p}${$}${a}`}class D{constructor(v,s,S,y){this.i=v,this.j=s,this.a=new i.$qe,this.onClose=this.a.event,this.b=t.ProtocolConstants.ReconnectionGraceTime,this.c=t.ProtocolConstants.ReconnectionShortGraceTime,this.d=S,this.protocol=y,this.e=!1,this.f=new E.$Xh(()=>{this.k(`The reconnection grace time of ${I(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new E.$Xh(()=>{this.k(`The reconnection short grace time of ${I(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${I(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(v){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${v}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${I(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const v=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),v.end(),this.a.fire(void 0)}acceptReconnection(v,s,S){this.d=v,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(s,S),this.protocol.endAcceptReconnection()}}e.$Nn=D});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[101],Le([1,0,20,59,12,8,180,26,62]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$6m=p,e.$8m=c,i=We(i),v=$t(v);const s=(0,I.$oc)(E.$5g.asFileUri("").fsPath),S=(0,I.$oc)(s,"nls.messages.json"),y=new Map;async function p(m,b){if(!v.default.commit||!await T.Promises.exists(S))return{userLocale:"en",osLocale:"en",resolvedLanguage:"en",defaultMessagesFile:S,locale:"en",availableLanguages:{}};const g=`${m}||${b}`;let d=y.get(g);return d||(d=(0,D.resolveNLSConfiguration)({userLocale:m,osLocale:m,commit:v.default.commit,userDataPath:b,nlsMetadataPath:s}),y.set(g,d),d.then(w=>{!m.startsWith("en")&&w.resolvedLanguage.startsWith("en")&&y.delete(g)})),d}const $=async m=>{try{const b=a(await t.promises.readFile(m,"utf8"));return JSON.parse(b).locale}catch(b){return b.code!=="ENOENT"&&console.warn(b),"en"}};e.$7m=$;const a=m=>{const b=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return m.replace(b,(g,d,w,o,l)=>{if(o)return"";if(l){const n=l.length;return n>2&&l[n-1]===`
`?l[n-2]==="\r"?`\r
`:`
`:""}else return g})};async function c(m,b){if(m.startsWith("en"))return"";const g=await p(m,b),d=g?.languagePack?.messagesFile,w=g?.resolvedLanguage;if(!d||!w)return"";const o=i.join(i.dirname(d),"nls.messages.js");try{return await t.promises.stat(o),o}catch(u){if(u.code!=="ENOENT")throw u}const n=`globalThis._VSCODE_NLS_MESSAGES=${(await t.promises.readFile(d)).toString()};
globalThis._VSCODE_NLS_LANGUAGE=${JSON.stringify(w)};`;return await t.promises.writeFile(o,n,"utf-8"),o}}),define(Oe[147],Le([1,0,19,4,27,54,64,15,5,11,29,35,33,101]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1R=void 0;let a=class extends D.$Yq{constructor(m,b,g,d,w,o,l,n){super(i.URI.file(w.builtinExtensionsPath),i.URI.file(w.extensionsPath),(0,t.$lh)(w.userHome,".vscode-oss-dev","extensions","control.json"),m.defaultProfile,m,b,g,d,w,o,l,n),this.S=w}async f(m){const b=await(0,$.$6m)(m,this.S.userDataPath);if(b.languagePack)try{const g=await this.w.readFile(i.URI.file(b.languagePack.translationsConfigFile));return JSON.parse(g.value.toString())}catch{}return Object.create(null)}};e.$1R=a,e.$1R=a=Ve([je(0,p.$Rl),je(1,I.$Tq),je(2,T.$fl),je(3,s.$fk),je(4,E.$Si),je(5,S.$yk),je(6,y.$Pl),je(7,v.$Ji)],a)}),define(Oe[102],Le([1,0,253,20,8,23,12,26]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=e.$On=e.ServerConnectionTokenType=void 0,e.$Rn=$,e.$Sn=a,e.$Tn=c,t=We(t),i=We(i),E=We(E);const v=/^[0-9A-Za-z_-]+$/;var s;(function(m){m[m.None=0]="None",m[m.Optional=1]="Optional",m[m.Mandatory=2]="Mandatory"})(s||(e.ServerConnectionTokenType=s={}));class S{constructor(){this.type=s.None}validate(b){return!0}}e.$On=S;class y{constructor(b){this.value=b,this.type=s.Mandatory}validate(b){return b===this.value}}e.$Pn=y;class p{constructor(b){this.message=b}}e.$Qn=p;async function $(m,b){const g=m["without-connection-token"],d=m["connection-token"],w=m["connection-token-file"];if(g)return typeof d<"u"||typeof w<"u"?new p("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new S;if(typeof w<"u"){if(typeof d<"u")return new p("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let o;try{o=i.readFileSync(w).toString().replace(/\r?\n$/,"")}catch{return new p(`Unable to read the connection token file at '${w}'.`)}return v.test(o)?new y(o):new p(`The connection token defined in '${w} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof d<"u"?v.test(d)?new y(d):new p(`The connection token '${d} does not adhere to the characters 0-9, a-z, A-Z or -.`):new y(await b())}async function a(m){return $(m,async()=>{if(!m["user-data-dir"])return(0,I.$7g)();const g=E.$oc(m["user-data-dir"],"token");try{const o=(await i.promises.readFile(g)).toString().replace(/\r?\n$/,"");if(v.test(o))return o}catch{}const d=(0,I.$7g)();try{await T.Promises.writeFile(g,d,{mode:384})}catch{}return d})}function c(m,b,g){if(m.validate(g.query[D.$Wg]))return!0;const d=t.parse(b.headers.cookie||"");return m.validate(d[D.$Vg])}}),define(Oe[55],Le([1,0,7,120,71,5,27,79]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=void 0,t=We(t),e.$hn={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},"disable-file-uploads":{type:"boolean"},"disable-getting-started-override":{type:"boolean"},locale:{type:"string"},host:{type:"string",cat:"o",args:"ip-address",description:t.localize(2505,null)},port:{type:"string",cat:"o",args:"port | port range",description:t.localize(2506,null)},"socket-path":{type:"string",cat:"o",args:"path",description:t.localize(2507,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:t.localize(2508,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:t.localize(2509,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:t.localize(2510,null)},"without-connection-token":{type:"boolean",cat:"o",description:t.localize(2511,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:t.localize(2512,null)},"server-data-dir":{type:"string",cat:"o",description:t.localize(2513,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:t.localize(2514,null)},"user-data-dir":E.$Hm["user-data-dir"],"enable-smoke-test-driver":E.$Hm["enable-smoke-test-driver"],"disable-telemetry":E.$Hm["disable-telemetry"],"disable-workspace-trust":E.$Hm["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:E.$Hm.log,logsPath:E.$Hm.logsPath,"force-disable-user-env":E.$Hm["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:t.localize(2515,null)},"default-workspace":{type:"string",description:t.localize(2516,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":E.$Hm["extensions-dir"],"extensions-download-dir":E.$Hm["extensions-download-dir"],"builtin-extensions-dir":E.$Hm["builtin-extensions-dir"],"install-extension":E.$Hm["install-extension"],"install-builtin-extension":E.$Hm["install-builtin-extension"],"update-extensions":E.$Hm["update-extensions"],"uninstall-extension":E.$Hm["uninstall-extension"],"list-extensions":E.$Hm["list-extensions"],"locate-extension":E.$Hm["locate-extension"],"show-versions":E.$Hm["show-versions"],category:E.$Hm.category,force:E.$Hm.force,"do-not-sync":E.$Hm["do-not-sync"],"pre-release":E.$Hm["pre-release"],"start-server":{type:"boolean",cat:"e",description:t.localize(2517,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:E.$Hm.help,version:E.$Hm.version,"locate-shell-integration-path":E.$Hm["locate-shell-integration-path"],compatibility:{type:"string"},_:E.$Hm._},e.$in=(0,I.$Li)(D.$Ri);class v extends i.$en{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$jn=v,Ve([T.$ci],v.prototype,"userRoamingDataHome",null)}),define(Oe[254],Le([1,0,295,238,255,31]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2R=void 0,i=We(i),E=We(E),I=We(I);class D extends t.AppInsightsCore{constructor(v,s,S){super(),this.b=v,this.a={measurements:{},properties:{}};try{const y=I.cpus();this.a.measurements.cores=y.length,this.a.properties["common.cpuModel"]=y[0].model}catch{}try{this.a.properties["common.shell"]=I.userInfo().shell,this.a.properties["common.release"]=I.release(),this.a.properties["common.arch"]=I.arch()}catch{}this.a.properties["common.remoteMachineId"]=s,this.a.properties["common.isContainer"]=S}track(v){const s=v.baseData||{};s.measurements={...s.measurements||{},...this.a.measurements},s.properties={...s.properties||{},...this.a.properties};try{s.measurements.memoryFree=I.freemem(),s.measurements.memoryTotal=I.totalmem()}catch{}try{const S=(/^http:/.test(this.b)?E:i).request(this.b,{method:"POST",headers:{"Content-Type":"application/json"}});S.on("error",()=>{}),S.write(JSON.stringify(s)),S.end()}catch{}}}e.$2R=D}),define(Oe[256],Le([1,0,20,59,93,253,96,36,69,3,11,55,8,12,23,29,102,47,18,4,14,10,101,34,65,125]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d,w,o,l,n,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wS=e.$vS=e.$uS=e.$tS=e.$sS=e.CacheControl=void 0,e.$qS=h,e.$rS=P,i=We(i),E=We(E),I=We(I),D=We(D);const f={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function h(J,x,ve,be){x.writeHead(ve,{"Content-Type":"text/plain"}),x.end(be)}var k;(function(J){J[J.NO_CACHING=0]="NO_CACHING",J[J.ETAG=1]="ETAG",J[J.NO_EXPIRY=2]="NO_EXPIRY"})(k||(e.CacheControl=k={}));async function P(J,x,ve,be,se,V){try{const B=await t.promises.stat(J);if(x===k.ETAG){const j=`W/"${[B.ino,B.size,B.mtime.getTime()].join("-")}"`;if(be.headers["if-none-match"]===j)return se.writeHead(304),void se.end();V.Etag=j}else x===k.NO_EXPIRY?V["Cache-Control"]="public, max-age=31536000":x===k.NO_CACHING&&(V["Cache-Control"]="no-store");V["Content-Type"]=f[(0,p.$tc)(J)]||(0,v.$kt)(J)||"text/plain",se.writeHead(200,V),(0,t.createReadStream)(J).pipe(se)}catch(B){return B.code!=="ENOENT"?(ve.error(B),console.error(B.toString())):console.error(`File not found: ${J}`),se.writeHead(404,{"Content-Type":"text/plain"}),void se.end("Not found")}}const O=(0,p.$rc)($.$5g.asFileUri("").fsPath);let C=class{constructor(x,ve,be,se,V,B,j,U){this.g=x,this.h=ve,this.serverRootPath=be,this.i=se,this.j=V,this.k=B,this.l=j,this.m=U,this.a=this.l.extensionsGallery?.resourceUrlTemplate?d.URI.parse(this.l.extensionsGallery.resourceUrlTemplate):void 0,this.c=be,this.b=`${be}/static`,this.d=`${be}/callback`,this.f="/web-extension-resource"}async handle(x,ve,be){try{const se=be.pathname;return se.startsWith(this.b)&&se.charCodeAt(this.b.length)===n.CharCode.Slash?this.n(x,ve,be):se===this.h?this.q(x,ve,be):se===this.d?this.s(ve):se.startsWith(this.f)&&se.charCodeAt(this.f.length)===n.CharCode.Slash?this.p(x,ve,be):h(x,ve,404,"Not found.")}catch(se){return this.j.error(se),console.error(se.toString()),h(x,ve,500,"Internal Server Error.")}}async n(x,ve,be){const se=Object.create(null),B=decodeURIComponent(be.pathname).substring(this.b.length+1),j=(0,p.$oc)(O,B);return(0,T.$Jg)(j,O,!s.$n)?P(j,this.i.isBuilt?k.NO_EXPIRY:k.ETAG,this.j,x,ve,se):h(x,ve,400,"Bad request.")}o(x){const ve=x.authority.indexOf(".");return ve!==-1?x.authority.substring(ve+1):void 0}async p(x,ve,be){if(!this.a)return h(x,ve,500,"No extension gallery service configured.");const se=decodeURIComponent(be.pathname),V=(0,p.$mc)(se.substring(this.f.length+1)),B=d.URI.parse(V).with({scheme:this.a.scheme,authority:V.substring(0,V.indexOf("/")),path:V.substring(V.indexOf("/")+1)});if(this.o(this.a)!==this.o(B))return h(x,ve,403,"Request Forbidden");const j={},U=X=>{const M=x.headers[X];M&&((0,o.$jg)(M)||M[0])?j[X]=(0,o.$jg)(M)?M:M[0]:X!==X.toLowerCase()&&U(X.toLowerCase())};U("X-Client-Name"),U("X-Client-Version"),U("X-Machine-Id"),U("X-Client-Commit");const te=await this.k.request({type:"GET",url:B.toString(!0),headers:j},g.CancellationToken.None),le=te.res.statusCode||500;if(le!==200){let X=null;try{X=await(0,b.$iq)(te)}catch{}return h(x,ve,le,X||`Request failed with status ${le}`)}const ye=Object.create(null),oe=X=>{const M=te.res.headers[X];M?ye[X]=M:X!==X.toLowerCase()&&oe(X.toLowerCase())};oe("Cache-Control"),oe("Content-Type"),ve.writeHead(200,ye);const _=await(0,w.$5e)(te.stream);return void ve.end(_.buffer)}async q(x,ve,be){const se=be.query[$.$Wg];if(typeof se=="string"){const Ie=Object.create(null);Ie["Set-Cookie"]=I.serialize($.$Vg,se,{sameSite:"lax",maxAge:60*60*24*7});const Me=Object.create(null);for(const De in be.query)De!==$.$Wg&&(Me[De]=be.query[De]);const Be=E.format({pathname:be.pathname,query:Me});return Ie.Location=Be,ve.writeHead(302,Ie),void ve.end()}const V=!this.i.isBuilt&&this.i.args["use-test-resolver"],B=V?"test+test":"remote";if(!B)return h(x,ve,400,"Bad request.");function j(Ie){return JSON.stringify(Ie).replace(/"/g,"&quot;")}let U;this.i.args["enable-smoke-test-driver"]&&(U=!1);const te=Ie=>Ie&&d.URI.file(i.resolve(Ie)).with({scheme:$.Schemas.vscodeRemote,authority:B}),le=$.$5g.asFileUri(`vs/code/browser/workbench/workbench${this.i.isBuilt?"":"-dev"}.${u.$V?"esm.":""}html`).fsPath,ye=!this.i.isBuilt&&this.i.args["github-auth"]?{id:(0,a.$7g)(),providerId:"github",accessToken:this.i.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,oe=(0,e.$uS)((0,e.$wS)(x)),_=(0,e.$vS)((0,e.$wS)(x)),X={codeServerVersion:this.l.codeServerVersion,rootEndpoint:oe,updateEndpoint:this.i.args["disable-update-check"]?void 0:oe+"/update/check",logoutEndpoint:this.i.args.auth&&this.i.args.auth!=="none"?oe+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??oe+"/proxy/{{port}}/",serviceWorker:{scope:_+"/",path:oe+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.l.enableTelemetry,telemetryEndpoint:this.l.telemetryEndpoint,embedderIdentifier:"server-distro",extensionsGallery:this.l.extensionsGallery};if(!this.i.isBuilt)try{const Ie=JSON.parse((await t.promises.readFile((0,p.$oc)(O,"product.overrides.json"))).toString());Object.assign(X,Ie)}catch{}const M={remoteAuthority:B,serverBasePath:this.h,webviewEndpoint:_+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.i.userDataPath,isEnabledFileDownloads:!this.i.args["disable-file-downloads"],isEnabledFileUploads:!this.i.args["disable-file-uploads"],isEnabledCoderGettingStarted:!this.i.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:U,developmentOptions:{enableSmokeTestDriver:this.i.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.j.getLevel()},settingsSyncOptions:!this.i.isBuilt&&this.i.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.i.args["disable-workspace-trust"],folderUri:te(this.i.args["default-folder"]),workspaceUri:te(this.i.args["default-workspace"]),productConfiguration:X,callbackRoute:_+this.d},A=I.parse(x.headers.cookie||""),Y=this.i.args.locale||await(0,l.$7m)(this.i.argvResource.fsPath)||A["vscode.nls.locale"]||x.headers["accept-language"]?.split(",")[0]?.toLowerCase()||"en";let pe,ne;if(!Y.startsWith("en")&&this.l.nlsCoreBaseUrl)pe=this.l.nlsCoreBaseUrl,ne=`${pe}${this.l.commit}/${this.l.version}/${Y}/nls.messages.js`;else try{const Ie=await(0,l.$8m)(Y,this.i.userDataPath);ne=Ie?`${_}${this.c}/vscode-remote-resource?path=${encodeURIComponent(Ie)}`:""}catch(Ie){console.error("Failed to generate translations",Ie),ne=""}const ie={WORKBENCH_WEB_CONFIGURATION:j(M),WORKBENCH_AUTH_SESSION:ye?j(ye):"",WORKBENCH_WEB_BASE_URL:_+this.b,WORKBENCH_NLS_URL:ne,WORKBENCH_NLS_FALLBACK_URL:`${_}${this.b}/out/nls.messages.js`,BASE:oe,VS_BASE:_};if(this.m.isEnabled){const Ie=await this.m.getCssModules();ie.WORKBENCH_DEV_CSS_MODULES=JSON.stringify(Ie)}if(V){const Ie=[];for(const Me of["vscode-test-resolver","github-authentication"]){const Be=JSON.parse((await t.promises.readFile($.$5g.asFileUri(`${$.$Zg}/${Me}/package.json`).fsPath)).toString());Ie.push({extensionPath:Me,packageJSON:Be})}ie.WORKBENCH_BUILTIN_EXTENSIONS=j(Ie)}let G;try{G=(await t.promises.readFile(le)).toString().replace(/\{\{([^}]+)\}\}/g,(Me,Be)=>ie[Be]??"undefined")}catch{return ve.writeHead(404,{"Content-Type":"text/plain"}),void ve.end("Not found")}const Z=u.$V?"sha256-2Q+j4hfT09+1+imS46J2YlkCtHWQt0/BE79PXjJ0ZJ8=":"sha256-TMJESLUenkUgTCHw3qQlCngteoHhhRnn81kYP41UnCE=",we={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",u.$V?`script-src 'self' 'unsafe-eval' ${pe??""} blob: 'nonce-1nline-m4p' ${this.r(G).join(" ")} '${Z}' 'sha256-/r7rqQ+yrxt57sxLuQ6AMYcy/lUpvAIzHjIJt/OeLWU=' ;`:`script-src 'self' 'unsafe-eval' ${pe??""} ${this.r(G).join(" ")} '${Z}' ;`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.g.type!==m.ServerConnectionTokenType.None&&(we["Set-Cookie"]=I.serialize($.$Vg,this.g.value,{sameSite:"lax",maxAge:60*60*24*7})),ve.writeHead(200,we),void ve.end(G)}r(x){const ve=/<script>([\s\S]+?)<\/script>/img,be=[];let se;for(;se=ve.exec(x);){const V=D.createHash("sha256"),B=se[1].replace(/\r\n/g,`
`),j=V.update(Buffer.from(B)).digest().toString("base64");be.push(`'sha256-${j}'`)}return be}async s(x){const ve=$.$5g.asFileUri("vs/code/browser/workbench/callback.html").fsPath,be=(await t.promises.readFile(ve)).toString(),se=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.r(be).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return x.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":se}),void x.end(be)}};e.$sS=C,e.$sS=C=Ve([je(3,y.$in),je(4,S.$fk),je(5,b.$dq),je(6,c.$yk),je(7,r.$mS)],C);const L=(J,x=!1)=>J.replace(/\/\/+/g,"/").replace(/\/+$/,x?"/":"");e.$tS=L;const R=J=>{const x=(J.split("?",1)[0].match(/\//g)||[]).length;return(0,e.$tS)("./"+(x>1?"../".repeat(x-1):""))};e.$uS=R;const z=J=>{const x=J.split("?",1)[0].split("/");return(0,e.$tS)("./"+x[x.length-1])};e.$vS=z;const Q=J=>J.originalUrl||J.url;e.$wS=Q}),define(Oe[257],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0,e.$5Q=(0,t.$Ki)("IExtHostInitDataService")}),define(Oe[258],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.$OQ=void 0,e.$OQ=(0,t.$Ki)("IExtHostRpcService");class i{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$PQ=i}),define(Oe[76],Le([1,0,60]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=E;function i(I){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:I,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function E(I){return new t.$Un(i(I))}}),define(Oe[259],Le([1,0,3,44,4,76,60,117,231,8,102,19]),function(ue,e,t,i,E,I,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=void 0,t=We(t),i=We(i);class p{static{this.a=1}constructor(a,c,m,b){this.b=a,this.c=c,this.d=m,this.e=b}async call(a,c,m){switch(c){case"getEnvironmentData":{const b=m,g=(0,I.$6s)(b.remoteAuthority);let d=await this.f(b.profile);return d=(0,D.$Wn)(d,g),d}case"getExtensionHostExitInfo":{const b=m;return this.e.getExitInfo(b.reconnectionToken)}case"getDiagnosticInfo":{const b=m,g={machineInfo:(0,v.$0s)()},d=b.includeProcesses?(0,T.$8s)(process.pid):Promise.resolve();let w=[];const o={};if(b.folders){const l=(0,I.$6s)("");w=b.folders.map(u=>E.URI.revive(l.transformIncoming(u))).filter(u=>u.scheme==="file").map(u=>(0,v.$9s)(u.fsPath,["node_modules",".git"]).then(r=>{o[(0,s.$sc)(u.fsPath)]=r}))}return Promise.all([d,...w]).then(([l,n])=>(g.processes=l||void 0,g.workspaceMetadata=b.folders?o:void 0,g))}}throw new Error(`IPC Command ${c} not found`)}listen(a,c,m){throw new Error("Not supported")}async f(a){a&&!this.d.profiles.some(m=>m.id===a)&&await this.d.createProfile(a,a);let c=!1;if(process.platform==="linux"){const m=process.glibcVersion;c=(m?parseInt(m.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==S.ServerConnectionTokenType.None?this.b.value:"",appRoot:E.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,y.$lh)(this.c.logsHome,`exthost${p.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:t.OS,arch:process.arch,marks:i.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(m=>({...m}))},isUnsupportedGlibc:c}}}e.$at=p}),define(Oe[260],Le([1,0,4,76,73,8,216]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0;class T extends D.$bt{constructor(S,y){super(new E.$Dr(S),S),this.N=y,this.M=new Map,this.B(this.a)}c(S){let y=this.M.get(S.remoteAuthority);return y||(y=(0,i.$6s)(S.remoteAuthority),this.M.set(S.remoteAuthority,y)),y}f(S,y,p=!1){if(p&&y.path==="/vscode-resource"&&y.query){const $=JSON.parse(y.query).requestResourcePath;return t.URI.from({scheme:"file",path:$})}return t.URI.revive(S.transformIncoming(y))}L(S,y){return new v(S,y,this.b,this.N)}}e.$dt=T;class v extends D.$ct{constructor(S,y,p,$){super(S,y,p,$)}j(S){const y=S.args["file-watcher-polling"];if(y){const p=y.split(I.$yc),$=Number(p[0]);if($>0)return{usePolling:p.length>1?p.slice(1):!0,pollingInterval:$}}}m(S){if(S.extensionsPath)return[I.$lc.join(S.extensionsPath,"**")]}}});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[103],Le([1,0,7,10,4,2,5,37,15,12,45,188,58]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$JG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$zG=e.EditorInputCapabilities=e.$yG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=void 0,e.$pG=c,e.$qG=m,e.$rG=b,e.$sG=g,e.$tG=d,e.$uG=w,e.$vG=o,e.$wG=l,e.$xG=n,e.$AG=P,e.$BG=C,e.$CG=L,e.$DG=R,e.$EG=z,e.$FG=Q,e.$GG=J,e.$HG=x,e.$IG=j,e.$KG=le,e.$LG=oe,e.$MG=_,e.$NG=X,p=$t(p),e.$kG={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$lG={id:"default",displayName:(0,t.localize)(4060,null),providerDisplayName:(0,t.localize)(4061,null)},e.$mG="workbench.editor.sidebysideEditor",e.$nG="workbench.editors.textDiffEditor",e.$oG="workbench.editors.binaryResourceDiffEditor";var $;(function(M){M[M.PROGRAMMATIC=1]="PROGRAMMATIC",M[M.USER=2]="USER",M[M.EDIT=3]="EDIT",M[M.NAVIGATION=4]="NAVIGATION",M[M.JUMP=5]="JUMP"})($||(e.EditorPaneSelectionChangeReason=$={}));var a;(function(M){M[M.IDENTICAL=1]="IDENTICAL",M[M.SIMILAR=2]="SIMILAR",M[M.DIFFERENT=3]="DIFFERENT"})(a||(e.EditorPaneSelectionCompareResult=a={}));function c(M){const A=M;return!!A&&typeof A.getSelection=="function"&&!!A.onDidChangeSelection}function m(M){const A=M;return!!A&&typeof A.getScrollPosition=="function"&&typeof A.setScrollPosition=="function"&&!!A.onDidChangeScroll}function b(M,A,Y){for(const pe of Y.visibleEditorPanes)if(pe.group.id===A&&M.matches(pe.input))return pe.getViewState()}function g(M){if(P(M))return!1;const A=M;return E.URI.isUri(A?.resource)}function d(M){if(P(M))return!1;const A=M;return A?.original!==void 0&&A.modified!==void 0}function w(M){if(P(M))return!1;const A=M;return!A||A.resources&&!Array.isArray(A.resources)?!1:!!A.resources||!!A.multiDiffSource}function o(M){if(P(M)||d(M))return!1;const A=M;return A?.primary!==void 0&&A.secondary!==void 0}function l(M){if(P(M))return!1;const A=M;return A?A.resource===void 0||A.resource.scheme===s.Schemas.untitled||A.forceUntitled===!0:!1}function n(M){if(P(M))return!1;const A=M;return E.URI.isUri(A?.base?.resource)&&E.URI.isUri(A?.input1?.resource)&&E.URI.isUri(A?.input2?.resource)&&E.URI.isUri(A?.result?.resource)}var u;(function(M){M[M.SHORT=0]="SHORT",M[M.MEDIUM=1]="MEDIUM",M[M.LONG=2]="LONG"})(u||(e.Verbosity=u={}));var r;(function(M){M[M.EXPLICIT=1]="EXPLICIT",M[M.AUTO=2]="AUTO",M[M.FOCUS_CHANGE=3]="FOCUS_CHANGE",M[M.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class f{constructor(){this.a=new Map}registerSource(A,Y){let pe=this.a.get(A);return pe||(pe={source:A,label:Y},this.a.set(A,pe)),pe.source}getSourceLabel(A){return this.a.get(A)?.label??A}}e.$yG=new f;var h;(function(M){M[M.None=0]="None",M[M.Readonly=2]="Readonly",M[M.Untitled=4]="Untitled",M[M.Singleton=8]="Singleton",M[M.RequiresTrust=16]="RequiresTrust",M[M.CanSplitInGroup=32]="CanSplitInGroup",M[M.ForceDescription=64]="ForceDescription",M[M.CanDropIntoEditor=128]="CanDropIntoEditor",M[M.MultipleEditors=256]="MultipleEditors",M[M.Scratchpad=512]="Scratchpad"})(h||(e.EditorInputCapabilities=h={}));class k extends I.$Zc{}e.$zG=k;function P(M){return M instanceof k}function O(M){const A=M;return E.URI.isUri(A?.preferredResource)}function C(M){const A=M;return P(A?.primary)&&P(A?.secondary)}function L(M){const A=M;return P(A?.modified)&&P(A?.original)}function R(M,A,Y,pe,ne){return X(pe,[(0,y.$uj)({id:"workbench.action.openLargeFile",label:(0,t.localize)(4062,null),run:()=>{const ie={...Y,limits:{size:Number.MAX_VALUE}};M.openEditor(A,ie)}}),(0,y.$uj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,t.localize)(4063,null),run:()=>ne.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}function z(M){return P(M?.editor)}function Q(M){const A=M;return z(M)&&A?.group!==void 0}function J(M){const A=M;return typeof A?.groupId=="number"&&P(A.editor)}function x(M){return typeof M?.groupId=="number"}var ve;(function(M){M[M.UNKNOWN=0]="UNKNOWN",M[M.REPLACE=1]="REPLACE",M[M.MOVE=2]="MOVE",M[M.UNPIN=3]="UNPIN"})(ve||(e.EditorCloseContext=ve={}));var be;(function(M){M[M.GROUP_ACTIVE=0]="GROUP_ACTIVE",M[M.GROUP_INDEX=1]="GROUP_INDEX",M[M.GROUP_LABEL=2]="GROUP_LABEL",M[M.GROUP_LOCKED=3]="GROUP_LOCKED",M[M.EDITORS_SELECTION=4]="EDITORS_SELECTION",M[M.EDITOR_OPEN=5]="EDITOR_OPEN",M[M.EDITOR_CLOSE=6]="EDITOR_CLOSE",M[M.EDITOR_MOVE=7]="EDITOR_MOVE",M[M.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",M[M.EDITOR_LABEL=9]="EDITOR_LABEL",M[M.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",M[M.EDITOR_PIN=11]="EDITOR_PIN",M[M.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",M[M.EDITOR_STICKY=13]="EDITOR_STICKY",M[M.EDITOR_DIRTY=14]="EDITOR_DIRTY",M[M.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(be||(e.GroupModelChangeKind=be={}));var se;(function(M){M[M.PRIMARY=1]="PRIMARY",M[M.SECONDARY=2]="SECONDARY",M[M.BOTH=3]="BOTH",M[M.ANY=4]="ANY"})(se||(e.SideBySideEditor=se={}));class V{getOriginalUri(A,Y){if(!A)return;if(n(A))return e.$JG.getOriginalUri(A.result,Y);if(Y?.supportSideBySide){const{primary:ne,secondary:ie}=this.a(A);if(ne&&ie){if(Y?.supportSideBySide===se.BOTH)return{primary:this.getOriginalUri(ne,{filterByScheme:Y.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:Y.filterByScheme})};if(Y?.supportSideBySide===se.ANY)return this.getOriginalUri(ne,{filterByScheme:Y.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:Y.filterByScheme});A=Y.supportSideBySide===se.PRIMARY?ne:ie}}if(d(A)||w(A)||o(A)||n(A))return;const pe=O(A)?A.preferredResource:A.resource;return!pe||!Y||!Y.filterByScheme?pe:this.b(pe,Y.filterByScheme)}a(A){return C(A)||o(A)?{primary:A.primary,secondary:A.secondary}:L(A)||d(A)?{primary:A.modified,secondary:A.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(A,Y){if(!A)return;if(n(A))return e.$JG.getCanonicalUri(A.result,Y);if(Y?.supportSideBySide){const{primary:ne,secondary:ie}=this.a(A);if(ne&&ie){if(Y?.supportSideBySide===se.BOTH)return{primary:this.getCanonicalUri(ne,{filterByScheme:Y.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:Y.filterByScheme})};if(Y?.supportSideBySide===se.ANY)return this.getCanonicalUri(ne,{filterByScheme:Y.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:Y.filterByScheme});A=Y.supportSideBySide===se.PRIMARY?ne:ie}}if(d(A)||w(A)||o(A)||n(A))return;const pe=A.resource;return!pe||!Y||!Y.filterByScheme?pe:this.b(pe,Y.filterByScheme)}b(A,Y){if(Array.isArray(Y)){if(Y.some(pe=>A.scheme===pe))return A}else if(Y===A.scheme)return A}}var B;(function(M){M[M.UNKNOWN=0]="UNKNOWN",M[M.KEYBOARD=1]="KEYBOARD",M[M.MOUSE=2]="MOUSE"})(B||(e.EditorCloseMethod=B={}));function j(M,A,Y,pe){if(!M.isSticky(A))return!1;switch(pe.preventPinnedEditorClose){case"keyboardAndMouse":return Y===B.MOUSE||Y===B.KEYBOARD;case"mouse":return Y===B.MOUSE;case"keyboard":return Y===B.KEYBOARD}return!1}e.$JG=new V;var U;(function(M){M[M.LEFT=0]="LEFT",M[M.RIGHT=1]="RIGHT"})(U||(e.CloseDirection=U={}));class te{constructor(){this.c=new Map,this.d=new Map}start(A){const Y=this.a=A.get(D.$Ji);for(const[pe,ne]of this.c)this.e(pe,ne,Y);this.c.clear()}e(A,Y,pe){const ne=pe.createInstance(Y);this.d.set(A,ne)}registerFileEditorFactory(A){if(this.b)throw new Error("Can only register one file editor factory.");this.b=A}getFileEditorFactory(){return(0,i.$ug)(this.b)}registerEditorSerializer(A,Y){if(this.c.has(A)||this.d.has(A))throw new Error(`A editor serializer with type ID '${A}' was already registered.`);return this.a?this.e(A,Y,this.a):this.c.set(A,Y),(0,I.$Xc)(()=>{this.c.delete(A),this.d.delete(A)})}getEditorSerializer(A){return this.d.get(typeof A=="string"?A:A.typeId)}}T.$zo.add(e.$kG.EditorFactory,new te);async function le(M,A,Y){return!M||!M.length?[]:await Promise.all(M.map(async pe=>{const ne=E.URI.revive(pe.fileUri);if(!ne){Y.info("Cannot resolve the path because it is not valid.",pe);return}if(!await A.canHandleResource(ne)){Y.info("Cannot resolve the path because it cannot be handled",pe);return}let G=pe.exists,Z=pe.type;if(typeof G!="boolean"||typeof Z!="number")try{Z=(await A.stat(ne)).isDirectory?v.FileType.Directory:v.FileType.Unknown,G=!0}catch(we){Y.error(we),G=!1}if(!G&&pe.openOnlyIfExists){Y.info("Cannot resolve the path because it does not exist",pe);return}if(Z===v.FileType.Directory){Y.info("Cannot resolve the path because it is a directory",pe);return}const ce={...pe.options,pinned:!0};return G?{resource:ne,options:ce}:{resource:ne,options:ce,forceUntitled:!0}}))}var ye;(function(M){M[M.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",M[M.SEQUENTIAL=1]="SEQUENTIAL"})(ye||(e.EditorsOrder=ye={}));function oe(M){const A=M;if(!A)return!1;const Y=A;if(Y.modified)return oe(Y.modified);const pe=A;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}function _(M){return(0,S.$wj)(M)}function X(M,A,Y){const pe=(0,S.$xj)(M,A);return pe.forceMessage=Y?.forceMessage,pe.forceSeverity=Y?.forceSeverity,pe.allowDialog=Y?.allowDialog,pe}}),define(Oe[261],Le([1,0,7,41]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=void 0,e.$ZG=new i.$2j("chatSessionResponseVote","",{type:"string",description:(0,t.localize)(4721,null)}),e.$1G=new i.$2j("chatVoteUpEnabled",!1,{type:"boolean",description:(0,t.localize)(4722,null)}),e.$2G=new i.$2j("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,t.localize)(4723,null)}),e.$3G=new i.$2j("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,t.localize)(4724,null)}),e.$4G=new i.$2j("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,t.localize)(4725,null)}),e.$5G=new i.$2j("chatSessionResponseError",!1,{type:"boolean",description:(0,t.localize)(4726,null)}),e.$6G=new i.$2j("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,t.localize)(4727,null)}),e.$7G=new i.$2j("chatResponse",!1,{type:"boolean",description:(0,t.localize)(4728,null)}),e.$8G=new i.$2j("chatRequest",!1,{type:"boolean",description:(0,t.localize)(4729,null)}),e.$9G=new i.$2j("chatEditApplied",!1,{type:"boolean",description:(0,t.localize)(4730,null)}),e.$0G=new i.$2j("chatInputHasText",!1,{type:"boolean",description:(0,t.localize)(4731,null)}),e.$$G=new i.$2j("chatInputHasFocus",!1,{type:"boolean",description:(0,t.localize)(4732,null)}),e.$_G=new i.$2j("inChatInput",!1,{type:"boolean",description:(0,t.localize)(4733,null)}),e.$aH=new i.$2j("inChat",!1,{type:"boolean",description:(0,t.localize)(4734,null)}),e.$bH=new i.$2j("chatIsEnabled",!1,{type:"boolean",description:(0,t.localize)(4735,null)}),e.$cH=new i.$2j("chatPanelParticipantRegistered",!1,{type:"boolean",description:(0,t.localize)(4736,null)}),e.$dH=new i.$2j("chatExtensionInvalid",!1,{type:"boolean",description:(0,t.localize)(4737,null)}),e.$eH=new i.$2j("chatCursorAtTop",!1),e.$fH=new i.$2j("chatInputHasAgent",!1),e.$gH=new i.$2j("chatLocation",void 0),e.$hH=new i.$2j("quickChatHasFocus",!1,{type:"boolean",description:(0,t.localize)(4738,null)})}),define(Oe[262],Le([1,0,105,13,18,6,39,2,49,169,16,41,22,5,11,29,47,100,261]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.ChatAgentLocation=void 0,e.$qI=u,e.$rI=r;var w;(function(f){f.Panel="panel",f.Terminal="terminal",f.Notebook="notebook",f.Editor="editor"})(w||(e.ChatAgentLocation=w={})),function(f){function h(k){switch(k){case"panel":return f.Panel;case"terminal":return f.Terminal;case"notebook":return f.Notebook;case"editor":return f.Editor}return f.Panel}f.fromRaw=h}(w||(e.ChatAgentLocation=w={})),e.$lI=(0,$.$Ki)("chatAgentService");let o=class{static{this.AGENT_LEADER="@"}constructor(h){this.g=h,this.b=new Map,this.d=new I.$qe,this.onDidChangeAgents=this.d.event,this.h=new Map,this.j=new Map,this.e=g.$bH.bindTo(this.g),this.f=g.$cH.bindTo(this.g)}registerAgent(h,k){if(this.getAgent(h))throw new Error(`Agent already registered: ${JSON.stringify(h)}`);k.isDefault&&this.f.set(!0);const O=this,C=k.slashCommands;k={...k,get slashCommands(){return C.filter(R=>!R.when||O.g.contextMatchesRules(y.$Ij.deserialize(R.when)))}};const L={data:k};return this.b.set(h,L),this.d.fire(void 0),(0,T.$Xc)(()=>{this.b.delete(h),k.isDefault&&this.f.set(!1),this.d.fire(void 0)})}registerAgentImplementation(h,k){const P=this.b.get(h);if(!P)throw new Error(`Unknown agent: ${JSON.stringify(h)}`);if(P.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(h)}`);return P.data.isDefault&&this.e.set(!0),P.impl=k,this.d.fire(new l(P.data,k)),(0,T.$Xc)(()=>{P.impl=void 0,this.d.fire(void 0),P.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(h,k){h.isDynamic=!0;const P={data:h,impl:k};return this.b.set(h.id,P),this.d.fire(new l(h,k)),(0,T.$Xc)(()=>{this.b.delete(h.id),this.d.fire(void 0)})}registerAgentCompletionProvider(h,k){return this.h.set(h,k),{dispose:()=>{this.h.delete(h)}}}async getAgentCompletionItems(h,k,P){return await this.h.get(h)?.(k,P)??[]}updateAgent(h,k){const P=this.b.get(h);if(!P?.impl)throw new Error(`No activated agent with id ${JSON.stringify(h)} registered`);P.data.metadata={...P.data.metadata,...k},this.d.fire(new l(P.data,P.impl))}getDefaultAgent(h){return(0,t.$jb)(this.getActivatedAgents(),k=>!!k.isDefault&&k.locations.includes(h))}getContributedDefaultAgent(h){return this.getAgents().find(k=>!!k.isDefault&&k.locations.includes(h))}getSecondaryAgent(){return D.Iterable.find(this.b.values(),h=>!!h.data.metadata.isSecondary)?.data}getAgent(h){if(this.i(h))return this.b.get(h)?.data}i(h){const k=this.b.get(h);return!k?.data.when||this.g.contextMatchesRules(y.$Ij.deserialize(k.data.when))}getAgentByFullyQualifiedId(h){const k=D.Iterable.find(this.b.values(),P=>u(P.data)===h)?.data;if(!(k&&!this.i(k.id)))return k}getAgents(){return Array.from(this.b.values()).map(h=>h.data).filter(h=>this.i(h.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(h=>!!h.impl).filter(h=>this.i(h.data.id)).map(h=>new l(h.data,h.impl))}getAgentsByName(h){return this.getAgents().filter(k=>k.name===h)}agentHasDupeName(h){const k=this.getAgent(h);return k?this.getAgentsByName(k.name).filter(P=>P.extensionId.value!==k.extensionId.value).length>0:!1}async invokeAgent(h,k,P,O,C){const L=this.b.get(h);if(!L?.impl)throw new Error(`No activated agent with id "${h}"`);return await L.impl.invoke(k,P,O,C)}async getFollowups(h,k,P,O,C){const L=this.b.get(h);if(!L?.impl)throw new Error(`No activated agent with id "${h}"`);return L.impl?.provideFollowups?L.impl.provideFollowups(k,P,O,C):[]}async getChatTitle(h,k,P){const O=this.b.get(h);if(!O?.impl)throw new Error(`No activated agent with id "${h}"`);if(O.impl?.provideChatTitle)return O.impl.provideChatTitle(k,P)}registerChatParticipantDetectionProvider(h,k){return this.j.set(h,k),(0,T.$Xc)(()=>{this.j.delete(h)})}hasChatParticipantDetectionProviders(){return this.j.size>0}async detectAgentOrCommand(h,k,P,O){const C=D.Iterable.first(this.j.values());if(!C)return;const L=this.getAgents().reduce((J,x)=>{J.push({participant:x.id,disambiguation:x.disambiguation??[]});for(const ve of x.slashCommands)J.push({participant:x.id,command:ve.name,disambiguation:ve.disambiguation??[]});return J},[]),R=await C.provideParticipantDetection(h,k,{...P,participants:L},O);if(!R)return;const z=this.getAgent(R.participant);if(!z)return;if(!R.command)return{agent:z};const Q=z?.slashCommands.find(J=>J.name===R.command);if(Q)return{agent:z,command:Q}}};e.$mI=o,e.$mI=o=Ve([je(0,y.$3j)],o);class l{constructor(h,k){this.b=h,this.d=k}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}get disambiguation(){return this.b.disambiguation}async invoke(h,k,P,O){return this.d.invoke(h,k,P,O)}async provideFollowups(h,k,P,O){return this.d.provideFollowups?this.d.provideFollowups(h,k,P,O):[]}provideWelcomeMessage(h,k){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(h,k)}provideSampleQuestions(h,k){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(h,k)}toJSON(){return this.b}}e.$nI=l,e.$oI=(0,$.$Ki)("chatAgentNameService");let n=class{static{d=this}static{this.b="chat.participantNameRegistry"}constructor(h,k,P,O){if(this.g=k,this.h=P,this.i=O,this.e=(0,s.$$d)(this,Object.create(null)),this.f=!1,!h.chatParticipantRegistry)return;this.d=h.chatParticipantRegistry;const C=O.get(d.b,b.StorageScope.APPLICATION);try{this.e.set(JSON.parse(C??"{}"),void 0)}catch{O.remove(d.b,b.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(h=>this.h.warn("Failed to fetch chat participant registry",h)).then(()=>(0,i.$Lh)(5*60*1e3)).then(()=>this.j())}async k(){const h=await this.g.request({type:"GET",url:this.d},E.CancellationToken.None);if(h.res.statusCode!==200)throw new Error("Could not get extensions report.");const k=await(0,m.$jq)(h);if(!k||k.version!==1)throw new Error("Unexpected chat participant registry response.");const P=k.restrictedChatParticipants;this.e.set(P,void 0),this.i.store(d.b,JSON.stringify(P),b.StorageScope.APPLICATION,b.StorageTarget.MACHINE)}getAgentNameRestriction(h){const k=this.l(h.name,h).get(),P=!h.fullName||this.l(h.fullName.replace(/\s/g,""),h).get();return k&&P}l(h,k){return this.e.map(O=>O[h.toLowerCase()]).map(O=>O?O.some(C=>(0,S.$Kf)(C,C.includes(".")?k.extensionId.value:k.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$pI=n,e.$pI=n=d=Ve([je(0,c.$yk),je(1,m.$dq),je(2,a.$fk),je(3,b.$qq)],n);function u(f){return`${f.extensionId.value}.${f.id}`}function r(f){const h="name"in f?f:{...f,name:f.id};return"extensionPublisherId"in h||(h.extensionPublisherId=h.extensionPublisher??""),"extensionDisplayName"in h||(h.extensionDisplayName=""),"extensionId"in h||(h.extensionId=new p.$zn("")),(0,v.$hi)(h)}}),define(Oe[263],Le([1,0,4,7,41,5]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$cL=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$aL=e.MemoryRangeType=e.State=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=void 0,e.$_K=v,e.$bL=S,i=We(i),e.$ZJ="workbench.view.debug",e.$1J="workbench.debug.variablesView",e.$2J="workbench.debug.watchExpressionsView",e.$3J="workbench.debug.callStackView",e.$4J="workbench.debug.loadedScriptsView",e.$5J="workbench.debug.breakPointsView",e.$6J="workbench.debug.disassemblyView",e.$7J="workbench.panel.repl",e.$8J="workbench.panel.repl.view",e.$9J=new E.$2j("debugType",void 0,{type:"string",description:i.localize(5739,null)}),e.$0J=new E.$2j("debugConfigurationType",void 0,{type:"string",description:i.localize(5740,null)}),e.$$J=new E.$2j("debugState","inactive",{type:"string",description:i.localize(5741,null)}),e.$_J="debugUx",e.$aK=new E.$2j(e.$_J,"default",{type:"string",description:i.localize(5742,null)}),e.$bK=new E.$2j("hasDebugged",!1,{type:"boolean",description:i.localize(5743,null)}),e.$cK=new E.$2j("inDebugMode",!1,{type:"boolean",description:i.localize(5744,null)}),e.$dK=new E.$2j("inDebugRepl",!1,{type:"boolean",description:i.localize(5745,null)}),e.$eK=new E.$2j("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(5746,null)}),e.$fK=new E.$2j("inBreakpointWidget",!1,{type:"boolean",description:i.localize(5747,null)}),e.$gK=new E.$2j("breakpointsFocused",!0,{type:"boolean",description:i.localize(5748,null)}),e.$hK=new E.$2j("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(5749,null)}),e.$iK=new E.$2j("watchExpressionsExist",!1,{type:"boolean",description:i.localize(5750,null)}),e.$jK=new E.$2j("variablesFocused",!0,{type:"boolean",description:i.localize(5751,null)}),e.$kK=new E.$2j("expressionSelected",!1,{type:"boolean",description:i.localize(5752,null)}),e.$lK=new E.$2j("breakpointInputFocused",!1,{type:"boolean",description:i.localize(5753,null)}),e.$mK=new E.$2j("callStackItemType",void 0,{type:"string",description:i.localize(5754,null)}),e.$nK=new E.$2j("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(5755,null)}),e.$oK=new E.$2j("callStackItemStopped",!1,{type:"boolean",description:i.localize(5756,null)}),e.$pK=new E.$2j("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(5757,null)}),e.$qK=new E.$2j("watchItemType",void 0,{type:"string",description:i.localize(5758,null)}),e.$rK=new E.$2j("canViewMemory",void 0,{type:"boolean",description:i.localize(5759,null)}),e.$sK=new E.$2j("breakpointItemType",void 0,{type:"string",description:i.localize(5760,null)}),e.$tK=new E.$2j("breakpointItemBytes",void 0,{type:"boolean",description:i.localize(5761,null)}),e.$uK=new E.$2j("breakpointHasModes",!1,{type:"boolean",description:i.localize(5762,null)}),e.$vK=new E.$2j("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(5763,null)}),e.$wK=new E.$2j("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(5764,null)}),e.$xK=new E.$2j("loadedScriptsItemType",void 0,{type:"string",description:i.localize(5765,null)}),e.$yK=new E.$2j("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(5766,null)}),e.$zK=new E.$2j("focusedSessionIsNoDebug",!1,{type:"boolean",description:i.localize(5767,null)}),e.$AK=new E.$2j("stepBackSupported",!1,{type:"boolean",description:i.localize(5768,null)}),e.$BK=new E.$2j("restartFrameSupported",!1,{type:"boolean",description:i.localize(5769,null)}),e.$CK=new E.$2j("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(5770,null)}),e.$DK=new E.$2j("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(5771,null)}),e.$EK=new E.$2j("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(5772,null)}),e.$FK=new E.$2j("breakpointsExist",!1,{type:"boolean",description:i.localize(5773,null)}),e.$GK=new E.$2j("debuggersAvailable",!1,{type:"boolean",description:i.localize(5774,null)}),e.$HK=new E.$2j("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(5775,null)}),e.$IK=new E.$2j("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(5776,null)}),e.$JK=new E.$2j("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(5777,null)}),e.$KK=new E.$2j("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:i.localize(5778,null)}),e.$LK=new E.$2j("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(5779,null)}),e.$MK=new E.$2j("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(5780,null)}),e.$NK=new E.$2j("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(5781,null)}),e.$OK=new E.$2j("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(5782,null)}),e.$PK=new E.$2j("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(5783,null)}),e.$QK=new E.$2j("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(5784,null)}),e.$RK=new E.$2j("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(5785,null)}),e.$SK=new E.$2j("variableIsReadonly",!1,{type:"boolean",description:i.localize(5786,null)}),e.$TK=new E.$2j("variableValue",!1,{type:"string",description:i.localize(5787,null)}),e.$UK=new E.$2j("variableType",!1,{type:"string",description:i.localize(5788,null)}),e.$VK=new E.$2j("variableInterfaces",!1,{type:"array",description:i.localize(5789,null)}),e.$WK=new E.$2j("variableName",!1,{type:"string",description:i.localize(5790,null)}),e.$XK=new E.$2j("variableLanguage",!1,{type:"string",description:i.localize(5791,null)}),e.$YK=new E.$2j("variableExtensionId",!1,{type:"string",description:i.localize(5792,null)}),e.$ZK=new E.$2j("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(5793,null)}),e.$1K=new E.$2j("multiSessionRepl",!1,{type:"boolean",description:i.localize(5794,null)}),e.$2K=new E.$2j("multiSessionDebug",!1,{type:"boolean",description:i.localize(5795,null)}),e.$3K=new E.$2j("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(5796,null)}),e.$4K=new E.$2j("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(5797,null)}),e.$5K=new E.$2j("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(5798,null)}),e.$6K=new E.$2j("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(5799,null)});const D=d=>i.localize(5800,null,d);e.$7K=D,e.$8K="editor.contrib.debug",e.$9K="editor.contrib.breakpoint",e.$0K="debug",e.$$K={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(5801,null)};var T;(function(d){d[d.Inactive=0]="Inactive",d[d.Initializing=1]="Initializing",d[d.Stopped=2]="Stopped",d[d.Running=3]="Running"})(T||(e.State=T={}));function v(d){switch(d){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var s;(function(d){d[d.Valid=0]="Valid",d[d.Unreadable=1]="Unreadable",d[d.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$aL="vscode-debug-memory";function S(d){const w=d.presentationHint??d.source.presentationHint;return w==="deemphasize"||w==="subtle"}var y;(function(d){d[d.Variable=0]="Variable",d[d.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var p;(function(d){d[d.Initial=1]="Initial",d[d.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var $;(function(d){d.UnverifiedBreakpoints="unverifiedBreakpoints"})($||(e.DebuggerString=$={})),e.$cL=(0,I.$Ki)("debugService");var a;(function(d){d[d.CONDITION=0]="CONDITION",d[d.HIT_COUNT=1]="HIT_COUNT",d[d.LOG_MESSAGE=2]="LOG_MESSAGE",d[d.TRIGGER_POINT=3]="TRIGGER_POINT"})(a||(e.BreakpointWidgetContext=a={}));var c;(function(d){d[d.Command=0]="Command",d[d.Tree=1]="Tree"})(c||(e.DebugVisualizationType=c={}));var m;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var b;(function(d){d.deserialize=w=>w,d.serialize=w=>w})(b||(e.IDebugVisualizationTreeItem=b={}));var g;(function(d){d.deserialize=w=>({id:w.id,name:w.name,iconPath:w.iconPath&&{light:t.URI.revive(w.iconPath.light),dark:t.URI.revive(w.iconPath.dark)},iconClass:w.iconClass,visualization:w.visualization}),d.serialize=w=>w})(g||(e.IDebugVisualization=g={}))}),define(Oe[264],Le([1,0,5]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fR=void 0,e.$fR=(0,t.$Ki)("environmentVariableService")}),define(Oe[148],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelRequest=e.RemoteTerminalChannelEvent=e.$BR=void 0,e.$BR="remoteterminal";var t;(function(E){E.OnPtyHostExitEvent="$onPtyHostExitEvent",E.OnPtyHostStartEvent="$onPtyHostStartEvent",E.OnPtyHostUnresponsiveEvent="$onPtyHostUnresponsiveEvent",E.OnPtyHostResponsiveEvent="$onPtyHostResponsiveEvent",E.OnPtyHostRequestResolveVariablesEvent="$onPtyHostRequestResolveVariablesEvent",E.OnProcessDataEvent="$onProcessDataEvent",E.OnProcessReadyEvent="$onProcessReadyEvent",E.OnProcessExitEvent="$onProcessExitEvent",E.OnProcessReplayEvent="$onProcessReplayEvent",E.OnProcessOrphanQuestion="$onProcessOrphanQuestion",E.OnExecuteCommand="$onExecuteCommand",E.OnDidRequestDetach="$onDidRequestDetach",E.OnDidChangeProperty="$onDidChangeProperty"})(t||(e.RemoteTerminalChannelEvent=t={}));var i;(function(E){E.RestartPtyHost="$restartPtyHost",E.CreateProcess="$createProcess",E.AttachToProcess="$attachToProcess",E.DetachFromProcess="$detachFromProcess",E.ListProcesses="$listProcesses",E.GetLatency="$getLatency",E.GetPerformanceMarks="$getPerformanceMarks",E.OrphanQuestionReply="$orphanQuestionReply",E.AcceptPtyHostResolvedVariables="$acceptPtyHostResolvedVariables",E.Start="$start",E.Input="$input",E.AcknowledgeDataEvent="$acknowledgeDataEvent",E.Shutdown="$shutdown",E.Resize="$resize",E.ClearBuffer="$clearBuffer",E.GetInitialCwd="$getInitialCwd",E.GetCwd="$getCwd",E.ProcessBinary="$processBinary",E.SendCommandResult="$sendCommandResult",E.InstallAutoReply="$installAutoReply",E.UninstallAllAutoReplies="$uninstallAllAutoReplies",E.GetDefaultSystemShell="$getDefaultSystemShell",E.GetProfiles="$getProfiles",E.GetEnvironment="$getEnvironment",E.GetWslPath="$getWslPath",E.GetTerminalLayoutInfo="$getTerminalLayoutInfo",E.SetTerminalLayoutInfo="$setTerminalLayoutInfo",E.SerializeTerminalState="$serializeTerminalState",E.ReviveTerminalProcesses="$reviveTerminalProcesses",E.GetRevivedPtyNewId="$getRevivedPtyNewId",E.SetUnicodeVersion="$setUnicodeVersion",E.ReduceConnectionGraceTime="$reduceConnectionGraceTime",E.UpdateIcon="$updateIcon",E.UpdateTitle="$updateTitle",E.UpdateProperty="$updateProperty",E.RefreshProperty="$refreshProperty",E.RequestDetachInstance="$requestDetachInstance",E.AcceptDetachInstanceReply="$acceptDetachInstanceReply",E.AcceptDetachedInstance="$acceptDetachedInstance",E.FreePortKillProcess="$freePortKillProcess"})(i||(e.RemoteTerminalChannelRequest=i={}))}),define(Oe[265],Le([1,0,8,4,70,53,3,139,10]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JR=s,e.$KR=y,e.$LR=a,e.$MR=c,e.$NR=m,e.$OR=g,e.$PR=d,e.$QR=w,e.$RR=o,t=We(t);function s(l,n){if(n)if(D.$l)for(const u in n){let r=u;for(const h in l)if(u.toLowerCase()===h.toLowerCase()){r=h;break}const f=n[u];f!==void 0&&S(l,r,f)}else Object.keys(n).forEach(u=>{const r=n[u];r!==void 0&&S(l,u,r)})}function S(l,n,u){typeof u=="string"?l[n]=u:delete l[n]}function y(l,n,u,r){l.TERM_PROGRAM="vscode",n&&(l.TERM_PROGRAM_VERSION=n),a(l,r)&&(l.LANG=c(u)),l.COLORTERM="truecolor"}function p(l,n){if(n)for(const u of Object.keys(n)){const r=n[u];r!=null&&(l[u]=r)}}async function $(l,n){return await Promise.all(Object.entries(n).map(async([u,r])=>{if(typeof r=="string")try{n[u]=await l(r)}catch{n[u]=r}})),n}function a(l,n){if(n==="on")return!0;if(n==="auto"){const u=l.LANG;return!u||u.search(/\.UTF\-8$/)===-1&&u.search(/\.utf8$/)===-1&&u.search(/\.euc.+/)===-1}return!1}function c(l){const n=l?l.split("-"):[],u=n.length;if(u===0)return"en_US.UTF-8";if(u===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in r&&n.push(r[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}async function m(l,n,u,r,f,h){if(l.cwd){const P=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,O=await b(P,u);return(0,T.$GR)(O||P)}let k;return!l.ignoreConfigurationCwd&&f&&(u&&(f=await b(f,u,h)),f&&(t.$nc(f)?k=f:r&&(k=t.$oc(r.fsPath,f)))),k||(k=r?r.fsPath:n||""),(0,T.$GR)(k)}async function b(l,n,u){if(n)try{return await n(l)}catch(r){u?.error("Could not resolve terminal cwd",r);return}return l}function g(l,n,u){if(u)return r=>u.resolveWithEnvironment(n,l,r)}async function d(l,n,u,r,f,h){const k={};if(l.strictEnv)p(k,l.env);else{p(k,h);const P={...n};u&&(P&&await $(u,P),l.env&&await $(u,l.env)),D.$m&&(k.VSCODE_NODE_OPTIONS&&(k.NODE_OPTIONS=k.VSCODE_NODE_OPTIONS,delete k.VSCODE_NODE_OPTIONS),k.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(k.NODE_REPL_EXTERNAL_MODULE=k.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete k.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,E.$qm)(k,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),s(k,P),s(k,l.env),y(k,r,D.$z,f)}return k}async function w(l,n,u,r,f,h,k=D.$l){let P;if((0,v.$jg)(l)?P=l:(P=l.fsPath,k&&h!==D.OperatingSystem.Windows?P=P.replace(/\\/g,"/"):!k&&h===D.OperatingSystem.Windows&&(P=P.replace(/\//g,"\\"))),!n)return P;const O=P.includes(" "),C=P.includes("(")||P.includes(")"),L=t.$sc(n,".exe"),R=L==="pwsh"||u==="pwsh"||L==="powershell"||u==="powershell";if(R&&(O||P.includes("'")))return`& '${P.replace(/'/g,"''")}'`;if(C&&R)return`& '${P}'`;if(h===D.OperatingSystem.Windows){if(r!==void 0)return r===I.WindowsShellType.GitBash?(0,T.$ER)(P.replace(/\\/g,"/")):r===I.WindowsShellType.Wsl?f?.getWslPath(P,"win-to-unix")||P:O?`"${P}"`:P;const z=n.toLowerCase();return z.includes("wsl")||z.includes("bash.exe")&&!z.toLowerCase().includes("git")?f?.getWslPath(P,"win-to-unix")||P:O?`"${P}"`:P}return(0,T.$ER)(P)}function o(l,n,u){const r=typeof l=="string"?i.URI.parse(l):l;let f=r?n.getWorkspaceFolder(r)??void 0:void 0;if(!f){const h=u.getLastActiveWorkspaceRoot();f=h?n.getWorkspaceFolder(h)??void 0:void 0}return f}}),define(Oe[77],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.TestPosition=e.TestIdPathParts=void 0;var t;(function(I){I.Delimiter="\0"})(t||(e.TestIdPathParts=t={}));var i;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(i||(e.TestPosition=i={}));class E{static fromExtHostTestItem(D,T,v=D.parent){if(D._isRoot)return new E([T]);const s=[D.id];for(let S=v;S&&S.id!==T;S=S.parent)s.push(S.id);return s.push(T),new E(s.reverse())}static isRoot(D){return!D.includes(t.Delimiter)}static root(D){const T=D.indexOf(t.Delimiter);return T===-1?D:D.slice(0,T)}static fromString(D){return new E(D.split(t.Delimiter))}static join(D,T){return new E([...D.path,T])}static joinToString(D,T){return D.toString()+t.Delimiter+T}static parentId(D){const T=D.lastIndexOf(t.Delimiter);return T===-1?void 0:D.slice(0,T)}static localId(D){const T=D.lastIndexOf(t.Delimiter);return T===-1?D:D.slice(T+t.Delimiter.length)}static isChild(D,T){return T[D.length]===t.Delimiter&&T.startsWith(D)}static compare(D,T){return D===T?i.IsSame:E.isChild(D,T)?i.IsChild:E.isChild(T,D)?i.IsParent:i.Disconnected}static getLengthOfCommonPrefix(D,T){if(D===0)return 0;let v=0;for(;v<D-1;){for(let s=1;s<D;s++){const S=T(s-1),y=T(s);if(S.path[v]!==y.path[v])return v}v++}return v}constructor(D,T=D.length){if(this.path=D,this.d=T,D.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new E(this.path,1)}get parentId(){return this.d>1?new E(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new E(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new E(this.path,D)}compare(D){if(typeof D=="string")return E.compare(this.toString(),D);for(let T=0;T<D.d&&T<this.d;T++)if(D.path[T]!==this.path[T])return i.Disconnected;return D.d>this.d?i.IsChild:D.d<this.d?i.IsParent:i.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+=t.Delimiter,this.c+=this.path[D]}return this.c}}e.$tJ=E}),define(Oe[104],Le([1,0,4,85,48,77]),function(ue,e,t,i,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$BJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$AJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$zJ=e.$yJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$xJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$wJ=e.$vJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$uJ=e.TestResultState=void 0;var D;(function(se){se[se.Unset=0]="Unset",se[se.Queued=1]="Queued",se[se.Running=2]="Running",se[se.Passed=3]="Passed",se[se.Failed=4]="Failed",se[se.Skipped=5]="Skipped",se[se.Errored=6]="Errored"})(D||(e.TestResultState=D={})),e.$uJ={[D.Unset]:"unset",[D.Queued]:"queued",[D.Running]:"running",[D.Passed]:"passed",[D.Failed]:"failed",[D.Skipped]:"skipped",[D.Errored]:"errored"};var T;(function(se){se[se.Run=1]="Run",se[se.Debug=2]="Debug",se[se.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var v;(function(se){se[se.Refresh=2]="Refresh",se[se.CodeRelatedToTest=4]="CodeRelatedToTest",se[se.TestRelatedToCode=8]="TestRelatedToCode"})(v||(e.TestControllerCapability=v={}));var s;(function(se){se[se.Run=2]="Run",se[se.Debug=4]="Debug",se[se.Coverage=8]="Coverage",se[se.HasNonDefaultProfile=16]="HasNonDefaultProfile",se[se.HasConfigurable=32]="HasConfigurable",se[se.SupportsContinuousRun=64]="SupportsContinuousRun"})(s||(e.TestRunProfileBitset=s={})),e.$vJ=[s.Run,s.Debug,s.Coverage,s.HasNonDefaultProfile,s.HasConfigurable,s.SupportsContinuousRun];const S=se=>"runId"in se;e.$wJ=S;var y;(function(se){se.serialize=V=>({range:V.range.toJSON(),uri:V.uri.toJSON()}),se.deserialize=(V,B)=>({range:E.$Yt.lift(B.range),uri:V.asCanonicalUri(t.URI.revive(B.uri))})})(y||(e.IRichLocation=y={}));var p;(function(se){se[se.Error=0]="Error",se[se.Output=1]="Output"})(p||(e.TestMessageType=p={}));var $;(function(se){se.serialize=V=>({label:V.label,uri:V.uri?.toJSON(),position:V.position?.toJSON()}),se.deserialize=(V,B)=>({label:B.label,uri:B.uri?V.asCanonicalUri(t.URI.revive(B.uri)):void 0,position:B.position?i.$Xt.lift(B.position):void 0})})($||(e.ITestMessageStackFrame=$={}));var a;(function(se){se.serialize=V=>({message:V.message,type:p.Error,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&y.serialize(V.location),stackTrace:V.stackTrace?.map($.serialize)}),se.deserialize=(V,B)=>({message:B.message,type:p.Error,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&y.deserialize(V,B.location),stackTrace:B.stackTrace&&B.stackTrace.map(j=>$.deserialize(V,j))})})(a||(e.ITestErrorMessage=a={}));const c=(se,V)=>`${V?"s":"e"}${se}`;e.$xJ=c;var m;(function(se){se.serialize=V=>({message:V.message,type:p.Output,offset:V.offset,length:V.length,location:V.location&&y.serialize(V.location)}),se.deserialize=(V,B)=>({message:B.message,type:p.Output,offset:B.offset,length:B.length,location:B.location&&y.deserialize(V,B.location)})})(m||(e.ITestOutputMessage=m={}));var b;(function(se){se.serialize=V=>V.type===p.Error?a.serialize(V):m.serialize(V),se.deserialize=(V,B)=>B.type===p.Error?a.deserialize(V,B):m.deserialize(V,B),se.isDiffable=V=>V.type===p.Error&&V.actual!==void 0&&V.expected!==void 0})(b||(e.ITestMessage=b={}));var g;(function(se){se.serializeWithoutMessages=V=>({state:V.state,duration:V.duration,messages:[]}),se.serialize=V=>({state:V.state,duration:V.duration,messages:V.messages.map(b.serialize)}),se.deserialize=(V,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(j=>b.deserialize(V,j))})})(g||(e.ITestTaskState=g={}));const d="\0",w=(se,V)=>se+d+V;e.$yJ=w;const o=se=>{const V=se.indexOf(d);return{ctrlId:se.slice(0,V),tagId:se.slice(V+1)}};e.$zJ=o;var l;(function(se){se.serialize=V=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?.toJSON(),range:V.range?.toJSON()||null,description:V.description,error:V.error,sortText:V.sortText}),se.deserialize=(V,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?V.asCanonicalUri(t.URI.revive(B.uri)):void 0,range:B.range?E.$Yt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(l||(e.ITestItem=l={}));var n;(function(se){se[se.NotExpandable=0]="NotExpandable",se[se.Expandable=1]="Expandable",se[se.BusyExpanding=2]="BusyExpanding",se[se.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var u;(function(se){se.serialize=V=>({expand:V.expand,item:l.serialize(V.item)}),se.deserialize=(V,B)=>({controllerId:I.$tJ.root(B.item.extId),expand:B.expand,item:l.deserialize(V,B.item)})})(u||(e.InternalTestItem=u={}));var r;(function(se){se.serialize=V=>{let B;return V.item&&(B={},V.item.label!==void 0&&(B.label=V.item.label),V.item.tags!==void 0&&(B.tags=V.item.tags),V.item.busy!==void 0&&(B.busy=V.item.busy),V.item.uri!==void 0&&(B.uri=V.item.uri?.toJSON()),V.item.range!==void 0&&(B.range=V.item.range?.toJSON()),V.item.description!==void 0&&(B.description=V.item.description),V.item.error!==void 0&&(B.error=V.item.error),V.item.sortText!==void 0&&(B.sortText=V.item.sortText)),{extId:V.extId,expand:V.expand,item:B}},se.deserialize=V=>{let B;return V.item&&(B={},V.item.label!==void 0&&(B.label=V.item.label),V.item.tags!==void 0&&(B.tags=V.item.tags),V.item.busy!==void 0&&(B.busy=V.item.busy),V.item.range!==void 0&&(B.range=V.item.range?E.$Yt.lift(V.item.range):null),V.item.description!==void 0&&(B.description=V.item.description),V.item.error!==void 0&&(B.error=V.item.error),V.item.sortText!==void 0&&(B.sortText=V.item.sortText)),{extId:V.extId,expand:V.expand,item:B}}})(r||(e.ITestItemUpdate=r={}));const f=(se,V)=>{V.expand!==void 0&&(se.expand=V.expand),V.item!==void 0&&(se.item=se.item?Object.assign(se.item,V.item):V.item)};e.$AJ=f;var h;(function(se){se.serializeWithoutMessages=V=>({...u.serialize(V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(g.serializeWithoutMessages)}),se.serialize=V=>({...u.serialize(V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(g.serialize)}),se.deserialize=(V,B)=>({...u.deserialize(V,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(j=>g.deserialize(V,j)),retired:!0})})(h||(e.TestResultItem=h={}));var k;(function(se){se.empty=()=>({covered:0,total:0}),se.sum=(V,B)=>{V.covered+=B.covered,V.total+=B.total}})(k||(e.ICoverageCount=k={}));var P;(function(se){se.serialize=V=>({id:V.id,statement:V.statement,branch:V.branch,declaration:V.declaration,testIds:V.testIds,uri:V.uri.toJSON()}),se.deserialize=(V,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,testIds:B.testIds,uri:V.asCanonicalUri(t.URI.revive(B.uri))}),se.empty=(V,B)=>({id:V,uri:B,statement:k.empty()})})(P||(e.IFileCoverage=P={}));function O(se){return{...se,location:se.location?.toJSON()}}function C(se){return se.location=se.location?i.$Xt.isIPosition(se.location)?i.$Xt.lift(se.location):E.$Yt.lift(se.location):void 0,se}e.$BJ=3;var L;(function(se){se[se.Declaration=0]="Declaration",se[se.Statement=1]="Statement",se[se.Branch=2]="Branch"})(L||(e.DetailType=L={}));var R;(function(se){se.serialize=V=>V.type===L.Declaration?Q.serialize(V):J.serialize(V),se.deserialize=V=>V.type===L.Declaration?Q.deserialize(V):J.deserialize(V)})(R||(e.CoverageDetails=R={}));var z;(function(se){se.serialize=O,se.deserialize=C})(z||(e.IBranchCoverage=z={}));var Q;(function(se){se.serialize=O,se.deserialize=C})(Q||(e.IDeclarationCoverage=Q={}));var J;(function(se){se.serialize=V=>({...O(V),branches:V.branches?.map(z.serialize)}),se.deserialize=V=>({...C(V),branches:V.branches?.map(z.deserialize)})})(J||(e.IStatementCoverage=J={}));var x;(function(se){se[se.Add=0]="Add",se[se.Update=1]="Update",se[se.DocumentSynced=2]="DocumentSynced",se[se.Remove=3]="Remove",se[se.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",se[se.Retire=5]="Retire",se[se.AddTag=6]="AddTag",se[se.RemoveTag=7]="RemoveTag"})(x||(e.TestDiffOpType=x={}));var ve;(function(se){se.deserialize=(V,B)=>B.op===x.Add?{op:B.op,item:u.deserialize(V,B.item)}:B.op===x.Update?{op:B.op,item:r.deserialize(B.item)}:B.op===x.DocumentSynced?{op:B.op,uri:V.asCanonicalUri(t.URI.revive(B.uri)),docv:B.docv}:B,se.serialize=V=>V.op===x.Add?{op:V.op,item:u.serialize(V.item)}:V.op===x.Update?{op:V.op,item:r.serialize(V.item)}:V})(ve||(e.TestsDiffOp=ve={}));class be{constructor(V){this.l=V,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(V){const B=this.x();for(const j of V)switch(j.op){case x.Add:this.p(u.deserialize(this.l,j.item),B);break;case x.Update:this.q(r.deserialize(j.item),B);break;case x.Remove:this.v(j.itemId,B);break;case x.Retire:this.w(j.itemId);break;case x.IncrementPendingExtHosts:this.updatePendingRoots(j.amount);break;case x.AddTag:this.f.set(j.tag.id,j.tag);break;case x.RemoveTag:this.f.delete(j.id);break}B.complete?.()}p(V,B){const j=I.$tJ.parentId(V.item.extId)?.toString();let U;if(!j)U=this.y(V),this.h.add(U),this.g.set(V.item.extId,U);else if(this.g.has(j)){const te=this.g.get(j);te.children.add(V.item.extId),U=this.y(V,te),this.g.set(V.item.extId,U)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(V)}`);return}return B.add?.(U),V.expand===n.BusyExpanding&&this.j++,U}q(V,B){const j=this.g.get(V.extId);if(j)return V.expand!==void 0&&(j.expand===n.BusyExpanding&&this.j--,V.expand===n.BusyExpanding&&this.j++),(0,e.$AJ)(j,V),B.update?.(j),j}v(V,B){const j=this.g.get(V);if(!j)return;const U=I.$tJ.parentId(j.item.extId)?.toString();U?this.g.get(U).children.delete(j.item.extId):this.h.delete(j);const te=[[V]];for(;te.length;)for(const le of te.pop()){const ye=this.g.get(le);ye&&(te.push(ye.children),this.g.delete(le),B.remove?.(ye,ye!==j),ye.expand===n.BusyExpanding&&this.j--)}}w(V){}updatePendingRoots(V){this.k+=V}x(){return{}}}e.$CJ=be}),define(Oe[149],Le([1,0,13,6,2,106,104,77]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=e.$HQ=e.$GQ=e.$FQ=e.$EQ=e.TestItemEventOp=void 0;var v;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const s=(g,d)=>g===d,y=Object.entries({range:(g,d)=>g===d?!0:!g||!d?!1:g.equalsRange(d),busy:s,label:s,description:s,error:s,sortText:s,tags:(g,d)=>!(g.length!==d.length||g.some(w=>!d.includes(w)))}),p=(g,d)=>{let w;for(const[o,l]of y)l(g[o],d[o])||(w?w[o]=d[o]:w={[o]:d[o]});return w};class $ extends E.$Zc{get root(){return this.s.root}constructor(d){super(),this.s=d,this.f=this.B(new t.$Wh(()=>this.flushDiff(),200)),this.g=this.B(new i.$qe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(d){this.h=d;for(const w of this.tree.values())this.J(w)}get resolveHandler(){return this.h}collectDiff(){const d=this.m;return this.m=[],d}pushDiff(d){switch(d.op){case D.TestDiffOpType.DocumentSynced:{for(const w of this.m)if(w.op===D.TestDiffOpType.DocumentSynced&&w.uri===d.uri){w.docv=d.docv;return}break}case D.TestDiffOpType.Update:{const w=this.m[this.m.length-1];if(w){if(w.op===D.TestDiffOpType.Update&&w.item.extId===d.item.extId){(0,D.$AJ)(w.item,d.item);return}if(w.op===D.TestDiffOpType.Add&&w.item.item.extId===d.item.extId){(0,D.$AJ)(w.item,d.item);return}}break}}this.m.push(d),this.f.isScheduled()||this.f.schedule()}expand(d,w){const o=this.tree.get(d);if(o){if((o.expandLevels===void 0||w>o.expandLevels)&&(o.expandLevels=w),o.expand===D.TestItemExpandState.Expandable){const l=this.M(o);return l.isOpen()?this.L(o,w-1):l.wait().then(()=>this.L(o,w-1))}else if(o.expand===D.TestItemExpandState.Expanded)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,w-1)):this.L(o,w-1)}}dispose(){for(const d of this.tree.values())this.s.getApiFor(d.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(d,w){switch(w.op){case v.RemoveChild:this.O(T.$tJ.joinToString(d.fullId,w.id));break;case v.Upsert:this.z(w.item,d);break;case v.Bulk:for(const o of w.ops)this.w(d,o);break;case v.SetTags:this.C(w.new,w.old,d.fullId.toString());break;case v.UpdateCanResolveChildren:this.J(d);break;case v.SetProp:this.pushDiff({op:D.TestDiffOpType.Update,item:{extId:d.fullId.toString(),item:w.update}});break;case v.DocumentSynced:this.y(d.actual.uri);break;default:(0,I.$jd)(w)}}y(d){d&&this.pushDiff({op:D.TestDiffOpType.DocumentSynced,uri:d,docv:this.s.getDocumentVersion(d)})}z(d,w){const o=T.$tJ.fromExtHostTestItem(d,this.root.id,w?.actual),l=this.s.getApiFor(d);l.parent&&l.parent!==w?.actual&&this.s.getChildren(l.parent).delete(d.id);let n=this.tree.get(o.toString());if(!n){n={fullId:o,actual:d,expandLevels:w?.expandLevels?w.expandLevels-1:void 0,expand:D.TestItemExpandState.NotExpandable},d.tags.forEach(this.D,this),this.tree.set(n.fullId.toString(),n),this.G(d,w),this.pushDiff({op:D.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(d)}}),this.I(d,n,w);return}if(n.actual===d){this.H(d,n,w);return}if(n.actual.uri?.toString()!==d.uri?.toString())return this.O(o.toString()),this.z(d,w);const u=this.s.getChildren(n.actual),r=n.actual,f=p(this.s.toITestItem(r),this.s.toITestItem(d));this.s.getApiFor(r).listener=void 0,n.actual=d,n.resolveBarrier=void 0,n.expand=D.TestItemExpandState.NotExpandable,f&&(f.hasOwnProperty("tags")&&(this.C(d.tags,r.tags,o.toString()),delete f.tags),this.w(n,{op:v.SetProp,update:f})),this.I(d,n,w);for(const[k,P]of u)this.s.getChildren(d).get(P.id)||this.O(T.$tJ.joinToString(o,P.id));const h=n.expandLevels;h!==void 0&&queueMicrotask(()=>{n.expand===D.TestItemExpandState.Expandable&&(n.expandLevels=void 0,this.expand(o.toString(),h))}),this.y(n.actual.uri)}C(d,w,o){const l=new Set(w.map(n=>n.id));for(const n of d)l.delete(n.id)||this.D(n);this.pushDiff({op:D.TestDiffOpType.Update,item:{extId:o,item:{tags:d.map(n=>(0,D.$yJ)(this.s.controllerId,n.id))}}}),l.forEach(this.F,this)}D(d){const w=this.j.get(d.id);w?w.refCount++:(this.j.set(d.id,{refCount:1}),this.pushDiff({op:D.TestDiffOpType.AddTag,tag:{id:(0,D.$yJ)(this.s.controllerId,d.id)}}))}F(d){const w=this.j.get(d);w&&!--w.refCount&&(this.j.delete(d),this.pushDiff({op:D.TestDiffOpType.RemoveTag,id:(0,D.$yJ)(this.s.controllerId,d)}))}G(d,w){this.s.getApiFor(d).parent=w&&w.actual!==this.root?w.actual:void 0}H(d,w,o){this.G(d,o);const l=this.s.getApiFor(d);l.parent=o?.actual,l.listener=n=>this.w(w,n),this.J(w)}I(d,w,o){this.H(d,w,o);for(const[l,n]of this.s.getChildren(d))this.z(n,w)}J(d){let w;this.h?d.resolveBarrier?w=d.resolveBarrier.isOpen()?D.TestItemExpandState.Expanded:D.TestItemExpandState.BusyExpanding:w=d.actual.canResolveChildren?D.TestItemExpandState.Expandable:D.TestItemExpandState.NotExpandable:w=D.TestItemExpandState.NotExpandable,w!==d.expand&&(d.expand=w,this.pushDiff({op:D.TestDiffOpType.Update,item:{extId:d.fullId.toString(),expand:w}}),w===D.TestItemExpandState.Expandable&&d.expandLevels!==void 0&&this.M(d))}L(d,w){if(w<0)return;const o=[];for(const[l,n]of this.s.getChildren(d.actual)){const u=this.expand(T.$tJ.joinToString(d.fullId,n.id),w);(0,t.$wh)(u)&&o.push(u)}if(o.length)return Promise.all(o).then(()=>{})}M(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this.h){const n=new t.$Jh;return n.open(),n}d.expand=D.TestItemExpandState.BusyExpanding,this.N(d);const w=d.resolveBarrier=new t.$Jh,o=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let l;try{l=this.h(d.actual===this.root?void 0:d.actual)}catch(n){o(n)}return(0,t.$wh)(l)?l.catch(o).then(()=>{w.open(),this.J(d)}):(w.open(),this.J(d)),d.resolveBarrier}N(d){this.pushDiff({op:D.TestDiffOpType.Update,item:{extId:d.fullId.toString(),expand:d.expand}})}O(d){const w=this.tree.get(d);if(!w)throw new Error("attempting to remove non-existent child");this.pushDiff({op:D.TestDiffOpType.Remove,itemId:d});const o=[w];for(;o.length;){const l=o.pop();if(l){this.s.getApiFor(l.actual).listener=void 0;for(const n of l.actual.tags)this.F(n.id);this.tree.delete(l.fullId.toString());for(const[n,u]of this.s.getChildren(l.actual))o.push(this.tree.get(T.$tJ.joinToString(l.fullId,u.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.g.fire(d)}}e.$EQ=$;class a extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.$FQ=a;class c extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$GQ=c;class m extends Error{constructor(d,w,o){super(`TestItem with ID "${d}" is from controller "${w}" and cannot be added as a child of an item from controller "${o}".`)}}e.$HQ=m;const b=(g,d,w)=>{let o=new Map;return{get size(){return o.size},forEach(l,n){for(const u of o.values())l.call(n,u,this)},[Symbol.iterator](){return o.entries()},replace(l){const n=new Map,u=new Set(o.keys()),r={op:v.Bulk,ops:[]};for(const f of l){if(!(f instanceof w))throw new c(f.id);const h=d(f).controllerId;if(h!==g.controllerId)throw new m(f.id,h,g.controllerId);if(n.has(f.id))throw new a(f.id);n.set(f.id,f),u.delete(f.id),r.ops.push({op:v.Upsert,item:f})}for(const f of u.keys())r.ops.push({op:v.RemoveChild,id:f});g.listener?.(r),o=n},add(l){if(!(l instanceof w))throw new c(l.id);o.set(l.id,l),g.listener?.({op:v.Upsert,item:l})},delete(l){o.delete(l)&&g.listener?.({op:v.RemoveChild,id:l})},get(l){return o.get(l)},toJSON(){return Array.from(o.values())}}};e.$IQ=b}),define(Oe[150],Le([1,0,149]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=e.$JQ=void 0;const i=new WeakMap,E=(D,T)=>{const v={controllerId:T};return i.set(D,v),v};e.$JQ=E;const I=D=>{const T=i.get(D);if(!T)throw new t.$GQ(D?.id||"<unknown>");return T};e.$KQ=I}),define(Oe[266],Le([1,0,46,28,5]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$FF=".vscode",e.$GF="settings",e.$HF=`${e.$FF}/${e.$GF}.json`,e.$IF="vscode://schemas/settings/default",e.$JF="vscode://schemas/settings/user",e.$KF="vscode://schemas/settings/profile",e.$LF="vscode://schemas/settings/machine",e.$MF="vscode://schemas/settings/workspace",e.$NF="vscode://schemas/settings/folder",e.$OF="vscode://schemas/launch",e.$PF="vscode://schemas/tasks",e.$QF=[t.ConfigurationScope.APPLICATION],e.$RF=[t.ConfigurationScope.MACHINE,t.ConfigurationScope.WINDOW,t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE,t.ConfigurationScope.MACHINE_OVERRIDABLE],e.$SF=[t.ConfigurationScope.WINDOW,t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE],e.$TF=[t.ConfigurationScope.APPLICATION,...e.$SF],e.$UF=[t.ConfigurationScope.MACHINE,t.ConfigurationScope.WINDOW,t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE,t.ConfigurationScope.MACHINE_OVERRIDABLE],e.$VF=[t.ConfigurationScope.WINDOW,t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE,t.ConfigurationScope.MACHINE_OVERRIDABLE],e.$WF=[t.ConfigurationScope.RESOURCE,t.ConfigurationScope.LANGUAGE_OVERRIDABLE,t.ConfigurationScope.MACHINE_OVERRIDABLE],e.$XF="tasks",e.$YF="launch",e.$ZF=Object.create(null),e.$ZF[e.$XF]=`${e.$FF}/${e.$XF}.json`,e.$ZF[e.$YF]=`${e.$FF}/${e.$YF}.json`,e.$1F=Object.create(null),e.$1F[e.$XF]=`${e.$XF}.json`,e.$2F=(0,E.$Li)(i.$ej),e.$3F=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$4F="workbench.settings.applyToAllProfiles"}),define(Oe[151],Le([1,0,5,9]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=e.VariableKind=e.$CR=void 0,e.$CR=(0,t.$Ki)("configurationResolverService");var E;(function(D){D.Unknown="unknown",D.Env="env",D.Config="config",D.Command="command",D.Input="input",D.ExtensionInstallFolder="extensionInstallFolder",D.WorkspaceFolder="workspaceFolder",D.Cwd="cwd",D.WorkspaceFolderBasename="workspaceFolderBasename",D.UserHome="userHome",D.LineNumber="lineNumber",D.SelectedText="selectedText",D.File="file",D.FileWorkspaceFolder="fileWorkspaceFolder",D.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",D.RelativeFile="relativeFile",D.RelativeFileDirname="relativeFileDirname",D.FileDirname="fileDirname",D.FileExtname="fileExtname",D.FileBasename="fileBasename",D.FileBasenameNoExtension="fileBasenameNoExtension",D.FileDirnameBasename="fileDirnameBasename",D.ExecPath="execPath",D.ExecInstallFolder="execInstallFolder",D.PathSeparator="pathSeparator",D.PathSeparatorAlias="/"})(E||(e.VariableKind=E={}));class I extends i.$fb{constructor(T,v){super(v),this.variable=T}}e.$DR=I}),define(Oe[267],Le([1,0,8,32,10,21,3,192,7,151,16]),function(ue,e,t,i,E,I,D,T,v,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SR=void 0,t=We(t),i=We(i),E=We(E),I=We(I);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor($,a,c,m){this.h=new Map,this.a=$,this.b=a,this.g=c,m&&(this.c=m.then(b=>this.i(b)))}i($){if(D.$l){const a=Object.create(null);return Object.keys($).forEach(c=>{a[c.toLowerCase()]=$[c]}),a}return $}resolveWithEnvironment($,a,c){return this.l({env:this.i($),userHome:void 0},a?a.uri:void 0,c)}async resolveAsync($,a){const c={env:await this.c,userHome:await this.g};return this.l(c,$?$.uri:void 0,a)}async j($,a,c,m){const b=I.$mo(a);D.$l&&b.windows?Object.keys(b.windows).forEach(d=>b[d]=b.windows[d]):D.$m&&b.osx?Object.keys(b.osx).forEach(d=>b[d]=b.osx[d]):D.$n&&b.linux&&Object.keys(b.linux).forEach(d=>b[d]=b.linux[d]),delete b.windows,delete b.osx,delete b.linux;const g={env:await this.c,userHome:await this.g};return this.l(g,$?$.uri:void 0,b,c,m)}async resolveAnyAsync($,a,c){return this.j($,a,c)}async resolveAnyMap($,a,c){const m=new Map;return{newConfig:await this.j($,a,c,m),resolvedVariables:m}}resolveWithInteractionReplace($,a,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction($,a,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable($,a){if(this.h.has($))throw new Error("Variable "+$+" is contributed twice.");this.h.set($,a)}async l($,a,c,m,b){if(E.$jg(c))return this.m($,a,c,m,b);if(Array.isArray(c))return Promise.all(c.map(g=>this.l($,a,g,m,b)));if(E.$lg(c)){const g=Object.create(null),d=await Promise.all(Object.keys(c).map(async w=>[await this.m($,a,w,m,b),await this.l($,a,c[w],m,b)]));for(const[w,o]of d)g[w]=o;return g}return c}m($,a,c,m,b){return(0,S.$Cf)(c,y.VARIABLE_REGEXP,async(g,d)=>{if(d.includes(y.VARIABLE_LHS))return g;let w=await this.o($,g,d,a,m);return b?.set(d,w),w!==g&&E.$jg(w)&&w.match(y.VARIABLE_REGEXP)&&(w=await this.m($,a,w,m,b)),w})}n($){return this.b?this.b.getUriLabel($,{noPrefix:!0}):$.fsPath}async o($,a,c,m,b){let g;const d=c.split(":");d.length>1&&(c=d[0],g=d[1]);const w=n=>{const u=this.a.getFilePath();if(u)return(0,T.$_w)(u);throw new s.$DR(n,(0,v.localize)(12113,null,a))},o=n=>{const u=w(n);if(this.a.getWorkspaceFolderPathForFile){const r=this.a.getWorkspaceFolderPathForFile();if(r)return(0,T.$_w)(r)}throw new s.$DR(n,(0,v.localize)(12114,null,a,t.$sc(u)))},l=n=>{if(g){const u=this.a.getFolderUri(g);if(u)return u;throw new s.$DR(n,(0,v.localize)(12115,null,a,g))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new s.$DR(n,(0,v.localize)(12116,null,a)):new s.$DR(n,(0,v.localize)(12117,null,a))};switch(c){case"env":if(g){if($.env){const n=$.env[D.$l?g.toLowerCase():g];if(E.$jg(n))return n}return""}throw new s.$DR(s.VariableKind.Env,(0,v.localize)(12118,null,a));case"config":if(g){const n=this.a.getConfigurationValue(m,g);if(E.$sg(n))throw new s.$DR(s.VariableKind.Config,(0,v.localize)(12119,null,a,g));if(E.$lg(n))throw new s.$DR(s.VariableKind.Config,(0,v.localize)(12120,null,a,g));return n}throw new s.$DR(s.VariableKind.Config,(0,v.localize)(12121,null,a));case"command":return this.p(s.VariableKind.Command,a,g,b,"command");case"input":return this.p(s.VariableKind.Input,a,g,b,"input");case"extensionInstallFolder":if(g){const n=await this.a.getExtension(g);if(!n)throw new s.$DR(s.VariableKind.ExtensionInstallFolder,(0,v.localize)(12122,null,a,g));return this.n(n.extensionLocation)}throw new s.$DR(s.VariableKind.ExtensionInstallFolder,(0,v.localize)(12123,null,a));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,T.$_w)(this.n(l(s.VariableKind.WorkspaceFolder)));case"cwd":return m||g?(0,T.$_w)(this.n(l(s.VariableKind.Cwd))):i.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$_w)(t.$sc(this.n(l(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if($.userHome)return $.userHome;throw new s.$DR(s.VariableKind.UserHome,(0,v.localize)(12124,null,a))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new s.$DR(s.VariableKind.LineNumber,(0,v.localize)(12125,null,a))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new s.$DR(s.VariableKind.SelectedText,(0,v.localize)(12126,null,a))}case"file":return w(s.VariableKind.File);case"fileWorkspaceFolder":return o(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return t.$sc(o(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||g?t.$qc(this.n(l(s.VariableKind.RelativeFile)),w(s.VariableKind.RelativeFile)):w(s.VariableKind.RelativeFile);case"relativeFileDirname":{const n=t.$rc(w(s.VariableKind.RelativeFileDirname));if(m||g){const u=t.$qc(this.n(l(s.VariableKind.RelativeFileDirname)),n);return u.length===0?".":u}return n}case"fileDirname":return t.$rc(w(s.VariableKind.FileDirname));case"fileExtname":return t.$tc(w(s.VariableKind.FileExtname));case"fileBasename":return t.$sc(w(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=t.$sc(w(s.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-t.$tc(n).length)}case"fileDirnameBasename":return t.$sc(t.$rc(w(s.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||a}case"execInstallFolder":{const n=this.a.getAppRoot();return n||a}case"pathSeparator":case"/":return t.sep;default:try{const n=g?`${c}:${g}`:c;return this.p(s.VariableKind.Unknown,a,n,b,void 0)}catch{return a}}}}p($,a,c,m,b){if(c&&m){const g=b===void 0?m[c]:m[b+":"+c];if(typeof g=="string")return g;throw new s.$DR($,(0,v.localize)(12127,null,a))}return a}}e.$SR=y}),define(Oe[268],Le([1,0,5,103]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$OE=void 0,e.$PE=s,e.$QE=p,e.$RE=$,e.$OE=(0,t.$Ki)("editorGroupsService");var E;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(E||(e.GroupDirection=E={}));var I;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var D;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(D||(e.GroupLocation=D={}));var T;(function(a){a[a.MAXIMIZE=0]="MAXIMIZE",a[a.EXPAND=1]="EXPAND",a[a.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var v;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function s(a){const c=a;return(0,i.$AG)(c?.editor)&&(0,i.$AG)(c?.replacement)}var S;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(S||(e.GroupsOrder=S={}));var y;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function p(a){const c=a;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function $(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?E.DOWN:E.RIGHT}}),define(Oe[152],Le([1,0,5,268]),function(ue,e,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=e.$TE=e.$SE=void 0,e.$WE=E,e.$SE=(0,t.$Ki)("editorService"),e.$TE=-1,e.$UE=-2,e.$VE=-3;function E(I){const D=I;return typeof I=="number"||(0,i.$QE)(D)}}),define(Oe[269],Le([1,0,266,90,98,97,151,103,152,12,214,264,53,148]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VR=e.$UR=void 0,e.$UR="remoteterminal";let a=class{get onPtyHostExit(){return this.b.listen($.RemoteTerminalChannelEvent.OnPtyHostExitEvent)}get onPtyHostStart(){return this.b.listen($.RemoteTerminalChannelEvent.OnPtyHostStartEvent)}get onPtyHostUnresponsive(){return this.b.listen($.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent)}get onPtyHostResponsive(){return this.b.listen($.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent)}get onPtyHostRequestResolveVariables(){return this.b.listen($.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent)}get onProcessData(){return this.b.listen($.RemoteTerminalChannelEvent.OnProcessDataEvent)}get onProcessExit(){return this.b.listen($.RemoteTerminalChannelEvent.OnProcessExitEvent)}get onProcessReady(){return this.b.listen($.RemoteTerminalChannelEvent.OnProcessReadyEvent)}get onProcessReplay(){return this.b.listen($.RemoteTerminalChannelEvent.OnProcessReplayEvent)}get onProcessOrphanQuestion(){return this.b.listen($.RemoteTerminalChannelEvent.OnProcessOrphanQuestion)}get onExecuteCommand(){return this.b.listen($.RemoteTerminalChannelEvent.OnExecuteCommand)}get onDidRequestDetach(){return this.b.listen($.RemoteTerminalChannelEvent.OnDidRequestDetach)}get onDidChangeProperty(){return this.b.listen($.RemoteTerminalChannelEvent.OnDidChangeProperty)}constructor(m,b,g,d,w,o,l,n,u,r){this.a=m,this.b=b,this.c=g,this.d=d,this.e=w,this.f=o,this.g=l,this.h=n,this.i=u,this.j=r}restartPtyHost(){return this.b.call($.RemoteTerminalChannelRequest.RestartPtyHost,[])}async createProcess(m,b,g,d,w,o,l,n){await this.c.whenRemoteConfigurationLoaded();const u=Object.create(null),r=g?this.d.getWorkspaceFolder(g)??void 0:void 0;let f;try{f=(await this.e.resolveAnyMap(r,{shellLaunchConfig:m,configuration:b})).resolvedVariables}catch(Q){this.h.error(Q)}if(f)for(const[Q,J]of f.entries())(/^config:/.test(Q)||Q==="selectedText"||Q==="lineNumber")&&(u[Q]=J);const h=[];for(const[Q,J]of this.f.collections.entries())h.push([Q,(0,I.$Ps)(J.map),(0,I.$Qs)(J.descriptionMap)]);const k=await this.g.resolveAuthority(this.a),P=k.options&&k.options.extensionHostEnv,O=this.d.getWorkspace(),C=O.folders,L=g?this.d.getWorkspaceFolder(g):null,R=T.$JG.getOriginalUri(this.i.activeEditor,{supportSideBySide:T.SideBySideEditor.PRIMARY,filterByScheme:[s.Schemas.file,s.Schemas.vscodeUserData,s.Schemas.vscodeRemote]}),z={configuration:b,resolvedVariables:u,envVariableCollections:h,shellLaunchConfig:m,workspaceId:O.id,workspaceName:this.j.getWorkspaceLabel(O),workspaceFolders:C,activeWorkspaceFolder:L,activeFileResource:R,shouldPersistTerminal:w,options:d,cols:o,rows:l,unicodeVersion:n,resolverEnv:P};return await this.b.call($.RemoteTerminalChannelRequest.CreateProcess,z)}requestDetachInstance(m,b){return this.b.call($.RemoteTerminalChannelRequest.RequestDetachInstance,[m,b])}acceptDetachInstanceReply(m,b){return this.b.call($.RemoteTerminalChannelRequest.AcceptDetachInstanceReply,[m,b])}attachToProcess(m){return this.b.call($.RemoteTerminalChannelRequest.AttachToProcess,[m])}detachFromProcess(m,b){return this.b.call($.RemoteTerminalChannelRequest.DetachFromProcess,[m,b])}listProcesses(){return this.b.call($.RemoteTerminalChannelRequest.ListProcesses)}getLatency(){return this.b.call($.RemoteTerminalChannelRequest.GetLatency)}getPerformanceMarks(){return this.b.call($.RemoteTerminalChannelRequest.GetPerformanceMarks)}reduceConnectionGraceTime(){return this.b.call($.RemoteTerminalChannelRequest.ReduceConnectionGraceTime)}processBinary(m,b){return this.b.call($.RemoteTerminalChannelRequest.ProcessBinary,[m,b])}start(m){return this.b.call($.RemoteTerminalChannelRequest.Start,[m])}input(m,b){return this.b.call($.RemoteTerminalChannelRequest.Input,[m,b])}acknowledgeDataEvent(m,b){return this.b.call($.RemoteTerminalChannelRequest.AcknowledgeDataEvent,[m,b])}setUnicodeVersion(m,b){return this.b.call($.RemoteTerminalChannelRequest.SetUnicodeVersion,[m,b])}shutdown(m,b){return this.b.call($.RemoteTerminalChannelRequest.Shutdown,[m,b])}resize(m,b,g){return this.b.call($.RemoteTerminalChannelRequest.Resize,[m,b,g])}clearBuffer(m){return this.b.call($.RemoteTerminalChannelRequest.ClearBuffer,[m])}getInitialCwd(m){return this.b.call($.RemoteTerminalChannelRequest.GetInitialCwd,[m])}getCwd(m){return this.b.call($.RemoteTerminalChannelRequest.GetCwd,[m])}orphanQuestionReply(m){return this.b.call($.RemoteTerminalChannelRequest.OrphanQuestionReply,[m])}sendCommandResult(m,b,g){return this.b.call($.RemoteTerminalChannelRequest.SendCommandResult,[m,b,g])}freePortKillProcess(m){return this.b.call($.RemoteTerminalChannelRequest.FreePortKillProcess,[m])}installAutoReply(m,b){return this.b.call($.RemoteTerminalChannelRequest.InstallAutoReply,[m,b])}uninstallAllAutoReplies(){return this.b.call($.RemoteTerminalChannelRequest.UninstallAllAutoReplies,[])}getDefaultSystemShell(m){return this.b.call($.RemoteTerminalChannelRequest.GetDefaultSystemShell,[m])}getProfiles(m,b,g){return this.b.call($.RemoteTerminalChannelRequest.GetProfiles,[this.d.getWorkspace().id,m,b,g])}acceptPtyHostResolvedVariables(m,b){return this.b.call($.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables,[m,b])}getEnvironment(){return this.b.call($.RemoteTerminalChannelRequest.GetEnvironment)}getWslPath(m,b){return this.b.call($.RemoteTerminalChannelRequest.GetWslPath,[m,b])}setTerminalLayoutInfo(m){const g={workspaceId:this.d.getWorkspace().id,tabs:m?m.tabs:[]};return this.b.call($.RemoteTerminalChannelRequest.SetTerminalLayoutInfo,g)}updateTitle(m,b,g){return this.b.call($.RemoteTerminalChannelRequest.UpdateTitle,[m,b,g])}updateIcon(m,b,g,d){return this.b.call($.RemoteTerminalChannelRequest.UpdateIcon,[m,b,g,d])}refreshProperty(m,b){return this.b.call($.RemoteTerminalChannelRequest.RefreshProperty,[m,b])}updateProperty(m,b,g){return this.b.call($.RemoteTerminalChannelRequest.UpdateProperty,[m,b,g])}getTerminalLayoutInfo(){const b={workspaceId:this.d.getWorkspace().id};return this.b.call($.RemoteTerminalChannelRequest.GetTerminalLayoutInfo,b)}reviveTerminalProcesses(m,b,g){return this.b.call($.RemoteTerminalChannelRequest.ReviveTerminalProcesses,[m,b,g])}getRevivedPtyNewId(m){return this.b.call($.RemoteTerminalChannelRequest.GetRevivedPtyNewId,[m])}serializeTerminalState(m){return this.b.call($.RemoteTerminalChannelRequest.SerializeTerminalState,[m])}};e.$VR=a,e.$VR=a=Ve([je(2,t.$2F),je(3,E.$Ti),je(4,D.$CR),je(5,y.$fR),je(6,i.$Wl),je(7,p.$Cs),je(8,v.$SE),je(9,S.$Dw)],a)}),define(Oe[270],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=e.$kn=e.ExtHostConnectionType=void 0,e.$nn=T,e.$on=v;var t;(function(S){S[S.IPC=1]="IPC",S[S.Socket=2]="Socket",S[S.MessagePort=3]="MessagePort"})(t||(e.ExtHostConnectionType=t={}));class i{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(y){this.pipeName=y,this.type=t.IPC}serialize(y){y[i.ENV_KEY]=this.pipeName}}e.$kn=i;class E{constructor(){this.type=t.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(y){y[E.ENV_KEY]="1"}}e.$ln=E;class I{constructor(){this.type=t.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(y){y[I.ENV_KEY]="1"}}e.$mn=I;function D(S){delete S[i.ENV_KEY],delete S[E.ENV_KEY],delete S[I.ENV_KEY]}function T(S,y){D(y),S.serialize(y)}function v(S){if(S[i.ENV_KEY])return s(S,new i(S[i.ENV_KEY]));if(S[E.ENV_KEY])return s(S,new E);if(S[I.ENV_KEY])return s(S,new I);throw new Error("No connection information defined in environment!")}function s(S,y){return D(S),y}}),define(Oe[271],Le([1,0,14]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Jn=D,e.$Kn=T;var i;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(i||(e.UIKind=i={}));var E;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(E||(e.ExtensionHostExitCode=E={}));var I;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function D(s){const S=t.$Se.alloc(1);switch(s){case I.Initialized:S.writeUInt8(1,0);break;case I.Ready:S.writeUInt8(2,0);break;case I.Terminate:S.writeUInt8(3,0);break}return S}function T(s,S){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return S===I.Initialized;case 2:return S===I.Ready;case 3:return S===I.Terminate;default:return!1}}var v;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(Oe[272],Le([1,0,5,6,24,11,257,271,91,40,21,4,2,7]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Q=e.$7Q=e.$6Q=void 0,e.$8Q=m;let a=class extends p.$Zc{constructor(g,d){super(),this.s=g,this.t=d,this.a=this.B(new i.$qe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new i.$qe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=E.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=d.createLogger(this.m,{id:s.$Kp,name:(0,$.localize)(2714,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(d.onDidChangeLogLevel(w=>{(0,I.$hk)(w)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===E.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=E.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=E.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=E.TelemetryLevel.USAGE:!1}}instantiateLogger(g,d,w){const o=this.getTelemetryDetails(),l=new c(d,w,g,this.n,this.j,this.getBuiltInCommonProperties(g),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),n=this.r.get(g.identifier.value)??[];return this.r.set(g.identifier.value,[...n,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(g,d,w){this.f=g,this.g=d,this.c=w??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(g){const d=Object.create(null);switch(d["common.extname"]=`${g.publisher}.${g.name}`,d["common.extversion"]=g.version,d["common.vscodemachineid"]=this.s.telemetryInfo.machineId,d["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,d["common.sqmid"]=this.s.telemetryInfo.sqmId,d["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,d["common.vscodeversion"]=this.s.version,d["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),d["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:d["common.uikind"]="web";break;case T.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,v.$qn)((0,s.$Qp)(this.s.remote.authority)),d}$onDidChangeTelemetryLevel(g){this.h=this.getTelemetryConfiguration(),this.f=g;const d=this.getTelemetryDetails();this.r.forEach((w,o)=>{const l=w.filter(n=>!n.isDisposed);l.length===0?this.r.delete(o):this.r.set(o,l)}),this.r.forEach(w=>{for(const o of w)o.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(g,d){const o=this.r.get(g.value)?.filter(n=>!n.isDisposed);if(!o)return this.r.delete(g.value),!1;let l=!1;for(const n of o)n.ignoreUnhandledExtHostErrors||(n.logError(d),l=!0);return l}};e.$6Q=a,e.$6Q=a=Ve([je(0,D.$5Q),je(1,I.$gk)],a);class c{static validateSender(g){if(typeof g!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof g.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof g.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof g.flush<"u"&&typeof g.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(g,d,w,o,l,n,u){this.g=w,this.h=o,this.i=l,this.j=n,this.a=new i.$qe,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.b=d?.ignoreBuiltInCommonProperties??!1,this.c=d?.additionalCommonProperties,this.f=g,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(g,d){this.e&&(this.d={isUsageEnabled:g,isErrorsEnabled:d},this.a.fire(this.e))}mixInCommonPropsAndCleanData(g){let d="properties"in g?g.properties??{}:g;return d=(0,s.$Tp)(d,[]),this.c&&(d=(0,S.$po)(d,this.c)),this.b||(d=(0,S.$po)(d,this.j)),"properties"in g?g.properties=d:g=d,g}k(g,d){this.f&&(this.g.publisher==="vscode"?g=this.g.name+"/"+g:g=this.g.identifier.value+"/"+g,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f?.sendEventData(g,d),this.h.trace(g,d))}logUsage(g,d){this.d.isUsageEnabled&&this.k(g,d)}logError(g,d){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof g=="string")this.k(g,d);else{const w={name:g.name,message:g.message,stack:g.stack,cause:g.cause},o=(0,s.$Tp)(w,[]),l=new Error(o.message,{cause:o.cause});l.stack=o.stack,l.name=o.name,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f.sendErrorData(l,d),this.h.trace("exception",d)}}get apiTelemetryLogger(){if(!this.e){const g=this,d={logUsage:g.logUsage.bind(g),get isUsageEnabled(){return g.d.isUsageEnabled},get isErrorsEnabled(){return g.d.isErrorsEnabled},logError:g.logError.bind(g),dispose:g.dispose.bind(g),onDidChangeEnableStates:g.a.event.bind(g)};this.e=Object.freeze(d)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let g=this.f;this.f=void 0,Promise.resolve(g.flush()).then(g=void 0),this.e=void 0}else this.f=void 0}}e.$7Q=c;function m(b){const g=Date.now()-new Date(b).getTime();return isNaN(g)?!1:g<1e3*60*60*24}e.$9Q=(0,t.$Ki)("IExtHostTelemetry")}),define(Oe[273],Le([1,0,6,4,38,133,22,5]),function(ue,e,t,i,E,I,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IH=e.ActivationKind=e.$FH=e.$EH=e.$BH=e.ExtensionHostStartup=e.$AH=e.$zH=e.$yH=e.$xH=void 0,e.$CH=p,e.$DH=$,e.$GH=b,e.$HH=g,e.$xH=Object.freeze({identifier:new D.$zn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:i.URI.parse("void:location"),isBuiltin:!1,targetPlatform:D.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$yH="extensions.webWorker",e.$zH=(0,T.$Ki)("extensionService");class v{constructor(o){this.dependency=o}}e.$AH=v;var s;(function(w){w[w.EagerAutoStart=1]="EagerAutoStart",w[w.EagerManualStart=2]="EagerManualStart",w[w.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class S{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,l,n){this.c=o,this.d=l.slice(0),this.e=n.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:I.$jH.createActivationEventsMap(this.d)}}set(o,l,n){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const u=[],r=[],f=[],h=[],k=y(this.d),P=y(l),O=(Q,J)=>Q.extensionLocation.toString()===J.extensionLocation.toString()||Q.isBuiltin===J.isBuiltin||Q.isUserBuiltin===J.isUserBuiltin||Q.isUnderDevelopment===J.isUnderDevelopment;for(const Q of this.d){const J=P.get(Q.identifier);if(!J){u.push(Q.identifier),k.delete(Q.identifier);continue}if(!O(Q,J)){u.push(Q.identifier),k.delete(Q.identifier);continue}}for(const Q of l){const J=k.get(Q.identifier);if(!J){r.push(Q);continue}if(!O(J,Q)){u.push(J.identifier),k.delete(J.identifier);continue}}const C=new D.$An(this.e),L=new D.$An(n);for(const Q of this.e)L.has(Q)||f.push(Q);for(const Q of n)C.has(Q)||h.push(Q);const R=I.$jH.createActivationEventsMap(r),z={versionId:o,toRemove:u,toAdd:r,addActivationEvents:R,myToRemove:f,myToAdd:h};return this.delta(z),z}delta(o){if(this.c>=o.versionId)return null;const{toRemove:l,toAdd:n,myToRemove:u,myToAdd:r}=o,f=new D.$An(l),h=new D.$An(u);for(let k=0;k<this.d.length;k++)f.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)h.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of n)this.d.push(k);for(const k of r)this.e.push(k);return this.f=null,o}containsExtension(o){for(const l of this.e)if(D.$zn.equals(l,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const l of this.d){if(!this.containsExtension(l.identifier))continue;const n=I.$jH.readActivationEvents(l);for(const u of n)o.add(u)}return o}}e.$BH=S;function y(w){const o=new D.$Bn;for(const l of w)o.set(l.identifier,l);return o}function p(w,o){return!0}function $(w,o){if(!p(w,o))throw new Error(`Extension '${w.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${w.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${w.identifier.value}`)}class a{constructor(o,l,n,u){this.codeLoadingTime=o,this.activateCallTime=l,this.activateResolvedTime=n,this.activationReason=u}}e.$EH=a;class c{constructor(o,l){this.description=o,this.value=l}}e.$FH=c;var m;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function b(w){return{type:w.isBuiltin?D.ExtensionType.System:D.ExtensionType.User,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,E.$Zp)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation,targetPlatform:w.targetPlatform,validations:[],isValid:!0}}function g(w,o){const l=(0,E.$Xp)(w.manifest.publisher,w.manifest.name);return{id:l,identifier:new D.$zn(l),isBuiltin:w.type===D.ExtensionType.System,isUserBuiltin:w.type===D.ExtensionType.User&&w.isBuiltin,isUnderDevelopment:!!o,extensionLocation:w.location,uuid:w.identifier.uuid,targetPlatform:w.targetPlatform,publisherDisplayName:w.publisherDisplayName,...w.manifest}}class d{constructor(){this.onDidRegisterExtensions=t.Event.None,this.onDidChangeExtensionsStatus=t.Event.None,this.onDidChangeExtensions=t.Event.None,this.onWillActivateByEvent=t.Event.None,this.onDidChangeResponsiveChange=t.Event.None,this.onWillStop=t.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,l){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,l){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$IH=d});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[274],Le([1,0,7,9,58,30,130,37,22,29,133,121]),function(ue,e,t,i,E,I,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=void 0,t=We(t),E=$t(E);const p=T.$zo.as(D.$Ao.JSONContribution);class ${constructor(o,l,n){this.a=o,this.b=l,this.c=n}d(o,l){this.a({type:o,message:l,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(E.default.Error,o)}warn(o){this.d(E.default.Warning,o)}info(o){this.d(E.default.Info,o)}}e.$rH=$;class a{static a(o){const l=new v.$An;for(let n=0,u=o.length;n<u;n++)l.add(o[n].description.identifier);return l}static compute(o,l){if(!o||!o.length)return new a(l,[]);if(!l||!l.length)return new a([],o);const n=this.a(o),u=this.a(l),r=l.filter(h=>!n.has(h.description.identifier)),f=o.filter(h=>!u.has(h.description.identifier));return new a(r,f)}constructor(o,l){this.added=o,this.removed=l}}e.$sH=a;class c{constructor(o,l){this.name=o,this.defaultExtensionKind=l,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");return this.a=o,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(o){this.c=a.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,i.$4)(o)}}}e.$tH=c;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[t.localize(12282,null),t.localize(12283,null)]},b="vscode://schemas/vscode-extensions";e.$uH={properties:{engines:{type:"object",description:t.localize(12284,null),properties:{vscode:{type:"string",description:t.localize(12285,null),default:"^1.22.0"}}},publisher:{description:t.localize(12286,null),type:"string"},displayName:{description:t.localize(12287,null),type:"string"},categories:{description:t.localize(12288,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:v.$yn},{type:"string",const:"Languages",deprecationMessage:t.localize(12289,null)}]}},galleryBanner:{type:"object",description:t.localize(12290,null),properties:{color:{description:t.localize(12291,null),type:"string"},theme:{description:t.localize(12292,null),type:"string",enum:["dark","light"]}}},contributes:{description:t.localize(12293,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:t.localize(12294,null)},enableProposedApi:{type:"boolean",deprecationMessage:t.localize(12295,null)},enabledApiProposals:{markdownDescription:t.localize(12296,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(w=>w),markdownEnumDescriptions:Object.values(y.allApiProposals).map(w=>w.proposal)}},api:{markdownDescription:t.localize(12297,null),type:"string",enum:["none"],enumDescriptions:[t.localize(12298,null)]},activationEvents:{description:t.localize(12299,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:t.localize(12300,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:t.localize(12301,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:t.localize(12302,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:t.localize(12303,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:t.localize(12304,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:t.localize(12305,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:t.localize(12306,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:t.localize(12307,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:t.localize(12308,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:t.localize(12309,null),body:"onStartupFinished"},{label:"onTaskType",description:t.localize(12310,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:t.localize(12311,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:t.localize(12312,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:t.localize(12313,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:t.localize(12314,null)},{label:"onUri",body:"onUri",description:t.localize(12315,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:t.localize(12316,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:t.localize(12317,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:t.localize(12318,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:t.localize(12319,null)},{label:"onRenderer",description:t.localize(12320,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:t.localize(12321,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:t.localize(12322,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:t.localize(12323,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:t.localize(12324,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:t.localize(12325,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolId}",description:t.localize(12326,null)},{label:"*",description:t.localize(12327,null),body:"*"}]}},badges:{type:"array",description:t.localize(12328,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:t.localize(12329,null)},href:{type:"string",description:t.localize(12330,null)},description:{type:"string",description:t.localize(12331,null)}}}},markdown:{type:"string",description:t.localize(12332,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:t.localize(12333,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:t.localize(12334,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$gp}},extensionPack:{description:t.localize(12335,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$gp}},extensionKind:{description:t.localize(12336,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:t.localize(12337,null)},{body:["workspace"],description:t.localize(12338,null)},{body:["ui","workspace"],description:t.localize(12339,null)},{body:["workspace","ui"],description:t.localize(12340,null)},{body:[],description:t.localize(12341,null)}]},capabilities:{description:t.localize(12342,null),type:"object",properties:{virtualWorkspaces:{description:t.localize(12343,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:t.localize(12344,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[t.localize(12345,null),t.localize(12346,null),t.localize(12347,null)]},description:{type:"string",markdownDescription:t.localize(12348,null)}}},untrustedWorkspaces:{description:t.localize(12349,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:t.localize(12350,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[t.localize(12351,null),t.localize(12352,null),t.localize(12353,null)]},restrictedConfigurations:{description:t.localize(12354,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:t.localize(12355,null)}}}}},sponsor:{description:t.localize(12356,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:t.localize(12357,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:t.localize(12358,null),type:"string"},"vscode:uninstall":{description:t.localize(12359,null),type:"string"}}},icon:{type:"string",description:t.localize(12360,null)},l10n:{type:"string",description:t.localize(12361,null)},pricing:{type:"string",markdownDescription:t.localize(12362,null),enum:["Free","Trial"],default:"Free"}}};class g{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const l=new c(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,l),o.activationEventsGenerator&&S.$jH.register(o.extensionPoint,o.activationEventsGenerator),e.$uH.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,p.registerSchema(b,e.$uH),l}getExtensionPoints(){return Array.from(this.a.values())}}e.$vH=g;const d={ExtensionsRegistry:"ExtensionsRegistry"};T.$zo.add(d.ExtensionsRegistry,new g),e.$wH=T.$zo.as(d.ExtensionsRegistry),p.registerSchema(b,e.$uH),p.registerSchema(s.$zk,{properties:{extensionEnabledApiProposals:{description:t.localize(12363,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(w=>w.proposal)}}]}}}})}),define(Oe[275],Le([1,0,6,39,2,16,7,22,5,11,273,274]),function(ue,e,t,i,E,I,D,T,v,s,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LH=e.$KH=e.$JH=e.ChatMessageRole=void 0;var p;(function(c){c[c.System=0]="System",c[c.User=1]="User",c[c.Assistant=2]="Assistant"})(p||(e.ChatMessageRole=p={})),e.$JH=(0,v.$Ki)("ILanguageModelsService");const $={type:"object",properties:{vendor:{type:"string",description:(0,D.localize)(4744,null)}}};e.$KH=y.$wH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,D.localize)(4745,null),oneOf:[$,{type:"array",items:$}]},activationEventsGenerator:(c,m)=>{for(const b of c)m.push(`onLanguageModelChat:${b.vendor}`)}});let a=class{constructor(m,b){this.e=m,this.f=b,this.a=new E.$Yc,this.b=new Map,this.c=new Set,this.d=this.a.add(new t.$qe),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$KH.setHandler(g=>{this.c.clear();for(const w of g){if(!(0,S.$CH)(w.description,"chatProvider")){w.collector.error((0,D.localize)(4746,null));continue}for(const o of i.Iterable.wrap(w.value)){if(this.c.has(o.vendor)){w.collector.error((0,D.localize)(4747,null,o.vendor));continue}if((0,I.$hf)(o.vendor)){w.collector.error((0,D.localize)(4748,null));continue}if(o.vendor.trim()!==o.vendor){w.collector.error((0,D.localize)(4749,null));continue}this.c.add(o.vendor)}}const d=[];for(const[w,o]of this.b)this.c.has(o.metadata.vendor)||(this.b.delete(w),d.push(w));d.length>0&&this.d.fire({removed:d})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const g=Array.from(this.c).map(d=>this.e.activateByEvent(`onLanguageModelChat:${d}`));await Promise.all(g)}const b=[];for(const[g,d]of this.b)(m.vendor===void 0||d.metadata.vendor===m.vendor)&&(m.family===void 0||d.metadata.family===m.family)&&(m.version===void 0||d.metadata.version===m.version)&&(m.identifier===void 0||d.metadata.id===m.identifier)&&(!d.metadata.targetExtensions||d.metadata.targetExtensions.some(w=>T.$zn.equals(w,m.extension)))&&b.push(g);return this.f.trace("[LM] selected language models",m,b),b}registerLanguageModelChat(m,b){if(this.f.trace("[LM] registering language model chat",m,b.metadata),!this.c.has(b.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${b.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,b),this.d.fire({added:[{identifier:m,metadata:b.metadata}]}),(0,E.$Xc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,b.metadata))})}async sendChatRequest(m,b,g,d,w){const o=this.b.get(m);if(!o)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return o.sendChatRequest(g,b,d,w)}computeTokenLength(m,b,g){const d=this.b.get(m);if(!d)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return d.provideTokenCount(b,g)}};e.$LH=a,e.$LH=a=Ve([je(0,S.$zH),je(1,s.$fk)],a)}),define(Oe[276],Le([1,0,22,7,63]),function(ue,e,t,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eS=I,E=We(E);function I(D,T,v,s,S){const y=new t.$Bn;return D.forEach(p=>{const $=y.get(p.identifier);$&&S.warn((0,i.localize)(12364,null,$.extensionLocation.fsPath,p.extensionLocation.fsPath)),y.set(p.identifier,p)}),T.forEach(p=>{const $=y.get(p.identifier);if($)if($.isBuiltin){if(E.gte($.version,p.version)){S.warn(`Skipping extension ${p.extensionLocation.path} in favour of the builtin extension ${$.extensionLocation.path}.`);return}p.isBuiltin=!0}else S.warn((0,i.localize)(12365,null,$.extensionLocation.fsPath,p.extensionLocation.fsPath));else if(p.isBuiltin){S.warn(`Skipping obsolete builtin extension ${p.extensionLocation.path}`);return}y.set(p.identifier,p)}),v.forEach(p=>{const $=y.get(p.identifier);$&&S.warn((0,i.localize)(12366,null,$.extensionLocation.fsPath,p.extensionLocation.fsPath)),y.set(p.identifier,p)}),s.forEach(p=>{S.info((0,i.localize)(12367,null,p.extensionLocation.fsPath));const $=y.get(p.identifier);$&&$.isBuiltin&&(p.isBuiltin=!0),y.set(p.identifier,p)}),Array.from(y.values())}}),define(Oe[277],Le([1,0,8,3,32,4,44,60,41,64,22,276,12]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iS=e.$hS=void 0,i=We(i),D=We(D);class ${constructor(m,b,g,d,w,o,l){this.c=m,this.d=g,this.f=d,this.g=w,this.h=o,this.i=l,this.a=Promise.resolve(),this.b=Promise.resolve();const n=b.args["install-builtin-extension"];if(n){w.trace("Installing builtin extensions passed via args...");const r={isMachineScoped:!!b.args["do-not-sync"],installPreReleaseVersion:!!b.args["pre-release"]};D.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=m.installExtensions([],this.j(n),r,!!b.args.force).then(()=>{D.mark("code/server/didInstallBuiltinExtensions"),w.trace("Finished installing builtin extensions")},f=>{w.error(f)})}const u=b.args["install-extension"];u&&(w.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>m.installExtensions(this.j(u),[],{isMachineScoped:!!b.args["do-not-sync"],installPreReleaseVersion:!!b.args["pre-release"],isApplicationScoped:!0},!!b.args.force)).then(()=>{w.trace("Finished installing extensions")},r=>{w.error(r)}))}j(m){return m.map(b=>/\.vsix$/i.test(b)?I.URI.file((0,t.$nc)(b)?b:(0,t.$oc)((0,E.cwd)(),b)):b)}whenExtensionsReady(){return this.b}async scanExtensions(m,b,g,d,w){D.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${m}`),await this.a;const o=d?d.filter(n=>n.scheme===p.Schemas.file).map(n=>n.fsPath):void 0;b=b??this.d.defaultProfile.extensionsResource;const l=await this.k(b,m??i.$z,g,o,w);return this.g.trace("Scanned Extensions",l),this.r(l),D.mark("code/server/didScanExtensions"),l}async k(m,b,g,d,w){await this.q(b,w);const[o,l,n,u]=await Promise.all([this.n(b),this.o(m,b),this.m(b,g),this.l(b,d)]);return(0,y.$eS)(o,l,n,u,this.g)}async l(m,b){return b?(await Promise.all(b.map(g=>this.f.scanOneOrMultipleExtensions(I.URI.file((0,t.$pc)(g)),S.ExtensionType.User,{language:m})))).flat().map(g=>(0,s.$1q)(g,!0)):[]}async m(m,b){const g=[];if(b?.length){const d=await Promise.all(b.map(w=>this.f.scanExistingExtension(w,S.ExtensionType.User,{language:m})));for(const w of d)w&&g.push((0,s.$1q)(w,!1))}return g}async n(m){return(await this.f.scanSystemExtensions({language:m,useCache:!0})).map(g=>(0,s.$1q)(g,!1))}async o(m,b){return(await this.f.scanUserExtensions({profileLocation:m,language:b,useCache:!0})).map(d=>(0,s.$1q)(d,!1))}async q(m,b){if(!(m===i.$j||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(d=>d.id===m)){this.g.trace(`Language Pack ${m} is already installed. Skipping language pack installation.`);return}}catch(g){this.g.error(g)}if(!b){this.g.trace(`No language pack id provided for language ${m}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${b} for language ${m} is not installed. It will be installed now.`);try{await this.c.installExtensions([b],[],{isMachineScoped:!0},!0)}catch(g){this.g.error(g)}}}r(m){const b=(n,u)=>n.replace(/file/g,"vscode-remote"),g=n=>{let u="";return u+=n.global?"g":"",u+=n.ignoreCase?"i":"",u+=n.multiline?"m":"",new RegExp(b(n.source,!0),u)},d=new class{mapDefined(n){return v.$Nj.create(n)}mapNot(n){return v.$Sj.create(n)}mapEquals(n,u){return n==="resourceScheme"&&typeof u=="string"?v.$Oj.create(n,b(u,!1)):v.$Oj.create(n,u)}mapNotEquals(n,u){return n==="resourceScheme"&&typeof u=="string"?v.$Rj.create(n,b(u,!1)):v.$Rj.create(n,u)}mapGreater(n,u){return v.$Tj.create(n,u)}mapGreaterEquals(n,u){return v.$Uj.create(n,u)}mapSmaller(n,u){return v.$Vj.create(n,u)}mapSmallerEquals(n,u){return v.$Wj.create(n,u)}mapRegex(n,u){return n==="resourceScheme"&&u?v.$Xj.create(n,g(u)):v.$Xj.create(n,u)}mapIn(n,u){return v.$Pj.create(n,u)}mapNotIn(n,u){return v.$Qj.create(n,u)}},w=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const u=v.$Ij.deserialize(n.when);if(!u)return;const r=u.map(d);n.when=r.serialize()},o=n=>{if(Array.isArray(n))for(const u of n)w(u);else w(n)},l=n=>{for(const u in n)o(n[u])};m.forEach(n=>{n.contributes&&(n.contributes.menus&&l(n.contributes.menus),n.contributes.keybindings&&o(n.contributes.keybindings),n.contributes.views&&l(n.contributes.views))})}}e.$hS=$;class a{constructor(m,b){this.a=m,this.b=b}listen(m,b){throw new Error("Invalid listen")}async call(m,b,g){const d=this.b(m);switch(b){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const w=g[0],o=g[1]?I.URI.revive(d.transformIncoming(g[1])):void 0,l=Array.isArray(g[2])?g[2].map(f=>I.URI.revive(d.transformIncoming(f))):void 0,n=Array.isArray(g[3])?g[3].map(f=>I.URI.revive(d.transformIncoming(f))):void 0,u=g[4];return(await this.a.scanExtensions(w,o,l,n,u)).map(f=>(0,T.$Wn)(f,d))}}throw new Error("Invalid call")}}e.$iS=a}),define(Oe[153],Le([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9w=e.$6w=void 0,e.$7w=E,e.$8w=I;class t{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++t.count}}e.$6w=t;const i=[];function E(T){const v=new t(T);return i[v.nid]=v,v}function I(T){return i[T].sid}class D{constructor(v){this.value=v}}e.$9w=D}),define(Oe[278],Le([1,0,153]),function(ue,e,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=e.$bO=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$aO=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var i;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(i||(e.TextEditorRevealType=i={}));var E;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput",c[c.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(E||(e.TabInputKind=E={}));var I;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var D;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(D||(e.WebviewEditorCapabilities=D={}));var T;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var v;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var s;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var S;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output",c[c.Hybrid=3]="Hybrid"})(S||(e.CandidatePortSource=S={}));class y{static{this.a=0}static mixin(m){return m._id=y.a++,m}}e.$aO=y;var p;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var $;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})($||(e.ISuggestResultDtoField=$={}));var a;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(a||(e.ExtHostTestingResource=a={})),e.$bO={MainThreadAuthentication:(0,t.$7w)("MainThreadAuthentication"),MainThreadBulkEdits:(0,t.$7w)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,t.$7w)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,t.$7w)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,t.$7w)("MainThreadChatAgents2"),MainThreadChatVariables:(0,t.$7w)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,t.$7w)("MainThreadChatSkills"),MainThreadClipboard:(0,t.$7w)("MainThreadClipboard"),MainThreadCommands:(0,t.$7w)("MainThreadCommands"),MainThreadComments:(0,t.$7w)("MainThreadComments"),MainThreadConfiguration:(0,t.$7w)("MainThreadConfiguration"),MainThreadConsole:(0,t.$7w)("MainThreadConsole"),MainThreadDebugService:(0,t.$7w)("MainThreadDebugService"),MainThreadDecorations:(0,t.$7w)("MainThreadDecorations"),MainThreadDiagnostics:(0,t.$7w)("MainThreadDiagnostics"),MainThreadDialogs:(0,t.$7w)("MainThreadDiaglogs"),MainThreadDocuments:(0,t.$7w)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,t.$7w)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,t.$7w)("MainThreadTextEditors"),MainThreadEditorInsets:(0,t.$7w)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,t.$7w)("MainThreadEditorTabs"),MainThreadErrors:(0,t.$7w)("MainThreadErrors"),MainThreadTreeViews:(0,t.$7w)("MainThreadTreeViews"),MainThreadDownloadService:(0,t.$7w)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,t.$7w)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,t.$7w)("MainThreadLanguages"),MainThreadLogger:(0,t.$7w)("MainThreadLogger"),MainThreadMessageService:(0,t.$7w)("MainThreadMessageService"),MainThreadOutputService:(0,t.$7w)("MainThreadOutputService"),MainThreadProgress:(0,t.$7w)("MainThreadProgress"),MainThreadQuickDiff:(0,t.$7w)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,t.$7w)("MainThreadQuickOpen"),MainThreadStatusBar:(0,t.$7w)("MainThreadStatusBar"),MainThreadSecretState:(0,t.$7w)("MainThreadSecretState"),MainThreadStorage:(0,t.$7w)("MainThreadStorage"),MainThreadSpeech:(0,t.$7w)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,t.$7w)("MainThreadTelemetry"),MainThreadTerminalService:(0,t.$7w)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,t.$7w)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,t.$7w)("MainThreadWebviews"),MainThreadWebviewPanels:(0,t.$7w)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,t.$7w)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,t.$7w)("MainThreadCustomEditors"),MainThreadUrls:(0,t.$7w)("MainThreadUrls"),MainThreadUriOpeners:(0,t.$7w)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,t.$7w)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,t.$7w)("MainThreadWorkspace"),MainThreadFileSystem:(0,t.$7w)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,t.$7w)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,t.$7w)("MainThreadExtensionService"),MainThreadSCM:(0,t.$7w)("MainThreadSCM"),MainThreadSearch:(0,t.$7w)("MainThreadSearch"),MainThreadShare:(0,t.$7w)("MainThreadShare"),MainThreadTask:(0,t.$7w)("MainThreadTask"),MainThreadWindow:(0,t.$7w)("MainThreadWindow"),MainThreadLabelService:(0,t.$7w)("MainThreadLabelService"),MainThreadNotebook:(0,t.$7w)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,t.$7w)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,t.$7w)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,t.$7w)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,t.$7w)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,t.$7w)("MainThreadInteractive"),MainThreadTheming:(0,t.$7w)("MainThreadTheming"),MainThreadTunnelService:(0,t.$7w)("MainThreadTunnelService"),MainThreadManagedSockets:(0,t.$7w)("MainThreadManagedSockets"),MainThreadTimeline:(0,t.$7w)("MainThreadTimeline"),MainThreadTesting:(0,t.$7w)("MainThreadTesting"),MainThreadLocalization:(0,t.$7w)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,t.$7w)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,t.$7w)("MainThreadAiEmbeddingVector")},e.$cO={ExtHostCommands:(0,t.$7w)("ExtHostCommands"),ExtHostConfiguration:(0,t.$7w)("ExtHostConfiguration"),ExtHostDiagnostics:(0,t.$7w)("ExtHostDiagnostics"),ExtHostDebugService:(0,t.$7w)("ExtHostDebugService"),ExtHostDecorations:(0,t.$7w)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,t.$7w)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,t.$7w)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,t.$7w)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,t.$7w)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,t.$7w)("ExtHostEditors"),ExtHostTreeViews:(0,t.$7w)("ExtHostTreeViews"),ExtHostFileSystem:(0,t.$7w)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,t.$7w)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,t.$7w)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,t.$7w)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,t.$7w)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,t.$7w)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,t.$7w)("ExtHostQuickDiff"),ExtHostStatusBar:(0,t.$7w)("ExtHostStatusBar"),ExtHostShare:(0,t.$7w)("ExtHostShare"),ExtHostExtensionService:(0,t.$7w)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,t.$7w)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,t.$7w)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,t.$7w)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,t.$7w)("ExtHostSCM"),ExtHostSearch:(0,t.$7w)("ExtHostSearch"),ExtHostTask:(0,t.$7w)("ExtHostTask"),ExtHostWorkspace:(0,t.$7w)("ExtHostWorkspace"),ExtHostWindow:(0,t.$7w)("ExtHostWindow"),ExtHostWebviews:(0,t.$7w)("ExtHostWebviews"),ExtHostWebviewPanels:(0,t.$7w)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,t.$7w)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,t.$7w)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,t.$7w)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,t.$7w)("ExtHostEditorTabs"),ExtHostProgress:(0,t.$7w)("ExtHostProgress"),ExtHostComments:(0,t.$7w)("ExtHostComments"),ExtHostSecretState:(0,t.$7w)("ExtHostSecretState"),ExtHostStorage:(0,t.$7w)("ExtHostStorage"),ExtHostUrls:(0,t.$7w)("ExtHostUrls"),ExtHostUriOpeners:(0,t.$7w)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,t.$7w)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,t.$7w)("ExtHostOutputService"),ExtHostLabelService:(0,t.$7w)("ExtHostLabelService"),ExtHostNotebook:(0,t.$7w)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,t.$7w)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,t.$7w)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,t.$7w)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,t.$7w)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,t.$7w)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,t.$7w)("ExtHostInteractive"),ExtHostChatAgents2:(0,t.$7w)("ExtHostChatAgents"),ExtHostChatVariables:(0,t.$7w)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,t.$7w)("ExtHostChatSkills"),ExtHostChatProvider:(0,t.$7w)("ExtHostChatProvider"),ExtHostSpeech:(0,t.$7w)("ExtHostSpeech"),ExtHostEmbeddings:(0,t.$7w)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,t.$7w)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,t.$7w)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,t.$7w)("ExtHostTheming"),ExtHostTunnelService:(0,t.$7w)("ExtHostTunnelService"),ExtHostManagedSockets:(0,t.$7w)("ExtHostManagedSockets"),ExtHostAuthentication:(0,t.$7w)("ExtHostAuthentication"),ExtHostTimeline:(0,t.$7w)("ExtHostTimeline"),ExtHostTesting:(0,t.$7w)("ExtHostTesting"),ExtHostTelemetry:(0,t.$7w)("ExtHostTelemetry"),ExtHostLocalization:(0,t.$7w)("ExtHostLocalization")}}),define(Oe[279],Le([1,0,14,25,12,122,5]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$QL=void 0,e.$RL=S,e.$SL=y,e.$TL=p,e.$UL=$,e.$QL=(0,D.$Ki)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${T.join("")}]+`),s=7;function S(c){if(c.scheme!==E.Schemas.vscodeNotebookCell)return;const m=c.fragment.indexOf("s");if(m<0)return;const b=parseInt(c.fragment.substring(0,m).replace(v,""),s),g=(0,t.$_e)(c.fragment.substring(m+1)).toString();if(!isNaN(b))return{handle:b,notebook:c.with({scheme:g,fragment:null})}}function y(c,m){const b=m.toString(s),d=`${b.length<T.length?T[b.length-1]:"z"}${b}s${(0,t.$af)(t.$Se.fromString(c.scheme),!0,!0)}`;return c.with({scheme:E.Schemas.vscodeNotebookCell,fragment:d})}function p(c){if(c.scheme!==E.Schemas.vscodeNotebookMetadata)return;const m=(0,t.$_e)(c.fragment).toString();return c.with({scheme:m,fragment:null})}function $(c){const m=`${(0,t.$af)(t.$Se.fromString(c.scheme),!0,!0)}`;return c.with({scheme:E.Schemas.vscodeNotebookMetadata,fragment:m})}class a{constructor(){this.a=new i.$Fc}getNotebook(m){if(m.scheme===E.Schemas.vscodeNotebookCell){const b=S(m);if(b){const g=this.a.get(b.notebook);if(g)return g}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$VL=a,(0,I.$2s)(e.$QL,a,I.InstantiationType.Delayed)}),define(Oe[154],Le([1,0,14,86,39,69,12,8,3,41,279]),function(ue,e,t,i,E,I,D,T,v,s,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$bM=e.CellStatusbarAlignment=e.$aM=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$0L=e.$9L=e.$7L=e.CellUri=e.NotebookUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$6L=e.$5L=e.$4L=e.$3L=e.CellKind=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=void 0,e.$8L=u,e.$$L=h,e.$_L=k,e.$cM=C,e.$dM=R,i=We(i),e.$WL="workbench.editor.notebook",e.$XL="workbench.editor.notebookTextDiffEditor",e.$YL="workbench.editor.notebookMultiTextDiffEditor",e.$ZL="workbench.editor.interactive",e.$1L="workbench.editor.repl",e.$2L="replNotebook.input.execute";var y;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(y||(e.CellKind=y={})),e.$3L=["application/json","application/javascript","text/html","image/svg+xml",I.$it.latex,I.$it.markdown,"image/png","image/jpeg",I.$it.text],e.$4L=[I.$it.latex,I.$it.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$it.text],e.$5L=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$6L="_notAvailable";var p;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var $;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var a;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(a||(e.NotebookExecutionState=a={}));var c;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var b;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(b||(e.NotebookCellsChangeType=b={}));var g;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(g||(e.SelectionStateType=g={}));var d;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var w;(function(B){B.scheme=D.Schemas.vscodeNotebookMetadata;function j(te){return(0,S.$UL)(te)}B.generate=j;function U(te){return(0,S.$TL)(te)}B.parse=U})(w||(e.NotebookUri=w={}));var o;(function(B){B.scheme=D.Schemas.vscodeNotebookCell;function j(_,X){return(0,S.$SL)(_,X)}B.generate=j;function U(_){return(0,S.$RL)(_)}B.parse=U;function te(_,X){return _.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${X??""},${_.scheme!==D.Schemas.file?_.scheme:""}`})}B.generateCellOutputUri=te;function le(_){if(_.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const X=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!X)return;const M=X[1]&&X[1]!==""?X[1]:void 0,A=X[2];return{outputId:M,notebook:_.with({scheme:A||D.Schemas.file,fragment:null})}}B.parseCellOutputUri=le;function ye(_,X,M){return B.generate(_,X).with({scheme:M})}B.generateCellPropertyUri=ye;function oe(_,X){if(_.scheme===X)return B.parse(_.with({scheme:B.scheme}))}B.parseCellPropertyUri=oe})(o||(e.CellUri=o={}));const l=B=>v.$l?B.replace(/\//g,"\\"):B;class n{constructor(j=[],U=e.$3L){this.e=U,this.d=[...new Set(j)].map(te=>({pattern:te,matches:i.$Fk(l(te))}))}sort(j){const U=new Map(E.Iterable.map(j,le=>[le,l(le)]));let te=[];for(const{matches:le}of this.d)for(const[ye,oe]of U)if(le(oe)){te.push(ye),U.delete(ye);break}return U.size&&(te=te.concat([...U.keys()].sort((le,ye)=>this.e.indexOf(le)-this.e.indexOf(ye)))),te}prioritize(j,U){const te=this.f(j);if(te===-1){this.d.unshift({pattern:j,matches:i.$Fk(l(j))});return}const le=new Set(U.map(oe=>this.f(oe,te)));le.delete(-1);const ye=Array.from(le).sort();this.d.splice(te+1,0,...ye.map(oe=>this.d[oe]));for(let oe=ye.length-1;oe>=0;oe--)this.d.splice(ye[oe],1)}toArray(){return this.d.map(j=>j.pattern)}f(j,U=this.d.length){const te=l(j);for(let le=0;le<U;le++)if(this.d[le].matches(te))return le;return-1}}e.$7L=n;function u(B,j,U,te=(le,ye)=>le===ye){const le=[];function ye(X,M,A){if(M===0&&A.length===0)return;const Y=le[le.length-1];Y&&Y.start+Y.deleteCount===X?(Y.deleteCount+=M,Y.toInsert.push(...A)):le.push({start:X,deleteCount:M,toInsert:A})}let oe=0,_=0;for(;;){if(oe===B.length){ye(oe,0,j.slice(_));break}if(_===j.length){ye(oe,B.length-oe,[]);break}const X=B[oe],M=j[_];if(te(X,M)){oe+=1,_+=1;continue}U(M)?(ye(oe,1,[]),oe+=1):(ye(oe,0,[M]),_+=1)}return le}e.$9L=new s.$2j("notebookEditorCursorAtBoundary","none"),e.$0L=new s.$2j("notebookEditorCursorAtLineBoundary","none");var r;(function(B){B.default="default",B.option="option"})(r||(e.NotebookEditorPriority=r={}));var f;(function(B){B.Cells="cells",B.Text="text",B.None="none"})(f||(e.NotebookFindScopeType=f={}));function h(B){const j=B;return!!((typeof j.include=="string"||i.$Gk(j.include))&&(typeof j.exclude=="string"||i.$Gk(j.exclude)))}function k(B,j,U){if(Array.isArray(B.viewType)&&B.viewType.indexOf(j)>=0||B.viewType===j)return!0;if(B.filenamePattern){const te=h(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,le=h(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(i.$Ek(te,(0,T.$sc)(U.fsPath).toLowerCase()))return!(le&&i.$Ek(le,(0,T.$sc)(U.fsPath).toLowerCase()))}return!1}e.$aM={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var P;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(P||(e.CellStatusbarAlignment=P={}));class O{static{this.d="notebook/"}static create(j){return`${O.d}${j}`}static parse(j){if(j.startsWith(O.d))return j.substring(O.d.length)}}e.$bM=O;function C(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const L=new TextDecoder;function R(B){const j=[];let U=!1;for(const oe of B)(j.length===0||U)&&(j.push(oe),U=!0);let te=J(j);const le=t.$Se.concat(j.map(oe=>t.$Se.wrap(oe))),ye=V(le);return te=te||ye.byteLength!==le.byteLength,{data:ye,didCompression:te}}e.$eM="\x1B[A";const z=e.$eM.split("").map(B=>B.charCodeAt(0)),Q=10;function J(B){let j=!1;return B.forEach((U,te)=>{if(te===0||U.length<e.$eM.length)return;const le=B[te-1],ye=U.subarray(0,e.$eM.length);if(ye[0]===z[0]&&ye[1]===z[1]&&ye[2]===z[2]){const oe=le.lastIndexOf(Q);if(oe===-1)return;j=!0,B[te-1]=le.subarray(0,oe),B[te]=U.subarray(e.$eM.length)}}),j}function x(B){let j=B;do B=j,j=B.replace(/[^\n]\x08/gm,"");while(j.length<B.length);return B}function ve(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const j=B.match(/^(.*)\r+/m)[1];let U=B.match(/\r+(.*)$/m)[1];U=U+j.slice(U.length,j.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,U)}return B}const be=8,se=13;function V(B){return!B.buffer.includes(be)&&!B.buffer.includes(se)?B:t.$Se.fromString(ve(x(L.decode(B.buffer))))}}),define(Oe[155],Le([1,0,17,9,113,25,69,16,10,4,23,22,15,90,154]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a){"use strict";var c,m,b,g,d,w,o,l,n,u,r,f,h,k,P,O,C;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$DQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$CQ=e.$BQ=e.$AQ=e.$zQ=e.$yQ=e.$xQ=e.$wQ=e.$vQ=e.LanguageModelChatMessageRole=e.$uQ=e.$tQ=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$sQ=e.$rQ=e.$qQ=e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=e.$iQ=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.$dQ=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$cQ=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.$3P=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$2P=e.$1P=e.$ZP=e.$YP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.TestRunProfileKind=e.TestResultState=e.$RP=e.$QP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$PP=e.NotebookVariablesRequestKind=e.$OP=e.$NP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$MP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.ColorThemeKind=e.$GP=e.$FP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$EP=e.QuickInputButtonLocation=e.$DP=e.DebugConsoleMode=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$xP=e.$wP=e.FileChangeType=e.$vP=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$uP=e.$tP=e.$sP=e.$rP=e.InlineCompletionTriggerKind=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.$eP=e.ConfigurationTarget=e.$dP=e.$cP=e.$bP=e.$aP=e.DocumentPasteTriggerKind=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$7O=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$6O=e.ViewBadge=e.ProgressLocation=e.$5O=e.$4O=e.TaskScope=e.ShellQuoting=e.$3O=e.$2O=e.$1O=e.TaskPanelKind=e.TaskRevealKind=e.$ZO=e.TerminalLocation=e.$YO=e.$XO=e.$WO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$VO=e.$UO=e.$TO=e.$SO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$QO=e.$PO=e.$OO=e.$NO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$MO=e.$LO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.LanguageStatusSeverity=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.CodeActionTriggerKind=e.$zO=e.$yO=e.SymbolTag=e.SymbolKind=e.$xO=e.$wO=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.DiagnosticSeverity=e.DiagnosticTag=e.$qO=e.$pO=e.FileEditType=e.$oO=e.$nO=e.$mO=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$lO=e.$kO=e.$jO=e.$gO=e.$fO=e.$eO=e.$dO=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$hO=be,e.$iO=se,e.$RO=et,e.$fP=Pn,e.$XP=$i;function L(F){return Object.assign(F,{apply:function(...ae){if(ae.length===0)return Reflect.construct(F,[]);{const ke=ae.length===1?[]:ae[1];return Reflect.construct(F,ke,ae[0].constructor)}},call:function(...ae){if(ae.length===0)return Reflect.construct(F,[]);{const[ke,...Ke]=ae;return Reflect.construct(F,Ke,ke.constructor)}}})}var R;(function(F){F[F.Top=0]="Top",F[F.Bottom=1]="Bottom"})(R||(e.TerminalOutputAnchor=R={}));var z;(function(F){F[F.TerminalCommand=0]="TerminalCommand",F[F.Opener=1]="Opener",F[F.Command=3]="Command"})(z||(e.TerminalQuickFixType=z={}));let Q=c=class{static from(...N){let ae=N;return new c(function(){if(ae){for(const ke of ae)ke&&typeof ke.dispose=="function"&&ke.dispose();ae=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$dO=Q,e.$dO=Q=c=Ve([L],Q);let J=m=class{static Min(...N){if(N.length===0)throw new TypeError;let ae=N[0];for(let ke=1;ke<N.length;ke++){const Ke=N[ke];Ke.isBefore(ae)&&(ae=Ke)}return ae}static Max(...N){if(N.length===0)throw new TypeError;let ae=N[0];for(let ke=1;ke<N.length;ke++){const Ke=N[ke];Ke.isAfter(ae)&&(ae=Ke)}return ae}static isPosition(N){if(!N)return!1;if(N instanceof m)return!0;const{line:ae,character:ke}=N;return typeof ae=="number"&&typeof ke=="number"}static of(N){if(N instanceof m)return N;if(this.isPosition(N))return new m(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,ae){if(N<0)throw(0,i.$$)("line must be non-negative");if(ae<0)throw(0,i.$$)("character must be non-negative");this.c=N,this.e=ae}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,ae=0){if(N===null||ae===null)throw(0,i.$$)();let ke;return typeof N>"u"?ke=0:typeof N=="number"?ke=N:(ke=typeof N.lineDelta=="number"?N.lineDelta:0,ae=typeof N.characterDelta=="number"?N.characterDelta:0),ke===0&&ae===0?this:new m(this.line+ke,this.character+ae)}with(N,ae=this.character){if(N===null||ae===null)throw(0,i.$$)();let ke;return typeof N>"u"?ke=this.line:typeof N=="number"?ke=N:(ke=typeof N.line=="number"?N.line:this.line,ae=typeof N.character=="number"?N.character:this.character),ke===this.line&&ae===this.character?this:new m(ke,ae)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$eO=J,e.$eO=J=m=Ve([L],J);let x=b=class{static isRange(N){return N instanceof b?!0:N?J.isPosition(N.start)&&J.isPosition(N.end):!1}static of(N){if(N instanceof b)return N;if(this.isRange(N))return new b(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,ae,ke,Ke){let _e,lt;if(typeof N=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Ke=="number"?(_e=new J(N,ae),lt=new J(ke,Ke)):J.isPosition(N)&&J.isPosition(ae)&&(_e=J.of(N),lt=J.of(ae)),!_e||!lt)throw new Error("Invalid arguments");_e.isBefore(lt)?(this.c=_e,this.e=lt):(this.c=lt,this.e=_e)}contains(N){return b.isRange(N)?this.contains(N.start)&&this.contains(N.end):J.isPosition(N)?!(J.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const ae=J.Max(N.start,this.c),ke=J.Min(N.end,this.e);if(!ae.isAfter(ke))return new b(ae,ke)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ae=J.Min(N.start,this.c),ke=J.Max(N.end,this.end);return new b(ae,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,ae=this.end){if(N===null||ae===null)throw(0,i.$$)();let ke;return N?J.isPosition(N)?ke=N:(ke=N.start||this.start,ae=N.end||this.end):ke=this.start,ke.isEqual(this.c)&&ae.isEqual(this.end)?this:new b(ke,ae)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return be(this)}};e.$fO=x,e.$fO=x=b=Ve([L],x);let ve=g=class extends x{static isSelection(N){return N instanceof g?!0:N?x.isRange(N)&&J.isPosition(N.anchor)&&J.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,ae,ke,Ke){let _e,lt;if(typeof N=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Ke=="number"?(_e=new J(N,ae),lt=new J(ke,Ke)):J.isPosition(N)&&J.isPosition(ae)&&(_e=J.of(N),lt=J.of(ae)),!_e||!lt)throw new Error("Invalid arguments");super(_e,lt),this.f=_e,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return se(this)}};e.$gO=ve,e.$gO=ve=g=Ve([L],ve);function be(F){return F.isEmpty?`[${F.start.line}:${F.start.character})`:`[${F.start.line}:${F.start.character} -> ${F.end.line}:${F.end.character})`}function se(F){let N=be(F);return F.isEmpty||(F.active.isEqual(F.start)?N=`|${N}`:N=`${N}|`),N}const V=F=>{if(typeof F!="string"||F.length===0||!/^[0-9A-Za-z_\-]+$/.test(F))throw(0,i.$$)("connectionToken")};class B{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ae,ke){if(typeof N!="string"||N.length===0)throw(0,i.$$)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,i.$$)("port");typeof ke<"u"&&V(ke),this.host=N,this.port=Math.round(ae),this.connectionToken=ke}}e.$jO=B;class j{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ae){this.makeConnection=N,this.connectionToken=ae,typeof ae<"u"&&V(ae)}}e.$kO=j;class U extends Error{static NotAvailable(N,ae){return new U(N,$.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(N){return new U(N,$.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ae=$.RemoteAuthorityResolverErrorCode.Unknown,ke){super(N),this._message=N,this._code=ae,this._detail=ke,Object.setPrototypeOf(this,U.prototype)}}e.$lO=U;var te;(function(F){F[F.LF=1]="LF",F[F.CRLF=2]="CRLF"})(te||(e.EndOfLine=te={}));var le;(function(F){F[F.Replace=1]="Replace",F[F.Append=2]="Append",F[F.Prepend=3]="Prepend"})(le||(e.EnvironmentVariableMutatorType=le={}));let ye=d=class{static isTextEdit(N){return N instanceof d?!0:N?x.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ae){return new d(N,ae)}static insert(N,ae){return d.replace(new x(N,N),ae)}static delete(N){return d.replace(N,"")}static setEndOfLine(N){const ae=new d(new x(new J(0,0),new J(0,0)),"");return ae.newEol=N,ae}get range(){return this.c}set range(N){if(N&&!x.isRange(N))throw(0,i.$$)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,i.$$)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,i.$$)("newEol");this.f=N}constructor(N,ae){this.c=N,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$mO=ye,e.$mO=ye=d=Ve([L],ye);let oe=w=class{static isNotebookCellEdit(N){return N instanceof w?!0:N?un.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ae){return new w(N,ae)}static insertCells(N,ae){return new w(new un(N,N),ae)}static deleteCells(N){return new w(N,[])}static updateCellMetadata(N,ae){const ke=new w(new un(N,N),[]);return ke.newCellMetadata=ae,ke}static updateNotebookMetadata(N){const ae=new w(new un(0,0),[]);return ae.newNotebookMetadata=N,ae}constructor(N,ae){this.range=N,this.newCells=ae}};e.$nO=oe,e.$nO=oe=w=Ve([L],oe);class _{static isSnippetTextEdit(N){return N instanceof _?!0:N?x.isRange(N.range)&&A.isSnippetString(N.snippet):!1}static replace(N,ae){return new _(N,ae)}static insert(N,ae){return _.replace(new x(N,N),ae)}constructor(N,ae){this.range=N,this.snippet=ae}}e.$oO=_;var X;(function(F){F[F.File=1]="File",F[F.Text=2]="Text",F[F.Cell=3]="Cell",F[F.CellReplace=5]="CellReplace",F[F.Snippet=6]="Snippet"})(X||(e.FileEditType=X={}));let M=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,ae,ke,Ke){this.c.push({_type:X.File,from:N,to:ae,options:ke,metadata:Ke})}createFile(N,ae,ke){this.c.push({_type:X.File,from:void 0,to:N,options:ae,metadata:ke})}deleteFile(N,ae,ke){this.c.push({_type:X.File,from:N,to:void 0,options:ae,metadata:ke})}e(N,ae,ke){this.c.push({_type:X.Cell,metadata:ke,uri:N,edit:{editType:a.CellEditType.DocumentMetadata,metadata:ae},notebookMetadata:ae})}f(N,ae,ke,Ke){const _e=ae.start,lt=ae.end;(_e!==lt||ke.length>0)&&this.c.push({_type:X.CellReplace,uri:N,index:_e,count:lt-_e,cells:ke,metadata:Ke})}g(N,ae,ke,Ke){this.c.push({_type:X.Cell,metadata:Ke,uri:N,edit:{editType:a.CellEditType.Metadata,index:ae,metadata:ke}})}replace(N,ae,ke,Ke){this.c.push({_type:X.Text,uri:N,edit:new ye(ae,ke),metadata:Ke})}insert(N,ae,ke,Ke){this.replace(N,new x(ae,ae),ke,Ke)}delete(N,ae,ke){this.replace(N,ae,"",ke)}has(N){return this.c.some(ae=>ae._type===X.Text&&ae.uri.toString()===N.toString())}set(N,ae){if(ae)for(const ke of ae){if(!ke)continue;let Ke,_e;Array.isArray(ke)?(Ke=ke[0],_e=ke[1]):Ke=ke,oe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(N,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(N,Ke.newNotebookMetadata,_e):this.f(N,Ke.range,Ke.newCells,_e):_.isSnippetTextEdit(Ke)?this.c.push({_type:X.Snippet,uri:N,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:X.Text,uri:N,edit:Ke,metadata:_e})}else{for(let ke=0;ke<this.c.length;ke++){const Ke=this.c[ke];switch(Ke._type){case X.Text:case X.Snippet:case X.Cell:case X.CellReplace:Ke.uri.toString()===N.toString()&&(this.c[ke]=void 0);break}}(0,t.$Mb)(this.c)}}get(N){const ae=[];for(const ke of this.c)ke._type===X.Text&&ke.uri.toString()===N.toString()&&ae.push(ke.edit);return ae}entries(){const N=new I.$Fc;for(const ae of this.c)if(ae._type===X.Text){let ke=N.get(ae.uri);ke||(ke=[ae.uri,[]],N.set(ae.uri,ke)),ke[1].push(ae.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$pO=M,e.$pO=M=Ve([L],M);let A=o=class{static isSnippetString(N){return N instanceof o?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=o.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ae=this.e++){if(typeof N=="function"){const ke=new o;ke.e=this.e,N(ke),this.e=ke.e,N=ke.value}else N=o.c(N);return this.value+="${",this.value+=ae,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ae=this.e++){const ke=N.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(N,ae){if(typeof ae=="function"){const ke=new o;ke.e=this.e,ae(ke),this.e=ke.e,ae=ke.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.$qO=A,e.$qO=A=o=Ve([L],A);var Y;(function(F){F[F.Unnecessary=1]="Unnecessary",F[F.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var pe;(function(F){F[F.Hint=3]="Hint",F[F.Information=2]="Information",F[F.Warning=1]="Warning",F[F.Error=0]="Error"})(pe||(e.DiagnosticSeverity=pe={}));let ne=l=class{static isLocation(N){return N instanceof l?!0:N?x.isRange(N.range)&&s.URI.isUri(N.uri):!1}constructor(N,ae){if(this.uri=N,ae)if(x.isRange(ae))this.range=x.of(ae);else if(J.isPosition(ae))this.range=new x(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$rO=ne,e.$rO=ne=l=Ve([L],ne);let ie=class{static is(N){return N?typeof N.message=="string"&&N.location&&x.isRange(N.location.range)&&s.URI.isUri(N.location.uri):!1}constructor(N,ae){this.location=N,this.message=ae}static isEqual(N,ae){return N===ae?!0:!N||!ae?!1:N.message===ae.message&&N.location.range.isEqual(ae.location.range)&&N.location.uri.toString()===ae.location.uri.toString()}};e.$sO=ie,e.$sO=ie=Ve([L],ie);let G=class{constructor(N,ae,ke=pe.Error){if(!x.isRange(N))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=N,this.message=ae,this.severity=ke}toJSON(){return{severity:pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ae){return N===ae?!0:!N||!ae?!1:N.message===ae.message&&N.severity===ae.severity&&N.code===ae.code&&N.severity===ae.severity&&N.source===ae.source&&N.range.isEqual(ae.range)&&(0,t.$yb)(N.tags,ae.tags)&&(0,t.$yb)(N.relatedInformation,ae.relatedInformation,ie.isEqual)}};e.$tO=G,e.$tO=G=Ve([L],G);let Z=class{constructor(N,ae){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ae}};e.$uO=Z,e.$uO=Z=Ve([L],Z);let ce=class extends Z{constructor(N,ae,ke,Ke){super(N,ae),this.canIncreaseVerbosity=ke,this.canDecreaseVerbosity=Ke}};e.$vO=ce,e.$vO=ce=Ve([L],ce);var we;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})(we||(e.HoverVerbosityAction=we={}));var Ie;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(Ie||(e.DocumentHighlightKind=Ie={}));let Me=class{constructor(N,ae=Ie.Text){this.range=N,this.kind=ae}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};e.$wO=Me,e.$wO=Me=Ve([L],Me);let Be=class{constructor(N,ae){this.uri=N,this.highlights=ae}toJSON(){return{uri:this.uri,highlights:this.highlights.map(N=>N.toJSON())}}};e.$xO=Be,e.$xO=Be=Ve([L],Be);var De;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(De||(e.SymbolKind=De={}));var Ne;(function(F){F[F.Deprecated=1]="Deprecated"})(Ne||(e.SymbolTag=Ne={}));let Te=n=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ae,ke,Ke,_e){this.name=N,this.kind=ae,this.containerName=_e,typeof ke=="string"&&(this.containerName=ke),Ke instanceof ne?this.location=Ke:ke instanceof x&&(this.location=new ne(Ke,ke)),n.validate(this)}toJSON(){return{name:this.name,kind:De[this.kind],location:this.location,containerName:this.containerName}}};e.$yO=Te,e.$yO=Te=n=Ve([L],Te);let Ce=u=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(u.validate)}constructor(N,ae,ke,Ke,_e){this.name=N,this.detail=ae,this.kind=ke,this.range=Ke,this.selectionRange=_e,this.children=[],u.validate(this)}};e.$zO=Ce,e.$zO=Ce=u=Ve([L],Ce);var de;(function(F){F[F.Invoke=1]="Invoke",F[F.Automatic=2]="Automatic"})(de||(e.CodeActionTriggerKind=de={}));let Se=class{constructor(N,ae){this.title=N,this.kind=ae}};e.$AO=Se,e.$AO=Se=Ve([L],Se);let Re=class{static{r=this}static{this.c="."}constructor(N){this.value=N}append(N){return new r(this.value?this.value+r.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+r.c)}};e.$BO=Re,e.$BO=Re=r=Ve([L],Re),Re.Empty=new Re(""),Re.QuickFix=Re.Empty.append("quickfix"),Re.Refactor=Re.Empty.append("refactor"),Re.RefactorExtract=Re.Refactor.append("extract"),Re.RefactorInline=Re.Refactor.append("inline"),Re.RefactorMove=Re.Refactor.append("move"),Re.RefactorRewrite=Re.Refactor.append("rewrite"),Re.Source=Re.Empty.append("source"),Re.SourceOrganizeImports=Re.Source.append("organizeImports"),Re.SourceFixAll=Re.Source.append("fixAll"),Re.Notebook=Re.Empty.append("notebook");let Ue=class{constructor(N,ae){if(this.range=N,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$CO=Ue,e.$CO=Ue=Ve([L],Ue);class Ge{constructor(N,ae,ke,Ke,_e,lt){this.kind=N,this.name=ae,this.detail=ke,this.uri=Ke,this.range=_e,this.selectionRange=lt}}e.$DO=Ge;class Qe{constructor(N,ae){this.fromRanges=ae,this.from=N}}e.$EO=Qe;class Je{constructor(N,ae){this.fromRanges=ae,this.to=N}}e.$FO=Je;var Xe;(function(F){F[F.Information=0]="Information",F[F.Warning=1]="Warning",F[F.Error=2]="Error"})(Xe||(e.LanguageStatusSeverity=Xe={}));let tt=class{constructor(N,ae){this.range=N,this.command=ae}get isResolved(){return!!this.command}};e.$GO=tt,e.$GO=tt=Ve([L],tt);let st=f=class{#e;static isMarkdownString(N){return N instanceof f?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ae=!1){this.#e=new E.$9k(N,{supportThemeIcons:ae})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,ae){return this.#e.appendCodeblock(ae??"",N),this}};e.$HO=st,e.$HO=st=f=Ve([L],st);let dt=class{constructor(N,ae){this.label=N,this.documentation=ae}};e.$IO=dt,e.$IO=dt=Ve([L],dt);let rt=class{constructor(N,ae){this.label=N,this.documentation=ae,this.parameters=[]}};e.$JO=rt,e.$JO=rt=Ve([L],rt);let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$KO=ot,e.$KO=ot=Ve([L],ot);var ut;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(ut||(e.SignatureHelpTriggerKind=ut={}));var Ye;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(Ye||(e.InlayHintKind=Ye={}));let me=class{constructor(N){this.value=N}};e.$LO=me,e.$LO=me=Ve([L],me);let H=class{constructor(N,ae,ke){this.position=N,this.label=ae,this.kind=ke}};e.$MO=H,e.$MO=H=Ve([L],H);var ee;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ee||(e.CompletionTriggerKind=ee={}));var ge;(function(F){F[F.Text=0]="Text",F[F.Method=1]="Method",F[F.Function=2]="Function",F[F.Constructor=3]="Constructor",F[F.Field=4]="Field",F[F.Variable=5]="Variable",F[F.Class=6]="Class",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Unit=10]="Unit",F[F.Value=11]="Value",F[F.Enum=12]="Enum",F[F.Keyword=13]="Keyword",F[F.Snippet=14]="Snippet",F[F.Color=15]="Color",F[F.File=16]="File",F[F.Reference=17]="Reference",F[F.Folder=18]="Folder",F[F.EnumMember=19]="EnumMember",F[F.Constant=20]="Constant",F[F.Struct=21]="Struct",F[F.Event=22]="Event",F[F.Operator=23]="Operator",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue"})(ge||(e.CompletionItemKind=ge={}));var re;(function(F){F[F.Deprecated=1]="Deprecated"})(re||(e.CompletionItemTag=re={}));let fe=class{constructor(N,ae){this.label=N,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$NO=fe,e.$NO=fe=Ve([L],fe);let W=class{constructor(N=[],ae=!1){this.items=N,this.isIncomplete=ae}};e.$OO=W,e.$OO=W=Ve([L],W);let K=class{constructor(N,ae,ke){this.insertText=N,this.range=ae,this.command=ke}};e.$PO=K,e.$PO=K=Ve([L],K);let $e=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$QO=$e,e.$QO=$e=Ve([L],$e);var Fe;(function(F){F[F.Unknown=0]="Unknown",F[F.Word=1]="Word",F[F.Line=2]="Line",F[F.Suggest=3]="Suggest"})(Fe||(e.PartialAcceptTriggerKind=Fe={}));var qe;(function(F){F[F.Active=-1]="Active",F[F.Beside=-2]="Beside",F[F.One=1]="One",F[F.Two=2]="Two",F[F.Three=3]="Three",F[F.Four=4]="Four",F[F.Five=5]="Five",F[F.Six=6]="Six",F[F.Seven=7]="Seven",F[F.Eight=8]="Eight",F[F.Nine=9]="Nine"})(qe||(e.ViewColumn=qe={}));var xe;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(xe||(e.StatusBarAlignment=xe={}));function et(F,N){return`${y.$zn.toKey(F)}.${N}`}var it;(function(F){F[F.Off=0]="Off",F[F.On=1]="On",F[F.Relative=2]="Relative",F[F.Interval=3]="Interval"})(it||(e.TextEditorLineNumbersStyle=it={}));var ct;(function(F){F[F.Manual=1]="Manual",F[F.AfterDelay=2]="AfterDelay",F[F.FocusOut=3]="FocusOut"})(ct||(e.TextDocumentSaveReason=ct={}));var mt;(function(F){F[F.Default=0]="Default",F[F.InCenter=1]="InCenter",F[F.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",F[F.AtTop=3]="AtTop"})(mt||(e.TextEditorRevealType=mt={}));var vt;(function(F){F[F.Keyboard=1]="Keyboard",F[F.Mouse=2]="Mouse",F[F.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var Ct;(function(F){F[F.Undo=1]="Undo",F[F.Redo=2]="Redo"})(Ct||(e.TextDocumentChangeReason=Ct={}));var gt;(function(F){F[F.OpenOpen=0]="OpenOpen",F[F.ClosedClosed=1]="ClosedClosed",F[F.OpenClosed=2]="OpenClosed",F[F.ClosedOpen=3]="ClosedOpen"})(gt||(e.DecorationRangeBehavior=gt={})),function(F){function N(ae){switch(ae){case"keyboard":return F.Keyboard;case"mouse":return F.Mouse;case"api":return F.Command}}F.fromValue=N}(vt||(e.TextEditorSelectionChangeKind=vt={}));var bt;(function(F){F[F.Other=0]="Other",F[F.Comment=1]="Comment",F[F.String=2]="String",F[F.RegEx=3]="RegEx"})(bt||(e.SyntaxTokenType=bt={})),function(F){function N(ae){switch(ae){case F.Other:return"other";case F.Comment:return"comment";case F.String:return"string";case F.RegEx:return"regex"}return"other"}F.toString=N}(bt||(e.SyntaxTokenType=bt={}));let pt=class{constructor(N,ae){if(ae&&!s.URI.isUri(ae))throw(0,i.$$)("target");if(!x.isRange(N)||N.isEmpty)throw(0,i.$$)("range");this.range=N,this.target=ae}};e.$SO=pt,e.$SO=pt=Ve([L],pt);let Nt=class{constructor(N,ae,ke,Ke){this.red=N,this.green=ae,this.blue=ke,this.alpha=Ke}};e.$TO=Nt,e.$TO=Nt=Ve([L],Nt);let jt=class{constructor(N,ae){if(ae&&!(ae instanceof Nt))throw(0,i.$$)("color");if(!x.isRange(N)||N.isEmpty)throw(0,i.$$)("range");this.range=N,this.color=ae}};e.$UO=jt,e.$UO=jt=Ve([L],jt);let Ft=class{constructor(N){if(!N||typeof N!="string")throw(0,i.$$)("label");this.label=N}};e.$VO=Ft,e.$VO=Ft=Ve([L],Ft);var Ht;(function(F){F[F.RGB=0]="RGB",F[F.HEX=1]="HEX",F[F.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var kt;(function(F){F[F.Error=0]="Error",F[F.Warning=1]="Warning",F[F.Information=2]="Information"})(kt||(e.SourceControlInputBoxValidationType=kt={}));var Wt;(function(F){F[F.Unknown=0]="Unknown",F[F.Shutdown=1]="Shutdown",F[F.Process=2]="Process",F[F.User=3]="User",F[F.Extension=4]="Extension"})(Wt||(e.TerminalExitReason=Wt={}));var Et;(function(F){F[F.Low=0]="Low",F[F.Medium=1]="Medium",F[F.High=2]="High"})(Et||(e.TerminalShellExecutionCommandLineConfidence=Et={}));class ft{constructor(N,ae,ke){if(this.startIndex=N,this.length=ae,this.tooltip=ke,typeof N!="number"||N<0)throw(0,i.$$)("startIndex");if(typeof ae!="number"||ae<1)throw(0,i.$$)("length");if(ke!==void 0&&typeof ke!="string")throw(0,i.$$)("tooltip")}}e.$WO=ft;class wt{constructor(N){this.uri=N}}e.$XO=wt;class Tt{constructor(N){this.terminalCommand=N}}e.$YO=Tt;var Mt;(function(F){F[F.Panel=1]="Panel",F[F.Editor=2]="Editor"})(Mt||(e.TerminalLocation=Mt={}));class Vt{constructor(N){if(this.options=N,typeof N!="object")throw(0,i.$$)("options")}}e.$ZO=Vt;var Qt;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(Qt||(e.TaskRevealKind=Qt={}));var Jt;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(Jt||(e.TaskPanelKind=Jt={}));let It=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(N){switch(N){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(N,ae){if(this.label=ae,typeof N!="string"||typeof ae!="string")throw(0,i.$$)("name");this.c=N}get id(){return this.c}};e.$1O=It,e.$1O=It=h=Ve([L],It);function Pt(F){let N="";for(let ae=0;ae<F.length;ae++)N+=F[ae].replace(/,/g,",,")+",";return N}let Rt=class{constructor(N,ae,ke){if(typeof N!="string")throw(0,i.$$)("process");this.e=[],this.c=N,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=ke):this.f=ae)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,i.$$)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)N.push(ae);return Pt(N)}};e.$2O=Rt,e.$2O=Rt=Ve([L],Rt);let zt=class{constructor(N,ae,ke){if(this.f=[],Array.isArray(ae)){if(!N)throw(0,i.$$)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,i.$$)("command");this.e=N,this.f=ae,this.g=ke}else{if(typeof N!="string")throw(0,i.$$)("commandLine");this.c=N,this.g=ae}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,i.$$)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,i.$$)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)N.push(typeof ae=="string"?ae:ae.value);return Pt(N)}};e.$3O=zt,e.$3O=zt=Ve([L],zt);var Ot;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(Ot||(e.ShellQuoting=Ot={}));var Gt;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace"})(Gt||(e.TaskScope=Gt={}));class Yt{constructor(N){this.c=N}computeId(){return"customExecution"+(0,S.$7g)()}set callback(N){this.c=N}get callback(){return this.c}}e.$4O=Yt;let Xt=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,ae,ke,Ke,_e,lt){this.k=!1,this.l=this.definition=N;let ht;typeof ae=="string"?(this.o=this.name=ae,this.w=this.source=ke,this.execution=Ke,ht=_e,this.k=!0):ae===Gt.Global||ae===Gt.Workspace?(this.target=ae,this.o=this.name=ke,this.w=this.source=Ke,this.execution=_e,ht=lt):(this.target=ae,this.o=this.name=ke,this.w=this.source=Ke,this.execution=_e,ht=lt),typeof ht=="string"?(this.r=[ht],this.t=!0):Array.isArray(ht)?(this.r=ht,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(N){this.j=N}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Rt?this.l={type:k.e,id:this.q.computeId()}:this.q instanceof zt?this.l={type:k.f,id:this.q.computeId()}:this.q instanceof Yt?this.l={type:k.c,id:this.q.computeId()}:this.l={type:k.g,id:(0,S.$7g)()}}get definition(){return this.l}set definition(N){if(N==null)throw(0,i.$$)("Kind can't be undefined or null");this.B(),this.l=N}get scope(){return this.m}set target(N){this.B(),this.m=N}get name(){return this.o}set name(N){if(typeof N!="string")throw(0,i.$$)("name");this.B(),this.o=N}get execution(){return this.q}set execution(N){N===null&&(N=void 0),this.B(),this.q=N;const ae=this.l.type;(k.g===ae||k.e===ae||k.f===ae||k.c===ae)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(N){if(Array.isArray(N))this.B(),this.r=N,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.B(),this.u=N}get source(){return this.w}set source(N){if(typeof N!="string"||N.length===0)throw(0,i.$$)("source must be a string of length > 0");this.B(),this.w=N}get group(){return this.x}set group(N){N===null&&(N=void 0),this.B(),this.x=N}get detail(){return this.A}set detail(N){N===null&&(N=void 0),this.A=N}get presentationOptions(){return this.y}set presentationOptions(N){N==null&&(N=Object.create(null)),this.B(),this.y=N}get runOptions(){return this.z}set runOptions(N){N==null&&(N=Object.create(null)),this.B(),this.z=N}};e.$5O=Xt,e.$5O=Xt=k=Ve([L],Xt);var xt;(function(F){F[F.SourceControl=1]="SourceControl",F[F.Window=10]="Window",F[F.Notification=15]="Notification"})(xt||(e.ProgressLocation=xt={}));var Ut;(function(F){function N(ae){const ke=ae;return(0,v.$ng)(ke.value)?ke.tooltip&&!(0,v.$jg)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}F.isViewBadge=N})(Ut||(e.ViewBadge=Ut={}));let Kt=P=class{static isTreeItem(N,ae){const ke=N;if(ke.checkboxState!==void 0){const Ke=(0,v.$ng)(ke.checkboxState)?ke.checkboxState:(0,v.$lg)(ke.checkboxState)&&(0,v.$ng)(ke.checkboxState.state)?ke.checkboxState.state:void 0,_e=!(0,v.$ng)(ke.checkboxState)&&(0,v.$lg)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Bt.Checked&&Ke!==Bt.Unchecked||_e!==void 0&&!(0,v.$jg)(_e))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(N instanceof P)return!0;if(ke.label!==void 0&&!(0,v.$jg)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,v.$jg)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,v.$jg)(ke.iconPath)&&!s.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,v.$jg)(ke.iconPath.id))){const Ke=ke.iconPath;if(!Ke||!(0,v.$jg)(Ke.light)&&!s.URI.isUri(Ke.light)&&!(0,v.$jg)(Ke.dark)&&!s.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,v.$jg)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!s.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,v.$jg)(ke.tooltip)&&!(ke.tooltip instanceof st)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<yt.None&&ke.collapsibleState>yt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,v.$jg)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(N,ae=yt.None){this.collapsibleState=ae,s.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$6O=Kt,e.$6O=Kt=P=Ve([L],Kt);var yt;(function(F){F[F.None=0]="None",F[F.Collapsed=1]="Collapsed",F[F.Expanded=2]="Expanded"})(yt||(e.TreeItemCollapsibleState=yt={}));var Bt;(function(F){F[F.Unchecked=0]="Unchecked",F[F.Checked=1]="Checked"})(Bt||(e.TreeItemCheckboxState=Bt={}));let qt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$7O=qt,e.$7O=qt=Ve([L],qt);class an extends qt{}e.$8O=an;class ln extends an{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$9O=ln;class wn{constructor(N,ae,ke,Ke){this.name=N,this.uri=ae,this._itemId=ke,this.c=Ke}data(){return this.c()}}e.$0O=wn;let cn=class{#e=new Map;constructor(N){for(const[ae,ke]of N??[]){const Ke=this.#e.get(this.#t(ae));Ke?Ke.push(ke):this.#e.set(this.#t(ae),[ke])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,ae){this.#e.set(this.#t(N),[ae])}forEach(N,ae){for(const[ke,Ke]of this.#e)for(const _e of Ke)N.call(ae,_e,ke,this)}*[Symbol.iterator](){for(const[N,ae]of this.#e)for(const ke of ae)yield[N,ke]}#t(N){return N.toLowerCase()}};e.$$O=cn,e.$$O=cn=Ve([L],cn);let fn=class{constructor(N,ae,ke){this.insertText=N,this.title=ae,this.kind=ke}};e.$_O=fn,e.$_O=fn=Ve([L],fn);var yn;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(yn||(e.DocumentPasteTriggerKind=yn={}));class tn{static{this.c="."}constructor(N){this.value=N}append(...N){return new tn((this.value?[this.value,...N]:N).join(tn.c))}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+tn.c)}}e.$aP=tn,tn.Empty=new tn("");class vn{constructor(N,ae,ke){this.title=ae,this.insertText=N,this.kind=ke}}e.$bP=vn;let Zt=class{constructor(N,ae){this.id=N,this.color=ae}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$cP=Zt,e.$cP=Zt=Ve([L],Zt),Zt.File=new Zt("file"),Zt.Folder=new Zt("folder");let dn=class{constructor(N){this.id=N}};e.$dP=dn,e.$dP=dn=Ve([L],dn);var En;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.WorkspaceFolder=3]="WorkspaceFolder"})(En||(e.ConfigurationTarget=En={}));let mn=class{get base(){return this.c}set base(N){this.c=N,this.e=s.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,ae){if(typeof N!="string"&&(!N||!s.URI.isUri(N)&&!s.URI.isUri(N.uri)))throw(0,i.$$)("base");if(typeof ae!="string")throw(0,i.$$)("pattern");typeof N=="string"?this.baseUri=s.URI.file(N):s.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$eP=mn,e.$eP=mn=Ve([L],mn);const Sn=new WeakMap;function Pn(F,N){Sn.set(F,N)}let sn=class{constructor(N,ae,ke,Ke,_e){this.enabled=typeof N=="boolean"?N:!0,typeof ae=="string"&&(this.condition=ae),typeof ke=="string"&&(this.hitCondition=ke),typeof Ke=="string"&&(this.logMessage=Ke),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=Sn.get(this)??(0,S.$7g)()),this.c}};e.$gP=sn,e.$gP=sn=Ve([L],sn);let $n=class extends sn{constructor(N,ae,ke,Ke,_e,lt){if(super(ae,ke,Ke,_e,lt),N===null)throw(0,i.$$)("location");this.location=N}};e.$hP=$n,e.$hP=$n=Ve([L],$n);let gn=class extends sn{constructor(N,ae,ke,Ke,_e,lt){super(ae,ke,Ke,_e,lt),this.functionName=N}};e.$iP=gn,e.$iP=gn=Ve([L],gn);let pn=class extends sn{constructor(N,ae,ke,Ke,_e,lt,ht,At){if(super(Ke,_e,lt,ht,At),!ae)throw(0,i.$$)("dataId");this.label=N,this.dataId=ae,this.canPersist=ke}};e.$jP=pn,e.$jP=pn=Ve([L],pn);let bn=class{constructor(N,ae,ke){this.command=N,this.args=ae||[],this.options=ke}};e.$kP=bn,e.$kP=bn=Ve([L],bn);let Ee=class{constructor(N,ae){this.port=N,this.host=ae}};e.$lP=Ee,e.$lP=Ee=Ve([L],Ee);let Ae=class{constructor(N){this.path=N}};e.$mP=Ae,e.$mP=Ae=Ve([L],Ae);let he=class{constructor(N){this.implementation=N}};e.$nP=he,e.$nP=he=Ve([L],he);class q{constructor(N,ae,ke){this.session=N,this.threadId=ae,this.frameId=ke}}e.$oP=q;class Pe{constructor(N,ae){this.session=N,this.threadId=ae}}e.$pP=Pe;let He=class{constructor(N,ae){this.range=N,this.expression=ae}};e.$qP=He,e.$qP=He=Ve([L],He);var Ze;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Ze||(e.InlineCompletionTriggerKind=Ze={}));let ze=class{constructor(N,ae){this.range=N,this.text=ae}};e.$rP=ze,e.$rP=ze=Ve([L],ze);let nt=class{constructor(N,ae,ke=!0){this.range=N,this.variableName=ae,this.caseSensitiveLookup=ke}};e.$sP=nt,e.$sP=nt=Ve([L],nt);let at=class{constructor(N,ae){this.range=N,this.expression=ae}};e.$tP=at,e.$tP=at=Ve([L],at);let Lt=class{constructor(N,ae){this.frameId=N,this.stoppedLocation=ae}};e.$uP=Lt,e.$uP=Lt=Ve([L],Lt);var St;(function(F){F[F.AIGenerated=1]="AIGenerated"})(St||(e.NewSymbolNameTag=St={}));var Dt;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Dt||(e.NewSymbolNameTriggerKind=Dt={}));class Rn{constructor(N,ae){this.newSymbolName=N,this.tags=ae}}e.$vP=Rn;var Vn;(function(F){F[F.Changed=1]="Changed",F[F.Created=2]="Created",F[F.Deleted=3]="Deleted"})(Vn||(e.FileChangeType=Vn={}));let Cn=O=class extends Error{static FileExists(N){return new O(N,p.FileSystemProviderErrorCode.FileExists,O.FileExists)}static FileNotFound(N){return new O(N,p.FileSystemProviderErrorCode.FileNotFound,O.FileNotFound)}static FileNotADirectory(N){return new O(N,p.FileSystemProviderErrorCode.FileNotADirectory,O.FileNotADirectory)}static FileIsADirectory(N){return new O(N,p.FileSystemProviderErrorCode.FileIsADirectory,O.FileIsADirectory)}static NoPermissions(N){return new O(N,p.FileSystemProviderErrorCode.NoPermissions,O.NoPermissions)}static Unavailable(N){return new O(N,p.FileSystemProviderErrorCode.Unavailable,O.Unavailable)}constructor(N,ae=p.FileSystemProviderErrorCode.Unknown,ke){super(s.URI.isUri(N)?N.toString(!0):N),this.code=ke?.name??"Unknown",(0,p.$ul)(this,ae),Object.setPrototypeOf(this,O.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$wP=Cn,e.$wP=Cn=O=Ve([L],Cn);let Nn=class{constructor(N,ae,ke){this.start=N,this.end=ae,this.kind=ke}};e.$xP=Nn,e.$xP=Nn=Ve([L],Nn);var Gn;(function(F){F[F.Comment=1]="Comment",F[F.Imports=2]="Imports",F[F.Region=3]="Region"})(Gn||(e.FoldingRangeKind=Gn={}));var Kn;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(Kn||(e.CommentThreadCollapsibleState=Kn={}));var Qn;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(Qn||(e.CommentMode=Qn={}));var Jn;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(Jn||(e.CommentState=Jn={}));var Xn;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(Xn||(e.CommentThreadState=Xn={}));var Zn;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(Zn||(e.CommentThreadApplicability=Zn={}));var Yn;(function(F){F[F.Reply=1]="Reply",F[F.Comment=2]="Comment"})(Yn||(e.CommentThreadFocus=Yn={}));class ji{constructor(N,ae=[]){this.tokenTypes=N,this.tokenModifiers=ae}}e.$yP=ji;function Fi(F){return typeof F>"u"||(0,v.$kg)(F)}class jn{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,N){this.m=!0;for(let ae=0,ke=N.tokenTypes.length;ae<ke;ae++)this.k.set(N.tokenTypes[ae],ae);for(let ae=0,ke=N.tokenModifiers.length;ae<ke;ae++)this.l.set(N.tokenModifiers[ae],ae)}}push(N,ae,ke,Ke,_e){if(typeof N=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(N,ae,ke,Ke,_e);if(x.isRange(N)&&typeof ae=="string"&&Fi(ke))return this.o(N,ae,ke);throw(0,i.$$)()}o(N,ae,ke){if(!this.m)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ke=N.start.line,_e=N.start.character,lt=N.end.character-N.start.character,ht=this.k.get(ae);let At=0;if(ke)for(const _t of ke){if(!this.l.has(_t))throw new Error("`tokenModifier` is not in the provided legend");const en=this.l.get(_t);At|=1<<en>>>0}this.q(Ke,_e,lt,ht,At)}q(N,ae,ke,Ke,_e){if(this.f&&(N<this.c||N===this.c&&ae<this.e)){this.f=!1;const At=this.g.length/5|0;let _t=0,en=0;for(let rn=0;rn<At;rn++){let on=this.g[5*rn],kn=this.g[5*rn+1];on===0?(on=_t,kn+=en):on+=_t,this.g[5*rn]=on,this.g[5*rn+1]=kn,_t=on,en=kn}}let lt=N,ht=ae;this.f&&this.j>0&&(lt-=this.c,lt===0&&(ht-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=ht,this.g[this.j++]=ke,this.g[this.j++]=Ke,this.g[this.j++]=_e,this.c=N,this.e=ae}static r(N){const ae=[],ke=N.length/5|0;for(let ht=0;ht<ke;ht++)ae[ht]=ht;ae.sort((ht,At)=>{const _t=N[5*ht],en=N[5*At];if(_t===en){const rn=N[5*ht+1],on=N[5*At+1];return rn-on}return _t-en});const Ke=new Uint32Array(N.length);let _e=0,lt=0;for(let ht=0;ht<ke;ht++){const At=5*ae[ht],_t=N[At+0],en=N[At+1],rn=N[At+2],on=N[At+3],kn=N[At+4],Ai=_t-_e,jr=Ai===0?en-lt:en,In=5*ht;Ke[In+0]=Ai,Ke[In+1]=jr,Ke[In+2]=rn,Ke[In+3]=on,Ke[In+4]=kn,_e=_t,lt=en}return Ke}build(N){return this.f?new Fn(new Uint32Array(this.g),N):new Fn(jn.r(this.g),N)}}e.$zP=jn;class Fn{constructor(N,ae){this.resultId=ae,this.data=N}}e.$AP=Fn;class Mi{constructor(N,ae,ke){this.start=N,this.deleteCount=ae,this.data=ke}}e.$BP=Mi;class zi{constructor(N,ae){this.resultId=ae,this.edits=N}}e.$CP=zi;var xn;(function(F){F[F.Separate=0]="Separate",F[F.MergeWithParent=1]="MergeWithParent"})(xn||(e.DebugConsoleMode=xn={}));class Ui{constructor(N){this.name=N}}e.$DP=Ui;var _n;(function(F){F[F.Title=1]="Title",F[F.Inline=2]="Inline"})(_n||(e.QuickInputButtonLocation=_n={}));let Mn=class{static{this.Back={iconPath:new Zt("arrow-left")}}constructor(){}};e.$EP=Mn,e.$EP=Mn=Ve([L],Mn);var ei;(function(F){F[F.Separator=-1]="Separator",F[F.Default=0]="Default"})(ei||(e.QuickPickItemKind=ei={}));var ti;(function(F){F[F.Info=1]="Info",F[F.Warning=2]="Warning",F[F.Error=3]="Error"})(ti||(e.InputBoxValidationSeverity=ti={}));var ni;(function(F){F[F.UI=1]="UI",F[F.Workspace=2]="Workspace"})(ni||(e.ExtensionKind=ni={}));class Bi{static validate(N){if(typeof N.badge=="string"){let ae=(0,T.$Uf)(N.badge,0);if(ae<N.badge.length&&(ae+=(0,T.$Uf)(N.badge,ae)),N.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Zt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ae,ke){this.badge=N,this.tooltip=ae,this.color=ke}}e.$FP=Bi;let zn=class{constructor(N){this.kind=N}};e.$GP=zn,e.$GP=zn=Ve([L],zn);var ii;(function(F){F[F.Light=1]="Light",F[F.Dark=2]="Dark",F[F.HighContrast=3]="HighContrast",F[F.HighContrastLight=4]="HighContrastLight"})(ii||(e.ColorThemeKind=ii={}));class un{static isNotebookRange(N){return N instanceof un?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,ae){if(N<0)throw(0,i.$$)("start must be positive");if(ae<0)throw(0,i.$$)("end must be positive");N<=ae?(this.c=N,this.e=ae):(this.c=ae,this.e=N)}with(N){let ae=this.c,ke=this.e;return N.start!==void 0&&(ae=N.start),N.end!==void 0&&(ke=N.end),ae===this.c&&ke===this.e?this:new un(ae,ke)}}e.$HP=un;class Dn{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ae=>Dn.isNotebookCellData(ae))}static isNotebookCellData(N){return!0}constructor(N,ae,ke,Ke,_e,lt,ht){this.kind=N,this.value=ae,this.languageId=ke,this.mime=Ke,this.outputs=_e??[],this.metadata=lt,this.executionSummary=ht,Dn.validate(this)}}e.$IP=Dn;class qi{constructor(N){this.cells=N}}e.$JP=qi;class nn{static isNotebookCellOutputItem(N){return N instanceof nn?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ae={name:N.name,message:N.message,stack:N.stack};return nn.json(ae,"application/vnd.code.notebook.error")}static stdout(N){return nn.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return nn.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ae="application/octet-stream"){return new nn(N,ae)}static#e=new TextEncoder;static text(N,ae=D.$it.text){const ke=nn.#e.encode(String(N));return new nn(ke,ae)}static json(N,ae="text/x-json"){const ke=JSON.stringify(N,void 0,"	");return nn.text(ke,ae)}constructor(N,ae){this.data=N,this.mime=ae;const ke=(0,D.$mt)(ae,!0);if(!ke)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$KP=nn;class Tn{static isNotebookCellOutput(N){return N instanceof Tn?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ae=!1){const ke=new Set,Ke=new Set;for(let _e=0;_e<N.length;_e++){const lt=N[_e],ht=(0,D.$mt)(lt.mime);if(!ke.has(ht)||(0,a.$cM)(ht)){ke.add(ht);continue}Ke.add(_e),ae&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ke.size===0?N:N.filter((_e,lt)=>!Ke.has(lt))}constructor(N,ae,ke){this.items=Tn.ensureUniqueMimeTypes(N,!0),typeof ae=="string"?(this.id=ae,this.metadata=ke):(this.id=(0,S.$7g)(),this.metadata=ae??ke)}}e.$LP=Tn;var ri;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(ri||(e.NotebookCellKind=ri={}));var si;(function(F){F[F.Idle=1]="Idle",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(si||(e.NotebookCellExecutionState=si={}));var oi;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(oi||(e.NotebookCellStatusBarAlignment=oi={}));var ai;(function(F){F[F.Default=0]="Default",F[F.InCenter=1]="InCenter",F[F.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",F[F.AtTop=3]="AtTop"})(ai||(e.NotebookEditorRevealType=ai={}));class Hi{constructor(N,ae){this.text=N,this.alignment=ae}}e.$MP=Hi;var li;(function(F){F[F.Default=1]="Default",F[F.Preferred=2]="Preferred"})(li||(e.NotebookControllerAffinity=li={}));var ci;(function(F){F[F.Default=1]="Default",F[F.Preferred=2]="Preferred",F[F.Hidden=-1]="Hidden"})(ci||(e.NotebookControllerAffinity2=ci={}));class Wi{constructor(N,ae=[]){this.uri=N,this.provides=(0,t.$6b)(ae)}}e.$NP=Wi;class Vi{constructor(N){this.label=N}}e.$OP=Vi;var ui;(function(F){F[F.Named=1]="Named",F[F.Indexed=2]="Indexed"})(ui||(e.NotebookVariablesRequestKind=ui={}));let Un=class{constructor(N,ae){this.label=N,this.timestamp=ae}};e.$PP=Un,e.$PP=Un=Ve([L],Un);var hi;(function(F){F[F.Production=1]="Production",F[F.Development=2]="Development",F[F.Test=3]="Test"})(hi||(e.ExtensionMode=hi={}));var fi;(function(F){F[F.Node=1]="Node",F[F.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var di;(function(F){F[F.Other=0]="Other",F[F.Comment=1]="Comment",F[F.String=2]="String",F[F.RegEx=3]="RegEx"})(di||(e.StandardTokenType=di={}));class Gi{constructor(N,ae){this.ranges=N,this.wordPattern=ae}}e.$QP=Gi;class Ki{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$RP=Ki;var mi;(function(F){F[F.Queued=1]="Queued",F[F.Running=2]="Running",F[F.Passed=3]="Passed",F[F.Failed=4]="Failed",F[F.Skipped=5]="Skipped",F[F.Errored=6]="Errored"})(mi||(e.TestResultState=mi={}));var gi;(function(F){F[F.Run=1]="Run",F[F.Debug=2]="Debug",F[F.Coverage=3]="Coverage"})(gi||(e.TestRunProfileKind=gi={}));let Bn=class{constructor(N=void 0,ae=void 0,ke=void 0,Ke=!1,_e=!0){this.include=N,this.exclude=ae,this.profile=ke,this.continuous=Ke,this.preserveFocus=_e}};e.$SP=Bn,e.$SP=Bn=Ve([L],Bn);let qn=C=class{static diff(N,ae,ke){const Ke=new C(N);return Ke.expectedOutput=ae,Ke.actualOutput=ke,Ke}constructor(N){this.message=N}};e.$TP=qn,e.$TP=qn=C=Ve([L],qn);let Hn=class{constructor(N){this.id=N}};e.$UP=Hn,e.$UP=Hn=Ve([L],Hn);class Qi{constructor(N,ae,ke){this.label=N,this.uri=ae,this.position=ke}}e.$VP=Qi;class On{constructor(N,ae){this.covered=N,this.total=ae,$i(this)}}e.$WP=On;function $i(F){if(F){if(F.covered>F.total)throw new Error(`The total number of covered items (${F.covered}) cannot be greater than the total (${F.total})`);if(F.total<0)throw new Error(`The number of covered items (${F.total}) cannot be negative`)}}class Wn{static fromDetails(N,ae){const ke=new On(0,0),Ke=new On(0,0),_e=new On(0,0);for(const ht of ae)if("branches"in ht){ke.total+=1,ke.covered+=ht.executed?1:0;for(const At of ht.branches)Ke.total+=1,Ke.covered+=At.executed?1:0}else _e.total+=1,_e.covered+=ht.executed?1:0;const lt=new Wn(N,ke,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return lt.detailedCoverage=ae,lt}constructor(N,ae,ke,Ke,_e=[]){this.uri=N,this.statementCoverage=ae,this.branchCoverage=ke,this.declarationCoverage=Ke,this.fromTests=_e}}e.$YP=Wn;class Ji{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ae,ke=[]){this.executed=N,this.location=ae,this.branches=ke}}e.$ZP=Ji;class Xi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ae,ke){this.executed=N,this.location=ae,this.label=ke}}e.$1P=Xi;class Zi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ae,ke){this.name=N,this.executed=ae,this.location=ke}}e.$2P=Zi;var pi;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(pi||(e.ExternalUriOpenerPriority=pi={}));var bi;(function(F){F[F.Untrusted=0]="Untrusted",F[F.Trusted=1]="Trusted",F[F.Unspecified=2]="Unspecified"})(bi||(e.WorkspaceTrustState=bi={}));var wi;(function(F){F[F.Notify=1]="Notify",F[F.OpenBrowser=2]="OpenBrowser",F[F.OpenPreview=3]="OpenPreview",F[F.Silent=4]="Silent",F[F.Ignore=5]="Ignore",F[F.OpenBrowserOnce=6]="OpenBrowserOnce"})(wi||(e.PortAutoForwardAction=wi={}));class Yi{constructor(N,ae,ke,Ke,_e,lt){this.kind=N,this.name=ae,this.detail=ke,this.uri=Ke,this.range=_e,this.selectionRange=lt}}e.$3P=Yi;class xi{constructor(N){this.uri=N}}e.$4P=xi;class _i{constructor(N,ae){this.original=N,this.modified=ae}}e.$5P=_i;class er{constructor(N,ae,ke,Ke){this.base=N,this.input1=ae,this.input2=ke,this.result=Ke}}e.$6P=er;class tr{constructor(N,ae){this.uri=N,this.viewType=ae}}e.$7P=tr;class nr{constructor(N){this.viewType=N}}e.$8P=nr;class ir{constructor(N,ae){this.uri=N,this.notebookType=ae}}e.$9P=ir;class rr{constructor(N,ae,ke){this.original=N,this.modified=ae,this.notebookType=ke}}e.$0P=rr;class sr{constructor(){}}e.$$P=sr;class or{constructor(N,ae){this.uri=N,this.inputBoxUri=ae}}e.$_P=or;class ar{constructor(){}}e.$aQ=ar;class lr{constructor(N){this.textDiffs=N}}e.$bQ=lr;var yi;(function(F){F[F.Down=0]="Down",F[F.Up=1]="Up"})(yi||(e.InteractiveSessionVoteDirection=yi={}));var vi;(function(F){F[F.Action=1]="Action",F[F.Toolbar=2]="Toolbar"})(vi||(e.ChatCopyKind=vi={}));var Ei;(function(F){F[F.Short=1]="Short",F[F.Medium=2]="Medium",F[F.Full=3]="Full"})(Ei||(e.ChatVariableLevel=Ei={}));class cr{constructor(N,ae,ke){this.id=N,this.label=ae,this.values=ke}}e.$cQ=cr;var Si;(function(F){F[F.Unhelpful=0]="Unhelpful",F[F.Helpful=1]="Helpful",F[F.Undone=2]="Undone",F[F.Accepted=3]="Accepted",F[F.Bug=4]="Bug"})(Si||(e.InteractiveEditorResponseFeedbackKind=Si={}));var ki;(function(F){F[F.Unhelpful=0]="Unhelpful",F[F.Helpful=1]="Helpful"})(ki||(e.ChatResultFeedbackKind=ki={}));class ur{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new st(N):N}}e.$dQ=ur;class hr{constructor(N,ae){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new st(N):N,this.vulnerabilities=ae}}e.$eQ=hr;class fr{constructor(N,ae){this.participant=N,this.command=ae}}e.$fQ=fr;class dr{constructor(N,ae,ke,Ke){this.title=N,this.message=ae,this.data=ke,this.buttons=Ke}}e.$gQ=dr;class mr{constructor(N,ae){this.value=N,this.baseUri=ae}}e.$hQ=mr;class gr{constructor(N,ae){this.value=N,this.title=ae}}e.$iQ=gr;class $r{constructor(N){this.value=N}}e.$jQ=$r;class pr{constructor(N,ae){this.value=N,this.task=ae}}e.$kQ=pr;class br{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new st(N):N}}e.$lQ=br;class wr{constructor(N){this.value=N}}e.$mQ=wr;class yr{constructor(N,ae,ke){this.value=N,this.iconPath=ae,this.options=ke}}e.$nQ=yr;class vr{constructor(N,ae,ke){this.value=N,this.license=ae,this.snippet=ke}}e.$oQ=vr;class Er{constructor(N,ae){this.uri=N,this.range=ae}}e.$pQ=Er;class Sr{constructor(N,ae){this.uri=N,this.edits=Array.isArray(ae)?ae:[ae]}}e.$qQ=Sr;class kr{constructor(N,ae,ke,Ke){this.prompt=N,this.command=ae,this.references=ke,this.participant=Ke}}e.$rQ=kr;class Ir{constructor(N,ae,ke,Ke){this.response=N,this.result=ae,this.participant=ke,this.command=Ke}}e.$sQ=Ir;var Ii;(function(F){F[F.Panel=1]="Panel",F[F.Terminal=2]="Terminal",F[F.Notebook=3]="Notebook",F[F.Editor=4]="Editor"})(Ii||(e.ChatLocation=Ii={}));var Pi;(function(F){F[F.Complete=1]="Complete",F[F.Partial=2]="Partial",F[F.Omitted=3]="Omitted"})(Pi||(e.ChatResponseReferencePartStatusKind=Pi={}));class Pr{constructor(N,ae,ke){this.document=N,this.selection=ae,this.wholeRange=ke}}e.$tQ=Pr;class Rr{constructor(N){this.cell=N}}e.$uQ=Rr;var Ln;(function(F){F[F.User=1]="User",F[F.Assistant=2]="Assistant",F[F.System=3]="System"})(Ln||(e.LanguageModelChatMessageRole=Ln={}));class Dr{constructor(N,ae,ke){this.toolCallId=N,this.content=ae,this.isError=ke??!1}}e.$vQ=Dr;class An{static User(N,ae){const ke=new An(Ln.User,typeof N=="string"?N:"",ae);return ke.content2=[N],ke}static Assistant(N,ae){return new An(Ln.Assistant,N,ae)}constructor(N,ae,ke){this.role=N,this.content=ae,this.content2=[ae],this.name=ke}}e.$wQ=An;class Tr{constructor(N,ae,ke){this.name=N,this.toolCallId=ae,this.parameters=ke}}e.$xQ=Tr;class Or{constructor(N){this.value=N}}e.$yQ=Or;class Lr{constructor(N){this.content=N}}e.$zQ=Lr;class Ar{constructor(N,ae){this.content=N,this.name=ae}}e.$AQ=Ar;class Cr{constructor(N,ae){this.content=N,this.name=ae}}e.$BQ=Cr;class hn extends Error{static NotFound(N){return new hn(N,hn.NotFound.name)}static NoPermissions(N){return new hn(N,hn.NoPermissions.name)}static Blocked(N){return new hn(N,hn.Blocked.name)}constructor(N,ae,ke){super(N,{cause:ke}),this.name="LanguageModelError",this.code=ae??""}}e.$CQ=hn;var Ri;(function(F){F[F.SymbolInformation=1]="SymbolInformation",F[F.CommandInformation=2]="CommandInformation",F[F.SearchInformation=3]="SearchInformation",F[F.SettingInformation=4]="SettingInformation"})(Ri||(e.RelatedInformationType=Ri={}));var Di;(function(F){F[F.Started=1]="Started",F[F.Recognizing=2]="Recognizing",F[F.Recognized=3]="Recognized",F[F.Stopped=4]="Stopped",F[F.Error=5]="Error"})(Di||(e.SpeechToTextStatus=Di={}));var Ti;(function(F){F[F.Started=1]="Started",F[F.Stopped=2]="Stopped",F[F.Error=3]="Error"})(Ti||(e.TextToSpeechStatus=Ti={}));var Oi;(function(F){F[F.Recognized=1]="Recognized",F[F.Stopped=2]="Stopped"})(Oi||(e.KeywordRecognitionStatus=Oi={}));class Nr{constructor(N,ae){this.text=N,this.range=ae}}e.$DQ=Nr;var Li;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Li||(e.InlineEditTriggerKind=Li={}))}),define(Oe[156],Le([1,0,17,14,178,80,113,25,164,49,69,21,170,19,83,10,4,206,48,110,196,186,218,219,150,103,262,275,263,154,77,104,152,155]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d,w,o,l,n,u,r,f,h,k,P,O,C,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatLanguageModelToolReference=e.ChatPromptReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseMovePart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$LQ=le,e.$MQ=oe,e.$NQ=_,D=We(D),v=We(v),g=We(g),d=We(d),w=We(w),h=We(h),P=We(P),R=We(R);var z;(function(Ee){function Ae(q){const{selectionStartLineNumber:Pe,selectionStartColumn:He,positionLineNumber:Ze,positionColumn:ze}=q,nt=new R.$eO(Pe-1,He-1),at=new R.$eO(Ze-1,ze-1);return new R.$gO(nt,at)}Ee.to=Ae;function he(q){const{anchor:Pe,active:He}=q;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Ee.from=he})(z||(e.Selection=z={}));var Q;(function(Ee){function Ae(q){if(!q)return;const{start:Pe,end:He}=q;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Ee.from=Ae;function he(q){if(!q)return;const{startLineNumber:Pe,startColumn:He,endLineNumber:Ze,endColumn:ze}=q;return new R.$fO(Pe-1,He-1,Ze-1,ze-1)}Ee.to=he})(Q||(e.Range=Q={}));var J;(function(Ee){function Ae(q){return{uri:q.uri,range:Q.from(q.range)}}Ee.from=Ae;function he(q){return new R.$rO(m.URI.revive(q.uri),Q.to(q.range))}Ee.to=he})(J||(e.Location=J={}));var x;(function(Ee){function Ae(he){switch(he){case d.StandardTokenType.Comment:return R.StandardTokenType.Comment;case d.StandardTokenType.Other:return R.StandardTokenType.Other;case d.StandardTokenType.RegEx:return R.StandardTokenType.RegEx;case d.StandardTokenType.String:return R.StandardTokenType.String}}Ee.to=Ae})(x||(e.TokenType=x={}));var ve;(function(Ee){function Ae(q){return new R.$eO(q.lineNumber-1,q.column-1)}Ee.to=Ae;function he(q){return{lineNumber:q.line+1,column:q.character+1}}Ee.from=he})(ve||(e.Position=ve={}));var be;(function(Ee){function Ae(Pe,He,Ze){return(0,t.$Lb)((0,t.$6b)(Pe).map(ze=>he(ze,He,Ze)))}Ee.from=Ae;function he(Pe,He,Ze){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:Ze?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:q(Pe.scheme,He),pattern:qe.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:Ze?.isBuiltin}}function q(Pe,He){return He&&typeof Pe=="string"?He.transformOutgoingScheme(Pe):Pe}})(be||(e.DocumentSelector=be={}));var se;(function(Ee){function Ae(q){switch(q){case R.DiagnosticTag.Unnecessary:return l.MarkerTag.Unnecessary;case R.DiagnosticTag.Deprecated:return l.MarkerTag.Deprecated}}Ee.from=Ae;function he(q){switch(q){case l.MarkerTag.Unnecessary:return R.DiagnosticTag.Unnecessary;case l.MarkerTag.Deprecated:return R.DiagnosticTag.Deprecated;default:return}}Ee.to=he})(se||(e.DiagnosticTag=se={}));var V;(function(Ee){function Ae(q){let Pe;return q.code&&((0,c.$jg)(q.code)||(0,c.$ng)(q.code)?Pe=String(q.code):Pe={value:String(q.code.value),target:q.code.target}),{...Q.from(q.range),message:q.message,source:q.source,code:Pe,severity:j.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(B.from),tags:Array.isArray(q.tags)?(0,t.$Lb)(q.tags.map(se.from)):void 0}}Ee.from=Ae;function he(q){const Pe=new R.$tO(Q.to(q),q.message,j.to(q.severity));return Pe.source=q.source,Pe.code=(0,c.$jg)(q.code)?q.code:q.code?.value,Pe.relatedInformation=q.relatedInformation&&q.relatedInformation.map(B.to),Pe.tags=q.tags&&(0,t.$Lb)(q.tags.map(se.to)),Pe}Ee.to=he})(V||(e.Diagnostic=V={}));var B;(function(Ee){function Ae(q){return{...Q.from(q.location.range),message:q.message,resource:q.location.uri}}Ee.from=Ae;function he(q){return new R.$sO(new R.$rO(q.resource,Q.to(q)),q.message)}Ee.to=he})(B||(e.DiagnosticRelatedInformation=B={}));var j;(function(Ee){function Ae(q){switch(q){case R.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case R.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case R.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case R.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}Ee.from=Ae;function he(q){switch(q){case l.MarkerSeverity.Info:return R.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return R.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return R.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return R.DiagnosticSeverity.Hint;default:return R.DiagnosticSeverity.Error}}Ee.to=he})(j||(e.DiagnosticSeverity=j={}));var U;(function(Ee){function Ae(q){return typeof q=="number"&&q>=R.ViewColumn.One?q-1:q===R.ViewColumn.Beside?L.$UE:L.$TE}Ee.from=Ae;function he(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=he})(U||(e.ViewColumn=U={}));function te(Ee){return typeof Ee.range<"u"}function le(Ee){return Ee.length===0?!0:!!te(Ee[0])}var ye;(function(Ee){function Ae(ze){return ze.map(Ee.from)}Ee.fromMany=Ae;function he(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function q(ze){let nt;if(he(ze)){const{language:St,value:Dt}=ze;nt={value:"```"+St+`
`+Dt+"\n```\n"}}else R.$HO.isMarkdownString(ze)?nt={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?nt={value:ze}:nt={value:""};const at=Object.create(null);nt.uris=at;const Lt=({href:St})=>{try{let Dt=m.URI.parse(St,!0);Dt=Dt.with({query:Pe(Dt.query,at)}),at[St]=Dt}catch{}return""};return v.marked.walkTokens(v.marked.lexer(nt.value),St=>{St.type==="link"?Lt({href:St.href}):St.type==="image"&&typeof St.href=="string"&&Lt(D.$el(St.href))}),nt}Ee.from=q;function Pe(ze,nt){if(!ze)return ze;let at;try{at=(0,s.$gi)(ze)}catch{}if(!at)return ze;let Lt=!1;return at=(0,y.$oo)(at,St=>{if(m.URI.isUri(St)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[Dt]=St,Lt=!0,Dt}else return}),Lt?JSON.stringify(at):ze}function He(ze){const nt=new R.$HO(ze.value,ze.supportThemeIcons);return nt.isTrusted=ze.isTrusted,nt.supportHtml=ze.supportHtml,nt.baseUri=ze.baseUri?m.URI.from(ze.baseUri):void 0,nt}Ee.to=He;function Ze(ze){if(ze)return typeof ze=="string"?ze:Ee.from(ze)}Ee.fromStrict=Ze})(ye||(e.MarkdownString=ye={}));function oe(Ee){return le(Ee)?Ee.map(Ae=>({range:Q.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?ye.fromMany(Ae.hoverMessage):Ae.hoverMessage?ye.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):Ee.map(Ae=>({range:Q.from(Ae)}))}function _(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?m.URI.file(Ee):Ee}var X;(function(Ee){function Ae(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?_(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Ee.from=Ae})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var M;(function(Ee){function Ae(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?_(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?X.from(he.before):void 0,after:he.after?X.from(he.after):void 0}}Ee.from=Ae})(M||(e.ThemableDecorationRenderOptions=M={}));var A;(function(Ee){function Ae(he){if(typeof he>"u")return he;switch(he){case R.DecorationRangeBehavior.OpenOpen:return o.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case R.DecorationRangeBehavior.ClosedClosed:return o.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case R.DecorationRangeBehavior.OpenClosed:return o.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case R.DecorationRangeBehavior.ClosedOpen:return o.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ee.from=Ae})(A||(e.DecorationRangeBehavior=A={}));var Y;(function(Ee){function Ae(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?A.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?M.from(he.light):void 0,dark:he.dark?M.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?_(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?X.from(he.before):void 0,after:he.after?X.from(he.after):void 0}}Ee.from=Ae})(Y||(e.DecorationRenderOptions=Y={}));var pe;(function(Ee){function Ae(q){return{text:q.newText,eol:q.newEol&&fe.from(q.newEol),range:Q.from(q.range)}}Ee.from=Ae;function he(q){const Pe=new R.$mO(Q.to(q.range),q.text);return Pe.newEol=typeof q.eol>"u"?void 0:fe.to(q.eol),Pe}Ee.to=he})(pe||(e.TextEdit=pe={}));var ne;(function(Ee){function Ae(q,Pe){const He={edits:[]};if(q instanceof R.$pO){const Ze=new T.$Gc;for(const ze of q._allEntries())ze._type===R.FileEditType.File&&m.URI.isUri(ze.to)&&ze.from===void 0&&Ze.add(ze.to);for(const ze of q._allEntries())if(ze._type===R.FileEditType.File){let nt;ze.options?.contents&&(ArrayBuffer.isView(ze.options.contents)?nt={type:"base64",value:(0,i.$af)(i.$Se.wrap(ze.options.contents))}:nt={type:"dataTransferItem",id:ze.options.contents._itemId}),He.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contents:nt},metadata:ze.metadata})}else ze._type===R.FileEditType.Text?He.edits.push({resource:ze.uri,textEdit:pe.from(ze.edit),versionId:Ze.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===R.FileEditType.Snippet?He.edits.push({resource:ze.uri,textEdit:{range:Q.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Ze.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===R.FileEditType.Cell?He.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri)}):ze._type===R.FileEditType.CellReplace&&He.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:P.CellEditType.Replace,index:ze.index,count:ze.count,cells:ze.cells.map(gt.from)}})}return He}Ee.from=Ae;function he(q){const Pe=new R.$pO,He=new T.$Fc;for(const Ze of q.edits)if(Ze.textEdit){const ze=Ze,nt=m.URI.revive(ze.resource),at=Q.to(ze.textEdit.range),Lt=ze.textEdit.text,St=ze.textEdit.insertAsSnippet;let Dt;St?Dt=R.$oO.replace(at,new R.$qO(Lt)):Dt=R.$mO.replace(at,Lt);const Rn=He.get(nt);Rn?Rn.push(Dt):He.set(nt,[Dt])}else Pe.renameFile(m.URI.revive(Ze.oldResource),m.URI.revive(Ze.newResource),Ze.options);for(const[Ze,ze]of He)Pe.set(Ze,ze);return Pe}Ee.to=he})(ne||(e.WorkspaceEdit=ne={}));var ie;(function(Ee){const Ae=Object.create(null);Ae[R.SymbolKind.File]=w.SymbolKind.File,Ae[R.SymbolKind.Module]=w.SymbolKind.Module,Ae[R.SymbolKind.Namespace]=w.SymbolKind.Namespace,Ae[R.SymbolKind.Package]=w.SymbolKind.Package,Ae[R.SymbolKind.Class]=w.SymbolKind.Class,Ae[R.SymbolKind.Method]=w.SymbolKind.Method,Ae[R.SymbolKind.Property]=w.SymbolKind.Property,Ae[R.SymbolKind.Field]=w.SymbolKind.Field,Ae[R.SymbolKind.Constructor]=w.SymbolKind.Constructor,Ae[R.SymbolKind.Enum]=w.SymbolKind.Enum,Ae[R.SymbolKind.Interface]=w.SymbolKind.Interface,Ae[R.SymbolKind.Function]=w.SymbolKind.Function,Ae[R.SymbolKind.Variable]=w.SymbolKind.Variable,Ae[R.SymbolKind.Constant]=w.SymbolKind.Constant,Ae[R.SymbolKind.String]=w.SymbolKind.String,Ae[R.SymbolKind.Number]=w.SymbolKind.Number,Ae[R.SymbolKind.Boolean]=w.SymbolKind.Boolean,Ae[R.SymbolKind.Array]=w.SymbolKind.Array,Ae[R.SymbolKind.Object]=w.SymbolKind.Object,Ae[R.SymbolKind.Key]=w.SymbolKind.Key,Ae[R.SymbolKind.Null]=w.SymbolKind.Null,Ae[R.SymbolKind.EnumMember]=w.SymbolKind.EnumMember,Ae[R.SymbolKind.Struct]=w.SymbolKind.Struct,Ae[R.SymbolKind.Event]=w.SymbolKind.Event,Ae[R.SymbolKind.Operator]=w.SymbolKind.Operator,Ae[R.SymbolKind.TypeParameter]=w.SymbolKind.TypeParameter;function he(Pe){return typeof Ae[Pe]=="number"?Ae[Pe]:w.SymbolKind.Property}Ee.from=he;function q(Pe){for(const He in Ae)if(Ae[He]===Pe)return Number(He);return R.SymbolKind.Property}Ee.to=q})(ie||(e.SymbolKind=ie={}));var G;(function(Ee){function Ae(q){switch(q){case R.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}Ee.from=Ae;function he(q){switch(q){case w.SymbolTag.Deprecated:return R.SymbolTag.Deprecated}}Ee.to=he})(G||(e.SymbolTag=G={}));var Z;(function(Ee){function Ae(q){return{name:q.name,kind:ie.from(q.kind),tags:q.tags&&q.tags.map(G.from),containerName:q.containerName,location:Be.from(q.location)}}Ee.from=Ae;function he(q){const Pe=new R.$yO(q.name,ie.to(q.kind),q.containerName,Be.to(q.location));return Pe.tags=q.tags&&q.tags.map(G.to),Pe}Ee.to=he})(Z||(e.WorkspaceSymbol=Z={}));var ce;(function(Ee){function Ae(q){const Pe={name:q.name||"!!MISSING: name!!",detail:q.detail,range:Q.from(q.range),selectionRange:Q.from(q.selectionRange),kind:ie.from(q.kind),tags:q.tags?.map(G.from)??[]};return q.children&&(Pe.children=q.children.map(Ae)),Pe}Ee.from=Ae;function he(q){const Pe=new R.$zO(q.name,q.detail,ie.to(q.kind),Q.to(q.range),Q.to(q.selectionRange));return(0,t.$Pb)(q.tags)&&(Pe.tags=q.tags.map(G.to)),q.children&&(Pe.children=q.children.map(he)),Pe}Ee.to=he})(ce||(e.DocumentSymbol=ce={}));var we;(function(Ee){function Ae(q){const Pe=new R.$DO(ie.to(q.kind),q.name,q.detail||"",m.URI.revive(q.uri),Q.to(q.range),Q.to(q.selectionRange));return Pe._sessionId=q._sessionId,Pe._itemId=q._itemId,Pe}Ee.to=Ae;function he(q,Pe,He){if(Pe=Pe??q._sessionId,He=He??q._itemId,Pe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:He,name:q.name,detail:q.detail,kind:ie.from(q.kind),uri:q.uri,range:Q.from(q.range),selectionRange:Q.from(q.selectionRange),tags:q.tags?.map(G.from)}}Ee.from=he})(we||(e.CallHierarchyItem=we={}));var Ie;(function(Ee){function Ae(he){return new R.$EO(we.to(he.from),he.fromRanges.map(q=>Q.to(q)))}Ee.to=Ae})(Ie||(e.CallHierarchyIncomingCall=Ie={}));var Me;(function(Ee){function Ae(he){return new R.$FO(we.to(he.to),he.fromRanges.map(q=>Q.to(q)))}Ee.to=Ae})(Me||(e.CallHierarchyOutgoingCall=Me={}));var Be;(function(Ee){function Ae(q){return{range:q.range&&Q.from(q.range),uri:q.uri}}Ee.from=Ae;function he(q){return new R.$rO(m.URI.revive(q.uri),Q.to(q.range))}Ee.to=he})(Be||(e.location=Be={}));var De;(function(Ee){function Ae(q){const Pe=q,He=q;return{originSelectionRange:Pe.originSelectionRange?Q.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:He.uri,range:Q.from(Pe.targetRange?Pe.targetRange:He.range),targetSelectionRange:Pe.targetSelectionRange?Q.from(Pe.targetSelectionRange):void 0}}Ee.from=Ae;function he(q){return{targetUri:m.URI.revive(q.uri),targetRange:Q.to(q.range),targetSelectionRange:q.targetSelectionRange?Q.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?Q.to(q.originSelectionRange):void 0}}Ee.to=he})(De||(e.DefinitionLink=De={}));var Ne;(function(Ee){function Ae(q){return{range:Q.from(q.range),contents:ye.fromMany(q.contents),canIncreaseVerbosity:q.canIncreaseVerbosity,canDecreaseVerbosity:q.canDecreaseVerbosity}}Ee.from=Ae;function he(q){const Pe=q.contents.map(ye.to),He=Q.to(q.range),Ze=q.canIncreaseVerbosity,ze=q.canDecreaseVerbosity;return new R.$vO(Pe,He,Ze,ze)}Ee.to=he})(Ne||(e.Hover=Ne={}));var Te;(function(Ee){function Ae(q){return{range:Q.from(q.range),expression:q.expression}}Ee.from=Ae;function he(q){return new R.$qP(Q.to(q.range),q.expression)}Ee.to=he})(Te||(e.EvaluatableExpression=Te={}));var Ce;(function(Ee){function Ae(q){if(q instanceof R.$rP)return{type:"text",range:Q.from(q.range),text:q.text};if(q instanceof R.$sP)return{type:"variable",range:Q.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof R.$tP)return{type:"expression",range:Q.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ae;function he(q){switch(q.type){case"text":return{range:Q.to(q.range),text:q.text};case"variable":return{range:Q.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:Q.to(q.range),expression:q.expression}}}Ee.to=he})(Ce||(e.InlineValue=Ce={}));var de;(function(Ee){function Ae(q){return{frameId:q.frameId,stoppedLocation:Q.from(q.stoppedLocation)}}Ee.from=Ae;function he(q){return new R.$uP(q.frameId,Q.to(q.stoppedLocation))}Ee.to=he})(de||(e.InlineValueContext=de={}));var Se;(function(Ee){function Ae(q){return{range:Q.from(q.range),kind:q.kind}}Ee.from=Ae;function he(q){return new R.$wO(Q.to(q.range),q.kind)}Ee.to=he})(Se||(e.DocumentHighlight=Se={}));var Re;(function(Ee){function Ae(q){return{uri:q.uri,highlights:q.highlights.map(Se.from)}}Ee.from=Ae;function he(q){return new R.$xO(m.URI.revive(q.uri),q.highlights.map(Se.to))}Ee.to=he})(Re||(e.MultiDocumentHighlight=Re={}));var Ue;(function(Ee){function Ae(he){switch(he){case w.CompletionTriggerKind.TriggerCharacter:return R.CompletionTriggerKind.TriggerCharacter;case w.CompletionTriggerKind.TriggerForIncompleteCompletions:return R.CompletionTriggerKind.TriggerForIncompleteCompletions;case w.CompletionTriggerKind.Invoke:default:return R.CompletionTriggerKind.Invoke}}Ee.to=Ae})(Ue||(e.CompletionTriggerKind=Ue={}));var Ge;(function(Ee){function Ae(he){return{triggerKind:Ue.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Ee.to=Ae})(Ge||(e.CompletionContext=Ge={}));var Qe;(function(Ee){function Ae(q){switch(q){case R.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}Ee.from=Ae;function he(q){switch(q){case w.CompletionItemTag.Deprecated:return R.CompletionItemTag.Deprecated}}Ee.to=he})(Qe||(e.CompletionItemTag=Qe={}));var Je;(function(Ee){const Ae=new Map([[R.CompletionItemKind.Method,w.CompletionItemKind.Method],[R.CompletionItemKind.Function,w.CompletionItemKind.Function],[R.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[R.CompletionItemKind.Field,w.CompletionItemKind.Field],[R.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[R.CompletionItemKind.Class,w.CompletionItemKind.Class],[R.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[R.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[R.CompletionItemKind.Module,w.CompletionItemKind.Module],[R.CompletionItemKind.Property,w.CompletionItemKind.Property],[R.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[R.CompletionItemKind.Value,w.CompletionItemKind.Value],[R.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[R.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[R.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[R.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[R.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[R.CompletionItemKind.Text,w.CompletionItemKind.Text],[R.CompletionItemKind.Color,w.CompletionItemKind.Color],[R.CompletionItemKind.File,w.CompletionItemKind.File],[R.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[R.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[R.CompletionItemKind.Event,w.CompletionItemKind.Event],[R.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[R.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[R.CompletionItemKind.Issue,w.CompletionItemKind.Issue],[R.CompletionItemKind.User,w.CompletionItemKind.User]]);function he(He){return Ae.get(He)??w.CompletionItemKind.Property}Ee.from=he;const q=new Map([[w.CompletionItemKind.Method,R.CompletionItemKind.Method],[w.CompletionItemKind.Function,R.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,R.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,R.CompletionItemKind.Field],[w.CompletionItemKind.Variable,R.CompletionItemKind.Variable],[w.CompletionItemKind.Class,R.CompletionItemKind.Class],[w.CompletionItemKind.Interface,R.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,R.CompletionItemKind.Struct],[w.CompletionItemKind.Module,R.CompletionItemKind.Module],[w.CompletionItemKind.Property,R.CompletionItemKind.Property],[w.CompletionItemKind.Unit,R.CompletionItemKind.Unit],[w.CompletionItemKind.Value,R.CompletionItemKind.Value],[w.CompletionItemKind.Constant,R.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,R.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,R.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,R.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,R.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,R.CompletionItemKind.Text],[w.CompletionItemKind.Color,R.CompletionItemKind.Color],[w.CompletionItemKind.File,R.CompletionItemKind.File],[w.CompletionItemKind.Reference,R.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,R.CompletionItemKind.Folder],[w.CompletionItemKind.Event,R.CompletionItemKind.Event],[w.CompletionItemKind.Operator,R.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,R.CompletionItemKind.TypeParameter],[w.CompletionItemKind.User,R.CompletionItemKind.User],[w.CompletionItemKind.Issue,R.CompletionItemKind.Issue]]);function Pe(He){return q.get(He)??R.CompletionItemKind.Property}Ee.to=Pe})(Je||(e.CompletionItemKind=Je={}));var Xe;(function(Ee){function Ae(he,q){const Pe=new R.$NO(he.label);return Pe.insertText=he.insertText,Pe.kind=Je.to(he.kind),Pe.tags=he.tags?.map(Qe.to),Pe.detail=he.detail,Pe.documentation=D.$$k(he.documentation)?ye.to(he.documentation):he.documentation,Pe.sortText=he.sortText,Pe.filterText=he.filterText,Pe.preselect=he.preselect,Pe.commitCharacters=he.commitCharacters,g.$Yt.isIRange(he.range)?Pe.range=Q.to(he.range):typeof he.range=="object"&&(Pe.range={inserting:Q.to(he.range.insert),replacing:Q.to(he.range.replace)}),Pe.keepWhitespace=typeof he.insertTextRules>"u"?!1:!!(he.insertTextRules&w.CompletionItemInsertTextRule.KeepWhitespace),typeof he.insertTextRules<"u"&&he.insertTextRules&w.CompletionItemInsertTextRule.InsertAsSnippet?Pe.insertText=new R.$qO(he.insertText):(Pe.insertText=he.insertText,Pe.textEdit=Pe.range instanceof R.$fO?new R.$mO(Pe.range,Pe.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Pe.additionalTextEdits=he.additionalTextEdits.map(He=>pe.to(He))),Pe.command=q&&he.command?q.fromInternal(he.command):void 0,Pe}Ee.to=Ae})(Xe||(e.CompletionItem=Xe={}));var tt;(function(Ee){function Ae(q){if(typeof q.label!="string"&&!Array.isArray(q.label))throw new TypeError("Invalid label");return{label:q.label,documentation:ye.fromStrict(q.documentation)}}Ee.from=Ae;function he(q){return{label:q.label,documentation:D.$$k(q.documentation)?ye.to(q.documentation):q.documentation}}Ee.to=he})(tt||(e.ParameterInformation=tt={}));var st;(function(Ee){function Ae(q){return{label:q.label,documentation:ye.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(tt.from):[],activeParameter:q.activeParameter}}Ee.from=Ae;function he(q){return{label:q.label,documentation:D.$$k(q.documentation)?ye.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(tt.to):[],activeParameter:q.activeParameter}}Ee.to=he})(st||(e.SignatureInformation=st={}));var dt;(function(Ee){function Ae(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(st.from):[]}}Ee.from=Ae;function he(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(st.to):[]}}Ee.to=he})(dt||(e.SignatureHelp=dt={}));var rt;(function(Ee){function Ae(he,q){const Pe=new R.$MO(ve.to(q.position),typeof q.label=="string"?q.label:q.label.map(ot.to.bind(void 0,he)),q.kind&&ut.to(q.kind));return Pe.textEdits=q.textEdits&&q.textEdits.map(pe.to),Pe.tooltip=D.$$k(q.tooltip)?ye.to(q.tooltip):q.tooltip,Pe.paddingLeft=q.paddingLeft,Pe.paddingRight=q.paddingRight,Pe}Ee.to=Ae})(rt||(e.InlayHint=rt={}));var ot;(function(Ee){function Ae(he,q){const Pe=new R.$LO(q.label);return Pe.tooltip=D.$$k(q.tooltip)?ye.to(q.tooltip):q.tooltip,w.Command.is(q.command)&&(Pe.command=he.fromInternal(q.command)),q.location&&(Pe.location=Be.to(q.location)),Pe}Ee.to=Ae})(ot||(e.InlayHintLabelPart=ot={}));var ut;(function(Ee){function Ae(q){return q}Ee.from=Ae;function he(q){return q}Ee.to=he})(ut||(e.InlayHintKind=ut={}));var Ye;(function(Ee){function Ae(q){return{range:Q.from(q.range),url:q.target,tooltip:q.tooltip}}Ee.from=Ae;function he(q){let Pe;if(q.url)try{Pe=typeof q.url=="string"?m.URI.parse(q.url,!0):m.URI.revive(q.url)}catch{}const He=new R.$SO(Q.to(q.range),Pe);return He.tooltip=q.tooltip,He}Ee.to=he})(Ye||(e.DocumentLink=Ye={}));var me;(function(Ee){function Ae(q){const Pe=new R.$VO(q.label);return q.textEdit&&(Pe.textEdit=pe.to(q.textEdit)),q.additionalTextEdits&&(Pe.additionalTextEdits=q.additionalTextEdits.map(He=>pe.to(He))),Pe}Ee.to=Ae;function he(q){return{label:q.label,textEdit:q.textEdit?pe.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Pe=>pe.from(Pe)):void 0}}Ee.from=he})(me||(e.ColorPresentation=me={}));var H;(function(Ee){function Ae(q){return new R.$TO(q[0],q[1],q[2],q[3])}Ee.to=Ae;function he(q){return[q.red,q.green,q.blue,q.alpha]}Ee.from=he})(H||(e.Color=H={}));var ee;(function(Ee){function Ae(q){return{range:Q.from(q.range)}}Ee.from=Ae;function he(q){return new R.$CO(Q.to(q.range))}Ee.to=he})(ee||(e.SelectionRange=ee={}));var ge;(function(Ee){function Ae(he){switch(he){case r.SaveReason.AUTO:return R.TextDocumentSaveReason.AfterDelay;case r.SaveReason.EXPLICIT:return R.TextDocumentSaveReason.Manual;case r.SaveReason.FOCUS_CHANGE:case r.SaveReason.WINDOW_CHANGE:return R.TextDocumentSaveReason.FocusOut}}Ee.to=Ae})(ge||(e.TextDocumentSaveReason=ge={}));var re;(function(Ee){function Ae(q){switch(q){case R.TextEditorLineNumbersStyle.Off:return b.RenderLineNumbersType.Off;case R.TextEditorLineNumbersStyle.Relative:return b.RenderLineNumbersType.Relative;case R.TextEditorLineNumbersStyle.Interval:return b.RenderLineNumbersType.Interval;case R.TextEditorLineNumbersStyle.On:default:return b.RenderLineNumbersType.On}}Ee.from=Ae;function he(q){switch(q){case b.RenderLineNumbersType.Off:return R.TextEditorLineNumbersStyle.Off;case b.RenderLineNumbersType.Relative:return R.TextEditorLineNumbersStyle.Relative;case b.RenderLineNumbersType.Interval:return R.TextEditorLineNumbersStyle.Interval;case b.RenderLineNumbersType.On:default:return R.TextEditorLineNumbersStyle.On}}Ee.to=he})(re||(e.TextEditorLineNumbersStyle=re={}));var fe;(function(Ee){function Ae(q){if(q===R.EndOfLine.CRLF)return o.EndOfLineSequence.CRLF;if(q===R.EndOfLine.LF)return o.EndOfLineSequence.LF}Ee.from=Ae;function he(q){if(q===o.EndOfLineSequence.CRLF)return R.EndOfLine.CRLF;if(q===o.EndOfLineSequence.LF)return R.EndOfLine.LF}Ee.to=he})(fe||(e.EndOfLine=fe={}));var W;(function(Ee){function Ae(he){if(typeof he=="object")return he.viewId;switch(he){case R.ProgressLocation.SourceControl:return n.ProgressLocation.Scm;case R.ProgressLocation.Window:return n.ProgressLocation.Window;case R.ProgressLocation.Notification:return n.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ae})(W||(e.ProgressLocation=W={}));var K;(function(Ee){function Ae(q){const Pe={start:q.start+1,end:q.end+1};return q.kind&&(Pe.kind=$e.from(q.kind)),Pe}Ee.from=Ae;function he(q){const Pe={start:q.start-1,end:q.end-1};return q.kind&&(Pe.kind=$e.to(q.kind)),Pe}Ee.to=he})(K||(e.FoldingRange=K={}));var $e;(function(Ee){function Ae(q){if(q)switch(q){case R.FoldingRangeKind.Comment:return w.$Zu.Comment;case R.FoldingRangeKind.Imports:return w.$Zu.Imports;case R.FoldingRangeKind.Region:return w.$Zu.Region}}Ee.from=Ae;function he(q){if(q)switch(q.value){case w.$Zu.Comment.value:return R.FoldingRangeKind.Comment;case w.$Zu.Imports.value:return R.FoldingRangeKind.Imports;case w.$Zu.Region.value:return R.FoldingRangeKind.Region}}Ee.to=he})($e||(e.FoldingRangeKind=$e={}));var Fe;(function(Ee){function Ae(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?Q.from(he.selection):void 0,override:typeof he.override=="boolean"?r.$lG.id:void 0}}Ee.from=Ae})(Fe||(e.TextEditorOpenOptions=Fe={}));var qe;(function(Ee){function Ae(He){return He instanceof R.$eP?He.toJSON():typeof He=="string"?He:he(He)||q(He)?new R.$eP(He.baseUri??He.base,He.pattern).toJSON():He}Ee.from=Ae;function he(He){const Ze=He;return Ze?m.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function q(He){const Ze=He;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Pe(He){return typeof He=="string"?He:new R.$eP(m.URI.revive(He.baseUri),He.pattern)}Ee.to=Pe})(qe||(e.GlobPattern=qe={}));var xe;(function(Ee){function Ae(he){if(he){if(Array.isArray(he))return he.map(Ae);if(typeof he=="string")return he;{const q=he;return{language:q.language,scheme:q.scheme,pattern:qe.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}Ee.from=Ae})(xe||(e.LanguageSelector=xe={}));var et;(function(Ee){function Ae(q){return!!q&&typeof q=="object"&&"documents"in q&&Array.isArray(q.documents)&&q.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(He=>He&&typeof He=="object"&&"uri"in He&&m.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(Ze=>Ze instanceof R.$fO)))}Ee.is=Ae;function he(q){return{documents:q.documents.map(Pe=>Pe.map(He=>({uri:m.URI.from(He.uri),version:He.version,ranges:He.ranges.map(Ze=>Q.from(Ze))})))}}Ee.from=he})(et||(e.MappedEditsContext=et={}));var it;(function(Ee){function Ae(q){return{start:q.start,end:q.end}}Ee.from=Ae;function he(q){return new R.$HP(q.start,q.end)}Ee.to=he})(it||(e.NotebookRange=it={}));var ct;(function(Ee){function Ae(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}Ee.to=Ae;function he(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}Ee.from=he})(ct||(e.NotebookCellExecutionSummary=ct={}));var mt;(function(Ee){function Ae(he){if(he===P.NotebookCellExecutionState.Unconfirmed)return R.NotebookCellExecutionState.Pending;if(he===P.NotebookCellExecutionState.Pending)return;if(he===P.NotebookCellExecutionState.Executing)return R.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}Ee.to=Ae})(mt||(e.NotebookCellExecutionState=mt={}));var vt;(function(Ee){function Ae(q){switch(q){case R.NotebookCellKind.Markup:return P.CellKind.Markup;case R.NotebookCellKind.Code:default:return P.CellKind.Code}}Ee.from=Ae;function he(q){switch(q){case P.CellKind.Markup:return R.NotebookCellKind.Markup;case P.CellKind.Code:default:return R.NotebookCellKind.Code}}Ee.to=he})(vt||(e.NotebookCellKind=vt={}));var Ct;(function(Ee){function Ae(q){const Pe={metadata:q.metadata??Object.create(null),cells:[]};for(const He of q.cells)R.$IP.validate(He),Pe.cells.push(gt.from(He));return Pe}Ee.from=Ae;function he(q){const Pe=new R.$JP(q.cells.map(gt.to));return(0,c.$wg)(q.metadata)||(Pe.metadata=q.metadata),Pe}Ee.to=he})(Ct||(e.NotebookData=Ct={}));var gt;(function(Ee){function Ae(q){return{cellKind:vt.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:ct.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(pt.from):[]}}Ee.from=Ae;function he(q){return new R.$IP(vt.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(pt.to):void 0,q.metadata,q.internalMetadata?ct.to(q.internalMetadata):void 0)}Ee.to=he})(gt||(e.NotebookCellData=gt={}));var bt;(function(Ee){function Ae(q){return{mime:q.mime,valueBytes:i.$Se.wrap(q.data)}}Ee.from=Ae;function he(q){return new R.$KP(q.valueBytes.buffer,q.mime)}Ee.to=he})(bt||(e.NotebookCellOutputItem=bt={}));var pt;(function(Ee){function Ae(q){return{outputId:q.id,items:q.items.map(bt.from),metadata:q.metadata}}Ee.from=Ae;function he(q){const Pe=q.items.map(bt.to);return new R.$LP(Pe,q.outputId,q.metadata)}Ee.to=he})(pt||(e.NotebookCellOutput=pt={}));var Nt;(function(Ee){function Ae(Pe){return q(Pe)?{include:qe.from(Pe.include)??void 0,exclude:qe.from(Pe.exclude)??void 0}:qe.from(Pe)??void 0}Ee.from=Ae;function he(Pe){return q(Pe)?{include:qe.to(Pe.include),exclude:qe.to(Pe.exclude)}:qe.to(Pe)}Ee.to=he;function q(Pe){const He=Pe;return He?!(0,c.$sg)(He.include)&&!(0,c.$sg)(He.exclude):!1}})(Nt||(e.NotebookExclusiveDocumentPattern=Nt={}));var jt;(function(Ee){function Ae(he,q,Pe){const He=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===R.NotebookCellStatusBarAlignment.Left?P.CellStatusbarAlignment.Left:P.CellStatusbarAlignment.Right,command:q.toInternal(He,Pe),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Ee.from=Ae})(jt||(e.NotebookStatusBarItem=jt={}));var Ft;(function(Ee){function Ae(he,q,Pe){const He=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:q.toInternal(He,Pe),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}Ee.from=Ae})(Ft||(e.NotebookKernelSourceAction=Ft={}));var Ht;(function(Ee){function Ae(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}Ee.from=Ae})(Ht||(e.NotebookDocumentContentOptions=Ht={}));var kt;(function(Ee){function Ae(q){return{uri:q.uri,provides:q.provides}}Ee.from=Ae;function he(q){return new R.$NP(m.URI.revive(q.uri),q.provides)}Ee.to=he})(kt||(e.NotebookRendererScript=kt={}));var Wt;(function(Ee){function Ae(q){return{message:ye.fromStrict(q.message)||"",type:C.TestMessageType.Error,expected:q.expectedOutput,actual:q.actualOutput,contextValue:q.contextValue,location:q.location&&{range:Q.from(q.location.range),uri:q.location.uri},stackTrace:q.stackTrace?.map(Pe=>({label:Pe.label,position:Pe.position&&ve.from(Pe.position),uri:Pe.uri&&m.URI.revive(Pe.uri).toJSON()}))}}Ee.from=Ae;function he(q){const Pe=new R.$TP(typeof q.message=="string"?q.message:ye.to(q.message));return Pe.actualOutput=q.actual,Pe.expectedOutput=q.expected,Pe.contextValue=q.contextValue,Pe.location=q.location?Be.to(q.location):void 0,Pe}Ee.to=he})(Wt||(e.TestMessage=Wt={}));var Et;(function(Ee){Ee.namespace=C.$yJ,Ee.denamespace=C.$zJ})(Et||(e.TestTag=Et={}));var ft;(function(Ee){function Ae(q){const Pe=(0,u.$KQ)(q).controllerId;return{extId:O.$tJ.fromExtHostTestItem(q,Pe).toString(),label:q.label,uri:m.URI.revive(q.uri),busy:q.busy,tags:q.tags.map(He=>Et.namespace(Pe,He.id)),range:g.$Yt.lift(Q.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&ye.fromStrict(q.error)||null}}Ee.from=Ae;function he(q){return{parent:void 0,error:void 0,id:O.$tJ.fromString(q.extId).localId,label:q.label,uri:m.URI.revive(q.uri),tags:(q.tags||[]).map(Pe=>{const{tagId:He}=Et.denamespace(Pe);return new R.$UP(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:Q.to(q.range||void 0),canResolveChildren:!1,busy:q.busy,description:q.description||void 0,sortText:q.sortText||void 0}}Ee.toPlain=he})(ft||(e.TestItem=ft={})),function(Ee){function Ae(q){return{id:q.id}}Ee.from=Ae;function he(q){return new R.$UP(q.id)}Ee.to=he}(Et||(e.TestTag=Et={}));var wt;(function(Ee){const Ae=(q,Pe)=>{const He=q.value;if(!He)return;const Ze={...ft.toPlain(He.item),parent:Pe,taskStates:He.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(nt=>nt.type===C.TestMessageType.Error).map(Wt.to)})),children:[]};if(q.children)for(const ze of q.children.values()){const nt=Ae(ze,Ze);nt&&Ze.children.push(nt)}return Ze};function he(q){const Pe=new p.$sJ;for(const ze of q.items)Pe.insert(O.$tJ.fromString(ze.item.extId).path,ze);const He=[Pe.nodes],Ze=[];for(;He.length;)for(const ze of He.pop())ze.value?Ze.push(ze):ze.children&&He.push(ze.children.values());return{completedAt:q.completedAt,results:Ze.map(ze=>Ae(ze)).filter(c.$rg)}}Ee.to=he})(wt||(e.TestResults=wt={}));var Tt;(function(Ee){function Ae(ze){return{covered:ze.covered,total:ze.total}}function he(ze){return"line"in ze?ve.from(ze):Q.from(ze)}function q(ze){if(ze)return"endLineNumber"in ze?Q.to(ze):ve.to(ze)}function Pe(ze){if(ze.type===C.DetailType.Statement){const nt=[];if(ze.branches)for(const at of ze.branches)nt.push({executed:at.count,location:q(at.location),label:at.label});return new R.$ZP(ze.count,q(ze.location),ze.branches?.map(at=>new R.$1P(at.count,q(at.location),at.label)))}else return new R.$2P(ze.name,ze.count,q(ze.location))}Ee.to=Pe;function He(ze){if(typeof ze.executed=="number"&&ze.executed<0)throw new Error(`Invalid coverage count ${ze.executed}`);return"branches"in ze?{count:ze.executed,location:he(ze.location),type:C.DetailType.Statement,branches:ze.branches.length?ze.branches.map(nt=>({count:nt.executed,location:nt.location&&he(nt.location),label:nt.label})):void 0}:{type:C.DetailType.Declaration,name:ze.name,count:ze.executed,location:he(ze.location)}}Ee.fromDetails=He;function Ze(ze,nt,at){return R.$XP(at.statementCoverage),R.$XP(at.branchCoverage),R.$XP(at.declarationCoverage),{id:nt,uri:at.uri,statement:Ae(at.statementCoverage),branch:at.branchCoverage&&Ae(at.branchCoverage),declaration:at.declarationCoverage&&Ae(at.declarationCoverage),testIds:at instanceof R.$YP&&at.fromTests.length?at.fromTests.map(Lt=>O.$tJ.fromExtHostTestItem(Lt,ze).toString()):void 0}}Ee.fromFile=Ze})(Tt||(e.TestCoverage=Tt={}));var Mt;(function(Ee){function Ae(he){switch(he){case w.CodeActionTriggerType.Invoke:return R.CodeActionTriggerKind.Invoke;case w.CodeActionTriggerType.Auto:return R.CodeActionTriggerKind.Automatic}}Ee.to=Ae})(Mt||(e.CodeActionTriggerKind=Mt={}));var Vt;(function(Ee){function Ae(q){const Pe=new R.$3P(ie.to(q.kind),q.name,q.detail||"",m.URI.revive(q.uri),Q.to(q.range),Q.to(q.selectionRange));return Pe._sessionId=q._sessionId,Pe._itemId=q._itemId,Pe}Ee.to=Ae;function he(q,Pe,He){if(Pe=Pe??q._sessionId,He=He??q._itemId,Pe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:He,kind:ie.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:Q.from(q.range),selectionRange:Q.from(q.selectionRange),tags:q.tags?.map(G.from)}}Ee.from=he})(Vt||(e.TypeHierarchyItem=Vt={}));var Qt;(function(Ee){function Ae(he){if(he)return{value:he.value,tooltip:he.tooltip}}Ee.from=Ae})(Qt||(e.ViewBadge=Qt={}));var Jt;(function(Ee){function Ae(He,Ze,ze){const nt=Ze.fileData;return nt?new R.$9O(new R.$0O(nt.name,m.URI.revive(nt.uri),nt.id,(0,I.$hb)(()=>ze(nt.id)))):He===S.$it.uriList&&Ze.uriListData?new R.$8O(Pe(Ze.uriListData)):new R.$8O(Ze.asString)}Ee.to=Ae;async function he(He,Ze){const ze=await Ze.asString();if(He===S.$it.uriList)return{asString:ze,fileData:void 0,uriListData:q(ze)};const nt=Ze.asFile();return{asString:ze,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Ee.from=he;function q(He){return E.$Du.split(He).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return m.URI.parse(Ze)}catch{}return Ze})}function Pe(He){return E.$Du.create(He.map(Ze=>typeof Ze=="string"?Ze:m.URI.revive(Ze)))}})(Jt||(e.DataTransferItem=Jt={}));var It;(function(Ee){function Ae(q,Pe){const He=q.items.map(([Ze,ze])=>[Ze,Jt.to(Ze,ze,Pe)]);return new R.$$O(He)}Ee.toDataTransfer=Ae;async function he(q){const Pe={items:[]},He=[];for(const[Ze,ze]of q)He.push((async()=>{Pe.items.push([Ze,await Jt.from(Ze,ze)])})());return await Promise.all(He),Pe}Ee.from=he})(It||(e.DataTransfer=It={}));var Pt;(function(Ee){function Ae(q,Pe){return{kind:"reply",agentId:q.participant??Pe?.agentId??"",subCommand:q.command??Pe?.command,message:q.prompt,title:q.label}}Ee.from=Ae;function he(q){return{prompt:q.message,label:q.title,participant:q.agentId,command:q.subCommand}}Ee.to=he})(Pt||(e.ChatFollowup=Pt={}));var Rt;(function(Ee){function Ae(q){switch(q){case h.ChatMessageRole.System:return R.LanguageModelChatMessageRole.System;case h.ChatMessageRole.User:return R.LanguageModelChatMessageRole.User;case h.ChatMessageRole.Assistant:return R.LanguageModelChatMessageRole.Assistant}}Ee.to=Ae;function he(q){switch(q){case R.LanguageModelChatMessageRole.System:return h.ChatMessageRole.System;case R.LanguageModelChatMessageRole.User:return h.ChatMessageRole.User;case R.LanguageModelChatMessageRole.Assistant:return h.ChatMessageRole.Assistant}return h.ChatMessageRole.User}Ee.from=he})(Rt||(e.LanguageModelChatMessageRole=Rt={}));var zt;(function(Ee){function Ae(q){const Pe=q.content.map(nt=>nt.type==="text"?nt.value:nt.type==="tool_result"?new R.$vQ(nt.toolCallId,nt.value,nt.isError):new R.$xQ(nt.name,nt.toolCallId,nt.parameters)),He=Pe.find(nt=>typeof nt=="string")??"",Ze=Rt.to(q.role),ze=new R.$wQ(Ze,He,q.name);return ze.content2=Pe,ze}Ee.to=Ae;function he(q){const Pe=Rt.from(q.role),He=q.name,Ze=q.content2.map(ze=>{if(ze instanceof R.$vQ)return{type:"tool_result",toolCallId:ze.toolCallId,value:ze.content,isError:ze.isError};if(ze instanceof R.$xQ)return{type:"tool_use",toolCallId:ze.toolCallId,name:ze.name,parameters:ze.parameters};if(typeof ze!="string")throw new Error("Unexpected chat message content type");return{type:"text",value:ze}});return{role:Pe,name:He,content:Ze}}Ee.from=he})(zt||(e.LanguageModelChatMessage=zt={}));var Ot;(function(Ee){function Ae(q){return{kind:"markdownContent",content:ye.from(q.value)}}Ee.from=Ae;function he(q){return new R.$dQ(ye.to(q.content))}Ee.to=he})(Ot||(e.ChatResponseMarkdownPart=Ot={}));var Gt;(function(Ee){function Ae(q){return{kind:"markdownVuln",content:ye.from(q.value),vulnerabilities:q.vulnerabilities}}Ee.from=Ae;function he(q){return new R.$eQ(ye.to(q.content),q.vulnerabilities)}Ee.to=he})(Gt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Gt={}));var Yt;(function(Ee){function Ae(q){return{kind:"agentDetection",agentId:q.participant,command:q.command}}Ee.from=Ae;function he(q){return new R.$fQ(q.agentId,q.command)}Ee.to=he})(Yt||(e.ChatResponseDetectedParticipantPart=Yt={}));var Xt;(function(Ee){function Ae(he){return{kind:"confirmation",title:he.title,message:he.message,data:he.data,buttons:he.buttons}}Ee.from=Ae})(Xt||(e.ChatResponseConfirmationPart=Xt={}));var xt;(function(Ee){function Ae(q){const{value:Pe,baseUri:He}=q;function Ze(ze,nt){return ze.map(at=>{const Lt=m.URI.joinPath(nt,at.name);return{label:at.name,uri:Lt,children:at.children&&Ze(at.children,Lt)}})}return{kind:"treeData",treeData:{label:(0,$.$ih)(He),uri:He,children:Ze(Pe,He)}}}Ee.from=Ae;function he(q){const Pe=(0,s.$hi)(q.treeData);function He(nt){return nt.map(at=>({name:at.label,children:at.children&&He(at.children)}))}const Ze=Pe.uri,ze=Pe.children?He(Pe.children):[];return new R.$hQ(ze,Ze)}Ee.to=he})(xt||(e.ChatResponseFilesPart=xt={}));var Ut;(function(Ee){function Ae(q){const Pe=He=>m.URI.isUri(He);return{kind:"inlineReference",name:q.title,inlineReference:Pe(q.value)?q.value:J.from(q.value)}}Ee.from=Ae;function he(q){const Pe=(0,s.$hi)(q);return new R.$iQ(m.URI.isUri(Pe.inlineReference)?Pe.inlineReference:J.to(Pe.inlineReference),q.name)}Ee.to=he})(Ut||(e.ChatResponseAnchorPart=Ut={}));var Kt;(function(Ee){function Ae(q){return{kind:"progressMessage",content:ye.from(q.value)}}Ee.from=Ae;function he(q){return new R.$jQ(q.content.value)}Ee.to=he})(Kt||(e.ChatResponseProgressPart=Kt={}));var yt;(function(Ee){function Ae(q){return{kind:"warning",content:ye.from(q.value)}}Ee.from=Ae;function he(q){return new R.$lQ(q.content.value)}Ee.to=he})(yt||(e.ChatResponseWarningPart=yt={}));var Bt;(function(Ee){function Ae(q){return{kind:"move",uri:q.uri,range:Q.from(q.range)}}Ee.from=Ae;function he(q){return new R.$pQ(m.URI.revive(q.uri),Q.to(q.range))}Ee.to=he})(Bt||(e.ChatResponseMovePart=Bt={}));var qt;(function(Ee){function Ae(he){return{kind:"progressTask",content:ye.from(he.value)}}Ee.from=Ae})(qt||(e.ChatTask=qt={}));var an;(function(Ee){function Ae(he){return{kind:"progressTaskResult",content:typeof he=="string"?ye.from(he):void 0}}Ee.from=Ae})(an||(e.ChatTaskResult=an={}));var ln;(function(Ee){function Ae(q,Pe,He){return{kind:"command",command:Pe.toInternal(q.value,He)??{command:q.value.command,title:q.value.title}}}Ee.from=Ae;function he(q,Pe){return new R.$mQ(Pe.fromInternal(q.command)??{command:q.command.id,title:q.command.title})}Ee.to=he})(ln||(e.ChatResponseCommandButtonPart=ln={}));var wn;(function(Ee){function Ae(q){return{kind:"textEdit",uri:q.uri,edits:q.edits.map(Pe=>pe.from(Pe))}}Ee.from=Ae;function he(q){return new R.$qQ(m.URI.revive(q.uri),q.edits.map(Pe=>pe.to(Pe)))}Ee.to=he})(wn||(e.ChatResponseTextEditPart=wn={}));var cn;(function(Ee){function Ae(q){const Pe=a.ThemeIcon.isThemeIcon(q.iconPath)?q.iconPath:m.URI.isUri(q.iconPath)?{light:m.URI.revive(q.iconPath)}:q.iconPath&&"light"in q.iconPath&&"dark"in q.iconPath&&m.URI.isUri(q.iconPath.light)&&m.URI.isUri(q.iconPath.dark)?{light:m.URI.revive(q.iconPath.light),dark:m.URI.revive(q.iconPath.dark)}:void 0;return typeof q.value=="object"&&"variableName"in q.value?{kind:"reference",reference:{variableName:q.value.variableName,value:m.URI.isUri(q.value.value)||!q.value.value?q.value.value:J.from(q.value.value)},iconPath:Pe,options:q.options}:{kind:"reference",reference:m.URI.isUri(q.value)||typeof q.value=="string"?q.value:J.from(q.value),iconPath:Pe,options:q.options}}Ee.from=Ae;function he(q){const Pe=(0,s.$hi)(q),He=Ze=>m.URI.isUri(Ze)?Ze:J.to(Ze);return new R.$nQ(typeof Pe.reference=="string"?Pe.reference:"variableName"in Pe.reference?{variableName:Pe.reference.variableName,value:Pe.reference.value&&He(Pe.reference.value)}:He(Pe.reference))}Ee.to=he})(cn||(e.ChatResponseReferencePart=cn={}));var fn;(function(Ee){function Ae(he){return{kind:"codeCitation",value:he.value,license:he.license,snippet:he.snippet}}Ee.from=Ae})(fn||(e.ChatResponseCodeCitationPart=fn={}));var yn;(function(Ee){function Ae(Pe,He,Ze){return Pe instanceof R.$dQ?Ot.from(Pe):Pe instanceof R.$iQ?Ut.from(Pe):Pe instanceof R.$nQ?cn.from(Pe):Pe instanceof R.$jQ?Kt.from(Pe):Pe instanceof R.$hQ?xt.from(Pe):Pe instanceof R.$mQ?ln.from(Pe,He,Ze):Pe instanceof R.$qQ?wn.from(Pe):Pe instanceof R.$eQ?Gt.from(Pe):Pe instanceof R.$fQ?Yt.from(Pe):Pe instanceof R.$lQ?yt.from(Pe):Pe instanceof R.$gQ?Xt.from(Pe):Pe instanceof R.$oQ?fn.from(Pe):Pe instanceof R.$pQ?Bt.from(Pe):{kind:"markdownContent",content:ye.from("")}}Ee.from=Ae;function he(Pe,He){switch(Pe.kind){case"reference":return cn.to(Pe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return q(Pe,He)}}Ee.to=he;function q(Pe,He){switch(Pe.kind){case"markdownContent":return Ot.to(Pe);case"inlineReference":return Ut.to(Pe);case"progressMessage":return;case"treeData":return xt.to(Pe);case"command":return ln.to(Pe,He)}}Ee.toContent=q})(yn||(e.ChatResponsePart=yn={}));var tn;(function(Ee){function Ae(he,q){const Pe=he.variables.variables.filter(Ze=>Ze.isTool),He=he.variables.variables.filter(Ze=>!Ze.isTool);return{prompt:he.message,command:he.command,attempt:he.attempt??0,enableCommandDetection:he.enableCommandDetection??!0,isParticipantDetected:he.isParticipantDetected??!1,references:He.map(Zt.to),toolReferences:Pe.map(dn.to),location:vn.to(he.location),acceptedConfirmationData:he.acceptedConfirmationData,rejectedConfirmationData:he.rejectedConfirmationData,location2:q}}Ee.to=Ae})(tn||(e.ChatAgentRequest=tn={}));var vn;(function(Ee){function Ae(q){switch(q){case f.ChatAgentLocation.Notebook:return R.ChatLocation.Notebook;case f.ChatAgentLocation.Terminal:return R.ChatLocation.Terminal;case f.ChatAgentLocation.Panel:return R.ChatLocation.Panel;case f.ChatAgentLocation.Editor:return R.ChatLocation.Editor}}Ee.to=Ae;function he(q){switch(q){case R.ChatLocation.Notebook:return f.ChatAgentLocation.Notebook;case R.ChatLocation.Terminal:return f.ChatAgentLocation.Terminal;case R.ChatLocation.Panel:return f.ChatAgentLocation.Panel;case R.ChatLocation.Editor:return f.ChatAgentLocation.Editor}}Ee.from=he})(vn||(e.ChatLocation=vn={}));var Zt;(function(Ee){function Ae(he){const q=he.value;if(!q)throw new Error("Invalid value reference");return{id:he.id,name:he.name,range:he.range&&[he.range.start,he.range.endExclusive],value:(0,m.$Ac)(q)?m.URI.revive(q):q&&typeof q=="object"&&"uri"in q&&"range"in q&&(0,m.$Ac)(q.uri)?J.to((0,s.$hi)(q)):q,modelDescription:he.modelDescription}}Ee.to=Ae})(Zt||(e.ChatPromptReference=Zt={}));var dn;(function(Ee){function Ae(he){if(he.value)throw new Error("Invalid tool reference");return{id:he.id,range:he.range&&[he.range.start,he.range.endExclusive]}}Ee.to=Ae})(dn||(e.ChatLanguageModelToolReference=dn={}));var En;(function(Ee){function Ae(he,q,Pe){return{id:he.id,label:he.label,fullName:he.fullName,icon:he.icon?.id,value:he.values[0].value,insertText:he.insertText,detail:he.detail,documentation:he.documentation,command:q.toInternal(he.command,Pe)}}Ee.from=Ae})(En||(e.ChatAgentCompletionItem=En={}));var mn;(function(Ee){function Ae(he){return{errorDetails:he.errorDetails,metadata:he.metadata,nextQuestion:he.nextQuestion}}Ee.to=Ae})(mn||(e.ChatAgentResult=mn={}));var Sn;(function(Ee){function Ae(he,q,Pe){if(q.action.kind==="vote")return;const He=mn.to(he);if(q.action.kind==="command"){const Ze=q.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Pe.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:He}}else return q.action.kind==="followUp"?{action:{kind:"followUp",followup:Pt.to(q.action.followup)},result:He}:q.action.kind==="inlineChat"?{action:{kind:"editor",accepted:q.action.action==="accepted"},result:He}:{action:q.action,result:He}}Ee.to=Ae})(Sn||(e.ChatAgentUserActionEvent=Sn={}));var Pn;(function(Ee){function Ae(q){return{...q,string:q.toString()}}Ee.from=Ae;function he(q){const Pe={...q,toString:()=>q.string};return delete Pe.string,Pe}Ee.to=he})(Pn||(e.LanguageModelToolResult=Pn={}));var sn;(function(Ee){function Ae(he,q,Pe){return"terminalCommand"in he?{terminalCommand:he.terminalCommand,shouldExecute:he.shouldExecute}:"uri"in he?{uri:he.uri}:q.toInternal(he,Pe)}Ee.from=Ae})(sn||(e.TerminalQuickFix=sn={}));var $n;(function(Ee){function Ae(he){return{kind:gn.to(he.kind)}}Ee.to=Ae})($n||(e.PartialAcceptInfo=$n={}));var gn;(function(Ee){function Ae(he){switch(he){case w.PartialAcceptTriggerKind.Word:return R.PartialAcceptTriggerKind.Word;case w.PartialAcceptTriggerKind.Line:return R.PartialAcceptTriggerKind.Line;case w.PartialAcceptTriggerKind.Suggest:return R.PartialAcceptTriggerKind.Suggest;default:return R.PartialAcceptTriggerKind.Unknown}}Ee.to=Ae})(gn||(e.PartialAcceptTriggerKind=gn={}));var pn;(function(Ee){function Ae(he,q){return{id:q,label:he.label,description:he.description,canEdit:he.canEdit,collapsibleState:he.collapsibleState||k.DebugTreeItemCollapsibleState.None,contextValue:he.contextValue}}Ee.from=Ae})(pn||(e.DebugTreeItem=pn={}));var bn;(function(Ee){function Ae(he){return{id:he.id,modelDescription:he.modelDescription,parametersSchema:he.parametersSchema,displayName:he.displayName}}Ee.to=Ae})(bn||(e.LanguageModelToolDescription=bn={}))}),define(Oe[280],Le([1,0,48,150,77,149,104,156,4]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Q=e.$3Q=e.$2Q=e.$1Q=void 0,t=We(t),T=We(T);const s=(d,w,o,l)=>{let n=w;return{enumerable:!0,configurable:!1,get(){return n},set(u){if(!o(n,u)){const r=n;n=u,d.listener?.(l(u,r))}}}},S=(d,w)=>d===w,y={range:(d,w)=>d===w?!0:!d||!w?!1:d.isEqual(w),label:S,description:S,sortText:S,busy:S,error:S,canResolveChildren:S,tags:(d,w)=>!(d.length!==w.length||d.some(o=>!w.find(l=>o.id===l.id)))},p=d=>w=>({op:I.TestItemEventOp.SetProp,update:d(w)}),$=(d,w)=>({range:(()=>{let o;const l=p(n=>({range:t.$Yt.lift(T.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return o},set(n){d.listener?.({op:I.TestItemEventOp.DocumentSynced}),y.range(o,n)||(o=n,d.listener?.(l(n)))}}})(),label:s(d,w,y.label,p(o=>({label:o}))),description:s(d,void 0,y.description,p(o=>({description:o}))),sortText:s(d,void 0,y.sortText,p(o=>({sortText:o}))),canResolveChildren:s(d,!1,y.canResolveChildren,o=>({op:I.TestItemEventOp.UpdateCanResolveChildren,state:o})),busy:s(d,!1,y.busy,p(o=>({busy:o}))),error:s(d,void 0,y.error,p(o=>({error:T.MarkdownString.fromStrict(o)||null}))),tags:s(d,[],y.tags,(o,l)=>({op:I.TestItemEventOp.SetTags,new:o.map(T.TestTag.from),old:l.map(T.TestTag.from)}))}),a=d=>{const w=E.$tJ.fromString(d.extId),o=new m(w.controllerId,w.localId,d.label,v.URI.revive(d.uri)||void 0);return o.range=T.Range.to(d.range||void 0),o.description=d.description||void 0,o.sortText=d.sortText||void 0,o.tags=d.tags.map(l=>T.TestTag.to({id:(0,D.$zJ)(l).tagId})),o},c=d=>{let w;for(const o of d.tests){const l=a(o.item);(0,i.$KQ)(l).parent=w,w=l}return w};e.$1Q=c;class m{constructor(w,o,l,n){if(o.includes(E.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const u=(0,i.$JQ)(this,w);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof b?void 0:u.parent}},children:{value:(0,I.$IQ)(u,i.$KQ,m),enumerable:!0,writable:!1},...$(u,l)})}}e.$2Q=m;class b extends m{constructor(w,o){super(w,w,o,void 0),this._isRoot=!0}}e.$3Q=b;class g extends I.$EQ{constructor(w,o,l){super({controllerId:w,getDocumentVersion:n=>n&&l.getDocument(n)?.version,getApiFor:i.$KQ,getChildren:n=>n.children,root:new b(w,o),toITestItem:T.TestItem.from})}}e.$4Q=g}),define(Oe[281],Le([1,0,10,155,156,21,278,17,11,49,48,85,4,2,5,258,280,14,153,45,43,40,272,23]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d,w,o,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=e.$bR=e.$aR=e.$_Q=e.$$Q=e.$0Q=void 0,i=We(i),E=We(E);let u=class{#e;#t;#n;constructor(O,C,L){this.b=new Map,this.c=new Map,this.#e=O.getProxy(D.$bO.MainThreadCommands),this.d=C,this.#n=L,this.#t=O.getProxy(D.$bO.MainThreadTelemetry),this.converter=new r(this,R=>{const z=this.c.get(R);return z?.result===h.Void?z:void 0},C),this.f=[{processArgument(R){return(0,s.$hi)(R)}},{processArgument(R){return(0,I.$oo)(R,function(z){if(S.$Yt.isIRange(z))return E.Range.to(z);if(y.$Xt.isIPosition(z))return E.Position.to(z);if(S.$Yt.isIRange(z.range)&&p.URI.isUri(z.uri))return E.location.to(z);if(z instanceof b.$Se)return z.buffer.buffer;if(!Array.isArray(z))return z})}}]}registerArgumentProcessor(O){this.f.push(O)}registerApiCommand(O){const C=this.registerCommand(!1,O.id,async(...L)=>{const R=O.args.map((Q,J)=>{if(!Q.validate(L[J]))throw new Error(`Invalid argument '${Q.name}' when running '${O.id}', received: ${typeof L[J]=="object"?JSON.stringify(L[J],null,"	"):L[J]} `);return Q.convert(L[J])}),z=await this.executeCommand(O.internalId,...R);return O.result.convert(z,L,this.converter)},void 0,{description:O.description,args:O.args,returns:O.result.description});return this.c.set(O.id,O),new i.$dO(()=>{C.dispose(),this.c.delete(O.id)})}registerCommand(O,C,L,R,z,Q){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:L,thisArg:R,metadata:z,extension:Q}),O&&this.#e.$registerCommand(C),new i.$dO(()=>{this.b.delete(C)&&O&&this.#e.$unregisterCommand(C)})}executeCommand(O,...C){return this.d.trace("ExtHostCommands#executeCommand",O),this.g(O,C,!0)}async g(O,C,L){if(this.b.has(O))return this.#e.$fireCommandActivationEvent(O),this.h(O,C,!1);{let R=!1;const z=(0,I.$oo)(C,function(Q){if(Q instanceof i.$eO)return E.Position.from(Q);if(Q instanceof i.$fO)return E.Range.from(Q);if(Q instanceof i.$rO)return E.location.from(Q);if(i.$HP.isNotebookRange(Q))return E.NotebookRange.from(Q);if(Q instanceof ArrayBuffer)return R=!0,b.$Se.wrap(new Uint8Array(Q));if(Q instanceof Uint8Array)return R=!0,b.$Se.wrap(Q);if(Q instanceof b.$Se)return R=!0,Q;if(!Array.isArray(Q))return Q});try{const Q=await this.#e.$executeCommand(O,R?new g.$9w(z):z,L);return(0,s.$hi)(Q)}catch(Q){if(Q instanceof Error&&Q.message==="$executeCommand:retry")return this.g(O,C,!1);throw Q}}}async h(O,C,L){const R=this.b.get(O);if(!R)throw new Error("Unknown command");const{callback:z,thisArg:Q,metadata:J}=R;if(J?.args)for(let ve=0;ve<J.args.length;ve++)try{(0,t.$Ag)(C[ve],J.args[ve].constraint)}catch{throw new Error(`Running the contributed command: '${O}' failed. Illegal argument '${J.args[ve].name}' - ${J.args[ve].description}`)}const x=w.$ke.create();try{return await z.apply(Q,C)}catch(ve){if(O===this.converter.delegatingCommandId){const be=this.converter.getActualCommand(...C);be&&(O=be.command)}if(this.d.error(ve,O,R.extension?.identifier),!L)throw ve;if(R.extension?.identifier){const be=this.#n.onExtensionError(R.extension.identifier,ve);this.d.trace("forwarded error to extension?",be,R.extension?.identifier)}throw new class extends Error{constructor(){super((0,d.$vj)(ve)),this.id=O,this.source=R.extension?.displayName??R.extension?.name}}}finally{this.j(R,O,x.elapsed())}}j(O,C,L){O.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:O.extension.identifier.value,id:new o.$Fp(C),duration:L})}$executeContributedCommand(O,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",O);const L=this.b.get(O);return L?(C=C.map(R=>this.f.reduce((z,Q)=>Q.processArgument(z,L.extension?.identifier),R)),this.h(O,C,!0)):Promise.reject(new Error(`Contributed command '${O}' does not exist.`))}getCommands(O=!1){return this.d.trace("ExtHostCommands#getCommands",O),this.#e.$getCommands().then(C=>(O&&(C=C.filter(L=>L[0]!=="_")),C))}$getContributedCommandMetadata(){const O=Object.create(null);for(const[C,L]of this.b){const{metadata:R}=L;R&&(O[C]=R)}return Promise.resolve(O)}};e.$0Q=u,e.$0Q=u=Ve([je(0,c.$OQ),je(1,v.$fk),je(2,l.$9Q)],u),e.$$Q=(0,a.$Ki)("IExtHostCommands");class r{constructor(O,C,L){this.d=O,this.f=C,this.g=L,this.delegatingCommandId=`__vsc${(0,n.$7g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(O,C){if(!O)return;const L={$ident:void 0,id:O.command,title:O.title,tooltip:O.tooltip};if(!O.command)return L;const R=this.f(O.command);if(R)L.id=R.internalId,L.arguments=R.args.map((z,Q)=>z.convert(O.arguments&&O.arguments[Q]));else if((0,T.$Pb)(O.arguments)){const z=`${O.command} /${++this.c}`;this.b.set(z,O),C.add((0,$.$Xc)(()=>{this.b.delete(z),this.g.trace("CommandsConverter#DISPOSE",z)})),L.$ident=z,L.id=this.delegatingCommandId,L.arguments=[z],this.g.trace("CommandsConverter#CREATE",O.command,z)}return L}fromInternal(O){return typeof O.$ident=="string"?this.b.get(O.$ident):{command:O.id,title:O.title,arguments:O.arguments}}getActualCommand(...O){return this.b.get(O[0])}h(...O){const C=this.getActualCommand(...O);return this.g.trace("CommandsConverter#EXECUTE",O[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${O[0]}`)}}e.$_Q=r;class f{static{this.Uri=new f("uri","Uri of a text document",O=>p.URI.isUri(O),O=>O)}static{this.Position=new f("position","A position in a text document",O=>i.$eO.isPosition(O),E.Position.from)}static{this.Range=new f("range","A range in a text document",O=>i.$fO.isRange(O),E.Range.from)}static{this.Selection=new f("selection","A selection in a text document",O=>i.$gO.isSelection(O),E.Selection.from)}static{this.Number=new f("number","",O=>typeof O=="number",O=>O)}static{this.String=new f("string","",O=>typeof O=="string",O=>O)}static{this.StringArray=f.Arr(f.String)}static Arr(O){return new f(`${O.name}_array`,`Array of ${O.name}, ${O.description}`,C=>Array.isArray(C)&&C.every(L=>O.validate(L)),C=>C.map(L=>O.convert(L)))}static{this.CallHierarchyItem=new f("item","A call hierarchy item",O=>O instanceof i.$DO,E.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new f("item","A type hierarchy item",O=>O instanceof i.$3P,E.TypeHierarchyItem.from)}static{this.TestItem=new f("testItem","A VS Code TestItem",O=>O instanceof m.$2Q,E.TestItem.from)}constructor(O,C,L,R){this.name=O,this.description=C,this.validate=L,this.convert=R}optional(){return new f(this.name,`(optional) ${this.description}`,O=>O==null||this.validate(O),O=>O===void 0?void 0:O===null?null:this.convert(O))}with(O,C){return new f(O??this.name,C??this.description,this.validate,this.convert)}}e.$aR=f;class h{static{this.Void=new h("no result",O=>O)}constructor(O,C){this.description=O,this.convert=C}}e.$bR=h;class k{constructor(O,C,L,R,z){this.id=O,this.internalId=C,this.description=L,this.args=R,this.result=z}}e.$cR=k}),define(Oe[282],Le([1,0,9,2,12,3,208]),function(ue,e,t,i,E,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZR=e.$YR=void 0,e.$YR="remoteFilesystem";class T extends D.$XR{static register(s,S,y){const p=s.getConnection();if(!p)return i.$Zc.None;const $=new i.$Yc,a=(async()=>{try{const c=await s.getRawEnvironment();c?S.registerProvider(E.Schemas.vscodeRemote,$.add(new T(c,p))):y.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(c){y.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,t.$bb)(c))}})();return $.add(S.onWillActivateFileSystemProvider(c=>{c.scheme===E.Schemas.vscodeRemote&&c.join(a)})),$}constructor(s,S){super(S.getChannel(e.$YR),{pathCaseSensitive:s.os===I.OperatingSystem.Linux})}}e.$ZR=T}),define(Oe[78],Le([1,0,96,84,31,283,14,9,6,2,8,3,23,51,61]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Bi=e.$Ai=e.$zi=void 0,e.$Ci=r,e.$Di=f,e.$Fi=P,e.$Gi=O;const c=3e4;class m{traceSocketEvent(L,R){a.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,R)}constructor(L,R=""){this.f=!0,this.debugLabel=R,this.socket=L,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=Q=>{if(this.traceSocketEvent(a.SocketDiagnosticsEventType.Error,{code:Q?.code,message:Q?.message}),Q){if(Q.code==="EPIPE")return;(0,T.$4)(Q)}},this.socket.on("error",this.a);let z;this.b=Q=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Close,{hadError:Q}),this.f=!1,z&&clearTimeout(z)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,z=setTimeout(()=>L.destroy(),c)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(L){const R=z=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Read,z),L(D.$Se.wrap(z))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(L){const R=z=>{L({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:z,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(L){const R=()=>{L()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(L){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(a.SocketDiagnosticsEventType.Write,L),this.socket.write(L.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,T.$4)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,T.$4)(R)}}end(){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((L,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),L();return}const z=()=>{this.socket.off("close",z),this.socket.off("end",z),this.socket.off("error",z),this.socket.off("timeout",z),this.socket.off("drain",z),this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),L()};this.socket.on("close",z),this.socket.on("end",z),this.socket.on("error",z),this.socket.on("timeout",z),this.socket.on("drain",z)})}}e.$zi=m;var b;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var g;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(g||(g={}));class d extends s.$Zc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(L,R){this.socket.traceSocketEvent(L,R)}constructor(L,R,z,Q){super(),this.f=this.B(new v.$qe),this.g=this.B(new v.$qe),this.h=!1,this.j={state:g.PeekHeader,readLen:b.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=L,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:z?.byteLength||0,recordInflateBytes:Q}),this.a=this.B(new w(this,R,z,Q,this.f,(J,x)=>this.m(J,x))),this.B(this.a.onError(J=>{console.error(J),(0,T.$4)(J),this.g.fire({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:J})})),this.b=new a.$ui,this.B(this.socket.onData(J=>this.n(J))),this.B(this.socket.onClose(async J=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(J)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this.f.event(L)}onClose(L){return this.g.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){let R=0;for(;R<L.byteLength;)this.a.writeMessage(L.slice(R,Math.min(R+b.MaxWebSocketMessageLength,L.byteLength)),{compressed:!0,opcode:2}),R+=b.MaxWebSocketMessageLength}m(L,{compressed:R,opcode:z}){if(this.h)return;this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,L);let Q=b.MinHeaderByteSize;L.byteLength<126?Q+=0:L.byteLength<2**16?Q+=2:Q+=8;const J=D.$Se.alloc(Q),x=R?64:0,ve=z&15;if(J.writeUInt8(128|x|ve,0),L.byteLength<126)J.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){J.writeUInt8(126,1);let be=1;J.writeUInt8(L.byteLength>>>8&255,++be),J.writeUInt8(L.byteLength>>>0&255,++be)}else{J.writeUInt8(127,1);let be=1;J.writeUInt8(0,++be),J.writeUInt8(0,++be),J.writeUInt8(0,++be),J.writeUInt8(0,++be),J.writeUInt8(L.byteLength>>>24&255,++be),J.writeUInt8(L.byteLength>>>16&255,++be),J.writeUInt8(L.byteLength>>>8&255,++be),J.writeUInt8(L.byteLength>>>0&255,++be)}this.socket.write(D.$Se.concat([J,L]))}end(){this.h=!0,this.socket.end()}n(L){if(L.byteLength!==0){for(this.b.acceptChunk(L);this.b.byteLength>=this.j.readLen;)if(this.j.state===g.PeekHeader){const R=this.b.peek(this.j.readLen),z=R.readUInt8(0),Q=(z&128)>>>7,J=(z&64)>>>6,x=z&15,ve=R.readUInt8(1),be=(ve&128)>>>7,se=ve&127;this.j.state=g.ReadHeader,this.j.readLen=b.MinHeaderByteSize+(be?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=Q,this.j.firstFrameOfMessage&&(this.j.compressed=!!J),this.j.firstFrameOfMessage=!!Q,this.j.mask=0,this.j.opcode=x,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===g.ReadHeader){const R=this.b.read(this.j.readLen),z=R.readUInt8(1),Q=(z&128)>>>7;let J=z&127,x=1;J===126?J=R.readUInt8(++x)*2**8+R.readUInt8(++x):J===127&&(J=R.readUInt8(++x)*0+R.readUInt8(++x)*0+R.readUInt8(++x)*0+R.readUInt8(++x)*0+R.readUInt8(++x)*2**24+R.readUInt8(++x)*2**16+R.readUInt8(++x)*2**8+R.readUInt8(++x));let ve=0;Q&&(ve=R.readUInt8(++x)*2**24+R.readUInt8(++x)*2**16+R.readUInt8(++x)*2**8+R.readUInt8(++x)),this.j.state=g.ReadBody,this.j.readLen=J,this.j.mask=ve,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===g.ReadBody){const R=this.b.read(this.j.readLen);this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,R),n(R,this.j.mask),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,R),this.j.state=g.PeekHeader,this.j.readLen=b.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(R,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(R,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$Ai=d;class w extends s.$Zc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$Se.alloc(0)}constructor(L,R,z,Q,J,x){super(),this.n=L,this.r=J,this.s=x,this.a=this.B(new v.$qe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.$qe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new v.$qe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,R?(this.b=this.B(new o(this.n,Q,z,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(ve=>this.a.fire(ve))),this.B(this.f.onError(ve=>this.a.fire(ve)))):(this.b=null,this.f=null)}writeMessage(L,R){this.g.push({data:L,options:R}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:L,options:R}=this.g.shift();if(this.f&&R.compressed){const z=await this.w(this.f,L);this.s(z,R)}else this.s(L,{...R,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(L,R){return new Promise((z,Q)=>{L.write(R),L.flush(J=>z(J))})}acceptFrame(L,R,z){this.h.push({data:L,isCompressed:R,isLastFrameOfMessage:z}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const L=this.h.shift();if(this.b&&L.isCompressed){const R=await this.C(this.b,L.data,L.isLastFrameOfMessage);this.r.fire(R)}else this.r.fire(L.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(L,R,z){return new Promise((Q,J)=>{L.write(R),z&&L.write(D.$Se.fromByteArray([0,0,255,255])),L.flush(x=>Q(x))})}}class o extends s.$Zc{get recordedInflateBytes(){return this.j?D.$Se.concat(this.f):D.$Se.alloc(0)}constructor(L,R,z,Q){super(),this.h=L,this.j=R,this.a=this.B(new v.$qe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(Q),this.b.on("error",J=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateError,{message:J?.message,code:J?.code}),this.a.fire(J)}),this.b.on("data",J=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateData,J),this.g.push(D.$Se.wrap(J))}),z&&(this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialWrite,z.buffer),this.b.write(z.buffer),this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(L){this.j&&this.f.push(L.clone()),this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateWrite,L),this.b.write(L.buffer)}flush(L){this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateFlushFired);const R=D.$Se.concat(this.g);this.g.length=0,L(R)})}}class l extends s.$Zc{constructor(L,R){super(),this.g=L,this.a=this.B(new v.$qe),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",z=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateError,{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateData,z),this.f.push(D.$Se.wrap(z))})}write(L){this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateWrite,L.buffer),this.b.write(L.buffer)}flush(L){this.b.flush(2,()=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateFlushFired);let R=D.$Se.concat(this.f);this.f.length=0,R=R.slice(0,R.byteLength-4),L(R)})}}function n(C,L){if(L===0)return;const R=C.byteLength>>>2;for(let be=0;be<R;be++){const se=C.readUInt32BE(be*4);C.writeUInt32BE(se^L,be*4)}const z=R*4,Q=C.byteLength-z,J=L>>>24&255,x=L>>>16&255,ve=L>>>8&255;Q>=1&&C.writeUInt8(C.readUInt8(z)^J,z),Q>=2&&C.writeUInt8(C.readUInt8(z+1)^x,z+1),Q>=3&&C.writeUInt8(C.readUInt8(z+2)^ve,z+2)}e.$Bi=process.env.XDG_RUNTIME_DIR;const u={[y.Platform.Linux]:107,[y.Platform.Mac]:103};function r(){const C=(0,p.$7g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const L=process.platform!=="darwin"&&e.$Bi?e.$Bi:(0,E.tmpdir)(),R=(0,S.$oc)(L,`vscode-ipc-${C}.sock`);return h(R),R}function f(C,L,R){const Q=(0,t.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${Q}-${R}-${L}-sock`;const J=R.substr(0,4),x=L.substr(0,6);let ve;return process.platform!=="darwin"&&e.$Bi&&!process.env.VSCODE_PORTABLE?ve=(0,S.$oc)(e.$Bi,`vscode-${Q}-${J}-${x}.sock`):ve=(0,S.$oc)(C,`${J}-${x}.sock`),h(ve),ve}function h(C){const L=u[y.$x];typeof L=="number"&&C.length>=L&&console.warn(`WARNING: IPC handle "${C}" is longer than ${L} chars, try a shorter --user-data-dir`)}class k extends $.$oi{static b(L){const R=v.Event.fromNodeEventEmitter(L,"connection");return v.Event.map(R,z=>({protocol:new a.$vi(new m(z,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(z,"close"))}))}constructor(L){super(k.b(L)),this.d=L}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ei=k;function P(C){return new Promise((L,R)=>{const z=(0,i.createServer)();z.on("error",R),z.listen(C,()=>{z.removeListener("error",R),L(new k(z))})})}function O(C,L){return new Promise((R,z)=>{const Q=(0,i.createConnection)(C,()=>{Q.removeListener("error",z),R(a.$wi.fromSocket(new m(Q,`ipc-client${L}`),L))});Q.once("error",z)})}}),define(Oe[157],Le([1,0,93,13,14,9,10,28,27,94,11,47,227,283]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0,e.$qs=m;let a=class extends y.$eq{constructor(g,d,w,o){super(o),this.m=g,this.n=d,this.r=w,this.s(),this.B(g.onDidChangeConfiguration(l=>{l.affectsConfiguration("http")&&this.s()}))}s(){const g=this.m.getValue("http");this.f=g?.proxy,this.g=!!g?.proxyStrictSSL,this.h=g?.proxyAuthorization}async request(g,d){const{f:w,g:o}=this;let l;try{l=await(0,s.$Wm)(this.m,this.r,this.n.args,process.env)}catch(r){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,I.$bb)(r)))}const n={...process.env,...l},u=g.agent?g.agent:await(0,p.$os)(g.url||"",n,{proxyUrl:w,strictSSL:o});return g.agent=u,g.strictSSL=o,this.h&&(g.headers={...g.headers||{},"Proxy-Authorization":this.h}),this.c(g.isChromiumNetwork?"electron":"node",g,()=>m(g,d))}async resolveProxy(g){}async lookupAuthorization(g){}async lookupKerberosAuthorization(g){try{const d=await new Promise((u,r)=>{ue(["kerberos"],u,r)}).then(We),w=new URL(g),o=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${w.hostname}`:`HTTP@${w.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${w}`,`spn:${o}`),"Negotiate "+await(await d.initializeClient(o)).step("")}catch(d){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",d);return}}async loadCertificates(){return(await new Promise((d,w)=>{ue(["@vscode/proxy-agent"],d,w)}).then(We)).loadSystemCertificates({log:this.r})}};e.$ps=a,e.$ps=a=Ve([je(0,T.$ej),je(1,v.$Si),je(2,S.$fk),je(3,S.$gk)],a);async function c(b){return((0,t.parse)(b.url).protocol==="https:"?await new Promise((w,o)=>{ue(["https"],w,o)}).then(We):await new Promise((w,o)=>{ue(["http"],w,o)}).then(We)).request}async function m(b,g){return i.Promises.withAsyncBody(async(d,w)=>{const o=(0,t.parse)(b.url),l=b.getRawRequest?b.getRawRequest(b):await c(b),n={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,D.$pg)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(n.auth=b.user+":"+b.password);const u=l(n,r=>{const f=(0,D.$ng)(b.followRedirects)?b.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&f>0&&r.headers.location)m({...b,url:r.headers.location,followRedirects:f-1},g).then(d,w);else{let h=r;!b.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(h=r.pipe((0,$.createGunzip)())),d({res:r,stream:(0,E.$8e)(h)})}});u.on("error",w),b.timeout&&u.setTimeout(b.timeout),b.isChromiumNetwork&&u.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&u.write(b.data),u.end(),g.onCancellationRequested(()=>{u.abort(),w(new I.$9)})})}}),define(Oe[158],Le([1,0,50,84,14,6,2,12,8,3,70,78,28,11,94,146,101,55,270]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=void 0,e.$Ln=d,t=We(t),i=We(i);async function d(r={},f,h,k,P,O){const C=await(0,m.$6m)(h,k.userDataPath);let L={};if(f)try{L=await(0,a.$Wm)(O,P,k.args,process.env)}catch(ve){P.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ve)}const z={...process.env,...L,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(C),...r},Q=k.isBuilt?(0,v.$oc)(k.appRoot,"bin"):(0,v.$oc)(k.appRoot,"resources","server","bin-dev"),J=(0,v.$oc)(Q,"remote-cli");let x=l(z,"PATH");return x?x=J+v.$yc+x:x=J,n(z,"PATH",x),k.args["without-browser-env-var"]||(z.BROWSER=(0,v.$oc)(Q,"helpers",s.$l?"browser.cmd":"browser.sh")),u(z),z}class w{constructor(f,h){this.socket=f,this.initialDataChunk=h}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let f,h,k;return this.socket instanceof y.$zi?(f=!0,h=!1,k=E.$Se.alloc(0)):(f=!1,h=this.socket.permessageDeflate,k=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:f,permessageDeflate:h,inflateBytes:k.buffer.toString("base64")}}}let o=class extends D.$Zc{constructor(f,h,k,P,O,C,L,R){super(),this.m=f,this.n=O,this.r=C,this.s=L,this.t=R,this.b=new I.$qe,this.onClose=this.b.event,this.c=!s.$l||!this.n.args["socket-path"],this.f=!1,this.g=h,this.h=null,this.j=new w(k,P),this.w("New connection established.")}dispose(){this.D(),super.dispose()}get u(){return`[${this.g}][${this.m.substr(0,8)}][ExtensionHostConnection] `}w(f){this.r.info(`${this.u}${f}`)}y(f){this.r.error(`${this.u}${f}`)}async z(f,h){const k=new D.$Yc;k.add(h.socket),k.add((0,D.$Xc)(()=>{f.destroy()}));const P=()=>{k.dispose()};k.add(h.socket.onEnd(P)),k.add(h.socket.onClose(P)),k.add(I.Event.fromNodeEventEmitter(f,"end")(P)),k.add(I.Event.fromNodeEventEmitter(f,"close")(P)),k.add(I.Event.fromNodeEventEmitter(f,"error")(P)),k.add(h.socket.onData(O=>f.write(O.buffer))),k.add(I.Event.fromNodeEventEmitter(f,"data")(O=>{h.socket.write(E.$Se.wrap(O))})),h.initialDataChunk.byteLength>0&&f.write(h.initialDataChunk.buffer)}async C(f,h){await h.socketDrain();const k=h.toIExtHostSocketMessage();let P;h.socket instanceof y.$zi?P=h.socket.socket:P=h.socket.socket.socket,f.send(k,P)}shortenReconnectionGraceTimeIfNecessary(){if(!this.h)return;const f={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.h.send(f)}acceptReconnection(f,h,k){this.g=f,this.w("The client has reconnected.");const P=new w(h,k);if(!this.h){this.j=P;return}this.C(this.h,P)}D(){this.f||(this.f=!0,this.j&&(this.j.socket.end(),this.j=null),this.h&&(this.h.kill(),this.h=null),this.b.fire(void 0))}async start(f){try{let h=process.execArgv?process.execArgv.filter(J=>!/^--inspect(-brk)?=/.test(J)):[];f.port&&!process.pkg&&(h=[`--inspect${f.break?"-brk":""}=${f.port}`]);const k=await d(f.env,!0,f.language,this.n,this.r,this.t);(0,S.$rm)(k);let P;if(this.c)(0,g.$nn)(new g.$ln,k),P=null;else{const{namedPipeServer:J,pipeName:x}=await this.F();(0,g.$nn)(new g.$kn(x),k),P=J}const O={env:k,execArgv:h,silent:!0};O.execArgv.unshift("--dns-result-order=ipv4first");const C=["--type=extensionHost","--transformURIs"],L=this.n.args["use-host-proxy"];C.push(`--useHostProxy=${L?"true":"false"}`),this.h=t.fork(T.$5g.asFileUri("bootstrap-fork").fsPath,C,O);const R=this.h.pid;this.w(`<${R}> Launched Extension Host Process.`),this.h.stdout.setEncoding("utf8"),this.h.stderr.setEncoding("utf8");const z=I.Event.fromNodeEventEmitter(this.h.stdout,"data"),Q=I.Event.fromNodeEventEmitter(this.h.stderr,"data");if(this.B(z(J=>this.w(`<${R}> ${J}`))),this.B(Q(J=>this.w(`<${R}><stderr> ${J}`))),this.h.on("error",J=>{this.y(`<${R}> Extension Host Process had an error`),this.r.error(J),this.D()}),this.h.on("exit",(J,x)=>{this.s.setExitInfo(this.m,{code:J,signal:x}),this.w(`<${R}> Extension Host Process exited with code: ${J}, signal: ${x}.`),this.D()}),P)P.on("connection",J=>{P.close(),this.z(J,this.j)});else{const J=x=>{x.type==="VSCODE_EXTHOST_IPC_READY"&&(this.h.removeListener("message",J),this.C(this.h,this.j),this.j=null)};this.h.on("message",J)}}catch(h){console.error("ExtensionHostConnection errored"),h&&console.error(h)}}F(){return new Promise((f,h)=>{const k=(0,y.$Ci)(),P=i.createServer();P.on("error",h),P.listen(k,()=>{P?.removeListener("error",h),f({pipeName:k,namedPipeServer:P})})})}};e.$Mn=o,e.$Mn=o=Ve([je(4,b.$in),je(5,$.$fk),je(6,c.$4m),je(7,p.$ej)],o);function l(r,f){const h=Object.keys(r).filter(P=>P.toLowerCase()===f.toLowerCase()),k=h.length>0?h[0]:f;return r[k]}function n(r,f,h){const k=Object.keys(r).filter(O=>O.toLowerCase()===f.toLowerCase()),P=k.length>0?k[0]:f;r[P]=h}function u(r){for(const f of Object.keys(r))r[f]===null&&delete r[f]}});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[284],Le([1,0,89,11,72,132,28,47,157,40,24,30,144,142,95,124,62,2,126,73,12,15,29,55,135,92,136,9,4,8,32,225,88,35,140,71,3,64,147,33,54,74,145,143,128,129,7,285]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d,w,o,l,n,u,r,f,h,k,P,O,C,L,R,z,Q,J,x,ve,be,se,V,B,j,U,te,le,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=X,m=$t(m);class oe extends b.$Zc{constructor(A,Y){super(),this.a=A,this.b=Y,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const A=await this.f();await A.invokeFunction(async Y=>{const pe=Y.get(D.$ej),ne=Y.get(i.$fk);J.$l&&(pe.getValue("security.restrictUNCAccess")===!1?(0,ye.disableUNCAccessRestrictions)():(0,ye.addUNCHostToAllowlist)(pe.getValue("security.allowedUNCHosts")));try{await this.g(A.createInstance(u.$Gq,new i.$nk(ne.getLevel(),!1)))}catch(ie){throw ne.error(ie),console.error((0,h.$bb)(ie)),ie}})}async f(){const A=new t.$Ii,Y={_serviceBrand:void 0,...m.default};A.set(l.$yk,Y);const pe=new n.$jn(this.a,Y);A.set(n.$in,pe);const ne=new te.$6R((0,i.$tk)(pe),pe.logsHome);A.set(i.$gk,ne);const ie=new U.$dS(this.B(ne.createLogger("remoteCLI",{name:(0,le.localize)(2504,null)})));A.set(i.$fk,ie),ie.trace(`Remote configuration data at ${this.b}`),ie.trace("process arguments:",this.a);const G=this.B(new g.$ar(ie));A.set(o.$fl,G),G.registerProvider(w.Schemas.file,this.B(new d.$Dr(ie)));const Z=new z.$5s(G);A.set(R.$Pl,Z);const ce=this.B(new B.$bS(Z,pe,G,ie));A.set(be.$Rl,ce);const we=this.B(new I.$6o(ce.defaultProfile.settingsResource,G,new V.$Do,ie));return A.set(D.$ej,we),await Promise.all([we.initialize(),ce.init()]),A.set(T.$dq,new E.$Hi(v.$ps)),A.set(L.$0o,new E.$Hi(C.$yS)),A.set(S.$em,s.$Hp),A.set(y.$tp,new E.$Hi(p.$Aq)),A.set(se.$Tq,new E.$Hi(j.$cS)),A.set(x.$Xq,new E.$Hi(ve.$1R)),A.set(a.$Dq,new E.$Hi(a.$Fq)),A.set($.$9q,new E.$Hi($.$0q)),A.set(r.$js,new E.$Hi(f.$ls)),new c.$Gr(A)}async g(A){if(this.a["list-extensions"])return A.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const Y={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return A.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),Y,!!this.a.force)}else{if(this.a["uninstall-extension"])return A.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return A.updateExtensions();if(this.a["locate-extension"])return A.locateExtension(this.a["locate-extension"])}}h(A){return A.map(Y=>/\.vsix$/i.test(Y)?k.URI.file((0,P.$nc)(Y)?Y:(0,P.$oc)((0,O.cwd)(),Y)):Y)}}function _(M){setTimeout(()=>process.exit(M),0)}async function X(M,A,Y){if(M.help){const ne=m.default.serverApplicationName+(J.$l?".cmd":"");console.log((0,Q.$Km)(m.default.nameLong,ne,m.default.version,Y,{noInputFiles:!0,noPipe:!0}));return}if(M.version){console.log((0,Q.$Lm)(m.default.version,m.default.commit));return}const pe=new oe(M,A);try{await pe.run(),_(0)}catch{_(1)}finally{pe.dispose()}}}),define(Oe[286],Le([1,0,78,255,20,281,4,11,98]),function(ue,e,t,i,E,I,D,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eR=e.$dR=void 0,i=We(i),E=We(E);class s{constructor(p,$,a){this.b=p,this.c=$,this.f=a,this.a=i.createServer((c,m)=>this.h(c,m)),this.g().catch(c=>($.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,$){const a=(m,b)=>{$.writeHead(m,{"content-type":"application/json"}),$.end(JSON.stringify(b||null),g=>g&&this.c.error(g))},c=[];p.setEncoding("utf8"),p.on("data",m=>c.push(m)),p.on("end",async()=>{try{const m=JSON.parse(c.join(""));let b;switch(m.type){case"open":b=await this.i(m);break;case"openExternal":b=await this.j(m);break;case"status":b=await this.l(m);break;case"extensionManagement":b=await this.k(m);break;case"clipboard":b=await this.m(m);break;default:a(404,`Unknown message type: ${m.type}`);break}a(200,b)}catch(m){const b=m instanceof Error?m.message:JSON.stringify(m);a(500,b),this.c.error("Error while processing pipe request",m)}})}async i(p){const{fileURIs:$,folderURIs:a,forceNewWindow:c,diffMode:m,mergeMode:b,addMode:g,forceReuseWindow:d,gotoLineMode:w,waitMarkerFilePath:o,remoteAuthority:l}=p,n=[];if(Array.isArray(a))for(const h of a)try{n.push({folderUri:D.URI.parse(h)})}catch{}if(Array.isArray($))for(const h of $)try{(0,v.$dj)(h)?n.push({workspaceUri:D.URI.parse(h)}):n.push({fileUri:D.URI.parse(h)})}catch{}const u=o?D.URI.file(o):void 0,f={forceNewWindow:c,diffMode:m,mergeMode:b,addMode:g,gotoLineMode:w,forceReuseWindow:d,preferNewWindow:!d&&!u&&!g,waitMarkerFileURI:u,remoteAuthority:l};this.b.executeCommand("_remoteCLI.windowOpen",n,f)}async j(p){for(const $ of p.uris){const a=D.URI.parse($),c=a.scheme==="file"?a:$;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(p){const $=c=>c?.map(m=>/\.vsix$/i.test(m)?D.URI.parse(m):m),a={list:p.list,install:$(p.install),uninstall:$(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",a)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}async m(p){return await this.b.executeCommand("_remoteCLI.setClipboard",p.content)}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&E.existsSync(this.f)&&E.unlinkSync(this.f)}}e.$dR=s;let S=class extends s{constructor(p,$){super(p,$,(0,t.$Ci)())}};e.$eR=S,e.$eR=S=Ve([je(0,I.$$Q),je(1,T.$fk)],S)}),define(Oe[287],Le([1,0,31,6,21,2,8,3,4,78,76,286,138,97,148,265,267,158,13,139]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TR=void 0,t=We(t),D=We(D),T=We(T),c=We(c);class w extends m.$SR{constructor(n,u,r,f,h){super({getFolderUri:k=>{const P=u.filter(O=>O.name===k);if(P&&P.length>0)return P[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(k,P)=>f[`config:${P}`],getExecPath:()=>n.VSCODE_EXEC_PATH,getAppRoot:()=>n.VSCODE_CWD,getFilePath:()=>{if(r)return D.$mc(r.fsPath)},getSelectedText:()=>f.selectedText,getLineNumber:()=>f.lineNumber,getExtension:async k=>{const O=(await h.getInstalled()).find(C=>C.identifier.id===k);return O&&{extensionLocation:O.location}}},void 0,Promise.resolve(t.homedir()),Promise.resolve(n))}}class o extends I.$Zc{constructor(n,u,r,f,h,k){super(),this.g=n,this.h=u,this.j=r,this.m=f,this.n=h,this.r=k,this.a=0,this.b=new Map,this.c=this.B(new i.$qe),this.onExecuteCommand=this.c.event}async call(n,u,r){switch(u){case a.RemoteTerminalChannelRequest.RestartPtyHost:return this.j.restartPtyHost.apply(this.j,r);case a.RemoteTerminalChannelRequest.CreateProcess:{const f=(0,S.$6s)(n.remoteAuthority);return this.s(f,r)}case a.RemoteTerminalChannelRequest.AttachToProcess:return this.j.attachToProcess.apply(this.j,r);case a.RemoteTerminalChannelRequest.DetachFromProcess:return this.j.detachFromProcess.apply(this.j,r);case a.RemoteTerminalChannelRequest.ListProcesses:return this.j.listProcesses.apply(this.j,r);case a.RemoteTerminalChannelRequest.GetLatency:return this.j.getLatency.apply(this.j,r);case a.RemoteTerminalChannelRequest.GetPerformanceMarks:return this.j.getPerformanceMarks.apply(this.j,r);case a.RemoteTerminalChannelRequest.OrphanQuestionReply:return this.j.orphanQuestionReply.apply(this.j,r);case a.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables:return this.j.acceptPtyHostResolvedVariables.apply(this.j,r);case a.RemoteTerminalChannelRequest.Start:return this.j.start.apply(this.j,r);case a.RemoteTerminalChannelRequest.Input:return this.j.input.apply(this.j,r);case a.RemoteTerminalChannelRequest.AcknowledgeDataEvent:return this.j.acknowledgeDataEvent.apply(this.j,r);case a.RemoteTerminalChannelRequest.Shutdown:return this.j.shutdown.apply(this.j,r);case a.RemoteTerminalChannelRequest.Resize:return this.j.resize.apply(this.j,r);case a.RemoteTerminalChannelRequest.ClearBuffer:return this.j.clearBuffer.apply(this.j,r);case a.RemoteTerminalChannelRequest.GetInitialCwd:return this.j.getInitialCwd.apply(this.j,r);case a.RemoteTerminalChannelRequest.GetCwd:return this.j.getCwd.apply(this.j,r);case a.RemoteTerminalChannelRequest.ProcessBinary:return this.j.processBinary.apply(this.j,r);case a.RemoteTerminalChannelRequest.SendCommandResult:return this.u(r[0],r[1],r[2]);case a.RemoteTerminalChannelRequest.InstallAutoReply:return this.j.installAutoReply.apply(this.j,r);case a.RemoteTerminalChannelRequest.UninstallAllAutoReplies:return this.j.uninstallAllAutoReplies.apply(this.j,r);case a.RemoteTerminalChannelRequest.GetDefaultSystemShell:return this.w.apply(this,r);case a.RemoteTerminalChannelRequest.GetProfiles:return this.y.apply(this,r);case a.RemoteTerminalChannelRequest.GetEnvironment:return this.z();case a.RemoteTerminalChannelRequest.GetWslPath:return this.C(r[0],r[1]);case a.RemoteTerminalChannelRequest.GetTerminalLayoutInfo:return this.j.getTerminalLayoutInfo(r);case a.RemoteTerminalChannelRequest.SetTerminalLayoutInfo:return this.j.setTerminalLayoutInfo(r);case a.RemoteTerminalChannelRequest.SerializeTerminalState:return this.j.serializeTerminalState.apply(this.j,r);case a.RemoteTerminalChannelRequest.ReviveTerminalProcesses:return this.j.reviveTerminalProcesses.apply(this.j,r);case a.RemoteTerminalChannelRequest.GetRevivedPtyNewId:return this.j.getRevivedPtyNewId.apply(this.j,r);case a.RemoteTerminalChannelRequest.SetUnicodeVersion:return this.j.setUnicodeVersion.apply(this.j,r);case a.RemoteTerminalChannelRequest.ReduceConnectionGraceTime:return this.D();case a.RemoteTerminalChannelRequest.UpdateIcon:return this.j.updateIcon.apply(this.j,r);case a.RemoteTerminalChannelRequest.UpdateTitle:return this.j.updateTitle.apply(this.j,r);case a.RemoteTerminalChannelRequest.UpdateProperty:return this.j.updateProperty.apply(this.j,r);case a.RemoteTerminalChannelRequest.RefreshProperty:return this.j.refreshProperty.apply(this.j,r);case a.RemoteTerminalChannelRequest.RequestDetachInstance:return this.j.requestDetachInstance(r[0],r[1]);case a.RemoteTerminalChannelRequest.AcceptDetachedInstance:return this.j.acceptDetachInstanceReply(r[0],r[1]);case a.RemoteTerminalChannelRequest.FreePortKillProcess:return this.j.freePortKillProcess.apply(this.j,r);case a.RemoteTerminalChannelRequest.AcceptDetachInstanceReply:return this.j.acceptDetachInstanceReply.apply(this.j,r)}throw new Error(`IPC Command ${u} not found`)}listen(n,u,r){switch(u){case a.RemoteTerminalChannelEvent.OnPtyHostExitEvent:return this.j.onPtyHostExit||i.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostStartEvent:return this.j.onPtyHostStart||i.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent:return this.j.onPtyHostUnresponsive||i.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent:return this.j.onPtyHostResponsive||i.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent:return this.j.onPtyHostRequestResolveVariables||i.Event.None;case a.RemoteTerminalChannelEvent.OnProcessDataEvent:return this.j.onProcessData;case a.RemoteTerminalChannelEvent.OnProcessReadyEvent:return this.j.onProcessReady;case a.RemoteTerminalChannelEvent.OnProcessExitEvent:return this.j.onProcessExit;case a.RemoteTerminalChannelEvent.OnProcessReplayEvent:return this.j.onProcessReplay;case a.RemoteTerminalChannelEvent.OnProcessOrphanQuestion:return this.j.onProcessOrphanQuestion;case a.RemoteTerminalChannelEvent.OnExecuteCommand:return this.onExecuteCommand;case a.RemoteTerminalChannelEvent.OnDidRequestDetach:return this.j.onDidRequestDetach||i.Event.None;case a.RemoteTerminalChannelEvent.OnDidChangeProperty:return this.j.onDidChangeProperty}throw new Error(`IPC Command ${u} not found`)}async s(n,u){const r={name:u.shellLaunchConfig.name,executable:u.shellLaunchConfig.executable,args:u.shellLaunchConfig.args,cwd:typeof u.shellLaunchConfig.cwd=="string"||typeof u.shellLaunchConfig.cwd>"u"?u.shellLaunchConfig.cwd:v.URI.revive(n.transformIncoming(u.shellLaunchConfig.cwd)),env:u.shellLaunchConfig.env,useShellEnvironment:u.shellLaunchConfig.useShellEnvironment,reconnectionProperties:u.shellLaunchConfig.reconnectionProperties,type:u.shellLaunchConfig.type,isFeatureTerminal:u.shellLaunchConfig.isFeatureTerminal},f=await(0,b.$Ln)(u.resolverEnv,!!u.shellLaunchConfig.useShellEnvironment,T.$z,this.g,this.h,this.r);this.h.trace("baseEnv",f);const h=V=>({uri:v.URI.revive(n.transformIncoming(V.uri)),name:V.name,index:V.index,toResource:()=>{throw new Error("Not implemented")}}),k=u.workspaceFolders.map(h),P=u.activeWorkspaceFolder?h(u.activeWorkspaceFolder):void 0,O=u.activeFileResource?v.URI.revive(n.transformIncoming(u.activeFileResource)):void 0,C=new w(f,k,O,u.resolvedVariables,this.n),L=c.$OR(P,process.env,C),R=await c.$NR(r,t.homedir(),L,P?.uri,u.configuration["terminal.integrated.cwd"],this.h);r.cwd=R;const z=T.$l?"terminal.integrated.env.windows":T.$m?"terminal.integrated.env.osx":"terminal.integrated.env.linux",Q=u.configuration[z],J=await c.$PR(r,Q,L,this.m.version,u.configuration["terminal.integrated.detectLocale"],f);if((0,d.$HR)(r)){const V=[];for(const[te,le,ye]of u.envVariableCollections)V.push([te,{map:(0,$.$Rs)(le),descriptionMap:(0,$.$Ss)(ye)}]);const B=new Map(V),j=new p.$Vs(B),U=P?P??void 0:void 0;await j.applyToProcessEnvironment(J,{workspaceFolder:U},L)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:R,cols:u.cols,rows:u.rows,env:J});const x=(0,s.$Ci)();J.VSCODE_IPC_HOOK_CLI=x;const ve=await this.j.createProcess(r,R,u.cols,u.rows,u.unicodeVersion,J,f,u.options,u.shouldPersistTerminal,u.workspaceId,u.workspaceName),be={executeCommand:(V,...B)=>this.t(ve,V,B,n)},se=new y.$dR(be,this.h,x);return this.j.onProcessExit(V=>V.id===ve&&se.dispose()),{persistentTerminalId:ve,resolvedShellLaunchConfig:r}}t(n,u,r,f){const{resolve:h,reject:k,promise:P}=(0,g.$Dh)(),O=++this.a;this.b.set(O,{resolve:h,reject:k,uriTransformer:f});const C=(0,E.$oo)(r,L=>{if(L&&L.$mid===1)return f.transformOutgoing(L);if(L&&L instanceof v.URI)return f.transformOutgoingURI(L)});return this.c.fire({reqId:O,persistentProcessId:n,commandId:u,commandArgs:C}),P}u(n,u,r){const f=this.b.get(n);if(!f)return;this.b.delete(n);const h=(0,E.$oo)(r,k=>{if(k&&k.$mid===1)return f.uriTransformer.transformIncoming(k)});u?f.reject(h):f.resolve(h)}w(n){return this.j.getDefaultSystemShell(n)}async y(n,u,r,f){return this.j.getProfiles(n,u,r,f)||[]}z(){return{...process.env}}C(n,u){return this.j.getWslPath(n,u)}D(){return this.j.reduceConnectionGraceTime()}}e.$TR=o});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[288],Le([1,0,31,20,6,2,12,8,114,26,51,61,28,132,198,88,199,27,144,30,95,135,223,142,15,126,73,72,124,89,92,136,11,62,29,47,226,157,134,24,40,239,53,246,35,140,259,260,232,236,287,76,55,269,282,146,64,147,54,33,254,74,237,129,145,143,128,127,7,277,222,251,243,125]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d,w,o,l,n,u,r,f,h,k,P,O,C,L,R,z,Q,J,x,ve,be,se,V,B,j,U,te,le,ye,oe,_,X,M,A,Y,pe,ne,ie,G,Z,ce,we,Ie,Me,Be,De,Ne,Te,Ce,de,Se,Re,Ue,Ge,Qe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pS=void 0,e.$oS=Xe,T=We(T),R=$t(R),V=$t(V);const Je="monacoworkbench";async function Xe(me,H,ee,ge){const re=new P.$Ii,fe=new dt,W={_serviceBrand:void 0,...R.default};re.set(z.$yk,W);const K=new A.$jn(H,W);re.set(b.$Ri,K),re.set(b.$Si,K);const $e=new Be.$6R((0,L.$tk)(K),K.logsHome);re.set(L.$gk,$e),fe.registerChannel("logger",new Ce.$Es($e,ft=>st(ft.remoteAuthority)));const Fe=$e.createLogger("remoteagent",{name:(0,de.localize)(2518,null)}),qe=new Te.$dS(Fe,[new rt((0,L.$tk)(K))]);re.set(L.$fk,qe),setTimeout(()=>Ye(K.logsHome.with({scheme:D.Schemas.file}).fsPath).then(null,ft=>qe.error(ft)),1e4),qe.onDidChangeLogLevel(ft=>(0,L.log)(qe,ft,`Log level changed to ${(0,L.$uk)(qe.getLevel())}`)),qe.trace(`Remote configuration data at ${ee}`),qe.trace("process arguments:",K.args),Array.isArray(W.serverGreeting)&&qe.info(`

${W.serverGreeting.join(`
`)}

`),fe.registerChannel(a.$8o.ChannelName,new a.$8o);const xe=new S.$si(ft=>ft.clientId==="renderer"),et=ge.add(new r.$ar(qe));re.set(u.$fl,et),et.registerProvider(D.Schemas.file,ge.add(new f.$Dr(qe)));const it=new te.$5s(et);re.set(U.$Pl,it);const ct=new $.$6o(K.machineSettingsResource,et,new Ie.$Do,qe);re.set(p.$ej,ct);const mt=new De.$bS(it,K,et,qe);re.set(ce.$Rl,mt),fe.registerChannel("userDataProfiles",new Ue.$jS(mt,ft=>st(ft.remoteAuthority))),re.set(Qe.$mS,new h.$Hi(Qe.$nS,void 0,!0));const[,,vt,Ct,gt]=await Promise.all([ct.initialize(),mt.init(),(0,v.$2n)(qe.error.bind(qe)),(0,v.$3n)(qe.error.bind(qe)),(0,v.$4n)(qe.error.bind(qe))]),bt=new ne.$5m;re.set(ne.$4m,bt);const pt=new x.$ps(ct,K,qe,$e);re.set(Q.$dq,pt);let Nt;try{await i.promises.stat("/run/.containerenv"),Nt=!0}catch{}if(!Nt)try{Nt=(await i.promises.readFile("/proc/self/cgroup","utf8")).includes("docker")}catch{}let jt=se.$Lp;const Ft=(0,se.$Rp)(W,ct);if((0,se.$Mp)(W,K)){!(0,se.$Np)(W,K)&&W.telemetryEndpoint&&(jt=new Me.$4R(pt,Ft,Je,null,()=>new we.$2R(W.telemetryEndpoint,vt,Nt)),ge.add((0,I.$Xc)(()=>jt?.flush())));const ft={appenders:[jt],commonProperties:(0,ve.$Dp)((0,t.release)(),(0,t.hostname)(),process.arch,W.commit,W.version+"-remote",vt,Ct,gt,Ft,"remoteAgent"),piiPaths:(0,se.$Sp)(K)},wt=K.args["telemetry-level"];let Tt=be.TelemetryLevel.USAGE;wt==="all"?Tt=be.TelemetryLevel.USAGE:wt==="error"?Tt=be.TelemetryLevel.ERROR:wt==="crash"?Tt=be.TelemetryLevel.CRASH:wt!==void 0&&(Tt=be.TelemetryLevel.NONE),re.set(_.$gt,new h.$Hi(_.$et,[ft,Tt]))}else re.set(_.$gt,_.$ft);re.set(d.$tp,new h.$Hi(g.$Aq));const Ht=fe.getChannel("download",xe);re.set(c.$0o,new m.$_o(Ht,()=>st("renderer"))),re.set(Z.$Tq,new h.$Hi(Ne.$cS)),re.set(ie.$Xq,new h.$Hi(G.$1R)),re.set(w.$Dq,new h.$Hi(w.$Fq)),re.set(n.$9q,new h.$Hi(n.$0q));const kt=new k.$Gr(re);re.set(O.$js,kt.createInstance(C.$ls));const Wt=kt.createInstance(Ge.$lS,{graceTime:y.ProtocolConstants.ReconnectionGraceTime,shortGraceTime:y.ProtocolConstants.ReconnectionShortGraceTime,scrollback:ct.getValue(B.TerminalSettingId.PersistentSessionScrollback)??100}),Et=kt.createInstance(j.$1s,Wt);return re.set(B.$zs,Et),kt.invokeFunction(ft=>{const wt=ft.get(n.$9q),Tt=ft.get(ie.$Xq),Mt=ft.get(d.$tp),Vt=ft.get(O.$js),Qt=new le.$at(me,K,mt,bt);fe.registerChannel("remoteextensionsenvironment",Qt);const Jt=new oe.$ht(ft.get(_.$gt),jt);fe.registerChannel("telemetry",Jt),fe.registerChannel(Y.$UR,new X.$TR(K,qe,Et,W,wt,ct));const It=new Se.$hS(kt.createInstance(o.$Gq,qe),K,mt,Tt,qe,Mt,Vt);fe.registerChannel(Re.$gS,new Se.$iS(It,Ot=>st(Ot.remoteAuthority)));const Pt=ge.add(new ye.$dt(qe,K));fe.registerChannel(pe.$YR,Pt),fe.registerChannel("request",new J.$ms(ft.get(Q.$dq)));const Rt=new l.$Hq(wt,Ot=>st(Ot.remoteAuthority));fe.registerChannel("extensions",Rt);const zt=S.ProxyChannel.fromService(ft.get(O.$js),ge);return fe.registerChannel("languagePacks",zt),It.whenExtensionsReady().then(()=>wt.cleanUp()),ge.add(new V.default(ft.get(be.$em))),{telemetryService:ft.get(be.$em)}}),{socketServer:fe,instantiationService:kt}}const tt=Object.create(null);function st(me){return tt[me]||(tt[me]=(0,M.$6s)(me)),tt[me]}class dt extends S.$oi{constructor(){const H=new E.$qe;super(H.event),this.b=H}acceptConnection(H,ee){this.b.fire({protocol:H,onDidClientDisconnect:ee})}}e.$pS=dt;class rt extends L.$kk{constructor(H=L.$ik){super(),this.setLevel(H),this.g=!!process.stdout.isTTY}trace(H,...ee){this.f(L.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${ot()}]\x1B[0m`,H,...ee):console.log(`[${ot()}]`,H,...ee))}debug(H,...ee){this.f(L.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${ot()}]\x1B[0m`,H,...ee):console.log(`[${ot()}]`,H,...ee))}info(H,...ee){this.f(L.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${ot()}]\x1B[0m`,H,...ee):console.log(`[${ot()}]`,H,...ee))}warn(H,...ee){this.f(L.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${ot()}]\x1B[0m`,H,...ee):console.warn(`[${ot()}]`,H,...ee))}error(H,...ee){this.f(L.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${ot()}]\x1B[0m`,H,...ee):console.error(`[${ot()}]`,H,...ee))}flush(){}}function ot(){const me=new Date;return`${ut(me.getHours())}:${ut(me.getMinutes())}:${ut(me.getSeconds())}`}function ut(me){return me<10?`0${me}`:String(me)}async function Ye(me){const H=T.$sc(me),ee=T.$rc(me),fe=(await s.Promises.readdir(ee)).filter(K=>/^\d{8}T\d{6}$/.test(K)).sort().filter(K=>K!==H),W=fe.slice(0,Math.max(0,fe.length-9));await Promise.all(W.map(K=>s.Promises.rm(T.$oc(ee,K))))}}),define(Oe[289],Le([1,0,96,20,84,290,93,65,14,34,9,36,2,12,8,44,3,16,4,23,193,181,285,61,78,28,5,11,29,221,24,158,252,102,55,288,256]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p,$,a,c,m,b,g,d,w,o,l,n,u,r,f,h,k,P,O,C,L,R,z,Q,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xS=be,t=We(t),i=We(i),E=We(E),D=We(D),c=We(c),m=We(m);const x=5*60*1e3;let ve=class extends p.$Zc{constructor(B,j,U,te,le,ye,oe,_,X){super(),this.n=B,this.r=j,this.s=U,this.t=ye,this.u=oe,this.w=_,this.y=X,this.h=se.create(this.u),this.j=(0,$.$Yg)(oe,le),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=te?this.y.createInstance(J.$sS,this.r,le??"/",this.j):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(B,j){if(B.method!=="GET")return(0,J.$qS)(B,j,405,`Unsupported method ${B.method}`);if(!B.url)return(0,J.$qS)(B,j,400,"Bad request.");const U=D.parse(B.url,!0);let te=U.pathname;if(!te)return(0,J.$qS)(B,j,400,"Bad request.");if(te.startsWith(this.j)&&te.charCodeAt(this.j.length)===s.CharCode.Slash&&(te=te.substring(this.j.length)),te==="/version")return j.writeHead(200,{"Content-Type":"text/plain"}),void j.end(this.u.commit||"");if(te==="/delay-shutdown")return this.N(),j.writeHead(200),void j.end("OK");if(!(0,R.$Tn)(this.r,B,U))return(0,J.$qS)(B,j,403,"Forbidden.");if(te==="/vscode-remote-resource"){const le=U.query.path;if(typeof le!="string")return(0,J.$qS)(B,j,400,"Bad request.");let ye;try{ye=g.URI.from({scheme:$.Schemas.file,path:le}).fsPath}catch{return(0,J.$qS)(B,j,400,"Bad request.")}const oe=Object.create(null);this.t.isBuilt&&((0,y.$Jg)(ye,this.t.builtinExtensionsPath,!m.$n)||(0,y.$Jg)(ye,this.t.extensionsPath,!m.$n))&&(oe["Cache-Control"]="public, max-age=31536000"),oe.Vary="Origin";const _=B.headers.origin;return _&&this.h.matches(_)&&(oe["Access-Control-Allow-Origin"]=_),(0,J.$rS)(ye,J.CacheControl.ETAG,this.w,B,j,oe)}if(this.g){this.g.handle(B,j,U);return}return j.writeHead(404,{"Content-Type":"text/plain"}),void j.end("Not found")}handleUpgrade(B,j){let U=(0,d.$7g)(),te=!1,le=!1;if(B.url){const A=D.parse(B.url,!0).query;typeof A.reconnectionToken=="string"&&(U=A.reconnectionToken),A.reconnection==="true"&&(te=!0),A.skipWebSocketFrames==="true"&&(le=!0)}if(B.headers.upgrade===void 0||B.headers.upgrade.toLowerCase()!=="websocket"){j.end("HTTP/1.1 400 Bad Request");return}const ye=B.headers["sec-websocket-key"],oe=t.createHash("sha1");oe.update(ye+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const X=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${oe.digest("base64")}`];let M=!1;if(!le&&!this.t.args["disable-websocket-compression"]&&B.headers["sec-websocket-extensions"]){const A=Array.isArray(B.headers["sec-websocket-extensions"])?B.headers["sec-websocket-extensions"]:[B.headers["sec-websocket-extensions"]];for(const Y of A)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(Y)){if(/\b(permessage-deflate)\b/.test(Y)){M=!0,X.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(Y)){M=!0,X.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}j.write(X.join(`\r
`)+`\r
\r
`),j.setTimeout(0),j.setNoDelay(!0),le?this.D(new u.$zi(j,`server-connection-${U}`),te,U):this.D(new u.$Ai(new u.$zi(j,`server-connection-${U}`),M,null,!0),te,U)}handleServerError(B){this.w.error("Error occurred in server"),this.w.error(B)}z(B){let j;return B instanceof u.$zi?j=B.socket:j=B.socket.socket,j.remoteAddress||"<unknown>"}async C(B,j,U){const te=j.getSocket();this.w.error(`${B} ${U}.`);const le={type:"error",reason:U};j.sendControl(v.$Se.fromString(JSON.stringify(le))),j.dispose(),await te.drain(),te.dispose()}D(B,j,U){const te=this.z(B),le=`[${te}][${U.substr(0,8)}]`,ye=new n.$yi({socket:B}),oe=this.s?new this.s.validator:null,_=this.s?new this.s.signer:null;let X;(function(pe){pe[pe.WaitingForAuth=0]="WaitingForAuth",pe[pe.WaitingForConnectionType=1]="WaitingForConnectionType",pe[pe.Done=2]="Done",pe[pe.Error=3]="Error"})(X||(X={}));let M=X.WaitingForAuth;const A=pe=>{M=X.Error,Y.dispose(),this.C(le,ye,pe)},Y=ye.onControlMessage(pe=>{if(M===X.WaitingForAuth){let ne;try{ne=JSON.parse(pe.toString())}catch{return A("Malformed first message")}if(ne.type!=="auth")return A("Invalid first message");if(this.r.type===R.ServerConnectionTokenType.Mandatory&&!this.r.validate(ne.auth))return A("Unauthorized client refused: auth mismatch");let ie=(0,d.$7g)();if(_)try{ie=_.sign(ne.data)}catch{}let G=(0,d.$7g)();if(oe)try{G=oe.createNewMessage(G)}catch{}const Z={type:"sign",data:G,signedData:ie};ye.sendControl(v.$Se.fromString(JSON.stringify(Z))),M=X.WaitingForConnectionType}else if(M===X.WaitingForConnectionType){let ne;try{ne=JSON.parse(pe.toString())}catch{return A("Malformed second message")}if(ne.type!=="connectionType")return A("Invalid second message");if(typeof ne.signedData!="string")return A("Invalid second message field type");const ie=ne.commit,G=this.u.commit;if(ie&&G&&ie!==G)return A("Client refused: version mismatch");let Z=!1;if(!oe)Z=!0;else if(this.r.validate(ne.signedData))Z=!0;else try{Z=oe.validate(ne.signedData)==="ok"}catch{}if(!Z){if(this.t.isBuilt)return A("Unauthorized client refused");this.w.error(`${le} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const ce in this.b)this.b[ce].shortenReconnectionGraceTimeIfNecessary();for(const ce in this.a)this.a[ce].shortenReconnectionGraceTimeIfNecessary();M=X.Done,Y.dispose(),this.F(te,le,ye,B,j,U,ne)}})}async F(B,j,U,te,le,ye,oe){const _=oe.desiredConnectionType===P.ConnectionType.Management?`${j}[ManagementConnection]`:oe.desiredConnectionType===P.ConnectionType.ExtensionHost?`${j}[ExtensionHostConnection]`:j;if(oe.desiredConnectionType===P.ConnectionType.Management)if(le){if(!this.b[ye])return this.f.has(ye)?this.C(_,U,"Unknown reconnection token (seen before)"):this.C(_,U,"Unknown reconnection token (never seen)");U.sendControl(v.$Se.fromString(JSON.stringify({type:"ok"})));const X=U.readEntireBuffer();U.dispose(),this.b[ye].acceptReconnection(B,te,X)}else{if(this.b[ye])return this.C(_,U,"Duplicate reconnection token");U.sendControl(v.$Se.fromString(JSON.stringify({type:"ok"})));const X=new L.$Nn(this.w,ye,B,U);this.n.acceptConnection(X.protocol,X.onClose),this.b[ye]=X,this.f.add(ye),X.onClose(()=>{delete this.b[ye]})}else if(oe.desiredConnectionType===P.ConnectionType.ExtensionHost){const X=oe.args||{language:"en"},M=await this.I(X);if(M.port&&this.w.trace(`${_} - startParams debug port ${M.port}`),this.w.trace(`${_} - startParams language: ${M.language}`),this.w.trace(`${_} - startParams env: ${JSON.stringify(M.env)}`),le){if(!this.a[ye])return this.f.has(ye)?this.C(_,U,"Unknown reconnection token (seen before)"):this.C(_,U,"Unknown reconnection token (never seen)");U.sendPause(),U.sendControl(v.$Se.fromString(JSON.stringify(M.port?{debugPort:M.port}:{})));const A=U.readEntireBuffer();U.dispose(),this.a[ye].acceptReconnection(B,te,A)}else{if(this.a[ye])return this.C(_,U,"Duplicate reconnection token");U.sendPause(),U.sendControl(v.$Se.fromString(JSON.stringify(M.port?{debugPort:M.port}:{})));const A=U.readEntireBuffer();U.dispose();const Y=this.y.createInstance(C.$Mn,ye,B,te,A);this.a[ye]=Y,this.f.add(ye),Y.onClose(()=>{Y.dispose(),delete this.a[ye],this.J()}),Y.start(M)}}else if(oe.desiredConnectionType===P.ConnectionType.Tunnel){const X=oe.args;this.G(U,X)}else return this.C(_,U,"Unknown initial data received")}async G(B,j){const U=B.getSocket().socket,te=B.readEntireBuffer();B.dispose(),U.pause();const le=await this.H(j.host,j.port);te.byteLength>0&&le.write(te.buffer),le.on("end",()=>U.end()),le.on("close",()=>U.end()),le.on("error",()=>U.destroy()),U.on("end",()=>le.end()),U.on("close",()=>le.end()),U.on("error",()=>le.destroy()),le.pipe(U),U.pipe(le)}H(B,j){return new Promise((U,te)=>{const le=E.createConnection({host:B,port:j,autoSelectFamily:!0},()=>{le.removeListener("error",te),le.pause(),U(le)});le.once("error",te)})}I(B){return typeof B.port=="number"?(0,o.$9g)(B.port,10,5e3).then(j=>(B.port=j,B)):(B.debugId=void 0,B.port=void 0,B.break=void 0,Promise.resolve(B))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(B=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!B?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},x))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};ve=Ve([je(5,z.$in),je(6,k.$yk),je(7,h.$fk),je(8,f.$Ji)],ve);async function be(V,B,j){const U=await(0,R.$Sn)(B);U instanceof R.$Qn&&(console.warn(U.message),process.exit(1));function te(ce){(0,S.setUnexpectedErrorHandler)(we=>{(0,S.$3)(we)&&we.stack&&/unexpectedErrorHandler/.test(we.stack)||ce(we)})}const le=[];te(ce=>{le.push(ce),console.error(ce)});let ye=!1;process.on("SIGPIPE",()=>{ye||(ye=!0,(0,S.$4)(new Error("Unexpected SIGPIPE")))});const oe=new p.$Yc,{socketServer:_,instantiationService:X}=await(0,Q.$oS)(U,B,j,oe);X.invokeFunction(ce=>{const we=ce.get(h.$fk);le.forEach(Ie=>we.error(Ie)),le.length=0,te(Ie=>we.error(Ie))}),X.invokeFunction(ce=>{const we=ce.get(r.$ej);m.$l&&(we.getValue("security.restrictUNCAccess")===!1?(0,l.disableUNCAccessRestrictions)():(0,l.addUNCHostToAllowlist)(we.getValue("security.allowedUNCHosts")))}),X.invokeFunction(ce=>{const we=ce.get(h.$fk);if(m.$l&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const Ie=(0,a.$oc)(process.env.HOMEDRIVE,"node_modules"),Me=(0,a.$rc)((0,a.$oc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Be=(0,a.$oc)(Me,"node_modules");if(i.existsSync(Ie)||i.existsSync(Be)){const De=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${Ie}
* ${Be}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;we.warn(De),console.warn(De),process.exit(0)}}});const M=X.invokeFunction(ce=>{const we=ce.get(h.$fk);if(i.existsSync((0,a.$oc)($.$5g.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(Me){we.error(Me)}return null});let A=B["server-base-path"];A&&!A.startsWith("/")&&(A=`/${A}`);const Y=i.existsSync($.$5g.asFileUri(`vs/code/browser/workbench/workbench.${T.$V?"esm.":""}html`).fsPath);if(Y&&V&&typeof V!="string"){const ce=U.type!==R.ServerConnectionTokenType.None?`?${$.$Wg}=${U.value}`:"";console.log(`Web UI available at http://localhost${V.port===80?"":`:${V.port}`}${A??""}${ce}`)}const pe=X.createInstance(ve,_,U,M,Y,A);c.mark("code/server/ready");const ne=I.performance.now(),ie=global.vscodeServerStartTime,G=global.vscodeServerListenTime,Z=global.vscodeServerCodeLoadedTime;if(X.invokeFunction(async ce=>{const we=ce.get(O.$em);if(we.publicLog2("serverStart",{startTime:ie,startedTime:G,codeLoadedTime:Z,readyTime:ne}),m.$n){const Ie=ce.get(h.$fk),Me=await(0,w.$8g)(Ie.error.bind(Ie));Me&&we.publicLog2("serverPlatformInfo",{platformId:Me.id,platformVersionId:Me.version_id,platformIdLike:Me.id_like})}}),B["print-startup-performance"]){const ce=T.$X.get();let we="";we+=`

### Load AMD-module
`,we+=T.$X.toMarkdownTable(["Module","Duration"],ce.amdLoad),we+=`

### Load commonjs-module
`,we+=T.$X.toMarkdownTable(["Module","Duration"],ce.nodeRequire),we+=`

### Invoke AMD-module factory
`,we+=T.$X.toMarkdownTable(["Module","Duration"],ce.amdInvoke),we+=`

### Invoke commonjs-module
`,we+=T.$X.toMarkdownTable(["Module","Duration"],ce.nodeEval),we+=`Start-up time: ${G-ie}
`,we+=`Code loading time: ${Z-ie}
`,we+=`Initialized time: ${ne-ie}
`,we+=`
`,console.log(we)}return pe}class se{static create(B){const j=B.webEndpointUrlTemplate,U=B.commit,te=B.quality;if(!j||!U||!te)return new se(null);const le=(0,d.$7g)(),oe=new URL(j.replace("{{uuid}}",le).replace("{{commit}}",U).replace("{{quality}}",te)).origin,_=(0,b.$mf)(oe).replace(le,"[a-zA-Z0-9\\-]+");try{const X=(0,b.$vf)(`^${_}$`,!0,{matchCase:!1});return new se(X)}catch{return new se(null)}}constructor(B){this.a=B}matches(B){return this.a?this.a.test(B):!1}}});var $t=this&&this.__importDefault||function(ue){return ue&&ue.__esModule?ue:{default:ue}};define(Oe[296],Le([1,0,31,20,12,284,289,71,8,290,55,62,44]),function(ue,e,t,i,E,I,D,T,v,s,S,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=m,e.createServer=b,t=We(t),i=We(i),y=$t(y),p=We(p),p.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=s.performance.now();const $={onMultipleValues:(g,d)=>{console.error(`Option '${g}' can only be defined once. Using value ${d}.`)},onEmptyValue:g=>{console.error(`Ignoring option '${g}': Value must not be empty.`)},onUnknownOption:g=>{console.error(`Ignoring option '${g}': not supported for server.`)},onDeprecatedOption:(g,d)=>{console.warn(`Option '${g}' is deprecated: ${d}`)}};function a(){return(0,T.$Im)(process.argv.slice(2),S.$hn,$)}function c(g){const d=g["server-data-dir"]||g["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.$oc)(t.homedir(),y.default.serverDataFolderName||".vscode-remote"),w=g["user-data-dir"]||(0,v.$oc)(d,"data"),o=(0,v.$oc)(w,"User"),l=(0,v.$oc)(o,"globalStorage"),n=(0,v.$oc)(o,"History"),u=(0,v.$oc)(w,"Machine");g["user-data-dir"]=w;const r=(0,v.$rc)(E.$5g.asFileUri("").fsPath),f=g["builtin-extensions-dir"]||(0,v.$oc)(r,"extensions");return g["builtin-extensions-dir"]=f,g["extensions-dir"]=g["extensions-dir"]||(0,v.$oc)(d,"extensions"),[d,g["extensions-dir"],w,o,u,l,n].forEach(h=>{try{i.existsSync(h)||i.mkdirSync(h,{mode:448})}catch(k){console.error(k)}}),d}function m(g=a()){return(0,I.run)(g,c(g),S.$hn)}function b(g,d=a()){return(0,D.$xS)(g,d,c(d))}})}).call(this);

//# sourceMappingURL=server.main.js.map
