"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/nls","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","fs","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/process","child_process","vs/workbench/services/search/common/searchExtTypes","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","http","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/common/searchExtConversionTypes","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/iconLabels","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/nls.messages","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/amdX","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/base/common/actions","vs/base/common/date","vs/base/common/console","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(ge){for(var e=[],s=0,h=ge.length;s<h;s++)e[s]=Re[ge[s]];return e};define(Re[133],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=e.LoaderEventType=e.$W=e.$V=void 0,e.$V=!1,e.$W=!0;var s;(function(D){D[D.LoaderAvailable=1]="LoaderAvailable",D[D.BeginLoadingScript=10]="BeginLoadingScript",D[D.EndLoadingScriptOK=11]="EndLoadingScriptOK",D[D.EndLoadingScriptError=12]="EndLoadingScriptError",D[D.BeginInvokeFactory=21]="BeginInvokeFactory",D[D.EndInvokeFactory=22]="EndInvokeFactory",D[D.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",D[D.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",D[D.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",D[D.NodeEndNativeRequire=34]="NodeEndNativeRequire",D[D.CachedDataFound=60]="CachedDataFound",D[D.CachedDataMissed=61]="CachedDataMissed",D[D.CachedDataRejected=62]="CachedDataRejected",D[D.CachedDataCreated=63]="CachedDataCreated"})(s||(e.LoaderEventType=s={}));class h{static get(){const O=new Map,T=new Map,A=new Map,p=new Map;function c(v,o){v.has(o.detail)||v.set(o.detail,-o.timestamp)}function I(v,o){const m=v.get(o.detail);m&&(m>=0||v.set(o.detail,m+o.timestamp))}let E=[];typeof ge=="function"&&typeof ge.getStats=="function"&&(E=ge.getStats().slice(0).sort((v,o)=>v.timestamp-o.timestamp));for(const v of E)switch(v.type){case s.BeginLoadingScript:c(O,v);break;case s.EndLoadingScriptOK:case s.EndLoadingScriptError:I(O,v);break;case s.BeginInvokeFactory:c(T,v);break;case s.EndInvokeFactory:I(T,v);break;case s.NodeBeginNativeRequire:c(A,v);break;case s.NodeEndNativeRequire:I(A,v);break;case s.NodeBeginEvaluatingScript:c(p,v);break;case s.NodeEndEvaluatingScript:I(p,v);break}let f=0;A.forEach(v=>f+=v);function P(v){const o=[];return v.forEach((m,$)=>o.push([$,m])),o}return{amdLoad:P(O),amdInvoke:P(T),nodeRequire:P(A),nodeEval:P(p),nodeRequireTotal:f}}static toMarkdownTable(O,T){let A="";const p=[];return O.forEach((c,I)=>{p[I]=c.length}),T.forEach(c=>{c.forEach((I,E)=>{typeof I>"u"&&(I=c[E]="-");const f=I.toString().length;p[E]=Math.max(f,p[E])})}),O.forEach((c,I)=>{A+=`| ${c+" ".repeat(p[I]-c.toString().length)} `}),A+=`|
`,O.forEach((c,I)=>{A+=`| ${"-".repeat(p[I])} `}),A+=`|
`,T.forEach(c=>{c.forEach((I,E)=>{typeof I<"u"&&(A+=`| ${I+" ".repeat(p[E]-I.toString().length)} `)}),A+=`|
`}),A}}e.$X=h}),define(Re[134],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=void 0,e.$jb=s,e.$kb=h,e.$lb=D,e.$mb=O,e.$nb=T,e.$ob=A,e.$pb=p,e.$rb=I,e.$sb=E,e.$tb=f,e.$ub=P,e.$vb=v;function s(o,m){const $=h(o,m);if($!==-1)return o[$]}function h(o,m,$=o.length-1){for(let d=$;d>=0;d--){const i=o[d];if(m(i))return d}return-1}function D(o,m){const $=O(o,m);return $===-1?void 0:o[$]}function O(o,m,$=0,d=o.length){let i=$,a=d;for(;i<a;){const t=Math.floor((i+a)/2);m(o[t])?i=t+1:a=t}return i-1}function T(o,m){const $=A(o,m);return $===o.length?void 0:o[$]}function A(o,m,$=0,d=o.length){let i=$,a=d;for(;i<a;){const t=Math.floor((i+a)/2);m(o[t])?a=t:i=t+1}return i}function p(o,m,$=0,d=o.length){const i=A(o,m,$,d);return i===o.length?-1:i}class c{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(c.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!m(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const $=O(this.e,m,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$qb=c;function I(o,m){if(o.length===0)return;let $=o[0];for(let d=1;d<o.length;d++){const i=o[d];m(i,$)>0&&($=i)}return $}function E(o,m){if(o.length===0)return;let $=o[0];for(let d=1;d<o.length;d++){const i=o[d];m(i,$)>=0&&($=i)}return $}function f(o,m){return I(o,($,d)=>-m($,d))}function P(o,m){if(o.length===0)return-1;let $=0;for(let d=1;d<o.length;d++){const i=o[d];m(i,o[$])>0&&($=d)}return $}function v(o,m){for(const $ of o){const d=m($);if(d!==void 0)return d}}}),define(Re[26],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var s;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(s||(e.CharCode=s={}))}),define(Re[80],Ce([1,0]),function(ge,e){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$i=void 0,e.$e=h,e.$f=D,e.$g=O,e.$h=T;function h(p,c){const I=Object.create(null);for(const E of p){const f=c(E);let P=I[f];P||(P=I[f]=[]),P.push(E)}return I}function D(p,c){const I=[],E=[];for(const f of p)c.has(f)||I.push(f);for(const f of c)p.has(f)||E.push(f);return{removed:I,added:E}}function O(p,c){const I=[],E=[];for(const[f,P]of p)c.has(f)||I.push(P);for(const[f,P]of c)p.has(f)||E.push(P);return{removed:I,added:E}}function T(p,c){const I=new Set;for(const E of c)p.has(E)&&I.add(E);return I}class A{static{s=Symbol.toStringTag}constructor(c,I){this.b=I,this.a=new Map,this[s]="SetWithKey";for(const E of c)this.add(E)}get size(){return this.a.size}add(c){const I=this.b(c);return this.a.set(I,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,I){this.a.forEach(E=>c.call(I,E,E,this))}[Symbol.iterator](){return this.values()}}e.$i=A}),define(Re[60],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=h,e.$di=D,e.$ei=O;function s(T){return(A,p,c)=>{let I=null,E=null;if(typeof c.value=="function"?(I="value",E=c.value):typeof c.get=="function"&&(I="get",E=c.get),!E)throw new Error("not supported");c[I]=T(E,p)}}function h(T,A,p){let c=null,I=null;if(typeof p.value=="function"?(c="value",I=p.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",I=p.get),!I)throw new Error("not supported");const E=`$memoize$${A}`;p[c]=function(...f){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,f)}),this[E]}}function D(T,A,p){return s((c,I)=>{const E=`$debounce$${I}`,f=`$debounce$result$${I}`;return function(...P){this[f]||(this[f]=p?p():void 0),clearTimeout(this[E]),A&&(this[f]=A(this[f],...P),P=[this[f]]),this[E]=setTimeout(()=>{c.apply(this,P),this[f]=p?p():void 0},T)}})}function O(T,A,p){return s((c,I)=>{const E=`$throttle$timer$${I}`,f=`$throttle$result$${I}`,P=`$throttle$lastRun$${I}`,v=`$throttle$pending$${I}`;return function(...o){if(this[f]||(this[f]=p?p():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),A&&(this[f]=A(this[f],...o)),this[v])return;const m=this[P]+T;m<=Date.now()?(this[P]=Date.now(),c.apply(this,[this[f]]),this[f]=p?p():void 0):(this[v]=!0,this[E]=setTimeout(()=>{this[v]=!1,this[P]=Date.now(),c.apply(this,[this[f]]),this[f]=p?p():void 0},m-Date.now()))}})}}),define(Re[12],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=e.$fb=e.$eb=e.$db=e.$cb=e.$ab=e.$9=e.$1=e.$Z=void 0,e.setUnexpectedErrorHandler=h,e.$3=D,e.$4=O,e.$5=T,e.$6=A,e.$7=p,e.$8=I,e.$0=f,e.$$=P,e.$_=v,e.$bb=m;class s{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?a.isErrorNoTelemetry(n)?new a(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(u=>{u(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$Z=s,e.$1=new s;function h(r){e.$1.setUnexpectedErrorHandler(r)}function D(r){if(!r||typeof r!="object")return!1;const n=r;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function O(r){I(r)||e.$1.onUnexpectedError(r)}function T(r){I(r)||e.$1.onUnexpectedExternalError(r)}function A(r){if(r instanceof Error){const{name:n,message:u}=r,l=r.stacktrace||r.stack;return{$isError:!0,name:n,message:u,stack:l,noTelemetry:a.isErrorNoTelemetry(r)}}return r}function p(r){let n;return r.noTelemetry?n=new a:(n=new Error,n.name=r.name),n.message=r.message,n.stack=r.stack,n}const c="Canceled";function I(r){return r instanceof E?!0:r instanceof Error&&r.name===c&&r.message===c}class E extends Error{constructor(){super(c),this.name=this.message}}e.$9=E;function f(){const r=new Error(c);return r.name=r.message,r}function P(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}function v(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}class o extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$ab=o;function m(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}class $ extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$cb=$;class d extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$db=d;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$eb=i;class a extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof a)return n;const u=new a;return u.message=n.message,u.stack=n.stack,u}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$fb=a;class t extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$gb=t}),define(Re[18],Ce([1,0,12,134]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.$cc=e.$ac=e.$_b=e.CompareResult=void 0,e.$wb=D,e.$xb=O,e.$yb=T,e.$zb=A,e.$Ab=p,e.$Bb=c,e.$Cb=I,e.$Db=E,e.$Eb=f,e.$Fb=P,e.$Gb=v,e.$Hb=o,e.$Ib=m,e.top=$,e.$Kb=d,e.$Lb=a,e.$Mb=t,e.$Nb=r,e.$Ob=n,e.$Pb=u,e.$Qb=l,e.$Rb=g,e.$Sb=y,e.$Tb=k,e.$Ub=S,e.$Vb=R,e.$Wb=C,e.$Xb=w,e.$Yb=b,e.$Zb=N,e.$1b=L,e.$2b=M,e.$3b=z,e.$4b=V,e.$5b=F,e.$6b=j,e.$7b=W,e.$8b=J,e.$9b=B,e.$0b=x,e.$$b=oe,e.$bc=ce,e.$fc=be;function D(ae,we=0){return ae[ae.length-(1+we)]}function O(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function T(ae,we,$e=(pe,Oe)=>pe===Oe){if(ae===we)return!0;if(!ae||!we||ae.length!==we.length)return!1;for(let pe=0,Oe=ae.length;pe<Oe;pe++)if(!$e(ae[pe],we[pe]))return!1;return!0}function A(ae,we){const $e=ae.length-1;we<$e&&(ae[we]=ae[$e]),ae.pop()}function p(ae,we,$e){return c(ae.length,pe=>$e(ae[pe],we))}function c(ae,we){let $e=0,pe=ae-1;for(;$e<=pe;){const Oe=($e+pe)/2|0,Fe=we(Oe);if(Fe<0)$e=Oe+1;else if(Fe>0)pe=Oe-1;else return Oe}return-($e+1)}function I(ae,we,$e){if(ae=ae|0,ae>=we.length)throw new TypeError("invalid index");const pe=we[Math.floor(we.length*Math.random())],Oe=[],Fe=[],He=[];for(const Ze of we){const xe=$e(Ze,pe);xe<0?Oe.push(Ze):xe>0?Fe.push(Ze):He.push(Ze)}return ae<Oe.length?I(ae,Oe,$e):ae<Oe.length+He.length?He[0]:I(ae-(Oe.length+He.length),Fe,$e)}function E(ae,we){const $e=[];let pe;for(const Oe of ae.slice(0).sort(we))!pe||we(pe[0],Oe)!==0?(pe=[Oe],$e.push(pe)):pe.push(Oe);return $e}function*f(ae,we){let $e,pe;for(const Oe of ae)pe!==void 0&&we(pe,Oe)?$e.push(Oe):($e&&(yield $e),$e=[Oe]),pe=Oe;$e&&(yield $e)}function P(ae,we){for(let $e=0;$e<=ae.length;$e++)we($e===0?void 0:ae[$e-1],$e===ae.length?void 0:ae[$e])}function v(ae,we){for(let $e=0;$e<ae.length;$e++)we($e===0?void 0:ae[$e-1],ae[$e],$e+1===ae.length?void 0:ae[$e+1])}function o(ae,we,$e){const pe=[];function Oe(Ze,xe,je){if(xe===0&&je.length===0)return;const qe=pe[pe.length-1];qe&&qe.start+qe.deleteCount===Ze?(qe.deleteCount+=xe,qe.toInsert.push(...je)):pe.push({start:Ze,deleteCount:xe,toInsert:je})}let Fe=0,He=0;for(;;){if(Fe===ae.length){Oe(Fe,0,we.slice(He));break}if(He===we.length){Oe(Fe,ae.length-Fe,[]);break}const Ze=ae[Fe],xe=we[He],je=$e(Ze,xe);je===0?(Fe+=1,He+=1):je<0?(Oe(Fe,1,[]),Fe+=1):je>0&&(Oe(Fe,0,[xe]),He+=1)}return pe}function m(ae,we,$e){const pe=o(ae,we,$e),Oe=[],Fe=[];for(const He of pe)Oe.push(...ae.slice(He.start,He.start+He.deleteCount)),Fe.push(...He.toInsert);return{removed:Oe,added:Fe}}function $(ae,we,$e){if($e===0)return[];const pe=ae.slice(0,$e).sort(we);return i(ae,we,pe,$e,ae.length),pe}function d(ae,we,$e,pe,Oe){return $e===0?Promise.resolve([]):new Promise((Fe,He)=>{(async()=>{const Ze=ae.length,xe=ae.slice(0,$e).sort(we);for(let je=$e,qe=Math.min($e+pe,Ze);je<Ze;je=qe,qe=Math.min(qe+pe,Ze)){if(je>$e&&await new Promise(Ne=>setTimeout(Ne)),Oe&&Oe.isCancellationRequested)throw new s.$9;i(ae,we,xe,je,qe)}return xe})().then(Fe,He)})}function i(ae,we,$e,pe,Oe){for(const Fe=$e.length;pe<Oe;pe++){const He=ae[pe];if(we(He,$e[Fe-1])<0){$e.pop();const Ze=(0,h.$ob)($e,xe=>we(He,xe)<0);$e.splice(Ze,0,He)}}}function a(ae){return ae.filter(we=>!!we)}function t(ae){let we=0;for(let $e=0;$e<ae.length;$e++)ae[$e]&&(ae[we]=ae[$e],we+=1);ae.length=we}function r(ae,we,$e){ae.splice($e,0,ae.splice(we,1)[0])}function n(ae){return!Array.isArray(ae)||ae.length===0}function u(ae){return Array.isArray(ae)&&ae.length>0}function l(ae,we=$e=>$e){const $e=new Set;return ae.filter(pe=>{const Oe=we(pe);return $e.has(Oe)?!1:($e.add(Oe),!0)})}function g(ae){const we=new Set;return $e=>{const pe=ae($e);return we.has(pe)?!1:(we.add(pe),!0)}}function y(ae,we){return ae.length>0?ae[0]:we}function k(ae,we){return ae.length>0?ae[ae.length-1]:we}function S(ae,we,$e=(pe,Oe)=>pe===Oe){let pe=0;for(let Oe=0,Fe=Math.min(ae.length,we.length);Oe<Fe&&$e(ae[Oe],we[Oe]);Oe++)pe++;return pe}function R(ae,we){let $e=typeof we=="number"?ae:0;typeof we=="number"?$e=ae:($e=0,we=ae);const pe=[];if($e<=we)for(let Oe=$e;Oe<we;Oe++)pe.push(Oe);else for(let Oe=$e;Oe>we;Oe--)pe.push(Oe);return pe}function C(ae,we,$e){return ae.reduce((pe,Oe)=>(pe[we(Oe)]=$e?$e(Oe):Oe,pe),Object.create(null))}function w(ae,we){return ae.push(we),()=>b(ae,we)}function b(ae,we){const $e=ae.indexOf(we);if($e>-1)return ae.splice($e,1),we}function N(ae,we,$e){const pe=ae.slice(0,we),Oe=ae.slice(we);return pe.concat($e,Oe)}function L(ae,we){let $e;if(typeof we=="number"){let pe=we;$e=()=>{const Oe=Math.sin(pe++)*179426549;return Oe-Math.floor(Oe)}}else $e=Math.random;for(let pe=ae.length-1;pe>0;pe-=1){const Oe=Math.floor($e()*(pe+1)),Fe=ae[pe];ae[pe]=ae[Oe],ae[Oe]=Fe}}function M(ae,we){const $e=ae.indexOf(we);$e>-1&&(ae.splice($e,1),ae.unshift(we))}function z(ae,we){const $e=ae.indexOf(we);$e>-1&&(ae.splice($e,1),ae.push(we))}function V(ae,we){for(const $e of we)ae.push($e)}function F(ae,we){return Array.isArray(ae)?ae.map(we):we(ae)}function j(ae){return Array.isArray(ae)?ae:[ae]}function W(ae){return ae[Math.floor(Math.random()*ae.length)]}function J(ae,we,$e){const pe=U(ae,we),Oe=ae.length,Fe=$e.length;ae.length=Oe+Fe;for(let He=Oe-1;He>=pe;He--)ae[He+Fe]=ae[He];for(let He=0;He<Fe;He++)ae[He+pe]=$e[He]}function B(ae,we,$e,pe){const Oe=U(ae,we);let Fe=ae.splice(Oe,$e);return Fe===void 0&&(Fe=[]),J(ae,Oe,pe),Fe}function U(ae,we){return we<0?Math.max(we+ae.length,0):Math.min(we,ae.length)}var _;(function(ae){function we(Fe){return Fe<0}ae.isLessThan=we;function $e(Fe){return Fe<=0}ae.isLessThanOrEqual=$e;function pe(Fe){return Fe>0}ae.isGreaterThan=pe;function Oe(Fe){return Fe===0}ae.isNeitherLessOrGreaterThan=Oe,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function x(ae,we){return($e,pe)=>we(ae($e),ae(pe))}function oe(...ae){return(we,$e)=>{for(const pe of ae){const Oe=pe(we,$e);if(!_.isNeitherLessOrGreaterThan(Oe))return Oe}return _.neitherLessOrGreaterThan}}const te=(ae,we)=>ae-we;e.$_b=te;const me=(ae,we)=>(0,e.$_b)(ae?1:0,we?1:0);e.$ac=me;function ce(ae){return(we,$e)=>-ae(we,$e)}class Y{constructor(we){this.g=we,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(we){let $e=this.c;for(;$e<this.g.length&&we(this.g[$e]);)$e++;const pe=$e===this.c?null:this.g.slice(this.c,$e);return this.c=$e,pe}takeFromEndWhile(we){let $e=this.d;for(;$e>=0&&we(this.g[$e]);)$e--;const pe=$e===this.d?null:this.g.slice($e+1,this.d+1);return this.d=$e,pe}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const we=this.g[this.c];return this.c++,we}removeLast(){const we=this.g[this.d];return this.d--,we}takeCount(we){const $e=this.g.slice(this.c,this.c+we);return this.c+=we,$e}}e.$cc=Y;class q{static{this.empty=new q(we=>{})}constructor(we){this.iterate=we}forEach(we){this.iterate($e=>(we($e),!0))}toArray(){const we=[];return this.iterate($e=>(we.push($e),!0)),we}filter(we){return new q($e=>this.iterate(pe=>we(pe)?$e(pe):!0))}map(we){return new q($e=>this.iterate(pe=>$e(we(pe))))}some(we){let $e=!1;return this.iterate(pe=>($e=we(pe),!$e)),$e}findFirst(we){let $e;return this.iterate(pe=>we(pe)?($e=pe,!1):!0),$e}findLast(we){let $e;return this.iterate(pe=>(we(pe)&&($e=pe),!0)),$e}findLastMaxBy(we){let $e,pe=!0;return this.iterate(Oe=>((pe||_.isGreaterThan(we(Oe,$e)))&&(pe=!1,$e=Oe),!0)),$e}}e.$dc=q;class se{constructor(we){this.c=we}static createSortPermutation(we,$e){const pe=Array.from(we.keys()).sort((Oe,Fe)=>$e(we[Oe],we[Fe]));return new se(pe)}apply(we){return we.map(($e,pe)=>we[this.c[pe]])}inverse(){const we=this.c.slice();for(let $e=0;$e<this.c.length;$e++)we[this.c[$e]]=$e;return new se(we)}}e.$ec=se;async function be(ae,we){return(await Promise.all(ae.map(async(pe,Oe)=>({element:pe,ok:await we(pe,Oe)})))).find(pe=>pe.ok)?.element}}),define(Re[67],Ce([1,0,12]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$jd=D,e.$kd=O,e.$ld=T,e.$md=A,e.$nd=p;function h(c,I){if(!c)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function D(c,I="Unreachable"){throw new Error(I)}function O(c,I="unexpected state"){if(!c)throw new s.$gb(`Assertion Failed: ${I}`)}function T(c){c||(0,s.$4)(new s.$gb("Soft Assertion Failed"))}function A(c){if(!c()){debugger;c(),(0,s.$4)(new s.$gb("Assertion Failed"))}}function p(c,I){let E=0;for(;E<c.length-1;){const f=c[E],P=c[E+1];if(!I(f,P))return!1;E++}return!0}});var Kn=this&&this.__createBinding||(Object.create?function(ge,e,s,h){h===void 0&&(h=s);var D=Object.getOwnPropertyDescriptor(e,s);(!D||("get"in D?!e.__esModule:D.writable||D.configurable))&&(D={enumerable:!0,get:function(){return e[s]}}),Object.defineProperty(ge,h,D)}:function(ge,e,s,h){h===void 0&&(h=s),ge[h]=e[s]}),Gn=this&&this.__setModuleDefault||(Object.create?function(ge,e){Object.defineProperty(ge,"default",{enumerable:!0,value:e})}:function(ge,e){ge.default=e}),Ue=this&&this.__importStar||function(ge){if(ge&&ge.__esModule)return ge;var e={};if(ge!=null)for(var s in ge)s!=="default"&&Object.prototype.hasOwnProperty.call(ge,s)&&Kn(e,ge,s);return Gn(e,ge),e};define(Re[180],Ce([1,0,18]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$c=void 0,e.$_c=D,e.$ad=O,e.$bd=T,e.$cd=A,e.$dd=p,e.$ed=c,s=Ue(s);const h=(P,v)=>P===v;e.$$c=h;function D(P=e.$$c){return(v,o)=>s.$yb(v,o,P)}function O(){return(P,v)=>JSON.stringify(P)===JSON.stringify(v)}function T(){return(P,v)=>P.equals(v)}function A(P,v,o){if(o!==void 0){const m=P;return m==null||v===void 0||v===null?v===m:o(m,v)}else{const m=P;return($,d)=>$==null||d===void 0||d===null?d===$:m($,d)}}function p(P,v){if(P===v)return!0;if(Array.isArray(P)&&Array.isArray(v)){if(P.length!==v.length)return!1;for(let o=0;o<P.length;o++)if(!p(P[o],v[o]))return!1;return!0}if(P&&typeof P=="object"&&v&&typeof v=="object"&&Object.getPrototypeOf(P)===Object.prototype&&Object.getPrototypeOf(v)===Object.prototype){const o=P,m=v,$=Object.keys(o),d=Object.keys(m),i=new Set(d);if($.length!==d.length)return!1;for(const a of $)if(!i.has(a)||!p(o[a],m[a]))return!1;return!0}return!1}function c(P){return JSON.stringify(f(P))}let I=0;const E=new WeakMap;function f(P){if(Array.isArray(P))return P.map(f);if(P&&typeof P=="object")if(Object.getPrototypeOf(P)===Object.prototype){const v=P,o=Object.create(null);for(const m of Object.keys(v).sort())o[m]=f(v[m]);return o}else{let v=E.get(P);return v===void 0&&(v=I++,E.set(P,v)),v+"----2b76a038c20c4bcc"}return P}}),define(Re[81],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hb=s;function s(h,D){const O=this;let T=!1,A;return function(){if(T)return A;if(T=!0,D)try{A=h.apply(O,arguments)}finally{D()}else A=h.apply(O,arguments);return A}}}),define(Re[135],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=e.$TQ=void 0;class s{constructor(D){this.a=D,this.b=0}nextId(){return this.a+ ++this.b}}e.$TQ=s,e.$UQ=new s("id#")}),define(Re[40],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var s;(function(h){function D(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}h.is=D;const O=Object.freeze([]);function T(){return O}h.empty=T;function*A(n){yield n}h.single=A;function p(n){return D(n)?n:A(n)}h.wrap=p;function c(n){return n||O}h.from=c;function*I(n){for(let u=n.length-1;u>=0;u--)yield n[u]}h.reverse=I;function E(n){return!n||n[Symbol.iterator]().next().done===!0}h.isEmpty=E;function f(n){return n[Symbol.iterator]().next().value}h.first=f;function P(n,u){let l=0;for(const g of n)if(u(g,l++))return!0;return!1}h.some=P;function v(n,u){for(const l of n)if(u(l))return l}h.find=v;function*o(n,u){for(const l of n)u(l)&&(yield l)}h.filter=o;function*m(n,u){let l=0;for(const g of n)yield u(g,l++)}h.map=m;function*$(n,u){let l=0;for(const g of n)yield*u(g,l++)}h.flatMap=$;function*d(...n){for(const u of n)yield*u}h.concat=d;function i(n,u,l){let g=l;for(const y of n)g=u(g,y);return g}h.reduce=i;function*a(n,u,l=n.length){for(u<0&&(u+=n.length),l<0?l+=n.length:l>n.length&&(l=n.length);u<l;u++)yield n[u]}h.slice=a;function t(n,u=Number.POSITIVE_INFINITY){const l=[];if(u===0)return[l,n];const g=n[Symbol.iterator]();for(let y=0;y<u;y++){const k=g.next();if(k.done)return[l,h.empty()];l.push(k.value)}return[l,{[Symbol.iterator](){return g}}]}h.consume=t;async function r(n){const u=[];for await(const l of n)u.push(l);return Promise.resolve(u)}h.asyncToArray=r})(s||(e.Iterable=s={}))}),define(Re[181],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$5n=T,e.$6n=E,e.$7n=f,e.$8n=P,e.$9n=v,e.$0n=o,e.$$n=m,e.$_n=$,e.$ao=d,e.$bo=i,e.$co=a;var s;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(s||(e.ScanError=s={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function T(t,r=!1){let n=0;const u=t.length;let l="",g=0,y=h.Unknown,k=s.None;function S(M){let z=0,V=0;for(;z<M;){const F=t.charCodeAt(n);if(F>=I._0&&F<=I._9)V=V*16+F-I._0;else if(F>=I.A&&F<=I.F)V=V*16+F-I.A+10;else if(F>=I.a&&F<=I.f)V=V*16+F-I.a+10;else break;n++,z++}return z<M&&(V=-1),V}function R(M){n=M,l="",g=0,y=h.Unknown,k=s.None}function C(){const M=n;if(t.charCodeAt(n)===I._0)n++;else for(n++;n<t.length&&c(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===I.dot)if(n++,n<t.length&&c(t.charCodeAt(n)))for(n++;n<t.length&&c(t.charCodeAt(n));)n++;else return k=s.UnexpectedEndOfNumber,t.substring(M,n);let z=n;if(n<t.length&&(t.charCodeAt(n)===I.E||t.charCodeAt(n)===I.e))if(n++,(n<t.length&&t.charCodeAt(n)===I.plus||t.charCodeAt(n)===I.minus)&&n++,n<t.length&&c(t.charCodeAt(n))){for(n++;n<t.length&&c(t.charCodeAt(n));)n++;z=n}else k=s.UnexpectedEndOfNumber;return t.substring(M,z)}function w(){let M="",z=n;for(;;){if(n>=u){M+=t.substring(z,n),k=s.UnexpectedEndOfString;break}const V=t.charCodeAt(n);if(V===I.doubleQuote){M+=t.substring(z,n),n++;break}if(V===I.backslash){if(M+=t.substring(z,n),n++,n>=u){k=s.UnexpectedEndOfString;break}switch(t.charCodeAt(n++)){case I.doubleQuote:M+='"';break;case I.backslash:M+="\\";break;case I.slash:M+="/";break;case I.b:M+="\b";break;case I.f:M+="\f";break;case I.n:M+=`
`;break;case I.r:M+="\r";break;case I.t:M+="	";break;case I.u:{const j=S(4);j>=0?M+=String.fromCharCode(j):k=s.InvalidUnicode;break}default:k=s.InvalidEscapeCharacter}z=n;continue}if(V>=0&&V<=31)if(p(V)){M+=t.substring(z,n),k=s.UnexpectedEndOfString;break}else k=s.InvalidCharacter;n++}return M}function b(){if(l="",k=s.None,g=n,n>=u)return g=u,y=h.EOF;let M=t.charCodeAt(n);if(A(M)){do n++,l+=String.fromCharCode(M),M=t.charCodeAt(n);while(A(M));return y=h.Trivia}if(p(M))return n++,l+=String.fromCharCode(M),M===I.carriageReturn&&t.charCodeAt(n)===I.lineFeed&&(n++,l+=`
`),y=h.LineBreakTrivia;switch(M){case I.openBrace:return n++,y=h.OpenBraceToken;case I.closeBrace:return n++,y=h.CloseBraceToken;case I.openBracket:return n++,y=h.OpenBracketToken;case I.closeBracket:return n++,y=h.CloseBracketToken;case I.colon:return n++,y=h.ColonToken;case I.comma:return n++,y=h.CommaToken;case I.doubleQuote:return n++,l=w(),y=h.StringLiteral;case I.slash:{const z=n-1;if(t.charCodeAt(n+1)===I.slash){for(n+=2;n<u&&!p(t.charCodeAt(n));)n++;return l=t.substring(z,n),y=h.LineCommentTrivia}if(t.charCodeAt(n+1)===I.asterisk){n+=2;const V=u-1;let F=!1;for(;n<V;){if(t.charCodeAt(n)===I.asterisk&&t.charCodeAt(n+1)===I.slash){n+=2,F=!0;break}n++}return F||(n++,k=s.UnexpectedEndOfComment),l=t.substring(z,n),y=h.BlockCommentTrivia}return l+=String.fromCharCode(M),n++,y=h.Unknown}case I.minus:if(l+=String.fromCharCode(M),n++,n===u||!c(t.charCodeAt(n)))return y=h.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return l+=C(),y=h.NumericLiteral;default:for(;n<u&&N(M);)n++,M=t.charCodeAt(n);if(g!==n){switch(l=t.substring(g,n),l){case"true":return y=h.TrueKeyword;case"false":return y=h.FalseKeyword;case"null":return y=h.NullKeyword}return y=h.Unknown}return l+=String.fromCharCode(M),n++,y=h.Unknown}}function N(M){if(A(M)||p(M))return!1;switch(M){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function L(){let M;do M=b();while(M>=h.LineCommentTrivia&&M<=h.Trivia);return M}return{setPosition:R,getPosition:()=>n,scan:r?L:b,getToken:()=>y,getTokenValue:()=>l,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>k}}function A(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function p(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function c(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function E(t,r){const n=[],u=new Object;let l;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function k(S,R,C,w){g.value=S,g.offset=R,g.length=C,g.type=w,g.colonOffset=void 0,l=g}try{i(t,{onObjectBegin:(S,R)=>{if(r<=S)throw u;l=void 0,y=r>S,n.push("")},onObjectProperty:(S,R,C)=>{if(r<R||(k(S,R,C,"property"),n[n.length-1]=S,r<=R+C))throw u},onObjectEnd:(S,R)=>{if(r<=S)throw u;l=void 0,n.pop()},onArrayBegin:(S,R)=>{if(r<=S)throw u;l=void 0,n.push(0)},onArrayEnd:(S,R)=>{if(r<=S)throw u;l=void 0,n.pop()},onLiteralValue:(S,R,C)=>{if(r<R||(k(S,R,C,a(S)),r<=R+C))throw u},onSeparator:(S,R,C)=>{if(r<=R)throw u;if(S===":"&&l&&l.type==="property")l.colonOffset=R,y=!1,l=void 0;else if(S===","){const w=n[n.length-1];typeof w=="number"?n[n.length-1]=w+1:(y=!0,n[n.length-1]=""),l=void 0}}})}catch(S){if(S!==u)throw S}return{path:n,previousNode:l,isAtPropertyKey:y,matches:S=>{let R=0;for(let C=0;R<S.length&&C<n.length;C++)if(S[R]===n[C]||S[R]==="*")R++;else if(S[R]!=="**")return!1;return R===S.length}}}function f(t,r=[],n=O.DEFAULT){let u=null,l=[];const g=[];function y(S){Array.isArray(l)?l.push(S):u!==null&&(l[u]=S)}return i(t,{onObjectBegin:()=>{const S={};y(S),g.push(l),l=S,u=null},onObjectProperty:S=>{u=S},onObjectEnd:()=>{l=g.pop()},onArrayBegin:()=>{const S=[];y(S),g.push(l),l=S,u=null},onArrayEnd:()=>{l=g.pop()},onLiteralValue:y,onError:(S,R,C)=>{r.push({error:S,offset:R,length:C})}},n),l[0]}function P(t,r=[],n=O.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(S){u.type==="property"&&(u.length=S-u.offset,u=u.parent)}function g(S){return u.children.push(S),S}i(t,{onObjectBegin:S=>{u=g({type:"object",offset:S,length:-1,parent:u,children:[]})},onObjectProperty:(S,R,C)=>{u=g({type:"property",offset:R,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:S,offset:R,length:C,parent:u})},onObjectEnd:(S,R)=>{u.length=S+R-u.offset,u=u.parent,l(S+R)},onArrayBegin:(S,R)=>{u=g({type:"array",offset:S,length:-1,parent:u,children:[]})},onArrayEnd:(S,R)=>{u.length=S+R-u.offset,u=u.parent,l(S+R)},onLiteralValue:(S,R,C)=>{g({type:a(S),offset:R,length:C,parent:u,value:S}),l(R+C)},onSeparator:(S,R,C)=>{u.type==="property"&&(S===":"?u.colonOffset=R:S===","&&l(R))},onError:(S,R,C)=>{r.push({error:S,offset:R,length:C})}},n);const k=u.children[0];return k&&delete k.parent,k}function v(t,r){if(!t)return;let n=t;for(const u of r)if(typeof u=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===u){n=g.children[1],l=!0;break}if(!l)return}else{const l=u;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}function o(t){if(!t.parent||!t.parent.children)return[];const r=o(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const r=Object.create(null);for(const n of t.children){const u=n.children[1];u&&(r[n.children[0].value]=m(u))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}function d(t,r,n=!1){if($(t,r,n)){const u=t.children;if(Array.isArray(u))for(let l=0;l<u.length&&u[l].offset<=r;l++){const g=d(u[l],r,n);if(g)return g}return t}}function i(t,r,n=O.DEFAULT){const u=T(t,!1);function l(x){return x?()=>x(u.getTokenOffset(),u.getTokenLength()):()=>!0}function g(x){return x?oe=>x(oe,u.getTokenOffset(),u.getTokenLength()):()=>!0}const y=l(r.onObjectBegin),k=g(r.onObjectProperty),S=l(r.onObjectEnd),R=l(r.onArrayBegin),C=l(r.onArrayEnd),w=g(r.onLiteralValue),b=g(r.onSeparator),N=l(r.onComment),L=g(r.onError),M=n&&n.disallowComments,z=n&&n.allowTrailingComma;function V(){for(;;){const x=u.scan();switch(u.getTokenError()){case s.InvalidUnicode:F(D.InvalidUnicode);break;case s.InvalidEscapeCharacter:F(D.InvalidEscapeCharacter);break;case s.UnexpectedEndOfNumber:F(D.UnexpectedEndOfNumber);break;case s.UnexpectedEndOfComment:M||F(D.UnexpectedEndOfComment);break;case s.UnexpectedEndOfString:F(D.UnexpectedEndOfString);break;case s.InvalidCharacter:F(D.InvalidCharacter);break}switch(x){case h.LineCommentTrivia:case h.BlockCommentTrivia:M?F(D.InvalidCommentToken):N();break;case h.Unknown:F(D.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return x}}}function F(x,oe=[],te=[]){if(L(x),oe.length+te.length>0){let me=u.getToken();for(;me!==h.EOF;){if(oe.indexOf(me)!==-1){V();break}else if(te.indexOf(me)!==-1)break;me=V()}}}function j(x){const oe=u.getTokenValue();return x?w(oe):k(oe),V(),!0}function W(){switch(u.getToken()){case h.NumericLiteral:{let x=0;try{x=JSON.parse(u.getTokenValue()),typeof x!="number"&&(F(D.InvalidNumberFormat),x=0)}catch{F(D.InvalidNumberFormat)}w(x);break}case h.NullKeyword:w(null);break;case h.TrueKeyword:w(!0);break;case h.FalseKeyword:w(!1);break;default:return!1}return V(),!0}function J(){return u.getToken()!==h.StringLiteral?(F(D.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(j(!1),u.getToken()===h.ColonToken?(b(":"),V(),_()||F(D.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):F(D.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function B(){y(),V();let x=!1;for(;u.getToken()!==h.CloseBraceToken&&u.getToken()!==h.EOF;){if(u.getToken()===h.CommaToken){if(x||F(D.ValueExpected,[],[]),b(","),V(),u.getToken()===h.CloseBraceToken&&z)break}else x&&F(D.CommaExpected,[],[]);J()||F(D.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),x=!0}return S(),u.getToken()!==h.CloseBraceToken?F(D.CloseBraceExpected,[h.CloseBraceToken],[]):V(),!0}function U(){R(),V();let x=!1;for(;u.getToken()!==h.CloseBracketToken&&u.getToken()!==h.EOF;){if(u.getToken()===h.CommaToken){if(x||F(D.ValueExpected,[],[]),b(","),V(),u.getToken()===h.CloseBracketToken&&z)break}else x&&F(D.CommaExpected,[],[]);_()||F(D.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),x=!0}return C(),u.getToken()!==h.CloseBracketToken?F(D.CloseBracketExpected,[h.CloseBracketToken],[]):V(),!0}function _(){switch(u.getToken()){case h.OpenBracketToken:return U();case h.OpenBraceToken:return B();case h.StringLiteral:return j(!0);default:return W()}}return V(),u.getToken()===h.EOF?n.allowEmptyContent?!0:(F(D.ValueExpected,[],[]),!1):_()?(u.getToken()!==h.EOF&&F(D.EndOfFileExpected,[],[]),!0):(F(D.ValueExpected,[],[]),!1)}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Re[182],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=s;function s(O){let T=!1;const A=new Map,p=new Map;if(D(O,o=>{if(O===o)return!0;const m=JSON.stringify(o);if(m.length<30)return!0;const $=A.get(m);if(!$){const d={schemas:[o]};return A.set(m,d),p.set(o,d),!0}return $.schemas.push(o),p.set(o,$),T=!0,!1}),A.clear(),!T)return JSON.stringify(O);let I="$defs";for(;O.hasOwnProperty(I);)I+="_";const E=[];function f(o){return JSON.stringify(o,(m,$)=>{if($!==o){const d=p.get($);if(d&&d.schemas.length>1)return d.id||(d.id=`_${E.length}`,E.push(d.schemas[0])),{$ref:`#/${I}/${d.id}`}}return $})}const P=f(O),v=[];for(let o=0;o<E.length;o++)v.push(`"_${o}":${f(E[o])}`);return v.length?`${P.substring(0,P.length-1)},"${I}":{${v.join(",")}}}`:P}function h(O){return typeof O=="object"&&O!==null}function D(O,T){if(!O||typeof O!="object")return;const A=(...P)=>{for(const v of P)h(v)&&E.push(v)},p=(...P)=>{for(const v of P)if(h(v))for(const o in v){const m=v[o];h(m)&&E.push(m)}},c=(...P)=>{for(const v of P)if(Array.isArray(v))for(const o of v)h(o)&&E.push(o)},I=P=>{if(Array.isArray(P))for(const v of P)h(v)&&E.push(v);else h(P)&&E.push(P)},E=[O];let f=E.pop();for(;f;)T(f)&&(A(f.additionalItems,f.additionalProperties,f.not,f.contains,f.propertyNames,f.if,f.then,f.else,f.unevaluatedItems,f.unevaluatedProperties),p(f.definitions,f.$defs,f.properties,f.patternProperties,f.dependencies,f.dependentSchemas),c(f.anyOf,f.allOf,f.oneOf,f.prefixItems),I(f.items)),f=E.pop()}}),define(Re[50],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y=void 0;class s{constructor(D){this.d=D,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$Y=s}),define(Re[82],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=void 0;class s{static{this.Undefined=new s(void 0)}constructor(O){this.element=O,this.next=s.Undefined,this.prev=s.Undefined}}class h{constructor(){this.a=s.Undefined,this.b=s.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===s.Undefined}clear(){let O=this.a;for(;O!==s.Undefined;){const T=O.next;O.prev=s.Undefined,O.next=s.Undefined,O=T}this.a=s.Undefined,this.b=s.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,T){const A=new s(O);if(this.a===s.Undefined)this.a=A,this.b=A;else if(T){const c=this.b;this.b=A,A.prev=c,c.next=A}else{const c=this.a;this.a=A,A.next=c,c.prev=A}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(A))}}shift(){if(this.a!==s.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==s.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==s.Undefined&&O.next!==s.Undefined){const T=O.prev;T.next=O.next,O.next.prev=T}else O.prev===s.Undefined&&O.next===s.Undefined?(this.a=s.Undefined,this.b=s.Undefined):O.next===s.Undefined?(this.b=this.b.prev,this.b.next=s.Undefined):O.prev===s.Undefined&&(this.a=this.a.next,this.a.prev=s.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==s.Undefined;)yield O.element,O=O.next}}e.$0c=h}),define(Re[28],Ce([1,0]),function(ge,e){"use strict";var s,h,D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.Touch=e.$Gc=e.$Fc=void 0,e.$Cc=O,e.$Dc=T,e.$Ec=A,e.$Nc=a;function O(t,r,n){let u=t.get(r);return u===void 0&&(u=n,t.set(r,u)),u}function T(t){const r=[];return t.forEach((n,u)=>{r.push(`${u} => ${n}`)}),`Map(${t.size}) {${r.join(", ")}}`}function A(t){const r=[];return t.forEach(n=>{r.push(n)}),`Set(${t.size}) {${r.join(", ")}}`}class p{constructor(r,n){this.uri=r,this.value=n}}function c(t){return Array.isArray(t)}class I{static{this.c=r=>r.toString()}constructor(r,n){if(this[s]="ResourceMap",r instanceof I)this.d=new Map(r.d),this.e=n??I.c;else if(c(r)){this.d=new Map,this.e=n??I.c;for(const[u,l]of r)this.set(u,l)}else this.d=new Map,this.e=r??I.c}set(r,n){return this.d.set(this.e(r),new p(r,n)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,n){typeof n<"u"&&(r=r.bind(n));for(const[u,l]of this.d)r(l.value,l.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(s=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Fc=I;class E{constructor(r,n){this[h]="ResourceSet",!r||typeof r=="function"?this.c=new I(r):(this.c=new I(n),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,n){this.c.forEach((u,l)=>r.call(n,l,l,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Gc=E;var f;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class P{constructor(){this[D]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,n=f.None){const u=this.c.get(r);if(u)return n!==f.None&&this.m(u,n),u.value}set(r,n,u=f.None){let l=this.c.get(r);if(l)l.value=n,u!==f.None&&this.m(l,u);else{switch(l={key:r,value:n,next:void 0,previous:void 0},u){case f.None:this.k(l);break;case f.AsOld:this.j(l);break;case f.AsNew:this.k(l);break;default:this.k(l);break}this.c.set(r,l),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const n=this.c.get(r);if(n)return this.c.delete(r),this.l(n),this.f--,n.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,n){const u=this.g;let l=this.d;for(;l;){if(n?r.bind(n)(l.value,l.key,this):r(l.value,l.key,this),this.g!==u)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,n=this.g;let u=this.d;const l={[Symbol.iterator](){return l},next(){if(r.g!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.key,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return l}values(){const r=this,n=this.g;let u=this.d;const l={[Symbol.iterator](){return l},next(){if(r.g!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.value,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return l}entries(){const r=this,n=this.g;let u=this.d;const l={[Symbol.iterator](){return l},next(){if(r.g!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:[u.key,u.value],done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return l}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let n=this.d,u=this.size;for(;n&&u>r;)this.c.delete(n.key),n=n.next,u--;this.d=n,this.f=u,n&&(n.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let n=this.e,u=this.size;for(;n&&u>r;)this.c.delete(n.key),n=n.previous,u--;this.e=n,this.f=u,n&&(n.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const n=r.next,u=r.previous;if(!n||!u)throw new Error("Invalid list");n.previous=u,u.next=n}r.next=void 0,r.previous=void 0,this.g++}m(r,n){if(!this.d||!this.e)throw new Error("Invalid list");if(!(n!==f.AsOld&&n!==f.AsNew)){if(n===f.AsOld){if(r===this.d)return;const u=r.next,l=r.previous;r===this.e?(l.next=void 0,this.e=l):(u.previous=l,l.next=u),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(n===f.AsNew){if(r===this.e)return;const u=r.next,l=r.previous;r===this.d?(u.previous=void 0,this.d=u):(u.previous=l,l.next=u),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((n,u)=>{r.push([u,n])}),r}fromJSON(r){this.clear();for(const[n,u]of r)this.set(n,u)}}e.$Hc=P;class v extends P{constructor(r,n=1){super(),this.n=r,this.o=Math.min(Math.max(0,n),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,n=f.AsNew){return super.get(r,n)}peek(r){return super.get(r,f.None)}set(r,n){return super.set(r,n,f.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class o extends v{constructor(r,n=1){super(r,n)}q(r){this.h(r)}set(r,n){return super.set(r,n),this.p(),this}}e.$Ic=o;class m extends v{constructor(r,n=1){super(r,n)}q(r){this.i(r)}set(r,n){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,n),this}}e.$Jc=m;class ${constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let n=this.c.get(r)||0;return n===0?!1:(n--,n===0?this.c.delete(r):this.c.set(r,n),!0)}has(r){return this.c.has(r)}}e.$Kc=$;class d{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[n,u]of r)this.set(n,u)}clear(){this.c.clear(),this.d.clear()}set(r,n){this.c.set(r,n),this.d.set(n,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const n=this.c.get(r);return n===void 0?!1:(this.c.delete(r),this.d.delete(n),!0)}forEach(r,n){this.c.forEach((u,l)=>{r.call(n,u,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Lc=d;class i{constructor(){this.c=new Map}add(r,n){let u=this.c.get(r);u||(u=new Set,this.c.set(r,u)),u.add(n)}delete(r,n){const u=this.c.get(r);u&&(u.delete(n),u.size===0&&this.c.delete(r))}forEach(r,n){const u=this.c.get(r);u&&u.forEach(n)}get(r){const n=this.c.get(r);return n||new Set}}e.$Mc=i;function a(t,r){if(t===r)return!0;if(t.size!==r.size)return!1;for(const[n,u]of t)if(!r.has(n)||r.get(n)!==u)return!1;for(const[n]of r)if(!t.has(n))return!1;return!0}}),define(Re[3],Ce([1,0,18,80,28,81,40]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Oc=void 0,e.$Pc=I,e.$Qc=E,e.$Rc=f,e.$Sc=o,e.$Tc=m,e.$Uc=$,e.$Vc=d,e.$Wc=i,e.$Xc=a,e.$8c=R;const A=!1;let p=null;class c{constructor(){this.b=new Map}static{this.a=0}c(b){let N=this.b.get(b);return N||(N={parent:null,source:null,isSingleton:!1,value:b,idx:c.a++},this.b.set(b,N)),N}trackDisposable(b){const N=this.c(b);N.source||(N.source=new Error().stack)}setParent(b,N){const L=this.c(b);L.parent=N}markAsDisposed(b){this.b.delete(b)}markAsSingleton(b){this.c(b).isSingleton=!0}f(b,N){const L=N.get(b);if(L)return L;const M=b.parent?this.f(this.c(b.parent),N):b;return N.set(b,M),M}getTrackedDisposables(){const b=new Map;return[...this.b.entries()].filter(([,L])=>L.source!==null&&!this.f(L,b).isSingleton).flatMap(([L])=>L)}computeLeakingDisposables(b=10,N){let L;if(N)L=N;else{const j=new Map,W=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,j).isSingleton);if(W.length===0)return;const J=new Set(W.map(B=>B.value));if(L=W.filter(B=>!(B.parent&&J.has(B.parent))),L.length===0)throw new Error("There are cyclic diposable chains!")}if(!L)return;function M(j){function W(B,U){for(;B.length>0&&U.some(_=>typeof _=="string"?_===B[0]:B[0].match(_));)B.shift()}const J=j.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return W(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const z=new D.$Mc;for(const j of L){const W=M(j);for(let J=0;J<=W.length;J++)z.add(W.slice(0,J).join(`
`),j)}L.sort((0,s.$0b)(j=>j.idx,s.$_b));let V="",F=0;for(const j of L.slice(0,b)){F++;const W=M(j),J=[];for(let B=0;B<W.length;B++){let U=W[B];U=`(shared with ${z.get(W.slice(0,B+1).join(`
`)).size}/${L.length} leaks) at ${U}`;const x=z.get(W.slice(0,B).join(`
`)),oe=(0,h.$e)([...x].map(te=>M(te)[B]),te=>te);delete oe[W[B]];for(const[te,me]of Object.entries(oe))J.unshift(`    - stacktraces of ${me.length} other leaks continue with ${te}`);J.unshift(U)}V+=`


==================== Leaking disposable ${F}/${L.length}: ${j.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return L.length>b&&(V+=`


... and ${L.length-b} more leaking disposables

`),{leaks:L,details:V}}}e.$Oc=c;function I(w){p=w}if(A){const w="__is_disposable_tracked__";I(new class{trackDisposable(b){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[w]||console.log(N)},3e3)}setParent(b,N){if(b&&b!==r.None)try{b[w]=!0}catch{}}markAsDisposed(b){if(b&&b!==r.None)try{b[w]=!0}catch{}}markAsSingleton(b){}})}function E(w){return p?.trackDisposable(w),w}function f(w){p?.markAsDisposed(w)}function P(w,b){p?.setParent(w,b)}function v(w,b){if(p)for(const N of w)p.setParent(N,b)}function o(w){return p?.markAsSingleton(w),w}function m(w){return typeof w=="object"&&w!==null&&typeof w.dispose=="function"&&w.dispose.length===0}function $(w){if(T.Iterable.is(w)){const b=[];for(const N of w)if(N)try{N.dispose()}catch(L){b.push(L)}if(b.length===1)throw b[0];if(b.length>1)throw new AggregateError(b,"Encountered errors while disposing of store");return Array.isArray(w)?[]:w}else if(w)return w.dispose(),w}function d(w){for(const b of w)m(b)&&b.dispose();return[]}function i(...w){const b=a(()=>$(w));return v(w,b),b}function a(w){const b=E({dispose:(0,O.$hb)(()=>{f(b),w()})});return b}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return P(b,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(b),b}delete(b){if(b){if(b===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(b),b.dispose()}}deleteAndLeak(b){b&&this.f.has(b)&&(this.f.delete(b),P(b,null))}}e.$Yc=t;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,E(this),P(this.q,this)}dispose(){f(this),this.q.dispose()}B(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(b)}}e.$Zc=r;class n{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(b){this.b||b===this.a||(this.a?.dispose(),b&&P(b,this),this.a=b)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const b=this.a;return this.a=void 0,b&&P(b,null),b}}e.$1c=n;class u{constructor(b){this.a=new n,this.b=!1,this.a.value=b}get value(){return this.a.value}set value(b){this.b||b===this.a.value||(this.a.value=b)}dispose(){this.b=!0,this.a.dispose()}}e.$2c=u;class l{constructor(b){this.b=b,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$3c=l;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(b){let N=b;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,f(this))},this}}e.$4c=g;class y{constructor(){this.a=new Map}acquire(b,...N){let L=this.a.get(b);L||(L={counter:0,object:this.b(b,...N)},this.a.set(b,L));const{object:M}=L,z=(0,O.$hb)(()=>{--L.counter===0&&(this.c(b,L.object),this.a.delete(b))});return L.counter++,{object:M,dispose:z}}}e.$5c=y;class k{constructor(b){this.a=b}async acquire(b,...N){const L=this.a.acquire(b,...N);try{return{object:await L.object,dispose:()=>L.dispose()}}catch(M){throw L.dispose(),M}}}e.$6c=k;class S{constructor(b){this.object=b}dispose(){}}e.$7c=S;function R(w){const b=new t;try{w(b)}finally{b.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(b){return this.a.has(b)}get size(){return this.a.size}get(b){return this.a.get(b)}set(b,N,L=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||this.a.get(b)?.dispose(),this.a.set(b,N)}deleteAndDispose(b){this.a.get(b)?.dispose(),this.a.delete(b)}deleteAndLeak(b){const N=this.a.get(b);return this.a.delete(b),N}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$9c=C}),function(ge,e){typeof define=="function"&&define.amd?define(Re[183],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}ge.defaults=e();function s(it){ge.defaults=it}const h=/[&<>"']/,D=new RegExp(h.source,"g"),O=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,T=new RegExp(O.source,"g"),A={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=it=>A[it];function c(it,Ie){if(Ie){if(h.test(it))return it.replace(D,p)}else if(O.test(it))return it.replace(T,p);return it}const I=/(^|[^\[])\^/g;function E(it,Ie){let re=typeof it=="string"?it:it.source;Ie=Ie||"";const le={replace:(Se,de)=>{let ke=typeof de=="string"?de:de.source;return ke=ke.replace(I,"$1"),re=re.replace(Se,ke),le},getRegex:()=>new RegExp(re,Ie)};return le}function f(it){try{it=encodeURI(it).replace(/%25/g,"%")}catch{return null}return it}const P={exec:()=>null};function v(it,Ie){const re=it.replace(/\|/g,(de,ke,ne)=>{let X=!1,Pe=ke;for(;--Pe>=0&&ne[Pe]==="\\";)X=!X;return X?"|":" |"}),le=re.split(/ \|/);let Se=0;if(le[0].trim()||le.shift(),le.length>0&&!le[le.length-1].trim()&&le.pop(),Ie)if(le.length>Ie)le.splice(Ie);else for(;le.length<Ie;)le.push("");for(;Se<le.length;Se++)le[Se]=le[Se].trim().replace(/\\\|/g,"|");return le}function o(it,Ie,re){const le=it.length;if(le===0)return"";let Se=0;for(;Se<le;){const de=it.charAt(le-Se-1);if(de===Ie&&!re)Se++;else if(de!==Ie&&re)Se++;else break}return it.slice(0,le-Se)}function m(it,Ie){if(it.indexOf(Ie[1])===-1)return-1;let re=0;for(let le=0;le<it.length;le++)if(it[le]==="\\")le++;else if(it[le]===Ie[0])re++;else if(it[le]===Ie[1]&&(re--,re<0))return le;return-1}function $(it,Ie,re,le){const Se=Ie.href,de=Ie.title?c(Ie.title):null,ke=it[1].replace(/\\([\[\]])/g,"$1");if(it[0].charAt(0)!=="!"){le.state.inLink=!0;const ne={type:"link",raw:re,href:Se,title:de,text:ke,tokens:le.inlineTokens(ke)};return le.state.inLink=!1,ne}return{type:"image",raw:re,href:Se,title:de,text:c(ke)}}function d(it,Ie){const re=it.match(/^(\s+)(?:```)/);if(re===null)return Ie;const le=re[1];return Ie.split(`
`).map(Se=>{const de=Se.match(/^\s+/);if(de===null)return Se;const[ke]=de;return ke.length>=le.length?Se.slice(le.length):Se}).join(`
`)}class i{options;rules;lexer;constructor(Ie){this.options=Ie||ge.defaults}space(Ie){const re=this.rules.block.newline.exec(Ie);if(re&&re[0].length>0)return{type:"space",raw:re[0]}}code(Ie){const re=this.rules.block.code.exec(Ie);if(re){const le=re[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:re[0],codeBlockStyle:"indented",text:this.options.pedantic?le:o(le,`
`)}}}fences(Ie){const re=this.rules.block.fences.exec(Ie);if(re){const le=re[0],Se=d(le,re[3]||"");return{type:"code",raw:le,lang:re[2]?re[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):re[2],text:Se}}}heading(Ie){const re=this.rules.block.heading.exec(Ie);if(re){let le=re[2].trim();if(/#$/.test(le)){const Se=o(le,"#");(this.options.pedantic||!Se||/ $/.test(Se))&&(le=Se.trim())}return{type:"heading",raw:re[0],depth:re[1].length,text:le,tokens:this.lexer.inline(le)}}}hr(Ie){const re=this.rules.block.hr.exec(Ie);if(re)return{type:"hr",raw:o(re[0],`
`)}}blockquote(Ie){const re=this.rules.block.blockquote.exec(Ie);if(re){let le=o(re[0],`
`).split(`
`),Se="",de="";const ke=[];for(;le.length>0;){let ne=!1;const X=[];let Pe;for(Pe=0;Pe<le.length;Pe++)if(/^ {0,3}>/.test(le[Pe]))X.push(le[Pe]),ne=!0;else if(!ne)X.push(le[Pe]);else break;le=le.slice(Pe);const Ke=X.join(`
`),Xe=Ke.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");Se=Se?`${Se}
${Ke}`:Ke,de=de?`${de}
${Xe}`:Xe;const st=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(Xe,ke,!0),this.lexer.state.top=st,le.length===0)break;const dt=ke[ke.length-1];if(dt?.type==="code")break;if(dt?.type==="blockquote"){const gt=dt,kt=gt.raw+`
`+le.join(`
`),At=this.blockquote(kt);ke[ke.length-1]=At,Se=Se.substring(0,Se.length-gt.raw.length)+At.raw,de=de.substring(0,de.length-gt.text.length)+At.text;break}else if(dt?.type==="list"){const gt=dt,kt=gt.raw+`
`+le.join(`
`),At=this.list(kt);ke[ke.length-1]=At,Se=Se.substring(0,Se.length-dt.raw.length)+At.raw,de=de.substring(0,de.length-gt.raw.length)+At.raw,le=kt.substring(ke[ke.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:Se,tokens:ke,text:de}}}list(Ie){let re=this.rules.block.list.exec(Ie);if(re){let le=re[1].trim();const Se=le.length>1,de={type:"list",raw:"",ordered:Se,start:Se?+le.slice(0,-1):"",loose:!1,items:[]};le=Se?`\\d{1,9}\\${le.slice(-1)}`:`\\${le}`,this.options.pedantic&&(le=Se?le:"[*+-]");const ke=new RegExp(`^( {0,3}${le})((?:[	 ][^\\n]*)?(?:\\n|$))`);let ne=!1;for(;Ie;){let X=!1,Pe="",Ke="";if(!(re=ke.exec(Ie))||this.rules.block.hr.test(Ie))break;Pe=re[0],Ie=Ie.substring(Pe.length);let Xe=re[2].split(`
`,1)[0].replace(/^\t+/,Kt=>" ".repeat(3*Kt.length)),st=Ie.split(`
`,1)[0],dt=!Xe.trim(),gt=0;if(this.options.pedantic?(gt=2,Ke=Xe.trimStart()):dt?gt=re[1].length+1:(gt=re[2].search(/[^ ]/),gt=gt>4?1:gt,Ke=Xe.slice(gt),gt+=re[1].length),dt&&/^ *$/.test(st)&&(Pe+=st+`
`,Ie=Ie.substring(st.length+1),X=!0),!X){const Kt=new RegExp(`^ {0,${Math.min(3,gt-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),ei=new RegExp(`^ {0,${Math.min(3,gt-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),tt=new RegExp(`^ {0,${Math.min(3,gt-1)}}(?:\`\`\`|~~~)`),Tt=new RegExp(`^ {0,${Math.min(3,gt-1)}}#`);for(;Ie;){const zt=Ie.split(`
`,1)[0];if(st=zt,this.options.pedantic&&(st=st.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),tt.test(st)||Tt.test(st)||Kt.test(st)||ei.test(Ie))break;if(st.search(/[^ ]/)>=gt||!st.trim())Ke+=`
`+st.slice(gt);else{if(dt||Xe.search(/[^ ]/)>=4||tt.test(Xe)||Tt.test(Xe)||ei.test(Xe))break;Ke+=`
`+st}!dt&&!st.trim()&&(dt=!0),Pe+=zt+`
`,Ie=Ie.substring(zt.length+1),Xe=st.slice(gt)}}de.loose||(ne?de.loose=!0:/\n *\n *$/.test(Pe)&&(ne=!0));let kt=null,At;this.options.gfm&&(kt=/^\[[ xX]\] /.exec(Ke),kt&&(At=kt[0]!=="[ ] ",Ke=Ke.replace(/^\[[ xX]\] +/,""))),de.items.push({type:"list_item",raw:Pe,task:!!kt,checked:At,loose:!1,text:Ke,tokens:[]}),de.raw+=Pe}de.items[de.items.length-1].raw=de.items[de.items.length-1].raw.trimEnd(),de.items[de.items.length-1].text=de.items[de.items.length-1].text.trimEnd(),de.raw=de.raw.trimEnd();for(let X=0;X<de.items.length;X++)if(this.lexer.state.top=!1,de.items[X].tokens=this.lexer.blockTokens(de.items[X].text,[]),!de.loose){const Pe=de.items[X].tokens.filter(Xe=>Xe.type==="space"),Ke=Pe.length>0&&Pe.some(Xe=>/\n.*\n/.test(Xe.raw));de.loose=Ke}if(de.loose)for(let X=0;X<de.items.length;X++)de.items[X].loose=!0;return de}}html(Ie){const re=this.rules.block.html.exec(Ie);if(re)return{type:"html",block:!0,raw:re[0],pre:re[1]==="pre"||re[1]==="script"||re[1]==="style",text:re[0]}}def(Ie){const re=this.rules.block.def.exec(Ie);if(re){const le=re[1].toLowerCase().replace(/\s+/g," "),Se=re[2]?re[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",de=re[3]?re[3].substring(1,re[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):re[3];return{type:"def",tag:le,raw:re[0],href:Se,title:de}}}table(Ie){const re=this.rules.block.table.exec(Ie);if(!re||!/[:|]/.test(re[2]))return;const le=v(re[1]),Se=re[2].replace(/^\||\| *$/g,"").split("|"),de=re[3]&&re[3].trim()?re[3].replace(/\n[ \t]*$/,"").split(`
`):[],ke={type:"table",raw:re[0],header:[],align:[],rows:[]};if(le.length===Se.length){for(const ne of Se)/^ *-+: *$/.test(ne)?ke.align.push("right"):/^ *:-+: *$/.test(ne)?ke.align.push("center"):/^ *:-+ *$/.test(ne)?ke.align.push("left"):ke.align.push(null);for(let ne=0;ne<le.length;ne++)ke.header.push({text:le[ne],tokens:this.lexer.inline(le[ne]),header:!0,align:ke.align[ne]});for(const ne of de)ke.rows.push(v(ne,ke.header.length).map((X,Pe)=>({text:X,tokens:this.lexer.inline(X),header:!1,align:ke.align[Pe]})));return ke}}lheading(Ie){const re=this.rules.block.lheading.exec(Ie);if(re)return{type:"heading",raw:re[0],depth:re[2].charAt(0)==="="?1:2,text:re[1],tokens:this.lexer.inline(re[1])}}paragraph(Ie){const re=this.rules.block.paragraph.exec(Ie);if(re){const le=re[1].charAt(re[1].length-1)===`
`?re[1].slice(0,-1):re[1];return{type:"paragraph",raw:re[0],text:le,tokens:this.lexer.inline(le)}}}text(Ie){const re=this.rules.block.text.exec(Ie);if(re)return{type:"text",raw:re[0],text:re[0],tokens:this.lexer.inline(re[0])}}escape(Ie){const re=this.rules.inline.escape.exec(Ie);if(re)return{type:"escape",raw:re[0],text:c(re[1])}}tag(Ie){const re=this.rules.inline.tag.exec(Ie);if(re)return!this.lexer.state.inLink&&/^<a /i.test(re[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(re[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(re[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(re[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:re[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:re[0]}}link(Ie){const re=this.rules.inline.link.exec(Ie);if(re){const le=re[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;const ke=o(le.slice(0,-1),"\\");if((le.length-ke.length)%2===0)return}else{const ke=m(re[2],"()");if(ke>-1){const X=(re[0].indexOf("!")===0?5:4)+re[1].length+ke;re[2]=re[2].substring(0,ke),re[0]=re[0].substring(0,X).trim(),re[3]=""}}let Se=re[2],de="";if(this.options.pedantic){const ke=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Se);ke&&(Se=ke[1],de=ke[3])}else de=re[3]?re[3].slice(1,-1):"";return Se=Se.trim(),/^</.test(Se)&&(this.options.pedantic&&!/>$/.test(le)?Se=Se.slice(1):Se=Se.slice(1,-1)),$(re,{href:Se&&Se.replace(this.rules.inline.anyPunctuation,"$1"),title:de&&de.replace(this.rules.inline.anyPunctuation,"$1")},re[0],this.lexer)}}reflink(Ie,re){let le;if((le=this.rules.inline.reflink.exec(Ie))||(le=this.rules.inline.nolink.exec(Ie))){const Se=(le[2]||le[1]).replace(/\s+/g," "),de=re[Se.toLowerCase()];if(!de){const ke=le[0].charAt(0);return{type:"text",raw:ke,text:ke}}return $(le,de,le[0],this.lexer)}}emStrong(Ie,re,le=""){let Se=this.rules.inline.emStrongLDelim.exec(Ie);if(!Se||Se[3]&&le.match(/[\p{L}\p{N}]/u))return;if(!(Se[1]||Se[2]||"")||!le||this.rules.inline.punctuation.exec(le)){const ke=[...Se[0]].length-1;let ne,X,Pe=ke,Ke=0;const Xe=Se[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(Xe.lastIndex=0,re=re.slice(-1*Ie.length+ke);(Se=Xe.exec(re))!=null;){if(ne=Se[1]||Se[2]||Se[3]||Se[4]||Se[5]||Se[6],!ne)continue;if(X=[...ne].length,Se[3]||Se[4]){Pe+=X;continue}else if((Se[5]||Se[6])&&ke%3&&!((ke+X)%3)){Ke+=X;continue}if(Pe-=X,Pe>0)continue;X=Math.min(X,X+Pe+Ke);const st=[...Se[0]][0].length,dt=Ie.slice(0,ke+Se.index+st+X);if(Math.min(ke,X)%2){const kt=dt.slice(1,-1);return{type:"em",raw:dt,text:kt,tokens:this.lexer.inlineTokens(kt)}}const gt=dt.slice(2,-2);return{type:"strong",raw:dt,text:gt,tokens:this.lexer.inlineTokens(gt)}}}}codespan(Ie){const re=this.rules.inline.code.exec(Ie);if(re){let le=re[2].replace(/\n/g," ");const Se=/[^ ]/.test(le),de=/^ /.test(le)&&/ $/.test(le);return Se&&de&&(le=le.substring(1,le.length-1)),le=c(le,!0),{type:"codespan",raw:re[0],text:le}}}br(Ie){const re=this.rules.inline.br.exec(Ie);if(re)return{type:"br",raw:re[0]}}del(Ie){const re=this.rules.inline.del.exec(Ie);if(re)return{type:"del",raw:re[0],text:re[2],tokens:this.lexer.inlineTokens(re[2])}}autolink(Ie){const re=this.rules.inline.autolink.exec(Ie);if(re){let le,Se;return re[2]==="@"?(le=c(re[1]),Se="mailto:"+le):(le=c(re[1]),Se=le),{type:"link",raw:re[0],text:le,href:Se,tokens:[{type:"text",raw:le,text:le}]}}}url(Ie){let re;if(re=this.rules.inline.url.exec(Ie)){let le,Se;if(re[2]==="@")le=c(re[0]),Se="mailto:"+le;else{let de;do de=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])?.[0]??"";while(de!==re[0]);le=c(re[0]),re[1]==="www."?Se="http://"+re[0]:Se=re[0]}return{type:"link",raw:re[0],text:le,href:Se,tokens:[{type:"text",raw:le,text:le}]}}}inlineText(Ie){const re=this.rules.inline.text.exec(Ie);if(re){let le;return this.lexer.state.inRawBlock?le=re[0]:le=c(re[0]),{type:"text",raw:re[0],text:le}}}}const a=/^(?: *(?:\n|$))+/,t=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,r=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,n=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,u=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,l=/(?:[*+-]|\d{1,9}[.)])/,g=E(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,l).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),y=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,k=/^[^\n]+/,S=/(?!\s*\])(?:\\.|[^\[\]\\])+/,R=E(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",S).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),C=E(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,l).getRegex(),w="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",b=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,N=E("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",b).replace("tag",w).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),L=E(y).replace("hr",n).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",w).getRegex(),z={blockquote:E(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",L).getRegex(),code:t,def:R,fences:r,heading:u,hr:n,html:N,lheading:g,list:C,newline:a,paragraph:L,table:P,text:k},V=E("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",n).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",w).getRegex(),F={...z,table:V,paragraph:E(y).replace("hr",n).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",V).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",w).getRegex()},j={...z,html:E(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",b).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:P,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:E(y).replace("hr",n).replace("heading",` *#{1,6} *[^
]`).replace("lheading",g).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},W=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,J=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,B=/^( {2,}|\\)\n(?!\s*$)/,U=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,_="\\p{P}\\p{S}",x=E(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,_).getRegex(),oe=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,te=E(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,_).getRegex(),me=E("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,_).getRegex(),ce=E("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,_).getRegex(),Y=E(/\\([punct])/,"gu").replace(/punct/g,_).getRegex(),q=E(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),se=E(b).replace("(?:-->|$)","-->").getRegex(),be=E("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",se).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),ae=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,we=E(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",ae).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),$e=E(/^!?\[(label)\]\[(ref)\]/).replace("label",ae).replace("ref",S).getRegex(),pe=E(/^!?\[(ref)\](?:\[\])?/).replace("ref",S).getRegex(),Oe=E("reflink|nolink(?!\\()","g").replace("reflink",$e).replace("nolink",pe).getRegex(),Fe={_backpedal:P,anyPunctuation:Y,autolink:q,blockSkip:oe,br:B,code:J,del:P,emStrongLDelim:te,emStrongRDelimAst:me,emStrongRDelimUnd:ce,escape:W,link:we,nolink:pe,punctuation:x,reflink:$e,reflinkSearch:Oe,tag:be,text:U,url:P},He={...Fe,link:E(/^!?\[(label)\]\((.*?)\)/).replace("label",ae).getRegex(),reflink:E(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae).getRegex()},Ze={...Fe,escape:E(W).replace("])","~|])").getRegex(),url:E(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},xe={...Ze,br:E(B).replace("{2,}","*").getRegex(),text:E(Ze.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},je={normal:z,gfm:F,pedantic:j},qe={normal:Fe,gfm:Ze,breaks:xe,pedantic:He};class Ne{tokens;options;state;tokenizer;inlineQueue;constructor(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||ge.defaults,this.options.tokenizer=this.options.tokenizer||new i,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const re={block:je.normal,inline:qe.normal};this.options.pedantic?(re.block=je.pedantic,re.inline=qe.pedantic):this.options.gfm&&(re.block=je.gfm,this.options.breaks?re.inline=qe.breaks:re.inline=qe.gfm),this.tokenizer.rules=re}static get rules(){return{block:je,inline:qe}}static lex(Ie,re){return new Ne(re).lex(Ie)}static lexInline(Ie,re){return new Ne(re).inlineTokens(Ie)}lex(Ie){Ie=Ie.replace(/\r\n|\r/g,`
`),this.blockTokens(Ie,this.tokens);for(let re=0;re<this.inlineQueue.length;re++){const le=this.inlineQueue[re];this.inlineTokens(le.src,le.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(Ie,re=[],le=!1){this.options.pedantic?Ie=Ie.replace(/\t/g,"    ").replace(/^ +$/gm,""):Ie=Ie.replace(/^( *)(\t+)/gm,(ne,X,Pe)=>X+"    ".repeat(Pe.length));let Se,de,ke;for(;Ie;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(ne=>(Se=ne.call({lexer:this},Ie,re))?(Ie=Ie.substring(Se.raw.length),re.push(Se),!0):!1))){if(Se=this.tokenizer.space(Ie)){Ie=Ie.substring(Se.raw.length),Se.raw.length===1&&re.length>0?re[re.length-1].raw+=`
`:re.push(Se);continue}if(Se=this.tokenizer.code(Ie)){Ie=Ie.substring(Se.raw.length),de=re[re.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+Se.raw,de.text+=`
`+Se.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):re.push(Se);continue}if(Se=this.tokenizer.fences(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.heading(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.hr(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.blockquote(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.list(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.html(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.def(Ie)){Ie=Ie.substring(Se.raw.length),de=re[re.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+Se.raw,de.text+=`
`+Se.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[Se.tag]||(this.tokens.links[Se.tag]={href:Se.href,title:Se.title});continue}if(Se=this.tokenizer.table(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(Se=this.tokenizer.lheading(Ie)){Ie=Ie.substring(Se.raw.length),re.push(Se);continue}if(ke=Ie,this.options.extensions&&this.options.extensions.startBlock){let ne=1/0;const X=Ie.slice(1);let Pe;this.options.extensions.startBlock.forEach(Ke=>{Pe=Ke.call({lexer:this},X),typeof Pe=="number"&&Pe>=0&&(ne=Math.min(ne,Pe))}),ne<1/0&&ne>=0&&(ke=Ie.substring(0,ne+1))}if(this.state.top&&(Se=this.tokenizer.paragraph(ke))){de=re[re.length-1],le&&de?.type==="paragraph"?(de.raw+=`
`+Se.raw,de.text+=`
`+Se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):re.push(Se),le=ke.length!==Ie.length,Ie=Ie.substring(Se.raw.length);continue}if(Se=this.tokenizer.text(Ie)){Ie=Ie.substring(Se.raw.length),de=re[re.length-1],de&&de.type==="text"?(de.raw+=`
`+Se.raw,de.text+=`
`+Se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):re.push(Se);continue}if(Ie){const ne="Infinite loop on byte: "+Ie.charCodeAt(0);if(this.options.silent){console.error(ne);break}else throw new Error(ne)}}return this.state.top=!0,re}inline(Ie,re=[]){return this.inlineQueue.push({src:Ie,tokens:re}),re}inlineTokens(Ie,re=[]){let le,Se,de,ke=Ie,ne,X,Pe;if(this.tokens.links){const Ke=Object.keys(this.tokens.links);if(Ke.length>0)for(;(ne=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)Ke.includes(ne[0].slice(ne[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,ne.index)+"["+"a".repeat(ne[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ne=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,ne.index)+"["+"a".repeat(ne[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ne=this.tokenizer.rules.inline.anyPunctuation.exec(ke))!=null;)ke=ke.slice(0,ne.index)+"++"+ke.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;Ie;)if(X||(Pe=""),X=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(Ke=>(le=Ke.call({lexer:this},Ie,re))?(Ie=Ie.substring(le.raw.length),re.push(le),!0):!1))){if(le=this.tokenizer.escape(Ie)){Ie=Ie.substring(le.raw.length),re.push(le);continue}if(le=this.tokenizer.tag(Ie)){Ie=Ie.substring(le.raw.length),Se=re[re.length-1],Se&&le.type==="text"&&Se.type==="text"?(Se.raw+=le.raw,Se.text+=le.text):re.push(le);continue}if(le=this.tokenizer.link(Ie)){Ie=Ie.substring(le.raw.length),re.push(le);continue}if(le=this.tokenizer.reflink(Ie,this.tokens.links)){Ie=Ie.substring(le.raw.length),Se=re[re.length-1],Se&&le.type==="text"&&Se.type==="text"?(Se.raw+=le.raw,Se.text+=le.text):re.push(le);continue}if(le=this.tokenizer.emStrong(Ie,ke,Pe)){Ie=Ie.substring(le.raw.length),re.push(le);continue}if(le=this.tokenizer.codespan(Ie)){Ie=Ie.substring(le.raw.length),re.push(le);continue}if(le=this.tokenizer.br(Ie)){Ie=Ie.substring(le.raw.length),re.push(le);continue}if(le=this.tokenizer.del(Ie)){Ie=Ie.substring(le.raw.length),re.push(le);continue}if(le=this.tokenizer.autolink(Ie)){Ie=Ie.substring(le.raw.length),re.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(Ie))){Ie=Ie.substring(le.raw.length),re.push(le);continue}if(de=Ie,this.options.extensions&&this.options.extensions.startInline){let Ke=1/0;const Xe=Ie.slice(1);let st;this.options.extensions.startInline.forEach(dt=>{st=dt.call({lexer:this},Xe),typeof st=="number"&&st>=0&&(Ke=Math.min(Ke,st))}),Ke<1/0&&Ke>=0&&(de=Ie.substring(0,Ke+1))}if(le=this.tokenizer.inlineText(de)){Ie=Ie.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(Pe=le.raw.slice(-1)),X=!0,Se=re[re.length-1],Se&&Se.type==="text"?(Se.raw+=le.raw,Se.text+=le.text):re.push(le);continue}if(Ie){const Ke="Infinite loop on byte: "+Ie.charCodeAt(0);if(this.options.silent){console.error(Ke);break}else throw new Error(Ke)}}return re}}class H{options;parser;constructor(Ie){this.options=Ie||ge.defaults}space(Ie){return""}code({text:Ie,lang:re,escaped:le}){const Se=(re||"").match(/^\S*/)?.[0],de=Ie.replace(/\n$/,"")+`
`;return Se?'<pre><code class="language-'+c(Se)+'">'+(le?de:c(de,!0))+`</code></pre>
`:"<pre><code>"+(le?de:c(de,!0))+`</code></pre>
`}blockquote({tokens:Ie}){return`<blockquote>
${this.parser.parse(Ie)}</blockquote>
`}html({text:Ie}){return Ie}heading({tokens:Ie,depth:re}){return`<h${re}>${this.parser.parseInline(Ie)}</h${re}>
`}hr(Ie){return`<hr>
`}list(Ie){const re=Ie.ordered,le=Ie.start;let Se="";for(let ne=0;ne<Ie.items.length;ne++){const X=Ie.items[ne];Se+=this.listitem(X)}const de=re?"ol":"ul",ke=re&&le!==1?' start="'+le+'"':"";return"<"+de+ke+`>
`+Se+"</"+de+`>
`}listitem(Ie){let re="";if(Ie.task){const le=this.checkbox({checked:!!Ie.checked});Ie.loose?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=le+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=le+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",raw:le+" ",text:le+" "}):re+=le+" "}return re+=this.parser.parse(Ie.tokens,!!Ie.loose),`<li>${re}</li>
`}checkbox({checked:Ie}){return"<input "+(Ie?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:Ie}){return`<p>${this.parser.parseInline(Ie)}</p>
`}table(Ie){let re="",le="";for(let de=0;de<Ie.header.length;de++)le+=this.tablecell(Ie.header[de]);re+=this.tablerow({text:le});let Se="";for(let de=0;de<Ie.rows.length;de++){const ke=Ie.rows[de];le="";for(let ne=0;ne<ke.length;ne++)le+=this.tablecell(ke[ne]);Se+=this.tablerow({text:le})}return Se&&(Se=`<tbody>${Se}</tbody>`),`<table>
<thead>
`+re+`</thead>
`+Se+`</table>
`}tablerow({text:Ie}){return`<tr>
${Ie}</tr>
`}tablecell(Ie){const re=this.parser.parseInline(Ie.tokens),le=Ie.header?"th":"td";return(Ie.align?`<${le} align="${Ie.align}">`:`<${le}>`)+re+`</${le}>
`}strong({tokens:Ie}){return`<strong>${this.parser.parseInline(Ie)}</strong>`}em({tokens:Ie}){return`<em>${this.parser.parseInline(Ie)}</em>`}codespan({text:Ie}){return`<code>${Ie}</code>`}br(Ie){return"<br>"}del({tokens:Ie}){return`<del>${this.parser.parseInline(Ie)}</del>`}link({href:Ie,title:re,tokens:le}){const Se=this.parser.parseInline(le),de=f(Ie);if(de===null)return Se;Ie=de;let ke='<a href="'+Ie+'"';return re&&(ke+=' title="'+re+'"'),ke+=">"+Se+"</a>",ke}image({href:Ie,title:re,text:le}){const Se=f(Ie);if(Se===null)return le;Ie=Se;let de=`<img src="${Ie}" alt="${le}"`;return re&&(de+=` title="${re}"`),de+=">",de}text(Ie){return"tokens"in Ie&&Ie.tokens?this.parser.parseInline(Ie.tokens):Ie.text}}class G{strong({text:Ie}){return Ie}em({text:Ie}){return Ie}codespan({text:Ie}){return Ie}del({text:Ie}){return Ie}html({text:Ie}){return Ie}text({text:Ie}){return Ie}link({text:Ie}){return""+Ie}image({text:Ie}){return""+Ie}br(){return""}}class Z{options;renderer;textRenderer;constructor(Ie){this.options=Ie||ge.defaults,this.options.renderer=this.options.renderer||new H,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new G}static parse(Ie,re){return new Z(re).parse(Ie)}static parseInline(Ie,re){return new Z(re).parseInline(Ie)}parse(Ie,re=!0){let le="";for(let Se=0;Se<Ie.length;Se++){const de=Ie[Se];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]){const ne=de,X=this.options.extensions.renderers[ne.type].call({parser:this},ne);if(X!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ne.type)){le+=X||"";continue}}const ke=de;switch(ke.type){case"space":{le+=this.renderer.space(ke);continue}case"hr":{le+=this.renderer.hr(ke);continue}case"heading":{le+=this.renderer.heading(ke);continue}case"code":{le+=this.renderer.code(ke);continue}case"table":{le+=this.renderer.table(ke);continue}case"blockquote":{le+=this.renderer.blockquote(ke);continue}case"list":{le+=this.renderer.list(ke);continue}case"html":{le+=this.renderer.html(ke);continue}case"paragraph":{le+=this.renderer.paragraph(ke);continue}case"text":{let ne=ke,X=this.renderer.text(ne);for(;Se+1<Ie.length&&Ie[Se+1].type==="text";)ne=Ie[++Se],X+=`
`+this.renderer.text(ne);re?le+=this.renderer.paragraph({type:"paragraph",raw:X,text:X,tokens:[{type:"text",raw:X,text:X}]}):le+=X;continue}default:{const ne='Token with "'+ke.type+'" type was not found.';if(this.options.silent)return console.error(ne),"";throw new Error(ne)}}}return le}parseInline(Ie,re){re=re||this.renderer;let le="";for(let Se=0;Se<Ie.length;Se++){const de=Ie[Se];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]){const ne=this.options.extensions.renderers[de.type].call({parser:this},de);if(ne!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type)){le+=ne||"";continue}}const ke=de;switch(ke.type){case"escape":{le+=re.text(ke);break}case"html":{le+=re.html(ke);break}case"link":{le+=re.link(ke);break}case"image":{le+=re.image(ke);break}case"strong":{le+=re.strong(ke);break}case"em":{le+=re.em(ke);break}case"codespan":{le+=re.codespan(ke);break}case"br":{le+=re.br(ke);break}case"del":{le+=re.del(ke);break}case"text":{le+=re.text(ke);break}default:{const ne='Token with "'+ke.type+'" type was not found.';if(this.options.silent)return console.error(ne),"";throw new Error(ne)}}}return le}}class ee{options;constructor(Ie){this.options=Ie||ge.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(Ie){return Ie}postprocess(Ie){return Ie}processAllTokens(Ie){return Ie}}class ue{defaults=e();options=this.setOptions;parse=this.parseMarkdown(Ne.lex,Z.parse);parseInline=this.parseMarkdown(Ne.lexInline,Z.parseInline);Parser=Z;Renderer=H;TextRenderer=G;Lexer=Ne;Tokenizer=i;Hooks=ee;constructor(...Ie){this.use(...Ie)}walkTokens(Ie,re){let le=[];for(const Se of Ie)switch(le=le.concat(re.call(this,Se)),Se.type){case"table":{const de=Se;for(const ke of de.header)le=le.concat(this.walkTokens(ke.tokens,re));for(const ke of de.rows)for(const ne of ke)le=le.concat(this.walkTokens(ne.tokens,re));break}case"list":{const de=Se;le=le.concat(this.walkTokens(de.items,re));break}default:{const de=Se;this.defaults.extensions?.childTokens?.[de.type]?this.defaults.extensions.childTokens[de.type].forEach(ke=>{const ne=de[ke].flat(1/0);le=le.concat(this.walkTokens(ne,re))}):de.tokens&&(le=le.concat(this.walkTokens(de.tokens,re)))}}return le}use(...Ie){const re=this.defaults.extensions||{renderers:{},childTokens:{}};return Ie.forEach(le=>{const Se={...le};if(Se.async=this.defaults.async||Se.async||!1,le.extensions&&(le.extensions.forEach(de=>{if(!de.name)throw new Error("extension name required");if("renderer"in de){const ke=re.renderers[de.name];ke?re.renderers[de.name]=function(...ne){let X=de.renderer.apply(this,ne);return X===!1&&(X=ke.apply(this,ne)),X}:re.renderers[de.name]=de.renderer}if("tokenizer"in de){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const ke=re[de.level];ke?ke.unshift(de.tokenizer):re[de.level]=[de.tokenizer],de.start&&(de.level==="block"?re.startBlock?re.startBlock.push(de.start):re.startBlock=[de.start]:de.level==="inline"&&(re.startInline?re.startInline.push(de.start):re.startInline=[de.start]))}"childTokens"in de&&de.childTokens&&(re.childTokens[de.name]=de.childTokens)}),Se.extensions=re),le.renderer){const de=this.defaults.renderer||new H(this.defaults);for(const ke in le.renderer){if(!(ke in de))throw new Error(`renderer '${ke}' does not exist`);if(["options","parser"].includes(ke))continue;const ne=ke,X=le.renderer[ne],Pe=de[ne];de[ne]=(...Ke)=>{let Xe=X.apply(de,Ke);return Xe===!1&&(Xe=Pe.apply(de,Ke)),Xe||""}}Se.renderer=de}if(le.tokenizer){const de=this.defaults.tokenizer||new i(this.defaults);for(const ke in le.tokenizer){if(!(ke in de))throw new Error(`tokenizer '${ke}' does not exist`);if(["options","rules","lexer"].includes(ke))continue;const ne=ke,X=le.tokenizer[ne],Pe=de[ne];de[ne]=(...Ke)=>{let Xe=X.apply(de,Ke);return Xe===!1&&(Xe=Pe.apply(de,Ke)),Xe}}Se.tokenizer=de}if(le.hooks){const de=this.defaults.hooks||new ee;for(const ke in le.hooks){if(!(ke in de))throw new Error(`hook '${ke}' does not exist`);if(ke==="options")continue;const ne=ke,X=le.hooks[ne],Pe=de[ne];ee.passThroughHooks.has(ke)?de[ne]=Ke=>{if(this.defaults.async)return Promise.resolve(X.call(de,Ke)).then(st=>Pe.call(de,st));const Xe=X.call(de,Ke);return Pe.call(de,Xe)}:de[ne]=(...Ke)=>{let Xe=X.apply(de,Ke);return Xe===!1&&(Xe=Pe.apply(de,Ke)),Xe}}Se.hooks=de}if(le.walkTokens){const de=this.defaults.walkTokens,ke=le.walkTokens;Se.walkTokens=function(ne){let X=[];return X.push(ke.call(this,ne)),de&&(X=X.concat(de.call(this,ne))),X}}this.defaults={...this.defaults,...Se}}),this}setOptions(Ie){return this.defaults={...this.defaults,...Ie},this}lexer(Ie,re){return Ne.lex(Ie,re??this.defaults)}parser(Ie,re){return Z.parse(Ie,re??this.defaults)}parseMarkdown(Ie,re){return(Se,de)=>{const ke={...de},ne={...this.defaults,...ke},X=this.onError(!!ne.silent,!!ne.async);if(this.defaults.async===!0&&ke.async===!1)return X(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof Se>"u"||Se===null)return X(new Error("marked(): input parameter is undefined or null"));if(typeof Se!="string")return X(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected"));if(ne.hooks&&(ne.hooks.options=ne),ne.async)return Promise.resolve(ne.hooks?ne.hooks.preprocess(Se):Se).then(Pe=>Ie(Pe,ne)).then(Pe=>ne.hooks?ne.hooks.processAllTokens(Pe):Pe).then(Pe=>ne.walkTokens?Promise.all(this.walkTokens(Pe,ne.walkTokens)).then(()=>Pe):Pe).then(Pe=>re(Pe,ne)).then(Pe=>ne.hooks?ne.hooks.postprocess(Pe):Pe).catch(X);try{ne.hooks&&(Se=ne.hooks.preprocess(Se));let Pe=Ie(Se,ne);ne.hooks&&(Pe=ne.hooks.processAllTokens(Pe)),ne.walkTokens&&this.walkTokens(Pe,ne.walkTokens);let Ke=re(Pe,ne);return ne.hooks&&(Ke=ne.hooks.postprocess(Ke)),Ke}catch(Pe){return X(Pe)}}}onError(Ie,re){return le=>{if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie){const Se="<p>An error occurred:</p><pre>"+c(le.message+"",!0)+"</pre>";return re?Promise.resolve(Se):Se}if(re)return Promise.reject(le);throw le}}}const ye=new ue;function Ae(it,Ie){return ye.parse(it,Ie)}Ae.options=Ae.setOptions=function(it){return ye.setOptions(it),Ae.defaults=ye.defaults,s(Ae.defaults),Ae},Ae.getDefaults=e,Ae.defaults=ge.defaults,Ae.use=function(...it){return ye.use(...it),Ae.defaults=ye.defaults,s(Ae.defaults),Ae},Ae.walkTokens=function(it,Ie){return ye.walkTokens(it,Ie)},Ae.parseInline=ye.parseInline,Ae.Parser=Z,Ae.parser=Z.parse,Ae.Renderer=H,Ae.TextRenderer=G,Ae.Lexer=Ne,Ae.lexer=Ne.lex,Ae.Tokenizer=i,Ae.Hooks=ee,Ae.parse=Ae;const Ve=Ae.options,Je=Ae.setOptions,nt=Ae.use,ot=Ae.walkTokens,ht=Ae.parseInline,at=Ae,lt=Z.parse,pt=Ne.lex;ge.Hooks=ee,ge.Lexer=Ne,ge.Marked=ue,ge.Parser=Z,ge.Renderer=H,ge.TextRenderer=G,ge.Tokenizer=i,ge.getDefaults=e,ge.lexer=pt,ge.marked=Ae,ge.options=Ve,ge.parse=at,ge.parseInline=ht,ge.parser=lt,ge.setOptions=Je,ge.use=nt,ge.walkTokens=ot}),define(Re[41],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var s;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(s||(e.MarshalledId=s={}))}),define(Re[184],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=s;function s(o){const m=O(o);if(m&&m.length>0)return new Uint32Array(m)}let h=0;const D=new Uint32Array(10);function O(o){if(h=0,T(o,E,p.InitialConsonant),h>0||(T(o,f,p.Vowel),h>0)||(T(o,P,p.FinalConsonant),h>0)||(T(o,v,p.CompatibilityJamo),h))return D.subarray(0,h);if(o>=44032&&o<=55203){const m=o-44032,$=m%588,d=Math.floor(m/588),i=Math.floor($/28),a=$%28-1;if(d<E.length?T(d,E,0):p.InitialConsonant+d-p.CompatibilityJamo<v.length&&T(p.InitialConsonant+d,v,p.CompatibilityJamo),i<f.length?T(i,f,0):p.Vowel+i-p.CompatibilityJamo<v.length&&T(p.Vowel+i-p.CompatibilityJamo,v,p.CompatibilityJamo),a>=0&&(a<P.length?T(a,P,0):p.FinalConsonant+a-p.CompatibilityJamo<v.length&&T(p.FinalConsonant+a-p.CompatibilityJamo,v,p.CompatibilityJamo)),h>0)return D.subarray(0,h)}}function T(o,m,$){o>=$&&o<$+m.length&&A(m[o-$])}function A(o){o!==c.NUL&&(D[h++]=o&255,o>>8&&(D[h++]=o>>8&255),o>>16&&(D[h++]=o>>16&255))}var p;(function(o){o[o.InitialConsonant=4352]="InitialConsonant",o[o.Vowel=4449]="Vowel",o[o.FinalConsonant=4520]="FinalConsonant",o[o.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var c;(function(o){o[o.NUL=0]="NUL",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z"})(c||(c={}));var I;(function(o){o[o.fa=24934]="fa",o[o.fg=26470]="fg",o[o.fq=29030]="fq",o[o.fr=29286]="fr",o[o.ft=29798]="ft",o[o.fv=30310]="fv",o[o.fx=30822]="fx",o[o.hk=27496]="hk",o[o.hl=27752]="hl",o[o.ho=28520]="ho",o[o.ml=27757]="ml",o[o.nj=27246]="nj",o[o.nl=27758]="nl",o[o.np=28782]="np",o[o.qt=29809]="qt",o[o.rt=29810]="rt",o[o.sg=26483]="sg",o[o.sw=30579]="sw"})(I||(I={}));const E=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),f=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l]),P=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,I.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),v=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.E,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,c.Q,I.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l])}),define(Re[83],Ce([1,0,28]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=void 0,e.$sm=D,e.$tm=T;const h=new s.$Ic(1e4);function D(c){return p(c,"NFC",h)}const O=new s.$Ic(1e4);function T(c){return p(c,"NFD",O)}const A=/[^\u0000-\u0080]/;function p(c,I,E){if(!c)return c;const f=E.get(c);if(f)return f;let P;return A.test(c)?P=c.normalize(I):P=c,E.set(c,P),P}e.$um=function(){const c=/[\u0300-\u036f]/g;return function(I){return T(I).replace(c,"")}}()}),define(Re[136],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Qm=s,e.rot=h,e.$Vm=A;function s(p,c,I){return Math.min(Math.max(p,c),I)}function h(p,c){return(c+p%c)%c}class D{constructor(){this.a=0}getNext(){return this.a++}}e.$Sm=D;class O{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Tm=O;class T{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const I=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Um=T;function A(p,c,I,E,f,P,v,o){const m=v-I,$=o-E,d=f-I,i=P-E,a=p-I,t=c-E,r=m*m+$*$,n=m*d+$*i,u=m*a+$*t,l=d*d+i*i,g=d*a+i*t,y=1/(r*l-n*n),k=(l*u-n*g)*y,S=(r*g-n*u)*y;return k>=0&&S>=0&&k+S<1}}),define(Re[185],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fd=void 0,e.$gd=O,e.$hd=f;class s{constructor(v,o,m){this.owner=v,this.debugNameSource=o,this.referenceFn=m}getDebugName(v){return O(v,this)}}e.$fd=s;const h=new Map,D=new WeakMap;function O(P,v){const o=D.get(P);if(o)return o;const m=T(P,v);if(m){let $=h.get(m)??0;$++,h.set(m,$);const d=$===1?m:`${m}#${$}`;return D.set(P,d),d}}function T(P,v){const o=D.get(P);if(o)return o;const m=v.owner?I(v.owner)+".":"";let $;const d=v.debugNameSource;if(d!==void 0)if(typeof d=="function"){if($=d(),$!==void 0)return m+$}else return m+d;const i=v.referenceFn;if(i!==void 0&&($=f(i),$!==void 0))return m+$;if(v.owner!==void 0){const a=A(v.owner,P);if(a!==void 0)return m+a}}function A(P,v){for(const o in P)if(P[o]===v)return o}const p=new Map,c=new WeakMap;function I(P){const v=c.get(P);if(v)return v;const o=E(P);let m=p.get(o)??0;m++,p.set(o,m);const $=m===1?o:`${o}#${m}`;return c.set(P,$),$}function E(P){const v=P.constructor;return v?v.name:"Object"}function f(P){const v=P.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(v);return(m?m[1]:void 0)?.trim()}}),define(Re[186],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0,e.$Pd=h,e.$Qd=D;let s;function h(o){s=o}function D(){return s}class O{constructor(){this.a=0,this.d=new WeakMap}b(m){return T([A(P("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[A(" "),c(I(m.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),c(I(m.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),c(I(m.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(m,$){console.log(...this.b([p("observable value changed"),c(m.debugName,{color:"BlueViolet"}),...this.c($)]))}formatChanges(m){if(m.size!==0)return c(" (changed deps: "+[...m].map($=>$.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(d,i)=>(this.d.get(m).add(d),$.apply(m,[d,i]))}handleDerivedRecomputed(m,$){const d=this.d.get(m);console.log(...this.b([p("derived recomputed"),c(m.debugName,{color:"BlueViolet"}),...this.c($),this.formatChanges(d),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),d.clear()}handleFromEventObservableTriggered(m,$){console.log(...this.b([p("observable from event triggered"),c(m.debugName,{color:"BlueViolet"}),...this.c($),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(d,i)=>(this.d.get(m).add(d),$.apply(m,[d,i]))}handleAutorunTriggered(m){const $=this.d.get(m);console.log(...this.b([p("autorun"),c(m.debugName,{color:"BlueViolet"}),this.formatChanges($),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),$.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let $=m.getDebugName();$===void 0&&($=""),console.log(...this.b([p("transaction"),c($,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Rd=O;function T(o){const m=new Array,$=[];let d="";function i(t){if("length"in t)for(const r of t)r&&i(r);else"text"in t?(d+=`%c${t.text}`,m.push(t.style),t.data&&$.push(...t.data)):"data"in t&&$.push(...t.data)}i(o);const a=[d,...m];return a.push(...$),a}function A(o){return c(o,{color:"black"})}function p(o){return c(v(`${o}: `,10),{color:"black",bold:!0})}function c(o,m={color:"black"}){function $(i){return Object.entries(i).reduce((a,[t,r])=>`${a}${t}:${r};`,"")}const d={color:m.color};return m.strikeThrough&&(d["text-decoration"]="line-through"),m.bold&&(d["font-weight"]="bold"),{text:o,style:$(d)}}function I(o,m){switch(typeof o){case"number":return""+o;case"string":return o.length+2<=m?`"${o}"`:`"${o.substr(0,m-7)}"+...`;case"boolean":return o?"true":"false";case"undefined":return"undefined";case"object":return o===null?"null":Array.isArray(o)?E(o,m):f(o,m);case"symbol":return o.toString();case"function":return`[[Function${o.name?" "+o.name:""}]]`;default:return""+o}}function E(o,m){let $="[ ",d=!0;for(const i of o){if(d||($+=", "),$.length-5>m){$+="...";break}d=!1,$+=`${I(i,m-$.length)}`}return $+=" ]",$}function f(o,m){let $="{ ",d=!0;for(const[i,a]of Object.entries(o)){if(d||($+=", "),$.length-5>m){$+="...";break}d=!1,$+=`${i}: ${I(a,m-$.length)}`}return $+=" }",$}function P(o,m){let $="";for(let d=1;d<=m;d++)$+=o;return $}function v(o,m){for(;o.length<m;)o+=" ";return o}}),define(Re[187],Ce([1,0,180,185,186]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$_d=e.$0d=e.$5d=e.$4d=void 0,e.$1d=T,e.$2d=p,e.$3d=I,e.$6d=P,e.$7d=o,e.$8d=m,e.$9d=$,e.$$d=i,e.$ae=t;let O;function T(n){O=n}let A;function p(n){A=n}let c;function I(n){c=n}class E{get TChange(){return null}reportChanges(){this.get()}read(u){return u?u.readObservable(this):this.get()}map(u,l){const g=l===void 0?void 0:u,y=l===void 0?u:l;return c({owner:g,debugName:()=>{const k=(0,h.$hd)(y);if(k!==void 0)return k;const R=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(y.toString());if(R)return`${this.debugName}.${R[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:y},k=>y(this.read(k),k))}flatten(){return c({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},u=>this.read(u).read(u))}recomputeInitiallyAndOnChange(u,l){return u.add(O(this,l)),this}keepObserved(u){return u.add(A(this)),this}get a(){return this.get()}}e.$4d=E;class f extends E{constructor(){super(...arguments),this.b=new Set}addObserver(u){const l=this.b.size;this.b.add(u),l===0&&this.c()}removeObserver(u){this.b.delete(u)&&this.b.size===0&&this.f()}c(){}f(){}}e.$5d=f;function P(n,u){const l=new d(n,u);try{n(l)}finally{l.finish()}}let v;function o(n){if(v)n(v);else{const u=new d(n,void 0);v=u;try{n(u)}finally{u.finish(),v=void 0}}}async function m(n,u){const l=new d(n,u);try{await n(l)}finally{l.finish()}}function $(n,u,l){n?u(n):P(u,l)}class d{constructor(u,l){this._fn=u,this.b=l,this.a=[],(0,D.$Qd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$hd)(this._fn)}updateObserver(u,l){this.a.push({observer:u,observable:l}),u.beginUpdate(l)}finish(){const u=this.a;for(let l=0;l<u.length;l++){const{observer:g,observable:y}=u[l];g.endUpdate(y)}this.a=null,(0,D.$Qd)()?.handleEndTransaction()}}e.$0d=d;function i(n,u){let l;return typeof n=="string"?l=new h.$fd(void 0,n,void 0):l=new h.$fd(n,void 0,void 0),new a(l,u,s.$$c)}class a extends f{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(u,l,g){super(),this.e=u,this.g=g,this.d=l}get(){return this.d}set(u,l,g){if(g===void 0&&this.g(this.d,u))return;let y;l||(l=y=new d(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(u),(0,D.$Qd)()?.handleObservableChanged(this,{oldValue:k,newValue:u,change:g,didChange:!0,hadValue:!0});for(const S of this.b)l.updateObserver(S,this),S.handleChange(this,g)}finally{y&&y.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(u){this.d=u}}e.$_d=a;function t(n,u){let l;return typeof n=="string"?l=new h.$fd(void 0,n,void 0):l=new h.$fd(n,void 0,void 0),new r(l,u,s.$$c)}class r extends a{h(u){this.d!==u&&(this.d&&this.d.dispose(),this.d=u)}dispose(){this.d?.dispose()}}e.$be=r}),function(){function ge(D){const O=[];typeof D=="number"&&O.push("code/timeOrigin",D);function T(p){O.push(p,Date.now())}function A(){const p=[];for(let c=0;c<O.length;c+=2)p.push({name:O[c],startTime:O[c+1]});return p}return{mark:T,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const T of performance.getEntriesByType("mark"))O.push({name:T.name,startTime:Math.round(D+T.startTime)});return O}};if(typeof process=="object"){const D=performance?.timeOrigin;return ge(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function s(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return s(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=s(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=s(h))}(),define(Re[188],Ce([1,0,40]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=void 0;const h=Symbol("unset");class D{constructor(){this.a=new T,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||s.Iterable.empty()}get entries(){return this.a.children?.entries()||s.Iterable.empty()}insert(p,c,I){this.d(p,E=>E._value=c,I)}mutate(p,c){this.d(p,I=>I._value=c(I._value===h?void 0:I._value))}mutatePath(p,c){this.d(p,()=>{},I=>c(I))}delete(p){const c=this.c(p);if(!c)return;let I=c.length-1;const E=c[I].node._value;if(E!==h){for(this.b--,c[I].node._value=h;I>0;I--){const{node:f,part:P}=c[I];if(f.children?.size||f._value!==h)break;c[I-1].node.children.delete(P)}return E}}*deleteRecursive(p){const c=this.c(p);if(!c)return;const I=c[c.length-1].node;for(let E=c.length-1;E>0;E--){const f=c[E-1];if(f.node.children.delete(c[E].part),f.node.children.size>0||f.node._value!==h)break}for(const E of O(I))E._value!==h&&(this.b--,yield E._value)}find(p){let c=this.a;for(const I of p){const E=c.children?.get(I);if(!E)return;c=E}return c._value===h?void 0:c._value}hasKeyOrParent(p){let c=this.a;for(const I of p){const E=c.children?.get(I);if(!E)return!1;if(E._value!==h)return!0;c=E}return!1}hasKeyOrChildren(p){let c=this.a;for(const I of p){const E=c.children?.get(I);if(!E)return!1;c=E}return!0}hasKey(p){let c=this.a;for(const I of p){const E=c.children?.get(I);if(!E)return!1;c=E}return c._value!==h}c(p){const c=[{part:"",node:this.a}];let I=0;for(const E of p){const f=c[I].node.children?.get(E);if(!f)return;c.push({part:E,node:f}),I++}return c}d(p,c,I){let E=this.a;for(const v of p){if(E.children)if(E.children.has(v))E=E.children.get(v);else{const o=new T;E.children.set(v,o),E=o}else{const o=new T;E.children=new Map([[v,o]]),E=o}I?.(E)}const f=E._value===h?0:1;c(E);const P=E._value===h?0:1;this.b+=P-f}*values(){for(const{_value:p}of O(this.a))p!==h&&(yield p)}}e.$sJ=D;function*O(A){const p=[A];for(;p.length>0;){const c=p.pop();if(yield c,c.children)for(const I of c.children.values())p.push(I)}}class T{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value(p){this._value=p===void 0?h:p}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var s=e();for(var h in s)(typeof exports=="object"?exports:ge)[h]=s[h]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function s(h){if(e[h])return e[h].exports;var D=e[h]={i:h,l:!1,exports:{}};return ge[h].call(D.exports,D,D.exports,s),D.l=!0,D.exports}return s.m=ge,s.c=e,s.d=function(h,D,O){s.o(h,D)||Object.defineProperty(h,D,{enumerable:!0,get:O})},s.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},s.t=function(h,D){if(1&D&&(h=s(h)),8&D||4&D&&typeof h=="object"&&h&&h.__esModule)return h;var O=Object.create(null);if(s.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:h}),2&D&&typeof h!="string")for(var T in h)s.d(O,T,function(A){return h[A]}.bind(null,T));return O},s.n=function(h){var D=h&&h.__esModule?function(){return h.default}:function(){return h};return s.d(D,"a",D),D},s.o=function(h,D){return Object.prototype.hasOwnProperty.call(h,D)},s.p="",s(s.s=0)}([function(ge,e,s){(function(h){var D;e=ge.exports=me,D=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var G=Array.prototype.slice.call(arguments,0);G.unshift("SEMVER"),console.log.apply(console,G)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],p=e.src=[],c=0,I=c++;p[I]="0|[1-9]\\d*";var E=c++;p[E]="[0-9]+";var f=c++;p[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=c++;p[P]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var v=c++;p[v]="("+p[E]+")\\.("+p[E]+")\\.("+p[E]+")";var o=c++;p[o]="(?:"+p[I]+"|"+p[f]+")";var m=c++;p[m]="(?:"+p[E]+"|"+p[f]+")";var $=c++;p[$]="(?:-("+p[o]+"(?:\\."+p[o]+")*))";var d=c++;p[d]="(?:-?("+p[m]+"(?:\\."+p[m]+")*))";var i=c++;p[i]="[0-9A-Za-z-]+";var a=c++;p[a]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var t=c++,r="v?"+p[P]+p[$]+"?"+p[a]+"?";p[t]="^"+r+"$";var n="[v=\\s]*"+p[v]+p[d]+"?"+p[a]+"?",u=c++;p[u]="^"+n+"$";var l=c++;p[l]="((?:<|>)?=?)";var g=c++;p[g]=p[E]+"|x|X|\\*";var y=c++;p[y]=p[I]+"|x|X|\\*";var k=c++;p[k]="[v=\\s]*("+p[y]+")(?:\\.("+p[y]+")(?:\\.("+p[y]+")(?:"+p[$]+")?"+p[a]+"?)?)?";var S=c++;p[S]="[v=\\s]*("+p[g]+")(?:\\.("+p[g]+")(?:\\.("+p[g]+")(?:"+p[d]+")?"+p[a]+"?)?)?";var R=c++;p[R]="^"+p[l]+"\\s*"+p[k]+"$";var C=c++;p[C]="^"+p[l]+"\\s*"+p[S]+"$";var w=c++;p[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=c++;p[b]="(?:~>?)";var N=c++;p[N]="(\\s*)"+p[b]+"\\s+",A[N]=new RegExp(p[N],"g");var L=c++;p[L]="^"+p[b]+p[k]+"$";var M=c++;p[M]="^"+p[b]+p[S]+"$";var z=c++;p[z]="(?:\\^)";var V=c++;p[V]="(\\s*)"+p[z]+"\\s+",A[V]=new RegExp(p[V],"g");var F=c++;p[F]="^"+p[z]+p[k]+"$";var j=c++;p[j]="^"+p[z]+p[S]+"$";var W=c++;p[W]="^"+p[l]+"\\s*("+n+")$|^$";var J=c++;p[J]="^"+p[l]+"\\s*("+r+")$|^$";var B=c++;p[B]="(\\s*)"+p[l]+"\\s*("+n+"|"+p[k]+")",A[B]=new RegExp(p[B],"g");var U=c++;p[U]="^\\s*("+p[k]+")\\s+-\\s+("+p[k]+")\\s*$";var _=c++;p[_]="^\\s*("+p[S]+")\\s+-\\s+("+p[S]+")\\s*$";var x=c++;p[x]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)D(oe,p[oe]),A[oe]||(A[oe]=new RegExp(p[oe]));function te(G,Z){if(G instanceof me)return G;if(typeof G!="string"||G.length>O||!(Z?A[u]:A[t]).test(G))return null;try{return new me(G,Z)}catch{return null}}function me(G,Z){if(G instanceof me){if(G.loose===Z)return G;G=G.version}else if(typeof G!="string")throw new TypeError("Invalid Version: "+G);if(G.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof me))return new me(G,Z);D("SemVer",G,Z),this.loose=Z;var ee=G.trim().match(Z?A[u]:A[t]);if(!ee)throw new TypeError("Invalid Version: "+G);if(this.raw=G,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var ye=+ue;if(ye>=0&&ye<T)return ye}return ue}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=te,e.valid=function(G,Z){var ee=te(G,Z);return ee?ee.version:null},e.clean=function(G,Z){var ee=te(G.trim().replace(/^[=v]+/,""),Z);return ee?ee.version:null},e.SemVer=me,me.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},me.prototype.toString=function(){return this.version},me.prototype.compare=function(G){return D("SemVer.compare",this.version,this.loose,G),G instanceof me||(G=new me(G,this.loose)),this.compareMain(G)||this.comparePre(G)},me.prototype.compareMain=function(G){return G instanceof me||(G=new me(G,this.loose)),Y(this.major,G.major)||Y(this.minor,G.minor)||Y(this.patch,G.patch)},me.prototype.comparePre=function(G){if(G instanceof me||(G=new me(G,this.loose)),this.prerelease.length&&!G.prerelease.length)return-1;if(!this.prerelease.length&&G.prerelease.length)return 1;if(!this.prerelease.length&&!G.prerelease.length)return 0;var Z=0;do{var ee=this.prerelease[Z],ue=G.prerelease[Z];if(D("prerelease compare",Z,ee,ue),ee===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(ee===void 0)return-1;if(ee!==ue)return Y(ee,ue)}while(++Z)},me.prototype.inc=function(G,Z){switch(G){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+G)}return this.format(),this.raw=this.version,this},e.inc=function(G,Z,ee,ue){typeof ee=="string"&&(ue=ee,ee=void 0);try{return new me(G,ee).inc(Z,ue).version}catch{return null}},e.diff=function(G,Z){if(ae(G,Z))return null;var ee=te(G),ue=te(Z);if(ee.prerelease.length||ue.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==ue[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==ue[ye])return ye},e.compareIdentifiers=Y;var ce=/^[0-9]+$/;function Y(G,Z){var ee=ce.test(G),ue=ce.test(Z);return ee&&ue&&(G=+G,Z=+Z),ee&&!ue?-1:ue&&!ee?1:G<Z?-1:G>Z?1:0}function q(G,Z,ee){return new me(G,ee).compare(new me(Z,ee))}function se(G,Z,ee){return q(G,Z,ee)>0}function be(G,Z,ee){return q(G,Z,ee)<0}function ae(G,Z,ee){return q(G,Z,ee)===0}function we(G,Z,ee){return q(G,Z,ee)!==0}function $e(G,Z,ee){return q(G,Z,ee)>=0}function pe(G,Z,ee){return q(G,Z,ee)<=0}function Oe(G,Z,ee,ue){var ye;switch(Z){case"===":typeof G=="object"&&(G=G.version),typeof ee=="object"&&(ee=ee.version),ye=G===ee;break;case"!==":typeof G=="object"&&(G=G.version),typeof ee=="object"&&(ee=ee.version),ye=G!==ee;break;case"":case"=":case"==":ye=ae(G,ee,ue);break;case"!=":ye=we(G,ee,ue);break;case">":ye=se(G,ee,ue);break;case">=":ye=$e(G,ee,ue);break;case"<":ye=be(G,ee,ue);break;case"<=":ye=pe(G,ee,ue);break;default:throw new TypeError("Invalid operator: "+Z)}return ye}function Fe(G,Z){if(G instanceof Fe){if(G.loose===Z)return G;G=G.value}if(!(this instanceof Fe))return new Fe(G,Z);D("comparator",G,Z),this.loose=Z,this.parse(G),this.semver===He?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(G,Z){return Y(Z,G)},e.major=function(G,Z){return new me(G,Z).major},e.minor=function(G,Z){return new me(G,Z).minor},e.patch=function(G,Z){return new me(G,Z).patch},e.compare=q,e.compareLoose=function(G,Z){return q(G,Z,!0)},e.rcompare=function(G,Z,ee){return q(Z,G,ee)},e.sort=function(G,Z){return G.sort(function(ee,ue){return e.compare(ee,ue,Z)})},e.rsort=function(G,Z){return G.sort(function(ee,ue){return e.rcompare(ee,ue,Z)})},e.gt=se,e.lt=be,e.eq=ae,e.neq=we,e.gte=$e,e.lte=pe,e.cmp=Oe,e.Comparator=Fe;var He={};function Ze(G,Z){if(G instanceof Ze)return G.loose===Z?G:new Ze(G.raw,Z);if(G instanceof Fe)return new Ze(G.value,Z);if(!(this instanceof Ze))return new Ze(G,Z);if(this.loose=Z,this.raw=G,this.set=G.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+G);this.format()}function xe(G){return!G||G.toLowerCase()==="x"||G==="*"}function je(G,Z,ee,ue,ye,Ae,Ve,Je,nt,ot,ht,at,lt){return((Z=xe(ee)?"":xe(ue)?">="+ee+".0.0":xe(ye)?">="+ee+"."+ue+".0":">="+Z)+" "+(Je=xe(nt)?"":xe(ot)?"<"+(+nt+1)+".0.0":xe(ht)?"<"+nt+"."+(+ot+1)+".0":at?"<="+nt+"."+ot+"."+ht+"-"+at:"<="+Je)).trim()}function qe(G,Z){for(var ee=0;ee<G.length;ee++)if(!G[ee].test(Z))return!1;if(Z.prerelease.length){for(ee=0;ee<G.length;ee++)if(D(G[ee].semver),G[ee].semver!==He&&G[ee].semver.prerelease.length>0){var ue=G[ee].semver;if(ue.major===Z.major&&ue.minor===Z.minor&&ue.patch===Z.patch)return!0}return!1}return!0}function Ne(G,Z,ee){try{Z=new Ze(Z,ee)}catch{return!1}return Z.test(G)}function H(G,Z,ee,ue){var ye,Ae,Ve,Je,nt;switch(G=new me(G,ue),Z=new Ze(Z,ue),ee){case">":ye=se,Ae=pe,Ve=be,Je=">",nt=">=";break;case"<":ye=be,Ae=$e,Ve=se,Je="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(G,Z,ue))return!1;for(var ot=0;ot<Z.set.length;++ot){var ht=Z.set[ot],at=null,lt=null;if(ht.forEach(function(pt){pt.semver===He&&(pt=new Fe(">=0.0.0")),at=at||pt,lt=lt||pt,ye(pt.semver,at.semver,ue)?at=pt:Ve(pt.semver,lt.semver,ue)&&(lt=pt)}),at.operator===Je||at.operator===nt||(!lt.operator||lt.operator===Je)&&Ae(G,lt.semver)||lt.operator===nt&&Ve(G,lt.semver))return!1}return!0}Fe.prototype.parse=function(G){var Z=this.loose?A[W]:A[J],ee=G.match(Z);if(!ee)throw new TypeError("Invalid comparator: "+G);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new me(ee[2],this.loose):this.semver=He},Fe.prototype.toString=function(){return this.value},Fe.prototype.test=function(G){return D("Comparator.test",G,this.loose),this.semver===He||(typeof G=="string"&&(G=new me(G,this.loose)),Oe(G,this.operator,this.semver,this.loose))},Fe.prototype.intersects=function(G,Z){if(!(G instanceof Fe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new Ze(G.value,Z),Ne(this.value,ee,Z);if(G.operator==="")return ee=new Ze(this.value,Z),Ne(G.semver,ee,Z);var ue=!(this.operator!==">="&&this.operator!==">"||G.operator!==">="&&G.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||G.operator!=="<="&&G.operator!=="<"),Ae=this.semver.version===G.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||G.operator!==">="&&G.operator!=="<="),Je=Oe(this.semver,"<",G.semver,Z)&&(this.operator===">="||this.operator===">")&&(G.operator==="<="||G.operator==="<"),nt=Oe(this.semver,">",G.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(G.operator===">="||G.operator===">");return ue||ye||Ae&&Ve||Je||nt},e.Range=Ze,Ze.prototype.format=function(){return this.range=this.set.map(function(G){return G.join(" ").trim()}).join("||").trim(),this.range},Ze.prototype.toString=function(){return this.range},Ze.prototype.parseRange=function(G){var Z=this.loose;G=G.trim(),D("range",G,Z);var ee=Z?A[_]:A[U];G=G.replace(ee,je),D("hyphen replace",G),G=G.replace(A[B],"$1$2$3"),D("comparator trim",G,A[B]),G=(G=(G=G.replace(A[N],"$1~")).replace(A[V],"$1^")).split(/\s+/).join(" ");var ue=Z?A[W]:A[J],ye=G.split(" ").map(function(Ae){return function(Ve,Je){return D("comp",Ve),Ve=function(nt,ot){return nt.trim().split(/\s+/).map(function(ht){return function(at,lt){D("caret",at,lt);var pt=lt?A[j]:A[F];return at.replace(pt,function(it,Ie,re,le,Se){var de;return D("caret",at,it,Ie,re,le,Se),xe(Ie)?de="":xe(re)?de=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":xe(le)?de=Ie==="0"?">="+Ie+"."+re+".0 <"+Ie+"."+(+re+1)+".0":">="+Ie+"."+re+".0 <"+(+Ie+1)+".0.0":Se?(D("replaceCaret pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),de=Ie==="0"?re==="0"?">="+Ie+"."+re+"."+le+Se+" <"+Ie+"."+re+"."+(+le+1):">="+Ie+"."+re+"."+le+Se+" <"+Ie+"."+(+re+1)+".0":">="+Ie+"."+re+"."+le+Se+" <"+(+Ie+1)+".0.0"):(D("no pr"),de=Ie==="0"?re==="0"?">="+Ie+"."+re+"."+le+" <"+Ie+"."+re+"."+(+le+1):">="+Ie+"."+re+"."+le+" <"+Ie+"."+(+re+1)+".0":">="+Ie+"."+re+"."+le+" <"+(+Ie+1)+".0.0"),D("caret return",de),de})}(ht,ot)}).join(" ")}(Ve,Je),D("caret",Ve),Ve=function(nt,ot){return nt.trim().split(/\s+/).map(function(ht){return function(at,lt){var pt=lt?A[M]:A[L];return at.replace(pt,function(it,Ie,re,le,Se){var de;return D("tilde",at,it,Ie,re,le,Se),xe(Ie)?de="":xe(re)?de=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":xe(le)?de=">="+Ie+"."+re+".0 <"+Ie+"."+(+re+1)+".0":Se?(D("replaceTilde pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),de=">="+Ie+"."+re+"."+le+Se+" <"+Ie+"."+(+re+1)+".0"):de=">="+Ie+"."+re+"."+le+" <"+Ie+"."+(+re+1)+".0",D("tilde return",de),de})}(ht,ot)}).join(" ")}(Ve,Je),D("tildes",Ve),Ve=function(nt,ot){return D("replaceXRanges",nt,ot),nt.split(/\s+/).map(function(ht){return function(at,lt){at=at.trim();var pt=lt?A[C]:A[R];return at.replace(pt,function(it,Ie,re,le,Se,de){D("xRange",at,it,Ie,re,le,Se,de);var ke=xe(re),ne=ke||xe(le),X=ne||xe(Se);return Ie==="="&&X&&(Ie=""),ke?it=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&X?(ne&&(le=0),X&&(Se=0),Ie===">"?(Ie=">=",ne?(re=+re+1,le=0,Se=0):X&&(le=+le+1,Se=0)):Ie==="<="&&(Ie="<",ne?re=+re+1:le=+le+1),it=Ie+re+"."+le+"."+Se):ne?it=">="+re+".0.0 <"+(+re+1)+".0.0":X&&(it=">="+re+"."+le+".0 <"+re+"."+(+le+1)+".0"),D("xRange return",it),it})}(ht,ot)}).join(" ")}(Ve,Je),D("xrange",Ve),Ve=function(nt,ot){return D("replaceStars",nt,ot),nt.trim().replace(A[x],"")}(Ve,Je),D("stars",Ve),Ve}(Ae,Z)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Ae){return!!Ae.match(ue)})),ye=ye.map(function(Ae){return new Fe(Ae,Z)})},Ze.prototype.intersects=function(G,Z){if(!(G instanceof Ze))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ue){return G.set.some(function(ye){return ye.every(function(Ae){return ue.intersects(Ae,Z)})})})})},e.toComparators=function(G,Z){return new Ze(G,Z).set.map(function(ee){return ee.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},Ze.prototype.test=function(G){if(!G)return!1;typeof G=="string"&&(G=new me(G,this.loose));for(var Z=0;Z<this.set.length;Z++)if(qe(this.set[Z],G))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(G,Z,ee){var ue=null,ye=null;try{var Ae=new Ze(Z,ee)}catch{return null}return G.forEach(function(Ve){Ae.test(Ve)&&(ue&&ye.compare(Ve)!==-1||(ye=new me(ue=Ve,ee)))}),ue},e.minSatisfying=function(G,Z,ee){var ue=null,ye=null;try{var Ae=new Ze(Z,ee)}catch{return null}return G.forEach(function(Ve){Ae.test(Ve)&&(ue&&ye.compare(Ve)!==1||(ye=new me(ue=Ve,ee)))}),ue},e.validRange=function(G,Z){try{return new Ze(G,Z).range||"*"}catch{return null}},e.ltr=function(G,Z,ee){return H(G,Z,"<",ee)},e.gtr=function(G,Z,ee){return H(G,Z,">",ee)},e.outside=H,e.prerelease=function(G,Z){var ee=te(G,Z);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(G,Z,ee){return G=new Ze(G,ee),Z=new Ze(Z,ee),G.intersects(Z)},e.coerce=function(G){if(G instanceof me)return G;if(typeof G!="string")return null;var Z=G.match(A[w]);return Z==null?null:te((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,s(1))},function(ge,e){var s,h,D=ge.exports={};function O(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function A(m){if(s===setTimeout)return setTimeout(m,0);if((s===O||!s)&&setTimeout)return s=setTimeout,setTimeout(m,0);try{return s(m,0)}catch{try{return s.call(null,m,0)}catch{return s.call(this,m,0)}}}(function(){try{s=typeof setTimeout=="function"?setTimeout:O}catch{s=O}try{h=typeof clearTimeout=="function"?clearTimeout:T}catch{h=T}})();var p,c=[],I=!1,E=-1;function f(){I&&p&&(I=!1,p.length?c=p.concat(c):E=-1,c.length&&P())}function P(){if(!I){var m=A(f);I=!0;for(var $=c.length;$;){for(p=c,c=[];++E<$;)p&&p[E].run();E=-1,$=c.length}p=null,I=!1,function(d){if(h===clearTimeout)return clearTimeout(d);if((h===T||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(d);try{h(d)}catch{try{return h.call(null,d)}catch{return h.call(this,d)}}}(m)}}function v(m,$){this.fun=m,this.array=$}function o(){}D.nextTick=function(m){var $=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)$[d-1]=arguments[d];c.push(new v(m,$)),c.length!==1||I||A(P)},v.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=o,D.addListener=o,D.once=o,D.off=o,D.removeListener=o,D.removeAllListeners=o,D.emit=o,D.prependListener=o,D.prependOnceListener=o,D.listeners=function(m){return[]},D.binding=function(m){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(m){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Re[44],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=void 0;const s=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(O){return new h(O)}constructor(O){this.c=s&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ke=h}),define(Re[4],Ce([1,0,12,81,3,82,44]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$me=e.Event=void 0,e.$ne=P;const A=!1,p=!1,c=!1;var I;(function(M){M.None=()=>D.$Zc.None;function z(Ne){if(c){const{onDidAddListener:H}=Ne,G=o.create();let Z=0;Ne.onDidAddListener=()=>{++Z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),H?.()}}}function V(Ne,H){return me(Ne,()=>{},0,void 0,!0,void 0,H)}M.defer=V;function F(Ne){return(H,G=null,Z)=>{let ee=!1,ue;return ue=Ne(ye=>{if(!ee)return ue?ue.dispose():ee=!0,H.call(G,ye)},null,Z),ee&&ue.dispose(),ue}}M.once=F;function j(Ne,H){return M.once(M.filter(Ne,H))}M.onceIf=j;function W(Ne,H,G){return oe((Z,ee=null,ue)=>Ne(ye=>Z.call(ee,H(ye)),null,ue),G)}M.map=W;function J(Ne,H,G){return oe((Z,ee=null,ue)=>Ne(ye=>{H(ye),Z.call(ee,ye)},null,ue),G)}M.forEach=J;function B(Ne,H,G){return oe((Z,ee=null,ue)=>Ne(ye=>H(ye)&&Z.call(ee,ye),null,ue),G)}M.filter=B;function U(Ne){return Ne}M.signal=U;function _(...Ne){return(H,G=null,Z)=>{const ee=(0,D.$Wc)(...Ne.map(ue=>ue(ye=>H.call(G,ye))));return te(ee,Z)}}M.any=_;function x(Ne,H,G,Z){let ee=G;return W(Ne,ue=>(ee=H(ee,ue),ee),Z)}M.reduce=x;function oe(Ne,H){let G;const Z={onWillAddFirstListener(){G=Ne(ee.fire,ee)},onDidRemoveLastListener(){G?.dispose()}};H||z(Z);const ee=new n(Z);return H?.add(ee),ee.event}function te(Ne,H){return H instanceof Array?H.push(Ne):H&&H.add(Ne),Ne}function me(Ne,H,G=100,Z=!1,ee=!1,ue,ye){let Ae,Ve,Je,nt=0,ot;const ht={leakWarningThreshold:ue,onWillAddFirstListener(){Ae=Ne(lt=>{nt++,Ve=H(Ve,lt),Z&&!Je&&(at.fire(Ve),Ve=void 0),ot=()=>{const pt=Ve;Ve=void 0,Je=void 0,(!Z||nt>1)&&at.fire(pt),nt=0},typeof G=="number"?(clearTimeout(Je),Je=setTimeout(ot,G)):Je===void 0&&(Je=0,queueMicrotask(ot))})},onWillRemoveListener(){ee&&nt>0&&ot?.()},onDidRemoveLastListener(){ot=void 0,Ae.dispose()}};ye||z(ht);const at=new n(ht);return ye?.add(at),at.event}M.debounce=me;function ce(Ne,H=0,G){return M.debounce(Ne,(Z,ee)=>Z?(Z.push(ee),Z):[ee],H,void 0,!0,void 0,G)}M.accumulate=ce;function Y(Ne,H=(Z,ee)=>Z===ee,G){let Z=!0,ee;return B(Ne,ue=>{const ye=Z||!H(ue,ee);return Z=!1,ee=ue,ye},G)}M.latch=Y;function q(Ne,H,G){return[M.filter(Ne,H,G),M.filter(Ne,Z=>!H(Z),G)]}M.split=q;function se(Ne,H=!1,G=[],Z){let ee=G.slice(),ue=Ne(Ve=>{ee?ee.push(Ve):Ae.fire(Ve)});Z&&Z.add(ue);const ye=()=>{ee?.forEach(Ve=>Ae.fire(Ve)),ee=null},Ae=new n({onWillAddFirstListener(){ue||(ue=Ne(Ve=>Ae.fire(Ve)),Z&&Z.add(ue))},onDidAddFirstListener(){ee&&(H?setTimeout(ye):ye())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return Z&&Z.add(Ae),Ae.event}M.buffer=se;function be(Ne,H){return(Z,ee,ue)=>{const ye=H(new we);return Ne(function(Ae){const Ve=ye.evaluate(Ae);Ve!==ae&&Z.call(ee,Ve)},void 0,ue)}}M.chain=be;const ae=Symbol("HaltChainable");class we{constructor(){this.f=[]}map(H){return this.f.push(H),this}forEach(H){return this.f.push(G=>(H(G),G)),this}filter(H){return this.f.push(G=>H(G)?G:ae),this}reduce(H,G){let Z=G;return this.f.push(ee=>(Z=H(Z,ee),Z)),this}latch(H=(G,Z)=>G===Z){let G=!0,Z;return this.f.push(ee=>{const ue=G||!H(ee,Z);return G=!1,Z=ee,ue?ee:ae}),this}evaluate(H){for(const G of this.f)if(H=G(H),H===ae)break;return H}}function $e(Ne,H,G=Z=>Z){const Z=(...Ae)=>ye.fire(G(...Ae)),ee=()=>Ne.on(H,Z),ue=()=>Ne.removeListener(H,Z),ye=new n({onWillAddFirstListener:ee,onDidRemoveLastListener:ue});return ye.event}M.fromNodeEventEmitter=$e;function pe(Ne,H,G=Z=>Z){const Z=(...Ae)=>ye.fire(G(...Ae)),ee=()=>Ne.addEventListener(H,Z),ue=()=>Ne.removeEventListener(H,Z),ye=new n({onWillAddFirstListener:ee,onDidRemoveLastListener:ue});return ye.event}M.fromDOMEventEmitter=pe;function Oe(Ne){return new Promise(H=>F(Ne)(H))}M.toPromise=Oe;function Fe(Ne){const H=new n;return Ne.then(G=>{H.fire(G)},()=>{H.fire(void 0)}).finally(()=>{H.dispose()}),H.event}M.fromPromise=Fe;function He(Ne,H){return Ne(G=>H.fire(G))}M.forward=He;function Ze(Ne,H,G){return H(G),Ne(Z=>H(Z))}M.runAndSubscribe=Ze;class xe{constructor(H,G){this._observable=H,this.f=0,this.g=!1;const Z={onWillAddFirstListener:()=>{H.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{H.removeObserver(this)}};G||z(Z),this.emitter=new n(Z),G&&G.add(this.emitter)}beginUpdate(H){this.f++}handlePossibleChange(H){}handleChange(H,G){this.g=!0}endUpdate(H){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function je(Ne,H){return new xe(Ne,H).emitter.event}M.fromObservable=je;function qe(Ne){return(H,G,Z)=>{let ee=0,ue=!1;const ye={beginUpdate(){ee++},endUpdate(){ee--,ee===0&&(Ne.reportChanges(),ue&&(ue=!1,H.call(G)))},handlePossibleChange(){},handleChange(){ue=!0}};Ne.addObserver(ye),Ne.reportChanges();const Ae={dispose(){Ne.removeObserver(ye)}};return Z instanceof D.$Yc?Z.add(Ae):Array.isArray(Z)&&Z.push(Ae),Ae}}M.fromObservableLight=qe})(I||(e.Event=I={}));class E{static{this.all=new Set}static{this.f=0}constructor(z){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${z}_${E.f++}`,E.all.add(this)}start(z){this.g=new T.$ke,this.listenerCount=z}stop(){if(this.g){const z=this.g.elapsed();this.durations.push(z),this.elapsedOverall+=z,this.invocationCount+=1,this.g=void 0}}}e.$me=E;let f=-1;function P(M){const z=f;return f=M,{dispose(){f=z}}}class v{static{this.f=1}constructor(z,V,F=(v.f++).toString(16).padStart(3,"0")){this.j=z,this.threshold=V,this.name=F,this.h=0}dispose(){this.g?.clear()}check(z,V){const F=this.threshold;if(F<=0||V<F)return;this.g||(this.g=new Map);const j=this.g.get(z.value)||0;if(this.g.set(z.value,j+1),this.h-=1,this.h<=0){this.h=F*.5;const[W,J]=this.getMostFrequentStack(),B=`[${this.name}] potential listener LEAK detected, having ${V} listeners already. MOST frequent listener (${J}):`;console.warn(B),console.warn(W);const U=new m(B,W);this.j(U)}return()=>{const W=this.g.get(z.value)||0;this.g.set(z.value,W-1)}}getMostFrequentStack(){if(!this.g)return;let z,V=0;for(const[F,j]of this.g)(!z||V<j)&&(z=[F,j],V=j);return z}}class o{static create(){const z=new Error;return new o(z.stack??"")}constructor(z){this.value=z}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(z,V){super(z),this.name="ListenerLeakError",this.stack=V}}e.$oe=m;class $ extends Error{constructor(z,V){super(z),this.name="ListenerRefusalError",this.stack=V}}e.$pe=$;let d=0;class i{constructor(z){this.value=z,this.id=d++}}const a=2,t=(M,z)=>{if(M instanceof i)z(M);else for(let V=0;V<M.length;V++){const F=M[V];F&&z(F)}};let r;if(A){const M=[];setInterval(()=>{M.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(M.join(`
`)),M.length=0)},3e3),r=new FinalizationRegistry(z=>{typeof z=="string"&&M.push(z)})}class n{constructor(z){this.z=0,this.f=z,this.g=f>0||this.f?.leakWarningThreshold?new v(z?.onListenerError??s.$4,this.f?.leakWarningThreshold??f):void 0,this.j=this.f?._profName?new E(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(p){const z=this.u;queueMicrotask(()=>{t(z,V=>V.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(z,V,F)=>{if(this.g&&this.z>this.g.threshold**2){const U=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(U);const _=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],x=new $(`${U}. HINT: Stack shows most frequent listener (${_[1]}-times)`,_[0]);return(this.f?.onListenerError||s.$4)(x),D.$Zc.None}if(this.m)return D.$Zc.None;V&&(z=z.bind(V));const j=new i(z);let W,J;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(j.stack=o.create(),W=this.g.check(j.stack,this.z+1)),p&&(j.stack=J??o.create()),this.u?this.u instanceof i?(this.w??=new l,this.u=[this.u,j]):this.u.push(j):(this.f?.onWillAddFirstListener?.(this),this.u=j,this.f?.onDidAddFirstListener?.(this)),this.z++;const B=(0,D.$Xc)(()=>{r?.unregister(B),W?.(),this.A(j)});if(F instanceof D.$Yc?F.add(B):Array.isArray(F)&&F.push(B),r){const U=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),_=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(U);r.register(B,_?.[2]??U,B)}return B},this.q}A(z){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const V=this.u,F=V.indexOf(z);if(F===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,V[F]=void 0;const j=this.w.current===this;if(this.z*a<=V.length){let W=0;for(let J=0;J<V.length;J++)V[J]?V[W++]=V[J]:j&&(this.w.end--,W<this.w.i&&this.w.i--);V.length=W}}B(z,V){if(!z)return;const F=this.f?.onListenerError||s.$4;if(!F){z.value(V);return}try{z.value(V)}catch(j){F(j)}}C(z){const V=z.current.u;for(;z.i<z.end;)this.B(V[z.i++],z.value);z.reset()}fire(z){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof i)this.B(this.u,z);else{const V=this.w;V.enqueue(this,z,this.u.length),this.C(V)}this.j?.stop()}hasListeners(){return this.z>0}}e.$qe=n;const u=()=>new l;e.$re=u;class l{constructor(){this.i=-1,this.end=0}enqueue(z,V,F){this.i=0,this.end=F,this.current=z,this.value=V}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class g extends n{async fireAsync(z,V,F){if(this.u)for(this.h||(this.h=new O.$0c),t(this.u,j=>this.h.push([j.value,z]));this.h.size>0&&!V.isCancellationRequested;){const[j,W]=this.h.shift(),J=[],B={...W,token:V,waitUntil:U=>{if(Object.isFrozen(J))throw new Error("waitUntil can NOT be called asynchronous");F&&(U=F(U,j)),J.push(U)}};try{j(B)}catch(U){(0,s.$4)(U);continue}Object.freeze(J),await Promise.allSettled(J).then(U=>{for(const _ of U)_.status==="rejected"&&(0,s.$4)(_.reason)})}}}e.$se=g;class y extends n{get isPaused(){return this.h!==0}constructor(z){super(z),this.h=0,this.s=new O.$0c,this.t=z?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const z=Array.from(this.s);this.s.clear(),super.fire(this.t(z))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(z){this.z&&(this.h!==0?this.s.push(z):super.fire(z))}}e.$te=y;class k extends y{constructor(z){super(z),this.k=z.delay??100}fire(z){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(z)}}e.$ue=k;class S extends n{constructor(z){super(z),this.h=[],this.k=z?.merge}fire(z){this.hasListeners()&&(this.h.push(z),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(V=>super.fire(V)),this.h=[]}))}}e.$ve=S;class R{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(z){const V={event:z,listener:null};this.h.push(V),this.g&&this.m(V);const F=()=>{this.g&&this.o(V);const j=this.h.indexOf(V);this.h.splice(j,1)};return(0,D.$Xc)((0,h.$hb)(F))}j(){this.g=!0,this.h.forEach(z=>this.m(z))}k(){this.g=!1,this.h.forEach(z=>this.o(z))}m(z){z.listener=z.event(V=>this.f.fire(V))}o(z){z.listener?.dispose(),z.listener=null}dispose(){this.f.dispose();for(const z of this.h)z.listener?.dispose();this.h=[]}}e.$we=R;class C{constructor(z,V,F,j){this.f=new D.$Yc;const W=this.f.add(new R),J=this.f.add(new D.$9c);function B(U){J.set(U,W.add(j(U)))}for(const U of z)B(U);this.f.add(V(U=>{B(U)})),this.f.add(F(U=>{J.deleteAndDispose(U)})),this.event=W.event}dispose(){this.f.dispose()}}e.$xe=C;class w{constructor(){this.f=[]}wrapEvent(z,V,F){return(j,W,J)=>z(B=>{const U=this.f[this.f.length-1];if(!V){U?U.buffers.push(()=>j.call(W,B)):j.call(W,B);return}const _=U;if(!_){j.call(W,V(F,B));return}_.items??=[],_.items.push(B),_.buffers.length===0&&U.buffers.push(()=>{_.reducedResult??=F?_.items.reduce(V,F):_.items.reduce(V),j.call(W,_.reducedResult)})},void 0,J)}bufferEvents(z){const V={buffers:new Array};this.f.push(V);const F=z();return this.f.pop(),V.buffers.forEach(j=>j()),F}}e.$ye=w;class b{constructor(){this.f=!1,this.g=I.None,this.h=D.$Zc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(z){this.g=z,this.f&&(this.h.dispose(),this.h=z(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ze=b;class N{static const(z){return new L(z)}constructor(z){this.g=z,this.f=new n,this.onDidChange=this.f.event}get value(){return this.g}set value(z){z!==this.g&&(this.g=z,this.f.fire(void 0))}}e.$Ae=N;class L{constructor(z){this.value=z,this.onDidChange=I.None}}}),define(Re[20],Ce([1,0,4]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.CancellationToken=void 0,e.$Ce=A;const h=Object.freeze(function(p,c){const I=setTimeout(p.bind(c),0);return{dispose(){clearTimeout(I)}}});var D;(function(p){function c(I){return I===p.None||I===p.Cancelled||I instanceof O?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}p.isCancellationToken=c,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:s.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(D||(e.CancellationToken=D={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new s.$qe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=D.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=D.None}}e.$Be=T;function A(p){const c=new T;return p.add({dispose(){c.cancel()}}),c.token}}),define(Re[189],Ce([1,0,20]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ef=e.$df=e.$bf=void 0,e.$cf=D;class h{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new s.$Be,c=this.b(p.token);return this.a={promise:c,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$bf=h;function D(A){return A}class O{constructor(p,c){this.a=void 0,this.b=void 0,typeof p=="function"?(this.c=p,this.d=D):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);return this.b!==c&&(this.b=c,this.a=this.c(p)),this.a}}e.$df=O;class T{get cachedValues(){return this.a}constructor(p,c){this.a=new Map,this.b=new Map,typeof p=="function"?(this.c=p,this.d=D):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);if(this.b.has(c))return this.b.get(c);const I=this.c(p);return this.a.set(p,I),this.b.set(c,I),I}}e.$ef=T}),define(Re[190],Ce([1,0,4,3]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.$ot=e.$nt=e.ScrollbarVisibility=void 0;var D;(function(P){P[P.Auto=1]="Auto",P[P.Hidden=2]="Hidden",P[P.Visible=3]="Visible"})(D||(e.ScrollbarVisibility=D={}));class O{constructor(v,o,m,$,d,i,a){this.c=v,this._scrollStateBrand=void 0,this.c&&(o=o|0,m=m|0,$=$|0,d=d|0,i=i|0,a=a|0),this.rawScrollLeft=$,this.rawScrollTop=a,o<0&&(o=0),$+o>m&&($=m-o),$<0&&($=0),d<0&&(d=0),a+d>i&&(a=i-d),a<0&&(a=0),this.width=o,this.scrollWidth=m,this.scrollLeft=$,this.height=d,this.scrollHeight=i,this.scrollTop=a}equals(v){return this.rawScrollLeft===v.rawScrollLeft&&this.rawScrollTop===v.rawScrollTop&&this.width===v.width&&this.scrollWidth===v.scrollWidth&&this.scrollLeft===v.scrollLeft&&this.height===v.height&&this.scrollHeight===v.scrollHeight&&this.scrollTop===v.scrollTop}withScrollDimensions(v,o){return new O(this.c,typeof v.width<"u"?v.width:this.width,typeof v.scrollWidth<"u"?v.scrollWidth:this.scrollWidth,o?this.rawScrollLeft:this.scrollLeft,typeof v.height<"u"?v.height:this.height,typeof v.scrollHeight<"u"?v.scrollHeight:this.scrollHeight,o?this.rawScrollTop:this.scrollTop)}withScrollPosition(v){return new O(this.c,this.width,this.scrollWidth,typeof v.scrollLeft<"u"?v.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof v.scrollTop<"u"?v.scrollTop:this.rawScrollTop)}createScrollEvent(v,o){const m=this.width!==v.width,$=this.scrollWidth!==v.scrollWidth,d=this.scrollLeft!==v.scrollLeft,i=this.height!==v.height,a=this.scrollHeight!==v.scrollHeight,t=this.scrollTop!==v.scrollTop;return{inSmoothScrolling:o,oldWidth:v.width,oldScrollWidth:v.scrollWidth,oldScrollLeft:v.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:v.height,oldScrollHeight:v.scrollHeight,oldScrollTop:v.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:$,scrollLeftChanged:d,heightChanged:i,scrollHeightChanged:a,scrollTopChanged:t}}}e.$nt=O;class T extends h.$Zc{constructor(v){super(),this._scrollableBrand=void 0,this.j=this.B(new s.$qe),this.onScroll=this.j.event,this.c=v.smoothScrollDuration,this.f=v.scheduleAtNextAnimationFrame,this.g=new O(v.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(v){this.c=v}validateScrollPosition(v){return this.g.withScrollPosition(v)}getScrollDimensions(){return this.g}setScrollDimensions(v,o){const m=this.g.withScrollDimensions(v,o);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(v){const o=this.g.withScrollPosition(v);this.h&&(this.h.dispose(),this.h=null),this.n(o,!1)}setScrollPositionSmooth(v,o){if(this.c===0)return this.setScrollPositionNow(v);if(this.h){v={scrollLeft:typeof v.scrollLeft>"u"?this.h.to.scrollLeft:v.scrollLeft,scrollTop:typeof v.scrollTop>"u"?this.h.to.scrollTop:v.scrollTop};const m=this.g.withScrollPosition(v);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let $;o?$=new I(this.h.from,m,this.h.startTime,this.h.duration):$=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=$}else{const m=this.g.withScrollPosition(v);this.h=I.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const v=this.h.tick(),o=this.g.withScrollPosition(v);if(this.n(o,!0),!!this.h){if(v.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(v,o){const m=this.g;m.equals(v)||(this.g=v,this.j.fire(this.g.createScrollEvent(m,o)))}}e.$ot=T;class A{constructor(v,o,m){this.scrollLeft=v,this.scrollTop=o,this.isDone=m}}e.$pt=A;function p(P,v){const o=v-P;return function(m){return P+o*f(m)}}function c(P,v,o){return function(m){return m<o?P(m/o):v((m-o)/(1-o))}}class I{constructor(v,o,m,$){this.from=v,this.to=o,this.duration=$,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(v,o,m){if(Math.abs(v-o)>2.5*m){let d,i;return v<o?(d=v+.75*m,i=o-.75*m):(d=v-.75*m,i=o+.75*m),c(p(v,d),p(i,o),.33)}return p(v,o)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(v){this.to=v.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(v){const o=(v-this.startTime)/this.duration;if(o<1){const m=this.c(o),$=this.d(o);return new A(m,$,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(v,o,m){return I.start(v,o,m)}static start(v,o,m){m=m+10;const $=Date.now()-10;return new I(v,o,$,m)}}e.$qt=I;function E(P){return Math.pow(P,3)}function f(P){return 1-E(1-P)}}),define(Re[103],Ce([1,0,12,3]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=D,e.$Ee=O,e.$Fe=T,e.$Ge=A,e.$He=c,e.$Ie=I,e.$Je=E,e.$Ke=f,e.$Le=P,e.$Me=v,e.$Ne=o,e.$Oe=m,e.$Pe=$,e.$Qe=d,e.$Re=i;function D(a){const t=a;return t?typeof t.read=="function":!1}function O(a){const t=a;return t?[t.on,t.pause,t.resume,t.destroy].every(r=>typeof r=="function"):!1}function T(a){const t=a;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function A(a,t){return new p(a,t)}class p{constructor(t,r){this.e=t,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(r=>r(t))}h(t){this.c.error.length===0?(0,s.$4)(t):this.c.error.slice(0).forEach(r=>r(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,r){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(t,r){if(this.a.destroyed)return;let n;switch(t){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const u=n.indexOf(r);u>=0&&n.splice(u,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(a,t){const r=[];let n;for(;(n=a.read())!==null;)r.push(n);return t(r)}function I(a,t,r){const n=[];let u;for(;(u=a.read())!==null&&n.length<r;)n.push(u);return u===null&&n.length>0?t(n):{read:()=>{if(n.length>0)return n.shift();if(typeof u<"u"){const l=u;return u=void 0,l}return a.read()}}}function E(a,t){return new Promise((r,n)=>{const u=[];f(a,{onData:l=>{t&&u.push(l)},onError:l=>{t?n(l):r(void 0)},onEnd:()=>{r(t?t(u):void 0)}})})}function f(a,t,r){a.on("error",n=>{r?.isCancellationRequested||t.onError(n)}),a.on("end",()=>{r?.isCancellationRequested||t.onEnd()}),a.on("data",n=>{r?.isCancellationRequested||t.onData(n)})}function P(a,t){return new Promise((r,n)=>{const u=new h.$Yc,l=[],g=S=>{if(l.push(S),l.length>t)return u.dispose(),a.pause(),r({stream:a,buffer:l,ended:!1})},y=S=>(u.dispose(),n(S)),k=()=>(u.dispose(),r({stream:a,buffer:l,ended:!0}));u.add((0,h.$Xc)(()=>a.removeListener("error",y))),a.on("error",y),u.add((0,h.$Xc)(()=>a.removeListener("end",k))),a.on("end",k),u.add((0,h.$Xc)(()=>a.removeListener("data",g))),a.on("data",g)})}function v(a,t){const r=A(t);return r.end(a),r}function o(){const a=A(()=>{throw new Error("not supported")});return a.end(),a}function m(a){let t=!1;return{read:()=>t?null:(t=!0,a)}}function $(a,t,r){const n=A(r);return f(a,{onData:u=>n.write(t.data(u)),onError:u=>n.error(t.error?t.error(u):u),onEnd:()=>n.end()}),n}function d(a,t,r){let n=!1;return{read:()=>{const u=t.read();return n?u:(n=!0,u!==null?r([a,u]):a)}}}function i(a,t,r){let n=!1;const u=A(r);return f(t,{onData:l=>n?u.write(l):(n=!0,u.write(r([a,l]))),onError:l=>u.error(l),onEnd:()=>{n||(n=!0,u.write(a)),u.end()}}),u}}),define(Re[21],Ce([1,0,50,103]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=void 0,e.$Te=c,e.$Ue=I,e.$Ve=E,e.$We=f,e.$Xe=P,e.$Ye=v,e.$Ze=o,e.$1e=m,e.$2e=$,e.$3e=d,e.$4e=i,e.$5e=a,e.$6e=t,e.$7e=r,e.$8e=n,e.$9e=u,e.$0e=l,e.$$e=g,e.$_e=y,e.$af=R,h=Ue(h);const D=typeof Buffer<"u",O=new s.$Y(()=>new Uint8Array(256));let T,A;class p{static alloc(w){return D?new p(Buffer.allocUnsafe(w)):new p(new Uint8Array(w))}static wrap(w){return D&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new p(w)}static fromString(w,b){return!(b?.dontUseNodeBuffer||!1)&&D?new p(Buffer.from(w)):(T||(T=new TextEncoder),new p(T.encode(w)))}static fromByteArray(w){const b=p.alloc(w.length);for(let N=0,L=w.length;N<L;N++)b.buffer[N]=w[N];return b}static concat(w,b){if(typeof b>"u"){b=0;for(let M=0,z=w.length;M<z;M++)b+=w[M].byteLength}const N=p.alloc(b);let L=0;for(let M=0,z=w.length;M<z;M++){const V=w[M];N.set(V,L),L+=V.byteLength}return N}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=p.alloc(this.byteLength);return w.set(this),w}toString(){return D?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(w,b){return new p(this.buffer.subarray(w,b))}set(w,b){if(w instanceof p)this.buffer.set(w.buffer,b);else if(w instanceof Uint8Array)this.buffer.set(w,b);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),b);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return f(this.buffer,w)}writeUInt32BE(w,b){P(this.buffer,w,b)}readUInt32LE(w){return v(this.buffer,w)}writeUInt32LE(w,b){o(this.buffer,w,b)}readUInt8(w){return m(this.buffer,w)}writeUInt8(w,b){$(this.buffer,w,b)}indexOf(w,b=0){return c(this.buffer,w instanceof p?w.buffer:w,b)}}e.$Se=p;function c(C,w,b=0){const N=w.byteLength,L=C.byteLength;if(N===0)return 0;if(N===1)return C.indexOf(w[0]);if(N>L-b)return-1;const M=O.value;M.fill(w.length);for(let j=0;j<w.length;j++)M[w[j]]=w.length-j-1;let z=b+w.length-1,V=z,F=-1;for(;z<L;)if(C[z]===w[V]){if(V===0){F=z;break}z--,V--}else z+=Math.max(w.length-V,M[C[z]]),V=w.length-1;return F}function I(C,w){return C[w+0]<<0>>>0|C[w+1]<<8>>>0}function E(C,w,b){C[b+0]=w&255,w=w>>>8,C[b+1]=w&255}function f(C,w){return C[w]*2**24+C[w+1]*2**16+C[w+2]*2**8+C[w+3]}function P(C,w,b){C[b+3]=w,w=w>>>8,C[b+2]=w,w=w>>>8,C[b+1]=w,w=w>>>8,C[b]=w}function v(C,w){return C[w+0]<<0>>>0|C[w+1]<<8>>>0|C[w+2]<<16>>>0|C[w+3]<<24>>>0}function o(C,w,b){C[b+0]=w&255,w=w>>>8,C[b+1]=w&255,w=w>>>8,C[b+2]=w&255,w=w>>>8,C[b+3]=w&255}function m(C,w){return C[w]}function $(C,w,b){C[b]=w}function d(C){return h.$He(C,w=>p.concat(w))}function i(C){return h.$Oe(C)}function a(C){return h.$Je(C,w=>p.concat(w))}async function t(C){return C.ended?p.concat(C.buffer):p.concat([...C.buffer,await a(C.stream)])}function r(C){return h.$Me(C,w=>p.concat(w))}function n(C){return h.$Pe(C,{data:w=>typeof w=="string"?p.fromString(w):p.wrap(w)},w=>p.concat(w))}function u(C){return h.$Ge(w=>p.concat(w),C)}function l(C,w){return h.$Qe(C,w,b=>p.concat(b))}function g(C,w){return h.$Re(C,w,b=>p.concat(b))}function y(C){let w=0,b=0,N=0;const L=new Uint8Array(Math.floor(C.length/4*3)),M=V=>{switch(b){case 3:L[N++]=w|V,b=0;break;case 2:L[N++]=w|V>>>2,w=V<<6,b=3;break;case 1:L[N++]=w|V>>>4,w=V<<4,b=2;break;default:w=V<<2,b=1}};for(let V=0;V<C.length;V++){const F=C.charCodeAt(V);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${C[V]}`)}}const z=N;for(;b>0;)M(0);return p.wrap(L).slice(0,z)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:C},w=!0,b=!1){const N=b?S:k;let L="";const M=C.byteLength%3;let z=0;for(;z<C.byteLength-M;z+=3){const V=C[z+0],F=C[z+1],j=C[z+2];L+=N[V>>>2],L+=N[(V<<4|F>>>4)&63],L+=N[(F<<2|j>>>6)&63],L+=N[j&63]}if(M===1){const V=C[z+0];L+=N[V>>>2],L+=N[V<<4&63],w&&(L+="==")}else if(M===2){const V=C[z+0],F=C[z+1];L+=N[V>>>2],L+=N[(V<<4|F>>>4)&63],L+=N[F<<2&63],w&&(L+="=")}return L}}),define(Re[191],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=void 0,e.$le=Symbol("MicrotaskDelay")}),define(Re[17],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=s,e.$kg=h,e.$lg=D,e.$mg=O,e.$ng=T,e.$og=A,e.$pg=p,e.$qg=c,e.$rg=I,e.$sg=E,e.$tg=f,e.$ug=P,e.$vg=v,e.$wg=m,e.$xg=$,e.$yg=d,e.$zg=i,e.$Ag=a,e.$Bg=t;function s(r){return typeof r=="string"}function h(r){return Array.isArray(r)&&r.every(n=>s(n))}function D(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}function O(r){const n=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof n}function T(r){return typeof r=="number"&&!isNaN(r)}function A(r){return!!r&&typeof r[Symbol.iterator]=="function"}function p(r){return r===!0||r===!1}function c(r){return typeof r>"u"}function I(r){return!E(r)}function E(r){return c(r)||r===null}function f(r,n){if(!r)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function P(r){if(E(r))throw new Error("Assertion Failed: argument is undefined or null");return r}function v(...r){const n=[];for(let u=0;u<r.length;u++){const l=r[u];if(E(l))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);n.push(l)}return n}const o=Object.prototype.hasOwnProperty;function m(r){if(!D(r))return!1;for(const n in r)if(o.call(r,n))return!1;return!0}function $(r){return typeof r=="function"}function d(...r){return r.length>0&&r.every($)}function i(r,n){const u=Math.min(r.length,n.length);for(let l=0;l<u;l++)a(r[l],n[l])}function a(r,n){if(s(n)){if(typeof r!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if($(n)){try{if(r instanceof n)return}catch{}if(!E(r)&&r.constructor===n||n.length===1&&n.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function t(r){return r}}),define(Re[104],Ce([1,0,17]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=D,e.$6j=O;const h=Object.create(null);function D(T,A){if((0,s.$jg)(A)){const p=h[A];if(p===void 0)throw new Error(`${T} references an unknown codicon: ${A}`);A=p}return h[T]=A,{id:T}}function O(){return h}}),define(Re[192],Ce([1,0,104]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=void 0,e.$7j={add:(0,s.$5j)("add",6e4),plus:(0,s.$5j)("plus",6e4),gistNew:(0,s.$5j)("gist-new",6e4),repoCreate:(0,s.$5j)("repo-create",6e4),lightbulb:(0,s.$5j)("lightbulb",60001),lightBulb:(0,s.$5j)("light-bulb",60001),repo:(0,s.$5j)("repo",60002),repoDelete:(0,s.$5j)("repo-delete",60002),gistFork:(0,s.$5j)("gist-fork",60003),repoForked:(0,s.$5j)("repo-forked",60003),gitPullRequest:(0,s.$5j)("git-pull-request",60004),gitPullRequestAbandoned:(0,s.$5j)("git-pull-request-abandoned",60004),recordKeys:(0,s.$5j)("record-keys",60005),keyboard:(0,s.$5j)("keyboard",60005),tag:(0,s.$5j)("tag",60006),gitPullRequestLabel:(0,s.$5j)("git-pull-request-label",60006),tagAdd:(0,s.$5j)("tag-add",60006),tagRemove:(0,s.$5j)("tag-remove",60006),person:(0,s.$5j)("person",60007),personFollow:(0,s.$5j)("person-follow",60007),personOutline:(0,s.$5j)("person-outline",60007),personFilled:(0,s.$5j)("person-filled",60007),gitBranch:(0,s.$5j)("git-branch",60008),gitBranchCreate:(0,s.$5j)("git-branch-create",60008),gitBranchDelete:(0,s.$5j)("git-branch-delete",60008),sourceControl:(0,s.$5j)("source-control",60008),mirror:(0,s.$5j)("mirror",60009),mirrorPublic:(0,s.$5j)("mirror-public",60009),star:(0,s.$5j)("star",60010),starAdd:(0,s.$5j)("star-add",60010),starDelete:(0,s.$5j)("star-delete",60010),starEmpty:(0,s.$5j)("star-empty",60010),comment:(0,s.$5j)("comment",60011),commentAdd:(0,s.$5j)("comment-add",60011),alert:(0,s.$5j)("alert",60012),warning:(0,s.$5j)("warning",60012),search:(0,s.$5j)("search",60013),searchSave:(0,s.$5j)("search-save",60013),logOut:(0,s.$5j)("log-out",60014),signOut:(0,s.$5j)("sign-out",60014),logIn:(0,s.$5j)("log-in",60015),signIn:(0,s.$5j)("sign-in",60015),eye:(0,s.$5j)("eye",60016),eyeUnwatch:(0,s.$5j)("eye-unwatch",60016),eyeWatch:(0,s.$5j)("eye-watch",60016),circleFilled:(0,s.$5j)("circle-filled",60017),primitiveDot:(0,s.$5j)("primitive-dot",60017),closeDirty:(0,s.$5j)("close-dirty",60017),debugBreakpoint:(0,s.$5j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,s.$5j)("debug-breakpoint-disabled",60017),debugHint:(0,s.$5j)("debug-hint",60017),terminalDecorationSuccess:(0,s.$5j)("terminal-decoration-success",60017),primitiveSquare:(0,s.$5j)("primitive-square",60018),edit:(0,s.$5j)("edit",60019),pencil:(0,s.$5j)("pencil",60019),info:(0,s.$5j)("info",60020),issueOpened:(0,s.$5j)("issue-opened",60020),gistPrivate:(0,s.$5j)("gist-private",60021),gitForkPrivate:(0,s.$5j)("git-fork-private",60021),lock:(0,s.$5j)("lock",60021),mirrorPrivate:(0,s.$5j)("mirror-private",60021),close:(0,s.$5j)("close",60022),removeClose:(0,s.$5j)("remove-close",60022),x:(0,s.$5j)("x",60022),repoSync:(0,s.$5j)("repo-sync",60023),sync:(0,s.$5j)("sync",60023),clone:(0,s.$5j)("clone",60024),desktopDownload:(0,s.$5j)("desktop-download",60024),beaker:(0,s.$5j)("beaker",60025),microscope:(0,s.$5j)("microscope",60025),vm:(0,s.$5j)("vm",60026),deviceDesktop:(0,s.$5j)("device-desktop",60026),file:(0,s.$5j)("file",60027),fileText:(0,s.$5j)("file-text",60027),more:(0,s.$5j)("more",60028),ellipsis:(0,s.$5j)("ellipsis",60028),kebabHorizontal:(0,s.$5j)("kebab-horizontal",60028),mailReply:(0,s.$5j)("mail-reply",60029),reply:(0,s.$5j)("reply",60029),organization:(0,s.$5j)("organization",60030),organizationFilled:(0,s.$5j)("organization-filled",60030),organizationOutline:(0,s.$5j)("organization-outline",60030),newFile:(0,s.$5j)("new-file",60031),fileAdd:(0,s.$5j)("file-add",60031),newFolder:(0,s.$5j)("new-folder",60032),fileDirectoryCreate:(0,s.$5j)("file-directory-create",60032),trash:(0,s.$5j)("trash",60033),trashcan:(0,s.$5j)("trashcan",60033),history:(0,s.$5j)("history",60034),clock:(0,s.$5j)("clock",60034),folder:(0,s.$5j)("folder",60035),fileDirectory:(0,s.$5j)("file-directory",60035),symbolFolder:(0,s.$5j)("symbol-folder",60035),logoGithub:(0,s.$5j)("logo-github",60036),markGithub:(0,s.$5j)("mark-github",60036),github:(0,s.$5j)("github",60036),terminal:(0,s.$5j)("terminal",60037),console:(0,s.$5j)("console",60037),repl:(0,s.$5j)("repl",60037),zap:(0,s.$5j)("zap",60038),symbolEvent:(0,s.$5j)("symbol-event",60038),error:(0,s.$5j)("error",60039),stop:(0,s.$5j)("stop",60039),variable:(0,s.$5j)("variable",60040),symbolVariable:(0,s.$5j)("symbol-variable",60040),array:(0,s.$5j)("array",60042),symbolArray:(0,s.$5j)("symbol-array",60042),symbolModule:(0,s.$5j)("symbol-module",60043),symbolPackage:(0,s.$5j)("symbol-package",60043),symbolNamespace:(0,s.$5j)("symbol-namespace",60043),symbolObject:(0,s.$5j)("symbol-object",60043),symbolMethod:(0,s.$5j)("symbol-method",60044),symbolFunction:(0,s.$5j)("symbol-function",60044),symbolConstructor:(0,s.$5j)("symbol-constructor",60044),symbolBoolean:(0,s.$5j)("symbol-boolean",60047),symbolNull:(0,s.$5j)("symbol-null",60047),symbolNumeric:(0,s.$5j)("symbol-numeric",60048),symbolNumber:(0,s.$5j)("symbol-number",60048),symbolStructure:(0,s.$5j)("symbol-structure",60049),symbolStruct:(0,s.$5j)("symbol-struct",60049),symbolParameter:(0,s.$5j)("symbol-parameter",60050),symbolTypeParameter:(0,s.$5j)("symbol-type-parameter",60050),symbolKey:(0,s.$5j)("symbol-key",60051),symbolText:(0,s.$5j)("symbol-text",60051),symbolReference:(0,s.$5j)("symbol-reference",60052),goToFile:(0,s.$5j)("go-to-file",60052),symbolEnum:(0,s.$5j)("symbol-enum",60053),symbolValue:(0,s.$5j)("symbol-value",60053),symbolRuler:(0,s.$5j)("symbol-ruler",60054),symbolUnit:(0,s.$5j)("symbol-unit",60054),activateBreakpoints:(0,s.$5j)("activate-breakpoints",60055),archive:(0,s.$5j)("archive",60056),arrowBoth:(0,s.$5j)("arrow-both",60057),arrowDown:(0,s.$5j)("arrow-down",60058),arrowLeft:(0,s.$5j)("arrow-left",60059),arrowRight:(0,s.$5j)("arrow-right",60060),arrowSmallDown:(0,s.$5j)("arrow-small-down",60061),arrowSmallLeft:(0,s.$5j)("arrow-small-left",60062),arrowSmallRight:(0,s.$5j)("arrow-small-right",60063),arrowSmallUp:(0,s.$5j)("arrow-small-up",60064),arrowUp:(0,s.$5j)("arrow-up",60065),bell:(0,s.$5j)("bell",60066),bold:(0,s.$5j)("bold",60067),book:(0,s.$5j)("book",60068),bookmark:(0,s.$5j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,s.$5j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,s.$5j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,s.$5j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,s.$5j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,s.$5j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,s.$5j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,s.$5j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,s.$5j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,s.$5j)("debug-breakpoint-log-disabled",60075),briefcase:(0,s.$5j)("briefcase",60076),broadcast:(0,s.$5j)("broadcast",60077),browser:(0,s.$5j)("browser",60078),bug:(0,s.$5j)("bug",60079),calendar:(0,s.$5j)("calendar",60080),caseSensitive:(0,s.$5j)("case-sensitive",60081),check:(0,s.$5j)("check",60082),checklist:(0,s.$5j)("checklist",60083),chevronDown:(0,s.$5j)("chevron-down",60084),chevronLeft:(0,s.$5j)("chevron-left",60085),chevronRight:(0,s.$5j)("chevron-right",60086),chevronUp:(0,s.$5j)("chevron-up",60087),chromeClose:(0,s.$5j)("chrome-close",60088),chromeMaximize:(0,s.$5j)("chrome-maximize",60089),chromeMinimize:(0,s.$5j)("chrome-minimize",60090),chromeRestore:(0,s.$5j)("chrome-restore",60091),circleOutline:(0,s.$5j)("circle-outline",60092),circle:(0,s.$5j)("circle",60092),debugBreakpointUnverified:(0,s.$5j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,s.$5j)("terminal-decoration-incomplete",60092),circleSlash:(0,s.$5j)("circle-slash",60093),circuitBoard:(0,s.$5j)("circuit-board",60094),clearAll:(0,s.$5j)("clear-all",60095),clippy:(0,s.$5j)("clippy",60096),closeAll:(0,s.$5j)("close-all",60097),cloudDownload:(0,s.$5j)("cloud-download",60098),cloudUpload:(0,s.$5j)("cloud-upload",60099),code:(0,s.$5j)("code",60100),collapseAll:(0,s.$5j)("collapse-all",60101),colorMode:(0,s.$5j)("color-mode",60102),commentDiscussion:(0,s.$5j)("comment-discussion",60103),creditCard:(0,s.$5j)("credit-card",60105),dash:(0,s.$5j)("dash",60108),dashboard:(0,s.$5j)("dashboard",60109),database:(0,s.$5j)("database",60110),debugContinue:(0,s.$5j)("debug-continue",60111),debugDisconnect:(0,s.$5j)("debug-disconnect",60112),debugPause:(0,s.$5j)("debug-pause",60113),debugRestart:(0,s.$5j)("debug-restart",60114),debugStart:(0,s.$5j)("debug-start",60115),debugStepInto:(0,s.$5j)("debug-step-into",60116),debugStepOut:(0,s.$5j)("debug-step-out",60117),debugStepOver:(0,s.$5j)("debug-step-over",60118),debugStop:(0,s.$5j)("debug-stop",60119),debug:(0,s.$5j)("debug",60120),deviceCameraVideo:(0,s.$5j)("device-camera-video",60121),deviceCamera:(0,s.$5j)("device-camera",60122),deviceMobile:(0,s.$5j)("device-mobile",60123),diffAdded:(0,s.$5j)("diff-added",60124),diffIgnored:(0,s.$5j)("diff-ignored",60125),diffModified:(0,s.$5j)("diff-modified",60126),diffRemoved:(0,s.$5j)("diff-removed",60127),diffRenamed:(0,s.$5j)("diff-renamed",60128),diff:(0,s.$5j)("diff",60129),diffSidebyside:(0,s.$5j)("diff-sidebyside",60129),discard:(0,s.$5j)("discard",60130),editorLayout:(0,s.$5j)("editor-layout",60131),emptyWindow:(0,s.$5j)("empty-window",60132),exclude:(0,s.$5j)("exclude",60133),extensions:(0,s.$5j)("extensions",60134),eyeClosed:(0,s.$5j)("eye-closed",60135),fileBinary:(0,s.$5j)("file-binary",60136),fileCode:(0,s.$5j)("file-code",60137),fileMedia:(0,s.$5j)("file-media",60138),filePdf:(0,s.$5j)("file-pdf",60139),fileSubmodule:(0,s.$5j)("file-submodule",60140),fileSymlinkDirectory:(0,s.$5j)("file-symlink-directory",60141),fileSymlinkFile:(0,s.$5j)("file-symlink-file",60142),fileZip:(0,s.$5j)("file-zip",60143),files:(0,s.$5j)("files",60144),filter:(0,s.$5j)("filter",60145),flame:(0,s.$5j)("flame",60146),foldDown:(0,s.$5j)("fold-down",60147),foldUp:(0,s.$5j)("fold-up",60148),fold:(0,s.$5j)("fold",60149),folderActive:(0,s.$5j)("folder-active",60150),folderOpened:(0,s.$5j)("folder-opened",60151),gear:(0,s.$5j)("gear",60152),gift:(0,s.$5j)("gift",60153),gistSecret:(0,s.$5j)("gist-secret",60154),gist:(0,s.$5j)("gist",60155),gitCommit:(0,s.$5j)("git-commit",60156),gitCompare:(0,s.$5j)("git-compare",60157),compareChanges:(0,s.$5j)("compare-changes",60157),gitMerge:(0,s.$5j)("git-merge",60158),githubAction:(0,s.$5j)("github-action",60159),githubAlt:(0,s.$5j)("github-alt",60160),globe:(0,s.$5j)("globe",60161),grabber:(0,s.$5j)("grabber",60162),graph:(0,s.$5j)("graph",60163),gripper:(0,s.$5j)("gripper",60164),heart:(0,s.$5j)("heart",60165),home:(0,s.$5j)("home",60166),horizontalRule:(0,s.$5j)("horizontal-rule",60167),hubot:(0,s.$5j)("hubot",60168),inbox:(0,s.$5j)("inbox",60169),issueReopened:(0,s.$5j)("issue-reopened",60171),issues:(0,s.$5j)("issues",60172),italic:(0,s.$5j)("italic",60173),jersey:(0,s.$5j)("jersey",60174),json:(0,s.$5j)("json",60175),kebabVertical:(0,s.$5j)("kebab-vertical",60176),key:(0,s.$5j)("key",60177),law:(0,s.$5j)("law",60178),lightbulbAutofix:(0,s.$5j)("lightbulb-autofix",60179),linkExternal:(0,s.$5j)("link-external",60180),link:(0,s.$5j)("link",60181),listOrdered:(0,s.$5j)("list-ordered",60182),listUnordered:(0,s.$5j)("list-unordered",60183),liveShare:(0,s.$5j)("live-share",60184),loading:(0,s.$5j)("loading",60185),location:(0,s.$5j)("location",60186),mailRead:(0,s.$5j)("mail-read",60187),mail:(0,s.$5j)("mail",60188),markdown:(0,s.$5j)("markdown",60189),megaphone:(0,s.$5j)("megaphone",60190),mention:(0,s.$5j)("mention",60191),milestone:(0,s.$5j)("milestone",60192),gitPullRequestMilestone:(0,s.$5j)("git-pull-request-milestone",60192),mortarBoard:(0,s.$5j)("mortar-board",60193),move:(0,s.$5j)("move",60194),multipleWindows:(0,s.$5j)("multiple-windows",60195),mute:(0,s.$5j)("mute",60196),noNewline:(0,s.$5j)("no-newline",60197),note:(0,s.$5j)("note",60198),octoface:(0,s.$5j)("octoface",60199),openPreview:(0,s.$5j)("open-preview",60200),package:(0,s.$5j)("package",60201),paintcan:(0,s.$5j)("paintcan",60202),pin:(0,s.$5j)("pin",60203),play:(0,s.$5j)("play",60204),run:(0,s.$5j)("run",60204),plug:(0,s.$5j)("plug",60205),preserveCase:(0,s.$5j)("preserve-case",60206),preview:(0,s.$5j)("preview",60207),project:(0,s.$5j)("project",60208),pulse:(0,s.$5j)("pulse",60209),question:(0,s.$5j)("question",60210),quote:(0,s.$5j)("quote",60211),radioTower:(0,s.$5j)("radio-tower",60212),reactions:(0,s.$5j)("reactions",60213),references:(0,s.$5j)("references",60214),refresh:(0,s.$5j)("refresh",60215),regex:(0,s.$5j)("regex",60216),remoteExplorer:(0,s.$5j)("remote-explorer",60217),remote:(0,s.$5j)("remote",60218),remove:(0,s.$5j)("remove",60219),replaceAll:(0,s.$5j)("replace-all",60220),replace:(0,s.$5j)("replace",60221),repoClone:(0,s.$5j)("repo-clone",60222),repoForcePush:(0,s.$5j)("repo-force-push",60223),repoPull:(0,s.$5j)("repo-pull",60224),repoPush:(0,s.$5j)("repo-push",60225),report:(0,s.$5j)("report",60226),requestChanges:(0,s.$5j)("request-changes",60227),rocket:(0,s.$5j)("rocket",60228),rootFolderOpened:(0,s.$5j)("root-folder-opened",60229),rootFolder:(0,s.$5j)("root-folder",60230),rss:(0,s.$5j)("rss",60231),ruby:(0,s.$5j)("ruby",60232),saveAll:(0,s.$5j)("save-all",60233),saveAs:(0,s.$5j)("save-as",60234),save:(0,s.$5j)("save",60235),screenFull:(0,s.$5j)("screen-full",60236),screenNormal:(0,s.$5j)("screen-normal",60237),searchStop:(0,s.$5j)("search-stop",60238),server:(0,s.$5j)("server",60240),settingsGear:(0,s.$5j)("settings-gear",60241),settings:(0,s.$5j)("settings",60242),shield:(0,s.$5j)("shield",60243),smiley:(0,s.$5j)("smiley",60244),sortPrecedence:(0,s.$5j)("sort-precedence",60245),splitHorizontal:(0,s.$5j)("split-horizontal",60246),splitVertical:(0,s.$5j)("split-vertical",60247),squirrel:(0,s.$5j)("squirrel",60248),starFull:(0,s.$5j)("star-full",60249),starHalf:(0,s.$5j)("star-half",60250),symbolClass:(0,s.$5j)("symbol-class",60251),symbolColor:(0,s.$5j)("symbol-color",60252),symbolConstant:(0,s.$5j)("symbol-constant",60253),symbolEnumMember:(0,s.$5j)("symbol-enum-member",60254),symbolField:(0,s.$5j)("symbol-field",60255),symbolFile:(0,s.$5j)("symbol-file",60256),symbolInterface:(0,s.$5j)("symbol-interface",60257),symbolKeyword:(0,s.$5j)("symbol-keyword",60258),symbolMisc:(0,s.$5j)("symbol-misc",60259),symbolOperator:(0,s.$5j)("symbol-operator",60260),symbolProperty:(0,s.$5j)("symbol-property",60261),wrench:(0,s.$5j)("wrench",60261),wrenchSubaction:(0,s.$5j)("wrench-subaction",60261),symbolSnippet:(0,s.$5j)("symbol-snippet",60262),tasklist:(0,s.$5j)("tasklist",60263),telescope:(0,s.$5j)("telescope",60264),textSize:(0,s.$5j)("text-size",60265),threeBars:(0,s.$5j)("three-bars",60266),thumbsdown:(0,s.$5j)("thumbsdown",60267),thumbsup:(0,s.$5j)("thumbsup",60268),tools:(0,s.$5j)("tools",60269),triangleDown:(0,s.$5j)("triangle-down",60270),triangleLeft:(0,s.$5j)("triangle-left",60271),triangleRight:(0,s.$5j)("triangle-right",60272),triangleUp:(0,s.$5j)("triangle-up",60273),twitter:(0,s.$5j)("twitter",60274),unfold:(0,s.$5j)("unfold",60275),unlock:(0,s.$5j)("unlock",60276),unmute:(0,s.$5j)("unmute",60277),unverified:(0,s.$5j)("unverified",60278),verified:(0,s.$5j)("verified",60279),versions:(0,s.$5j)("versions",60280),vmActive:(0,s.$5j)("vm-active",60281),vmOutline:(0,s.$5j)("vm-outline",60282),vmRunning:(0,s.$5j)("vm-running",60283),watch:(0,s.$5j)("watch",60284),whitespace:(0,s.$5j)("whitespace",60285),wholeWord:(0,s.$5j)("whole-word",60286),window:(0,s.$5j)("window",60287),wordWrap:(0,s.$5j)("word-wrap",60288),zoomIn:(0,s.$5j)("zoom-in",60289),zoomOut:(0,s.$5j)("zoom-out",60290),listFilter:(0,s.$5j)("list-filter",60291),listFlat:(0,s.$5j)("list-flat",60292),listSelection:(0,s.$5j)("list-selection",60293),selection:(0,s.$5j)("selection",60293),listTree:(0,s.$5j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,s.$5j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,s.$5j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,s.$5j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,s.$5j)("debug-stackframe-active",60297),circleSmallFilled:(0,s.$5j)("circle-small-filled",60298),debugStackframeDot:(0,s.$5j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,s.$5j)("terminal-decoration-mark",60298),debugStackframe:(0,s.$5j)("debug-stackframe",60299),debugStackframeFocused:(0,s.$5j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,s.$5j)("debug-breakpoint-unsupported",60300),symbolString:(0,s.$5j)("symbol-string",60301),debugReverseContinue:(0,s.$5j)("debug-reverse-continue",60302),debugStepBack:(0,s.$5j)("debug-step-back",60303),debugRestartFrame:(0,s.$5j)("debug-restart-frame",60304),debugAlt:(0,s.$5j)("debug-alt",60305),callIncoming:(0,s.$5j)("call-incoming",60306),callOutgoing:(0,s.$5j)("call-outgoing",60307),menu:(0,s.$5j)("menu",60308),expandAll:(0,s.$5j)("expand-all",60309),feedback:(0,s.$5j)("feedback",60310),gitPullRequestReviewer:(0,s.$5j)("git-pull-request-reviewer",60310),groupByRefType:(0,s.$5j)("group-by-ref-type",60311),ungroupByRefType:(0,s.$5j)("ungroup-by-ref-type",60312),account:(0,s.$5j)("account",60313),gitPullRequestAssignee:(0,s.$5j)("git-pull-request-assignee",60313),bellDot:(0,s.$5j)("bell-dot",60314),debugConsole:(0,s.$5j)("debug-console",60315),library:(0,s.$5j)("library",60316),output:(0,s.$5j)("output",60317),runAll:(0,s.$5j)("run-all",60318),syncIgnored:(0,s.$5j)("sync-ignored",60319),pinned:(0,s.$5j)("pinned",60320),githubInverted:(0,s.$5j)("github-inverted",60321),serverProcess:(0,s.$5j)("server-process",60322),serverEnvironment:(0,s.$5j)("server-environment",60323),pass:(0,s.$5j)("pass",60324),issueClosed:(0,s.$5j)("issue-closed",60324),stopCircle:(0,s.$5j)("stop-circle",60325),playCircle:(0,s.$5j)("play-circle",60326),record:(0,s.$5j)("record",60327),debugAltSmall:(0,s.$5j)("debug-alt-small",60328),vmConnect:(0,s.$5j)("vm-connect",60329),cloud:(0,s.$5j)("cloud",60330),merge:(0,s.$5j)("merge",60331),export:(0,s.$5j)("export",60332),graphLeft:(0,s.$5j)("graph-left",60333),magnet:(0,s.$5j)("magnet",60334),notebook:(0,s.$5j)("notebook",60335),redo:(0,s.$5j)("redo",60336),checkAll:(0,s.$5j)("check-all",60337),pinnedDirty:(0,s.$5j)("pinned-dirty",60338),passFilled:(0,s.$5j)("pass-filled",60339),circleLargeFilled:(0,s.$5j)("circle-large-filled",60340),circleLarge:(0,s.$5j)("circle-large",60341),circleLargeOutline:(0,s.$5j)("circle-large-outline",60341),combine:(0,s.$5j)("combine",60342),gather:(0,s.$5j)("gather",60342),table:(0,s.$5j)("table",60343),variableGroup:(0,s.$5j)("variable-group",60344),typeHierarchy:(0,s.$5j)("type-hierarchy",60345),typeHierarchySub:(0,s.$5j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,s.$5j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,s.$5j)("git-pull-request-create",60348),runAbove:(0,s.$5j)("run-above",60349),runBelow:(0,s.$5j)("run-below",60350),notebookTemplate:(0,s.$5j)("notebook-template",60351),debugRerun:(0,s.$5j)("debug-rerun",60352),workspaceTrusted:(0,s.$5j)("workspace-trusted",60353),workspaceUntrusted:(0,s.$5j)("workspace-untrusted",60354),workspaceUnknown:(0,s.$5j)("workspace-unknown",60355),terminalCmd:(0,s.$5j)("terminal-cmd",60356),terminalDebian:(0,s.$5j)("terminal-debian",60357),terminalLinux:(0,s.$5j)("terminal-linux",60358),terminalPowershell:(0,s.$5j)("terminal-powershell",60359),terminalTmux:(0,s.$5j)("terminal-tmux",60360),terminalUbuntu:(0,s.$5j)("terminal-ubuntu",60361),terminalBash:(0,s.$5j)("terminal-bash",60362),arrowSwap:(0,s.$5j)("arrow-swap",60363),copy:(0,s.$5j)("copy",60364),personAdd:(0,s.$5j)("person-add",60365),filterFilled:(0,s.$5j)("filter-filled",60366),wand:(0,s.$5j)("wand",60367),debugLineByLine:(0,s.$5j)("debug-line-by-line",60368),inspect:(0,s.$5j)("inspect",60369),layers:(0,s.$5j)("layers",60370),layersDot:(0,s.$5j)("layers-dot",60371),layersActive:(0,s.$5j)("layers-active",60372),compass:(0,s.$5j)("compass",60373),compassDot:(0,s.$5j)("compass-dot",60374),compassActive:(0,s.$5j)("compass-active",60375),azure:(0,s.$5j)("azure",60376),issueDraft:(0,s.$5j)("issue-draft",60377),gitPullRequestClosed:(0,s.$5j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,s.$5j)("git-pull-request-draft",60379),debugAll:(0,s.$5j)("debug-all",60380),debugCoverage:(0,s.$5j)("debug-coverage",60381),runErrors:(0,s.$5j)("run-errors",60382),folderLibrary:(0,s.$5j)("folder-library",60383),debugContinueSmall:(0,s.$5j)("debug-continue-small",60384),beakerStop:(0,s.$5j)("beaker-stop",60385),graphLine:(0,s.$5j)("graph-line",60386),graphScatter:(0,s.$5j)("graph-scatter",60387),pieChart:(0,s.$5j)("pie-chart",60388),bracket:(0,s.$5j)("bracket",60175),bracketDot:(0,s.$5j)("bracket-dot",60389),bracketError:(0,s.$5j)("bracket-error",60390),lockSmall:(0,s.$5j)("lock-small",60391),azureDevops:(0,s.$5j)("azure-devops",60392),verifiedFilled:(0,s.$5j)("verified-filled",60393),newline:(0,s.$5j)("newline",60394),layout:(0,s.$5j)("layout",60395),layoutActivitybarLeft:(0,s.$5j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,s.$5j)("layout-activitybar-right",60397),layoutPanelLeft:(0,s.$5j)("layout-panel-left",60398),layoutPanelCenter:(0,s.$5j)("layout-panel-center",60399),layoutPanelJustify:(0,s.$5j)("layout-panel-justify",60400),layoutPanelRight:(0,s.$5j)("layout-panel-right",60401),layoutPanel:(0,s.$5j)("layout-panel",60402),layoutSidebarLeft:(0,s.$5j)("layout-sidebar-left",60403),layoutSidebarRight:(0,s.$5j)("layout-sidebar-right",60404),layoutStatusbar:(0,s.$5j)("layout-statusbar",60405),layoutMenubar:(0,s.$5j)("layout-menubar",60406),layoutCentered:(0,s.$5j)("layout-centered",60407),target:(0,s.$5j)("target",60408),indent:(0,s.$5j)("indent",60409),recordSmall:(0,s.$5j)("record-small",60410),errorSmall:(0,s.$5j)("error-small",60411),terminalDecorationError:(0,s.$5j)("terminal-decoration-error",60411),arrowCircleDown:(0,s.$5j)("arrow-circle-down",60412),arrowCircleLeft:(0,s.$5j)("arrow-circle-left",60413),arrowCircleRight:(0,s.$5j)("arrow-circle-right",60414),arrowCircleUp:(0,s.$5j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,s.$5j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,s.$5j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,s.$5j)("layout-sidebar-left-off",60418),blank:(0,s.$5j)("blank",60419),heartFilled:(0,s.$5j)("heart-filled",60420),map:(0,s.$5j)("map",60421),mapHorizontal:(0,s.$5j)("map-horizontal",60421),foldHorizontal:(0,s.$5j)("fold-horizontal",60421),mapFilled:(0,s.$5j)("map-filled",60422),mapHorizontalFilled:(0,s.$5j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,s.$5j)("fold-horizontal-filled",60422),circleSmall:(0,s.$5j)("circle-small",60423),bellSlash:(0,s.$5j)("bell-slash",60424),bellSlashDot:(0,s.$5j)("bell-slash-dot",60425),commentUnresolved:(0,s.$5j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,s.$5j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,s.$5j)("git-pull-request-new-changes",60428),searchFuzzy:(0,s.$5j)("search-fuzzy",60429),commentDraft:(0,s.$5j)("comment-draft",60430),send:(0,s.$5j)("send",60431),sparkle:(0,s.$5j)("sparkle",60432),insert:(0,s.$5j)("insert",60433),mic:(0,s.$5j)("mic",60434),thumbsdownFilled:(0,s.$5j)("thumbsdown-filled",60435),thumbsupFilled:(0,s.$5j)("thumbsup-filled",60436),coffee:(0,s.$5j)("coffee",60437),snake:(0,s.$5j)("snake",60438),game:(0,s.$5j)("game",60439),vr:(0,s.$5j)("vr",60440),chip:(0,s.$5j)("chip",60441),piano:(0,s.$5j)("piano",60442),music:(0,s.$5j)("music",60443),micFilled:(0,s.$5j)("mic-filled",60444),repoFetch:(0,s.$5j)("repo-fetch",60445),copilot:(0,s.$5j)("copilot",60446),lightbulbSparkle:(0,s.$5j)("lightbulb-sparkle",60447),robot:(0,s.$5j)("robot",60448),sparkleFilled:(0,s.$5j)("sparkle-filled",60449),diffSingle:(0,s.$5j)("diff-single",60450),diffMultiple:(0,s.$5j)("diff-multiple",60451),surroundWith:(0,s.$5j)("surround-with",60452),share:(0,s.$5j)("share",60453),gitStash:(0,s.$5j)("git-stash",60454),gitStashApply:(0,s.$5j)("git-stash-apply",60455),gitStashPop:(0,s.$5j)("git-stash-pop",60456),vscode:(0,s.$5j)("vscode",60457),vscodeInsiders:(0,s.$5j)("vscode-insiders",60458),codeOss:(0,s.$5j)("code-oss",60459),runCoverage:(0,s.$5j)("run-coverage",60460),runAllCoverage:(0,s.$5j)("run-all-coverage",60461),coverage:(0,s.$5j)("coverage",60462),githubProject:(0,s.$5j)("github-project",60463),mapVertical:(0,s.$5j)("map-vertical",60464),foldVertical:(0,s.$5j)("fold-vertical",60464),mapVerticalFilled:(0,s.$5j)("map-vertical-filled",60465),foldVerticalFilled:(0,s.$5j)("fold-vertical-filled",60465),goToSearch:(0,s.$5j)("go-to-search",60466),percentage:(0,s.$5j)("percentage",60467),sortPercentage:(0,s.$5j)("sort-percentage",60467),attach:(0,s.$5j)("attach",60468)}}),define(Re[84],Ce([1,0,104,192]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=void 0,e.$8j=D;function D(){return Object.values(e.$0j)}e.$9j={dialogError:(0,s.$5j)("dialog-error","error"),dialogWarning:(0,s.$5j)("dialog-warning","warning"),dialogInfo:(0,s.$5j)("dialog-info","info"),dialogClose:(0,s.$5j)("dialog-close","close"),treeItemExpanded:(0,s.$5j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,s.$5j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,s.$5j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,s.$5j)("tree-filter-clear","close"),treeItemLoading:(0,s.$5j)("tree-item-loading","loading"),menuSelection:(0,s.$5j)("menu-selection","check"),menuSubmenu:(0,s.$5j)("menu-submenu","chevron-right"),menuBarMore:(0,s.$5j)("menubar-more","more"),scrollbarButtonLeft:(0,s.$5j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,s.$5j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,s.$5j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,s.$5j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,s.$5j)("toolbar-more","more"),quickInputBack:(0,s.$5j)("quick-input-back","arrow-left"),dropDownButton:(0,s.$5j)("drop-down-button",60084),symbolCustomColor:(0,s.$5j)("symbol-customcolor",60252),exportIcon:(0,s.$5j)("export",60332),workspaceUnspecified:(0,s.$5j)("workspace-unspecified",60355),newLine:(0,s.$5j)("newline",60394),thumbsDownFilled:(0,s.$5j)("thumbsdown-filled",60435),thumbsUpFilled:(0,s.$5j)("thumbsup-filled",60436),gitFetch:(0,s.$5j)("git-fetch",60445),lightbulbSparkleAutofix:(0,s.$5j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,s.$5j)("debug-breakpoint-pending",60377)},e.$0j={...h.$7j,...e.$9j}}),define(Re[24],Ce([1,0,17]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=h,e.$no=D,e.$oo=T,e.$po=p,e.$qo=c,e.$ro=I,e.$so=E,e.$to=f,e.$uo=P,e.$vo=v,e.$wo=o,e.$xo=m,e.$yo=$;function h(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const i=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([a,t])=>{i[a]=t&&typeof t=="object"?h(t):t}),i}function D(d){if(!d||typeof d!="object")return d;const i=[d];for(;i.length>0;){const a=i.shift();Object.freeze(a);for(const t in a)if(O.call(a,t)){const r=a[t];typeof r=="object"&&!Object.isFrozen(r)&&!(0,s.$mg)(r)&&i.push(r)}}return d}const O=Object.prototype.hasOwnProperty;function T(d,i){return A(d,i,new Set)}function A(d,i,a){if((0,s.$sg)(d))return d;const t=i(d);if(typeof t<"u")return t;if(Array.isArray(d)){const r=[];for(const n of d)r.push(A(n,i,a));return r}if((0,s.$lg)(d)){if(a.has(d))throw new Error("Cannot clone recursive data-structure");a.add(d);const r={};for(const n in d)O.call(d,n)&&(r[n]=A(d[n],i,a));return a.delete(d),r}return d}function p(d,i,a=!0){return(0,s.$lg)(d)?((0,s.$lg)(i)&&Object.keys(i).forEach(t=>{t in d?a&&((0,s.$lg)(d[t])&&(0,s.$lg)(i[t])?p(d[t],i[t],a):d[t]=i[t]):d[t]=i[t]}),d):i}function c(d,i){if(d===i)return!0;if(d==null||i===null||i===void 0||typeof d!=typeof i||typeof d!="object"||Array.isArray(d)!==Array.isArray(i))return!1;let a,t;if(Array.isArray(d)){if(d.length!==i.length)return!1;for(a=0;a<d.length;a++)if(!c(d[a],i[a]))return!1}else{const r=[];for(t in d)r.push(t);r.sort();const n=[];for(t in i)n.push(t);if(n.sort(),!c(r,n))return!1;for(a=0;a<r.length;a++)if(!c(d[r[a]],i[r[a]]))return!1}return!0}function I(d){const i=new Set;return JSON.stringify(d,(a,t)=>{if((0,s.$lg)(t)||Array.isArray(t)){if(i.has(t))return"[Circular]";i.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function E(d,i){const a=Object.create(null);return!d||!i||Object.keys(i).forEach(r=>{const n=d[r],u=i[r];c(n,u)||(a[r]=u)}),a}function f(d,i){const a=i.toLowerCase(),t=Object.keys(d).find(r=>r.toLowerCase()===a);return t?d[t]:d[i]}function P(d,i){const a=Object.create(null);for(const[t,r]of Object.entries(d))i(t,r)&&(a[t]=r);return a}function v(d){let i=[];for(;Object.prototype!==d;)i=i.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return i}function o(d){const i=[];for(const a of v(d))typeof d[a]=="function"&&i.push(a);return i}function m(d,i){const a=r=>function(){const n=Array.prototype.slice.call(arguments,0);return i(r,n)},t={};for(const r of d)t[r]=a(r);return t}function $(d,i){const a={};for(const[t,r]of Object.entries(d))a[t]=i(r,t);return a}}),define(Re[51],Ce([1,0,84]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$$j=D;var h;(function(T){function A(p){return p&&typeof p=="object"&&typeof p.id=="string"}T.isThemeColor=A})(h||(e.ThemeColor=h={}));function D(T){return{id:T}}var O;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function p(d){const i=A.exec(d.id);if(!i)return p(s.$0j.error);const[,a,t]=i,r=["codicon","codicon-"+a];return t&&r.push("codicon-modifier-"+t.substring(1)),r}T.asClassNameArray=p;function c(d){return p(d).join(" ")}T.asClassName=c;function I(d){return"."+p(d).join(".")}T.asCSSSelector=I;function E(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||h.isThemeColor(d.color))}T.isThemeIcon=E;const f=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function P(d){const i=f.exec(d);if(!i)return;const[,a]=i;return{id:a}}T.fromString=P;function v(d){return{id:d}}T.fromId=v;function o(d,i){let a=d.id;const t=a.lastIndexOf("~");return t!==-1&&(a=a.substring(0,t)),i&&(a=`${a}~${i}`),{id:a}}T.modify=o;function m(d){const i=d.id.lastIndexOf("~");if(i!==-1)return d.id.substring(i+1)}T.getModifier=m;function $(d,i){return d.id===i.id&&d.color?.id===i.color?.id}T.isEqual=$})(O||(e.ThemeIcon=O={}))}),define(Re[85],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$ff=h,e.$gf=D;var s;(function(O){O[O.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",O[O.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",O[O.MAX_UINT_8=255]="MAX_UINT_8",O[O.MAX_UINT_16=65535]="MAX_UINT_16",O[O.MAX_UINT_32=4294967295]="MAX_UINT_32",O[O.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(s||(e.Constants=s={}));function h(O){return O<0?0:O>s.MAX_UINT_8?s.MAX_UINT_8:O|0}function D(O){return O<0?0:O>s.MAX_UINT_32?s.MAX_UINT_32:O|0}}),define(Re[13],Ce([1,0,189,26,50,85]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=e.GraphemeBreakType=e.$9f=e.$1f=e.$Tf=e.$Sf=void 0,e.$hf=T,e.$if=p,e.$jf=I,e.$kf=E,e.$lf=f,e.$mf=P,e.$nf=v,e.$of=o,e.$pf=m,e.$qf=$,e.$rf=d,e.$sf=i,e.$tf=a,e.$uf=t,e.$vf=r,e.$wf=n,e.$xf=u,e.$yf=l,e.$zf=g,e.$Af=y,e.$Bf=k,e.$Cf=S,e.$Df=R,e.$Ef=C,e.$Ff=w,e.$Gf=b,e.$Hf=N,e.$If=L,e.$Jf=M,e.$Kf=z,e.$Lf=V,e.$Mf=F,e.$Nf=j,e.$Of=W,e.$Pf=J,e.$Qf=B,e.$Rf=U,e.$Uf=te,e.$Vf=me,e.$Wf=ce,e.$Xf=Y,e.$Yf=be,e.$Zf=we,e.$2f=$e,e.$3f=pe,e.$4f=Oe,e.$5f=Fe,e.$6f=Ze,e.$7f=xe,e.$8f=qe,e.$0f=Ne,e.$$f=H,e.$_f=G,e.$ag=Z,e.$bg=ee,e.$cg=ue,e.$dg=ye,e.$eg=Ae,e.$fg=ht;function T(re){return!re||typeof re!="string"?!0:re.trim().length===0}const A=/{(\d+)}/g;function p(re,...le){return le.length===0?re:re.replace(A,function(Se,de){const ke=parseInt(de,10);return isNaN(ke)||ke<0||ke>=le.length?Se:le[ke]})}const c=/{([^}]+)}/g;function I(re,le){return Object.keys(le).length===0?re:re.replace(c,(Se,de)=>le[de]??Se)}function E(re){return re.replace(/[<>"'&]/g,le=>{switch(le){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return le})}function f(re){return re.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}function P(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function v(re,le){let Se=0,de=re.indexOf(le);for(;de!==-1;)Se++,de=re.indexOf(le,de+le.length);return Se}function o(re,le,Se="\u2026"){return re.length<=le?re:`${re.substr(0,le)}${Se}`}function m(re,le,Se="\u2026"){if(re.length<=le)return re;const de=Math.ceil(le/2)-Se.length/2,ke=Math.floor(le/2)-Se.length/2;return`${re.substr(0,de)}${Se}${re.substr(re.length-ke)}`}function $(re,le=" "){const Se=d(re,le);return i(Se,le)}function d(re,le){if(!re||!le)return re;const Se=le.length;if(Se===0||re.length===0)return re;let de=0;for(;re.indexOf(le,de)===de;)de=de+Se;return re.substring(de)}function i(re,le){if(!re||!le)return re;const Se=le.length,de=re.length;if(Se===0||de===0)return re;let ke=de,ne=-1;for(;ne=re.lastIndexOf(le,ke-1),!(ne===-1||ne+Se!==ke);){if(ne===0)return"";ke=ne}return re.substring(0,ke)}function a(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(re){return re.replace(/\*/g,"")}function r(re,le,Se={}){if(!re)throw new Error("Cannot create regex from empty string");le||(re=P(re)),Se.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let de="";return Se.global&&(de+="g"),Se.matchCase||(de+="i"),Se.multiline&&(de+="m"),Se.unicode&&(de+="u"),new RegExp(re,de)}function n(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function u(re){return re.split(/\r\n|\r|\n/)}function l(re){const le=[],Se=re.split(/(\r\n|\r|\n)/);for(let de=0;de<Math.ceil(Se.length/2);de++)le.push(Se[2*de]+(Se[2*de+1]??""));return le}function g(re){for(let le=0,Se=re.length;le<Se;le++){const de=re.charCodeAt(le);if(de!==h.CharCode.Space&&de!==h.CharCode.Tab)return le}return-1}function y(re,le=0,Se=re.length){for(let de=le;de<Se;de++){const ke=re.charCodeAt(de);if(ke!==h.CharCode.Space&&ke!==h.CharCode.Tab)return re.substring(le,de)}return re.substring(le,Se)}function k(re,le=re.length-1){for(let Se=le;Se>=0;Se--){const de=re.charCodeAt(Se);if(de!==h.CharCode.Space&&de!==h.CharCode.Tab)return Se}return-1}function S(re,le,Se){const de=[];let ke=0;for(const ne of re.matchAll(le)){if(de.push(re.slice(ke,ne.index)),ne.index===void 0)throw new Error("match.index should be defined");ke=ne.index+ne[0].length,de.push(Se(ne[0],...ne.slice(1),ne.index,re,ne.groups))}return de.push(re.slice(ke)),Promise.all(de).then(ne=>ne.join(""))}function R(re,le){return re<le?-1:re>le?1:0}function C(re,le,Se=0,de=re.length,ke=0,ne=le.length){for(;Se<de&&ke<ne;Se++,ke++){const Ke=re.charCodeAt(Se),Xe=le.charCodeAt(ke);if(Ke<Xe)return-1;if(Ke>Xe)return 1}const X=de-Se,Pe=ne-ke;return X<Pe?-1:X>Pe?1:0}function w(re,le){return b(re,le,0,re.length,0,le.length)}function b(re,le,Se=0,de=re.length,ke=0,ne=le.length){for(;Se<de&&ke<ne;Se++,ke++){let Ke=re.charCodeAt(Se),Xe=le.charCodeAt(ke);if(Ke===Xe)continue;if(Ke>=128||Xe>=128)return C(re.toLowerCase(),le.toLowerCase(),Se,de,ke,ne);L(Ke)&&(Ke-=32),L(Xe)&&(Xe-=32);const st=Ke-Xe;if(st!==0)return st}const X=de-Se,Pe=ne-ke;return X<Pe?-1:X>Pe?1:0}function N(re){return re>=h.CharCode.Digit0&&re<=h.CharCode.Digit9}function L(re){return re>=h.CharCode.a&&re<=h.CharCode.z}function M(re){return re>=h.CharCode.A&&re<=h.CharCode.Z}function z(re,le){return re.length===le.length&&b(re,le)===0}function V(re,le){const Se=le.length;return le.length>re.length?!1:b(re,le,0,Se)===0}function F(re,le){const Se=Math.min(re.length,le.length);let de;for(de=0;de<Se;de++)if(re.charCodeAt(de)!==le.charCodeAt(de))return de;return Se}function j(re,le){const Se=Math.min(re.length,le.length);let de;const ke=re.length-1,ne=le.length-1;for(de=0;de<Se;de++)if(re.charCodeAt(ke-de)!==le.charCodeAt(ne-de))return de;return Se}function W(re){return 55296<=re&&re<=56319}function J(re){return 56320<=re&&re<=57343}function B(re,le){return(re-55296<<10)+(le-56320)+65536}function U(re,le,Se){const de=re.charCodeAt(Se);if(W(de)&&Se+1<le){const ke=re.charCodeAt(Se+1);if(J(ke))return B(de,ke)}return de}function _(re,le){const Se=re.charCodeAt(le-1);if(J(Se)&&le>1){const de=re.charCodeAt(le-2);if(W(de))return B(de,Se)}return Se}class x{get offset(){return this.e}constructor(le,Se=0){this.c=le,this.d=le.length,this.e=Se}setOffset(le){this.e=le}prevCodePoint(){const le=_(this.c,this.e);return this.e-=le>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,le}nextCodePoint(){const le=U(this.c,this.d,this.e);return this.e+=le>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,le}eol(){return this.e>=this.d}}e.$Sf=x;class oe{get offset(){return this.c.offset}constructor(le,Se=0){this.c=new x(le,Se)}nextGraphemeLength(){const le=nt.getInstance(),Se=this.c,de=Se.offset;let ke=le.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const ne=Se.offset,X=le.getGraphemeBreakType(Se.nextCodePoint());if(Ve(ke,X)){Se.setOffset(ne);break}ke=X}return Se.offset-de}prevGraphemeLength(){const le=nt.getInstance(),Se=this.c,de=Se.offset;let ke=le.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const ne=Se.offset,X=le.getGraphemeBreakType(Se.prevCodePoint());if(Ve(X,ke)){Se.setOffset(ne);break}ke=X}return de-Se.offset}eol(){return this.c.eol()}}e.$Tf=oe;function te(re,le){return new oe(re,le).nextGraphemeLength()}function me(re,le){return new oe(re,le).prevGraphemeLength()}function ce(re,le){le>0&&J(re.charCodeAt(le))&&le--;const Se=le+te(re,le);return[Se-me(re,Se),Se]}function Y(re){const le=new oe(re);let Se=0;for(;!le.eol();)Se++,le.nextGraphemeLength();return Se}let q;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function be(re){return q||(q=se()),q.test(re)}const ae=/^[\t\n\r\x20-\x7E]*$/;function we(re){return ae.test(re)}e.$1f=/[\u2028\u2029]/;function $e(re){return e.$1f.test(re)}function pe(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function Oe(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function Fe(re,le,Se=""){const de=re.trimStart();if(de.length<le)return de;const ke=/\b/g;let ne=0;for(;ke.test(de)&&!(de.length-ke.lastIndex<le);)ne=ke.lastIndex,ke.lastIndex+=1;return ne===0?de:Se+de.substring(ne).trimStart()}const He=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Ze(re){let le=0;for(const Se of re.matchAll(He))le!==Se.index&&(yield{isCode:!1,str:re.substring(le,Se.index)}),yield{isCode:!0,str:Se[0]},le=Se.index+Se[0].length;le!==re.length&&(yield{isCode:!1,str:re.substring(le)})}function xe(re){return re&&(re=re.replace(He,"")),re}const je=/\\\[.*?\\\]/g;function qe(re){return xe(re).replace(je,"")}e.$9f=String.fromCharCode(h.CharCode.UTF8_BOM);function Ne(re){return!!(re&&re.length>0&&re.charCodeAt(0)===h.CharCode.UTF8_BOM)}function H(re){return Ne(re)?re.substr(1):re}function G(re,le){if(!re||!le||re.length<le.length)return!1;const Se=le.length,de=re.toLowerCase();let ke=0,ne=-1;for(;ke<Se;){const X=de.indexOf(le[ke],ne+1);if(X<0)return!1;ne=X,ke++}return!0}function Z(re,le=!1){return re?(le&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function ee(re){return re.charAt(0).toUpperCase()+re.slice(1)}function ue(re,le=1){if(le===0)return"";let Se=-1;do Se=re.indexOf(`
`,Se+1),le--;while(le>0&&Se>=0);return Se===-1?re:(re[Se-1]==="\r"&&Se--,re.substr(0,Se))}function ye(re){const le=h.CharCode.Z-h.CharCode.A+1;return re=re%(2*le),re<le?String.fromCharCode(h.CharCode.a+re):String.fromCharCode(h.CharCode.A+re-le)}function Ae(re){return nt.getInstance().getGraphemeBreakType(re)}function Ve(re,le){return re===Je.Other?le!==Je.Extend&&le!==Je.SpacingMark:re===Je.CR&&le===Je.LF?!1:re===Je.Control||re===Je.CR||re===Je.LF||le===Je.Control||le===Je.CR||le===Je.LF?!0:!(re===Je.L&&(le===Je.L||le===Je.V||le===Je.LV||le===Je.LVT)||(re===Je.LV||re===Je.V)&&(le===Je.V||le===Je.T)||(re===Je.LVT||re===Je.T)&&le===Je.T||le===Je.Extend||le===Je.ZWJ||le===Je.SpacingMark||re===Je.Prepend||re===Je.ZWJ&&le===Je.Extended_Pictographic||re===Je.Regional_Indicator&&le===Je.Regional_Indicator)}var Je;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Je||(e.GraphemeBreakType=Je={}));class nt{static{this.c=null}static getInstance(){return nt.c||(nt.c=new nt),nt.c}constructor(){this.d=ot()}getGraphemeBreakType(le){if(le<32)return le===h.CharCode.LineFeed?Je.LF:le===h.CharCode.CarriageReturn?Je.CR:Je.Control;if(le<127)return Je.Other;const Se=this.d,de=Se.length/3;let ke=1;for(;ke<=de;)if(le<Se[3*ke])ke=2*ke;else if(le>Se[3*ke+1])ke=2*ke+1;else return Se[3*ke+2];return Je.Other}}function ot(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ht(re,le){if(re===0)return 0;const Se=at(re,le);if(Se!==void 0)return Se;const de=new x(le,re);return de.prevCodePoint(),de.offset}function at(re,le){const Se=new x(le,re);let de=Se.prevCodePoint();for(;lt(de)||de===pt.emojiVariantSelector||de===pt.enclosingKeyCap;){if(Se.offset===0)return;de=Se.prevCodePoint()}if(!Oe(de))return;let ke=Se.offset;return ke>0&&Se.prevCodePoint()===pt.zwj&&(ke=Se.offset),ke}function lt(re){return 127995<=re&&re<=127999}var pt;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(pt||(pt={})),e.$gg="\xA0";class it{static{this.c=new D.$Y(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new s.$df({getCacheKey:JSON.stringify},le=>{function Se(st){const dt=new Map;for(let gt=0;gt<st.length;gt+=2)dt.set(st[gt],st[gt+1]);return dt}function de(st,dt){const gt=new Map(st);for(const[kt,At]of dt)gt.set(kt,At);return gt}function ke(st,dt){if(!st)return dt;const gt=new Map;for(const[kt,At]of st)dt.has(kt)&&gt.set(kt,At);return gt}const ne=this.c.value;let X=le.filter(st=>!st.startsWith("_")&&st in ne);X.length===0&&(X=["_default"]);let Pe;for(const st of X){const dt=Se(ne[st]);Pe=ke(Pe,dt)}const Ke=Se(ne._common),Xe=de(Ke,Pe);return new it(Xe)})}static getInstance(le){return it.d.get(Array.from(le))}static{this.e=new D.$Y(()=>Object.keys(it.c.value).filter(le=>!le.startsWith("_")))}static getLocales(){return it.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}containsAmbiguousCharacter(le){for(let Se=0;Se<le.length;Se++){const de=le.codePointAt(Se);if(typeof de=="number"&&this.isAmbiguous(de))return!0}return!1}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hg=it;class Ie{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ie.c())),this.d}static isInvisibleCharacter(le){return Ie.e().has(le)}static containsInvisibleCharacter(le){for(let Se=0;Se<le.length;Se++){const de=le.codePointAt(Se);if(typeof de=="number"&&Ie.isInvisibleCharacter(de))return!0}return!1}static get codePoints(){return Ie.e()}}e.$ig=Ie}),define(Re[137],Ce([1,0,26,28,184,13]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.FuzzyScore=e.$Nk=e.$Mk=void 0,e.or=T,e.$Ok=p,e.$Pk=c,e.$Qk=f,e.$Rk=k,e.$Sk=S,e.$Tk=L,e.$Uk=M,e.$Vk=z,e.$Wk=V,e.$Xk=se,e.$Zk=$e,e.$1k=Fe,e.$2k=He,O=Ue(O);function T(...je){return function(qe,Ne){for(let H=0,G=je.length;H<G;H++){const Z=je[H](qe,Ne);if(Z)return Z}return null}}e.$Mk=A.bind(void 0,!1),e.$Nk=A.bind(void 0,!0);function A(je,qe,Ne){if(!Ne||Ne.length<qe.length)return null;let H;return je?H=O.$Lf(Ne,qe):H=Ne.indexOf(qe)===0,H?qe.length>0?[{start:0,end:qe.length}]:[]:null}function p(je,qe){const Ne=qe.toLowerCase().indexOf(je.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+je.length}]}function c(je,qe){return I(je.toLowerCase(),qe.toLowerCase(),0,0)}function I(je,qe,Ne,H){if(Ne===je.length)return[];if(H===qe.length)return null;if(je[Ne]===qe[H]){let G=null;return(G=I(je,qe,Ne+1,H+1))?t({start:H,end:H+1},G):null}return I(je,qe,Ne,H+1)}function E(je){return s.CharCode.a<=je&&je<=s.CharCode.z}function f(je){return s.CharCode.A<=je&&je<=s.CharCode.Z}function P(je){return s.CharCode.Digit0<=je&&je<=s.CharCode.Digit9}function v(je){return je===s.CharCode.Space||je===s.CharCode.Tab||je===s.CharCode.LineFeed||je===s.CharCode.CarriageReturn}const o=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(je=>o.add(je.charCodeAt(0)));function m(je){return v(je)||o.has(je)}function $(je,qe){return je===qe||m(je)&&m(qe)}const d=new Map;function i(je){if(d.has(je))return d.get(je);let qe;const Ne=(0,D.$Kk)(je);return Ne&&(qe=Ne),d.set(je,qe),qe}function a(je){return E(je)||f(je)||P(je)}function t(je,qe){return qe.length===0?qe=[je]:je.end===qe[0].start?qe[0].start=je.start:qe.unshift(je),qe}function r(je,qe){for(let Ne=qe;Ne<je.length;Ne++){const H=je.charCodeAt(Ne);if(f(H)||P(H)||Ne>0&&!a(je.charCodeAt(Ne-1)))return Ne}return je.length}function n(je,qe,Ne,H){if(Ne===je.length)return[];if(H===qe.length)return null;if(je[Ne]!==qe[H].toLowerCase())return null;{let G=null,Z=H+1;for(G=n(je,qe,Ne+1,H+1);!G&&(Z=r(qe,Z))<qe.length;)G=n(je,qe,Ne+1,Z),Z++;return G===null?null:t({start:H,end:H+1},G)}}function u(je){let qe=0,Ne=0,H=0,G=0,Z=0;for(let Ve=0;Ve<je.length;Ve++)Z=je.charCodeAt(Ve),f(Z)&&qe++,E(Z)&&Ne++,a(Z)&&H++,P(Z)&&G++;const ee=qe/je.length,ue=Ne/je.length,ye=H/je.length,Ae=G/je.length;return{upperPercent:ee,lowerPercent:ue,alphaPercent:ye,numericPercent:Ae}}function l(je){const{upperPercent:qe,lowerPercent:Ne}=je;return Ne===0&&qe>.6}function g(je){const{upperPercent:qe,lowerPercent:Ne,alphaPercent:H,numericPercent:G}=je;return Ne>.2&&qe<.8&&H>.6&&G<.2}function y(je){let qe=0,Ne=0,H=0,G=0;for(let Z=0;Z<je.length;Z++)H=je.charCodeAt(Z),f(H)&&qe++,E(H)&&Ne++,v(H)&&G++;return(qe===0||Ne===0)&&G===0?je.length<=30:qe<=5}function k(je,qe){if(!qe||(qe=qe.trim(),qe.length===0)||!y(je))return null;qe.length>60&&(qe=qe.substring(0,60));const Ne=u(qe);if(!g(Ne)){if(!l(Ne))return null;qe=qe.toLowerCase()}let H=null,G=0;for(je=je.toLowerCase();G<qe.length&&(H=n(je,qe,0,G))===null;)G=r(qe,G+1);return H}function S(je,qe,Ne=!1){if(!qe||qe.length===0)return null;let H=null,G=0;for(je=je.toLowerCase(),qe=qe.toLowerCase();G<qe.length&&(H=R(je,qe,0,G,Ne),H===null);)G=C(qe,G+1);return H}function R(je,qe,Ne,H,G){let Z=0;if(Ne===je.length)return[];if(H===qe.length)return null;if(!$(je.charCodeAt(Ne),qe.charCodeAt(H))){const ye=i(je.charCodeAt(Ne));if(!ye)return null;for(let Ae=0;Ae<ye.length;Ae++)if(!$(ye[Ae],qe.charCodeAt(H+Ae)))return null;Z+=ye.length-1}let ee=null,ue=H+Z+1;if(ee=R(je,qe,Ne+1,ue,G),!G)for(;!ee&&(ue=C(qe,ue))<qe.length;)ee=R(je,qe,Ne+1,ue,G),ue++;if(!ee)return null;if(je.charCodeAt(Ne)!==qe.charCodeAt(H)){const ye=i(je.charCodeAt(Ne));if(!ye)return ee;for(let Ae=0;Ae<ye.length;Ae++)if(ye[Ae]!==qe.charCodeAt(H+Ae))return ee}return t({start:H,end:H+Z+1},ee)}function C(je,qe){for(let Ne=qe;Ne<je.length;Ne++)if(m(je.charCodeAt(Ne))||Ne>0&&m(je.charCodeAt(Ne-1)))return Ne;return je.length}const w=T(e.$Nk,k,p),b=T(e.$Nk,k,c),N=new h.$Ic(1e4);function L(je,qe,Ne=!1){if(typeof je!="string"||typeof qe!="string")return null;let H=N.get(je);H||(H=new RegExp(O.$tf(je),"i"),N.set(je,H));const G=H.exec(qe);return G?[{start:G.index,end:G.index+G[0].length}]:Ne?b(je,qe):w(je,qe)}function M(je,qe){const Ne=$e(je,je.toLowerCase(),0,qe,qe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?V(Ne):null}function z(je,qe,Ne,H,G,Z){const ee=Math.min(13,je.length);for(;Ne<ee;Ne++){const ue=$e(je,qe,Ne,H,G,Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ue)return ue}return[0,Z]}function V(je){if(typeof je>"u")return[];const qe=[],Ne=je[1];for(let H=je.length-1;H>1;H--){const G=je[H]+Ne,Z=qe[qe.length-1];Z&&Z.end===G?Z.end=G+1:qe.push({start:G,end:G+1})}return qe}const F=128;function j(){const je=[],qe=[];for(let Ne=0;Ne<=F;Ne++)qe[Ne]=0;for(let Ne=0;Ne<=F;Ne++)je.push(qe.slice(0));return je}function W(je){const qe=[];for(let Ne=0;Ne<=je;Ne++)qe[Ne]=0;return qe}const J=W(2*F),B=W(2*F),U=j(),_=j(),x=j(),oe=!1;function te(je,qe,Ne,H,G){function Z(ue,ye,Ae=" "){for(;ue.length<ye;)ue=Ae+ue;return ue}let ee=` |   |${H.split("").map(ue=>Z(ue,3)).join("|")}
`;for(let ue=0;ue<=Ne;ue++)ue===0?ee+=" |":ee+=`${qe[ue-1]}|`,ee+=je[ue].slice(0,G+1).map(ye=>Z(ye.toString(),3)).join("|")+`
`;return ee}function me(je,qe,Ne,H){je=je.substr(qe),Ne=Ne.substr(H),console.log(te(_,je,je.length,Ne,Ne.length)),console.log(te(x,je,je.length,Ne,Ne.length)),console.log(te(U,je,je.length,Ne,Ne.length))}function ce(je,qe){if(qe<0||qe>=je.length)return!1;const Ne=je.codePointAt(qe);switch(Ne){case s.CharCode.Underline:case s.CharCode.Dash:case s.CharCode.Period:case s.CharCode.Space:case s.CharCode.Slash:case s.CharCode.Backslash:case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.Colon:case s.CharCode.DollarSign:case s.CharCode.LessThan:case s.CharCode.GreaterThan:case s.CharCode.OpenParen:case s.CharCode.CloseParen:case s.CharCode.OpenSquareBracket:case s.CharCode.CloseSquareBracket:case s.CharCode.OpenCurlyBrace:case s.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$4f(Ne)}}function Y(je,qe){if(qe<0||qe>=je.length)return!1;switch(je.charCodeAt(qe)){case s.CharCode.Space:case s.CharCode.Tab:return!0;default:return!1}}function q(je,qe,Ne){return qe[je]!==Ne[je]}function se(je,qe,Ne,H,G,Z,ee=!1){for(;qe<Ne&&G<Z;)je[qe]===H[G]&&(ee&&(J[qe]=G),qe+=1),G+=1;return qe===Ne}var be;(function(je){je[je.Diag=1]="Diag",je[je.Left=2]="Left",je[je.LeftLeft=3]="LeftLeft"})(be||(be={}));var ae;(function(je){je.Default=[-100,0];function qe(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}je.isDefault=qe})(ae||(e.FuzzyScore=ae={}));class we{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(qe,Ne){this.firstMatchCanBeWeak=qe,this.boostFullMatch=Ne}}e.$Yk=we;function $e(je,qe,Ne,H,G,Z,ee=we.default){const ue=je.length>F?F:je.length,ye=H.length>F?F:H.length;if(Ne>=ue||Z>=ye||ue-Ne>ye-Z||!se(qe,Ne,ue,G,Z,ye,!0))return;pe(ue,ye,Ne,Z,qe,G);let Ae=1,Ve=1,Je=Ne,nt=Z;const ot=[!1];for(Ae=1,Je=Ne;Je<ue;Ae++,Je++){const it=J[Je],Ie=B[Je],re=Je+1<ue?B[Je+1]:ye;for(Ve=it-Z+1,nt=it;nt<re;Ve++,nt++){let le=Number.MIN_SAFE_INTEGER,Se=!1;nt<=Ie&&(le=Oe(je,qe,Je,Ne,H,G,nt,ye,Z,U[Ae-1][Ve-1]===0,ot));let de=0;le!==Number.MAX_SAFE_INTEGER&&(Se=!0,de=le+_[Ae-1][Ve-1]);const ke=nt>it,ne=ke?_[Ae][Ve-1]+(U[Ae][Ve-1]>0?-5:0):0,X=nt>it+1&&U[Ae][Ve-1]>0,Pe=X?_[Ae][Ve-2]+(U[Ae][Ve-2]>0?-5:0):0;if(X&&(!ke||Pe>=ne)&&(!Se||Pe>=de))_[Ae][Ve]=Pe,x[Ae][Ve]=be.LeftLeft,U[Ae][Ve]=0;else if(ke&&(!Se||ne>=de))_[Ae][Ve]=ne,x[Ae][Ve]=be.Left,U[Ae][Ve]=0;else if(Se)_[Ae][Ve]=de,x[Ae][Ve]=be.Diag,U[Ae][Ve]=U[Ae-1][Ve-1]+1;else throw new Error("not possible")}}if(oe&&me(je,Ne,H,Z),!ot[0]&&!ee.firstMatchCanBeWeak)return;Ae--,Ve--;const ht=[_[Ae][Ve],Z];let at=0,lt=0;for(;Ae>=1;){let it=Ve;do{const Ie=x[Ae][it];if(Ie===be.LeftLeft)it=it-2;else if(Ie===be.Left)it=it-1;else break}while(it>=1);at>1&&qe[Ne+Ae-1]===G[Z+Ve-1]&&!q(it+Z-1,H,G)&&at+1>U[Ae][it]&&(it=Ve),it===Ve?at++:at=1,lt||(lt=it),Ae--,Ve=it-1,ht.push(Ve)}ye-Z===ue&&ee.boostFullMatch&&(ht[0]+=2);const pt=lt-ue;return ht[0]-=pt,ht}function pe(je,qe,Ne,H,G,Z){let ee=je-1,ue=qe-1;for(;ee>=Ne&&ue>=H;)G[ee]===Z[ue]&&(B[ee]=ue,ee--),ue--}function Oe(je,qe,Ne,H,G,Z,ee,ue,ye,Ae,Ve){if(qe[Ne]!==Z[ee])return Number.MIN_SAFE_INTEGER;let Je=1,nt=!1;return ee===Ne-H?Je=je[Ne]===G[ee]?7:5:q(ee,G,Z)&&(ee===0||!q(ee-1,G,Z))?(Je=je[Ne]===G[ee]?7:5,nt=!0):ce(Z,ee)&&(ee===0||!ce(Z,ee-1))?Je=5:(ce(Z,ee-1)||Y(Z,ee-1))&&(Je=5,nt=!0),Je>1&&Ne===H&&(Ve[0]=!0),nt||(nt=q(ee,G,Z)||ce(Z,ee-1)||Y(Z,ee-1)),Ne===H?ee>ye&&(Je-=nt?3:5):Ae?Je+=nt?2:0:Je+=nt?0:1,ee+1===ue&&(Je-=nt?3:5),Je}function Fe(je,qe,Ne,H,G,Z,ee){return Ze(je,qe,Ne,H,G,Z,!0,ee)}function He(je,qe,Ne,H,G,Z,ee){return Ze(je,qe,Ne,H,G,Z,!1,ee)}function Ze(je,qe,Ne,H,G,Z,ee,ue){let ye=$e(je,qe,Ne,H,G,Z,ue);if(ye&&!ee)return ye;if(je.length>=3){const Ae=Math.min(7,je.length-1);for(let Ve=Ne+1;Ve<Ae;Ve++){const Je=xe(je,Ve);if(Je){const nt=$e(Je,Je.toLowerCase(),Ne,H,G,Z,ue);nt&&(nt[0]-=3,(!ye||nt[0]>ye[0])&&(ye=nt))}}}return ye}function xe(je,qe){if(qe+1>=je.length)return;const Ne=je[qe],H=je[qe+1];if(Ne!==H)return je.slice(0,qe)+H+Ne+je.slice(qe+2)}}),define(Re[61],Ce([1,0,13]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Cj=void 0,e.$yj=h,e.$zj=D,e.$Aj=O,e.$Bj=A,e.$Dj=o,s=Ue(s);function h($){return D($,0)}function D($,d){switch(typeof $){case"object":return $===null?O(349,d):Array.isArray($)?p($,d):c($,d);case"string":return A($,d);case"boolean":return T($,d);case"number":return O($,d);case"undefined":return O(937,d);default:return O(617,d)}}function O($,d){return(d<<5)-d+$|0}function T($,d){return O($?433:863,d)}function A($,d){d=O(149417,d);for(let i=0,a=$.length;i<a;i++)d=O($.charCodeAt(i),d);return d}function p($,d){return d=O(104579,d),$.reduce((i,a)=>D(a,i),d)}function c($,d){return d=O(181387,d),Object.keys($).sort().reduce((i,a)=>(i=A(a,i),D($[a],i)),d)}class I{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=D(d,this.g),this.g}}e.$Cj=I;var E;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function f($,d,i=32){const a=i-d,t=~((1<<a)-1);return($<<d|(t&$)>>>a)>>>0}function P($,d=0,i=$.byteLength,a=0){for(let t=0;t<i;t++)$[d+t]=a}function v($,d,i="0"){for(;$.length<d;)$=i+$;return $}function o($,d=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(i=>i.toString(16).padStart(2,"0")).join(""):v(($>>>0).toString(16),d/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(E.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const i=d.length;if(i===0)return;const a=this.p;let t=this.r,r=this.u,n,u;for(r!==0?(n=r,u=-1,r=0):(n=d.charCodeAt(0),u=0);;){let l=n;if(s.$Of(n))if(u+1<i){const g=d.charCodeAt(u+1);s.$Pf(g)?(u++,l=s.$Qf(n,g)):l=E.UNICODE_REPLACEMENT}else{r=n;break}else s.$Pf(n)&&(l=E.UNICODE_REPLACEMENT);if(t=this.w(a,t,l),u++,u<i)n=d.charCodeAt(u);else break}this.r=t,this.u=r}w(d,i,a){return a<128?d[i++]=a:a<2048?(d[i++]=192|(a&1984)>>>6,d[i++]=128|(a&63)>>>0):a<65536?(d[i++]=224|(a&61440)>>>12,d[i++]=128|(a&4032)>>>6,d[i++]=128|(a&63)>>>0):(d[i++]=240|(a&1835008)>>>18,d[i++]=128|(a&258048)>>>12,d[i++]=128|(a&4032)>>>6,d[i++]=128|(a&63)>>>0),i>=E.BLOCK_SIZE&&(this.y(),i-=E.BLOCK_SIZE,this.t+=E.BLOCK_SIZE,d[0]=d[E.BLOCK_SIZE+0],d[1]=d[E.BLOCK_SIZE+1],d[2]=d[E.BLOCK_SIZE+2]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,E.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),o(this.h)+o(this.l)+o(this.m)+o(this.n)+o(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=m.g,i=this.q;for(let k=0;k<64;k+=4)d.setUint32(k,i.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)d.setUint32(k,f(d.getUint32(k-12,!1)^d.getUint32(k-32,!1)^d.getUint32(k-56,!1)^d.getUint32(k-64,!1),1),!1);let a=this.h,t=this.l,r=this.m,n=this.n,u=this.o,l,g,y;for(let k=0;k<80;k++)k<20?(l=t&r|~t&n,g=1518500249):k<40?(l=t^r^n,g=1859775393):k<60?(l=t&r|t&n|r&n,g=2400959708):(l=t^r^n,g=3395469782),y=f(a,5)+l+u+g+d.getUint32(k*4,!1)&4294967295,u=n,n=r,r=f(t,30),t=a,a=y;this.h=this.h+a&4294967295,this.l=this.l+t&4294967295,this.m=this.m+r&4294967295,this.n=this.n+n&4294967295,this.o=this.o+u&4294967295}}e.$Ej=m}),define(Re[138],Ce([1,0,137,13,51]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=p,e.$4k=I,e.$5k=f,e.$6k=P,e.$7k=o,e.$8k=m;const O="$(",T=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${T.source}`,"g");function p($){return $.replace(A,(d,i)=>i?d:`\\${d}`)}const c=new RegExp(`\\\\${T.source}`,"g");function I($){return $.replace(c,d=>`\\${d}`)}const E=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function f($){return $.indexOf(O)===-1?$:$.replace(E,(d,i,a,t)=>a?d:i||t||"")}function P($){return $?$.replace(/\$\((.*?)\)/g,(d,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function o($){v.lastIndex=0;let d="";const i=[];let a=0;for(;;){const t=v.lastIndex,r=v.exec($),n=$.substring(t,r?.index);if(n.length>0){d+=n;for(let u=0;u<n.length;u++)i.push(a)}if(!r)break;a+=r[0].length}return{text:d,iconOffsets:i}}function m($,d,i=!1){const{text:a,iconOffsets:t}=d;if(!t||t.length===0)return(0,s.$Tk)($,a,i);const r=(0,h.$rf)(a," "),n=a.length-r.length,u=(0,s.$Tk)($,r,i);if(u)for(const l of u){const g=t[l.start+n]+n;l.start+=g,l.end+=g}return u}}),define(Re[45],Ce([1,0,13]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),s=Ue(s);var h;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(h||(h={})),function(D){const O="error",T="warning",A="warn",p="info",c="ignore";function I(f){return f?s.$Kf(O,f)?D.Error:s.$Kf(T,f)||s.$Kf(A,f)?D.Warning:s.$Kf(p,f)?D.Info:D.Ignore:D.Ignore}D.fromValue=I;function E(f){switch(f){case D.Error:return O;case D.Warning:return T;case D.Info:return p;default:return c}}D.toString=E}(h||(h={})),e.default=h}),define(Re[62],Ce([1,0,18,26,13]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class O{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const o=v.charCodeAt(0),m=this.b.charCodeAt(this.c);return o-m}value(){return this.b[this.c]}}e.$Mi=O;class T{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,D.$Ef)(v,this.b,0,v.length,this.c,this.d):(0,D.$Gf)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ni=T;class A{constructor(v=!0,o=!0){this.f=v,this.g=o}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let o=v.length-1;o>=0;o--,this.c--){const m=this.b.charCodeAt(o);if(!(m===h.CharCode.Slash||this.f&&m===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const o=this.b.charCodeAt(this.e);if(o===h.CharCode.Slash||this.f&&o===h.CharCode.Backslash)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,D.$Ef)(v,this.b,0,v.length,this.d,this.e):(0,D.$Gf)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Oi=A;var p;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(v,o){this.f=v,this.g=o,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new A(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(p.Path)),this.g(v)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===p.Scheme)return(0,D.$Ff)(v,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,D.$Ff)(v,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(v);if(this.d[this.e]===p.Query)return(0,D.$Df)(v,this.c.query);if(this.d[this.e]===p.Fragment)return(0,D.$Df)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Pi=c;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(E||(E={}));class f{static forUris(v=()=>!1,o=()=>!1){return new f(new c(v,o))}static forPaths(v=!1){return new f(new A(void 0,!v))}static forStrings(){return new f(new O)}static forConfigKeys(){return new f(new T)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,o){if(o){const m=o.slice(0);(0,s.$1b)(m);for(const $ of m)this.set($,v)}else{const m=v.slice(0);(0,s.$1b)(m);for(const $ of m)this.set($[0],$[1])}}set(v,o){const m=this.b.reset(v);let $;this.c||(this.c=new I,this.c.segment=m.value());const d=[];for($=this.c;;){const a=m.cmp($.segment);if(a>0)$.left||($.left=new I,$.left.segment=m.value()),d.push([E.Left,$]),$=$.left;else if(a<0)$.right||($.right=new I,$.right.segment=m.value()),d.push([E.Right,$]),$=$.right;else if(m.hasNext())m.next(),$.mid||($.mid=new I,$.mid.segment=m.value()),d.push([E.Mid,$]),$=$.mid;else break}const i=$.value;$.value=o,$.key=v;for(let a=d.length-1;a>=0;a--){const t=d[a][1];t.updateHeight();const r=t.balanceFactor();if(r<-1||r>1){const n=d[a][0],u=d[a+1][0];if(n===E.Right&&u===E.Right)d[a][1]=t.rotateLeft();else if(n===E.Left&&u===E.Left)d[a][1]=t.rotateRight();else if(n===E.Right&&u===E.Left)t.right=d[a+1][1]=d[a+1][1].rotateRight(),d[a][1]=t.rotateLeft();else if(n===E.Left&&u===E.Right)t.left=d[a+1][1]=d[a+1][1].rotateLeft(),d[a][1]=t.rotateRight();else throw new Error;if(a>0)switch(d[a-1][0]){case E.Left:d[a-1][1].left=d[a][1];break;case E.Right:d[a-1][1].right=d[a][1];break;case E.Mid:d[a-1][1].mid=d[a][1];break}else this.c=d[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const o=this.b.reset(v);let m=this.c;for(;m;){const $=o.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(o.hasNext())o.next(),m=m.mid;else break}return m}has(v){const o=this.d(v);return!(o?.value===void 0&&o?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,o){const m=this.b.reset(v),$=[];let d=this.c;for(;d;){const i=m.cmp(d.segment);if(i>0)$.push([E.Left,d]),d=d.left;else if(i<0)$.push([E.Right,d]),d=d.right;else if(m.hasNext())m.next(),$.push([E.Mid,d]),d=d.mid;else break}if(d){if(o?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const i=this.f(d.right);if(i.key){const{key:a,value:t,segment:r}=i;this.e(i.key,!1),d.key=a,d.value=t,d.segment=r}}else{const i=d.left??d.right;if($.length>0){const[a,t]=$[$.length-1];switch(a){case E.Left:t.left=i;break;case E.Mid:t.mid=i;break;case E.Right:t.right=i;break}}else this.c=i}for(let i=$.length-1;i>=0;i--){const a=$[i][1];a.updateHeight();const t=a.balanceFactor();if(t>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),$[i][1]=a.rotateLeft()):t<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),$[i][1]=a.rotateRight()),i>0)switch($[i-1][0]){case E.Left:$[i-1][1].left=$[i][1];break;case E.Right:$[i-1][1].right=$[i][1];break;case E.Mid:$[i-1][1].mid=$[i][1];break}else this.c=$[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const o=this.b.reset(v);let m=this.c,$;for(;m;){const d=o.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(o.hasNext())o.next(),$=m.value||$,m=m.mid;else break}return m&&m.value||$}findSuperstr(v){return this.g(v,!1)}g(v,o){const m=this.b.reset(v);let $=this.c;for(;$;){const d=m.cmp($.segment);if(d>0)$=$.left;else if(d<0)$=$.right;else if(m.hasNext())m.next(),$=$.mid;else return $.mid?this.h($.mid):o?$.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[o,m]of this)v(m,o)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const o=[];return this.j(v,o),o[Symbol.iterator]()}j(v,o){v&&(v.left&&this.j(v.left,o),v.value&&o.push([v.key,v.value]),v.mid&&this.j(v.mid,o),v.right&&this.j(v.right,o))}_isBalanced(){const v=o=>{if(!o)return!0;const m=o.balanceFactor();return m<-1||m>1?!1:v(o.left)&&v(o.right)};return v(this.c)}}e.$Qi=f}),define(Re[31],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=void 0,e.$6g=h;const s=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(D){return s.test(D)}e.$7g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(A){for(let p=0;p<A.length;p++)A[p]=Math.floor(Math.random()*256);return A};const O=new Uint8Array(16),T=[];for(let A=0;A<256;A++)T.push(A.toString(16).padStart(2,"0"));return function(){D(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let p=0,c="";return c+=T[O[p++]],c+=T[O[p++]],c+=T[O[p++]],c+=T[O[p++]],c+="-",c+=T[O[p++]],c+=T[O[p++]],c+="-",c+=T[O[p++]],c+=T[O[p++]],c+="-",c+=T[O[p++]],c+=T[O[p++]],c+="-",c+=T[O[p++]],c+=T[O[p++]],c+=T[O[p++]],c+=T[O[p++]],c+=T[O[p++]],c+=T[O[p++]],c}}()}),define(Re[193],Ce([1,0,18,40,31]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Du=e.$Bu=void 0,e.$zu=O,e.$Au=T,e.$Cu=c;function O(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function T(E,f,P){const v={id:(0,D.$7g)(),name:E,uri:f,data:P};return{asString:async()=>"",asFile:()=>v,value:void 0}}class A{constructor(){this.a=new Map}get size(){let f=0;for(const P of this.a)f++;return f}has(f){return this.a.has(this.b(f))}matches(f){const P=[...this.a.keys()];return h.Iterable.some(this,([v,o])=>o.asFile())&&P.push("files"),I(p(f),P)}get(f){return this.a.get(this.b(f))?.[0]}append(f,P){const v=this.a.get(f);v?v.push(P):this.a.set(this.b(f),[P])}replace(f,P){this.a.set(this.b(f),[P])}delete(f){this.a.delete(this.b(f))}*[Symbol.iterator](){for(const[f,P]of this.a)for(const v of P)yield[f,v]}b(f){return p(f)}}e.$Bu=A;function p(E){return E.toLowerCase()}function c(E,f){return I(p(E),f.map(p))}function I(E,f){if(E==="*/*")return f.length>0;if(f.includes(E))return!0;const P=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!P)return!1;const[v,o,m]=P;return m==="*"?f.some($=>$.startsWith(o+"/")):!1}e.$Du=Object.freeze({create:E=>(0,s.$Qb)(E.map(f=>f.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$Du.split(E).filter(f=>!f.startsWith("#"))})}),define(Re[194],Ce([1,0,68]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=void 0,e.$9g=h,e.$$g=O,s=Ue(s);function h(A,p,c,I=1){let E=!1;return new Promise(f=>{const P=setTimeout(()=>{if(!E)return E=!0,f(0)},c);D(A,p,I,v=>{if(!E)return E=!0,clearTimeout(P),f(v)})})}function D(A,p,c,I){if(p===0)return I(0);const E=new s.Socket;E.once("connect",()=>(T(E),D(A+c,p-1,c,I))),E.once("data",()=>{}),E.once("error",f=>(T(E),f.code!=="ECONNREFUSED"?D(A+c,p-1,c,I):I(A))),E.connect(A,"127.0.0.1")}e.$0g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(A,p,c,I="127.0.0.1"){let E=!1,f,P=1;const v=s.createServer({pauseOnConnect:!0});function o(m,$){E||(E=!0,v.removeAllListeners(),v.close(),f&&clearTimeout(f),$(m))}return new Promise(m=>{f=setTimeout(()=>{o(0,m)},c),v.on("listening",()=>{o(A,m)}),v.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&P<p?(A++,P++,v.listen(A,I)):o(0,m)}),v.on("close",()=>{o(0,m)}),v.listen(A,I)})}function T(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(p){console.error(p)}}}),define(Re[139],Ce([1,0,85]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=e.$ru=void 0;class h{constructor(A){const p=(0,s.$ff)(A);this.c=p,this.a=h.d(p),this.b=new Map}static d(A){const p=new Uint8Array(256);return p.fill(A),p}set(A,p){const c=(0,s.$ff)(p);A>=0&&A<256?this.a[A]=c:this.b.set(A,c)}get(A){return A>=0&&A<256?this.a[A]:this.b.get(A)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$ru=h;var D;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(D||(D={}));class O{constructor(){this.a=new h(D.False)}add(A){this.a.set(A,D.True)}has(A){return this.a.get(A)===D.True}clear(){return this.a.clear()}}e.$su=O}),define(Re[195],Ce([1,0,26]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Ju=D;var h;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function D(O){let T=0,A=0,p=0,c=h.Unknown;for(let I=0,E=O.length;I<E;I++){const f=O.charCodeAt(I);f===s.CharCode.CarriageReturn?(T===0&&(A=I),T++,I+1<E&&O.charCodeAt(I+1)===s.CharCode.LineFeed?(c|=h.CRLF,I++):c|=h.Invalid,p=I+1):f===s.CharCode.LineFeed&&(c|=h.LF,T===0&&(A=I),T++,p=I+1)}return T===0&&(A=O.length),[T,A,O.length-p,c]}}),define(Re[55],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=void 0;class s{constructor(D,O){this.lineNumber=D,this.column=O}with(D=this.lineNumber,O=this.column){return D===this.lineNumber&&O===this.column?this:new s(D,O)}delta(D=0,O=0){return this.with(this.lineNumber+D,this.column+O)}equals(D){return s.equals(this,D)}static equals(D,O){return!D&&!O?!0:!!D&&!!O&&D.lineNumber===O.lineNumber&&D.column===O.column}isBefore(D){return s.isBefore(this,D)}static isBefore(D,O){return D.lineNumber<O.lineNumber?!0:O.lineNumber<D.lineNumber?!1:D.column<O.column}isBeforeOrEqual(D){return s.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,O){return D.lineNumber<O.lineNumber?!0:O.lineNumber<D.lineNumber?!1:D.column<=O.column}static compare(D,O){const T=D.lineNumber|0,A=O.lineNumber|0;if(T===A){const p=D.column|0,c=O.column|0;return p-c}return T-A}clone(){return new s(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new s(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Xt=s}),define(Re[30],Ce([1,0,55]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yt=void 0;class h{constructor(O,T,A,p){O>A||O===A&&T>p?(this.startLineNumber=A,this.startColumn=p,this.endLineNumber=O,this.endColumn=T):(this.startLineNumber=O,this.startColumn=T,this.endLineNumber=A,this.endColumn=p)}isEmpty(){return h.isEmpty(this)}static isEmpty(O){return O.startLineNumber===O.endLineNumber&&O.startColumn===O.endColumn}containsPosition(O){return h.containsPosition(this,O)}static containsPosition(O,T){return!(T.lineNumber<O.startLineNumber||T.lineNumber>O.endLineNumber||T.lineNumber===O.startLineNumber&&T.column<O.startColumn||T.lineNumber===O.endLineNumber&&T.column>O.endColumn)}static strictContainsPosition(O,T){return!(T.lineNumber<O.startLineNumber||T.lineNumber>O.endLineNumber||T.lineNumber===O.startLineNumber&&T.column<=O.startColumn||T.lineNumber===O.endLineNumber&&T.column>=O.endColumn)}containsRange(O){return h.containsRange(this,O)}static containsRange(O,T){return!(T.startLineNumber<O.startLineNumber||T.endLineNumber<O.startLineNumber||T.startLineNumber>O.endLineNumber||T.endLineNumber>O.endLineNumber||T.startLineNumber===O.startLineNumber&&T.startColumn<O.startColumn||T.endLineNumber===O.endLineNumber&&T.endColumn>O.endColumn)}strictContainsRange(O){return h.strictContainsRange(this,O)}static strictContainsRange(O,T){return!(T.startLineNumber<O.startLineNumber||T.endLineNumber<O.startLineNumber||T.startLineNumber>O.endLineNumber||T.endLineNumber>O.endLineNumber||T.startLineNumber===O.startLineNumber&&T.startColumn<=O.startColumn||T.endLineNumber===O.endLineNumber&&T.endColumn>=O.endColumn)}plusRange(O){return h.plusRange(this,O)}static plusRange(O,T){let A,p,c,I;return T.startLineNumber<O.startLineNumber?(A=T.startLineNumber,p=T.startColumn):T.startLineNumber===O.startLineNumber?(A=T.startLineNumber,p=Math.min(T.startColumn,O.startColumn)):(A=O.startLineNumber,p=O.startColumn),T.endLineNumber>O.endLineNumber?(c=T.endLineNumber,I=T.endColumn):T.endLineNumber===O.endLineNumber?(c=T.endLineNumber,I=Math.max(T.endColumn,O.endColumn)):(c=O.endLineNumber,I=O.endColumn),new h(A,p,c,I)}intersectRanges(O){return h.intersectRanges(this,O)}static intersectRanges(O,T){let A=O.startLineNumber,p=O.startColumn,c=O.endLineNumber,I=O.endColumn;const E=T.startLineNumber,f=T.startColumn,P=T.endLineNumber,v=T.endColumn;return A<E?(A=E,p=f):A===E&&(p=Math.max(p,f)),c>P?(c=P,I=v):c===P&&(I=Math.min(I,v)),A>c||A===c&&p>I?null:new h(A,p,c,I)}equalsRange(O){return h.equalsRange(this,O)}static equalsRange(O,T){return!O&&!T?!0:!!O&&!!T&&O.startLineNumber===T.startLineNumber&&O.startColumn===T.startColumn&&O.endLineNumber===T.endLineNumber&&O.endColumn===T.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(O){return new s.$Xt(O.endLineNumber,O.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(O){return new s.$Xt(O.startLineNumber,O.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(O,T){return new h(this.startLineNumber,this.startColumn,O,T)}setStartPosition(O,T){return new h(O,T,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(O){return new h(O.startLineNumber,O.startColumn,O.startLineNumber,O.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(O){return new h(O.endLineNumber,O.endColumn,O.endLineNumber,O.endColumn)}delta(O){return new h(this.startLineNumber+O,this.startColumn,this.endLineNumber+O,this.endColumn)}static fromPositions(O,T=O){return new h(O.lineNumber,O.column,T.lineNumber,T.column)}static lift(O){return O?new h(O.startLineNumber,O.startColumn,O.endLineNumber,O.endColumn):null}static isIRange(O){return O&&typeof O.startLineNumber=="number"&&typeof O.startColumn=="number"&&typeof O.endLineNumber=="number"&&typeof O.endColumn=="number"}static areIntersectingOrTouching(O,T){return!(O.endLineNumber<T.startLineNumber||O.endLineNumber===T.startLineNumber&&O.endColumn<T.startColumn||T.endLineNumber<O.startLineNumber||T.endLineNumber===O.startLineNumber&&T.endColumn<O.startColumn)}static areIntersecting(O,T){return!(O.endLineNumber<T.startLineNumber||O.endLineNumber===T.startLineNumber&&O.endColumn<=T.startColumn||T.endLineNumber<O.startLineNumber||T.endLineNumber===O.startLineNumber&&T.endColumn<=O.startColumn)}static compareRangesUsingStarts(O,T){if(O&&T){const c=O.startLineNumber|0,I=T.startLineNumber|0;if(c===I){const E=O.startColumn|0,f=T.startColumn|0;if(E===f){const P=O.endLineNumber|0,v=T.endLineNumber|0;if(P===v){const o=O.endColumn|0,m=T.endColumn|0;return o-m}return P-v}return E-f}return c-I}return(O?1:0)-(T?1:0)}static compareRangesUsingEnds(O,T){return O.endLineNumber===T.endLineNumber?O.endColumn===T.endColumn?O.startLineNumber===T.startLineNumber?O.startColumn-T.startColumn:O.startLineNumber-T.startLineNumber:O.endColumn-T.endColumn:O.endLineNumber-T.endLineNumber}static spansMultipleLines(O){return O.endLineNumber>O.startLineNumber}toJSON(){return this}}e.$Yt=h}),define(Re[196],Ce([1,0,30]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zt=void 0;class h{static insert(O,T){return{range:new s.$Yt(O.lineNumber,O.column,O.lineNumber,O.column),text:T,forceMoveMarkers:!0}}static delete(O){return{range:O,text:null}}static replace(O,T){return{range:O,text:T}}static replaceMove(O,T){return{range:O,text:T,forceMoveMarkers:!0}}}e.$Zt=h}),define(Re[197],Ce([1,0,55,30]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1t=e.SelectionDirection=void 0;var D;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(D||(e.SelectionDirection=D={}));class O extends h.$Yt{constructor(A,p,c,I){super(A,p,c,I),this.selectionStartLineNumber=A,this.selectionStartColumn=p,this.positionLineNumber=c,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return O.selectionsEqual(this,A)}static selectionsEqual(A,p){return A.selectionStartLineNumber===p.selectionStartLineNumber&&A.selectionStartColumn===p.selectionStartColumn&&A.positionLineNumber===p.positionLineNumber&&A.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?D.LTR:D.RTL}setEndPosition(A,p){return this.getDirection()===D.LTR?new O(this.startLineNumber,this.startColumn,A,p):new O(A,p,this.startLineNumber,this.startColumn)}getPosition(){return new s.$Xt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new s.$Xt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(A,p){return this.getDirection()===D.LTR?new O(A,p,this.endLineNumber,this.endColumn):new O(this.endLineNumber,this.endColumn,A,p)}static fromPositions(A,p=A){return new O(A.lineNumber,A.column,p.lineNumber,p.column)}static fromRange(A,p){return p===D.LTR?new O(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):new O(A.endLineNumber,A.endColumn,A.startLineNumber,A.startColumn)}static liftSelection(A){return new O(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,p){if(A&&!p||!A&&p)return!1;if(!A&&!p)return!0;if(A.length!==p.length)return!1;for(let c=0,I=A.length;c<I;c++)if(!this.selectionsEqual(A[c],p[c]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,p,c,I,E){return E===D.LTR?new O(A,p,c,I):new O(c,I,A,p)}}e.$1t=O}),define(Re[198],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$vt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[199],Ce([1,0,26,28,139]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=e.WordCharacterClass=void 0,e.$uu=p;var O;(function(c){c[c.Regular=0]="Regular",c[c.Whitespace=1]="Whitespace",c[c.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class T extends D.$ru{constructor(I,E){super(O.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=E,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let f=0,P=I.length;f<P;f++)this.set(I.charCodeAt(f),O.WordSeparator);this.set(s.CharCode.Space,O.Whitespace),this.set(s.CharCode.Tab,O.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,E){let f=null;for(const P of this.h(I)){if(P.index>E)break;f=P}return f}findNextIntlWordAtOrAfterOffset(I,E){for(const f of this.h(I))if(!(f.index<E))return f;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const E=[];for(const f of I)this.k(f)&&E.push(f);return E}k(I){return!!I.isWordLike}}e.$tu=T;const A=new h.$Ic(10);function p(c,I){const E=`${c}/${I.join(",")}`;let f=A.get(E);return f||(f=new T(c,I),A.set(E,f)),f}}),define(Re[140],Ce([1,0,40,3,82]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.$wt=void 0,e.$yt=T,e.$zt=p,e.$At=c,e.$wt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function O(E=""){let f="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.$wt)E.indexOf(P)>=0||(f+="\\"+P);return f+="\\s]+)",new RegExp(f,"g")}e.$xt=O();function T(E){let f=e.$xt;if(E&&E instanceof RegExp)if(E.global)f=E;else{let P="g";E.ignoreCase&&(P+="i"),E.multiline&&(P+="m"),E.unicode&&(P+="u"),f=new RegExp(E.source,P)}return f.lastIndex=0,f}const A=new D.$0c;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(E){const f=A.unshift(E);return(0,h.$Xc)(f)}function c(E,f,P,v,o){if(f=T(f),o||(o=s.Iterable.first(A)),P.length>o.maxLen){let a=E-o.maxLen/2;return a<0?a=0:v+=a,P=P.substring(a,E+o.maxLen/2),c(E,f,P,v,o)}const m=Date.now(),$=E-1-v;let d=-1,i=null;for(let a=1;!(Date.now()-m>=o.timeBudget);a++){const t=$-o.windowSize*a;f.lastIndex=Math.max(0,t);const r=I(f,P,$,d);if(!r&&i||(i=r,t<=0))break;d=t}if(i){const a={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return f.lastIndex=0,a}return null}function I(E,f,P,v){let o;for(;o=E.exec(f);){const m=o.index||0;if(m<=P&&E.lastIndex>=P)return o;if(v>0&&m>v)return null}return null}}),define(Re[105],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var s;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(s||(e.LanguageId=s={}));var h;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline",p[p.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var D;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(D||(e.ColorId=D={}));var O;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var T;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",p[p.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",p[p.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",p[p.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(T||(e.MetadataConsts=T={}));class A{static getLanguageId(c){return(c&T.LANGUAGEID_MASK)>>>T.LANGUAGEID_OFFSET}static getTokenType(c){return(c&T.TOKEN_TYPE_MASK)>>>T.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(c){return(c&T.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(c){return(c&T.FONT_STYLE_MASK)>>>T.FONT_STYLE_OFFSET}static getForeground(c){return(c&T.FOREGROUND_MASK)>>>T.FOREGROUND_OFFSET}static getBackground(c){return(c&T.BACKGROUND_MASK)>>>T.BACKGROUND_OFFSET}static getClassNameFromMetadata(c){let E="mtk"+this.getForeground(c);const f=this.getFontStyle(c);return f&h.Italic&&(E+=" mtki"),f&h.Bold&&(E+=" mtkb"),f&h.Underline&&(E+=" mtku"),f&h.Strikethrough&&(E+=" mtks"),E}static getInlineStyleFromMetadata(c,I){const E=this.getForeground(c),f=this.getFontStyle(c);let P=`color: ${I[E]};`;f&h.Italic&&(P+="font-style: italic;"),f&h.Bold&&(P+="font-weight: bold;");let v="";return f&h.Underline&&(v+=" underline"),f&h.Strikethrough&&(v+=" line-through"),v&&(P+=`text-decoration:${v};`),P}static getPresentationFromMetadata(c){const I=this.getForeground(c),E=this.getFontStyle(c);return{foreground:I,italic:!!(E&h.Italic),bold:!!(E&h.Bold),underline:!!(E&h.Underline),strikethrough:!!(E&h.Strikethrough)}}}e.$Fu=A}),define(Re[200],Ce([1,0,26,105]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9u=e.$8u=e.IndentAction=void 0;var D;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class O{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let I=0,E=c.notIn.length;I<E;I++)switch(c.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,I){if(c.getTokenCount()===0)return!0;const E=c.findTokenIndexAtOffset(I-2),f=c.getStandardTokenType(E);return this.isOK(f)}g(c,I){for(let E=c;E<=I;E++){const f=String.fromCharCode(E);if(!this.open.includes(f)&&!this.close.includes(f))return f}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(s.CharCode.Digit0,s.CharCode.Digit9)),this.e||(this.e=this.g(s.CharCode.a,s.CharCode.z)),this.e||(this.e=this.g(s.CharCode.A,s.CharCode.Z))),this.e}}e.$8u=O;class T{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of c)A(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),A(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),A(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),A(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&A(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$9u=T;function A(p,c,I){p.has(c)?p.get(c).push(I):p.set(c,[I])}}),define(Re[201],Ce([1,0,26,139]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h5=e.$g5=e.State=void 0,e.$i5=P;var D;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(D||(e.State=D={}));class O{constructor(o,m,$){const d=new Uint8Array(o*m);for(let i=0,a=o*m;i<a;i++)d[i]=$;this.a=d,this.rows=o,this.cols=m}get(o,m){return this.a[o*this.cols+m]}set(o,m,$){this.a[o*this.cols+m]=$}}class T{constructor(o){let m=0,$=D.Invalid;for(let i=0,a=o.length;i<a;i++){const[t,r,n]=o[i];r>m&&(m=r),t>$&&($=t),n>$&&($=n)}m++,$++;const d=new O($,m,D.Invalid);for(let i=0,a=o.length;i<a;i++){const[t,r,n]=o[i];d.set(t,r,n)}this.a=d,this.b=m}nextState(o,m){return m<0||m>=this.b?D.Invalid:this.a.get(o,m)}}e.$g5=T;let A=null;function p(){return A===null&&(A=new T([[D.Start,s.CharCode.h,D.H],[D.Start,s.CharCode.H,D.H],[D.Start,s.CharCode.f,D.F],[D.Start,s.CharCode.F,D.F],[D.H,s.CharCode.t,D.HT],[D.H,s.CharCode.T,D.HT],[D.HT,s.CharCode.t,D.HTT],[D.HT,s.CharCode.T,D.HTT],[D.HTT,s.CharCode.p,D.HTTP],[D.HTT,s.CharCode.P,D.HTTP],[D.HTTP,s.CharCode.s,D.BeforeColon],[D.HTTP,s.CharCode.S,D.BeforeColon],[D.HTTP,s.CharCode.Colon,D.AfterColon],[D.F,s.CharCode.i,D.FI],[D.F,s.CharCode.I,D.FI],[D.FI,s.CharCode.l,D.FIL],[D.FI,s.CharCode.L,D.FIL],[D.FIL,s.CharCode.e,D.BeforeColon],[D.FIL,s.CharCode.E,D.BeforeColon],[D.BeforeColon,s.CharCode.Colon,D.AfterColon],[D.AfterColon,s.CharCode.Slash,D.AlmostThere],[D.AlmostThere,s.CharCode.Slash,D.End]])),A}var c;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})(c||(c={}));let I=null;function E(){if(I===null){I=new h.$ru(c.None);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<v.length;m++)I.set(v.charCodeAt(m),c.ForceTermination);const o=".,;:";for(let m=0;m<o.length;m++)I.set(o.charCodeAt(m),c.CannotEndIn)}return I}class f{static a(o,m,$,d,i){let a=i-1;do{const t=m.charCodeAt(a);if(o.get(t)!==c.CannotEndIn)break;a--}while(a>d);if(d>0){const t=m.charCodeAt(d-1),r=m.charCodeAt(a);(t===s.CharCode.OpenParen&&r===s.CharCode.CloseParen||t===s.CharCode.OpenSquareBracket&&r===s.CharCode.CloseSquareBracket||t===s.CharCode.OpenCurlyBrace&&r===s.CharCode.CloseCurlyBrace)&&a--}return{range:{startLineNumber:$,startColumn:d+1,endLineNumber:$,endColumn:a+2},url:m.substring(d,a+1)}}static computeLinks(o,m=p()){const $=E(),d=[];for(let i=1,a=o.getLineCount();i<=a;i++){const t=o.getLineContent(i),r=t.length;let n=0,u=0,l=0,g=D.Start,y=!1,k=!1,S=!1,R=!1;for(;n<r;){let C=!1;const w=t.charCodeAt(n);if(g===D.Accept){let b;switch(w){case s.CharCode.OpenParen:y=!0,b=c.None;break;case s.CharCode.CloseParen:b=y?c.None:c.ForceTermination;break;case s.CharCode.OpenSquareBracket:S=!0,k=!0,b=c.None;break;case s.CharCode.CloseSquareBracket:S=!1,b=k?c.None:c.ForceTermination;break;case s.CharCode.OpenCurlyBrace:R=!0,b=c.None;break;case s.CharCode.CloseCurlyBrace:b=R?c.None:c.ForceTermination;break;case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.BackTick:l===w?b=c.ForceTermination:l===s.CharCode.SingleQuote||l===s.CharCode.DoubleQuote||l===s.CharCode.BackTick?b=c.None:b=c.ForceTermination;break;case s.CharCode.Asterisk:b=l===s.CharCode.Asterisk?c.ForceTermination:c.None;break;case s.CharCode.Pipe:b=l===s.CharCode.Pipe?c.ForceTermination:c.None;break;case s.CharCode.Space:b=S?c.None:c.ForceTermination;break;default:b=$.get(w)}b===c.ForceTermination&&(d.push(f.a($,t,i,u,n)),C=!0)}else if(g===D.End){let b;w===s.CharCode.OpenSquareBracket?(k=!0,b=c.None):b=$.get(w),b===c.ForceTermination?C=!0:g=D.Accept}else g=m.nextState(g,w),g===D.Invalid&&(C=!0);C&&(g=D.Start,y=!1,k=!1,R=!1,u=n+1,l=w),n++}g===D.Accept&&d.push(f.a($,t,i,u,r))}return d}}e.$h5=f;function P(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:f.computeLinks(v)}}),define(Re[56],Ce([1,0,24]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$rw=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$pw=e.$ow=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$qw=v,e.$uw=a;var h;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var D;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(D||(e.GlyphMarginLane=D={}));var O;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(O||(e.MinimapPosition=O={}));var T;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(T||(e.MinimapSectionHeaderStyle=T={}));var A;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var p;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var c;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c||(e.DefaultEndOfLine=c={}));var I;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class E{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(r){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,r.tabSize|0),r.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,r.indentSize|0),this.a=!1),this.insertSpaces=!!r.insertSpaces,this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=!!r.trimAutoWhitespace,this.bracketPairColorizationOptions=r.bracketPairColorizationOptions}equals(r){return this.tabSize===r.tabSize&&this.a===r.a&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace&&(0,s.$qo)(this.bracketPairColorizationOptions,r.bracketPairColorizationOptions)}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.$ow=E;class f{constructor(r,n){this._findMatchBrand=void 0,this.range=r,this.matches=n}}e.$pw=f;var P;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));function v(t){return t&&typeof t.read=="function"}var o;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(o||(e.PositionAffinity=o={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class ${constructor(r,n,u,l,g,y){this.identifier=r,this.range=n,this.text=u,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=g,this._isTracked=y}}e.$rw=$;class d{constructor(r,n,u){this.regex=r,this.wordSeparators=n,this.simpleSearch=u}}e.$sw=d;class i{constructor(r,n,u){this.reverseEdits=r,this.changes=n,this.trimAutoWhitespaceLineNumbers=u}}e.$tw=i;function a(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(Re[202],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qD=e.NodeColor=e.$pD=void 0,e.$rD=D,e.$sD=O,e.$tD=c,e.$uD=I,e.$vD=E,e.$wD=f,e.$xD=P,e.$yD=v;class s{constructor(m,$){this.piece=m,this.color=$,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$qD)return D(this.right);let m=this;for(;m.parent!==e.$qD&&m.parent.left!==m;)m=m.parent;return m.parent===e.$qD?e.$qD:m.parent}prev(){if(this.left!==e.$qD)return O(this.left);let m=this;for(;m.parent!==e.$qD&&m.parent.right!==m;)m=m.parent;return m.parent===e.$qD?e.$qD:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$pD=s;var h;(function(o){o[o.Black=0]="Black",o[o.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$qD=new s(null,h.Black),e.$qD.parent=e.$qD,e.$qD.left=e.$qD,e.$qD.right=e.$qD,e.$qD.color=h.Black;function D(o){for(;o.left!==e.$qD;)o=o.left;return o}function O(o){for(;o.right!==e.$qD;)o=o.right;return o}function T(o){return o===e.$qD?0:o.size_left+o.piece.length+T(o.right)}function A(o){return o===e.$qD?0:o.lf_left+o.piece.lineFeedCnt+A(o.right)}function p(){e.$qD.parent=e.$qD}function c(o,m){const $=m.right;$.size_left+=m.size_left+(m.piece?m.piece.length:0),$.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=$.left,$.left!==e.$qD&&($.left.parent=m),$.parent=m.parent,m.parent===e.$qD?o.root=$:m.parent.left===m?m.parent.left=$:m.parent.right=$,$.left=m,m.parent=$}function I(o,m){const $=m.left;m.left=$.right,$.right!==e.$qD&&($.right.parent=m),$.parent=m.parent,m.size_left-=$.size_left+($.piece?$.piece.length:0),m.lf_left-=$.lf_left+($.piece?$.piece.lineFeedCnt:0),m.parent===e.$qD?o.root=$:m===m.parent.right?m.parent.right=$:m.parent.left=$,$.right=m,m.parent=$}function E(o,m){let $,d;if(m.left===e.$qD?(d=m,$=d.right):m.right===e.$qD?(d=m,$=d.left):(d=D(m.right),$=d.right),d===o.root){o.root=$,$.color=h.Black,m.detach(),p(),o.root.parent=e.$qD;return}const i=d.color===h.Red;if(d===d.parent.left?d.parent.left=$:d.parent.right=$,d===m?($.parent=d.parent,v(o,$)):(d.parent===m?$.parent=d:$.parent=d.parent,v(o,$),d.left=m.left,d.right=m.right,d.parent=m.parent,d.color=m.color,m===o.root?o.root=d:m===m.parent.left?m.parent.left=d:m.parent.right=d,d.left!==e.$qD&&(d.left.parent=d),d.right!==e.$qD&&(d.right.parent=d),d.size_left=m.size_left,d.lf_left=m.lf_left,v(o,d)),m.detach(),$.parent.left===$){const t=T($),r=A($);if(t!==$.parent.size_left||r!==$.parent.lf_left){const n=t-$.parent.size_left,u=r-$.parent.lf_left;$.parent.size_left=t,$.parent.lf_left=r,P(o,$.parent,n,u)}}if(v(o,$.parent),i){p();return}let a;for(;$!==o.root&&$.color===h.Black;)$===$.parent.left?(a=$.parent.right,a.color===h.Red&&(a.color=h.Black,$.parent.color=h.Red,c(o,$.parent),a=$.parent.right),a.left.color===h.Black&&a.right.color===h.Black?(a.color=h.Red,$=$.parent):(a.right.color===h.Black&&(a.left.color=h.Black,a.color=h.Red,I(o,a),a=$.parent.right),a.color=$.parent.color,$.parent.color=h.Black,a.right.color=h.Black,c(o,$.parent),$=o.root)):(a=$.parent.left,a.color===h.Red&&(a.color=h.Black,$.parent.color=h.Red,I(o,$.parent),a=$.parent.left),a.left.color===h.Black&&a.right.color===h.Black?(a.color=h.Red,$=$.parent):(a.left.color===h.Black&&(a.right.color=h.Black,a.color=h.Red,c(o,a),a=$.parent.left),a.color=$.parent.color,$.parent.color=h.Black,a.left.color=h.Black,I(o,$.parent),$=o.root));$.color=h.Black,p()}function f(o,m){for(v(o,m);m!==o.root&&m.parent.color===h.Red;)if(m.parent===m.parent.parent.left){const $=m.parent.parent.right;$.color===h.Red?(m.parent.color=h.Black,$.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,c(o,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,I(o,m.parent.parent))}else{const $=m.parent.parent.left;$.color===h.Red?(m.parent.color=h.Black,$.color=h.Black,m.parent.parent.color=h.Red,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,I(o,m)),m.parent.color=h.Black,m.parent.parent.color=h.Red,c(o,m.parent.parent))}o.root.color=h.Black}function P(o,m,$,d){for(;m!==o.root&&m!==e.$qD;)m.parent.left===m&&(m.parent.size_left+=$,m.parent.lf_left+=d),m=m.parent}function v(o,m){let $=0,d=0;if(m!==o.root){for(;m!==o.root&&m===m.parent.right;)m=m.parent;if(m!==o.root)for(m=m.parent,$=T(m.left)-m.size_left,d=A(m.left)-m.lf_left,m.size_left+=$,m.lf_left+=d;m!==o.root&&($!==0||d!==0);)m.parent.left===m&&(m.parent.size_left+=$,m.parent.lf_left+=d),m=m.parent}}}),define(Re[203],Ce([1,0,18,85]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zw=e.$yw=e.$xw=void 0;class D{constructor(p){this.a=p,this.b=new Uint32Array(p.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(p,c){p=(0,h.$gf)(p);const I=this.a,E=this.b,f=c.length;return f===0?!1:(this.a=new Uint32Array(I.length+f),this.a.set(I.subarray(0,p),0),this.a.set(I.subarray(p),p+f),this.a.set(c,p),p-1<this.c[0]&&(this.c[0]=p-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue(p,c){return p=(0,h.$gf)(p),c=(0,h.$gf)(c),this.a[p]===c?!1:(this.a[p]=c,p-1<this.c[0]&&(this.c[0]=p-1),!0)}removeValues(p,c){p=(0,h.$gf)(p),c=(0,h.$gf)(c);const I=this.a,E=this.b;if(p>=I.length)return!1;const f=I.length-p;return c>=f&&(c=f),c===0?!1:(this.a=new Uint32Array(I.length-c),this.a.set(I.subarray(0,p),0),this.a.set(I.subarray(p+c),p),this.b=new Uint32Array(this.a.length),p-1<this.c[0]&&(this.c[0]=p-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(p){return p<0?0:(p=(0,h.$gf)(p),this.d(p))}d(p){if(p<=this.c[0])return this.b[p];let c=this.c[0]+1;c===0&&(this.b[0]=this.a[0],c++),p>=this.a.length&&(p=this.a.length-1);for(let I=c;I<=p;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],p),this.b[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let c=0,I=this.a.length-1,E=0,f=0,P=0;for(;c<=I;)if(E=c+(I-c)/2|0,f=this.b[E],P=f-this.a[E],p<P)I=E-1;else if(p>=f)c=E+1;else break;return new T(E,p-P)}}e.$xw=D;class O{constructor(p){this.a=p,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(p){return this.g(),p===0?0:this.d[p-1]}getIndexOf(p){this.g();const c=this.e[p],I=c>0?this.d[c-1]:0;return new T(c,p-I)}removeValues(p,c){this.a.splice(p,c),this.f(p)}insertValues(p,c){this.a=(0,s.$Zb)(this.a,p,c),this.f(p)}f(p){this.b=!1,this.c=Math.min(this.c,p-1)}g(){if(!this.b){for(let p=this.c+1,c=this.a.length;p<c;p++){const I=this.a[p],E=p>0?this.d[p-1]:0;this.d[p]=E+I;for(let f=0;f<I;f++)this.e[E+f]=p}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(p,c){this.a[p]!==c&&(this.a[p]=c,this.f(p))}}e.$yw=O;class T{constructor(p,c){this.index=p,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=c}}e.$zw=T}),define(Re[204],Ce([1,0,13,55,203]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aw=void 0;class O{constructor(A,p,c,I){this.a=A,this.b=p,this.c=c,this.d=I,this.f=null,this.g=null}dispose(){this.b.length=0}get version(){return this.d}getText(){return this.g===null&&(this.g=this.b.join(this.c)),this.g}onEvents(A){A.eol&&A.eol!==this.c&&(this.c=A.eol,this.f=null);const p=A.changes;for(const c of p)this.k(c.range),this.l(new h.$Xt(c.range.startLineNumber,c.range.startColumn),c.text);this.d=A.versionId,this.g=null}h(){if(!this.f){const A=this.c.length,p=this.b.length,c=new Uint32Array(p);for(let I=0;I<p;I++)c[I]=this.b[I].length+A;this.f=new D.$xw(c)}}j(A,p){this.b[A]=p,this.f&&this.f.setValue(A,this.b[A].length+this.c.length)}k(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this.j(A.startLineNumber-1,this.b[A.startLineNumber-1].substring(0,A.startColumn-1)+this.b[A.startLineNumber-1].substring(A.endColumn-1));return}this.j(A.startLineNumber-1,this.b[A.startLineNumber-1].substring(0,A.startColumn-1)+this.b[A.endLineNumber-1].substring(A.endColumn-1)),this.b.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this.f&&this.f.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}l(A,p){if(p.length===0)return;const c=(0,s.$xf)(p);if(c.length===1){this.j(A.lineNumber-1,this.b[A.lineNumber-1].substring(0,A.column-1)+c[0]+this.b[A.lineNumber-1].substring(A.column-1));return}c[c.length-1]+=this.b[A.lineNumber-1].substring(A.column-1),this.j(A.lineNumber-1,this.b[A.lineNumber-1].substring(0,A.column-1)+c[0]);const I=new Uint32Array(c.length-1);for(let E=1;E<c.length;E++)this.b.splice(A.lineNumber+E-1,0,c[E]),I[E-1]=c[E].length+this.c.length;this.f&&this.f.insertValues(A.lineNumber,I)}}e.$Aw=O}),define(Re[106],Ce([1,0,26,13,199,55,30,56]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ED=e.$CD=e.$zD=void 0,e.$AD=I,e.$BD=E,e.$DD=m,h=Ue(h);const p=999;class c{constructor(i,a,t,r){this.searchString=i,this.isRegex=a,this.matchCase=t,this.wordSeparators=r}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=I(this.searchString):i=this.searchString.indexOf(`
`)>=0;let a=null;try{a=h.$vf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!a)return null;let t=!this.isRegex&&!i;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new A.$sw(a,this.wordSeparators?(0,D.$uu)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.$zD=c;function I(d){if(!d||d.length===0)return!1;for(let i=0,a=d.length;i<a;i++){const t=d.charCodeAt(i);if(t===s.CharCode.LineFeed)return!0;if(t===s.CharCode.Backslash){if(i++,i>=a)break;const r=d.charCodeAt(i);if(r===s.CharCode.n||r===s.CharCode.r||r===s.CharCode.W)return!0}}return!1}function E(d,i,a){if(!a)return new A.$pw(d,null);const t=[];for(let r=0,n=i.length;r<n;r++)t[r]=i[r];return new A.$pw(d,t)}class f{constructor(i){const a=[];let t=0;for(let r=0,n=i.length;r<n;r++)i.charCodeAt(r)===s.CharCode.LineFeed&&(a[t++]=r);this.a=a}findLineFeedCountBeforeOffset(i){const a=this.a;let t=0,r=a.length-1;if(r===-1||i<=a[0])return 0;for(;t<r;){const n=t+((r-t)/2>>0);a[n]>=i?r=n-1:a[n+1]>=i?(t=n,r=n):t=n+1}return t+1}}class P{static findMatches(i,a,t,r,n){const u=a.parseSearchRequest();return u?u.regex.multiline?this.b(i,t,new $(u.wordSeparators,u.regex),r,n):this.c(i,t,u,r,n):[]}static a(i,a,t,r,n,u){let l,g=0;r?(g=r.findLineFeedCountBeforeOffset(n),l=a+n+g):l=a+n;let y;if(r){const C=r.findLineFeedCountBeforeOffset(n+u.length)-g;y=l+u.length+C}else y=l+u.length;const k=i.getPositionAt(l),S=i.getPositionAt(y);return new T.$Yt(k.lineNumber,k.column,S.lineNumber,S.column)}static b(i,a,t,r,n){const u=i.getOffsetAt(a.getStartPosition()),l=i.getValueInRange(a,A.EndOfLinePreference.LF),g=i.getEOL()===`\r
`?new f(l):null,y=[];let k=0,S;for(t.reset(0);S=t.next(l);)if(y[k++]=E(this.a(i,u,l,g,S.index,S[0]),S,r),k>=n)return y;return y}static c(i,a,t,r,n){const u=[];let l=0;if(a.startLineNumber===a.endLineNumber){const y=i.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return l=this.d(t,y,a.startLineNumber,a.startColumn-1,l,u,r,n),u}const g=i.getLineContent(a.startLineNumber).substring(a.startColumn-1);l=this.d(t,g,a.startLineNumber,a.startColumn-1,l,u,r,n);for(let y=a.startLineNumber+1;y<a.endLineNumber&&l<n;y++)l=this.d(t,i.getLineContent(y),y,0,l,u,r,n);if(l<n){const y=i.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);l=this.d(t,y,a.endLineNumber,0,l,u,r,n)}return u}static d(i,a,t,r,n,u,l,g){const y=i.wordSeparators;if(!l&&i.simpleSearch){const R=i.simpleSearch,C=R.length,w=a.length;let b=-C;for(;(b=a.indexOf(R,b+C))!==-1;)if((!y||m(y,a,w,b,C))&&(u[n++]=new A.$pw(new T.$Yt(t,b+1+r,t,b+1+C+r),null),n>=g))return n;return n}const k=new $(i.wordSeparators,i.regex);let S;k.reset(0);do if(S=k.next(a),S&&(u[n++]=E(new T.$Yt(t,S.index+1+r,t,S.index+1+S[0].length+r),S,l),n>=g))return n;while(S);return n}static findNextMatch(i,a,t,r){const n=a.parseSearchRequest();if(!n)return null;const u=new $(n.wordSeparators,n.regex);return n.regex.multiline?this.e(i,t,u,r):this.f(i,t,u,r)}static e(i,a,t,r){const n=new O.$Xt(a.lineNumber,1),u=i.getOffsetAt(n),l=i.getLineCount(),g=i.getValueInRange(new T.$Yt(n.lineNumber,n.column,l,i.getLineMaxColumn(l)),A.EndOfLinePreference.LF),y=i.getEOL()===`\r
`?new f(g):null;t.reset(a.column-1);const k=t.next(g);return k?E(this.a(i,u,g,y,k.index,k[0]),k,r):a.lineNumber!==1||a.column!==1?this.e(i,new O.$Xt(1,1),t,r):null}static f(i,a,t,r){const n=i.getLineCount(),u=a.lineNumber,l=i.getLineContent(u),g=this.g(t,l,u,a.column,r);if(g)return g;for(let y=1;y<=n;y++){const k=(u+y-1)%n,S=i.getLineContent(k+1),R=this.g(t,S,k+1,1,r);if(R)return R}return null}static g(i,a,t,r,n){i.reset(r-1);const u=i.next(a);return u?E(new T.$Yt(t,u.index+1,t,u.index+1+u[0].length),u,n):null}static findPreviousMatch(i,a,t,r){const n=a.parseSearchRequest();if(!n)return null;const u=new $(n.wordSeparators,n.regex);return n.regex.multiline?this.h(i,t,u,r):this.j(i,t,u,r)}static h(i,a,t,r){const n=this.b(i,new T.$Yt(1,1,a.lineNumber,a.column),t,r,10*p);if(n.length>0)return n[n.length-1];const u=i.getLineCount();return a.lineNumber!==u||a.column!==i.getLineMaxColumn(u)?this.h(i,new O.$Xt(u,i.getLineMaxColumn(u)),t,r):null}static j(i,a,t,r){const n=i.getLineCount(),u=a.lineNumber,l=i.getLineContent(u).substring(0,a.column-1),g=this.k(t,l,u,r);if(g)return g;for(let y=1;y<=n;y++){const k=(n+u-y-1)%n,S=i.getLineContent(k+1),R=this.k(t,S,k+1,r);if(R)return R}return null}static k(i,a,t,r){let n=null,u;for(i.reset(0);u=i.next(a);)n=E(new T.$Yt(t,u.index+1,t,u.index+1+u[0].length),u,r);return n}}e.$CD=P;function v(d,i,a,t,r){if(t===0)return!0;const n=i.charCodeAt(t-1);if(d.get(n)!==D.WordCharacterClass.Regular||n===s.CharCode.CarriageReturn||n===s.CharCode.LineFeed)return!0;if(r>0){const u=i.charCodeAt(t);if(d.get(u)!==D.WordCharacterClass.Regular)return!0}return!1}function o(d,i,a,t,r){if(t+r===a)return!0;const n=i.charCodeAt(t+r);if(d.get(n)!==D.WordCharacterClass.Regular||n===s.CharCode.CarriageReturn||n===s.CharCode.LineFeed)return!0;if(r>0){const u=i.charCodeAt(t+r-1);if(d.get(u)!==D.WordCharacterClass.Regular)return!0}return!1}function m(d,i,a,t,r){return v(d,i,a,t,r)&&o(d,i,a,t,r)}class ${constructor(i,a){this._wordSeparators=i,this.a=a,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const a=i.length;let t;do{if(this.b+this.c===a||(t=this.a.exec(i),!t))return null;const r=t.index,n=t[0].length;if(r===this.b&&n===this.c){if(n===0){h.$Rf(i,a,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=r,this.c=n,!this._wordSeparators||m(this._wordSeparators,i,a,r,n))return t}while(t);return null}}e.$ED=$}),define(Re[141],Ce([1,0,26,55,30,56,202,106]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JD=e.$ID=e.$HD=void 0,e.$FD=E,e.$GD=f;const p=65535;function c(d){let i;return d[d.length-1]<65536?i=new Uint16Array(d.length):i=new Uint32Array(d.length),i.set(d,0),i}class I{constructor(i,a,t,r,n){this.lineStarts=i,this.cr=a,this.lf=t,this.crlf=r,this.isBasicASCII=n}}function E(d,i=!0){const a=[0];let t=1;for(let r=0,n=d.length;r<n;r++){const u=d.charCodeAt(r);u===s.CharCode.CarriageReturn?r+1<n&&d.charCodeAt(r+1)===s.CharCode.LineFeed?(a[t++]=r+2,r++):a[t++]=r+1:u===s.CharCode.LineFeed&&(a[t++]=r+1)}return i?c(a):a}function f(d,i){d.length=0,d[0]=0;let a=1,t=0,r=0,n=0,u=!0;for(let g=0,y=i.length;g<y;g++){const k=i.charCodeAt(g);k===s.CharCode.CarriageReturn?g+1<y&&i.charCodeAt(g+1)===s.CharCode.LineFeed?(n++,d[a++]=g+2,g++):(t++,d[a++]=g+1):k===s.CharCode.LineFeed?(r++,d[a++]=g+1):u&&k!==s.CharCode.Tab&&(k<32||k>126)&&(u=!1)}const l=new I(c(d),t,r,n,u);return d.length=0,l}class P{constructor(i,a,t,r,n){this.bufferIndex=i,this.start=a,this.end=t,this.lineFeedCnt=r,this.length=n}}e.$HD=P;class v{constructor(i,a){this.buffer=i,this.lineStarts=a}}e.$ID=v;class o{constructor(i,a){this.a=[],this.c=i,this.d=a,this.b=0,i.root!==T.$qD&&i.iterate(i.root,t=>(t!==T.$qD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class m{constructor(i){this.a=i,this.b=[]}get(i){for(let a=this.b.length-1;a>=0;a--){const t=this.b[a];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let a=this.b.length-1;a>=0;a--){const t=this.b[a];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let a=!1;const t=this.b;for(let r=0;r<t.length;r++){const n=t[r];if(n.node.parent===null||n.nodeStartOffset>=i){t[r]=null,a=!0;continue}}if(a){const r=[];for(const n of t)n!==null&&r.push(n);this.b=r}}}class ${constructor(i,a,t){this.create(i,a,t)}create(i,a,t){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=T.$qD,this.b=1,this.c=0,this.d=a,this.e=a.length,this.f=t;let r=null;for(let n=0,u=i.length;n<u;n++)if(i[n].buffer.length>0){i[n].lineStarts||(i[n].lineStarts=E(i[n].buffer));const l=new P(n+1,{line:0,column:0},{line:i[n].lineStarts.length-1,column:i[n].buffer.length-i[n].lineStarts[i[n].lineStarts.length-1]},i[n].lineStarts.length-1,i[n].buffer.length);this.a.push(i[n]),r=this.S(r,l)}this.h=new m(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const a=p,t=a-Math.floor(a/3),r=t*2;let n="",u=0;const l=[];if(this.iterate(this.root,g=>{const y=this.R(g),k=y.length;if(u<=t||u+k<r)return n+=y,u+=k,!0;const S=n.replace(/\r\n|\r|\n/g,i);return l.push(new v(S,E(S))),n=y,u=k,!0}),u>0){const g=n.replace(/\r\n|\r|\n/g,i);l.push(new v(g,E(g)))}this.create(l,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new o(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let a=0;return this.iterate(this.root,r=>{if(r===T.$qD)return!0;const n=this.R(r),u=n.length,l=i.G(a),g=i.G(a+u),y=i.getValueInRange2(l,g);return a+=u,n===y})}getOffsetAt(i,a){let t=0,r=this.root;for(;r!==T.$qD;)if(r.left!==T.$qD&&r.lf_left+1>=i)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt+1>=i){t+=r.size_left;const n=this.B(r,i-r.lf_left-2);return t+=n+a-1}else i-=r.lf_left+r.piece.lineFeedCnt,t+=r.size_left+r.piece.length,r=r.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let a=this.root,t=0;const r=i;for(;a!==T.$qD;)if(a.size_left!==0&&a.size_left>=i)a=a.left;else if(a.size_left+a.piece.length>=i){const n=this.A(a,i-a.size_left);if(t+=a.lf_left+n.index,n.index===0){const u=this.getOffsetAt(t+1,1),l=r-u;return new h.$Xt(t+1,l+1)}return new h.$Xt(t+1,n.remainder+1)}else if(i-=a.size_left+a.piece.length,t+=a.lf_left+a.piece.lineFeedCnt,a.right===T.$qD){const n=this.getOffsetAt(t+1,1),u=r-i-n;return new h.$Xt(t+1,u+1)}else a=a.right;return new h.$Xt(1,1)}getValueInRange(i,a){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),r=this.H(i.endLineNumber,i.endColumn),n=this.getValueInRange2(t,r);return a?a!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,a):a===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,a):n}getValueInRange2(i,a){if(i.node===a.node){const l=i.node,g=this.a[l.piece.bufferIndex].buffer,y=this.u(l.piece.bufferIndex,l.piece.start);return g.substring(y+i.remainder,y+a.remainder)}let t=i.node;const r=this.a[t.piece.bufferIndex].buffer,n=this.u(t.piece.bufferIndex,t.piece.start);let u=r.substring(n+i.remainder,n+t.piece.length);for(t=t.next();t!==T.$qD;){const l=this.a[t.piece.bufferIndex].buffer,g=this.u(t.piece.bufferIndex,t.piece.start);if(t===a.node){u+=l.substring(g,g+a.remainder);break}else u+=l.substr(g,t.piece.length);t=t.next()}return u}getLinesContent(){const i=[];let a=0,t="",r=!1;return this.iterate(this.root,n=>{if(n===T.$qD)return!0;const u=n.piece;let l=u.length;if(l===0)return!0;const g=this.a[u.bufferIndex].buffer,y=this.a[u.bufferIndex].lineStarts,k=u.start.line,S=u.end.line;let R=y[k]+u.start.column;if(r&&(g.charCodeAt(R)===s.CharCode.LineFeed&&(R++,l--),i[a++]=t,t="",r=!1,l===0))return!0;if(k===S)return!this.f&&g.charCodeAt(R+l-1)===s.CharCode.CarriageReturn?(r=!0,t+=g.substr(R,l-1)):t+=g.substr(R,l),!0;t+=this.f?g.substring(R,Math.max(R,y[k+1]-this.e)):g.substring(R,y[k+1]).replace(/(\r\n|\r|\n)$/,""),i[a++]=t;for(let C=k+1;C<S;C++)t=this.f?g.substring(y[C],y[C+1]-this.e):g.substring(y[C],y[C+1]).replace(/(\r\n|\r|\n)$/,""),i[a++]=t;return!this.f&&g.charCodeAt(y[S]+u.end.column-1)===s.CharCode.CarriageReturn?(r=!0,u.end.column===0?a--:t=g.substr(y[S],u.end.column-1)):t=g.substr(y[S],u.end.column),!0}),r&&(i[a++]=t,t=""),i[a++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const a=i.node.next();if(!a)return 0;const t=this.a[a.piece.bufferIndex],r=this.u(a.piece.bufferIndex,a.piece.start);return t.buffer.charCodeAt(r)}else{const a=this.a[i.node.piece.bufferIndex],r=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return a.buffer.charCodeAt(r)}}getLineCharCode(i,a){const t=this.H(i,a+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const a=this.getOffsetAt(i,1);return this.getLength()-a}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const a=this.G(i);return this.l(a)}getNearestChunk(i){const a=this.G(i);if(a.remainder===a.node.piece.length){const t=a.node.next();if(!t||t===T.$qD)return"";const r=this.a[t.piece.bufferIndex],n=this.u(t.piece.bufferIndex,t.piece.start);return r.buffer.substring(n,n+t.piece.length)}else{const t=this.a[a.node.piece.bufferIndex],r=this.u(a.node.piece.bufferIndex,a.node.piece.start),n=r+a.remainder,u=r+a.node.piece.length;return t.buffer.substring(n,u)}}findMatchesInNode(i,a,t,r,n,u,l,g,y,k,S){const R=this.a[i.piece.bufferIndex],C=this.u(i.piece.bufferIndex,i.piece.start),w=this.u(i.piece.bufferIndex,n),b=this.u(i.piece.bufferIndex,u);let N;const L={line:0,column:0};let M,z;a._wordSeparators?(M=R.buffer.substring(w,b),z=V=>V+w,a.reset(0)):(M=R.buffer,z=V=>V,a.reset(w));do if(N=a.next(M),N){if(z(N.index)>=b)return k;this.s(i,z(N.index)-C,L);const V=this.t(i.piece.bufferIndex,n,L),F=L.line===n.line?L.column-n.column+r:L.column+1,j=F+N[0].length;if(S[k++]=(0,A.$BD)(new D.$Yt(t+V,F,t+V,j),N,g),z(N.index)+N[0].length>=b||k>=y)return k}while(N);return k}findMatchesLineByLine(i,a,t,r){const n=[];let u=0;const l=new A.$ED(a.wordSeparators,a.regex);let g=this.H(i.startLineNumber,i.startColumn);if(g===null)return[];const y=this.H(i.endLineNumber,i.endColumn);if(y===null)return[];let k=this.s(g.node,g.remainder);const S=this.s(y.node,y.remainder);if(g.node===y.node)return this.findMatchesInNode(g.node,l,i.startLineNumber,i.startColumn,k,S,a,t,r,u,n),n;let R=i.startLineNumber,C=g.node;for(;C!==y.node;){const b=this.t(C.piece.bufferIndex,k,C.piece.end);if(b>=1){const L=this.a[C.piece.bufferIndex].lineStarts,M=this.u(C.piece.bufferIndex,C.piece.start),z=L[k.line+b],V=R===i.startLineNumber?i.startColumn:1;if(u=this.findMatchesInNode(C,l,R,V,k,this.s(C,z-M),a,t,r,u,n),u>=r)return n;R+=b}const N=R===i.startLineNumber?i.startColumn-1:0;if(R===i.endLineNumber){const L=this.getLineContent(R).substring(N,i.endColumn-1);return u=this.n(a,l,L,i.endLineNumber,N,u,n,t,r),n}if(u=this.n(a,l,this.getLineContent(R).substr(N),R,N,u,n,t,r),u>=r)return n;R++,g=this.H(R,1),C=g.node,k=this.s(g.node,g.remainder)}if(R===i.endLineNumber){const b=R===i.startLineNumber?i.startColumn-1:0,N=this.getLineContent(R).substring(b,i.endColumn-1);return u=this.n(a,l,N,i.endLineNumber,b,u,n,t,r),n}const w=R===i.startLineNumber?i.startColumn:1;return u=this.findMatchesInNode(y.node,l,R,w,k,S,a,t,r,u,n),n}n(i,a,t,r,n,u,l,g,y){const k=i.wordSeparators;if(!g&&i.simpleSearch){const R=i.simpleSearch,C=R.length,w=t.length;let b=-C;for(;(b=t.indexOf(R,b+C))!==-1;)if((!k||(0,A.$DD)(k,t,w,b,C))&&(l[u++]=new O.$pw(new D.$Yt(r,b+1+n,r,b+1+C+n),null),u>=y))return u;return u}let S;a.reset(0);do if(S=a.next(t),S&&(l[u++]=(0,A.$BD)(new D.$Yt(r,S.index+1+n,r,S.index+1+S[0].length+n),S,g),u>=y))return u;while(S);return u}insert(i,a,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==T.$qD){const{node:r,remainder:n,nodeStartOffset:u}=this.G(i),l=r.piece,g=l.bufferIndex,y=this.s(r,n);if(r.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&u+l.length===i&&a.length<p){this.F(r,a),this.y();return}if(u===i)this.o(a,r),this.h.validate(i);else if(u+r.piece.length>i){const k=[];let S=new P(l.bufferIndex,y,l.end,this.t(l.bufferIndex,y,l.end),this.u(g,l.end)-this.u(g,y));if(this.K()&&this.M(a)&&this.I(r,n)===10){const b={line:S.start.line+1,column:0};S=new P(S.bufferIndex,b,S.end,this.t(S.bufferIndex,b,S.end),S.length-1),a+=`
`}if(this.K()&&this.L(a))if(this.I(r,n-1)===13){const b=this.s(r,n-1);this.C(r,b),a="\r"+a,r.piece.length===0&&k.push(r)}else this.C(r,y);else this.C(r,y);const R=this.w(a);S.length>0&&this.S(r,S);let C=r;for(let w=0;w<R.length;w++)C=this.S(C,R[w]);this.v(k)}else this.q(a,r)}else{const r=this.w(a);let n=this.T(null,r[0]);for(let u=1;u<r.length;u++)n=this.S(n,r[u])}this.y()}delete(i,a){if(this.j.lineNumber=0,this.j.value="",a<=0||this.root===T.$qD)return;const t=this.G(i),r=this.G(i+a),n=t.node,u=r.node;if(n===u){const R=this.s(n,t.remainder),C=this.s(n,r.remainder);if(t.nodeStartOffset===i){if(a===n.piece.length){const w=n.next();(0,T.$vD)(this,n),this.N(w),this.y();return}this.D(n,C),this.h.validate(i),this.N(n),this.y();return}if(t.nodeStartOffset+n.piece.length===i+a){this.C(n,R),this.O(n),this.y();return}this.E(n,R,C),this.y();return}const l=[],g=this.s(n,t.remainder);this.C(n,g),this.h.validate(i),n.piece.length===0&&l.push(n);const y=this.s(u,r.remainder);this.D(u,y),u.piece.length===0&&l.push(u);const k=n.next();for(let R=k;R!==T.$qD&&R!==u;R=R.next())l.push(R);const S=n.piece.length===0?n.prev():n;this.v(l),this.O(S),this.y()}o(i,a){const t=[];if(this.K()&&this.M(i)&&this.L(a)){const u=a.piece,l={line:u.start.line+1,column:0},g=new P(u.bufferIndex,l,u.end,this.t(u.bufferIndex,l,u.end),u.length-1);a.piece=g,i+=`
`,(0,T.$xD)(this,a,-1,-1),a.piece.length===0&&t.push(a)}const r=this.w(i);let n=this.T(a,r[r.length-1]);for(let u=r.length-2;u>=0;u--)n=this.T(n,r[u]);this.N(n),this.v(t)}q(i,a){this.Q(i,a)&&(i+=`
`);const t=this.w(i),r=this.S(a,t[0]);let n=r;for(let u=1;u<t.length;u++)n=this.S(n,t[u]);this.N(r)}s(i,a,t){const r=i.piece,n=i.piece.bufferIndex,u=this.a[n].lineStarts,g=u[r.start.line]+r.start.column+a;let y=r.start.line,k=r.end.line,S=0,R=0,C=0;for(;y<=k&&(S=y+(k-y)/2|0,C=u[S],S!==k);)if(R=u[S+1],g<C)k=S-1;else if(g>=R)y=S+1;else break;return t?(t.line=S,t.column=g-C,null):{line:S,column:g-C}}t(i,a,t){if(t.column===0)return t.line-a.line;const r=this.a[i].lineStarts;if(t.line===r.length-1)return t.line-a.line;const n=r[t.line+1],u=r[t.line]+t.column;if(n>u+1)return t.line-a.line;const l=u-1;return this.a[i].buffer.charCodeAt(l)===13?t.line-a.line+1:t.line-a.line}u(i,a){return this.a[i].lineStarts[a.line]+a.column}v(i){for(let a=0;a<i.length;a++)(0,T.$vD)(this,i[a])}w(i){if(i.length>p){const k=[];for(;i.length>p;){const R=i.charCodeAt(p-1);let C;R===s.CharCode.CarriageReturn||R>=55296&&R<=56319?(C=i.substring(0,p-1),i=i.substring(p-1)):(C=i.substring(0,p),i=i.substring(p));const w=E(C);k.push(new P(this.a.length,{line:0,column:0},{line:w.length-1,column:C.length-w[w.length-1]},w.length-1,C.length)),this.a.push(new v(C,w))}const S=E(i);return k.push(new P(this.a.length,{line:0,column:0},{line:S.length-1,column:i.length-S[S.length-1]},S.length-1,i.length)),this.a.push(new v(i,S)),k}let a=this.a[0].buffer.length;const t=E(i,!1);let r=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===a&&a!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},r=this.g;for(let k=0;k<t.length;k++)t[k]+=a+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,a+=1}else{if(a!==0)for(let k=0;k<t.length;k++)t[k]+=a;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const n=this.a[0].buffer.length,u=this.a[0].lineStarts.length-1,l=n-this.a[0].lineStarts[u],g={line:u,column:l},y=new P(0,r,g,this.t(0,r,g),n-a);return this.g=g,[y]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,a=0){let t=this.root,r="";const n=this.h.get2(i);if(n){t=n.node;const u=this.B(t,i-n.nodeStartLineNumber-1),l=this.a[t.piece.bufferIndex].buffer,g=this.u(t.piece.bufferIndex,t.piece.start);if(n.nodeStartLineNumber+t.piece.lineFeedCnt===i)r=l.substring(g+u,g+t.piece.length);else{const y=this.B(t,i-n.nodeStartLineNumber);return l.substring(g+u,g+y-a)}}else{let u=0;const l=i;for(;t!==T.$qD;)if(t.left!==T.$qD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const g=this.B(t,i-t.lf_left-2),y=this.B(t,i-t.lf_left-1),k=this.a[t.piece.bufferIndex].buffer,S=this.u(t.piece.bufferIndex,t.piece.start);return u+=t.size_left,this.h.set({node:t,nodeStartOffset:u,nodeStartLineNumber:l-(i-1-t.lf_left)}),k.substring(S+g,S+y-a)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const g=this.B(t,i-t.lf_left-2),y=this.a[t.piece.bufferIndex].buffer,k=this.u(t.piece.bufferIndex,t.piece.start);r=y.substring(k+g,k+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,u+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==T.$qD;){const u=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const l=this.B(t,0),g=this.u(t.piece.bufferIndex,t.piece.start);return r+=u.substring(g,g+l-a),r}else{const l=this.u(t.piece.bufferIndex,t.piece.start);r+=u.substr(l,t.piece.length)}t=t.next()}return r}y(){let i=this.root,a=1,t=0;for(;i!==T.$qD;)a+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=a,this.c=t,this.h.validate(this.c)}A(i,a){const t=i.piece,r=this.s(i,a),n=r.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===a){const u=this.t(i.piece.bufferIndex,t.start,r);if(u!==n)return{index:u,remainder:0}}return{index:n,remainder:r.column}}B(i,a){if(a<0)return 0;const t=i.piece,r=this.a[t.bufferIndex].lineStarts,n=t.start.line+a+1;return n>t.end.line?r[t.end.line]+t.end.column-r[t.start.line]-t.start.column:r[n]-r[t.start.line]-t.start.column}C(i,a){const t=i.piece,r=t.lineFeedCnt,n=this.u(t.bufferIndex,t.end),u=a,l=this.u(t.bufferIndex,u),g=this.t(t.bufferIndex,t.start,u),y=g-r,k=l-n,S=t.length+k;i.piece=new P(t.bufferIndex,t.start,u,g,S),(0,T.$xD)(this,i,k,y)}D(i,a){const t=i.piece,r=t.lineFeedCnt,n=this.u(t.bufferIndex,t.start),u=a,l=this.t(t.bufferIndex,u,t.end),g=this.u(t.bufferIndex,u),y=l-r,k=n-g,S=t.length+k;i.piece=new P(t.bufferIndex,u,t.end,l,S),(0,T.$xD)(this,i,k,y)}E(i,a,t){const r=i.piece,n=r.start,u=r.end,l=r.length,g=r.lineFeedCnt,y=a,k=this.t(r.bufferIndex,r.start,y),S=this.u(r.bufferIndex,a)-this.u(r.bufferIndex,n);i.piece=new P(r.bufferIndex,r.start,y,k,S),(0,T.$xD)(this,i,S-l,k-g);const R=new P(r.bufferIndex,t,u,this.t(r.bufferIndex,t,u),this.u(r.bufferIndex,u)-this.u(r.bufferIndex,t)),C=this.S(i,R);this.N(C)}F(i,a){this.Q(a,i)&&(a+=`
`);const t=this.K()&&this.L(a)&&this.M(i),r=this.a[0].buffer.length;this.a[0].buffer+=a;const n=E(a,!1);for(let C=0;C<n.length;C++)n[C]+=r;if(t){const C=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:r-C}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const u=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[u],g={line:u,column:l},y=i.piece.length+a.length,k=i.piece.lineFeedCnt,S=this.t(0,i.piece.start,g),R=S-k;i.piece=new P(i.piece.bufferIndex,i.piece.start,g,S,y),this.g=g,(0,T.$xD)(this,i,a.length,R)}G(i){let a=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let r=0;for(;a!==T.$qD;)if(a.size_left>i)a=a.left;else if(a.size_left+a.piece.length>=i){r+=a.size_left;const n={node:a,remainder:i-a.size_left,nodeStartOffset:r};return this.h.set(n),n}else i-=a.size_left+a.piece.length,r+=a.size_left+a.piece.length,a=a.right;return null}H(i,a){let t=this.root,r=0;for(;t!==T.$qD;)if(t.left!==T.$qD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const n=this.B(t,i-t.lf_left-2),u=this.B(t,i-t.lf_left-1);return r+=t.size_left,{node:t,remainder:Math.min(n+a-1,u),nodeStartOffset:r}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const n=this.B(t,i-t.lf_left-2);if(n+a-1<=t.piece.length)return{node:t,remainder:n+a-1,nodeStartOffset:r};a-=t.piece.length-n;break}else i-=t.lf_left+t.piece.lineFeedCnt,r+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==T.$qD;){if(t.piece.lineFeedCnt>0){const n=this.B(t,0),u=this.J(t);return{node:t,remainder:Math.min(a-1,n),nodeStartOffset:u}}else if(t.piece.length>=a-1){const n=this.J(t);return{node:t,remainder:a-1,nodeStartOffset:n}}else a-=t.piece.length;t=t.next()}return null}I(i,a){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],r=this.u(i.piece.bufferIndex,i.piece.start)+a;return t.buffer.charCodeAt(r)}J(i){if(!i)return 0;let a=i.size_left;for(;i!==this.root;)i.parent.right===i&&(a+=i.parent.size_left+i.parent.piece.length),i=i.parent;return a}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===T.$qD||i.piece.lineFeedCnt===0)return!1;const a=i.piece,t=this.a[a.bufferIndex].lineStarts,r=a.start.line,n=t[r]+a.start.column;return r===t.length-1||t[r+1]>n+1?!1:this.a[a.bufferIndex].buffer.charCodeAt(n)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===T.$qD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const a=i.prev();this.M(a)&&this.P(a,i)}}O(i){if(this.K()&&this.M(i)){const a=i.next();this.L(a)&&this.P(i,a)}}P(i,a){const t=[],r=this.a[i.piece.bufferIndex].lineStarts;let n;i.piece.end.column===0?n={line:i.piece.end.line-1,column:r[i.piece.end.line]-r[i.piece.end.line-1]-1}:n={line:i.piece.end.line,column:i.piece.end.column-1};const u=i.piece.length-1,l=i.piece.lineFeedCnt-1;i.piece=new P(i.piece.bufferIndex,i.piece.start,n,l,u),(0,T.$xD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const g={line:a.piece.start.line+1,column:0},y=a.piece.length-1,k=this.t(a.piece.bufferIndex,g,a.piece.end);a.piece=new P(a.piece.bufferIndex,g,a.piece.end,k,y),(0,T.$xD)(this,a,-1,-1),a.piece.length===0&&t.push(a);const S=this.w(`\r
`);this.S(i,S[0]);for(let R=0;R<t.length;R++)(0,T.$vD)(this,t[R])}Q(i,a){if(this.K()&&this.M(i)){const t=a.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,T.$vD)(this,t);else{const r=t.piece,n={line:r.start.line+1,column:0},u=r.length-1,l=this.t(r.bufferIndex,n,r.end);t.piece=new P(r.bufferIndex,n,r.end,l,u),(0,T.$xD)(this,t,-1,-1)}return!0}}return!1}iterate(i,a){if(i===T.$qD)return a(T.$qD);const t=this.iterate(i.left,a);return t&&a(i)&&this.iterate(i.right,a)}R(i){if(i===T.$qD)return"";const a=this.a[i.piece.bufferIndex],t=i.piece,r=this.u(t.bufferIndex,t.start),n=this.u(t.bufferIndex,t.end);return a.buffer.substring(r,n)}getPieceContent(i){const a=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),r=this.u(i.bufferIndex,i.end);return a.buffer.substring(t,r)}S(i,a){const t=new T.$pD(a,T.NodeColor.Red);if(t.left=T.$qD,t.right=T.$qD,t.parent=T.$qD,t.size_left=0,t.lf_left=0,this.root===T.$qD)this.root=t,t.color=T.NodeColor.Black;else if(i.right===T.$qD)i.right=t,t.parent=i;else{const n=(0,T.$rD)(i.right);n.left=t,t.parent=n}return(0,T.$wD)(this,t),t}T(i,a){const t=new T.$pD(a,T.NodeColor.Red);if(t.left=T.$qD,t.right=T.$qD,t.parent=T.$qD,t.size_left=0,t.lf_left=0,this.root===T.$qD)this.root=t,t.color=T.NodeColor.Black;else if(i.left===T.$qD)i.left=t,t.parent=i;else{const r=(0,T.$sD)(i.left);r.right=t,t.parent=r}return(0,T.$wD)(this,t),t}U(i){let a="";return this.iterate(i,t=>(a+=this.R(t),!0)),a}}e.$JD=$}),define(Re[205],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tab=e.$sab=void 0;class s{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const T=this.a.get(O);return this.a.delete(O),T}}addDragOperationTransfer(O,T){this.a.set(O,T)}}e.$sab=s;class h{constructor(O){this.identifier=O}}e.$tab=h}),define(Re[206],Ce([1,0,4,3,105]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iu=void 0;class O{constructor(){this.a=new Map,this.b=new Map,this.c=new s.$qe,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,c){return this.a.set(p,c),this.handleChange([p]),(0,h.$Xc)(()=>{this.a.get(p)===c&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,c){this.b.get(p)?.dispose();const I=new T(this,p,c);return this.b.set(p,I),(0,h.$Xc)(()=>{const E=this.b.get(p);!E||E!==I||(this.b.delete(p),E.dispose())})}async getOrCreate(p){const c=this.get(p);if(c)return c;const I=this.b.get(p);return!I||I.isResolved?null:(await I.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const I=this.b.get(p);return!!(!I||I.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>D.ColorId.DefaultBackground?this.d[D.ColorId.DefaultBackground]:null}}e.$Iu=O;class T extends h.$Zc{get isResolved(){return this.c}constructor(p,c,I){super(),this.f=p,this.g=c,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(Re[142],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a=s,e.$b=h;function s(){return globalThis._VSCODE_NLS_MESSAGES}function h(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(Re[7],Ce([1,0,142,142]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=T,e.localize2=p,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return h.$b}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return h.$a}});const D=(0,s.$b)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function O(c,I){let E;return I.length===0?E=c:E=c.replace(/\{(\d+)\}/g,(f,P)=>{const v=P[0],o=I[v];let m=f;return typeof o=="string"?m=o:(typeof o=="number"||typeof o=="boolean"||o===void 0||o===null)&&(m=String(o)),m}),D&&(E="\uFF3B"+E.replace(/[aouei]/g,"$&$&")+"\uFF3D"),E}function T(c,I,...E){return O(typeof c=="number"?A(c,I):I,E)}function A(c,I){const E=(0,s.$a)()?.[c];if(typeof E!="string"){if(typeof I=="string")return I;throw new Error(`!!! NLS MISSING: ${c} !!!`)}return E}function p(c,I,...E){let f;typeof c=="number"?f=A(c,I):f=I;const P=O(f,E);return{value:P,original:I===f?P:O(I,E)}}}),define(Re[207],Ce([1,0,4,3,7]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0,e.$uj=I,D=Ue(D);class O extends h.$Zc{constructor(f,P="",v="",o=!0,m){super(),this.j=this.B(new s.$qe),this.onDidChange=this.j.event,this.z=!0,this.m=f,this.n=P,this.w=v,this.z=o,this.D=m}get id(){return this.m}get label(){return this.n}set label(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.j.fire({label:f}))}get tooltip(){return this.u||""}set tooltip(f){this.G(f)}G(f){this.u!==f&&(this.u=f,this.j.fire({tooltip:f}))}get class(){return this.w}set class(f){this.H(f)}H(f){this.w!==f&&(this.w=f,this.j.fire({class:f}))}get enabled(){return this.z}set enabled(f){this.I(f)}I(f){this.z!==f&&(this.z=f,this.j.fire({enabled:f}))}get checked(){return this.C}set checked(f){this.J(f)}J(f){this.C!==f&&(this.C=f,this.j.fire({checked:f}))}async run(f,P){this.D&&await this.D(f)}}e.$pj=O;class T extends h.$Zc{constructor(){super(...arguments),this.f=this.B(new s.$qe),this.onWillRun=this.f.event,this.m=this.B(new s.$qe),this.onDidRun=this.m.event}async run(f,P){if(!f.enabled)return;this.f.fire({action:f});let v;try{await this.u(f,P)}catch(o){v=o}this.m.fire({action:f,error:v})}async u(f,P){await f.run(P)}}e.$qj=T;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let P=[];for(const v of f)v.length&&(P.length?P=[...P,new A,...v]:P=v);return P}static{this.ID="vs.actions.separator"}async run(){}}e.$rj=A;class p{get actions(){return this.a}constructor(f,P,v,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=P,this.class=o,this.a=v}async run(){}}e.$sj=p;class c extends O{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,D.localize(41,null),void 0,!1)}}e.$tj=c;function I(E){return{id:E.id,label:E.label,tooltip:E.tooltip??E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...f)=>E.run(...f)}}}),define(Re[208],Ce([1,0,7]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=c,e.$0m=I,e.$$m=E,e.$_m=f;const h=60,D=h*60,O=D*24,T=O*7,A=O*30,p=O*365;function c(P,v,o,m){typeof P!="number"&&(P=P.getTime());const $=Math.round((new Date().getTime()-P)/1e3);if($<-30)return(0,s.localize)(42,null,c(new Date().getTime()+$*1e3,!1));if(!m&&$<30)return(0,s.localize)(43,null);let d;return $<h?(d=$,v?d===1?o?(0,s.localize)(44,null,d):(0,s.localize)(45,null,d):o?(0,s.localize)(46,null,d):(0,s.localize)(47,null,d):d===1?o?(0,s.localize)(48,null,d):(0,s.localize)(49,null,d):o?(0,s.localize)(50,null,d):(0,s.localize)(51,null,d)):$<D?(d=Math.floor($/h),v?d===1?o?(0,s.localize)(52,null,d):(0,s.localize)(53,null,d):o?(0,s.localize)(54,null,d):(0,s.localize)(55,null,d):d===1?o?(0,s.localize)(56,null,d):(0,s.localize)(57,null,d):o?(0,s.localize)(58,null,d):(0,s.localize)(59,null,d)):$<O?(d=Math.floor($/D),v?d===1?o?(0,s.localize)(60,null,d):(0,s.localize)(61,null,d):o?(0,s.localize)(62,null,d):(0,s.localize)(63,null,d):d===1?o?(0,s.localize)(64,null,d):(0,s.localize)(65,null,d):o?(0,s.localize)(66,null,d):(0,s.localize)(67,null,d)):$<T?(d=Math.floor($/O),v?d===1?(0,s.localize)(68,null,d):(0,s.localize)(69,null,d):d===1?(0,s.localize)(70,null,d):(0,s.localize)(71,null,d)):$<A?(d=Math.floor($/T),v?d===1?o?(0,s.localize)(72,null,d):(0,s.localize)(73,null,d):o?(0,s.localize)(74,null,d):(0,s.localize)(75,null,d):d===1?o?(0,s.localize)(76,null,d):(0,s.localize)(77,null,d):o?(0,s.localize)(78,null,d):(0,s.localize)(79,null,d)):$<p?(d=Math.floor($/A),v?d===1?o?(0,s.localize)(80,null,d):(0,s.localize)(81,null,d):o?(0,s.localize)(82,null,d):(0,s.localize)(83,null,d):d===1?o?(0,s.localize)(84,null,d):(0,s.localize)(85,null,d):o?(0,s.localize)(86,null,d):(0,s.localize)(87,null,d)):(d=Math.floor($/p),v?d===1?o?(0,s.localize)(88,null,d):(0,s.localize)(89,null,d):o?(0,s.localize)(90,null,d):(0,s.localize)(91,null,d):d===1?o?(0,s.localize)(92,null,d):(0,s.localize)(93,null,d):o?(0,s.localize)(94,null,d):(0,s.localize)(95,null,d))}function I(P,v,o){typeof P!="number"&&(P=P.getTime());const m=new Date;m.setHours(0,0,0,0);const $=new Date(m.getTime());return $.setDate($.getDate()-1),P>m.getTime()?(0,s.localize)(96,null):P>$.getTime()?(0,s.localize)(97,null):c(P,v,o)}function E(P,v){const o=Math.abs(P/1e3);return o<1?v?(0,s.localize)(98,null,P):(0,s.localize)(99,null,P):o<h?v?(0,s.localize)(100,null,Math.round(P)/1e3):(0,s.localize)(101,null,Math.round(P)/1e3):o<D?v?(0,s.localize)(102,null,Math.round(P/(1e3*h))):(0,s.localize)(103,null,Math.round(P/(1e3*h))):o<O?v?(0,s.localize)(104,null,Math.round(P/(1e3*D))):(0,s.localize)(105,null,Math.round(P/(1e3*D))):(0,s.localize)(106,null,Math.round(P/(1e3*O)))}function f(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Re[52],Ce([1,0,18,17,7]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=p,e.$wj=c,e.$xj=I,s=Ue(s),h=Ue(h),D=Ue(D);function O(E,f){return f&&(E.stack||E.stacktrace)?D.localize(107,null,A(E),T(E.stack)||T(E.stacktrace)):A(E)}function T(E){return Array.isArray(E)?E.join(`
`):E}function A(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?D.localize(108,null,E.message):E.message||D.localize(109,null)}function p(E=null,f=!1){if(!E)return D.localize(110,null);if(Array.isArray(E)){const P=s.$Lb(E),v=p(P[0],f);return P.length>1?D.localize(111,null,v,P.length):v}if(h.$jg(E))return E;if(E.detail){const P=E.detail;if(P.error)return O(P.error,f);if(P.exception)return O(P.exception,f)}return E.stack?O(E,f):E.message?E.message:D.localize(112,null)}function c(E){const f=E;return f instanceof Error&&Array.isArray(f.actions)}function I(E,f){let P;return typeof E=="string"?P=new Error(E):P=E,P.actions=f,P}}),define(Re[10],Ce([1,0,7]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=e.$H=e.OS=e.OperatingSystem=e.$E=e.$D=e.$C=e.$B=e.$A=e.Language=e.$z=e.$y=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.Platform=e.$j=void 0,e.$k=n,e.$G=S,e.$M=R,s=Ue(s),e.$j="en";let h=!1,D=!1,O=!1,T=!1,A=!1,p=!1,c=!1,I=!1,E=!1,f=!1,P,v=e.$j,o=e.$j,m,$;const d=globalThis;let i;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?i=d.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const a=typeof i?.versions?.electron=="string",t=a&&i?.type==="renderer";if(typeof i=="object"){h=i.platform==="win32",D=i.platform==="darwin",O=i.platform==="linux",T=O&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,c=a,E=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,P=e.$j,v=e.$j;const C=i.env.VSCODE_NLS_CONFIG;if(C)try{const w=JSON.parse(C);P=w.userLocale,o=w.osLocale,v=w.resolvedLanguage||e.$j,m=w.languagePack?.translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!t?($=navigator.userAgent,h=$.indexOf("Windows")>=0,D=$.indexOf("Macintosh")>=0,I=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=$.indexOf("Linux")>=0,f=$?.indexOf("Mobi")>=0,p=!0,v=s.getNLSLanguage()||e.$j,P=navigator.language.toLowerCase(),o=P):console.error("Unable to resolve platform.");var r;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(r||(e.Platform=r={}));function n(C){switch(C){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let u=r.Web;D?u=r.Mac:h?u=r.Windows:O&&(u=r.Linux),e.$l=h,e.$m=D,e.$n=O,e.$o=T,e.$p=A,e.$q=c,e.$r=p,e.$s=p&&typeof d.importScripts=="function",e.$t=e.$s?d.origin:void 0,e.$u=I,e.$v=f,e.$w=E,e.$x=u,e.$y=$,e.$z=v;var l;(function(C){function w(){return e.$z}C.value=w;function b(){return e.$z.length===2?e.$z==="en":e.$z.length>=3?e.$z[0]==="e"&&e.$z[1]==="n"&&e.$z[2]==="-":!1}C.isDefaultVariant=b;function N(){return e.$z==="en"}C.isDefault=N})(l||(e.Language=l={})),e.$A=P,e.$B=o,e.$C=m,e.$D=typeof d.postMessage=="function"&&!d.importScripts,e.$E=(()=>{if(e.$D){const C=[];d.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let N=0,L=C.length;N<L;N++){const M=C[N];if(M.id===b.data.vscodeScheduleAsyncWork){C.splice(N,1),M.callback();return}}});let w=0;return b=>{const N=++w;C.push({id:N,callback:b}),d.postMessage({vscodeScheduleAsyncWork:N},"*")}}return C=>setTimeout(C)})();var g;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(g||(e.OperatingSystem=g={})),e.OS=D||I?g.Macintosh:h?g.Windows:g.Linux;let y=!0,k=!1;function S(){if(!k){k=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,y=new Uint16Array(C.buffer)[0]===513}return y}e.$H=!!(e.$y&&e.$y.indexOf("Chrome")>=0),e.$I=!!(e.$y&&e.$y.indexOf("Firefox")>=0),e.$J=!!(!e.$H&&e.$y&&e.$y.indexOf("Safari")>=0),e.$K=!!(e.$y&&e.$y.indexOf("Edg/")>=0),e.$L=!!(e.$y&&e.$y.indexOf("Android")>=0);function R(C){return parseFloat(C)>=20}}),define(Re[57],Ce([1,0,10]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jc=e.$ic=e.env=e.cwd=void 0;let h;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.process<"u"){const O=D.process;h={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return s.$l?"win32":s.$m?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$ic=h.platform,e.$jc=h.arch}),define(Re[16],Ce([1,0,57]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.sep=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=void 0,s=Ue(s);const h=65,D=97,O=90,T=122,A=46,p=47,c=92,I=58,E=63;class f extends Error{constructor(u,l,g){let y;typeof l=="string"&&l.indexOf("not ")===0?(y="must not be",l=l.replace(/^not /,"")):y="must be";const k=u.indexOf(".")!==-1?"property":"argument";let S=`The "${u}" ${k} ${y} of type ${l}`;S+=`. Received type ${typeof g}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function P(n,u){if(n===null||typeof n!="object")throw new f(u,"Object",n)}function v(n,u){if(typeof n!="string")throw new f(u,"string",n)}const o=s.$ic==="win32";function m(n){return n===p||n===c}function $(n){return n===p}function d(n){return n>=h&&n<=O||n>=D&&n<=T}function i(n,u,l,g){let y="",k=0,S=-1,R=0,C=0;for(let w=0;w<=n.length;++w){if(w<n.length)C=n.charCodeAt(w);else{if(g(C))break;C=p}if(g(C)){if(!(S===w-1||R===1))if(R===2){if(y.length<2||k!==2||y.charCodeAt(y.length-1)!==A||y.charCodeAt(y.length-2)!==A){if(y.length>2){const b=y.lastIndexOf(l);b===-1?(y="",k=0):(y=y.slice(0,b),k=y.length-1-y.lastIndexOf(l)),S=w,R=0;continue}else if(y.length!==0){y="",k=0,S=w,R=0;continue}}u&&(y+=y.length>0?`${l}..`:"..",k=2)}else y.length>0?y+=`${l}${n.slice(S+1,w)}`:y=n.slice(S+1,w),k=w-S-1;S=w,R=0}else C===A&&R!==-1?++R:R=-1}return y}function a(n){return n?`${n[0]==="."?"":"."}${n}`:""}function t(n,u){P(u,"pathObject");const l=u.dir||u.root,g=u.base||`${u.name||""}${a(u.ext)}`;return l?l===u.root?`${l}${g}`:`${l}${n}${g}`:g}e.$kc={resolve(...n){let u="",l="",g=!1;for(let y=n.length-1;y>=-1;y--){let k;if(y>=0){if(k=n[y],v(k,`paths[${y}]`),k.length===0)continue}else u.length===0?k=s.cwd():(k=s.env[`=${u}`]||s.cwd(),(k===void 0||k.slice(0,2).toLowerCase()!==u.toLowerCase()&&k.charCodeAt(2)===c)&&(k=`${u}\\`));const S=k.length;let R=0,C="",w=!1;const b=k.charCodeAt(0);if(S===1)m(b)&&(R=1,w=!0);else if(m(b))if(w=!0,m(k.charCodeAt(1))){let N=2,L=N;for(;N<S&&!m(k.charCodeAt(N));)N++;if(N<S&&N!==L){const M=k.slice(L,N);for(L=N;N<S&&m(k.charCodeAt(N));)N++;if(N<S&&N!==L){for(L=N;N<S&&!m(k.charCodeAt(N));)N++;(N===S||N!==L)&&(C=`\\\\${M}\\${k.slice(L,N)}`,R=N)}}}else R=1;else d(b)&&k.charCodeAt(1)===I&&(C=k.slice(0,2),R=2,S>2&&m(k.charCodeAt(2))&&(w=!0,R=3));if(C.length>0)if(u.length>0){if(C.toLowerCase()!==u.toLowerCase())continue}else u=C;if(g){if(u.length>0)break}else if(l=`${k.slice(R)}\\${l}`,g=w,w&&u.length>0)break}return l=i(l,!g,"\\",m),g?`${u}\\${l}`:`${u}${l}`||"."},normalize(n){v(n,"path");const u=n.length;if(u===0)return".";let l=0,g,y=!1;const k=n.charCodeAt(0);if(u===1)return $(k)?"\\":n;if(m(k))if(y=!0,m(n.charCodeAt(1))){let R=2,C=R;for(;R<u&&!m(n.charCodeAt(R));)R++;if(R<u&&R!==C){const w=n.slice(C,R);for(C=R;R<u&&m(n.charCodeAt(R));)R++;if(R<u&&R!==C){for(C=R;R<u&&!m(n.charCodeAt(R));)R++;if(R===u)return`\\\\${w}\\${n.slice(C)}\\`;R!==C&&(g=`\\\\${w}\\${n.slice(C,R)}`,l=R)}}}else l=1;else d(k)&&n.charCodeAt(1)===I&&(g=n.slice(0,2),l=2,u>2&&m(n.charCodeAt(2))&&(y=!0,l=3));let S=l<u?i(n.slice(l),!y,"\\",m):"";return S.length===0&&!y&&(S="."),S.length>0&&m(n.charCodeAt(u-1))&&(S+="\\"),g===void 0?y?`\\${S}`:S:y?`${g}\\${S}`:`${g}${S}`},isAbsolute(n){v(n,"path");const u=n.length;if(u===0)return!1;const l=n.charCodeAt(0);return m(l)||u>2&&d(l)&&n.charCodeAt(1)===I&&m(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let u,l;for(let k=0;k<n.length;++k){const S=n[k];v(S,"path"),S.length>0&&(u===void 0?u=l=S:u+=`\\${S}`)}if(u===void 0)return".";let g=!0,y=0;if(typeof l=="string"&&m(l.charCodeAt(0))){++y;const k=l.length;k>1&&m(l.charCodeAt(1))&&(++y,k>2&&(m(l.charCodeAt(2))?++y:g=!1))}if(g){for(;y<u.length&&m(u.charCodeAt(y));)y++;y>=2&&(u=`\\${u.slice(y)}`)}return e.$kc.normalize(u)},relative(n,u){if(v(n,"from"),v(u,"to"),n===u)return"";const l=e.$kc.resolve(n),g=e.$kc.resolve(u);if(l===g||(n=l.toLowerCase(),u=g.toLowerCase(),n===u))return"";let y=0;for(;y<n.length&&n.charCodeAt(y)===c;)y++;let k=n.length;for(;k-1>y&&n.charCodeAt(k-1)===c;)k--;const S=k-y;let R=0;for(;R<u.length&&u.charCodeAt(R)===c;)R++;let C=u.length;for(;C-1>R&&u.charCodeAt(C-1)===c;)C--;const w=C-R,b=S<w?S:w;let N=-1,L=0;for(;L<b;L++){const z=n.charCodeAt(y+L);if(z!==u.charCodeAt(R+L))break;z===c&&(N=L)}if(L!==b){if(N===-1)return g}else{if(w>b){if(u.charCodeAt(R+L)===c)return g.slice(R+L+1);if(L===2)return g.slice(R+L)}S>b&&(n.charCodeAt(y+L)===c?N=L:L===2&&(N=3)),N===-1&&(N=0)}let M="";for(L=y+N+1;L<=k;++L)(L===k||n.charCodeAt(L)===c)&&(M+=M.length===0?"..":"\\..");return R+=N,M.length>0?`${M}${g.slice(R,C)}`:(g.charCodeAt(R)===c&&++R,g.slice(R,C))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const u=e.$kc.resolve(n);if(u.length<=2)return n;if(u.charCodeAt(0)===c){if(u.charCodeAt(1)===c){const l=u.charCodeAt(2);if(l!==E&&l!==A)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(d(u.charCodeAt(0))&&u.charCodeAt(1)===I&&u.charCodeAt(2)===c)return`\\\\?\\${u}`;return n},dirname(n){v(n,"path");const u=n.length;if(u===0)return".";let l=-1,g=0;const y=n.charCodeAt(0);if(u===1)return m(y)?n:".";if(m(y)){if(l=g=1,m(n.charCodeAt(1))){let R=2,C=R;for(;R<u&&!m(n.charCodeAt(R));)R++;if(R<u&&R!==C){for(C=R;R<u&&m(n.charCodeAt(R));)R++;if(R<u&&R!==C){for(C=R;R<u&&!m(n.charCodeAt(R));)R++;if(R===u)return n;R!==C&&(l=g=R+1)}}}}else d(y)&&n.charCodeAt(1)===I&&(l=u>2&&m(n.charCodeAt(2))?3:2,g=l);let k=-1,S=!0;for(let R=u-1;R>=g;--R)if(m(n.charCodeAt(R))){if(!S){k=R;break}}else S=!1;if(k===-1){if(l===-1)return".";k=l}return n.slice(0,k)},basename(n,u){u!==void 0&&v(u,"suffix"),v(n,"path");let l=0,g=-1,y=!0,k;if(n.length>=2&&d(n.charCodeAt(0))&&n.charCodeAt(1)===I&&(l=2),u!==void 0&&u.length>0&&u.length<=n.length){if(u===n)return"";let S=u.length-1,R=-1;for(k=n.length-1;k>=l;--k){const C=n.charCodeAt(k);if(m(C)){if(!y){l=k+1;break}}else R===-1&&(y=!1,R=k+1),S>=0&&(C===u.charCodeAt(S)?--S===-1&&(g=k):(S=-1,g=R))}return l===g?g=R:g===-1&&(g=n.length),n.slice(l,g)}for(k=n.length-1;k>=l;--k)if(m(n.charCodeAt(k))){if(!y){l=k+1;break}}else g===-1&&(y=!1,g=k+1);return g===-1?"":n.slice(l,g)},extname(n){v(n,"path");let u=0,l=-1,g=0,y=-1,k=!0,S=0;n.length>=2&&n.charCodeAt(1)===I&&d(n.charCodeAt(0))&&(u=g=2);for(let R=n.length-1;R>=u;--R){const C=n.charCodeAt(R);if(m(C)){if(!k){g=R+1;break}continue}y===-1&&(k=!1,y=R+1),C===A?l===-1?l=R:S!==1&&(S=1):l!==-1&&(S=-1)}return l===-1||y===-1||S===0||S===1&&l===y-1&&l===g+1?"":n.slice(l,y)},format:t.bind(null,"\\"),parse(n){v(n,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return u;const l=n.length;let g=0,y=n.charCodeAt(0);if(l===1)return m(y)?(u.root=u.dir=n,u):(u.base=u.name=n,u);if(m(y)){if(g=1,m(n.charCodeAt(1))){let N=2,L=N;for(;N<l&&!m(n.charCodeAt(N));)N++;if(N<l&&N!==L){for(L=N;N<l&&m(n.charCodeAt(N));)N++;if(N<l&&N!==L){for(L=N;N<l&&!m(n.charCodeAt(N));)N++;N===l?g=N:N!==L&&(g=N+1)}}}}else if(d(y)&&n.charCodeAt(1)===I){if(l<=2)return u.root=u.dir=n,u;if(g=2,m(n.charCodeAt(2))){if(l===3)return u.root=u.dir=n,u;g=3}}g>0&&(u.root=n.slice(0,g));let k=-1,S=g,R=-1,C=!0,w=n.length-1,b=0;for(;w>=g;--w){if(y=n.charCodeAt(w),m(y)){if(!C){S=w+1;break}continue}R===-1&&(C=!1,R=w+1),y===A?k===-1?k=w:b!==1&&(b=1):k!==-1&&(b=-1)}return R!==-1&&(k===-1||b===0||b===1&&k===R-1&&k===S+1?u.base=u.name=n.slice(S,R):(u.name=n.slice(S,k),u.base=n.slice(S,R),u.ext=n.slice(k,R))),S>0&&S!==g?u.dir=n.slice(0,S-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const r=(()=>{if(o){const n=/\\/g;return()=>{const u=s.cwd().replace(n,"/");return u.slice(u.indexOf("/"))}}return()=>s.cwd()})();e.$lc={resolve(...n){let u="",l=!1;for(let g=n.length-1;g>=-1&&!l;g--){const y=g>=0?n[g]:r();v(y,`paths[${g}]`),y.length!==0&&(u=`${y}/${u}`,l=y.charCodeAt(0)===p)}return u=i(u,!l,"/",$),l?`/${u}`:u.length>0?u:"."},normalize(n){if(v(n,"path"),n.length===0)return".";const u=n.charCodeAt(0)===p,l=n.charCodeAt(n.length-1)===p;return n=i(n,!u,"/",$),n.length===0?u?"/":l?"./":".":(l&&(n+="/"),u?`/${n}`:n)},isAbsolute(n){return v(n,"path"),n.length>0&&n.charCodeAt(0)===p},join(...n){if(n.length===0)return".";let u;for(let l=0;l<n.length;++l){const g=n[l];v(g,"path"),g.length>0&&(u===void 0?u=g:u+=`/${g}`)}return u===void 0?".":e.$lc.normalize(u)},relative(n,u){if(v(n,"from"),v(u,"to"),n===u||(n=e.$lc.resolve(n),u=e.$lc.resolve(u),n===u))return"";const l=1,g=n.length,y=g-l,k=1,S=u.length-k,R=y<S?y:S;let C=-1,w=0;for(;w<R;w++){const N=n.charCodeAt(l+w);if(N!==u.charCodeAt(k+w))break;N===p&&(C=w)}if(w===R)if(S>R){if(u.charCodeAt(k+w)===p)return u.slice(k+w+1);if(w===0)return u.slice(k+w)}else y>R&&(n.charCodeAt(l+w)===p?C=w:w===0&&(C=0));let b="";for(w=l+C+1;w<=g;++w)(w===g||n.charCodeAt(w)===p)&&(b+=b.length===0?"..":"/..");return`${b}${u.slice(k+C)}`},toNamespacedPath(n){return n},dirname(n){if(v(n,"path"),n.length===0)return".";const u=n.charCodeAt(0)===p;let l=-1,g=!0;for(let y=n.length-1;y>=1;--y)if(n.charCodeAt(y)===p){if(!g){l=y;break}}else g=!1;return l===-1?u?"/":".":u&&l===1?"//":n.slice(0,l)},basename(n,u){u!==void 0&&v(u,"ext"),v(n,"path");let l=0,g=-1,y=!0,k;if(u!==void 0&&u.length>0&&u.length<=n.length){if(u===n)return"";let S=u.length-1,R=-1;for(k=n.length-1;k>=0;--k){const C=n.charCodeAt(k);if(C===p){if(!y){l=k+1;break}}else R===-1&&(y=!1,R=k+1),S>=0&&(C===u.charCodeAt(S)?--S===-1&&(g=k):(S=-1,g=R))}return l===g?g=R:g===-1&&(g=n.length),n.slice(l,g)}for(k=n.length-1;k>=0;--k)if(n.charCodeAt(k)===p){if(!y){l=k+1;break}}else g===-1&&(y=!1,g=k+1);return g===-1?"":n.slice(l,g)},extname(n){v(n,"path");let u=-1,l=0,g=-1,y=!0,k=0;for(let S=n.length-1;S>=0;--S){const R=n.charCodeAt(S);if(R===p){if(!y){l=S+1;break}continue}g===-1&&(y=!1,g=S+1),R===A?u===-1?u=S:k!==1&&(k=1):u!==-1&&(k=-1)}return u===-1||g===-1||k===0||k===1&&u===g-1&&u===l+1?"":n.slice(u,g)},format:t.bind(null,"/"),parse(n){v(n,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return u;const l=n.charCodeAt(0)===p;let g;l?(u.root="/",g=1):g=0;let y=-1,k=0,S=-1,R=!0,C=n.length-1,w=0;for(;C>=g;--C){const b=n.charCodeAt(C);if(b===p){if(!R){k=C+1;break}continue}S===-1&&(R=!1,S=C+1),b===A?y===-1?y=C:w!==1&&(w=1):y!==-1&&(w=-1)}if(S!==-1){const b=k===0&&l?1:k;y===-1||w===0||w===1&&y===S-1&&y===k+1?u.base=u.name=n.slice(b,S):(u.name=n.slice(b,y),u.base=n.slice(b,S),u.ext=n.slice(y,S))}return k>0?u.dir=n.slice(0,k-1):l&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.$lc.win32=e.$kc.win32=e.$kc,e.$lc.posix=e.$kc.posix=e.$lc,e.$mc=o?e.$kc.normalize:e.$lc.normalize,e.$nc=o?e.$kc.isAbsolute:e.$lc.isAbsolute,e.$oc=o?e.$kc.join:e.$lc.join,e.$pc=o?e.$kc.resolve:e.$lc.resolve,e.$qc=o?e.$kc.relative:e.$lc.relative,e.$rc=o?e.$kc.dirname:e.$lc.dirname,e.$sc=o?e.$kc.basename:e.$lc.basename,e.$tc=o?e.$kc.extname:e.$lc.extname,e.$uc=o?e.$kc.format:e.$lc.format,e.$vc=o?e.$kc.parse:e.$lc.parse,e.$wc=o?e.$kc.toNamespacedPath:e.$lc.toNamespacedPath,e.sep=o?e.$kc.sep:e.$lc.sep,e.$yc=o?e.$kc.delimiter:e.$lc.delimiter}),define(Re[143],Ce([1,0,50,16]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=A,e.$Lr=p,e.$Mr=c,e.$Nr=I,e.$Or=E,e.$Pr=f,e.$Qr=P,e.$Rr=v,e.$Sr=o,e.$Tr=m,e.$Ur=g,e.$Vr=y,e.$Wr=k;const D=new s.$Y(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),O=new s.$Y(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new s.$Y(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(S,R,C=!1){const w=S||"",b=R||"",N=D.value.collator.compare(w,b);return D.value.collatorIsNumeric&&N===0&&w!==b?w<b?-1:1:N}function p(S,R){const C=O.value.collator;return S=S||"",R=R||"",a(C,S,R)}function c(S,R){const C=O.value.collator;return S=S||"",R=R||"",u(S,R)||a(C,S,R)}function I(S,R){const C=O.value.collator;return S=S||"",R=R||"",n(S,R)||a(C,S,R)}function E(S,R){return S=S||"",R=R||"",S===R?0:S<R?-1:1}function f(S,R){const[C,w]=d(S),[b,N]=d(R);let L=D.value.collator.compare(w,N);if(L===0){if(D.value.collatorIsNumeric&&w!==N)return w<N?-1:1;if(L=D.value.collator.compare(C,b),D.value.collatorIsNumeric&&L===0&&C!==b)return C<b?-1:1}return L}function P(S,R){S=S||"",R=R||"";const C=i(S),w=i(R),b=O.value.collator,N=T.value.collator;return a(N,C,w)||a(b,S,R)}function v(S,R){S=S||"",R=R||"";const C=i(S),w=i(R),b=O.value.collator,N=T.value.collator;return a(N,C,w)||u(S,R)||a(b,S,R)}function o(S,R){S=S||"",R=R||"";const C=i(S),w=i(R),b=O.value.collator,N=T.value.collator;return a(N,C,w)||n(S,R)||a(b,S,R)}function m(S,R){S=S||"",R=R||"";const C=i(S).toLowerCase(),w=i(R).toLowerCase();return C!==w?C<w?-1:1:S!==R?S<R?-1:1:0}const $=/^(.*?)(\.([^.]*))?$/;function d(S,R=!1){const C=S?$.exec(S):[];let w=[C&&C[1]||"",C&&C[3]||""];return R&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function i(S){const R=S?$.exec(S):[];return R&&R[1]&&R[1].charAt(0)!=="."&&R[3]||""}function a(S,R,C){const w=S.compare(R,C);return w!==0?w:R.length!==C.length?R.length<C.length?-1:1:0}function t(S){const R=S.charAt(0);return R.toLocaleUpperCase()!==R}function r(S){const R=S.charAt(0);return R.toLocaleLowerCase()!==R}function n(S,R){return t(S)&&r(R)?-1:r(S)&&t(R)?1:0}function u(S,R){return r(S)&&t(R)?-1:t(S)&&r(R)?1:0}function l(S,R,C=!1){return C||(S=S&&S.toLowerCase(),R=R&&R.toLowerCase()),S===R?0:S<R?-1:1}function g(S,R,C=!1){const w=S.split(h.sep),b=R.split(h.sep),N=w.length-1,L=b.length-1;let M,z;for(let V=0;;V++){if(M=N===V,z=L===V,M&&z)return A(w[V],b[V],C);if(M)return-1;if(z)return 1;const F=l(w[V],b[V],C);if(F!==0)return F}}function y(S,R,C){const w=S.toLowerCase(),b=R.toLowerCase(),N=k(S,R,C);if(N)return N;const L=w.endsWith(C),M=b.endsWith(C);if(L!==M)return L?-1:1;const z=A(w,b);return z!==0?z:w.localeCompare(b)}function k(S,R,C){const w=S.toLowerCase(),b=R.toLowerCase(),N=w.startsWith(C),L=b.startsWith(C);if(N!==L)return N?-1:1;if(N&&L){if(w.length<b.length)return-1;if(w.length>b.length)return 1}return 0}}),define(Re[33],Ce([1,0,26,16,10,13,17]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=A,e.$Dg=p,e.$Eg=c,e.$Fg=I,e.$Gg=E,e.$Hg=o,e.$Ig=m,e.$Jg=$,e.$Kg=d,e.$Lg=i,e.$Mg=a,e.$Ng=t,e.$Og=r,e.$Pg=n,e.$Qg=u,e.$Rg=l,e.$Sg=k;function A(S){return S===s.CharCode.Slash||S===s.CharCode.Backslash}function p(S){return S.replace(/[\\/]/g,h.$lc.sep)}function c(S){return S.indexOf("/")===-1&&(S=p(S)),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S),S}function I(S,R=h.$lc.sep){if(!S)return"";const C=S.length,w=S.charCodeAt(0);if(A(w)){if(A(S.charCodeAt(1))&&!A(S.charCodeAt(2))){let N=3;const L=N;for(;N<C&&!A(S.charCodeAt(N));N++);if(L!==N&&!A(S.charCodeAt(N+1))){for(N+=1;N<C;N++)if(A(S.charCodeAt(N)))return S.slice(0,N+1).replace(/[\\/]/g,R)}}return R}else if(d(w)&&S.charCodeAt(1)===s.CharCode.Colon)return A(S.charCodeAt(2))?S.slice(0,2)+R:S.slice(0,2);let b=S.indexOf("://");if(b!==-1){for(b+=3;b<C;b++)if(A(S.charCodeAt(b)))return S.slice(0,b+1)}return""}function E(S){if(!D.$l||!S||S.length<5)return!1;let R=S.charCodeAt(0);if(R!==s.CharCode.Backslash||(R=S.charCodeAt(1),R!==s.CharCode.Backslash))return!1;let C=2;const w=C;for(;C<S.length&&(R=S.charCodeAt(C),R!==s.CharCode.Backslash);C++);return!(w===C||(R=S.charCodeAt(C+1),isNaN(R)||R===s.CharCode.Backslash))}const f=/[\\/:\*\?"<>\|]/g,P=/[/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(S,R=D.$l){const C=R?f:P;return!(!S||S.length===0||/^\s+$/.test(S)||(C.lastIndex=0,C.test(S))||R&&v.test(S)||S==="."||S===".."||R&&S[S.length-1]==="."||R&&S.length!==S.trim().length||S.length>255)}function m(S,R,C){const w=S===R;return!C||w?w:!S||!R?!1:(0,O.$Kf)(S,R)}function $(S,R,C,w=h.sep){if(S===R)return!0;if(!S||!R||R.length>S.length)return!1;if(C){if(!(0,O.$Lf)(S,R))return!1;if(R.length===S.length)return!0;let N=R.length;return R.charAt(R.length-1)===w&&N--,S.charAt(N)===w}return R.charAt(R.length-1)!==w&&(R+=w),S.indexOf(R)===0}function d(S){return S>=s.CharCode.A&&S<=s.CharCode.Z||S>=s.CharCode.a&&S<=s.CharCode.z}function i(S,R){return D.$l&&S.endsWith(":")&&(S+=h.sep),(0,h.$nc)(S)||(S=(0,h.$oc)(R,S)),S=(0,h.$mc)(S),a(S)}function a(S){return D.$l?(S=(0,O.$sf)(S,h.sep),S.endsWith(":")&&(S+=h.sep)):(S=(0,O.$sf)(S,h.sep),S||(S=h.sep)),S}function t(S){const R=(0,h.$mc)(S);return D.$l?S.length>3?!1:r(R)&&(S.length===2||R.charCodeAt(2)===s.CharCode.Backslash):R===h.$lc.sep}function r(S,R=D.$l){return R?d(S.charCodeAt(0))&&S.charCodeAt(1)===s.CharCode.Colon:!1}function n(S,R=D.$l){return r(S,R)?S[0]:void 0}function u(S,R,C){return R.length>S.length?-1:S===R?0:(C&&(S=S.toLowerCase(),R=R.toLowerCase()),S.indexOf(R))}function l(S){const R=S.split(":");let C,w,b;for(const N of R){const L=Number(N);(0,T.$ng)(L)?w===void 0?w=L:b===void 0&&(b=L):C=C?[C,N].join(":"):N}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:w!==void 0?w:void 0,column:b!==void 0?b:w!==void 0?1:void 0}}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",y="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function k(S,R,C=8){let w="";for(let N=0;N<C;N++){let L;N===0&&D.$l&&!R&&(C===3||C===4)?L=y:L=g,w+=L.charAt(Math.floor(Math.random()*L.length))}let b;return R?b=`${R}-${w}`:b=w,S?(0,h.$oc)(S,b):b}}),define(Re[144],Ce([1,0,26,143,137,61,16,10,13]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=E,e.$Yr=$,e.$Zr=l,e.$1r=w,e.$2r=V,e.$3r=j;const c=0,I=[c,[]];function E(W,J,B,U){if(!W||!J)return I;const _=W.length,x=J.length;if(_<x)return I;const oe=W.toLowerCase();return f(J,B,x,W,oe,_,U)}function f(W,J,B,U,_,x,oe){const te=[],me=[];for(let se=0;se<B;se++){const be=se*x,ae=be-x,we=se>0,$e=W[se],pe=J[se];for(let Oe=0;Oe<x;Oe++){const Fe=Oe>0,He=be+Oe,Ze=He-1,xe=ae+Oe-1,je=Fe?te[Ze]:0,qe=we&&Fe?te[xe]:0,Ne=we&&Fe?me[xe]:0;let H;!qe&&we?H=0:H=P($e,pe,U,_,Oe,Ne),H&&qe+H>=je&&(oe||we||_.startsWith(J,Oe))?(me[He]=Ne+1,te[He]=qe+H):(me[He]=c,te[He]=je)}}const ce=[];let Y=B-1,q=x-1;for(;Y>=0&&q>=0;){const se=Y*x+q;me[se]===c||(ce.push(q),Y--),q--}return[te[B*x-1],ce.reverse()]}function P(W,J,B,U,_,x){let oe=0;if(!v(J,U[_]))return oe;if(oe+=1,x>0&&(oe+=x*5),W===B[_]&&(oe+=1),_===0)oe+=8;else{const te=o(B.charCodeAt(_-1));te?oe+=te:(0,D.$Qk)(B.charCodeAt(_))&&x===0&&(oe+=2)}return oe}function v(W,J){return W===J?!0:W==="/"||W==="\\"?J==="/"||J==="\\":!1}function o(W){switch(W){case s.CharCode.Slash:case s.CharCode.Backslash:return 5;case s.CharCode.Underline:case s.CharCode.Dash:case s.CharCode.Period:case s.CharCode.Space:case s.CharCode.SingleQuote:case s.CharCode.DoubleQuote:case s.CharCode.Colon:return 4;default:return 0}}const m=[void 0,[]];function $(W,J,B=0,U=0){const _=J;return _.values&&_.values.length>1?d(W,_.values,B,U):i(W,J,B,U)}function d(W,J,B,U){let _=0;const x=[];for(const oe of J){const[te,me]=i(W,oe,B,U);if(typeof te!="number")return m;_+=te,x.push(...me)}return[_,R(x)]}function i(W,J,B,U){const _=(0,D.$Zk)(J.original,J.originalLowercase,B,W,W.toLowerCase(),U,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?[_[0],(0,D.$Wk)(_)]:m}const a=Object.freeze({score:0}),t=1<<18,r=1<<17,n=65536;function u(W,J,B,U){const _=U.values?U.values:[U];return(0,O.$yj)({[U.normalized]:{values:_.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:W,description:J,allowNonContiguousMatches:B}})}function l(W,J,B,U,_){if(!W||!J.normalized)return a;const x=U.getItemLabel(W);if(!x)return a;const oe=U.getItemDescription(W),te=u(x,oe,B,J),me=_[te];if(me)return me;const ce=g(x,oe,U.getItemPath(W),J,B);return _[te]=ce,ce}function g(W,J,B,U,_){const x=!B||!U.containsPathSeparator;return B&&(A.$n?U.pathNormalized===B:(0,p.$Kf)(U.pathNormalized,B))?{score:t,labelMatch:[{start:0,end:W.length}],descriptionMatch:J?[{start:0,end:J.length}]:void 0}:U.values&&U.values.length>1?y(W,J,B,U.values,x,_):k(W,J,B,U,x,_)}function y(W,J,B,U,_,x){let oe=0;const te=[],me=[];for(const ce of U){const{score:Y,labelMatch:q,descriptionMatch:se}=k(W,J,B,ce,_,x);if(Y===c)return a;oe+=Y,q&&te.push(...q),se&&me.push(...se)}return{score:oe,labelMatch:R(te),descriptionMatch:R(me)}}function k(W,J,B,U,_,x){if(_||!J){const[oe,te]=E(W,U.normalized,U.normalizedLowercase,x&&!U.expectContiguousMatch);if(oe){const me=(0,D.$Nk)(U.normalized,W);let ce;if(me){ce=r;const Y=Math.round(U.normalized.length/W.length*100);ce+=Y}else ce=n;return{score:ce+oe,labelMatch:me||S(te)}}}if(J){let oe=J;B&&(oe=`${J}${T.sep}`);const te=oe.length,me=`${oe}${W}`,[ce,Y]=E(me,U.normalized,U.normalizedLowercase,x&&!U.expectContiguousMatch);if(ce){const q=S(Y),se=[],be=[];return q.forEach(ae=>{ae.start<te&&ae.end>te?(se.push({start:0,end:ae.end-te}),be.push({start:ae.start,end:te})):ae.start>=te?se.push({start:ae.start-te,end:ae.end-te}):be.push(ae)}),{score:ce,labelMatch:se,descriptionMatch:be}}}return a}function S(W){const J=[];if(!W)return J;let B;for(const U of W)B&&B.end===U?B.end+=1:(B={start:U,end:U+1},J.push(B));return J}function R(W){const J=W.sort((_,x)=>_.start-x.start),B=[];let U;for(const _ of J)!U||!C(U,_)?(U=_,B.push(_)):(U.start=Math.min(U.start,_.start),U.end=Math.max(U.end,_.end));return B}function C(W,J){return!(W.end<J.start||J.end<W.start)}function w(W,J,B,U,_,x){const oe=l(W,B,U,_,x),te=l(J,B,U,_,x),me=oe.score,ce=te.score;if((me===t||ce===t)&&me!==ce)return me===t?-1:1;if(me>n||ce>n){if(me!==ce)return me>ce?-1:1;if(me<r&&ce<r){const $e=N(oe.labelMatch,te.labelMatch);if($e!==0)return $e}const ae=_.getItemLabel(W)||"",we=_.getItemLabel(J)||"";if(ae.length!==we.length)return ae.length-we.length}if(me!==ce)return me>ce?-1:1;const Y=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,q=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(Y&&!q)return-1;if(q&&!Y)return 1;const se=b(W,oe,_),be=b(J,te,_);return se&&be&&se!==be?be>se?-1:1:L(W,J,B,_)}function b(W,J,B){let U=-1,_=-1;if(J.descriptionMatch&&J.descriptionMatch.length?U=J.descriptionMatch[0].start:J.labelMatch&&J.labelMatch.length&&(U=J.labelMatch[0].start),J.labelMatch&&J.labelMatch.length){if(_=J.labelMatch[J.labelMatch.length-1].end,J.descriptionMatch&&J.descriptionMatch.length){const x=B.getItemDescription(W);x&&(_+=x.length)}}else J.descriptionMatch&&J.descriptionMatch.length&&(_=J.descriptionMatch[J.descriptionMatch.length-1].end);return _-U}function N(W,J){if(!W&&!J||(!W||!W.length)&&(!J||!J.length))return 0;if(!J||!J.length)return-1;if(!W||!W.length)return 1;const B=W[0].start,_=W[W.length-1].end-B,x=J[0].start,te=J[J.length-1].end-x;return _===te?0:te<_?1:-1}function L(W,J,B,U){const _=U.getItemLabel(W)||"",x=U.getItemLabel(J)||"",oe=U.getItemDescription(W),te=U.getItemDescription(J),me=_.length+(oe?oe.length:0),ce=x.length+(te?te.length:0);if(me!==ce)return me-ce;const Y=U.getItemPath(W),q=U.getItemPath(J);return Y&&q&&Y.length!==q.length?Y.length-q.length:_!==x?(0,h.$Vr)(_,x,B.normalized):oe&&te&&oe!==te?(0,h.$Vr)(oe,te,B.normalized):Y&&q&&Y!==q?(0,h.$Vr)(Y,q,B.normalized):0}function M(W){return W.startsWith('"')&&W.endsWith('"')}const z=" ";function V(W){typeof W!="string"&&(W="");const J=W.toLowerCase(),{pathNormalized:B,normalized:U,normalizedLowercase:_}=F(W),x=B.indexOf(T.sep)>=0,oe=M(W);let te;const me=W.split(z);if(me.length>1)for(const ce of me){const Y=M(ce),{pathNormalized:q,normalized:se,normalizedLowercase:be}=F(ce);se&&(te||(te=[]),te.push({original:ce,originalLowercase:ce.toLowerCase(),pathNormalized:q,normalized:se,normalizedLowercase:be,expectContiguousMatch:Y}))}return{original:W,originalLowercase:J,pathNormalized:B,normalized:U,normalizedLowercase:_,values:te,containsPathSeparator:x,expectContiguousMatch:oe}}function F(W){let J;A.$l?J=W.replace(/\//g,T.sep):J=W.replace(/\\/g,T.sep);const B=(0,p.$uf)(J).replace(/\s|"/g,"");return{pathNormalized:J,normalized:B,normalizedLowercase:B.toLowerCase()}}function j(W){return Array.isArray(W)?V(W.map(J=>J.original).join(z)):V(W.original)}}),define(Re[107],Ce([1,0,16]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=void 0,e.$jt=O,e.$kt=T,e.$lt=A,e.$mt=c,e.$it=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(I){const E=(0,s.$tc)(I),f=h[E.toLowerCase()];return f!==void 0?f:T(I)}function T(I){const E=(0,s.$tc)(I);return D[E.toLowerCase()]}function A(I){for(const E in D)if(D[E]===I)return E}const p=/^(.+)\/(.+?)(;.+)?$/;function c(I,E){const f=p.exec(I);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:E?void 0:I}}),define(Re[108],Ce([1,0,10]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=O,e.$rm=T;var h;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(h||(e.Source=h={}));var D;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function O(A,...p){const c=p.reduce((f,P)=>(f[P]=!0,f),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(A).filter(f=>!c[f]).forEach(f=>{for(let P=0;P<I.length;P++)if(f.search(I[P])!==-1){delete A[f];break}})}function T(A){A&&(delete A.DEBUG,s.$n&&delete A.LD_PRELOAD)}}),define(Re[2],Ce([1,0,26,41,16,10]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$Ac=m,e.$Bc=r,D=Ue(D);const T=/^\w[\w\d+.-]*$/,A=/^\//,p=/^\/\//;function c(y,k){if(!y.scheme&&k)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${y.authority}", path: "${y.path}", query: "${y.query}", fragment: "${y.fragment}"}`);if(y.scheme&&!T.test(y.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(y.path){if(y.authority){if(!A.test(y.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(y.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(y,k){return!y&&!k?"file":y}function E(y,k){switch(y){case"https":case"http":case"file":k?k[0]!==P&&(k=P+k):k=P;break}return k}const f="",P="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri(k){return k instanceof o?!0:k?typeof k.authority=="string"&&typeof k.fragment=="string"&&typeof k.path=="string"&&typeof k.query=="string"&&typeof k.scheme=="string"&&typeof k.fsPath=="string"&&typeof k.with=="function"&&typeof k.toString=="function":!1}constructor(k,S,R,C,w,b=!1){typeof k=="object"?(this.scheme=k.scheme||f,this.authority=k.authority||f,this.path=k.path||f,this.query=k.query||f,this.fragment=k.fragment||f):(this.scheme=I(k,b),this.authority=S||f,this.path=E(this.scheme,R||f),this.query=C||f,this.fragment=w||f,c(this,b))}get fsPath(){return r(this,!1)}with(k){if(!k)return this;let{scheme:S,authority:R,path:C,query:w,fragment:b}=k;return S===void 0?S=this.scheme:S===null&&(S=f),R===void 0?R=this.authority:R===null&&(R=f),C===void 0?C=this.path:C===null&&(C=f),w===void 0?w=this.query:w===null&&(w=f),b===void 0?b=this.fragment:b===null&&(b=f),S===this.scheme&&R===this.authority&&C===this.path&&w===this.query&&b===this.fragment?this:new d(S,R,C,w,b)}static parse(k,S=!1){const R=v.exec(k);return R?new d(R[2]||f,g(R[4]||f),g(R[5]||f),g(R[7]||f),g(R[9]||f),S):new d(f,f,f,f,f)}static file(k){let S=f;if(O.$l&&(k=k.replace(/\\/g,P)),k[0]===P&&k[1]===P){const R=k.indexOf(P,2);R===-1?(S=k.substring(2),k=P):(S=k.substring(2,R),k=k.substring(R)||P)}return new d("file",S,k,f,f)}static from(k,S){return new d(k.scheme,k.authority,k.path,k.query,k.fragment,S)}static joinPath(k,...S){if(!k.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return O.$l&&k.scheme==="file"?R=o.file(D.$kc.join(r(k,!0),...S)).path:R=D.$lc.join(k.path,...S),k.with({path:R})}toString(k=!1){return n(this,k)}toJSON(){return this}static revive(k){if(k){if(k instanceof o)return k;{const S=new d(k);return S._formatted=k.external??null,S._fsPath=k._sep===$?k.fsPath??null:null,S}}else return k}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=o;function m(y){return!y||typeof y!="object"?!1:typeof y.scheme=="string"&&(typeof y.authority=="string"||typeof y.authority>"u")&&(typeof y.path=="string"||typeof y.path>"u")&&(typeof y.query=="string"||typeof y.query>"u")&&(typeof y.fragment=="string"||typeof y.fragment>"u")}const $=O.$l?1:void 0;class d extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(k=!1){return k?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const k={$mid:h.MarshalledId.Uri};return this._fsPath&&(k.fsPath=this._fsPath,k._sep=$),this._formatted&&(k.external=this._formatted),this.path&&(k.path=this.path),this.scheme&&(k.scheme=this.scheme),this.authority&&(k.authority=this.authority),this.query&&(k.query=this.query),this.fragment&&(k.fragment=this.fragment),k}}const i={[s.CharCode.Colon]:"%3A",[s.CharCode.Slash]:"%2F",[s.CharCode.QuestionMark]:"%3F",[s.CharCode.Hash]:"%23",[s.CharCode.OpenSquareBracket]:"%5B",[s.CharCode.CloseSquareBracket]:"%5D",[s.CharCode.AtSign]:"%40",[s.CharCode.ExclamationMark]:"%21",[s.CharCode.DollarSign]:"%24",[s.CharCode.Ampersand]:"%26",[s.CharCode.SingleQuote]:"%27",[s.CharCode.OpenParen]:"%28",[s.CharCode.CloseParen]:"%29",[s.CharCode.Asterisk]:"%2A",[s.CharCode.Plus]:"%2B",[s.CharCode.Comma]:"%2C",[s.CharCode.Semicolon]:"%3B",[s.CharCode.Equals]:"%3D",[s.CharCode.Space]:"%20"};function a(y,k,S){let R,C=-1;for(let w=0;w<y.length;w++){const b=y.charCodeAt(w);if(b>=s.CharCode.a&&b<=s.CharCode.z||b>=s.CharCode.A&&b<=s.CharCode.Z||b>=s.CharCode.Digit0&&b<=s.CharCode.Digit9||b===s.CharCode.Dash||b===s.CharCode.Period||b===s.CharCode.Underline||b===s.CharCode.Tilde||k&&b===s.CharCode.Slash||S&&b===s.CharCode.OpenSquareBracket||S&&b===s.CharCode.CloseSquareBracket||S&&b===s.CharCode.Colon)C!==-1&&(R+=encodeURIComponent(y.substring(C,w)),C=-1),R!==void 0&&(R+=y.charAt(w));else{R===void 0&&(R=y.substr(0,w));const N=i[b];N!==void 0?(C!==-1&&(R+=encodeURIComponent(y.substring(C,w)),C=-1),R+=N):C===-1&&(C=w)}}return C!==-1&&(R+=encodeURIComponent(y.substring(C))),R!==void 0?R:y}function t(y){let k;for(let S=0;S<y.length;S++){const R=y.charCodeAt(S);R===s.CharCode.Hash||R===s.CharCode.QuestionMark?(k===void 0&&(k=y.substr(0,S)),k+=i[R]):k!==void 0&&(k+=y[S])}return k!==void 0?k:y}function r(y,k){let S;return y.authority&&y.path.length>1&&y.scheme==="file"?S=`//${y.authority}${y.path}`:y.path.charCodeAt(0)===s.CharCode.Slash&&(y.path.charCodeAt(1)>=s.CharCode.A&&y.path.charCodeAt(1)<=s.CharCode.Z||y.path.charCodeAt(1)>=s.CharCode.a&&y.path.charCodeAt(1)<=s.CharCode.z)&&y.path.charCodeAt(2)===s.CharCode.Colon?k?S=y.path.substr(1):S=y.path[1].toLowerCase()+y.path.substr(2):S=y.path,O.$l&&(S=S.replace(/\//g,"\\")),S}function n(y,k){const S=k?t:a;let R="",{scheme:C,authority:w,path:b,query:N,fragment:L}=y;if(C&&(R+=C,R+=":"),(w||C==="file")&&(R+=P,R+=P),w){let M=w.indexOf("@");if(M!==-1){const z=w.substr(0,M);w=w.substr(M+1),M=z.lastIndexOf(":"),M===-1?R+=S(z,!1,!1):(R+=S(z.substr(0,M),!1,!1),R+=":",R+=S(z.substr(M+1),!1,!0)),R+="@"}w=w.toLowerCase(),M=w.lastIndexOf(":"),M===-1?R+=S(w,!1,!0):(R+=S(w.substr(0,M),!1,!0),R+=w.substr(M))}if(b){if(b.length>=3&&b.charCodeAt(0)===s.CharCode.Slash&&b.charCodeAt(2)===s.CharCode.Colon){const M=b.charCodeAt(1);M>=s.CharCode.A&&M<=s.CharCode.Z&&(b=`/${String.fromCharCode(M+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===s.CharCode.Colon){const M=b.charCodeAt(0);M>=s.CharCode.A&&M<=s.CharCode.Z&&(b=`${String.fromCharCode(M+32)}:${b.substr(2)}`)}R+=S(b,!0,!1)}return N&&(R+="?",R+=S(N,!1,!1)),L&&(R+="#",R+=k?L:a(L,!1,!1)),R}function u(y){try{return decodeURIComponent(y)}catch{return y.length>3?y.substr(0,3)+u(y.substr(3)):y}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function g(y){return y.match(l)?y.replace(l,k=>u(k)):y}}),define(Re[209],Ce([1,0,2]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=h,e.$or=D,e.$pr=O,e.log=A;function h(c){const I=c;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function D(c){const I=[];let E;try{const f=JSON.parse(c.arguments),P=f[f.length-1];P&&P.__$stack&&(f.pop(),E=P.__$stack),I.push(...f)}catch{I.push("Unable to log remote console arguments",c.arguments)}return{args:I,stack:E}}function O(c){if(typeof c!="string")return O(D(c).stack);const I=c;if(I){const E=T(I),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(f&&f.length===4)return{uri:s.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function T(c){if(!c)return c;const I=c.indexOf(`
`);return I===-1?c:c.substring(0,I)}function A(c,I){const{args:E,stack:f}=D(c),P=typeof E[0]=="string"&&E.length===1;let v=T(f);v&&(v=`(${v.trim()})`);let o=[];if(typeof E[0]=="string"?v&&P?o=[`%c[${I}] %c${E[0]} %c${v}`,p("blue"),p(""),p("grey")]:o=[`%c[${I}] %c${E[0]}`,p("blue"),p(""),...E.slice(1)]:o=[`%c[${I}]%`,p("blue"),...E],v&&!P&&o.push(v),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,o)}function p(c){return`color: ${c}`}}),define(Re[38],Ce([1,0,21,2,41]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=O,e.$gi=T,e.$hi=p;function O(c){return JSON.stringify(c,A)}function T(c){let I=JSON.parse(c);return I=p(I),I}function A(c,I){return I instanceof RegExp?{$mid:D.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function p(c,I=0){if(!c||I>200)return c;if(typeof c=="object"){switch(c.$mid){case D.MarshalledId.Uri:return h.URI.revive(c);case D.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case D.MarshalledId.Date:return new Date(c.source)}if(c instanceof s.$Se||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let E=0;E<c.length;++E)c[E]=p(c[E],I+1);else for(const E in c)Object.hasOwnProperty.call(c,E)&&(c[E]=p(c[E],I+1))}return c}}),define(Re[14],Ce([1,0,12,10,13,2,16]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Xg=e.$Wg=e.$Vg=e.Schemas=void 0,e.$Tg=p,e.$Ug=c,e.$Yg=E,s=Ue(s),h=Ue(h),T=Ue(T);var A;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",v.vscodeNotebookMetadata="vscode-notebook-metadata",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.commentsInput="comment",v.codeSetting="code-setting",v.outputChannel="output"})(A||(e.Schemas=A={}));function p(v,o){return O.URI.isUri(v)?(0,D.$Kf)(v.scheme,o):(0,D.$Lf)(v,o+":")}function c(v,...o){return o.some(m=>p(v,m))}e.$Vg="vscode-tkn",e.$Wg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(o){this.d=o}setDelegate(o){this.e=o}setServerRootPath(o,m){this.f=E(o,m)}getServerRootPath(){return this.f}get g(){return T.$lc.join(this.f,A.vscodeRemoteResource)}set(o,m,$){this.a[o]=m,this.b[o]=$}setConnectionToken(o,m){this.c[o]=m}getPreferredWebSchema(){return this.d}rewrite(o){if(this.e)try{return this.e(o)}catch(t){return s.$4(t),o}const m=o.authority;let $=this.a[m];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const d=this.b[m],i=this.c[m];let a=`path=${encodeURIComponent(o.path)}`;return typeof i=="string"&&(a+=`&${e.$Wg}=${encodeURIComponent(i)}`),O.URI.from({scheme:h.$r?this.d:A.vscodeRemoteResource,authority:`${$}:${d}`,path:h.$r?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:a})}}e.$Xg=new I;function E(v,o){return T.$lc.join(o??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Zg="vs/../../extensions",e.$1g="vs/../../node_modules",e.$2g="vs/../../node_modules.asar",e.$3g="vs/../../node_modules.asar.unpacked",e.$4g="vscode-app";class f{static{this.a=e.$4g}asBrowserUri(o){const m=this.b(o,ge);return this.uriToBrowserUri(m)}uriToBrowserUri(o){return o.scheme===A.vscodeRemote?e.$Xg.rewrite(o):o.scheme===A.file&&(h.$p||h.$t===`${A.vscodeFileResource}://${f.a}`)?o.with({scheme:A.vscodeFileResource,authority:o.authority||f.a,query:null,fragment:null}):o}asFileUri(o){const m=this.b(o,ge);return this.uriToFileUri(m)}uriToFileUri(o){return o.scheme===A.vscodeFileResource?o.with({scheme:A.file,authority:o.authority!==f.a?o.authority:null,query:null,fragment:null}):o}b(o,m){if(O.URI.isUri(o))return o;if(globalThis._VSCODE_FILE_ROOT){const $=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test($))return O.URI.joinPath(O.URI.parse($,!0),o);const d=T.$oc($,o);return O.URI.file(d)}return O.URI.parse(m.toUrl(o))}}e.$5g=new f;var P;(function(v){const o=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(o.get("3"));const m="vscode-coi";function $(i){let a;typeof i=="string"?a=new URL(i).searchParams:i instanceof URL?a=i.searchParams:O.URI.isUri(i)&&(a=new URL(i.toString(!0)).searchParams);const t=a?.get(m);if(t)return o.get(t)}v.getHeadersFromQuery=$;function d(i,a,t){if(!globalThis.crossOriginIsolated)return;const r=a&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(m,r):i[m]=r}v.addSearchParam=d})(P||(e.COI=P={}))}),define(Re[145],Ce([1,0,133,14,10,17,2]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=I,e.$Cq=E,D=Ue(D);class A{constructor(P,v,o){this.id=P,this.dependencies=v,this.callback=o}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(P,v,o)=>{typeof P!="string"&&(o=v,v=P,P=null),(typeof v!="object"||!Array.isArray(v))&&(o=v,v=null),this.c.push(new A(P,v,o))},globalThis.define.amd=!0,this.b?this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(P){if(P.startsWith(window.location.origin)||P.startsWith(`${h.Schemas.vscodeFileResource}://${h.$4g}`))return P;throw new Error(`[trusted_script_src] Invalid script url: ${P}`)}}):this.a&&(this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(P){return P}})))}async load(P){this.g();const v=await(this.a?this.i(P):this.b?this.h(P):this.j(P));if(!v){console.warn(`Did not receive a define call from script ${P}`);return}const o={},m=[],$=[];if(Array.isArray(v.dependencies))for(const d of v.dependencies)d==="exports"?m.push(o):$.push(d);if($.length>0)throw new Error(`Cannot resolve dependencies for script ${P}. The dependencies are: ${$.join(", ")}`);return typeof v.callback=="function"?v.callback(...m)??o:v.callback}h(P){return new Promise((v,o)=>{const m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript");const $=()=>{m.removeEventListener("load",d),m.removeEventListener("error",i)},d=a=>{$(),v(this.c.pop())},i=a=>{$(),o(a)};m.addEventListener("load",d),m.addEventListener("error",i),this.f&&(P=this.f.createScriptURL(P)),m.setAttribute("src",P),window.document.getElementsByTagName("head")[0].appendChild(m)})}async i(P){return this.f&&(P=this.f.createScriptURL(P)),s.$V?await new Promise((v,o)=>{ge([P],v,o)}).then(Ue):importScripts(P),this.c.pop()}async j(P){try{const v=globalThis._VSCODE_NODE_MODULES.fs,o=globalThis._VSCODE_NODE_MODULES.vm,m=globalThis._VSCODE_NODE_MODULES.module,$=T.URI.parse(P).fsPath,d=v.readFileSync($).toString(),i=m.wrap(d.replace(/^#!.*/,""));return new o.Script(i).runInThisContext().apply(),this.c.pop()}catch(v){throw v}}}const c=new Map;async function I(f,P,v){if(s.$V){v===void 0&&(v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit);const o=P?`${f}/${P}`:f;if(c.has(o))return c.get(o);let m;if(/^\w[\w\d+.-]*:\/\//.test(o))m=o;else{const a=`${s.$W&&v&&!D.$r?h.$2g:h.$1g}/${o}`;m=h.$5g.asBrowserUri(a).toString(!0)}const $=p.INSTANCE.load(m);return c.set(o,$),$}else return await new Promise((o,m)=>{ge([f],o,m)}).then(Ue)}function E(f,P){(0,O.$tg)(s.$V);const o=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,m=s.$W&&o&&!D.$r,$=`${f}/${P}`,i=`${m?h.$2g:h.$1g}/${$}`;return h.$5g.asBrowserUri(i).toString(!0)}}),define(Re[22],Ce([1,0,26,33,14,16,10,13,2]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$_g=c,e.$uh=E,e.$vh=P,h=Ue(h),O=Ue(O);function c(v){return(0,p.$Bc)(v,!0)}class I{constructor(o){this.a=o}compare(o,m,$=!1){return o===m?0:(0,A.$Df)(this.getComparisonKey(o,$),this.getComparisonKey(m,$))}isEqual(o,m,$=!1){return o===m?!0:!o||!m?!1:this.getComparisonKey(o,$)===this.getComparisonKey(m,$)}getComparisonKey(o,m=!1){return o.with({path:this.a(o)?o.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(o){return this.a(o)}isEqualOrParent(o,m,$=!1){if(o.scheme===m.scheme){if(o.scheme===D.Schemas.file)return h.$Jg(c(o),c(m),this.a(o))&&o.query===m.query&&($||o.fragment===m.fragment);if((0,e.$qh)(o.authority,m.authority))return h.$Jg(o.path,m.path,this.a(o),"/")&&o.query===m.query&&($||o.fragment===m.fragment)}return!1}joinPath(o,...m){return p.URI.joinPath(o,...m)}basenameOrAuthority(o){return(0,e.$ih)(o)||o.authority}basename(o){return O.$lc.basename(o.path)}extname(o){return O.$lc.extname(o.path)}dirname(o){if(o.path.length===0)return o;let m;return o.scheme===D.Schemas.file?m=p.URI.file(O.$rc(c(o))).path:(m=O.$lc.dirname(o.path),o.authority&&m.length&&m.charCodeAt(0)!==s.CharCode.Slash&&(console.error(`dirname("${o.toString})) resulted in a relative path`),m="/")),o.with({path:m})}normalizePath(o){if(!o.path.length)return o;let m;return o.scheme===D.Schemas.file?m=p.URI.file(O.$mc(c(o))).path:m=O.$lc.normalize(o.path),o.with({path:m})}relativePath(o,m){if(o.scheme!==m.scheme||!(0,e.$qh)(o.authority,m.authority))return;if(o.scheme===D.Schemas.file){const i=O.$qc(c(o),c(m));return T.$l?h.$Dg(i):i}let $=o.path||"/";const d=m.path||"/";if(this.a(o)){let i=0;for(const a=Math.min($.length,d.length);i<a&&!($.charCodeAt(i)!==d.charCodeAt(i)&&$.charAt(i).toLowerCase()!==d.charAt(i).toLowerCase());i++);$=d.substr(0,i)+$.substr(i)}return O.$lc.relative($,d)}resolvePath(o,m){if(o.scheme===D.Schemas.file){const $=p.URI.file(O.$pc(c(o),m));return o.with({authority:$.authority,path:$.path})}return m=h.$Eg(m),o.with({path:O.$lc.resolve(o.path,m)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,m){return o===m||o!==void 0&&m!==void 0&&(0,A.$Kf)(o,m)}hasTrailingPathSeparator(o,m=O.sep){if(o.scheme===D.Schemas.file){const $=c(o);return $.length>h.$Fg($).length&&$[$.length-1]===m}else{const $=o.path;return $.length>1&&$.charCodeAt($.length-1)===s.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,m=O.sep){return(0,e.$rh)(o,m)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,m=O.sep){let $=!1;if(o.scheme===D.Schemas.file){const d=c(o);$=d!==void 0&&d.length===h.$Fg(d).length&&d[d.length-1]===m}else{m="/";const d=o.path;$=d.length===1&&d.charCodeAt(d.length-1)===s.CharCode.Slash}return!$&&!(0,e.$rh)(o,m)?o.with({path:o.path+"/"}):o}}e.$ah=I,e.$bh=new I(()=>!1),e.$ch=new I(v=>v.scheme===D.Schemas.file?!T.$n:!0),e.$dh=new I(v=>!0),e.$eh=e.$bh.isEqual.bind(e.$bh),e.$fh=e.$bh.isEqualOrParent.bind(e.$bh),e.$gh=e.$bh.getComparisonKey.bind(e.$bh),e.$hh=e.$bh.basenameOrAuthority.bind(e.$bh),e.$ih=e.$bh.basename.bind(e.$bh),e.$jh=e.$bh.extname.bind(e.$bh),e.$kh=e.$bh.dirname.bind(e.$bh),e.$lh=e.$bh.joinPath.bind(e.$bh),e.$mh=e.$bh.normalizePath.bind(e.$bh),e.$nh=e.$bh.relativePath.bind(e.$bh),e.$oh=e.$bh.resolvePath.bind(e.$bh),e.$ph=e.$bh.isAbsolutePath.bind(e.$bh),e.$qh=e.$bh.isEqualAuthority.bind(e.$bh),e.$rh=e.$bh.hasTrailingPathSeparator.bind(e.$bh),e.$sh=e.$bh.removeTrailingPathSeparator.bind(e.$bh),e.$th=e.$bh.addTrailingPathSeparator.bind(e.$bh);function E(v,o){const m=[];for(let $=0;$<v.length;$++){const d=o(v[$]);v.some((i,a)=>a===$?!1:(0,e.$fh)(d,o(i)))||m.push(v[$])}return m}var f;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function o(m){const $=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(a=>{const[t,r]=a.split(":");t&&r&&$.set(t,r)});const i=m.path.substring(0,m.path.indexOf(";"));return i&&$.set(v.META_DATA_MIME,i),$}v.parseMetaData=o})(f||(e.DataUri=f={}));function P(v,o,m){if(o){let $=v.path;return $&&$[0]!==O.$lc.sep&&($=O.$lc.sep+$),v.with({scheme:m,authority:o,path:$})}return v.with({scheme:m})}}),define(Re[8],Ce([1,0,20,12,4,3,22,10,191,50]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$_h=e.$$h=e.$0h=e.$9h=e.Promises=e.$8h=e.$7h=e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0,e.$wh=I,e.$xh=E,e.$yh=f,e.$zh=P,e.$Ah=v,e.$Bh=o,e.$Ch=m,e.$Dh=$,e.$Lh=y,e.$Mh=k,e.$Nh=S,e.$Oh=R,e.$Ph=C,e.$5h=U,e.$ai=ae;function I($e){return!!$e&&typeof $e.then=="function"}function E($e){const pe=new s.$Be,Oe=$e(pe.token),Fe=new Promise((He,Ze)=>{const xe=pe.token.onCancellationRequested(()=>{xe.dispose(),Ze(new h.$9)});Promise.resolve(Oe).then(je=>{xe.dispose(),pe.dispose(),He(je)},je=>{xe.dispose(),pe.dispose(),Ze(je)})});return new class{cancel(){pe.cancel(),pe.dispose()}then(He,Ze){return Fe.then(He,Ze)}catch(He){return this.then(void 0,He)}finally(He){return Fe.finally(He)}}}function f($e,pe,Oe){return new Promise((Fe,He)=>{const Ze=pe.onCancellationRequested(()=>{Ze.dispose(),Fe(Oe)});$e.then(Fe,He).finally(()=>Ze.dispose())})}function P($e,pe){return new Promise((Oe,Fe)=>{const He=pe.onCancellationRequested(()=>{He.dispose(),Fe(new h.$9)});$e.then(Oe,Fe).finally(()=>He.dispose())})}async function v($e){let pe=-1;const Oe=$e.map((Fe,He)=>Fe.then(Ze=>(pe=He,Ze)));try{return await Promise.race(Oe)}finally{$e.forEach((Fe,He)=>{He!==pe&&Fe.cancel()})}}function o($e,pe,Oe){let Fe;const He=setTimeout(()=>{Fe?.(void 0),Oe?.()},pe);return Promise.race([$e.finally(()=>clearTimeout(He)),new Promise(Ze=>Fe=Ze)])}function m($e){return new Promise((pe,Oe)=>{const Fe=$e();I(Fe)?Fe.then(pe,Oe):pe(Fe)})}function $(){let $e,pe;return{promise:new Promise((Fe,He)=>{$e=Fe,pe=He}),resolve:$e,reject:pe}}class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(pe){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=pe,!this.b){const Oe=()=>{if(this.b=null,this.f)return;const Fe=this.queue(this.d);return this.d=null,Fe};this.b=new Promise(Fe=>{this.a.then(Oe,Oe).then(Fe)})}return new Promise((Oe,Fe)=>{this.b.then(Oe,Fe)})}return this.a=pe(),new Promise((Oe,Fe)=>{this.a.then(He=>{this.a=null,Oe(He)},He=>{this.a=null,Fe(He)})})}dispose(){this.f=!0}}e.$Eh=d;class i{constructor(){this.a=Promise.resolve(null)}queue(pe){return this.a=this.a.then(()=>pe(),()=>pe())}}e.$Fh=i;class a{constructor(){this.a=new Map}queue(pe,Oe){const He=(this.a.get(pe)??Promise.resolve()).catch(()=>{}).then(Oe).finally(()=>{this.a.get(pe)===He&&this.a.delete(pe)});return this.a.set(pe,He),He}}e.$Gh=a;const t=($e,pe)=>{let Oe=!0;const Fe=setTimeout(()=>{Oe=!1,pe()},$e);return{isTriggered:()=>Oe,dispose:()=>{clearTimeout(Fe),Oe=!1}}},r=$e=>{let pe=!0;return queueMicrotask(()=>{pe&&(pe=!1,$e())}),{isTriggered:()=>pe,dispose:()=>{pe=!1}}};class n{constructor(pe){this.defaultDelay=pe,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(pe,Oe=this.defaultDelay){this.g=pe,this.h(),this.b||(this.b=new Promise((He,Ze)=>{this.d=He,this.f=Ze}).then(()=>{if(this.b=null,this.d=null,this.g){const He=this.g;return this.g=null,He()}}));const Fe=()=>{this.a=null,this.d?.(null)};return this.a=Oe===p.$le?r(Fe):t(Oe,Fe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$9),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Hh=n;class u{constructor(pe){this.a=new n(pe),this.b=new d}trigger(pe,Oe){return this.a.trigger(()=>this.b.queue(pe),Oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ih=u;class l{constructor(){this.a=!1,this.b=new Promise((pe,Oe)=>{this.d=pe})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Jh=l;class g extends l{constructor(pe){super(),this.f=setTimeout(()=>this.open(),pe)}open(){clearTimeout(this.f),super.open()}}e.$Kh=g;function y($e,pe){return pe?new Promise((Oe,Fe)=>{const He=setTimeout(()=>{Ze.dispose(),Oe()},$e),Ze=pe.onCancellationRequested(()=>{clearTimeout(He),Ze.dispose(),Fe(new h.$9)})}):E(Oe=>y($e,Oe))}function k($e,pe=0,Oe){const Fe=setTimeout(()=>{$e(),Oe&&He.dispose()},pe),He=(0,O.$Xc)(()=>{clearTimeout(Fe),Oe?.deleteAndLeak(He)});return Oe?.add(He),He}function S($e){const pe=[];let Oe=0;const Fe=$e.length;function He(){return Oe<Fe?$e[Oe++]():null}function Ze(xe){xe!=null&&pe.push(xe);const je=He();return je?je.then(Ze):Promise.resolve(pe)}return Promise.resolve(null).then(Ze)}function R($e,pe=Fe=>!!Fe,Oe=null){let Fe=0;const He=$e.length,Ze=()=>{if(Fe>=He)return Promise.resolve(Oe);const xe=$e[Fe++];return Promise.resolve(xe()).then(qe=>pe(qe)?Promise.resolve(qe):Ze())};return Ze()}function C($e,pe=Fe=>!!Fe,Oe=null){if($e.length===0)return Promise.resolve(Oe);let Fe=$e.length;const He=()=>{Fe=-1;for(const Ze of $e)Ze.cancel?.()};return new Promise((Ze,xe)=>{for(const je of $e)je.then(qe=>{--Fe>=0&&pe(qe)?(He(),Ze(qe)):Fe===0&&Ze(Oe)}).catch(qe=>{--Fe>=0&&(He(),xe(qe))})})}class w{constructor(pe){this.a=0,this.b=!1,this.f=pe,this.g=[],this.d=0,this.h=new D.$qe}whenIdle(){return this.size>0?D.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(pe){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Oe,Fe)=>{this.g.push({factory:pe,c:Oe,e:Fe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const pe=this.g.shift();this.d++;const Oe=pe.factory();Oe.then(pe.c,pe.e),Oe.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Qh=w;class b extends w{constructor(){super(1)}}e.$Rh=b;class N{constructor(){this.a=new _,this.b=0}queue(pe){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,pe())):this.a.run(this.b++,pe())}}e.$Sh=N;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const pe=new te;return this.b.add(pe),pe.p}g(){for(const[,pe]of this.a)if(pe.size>0)return!1;return!0}queueSize(pe,Oe=T.$bh){const Fe=Oe.getComparisonKey(pe);return this.a.get(Fe)?.size??0}queueFor(pe,Oe,Fe=T.$bh){const He=Fe.getComparisonKey(pe);let Ze=this.a.get(He);if(!Ze){Ze=new b;const xe=this.f++,je=D.Event.once(Ze.onDrained)(()=>{Ze?.dispose(),this.a.delete(He),this.h(),this.d?.deleteAndDispose(xe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$9c),this.d.set(xe,je),this.a.set(He,Ze)}return Ze.queue(Oe)}h(){this.g()&&this.j()}j(){for(const pe of this.b)pe.complete();this.b.clear()}dispose(){for(const[,pe]of this.a)pe.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Th=L;class M{constructor(pe,Oe){this.b=!1,this.a=-1,typeof pe=="function"&&typeof Oe=="number"&&this.setIfNotSet(pe,Oe)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(pe,Oe){if(this.b)throw new h.$gb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,pe()},Oe)}setIfNotSet(pe,Oe){if(this.b)throw new h.$gb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,pe()},Oe))}}e.$Uh=M;class z{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(pe,Oe,Fe=globalThis){if(this.f)throw new h.$gb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const He=Fe.setInterval(()=>{pe()},Oe);this.d=(0,O.$Xc)(()=>{Fe.clearInterval(He),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Vh=z;class V{constructor(pe,Oe){this.b=-1,this.a=pe,this.d=Oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(pe=this.d){this.cancel(),this.b=setTimeout(this.f,pe)}get delay(){return this.d}set delay(pe){this.d=pe}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Wh=V;class F{constructor(pe,Oe){Oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Oe}ms is not a multiple of 1000ms.`),this.a=pe,this.b=Oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(pe=this.b){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(pe/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Xh=F;class j extends V{constructor(pe,Oe){super(pe,Oe),this.j=[]}work(pe){this.j.push(pe),this.isScheduled()||this.schedule()}h(){const pe=this.j;this.j=[],this.a?.(pe)}dispose(){this.j=[],super.dispose()}}e.$Yh=j;class W extends O.$Zc{constructor(pe,Oe){super(),this.g=pe,this.h=Oe,this.a=[],this.b=this.B(new O.$1c),this.f=!1}get pending(){return this.a.length}work(pe){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+pe.length>this.g.maxBufferedWork)return!1}else if(this.pending+pe.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Oe of pe)this.a.push(Oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Zh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$2h=($e,pe)=>{(0,A.$E)(()=>{if(Oe)return;const Fe=Date.now()+15;pe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Fe-Date.now())}}))});let Oe=!1;return{dispose(){Oe||(Oe=!0)}}}:e.$2h=($e,pe,Oe)=>{const Fe=$e.requestIdleCallback(pe,typeof Oe=="number"?{timeout:Oe}:void 0);let He=!1;return{dispose(){He||(He=!0,$e.cancelIdleCallback(Fe))}}},e.$1h=$e=>(0,e.$2h)(globalThis,$e)}();class J{constructor(pe,Oe){this.g=!1,this.d=()=>{try{this.j=Oe()}catch(Fe){this.l=Fe}finally{this.g=!0}},this.f=(0,e.$2h)(pe,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$3h=J;class B extends J{constructor(pe){super(globalThis,pe)}}e.$4h=B;async function U($e,pe,Oe){let Fe;for(let He=0;He<Oe;He++)try{return await $e()}catch(Ze){Fe=Ze,await y(pe)}throw Fe}class _{isRunning(pe){return typeof pe=="number"?this.a?.taskId===pe:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(pe,Oe,Fe){return this.a={taskId:pe,cancel:()=>Fe?.(),promise:Oe},Oe.then(()=>this.d(pe),()=>this.d(pe)),Oe}d(pe){this.a&&pe===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const pe=this.b;this.b=void 0,pe.run().then(pe.promiseResolve,pe.promiseReject)}}queue(pe){if(this.b)this.b.run=pe;else{const{promise:Oe,resolve:Fe,reject:He}=$();this.b={run:pe,promise:Oe,promiseResolve:Fe,promiseReject:He}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$6h=_;class x{constructor(pe,Oe=()=>Date.now()){this.d=pe,this.f=Oe,this.a=0,this.b=0}increment(){const pe=this.f();return pe-this.a>this.d&&(this.a=pe,this.b=0),this.b++,this.b}}e.$7h=x;var oe;(function($e){$e[$e.Resolved=0]="Resolved",$e[$e.Rejected=1]="Rejected"})(oe||(oe={}));class te{get isRejected(){return this.d?.outcome===oe.Rejected}get isResolved(){return this.d?.outcome===oe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===oe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((pe,Oe)=>{this.a=pe,this.b=Oe})}complete(pe){return new Promise(Oe=>{this.a(pe),this.d={outcome:oe.Resolved,value:pe},Oe()})}error(pe){return new Promise(Oe=>{this.b(pe),this.d={outcome:oe.Rejected,value:pe},Oe()})}cancel(){return this.error(new h.$9)}}e.$8h=te;var me;(function($e){async function pe(Fe){let He;const Ze=await Promise.all(Fe.map(xe=>xe.then(je=>je,je=>{He||(He=je)})));if(typeof He<"u")throw He;return Ze}$e.settled=pe;function Oe(Fe){return new Promise(async(He,Ze)=>{try{await Fe(He,Ze)}catch(xe){Ze(xe)}})}$e.withAsyncBody=Oe})(me||(e.Promises=me={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(pe){this.a=void 0,this.b=void 0,this.d=!1,this.promise=pe.then(Oe=>(this.a=Oe,this.d=!0,Oe),Oe=>{throw this.b=Oe,this.d=!0,Oe})}requireValue(){if(!this.d)throw new h.$gb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$9h=ce;class Y{constructor(pe){this.b=pe,this.a=new c.$Y(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$0h=Y;var q;(function($e){$e[$e.Initial=0]="Initial",$e[$e.DoneOK=1]="DoneOK",$e[$e.DoneError=2]="DoneError"})(q||(q={}));class se{static fromArray(pe){return new se(Oe=>{Oe.emitMany(pe)})}static fromPromise(pe){return new se(async Oe=>{Oe.emitMany(await pe)})}static fromPromises(pe){return new se(async Oe=>{await Promise.all(pe.map(async Fe=>Oe.emitOne(await Fe)))})}static merge(pe){return new se(async Oe=>{await Promise.all(pe.map(async Fe=>{for await(const He of Fe)Oe.emitOne(He)}))})}static{this.EMPTY=se.fromArray([])}constructor(pe,Oe){this.a=q.Initial,this.b=[],this.d=null,this.f=Oe,this.g=new D.$qe,queueMicrotask(async()=>{const Fe={emitOne:He=>this.h(He),emitMany:He=>this.j(He),reject:He=>this.l(He)};try{await Promise.resolve(pe(Fe)),this.k()}catch(He){this.l(He)}finally{Fe.emitOne=void 0,Fe.emitMany=void 0,Fe.reject=void 0}})}[Symbol.asyncIterator](){let pe=0;return{next:async()=>{do{if(this.a===q.DoneError)throw this.d;if(pe<this.b.length)return{done:!1,value:this.b[pe++]};if(this.a===q.DoneOK)return{done:!0,value:void 0};await D.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(pe,Oe){return new se(async Fe=>{for await(const He of pe)Fe.emitOne(Oe(He))})}map(pe){return se.map(this,pe)}static filter(pe,Oe){return new se(async Fe=>{for await(const He of pe)Oe(He)&&Fe.emitOne(He)})}filter(pe){return se.filter(this,pe)}static coalesce(pe){return se.filter(pe,Oe=>!!Oe)}coalesce(){return se.coalesce(this)}static async toPromise(pe){const Oe=[];for await(const Fe of pe)Oe.push(Fe);return Oe}toPromise(){return se.toPromise(this)}h(pe){this.a===q.Initial&&(this.b.push(pe),this.g.fire())}j(pe){this.a===q.Initial&&(this.b=this.b.concat(pe),this.g.fire())}k(){this.a===q.Initial&&(this.a=q.DoneOK,this.g.fire())}l(pe){this.a===q.Initial&&(this.a=q.DoneError,this.d=pe,this.g.fire())}}e.$$h=se;class be extends se{constructor(pe,Oe){super(Oe),this.m=pe}cancel(){this.m.cancel()}}e.$_h=be;function ae($e){const pe=new s.$Be,Oe=$e(pe.token);return new be(pe,async Fe=>{const He=pe.token.onCancellationRequested(()=>{He.dispose(),pe.dispose(),Fe.reject(new h.$9)});try{for await(const Ze of Oe){if(pe.token.isCancellationRequested)return;Fe.emitOne(Ze)}He.dispose(),pe.dispose()}catch(Ze){He.dispose(),pe.dispose(),Fe.reject(Ze)}})}class we{constructor(pe){this.a=new te,this.b=new se(He=>{if(Oe){He.reject(Oe);return}return Fe&&He.emitMany(Fe),this.d=Ze=>He.reject(Ze),this.f=Ze=>He.emitOne(Ze),this.a.p},pe);let Oe,Fe;this.f=He=>{Fe||(Fe=[]),Fe.push(He)},this.d=He=>{Oe||(Oe=He)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(pe){this.d(pe),this.a.complete()}emitOne(pe){this.f(pe)}}e.$bi=we}),define(Re[39],Ce([1,0,18,8,26,33,28,16,10,13]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=void 0,e.$Ak=I,e.$Dk=o,e.$Ek=N,e.$Fk=L,e.$Gk=M,e.$Hk=z,e.$Ik=V,e.$Jk=J;function I(){return Object.create(null)}e.$Bk="**",e.$Ck="/";const E="[/\\\\]",f="[^/\\\\]",P=/\//g;function v(B,U){switch(B){case 0:return"";case 1:return`${f}*?`;default:return`(?:${E}|${f}+${E}${U?`|${E}${f}+`:""})*?`}}function o(B,U){if(!B)return[];const _=[];let x=!1,oe=!1,te="";for(const me of B){switch(me){case U:if(!x&&!oe){_.push(te),te="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}te+=me}return te&&_.push(te),_}function m(B){if(!B)return"";let U="";const _=o(B,e.$Ck);if(_.every(x=>x===e.$Bk))U=".*";else{let x=!1;_.forEach((oe,te)=>{if(oe===e.$Bk){if(x)return;U+=v(2,te===_.length-1)}else{let me=!1,ce="",Y=!1,q="";for(const se of oe){if(se!=="}"&&me){ce+=se;continue}if(Y&&(se!=="]"||!q)){let be;se==="-"?be=se:(se==="^"||se==="!")&&!q?be="^":se===e.$Ck?be="":be=(0,c.$mf)(se),q+=be;continue}switch(se){case"{":me=!0;continue;case"[":Y=!0;continue;case"}":{const ae=`(?:${o(ce,",").map(we=>m(we)).join("|")})`;U+=ae,me=!1,ce="";break}case"]":{U+="["+q+"]",Y=!1,q="";break}case"?":U+=f;continue;case"*":U+=v(1);continue;default:U+=(0,c.$mf)(se)}}te<_.length-1&&(_[te+1]!==e.$Bk||te+2<_.length)&&(U+=E)}x=oe===e.$Bk})}return U}const $=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new T.$Ic(1e4),u=function(){return!1},l=function(){return null};function g(B,U){if(!B)return l;let _;typeof B!="string"?_=B.pattern:_=B,_=_.trim();const x=`${_}_${!!U.trimForExclusions}`;let oe=n.get(x);if(oe)return y(oe,B);let te;return $.test(_)?oe=S(_.substr(4),_):(te=d.exec(k(_,U)))?oe=R(te[1],_):(U.trimForExclusions?a:i).test(_)?oe=C(_,U):(te=t.exec(k(_,U)))?oe=w(te[1].substr(1),_,!0):(te=r.exec(k(_,U)))?oe=w(te[1],_,!1):oe=b(_),n.set(x,oe),y(oe,B)}function y(B,U){if(typeof U=="string")return B;const _=function(x,oe){return(0,O.$Jg)(x,U.base,!p.$n)?B((0,c.$rf)(x.substr(U.base.length),A.sep),oe):null};return _.allBasenames=B.allBasenames,_.allPaths=B.allPaths,_.basenames=B.basenames,_.patterns=B.patterns,_}function k(B,U){return U.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function S(B,U){return function(_,x){return typeof _=="string"&&_.endsWith(B)?U:null}}function R(B,U){const _=`/${B}`,x=`\\${B}`,oe=function(me,ce){return typeof me!="string"?null:ce?ce===B?U:null:me===B||me.endsWith(_)||me.endsWith(x)?U:null},te=[B];return oe.basenames=te,oe.patterns=[U],oe.allBasenames=te,oe}function C(B,U){const _=W(B.slice(1,-1).split(",").map(ce=>g(ce,U)).filter(ce=>ce!==l),B),x=_.length;if(!x)return l;if(x===1)return _[0];const oe=function(ce,Y){for(let q=0,se=_.length;q<se;q++)if(_[q](ce,Y))return B;return null},te=_.find(ce=>!!ce.allBasenames);te&&(oe.allBasenames=te.allBasenames);const me=_.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return me.length&&(oe.allPaths=me),oe}function w(B,U,_){const x=A.sep===A.$lc.sep,oe=x?B:B.replace(P,A.sep),te=A.sep+oe,me=A.$lc.sep+B;let ce;return _?ce=function(Y,q){return typeof Y=="string"&&(Y===oe||Y.endsWith(te)||!x&&(Y===B||Y.endsWith(me)))?U:null}:ce=function(Y,q){return typeof Y=="string"&&(Y===oe||!x&&Y===B)?U:null},ce.allPaths=[(_?"*/":"./")+B],ce}function b(B){try{const U=new RegExp(`^${m(B)}$`);return function(_){return U.lastIndex=0,typeof _=="string"&&U.test(_)?B:null}}catch{return l}}function N(B,U,_){return!B||typeof U!="string"?!1:L(B)(U,void 0,_)}function L(B,U={}){if(!B)return u;if(typeof B=="string"||M(B)){const _=g(B,U);if(_===l)return u;const x=function(oe,te){return!!_(oe,te)};return _.allBasenames&&(x.allBasenames=_.allBasenames),_.allPaths&&(x.allPaths=_.allPaths),x}return F(B,U)}function M(B){const U=B;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}function z(B){return B.allBasenames||[]}function V(B){return B.allPaths||[]}function F(B,U){const _=W(Object.getOwnPropertyNames(B).map(ce=>j(ce,B[ce],U)).filter(ce=>ce!==l)),x=_.length;if(!x)return l;if(!_.some(ce=>!!ce.requiresSiblings)){if(x===1)return _[0];const ce=function(se,be){let ae;for(let we=0,$e=_.length;we<$e;we++){const pe=_[we](se,be);if(typeof pe=="string")return pe;(0,h.$wh)(pe)&&(ae||(ae=[]),ae.push(pe))}return ae?(async()=>{for(const we of ae){const $e=await we;if(typeof $e=="string")return $e}return null})():null},Y=_.find(se=>!!se.allBasenames);Y&&(ce.allBasenames=Y.allBasenames);const q=_.reduce((se,be)=>be.allPaths?se.concat(be.allPaths):se,[]);return q.length&&(ce.allPaths=q),ce}const oe=function(ce,Y,q){let se,be;for(let ae=0,we=_.length;ae<we;ae++){const $e=_[ae];$e.requiresSiblings&&q&&(Y||(Y=(0,A.$sc)(ce)),se||(se=Y.substr(0,Y.length-(0,A.$tc)(ce).length)));const pe=$e(ce,Y,se,q);if(typeof pe=="string")return pe;(0,h.$wh)(pe)&&(be||(be=[]),be.push(pe))}return be?(async()=>{for(const ae of be){const we=await ae;if(typeof we=="string")return we}return null})():null},te=_.find(ce=>!!ce.allBasenames);te&&(oe.allBasenames=te.allBasenames);const me=_.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return me.length&&(oe.allPaths=me),oe}function j(B,U,_){if(U===!1)return l;const x=g(B,_);if(x===l)return l;if(typeof U=="boolean")return x;if(U){const oe=U.when;if(typeof oe=="string"){const te=(me,ce,Y,q)=>{if(!q||!x(me,ce))return null;const se=oe.replace("$(basename)",()=>Y),be=q(se);return(0,h.$wh)(be)?be.then(ae=>ae?B:null):be?B:null};return te.requiresSiblings=!0,te}}return x}function W(B,U){const _=B.filter(ce=>!!ce.basenames);if(_.length<2)return B;const x=_.reduce((ce,Y)=>{const q=Y.basenames;return q?ce.concat(q):ce},[]);let oe;if(U){oe=[];for(let ce=0,Y=x.length;ce<Y;ce++)oe.push(U)}else oe=_.reduce((ce,Y)=>{const q=Y.patterns;return q?ce.concat(q):ce},[]);const te=function(ce,Y){if(typeof ce!="string")return null;if(!Y){let se;for(se=ce.length;se>0;se--){const be=ce.charCodeAt(se-1);if(be===D.CharCode.Slash||be===D.CharCode.Backslash)break}Y=ce.substr(se)}const q=x.indexOf(Y);return q!==-1?oe[q]:null};te.basenames=x,te.patterns=oe,te.allBasenames=x;const me=B.filter(ce=>!ce.basenames);return me.push(te),me}function J(B,U){return(0,s.$yb)(B,U,(_,x)=>typeof _=="string"&&typeof x=="string"?_===x:typeof _!="string"&&typeof x!="string"?_.base===x.base&&_.pattern===x.pattern:!1)}}),define(Re[86],Ce([1,0,12,138,22,13,2]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.MarkdownStringTextNewlineStyle=void 0,e.$0k=c,e.$$k=I,e.$_k=E,e.$al=f,e.$bl=P,e.$cl=v,e.$dl=o,e.$el=m;var A;(function($){$[$.Paragraph=0]="Paragraph",$[$.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class p{constructor(d="",i=!1){if(this.value=d,typeof this.value!="string")throw(0,s.$$)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(d,i=A.Paragraph){return this.value+=f(this.supportThemeIcons?(0,h.$3k)(d):d).replace(/([ \t]+)/g,(a,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===A.Break?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,i){return this.value+=`
${P(i,d)}
`,this}appendLink(d,i,a){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(d),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(d,i){const a=new RegExp((0,O.$mf)(i),"g");return d.replace(a,(t,r)=>d.charAt(r-1)!=="\\"?`\\${t}`:t)}}e.$9k=p;function c($){return I($)?!$.value:Array.isArray($)?$.every(c):!0}function I($){return $ instanceof p?!0:$&&typeof $=="object"?typeof $.value=="string"&&(typeof $.isTrusted=="boolean"||typeof $.isTrusted=="object"||$.isTrusted===void 0)&&(typeof $.supportThemeIcons=="boolean"||$.supportThemeIcons===void 0):!1}function E($,d){return $===d?!0:!$||!d?!1:$.value===d.value&&$.isTrusted===d.isTrusted&&$.supportThemeIcons===d.supportThemeIcons&&$.supportHtml===d.supportHtml&&($.baseUri===d.baseUri||!!$.baseUri&&!!d.baseUri&&(0,D.$eh)(T.URI.from($.baseUri),T.URI.from(d.baseUri)))}function f($){return $.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function P($,d){const i=$.match(/^`+/gm)?.reduce((t,r)=>t.length>r.length?t:r).length??0,a=i>=3?i+1:3;return[`${"`".repeat(a)}${d}`,$,`${"`".repeat(a)}`].join(`
`)}function v($){return $.replace(/"/g,"&quot;")}function o($){return $&&$.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m($){const d=[],i=$.split("|").map(t=>t.trim());$=i[0];const a=i[1];if(a){const t=/height=(\d+)/.exec(a),r=/width=(\d+)/.exec(a),n=t?t[1]:"",u=r?r[1]:"",l=isFinite(parseInt(u)),g=isFinite(parseInt(n));l&&d.push(`width="${u}"`),g&&d.push(`height="${n}"`)}return{href:$,dimensions:d}}}),define(Re[109],Ce([1,0,18,33,16,10,22,13]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$w=p,e.$_w=I,e.$ax=f,e.$bx=P,e.$cx=$,e.$dx=i,e.$ex=a,e.$fx=t,e.$gx=r,e.$hx=n;function p(l,g){const{os:y,tildify:k,relative:S}=g;if(S){const w=c(l,S,y);if(typeof w=="string")return w}let R=l.fsPath;if(y===O.OperatingSystem.Windows&&!O.$l?R=R.replace(/\//g,"\\"):y!==O.OperatingSystem.Windows&&O.$l&&(R=R.replace(/\\/g,"/")),y!==O.OperatingSystem.Windows&&k?.userHome){const w=k.userHome.fsPath;let b;l.scheme!==k.userHome.scheme&&l.path[0]===D.$lc.sep&&l.path[1]!==D.$lc.sep?b=k.userHome.with({path:l.path}).fsPath:b=R,R=f(b,w,y)}return(y===O.OperatingSystem.Windows?D.$kc:D.$lc).normalize(I(R,y===O.OperatingSystem.Windows))}function c(l,g,y){const k=y===O.OperatingSystem.Windows?D.$kc:D.$lc,S=y===O.OperatingSystem.Linux?T.$bh:T.$dh,R=g.getWorkspace(),C=(0,s.$Sb)(R.folders);if(!C)return;l.scheme!==C.uri.scheme&&l.path[0]===D.$lc.sep&&l.path[1]!==D.$lc.sep&&(l=C.uri.with({path:l.path}));const w=g.getWorkspaceFolder(l);if(!w)return;let b;if(S.isEqual(w.uri,l)?b="":b=S.relativePath(w.uri,l)??"",b&&(b=k.normalize(b)),R.folders.length>1&&!g.noPrefix){const N=w.name?w.name:S.basenameOrAuthority(w.uri);b=b?`${N} \u2022 ${b}`:N}return b}function I(l,g=O.$l){return(0,h.$Og)(l,g)?l.charAt(0).toUpperCase()+l.slice(1):l}let E=Object.create(null);function f(l,g,y=O.OS){if(y===O.OperatingSystem.Windows||!l||!g)return l;let k=E.original===g?E.normalized:void 0;k||(k=g,O.$l&&(k=(0,h.$Dg)(k)),k=`${(0,A.$sf)(k,D.$lc.sep)}${D.$lc.sep}`,E={original:g,normalized:k});let S=l;return O.$l&&(S=(0,h.$Dg)(S)),(y===O.OperatingSystem.Linux?S.startsWith(k):(0,A.$Lf)(S,k))?`~/${S.substr(k.length)}`:l}function P(l,g){return l.replace(/^~($|\/|\\)/,`${g}$1`)}const v="\u2026",o="\\\\",m="~";function $(l,g=D.sep){const y=new Array(l.length);let k=!1;for(let S=0;S<l.length;S++){const R=l[S];if(R===""){y[S]=`.${g}`;continue}if(!R){y[S]=R;continue}k=!0;let C="",w=R;w.indexOf(o)===0?(C=w.substr(0,w.indexOf(o)+o.length),w=w.substr(w.indexOf(o)+o.length)):w.indexOf(g)===0?(C=w.substr(0,w.indexOf(g)+g.length),w=w.substr(w.indexOf(g)+g.length)):w.indexOf(m)===0&&(C=w.substr(0,w.indexOf(m)+m.length),w=w.substr(w.indexOf(m)+m.length));const b=w.split(g);for(let N=1;k&&N<=b.length;N++)for(let L=b.length-N;k&&L>=0;L--){k=!1;let M=b.slice(L,L+N).join(g);for(let z=0;!k&&z<l.length;z++)if(z!==S&&l[z]&&l[z].indexOf(M)>-1){const V=L+N===b.length,F=L>0&&l[z].indexOf(g)>-1?g+M:M,j=l[z].endsWith(F);k=!V||j}if(!k){let z="";(b[0].endsWith(":")||C!=="")&&(L===1&&(L=0,N++,M=b[0]+g+M),L>0&&(z=b[0]+g),z=C+z),L>0&&(z=z+v+g),z=z+M,L+N<b.length&&(z=z+g+v),y[S]=z}}k&&(y[S]=R)}return y}var d;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function i(l,g=Object.create(null)){const y=[];let k=!1,S="";for(const R of l)if(R==="$"||k&&R==="{")S&&y.push({value:S,type:d.TEXT}),S="",k=!0;else if(R==="}"&&k){const C=g[S];if(typeof C=="string")C.length&&y.push({value:C,type:d.VARIABLE});else if(C){const w=y[y.length-1];(!w||w.type!==d.SEPARATOR)&&y.push({value:C.label,type:d.SEPARATOR})}S="",k=!1}else S+=R;return S&&!k&&y.push({value:S,type:d.TEXT}),y.filter((R,C)=>{if(R.type===d.SEPARATOR){const w=y[C-1],b=y[C+1];return[w,b].every(N=>N&&(N.type===d.VARIABLE||N.type===d.TEXT)&&N.value.length>0)}return!0}).map(R=>R.value).join("")}function a(l,g){return O.$m||g?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$m?"&":"&&"):l.replace(/&&|&/g,y=>y==="&"?"&&":"&")}function t(l,g){return O.$m||g?l.replace(/\(&&\w\)|&&/g,""):O.$l?l.replace(/&&|&/g,y=>y==="&"?"&&":"&"):l.replace(/&&/g,"_")}function r(l){return l.replace(/&/g,"&&")}function n(l){if(l.endsWith("]")){const g=l.lastIndexOf(" [",l.length-2);if(g!==-1){const y=u(l.substring(0,g)),k=l.substring(g);return{name:y.name+k,parentPath:y.parentPath}}}return u(l)}function u(l){const g=l.indexOf("/")!==-1?D.$lc:D.$kc,y=g.basename(l),k=g.dirname(l);return y.length?{name:y,parentPath:k}:{name:k,parentPath:""}}}),define(Re[146],Ce([1,0,21,41,2]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=void 0,e.$Wn=p,e.$Xn=I,e.$Yn=E;function O(f){return f.toJSON()}class T{constructor(P){this.a=P}transformIncoming(P){const v=this.a.transformIncoming(P);return v===P?P:O(D.URI.from(v))}transformOutgoing(P){const v=this.a.transformOutgoing(P);return v===P?P:O(D.URI.from(v))}transformOutgoingURI(P){const v=this.a.transformOutgoing(P);return v===P?P:D.URI.from(v)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$Un=T,e.$Vn=new class{transformIncoming(f){return f}transformOutgoing(f){return f}transformOutgoingURI(f){return f}transformOutgoingScheme(f){return f}};function A(f,P,v){if(!f||v>200)return null;if(typeof f=="object"){if(f instanceof D.URI)return P.transformOutgoing(f);for(const o in f)if(Object.hasOwnProperty.call(f,o)){const m=A(f[o],P,v+1);m!==null&&(f[o]=m)}}return null}function p(f,P){const v=A(f,P,0);return v===null?f:v}function c(f,P,v,o){if(!f||o>200)return null;if(typeof f=="object"){if(f.$mid===h.MarshalledId.Uri)return v?D.URI.revive(P.transformIncoming(f)):P.transformIncoming(f);if(f instanceof s.$Se)return null;for(const m in f)if(Object.hasOwnProperty.call(f,m)){const $=c(f[m],P,v,o+1);$!==null&&(f[m]=$)}}return null}function I(f,P){const v=c(f,P,!1,0);return v===null?f:v}function E(f,P){const v=c(f,P,!0,0);return v===null?f:v}}),define(Re[34],Ce([1,0,46,69,362,8,33,83,16,10,22,2]),function(ge,e,s,h,D,O,T,A,p,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=r,e.configureFlushOnWrite=y,e.writeFileSync=S,s=Ue(s);var f;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(f||(e.RimRafMode=f={}));async function P(F,j=f.UNLINK,W){if((0,T.$Ng)(F))throw new Error("rimraf - will refuse to recursively delete root");return j===f.UNLINK?o(F):v(F,W)}async function v(F,j=(0,T.$Sg)((0,h.tmpdir)())){try{try{await s.promises.rename(F,j)}catch(W){return W.code==="ENOENT"?void 0:o(F)}o(j).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function o(F){return s.promises.rm(F,{recursive:!0,force:!0,maxRetries:3})}function m(F){if((0,T.$Ng)(F))throw new Error("rimraf - will refuse to recursively delete root");s.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function $(F,j){return a(await(j?d(F):s.promises.readdir(F)))}async function d(F){try{return await s.promises.readdir(F,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const j=[],W=await $(F);for(const J of W){let B=!1,U=!1,_=!1;try{const x=await s.promises.lstat((0,p.$oc)(F,J));B=x.isFile(),U=x.isDirectory(),_=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}j.push({name:J,isFile:()=>B,isDirectory:()=>U,isSymbolicLink:()=>_})}return j}function i(F){return a(s.readdirSync(F))}function a(F){return F.map(j=>typeof j=="string"?c.$m?(0,A.$sm)(j):j:(j.name=c.$m?(0,A.$sm)(j.name):j.name,j))}async function t(F){const j=await $(F),W=[];for(const J of j)await n.existsDirectory((0,p.$oc)(F,J))&&W.push(J);return W}function r(F,j=1e3){return new Promise(W=>{let J=!1;const B=setInterval(()=>{J||(J=!0,s.access(F,U=>{J=!1,U&&(clearInterval(B),W(void 0))}))},j)})}var n;(function(F){async function j(B){let U;try{if(U=await s.promises.lstat(B),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await s.promises.stat(B),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(c.$l&&_.code==="EACCES")try{return{stat:await s.promises.stat(await s.promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw x}throw _}}F.stat=j;async function W(B){try{const{stat:U,symbolicLink:_}=await F.stat(B);return U.isFile()&&_?.dangling!==!0}catch{}return!1}F.existsFile=W;async function J(B){try{const{stat:U,symbolicLink:_}=await F.stat(B);return U.isDirectory()&&_?.dangling!==!0}catch{}return!1}F.existsDirectory=J})(n||(e.SymlinkSupport=n={}));const u=new O.$Th;function l(F,j,W){return u.queueFor(E.URI.file(F),()=>{const J=R(W);return new Promise((B,U)=>k(F,j,J,_=>_?U(_):B()))},I.$ch)}let g=!0;function y(F){g=F}function k(F,j,W,J){if(!g)return s.writeFile(F,j,{mode:W.mode,flag:W.flag},J);s.open(F,W.flag,W.mode,(B,U)=>{if(B)return J(B);s.writeFile(U,j,_=>{if(_)return s.close(U,()=>J(_));s.fdatasync(U,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),y(!1)),s.close(U,oe=>J(oe))))})})}function S(F,j,W){const J=R(W);if(!g)return s.writeFileSync(F,j,{mode:J.mode,flag:J.flag});const B=s.openSync(F,J.flag,J.mode);try{s.writeFileSync(B,j);try{s.fdatasyncSync(B)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),y(!1)}}finally{s.closeSync(B)}}function R(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function C(F,j,W=6e4){if(F!==j)try{c.$l&&typeof W=="number"?await w(F,j,Date.now(),W):await s.promises.rename(F,j)}catch(J){if(F.toLowerCase()!==j.toLowerCase()&&J.code==="EXDEV"||F.endsWith("."))await b(F,j,{preserveSymlinks:!1}),await P(F,f.MOVE);else throw J}}async function w(F,j,W,J,B=0){try{return await s.promises.rename(F,j)}catch(U){if(U.code!=="EACCES"&&U.code!=="EPERM"&&U.code!=="EBUSY")throw U;if(Date.now()-W>=J)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${U}`),U;if(B===0){let _=!1;try{const{stat:x}=await n.stat(j);x.isFile()||(_=!0)}catch{}if(_)throw U}return await(0,O.$Lh)(Math.min(100,B*10)),w(F,j,W,J,B+1)}}async function b(F,j,W){return L(F,j,{root:{source:F,target:j},options:W,handledSourcePaths:new Set})}const N=511;async function L(F,j,W){if(W.handledSourcePaths.has(F))return;W.handledSourcePaths.add(F);const{stat:J,symbolicLink:B}=await n.stat(F);if(B){if(W.options.preserveSymlinks)try{return await V(F,j,W)}catch{}if(B.dangling)return}return J.isDirectory()?M(F,j,J.mode&N,W):z(F,j,J.mode&N)}async function M(F,j,W,J){await s.promises.mkdir(j,{recursive:!0,mode:W});const B=await $(F);for(const U of B)await L((0,p.$oc)(F,U),(0,p.$oc)(j,U),J)}async function z(F,j,W){await s.promises.copyFile(F,j),await s.promises.chmod(j,W)}async function V(F,j,W){let J=await s.promises.readlink(F);(0,T.$Jg)(J,W.root.source,!c.$n)&&(J=(0,p.$oc)(W.root.target,J.substr(W.root.source.length+1))),await s.promises.symlink(J,j)}e.Promises=new class{get read(){return(F,j,W,J,B)=>new Promise((U,_)=>{s.read(F,j,W,J,B,(x,oe,te)=>x?_(x):U({bytesRead:oe,buffer:te}))})}get write(){return(F,j,W,J,B)=>new Promise((U,_)=>{s.write(F,j,W,J,B,(x,oe,te)=>x?_(x):U({bytesWritten:oe,buffer:te}))})}get fdatasync(){return(0,D.promisify)(s.fdatasync)}get open(){return(0,D.promisify)(s.open)}get close(){return(0,D.promisify)(s.close)}get realpath(){return(0,D.promisify)(s.realpath)}async exists(F){try{return await s.promises.access(F),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return P}get rename(){return C}get copy(){return b}}}),define(Re[110],Ce([1,0,46,16,10,13,34]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=A,e.$wr=p,e.$xr=c,e.$yr=I,s=Ue(s);function A(f){if(D.$n)return f;const P=(0,h.$rc)(f);if(f===P)return f;const v=((0,h.$sc)(f)||f).toLowerCase();try{const m=(0,T.readdirSync)(P).filter($=>$.toLowerCase()===v);if(m.length===1){const $=A(P);if($)return(0,h.$oc)($,m[0])}else if(m.length>1){const $=m.indexOf(v);if($>=0){const d=A(P);if(d)return(0,h.$oc)(d,m[$])}}}catch{}return null}async function p(f,P){if(D.$n)return f;const v=(0,h.$rc)(f);if(f===v)return f;const o=((0,h.$sc)(f)||f).toLowerCase();try{if(P?.isCancellationRequested)return null;const $=(await T.Promises.readdir(v)).filter(d=>d.toLowerCase()===o);if($.length===1){const d=await p(v,P);if(d)return(0,h.$oc)(d,$[0])}else if($.length>1){const d=$.indexOf(o);if(d>=0){const i=await p(v,P);if(i)return(0,h.$oc)(i,$[d])}}}catch{}return null}async function c(f){try{return await T.Promises.realpath(f)}catch{const v=E(f);return await s.promises.access(v,s.constants.R_OK),v}}function I(f){try{return s.realpathSync(f)}catch{const v=E(f);return s.accessSync(v,s.constants.R_OK),v}}function E(f){return(0,O.$sf)((0,h.$mc)(f),h.sep)}}),define(Re[111],Ce([1,0,46,16,10,57,108,17,34]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Dm=c,e.$Em=I,h=Ue(h),D=Ue(D),O=Ue(O),A=Ue(A),p=Ue(p),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function c(f=O.env){return f.comspec||"cmd.exe"}function I(f){let P=[],v=!1;const o=function(m){if(v){P.push(m);return}(!f.send(m,d=>{if(d&&console.error(d),v=!1,P.length>0){const i=P.slice(0);P=[],i.forEach(a=>o(a))}})||D.$l)&&(v=!0)};return{send:o}}var E;(function(f){async function P(v,o,m){if(h.$nc(v))return v;if(o===void 0&&(o=O.cwd()),h.$rc(v)!=="."||(m===void 0&&A.$jg(O.env.PATH)&&(m=O.env.PATH.split(h.$yc)),m===void 0||m.length===0))return h.$oc(o,v);async function d(i){if(await p.Promises.exists(i)){let a;try{a=await s.promises.stat(i)}catch(t){t.message.startsWith("EACCES")&&(a=await s.promises.lstat(i))}return a?!a.isDirectory():!1}return!1}for(const i of m){let a;if(h.$nc(i)?a=h.$oc(i,v):a=h.$oc(o,i,v),await d(a))return a;let t=a+".com";if(await d(t)||(t=a+".exe",await d(t)))return t}return h.$oc(o,v)}f.findExecutable=P})(E||(e.win32=E={}))});var Ye=this&&this.__decorate||function(ge,e,s,h){var D=arguments.length,O=D<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,s):h,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ge,e,s,h);else for(var A=ge.length-1;A>=0;A--)(T=ge[A])&&(O=(D<3?T(O):D>3?T(e,s,O):T(e,s))||O);return D>3&&O&&Object.defineProperty(e,s,O),O};define(Re[87],Ce([1,0,18,8,21,20,60,12,4,3,38,13,17]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.ProxyChannel=e.$si=e.$pi=e.$oi=e.$ni=e.RequestInitiator=e.$mi=e.$ji=e.$ii=void 0,e.$ki=y,e.$li=k,e.$qi=N,e.$ri=L,E=Ue(E);var P;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(P||(P={}));function v(B){switch(B){case P.Promise:return"req";case P.PromiseCancel:return"cancel";case P.EventListen:return"subscribe";case P.EventDispose:return"unsubscribe"}}var o;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(o||(o={}));function m(B){switch(B){case o.Initialize:return"init";case o.PromiseSuccess:return"reply:";case o.PromiseError:case o.PromiseErrorObj:return"replyErr:";case o.EventFire:return"event:"}}var $;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})($||($={}));function d(B){let U=0;for(let _=0;;_+=7){const x=B.read(1);if(U|=(x.buffer[0]&127)<<_,!(x.buffer[0]&128))return U}}const i=u(0);function a(B,U){if(U===0){B.write(i);return}let _=0;for(let oe=U;oe!==0;oe=oe>>>7)_++;const x=D.$Se.alloc(_);for(let oe=0;U!==0;oe++)x.buffer[oe]=U&127,U=U>>>7,U>0&&(x.buffer[oe]|=128);B.write(x)}class t{constructor(U){this.b=U,this.a=0}read(U){const _=this.b.slice(this.a,this.a+U);return this.a+=_.byteLength,_}}e.$ii=t;class r{constructor(){this.a=[]}get buffer(){return D.$Se.concat(this.a)}write(U){this.a.push(U)}}e.$ji=r;var n;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(n||(n={}));function u(B){const U=D.$Se.alloc(1);return U.writeUInt8(B,0),U}const l={Undefined:u(n.Undefined),String:u(n.String),Buffer:u(n.Buffer),VSBuffer:u(n.VSBuffer),Array:u(n.Array),Object:u(n.Object),Uint:u(n.Int)},g=typeof Buffer<"u";function y(B,U){if(typeof U>"u")B.write(l.Undefined);else if(typeof U=="string"){const _=D.$Se.fromString(U);B.write(l.String),a(B,_.byteLength),B.write(_)}else if(g&&Buffer.isBuffer(U)){const _=D.$Se.wrap(U);B.write(l.Buffer),a(B,_.byteLength),B.write(_)}else if(U instanceof D.$Se)B.write(l.VSBuffer),a(B,U.byteLength),B.write(U);else if(Array.isArray(U)){B.write(l.Array),a(B,U.length);for(const _ of U)y(B,_)}else if(typeof U=="number"&&(U|0)===U)B.write(l.Uint),a(B,U);else{const _=D.$Se.fromString(JSON.stringify(U));B.write(l.Object),a(B,_.byteLength),B.write(_)}}function k(B){switch(B.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return B.read(d(B)).toString();case n.Buffer:return B.read(d(B)).buffer;case n.VSBuffer:return B.read(d(B));case n.Array:{const _=d(B),x=[];for(let oe=0;oe<_;oe++)x.push(k(B));return x}case n.Object:return JSON.parse(B.read(d(B)).toString());case n.Int:return d(B)}}class S{constructor(U,_,x=null,oe=1e3){this.h=U,this.j=_,this.k=x,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:o.Initialize})}registerChannel(U,_){this.b.set(U,_),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case o.Initialize:{const _=this.o([U.type]);this.k?.logOutgoing(_,0,R.OtherSide,m(U.type));return}case o.PromiseSuccess:case o.PromiseError:case o.EventFire:case o.PromiseErrorObj:{const _=this.o([U.type,U.id],U.data);this.k?.logOutgoing(_,U.id,R.OtherSide,m(U.type),U.data);return}}}o(U,_=void 0){const x=new r;return y(x,U),y(x,_),this.p(x.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const _=new t(U),x=k(_),oe=k(_),te=x[0];switch(te){case P.Promise:return this.k?.logIncoming(U.byteLength,x[1],R.OtherSide,`${v(te)}: ${x[2]}.${x[3]}`,oe),this.s({type:te,id:x[1],channelName:x[2],name:x[3],arg:oe});case P.EventListen:return this.k?.logIncoming(U.byteLength,x[1],R.OtherSide,`${v(te)}: ${x[2]}.${x[3]}`,oe),this.t({type:te,id:x[1],channelName:x[2],name:x[3],arg:oe});case P.PromiseCancel:return this.k?.logIncoming(U.byteLength,x[1],R.OtherSide,`${v(te)}`),this.u({type:te,id:x[1]});case P.EventDispose:return this.k?.logIncoming(U.byteLength,x[1],R.OtherSide,`${v(te)}`),this.u({type:te,id:x[1]})}}s(U){const _=this.b.get(U.channelName);if(!_){this.v(U);return}const x=new O.$Be;let oe;try{oe=_.call(this.j,U.name,U.arg,x.token)}catch(ce){oe=Promise.reject(ce)}const te=U.id;oe.then(ce=>{this.m({id:te,data:ce,type:o.PromiseSuccess})},ce=>{ce instanceof Error?this.m({id:te,data:{message:ce.message,name:ce.name,stack:ce.stack?ce.stack.split(`
`):void 0},type:o.PromiseError}):this.m({id:te,data:ce,type:o.PromiseErrorObj})}).finally(()=>{me.dispose(),this.d.delete(U.id)});const me=(0,c.$Xc)(()=>x.cancel());this.d.set(U.id,me)}t(U){const _=this.b.get(U.channelName);if(!_){this.v(U);return}const x=U.id,te=_.listen(this.j,U.name,U.arg)(me=>this.m({id:x,data:me,type:o.EventFire}));this.d.set(U.id,te)}u(U){const _=this.d.get(U.id);_&&(_.dispose(),this.d.delete(U.id))}v(U){let _=this.g.get(U.channelName);_||(_=[],this.g.set(U.channelName,_));const x=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===P.Promise&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:o.PromiseError})},this.l);_.push({request:U,timeoutTimer:x})}w(U){const _=this.g.get(U);if(_){for(const x of _)switch(clearTimeout(x.timeoutTimer),x.request.type){case P.Promise:this.s(x.request);break;case P.EventListen:this.t(x.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Uc)(this.d.values()),this.d.clear()}}e.$mi=S;var R;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class C{constructor(U,_=null){this.l=U,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$qe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(x=>this.s(x)),this.j=_}getChannel(U){const _=this;return{call(x,oe,te){return _.a?Promise.reject(new A.$9):_.m(U,x,oe,te)},listen(x,oe){return _.a?p.Event.None:_.o(U,x,oe)}}}m(U,_,x,oe=O.CancellationToken.None){const te=this.g++,me=P.Promise,ce={id:te,type:me,channelName:U,name:_,arg:x};if(oe.isCancellationRequested)return Promise.reject(new A.$9);let Y;return new Promise((se,be)=>{if(oe.isCancellationRequested)return be(new A.$9);const ae=()=>{const Oe=Fe=>{switch(Fe.type){case o.PromiseSuccess:this.f.delete(te),se(Fe.data);break;case o.PromiseError:{this.f.delete(te);const He=new Error(Fe.data.message);He.stack=Array.isArray(Fe.data.stack)?Fe.data.stack.join(`
`):Fe.data.stack,He.name=Fe.data.name,be(He);break}case o.PromiseErrorObj:this.f.delete(te),be(Fe.data);break}};this.f.set(te,Oe),this.p(ce)};let we=null;this.b===$.Idle?ae():(we=(0,h.$xh)(Oe=>this.u()),we.then(()=>{we=null,ae()}));const $e=()=>{we?(we.cancel(),we=null):this.p({id:te,type:P.PromiseCancel}),be(new A.$9)},pe=oe.onCancellationRequested($e);Y=(0,c.$Wc)((0,c.$Xc)($e),pe),this.d.add(Y)}).finally(()=>{Y.dispose(),this.d.delete(Y)})}o(U,_,x){const oe=this.g++,te=P.EventListen,me={id:oe,type:te,channelName:U,name:_,arg:x};let ce=null;const Y=new p.$qe({onWillAddFirstListener:()=>{ce=(0,h.$xh)(se=>this.u()),ce.then(()=>{ce=null,this.d.add(Y),this.p(me)})},onDidRemoveLastListener:()=>{ce?(ce.cancel(),ce=null):(this.d.delete(Y),this.p({id:oe,type:P.EventDispose}))}}),q=se=>Y.fire(se.data);return this.f.set(oe,q),Y.event}p(U){switch(U.type){case P.Promise:case P.EventListen:{const _=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(_,U.id,R.LocalSide,`${v(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case P.PromiseCancel:case P.EventDispose:{const _=this.q([U.type,U.id]);this.j?.logOutgoing(_,U.id,R.LocalSide,v(U.type));return}}}q(U,_=void 0){const x=new r;return y(x,U),y(x,_),this.r(x.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const _=new t(U),x=k(_),oe=k(_),te=x[0];switch(te){case o.Initialize:return this.j?.logIncoming(U.byteLength,0,R.LocalSide,m(te)),this.t({type:x[0]});case o.PromiseSuccess:case o.PromiseError:case o.EventFire:case o.PromiseErrorObj:return this.j?.logIncoming(U.byteLength,x[1],R.LocalSide,m(te),oe),this.t({type:x[0],id:x[1],data:oe})}}t(U){if(U.type===o.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Uc)(this.d.values()),this.d.clear()}}e.$ni=C,Ye([T.$ci],C.prototype,"onDidInitializePromise",null);class w{get connections(){const U=[];return this.f.forEach(_=>U.push(_)),U}constructor(U,_,x){this.a=new Map,this.f=new Set,this.g=new p.$qe,this.onDidAddConnection=this.g.event,this.h=new p.$qe,this.onDidRemoveConnection=this.h.event,this.j=new c.$Yc,this.j.add(U(({protocol:oe,onDidClientDisconnect:te})=>{const me=p.Event.once(oe.onMessage);this.j.add(me(ce=>{const Y=new t(ce),q=k(Y),se=new S(oe,q,_,x),be=new C(oe,_);this.a.forEach((we,$e)=>se.registerChannel($e,we));const ae={channelServer:se,channelClient:be,ctx:q};this.f.add(ae),this.g.fire(ae),this.j.add(te(()=>{se.dispose(),be.dispose(),this.f.delete(ae),this.h.fire(ae)}))}))}))}getChannel(U,_){const x=this;return{call(oe,te,me){let ce;if((0,f.$xg)(_)){const q=(0,s.$7b)(x.connections.filter(_));ce=q?Promise.resolve(q):p.Event.toPromise(p.Event.filter(x.onDidAddConnection,_))}else ce=_.routeCall(x,oe,te);const Y=ce.then(q=>q.channelClient.getChannel(U));return N(Y).call(oe,te,me)},listen(oe,te){if((0,f.$xg)(_))return x.k(U,_,oe,te);const me=_.routeEvent(x,oe,te).then(ce=>ce.channelClient.getChannel(U));return N(me).listen(oe,te)}}}k(U,_,x,oe){const te=this;let me;const ce=new p.$qe({onWillAddFirstListener:()=>{me=new c.$Yc;const Y=new p.$we,q=new Map,se=ae=>{const $e=ae.channelClient.getChannel(U).listen(x,oe),pe=Y.add($e);q.set(ae,pe)},be=ae=>{const we=q.get(ae);we&&(we.dispose(),q.delete(ae))};te.connections.filter(_).forEach(se),p.Event.filter(te.onDidAddConnection,_)(se,void 0,me),te.onDidRemoveConnection(be,void 0,me),Y.event(ce.fire,ce,me),me.add(Y)},onDidRemoveLastListener:()=>{me?.dispose(),me=void 0}});return ce.event}registerChannel(U,_){this.a.set(U,_);for(const x of this.f)x.channelServer.registerChannel(U,_)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$oi=w;class b{constructor(U,_,x=null){const oe=new r;y(oe,_),U.send(oe.buffer),this.a=new C(U,x),this.d=new S(U,_,x)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,_){this.d.registerChannel(U,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.$pi=b;function N(B){return{call(U,_,x){return B.then(oe=>oe.call(U,_,x))},listen(U,_){const x=new p.$ze;return B.then(oe=>x.input=oe.listen(U,_)),x.event}}}function L(B){let U=!1;return{call(_,x,oe){return U?B.call(_,x,oe):(0,h.$Lh)(0).then(()=>U=!0).then(()=>B.call(_,x,oe))},listen(_,x){if(U)return B.listen(_,x);const oe=new p.$ze;return(0,h.$Lh)(0).then(()=>U=!0).then(()=>oe.input=B.listen(_,x)),oe.event}}}class M{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const _ of U.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await p.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$si=M;var z;(function(B){function U(te,me,ce){const Y=te,q=ce&&ce.disableMarshalling,se=new Map;for(const be in Y)x(be)&&se.set(be,p.Event.buffer(Y[be],!0,void 0,me));return new class{listen(be,ae,we){const $e=se.get(ae);if($e)return $e;const pe=Y[ae];if(typeof pe=="function"){if(oe(ae))return pe.call(Y,we);if(x(ae))return se.set(ae,p.Event.buffer(Y[ae],!0,void 0,me)),se.get(ae)}throw new A.$fb(`Event not found: ${ae}`)}call(be,ae,we){const $e=Y[ae];if(typeof $e=="function"){if(!q&&Array.isArray(we))for(let Oe=0;Oe<we.length;Oe++)we[Oe]=(0,I.$hi)(we[Oe]);let pe=$e.apply(Y,we);return pe instanceof Promise||(pe=Promise.resolve(pe)),pe}throw new A.$fb(`Method not found: ${ae}`)}}}B.fromService=U;function _(te,me){const ce=me&&me.disableMarshalling;return new Proxy({},{get(Y,q){if(typeof q=="string")return me?.properties?.has(q)?me.properties.get(q):oe(q)?function(se){return te.listen(q,se)}:x(q)?te.listen(q):async function(...se){let be;me&&!(0,f.$sg)(me.context)?be=[me.context,...se]:be=se;const ae=await te.call(q,be);return ce?ae:(0,I.$hi)(ae)};throw new A.$fb(`Property not found: ${String(q)}`)}})}B.toService=_;function x(te){return te[0]==="o"&&te[1]==="n"&&E.$Jf(te.charCodeAt(2))}function oe(te){return/^onDynamic/.test(te)&&E.$Jf(te.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const U=B.toString();if(U!=="[object Object]")return U}return B}function j(B){return Array.isArray(B)?B.map(F):F(B)}function W(B,U,_,x,oe,te,me){me=j(me);const ce=V[oe],Y=ce[x%ce.length];let q=[`%c[${B}]%c[${String(U).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(te)?(q=q.concat(me),q.push(")")):q.push(me),console.log.apply(console,q)}class J{constructor(U,_){this.d=U,this.f=_,this.a=0,this.b=0}logOutgoing(U,_,x,oe,te){this.b+=U,W(this.d,this.b,U,_,x,oe,te)}logIncoming(U,_,x,oe,te){this.a+=U,W(this.f,this.a,U,_,x,oe,te)}}e.$ti=J}),define(Re[70],Ce([1,0,21,4,3,87]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.ProtocolConstants=e.$ui=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var A;(function(l){l.enableDiagnostics=!1,l.records=[];const g=new WeakMap;let y=0;function k(R,C){if(!g.has(R)){const w=String(++y);g.set(R,w)}return g.get(R)}function S(R,C,w,b){if(!l.enableDiagnostics)return;const N=k(R,C);if(b instanceof s.$Se||b instanceof Uint8Array||b instanceof ArrayBuffer||ArrayBuffer.isView(b)){const L=s.$Se.alloc(b.byteLength);L.set(b),l.records.push({timestamp:Date.now(),id:N,label:C,type:w,buff:L})}else l.records.push({timestamp:Date.now(),id:N,label:C,type:w,data:b})}l.traceSocketEvent=S})(A||(e.SocketDiagnostics=A={}));var p;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let c=null;function I(){return c||(c=s.$Se.alloc(0)),c}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(g){this.a.push(g),this.b+=g.byteLength}read(g){return this.c(g,!0)}peek(g){return this.c(g,!1)}c(g,y){if(g===0)return I();if(g>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===g){const C=this.a[0];return y&&(this.a.shift(),this.b-=g),C}if(this.a[0].byteLength>g){const C=this.a[0].slice(0,g);return y&&(this.a[0]=this.a[0].slice(g),this.b-=g),C}const k=s.$Se.alloc(g);let S=0,R=0;for(;g>0;){const C=this.a[R];if(C.byteLength>g){const w=C.slice(0,g);k.set(w,S),S+=g,y&&(this.a[R]=C.slice(g),this.b-=g),g-=g}else k.set(C,S),S+=C.byteLength,y?(this.a.shift(),this.b-=C.byteLength):R++,g-=C.byteLength}return k}}e.$ui=E;var f;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(f||(f={}));function P(l){switch(l){case f.None:return"None";case f.Regular:return"Regular";case f.Control:return"Control";case f.Ack:return"Ack";case f.Disconnect:return"Disconnect";case f.ReplayRequest:return"ReplayRequest";case f.Pause:return"PauseWriting";case f.Resume:return"ResumeWriting";case f.KeepAlive:return"KeepAlive"}}var v;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class o{constructor(g,y,k,S){this.type=g,this.id=y,this.ack=k,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends D.$Zc{constructor(g){super(),this.f=this.B(new h.$qe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:v.HeaderLength,messageType:f.None,id:0,ack:0},this.a=g,this.b=!1,this.c=new E,this.B(this.a.onData(y=>this.acceptChunk(y))),this.lastReadTime=Date.now()}acceptChunk(g){if(!(!g||g.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(g);this.c.byteLength>=this.g.readLen;){const y=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=y.readUInt32BE(9),this.g.messageType=y.readUInt8(0),this.g.id=y.readUInt32BE(1),this.g.ack=y.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:P(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,S=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=v.HeaderLength,this.g.messageType=f.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,y),this.f.fire(new o(k,S,R,y)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(g){this.k=null,this.a=!1,this.b=!1,this.c=g,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(g){if(this.a)return;g.writtenTime=Date.now(),this.lastWriteTime=Date.now();const y=s.$Se.alloc(v.HeaderLength);y.writeUInt8(g.type,0),y.writeUInt32BE(g.id,1),y.writeUInt32BE(g.ack,5),y.writeUInt32BE(g.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:P(g.type),id:g.id,ack:g.ack,messageSize:g.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,g.data),this.j(y,g.data)}g(g,y){const k=this.f===0;return this.d.push(g,y),this.f+=g.byteLength+y.byteLength,k}h(){const g=s.$Se.concat(this.d,this.f);return this.d.length=0,this.f=0,g}j(g,y){this.g(g,y)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const g=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:g.byteLength}),this.c.write(g)}}class d extends D.$Zc{constructor(g){super(),this.f=new h.$qe,this.onMessage=this.f.event,this.g=new h.$qe,this.onDidDispose=this.g.event,this.a=g,this.b=this.B(new $(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(y=>{y.type===f.Regular&&this.f.fire(y.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(g){this.b.write(new o(f.Regular,0,0,g))}}e.$vi=d;class i extends O.$pi{static fromSocket(g,y){return new i(new d(g),y)}get onDidDispose(){return this.b.onDidDispose}constructor(g,y,k=null){super(g,y,k),this.b=g}dispose(){super.dispose();const g=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),g.end()}}e.$wi=i;class a{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$qe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(g){this.b?this.d.length>0?this.d.push(g):this.a.fire(g):this.d.push(g)}flushBuffer(){this.d=[]}}e.$xi=a;class t{constructor(g){this.data=g,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let g=0,y=this.a;for(;y;)y=y.next,g++;return g}peek(){return this.a?this.a.data:null}toArray(){const g=[];let y=0,k=this.a;for(;k;)g[y++]=k.data,k=k.next;return g}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(g){const y=new t(g);if(!this.a){this.a=y,this.b=y;return}this.b.next=y,this.b=y}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const g=Date.now();for(let y=0;y<n.a;y++)this.c[y]=g-1e3*y;setInterval(()=>{for(let y=n.a;y>=1;y--)this.c[y]=this.c[y-1];this.c[0]=Date.now()},1e3)}d(){const g=Date.now(),y=(1+n.a)*1e3;let k=0;for(let S=0;S<n.a;S++)g-this.c[S]<=y&&k++;return 1-k/n.a}hasHighLoad(){return this.d()>=.5}}class u{get unacknowledgedCount(){return this.d-this.f}constructor(g){this.v=new a,this.onControlMessage=this.v.event,this.w=new a,this.onMessage=this.w.event,this.x=new a,this.onDidDispose=this.x.event,this.y=new a,this.onSocketClose=this.y.event,this.z=new a,this.onSocketTimeout=this.z.event,this.t=g.loadEstimator??n.getInstance(),this.u=g.sendKeepAlive??!0,this.a=!1,this.c=new r,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new D.$Yc,this.p=g.socket,this.q=this.s.add(new $(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(y=>this.A(y))),this.s.add(this.p.onClose(y=>this.y.fire(y))),g.initialChunk&&this.r.acceptChunk(g.initialChunk),this.u?this.m=setInterval(()=>{this.E()},v.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const g=new o(f.Disconnect,0,0,I());this.q.write(g),this.q.flush()}}sendPause(){const g=new o(f.Pause,0,0,I());this.q.write(g)}sendResume(){const g=new o(f.Resume,0,0,I());this.q.write(g)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(g,y){this.a=!0,this.s.dispose(),this.s=new D.$Yc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=g,this.q=this.s.add(new $(this.p)),this.r=this.s.add(new m(this.p)),this.s.add(this.r.onMessage(k=>this.A(k))),this.s.add(this.p.onClose(k=>this.y.fire(k))),this.r.acceptChunk(y)}endAcceptReconnection(){this.a=!1,this.j=this.h;const g=new o(f.Ack,0,this.j,I());this.q.write(g);const y=this.c.toArray();for(let k=0,S=y.length;k<S;k++)this.q.write(y[k]);this.C()}acceptDisconnect(){this.x.fire()}A(g){if(g.ack>this.f){this.f=g.ack;do{const y=this.c.peek();if(y&&y.id<=g.ack)this.c.pop();else break}while(!0)}switch(g.type){case f.None:break;case f.Regular:{if(g.id>this.h)if(g.id!==this.h+1){const y=Date.now();y-this.n>1e4&&(this.n=y,this.q.write(new o(f.ReplayRequest,0,0,I())))}else this.h=g.id,this.k=Date.now(),this.B(),this.w.fire(g.data);break}case f.Control:{this.v.fire(g.data);break}case f.Ack:break;case f.Disconnect:{this.x.fire();break}case f.ReplayRequest:{const y=this.c.toArray();for(let k=0,S=y.length;k<S;k++)this.q.write(y[k]);this.C();break}case f.Pause:{this.q.pause();break}case f.Resume:{this.q.resume();break}case f.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(g){const y=++this.d;this.j=this.h;const k=new o(f.Regular,y,this.j,g);this.c.push(k),this.a||(this.q.write(k),this.C())}sendControl(g){const y=new o(f.Control,0,0,g);this.q.write(y)}B(){if(this.h<=this.j||this.l)return;const g=Date.now()-this.k;if(g>=v.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},v.AcknowledgeTime-g+5)}C(){if(this.d<=this.f||this.g||this.a)return;const g=this.c.peek(),y=Date.now()-g.writtenTime,k=Date.now()-this.r.lastReadTime,S=Date.now()-this.o;if(y>=v.TimeoutTime&&k>=v.TimeoutTime&&S>=v.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:y,timeSinceLastReceivedSomeData:k});return}const R=Math.max(v.TimeoutTime-y,v.TimeoutTime-k,v.TimeoutTime-S,500);this.g=setTimeout(()=>{this.g=null,this.C()},R)}D(){if(this.h<=this.j)return;this.j=this.h;const g=new o(f.Ack,0,this.j,I());this.q.write(g)}E(){this.j=this.h;const g=new o(f.KeepAlive,0,this.j,I());this.q.write(g)}}e.$yi=u}),define(Re[210],Ce([1,0,58,8,21,20,209,12,4,3,24,111,108,87]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0,A=Ue(A);class v extends P.$mi{constructor($){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",d=>D.$Se.wrap(Buffer.from(d,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$rr=v;class o{constructor($,d){this.i=$,this.j=d,this.c=new Set,this.g=new Map,this.h=new p.$qe,this.onDidProcessExit=this.h.event;const i=d&&d.timeout?d.timeout:6e4;this.b=new h.$Hh(i),this.d=null,this.f=null}getChannel($){const d=this;return{call(i,a,t){return d.k($,i,a,t)},listen(i,a){return d.l($,i,a)}}}k($,d,i,a=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(A.$0());this.b.cancel();const t=this.n($),r=(0,h.$xh)(l=>t.call(d,i,l)),n=a.onCancellationRequested(()=>r.cancel()),u=(0,c.$Xc)(()=>r.cancel());return this.c.add(u),r.finally(()=>{n.dispose(),this.c.delete(u),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),r}l($,d,i){if(!this.b)return p.Event.None;this.b.cancel();let a;const t=new p.$qe({onWillAddFirstListener:()=>{a=this.n($).listen(d,i)(t.fire,t),this.c.add(a)},onDidRemoveLastListener:()=>{this.c.delete(a),a.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,I.$mo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(y=>!/^--inspect(-brk)?=/.test(y)).filter(y=>!y.startsWith("--vscode-"))),(0,f.$rm)(d.env),this.d=(0,s.fork)(this.i,$,d);const i=new p.$qe,t=p.Event.fromNodeEventEmitter(this.d,"message",y=>y)(y=>{if((0,T.$nr)(y)){(0,T.log)(y,`IPC Library: ${this.j.serverName}`);return}i.fire(D.$Se.wrap(Buffer.from(y,"base64")))}),r=this.j.useQueue?(0,E.$Em)(this.d):this.d,n=y=>this.d&&this.d.connected&&r.send(y.buffer.toString("base64")),u=i.event,l={send:n,onMessage:u};this.f=new P.$ni(l);const g=()=>this.o();process.once("exit",g),this.d.on("error",y=>console.warn('IPC "'+this.j.serverName+'" errored with '+y)),this.d.on("exit",(y,k)=>{process.removeListener("exit",g),t.dispose(),this.c.forEach(S=>(0,c.$Uc)(S)),this.c.clear(),y!==0&&k!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+y+" and signal "+k),this.b?.cancel(),this.o(),this.h.fire({code:y,signal:k})})}return this.f}n($){let d=this.g.get($);return d||(d=this.m.getChannel($),this.g.set($,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$sr=o}),define(Re[211],Ce([1,0,8,4,3,38,17]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=e.StorageState=e.StorageHint=void 0,e.$lq=p;var A;(function(f){f[f.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",f[f.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A||(e.StorageHint=A={}));function p(f){const P=f;return P?.changed instanceof Map||P?.deleted instanceof Set}var c;(function(f){f[f.None=0]="None",f[f.Initialized=1]="Initialized",f[f.Closed=2]="Closed"})(c||(e.StorageState=c={}));class I extends D.$Zc{static{this.a=100}constructor(P,v=Object.create(null)){super(),this.r=P,this.s=v,this.b=this.B(new h.$te),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new s.$Ih(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(P=>this.u(P)))}u(P){this.b.pause();try{P.changed?.forEach((v,o)=>this.w(o,v)),P.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(P,v){if(this.c===c.Closed)return;let o=!1;(0,T.$sg)(v)?o=this.f.delete(P):this.f.get(P)!==v&&(this.f.set(P,v),o=!0),o&&this.b.fire({key:P,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(P,v){const o=this.f.get(P);return(0,T.$sg)(o)?v:o}getBoolean(P,v){const o=this.get(P);return(0,T.$sg)(o)?v:o==="true"}getNumber(P,v){const o=this.get(P);return(0,T.$sg)(o)?v:parseInt(o,10)}getObject(P,v){const o=this.get(P);return(0,T.$sg)(o)?v:(0,O.$gi)(o)}async set(P,v,o=!1){if(this.c===c.Closed)return;if((0,T.$sg)(v))return this.delete(P,o);const m=(0,T.$lg)(v)||Array.isArray(v)?(0,O.$fi)(v):String(v);if(this.f.get(P)!==m)return this.f.set(P,m),this.j.set(P,m),this.h.delete(P),this.b.fire({key:P,external:o}),this.D()}async delete(P,v=!1){if(!(this.c===c.Closed||!this.f.delete(P)))return this.h.has(P)||this.h.add(P),this.j.delete(P),this.b.fire({key:P,external:v}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const P={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(P).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(P){if(!(this.c===c.Closed||this.m))return this.D(P)}async D(P){return this.s.hint===A.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),P)}async whenFlushed(){if(this.z)return new Promise(P=>this.n.push(P))}isInMemory(){return this.s.hint===A.STORAGE_IN_MEMORY}}e.$mq=I;class E{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(P){P.insert?.forEach((v,o)=>this.a.set(o,v)),P.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$nq=E}),define(Re[212],Ce([1,0,13,10,21]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=void 0,e.$mu=I,e.$nu=E,s=Ue(s),h=Ue(h),D=Ue(D);let O;function T(){return O||(O=new TextDecoder("UTF-16LE")),O}let A;function p(){return A||(A=new TextDecoder("UTF-16BE")),A}let c;function I(){return c||(c=h.$G()?T():p()),c}function E(v,o,m){const $=new Uint16Array(v.buffer,o,m);return m>0&&($[0]===65279||$[0]===65534)?f(v,o,m):T().decode($)}function f(v,o,m){const $=[];let d=0;for(let i=0;i<m;i++){const a=D.$Ue(v,o);o+=2,$[d++]=String.fromCharCode(a)}return $.join("")}class P{constructor(o){this.a=o|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const o=new Uint16Array(this.b.buffer,0,this.d);return I().decode(o)}f(){const o=this.e();this.d=0,this.c===null?this.c=[o]:this.c[this.c.length]=o}appendCharCode(o){const m=this.a-this.d;m<=1&&(m===0||s.$Of(o))&&this.f(),this.b[this.d++]=o}appendASCIICharCode(o){this.d===this.a&&this.f(),this.b[this.d++]=o}appendString(o){const m=o.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=o;return}for(let $=0;$<m;$++)this.b[this.d++]=o.charCodeAt($)}}e.$ou=P}),define(Re[213],Ce([1,0,21,212]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pu=void 0,e.$qu=T,s=Ue(s);function D(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,I,E,f){this.oldPosition=c,this.oldText=I,this.newPosition=E,this.newText=f}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${D(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${D(this.oldText)}")`:`(replace@${this.oldPosition} "${D(this.oldText)}" with "${D(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,I,E){const f=I.length;s.$Xe(c,f,E),E+=4;for(let P=0;P<f;P++)s.$Ve(c,I.charCodeAt(P),E),E+=2;return E}static d(c,I){const E=s.$We(c,I);return I+=4,(0,h.$nu)(c,I,E)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(c,I){return s.$Xe(c,this.oldPosition,I),I+=4,s.$Xe(c,this.newPosition,I),I+=4,I=O.c(c,this.oldText,I),I=O.c(c,this.newText,I),I}static read(c,I,E){const f=s.$We(c,I);I+=4;const P=s.$We(c,I);I+=4;const v=O.d(c,I);I+=O.a(v);const o=O.d(c,I);return I+=O.a(o),E.push(new O(f,v,P,o)),I}}e.$pu=O;function T(p,c){return p===null||p.length===0?c:new A(p,c).compress()}class A{constructor(c,I){this.a=c,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,I=0,E=this.n(c),f=this.l(I);for(;c<this.f||I<this.h;){if(E===null){this.k(f),f=this.l(++I);continue}if(f===null){this.m(E),E=this.n(++c);continue}if(f.oldEnd<=E.newPosition){this.k(f),f=this.l(++I);continue}if(E.newEnd<=f.oldPosition){this.m(E),E=this.n(++c);continue}if(f.oldPosition<E.newPosition){const[$,d]=A.r(f,E.newPosition-f.oldPosition);this.k($),f=d;continue}if(E.newPosition<f.oldPosition){const[$,d]=A.q(E,f.oldPosition-E.newPosition);this.m($),E=d;continue}let o,m;if(f.oldEnd===E.newEnd)o=E,m=f,E=this.n(++c),f=this.l(++I);else if(f.oldEnd<E.newEnd){const[$,d]=A.q(E,f.oldLength);o=$,m=f,E=d,f=this.l(++I)}else{const[$,d]=A.r(f,E.newLength);o=E,m=$,E=this.n(++c),f=d}this.d[this.e++]=new O(o.oldPosition,o.oldText,m.newPosition,m.newText),this.g+=o.newLength-o.oldLength,this.j+=m.newLength-m.oldLength}const P=A.s(this.d);return A.t(P)}k(c){this.d[this.e++]=A.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=A.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,I){return new O(I.oldPosition-c,I.oldText,I.newPosition,I.newText)}static p(c,I){return new O(I.oldPosition,I.oldText,I.newPosition+c,I.newText)}static q(c,I){const E=c.newText.substr(0,I),f=c.newText.substr(I);return[new O(c.oldPosition,c.oldText,c.newPosition,E),new O(c.oldEnd,"",c.newPosition+I,f)]}static r(c,I){const E=c.oldText.substr(0,I),f=c.oldText.substr(I);return[new O(c.oldPosition,E,c.newPosition,c.newText),new O(c.oldPosition+I,f,c.newEnd,"")]}static s(c){if(c.length===0)return c;const I=[];let E=0,f=c[0];for(let P=1;P<c.length;P++){const v=c[P];f.oldEnd===v.oldPosition?f=new O(f.oldPosition,f.oldText+v.oldText,f.newPosition,f.newText+v.newText):(I[E++]=f,f=v)}return I[E++]=f,I}static t(c){if(c.length===0)return c;const I=[];let E=0;for(let f=0;f<c.length;f++){const P=c[f];P.oldText!==P.newText&&(I[E++]=P)}return I}}}),define(Re[214],Ce([1,0,39,16]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gu=D,e.$Hu=O;function D(T,A,p,c,I,E){if(Array.isArray(T)){let f=0;for(const P of T){const v=D(P,A,p,c,I,E);if(v===10)return v;v>f&&(f=v)}return f}else{if(typeof T=="string")return c?T==="*"?5:T===p?10:0:0;if(T){const{language:f,pattern:P,scheme:v,hasAccessToAllModels:o,notebookType:m}=T;if(!c&&!o)return 0;m&&I&&(A=I);let $=0;if(v)if(v===A.scheme)$=10;else if(v==="*")$=5;else return 0;if(f)if(f===p)$=10;else if(f==="*")$=Math.max($,5);else return 0;if(m)if(m===E)$=10;else if(m==="*"&&E!==void 0)$=Math.max($,5);else return 0;if(P){let d;if(typeof P=="string"?d=P:d={...P,base:(0,h.$mc)(P.base)},d===A.fsPath||(0,s.$Ek)(d,A.fsPath))$=10;else return 0}return $}else return 0}}function O(T){return typeof T=="string"?!1:Array.isArray(T)?T.some(O):!!T.notebookType}}),define(Re[88],Ce([1,0,84,2,196,30,206,7]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$3u=e.$2u=e.$1u=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Zu=e.$Yu=e.SymbolKinds=e.SymbolTag=e.$Wu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Uu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Tu=e.$Su=e.$Ru=void 0,e.$Vu=u,e.$Xu=g;class p{constructor(U,_,x){this.offset=U,this.type=_,this.language=x,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Ru=p;class c{constructor(U,_){this.tokens=U,this.endState=_,this._tokenizationResultBrand=void 0}}e.$Su=c;class I{constructor(U,_){this.tokens=U,this.endState=_,this._encodedTokenizationResultBrand=void 0}}e.$Tu=I;var E;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(E||(e.HoverVerbosityAction=E={}));var f;(function(B){B[B.Method=0]="Method",B[B.Function=1]="Function",B[B.Constructor=2]="Constructor",B[B.Field=3]="Field",B[B.Variable=4]="Variable",B[B.Class=5]="Class",B[B.Struct=6]="Struct",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Event=10]="Event",B[B.Operator=11]="Operator",B[B.Unit=12]="Unit",B[B.Value=13]="Value",B[B.Constant=14]="Constant",B[B.Enum=15]="Enum",B[B.EnumMember=16]="EnumMember",B[B.Keyword=17]="Keyword",B[B.Text=18]="Text",B[B.Color=19]="Color",B[B.File=20]="File",B[B.Reference=21]="Reference",B[B.Customcolor=22]="Customcolor",B[B.Folder=23]="Folder",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue",B[B.Snippet=27]="Snippet"})(f||(e.CompletionItemKind=f={}));var P;(function(B){const U=new Map;U.set(f.Method,s.$0j.symbolMethod),U.set(f.Function,s.$0j.symbolFunction),U.set(f.Constructor,s.$0j.symbolConstructor),U.set(f.Field,s.$0j.symbolField),U.set(f.Variable,s.$0j.symbolVariable),U.set(f.Class,s.$0j.symbolClass),U.set(f.Struct,s.$0j.symbolStruct),U.set(f.Interface,s.$0j.symbolInterface),U.set(f.Module,s.$0j.symbolModule),U.set(f.Property,s.$0j.symbolProperty),U.set(f.Event,s.$0j.symbolEvent),U.set(f.Operator,s.$0j.symbolOperator),U.set(f.Unit,s.$0j.symbolUnit),U.set(f.Value,s.$0j.symbolValue),U.set(f.Enum,s.$0j.symbolEnum),U.set(f.Constant,s.$0j.symbolConstant),U.set(f.Enum,s.$0j.symbolEnum),U.set(f.EnumMember,s.$0j.symbolEnumMember),U.set(f.Keyword,s.$0j.symbolKeyword),U.set(f.Snippet,s.$0j.symbolSnippet),U.set(f.Text,s.$0j.symbolText),U.set(f.Color,s.$0j.symbolColor),U.set(f.File,s.$0j.symbolFile),U.set(f.Reference,s.$0j.symbolReference),U.set(f.Customcolor,s.$0j.symbolCustomColor),U.set(f.Folder,s.$0j.symbolFolder),U.set(f.TypeParameter,s.$0j.symbolTypeParameter),U.set(f.User,s.$0j.account),U.set(f.Issue,s.$0j.issues);function _(te){let me=U.get(te);return me||(console.info("No codicon found for CompletionItemKind "+te),me=s.$0j.symbolProperty),me}B.toIcon=_;const x=new Map;x.set("method",f.Method),x.set("function",f.Function),x.set("constructor",f.Constructor),x.set("field",f.Field),x.set("variable",f.Variable),x.set("class",f.Class),x.set("struct",f.Struct),x.set("interface",f.Interface),x.set("module",f.Module),x.set("property",f.Property),x.set("event",f.Event),x.set("operator",f.Operator),x.set("unit",f.Unit),x.set("value",f.Value),x.set("constant",f.Constant),x.set("enum",f.Enum),x.set("enum-member",f.EnumMember),x.set("enumMember",f.EnumMember),x.set("keyword",f.Keyword),x.set("snippet",f.Snippet),x.set("text",f.Text),x.set("color",f.Color),x.set("file",f.File),x.set("reference",f.Reference),x.set("customcolor",f.Customcolor),x.set("folder",f.Folder),x.set("type-parameter",f.TypeParameter),x.set("typeParameter",f.TypeParameter),x.set("account",f.User),x.set("issue",f.Issue);function oe(te,me){let ce=x.get(te);return typeof ce>"u"&&!me&&(ce=f.Property),ce}B.fromString=oe})(P||(e.CompletionItemKinds=P={}));var v;(function(B){B[B.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var o;(function(B){B[B.None=0]="None",B[B.KeepWhitespace=1]="KeepWhitespace",B[B.InsertAsSnippet=4]="InsertAsSnippet"})(o||(e.CompletionItemInsertTextRule=o={}));var m;(function(B){B[B.Word=0]="Word",B[B.Line=1]="Line",B[B.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var $;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($||(e.CompletionTriggerKind=$={}));var d;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(d||(e.InlineCompletionTriggerKind=d={}));class i{constructor(U,_,x,oe){this.range=U,this.text=_,this.completionKind=x,this.isSnippetText=oe}equals(U){return O.$Yt.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}e.$Uu=i;var a;(function(B){B[B.Invoke=1]="Invoke",B[B.Auto=2]="Auto"})(a||(e.CodeActionTriggerType=a={}));var t;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var r;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(r||(e.SignatureHelpTriggerKind=r={}));var n;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function u(B){return B&&h.URI.isUri(B.uri)&&O.$Yt.isIRange(B.range)&&(O.$Yt.isIRange(B.originSelectionRange)||O.$Yt.isIRange(B.targetSelectionRange))}var l;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(l||(e.SymbolKind=l={})),e.$Wu={[l.Array]:(0,A.localize)(788,null),[l.Boolean]:(0,A.localize)(789,null),[l.Class]:(0,A.localize)(790,null),[l.Constant]:(0,A.localize)(791,null),[l.Constructor]:(0,A.localize)(792,null),[l.Enum]:(0,A.localize)(793,null),[l.EnumMember]:(0,A.localize)(794,null),[l.Event]:(0,A.localize)(795,null),[l.Field]:(0,A.localize)(796,null),[l.File]:(0,A.localize)(797,null),[l.Function]:(0,A.localize)(798,null),[l.Interface]:(0,A.localize)(799,null),[l.Key]:(0,A.localize)(800,null),[l.Method]:(0,A.localize)(801,null),[l.Module]:(0,A.localize)(802,null),[l.Namespace]:(0,A.localize)(803,null),[l.Null]:(0,A.localize)(804,null),[l.Number]:(0,A.localize)(805,null),[l.Object]:(0,A.localize)(806,null),[l.Operator]:(0,A.localize)(807,null),[l.Package]:(0,A.localize)(808,null),[l.Property]:(0,A.localize)(809,null),[l.String]:(0,A.localize)(810,null),[l.Struct]:(0,A.localize)(811,null),[l.TypeParameter]:(0,A.localize)(812,null),[l.Variable]:(0,A.localize)(813,null)};function g(B,U){return(0,A.localize)(814,null,B,e.$Wu[U])}var y;(function(B){B[B.Deprecated=1]="Deprecated"})(y||(e.SymbolTag=y={}));var k;(function(B){const U=new Map;U.set(l.File,s.$0j.symbolFile),U.set(l.Module,s.$0j.symbolModule),U.set(l.Namespace,s.$0j.symbolNamespace),U.set(l.Package,s.$0j.symbolPackage),U.set(l.Class,s.$0j.symbolClass),U.set(l.Method,s.$0j.symbolMethod),U.set(l.Property,s.$0j.symbolProperty),U.set(l.Field,s.$0j.symbolField),U.set(l.Constructor,s.$0j.symbolConstructor),U.set(l.Enum,s.$0j.symbolEnum),U.set(l.Interface,s.$0j.symbolInterface),U.set(l.Function,s.$0j.symbolFunction),U.set(l.Variable,s.$0j.symbolVariable),U.set(l.Constant,s.$0j.symbolConstant),U.set(l.String,s.$0j.symbolString),U.set(l.Number,s.$0j.symbolNumber),U.set(l.Boolean,s.$0j.symbolBoolean),U.set(l.Array,s.$0j.symbolArray),U.set(l.Object,s.$0j.symbolObject),U.set(l.Key,s.$0j.symbolKey),U.set(l.Null,s.$0j.symbolNull),U.set(l.EnumMember,s.$0j.symbolEnumMember),U.set(l.Struct,s.$0j.symbolStruct),U.set(l.Event,s.$0j.symbolEvent),U.set(l.Operator,s.$0j.symbolOperator),U.set(l.TypeParameter,s.$0j.symbolTypeParameter);function _(x){let oe=U.get(x);return oe||(console.info("No codicon found for SymbolKind "+x),oe=s.$0j.symbolProperty),oe}B.toIcon=_})(k||(e.SymbolKinds=k={}));class S{static asEditOperation(U){return D.$Zt.replace(O.$Yt.lift(U.range),U.text)}}e.$Yu=S;class R{static{this.Comment=new R("comment")}static{this.Imports=new R("imports")}static{this.Region=new R("region")}static fromValue(U){switch(U){case"comment":return R.Comment;case"imports":return R.Imports;case"region":return R.Region}return new R(U)}constructor(U){this.value=U}}e.$Zu=R;var C;(function(B){B[B.AIGenerated=1]="AIGenerated"})(C||(e.NewSymbolNameTag=C={}));var w;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(w||(e.NewSymbolNameTriggerKind=w={}));var b;(function(B){function U(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}B.is=U})(b||(e.Command=b={}));var N;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(N||(e.CommentThreadCollapsibleState=N={}));var L;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(L||(e.CommentThreadState=L={}));var M;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(M||(e.CommentThreadApplicability=M={}));var z;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var V;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(V||(e.CommentState=V={}));var F;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class j{constructor(U){this.b=U,this.a=null}dispose(){this.a&&this.a.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$1u=j,e.$2u=new T.$Iu,e.$3u=new T.$Iu;var W;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(W||(e.ExternalUriOpenerPriority=W={}));var J;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(J||(e.InlineEditTriggerKind=J={}))}),define(Re[215],Ce([1,0,4,13,30,56,141,195,213,3]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KD=void 0,h=Ue(h);class I extends c.$Zc{constructor(f,P,v,o,m,$,d){super(),this.m=this.B(new s.$qe),this.onDidChangeContent=this.m.event,this.f=P,this.j=!$,this.g=o,this.h=m,this.c=new T.$JD(f,v,d)}equals(f){return!(f instanceof I)||this.f!==f.f||this.getEOL()!==f.getEOL()?!1:this.c.equal(f.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(f){return this.c.createSnapshot(f?this.f:"")}getOffsetAt(f,P){return this.c.getOffsetAt(f,P)}getPositionAt(f){return this.c.getPositionAt(f)}getRangeAt(f,P){const v=f+P,o=this.getPositionAt(f),m=this.getPositionAt(v);return new D.$Yt(o.lineNumber,o.column,m.lineNumber,m.column)}getValueInRange(f,P=O.EndOfLinePreference.TextDefined){if(f.isEmpty())return"";const v=this.n(P);return this.c.getValueInRange(f,v)}getValueLengthInRange(f,P=O.EndOfLinePreference.TextDefined){if(f.isEmpty())return 0;if(f.startLineNumber===f.endLineNumber)return f.endColumn-f.startColumn;const v=this.getOffsetAt(f.startLineNumber,f.startColumn),o=this.getOffsetAt(f.endLineNumber,f.endColumn);let m=0;const $=this.n(P),d=this.getEOL();if($.length!==d.length){const i=$.length-d.length,a=f.endLineNumber-f.startLineNumber;m=i*a}return o-v+m}getCharacterCountInRange(f,P=O.EndOfLinePreference.TextDefined){if(this.j){let v=0;const o=f.startLineNumber,m=f.endLineNumber;for(let $=o;$<=m;$++){const d=this.getLineContent($),i=$===o?f.startColumn-1:0,a=$===m?f.endColumn-1:d.length;for(let t=i;t<a;t++)h.$Of(d.charCodeAt(t))?(v=v+1,t=t+1):v=v+1}return v+=this.n(P).length*(m-o),v}return this.getValueLengthInRange(f,P)}getNearestChunk(f){return this.c.getNearestChunk(f)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(f){return this.c.getLineContent(f)}getLineCharCode(f,P){return this.c.getLineCharCode(f,P)}getCharCode(f){return this.c.getCharCode(f)}getLineLength(f){return this.c.getLineLength(f)}getLineMinColumn(f){return 1}getLineMaxColumn(f){return this.getLineLength(f)+1}getLineFirstNonWhitespaceColumn(f){const P=h.$zf(this.getLineContent(f));return P===-1?0:P+1}getLineLastNonWhitespaceColumn(f){const P=h.$Bf(this.getLineContent(f));return P===-1?0:P+2}n(f){switch(f){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(f){this.c.setEOL(f)}applyEdits(f,P,v){let o=this.g,m=this.h,$=this.j,d=!0,i=[];for(let g=0;g<f.length;g++){const y=f[g];d&&y._isTracked&&(d=!1);const k=y.range;if(y.text){let b=!0;$||(b=!h.$Zf(y.text),$=b),!o&&b&&(o=h.$Yf(y.text)),!m&&b&&(m=h.$2f(y.text))}let S="",R=0,C=0,w=0;if(y.text){let b;[R,C,w,b]=(0,A.$Ju)(y.text);const N=this.getEOL(),L=N===`\r
`?A.StringEOL.CRLF:A.StringEOL.LF;b===A.StringEOL.Unknown||b===L?S=y.text:S=y.text.replace(/\r\n|\r|\n/g,N)}i[g]={sortIndex:g,identifier:y.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:S,eolCount:R,firstLineLength:C,lastLineLength:w,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}i.sort(I.u);let a=!1;for(let g=0,y=i.length-1;g<y;g++){const k=i[g].range.getEndPosition(),S=i[g+1].range.getStartPosition();if(S.isBeforeOrEqual(k)){if(S.isBefore(k))throw new Error("Overlapping ranges are not allowed!");a=!0}}d&&(i=this.s(i));const t=v||P?I._getInverseEditRanges(i):[],r=[];if(P)for(let g=0;g<i.length;g++){const y=i[g],k=t[g];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let S=k.startLineNumber;S<=k.endLineNumber;S++){let R="";S===k.startLineNumber&&(R=this.getLineContent(y.range.startLineNumber),h.$zf(R)!==-1)||r.push({lineNumber:S,oldContent:R})}}let n=null;if(v){let g=0;n=[];for(let y=0;y<i.length;y++){const k=i[y],S=t[y],R=this.getValueInRange(k.range),C=k.rangeOffset+g;g+=k.text.length-R.length,n[y]={sortIndex:k.sortIndex,identifier:k.identifier,range:S,text:R,textChange:new p.$pu(k.rangeOffset,R,C,k.text)}}a||n.sort((y,k)=>y.sortIndex-k.sortIndex)}this.g=o,this.h=m,this.j=$;const u=this.t(i);let l=null;if(P&&r.length>0){r.sort((g,y)=>y.lineNumber-g.lineNumber),l=[];for(let g=0,y=r.length;g<y;g++){const k=r[g].lineNumber;if(g>0&&r[g-1].lineNumber===k)continue;const S=r[g].oldContent,R=this.getLineContent(k);R.length===0||R===S||h.$zf(R)!==-1||l.push(k)}}return this.m.fire(),new O.$tw(n,u,l)}s(f){return f.length<1e3?f:[this._toSingleEditOperation(f)]}_toSingleEditOperation(f){let P=!1;const v=f[0].range,o=f[f.length-1].range,m=new D.$Yt(v.startLineNumber,v.startColumn,o.endLineNumber,o.endColumn);let $=v.startLineNumber,d=v.startColumn;const i=[];for(let u=0,l=f.length;u<l;u++){const g=f[u],y=g.range;P=P||g.forceMoveMarkers,i.push(this.getValueInRange(new D.$Yt($,d,y.startLineNumber,y.startColumn))),g.text.length>0&&i.push(g.text),$=y.endLineNumber,d=y.endColumn}const a=i.join(""),[t,r,n]=(0,A.$Ju)(a);return{sortIndex:0,identifier:f[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,O.EndOfLinePreference.TextDefined),text:a,eolCount:t,firstLineLength:r,lastLineLength:n,forceMoveMarkers:P,isAutoWhitespaceEdit:!1}}t(f){f.sort(I.w);const P=[];for(let v=0;v<f.length;v++){const o=f[v],m=o.range.startLineNumber,$=o.range.startColumn,d=o.range.endLineNumber,i=o.range.endColumn;if(m===d&&$===i&&o.text.length===0)continue;o.text?(this.c.delete(o.rangeOffset,o.rangeLength),this.c.insert(o.rangeOffset,o.text,!0)):this.c.delete(o.rangeOffset,o.rangeLength);const a=new D.$Yt(m,$,d,i);P.push({range:a,rangeLength:o.rangeLength,text:o.text,rangeOffset:o.rangeOffset,forceMoveMarkers:o.forceMoveMarkers})}return P}findMatchesLineByLine(f,P,v,o){return this.c.findMatchesLineByLine(f,P,v,o)}getPieceTree(){return this.c}static _getInverseEditRange(f,P){const v=f.startLineNumber,o=f.startColumn,[m,$,d]=(0,A.$Ju)(P);let i;if(P.length>0){const a=m+1;a===1?i=new D.$Yt(v,o,v,o+$):i=new D.$Yt(v,o,v+a-1,d+1)}else i=new D.$Yt(v,o,v,o);return i}static _getInverseEditRanges(f){const P=[];let v=0,o=0,m=null;for(let $=0,d=f.length;$<d;$++){const i=f[$];let a,t;m?m.range.endLineNumber===i.range.startLineNumber?(a=v,t=o+(i.range.startColumn-m.range.endColumn)):(a=v+(i.range.startLineNumber-m.range.endLineNumber),t=i.range.startColumn):(a=i.range.startLineNumber,t=i.range.startColumn);let r;if(i.text.length>0){const n=i.eolCount+1;n===1?r=new D.$Yt(a,t,a,t+i.firstLineLength):r=new D.$Yt(a,t,a+n-1,i.lastLineLength+1)}else r=new D.$Yt(a,t,a,t);v=r.endLineNumber,o=r.endColumn,P.push(r),m=i}return P}static u(f,P){const v=D.$Yt.compareRangesUsingEnds(f.range,P.range);return v===0?f.sortIndex-P.sortIndex:v}static w(f,P){const v=D.$Yt.compareRangesUsingEnds(f.range,P.range);return v===0?P.sortIndex-f.sortIndex:-v}}e.$KD=I}),define(Re[216],Ce([1,0,26,13,56,141,215]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LD=void 0,h=Ue(h);class A{constructor(I,E,f,P,v,o,m,$,d){this.a=I,this.b=E,this.c=f,this.d=P,this.e=v,this.f=o,this.g=m,this.h=$,this.j=d}k(I){const E=this.c+this.d+this.e,f=this.c+this.e;return E===0?I===D.DefaultEndOfLine.LF?`
`:`\r
`:f>E/2?`\r
`:`
`}create(I){const E=this.k(I),f=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let v=0,o=f.length;v<o;v++){const m=f[v].buffer.replace(/\r\n|\r|\n/g,E),$=(0,O.$FD)(m);f[v]=new O.$ID(m,$)}const P=new T.$KD(f,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&h.$0f(I)&&(this.b=h.$9f,I=I.substr(1));const E=I.charCodeAt(I.length-1);E===s.CharCode.CarriageReturn||E>=55296&&E<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=E):(this.m(I,!1),this.c=!1,this.d=E)}m(I,E){!E&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const E=(0,O.$GD)(this.e,I);this.a.push(new O.$ID(I,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Yf(I)),this.k||(this.k=h.$2f(I)))}finish(I=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const E=(0,O.$FD)(I.buffer);I.lineStarts=E,this.d===s.CharCode.CarriageReturn&&this.f++}}}e.$LD=p}),define(Re[147],Ce([1,0,21,10]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Feb=p,e.$Geb=I,h=Ue(h);var D;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(D||(D={}));function O(E){for(let f=0,P=E.length;f<P;f+=4){const v=E[f+0],o=E[f+1],m=E[f+2],$=E[f+3];E[f+0]=$,E[f+1]=m,E[f+2]=o,E[f+3]=v}}function T(E){const f=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return h.$G()||O(f),s.$Se.wrap(f)}function A(E){const f=E.buffer;if(h.$G()||O(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const P=new Uint8Array(f.byteLength);return P.set(f),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function p(E){const f=new Uint32Array(c(E));let P=0;if(f[P++]=E.id,E.type==="full")f[P++]=D.Full,f[P++]=E.data.length,f.set(E.data,P),P+=E.data.length;else{f[P++]=D.Delta,f[P++]=E.deltas.length;for(const v of E.deltas)f[P++]=v.start,f[P++]=v.deleteCount,v.data?(f[P++]=v.data.length,f.set(v.data,P),P+=v.data.length):f[P++]=0}return T(f)}function c(E){let f=0;if(f+=2,E.type==="full")f+=1+E.data.length;else{f+=1,f+=3*E.deltas.length;for(const P of E.deltas)P.data&&(f+=P.data.length)}return f}function I(E){const f=A(E);let P=0;const v=f[P++];if(f[P++]===D.Full){const d=f[P++],i=f.subarray(P,P+d);return P+=d,{id:v,type:"full",data:i}}const m=f[P++],$=[];for(let d=0;d<m;d++){const i=f[P++],a=f[P++],t=f[P++];let r;t>0&&(r=f.subarray(P,P+t),P+=t),$[d]={start:i,deleteCount:a,data:r}}return{id:v,type:"delta",deltas:$}}}),define(Re[217],Ce([1,0,26,12,7]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.TokenType=void 0;var O;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(O||(e.TokenType=O={}));function T(...I){switch(I.length){case 1:return(0,D.localize)(1693,null,I[0]);case 2:return(0,D.localize)(1694,null,I[0],I[1]);case 3:return(0,D.localize)(1695,null,I[0],I[1],I[2]);default:return}}const A=(0,D.localize)(1696,null),p=(0,D.localize)(1697,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return E.isTripleEq?"===":"==";case O.NotEq:return E.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return E.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return E.lexeme;case O.QuotedStr:return E.lexeme;case O.Error:return E.lexeme;case O.EOF:return"EOF";default:throw(0,h.$_)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case s.CharCode.OpenParen:this.k(O.LParen);break;case s.CharCode.CloseParen:this.k(O.RParen);break;case s.CharCode.ExclamationMark:if(this.h(s.CharCode.Equals)){const f=this.h(s.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:f})}else this.k(O.Neg);break;case s.CharCode.SingleQuote:this.o();break;case s.CharCode.Slash:this.q();break;case s.CharCode.Equals:if(this.h(s.CharCode.Equals)){const f=this.h(s.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:f})}else this.h(s.CharCode.Tilde)?this.k(O.RegexOp):this.l(T("==","=~"));break;case s.CharCode.LessThan:this.k(this.h(s.CharCode.Equals)?O.LtEq:O.Lt);break;case s.CharCode.GreaterThan:this.k(this.h(s.CharCode.Equals)?O.GtEq:O.Gt);break;case s.CharCode.Ampersand:this.h(s.CharCode.Ampersand)?this.k(O.And):this.l(T("&&"));break;case s.CharCode.Pipe:this.h(s.CharCode.Pipe)?this.k(O.Or):this.l(T("||"));break;case s.CharCode.Space:case s.CharCode.CarriageReturn:case s.CharCode.Tab:case s.CharCode.LineFeed:case s.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?s.CharCode.Null:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const f=this.d,P=this.c.substring(this.d,this.e),v={type:O.Error,offset:this.d,lexeme:P};this.g.push({offset:f,lexeme:P,additionalInfo:E}),this.f.push(v)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const f=this.c.substring(this.d,this.e),P=c.b.get(f);P?this.k(P):this.f.push({type:O.Str,lexeme:f,offset:this.d})}}o(){for(;this.j()!==s.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,f=!1,P=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(p);return}const o=this.c.charCodeAt(E);if(f)f=!1;else if(o===s.CharCode.Slash&&!P){E++;break}else o===s.CharCode.OpenSquareBracket?P=!0:o===s.CharCode.Backslash?f=!0:o===s.CharCode.CloseSquareBracket&&(P=!1);E++}for(;E<this.c.length&&c.a.has(this.c.charCodeAt(E));)E++;this.e=E;const v=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fj=c}),define(Re[148],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const s={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribChatParticipantDetection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribChatParticipantDetection.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(s)}),define(Re[112],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=void 0;class s{constructor(D,O=[],T=!1){this.ctor=D,this.staticArguments=O,this.supportsDelayedInstantiation=T}}e.$Hi=s}),define(Re[89],Ce([1,0,112]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$2s=O,e.$3s=T;const h=[];var D;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function O(A,p,c){p instanceof s.$Hi||(p=new s.$Hi(p,[],!!c)),h.push([A,p])}function T(){return h}}),define(Re[218],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;class s{constructor(O,T){this.key=O,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$Er=s;class h{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const T of this.a.values())T.outgoing.size===0&&O.push(T);return O}insertEdge(O,T){const A=this.lookupOrInsertNode(O),p=this.lookupOrInsertNode(T);A.outgoing.set(p.key,p),p.incoming.set(A.key,A)}removeNode(O){const T=this.b(O);this.a.delete(T);for(const A of this.a.values())A.outgoing.delete(T),A.incoming.delete(T)}lookupOrInsertNode(O){const T=this.b(O);let A=this.a.get(T);return A||(A=new s(T,O),this.a.set(T,A)),A}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[T,A]of this.a)O.push(`${T}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,T]of this.a){const A=new Set([O]),p=this.c(T,A);if(p)return p}}c(O,T){for(const[A,p]of O.outgoing){if(T.has(A))return[...T,A].join(" -> ");T.add(A);const c=this.c(p,T);if(c)return c;T.delete(A)}}}e.$Fr=h}),define(Re[5],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e._util=void 0,e.$Ki=D,e.$Li=O;var s;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function A(p){return p[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=A})(s||(e._util=s={})),e.$Ji=D("instantiationService");function h(T,A,p){A[s.DI_TARGET]===A?A[s.DI_DEPENDENCIES].push({id:T,index:p}):(A[s.DI_DEPENDENCIES]=[{id:T,index:p}],A[s.DI_TARGET]=A)}function D(T){if(s.serviceIds.has(T))return s.serviceIds.get(T);const A=function(p,c,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(A,p,I)};return A.toString=()=>T,s.serviceIds.set(T,A),A}function O(T){return T}}),define(Re[47],Ce([1,0,17,2,5]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$ej=void 0,e.$fj=O,e.$gj=T,e.$hj=p,e.$ij=c,e.$jj=I,e.$kj=E,e.$lj=f,e.$mj=v,e.$nj=o,e.$oj=m,s=Ue(s),e.$ej=(0,D.$Ki)("configurationService");function O($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof h.URI)}function T($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof h.URI)}var A;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function p($){switch($){case A.APPLICATION:return"APPLICATION";case A.USER:return"USER";case A.USER_LOCAL:return"USER_LOCAL";case A.USER_REMOTE:return"USER_REMOTE";case A.WORKSPACE:return"WORKSPACE";case A.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case A.DEFAULT:return"DEFAULT";case A.MEMORY:return"MEMORY"}}function c($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function I($,d){const i=Object.create(null);for(const a in $)E(i,a,$[a],d);return i}function E($,d,i,a){const t=d.split("."),r=t.pop();let n=$;for(let u=0;u<t.length;u++){const l=t[u];let g=n[l];switch(typeof g){case"undefined":g=n[l]=Object.create(null);break;case"object":if(g===null){a(`Ignoring ${d} as ${t.slice(0,u+1).join(".")} is null`);return}break;default:a(`Ignoring ${d} as ${t.slice(0,u+1).join(".")} is ${JSON.stringify(g)}`);return}n=g}if(typeof n=="object"&&n!==null)try{n[r]=i}catch{a(`Ignoring ${d} as ${t.join(".")} is ${JSON.stringify(n)}`)}else a(`Ignoring ${d} as ${t.join(".")} is ${JSON.stringify(n)}`)}function f($,d){const i=d.split(".");P($,i)}function P($,d){const i=d.shift();if(d.length===0){delete $[i];return}if(Object.keys($).indexOf(i)!==-1){const a=$[i];typeof a=="object"&&!Array.isArray(a)&&(P(a,d),Object.keys(a).length===0&&delete $[i])}}function v($,d,i){function a(n,u){let l=n;for(const g of u){if(typeof l!="object"||l===null)return;l=l[g]}return l}const t=d.split("."),r=a($,t);return typeof r>"u"?i:r}function o($,d,i){Object.keys(d).forEach(a=>{a!=="__proto__"&&(a in $?s.$lg($[a])&&s.$lg(d[a])?o($[a],d[a],i):i&&($[a]=d[a]):$[a]=d[a])})}function m($){return $.replace(/[\[\]]/g,"")}}),define(Re[36],Ce([1,0,26,10,13,217,5,7,12]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Ij=e.$Hj=e.ContextKeyExprType=void 0,e.$Gj=I,e.$Jj=u,e.$Kj=l,e.$4j=te;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",h.$m),c.set("isLinux",h.$n),c.set("isWindows",h.$l),c.set("isWeb",h.$r),c.set("isMacNative",h.$m&&!h.$r),c.set("isEdge",h.$K),c.set("isFirefox",h.$I),c.set("isChrome",h.$H),c.set("isSafari",h.$J);function I(Y,q){if(c.get(Y)!==void 0)throw(0,p.$$)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Y,q)}const E=Object.prototype.hasOwnProperty;var f;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const P={regexParsingWithErrorRecovery:!0},v=(0,A.localize)(1673,null),o=(0,A.localize)(1674,null),m=(0,A.localize)(1675,null),$=(0,A.localize)(1676,null),d=(0,A.localize)(1677,null),i=(0,A.localize)(1678,null),a=(0,A.localize)(1679,null),t=(0,A.localize)(1680,null);class r{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=P){this.k=q,this.d=new O.$Fj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:o});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const be=this.D(),ae=be.type===O.TokenType.Str?i:void 0;throw this.h.push({message:d,offset:be.offset,lexeme:O.$Fj.getLexeme(be),additionalInfo:ae}),r.c}return se}catch(se){if(se!==r.c)throw se;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(O.TokenType.Or);){const se=this.o();q.push(se)}return q.length===1?q[0]:n.or(...q)}o(){const q=[this.s()];for(;this.y(O.TokenType.And);){const se=this.s();q.push(se)}return q.length===1?q[0]:n.and(...q)}s(){if(this.y(O.TokenType.Neg)){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),y.INSTANCE;case O.TokenType.False:return this.z(),k.INSTANCE;case O.TokenType.LParen:{this.z();const se=this.l();return this.A(O.TokenType.RParen,$),se?.negate()}case O.TokenType.Str:return this.z(),N.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),n.true();case O.TokenType.False:return this.z(),n.false();case O.TokenType.LParen:{this.z();const se=this.l();return this.A(O.TokenType.RParen,$),se}case O.TokenType.Str:{const se=q.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ae.type!==O.TokenType.RegexStr)throw this.B("REGEX",ae);const we=ae.lexeme,$e=we.lastIndexOf("/"),pe=$e===we.length-1?void 0:this.w(we.substring($e+1));let Oe;try{Oe=new RegExp(we.substring(1,$e),pe)}catch{throw this.B("REGEX",ae)}return j.create(se,Oe)}switch(ae.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const we=[ae.lexeme];this.z();let $e=this.D(),pe=0;for(let xe=0;xe<ae.lexeme.length;xe++)ae.lexeme.charCodeAt(xe)===s.CharCode.OpenParen?pe++:ae.lexeme.charCodeAt(xe)===s.CharCode.CloseParen&&pe--;for(;!this.E()&&$e.type!==O.TokenType.And&&$e.type!==O.TokenType.Or;){switch($e.type){case O.TokenType.LParen:pe++;break;case O.TokenType.RParen:pe--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let xe=0;xe<$e.lexeme.length;xe++)$e.lexeme.charCodeAt(xe)===s.CharCode.OpenParen?pe++:ae.lexeme.charCodeAt(xe)===s.CharCode.CloseParen&&pe--}if(pe<0)break;we.push(O.$Fj.getLexeme($e)),this.z(),$e=this.D()}const Oe=we.join(""),Fe=Oe.lastIndexOf("/"),He=Fe===Oe.length-1?void 0:this.w(Oe.substring(Fe+1));let Ze;try{Ze=new RegExp(Oe.substring(1,Fe),He)}catch{throw this.B("REGEX",ae)}return n.regex(se,Ze)}case O.TokenType.QuotedStr:{const we=ae.lexeme;this.z();let $e=null;if(!(0,D.$hf)(we)){const pe=we.indexOf("/"),Oe=we.lastIndexOf("/");if(pe!==Oe&&pe>=0){const Fe=we.slice(pe+1,Oe),He=we[Oe+1]==="i"?"i":"";try{$e=new RegExp(Fe,He)}catch{throw this.B("REGEX",ae)}}}if($e===null)throw this.B("REGEX",ae);return j.create(se,$e)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,m);const ae=this.u();return n.notIn(se,ae)}switch(this.D().type){case O.TokenType.Eq:{this.z();const ae=this.u();if(this.x().type===O.TokenType.QuotedStr)return n.equals(se,ae);switch(ae){case"true":return n.has(se);case"false":return n.not(se);default:return n.equals(se,ae)}}case O.TokenType.NotEq:{this.z();const ae=this.u();if(this.x().type===O.TokenType.QuotedStr)return n.notEquals(se,ae);switch(ae){case"true":return n.not(se);case"false":return n.has(se);default:return n.notEquals(se,ae)}}case O.TokenType.Lt:return this.z(),V.create(se,this.u());case O.TokenType.LtEq:return this.z(),F.create(se,this.u());case O.TokenType.Gt:return this.z(),M.create(se,this.u());case O.TokenType.GtEq:return this.z(),z.create(se,this.u());case O.TokenType.In:return this.z(),n.in(se,this.u());default:return n.has(se)}}case O.TokenType.EOF:throw this.h.push({message:a,offset:q.offset,lexeme:"",additionalInfo:t}),r.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),q.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,se){if(this.C(q))return this.z();throw this.B(se,this.D())}B(q,se,be){const ae=(0,A.localize)(1681,null,q,O.$Fj.getLexeme(se)),we=se.offset,$e=O.$Fj.getLexeme(se);return this.h.push({message:ae,offset:we,lexeme:$e,additionalInfo:be}),r.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Hj=r;class n{static false(){return y.INSTANCE}static true(){return k.INSTANCE}static has(q){return S.create(q)}static equals(q,se){return R.create(q,se)}static notEquals(q,se){return b.create(q,se)}static regex(q,se){return j.create(q,se)}static in(q,se){return C.create(q,se)}static notIn(q,se){return w.create(q,se)}static not(q){return N.create(q)}static and(...q){return B.create(q,null,!0)}static or(...q){return U.create(q,null,!0)}static greater(q,se){return M.create(q,se)}static greaterEquals(q,se){return z.create(q,se)}static smaller(q,se){return V.create(q,se)}static smallerEquals(q,se){return F.create(q,se)}static{this.c=new r({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Ij=n;function u(Y){const q=new r({regexParsingWithErrorRecovery:!1});return Y.map(se=>(q.parse(se),q.lexingErrors.length>0?q.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,A.localize)(1682,null,be.additionalInfo):(0,A.localize)(1683,null),offset:be.offset,length:be.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function l(Y,q){const se=Y?Y.substituteConstants():void 0,be=q?q.substituteConstants():void 0;return!se&&!be?!0:!se||!be?!1:se.equals(be)}function g(Y,q){return Y.cmp(q)}class y{static{this.INSTANCE=new y}constructor(){this.type=f.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return k.INSTANCE}}e.$Lj=y;class k{static{this.INSTANCE=new k}constructor(){this.type=f.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return y.INSTANCE}}e.$Mj=k;class S{static create(q,se=null){const be=c.get(q);return typeof be=="boolean"?be?k.INSTANCE:y.INSTANCE:new S(q,se)}constructor(q,se){this.key=q,this.c=se,this.type=f.Defined}cmp(q){return q.type!==this.type?this.type-q.type:x(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=c.get(this.key);return typeof q=="boolean"?q?k.INSTANCE:y.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Nj=S;class R{static create(q,se,be=null){if(typeof se=="boolean")return se?S.create(q,be):N.create(q,be);const ae=c.get(q);return typeof ae=="boolean"?se===(ae?"true":"false")?k.INSTANCE:y.INSTANCE:new R(q,se,be)}constructor(q,se,be){this.c=q,this.d=se,this.f=be,this.type=f.Equals}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=c.get(this.c);if(typeof q=="boolean"){const se=q?"true":"false";return this.d===se?k.INSTANCE:y.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Oj=R;class C{static create(q,se){return new C(q,se)}constructor(q,se){this.d=q,this.f=se,this.type=f.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const se=q.getValue(this.f),be=q.getValue(this.d);return Array.isArray(se)?se.includes(be):typeof be=="string"&&typeof se=="object"&&se!==null?E.call(se,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Pj=C;class w{static create(q,se){return new w(q,se)}constructor(q,se){this.d=q,this.f=se,this.type=f.NotIn,this.c=C.create(q,se)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qj=w;class b{static create(q,se,be=null){if(typeof se=="boolean")return se?N.create(q,be):S.create(q,be);const ae=c.get(q);return typeof ae=="boolean"?se===(ae?"true":"false")?y.INSTANCE:k.INSTANCE:new b(q,se,be)}constructor(q,se,be){this.c=q,this.d=se,this.f=be,this.type=f.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=c.get(this.c);if(typeof q=="boolean"){const se=q?"true":"false";return this.d===se?y.INSTANCE:k.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Rj=b;class N{static create(q,se=null){const be=c.get(q);return typeof be=="boolean"?be?y.INSTANCE:k.INSTANCE:new N(q,se)}constructor(q,se){this.c=q,this.d=se,this.type=f.Not}cmp(q){return q.type!==this.type?this.type-q.type:x(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=c.get(this.c);return typeof q=="boolean"?q?y.INSTANCE:k.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$Sj=N;function L(Y,q){if(typeof Y=="string"){const se=parseFloat(Y);isNaN(se)||(Y=se)}return typeof Y=="string"||typeof Y=="number"?q(Y):y.INSTANCE}class M{static create(q,se,be=null){return L(se,ae=>new M(q,ae,be))}constructor(q,se,be){this.c=q,this.d=se,this.f=be,this.type=f.Greater}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Tj=M;class z{static create(q,se,be=null){return L(se,ae=>new z(q,ae,be))}constructor(q,se,be){this.c=q,this.d=se,this.f=be,this.type=f.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Uj=z;class V{static create(q,se,be=null){return L(se,ae=>new V(q,ae,be))}constructor(q,se,be){this.c=q,this.d=se,this.f=be,this.type=f.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Vj=V;class F{static create(q,se,be=null){return L(se,ae=>new F(q,ae,be))}constructor(q,se,be){this.c=q,this.d=se,this.f=be,this.type=f.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:oe(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Wj=F;class j{static create(q,se){return new j(q,se)}constructor(q,se){this.d=q,this.f=se,this.type=f.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const se=this.f?this.f.source:"",be=q.f?q.f.source:"";return se<be?-1:se>be?1:0}equals(q){if(q.type===this.type){const se=this.f?this.f.source:"",be=q.f?q.f.source:"";return this.d===q.d&&se===be}return!1}substituteConstants(){return this}evaluate(q){const se=q.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$Xj=j;class W{static create(q){return new W(q)}constructor(q){this.c=q,this.type=f.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new W(this.c.map(q))}negate(){return this.c}}e.$Yj=W;function J(Y){let q=null;for(let se=0,be=Y.length;se<be;se++){const ae=Y[se].substituteConstants();if(Y[se]!==ae&&q===null){q=[];for(let we=0;we<se;we++)q[we]=Y[we]}q!==null&&(q[se]=ae)}return q===null?Y:q}class B{static create(q,se,be){return B.d(q,se,be)}constructor(q,se){this.expr=q,this.c=se,this.type=f.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let se=0,be=this.expr.length;se<be;se++){const ae=g(this.expr[se],q.expr[se]);if(ae!==0)return ae}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let se=0,be=this.expr.length;se<be;se++)if(!this.expr[se].equals(q.expr[se]))return!1;return!0}return!1}substituteConstants(){const q=J(this.expr);return q===this.expr?this:B.create(q,this.c,!1)}evaluate(q){for(let se=0,be=this.expr.length;se<be;se++)if(!this.expr[se].evaluate(q))return!1;return!0}static d(q,se,be){const ae=[];let we=!1;for(const $e of q)if($e){if($e.type===f.True){we=!0;continue}if($e.type===f.False)return y.INSTANCE;if($e.type===f.And){ae.push(...$e.expr);continue}ae.push($e)}if(ae.length===0&&we)return k.INSTANCE;if(ae.length!==0){if(ae.length===1)return ae[0];ae.sort(g);for(let $e=1;$e<ae.length;$e++)ae[$e-1].equals(ae[$e])&&(ae.splice($e,1),$e--);if(ae.length===1)return ae[0];for(;ae.length>1;){const $e=ae[ae.length-1];if($e.type!==f.Or)break;ae.pop();const pe=ae.pop(),Oe=ae.length===0,Fe=U.create($e.expr.map(He=>B.create([He,pe],null,be)),null,Oe);Fe&&(ae.push(Fe),ae.sort(g))}if(ae.length===1)return ae[0];if(be){for(let $e=0;$e<ae.length;$e++)for(let pe=$e+1;pe<ae.length;pe++)if(ae[$e].negate().equals(ae[pe]))return y.INSTANCE;if(ae.length===1)return ae[0]}return new B(ae,se)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const se of this.expr)q.push(...se.keys());return q}map(q){return new B(this.expr.map(se=>se.map(q)),null)}negate(){if(!this.c){const q=[];for(const se of this.expr)q.push(se.negate());this.c=U.create(q,this,!0)}return this.c}}e.$Zj=B;class U{static create(q,se,be){return U.d(q,se,be)}constructor(q,se){this.expr=q,this.c=se,this.type=f.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let se=0,be=this.expr.length;se<be;se++){const ae=g(this.expr[se],q.expr[se]);if(ae!==0)return ae}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let se=0,be=this.expr.length;se<be;se++)if(!this.expr[se].equals(q.expr[se]))return!1;return!0}return!1}substituteConstants(){const q=J(this.expr);return q===this.expr?this:U.create(q,this.c,!1)}evaluate(q){for(let se=0,be=this.expr.length;se<be;se++)if(this.expr[se].evaluate(q))return!0;return!1}static d(q,se,be){let ae=[],we=!1;if(q){for(let $e=0,pe=q.length;$e<pe;$e++){const Oe=q[$e];if(Oe){if(Oe.type===f.False){we=!0;continue}if(Oe.type===f.True)return k.INSTANCE;if(Oe.type===f.Or){ae=ae.concat(Oe.expr);continue}ae.push(Oe)}}if(ae.length===0&&we)return y.INSTANCE;ae.sort(g)}if(ae.length!==0){if(ae.length===1)return ae[0];for(let $e=1;$e<ae.length;$e++)ae[$e-1].equals(ae[$e])&&(ae.splice($e,1),$e--);if(ae.length===1)return ae[0];if(be){for(let $e=0;$e<ae.length;$e++)for(let pe=$e+1;pe<ae.length;pe++)if(ae[$e].negate().equals(ae[pe]))return k.INSTANCE;if(ae.length===1)return ae[0]}return new U(ae,se)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const se of this.expr)q.push(...se.keys());return q}map(q){return new U(this.expr.map(se=>se.map(q)),null)}negate(){if(!this.c){const q=[];for(const se of this.expr)q.push(se.negate());for(;q.length>1;){const se=q.shift(),be=q.shift(),ae=[];for(const we of ce(se))for(const $e of ce(be))ae.push(B.create([we,$e],null,!1));q.unshift(U.create(ae,null,!1))}this.c=U.create(q,this,!0)}return this.c}}e.$1j=U;class _ extends S{static{this.d=[]}static all(){return _.d.values()}constructor(q,se,be){super(q,null),this.f=se,typeof be=="object"?_.d.push({...be,key:q}):be!==!0&&_.d.push({key:q,description:be,type:se!=null?typeof se:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return R.create(this.key,q)}notEqualsTo(q){return b.create(this.key,q)}}e.$2j=_,e.$3j=(0,T.$Ki)("contextKeyService");function x(Y,q){return Y<q?-1:Y>q?1:0}function oe(Y,q,se,be){return Y<se?-1:Y>se?1:q<be?-1:q>be?1:0}function te(Y,q){if(Y.type===f.False||q.type===f.True)return!0;if(Y.type===f.Or)return q.type===f.Or?me(Y.expr,q.expr):!1;if(q.type===f.Or){for(const se of q.expr)if(te(Y,se))return!0;return!1}if(Y.type===f.And){if(q.type===f.And)return me(q.expr,Y.expr);for(const se of Y.expr)if(te(se,q))return!0;return!1}return Y.equals(q)}function me(Y,q){let se=0,be=0;for(;se<Y.length&&be<q.length;){const ae=Y[se].cmp(q[be]);if(ae<0)return!1;ae===0&&se++,be++}return se===Y.length}function ce(Y){return Y.type===f.Or?Y.expr:[Y]}}),define(Re[219],Ce([1,0,36,5]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=e.$Ct=e.AccessibilitySupport=e.$Bt=void 0,e.$Dt=O,e.$Bt=(0,h.$Ki)("accessibilityService");var D;(function(T){T[T.Unknown=0]="Unknown",T[T.Disabled=1]="Disabled",T[T.Enabled=2]="Enabled"})(D||(e.AccessibilitySupport=D={})),e.$Ct=new s.$2j("accessibilityModeEnabled",!1);function O(T){return T&&typeof T=="object"&&typeof T.label=="string"&&(typeof T.role>"u"||typeof T.role=="string")}e.$Et="ACCESSIBLE_VIEW_SHOWN_"}),define(Re[113],Ce([1,0,18,24,10,190,85,198,140,7,219]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=n,e.stringSet=g,e.cursorStyleToString=L,e.filterValidationDecorations=qe,s=Ue(s),h=Ue(h),D=Ue(D),c=Ue(c);var E;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=f;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class v{constructor(X,Pe,Ke,Xe){this.id=X,this.name=Pe,this.defaultValue=Ke,this.schema=Xe}applyUpdate(X,Pe){return m(X,Pe)}compute(X,Pe,Ke){return Ke}}class o{constructor(X,Pe){this.newValue=X,this.didChange=Pe}}e.ApplyUpdateResult=o;function m(ne,X){if(typeof ne!="object"||typeof X!="object"||!ne||!X)return new o(X,ne!==X);if(Array.isArray(ne)||Array.isArray(X)){const Ke=Array.isArray(ne)&&Array.isArray(X)&&s.$yb(ne,X);return new o(X,!Ke)}let Pe=!1;for(const Ke in X)if(X.hasOwnProperty(Ke)){const Xe=m(ne[Ke],X[Ke]);Xe.didChange&&(ne[Ke]=Xe.newValue,Pe=!0)}return new o(ne,Pe)}class ${constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,Pe){return m(X,Pe)}validate(X){return this.defaultValue}}class d{constructor(X,Pe,Ke,Xe){this.id=X,this.name=Pe,this.defaultValue=Ke,this.schema=Xe}applyUpdate(X,Pe){return m(X,Pe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,Pe,Ke){return Ke}}function i(ne,X){return typeof ne>"u"?X:ne==="false"?!1:!!ne}class a extends d{constructor(X,Pe,Ke,Xe=void 0){typeof Xe<"u"&&(Xe.type="boolean",Xe.default=Ke),super(X,Pe,Ke,Xe)}validate(X){return i(X,this.defaultValue)}}function t(ne,X,Pe,Ke){if(typeof ne>"u")return X;let Xe=parseInt(ne,10);return isNaN(Xe)?X:(Xe=Math.max(Pe,Xe),Xe=Math.min(Ke,Xe),Xe|0)}class r extends d{static clampedInt(X,Pe,Ke,Xe){return t(X,Pe,Ke,Xe)}constructor(X,Pe,Ke,Xe,st,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=Ke,dt.minimum=Xe,dt.maximum=st),super(X,Pe,Ke,dt),this.minimum=Xe,this.maximum=st}validate(X){return r.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function n(ne,X,Pe,Ke){if(typeof ne>"u")return X;const Xe=u.float(ne,X);return u.clamp(Xe,Pe,Ke)}class u extends d{static clamp(X,Pe,Ke){return X<Pe?Pe:X>Ke?Ke:X}static float(X,Pe){if(typeof X=="number")return X;if(typeof X>"u")return Pe;const Ke=parseFloat(X);return isNaN(Ke)?Pe:Ke}constructor(X,Pe,Ke,Xe,st){typeof st<"u"&&(st.type="number",st.default=Ke),super(X,Pe,Ke,st),this.validationFn=Xe}validate(X){return this.validationFn(u.float(X,this.defaultValue))}}class l extends d{static string(X,Pe){return typeof X!="string"?Pe:X}constructor(X,Pe,Ke,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.default=Ke),super(X,Pe,Ke,Xe)}validate(X){return l.string(X,this.defaultValue)}}function g(ne,X,Pe,Ke){return typeof ne!="string"?X:Ke&&ne in Ke?Ke[ne]:Pe.indexOf(ne)===-1?X:ne}class y extends d{constructor(X,Pe,Ke,Xe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Xe,st.default=Ke),super(X,Pe,Ke,st),this.c=Xe}validate(X){return g(X,this.defaultValue,this.c)}}class k extends v{constructor(X,Pe,Ke,Xe,st,dt,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=st,gt.default=Xe),super(X,Pe,Ke,gt),this.c=st,this.d=dt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function S(ne){switch(ne){case"none":return E.None;case"keep":return E.Keep;case"brackets":return E.Brackets;case"advanced":return E.Advanced;case"full":return E.Full}}class R extends v{constructor(){super(ke.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(302,null),c.localize(303,null),c.localize(304,null)],default:"auto",tags:["accessibility"],description:c.localize(305,null)})}validate(X){switch(X){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(X,Pe,Ke){return Ke===I.AccessibilitySupport.Unknown?X.accessibilitySupport:Ke}}class C extends v{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(ke.comments,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:c.localize(306,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:c.localize(307,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{insertSpace:i(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var w;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(w||(e.TextEditorCursorBlinkingStyle=w={}));function b(ne){switch(ne){case"blink":return w.Blink;case"smooth":return w.Smooth;case"phase":return w.Phase;case"expand":return w.Expand;case"solid":return w.Solid}}var N;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(N||(e.TextEditorCursorStyle=N={}));function L(ne){switch(ne){case N.Line:return"line";case N.Block:return"block";case N.Underline:return"underline";case N.LineThin:return"line-thin";case N.BlockOutline:return"block-outline";case N.UnderlineThin:return"underline-thin"}}function M(ne){switch(ne){case"line":return N.Line;case"block":return N.Block;case"underline":return N.Underline;case"line-thin":return N.LineThin;case"block-outline":return N.BlockOutline;case"underline-thin":return N.UnderlineThin}}class z extends ${constructor(){super(ke.editorClassName)}compute(X,Pe,Ke){const Xe=["monaco-editor"];return Pe.get(ke.extraEditorClassName)&&Xe.push(Pe.get(ke.extraEditorClassName)),X.extraEditorClassName&&Xe.push(X.extraEditorClassName),Pe.get(ke.mouseStyle)==="default"?Xe.push("mouse-default"):Pe.get(ke.mouseStyle)==="copy"&&Xe.push("mouse-copy"),Pe.get(ke.showUnused)&&Xe.push("showUnused"),Pe.get(ke.showDeprecated)&&Xe.push("showDeprecated"),Xe.join(" ")}}class V extends a{constructor(){super(ke.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(308,null)})}compute(X,Pe,Ke){return Ke&&X.emptySelectionClipboard}}class F extends v{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(ke.find,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:c.localize(309,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[c.localize(310,null),c.localize(311,null),c.localize(312,null)],description:c.localize(313,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[c.localize(314,null),c.localize(315,null),c.localize(316,null)],description:c.localize(317,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:c.localize(318,null),included:D.$m},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:c.localize(319,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:c.localize(320,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{cursorMoveOnType:i(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":g(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":g(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Pe.loop,this.defaultValue.loop)}}}class j extends v{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(ke.fontLigatures,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:c.localize(321,null)},{type:"string",description:c.localize(322,null)}],description:c.localize(323,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?j.OFF:X==="true"?j.ON:X:X?j.ON:j.OFF}}e.EditorFontLigatures=j;class W extends v{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(ke.fontVariations,"fontVariations",W.OFF,{anyOf:[{type:"boolean",description:c.localize(324,null)},{type:"string",description:c.localize(325,null)}],description:c.localize(326,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?W.OFF:X==="true"?W.TRANSLATE:X:X?W.TRANSLATE:W.OFF}compute(X,Pe,Ke){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=W;class J extends ${constructor(){super(ke.fontInfo)}compute(X,Pe,Ke){return X.fontInfo}}class B extends d{constructor(){super(ke.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(327,null)})}validate(X){const Pe=u.float(X,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(Pe,6,100)}compute(X,Pe,Ke){return X.fontInfo.fontSize}}class U extends v{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(ke.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.d,maximum:U.e,errorMessage:c.localize(328,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(329,null)})}validate(X){return X==="normal"||X==="bold"?X:String(r.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,U.d,U.e))}}class _ extends v{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[c.localize(330,null),c.localize(331,null),c.localize(332,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(ke.gotoLocation,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(333,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(334,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(335,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:c.localize(336,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:c.localize(337,null),...Pe},"editor.gotoLocation.multipleReferences":{description:c.localize(338,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ke,description:c.localize(339,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ke,description:c.localize(340,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ke,description:c.localize(341,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ke,description:c.localize(342,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ke,description:c.localize(343,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{multiple:g(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??g(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??g(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??g(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??g(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??g(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:Pe.multipleTests??g(Pe.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:l.string(Pe.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class x extends v{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(ke.hover,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:c.localize(344,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:c.localize(345,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:c.localize(346,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:c.localize(347,null)},"editor.hover.above":{type:"boolean",default:X.above,description:c.localize(348,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{enabled:i(Pe.enabled,this.defaultValue.enabled),delay:r.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:i(Pe.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Pe.above,this.defaultValue.above)}}}var oe;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(oe||(e.RenderMinimap=oe={}));class te extends ${constructor(){super(ke.layoutInfo)}compute(X,Pe,Ke){return te.computeLayout(Pe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const Pe=X.height/X.lineHeight,Ke=Math.floor(X.paddingTop/X.lineHeight);let Xe=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Xe=Math.max(Xe,Pe-1));const st=(Ke+X.viewLineCount+Xe)/(X.pixelRatio*X.height),dt=Math.floor(X.viewLineCount/st);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Xe,desiredRatio:st,minimapLineCount:dt}}static c(X,Pe){const Ke=X.outerWidth,Xe=X.outerHeight,st=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:oe.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Xe};const dt=Pe.stableMinimapLayoutInput,gt=dt&&X.outerHeight===dt.outerHeight&&X.lineHeight===dt.lineHeight&&X.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&X.pixelRatio===dt.pixelRatio&&X.scrollBeyondLastLine===dt.scrollBeyondLastLine&&X.paddingTop===dt.paddingTop&&X.paddingBottom===dt.paddingBottom&&X.minimap.enabled===dt.minimap.enabled&&X.minimap.side===dt.minimap.side&&X.minimap.size===dt.minimap.size&&X.minimap.showSlider===dt.minimap.showSlider&&X.minimap.renderCharacters===dt.minimap.renderCharacters&&X.minimap.maxColumn===dt.minimap.maxColumn&&X.minimap.scale===dt.minimap.scale&&X.verticalScrollbarWidth===dt.verticalScrollbarWidth&&X.isViewportWrapping===dt.isViewportWrapping,kt=X.lineHeight,At=X.typicalHalfwidthCharacterWidth,Kt=X.scrollBeyondLastLine,ei=X.minimap.renderCharacters;let tt=st>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Tt=X.minimap.maxColumn,zt=X.minimap.size,wt=X.minimap.side,Rt=X.verticalScrollbarWidth,ti=X.viewLineCount,ii=X.remainingWidth,Qt=X.isViewportWrapping,vt=ei?2:3;let Lt=Math.floor(st*Xe);const ci=Lt/st;let Zt=!1,et=!1,ni=vt*tt,li=tt/st,hi=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:Jt,extraLinesBeyondLastLine:Xt,desiredRatio:ui,minimapLineCount:Mt}=te.computeContainedMinimapLineCount({viewLineCount:ti,scrollBeyondLastLine:Kt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Xe,lineHeight:kt,pixelRatio:st});if(ti/Mt>1)Zt=!0,et=!0,tt=1,ni=1,li=tt/st;else{let yt=!1,Yt=tt+1;if(zt==="fit"){const St=Math.ceil((Jt+ti+Xt)*ni);Qt&&gt&&ii<=Pe.stableFitRemainingWidth?(yt=!0,Yt=Pe.stableFitMaxMinimapScale):yt=St>Lt}if(zt==="fill"||yt){Zt=!0;const St=tt;ni=Math.min(kt*st,Math.max(1,Math.floor(1/ui))),Qt&&gt&&ii<=Pe.stableFitRemainingWidth&&(Yt=Pe.stableFitMaxMinimapScale),tt=Math.min(Yt,Math.max(1,Math.floor(ni/vt))),tt>St&&(hi=Math.min(2,tt/St)),li=tt/st/hi,Lt=Math.ceil(Math.max(si,Jt+ti+Xt)*ni),Qt?(Pe.stableMinimapLayoutInput=X,Pe.stableFitRemainingWidth=ii,Pe.stableFitMaxMinimapScale=tt):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const It=Math.floor(Tt*li),Ut=Math.min(It,Math.max(0,Math.floor((ii-Rt-2)*li/(At+li)))+e.MINIMAP_GUTTER_WIDTH);let Nt=Math.floor(st*Ut);const Bt=Nt/st;Nt=Math.floor(Nt*hi);const ai=ei?oe.Text:oe.Blocks,ri=wt==="left"?0:Ke-Ut-Rt;return{renderMinimap:ai,minimapLeft:ri,minimapWidth:Ut,minimapHeightIsEditorHeight:Zt,minimapIsSampling:et,minimapScale:tt,minimapLineHeight:ni,minimapCanvasInnerWidth:Nt,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:ci}}static computeLayout(X,Pe){const Ke=Pe.outerWidth|0,Xe=Pe.outerHeight|0,st=Pe.lineHeight|0,dt=Pe.lineNumbersDigitCount|0,gt=Pe.typicalHalfwidthCharacterWidth,kt=Pe.maxDigitWidth,At=Pe.pixelRatio,Kt=Pe.viewLineCount,ei=X.get(ke.wordWrapOverride2),tt=ei==="inherit"?X.get(ke.wordWrapOverride1):ei,Tt=tt==="inherit"?X.get(ke.wordWrap):tt,zt=X.get(ke.wordWrapColumn),wt=Pe.isDominatedByLongLines,Rt=X.get(ke.glyphMargin),ti=X.get(ke.lineNumbers).renderType!==xe.Off,ii=X.get(ke.lineNumbersMinChars),Qt=X.get(ke.scrollBeyondLastLine),vt=X.get(ke.padding),Lt=X.get(ke.minimap),ci=X.get(ke.scrollbar),Zt=ci.verticalScrollbarSize,et=ci.verticalHasArrows,ni=ci.arrowSize,li=ci.horizontalScrollbarSize,hi=X.get(ke.folding),It=X.get(ke.showFoldingControls)!=="never";let Ut=X.get(ke.lineDecorationsWidth);hi&&It&&(Ut+=16);let Nt=0;if(ti){const xt=Math.max(dt,ii);Nt=Math.round(xt*kt)}let Bt=0;Rt&&(Bt=st*Pe.glyphMarginDecorationLaneCount);let ai=0,ri=ai+Bt,si=ri+Nt,Jt=si+Ut;const Xt=Ke-Bt-Nt-Ut;let ui=!1,Mt=!1,Ct=-1;tt==="inherit"&&wt?(ui=!0,Mt=!0):Tt==="on"||Tt==="bounded"?Mt=!0:Tt==="wordWrapColumn"&&(Ct=zt);const yt=te.c({outerWidth:Ke,outerHeight:Xe,lineHeight:st,typicalHalfwidthCharacterWidth:gt,pixelRatio:At,scrollBeyondLastLine:Qt,paddingTop:vt.top,paddingBottom:vt.bottom,minimap:Lt,verticalScrollbarWidth:Zt,viewLineCount:Kt,remainingWidth:Xt,isViewportWrapping:Mt},Pe.memory||new P);yt.renderMinimap!==oe.None&&yt.minimapLeft===0&&(ai+=yt.minimapWidth,ri+=yt.minimapWidth,si+=yt.minimapWidth,Jt+=yt.minimapWidth);const Yt=Xt-yt.minimapWidth,St=Math.max(1,Math.floor((Yt-Zt-2)/gt)),oi=et?ni:0;return Mt&&(Ct=Math.max(1,St),Tt==="bounded"&&(Ct=Math.min(Ct,zt))),{width:Ke,height:Xe,glyphMarginLeft:ai,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:ri,lineNumbersWidth:Nt,decorationsLeft:si,decorationsWidth:Ut,contentLeft:Jt,contentWidth:Yt,minimap:yt,viewportColumn:St,isWordWrapMinified:ui,isViewportWrapping:Mt,wrappingColumn:Ct,verticalScrollbarWidth:Zt,horizontalScrollbarHeight:li,overviewRuler:{top:oi,width:Zt,height:Xe-2*oi,right:0}}}}e.EditorLayoutInfoComputer=te;class me extends v{constructor(){super(ke.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(349,null),c.localize(350,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(351,null)}})}validate(X){return g(X,"simple",["simple","advanced"])}compute(X,Pe,Ke){return Pe.get(ke.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Ke}}var ce;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(ce||(e.ShowLightbulbIconMode=ce={}));class Y extends v{constructor(){const X={enabled:ce.OnCode};super(ke.lightbulb,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ce.Off,ce.OnCode,ce.On],default:X.enabled,enumDescriptions:[c.localize(352,null),c.localize(353,null),c.localize(354,null)],description:c.localize(355,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:g(X.enabled,this.defaultValue.enabled,[ce.Off,ce.OnCode,ce.On])}}}class q extends v{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(ke.stickyScroll,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:c.localize(356,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:c.localize(357,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:c.localize(358,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:c.localize(359,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{enabled:i(Pe.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends v{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(ke.inlayHints,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:c.localize(360,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(361,null),c.localize(362,null,D.$m?"Ctrl+Option":"Ctrl+Alt"),c.localize(363,null,D.$m?"Ctrl+Option":"Ctrl+Alt"),c.localize(364,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:c.localize(365,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:c.localize(366,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:c.localize(367,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:g(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:i(Pe.padding,this.defaultValue.padding)}}}class be extends v{constructor(){super(ke.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):r.clampedInt(X,this.defaultValue,0,1e3)}compute(X,Pe,Ke){return Ke<0?r.clampedInt(-Ke*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class ae extends u{constructor(){super(ke.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>u.clamp(X,0,150),{markdownDescription:c.localize(368,null)})}compute(X,Pe,Ke){return X.fontInfo.lineHeight}}class we extends v{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(ke.minimap,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:c.localize(369,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:c.localize(370,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(371,null),c.localize(372,null),c.localize(373,null)],default:X.size,description:c.localize(374,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:c.localize(375,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:c.localize(376,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(377,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:c.localize(378,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:c.localize(379,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:c.localize(380,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:c.localize(381,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:c.localize(382,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:X.sectionHeaderLetterSpacing,description:c.localize(383,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{enabled:i(Pe.enabled,this.defaultValue.enabled),autohide:i(Pe.autohide,this.defaultValue.autohide),size:g(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(Pe.side,this.defaultValue.side,["right","left"]),showSlider:g(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(Pe.scale,1,1,3),maxColumn:r.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Pe.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Pe.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:u.clamp(Pe.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:u.clamp(Pe.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function $e(ne){return ne==="ctrlCmd"?D.$m?"metaKey":"ctrlKey":"altKey"}class pe extends v{constructor(){super(ke.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(384,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(385,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{top:r.clampedInt(Pe.top,0,0,1e3),bottom:r.clampedInt(Pe.bottom,0,0,1e3)}}}class Oe extends v{constructor(){const X={enabled:!0,cycle:!0};super(ke.parameterHints,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:c.localize(386,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:c.localize(387,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{enabled:i(Pe.enabled,this.defaultValue.enabled),cycle:i(Pe.cycle,this.defaultValue.cycle)}}}class Fe extends ${constructor(){super(ke.pixelRatio)}compute(X,Pe,Ke){return X.pixelRatio}}class He extends v{constructor(){super(ke.placeholder,"placeholder",void 0)}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X:this.defaultValue}}class Ze extends v{constructor(){const X={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(388,null),c.localize(389,null),c.localize(390,null)]}];super(ke.quickSuggestions,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:X.strings,description:c.localize(391,null)},comments:{anyOf:Pe,default:X.comments,description:c.localize(392,null)},other:{anyOf:Pe,default:X.other,description:c.localize(393,null)}},default:X,markdownDescription:c.localize(394,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const At=X?"on":"off";return{comments:At,strings:At,other:At}}if(!X||typeof X!="object")return this.defaultValue;const{other:Pe,comments:Ke,strings:Xe}=X,st=["on","inline","off"];let dt,gt,kt;return typeof Pe=="boolean"?dt=Pe?"on":"off":dt=g(Pe,this.defaultValue.other,st),typeof Ke=="boolean"?gt=Ke?"on":"off":gt=g(Ke,this.defaultValue.comments,st),typeof Xe=="boolean"?kt=Xe?"on":"off":kt=g(Xe,this.defaultValue.strings,st),{other:dt,comments:gt,strings:kt}}}var xe;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(xe||(e.RenderLineNumbersType=xe={}));class je extends v{constructor(){super(ke.lineNumbers,"lineNumbers",{renderType:xe.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(395,null),c.localize(396,null),c.localize(397,null),c.localize(398,null)],default:"on",description:c.localize(399,null)})}validate(X){let Pe=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(Pe=xe.Custom,Ke=X):X==="interval"?Pe=xe.Interval:X==="relative"?Pe=xe.Relative:X==="on"?Pe=xe.On:Pe=xe.Off),{renderType:Pe,renderFn:Ke}}}function qe(ne){const X=ne.get(ke.renderValidationDecorations);return X==="editable"?ne.get(ke.readOnly):X!=="on"}class Ne extends v{constructor(){const X=[],Pe={type:"number",description:c.localize(400,null)};super(ke.rulers,"rulers",X,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:c.localize(401,null),format:"color-hex"}}}]},default:X,description:c.localize(402,null)})}validate(X){if(Array.isArray(X)){const Pe=[];for(const Ke of X)if(typeof Ke=="number")Pe.push({column:r.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Xe=Ke;Pe.push({column:r.clampedInt(Xe.column,0,0,1e4),color:Xe.color})}return Pe.sort((Ke,Xe)=>Ke.column-Xe.column),Pe}return this.defaultValue}}class H extends v{constructor(){super(ke.readOnlyMessage,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function G(ne,X){if(typeof ne!="string")return X;switch(ne){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class Z extends v{constructor(){const X={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(ke.scrollbar,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(403,null),c.localize(404,null),c.localize(405,null)],default:"auto",description:c.localize(406,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(407,null),c.localize(408,null),c.localize(409,null)],default:"auto",description:c.localize(410,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:c.localize(411,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:c.localize(412,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:c.localize(413,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:c.localize(414,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X,Ke=r.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Xe=r.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:G(Pe.vertical,this.defaultValue.vertical),horizontal:G(Pe.horizontal,this.defaultValue.horizontal),useShadows:i(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:r.clampedInt(Pe.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Xe,verticalSliderSize:r.clampedInt(Pe.verticalSliderSize,Xe,0,1e3),scrollByPage:i(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ee extends v{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(ke.unicodeHighlighting,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:c.localize(415,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:c.localize(416,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:c.localize(417,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:c.localize(418,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:c.localize(419,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:c.localize(420,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:c.localize(421,null)}})}applyUpdate(X,Pe){let Ke=!1;Pe.allowedCharacters&&X&&(h.$qo(X.allowedCharacters,Pe.allowedCharacters)||(X={...X,allowedCharacters:Pe.allowedCharacters},Ke=!0)),Pe.allowedLocales&&X&&(h.$qo(X.allowedLocales,Pe.allowedLocales)||(X={...X,allowedLocales:Pe.allowedLocales},Ke=!0));const Xe=super.applyUpdate(X,Pe);return Ke?new o(Xe.newValue,!0):Xe}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{nonBasicASCII:Je(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Je(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Je(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,Pe){if(typeof X!="object"||!X)return Pe;const Ke={};for(const[Xe,st]of Object.entries(X))st===!0&&(Ke[Xe]=!0);return Ke}}class ue extends v{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(ke.inlineSuggest,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:c.localize(422,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(423,null),c.localize(424,null),c.localize(425,null)],description:c.localize(426,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:c.localize(427,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:c.localize(428,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{enabled:i(Pe.enabled,this.defaultValue.enabled),mode:g(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(Pe.fontFamily,this.defaultValue.fontFamily)}}}class ye extends v{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(ke.inlineEdit,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:c.localize(429,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(430,null),c.localize(431,null),c.localize(432,null)],description:c.localize(433,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:c.localize(434,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{enabled:i(Pe.enabled,this.defaultValue.enabled),showToolbar:g(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(Pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ae extends v{constructor(){const X={enabled:A.$vt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$vt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(ke.bracketPairColorization,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:c.localize(435,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:c.localize(436,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{enabled:i(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ve extends v{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(ke.guides,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(437,null),c.localize(438,null),c.localize(439,null)],default:X.bracketPairs,description:c.localize(440,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(441,null),c.localize(442,null),c.localize(443,null)],default:X.bracketPairsHorizontal,description:c.localize(444,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:c.localize(445,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:c.localize(446,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(447,null),c.localize(448,null),c.localize(449,null)],default:X.highlightActiveIndentation,description:c.localize(450,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{bracketPairs:Je(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Je(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Je(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Je(ne,X,Pe){const Ke=Pe.indexOf(ne);return Ke===-1?X:Pe[Ke]}class nt extends v{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(ke.suggest,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(451,null),c.localize(452,null)],default:X.insertMode,description:c.localize(453,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:c.localize(454,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:c.localize(455,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:c.localize(456,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(457,null),c.localize(458,null),c.localize(459,null),c.localize(460,null)],default:X.selectionMode,markdownDescription:c.localize(461,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:c.localize(462,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:c.localize(463,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:c.localize(464,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:c.localize(465,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:c.localize(466,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(467,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(468,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(469,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(470,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(471,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(472,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(473,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(474,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(475,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(476,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(477,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(478,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(479,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(480,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(481,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(482,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(483,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(484,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(485,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(486,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(487,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(488,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(489,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(490,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(491,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(492,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(493,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(494,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(495,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(496,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(497,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(498,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{insertMode:g(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:i(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:i(Pe.preview,this.defaultValue.preview),previewMode:g(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Pe.showMethods,this.defaultValue.showMethods),showFunctions:i(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Pe.showFields,this.defaultValue.showFields),showVariables:i(Pe.showVariables,this.defaultValue.showVariables),showClasses:i(Pe.showClasses,this.defaultValue.showClasses),showStructs:i(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:i(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Pe.showModules,this.defaultValue.showModules),showProperties:i(Pe.showProperties,this.defaultValue.showProperties),showEvents:i(Pe.showEvents,this.defaultValue.showEvents),showOperators:i(Pe.showOperators,this.defaultValue.showOperators),showUnits:i(Pe.showUnits,this.defaultValue.showUnits),showValues:i(Pe.showValues,this.defaultValue.showValues),showConstants:i(Pe.showConstants,this.defaultValue.showConstants),showEnums:i(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Pe.showKeywords,this.defaultValue.showKeywords),showWords:i(Pe.showWords,this.defaultValue.showWords),showColors:i(Pe.showColors,this.defaultValue.showColors),showFiles:i(Pe.showFiles,this.defaultValue.showFiles),showReferences:i(Pe.showReferences,this.defaultValue.showReferences),showFolders:i(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:i(Pe.showUsers,this.defaultValue.showUsers),showIssues:i(Pe.showIssues,this.defaultValue.showIssues)}}}class ot extends v{constructor(){super(ke.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(499,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(500,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(X.selectSubwords,this.defaultValue.selectSubwords)}}}class ht extends v{constructor(){const X=[];super(ke.wordSegmenterLocales,"wordSegmenterLocales",X,{anyOf:[{description:c.localize(501,null),type:"string"},{description:c.localize(502,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const Pe=[];for(const Ke of X)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&Pe.push(Ke)}catch{}return Pe}return this.defaultValue}}var at;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(at||(e.WrappingIndent=at={}));class lt extends v{constructor(){super(ke.wrappingIndent,"wrappingIndent",at.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(503,null),c.localize(504,null),c.localize(505,null),c.localize(506,null)],description:c.localize(507,null),default:"same"}})}validate(X){switch(X){case"none":return at.None;case"same":return at.Same;case"indent":return at.Indent;case"deepIndent":return at.DeepIndent}return at.Same}compute(X,Pe,Ke){return Pe.get(ke.accessibilitySupport)===I.AccessibilitySupport.Enabled?at.None:Ke}}class pt extends ${constructor(){super(ke.wrappingInfo)}compute(X,Pe,Ke){const Xe=Pe.get(ke.layoutInfo);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Xe.isWordWrapMinified,isViewportWrapping:Xe.isViewportWrapping,wrappingColumn:Xe.wrappingColumn}}}class it extends v{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(ke.dropIntoEditor,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:c.localize(508,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(509,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(510,null),c.localize(511,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{enabled:i(Pe.enabled,this.defaultValue.enabled),showDropSelector:g(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ie extends v{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(ke.pasteAs,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:c.localize(512,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(513,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(514,null),c.localize(515,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Pe=X;return{enabled:i(Pe.enabled,this.defaultValue.enabled),showPasteSelector:g(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const re="Consolas, 'Courier New', monospace",le="Menlo, Monaco, 'Courier New', monospace",Se="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:D.$m?le:D.$n?Se:re,fontWeight:"normal",fontSize:D.$m?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function de(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var ke;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.inlineEdit=63]="inlineEdit",ne[ne.letterSpacing=64]="letterSpacing",ne[ne.lightbulb=65]="lightbulb",ne[ne.lineDecorationsWidth=66]="lineDecorationsWidth",ne[ne.lineHeight=67]="lineHeight",ne[ne.lineNumbers=68]="lineNumbers",ne[ne.lineNumbersMinChars=69]="lineNumbersMinChars",ne[ne.linkedEditing=70]="linkedEditing",ne[ne.links=71]="links",ne[ne.matchBrackets=72]="matchBrackets",ne[ne.minimap=73]="minimap",ne[ne.mouseStyle=74]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=76]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=78]="multiCursorModifier",ne[ne.multiCursorPaste=79]="multiCursorPaste",ne[ne.multiCursorLimit=80]="multiCursorLimit",ne[ne.occurrencesHighlight=81]="occurrencesHighlight",ne[ne.overviewRulerBorder=82]="overviewRulerBorder",ne[ne.overviewRulerLanes=83]="overviewRulerLanes",ne[ne.padding=84]="padding",ne[ne.pasteAs=85]="pasteAs",ne[ne.parameterHints=86]="parameterHints",ne[ne.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ne[ne.placeholder=88]="placeholder",ne[ne.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=90]="quickSuggestions",ne[ne.quickSuggestionsDelay=91]="quickSuggestionsDelay",ne[ne.readOnly=92]="readOnly",ne[ne.readOnlyMessage=93]="readOnlyMessage",ne[ne.renameOnType=94]="renameOnType",ne[ne.renderControlCharacters=95]="renderControlCharacters",ne[ne.renderFinalNewline=96]="renderFinalNewline",ne[ne.renderLineHighlight=97]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=99]="renderValidationDecorations",ne[ne.renderWhitespace=100]="renderWhitespace",ne[ne.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ne[ne.roundedSelection=102]="roundedSelection",ne[ne.rulers=103]="rulers",ne[ne.scrollbar=104]="scrollbar",ne[ne.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=106]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=107]="scrollPredominantAxis",ne[ne.selectionClipboard=108]="selectionClipboard",ne[ne.selectionHighlight=109]="selectionHighlight",ne[ne.selectOnLineNumbers=110]="selectOnLineNumbers",ne[ne.showFoldingControls=111]="showFoldingControls",ne[ne.showUnused=112]="showUnused",ne[ne.snippetSuggestions=113]="snippetSuggestions",ne[ne.smartSelect=114]="smartSelect",ne[ne.smoothScrolling=115]="smoothScrolling",ne[ne.stickyScroll=116]="stickyScroll",ne[ne.stickyTabStops=117]="stickyTabStops",ne[ne.stopRenderingLineAfter=118]="stopRenderingLineAfter",ne[ne.suggest=119]="suggest",ne[ne.suggestFontSize=120]="suggestFontSize",ne[ne.suggestLineHeight=121]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ne[ne.suggestSelection=123]="suggestSelection",ne[ne.tabCompletion=124]="tabCompletion",ne[ne.tabIndex=125]="tabIndex",ne[ne.unicodeHighlighting=126]="unicodeHighlighting",ne[ne.unusualLineTerminators=127]="unusualLineTerminators",ne[ne.useShadowDOM=128]="useShadowDOM",ne[ne.useTabStops=129]="useTabStops",ne[ne.wordBreak=130]="wordBreak",ne[ne.wordSegmenterLocales=131]="wordSegmenterLocales",ne[ne.wordSeparators=132]="wordSeparators",ne[ne.wordWrap=133]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=136]="wordWrapColumn",ne[ne.wordWrapOverride1=137]="wordWrapOverride1",ne[ne.wordWrapOverride2=138]="wordWrapOverride2",ne[ne.wrappingIndent=139]="wrappingIndent",ne[ne.wrappingStrategy=140]="wrappingStrategy",ne[ne.showDeprecated=141]="showDeprecated",ne[ne.inlayHints=142]="inlayHints",ne[ne.editorClassName=143]="editorClassName",ne[ne.pixelRatio=144]="pixelRatio",ne[ne.tabFocusMode=145]="tabFocusMode",ne[ne.layoutInfo=146]="layoutInfo",ne[ne.wrappingInfo=147]="wrappingInfo",ne[ne.defaultColorDecorators=148]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(ke||(e.EditorOption=ke={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:de(new a(ke.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(516,null)})),acceptSuggestionOnEnter:de(new y(ke.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(517,null),""],markdownDescription:c.localize(518,null)})),accessibilitySupport:de(new R),accessibilityPageSize:de(new r(ke.accessibilityPageSize,"accessibilityPageSize",10,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(519,null),tags:["accessibility"]})),ariaLabel:de(new l(ke.ariaLabel,"ariaLabel",c.localize(520,null))),ariaRequired:de(new a(ke.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:de(new a(ke.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(521,null),tags:["accessibility"]})),autoClosingBrackets:de(new y(ke.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(522,null),c.localize(523,null),""],description:c.localize(524,null)})),autoClosingComments:de(new y(ke.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(525,null),c.localize(526,null),""],description:c.localize(527,null)})),autoClosingDelete:de(new y(ke.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(528,null),""],description:c.localize(529,null)})),autoClosingOvertype:de(new y(ke.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(530,null),""],description:c.localize(531,null)})),autoClosingQuotes:de(new y(ke.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(532,null),c.localize(533,null),""],description:c.localize(534,null)})),autoIndent:de(new k(ke.autoIndent,"autoIndent",E.Full,"full",["none","keep","brackets","advanced","full"],S,{enumDescriptions:[c.localize(535,null),c.localize(536,null),c.localize(537,null),c.localize(538,null),c.localize(539,null)],description:c.localize(540,null)})),automaticLayout:de(new a(ke.automaticLayout,"automaticLayout",!1)),autoSurround:de(new y(ke.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(541,null),c.localize(542,null),c.localize(543,null),""],description:c.localize(544,null)})),bracketPairColorization:de(new Ae),bracketPairGuides:de(new Ve),stickyTabStops:de(new a(ke.stickyTabStops,"stickyTabStops",!1,{description:c.localize(545,null)})),codeLens:de(new a(ke.codeLens,"codeLens",!0,{description:c.localize(546,null)})),codeLensFontFamily:de(new l(ke.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(547,null)})),codeLensFontSize:de(new r(ke.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(548,null)})),colorDecorators:de(new a(ke.colorDecorators,"colorDecorators",!0,{description:c.localize(549,null)})),colorDecoratorActivatedOn:de(new y(ke.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(550,null),c.localize(551,null),c.localize(552,null)],description:c.localize(553,null)})),colorDecoratorsLimit:de(new r(ke.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(554,null)})),columnSelection:de(new a(ke.columnSelection,"columnSelection",!1,{description:c.localize(555,null)})),comments:de(new C),contextmenu:de(new a(ke.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:de(new a(ke.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(556,null)})),cursorBlinking:de(new k(ke.cursorBlinking,"cursorBlinking",w.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:c.localize(557,null)})),cursorSmoothCaretAnimation:de(new y(ke.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(558,null),c.localize(559,null),c.localize(560,null)],description:c.localize(561,null)})),cursorStyle:de(new k(ke.cursorStyle,"cursorStyle",N.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:c.localize(562,null)})),cursorSurroundingLines:de(new r(ke.cursorSurroundingLines,"cursorSurroundingLines",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(563,null)})),cursorSurroundingLinesStyle:de(new y(ke.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(564,null),c.localize(565,null)],markdownDescription:c.localize(566,null)})),cursorWidth:de(new r(ke.cursorWidth,"cursorWidth",0,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(567,null)})),disableLayerHinting:de(new a(ke.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:de(new a(ke.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:de(new a(ke.domReadOnly,"domReadOnly",!1)),dragAndDrop:de(new a(ke.dragAndDrop,"dragAndDrop",!0,{description:c.localize(568,null)})),emptySelectionClipboard:de(new V),dropIntoEditor:de(new it),stickyScroll:de(new q),experimentalWhitespaceRendering:de(new y(ke.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(569,null),c.localize(570,null),c.localize(571,null)],description:c.localize(572,null)})),extraEditorClassName:de(new l(ke.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:de(new u(ke.fastScrollSensitivity,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:c.localize(573,null)})),find:de(new F),fixedOverflowWidgets:de(new a(ke.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:de(new a(ke.folding,"folding",!0,{description:c.localize(574,null)})),foldingStrategy:de(new y(ke.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(575,null),c.localize(576,null)],description:c.localize(577,null)})),foldingHighlight:de(new a(ke.foldingHighlight,"foldingHighlight",!0,{description:c.localize(578,null)})),foldingImportsByDefault:de(new a(ke.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(579,null)})),foldingMaximumRegions:de(new r(ke.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(580,null)})),unfoldOnClickAfterEndOfLine:de(new a(ke.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(581,null)})),fontFamily:de(new l(ke.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(582,null)})),fontInfo:de(new J),fontLigatures2:de(new j),fontSize:de(new B),fontWeight:de(new U),fontVariations:de(new W),formatOnPaste:de(new a(ke.formatOnPaste,"formatOnPaste",!1,{description:c.localize(583,null)})),formatOnType:de(new a(ke.formatOnType,"formatOnType",!1,{description:c.localize(584,null)})),glyphMargin:de(new a(ke.glyphMargin,"glyphMargin",!0,{description:c.localize(585,null)})),gotoLocation:de(new _),hideCursorInOverviewRuler:de(new a(ke.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(586,null)})),hover:de(new x),inDiffEditor:de(new a(ke.inDiffEditor,"inDiffEditor",!1)),letterSpacing:de(new u(ke.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>u.clamp(ne,-5,20),{description:c.localize(587,null)})),lightbulb:de(new Y),lineDecorationsWidth:de(new be),lineHeight:de(new ae),lineNumbers:de(new je),lineNumbersMinChars:de(new r(ke.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:de(new a(ke.linkedEditing,"linkedEditing",!1,{description:c.localize(588,null)})),links:de(new a(ke.links,"links",!0,{description:c.localize(589,null)})),matchBrackets:de(new y(ke.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(590,null)})),minimap:de(new we),mouseStyle:de(new y(ke.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:de(new u(ke.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:c.localize(591,null)})),mouseWheelZoom:de(new a(ke.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:D.$m?c.localize(592,null):c.localize(593,null)})),multiCursorMergeOverlapping:de(new a(ke.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(594,null)})),multiCursorModifier:de(new k(ke.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$e,{markdownEnumDescriptions:[c.localize(595,null),c.localize(596,null)],markdownDescription:c.localize(597,null)})),multiCursorPaste:de(new y(ke.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(598,null),c.localize(599,null)],markdownDescription:c.localize(600,null)})),multiCursorLimit:de(new r(ke.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(601,null)})),occurrencesHighlight:de(new y(ke.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(602,null),c.localize(603,null),c.localize(604,null)],markdownDescription:c.localize(605,null)})),overviewRulerBorder:de(new a(ke.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(606,null)})),overviewRulerLanes:de(new r(ke.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:de(new pe),pasteAs:de(new Ie),parameterHints:de(new Oe),peekWidgetDefaultFocus:de(new y(ke.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(607,null),c.localize(608,null)],description:c.localize(609,null)})),placeholder:de(new He),definitionLinkOpensInPeek:de(new a(ke.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(610,null)})),quickSuggestions:de(new Ze),quickSuggestionsDelay:de(new r(ke.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(611,null)})),readOnly:de(new a(ke.readOnly,"readOnly",!1)),readOnlyMessage:de(new H),renameOnType:de(new a(ke.renameOnType,"renameOnType",!1,{description:c.localize(612,null),markdownDeprecationMessage:c.localize(613,null)})),renderControlCharacters:de(new a(ke.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(614,null),restricted:!0})),renderFinalNewline:de(new y(ke.renderFinalNewline,"renderFinalNewline",D.$n?"dimmed":"on",["off","on","dimmed"],{description:c.localize(615,null)})),renderLineHighlight:de(new y(ke.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(616,null)],description:c.localize(617,null)})),renderLineHighlightOnlyWhenFocus:de(new a(ke.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(618,null)})),renderValidationDecorations:de(new y(ke.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:de(new y(ke.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(619,null),c.localize(620,null),c.localize(621,null),""],description:c.localize(622,null)})),revealHorizontalRightPadding:de(new r(ke.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:de(new a(ke.roundedSelection,"roundedSelection",!0,{description:c.localize(623,null)})),rulers:de(new Ne),scrollbar:de(new Z),scrollBeyondLastColumn:de(new r(ke.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,T.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(624,null)})),scrollBeyondLastLine:de(new a(ke.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(625,null)})),scrollPredominantAxis:de(new a(ke.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(626,null)})),selectionClipboard:de(new a(ke.selectionClipboard,"selectionClipboard",!0,{description:c.localize(627,null),included:D.$n})),selectionHighlight:de(new a(ke.selectionHighlight,"selectionHighlight",!0,{description:c.localize(628,null)})),selectOnLineNumbers:de(new a(ke.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:de(new y(ke.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(629,null),c.localize(630,null),c.localize(631,null)],description:c.localize(632,null)})),showUnused:de(new a(ke.showUnused,"showUnused",!0,{description:c.localize(633,null)})),showDeprecated:de(new a(ke.showDeprecated,"showDeprecated",!0,{description:c.localize(634,null)})),inlayHints:de(new se),snippetSuggestions:de(new y(ke.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(635,null),c.localize(636,null),c.localize(637,null),c.localize(638,null)],description:c.localize(639,null)})),smartSelect:de(new ot),smoothScrolling:de(new a(ke.smoothScrolling,"smoothScrolling",!1,{description:c.localize(640,null)})),stopRenderingLineAfter:de(new r(ke.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:de(new nt),inlineSuggest:de(new ue),inlineEdit:de(new ye),inlineCompletionsAccessibilityVerbose:de(new a(ke.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(641,null)})),suggestFontSize:de(new r(ke.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(642,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:de(new r(ke.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(643,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:de(new a(ke.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(644,null)})),suggestSelection:de(new y(ke.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(645,null),c.localize(646,null),c.localize(647,null)],description:c.localize(648,null)})),tabCompletion:de(new y(ke.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(649,null),c.localize(650,null),c.localize(651,null)],description:c.localize(652,null)})),tabIndex:de(new r(ke.tabIndex,"tabIndex",0,-1,T.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:de(new ee),unusualLineTerminators:de(new y(ke.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(653,null),c.localize(654,null),c.localize(655,null)],description:c.localize(656,null)})),useShadowDOM:de(new a(ke.useShadowDOM,"useShadowDOM",!0)),useTabStops:de(new a(ke.useTabStops,"useTabStops",!0,{description:c.localize(657,null)})),wordBreak:de(new y(ke.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(658,null),c.localize(659,null)],description:c.localize(660,null)})),wordSegmenterLocales:de(new ht),wordSeparators:de(new l(ke.wordSeparators,"wordSeparators",p.$wt,{description:c.localize(661,null)})),wordWrap:de(new y(ke.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(662,null),c.localize(663,null),c.localize(664,null),c.localize(665,null)],description:c.localize(666,null)})),wordWrapBreakAfterCharacters:de(new l(ke.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:de(new l(ke.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:de(new r(ke.wordWrapColumn,"wordWrapColumn",80,1,T.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(667,null)})),wordWrapOverride1:de(new y(ke.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:de(new y(ke.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:de(new z),defaultColorDecorators:de(new a(ke.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(668,null)})),pixelRatio:de(new Fe),tabFocusMode:de(new a(ke.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(669,null)})),layoutInfo:de(new te),wrappingInfo:de(new pt),wrappingIndent:de(new lt),wrappingStrategy:de(new me)}});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[220],Ce([1,0,22,45,7,5,109,10,24]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$kx=e.$jx=e.$ix=void 0,e.$lx=P,e.$mx=v,h=Ht(h),e.$ix=(0,O.$Ki)("dialogService");var c;(function(o){o[o.Confirmation=1]="Confirmation",o[o.Prompt=2]="Prompt",o[o.Input=3]="Input"})(c||(c={}));class I{a(m){return this.d(m,c.Confirmation)}b(m){return this.d(m,c.Prompt)}c(m){return this.d(m,c.Input)}d(m,$){const d=[];switch($){case c.Confirmation:{const i=m;i.primaryButton?d.push(i.primaryButton):d.push((0,D.localize)(1698,null)),i.cancelButton?d.push(i.cancelButton):d.push((0,D.localize)(1699,null));break}case c.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&d.push(...i.buttons.map(a=>a.label)),i.cancelButton&&(i.cancelButton===!0?d.push((0,D.localize)(1700,null)):typeof i.cancelButton=="string"?d.push(i.cancelButton):i.cancelButton.label?d.push(i.cancelButton.label):d.push((0,D.localize)(1701,null))),d.length===0&&d.push((0,D.localize)(1702,null));break}case c.Input:{const i=m;i.primaryButton?d.push(i.primaryButton):d.push((0,D.localize)(1703,null)),i.cancelButton?d.push(i.cancelButton):d.push((0,D.localize)(1704,null));break}}return d}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===h.default.Info?"info":m===h.default.Error?"error":m===h.default.Warning?"warning":"none"}f(m,$,d){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let a=i[$]?.run({checkboxChecked:d});return a instanceof Promise||(a=Promise.resolve(a)),{result:a,checkboxChecked:d}}}e.$jx=I,e.$kx=(0,O.$Ki)("fileDialogService");var E;(function(o){o[o.SAVE=0]="SAVE",o[o.DONT_SAVE=1]="DONT_SAVE",o[o.CANCEL=2]="CANCEL"})(E||(e.ConfirmResult=E={}));const f=10;function P(o){const m=[];return m.push(...o.slice(0,f).map($=>typeof $=="string"?$:(0,s.$ih)($))),o.length>f&&(o.length-f===1?m.push((0,D.localize)(1705,null)):m.push((0,D.localize)(1706,null,o.length-f))),m.push(""),m.join(`
`)}function v(o,m){const $=(0,p.$mo)(o);let d=($.buttons??[]).map(r=>(0,T.$fx)(r)),i=(o.buttons||[]).map((r,n)=>n),a=0,t=$.cancelId??d.length-1;if(d.length>1){const r=typeof t=="number"?d[t]:void 0;if(A.$n||A.$m){if(typeof r=="string"&&d.length>1&&t!==1){d.splice(t,1),d.splice(1,0,r);const n=i[t];i.splice(t,1),i.splice(1,0,n),t=1}A.$n&&d.length>1&&(d=d.reverse(),i=i.reverse(),a=d.length-1,typeof r=="string"&&(t=a-1))}else if(A.$l&&typeof r=="string"&&d.length>1&&t!==d.length-1){d.splice(t,1),d.push(r);const n=i[t];i.splice(t,1),i.push(n),t=d.length-1}}return $.buttons=d,$.defaultId=a,$.cancelId=t,$.noLink=!0,$.title=$.title||m.nameLong,{options:$,buttonIndeces:i}}}),define(Re[149],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=void 0,e.$Ri=(0,s.$Ki)("environmentService"),e.$Si=(0,s.$Li)(e.$Ri)}),define(Re[221],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=e.$k_b=void 0,e.$k_b=(0,s.$Ki)("externalTerminal"),e.$l_b="Terminal.app"}),define(Re[222],Ce([1,0,58,60,14,16,10,108,34,111,7,221]),function(ge,e,s,h,D,O,T,A,p,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=e.$bic=e.$aic=void 0,s=Ue(s),O=Ue(O),T=Ue(T),p=Ue(p),c=Ue(c),I=Ue(I);const f=I.localize(1852,null);class P{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends P{static{this.b="cmd.exe"}openTerminal(t,r){return this.spawnTerminal(s,t,c.$Dm(),r)}spawnTerminal(t,r,n,u){const l=r.windowsExec||v.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const g=O.$sc(l,".exe").toLowerCase();if(g==="cmder")return t.spawn(l,u?[u]:void 0),Promise.resolve(void 0);const y=["/c","start","/wait"];return l.indexOf(" ")>=0&&y.push(l),y.push(l),g==="wt"&&y.push("-d ."),new Promise((k,S)=>{const R=$(process),C=t.spawn(n,y,{cwd:u,env:R,detached:!0});C.on("error",S),C.on("exit",()=>k())})}async runInTerminal(t,r,n,u,l){const g="windowsExec"in l&&l.windowsExec?l.windowsExec:v.getDefaultTerminalWindows(),y=await v.f();return new Promise((k,S)=>{const R=`"${r} - ${f}"`,C=`"${n.join('" "')}" & pause`,w=Object.assign({},$(process),u);Object.keys(w).filter(z=>w[z]===null).forEach(z=>delete w[z]);const b={cwd:r,env:w,windowsVerbatimArguments:!0};let N,L;O.$sc(g,".exe")==="wt"?(N=g,L=["-d",".",v.b,"/c",C]):y?(N=y,L=["-d",".",g,"/c",C]):(N=v.b,L=["/c","start",R,"/wait",g,"/c",`"${C}"`]),s.spawn(N,L,b).on("error",z=>{S(d(z))}),k(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await p.Promises.exists(t)?t:void 0}catch{return}}}e.$aic=v,Ye([h.$ci],v,"f",null);class o extends P{static{this.b="/usr/bin/osascript"}openTerminal(t,r){return this.spawnTerminal(s,t,r)}runInTerminal(t,r,n,u,l){const g=l.osxExec||E.$l_b;return new Promise((y,k)=>{if(g===E.$l_b||g==="iTerm.app"){const S=g===E.$l_b?"TerminalHelper":"iTermHelper",C=[D.$5g.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",t||f,"-w",r];for(const N of n)C.push("-a"),C.push(N);if(u){const N=Object.assign({},$(process),u);for(const L in N){const M=N[L];M===null?(C.push("-u"),C.push(L)):(C.push("-e"),C.push(`${L}=${M}`))}}let w="";const b=s.spawn(o.b,C);b.on("error",N=>{k(d(N))}),b.stderr.on("data",N=>{w+=N.toString()}),b.on("exit",N=>{if(N===0)y(void 0);else if(w){const L=w.split(`
`,1);k(new Error(L[0]))}else k(new Error(I.localize(1853,null,S,N)))})}else k(new Error(I.localize(1854,null,g)))})}spawnTerminal(t,r,n){const u=r.osxExec||E.$l_b;return new Promise((l,g)=>{const y=["-a",u];n&&y.push(n);const k=$(process),S=t.spawn("/usr/bin/open",y,{cwd:n,env:k});S.on("error",g),S.on("exit",()=>l())})}}e.$bic=o;class m extends P{static{this.b=I.localize(1855,null)}openTerminal(t,r){return this.spawnTerminal(s,t,r)}runInTerminal(t,r,n,u,l){const g=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((y,k)=>{const S=[];g.then(R=>{R.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const C=`${i(n)}; echo; read -p "${m.b}" -n1;`;S.push(`''${C}''`);const w=Object.assign({},$(process),u);Object.keys(w).filter(M=>w[M]===null).forEach(M=>delete w[M]);const b={cwd:r,env:w};let N="";const L=s.spawn(R,S,b);L.on("error",M=>{k(d(M))}),L.stderr.on("data",M=>{N+=M.toString()}),L.on("exit",M=>{if(M===0)y(void 0);else if(N){const z=N.split(`
`,1);k(new Error(z[0]))}else k(new Error(I.localize(1856,null,R,M)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!T.$n)m.d=Promise.resolve("xterm");else{const t=await p.Promises.exists("/etc/debian_version");m.d=new Promise(r=>{t?r("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?r("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?r("konsole"):process.env.COLORTERM?r(process.env.COLORTERM):process.env.TERM?r(process.env.TERM):r("xterm")})}return m.d}spawnTerminal(t,r,n){const u=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,g)=>{u.then(y=>{const k=$(process),S=t.spawn(y,[],{cwd:n,env:k});S.on("error",g),S.on("exit",()=>l())})})}}e.$cic=m;function $(a){const t={...a.env};return(0,A.$qm)(t),t}function d(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(I.localize(1857,null,a.path)):a}function i(a){let t="";for(const r of a)r.indexOf(" ")>=0?t+='"'+r+'"':t+=r,t+=" ";return t}}),define(Re[27],Ce([1,0,62,16,13,17,2,7,5,10,14,50]),function(ge,e,s,h,D,O,T,A,p,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Kl=e.FileKind=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.FileOperationResult=e.$Cl=e.$Bl=e.$Al=e.$yl=e.FileChangeType=e.$xl=e.FileOperation=e.$rl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$fl=void 0,e.$gl=f,e.$hl=m,e.$il=d,e.$jl=i,e.$kl=a,e.$ll=t,e.$ml=r,e.$nl=n,e.$ol=u,e.$pl=l,e.$ql=g,e.$sl=S,e.$tl=R,e.$ul=C,e.$vl=w,e.$wl=b,e.$zl=V,e.$Ll=U,e.$Ml=_,e.$Ol=oe,e.$fl=(0,p.$Ki)("fileService");function f(te){return te.create===!0}var P;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var v;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(v||(e.FilePermission=v={}));var o;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(o||(e.FileChangeFilter=o={}));function m(te){const me=te;return!!me&&typeof me.onDidChange=="function"}var $;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function d(te){return!!(te.capabilities&$.FileReadWrite)}function i(te){return!!(te.capabilities&$.FileFolderCopy)}function a(te){return!!(te.capabilities&$.FileClone)}function t(te){return!!(te.capabilities&$.FileOpenReadWriteClose)}function r(te){return!!(te.capabilities&$.FileReadStream)}function n(te){return d(te)?!!(te.capabilities&$.FileAtomicRead):!1}function u(te){return d(te)?!!(te.capabilities&$.FileAtomicWrite):!1}function l(te){return!!(te.capabilities&$.FileAtomicDelete)}function g(te){return!!(te.capabilities&$.Readonly)}var y;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(y||(e.FileSystemProviderErrorCode=y={}));class k extends Error{static create(me,ce){const Y=new k(me.toString(),ce);return C(Y,ce),Y}constructor(me,ce){super(me),this.code=ce}}e.$rl=k;function S(te,me){return k.create(te,me)}function R(te){return te||S((0,A.localize)(1866,null),y.Unknown)}function C(te,me){return te.name=me?`${me} (FileSystemError)`:"FileSystemError",te}function w(te){if(!te)return y.Unknown;if(te instanceof k)return te.code;const me=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!me)return y.Unknown;switch(me[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}function b(te){if(te instanceof F)return te.fileOperationResult;switch(w(te)){case y.FileNotFound:return J.FILE_NOT_FOUND;case y.FileIsADirectory:return J.FILE_IS_DIRECTORY;case y.FileNotADirectory:return J.FILE_NOT_DIRECTORY;case y.FileWriteLocked:return J.FILE_WRITE_LOCKED;case y.NoPermissions:return J.FILE_PERMISSION_DENIED;case y.FileExists:return J.FILE_MOVE_CONFLICT;case y.FileTooLarge:return J.FILE_TOO_LARGE;default:return J.FILE_OTHER_ERROR}}var N;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class L{constructor(me,ce,Y){this.resource=me,this.operation=ce,this.target=Y}isOperation(me){return this.operation===me}}e.$xl=L;var M;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class z{static{this.a=null}constructor(me,ce){this.c=ce,this.b=void 0,this.d=new E.$Y(()=>{const Y=s.$Qi.forUris(()=>this.c);return Y.fill(this.rawAdded.map(q=>[q,!0])),Y}),this.f=new E.$Y(()=>{const Y=s.$Qi.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(q=>[q,!0])),Y}),this.g=new E.$Y(()=>{const Y=s.$Qi.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(q=>[q,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of me){switch(Y.type){case M.ADDED:this.rawAdded.push(Y.resource);break;case M.UPDATED:this.rawUpdated.push(Y.resource);break;case M.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==z.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(me,...ce){return this.h(me,{includeChildren:!1},...ce)}affects(me,...ce){return this.h(me,{includeChildren:!0},...ce)}h(me,ce,...Y){if(!me)return!1;const q=Y.length>0;return!!((!q||Y.includes(M.ADDED))&&(this.d.value.get(me)||ce.includeChildren&&this.d.value.findSuperstr(me))||(!q||Y.includes(M.UPDATED))&&(this.f.value.get(me)||ce.includeChildren&&this.f.value.findSuperstr(me))||(!q||Y.includes(M.DELETED))&&(this.g.value.findSubstr(me)||ce.includeChildren&&this.g.value.findSuperstr(me)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(me){return this.b===me}hasCorrelation(){return typeof this.b=="number"}}e.$yl=z;function V(te,me,ce){return!te||!me||te===me||me.length>te.length?!1:(me.charAt(me.length-1)!==h.sep&&(me+=h.sep),ce?(0,D.$Lf)(te,me):te.indexOf(me)===0)}class F extends Error{constructor(me,ce,Y){super(me),this.fileOperationResult=ce,this.options=Y}}e.$Al=F;class j extends F{constructor(me,ce,Y,q){super(me,ce,q),this.fileOperationResult=ce,this.size=Y}}e.$Bl=j;class W extends F{constructor(me,ce,Y){super(me,J.FILE_NOT_MODIFIED_SINCE,Y),this.stat=ce}}e.$Cl=W;var J;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$Dl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$El={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Fl="files.associations",e.$Gl="files.exclude",e.$Hl="files.readonlyInclude",e.$Il="files.readonlyExclude",e.$Jl="files.readonlyFromPermissions";var B;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$Kl="";function U(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function _(te,me){if(!me.hasProvider(T.URI.from({scheme:te.scheme})))return new Promise(ce=>{const Y=me.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===te.scheme&&q.added&&(Y.dispose(),ce())})})}class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(me){return(0,O.$ng)(me)||(me=0),me<x.KB?(0,A.localize)(1867,null,me.toFixed(0)):me<x.MB?(0,A.localize)(1868,null,(me/x.KB).toFixed(2)):me<x.GB?(0,A.localize)(1869,null,(me/x.MB).toFixed(2)):me<x.TB?(0,A.localize)(1870,null,(me/x.GB).toFixed(2)):(0,A.localize)(1871,null,(me/x.TB).toFixed(2))}}e.$Nl=x;function oe(te){const me=typeof te=="string"||te?.scheme===I.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===I.Schemas.file?1024*x.MB:me?10*x.MB:c.$r?50*x.MB:1024*x.MB}}),define(Re[223],Ce([1,0,21,12,7,27]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=T;async function T(I,E,f,P,v,o){let m;try{await A(I,E,f,P,v,o)}catch($){m=$}finally{m&&v.errorTransformer&&(m=v.errorTransformer(m)),typeof m<"u"&&f.error(m),f.end()}}async function A(I,E,f,P,v,o){p(o);const m=await I.open(E,{create:!1});try{p(o);let $=0,d=0,i=v&&typeof v.length=="number"?v.length:void 0,a=s.$Se.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=v&&typeof v.position=="number"?v.position:0,r=0;do d=await I.read(m,t,a.buffer,r,a.byteLength-r),t+=d,r+=d,$+=d,typeof i=="number"&&(i-=d),r===a.byteLength&&(await f.write(P(a)),a=s.$Se.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),r=0);while(d>0&&(typeof i!="number"||i>0)&&p(o)&&c($,v));if(r>0){let n=r;typeof i=="number"&&(n=Math.min(r,i)),f.write(P(a.slice(0,n)))}}catch($){throw(0,O.$tl)($)}finally{await I.close(m)}}function p(I){if(I.isCancellationRequested)throw(0,h.$0)();return!0}function c(I,E){if(typeof E?.limits?.size=="number"&&I>E.limits.size)throw(0,O.$sl)((0,D.localize)(1899,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Re[71],Ce([1,0,39,3,16,10,2,27]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=void 0,e.$br=p,e.$cr=c,e.$gr=P,e.$hr=v,e.$ir=o,e.$jr=m,e.$kr=d,e.$lr=i;function p(a){return typeof a.correlationId=="number"}function c(a){return a.recursive===!0}class I extends h.$Zc{static{this.a=5}constructor(t,r,n,u){super(),this.h=t,this.j=r,this.m=n,this.n=u,this.c=this.B(new h.$1c),this.f=void 0,this.g=0}s(){const t=new h.$Yc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(r=>this.h(r))),t.add(this.b.onDidLogMessage(r=>this.j(r))),t.add(this.b.onDidError(r=>this.t(r.error,r.request)))}t(t,r){this.u(t,r)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,r){return!(!this.n.restartOnError||r||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$dr=I;class E extends I{constructor(t,r,n){super(t,r,n,{type:"node.js",restartOnError:!1})}}e.$er=E;class f extends I{constructor(t,r,n){super(t,r,n,{type:"universal",restartOnError:!0})}}e.$fr=f;function P(a){return a.map(t=>({type:t.type,resource:T.URI.revive(t.resource),cId:t.cId}))}function v(a){const t=new $;for(const r of a)t.processEvent(r);return t.coalesce()}function o(a,t){return typeof t=="string"&&!t.startsWith(s.$Bk)&&!(0,D.$nc)(t)?{base:a,pattern:t}:t}function m(a,t){const r=[];for(const n of t)r.push((0,s.$Fk)(o(a,n)));return r}class ${constructor(){this.a=new Set,this.b=new Map}c(t){return O.$n?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const r=this.b.get(this.c(t));let n=!1;if(r){const u=r.type,l=t.type;r.resource.fsPath!==t.resource.fsPath&&(t.type===A.FileChangeType.DELETED||t.type===A.FileChangeType.ADDED)?n=!0:u===A.FileChangeType.ADDED&&l===A.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(r)):u===A.FileChangeType.DELETED&&l===A.FileChangeType.ADDED?r.type=A.FileChangeType.UPDATED:u===A.FileChangeType.ADDED&&l===A.FileChangeType.UPDATED||(r.type=l)}else n=!0;n&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],r=[];return Array.from(this.a).filter(n=>n.type!==A.FileChangeType.DELETED?(t.push(n),!1):!0).sort((n,u)=>n.resource.fsPath.length-u.resource.fsPath.length).filter(n=>r.some(u=>(0,A.$zl)(n.resource.fsPath,u,!O.$n))?!1:(r.push(n.resource.fsPath),!0)).concat(t)}}function d(a,t){if(typeof t=="number")switch(a.type){case A.FileChangeType.ADDED:return(t&A.FileChangeFilter.ADDED)===0;case A.FileChangeType.DELETED:return(t&A.FileChangeFilter.DELETED)===0;case A.FileChangeType.UPDATED:return(t&A.FileChangeFilter.UPDATED)===0}return!1}function i(a){if(typeof a=="number"){const t=[];return a&A.FileChangeFilter.ADDED&&t.push("Added"),a&A.FileChangeFilter.DELETED&&t.push("Deleted"),a&A.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(Re[224],Ce([1,0,46,3,71,4,27,2,8]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;class c extends h.$Zc{constructor(){super(),this.a=this.B(new O.$qe),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$qe),this.onDidLogMessage=this.b.event,this.c=this.B(new O.$qe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$9c),this.m=new Set,this.n=this.B(new p.$Ih(this.y())),this.r=5007,this.s=new p.$8h,this.R=!1,this.B(this.f(E=>this.t(E)))}t(E){this.u(E)&&this.z(E)}u(E){return(0,D.$br)(E)}async watch(E){this.s.isSettled||this.s.complete(),this.s=new p.$8h;try{this.h.clear(),this.g.clear();for(const f of E)this.u(f)?this.h.set(f.correlationId,f):this.g.add(f);for(const[f]of this.j)this.h.has(f)||(this.j.deleteAndDispose(f),this.m.delete(f));return await this.w(!1)}finally{this.s.complete()}}w(E){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(f=>!this.j.has(f.correlationId))]),E?this.y():0)}y(){return 800}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async z(E){if(this.j.has(E.correlationId))return;const f=new h.$Yc;this.j.set(E.correlationId,f),await this.s.p,!f.isDisposed&&(this.D(E,f),this.w(!0))}C(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.w(!1)}D(E,f){this.F(E,f)?(this.P(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.G(E,f),this.m.add(E.correlationId))}F(E,f){const P=this.O?.subscribe(E.path,(v,o)=>{f.isDisposed||(v?this.D(E,f):o?.type===T.FileChangeType.ADDED&&this.H(E))});return P?(f.add(P),!0):!1}G(E,f){let P=!1;const v=(o,m)=>{if(f.isDisposed)return;const $=this.I(o),d=this.I(m),i=P;P=$,!$&&(d||i)&&this.H(E)};this.P(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,s.watchFile)(E.path,{persistent:!1,interval:this.r},v)}catch(o){this.Q(`fs.watchFile() failed with error ${o} on path ${E.path} (correlationId: ${E.correlationId})`)}f.add((0,h.$Xc)(()=>{this.P(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,s.unwatchFile)(E.path,v)}catch(o){this.Q(`fs.unwatchFile() failed with error ${o} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}H(E){this.P(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const f={resource:A.URI.file(E.path),type:T.FileChangeType.ADDED,cId:E.correlationId};this.a.fire([f]),this.J(f,E),this.C(E)}I(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(E,f){if(this.R){const P=` >> normalized ${E.type===T.FileChangeType.ADDED?"[ADDED]":E.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.L(P,f)}}L(E,f){this.R&&this.P(`${E}${typeof f.correlationId=="number"?` <${f.correlationId}> `:""}`)}M(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,D.$lr)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.R=E}}e.$ur=c}),define(Re[225],Ce([1,0,46,8,20,33,3,83,16,10,22,2,110,34,27,71]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0,e.$Ar=$;class m extends T.$Zc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(i,a,t,r,n,u){super(),this.s=i,this.t=a,this.u=t,this.w=r,this.y=n,this.z=u,this.c=this.B(new h.$Zh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.u(l))),this.f=this.B(new h.$Yh(l=>this.M(l),m.b)),this.g=(0,o.$jr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,o.$jr)(this.s.path,this.s.includes):void 0,this.j=(0,o.$br)(this.s)?this.s.filter:void 0,this.m=new D.$Be,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const i=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const a=await s.promises.stat(i);if(this.m.token.isCancellationRequested)return;this.B(await this.G(i,a.isDirectory()))}catch(i){i.code!=="ENOENT"?this.O(i):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${i})`),this.D()}}D(){this.r=!0,this.w?.()}async F(i){let a=i.path;try{a=await P.Promises.realpath(i.path),i.path===a&&(a=await(0,f.$wr)(i.path,this.m.token)??i.path),i.path!==a&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${a})`)}catch{}return a}async G(i,a){const t=new T.$Yc;return this.H(i,a,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(i,a,t)),t}H(i,a,t){if(a)return!1;const r=E.URI.file(this.s.path),n=this.t?.subscribe(this.s.path,async(u,l)=>{if(!t.isDisposed)if(u){const g=await this.G(i,a);t.isDisposed?g.dispose():t.add(g)}else l&&(typeof l.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:r,type:l.type,cId:this.s.correlationId},!0)});return n?(t.add(n),!0):!1}async I(i,a,t){if(c.$m&&(0,O.$Jg)(i,"/Volumes/",!0)){this.O(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const r=new D.$Be(this.m.token);t.add((0,T.$Xc)(()=>r.dispose(!0)));const n=new T.$Yc;t.add(n);try{const u=E.URI.file(this.s.path),l=(0,p.$sc)(i),g=(0,s.watch)(i);n.add((0,T.$Xc)(()=>{g.removeAllListeners(),g.close()})),this.Q(`Started watching: '${i}'`);const y=new Set;if(a)try{for(const S of await P.Promises.readdir(i))y.add(S)}catch(S){this.O(S)}if(r.token.isCancellationRequested)return;const k=new Map;n.add((0,T.$Xc)(()=>{for(const[,S]of k)S.dispose();k.clear()})),g.on("error",(S,R)=>{r.token.isCancellationRequested||(this.O(`Failed to watch ${i} for changes using fs.watch() (${S}, ${R})`),this.D())}),g.on("change",(S,R)=>{if(r.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${S}"] ${R}`);let C="";if(R&&(C=R.toString(),c.$m&&(C=(0,A.$sm)(C))),!(!C||S!=="change"&&S!=="rename"))if(a)if(S==="rename"){k.get(C)?.dispose();const w=setTimeout(async()=>{if(k.delete(C),C===l&&!await P.Promises.exists(i)){this.J(u);return}if(r.token.isCancellationRequested)return;const b=await this.N((0,p.$oc)(i,C));if(r.token.isCancellationRequested)return;let N;b?y.has(C)?N=v.FileChangeType.UPDATED:(N=v.FileChangeType.ADDED,y.add(C)):(y.delete(C),N=v.FileChangeType.DELETED),this.L({resource:(0,I.$lh)(u,C),type:N,cId:this.s.correlationId})},m.a);k.set(C,(0,T.$Xc)(()=>clearTimeout(w)))}else{let w;y.has(C)?w=v.FileChangeType.UPDATED:(w=v.FileChangeType.ADDED,y.add(C)),this.L({resource:(0,I.$lh)(u,C),type:w,cId:this.s.correlationId})}else if(S==="rename"||C!==l){const w=setTimeout(async()=>{const b=await P.Promises.exists(i);r.token.isCancellationRequested||(b?(this.L({resource:u,type:v.FileChangeType.UPDATED,cId:this.s.correlationId},!0),n.add(await this.G(i,!1))):this.J(u))},m.a);n.clear(),n.add((0,T.$Xc)(()=>clearTimeout(w)))}else this.L({resource:u,type:v.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(u){r.token.isCancellationRequested||this.O(`Failed to watch ${i} for changes using fs.watch() (${u.toString()})`),this.D()}}J(i){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:i,type:v.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(i,a=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${i.type===v.FileChangeType.ADDED?"[ADDED]":i.type===v.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!a&&this.g.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${i.resource.fsPath}`):!a&&this.h&&this.h.length>0&&!this.h.some(t=>t(i.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}M(i){const a=(0,o.$hr)(i),t=[];for(const n of a){if((0,o.$kr)(n,this.j)){this.z&&this.R(` >> ignored (filtered) ${n.resource.fsPath}`);continue}t.push(n)}if(t.length===0)return;if(this.z)for(const n of t)this.R(` >> normalized ${n.type===v.FileChangeType.ADDED?"[ADDED]":n.type===v.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(i){if(c.$n)return P.Promises.exists(i);try{const a=(0,p.$sc)(i);return(await P.Promises.readdir((0,p.$rc)(i))).some(r=>r===a)}catch(a){return this.Q(a),!1}}setVerboseLogging(i){this.z=i}O(i){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}P(i){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}Q(i){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}R(i){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${i}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$zr=m;async function $(d,i,a,t,r=512){const n=await P.Promises.open(d,"r"),u=Buffer.allocUnsafe(r),l=new D.$Be(t);let g,y=!1;const k={path:d,excludes:[],recursive:!1},S=new m(k,void 0,R=>{(async()=>{for(const{type:C}of R)if(C===v.FileChangeType.UPDATED){if(y)return;y=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:w}=await P.Promises.read(n,u,0,r,null);if(!w||l.token.isCancellationRequested)break;i(u.slice(0,w))}}catch(w){g=new Error(w),l.dispose(!0)}finally{y=!1}}})()});return await S.ready,a(),new Promise((R,C)=>{l.token.onCancellationRequested(async()=>{S.dispose();try{await P.Promises.close(n)}catch(w){g=new Error(w)}g?C(g):R()})})}}),define(Re[226],Ce([1,0,4,39,224,10,225,33]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;class p extends D.$ur{constructor(I){super(),this.O=I,this.onDidError=s.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const E=[],f=new Set(Array.from(this.watchers));for(const P of I){const v=this.W(P);v&&(0,h.$Jk)(v.request.excludes,P.excludes)&&(0,h.$Jk)(v.request.includes,P.includes)?f.delete(v):E.push(P)}E.length&&this.P(`Request to start watching: ${E.map(P=>this.M(P)).join(",")}`),f.size&&this.P(`Request to stop watching: ${Array.from(f).map(P=>this.M(P.request)).join(",")}`);for(const P of f)this.Y(P);for(const P of E)this.X(P)}W(I){for(const E of this.watchers)if(typeof I.correlationId=="number"||typeof E.request.correlationId=="number"){if(E.request.correlationId===I.correlationId)return E}else if((0,A.$Ig)(E.request.path,I.path,!O.$n))return E}X(I){const E=new T.$zr(I,this.O,P=>this.a.fire(P),()=>this.c.fire(I),P=>this.b.fire(P),this.R),f={request:I,instance:E};this.watchers.add(f)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const E=new Map;for(const f of I){const P=O.$n?f.path:f.path.toLowerCase();let v=E.get(f.correlationId);v||(v=new Map,E.set(f.correlationId,v)),v.has(P)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(f)}`),v.set(P,f)}return Array.from(E.values()).map(f=>Array.from(f.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const E of this.watchers)E.instance.setVerboseLogging(I)}P(I,E){this.R&&this.b.fire({type:"trace",message:this.bb(I,E)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,E){return E?`[File Watcher (node.js)] ${I} (${this.M(E.request)})`:`[File Watcher (node.js)] ${I}`}}e.$Br=p}),define(Re[227],Ce([1,0,71,226]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class D extends s.$er{constructor(T,A,p){super(T,A,p),this.s()}r(T){return T.add(new h.$Br(void 0))}}e.$Cr=D}),define(Re[228],Ce([1,0,14,87,210,71]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;class T extends O.$fr{constructor(p,c,I){super(p,c,I),this.s()}r(p){const c=p.add(new D.$sr(s.$5g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(c.onDidProcessExit(({code:I,signal:E})=>this.t(`terminated by itself with code ${I}, signal: ${E} (ETERM)`))),h.ProxyChannel.toService((0,h.$ri)(c.getChannel("watcher")))}}e.$tr=T}),define(Re[114],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=void 0;class s{constructor(...D){this.a=new Map;for(const[O,T]of D)this.set(O,T)}set(D,O){const T=this.a.get(D);return this.a.set(D,O),T}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$Ii=s}),define(Re[229],Ce([1,0,8,12,3,112,218,5,114,82]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=void 0;const I=!1;class E extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class f{constructor(m=new p.$Ii,$=!1,d,i=I){this.i=m,this.j=$,this.k=d,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(A.$Ji,this),this._globalGraph=i?d?._globalGraph??new T.$Fr(a=>a):void 0}dispose(){if(!this.f){this.f=!0,(0,D.$Uc)(this.h),this.h.clear();for(const m of this.g)(0,D.$Tc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,$){this.m();const d=this,i=new class extends f{dispose(){d.h.delete(i),super.dispose()}}(m,this.j,this,this.l);return this.h.add(i),$?.add(i),i}invokeFunction(m,...$){this.m();const d=v.traceInvocation(this.l,m);let i=!1;try{return m({get:t=>{if(i)throw(0,h.$_)("service accessor is only valid during the invocation of its target method");const r=this.s(t,d);if(!r)throw new Error(`[invokeFunction] unknown service '${t}'`);return r}},...$)}finally{i=!0,d.stop()}}createInstance(m,...$){this.m();let d,i;return m instanceof O.$Hi?(d=v.traceCreation(this.l,m.ctor),i=this.o(m.ctor,m.staticArguments.concat($),d)):(d=v.traceCreation(this.l,m),i=this.o(m,$,d)),d.stop(),i}o(m,$=[],d){const i=A._util.getServiceDependencies(m).sort((r,n)=>r.index-n.index),a=[];for(const r of i){const n=this.s(r.id,d);n||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${r.id}.`,!1),a.push(n)}const t=i.length>0?i[0].index:$.length;if($.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${$.length} static arguments`);const r=t-$.length;r>0?$=$.concat(new Array(r)):$=$.slice(0,t)}return Reflect.construct(m,$.concat(a))}q(m,$){if(this.i.get(m)instanceof O.$Hi)this.i.set(m,$);else if(this.k)this.k.q(m,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const $=this.i.get(m);return!$&&this.k?this.k.r(m):$}s(m,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const d=this.r(m);return d instanceof O.$Hi?this.u(m,d,$.branch(m,!0)):($.branch(m,!1),d)}u(m,$,d){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,$,d)}finally{this.t.delete(m)}}v(m,$,d){const i=new T.$Fr(n=>n.id.toString());let a=0;const t=[{id:m,desc:$,_trace:d}],r=new Set;for(;t.length;){const n=t.pop();if(!r.has(String(n.id))){if(r.add(String(n.id)),i.lookupOrInsertNode(n),a++>1e3)throw new E(i);for(const u of A._util.getServiceDependencies(n.desc.ctor)){const l=this.r(u.id);if(l||this.y(`[createInstance] ${m} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(u.id)),l instanceof O.$Hi){const g={id:u.id,desc:l,_trace:n._trace.branch(u.id,!0)};i.insertEdge(n,g),t.push(g)}}}}for(;;){const n=i.roots();if(n.length===0){if(!i.isEmpty())throw new E(i);break}for(const{data:u}of n){if(this.r(u.id)instanceof O.$Hi){const g=this.w(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.q(u.id,g)}i.removeNode(u)}}return this.r(m)}w(m,$,d=[],i,a){if(this.i.get(m)instanceof O.$Hi)return this.x(m,$,d,i,a,this.g);if(this.k)return this.k.w(m,$,d,i,a);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(m,$,d=[],i,a,t){if(i){const r=new f(void 0,this.j,this,this.l);r.c=String(m);const n=new Map,u=new s.$4h(()=>{const l=r.o($,d,a);for(const[g,y]of n){const k=l[g];if(typeof k=="function")for(const S of y)S.disposable=k.apply(l,S.listener)}return n.clear(),t.add(l),l});return new Proxy(Object.create(null),{get(l,g){if(!u.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let S=n.get(g);return S||(S=new c.$0c,n.set(g,S)),(C,w,b)=>{if(u.isInitialized)return u.value[g](C,w,b);{const N={listener:[C,w,b],disposable:void 0},L=S.push(N);return(0,D.$Xc)(()=>{L(),N.disposable?.dispose()})}}}if(g in l)return l[g];const y=u.value;let k=y[g];return typeof k!="function"||(k=k.bind(y),l[g]=k),k},set(l,g,y){return u.value[g]=y,!0},getPrototypeOf(l){return $.prototype}})}else{const r=this.o($,d,a);return t.add(r),r}}y(m,$){if($&&console.warn(m),this.j)throw new Error(m)}}e.$Gr=f;var P;(function(o){o[o.None=0]="None",o[o.Creation=1]="Creation",o[o.Invocation=2]="Invocation",o[o.Branch=3]="Branch"})(P||(P={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(P.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,$){return m?new v(P.Invocation,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(m,$){return m?new v(P.Creation,$.name):v.c}static{this.f=0}constructor(m,$){this.type=m,this.name=$,this.g=Date.now(),this.h=[]}branch(m,$){const d=new v(P.Branch,m.toString());return this.h.push([m,$,d]),d}stop(){const m=Date.now()-this.g;v.f+=m;let $=!1;function d(a,t){const r=[],n=new Array(a+1).join("	");for(const[u,l,g]of t.h)if(l&&g){$=!0,r.push(`${n}CREATES -> ${u}`);const y=d(a+1,g);y&&r.push(y)}else r.push(`${n}uses -> ${u}`);return r.join(`
`)}const i=[`${this.type===P.Creation?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(m>2||$)&&v.all.add(i.join(`
`))}}e.$Hr=v}),define(Re[11],Ce([1,0,7,52,4,61,3,28,10,22,17,2,36,5]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$ik=e.LogLevel=e.$gk=e.$fk=void 0,e.$hk=o,e.log=$,e.$tk=k,e.$uk=S,e.$vk=R,e.$wk=C,s=Ue(s),e.$fk=(0,P.$Ki)("logService"),e.$gk=(0,P.$Ki)("loggerService");function v(){return new Date().toISOString()}function o(w){return(0,I.$ng)(w)}var m;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$ik=m.Info;function $(w,b,N){switch(b){case m.Trace:w.trace(N);break;case m.Debug:w.debug(N);break;case m.Info:w.info(N);break;case m.Warning:w.warn(N);break;case m.Error:w.error(N);break;case m.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function d(w,b=!1){let N="";for(let L=0;L<w.length;L++){let M=w[L];if(M instanceof Error&&(M=(0,h.$vj)(M,b)),typeof M=="object")try{M=JSON.stringify(M)}catch{}N+=(L>0?" ":"")+M}return N}class i extends T.$Zc{constructor(){super(...arguments),this.b=e.$ik,this.c=this.B(new D.$qe),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==m.Off&&this.b<=b}}e.$kk=i;class a extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...N){this.f(m.Trace)&&this.g(m.Trace,d([b,...N],!0))}debug(b,...N){this.f(m.Debug)&&this.g(m.Debug,d([b,...N]))}info(b,...N){this.f(m.Info)&&this.g(m.Info,d([b,...N]))}warn(b,...N){this.f(m.Warning)&&this.g(m.Warning,d([b,...N]))}error(b,...N){if(this.f(m.Error))if(b instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=b.stack,this.g(m.Error,d(L))}else this.g(m.Error,d([b,...N]))}flush(){}}e.$lk=a;class t extends i{constructor(b=e.$ik){super(),this.setLevel(b),this.g=!p.$l}trace(b,...N){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,b,...N):console.log(`[main ${v()}]`,b,...N))}debug(b,...N){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,b,...N):console.log(`[main ${v()}]`,b,...N))}info(b,...N){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,b,...N):console.log(`[main ${v()}]`,b,...N))}warn(b,...N){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,b,...N):console.warn(`[main ${v()}]`,b,...N))}error(b,...N){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,b,...N):console.error(`[main ${v()}]`,b,...N))}flush(){}}e.$mk=t;class r extends i{constructor(b=e.$ik,N=!0){super(),this.g=N,this.setLevel(b)}trace(b,...N){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...N):console.log(b,...N))}debug(b,...N){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...N):console.log(b,...N))}info(b,...N){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...N):console.log(b,...N))}warn(b,...N){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...N):console.log(b,...N))}error(b,...N){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...N):console.error(b,...N))}flush(){}}e.$nk=r;class n extends i{constructor(b,N=e.$ik){super(),this.g=b,this.setLevel(N)}trace(b,...N){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(b),...N])}debug(b,...N){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(b),...N])}info(b,...N){this.f(m.Info)&&this.g.log(m.Info,[this.h(b),...N])}warn(b,...N){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(b),...N])}error(b,...N){this.f(m.Error)&&this.g.log(m.Error,[this.h(b),...N])}h(b){return typeof b=="string"?b:(0,h.$vj)(b,this.f(m.Trace))}flush(){}}e.$ok=n;class u extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const N of this.g)N.setLevel(b);super.setLevel(b)}trace(b,...N){for(const L of this.g)L.trace(b,...N)}debug(b,...N){for(const L of this.g)L.debug(b,...N)}info(b,...N){for(const L of this.g)L.info(b,...N)}warn(b,...N){for(const L of this.g)L.warn(b,...N)}error(b,...N){for(const L of this.g)L.error(b,...N)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$pk=u;class l extends T.$Zc{constructor(b,N,L){if(super(),this.h=b,this.j=N,this.b=new A.$Fc,this.c=this.B(new D.$qe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$qe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$qe),this.onDidChangeVisibility=this.g.event,L)for(const M of L)this.b.set(M.resource,{logger:void 0,info:M})}m(b){return(0,I.$jg)(b)?[...this.b.values()].find(N=>N.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,N){const L=this.n(b),M=(0,I.$jg)(b)?b:N?.id??(0,O.$yj)(L.toString()).toString(16);let z=this.b.get(L)?.logger;const V=N?.logLevel==="always"?m.Trace:N?.logLevel;z||(z=this.s(L,V??this.getLogLevel(L)??this.h,{...N,id:M}));const F={logger:z,info:{resource:L,id:M,logLevel:V,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(F.info),this.b.set(L,F),z}n(b){return(0,I.$jg)(b)?(0,c.$lh)(this.j,`${b}.log`):b}setLogLevel(b,N){if(E.URI.isUri(b)){const L=b,M=N,z=this.b.get(L);z&&M!==z.info.logLevel&&(z.info.logLevel=M===this.h?void 0:M,z.logger?.setLevel(M),this.b.set(z.info.resource,z),this.f.fire([L,M]))}else{this.h=b;for(const[L,M]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,N){const L=this.m(b);L&&N!==!L.info.hidden&&(L.info.hidden=!N,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,N]))}getLogLevel(b){let N;return b&&(N=this.b.get(b)?.info.logLevel),N??this.h}registerLogger(b){const N=this.b.get(b.resource);N?N.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const N=this.b.get(b);N&&(N.logger&&N.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qk=l;class g{constructor(){this.onDidChangeLogLevel=new D.$qe().event}setLevel(b){}getLevel(){return m.Info}trace(b,...N){}debug(b,...N){}info(b,...N){}warn(b,...N){}error(b,...N){}critical(b,...N){}dispose(){}flush(){}}e.$rk=g;class y extends g{}e.$sk=y;function k(w){if(w.verbose)return m.Trace;if(typeof w.logLevel=="string"){const b=C(w.logLevel.toLowerCase());if(b!==void 0)return b}return e.$ik}function S(w){switch(w){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function R(w){switch(w){case m.Trace:return{original:"Trace",value:s.localize(1960,null)};case m.Debug:return{original:"Debug",value:s.localize(1961,null)};case m.Info:return{original:"Info",value:s.localize(1962,null)};case m.Warning:return{original:"Warning",value:s.localize(1963,null)};case m.Error:return{original:"Error",value:s.localize(1964,null)};case m.Off:return{original:"Off",value:s.localize(1965,null)}}}function C(w){switch(w){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$xk=new f.$2j("logLevel",S(m.Info))}),define(Re[230],Ce([1,0,18,8,12,4,33,3,16,71,11]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class E extends A.$Zc{constructor(P,v){super(),this.a=P,this.b=v,this.c=this.B(new O.$qe),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$qe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Ih(0)),this.w=[],this.y=this.B(new h.$Ih(0))}watch(P,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(P,v):this.z(P,v)}n(P,v){const o={path:this.J(P),excludes:v.excludes,includes:v.includes,recursive:v.recursive,filter:v.filter,correlationId:v.correlationId},m=(0,s.$Xb)(this.j,o);return this.r(),(0,A.$Xc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(P=>(0,D.$4)(P))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,c.$gr)(v)),v=>this.G(v),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const P=this.b?.watcher?.recursive?.usePolling;if(P===!0)for(const v of this.j)(0,c.$cr)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(P))for(const v of this.j)(0,c.$cr)(v)&&P.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(P,v){const o={path:this.J(P),excludes:v.excludes,includes:v.includes,recursive:!1,filter:v.filter,correlationId:v.correlationId},m=(0,s.$Xb)(this.w,o);return this.C(),(0,A.$Xc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(P=>(0,D.$4)(P))}D(){return this.u||(this.u=this.B(this.F(P=>this.c.fire((0,c.$gr)(P)),P=>this.G(P),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(P){P.type==="error"&&this.g.fire(P.message),this.H(P)}H(P){this.a[P.type](P.message)}I(P){return(0,p.$mc)(P.fsPath)}J(P){const v=this.I(P);return(0,T.$Mg)(v)}}e.$mr=E}),define(Re[231],Ce([1,0,46,8,28,21,4,33,3,16,10,22,103,34,7,27,223,230,228,227]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;class a extends $.$mr{static{this.L=!1}constructor(r,n){super(r,n),this.onDidChangeCapabilities=T.Event.None,this.P=new D.$Fc(u=>E.$ch.getComparisonKey(u)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=o.FileSystemProviderCapabilities.FileReadWrite|o.FileSystemProviderCapabilities.FileOpenReadWriteClose|o.FileSystemProviderCapabilities.FileReadStream|o.FileSystemProviderCapabilities.FileFolderCopy|o.FileSystemProviderCapabilities.FileWriteUnlock|o.FileSystemProviderCapabilities.FileAtomicRead|o.FileSystemProviderCapabilities.FileAtomicWrite|o.FileSystemProviderCapabilities.FileAtomicDelete|o.FileSystemProviderCapabilities.FileClone,I.$n&&(this.M|=o.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(r){try{const{stat:n,symbolicLink:u}=await P.SymlinkSupport.stat(this.I(r));return{type:this.O(n,u),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:o.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const n=await P.Promises.readdir(this.I(r),{withFileTypes:!0}),u=[];return await Promise.all(n.map(async l=>{try{let g;l.isSymbolicLink()?g=(await this.stat((0,E.$lh)(r,l.name))).type:g=this.O(l),u.push([l.name,g])}catch(g){this.a.trace(g)}})),u}catch(n){throw this.hb(n)}}O(r,n){let u;return n?.dangling?u=o.FileType.Unknown:r.isFile()?u=o.FileType.File:r.isDirectory()?u=o.FileType.Directory:u=o.FileType.Unknown,n&&(u|=o.FileType.SymbolicLink),u}async Q(r){const n=this.I(r);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let u;for(;u=this.P.get(r);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await u.wait();const l=new h.$Jh;return this.P.set(r,l),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,p.$Xc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(r)===l&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(r)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(r,n){let u;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(r)})`),u=await this.Q(r));const l=this.I(r);return await s.promises.readFile(l)}catch(l){throw this.hb(l)}finally{u?.dispose()}}R(r){a.L&&this.a.trace(r)}readFileStream(r,n,u){const l=(0,f.$Ge)(g=>O.$Se.concat(g.map(y=>O.$Se.wrap(y))).buffer);return(0,m.$_q)(this,r,l,g=>g.buffer,{...n,bufferSize:256*1024},u),l}async writeFile(r,n,u){return u?.atomic!==!1&&u?.atomic?.postfix&&await this.S(r)?this.U(r,(0,E.$lh)((0,E.$kh)(r),`${(0,E.$ih)(r)}${u.atomic.postfix}`),n,u):this.W(r,n,u)}async S(r){try{const n=this.I(r),{symbolicLink:u}=await P.SymlinkSupport.stat(n);if(u)return!1}catch{}return!0}async U(r,n,u,l){const g=new p.$Yc;try{g.add(await this.Q(r)),g.add(await this.Q(n)),await this.W(n,u,l,!0);try{await this.rename(n,r,{overwrite:!0})}catch(y){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw y}}finally{g.dispose()}}async W(r,n,u,l){let g;try{const y=this.I(r);if(!u.create||!u.overwrite){if(await P.Promises.exists(y)){if(!u.overwrite)throw(0,o.$sl)((0,v.localize)(1902,null),o.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,o.$sl)((0,v.localize)(1903,null),o.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(r,{create:!0,unlock:u.unlock},l),await this.write(g,0,n,0,n.byteLength)}catch(y){throw await this.ib(r,y)}finally{typeof g=="number"&&await this.close(g)}}static{this.$=!0}static configureFlushOnWrite(r){a.$=r}async open(r,n,u){const l=this.I(r);let g;(0,o.$gl)(n)&&!u&&(g=await this.Q(r));let y;try{if((0,o.$gl)(n)&&n.unlock)try{const{stat:S}=await P.SymlinkSupport.stat(l);S.mode&128||await s.promises.chmod(l,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let k;if((0,o.$gl)(n)){if(I.$l)try{await s.promises.truncate(l,0),k="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}k||(k="w")}else k="r";y=await P.Promises.open(l,k)}catch(k){throw g?.dispose(),(0,o.$gl)(n)?await this.ib(r,k):this.hb(k)}if(this.X.set(y,0),(0,o.$gl)(n)&&this.Z.set(y,r),g){const k=this.Y.get(y);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${l})`),this.Y.set(y,g),k&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${l})`),k.dispose())}return y}async close(r){const n=this.Y.get(r);try{if(this.X.delete(r),this.Z.delete(r)&&a.$)try{await P.Promises.fdatasync(r)}catch(u){a.configureFlushOnWrite(!1),this.a.error(u)}return await P.Promises.close(r)}catch(u){throw this.hb(u)}finally{n&&(this.Y.get(r)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.Y.delete(r)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),n.dispose())}}async read(r,n,u,l,g){const y=this.ab(r,n);let k=null;try{k=(await P.Promises.read(r,u,l,g,y)).bytesRead}catch(S){throw this.hb(S)}finally{this.bb(r,y,k)}return k}ab(r,n){return n===this.X.get(r)?null:n}bb(r,n,u){const l=this.X.get(r);typeof l=="number"&&(typeof n=="number"||(typeof u=="number"?this.X.set(r,l+u):this.X.delete(r)))}async write(r,n,u,l,g){return(0,h.$5h)(()=>this.cb(r,n,u,l,g),100,3)}async cb(r,n,u,l,g){const y=this.ab(r,n);let k=null;try{k=(await P.Promises.write(r,u,l,g,y)).bytesWritten}catch(S){throw await this.ib(this.Z.get(r),S)}finally{this.bb(r,y,k)}return k}async mkdir(r){try{await s.promises.mkdir(this.I(r))}catch(n){throw this.hb(n)}}async delete(r,n){try{const u=this.I(r);if(n.recursive){let l;n?.atomic!==!1&&n.atomic.postfix&&(l=(0,c.$oc)((0,c.$rc)(u),`${(0,c.$sc)(u)}${n.atomic.postfix}`)),await P.Promises.rm(u,P.RimRafMode.MOVE,l)}else try{await s.promises.unlink(u)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let g=!1;try{const{stat:y,symbolicLink:k}=await P.SymlinkSupport.stat(u);g=y.isDirectory()&&!k}catch{}if(g)await s.promises.rmdir(u);else throw l}else throw l}}catch(u){throw this.hb(u)}}async rename(r,n,u){const l=this.I(r),g=this.I(n);if(l!==g)try{await this.db(r,n,"move",u.overwrite),await P.Promises.rename(l,g)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,v.localize)(1904,null,(0,c.$sc)(l),(0,c.$sc)((0,c.$rc)(g)),y.toString()))),this.hb(y)}}async copy(r,n,u){const l=this.I(r),g=this.I(n);if(l!==g)try{await this.db(r,n,"copy",u.overwrite),await P.Promises.copy(l,g,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,v.localize)(1905,null,(0,c.$sc)(l),(0,c.$sc)((0,c.$rc)(g)),y.toString()))),this.hb(y)}}async db(r,n,u,l){const g=this.I(r),y=this.I(n);let k=!1;if(!!(this.capabilities&o.FileSystemProviderCapabilities.PathCaseSensitive)||(k=(0,A.$Ig)(g,y,!0)),k){if(u==="copy")throw(0,o.$sl)((0,v.localize)(1906,null),o.FileSystemProviderErrorCode.FileExists);if(u==="move")return}const R=await this.N(r);if(!R)throw(0,o.$sl)((0,v.localize)(1907,null),o.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(n);if(C){if(!l)throw(0,o.$sl)((0,v.localize)(1908,null),o.FileSystemProviderErrorCode.FileExists);R.type&o.FileType.File&&C.type&o.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,n){return this.eb(r,n,!1)}async eb(r,n,u){const l=this.I(r),g=this.I(n),y=!!(this.capabilities&o.FileSystemProviderCapabilities.PathCaseSensitive);if((0,A.$Ig)(l,g,!y))return;const k=new p.$Yc;try{k.add(await this.Q(r)),k.add(await this.Q(n)),u&&await s.promises.mkdir((0,c.$rc)(g),{recursive:!0}),await s.promises.copyFile(l,g)}catch(S){if(S.code==="ENOENT"&&!u)return this.eb(r,n,!0);throw this.hb(S)}finally{k.dispose()}}t(r,n,u){return new d.$tr(l=>r(l),l=>n(l),u)}F(r,n,u){return new i.$Cr(l=>r(l),l=>n(l),u)}hb(r){if(r instanceof o.$rl)return r;let n=r,u;switch(r.code){case"ENOENT":u=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=o.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,u=o.FileSystemProviderErrorCode.Unknown;break;default:u=o.FileSystemProviderErrorCode.Unknown}return(0,o.$sl)(n,u)}async ib(r,n){let u=this.hb(n);if(r&&u.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await P.SymlinkSupport.stat(this.I(r));l.mode&128||(u=(0,o.$sl)(n,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return u}}e.$Dr=a}),define(Re[232],Ce([1,0,3,11]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dS=void 0;class D extends s.$Zc{constructor(T,A=[]){super(),this.a=new h.$pk([T,...A]),this.B(T.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...A){this.a.trace(T,...A)}debug(T,...A){this.a.debug(T,...A)}info(T,...A){this.a.info(T,...A)}warn(T,...A){this.a.warn(T,...A)}error(T,...A){this.a.error(T,...A)}flush(){this.a.flush()}}e.$dS=D}),define(Re[233],Ce([1,0,27,11]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5R=void 0;var D;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(D||(D={}));async function O(c,I,E,f,P){try{const v=await new Promise((m,$)=>{ge(["@vscode/spdlog"],m,$)}).then(Ue);v.setFlushOn(D.Trace);const o=await v.createAsyncRotatingLogger(c,I,E,f);return P?o.clearFormatters():o.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),o}catch(v){console.error(v)}return null}function T(c,I,E){switch(I){case h.LogLevel.Trace:c.trace(E);break;case h.LogLevel.Debug:c.debug(E);break;case h.LogLevel.Info:c.info(E);break;case h.LogLevel.Warning:c.warn(E);break;case h.LogLevel.Error:c.error(E);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function A(c,I){switch(I){case h.LogLevel.Trace:c.setLevel(D.Trace);break;case h.LogLevel.Debug:c.setLevel(D.Debug);break;case h.LogLevel.Info:c.setLevel(D.Info);break;case h.LogLevel.Warning:c.setLevel(D.Warning);break;case h.LogLevel.Error:c.setLevel(D.Error);break;case h.LogLevel.Off:c.setLevel(D.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class p extends h.$lk{constructor(I,E,f,P,v){super(),this.m=[],this.setLevel(v),this.n=this.s(I,E,f,P),this.B(this.onDidChangeLogLevel(o=>{this.r&&A(this.r,o)}))}async s(I,E,f,P){const v=f?6:1,o=30/v*s.$Nl.MB,m=await O(I,E,o,v,P);if(m){this.r=m,A(this.r,this.getLevel());for(const{level:$,message:d}of this.m)T(this.r,$,d);this.m=[]}}g(I,E){this.r?T(this.r,I,E):this.getLevel()<=I&&this.m.push({level:I,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$5R=p});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[150],Ce([1,0,45,7,5]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,s=Ht(s);var O;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var T;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(T||(e.MarkerSeverity=T={})),function(p){function c(v,o){return o-v}p.compare=c;const I=Object.create(null);I[p.Error]=(0,h.localize)(1966,null),I[p.Warning]=(0,h.localize)(1967,null),I[p.Info]=(0,h.localize)(1968,null);function E(v){return I[v]||""}p.toString=E;function f(v){switch(v){case s.default.Error:return p.Error;case s.default.Warning:return p.Warning;case s.default.Info:return p.Info;case s.default.Ignore:return p.Hint}}p.fromSeverity=f;function P(v){switch(v){case p.Error:return s.default.Error;case p.Warning:return s.default.Warning;case p.Info:return s.default.Info;case p.Hint:return s.default.Ignore}}p.toSeverity=P}(T||(e.MarkerSeverity=T={}));var A;(function(p){const c="";function I(f){return E(f,!0)}p.makeKey=I;function E(f,P){const v=[c];return f.source?v.push(f.source.replace("\xA6","\\\xA6")):v.push(c),f.code?typeof f.code=="string"?v.push(f.code.replace("\xA6","\\\xA6")):v.push(f.code.value.replace("\xA6","\\\xA6")):v.push(c),f.severity!==void 0&&f.severity!==null?v.push(T.toString(f.severity)):v.push(c),f.message&&P?v.push(f.message.replace("\xA6","\\\xA6")):v.push(c),f.startLineNumber!==void 0&&f.startLineNumber!==null?v.push(f.startLineNumber.toString()):v.push(c),f.startColumn!==void 0&&f.startColumn!==null?v.push(f.startColumn.toString()):v.push(c),f.endLineNumber!==void 0&&f.endLineNumber!==null?v.push(f.endLineNumber.toString()):v.push(c),f.endColumn!==void 0&&f.endColumn!==null?v.push(f.endColumn.toString()):v.push(c),v.push(c),v.join("\xA6")}p.makeKeyOptionalMessage=E})(A||(e.IMarkerData=A={})),e.$Qu=(0,D.$Ki)("markerService")});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[234],Ce([1,0,4,45,5]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Ew=e.Severity=void 0,e.$Fw=A,h=Ht(h),e.Severity=h.default,e.$Ew=(0,D.$Ki)("notificationService");var O;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var T;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(T||(e.NeverShowAgainScope=T={}));function A(E){if(E){const f=E;return typeof f.id=="string"&&typeof f.label=="string"}return!1}var p;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class c{constructor(){this.progress=new I,this.onDidClose=s.Event.None,this.onDidChangeVisibility=s.Event.None}updateSeverity(f){}updateMessage(f){}updateActions(f){}close(){}}e.$Gw=c;class I{infinite(){}done(){}total(f){}worked(f){}}e.$Hw=I}),define(Re[235],Ce([1,0,57]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.context<"u"){const O=D.context.configuration();if(O)h=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,s.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:O.version})}Object.assign(h,{extensionsGallery:s.env.EXTENSIONS_GALLERY?JSON.parse(s.env.EXTENSIONS_GALLERY):h.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""},telemetryEndpoint:s.env.CS_TELEMETRY_URL||h.telemetryEndpoint||"https://v1.telemetry.coder.com/track"})}else h={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.3",sha256:"7380a890787452f14b2db7835dfa94de538caf358ebc263f9d46dd68ac52de93",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.93.0",sha256:"9339cb8e6b77f554df54d79e71f533279cb76b0f9b04c207f633bfd507442b6a",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.93.1",commit:"3542bd157b0ccc8bf732acdb03d4d69d85f48ea9",date:"2024-09-19T10:15:30.023Z"},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(Re[115],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=void 0,e.$yk=(0,s.$Ki)("productService"),e.$zk="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ge,e){return function(s,h){e(s,h,ge)}};define(Re[90],Ce([1,0,8,20,3,5]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ow=e.$Nw=e.$Mw=e.$Lw=e.$Kw=e.$Jw=e.ProgressLocation=e.$Iw=void 0,e.$Iw=(0,O.$Ki)("progressService");var T;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(T||(e.ProgressLocation=T={})),e.$Jw=Object.freeze({total(){},worked(){},done(){}});class A{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(f){this.b=f}report(f){this.a=f,this.b(this.a)}}e.$Kw=A;class p{get value(){return this.a}constructor(f){this.e=f}report(f){this.b?this.b.push(f):this.b=[f],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const f=this.b.shift();this.a=f,await this.e(this.a)}}finally{this.c=!1;const f=this.d;this.d=void 0,f?.()}}drain(){return this.c?new Promise(f=>{const P=this.d;this.d=()=>{P?.(),f()}}):Promise.resolve()}}e.$Lw=p;let c=class extends D.$Zc{constructor(f,P){super(),this.a=new s.$8h,P.withProgress(f,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,D.$Xc)(()=>this.a.complete()))}report(f){this.b?this.b.report(f):this.c=f}};e.$Mw=c,e.$Mw=c=Ye([We(1,e.$Iw)],c);class I extends D.$Zc{constructor(f){super(),this.g=f,this.a=0,this.b=this.B(new D.$Yc)}start(f){this.stop();const P=++this.a,v=new h.$Be;return this.f=setTimeout(()=>{P===this.a&&(this.c=this.g.show(!0))},f),this.b.add((0,D.$Xc)(()=>clearTimeout(this.f))),this.b.add((0,D.$Xc)(()=>v.cancel())),this.b.add((0,D.$Xc)(()=>this.c?this.c.done():void 0)),{id:P,token:v.token,stop:()=>this.h(P),isCurrent:()=>this.a===P}}stop(){this.h(this.a)}h(f){this.a===f&&this.b.clear()}}e.$Nw=I,e.$Ow=(0,O.$Ki)("editorProgressService")}),define(Re[37],Ce([1,0,67,17]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=void 0,s=Ue(s),h=Ue(h);class D{constructor(){this.a=new Map}add(T,A){s.ok(h.$jg(T)),s.ok(h.$lg(A)),s.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,A)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$zo=new D}),define(Re[116],Ce([1,0,4,182,37]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=void 0,D=Ue(D),e.$Ao={JSONContribution:"base.contributions.json"};function O(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class T{constructor(){this.b=new s.$qe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,I){this.a[O(c)]=I,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(c){const I=this.a[c];return I?(0,h.$ak)(I):void 0}hasSchemaContent(c){return!!this.a[c]}}const A=new T;D.$zo.add(e.$Ao.JSONContribution,A)}),define(Re[72],Ce([1,0,18,4,17,7,47,116,37]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.ConfigurationScope=e.$Eo=e.EditPresentationTypes=void 0,e.$Po=o,e.$Qo=m,e.$Ro=$,e.$So=i,e.$To=a,e.$Uo=t,e.$Vo=r,D=Ue(D),O=Ue(O);var c;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$Eo={Configuration:"base.contributions.configuration"};var I;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho={properties:{},patternProperties:{}},e.$Io={properties:{},patternProperties:{}},e.$Jo={properties:{},patternProperties:{}},e.$Ko={properties:{},patternProperties:{}},e.$Lo="vscode://schemas/settings/resourceLanguage",e.$Mo="vscode://schemas/settings/configurationDefaults";const E=p.$zo.as(A.$Ao.JSONContribution);class f{constructor(){this.a=[],this.i=new Set,this.j=new h.$qe,this.onDidSchemaChange=this.j.event,this.k=new h.$qe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:O.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},E.registerSchema(e.$Lo,this.h),this.z()}registerConfiguration(u,l=!0){this.registerConfigurations([u],l)}registerConfigurations(u,l=!0){const g=new Set;this.r(u,l,g),E.registerSchema(e.$Lo,this.h),this.j.fire(),this.k.fire({properties:g})}deregisterConfigurations(u){const l=new Set;this.s(u,l),E.registerSchema(e.$Lo,this.h),this.j.fire(),this.k.fire({properties:l})}updateConfigurations({add:u,remove:l}){const g=new Set;this.s(l,g),this.r(u,!1,g),E.registerSchema(e.$Lo,this.h),this.j.fire(),this.k.fire({properties:g})}registerDefaultConfigurations(u){const l=new Set;this.l(u,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}l(u,l){this.a.push(...u);const g=[];for(const{overrides:y,source:k}of u)for(const S in y){l.add(S);const R=this.b.get(S)??this.b.set(S,{configurationDefaultOverrides:[]}).get(S),C=y[S];if(R.configurationDefaultOverrides.push({value:C,source:k}),e.$Oo.test(S)){const w=this.o(S,C,k,R.configurationDefaultOverrideValue);if(!w)continue;R.configurationDefaultOverrideValue=w,this.n(S,w,k),g.push(...o(S))}else{const w=this.p(S,C,k,R.configurationDefaultOverrideValue);if(!w)continue;R.configurationDefaultOverrideValue=w;const b=this.e[S];b&&(this.A(S,b),this.w(S,b))}}this.q(g)}deregisterDefaultConfigurations(u){const l=new Set;this.m(u,l),this.j.fire(),this.k.fire({properties:l,defaultsOverrides:!0})}m(u,l){for(const g of u){const y=this.a.indexOf(g);y!==-1&&this.a.splice(y,1)}for(const{overrides:g,source:y}of u)for(const k in g){const S=this.b.get(k);if(!S)continue;const R=S.configurationDefaultOverrides.findIndex(C=>y?C.source?.id===y.id:C.value===g[k]);if(R!==-1){if(S.configurationDefaultOverrides.splice(R,1),S.configurationDefaultOverrides.length===0&&this.b.delete(k),e.$Oo.test(k)){let C;for(const w of S.configurationDefaultOverrides)C=this.o(k,w.value,w.source,C);C&&!D.$wg(C.value)?(S.configurationDefaultOverrideValue=C,this.n(k,C,y)):(this.b.delete(k),delete this.e[k],delete this.c.properties[k])}else{let C;for(const b of S.configurationDefaultOverrides)C=this.p(k,b.value,b.source,C);S.configurationDefaultOverrideValue=C;const w=this.e[k];w&&(this.A(k,w),this.w(k,w))}l.add(k)}}this.y()}n(u,l,g){const y={type:"object",default:l.value,description:O.localize(1663,null,(0,T.$oj)(u)),$ref:e.$Lo,defaultDefaultValue:l.value,source:g,defaultValueSource:g};this.e[u]=y,this.c.properties[u]=y}o(u,l,g,y){const k=y?.value||{},S=y?.source??new Map;if(!(S instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const R of Object.keys(l)){const C=l[R];if(D.$lg(C)&&(D.$qg(k[R])||D.$lg(k[R]))){if(k[R]={...k[R]??{},...C},g)for(const b in C)S.set(`${R}.${b}`,g)}else k[R]=C,g?S.set(R,g):S.delete(R)}return{value:k,source:S}}p(u,l,g,y){const k=this.e[u],S=y?.value??k?.defaultDefaultValue;let R=g;if(D.$lg(l)&&(k!==void 0&&k.type==="object"||k===void 0&&(D.$qg(S)||D.$lg(S)))){if(R=y?.source??new Map,!(R instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const w in l)g&&R.set(`${u}.${w}`,g);l={...D.$lg(S)?S:{},...l}}return{value:l,source:R}}deltaConfiguration(u){let l=!1;const g=new Set;u.removedDefaults&&(this.m(u.removedDefaults,g),l=!0),u.addedDefaults&&(this.l(u.addedDefaults,g),l=!0),u.removedConfigurations&&this.s(u.removedConfigurations,g),u.addedConfigurations&&this.r(u.addedConfigurations,!1,g),this.j.fire(),this.k.fire({properties:g,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...u){this.j.fire()}registerOverrideIdentifiers(u){this.q(u),this.j.fire()}q(u){for(const l of u)this.i.add(l);this.y()}r(u,l,g){u.forEach(y=>{this.u(y,l,y.extensionInfo,y.restrictedProperties,void 0,g),this.d.push(y),this.v(y)})}s(u,l){const g=y=>{if(y.properties)for(const k in y.properties){l.add(k);const S=this.e[k];S?.policy?.name&&this.f.delete(S.policy.name),delete this.e[k],this.x(k,y.properties[k])}y.allOf?.forEach(k=>g(k))};for(const y of u){g(y);const k=this.d.indexOf(y);k!==-1&&this.d.splice(k,1)}}u(u,l=!0,g,y,k=I.WINDOW,S){k=D.$sg(u.scope)?k:u.scope;const R=u.properties;if(R)for(const w in R){const b=R[w];if(l&&i(w,b)){delete R[w];continue}if(b.source=g,b.defaultDefaultValue=R[w].default,this.A(w,b),e.$Oo.test(w)?b.scope=void 0:(b.scope=D.$sg(b.scope)?k:b.scope,b.restricted=D.$sg(b.restricted)?!!y?.includes(w):b.restricted),R[w].hasOwnProperty("included")&&!R[w].included){this.g[w]=R[w],delete R[w];continue}else this.e[w]=R[w],R[w].policy?.name&&this.f.set(R[w].policy.name,w);!R[w].deprecationMessage&&R[w].markdownDeprecationMessage&&(R[w].deprecationMessage=R[w].markdownDeprecationMessage),S.add(w)}const C=u.allOf;if(C)for(const w of C)this.u(w,l,g,y,k,S)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const u=new Map;for(const[l,g]of this.b)g.configurationDefaultOverrideValue&&u.set(l,g.configurationDefaultOverrideValue);return u}v(u){const l=g=>{const y=g.properties;if(y)for(const S in y)this.w(S,y[S]);g.allOf?.forEach(l)};l(u)}w(u,l){switch(e.$Fo.properties[u]=l,l.scope){case I.APPLICATION:e.$Go.properties[u]=l;break;case I.MACHINE:e.$Ho.properties[u]=l;break;case I.MACHINE_OVERRIDABLE:e.$Io.properties[u]=l;break;case I.WINDOW:e.$Jo.properties[u]=l;break;case I.RESOURCE:e.$Ko.properties[u]=l;break;case I.LANGUAGE_OVERRIDABLE:e.$Ko.properties[u]=l,this.h.properties[u]=l;break}}x(u,l){switch(delete e.$Fo.properties[u],l.scope){case I.APPLICATION:delete e.$Go.properties[u];break;case I.MACHINE:delete e.$Ho.properties[u];break;case I.MACHINE_OVERRIDABLE:delete e.$Io.properties[u];break;case I.WINDOW:delete e.$Jo.properties[u];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Ko.properties[u],delete this.h.properties[u];break}}y(){for(const u of this.i.values()){const l=`[${u}]`,g={type:"object",description:O.localize(1664,null),errorMessage:O.localize(1665,null),$ref:e.$Lo};this.A(l,g),e.$Fo.properties[l]=g,e.$Go.properties[l]=g,e.$Ho.properties[l]=g,e.$Io.properties[l]=g,e.$Jo.properties[l]=g,e.$Ko.properties[l]=g}}z(){const u={type:"object",description:O.localize(1666,null),errorMessage:O.localize(1667,null),$ref:e.$Lo};e.$Fo.patternProperties[e.$No]=u,e.$Go.patternProperties[e.$No]=u,e.$Ho.patternProperties[e.$No]=u,e.$Io.patternProperties[e.$No]=u,e.$Jo.patternProperties[e.$No]=u,e.$Ko.patternProperties[e.$No]=u,this.j.fire()}A(u,l){const g=this.b.get(u)?.configurationDefaultOverrideValue;let y,k;g&&(!l.disallowConfigurationDefault||!g.source)&&(y=g.value,k=g.source),D.$qg(y)&&(y=l.defaultDefaultValue,k=void 0),D.$qg(y)&&(y=$(l.type)),l.default=y,l.defaultValueSource=k}}const P="\\[([^\\]]+)\\]",v=new RegExp(P,"g");e.$No=`^(${P})+$`,e.$Oo=new RegExp(e.$No);function o(n){const u=[];if(e.$Oo.test(n)){let l=v.exec(n);for(;l?.length;){const g=l[1].trim();g&&u.push(g),l=v.exec(n)}}return(0,s.$Qb)(u)}function m(n){return n.reduce((u,l)=>`${u}[${l}]`,"")}function $(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new f;p.$zo.add(e.$Eo.Configuration,d);function i(n,u){return n.trim()?e.$Oo.test(n)?O.localize(1669,null,n):d.getConfigurationProperties()[n]!==void 0?O.localize(1670,null,n):u.policy?.name&&d.getPolicyConfigurations().get(u.policy?.name)!==void 0?O.localize(1671,null,n,u.policy?.name,d.getPolicyConfigurations().get(u.policy?.name)):null:O.localize(1668,null)}function a(){const n=[],u=d.getConfigurationProperties();for(const l of Object.keys(u))n.push([l,u[l].scope]);return n.push(["launch",I.RESOURCE]),n.push(["task",I.RESOURCE]),n}function t(n){const u={};for(const l of n){const g=l.properties;if(D.$lg(g))for(const y in g)u[y]=g[y];l.allOf&&Object.assign(u,t(l.allOf))}return u}function r(n){switch(n){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Re[236],Ce([1,0,18,4,181,3,28,24,17,2,47,72,27,37]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$1o=a,s=Ue(s),D=Ue(D),A=Ue(A),p=Ue(p);function v(u){return Object.isFrozen(u)?u:A.$no(u)}class o{static createEmptyModel(l){return new o({},[],[],void 0,l)}constructor(l,g,y,k,S){this.b=l,this.c=g,this.d=y,this.raw=k,this.f=S,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map(g=>{if(g instanceof o)return g;const y=new m("",this.f);return y.parseRaw(g),y.configurationModel});this.g=l.reduce((g,y)=>y===g?y:g.merge(y),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,I.$mj)(this.contents,l):this.contents}inspect(l,g){const y=this;return{get value(){return v(y.rawConfiguration.getValue(l))},get override(){return g?v(y.rawConfiguration.getOverrideValue(l,g)):void 0},get merged(){return v(g?y.rawConfiguration.override(g).getValue(l):y.rawConfiguration.getValue(l))},get overrides(){const k=[];for(const{contents:S,identifiers:R,keys:C}of y.rawConfiguration.overrides){const w=new o(S,C,[],void 0,y.f).getValue(l);w!==void 0&&k.push({identifiers:R,value:w})}return k.length?v(k):void 0}}}getOverrideValue(l,g){const y=this.j(g);return y?l?(0,I.$mj)(y,l):y:void 0}getKeysForOverrideIdentifier(l){const g=[];for(const y of this.overrides)y.identifiers.includes(l)&&g.push(...y.keys);return s.$Qb(g)}getAllOverrideIdentifiers(){const l=[];for(const g of this.overrides)l.push(...g.identifiers);return s.$Qb(l)}override(l){let g=this.a.get(l);return g||(g=this.h(l),this.a.set(l,g)),g}merge(...l){const g=A.$mo(this.contents),y=A.$mo(this.overrides),k=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const R of l)if(S.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(g,R.contents);for(const C of R.overrides){const[w]=y.filter(b=>s.$yb(b.identifiers,C.identifiers));w?(this.i(w.contents,C.contents),w.keys.push(...C.keys),w.keys=s.$Qb(w.keys)):y.push(A.$mo(C))}for(const C of R.keys)k.indexOf(C)===-1&&k.push(C)}return new o(g,k,y,S.every(R=>R instanceof o)?void 0:S,this.f)}h(l){const g=this.j(l);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const y={};for(const k of s.$Qb([...Object.keys(this.contents),...Object.keys(g)])){let S=this.contents[k];const R=g[k];R&&(typeof S=="object"&&typeof R=="object"?(S=A.$mo(S),this.i(S,R)):S=R),y[k]=S}return new o(y,this.keys,this.overrides,void 0,this.f)}i(l,g){for(const y of Object.keys(g)){if(y in l&&p.$lg(l[y])&&p.$lg(g[y])){this.i(l[y],g[y]);continue}l[y]=A.$mo(g[y])}}j(l){let g=null,y=null;const k=S=>{S&&(y?this.i(y,S):y=A.$mo(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===l?g=S.contents:S.identifiers.includes(l)&&k(S.contents);return k(g),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,g){this.k(l,g,!0)}setValue(l,g){this.k(l,g,!1)}removeValue(l){const g=this.keys.indexOf(l);g!==-1&&(this.keys.splice(g,1),(0,I.$lj)(this.contents,l),E.$Oo.test(l)&&this.overrides.splice(this.overrides.findIndex(y=>s.$yb(y.identifiers,(0,E.$Po)(l))),1))}k(l,g,y){if((0,I.$kj)(this.contents,l,g,k=>this.f.error(k)),y=y||this.keys.indexOf(l)===-1,y&&this.keys.push(l),E.$Oo.test(l)){const k=(0,E.$Po)(l),S={identifiers:k,keys:Object.keys(this.contents[l]),contents:(0,I.$jj)(this.contents[l],C=>this.f.error(C))},R=this.overrides.findIndex(C=>s.$yb(C.identifiers,k));R!==-1?this.overrides[R]=S:this.overrides.push(S)}}}e.$Wo=o;class m{constructor(l,g){this.f=l,this.g=g,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||o.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,g){if(!p.$sg(l)){const y=this.h(l);this.parseRaw(y,g)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,g){this.a=l;const{contents:y,keys:k,overrides:S,restricted:R,hasExcludedProperties:C}=this.i(l,g);this.b=new o(y,k,S,C?[l]:void 0,this.g),this.c=R||[]}h(l){let g={},y=null,k=[];const S=[],R=[];function C(b){Array.isArray(k)?k.push(b):y!==null&&(k[y]=b)}const w={onObjectBegin:()=>{const b={};C(b),S.push(k),k=b,y=null},onObjectProperty:b=>{y=b},onObjectEnd:()=>{k=S.pop()},onArrayBegin:()=>{const b=[];C(b),S.push(k),k=b,y=null},onArrayEnd:()=>{k=S.pop()},onLiteralValue:C,onError:(b,N,L)=>{R.push({error:b,offset:N,length:L})}};if(l)try{D.$bo(l,w),g=k[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return g}i(l,g){const y=P.$zo.as(E.$Eo.Configuration).getConfigurationProperties(),k=this.j(l,y,!0,g);l=k.raw;const S=(0,I.$jj)(l,w=>this.g.error(`Conflict in settings file ${this.f}: ${w}`)),R=Object.keys(l),C=this.l(l,w=>this.g.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:S,keys:R,overrides:C,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(l,g,y,k){let S=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:S};const R={},C=[];for(const w in l)if(E.$Oo.test(w)&&y){const b=this.j(l[w],g,!1,k);R[w]=b.raw,S=S||b.hasExcludedProperties,C.push(...b.restricted)}else{const b=g[w],N=b?typeof b.scope<"u"?b.scope:E.ConfigurationScope.WINDOW:void 0;b?.restricted&&C.push(w),!k.exclude?.includes(w)&&(k.include?.includes(w)||(N===void 0||k.scopes===void 0||k.scopes.includes(N))&&!(k.skipRestricted&&b?.restricted))?R[w]=l[w]:S=!0}return{raw:R,restricted:C,hasExcludedProperties:S}}l(l,g){const y=[];for(const k of Object.keys(l))if(E.$Oo.test(k)){const S={};for(const R in l[k])S[R]=l[k][R];y.push({identifiers:(0,E.$Po)(k),keys:Object.keys(S),contents:(0,I.$jj)(S,g)})}return y}}e.$Xo=m;class $ extends O.$Zc{constructor(l,g,y,k,S){super(),this.c=l,this.f=g,this.g=k,this.h=S,this.b=this.B(new h.$qe),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),S),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(f.FileOperation.CREATE)||R.isOperation(f.FileOperation.COPY)||R.isOperation(f.FileOperation.DELETE)||R.isOperation(f.FileOperation.WRITE))&&y.isEqual(R.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return o.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Yo=$;class d{constructor(l,g,y,k,S,R,C,w,b,N,L,M,z){this.a=l,this.b=g,this.c=y,this.overrideIdentifiers=k,this.d=S,this.f=R,this.g=C,this.h=w,this.i=b,this.j=N,this.k=L,this.l=M,this.m=z}get value(){return v(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(l,g,y,k,S,R,C,w,b,N){this.j=l,this.l=g,this.m=y,this.n=k,this.p=S,this.q=R,this.r=C,this.s=w,this.t=b,this.u=N,this.h=null,this.i=new T.$Fc,this.v=null}getValue(l,g,y){return this.w(l,g,y).getValue(l)}updateValue(l,g,y={}){let k;y.resource?(k=this.t.get(y.resource),k||(k=o.createEmptyModel(this.u),this.t.set(y.resource,k))):k=this.s,g===void 0?k.removeValue(l):k.setValue(l,g),y.resource||(this.h=null)}inspect(l,g,y){const k=this.w(l,g,y),S=this.A(g.resource,y),R=g.resource?this.t.get(g.resource)||this.s:this.s,C=new Set;for(const w of k.overrides)for(const b of w.identifiers)k.getOverrideValue(l,b)!==void 0&&C.add(b);return new d(l,g,k.getValue(l),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.q:void 0,S||void 0,R)}keys(l){const g=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,g){this.r.set(l,g),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,g){const y=[];if(!g){const{added:k,updated:S,removed:R}=r(this.j,l);g=[...k,...S,...R]}for(const k of g)for(const S of(0,E.$Po)(k)){const R=this.j.getKeysForOverrideIdentifier(S),C=l.getKeysForOverrideIdentifier(S),w=[...C.filter(b=>R.indexOf(b)===-1),...R.filter(b=>C.indexOf(b)===-1),...R.filter(b=>!A.$qo(this.j.override(S).getValue(b),l.override(S).getValue(b)))];y.push([S,w])}return this.updateDefaultConfiguration(l),{keys:g,overrides:y}}compareAndUpdatePolicyConfiguration(l){const{added:g,updated:y,removed:k}=r(this.l,l),S=[...g,...y,...k];return S.length&&this.updatePolicyConfiguration(l),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:g,updated:y,removed:k,overrides:S}=r(this.applicationConfiguration,l),R=[...g,...y,...k];return R.length&&this.updateApplicationConfiguration(l),{keys:R,overrides:S}}compareAndUpdateLocalUserConfiguration(l){const{added:g,updated:y,removed:k,overrides:S}=r(this.localUserConfiguration,l),R=[...g,...y,...k];return R.length&&this.updateLocalUserConfiguration(l),{keys:R,overrides:S}}compareAndUpdateRemoteUserConfiguration(l){const{added:g,updated:y,removed:k,overrides:S}=r(this.remoteUserConfiguration,l),R=[...g,...y,...k];return R.length&&this.updateRemoteUserConfiguration(l),{keys:R,overrides:S}}compareAndUpdateWorkspaceConfiguration(l){const{added:g,updated:y,removed:k,overrides:S}=r(this.workspaceConfiguration,l),R=[...g,...y,...k];return R.length&&this.updateWorkspaceConfiguration(l),{keys:R,overrides:S}}compareAndUpdateFolderConfiguration(l,g){const y=this.folderConfigurations.get(l),{added:k,updated:S,removed:R,overrides:C}=r(y,g),w=[...k,...S,...R];return(w.length||!y)&&this.updateFolderConfiguration(l,g),{keys:w,overrides:C}}compareAndDeleteFolderConfiguration(l){const g=this.folderConfigurations.get(l);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:y,updated:k,removed:S,overrides:R}=r(g,void 0);return{keys:[...y,...k,...S],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,g,y){let k=this.x(g,y);return g.overrideIdentifier&&(k=k.override(g.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(k=k.merge(this.l)),k}x({resource:l},g){let y=this.y();if(g&&l){const k=g.getFolder(l);k&&(y=this.z(k.uri)||y);const S=this.t.get(l);S&&(y=y.merge(S))}return y}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let g=this.i.get(l);if(!g){const y=this.y(),k=this.r.get(l);k?(g=y.merge(k),this.i.set(l,g)):g=y}return g}A(l,g){if(g&&l){const y=g.getFolder(l);if(y)return this.r.get(y.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,g)=>{const{contents:y,overrides:k,keys:S}=this.r.get(g);return l.push([g,{contents:y,overrides:k,keys:S}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach(g=>l.add(g)),this.userConfiguration.keys.forEach(g=>l.add(g)),this.q.keys.forEach(g=>l.add(g)),this.r.forEach(g=>g.keys.forEach(y=>l.add(y))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.q.getAllOverrideIdentifiers().forEach(g=>l.add(g)),this.r.forEach(g=>g.getAllOverrideIdentifiers().forEach(y=>l.add(y))),[...l.values()]}D(l){const g=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(y=>g.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(y=>g.add(y)),this.q.getKeysForOverrideIdentifier(l).forEach(y=>g.add(y)),this.r.forEach(y=>y.getKeysForOverrideIdentifier(l).forEach(k=>g.add(k))),[...g.values()]}static parse(l,g){const y=this.E(l.defaults,g),k=this.E(l.policy,g),S=this.E(l.application,g),R=this.E(l.user,g),C=this.E(l.workspace,g),w=l.folders.reduce((b,N)=>(b.set(c.URI.revive(N[0]),this.E(N[1],g)),b),new T.$Fc);return new i(y,k,S,R,o.createEmptyModel(g),C,w,o.createEmptyModel(g),new T.$Fc,g)}static E(l,g){return new o(l.contents,l.keys,l.overrides,void 0,g)}}e.$Zo=i;function a(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const l=new Set,g=new Map;for(const k of u)k.keys.forEach(S=>l.add(S)),k.overrides.forEach(([S,R])=>{const C=(0,T.$Cc)(g,S,new Set);R.forEach(w=>C.add(w))});const y=[];return g.forEach((k,S)=>y.push([S,[...k.values()]])),{keys:[...l.values()],overrides:y}}class t{constructor(l,g,y,k,S){this.change=l,this.f=g,this.g=y,this.h=k,this.i=S,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of l.keys)this.affectedKeys.add(R);for(const[,R]of l.overrides)for(const C of R)this.affectedKeys.add(C);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,g){const y=this.a+l,k=this.d.indexOf(y);if(k<0)return!1;const S=k+y.length;if(S>=this.d.length)return!1;const R=this.d.charCodeAt(S);if(R!==this.b&&R!==this.c)return!1;if(g){const C=this.previousConfiguration?this.previousConfiguration.getValue(l,g,this.f?.workspace):void 0,w=this.g.getValue(l,g,this.h);return!A.$qo(C,w)}return!0}}e.$2o=t;function r(u,l){const{added:g,removed:y,updated:k}=n(l?.rawConfiguration,u?.rawConfiguration),S=[],R=u?.getAllOverrideIdentifiers()||[],C=l?.getAllOverrideIdentifiers()||[];if(l){const w=C.filter(b=>!R.includes(b));for(const b of w)S.push([b,l.getKeysForOverrideIdentifier(b)])}if(u){const w=R.filter(b=>!C.includes(b));for(const b of w)S.push([b,u.getKeysForOverrideIdentifier(b)])}if(l&&u){for(const w of R)if(C.includes(w)){const b=n({contents:u.getOverrideValue(void 0,w)||{},keys:u.getKeysForOverrideIdentifier(w)},{contents:l.getOverrideValue(void 0,w)||{},keys:l.getKeysForOverrideIdentifier(w)});S.push([w,[...b.added,...b.removed,...b.updated]])}}return{added:g,removed:y,updated:k,overrides:S}}function n(u,l){const g=u?l?u.keys.filter(S=>l.keys.indexOf(S)===-1):[...u.keys]:[],y=l?u?l.keys.filter(S=>u.keys.indexOf(S)===-1):[...l.keys]:[],k=[];if(u&&l){for(const S of l.keys)if(u.keys.indexOf(S)!==-1){const R=(0,I.$mj)(l.contents,S),C=(0,I.$mj)(u.contents,S);A.$qo(R,C)||k.push(S)}}return{added:g,removed:y,updated:k}}}),define(Re[237],Ce([1,0,21,4,3,70]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xzb=e.$Vzb=e.$Uzb=void 0,e.$Wzb=A;const T=(c,I,E)=>{const f=new Uint8Array(16);for(let o=0;o<16;o++)f[o]=Math.round(Math.random()*256);const P=(0,s.$af)(s.$Se.wrap(f));return[`GET ws://localhost${c}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.$Uzb=T,e.$Vzb=s.$Se.fromString(`\r
\r
`);async function A(c,I,E,f,P){c.write(s.$Se.fromString((0,e.$Uzb)(I,E,f)));const v=new D.$Yc;try{return await new Promise((o,m)=>{let $;v.add(c.onData(d=>{$?$=s.$Se.concat([$,d],$.byteLength+d.byteLength):$=d;const i=$.indexOf(e.$Vzb);if(i===-1)return;o(c),c.pauseData();const a=$.slice(i+e.$Vzb.byteLength);a.byteLength&&P.onData.fire(a)})),v.add(c.onClose(d=>m(d??new Error("socket closed")))),v.add(c.onEnd(()=>m(new Error("socket ended"))))})}catch(o){throw c.dispose(),o}finally{v.dispose()}}class p extends D.$Zc{constructor(I,E){super(),this.g=I,this.a=this.B(new h.$te),this.onData=(...f)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...f)),this.b=this.B(new h.$qe),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(f=>this.a.fire(f))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,E){O.SocketDiagnostics.traceSocketEvent(this,this.g,I,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Xzb=p}),define(Re[73],Ce([1,0,12,5]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.RemoteAuthorityResolverErrorCode=e.$Yl=e.$Xl=e.RemoteConnectionType=e.$Wl=void 0,e.$1l=c,e.$Wl=(0,h.$Ki)("remoteAuthorityResolverService");var D;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(D||(e.RemoteConnectionType=D={}));class O{constructor(E){this.id=E,this.type=D.Managed}toString(){return`Managed(${this.id})`}}e.$Xl=O;class T{constructor(E,f){this.host=E,this.port=f,this.type=D.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Yl=T;var A;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(A||(e.RemoteAuthorityResolverErrorCode=A={}));class p extends s.$fb{static isNotAvailable(E){return E instanceof p&&E._code===A.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof p&&E._code===A.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof p&&E._code===A.NoResolverFound}static isInvalidAuthority(E){return E instanceof p&&E._code===A.InvalidAuthority}static isHandled(E){return E instanceof p&&E.isHandled}constructor(E,f=A.Unknown,P){super(E),this._message=E,this._code=f,this._detail=P,this.isHandled=f===A.NotAvailable&&P===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Zl=p;function c(I){const E=I.indexOf("+");return E===-1?I:I.substring(0,E)}}),define(Re[238],Ce([1,0,8,21,20,12,4,3,14,63,44,31,70,73]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$6l=S,e.$7l=R,e.$8l=w,c=Ue(c);const v=30*1e3;var o;(function(ce){ce[ce.Management=1]="Management",ce[ce.ExtensionHost=2]="ExtensionHost",ce[ce.Tunnel=3]="Tunnel"})(o||(e.ConnectionType=o={}));function m(ce){switch(ce){case o.Management:return"Management";case o.ExtensionHost:return"ExtensionHost";case o.Tunnel:return"Tunnel"}}function $(ce){const Y=new D.$Be;return setTimeout(()=>Y.cancel(),ce),Y.token}function d(ce,Y){if(ce.isCancellationRequested||Y.isCancellationRequested)return D.CancellationToken.Cancelled;const q=new D.$Be;return ce.onCancellationRequested(()=>q.cancel()),Y.onCancellationRequested(()=>q.cancel()),q.token}class i{get didTimeout(){return this.c==="timedout"}constructor(Y){this.c="pending",this.d=new A.$Yc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,s.$Dh)(),Y.isCancellationRequested?this.h():this.d.add(Y.onCancellationRequested(()=>this.h()))}registerDisposable(Y){this.c==="pending"?this.d.add(Y):Y.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Y=new Error("Time limit reached");return Y.code="ETIMEDOUT",Y.syscall="connect",Y}resolve(Y){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Y))}reject(Y){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Y))}}function a(ce,Y){const q=new i(Y);return q.registerDisposable(ce.onControlMessage(se=>{const be=JSON.parse(se.toString()),ae=U(be);ae?q.reject(ae):q.resolve(be)})),q.promise}function t(ce,Y,q,se,be,ae,we,$e){const pe=new i($e),Oe=I.$ke.create(!1);return ce.info(`Creating a socket (${we})...`),c.mark(`code/willCreateSocket/${ae}`),Y.connect(q,se,be,we).then(Fe=>{pe.didTimeout?(c.mark(`code/didCreateSocketError/${ae}`),ce.info(`Creating a socket (${we}) finished after ${Oe.elapsed()} ms, but this is too late and has timed out already.`),Fe?.dispose()):(c.mark(`code/didCreateSocketOK/${ae}`),ce.info(`Creating a socket (${we}) was successful after ${Oe.elapsed()} ms.`),pe.resolve(Fe))},Fe=>{c.mark(`code/didCreateSocketError/${ae}`),ce.info(`Creating a socket (${we}) returned an error after ${Oe.elapsed()} ms.`),ce.error(Fe),pe.reject(Fe)}),pe.promise}function r(ce,Y){const q=new i(Y);return ce.then(se=>{q.didTimeout||q.resolve(se)},se=>{q.didTimeout||q.reject(se)}),q.promise}async function n(ce,Y,q,se){const be=te(ce,Y);ce.logService.trace(`${be} 1/6. invoking socketFactory.connect().`);let ae;try{ae=await t(ce.logService,ce.remoteSocketFactoryService,ce.connectTo,p.$Xg.getServerRootPath(),`reconnectionToken=${ce.reconnectionToken}&reconnection=${ce.reconnectionProtocol?"true":"false"}`,m(Y),`renderer-${m(Y)}-${ce.reconnectionToken}`,se)}catch(Fe){throw ce.logService.error(`${be} socketFactory.connect() failed or timed out. Error:`),ce.logService.error(Fe),Fe}ce.logService.trace(`${be} 2/6. socketFactory.connect() was successful.`);let we,$e;ce.reconnectionProtocol?(ce.reconnectionProtocol.beginAcceptReconnection(ae,null),we=ce.reconnectionProtocol,$e=!1):(we=new f.$yi({socket:ae}),$e=!0),ce.logService.trace(`${be} 3/6. sending AuthRequest control message.`);const pe=await r(ce.signService.createNewMessage((0,E.$7g)()),se),Oe={type:"auth",auth:ce.connectionToken||"00000000000000000000",data:pe.data};we.sendControl(h.$Se.fromString(JSON.stringify(Oe)));try{const Fe=await a(we,d(se,$(1e4)));if(Fe.type!=="sign"||typeof Fe.data!="string"){const je=new Error("Unexpected handshake message");throw je.code="VSCODE_CONNECTION_ERROR",je}if(ce.logService.trace(`${be} 4/6. received SignRequest control message.`),!await r(ce.signService.validate(pe,Fe.signedData),se)){const je=new Error("Refused to connect to unsupported server");throw je.code="VSCODE_CONNECTION_ERROR",je}const Ze=await r(ce.signService.sign(Fe.data),se),xe={type:"connectionType",commit:ce.commit,signedData:Ze,desiredConnectionType:Y};return q&&(xe.args=q),ce.logService.trace(`${be} 5/6. sending ConnectionTypeRequest control message.`),we.sendControl(h.$Se.fromString(JSON.stringify(xe))),{protocol:we,ownsProtocol:$e}}catch(Fe){throw Fe&&Fe.code==="ETIMEDOUT"&&(ce.logService.error(`${be} the handshake timed out. Error:`),ce.logService.error(Fe)),Fe&&Fe.code==="VSCODE_CONNECTION_ERROR"&&(ce.logService.error(`${be} received error control message when negotiating connection. Error:`),ce.logService.error(Fe)),$e&&B(we),Fe}}async function u(ce,Y,q,se){const be=Date.now(),ae=te(ce,Y),{protocol:we,ownsProtocol:$e}=await n(ce,Y,q,se),pe=new i(se);return pe.registerDisposable(we.onControlMessage(Oe=>{const Fe=JSON.parse(Oe.toString()),He=U(Fe);He?(ce.logService.error(`${ae} received error control message when negotiating connection. Error:`),ce.logService.error(He),$e&&B(we),pe.reject(He)):(ce.reconnectionProtocol?.endAcceptReconnection(),ce.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${me(be)}!`),pe.resolve({protocol:we,firstMessage:Fe}))})),pe.promise}async function l(ce,Y){const{protocol:q}=await u(ce,o.Management,void 0,Y);return{protocol:q}}async function g(ce,Y,q){const{protocol:se,firstMessage:be}=await u(ce,o.ExtensionHost,Y,q),ae=be&&be.debugPort;return{protocol:se,debugPort:ae}}async function y(ce,Y,q){const se=Date.now(),be=te(ce,o.Tunnel),{protocol:ae}=await n(ce,o.Tunnel,Y,q);return ce.logService.trace(`${be} 6/6. handshake finished, connection is up and running after ${me(se)}!`),ae}async function k(ce,Y,q){const{connectTo:se,connectionToken:be}=await ce.addressProvider.getAddress();return{commit:ce.commit,quality:ce.quality,connectTo:se,connectionToken:be,reconnectionToken:Y,reconnectionProtocol:q,remoteSocketFactoryService:ce.remoteSocketFactoryService,signService:ce.signService,logService:ce.logService}}async function S(ce,Y,q){return C(ce,async se=>{const{protocol:be}=await l(se,D.CancellationToken.None);return new W(ce,Y,q,se.reconnectionToken,be)})}async function R(ce,Y){return C(ce,async q=>{const{protocol:se,debugPort:be}=await g(q,Y,D.CancellationToken.None);return new J(ce,Y,q.reconnectionToken,se,be)})}async function C(ce,Y){for(let se=1;;se++)try{const be=(0,E.$7g)(),ae=await k(ce,be,null);return await Y(ae)}catch(be){if(se<5)ce.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),ce.logService.error(be);else throw ce.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ce.logService.error(be),j.triggerPermanentFailure(0,0,P.$Zl.isHandled(be)),be}}async function w(ce,Y,q){const se=await k(ce,(0,E.$7g)(),null);return await y(se,{host:Y,port:q},D.CancellationToken.None)}function b(ce){return(0,s.$xh)(Y=>new Promise((q,se)=>{const be=setTimeout(q,ce*1e3);Y.onCancellationRequested(()=>{clearTimeout(be),q()})}))}var N;(function(ce){ce[ce.ConnectionLost=0]="ConnectionLost",ce[ce.ReconnectionWait=1]="ReconnectionWait",ce[ce.ReconnectionRunning=2]="ReconnectionRunning",ce[ce.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ce[ce.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class L{constructor(Y,q){this.reconnectionToken=Y,this.millisSinceLastIncomingData=q,this.type=N.ConnectionLost}}e.$9l=L;class M{constructor(Y,q,se,be){this.reconnectionToken=Y,this.millisSinceLastIncomingData=q,this.durationSeconds=se,this.c=be,this.type=N.ReconnectionWait}skipWait(){this.c.cancel()}}e.$0l=M;class z{constructor(Y,q,se){this.reconnectionToken=Y,this.millisSinceLastIncomingData=q,this.attempt=se,this.type=N.ReconnectionRunning}}e.$$l=z;class V{constructor(Y,q,se){this.reconnectionToken=Y,this.millisSinceLastIncomingData=q,this.attempt=se,this.type=N.ConnectionGain}}e.$_l=V;class F{constructor(Y,q,se,be){this.reconnectionToken=Y,this.millisSinceLastIncomingData=q,this.attempt=se,this.handled=be,this.type=N.ReconnectionPermanentFailure}}e.$am=F;class j extends A.$Zc{static triggerPermanentFailure(Y,q,se){this._permanentFailure=!0,this.f=Y,this.g=q,this.h=se,this.j.forEach(be=>be.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Y=>Y.y())}static debugPauseSocketWriting(){this.j.forEach(Y=>Y.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||j._permanentFailure}constructor(Y,q,se,be,ae){super(),this.t=Y,this.u=q,this.reconnectionToken=se,this.protocol=be,this.w=ae,this.m=this.B(new T.$qe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new V(this.reconnectionToken,0,0)),this.B(be.onSocketClose(we=>{const $e=oe(this.t,this.reconnectionToken,!0);we?we.type===f.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${$e} received socket close event (hadError: ${we.hadError}).`),we.error&&this.u.logService.error(we.error)):(this.u.logService.info(`${$e} received socket close event (wasClean: ${we.wasClean}, code: ${we.code}, reason: ${we.reason}).`),we.event&&this.u.logService.error(we.event)):this.u.logService.info(`${$e} received socket close event.`),this.y()})),this.B(be.onSocketTimeout(we=>{const $e=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${$e} received socket timeout event (unacknowledgedMsgCount: ${we.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${we.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${we.timeSinceLastReceivedSomeData}).`),this.y()})),j.j.push(this),this.B((0,A.$Xc)(()=>{const we=j.j.indexOf(this);we>=0&&j.j.splice(we,1)})),this.n&&this.D(j.f,j.g,j.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Y=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Y} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const q=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const be=se<q.length?q[se]:q[q.length-1];try{if(be>0){const we=b(be);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be,we)),this.u.logService.info(`${Y} waiting for ${be} seconds before reconnecting...`);try{await we}catch{}}if(this.n){this.u.logService.error(`${Y} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${Y} resolving connection...`);const ae=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Y} connecting to ${ae.connectTo}...`),await this.G(ae,$(v)),this.u.logService.info(`${Y} reconnected!`),this.m.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(ae){if(ae.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Y} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${Y} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(P.$Zl.isTemporarilyNotAvailable(ae)){this.u.logService.info(`${Y} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if((ae.code==="ETIMEDOUT"||ae.code==="ENETUNREACH"||ae.code==="ECONNREFUSED"||ae.code==="ECONNRESET")&&ae.syscall==="connect"){this.u.logService.info(`${Y} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if((0,O.$8)(ae)){this.u.logService.info(`${Y} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if(ae instanceof P.$Zl){this.u.logService.error(`${Y} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,P.$Zl.isHandled(ae));break}this.u.logService.error(`${Y} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(Y,q,se){this.w?j.triggerPermanentFailure(Y,q,se):this.D(Y,q,se)}D(Y,q,se){this.m.fire(new F(this.reconnectionToken,Y,q,se)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$bm=j;class W extends j{constructor(Y,q,se,be,ae){super(o.Management,Y,be,ae,!0),this.client=this.B(new f.$wi(ae,{remoteAuthority:q,clientId:se},Y.ipcLogger))}async G(Y,q){await l(Y,q)}}e.$cm=W;class J extends j{constructor(Y,q,se,be,ae){super(o.ExtensionHost,Y,se,be,!1),this.H=q,this.debugPort=ae}async G(Y,q){await g(Y,this.H,q)}}e.$dm=J;function B(ce){try{ce.acceptDisconnect();const Y=ce.getSocket();ce.dispose(),Y.dispose()}catch(Y){(0,O.$4)(Y)}}function U(ce){if(ce&&ce.type==="error"){const Y=new Error(`Connection error: ${ce.reason}`);return Y.code="VSCODE_CONNECTION_ERROR",Y}return null}function _(ce,Y){for(;ce.length<Y;)ce+=" ";return ce}function x(ce,Y){return`[remote-connection][${_(m(ce),13)}][${Y.substr(0,5)}\u2026]`}function oe(ce,Y,q){return`${x(ce,Y)}[${q?"reconnect":"initial"}]`}function te(ce,Y){return`${oe(Y,ce.reconnectionToken,!!ce.reconnectionProtocol)}[${ce.connectTo}]`}function me(ce){return`${Date.now()-ce} ms`}}),define(Re[91],Ce([1,0,14]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=h,e.$qn=D,e.$rn=O,e.$sn=T;function h(p){return p.scheme===s.Schemas.vscodeRemote?p.authority:void 0}function D(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function O(p){const{host:c,port:I}=A(p);if(typeof I>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:I}}function T(p,c){let{host:I,port:E}=A(p);return typeof E>"u"&&(E=c),{host:I,port:E}}function A(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const E=p.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:p,port:void 0}}}),define(Re[23],Ce([1,0,13,5,91]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=e.$Bn=e.$An=e.$zn=e.TargetPlatform=e.ExtensionType=e.$yn=e.$wn=e.$vn=e.$un=e.$tn=void 0,e.$xn=O,e.$Cn=E,e.$Dn=f,e.$En=P,e.$Fn=v,e.$Gn=o,e.$Hn=m,s=Ue(s),e.$tn="extensions.user.cache",e.$un="extensions.builtin.cache",e.$vn="undefined_publisher",e.$wn=["ui","workspace","web"];function O($){if(typeof $=="object"&&$!==null&&$.supported!==!0)return $.description}e.$yn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function($){$[$.System=0]="System",$[$.User=1]="User"})(T||(e.ExtensionType=T={}));var A;(function($){$.WIN32_X64="win32-x64",$.WIN32_ARM64="win32-arm64",$.LINUX_X64="linux-x64",$.LINUX_ARM64="linux-arm64",$.LINUX_ARMHF="linux-armhf",$.ALPINE_X64="alpine-x64",$.ALPINE_ARM64="alpine-arm64",$.DARWIN_X64="darwin-x64",$.DARWIN_ARM64="darwin-arm64",$.WEB="web",$.UNIVERSAL="universal",$.UNKNOWN="unknown",$.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class p{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,i){if(typeof d>"u"||d===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof d=="string"||typeof i=="string"){const a=typeof d=="string"?d:d.value,t=typeof i=="string"?i:i.value;return s.$Kf(a,t)}return d._lower===i._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$zn=p;class c{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const i of d)this.add(i)}add(d){this.c.add(p.toKey(d))}delete(d){return this.c.delete(p.toKey(d))}has(d){return this.c.has(p.toKey(d))}}e.$An=c;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(p.toKey(d))}get(d){return this.c.get(p.toKey(d))}has(d){return this.c.has(p.toKey(d))}set(d,i){this.c.set(p.toKey(d),i)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Bn=I;function E($){return f($)}function f($){return $.contributes&&$.contributes.localizations?$.contributes.localizations.length>0:!1}function P($){return $.contributes&&$.contributes.authentication?$.contributes.authentication.length>0:!1}function v($,d){if(d){const i=`onResolveRemoteAuthority:${(0,D.$qn)(d)}`;return!!$.activationEvents?.includes(i)}return!1}function o($){return $.map(d=>{const[i,a]=d.split("@");return{proposalName:i,version:a?parseInt(a):void 0}})}function m($){return $.map(d=>d.split("@")[0])}e.$In=(0,h.$Ki)("IBuiltinExtensionsScannerService")}),define(Re[151],Ce([1,0,10,7,23,5]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.ExtensionManagementErrorCode=e.$up=e.ExtensionGalleryErrorCode=e.$tp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=void 0,e.$np=A,e.$op=p,e.$pp=c,e.$qp=I,e.$rp=E,e.$sp=f,e.$gp="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$hp=new RegExp(e.$gp),e.$ip="__web_extension",e.$jp="skipWalkthrough",e.$kp="extensionInstallSource",e.$lp="dependecyOrPackExtensionInstall",e.$mp="clientTargetPlatform";var T;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function A(t){switch(t){case D.TargetPlatform.WIN32_X64:return"Windows 64 bit";case D.TargetPlatform.WIN32_ARM64:return"Windows ARM";case D.TargetPlatform.LINUX_X64:return"Linux 64 bit";case D.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case D.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case D.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case D.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case D.TargetPlatform.DARWIN_X64:return"Mac";case D.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case D.TargetPlatform.WEB:return"Web";case D.TargetPlatform.UNIVERSAL:return D.TargetPlatform.UNIVERSAL;case D.TargetPlatform.UNKNOWN:return D.TargetPlatform.UNKNOWN;case D.TargetPlatform.UNDEFINED:return D.TargetPlatform.UNDEFINED}}function p(t){switch(t){case D.TargetPlatform.WIN32_X64:return D.TargetPlatform.WIN32_X64;case D.TargetPlatform.WIN32_ARM64:return D.TargetPlatform.WIN32_ARM64;case D.TargetPlatform.LINUX_X64:return D.TargetPlatform.LINUX_X64;case D.TargetPlatform.LINUX_ARM64:return D.TargetPlatform.LINUX_ARM64;case D.TargetPlatform.LINUX_ARMHF:return D.TargetPlatform.LINUX_ARMHF;case D.TargetPlatform.ALPINE_X64:return D.TargetPlatform.ALPINE_X64;case D.TargetPlatform.ALPINE_ARM64:return D.TargetPlatform.ALPINE_ARM64;case D.TargetPlatform.DARWIN_X64:return D.TargetPlatform.DARWIN_X64;case D.TargetPlatform.DARWIN_ARM64:return D.TargetPlatform.DARWIN_ARM64;case D.TargetPlatform.WEB:return D.TargetPlatform.WEB;case D.TargetPlatform.UNIVERSAL:return D.TargetPlatform.UNIVERSAL;default:return D.TargetPlatform.UNKNOWN}}function c(t,r){switch(t){case s.Platform.Windows:return r==="x64"?D.TargetPlatform.WIN32_X64:r==="arm64"?D.TargetPlatform.WIN32_ARM64:D.TargetPlatform.UNKNOWN;case s.Platform.Linux:return r==="x64"?D.TargetPlatform.LINUX_X64:r==="arm64"?D.TargetPlatform.LINUX_ARM64:r==="arm"?D.TargetPlatform.LINUX_ARMHF:D.TargetPlatform.UNKNOWN;case"alpine":return r==="x64"?D.TargetPlatform.ALPINE_X64:r==="arm64"?D.TargetPlatform.ALPINE_ARM64:D.TargetPlatform.UNKNOWN;case s.Platform.Mac:return r==="x64"?D.TargetPlatform.DARWIN_X64:r==="arm64"?D.TargetPlatform.DARWIN_ARM64:D.TargetPlatform.UNKNOWN;case s.Platform.Web:return D.TargetPlatform.WEB}}function I(t,r){return r===D.TargetPlatform.WEB&&!t.includes(D.TargetPlatform.WEB)}function E(t,r,n){return I(r,n)?!1:t===D.TargetPlatform.UNDEFINED||t===D.TargetPlatform.UNIVERSAL?!0:t===D.TargetPlatform.UNKNOWN?!1:t===n}function f(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var P;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var v;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var o;(function(t){t.Install="install",t.Uninstall="uninstall"})(o||(e.StatisticType=o={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$tp=(0,O.$Ki)("extensionGalleryService");var $;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})($||(e.ExtensionGalleryErrorCode=$={}));class d extends Error{constructor(r,n){super(r),this.code=n,this.name=n}}e.$up=d;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class a extends Error{constructor(r,n){super(r),this.code=n,this.name=n}}e.$vp=a,e.$wp=(0,O.$Ki)("extensionManagementService"),e.$xp="extensionsIdentifiers/disabled",e.$yp="extensionsIdentifiers/enabled",e.$zp=(0,O.$Ki)("IGlobalExtensionEnablementService"),e.$Ap=(0,O.$Ki)("IExtensionTipsService"),e.$Bp=(0,h.localize2)(1781,"Extensions"),e.$Cp=(0,h.localize2)(1782,"Preferences")}),define(Re[152],Ce([1,0,12,23]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jH=e.$iH=void 0;class D{constructor(){this.a=new Map,this.b=new WeakMap}register(T,A){this.a.set(T,A)}readActivationEvents(T){return this.b.has(T)||this.b.set(T,this.c(T)),this.b.get(T)}createActivationEventsMap(T){const A=Object.create(null);for(const p of T){const c=this.readActivationEvents(p);c.length>0&&(A[h.$zn.toKey(p.identifier)]=c)}return A}c(T){if(typeof T.main>"u"&&typeof T.browser>"u")return[];const A=Array.isArray(T.activationEvents)?T.activationEvents.slice(0):[];for(let p=0;p<A.length;p++)A[p]==="onUri"&&(A[p]=`onUri:${h.$zn.toKey(T.identifier)}`);if(!T.contributes)return A;for(const p in T.contributes){const c=this.a.get(p);if(!c)continue;const I=T.contributes[p],E=Array.isArray(I)?I:[I];try{c(E,A)}catch(f){(0,s.$4)(f)}}return A}}e.$iH=D,e.$jH=new D});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[239],Ce([1,0,22,45,7,363,23,148]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=I,e.$9p=E,e.$0p=f,e.$$p=P,e.$_p=v,e.$aq=o,e.$bq=m,e.$cq=$,h=Ht(h),D=Ue(D),O=Ue(O);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function I(a){return a=a.trim(),a==="*"||p.test(a)}function E(a){if(!I(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=a.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function f(a){if(!a)return null;const t=a.majorBase,r=a.majorMustEqual,n=a.minorBase;let u=a.minorMustEqual;const l=a.patchBase;let g=a.patchMustEqual;a.hasCaret&&(t===0||(u=!1),g=!1);let y=0;if(a.preRelease){const k=c.exec(a.preRelease);if(k){const[,S,R,C]=k;y=Date.UTC(Number(S),Number(R)-1,Number(C))}}return{majorBase:t,majorMustEqual:r,minorBase:n,minorMustEqual:u,patchBase:l,patchMustEqual:g,isMinimum:a.hasGreaterEquals,notBefore:y}}function P(a,t,r){let n;typeof a=="string"?n=f(E(a)):n=a;let u;t instanceof Date?u=t.getTime():typeof t=="string"&&(u=new Date(t).getTime());let l;if(typeof r=="string"?l=f(E(r)):l=r,!n||!l)return!1;const g=n.majorBase,y=n.minorBase,k=n.patchBase;let S=l.majorBase,R=l.minorBase,C=l.patchBase;const w=l.notBefore;let b=l.majorMustEqual,N=l.minorMustEqual,L=l.patchMustEqual;return l.isMinimum?g>S?!0:g<S?!1:y>R?!0:y<R||u&&u<w?!1:k>=C:(g===1&&S===0&&(!b||!N||!L)&&(S=1,R=0,C=0,b=!0,N=!1,L=!1),g<S?!1:g>S?!b:y<R?!1:y>R?!N:k<C?!1:k>C?!L:!(u&&u<w))}function v(a,t,r,n,u,l){const g=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return g.push([h.default.Error,D.localize(1833,null)]),g;if(typeof n.name!="string")return g.push([h.default.Error,D.localize(1834,null,"name")]),g;if(typeof n.version!="string")return g.push([h.default.Error,D.localize(1835,null,"version")]),g;if(!n.engines)return g.push([h.default.Error,D.localize(1836,null,"engines")]),g;if(typeof n.engines.vscode!="string")return g.push([h.default.Error,D.localize(1837,null,"engines.vscode")]),g;if(typeof n.extensionDependencies<"u"&&!i(n.extensionDependencies))return g.push([h.default.Error,D.localize(1838,null,"extensionDependencies")]),g;if(typeof n.activationEvents<"u"){if(!i(n.activationEvents))return g.push([h.default.Error,D.localize(1839,null,"activationEvents")]),g;if(typeof n.main>"u"&&typeof n.browser>"u")return g.push([h.default.Error,D.localize(1840,null,"activationEvents","main","browser")]),g}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&g.push([h.default.Warning,D.localize(1841,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return g.push([h.default.Error,D.localize(1842,null,"main")]),g;{const S=(0,s.$lh)(r,n.main);(0,s.$fh)(S,r)||g.push([h.default.Warning,D.localize(1843,null,S.path,r.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return g.push([h.default.Error,D.localize(1844,null,"browser")]),g;{const S=(0,s.$lh)(r,n.browser);(0,s.$fh)(S,r)||g.push([h.default.Warning,D.localize(1845,null,S.path,r.path)])}}if(!O.valid(n.version))return g.push([h.default.Error,D.localize(1846,null)]),g;const y=[];if(!o(a,t,n,u,y))for(const S of y)g.push([h.default.Error,S]);if(l&&n.enabledApiProposals?.length){const S=[];if(!$([...n.enabledApiProposals],S))for(const R of S)g.push([h.default.Error,R])}return g}function o(a,t,r,n,u){return n||typeof r.main>"u"&&typeof r.browser>"u"?!0:d(a,t,r.engines.vscode,u)}function m(a,t,r){return a==="*"||d(t,r,a)}function $(a,t){if(a.length===0)return!0;const r=Array.isArray(t)?t:void 0,n=(r?void 0:t)??A.allApiProposals,u=[],l=(0,T.$Gn)(a);for(const{proposalName:g,version:y}of l){const k=n[g];k&&y&&k.version!==y&&u.push(D.localize(1847,null,g))}return r?.push(...u),u.length===0}function d(a,t,r,n=[]){const u=f(E(r));if(!u)return n.push(D.localize(1848,null,r)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return n.push(D.localize(1849,null,r)),!1}else if(!u.majorMustEqual)return n.push(D.localize(1850,null,r)),!1;return P(a,t,u)?!0:(n.push(D.localize(1851,null,a,r)),!1)}function i(a){if(!Array.isArray(a))return!1;for(let t=0,r=a.length;t<r;t++)if(typeof a[t]!="string")return!1;return!0}}),define(Re[240],Ce([1,0,3,5]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=void 0,e.$2l=(0,h.$Ki)("remoteSocketFactoryService");class D{constructor(){this.a={}}register(T,A){return this.a[T]??=[],this.a[T].push(A),(0,s.$Xc)(()=>{const p=this.a[T]?.indexOf(A);typeof p=="number"&&p>=0&&this.a[T]?.splice(p,1)})}b(T){return(this.a[T.type]||[]).find(p=>p.supports(T))}connect(T,A,p,c){const I=this.b(T);if(!I)throw new Error(`No socket factory found for ${T}`);return I.connect(T,A,p,c)}}e.$3l=D}),define(Re[241],Ce([1,0,21,12,3,7,72,5,11,37]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0,e.$fq=f,e.$gq=P,e.$hq=v,e.$iq=o,e.$jq=m,e.$kq=$,e.$dq=(0,A.$Ki)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const r in this.b)r.toLowerCase()==="authorization"||r.toLowerCase()==="proxy-authorization"?t[r]="*****":t[r]=this.b[r];this.a=t}return this.a}}class E extends D.$Zc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,O.localize)(2051,null),when:p.$xk.isEqualTo((0,p.$uk)(p.LogLevel.Trace)).serialize()})}async c(t,r,n){const u=`${t} #${++this.b}: ${r.url}`;this.a.trace(`${u} - begin`,r.type,new I(r.headers??{}));try{const l=await n();return this.a.trace(`${u} - end`,r.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${u} - error`,r.type,(0,h.$bb)(l)),l}}}e.$eq=E;function f(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}function P(a){return a.res.statusCode===204}async function v(a){return P(a)?null:(await(0,s.$5e)(a.stream)).toString()}async function o(a){if(!f(a))throw new Error("Server returned "+a.res.statusCode);return v(a)}async function m(a){if(!f(a))throw new Error("Server returned "+a.res.statusCode);if(P(a))return null;const r=(await(0,s.$5e)(a.stream)).toString();try{return JSON.parse(r)}catch(n){throw n.message+=`:
`+r,n}}function $(a){i(a)}let d;function i(a){const t=c.$zo.as(T.$Eo.Configuration),r=d;d={id:"http",order:15,title:(0,O.localize)(2052,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2053,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(2054,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(2055,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,O.localize)(2056,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(2057,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(2058,null),(0,O.localize)(2059,null),(0,O.localize)(2060,null),(0,O.localize)(2061,null)],default:"override",description:(0,O.localize)(2062,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(2063,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(2064,null),restricted:!0}}},t.updateConfigurations({add:[d],remove:r?[r]:[]})}i(T.ConfigurationScope.APPLICATION)}),define(Re[242],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class s{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(D){try{const O=await this.c();if(O){const T=String(s.a++);return this.b.set(T,O),{id:T,data:O.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,O){if(!D.id)return!0;const T=this.b.get(D.id);if(!T)return!1;this.b.delete(D.id);try{return T.validate(O)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(D){try{return await this.d(D)}catch{}return D}}e.$jec=s}),define(Re[117],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=void 0,e.$4l="signService",e.$5l=(0,s.$Ki)(e.$4l)}),define(Re[153],Ce([1,0,145,242]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=void 0;class D extends h.$jec{c(){return this.h().then(T=>new T.validator)}d(T){return this.h().then(A=>new A.signer().sign(T))}async h(){return(0,s.$Bq)("vsda","index.js")}}e.$sjc=D}),define(Re[243],Ce([1,0,10,57,31]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=T,e.$Ep=A;function O(p){if(s.$x===s.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function T(p,c,I,E,f,P,v,o,m,$){const d=Object.create(null);d["common.machineId"]=P,d["common.sqmId"]=v,d["common.devDeviceId"]=o,d.sessionID=(0,D.$7g)()+Date.now(),d.commitHash=E,d.version=f,d["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,s.$k)(s.$x),d["common.nodePlatform"]=h.$ic,d["common.nodeArch"]=I,d["common.product"]=$||"desktop",m&&(d["common.msftInternal"]=m);let i=0;const a=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),s.$o&&(d["common.snap"]="true");const t=O(c);return t&&(d["common.platformDetail"]=t),d}function A(p){const c=h.env.USERDNSDOMAIN;if(!c)return!1;const I=c.toLowerCase();return p.some(E=>I===E)}}),define(Re[154],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em=(0,s.$Ki)("telemetryService"),e.$fm=(0,s.$Ki)("customEndpointTelemetryService"),e.$gm="telemetry.currentSessionDate",e.$hm="telemetry.firstSessionDate",e.$im="telemetry.lastSessionDate",e.$jm="telemetry.machineId",e.$km="telemetry.sqmId",e.$lm="telemetry.devDeviceId",e.$mm="telemetry",e.$nm="telemetry.telemetryLevel",e.$om="telemetry.enableCrashReporter",e.$pm="telemetry.enableTelemetry";var h;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var D;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(Re[92],Ce([1,0,24,17,91,243,154]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0,e.$Mp=I,e.$Np=E,e.$Op=f,e.$Pp=P,e.$Qp=o,e.$Rp=$,e.$Sp=d,e.$Tp=t;class A{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$Fp=A;class p{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Gp=p,e.$Hp=new p;class c{async publicLog(n,u,l){}async publicLogError(n,u,l){}}e.$Ip=c,e.$Jp="telemetry",e.$Kp="extensionTelemetryLog",e.$Lp={log:()=>null,flush:()=>Promise.resolve(null)};function I(r,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!r.enableTelemetry)}function E(r,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}function f(r){const n=r.getValue(T.$nm),u=r.getValue(T.$om);if(r.getValue(T.$pm)===!1||u===!1)return T.TelemetryLevel.NONE;switch(n??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function P(r){const n={},u={},l={};m(r,l);for(let g in l){g=g.length>150?g.substr(g.length-149):g;const y=l[g];typeof y=="number"?u[g]=y:typeof y=="boolean"?u[g]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${y.length}`),n[g]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(n[g]=y)}return{properties:n,measurements:u}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function o(r){if(!r)return"none";const n=(0,D.$qn)(r);return v.has(n)?n:"other"}function m(r,n,u=0,l){if(r)for(const g of Object.getOwnPropertyNames(r)){const y=r[g],k=l?l+g:g;Array.isArray(y)?n[k]=(0,s.$ro)(y):y instanceof Date?n[k]=y.toISOString():(0,h.$lg)(y)?u<2?m(y,n,u+1,k+"."):n[k]=(0,s.$ro)(y):n[k]=y}}function $(r,n){const u=r.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,O.$Ep)(u)||l}function d(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}function i(r,n){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let u=r;const l=[];for(const S of n)for(;;){const R=S.exec(r);if(!R)break;l.push([R.index,S.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(u="";;){const S=y.exec(r);if(!S)break;const R=l.some(([C,w])=>S.index<w&&C<y.lastIndex);!g.test(S[0])&&!R&&(u+=r.substring(k,S.index)+"<REDACTED: user-file-path>",k=y.lastIndex)}return k<r.length&&(u+=r.substr(k)),u}function a(r){if(!r)return r;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of n)if(u.regex.test(r))return`<REDACTED: ${u.label}>`;return r}function t(r,n){return(0,s.$oo)(r,u=>{if(u instanceof A||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let l=u.replaceAll("%20"," ");l=i(l,n);for(const g of n)l=l.replace(g,"");return l=a(l),l}})}}),define(Re[244],Ce([1,0,13,151,23,10,2,12,57,92]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$Vp=void 0,e.$Up=I,e.$Wp=v,e.$Xp=o,e.$Yp=m,e.$Zp=$,e.$1p=d,e.$2p=i,e.$3p=a,e.$5p=t,e.$6p=n;function I(u,l){return u.uuid&&l.uuid?u.uuid===l.uuid:u.id===l.id?!0:(0,s.$Ff)(u.id,l.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(l){const g=l.manifest?l.manifest.version:l.version,y=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new f(l.identifier,g,y)}static parse(l){const g=E.exec(l);return g&&g[1]&&g[2]?new f({id:g[1]},g[2],g[4]||void 0):null}constructor(l,g,y=D.TargetPlatform.UNDEFINED){this.identifier=l,this.version=g,this.targetPlatform=y,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==D.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof f?I(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Vp=f;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(u){const l=P.exec(u);return l&&l[1]?[m(l[1]),l[2]]:[m(u),void 0]}function o(u,l){return`${u}.${l}`}function m(u){return u.toLowerCase()}function $(u,l){return m(o(u??D.$vn,l))}function d(u,l){const g=[],y=k=>{for(const S of g)if(S.some(R=>I(l(R),l(k))))return S;return null};for(const k of u){const S=y(k);S?S.push(k):g.push([k])}return g}function i(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}function a(u){return{id:new c.$Fp(u.identifier.id),name:new c.$Fp(u.name),version:u.version,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$4p=new D.$zn("pprice.better-merge");function t(u,l){const g=[],y=l.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const k=y.shift();if(k&&g.every(S=>!I(S.identifier,{id:k}))){const S=u.filter(R=>I(R.identifier,{id:k}));S.length===1&&(g.push(S[0]),y.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}async function r(u,l){if(!O.$n)return!1;let g;try{g=(await u.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{g=(await u.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){l.debug("Error while getting the os-release file.",(0,A.$bb)(k))}}return!!g&&(g.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(u,l){const g=await r(u,l),y=(0,h.$pp)(g?"alpine":O.$x,p.$jc);return l.debug("ComputeTargetPlatform:",y),y}}),define(Re[245],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=s,e.$Qs=h,e.$Rs=D,e.$Ss=O,e.$Ts=T,e.$Us=A;function s(p){return[...p.entries()]}function h(p){return p?[...p.entries()]:[]}function D(p){return new Map(p)}function O(p){return new Map(p??[])}function T(p){return Array.from(p.entries()).map(c=>[c[0],s(c[1].map),h(c[1].descriptionMap)])}function A(p){return new Map(p.map(c=>[c[0],{map:D(c[1]),descriptionMap:O(c[2])}]))}}),define(Re[246],Ce([1,0,5,36,37]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=e.$Bs=e.$As=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$zs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ys=void 0,e.$ys=new h.$2j("terminalTabFocusMode",!1,!0);var O;(function(r){r.AutomationProfile="terminal.integrated.automationProfile.",r.DefaultProfile="terminal.integrated.defaultProfile.",r.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var T;(function(r){r.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",r.AutomationProfileLinux="terminal.integrated.automationProfile.linux",r.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",r.AutomationProfileWindows="terminal.integrated.automationProfile.windows",r.ProfilesWindows="terminal.integrated.profiles.windows",r.ProfilesMacOs="terminal.integrated.profiles.osx",r.ProfilesLinux="terminal.integrated.profiles.linux",r.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",r.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",r.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",r.UseWslProfiles="terminal.integrated.useWslProfiles",r.TabsDefaultColor="terminal.integrated.tabs.defaultColor",r.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",r.TabsEnabled="terminal.integrated.tabs.enabled",r.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",r.TabsHideCondition="terminal.integrated.tabs.hideCondition",r.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",r.TabsShowActions="terminal.integrated.tabs.showActions",r.TabsLocation="terminal.integrated.tabs.location",r.TabsFocusMode="terminal.integrated.tabs.focusMode",r.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",r.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",r.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",r.CopyOnSelection="terminal.integrated.copyOnSelection",r.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",r.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",r.FontFamily="terminal.integrated.fontFamily",r.FontSize="terminal.integrated.fontSize",r.LetterSpacing="terminal.integrated.letterSpacing",r.LineHeight="terminal.integrated.lineHeight",r.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",r.TabStopWidth="terminal.integrated.tabStopWidth",r.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",r.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",r.BellDuration="terminal.integrated.bellDuration",r.FontWeight="terminal.integrated.fontWeight",r.FontWeightBold="terminal.integrated.fontWeightBold",r.CursorBlinking="terminal.integrated.cursorBlinking",r.CursorStyle="terminal.integrated.cursorStyle",r.CursorStyleInactive="terminal.integrated.cursorStyleInactive",r.CursorWidth="terminal.integrated.cursorWidth",r.Scrollback="terminal.integrated.scrollback",r.DetectLocale="terminal.integrated.detectLocale",r.DefaultLocation="terminal.integrated.defaultLocation",r.GpuAcceleration="terminal.integrated.gpuAcceleration",r.TerminalTitleSeparator="terminal.integrated.tabs.separator",r.TerminalTitle="terminal.integrated.tabs.title",r.TerminalDescription="terminal.integrated.tabs.description",r.RightClickBehavior="terminal.integrated.rightClickBehavior",r.MiddleClickBehavior="terminal.integrated.middleClickBehavior",r.Cwd="terminal.integrated.cwd",r.ConfirmOnExit="terminal.integrated.confirmOnExit",r.ConfirmOnKill="terminal.integrated.confirmOnKill",r.EnableBell="terminal.integrated.enableBell",r.EnableVisualBell="terminal.integrated.enableVisualBell",r.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",r.AllowChords="terminal.integrated.allowChords",r.AllowMnemonics="terminal.integrated.allowMnemonics",r.TabFocusMode="terminal.integrated.tabFocusMode",r.EnvMacOs="terminal.integrated.env.osx",r.EnvLinux="terminal.integrated.env.linux",r.EnvWindows="terminal.integrated.env.windows",r.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",r.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",r.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",r.ShowExitAlert="terminal.integrated.showExitAlert",r.SplitCwd="terminal.integrated.splitCwd",r.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",r.WordSeparators="terminal.integrated.wordSeparators",r.EnableFileLinks="terminal.integrated.enableFileLinks",r.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",r.UnicodeVersion="terminal.integrated.unicodeVersion",r.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",r.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",r.HideOnStartup="terminal.integrated.hideOnStartup",r.CustomGlyphs="terminal.integrated.customGlyphs",r.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",r.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",r.InheritEnv="terminal.integrated.inheritEnv",r.ShowLinkHover="terminal.integrated.showLinkHover",r.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",r.AutoReplies="terminal.integrated.autoReplies",r.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",r.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",r.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",r.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",r.EnableImages="terminal.integrated.enableImages",r.SmoothScrolling="terminal.integrated.smoothScrolling",r.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",r.FocusAfterRun="terminal.integrated.focusAfterRun",r.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",r.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",r.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var A;(function(r){r.Bash="bash",r.Fish="fish",r.Sh="sh",r.Csh="csh",r.Ksh="ksh",r.Zsh="zsh"})(A||(e.PosixShellType=A={}));var p;(function(r){r.CommandPrompt="cmd",r.Wsl="wsl",r.GitBash="gitbash"})(p||(e.WindowsShellType=p={}));var c;(function(r){r.PowerShell="pwsh",r.Python="python",r.Julia="julia",r.NuShell="nu"})(c||(e.GeneralShellType=c={}));var I;(function(r){r[r.Api=0]="Api",r[r.Process=1]="Process",r[r.Sequence=2]="Sequence",r[r.Config=3]="Config"})(I||(e.TitleEventSource=I={}));var E;(function(r){r.LocalPty="localPty",r.PtyHost="ptyHost",r.PtyHostWindow="ptyHostWindow",r.Logger="logger",r.Heartbeat="heartbeat"})(E||(e.TerminalIpcChannels=E={}));var f;(function(r){r.Cwd="cwd",r.InitialCwd="initialCwd",r.FixedDimensions="fixedDimensions",r.Title="title",r.ShellType="shellType",r.HasChildProcesses="hasChildProcesses",r.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",r.OverrideDimensions="overrideDimensions",r.FailedShellIntegrationActivation="failedShellIntegrationActivation",r.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(f||(e.ProcessPropertyType=f={})),e.$zs=(0,s.$Ki)("ptyService");var P;(function(r){r[r.BeatInterval=5e3]="BeatInterval",r[r.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",r[r.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",r[r.SecondWaitMultiplier=1]="SecondWaitMultiplier",r[r.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(P||(e.HeartbeatConstants=P={}));var v;(function(r){r[r.Panel=1]="Panel",r[r.Editor=2]="Editor"})(v||(e.TerminalLocation=v={}));var o;(function(r){r.TerminalView="view",r.Editor="editor"})(o||(e.TerminalLocationString=o={}));var m;(function(r){r[r.GraceTime=6e4]="GraceTime",r[r.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var $;(function(r){r[r.HighWatermarkChars=1e5]="HighWatermarkChars",r[r.LowWatermarkChars=5e3]="LowWatermarkChars",r[r.CharCountAckSize=5e3]="CharCountAckSize"})($||(e.FlowControlConstants=$={}));var d;(function(r){r.GitBash="Git Bash",r.Pwsh="PowerShell"})(d||(e.ProfileSource=d={}));var i;(function(r){r[r.Off=0]="Off",r[r.FinalTerm=1]="FinalTerm",r[r.VSCode=2]="VSCode"})(i||(e.ShellIntegrationStatus=i={}));var a;(function(r){r[r.Unknown=0]="Unknown",r[r.Shutdown=1]="Shutdown",r[r.Process=2]="Process",r[r.User=3]="User",r[r.Extension=4]="Extension"})(a||(e.TerminalExitReason=a={})),e.$As={Backend:"workbench.contributions.terminal.processBackend"};class t{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(n){const u=this.b(n.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,n)}getTerminalBackend(n){return this.a.get(this.b(n))}b(n){return n?.toLowerCase()??""}}D.$zo.add(e.$As.Backend,new t),e.$Bs=(0,s.$Ki)("localPtyService"),e.$Cs=(0,s.$Ki)("terminalLogService")}),define(Re[247],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dAb=void 0;class s{constructor(D){this.b=D,this.a=new Map}dispose(){for(const D of this.a.values())D.dispose()}startBuffering(D,O,T=5){const A=O(p=>{const c=typeof p=="string"?p:p.data;let I=this.a.get(D);if(I){I.data.push(c);return}const E=setTimeout(()=>this.flushBuffer(D),T);I={data:[c],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(D),A.dispose()}},this.a.set(D,I)});return A}stopBuffering(D){this.a.get(D)?.dispose()}flushBuffer(D){const O=this.a.get(D);O&&(this.a.delete(D),this.b(D,O.data.join("")))}}e.$dAb=s}),define(Re[248],Ce([1,0,8,84,104,51,4,17,2,7,116,37]),function(ge,e,s,h,D,O,T,A,p,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tx=e.$Sx=e.$Rx=e.$Qx=e.$Px=e.$Ox=e.IconFontDefinition=e.IconContribution=e.$Lx=void 0,e.$Mx=m,e.$Nx=$,E=Ue(E),e.$Lx={IconContribution:"base.contributions.icons"};var f;(function(t){function r(n,u){let l=n.defaults;for(;O.ThemeIcon.isThemeIcon(l);){const g=o.getIcon(l.id);if(!g)return;l=g.defaults}return l}t.getDefinition=r})(f||(e.IconContribution=f={}));var P;(function(t){function r(u){return{weight:u.weight,style:u.style,src:u.src.map(l=>({format:l.format,location:l.location.toString()}))}}t.toJSONObject=r;function n(u){const l=g=>(0,A.$jg)(g)?g:void 0;if(u&&Array.isArray(u.src)&&u.src.every(g=>(0,A.$jg)(g.format)&&(0,A.$jg)(g.location)))return{weight:l(u.weight),style:l(u.style),src:u.src.map(g=>({format:g.format,location:p.URI.parse(g.location)}))}}t.fromJSONObject=n})(P||(e.IconFontDefinition=P={}));class v{constructor(){this.a=new T.$qe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(2365,null)},fontCharacter:{type:"string",description:(0,c.localize)(2366,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,n,u,l){const g=this.b[r];if(g){if(u&&!g.description){g.description=u,this.d.properties[r].markdownDescription=`${u} $(${r})`;const S=this.e.enum.indexOf(r);S!==-1&&(this.e.enumDescriptions[S]=u),this.a.fire()}return g}const y={id:r,description:u,defaults:n,deprecationMessage:l};this.b[r]=y;const k={$ref:"#/definitions/icons"};return l&&(k.deprecationMessage=l),u&&(k.markdownDescription=`${u}: $(${r})`),this.d.properties[r]=k,this.e.enum.push(r),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const n=this.e.enum.indexOf(r);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,n){const u=this.f[r];return u||(this.f[r]=n,this.a.fire(),n)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(g,y)=>g.id.localeCompare(y.id),n=g=>{for(;O.ThemeIcon.isThemeIcon(g.defaults);)g=this.b[g.defaults.id];return`codicon codicon-${g?g.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(g=>this.b[g]);for(const g of l.filter(y=>!!y.description).sort(r))u.push(`|<i class="${n(g)}"></i>|${g.id}|${O.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const g of l.filter(y=>!O.ThemeIcon.isThemeIcon(y.defaults)).sort(r))u.push(`|<i class="${n(g)}"></i>|${g.id}|`);return u.join(`
`)}}const o=new v;E.$zo.add(e.$Lx.IconContribution,o);function m(t,r,n,u){return o.registerIcon(t,r,n,u)}function $(){return o}function d(){const t=(0,D.$6j)();for(const r in t){const n="\\"+t[r].toString(16);o.registerIcon(r,{fontCharacter:n})}}d(),e.$Ox="vscode://schemas/icons";const i=E.$zo.as(I.$Ao.JSONContribution);i.registerSchema(e.$Ox,o.getIconSchema());const a=new s.$Wh(()=>i.notifySchemaChanged(e.$Ox),200);o.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$Px=m("widget-close",h.$0j.close,(0,c.localize)(2367,null)),e.$Qx=m("goto-previous-location",h.$0j.arrowUp,(0,c.localize)(2368,null)),e.$Rx=m("goto-next-location",h.$0j.arrowDown,(0,c.localize)(2369,null)),e.$Sx=O.ThemeIcon.modify(h.$0j.sync,"spin"),e.$Tx=O.ThemeIcon.modify(h.$0j.loading,"spin")}),define(Re[93],Ce([1,0,4,3,10,2,47,5,11]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1w=e.$Zw=e.$Ww=e.$Uw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Qw=e.$Pw=void 0,e.$Rw=E,e.$Sw=P,e.$Tw=v,e.$Vw=o,e.$Xw=m,e.$Yw=$,e.$Pw=(0,A.$Ki)("tunnelService"),e.$Qw=(0,A.$Ki)("sharedTunnelsService");var c;(function(a){a.Http="http",a.Https="https"})(c||(e.TunnelProtocol=c={}));var I;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(I||(e.TunnelPrivacyId=I={}));function E(a){return!!a.forwardPort}var f;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function P(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(t)return{address:t[1],port:+t[2]}}function v(a){if(a.scheme!=="http"&&a.scheme!=="https"||!a.query)return;const t=a.query.split("&");for(const r of t){const n=r.split("=")[1];if(/^https?:/.exec(n)){const u=P(O.URI.parse(n));if(u)return u}}}e.$Uw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function o(a){return e.$Uw.indexOf(a)>=0}e.$Ww=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(a){return e.$Ww.indexOf(a)>=0}function $(a,t,r,n){if(r===D.OperatingSystem.Windows)return!1;if(r===D.OperatingSystem.Macintosh&&m(t)){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(u?.length===4&&parseInt(u[1])>=18)return!1}return a<1024}class d{constructor(t,r,n){this.remoteAddress=t,this.localAddress=r,this.b=n,this.a=new s.$qe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Zw=d;let i=class extends h.$Zc{constructor(t,r){super(),this.r=t,this.s=r,this.a=new s.$qe,this.onTunnelOpened=this.a.event,this.b=new s.$qe,this.onTunnelClosed=this.b.event,this.c=new s.$qe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],r=Array.from(this.f.values());for(const n of r){const u=Array.from(n.values());for(const l of u){const g=await l.value;g&&typeof g!="string"&&t.push(g)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:r}of t.values())await r.then(n=>typeof n!="string"?n?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,r,n,u,l){this.z(t,r,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:r,localAddress:n,privacy:u,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,r){(m(t)||o(t))&&(t=e.$Uw[0]);const n=this.D(t,r);if(n)return++n.refcount,n.value}openTunnel(t,r,n,u,l,g=!1,y,k){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${n} on local port ${l}.`);const S=this.g??t;if(!S)return;if(r||(r="localhost"),u||(u=this.t),this.g&&this.n.has(n)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const R=this.F(S,r,n,u,l,g,y,k);return R?R.then(C=>{if(C){if(typeof C=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(r,n),C}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(r,n);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.w(C);return(C.tunnelRemoteHost!==r||C.tunnelRemotePort!==n)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),y&&C.privacy!==y&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),R)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const r=this.f.get(t.tunnelRemoteHost);if(r){const n=r.get(t.tunnelRemotePort);n&&(n.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,n))}}}}async y(t,r,n){if(n.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${r}.`);const u=n.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(r),u}}async closeTunnel(t,r){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${r} `);const n=this.f.get(t);if(n&&n.has(r)){const u=n.get(r);u.refcount=0,await this.y(t,r,u)}}z(t,r,n){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(r,{refcount:1,value:n})}async C(t,r){const n=this.f.get(t);if(n){const u=n.get(r),l=u?await u.value:void 0;(!l||typeof l=="string")&&n.delete(r),n.size===0&&this.f.delete(t)}}D(t,r){const n=[t];o(t)?(n.push(...e.$Uw),n.push(...e.$Ww)):m(t)&&n.push(...e.$Ww);const u=n.map(l=>this.f.get(l));for(const l of u){const g=l?.get(r);if(g)return g}}canTunnel(t){return!!P(t)}G(t,r,n,u,l,g,y){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${n} on local port ${u}.`);const k=n;this.n.add(k);const S=u===void 0?n:u,R={elevationRequired:l?this.isPortPrivileged(S):!1},C={remoteAddress:{host:r,port:n},localAddressPort:u,privacy:g,public:g?g!==I.Private:void 0,protocol:y},w=t.forwardPort(C,R);return w?(this.z(r,n,w),w.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(k)})):this.n.delete(k),w}};e.$1w=i,e.$1w=i=Ye([We(0,p.$fk),We(1,T.$ej)],i)}),define(Re[155],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0,e.$Pl=(0,s.$Ki)("IUriIdentityService")}),define(Re[249],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$2w=void 0,e.$2w=(0,s.$Ki)("editSessionIdentityService");var h;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(Re[250],Ce([1,0,14]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=h,e.$LN=D,e.$MN=O,e.$NN=T,e.$ON=A;function h(p){return p.scheme!==s.Schemas.file&&p.scheme!==s.Schemas.vscodeRemote}function D(p){if(p.folders.length)return p.folders.every(c=>h(c.uri))?p.folders[0].uri:void 0;if(p.configuration&&h(p.configuration))return p.configuration}function O(p){return D(p)?.scheme}function T(p){return D(p)?.authority}function A(p){return D(p)!==void 0}}),define(Re[48],Ce([1,0,7,16,62,22,2,5,14]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$0i=e.$9i=e.$8i=e.$7i=e.$5i=e.$4i=e.WorkbenchState=e.$Xi=e.$Wi=e.$Ti=void 0,e.$Ui=c,e.$Vi=I,e.$Yi=E,e.$Zi=f,e.$1i=P,e.$2i=o,e.$3i=m,e.$6i=i,e.$$i=a,e.$_i=t,e.$bj=r,e.$cj=n,e.$dj=u,e.$Ti=(0,A.$Ki)("contextService");function c(l){const g=l;return typeof g?.id=="string"&&T.URI.isUri(g.uri)}function I(l){return typeof l?.id=="string"&&!c(l)&&!f(l)}e.$Wi={id:"ext-dev"},e.$Xi={id:"empty-window"};function E(l,g){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,h.$sc)(l)}:g?e.$Wi:e.$Xi;const y=l;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}function f(l){const g=l;return typeof g?.id=="string"&&T.URI.isUri(g.configPath)}function P(l){const g=l;if(g?.uri)return{id:g.id,uri:T.URI.revive(g.uri)};const y=l;if(y?.configPath)return{id:y.id,configPath:T.URI.revive(y.configPath)};if(l?.id)return{id:l.id}}var v;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function o(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}function m(l){const g=l;return!!(g&&typeof g=="object"&&T.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}class ${constructor(g,y,k,S,R){this.h=g,this.j=k,this.k=S,this.l=R,this.c=D.$Qi.forUris(this.l,()=>!0),this.folders=y}update(g){this.h=g.id,this.k=g.configuration,this.j=g.transient,this.l=g.l,this.folders=g.folders}get folders(){return this.g}set folders(g){this.g=g,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(g){this.k=g}getFolder(g){return g&&this.c.findSubstr(g)||null}n(){this.c=D.$Qi.forUris(this.l,()=>!0);for(const g of this.folders)this.c.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$4i=$;class d{constructor(g,y){this.raw=y,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,O.$lh)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$5i=d;function i(l){return new d({uri:l,index:0,name:(0,O.$hh)(l)},{uri:l.toString()})}e.$7i="code-workspace",e.$8i=`.${e.$7i}`,e.$9i=[{name:(0,s.localize)(2490,null),extensions:[e.$7i]}],e.$0i="workspace.json";function a(l,g){return O.$ch.isEqualOrParent(l,g.untitledWorkspacesHome)}function t(l){let g;return T.URI.isUri(l)?g=l:g=l.configuration,g?.scheme===p.Schemas.tmp}e.$aj="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(l){return l.id===e.$aj}function n(l,g){return!a(l,g)&&!t(l)}function u(l){return(typeof l=="string"?(0,h.$tc)(l):(0,O.$jh)(l))===e.$8i}}),define(Re[156],Ce([1,0,61,4,3,22,2,7,149,27,5,11,48,28,155,8,31,13,17]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Rl=e.ProfileResourceType=void 0,e.$Ql=a,e.$Sl=t,e.$Tl=r;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function a(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&typeof g.isDefault=="boolean"&&typeof g.name=="string"&&T.URI.isUri(g.location)&&T.URI.isUri(g.globalStorageHome)&&T.URI.isUri(g.settingsResource)&&T.URI.isUri(g.keybindingsResource)&&T.URI.isUri(g.tasksResource)&&T.URI.isUri(g.snippetsHome)&&T.URI.isUri(g.extensionsResource))}e.$Rl=(0,I.$Ki)("IUserDataProfilesService");function t(l,g){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:T.URI.revive(l.location).with({scheme:g}),globalStorageHome:T.URI.revive(l.globalStorageHome).with({scheme:g}),settingsResource:T.URI.revive(l.settingsResource).with({scheme:g}),keybindingsResource:T.URI.revive(l.keybindingsResource).with({scheme:g}),tasksResource:T.URI.revive(l.tasksResource).with({scheme:g}),snippetsHome:T.URI.revive(l.snippetsHome).with({scheme:g}),extensionsResource:T.URI.revive(l.extensionsResource).with({scheme:g}),cacheHome:T.URI.revive(l.cacheHome).with({scheme:g}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function r(l,g,y,k,S,R){return{id:l,name:g,location:y,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:R&&S?.useDefaultFlags?.globalState?R.globalStorageHome:(0,O.$lh)(y,"globalStorage"),settingsResource:R&&S?.useDefaultFlags?.settings?R.settingsResource:(0,O.$lh)(y,"settings.json"),keybindingsResource:R&&S?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,O.$lh)(y,"keybindings.json"),tasksResource:R&&S?.useDefaultFlags?.tasks?R.tasksResource:(0,O.$lh)(y,"tasks.json"),snippetsHome:R&&S?.useDefaultFlags?.snippets?R.snippetsHome:(0,O.$lh)(y,"snippets"),extensionsResource:R&&S?.useDefaultFlags?.extensions?R.extensionsResource:(0,O.$lh)(y,"extensions.json"),cacheHome:(0,O.$lh)(k,l),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let n=class extends D.$Zc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(g,y,k,S){super(),this.t=g,this.u=y,this.w=k,this.y=S,this.f=!0,this.h=this.B(new h.$qe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$qe),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$qe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$qe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new P.$Fc,workspaces:new P.$Fc,emptyWindows:new Map},this.profilesHome=(0,O.$lh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$lh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(g){this.f!==g&&(this.z=void 0,this.f=g)}isEnabled(){return this.f}get C(){if(!this.z){const g=this.D(),y=[g];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,d.$jg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}y.push(r((0,O.$ih)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},g))}}catch(R){this.y.error(R)}const k=new P.$Fc,S=new Map;if(y.length)try{const R=this.Q();if(R.workspaces)for(const[C,w]of Object.entries(R.workspaces)){const b=T.URI.parse(C),N=y.find(L=>L.id===w);N&&k.set(b,N)}if(R.emptyWindows)for(const[C,w]of Object.entries(R.emptyWindows)){const b=y.find(N=>N.id===w);b&&S.set(C,b)}}catch(R){this.y.error(R)}this.z={profiles:y,workspaces:k,emptyWindows:S}}return this.z}D(){const g=r("__default__profile__",(0,A.localize)(2443,null),this.t.userRoamingDataHome,this.g);return{...g,extensionsResource:this.S()??g.extensionsResource,isDefault:!0}}async createTransientProfile(g){const y="Temp",k=new RegExp(`${(0,$.$mf)(y)}\\s(\\d+)`);let S=0;for(const C of this.profiles){const w=k.exec(C.name),b=w?parseInt(w[1]):0;S=b>S?b:S}const R=`${y} ${S+1}`;return this.createProfile((0,s.$yj)((0,m.$7g)()).toString(16),R,{transient:!0},g)}async createNamedProfile(g,y,k){return this.createProfile((0,s.$yj)((0,m.$7g)()).toString(16),g,y,k)}async createProfile(g,y,k,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(g,y,k);return S&&await this.setProfileForWorkspace(S,R),R}async F(g,y,k){if(!(0,d.$jg)(y)||!y)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(y);return S||(S=(async()=>{try{if(this.profiles.find(b=>b.name===y||b.id===g))throw new Error(`Profile with ${y} name already exists`);const C=r(g,y,(0,O.$lh)(this.profilesHome,g),this.g,k,this.defaultProfile);await this.u.createFolder(C.location);const w=[];return this.j.fire({profile:C,join(b){w.push(b)}}),await o.Promises.settled(w),this.I([C],[],[]),C}finally{this.r.delete(y)}})(),this.r.set(y,S)),S}async updateProfile(g,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(S=>S.id===g.id);if(!k)throw new Error(`Profile '${g.name}' does not exist`);return k=r(k.id,y.name??k.name,k.location,this.g,{shortName:y.shortName??k.shortName,icon:y.icon===null?void 0:y.icon??k.icon,transient:y.transient??k.isTransient,useDefaultFlags:y.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(g.isDefault)throw new Error("Cannot remove default profile");const y=this.profiles.find(S=>S.id===g.id);if(!y)throw new Error(`Profile '${g.name}' does not exist`);const k=[];this.m.fire({profile:y,join(S){k.push(S)}});try{await Promise.allSettled(k)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])y.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])y.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[y],[]);try{await this.u.del(y.cacheHome,{recursive:!0})}catch(S){(0,c.$wl)(S)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(S)}}async setProfileForWorkspace(g,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(S=>S.id===y.id);if(!k)throw new Error(`Profile '${y.name}' does not exist`);this.L(g,k)}unsetWorkspace(g,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(g,void 0,y)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const g=await this.u.resolve(this.profilesHome);await Promise.all((g.children||[]).filter(y=>y.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,y.resource))).map(y=>this.u.del(y.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const g=this.s.profiles.filter(y=>!this.H(y));await Promise.allSettled(g.map(y=>this.removeProfile(y)))}getProfileForWorkspace(g){const y=this.G(g),k=T.URI.isUri(y)?this.C.workspaces.get(y):this.C.emptyWindows.get(y);return k||((0,f.$Ui)(g)?this.s.folders.get(g.uri):(0,f.$Zi)(g)?this.s.workspaces.get(g.configPath):this.s.emptyWindows.get(g.id))}G(g){return(0,f.$Ui)(g)?g.uri:(0,f.$Zi)(g)?g.configPath:g.id}H(g){return!!([...this.C.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,g.location))||[...this.C.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,g.location))||[...this.s.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,g.location))||[...this.s.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,g.location))||[...this.s.folders.values()].some(y=>this.w.extUri.isEqual(y.location,g.location)))}I(g,y,k){const S=[...this.profiles,...g],R=[],C=this.s.profiles;this.s.profiles=[];for(let w of S){if(w.isDefault||y.some(N=>w.id===N.id))continue;w=k.find(N=>w.id===N.id)??w;const b=C.find(N=>w.id===N.id);if(w.isTransient)this.s.profiles.push(w);else{if(b){for(const[N,L]of this.s.emptyWindows.entries())if(w.id===L.id){this.L({id:N},w);break}for(const[N,L]of this.s.workspaces.entries())if(w.id===L.id){this.L({id:"",configPath:N},w);break}for(const[N,L]of this.s.folders.entries())if(w.id===L.id){this.L({id:"",uri:N},w);break}}R.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(g,y,k)}J(g,y,k){this.h.fire({added:g,removed:y,updated:k,all:this.profiles})}L(g,y,k){if(k=y?.isTransient?!0:k,k)(0,f.$Ui)(g)?(this.s.folders.delete(g.uri),y&&this.s.folders.set(g.uri,y)):(0,f.$Zi)(g)?(this.s.workspaces.delete(g.configPath),y&&this.s.workspaces.set(g.configPath,y)):(this.s.emptyWindows.delete(g.id),y&&this.s.emptyWindows.set(g.id,y));else{this.L(g,void 0,!0);const S=this.G(g);T.URI.isUri(S)?(this.C.workspaces.delete(S),y&&this.C.workspaces.set(S,y)):(this.C.emptyWindows.delete(S),y&&this.C.emptyWindows.set(S,y)),this.M()}}M(){const g={};for(const[k,S]of this.C.workspaces.entries())g[k.toString()]=S.id;const y={};for(const[k,S]of this.C.emptyWindows.entries())y[k.toString()]=S.id;this.R({workspaces:g,emptyWindows:y}),this.z=void 0}N(g){const y={},k=this.D();if(g.workspaces)for(const[R,C]of Object.entries(g.workspaces)){const w=T.URI.parse(C);y[R]=this.w.extUri.isEqual(w,k.location)?k.id:this.w.extUri.basename(w)}const S={};if(g.emptyWindows)for(const[R,C]of Object.entries(g.emptyWindows)){const w=T.URI.parse(C);S[R]=this.w.extUri.isEqual(w,k.location)?k.id:this.w.extUri.basename(w)}return{workspaces:y,emptyWindows:S}}O(){return[]}P(g){throw new Error("not implemented")}Q(){return{}}R(g){throw new Error("not implemented")}S(){}};e.$Ul=n,e.$Ul=n=Ye([We(0,p.$Ri),We(1,c.$fl),We(2,v.$Pl),We(3,E.$fk)],n);class u extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(g){this.a=g}Q(){return this.X}R(g){this.X=g}}e.$Vl=u}),define(Re[157],Ce([1,0,8,4,3,63,17,211,5,156]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$sq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$qq=e.$pq=e.$oq=void 0,e.$rq=P,e.$tq=o,e.$vq=$,e.$oq="__$__isNewStorageMarker",e.$pq="__$__targetStorageMarker",e.$qq=(0,p.$Ki)("storageService");var I;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var E;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var f;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(f||(e.StorageTarget=f={}));function P(d){const i=d.get(e.$pq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends D.$Zc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new h.$te),this.c=this.B(new h.$te),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$qe),this.onWillSaveState=this.f.event,this.h=this.B(new s.$Wh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new D.$1c),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,a,t){return h.Event.filter(this.b.event,r=>r.scope===i&&(a===void 0||r.key===a),t)}n(){this.j.value=(0,s.$1h)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,D.$Uc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,a){const{key:t,external:r}=a;if(t===e.$pq){switch(i){case E.APPLICATION:this.H=void 0;break;case E.PROFILE:this.F=void 0;break;case E.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:r})}w(i){this.f.fire({reason:i})}get(i,a,t){return this.P(a)?.get(i,t)}getBoolean(i,a,t){return this.P(a)?.getBoolean(i,t)}getNumber(i,a,t){return this.P(a)?.getNumber(i,t)}getObject(i,a,t){return this.P(a)?.getObject(i,t)}storeAll(i,a){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,a)})}store(i,a,t,r,n=!1){if((0,T.$sg)(a)){this.remove(i,t,n);return}this.y(()=>{this.z(i,t,r),this.P(t)?.set(i,a,n)})}remove(i,a,t=!1){this.y(()=>{this.z(i,a,void 0),this.P(a)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,a){const t=[],r=this.J(i);for(const n of Object.keys(r))r[n]===a&&t.push(n);return t}z(i,a,t,r=!1){const n=this.J(a);typeof t=="number"?n[i]!==t&&(n[i]=t,this.P(a)?.set(e.$pq,JSON.stringify(n),r)):typeof n[i]=="number"&&(delete n[i],this.P(a)?.set(e.$pq,JSON.stringify(n),r))}get D(){return this.C||(this.C=this.L(E.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(E.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(E.APPLICATION)),this.H}J(i){switch(i){case E.APPLICATION:return this.I;case E.PROFILE:return this.G;default:return this.D}}L(i){const a=this.P(i);return a?P(a):Object.create(null)}isNew(i){return this.getBoolean(e.$oq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const a=this.P(E.APPLICATION),t=this.P(E.PROFILE),r=this.P(E.WORKSPACE);switch(i){case I.NONE:await s.Promises.settled([a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await s.Promises.settled([a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(E.APPLICATION)?.items??new Map,a=this.P(E.PROFILE)?.items??new Map,t=this.P(E.WORKSPACE)?.items??new Map;return $(i,a,t,this.Q(E.APPLICATION)??"",this.Q(E.PROFILE)??"",this.Q(E.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,a){return this.w(I.NONE),(0,c.$Ql)(i)?this.R(i,a):this.S(i,a)}M(i,a){return!(i.id===a.id||o(a)&&o(i))}N(i,a,t){this.y(()=>{const r=new Set;for(const[n,u]of i)r.add(n),a.get(n)!==u&&this.u(t,{key:n,external:!0});for(const[n]of a.items)r.has(n)||this.u(t,{key:n,external:!0})})}}e.$sq=v;function o(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class m extends v{constructor(){super(),this.U=this.B(new A.$mq(new A.$nq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new A.$mq(new A.$nq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new A.$mq(new A.$nq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(E.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(E.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(E.APPLICATION,i)))}P(i){switch(i){case E.APPLICATION:return this.U;case E.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case E.APPLICATION:return"inMemory (application)";case E.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$uq=m;async function $(d,i,a,t,r,n){const u=b=>{try{return JSON.parse(b)}catch{return b}},l=new Map,g=new Map;d.forEach((b,N)=>{l.set(N,b),g.set(N,u(b))});const y=new Map,k=new Map;i.forEach((b,N)=>{y.set(N,b),k.set(N,u(b))});const S=new Map,R=new Map;a.forEach((b,N)=>{S.set(N,b),R.set(N,u(b))}),console.group(t!==r?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const C=[];if(l.forEach((b,N)=>{C.push({key:N,value:b})}),console.table(C),console.groupEnd(),console.log(g),t!==r){console.group(`Storage: Profile (path: ${r}, profile specific)`);const b=[];y.forEach((N,L)=>{b.push({key:L,value:N})}),console.table(b),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${n})`);const w=[];S.forEach((b,N)=>{w.push({key:N,value:b})}),console.table(w),console.groupEnd(),console.log(R)}}),define(Re[118],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0;class s{static{this.a=!1}constructor(D){this.d=D,this.b=new Map,this.c=1}add(D){const O=this.c++;return this.b.set(O,D),this.e(),O}get(D,O){return this.b.has(D)?this.b.get(D)[O]:void 0}delete(D){this.b.delete(D),this.e()}e(){s.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$5qc=s}),define(Re[64],Ce([1,0,14,22,27,5]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=e.$0qc=void 0;class T{constructor(){this.a=new Set(Object.keys(s.Schemas)),this.b=new Map,this.extUri=new h.$ah(p=>{const c=this.b.get(p.scheme);return!(c===void 0||c&D.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,c){c===null?this.b.delete(p.scheme):this.b.set(p.scheme,c)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$0qc=T,e.$$qc=(0,O.$Ki)("IExtHostFileSystemInfo")}),define(Re[29],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0,e.$5Q=(0,s.$Ki)("IExtHostInitDataService")}),define(Re[251],Ce([1,0,7,11,232,29]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ltc=void 0;let T=class extends D.$dS{constructor(p,c,I){const E=I.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",f=I.remote.isRemote?(0,s.localize)(2707,null):p?(0,s.localize)(2708,null):(0,s.localize)(2709,null);super(c.createLogger(E,{name:f}))}};e.$ltc=T,e.$ltc=T=Ye([We(1,h.$gk),We(2,O.$5Q)],T)}),define(Re[252],Ce([1,0,8]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qrc=e.$Prc=void 0;class h{constructor(T,A,p){this.h=new Map,this.a=T,this.b=A,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new s.$Wh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of c.values())I.complete()}catch(I){for(const E of c.values())E.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this.d}get(T,A){let p=this.f[T];return typeof p>"u"&&(p=A),p}update(T,A){this.f[T]=A;const p=this.h.get(T);if(p!==void 0)return p.p;const c=new s.$8h;return this.h.set(T,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$Prc=h;class D extends h{setKeysForSync(T){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},T)}constructor(T,A){super(T.identifier.value,!0,A),this.j=T}}e.$Qrc=D}),define(Re[253],Ce([1,0,4,2]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Psc=void 0;class D{constructor(T){this.c=T,this.a=new s.$qe,this.onDidSaveNotebookDocument=this.a.event,this.b=new s.$qe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(T,A,p,c){const E=this.c.getNotebookDocument(h.URI.revive(T)).acceptModelChanged(A.value,p,c);this.b.fire(E)}$acceptDirtyStateChanged(T,A){this.c.getNotebookDocument(h.URI.revive(T)).acceptDirty(A)}$acceptModelSaved(T){const A=this.c.getNotebookDocument(h.URI.revive(T));this.a.fire(A.apiNotebook)}}e.$Psc=D}),define(Re[19],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.$OQ=void 0,e.$OQ=(0,s.$Ki)("IExtHostRpcService");class h{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$PQ=h}),define(Re[254],Ce([1,0,23,4,3]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zrc=void 0;class O{#e;constructor(A,p){this.disposables=new D.$Yc,this.a=s.$zn.toKey(A.identifier),this.#e=p,this.onDidChange=h.Event.map(h.Event.filter(this.#e.onDidChangePassword,c=>c.extensionId===this.a),c=>({key:c.key}),this.disposables)}dispose(){this.disposables.dispose()}get(A){return this.#e.get(this.a,A)}store(A,p){return this.#e.store(this.a,A,p)}delete(A){return this.#e.delete(this.a,A)}}e.$Zrc=O}),define(Re[74],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$orc=e.$nrc=void 0,e.$nrc=(0,s.$Ki)("IURITransformerService");class h{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.$orc=h}),define(Re[255],Ce([1,0,119,364,365,68,2,11,366]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Utc=I,s=Ue(s),h=Ue(h),D=Ue(D),O=Ue(O);const c=!1;function I(i,a,t,r,n,u){const l=u.environment.useHostProxy,g=typeof l=="boolean"?l:!u.remote.isRemote,y={resolveProxy:R=>i.resolveProxy(R),lookupProxyAuthorization:m.bind(void 0,i,r,n,a,{},{},u.remote.isRemote,g),getProxyURL:()=>a.getConfiguration("http").get("proxy"),getProxySupport:()=>a.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>a.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>f(a),addCertificatesV2:()=>P(a),log:r,getLogLevel:()=>{const R=r.getLevel();switch(R){case A.LogLevel.Trace:return p.LogLevel.Trace;case A.LogLevel.Debug:return p.LogLevel.Debug;case A.LogLevel.Info:return p.LogLevel.Info;case A.LogLevel.Warning:return p.LogLevel.Warning;case A.LogLevel.Error:return p.LogLevel.Error;case A.LogLevel.Off:return p.LogLevel.Off;default:return C(R)}function C(w){return r.error("Unknown log level",w),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:g,loadAdditionalCertificates:async()=>{const R=[];if(u.remote.isRemote&&R.push((0,p.loadSystemCertificates)({log:r})),g){r.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const C=i.loadCertificates();C.then(w=>r.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",w.length)),R.push(C)}return u.environment.extensionTestsLocationURI&&h.globalAgent.testCertificates?.length&&(r.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),R.push(Promise.resolve(h.globalAgent.testCertificates))),(await Promise.all(R)).flat()},env:process.env},k=(0,p.createProxyResolver)(y),S=E(y,k);return o(t,S)}function E(i,a){function t(r,n){return Object.assign(r.default||r,n)}return{http:t(s,(0,p.createHttpPatch)(i,s,a)),https:t(h,(0,p.createHttpPatch)(i,h,a)),net:t(O,(0,p.createNetPatch)(i,O)),tls:t(D,(0,p.createTlsPatch)(i,D))}}function f(i){const a=i.getConfiguration("http");return!a.get("experimental.systemCertificatesV2",c)&&!!a.get("systemCertificates")}function P(i){const a=i.getConfiguration("http");return!!a.get("experimental.systemCertificatesV2",c)&&!!a.get("systemCertificates")}const v=new Map;function o(i,a){return i.getExtensionPathIndex().then(t=>{const r=globalThis._VSCODE_NODE_MODULES.module,n=r._load;r._load=function(l,g,y){if(l==="net")return a.net;if(l==="tls")return a.tls;if(l!=="http"&&l!=="https")return n.apply(this,arguments);const k=t.findSubstr(T.URI.file(g.filename));let S=v.get(k);if(S||v.set(k,S={}),!S[l]){const R=a[l];S[l]={...R}}return S[l]}})}async function m(i,a,t,r,n,u,l,g,y,k,S){const R=n[y];k&&(n[y]=k),a.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${y}`,`proxyAuthenticate:${k}`,`proxyAuthenticateCache:${R}`);const C=k||R,w=Array.isArray(C)?C:typeof C=="string"?[C]:[];if(d(t,w,l),w.some(N=>/^(Negotiate|Kerberos)( |$)/i.test(N))&&!S.kerberosRequested){S.kerberosRequested=!0;try{const N=await new Promise((F,j)=>{ge(["kerberos"],F,j)}).then(Ue),L=new URL(y),M=r.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${L.hostname}`:`HTTP@${L.hostname}`);return a.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${y}`,`spn:${M}`),"Negotiate "+await(await N.initializeClient(M)).step("")}catch(N){a.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",N)}if(l&&g){a.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup on host",`proxyURL:${y}`);const N=await i.lookupKerberosAuthorization(y);if(N)return"Negotiate "+N}}const b=w.find(N=>/^Basic( |$)/i.test(N));if(b)try{const N=u[y];if(N)if(S.basicAuthCacheUsed)a.debug("ProxyResolver#lookupProxyAuthorization Basic authentication deleting cached credentials",`proxyURL:${y}`),delete u[y];else return a.debug("ProxyResolver#lookupProxyAuthorization Basic authentication using cached credentials",`proxyURL:${y}`),S.basicAuthCacheUsed=!0,N;S.basicAuthAttempt=(S.basicAuthAttempt||0)+1;const L=/ realm="([^"]+)"/i.exec(b)?.[1];a.debug("ProxyResolver#lookupProxyAuthorization Basic authentication lookup",`proxyURL:${y}`,`realm:${L}`);const M=new URL(y),z={scheme:"basic",host:M.hostname,port:Number(M.port),realm:L||"",isProxy:!0,attempt:S.basicAuthAttempt},V=await i.lookupAuthorization(z);if(V){a.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received credentials",`proxyURL:${y}`,`realm:${L}`);const F="Basic "+Buffer.from(`${V.username}:${V.password}`).toString("base64");return u[y]=F,F}else a.debug("ProxyResolver#lookupProxyAuthorization Basic authentication received no credentials",`proxyURL:${y}`,`realm:${L}`)}catch(N){a.error("ProxyResolver#lookupProxyAuthorization Basic authentication failed",N)}}let $=!1;function d(i,a,t){$||!a.length||($=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:a.map(r=>r.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(Re[256],Ce([1,0,146]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=D;function h(O){return{transformIncoming:T=>T.scheme==="vscode-remote"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="file"?{scheme:"vscode-local",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoing:T=>T.scheme==="file"?{scheme:"vscode-remote",authority:O,path:T.path,query:T.query,fragment:T.fragment}:T.scheme==="vscode-local"?{scheme:"file",path:T.path,query:T.query,fragment:T.fragment}:T,transformOutgoingScheme:T=>T==="file"?"vscode-remote":T==="vscode-local"?"file":T}}function D(O){return new s.$Un(h(O))}});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[158],Ce([1,0,7,17,2,3,5,37,27,14,52,207,45]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$JG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$zG=e.EditorInputCapabilities=e.$yG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=void 0,e.$pG=o,e.$qG=m,e.$rG=$,e.$sG=d,e.$tG=i,e.$uG=a,e.$vG=t,e.$wG=r,e.$xG=n,e.$AG=S,e.$BG=C,e.$CG=w,e.$DG=b,e.$EG=N,e.$FG=L,e.$GG=M,e.$HG=z,e.$IG=B,e.$KG=x,e.$LG=te,e.$MG=me,e.$NG=ce,f=Ht(f),e.$kG={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$lG={id:"default",displayName:(0,s.localize)(4060,null),providerDisplayName:(0,s.localize)(4061,null)},e.$mG="workbench.editor.sidebysideEditor",e.$nG="workbench.editors.textDiffEditor",e.$oG="workbench.editors.binaryResourceDiffEditor";var P;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var v;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function o(Y){const q=Y;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function m(Y){const q=Y;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function $(Y,q,se){for(const be of se.visibleEditorPanes)if(be.group.id===q&&Y.matches(be.input))return be.getViewState()}function d(Y){if(S(Y))return!1;const q=Y;return D.URI.isUri(q?.resource)}function i(Y){if(S(Y))return!1;const q=Y;return q?.original!==void 0&&q.modified!==void 0}function a(Y){if(S(Y))return!1;const q=Y;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(Y){if(S(Y)||i(Y))return!1;const q=Y;return q?.primary!==void 0&&q.secondary!==void 0}function r(Y){if(S(Y))return!1;const q=Y;return q?q.resource===void 0||q.resource.scheme===c.Schemas.untitled||q.forceUntitled===!0:!1}function n(Y){if(S(Y))return!1;const q=Y;return D.URI.isUri(q?.base?.resource)&&D.URI.isUri(q?.input1?.resource)&&D.URI.isUri(q?.input2?.resource)&&D.URI.isUri(q?.result?.resource)}var u;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(u||(e.Verbosity=u={}));var l;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class g{constructor(){this.a=new Map}registerSource(q,se){let be=this.a.get(q);return be||(be={source:q,label:se},this.a.set(q,be)),be.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$yG=new g;var y;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(y||(e.EditorInputCapabilities=y={}));class k extends O.$Zc{}e.$zG=k;function S(Y){return Y instanceof k}function R(Y){const q=Y;return D.URI.isUri(q?.preferredResource)}function C(Y){const q=Y;return S(q?.primary)&&S(q?.secondary)}function w(Y){const q=Y;return S(q?.modified)&&S(q?.original)}function b(Y,q,se,be,ae){return ce(be,[(0,E.$uj)({id:"workbench.action.openLargeFile",label:(0,s.localize)(4062,null),run:()=>{const we={...se,limits:{size:Number.MAX_VALUE}};Y.openEditor(q,we)}}),(0,E.$uj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,s.localize)(4063,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}function N(Y){return S(Y?.editor)}function L(Y){const q=Y;return N(Y)&&q?.group!==void 0}function M(Y){const q=Y;return typeof q?.groupId=="number"&&S(q.editor)}function z(Y){return typeof Y?.groupId=="number"}var V;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var F;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var j;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class W{getOriginalUri(q,se){if(!q)return;if(n(q))return e.$JG.getOriginalUri(q.result,se);if(se?.supportSideBySide){const{primary:ae,secondary:we}=this.a(q);if(ae&&we){if(se?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(we,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===j.ANY)return this.getOriginalUri(ae,{filterByScheme:se.filterByScheme})??this.getOriginalUri(we,{filterByScheme:se.filterByScheme});q=se.supportSideBySide===j.PRIMARY?ae:we}}if(i(q)||a(q)||t(q)||n(q))return;const be=R(q)?q.preferredResource:q.resource;return!be||!se||!se.filterByScheme?be:this.b(be,se.filterByScheme)}a(q){return C(q)||t(q)?{primary:q.primary,secondary:q.secondary}:w(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,se){if(!q)return;if(n(q))return e.$JG.getCanonicalUri(q.result,se);if(se?.supportSideBySide){const{primary:ae,secondary:we}=this.a(q);if(ae&&we){if(se?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(we,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===j.ANY)return this.getCanonicalUri(ae,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(we,{filterByScheme:se.filterByScheme});q=se.supportSideBySide===j.PRIMARY?ae:we}}if(i(q)||a(q)||t(q)||n(q))return;const be=q.resource;return!be||!se||!se.filterByScheme?be:this.b(be,se.filterByScheme)}b(q,se){if(Array.isArray(se)){if(se.some(be=>q.scheme===be))return q}else if(se===q.scheme)return q}}var J;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(J||(e.EditorCloseMethod=J={}));function B(Y,q,se,be){if(!Y.isSticky(q))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return se===J.MOUSE||se===J.KEYBOARD;case"mouse":return se===J.MOUSE;case"keyboard":return se===J.KEYBOARD}return!1}e.$JG=new W;var U;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(U||(e.CloseDirection=U={}));class _{constructor(){this.c=new Map,this.d=new Map}start(q){const se=this.a=q.get(T.$Ji);for(const[be,ae]of this.c)this.e(be,ae,se);this.c.clear()}e(q,se,be){const ae=be.createInstance(se);this.d.set(q,ae)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,h.$ug)(this.b)}registerEditorSerializer(q,se){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,se,this.a):this.c.set(q,se),(0,O.$Xc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}A.$zo.add(e.$kG.EditorFactory,new _);async function x(Y,q,se){return!Y||!Y.length?[]:await Promise.all(Y.map(async be=>{const ae=D.URI.revive(be.fileUri);if(!ae){se.info("Cannot resolve the path because it is not valid.",be);return}if(!await q.canHandleResource(ae)){se.info("Cannot resolve the path because it cannot be handled",be);return}let $e=be.exists,pe=be.type;if(typeof $e!="boolean"||typeof pe!="number")try{pe=(await q.stat(ae)).isDirectory?p.FileType.Directory:p.FileType.Unknown,$e=!0}catch(Fe){se.error(Fe),$e=!1}if(!$e&&be.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",be);return}if(pe===p.FileType.Directory){se.info("Cannot resolve the path because it is a directory",be);return}const Oe={...be.options,pinned:!0};return $e?{resource:ae,options:Oe}:{resource:ae,options:Oe,forceUntitled:!0}}))}var oe;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(oe||(e.EditorsOrder=oe={}));function te(Y){const q=Y;if(!q)return!1;const se=q;if(se.modified)return te(se.modified);const be=q;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function me(Y){return(0,I.$wj)(Y)}function ce(Y,q,se){const be=(0,I.$xj)(Y,q);return be.forceMessage=se?.forceMessage,be.forceSeverity=se?.forceSeverity,be.allowDialog=se?.allowDialog,be}}),define(Re[257],Ce([1,0,4,7,5,3,28,37,24,84,248]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VG=e.$UG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$TG=e.ViewContentGroups=e.$RG=e.ViewContainerLocation=e.Extensions=e.$QG=e.$PG=e.$OG=void 0,e.$SG=P,e.$OG="views",e.$PG=(0,h.localize)(4223,null),e.$QG=(0,I.$Mx)("default-view-icon",c.$0j.window,(0,h.localize)(4224,null));var E;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var f;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(f||(e.ViewContainerLocation=f={})),e.$RG=[f.Sidebar,f.Panel,f.AuxiliaryBar];function P(r){switch(r){case f.Sidebar:return"sidebar";case f.Panel:return"panel";case f.AuxiliaryBar:return"auxiliarybar"}}class v extends O.$Zc{constructor(){super(...arguments),this.c=this.B(new s.$qe),this.onDidRegister=this.c.event,this.f=this.B(new s.$qe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(n,u,l){const g=this.get(n.id);if(g)return g;const y=n;return y.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,T.$Cc)(this.g,u,[]).push(y),l?.isDefault&&this.h.push(y),this.c.fire({viewContainer:y,viewContainerLocation:u}),y}deregisterViewContainer(n){for(const u of this.g.keys()){const l=this.g.get(u),g=l?.indexOf(n);if(g!==-1){l?.splice(g,1),l.length===0&&this.g.delete(u),this.f.fire({viewContainer:n,viewContainerLocation:u});return}}}get(n){return this.all.filter(u=>u.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(l=>l?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(u=>this.getViewContainerLocation(u)===n)}}A.$zo.add(E.ViewContainersRegistry,new v);var o;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(o||(e.ViewContentGroups=o={}));function m(r,n){const u=r.group??o.More,l=n.group??o.More;return u!==l?u.localeCompare(l):(r.order??5)-(n.order??5)}class $ extends O.$Zc{constructor(){super(...arguments),this.c=this.B(new s.$qe),this.onViewsRegistered=this.c.event,this.f=this.B(new s.$qe),this.onViewsDeregistered=this.f.event,this.g=this.B(new s.$qe),this.onDidChangeContainer=this.g.event,this.h=this.B(new s.$qe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new T.$Mc}registerViews(n,u){this.registerViews2([{views:n,viewContainer:u}])}registerViews2(n){n.forEach(({views:u,viewContainer:l})=>this.r(u,l)),this.c.fire(n)}deregisterViews(n,u){const l=this.s(n,u);l.length&&this.f.fire({views:l,viewContainer:u})}moveViews(n,u){for(const l of this.m.keys())if(l!==u){const g=this.s(n,l);g.length&&(this.r(g,u),this.g.fire({views:g,from:l,to:u}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const u of this.j){const l=(this.m.get(u)||[]).filter(g=>g.id===n)[0];if(l)return l}return null}getViewContainer(n){for(const u of this.j)if((this.m.get(u)||[]).filter(g=>g.id===n)[0])return u;return null}registerViewWelcomeContent(n,u){return this.n.add(n,u),this.h.fire(n),(0,O.$Xc)(()=>{this.n.delete(n,u),this.h.fire(n)})}registerViewWelcomeContent2(n,u){const l=new Map;for(const[g,y]of u)this.n.add(n,y),l.set(g,(0,O.$Xc)(()=>{this.n.delete(n,y),this.h.fire(n)}));return this.h.fire(n),l}getViewWelcomeContent(n){const u=[];return this.n.forEach(n,l=>u.push(l)),u.sort(m)}r(n,u){let l=this.m.get(u);l||(l=[],this.m.set(u,l),this.j.push(u));for(const g of n){if(this.getView(g.id)!==null)throw new Error((0,h.localize)(4225,null,g.id));l.push(g)}}s(n,u){const l=this.m.get(u);if(!l)return[];const g=[],y=[];for(const k of l)n.includes(k)?g.push(k):y.push(k);return g.length&&(y.length?this.m.set(u,y):(this.m.delete(u),this.j.splice(this.j.indexOf(u),1))),g}}A.$zo.add(E.ViewsRegistry,new $),e.$TG=(0,D.$Ki)("viewDescriptorService");var d;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(d||(e.ViewVisibilityState=d={}));var i;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class a{constructor(n,u){this.c=!1,this.d=!1,(0,p.$po)(this,n),this.d=!!u,this.resolve=async l=>{if(u&&!this.c){const g=await u(l);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$UG=a;class t extends Error{constructor(n){super((0,h.localize)(4226,null,n)),this.name="NoTreeViewError"}static is(n){return!!n&&n.name==="NoTreeViewError"}}e.$VG=t}),define(Re[258],Ce([1,0,7,36]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=void 0,e.$ZG=new h.$2j("chatSessionResponseVote","",{type:"string",description:(0,s.localize)(4721,null)}),e.$1G=new h.$2j("chatVoteUpEnabled",!1,{type:"boolean",description:(0,s.localize)(4722,null)}),e.$2G=new h.$2j("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,s.localize)(4723,null)}),e.$3G=new h.$2j("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,s.localize)(4724,null)}),e.$4G=new h.$2j("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,s.localize)(4725,null)}),e.$5G=new h.$2j("chatSessionResponseError",!1,{type:"boolean",description:(0,s.localize)(4726,null)}),e.$6G=new h.$2j("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,s.localize)(4727,null)}),e.$7G=new h.$2j("chatResponse",!1,{type:"boolean",description:(0,s.localize)(4728,null)}),e.$8G=new h.$2j("chatRequest",!1,{type:"boolean",description:(0,s.localize)(4729,null)}),e.$9G=new h.$2j("chatEditApplied",!1,{type:"boolean",description:(0,s.localize)(4730,null)}),e.$0G=new h.$2j("chatInputHasText",!1,{type:"boolean",description:(0,s.localize)(4731,null)}),e.$$G=new h.$2j("chatInputHasFocus",!1,{type:"boolean",description:(0,s.localize)(4732,null)}),e.$_G=new h.$2j("inChatInput",!1,{type:"boolean",description:(0,s.localize)(4733,null)}),e.$aH=new h.$2j("inChat",!1,{type:"boolean",description:(0,s.localize)(4734,null)}),e.$bH=new h.$2j("chatIsEnabled",!1,{type:"boolean",description:(0,s.localize)(4735,null)}),e.$cH=new h.$2j("chatPanelParticipantRegistered",!1,{type:"boolean",description:(0,s.localize)(4736,null)}),e.$dH=new h.$2j("chatExtensionInvalid",!1,{type:"boolean",description:(0,s.localize)(4737,null)}),e.$eH=new h.$2j("chatCursorAtTop",!1),e.$fH=new h.$2j("chatInputHasAgent",!1),e.$gH=new h.$2j("chatLocation",void 0),e.$hH=new h.$2j("quickChatHasFocus",!1,{type:"boolean",description:(0,s.localize)(4738,null)})}),define(Re[159],Ce([1,0,134,8,20,4,40,3,38,187,13,36,23,5,11,115,241,157,258]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.ChatAgentLocation=void 0,e.$qI=u,e.$rI=l;var a;(function(g){g.Panel="panel",g.Terminal="terminal",g.Notebook="notebook",g.Editor="editor"})(a||(e.ChatAgentLocation=a={})),function(g){function y(k){switch(k){case"panel":return g.Panel;case"terminal":return g.Terminal;case"notebook":return g.Notebook;case"editor":return g.Editor}return g.Panel}g.fromRaw=y}(a||(e.ChatAgentLocation=a={})),e.$lI=(0,P.$Ki)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(y){this.g=y,this.b=new Map,this.d=new O.$qe,this.onDidChangeAgents=this.d.event,this.h=new Map,this.j=new Map,this.e=d.$bH.bindTo(this.g),this.f=d.$cH.bindTo(this.g)}registerAgent(y,k){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);k.isDefault&&this.f.set(!0);const R=this,C=k.slashCommands;k={...k,get slashCommands(){return C.filter(b=>!b.when||R.g.contextMatchesRules(E.$Ij.deserialize(b.when)))}};const w={data:k};return this.b.set(y,w),this.d.fire(void 0),(0,A.$Xc)(()=>{this.b.delete(y),k.isDefault&&this.f.set(!1),this.d.fire(void 0)})}registerAgentImplementation(y,k){const S=this.b.get(y);if(!S)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(S.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return S.data.isDefault&&this.e.set(!0),S.impl=k,this.d.fire(new r(S.data,k)),(0,A.$Xc)(()=>{S.impl=void 0,this.d.fire(void 0),S.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(y,k){y.isDynamic=!0;const S={data:y,impl:k};return this.b.set(y.id,S),this.d.fire(new r(y,k)),(0,A.$Xc)(()=>{this.b.delete(y.id),this.d.fire(void 0)})}registerAgentCompletionProvider(y,k){return this.h.set(y,k),{dispose:()=>{this.h.delete(y)}}}async getAgentCompletionItems(y,k,S){return await this.h.get(y)?.(k,S)??[]}updateAgent(y,k){const S=this.b.get(y);if(!S?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);S.data.metadata={...S.data.metadata,...k},this.d.fire(new r(S.data,S.impl))}getDefaultAgent(y){return(0,s.$jb)(this.getActivatedAgents(),k=>!!k.isDefault&&k.locations.includes(y))}getContributedDefaultAgent(y){return this.getAgents().find(k=>!!k.isDefault&&k.locations.includes(y))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),y=>!!y.data.metadata.isSecondary)?.data}getAgent(y){if(this.i(y))return this.b.get(y)?.data}i(y){const k=this.b.get(y);return!k?.data.when||this.g.contextMatchesRules(E.$Ij.deserialize(k.data.when))}getAgentByFullyQualifiedId(y){const k=T.Iterable.find(this.b.values(),S=>u(S.data)===y)?.data;if(!(k&&!this.i(k.id)))return k}getAgents(){return Array.from(this.b.values()).map(y=>y.data).filter(y=>this.i(y.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(y=>!!y.impl).filter(y=>this.i(y.data.id)).map(y=>new r(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(k=>k.name===y)}agentHasDupeName(y){const k=this.getAgent(y);return k?this.getAgentsByName(k.name).filter(S=>S.extensionId.value!==k.extensionId.value).length>0:!1}async invokeAgent(y,k,S,R,C){const w=this.b.get(y);if(!w?.impl)throw new Error(`No activated agent with id "${y}"`);return await w.impl.invoke(k,S,R,C)}async getFollowups(y,k,S,R,C){const w=this.b.get(y);if(!w?.impl)throw new Error(`No activated agent with id "${y}"`);return w.impl?.provideFollowups?w.impl.provideFollowups(k,S,R,C):[]}async getChatTitle(y,k,S){const R=this.b.get(y);if(!R?.impl)throw new Error(`No activated agent with id "${y}"`);if(R.impl?.provideChatTitle)return R.impl.provideChatTitle(k,S)}registerChatParticipantDetectionProvider(y,k){return this.j.set(y,k),(0,A.$Xc)(()=>{this.j.delete(y)})}hasChatParticipantDetectionProviders(){return this.j.size>0}async detectAgentOrCommand(y,k,S,R){const C=T.Iterable.first(this.j.values());if(!C)return;const w=this.getAgents().reduce((M,z)=>{M.push({participant:z.id,disambiguation:z.disambiguation??[]});for(const V of z.slashCommands)M.push({participant:z.id,command:V.name,disambiguation:V.disambiguation??[]});return M},[]),b=await C.provideParticipantDetection(y,k,{...S,participants:w},R);if(!b)return;const N=this.getAgent(b.participant);if(!N)return;if(!b.command)return{agent:N};const L=N?.slashCommands.find(M=>M.name===b.command);if(L)return{agent:N,command:L}}};e.$mI=t,e.$mI=t=Ye([We(0,E.$3j)],t);class r{constructor(y,k){this.b=y,this.d=k}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}get disambiguation(){return this.b.disambiguation}async invoke(y,k,S,R){return this.d.invoke(y,k,S,R)}async provideFollowups(y,k,S,R){return this.d.provideFollowups?this.d.provideFollowups(y,k,S,R):[]}provideWelcomeMessage(y,k){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(y,k)}provideSampleQuestions(y,k){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(y,k)}toJSON(){return this.b}}e.$nI=r,e.$oI=(0,P.$Ki)("chatAgentNameService");let n=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(y,k,S,R){if(this.g=k,this.h=S,this.i=R,this.e=(0,c.$$d)(this,Object.create(null)),this.f=!1,!y.chatParticipantRegistry)return;this.d=y.chatParticipantRegistry;const C=R.get(i.b,$.StorageScope.APPLICATION);try{this.e.set(JSON.parse(C??"{}"),void 0)}catch{R.remove(i.b,$.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(y=>this.h.warn("Failed to fetch chat participant registry",y)).then(()=>(0,h.$Lh)(5*60*1e3)).then(()=>this.j())}async k(){const y=await this.g.request({type:"GET",url:this.d},D.CancellationToken.None);if(y.res.statusCode!==200)throw new Error("Could not get extensions report.");const k=await(0,m.$jq)(y);if(!k||k.version!==1)throw new Error("Unexpected chat participant registry response.");const S=k.restrictedChatParticipants;this.e.set(S,void 0),this.i.store(i.b,JSON.stringify(S),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}getAgentNameRestriction(y){const k=this.l(y.name,y).get(),S=!y.fullName||this.l(y.fullName.replace(/\s/g,""),y).get();return k&&S}l(y,k){return this.e.map(R=>R[y.toLowerCase()]).map(R=>R?R.some(C=>(0,I.$Kf)(C,C.includes(".")?k.extensionId.value:k.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$pI=n,e.$pI=n=i=Ye([We(0,o.$yk),We(1,m.$dq),We(2,v.$fk),We(3,$.$qq)],n);function u(g){return`${g.extensionId.value}.${g.id}`}function l(g){const y="name"in g?g:{...g,name:g.id};return"extensionPublisherId"in y||(y.extensionPublisherId=y.extensionPublisher??""),"extensionDisplayName"in y||(y.extensionDisplayName=""),"extensionId"in y||(y.extensionId=new f.$zn("")),(0,p.$hi)(y)}}),define(Re[259],Ce([1,0,2,30,5]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TH=e.$SH=e.ChatCopyKind=e.ChatAgentVoteDownReason=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$QH=O,e.$RH=T;function O(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof s.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(h.$Yt.isIRange)}function T(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(O)}var A;(function(E){E[E.Complete=1]="Complete",E[E.Partial=2]="Partial",E[E.Omitted=3]="Omitted"})(A||(e.ChatResponseReferencePartStatusKind=A={}));var p;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(p||(e.ChatAgentVoteDirection=p={}));var c;(function(E){E.IncorrectCode="incorrectCode",E.DidNotFollowInstructions="didNotFollowInstructions",E.IncompleteCode="incompleteCode",E.MissingContext="missingContext",E.PoorlyWrittenOrFormatted="poorlyWrittenOrFormatted",E.RefusedAValidRequest="refusedAValidRequest",E.OffensiveOrUnsafe="offensiveOrUnsafe",E.Other="other",E.WillReportIssue="willReportIssue"})(c||(e.ChatAgentVoteDownReason=c={}));var I;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(I||(e.ChatCopyKind=I={})),e.$SH=(0,D.$Ki)("IChatService"),e.$TH="accessibility.voice.keywordActivation"}),define(Re[160],Ce([1,0,4,8,7]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pwb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new s.$qe,this.o=new s.$qe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(A){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=A}onEvent(A){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=A}onRequest(A){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.u("response",A)}sendRequest(A,p,c,I){const E={command:A};if(p&&Object.keys(p).length>0&&(E.arguments=p),this.u("request",E),typeof I=="number"){const f=setTimeout(()=>{clearTimeout(f);const P=this.f.get(E.seq);if(P){this.f.delete(E.seq);const v={type:"response",seq:0,request_seq:E.seq,success:!1,command:A,message:(0,D.localize)(5738,null,I,A)};P(v)}},I)}return c&&this.f.set(E.seq,c),E.seq}acceptMessage(A){this.k?this.k(A):(this.m.push(A),this.m.length===1&&this.s())}q(A,p){return A.type!=="event"||p.type!=="event"}async s(){let A;for(;this.m.length;){if((!A||this.q(this.m[0],A))&&await(0,h.$Lh)(0),A=this.m.shift(),!A)return;switch(A.type){case"event":this.j?.(A);break;case"request":this.g?.(A);break;case"response":{const p=A,c=this.f.get(p.request_seq);c&&(this.f.delete(p.request_seq),c(p));break}}}}u(A,p){p.type=A,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((p,c)=>A.set(c,p)),await(0,h.$Lh)(500),A.forEach((p,c)=>{p({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$pwb=O}),define(Re[120],Ce([1,0,2,7,36,5]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$cL=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$aL=e.MemoryRangeType=e.State=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=void 0,e.$_K=p,e.$bL=I,h=Ue(h),e.$ZJ="workbench.view.debug",e.$1J="workbench.debug.variablesView",e.$2J="workbench.debug.watchExpressionsView",e.$3J="workbench.debug.callStackView",e.$4J="workbench.debug.loadedScriptsView",e.$5J="workbench.debug.breakPointsView",e.$6J="workbench.debug.disassemblyView",e.$7J="workbench.panel.repl",e.$8J="workbench.panel.repl.view",e.$9J=new D.$2j("debugType",void 0,{type:"string",description:h.localize(5739,null)}),e.$0J=new D.$2j("debugConfigurationType",void 0,{type:"string",description:h.localize(5740,null)}),e.$$J=new D.$2j("debugState","inactive",{type:"string",description:h.localize(5741,null)}),e.$_J="debugUx",e.$aK=new D.$2j(e.$_J,"default",{type:"string",description:h.localize(5742,null)}),e.$bK=new D.$2j("hasDebugged",!1,{type:"boolean",description:h.localize(5743,null)}),e.$cK=new D.$2j("inDebugMode",!1,{type:"boolean",description:h.localize(5744,null)}),e.$dK=new D.$2j("inDebugRepl",!1,{type:"boolean",description:h.localize(5745,null)}),e.$eK=new D.$2j("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(5746,null)}),e.$fK=new D.$2j("inBreakpointWidget",!1,{type:"boolean",description:h.localize(5747,null)}),e.$gK=new D.$2j("breakpointsFocused",!0,{type:"boolean",description:h.localize(5748,null)}),e.$hK=new D.$2j("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(5749,null)}),e.$iK=new D.$2j("watchExpressionsExist",!1,{type:"boolean",description:h.localize(5750,null)}),e.$jK=new D.$2j("variablesFocused",!0,{type:"boolean",description:h.localize(5751,null)}),e.$kK=new D.$2j("expressionSelected",!1,{type:"boolean",description:h.localize(5752,null)}),e.$lK=new D.$2j("breakpointInputFocused",!1,{type:"boolean",description:h.localize(5753,null)}),e.$mK=new D.$2j("callStackItemType",void 0,{type:"string",description:h.localize(5754,null)}),e.$nK=new D.$2j("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(5755,null)}),e.$oK=new D.$2j("callStackItemStopped",!1,{type:"boolean",description:h.localize(5756,null)}),e.$pK=new D.$2j("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(5757,null)}),e.$qK=new D.$2j("watchItemType",void 0,{type:"string",description:h.localize(5758,null)}),e.$rK=new D.$2j("canViewMemory",void 0,{type:"boolean",description:h.localize(5759,null)}),e.$sK=new D.$2j("breakpointItemType",void 0,{type:"string",description:h.localize(5760,null)}),e.$tK=new D.$2j("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(5761,null)}),e.$uK=new D.$2j("breakpointHasModes",!1,{type:"boolean",description:h.localize(5762,null)}),e.$vK=new D.$2j("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(5763,null)}),e.$wK=new D.$2j("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(5764,null)}),e.$xK=new D.$2j("loadedScriptsItemType",void 0,{type:"string",description:h.localize(5765,null)}),e.$yK=new D.$2j("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(5766,null)}),e.$zK=new D.$2j("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(5767,null)}),e.$AK=new D.$2j("stepBackSupported",!1,{type:"boolean",description:h.localize(5768,null)}),e.$BK=new D.$2j("restartFrameSupported",!1,{type:"boolean",description:h.localize(5769,null)}),e.$CK=new D.$2j("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(5770,null)}),e.$DK=new D.$2j("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(5771,null)}),e.$EK=new D.$2j("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(5772,null)}),e.$FK=new D.$2j("breakpointsExist",!1,{type:"boolean",description:h.localize(5773,null)}),e.$GK=new D.$2j("debuggersAvailable",!1,{type:"boolean",description:h.localize(5774,null)}),e.$HK=new D.$2j("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(5775,null)}),e.$IK=new D.$2j("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(5776,null)}),e.$JK=new D.$2j("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(5777,null)}),e.$KK=new D.$2j("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(5778,null)}),e.$LK=new D.$2j("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(5779,null)}),e.$MK=new D.$2j("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(5780,null)}),e.$NK=new D.$2j("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(5781,null)}),e.$OK=new D.$2j("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(5782,null)}),e.$PK=new D.$2j("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(5783,null)}),e.$QK=new D.$2j("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(5784,null)}),e.$RK=new D.$2j("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(5785,null)}),e.$SK=new D.$2j("variableIsReadonly",!1,{type:"boolean",description:h.localize(5786,null)}),e.$TK=new D.$2j("variableValue",!1,{type:"string",description:h.localize(5787,null)}),e.$UK=new D.$2j("variableType",!1,{type:"string",description:h.localize(5788,null)}),e.$VK=new D.$2j("variableInterfaces",!1,{type:"array",description:h.localize(5789,null)}),e.$WK=new D.$2j("variableName",!1,{type:"string",description:h.localize(5790,null)}),e.$XK=new D.$2j("variableLanguage",!1,{type:"string",description:h.localize(5791,null)}),e.$YK=new D.$2j("variableExtensionId",!1,{type:"string",description:h.localize(5792,null)}),e.$ZK=new D.$2j("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(5793,null)}),e.$1K=new D.$2j("multiSessionRepl",!1,{type:"boolean",description:h.localize(5794,null)}),e.$2K=new D.$2j("multiSessionDebug",!1,{type:"boolean",description:h.localize(5795,null)}),e.$3K=new D.$2j("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(5796,null)}),e.$4K=new D.$2j("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(5797,null)}),e.$5K=new D.$2j("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(5798,null)}),e.$6K=new D.$2j("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(5799,null)});const T=i=>h.localize(5800,null,i);e.$7K=T,e.$8K="editor.contrib.debug",e.$9K="editor.contrib.breakpoint",e.$0K="debug",e.$$K={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(5801,null)};var A;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(A||(e.State=A={}));function p(i){switch(i){case A.Initializing:return"initializing";case A.Stopped:return"stopped";case A.Running:return"running";default:return"inactive"}}var c;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$aL="vscode-debug-memory";function I(i){const a=i.presentationHint??i.source.presentationHint;return a==="deemphasize"||a==="subtle"}var E;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(E||(e.DataBreakpointSetType=E={}));var f;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var P;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$cL=(0,O.$Ki)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var o;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(o||(e.DebugVisualizationType=o={}));var m;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var $;(function(i){i.deserialize=a=>a,i.serialize=a=>a})($||(e.IDebugVisualizationTreeItem=$={}));var d;(function(i){i.deserialize=a=>({id:a.id,name:a.name,iconPath:a.iconPath&&{light:s.URI.revive(a.iconPath.light),dark:s.URI.revive(a.iconPath.dark)},iconClass:a.iconClass,visualization:a.visualization}),i.serialize=a=>a})(d||(e.IDebugVisualization=d={}))}),define(Re[260],Ce([1,0,13,2,16,24,14,30,20,18]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GI=void 0,e.$uI=E,e.$vI=f,e.$wI=P,e.$xI=v,e.$yI=o,e.$zI=m,e.$AI=$,e.$BI=i,e.$CI=r,e.$DI=n,e.$EI=l,e.$FI=y;const I=/{([^}]+)}/g;function E(S,R,C){return S.replace(I,function(w,b){return R&&b.length>0&&b[0]!=="_"?w:C&&C.hasOwnProperty(b)?C[b]:w})}function f(S){const R={};for(const C of Object.keys(S))C.startsWith("!")||(R[C]=S[C]);return R}function P(S){return S.configuration.request==="attach"&&!v(S)&&(!S.parentSession||P(S.parentSession))}function v(S){let R=S.configuration.type;if(R)return R==="vslsShare"&&(R=S.configuration.adapterProxy.configuration.type),(0,s.$Kf)(R,"extensionhost")||(0,s.$Kf)(R,"pwa-extensionhost")?S:S.parentSession?v(S.parentSession):void 0}function o(S){return S.type&&(S.label||S.program||S.runtime)}function m(S,R,C){let w,b=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let L=null;for(;L=N.exec(S);){const M=L.index+1,z=M+L[0].length;if(M<=R&&z>=C){w=L[0],b=M;break}}if(w){const M=/(\w|\p{L})+/gu;let z=null;for(;(z=M.exec(w))&&!(z.index+1+b+z[0].length>=C););z&&(w=w.substring(0,M.lastIndex))}return w?{start:b,end:b+w.length-1}:{start:0,end:0}}async function $(S,R,C,w){if(S.evaluatableExpressionProvider.has(R)){const b=S.evaluatableExpressionProvider.ordered(R),N=(0,c.$Lb)(await Promise.all(b.map(async L=>{try{return await L.provideEvaluatableExpression(R,C,w??p.CancellationToken.None)}catch{return}})));if(N.length>0){let L=N[0].expression;const M=N[0].range;return L||(L=R.getLineContent(C.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:L}}}else{const b=R.getLineContent(C.lineNumber),{start:N,end:L}=m(b,C.column,C.column),M=b.substring(N-1,L);return{matchingExpression:M,range:new A.$Yt(C.lineNumber,N,C.lineNumber,N+M.length)}}return null}const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(S){return!!(S&&S.match(d))}function a(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(i(S.path))return h.URI.parse(S.path);if((0,D.$nc)(S.path))return h.URI.file(S.path)}return S.path}function t(S){if(typeof S.path=="object"){const R=h.URI.revive(S.path);if(R)return R.scheme===T.Schemas.file?R.fsPath:R.toString()}return S.path}function r(S,R){const C=R?a:t,w=(0,O.$mo)(S);return u(w,(b,N)=>{b&&N&&(N.path=C(N))}),w}function n(S,R){const C=R?a:t,w=(0,O.$mo)(S);return u(w,(b,N)=>{!b&&N&&(N.path=C(N))}),w}function u(S,R){switch(S.type){case"event":{const C=S;switch(C.event){case"output":R(!1,C.body.source);break;case"loadedSource":R(!1,C.body.source);break;case"breakpoint":R(!1,C.body.breakpoint.source);break;default:break}break}case"request":{const C=S;switch(C.command){case"setBreakpoints":R(!0,C.arguments.source);break;case"breakpointLocations":R(!0,C.arguments.source);break;case"source":R(!0,C.arguments.source);break;case"gotoTargets":R(!0,C.arguments.source);break;case"launchVSCode":C.arguments.args.forEach(w=>R(!1,w));break;default:break}break}case"response":{const C=S;if(C.success&&C.body)switch(C.command){case"stackTrace":C.body.stackFrames.forEach(w=>R(!1,w.source));break;case"loadedSources":C.body.sources.forEach(w=>R(!1,w));break;case"scopes":C.body.scopes.forEach(w=>R(!1,w.source));break;case"setFunctionBreakpoints":C.body.breakpoints.forEach(w=>R(!1,w.source));break;case"setBreakpoints":C.body.breakpoints.forEach(w=>R(!1,w.source));break;case"disassemble":C.body?.instructions.forEach(b=>R(!1,b.location));break;case"locations":R(!1,C.body?.source);break;default:break}break}}}function l(S){return S.filter(R=>!R.presentation?.hidden).sort((R,C)=>R.presentation?C.presentation?R.presentation.group?C.presentation.group?R.presentation.group!==C.presentation.group?R.presentation.group.localeCompare(C.presentation.group):g(R.presentation.order,C.presentation.order):-1:C.presentation.group?1:g(R.presentation.order,C.presentation.order):-1:C.presentation?1:0)}function g(S,R){return typeof S!="number"?typeof R!="number"?0:1:typeof R!="number"?-1:S-R}async function y(S,R){const C=S.getValue("debug.saveBeforeStart",{overrideIdentifier:R.activeTextEditorLanguageId});if(C!=="none"&&(await R.saveAll(),C==="allEditorsInActiveGroup")){const w=R.activeEditorPane;w&&w.input.resource?.scheme===T.Schemas.untitled&&await R.save({editor:w.input,groupId:w.group.id})}await S.reloadConfiguration()}const k=(S,R)=>!S||!R?S===R:S.name===R.name&&S.path===R.path&&S.sourceReference===R.sourceReference;e.$GI=k}),define(Re[261],Ce([1,0,58,68,24,16,10,13,34,7,160]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vtc=e.$utc=e.$ttc=e.$stc=e.$rtc=void 0,s=Ue(s),h=Ue(h),D=Ue(D),O=Ue(O),T=Ue(T),A=Ue(A),c=Ue(c);class E extends I.$pwb{static{this.b=`\r
\r
`}static{this.i=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v($,d){this.p=d,this.r=Buffer.allocUnsafe(0),this.t=-1,$.on("data",i=>this.x(i))}sendMessage($){if(this.p){const d=JSON.stringify($);this.p.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${E.b}${d}`,"utf8")}}x($){for(this.r=Buffer.concat([this.r,$]);;){if(this.t>=0){if(this.r.length>=this.t){const d=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(i){this.n.fire(new Error((i.message||i)+`
`+d))}continue}}else{const d=this.r.indexOf(E.b);if(d!==-1){const a=this.r.toString("utf8",0,d).split(E.i);for(const t of a){const r=t.split(E.l);r[0]==="Content-Length"&&(this.t=Number(r[1]))}this.r=this.r.slice(d+E.b.length);continue}}break}}}e.$rtc=E;class f extends E{startSession(){return new Promise(($,d)=>{let i=!1;this.y=this.z(()=>{this.v(this.y,this.y),$(),i=!0}),this.y.on("close",()=>{i?this.n.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.y.on("error",a=>{i?this.n.fire(a):d(a)})})}async stopSession(){await this.w(),this.y&&(this.y.end(),this.y=void 0)}}e.$stc=f;class P extends f{constructor($){super(),this.A=$}z($){return h.createConnection(this.A.port,this.A.host||"127.0.0.1",$)}}e.$ttc=P;class v extends f{constructor($){super(),this.A=$}z($){return h.createConnection(this.A.path,$)}}e.$utc=v;class o extends E{constructor($,d){super(),this.z=$,this.A=d}async startSession(){const $=this.z.command,d=this.z.args,i=this.z.options||{};try{if($)if(O.$nc($)){if(!await p.Promises.exists($))throw new Error(c.localize(5875,null,$))}else $.indexOf("/")<0&&$.indexOf("\\")<0;else throw new Error(c.localize(5876,null,this.A));let a=process.env;if(i.env&&Object.keys(i.env).length>0&&(a=D.$po(D.$mo(process.env),i.env)),$==="node")if(Array.isArray(d)&&d.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:a,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(r.cwd=i.cwd);const n=s.fork(d[0],d.slice(1),r);if(!n.pid)throw new Error(c.localize(5877,null,d[0]));this.y=n}else throw new Error(c.localize(5878,null));else{let t=$,r=d;const n={env:a};i.cwd&&(n.cwd=i.cwd),T.$l&&($.endsWith(".bat")||$.endsWith(".cmd"))&&(n.shell=!0,t=`"${$}"`,r=d.map(u=>(u=u.replace(/"/g,'\\"'),`"${u}"`))),this.y=s.spawn(t,r,n)}this.y.on("error",t=>{this.n.fire(t)}),this.y.on("exit",(t,r)=>{this.o.fire(t)}),this.y.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.y.stdout.on("error",t=>{this.n.fire(t)}),this.y.stdin.on("error",t=>{this.n.fire(t)}),this.y.stderr.resume(),this.v(this.y.stdout,this.y.stdin)}catch(a){this.n.fire(a)}}async stopSession(){return this.y?(await this.w(),T.$l?new Promise(($,d)=>{const i=s.exec(`taskkill /F /T /PID ${this.y.pid}`,function(a,t,r){if(a)return d(a)});i.on("exit",$),i.on("error",d)}):(this.y.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static B($,d){if(!$)return;const i=Object.create(null);$.runtime&&($.runtime.indexOf("./")===0?i.runtime=O.$oc(d,$.runtime):i.runtime=$.runtime),$.runtimeArgs&&(i.runtimeArgs=$.runtimeArgs),$.program&&(O.$nc($.program)?i.program=$.program:i.program=O.$oc(d,$.program)),$.args&&(i.args=$.args);const a=$;return a.win&&(i.win=o.B(a.win,d)),a.winx86&&(i.winx86=o.B(a.winx86,d)),a.windows&&(i.windows=o.B(a.windows,d)),a.osx&&(i.osx=o.B(a.osx,d)),a.linux&&(i.linux=o.B(a.linux,d)),i}static platformAdapterExecutable($,d){let i=Object.create(null);d=d.toLowerCase();for(const l of $)if(l.contributes){const g=l.contributes.debuggers;g&&g.length>0&&g.filter(y=>typeof y.type=="string"&&A.$Kf(y.type,d)).forEach(y=>{const k=o.B(y,l.extensionLocation.fsPath);i=D.$po(i,k,l.isBuiltin)})}let a;T.$l&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?a=i.winx86||i.win||i.windows:T.$l?a=i.win||i.windows:T.$m?a=i.osx:T.$n&&(a=i.linux),a=a||i;const t=a.program||i.program,r=a.args||i.args,n=a.runtime||i.runtime,u=a.runtimeArgs||i.runtimeArgs;if(n)return{type:"executable",command:n,args:(u||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.$vtc=o}),define(Re[262],Ce([1,0,58,33,10]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wtc=T,e.$xtc=p,s=Ue(s),D=Ue(D);function O(c,I){return new Promise((E,f)=>{let P="";const v=s.spawn(c,I);v.pid&&v.stdout.on("data",o=>{P+=o.toString()}),v.on("error",o=>{f(o)}),v.on("close",o=>{E(P)})})}async function T(c){if(c)if(D.$l){const I=await new Promise((E,f)=>{ge(["@vscode/windows-process-tree"],E,f)}).then(Ue);return new Promise(E=>{I.getProcessTree(c,f=>{E(!!f&&f.children.length>0)})})}else return O("/usr/bin/pgrep",["-lP",String(c)]).then(I=>{const E=I.trim();return!(E.length===0||E.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var A;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(A||(A={}));function p(c,I,E,f,P){c=c.trim().toLowerCase();let v;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?v=A.powershell:c.indexOf("cmd.exe")>=0?v=A.cmd:c.indexOf("bash")>=0?v=A.bash:D.$l?v=A.cmd:v=A.bash;let o,m=" ";switch(v){case A.powershell:if(o=$=>($=$.replace(/\'/g,"''"),$.length>0&&$.charAt($.length-1)==="\\"?`'${$}\\'`:`'${$}'`),f){const $=(0,h.$Pg)(f);$&&(m+=`${$}:; `),m+=`cd ${o(f)}; `}if(P)for(const $ in P){const d=P[$];d===null?m+=`Remove-Item env:${$}; `:m+=`\${env:${$}}='${d}'; `}if(I.length>0){const $=I.shift(),d=E?$:o($);m+=d[0]==="'"?`& ${d} `:`${d} `;for(const i of I)m+=i==="<"||i===">"||E?i:o(i),m+=" "}break;case A.cmd:if(o=$=>($=$.replace(/\"/g,'""'),$=$.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(d=>$.includes(d))||$.length===0?`"${$}"`:$),f){const $=(0,h.$Pg)(f);$&&(m+=`${$}: && `),m+=`cd ${o(f)} && `}if(P){m+='cmd /C "';for(const $ in P){let d=P[$];d===null?m+=`set "${$}=" && `:(d=d.replace(/[&^|<>]/g,i=>`^${i}`),m+=`set "${$}=${d}" && `)}}for(const $ of I)m+=$==="<"||$===">"||E?$:o($),m+=" ";P&&(m+='"');break;case A.bash:{o=d=>(d=d.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),d.length===0?'""':d);const $=d=>/[^\w@%\/+=,.:^-]/.test(d)?`'${d.replace(/'/g,"'\\''")}'`:d;if(f&&(m+=`cd ${o(f)} ; `),P){m+="/usr/bin/env";for(const d in P){const i=P[d];i===null?m+=` -u ${$(d)}`:m+=` ${$(`${d}=${i}`)}`}m+=" "}for(const d of I)m+=d==="<"||d===">"||E?d:o(d),m+=" ";break}}return m}}),define(Re[263],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.CellExecutionUpdateType=void 0;var h;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$kL=(0,s.$Ki)("INotebookExecutionService")}),define(Re[264],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oL=e.$nL=e.ProxyKernelState=e.$mL=void 0,e.$mL=100;var h;(function(D){D[D.Disconnected=1]="Disconnected",D[D.Connected=2]="Connected",D[D.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$nL=(0,s.$Ki)("INotebookKernelService"),e.$oL=(0,s.$Ki)("INotebookKernelHistoryService")}),define(Re[265],Ce([1,0,3,30,56,216,106]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$32b=void 0;class A extends s.$Zc{constructor(c,I,E){super(),this._source=c,this.b=I,this.c=E,this.a=void 0}f(c){const I=c.getLineCount();return new h.$Yt(1,1,I,this.g(c,I))}g(c,I){if(I<1||I>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const c=new O.$LD;c.acceptChunk(this._source);const I=c.finish(!0),{textBuffer:E,disposable:f}=I.create(D.DefaultEndOfLine.LF);this.b=E,this.B(f)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const I=new O.$LD;I.acceptChunk(c);const E=I.finish(!0),{textBuffer:f,disposable:P}=E.create(D.DefaultEndOfLine.LF);return this.B(P),f})),this.a}findInInputs(c){const E=new T.$zD(c,!1,!1,null).parseSearchRequest();if(!E)return[];const f=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(f,E,!0,5e3)}findInOutputs(c){const E=new T.$zD(c,!1,!1,null).parseSearchRequest();return E?this.outputTextBuffers.map(f=>{const P=f.findMatchesLineByLine(this.f(f),E,!0,5e3);if(P.length!==0)return{textBuffer:f,matches:P}}).filter(f=>!!f):[]}}e.$32b=A}),define(Re[75],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.TestPosition=e.TestIdPathParts=void 0;var s;(function(O){O.Delimiter="\0"})(s||(e.TestIdPathParts=s={}));var h;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class D{static fromExtHostTestItem(T,A,p=T.parent){if(T._isRoot)return new D([A]);const c=[T.id];for(let I=p;I&&I.id!==A;I=I.parent)c.push(I.id);return c.push(A),new D(c.reverse())}static isRoot(T){return!T.includes(s.Delimiter)}static root(T){const A=T.indexOf(s.Delimiter);return A===-1?T:T.slice(0,A)}static fromString(T){return new D(T.split(s.Delimiter))}static join(T,A){return new D([...T.path,A])}static joinToString(T,A){return T.toString()+s.Delimiter+A}static parentId(T){const A=T.lastIndexOf(s.Delimiter);return A===-1?void 0:T.slice(0,A)}static localId(T){const A=T.lastIndexOf(s.Delimiter);return A===-1?T:T.slice(A+s.Delimiter.length)}static isChild(T,A){return A[T.length]===s.Delimiter&&A.startsWith(T)}static compare(T,A){return T===A?h.IsSame:D.isChild(T,A)?h.IsChild:D.isChild(A,T)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(T,A){if(T===0)return 0;let p=0;for(;p<T-1;){for(let c=1;c<T;c++){const I=A(c-1),E=A(c);if(I.path[p]!==E.path[p])return p}p++}return p}constructor(T,A=T.length){if(this.path=T,this.d=A,T.length===0||A<1)throw new Error("cannot create test with empty path")}get rootId(){return new D(this.path,1)}get parentId(){return this.d>1?new D(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let T=1;T<=this.d;T++)yield new D(this.path,T)}*idsToRoot(){for(let T=this.d;T>0;T--)yield new D(this.path,T)}compare(T){if(typeof T=="string")return D.compare(this.toString(),T);for(let A=0;A<T.d&&A<this.d;A++)if(T.path[A]!==this.path[A])return h.Disconnected;return T.d>this.d?h.IsChild:T.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let T=1;T<this.d;T++)this.c+=s.Delimiter,this.c+=this.path[T]}return this.c}}e.$tJ=D}),define(Re[76],Ce([1,0,2,55,30,75]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$BJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$AJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$zJ=e.$yJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$xJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$wJ=e.$vJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$uJ=e.TestResultState=void 0;var T;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(T||(e.TestResultState=T={})),e.$uJ={[T.Unset]:"unset",[T.Queued]:"queued",[T.Running]:"running",[T.Passed]:"passed",[T.Failed]:"failed",[T.Skipped]:"skipped",[T.Errored]:"errored"};var A;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var p;(function(j){j[j.Refresh=2]="Refresh",j[j.CodeRelatedToTest=4]="CodeRelatedToTest",j[j.TestRelatedToCode=8]="TestRelatedToCode"})(p||(e.TestControllerCapability=p={}));var c;(function(j){j[j.Run=2]="Run",j[j.Debug=4]="Debug",j[j.Coverage=8]="Coverage",j[j.HasNonDefaultProfile=16]="HasNonDefaultProfile",j[j.HasConfigurable=32]="HasConfigurable",j[j.SupportsContinuousRun=64]="SupportsContinuousRun"})(c||(e.TestRunProfileBitset=c={})),e.$vJ=[c.Run,c.Debug,c.Coverage,c.HasNonDefaultProfile,c.HasConfigurable,c.SupportsContinuousRun];const I=j=>"runId"in j;e.$wJ=I;var E;(function(j){j.serialize=W=>({range:W.range.toJSON(),uri:W.uri.toJSON()}),j.deserialize=(W,J)=>({range:D.$Yt.lift(J.range),uri:W.asCanonicalUri(s.URI.revive(J.uri))})})(E||(e.IRichLocation=E={}));var f;(function(j){j[j.Error=0]="Error",j[j.Output=1]="Output"})(f||(e.TestMessageType=f={}));var P;(function(j){j.serialize=W=>({label:W.label,uri:W.uri?.toJSON(),position:W.position?.toJSON()}),j.deserialize=(W,J)=>({label:J.label,uri:J.uri?W.asCanonicalUri(s.URI.revive(J.uri)):void 0,position:J.position?h.$Xt.lift(J.position):void 0})})(P||(e.ITestMessageStackFrame=P={}));var v;(function(j){j.serialize=W=>({message:W.message,type:f.Error,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&E.serialize(W.location),stackTrace:W.stackTrace?.map(P.serialize)}),j.deserialize=(W,J)=>({message:J.message,type:f.Error,expected:J.expected,actual:J.actual,contextValue:J.contextValue,location:J.location&&E.deserialize(W,J.location),stackTrace:J.stackTrace&&J.stackTrace.map(B=>P.deserialize(W,B))})})(v||(e.ITestErrorMessage=v={}));const o=(j,W)=>`${W?"s":"e"}${j}`;e.$xJ=o;var m;(function(j){j.serialize=W=>({message:W.message,type:f.Output,offset:W.offset,length:W.length,location:W.location&&E.serialize(W.location)}),j.deserialize=(W,J)=>({message:J.message,type:f.Output,offset:J.offset,length:J.length,location:J.location&&E.deserialize(W,J.location)})})(m||(e.ITestOutputMessage=m={}));var $;(function(j){j.serialize=W=>W.type===f.Error?v.serialize(W):m.serialize(W),j.deserialize=(W,J)=>J.type===f.Error?v.deserialize(W,J):m.deserialize(W,J),j.isDiffable=W=>W.type===f.Error&&W.actual!==void 0&&W.expected!==void 0})($||(e.ITestMessage=$={}));var d;(function(j){j.serializeWithoutMessages=W=>({state:W.state,duration:W.duration,messages:[]}),j.serialize=W=>({state:W.state,duration:W.duration,messages:W.messages.map($.serialize)}),j.deserialize=(W,J)=>({state:J.state,duration:J.duration,messages:J.messages.map(B=>$.deserialize(W,B))})})(d||(e.ITestTaskState=d={}));const i="\0",a=(j,W)=>j+i+W;e.$yJ=a;const t=j=>{const W=j.indexOf(i);return{ctrlId:j.slice(0,W),tagId:j.slice(W+1)}};e.$zJ=t;var r;(function(j){j.serialize=W=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?.toJSON(),range:W.range?.toJSON()||null,description:W.description,error:W.error,sortText:W.sortText}),j.deserialize=(W,J)=>({extId:J.extId,label:J.label,tags:J.tags,busy:J.busy,children:void 0,uri:J.uri?W.asCanonicalUri(s.URI.revive(J.uri)):void 0,range:J.range?D.$Yt.lift(J.range):null,description:J.description,error:J.error,sortText:J.sortText})})(r||(e.ITestItem=r={}));var n;(function(j){j[j.NotExpandable=0]="NotExpandable",j[j.Expandable=1]="Expandable",j[j.BusyExpanding=2]="BusyExpanding",j[j.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var u;(function(j){j.serialize=W=>({expand:W.expand,item:r.serialize(W.item)}),j.deserialize=(W,J)=>({controllerId:O.$tJ.root(J.item.extId),expand:J.expand,item:r.deserialize(W,J.item)})})(u||(e.InternalTestItem=u={}));var l;(function(j){j.serialize=W=>{let J;return W.item&&(J={},W.item.label!==void 0&&(J.label=W.item.label),W.item.tags!==void 0&&(J.tags=W.item.tags),W.item.busy!==void 0&&(J.busy=W.item.busy),W.item.uri!==void 0&&(J.uri=W.item.uri?.toJSON()),W.item.range!==void 0&&(J.range=W.item.range?.toJSON()),W.item.description!==void 0&&(J.description=W.item.description),W.item.error!==void 0&&(J.error=W.item.error),W.item.sortText!==void 0&&(J.sortText=W.item.sortText)),{extId:W.extId,expand:W.expand,item:J}},j.deserialize=W=>{let J;return W.item&&(J={},W.item.label!==void 0&&(J.label=W.item.label),W.item.tags!==void 0&&(J.tags=W.item.tags),W.item.busy!==void 0&&(J.busy=W.item.busy),W.item.range!==void 0&&(J.range=W.item.range?D.$Yt.lift(W.item.range):null),W.item.description!==void 0&&(J.description=W.item.description),W.item.error!==void 0&&(J.error=W.item.error),W.item.sortText!==void 0&&(J.sortText=W.item.sortText)),{extId:W.extId,expand:W.expand,item:J}}})(l||(e.ITestItemUpdate=l={}));const g=(j,W)=>{W.expand!==void 0&&(j.expand=W.expand),W.item!==void 0&&(j.item=j.item?Object.assign(j.item,W.item):W.item)};e.$AJ=g;var y;(function(j){j.serializeWithoutMessages=W=>({...u.serialize(W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(d.serializeWithoutMessages)}),j.serialize=W=>({...u.serialize(W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(d.serialize)}),j.deserialize=(W,J)=>({...u.deserialize(W,J),ownComputedState:J.ownComputedState,computedState:J.computedState,tasks:J.tasks.map(B=>d.deserialize(W,B)),retired:!0})})(y||(e.TestResultItem=y={}));var k;(function(j){j.empty=()=>({covered:0,total:0}),j.sum=(W,J)=>{W.covered+=J.covered,W.total+=J.total}})(k||(e.ICoverageCount=k={}));var S;(function(j){j.serialize=W=>({id:W.id,statement:W.statement,branch:W.branch,declaration:W.declaration,testIds:W.testIds,uri:W.uri.toJSON()}),j.deserialize=(W,J)=>({id:J.id,statement:J.statement,branch:J.branch,declaration:J.declaration,testIds:J.testIds,uri:W.asCanonicalUri(s.URI.revive(J.uri))}),j.empty=(W,J)=>({id:W,uri:J,statement:k.empty()})})(S||(e.IFileCoverage=S={}));function R(j){return{...j,location:j.location?.toJSON()}}function C(j){return j.location=j.location?h.$Xt.isIPosition(j.location)?h.$Xt.lift(j.location):D.$Yt.lift(j.location):void 0,j}e.$BJ=3;var w;(function(j){j[j.Declaration=0]="Declaration",j[j.Statement=1]="Statement",j[j.Branch=2]="Branch"})(w||(e.DetailType=w={}));var b;(function(j){j.serialize=W=>W.type===w.Declaration?L.serialize(W):M.serialize(W),j.deserialize=W=>W.type===w.Declaration?L.deserialize(W):M.deserialize(W)})(b||(e.CoverageDetails=b={}));var N;(function(j){j.serialize=R,j.deserialize=C})(N||(e.IBranchCoverage=N={}));var L;(function(j){j.serialize=R,j.deserialize=C})(L||(e.IDeclarationCoverage=L={}));var M;(function(j){j.serialize=W=>({...R(W),branches:W.branches?.map(N.serialize)}),j.deserialize=W=>({...C(W),branches:W.branches?.map(N.deserialize)})})(M||(e.IStatementCoverage=M={}));var z;(function(j){j[j.Add=0]="Add",j[j.Update=1]="Update",j[j.DocumentSynced=2]="DocumentSynced",j[j.Remove=3]="Remove",j[j.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",j[j.Retire=5]="Retire",j[j.AddTag=6]="AddTag",j[j.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var V;(function(j){j.deserialize=(W,J)=>J.op===z.Add?{op:J.op,item:u.deserialize(W,J.item)}:J.op===z.Update?{op:J.op,item:l.deserialize(J.item)}:J.op===z.DocumentSynced?{op:J.op,uri:W.asCanonicalUri(s.URI.revive(J.uri)),docv:J.docv}:J,j.serialize=W=>W.op===z.Add?{op:W.op,item:u.serialize(W.item)}:W.op===z.Update?{op:W.op,item:l.serialize(W.item)}:W})(V||(e.TestsDiffOp=V={}));class F{constructor(W){this.l=W,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(W){const J=this.x();for(const B of W)switch(B.op){case z.Add:this.p(u.deserialize(this.l,B.item),J);break;case z.Update:this.q(l.deserialize(B.item),J);break;case z.Remove:this.v(B.itemId,J);break;case z.Retire:this.w(B.itemId);break;case z.IncrementPendingExtHosts:this.updatePendingRoots(B.amount);break;case z.AddTag:this.f.set(B.tag.id,B.tag);break;case z.RemoveTag:this.f.delete(B.id);break}J.complete?.()}p(W,J){const B=O.$tJ.parentId(W.item.extId)?.toString();let U;if(!B)U=this.y(W),this.h.add(U),this.g.set(W.item.extId,U);else if(this.g.has(B)){const _=this.g.get(B);_.children.add(W.item.extId),U=this.y(W,_),this.g.set(W.item.extId,U)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(W)}`);return}return J.add?.(U),W.expand===n.BusyExpanding&&this.j++,U}q(W,J){const B=this.g.get(W.extId);if(B)return W.expand!==void 0&&(B.expand===n.BusyExpanding&&this.j--,W.expand===n.BusyExpanding&&this.j++),(0,e.$AJ)(B,W),J.update?.(B),B}v(W,J){const B=this.g.get(W);if(!B)return;const U=O.$tJ.parentId(B.item.extId)?.toString();U?this.g.get(U).children.delete(B.item.extId):this.h.delete(B);const _=[[W]];for(;_.length;)for(const x of _.pop()){const oe=this.g.get(x);oe&&(_.push(oe.children),this.g.delete(x),J.remove?.(oe,oe!==B),oe.expand===n.BusyExpanding&&this.j--)}}w(W){}updatePendingRoots(W){this.k+=W}x(){return{}}}e.$CJ=F}),define(Re[266],Ce([1,0,138,7,76]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$NHb=e.$MHb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(E){E.ViewletId="workbench.view.extension.test",E.ExplorerViewId="workbench.view.testing",E.OutputPeekContributionId="editor.contrib.testingOutputPeek",E.DecorationsContributionId="editor.contrib.testingDecorations",E.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",E.CoverageViewId="workbench.view.testCoverage",E.ResultsPanelId="workbench.panel.testResults",E.ResultsViewId="workbench.panel.testResults.view",E.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var T;(function(E){E.List="list",E.Tree="true"})(T||(e.TestExplorerViewMode=T={}));var A;(function(E){E.ByLocation="location",E.ByStatus="status",E.ByDuration="duration"})(A||(e.TestExplorerViewSorting=A={}));const p={[D.TestResultState.Errored]:(0,h.localize)(10846,null),[D.TestResultState.Failed]:(0,h.localize)(10847,null),[D.TestResultState.Passed]:(0,h.localize)(10848,null),[D.TestResultState.Queued]:(0,h.localize)(10849,null),[D.TestResultState.Running]:(0,h.localize)(10850,null),[D.TestResultState.Skipped]:(0,h.localize)(10851,null),[D.TestResultState.Unset]:(0,h.localize)(10852,null)},c=(E,f)=>(0,h.localize)(10853,null,(0,s.$5k)(E),p[f]);e.$MHb=c,e.$NHb={[D.TestRunProfileBitset.Debug]:(0,h.localize)(10854,null),[D.TestRunProfileBitset.Run]:(0,h.localize)(10855,null),[D.TestRunProfileBitset.Coverage]:(0,h.localize)(10856,null)};var I;(function(E){E.CancelTestRefreshAction="testing.cancelTestRefresh",E.CancelTestRunAction="testing.cancelRun",E.ClearTestResultsAction="testing.clearTestResults",E.CollapseAllAction="testing.collapseAll",E.ConfigureTestProfilesAction="testing.configureProfile",E.ContinousRunUsingForTest="testing.continuousRunUsingForTest",E.CoverageAtCursor="testing.coverageAtCursor",E.CoverageByUri="testing.coverage.uri",E.CoverageClear="testing.coverage.close",E.CoverageCurrentFile="testing.coverageCurrentFile",E.CoverageFilterToTest="testing.coverageFilterToTest",E.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",E.CoverageLastRun="testing.coverageLastRun",E.CoverageSelectedAction="testing.coverageSelected",E.CoverageToggleToolbar="testing.coverageToggleToolbar",E.CoverageViewChangeSorting="testing.coverageViewChangeSorting",E.DebugAction="testing.debug",E.DebugAllAction="testing.debugAll",E.DebugAtCursor="testing.debugAtCursor",E.DebugByUri="testing.debug.uri",E.DebugCurrentFile="testing.debugCurrentFile",E.DebugFailedTests="testing.debugFailTests",E.DebugLastRun="testing.debugLastRun",E.DebugSelectedAction="testing.debugSelected",E.FilterAction="workbench.actions.treeView.testExplorer.filter",E.GetExplorerSelection="_testing.getExplorerSelection",E.GetSelectedProfiles="testing.getSelectedProfiles",E.GoToTest="testing.editFocusedTest",E.GoToRelatedTest="testing.goToRelatedTest",E.PeekRelatedTest="testing.peekRelatedTest",E.GoToRelatedCode="testing.goToRelatedCode",E.PeekRelatedCode="testing.peekRelatedCode",E.HideTestAction="testing.hideTest",E.OpenCoverage="testing.openCoverage",E.OpenOutputPeek="testing.openOutputPeek",E.RefreshTestsAction="testing.refreshTests",E.ReRunFailedTests="testing.reRunFailTests",E.ReRunLastRun="testing.reRunLastRun",E.RunAction="testing.run",E.RunAllAction="testing.runAll",E.RunAllWithCoverageAction="testing.coverageAll",E.RunAtCursor="testing.runAtCursor",E.RunByUri="testing.run.uri",E.RunCurrentFile="testing.runCurrentFile",E.RunSelectedAction="testing.runSelected",E.RunUsingProfileAction="testing.runUsing",E.RunWithCoverageAction="testing.coverage",E.SearchForTestExtension="testing.searchForTestExtension",E.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",E.ShowMostRecentOutputAction="testing.showMostRecentOutput",E.StartContinousRun="testing.startContinuousRun",E.StopContinousRun="testing.stopContinuousRun",E.TestingSortByDurationAction="testing.sortByDuration",E.TestingSortByLocationAction="testing.sortByLocation",E.TestingSortByStatusAction="testing.sortByStatus",E.TestingViewAsListAction="testing.viewAsList",E.TestingViewAsTreeAction="testing.viewAsTree",E.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",E.ToggleInlineTestOutput="testing.toggleInlineTestOutput",E.UnhideAllTestsAction="testing.unhideAllTests",E.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Re[121],Ce([1,0,8,4,3,67,76,75]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=e.$HQ=e.$GQ=e.$FQ=e.$EQ=e.TestItemEventOp=void 0;var p;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const c=(d,i)=>d===i,E=Object.entries({range:(d,i)=>d===i?!0:!d||!i?!1:d.equalsRange(i),busy:c,label:c,description:c,error:c,sortText:c,tags:(d,i)=>!(d.length!==i.length||d.some(a=>!i.includes(a)))}),f=(d,i)=>{let a;for(const[t,r]of E)r(d[t],i[t])||(a?a[t]=i[t]:a={[t]:i[t]});return a};class P extends D.$Zc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new s.$Wh(()=>this.flushDiff(),200)),this.g=this.B(new h.$qe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case T.TestDiffOpType.DocumentSynced:{for(const a of this.m)if(a.op===T.TestDiffOpType.DocumentSynced&&a.uri===i.uri){a.docv=i.docv;return}break}case T.TestDiffOpType.Update:{const a=this.m[this.m.length-1];if(a){if(a.op===T.TestDiffOpType.Update&&a.item.extId===i.item.extId){(0,T.$AJ)(a.item,i.item);return}if(a.op===T.TestDiffOpType.Add&&a.item.item.extId===i.item.extId){(0,T.$AJ)(a.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,a){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||a>t.expandLevels)&&(t.expandLevels=a),t.expand===T.TestItemExpandState.Expandable){const r=this.M(t);return r.isOpen()?this.L(t,a-1):r.wait().then(()=>this.L(t,a-1))}else if(t.expand===T.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,a-1)):this.L(t,a-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,a){switch(a.op){case p.RemoveChild:this.O(A.$tJ.joinToString(i.fullId,a.id));break;case p.Upsert:this.z(a.item,i);break;case p.Bulk:for(const t of a.ops)this.w(i,t);break;case p.SetTags:this.C(a.new,a.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:a.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,O.$jd)(a)}}y(i){i&&this.pushDiff({op:T.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,a){const t=A.$tJ.fromExtHostTestItem(i,this.root.id,a?.actual),r=this.s.getApiFor(i);r.parent&&r.parent!==a?.actual&&this.s.getChildren(r.parent).delete(i.id);let n=this.tree.get(t.toString());if(!n){n={fullId:t,actual:i,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:T.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(n.fullId.toString(),n),this.G(i,a),this.pushDiff({op:T.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(i)}}),this.I(i,n,a);return}if(n.actual===i){this.H(i,n,a);return}if(n.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,a);const u=this.s.getChildren(n.actual),l=n.actual,g=f(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,n.actual=i,n.resolveBarrier=void 0,n.expand=T.TestItemExpandState.NotExpandable,g&&(g.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,t.toString()),delete g.tags),this.w(n,{op:p.SetProp,update:g})),this.I(i,n,a);for(const[k,S]of u)this.s.getChildren(i).get(S.id)||this.O(A.$tJ.joinToString(t,S.id));const y=n.expandLevels;y!==void 0&&queueMicrotask(()=>{n.expand===T.TestItemExpandState.Expandable&&(n.expandLevels=void 0,this.expand(t.toString(),y))}),this.y(n.actual.uri)}C(i,a,t){const r=new Set(a.map(n=>n.id));for(const n of i)r.delete(n.id)||this.D(n);this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(n=>(0,T.$yJ)(this.s.controllerId,n.id))}}}),r.forEach(this.F,this)}D(i){const a=this.j.get(i.id);a?a.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:T.TestDiffOpType.AddTag,tag:{id:(0,T.$yJ)(this.s.controllerId,i.id)}}))}F(i){const a=this.j.get(i);a&&!--a.refCount&&(this.j.delete(i),this.pushDiff({op:T.TestDiffOpType.RemoveTag,id:(0,T.$yJ)(this.s.controllerId,i)}))}G(i,a){this.s.getApiFor(i).parent=a&&a.actual!==this.root?a.actual:void 0}H(i,a,t){this.G(i,t);const r=this.s.getApiFor(i);r.parent=t?.actual,r.listener=n=>this.w(a,n),this.J(a)}I(i,a,t){this.H(i,a,t);for(const[r,n]of this.s.getChildren(i))this.z(n,a)}J(i){let a;this.h?i.resolveBarrier?a=i.resolveBarrier.isOpen()?T.TestItemExpandState.Expanded:T.TestItemExpandState.BusyExpanding:a=i.actual.canResolveChildren?T.TestItemExpandState.Expandable:T.TestItemExpandState.NotExpandable:a=T.TestItemExpandState.NotExpandable,a!==i.expand&&(i.expand=a,this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:a}}),a===T.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,a){if(a<0)return;const t=[];for(const[r,n]of this.s.getChildren(i.actual)){const u=this.expand(A.$tJ.joinToString(i.fullId,n.id),a);(0,s.$wh)(u)&&t.push(u)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const n=new s.$Jh;return n.open(),n}i.expand=T.TestItemExpandState.BusyExpanding,this.N(i);const a=i.resolveBarrier=new s.$Jh,t=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let r;try{r=this.h(i.actual===this.root?void 0:i.actual)}catch(n){t(n)}return(0,s.$wh)(r)?r.catch(t).then(()=>{a.open(),this.J(i)}):(a.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:T.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const a=this.tree.get(i);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:T.TestDiffOpType.Remove,itemId:i});const t=[a];for(;t.length;){const r=t.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const n of r.actual.tags)this.F(n.id);this.tree.delete(r.fullId.toString());for(const[n,u]of this.s.getChildren(r.actual))t.push(this.tree.get(A.$tJ.joinToString(r.fullId,u.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$EQ=P;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$FQ=v;class o extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$GQ=o;class m extends Error{constructor(i,a,t){super(`TestItem with ID "${i}" is from controller "${a}" and cannot be added as a child of an item from controller "${t}".`)}}e.$HQ=m;const $=(d,i,a)=>{let t=new Map;return{get size(){return t.size},forEach(r,n){for(const u of t.values())r.call(n,u,this)},[Symbol.iterator](){return t.entries()},replace(r){const n=new Map,u=new Set(t.keys()),l={op:p.Bulk,ops:[]};for(const g of r){if(!(g instanceof a))throw new o(g.id);const y=i(g).controllerId;if(y!==d.controllerId)throw new m(g.id,y,d.controllerId);if(n.has(g.id))throw new v(g.id);n.set(g.id,g),u.delete(g.id),l.ops.push({op:p.Upsert,item:g})}for(const g of u.keys())l.ops.push({op:p.RemoveChild,id:g});d.listener?.(l),t=n},add(r){if(!(r instanceof a))throw new o(r.id);t.set(r.id,r),d.listener?.({op:p.Upsert,item:r})},delete(r){t.delete(r)&&d.listener?.({op:p.RemoveChild,id:r})},get(r){return t.get(r)},toJSON(){return Array.from(t.values())}}};e.$IQ=$}),define(Re[161],Ce([1,0,121]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=e.$JQ=void 0;const h=new WeakMap,D=(T,A)=>{const p={controllerId:A};return h.set(T,p),p};e.$JQ=D;const O=T=>{const A=h.get(T);if(!A)throw new s.$GQ(T?.id||"<unknown>");return A};e.$KQ=O}),define(Re[122],Ce([1,0,26,14,2]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EEb=e.$DEb=e.$CEb=void 0,e.$FEb=O,e.$GEb=A,e.$CEb="vscode-cdn.net",e.$DEb=`vscode-resource.${e.$CEb}`,e.$EEb=`'self' https://*.${e.$CEb}`;function O(p,c){return p.scheme===h.Schemas.http||p.scheme===h.Schemas.https?p:(c&&c.authority&&c.isRemote&&p.scheme===h.Schemas.file&&(p=D.URI.from({scheme:h.Schemas.vscodeRemote,authority:c.authority,path:p.path})),D.URI.from({scheme:h.Schemas.https,authority:`${p.scheme}+${T(p.authority)}.${e.$DEb}`,path:p.path,fragment:p.fragment,query:p.query}))}function T(p){return p.replace(/./g,c=>{const I=c.charCodeAt(0);return I>=s.CharCode.a&&I<=s.CharCode.z||I>=s.CharCode.A&&I<=s.CharCode.Z||I>=s.CharCode.Digit0&&I<=s.CharCode.Digit9?c:"-"+I.toString(16).padStart(4,"0")})}function A(p){return p.replace(/-([0-9a-f]{4})/g,(c,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Re[267],Ce([1,0,4,3,122]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lrc=void 0;class O{constructor(A,p,c){this.d=A,this.e=p,this.f=c,this.a=0,this.b=new h.$Yc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const I=p.getVisibleTextEditors();for(const E of this.c.values())I.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,p,c,I,E){let f;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===A){f=i;break}if(!f)throw new Error("not a visible editor");const P=this,v=this.a++,o=new s.$qe,m=new s.$qe,$=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,D.$FEb)(i,P.f)}get cspSource(){return D.$EEb}set options(i){this.b=i,P.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,P.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return o.event}postMessage(i){return P.d.$postMessage(v,i)}},d=new class{constructor(){this.editor=A,this.line=p,this.height=c,this.webview=$,this.onDidDispose=m.event}dispose(){P.c.has(v)&&(P.c.delete(v),P.d.$disposeEditorInset(v),m.fire(),m.dispose(),o.dispose())}};return this.d.$createEditorInset(v,f.id,f.value.document.uri,p+1,c,I||{},E.identifier,E.extensionLocation),this.c.set(v,{editor:A,inset:d,onDidReceiveMessage:o}),d}$onDidDispose(A){const p=this.c.get(A);p&&p.inset.dispose()}$onDidReceiveMessage(A,p){this.c.get(A)?.onDidReceiveMessage.fire(p)}}e.$lrc=O}),define(Re[162],Ce([1,0,5]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=e.$eN=void 0,e.$eN="__",e.$fN=(0,s.$Ki)("IAuthenticationService"),e.$gN=(0,s.$Ki)("IAuthenticationExtensionsService")}),define(Re[268],Ce([1,0,5,12]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=e.VariableKind=e.$CR=void 0,e.$CR=(0,s.$Ki)("configurationResolverService");var D;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator",T.PathSeparatorAlias="/"})(D||(e.VariableKind=D={}));class O extends h.$fb{constructor(A,p){super(p),this.variable=A}}e.$DR=O}),define(Re[269],Ce([1,0,16,57,17,24,10,109,7,268,13]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SR=void 0,s=Ue(s),h=Ue(h),D=Ue(D),O=Ue(O);class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(P,v,o,m){this.h=new Map,this.a=P,this.b=v,this.g=o,m&&(this.c=m.then($=>this.i($)))}i(P){if(T.$l){const v=Object.create(null);return Object.keys(P).forEach(o=>{v[o.toLowerCase()]=P[o]}),v}return P}resolveWithEnvironment(P,v,o){return this.l({env:this.i(P),userHome:void 0},v?v.uri:void 0,o)}async resolveAsync(P,v){const o={env:await this.c,userHome:await this.g};return this.l(o,P?P.uri:void 0,v)}async j(P,v,o,m){const $=O.$mo(v);T.$l&&$.windows?Object.keys($.windows).forEach(i=>$[i]=$.windows[i]):T.$m&&$.osx?Object.keys($.osx).forEach(i=>$[i]=$.osx[i]):T.$n&&$.linux&&Object.keys($.linux).forEach(i=>$[i]=$.linux[i]),delete $.windows,delete $.osx,delete $.linux;const d={env:await this.c,userHome:await this.g};return this.l(d,P?P.uri:void 0,$,o,m)}async resolveAnyAsync(P,v,o){return this.j(P,v,o)}async resolveAnyMap(P,v,o){const m=new Map;return{newConfig:await this.j(P,v,o,m),resolvedVariables:m}}resolveWithInteractionReplace(P,v,o,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,v,o,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,v){if(this.h.has(P))throw new Error("Variable "+P+" is contributed twice.");this.h.set(P,v)}async l(P,v,o,m,$){if(D.$jg(o))return this.m(P,v,o,m,$);if(Array.isArray(o))return Promise.all(o.map(d=>this.l(P,v,d,m,$)));if(D.$lg(o)){const d=Object.create(null),i=await Promise.all(Object.keys(o).map(async a=>[await this.m(P,v,a,m,$),await this.l(P,v,o[a],m,$)]));for(const[a,t]of i)d[a]=t;return d}return o}m(P,v,o,m,$){return(0,I.$Cf)(o,E.VARIABLE_REGEXP,async(d,i)=>{if(i.includes(E.VARIABLE_LHS))return d;let a=await this.o(P,d,i,v,m);return $?.set(i,a),a!==d&&D.$jg(a)&&a.match(E.VARIABLE_REGEXP)&&(a=await this.m(P,v,a,m,$)),a})}n(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async o(P,v,o,m,$){let d;const i=o.split(":");i.length>1&&(o=i[0],d=i[1]);const a=n=>{const u=this.a.getFilePath();if(u)return(0,A.$_w)(u);throw new c.$DR(n,(0,p.localize)(12113,null,v))},t=n=>{const u=a(n);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,A.$_w)(l)}throw new c.$DR(n,(0,p.localize)(12114,null,v,s.$sc(u)))},r=n=>{if(d){const u=this.a.getFolderUri(d);if(u)return u;throw new c.$DR(n,(0,p.localize)(12115,null,v,d))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new c.$DR(n,(0,p.localize)(12116,null,v)):new c.$DR(n,(0,p.localize)(12117,null,v))};switch(o){case"env":if(d){if(P.env){const n=P.env[T.$l?d.toLowerCase():d];if(D.$jg(n))return n}return""}throw new c.$DR(c.VariableKind.Env,(0,p.localize)(12118,null,v));case"config":if(d){const n=this.a.getConfigurationValue(m,d);if(D.$sg(n))throw new c.$DR(c.VariableKind.Config,(0,p.localize)(12119,null,v,d));if(D.$lg(n))throw new c.$DR(c.VariableKind.Config,(0,p.localize)(12120,null,v,d));return n}throw new c.$DR(c.VariableKind.Config,(0,p.localize)(12121,null,v));case"command":return this.p(c.VariableKind.Command,v,d,$,"command");case"input":return this.p(c.VariableKind.Input,v,d,$,"input");case"extensionInstallFolder":if(d){const n=await this.a.getExtension(d);if(!n)throw new c.$DR(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(12122,null,v,d));return this.n(n.extensionLocation)}throw new c.$DR(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(12123,null,v));default:switch(o){case"workspaceRoot":case"workspaceFolder":return(0,A.$_w)(this.n(r(c.VariableKind.WorkspaceFolder)));case"cwd":return m||d?(0,A.$_w)(this.n(r(c.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.$_w)(s.$sc(this.n(r(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new c.$DR(c.VariableKind.UserHome,(0,p.localize)(12124,null,v))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new c.$DR(c.VariableKind.LineNumber,(0,p.localize)(12125,null,v))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new c.$DR(c.VariableKind.SelectedText,(0,p.localize)(12126,null,v))}case"file":return a(c.VariableKind.File);case"fileWorkspaceFolder":return t(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return s.$sc(t(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||d?s.$qc(this.n(r(c.VariableKind.RelativeFile)),a(c.VariableKind.RelativeFile)):a(c.VariableKind.RelativeFile);case"relativeFileDirname":{const n=s.$rc(a(c.VariableKind.RelativeFileDirname));if(m||d){const u=s.$qc(this.n(r(c.VariableKind.RelativeFileDirname)),n);return u.length===0?".":u}return n}case"fileDirname":return s.$rc(a(c.VariableKind.FileDirname));case"fileExtname":return s.$tc(a(c.VariableKind.FileExtname));case"fileBasename":return s.$sc(a(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=s.$sc(a(c.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-s.$tc(n).length)}case"fileDirnameBasename":return s.$sc(s.$rc(a(c.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||v}case"execInstallFolder":{const n=this.a.getAppRoot();return n||v}case"pathSeparator":case"/":return s.sep;default:try{const n=d?`${o}:${d}`:o;return this.p(c.VariableKind.Unknown,v,n,$,void 0)}catch{return v}}}}p(P,v,o,m,$){if(o&&m){const d=$===void 0?m[o]:m[$+":"+o];if(typeof d=="string")return d;throw new c.$DR(P,(0,p.localize)(12127,null,v))}return v}}e.$SR=E}),define(Re[163],Ce([1,0,5,158]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$OE=void 0,e.$PE=c,e.$QE=f,e.$RE=P,e.$OE=(0,s.$Ki)("editorGroupsService");var D;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(D||(e.GroupDirection=D={}));var O;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T||(e.GroupLocation=T={}));var A;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(A||(e.GroupsArrangement=A={}));var p;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function c(v){const o=v;return(0,h.$AG)(o?.editor)&&(0,h.$AG)(o?.replacement)}var I;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var E;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function f(v){const o=v;return!!o&&typeof o.id=="number"&&Array.isArray(o.editors)}function P(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?D.DOWN:D.RIGHT}}),define(Re[270],Ce([1,0,5,163]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=e.$TE=e.$SE=void 0,e.$WE=D,e.$SE=(0,s.$Ki)("editorService"),e.$TE=-1,e.$UE=-2,e.$VE=-3;function D(O){const T=O;return typeof O=="number"||(0,h.$QE)(T)}}),define(Re[164],Ce([1,0,5,149]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0,e.$yN=(0,s.$Li)(h.$Ri)}),define(Re[165],Ce([1,0,23,4,16,3,8]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=e.$mfc=e.$lfc=e.$kfc=void 0,D=Ue(D);class A{constructor(d,i){this.versionId=d,this.removedDueToLooping=i}}e.$kfc=A;class p{static isHostExtension(d,i,a){if(i.getExtensionDescription(d))return!1;const t=a.getExtensionDescription(d);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(d,i){this.j=d,this.c=new h.$qe,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(o),this.f=new s.$Bn,this.g=[],this.h=new Map;for(const d of this.e){if(this.f.has(d.identifier)){console.error("Extension `"+d.identifier.value+"` is already registered");continue}this.f.set(d.identifier,d),this.g.push(d);const i=this.j.readActivationEvents(d);for(const a of i)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(d)}}set(d){return this.e=d,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(d,i){this.e=m(this.e,i),this.e=this.e.concat(d);const a=p.l(this.e);return this.e=m(this.e,a.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,a)}static l(d){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,l){this.addNode(u),this.addNode(l),this.c.has(u)?this.c.get(u).push(l):this.c.set(u,[l])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,l){const g=i.getArcs(u);for(let y=0;y<g.length;y++)if(!l.has(g[y]))return!1;return!0}getNodes(){return this.e}},a=new s.$Bn;for(const u of d)if(a.set(u.identifier,u),u.extensionDependencies)for(const l of u.extensionDependencies)i.addArc(s.$zn.toKey(u.identifier),s.$zn.toKey(l));const t=new Set;i.getNodes().filter(u=>i.getArcs(u).length===0).forEach(u=>t.add(u));const r=i.getNodes().filter(u=>!t.has(u));let n;do{n=!1;for(let u=0;u<r.length;u++){const l=r[u];i.hasOnlyGoodArcs(l,t)&&(r.splice(u,1),u--,t.add(l),n=!0)}}while(n);return r.map(u=>a.get(u))}containsActivationEvent(d){return this.h.has(d)}containsExtension(d){return this.f.has(d)}getExtensionDescriptionsForActivationEvent(d){const i=this.h.get(d);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(d){const i=this.f.get(d);return i||void 0}getExtensionDescriptionByUUID(d){for(const i of this.g)if(i.uuid===d)return i}getExtensionDescriptionByIdOrUUID(d,i){return this.getExtensionDescription(d)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$lfc=p;class c{constructor(d,i){this.versionId=d,this.extensions=i}}e.$mfc=c;class I{constructor(d){this.d=new P,this.c=new p(d,[])}async acquireLock(d){const i=await this.d.acquire(d);return new E(this,i)}deltaExtensions(d,i,a){if(!d.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(d){return this.c.containsActivationEvent(d)}containsExtension(d){return this.c.containsExtension(d)}getExtensionDescriptionsForActivationEvent(d){return this.c.getExtensionDescriptionsForActivationEvent(d)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(d){return this.c.getExtensionDescription(d)}getExtensionDescriptionByUUID(d){return this.c.getExtensionDescriptionByUUID(d)}getExtensionDescriptionByIdOrUUID(d,i){return this.c.getExtensionDescriptionByIdOrUUID(d,i)}}e.$nfc=I;class E extends O.$Zc{constructor(d,i){super(),this.f=d,this.c=!1,this.B(i)}isAcquiredFor(d){return!this.c&&this.f===d}}e.$ofc=E;class f{constructor(d){this.name=d;const i=(0,T.$Dh)();this.promise=i.promise,this.c=i.resolve}resolve(d){this.c(d)}}class P{constructor(){this.c=[],this.d=!1}async acquire(d){const i=new f(d);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const d=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${d.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};d.resolve((0,O.$Xc)(t))}}var v;(function($){$[$.Builtin=0]="Builtin",$[$.User=1]="User",$[$.Dev=2]="Dev"})(v||(v={}));function o($,d){const i=$.isBuiltin?v.Builtin:$.isUnderDevelopment?v.Dev:v.User,a=d.isBuiltin?v.Builtin:d.isUnderDevelopment?v.Dev:v.User;if(i!==a)return i-a;const t=D.$lc.basename($.extensionLocation.path),r=D.$lc.basename(d.extensionLocation.path);return t<r?-1:t>r?1:0}function m($,d){const i=new s.$An(d);return $.filter(a=>!i.has(a.identifier))}}),define(Re[271],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=e.$kn=e.ExtHostConnectionType=void 0,e.$nn=A,e.$on=p;var s;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(s||(e.ExtHostConnectionType=s={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(E){this.pipeName=E,this.type=s.IPC}serialize(E){E[h.ENV_KEY]=this.pipeName}}e.$kn=h;class D{constructor(){this.type=s.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(E){E[D.ENV_KEY]="1"}}e.$ln=D;class O{constructor(){this.type=s.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(E){E[O.ENV_KEY]="1"}}e.$mn=O;function T(I){delete I[h.ENV_KEY],delete I[D.ENV_KEY],delete I[O.ENV_KEY]}function A(I,E){T(E),I.serialize(E)}function p(I){if(I[h.ENV_KEY])return c(I,new h(I[h.ENV_KEY]));if(I[D.ENV_KEY])return c(I,new D);if(I[O.ENV_KEY])return c(I,new O);throw new Error("No connection information defined in environment!")}function c(I,E){return T(I),E}}),define(Re[94],Ce([1,0,21]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Jn=T,e.$Kn=A;var h;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(h||(e.UIKind=h={}));var D;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(D||(e.ExtensionHostExitCode=D={}));var O;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function T(c){const I=s.$Se.alloc(1);switch(c){case O.Initialized:I.writeUInt8(1,0);break;case O.Ready:I.writeUInt8(2,0);break;case O.Terminate:I.writeUInt8(3,0);break}return I}function A(c,I){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return I===O.Initialized;case 2:return I===O.Ready;case 3:return I===O.Terminate;default:return!1}}var p;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Re[95],Ce([1,0,5,4,154,11,29,94,91,92,24,2,3,7]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Q=e.$7Q=e.$6Q=void 0,e.$8Q=m;let v=class extends f.$Zc{constructor(d,i){super(),this.s=d,this.t=i,this.a=this.B(new h.$qe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$qe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=D.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=E.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:c.$Kp,name:(0,P.localize)(2714,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(a=>{(0,O.$hk)(a)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===D.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=D.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=D.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=D.TelemetryLevel.USAGE:!1}}instantiateLogger(d,i,a){const t=this.getTelemetryDetails(),r=new o(i,a,d,this.n,this.j,this.getBuiltInCommonProperties(d),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),n=this.r.get(d.identifier.value)??[];return this.r.set(d.identifier.value,[...n,r]),r.apiTelemetryLogger}$initializeTelemetryLevel(d,i,a){this.f=d,this.g=i,this.c=a??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(d){const i=Object.create(null);switch(i["common.extname"]=`${d.publisher}.${d.name}`,i["common.extversion"]=d.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$qn)((0,c.$Qp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(d){this.h=this.getTelemetryConfiguration(),this.f=d;const i=this.getTelemetryDetails();this.r.forEach((a,t)=>{const r=a.filter(n=>!n.isDisposed);r.length===0?this.r.delete(t):this.r.set(t,r)}),this.r.forEach(a=>{for(const t of a)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(d,i){const t=this.r.get(d.value)?.filter(n=>!n.isDisposed);if(!t)return this.r.delete(d.value),!1;let r=!1;for(const n of t)n.ignoreUnhandledExtHostErrors||(n.logError(i),r=!0);return r}};e.$6Q=v,e.$6Q=v=Ye([We(0,T.$5Q),We(1,O.$gk)],v);class o{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,i,a,t,r,n,u){this.g=a,this.h=t,this.i=r,this.j=n,this.a=new h.$qe,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=d,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(d,i){this.e&&(this.d={isUsageEnabled:d,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(d){let i="properties"in d?d.properties??{}:d;return i=(0,c.$Tp)(i,[]),this.c&&(i=(0,I.$po)(i,this.c)),this.b||(i=(0,I.$po)(i,this.j)),"properties"in d?d.properties=i:d=i,d}k(d,i){this.f&&(this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(d,i),this.h.trace(d,i))}logUsage(d,i){this.d.isUsageEnabled&&this.k(d,i)}logError(d,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof d=="string")this.k(d,i);else{const a={name:d.name,message:d.message,stack:d.stack,cause:d.cause},t=(0,c.$Tp)(a,[]),r=new Error(t.message,{cause:t.cause});r.stack=t.stack,r.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(r,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const d=this,i={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.d.isUsageEnabled},get isErrorsEnabled(){return d.d.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.a.event.bind(d)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let d=this.f;this.f=void 0,Promise.resolve(d.flush()).then(d=void 0),this.e=void 0}else this.f=void 0}}e.$7Q=o;function m($){const d=Date.now()-new Date($).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.$9Q=(0,s.$Ki)("IExtHostTelemetry")}),define(Re[25],Ce([1,0,4,2,244,152,23,5]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IH=e.ActivationKind=e.$FH=e.$EH=e.$BH=e.ExtensionHostStartup=e.$AH=e.$zH=e.$yH=e.$xH=void 0,e.$CH=f,e.$DH=P,e.$GH=$,e.$HH=d,e.$xH=Object.freeze({identifier:new T.$zn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:T.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$yH="extensions.webWorker",e.$zH=(0,A.$Ki)("extensionService");class p{constructor(t){this.dependency=t}}e.$AH=p;var c;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,r,n){this.c=t,this.d=r.slice(0),this.e=n.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$jH.createActivationEventsMap(this.d)}}set(t,r,n){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const u=[],l=[],g=[],y=[],k=E(this.d),S=E(r),R=(L,M)=>L.extensionLocation.toString()===M.extensionLocation.toString()||L.isBuiltin===M.isBuiltin||L.isUserBuiltin===M.isUserBuiltin||L.isUnderDevelopment===M.isUnderDevelopment;for(const L of this.d){const M=S.get(L.identifier);if(!M){u.push(L.identifier),k.delete(L.identifier);continue}if(!R(L,M)){u.push(L.identifier),k.delete(L.identifier);continue}}for(const L of r){const M=k.get(L.identifier);if(!M){l.push(L);continue}if(!R(M,L)){u.push(M.identifier),k.delete(M.identifier);continue}}const C=new T.$An(this.e),w=new T.$An(n);for(const L of this.e)w.has(L)||g.push(L);for(const L of n)C.has(L)||y.push(L);const b=O.$jH.createActivationEventsMap(l),N={versionId:t,toRemove:u,toAdd:l,addActivationEvents:b,myToRemove:g,myToAdd:y};return this.delta(N),N}delta(t){if(this.c>=t.versionId)return null;const{toRemove:r,toAdd:n,myToRemove:u,myToAdd:l}=t,g=new T.$An(r),y=new T.$An(u);for(let k=0;k<this.d.length;k++)g.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)y.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of n)this.d.push(k);for(const k of l)this.e.push(k);return this.f=null,t}containsExtension(t){for(const r of this.e)if(T.$zn.equals(r,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const r of this.d){if(!this.containsExtension(r.identifier))continue;const n=O.$jH.readActivationEvents(r);for(const u of n)t.add(u)}return t}}e.$BH=I;function E(a){const t=new T.$Bn;for(const r of a)t.set(r.identifier,r);return t}function f(a,t){return!0}function P(a,t){if(!f(a,t))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class v{constructor(t,r,n,u){this.codeLoadingTime=t,this.activateCallTime=r,this.activateResolvedTime=n,this.activationReason=u}}e.$EH=v;class o{constructor(t,r){this.description=t,this.value=r}}e.$FH=o;var m;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function $(a){return{type:a.isBuiltin?T.ExtensionType.System:T.ExtensionType.User,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,D.$Zp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function d(a,t){const r=(0,D.$Xp)(a.manifest.publisher,a.manifest.name);return{id:r,identifier:new T.$zn(r),isBuiltin:a.type===T.ExtensionType.System,isUserBuiltin:a.type===T.ExtensionType.User&&a.isBuiltin,isUnderDevelopment:!!t,extensionLocation:a.location,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,publisherDisplayName:a.publisherDisplayName,...a.manifest}}class i{constructor(){this.onDidRegisterExtensions=s.Event.None,this.onDidChangeExtensionsStatus=s.Event.None,this.onDidChangeExtensions=s.Event.None,this.onWillActivateByEvent=s.Event.None,this.onDidChangeResponsiveChange=s.Event.None,this.onWillStop=s.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,r){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$IH=i}),define(Re[272],Ce([1,0,12,3,165,23,25,11,8]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mrc=e.$Lrc=e.$Krc=e.$Jrc=e.$Irc=e.$Hrc=void 0,s=Ue(s);class c{static{this.NONE=new c(!1,-1,-1,-1)}constructor(d,i,a,t){this.startup=d,this.codeLoadingTime=i,this.activateCallTime=a,this.activateResolvedTime=t}}e.$Hrc=c;class I{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,i){return d===-1||i===-1?-1:i-d}build(){return new c(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Irc=I;class E{constructor(d,i,a,t,r,n){this.activationFailed=d,this.activationFailedError=i,this.activationTimes=a,this.module=t,this.exports=r,this.disposable=n}}e.$Jrc=E;class f extends E{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,h.$Zc.None)}}e.$Krc=f;class P extends E{constructor(){super(!1,null,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Zc.None)}}e.$Lrc=P;class v extends E{constructor(d){super(!0,d,c.NONE,{activate:void 0,deactivate:void 0},void 0,h.$Zc.None)}}let o=class{constructor(d,i,a,t){this.g=t,this.a=d,this.b=i,this.c=a,this.d=new O.$Bn,this.f=Object.create(null)}dispose(){for(const[d,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const d=[];for(const[i,a]of this.d)d.push(a.wait());await Promise.all(d)}isActivated(d){const i=this.d.get(d);return!!(i&&i.value)}getActivatedExtension(d){const i=this.d.get(d);if(!i||!i.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return i.value}async activateByEvent(d,i){if(this.f[d])return;const a=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(a.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,i){const a=this.a.getExtensionDescription(d);if(!a)throw new Error(`Extension '${d.value}' is not known`);return this.h([{id:a.identifier,reason:i}])}async h(d){const i=d.filter(a=>!this.isActivated(a.id)).map(a=>this.j(a));await Promise.all(i.map(a=>a.wait()))}j(d){if(this.d.has(d.id))return this.d.get(d.id);if(this.l(d.id))return this.k(d,null,[],null);const i=this.a.getExtensionDescription(d.id);if(!i){const r=new Error(`Cannot activate unknown extension '${d.id.value}'`),n=this.k(d,null,[],new v(r));return this.c.onExtensionActivationError(d.id,r,new T.$AH(d.id.value)),n}const a=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const r of t){if(this.m(r))continue;const n=this.d.get(r);if(n){a.push(n);continue}if(this.l(r)){a.push(this.j({id:this.b.getExtensionDescription(r).identifier,reason:d.reason}));continue}const u=this.a.getExtensionDescription(r);if(u){if(!u.main&&!u.browser)continue;a.push(this.j({id:u.identifier,reason:d.reason}));continue}const l=i.displayName||i.identifier.value,g=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${r}'`),y=this.k(d,i.displayName,[],new v(g));return this.c.onExtensionActivationError(i.identifier,g,new T.$AH(r)),y}return this.k(d,i.displayName,a,null)}k(d,i,a,t){const r=new m(d.id,i,d.reason,a,t,this.c,this.g);return this.d.set(d.id,r),r}l(d){return D.$lfc.isHostExtension(d,this.a,this.b)}m(d){const i=this.b.getExtensionDescription(d);return i?!i.main&&!i.browser:!1}};e.$Mrc=o,e.$Mrc=o=Ye([We(3,A.$fk)],o);let m=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,i,a,t,r,n,u){this.c=d,this.d=i,this.f=a,this.g=t,this.h=r,this.j=n,this.k=u,this.a=new p.$Jh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const i=this.g[d];if(i.value&&!i.value.activationFailed){this.g.splice(d,1),d--;continue}if(i.value&&i.value.activationFailed){const a=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);a.detail=i.value.activationFailedError,this.h=new v(a),this.j.onExtensionActivationError(this.c,a,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const i=new Error;if(d&&d.name&&(i.name=d.name),d&&d.message?i.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(i.stack=d.stack),this.h=new v(i),this.b&&s.$8(d))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};m=Ye([We(6,A.$fk)],m)});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[166],Ce([1,0,7,12,45,151,116,37,23,115,152,148]),function(ge,e,s,h,D,O,T,A,p,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=void 0,s=Ue(s),D=Ht(D);const f=A.$zo.as(T.$Ao.JSONContribution);class P{constructor(t,r,n){this.a=t,this.b=r,this.c=n}d(t,r){this.a({type:t,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(D.default.Error,t)}warn(t){this.d(D.default.Warning,t)}info(t){this.d(D.default.Info,t)}}e.$rH=P;class v{static a(t){const r=new p.$An;for(let n=0,u=t.length;n<u;n++)r.add(t[n].description.identifier);return r}static compute(t,r){if(!t||!t.length)return new v(r,[]);if(!r||!r.length)return new v([],t);const n=this.a(t),u=this.a(r),l=r.filter(y=>!n.has(y.description.identifier)),g=t.filter(y=>!u.has(y.description.identifier));return new v(l,g)}constructor(t,r){this.added=t,this.removed=r}}e.$sH=v;class o{constructor(t,r){this.name=t,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=v.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,h.$4)(t)}}}e.$tH=o;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[s.localize(12282,null),s.localize(12283,null)]},$="vscode://schemas/vscode-extensions";e.$uH={properties:{engines:{type:"object",description:s.localize(12284,null),properties:{vscode:{type:"string",description:s.localize(12285,null),default:"^1.22.0"}}},publisher:{description:s.localize(12286,null),type:"string"},displayName:{description:s.localize(12287,null),type:"string"},categories:{description:s.localize(12288,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$yn},{type:"string",const:"Languages",deprecationMessage:s.localize(12289,null)}]}},galleryBanner:{type:"object",description:s.localize(12290,null),properties:{color:{description:s.localize(12291,null),type:"string"},theme:{description:s.localize(12292,null),type:"string",enum:["dark","light"]}}},contributes:{description:s.localize(12293,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:s.localize(12294,null)},enableProposedApi:{type:"boolean",deprecationMessage:s.localize(12295,null)},enabledApiProposals:{markdownDescription:s.localize(12296,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals).map(a=>a),markdownEnumDescriptions:Object.values(E.allApiProposals).map(a=>a.proposal)}},api:{markdownDescription:s.localize(12297,null),type:"string",enum:["none"],enumDescriptions:[s.localize(12298,null)]},activationEvents:{description:s.localize(12299,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:s.localize(12300,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:s.localize(12301,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:s.localize(12302,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:s.localize(12303,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:s.localize(12304,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:s.localize(12305,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:s.localize(12306,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:s.localize(12307,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:s.localize(12308,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:s.localize(12309,null),body:"onStartupFinished"},{label:"onTaskType",description:s.localize(12310,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:s.localize(12311,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:s.localize(12312,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:s.localize(12313,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:s.localize(12314,null)},{label:"onUri",body:"onUri",description:s.localize(12315,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:s.localize(12316,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:s.localize(12317,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:s.localize(12318,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:s.localize(12319,null)},{label:"onRenderer",description:s.localize(12320,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:s.localize(12321,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:s.localize(12322,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:s.localize(12323,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:s.localize(12324,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:s.localize(12325,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolId}",description:s.localize(12326,null)},{label:"*",description:s.localize(12327,null),body:"*"}]}},badges:{type:"array",description:s.localize(12328,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:s.localize(12329,null)},href:{type:"string",description:s.localize(12330,null)},description:{type:"string",description:s.localize(12331,null)}}}},markdown:{type:"string",description:s.localize(12332,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:s.localize(12333,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:s.localize(12334,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$gp}},extensionPack:{description:s.localize(12335,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$gp}},extensionKind:{description:s.localize(12336,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:s.localize(12337,null)},{body:["workspace"],description:s.localize(12338,null)},{body:["ui","workspace"],description:s.localize(12339,null)},{body:["workspace","ui"],description:s.localize(12340,null)},{body:[],description:s.localize(12341,null)}]},capabilities:{description:s.localize(12342,null),type:"object",properties:{virtualWorkspaces:{description:s.localize(12343,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:s.localize(12344,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(12345,null),s.localize(12346,null),s.localize(12347,null)]},description:{type:"string",markdownDescription:s.localize(12348,null)}}},untrustedWorkspaces:{description:s.localize(12349,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:s.localize(12350,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[s.localize(12351,null),s.localize(12352,null),s.localize(12353,null)]},restrictedConfigurations:{description:s.localize(12354,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:s.localize(12355,null)}}}}},sponsor:{description:s.localize(12356,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:s.localize(12357,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:s.localize(12358,null),type:"string"},"vscode:uninstall":{description:s.localize(12359,null),type:"string"}}},icon:{type:"string",description:s.localize(12360,null)},l10n:{type:"string",description:s.localize(12361,null)},pricing:{type:"string",markdownDescription:s.localize(12362,null),enum:["Free","Trial"],default:"Free"}}};class d{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const r=new o(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,r),t.activationEventsGenerator&&I.$jH.register(t.extensionPoint,t.activationEventsGenerator),e.$uH.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,f.registerSchema($,e.$uH),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$vH=d;const i={ExtensionsRegistry:"ExtensionsRegistry"};A.$zo.add(i.ExtensionsRegistry,new d),e.$wH=A.$zo.as(i.ExtensionsRegistry),f.registerSchema($,e.$uH),f.registerSchema(c.$zk,{properties:{extensionEnabledApiProposals:{description:s.localize(12363,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals).map(a=>a.proposal)}}]}}}})}),define(Re[273],Ce([1,0,4,40,3,13,7,23,5,11,25,166]),function(ge,e,s,h,D,O,T,A,p,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LH=e.$KH=e.$JH=e.ChatMessageRole=void 0;var f;(function(o){o[o.System=0]="System",o[o.User=1]="User",o[o.Assistant=2]="Assistant"})(f||(e.ChatMessageRole=f={})),e.$JH=(0,p.$Ki)("ILanguageModelsService");const P={type:"object",properties:{vendor:{type:"string",description:(0,T.localize)(4744,null)}}};e.$KH=E.$wH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,T.localize)(4745,null),oneOf:[P,{type:"array",items:P}]},activationEventsGenerator:(o,m)=>{for(const $ of o)m.push(`onLanguageModelChat:${$.vendor}`)}});let v=class{constructor(m,$){this.e=m,this.f=$,this.a=new D.$Yc,this.b=new Map,this.c=new Set,this.d=this.a.add(new s.$qe),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$KH.setHandler(d=>{this.c.clear();for(const a of d){if(!(0,I.$CH)(a.description,"chatProvider")){a.collector.error((0,T.localize)(4746,null));continue}for(const t of h.Iterable.wrap(a.value)){if(this.c.has(t.vendor)){a.collector.error((0,T.localize)(4747,null,t.vendor));continue}if((0,O.$hf)(t.vendor)){a.collector.error((0,T.localize)(4748,null));continue}if(t.vendor.trim()!==t.vendor){a.collector.error((0,T.localize)(4749,null));continue}this.c.add(t.vendor)}}const i=[];for(const[a,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(a),i.push(a));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const d=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(d)}const $=[];for(const[d,i]of this.b)(m.vendor===void 0||i.metadata.vendor===m.vendor)&&(m.family===void 0||i.metadata.family===m.family)&&(m.version===void 0||i.metadata.version===m.version)&&(m.identifier===void 0||i.metadata.id===m.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(a=>A.$zn.equals(a,m.extension)))&&$.push(d);return this.f.trace("[LM] selected language models",m,$),$}registerLanguageModelChat(m,$){if(this.f.trace("[LM] registering language model chat",m,$.metadata),!this.c.has($.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${$.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,$),this.d.fire({added:[{identifier:m,metadata:$.metadata}]}),(0,D.$Xc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,$.metadata))})}async sendChatRequest(m,$,d,i,a){const t=this.b.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(d,$,i,a)}computeTokenLength(m,$,d){const i=this.b.get(m);if(!i)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return i.provideTokenCount($,d)}};e.$LH=v,e.$LH=v=Ye([We(0,I.$zH),We(1,c.$fk)],v)}),define(Re[274],Ce([1,0,7,17,24,166,36,4]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hJ=void 0,s=Ue(s),h=Ue(h),D=Ue(D);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:s.localize(9883,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:s.localize(9884,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:s.localize(9885,null),default:""}}};var c;(function(f){function P(v,o,m){if(!v)return;const $=h.$jg(v.type)?v.type:void 0;if(!$||$.length===0){m.error(s.localize(9886,null));return}const d=[];if(Array.isArray(v.required))for(const i of v.required)h.$jg(i)&&d.push(i);return{extensionId:o.value,taskType:$,required:d,properties:v.properties?D.$mo(v.properties):{},when:v.when?T.$Ij.deserialize(v.when):void 0}}f.from=P})(c||(c={}));const I=O.$wH.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(f,P)=>{for(const v of f)v.type&&P.push(`onTaskType:${v.type}`)},jsonSchema:{description:s.localize(9887,null),type:"array",items:p}});class E{constructor(){this.d=new A.$qe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,v)=>{I.setHandler((o,m)=>{this.c=void 0;try{for(const $ of m.removed){const d=$.value;for(const i of d)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const $ of m.added){const d=$.value;for(const i of d){const a=c.from(i,$.description.identifier,$.collector);a&&(this.a[a.taskType]=a)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const v of this.all()){const o={type:"object",additionalProperties:!1};v.required.length>0&&(o.required=v.required.slice(0)),v.properties!==void 0?o.properties=D.$mo(v.properties):o.properties=Object.create(null),o.properties.type={type:"string",enum:[v.taskType]},P.push(o)}this.c={oneOf:P}}return this.c}}e.$hJ=new E}),define(Re[275],Ce([1,0,7,17,22,24,36,274,47]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$rJ=e.JsonSchemaVersion=e.ExecutionEngine=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$lJ=e.ShellQuoting=e.$kJ=e.$jJ=e.$iJ=void 0,s=Ue(s),h=Ue(h),D=Ue(D),O=Ue(O),e.$iJ="settings",e.$jJ=new T.$2j("taskRunning",!1,s.localize(9888,null)),e.$kJ=s.localize2(9890,"Tasks");var c;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$lJ="$customized",function(F){function j(W){if(!W)return F.Strong;switch(W.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=j}(c||(e.ShellQuoting=c={}));var I;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var E;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(E||(e.RevealKind=E={})),function(F){function j(W){switch(W.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=j}(E||(e.RevealKind=E={}));var f;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(f||(e.RevealProblemKind=f={})),function(F){function j(W){switch(W.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=j}(f||(e.RevealProblemKind=f={}));var P;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(P||(e.PanelKind=P={})),function(F){function j(W){switch(W.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=j}(P||(e.PanelKind=P={}));var v;(function(F){F.defaults={echo:!0,reveal:E.Always,revealProblems:f.Never,focus:!1,panel:P.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var o;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(o||(e.RuntimeType=o={})),function(F){function j(J){switch(J.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=j;function W(J){switch(J){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=W}(o||(e.RuntimeType=o={}));var m;(function(F){function j(W){return h.$jg(W)?W:W.value}F.value=j})(m||(e.CommandString=m={}));var $;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function j(J){return J===F.Clean._id||J===F.Build._id||J===F.Rebuild._id||J===F.Test._id}F.is=j;function W(J){if(J!==void 0)return h.$jg(J)?j(J)?{_id:J,isDefault:!1}:void 0:J}F.from=W})($||(e.TaskGroup=$={}));var d;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(d||(e.TaskScope=d={}));var i;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function j(W){switch(W){case F.User:return p.ConfigurationTarget.USER;case F.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}F.toConfigurationTarget=j})(i||(e.TaskSourceKind=i={}));var a;(function(F){F.parallel="parallel",F.sequence="sequence"})(a||(e.DependsOrder=a={}));var t;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var r;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(r||(e.RunOptions=r={}));class n{constructor(j,W,J,B,U,_){this._label="",this._id=j,W&&(this._label=W),J&&(this.type=J),this.runOptions=B,this.configurationProperties=U,this._source=_}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,W=!1){if(j===void 0)return!1;if(h.$jg(j))return j===this._label||j===this.configurationProperties.identifier||W&&j===this._id;const J=this.getDefinition(!0);return J!==void 0&&J._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$mJ=n;class u extends n{constructor(j,W,J,B,U,_,x,oe){super(j,J,void 0,x,oe,W),this.command={},this._source=W,this.hasDefinedMatchers=_,U&&(this.command=U)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case o.Shell:W="shell";break;case o.Process:W="process";break;case o.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(j){return j instanceof u}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$iJ:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const J={type:e.$lJ,folder:j,id:W};return JSON.stringify(J)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.$ih(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new u(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$nJ=u;class l extends n{constructor(j,W,J,B,U,_,x){super(j,J,B,_,x,W),this._source=W,this.configures=U}static is(j){return j instanceof l}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.$ih(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$iJ:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const J={type:e.$lJ,folder:j,id:W};return JSON.stringify(J)}}e.$oJ=l;class g extends n{constructor(j,W,J,B,U,_,x,oe,te){super(j,J,B,oe,te,W),this.defines=U,this.hasDefinedMatchers=x,this.command=_,this.icon=te.icon,this.hide=te.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof g}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===d.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new g(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$pJ=g;class y extends n{constructor(j,W,J,B,U,_){super(j,J,B,U,_,W),this._source=W}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new y(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$qJ=y;var k;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(k||(e.ExecutionEngine=k={})),function(F){F._default=F.Terminal}(k||(e.ExecutionEngine=k={}));var S;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class R{constructor(j){this.c=new Map;for(let W=0;W<j.length;W++)this.c.set(j[W].uri.toString(),W)}compare(j,W){const J=j.getWorkspaceFolder(),B=W.getWorkspaceFolder();if(J&&B){let U=this.c.get(J.uri.toString());U=U===void 0?0:U+1;let _=this.c.get(B.uri.toString());return _=_===void 0?0:_+1,U===_?j._label.localeCompare(W._label):U-_}else return!J&&B?-1:J&&!B?1:0}}e.$rJ=R;var C;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(C||(e.TaskEventKind=C={}));var w;(function(F){F.SingleRun="singleRun",F.Background="background"})(w||(e.TaskRunType=w={}));var b;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var N;(function(F){function j(oe){return{taskId:oe._id,taskName:oe.configurationProperties.name,runType:oe.configurationProperties.isBackground?w.Background:w.SingleRun,group:oe.configurationProperties.group,__task:oe}}function W(oe,te,me){return{...j(oe),kind:C.Start,terminalId:te,resolvedVariables:me}}F.start=W;function J(oe,te,me){return{...j(oe),kind:C.ProcessStarted,terminalId:te,processId:me}}F.processStarted=J;function B(oe,te,me){return{...j(oe),kind:C.ProcessEnded,terminalId:te,exitCode:me}}F.processEnded=B;function U(oe,te,me){return{...j(oe),kind:C.Terminated,exitReason:me,terminalId:te}}F.terminated=U;function _(oe,te,me){return{...j(te),kind:oe,terminalId:me}}F.general=_;function x(){return{kind:C.Changed}}F.changed=x})(N||(e.TaskEvent=N={}));var L;(function(F){function j(J){const B=Object.keys(J).sort();let U="";for(const _ of B){let x=J[_];x instanceof Object?x=j(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),U+=_+","+x+","}return U}function W(J){const U={_key:j(J),type:J.taskType};return Object.assign(U,J),U}F.create=W})(L||(e.KeyedTaskIdentifier=L={}));var M;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(M||(e.TaskSettingId=M={}));var z;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var V;(function(F){function j(W,J){const B=A.$hJ.get(W.type);if(B===void 0){const oe=O.$mo(W);return delete oe._key,L.create(oe)}const U=Object.create(null);U.type=B.taskType;const _=new Set;B.required.forEach(oe=>_.add(oe));const x=B.properties;for(const oe of Object.keys(x)){const te=W[oe];if(te!=null)U[oe]=te;else if(_.has(oe)){const me=x[oe];if(me.default!==void 0)U[oe]=O.$mo(me.default);else switch(me.type){case"boolean":U[oe]=!1;break;case"number":case"integer":U[oe]=0;break;case"string":U[oe]="";break;default:J.error(s.localize(9889,null,JSON.stringify(W,void 0,0),oe));return}}}return L.create(U)}F.createTaskIdentifier=j})(V||(e.TaskDefinition=V={}))}),define(Re[276],Ce([1,0,12]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=e.$pfc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((T,A)=>{this.b=T,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(T){this.f||this.h||(this.f=!0,this.g=T,this.a&&this.b(T))}resolveErr(T){this.f||this.h||(this.h=!0,this.i=T,this.a?this.d(T):(0,s.$4)(T))}then(T,A){return this.j().then(T,A)}catch(T){return this.j().then(void 0,T)}finally(T){return this.j().finally(T)}}e.$pfc=h;class D extends h{constructor(){super(),this.h=!0,this.i=new s.$9}}e.$qfc=D}),define(Re[53],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9w=e.$6w=void 0,e.$7w=D,e.$8w=O;class s{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++s.count}}e.$6w=s;const h=[];function D(A){const p=new s(A);return h[p.nid]=p,p}function O(A){return h[A].sid}class T{constructor(p){this.value=p}}e.$9w=T}),define(Re[6],Ce([1,0,53]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=e.$bO=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$aO=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var D;(function(o){o[o.UnknownInput=0]="UnknownInput",o[o.TextInput=1]="TextInput",o[o.TextDiffInput=2]="TextDiffInput",o[o.TextMergeInput=3]="TextMergeInput",o[o.NotebookInput=4]="NotebookInput",o[o.NotebookDiffInput=5]="NotebookDiffInput",o[o.CustomEditorInput=6]="CustomEditorInput",o[o.WebviewEditorInput=7]="WebviewEditorInput",o[o.TerminalEditorInput=8]="TerminalEditorInput",o[o.InteractiveEditorInput=9]="InteractiveEditorInput",o[o.ChatEditorInput=10]="ChatEditorInput",o[o.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(D||(e.TabInputKind=D={}));var O;(function(o){o[o.TAB_OPEN=0]="TAB_OPEN",o[o.TAB_CLOSE=1]="TAB_CLOSE",o[o.TAB_UPDATE=2]="TAB_UPDATE",o[o.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var T;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(T||(e.WebviewEditorCapabilities=T={}));var A;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var p;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var c;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var I;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output",o[o.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class E{static{this.a=0}static mixin(m){return m._id=E.a++,m}}e.$aO=E;var f;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.kindModifier="m",o.commandIdent="n",o.commandId="o",o.commandArguments="p"})(f||(e.ISuggestDataDtoField=f={}));var P;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(P||(e.ISuggestResultDtoField=P={}));var v;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$bO={MainThreadAuthentication:(0,s.$7w)("MainThreadAuthentication"),MainThreadBulkEdits:(0,s.$7w)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,s.$7w)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,s.$7w)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,s.$7w)("MainThreadChatAgents2"),MainThreadChatVariables:(0,s.$7w)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,s.$7w)("MainThreadChatSkills"),MainThreadClipboard:(0,s.$7w)("MainThreadClipboard"),MainThreadCommands:(0,s.$7w)("MainThreadCommands"),MainThreadComments:(0,s.$7w)("MainThreadComments"),MainThreadConfiguration:(0,s.$7w)("MainThreadConfiguration"),MainThreadConsole:(0,s.$7w)("MainThreadConsole"),MainThreadDebugService:(0,s.$7w)("MainThreadDebugService"),MainThreadDecorations:(0,s.$7w)("MainThreadDecorations"),MainThreadDiagnostics:(0,s.$7w)("MainThreadDiagnostics"),MainThreadDialogs:(0,s.$7w)("MainThreadDiaglogs"),MainThreadDocuments:(0,s.$7w)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,s.$7w)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,s.$7w)("MainThreadTextEditors"),MainThreadEditorInsets:(0,s.$7w)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,s.$7w)("MainThreadEditorTabs"),MainThreadErrors:(0,s.$7w)("MainThreadErrors"),MainThreadTreeViews:(0,s.$7w)("MainThreadTreeViews"),MainThreadDownloadService:(0,s.$7w)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,s.$7w)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,s.$7w)("MainThreadLanguages"),MainThreadLogger:(0,s.$7w)("MainThreadLogger"),MainThreadMessageService:(0,s.$7w)("MainThreadMessageService"),MainThreadOutputService:(0,s.$7w)("MainThreadOutputService"),MainThreadProgress:(0,s.$7w)("MainThreadProgress"),MainThreadQuickDiff:(0,s.$7w)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,s.$7w)("MainThreadQuickOpen"),MainThreadStatusBar:(0,s.$7w)("MainThreadStatusBar"),MainThreadSecretState:(0,s.$7w)("MainThreadSecretState"),MainThreadStorage:(0,s.$7w)("MainThreadStorage"),MainThreadSpeech:(0,s.$7w)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,s.$7w)("MainThreadTelemetry"),MainThreadTerminalService:(0,s.$7w)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,s.$7w)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,s.$7w)("MainThreadWebviews"),MainThreadWebviewPanels:(0,s.$7w)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,s.$7w)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,s.$7w)("MainThreadCustomEditors"),MainThreadUrls:(0,s.$7w)("MainThreadUrls"),MainThreadUriOpeners:(0,s.$7w)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,s.$7w)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,s.$7w)("MainThreadWorkspace"),MainThreadFileSystem:(0,s.$7w)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,s.$7w)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,s.$7w)("MainThreadExtensionService"),MainThreadSCM:(0,s.$7w)("MainThreadSCM"),MainThreadSearch:(0,s.$7w)("MainThreadSearch"),MainThreadShare:(0,s.$7w)("MainThreadShare"),MainThreadTask:(0,s.$7w)("MainThreadTask"),MainThreadWindow:(0,s.$7w)("MainThreadWindow"),MainThreadLabelService:(0,s.$7w)("MainThreadLabelService"),MainThreadNotebook:(0,s.$7w)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,s.$7w)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,s.$7w)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,s.$7w)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,s.$7w)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,s.$7w)("MainThreadInteractive"),MainThreadTheming:(0,s.$7w)("MainThreadTheming"),MainThreadTunnelService:(0,s.$7w)("MainThreadTunnelService"),MainThreadManagedSockets:(0,s.$7w)("MainThreadManagedSockets"),MainThreadTimeline:(0,s.$7w)("MainThreadTimeline"),MainThreadTesting:(0,s.$7w)("MainThreadTesting"),MainThreadLocalization:(0,s.$7w)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,s.$7w)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,s.$7w)("MainThreadAiEmbeddingVector")},e.$cO={ExtHostCommands:(0,s.$7w)("ExtHostCommands"),ExtHostConfiguration:(0,s.$7w)("ExtHostConfiguration"),ExtHostDiagnostics:(0,s.$7w)("ExtHostDiagnostics"),ExtHostDebugService:(0,s.$7w)("ExtHostDebugService"),ExtHostDecorations:(0,s.$7w)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,s.$7w)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,s.$7w)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,s.$7w)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,s.$7w)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,s.$7w)("ExtHostEditors"),ExtHostTreeViews:(0,s.$7w)("ExtHostTreeViews"),ExtHostFileSystem:(0,s.$7w)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,s.$7w)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,s.$7w)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,s.$7w)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,s.$7w)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,s.$7w)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,s.$7w)("ExtHostQuickDiff"),ExtHostStatusBar:(0,s.$7w)("ExtHostStatusBar"),ExtHostShare:(0,s.$7w)("ExtHostShare"),ExtHostExtensionService:(0,s.$7w)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,s.$7w)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,s.$7w)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,s.$7w)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,s.$7w)("ExtHostSCM"),ExtHostSearch:(0,s.$7w)("ExtHostSearch"),ExtHostTask:(0,s.$7w)("ExtHostTask"),ExtHostWorkspace:(0,s.$7w)("ExtHostWorkspace"),ExtHostWindow:(0,s.$7w)("ExtHostWindow"),ExtHostWebviews:(0,s.$7w)("ExtHostWebviews"),ExtHostWebviewPanels:(0,s.$7w)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,s.$7w)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,s.$7w)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,s.$7w)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,s.$7w)("ExtHostEditorTabs"),ExtHostProgress:(0,s.$7w)("ExtHostProgress"),ExtHostComments:(0,s.$7w)("ExtHostComments"),ExtHostSecretState:(0,s.$7w)("ExtHostSecretState"),ExtHostStorage:(0,s.$7w)("ExtHostStorage"),ExtHostUrls:(0,s.$7w)("ExtHostUrls"),ExtHostUriOpeners:(0,s.$7w)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,s.$7w)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,s.$7w)("ExtHostOutputService"),ExtHostLabelService:(0,s.$7w)("ExtHostLabelService"),ExtHostNotebook:(0,s.$7w)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,s.$7w)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,s.$7w)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,s.$7w)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,s.$7w)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,s.$7w)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,s.$7w)("ExtHostInteractive"),ExtHostChatAgents2:(0,s.$7w)("ExtHostChatAgents"),ExtHostChatVariables:(0,s.$7w)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,s.$7w)("ExtHostChatSkills"),ExtHostChatProvider:(0,s.$7w)("ExtHostChatProvider"),ExtHostSpeech:(0,s.$7w)("ExtHostSpeech"),ExtHostEmbeddings:(0,s.$7w)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,s.$7w)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,s.$7w)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,s.$7w)("ExtHostTheming"),ExtHostTunnelService:(0,s.$7w)("ExtHostTunnelService"),ExtHostManagedSockets:(0,s.$7w)("ExtHostManagedSockets"),ExtHostAuthentication:(0,s.$7w)("ExtHostAuthentication"),ExtHostTimeline:(0,s.$7w)("ExtHostTimeline"),ExtHostTesting:(0,s.$7w)("ExtHostTesting"),ExtHostTelemetry:(0,s.$7w)("ExtHostTelemetry"),ExtHostLocalization:(0,s.$7w)("ExtHostLocalization")}}),define(Re[96],Ce([1,0,5,11,6,19]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=e.$8qc=e.$7qc=void 0,D=Ue(D),e.$7qc=(0,s.$Ki)("IExtHostApiDeprecationService");let T=class{constructor(p,c){this.c=c,this.a=new Set,this.b=p.getProxy(D.$bO.MainThreadTelemetry)}report(p,c,I){const E=this.d(p,c);this.a.has(E)||(this.a.add(E),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:p}))}d(p,c){return`${p}-${c.identifier.value}`}};e.$8qc=T,e.$8qc=T=Ye([We(0,O.$OQ),We(1,h.$fk)],T),e.$9qc=Object.freeze(new class{report(A,p,c){}})}),define(Re[277],Ce([1,0,6]),function(ge,e,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=void 0;class h{constructor(O){const T=O.getProxy(s.$bO.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(A){return T.$writeText(A)}})}}e.$jrc=h}),define(Re[278],Ce([1,0,24,6,29,19]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ktc=void 0;let T=class{constructor(I,E){this.a=I.getProxy(h.$bO.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,E){const f=this,P=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){f.e(I,E,P,arguments)}})}e(I,E,f,P){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:p(P,this.b)}),this.c&&this.f(I,f,P)}};e.$ktc=T,e.$ktc=T=Ye([We(0,O.$OQ),We(1,D.$5Q)],T);const A=1e5;function p(c,I){const E=[];if(c.length)for(let f=0;f<c.length;f++){let P=c[f];if(typeof P>"u")P="undefined";else if(P instanceof Error){const v=P;v.stack?P=v.stack:P=v.toString()}E.push(P)}if(I){const f=new Error().stack;f&&E.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,s.$ro)(E);return f.length>A?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(Re[279],Ce([1,0,2,6,25]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lsc=void 0;class O{constructor(A){this.a=A.getProxy(h.$bO.MainThreadDialogs)}showOpenDialog(A,p){return p?.allowUIResources&&(0,D.$DH)(A,"showLocal"),this.a.$showOpenDialog(p).then(c=>c?c.map(I=>s.URI.revive(I)):void 0)}showSaveDialog(A){return this.a.$showSaveDialog(A).then(p=>p?s.URI.revive(p):void 0)}}e.$lsc=O}),define(Re[280],Ce([1,0,20,4,3,6]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$osc=void 0;class T{constructor(p){this.b=new Map,this.c=new h.$qe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(O.$bO.MainThreadEmbeddings)}registerEmbeddingsProvider(p,c,I){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const E=this.e++;return this.a.$registerEmbeddingProvider(E,c),this.b.set(E,{id:c,provider:I}),(0,D.$Xc)(()=>{this.d.delete(c),this.a.$unregisterEmbeddingProvider(E),this.b.delete(E)})}async computeEmbeddings(p,c,I){I??=s.CancellationToken.None;let E=!1;typeof c=="string"&&(c=[c],E=!0);const f=await this.a.$computeEmbeddings(p,c,I);if(f.length!==c.length)throw new Error;if(E){if(f.length!==1)throw new Error;return f[0]}return f}async $provideEmbeddings(p,c,I){const E=this.b.get(p);if(!E)return[];const f=await E.provider.provideEmbeddings(c,I);return f||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$osc=T}),define(Re[281],Ce([1,0,3,6]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ksc=void 0;class D{constructor(T){this.b=0,this.a=T.getProxy(h.$bO.MainThreadLabelService)}$registerResourceLabelFormatter(T){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,T),(0,s.$Xc)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.$Ksc=D}),define(Re[123],Ce([1,0,10,13,2,5,11,6,29,19]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2rc=e.$1rc=void 0;let I=class{constructor(f,P,v){this.f=v,this.d=new Map,this.a=P.getProxy(A.$bO.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===s.$j}getMessage(f,P){const{message:v,args:o,comment:m}=P;if(this.c)return(0,h.$jf)(v,o??{});let $=v;m&&m.length>0&&($+=`/${Array.isArray(m)?m.join(""):m}`);const d=this.d.get(f)?.contents[$];return d||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${$}`),(0,h.$jf)(d??v,o??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let P;const v=await this.g(f);if(!v){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const o=await this.a.$fetchBundleContents(v),m=JSON.parse(o);P=f.isBuiltin?m.contents?.bundle:m}catch(o){this.f.error(`Failed to load translations for ${f.identifier.value} from ${v}: ${o.message}`);return}P&&this.d.set(f.identifier.value,{contents:P,uri:v})}async g(f){if(f.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(f.identifier.value,this.b);return D.URI.revive(P)}return f.l10n?D.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$1rc=I,e.$1rc=I=Ye([We(0,p.$5Q),We(1,c.$OQ),We(2,T.$fk)],I),e.$2rc=(0,O.$Ki)("IExtHostLocalizationService")}),define(Re[167],Ce([1,0,11,6,29,19,2,38]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jtc=void 0;let p=class extends s.$qk{constructor(E,f){super(f.logLevel,f.logsLocation,f.loggers.map(P=>(0,A.$hi)(P))),this.r=E.getProxy(h.$bO.MainThreadLogger)}$setLogLevel(E,f){f?this.setLogLevel(T.URI.revive(f),E):this.setLogLevel(E)}setVisibility(E,f){super.setVisibility(E,f),this.r.$setVisibility(E,f)}s(E,f,P){return new c(this.r,E,f,P)}};e.$jtc=p,e.$jtc=p=Ye([We(0,O.$OQ),We(1,D.$5Q)],p);class c extends s.$lk{constructor(E,f,P,v){super(v?.logLevel==="always"),this.r=E,this.s=f,this.m=!1,this.n=[],this.setLevel(P),this.r.$createLogger(f,v).then(()=>{this.u(this.n),this.m=!0})}g(E,f){const P=[[E,f]];this.m?this.u(P):this.n.push(...P)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Re[124],Ce([1,0,6,5,3,19,21]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4rc=e.$3rc=void 0,e.$3rc=(0,h.$Ki)("IExtHostManagedSockets");let A=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(s.$bO.MainThreadManagedSockets)}setFactory(E,f){for(const P of this.d.values())P.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(E,f),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const f=++this.b,P=await this.c.makeConnection(),v=new D.$Yc;return this.d.set(f,new c(f,P,v)),v.add((0,D.$Xc)(()=>this.d.delete(f))),v.add(P.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(f),v.dispose()})),v.add(P.onDidClose(o=>{this.a.$onDidManagedSocketClose(f,o?.stack??o?.message),v.dispose()})),v.add(P.onDidReceiveMessage(o=>this.a.$onDidManagedSocketHaveData(f,T.$Se.wrap(o)))),f}$remoteSocketWrite(E,f){this.d.get(E)?.actual.send(f.buffer)}$remoteSocketEnd(E){const f=this.d.get(E);f&&(f.actual.end(),f.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$4rc=A,e.$4rc=A=Ye([We(0,O.$OQ)],A);class p{constructor(E,f){this.socketFactoryId=E,this.makeConnection=f}}class c extends D.$Zc{constructor(E,f,P){super(),this.socketId=E,this.actual=f,this.B(P)}}}),define(Re[282],Ce([1,0,6,11,25]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nsc=void 0;function O(A){return A&&A.title}let T=class{constructor(p,c){this.b=c,this.a=p.getProxy(s.$bO.MainThreadMessageService)}showMessage(p,c,I,E,f){const P={source:{identifier:p.identifier,label:p.displayName||p.name}};let v;typeof E=="string"||O(E)?v=[E,...f]:(P.modal=E?.modal,P.useCustom=E?.useCustom,P.detail=E?.detail,v=f),P.useCustom&&(0,D.$DH)(p,"resolvers");const o=[];let m=!1;for(let $=0;$<v.length;$++){const d=v[$];if(typeof d=="string")o.push({title:d,handle:$,isCloseAffordance:!1});else if(typeof d=="object"){const{title:i,isCloseAffordance:a}=d;o.push({title:i,isCloseAffordance:!!a,handle:$}),a&&(m?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,d):m=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,d)}return this.a.$showMessage(c,I,P,o).then($=>{if(typeof $=="number")return v[$]})}};e.$Nsc=T,e.$Nsc=T=Ye([We(1,h.$fk)],T)}),define(Re[283],Ce([1,0,3,17,2,25,6]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wsc=void 0;class A{constructor(c){this.b=new Map,this.a=c.getProxy(T.$bO.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,I,E){if((0,O.$DH)(c,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,E),this.a.$registerProfileContentHandler(I,E.name,E.description,c.identifier.value),(0,s.$Xc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(c,I,E,f){const P=this.b.get(c);if(!P)throw new Error(`Unknown handler with id: ${c}`);return P.saveProfile(I,E,f)}async $readProfile(c,I,E){const f=this.b.get(c);if(!f)throw new Error(`Unknown handler with id: ${c}`);return f.readProfile((0,h.$jg)(I)?I:D.URI.revive(I),E)}}e.$Wsc=A}),define(Re[125],Ce([1,0,6,4,5]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yrc=e.$Xrc=void 0;class O{constructor(A){this.b=new h.$qe,this.onDidChangePassword=this.b.event,this.a=A.getProxy(s.$bO.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,p){return this.a.$getPassword(A,p)}store(A,p,c){return this.a.$setPassword(A,p,c)}delete(A,p){return this.a.$deletePassword(A,p)}}e.$Xrc=O,e.$Yrc=(0,D.$Ki)("IExtHostSecretState")}),define(Re[284],Ce([1,0,20,3,6]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4sc=void 0;class O{static{this.a=1}constructor(A){this.c=new Map,this.d=new Map,this.f=new Map,this.b=A.getProxy(D.$bO.MainThreadSpeech)}async $createSpeechToTextSession(A,p,c){const I=this.c.get(A);if(!I)return;const E=new h.$Yc,f=new s.$Be;this.d.set(p,f);const P=await I.provideSpeechToTextSession(f.token,c?{language:c}:void 0);P&&(E.add(P.onDidChange(v=>{f.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,v)})),E.add(f.token.onCancellationRequested(()=>E.dispose())))}async $cancelSpeechToTextSession(A){this.d.get(A)?.dispose(!0),this.d.delete(A)}async $createTextToSpeechSession(A,p,c){const I=this.c.get(A);if(!I)return;const E=new h.$Yc,f=new s.$Be;this.d.set(p,f);const P=await I.provideTextToSpeechSession(f.token,c?{language:c}:void 0);P&&(this.f.set(p,P),E.add(P.onDidChange(v=>{f.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,v)})),E.add(f.token.onCancellationRequested(()=>E.dispose())))}async $synthesizeSpeech(A,p){this.f.get(A)?.synthesize(p)}async $cancelTextToSpeechSession(A){this.d.get(A)?.dispose(!0),this.d.delete(A),this.f.delete(A)}async $createKeywordRecognitionSession(A,p){const c=this.c.get(A);if(!c)return;const I=new h.$Yc,E=new s.$Be;this.d.set(p,E);const f=await c.provideKeywordRecognitionSession(E.token);f&&(I.add(f.onDidChange(P=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,P)})),I.add(E.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(A){this.d.get(A)?.dispose(!0),this.d.delete(A)}registerProvider(A,p,c){const I=O.a++;return this.c.set(I,c),this.b.$registerProvider(I,p,{extension:A,displayName:A.value}),(0,h.$Xc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$4sc=O}),define(Re[126],Ce([1,0,6,4,5]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Orc=e.$Nrc=void 0;class O{constructor(A,p){this.c=p,this.b=new h.$qe,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(s.$bO.MainThreadStorage)}registerExtensionStorageKeysToSync(A,p){this.a.$registerExtensionStorageKeysToSync(A,p)}async initializeExtensionStorage(A,p,c){const I=await this.a.$initializeExtensionStorage(A,p);let E;return I&&(E=this.d(A,p,I)),E||c}setValue(A,p,c){return this.a.$setValue(A,p,c)}$acceptValue(A,p,c){const I=this.d(A,p,c);I&&this.b.fire({shared:A,key:p,value:I})}d(A,p,c){try{return JSON.parse(c)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${A}): ${I}`)}}}e.$Nrc=O,e.$Orc=(0,D.$Ki)("IExtHostStorage")}),define(Re[285],Ce([1,0,3,14,2,6]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dtc=void 0;class T{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(O.$bO.MainThreadUriOpeners)}registerExternalUriOpener(p,c,I,E){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const f=E.schemes.find(P=>!T.a.has(P));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(c,I),this.b.$registerUriOpener(c,E.schemes,p,E.label),(0,s.$Xc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(p,c,I){const E=this.c.get(p);if(!E)throw new Error(`Unknown opener with id: ${p}`);const f=D.URI.revive(c);return E.canOpenExternalUri(f,I)}async $openUri(p,c,I){const E=this.c.get(p);if(!E)throw new Error(`Unknown opener id: '${p}'`);return E.openExternalUri(D.URI.revive(c.resolvedUri),{sourceUri:D.URI.revive(c.sourceUri)},I)}}e.$dtc=T}),define(Re[286],Ce([1,0,6,2,3,12,23]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$etc=void 0;class A{static{this.a=0}constructor(c){this.c=new T.$An,this.d=new Map,this.b=c.getProxy(s.$bO.MainThreadUrls)}registerUriHandler(c,I){const E=c.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const f=A.a++;return this.c.add(E),this.d.set(f,I),this.b.$registerUriHandler(f,E,c.displayName||c.name),(0,D.$Xc)(()=>{this.c.delete(E),this.d.delete(f),this.b.$unregisterUriHandler(f)})}$handleExternalUri(c,I){const E=this.d.get(c);if(!E)return Promise.resolve(void 0);try{E.handleUri(h.URI.revive(I))}catch(f){(0,O.$4)(f)}return Promise.resolve(void 0)}async createAppUri(c){return h.URI.revive(await this.b.$createAppUri(c))}}e.$etc=A}),define(Re[287],Ce([1,0,21,6]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cwb=O,e.$dwb=A,h=Ue(h);class D{constructor(){this.buffers=[]}add(c){let I=this.buffers.indexOf(c);return I<0&&(I=this.buffers.length,this.buffers.push(c)),I}}function O(p,c){if(c.serializeBuffersForPostMessage){const I=new D,f=JSON.stringify(p,(v,o)=>{if(o instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(o)};if(ArrayBuffer.isView(o)){const m=T(o);if(m)return{$$vscode_array_buffer_reference$$:!0,index:I.add(o.buffer),view:{type:m,byteLength:o.byteLength,byteOffset:o.byteOffset}}}return o}),P=I.buffers.map(v=>{const o=new Uint8Array(v);return s.$Se.wrap(o)});return{message:f,buffers:P}}else return{message:JSON.stringify(p),buffers:[]}}function T(p){switch(p.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function A(p,c){const I=c.map(P=>{const v=new ArrayBuffer(P.byteLength);return new Uint8Array(v).set(P.buffer),v}),E=c.length?(P,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const o=v,{index:m}=o,$=I[m];if(o.view)switch(o.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array($,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array($,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray($,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array($,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array($,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array($,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array($,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array($,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array($,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array($,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array($,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return $}return v}:void 0;return{message:JSON.parse(p,E),arrayBuffers:I}}}),define(Re[97],Ce([1,0,4,3,14,24,2,239,287,122,6]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Arc=e.$yrc=void 0,e.$zrc=f,e.$Brc=o,e.$Crc=m,O=Ue(O),I=Ue(I);class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(a,t,r,n,u,l,g){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new s.$qe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new s.$qe,this._onDidDispose=this.#h.event,this.#e=a,this.#t=t,this.#o=r,this.#n=n,this.#s=u,this.#r=l,this.#u=f(l),this.#d=P(l),this.#i=g}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#l=!0,(0,c.$FEb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===D.Schemas.https||a.scheme===D.Schemas.http){let t=a.toString();return t.endsWith("/")||(t+="/"),t+" "+c.$EEb}return c.$EEb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),O.$qo(this.#o,a)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const t=(0,p.$cwb)(a,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const t=this.#r.extensionLocation?.scheme===D.Schemas.vscodeRemote,r=this.#r.extensionLocation.scheme===D.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,u,l,g,y,k)=>{const S=T.URI.from({scheme:g||"file",path:decodeURIComponent(y)}),R=(0,c.$FEb)(S,{isRemote:t,authority:r}).toString();return`${u}${R}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,u,l,g,y,k)=>{const S=T.URI.from({scheme:g||"file",path:decodeURIComponent(y)}),R=(0,c.$FEb)(S,{isRemote:t,authority:r}).toString();return`${u}${R}${k}`})}}e.$yrc=E;function f(i){try{const a=(0,A.$0p)((0,A.$9p)(i.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function P(i){try{const a=(0,A.$0p)((0,A.$9p)(i.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class v extends h.$Zc{constructor(a,t,r,n,u){super(),this.c=t,this.f=r,this.g=n,this.h=u,this.b=new Map,this.a=a.getProxy(I.$bO.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,t,r){const n=this.j(a);if(n){const{message:u}=(0,p.$dwb)(t,r.value);n._onMessageEmitter.fire(u)}}$onMissingCsp(a,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,t,r){const n=new E(a,this.a,$(t),this.c,this.f,r,this.h);this.b.set(a,n);const u=n._onDidDispose(()=>{u.dispose(),this.deleteWebview(a)});return n}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$Arc=v;function o(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,a,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||d(i,a)}}function $(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(a=>T.URI.from(a))}}function d(i,a){return[...(a?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Re[168],Ce([1,0,4,14,13,2,5,19,6]),function(ge,e,s,h,D,O,T,A,p){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$htc=e.$gtc=void 0;let I=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const f=this.d;return{get focused(){return f.focused},get active(){return f.active}}}constructor(f){this.c=new s.$qe,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=f.getProxy(p.$bO.MainThreadWindow),this.b.$getInitialState().then(({isFocused:P,isActive:v})=>{this.onDidChangeWindowProperty("focused",P),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(f){this.onDidChangeWindowProperty("focused",f)}$onDidChangeWindowActive(f){this.onDidChangeWindowProperty("active",f)}onDidChangeWindowProperty(f,P){P!==this.d[f]&&(this.d={...this.d,[f]:P},this.c.fire(this.d))}openUri(f,P){let v;if(typeof f=="string"){v=f;try{f=O.URI.parse(f)}catch{return Promise.reject(`Invalid uri - '${f}'`)}}return(0,D.$hf)(f.scheme)?Promise.reject("Invalid scheme - cannot be empty"):f.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${f.scheme}'`):this.b.$openUri(f,v,P)}async asExternalUri(f,P){if((0,D.$hf)(f.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(f,P);return O.URI.from(v)}};e.$gtc=I,e.$gtc=I=c=Ye([We(0,A.$OQ)],I),e.$htc=(0,T.$Ki)("IExtHostWindow")}),define(Re[288],Ce([1,0,278,29,19,94]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wtc=void 0;const T=1024*1024;let A=class extends s.$ktc{constructor(c,I){super(c,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(c,I,E){const f=c==="error"||c==="warn"?process.stderr:process.stdout;this.g=!0,f.write(`
${O.NativeLogMarkers.Start}
`),I.apply(console,E),f.write(`
${O.NativeLogMarkers.End}
`),this.g=!1}j(c,I){const E=process[c],f=E.write;let P="";Object.defineProperty(E,"write",{set:()=>{},get:()=>(v,o,m)=>{if(!this.g){P+=v.toString(o);const $=P.length>T?P.length:P.lastIndexOf(`
`);$!==-1&&(console[I](P.slice(0,$)),P=P.slice($+1))}f.call(E,v,o,m)}})}};e.$Wtc=A,e.$Wtc=A=Ye([We(0,D.$OQ),We(1,h.$5Q)],A)}),define(Re[289],Ce([1,0,167,14,233,31]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9tc=void 0;class T extends s.$jtc{s(p,c,I){return p.scheme===h.Schemas.file?new D.$5R(I?.name||(0,O.$7g)(),p.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,c):super.s(p,c,I)}registerLogger(p){super.registerLogger(p),this.r.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this.r.$deregisterLogger(p)}}e.$9tc=T}),define(Re[290],Ce([1,0,8,21,20,26,12,4,3,41,146,276,53]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.ResponsiveState=e.RequestInitiator=void 0,e.$rfc=d,e.$sfc=i,T=Ue(T);function v(N,L){try{return JSON.stringify(N,L)}catch{return"null"}}const o="$$ref$$",m={[o]:-1};class ${constructor(L,M){this.jsonString=L,this.referencedBuffers=M}}function d(N,L=null,M=!1){const z=[];return{jsonString:(M?v:JSON.stringify)(N,(F,j)=>{if(typeof j>"u")return m;if(typeof j=="object"){if(j instanceof h.$Se){const W=z.push(j)-1;return{[o]:W}}if(L)return L(F,j)}return j}),referencedBuffers:z}}function i(N,L,M){return JSON.parse(N,(z,V)=>{if(V){const F=V[o];if(typeof F=="number")return L[F];if(M&&V.$mid===c.MarshalledId.Uri)return M.transformIncoming(V)}return V})}function a(N,L){return JSON.stringify(N,L)}function t(N){return N?(L,M)=>M&&M.$mid===c.MarshalledId.Uri?N.transformOutgoing(M):M:null}var r;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var n;(function(N){N[N.Responsive=0]="Responsive",N[N.Unresponsive=1]="Unresponsive"})(n||(e.ResponsiveState=n={}));const u=()=>{},l=Symbol.for("rpcProtocol"),g=Symbol.for("rpcProxy");class y extends p.$Zc{static{P=l}static{this.a=3*1e3}constructor(L,M=null,z=null){super(),this[P]=!0,this.b=this.B(new A.$qe),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=M,this.g=z,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,F=f.$6w.count;V<F;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=n.Responsive,this.z=0,this.C=0,this.D=this.B(new s.$Wh(()=>this.H(),1e3)),this.B(this.c.onMessage(V=>this.L(V)))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const M=this.w[L];delete this.w[L],M.resolveErr(T.$0())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+y.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+y.a,this.z--,this.z===0&&this.D.cancel(),this.I(n.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(n.Unresponsive):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,I.$Xn)(L,this.g):L}getProxy(L){const{nid:M,sid:z}=L;return this.s[M]||(this.s[M]=this.J(M,z)),this.s[M]}J(L,M){const z={get:(V,F)=>(typeof F=="string"&&!V[F]&&F.charCodeAt(0)===O.CharCode.DollarSign&&(V[F]=(...j)=>this.U(L,F,j)),F===g?M:V[F])};return new Proxy(Object.create(null),z)}set(L,M){return this.m[L.nid]=M,M}assertRegistered(L){for(let M=0,z=L.length;M<z;M++){const V=L[M];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(L){if(this.j)return;const M=L.byteLength,z=S.read(L,0),V=z.readUInt8(),F=z.readUInt32();switch(V){case w.RequestJSONArgs:case w.RequestJSONArgsWithCancellation:{let{rpcId:j,method:W,args:J}=C.deserializeRequestJSONArgs(z);this.g&&(J=(0,I.$Xn)(J,this.g)),this.M(M,F,j,W,J,V===w.RequestJSONArgsWithCancellation);break}case w.RequestMixedArgs:case w.RequestMixedArgsWithCancellation:{let{rpcId:j,method:W,args:J}=C.deserializeRequestMixedArgs(z);this.g&&(J=(0,I.$Xn)(J,this.g)),this.M(M,F,j,W,J,V===w.RequestMixedArgsWithCancellation);break}case w.Acknowledged:{this.f?.logIncoming(M,F,r.LocalSide,"ack"),this.G(F);break}case w.Cancel:{this.N(M,F);break}case w.ReplyOKEmpty:{this.O(M,F,void 0);break}case w.ReplyOKJSON:{let j=C.deserializeReplyOKJSON(z);this.g&&(j=(0,I.$Xn)(j,this.g)),this.O(M,F,j);break}case w.ReplyOKJSONWithBuffers:{const j=C.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(M,F,j);break}case w.ReplyOKVSBuffer:{const j=C.deserializeReplyOKVSBuffer(z);this.O(M,F,j);break}case w.ReplyErrError:{let j=C.deserializeReplyErrError(z);this.g&&(j=(0,I.$Xn)(j,this.g)),this.P(M,F,j);break}case w.ReplyErrEmpty:{this.P(M,F,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,M,z,V,F,j){this.f?.logIncoming(L,M,r.OtherSide,`receiveRequest ${(0,f.$8w)(z)}.${V}(`,F);const W=String(M);let J,B;if(j){const _=new D.$Be;F.push(_.token),J=this.Q(z,V,F),B=()=>_.cancel()}else J=this.Q(z,V,F),B=u;this.u[W]=B;const U=C.serializeAcknowledged(M);this.f?.logOutgoing(U.byteLength,M,r.OtherSide,"ack"),this.c.send(U),J.then(_=>{delete this.u[W];const x=C.serializeReplyOK(M,_,this.h);this.f?.logOutgoing(x.byteLength,M,r.OtherSide,"reply:",_),this.c.send(x)},_=>{delete this.u[W];const x=C.serializeReplyErr(M,_);this.f?.logOutgoing(x.byteLength,M,r.OtherSide,"replyErr:",_),this.c.send(x)})}N(L,M){this.f?.logIncoming(L,M,r.OtherSide,"receiveCancel");const z=String(M);this.u[z]?.()}O(L,M,z){this.f?.logIncoming(L,M,r.LocalSide,"receiveReply:",z);const V=String(M);if(!this.w.hasOwnProperty(V))return;const F=this.w[V];delete this.w[V],F.resolveOk(z)}P(L,M,z){this.f?.logIncoming(L,M,r.LocalSide,"receiveReplyErr:",z);const V=String(M);if(!this.w.hasOwnProperty(V))return;const F=this.w[V];delete this.w[V];let j;z&&(z.$isError?(j=new Error,j.name=z.name,j.message=z.message,j.stack=z.stack):j=z),F.resolveErr(j)}Q(L,M,z){try{return Promise.resolve(this.S(L,M,z))}catch(V){return Promise.reject(V)}}S(L,M,z){const V=this.m[L];if(!V)throw new Error("Unknown actor "+(0,f.$8w)(L));const F=V[M];if(typeof F!="function")throw new Error("Unknown method "+M+" on actor "+(0,f.$8w)(L));return F.apply(V,z)}U(L,M,z){if(this.j)return new E.$qfc;let V=null;if(z.length>0&&D.CancellationToken.isCancellationToken(z[z.length-1])&&(V=z.pop()),V&&V.isCancellationRequested)return Promise.reject(T.$0());const F=C.serializeRequestArguments(z,this.h),j=++this.t,W=String(j),J=new E.$pfc,B=new p.$Yc;V&&B.add(V.onCancellationRequested(()=>{const _=C.serializeCancel(j);this.f?.logOutgoing(_.byteLength,j,r.LocalSide,"cancel"),this.c.send(C.serializeCancel(j))})),this.w[W]=new k(J,B),this.F(j);const U=C.serializeRequest(j,L,M,F,!!V);return this.f?.logOutgoing(U.byteLength,j,r.LocalSide,`request: ${(0,f.$8w)(L)}.${M}(`,z),this.c.send(U),J}}e.$tfc=y;class k{constructor(L,M){this.a=L,this.b=M}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class S{static alloc(L,M,z){const V=new S(h.$Se.alloc(z+1+4),0);return V.writeUInt8(L),V.writeUInt32(M),V}static read(L,M){return new S(L,M)}get buffer(){return this.a}constructor(L,M){this.a=L,this.b=M}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+L).toString();return this.b+=L,z}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+L).toString();return this.b+=L,z}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+L);return this.b+=L,M}static sizeMixedArray(L){let M=0;M+=1;for(let z=0,V=L.length;z<V;z++){const F=L[z];switch(M+=1,F.type){case b.String:M+=this.sizeLongString(F.value);break;case b.VSBuffer:M+=this.sizeVSBuffer(F.value);break;case b.SerializedObjectWithBuffers:M+=this.sizeUInt32,M+=this.sizeLongString(F.value);for(let j=0;j<F.buffers.length;++j)M+=this.sizeVSBuffer(F.buffers[j]);break;case b.Undefined:break}}return M}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let M=0,z=L.length;M<z;M++){const V=L[M];switch(V.type){case b.String:this.writeUInt8(b.String),this.writeLongString(V.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(V.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let F=0;F<V.buffers.length;++F)this.writeBuffer(V.buffers[F]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const M=new Array(L);for(let z=0;z<L;z++)switch(this.readUInt8()){case b.String:M[z]=this.readLongString();break;case b.VSBuffer:M[z]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const F=this.readUInt32(),j=this.readLongString(),W=[];for(let J=0;J<F;++J)W.push(this.readVSBuffer());M[z]=new f.$9w(i(j,W,null));break}case b.Undefined:M[z]=void 0;break}return M}}var R;(function(N){N[N.Simple=0]="Simple",N[N.Mixed=1]="Mixed"})(R||(R={}));class C{static a(L){for(let M=0,z=L.length;M<z;M++)if(L[M]instanceof h.$Se||L[M]instanceof f.$9w||typeof L[M]>"u")return!0;return!1}static serializeRequestArguments(L,M){if(this.a(L)){const z=[];for(let V=0,F=L.length;V<F;V++){const j=L[V];if(j instanceof h.$Se)z[V]={type:b.VSBuffer,value:j};else if(typeof j>"u")z[V]={type:b.Undefined};else if(j instanceof f.$9w){const{jsonString:W,referencedBuffers:J}=d(j.value,M);z[V]={type:b.SerializedObjectWithBuffers,value:h.$Se.fromString(W),buffers:J}}else z[V]={type:b.String,value:h.$Se.fromString(a(j,M))}}return{type:R.Mixed,args:z}}return{type:R.Simple,args:a(L,M)}}static serializeRequest(L,M,z,V,F){switch(V.type){case R.Simple:return this.b(L,M,z,V.args,F);case R.Mixed:return this.c(L,M,z,V.args,F)}}static b(L,M,z,V,F){const j=h.$Se.fromString(z),W=h.$Se.fromString(V);let J=0;J+=S.sizeUInt8(),J+=S.sizeShortString(j),J+=S.sizeLongString(W);const B=S.alloc(F?w.RequestJSONArgsWithCancellation:w.RequestJSONArgs,L,J);return B.writeUInt8(M),B.writeShortString(j),B.writeLongString(W),B.buffer}static deserializeRequestJSONArgs(L){const M=L.readUInt8(),z=L.readShortString(),V=L.readLongString();return{rpcId:M,method:z,args:JSON.parse(V)}}static c(L,M,z,V,F){const j=h.$Se.fromString(z);let W=0;W+=S.sizeUInt8(),W+=S.sizeShortString(j),W+=S.sizeMixedArray(V);const J=S.alloc(F?w.RequestMixedArgsWithCancellation:w.RequestMixedArgs,L,W);return J.writeUInt8(M),J.writeShortString(j),J.writeMixedArray(V),J.buffer}static deserializeRequestMixedArgs(L){const M=L.readUInt8(),z=L.readShortString(),V=L.readMixedArray(),F=new Array(V.length);for(let j=0,W=V.length;j<W;j++){const J=V[j];typeof J=="string"?F[j]=JSON.parse(J):F[j]=J}return{rpcId:M,method:z,args:F}}static serializeAcknowledged(L){return S.alloc(w.Acknowledged,L,0).buffer}static serializeCancel(L){return S.alloc(w.Cancel,L,0).buffer}static serializeReplyOK(L,M,z){if(typeof M>"u")return this.d(L);if(M instanceof h.$Se)return this.e(L,M);if(M instanceof f.$9w){const{jsonString:V,referencedBuffers:F}=d(M.value,z,!0);return this.g(L,V,F)}else return this.f(L,v(M,z))}static d(L){return S.alloc(w.ReplyOKEmpty,L,0).buffer}static e(L,M){let z=0;z+=S.sizeVSBuffer(M);const V=S.alloc(w.ReplyOKVSBuffer,L,z);return V.writeVSBuffer(M),V.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,M){const z=h.$Se.fromString(M);let V=0;V+=S.sizeLongString(z);const F=S.alloc(w.ReplyOKJSON,L,V);return F.writeLongString(z),F.buffer}static g(L,M,z){const V=h.$Se.fromString(M);let F=0;F+=S.sizeUInt32,F+=S.sizeLongString(V);for(const W of z)F+=S.sizeVSBuffer(W);const j=S.alloc(w.ReplyOKJSONWithBuffers,L,F);j.writeUInt32(z.length),j.writeLongString(V);for(const W of z)j.writeBuffer(W);return j.buffer}static deserializeReplyOKJSON(L){const M=L.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(L,M){const z=L.readUInt32(),V=L.readLongString(),F=[];for(let j=0;j<z;++j)F.push(L.readVSBuffer());return new f.$9w(i(V,F,M))}static serializeReplyErr(L,M){const z=M?v(T.$6(M),null):void 0;if(typeof z!="string")return this.h(L);const V=h.$Se.fromString(z);let F=0;F+=S.sizeLongString(V);const j=S.alloc(w.ReplyErrError,L,F);return j.writeLongString(V),j.buffer}static deserializeReplyErrError(L){const M=L.readLongString();return JSON.parse(M)}static h(L){return S.alloc(w.ReplyErrEmpty,L,0).buffer}}var w;(function(N){N[N.RequestJSONArgs=1]="RequestJSONArgs",N[N.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",N[N.RequestMixedArgs=3]="RequestMixedArgs",N[N.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",N[N.Acknowledged=5]="Acknowledged",N[N.Cancel=6]="Cancel",N[N.ReplyOKEmpty=7]="ReplyOKEmpty",N[N.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",N[N.ReplyOKJSON=9]="ReplyOKJSON",N[N.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",N[N.ReplyErrError=11]="ReplyErrError",N[N.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var b;(function(N){N[N.String=1]="String",N[N.VSBuffer=2]="VSBuffer",N[N.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",N[N.Undefined=4]="Undefined"})(b||(b={}))}),define(Re[291],Ce([1,0,21,28,14,89,5]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$QL=void 0,e.$RL=I,e.$SL=E,e.$TL=f,e.$UL=P,e.$QL=(0,T.$Ki)("notebookDocumentService");const A=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${A.join("")}]+`),c=7;function I(o){if(o.scheme!==D.Schemas.vscodeNotebookCell)return;const m=o.fragment.indexOf("s");if(m<0)return;const $=parseInt(o.fragment.substring(0,m).replace(p,""),c),d=(0,s.$_e)(o.fragment.substring(m+1)).toString();if(!isNaN($))return{handle:$,notebook:o.with({scheme:d,fragment:null})}}function E(o,m){const $=m.toString(c),i=`${$.length<A.length?A[$.length-1]:"z"}${$}s${(0,s.$af)(s.$Se.fromString(o.scheme),!0,!0)}`;return o.with({scheme:D.Schemas.vscodeNotebookCell,fragment:i})}function f(o){if(o.scheme!==D.Schemas.vscodeNotebookMetadata)return;const m=(0,s.$_e)(o.fragment).toString();return o.with({scheme:m,fragment:null})}function P(o){const m=`${(0,s.$af)(s.$Se.fromString(o.scheme),!0,!0)}`;return o.with({scheme:D.Schemas.vscodeNotebookMetadata,fragment:m})}class v{constructor(){this.a=new h.$Fc}getNotebook(m){if(m.scheme===D.Schemas.vscodeNotebookCell){const $=I(m);if($){const d=this.a.get($.notebook);if(d)return d}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$VL=v,(0,O.$2s)(e.$QL,v,O.InstantiationType.Delayed)}),define(Re[127],Ce([1,0,21,39,40,107,14,16,10,36,291]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$bM=e.CellStatusbarAlignment=e.$aM=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$0L=e.$9L=e.$7L=e.CellUri=e.NotebookUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$6L=e.$5L=e.$4L=e.$3L=e.CellKind=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=void 0,e.$8L=u,e.$$L=y,e.$_L=k,e.$cM=C,e.$dM=b,h=Ue(h),e.$WL="workbench.editor.notebook",e.$XL="workbench.editor.notebookTextDiffEditor",e.$YL="workbench.editor.notebookMultiTextDiffEditor",e.$ZL="workbench.editor.interactive",e.$1L="workbench.editor.repl",e.$2L="replNotebook.input.execute";var E;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(E||(e.CellKind=E={})),e.$3L=["application/json","application/javascript","text/html","image/svg+xml",O.$it.latex,O.$it.markdown,"image/png","image/jpeg",O.$it.text],e.$4L=[O.$it.latex,O.$it.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$it.text],e.$5L=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$6L="_notAvailable";var f;(function(J){J[J.Running=1]="Running",J[J.Idle=2]="Idle"})(f||(e.NotebookRunState=f={}));var P;(function(J){J[J.Unconfirmed=1]="Unconfirmed",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var v;(function(J){J[J.Unconfirmed=1]="Unconfirmed",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var o;(function(J){J[J.WithHardKernelDependency=0]="WithHardKernelDependency",J[J.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",J[J.Pure=2]="Pure",J[J.Never=3]="Never"})(o||(e.NotebookRendererMatch=o={}));var m;(function(J){J.Always="always",J.Never="never",J.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var $;(function(J){J[J.ModelChange=1]="ModelChange",J[J.Move=2]="Move",J[J.ChangeCellLanguage=5]="ChangeCellLanguage",J[J.Initialize=6]="Initialize",J[J.ChangeCellMetadata=7]="ChangeCellMetadata",J[J.Output=8]="Output",J[J.OutputItem=9]="OutputItem",J[J.ChangeCellContent=10]="ChangeCellContent",J[J.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",J[J.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",J[J.ChangeCellMime=13]="ChangeCellMime",J[J.Unknown=100]="Unknown"})($||(e.NotebookCellsChangeType=$={}));var d;(function(J){J[J.Handle=0]="Handle",J[J.Index=1]="Index"})(d||(e.SelectionStateType=d={}));var i;(function(J){J[J.Replace=1]="Replace",J[J.Output=2]="Output",J[J.Metadata=3]="Metadata",J[J.CellLanguage=4]="CellLanguage",J[J.DocumentMetadata=5]="DocumentMetadata",J[J.Move=6]="Move",J[J.OutputItems=7]="OutputItems",J[J.PartialMetadata=8]="PartialMetadata",J[J.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var a;(function(J){J.scheme=T.Schemas.vscodeNotebookMetadata;function B(_){return(0,I.$UL)(_)}J.generate=B;function U(_){return(0,I.$TL)(_)}J.parse=U})(a||(e.NotebookUri=a={}));var t;(function(J){J.scheme=T.Schemas.vscodeNotebookCell;function B(me,ce){return(0,I.$SL)(me,ce)}J.generate=B;function U(me){return(0,I.$RL)(me)}J.parse=U;function _(me,ce){return me.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${ce??""},${me.scheme!==T.Schemas.file?me.scheme:""}`})}J.generateCellOutputUri=_;function x(me){if(me.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(me.fragment);if(!ce)return;const Y=ce[1]&&ce[1]!==""?ce[1]:void 0,q=ce[2];return{outputId:Y,notebook:me.with({scheme:q||T.Schemas.file,fragment:null})}}J.parseCellOutputUri=x;function oe(me,ce,Y){return J.generate(me,ce).with({scheme:Y})}J.generateCellPropertyUri=oe;function te(me,ce){if(me.scheme===ce)return J.parse(me.with({scheme:J.scheme}))}J.parseCellPropertyUri=te})(t||(e.CellUri=t={}));const r=J=>p.$l?J.replace(/\//g,"\\"):J;class n{constructor(B=[],U=e.$3L){this.e=U,this.d=[...new Set(B)].map(_=>({pattern:_,matches:h.$Fk(r(_))}))}sort(B){const U=new Map(D.Iterable.map(B,x=>[x,r(x)]));let _=[];for(const{matches:x}of this.d)for(const[oe,te]of U)if(x(te)){_.push(oe),U.delete(oe);break}return U.size&&(_=_.concat([...U.keys()].sort((x,oe)=>this.e.indexOf(x)-this.e.indexOf(oe)))),_}prioritize(B,U){const _=this.f(B);if(_===-1){this.d.unshift({pattern:B,matches:h.$Fk(r(B))});return}const x=new Set(U.map(te=>this.f(te,_)));x.delete(-1);const oe=Array.from(x).sort();this.d.splice(_+1,0,...oe.map(te=>this.d[te]));for(let te=oe.length-1;te>=0;te--)this.d.splice(oe[te],1)}toArray(){return this.d.map(B=>B.pattern)}f(B,U=this.d.length){const _=r(B);for(let x=0;x<U;x++)if(this.d[x].matches(_))return x;return-1}}e.$7L=n;function u(J,B,U,_=(x,oe)=>x===oe){const x=[];function oe(ce,Y,q){if(Y===0&&q.length===0)return;const se=x[x.length-1];se&&se.start+se.deleteCount===ce?(se.deleteCount+=Y,se.toInsert.push(...q)):x.push({start:ce,deleteCount:Y,toInsert:q})}let te=0,me=0;for(;;){if(te===J.length){oe(te,0,B.slice(me));break}if(me===B.length){oe(te,J.length-te,[]);break}const ce=J[te],Y=B[me];if(_(ce,Y)){te+=1,me+=1;continue}U(Y)?(oe(te,1,[]),te+=1):(oe(te,0,[Y]),me+=1)}return x}e.$9L=new c.$2j("notebookEditorCursorAtBoundary","none"),e.$0L=new c.$2j("notebookEditorCursorAtLineBoundary","none");var l;(function(J){J.default="default",J.option="option"})(l||(e.NotebookEditorPriority=l={}));var g;(function(J){J.Cells="cells",J.Text="text",J.None="none"})(g||(e.NotebookFindScopeType=g={}));function y(J){const B=J;return!!((typeof B.include=="string"||h.$Gk(B.include))&&(typeof B.exclude=="string"||h.$Gk(B.exclude)))}function k(J,B,U){if(Array.isArray(J.viewType)&&J.viewType.indexOf(B)>=0||J.viewType===B)return!0;if(J.filenamePattern){const _=y(J.filenamePattern)?J.filenamePattern.include:J.filenamePattern,x=y(J.filenamePattern)?J.filenamePattern.exclude:void 0;if(h.$Ek(_,(0,A.$sc)(U.fsPath).toLowerCase()))return!(x&&h.$Ek(x,(0,A.$sc)(U.fsPath).toLowerCase()))}return!1}e.$aM={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var S;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(S||(e.CellStatusbarAlignment=S={}));class R{static{this.d="notebook/"}static create(B){return`${R.d}${B}`}static parse(B){if(B.startsWith(R.d))return B.substring(R.d.length)}}e.$bM=R;function C(J){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(J)}const w=new TextDecoder;function b(J){const B=[];let U=!1;for(const te of J)(B.length===0||U)&&(B.push(te),U=!0);let _=M(B);const x=s.$Se.concat(B.map(te=>s.$Se.wrap(te))),oe=W(x);return _=_||oe.byteLength!==x.byteLength,{data:oe,didCompression:_}}e.$eM="\x1B[A";const N=e.$eM.split("").map(J=>J.charCodeAt(0)),L=10;function M(J){let B=!1;return J.forEach((U,_)=>{if(_===0||U.length<e.$eM.length)return;const x=J[_-1],oe=U.subarray(0,e.$eM.length);if(oe[0]===N[0]&&oe[1]===N[1]&&oe[2]===N[2]){const te=x.lastIndexOf(L);if(te===-1)return;B=!0,J[_-1]=x.subarray(0,te),J[_]=U.subarray(e.$eM.length)}}),B}function z(J){let B=J;do J=B,B=J.replace(/[^\n]\x08/gm,"");while(B.length<J.length);return J}function V(J){for(J=J.replace(/\r+\n/gm,`
`);J.search(/\r[^$]/g)>-1;){const B=J.match(/^(.*)\r+/m)[1];let U=J.match(/\r+(.*)$/m)[1];U=U+B.slice(U.length,B.length),J=J.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,U)}return J}const F=8,j=13;function W(J){return!J.buffer.includes(F)&&!J.buffer.includes(j)?J:s.$Se.fromString(V(z(w.decode(J.buffer))))}}),define(Re[9],Ce([1,0,18,12,86,28,107,13,17,2,31,23,27,73,127]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v){"use strict";var o,m,$,d,i,a,t,r,n,u,l,g,y,k,S,R,C;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$DQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$CQ=e.$BQ=e.$AQ=e.$zQ=e.$yQ=e.$xQ=e.$wQ=e.$vQ=e.LanguageModelChatMessageRole=e.$uQ=e.$tQ=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$sQ=e.$rQ=e.$qQ=e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=e.$iQ=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.$dQ=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$cQ=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.$3P=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$2P=e.$1P=e.$ZP=e.$YP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.TestRunProfileKind=e.TestResultState=e.$RP=e.$QP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$PP=e.NotebookVariablesRequestKind=e.$OP=e.$NP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$MP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.ColorThemeKind=e.$GP=e.$FP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$EP=e.QuickInputButtonLocation=e.$DP=e.DebugConsoleMode=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$xP=e.$wP=e.FileChangeType=e.$vP=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$uP=e.$tP=e.$sP=e.$rP=e.InlineCompletionTriggerKind=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.$eP=e.ConfigurationTarget=e.$dP=e.$cP=e.$bP=e.$aP=e.DocumentPasteTriggerKind=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$7O=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$6O=e.ViewBadge=e.ProgressLocation=e.$5O=e.$4O=e.TaskScope=e.ShellQuoting=e.$3O=e.$2O=e.$1O=e.TaskPanelKind=e.TaskRevealKind=e.$ZO=e.TerminalLocation=e.$YO=e.$XO=e.$WO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$VO=e.$UO=e.$TO=e.$SO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$QO=e.$PO=e.$OO=e.$NO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$MO=e.$LO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.LanguageStatusSeverity=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.CodeActionTriggerKind=e.$zO=e.$yO=e.SymbolTag=e.SymbolKind=e.$xO=e.$wO=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.DiagnosticSeverity=e.DiagnosticTag=e.$qO=e.$pO=e.FileEditType=e.$oO=e.$nO=e.$mO=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$lO=e.$kO=e.$jO=e.$gO=e.$fO=e.$eO=e.$dO=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$hO=F,e.$iO=j,e.$RO=dt,e.$fP=Ui,e.$XP=Rn;function w(Q){return Object.assign(Q,{apply:function(...fe){if(fe.length===0)return Reflect.construct(Q,[]);{const Te=fe.length===1?[]:fe[1];return Reflect.construct(Q,Te,fe[0].constructor)}},call:function(...fe){if(fe.length===0)return Reflect.construct(Q,[]);{const[Te,..._e]=fe;return Reflect.construct(Q,_e,Te.constructor)}}})}var b;(function(Q){Q[Q.Top=0]="Top",Q[Q.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var N;(function(Q){Q[Q.TerminalCommand=0]="TerminalCommand",Q[Q.Opener=1]="Opener",Q[Q.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let L=o=class{static from(...K){let fe=K;return new o(function(){if(fe){for(const Te of fe)Te&&typeof Te.dispose=="function"&&Te.dispose();fe=void 0}})}#e;constructor(K){this.#e=K}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$dO=L,e.$dO=L=o=Ye([w],L);let M=m=class{static Min(...K){if(K.length===0)throw new TypeError;let fe=K[0];for(let Te=1;Te<K.length;Te++){const _e=K[Te];_e.isBefore(fe)&&(fe=_e)}return fe}static Max(...K){if(K.length===0)throw new TypeError;let fe=K[0];for(let Te=1;Te<K.length;Te++){const _e=K[Te];_e.isAfter(fe)&&(fe=_e)}return fe}static isPosition(K){if(!K)return!1;if(K instanceof m)return!0;const{line:fe,character:Te}=K;return typeof fe=="number"&&typeof Te=="number"}static of(K){if(K instanceof m)return K;if(this.isPosition(K))return new m(K.line,K.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(K,fe){if(K<0)throw(0,h.$$)("line must be non-negative");if(fe<0)throw(0,h.$$)("character must be non-negative");this.c=K,this.e=fe}isBefore(K){return this.c<K.c?!0:K.c<this.c?!1:this.e<K.e}isBeforeOrEqual(K){return this.c<K.c?!0:K.c<this.c?!1:this.e<=K.e}isAfter(K){return!this.isBeforeOrEqual(K)}isAfterOrEqual(K){return!this.isBefore(K)}isEqual(K){return this.c===K.c&&this.e===K.e}compareTo(K){return this.c<K.c?-1:this.c>K.line?1:this.e<K.e?-1:this.e>K.e?1:0}translate(K,fe=0){if(K===null||fe===null)throw(0,h.$$)();let Te;return typeof K>"u"?Te=0:typeof K=="number"?Te=K:(Te=typeof K.lineDelta=="number"?K.lineDelta:0,fe=typeof K.characterDelta=="number"?K.characterDelta:0),Te===0&&fe===0?this:new m(this.line+Te,this.character+fe)}with(K,fe=this.character){if(K===null||fe===null)throw(0,h.$$)();let Te;return typeof K>"u"?Te=this.line:typeof K=="number"?Te=K:(Te=typeof K.line=="number"?K.line:this.line,fe=typeof K.character=="number"?K.character:this.character),Te===this.line&&fe===this.character?this:new m(Te,fe)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$eO=M,e.$eO=M=m=Ye([w],M);let z=$=class{static isRange(K){return K instanceof $?!0:K?M.isPosition(K.start)&&M.isPosition(K.end):!1}static of(K){if(K instanceof $)return K;if(this.isRange(K))return new $(K.start,K.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(K,fe,Te,_e){let ct,bt;if(typeof K=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof _e=="number"?(ct=new M(K,fe),bt=new M(Te,_e)):M.isPosition(K)&&M.isPosition(fe)&&(ct=M.of(K),bt=M.of(fe)),!ct||!bt)throw new Error("Invalid arguments");ct.isBefore(bt)?(this.c=ct,this.e=bt):(this.c=bt,this.e=ct)}contains(K){return $.isRange(K)?this.contains(K.start)&&this.contains(K.end):M.isPosition(K)?!(M.of(K).isBefore(this.c)||this.e.isBefore(K)):!1}isEqual(K){return this.c.isEqual(K.c)&&this.e.isEqual(K.e)}intersection(K){const fe=M.Max(K.start,this.c),Te=M.Min(K.end,this.e);if(!fe.isAfter(Te))return new $(fe,Te)}union(K){if(this.contains(K))return this;if(K.contains(this))return K;const fe=M.Min(K.start,this.c),Te=M.Max(K.end,this.end);return new $(fe,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(K,fe=this.end){if(K===null||fe===null)throw(0,h.$$)();let Te;return K?M.isPosition(K)?Te=K:(Te=K.start||this.start,fe=K.end||this.end):Te=this.start,Te.isEqual(this.c)&&fe.isEqual(this.end)?this:new $(Te,fe)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return F(this)}};e.$fO=z,e.$fO=z=$=Ye([w],z);let V=d=class extends z{static isSelection(K){return K instanceof d?!0:K?z.isRange(K)&&M.isPosition(K.anchor)&&M.isPosition(K.active)&&typeof K.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(K,fe,Te,_e){let ct,bt;if(typeof K=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof _e=="number"?(ct=new M(K,fe),bt=new M(Te,_e)):M.isPosition(K)&&M.isPosition(fe)&&(ct=M.of(K),bt=M.of(fe)),!ct||!bt)throw new Error("Invalid arguments");super(ct,bt),this.f=ct,this.g=bt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return j(this)}};e.$gO=V,e.$gO=V=d=Ye([w],V);function F(Q){return Q.isEmpty?`[${Q.start.line}:${Q.start.character})`:`[${Q.start.line}:${Q.start.character} -> ${Q.end.line}:${Q.end.character})`}function j(Q){let K=F(Q);return Q.isEmpty||(Q.active.isEqual(Q.start)?K=`|${K}`:K=`${K}|`),K}const W=Q=>{if(typeof Q!="string"||Q.length===0||!/^[0-9A-Za-z_\-]+$/.test(Q))throw(0,h.$$)("connectionToken")};class J{static isResolvedAuthority(K){return K&&typeof K=="object"&&typeof K.host=="string"&&typeof K.port=="number"&&(K.connectionToken===void 0||typeof K.connectionToken=="string")}constructor(K,fe,Te){if(typeof K!="string"||K.length===0)throw(0,h.$$)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,h.$$)("port");typeof Te<"u"&&W(Te),this.host=K,this.port=Math.round(fe),this.connectionToken=Te}}e.$jO=J;class B{static isManagedResolvedAuthority(K){return K&&typeof K=="object"&&typeof K.makeConnection=="function"&&(K.connectionToken===void 0||typeof K.connectionToken=="string")}constructor(K,fe){this.makeConnection=K,this.connectionToken=fe,typeof fe<"u"&&W(fe)}}e.$kO=B;class U extends Error{static NotAvailable(K,fe){return new U(K,P.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable(K){return new U(K,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(K,fe=P.RemoteAuthorityResolverErrorCode.Unknown,Te){super(K),this._message=K,this._code=fe,this._detail=Te,Object.setPrototypeOf(this,U.prototype)}}e.$lO=U;var _;(function(Q){Q[Q.LF=1]="LF",Q[Q.CRLF=2]="CRLF"})(_||(e.EndOfLine=_={}));var x;(function(Q){Q[Q.Replace=1]="Replace",Q[Q.Append=2]="Append",Q[Q.Prepend=3]="Prepend"})(x||(e.EnvironmentVariableMutatorType=x={}));let oe=i=class{static isTextEdit(K){return K instanceof i?!0:K?z.isRange(K)&&typeof K.newText=="string":!1}static replace(K,fe){return new i(K,fe)}static insert(K,fe){return i.replace(new z(K,K),fe)}static delete(K){return i.replace(K,"")}static setEndOfLine(K){const fe=new i(new z(new M(0,0),new M(0,0)),"");return fe.newEol=K,fe}get range(){return this.c}set range(K){if(K&&!z.isRange(K))throw(0,h.$$)("range");this.c=K}get newText(){return this.e||""}set newText(K){if(K&&typeof K!="string")throw(0,h.$$)("newText");this.e=K}get newEol(){return this.f}set newEol(K){if(K&&typeof K!="number")throw(0,h.$$)("newEol");this.f=K}constructor(K,fe){this.c=K,this.e=fe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$mO=oe,e.$mO=oe=i=Ye([w],oe);let te=a=class{static isNotebookCellEdit(K){return K instanceof a?!0:K?ki.isNotebookRange(K)&&Array.isArray(K.newCells):!1}static replaceCells(K,fe){return new a(K,fe)}static insertCells(K,fe){return new a(new ki(K,K),fe)}static deleteCells(K){return new a(K,[])}static updateCellMetadata(K,fe){const Te=new a(new ki(K,K),[]);return Te.newCellMetadata=fe,Te}static updateNotebookMetadata(K){const fe=new a(new ki(0,0),[]);return fe.newNotebookMetadata=K,fe}constructor(K,fe){this.range=K,this.newCells=fe}};e.$nO=te,e.$nO=te=a=Ye([w],te);class me{static isSnippetTextEdit(K){return K instanceof me?!0:K?z.isRange(K.range)&&q.isSnippetString(K.snippet):!1}static replace(K,fe){return new me(K,fe)}static insert(K,fe){return me.replace(new z(K,K),fe)}constructor(K,fe){this.range=K,this.snippet=fe}}e.$oO=me;var ce;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.Cell=3]="Cell",Q[Q.CellReplace=5]="CellReplace",Q[Q.Snippet=6]="Snippet"})(ce||(e.FileEditType=ce={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(K,fe,Te,_e){this.c.push({_type:ce.File,from:K,to:fe,options:Te,metadata:_e})}createFile(K,fe,Te){this.c.push({_type:ce.File,from:void 0,to:K,options:fe,metadata:Te})}deleteFile(K,fe,Te){this.c.push({_type:ce.File,from:K,to:void 0,options:fe,metadata:Te})}e(K,fe,Te){this.c.push({_type:ce.Cell,metadata:Te,uri:K,edit:{editType:v.CellEditType.DocumentMetadata,metadata:fe},notebookMetadata:fe})}f(K,fe,Te,_e){const ct=fe.start,bt=fe.end;(ct!==bt||Te.length>0)&&this.c.push({_type:ce.CellReplace,uri:K,index:ct,count:bt-ct,cells:Te,metadata:_e})}g(K,fe,Te,_e){this.c.push({_type:ce.Cell,metadata:_e,uri:K,edit:{editType:v.CellEditType.Metadata,index:fe,metadata:Te}})}replace(K,fe,Te,_e){this.c.push({_type:ce.Text,uri:K,edit:new oe(fe,Te),metadata:_e})}insert(K,fe,Te,_e){this.replace(K,new z(fe,fe),Te,_e)}delete(K,fe,Te){this.replace(K,fe,"",Te)}has(K){return this.c.some(fe=>fe._type===ce.Text&&fe.uri.toString()===K.toString())}set(K,fe){if(fe)for(const Te of fe){if(!Te)continue;let _e,ct;Array.isArray(Te)?(_e=Te[0],ct=Te[1]):_e=Te,te.isNotebookCellEdit(_e)?_e.newCellMetadata?this.g(K,_e.range.start,_e.newCellMetadata,ct):_e.newNotebookMetadata?this.e(K,_e.newNotebookMetadata,ct):this.f(K,_e.range,_e.newCells,ct):me.isSnippetTextEdit(_e)?this.c.push({_type:ce.Snippet,uri:K,range:_e.range,edit:_e.snippet,metadata:ct}):this.c.push({_type:ce.Text,uri:K,edit:_e,metadata:ct})}else{for(let Te=0;Te<this.c.length;Te++){const _e=this.c[Te];switch(_e._type){case ce.Text:case ce.Snippet:case ce.Cell:case ce.CellReplace:_e.uri.toString()===K.toString()&&(this.c[Te]=void 0);break}}(0,s.$Mb)(this.c)}}get(K){const fe=[];for(const Te of this.c)Te._type===ce.Text&&Te.uri.toString()===K.toString()&&fe.push(Te.edit);return fe}entries(){const K=new O.$Fc;for(const fe of this.c)if(fe._type===ce.Text){let Te=K.get(fe.uri);Te||(Te=[fe.uri,[]],K.set(fe.uri,Te)),Te[1].push(fe.edit)}return[...K.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$pO=Y,e.$pO=Y=Ye([w],Y);let q=t=class{static isSnippetString(K){return K instanceof t?!0:K?typeof K.value=="string":!1}static c(K){return K.replace(/\$|}|\\/g,"\\$&")}constructor(K){this.e=1,this.value=K||""}appendText(K){return this.value+=t.c(K),this}appendTabstop(K=this.e++){return this.value+="$",this.value+=K,this}appendPlaceholder(K,fe=this.e++){if(typeof K=="function"){const Te=new t;Te.e=this.e,K(Te),this.e=Te.e,K=Te.value}else K=t.c(K);return this.value+="${",this.value+=fe,this.value+=":",this.value+=K,this.value+="}",this}appendChoice(K,fe=this.e++){const Te=K.map(_e=>_e.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(K,fe){if(typeof fe=="function"){const Te=new t;Te.e=this.e,fe(Te),this.e=Te.e,fe=Te.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=K,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};e.$qO=q,e.$qO=q=t=Ye([w],q);var se;(function(Q){Q[Q.Unnecessary=1]="Unnecessary",Q[Q.Deprecated=2]="Deprecated"})(se||(e.DiagnosticTag=se={}));var be;(function(Q){Q[Q.Hint=3]="Hint",Q[Q.Information=2]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let ae=r=class{static isLocation(K){return K instanceof r?!0:K?z.isRange(K.range)&&c.URI.isUri(K.uri):!1}constructor(K,fe){if(this.uri=K,fe)if(z.isRange(fe))this.range=z.of(fe);else if(M.isPosition(fe))this.range=new z(fe,fe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$rO=ae,e.$rO=ae=r=Ye([w],ae);let we=class{static is(K){return K?typeof K.message=="string"&&K.location&&z.isRange(K.location.range)&&c.URI.isUri(K.location.uri):!1}constructor(K,fe){this.location=K,this.message=fe}static isEqual(K,fe){return K===fe?!0:!K||!fe?!1:K.message===fe.message&&K.location.range.isEqual(fe.location.range)&&K.location.uri.toString()===fe.location.uri.toString()}};e.$sO=we,e.$sO=we=Ye([w],we);let $e=class{constructor(K,fe,Te=be.Error){if(!z.isRange(K))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=K,this.message=fe,this.severity=Te}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(K,fe){return K===fe?!0:!K||!fe?!1:K.message===fe.message&&K.severity===fe.severity&&K.code===fe.code&&K.severity===fe.severity&&K.source===fe.source&&K.range.isEqual(fe.range)&&(0,s.$yb)(K.tags,fe.tags)&&(0,s.$yb)(K.relatedInformation,fe.relatedInformation,we.isEqual)}};e.$tO=$e,e.$tO=$e=Ye([w],$e);let pe=class{constructor(K,fe){if(!K)throw new Error("Illegal argument, contents must be defined");Array.isArray(K)?this.contents=K:this.contents=[K],this.range=fe}};e.$uO=pe,e.$uO=pe=Ye([w],pe);let Oe=class extends pe{constructor(K,fe,Te,_e){super(K,fe),this.canIncreaseVerbosity=Te,this.canDecreaseVerbosity=_e}};e.$vO=Oe,e.$vO=Oe=Ye([w],Oe);var Fe;(function(Q){Q[Q.Increase=0]="Increase",Q[Q.Decrease=1]="Decrease"})(Fe||(e.HoverVerbosityAction=Fe={}));var He;(function(Q){Q[Q.Text=0]="Text",Q[Q.Read=1]="Read",Q[Q.Write=2]="Write"})(He||(e.DocumentHighlightKind=He={}));let Ze=class{constructor(K,fe=He.Text){this.range=K,this.kind=fe}toJSON(){return{range:this.range,kind:He[this.kind]}}};e.$wO=Ze,e.$wO=Ze=Ye([w],Ze);let xe=class{constructor(K,fe){this.uri=K,this.highlights=fe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(K=>K.toJSON())}}};e.$xO=xe,e.$xO=xe=Ye([w],xe);var je;(function(Q){Q[Q.File=0]="File",Q[Q.Module=1]="Module",Q[Q.Namespace=2]="Namespace",Q[Q.Package=3]="Package",Q[Q.Class=4]="Class",Q[Q.Method=5]="Method",Q[Q.Property=6]="Property",Q[Q.Field=7]="Field",Q[Q.Constructor=8]="Constructor",Q[Q.Enum=9]="Enum",Q[Q.Interface=10]="Interface",Q[Q.Function=11]="Function",Q[Q.Variable=12]="Variable",Q[Q.Constant=13]="Constant",Q[Q.String=14]="String",Q[Q.Number=15]="Number",Q[Q.Boolean=16]="Boolean",Q[Q.Array=17]="Array",Q[Q.Object=18]="Object",Q[Q.Key=19]="Key",Q[Q.Null=20]="Null",Q[Q.EnumMember=21]="EnumMember",Q[Q.Struct=22]="Struct",Q[Q.Event=23]="Event",Q[Q.Operator=24]="Operator",Q[Q.TypeParameter=25]="TypeParameter"})(je||(e.SymbolKind=je={}));var qe;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(qe||(e.SymbolTag=qe={}));let Ne=n=class{static validate(K){if(!K.name)throw new Error("name must not be falsy")}constructor(K,fe,Te,_e,ct){this.name=K,this.kind=fe,this.containerName=ct,typeof Te=="string"&&(this.containerName=Te),_e instanceof ae?this.location=_e:Te instanceof z&&(this.location=new ae(_e,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};e.$yO=Ne,e.$yO=Ne=n=Ye([w],Ne);let H=u=class{static validate(K){if(!K.name)throw new Error("name must not be falsy");if(!K.range.contains(K.selectionRange))throw new Error("selectionRange must be contained in fullRange");K.children?.forEach(u.validate)}constructor(K,fe,Te,_e,ct){this.name=K,this.detail=fe,this.kind=Te,this.range=_e,this.selectionRange=ct,this.children=[],u.validate(this)}};e.$zO=H,e.$zO=H=u=Ye([w],H);var G;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.Automatic=2]="Automatic"})(G||(e.CodeActionTriggerKind=G={}));let Z=class{constructor(K,fe){this.title=K,this.kind=fe}};e.$AO=Z,e.$AO=Z=Ye([w],Z);let ee=class{static{l=this}static{this.c="."}constructor(K){this.value=K}append(K){return new l(this.value?this.value+l.c+K:K)}intersects(K){return this.contains(K)||K.contains(this)}contains(K){return this.value===K.value||K.value.startsWith(this.value+l.c)}};e.$BO=ee,e.$BO=ee=l=Ye([w],ee),ee.Empty=new ee(""),ee.QuickFix=ee.Empty.append("quickfix"),ee.Refactor=ee.Empty.append("refactor"),ee.RefactorExtract=ee.Refactor.append("extract"),ee.RefactorInline=ee.Refactor.append("inline"),ee.RefactorMove=ee.Refactor.append("move"),ee.RefactorRewrite=ee.Refactor.append("rewrite"),ee.Source=ee.Empty.append("source"),ee.SourceOrganizeImports=ee.Source.append("organizeImports"),ee.SourceFixAll=ee.Source.append("fixAll"),ee.Notebook=ee.Empty.append("notebook");let ue=class{constructor(K,fe){if(this.range=K,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$CO=ue,e.$CO=ue=Ye([w],ue);class ye{constructor(K,fe,Te,_e,ct,bt){this.kind=K,this.name=fe,this.detail=Te,this.uri=_e,this.range=ct,this.selectionRange=bt}}e.$DO=ye;class Ae{constructor(K,fe){this.fromRanges=fe,this.from=K}}e.$EO=Ae;class Ve{constructor(K,fe){this.fromRanges=fe,this.to=K}}e.$FO=Ve;var Je;(function(Q){Q[Q.Information=0]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=2]="Error"})(Je||(e.LanguageStatusSeverity=Je={}));let nt=class{constructor(K,fe){this.range=K,this.command=fe}get isResolved(){return!!this.command}};e.$GO=nt,e.$GO=nt=Ye([w],nt);let ot=g=class{#e;static isMarkdownString(K){return K instanceof g?!0:K&&K.appendCodeblock&&K.appendMarkdown&&K.appendText&&K.value!==void 0}constructor(K,fe=!1){this.#e=new D.$9k(K,{supportThemeIcons:fe})}get value(){return this.#e.value}set value(K){this.#e.value=K}get isTrusted(){return this.#e.isTrusted}set isTrusted(K){this.#e.isTrusted=K}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(K){this.#e.supportThemeIcons=K}get supportHtml(){return this.#e.supportHtml}set supportHtml(K){this.#e.supportHtml=K}get baseUri(){return this.#e.baseUri}set baseUri(K){this.#e.baseUri=K}appendText(K){return this.#e.appendText(K),this}appendMarkdown(K){return this.#e.appendMarkdown(K),this}appendCodeblock(K,fe){return this.#e.appendCodeblock(fe??"",K),this}};e.$HO=ot,e.$HO=ot=g=Ye([w],ot);let ht=class{constructor(K,fe){this.label=K,this.documentation=fe}};e.$IO=ht,e.$IO=ht=Ye([w],ht);let at=class{constructor(K,fe){this.label=K,this.documentation=fe,this.parameters=[]}};e.$JO=at,e.$JO=at=Ye([w],at);let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$KO=lt,e.$KO=lt=Ye([w],lt);var pt;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.TriggerCharacter=2]="TriggerCharacter",Q[Q.ContentChange=3]="ContentChange"})(pt||(e.SignatureHelpTriggerKind=pt={}));var it;(function(Q){Q[Q.Type=1]="Type",Q[Q.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let Ie=class{constructor(K){this.value=K}};e.$LO=Ie,e.$LO=Ie=Ye([w],Ie);let re=class{constructor(K,fe,Te){this.position=K,this.label=fe,this.kind=Te}};e.$MO=re,e.$MO=re=Ye([w],re);var le;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.TriggerCharacter=1]="TriggerCharacter",Q[Q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(le||(e.CompletionTriggerKind=le={}));var Se;(function(Q){Q[Q.Text=0]="Text",Q[Q.Method=1]="Method",Q[Q.Function=2]="Function",Q[Q.Constructor=3]="Constructor",Q[Q.Field=4]="Field",Q[Q.Variable=5]="Variable",Q[Q.Class=6]="Class",Q[Q.Interface=7]="Interface",Q[Q.Module=8]="Module",Q[Q.Property=9]="Property",Q[Q.Unit=10]="Unit",Q[Q.Value=11]="Value",Q[Q.Enum=12]="Enum",Q[Q.Keyword=13]="Keyword",Q[Q.Snippet=14]="Snippet",Q[Q.Color=15]="Color",Q[Q.File=16]="File",Q[Q.Reference=17]="Reference",Q[Q.Folder=18]="Folder",Q[Q.EnumMember=19]="EnumMember",Q[Q.Constant=20]="Constant",Q[Q.Struct=21]="Struct",Q[Q.Event=22]="Event",Q[Q.Operator=23]="Operator",Q[Q.TypeParameter=24]="TypeParameter",Q[Q.User=25]="User",Q[Q.Issue=26]="Issue"})(Se||(e.CompletionItemKind=Se={}));var de;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(de||(e.CompletionItemTag=de={}));let ke=class{constructor(K,fe){this.label=K,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$NO=ke,e.$NO=ke=Ye([w],ke);let ne=class{constructor(K=[],fe=!1){this.items=K,this.isIncomplete=fe}};e.$OO=ne,e.$OO=ne=Ye([w],ne);let X=class{constructor(K,fe,Te){this.insertText=K,this.range=fe,this.command=Te}};e.$PO=X,e.$PO=X=Ye([w],X);let Pe=class{constructor(K){this.commands=void 0,this.suppressSuggestions=void 0,this.items=K}};e.$QO=Pe,e.$QO=Pe=Ye([w],Pe);var Ke;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.Word=1]="Word",Q[Q.Line=2]="Line",Q[Q.Suggest=3]="Suggest"})(Ke||(e.PartialAcceptTriggerKind=Ke={}));var Xe;(function(Q){Q[Q.Active=-1]="Active",Q[Q.Beside=-2]="Beside",Q[Q.One=1]="One",Q[Q.Two=2]="Two",Q[Q.Three=3]="Three",Q[Q.Four=4]="Four",Q[Q.Five=5]="Five",Q[Q.Six=6]="Six",Q[Q.Seven=7]="Seven",Q[Q.Eight=8]="Eight",Q[Q.Nine=9]="Nine"})(Xe||(e.ViewColumn=Xe={}));var st;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function dt(Q,K){return`${E.$zn.toKey(Q)}.${K}`}var gt;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval"})(gt||(e.TextEditorLineNumbersStyle=gt={}));var kt;(function(Q){Q[Q.Manual=1]="Manual",Q[Q.AfterDelay=2]="AfterDelay",Q[Q.FocusOut=3]="FocusOut"})(kt||(e.TextDocumentSaveReason=kt={}));var At;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(At||(e.TextEditorRevealType=At={}));var Kt;(function(Q){Q[Q.Keyboard=1]="Keyboard",Q[Q.Mouse=2]="Mouse",Q[Q.Command=3]="Command"})(Kt||(e.TextEditorSelectionChangeKind=Kt={}));var ei;(function(Q){Q[Q.Undo=1]="Undo",Q[Q.Redo=2]="Redo"})(ei||(e.TextDocumentChangeReason=ei={}));var tt;(function(Q){Q[Q.OpenOpen=0]="OpenOpen",Q[Q.ClosedClosed=1]="ClosedClosed",Q[Q.OpenClosed=2]="OpenClosed",Q[Q.ClosedOpen=3]="ClosedOpen"})(tt||(e.DecorationRangeBehavior=tt={})),function(Q){function K(fe){switch(fe){case"keyboard":return Q.Keyboard;case"mouse":return Q.Mouse;case"api":return Q.Command}}Q.fromValue=K}(Kt||(e.TextEditorSelectionChangeKind=Kt={}));var Tt;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(Tt||(e.SyntaxTokenType=Tt={})),function(Q){function K(fe){switch(fe){case Q.Other:return"other";case Q.Comment:return"comment";case Q.String:return"string";case Q.RegEx:return"regex"}return"other"}Q.toString=K}(Tt||(e.SyntaxTokenType=Tt={}));let zt=class{constructor(K,fe){if(fe&&!c.URI.isUri(fe))throw(0,h.$$)("target");if(!z.isRange(K)||K.isEmpty)throw(0,h.$$)("range");this.range=K,this.target=fe}};e.$SO=zt,e.$SO=zt=Ye([w],zt);let wt=class{constructor(K,fe,Te,_e){this.red=K,this.green=fe,this.blue=Te,this.alpha=_e}};e.$TO=wt,e.$TO=wt=Ye([w],wt);let Rt=class{constructor(K,fe){if(fe&&!(fe instanceof wt))throw(0,h.$$)("color");if(!z.isRange(K)||K.isEmpty)throw(0,h.$$)("range");this.range=K,this.color=fe}};e.$UO=Rt,e.$UO=Rt=Ye([w],Rt);let ti=class{constructor(K){if(!K||typeof K!="string")throw(0,h.$$)("label");this.label=K}};e.$VO=ti,e.$VO=ti=Ye([w],ti);var ii;(function(Q){Q[Q.RGB=0]="RGB",Q[Q.HEX=1]="HEX",Q[Q.HSL=2]="HSL"})(ii||(e.ColorFormat=ii={}));var Qt;(function(Q){Q[Q.Error=0]="Error",Q[Q.Warning=1]="Warning",Q[Q.Information=2]="Information"})(Qt||(e.SourceControlInputBoxValidationType=Qt={}));var vt;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.Shutdown=1]="Shutdown",Q[Q.Process=2]="Process",Q[Q.User=3]="User",Q[Q.Extension=4]="Extension"})(vt||(e.TerminalExitReason=vt={}));var Lt;(function(Q){Q[Q.Low=0]="Low",Q[Q.Medium=1]="Medium",Q[Q.High=2]="High"})(Lt||(e.TerminalShellExecutionCommandLineConfidence=Lt={}));class ci{constructor(K,fe,Te){if(this.startIndex=K,this.length=fe,this.tooltip=Te,typeof K!="number"||K<0)throw(0,h.$$)("startIndex");if(typeof fe!="number"||fe<1)throw(0,h.$$)("length");if(Te!==void 0&&typeof Te!="string")throw(0,h.$$)("tooltip")}}e.$WO=ci;class Zt{constructor(K){this.uri=K}}e.$XO=Zt;class et{constructor(K){this.terminalCommand=K}}e.$YO=et;var ni;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Editor=2]="Editor"})(ni||(e.TerminalLocation=ni={}));class li{constructor(K){if(this.options=K,typeof K!="object")throw(0,h.$$)("options")}}e.$ZO=li;var hi;(function(Q){Q[Q.Always=1]="Always",Q[Q.Silent=2]="Silent",Q[Q.Never=3]="Never"})(hi||(e.TaskRevealKind=hi={}));var It;(function(Q){Q[Q.Shared=1]="Shared",Q[Q.Dedicated=2]="Dedicated",Q[Q.New=3]="New"})(It||(e.TaskPanelKind=It={}));let Ut=class{static{y=this}static{this.Clean=new y("clean","Clean")}static{this.Build=new y("build","Build")}static{this.Rebuild=new y("rebuild","Rebuild")}static{this.Test=new y("test","Test")}static from(K){switch(K){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(K,fe){if(this.label=fe,typeof K!="string"||typeof fe!="string")throw(0,h.$$)("name");this.c=K}get id(){return this.c}};e.$1O=Ut,e.$1O=Ut=y=Ye([w],Ut);function Nt(Q){let K="";for(let fe=0;fe<Q.length;fe++)K+=Q[fe].replace(/,/g,",,")+",";return K}let Bt=class{constructor(K,fe,Te){if(typeof K!="string")throw(0,h.$$)("process");this.e=[],this.c=K,fe!==void 0&&(Array.isArray(fe)?(this.e=fe,this.f=Te):this.f=fe)}get process(){return this.c}set process(K){if(typeof K!="string")throw(0,h.$$)("process");this.c=K}get args(){return this.e}set args(K){Array.isArray(K)||(K=[]),this.e=K}get options(){return this.f}set options(K){this.f=K}computeId(){const K=[];if(K.push("process"),this.c!==void 0&&K.push(this.c),this.e&&this.e.length>0)for(const fe of this.e)K.push(fe);return Nt(K)}};e.$2O=Bt,e.$2O=Bt=Ye([w],Bt);let ai=class{constructor(K,fe,Te){if(this.f=[],Array.isArray(fe)){if(!K)throw(0,h.$$)("command can't be undefined or null");if(typeof K!="string"&&typeof K.value!="string")throw(0,h.$$)("command");this.e=K,this.f=fe,this.g=Te}else{if(typeof K!="string")throw(0,h.$$)("commandLine");this.c=K,this.g=fe}}get commandLine(){return this.c}set commandLine(K){if(typeof K!="string")throw(0,h.$$)("commandLine");this.c=K}get command(){return this.e?this.e:""}set command(K){if(typeof K!="string"&&typeof K.value!="string")throw(0,h.$$)("command");this.e=K}get args(){return this.f}set args(K){this.f=K||[]}get options(){return this.g}set options(K){this.g=K}computeId(){const K=[];if(K.push("shell"),this.c!==void 0&&K.push(this.c),this.e!==void 0&&K.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const fe of this.f)K.push(typeof fe=="string"?fe:fe.value);return Nt(K)}};e.$3O=ai,e.$3O=ai=Ye([w],ai);var ri;(function(Q){Q[Q.Escape=1]="Escape",Q[Q.Strong=2]="Strong",Q[Q.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var si;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace"})(si||(e.TaskScope=si={}));class Jt{constructor(K){this.c=K}computeId(){return"customExecution"+(0,I.$7g)()}set callback(K){this.c=K}get callback(){return this.c}}e.$4O=Jt;let Xt=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(K,fe,Te,_e,ct,bt){this.k=!1,this.l=this.definition=K;let Et;typeof fe=="string"?(this.o=this.name=fe,this.w=this.source=Te,this.execution=_e,Et=ct,this.k=!0):fe===si.Global||fe===si.Workspace?(this.target=fe,this.o=this.name=Te,this.w=this.source=_e,this.execution=ct,Et=bt):(this.target=fe,this.o=this.name=Te,this.w=this.source=_e,this.execution=ct,Et=bt),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(K){this.j=K}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Bt?this.l={type:k.e,id:this.q.computeId()}:this.q instanceof ai?this.l={type:k.f,id:this.q.computeId()}:this.q instanceof Jt?this.l={type:k.c,id:this.q.computeId()}:this.l={type:k.g,id:(0,I.$7g)()}}get definition(){return this.l}set definition(K){if(K==null)throw(0,h.$$)("Kind can't be undefined or null");this.B(),this.l=K}get scope(){return this.m}set target(K){this.B(),this.m=K}get name(){return this.o}set name(K){if(typeof K!="string")throw(0,h.$$)("name");this.B(),this.o=K}get execution(){return this.q}set execution(K){K===null&&(K=void 0),this.B(),this.q=K;const fe=this.l.type;(k.g===fe||k.e===fe||k.f===fe||k.c===fe)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(K){if(Array.isArray(K))this.B(),this.r=K,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(K){K!==!0&&K!==!1&&(K=!1),this.B(),this.u=K}get source(){return this.w}set source(K){if(typeof K!="string"||K.length===0)throw(0,h.$$)("source must be a string of length > 0");this.B(),this.w=K}get group(){return this.x}set group(K){K===null&&(K=void 0),this.B(),this.x=K}get detail(){return this.A}set detail(K){K===null&&(K=void 0),this.A=K}get presentationOptions(){return this.y}set presentationOptions(K){K==null&&(K=Object.create(null)),this.B(),this.y=K}get runOptions(){return this.z}set runOptions(K){K==null&&(K=Object.create(null)),this.B(),this.z=K}};e.$5O=Xt,e.$5O=Xt=k=Ye([w],Xt);var ui;(function(Q){Q[Q.SourceControl=1]="SourceControl",Q[Q.Window=10]="Window",Q[Q.Notification=15]="Notification"})(ui||(e.ProgressLocation=ui={}));var Mt;(function(Q){function K(fe){const Te=fe;return(0,p.$ng)(Te.value)?Te.tooltip&&!(0,p.$jg)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}Q.isViewBadge=K})(Mt||(e.ViewBadge=Mt={}));let Ct=S=class{static isTreeItem(K,fe){const Te=K;if(Te.checkboxState!==void 0){const _e=(0,p.$ng)(Te.checkboxState)?Te.checkboxState:(0,p.$lg)(Te.checkboxState)&&(0,p.$ng)(Te.checkboxState.state)?Te.checkboxState.state:void 0,ct=!(0,p.$ng)(Te.checkboxState)&&(0,p.$lg)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(_e===void 0||_e!==Yt.Checked&&_e!==Yt.Unchecked||ct!==void 0&&!(0,p.$jg)(ct))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(K instanceof S)return!0;if(Te.label!==void 0&&!(0,p.$jg)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,p.$jg)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,p.$jg)(Te.iconPath)&&!c.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,p.$jg)(Te.iconPath.id))){const _e=Te.iconPath;if(!_e||!(0,p.$jg)(_e.light)&&!c.URI.isUri(_e.light)&&!(0,p.$jg)(_e.dark)&&!c.URI.isUri(_e.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,p.$jg)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!c.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,p.$jg)(Te.tooltip)&&!(Te.tooltip instanceof ot)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<yt.None&&Te.collapsibleState>yt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,p.$jg)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(K,fe=yt.None){this.collapsibleState=fe,c.URI.isUri(K)?this.resourceUri=K:this.label=K}};e.$6O=Ct,e.$6O=Ct=S=Ye([w],Ct);var yt;(function(Q){Q[Q.None=0]="None",Q[Q.Collapsed=1]="Collapsed",Q[Q.Expanded=2]="Expanded"})(yt||(e.TreeItemCollapsibleState=yt={}));var Yt;(function(Q){Q[Q.Unchecked=0]="Unchecked",Q[Q.Checked=1]="Checked"})(Yt||(e.TreeItemCheckboxState=Yt={}));let St=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(K){this.value=K}};e.$7O=St,e.$7O=St=Ye([w],St);class oi extends St{}e.$8O=oi;class xt extends oi{#e;constructor(K){super(""),this.#e=K}asFile(){return this.#e}}e.$9O=xt;class Mi{constructor(K,fe,Te,_e){this.name=K,this.uri=fe,this._itemId=Te,this.c=_e}data(){return this.c()}}e.$0O=Mi;let di=class{#e=new Map;constructor(K){for(const[fe,Te]of K??[]){const _e=this.#e.get(this.#t(fe));_e?_e.push(Te):this.#e.set(this.#t(fe),[Te])}}get(K){return this.#e.get(this.#t(K))?.[0]}set(K,fe){this.#e.set(this.#t(K),[fe])}forEach(K,fe){for(const[Te,_e]of this.#e)for(const ct of _e)K.call(fe,ct,Te,this)}*[Symbol.iterator](){for(const[K,fe]of this.#e)for(const Te of fe)yield[K,Te]}#t(K){return K.toLowerCase()}};e.$$O=di,e.$$O=di=Ye([w],di);let yi=class{constructor(K,fe,Te){this.insertText=K,this.title=fe,this.kind=Te}};e.$_O=yi,e.$_O=yi=Ye([w],yi);var Wt;(function(Q){Q[Q.Automatic=0]="Automatic",Q[Q.PasteAs=1]="PasteAs"})(Wt||(e.DocumentPasteTriggerKind=Wt={}));class fi{static{this.c="."}constructor(K){this.value=K}append(...K){return new fi((this.value?[this.value,...K]:K).join(fi.c))}intersects(K){return this.contains(K)||K.contains(this)}contains(K){return this.value===K.value||K.value.startsWith(this.value+fi.c)}}e.$aP=fi,fi.Empty=new fi("");class Fi{constructor(K,fe,Te){this.title=fe,this.insertText=K,this.kind=Te}}e.$bP=Fi;let Ot=class{constructor(K,fe){this.id=K,this.color=fe}static isThemeIcon(K){return typeof K.id!="string"?(console.log("INVALID ThemeIcon, invalid id",K.id),!1):!0}};e.$cP=Ot,e.$cP=Ot=Ye([w],Ot),Ot.File=new Ot("file"),Ot.Folder=new Ot("folder");let Ei=class{constructor(K){this.id=K}};e.$dP=Ei,e.$dP=Ei=Ye([w],Ei);var Ti;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace",Q[Q.WorkspaceFolder=3]="WorkspaceFolder"})(Ti||(e.ConfigurationTarget=Ti={}));let gi=class{get base(){return this.c}set base(K){this.c=K,this.e=c.URI.file(K)}get baseUri(){return this.e}set baseUri(K){this.e=K,this.c=K.fsPath}constructor(K,fe){if(typeof K!="string"&&(!K||!c.URI.isUri(K)&&!c.URI.isUri(K.uri)))throw(0,h.$$)("base");if(typeof fe!="string")throw(0,h.$$)("pattern");typeof K=="string"?this.baseUri=c.URI.file(K):c.URI.isUri(K)?this.baseUri=K:this.baseUri=K.uri,this.pattern=fe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$eP=gi,e.$eP=gi=Ye([w],gi);const ji=new WeakMap;function Ui(Q,K){ji.set(Q,K)}let jt=class{constructor(K,fe,Te,_e,ct){this.enabled=typeof K=="boolean"?K:!0,typeof fe=="string"&&(this.condition=fe),typeof Te=="string"&&(this.hitCondition=Te),typeof _e=="string"&&(this.logMessage=_e),typeof ct=="string"&&(this.mode=ct)}get id(){return this.c||(this.c=ji.get(this)??(0,I.$7g)()),this.c}};e.$gP=jt,e.$gP=jt=Ye([w],jt);let Pi=class extends jt{constructor(K,fe,Te,_e,ct,bt){if(super(fe,Te,_e,ct,bt),K===null)throw(0,h.$$)("location");this.location=K}};e.$hP=Pi,e.$hP=Pi=Ye([w],Pi);let Di=class extends jt{constructor(K,fe,Te,_e,ct,bt){super(fe,Te,_e,ct,bt),this.functionName=K}};e.$iP=Di,e.$iP=Di=Ye([w],Di);let bi=class extends jt{constructor(K,fe,Te,_e,ct,bt,Et,_t){if(super(_e,ct,bt,Et,_t),!fe)throw(0,h.$$)("dataId");this.label=K,this.dataId=fe,this.canPersist=Te}};e.$jP=bi,e.$jP=bi=Ye([w],bi);let wi=class{constructor(K,fe,Te){this.command=K,this.args=fe||[],this.options=Te}};e.$kP=wi,e.$kP=wi=Ye([w],wi);let De=class{constructor(K,fe){this.port=K,this.host=fe}};e.$lP=De,e.$lP=De=Ye([w],De);let Me=class{constructor(K){this.path=K}};e.$mP=Me,e.$mP=Me=Ye([w],Me);let ve=class{constructor(K){this.implementation=K}};e.$nP=ve,e.$nP=ve=Ye([w],ve);class ie{constructor(K,fe,Te){this.session=K,this.threadId=fe,this.frameId=Te}}e.$oP=ie;class Le{constructor(K,fe){this.session=K,this.threadId=fe}}e.$pP=Le;let Qe=class{constructor(K,fe){this.range=K,this.expression=fe}};e.$qP=Qe,e.$qP=Qe=Ye([w],Qe);var rt;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(rt||(e.InlineCompletionTriggerKind=rt={}));let Ge=class{constructor(K,fe){this.range=K,this.text=fe}};e.$rP=Ge,e.$rP=Ge=Ye([w],Ge);let ut=class{constructor(K,fe,Te=!0){this.range=K,this.variableName=fe,this.caseSensitiveLookup=Te}};e.$sP=ut,e.$sP=ut=Ye([w],ut);let $t=class{constructor(K,fe){this.range=K,this.expression=fe}};e.$tP=$t,e.$tP=$t=Ye([w],$t);let Gt=class{constructor(K,fe){this.frameId=K,this.stoppedLocation=fe}};e.$uP=Gt,e.$uP=Gt=Ye([w],Gt);var Vt;(function(Q){Q[Q.AIGenerated=1]="AIGenerated"})(Vt||(e.NewSymbolNameTag=Vt={}));var qt;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(qt||(e.NewSymbolNameTriggerKind=qt={}));class Li{constructor(K,fe){this.newSymbolName=K,this.tags=fe}}e.$vP=Li;var en;(function(Q){Q[Q.Changed=1]="Changed",Q[Q.Created=2]="Created",Q[Q.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let Vi=R=class extends Error{static FileExists(K){return new R(K,f.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(K){return new R(K,f.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(K){return new R(K,f.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(K){return new R(K,f.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(K){return new R(K,f.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(K){return new R(K,f.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}constructor(K,fe=f.FileSystemProviderErrorCode.Unknown,Te){super(c.URI.isUri(K)?K.toString(!0):K),this.code=Te?.name??"Unknown",(0,f.$ul)(this,fe),Object.setPrototypeOf(this,R.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};e.$wP=Vi,e.$wP=Vi=R=Ye([w],Vi);let Si=class{constructor(K,fe,Te){this.start=K,this.end=fe,this.kind=Te}};e.$xP=Si,e.$xP=Si=Ye([w],Si);var tn;(function(Q){Q[Q.Comment=1]="Comment",Q[Q.Imports=2]="Imports",Q[Q.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(Q){Q[Q.Collapsed=0]="Collapsed",Q[Q.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var zi;(function(Q){Q[Q.Editing=0]="Editing",Q[Q.Preview=1]="Preview"})(zi||(e.CommentMode=zi={}));var rn;(function(Q){Q[Q.Published=0]="Published",Q[Q.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var Bi;(function(Q){Q[Q.Unresolved=0]="Unresolved",Q[Q.Resolved=1]="Resolved"})(Bi||(e.CommentThreadState=Bi={}));var Hi;(function(Q){Q[Q.Current=0]="Current",Q[Q.Outdated=1]="Outdated"})(Hi||(e.CommentThreadApplicability=Hi={}));var sn;(function(Q){Q[Q.Reply=1]="Reply",Q[Q.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(K,fe=[]){this.tokenTypes=K,this.tokenModifiers=fe}}e.$yP=on;function bn(Q){return typeof Q>"u"||(0,p.$kg)(Q)}class Ri{constructor(K){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,K){this.m=!0;for(let fe=0,Te=K.tokenTypes.length;fe<Te;fe++)this.k.set(K.tokenTypes[fe],fe);for(let fe=0,Te=K.tokenModifiers.length;fe<Te;fe++)this.l.set(K.tokenModifiers[fe],fe)}}push(K,fe,Te,_e,ct){if(typeof K=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof _e=="number"&&(typeof ct=="number"||typeof ct>"u"))return typeof ct>"u"&&(ct=0),this.q(K,fe,Te,_e,ct);if(z.isRange(K)&&typeof fe=="string"&&bn(Te))return this.o(K,fe,Te);throw(0,h.$$)()}o(K,fe,Te){if(!this.m)throw new Error("Legend must be provided in constructor");if(K.start.line!==K.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(fe))throw new Error("`tokenType` is not in the provided legend");const _e=K.start.line,ct=K.start.character,bt=K.end.character-K.start.character,Et=this.k.get(fe);let _t=0;if(Te)for(const pi of Te){if(!this.l.has(pi))throw new Error("`tokenModifier` is not in the provided legend");const vi=this.l.get(pi);_t|=1<<vi>>>0}this.q(_e,ct,bt,Et,_t)}q(K,fe,Te,_e,ct){if(this.f&&(K<this.c||K===this.c&&fe<this.e)){this.f=!1;const _t=this.g.length/5|0;let pi=0,vi=0;for(let Ii=0;Ii<_t;Ii++){let Ai=this.g[5*Ii],xi=this.g[5*Ii+1];Ai===0?(Ai=pi,xi+=vi):Ai+=pi,this.g[5*Ii]=Ai,this.g[5*Ii+1]=xi,pi=Ai,vi=xi}}let bt=K,Et=fe;this.f&&this.j>0&&(bt-=this.c,bt===0&&(Et-=this.e)),this.g[this.j++]=bt,this.g[this.j++]=Et,this.g[this.j++]=Te,this.g[this.j++]=_e,this.g[this.j++]=ct,this.c=K,this.e=fe}static r(K){const fe=[],Te=K.length/5|0;for(let Et=0;Et<Te;Et++)fe[Et]=Et;fe.sort((Et,_t)=>{const pi=K[5*Et],vi=K[5*_t];if(pi===vi){const Ii=K[5*Et+1],Ai=K[5*_t+1];return Ii-Ai}return pi-vi});const _e=new Uint32Array(K.length);let ct=0,bt=0;for(let Et=0;Et<Te;Et++){const _t=5*fe[Et],pi=K[_t+0],vi=K[_t+1],Ii=K[_t+2],Ai=K[_t+3],xi=K[_t+4],Hn=pi-ct,Mr=Hn===0?vi-bt:vi,_i=5*Et;_e[_i+0]=Hn,_e[_i+1]=Mr,_e[_i+2]=Ii,_e[_i+3]=Ai,_e[_i+4]=xi,ct=pi,bt=vi}return _e}build(K){return this.f?new Ki(new Uint32Array(this.g),K):new Ki(Ri.r(this.g),K)}}e.$zP=Ri;class Ki{constructor(K,fe){this.resultId=fe,this.data=K}}e.$AP=Ki;class wn{constructor(K,fe,Te){this.start=K,this.deleteCount=fe,this.data=Te}}e.$BP=wn;class vn{constructor(K,fe){this.resultId=fe,this.edits=K}}e.$CP=vn;var qi;(function(Q){Q[Q.Separate=0]="Separate",Q[Q.MergeWithParent=1]="MergeWithParent"})(qi||(e.DebugConsoleMode=qi={}));class an{constructor(K){this.name=K}}e.$DP=an;var Be;(function(Q){Q[Q.Title=1]="Title",Q[Q.Inline=2]="Inline"})(Be||(e.QuickInputButtonLocation=Be={}));let mi=class{static{this.Back={iconPath:new Ot("arrow-left")}}constructor(){}};e.$EP=mi,e.$EP=mi=Ye([w],mi);var Gi;(function(Q){Q[Q.Separator=-1]="Separator",Q[Q.Default=0]="Default"})(Gi||(e.QuickPickItemKind=Gi={}));var ft;(function(Q){Q[Q.Info=1]="Info",Q[Q.Warning=2]="Warning",Q[Q.Error=3]="Error"})(ft||(e.InputBoxValidationSeverity=ft={}));var Pt;(function(Q){Q[Q.UI=1]="UI",Q[Q.Workspace=2]="Workspace"})(Pt||(e.ExtensionKind=Pt={}));class yn{static validate(K){if(typeof K.badge=="string"){let fe=(0,A.$Uf)(K.badge,0);if(fe<K.badge.length&&(fe+=(0,A.$Uf)(K.badge,fe)),K.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(K.badge&&!Ot.isThemeIcon(K.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!K.color&&!K.badge&&!K.tooltip)throw new Error("The decoration is empty");return!0}constructor(K,fe,Te){this.badge=K,this.tooltip=fe,this.color=Te}}e.$FP=yn;let Qi=class{constructor(K){this.kind=K}};e.$GP=Qi,e.$GP=Qi=Ye([w],Qi);var Ji;(function(Q){Q[Q.Light=1]="Light",Q[Q.Dark=2]="Dark",Q[Q.HighContrast=3]="HighContrast",Q[Q.HighContrastLight=4]="HighContrastLight"})(Ji||(e.ColorThemeKind=Ji={}));class ki{static isNotebookRange(K){return K instanceof ki?!0:K?typeof K.start=="number"&&typeof K.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(K,fe){if(K<0)throw(0,h.$$)("start must be positive");if(fe<0)throw(0,h.$$)("end must be positive");K<=fe?(this.c=K,this.e=fe):(this.c=fe,this.e=K)}with(K){let fe=this.c,Te=this.e;return K.start!==void 0&&(fe=K.start),K.end!==void 0&&(Te=K.end),fe===this.c&&Te===this.e?this:new ki(fe,Te)}}e.$HP=ki;class Ci{static validate(K){if(typeof K.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof K.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof K.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(K){return Array.isArray(K)&&K.every(fe=>Ci.isNotebookCellData(fe))}static isNotebookCellData(K){return!0}constructor(K,fe,Te,_e,ct,bt,Et){this.kind=K,this.value=fe,this.languageId=Te,this.mime=_e,this.outputs=ct??[],this.metadata=bt,this.executionSummary=Et,Ci.validate(this)}}e.$IP=Ci;class En{constructor(K){this.cells=K}}e.$JP=En;class $i{static isNotebookCellOutputItem(K){return K instanceof $i?!0:K?typeof K.mime=="string"&&K.data instanceof Uint8Array:!1}static error(K){const fe={name:K.name,message:K.message,stack:K.stack};return $i.json(fe,"application/vnd.code.notebook.error")}static stdout(K){return $i.text(K,"application/vnd.code.notebook.stdout")}static stderr(K){return $i.text(K,"application/vnd.code.notebook.stderr")}static bytes(K,fe="application/octet-stream"){return new $i(K,fe)}static#e=new TextEncoder;static text(K,fe=T.$it.text){const Te=$i.#e.encode(String(K));return new $i(Te,fe)}static json(K,fe="text/x-json"){const Te=JSON.stringify(K,void 0,"	");return $i.text(Te,fe)}constructor(K,fe){this.data=K,this.mime=fe;const Te=(0,T.$mt)(fe,!0);if(!Te)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.$KP=$i;class Wi{static isNotebookCellOutput(K){return K instanceof Wi?!0:!K||typeof K!="object"?!1:typeof K.id=="string"&&Array.isArray(K.items)}static ensureUniqueMimeTypes(K,fe=!1){const Te=new Set,_e=new Set;for(let ct=0;ct<K.length;ct++){const bt=K[ct],Et=(0,T.$mt)(bt.mime);if(!Te.has(Et)||(0,v.$cM)(Et)){Te.add(Et);continue}_e.add(ct),fe&&console.warn(`DUPLICATED mime type '${bt.mime}' will be dropped`)}return _e.size===0?K:K.filter((ct,bt)=>!_e.has(bt))}constructor(K,fe,Te){this.items=Wi.ensureUniqueMimeTypes(K,!0),typeof fe=="string"?(this.id=fe,this.metadata=Te):(this.id=(0,I.$7g)(),this.metadata=fe??Te)}}e.$LP=Wi;var Xi;(function(Q){Q[Q.Markup=1]="Markup",Q[Q.Code=2]="Code"})(Xi||(e.NotebookCellKind=Xi={}));var cn;(function(Q){Q[Q.Idle=1]="Idle",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(cn||(e.NotebookCellExecutionState=cn={}));var ln;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(ln||(e.NotebookCellStatusBarAlignment=ln={}));var un;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(un||(e.NotebookEditorRevealType=un={}));class Sn{constructor(K,fe){this.text=K,this.alignment=fe}}e.$MP=Sn;var hn;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred"})(hn||(e.NotebookControllerAffinity=hn={}));var dn;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred",Q[Q.Hidden=-1]="Hidden"})(dn||(e.NotebookControllerAffinity2=dn={}));class kn{constructor(K,fe=[]){this.uri=K,this.provides=(0,s.$6b)(fe)}}e.$NP=kn;class In{constructor(K){this.label=K}}e.$OP=In;var fn;(function(Q){Q[Q.Named=1]="Named",Q[Q.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Yi=class{constructor(K,fe){this.label=K,this.timestamp=fe}};e.$PP=Yi,e.$PP=Yi=Ye([w],Yi);var gn;(function(Q){Q[Q.Production=1]="Production",Q[Q.Development=2]="Development",Q[Q.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var he;(function(Q){Q[Q.Node=1]="Node",Q[Q.Webworker=2]="Webworker"})(he||(e.ExtensionRuntime=he={}));var Ee;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(Ee||(e.StandardTokenType=Ee={}));class ze{constructor(K,fe){this.ranges=K,this.wordPattern=fe}}e.$QP=ze;class mt{constructor(K){this.c=K}get autoForwardAction(){return this.c}}e.$RP=mt;var Dt;(function(Q){Q[Q.Queued=1]="Queued",Q[Q.Running=2]="Running",Q[Q.Passed=3]="Passed",Q[Q.Failed=4]="Failed",Q[Q.Skipped=5]="Skipped",Q[Q.Errored=6]="Errored"})(Dt||(e.TestResultState=Dt={}));var Ft;(function(Q){Q[Q.Run=1]="Run",Q[Q.Debug=2]="Debug",Q[Q.Coverage=3]="Coverage"})(Ft||(e.TestRunProfileKind=Ft={}));let Oi=class{constructor(K=void 0,fe=void 0,Te=void 0,_e=!1,ct=!0){this.include=K,this.exclude=fe,this.profile=Te,this.continuous=_e,this.preserveFocus=ct}};e.$SP=Oi,e.$SP=Oi=Ye([w],Oi);let Zi=C=class{static diff(K,fe,Te){const _e=new C(K);return _e.expectedOutput=fe,_e.actualOutput=Te,_e}constructor(K){this.message=K}};e.$TP=Zi,e.$TP=Zi=C=Ye([w],Zi);let Pn=class{constructor(K){this.id=K}};e.$UP=Pn,e.$UP=Pn=Ye([w],Pn);class Qn{constructor(K,fe,Te){this.label=K,this.uri=fe,this.position=Te}}e.$VP=Qn;class mn{constructor(K,fe){this.covered=K,this.total=fe,Rn(this)}}e.$WP=mn;function Rn(Q){if(Q){if(Q.covered>Q.total)throw new Error(`The total number of covered items (${Q.covered}) cannot be greater than the total (${Q.total})`);if(Q.total<0)throw new Error(`The number of covered items (${Q.total}) cannot be negative`)}}class Dn{static fromDetails(K,fe){const Te=new mn(0,0),_e=new mn(0,0),ct=new mn(0,0);for(const Et of fe)if("branches"in Et){Te.total+=1,Te.covered+=Et.executed?1:0;for(const _t of Et.branches)_e.total+=1,_e.covered+=_t.executed?1:0}else ct.total+=1,ct.covered+=Et.executed?1:0;const bt=new Dn(K,Te,_e.total>0?_e:void 0,ct.total>0?ct:void 0);return bt.detailedCoverage=fe,bt}constructor(K,fe,Te,_e,ct=[]){this.uri=K,this.statementCoverage=fe,this.branchCoverage=Te,this.declarationCoverage=_e,this.fromTests=ct}}e.$YP=Dn;class Jn{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,fe,Te=[]){this.executed=K,this.location=fe,this.branches=Te}}e.$ZP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,fe,Te){this.executed=K,this.location=fe,this.label=Te}}e.$1P=Xn;class Yn{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,fe,Te){this.name=K,this.executed=fe,this.location=Te}}e.$2P=Yn;var Cn;(function(Q){Q[Q.None=0]="None",Q[Q.Option=1]="Option",Q[Q.Default=2]="Default",Q[Q.Preferred=3]="Preferred"})(Cn||(e.ExternalUriOpenerPriority=Cn={}));var On;(function(Q){Q[Q.Untrusted=0]="Untrusted",Q[Q.Trusted=1]="Trusted",Q[Q.Unspecified=2]="Unspecified"})(On||(e.WorkspaceTrustState=On={}));var An;(function(Q){Q[Q.Notify=1]="Notify",Q[Q.OpenBrowser=2]="OpenBrowser",Q[Q.OpenPreview=3]="OpenPreview",Q[Q.Silent=4]="Silent",Q[Q.Ignore=5]="Ignore",Q[Q.OpenBrowserOnce=6]="OpenBrowserOnce"})(An||(e.PortAutoForwardAction=An={}));class Zn{constructor(K,fe,Te,_e,ct,bt){this.kind=K,this.name=fe,this.detail=Te,this.uri=_e,this.range=ct,this.selectionRange=bt}}e.$3P=Zn;class xn{constructor(K){this.uri=K}}e.$4P=xn;class _n{constructor(K,fe){this.original=K,this.modified=fe}}e.$5P=_n;class er{constructor(K,fe,Te,_e){this.base=K,this.input1=fe,this.input2=Te,this.result=_e}}e.$6P=er;class tr{constructor(K,fe){this.uri=K,this.viewType=fe}}e.$7P=tr;class ir{constructor(K){this.viewType=K}}e.$8P=ir;class nr{constructor(K,fe){this.uri=K,this.notebookType=fe}}e.$9P=nr;class rr{constructor(K,fe,Te){this.original=K,this.modified=fe,this.notebookType=Te}}e.$0P=rr;class sr{constructor(){}}e.$$P=sr;class or{constructor(K,fe){this.uri=K,this.inputBoxUri=fe}}e.$_P=or;class ar{constructor(){}}e.$aQ=ar;class cr{constructor(K){this.textDiffs=K}}e.$bQ=cr;var Tn;(function(Q){Q[Q.Down=0]="Down",Q[Q.Up=1]="Up"})(Tn||(e.InteractiveSessionVoteDirection=Tn={}));var Ln;(function(Q){Q[Q.Action=1]="Action",Q[Q.Toolbar=2]="Toolbar"})(Ln||(e.ChatCopyKind=Ln={}));var Nn;(function(Q){Q[Q.Short=1]="Short",Q[Q.Medium=2]="Medium",Q[Q.Full=3]="Full"})(Nn||(e.ChatVariableLevel=Nn={}));class lr{constructor(K,fe,Te){this.id=K,this.label=fe,this.values=Te}}e.$cQ=lr;var Mn;(function(Q){Q[Q.Unhelpful=0]="Unhelpful",Q[Q.Helpful=1]="Helpful",Q[Q.Undone=2]="Undone",Q[Q.Accepted=3]="Accepted",Q[Q.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var Fn;(function(Q){Q[Q.Unhelpful=0]="Unhelpful",Q[Q.Helpful=1]="Helpful"})(Fn||(e.ChatResultFeedbackKind=Fn={}));class ur{constructor(K){if(typeof K!="string"&&K.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof K=="string"?new ot(K):K}}e.$dQ=ur;class hr{constructor(K,fe){if(typeof K!="string"&&K.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof K=="string"?new ot(K):K,this.vulnerabilities=fe}}e.$eQ=hr;class dr{constructor(K,fe){this.participant=K,this.command=fe}}e.$fQ=dr;class fr{constructor(K,fe,Te,_e){this.title=K,this.message=fe,this.data=Te,this.buttons=_e}}e.$gQ=fr;class gr{constructor(K,fe){this.value=K,this.baseUri=fe}}e.$hQ=gr;class mr{constructor(K,fe){this.value=K,this.title=fe}}e.$iQ=mr;class $r{constructor(K){this.value=K}}e.$jQ=$r;class pr{constructor(K,fe){this.value=K,this.task=fe}}e.$kQ=pr;class br{constructor(K){if(typeof K!="string"&&K.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof K=="string"?new ot(K):K}}e.$lQ=br;class wr{constructor(K){this.value=K}}e.$mQ=wr;class vr{constructor(K,fe,Te){this.value=K,this.iconPath=fe,this.options=Te}}e.$nQ=vr;class yr{constructor(K,fe,Te){this.value=K,this.license=fe,this.snippet=Te}}e.$oQ=yr;class Er{constructor(K,fe){this.uri=K,this.range=fe}}e.$pQ=Er;class Sr{constructor(K,fe){this.uri=K,this.edits=Array.isArray(fe)?fe:[fe]}}e.$qQ=Sr;class kr{constructor(K,fe,Te,_e){this.prompt=K,this.command=fe,this.references=Te,this.participant=_e}}e.$rQ=kr;class Ir{constructor(K,fe,Te,_e){this.response=K,this.result=fe,this.participant=Te,this.command=_e}}e.$sQ=Ir;var jn;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Terminal=2]="Terminal",Q[Q.Notebook=3]="Notebook",Q[Q.Editor=4]="Editor"})(jn||(e.ChatLocation=jn={}));var zn;(function(Q){Q[Q.Complete=1]="Complete",Q[Q.Partial=2]="Partial",Q[Q.Omitted=3]="Omitted"})(zn||(e.ChatResponseReferencePartStatusKind=zn={}));class Pr{constructor(K,fe,Te){this.document=K,this.selection=fe,this.wholeRange=Te}}e.$tQ=Pr;class Dr{constructor(K){this.cell=K}}e.$uQ=Dr;var $n;(function(Q){Q[Q.User=1]="User",Q[Q.Assistant=2]="Assistant",Q[Q.System=3]="System"})($n||(e.LanguageModelChatMessageRole=$n={}));class Rr{constructor(K,fe,Te){this.toolCallId=K,this.content=fe,this.isError=Te??!1}}e.$vQ=Rr;class pn{static User(K,fe){const Te=new pn($n.User,typeof K=="string"?K:"",fe);return Te.content2=[K],Te}static Assistant(K,fe){return new pn($n.Assistant,K,fe)}constructor(K,fe,Te){this.role=K,this.content=fe,this.content2=[fe],this.name=Te}}e.$wQ=pn;class Cr{constructor(K,fe,Te){this.name=K,this.toolCallId=fe,this.parameters=Te}}e.$xQ=Cr;class Or{constructor(K){this.value=K}}e.$yQ=Or;class Ar{constructor(K){this.content=K}}e.$zQ=Ar;class Tr{constructor(K,fe){this.content=K,this.name=fe}}e.$AQ=Tr;class Lr{constructor(K,fe){this.content=K,this.name=fe}}e.$BQ=Lr;class Ni extends Error{static NotFound(K){return new Ni(K,Ni.NotFound.name)}static NoPermissions(K){return new Ni(K,Ni.NoPermissions.name)}static Blocked(K){return new Ni(K,Ni.Blocked.name)}constructor(K,fe,Te){super(K,{cause:Te}),this.name="LanguageModelError",this.code=fe??""}}e.$CQ=Ni;var Un;(function(Q){Q[Q.SymbolInformation=1]="SymbolInformation",Q[Q.CommandInformation=2]="CommandInformation",Q[Q.SearchInformation=3]="SearchInformation",Q[Q.SettingInformation=4]="SettingInformation"})(Un||(e.RelatedInformationType=Un={}));var Bn;(function(Q){Q[Q.Started=1]="Started",Q[Q.Recognizing=2]="Recognizing",Q[Q.Recognized=3]="Recognized",Q[Q.Stopped=4]="Stopped",Q[Q.Error=5]="Error"})(Bn||(e.SpeechToTextStatus=Bn={}));var qn;(function(Q){Q[Q.Started=1]="Started",Q[Q.Stopped=2]="Stopped",Q[Q.Error=3]="Error"})(qn||(e.TextToSpeechStatus=qn={}));var Wn;(function(Q){Q[Q.Recognized=1]="Recognized",Q[Q.Stopped=2]="Stopped"})(Wn||(e.KeywordRecognitionStatus=Wn={}));class Nr{constructor(K,fe){this.text=K,this.range=fe}}e.$DQ=Nr;var Vn;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(Re[292],Ce([1,0,6,9]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0;class D{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(s.$bO.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(T,A,p){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(T);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(A,p)??[]}getRelatedInformation(T,A,p){return this.c.$getAiRelatedInformation(A,p)}registerRelatedInformationProvider(T,A,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiRelatedInformationProvider(c,A),new h.$dO(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$6qc=D}),define(Re[128],Ce([1,0,4,6,9,23,162,5,19]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=e.$erc=void 0,e.$erc=(0,A.$Ki)("IExtHostAuthentication");let c=class{constructor(f){this.b=new Map,this.c=new s.$qe,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=f.getProxy(h.$bO.MainThreadAuthentication)}async getSession(f,P,v,o={}){const m=O.$zn.toKey(f.identifier),$=[...v].sort().join(" ");return await this.d.getOrCreate(`${m} ${P} ${$}`,async()=>{await this.a.$ensureProvider(P);const d=f.displayName||f.name;return this.a.$getSession(P,v,m,d,o)})}async getAccounts(f){return await this.a.$ensureProvider(f),await this.a.$getAccounts(f)}async removeSession(f,P){const v=this.b.get(f);return v?v.provider.removeSession(P):this.a.$removeSession(f,P)}registerAuthenticationProvider(f,P,v,o){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:P,provider:v,options:o??{supportsMultipleAccounts:!1}});const m=v.onDidChangeSessions($=>this.a.$sendDidChangeSessions(f,$));return this.a.$registerAuthenticationProvider(f,P,o?.supportsMultipleAccounts??!1),new D.$dO(()=>{m.dispose(),this.b.delete(f),this.a.$unregisterAuthenticationProvider(f)})}async $createSession(f,P,v){const o=this.b.get(f);if(o)return await o.provider.createSession(P,v);throw new Error(`Unable to find authentication provider with handle: ${f}`)}async $removeSession(f,P){const v=this.b.get(f);if(v)return await v.provider.removeSession(P);throw new Error(`Unable to find authentication provider with handle: ${f}`)}async $getSessions(f,P,v){const o=this.b.get(f);if(o)return await o.provider.getSessions(P,v);throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,P){return f.startsWith(T.$eN)||this.c.fire({provider:{id:f,label:P}}),Promise.resolve()}};e.$frc=c,e.$frc=c=Ye([We(0,p.$OQ)],c);class I{constructor(){this.a=new Map}getOrCreate(f,P){const v=this.a.get(f);if(v)return v;const o=P().finally(()=>this.a.delete(f));return this.a.set(f,o),o}}}),define(Re[169],Ce([1,0,2,6,9,5,19,11,18,13,16,25]),function(ge,e,s,h,D,O,T,A,p,c,I,E){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$ksc=e.$jsc=void 0;let P=class{static{f=this}static{this.c=0}static{this.d=250}constructor(o,m){this.h=m,this.f=new Map,this.g=o.getProxy(h.$bO.MainThreadDecorations)}registerFileDecorationProvider(o,m){const $=f.c++;this.f.set($,{provider:o,extensionDescription:m}),this.g.$registerDecorationProvider($,m.identifier.value);const d=o.onDidChangeFileDecorations&&o.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange($,null);return}const a=(0,p.$6b)(i);if(a.length<=f.d){this.g.$onDidChange($,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,a.length);const t=a.map(u=>({uri:u,rank:(0,c.$nf)(u.path,"/")})),r=(0,p.$Db)(t,(u,l)=>u.rank-l.rank||(0,c.$Df)(u.uri.path,l.uri.path)),n=[];e:for(const u of r){let l;for(const g of u){const y=(0,I.$rc)(g.uri.path);if(l!==y&&(l=y,n.push(g.uri)>=f.d))break e}}this.g.$onDidChange($,n)});return new D.$dO(()=>{d?.dispose(),this.g.$unregisterDecorationProvider($),this.f.delete($)})}async $provideDecorations(o,m,$){if(!this.f.has(o))return Object.create(null);const d=Object.create(null),{provider:i,extensionDescription:a}=this.f.get(o);return await Promise.all(m.map(async t=>{try{const{uri:r,id:n}=t,u=await Promise.resolve(i.provideFileDecoration(s.URI.revive(r),$));if(!u)return;try{D.$FP.validate(u),u.badge&&typeof u.badge!="string"&&(0,E.$DH)(a,"codiconDecoration"),d[n]=[u.propagate,u.tooltip,u.badge,u.color]}catch(l){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${l}`)}}catch(r){this.h.error(r)}})),d}};e.$jsc=P,e.$jsc=P=f=Ye([We(0,T.$OQ),We(1,A.$fk)],P),e.$ksc=(0,O.$Ki)("IExtHostDecorations")}),define(Re[293],Ce([1,0,12,2,9,6,14,20,13]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$msc=void 0;class c{static{this.a=0}constructor(E,f,P){this.d=f,this.e=P,this.b=new Map,this.c=E.getProxy(O.$bO.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,f){if(Object.keys(T.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const P=c.a++;this.b.set(P,f),this.c.$registerTextContentProvider(P,E);let v;if(typeof f.onDidChange=="function"){let o;v=f.onDidChange(async m=>{if(m.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;o&&await o;const $=this.$provideTextDocumentContent(P,m).then(async d=>{if(!d&&typeof d!="string")return;const i=this.d.getDocument(m);if(!i)return;const a=(0,p.$xf)(d);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(m,d)}).catch(s.$4).finally(()=>{o===$&&(o=void 0)});o=$})}return new D.$dO(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(E,f){const P=this.b.get(E);return P?Promise.resolve(P.provideTextDocumentContent(h.URI.revive(f),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.$msc=c}),define(Re[170],Ce([1,0,67,14,13,204,140,9,18]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=e.$RQ=void 0,e.$QQ=I;const c=new Map;function I(v,o){o?c.set(v,o):c.delete(v)}function E(v){return c.get(v)}class f extends O.$Aw{constructor(o,m,$,d,i,a,t){super(m,$,d,i),this.o=o,this.p=a,this.q=t,this.n=!1}dispose(){(0,s.ok)(!this.n),this.n=!0,this.q=!1}equalLines(o){return(0,p.$yb)(this.b,o)}get document(){if(!this.m){const o=this;this.m={get uri(){return o.a},get fileName(){return o.a.fsPath},get isUntitled(){return o.a.scheme===h.Schemas.untitled},get languageId(){return o.p},get version(){return o.d},get isClosed(){return o.n},get isDirty(){return o.q},save(){return o.r()},getText(m){return m?o.s(m):o.getText()},get eol(){return o.c===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return o.b.length},lineAt(m){return o.t(m)},offsetAt(m){return o.u(m)},positionAt(m){return o.v(m)},validateRange(m){return o.w(m)},validatePosition(m){return o.x(m)},getWordRangeAtPosition(m,$){return o.y(m,$)},[Symbol.for("debug.description")](){return`TextDocument(${o.a.toString()})`}}}return Object.freeze(this.m)}_acceptLanguageId(o){(0,s.ok)(!this.n),this.p=o}_acceptIsDirty(o){(0,s.ok)(!this.n),this.q=o}r(){return this.n?Promise.reject(new Error("Document has been closed")):this.o.$trySaveDocument(this.a)}s(o){const m=this.w(o);if(m.isEmpty)return"";if(m.isSingleLine)return this.b[m.start.line].substring(m.start.character,m.end.character);const $=this.c,d=m.start.line,i=m.end.line,a=[];a.push(this.b[d].substring(m.start.character));for(let t=d+1;t<i;t++)a.push(this.b[t]);return a.push(this.b[i].substring(0,m.end.character)),a.join($)}t(o){let m;if(o instanceof A.$eO?m=o.line:typeof o=="number"&&(m=o),typeof m!="number"||m<0||m>=this.b.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new P(m,this.b[m],m===this.b.length-1)}u(o){return o=this.x(o),this.h(),this.f.getPrefixSum(o.line-1)+o.character}v(o){o=Math.floor(o),o=Math.max(0,o),this.h();const m=this.f.getIndexOf(o),$=this.b[m.index].length;return new A.$eO(m.index,Math.min(m.remainder,$))}w(o){if(!(o instanceof A.$fO))throw new Error("Invalid argument");const m=this.x(o.start),$=this.x(o.end);return m===o.start&&$===o.end?o:new A.$fO(m.line,m.character,$.line,$.character)}x(o){if(!(o instanceof A.$eO))throw new Error("Invalid argument");if(this.b.length===0)return o.with(0,0);let{line:m,character:$}=o,d=!1;if(m<0)m=0,$=0,d=!0;else if(m>=this.b.length)m=this.b.length-1,$=this.b[m].length,d=!0;else{const i=this.b[m].length;$<0?($=0,d=!0):$>i&&($=i,d=!0)}return d?new A.$eO(m,$):o}y(o,m){const $=this.x(o);if(!m)m=E(this.p);else if((0,D.$wf)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const d=(0,T.$At)($.character+1,(0,T.$yt)(m),this.b[$.line],0);if(d)return new A.$fO($.line,d.startColumn-1,$.line,d.endColumn-1)}}e.$RQ=f;class P{constructor(o,m,$){this.a=o,this.b=m,this.c=$}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.$fO(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.$fO(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$SQ=P}),define(Re[294],Ce([1,0,6,9]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$psc=void 0;class D{constructor(T){this.a=new Map,this.b=0,this.c=T.getProxy(s.$bO.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(T,A,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(T);if(!c)throw new Error("Embedding vector provider not found");const I=await c.provideEmbeddingVector(A,p);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(T,A,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiEmbeddingVectorProvider(A,c),new h.$dO(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$psc=D}),define(Re[77],Ce([1,0,6,27,9,21,5,19,64,3,8,22,14]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$vrc=e.$urc=void 0,h=Ue(h);let v=P=class{constructor(m,$){this.b=new Map,this.c=new I.$Th,this.a=m.getProxy(s.$bO.MainThreadFileSystem);const d=this;this.value=Object.freeze({async stat(i){try{let a;const t=d.b.get(i.scheme);return t?(await d.a.$ensureActivation(i.scheme),a=await t.impl.stat(i)):a=await d.a.$stat(i),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===h.FilePermission.Readonly?1:void 0}}catch(a){P.e(a)}},async readDirectory(i){try{const a=d.b.get(i.scheme);return a?(await d.a.$ensureActivation(i.scheme),(await a.impl.readDirectory(i)).slice()):await d.a.$readdir(i)}catch(a){return P.e(a)}},async createDirectory(i){try{const a=d.b.get(i.scheme);return a&&!a.isReadonly?(await d.a.$ensureActivation(i.scheme),await d.d(a.impl,a.extUri,i)):await d.a.$mkdir(i)}catch(a){return P.e(a)}},async readFile(i){try{const a=d.b.get(i.scheme);return a?(await d.a.$ensureActivation(i.scheme),(await a.impl.readFile(i)).slice()):(await d.a.$readFile(i)).buffer}catch(a){return P.e(a)}},async writeFile(i,a){try{const t=d.b.get(i.scheme);return t&&!t.isReadonly?(await d.a.$ensureActivation(i.scheme),await d.d(t.impl,t.extUri,t.extUri.dirname(i)),await d.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,a,{create:!0,overwrite:!0})))):await d.a.$writeFile(i,O.$Se.wrap(a))}catch(t){return P.e(t)}},async delete(i,a){try{const t=d.b.get(i.scheme);return t&&!t.isReadonly&&!a?.useTrash?(await d.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...a})):await d.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(t){return P.e(t)}},async rename(i,a,t){try{return await d.a.$rename(i,a,{overwrite:!1,...t})}catch(r){return P.e(r)}},async copy(i,a,t){try{return await d.a.$copy(i,a,{overwrite:!1,...t})}catch(r){return P.e(r)}},isWritableFileSystem(i){const a=$.getCapabilities(i);if(typeof a=="number")return!(a&h.FileSystemProviderCapabilities.Readonly)}})}async d(m,$,d){const i=[];for(;!$.isEqual(d,$.dirname(d));)try{if(!((await m.stat(d)).type&h.FileType.Directory))throw D.$wP.FileExists(`Unable to create folder '${d.scheme===f.Schemas.file?d.fsPath:d.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(h.$vl(a)!==h.FileSystemProviderErrorCode.FileNotFound)throw a;i.push($.basename(d)),d=$.dirname(d)}for(let a=i.length-1;a>=0;a--){d=$.joinPath(d,i[a]);try{await m.createDirectory(d)}catch(t){if(h.$vl(t)!==h.FileSystemProviderErrorCode.FileExists)throw t}}}static e(m){if(m instanceof D.$wP)throw m;if(m instanceof h.$rl)switch(m.code){case h.FileSystemProviderErrorCode.FileExists:throw D.$wP.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw D.$wP.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw D.$wP.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw D.$wP.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw D.$wP.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw D.$wP.Unavailable(m.message);default:throw new D.$wP(m.message,m.name)}if(!(m instanceof Error))throw new D.$wP(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw D.$wP.Unavailable(m.message);switch(m.name){case h.FileSystemProviderErrorCode.FileExists:throw D.$wP.FileExists(m.message);case h.FileSystemProviderErrorCode.FileNotFound:throw D.$wP.FileNotFound(m.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw D.$wP.FileNotADirectory(m.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw D.$wP.FileIsADirectory(m.message);case h.FileSystemProviderErrorCode.NoPermissions:throw D.$wP.NoPermissions(m.message);case h.FileSystemProviderErrorCode.Unavailable:throw D.$wP.Unavailable(m.message);default:throw new D.$wP(m.message,m.name)}}addFileSystemProvider(m,$,d){return this.b.set(m,{impl:$,extUri:d?.isCaseSensitive?E.$bh:E.$dh,isReadonly:!!d?.isReadonly}),(0,c.$Xc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??E.$bh}};e.$urc=v,e.$urc=v=P=Ye([We(0,A.$OQ),We(1,p.$$qc)],v),e.$vrc=(0,T.$Ki)("IExtHostConsumerFileSystem")}),define(Re[98],Ce([1,0,5,29,11,77,2]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xrc=e.$wrc=void 0,e.$wrc=(0,s.$Ki)("IExtensionStoragePaths");let A=class{constructor(c,I,E){this.d=I,this.f=E,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(c){return T.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,I=await this.g(c);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(T.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:T.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(c){if(this.c)return T.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return T.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$xrc=A,e.$xrc=A=Ye([We(0,h.$5Q),We(1,D.$fk),We(2,O.$vrc)],A)}),define(Re[295],Ce([1,0,9,19,4]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_sc=void 0;let O=class{constructor(A){this.a=new s.$GP(s.ColorThemeKind.Dark),this.b=new D.$qe}get activeColorTheme(){return this.a}$onColorThemeChange(A){let p;switch(A){case"light":p=s.ColorThemeKind.Light;break;case"hcDark":p=s.ColorThemeKind.HighContrast;break;case"hcLight":p=s.ColorThemeKind.HighContrastLight;break;default:p=s.ColorThemeKind.Dark}this.a=new s.$GP(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$_sc=O,e.$_sc=O=Ye([We(0,h.$OQ)],O)}),define(Re[78],Ce([1,0,20,4,3,7,5,11,93,6,29,19,9]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kHb=e.$jHb=e.TunnelDtoConverter=void 0,O=Ue(O),f=Ue(f);class P extends p.$Zw{}var v;(function(m){function $(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=$;function d(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=d})(v||(e.TunnelDtoConverter=v={})),e.$jHb=(0,T.$Ki)("IExtHostTunnelService");let o=class extends D.$Zc{constructor($,d,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$qe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=$.getProxy(c.$bO.MainThreadTunnelService)}async openTunnel($,d){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${$.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const i=await this.a.$openTunnel(d,$.displayName);if(i){const a=new P(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider($,d){$.portRange===void 0&&$.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:$,provider:d}),this.a.$registerPortsAttributesProvider($,i),new f.$dO(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes($,d,i,a,t){const r=[];for(const u of $){const l=this.r.get(u);if(!l)return[];r.push(...await Promise.all(d.map(async g=>{let y;try{y=await l.provider.providePortAttributes({port:g,pid:i,commandLine:a},t)}catch{y=await l.provider.providePortAttributes(g,i,a,t)}return{providedAttributes:y,port:g}})))}const n=r.filter(u=>!!u.providedAttributes);return n.length>0?n.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder($){}registerTunnelProvider($,d){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,t)=>await $.provideTunnel(a,t,s.CancellationToken.None)??void 0;const i=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,privacyOptions:d.tunnelFeatures?.privacyOptions,protocol:d.tunnelFeatures.protocol===void 0?!0:d.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,D.$Xc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory($,d){if($){$.candidatePortSource!==void 0&&this.a.$setCandidatePortSource($.candidatePortSource),$.showCandidatePort&&(this.f=$.showCandidatePort,this.a.$setCandidateFilter());const i=$.tunnelFactory??(d?this.w(d):void 0);if(i){this.b=i;let a=$.tunnelFeatures?.privacyOptions??[];$.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:O.localize(2717,null),themeIcon:"lock"},{id:"public",label:O.localize(2718,null),themeIcon:"eye"}]);const t=$.tunnelFeatures?{elevation:!!$.tunnelFeatures?.elevation,public:!!$.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,D.$Xc)(()=>{this.b=void 0})}w($){}async $closeTunnel($,d){if(this.g.has($.host)){const i=this.g.get($.host);i.has($.port)&&(d&&i.get($.port).disposeListener.dispose(),await i.get($.port).tunnel.dispose(),i.delete($.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort($,d){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b($,d);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const a=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has($.remoteAddress.host)||this.g.set($.remoteAddress.host,new Map);const t=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get($.remoteAddress.host).set($.remoteAddress.port,{tunnel:a,disposeListener:t}),v.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter($){const d=await Promise.all($.map(a=>this.f(a.host,a.port,a.detail??""))),i=$.filter((a,t)=>d[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${$.map(a=>a.port).join(", ")} to ${i.map(a=>a.port).join(", ")}`),i}};e.$kHb=o,e.$kHb=o=Ye([We(0,E.$OQ),We(1,I.$5Q),We(2,A.$fk)],o)}),define(Re[15],Ce([1,0,18,21,193,81,86,28,183,38,107,24,188,22,51,17,2,113,30,105,88,56,150,90,161,158,159,273,120,127,75,76,270,9]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t,r,n,u,l,g,y,k,S,R,C,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatLanguageModelToolReference=e.ChatPromptReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseMovePart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$LQ=x,e.$MQ=te,e.$NQ=me,T=Ue(T),p=Ue(p),d=Ue(d),i=Ue(i),a=Ue(a),y=Ue(y),S=Ue(S),b=Ue(b);var N;(function(De){function Me(ie){const{selectionStartLineNumber:Le,selectionStartColumn:Qe,positionLineNumber:rt,positionColumn:Ge}=ie,ut=new b.$eO(Le-1,Qe-1),$t=new b.$eO(rt-1,Ge-1);return new b.$gO(ut,$t)}De.to=Me;function ve(ie){const{anchor:Le,active:Qe}=ie;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Qe.line+1,positionColumn:Qe.character+1}}De.from=ve})(N||(e.Selection=N={}));var L;(function(De){function Me(ie){if(!ie)return;const{start:Le,end:Qe}=ie;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Qe.line+1,endColumn:Qe.character+1}}De.from=Me;function ve(ie){if(!ie)return;const{startLineNumber:Le,startColumn:Qe,endLineNumber:rt,endColumn:Ge}=ie;return new b.$fO(Le-1,Qe-1,rt-1,Ge-1)}De.to=ve})(L||(e.Range=L={}));var M;(function(De){function Me(ie){return{uri:ie.uri,range:L.from(ie.range)}}De.from=Me;function ve(ie){return new b.$rO(m.URI.revive(ie.uri),L.to(ie.range))}De.to=ve})(M||(e.Location=M={}));var z;(function(De){function Me(ve){switch(ve){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}De.to=Me})(z||(e.TokenType=z={}));var V;(function(De){function Me(ie){return new b.$eO(ie.lineNumber-1,ie.column-1)}De.to=Me;function ve(ie){return{lineNumber:ie.line+1,column:ie.character+1}}De.from=ve})(V||(e.Position=V={}));var F;(function(De){function Me(Le,Qe,rt){return(0,s.$Lb)((0,s.$6b)(Le).map(Ge=>ve(Ge,Qe,rt)))}De.from=Me;function ve(Le,Qe,rt){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:rt?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:ie(Le.scheme,Qe),pattern:Xe.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:rt?.isBuiltin}}function ie(Le,Qe){return Qe&&typeof Le=="string"?Qe.transformOutgoingScheme(Le):Le}})(F||(e.DocumentSelector=F={}));var j;(function(De){function Me(ie){switch(ie){case b.DiagnosticTag.Unnecessary:return r.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return r.MarkerTag.Deprecated}}De.from=Me;function ve(ie){switch(ie){case r.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case r.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}De.to=ve})(j||(e.DiagnosticTag=j={}));var W;(function(De){function Me(ie){let Le;return ie.code&&((0,o.$jg)(ie.code)||(0,o.$ng)(ie.code)?Le=String(ie.code):Le={value:String(ie.code.value),target:ie.code.target}),{...L.from(ie.range),message:ie.message,source:ie.source,code:Le,severity:B.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(J.from),tags:Array.isArray(ie.tags)?(0,s.$Lb)(ie.tags.map(j.from)):void 0}}De.from=Me;function ve(ie){const Le=new b.$tO(L.to(ie),ie.message,B.to(ie.severity));return Le.source=ie.source,Le.code=(0,o.$jg)(ie.code)?ie.code:ie.code?.value,Le.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(J.to),Le.tags=ie.tags&&(0,s.$Lb)(ie.tags.map(j.to)),Le}De.to=ve})(W||(e.Diagnostic=W={}));var J;(function(De){function Me(ie){return{...L.from(ie.location.range),message:ie.message,resource:ie.location.uri}}De.from=Me;function ve(ie){return new b.$sO(new b.$rO(ie.resource,L.to(ie)),ie.message)}De.to=ve})(J||(e.DiagnosticRelatedInformation=J={}));var B;(function(De){function Me(ie){switch(ie){case b.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}De.from=Me;function ve(ie){switch(ie){case r.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}De.to=ve})(B||(e.DiagnosticSeverity=B={}));var U;(function(De){function Me(ie){return typeof ie=="number"&&ie>=b.ViewColumn.One?ie-1:ie===b.ViewColumn.Beside?w.$UE:w.$TE}De.from=Me;function ve(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=ve})(U||(e.ViewColumn=U={}));function _(De){return typeof De.range<"u"}function x(De){return De.length===0?!0:!!_(De[0])}var oe;(function(De){function Me(Ge){return Ge.map(De.from)}De.fromMany=Me;function ve(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ie(Ge){let ut;if(ve(Ge)){const{language:Vt,value:qt}=Ge;ut={value:"```"+Vt+`
`+qt+"\n```\n"}}else b.$HO.isMarkdownString(Ge)?ut={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ut={value:Ge}:ut={value:""};const $t=Object.create(null);ut.uris=$t;const Gt=({href:Vt})=>{try{let qt=m.URI.parse(Vt,!0);qt=qt.with({query:Le(qt.query,$t)}),$t[Vt]=qt}catch{}return""};return p.marked.walkTokens(p.marked.lexer(ut.value),Vt=>{Vt.type==="link"?Gt({href:Vt.href}):Vt.type==="image"&&typeof Vt.href=="string"&&Gt(T.$el(Vt.href))}),ut}De.from=ie;function Le(Ge,ut){if(!Ge)return Ge;let $t;try{$t=(0,c.$gi)(Ge)}catch{}if(!$t)return Ge;let Gt=!1;return $t=(0,E.$oo)($t,Vt=>{if(m.URI.isUri(Vt)){const qt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[qt]=Vt,Gt=!0,qt}else return}),Gt?JSON.stringify($t):Ge}function Qe(Ge){const ut=new b.$HO(Ge.value,Ge.supportThemeIcons);return ut.isTrusted=Ge.isTrusted,ut.supportHtml=Ge.supportHtml,ut.baseUri=Ge.baseUri?m.URI.from(Ge.baseUri):void 0,ut}De.to=Qe;function rt(Ge){if(Ge)return typeof Ge=="string"?Ge:De.from(Ge)}De.fromStrict=rt})(oe||(e.MarkdownString=oe={}));function te(De){return x(De)?De.map(Me=>({range:L.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?oe.fromMany(Me.hoverMessage):Me.hoverMessage?oe.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):De.map(Me=>({range:L.from(Me)}))}function me(De){return typeof De>"u"?De:typeof De=="string"?m.URI.file(De):De}var ce;(function(De){function Me(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?me(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}De.from=Me})(ce||(e.ThemableDecorationAttachmentRenderOptions=ce={}));var Y;(function(De){function Me(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?me(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?ce.from(ve.before):void 0,after:ve.after?ce.from(ve.after):void 0}}De.from=Me})(Y||(e.ThemableDecorationRenderOptions=Y={}));var q;(function(De){function Me(ve){if(typeof ve>"u")return ve;switch(ve){case b.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}De.from=Me})(q||(e.DecorationRangeBehavior=q={}));var se;(function(De){function Me(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?q.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?Y.from(ve.light):void 0,dark:ve.dark?Y.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?me(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?ce.from(ve.before):void 0,after:ve.after?ce.from(ve.after):void 0}}De.from=Me})(se||(e.DecorationRenderOptions=se={}));var be;(function(De){function Me(ie){return{text:ie.newText,eol:ie.newEol&&ke.from(ie.newEol),range:L.from(ie.range)}}De.from=Me;function ve(ie){const Le=new b.$mO(L.to(ie.range),ie.text);return Le.newEol=typeof ie.eol>"u"?void 0:ke.to(ie.eol),Le}De.to=ve})(be||(e.TextEdit=be={}));var ae;(function(De){function Me(ie,Le){const Qe={edits:[]};if(ie instanceof b.$pO){const rt=new A.$Gc;for(const Ge of ie._allEntries())Ge._type===b.FileEditType.File&&m.URI.isUri(Ge.to)&&Ge.from===void 0&&rt.add(Ge.to);for(const Ge of ie._allEntries())if(Ge._type===b.FileEditType.File){let ut;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ut={type:"base64",value:(0,h.$af)(h.$Se.wrap(Ge.options.contents))}:ut={type:"dataTransferItem",id:Ge.options.contents._itemId}),Qe.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ut},metadata:Ge.metadata})}else Ge._type===b.FileEditType.Text?Qe.edits.push({resource:Ge.uri,textEdit:be.from(Ge.edit),versionId:rt.has(Ge.uri)?void 0:Le?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Snippet?Qe.edits.push({resource:Ge.uri,textEdit:{range:L.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:rt.has(Ge.uri)?void 0:Le?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Cell?Qe.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===b.FileEditType.CellReplace&&Qe.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Le?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:S.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(tt.from)}})}return Qe}De.from=Me;function ve(ie){const Le=new b.$pO,Qe=new A.$Fc;for(const rt of ie.edits)if(rt.textEdit){const Ge=rt,ut=m.URI.revive(Ge.resource),$t=L.to(Ge.textEdit.range),Gt=Ge.textEdit.text,Vt=Ge.textEdit.insertAsSnippet;let qt;Vt?qt=b.$oO.replace($t,new b.$qO(Gt)):qt=b.$mO.replace($t,Gt);const Li=Qe.get(ut);Li?Li.push(qt):Qe.set(ut,[qt])}else Le.renameFile(m.URI.revive(rt.oldResource),m.URI.revive(rt.newResource),rt.options);for(const[rt,Ge]of Qe)Le.set(rt,Ge);return Le}De.to=ve})(ae||(e.WorkspaceEdit=ae={}));var we;(function(De){const Me=Object.create(null);Me[b.SymbolKind.File]=a.SymbolKind.File,Me[b.SymbolKind.Module]=a.SymbolKind.Module,Me[b.SymbolKind.Namespace]=a.SymbolKind.Namespace,Me[b.SymbolKind.Package]=a.SymbolKind.Package,Me[b.SymbolKind.Class]=a.SymbolKind.Class,Me[b.SymbolKind.Method]=a.SymbolKind.Method,Me[b.SymbolKind.Property]=a.SymbolKind.Property,Me[b.SymbolKind.Field]=a.SymbolKind.Field,Me[b.SymbolKind.Constructor]=a.SymbolKind.Constructor,Me[b.SymbolKind.Enum]=a.SymbolKind.Enum,Me[b.SymbolKind.Interface]=a.SymbolKind.Interface,Me[b.SymbolKind.Function]=a.SymbolKind.Function,Me[b.SymbolKind.Variable]=a.SymbolKind.Variable,Me[b.SymbolKind.Constant]=a.SymbolKind.Constant,Me[b.SymbolKind.String]=a.SymbolKind.String,Me[b.SymbolKind.Number]=a.SymbolKind.Number,Me[b.SymbolKind.Boolean]=a.SymbolKind.Boolean,Me[b.SymbolKind.Array]=a.SymbolKind.Array,Me[b.SymbolKind.Object]=a.SymbolKind.Object,Me[b.SymbolKind.Key]=a.SymbolKind.Key,Me[b.SymbolKind.Null]=a.SymbolKind.Null,Me[b.SymbolKind.EnumMember]=a.SymbolKind.EnumMember,Me[b.SymbolKind.Struct]=a.SymbolKind.Struct,Me[b.SymbolKind.Event]=a.SymbolKind.Event,Me[b.SymbolKind.Operator]=a.SymbolKind.Operator,Me[b.SymbolKind.TypeParameter]=a.SymbolKind.TypeParameter;function ve(Le){return typeof Me[Le]=="number"?Me[Le]:a.SymbolKind.Property}De.from=ve;function ie(Le){for(const Qe in Me)if(Me[Qe]===Le)return Number(Qe);return b.SymbolKind.Property}De.to=ie})(we||(e.SymbolKind=we={}));var $e;(function(De){function Me(ie){switch(ie){case b.SymbolTag.Deprecated:return a.SymbolTag.Deprecated}}De.from=Me;function ve(ie){switch(ie){case a.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}De.to=ve})($e||(e.SymbolTag=$e={}));var pe;(function(De){function Me(ie){return{name:ie.name,kind:we.from(ie.kind),tags:ie.tags&&ie.tags.map($e.from),containerName:ie.containerName,location:xe.from(ie.location)}}De.from=Me;function ve(ie){const Le=new b.$yO(ie.name,we.to(ie.kind),ie.containerName,xe.to(ie.location));return Le.tags=ie.tags&&ie.tags.map($e.to),Le}De.to=ve})(pe||(e.WorkspaceSymbol=pe={}));var Oe;(function(De){function Me(ie){const Le={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:L.from(ie.range),selectionRange:L.from(ie.selectionRange),kind:we.from(ie.kind),tags:ie.tags?.map($e.from)??[]};return ie.children&&(Le.children=ie.children.map(Me)),Le}De.from=Me;function ve(ie){const Le=new b.$zO(ie.name,ie.detail,we.to(ie.kind),L.to(ie.range),L.to(ie.selectionRange));return(0,s.$Pb)(ie.tags)&&(Le.tags=ie.tags.map($e.to)),ie.children&&(Le.children=ie.children.map(ve)),Le}De.to=ve})(Oe||(e.DocumentSymbol=Oe={}));var Fe;(function(De){function Me(ie){const Le=new b.$DO(we.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),L.to(ie.range),L.to(ie.selectionRange));return Le._sessionId=ie._sessionId,Le._itemId=ie._itemId,Le}De.to=Me;function ve(ie,Le,Qe){if(Le=Le??ie._sessionId,Qe=Qe??ie._itemId,Le===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Qe,name:ie.name,detail:ie.detail,kind:we.from(ie.kind),uri:ie.uri,range:L.from(ie.range),selectionRange:L.from(ie.selectionRange),tags:ie.tags?.map($e.from)}}De.from=ve})(Fe||(e.CallHierarchyItem=Fe={}));var He;(function(De){function Me(ve){return new b.$EO(Fe.to(ve.from),ve.fromRanges.map(ie=>L.to(ie)))}De.to=Me})(He||(e.CallHierarchyIncomingCall=He={}));var Ze;(function(De){function Me(ve){return new b.$FO(Fe.to(ve.to),ve.fromRanges.map(ie=>L.to(ie)))}De.to=Me})(Ze||(e.CallHierarchyOutgoingCall=Ze={}));var xe;(function(De){function Me(ie){return{range:ie.range&&L.from(ie.range),uri:ie.uri}}De.from=Me;function ve(ie){return new b.$rO(m.URI.revive(ie.uri),L.to(ie.range))}De.to=ve})(xe||(e.location=xe={}));var je;(function(De){function Me(ie){const Le=ie,Qe=ie;return{originSelectionRange:Le.originSelectionRange?L.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Qe.uri,range:L.from(Le.targetRange?Le.targetRange:Qe.range),targetSelectionRange:Le.targetSelectionRange?L.from(Le.targetSelectionRange):void 0}}De.from=Me;function ve(ie){return{targetUri:m.URI.revive(ie.uri),targetRange:L.to(ie.range),targetSelectionRange:ie.targetSelectionRange?L.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?L.to(ie.originSelectionRange):void 0}}De.to=ve})(je||(e.DefinitionLink=je={}));var qe;(function(De){function Me(ie){return{range:L.from(ie.range),contents:oe.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}De.from=Me;function ve(ie){const Le=ie.contents.map(oe.to),Qe=L.to(ie.range),rt=ie.canIncreaseVerbosity,Ge=ie.canDecreaseVerbosity;return new b.$vO(Le,Qe,rt,Ge)}De.to=ve})(qe||(e.Hover=qe={}));var Ne;(function(De){function Me(ie){return{range:L.from(ie.range),expression:ie.expression}}De.from=Me;function ve(ie){return new b.$qP(L.to(ie.range),ie.expression)}De.to=ve})(Ne||(e.EvaluatableExpression=Ne={}));var H;(function(De){function Me(ie){if(ie instanceof b.$rP)return{type:"text",range:L.from(ie.range),text:ie.text};if(ie instanceof b.$sP)return{type:"variable",range:L.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof b.$tP)return{type:"expression",range:L.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Me;function ve(ie){switch(ie.type){case"text":return{range:L.to(ie.range),text:ie.text};case"variable":return{range:L.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:L.to(ie.range),expression:ie.expression}}}De.to=ve})(H||(e.InlineValue=H={}));var G;(function(De){function Me(ie){return{frameId:ie.frameId,stoppedLocation:L.from(ie.stoppedLocation)}}De.from=Me;function ve(ie){return new b.$uP(ie.frameId,L.to(ie.stoppedLocation))}De.to=ve})(G||(e.InlineValueContext=G={}));var Z;(function(De){function Me(ie){return{range:L.from(ie.range),kind:ie.kind}}De.from=Me;function ve(ie){return new b.$wO(L.to(ie.range),ie.kind)}De.to=ve})(Z||(e.DocumentHighlight=Z={}));var ee;(function(De){function Me(ie){return{uri:ie.uri,highlights:ie.highlights.map(Z.from)}}De.from=Me;function ve(ie){return new b.$xO(m.URI.revive(ie.uri),ie.highlights.map(Z.to))}De.to=ve})(ee||(e.MultiDocumentHighlight=ee={}));var ue;(function(De){function Me(ve){switch(ve){case a.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case a.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case a.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}De.to=Me})(ue||(e.CompletionTriggerKind=ue={}));var ye;(function(De){function Me(ve){return{triggerKind:ue.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}De.to=Me})(ye||(e.CompletionContext=ye={}));var Ae;(function(De){function Me(ie){switch(ie){case b.CompletionItemTag.Deprecated:return a.CompletionItemTag.Deprecated}}De.from=Me;function ve(ie){switch(ie){case a.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}De.to=ve})(Ae||(e.CompletionItemTag=Ae={}));var Ve;(function(De){const Me=new Map([[b.CompletionItemKind.Method,a.CompletionItemKind.Method],[b.CompletionItemKind.Function,a.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,a.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,a.CompletionItemKind.Field],[b.CompletionItemKind.Variable,a.CompletionItemKind.Variable],[b.CompletionItemKind.Class,a.CompletionItemKind.Class],[b.CompletionItemKind.Interface,a.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,a.CompletionItemKind.Struct],[b.CompletionItemKind.Module,a.CompletionItemKind.Module],[b.CompletionItemKind.Property,a.CompletionItemKind.Property],[b.CompletionItemKind.Unit,a.CompletionItemKind.Unit],[b.CompletionItemKind.Value,a.CompletionItemKind.Value],[b.CompletionItemKind.Constant,a.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,a.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,a.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,a.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,a.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,a.CompletionItemKind.Text],[b.CompletionItemKind.Color,a.CompletionItemKind.Color],[b.CompletionItemKind.File,a.CompletionItemKind.File],[b.CompletionItemKind.Reference,a.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,a.CompletionItemKind.Folder],[b.CompletionItemKind.Event,a.CompletionItemKind.Event],[b.CompletionItemKind.Operator,a.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,a.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,a.CompletionItemKind.Issue],[b.CompletionItemKind.User,a.CompletionItemKind.User]]);function ve(Qe){return Me.get(Qe)??a.CompletionItemKind.Property}De.from=ve;const ie=new Map([[a.CompletionItemKind.Method,b.CompletionItemKind.Method],[a.CompletionItemKind.Function,b.CompletionItemKind.Function],[a.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[a.CompletionItemKind.Field,b.CompletionItemKind.Field],[a.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[a.CompletionItemKind.Class,b.CompletionItemKind.Class],[a.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[a.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[a.CompletionItemKind.Module,b.CompletionItemKind.Module],[a.CompletionItemKind.Property,b.CompletionItemKind.Property],[a.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[a.CompletionItemKind.Value,b.CompletionItemKind.Value],[a.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[a.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[a.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[a.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[a.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[a.CompletionItemKind.Text,b.CompletionItemKind.Text],[a.CompletionItemKind.Color,b.CompletionItemKind.Color],[a.CompletionItemKind.File,b.CompletionItemKind.File],[a.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[a.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[a.CompletionItemKind.Event,b.CompletionItemKind.Event],[a.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[a.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[a.CompletionItemKind.User,b.CompletionItemKind.User],[a.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function Le(Qe){return ie.get(Qe)??b.CompletionItemKind.Property}De.to=Le})(Ve||(e.CompletionItemKind=Ve={}));var Je;(function(De){function Me(ve,ie){const Le=new b.$NO(ve.label);return Le.insertText=ve.insertText,Le.kind=Ve.to(ve.kind),Le.tags=ve.tags?.map(Ae.to),Le.detail=ve.detail,Le.documentation=T.$$k(ve.documentation)?oe.to(ve.documentation):ve.documentation,Le.sortText=ve.sortText,Le.filterText=ve.filterText,Le.preselect=ve.preselect,Le.commitCharacters=ve.commitCharacters,d.$Yt.isIRange(ve.range)?Le.range=L.to(ve.range):typeof ve.range=="object"&&(Le.range={inserting:L.to(ve.range.insert),replacing:L.to(ve.range.replace)}),Le.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&a.CompletionItemInsertTextRule.KeepWhitespace),typeof ve.insertTextRules<"u"&&ve.insertTextRules&a.CompletionItemInsertTextRule.InsertAsSnippet?Le.insertText=new b.$qO(ve.insertText):(Le.insertText=ve.insertText,Le.textEdit=Le.range instanceof b.$fO?new b.$mO(Le.range,Le.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Le.additionalTextEdits=ve.additionalTextEdits.map(Qe=>be.to(Qe))),Le.command=ie&&ve.command?ie.fromInternal(ve.command):void 0,Le}De.to=Me})(Je||(e.CompletionItem=Je={}));var nt;(function(De){function Me(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:oe.fromStrict(ie.documentation)}}De.from=Me;function ve(ie){return{label:ie.label,documentation:T.$$k(ie.documentation)?oe.to(ie.documentation):ie.documentation}}De.to=ve})(nt||(e.ParameterInformation=nt={}));var ot;(function(De){function Me(ie){return{label:ie.label,documentation:oe.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(nt.from):[],activeParameter:ie.activeParameter}}De.from=Me;function ve(ie){return{label:ie.label,documentation:T.$$k(ie.documentation)?oe.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(nt.to):[],activeParameter:ie.activeParameter}}De.to=ve})(ot||(e.SignatureInformation=ot={}));var ht;(function(De){function Me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(ot.from):[]}}De.from=Me;function ve(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(ot.to):[]}}De.to=ve})(ht||(e.SignatureHelp=ht={}));var at;(function(De){function Me(ve,ie){const Le=new b.$MO(V.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(lt.to.bind(void 0,ve)),ie.kind&&pt.to(ie.kind));return Le.textEdits=ie.textEdits&&ie.textEdits.map(be.to),Le.tooltip=T.$$k(ie.tooltip)?oe.to(ie.tooltip):ie.tooltip,Le.paddingLeft=ie.paddingLeft,Le.paddingRight=ie.paddingRight,Le}De.to=Me})(at||(e.InlayHint=at={}));var lt;(function(De){function Me(ve,ie){const Le=new b.$LO(ie.label);return Le.tooltip=T.$$k(ie.tooltip)?oe.to(ie.tooltip):ie.tooltip,a.Command.is(ie.command)&&(Le.command=ve.fromInternal(ie.command)),ie.location&&(Le.location=xe.to(ie.location)),Le}De.to=Me})(lt||(e.InlayHintLabelPart=lt={}));var pt;(function(De){function Me(ie){return ie}De.from=Me;function ve(ie){return ie}De.to=ve})(pt||(e.InlayHintKind=pt={}));var it;(function(De){function Me(ie){return{range:L.from(ie.range),url:ie.target,tooltip:ie.tooltip}}De.from=Me;function ve(ie){let Le;if(ie.url)try{Le=typeof ie.url=="string"?m.URI.parse(ie.url,!0):m.URI.revive(ie.url)}catch{}const Qe=new b.$SO(L.to(ie.range),Le);return Qe.tooltip=ie.tooltip,Qe}De.to=ve})(it||(e.DocumentLink=it={}));var Ie;(function(De){function Me(ie){const Le=new b.$VO(ie.label);return ie.textEdit&&(Le.textEdit=be.to(ie.textEdit)),ie.additionalTextEdits&&(Le.additionalTextEdits=ie.additionalTextEdits.map(Qe=>be.to(Qe))),Le}De.to=Me;function ve(ie){return{label:ie.label,textEdit:ie.textEdit?be.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Le=>be.from(Le)):void 0}}De.from=ve})(Ie||(e.ColorPresentation=Ie={}));var re;(function(De){function Me(ie){return new b.$TO(ie[0],ie[1],ie[2],ie[3])}De.to=Me;function ve(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}De.from=ve})(re||(e.Color=re={}));var le;(function(De){function Me(ie){return{range:L.from(ie.range)}}De.from=Me;function ve(ie){return new b.$CO(L.to(ie.range))}De.to=ve})(le||(e.SelectionRange=le={}));var Se;(function(De){function Me(ve){switch(ve){case l.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}De.to=Me})(Se||(e.TextDocumentSaveReason=Se={}));var de;(function(De){function Me(ie){switch(ie){case b.TextEditorLineNumbersStyle.Off:return $.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return $.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return $.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return $.RenderLineNumbersType.On}}De.from=Me;function ve(ie){switch(ie){case $.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case $.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case $.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case $.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}De.to=ve})(de||(e.TextEditorLineNumbersStyle=de={}));var ke;(function(De){function Me(ie){if(ie===b.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(ie===b.EndOfLine.LF)return t.EndOfLineSequence.LF}De.from=Me;function ve(ie){if(ie===t.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(ie===t.EndOfLineSequence.LF)return b.EndOfLine.LF}De.to=ve})(ke||(e.EndOfLine=ke={}));var ne;(function(De){function Me(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case b.ProgressLocation.SourceControl:return n.ProgressLocation.Scm;case b.ProgressLocation.Window:return n.ProgressLocation.Window;case b.ProgressLocation.Notification:return n.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}De.from=Me})(ne||(e.ProgressLocation=ne={}));var X;(function(De){function Me(ie){const Le={start:ie.start+1,end:ie.end+1};return ie.kind&&(Le.kind=Pe.from(ie.kind)),Le}De.from=Me;function ve(ie){const Le={start:ie.start-1,end:ie.end-1};return ie.kind&&(Le.kind=Pe.to(ie.kind)),Le}De.to=ve})(X||(e.FoldingRange=X={}));var Pe;(function(De){function Me(ie){if(ie)switch(ie){case b.FoldingRangeKind.Comment:return a.$Zu.Comment;case b.FoldingRangeKind.Imports:return a.$Zu.Imports;case b.FoldingRangeKind.Region:return a.$Zu.Region}}De.from=Me;function ve(ie){if(ie)switch(ie.value){case a.$Zu.Comment.value:return b.FoldingRangeKind.Comment;case a.$Zu.Imports.value:return b.FoldingRangeKind.Imports;case a.$Zu.Region.value:return b.FoldingRangeKind.Region}}De.to=ve})(Pe||(e.FoldingRangeKind=Pe={}));var Ke;(function(De){function Me(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?L.from(ve.selection):void 0,override:typeof ve.override=="boolean"?l.$lG.id:void 0}}De.from=Me})(Ke||(e.TextEditorOpenOptions=Ke={}));var Xe;(function(De){function Me(Qe){return Qe instanceof b.$eP?Qe.toJSON():typeof Qe=="string"?Qe:ve(Qe)||ie(Qe)?new b.$eP(Qe.baseUri??Qe.base,Qe.pattern).toJSON():Qe}De.from=Me;function ve(Qe){const rt=Qe;return rt?m.URI.isUri(rt.baseUri)&&typeof rt.pattern=="string":!1}function ie(Qe){const rt=Qe;return rt?typeof rt.base=="string"&&typeof rt.pattern=="string":!1}function Le(Qe){return typeof Qe=="string"?Qe:new b.$eP(m.URI.revive(Qe.baseUri),Qe.pattern)}De.to=Le})(Xe||(e.GlobPattern=Xe={}));var st;(function(De){function Me(ve){if(ve){if(Array.isArray(ve))return ve.map(Me);if(typeof ve=="string")return ve;{const ie=ve;return{language:ie.language,scheme:ie.scheme,pattern:Xe.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}De.from=Me})(st||(e.LanguageSelector=st={}));var dt;(function(De){function Me(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Le=>Array.isArray(Le)&&Le.every(Qe=>Qe&&typeof Qe=="object"&&"uri"in Qe&&m.URI.isUri(Qe.uri)&&"version"in Qe&&typeof Qe.version=="number"&&"ranges"in Qe&&Array.isArray(Qe.ranges)&&Qe.ranges.every(rt=>rt instanceof b.$fO)))}De.is=Me;function ve(ie){return{documents:ie.documents.map(Le=>Le.map(Qe=>({uri:m.URI.from(Qe.uri),version:Qe.version,ranges:Qe.ranges.map(rt=>L.from(rt))})))}}De.from=ve})(dt||(e.MappedEditsContext=dt={}));var gt;(function(De){function Me(ie){return{start:ie.start,end:ie.end}}De.from=Me;function ve(ie){return new b.$HP(ie.start,ie.end)}De.to=ve})(gt||(e.NotebookRange=gt={}));var kt;(function(De){function Me(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}De.to=Me;function ve(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}De.from=ve})(kt||(e.NotebookCellExecutionSummary=kt={}));var At;(function(De){function Me(ve){if(ve===S.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(ve===S.NotebookCellExecutionState.Pending)return;if(ve===S.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}De.to=Me})(At||(e.NotebookCellExecutionState=At={}));var Kt;(function(De){function Me(ie){switch(ie){case b.NotebookCellKind.Markup:return S.CellKind.Markup;case b.NotebookCellKind.Code:default:return S.CellKind.Code}}De.from=Me;function ve(ie){switch(ie){case S.CellKind.Markup:return b.NotebookCellKind.Markup;case S.CellKind.Code:default:return b.NotebookCellKind.Code}}De.to=ve})(Kt||(e.NotebookCellKind=Kt={}));var ei;(function(De){function Me(ie){const Le={metadata:ie.metadata??Object.create(null),cells:[]};for(const Qe of ie.cells)b.$IP.validate(Qe),Le.cells.push(tt.from(Qe));return Le}De.from=Me;function ve(ie){const Le=new b.$JP(ie.cells.map(tt.to));return(0,o.$wg)(ie.metadata)||(Le.metadata=ie.metadata),Le}De.to=ve})(ei||(e.NotebookData=ei={}));var tt;(function(De){function Me(ie){return{cellKind:Kt.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:kt.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(zt.from):[]}}De.from=Me;function ve(ie){return new b.$IP(Kt.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(zt.to):void 0,ie.metadata,ie.internalMetadata?kt.to(ie.internalMetadata):void 0)}De.to=ve})(tt||(e.NotebookCellData=tt={}));var Tt;(function(De){function Me(ie){return{mime:ie.mime,valueBytes:h.$Se.wrap(ie.data)}}De.from=Me;function ve(ie){return new b.$KP(ie.valueBytes.buffer,ie.mime)}De.to=ve})(Tt||(e.NotebookCellOutputItem=Tt={}));var zt;(function(De){function Me(ie){return{outputId:ie.id,items:ie.items.map(Tt.from),metadata:ie.metadata}}De.from=Me;function ve(ie){const Le=ie.items.map(Tt.to);return new b.$LP(Le,ie.outputId,ie.metadata)}De.to=ve})(zt||(e.NotebookCellOutput=zt={}));var wt;(function(De){function Me(Le){return ie(Le)?{include:Xe.from(Le.include)??void 0,exclude:Xe.from(Le.exclude)??void 0}:Xe.from(Le)??void 0}De.from=Me;function ve(Le){return ie(Le)?{include:Xe.to(Le.include),exclude:Xe.to(Le.exclude)}:Xe.to(Le)}De.to=ve;function ie(Le){const Qe=Le;return Qe?!(0,o.$sg)(Qe.include)&&!(0,o.$sg)(Qe.exclude):!1}})(wt||(e.NotebookExclusiveDocumentPattern=wt={}));var Rt;(function(De){function Me(ve,ie,Le){const Qe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===b.NotebookCellStatusBarAlignment.Left?S.CellStatusbarAlignment.Left:S.CellStatusbarAlignment.Right,command:ie.toInternal(Qe,Le),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}De.from=Me})(Rt||(e.NotebookStatusBarItem=Rt={}));var ti;(function(De){function Me(ve,ie,Le){const Qe=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:ie.toInternal(Qe,Le),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}De.from=Me})(ti||(e.NotebookKernelSourceAction=ti={}));var ii;(function(De){function Me(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}De.from=Me})(ii||(e.NotebookDocumentContentOptions=ii={}));var Qt;(function(De){function Me(ie){return{uri:ie.uri,provides:ie.provides}}De.from=Me;function ve(ie){return new b.$NP(m.URI.revive(ie.uri),ie.provides)}De.to=ve})(Qt||(e.NotebookRendererScript=Qt={}));var vt;(function(De){function Me(ie){return{message:oe.fromStrict(ie.message)||"",type:C.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:L.from(ie.location.range),uri:ie.location.uri},stackTrace:ie.stackTrace?.map(Le=>({label:Le.label,position:Le.position&&V.from(Le.position),uri:Le.uri&&m.URI.revive(Le.uri).toJSON()}))}}De.from=Me;function ve(ie){const Le=new b.$TP(typeof ie.message=="string"?ie.message:oe.to(ie.message));return Le.actualOutput=ie.actual,Le.expectedOutput=ie.expected,Le.contextValue=ie.contextValue,Le.location=ie.location?xe.to(ie.location):void 0,Le}De.to=ve})(vt||(e.TestMessage=vt={}));var Lt;(function(De){De.namespace=C.$yJ,De.denamespace=C.$zJ})(Lt||(e.TestTag=Lt={}));var ci;(function(De){function Me(ie){const Le=(0,u.$KQ)(ie).controllerId;return{extId:R.$tJ.fromExtHostTestItem(ie,Le).toString(),label:ie.label,uri:m.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(Qe=>Lt.namespace(Le,Qe.id)),range:d.$Yt.lift(L.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&oe.fromStrict(ie.error)||null}}De.from=Me;function ve(ie){return{parent:void 0,error:void 0,id:R.$tJ.fromString(ie.extId).localId,label:ie.label,uri:m.URI.revive(ie.uri),tags:(ie.tags||[]).map(Le=>{const{tagId:Qe}=Lt.denamespace(Le);return new b.$UP(Qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:L.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}De.toPlain=ve})(ci||(e.TestItem=ci={})),function(De){function Me(ie){return{id:ie.id}}De.from=Me;function ve(ie){return new b.$UP(ie.id)}De.to=ve}(Lt||(e.TestTag=Lt={}));var Zt;(function(De){const Me=(ie,Le)=>{const Qe=ie.value;if(!Qe)return;const rt={...ci.toPlain(Qe.item),parent:Le,taskStates:Qe.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ut=>ut.type===C.TestMessageType.Error).map(vt.to)})),children:[]};if(ie.children)for(const Ge of ie.children.values()){const ut=Me(Ge,rt);ut&&rt.children.push(ut)}return rt};function ve(ie){const Le=new f.$sJ;for(const Ge of ie.items)Le.insert(R.$tJ.fromString(Ge.item.extId).path,Ge);const Qe=[Le.nodes],rt=[];for(;Qe.length;)for(const Ge of Qe.pop())Ge.value?rt.push(Ge):Ge.children&&Qe.push(Ge.children.values());return{completedAt:ie.completedAt,results:rt.map(Ge=>Me(Ge)).filter(o.$rg)}}De.to=ve})(Zt||(e.TestResults=Zt={}));var et;(function(De){function Me(Ge){return{covered:Ge.covered,total:Ge.total}}function ve(Ge){return"line"in Ge?V.from(Ge):L.from(Ge)}function ie(Ge){if(Ge)return"endLineNumber"in Ge?L.to(Ge):V.to(Ge)}function Le(Ge){if(Ge.type===C.DetailType.Statement){const ut=[];if(Ge.branches)for(const $t of Ge.branches)ut.push({executed:$t.count,location:ie($t.location),label:$t.label});return new b.$ZP(Ge.count,ie(Ge.location),Ge.branches?.map($t=>new b.$1P($t.count,ie($t.location),$t.label)))}else return new b.$2P(Ge.name,Ge.count,ie(Ge.location))}De.to=Le;function Qe(Ge){if(typeof Ge.executed=="number"&&Ge.executed<0)throw new Error(`Invalid coverage count ${Ge.executed}`);return"branches"in Ge?{count:Ge.executed,location:ve(Ge.location),type:C.DetailType.Statement,branches:Ge.branches.length?Ge.branches.map(ut=>({count:ut.executed,location:ut.location&&ve(ut.location),label:ut.label})):void 0}:{type:C.DetailType.Declaration,name:Ge.name,count:Ge.executed,location:ve(Ge.location)}}De.fromDetails=Qe;function rt(Ge,ut,$t){return b.$XP($t.statementCoverage),b.$XP($t.branchCoverage),b.$XP($t.declarationCoverage),{id:ut,uri:$t.uri,statement:Me($t.statementCoverage),branch:$t.branchCoverage&&Me($t.branchCoverage),declaration:$t.declarationCoverage&&Me($t.declarationCoverage),testIds:$t instanceof b.$YP&&$t.fromTests.length?$t.fromTests.map(Gt=>R.$tJ.fromExtHostTestItem(Gt,Ge).toString()):void 0}}De.fromFile=rt})(et||(e.TestCoverage=et={}));var ni;(function(De){function Me(ve){switch(ve){case a.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case a.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}De.to=Me})(ni||(e.CodeActionTriggerKind=ni={}));var li;(function(De){function Me(ie){const Le=new b.$3P(we.to(ie.kind),ie.name,ie.detail||"",m.URI.revive(ie.uri),L.to(ie.range),L.to(ie.selectionRange));return Le._sessionId=ie._sessionId,Le._itemId=ie._itemId,Le}De.to=Me;function ve(ie,Le,Qe){if(Le=Le??ie._sessionId,Qe=Qe??ie._itemId,Le===void 0||Qe===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Qe,kind:we.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:L.from(ie.range),selectionRange:L.from(ie.selectionRange),tags:ie.tags?.map($e.from)}}De.from=ve})(li||(e.TypeHierarchyItem=li={}));var hi;(function(De){function Me(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}De.from=Me})(hi||(e.ViewBadge=hi={}));var It;(function(De){function Me(Qe,rt,Ge){const ut=rt.fileData;return ut?new b.$9O(new b.$0O(ut.name,m.URI.revive(ut.uri),ut.id,(0,O.$hb)(()=>Ge(ut.id)))):Qe===I.$it.uriList&&rt.uriListData?new b.$8O(Le(rt.uriListData)):new b.$8O(rt.asString)}De.to=Me;async function ve(Qe,rt){const Ge=await rt.asString();if(Qe===I.$it.uriList)return{asString:Ge,fileData:void 0,uriListData:ie(Ge)};const ut=rt.asFile();return{asString:Ge,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}De.from=ve;function ie(Qe){return D.$Du.split(Qe).map(rt=>{if(rt.startsWith("#"))return rt;try{return m.URI.parse(rt)}catch{}return rt})}function Le(Qe){return D.$Du.create(Qe.map(rt=>typeof rt=="string"?rt:m.URI.revive(rt)))}})(It||(e.DataTransferItem=It={}));var Ut;(function(De){function Me(ie,Le){const Qe=ie.items.map(([rt,Ge])=>[rt,It.to(rt,Ge,Le)]);return new b.$$O(Qe)}De.toDataTransfer=Me;async function ve(ie){const Le={items:[]},Qe=[];for(const[rt,Ge]of ie)Qe.push((async()=>{Le.items.push([rt,await It.from(rt,Ge)])})());return await Promise.all(Qe),Le}De.from=ve})(Ut||(e.DataTransfer=Ut={}));var Nt;(function(De){function Me(ie,Le){return{kind:"reply",agentId:ie.participant??Le?.agentId??"",subCommand:ie.command??Le?.command,message:ie.prompt,title:ie.label}}De.from=Me;function ve(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}De.to=ve})(Nt||(e.ChatFollowup=Nt={}));var Bt;(function(De){function Me(ie){switch(ie){case y.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case y.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case y.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}De.to=Me;function ve(ie){switch(ie){case b.LanguageModelChatMessageRole.System:return y.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return y.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return y.ChatMessageRole.Assistant}return y.ChatMessageRole.User}De.from=ve})(Bt||(e.LanguageModelChatMessageRole=Bt={}));var ai;(function(De){function Me(ie){const Le=ie.content.map(ut=>ut.type==="text"?ut.value:ut.type==="tool_result"?new b.$vQ(ut.toolCallId,ut.value,ut.isError):new b.$xQ(ut.name,ut.toolCallId,ut.parameters)),Qe=Le.find(ut=>typeof ut=="string")??"",rt=Bt.to(ie.role),Ge=new b.$wQ(rt,Qe,ie.name);return Ge.content2=Le,Ge}De.to=Me;function ve(ie){const Le=Bt.from(ie.role),Qe=ie.name,rt=ie.content2.map(Ge=>{if(Ge instanceof b.$vQ)return{type:"tool_result",toolCallId:Ge.toolCallId,value:Ge.content,isError:Ge.isError};if(Ge instanceof b.$xQ)return{type:"tool_use",toolCallId:Ge.toolCallId,name:Ge.name,parameters:Ge.parameters};if(typeof Ge!="string")throw new Error("Unexpected chat message content type");return{type:"text",value:Ge}});return{role:Le,name:Qe,content:rt}}De.from=ve})(ai||(e.LanguageModelChatMessage=ai={}));var ri;(function(De){function Me(ie){return{kind:"markdownContent",content:oe.from(ie.value)}}De.from=Me;function ve(ie){return new b.$dQ(oe.to(ie.content))}De.to=ve})(ri||(e.ChatResponseMarkdownPart=ri={}));var si;(function(De){function Me(ie){return{kind:"markdownVuln",content:oe.from(ie.value),vulnerabilities:ie.vulnerabilities}}De.from=Me;function ve(ie){return new b.$eQ(oe.to(ie.content),ie.vulnerabilities)}De.to=ve})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var Jt;(function(De){function Me(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}De.from=Me;function ve(ie){return new b.$fQ(ie.agentId,ie.command)}De.to=ve})(Jt||(e.ChatResponseDetectedParticipantPart=Jt={}));var Xt;(function(De){function Me(ve){return{kind:"confirmation",title:ve.title,message:ve.message,data:ve.data,buttons:ve.buttons}}De.from=Me})(Xt||(e.ChatResponseConfirmationPart=Xt={}));var ui;(function(De){function Me(ie){const{value:Le,baseUri:Qe}=ie;function rt(Ge,ut){return Ge.map($t=>{const Gt=m.URI.joinPath(ut,$t.name);return{label:$t.name,uri:Gt,children:$t.children&&rt($t.children,Gt)}})}return{kind:"treeData",treeData:{label:(0,P.$ih)(Qe),uri:Qe,children:rt(Le,Qe)}}}De.from=Me;function ve(ie){const Le=(0,c.$hi)(ie.treeData);function Qe(ut){return ut.map($t=>({name:$t.label,children:$t.children&&Qe($t.children)}))}const rt=Le.uri,Ge=Le.children?Qe(Le.children):[];return new b.$hQ(Ge,rt)}De.to=ve})(ui||(e.ChatResponseFilesPart=ui={}));var Mt;(function(De){function Me(ie){const Le=Qe=>m.URI.isUri(Qe);return{kind:"inlineReference",name:ie.title,inlineReference:Le(ie.value)?ie.value:M.from(ie.value)}}De.from=Me;function ve(ie){const Le=(0,c.$hi)(ie);return new b.$iQ(m.URI.isUri(Le.inlineReference)?Le.inlineReference:M.to(Le.inlineReference),ie.name)}De.to=ve})(Mt||(e.ChatResponseAnchorPart=Mt={}));var Ct;(function(De){function Me(ie){return{kind:"progressMessage",content:oe.from(ie.value)}}De.from=Me;function ve(ie){return new b.$jQ(ie.content.value)}De.to=ve})(Ct||(e.ChatResponseProgressPart=Ct={}));var yt;(function(De){function Me(ie){return{kind:"warning",content:oe.from(ie.value)}}De.from=Me;function ve(ie){return new b.$lQ(ie.content.value)}De.to=ve})(yt||(e.ChatResponseWarningPart=yt={}));var Yt;(function(De){function Me(ie){return{kind:"move",uri:ie.uri,range:L.from(ie.range)}}De.from=Me;function ve(ie){return new b.$pQ(m.URI.revive(ie.uri),L.to(ie.range))}De.to=ve})(Yt||(e.ChatResponseMovePart=Yt={}));var St;(function(De){function Me(ve){return{kind:"progressTask",content:oe.from(ve.value)}}De.from=Me})(St||(e.ChatTask=St={}));var oi;(function(De){function Me(ve){return{kind:"progressTaskResult",content:typeof ve=="string"?oe.from(ve):void 0}}De.from=Me})(oi||(e.ChatTaskResult=oi={}));var xt;(function(De){function Me(ie,Le,Qe){return{kind:"command",command:Le.toInternal(ie.value,Qe)??{command:ie.value.command,title:ie.value.title}}}De.from=Me;function ve(ie,Le){return new b.$mQ(Le.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}De.to=ve})(xt||(e.ChatResponseCommandButtonPart=xt={}));var Mi;(function(De){function Me(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Le=>be.from(Le))}}De.from=Me;function ve(ie){return new b.$qQ(m.URI.revive(ie.uri),ie.edits.map(Le=>be.to(Le)))}De.to=ve})(Mi||(e.ChatResponseTextEditPart=Mi={}));var di;(function(De){function Me(ie){const Le=v.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:m.URI.isUri(ie.iconPath)?{light:m.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&m.URI.isUri(ie.iconPath.light)&&m.URI.isUri(ie.iconPath.dark)?{light:m.URI.revive(ie.iconPath.light),dark:m.URI.revive(ie.iconPath.dark)}:void 0;return typeof ie.value=="object"&&"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:m.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:M.from(ie.value.value)},iconPath:Le,options:ie.options}:{kind:"reference",reference:m.URI.isUri(ie.value)||typeof ie.value=="string"?ie.value:M.from(ie.value),iconPath:Le,options:ie.options}}De.from=Me;function ve(ie){const Le=(0,c.$hi)(ie),Qe=rt=>m.URI.isUri(rt)?rt:M.to(rt);return new b.$nQ(typeof Le.reference=="string"?Le.reference:"variableName"in Le.reference?{variableName:Le.reference.variableName,value:Le.reference.value&&Qe(Le.reference.value)}:Qe(Le.reference))}De.to=ve})(di||(e.ChatResponseReferencePart=di={}));var yi;(function(De){function Me(ve){return{kind:"codeCitation",value:ve.value,license:ve.license,snippet:ve.snippet}}De.from=Me})(yi||(e.ChatResponseCodeCitationPart=yi={}));var Wt;(function(De){function Me(Le,Qe,rt){return Le instanceof b.$dQ?ri.from(Le):Le instanceof b.$iQ?Mt.from(Le):Le instanceof b.$nQ?di.from(Le):Le instanceof b.$jQ?Ct.from(Le):Le instanceof b.$hQ?ui.from(Le):Le instanceof b.$mQ?xt.from(Le,Qe,rt):Le instanceof b.$qQ?Mi.from(Le):Le instanceof b.$eQ?si.from(Le):Le instanceof b.$fQ?Jt.from(Le):Le instanceof b.$lQ?yt.from(Le):Le instanceof b.$gQ?Xt.from(Le):Le instanceof b.$oQ?yi.from(Le):Le instanceof b.$pQ?Yt.from(Le):{kind:"markdownContent",content:oe.from("")}}De.from=Me;function ve(Le,Qe){switch(Le.kind){case"reference":return di.to(Le);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Le,Qe)}}De.to=ve;function ie(Le,Qe){switch(Le.kind){case"markdownContent":return ri.to(Le);case"inlineReference":return Mt.to(Le);case"progressMessage":return;case"treeData":return ui.to(Le);case"command":return xt.to(Le,Qe)}}De.toContent=ie})(Wt||(e.ChatResponsePart=Wt={}));var fi;(function(De){function Me(ve,ie){const Le=ve.variables.variables.filter(rt=>rt.isTool),Qe=ve.variables.variables.filter(rt=>!rt.isTool);return{prompt:ve.message,command:ve.command,attempt:ve.attempt??0,enableCommandDetection:ve.enableCommandDetection??!0,isParticipantDetected:ve.isParticipantDetected??!1,references:Qe.map(Ot.to),toolReferences:Le.map(Ei.to),location:Fi.to(ve.location),acceptedConfirmationData:ve.acceptedConfirmationData,rejectedConfirmationData:ve.rejectedConfirmationData,location2:ie}}De.to=Me})(fi||(e.ChatAgentRequest=fi={}));var Fi;(function(De){function Me(ie){switch(ie){case g.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case g.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case g.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case g.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}De.to=Me;function ve(ie){switch(ie){case b.ChatLocation.Notebook:return g.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return g.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return g.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return g.ChatAgentLocation.Editor}}De.from=ve})(Fi||(e.ChatLocation=Fi={}));var Ot;(function(De){function Me(ve){const ie=ve.value;if(!ie)throw new Error("Invalid value reference");return{id:ve.id,name:ve.name,range:ve.range&&[ve.range.start,ve.range.endExclusive],value:(0,m.$Ac)(ie)?m.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,m.$Ac)(ie.uri)?M.to((0,c.$hi)(ie)):ie,modelDescription:ve.modelDescription}}De.to=Me})(Ot||(e.ChatPromptReference=Ot={}));var Ei;(function(De){function Me(ve){if(ve.value)throw new Error("Invalid tool reference");return{id:ve.id,range:ve.range&&[ve.range.start,ve.range.endExclusive]}}De.to=Me})(Ei||(e.ChatLanguageModelToolReference=Ei={}));var Ti;(function(De){function Me(ve,ie,Le){return{id:ve.id,label:ve.label,fullName:ve.fullName,icon:ve.icon?.id,value:ve.values[0].value,insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation,command:ie.toInternal(ve.command,Le)}}De.from=Me})(Ti||(e.ChatAgentCompletionItem=Ti={}));var gi;(function(De){function Me(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata,nextQuestion:ve.nextQuestion}}De.to=Me})(gi||(e.ChatAgentResult=gi={}));var ji;(function(De){function Me(ve,ie,Le){if(ie.action.kind==="vote")return;const Qe=gi.to(ve);if(ie.action.kind==="command"){const rt=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Le.fromInternal(rt)??{command:rt.id,title:rt.title}}},result:Qe}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:Nt.to(ie.action.followup)},result:Qe}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:Qe}:{action:ie.action,result:Qe}}De.to=Me})(ji||(e.ChatAgentUserActionEvent=ji={}));var Ui;(function(De){function Me(ie){return{...ie,string:ie.toString()}}De.from=Me;function ve(ie){const Le={...ie,toString:()=>ie.string};return delete Le.string,Le}De.to=ve})(Ui||(e.LanguageModelToolResult=Ui={}));var jt;(function(De){function Me(ve,ie,Le){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:ie.toInternal(ve,Le)}De.from=Me})(jt||(e.TerminalQuickFix=jt={}));var Pi;(function(De){function Me(ve){return{kind:Di.to(ve.kind)}}De.to=Me})(Pi||(e.PartialAcceptInfo=Pi={}));var Di;(function(De){function Me(ve){switch(ve){case a.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case a.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case a.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}De.to=Me})(Di||(e.PartialAcceptTriggerKind=Di={}));var bi;(function(De){function Me(ve,ie){return{id:ie,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||k.DebugTreeItemCollapsibleState.None,contextValue:ve.contextValue}}De.from=Me})(bi||(e.DebugTreeItem=bi={}));var wi;(function(De){function Me(ve){return{id:ve.id,modelDescription:ve.modelDescription,parametersSchema:ve.parametersSchema,displayName:ve.displayName}}De.to=Me})(wi||(e.LanguageModelToolDescription=wi={}))}),define(Re[296],Ce([1,0,6,19,15,53]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$grc=void 0;let T=class{constructor(p,c){this.a=p.getProxy(s.$bO.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>c.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,c,I){const E=new O.$9w(D.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(E,void 0,I?.isRefactoring??!1)}};e.$grc=T,e.$grc=T=Ye([We(0,h.$OQ)],T)}),define(Re[297],Ce([1,0,18,8,52,4,40,3,38,44,17,2,23,6,15,9,159,259,25]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=void 0,v=Ue(v),o=Ue(o);class i{constructor(n,u,l,g,y){this.j=n,this.k=u,this.l=l,this.m=g,this.n=y,this.b=c.$ke.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let u=function(g){if(n.c){const y=new Error("Response stream has been closed");throw Error.captureStackTrace(y,g),y}};const n=this;this.b.reset();const l=(g,y)=>{if(typeof this.d>"u"&&(g.kind==="markdownContent"||g.kind==="markdownVuln")&&(this.d=this.b.elapsed()),y){const k=this.l.$handleProgressChunk(this.k.requestId,g),S={report:R=>{k?.then(C=>{C&&(o.$HO.isMarkdownString(R.value)?this.l.$handleProgressChunk(this.k.requestId,v.ChatResponseWarningPart.from(R),C):this.l.$handleProgressChunk(this.k.requestId,v.ChatResponseReferencePart.from(R),C))})}};Promise.all([k,y?.(S)]).then(([R,C])=>{R!==void 0&&this.l.$handleProgressChunk(this.k.requestId,v.ChatTaskResult.from(C),R)})}else this.l.$handleProgressChunk(this.k.requestId,g)};this.g={markdown(g){u(this.markdown);const y=new o.$dQ(g),k=v.ChatResponseMarkdownPart.from(y);return l(k),this},markdownWithVulnerabilities(g,y){u(this.markdown),y&&(0,d.$DH)(n.j,"chatParticipantAdditions");const k=new o.$eQ(g,y),S=v.ChatResponseMarkdownWithVulnerabilitiesPart.from(k);return l(S),this},filetree(g,y){u(this.filetree);const k=new o.$hQ(g,y),S=v.ChatResponseFilesPart.from(k);return l(S),this},anchor(g,y){u(this.anchor);const k=new o.$iQ(g,y),S=v.ChatResponseAnchorPart.from(k);return l(S),this},button(g){u(this.anchor);const y=new o.$mQ(g),k=v.ChatResponseCommandButtonPart.from(y,n.m,n.n);return l(k),this},progress(g,y){u(this.progress);const k=new o.$kQ(g,y),S=y?v.ChatTask.from(k):v.ChatResponseProgressPart.from(k);return l(S,y),this},warning(g){u(this.progress),(0,d.$DH)(n.j,"chatParticipantAdditions");const y=new o.$lQ(g),k=v.ChatResponseWarningPart.from(y);return l(k),this},reference(g,y){return this.reference2(g,y)},reference2(g,y,k){if(u(this.reference),typeof g=="object"&&"variableName"in g&&(0,d.$DH)(n.j,"chatParticipantAdditions"),typeof g=="object"&&"variableName"in g&&!g.value){const S=n.k.variables.variables.find(R=>R.name===g.variableName);if(S){let R;if(S.references?.length)R=S.references.map(C=>({kind:"reference",reference:{variableName:g.variableName,value:C.reference}}));else{const C=new o.$nQ(g,y,k);R=[v.ChatResponseReferencePart.from(C)]}return R.forEach(C=>l(C)),this}}else{const S=new o.$nQ(g,y,k),R=v.ChatResponseReferencePart.from(S);l(R)}return this},codeCitation(g,y,k){u(this.codeCitation),(0,d.$DH)(n.j,"chatParticipantAdditions");const S=new o.$oQ(g,y,k),R=v.ChatResponseCodeCitationPart.from(S);l(R)},textEdit(g,y){u(this.textEdit),(0,d.$DH)(n.j,"chatParticipantAdditions");const k=new o.$qQ(g,y),S=v.ChatResponseTextEditPart.from(k);return l(S),this},detectedParticipant(g,y){u(this.detectedParticipant),(0,d.$DH)(n.j,"chatParticipantAdditions");const k=new o.$fQ(g,y),S=v.ChatResponseDetectedParticipantPart.from(k);return l(S),this},confirmation(g,y,k,S){u(this.confirmation),(0,d.$DH)(n.j,"chatParticipantAdditions");const R=new o.$gQ(g,y,k,S),C=v.ChatResponseConfirmationPart.from(R);return l(C),this},push(g){if(u(this.push),(g instanceof o.$qQ||g instanceof o.$eQ||g instanceof o.$fQ||g instanceof o.$lQ||g instanceof o.$gQ||g instanceof o.$oQ||g instanceof o.$pQ)&&(0,d.$DH)(n.j,"chatParticipantAdditions"),g instanceof o.$nQ)this.reference2(g.value,g.iconPath,g.options);else{const y=v.ChatResponsePart.from(g,n.m,n.n);l(y)}return this}}}return this.g}}class a extends A.$Zc{static{this.b=0}static{this.j=0}constructor(n,u,l,g){super(),this.t=u,this.u=l,this.w=g,this.c=new Map,this.m=new Map,this.n=this.B(new A.$9c),this.s=this.B(new A.$9c),this.g=n.getProxy(P.$bO.MainThreadChatAgents2)}transferActiveChat(n){this.g.$transferActiveChatSession(n)}createChatAgent(n,u,l){const g=a.b++,y=new t(n,u,this.g,g,l);return this.c.set(g,y),this.g.$registerAgent(g,n.identifier,u,{},void 0),y.apiAgent}createDynamicChatAgent(n,u,l,g){const y=a.b++,k=new t(n,u,this.g,y,g);return this.c.set(y,k),this.g.$registerAgent(y,n.identifier,u,{isSticky:!0},l),k.apiAgent}registerChatParticipantDetectionProvider(n){const u=a.j++;return this.m.set(u,n),this.g.$registerChatParticipantDetectionProvider(u),(0,A.$Xc)(()=>{this.m.delete(u),this.g.$unregisterChatParticipantDetectionProvider(u)})}async $detectChatParticipant(n,u,l,g,y){const{request:k,location:S,history:R}=await this.y(u,l),C=this.m.get(n);if(C)return C.provideParticipantDetection(v.ChatAgentRequest.to(k,S),{history:R},{participants:g.participants,location:v.ChatLocation.to(g.location)},y)}async y(n,u){const l=(0,p.$hi)(n),g=await this.z(l.agentId,u);let y;if(l.locationData?.type===m.ChatAgentLocation.Editor){const k=this.w.getDocument(l.locationData.document);y=new o.$tQ(k,v.Selection.to(l.locationData.selection),v.Range.to(l.locationData.wholeRange))}else if(l.locationData?.type===m.ChatAgentLocation.Notebook){const k=this.w.getDocument(l.locationData.sessionInputUri);y=new o.$uQ(k)}else l.locationData?.type,m.ChatAgentLocation.Terminal;return{request:l,location:y,history:g}}async $invokeAgent(n,u,l,g){const y=this.c.get(n);if(!y)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let k;try{const{request:S,location:R,history:C}=await this.y(u,l);let w=this.n.get(S.sessionId);w||(w=new A.$Yc,this.n.set(S.sessionId,w)),k=new i(y.extension,S,this.g,this.u.converter,w);const b=y.invoke(v.ChatAgentRequest.to(S,R),{history:C},k.apiObject,g);return await(0,h.$yh)(Promise.resolve(b).then(N=>{if(N?.metadata)try{JSON.stringify(N.metadata)}catch(M){const z=`result.metadata MUST be JSON.stringify-able. Got error: ${M.message}`;return this.t.error(`[${y.extension.identifier.value}] [@${y.id}] ${z}`,y.extension),{errorDetails:{message:z},timings:k?.timings,nextQuestion:N.nextQuestion}}let L;return N?.errorDetails&&(L={...N.errorDetails,responseIsIncomplete:!0}),L?.responseIsRedacted&&(0,d.$DH)(y.extension,"chatParticipantPrivate"),{errorDetails:L,timings:k?.timings,metadata:N?.metadata,nextQuestion:N?.nextQuestion}}),g)}catch(S){return this.t.error(S,y.extension),S instanceof o.$CQ&&S.cause&&(S=S.cause),{errorDetails:{message:(0,D.$vj)(S),responseIsIncomplete:!0}}}finally{k?.close()}}async z(n,u){const l=[];for(const g of u.history){const y=v.ChatAgentResult.to(g.result),k=n===g.request.agentId?y:{...y,metadata:void 0},S=g.request.variables.variables.filter(b=>!b.isTool).map(v.ChatPromptReference.to),R=g.request.variables.variables.filter(b=>b.isTool).map(v.ChatLanguageModelToolReference.to),C=new o.$rQ(g.request.message,g.request.command,S,g.request.agentId);C.toolReferences=R,l.push(C);const w=(0,s.$Lb)(g.response.map(b=>v.ChatResponsePart.toContent(b,this.u.converter)));l.push(new o.$sQ(w,k,g.request.agentId,g.request.command))}return l}$releaseSession(n){this.n.deleteAndDispose(n)}async $provideFollowups(n,u,l,g,y){const k=this.c.get(u);if(!k)return Promise.resolve([]);const S=(0,p.$hi)(n),R=await this.z(k.id,g),C=v.ChatAgentResult.to(l);return(await k.provideFollowups(C,{history:R},y)).filter(w=>{const b=!w.participant||T.Iterable.some(this.c.values(),N=>N.id===w.participant&&f.$zn.equals(N.extension.identifier,k.extension.identifier));return b||this.t.warn(`[@${k.id}] ChatFollowup refers to an unknown participant: ${w.participant}`),b}).map(w=>v.ChatFollowup.from(w,S))}$acceptFeedback(n,u,l){const g=this.c.get(n);if(!g)return;const y=v.ChatAgentResult.to(u);let k;switch(l.direction){case $.ChatAgentVoteDirection.Down:k=o.ChatResultFeedbackKind.Unhelpful;break;case $.ChatAgentVoteDirection.Up:k=o.ChatResultFeedbackKind.Helpful;break}const S={result:y,kind:k,unhelpfulReason:(0,d.$CH)(g.extension,"chatParticipantAdditions")?l.reason:void 0};g.acceptFeedback(Object.freeze(S))}$acceptAction(n,u,l){const g=this.c.get(n);if(!g||l.action.kind==="vote")return;const y=v.ChatAgentUserActionEvent.to(u,l,this.u.converter);y&&g.acceptAction(Object.freeze(y))}async $invokeCompletionProvider(n,u,l){const g=this.c.get(n);if(!g)return[];let y=this.s.get(n);return y?y.clear():(y=new A.$Yc,this.s.set(n,y)),(await g.invokeCompletionProvider(u,l)).map(S=>v.ChatAgentCompletionItem.from(S,this.u.converter,y))}async $provideWelcomeMessage(n,u,l){const g=this.c.get(n);if(g)return await g.provideWelcomeMessage(v.ChatLocation.to(u),l)}async $provideChatTitle(n,u,l){const g=this.c.get(n);if(!g)return;const y=await this.z(g.id,{history:u});return await g.provideTitle({history:y},l)}async $provideSampleQuestions(n,u,l){const g=this.c.get(n);if(g)return(await g.provideSampleQuestions(v.ChatLocation.to(u),l)).map(y=>v.ChatFollowup.from(y,void 0))}}e.$hrc=a;class t{constructor(n,u,l,g,y){this.extension=n,this.id=u,this.w=l,this.x=g,this.y=y,this.l=new O.$qe,this.m=new O.$qe}acceptFeedback(n){this.l.fire(n)}acceptAction(n){this.m.fire(n)}async invokeCompletionProvider(n,u){return this.o?await this.o.provider.provideCompletionItems(n,u)??[]:[]}async provideFollowups(n,u,l){if(!this.b)return[];const g=await this.b.provideFollowups(n,u,l);return g?g.filter(y=>!(y&&"commandId"in y)).filter(y=>!(y&&"message"in y)):[]}async provideWelcomeMessage(n,u){if(!this.q)return[];const l=await this.q.provideWelcomeMessage(n,u);return l?l.map(g=>typeof g=="string"?g:v.MarkdownString.from(g)):[]}async provideTitle(n,u){if(this.s)return await this.s.provideChatTitle(n,u)??void 0}async provideSampleQuestions(n,u){if(!this.q||!this.q.provideSampleQuestions)return[];const l=await this.q.provideSampleQuestions(n,u);return l||[]}get apiAgent(){let n=!1,u=!1;const l=()=>{n||u||(u=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof E.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof o.$cP?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.k,helpTextPrefix:!this.d||typeof this.d=="string"?this.d:v.MarkdownString.from(this.d),helpTextVariablesPrefix:!this.g||typeof this.g=="string"?this.g:v.MarkdownString.from(this.g),helpTextPostfix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),supportIssueReporting:this.n,requester:this.t,supportsSlowVariables:this.u}),u=!1}))},g=this;return{get id(){return g.id},get iconPath(){return g.c},set iconPath(y){g.c=y,l()},get requestHandler(){return g.y},set requestHandler(y){(0,I.$tg)(typeof y=="function","Invalid request handler"),g.y=y},get followupProvider(){return g.b},set followupProvider(y){g.b=y,l()},get helpTextPrefix(){return(0,d.$DH)(g.extension,"defaultChatParticipant"),g.d},set helpTextPrefix(y){(0,d.$DH)(g.extension,"defaultChatParticipant"),g.d=y,l()},get helpTextVariablesPrefix(){return(0,d.$DH)(g.extension,"defaultChatParticipant"),g.g},set helpTextVariablesPrefix(y){(0,d.$DH)(g.extension,"defaultChatParticipant"),g.g=y,l()},get helpTextPostfix(){return(0,d.$DH)(g.extension,"defaultChatParticipant"),g.j},set helpTextPostfix(y){(0,d.$DH)(g.extension,"defaultChatParticipant"),g.j=y,l()},get isSecondary(){return(0,d.$DH)(g.extension,"defaultChatParticipant"),g.k},set isSecondary(y){(0,d.$DH)(g.extension,"defaultChatParticipant"),g.k=y,l()},get supportIssueReporting(){return(0,d.$DH)(g.extension,"chatParticipantPrivate"),g.n},set supportIssueReporting(y){(0,d.$DH)(g.extension,"chatParticipantPrivate"),g.n=y,l()},get onDidReceiveFeedback(){return g.l.event},set participantVariableProvider(y){if((0,d.$DH)(g.extension,"chatParticipantAdditions"),g.o=y,y){if(!y.triggerCharacters.length)throw new Error("triggerCharacters are required");g.w.$registerAgentCompletionsProvider(g.x,g.id,y.triggerCharacters)}else g.w.$unregisterAgentCompletionsProvider(g.x,g.id)},get participantVariableProvider(){return(0,d.$DH)(g.extension,"chatParticipantAdditions"),g.o},set welcomeMessageProvider(y){(0,d.$DH)(g.extension,"defaultChatParticipant"),g.q=y,l()},get welcomeMessageProvider(){return(0,d.$DH)(g.extension,"defaultChatParticipant"),g.q},set titleProvider(y){(0,d.$DH)(g.extension,"defaultChatParticipant"),g.s=y,l()},get titleProvider(){return(0,d.$DH)(g.extension,"defaultChatParticipant"),g.s},onDidPerformAction:(0,d.$CH)(this.extension,"chatParticipantAdditions")?this.m.event:void 0,set requester(y){g.t=y,l()},get requester(){return g.t},set supportsSlowReferences(y){(0,d.$DH)(g.extension,"chatParticipantPrivate"),g.u=y,l()},get supportsSlowReferences(){return(0,d.$DH)(g.extension,"chatParticipantPrivate"),g.u},dispose(){n=!0,g.b=void 0,g.l.dispose(),g.w.$unregisterAgent(g.x)}}}invoke(n,u,l,g){return this.y(n,u,l,g)}}}),define(Re[298],Ce([1,0,12,3,51,6,15,9,25]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=void 0,T=Ue(T),A=Ue(A);class c{static{this.a=0}constructor(f){this.b=new Map,this.c=f.getProxy(O.$bO.MainThreadChatVariables)}async $resolveVariable(f,P,v,o){const m=this.b.get(f);if(m)try{if(m.resolver.resolve2){(0,p.$DH)(m.extension,"chatParticipantAdditions");const $=new I(P,this.c),d=await m.resolver.resolve2(m.data.name,{prompt:v},$.apiObject,o);if(d&&d[0])return d[0].value}else{const $=await m.resolver.resolve(m.data.name,{prompt:v},o);if($&&$[0])return $[0].value}}catch($){(0,s.$5)($)}}registerVariableResolver(f,P,v,o,m,$,d,i,a){const t=c.a++,r=a?D.ThemeIcon.fromId(a):void 0;return this.b.set(t,{extension:f,data:{id:P,name:v,description:o,modelDescription:m,icon:r},resolver:d}),this.c.$registerVariable(t,{id:P,name:v,description:o,modelDescription:m,isSlow:$,fullName:i,icon:r}),(0,h.$Xc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$irc=c;class I{constructor(f,P){this.c=f,this.d=P,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let P=function(o){if(f.a){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,o),m}};const f=this,v=o=>{this.d.$handleProgressChunk(this.c,o)};this.b={progress(o){P(this.progress);const m=new A.$jQ(o),$=T.ChatResponseProgressPart.from(m);return v($),this},reference(o){P(this.reference);const m=new A.$nQ(o),$=T.ChatResponseReferencePart.from(m);return v($),this},push(o){return P(this.push),o instanceof A.$nQ?v(T.ChatResponseReferencePart.from(o)):o instanceof A.$jQ&&v(T.ChatResponseProgressPart.from(o)),this}}}return this.b}}}),define(Re[299],Ce([1,0,8,60,4,3,41,2,88,23,15,9,6,25]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=v,p=Ue(p),I=Ue(I),E=Ue(E);function v(o,m,$){const d=o.getProxy(f.$bO.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$Bn,m.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===T.MarshalledId.CommentController){const R=this.b.get(S.handle);return R?R.value:S}else if(S&&S.$mid===T.MarshalledId.CommentThread){const R=S,C=this.b.get(R.commentControlHandle);if(!C)return R;const w=C.getCommentThread(R.commentThreadHandle);return w?w.value:R}else if(S&&(S.$mid===T.MarshalledId.CommentThreadReply||S.$mid===T.MarshalledId.CommentThreadInstance)){const R=this.b.get(S.thread.commentControlHandle);if(!R)return S;const C=R.getCommentThread(S.thread.commentThreadHandle);return C?S.$mid===T.MarshalledId.CommentThreadInstance?C.value:{thread:C.value,text:S.text}:S}else if(S&&S.$mid===T.MarshalledId.CommentNode){const R=this.b.get(S.thread.commentControlHandle);if(!R)return S;const C=R.getCommentThread(S.thread.commentThreadHandle);if(!C)return S;const w=S.commentUniqueId,b=C.getCommentByUniqueId(w);return b||S}else if(S&&S.$mid===T.MarshalledId.CommentThreadNode){const R=this.b.get(S.thread.commentControlHandle);if(!R)return S;const C=R.getCommentThread(S.thread.commentThreadHandle);if(!C)return S;const w=S.text,b=S.commentUniqueId,N=C.getCommentByUniqueId(b);return N?(typeof N.body=="string"?N.body=w:N.body=new E.$HO(w),N):S}return S}})}createCommentController(S,R,C){const w=i.a++,b=new t(S,w,R,C);this.b.set(b.handle,b);const N=this.c.get(S.identifier)||[];return N.push(b),this.c.set(S.identifier,N),b.value}async $createCommentThreadTemplate(S,R,C,w){const b=this.b.get(S);b&&b.$createCommentThreadTemplate(R,C,w)}async $setActiveComment(S,R){const C=this.b.get(S);C&&C.$setActiveComment(R??void 0)}async $updateCommentThreadTemplate(S,R,C){const w=this.b.get(S);w&&w.$updateCommentThreadTemplate(R,C)}$deleteCommentThread(S,R){this.b.get(S)?.$deleteCommentThread(R)}async $provideCommentingRanges(S,R,C){const w=this.b.get(S);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const b=await $.ensureDocumentData(A.URI.revive(R));return(0,s.$Ch)(async()=>{const N=await w.commentingRangeProvider.provideCommentingRanges(b.document,C);let L;return Array.isArray(N)?L={ranges:N,fileComments:!1}:N?L={ranges:N.ranges||[],fileComments:N.enableFileComments||!1}:L=N??void 0,L}).then(N=>{let L;return N&&(L={ranges:N.ranges.map(M=>I.Range.from(M)),fileComments:N.fileComments}),L})}$toggleReaction(S,R,C,w,b){const N=this.b.get(S);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,s.$Ch)(()=>{const L=N.getCommentThread(R);if(L){const M=L.getCommentByUniqueId(w.uniqueIdInThread);if(N!==void 0&&M&&N.reactionHandler)return N.reactionHandler(M,u(b))}return Promise.resolve(void 0)})}}class a{static{this.a=0}set threadId(S){this.n=S}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(S){(S===void 0!=(this.p===void 0)||!S||!this.p||!S.isEqual(this.p))&&(this.p=S,this.b.range=S,this.c.fire())}get range(){return this.p}set canReply(S){this.d!==S&&(this.d=S,this.b.canReply=S,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(S){this.e=S,this.b.label=S,this.c.fire()}get contextValue(){return this.f}set contextValue(S){this.f=S,this.b.contextValue=S,this.c.fire()}get comments(){return this.q}set comments(S){this.q=S,this.b.comments=S,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(S){this.g=S,this.b.collapsibleState=S,this.c.fire()}get state(){return this.h}set state(S){this.h=S,typeof S=="object"?((0,P.$DH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=S.resolved,this.b.applicability=S.applicability):this.b.state=S,this.c.fire()}get isDisposed(){return this.j}constructor(S,R,C,w,b,N,L,M,z){this.m=R,this.n=C,this.o=w,this.p=b,this.q=N,this.extensionDescription=L,this.r=M,this.handle=a.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new D.$qe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$1c,this.l.value=new O.$Yc,this.n===void 0&&(this.n=`${S}.${this.handle}`),d.$createCommentThread(R,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(F=>r(this,F,this.k,this.extensionDescription)),L.identifier,this.r,z),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{d.$deleteCommentThread(R,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(F){V.range=F},get comments(){return V.comments},set comments(F){V.comments=F},get collapsibleState(){return V.collapsibleState},set collapsibleState(F){V.collapsibleState=F},get canReply(){return V.canReply},set canReply(F){V.canReply=F},get contextValue(){return V.contextValue},set contextValue(F){V.contextValue=F},get label(){return V.label},set label(F){V.label=F},get state(){return V.state},set state(F){V.state=F},reveal:(F,j)=>V.reveal(F,j),hide:()=>V.hide(),dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Yc);const S=C=>Object.prototype.hasOwnProperty.call(this.b,C),R={};S("range")&&(R.range=I.Range.from(this.p)),S("label")&&(R.label=this.label),S("contextValue")&&(R.contextValue=this.contextValue??null),S("comments")&&(R.comments=this.q.map(C=>r(this,C,this.k,this.extensionDescription))),S("collapsibleState")&&(R.collapseState=l(this.g)),S("canReply")&&(R.canReply=this.canReply),S("state")&&(R.state=g(this.h)),S("applicability")&&(R.applicability=y(this.h)),S("isTemplate")&&(R.isTemplate=this.r),this.b={},d.$updateCommentThread(this.m,this.handle,this.n,this.o,R)}getCommentByUniqueId(S){for(const R of this.k){const C=R[0],w=R[1];if(S===w)return C}}async reveal(S,R){(0,P.$DH)(this.extensionDescription,"commentReveal");let C;S&&S.body!==void 0?C=S:R=R??S;let w=C?this.k.get(C):void 0;w??=this.k.get(this.q[0]);let b=!0,N=!1;return R?.focus===E.CommentThreadFocus.Reply?(N=!0,b=!1):R?.focus===E.CommentThreadFocus.Comment&&(b=!1),d.$revealCommentThread(this.m,this.handle,w,{preserveFocus:b,focusReply:N})}async hide(){return d.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(S=>S.dispose())}}Ye([(0,h.$di)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(S){this.b=S,S?.resourceHints&&(0,P.$DH)(this.h,"commentingRangeHint"),d.$updateCommentingRanges(this.handle,S?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(S){this.c=S,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!S})}get options(){return this.d}set options(S){this.d=S,d.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,P.$DH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,P.$DH)(this.h,"activeComment"),this.f?.value}constructor(S,R,C,w){this.h=S,this.i=R,this.j=C,this.k=w,this.a=new Map,d.$registerCommentController(this.handle,C,w,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(N){b.options=N},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(N){b.commentingRangeProvider=N},get reactionHandler(){return b.reactionHandler},set reactionHandler(N){b.reactionHandler=N},get activeCommentThread(){return b.activeCommentThread},createCommentThread(N,L,M){return b.createCommentThread(N,L,M).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(S,R,C){R===void 0&&(0,P.$DH)(this.h,"fileComments");const w=new a(this.id,this.handle,void 0,S,R,C,this.h,!1);return this.a.set(w.handle,w),w}$setActiveComment(S){if(!S){this.e=void 0,this.f=void 0;return}const R=this.a.get(S.commentThreadHandle);R&&(this.e=S.uniqueIdInThread?R.getCommentByUniqueId(S.uniqueIdInThread):void 0,this.f=R)}$createCommentThreadTemplate(S,R,C){const w=new a(this.id,this.handle,void 0,A.URI.revive(S),I.Range.to(R),[],this.h,!0,C);return w.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(w.handle,w),w}$updateCommentThreadTemplate(S,R){const C=this.a.get(S);C&&(C.range=I.Range.to(R))}$deleteCommentThread(S){this.a.get(S)?.dispose(),this.a.delete(S)}getCommentThread(S){return this.a.get(S)}dispose(){this.a.forEach(S=>{S.dispose()}),this.g.forEach(S=>S.dispose())}}function r(k,S,R,C){let w=R.get(S);return w||(w=++k.commentHandle,R.set(S,w)),S.state!==void 0&&(0,P.$DH)(C,"commentsDraftState"),S.reactions?.some(b=>b.reactors!==void 0)&&(0,P.$DH)(C,"commentReactor"),{mode:S.mode,contextValue:S.contextValue,uniqueIdInThread:w,body:typeof S.body=="string"?S.body:I.MarkdownString.from(S.body),userName:S.author.name,userIconPath:S.author.iconPath,label:S.label,commentReactions:S.reactions?S.reactions.map(b=>n(b)):void 0,state:S.state,timestamp:S.timestamp?.toJSON()}}function n(k){return{label:k.label,iconPath:k.iconPath?I.$NQ(k.iconPath):void 0,count:k.count,hasReacted:k.authorHasReacted,reactors:k.reactors&&k.reactors.length>0&&typeof k.reactors[0]!="string"?k.reactors.map(S=>S.name):k.reactors}}function u(k){return{label:k.label||"",count:k.count||0,iconPath:k.iconPath?A.URI.revive(k.iconPath):"",authorHasReacted:k.hasReacted||!1,reactors:k.reactors?.map(S=>({name:S}))}}function l(k){if(k!==void 0)switch(k){case E.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case E.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function g(k){let S;if(typeof k=="object"?S=k.resolved:S=k,S!==void 0)switch(S){case E.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case E.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function y(k){let S;if(typeof k=="object"&&(S=k.applicability),S!==void 0)switch(S){case E.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case E.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Re[300],Ce([1,0,20,61,3,14,22,2,15,97,118,6,9]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Erc=void 0,p=Ue(p),E=Ue(E),f=Ue(f);class P{constructor(n,u){this.document=n,this.b=u,this.a=1,this.c=new I.$5qc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,u){await this.f(n).undo(),u||this.disposeBackup()}async redo(n,u){await this.f(n).redo(),u||this.disposeBackup()}disposeEdits(n){for(const u of n)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=t(this.document.uri)+this.a++;return(0,T.$lh)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const u=this.c.get(n,0);if(!u)throw new Error("No edit found");return u}}class v{constructor(){this.a=new Map}get(n,u){return this.a.get(this.b(n,u))}add(n,u,l){const g=this.b(n,u.uri);if(this.a.has(g))throw new Error(`Document already exists for viewType:${n} resource:${u.uri}`);const y=new P(u,l);return this.a.set(g,y),y}delete(n,u){const l=this.b(n,u.uri);this.a.delete(l)}b(n,u){return`${n}@@@${u}`}}var o;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(o||(o={}));class m{constructor(){this.a=new Map}addTextProvider(n,u,l){return this.b(n,{type:o.Text,extension:u,provider:l})}addCustomProvider(n,u,l){return this.b(n,{type:o.Custom,extension:u,provider:l})}get(n){return this.a.get(n)}b(n,u){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,u),new f.$dO(()=>this.a.delete(n))}}class ${constructor(n,u,l,g,y){this.d=u,this.f=l,this.g=g,this.h=y,this.b=new m,this.c=new v,this.a=n.getProxy(E.$bO.MainThreadCustomEditors)}registerCustomEditorProvider(n,u,l,g){const y=new D.$Yc;return i(l)?(y.add(this.b.addTextProvider(u,n,l)),this.a.$registerTextEditorProvider((0,c.$Brc)(n),u,g.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$zrc)(n))):(y.add(this.b.addCustomProvider(u,n,l)),d(l)&&y.add(l.onDidChangeCustomDocument(k=>{const S=this.i(u,k.document.uri);if(a(k)){const R=S.addEdit(k);this.a.$onDidEdit(k.document.uri,u,R,k.label)}else this.a.$onContentChange(k.document.uri,u)})),this.a.$registerCustomEditorProvider((0,c.$Brc)(n),u,g.webviewOptions||{},!!g.supportsMultipleEditorsPerDocument,(0,c.$zrc)(n))),f.$dO.from(y,new f.$dO(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(n,u,l,g,y){const k=this.b.get(u);if(!k)throw new Error(`No provider found for '${u}'`);if(k.type!==o.Custom)throw new Error(`Invalid provide type for '${u}'`);const S=A.URI.revive(n),R=await k.provider.openCustomDocument(S,{backupId:l,untitledDocumentData:g?.buffer},y);let C;return d(k.provider)&&this.f&&(C=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(u,R,C),{editable:d(k.provider)}}async $disposeCustomDocument(n,u){const l=this.b.get(u);if(!l)throw new Error(`No provider found for '${u}'`);if(l.type!==o.Custom)throw new Error(`Invalid provider type for '${u}'`);const g=A.URI.revive(n),{document:y}=this.i(u,g);this.c.delete(u,y),y.dispose()}async $resolveCustomEditor(n,u,l,g,y,k){const S=this.b.get(l);if(!S)throw new Error(`No provider found for '${l}'`);const R=p.ViewColumn.to(y),C=this.g.createNewWebview(u,g.contentOptions,S.extension),w=this.h.createNewWebviewPanel(u,l,g.title,R,g.options,C,g.active),b=A.URI.revive(n);switch(S.type){case o.Custom:{const{document:N}=this.i(l,b);return S.provider.resolveCustomEditor(N,w,k)}case o.Text:{const N=this.d.getDocument(b);return S.provider.resolveCustomTextEditor(N,w,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,u,l){this.i(u,n).disposeEdits(l)}async $onMoveCustomEditor(n,u,l){const g=this.b.get(l);if(!g)throw new Error(`No provider found for '${l}'`);if(!g.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const y=this.h.getWebviewPanel(n);if(!y)throw new Error("No webview found");const k=A.URI.revive(u),S=this.d.getDocument(k);await g.provider.moveCustomTextEditor(S,y,s.CancellationToken.None)}async $undo(n,u,l,g){return this.i(u,n).undo(l,g)}async $redo(n,u,l,g){return this.i(u,n).redo(l,g)}async $revert(n,u,l){const g=this.i(u,n);await this.j(u).revertCustomDocument(g.document,l),g.disposeBackup()}async $onSave(n,u,l){const g=this.i(u,n);await this.j(u).saveCustomDocument(g.document,l),g.disposeBackup()}async $onSaveAs(n,u,l,g){const y=this.i(u,n);return this.j(u).saveCustomDocumentAs(y.document,A.URI.revive(l),g)}async $backup(n,u,l){const g=this.i(u,n),k=await this.j(u).backupCustomDocument(g.document,{destination:g.getNewBackupUri()},l);return g.updateBackup(k),k.id}i(n,u){const l=this.c.get(n,A.URI.revive(u));if(!l)throw new Error("No custom document found");return l}j(n){const l=this.b.get(n)?.provider;if(!l||!d(l))throw new Error("Custom document is not editable");return l}}e.$Erc=$;function d(r){return!!r.onDidChangeCustomDocument}function i(r){return typeof r.resolveCustomTextEditor=="function"}function a(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function t(r){const n=r.scheme===O.Schemas.file||r.scheme===O.Schemas.untitled?r.fsPath:r.toString();return(0,h.$yj)(n)+""}}),define(Re[301],Ce([1,0,7,150,2,6,9,15,4,11,28,64]),function(ge,e,s,h,D,O,T,A,p,c,I,E){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=e.$_qc=void 0,A=Ue(A);class P{#e;#t;#i;constructor(m,$,d,i,a,t,r,n){this.d=m,this.e=$,this.f=d,this.g=i,this.h=a,this.c=!1,this.f=Math.max(i,d),this.#i=new I.$Fc(u=>t.getComparisonKey(u)),this.#e=r,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,$){if(!m){this.clear();return}this.j();let d=[];if(D.URI.isUri(m)){if(!$){this.delete(m);return}this.#i.set(m,$.slice()),d=[m]}else if(Array.isArray(m)){d=[];let t;m=[...m].sort(P.k);for(const r of m){const[n,u]=r;if((!t||n.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=n,d.push(n),this.#i.set(n,[])),u)this.#i.get(n)?.push(...u);else{const l=this.#i.get(n);l&&(l.length=0)}}}if(this.#t.fire(d),!this.#e)return;const i=[];let a=0;for(const t of d){let r=[];const n=this.#i.get(t);if(n)if(n.length>this.g){r=[];const u=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const g of n)if(g.severity===u[l]&&r.push({...A.Diagnostic.from(g),modelVersionId:this.h(t)})===this.g)break e;r.push({severity:h.MarkerSeverity.Info,message:(0,s.localize)(2701,null,n.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=n.map(u=>({...A.Diagnostic.from(u),modelVersionId:this.h(t)}));if(i.push([t,r]),a+=r.length,a>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,$){this.j();for(const[d,i]of this)m.call($,d,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const $=this.#i.get(m);return Array.isArray($)?Object.freeze($.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,$){return m[0].toString()<$[0].toString()?-1:m[0].toString()>$[0].toString()?1:0}}e.$_qc=P;let v=class{static{f=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(m){const $=new I.$Fc;for(const d of m)$.set(d,d);return{uris:Object.freeze(Array.from($.values()))}}constructor(m,$,d,i){this.j=$,this.k=d,this.l=i,this.g=new Map,this.h=new p.$ue({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,f._mapper),this.f=m.getProxy(O.$bO.MainThreadDiagnostics)}createDiagnosticCollection(m,$){const{g:d,f:i,h:a,j:t,k:r,l:n}=this,u=new class{$changeMany(y,k){i.$changeMany(y,k),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,y,k.length===0?"CLEARING":k)}$clear(y){i.$clear(y),t.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,y)}dispose(){i.dispose()}};let l;if(!$)$="_generated_diagnostic_collection_name_#"+f.c++,l=$;else if(!d.has($))l=$;else{this.j.warn(`DiagnosticCollection with name '${$}' does already exist.`);do l=$+f.c++;while(d.has(l))}return new class extends P{constructor(){super($,l,f.e,f.d,y=>n.getDocument(y)?.version,r.extUri,u,a),d.set(l,this)}dispose(){super.dispose(),d.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const $=new Map,d=[];for(const i of this.g.values())i.forEach((a,t)=>{let r=$.get(a.toString());typeof r>"u"&&(r=d.length,$.set(a.toString(),r),d.push([a,[]])),d[r][1]=d[r][1].concat(...t)});return d}}m(m){let $=[];for(const d of this.g.values())d.has(m)&&($=$.concat(d.get(m)));return $}$acceptMarkersChange(m){if(!this.n){const $="_generated_mirror",d=new P($,$,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set($,d),this.n=d}for(const[$,d]of m)this.n.set(D.URI.revive($),d.map(A.Diagnostic.to))}};e.$arc=v,e.$arc=v=f=Ye([We(1,c.$fk),We(2,E.$$qc)],v)}),define(Re[302],Ce([1,0,2,12,9,15,82,53]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nsc=void 0;class p{constructor(I,E,f,P={timeout:1500,errors:3}){this.c=I,this.d=E,this.f=f,this.g=P,this.a=new T.$0c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(E,f,P)=>{const o={dispose:this.a.push([E,f,I])};return Array.isArray(P)&&P.push(o),o}}async $participateInSave(I,E){const f=s.URI.revive(I);let P=!1;const v=setTimeout(()=>P=!0,this.g.timeout),o=[];try{for(const m of[...this.a]){if(P)break;const $=this.d.getDocument(f),d=await this.h(m,{document:$,reason:O.TextDocumentSaveReason.to(E)});o.push(d)}}finally{clearTimeout(v)}return o}h([I,E,f],P){const v=this.b.get(I);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(f,I,E,P).then(()=>!0,o=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' threw ERROR`),this.c.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const m=this.b.get(I);this.b.set(I,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,E,f,P){const v=[],o=Date.now(),{document:m,reason:$}=P,{version:d}=m,i=Object.freeze({document:m,reason:$,waitUntil(a){if(Object.isFrozen(v))throw(0,h.$_)("waitUntil can not be called async");v.push(Promise.resolve(a))}});try{E.apply(f,[i])}catch(a){return Promise.reject(a)}return Object.freeze(v),new Promise((a,t)=>{const r=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(v).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(r),a(n)}).catch(n=>{clearTimeout(r),t(n)})}).then(a=>{const t={edits:[]};for(const r of a)if(Array.isArray(r)&&r.every(n=>n instanceof D.$mO))for(const{newText:n,newEol:u,range:l}of r)t.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:l&&O.Range.from(l),text:n,eol:u&&O.EndOfLine.from(u)}});if(t.edits.length!==0)return d===m.version?this.f.$tryApplyWorkspaceEdit(new A.$9w(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$nsc=p}),define(Re[303],Ce([1,0,4,3,2,6,170,15,17,24,9]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$brc=void 0,A=Ue(A);class E{constructor(P,v){this.a=new s.$qe,this.b=new s.$qe,this.c=new s.$qe,this.d=new s.$qe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Yc,this.h=new Map,this.f=P.getProxy(O.$bO.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(o=>{for(const m of o)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(o=>{for(const m of o)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const v=this.g.getDocument(P);if(v)return v}getDocument(P){const v=this.getDocumentData(P);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return v.document}ensureDocumentData(P){const v=this.g.getDocument(P);if(v)return Promise.resolve(v);let o=this.h.get(P.toString());return o||(o=this.f.$tryOpenDocument(P).then(m=>{this.h.delete(P.toString());const $=D.URI.revive(m);return(0,p.$ug)(this.g.getDocument($))},m=>(this.h.delete(P.toString()),Promise.reject(m))),this.h.set(P.toString(),o)),o}createDocumentData(P){return this.f.$tryCreateDocument(P).then(v=>D.URI.revive(v))}$acceptModelLanguageChanged(P,v){const o=D.URI.revive(P),m=this.g.getDocument(o);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(v),this.a.fire(m.document)}$acceptModelSaved(P){const v=D.URI.revive(P),o=this.g.getDocument(v);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(o.document)}$acceptDirtyStateChanged(P,v){const o=D.URI.revive(P),m=this.g.getDocument(o);if(!m)throw new Error("unknown document");m._acceptIsDirty(v),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,v,o){const m=D.URI.revive(P),$=this.g.getDocument(m);if(!$)throw new Error("unknown document");$._acceptIsDirty(o),$.onEvents(v);let d;v.isUndoing?d=I.TextDocumentChangeReason.Undo:v.isRedoing&&(d=I.TextDocumentChangeReason.Redo),this.c.fire((0,c.$no)({document:$.document,contentChanges:v.changes.map(i=>({range:A.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:d}))}setWordDefinitionFor(P,v){(0,T.$QQ)(P,v)}}e.$brc=E}),define(Re[79],Ce([1,0,80,4,17,2,5,6,19,15,9]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Grc=e.$Frc=void 0,c=Ue(c),e.$Frc=(0,T.$Ki)("IExtHostEditorTabs");class E{constructor(m,$,d){this.e=d,this.d=$,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,$={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze($)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case A.TabInputKind.TextInput:return new I.$4P(O.URI.revive(this.b.input.uri));case A.TabInputKind.TextDiffInput:return new I.$5P(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case A.TabInputKind.TextMergeInput:return new I.$6P(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case A.TabInputKind.CustomEditorInput:return new I.$7P(O.URI.revive(this.b.input.uri),this.b.input.viewType);case A.TabInputKind.WebviewEditorInput:return new I.$8P(this.b.input.viewType);case A.TabInputKind.NotebookInput:return new I.$9P(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case A.TabInputKind.NotebookDiffInput:return new I.$0P(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case A.TabInputKind.TerminalEditorInput:return new I.$$P;case A.TabInputKind.InteractiveEditorInput:return new I.$_P(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case A.TabInputKind.ChatEditorInput:return new I.$aQ;case A.TabInputKind.MultiDiffEditorInput:return new I.$bQ(this.b.input.diffEditors.map(m=>new I.$5P(O.URI.revive(m.original),O.URI.revive(m.modified))));default:return}}}class f{constructor(m,$){this.c=[],this.d="",this.b=m,this.e=$;for(const d of m.tabs)d.isActive&&(this.d=d.id),this.c.push(new E(d,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,$={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return c.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(d=>d.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(d=>d.apiObject))}};this.a=Object.freeze($)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===A.TabModelOperationKind.TAB_OPEN){const d=new E(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,d),m.tabDto.isActive&&(this.d=d.tabId),d}else if(m.kind===A.TabModelOperationKind.TAB_CLOSE){const d=this.c.splice(m.index,1)[0];if(!d)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return d.tabId===this.d&&(this.d=""),d}else if(m.kind===A.TabModelOperationKind.TAB_MOVE){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const d=this.c.splice(m.oldIndex,1)[0];if(!d)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,d),d}const $=this.c.find(d=>d.tabId===m.tabDto.id);if(!$)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),$.acceptDtoUpdate(m.tabDto),$}activeTabId(){return this.d}}let P=class{constructor(m){this.b=new h.$qe,this.c=new h.$qe,this.e=[],this.a=m.getProxy(A.$bO.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,$={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(d=>d.apiObject))},get activeTabGroup(){const d=m.d;return(0,D.$ug)(m.e.find(a=>a.groupId===d)?.apiObject)},close:async(d,i)=>{const a=Array.isArray(d)?d:[d];return a.length?v(a[0])?this.j(a,i):this.i(a,i):!0}};this.f=Object.freeze($)}return this.f}$acceptEditorTabModel(m){const $=new Set(this.e.map(u=>u.groupId)),d=new Set(m.map(u=>u.groupId)),i=(0,s.$f)($,d),a=this.e.filter(u=>i.removed.includes(u.groupId)).map(u=>u.apiObject),t=[],r=[];this.e=m.map(u=>{const l=new f(u,()=>this.d);return i.added.includes(l.groupId)?t.push(l.apiObject):r.push(l.apiObject),l});const n=(0,D.$ug)(m.find(u=>u.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:t,closed:a,changed:r}))}$acceptTabGroupUpdate(m){const $=this.e.find(d=>d.groupId===m.groupId);if(!$)throw new Error("Update Group IPC call received before group creation.");$.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[$.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const $=this.e.find(i=>i.groupId===m.groupId);if(!$)throw new Error("Update Tabs IPC call received before group creation.");const d=$.acceptTabOperation(m);switch(m.kind){case A.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[d.apiObject],closed:[],changed:[]}));return;case A.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[d.apiObject],changed:[]}));return;case A.TabModelOperationKind.TAB_MOVE:case A.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[d.apiObject]}));return}}g(m){for(const $ of this.e)for(const d of $.tabs)if(d.apiObject===m)return d}h(m){return this.e.find($=>$.apiObject===m)}async i(m,$){const d=[];for(const i of m){const a=this.g(i);if(!a)throw new Error("Tab close: Invalid tab not found!");d.push(a.tabId)}return this.a.$closeTab(d,$)}async j(m,$){const d=[];for(const i of m){const a=this.h(i);if(!a)throw new Error("Group close: Invalid group not found!");d.push(a.groupId)}return this.a.$closeGroup(d,$)}};e.$Grc=P,e.$Grc=P=Ye([We(0,p.$OQ)],P);function v(o){return o.tabs!==void 0}}),define(Re[304],Ce([1,0,2,6,27,3,9,15,201,13,26,21,25,86]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qsc=void 0,D=Ue(D),A=Ue(A);class v{constructor(){this.a=[]}add($){this.b=void 0,this.a.push($)}delete($){const d=this.a.indexOf($);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const $=this.a.sort(),d=[];let i,a,t=p.State.LastKnownState,r=p.State.LastKnownState;for(const n of $){let u=i?(0,c.$Mf)(i,n):0;for(u===0?a=p.State.Start:a=r;u<n.length;u++)u+1===n.length?(t=r,r=p.State.BeforeColon):r+=1,d.push([a,n.toUpperCase().charCodeAt(u),r]),d.push([a,n.toLowerCase().charCodeAt(u),r]),a=r;i=n,r=t}d.push([p.State.BeforeColon,I.CharCode.Colon,p.State.AfterColon]),d.push([p.State.AfterColon,I.CharCode.Slash,p.State.End]),this.b=new p.$g5(d)}}provideDocumentLinks($){this.c();const d=[],i=p.$h5.computeLinks({getLineContent(a){return $.lineAt(a-1).text},getLineCount(){return $.lineCount}},this.b);for(const a of i){const t=A.DocumentLink.to(a);t.target&&d.push(t)}return d}}class o{constructor($,d){this.i=d,this.b=new v,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=$.getProxy(h.$bO.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider($,d,i,a={}){if(o.j(i),this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider($,"*",this.b));const t=this.h++;this.b.add(d),this.d.add(d),this.c.set(t,i);let r=D.FileSystemProviderCapabilities.FileReadWrite;a.isCaseSensitive&&(r+=D.FileSystemProviderCapabilities.PathCaseSensitive),a.isReadonly&&(r+=D.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(r+=D.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,f.$DH)($,"fsChunks"),r+=D.FileSystemProviderCapabilities.FileOpenReadWriteClose);let n;a.isReadonly&&(0,P.$$k)(a.isReadonly)&&a.isReadonly.value!==""&&(n={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this.a.$registerFileSystemProvider(t,d,r,n).catch(l=>{console.error(`FAILED to register filesystem provider of ${$.identifier.value}-extension for the scheme ${d}`),console.error(l)});const u=i.onDidChangeFile(l=>{const g=[];for(const y of l){const{uri:k,type:S}=y;if(k.scheme!==d)continue;let R;switch(S){case T.FileChangeType.Changed:R=D.FileChangeType.UPDATED;break;case T.FileChangeType.Created:R=D.FileChangeType.ADDED;break;case T.FileChangeType.Deleted:R=D.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}g.push({resource:k,type:R})}this.a.$onFileSystemChange(t,g)});return(0,O.$Xc)(()=>{u.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(t),this.a.$unregisterProvider(t)})}static j($){if(!$)throw new Error("MISSING provider");if(typeof $.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof $.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof $.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof $.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof $.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof $.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof $.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof $.rename!="function")throw new Error("Provider does NOT implement rename")}static k($){const{type:d,ctime:i,mtime:a,size:t,permissions:r}=$;return{type:d,ctime:i,mtime:a,size:t,permissions:r}}$stat($,d){return Promise.resolve(this.l($).stat(s.URI.revive(d))).then(i=>o.k(i))}$readdir($,d){return Promise.resolve(this.l($).readDirectory(s.URI.revive(d)))}$readFile($,d){return Promise.resolve(this.l($).readFile(s.URI.revive(d))).then(i=>E.$Se.wrap(i))}$writeFile($,d,i,a){return Promise.resolve(this.l($).writeFile(s.URI.revive(d),i.buffer,a))}$delete($,d,i){return Promise.resolve(this.l($).delete(s.URI.revive(d),i))}$rename($,d,i,a){return Promise.resolve(this.l($).rename(s.URI.revive(d),s.URI.revive(i),a))}$copy($,d,i,a){const t=this.l($);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(s.URI.revive(d),s.URI.revive(i),a))}$mkdir($,d){return Promise.resolve(this.l($).createDirectory(s.URI.revive(d)))}$watch($,d,i,a){const t=this.l($).watch(s.URI.revive(i),a);this.f.set(d,t)}$unwatch($,d){const i=this.f.get(d);i&&(i.dispose(),this.f.delete(d))}$open($,d,i){const a=this.l($);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(s.URI.revive(d),i))}$close($,d){const i=this.l($);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(d))}$read($,d,i,a){const t=this.l($);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const r=E.$Se.alloc(a);return Promise.resolve(t.read(d,i,r.buffer,0,a)).then(n=>r.slice(0,n))}$write($,d,i,a){const t=this.l($);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(d,i,a.buffer,0,a.byteLength))}l($){const d=this.c.get($);if(!d){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return d}}e.$qsc=o}),define(Re[305],Ce([1,0,4,39,2,6,15,9,27,50]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rsc=void 0,T=Ue(T);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,o,m,$,d,i){this.a=Math.random(),this.b=new s.$qe,this.c=new s.$qe,this.d=new s.$qe,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const a=(0,h.$Fk)(d),t=typeof d=="string",r=i?.correlate,n=$(u=>{if(!(typeof u.session=="number"&&u.session!==this.a)&&!(r&&typeof u.session>"u")){if(!i?.ignoreCreateEvents)for(const l of u.created){const g=D.URI.revive(l);a(g.fsPath)&&(!t||o.getWorkspaceFolder(g))&&this.b.fire(g)}if(!i?.ignoreChangeEvents)for(const l of u.changed){const g=D.URI.revive(l);a(g.fsPath)&&(!t||o.getWorkspaceFolder(g))&&this.c.fire(g)}if(!i?.ignoreDeleteEvents)for(const l of u.deleted){const g=D.URI.revive(l);a(g.fsPath)&&(!t||o.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=A.$dO.from(this.i(v,m,d,i,i?.correlate),this.b,this.c,this.d,n)}i(v,o,m,$,d){const i=A.$dO.from();if(typeof m=="string"||$?.ignoreChangeEvents&&$?.ignoreCreateEvents&&$?.ignoreDeleteEvents)return i;const a=v.getProxy(O.$bO.MainThreadFileSystemEventService);let t=!1;(m.pattern.includes(h.$Bk)||m.pattern.includes(h.$Ck))&&(t=!0);let r;return d&&($?.ignoreChangeEvents||$?.ignoreCreateEvents||$?.ignoreDeleteEvents)&&(r=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,$?.ignoreChangeEvents&&(r&=~p.FileChangeFilter.UPDATED),$?.ignoreCreateEvents&&(r&=~p.FileChangeFilter.ADDED),$?.ignoreDeleteEvents&&(r&=~p.FileChangeFilter.DELETED)),a.$watch(o.identifier.value,this.a,m.baseUri,{recursive:t,excludes:$?.excludes??[],filter:r},!!d),A.$dO.from({dispose:()=>a.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class E{constructor(v){this.a=v,this.session=this.a.session,this.b=new c.$Y(()=>this.a.created.map(D.URI.revive)),this.c=new c.$Y(()=>this.a.changed.map(D.URI.revive)),this.d=new c.$Y(()=>this.a.deleted.map(D.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class f{constructor(v,o,m){this.j=v,this.k=o,this.l=m,this.a=new s.$qe,this.b=new s.$qe,this.c=new s.$qe,this.d=new s.$qe,this.g=new s.$se,this.h=new s.$se,this.i=new s.$se,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,o,m,$){return new I(this.j,v,o,this.a.event,T.GlobPattern.from(m),$)}$onFileEvent(v){this.a.fire(new E(v))}$onDidRunFileOperation(v,o){switch(v){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:o.map(m=>({oldUri:D.URI.revive(m.source),newUri:D.URI.revive(m.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:o.map(m=>D.URI.revive(m.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:o.map(m=>D.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,o){return(m,$,d)=>{const i=function(t){m.call($,t)};return i.extension=v,o.event(i,void 0,d)}}async $onWillRunFileOperation(v,o,m,$){switch(v){case p.FileOperation.MOVE:return await this.n(this.g,{files:o.map(d=>({oldUri:D.URI.revive(d.source),newUri:D.URI.revive(d.target)}))},m,$);case p.FileOperation.DELETE:return await this.n(this.i,{files:o.map(d=>D.URI.revive(d.target))},m,$);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:o.map(d=>D.URI.revive(d.target))},m,$)}}async n(v,o,m,$){const d=new Set,i=[];if(await v.fireAsync(o,$,async(t,r)=>{const n=Date.now(),u=await Promise.resolve(t);u instanceof A.$pO&&(i.push([r.extension,u]),d.add(r.extension.displayName??r.extension.identifier.value)),Date.now()-n>m&&this.k.warn("SLOW file-participant",r.extension.identifier)}),$.isCancellationRequested||i.length===0)return;const a={edits:[]};for(const[,t]of i){const{edits:r}=T.WorkspaceEdit.from(t,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(r)}return{edit:a,extensionNames:Array.from(d)}}}e.$rsc=f}),define(Re[306],Ce([1,0,18,8,20,12,135,3,24,44,13,17,2,30,197,88,147,7,23,15,9,25,118,6]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crc=void 0,o=Ue(o),i=Ue(i),n=Ue(n);class u{constructor(H,G){this.d=H,this.e=G}async provideDocumentSymbols(H,G){const Z=this.d.getDocument(H),ee=await this.e.provideDocumentSymbols(Z,G);if(!(0,s.$Ob)(ee))return ee[0]instanceof a.$zO?ee.map(i.DocumentSymbol.from):u.f(ee)}static f(H){H=H.slice(0).sort((ee,ue)=>{let ye=ee.location.range.start.compareTo(ue.location.range.start);return ye===0&&(ye=ue.location.range.end.compareTo(ee.location.range.end)),ye});const G=[],Z=[];for(const ee of H){const ue={name:ee.name||"!!MISSING: name!!",kind:i.SymbolKind.from(ee.kind),tags:ee.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:ee.containerName,range:i.Range.from(ee.location.range),selectionRange:i.Range.from(ee.location.range),children:[]};for(;;){if(Z.length===0){Z.push(ue),G.push(ue);break}const ye=Z[Z.length-1];if(P.$Yt.containsRange(ye.range,ue.range)&&!P.$Yt.equalsRange(ye.range,ue.range)){ye.children?.push(ue),Z.push(ue);break}Z.pop()}}return G}}class l{constructor(H,G,Z,ee,ue,ye){this.f=H,this.g=G,this.h=Z,this.j=ee,this.k=ue,this.l=ye,this.d=new r.$5qc("CodeLens"),this.e=new Map}async provideCodeLenses(H,G){const Z=this.f.getDocument(H),ee=await this.h.provideCodeLenses(Z,G);if(!ee||G.isCancellationRequested)return;const ue=this.d.add(ee),ye=new A.$Yc;this.e.set(ue,ye);const Ae={cacheId:ue,lenses:[]};for(let Ve=0;Ve<ee.length;Ve++)Ae.lenses.push({cacheId:[ue,Ve],range:i.Range.from(ee[Ve].range),command:this.g.toInternal(ee[Ve].command,ye)});return Ae}async resolveCodeLens(H,G){const Z=H.cacheId&&this.d.get(...H.cacheId);if(!Z)return;let ee;if(typeof this.h.resolveCodeLens!="function"||Z.isResolved?ee=Z:ee=await this.h.resolveCodeLens(Z,G),ee||(ee=Z),G.isCancellationRequested)return;const ue=H.cacheId&&this.e.get(H.cacheId[0]);if(ue){if(!ee.command){const ye=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ye),this.l.error(ye);return}return H.command=this.g.toInternal(ee.command,ue),H}}releaseCodeLenses(H){this.e.get(H)?.dispose(),this.e.delete(H),this.d.delete(H)}}function g(Ne){return Array.isArray(Ne)?Ne.map(i.DefinitionLink.from):Ne?[i.DefinitionLink.from(Ne)]:[]}class y{constructor(H,G){this.d=H,this.e=G}async provideDefinition(H,G,Z){const ee=this.d.getDocument(H),ue=i.Position.to(G),ye=await this.e.provideDefinition(ee,ue,Z);return g(ye)}}class k{constructor(H,G){this.d=H,this.e=G}async provideDeclaration(H,G,Z){const ee=this.d.getDocument(H),ue=i.Position.to(G),ye=await this.e.provideDeclaration(ee,ue,Z);return g(ye)}}class S{constructor(H,G){this.d=H,this.e=G}async provideImplementation(H,G,Z){const ee=this.d.getDocument(H),ue=i.Position.to(G),ye=await this.e.provideImplementation(ee,ue,Z);return g(ye)}}class R{constructor(H,G){this.d=H,this.e=G}async provideTypeDefinition(H,G,Z){const ee=this.d.getDocument(H),ue=i.Position.to(G),ye=await this.e.provideTypeDefinition(ee,ue,Z);return g(ye)}}class C{static{this.f=10}constructor(H,G){this.g=H,this.h=G,this.d=0,this.e=new Map}async provideHover(H,G,Z,ee){const ue=this.g.getDocument(H),ye=i.Position.to(G);let Ae;if(Z&&Z.verbosityRequest){const ot=Z.verbosityRequest.previousHover.id,ht=this.e.get(ot);if(!ht)throw new Error(`Hover with id ${ot} not found`);const at={verbosityDelta:Z.verbosityRequest.verbosityDelta,previousHover:ht};Ae=await this.h.provideHover(ue,ye,ee,at)}else Ae=await this.h.provideHover(ue,ye,ee);if(!Ae||(0,s.$Ob)(Ae.contents))return;Ae.range||(Ae.range=ue.getWordRangeAtPosition(ye)),Ae.range||(Ae.range=new a.$fO(ye,ye));const Ve=i.Hover.from(Ae),Je=this.d;if(this.e.size===C.f){const ot=Math.min(...this.e.keys());this.e.delete(ot)}return this.e.set(Je,Ae),this.d+=1,{...Ve,id:Je}}releaseHover(H){this.e.delete(H)}}class w{constructor(H,G){this.d=H,this.e=G}async provideEvaluatableExpression(H,G,Z){const ee=this.d.getDocument(H),ue=i.Position.to(G),ye=await this.e.provideEvaluatableExpression(ee,ue,Z);if(ye)return i.EvaluatableExpression.from(ye)}}class b{constructor(H,G){this.d=H,this.e=G}async provideInlineValues(H,G,Z,ee){const ue=this.d.getDocument(H),ye=await this.e.provideInlineValues(ue,i.Range.to(G),i.InlineValueContext.to(Z),ee);if(Array.isArray(ye))return ye.map(Ae=>i.InlineValue.from(Ae))}}class N{constructor(H,G){this.d=H,this.e=G}async provideDocumentHighlights(H,G,Z){const ee=this.d.getDocument(H),ue=i.Position.to(G),ye=await this.e.provideDocumentHighlights(ee,ue,Z);if(Array.isArray(ye))return ye.map(i.DocumentHighlight.from)}}class L{constructor(H,G){this.d=H,this.e=G}async provideMultiDocumentHighlights(H,G,Z,ee){const ue=this.d.getDocument(H),ye=Z.map(Je=>this.d.getDocument(Je)),Ae=i.Position.to(G),Ve=await this.e.provideMultiDocumentHighlights(ue,Ae,ye,ee);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class M{constructor(H,G){this.d=H,this.e=G}async provideLinkedEditingRanges(H,G,Z){const ee=this.d.getDocument(H),ue=i.Position.to(G),ye=await this.e.provideLinkedEditingRanges(ee,ue,Z);if(ye&&Array.isArray(ye.ranges))return{ranges:(0,s.$Lb)(ye.ranges.map(i.Range.from)),wordPattern:ye.wordPattern}}}class z{constructor(H,G){this.d=H,this.e=G}async provideReferences(H,G,Z,ee){const ue=this.d.getDocument(H),ye=i.Position.to(G),Ae=await this.e.provideReferences(ue,ye,Z,ee);if(Array.isArray(Ae))return Ae.map(i.location.from)}}class V{static{this.d=1e3}constructor(H,G,Z,ee,ue,ye,Ae){this.g=H,this.h=G,this.j=Z,this.k=ee,this.l=ue,this.m=ye,this.n=Ae,this.e=new r.$5qc("CodeAction"),this.f=new Map}async provideCodeActions(H,G,Z,ee){const ue=this.g.getDocument(H),ye=v.$1t.isISelection(G)?i.Selection.to(G):i.Range.to(G),Ae=[];for(const at of this.j.getDiagnostics(H))if(ye.intersection(at.range)&&Ae.push(at)>V.d)break;const Ve={diagnostics:Ae,only:Z.only?new a.$BO(Z.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Z.trigger)},Je=await this.k.provideCodeActions(ue,ye,Ve,ee);if(!(0,s.$Pb)(Je)||ee.isCancellationRequested)return;const nt=this.e.add(Je),ot=new A.$Yc;this.f.set(nt,ot);const ht=[];for(let at=0;at<Je.length;at++){const lt=Je[at];if(lt)if(V.o(lt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ht.push({_isSynthetic:!0,title:lt.title,command:this.h.toInternal(lt,ot)});else{Ve.only&&(lt.kind?Ve.only.contains(lt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value}' requested but returned code action is of kind '${lt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const pt=lt.ranges??[];ht.push({cacheId:[nt,at],title:lt.title,command:lt.command&&this.h.toInternal(lt.command,ot),diagnostics:lt.diagnostics&&lt.diagnostics.map(i.Diagnostic.from),edit:lt.edit&&i.WorkspaceEdit.from(lt.edit,void 0),kind:lt.kind&&lt.kind.value,isPreferred:lt.isPreferred,isAI:(0,t.$CH)(this.m,"codeActionAI")?lt.isAI:!1,ranges:(0,t.$CH)(this.m,"codeActionRanges")?(0,s.$Lb)(pt.map(i.Range.from)):void 0,disabled:lt.disabled?.reason})}}return{cacheId:nt,actions:ht}}async resolveCodeAction(H,G){const[Z,ee]=H,ue=this.e.get(Z,ee);if(!ue||V.o(ue))return{};if(!this.k.resolveCodeAction)return{};const ye=await this.k.resolveCodeAction(ue,G)??ue;let Ae;ye.edit&&(Ae=i.WorkspaceEdit.from(ye.edit,void 0));let Ve;if(ye.command){const Je=this.f.get(Z);Je&&(Ve=this.h.toInternal(ye.command,Je))}return{edit:Ae,command:Ve}}releaseCodeActions(H){this.f.get(H)?.dispose(),this.f.delete(H),this.e.delete(H)}static o(H){return typeof H.command=="string"&&typeof H.title=="string"}}class F{constructor(H,G,Z,ee,ue){this.e=H,this.f=G,this.g=Z,this.h=ee,this.j=ue,this.d=new r.$5qc("DocumentPasteEdit")}async prepareDocumentPaste(H,G,Z,ee){if(!this.g.prepareDocumentPaste)return;const ue=this.f.getDocument(H),ye=G.map(Je=>i.Range.to(Je)),Ae=i.DataTransfer.toDataTransfer(Z,()=>{throw new O.$cb});if(await this.g.prepareDocumentPaste(ue,ye,Ae,ee),ee.isCancellationRequested)return;const Ve=Array.from(Ae).filter(([,Je])=>!(Je instanceof a.$8O));return i.DataTransfer.from(Ve)}async providePasteEdits(H,G,Z,ee,ue,ye){if(!this.g.provideDocumentPasteEdits)return[];const Ae=this.f.getDocument(G),Ve=Z.map(ht=>i.Range.to(ht)),Je=i.DataTransfer.toDataTransfer(ee,async ht=>(await this.e.$resolvePasteFileData(this.h,H,ht)).buffer),nt=await this.g.provideDocumentPasteEdits(Ae,Ve,Je,{only:ue.only?new a.$aP(ue.only):void 0,triggerKind:ue.triggerKind},ye);if(!nt||ye.isCancellationRequested)return[];const ot=this.d.add(nt);return nt.map((ht,at)=>({_cacheId:[ot,at],title:ht.title??(0,$.localize)(2704,null,this.j.displayName||this.j.name),kind:ht.kind,yieldTo:ht.yieldTo?.map(lt=>lt.value),insertText:typeof ht.insertText=="string"?ht.insertText:{snippet:ht.insertText.value},additionalEdit:ht.additionalEdit?i.WorkspaceEdit.from(ht.additionalEdit,void 0):void 0}))}async resolvePasteEdit(H,G){const[Z,ee]=H,ue=this.d.get(Z,ee);if(!ue||!this.g.resolveDocumentPasteEdit)return{};const ye=await this.g.resolveDocumentPasteEdit(ue,G)??ue;return{additionalEdit:ye.additionalEdit?i.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}releasePasteEdits(H){this.d.delete(H)}}class j{constructor(H,G){this.d=H,this.e=G}async provideDocumentFormattingEdits(H,G,Z){const ee=this.d.getDocument(H),ue=await this.e.provideDocumentFormattingEdits(ee,G,Z);if(Array.isArray(ue))return ue.map(i.TextEdit.from)}}class W{constructor(H,G){this.d=H,this.e=G}async provideDocumentRangeFormattingEdits(H,G,Z,ee){const ue=this.d.getDocument(H),ye=i.Range.to(G),Ae=await this.e.provideDocumentRangeFormattingEdits(ue,ye,Z,ee);if(Array.isArray(Ae))return Ae.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(H,G,Z,ee){(0,E.$tg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ue=this.d.getDocument(H),ye=G.map(i.Range.to),Ae=await this.e.provideDocumentRangesFormattingEdits(ue,ye,Z,ee);if(Array.isArray(Ae))return Ae.map(i.TextEdit.from)}}class J{constructor(H,G){this.d=H,this.e=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,G,Z,ee,ue){const ye=this.d.getDocument(H),Ae=i.Position.to(G),Ve=await this.e.provideOnTypeFormattingEdits(ye,Ae,Z,ee,ue);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class B{constructor(H,G){this.e=H,this.f=G,this.d=new r.$5qc("WorkspaceSymbols")}async provideWorkspaceSymbols(H,G){const Z=await this.e.provideWorkspaceSymbols(H,G);if(!(0,s.$Pb)(Z))return{symbols:[]};const ee=this.d.add(Z),ue={cacheId:ee,symbols:[]};for(let ye=0;ye<Z.length;ye++){const Ae=Z[ye];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}ue.symbols.push({...i.WorkspaceSymbol.from(Ae),cacheId:[ee,ye]})}return ue}async resolveWorkspaceSymbol(H,G){if(typeof this.e.resolveWorkspaceSymbol!="function"||!H.cacheId)return H;const Z=this.d.get(...H.cacheId);if(Z){const ee=await this.e.resolveWorkspaceSymbol(Z,G);return ee&&(0,p.$po)(H,i.WorkspaceSymbol.from(ee),!0)}}releaseWorkspaceSymbols(H){this.d.delete(H)}}class U{static supportsResolving(H){return typeof H.prepareRename=="function"}constructor(H,G,Z){this.d=H,this.e=G,this.f=Z}async provideRenameEdits(H,G,Z,ee){const ue=this.d.getDocument(H),ye=i.Position.to(G);try{const Ae=await this.e.provideRenameEdits(ue,ye,Z,ee);return Ae?i.WorkspaceEdit.from(Ae):void 0}catch(Ae){const Ve=U.g(Ae);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(H,G,Z){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const ee=this.d.getDocument(H),ue=i.Position.to(G);try{const ye=await this.e.prepareRename(ee,ue,Z);let Ae,Ve;if(a.$fO.isRange(ye)?(Ae=ye,Ve=ee.getText(ye)):(0,E.$lg)(ye)&&(Ae=ye.range,Ve=ye.placeholder),!Ae||!Ve)return;if(Ae.start.line>ue.line||Ae.end.line<ue.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ae),text:Ve}}catch(ye){const Ae=U.g(ye);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(ye)}}static g(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class _{static{this.d={[o.NewSymbolNameTriggerKind.Invoke]:a.NewSymbolNameTriggerKind.Invoke,[o.NewSymbolNameTriggerKind.Automatic]:a.NewSymbolNameTriggerKind.Automatic}}constructor(H,G,Z){this.e=H,this.f=G,this.g=Z}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(H,G,Z,ee){const ue=this.e.getDocument(H),ye=i.Range.to(G);try{const Ae=_.d[Z],Ve=await this.f.provideNewSymbolNames(ue,ye,Ae,ee);return Ve?Ve.map(Je=>typeof Je=="string"?{newSymbolName:Je}:{newSymbolName:Je.newSymbolName,tags:Je.tags}):void 0}catch(Ae){this.g.error(_.h(Ae)??JSON.stringify(Ae,null,"	"));return}}static h(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class x{constructor(H,G){this.resultId=H,this.tokens=G}}class oe{constructor(H,G){this.f=H,this.g=G,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(H,G,Z){const ee=this.f.getDocument(H),ue=G!==0?this.d.get(G):null;let ye=typeof ue?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(ee,ue.resultId,Z):await this.g.provideDocumentSemanticTokens(ee,Z);return ue&&this.d.delete(G),ye?(ye=oe.h(ye),this.o(oe.n(ue,ye),ye)):null}async releaseDocumentSemanticColoring(H){this.d.delete(H)}static h(H){return oe.j(H)?oe.k(H)?H:new a.$AP(new Uint32Array(H.data),H.resultId):oe.l(H)?oe.m(H)?H:new a.$CP(H.edits.map(G=>new a.$BP(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),H.resultId):H}static j(H){return H&&!!H.data}static k(H){return H.data instanceof Uint32Array}static l(H){return H&&Array.isArray(H.edits)}static m(H){for(const G of H.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static n(H,G){if(!oe.j(G)||!H||!H.tokens)return G;const Z=H.tokens,ee=Z.length,ue=G.data,ye=ue.length;let Ae=0;const Ve=Math.min(ee,ye);for(;Ae<Ve&&Z[Ae]===ue[Ae];)Ae++;if(Ae===ee&&Ae===ye)return new a.$CP([],G.resultId);let Je=0;const nt=Ve-Ae;for(;Je<nt&&Z[ee-Je-1]===ue[ye-Je-1];)Je++;return new a.$CP([{start:Ae,deleteCount:ee-Ae-Je,data:ue.subarray(Ae,ye-Je)}],G.resultId)}o(H,G){if(oe.j(H)){const Z=this.e++;return this.d.set(Z,new x(H.resultId,H.data)),(0,m.$Feb)({id:Z,type:"full",data:H.data})}if(oe.l(H)){const Z=this.e++;return oe.j(G)?this.d.set(Z,new x(G.resultId,G.data)):this.d.set(Z,new x(H.resultId)),(0,m.$Feb)({id:Z,type:"delta",deltas:(H.edits||[]).map(ee=>({start:ee.start,deleteCount:ee.deleteCount,data:ee.data}))})}return null}}class te{constructor(H,G){this.d=H,this.e=G}async provideDocumentRangeSemanticTokens(H,G,Z){const ee=this.d.getDocument(H),ue=await this.e.provideDocumentRangeSemanticTokens(ee,i.Range.to(G),Z);return ue?this.f(ue):null}f(H){return(0,m.$Feb)({id:0,type:"full",data:H.data})}}class me{static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}constructor(H,G,Z,ee,ue){this.f=H,this.g=G,this.h=Z,this.j=ee,this.k=ue,this.d=new r.$5qc("CompletionItem"),this.e=new Map}async provideCompletionItems(H,G,Z,ee){const ue=this.f.getDocument(H),ye=i.Position.to(G),Ae=ue.getWordRangeAtPosition(ye)||new a.$fO(ye,ye),Ve=Ae.with({end:ye}),Je=new c.$ke,nt=await this.h.provideCompletionItems(ue,ye,ee,i.CompletionContext.to(Z));if(!nt||ee.isCancellationRequested)return;const ot=Array.isArray(nt)?new a.$OO(nt):nt,ht=me.supportsResolving(this.h)?this.d.add(ot.items):this.d.add([]),at=new A.$Yc;this.e.set(ht,at);const lt=[],pt={x:ht,[n.ISuggestResultDtoField.completions]:lt,[n.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ae),insert:i.Range.from(Ve)},[n.ISuggestResultDtoField.isIncomplete]:ot.isIncomplete||void 0,[n.ISuggestResultDtoField.duration]:Je.elapsed()};for(let it=0;it<ot.items.length;it++){const Ie=ot.items[it],re=this.l(Ie,[ht,it],Ve,Ae);lt.push(re)}return pt}async resolveCompletionItem(H,G){if(typeof this.h.resolveCompletionItem!="function")return;const Z=this.d.get(...H);if(!Z)return;const ee=this.l(Z,H),ue=await this.h.resolveCompletionItem(Z,G);if(!ue)return;const ye=this.l(ue,H);return(ee[n.ISuggestDataDtoField.insertText]!==ye[n.ISuggestDataDtoField.insertText]||ee[n.ISuggestDataDtoField.insertTextRules]!==ye[n.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(ee[n.ISuggestDataDtoField.commandIdent]!==ye[n.ISuggestDataDtoField.commandIdent]||ee[n.ISuggestDataDtoField.commandId]!==ye[n.ISuggestDataDtoField.commandId]||!(0,p.$qo)(ee[n.ISuggestDataDtoField.commandArguments],ye[n.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...ee,[n.ISuggestDataDtoField.documentation]:ye[n.ISuggestDataDtoField.documentation],[n.ISuggestDataDtoField.detail]:ye[n.ISuggestDataDtoField.detail],[n.ISuggestDataDtoField.additionalTextEdits]:ye[n.ISuggestDataDtoField.additionalTextEdits],[n.ISuggestDataDtoField.insertText]:ye[n.ISuggestDataDtoField.insertText],[n.ISuggestDataDtoField.insertTextRules]:ye[n.ISuggestDataDtoField.insertTextRules],[n.ISuggestDataDtoField.commandIdent]:ye[n.ISuggestDataDtoField.commandIdent],[n.ISuggestDataDtoField.commandId]:ye[n.ISuggestDataDtoField.commandId],[n.ISuggestDataDtoField.commandArguments]:ye[n.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(H){this.e.get(H)?.dispose(),this.e.delete(H),this.d.delete(H)}l(H,G,Z,ee){const ue=this.e.get(G[0]);if(!ue)throw Error("DisposableStore is missing...");const ye=this.g.toInternal(H.command,ue),Ae={x:G,[n.ISuggestDataDtoField.label]:H.label,[n.ISuggestDataDtoField.kind]:H.kind!==void 0?i.CompletionItemKind.from(H.kind):void 0,[n.ISuggestDataDtoField.kindModifier]:H.tags&&H.tags.map(i.CompletionItemTag.from),[n.ISuggestDataDtoField.detail]:H.detail,[n.ISuggestDataDtoField.documentation]:typeof H.documentation>"u"?void 0:i.MarkdownString.fromStrict(H.documentation),[n.ISuggestDataDtoField.sortText]:H.sortText!==H.label?H.sortText:void 0,[n.ISuggestDataDtoField.filterText]:H.filterText!==H.label?H.filterText:void 0,[n.ISuggestDataDtoField.preselect]:H.preselect||void 0,[n.ISuggestDataDtoField.insertTextRules]:H.keepWhitespace?o.CompletionItemInsertTextRule.KeepWhitespace:o.CompletionItemInsertTextRule.None,[n.ISuggestDataDtoField.commitCharacters]:H.commitCharacters?.join(""),[n.ISuggestDataDtoField.additionalTextEdits]:H.additionalTextEdits&&H.additionalTextEdits.map(i.TextEdit.from),[n.ISuggestDataDtoField.commandIdent]:ye?.$ident,[n.ISuggestDataDtoField.commandId]:ye?.id,[n.ISuggestDataDtoField.commandArguments]:ye?.$ident?void 0:ye?.arguments};H.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae[n.ISuggestDataDtoField.insertText]=H.textEdit.newText):typeof H.insertText=="string"?Ae[n.ISuggestDataDtoField.insertText]=H.insertText:H.insertText instanceof a.$qO&&(Ae[n.ISuggestDataDtoField.insertText]=H.insertText.value,Ae[n.ISuggestDataDtoField.insertTextRules]|=o.CompletionItemInsertTextRule.InsertAsSnippet);let Ve;return H.textEdit?Ve=H.textEdit.range:H.range&&(Ve=H.range),a.$fO.isRange(Ve)?Ae[n.ISuggestDataDtoField.range]=i.Range.from(Ve):Ve&&(!Z?.isEqual(Ve.inserting)||!ee?.isEqual(Ve.replacing))&&(Ae[n.ISuggestDataDtoField.range]={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),Ae}}class ce{async provideInlineCompletions(H,G,Z,ee){}async provideInlineEdits(H,G,Z,ee){}disposeCompletions(H){}handleDidShowCompletionItem(H,G,Z){}handlePartialAccept(H,G,Z,ee){}}class Y extends ce{constructor(H,G,Z,ee){super(),this.f=H,this.g=G,this.h=Z,this.j=ee,this.d=new se,this.e=(0,t.$CH)(this.f,"inlineCompletionsAdditions"),this.k={[o.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[o.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$CH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(H,G,Z,ee){const ue=this.g.getDocument(H),ye=i.Position.to(G),Ae=await this.h.provideInlineCompletionItems(ue,ye,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:i.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Z.triggerKind]},ee);if(!Ae||ee.isCancellationRequested)return;const Ve=Array.isArray(Ae)?Ae:Ae.items,Je=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[],nt=this.e&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:Ve}),items:Ve.map((at,lt)=>{let pt;at.command&&(ot||(ot=new A.$Yc),pt=this.j.toInternal(at.command,ot));const it=at.insertText;return{insertText:typeof it=="string"?it:{snippet:it.value},filterText:at.filterText,range:at.range?i.Range.from(at.range):void 0,command:pt,idx:lt,completeBracketPairs:this.e?at.completeBracketPairs:!1}}),commands:Je.map(at=>(ot||(ot=new A.$Yc),this.j.toInternal(at,ot))),suppressSuggestions:!1,enableForwardStability:nt}}async provideInlineEdits(H,G,Z,ee){if(!this.h.provideInlineEdits)return;(0,t.$DH)(this.f,"inlineCompletionsAdditions");const ue=this.g.getDocument(H),ye=i.Range.to(G),Ae=await this.h.provideInlineEdits(ue,ye,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:i.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Z.triggerKind],userPrompt:Z.userPrompt},ee);if(!Ae||ee.isCancellationRequested)return;const Ve=Array.isArray(Ae)?Ae:Ae.items,Je=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[],nt=this.e&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:Ve}),items:Ve.map((at,lt)=>{let pt;at.command&&(ot||(ot=new A.$Yc),pt=this.j.toInternal(at.command,ot));const it=at.insertText;return{insertText:typeof it=="string"?it:{snippet:it.value},filterText:at.filterText,range:at.range?i.Range.from(at.range):void 0,command:pt,idx:lt,completeBracketPairs:this.e?at.completeBracketPairs:!1}}),commands:Je.map(at=>(ot||(ot=new A.$Yc),this.j.toInternal(at,ot))),suppressSuggestions:!1,enableForwardStability:nt}}disposeCompletions(H){this.d.disposeReferenceId(H)?.dispose()}handleDidShowCompletionItem(H,G,Z){const ee=this.d.get(H)?.items[G];ee&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(ee,Z)}handlePartialAccept(H,G,Z,ee){const ue=this.d.get(H)?.items[G];ue&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ue,Z),this.h.handleDidPartiallyAcceptCompletionItem(ue,i.PartialAcceptInfo.to(ee)))}}class q{async provideInlineEdits(H,G,Z){const ee=this.f.getDocument(H),ue=await this.g.provideInlineEdit(ee,{triggerKind:this.e[G.triggerKind]},Z);if(!ue||Z.isCancellationRequested)return;let ye;const Ae=this.d.createReferenceId({dispose(){ye?.dispose()},item:ue});let Ve;ue.accepted&&(ye||(ye=new A.$Yc),Ve=this.h.toInternal(ue.accepted,ye));let Je;return ue.rejected&&(ye||(ye=new A.$Yc),Je=this.h.toInternal(ue.rejected,ye)),{pid:Ae,text:ue.text,range:i.Range.from(ue.range),accepted:Ve,rejected:Je}}disposeEdit(H){this.d.disposeReferenceId(H)?.dispose()}constructor(H,G,Z,ee){this.f=G,this.g=Z,this.h=ee,this.d=new se,this.e={[o.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[o.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(H){const G=this.e++;return this.d.set(G,H),G}disposeReferenceId(H){const G=this.d.get(H);return this.d.delete(H),G}get(H){return this.d.get(H)}}class be{constructor(H,G){this.e=H,this.f=G,this.d=new r.$5qc("SignatureHelp")}async provideSignatureHelp(H,G,Z,ee){const ue=this.e.getDocument(H),ye=i.Position.to(G),Ae=this.g(Z),Ve=await this.f.provideSignatureHelp(ue,ye,ee,Ae);if(Ve){const Je=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Je}}}g(H){let G;if(H.activeSignatureHelp){const Z=i.SignatureHelp.to(H.activeSignatureHelp),ee=this.d.get(H.activeSignatureHelp.id,0);ee?(G=ee,G.activeSignature=Z.activeSignature,G.activeParameter=Z.activeParameter):G=Z}return{...H,activeSignatureHelp:G}}releaseSignatureHelp(H){this.d.delete(H)}}class ae{constructor(H,G,Z,ee,ue){this.f=H,this.g=G,this.h=Z,this.j=ee,this.k=ue,this.d=new r.$5qc("InlayHints"),this.e=new Map}async provideInlayHints(H,G,Z){const ee=this.f.getDocument(H),ue=i.Range.to(G),ye=await this.h.provideInlayHints(ee,ue,Z);if(!Array.isArray(ye)||ye.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(G)}`);return}if(Z.isCancellationRequested)return;const Ae=this.d.add(ye);this.e.set(Ae,new A.$Yc);const Ve={hints:[],cacheId:Ae};for(let Je=0;Je<ye.length;Je++)this.l(ye[Je],ue)&&Ve.hints.push(this.m(ye[Je],[Ae,Je]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(G)}`),Ve}async resolveInlayHint(H,G){if(typeof this.h.resolveInlayHint!="function")return;const Z=this.d.get(...H);if(!Z)return;const ee=await this.h.resolveInlayHint(Z,G);if(ee&&this.l(ee))return this.m(ee,H)}releaseHints(H){this.e.get(H)?.dispose(),this.e.delete(H),this.d.delete(H)}l(H,G){return H.label.length===0||Array.isArray(H.label)&&H.label.every(Z=>Z.value.length===0)?(console.log("INVALID inlay hint, empty label",H),!1):!(G&&!G.contains(H.position))}m(H,G){const Z=this.e.get(G[0]);if(!Z)throw Error("DisposableStore is missing...");const ee={label:"",cacheId:G,tooltip:i.MarkdownString.fromStrict(H.tooltip),position:i.Position.from(H.position),textEdits:H.textEdits&&H.textEdits.map(i.TextEdit.from),kind:H.kind&&i.InlayHintKind.from(H.kind),paddingLeft:H.paddingLeft,paddingRight:H.paddingRight};if(typeof H.label=="string")ee.label=H.label;else{const ue=[];ee.label=ue;for(const ye of H.label){if(!ye.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ae={label:ye.value,tooltip:i.MarkdownString.fromStrict(ye.tooltip)};a.$rO.isLocation(ye.location)&&(Ae.location=i.location.from(ye.location)),ye.command&&(Ae.command=this.g.toInternal(ye.command,Z)),ue.push(Ae)}}return ee}}class we{constructor(H,G){this.e=H,this.f=G,this.d=new r.$5qc("DocumentLink")}async provideLinks(H,G){const Z=this.e.getDocument(H),ee=await this.f.provideDocumentLinks(Z,G);if(!(!Array.isArray(ee)||ee.length===0)&&!G.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:ee.filter(we.g).map(i.DocumentLink.from)};{const ue=this.d.add(ee),ye={links:[],cacheId:ue};for(let Ae=0;Ae<ee.length;Ae++){if(!we.g(ee[Ae]))continue;const Ve=i.DocumentLink.from(ee[Ae]);Ve.cacheId=[ue,Ae],ye.links.push(Ve)}return ye}}}static g(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,G){if(typeof this.f.resolveDocumentLink!="function")return;const Z=this.d.get(...H);if(!Z)return;const ee=await this.f.resolveDocumentLink(Z,G);if(!(!ee||!we.g(ee)))return i.DocumentLink.from(ee)}releaseLinks(H){this.d.delete(H)}}class $e{constructor(H,G){this.d=H,this.e=G}async provideColors(H,G){const Z=this.d.getDocument(H),ee=await this.e.provideDocumentColors(Z,G);return Array.isArray(ee)?ee.map(ye=>({color:i.Color.from(ye.color),range:i.Range.from(ye.range)})):[]}async provideColorPresentations(H,G,Z){const ee=this.d.getDocument(H),ue=i.Range.to(G.range),ye=i.Color.to(G.color),Ae=await this.e.provideColorPresentations(ye,{document:ee,range:ue},Z);if(Array.isArray(Ae))return Ae.map(i.ColorPresentation.from)}}class pe{constructor(H,G){this.d=H,this.e=G}async provideFoldingRanges(H,G,Z){const ee=this.d.getDocument(H),ue=await this.e.provideFoldingRanges(ee,G,Z);if(Array.isArray(ue))return ue.map(i.FoldingRange.from)}}class Oe{constructor(H,G,Z){this.d=H,this.e=G,this.f=Z}async provideSelectionRanges(H,G,Z){const ee=this.d.getDocument(H),ue=G.map(i.Position.to),ye=await this.e.provideSelectionRanges(ee,ue,Z);if(!(0,s.$Pb)(ye))return[];if(ye.length!==ue.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let Ve=0;Ve<ue.length;Ve++){const Je=[];Ae.push(Je);let nt=ue[Ve],ot=ye[Ve];for(;;){if(!ot.range.contains(nt))throw new Error("INVALID selection range, must contain the previous range");if(Je.push(i.SelectionRange.from(ot)),!ot.parent)break;nt=ot.range,ot=ot.parent}}return Ae}}class Fe{constructor(H,G){this.f=H,this.g=G,this.d=new T.$TQ(""),this.e=new Map}async prepareSession(H,G,Z){const ee=this.f.getDocument(H),ue=i.Position.to(G),ye=await this.g.prepareCallHierarchy(ee,ue,Z);if(!ye)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(ye)?ye.map(Ve=>this.h(Ae,Ve)):[this.h(Ae,ye)]}async provideCallsTo(H,G,Z){const ee=this.j(H,G);if(!ee)throw new Error("missing call hierarchy item");const ue=await this.g.provideCallHierarchyIncomingCalls(ee,Z);if(ue)return ue.map(ye=>({from:this.h(H,ye.from),fromRanges:ye.fromRanges.map(Ae=>i.Range.from(Ae))}))}async provideCallsFrom(H,G,Z){const ee=this.j(H,G);if(!ee)throw new Error("missing call hierarchy item");const ue=await this.g.provideCallHierarchyOutgoingCalls(ee,Z);if(ue)return ue.map(ye=>({to:this.h(H,ye.to),fromRanges:ye.fromRanges.map(Ae=>i.Range.from(Ae))}))}releaseSession(H){this.e.delete(H)}h(H,G){const Z=this.e.get(H),ee=i.CallHierarchyItem.from(G,H,Z.size.toString(36));return Z.set(ee._itemId,G),ee}j(H,G){return this.e.get(H)?.get(G)}}class He{constructor(H,G){this.f=H,this.g=G,this.d=new T.$TQ(""),this.e=new Map}async prepareSession(H,G,Z){const ee=this.f.getDocument(H),ue=i.Position.to(G),ye=await this.g.prepareTypeHierarchy(ee,ue,Z);if(!ye)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(ye)?ye.map(Ve=>this.h(Ae,Ve)):[this.h(Ae,ye)]}async provideSupertypes(H,G,Z){const ee=this.j(H,G);if(!ee)throw new Error("missing type hierarchy item");const ue=await this.g.provideTypeHierarchySupertypes(ee,Z);if(ue)return ue.map(ye=>this.h(H,ye))}async provideSubtypes(H,G,Z){const ee=this.j(H,G);if(!ee)throw new Error("missing type hierarchy item");const ue=await this.g.provideTypeHierarchySubtypes(ee,Z);if(ue)return ue.map(ye=>this.h(H,ye))}releaseSession(H){this.e.delete(H)}h(H,G){const Z=this.e.get(H),ee=i.TypeHierarchyItem.from(G,H,Z.size.toString(36));return Z.set(ee._itemId,G),ee}j(H,G){return this.e.get(H)?.get(G)}}class Ze{constructor(H,G,Z,ee,ue){this.e=H,this.f=G,this.g=Z,this.h=ee,this.j=ue,this.d=new r.$5qc("DocumentDropEdit")}async provideDocumentOnDropEdits(H,G,Z,ee,ue){const ye=this.f.getDocument(G),Ae=i.Position.to(Z),Ve=i.DataTransfer.toDataTransfer(ee,async ht=>(await this.e.$resolveDocumentOnDropFileData(this.h,H,ht)).buffer),Je=await this.g.provideDocumentDropEdits(ye,Ae,Ve,ue);if(!Je)return;const nt=(0,s.$6b)(Je),ot=this.d.add(nt);return nt.map((ht,at)=>({_cacheId:[ot,at],title:ht.title??(0,$.localize)(2705,null,this.j.displayName||this.j.name),kind:ht.kind?.value,yieldTo:ht.yieldTo?.map(lt=>lt.value),insertText:typeof ht.insertText=="string"?ht.insertText:{snippet:ht.insertText.value},additionalEdit:ht.additionalEdit?i.WorkspaceEdit.from(ht.additionalEdit,void 0):void 0}))}async resolveDropEdit(H,G){const[Z,ee]=H,ue=this.d.get(Z,ee);if(!ue||!this.g.resolveDocumentDropEdit)return{};const ye=await this.g.resolveDocumentDropEdit(ue,G)??ue;return{additionalEdit:ye.additionalEdit?i.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}releaseDropEdits(H){this.d.delete(H)}}class xe{constructor(H,G){this.d=H,this.e=G}async provideMappedEdits(H,G,Z,ee){const ue=f.URI.revive(H),ye=this.d.getDocument(ue),Ae=Z.documents.map(nt=>nt.map(ot=>({uri:f.URI.revive(ot.uri),version:ot.version,ranges:ot.ranges.map(ht=>i.Range.to(ht))}))),Ve={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},Je=await this.e.provideMappedEdits(ye,G,Ve,ee);return Je?i.WorkspaceEdit.from(Je):null}}class je{constructor(H,G){this.adapter=H,this.extension=G}}class qe{static{this.d=0}constructor(H,G,Z,ee,ue,ye,Ae,Ve){this.g=G,this.h=Z,this.j=ee,this.k=ue,this.l=ye,this.m=Ae,this.n=Ve,this.f=new Map,this.e=H.getProxy(n.$bO.MainThreadLanguageFeatures)}o(H,G){return i.DocumentSelector.from(H,this.g,G)}p(H){return new a.$dO(()=>{this.f.delete(H),this.e.$unregister(H)})}q(){return qe.d++}async s(H,G,Z,ee,ue,ye=!1){const Ae=this.f.get(H);if(!Ae||!(Ae.adapter instanceof G))return ee;const Ve=Date.now();ye||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${Z.toString().replace(/[\r\n]/g,"")}'`);const Je=Z(Ae.adapter,Ae.extension);return Promise.resolve(Je).catch(nt=>{(0,O.$8)(nt)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(nt),this.n.onExtensionError(Ae.extension.identifier,nt))}).finally(()=>{ye||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),D.CancellationToken.isCancellationToken(ue)?(0,h.$zh)(Je,ue):Je}t(H,G){const Z=this.q();return this.f.set(Z,new je(H,G)),Z}static u(H){return H.displayName||H.name}static w(H){return H.identifier.value}registerDocumentSymbolProvider(H,G,Z,ee){const ue=this.t(new u(this.h,Z),H),ye=ee&&ee.label||qe.u(H);return this.e.$registerDocumentSymbolProvider(ue,this.o(G,H),ye),this.p(ue)}$provideDocumentSymbols(H,G,Z){return this.s(H,u,ee=>ee.provideDocumentSymbols(f.URI.revive(G),Z),void 0,Z)}registerCodeLensProvider(H,G,Z){const ee=this.q(),ue=typeof Z.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(ee,new je(new l(this.h,this.j.converter,Z,H,this.n,this.l),H)),this.e.$registerCodeLensSupport(ee,this.o(G,H),ue);let ye=this.p(ee);if(ue!==void 0){const Ae=Z.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(ue));ye=a.$dO.from(ye,Ae)}return ye}$provideCodeLenses(H,G,Z){return this.s(H,l,ee=>ee.provideCodeLenses(f.URI.revive(G),Z),void 0,Z,G.scheme==="output")}$resolveCodeLens(H,G,Z){return this.s(H,l,ee=>ee.resolveCodeLens(G,Z),void 0,void 0,!0)}$releaseCodeLenses(H,G){this.s(H,l,Z=>Promise.resolve(Z.releaseCodeLenses(G)),void 0,void 0,!0)}registerDefinitionProvider(H,G,Z){const ee=this.t(new y(this.h,Z),H);return this.e.$registerDefinitionSupport(ee,this.o(G,H)),this.p(ee)}$provideDefinition(H,G,Z,ee){return this.s(H,y,ue=>ue.provideDefinition(f.URI.revive(G),Z,ee),[],ee)}registerDeclarationProvider(H,G,Z){const ee=this.t(new k(this.h,Z),H);return this.e.$registerDeclarationSupport(ee,this.o(G,H)),this.p(ee)}$provideDeclaration(H,G,Z,ee){return this.s(H,k,ue=>ue.provideDeclaration(f.URI.revive(G),Z,ee),[],ee)}registerImplementationProvider(H,G,Z){const ee=this.t(new S(this.h,Z),H);return this.e.$registerImplementationSupport(ee,this.o(G,H)),this.p(ee)}$provideImplementation(H,G,Z,ee){return this.s(H,S,ue=>ue.provideImplementation(f.URI.revive(G),Z,ee),[],ee)}registerTypeDefinitionProvider(H,G,Z){const ee=this.t(new R(this.h,Z),H);return this.e.$registerTypeDefinitionSupport(ee,this.o(G,H)),this.p(ee)}$provideTypeDefinition(H,G,Z,ee){return this.s(H,R,ue=>ue.provideTypeDefinition(f.URI.revive(G),Z,ee),[],ee)}registerHoverProvider(H,G,Z,ee){const ue=this.t(new C(this.h,Z),H);return this.e.$registerHoverProvider(ue,this.o(G,H)),this.p(ue)}$provideHover(H,G,Z,ee,ue){return this.s(H,C,ye=>ye.provideHover(f.URI.revive(G),Z,ee,ue),void 0,ue)}$releaseHover(H,G){this.s(H,C,Z=>Promise.resolve(Z.releaseHover(G)),void 0,void 0)}registerEvaluatableExpressionProvider(H,G,Z,ee){const ue=this.t(new w(this.h,Z),H);return this.e.$registerEvaluatableExpressionProvider(ue,this.o(G,H)),this.p(ue)}$provideEvaluatableExpression(H,G,Z,ee){return this.s(H,w,ue=>ue.provideEvaluatableExpression(f.URI.revive(G),Z,ee),void 0,ee)}registerInlineValuesProvider(H,G,Z,ee){const ue=typeof Z.onDidChangeInlineValues=="function"?this.q():void 0,ye=this.t(new b(this.h,Z),H);this.e.$registerInlineValuesProvider(ye,this.o(G,H),ue);let Ae=this.p(ye);if(ue!==void 0){const Ve=Z.onDidChangeInlineValues(Je=>this.e.$emitInlineValuesEvent(ue));Ae=a.$dO.from(Ae,Ve)}return Ae}$provideInlineValues(H,G,Z,ee,ue){return this.s(H,b,ye=>ye.provideInlineValues(f.URI.revive(G),Z,ee,ue),void 0,ue)}registerDocumentHighlightProvider(H,G,Z){const ee=this.t(new N(this.h,Z),H);return this.e.$registerDocumentHighlightProvider(ee,this.o(G,H)),this.p(ee)}registerMultiDocumentHighlightProvider(H,G,Z){const ee=this.t(new L(this.h,Z),H);return this.e.$registerMultiDocumentHighlightProvider(ee,this.o(G,H)),this.p(ee)}$provideDocumentHighlights(H,G,Z,ee){return this.s(H,N,ue=>ue.provideDocumentHighlights(f.URI.revive(G),Z,ee),void 0,ee)}$provideMultiDocumentHighlights(H,G,Z,ee,ue){return this.s(H,L,ye=>ye.provideMultiDocumentHighlights(f.URI.revive(G),Z,ee.map(Ae=>f.URI.revive(Ae)),ue),void 0,ue)}registerLinkedEditingRangeProvider(H,G,Z){const ee=this.t(new M(this.h,Z),H);return this.e.$registerLinkedEditingRangeProvider(ee,this.o(G,H)),this.p(ee)}$provideLinkedEditingRanges(H,G,Z,ee){return this.s(H,M,async ue=>{const ye=await ue.provideLinkedEditingRanges(f.URI.revive(G),Z,ee);if(ye)return{ranges:ye.ranges,wordPattern:ye.wordPattern?qe.y(ye.wordPattern):void 0}},void 0,ee)}registerReferenceProvider(H,G,Z){const ee=this.t(new z(this.h,Z),H);return this.e.$registerReferenceSupport(ee,this.o(G,H)),this.p(ee)}$provideReferences(H,G,Z,ee,ue){return this.s(H,z,ye=>ye.provideReferences(f.URI.revive(G),Z,ee,ue),void 0,ue)}registerCodeActionProvider(H,G,Z,ee){const ue=new A.$Yc,ye=this.t(new V(this.h,this.j.converter,this.k,Z,this.l,H,this.m),H);return this.e.$registerCodeActionSupport(ye,this.o(G,H),{providedKinds:ee?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:ee?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,ue)}))},qe.u(H),qe.w(H),!!Z.resolveCodeAction),ue.add(this.p(ye)),ue}$provideCodeActions(H,G,Z,ee,ue){return this.s(H,V,ye=>ye.provideCodeActions(f.URI.revive(G),Z,ee,ue),void 0,ue)}$resolveCodeAction(H,G,Z){return this.s(H,V,ee=>ee.resolveCodeAction(G,Z),{},void 0)}$releaseCodeActions(H,G){this.s(H,V,Z=>Promise.resolve(Z.releaseCodeActions(G)),void 0,void 0)}registerDocumentFormattingEditProvider(H,G,Z){const ee=this.t(new j(this.h,Z),H);return this.e.$registerDocumentFormattingSupport(ee,this.o(G,H),H.identifier,H.displayName||H.name),this.p(ee)}$provideDocumentFormattingEdits(H,G,Z,ee){return this.s(H,j,ue=>ue.provideDocumentFormattingEdits(f.URI.revive(G),Z,ee),void 0,ee)}registerDocumentRangeFormattingEditProvider(H,G,Z){const ee=typeof Z.provideDocumentRangesFormattingEdits=="function",ue=this.t(new W(this.h,Z),H);return this.e.$registerRangeFormattingSupport(ue,this.o(G,H),H.identifier,H.displayName||H.name,ee),this.p(ue)}$provideDocumentRangeFormattingEdits(H,G,Z,ee,ue){return this.s(H,W,ye=>ye.provideDocumentRangeFormattingEdits(f.URI.revive(G),Z,ee,ue),void 0,ue)}$provideDocumentRangesFormattingEdits(H,G,Z,ee,ue){return this.s(H,W,ye=>ye.provideDocumentRangesFormattingEdits(f.URI.revive(G),Z,ee,ue),void 0,ue)}registerOnTypeFormattingEditProvider(H,G,Z,ee){const ue=this.t(new J(this.h,Z),H);return this.e.$registerOnTypeFormattingSupport(ue,this.o(G,H),ee,H.identifier),this.p(ue)}$provideOnTypeFormattingEdits(H,G,Z,ee,ue,ye){return this.s(H,J,Ae=>Ae.provideOnTypeFormattingEdits(f.URI.revive(G),Z,ee,ue,ye),void 0,ye)}registerWorkspaceSymbolProvider(H,G){const Z=this.t(new B(G,this.l),H);return this.e.$registerNavigateTypeSupport(Z,typeof G.resolveWorkspaceSymbol=="function"),this.p(Z)}$provideWorkspaceSymbols(H,G,Z){return this.s(H,B,ee=>ee.provideWorkspaceSymbols(G,Z),{symbols:[]},Z)}$resolveWorkspaceSymbol(H,G,Z){return this.s(H,B,ee=>ee.resolveWorkspaceSymbol(G,Z),void 0,void 0)}$releaseWorkspaceSymbols(H,G){this.s(H,B,Z=>Z.releaseWorkspaceSymbols(G),void 0,void 0)}registerRenameProvider(H,G,Z){const ee=this.t(new U(this.h,Z,this.l),H);return this.e.$registerRenameSupport(ee,this.o(G,H),U.supportsResolving(Z)),this.p(ee)}$provideRenameEdits(H,G,Z,ee,ue){return this.s(H,U,ye=>ye.provideRenameEdits(f.URI.revive(G),Z,ee,ue),void 0,ue)}$resolveRenameLocation(H,G,Z,ee){return this.s(H,U,ue=>ue.resolveRenameLocation(f.URI.revive(G),Z,ee),void 0,ee)}registerNewSymbolNamesProvider(H,G,Z){const ee=this.t(new _(this.h,Z,this.l),H);return this.e.$registerNewSymbolNamesProvider(ee,this.o(G,H)),this.p(ee)}$supportsAutomaticNewSymbolNamesTriggerKind(H){return this.s(H,_,G=>G.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(H,G,Z,ee,ue){return this.s(H,_,ye=>ye.provideNewSymbolNames(f.URI.revive(G),Z,ee,ue),void 0,ue)}registerDocumentSemanticTokensProvider(H,G,Z,ee){const ue=this.t(new oe(this.h,Z),H),ye=typeof Z.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ue,this.o(G,H),ee,ye);let Ae=this.p(ue);if(ye){const Ve=Z.onDidChangeSemanticTokens(Je=>this.e.$emitDocumentSemanticTokensEvent(ye));Ae=a.$dO.from(Ae,Ve)}return Ae}$provideDocumentSemanticTokens(H,G,Z,ee){return this.s(H,oe,ue=>ue.provideDocumentSemanticTokens(f.URI.revive(G),Z,ee),null,ee)}$releaseDocumentSemanticTokens(H,G){this.s(H,oe,Z=>Z.releaseDocumentSemanticColoring(G),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(H,G,Z,ee){const ue=this.t(new te(this.h,Z),H);return this.e.$registerDocumentRangeSemanticTokensProvider(ue,this.o(G,H),ee),this.p(ue)}$provideDocumentRangeSemanticTokens(H,G,Z,ee){return this.s(H,te,ue=>ue.provideDocumentRangeSemanticTokens(f.URI.revive(G),Z,ee),null,ee)}registerCompletionItemProvider(H,G,Z,ee){const ue=this.t(new me(this.h,this.j.converter,Z,this.m,H),H);return this.e.$registerCompletionsProvider(ue,this.o(G,H),ee,me.supportsResolving(Z),H.identifier),this.p(ue)}$provideCompletionItems(H,G,Z,ee,ue){return this.s(H,me,ye=>ye.provideCompletionItems(f.URI.revive(G),Z,ee,ue),void 0,ue)}$resolveCompletionItem(H,G,Z){return this.s(H,me,ee=>ee.resolveCompletionItem(G,Z),void 0,Z)}$releaseCompletionItems(H,G){this.s(H,me,Z=>Z.releaseCompletionItems(G),void 0,void 0)}registerInlineCompletionsProvider(H,G,Z,ee){const ue=new Y(H,this.h,Z,this.j.converter),ye=this.t(ue,H);return this.e.$registerInlineCompletionsSupport(ye,this.o(G,H),ue.supportsHandleEvents,d.$zn.toKey(H.identifier.value),ee?.yieldTo?.map(Ae=>d.$zn.toKey(Ae))||[]),this.p(ye)}$provideInlineCompletions(H,G,Z,ee,ue){return this.s(H,ce,ye=>ye.provideInlineCompletions(f.URI.revive(G),Z,ee,ue),void 0,ue)}$provideInlineEdits(H,G,Z,ee,ue){return this.s(H,ce,ye=>ye.provideInlineEdits(f.URI.revive(G),Z,ee,ue),void 0,ue)}$handleInlineCompletionDidShow(H,G,Z,ee){this.s(H,ce,async ue=>{ue.handleDidShowCompletionItem(G,Z,ee)},void 0,void 0)}$handleInlineCompletionPartialAccept(H,G,Z,ee,ue){this.s(H,ce,async ye=>{ye.handlePartialAccept(G,Z,ee,ue)},void 0,void 0)}$freeInlineCompletionsList(H,G){this.s(H,ce,async Z=>{Z.disposeCompletions(G)},void 0,void 0)}registerInlineEditProvider(H,G,Z){const ee=new q(H,this.h,Z,this.j.converter),ue=this.t(ee,H);return this.e.$registerInlineEditProvider(ue,this.o(G,H),H.identifier),this.p(ue)}$provideInlineEdit(H,G,Z,ee){return this.s(H,q,ue=>ue.provideInlineEdits(f.URI.revive(G),Z,ee),void 0,ee)}$freeInlineEdit(H,G){this.s(H,q,async Z=>{Z.disposeEdit(G)},void 0,void 0)}registerSignatureHelpProvider(H,G,Z,ee){const ue=Array.isArray(ee)?{triggerCharacters:ee,retriggerCharacters:[]}:ee,ye=this.t(new be(this.h,Z),H);return this.e.$registerSignatureHelpProvider(ye,this.o(G,H),ue),this.p(ye)}$provideSignatureHelp(H,G,Z,ee,ue){return this.s(H,be,ye=>ye.provideSignatureHelp(f.URI.revive(G),Z,ee,ue),void 0,ue)}$releaseSignatureHelp(H,G){this.s(H,be,Z=>Z.releaseSignatureHelp(G),void 0,void 0)}registerInlayHintsProvider(H,G,Z){const ee=typeof Z.onDidChangeInlayHints=="function"?this.q():void 0,ue=this.t(new ae(this.h,this.j.converter,Z,this.l,H),H);this.e.$registerInlayHintsProvider(ue,this.o(G,H),typeof Z.resolveInlayHint=="function",ee,qe.u(H));let ye=this.p(ue);if(ee!==void 0){const Ae=Z.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(ee));ye=a.$dO.from(ye,Ae)}return ye}$provideInlayHints(H,G,Z,ee){return this.s(H,ae,ue=>ue.provideInlayHints(f.URI.revive(G),Z,ee),void 0,ee)}$resolveInlayHint(H,G,Z){return this.s(H,ae,ee=>ee.resolveInlayHint(G,Z),void 0,Z)}$releaseInlayHints(H,G){this.s(H,ae,Z=>Z.releaseHints(G),void 0,void 0)}registerDocumentLinkProvider(H,G,Z){const ee=this.t(new we(this.h,Z),H);return this.e.$registerDocumentLinkProvider(ee,this.o(G,H),typeof Z.resolveDocumentLink=="function"),this.p(ee)}$provideDocumentLinks(H,G,Z){return this.s(H,we,ee=>ee.provideLinks(f.URI.revive(G),Z),void 0,Z,G.scheme==="output")}$resolveDocumentLink(H,G,Z){return this.s(H,we,ee=>ee.resolveLink(G,Z),void 0,void 0,!0)}$releaseDocumentLinks(H,G){this.s(H,we,Z=>Z.releaseLinks(G),void 0,void 0,!0)}registerColorProvider(H,G,Z){const ee=this.t(new $e(this.h,Z),H);return this.e.$registerDocumentColorProvider(ee,this.o(G,H)),this.p(ee)}$provideDocumentColors(H,G,Z){return this.s(H,$e,ee=>ee.provideColors(f.URI.revive(G),Z),[],Z)}$provideColorPresentations(H,G,Z,ee){return this.s(H,$e,ue=>ue.provideColorPresentations(f.URI.revive(G),Z,ee),void 0,ee)}registerFoldingRangeProvider(H,G,Z){const ee=this.q(),ue=typeof Z.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(ee,new je(new pe(this.h,Z),H)),this.e.$registerFoldingRangeProvider(ee,this.o(G,H),H.identifier,ue);let ye=this.p(ee);if(ue!==void 0){const Ae=Z.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ue));ye=a.$dO.from(ye,Ae)}return ye}$provideFoldingRanges(H,G,Z,ee){return this.s(H,pe,ue=>ue.provideFoldingRanges(f.URI.revive(G),Z,ee),void 0,ee)}registerSelectionRangeProvider(H,G,Z){const ee=this.t(new Oe(this.h,Z,this.l),H);return this.e.$registerSelectionRangeProvider(ee,this.o(G,H)),this.p(ee)}$provideSelectionRanges(H,G,Z,ee){return this.s(H,Oe,ue=>ue.provideSelectionRanges(f.URI.revive(G),Z,ee),[],ee)}registerCallHierarchyProvider(H,G,Z){const ee=this.t(new Fe(this.h,Z),H);return this.e.$registerCallHierarchyProvider(ee,this.o(G,H)),this.p(ee)}$prepareCallHierarchy(H,G,Z,ee){return this.s(H,Fe,ue=>Promise.resolve(ue.prepareSession(f.URI.revive(G),Z,ee)),void 0,ee)}$provideCallHierarchyIncomingCalls(H,G,Z,ee){return this.s(H,Fe,ue=>ue.provideCallsTo(G,Z,ee),void 0,ee)}$provideCallHierarchyOutgoingCalls(H,G,Z,ee){return this.s(H,Fe,ue=>ue.provideCallsFrom(G,Z,ee),void 0,ee)}$releaseCallHierarchy(H,G){this.s(H,Fe,Z=>Promise.resolve(Z.releaseSession(G)),void 0,void 0)}registerTypeHierarchyProvider(H,G,Z){const ee=this.t(new He(this.h,Z),H);return this.e.$registerTypeHierarchyProvider(ee,this.o(G,H)),this.p(ee)}$prepareTypeHierarchy(H,G,Z,ee){return this.s(H,He,ue=>Promise.resolve(ue.prepareSession(f.URI.revive(G),Z,ee)),void 0,ee)}$provideTypeHierarchySupertypes(H,G,Z,ee){return this.s(H,He,ue=>ue.provideSupertypes(G,Z,ee),void 0,ee)}$provideTypeHierarchySubtypes(H,G,Z,ee){return this.s(H,He,ue=>ue.provideSubtypes(G,Z,ee),void 0,ee)}$releaseTypeHierarchy(H,G){this.s(H,He,Z=>Promise.resolve(Z.releaseSession(G)),void 0,void 0)}registerDocumentOnDropEditProvider(H,G,Z,ee){const ue=this.q();return this.f.set(ue,new je(new Ze(this.e,this.h,Z,ue,H),H)),this.e.$registerDocumentOnDropEditProvider(ue,this.o(G,H),(0,t.$CH)(H,"documentPaste")&&ee?{supportsResolve:!!Z.resolveDocumentDropEdit,dropMimeTypes:ee.dropMimeTypes}:void 0),this.p(ue)}$provideDocumentOnDropEdits(H,G,Z,ee,ue,ye){return this.s(H,Ze,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(G,f.URI.revive(Z),ee,ue,ye)),void 0,void 0)}$resolveDropEdit(H,G,Z){return this.s(H,Ze,ee=>ee.resolveDropEdit(G,Z),{},void 0)}$releaseDocumentOnDropEdits(H,G){this.s(H,Ze,Z=>Promise.resolve(Z.releaseDropEdits(G)),void 0,void 0)}registerMappedEditsProvider(H,G,Z){const ee=this.t(new xe(this.h,Z),H);return this.e.$registerMappedEditsProvider(ee,this.o(G,H),H.displayName??H.name),this.p(ee)}$provideMappedEdits(H,G,Z,ee,ue){return this.s(H,xe,ye=>Promise.resolve(ye.provideMappedEdits(G,Z,ee,ue)),null,ue)}registerDocumentPasteEditProvider(H,G,Z,ee){const ue=this.q();return this.f.set(ue,new je(new F(this.e,this.h,Z,ue,H),H)),this.e.$registerPasteEditProvider(ue,this.o(G,H),{supportsCopy:!!Z.prepareDocumentPaste,supportsPaste:!!Z.provideDocumentPasteEdits,supportsResolve:!!Z.resolveDocumentPasteEdit,providedPasteEditKinds:ee.providedPasteEditKinds?.map(ye=>ye.value),copyMimeTypes:ee.copyMimeTypes,pasteMimeTypes:ee.pasteMimeTypes}),this.p(ue)}$prepareDocumentPaste(H,G,Z,ee,ue){return this.s(H,F,ye=>ye.prepareDocumentPaste(f.URI.revive(G),Z,ee,ue),void 0,ue)}$providePasteEdits(H,G,Z,ee,ue,ye,Ae){return this.s(H,F,Ve=>Ve.providePasteEdits(G,f.URI.revive(Z),ee,ue,ye,Ae),void 0,Ae)}$resolvePasteEdit(H,G,Z){return this.s(H,F,ee=>ee.resolvePasteEdit(G,Z),{},void 0)}$releasePasteEdits(H,G){this.s(H,F,Z=>Promise.resolve(Z.releasePasteEdits(G)),void 0,void 0)}static y(H){return{pattern:H.source,flags:H.flags}}static z(H){return{decreaseIndentPattern:qe.y(H.decreaseIndentPattern),increaseIndentPattern:qe.y(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?qe.y(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?qe.y(H.unIndentedLinePattern):void 0}}static B(H){return{beforeText:qe.y(H.beforeText),afterText:H.afterText?qe.y(H.afterText):void 0,previousLineText:H.previousLineText?qe.y(H.previousLineText):void 0,action:H.action}}static C(H){return H.map(qe.B)}static D(H){return{open:H.open,close:H.close,notIn:H.notIn?H.notIn.map(G=>a.SyntaxTokenType.toString(G)):void 0}}static E(H){return H.map(qe.D)}setLanguageConfiguration(H,G,Z){const{wordPattern:ee}=Z;if(ee&&(0,I.$wf)(ee))throw new Error(`Invalid language configuration: wordPattern '${ee}' is not allowed to match the empty string.`);ee?this.h.setWordDefinitionFor(G,ee):this.h.setWordDefinitionFor(G,void 0),Z.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),Z.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const ue=this.q(),ye={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?qe.y(Z.wordPattern):void 0,indentationRules:Z.indentationRules?qe.z(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?qe.C(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport,autoClosingPairs:Z.autoClosingPairs?qe.E(Z.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ue,G,ye),this.p(ue)}$setWordDefinitions(H){for(const G of H)this.h.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.$crc=qe}),define(Re[307],Ce([1,0,8,20,12,3,38,31,6,15]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lsc=void 0,c=Ue(c);class I{constructor(f){this.a=new Map,this.c=new Map,this.d=new Map,this.b=f.getProxy(p.$bO.MainThreadLanguageModelTools),this.b.$getTools().then(P=>{for(const v of P)this.d.set(v.id,(0,T.$hi)(v))})}async $countTokensForInvocation(f,P,v){const o=this.c.get(f);if(!o)throw new Error(`Tool invocation call ${f} not found`);return await o(P,v)}async invokeTool(f,P,v){const o=(0,A.$7g)();P.tokenOptions&&this.c.set(o,P.tokenOptions.countTokens);try{const m=await this.b.$invokeTool({toolId:f,callId:o,parameters:P.parameters,tokenBudget:P.tokenOptions?.tokenBudget},v);return c.LanguageModelToolResult.to(m)}finally{this.c.delete(o)}}$onDidChangeTools(f){this.d.clear();for(const P of f)this.d.set(P.id,P)}get tools(){return Array.from(this.d.values()).map(f=>c.LanguageModelToolDescription.to(f))}async $invokeTool(f,P){const v=this.a.get(f.toolId);if(!v)throw new Error(`Unknown tool ${f.toolId}`);const o={parameters:f.parameters};f.tokenBudget!==void 0&&(o.tokenOptions={tokenBudget:f.tokenBudget,countTokens:this.c.get(f.callId)||(($,d=h.CancellationToken.None)=>this.b.$countTokensForInvocation(f.callId,$,d))});const m=await(0,s.$yh)(Promise.resolve(v.tool.invoke(o,P)),P);if(!m)throw new D.$9;for(const $ of Object.keys(m))if(m[$]instanceof Promise)throw new Error(`Tool result for '${$}' cannot be a Promise`);return c.LanguageModelToolResult.from(m)}registerTool(f,P,v){return this.a.set(P,{extension:f,tool:v}),this.b.$registerTool(P),(0,O.$Xc)(()=>{this.a.delete(P),this.b.$unregisterTool(P)})}}e.$Lsc=I}),define(Re[129],Ce([1,0,8,20,52,12,4,40,3,7,23,5,11,90,6,128,19,15,9,162,25]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wrc=e.$Vrc=void 0,$=Ue($),d=Ue(d),e.$Vrc=(0,E.$Ki)("IExtHostLanguageModels");class r{constructor(g,y){this.option=g,this.stream=new s.$bi,this.stream=y??new s.$bi}}class n{constructor(){this.a=new Map,this.b=new s.$bi,this.c=!1;const g=this;this.apiObject={get stream(){return g.b.asyncIterable},get text(){return s.$$h.map(g.b.asyncIterable,y=>{if(y instanceof d.$yQ)return y.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,g]of this.a)yield g.stream;else yield this.b}handleFragment(g){if(this.c)return;let y=this.a.get(g.index);y||(this.a.size===0?y=new r(g.index,this.b):y=new r(g.index),this.a.set(g.index,y));let k;g.part.type==="text"?k=new d.$yQ(g.part.value):k=new d.$xQ(g.part.name,g.part.toolCallId,g.part.parameters),y.stream.emitOne(k)}reject(g){this.c=!0;for(const y of this.d())y.reject(g)}resolve(){this.c=!0;for(const g of this.d())g.resolve()}}let u=class{static{t=this}static{this.a=1}constructor(g,y,k){this.j=y,this.k=k,this.c=new T.$qe,this.d=new T.$qe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$Bn,this.i=new Map,this.s=new Set,this.b=g.getProxy(v.$bO.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(g,y,k,S){const R=t.a++;this.f.set(R,{extension:g.identifier,provider:k,languageModelId:y});let C;S.auth&&(C={providerLabel:g.displayName||g.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(R,`${I.$zn.toKey(g.identifier)}/${R}/${y}`,{extension:g.identifier,id:y,vendor:S.vendor??I.$zn.toKey(g.identifier),name:S.name??"",family:S.family??"",version:S.version,maxInputTokens:S.maxInputTokens,maxOutputTokens:S.maxOutputTokens,auth:C,targetExtensions:S.extensions});const w=k.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:N,tokenCount:L})=>{this.b.$whenLanguageModelChatRequestMade(y,new I.$zn(b),N,L)});return(0,p.$Xc)(()=>{this.f.delete(R),this.b.$unregisterProvider(R),w?.dispose()})}async $startChatRequest(g,y,k,S,R,C){const w=this.f.get(g);if(!w)throw new Error("Provider not found");const b=new P.$Kw(async L=>{if(C.isCancellationRequested){this.j.warn(`[CHAT](${w.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let M;if(L.part instanceof d.$xQ?M={type:"tool_use",name:L.part.name,parameters:L.part.parameters,toolCallId:L.part.toolCallId}:L.part instanceof d.$yQ&&(M={type:"text",value:L.part.value}),!M){this.j.warn(`[CHAT](${w.extension.value}) UNKNOWN part ${JSON.stringify(L)}`);return}this.b.$reportResponsePart(y,{index:L.index,part:M})});let N;if(w.provider.provideLanguageModelResponse2)N=Promise.resolve(w.provider.provideLanguageModelResponse2(S.map($.LanguageModelChatMessage.to),R,I.$zn.toKey(k),b,C));else{const L=new P.$Kw(async M=>{b.report({index:M.index,part:new d.$yQ(M.part)})});N=Promise.resolve(w.provider.provideLanguageModelResponse(S.map($.LanguageModelChatMessage.to),R?.modelOptions??{},I.$zn.toKey(k),L,C))}N.then(()=>{this.b.$reportResponseDone(y,void 0)},L=>{this.b.$reportResponseDone(y,(0,O.$6)(L))})}$provideTokenLength(g,y,k){const S=this.f.get(g);return S?Promise.resolve(S.provider.provideTokenCount(y,k)):Promise.resolve(0)}$acceptChatModelMetadata(g){if(g.added)for(const{identifier:y,metadata:k}of g.added)this.g.set(y,{metadata:k,apiObjects:new I.$Bn});if(g.removed)for(const y of g.removed){this.g.delete(y);for(const[k,S]of this.i)S.languageModelId===y&&(S.res.reject(new O.$9),this.i.delete(k))}g.added?.forEach(y=>this.q(y.metadata)),this.d.fire(void 0)}async selectLanguageModels(g,y){const k=await this.b.$selectChatModels({...y,extension:g.identifier}),S=[],R=this;for(const C of k){const w=this.g.get(C);if(!w)continue;this.o(g.identifier,w.metadata)&&await this.q(w.metadata);let b=w.apiObjects.get(g.identifier);b||(b={id:C,vendor:w.metadata.vendor,family:w.metadata.family,version:w.metadata.version,name:w.metadata.name,maxInputTokens:w.metadata.maxInputTokens,countTokens(N,L){if(!R.g.has(C))throw d.$CQ.NotFound(C);return R.r(C,N,L??h.CancellationToken.None)},sendRequest(N,L,M){if(!R.g.has(C))throw d.$CQ.NotFound(C);return R.l(g,C,N,L??{},M??h.CancellationToken.None)}},Object.freeze(b),w.apiObjects.set(g.identifier,b)),S.push(b)}return S}async l(g,y,k,S,R){const C=this.m(g,k),w=g.identifier,b=this.g.get(y)?.metadata;if(!b||!this.g.has(y))throw d.$CQ.NotFound(`Language model '${y}' is unknown.`);if(this.o(w,b)&&(!await this.n(g,{identifier:b.extension,displayName:b.auth.providerLabel},S.justification,!1)||!this.h.get(w)?.has(b.extension)))throw d.$CQ.NoPermissions(`Language model '${y}' cannot be used by '${w.value}'.`);try{const N=Math.random()*1e6|0,L=new n;this.i.set(N,{languageModelId:y,res:L});try{await this.b.$tryStartChatRequest(w,y,N,C,S,R)}catch(M){throw this.i.delete(N),M}return L.apiObject}catch(N){throw N.name===d.$CQ.name?N:new d.$CQ(`Language model '${y}' errored: ${(0,D.$vj)(N)}`,"Unknown",N)}}m(g,y){const k=[];for(const S of y)S.role===d.LanguageModelChatMessageRole.System&&(0,a.$DH)(g,"languageModelSystem"),S.content2.some(R=>R instanceof d.$vQ)&&(0,a.$DH)(g,"lmTools"),k.push($.LanguageModelChatMessage.from(S));return k}async $acceptResponsePart(g,y){const k=this.i.get(g);k&&k.res.handleFragment(y)}async $acceptResponseDone(g,y){const k=this.i.get(g);k&&(this.i.delete(g),y?k.res.reject((0,O.$7)(y)):k.res.resolve())}async n(g,y,k,S){const R=i.$eN+y.identifier.value;if(await this.k.getSession(g,R,[],{silent:!0}))return this.$updateModelAccesslist([{from:g.identifier,to:y.identifier,enabled:!0}]),!0;if(S)return!1;try{const w=k?(0,c.localize)(2706,null,y.displayName,k):void 0;return await this.k.getSession(g,R,[],{forceNewSession:{detail:w}}),this.$updateModelAccesslist([{from:g.identifier,to:y.identifier,enabled:!0}]),!0}catch{return!1}}o(g,y){return!!y.auth&&!I.$zn.equals(y.extension,g)}async q(g){if(g.auth)for(const y of this.s)try{await this.n(y,{identifier:g.extension,displayName:""},void 0,!0)}catch(k){this.j.error("Fake Auth request failed"),this.j.error(k)}}async r(g,y,k){if(!this.g.get(g))throw d.$CQ.NotFound(`Language model '${g}' is unknown.`);const R=A.Iterable.find(this.f.values(),C=>C.languageModelId===g);return R?R.provider.provideTokenCount(y,k):this.b.$countTokens(g,typeof y=="string"?y:$.LanguageModelChatMessage.from(y),k)}$updateModelAccesslist(g){const y=new Array;for(const{from:k,to:S,enabled:R}of g){const C=this.h.get(k)??new I.$An;if(C.has(S)!==R){R?C.add(S):C.delete(S),this.h.set(k,C);const b={from:k,to:S};y.push(b),this.c.fire(b)}}}createLanguageModelAccessInformation(g){this.s.add(g);const y=this,k=T.Event.signal(T.Event.filter(this.c.event,R=>I.$zn.equals(R.from,g.identifier))),S=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any(k,S)},canSendRequest(R){let C;e:for(const[b,N]of y.g)for(const L of N.apiObjects.values())if(L===R){C=N.metadata;break e}if(!C)return;if(!y.o(g.identifier,C))return!0;const w=y.h.get(g.identifier);if(w)return w.has(C.extension)}}}};e.$Wrc=u,e.$Wrc=u=t=Ye([We(0,m.$OQ),We(1,f.$fk),We(2,o.$erc)],u)});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[308],Ce([1,0,6,15,9,45,8,3,25]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Msc=void 0,h=Ue(h),O=Ht(O);class c{constructor(E,f,P,v){this.c=f,this.d=P,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(s.$bO.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,f){await this.a.$changeLanguage(E,f);const P=this.c.getDocumentData(E);if(!P)throw new Error(`document '${E.toString()}' NOT found`);return P.document}async tokenAtPosition(E,f){const P=E.version,v=h.Position.from(f),o=await this.a.$tokensAtPosition(E.uri,v),m={type:D.StandardTokenType.Other,range:E.getWordRangeAtPosition(f)??new D.$fO(f.line,f.character,f.line,f.character)};if(!o)return m;const $={range:h.Range.to(o.range),type:h.TokenType.to(o.type)};return!$.range.contains(f)||P!==E.version?m:$}createLanguageStatusItem(E,f,P){const v=this.f++,o=this.a,m=this.g,$=`${E.identifier.value}/${f}`;if(m.has($))throw new Error(`LanguageStatusItem with id '${f}' ALREADY exists`);m.add($);const d={selector:P,id:f,name:E.displayName??E.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const a=new A.$Yc,t=()=>{if(i?.dispose(),!m.has($)){console.warn(`LanguageStatusItem (${f}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,T.$Mh)(()=>{a.clear(),this.a.$setLanguageStatus(v,{id:$,name:d.name??E.displayName??E.name,source:E.displayName??E.name,selector:h.DocumentSelector.from(d.selector,this.e),label:d.text,detail:d.detail??"",severity:d.severity===D.LanguageStatusSeverity.Error?O.default.Error:d.severity===D.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:d.command&&this.d.toInternal(d.command,a),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},r={dispose(){a.dispose(),i?.dispose(),o.$removeLanguageStatus(v),m.delete($)},get id(){return d.id},get name(){return d.name},set name(n){d.name=n,t()},get selector(){return d.selector},set selector(n){d.selector=n,t()},get text(){return d.text},set text(n){d.text=n,t()},set text2(n){(0,p.$DH)(E,"languageStatusText"),d.text=n,t()},get text2(){return(0,p.$DH)(E,"languageStatusText"),d.text},get detail(){return d.detail},set detail(n){d.detail=n,t()},get severity(){return d.severity},set severity(n){d.severity=n,t()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(n){d.accessibilityInformation=n,t()},get command(){return d.command},set command(n){d.command=n,t()},get busy(){return d.busy},set busy(n){d.busy=n,t()}};return t(),r}}e.$Msc=c}),define(Re[309],Ce([1,0,14,2,15,9,127]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tsc=e.$ssc=void 0,D=Ue(D),T=Ue(T);class A{constructor(E,f,P,v){this.start=E,this.deletedCount=f,this.deletedItems=P,this.items=v}asApiEvent(){return{range:new O.$HP(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,f,P){this.notebook=E,this.h=f,this.j=P,this.handle=P.handle,this.uri=h.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(D.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(D.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:D.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return E.g},set mime(v){E.g=v},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(P)}return this.f}setOutputs(E){this.a=E.map(D.NotebookCellOutput.to)}setOutputItems(E,f,P){const v=P.map(D.NotebookCellOutputItem.to),o=this.a.find(m=>m.id===E);if(o&&(f||(o.items.length=0),o.items.push(...v),o.items.length>1&&o.items.every(m=>T.$cM(m.mime)))){const m=new Map,$=[];o.items.forEach(d=>{let i;m.has(d.mime)?i=m.get(d.mime):(i=[],m.set(d.mime,i),$.push(d.mime)),i.push(d.data)}),o.items.length=0,$.forEach(d=>{const i=T.$dM(m.get(d));o.items.push({mime:d,data:i.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(D.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$ssc=p;class c{static{this.a=0}constructor(E,f,P,v,o){this.k=E,this.l=f,this.m=P,this.uri=v,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=o.viewType,this.f=Object.freeze(o.metadata??Object.create(null)),this.r([[0,0,o.cells]],!0,void 0),this.g=o.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,f={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===s.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(P){return P=E.n(P),E.b[P].apiCell},getCells(P){return(P?E.p(P):E.b).map(o=>o.apiCell)},save(){return E.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,f,P){this.g=E.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:P});const v={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},o=[];for(const $ of E.rawEvents)$.kind===T.NotebookCellsChangeType.ModelChange?this.r($.changes,!1,v.contentChanges):$.kind===T.NotebookCellsChangeType.Move?this.s($.index,$.length,$.newIdx,v.contentChanges):$.kind===T.NotebookCellsChangeType.Output?(this.t($.index,$.outputs),o.push({cell:this.b[$.index].apiCell,outputs:this.b[$.index].apiCell.outputs})):$.kind===T.NotebookCellsChangeType.OutputItem?(this.u($.index,$.outputId,$.append,$.outputItems),o.push({cell:this.b[$.index].apiCell,outputs:this.b[$.index].apiCell.outputs})):$.kind===T.NotebookCellsChangeType.ChangeCellLanguage?(this.v($.index,$.language),o.push({cell:this.b[$.index].apiCell,document:this.b[$.index].apiCell.document})):$.kind===T.NotebookCellsChangeType.ChangeCellContent?o.push({cell:this.b[$.index].apiCell,document:this.b[$.index].apiCell.document}):$.kind===T.NotebookCellsChangeType.ChangeCellMime?this.w($.index,$.mime):$.kind===T.NotebookCellsChangeType.ChangeCellMetadata?(this.x($.index,$.metadata),o.push({cell:this.b[$.index].apiCell,metadata:this.b[$.index].apiCell.metadata})):$.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y($.index,$.internalMetadata),o.push({cell:this.b[$.index].apiCell,executionSummary:this.b[$.index].apiCell.executionSummary}));const m=new Map;for(let $=0;$<o.length;$++){const d=o[$],i=m.get(d.cell);if(i===void 0){const a=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...d});m.set(d.cell,a-1)}else v.cellChanges[i]={...v.cellChanges[i],...d}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let f=E.start|0,P=E.end|0;return f<0&&(f=0),P>this.b.length&&(P=this.b.length),E.with({start:f,end:P})}p(E){E=this.o(E);const f=[];for(let P=E.start;P<E.end;P++)f.push(this.b[P]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,f,P){if(this.j)return;const v=[],o=[],m=[];if(E.reverse().forEach($=>{const i=$[2].map(r=>{const n=new p(this,this.l,r);return f||o.push(p.asModelAddData(r)),n}),a=new A($[0],$[1],[],i),t=this.b.splice($[0],$[1],...i);for(const r of t)m.push(r.uri),a.deletedItems.push(r.apiCell);v.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:m}),P)for(const $ of v)P.push($.asApiEvent())}s(E,f,P,v){const o=this.b.splice(E,f);this.b.splice(P,0,...o);const m=[new A(E,f,o.map($=>$.apiCell),[]),new A(P,0,[],o)];for(const $ of m)v.push($.asApiEvent())}t(E,f){this.b[E].setOutputs(f)}u(E,f,P,v){this.b[E].setOutputItems(f,P,v)}v(E,f){const P=this.b[E];P.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(P.uri,f)}w(E,f){const P=this.b[E];P.apiCell.mime=f}x(E,f){this.b[E].setMetadata(f)}y(E,f){this.b[E].setInternalMetadata(f)}getCellFromApiCell(E){return this.b.find(f=>f.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(f=>f.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$tsc=c}),define(Re[310],Ce([1,0,4,2,15,9,53]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Osc=void 0;class A{constructor(c,I,E,f={timeout:1500,errors:3}){this.b=c,this.c=I,this.d=E,this.f=f,this.a=new s.$se}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(I,E,f)=>{const P=function(o){I.call(E,o)};return P.extension=c,this.a.event(P,void 0,f)}}async $participateInSave(c,I,E){const f=h.URI.revive(c),P=this.c.getNotebookDocument(f);if(!P)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:P.apiNotebook,reason:D.TextDocumentSaveReason.to(I)},E,async(m,$)=>{const d=Date.now(),i=await await Promise.resolve(m);Date.now()-d>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",$.extension.identifier),!E.isCancellationRequested&&i&&(i instanceof O.$pO?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",$.extension.identifier,"ignored due to invalid data"))}),E.isCancellationRequested)return!1;if(v.length===0)return!0;const o={edits:[]};for(const m of v){const{edits:$}=D.WorkspaceEdit.from(m);o.edits=o.edits.concat($)}return this.d.$tryApplyWorkspaceEdit(new T.$9w(o))}}e.$Osc=A}),define(Re[171],Ce([1,0,12,15,9]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$usc=void 0,h=Ue(h),D=Ue(D);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(A,p,c,I,E,f){this.id=A,this.f=p,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=I,this.c=f}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(p){this.selections=[p]},get selections(){return A.a},set selections(p){if(!Array.isArray(p)||!p.every(D.$HP.isNotebookRange))throw(0,s.$$)("selections");A.a=p,A.g(p)},get visibleRanges(){return A.b},revealRange(p,c){A.f.$tryRevealRange(A.id,h.NotebookRange.from(p),c??D.NotebookEditorRevealType.Default)},get viewColumn(){return A.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(h.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.$usc=O}),define(Re[311],Ce([1,0,4,11,15]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qsc=void 0,D=Ue(D);let O=class{constructor(A,p){this.c=A,this.d=p,this.a=new s.$qe,this.b=new s.$qe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,p);const c=this.d.getEditorById(A);p.visibleRanges&&c._acceptVisibleRanges(p.visibleRanges.ranges.map(D.NotebookRange.to)),p.selections&&c._acceptSelections(p.selections.selections.map(D.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const p in A)this.d.getEditorById(p)._acceptViewColumn(D.ViewColumn.to(A[p]))}};e.$Qsc=O,e.$Qsc=O=Ye([We(0,h.$fk)],O)}),define(Re[312],Ce([1,0,4,6,171]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tsc=void 0;class O{constructor(A,p){this.c=p,this.a=new Map,this.b=A.getProxy(h.$bO.MainThreadNotebookRenderers)}$postRendererMessage(A,p,c){const I=this.c.getEditorById(A);this.a.get(p)?.fire({editor:I.apiEditor,message:c})}createRendererMessaging(A,p){if(!A.contributes?.notebookRenderer?.some(I=>I.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(I,E,f)=>this.d(p).event(I,E,f),postMessage:(I,E)=>{D.$usc.apiEditorsToExtHost.has(I)&&([I,E]=[E,I]);const f=E&&D.$usc.apiEditorsToExtHost.get(E);return this.b.$postMessage(f?.id,p,I)}}}d(A){let p=this.a.get(A);return p||(p=new s.$qe({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(A)}}),this.a.set(A,p),p)}}e.$Tsc=O}),define(Re[313],Ce([1,0,15,90,20,60,12]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xsc=void 0;class A{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,f,P){const v=this.b++,{title:o,location:m,cancellable:$}=f,d={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(v,{location:s.ProgressLocation.from(m),title:o,source:d,cancellable:$},E.isUnderDevelopment?void 0:E.identifier.value).catch(T.$5),this.d(v,P,!!$)}d(E,f,P){let v;P&&(v=new D.$Be,this.c.set(E,v));const o=$=>{this.a.$progressEnd($),this.c.delete($),v?.dispose()};let m;try{m=f(new c(this.a,E),P&&v?v.token:D.CancellationToken.None)}catch($){throw o(E),$}return m.then($=>o(E),$=>o(E)),m}$acceptProgressCanceled(E){const f=this.c.get(E);f&&(f.cancel(),this.c.delete(E))}}e.$Xsc=A;function p(I,E){return I.message=E.message,typeof E.increment=="number"&&(typeof I.increment=="number"?I.increment+=E.increment:I.increment=E.increment),I}class c extends h.$Kw{constructor(E,f){super(P=>this.throttledReport(P)),this.c=E,this.d=f}throttledReport(E){this.c.$progressReport(this.d,E)}}Ye([(0,O.$ei)(100,(I,E)=>p(I,E),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(Re[314],Ce([1,0,2,6,8,15]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ysc=void 0;class T{static{this.a=0}constructor(p,c){this.d=c,this.c=new Map,this.b=p.getProxy(h.$bO.MainThreadQuickDiff)}$provideOriginalResource(p,c,I){const E=s.URI.revive(c),f=this.c.get(p);return f?(0,D.$Ch)(()=>f.provideOriginalResource(E,I)).then(P=>P||null):Promise.resolve(null)}registerQuickDiffProvider(p,c,I,E){const f=T.a++;return this.c.set(f,c),this.b.$registerQuickDiffProvider(f,O.DocumentSelector.from(p,this.d),I,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(f),this.c.delete(f)}}}}e.$Ysc=T});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[315],Ce([1,0,20,4,3,6,2,9,12,18,45,51,25,15]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zsc=v,I=Ht(I);function v(o,m,$){const d=o.getProxy(O.$bO.MainThreadQuickOpen);class i{constructor(k,S){this.e=new Map,this.f=0,this.a=k,this.b=S}showQuickPick(k,S,R,C=s.CancellationToken.None){this.c=void 0;const w=Promise.resolve(S),b=++this.f,N=d.$show(b,{title:R?.title,placeHolder:R?.placeHolder,matchOnDescription:R?.matchOnDescription,matchOnDetail:R?.matchOnDetail,ignoreFocusLost:R?.ignoreFocusOut,canPickMany:R?.canPickMany},C),L={},M=N.then(()=>L);return Promise.race([M,w]).then(z=>{if(z===L)return;const V=(0,f.$CH)(k,"quickPickItemTooltip");return w.then(F=>{const j=[];for(let W=0;W<F.length;W++){const J=F[W];if(typeof J=="string")j.push({label:J,handle:W});else if(J.kind===A.QuickPickItemKind.Separator)j.push({type:"separator",label:J.label});else{J.tooltip&&!V&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const B=J.iconPath?u(J.iconPath):void 0;j.push({label:J.label,iconPath:B?.iconPath,iconClass:B?.iconClass,description:J.description,detail:J.detail,picked:J.picked,alwaysShow:J.alwaysShow,tooltip:V?P.MarkdownString.fromStrict(J.tooltip):void 0,handle:W})}}return R&&typeof R.onDidSelectItem=="function"&&(this.c=W=>{R.onDidSelectItem(F[W])}),d.$setItems(b,j),N.then(W=>{if(typeof W=="number")return F[W];if(Array.isArray(W))return W.map(J=>F[J])})})}).then(void 0,z=>{if(!(0,p.$8)(z))return d.$setError(b,z),Promise.reject(z)})}$onItemSelected(k){this.c?.(k)}showInput(k,S=s.CancellationToken.None){return this.d=k?.validateInput,d.$input(k,typeof this.d=="function",S).then(void 0,R=>{if(!(0,p.$8)(R))return Promise.reject(R)})}async $validateInput(k){if(!this.d)return;const S=await this.d(k);if(!S||typeof S=="string")return S;let R;switch(S.severity){case A.InputBoxValidationSeverity.Info:R=I.default.Info;break;case A.InputBoxValidationSeverity.Warning:R=I.default.Warning;break;case A.InputBoxValidationSeverity.Error:R=I.default.Error;break;default:R=S.message?I.default.Error:I.default.Ignore;break}return{content:S.message,severity:R}}async showWorkspaceFolderPick(k,S=s.CancellationToken.None){const R=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!R)return;const C=await this.a.getWorkspaceFolders2();if(C)return C.find(w=>w.uri.toString()===R.uri.toString())}createQuickPick(k){const S=new l(k,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(k){const S=new g(k,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(k,S){this.e.get(k)?._fireDidChangeValue(S)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,S){const R=this.e.get(k);R instanceof l&&R._fireDidChangeActive(S)}$onDidChangeSelection(k,S){const R=this.e.get(k);R instanceof l&&R._fireDidChangeSelection(S)}$onDidTriggerButton(k,S){this.e.get(k)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(k,S,R){const C=this.e.get(k);C instanceof l&&C._fireDidTriggerItemButton(S,R)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class a{static{this.a=1}constructor(k,S){this.x=k,this.y=S,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$qe,this.q=new h.$qe,this.r=new h.$qe,this.s=new h.$qe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){const S=(0,f.$CH)(this.x,"quickInputButtonLocation");!S&&k.some(R=>R.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=k.slice(),this.o.clear(),k.forEach((R,C)=>{const w=R===A.$EP.Back?-1:C;this.o.set(w,R)}),this.z({buttons:k.map((R,C)=>({...u(R.iconPath),tooltip:R.tooltip,handle:R===A.$EP.Back?-1:C,location:S?R.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const S=this.o.get(k);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,D.$Uc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(k){if(!this.v){for(const S of Object.keys(k)){const R=k[S];this.u[S]=R===void 0?null:R}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}function t(y){if(y instanceof A.$cP)return{id:y.id};const k=n(y),S=r(y);return{dark:typeof k=="string"?T.URI.file(k):k,light:typeof S=="string"?T.URI.file(S):S}}function r(y){return typeof y=="object"&&"light"in y?y.light:y}function n(y){return typeof y=="object"&&"dark"in y?y.dark:y}function u(y){const k=t(y);let S,R;return"id"in k?R=E.ThemeIcon.asClassName(k):S=k,{iconPath:S,iconClass:R}}class l extends a{constructor(k,S){super(k,S),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$qe,this.L=[],this.M=new h.$qe,this.N=new h.$qe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((C,w)=>{this.C.set(w,C),this.D.set(C,w)});const S=(0,f.$CH)(this.x,"quickPickItemTooltip"),R=[];for(let C=0;C<k.length;C++){const w=k[C];if(w.kind===A.QuickPickItemKind.Separator)R.push({type:"separator",label:w.label});else{w.tooltip&&!S&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const b=w.iconPath?u(w.iconPath):void 0;R.push({handle:C,label:w.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:S?P.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((N,L)=>({...u(N.iconPath),tooltip:N.tooltip,handle:L}))})}}this.z({items:R})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(k){const S=(0,c.$Lb)(k.map(R=>this.C.get(R)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(k){const S=(0,c.$Lb)(k.map(R=>this.C.get(R)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(k,S){const R=this.C.get(k);if(!R||!R.buttons||!R.buttons.length)return;const C=R.buttons[S];C&&this.N.fire({button:C,item:R})}}class g extends a{constructor(k,S){super(k,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:I.default.Error}):this.z({validationMessage:k.message,severity:k.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(m,$)}}),define(Re[316],Ce([1,0,2,4,60,3,8,6,18,143,11,23,41,51,15,25,14,10]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$2sc=e.$1sc=void 0;function i(L){return L instanceof s.URI}function a(L,M){return L.scheme===m.Schemas.file&&M.scheme===m.Schemas.file&&$.$n?L.toString()===M.toString():L.toString().toLowerCase()===M.toString().toLowerCase()}function t(L){if(L)return typeof L.iconPath=="string"?s.URI.file(L.iconPath):s.URI.isUri(L.iconPath)||P.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function r(L){if(L){if(s.URI.isUri(L))return L;if(P.ThemeIcon.isThemeIcon(L))return L;{const M=L;return{light:M.light,dark:M.dark}}}else return}function n(L){const M=r(L.icon),z=L.labels?.map(V=>({title:V.title,icon:r(V.icon)}));return{...L,icon:M,labels:z}}function u(L,M){if(!L.iconPath&&!M.iconPath)return 0;if(L.iconPath){if(!M.iconPath)return 1}else return-1;const z=typeof L.iconPath=="string"?L.iconPath:s.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,V=typeof M.iconPath=="string"?M.iconPath:s.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id;return(0,c.$Ur)(z,V)}function l(L,M){let z=0;if(L.strikeThrough!==M.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==M.faded)return L.faded?1:-1;if(L.tooltip!==M.tooltip)return(L.tooltip||"").localeCompare(M.tooltip||"");if(z=u(L,M),z!==0)return z;if(L.light&&M.light)z=u(L.light,M.light);else{if(L.light)return 1;if(M.light)return-1}if(z!==0)return z;if(L.dark&&M.dark)z=u(L.dark,M.dark);else{if(L.dark)return 1;if(M.dark)return-1}return z}function g(L,M){if(L.command!==M.command)return L.command<M.command?-1:1;if(L.title!==M.title)return L.title<M.title?-1:1;if(L.tooltip!==M.tooltip){if(L.tooltip!==void 0&&M.tooltip!==void 0)return L.tooltip<M.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(M.tooltip!==void 0)return-1}if(L.arguments===M.arguments)return 0;if(L.arguments)if(M.arguments){if(L.arguments.length!==M.arguments.length)return L.arguments.length-M.arguments.length}else return 1;else return-1;for(let z=0;z<L.arguments.length;z++){const V=L.arguments[z],F=M.arguments[z];if(V!==F&&!(i(V)&&i(F)&&a(V,F)))return V<F?-1:1}return 0}function y(L,M){let z=(0,c.$Ur)(L.resourceUri.fsPath,M.resourceUri.fsPath,!0);if(z!==0)return z;if(L.command&&M.command)z=g(L.command,M.command);else{if(L.command)return 1;if(M.command)return-1}if(z!==0)return z;if(L.decorations&&M.decorations)z=l(L.decorations,M.decorations);else{if(L.decorations)return 1;if(M.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&M.multiFileDiffEditorModifiedUri)z=(0,c.$Ur)(L.multiFileDiffEditorModifiedUri.fsPath,M.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(M.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&M.multiDiffEditorOriginalUri)z=(0,c.$Ur)(L.multiDiffEditorOriginalUri.fsPath,M.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(M.multiDiffEditorOriginalUri)return-1}return z}function k(L,M){for(let z=0;z<L.length;z++)if(L[z]!==M[z])return!1;return!0}function S(L,M){return L.command===M.command&&L.title===M.title&&L.tooltip===M.tooltip&&(L.arguments&&M.arguments?k(L.arguments,M.arguments):L.arguments===M.arguments)}function R(L,M){return(0,p.$yb)(L,M,S)}class C{#e;#t;get value(){return this.d}set value(M){M=M??"",this.#e.$setInputBoxValue(this.m,M),this.o(M)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(M){this.#e.$setInputBoxPlaceholder(this.m,M),this.f=M}get validateInput(){return(0,o.$DH)(this.k,"scmValidation"),this.g}set validateInput(M){if((0,o.$DH)(this.k,"scmValidation"),M&&typeof M!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=M,this.#e.$setValidationProviderIsEnabled(this.m,!!M)}get enabled(){return this.h}set enabled(M){M=!!M,this.h!==M&&(this.h=M,this.#e.$setInputBoxEnablement(this.m,M))}get visible(){return this.j}set visible(M){M=!!M,this.j!==M&&(this.j=M,this.#e.$setInputBoxVisibility(this.m,M))}get document(){return(0,o.$DH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(M,z,V,F,j){this.k=M,this.m=F,this.n=j,this.d="",this.e=new h.$qe,this.f="",this.h=!0,this.j=!0,this.#t=z,this.#e=V}showValidationMessage(M,z){(0,o.$DH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,M,z)}$onInputBoxValueChange(M){this.o(M)}o(M){this.d=M,this.e.fire(M)}}e.$1sc=C;class w{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(M){this.w=M,this.s.$updateGroupLabel(this.u,this.handle,M)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(M){this.q=M,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(M){this.f=[...M],this.k.fire()}constructor(M,z,V,F,j,W,J){this.s=M,this.t=z,this.u=V,this.v=F,this.w=j,this.multiDiffEditorEnableViewChanges=W,this.x=J,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$qe,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new h.$qe,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=w.d++}getResourceState(M){return this.g.get(M)}$executeResourceCommand(M,z){const V=this.h.get(M);return V?(0,T.$Ch)(()=>this.t.executeCommand(V.command,...V.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const M=[...this.f].sort(y),V=(0,p.$Hb)(this.p,M,y).map(W=>{const J=W.toInsert.map(B=>{const U=this.e++;this.g.set(U,B);const _=B.resourceUri;let x;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"||B.command.command==="vscode.changes"){const Oe=new O.$Yc;x=this.t.converter.toInternal(B.command,Oe),this.j.set(U,Oe)}else this.h.set(U,B.command);const oe=(0,o.$CH)(this.x,"scmMultiDiffEditor"),te=oe?B.multiDiffEditorOriginalUri:void 0,me=oe?B.multiFileDiffEditorModifiedUri:void 0,ce=t(B.decorations),Y=B.decorations&&t(B.decorations.light)||ce,q=B.decorations&&t(B.decorations.dark)||ce,se=[Y,q],be=B.decorations&&B.decorations.tooltip||"",ae=B.decorations&&!!B.decorations.strikeThrough,we=B.decorations&&!!B.decorations.faded,$e=B.contextValue||"";return{rawResource:[U,_,se,be,ae,we,$e,x,te,me],handle:U}});return{start:W.start,deleteCount:W.deleteCount,toInsert:J}}),F=V.map(({start:W,deleteCount:J,toInsert:B})=>[W,J,B.map(U=>U.rawResource)]),j=V.reverse();for(const{start:W,deleteCount:J,toInsert:B}of j){const U=B.map(x=>x.handle),_=this.o.splice(W,J,...U);for(const x of _)this.g.delete(x),this.h.delete(x),this.j.get(x)?.dispose(),this.j.delete(x)}return this.p=M,F}dispose(){this.m=!0,this.n.fire()}}class b{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(M){this.g!==M&&(this.g=M,this.#e.$updateSourceControl(this.x,{count:M}))}get quickDiffProvider(){return this.h}set quickDiffProvider(M){this.h=M;let z;(0,o.$CH)(this.y,"quickDiffProvider")&&(z=M?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!M,quickDiffLabel:z})}get historyProvider(){return(0,o.$DH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(M){(0,o.$DH)(this.y,"scmHistoryProvider"),this.j=M,this.k.value=new O.$Yc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!M}),M&&this.k.value.add(M.onDidChangeCurrentHistoryItemGroup(()=>{this.m=M?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(M){M!==this.n&&(this.n=M,this.#e.$updateSourceControl(this.x,{commitTemplate:M}))}get acceptInputCommand(){return this.p}set acceptInputCommand(M){this.o.value=new O.$Yc,this.p=M;const z=this.z.converter.toInternal(M,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:z})}get actionButton(){return(0,o.$DH)(this.y,"scmActionButton"),this.s}set actionButton(M){(0,o.$DH)(this.y,"scmActionButton"),this.q.value=new O.$Yc,this.s=M;const z=M!==void 0?{command:this.z.converter.toInternal(M.command,this.q.value),secondaryCommands:M.secondaryCommands?.map(V=>V.map(F=>this.z.converter.toInternal(F,this.q.value))),description:M.description,enabled:M.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:z??null})}get statusBarCommands(){return this.u}set statusBarCommands(M){if(this.u&&M&&R(this.u,M))return;this.t.value=new O.$Yc,this.u=M;const z=(M||[]).map(V=>this.z.converter.toInternal(V,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:z})}get selected(){return this.v}constructor(M,z,V,F,j,W,J){this.y=M,this.z=F,this.A=j,this.B=W,this.C=J,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$1c,this.n=void 0,this.o=new O.$1c,this.p=void 0,this.q=new O.$1c,this.t=new O.$1c,this.u=void 0,this.v=!1,this.w=new h.$qe,this.onDidChangeSelection=this.w.event,this.x=b.d++,this.D=new Map,this.E=new Set,this.#e=V;const B=s.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${j}/scm${this.x}/input`,query:J?`rootUri=${encodeURIComponent(J.toString())}`:void 0});this.f=new C(M,z,this.#e,this.x,B),this.#e.$registerSourceControl(this.x,j,W,J,B)}createResourceGroup(M,z,V){const F=(0,o.$CH)(this.y,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,j=new w(this.#e,this.z,this.x,M,z,F,this.y),W=h.Event.once(j.onDidDispose)(()=>this.D.delete(j));return this.D.set(j,W),this.eventuallyAddResourceGroups(),j}eventuallyAddResourceGroups(){const M=[],z=[];for(const[V,F]of this.D){F.dispose();const j=V.onDidUpdateResourceStates(()=>{this.E.add(V),this.eventuallyUpdateResourceStates()});h.Event.once(V.onDidDispose)(()=>{this.E.delete(V),j.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.x,V.handle)}),M.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const W=V._takeResourceStateSnapshot();W.length>0&&z.push([V.handle,W]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.x,M,z),this.D.clear()}eventuallyUpdateResourceStates(){const M=[];this.E.forEach(z=>{const V=z._takeResourceStateSnapshot();V.length!==0&&M.push([z.handle,V])}),M.length>0&&this.#e.$spliceResourceStates(this.x,M),this.E.clear()}getResourceGroup(M){return this.e.get(M)}setSelectionState(M){this.v=M,this.w.fire(M)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(M=>M.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ye([(0,D.$di)(100)],b.prototype,"eventuallyAddResourceGroups",null),Ye([(0,D.$di)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let N=class{static{d=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(M,z,V,F){this.m=z,this.n=V,this.o=F,this.g=new Map,this.h=new E.$Bn,this.j=new h.$qe,this.e=M.getProxy(A.$bO.MainThreadSCM),this.f=M.getProxy(A.$bO.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===f.MarshalledId.ScmResource){const W=this.g.get(j.sourceControlHandle);if(!W)return j;const J=W.getResourceGroup(j.groupHandle);return J?J.getResourceState(j.handle):j}else if(j&&j.$mid===f.MarshalledId.ScmResourceGroup){const W=this.g.get(j.sourceControlHandle);return W?W.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===f.MarshalledId.ScmProvider){const W=this.g.get(j.handle);return W||j}return j}})}createSourceControl(M,z,V,F){this.o.trace("ExtHostSCM#createSourceControl",M.identifier.value,z,V,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:M.identifier.value});const j=d.d++,W=new b(M,this.n,this.e,this.m,z,V,F);this.g.set(j,W);const J=this.h.get(M.identifier)||[];return J.push(W),this.h.set(M.identifier,J),W}getLastInputBox(M){this.o.trace("ExtHostSCM#getLastInputBox",M.identifier.value);const z=this.h.get(M.identifier),V=z&&z[z.length-1];return V&&V.inputBox}$provideOriginalResource(M,z,V){const F=s.URI.revive(z);this.o.trace("ExtHostSCM#$provideOriginalResource",M,F.toString());const j=this.g.get(M);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.$Ch)(()=>j.quickDiffProvider.provideOriginalResource(F,V)).then(W=>W||null)}$onInputBoxValueChange(M,z){this.o.trace("ExtHostSCM#$onInputBoxValueChange",M);const V=this.g.get(M);return V&&V.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(M,z,V,F){this.o.trace("ExtHostSCM#$executeResourceCommand",M,z,V);const j=this.g.get(M);if(!j)return Promise.resolve(void 0);const W=j.getResourceGroup(z);return W?W.$executeResourceCommand(V,F):Promise.resolve(void 0)}$validateInput(M,z,V){this.o.trace("ExtHostSCM#$validateInput",M);const F=this.g.get(M);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,T.$Ch)(()=>F.inputBox.validateInput(z,V)).then(j=>{if(!j)return Promise.resolve(void 0);const W=v.MarkdownString.fromStrict(j.message);return W?Promise.resolve([W,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(M){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",M),M!==void 0&&this.g.get(M)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=M,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(M,z,V,F){return await this.g.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,V,F)??void 0}async $resolveHistoryItemGroupCommonAncestor2(M,z,V){return await this.g.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(z,V)??void 0}async $provideHistoryItems(M,z,V,F){return(await this.g.get(M)?.historyProvider?.provideHistoryItems(z,V,F))?.map(J=>n(J))??void 0}async $provideHistoryItems2(M,z,V){return(await this.g.get(M)?.historyProvider?.provideHistoryItems2(z,V))?.map(W=>n(W))??void 0}async $provideHistoryItemSummary(M,z,V,F){const j=this.g.get(M)?.historyProvider;if(typeof j?.provideHistoryItemSummary!="function")return;const W=await j.provideHistoryItemSummary(z,V,F);return W?n(W):void 0}async $provideHistoryItemChanges(M,z,V,F){return await this.g.get(M)?.historyProvider?.provideHistoryItemChanges(z,V,F)??void 0}};e.$2sc=N,e.$2sc=N=d=Ye([We(3,I.$fk)],N)}),define(Re[317],Ce([1,0,6,15,2]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3sc=void 0;class O{static{this.a=0}constructor(A,p){this.d=p,this.c=new Map,this.b=A.getProxy(s.$bO.MainThreadShare)}async $provideShare(A,p,c){return await this.c.get(A)?.provideShare({selection:h.Range.to(p.selection),resourceUri:D.URI.revive(p.resourceUri)},c)??void 0}registerShareProvider(A,p){const c=O.a++;return this.c.set(c,p),this.b.$registerShareProvider(c,h.DocumentSelector.from(A,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$3sc=O}),define(Re[318],Ce([1,0,9,6,7,3,15,17]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6sc=e.$5sc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new s.$dP("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new s.$dP("statusBarItem.warningForeground")]])}#e;#t;constructor(f,P,v,o,m,$=s.StatusBarAlignment.Left,d){if(this.i=!1,this.k="",this.q=new O.$Yc,this.#e=f,this.#t=P,m&&o){this.c=(0,s.$RO)(o.identifier,m);const i=v.get(this.c);i&&($=i.alignLeft?s.StatusBarAlignment.Left:s.StatusBarAlignment.Right,d=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=o,this.f=m,this.g=$,this.h=this.u(d)}u(f){if((0,A.$ng)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(f){this.k=f,this.v()}set name(f){this.m=f,this.v()}set tooltip(f){this.l=f,this.v()}set color(f){this.n=f,this.v()}set backgroundColor(f){f&&!p.b.has(f.id)&&(f=void 0),this.o=f,this.v()}set command(f){this.r?.fromApi!==f&&(this.p&&this.q.add(this.p),this.p=new O.$Yc,typeof f=="string"?this.r={fromApi:f,internal:this.#t.toInternal({title:"",command:f},this.p)}:f?this.r={fromApi:f,internal:this.#t.toInternal(f,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(f){this.t=f,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let P;this.m?P=this.m:P=(0,D.localize)(2712,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=p.b.get(this.o.id));const o=T.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,f,this.e?.identifier.value,P,this.k,o,this.r?.internal,v,this.o,this.g===s.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$5sc=p;class c{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",s.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,D.localize)(2713,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const P={message:f};return this.b.unshift(P),this.c(),new s.$dO(()=>{const v=this.b.indexOf(P);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(f,P){this.e=new Map,this.a=f.getProxy(h.$bO.MainThreadStatusBar),this.b=P,this.c=new c(this)}$acceptStaticEntries(f){for(const P of f)this.e.set(P.entryId,P)}createStatusBarEntry(f,P,v,o){return new p(this.a,this.b,this.e,f,P,v,o)}setStatusBarMessage(f,P){const v=this.c.setMessage(f);let o;return typeof P=="number"?o=setTimeout(()=>v.dispose(),P):typeof P<"u"&&P.then(()=>v.dispose(),()=>v.dispose()),new s.$dO(()=>{v.dispose(),clearTimeout(o)})}}e.$6sc=I}),define(Re[172],Ce([1,0,30,161,75,121,76,15,2]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Q=e.$3Q=e.$2Q=e.$1Q=void 0,s=Ue(s),A=Ue(A);const c=(i,a,t,r)=>{let n=a;return{enumerable:!0,configurable:!1,get(){return n},set(u){if(!t(n,u)){const l=n;n=u,i.listener?.(r(u,l))}}}},I=(i,a)=>i===a,E={range:(i,a)=>i===a?!0:!i||!a?!1:i.isEqual(a),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,a)=>!(i.length!==a.length||i.some(t=>!a.find(r=>t.id===r.id)))},f=i=>a=>({op:O.TestItemEventOp.SetProp,update:i(a)}),P=(i,a)=>({range:(()=>{let t;const r=f(n=>({range:s.$Yt.lift(A.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return t},set(n){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),E.range(t,n)||(t=n,i.listener?.(r(n)))}}})(),label:c(i,a,E.label,f(t=>({label:t}))),description:c(i,void 0,E.description,f(t=>({description:t}))),sortText:c(i,void 0,E.sortText,f(t=>({sortText:t}))),canResolveChildren:c(i,!1,E.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:c(i,!1,E.busy,f(t=>({busy:t}))),error:c(i,void 0,E.error,f(t=>({error:A.MarkdownString.fromStrict(t)||null}))),tags:c(i,[],E.tags,(t,r)=>({op:O.TestItemEventOp.SetTags,new:t.map(A.TestTag.from),old:r.map(A.TestTag.from)}))}),v=i=>{const a=D.$tJ.fromString(i.extId),t=new m(a.controllerId,a.localId,i.label,p.URI.revive(i.uri)||void 0);return t.range=A.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(r=>A.TestTag.to({id:(0,T.$zJ)(r).tagId})),t},o=i=>{let a;for(const t of i.tests){const r=v(t.item);(0,h.$KQ)(r).parent=a,a=r}return a};e.$1Q=o;class m{constructor(a,t,r,n){if(t.includes(D.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const u=(0,h.$JQ)(this,a);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof $?void 0:u.parent}},children:{value:(0,O.$IQ)(u,h.$KQ,m),enumerable:!0,writable:!1},...P(u,r)})}}e.$2Q=m;class $ extends m{constructor(a,t){super(a,a,t,void 0),this._isRoot=!0}}e.$3Q=$;class d extends O.$EQ{constructor(a,t,r){super({controllerId:a,getDocumentVersion:n=>n&&r.getDocument(n)?.version,getApiFor:h.$KQ,getChildren:n=>n.children,root:new $(a,t),toITestItem:A.TestItem.from})}}e.$4Q=d}),define(Re[35],Ce([1,0,17,9,15,24,6,18,11,38,30,55,2,3,5,19,172,21,53,52,44,92,95,31]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=e.$bR=e.$aR=e.$_Q=e.$$Q=e.$0Q=void 0,h=Ue(h),D=Ue(D);let u=class{#e;#t;#i;constructor(R,C,w){this.b=new Map,this.c=new Map,this.#e=R.getProxy(T.$bO.MainThreadCommands),this.d=C,this.#i=w,this.#t=R.getProxy(T.$bO.MainThreadTelemetry),this.converter=new l(this,b=>{const N=this.c.get(b);return N?.result===y.Void?N:void 0},C),this.f=[{processArgument(b){return(0,c.$hi)(b)}},{processArgument(b){return(0,O.$oo)(b,function(N){if(I.$Yt.isIRange(N))return D.Range.to(N);if(E.$Xt.isIPosition(N))return D.Position.to(N);if(I.$Yt.isIRange(N.range)&&f.URI.isUri(N.uri))return D.location.to(N);if(N instanceof $.$Se)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(R){this.f.push(R)}registerApiCommand(R){const C=this.registerCommand(!1,R.id,async(...w)=>{const b=R.args.map((L,M)=>{if(!L.validate(w[M]))throw new Error(`Invalid argument '${L.name}' when running '${R.id}', received: ${typeof w[M]=="object"?JSON.stringify(w[M],null,"	"):w[M]} `);return L.convert(w[M])}),N=await this.executeCommand(R.internalId,...b);return R.result.convert(N,w,this.converter)},void 0,{description:R.description,args:R.args,returns:R.result.description});return this.c.set(R.id,R),new h.$dO(()=>{C.dispose(),this.c.delete(R.id)})}registerCommand(R,C,w,b,N,L){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:w,thisArg:b,metadata:N,extension:L}),R&&this.#e.$registerCommand(C),new h.$dO(()=>{this.b.delete(C)&&R&&this.#e.$unregisterCommand(C)})}executeCommand(R,...C){return this.d.trace("ExtHostCommands#executeCommand",R),this.g(R,C,!0)}async g(R,C,w){if(this.b.has(R))return this.#e.$fireCommandActivationEvent(R),this.h(R,C,!1);{let b=!1;const N=(0,O.$oo)(C,function(L){if(L instanceof h.$eO)return D.Position.from(L);if(L instanceof h.$fO)return D.Range.from(L);if(L instanceof h.$rO)return D.location.from(L);if(h.$HP.isNotebookRange(L))return D.NotebookRange.from(L);if(L instanceof ArrayBuffer)return b=!0,$.$Se.wrap(new Uint8Array(L));if(L instanceof Uint8Array)return b=!0,$.$Se.wrap(L);if(L instanceof $.$Se)return b=!0,L;if(!Array.isArray(L))return L});try{const L=await this.#e.$executeCommand(R,b?new d.$9w(N):N,w);return(0,c.$hi)(L)}catch(L){if(L instanceof Error&&L.message==="$executeCommand:retry")return this.g(R,C,!1);throw L}}}async h(R,C,w){const b=this.b.get(R);if(!b)throw new Error("Unknown command");const{callback:N,thisArg:L,metadata:M}=b;if(M?.args)for(let V=0;V<M.args.length;V++)try{(0,s.$Ag)(C[V],M.args[V].constraint)}catch{throw new Error(`Running the contributed command: '${R}' failed. Illegal argument '${M.args[V].name}' - ${M.args[V].description}`)}const z=a.$ke.create();try{return await N.apply(L,C)}catch(V){if(R===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...C);F&&(R=F.command)}if(this.d.error(V,R,b.extension?.identifier),!w)throw V;if(b.extension?.identifier){const F=this.#i.onExtensionError(b.extension.identifier,V);this.d.trace("forwarded error to extension?",F,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$vj)(V)),this.id=R,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,R,z.elapsed())}}j(R,C,w){R.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:R.extension.identifier.value,id:new t.$Fp(C),duration:w})}$executeContributedCommand(R,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",R);const w=this.b.get(R);return w?(C=C.map(b=>this.f.reduce((N,L)=>L.processArgument(N,w.extension?.identifier),b)),this.h(R,C,!0)):Promise.reject(new Error(`Contributed command '${R}' does not exist.`))}getCommands(R=!1){return this.d.trace("ExtHostCommands#getCommands",R),this.#e.$getCommands().then(C=>(R&&(C=C.filter(w=>w[0]!=="_")),C))}$getContributedCommandMetadata(){const R=Object.create(null);for(const[C,w]of this.b){const{metadata:b}=w;b&&(R[C]=b)}return Promise.resolve(R)}};e.$0Q=u,e.$0Q=u=Ye([We(0,o.$OQ),We(1,p.$fk),We(2,r.$9Q)],u),e.$$Q=(0,v.$Ki)("IExtHostCommands");class l{constructor(R,C,w){this.d=R,this.f=C,this.g=w,this.delegatingCommandId=`__vsc${(0,n.$7g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(R,C){if(!R)return;const w={$ident:void 0,id:R.command,title:R.title,tooltip:R.tooltip};if(!R.command)return w;const b=this.f(R.command);if(b)w.id=b.internalId,w.arguments=b.args.map((N,L)=>N.convert(R.arguments&&R.arguments[L]));else if((0,A.$Pb)(R.arguments)){const N=`${R.command} /${++this.c}`;this.b.set(N,R),C.add((0,P.$Xc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),w.$ident=N,w.id=this.delegatingCommandId,w.arguments=[N],this.g.trace("CommandsConverter#CREATE",R.command,N)}return w}fromInternal(R){return typeof R.$ident=="string"?this.b.get(R.$ident):{command:R.id,title:R.title,arguments:R.arguments}}getActualCommand(...R){return this.b.get(R[0])}h(...R){const C=this.getActualCommand(...R);return this.g.trace("CommandsConverter#EXECUTE",R[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${R[0]}`)}}e.$_Q=l;class g{static{this.Uri=new g("uri","Uri of a text document",R=>f.URI.isUri(R),R=>R)}static{this.Position=new g("position","A position in a text document",R=>h.$eO.isPosition(R),D.Position.from)}static{this.Range=new g("range","A range in a text document",R=>h.$fO.isRange(R),D.Range.from)}static{this.Selection=new g("selection","A selection in a text document",R=>h.$gO.isSelection(R),D.Selection.from)}static{this.Number=new g("number","",R=>typeof R=="number",R=>R)}static{this.String=new g("string","",R=>typeof R=="string",R=>R)}static{this.StringArray=g.Arr(g.String)}static Arr(R){return new g(`${R.name}_array`,`Array of ${R.name}, ${R.description}`,C=>Array.isArray(C)&&C.every(w=>R.validate(w)),C=>C.map(w=>R.convert(w)))}static{this.CallHierarchyItem=new g("item","A call hierarchy item",R=>R instanceof h.$DO,D.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new g("item","A type hierarchy item",R=>R instanceof h.$3P,D.TypeHierarchyItem.from)}static{this.TestItem=new g("testItem","A VS Code TestItem",R=>R instanceof m.$2Q,D.TestItem.from)}constructor(R,C,w,b){this.name=R,this.description=C,this.validate=w,this.convert=b}optional(){return new g(this.name,`(optional) ${this.description}`,R=>R==null||this.validate(R),R=>R===void 0?void 0:R===null?null:this.convert(R))}with(R,C){return new g(R??this.name,C??this.description,this.validate,this.convert)}}e.$aR=g;class y{static{this.Void=new y("no result",R=>R)}constructor(R,C){this.description=R,this.convert=C}}e.$bR=y;class k{constructor(R,C,w,b,N){this.id=R,this.internalId=C,this.description=w,this.args=b,this.result=N}}e.$cR=k}),define(Re[319],Ce([1,0,18,14,2,88,147,36,35,15,9]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=void 0,O=Ue(O),c=Ue(c),I=Ue(I);const E=[new p.$cR("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of DocumentHighlight-instances.",P(c.DocumentHighlight.to))),new p.$cR("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$aR.Uri],new p.$bR("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,m)=>{if((0,s.$Ob)(o))return;class $ extends I.$yO{static to(i){const a=new $(i.name,c.SymbolKind.to(i.kind),i.containerName||"",new I.$rO(m[0],c.Range.to(i.range)));return a.detail=i.detail,a.range=a.location.range,a.selectionRange=c.Range.to(i.selectionRange),a.children=i.children?i.children.map($.to):[],a}}return o.map($.to)})),new p.$cR("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$aR.Uri,new p.$aR("options","Formatting options",o=>!0,o=>o)],new p.$bR("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new p.$cR("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$aR.Uri,p.$aR.Range,new p.$aR("options","Formatting options",o=>!0,o=>o)],new p.$bR("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new p.$cR("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$aR.Uri,p.$aR.Position,new p.$aR("ch","Trigger character",o=>typeof o=="string",o=>o),new p.$aR("options","Formatting options",o=>!0,o=>o)],new p.$bR("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new p.$cR("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$cR("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$cR("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$cR("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$cR("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$cR("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$cR("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$cR("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$cR("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of Location-instances.",P(c.location.to))),new p.$cR("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of Location-instances.",P(c.location.to))),new p.$cR("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new p.$cR("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new p.$cR("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$aR.Uri,new p.$aR("position","A position in a text document",o=>Array.isArray(o)&&o.every(m=>I.$eO.isPosition(m)),o=>o.map(c.Position.from))],new p.$bR("A promise that resolves to an array of ranges.",o=>o.map(m=>{let $;for(const d of m.reverse())$=new I.$CO(c.Range.to(d),$);return $}))),new p.$cR("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$aR.String.with("query","Search string")],new p.$bR("A promise that resolves to an array of SymbolInformation-instances.",o=>o.map(c.WorkspaceSymbol.to))),new p.$cR("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of CallHierarchyItem-instances",o=>o.map(c.CallHierarchyItem.to))),new p.$cR("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$aR.CallHierarchyItem],new p.$bR("A promise that resolves to an array of CallHierarchyIncomingCall-instances",o=>o.map(c.CallHierarchyIncomingCall.to))),new p.$cR("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$aR.CallHierarchyItem],new p.$bR("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",o=>o.map(c.CallHierarchyOutgoingCall.to))),new p.$cR("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to a range and placeholder text.",o=>{if(o)return{range:c.Range.to(o.range),placeholder:o.text}})),new p.$cR("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$aR.Uri,p.$aR.Position,p.$aR.String.with("newName","The new symbol name")],new p.$bR("A promise that resolves to a WorkspaceEdit.",o=>{if(o){if(o.rejectReason)throw new Error(o.rejectReason);return c.WorkspaceEdit.to(o)}})),new p.$cR("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$aR.Uri,p.$aR.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$bR("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(c.DocumentLink.to))),new p.$cR("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$aR.Uri],new p.$bR("A promise that resolves to SemanticTokensLegend.",o=>{if(o)return new I.$yP(o.tokenTypes,o.tokenModifiers)})),new p.$cR("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$aR.Uri],new p.$bR("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const m=(0,T.$Geb)(o);if(m.type==="full")return new I.$AP(m.data,void 0)})),new p.$cR("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$aR.Uri,p.$aR.Range.optional()],new p.$bR("A promise that resolves to SemanticTokensLegend.",o=>{if(o)return new I.$yP(o.tokenTypes,o.tokenModifiers)})),new p.$cR("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$aR.Uri,p.$aR.Range],new p.$bR("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const m=(0,T.$Geb)(o);if(m.type==="full")return new I.$AP(m.data,void 0)})),new p.$cR("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$aR.Uri,p.$aR.Position,p.$aR.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$aR.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$bR("A promise that resolves to a CompletionList-instance.",(o,m,$)=>{if(!o)return new I.$OO([]);const d=o.suggestions.map(i=>c.CompletionItem.to(i,$));return new I.$OO(d,o.incomplete)})),new p.$cR("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$aR.Uri,p.$aR.Position,p.$aR.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$bR("A promise that resolves to SignatureHelp.",o=>{if(o)return c.SignatureHelp.to(o)})),new p.$cR("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$aR.Uri,p.$aR.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$bR("A promise that resolves to an array of CodeLens-instances.",(o,m,$)=>P(d=>new I.$GO(c.Range.to(d.range),d.command&&$.fromInternal(d.command)))(o))),new p.$cR("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$aR.Uri,new p.$aR("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>I.$fO.isRange(o),o=>I.$gO.isSelection(o)?c.Selection.from(o):c.Range.from(o)),p.$aR.String.with("kind","Code action kind to return code actions for").optional(),p.$aR.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$bR("A promise that resolves to an array of Command-instances.",(o,m,$)=>P(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return $.fromInternal(d.command)}else{const i=new I.$AO(d.title,d.kind?new I.$BO(d.kind):void 0);return d.edit&&(i.edit=c.WorkspaceEdit.to(d.edit)),d.command&&(i.command=$.fromInternal(d.command)),i.isPreferred=d.isPreferred,i}})(o))),new p.$cR("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$aR.Uri],new p.$bR("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(m=>new I.$UO(c.Range.to(m.range),c.Color.to(m.color))):[])),new p.$cR("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$aR("color","The color to show and insert",o=>o instanceof I.$TO,c.Color.from),new p.$aR("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:c.Range.from(o.range)}))],new p.$bR("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(c.ColorPresentation.to):[])),new p.$cR("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$aR.Uri,p.$aR.Range],new p.$bR("A promise that resolves to an array of Inlay objects",(o,m,$)=>o.map(c.InlayHint.to.bind(void 0,$)))),new p.$cR("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$aR.Uri],new p.$bR("A promise that resolves to an array of FoldingRange objects",(o,m)=>{if(o)return o.map(c.FoldingRange.to)})),new p.$cR("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$bR("A promise that resolves to an array of NotebookContentProvider static info objects.",P(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(m=>c.NotebookExclusiveDocumentPattern.to(m))})))),new p.$cR("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$aR.Uri,p.$aR.Range,new p.$aR("context","An InlineValueContext",o=>o&&typeof o.frameId=="number"&&o.stoppedLocation instanceof I.$fO,o=>c.InlineValueContext.from(o))],new p.$bR("A promise that resolves to an array of InlineValue objects",o=>o.map(c.InlineValue.to))),new p.$cR("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$aR("uriOrString","Uri-instance or string (only http/https)",o=>D.URI.isUri(o)||typeof o=="string"&&(0,h.$Ug)(o,h.Schemas.http,h.Schemas.https),o=>o),new p.$aR("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[c.ViewColumn.from(o),void 0]:[c.ViewColumn.from(o.viewColumn),c.TextEditorOpenOptions.from(o)])).optional(),p.$aR.String.with("label","").optional()],p.$bR.Void),new p.$cR("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$aR.Uri.with("resource","Resource to open"),p.$aR.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$aR("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[c.ViewColumn.from(o),void 0]:[c.ViewColumn.from(o.viewColumn),c.TextEditorOpenOptions.from(o)])).optional()],p.$bR.Void),new p.$cR("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$aR.Uri.with("left","Left-hand side resource of the diff editor"),p.$aR.Uri.with("right","Right-hand side resource of the diff editor"),p.$aR.String.with("title","Human readable title for the diff editor").optional(),new p.$aR("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[c.ViewColumn.from(o.viewColumn),c.TextEditorOpenOptions.from(o)]).optional()],p.$bR.Void),new p.$cR("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$aR.String.with("title","Human readable title for the changes editor"),new p.$aR("resourceList","List of resources to compare",o=>{for(const m of o){if(m.length!==3)return!1;const[$,d,i]=m;if(!D.URI.isUri($)||!D.URI.isUri(d)&&d!==void 0&&d!==null||!D.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},o=>o)],p.$bR.Void),new p.$cR("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$aR.Uri,p.$aR.Position],new p.$bR("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(c.TypeHierarchyItem.to))),new p.$cR("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$aR.TypeHierarchyItem],new p.$bR("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(c.TypeHierarchyItem.to))),new p.$cR("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$aR.TypeHierarchyItem],new p.$bR("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(c.TypeHierarchyItem.to))),new p.$cR("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$aR.TestItem],p.$bR.Void),new p.$cR("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$aR.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$bR.Void),new p.$cR("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$aR.String.with("name","The context key name"),new p.$aR("value","The context key value",()=>!0,o=>o)],p.$bR.Void),new p.$cR("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$aR.Uri,p.$aR.StringArray,new p.$aR("MappedEditsContext","Mapped Edits Context",o=>c.MappedEditsContext.is(o),o=>c.MappedEditsContext.from(o))],new p.$bR("A promise that resolves to a workspace edit or null",o=>o?c.WorkspaceEdit.to(o):null)),new p.$cR("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$aR("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?c.Range.from(o.initialRange):void 0,initialSelection:I.$gO.isSelection(o.initialSelection)?c.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?c.Position.from(o.position):void 0}})],p.$bR.Void)];class f{static register(m){E.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",A.$Jj)}}e.$drc=f;function P(o){return m=>{if(Array.isArray(m))return m.map(o)}}function v(o){if(!Array.isArray(o))return;const m=[];for(const $ of o)O.$Vu($)?m.push(c.DefinitionLink.to($)):m.push(c.location.to($));return m}}),define(Re[320],Ce([1,0,2,35]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jsc=void 0;class D{constructor(T,A,p,c,I){this.a=A,this.b=p,this.c=c;const E=new h.$cR("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$aR("showOptions","Show Options",f=>!0,f=>f),new h.$aR("resource","Interactive resource Uri",f=>!0,f=>f),new h.$aR("controllerId","Notebook controller Id",f=>!0,f=>f),new h.$aR("title","Interactive editor title",f=>!0,f=>f)],new h.$bR("Notebook and input URI",f=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const P=this.a.getEditorById(f.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:s.URI.revive(f.notebookUri),inputUri:s.URI.revive(f.inputUri),notebookEditor:P.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:s.URI.revive(f.notebookUri),inputUri:s.URI.revive(f.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(T,A,p,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:p,uri:T,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(T,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.$Jsc=D}),define(Re[321],Ce([1,0,18,8,20,4,3,28,2,23,11,6,35,15,9,122,263,25,53,264]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rsc=void 0,e.$Ssc=g,P=Ue(P);let a=class{constructor(k,S,R,C,w){this.m=S,this.n=R,this.o=C,this.q=w,this.b=new A.$Fc,this.c=new A.$Fc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$qe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=k.getProxy(E.$bO.MainThreadNotebookKernels);const b=new f.$cR("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new f.$aR("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const M=this.n.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:M}}else if(L&&"notebookEditor"in L){const M=this.n.getIdByEditor(L.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return L})],f.$bR.Void),N=new f.$cR("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[f.$aR.Uri],new f.$bR("A promise that resolves to an array of variables",(L,M)=>L.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(N)}createNotebookController(k,S,R,C,w,b){for(const te of this.j.values())if(te.controller.id===S&&c.$zn.equals(k.identifier,te.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const N=this.k++,L=this;this.q.trace(`NotebookController[${N}], CREATED by ${k.identifier.value}, ${S}`);const M=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${k.identifier}'`);let z=!1;const V=new O.$qe,F=new O.$qe,j={id:g(k.identifier,S),notebookType:R,extensionId:k.identifier,extensionLocation:k.extensionLocation,label:C||k.identifier.value,preloads:b?b.map(P.NotebookRendererScript.from):[]};let W=w??M,J,B;this.a.$addKernel(N,j).catch(te=>{console.log(te),z=!0});let U=0;const _=()=>{if(z)return;const te=++U;Promise.resolve().then(()=>{te===U&&this.a.$updateKernel(N,j)})},x=new A.$Fc,oe={get id(){return S},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:V.event,get label(){return j.label},set label(te){j.label=te??k.displayName??k.name,_()},get detail(){return j.detail??""},set detail(te){j.detail=te,_()},get description(){return j.description??""},set description(te){j.description=te,_()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(te){j.supportedLanguages=te,_()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(te){j.supportsExecutionOrder=te,_()},get rendererScripts(){return j.preloads?j.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(te){W=te??M},get interruptHandler(){return J},set interruptHandler(te){J=te,j.supportsInterrupt=!!te,_()},set variableProvider(te){(0,$.$DH)(k,"notebookVariableProvider"),B=te,j.hasVariableProvider=!!te,te?.onDidChangeVariables(me=>L.a.$variablesUpdated(me.uri)),_()},get variableProvider(){return B},createNotebookCellExecution(te){if(z)throw new Error("notebook controller is DISPOSED");if(!x.has(te.notebook.uri))throw L.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(me=>me.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.notebook.uri.toString()}`);return L._createNotebookCellExecution(te,g(k.identifier,this.id))},createNotebookExecution(te){if((0,$.$DH)(k,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!x.has(te.uri))throw L.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(me=>me.toString())),new Error(`notebook controller is NOT associated to notebook: ${te.uri.toString()}`);return L._createNotebookExecution(te,g(k.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${N}], DISPOSED`),z=!0,this.j.delete(N),V.dispose(),F.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(te,me){me===v.NotebookControllerAffinity2.Hidden&&(0,$.$DH)(k,"notebookControllerAffinityHidden"),L.a.$updateNotebookPriority(N,te.uri,me)},onDidReceiveMessage:F.event,postMessage(te,me){return(0,$.$DH)(k,"notebookMessaging"),L.a.$postMessage(N,me&&L.n.getIdByEditor(me),te)},asWebviewUri(te){return(0,$.$DH)(k,"notebookMessaging"),(0,o.$FEb)(te,L.m.remote)}};return this.j.set(N,{extensionId:k.identifier,controller:oe,onDidReceiveMessage:F,onDidChangeSelection:V,associatedNotebooks:x}),oe}getIdByController(k){for(const[S,R]of this.j)if(R.controller===k)return g(R.extensionId,k.id);return null}createNotebookControllerDetectionTask(k,S){const R=this.g++,C=this;this.q.trace(`NotebookControllerDetectionTask[${R}], CREATED by ${k.identifier.value}`),this.a.$addKernelDetectionTask(R,S);const w={dispose:()=>{this.f.delete(R),C.a.$removeKernelDetectionTask(R)}};return this.f.set(R,w),w}registerKernelSourceActionProvider(k,S,R){const C=this.i++,w=typeof R.onDidChangeNotebookKernelSourceActions=="function"?C:void 0,b=this;this.h.set(C,R),this.q.trace(`NotebookKernelSourceActionProvider[${C}], CREATED by ${k.identifier.value}`),this.a.$addKernelSourceActionProvider(C,C,S);let N;return w!==void 0&&(N=R.onDidChangeNotebookKernelSourceActions(L=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(C),b.a.$removeKernelSourceActionProvider(C,C),N?.dispose()}}}async $provideKernelSourceActions(k,S){const R=this.h.get(k);if(R){const C=new T.$Yc;return(await R.provideNotebookKernelSourceActions(S)??[]).map(b=>P.NotebookKernelSourceAction.from(b,this.o.converter,C))}return[]}$acceptNotebookAssociation(k,S,R){const C=this.j.get(k);if(C){const w=this.n.getNotebookDocument(p.URI.revive(S));R?C.associatedNotebooks.set(w.uri,!0):C.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${k}] ASSOCIATE notebook`,w.uri.toString(),R),C.onDidChangeSelection.fire({selected:R,notebook:w.apiNotebook})}}async $executeCells(k,S,R){const C=this.j.get(k);if(!C)return;const w=this.n.getNotebookDocument(p.URI.revive(S)),b=[];for(const N of R){const L=w.getCell(N);L&&b.push(L.apiCell)}try{this.q.trace(`NotebookController[${k}] EXECUTE cells`,w.uri.toString(),b.length),await C.controller.executeHandler.call(C.controller,b,w.apiNotebook,C.controller)}catch(N){this.q.error(`NotebookController[${k}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(k,S,R){const C=this.j.get(k);if(!C)return;const w=this.n.getNotebookDocument(p.URI.revive(S));if(C.controller.interruptHandler)await C.controller.interruptHandler.call(C.controller,w.apiNotebook);else for(const b of R){const N=w.getCell(b);N&&this.b.get(N.uri)?.cancel()}if(C.controller.interruptHandler){const b=this.c.get(w.uri);this.c.delete(w.uri),R.length&&Array.isArray(b)&&b.length&&b.forEach(N=>N.dispose())}}async $provideVariables(k,S,R,C,w,b,N){const L=this.j.get(k);if(!L)return;const M=this.n.getNotebookDocument(p.URI.revive(R)),z=L.controller.variableProvider;if(!z)return;let V;if(C!==void 0){if(V=this.s[C],!V)return}else this.s={};const F=w==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,j=z.provideVariables(M.apiNotebook,V,F,b,N);let W=0;for await(const J of j){if(N.isCancellationRequested)return;const B={id:this.r++,name:J.variable.name,value:J.variable.value,type:J.variable.type,interfaces:J.variable.interfaces,language:J.variable.language,expression:J.variable.expression,hasNamedChildren:J.hasNamedChildren,indexedChildrenCount:J.indexedChildrenCount,extensionId:L.extensionId.value};if(this.s[B.id]=J.variable,this.a.$receiveVariable(S,B),W++>=i.$mL)return}}$acceptKernelMessageFromRenderer(k,S,R){const C=this.j.get(k);if(!C)return;const w=this.n.getEditorById(S);C.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:R}))}$cellExecutionChanged(k,S,R){const w=this.n.getNotebookDocument(p.URI.revive(k)).getCell(S);if(w){const b=R?P.NotebookCellExecutionState.to(R):v.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:w.apiCell,state:b})}}_createNotebookCellExecution(k,S){if(k.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const C=this.n.getNotebookDocument(k.notebook.uri).getCellFromApiCell(k);if(!C)throw new Error("invalid cell");if(this.b.has(C.uri))throw new Error(`duplicate execution for ${C.uri}`);const w=new r(S,C,this.a);this.b.set(C.uri,w);const b=w.onDidChangeState(()=>{w.state===t.Resolved&&(w.dispose(),b.dispose(),this.b.delete(C.uri))});return w.asApiObject()}_createNotebookExecution(k,S){const R=this.n.getNotebookDocument(k.uri),C=k.getCells().find(N=>{const L=R.getCellFromApiCell(N);return L&&this.b.has(L.uri)});if(C)throw new Error(`duplicate cell execution for ${C.document.uri}`);if(this.c.has(R.uri))throw new Error(`duplicate notebook execution for ${R.uri}`);const w=new u(S,R,this.a),b=w.onDidChangeState(()=>{w.state===n.Resolved&&(w.dispose(),b.dispose(),this.c.delete(R.uri))});return this.c.set(R.uri,[w,b]),w.asApiObject()}};e.$Rsc=a,e.$Rsc=a=Ye([We(4,I.$fk)],a);var t;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(t||(t={}));class r extends T.$Zc{static{this.a=0}get state(){return this.f}constructor(k,S,R){super(),this.m=S,this.n=R,this.b=r.a++,this.c=new O.$qe,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new D.$Be),this.h=new l(10,C=>this.s(C)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,k,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(k){await this.h.addItem(k)}async s(k){const S=Array.isArray(k)?k:[k];return this.n.$updateExecution(this.b,new d.$9w(S))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(k){let S=this.m;if(k&&(S=this.m.notebook.getCellFromApiCell(k)),!S)throw new Error("INVALID cell");return S.handle}y(k){return k.map(S=>{const R=v.$LP.ensureUniqueMimeTypes(S.items,!0);return R===S.items?P.NotebookCellOutput.from(S):P.NotebookCellOutput.from({items:R,id:S.id,metadata:S.metadata})})}async z(k,S,R){const C=this.w(S),w=this.y((0,s.$6b)(k));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:C,append:R,outputs:w})}async C(k,S,R){return k=v.$LP.ensureUniqueMimeTypes((0,s.$6b)(k),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:k.map(P.NotebookCellOutputItem.from),outputId:S.id,append:R})}asApiObject(){const k=this;return Object.freeze({get token(){return k.g.token},get cell(){return k.m.apiCell},get executionOrder(){return k.j},set executionOrder(R){k.j=R,k.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:k.j}])},start(R){if(k.f===t.Resolved||k.f===t.Started)throw new Error("Cannot call start again");k.f=t.Started,k.c.fire(),k.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:R})},end(R,C,w){if(k.f===t.Resolved)throw new Error("Cannot call resolve twice");k.f=t.Resolved,k.c.fire(),k.h.flush();const b=w?{message:w.message,stack:w.stack,location:w?.location?{startLineNumber:w.location.start.line,startColumn:w.location.start.character,endLineNumber:w.location.end.line,endColumn:w.location.end.character}:void 0,uri:w.uri}:void 0;k.n.$completeExecution(k.b,new d.$9w({runEndTime:C,lastRunSuccess:R,error:b}))},clearOutput(R){return k.t(),k.z([],R,!1)},appendOutput(R,C){return k.t(),k.z(R,C,!0)},replaceOutput(R,C){return k.t(),k.z(R,C,!1)},appendOutputItems(R,C){return k.t(),k.C(R,C,!0)},replaceOutputItems(R,C){return k.t(),k.C(R,C,!1)}})}}var n;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(n||(n={}));class u extends T.$Zc{static{this.a=0}get state(){return this.f}constructor(k,S,R){super(),this.h=S,this.j=R,this.b=u.a++,this.c=new O.$qe,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new D.$Be),this.j.$createNotebookExecution(this.b,k,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(k,S){this.f=k,this.g=S,this.a=[],this.b=Date.now()}addItem(k){return this.a.push(k),this.c||(this.c=new h.$8h,this.b=Date.now(),(0,h.$Lh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const k=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>k.complete())}}function g(y,k){return`${y.value}/${k}`}}),define(Re[49],Ce([1,0,4,6,5,2,19,3,9,7,12,245,20,31,246,247,51,8,15,35,41]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=e.$Trc=e.$Src=e.$Rrc=void 0,e.$Rrc=(0,D.$Ki)("IExtHostTerminalService");class t extends A.$Zc{constructor(w,b,N,L){super(),this.u=w,this._id=b,this.w=N,this.y=L,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new s.$qe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(z=>this.g=z);const M=this;this.value={get name(){return M.y||""},get processId(){return M.b},get creationOptions(){return M.w},get exitStatus(){return M.j},get state(){return M.m},get selection(){return M.n},get shellIntegration(){return M.shellIntegration},sendText(z,V=!0){M.C(),M.u.$sendText(M._id,z,V)},show(z){M.C(),M.u.$show(M._id,z)},hide(){M.C(),M.u.$hide(M._id)},dispose(){M.a||(M.a=!0,M.u.$dispose(M._id))},get dimensions(){if(!(M.f===void 0||M.h===void 0))return{columns:M.f,rows:M.h}}}}dispose(){this.s.fire(),super.dispose()}async create(w,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??b?.cwd??void 0,env:w.env??void 0,icon:k(w.iconPath)??void 0,color:m.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z(w.location,b?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,b,N,L,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:L,color:m.ThemeColor.isThemeColor(M)?M.id:void 0,location:b?.location||this.z(w,N),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(w,b){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in w?{viewColumn:d.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.y=w}setExitStatus(w,b){this.j=Object.freeze({code:w,reason:b})}setDimensions(w,b){return w===this.f&&b===this.h||w===0||b===0?!1:(this.f=w,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(w){this.n=w}_setProcessId(w){this.g?(this.g(w),this.g=void 0):this.b.then(b=>{b!==w&&(this.b=Promise.resolve(w))})}}e.$Src=t;class r{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new s.$qe,this.onProcessData=this.a.event,this.b=new s.$qe,this.d=new s.$qe,this.onDidChangeProperty=this.d.event,this.f=new s.$qe,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,b){this.g.setDimensions?.({columns:w,rows:b})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:v.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:v.ProcessPropertyType.Title,value:b})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let n=1,u=class extends A.$Zc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,b,N){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new A.$1c),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new s.$qe,this.onDidCloseTerminal=this.H.event,this.I=new s.$qe,this.onDidOpenTerminal=this.I.event,this.J=new s.$qe,this.onDidChangeActiveTerminal=this.J.event,this.L=new s.$qe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new s.$qe,this.onDidChangeTerminalState=this.M.event,this.N=new s.$qe,this.onDidChangeShell=this.N.event,this.O=new s.$qe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new s.$qe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=N.getProxy(h.$bO.MainThreadTerminalService),this.y=new o.$dAb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:L=>{const M=z=>{const V=z;return this.getTerminalById(V.instanceId)?.value};switch(L?.$mid){case a.MarshalledId.TerminalContext:return M(L);default:{if(Array.isArray(L))for(let z=0;z<L.length&&L[z].$mid===a.MarshalledId.TerminalContext;z++)L[z]=M(L[z]);return L}}}}),this.B({dispose:()=>{for(const[L,M]of this.g)M.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,b){const N=new t(this.a,(0,P.$7g)(),w,w.name),L=new r(w.pty);return N.createExtensionTerminal(w.location,b,this.R(w,b).resolvedExtHostIdentifier,k(w.iconPath),S(w.color)).then(M=>{const z=this.S(M,L);this.h[M]=z}),this.f.push(N),N.value}R(w,b){if(b=b||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const N=w.location.parentTerminal;if(N){const L=this.f.find(M=>M.value===N);L&&(b.resolvedExtHostIdentifier=L._id)}}else w.location&&typeof w.location!="object"?b.location=w.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(w,b){if(!this.getTerminalById(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const L=new r(b),M=this.S(w,L);this.h[w]=M}async $acceptActiveTerminalChanged(w){const b=this.b;if(w===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const N=this.getTerminalById(w);N&&(this.b=N,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,b){const N=this.getTerminalById(w);N&&this.O.fire({terminal:N.value,data:b})}async $acceptTerminalDimensions(w,b,N){const L=this.getTerminalById(w);L&&L.setDimensions(b,N)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(w,b){const N=this.getTerminalById(w);N&&this.P.fire({terminal:N.value,...b})}async $acceptTerminalMaximumDimensions(w,b,N){this.g.get(w)?.resize(b,N)}async $acceptTerminalTitleChange(w,b){const N=this.getTerminalById(w);N&&(N.name=b)}async $acceptTerminalClosed(w,b,N){const L=this.X(this.f,w);if(L!==null){const M=this.f.splice(L,1)[0];M.setExitStatus(b,N),this.H.fire(M.value)}}$acceptTerminalOpened(w,b,N,L){if(b){const V=this.X(this.f,b);if(V!==null){this.f[V]._id=w,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const M={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:O.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},z=new t(this.a,w,M,N);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(w,b){this.getTerminalById(w)?._setProcessId(b)}async $startExtensionTerminal(w,b){const N=this.getTerminalById(w);if(!N)return{message:(0,c.localize)(2715,null,w)};N.isOpen||await new Promise(M=>{const z=this.onDidOpenTerminal(async V=>{V===N.value&&(z.dispose(),M())})});const L=this.g.get(w);L?L.startSendingEvents(b):this.j[w]={initialDimensions:b}}S(w,b){const N=new A.$Yc;N.add(b.onProcessReady(M=>this.a.$sendProcessReady(w,M.pid,M.cwd,M.windowsPty))),N.add(b.onDidChangeProperty(M=>this.a.$sendProcessProperty(w,M))),this.y.startBuffering(w,b.onProcessData),N.add(b.onProcessExit(M=>this.U(w,M))),this.g.set(w,b);const L=this.j[w];return L&&b instanceof r&&(b.startSendingEvents(L.initialDimensions),delete this.j[w]),N}$acceptProcessAckDataEvent(w,b){this.g.get(w)?.acknowledgeDataEvent(b)}$acceptProcessInput(w,b){this.g.get(w)?.input(b)}$acceptTerminalInteraction(w){const b=this.getTerminalById(w);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(w,b){this.getTerminalById(w)?.setSelection(b)}$acceptProcessResize(w,b,N){try{this.g.get(w)?.resize(b,N)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(w,b){this.g.get(w)?.shutdown(b)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(w,{type:v.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(b=>this.a.$sendProcessProperty(w,{type:v.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new p.$dO(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,b,N){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,N),this.a.$registerProfileProvider(b,w.identifier.value),new p.$dO(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(w,b,N){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,N),this.a.$registerQuickFixProvider(w,b),new p.$dO(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,b){const N=new f.$Be().token;if(N.isCancellationRequested)return;const L=this.D.get(w);if(!L)return;const M=await L.provideTerminalQuickFixes(b,N);if(M===null||Array.isArray(M)&&M.length===0)return;const z=new A.$Yc;if(this.w.value=z,!Array.isArray(M))return M?d.TerminalQuickFix.from(M,this.Q.converter,z):void 0;const V=[];for(const F of M){const j=d.TerminalQuickFix.from(F,this.Q.converter,z);j&&V.push(j)}return V}async $createContributedProfileTerminal(w,b){const N=new f.$Be().token;let L=await this.C.get(w)?.provideTerminalProfile(N);if(!N.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,b);return}this.createTerminalFromOptions(L.options,b)}}async $provideLinks(w,b){const N=this.getTerminalById(w);if(!N)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const M=new f.$Be;this.G.set(w,M);const z=[],V={terminal:N.value,line:b},F=[];for(const J of this.z)F.push($.Promises.withAsyncBody(async B=>{M.token.onCancellationRequested(()=>B({provider:J,links:[]}));const U=await J.provideTerminalLinks(V,M.token)||[];M.token.isCancellationRequested||B({provider:J,links:U})}));const j=await Promise.all(F);if(M.token.isCancellationRequested)return[];const W=new Map;for(const J of j)J&&J.links.length>0&&z.push(...J.links.map(B=>{const U={id:n++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return W.set(U.id,{provider:J.provider,link:B}),U}));return this.F.set(w,W),z}$activateLink(w,b){const N=this.F.get(w)?.get(b);N&&N.provider.handleTerminalLink(N.link)}U(w,b){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const N=this.h[w];N&&(N.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,b)}getTerminalById(w){return this.W(this.f,w)}getTerminalIdByApiObject(w){const b=this.f.findIndex(N=>N.value===w);return b>=0?b:null}W(w,b){const N=this.X(w,b);return N!==null?w[N]:null}X(w,b){const N=w.findIndex(L=>L._id===b);return N>=0?N:null}getEnvironmentVariableCollection(w){let b=this.n.get(w.identifier.value);return b||(b=this.B(new l),this.Z(w.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y(w,b){const N=(0,E.$Ps)(b.map),L=(0,E.$Qs)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(w,b.persistent,N.length===0?void 0:N,L)}$initEnvironmentVariableCollections(w){w.forEach(b=>{const N=b[0],L=this.B(new l(b[1]));this.Z(N,L)})}$acceptDefaultProfile(w,b){const N=this.s;this.s=w,this.u=b,N?.path!==w.path&&this.N.fire(w.path)}Z(w,b){this.n.set(w,b),this.B(b.onDidChangeCollection(()=>{this.Y(w,b)}))}};e.$Trc=u,e.$Trc=u=Ye([We(1,i.$$Q),We(2,T.$OQ)],u);class l extends A.$Zc{get persistent(){return this.b}set persistent(w){this.b=w,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(w){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new s.$qe,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const b=this.j(w);let N=this.a.get(b);return N||(N=new g(this,w),this.a.set(b,N),this.B(N.onDidChangeCollection(()=>this.f.fire()))),N}replace(w,b,N,L){this.g(w,{value:b,type:p.EnvironmentVariableMutatorType.Replace,options:N??{applyAtProcessCreation:!0},scope:L})}append(w,b,N,L){this.g(w,{value:b,type:p.EnvironmentVariableMutatorType.Append,options:N??{applyAtProcessCreation:!0},scope:L})}prepend(w,b,N,L){this.g(w,{value:b,type:p.EnvironmentVariableMutatorType.Prepend,options:N??{applyAtProcessCreation:!0},scope:L})}g(w,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const N=this.h(w,b.scope),L=this.map.get(N),M=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==b.value||L.type!==b.type||L.options?.applyAtProcessCreation!==M.applyAtProcessCreation||L.options?.applyAtShellIntegration!==M.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const z=this.h(w,b.scope),V={variable:w,...b,options:M};this.map.set(z,V),this.f.fire()}}get(w,b){const N=this.h(w,b),L=this.map.get(N);return L?R(L):void 0}h(w,b){const N=this.j(b);return N.length?`${w}:::${N}`:w}j(w){return this.m(w?.workspaceFolder)??""}m(w){return w?w.uri.toString():void 0}getVariableMap(w){const b=new Map;for(const[N,L]of this.map)this.j(L.scope)===this.j(w)&&b.set(L.variable,R(L));return b}delete(w,b){const N=this.h(w,b);this.map.delete(N),this.f.fire()}clear(w){if(w?.workspaceFolder){for(const[b,N]of this.map)N.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(b);this.n(w)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(w,b){const N=this.j(b),L=this.descriptionMap.get(N);if(!L||L.description!==w){let M;typeof w=="string"?M=w:M=w?.value.split(`

`)[0];const z={description:M,scope:b};this.descriptionMap.set(N,z),this.f.fire()}}getDescription(w){const b=this.j(w);return this.descriptionMap.get(b)?.description}n(w){const b=this.j(w);this.descriptionMap.delete(b)}}class g{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,b){this.b=w,this.d=b,this.a=new s.$qe}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,b,N){this.b.replace(w,b,N,this.d)}append(w,b,N){this.b.append(w,b,N,this.d)}prepend(w,b,N){this.b.prepend(w,b,N,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,b){this.b.getVariableMap(this.d).forEach((N,L)=>w.call(b,L,N,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let y=class extends u{constructor(w,b){super(!1,w,b)}createTerminal(w,b,N){throw new I.$db}createTerminalFromOptions(w,b){throw new I.$db}};e.$Urc=y,e.$Urc=y=Ye([We(0,i.$$Q),We(1,T.$OQ)],y);function k(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function S(C){return m.ThemeColor.isThemeColor(C)?C:void 0}function R(C){const w={...C};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(Re[173],Ce([1,0,9,3,5,6,19,49,4,2,8]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$sc=e.$0sc=void 0,e.$0sc=(0,D.$Ki)("IExtHostTerminalShellIntegration");let E=class extends h.$Zc{constructor(m,$){super(),this.h=$,this.b=new Map,this.c=new p.$qe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$qe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$qe,this.onDidEndTerminalShellExecution=this.g.event,this.a=m.getProxy(O.$bO.MainThreadTerminalShellIntegration),this.B((0,h.$Xc)(()=>{for(const[d,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(m){const $=this.h.getTerminalById(m);if(!$)return;const d=$.value;let i=this.b.get(m);i||(i=new f($.value,this.f),this.b.set(m,i),i.store.add($.onWillDispose(()=>this.b.get(m)?.dispose())),i.store.add(i.onDidRequestShellExecution(a=>this.a.$executeCommand(m,a))),i.store.add(i.onDidRequestEndExecution(a=>this.g.fire(a))),i.store.add(i.onDidRequestChangeShellIntegration(a=>this.c.fire(a))),$.shellIntegration=i.value),this.c.fire({terminal:d,shellIntegration:i.value})}$shellExecutionStart(m,$,d,i,a){this.b.has(m)||this.$shellIntegrationChange(m);const t={value:$,confidence:d,isTrusted:i};this.b.get(m)?.startShellExecution(t,c.URI.revive(a))}$shellExecutionEnd(m,$,d,i,a){const t={value:$,confidence:d,isTrusted:i};this.b.get(m)?.endShellExecution(t,a)}$shellExecutionData(m,$){this.b.get(m)?.emitData($)}$cwdChange(m,$){this.b.get(m)?.setCwd(c.URI.revive($))}$closeTerminal(m){this.b.get(m)?.dispose(),this.b.delete(m)}};e.$$sc=E,e.$$sc=E=Ye([We(0,T.$OQ),We(1,A.$Rrc)],E);class f extends h.$Zc{get currentExecution(){return this.a}constructor(m,$){super(),this.j=m,this.m=$,this.b=!1,this.store=this.B(new h.$Yc),this.f=this.B(new p.$qe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$qe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$qe),this.onDidRequestEndExecution=this.h.event;const d=this;this.value={get cwd(){return d.c},executeCommand(i,a){let t=i;a&&(t+=` "${a.map(u=>`${u.replaceAll('"','\\"')}`).join('" "')}"`),d.g.fire(t);const r={value:t,confidence:s.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},n=d.startShellExecution(r,d.c,!0).value;return d.b=!0,n}}}startShellExecution(m,$,d){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new P(m,$??this.c);d?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(m){this.currentExecution?.emitData(m)}endShellExecution(m,$){this.a&&(this.a.endExecution(m),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:$}),this.a=void 0)}setCwd(m){let $=!1;c.URI.isUri(this.c)?$=!c.URI.isUri(m)||this.c.toString()!==m.toString():this.c!==m&&($=!0),$&&(this.c=m,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class P{constructor(m,$){this.c=m,this.cwd=$,this.b=!1;const d=this;this.value={get commandLine(){return d.c},get cwd(){return d.cwd},read(){return d.d()}}}d(){if(!this.a){if(this.b)return I.$$h.EMPTY;this.a=new v}return this.a.createIterable()}emitData(m){this.a?.emitData(m)}endExecution(m){m&&(this.c=m),this.a?.endExecution(),this.a=void 0,this.b=!0}}class v extends h.$Zc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Jh);const m=this.a;return new I.$$h(async d=>{this.b.push(d),await m.wait()})}emitData(m){for(const $ of this.b)$.emitOne(m)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Re[174],Ce([1,0,67,12,135,15,9]),function(ge,e,s,h,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XQ=e.$WQ=e.$VQ=void 0,O=Ue(O);class A{static{this.c=new D.$TQ("TextEditorDecorationType")}constructor(f,P,v){const o=A.c.nextId();f.$registerTextEditorDecorationType(P.identifier,o,O.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:o,dispose(){f.$removeTextEditorDecorationType(o)}})}}e.$VQ=A;class p{constructor(f,P){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,P){this.k();let v=null;if(f instanceof T.$eO)v=new T.$fO(f,f);else if(f instanceof T.$fO)v=f;else throw new Error("Unrecognized location");this.l(v,P,!1)}insert(f,P){this.k(),this.l(new T.$fO(f,f),P,!0)}delete(f){this.k();let P=null;if(f instanceof T.$fO)P=f;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(f,P,v){const o=this.c.validateRange(f);this.g.push({range:o,text:P,forceMoveMarkers:v})}setEndOfLine(f){if(this.k(),f!==T.EndOfLine.LF&&f!==T.EndOfLine.CRLF)throw(0,h.$$)("endOfLine");this.h=f}}class c{constructor(f,P,v,o){this.c=f,this.d=P,this._accept(v),this.e=o;const m=this;this.value={get tabSize(){return m.f},set tabSize($){m.n($)},get indentSize(){return m.g},set indentSize($){m.p($)},get insertSpaces(){return m.j},set insertSpaces($){m.s($)},get cursorStyle(){return m.k},set cursorStyle($){m.t($)},get lineNumbers(){return m.l},set lineNumbers($){m.u($)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.originalIndentSize,this.j=f.insertSpaces,this.k=f.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(f.lineNumbers)}m(f){if(f==="auto")return"auto";if(typeof f=="number"){const P=Math.floor(f);return P>0?P:null}if(typeof f=="string"){const P=parseInt(f,10);return isNaN(P)?null:P>0?P:null}return null}n(f){const P=this.m(f);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}o(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const P=Math.floor(f);return P>0?P:null}if(typeof f=="string"){const P=parseInt(f,10);return isNaN(P)?null:P>0?P:null}return null}p(f){const P=this.o(f);if(P!==null){if(typeof P=="number"){if(this.h===P)return;this.g=P,this.h=P}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}q(f){return f==="auto"?"auto":f==="false"?!1:!!f}s(f){const P=this.q(f);if(typeof P=="boolean"){if(this.j===P)return;this.j=P}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}t(f){this.k!==f&&(this.k=f,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}u(f){this.l!==f&&(this.l=f,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(f)})))}assign(f){const P={};let v=!1;if(typeof f.tabSize<"u"){const o=this.m(f.tabSize);o==="auto"?(v=!0,P.tabSize=o):typeof o=="number"&&this.f!==o&&(this.f=o,v=!0,P.tabSize=o)}if(typeof f.indentSize<"u"){const o=this.o(f.indentSize);o==="tabSize"?(v=!0,P.indentSize=o):typeof o=="number"&&this.h!==o&&(this.g=o,this.h=o,v=!0,P.indentSize=o)}if(typeof f.insertSpaces<"u"){const o=this.q(f.insertSpaces);o==="auto"?(v=!0,P.insertSpaces=o):this.j!==o&&(this.j=o,v=!0,P.insertSpaces=o)}typeof f.cursorStyle<"u"&&this.k!==f.cursorStyle&&(this.k=f.cursorStyle,v=!0,P.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.l!==f.lineNumbers&&(this.l=f.lineNumbers,v=!0,P.lineNumbers=O.TextEditorLineNumbersStyle.from(f.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,P))}v(f,P){P.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(v)})}}e.$WQ=c;class I{constructor(f,P,v,o,m,$,d,i){this.id=f,this.j=P,this.k=v,this.g=!1,this.h=new Set,this.c=m,this.d=new c(this.j,this.id,$,v),this.e=d,this.f=i;const a=this;this.value=Object.freeze({get document(){return o.value},set document(t){throw new h.$ab("document")},get selection(){return a.c&&a.c[0]},set selection(t){if(!(t instanceof T.$gO))throw(0,h.$$)("selection");a.c=[t],a.l()},get selections(){return a.c},set selections(t){if(!Array.isArray(t)||t.some(r=>!(r instanceof T.$gO)))throw(0,h.$$)("selections");a.c=t,a.l()},get visibleRanges(){return a.e},set visibleRanges(t){throw new h.$ab("visibleRanges")},get options(){return a.d.value},set options(t){a.g||a.d.assign(t)},get viewColumn(){return a.f},set viewColumn(t){throw new h.$ab("viewColumn")},edit(t,r={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new p(o.value,r);return t(n),a.m(n)},insertSnippet(t,r,n={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!r||Array.isArray(r)&&r.length===0)u=a.c.map(l=>O.Range.from(l));else if(r instanceof T.$eO){const{lineNumber:l,column:g}=O.Position.from(r);u=[{startLineNumber:l,startColumn:g,endLineNumber:l,endColumn:g}]}else if(r instanceof T.$fO)u=[O.Range.from(r)];else{u=[];for(const l of r)if(l instanceof T.$fO)u.push(O.Range.from(l));else{const{lineNumber:g,column:y}=O.Position.from(l);u.push({startLineNumber:g,startColumn:y,endLineNumber:g,endColumn:y})}}return P.$tryInsertSnippet(f,o.value.version,t.value,u,n)},setDecorations(t,r){const n=r.length===0;n&&!a.h.has(t.key)||(n?a.h.delete(t.key):a.h.add(t.key),a.n(()=>{if(O.$LQ(r))return P.$trySetDecorations(f,t.key,O.$MQ(r));{const u=new Array(4*r.length);for(let l=0,g=r.length;l<g;l++){const y=r[l];u[4*l]=y.start.line+1,u[4*l+1]=y.start.character+1,u[4*l+2]=y.end.line+1,u[4*l+3]=y.end.character+1}return P.$trySetDecorationsFast(f,t.key,u)}}))},revealRange(t,r){a.n(()=>P.$tryRevealRange(f,O.Range.from(t),r||T.TextEditorRevealType.Default))},show(t){P.$tryShowEditor(f,O.ViewColumn.from(t))},hide(){P.$tryHideEditor(f)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,s.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,s.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,s.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,s.ok)(!this.g),this.f=f}_acceptSelections(f){(0,s.ok)(!this.g),this.c=f}async l(){const f=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const P=f.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const v=P.edits.map(m=>m.range);v.sort((m,$)=>m.end.line===$.end.line?m.end.character===$.end.character?m.start.line===$.start.line?m.start.character-$.start.character:m.start.line-$.start.line:m.end.character-$.end.character:m.end.line-$.end.line);for(let m=0,$=v.length-1;m<$;m++){const d=v[m].end;if(v[m+1].start.isBefore(d))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=P.edits.map(m=>({range:O.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,o,{setEndOfLine:typeof P.setEndOfLine=="number"?O.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.$XQ=I}),define(Re[65],Ce([1,0,67,4,3,2,5,6,170,19,174,15,11,28,14,40,50]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZQ=e.$YQ=void 0,s=Ue(s),E=Ue(E);class ${constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let d=class{constructor(a,t){this.h=a,this.i=t,this.a=null,this.b=new Map,this.c=new P.$Fc,this.d=new h.$qe,this.e=new h.$qe,this.f=new h.$qe,this.g=new h.$qe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const t=[],r=[],n=[];if(a.removedDocuments)for(const u of a.removedDocuments){const l=O.URI.revive(u),g=this.c.get(l);g?.unref()&&(this.c.delete(l),t.push(g.value))}if(a.addedDocuments)for(const u of a.addedDocuments){const l=O.URI.revive(u.uri);let g=this.c.get(l);if(g&&l.scheme!==v.Schemas.vscodeNotebookCell&&l.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);g||(g=new $(new p.$RQ(this.h.getProxy(A.$bO.MainThreadDocuments),l,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty)),this.c.set(l,g),r.push(g.value)),g.ref()}if(a.removedEditors)for(const u of a.removedEditors){const l=this.b.get(u);this.b.delete(u),l&&n.push(l)}if(a.addedEditors)for(const u of a.addedEditors){const l=O.URI.revive(u.documentUri);s.ok(this.c.has(l),`document '${l}' does not exist`),s.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const g=this.c.get(l).value,y=new I.$XQ(u.id,this.h.getProxy(A.$bO.MainThreadTextEditors),this.i,new m.$Y(()=>g.document),u.selections.map(E.Selection.to),u.options,u.visibleRanges.map(k=>E.Range.to(k)),typeof u.editorPosition=="number"?E.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,y)}a.newActiveEditor!==void 0&&(s.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,D.$Uc)(t),(0,D.$Uc)(n),a.removedDocuments&&this.e.fire(t),a.addedDocuments&&this.d.fire(r),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return o.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const t=this.b.get(this.a);return a?t:t?.value}allEditors(){return[...this.b.values()]}};e.$YQ=d,e.$YQ=d=Ye([We(0,c.$OQ),We(1,f.$fk)],d),e.$ZQ=(0,T.$Ki)("IExtHostDocumentsAndEditors")}),define(Re[99],Ce([1,0,8,21,20,4,81,61,3,41,17,2,31,5,11,6,35,65,19,172,15,9,266,75,121,76,25]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t,r,n,u,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsc=e.$csc=e.$bsc=e.$asc=e.$_rc=void 0,a=Ue(a);let y=0;const k=new WeakMap;e.$_rc=(0,P.$Ki)("IExtHostTesting");let S=class extends p.$Zc{constructor(U,_,x,oe){super(),this.C=_,this.D=x,this.F=oe,this.f=this.B(new O.$qe),this.g=new Map,this.w=this.B(new O.$qe),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(o.$bO.MainThreadTesting),this.m=new V(this.h),this.j=new b(this.h,_),x.registerArgumentProcessor({processArgument:te=>{switch(te?.$mid){case c.MarshalledId.TestItemContext:{const me=te,ce=me.tests[me.tests.length-1].item.extId;return this.g.get(n.$tJ.root(ce))?.collection.tree.get(ce)?.actual??(0,i.$1Q)(te)}case c.MarshalledId.TestMessageMenuArgs:{const{test:me,message:ce}=te,Y=me.item.extId;return{test:this.g.get(n.$tJ.root(Y))?.collection.tree.get(Y)?.actual??(0,i.$1Q)({$mid:c.MarshalledId.TestItemContext,tests:[me]}),message:a.TestMessage.to(ce)}}default:return te}}}),x.registerCommand(!1,"testing.getExplorerSelection",async()=>{const te=await x.executeCommand(r.TestCommandId.GetExplorerSelection),me=ce=>{const Y=this.g.get(n.$tJ.root(ce));if(Y)return n.$tJ.isRoot(ce)?Y.controller:Y.collection.tree.get(ce)?.actual};return{include:te?.include.map(me).filter(I.$rg)||[],exclude:te?.exclude.map(me).filter(I.$rg)||[]}})}createTestController(U,_,x,oe){if(this.g.has(_))throw new Error(`Attempt to insert a duplicate controller with ID "${_}"`);const te=new p.$Yc,me=te.add(new i.$4Q(_,x,this.F));me.root.label=x;const ce=new Map,Y=new Set,q=this.h,se=()=>{let we=0;oe&&(we|=l.TestControllerCapability.Refresh);const $e=ae.relatedCodeProvider;return $e&&($e?.provideRelatedTests&&(we|=l.TestControllerCapability.TestRelatedToCode),$e?.provideRelatedCode&&(we|=l.TestControllerCapability.CodeRelatedToTest)),we},be={items:me.root.children,get label(){return x},set label(we){x=we,me.root.label=we,q.$updateController(_,{label:x})},get refreshHandler(){return oe},set refreshHandler(we){oe=we,q.$updateController(_,{capabilities:se()})},get id(){return _},get relatedCodeProvider(){return ae.relatedCodeProvider},set relatedCodeProvider(we){(0,g.$DH)(U,"testRelatedCode"),ae.relatedCodeProvider=we,q.$updateController(_,{capabilities:se()})},createRunProfile:(we,$e,pe,Oe,Fe,He)=>{let Ze=(0,A.$yj)(we);for(;ce.has(Ze);)Ze++;return new j(this.h,ce,Y,this.w.event,_,Ze,we,$e,pe,Oe,Fe,He)},createTestItem(we,$e,pe){return new i.$2Q(_,we,$e,pe)},createTestRun:(we,$e,pe=!0)=>this.j.createTestRun(U,_,me,we,$e,pe),invalidateTestResults:we=>{if(we===void 0)this.h.$markTestRetired(void 0);else{const $e=we instanceof Array?we:[we];this.h.$markTestRetired($e.map(pe=>n.$tJ.fromExtHostTestItem(pe,_).toString()))}},set resolveHandler(we){me.resolveHandler=we},get resolveHandler(){return me.resolveHandler},dispose:()=>{te.dispose()}},ae={controller:be,collection:me,profiles:ce,extension:U,activeProfiles:Y};return q.$registerTestController(_,x,se()),te.add((0,p.$Xc)(()=>q.$unregisterTestController(_))),this.g.set(_,ae),te.add((0,p.$Xc)(()=>this.g.delete(_))),te.add(me.onDidGenerateDiff(we=>q.$publishDiff(_,we.map(l.TestsDiffOp.serialize)))),be}createTestObserver(){return this.m.checkout()}async runTests(U,_=D.CancellationToken.None){const x=N(U);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const oe=this.g.get(x.controllerId);if(!oe)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:U.preserveFocus??!0,group:W[x.kind],targets:[{testIds:U.include?.map(te=>n.$tJ.fromExtHostTestItem(te,oe.collection.root.id).toString())??[oe.collection.root.id],profileId:x.profileId,controllerId:x.controllerId}],exclude:U.exclude?.map(te=>te.id)},_)}registerTestFollowupProvider(U){return this.y.add(U),{dispose:()=>{this.y.delete(U)}}}async $getTestsRelatedToCode(U,_,x){const oe=this.F.getDocument(E.URI.revive(U));if(!oe)return[];const te=a.Position.to(_),me=[];return await Promise.all([...this.g.values()].map(async ce=>{let Y;try{Y=await ce.relatedCodeProvider?.provideRelatedTests?.(oe.document,te,x)}catch(q){x.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${ce.controller.label}`,q)}if(Y){for(const q of Y)me.push(n.$tJ.fromExtHostTestItem(q,ce.controller.id).toString());ce.collection.flushDiff()}})),me}async $getCodeRelatedToTest(U,_){const x=this.g.get(n.$tJ.root(U));if(!x)return[];const oe=x.collection.tree.get(U);return oe?(await x.relatedCodeProvider?.provideRelatedCode?.(oe.actual,_))?.map(a.location.from)??[]:[]}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $getCoverageDetails(U,_,x){return(await this.j.getCoverageDetails(U,_,x))?.map(a.TestCoverage.fromDetails)}async $disposeRun(U){this.j.disposeTestRun(U)}$configureRunProfile(U,_){this.g.get(U)?.profiles.get(_)?.configureHandler?.()}$setDefaultRunProfiles(U){const _=new Map;for(const[x,oe]of Object.entries(U)){const te=this.g.get(x);if(!te)continue;const me=new Map,ce=oe.filter(q=>!te.activeProfiles.has(q)),Y=[...te.activeProfiles].filter(q=>!oe.includes(q));for(const q of ce)me.set(q,!0),te.activeProfiles.add(q);for(const q of Y)me.set(q,!1),te.activeProfiles.delete(q);me.size&&_.set(x,me)}this.w.fire(_)}async $refreshTests(U,_){await this.g.get(U)?.controller.refreshHandler?.(_)}$publishTestResults(U){this.results=Object.freeze(U.map(_=>{const x=a.TestResults.to(_),oe=_.tasks.findIndex(te=>te.hasCoverage);return oe!==-1&&(x.getDetailedCoverage=(te,me=D.CancellationToken.None)=>this.h.$getCoverageDetails(_.id,oe,te,me).then(ce=>ce.map(a.TestCoverage.to))),k.set(x,_.id),x}).concat(this.results).sort((_,x)=>x.completedAt-_.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,_){const x=this.g.get(n.$tJ.fromString(U).controllerId)?.collection;x&&(await x.expand(U,_<0?1/0:_),x.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(_=>l.TestsDiffOp.deserialize({asCanonicalUri:x=>x},_)))}async $runControllerTests(U,_){return Promise.all(U.map(x=>this.G(x,!1,_)))}async $startContinuousRun(U,_){const x=new D.$Be(_),oe=await Promise.all(U.map(te=>this.G(te,!0,x.token)));return!_.isCancellationRequested&&!oe.some(te=>te.error)&&await new Promise(te=>_.onCancellationRequested(te)),x.dispose(!0),oe}async $provideTestFollowups(U,_){const x=this.results.find(me=>k.get(me)===U.resultId),oe=x&&J(n.$tJ.fromString(U.extId),x?.results);if(!oe)return[];let te=[];return await Promise.all([...this.y].map(async me=>{try{const ce=await me.provideFollowup(x,oe,U.taskIndex,U.messageIndex,_);ce&&(te=te.concat(ce))}catch(ce){this.C.error("Error thrown while providing followup for test message",ce)}})),_.isCancellationRequested?[]:te.map(me=>{const ce=y++;return this.z.set(ce,me),{title:me.title,id:ce}})}$disposeTestFollowups(U){for(const _ of U)this.z.delete(_)}$executeTestFollowup(U){const _=this.z.get(U);return _?this.D.executeCommand(_.command,..._.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(U,_){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U,_)}getMetadataForRun(U){for(const _ of this.j.trackers){const x=_.getTaskIdForRun(U);if(x)return{taskId:x,runId:_.id}}}async G(U,_,x){const oe=this.g.get(U.controllerId);if(!oe)return{};const{collection:te,profiles:me,extension:ce}=oe,Y=me.get(U.profileId);if(!Y)return{};const q=U.testIds.map(we=>te.tree.get(we)).filter(I.$rg),se=U.excludeExtIds.map(we=>oe.collection.tree.get(we)).filter(I.$rg).filter(we=>q.some($e=>$e.fullId.compare(we.fullId)===n.TestPosition.IsChild));if(!q.length)return{};const be=new t.$SP(q.some(we=>we.actual instanceof i.$3Q)?void 0:q.map(we=>we.actual),se.map(we=>we.actual),Y,_),ae=(0,l.$wJ)(U)&&this.j.prepareForMainThreadTestRun(ce,be,L.fromInternal(U,oe.collection),Y,x);try{return await Y.runHandler(be,x),{}}catch(we){return{error:String(we)}}finally{ae&&ae.hasRunningTasks&&!x.isCancellationRequested&&await O.Event.toPromise(ae.onEnd)}}};e.$asc=S,e.$asc=S=Ye([We(0,d.$OQ),We(1,v.$fk),We(2,m.$$Q),We(3,$.$ZQ)],S);const R=1e4;var C;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(C||(C={}));class w extends p.$Zc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(U,_,x,oe,te,me){super(),this.C=U,this.D=_,this.F=x,this.G=oe,this.H=te,this.f=C.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new O.$qe),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new D.$Be(me));const ce=this.B(new s.$Wh(()=>this.I(),R));this.B(this.m.token.onCancellationRequested(()=>ce.schedule()));const Y=new O.$qe;this.y=Y.event,this.B((0,p.$Xc)(()=>{Y.fire(),Y.dispose()}))}getTaskIdForRun(U){for(const[_,{run:x}]of this.h)if(x===U)return _}cancel(U){U?this.h.get(U)?.cts.cancel():this.f===C.Running?(this.m.cancel(),this.f=C.Cancelling):this.f===C.Cancelling&&this.I()}async getCoverageDetails(U,_,x){const[,oe]=n.$tJ.fromString(U).path,te=this.z.get(U);if(!te)return[];const{report:me,extIds:ce}=te,Y=this.h.get(oe);if(!Y)throw new Error("unreachable: run task was not found");let q;if(_&&me instanceof t.$YP){const be=ce.indexOf(_);if(be===-1)return[];q=me.fromTests[be]}return await(q?this.G?.loadDetailedCoverageForTest?.(Y.run,me,q,x):this.G?.loadDetailedCoverage?.(Y.run,me,x))??[]}createRun(U){const _=this.C.id,x=this.C.controllerId,oe=(0,f.$7g)(),te=se=>(be,...ae)=>{if(ce){this.F.warn(`Setting the state of test "${be.id}" is a no-op after the run ends.`);return}this.L(be),se(be,...ae)},me=(se,be)=>{const ae=be instanceof Array?be.map(a.TestMessage.from):[a.TestMessage.from(be)];if(se.uri&&se.range){const we={range:a.Range.from(se.range),uri:se.uri};for(const $e of ae)$e.location=$e.location||we}this.D.$appendTestMessagesInRun(_,oe,n.$tJ.fromExtHostTestItem(se,x).toString(),ae)};let ce=!1;const Y=this.B(new D.$Be(this.m.token)),q={isPersisted:this.C.isPersisted,token:Y.token,name:U,onDidDispose:this.y,addCoverage:se=>{if(ce)return;const be=se instanceof t.$YP?se.fromTests:[];if(be.length){(0,g.$DH)(this.H,"attributableCoverage");for(const $e of be)this.L($e)}const ae=se.uri.toString(),we=new n.$tJ([_,oe,ae]).toString();this.z.set(we,{report:se,extIds:be.map($e=>n.$tJ.fromExtHostTestItem($e,x).toString())}),this.D.$appendCoverage(_,oe,a.TestCoverage.fromFile(x,we,se))},enqueued:te(se=>{this.D.$updateTestStateInRun(_,oe,n.$tJ.fromExtHostTestItem(se,x).toString(),l.TestResultState.Queued)}),skipped:te(se=>{this.D.$updateTestStateInRun(_,oe,n.$tJ.fromExtHostTestItem(se,x).toString(),l.TestResultState.Skipped)}),started:te(se=>{this.D.$updateTestStateInRun(_,oe,n.$tJ.fromExtHostTestItem(se,x).toString(),l.TestResultState.Running)}),errored:te((se,be,ae)=>{me(se,be),this.D.$updateTestStateInRun(_,oe,n.$tJ.fromExtHostTestItem(se,x).toString(),l.TestResultState.Errored,ae)}),failed:te((se,be,ae)=>{me(se,be),this.D.$updateTestStateInRun(_,oe,n.$tJ.fromExtHostTestItem(se,x).toString(),l.TestResultState.Failed,ae)}),passed:te((se,be)=>{this.D.$updateTestStateInRun(_,oe,n.$tJ.fromExtHostTestItem(se,this.C.controllerId).toString(),l.TestResultState.Passed,be)}),appendOutput:(se,be,ae)=>{ce||(ae&&this.L(ae),this.D.$appendOutputToRun(_,oe,h.$Se.fromString(se),be&&a.location.from(be),ae&&n.$tJ.fromExtHostTestItem(ae,x).toString()))},end:()=>{ce||(ce=!0,this.D.$finishedTestRunTask(_,oe),--this.g||this.J())}};return this.g++,this.h.set(oe,{run:q,cts:Y}),this.D.$startedTestRunTask(_,{id:oe,ctrlId:this.C.controllerId,name:U||this.H.displayName||this.H.identifier.value,running:!0}),q}I(){for(const{run:U}of this.h.values())U.end()}J(){this.f!==C.Ended&&(this.f=C.Ended,this.w.fire())}L(U){if(!(U instanceof i.$2Q))throw new u.$GQ(U.id);if(this.j.has(n.$tJ.fromExtHostTestItem(U,this.C.controllerId).toString()))return;const _=[],x=this.C.colllection.root;for(;;){const oe=a.TestItem.from(U);if(_.unshift(oe),this.j.has(oe.extId)||(this.j.add(oe.extId),U===x))break;U=U.parent||x}this.D.$addTestsToRun(this.C.controllerId,this.C.id,_)}dispose(){this.J(),super.dispose()}}class b{get trackers(){return this.f.values()}constructor(U,_){this.h=U,this.j=_,this.f=new Map,this.g=new Map}getCoverageDetails(U,_,x){const oe=n.$tJ.root(U);return this.g.get(oe)?.getCoverageDetails(U,_,x)||[]}disposeTestRun(U){this.g.get(U)?.dispose(),this.g.delete(U);for(const[_,{id:x}]of this.f)x===U&&this.f.delete(_)}prepareForMainThreadTestRun(U,_,x,oe,te){return this.k(_,x,oe,U,te)}cancelRunById(U,_){this.g.get(U)?.cancel(_)}cancelAllRuns(){for(const U of this.f.values())U.cancel()}createTestRun(U,_,x,oe,te,me){const ce=this.f.get(oe);if(ce)return ce.createRun(te);const Y=L.fromPublic(_,x,oe,me),q=N(oe);this.h.$startedExtensionTestRun({controllerId:_,continuous:!!oe.continuous,profile:q&&{group:W[q.kind],id:q.profileId},exclude:oe.exclude?.map(be=>n.$tJ.fromExtHostTestItem(be,x.root.id).toString())??[],id:Y.id,include:oe.include?.map(be=>n.$tJ.fromExtHostTestItem(be,x.root.id).toString())??[x.root.id],preserveFocus:oe.preserveFocus??!0,persist:me});const se=this.k(oe,Y,oe.profile,U);return O.Event.once(se.onEnd)(()=>{this.h.$finishedExtensionTestRun(Y.id)}),se.createRun(te)}k(U,_,x,oe,te){const me=new w(_,this.h,this.j,x,oe,te);return this.f.set(U,me),this.g.set(me.id,me),me}}e.$bsc=b;const N=B=>{if(B.profile){if(!(B.profile instanceof j))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class L{static fromPublic(U,_,x,oe){return new L(U,(0,f.$7g)(),oe,_)}static fromInternal(U,_){return new L(U.controllerId,U.runId,!0,_)}constructor(U,_,x,oe){this.controllerId=U,this.id=_,this.isPersisted=x,this.colllection=oe}}e.$csc=L;class M{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(U){this.k=U,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(U){this.f.add(U)}update(U){Object.assign(U.revived,a.TestItem.toPlain(U.item)),this.f.has(U)||this.g.add(U)}remove(U){if(this.f.has(U)){this.f.delete(U);return}this.g.delete(U);const _=n.$tJ.parentId(U.item.extId);if(_&&this.j.has(_.toString())){this.j.add(U.item.extId);return}this.h.add(U)}getChangeEvent(){const{f:U,g:_,h:x}=this;return{get added(){return[...U].map(oe=>oe.revived)},get updated(){return[..._].map(oe=>oe.revived)},get removed(){return[...x].map(oe=>oe.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class z extends l.$CJ{constructor(){super(...arguments),this.z=new O.$qe,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(U){return this.g.get(U)}getMirroredTestDataByReference(U){return this.g.get(U.id)}y(U,_){return{...U,revived:a.TestItem.toPlain(U.item),depth:_?_.depth+1:0,children:new Set}}x(){return new M(this.z)}}class V{constructor(U){this.g=U}checkout(){this.f||(this.f=this.h());const U=this.f;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(_=>_.revived)},dispose:(0,T.$hb)(()=>{--U.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(U){return this.f?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.f?.tests.apply(U)}h(){const U=new z({asCanonicalUri:_=>_});return this.g.$subscribeToDiffs(),{observers:0,tests:U}}}const F=(B,U,_,x)=>{_?Object.assign(_,x):U.$updateTestRunConfig(B.controllerId,B.profileId,x)};class j{#e;#t;#i;#n;#s;get label(){return this.g}set label(U){U!==this.g&&(this.g=U,F(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(U){U!==this.h&&(this.h=U,F(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),F(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,F(this,this.#e,this.#n,{tag:U?a.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.f}set configureHandler(U){U!==this.f&&(this.f=U,F(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return O.Event.chain(this.#i,U=>U.map(_=>_.get(this.controllerId)?.get(this.profileId)).filter(I.$rg))}constructor(U,_,x,oe,te,me,ce,Y,q,se=!1,be=void 0,ae=!1){this.controllerId=te,this.profileId=me,this.g=ce,this.kind=Y,this.runHandler=q,this._tag=be,this.h=ae,this.#e=U,this.#s=_,this.#t=x,this.#i=oe,_.set(me,this);const we=W[Y];if(typeof we!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);se&&x.add(me),this.#n={profileId:me,controllerId:te,tag:be?a.TestTag.namespace(this.controllerId,be.id):null,label:ce,group:we,isDefault:se,hasConfigurationHandler:!1,supportsContinuousRun:ae},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$dsc=j;const W={[t.TestRunProfileKind.Coverage]:l.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:l.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:l.TestRunProfileBitset.Run};function J(B,U){for(let _=0;_<B.path.length;_++){const x=U.find(oe=>oe.id===B.path[_]);if(!x)return;if(_===B.path.length-1)return x;U=x.children}}}),define(Re[322],Ce([1,0,18,4,3,6,174,15,9]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=void 0,s=Ue(s),A=Ue(A);class c extends D.$Zc{constructor(E,f){super(),this.m=f,this.a=new h.$qe,this.b=new h.$qe,this.c=new h.$qe,this.f=new h.$qe,this.g=new h.$qe,this.h=new h.$qe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=E.getProxy(O.$bO.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(P=>this.h.fire(P))),this.B(this.m.onDidChangeActiveTextEditor(P=>this.g.fire(P)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(E){const f=this.m.allEditors();return E?f:f.map(P=>P.value)}async showTextDocument(E,f,P){let v;typeof f=="number"?v={position:A.ViewColumn.from(f),preserveFocus:P}:typeof f=="object"?v={position:A.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selection:typeof f.selection=="object"?A.Range.from(f.selection):void 0,pinned:typeof f.preview=="boolean"?!f.preview:void 0}:v={preserveFocus:!1};const o=await this.j.$tryShowTextDocument(E.uri,v),m=o&&this.m.getEditor(o);if(m)return m.value;throw o?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,f){return new T.$VQ(this.j,E,f).value}$acceptEditorPropertiesChanged(E,f){const P=this.m.getEditor(E);if(!P)throw new Error("unknown text editor");if(f.options&&P._acceptOptions(f.options),f.selections){const v=f.selections.selections.map(A.Selection.to);P._acceptSelections(v)}if(f.visibleRanges){const v=s.$Lb(f.visibleRanges.map(A.Range.to));P._acceptVisibleRanges(v)}if(f.options&&this.b.fire({textEditor:P.value,options:{...f.options,lineNumbers:A.TextEditorLineNumbersStyle.to(f.options.lineNumbers)}}),f.selections){const v=p.TextEditorSelectionChangeKind.fromValue(f.selections.source),o=f.selections.selections.map(A.Selection.to);this.a.fire({textEditor:P.value,selections:o,kind:v})}if(f.visibleRanges){const v=s.$Lb(f.visibleRanges.map(A.Range.to));this.c.fire({textEditor:P.value,visibleRanges:v})}}$acceptEditorPositionData(E){for(const f in E){const P=this.m.getEditor(f);if(!P)throw new Error("Unknown text editor");const v=A.ViewColumn.to(E[f]);P.value.viewColumn!==v&&(P._acceptViewColumn(v),this.f.fire({textEditor:P.value,viewColumn:v}))}}getDiffInformation(E){return Promise.resolve(this.j.$getDiffInformation(E))}}e.$krc=c}),define(Re[323],Ce([1,0,2,5,6,3,9,15,23,41,17]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$btc=e.$atc=void 0,e.$atc=(0,h.$Ki)("IExtHostTimeline");class E{constructor(v,o){this.b=new Map,this.c=new Map,this.a=v.getProxy(D.$bO.MainThreadTimeline),o.registerArgumentProcessor({processArgument:(m,$)=>{if(m&&m.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(m.source)&&p.$zn.equals($,this.b.get(m.source)?.extension)){const d=m.uri===void 0?void 0:s.URI.revive(m.uri);return this.c.get(m.source)?.get(f(d))?.get(m.handle)}else return;return m}})}async $getTimeline(v,o,m,$){return this.b.get(v)?.provider.provideTimeline(s.URI.revive(o),m,$)}registerTimelineProvider(v,o,m,$){const d=new O.$Yc,i=this.d(o.id,$,d).bind(this);let a;o.onDidChange&&(a=o.onDidChange(r=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...r,id:o.id}),this));const t=this.c;return this.f({...o,scheme:v,onDidChange:void 0,async provideTimeline(r,n,u){n?.resetCache&&(d.clear(),t.get(o.id)?.clear());const l=await o.provideTimeline(r,n,u);if(l==null)return;const g=i(r,n);return{...l,source:o.id,items:l.items.map(g)}},dispose(){for(const r of t.values())r.get(o.id)?.clear();a?.dispose(),d.dispose()}},m)}d(v,o,m){return($,d)=>{let i;if(d?.cacheResults){let a=this.c.get(v);a===void 0&&(a=new Map,this.c.set(v,a));const t=f($);i=a.get(t),i===void 0&&(i=new Map,a.set(t,i))}return a=>{const{iconPath:t,...r}=a,n=`${v}|${a.id??a.timestamp}`;i?.set(n,a);let u,l,g;a.iconPath&&(t instanceof T.$cP?g={id:t.id,color:t.color}:s.URI.isUri(t)?(u=t,l=t):{light:u,dark:l}=t);let y;return T.$HO.isMarkdownString(r.tooltip)?y=A.MarkdownString.from(r.tooltip):(0,I.$jg)(r.tooltip)?y=r.tooltip:T.$HO.isMarkdownString(r.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=A.MarkdownString.from(r.detail)):(0,I.$jg)(r.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=r.detail),{...r,id:r.id??void 0,handle:n,source:v,command:a.command?o.toInternal(a.command,m):void 0,icon:u,iconDark:l,themeIcon:g,tooltip:y,accessibilityInformation:a.accessibilityInformation}}}}f(v,o){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:o}),(0,O.$Xc)(()=>{for(const $ of this.c.values())$.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$btc=E;function f(P){return P?.toString()}}),define(Re[324],Ce([1,0,7,22,2,4,3,257,8,9,17,18,15,86,20,205,25]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ctc=void 0,c=Ue(c);function $(a,t){if((0,I.$jg)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let r;return Array.isArray(a.highlights)&&(r=a.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),r=r.length?r:void 0),{label:a.label,highlights:r}}}class d extends T.$Zc{constructor(t,r,n){super(),this.f=t,this.g=r,this.h=n,this.a=new Map,this.b=new o.$sab;function u(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:l=>u(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(g=>u(g)?this.r(g):g):l})}registerTreeDataProvider(t,r,n){const u=this.createTreeView(t,{treeDataProvider:r},n);return{dispose:()=>u.dispose()}}createTreeView(t,r,n){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=r.dragAndDropController?.dropMimeTypes??[],l=r.dragAndDropController?.dragMimeTypes??[],g=!!r.dragAndDropController?.handleDrag,y=!!r.dragAndDropController?.handleDrop,k=this.m(t,r,n),S={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:u,dragMimeTypes:l,hasHandleDrag:g,hasHandleDrop:y,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},R=this.f.$registerTreeViewDataProvider(t,S),C={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,m.$DH)(n,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,m.$DH)(n,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(w){(0,P.$$k)(w)&&(0,m.$DH)(n,"treeViewMarkdownMessage"),k.message=w},get title(){return k.title},set title(w){k.title=w},get description(){return k.description},set description(w){k.description=w},get badge(){return k.badge},set badge(w){w!==void 0&&c.ViewBadge.isViewBadge(w)?k.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(k.badge=void 0)},reveal:(w,b)=>k.reveal(w,b),dispose:async()=>{await R,this.a.delete(t),k.dispose()}};return this.B(C),C}$getChildren(t,r){const n=this.a.get(t);return n?n.getChildren(r):Promise.reject(new A.$VG(t))}async $handleDrop(t,r,n,u,l,g,y,k){const S=this.a.get(t);if(!S)return Promise.reject(new A.$VG(t));const R=f.DataTransfer.toDataTransfer(n,async C=>(await this.f.$resolveDropFileData(t,r,C)).buffer);return y===t&&k&&await this.j(R,S,k,l,g),S.onDrop(R,u,l)}async j(t,r,n,u,l){const g=this.b.removeDragOperationTransfer(l);if(g)(await g)?.forEach((y,k)=>{y&&t.set(k,y)});else if(l&&r.handleDrag){const y=r.handleDrag(n,t,u);this.b.addDragOperationTransfer(l,y),await y}return t}async $handleDrag(t,r,n,u){const l=this.a.get(t);if(!l)return Promise.reject(new A.$VG(t));const g=await this.j(new c.$$O,l,r,u,n);if(!(!g||u.isCancellationRequested))return f.DataTransfer.from(g)}async $hasResolve(t){const r=this.a.get(t);if(!r)throw new A.$VG(t);return r.hasResolve}$resolve(t,r,n){const u=this.a.get(t);if(!u)throw new A.$VG(t);return u.resolveTreeItem(r,n)}$setExpanded(t,r,n){const u=this.a.get(t);if(!u)throw new A.$VG(t);u.setExpanded(r,n)}$setSelectionAndFocus(t,r,n){const u=this.a.get(t);if(!u)throw new A.$VG(t);u.setSelectionAndFocus(r,n)}$setVisible(t,r){const n=this.a.get(t);if(!n){if(!r)return;throw new A.$VG(t)}n.setVisible(r)}$changeCheckboxState(t,r){const n=this.a.get(t);if(!n)throw new A.$VG(t);n.setCheckboxState(r)}m(t,r,n){const u=this.B(new i(t,r,this.f,this.g.converter,this.h,n));return this.a.set(t,u),u}r(t){const r=this.a.get(t.$treeViewId);return r&&"$treeItemHandle"in t?r.getExtensionElement(t.$treeItemHandle):r&&"$focusedTreeItem"in t&&t.$focusedTreeItem?r.focusedElement:null}}e.$ctc=d;class i extends T.$Zc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$sg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,r,n,u,l,g){if(super(),this.I=t,this.J=n,this.L=u,this.M=l,this.N=g,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$qe),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$qe),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$qe),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$qe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$qe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$qe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$qe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$Be,g.contributes&&g.contributes.views)for(const R in g.contributes.views)for(const C of g.contributes.views[R])C.id===t&&(this.P=C.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(R=>{Array.isArray(R)&&R.length===0||this.F.fire({message:!1,element:R})}));let y,k;const S=O.Event.debounce(this.F.event,(R,C)=>(R||(R={message:!1,elements:[]}),C.element!==!1&&(y||(y=new Promise(w=>k=w),this.G=this.G.then(()=>y)),Array.isArray(C.element)?R.elements.push(...C.element):R.elements.push(C.element)),C.message&&(R.message=!0),R),200,!0);this.B(S(({message:R,elements:C})=>{C.length&&(this.H=this.H.then(()=>{const w=k;return y=null,this.$(C).then(()=>w())})),R&&this.J.$setMessage(this.I,f.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const r=t?this.getExtensionElement(t):void 0;if(t&&!r)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let n=this.X(t);return n||(n=await this.Y(r)),n?n.map(u=>u.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,r){r=r||{select:!0,focus:!1};const n=(0,I.$sg)(r.select)?!0:r.select,u=(0,I.$sg)(r.focus)?!1:r.focus,l=(0,I.$sg)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(g=>this.W(t,g[g.length-1]).then(y=>this.J.$reveal(this.I,{item:y.item,parentChain:g.map(k=>k.item)},{select:n,focus:u,expand:l})),g=>this.M.error(g)):this.J.$reveal(this.I,void 0,{select:n,focus:u,expand:l})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=f.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,r){const n=this.getExtensionElement(t);n&&(r?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(t,r){const n=!(0,E.$yb)(this.s,t);this.s=t;const u=this.t!==r;this.t=r,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const r=(await Promise.all(t.map(async n=>{const u=this.getExtensionElement(n.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);r.forEach(n=>{n.treeItem.checkboxState=n.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(n=>[n.extensionItem,n.newState])})}async handleDrag(t,r,n){const u=[];for(const l of t){const g=this.getExtensionElement(l);g&&u.push(g)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,r,n),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,r,n){const u=r?this.getExtensionElement(r):void 0;if(!(!u&&r||!this.g?.handleDrop))return(0,p.$Ch)(()=>this.g?.handleDrop?this.g.handleDrop(u,t,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,r){if(!this.f.resolveTreeItem)return;const n=this.j.get(t);if(n){const u=this.m.get(n);if(u){const l=await this.f.resolveTreeItem(u.extensionItem,n,r)??u.extensionItem;return this.hb(l),u.item.tooltip=this.eb(l.tooltip),u.item.command=this.fb(u.disposableStore,l.command),u.item}}}S(t){return this.U(t).then(r=>r?this.S(r).then(n=>this.W(r,n[n.length-1]).then(u=>(n.push(u),n))):Promise.resolve([]))}U(t){const r=this.m.get(t);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,p.$Ch)(()=>this.f.getParent(t))}W(t,r){const n=this.m.get(t);return n?Promise.resolve(n):(0,p.$Ch)(()=>this.f.getTreeItem(t)).then(u=>this.kb(t,u,r,!0)).then(u=>this.getChildren(r?r.item.handle:void 0).then(()=>{const l=this.getExtensionElement(u);if(l){const g=this.m.get(l);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let r;if(typeof t=="string"){const n=this.getExtensionElement(t);r=n?this.m.get(n):void 0}else r=t;return r&&r.children||void 0}return this.h}async Y(t){this.rb(t);const r=new v.$Be(this.Z.token);try{const n=t?this.m.get(t):void 0,u=await this.f.getChildren(t);if(r.token.isCancellationRequested)return;const l=(0,E.$Lb)(u||[]),g=await Promise.all((0,E.$Lb)(l).map(k=>this.f.getTreeItem(k)));if(r.token.isCancellationRequested)return;const y=g.map((k,S)=>k?this.db(l[S],k,n):null);return(0,E.$Lb)(y)}finally{r.dispose()}}$(t){if(t.some(n=>!n))return this.Z.dispose(!0),this.Z=new v.$Be,this.tb(),this.J.$refresh(this.I);{const n=this.ab(t);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(t){const r=new Set,n=t.map(l=>this.m.get(l));for(const l of n)if(l&&!r.has(l.item.handle)){let g=l;for(;g&&g.parent&&n.findIndex(y=>g&&g.parent&&y&&y.item.handle===g.parent.item.handle)===-1;){const y=this.j.get(g.parent.item.handle);g=y?this.m.get(y):void 0}g&&!g.parent&&r.add(l.item.handle)}const u=[];return r.forEach(l=>{const g=this.j.get(l);if(g){const y=this.m.get(g);y&&(!y.parent||!r.has(y.parent.item.handle))&&u.push(l)}}),u}bb(t){const r={};return Promise.all(t.map(n=>this.cb(n).then(u=>{u&&(r[n]=u.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb(t){const r=this.getExtensionElement(t);if(r){const n=this.m.get(r);if(n)return this.rb(r),(0,p.$Ch)(()=>this.f.getTreeItem(r)).then(u=>{if(u){const l=this.ib(r,u,n.parent);return this.pb(r,l,n,n.parent),n.dispose(),l}return null})}return Promise.resolve(null)}db(t,r,n){const u=this.ib(t,r,n);if(r.id&&this.j.has(u.item.handle))throw new Error((0,s.localize)(2716,null,r.id));return this.ob(t,u),this.qb(u,n),u}eb(t){return c.$HO.isMarkdownString(t)?f.MarkdownString.from(t):t}fb(t,r){return r?{...this.L.toInternal(r,t),originalId:r.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let r,n,u;return typeof t.checkboxState=="number"?r=t.checkboxState:(r=t.checkboxState.state,n=t.checkboxState.tooltip,u=t.checkboxState.accessibilityInformation),{isChecked:r===c.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:u}}hb(t){if(!c.$6O.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,r,n){this.hb(r);const u=this.B(new T.$Yc),l=this.kb(t,r,n),g=this.lb(r);return{item:{handle:l,parentHandle:n?n.item.handle:void 0,label:$(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(u,r.command),contextValue:r.contextValue,icon:g,iconDark:this.mb(r)||g,themeIcon:this.jb(r),collapsibleState:(0,I.$sg)(r.collapsibleState)?c.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:n,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(t){return t.iconPath instanceof c.$cP?t.iconPath:void 0}kb(t,{id:r,label:n,resourceUri:u},l,g){if(r)return`${i.b}/${r}`;const y=$(n,this.N),k=l?l.item.handle:i.a;let S=y?y.label:u?(0,h.$ih)(u):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const R=this.m.has(t)?this.m.get(t).item.handle:void 0,C=this.X(l)||[];let w,b=0;do{if(w=`${k}/${b}:${S}`,g||!this.j.has(w)||R===w)break;b++}while(b<=C.length);return w}lb(t){if(t.iconPath&&!(t.iconPath instanceof c.$cP))return typeof t.iconPath=="string"||D.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof c.$cP)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return D.URI.isUri(t)?t:D.URI.file(t)}ob(t,r){this.j.set(r.item.handle,t),this.m.set(t,r)}pb(t,r,n,u){this.j.delete(r.item.handle),this.m.delete(t),r.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(t,r);const l=this.X(u)||[],g=l.filter(y=>y.item.handle===n.item.handle)[0];g&&l.splice(l.indexOf(g),1,r)}qb(t,r){r?(r.children||(r.children=[]),r.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const r=this.m.get(t);if(r){if(r.children)for(const n of r.children){const u=this.j.get(n.item.handle);u&&this.sb(u)}r.children=void 0}}else this.tb()}sb(t){const r=this.m.get(t);if(r){if(r.children)for(const n of r.children){const u=this.j.get(n.item.handle);u&&this.sb(u)}this.m.delete(t),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[325],Ce([1,0,4,3,2,31,15,97,6,9]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=void 0,T=Ue(T),p=Ue(p),c=Ue(c);class I extends h.$Zc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(v,o,m,$){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new s.$qe),this.onDidDispose=this.#d.event,this.#h=this.B(new s.$qe),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=o,this.#n=m,this.#i=$.viewType,this.#s=$.panelOptions,this.#o=$.viewColumn,this.#r=$.title,this.#l=$.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,D.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(v){this.#u||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#l=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,o){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:T.ViewColumn.from(v),preserveFocus:!!o})}c(){if(this.#u)throw new Error("Webview is disposed")}}class E extends h.$Zc{static c(){return(0,O.$7g)()}constructor(v,o,m){super(),this.j=o,this.m=m,this.g=new Map,this.h=new Map,this.f=v.getProxy(p.$bO.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,o,m,$,d={}){const i=typeof $=="object"?$.viewColumn:$,a={viewColumn:T.ViewColumn.from(i),preserveFocus:typeof $=="object"&&!!$.preserveFocus},t=(0,A.$zrc)(v),r=E.c();this.f.$createWebviewPanel((0,A.$Brc)(v),r,o,{title:m,panelOptions:f(d),webviewOptions:(0,A.$Crc)(v,this.m,d),serializeBuffersForPostMessage:t},a);const n=this.j.createNewWebview(r,d,v);return this.createNewWebviewPanel(r,o,m,i,d,n,!0)}$onDidChangeWebviewPanelViewStates(v){const o=Object.keys(v);o.sort((m,$)=>{const d=v[m],i=v[$];return d.active?1:i.active?-1:+d.visible-+i.visible});for(const m of o){const $=this.getWebviewPanel(m);if(!$)continue;const d=v[m];$._updateViewState({active:d.active,visible:d.visible,viewColumn:T.ViewColumn.to(d.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,o,m){if(this.h.has(o))throw new Error(`Serializer for '${o}' already registered`);return this.h.set(o,{serializer:m,extension:v}),this.f.$registerSerializer(o,{serializeBuffersForPostMessage:(0,A.$zrc)(v)}),new c.$dO(()=>{this.h.delete(o),this.f.$unregisterSerializer(o)})}async $deserializeWebviewPanel(v,o,m,$){const d=this.h.get(o);if(!d)throw new Error(`No serializer found for '${o}'`);const{serializer:i,extension:a}=d,t=this.j.createNewWebview(v,m.webviewOptions,a),r=this.createNewWebviewPanel(v,o,m.title,$,m.panelOptions,t,m.active);await i.deserializeWebviewPanel(r,m.state)}createNewWebviewPanel(v,o,m,$,d,i,a){const t=new I(v,this.f,i,{viewType:o,title:m,viewColumn:$,panelOptions:d,active:a});return this.g.set(v,t),t}getWebviewPanel(v){return this.g.get(v)}}e.$Drc=E;function f(P){return{enableFindWidget:P.enableFindWidget,retainContextWhenHidden:P.retainContextWhenHidden}}}),define(Re[326],Ce([1,0,4,3,97,15,6,9]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ftc=void 0,T=Ue(T),A=Ue(A);class p extends h.$Zc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,f,P,v,o,m){super(),this.#s=!1,this.#l=this.B(new s.$qe),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new s.$qe),this.onDidDispose=this.#u.event,this.#i=P,this.#a=v,this.#e=E,this.#t=f,this.#n=o,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(E,f){this.d=f,this.b=new Map,this.c=new Map,this.a=E.getProxy(T.$bO.MainThreadWebviewViews)}registerWebviewViewProvider(E,f,P,v){if(this.b.has(f))throw new Error(`View provider for '${f}' already registered`);return this.b.set(f,{provider:P,extension:E}),this.a.$registerWebviewViewProvider((0,D.$Brc)(E),f,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.$zrc)(E)}),new A.$dO(()=>{this.b.delete(f),this.a.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(E,f,P,v,o){const m=this.b.get(f);if(!m)throw new Error(`No view provider found for '${f}'`);const{provider:$,extension:d}=m,i=this.d.createNewWebview(E,{},d),a=new p(E,this.a,f,P,i,!0);this.c.set(E,a),await $.resolveWebviewView(a,{state:v},o)}async $onDidChangeWebviewViewVisibility(E,f){this.e(E)._setVisible(f)}async $disposeWebviewView(E){const f=this.e(E);this.c.delete(E),f.dispose(),this.d.deleteWebview(E)}e(E){const f=this.c.get(E);if(!f)throw new Error("No webview found");return f}}e.$ftc=c}),define(Re[327],Ce([1,0,77,14,11,231,27,10]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xtc=void 0;let p=class{constructor(E,f){E.addFileSystemProvider(h.Schemas.file,new c(f),{isCaseSensitive:A.$n})}};e.$Xtc=p,e.$Xtc=p=Ye([We(0,s.$vrc),We(1,D.$fk)],p);class c{constructor(E){this.b=E,this.a=new O.$Dr(this.b)}async stat(E){const f=await this.a.stat(E);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions===T.FilePermission.Readonly?1:void 0}}readDirectory(E){return this.a.readdir(E)}createDirectory(E){return this.a.mkdir(E)}readFile(E){return this.a.readFile(E)}writeFile(E,f,P){return this.a.writeFile(E,f,{...P,unlock:!1,atomic:!1})}delete(E,f){return this.a.delete(E,{...f,useTrash:!1,atomic:!1})}rename(E,f,P){return this.a.rename(E,f,P)}copy(E,f,P){return this.a.copy(E,f,P)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(E,f){throw new Error("Method not implemented.")}}}),define(Re[328],Ce([1,0,16,69,31,35,3,6,2,19]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vtc=void 0;let I=class extends T.$Zc{constructor(f,P){super();const v=f.getProxy(A.$bO.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async o=>{const m=p.URI.file((0,s.$oc)((0,h.tmpdir)(),(0,D.$7g)()));return await v.$download(o,m),m})}};e.$Vtc=I,e.$Vtc=I=Ye([We(0,c.$OQ),We(1,O.$$Q)],I)}),define(Re[329],Ce([1,0,46,16,2,98,3,14,8,34]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8tc=void 0,s=Ue(s),h=Ue(h);class I extends O.$xrc{constructor(){super(...arguments),this.i=null}async g(r){const n=await super.g(r);if(n.scheme!==A.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const u=n.fsPath;let l=0;do{let g;l===0?g=u:g=/[/\\]$/.test(u)?`${u.substr(0,u.length-1)}-${l}`:`${u}-${l}`,await E(g);const y=h.$oc(g,"vscode.lock"),k=await o(this.d,y,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),D.URI.file(g);l++}while(l<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$8tc=I;async function E(t){try{await s.promises.stat(t);return}catch{}try{await s.promises.mkdir(t,{recursive:!0})}catch{}}const f=1e3,P=10*60*1e3;class v extends T.$Zc{constructor(r,n){super(),this.b=r,this.c=n,this.a=this.B(new p.$Vh),this.a.cancelAndSet(async()=>{const u=await m(r,n);(!u||u.pid!==process.pid)&&(r.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await s.promises.utimes(n,new Date,new Date)}catch(l){r.error(l),r.info(`Lock '${n}': Could not update mtime.`)}},f)}dispose(){super.dispose();try{s.unlinkSync(this.c)}catch{}}async setWillRelease(r){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${r} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+r};await c.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function o(t,r,n){try{const l={pid:process.pid,willReleaseAt:0};await c.Promises.writeFile(r,JSON.stringify(l),{flag:"wx"})}catch(l){t.error(l)}const u=await m(t,r);return!u||u.pid!==process.pid?n?(t.info(`Lock '${r}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${r}': Could not acquire lock, checking if the file is stale.`),i(t,r)):(t.info(`Lock '${r}': Lock acquired.`),new v(t,r))}async function m(t,r){let n;try{n=await s.promises.readFile(r)}catch(u){return t.error(u),null}try{return JSON.parse(String(n))}catch(u){return t.error(u),null}}async function $(t,r){let n;try{n=await s.promises.stat(r)}catch(u){return t.error(u),0}return n.mtime.getTime()}function d(t){try{return process.kill(t,0),!0}catch{return!1}}async function i(t,r){const n=await m(t,r);if(!n)return t.info(`Lock '${r}': Could not read pid of lock holder.`),a(t,r);if(n.willReleaseAt){let k=n.willReleaseAt-Date.now();if(k<5e3){for(k>0?t.info(`Lock '${r}': The lockfile is scheduled to be released in ${k} ms.`):t.info(`Lock '${r}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,p.$Lh)(Math.min(100,k)),await $(t,r)===0)return a(t,r);k=n.willReleaseAt-Date.now()}return a(t,r)}}if(!d(n.pid))return t.info(`Lock '${r}': The pid ${n.pid} appears to be gone.`),a(t,r);const u=await $(t,r),l=Date.now()-u;if(l<=P)return t.info(`Lock '${r}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;t.info(`Lock '${r}': The lock looks stale, waiting for 2s.`),await(0,p.$Lh)(2e3);const g=await $(t,r),y=Date.now()-g;return y<=P?(t.info(`Lock '${r}': The lock does not look stale, elapsed: ${y} ms, giving up.`),null):(t.info(`Lock '${r}': The lock looks stale even after waiting for 2s.`),a(t,r))}async function a(t,r){t.info(`Lock '${r}': Deleting a stale lock.`);try{await s.promises.unlink(r)}catch{}return o(t,r,!0)}}),define(Re[330],Ce([1,0,31,19,49,35]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ptc=void 0;let T=class extends D.$Trc{constructor(p,c){super(!0,p,c)}createTerminal(p,c,I){return this.createTerminalFromOptions({name:p,shellPath:c,shellArgs:I})}createTerminalFromOptions(p,c){const I=new D.$Src(this.a,(0,s.$7g)(),p,p.name);return this.f.push(I),I.create(p,this.R(p,c)),I.value}};e.$ptc=T,e.$ptc=T=Ye([We(0,O.$$Q),We(1,h.$OQ)],T)}),define(Re[331],Ce([1,0,4,37,36,5]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=e.$wN=e.OutputChannelUpdateMode=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=void 0,e.$kN="text/x-code-output",e.$lN="Log",e.$mN="text/x-code-log-output",e.$nN="log",e.$oN="workbench.panel.output",e.$pN=new D.$2j("inOutput",!1),e.$qN=new D.$2j("activeLogOutput",!1),e.$rN=new D.$2j("activeLogOutput.levelSettable",!1),e.$sN=new D.$2j("activeLogOutput.level",""),e.$tN=new D.$2j("activeLogOutput.levelIsDefault",!1),e.$uN=new D.$2j("outputView.scrollLock",!1),e.$vN=(0,O.$Ki)("outputService");var T;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(T||(e.OutputChannelUpdateMode=T={})),e.$wN={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.a=new Map,this.b=new s.$qe,this.onDidRegisterChannel=this.b.event,this.c=new s.$qe,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(I=>c.push(I)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}h.$zo.add(e.$wN.OutputChannels,new A),e.$xN=new D.$2j("activeOutputChannel","")}),define(Re[175],Ce([1,0,6,5,19,23,11,331,77,29,64,208,21,17,27,4,3]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vsc=e.$Usc=void 0;class $ extends T.$lk{get disposed(){return this.n}constructor(t,r,n,u,l){super(),this.id=t,this.name=r,this.r=n,this.s=u,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(g=>this.setLevel(g)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,A.OutputChannelUpdateMode.Clear,t)}replace(t){const r=this.m;this.info(t),this.s.$update(this.id,A.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show(t,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:r))}hide(){this.s.$close(this.id)}g(t,r){this.m+=f.$Se.fromString(r).byteLength,(0,T.log)(this.r,t,r),this.visible&&(this.r.flush(),this.s.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class d extends ${appendLine(t){this.append(t)}}let i=class{constructor(t,r,n,u,l,g){this.i=r,this.j=n,this.k=u,this.l=l,this.m=g,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(s.$bO.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,E.$_m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[r,n]of this.g)n.visible=r===this.h}createOutputChannel(t,r,n){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const u=typeof r=="object"&&r.log,l=(0,P.$jg)(r)?r:void 0;if((0,P.$jg)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let g;const y=this.i.environment.extensionLogLevel?.find(([S])=>O.$zn.equals(n.identifier,S))?.[1];y&&(g=(0,T.$wk)(y));const k=u?this.o(t,g,n):this.n(t,l,n);return k.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),u?this.r(t,g??this.m.getLevel(),k):this.q(t,k)}async n(t,r,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,l=this.k.extUri.joinPath(u,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.a.$register(t,l,r,n.identifier.value);return new $(y,t,g,this.a,n)}async o(t,r,n){const u=await this.p(n),l=t.replace(/[\\/:\*\?"<>\|]/g,""),g=this.k.extUri.joinPath(u,`${l}.log`),y=`${n.identifier.value}.${l}`,k=this.l.createLogger(g,{id:y,name:t,logLevel:r,extensionId:n.identifier.value});return new d(y,t,k,this.a,n)}p(t){let r=this.d.get(t.identifier.value);if(!r){const n=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(n)}catch(u){if((0,v.$vl)(u)!==v.FileSystemProviderErrorCode.FileExists)throw u}return n})())}return r}q(t,r){let n=!1;const u=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return t},append(l){u(),r.then(g=>g.append(l))},appendLine(l){u(),r.then(g=>g.appendLine(l))},clear(){u(),r.then(l=>l.clear())},replace(l){u(),r.then(g=>g.replace(l))},show(l,g){u(),r.then(y=>y.show(l,g))},hide(){u(),r.then(l=>l.hide())},dispose(){n=!0,r.then(l=>l.dispose())}}}r(t,r,n){const u=new m.$Yc,l=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},g=u.add(new o.$qe);function y(k){r=k,g.fire(k)}return n.then(k=>{u.add(k),k.logLevel!==r&&y(k.logLevel),u.add(k.onDidChangeLogLevel(S=>y(S)))}),{...this.q(t,n),get logLevel(){return r},onDidChangeLogLevel:g.event,trace(k,...S){l(),n.then(R=>R.trace(k,...S))},debug(k,...S){l(),n.then(R=>R.debug(k,...S))},info(k,...S){l(),n.then(R=>R.info(k,...S))},warn(k,...S){l(),n.then(R=>R.warn(k,...S))},error(k,...S){l(),n.then(R=>R.error(k,...S))},dispose(){u.dispose()}}}};e.$Usc=i,e.$Usc=i=Ye([We(0,D.$OQ),We(1,c.$5Q),We(2,p.$vrc),We(3,I.$$qc),We(4,T.$gk),We(5,T.$fk)],i),e.$Vsc=(0,h.$Ki)("IExtHostOutputService")}),define(Re[176],Ce([1,0,5,8]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$2m=(0,s.$Ki)("remoteAgentService"),e.$3m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(D){let O=1/0;for(let A=0;A<this.maxSampleCount;A++){const p=await D.getRoundTripTime();if(p===void 0)return;O=Math.min(O,p/2),await(0,h.$Lh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let T;return this.initial.length<this.maxInitialCount?this.initial.push(O):T=this.initial.reduce((A,p)=>A+p,0)/this.initial.length,this.lastMeasurement={initial:T,current:O,average:this.average.reduce((A,p)=>A+p,0)/this.average.length,high:typeof T>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>T*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[332],Ce([1,0,7,72,37,48,47,3,4,176,10,24,8,156]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=void 0,e.$CL=Object.freeze({id:"application",order:100,title:(0,s.localize)(3980,null),type:"object"}),e.$DL=Object.freeze({id:"workbench",order:7,title:(0,s.localize)(3981,null),type:"object"}),e.$EL=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,s.localize)(3982,null),type:"object",order:7}),e.$FL=Object.freeze({id:"problems",title:(0,s.localize)(3983,null),type:"object",order:101}),e.$GL=Object.freeze({id:"window",order:8,title:(0,s.localize)(3984,null),type:"object"}),e.$HL={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new p.$qe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(a){this.migrations.push(...a)}}const o=new v;D.$zo.add(e.$HL.ConfigurationMigration,o);let m=class extends A.$Zc{static{this.ID="workbench.contrib.configurationMigration"}constructor(a,t){super(),this.a=a,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const n of r.added)await this.f(n,o.migrations)})),this.c(o.migrations),this.B(o.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(a){await this.f(void 0,a);for(const t of this.b.getWorkspace().folders)await this.f(t,a)}async f(a,t){await Promise.all([t.map(r=>this.g(r,a?.uri))])}async g(a,t){const r=this.a.inspect(a.key,{resource:t}),n=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE],["workspaceFolder",T.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",T.ConfigurationTarget.USER],["userLocal",T.ConfigurationTarget.USER_LOCAL],["userRemote",T.ConfigurationTarget.USER_REMOTE],["workspace",T.ConfigurationTarget.WORKSPACE]];for(const[u,l]of n){const g=r[u];if(!g)continue;const y=[];if(g.value!==void 0){const k=await this.h(a,u,g.value,t,void 0);for(const S of k??[])y.push([S,[]])}for(const{identifiers:k,value:S}of g.overrides??[])if(S!==void 0){const R=await this.h(a,u,S,t,k);for(const C of R??[])y.push([C,k])}y.length&&await Promise.allSettled(y.map(async([[k,S],R])=>this.a.updateValue(k,S.value,{resource:t,overrideIdentifiers:R},l)))}}async h(a,t,r,n,u){const l=y=>{const S=this.a.inspect(y,{resource:n})[t];if(S)return u?S.overrides?.find(({identifiers:R})=>(0,E.$qo)(R,u))?.value:S.value},g=await a.migrateFn(r,l);return Array.isArray(g)?g:[[a.key,g]]}};e.$IL=m,e.$IL=m=Ye([We(0,T.$ej),We(1,O.$Ti)],m);let $=class extends A.$Zc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(a){super(),this.b=a,this.a=new f.$8h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$l&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;D.$zo.as(h.$Eo.Configuration).registerConfiguration({...e.$EL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,s.localize)(3985,null)},default:[],markdownDescription:(0,s.localize)(3986,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,s.localize)(3987,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$JL=$,e.$JL=$=Ye([We(0,c.$2m)],$),e.$KL="window.newWindowProfile";let d=class extends A.$Zc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(a,t){super(),this.c=a,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(r=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(r=>{r.source!==T.ConfigurationTarget.DEFAULT&&r.affectsConfiguration(e.$KL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const a=D.$zo.as(h.$Eo.Configuration),t={...e.$GL,properties:{[e.$KL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(r=>r.name),null],enumItemLabels:[...this.c.profiles.map(r=>""),(0,s.localize)(3988,null)],description:(0,s.localize)(3989,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?a.updateConfigurations({add:[t],remove:[this.a]}):a.registerConfiguration(t),this.a=t}h(){const a=this.f.getValue(e.$KL);this.b=a?this.c.profiles.find(t=>t.name===a):void 0}j(){const a=this.f.getValue(e.$KL);if(!a)return;const t=this.b?this.c.profiles.find(r=>r.id===this.b.id):void 0;a!==t?.name&&this.f.updateValue(e.$KL,t?.name)}};e.$LL=d,e.$LL=d=Ye([We(0,P.$Rl),We(1,T.$ej)],d)}),define(Re[333],Ce([1,0,39,14,16,22,7,332,72,5,37]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$NL=e.$ML=void 0,e.$OL=o,e.$PL=m,s=Ue(s),e.$ML=(0,c.$Ki)("editorResolverService"),e.$NL="workbench.editorAssociations";const E=I.$zo.as(p.$Eo.Configuration),f={...A.$DL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,T.localize)(12180,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(f);var P;(function($){$.builtin="builtin",$.option="option",$.exclusive="exclusive",$.default="default"})(P||(e.RegisteredEditorPriority=P={}));var v;(function($){$[$.ABORT=1]="ABORT",$[$.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function o($){switch($){case P.exclusive:return 5;case P.default:return 4;case P.builtin:return 3;case P.option:default:return 1}}function m($,d){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(d.scheme))return!1;const t=typeof $=="string"&&$.indexOf(D.$lc.sep)>=0?`${d.scheme}:${d.path}`:(0,O.$ih)(d);return s.$Ek(typeof $=="string"?$.toLowerCase():$,t.toLowerCase())}}),define(Re[334],Ce([1,0,33,14,16,10,22,2,5,250,48,164,176]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=e.$PN=void 0,e.$PN=(0,p.$Ki)("pathService");let v=P=class{constructor(m,$,d,i){this.d=m,this.e=$,this.f=d,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??m})()}hasValidBasename(m,$,d){return typeof $=="string"||typeof $>"u"?this.a.then(i=>this.h(m,i,$)):this.h(m,$,d)}h(m,$,d){return m.scheme===h.Schemas.file||m.scheme===h.Schemas.vscodeRemote?(0,s.$Hg)(d??(0,T.$ih)(m),$===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return P.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,$){if(m.remoteAuthority)return h.Schemas.vscodeRemote;const d=(0,c.$MN)($.getWorkspace());if(d)return d;const i=$.getWorkspace().folders[0];if(i)return i.uri.scheme;const a=$.getWorkspace().configuration;return a?a.scheme:h.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===O.OperatingSystem.Windows?D.$kc:D.$lc)}async fileURI(m){let $="";if(await this.a===O.OperatingSystem.Windows&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?($=m.substring(2),m="/"):($=m.substring(2,i),m=m.substring(i)||"/")}return A.URI.from({scheme:h.Schemas.file,authority:$,path:m,query:"",fragment:""})}};e.$QN=v,e.$QN=v=P=Ye([We(1,f.$2m),We(2,E.$yN),We(3,I.$Ti)],v)}),define(Re[335],Ce([1,0,7,60,4,61,3,2,47,220,11,73,157,93,48,164,25,20,17,24,36]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=e.$IN=e.OnPortForward=e.$DN=e.$CN=e.TunnelSource=e.TunnelCloseReason=e.$AN=e.$zN=void 0,e.$BN=l,e.$EN=k,e.$FN=S,e.$GN=R,e.$HN=w,s=Ue(s);const t=10*1e3,r="remote.tunnels.toRestore",n="remote.tunnels.toRestoreExpiration",u=1e3*60*60*24*14;e.$zN="onTunnel",e.$AN=new a.$2j("forwardedPortsViewEnabled",!1,s.localize(12563,null));function l(L){const M=L.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(M)return{host:M[1]?.substring(0,M[1].length-1)||"localhost",port:Number(M[2])}}var g;(function(L){L.Other="Other",L.User="User",L.AutoForwardEnd="AutoForwardEnd"})(g||(e.TunnelCloseReason=g={}));var y;(function(L){L[L.User=0]="User",L[L.Auto=1]="Auto",L[L.Extension=2]="Extension"})(y||(e.TunnelSource=y={})),e.$CN={source:y.User,description:s.localize(12564,null)},e.$DN={source:y.Auto,description:s.localize(12565,null)};function k(L,M,z){const V=L.get(R(M,z));if(V)return V;if((0,P.$Vw)(M))for(const F of P.$Uw){const j=R(F,z);if(L.has(j))return L.get(j)}else if((0,P.$Xw)(M))for(const F of P.$Ww){const j=R(F,z);if(L.has(j))return L.get(j)}}function S(L,M,z){const V=k(L,M,z);if(V)return V;const F=(0,P.$Xw)(M)?"localhost":(0,P.$Vw)(M)?"0.0.0.0":void 0;if(F)return k(L,F,z)}function R(L,M){return L+":"+M}var C;(function(L){L.Notify="notify",L.OpenBrowser="openBrowser",L.OpenBrowserOnce="openBrowserOnce",L.OpenPreview="openPreview",L.Silent="silent",L.Ignore="ignore"})(C||(e.OnPortForward=C={}));function w(L){return L&&"host"in L&&typeof L.host=="string"&&"port"in L&&typeof L.port=="number"&&(!("detail"in L)||typeof L.detail=="string")&&(!("pid"in L)||typeof L.pid=="string")}class b extends T.$Zc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(M){super(),this.r=M,this.j=[],this.n=new D.$qe,this.onDidChangeAttributes=this.n.event,this.B(M.onDidChangeConfiguration(z=>{(z.affectsConfiguration(b.c)||z.affectsConfiguration(b.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(M,z,V){let F=this.w(M,z,V,this.j,0);const j={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const W=this.j[F];W.key===M?(j.onAutoForward=W.onAutoForward??j.onAutoForward,j.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:j.elevateIfNeeded,j.label=W.label??j.label,j.requireLocalPort=W.requireLocalPort,j.protocol=W.protocol):(j.onAutoForward=j.onAutoForward??W.onAutoForward,j.elevateIfNeeded=j.elevateIfNeeded!==void 0?j.elevateIfNeeded:W.elevateIfNeeded,j.label=j.label??W.label,j.requireLocalPort=j.requireLocalPort!==void 0?j.requireLocalPort:void 0,j.protocol=j.protocol??W.protocol),F=this.w(M,z,V,this.j,F+1)}return j.onAutoForward!==void 0||j.elevateIfNeeded!==void 0||j.label!==void 0||j.requireLocalPort!==void 0||j.protocol!==void 0?j:this.C()}t(M){return M.start!==void 0&&M.end!==void 0}u(M){return M.host!==void 0&&M.port!==void 0&&(0,d.$jg)(M.host)&&(0,d.$ng)(M.port)}w(M,z,V,F,j){if(j>=F.length)return-1;const W=!(0,P.$Vw)(z)&&!(0,P.$Xw)(z),B=F.slice(j).findIndex(U=>(0,d.$ng)(U.key)?W?!1:U.key===M:this.t(U.key)?W?!1:M>=U.key.start&&M<=U.key.end:this.u(U.key)?M===U.key.port&&z===U.key.host:V?U.key.test(V):!1);return B>=0?B+j:-1}y(){const M=this.r.getValue(b.c);if(!M||!(0,d.$lg)(M))return[];const z=[];for(const F in M){if(F===void 0)continue;const j=M[F];let W;if(Number(F))W=Number(F);else if((0,d.$jg)(F))if(b.g.test(F)){const J=F.match(b.g);W={start:Number(J[1]),end:Number(J[2])}}else if(b.h.test(F)){const J=F.match(b.h);W={host:J[1],port:Number(J[2])}}else{let J;try{J=RegExp(F)}catch{}J&&(W=J)}W&&z.push({key:W,elevateIfNeeded:j.elevateIfNeeded,onAutoForward:j.onAutoForward,label:j.label,requireLocalPort:j.requireLocalPort,protocol:j.protocol})}const V=this.r.getValue(b.f);return V&&(this.m={elevateIfNeeded:V.elevateIfNeeded,label:V.label,onAutoForward:V.onAutoForward,requireLocalPort:V.requireLocalPort,protocol:V.protocol}),this.z(z)}z(M){function z(V,F){return(0,d.$ng)(V.key)?V.key:F.t(V.key)?V.key.start:F.u(V.key)?V.key.port:Number.MAX_VALUE}return M.sort((V,F)=>z(V,this)-z(F,this))}C(){return this.m}static providedActionToAction(M){switch(M){case P.ProvidedOnAutoForward.Notify:return C.Notify;case P.ProvidedOnAutoForward.OpenBrowser:return C.OpenBrowser;case P.ProvidedOnAutoForward.OpenBrowserOnce:return C.OpenBrowserOnce;case P.ProvidedOnAutoForward.OpenPreview:return C.OpenPreview;case P.ProvidedOnAutoForward.Silent:return C.Silent;case P.ProvidedOnAutoForward.Ignore:return C.Ignore;default:return}}async addAttributes(M,z,V){const j=this.r.inspect(b.c).userRemoteValue;let W;!j||!(0,d.$lg)(j)?W={}:W=(0,i.$mo)(j),W[`${M}`]||(W[`${M}`]={});for(const J in z)W[`${M}`][J]=z[J];return this.r.updateValue(b.c,W,V)}}e.$IN=b;let N=class extends T.$Zc{constructor(M,z,V,F,j,W,J,B,U,_){super(),this.H=M,this.I=z,this.J=V,this.L=F,this.M=j,this.N=W,this.O=J,this.P=B,this.Q=U,this.R=_,this.c=new Map,this.g=new D.$qe,this.onForwardPort=this.g.event,this.h=new D.$qe,this.onClosePort=this.h.event,this.j=new D.$qe,this.onPortName=this.j.event,this.n=new D.$qe,this.onCandidatesChanged=this.n.event,this.t=new D.$qe,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new D.$qe,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new b(V),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async x=>{const oe=await this.getAttributes(x.map(te=>({port:te.tunnelRemotePort,host:te.tunnelRemoteHost})));for(const te of x)if(te.localAddress){const me=R(te.tunnelRemoteHost,te.tunnelRemotePort),ce=S(this.m??new Map,te.tunnelRemoteHost,te.tunnelRemotePort);this.forwarded.set(me,{remotePort:te.tunnelRemotePort,remoteHost:te.tunnelRemoteHost,localAddress:te.localAddress,protocol:oe?.get(te.tunnelRemotePort)?.protocol??P.TunnelProtocol.Http,localUri:await this.X(te.localAddress,oe?.get(te.tunnelRemotePort)),localPort:te.tunnelLocalPort,name:oe?.get(te.tunnelRemotePort)?.label,runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,privacy:te.privacy,source:e.$CN}),this.f.set(me,te)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async x=>{const oe=R(x.tunnelRemoteHost,x.tunnelRemotePort);if(!S(this.forwarded,x.tunnelRemoteHost,x.tunnelRemotePort)&&!S(this.detected,x.tunnelRemoteHost,x.tunnelRemotePort)&&!S(this.c,x.tunnelRemoteHost,x.tunnelRemotePort)&&x.localAddress){const te=S(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort),me=(await this.getAttributes([{port:x.tunnelRemotePort,host:x.tunnelRemoteHost}]))?.get(x.tunnelRemotePort);this.forwarded.set(oe,{remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localAddress:x.localAddress,protocol:me?.protocol??P.TunnelProtocol.Http,localUri:await this.X(x.localAddress,me),localPort:x.tunnelLocalPort,name:me?.label,closeable:!0,runningProcess:te?.detail,hasRunningProcess:!!te,pid:te?.pid,privacy:x.privacy,source:e.$CN})}await this.cb(),this.f.set(oe,x),this.g.fire(this.forwarded.get(oe))})),this.B(this.H.onTunnelClosed(x=>this.W(x,g.Other))),this.U()}S(){return this.Q.extensions.find(M=>M.activationEvents?.includes(e.$zN))?(this.R.createKey(e.$AN.key,!0),!0):!1}U(){if(this.S())return;const M=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&M.dispose()}))}async W(M,z){const V=R(M.host,M.port);this.forwarded.has(V)&&(this.forwarded.delete(V),await this.cb(),this.h.fire(M))}X(M,z){if(M.startsWith("http"))return A.URI.parse(M);const V=z?.protocol??"http";return A.URI.parse(`${V}://${M}`)}async Y(M){const z=this.N.getWorkspace(),V=z.configuration?(0,O.$yj)(z.configuration.path):z.folders.length>0?(0,O.$yj)(z.folders[0].uri.path):void 0;if(V===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${M}.${this.L.remoteAuthority}.${V}`}async Z(){return this.Y(r)}async $(){return this.Y(n)}async ab(){const M=this.I.get(r,f.StorageScope.WORKSPACE);if(M)return this.I.remove(r,f.StorageScope.WORKSPACE),await this.cb(),M;const z=await this.Z();if(z)return this.I.get(z,f.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const M=await this.s;if(M&&M!==this.y){const z=JSON.parse(M)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${z.map(V=>V.remotePort).join(", ")}`);for(const V of z){const F=S(this.detected,V.remoteHost,V.remotePort);V.source.source!==y.Extension&&!F||V.source.source===y.Extension&&F?await this.fb({remote:{host:V.remoteHost,port:V.remotePort},local:V.localPort,name:V.name,elevateIfNeeded:!0,source:V.source}):V.source.source===y.Extension&&!F&&this.D.set(R(V.remoteHost,V.remotePort),V)}}}if(this.z=!0,this.C.fire(),!this.w){const M=await this.Z();this.w=this.B(new T.$Yc),this.w.add(this.I.onDidChangeValue(f.StorageScope.PROFILE,void 0,this.w)(async z=>{z.key===M&&(this.s=Promise.resolve(this.I.get(M,f.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const M=this.I.keys(f.StorageScope.PROFILE,f.StorageTarget.USER).filter(z=>z.startsWith(n));for(const z of M){const V=this.I.getNumber(z,f.StorageScope.PROFILE);if(V&&V<Date.now()){this.s=Promise.resolve(void 0);const F=z.replace(n,r);this.I.remove(z,f.StorageScope.PROFILE),this.I.remove(F,f.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const M=Array.from(this.forwarded.values()),z=M.map(W=>({remoteHost:W.remoteHost,remotePort:W.remotePort,localPort:W.localPort,name:W.name,localAddress:W.localAddress,localUri:W.localUri,protocol:W.protocol,source:W.source}));let V;M.length>0&&(V=JSON.stringify(z));const F=await this.Z(),j=await this.$();!V&&F&&j?(this.I.remove(F,f.StorageScope.PROFILE),this.I.remove(j,f.StorageScope.PROFILE)):V!==this.y&&F&&j&&(this.I.store(F,V,f.StorageScope.PROFILE,f.StorageTarget.USER),this.I.store(j,Date.now()+u,f.StorageScope.PROFILE,f.StorageTarget.USER)),this.y=V}}async eb(M,z,V){if(!M.tunnelLocalPort||!V?.requireLocalPort||M.tunnelLocalPort===z)return;const F=new Date;if(this.db.getTime()+t>F.getTime())return;this.db=F;const j=s.localize(12566,null,z,M.tunnelRemotePort,M.tunnelLocalPort);return this.P.info(j)}async forward(M,z){return!this.z&&this.L.remoteAuthority&&await D.Event.toPromise(this.C.event),this.fb(M,z)}async fb(M,z){await this.Q.activateByEvent(e.$zN);const V=S(this.forwarded,M.remote.host,M.remote.port);z=z??(z!==null?(await this.getAttributes([M.remote]))?.get(M.remote.port):void 0);const F=M.local!==void 0?M.local:M.remote.port;let j;if(V)return this.hb(V,M,z);{const W=this.L.remoteAuthority,J=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,B=R(M.remote.host,M.remote.port);this.c.set(B,!0),M=this.gb(B,M);const U=await this.H.openTunnel(J,M.remote.host,M.remote.port,void 0,F,M.elevateIfNeeded?M.elevateIfNeeded:z?.elevateIfNeeded,M.privacy,z?.protocol);if(typeof U=="string")j=U;else if(U&&U.localAddress){const _=S(this.m??new Map,M.remote.host,M.remote.port),x=U.protocol?U.protocol===P.TunnelProtocol.Https?P.TunnelProtocol.Https:P.TunnelProtocol.Http:z?.protocol??P.TunnelProtocol.Http,oe={remoteHost:U.tunnelRemoteHost,remotePort:U.tunnelRemotePort,localPort:U.tunnelLocalPort,name:z?.label??M.name,closeable:!0,localAddress:U.localAddress,protocol:x,localUri:await this.X(U.localAddress,z),runningProcess:_?.detail,hasRunningProcess:!!_,pid:_?.pid,source:M.source??e.$CN,privacy:U.privacy};return this.forwarded.set(B,oe),this.f.set(B,U),this.c.delete(B),await this.cb(),await this.eb(U,F,z),this.g.fire(oe),U}this.c.delete(B)}return j}gb(M,z){const V=this.D.has(M)?this.D:this.F.has(M)?this.F:void 0;if(V){const F=V.get(M);V.delete(M),F&&(z.name=F.name??z.name,z.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??z.local,z.privacy=z.privacy)}return z}async hb(M,z,V){const F=V?.label??z.name;let j;(function(J){J[J.None=0]="None",J[J.Fire=1]="Fire",J[J.Reopen=2]="Reopen"})(j||(j={}));let W=j.None;switch(F!==M.name&&(M.name=F,W=j.Fire),(V?.protocol||M.protocol!==P.TunnelProtocol.Http)&&V?.protocol!==M.protocol&&(z.source=M.source,W=j.Reopen),z.privacy&&M.privacy!==z.privacy&&(W=j.Reopen),W){case j.Fire:{this.g.fire();break}case j.Reopen:await this.close(M.remoteHost,M.remotePort,g.User),await this.fb(z,V)}return S(this.f,z.remote.host,z.remote.port)}async name(M,z,V){const F=S(this.forwarded,M,z),j=R(M,z);if(F){F.name=V,await this.cb(),this.j.fire({host:M,port:z});return}else this.detected.has(j)&&(this.detected.get(j).name=V,this.j.fire({host:M,port:z}))}async close(M,z,V){const F=R(M,z),j=this.forwarded.get(F);return V===g.AutoForwardEnd&&j&&j.source.source===y.Auto&&this.F.set(F,{local:j.localPort,name:j.name,privacy:j.privacy}),await this.H.closeTunnel(M,z),this.W({host:M,port:z},V)}address(M,z){const V=R(M,z);return(this.forwarded.get(V)||this.detected.get(V))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(M){if(M)for(const z of M){const V=S(this.m??new Map,z.remoteAddress.host,z.remoteAddress.port),F=typeof z.localAddress=="string"?z.localAddress:R(z.localAddress.host,z.localAddress.port);this.detected.set(R(z.remoteAddress.host,z.remoteAddress.port),{remoteHost:z.remoteAddress.host,remotePort:z.remoteAddress.port,localAddress:F,protocol:P.TunnelProtocol.Http,localUri:this.X(F),closeable:!1,runningProcess:V?.detail,hasRunningProcess:!!V,pid:V?.pid,privacy:P.TunnelPrivacyId.ConstantPrivate,source:{source:y.Extension,description:s.localize(12567,null)}}),this.H.setEnvironmentTunnel(z.remoteAddress.host,z.remoteAddress.port,F,P.TunnelPrivacyId.ConstantPrivate,P.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(M){this.r=M}async setCandidates(M){let z=M;this.r&&(z=await this.r(M));const V=this.ib(z);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(V.values()).map(F=>F.port).join(", ")}`),this.n.fire(V)}ib(M){const z=this.m??new Map,V=new Map;return this.m=V,M.forEach(F=>{const j=R(F.host,F.port);V.set(j,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),z.has(j)&&z.delete(j);const W=S(this.forwarded,F.host,F.port);W&&(W.runningProcess=F.detail,W.hasRunningProcess=!0,W.pid=F.pid)}),z.forEach((F,j)=>{const W=l(j);if(!W)return;const J=S(this.forwarded,W.host,W.port);J&&(J.runningProcess=void 0,J.hasRunningProcess=!1,J.pid=void 0);const B=S(this.detected,W.host,W.port);B&&(B.runningProcess=void 0,B.hasRunningProcess=!1,B.pid=void 0)}),z}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const M=Array.from(this.forwarded.values()),z=await this.getAttributes(M.map(V=>({port:V.remotePort,host:V.remoteHost})),!1);if(z)for(const V of M){const F=z.get(V.remotePort);(F?.protocol||V.protocol!==P.TunnelProtocol.Http)&&F?.protocol!==V.protocol&&await this.fb({remote:{host:V.remoteHost,port:V.remotePort},local:V.localPort,name:V.name,source:V.source},F),F&&F.label&&F.label!==V.name&&await this.name(V.remoteHost,V.remotePort,F.label)}}async getAttributes(M,z=!0){const V=new Map,F=new Map;M.forEach(U=>{const _=S(this.m??new Map,P.$Uw[0],U.port)??U;if(_){V.set(U.port,_);const x=w(_)?_.pid:void 0;F.has(x)||F.set(x,[]),F.get(x)?.push(U.port)}});const j=new Map;if(M.forEach(U=>{const _=this.configPortsAttributes.getAttributes(U.port,U.host,V.get(U.port)?.detail);_&&j.set(U.port,_)}),this.G.length===0||!z)return j.size>0?j:void 0;const W=await Promise.all(this.G.flatMap(U=>Array.from(F.entries()).map(_=>{const x=_[1],oe=V.get(x[0]);return U.providePortAttributes(x,oe?.pid,oe?.detail,$.CancellationToken.None)}))),J=new Map;if(W.forEach(U=>U.forEach(_=>{_&&J.set(_.port,_)})),!j&&!J)return;const B=new Map;return M.forEach(U=>{const _=j.get(U.port),x=J.get(U.port);B.set(U.port,{elevateIfNeeded:_?.elevateIfNeeded,label:_?.label,onAutoForward:_?.onAutoForward??b.providedActionToAction(x?.autoForwardAction),requireLocalPort:_?.requireLocalPort,protocol:_?.protocol})}),B}addAttributesProvider(M){this.G.push(M)}};e.$JN=N,Ye([(0,h.$di)(1e3)],N.prototype,"cb",null),e.$JN=N=Ye([We(0,P.$Pw),We(1,f.$qq),We(2,p.$ej),We(3,o.$yN),We(4,E.$Wl),We(5,v.$Ti),We(6,I.$fk),We(7,c.$ix),We(8,m.$zH),We(9,a.$3j)],N)}),define(Re[59],Ce([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.ExcludeSettingOptions=e.$qM=e.$pM=e.$oM=e.$nM=void 0;class s{constructor(c,I){this.line=c,this.character=I}isBefore(c){return!1}isBeforeOrEqual(c){return!1}isAfter(c){return!1}isAfterOrEqual(c){return!1}isEqual(c){return!1}compareTo(c){return 0}translate(c,I){return new s(0,0)}with(c){return new s(0,0)}}e.$nM=s;class h{constructor(c,I,E,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new s(c,I),this.end=new s(E,f)}contains(c){return!1}isEqual(c){return!1}intersection(c){}union(c){return new h(0,0,0,0)}with(c){return new h(0,0,0,0)}}e.$oM=h;class D{constructor(c,I,E){this.uri=c,this.ranges=I,this.previewText=E}}e.$pM=D;class O{constructor(c,I,E){this.uri=c,this.text=I,this.lineNumber=E}}e.$qM=O;var T;(function(p){p[p.None=1]="None",p[p.FilesExclude=2]="FilesExclude",p[p.SearchAndFilesExclude=3]="SearchAndFilesExclude"})(T||(e.ExcludeSettingOptions=T={}));var A;(function(p){p[p.Information=1]="Information",p[p.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(Re[32],Ce([1,0,18,39,24,33,13,5,16,12,59,8]),function(ge,e,s,h,D,O,T,A,p,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$QM=e.$OM=e.$HM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$EM=e.$DM=e.$CM=e.$BM=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.TextSearchCompleteMessageType=void 0,e.$yM=$,e.$zM=d,e.$AM=i,e.$FM=k,e.$GM=S,e.$IM=w,e.$JM=b,e.$KM=N,e.$LM=L,e.$MM=M,e.$NM=z,e.$PM=F,e.$RM=J,e.$SM=B,e.$TM=_,h=Ue(h),D=Ue(D),O=Ue(O),p=Ue(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$rM="workbench.view.search",e.$sM="workbench.panel.search",e.$tM="workbench.view.search",e.$uM="search-result",e.$vM="search.exclude",e.$wM=2e4;const f="\u27EA ",P=" characters skipped \u27EB",v=(f.length+P.length+5)*2;e.$xM=(0,A.$Ki)("searchService");var o;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(o||(e.SearchProviderType=o={}));var m;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(m||(e.QueryType=m={}));function $(x){return!!x.rangeLocations&&!!x.previewText}function d(x){return!!x.resource}function i(x){return!!x.message}var a;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class t{constructor(oe){this.resource=oe,this.results=[]}}e.$BM=t;class r{constructor(oe,te,me,ce){this.rangeLocations=[],this.webviewIndex=ce;const Y=Array.isArray(te)?te:[te];if(me&&me.matchLines===1&&n(Y)){oe=(0,T.$cg)(oe,me.matchLines);let q="",se=0,be=0;const ae=Math.floor(me.charsPerLine/5);for(const we of Y){const $e=Math.max(we.startColumn-ae,0),pe=we.startColumn+me.charsPerLine;if($e>be+ae+v){const Oe=f+($e-be)+P;q+=Oe+oe.slice($e,pe),se+=$e-(be+Oe.length)}else q+=oe.slice(be,pe);be=pe,this.rangeLocations.push({source:we,preview:new l(0,we.startColumn-se,we.endColumn-se)})}this.previewText=q}else{const q=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber,se=(0,s.$5b)(te,be=>({preview:new u(be.startLineNumber-q,be.startColumn,be.endLineNumber-q,be.endColumn),source:be}));this.rangeLocations=Array.isArray(se)?se:[se],this.previewText=oe}}}e.$CM=r;function n(x){const oe=x[0].startLineNumber;for(const te of x)if(te.startLineNumber!==oe||te.endLineNumber!==oe)return!1;return!0}class u{constructor(oe,te,me,ce){this.startLineNumber=oe,this.startColumn=te,this.endLineNumber=me,this.endColumn=ce}}e.$DM=u;class l extends u{constructor(oe,te,me){super(oe,te,oe,me)}}e.$EM=l;var g;(function(x){x.List="list",x.Tree="tree"})(g||(e.ViewMode=g={}));var y;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function k(x,oe=!0){const te=x&&x.files&&x.files.exclude,me=oe&&x&&x.search&&x.search.exclude;if(!te&&!me)return;if(!te||!me)return te||me||void 0;let ce=Object.create(null);return ce=D.$po(ce,D.$mo(te)),ce=D.$po(ce,D.$mo(me),!0),ce}function S(x,oe){return x.excludePattern&&h.$Ek(x.excludePattern,oe)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&h.$Ek(x.includePattern,oe)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(te=>{const me=te.folder.fsPath;if(O.$Jg(oe,me)){const ce=p.$qc(me,oe);return!te.includePattern||!!h.$Ek(te.includePattern,ce)}else return!1}):!1:!0}var R;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(R||(e.SearchErrorCode=R={}));class C extends Error{constructor(oe,te){super(oe),this.code=te}}e.$HM=C;function w(x){const oe=x.message;if((0,c.$8)(x))return new C(oe,R.canceled);try{const te=JSON.parse(oe);return new C(te.message,te.code)}catch{return new C(oe,R.other)}}function b(x){const oe={message:x.message,code:x.code};return new Error(JSON.stringify(oe))}function N(x){return x.type==="error"?!0:x.type==="success"}function L(x){return x.type==="success"}function M(x){return!!x.path}function z(x,oe,te=!0){const me=x.searchPath?x.searchPath:x.relativePath;return te?(0,T.$_f)(me,oe):h.$Ek(oe,me)}class V{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$OM=V;function F(x,oe){const te={...x||{},...oe||{}};return Object.keys(te).filter(me=>{const ce=te[me];return typeof ce=="boolean"&&ce})}class j{constructor(oe,te){this.c=null,this.a=te.excludePattern?.map(ce=>({...oe.excludePattern||{},...ce.pattern||{}}))??[],this.a.length===0&&(this.a=[oe.excludePattern||{}]),this.b=this.a.map(ce=>h.$Fk(ce));let me=oe.includePattern;te.includePattern&&(me?me={...me,...te.includePattern}:me=te.includePattern),me&&(this.c=h.$Fk(me))}d(oe,te,me){let ce=null;for(const Y of this.b){const q=Y(oe,te,me);if(typeof q=="string"){ce=q;break}}return ce}matchesExcludesSync(oe,te,me){return!!(this.b&&this.d(oe,te,me))}includedInQuerySync(oe,te,me){return!(this.b&&this.d(oe,te,me)||this.c&&!this.c(oe,te,me))}includedInQuery(oe,te,me){const ce=()=>this.c?!!this.c(oe,te,me):!0;return Promise.all(this.b.map(Y=>{const q=Y(oe,te,me);return(0,E.$wh)(q)?q.then(se=>se?!1:ce()):ce()})).then(Y=>Y.some(q=>!!q))}hasSiblingExcludeClauses(){return this.a.reduce((oe,te)=>W(te)||oe,!1)}}e.$QM=j;function W(x){for(const oe in x)if(typeof x[oe]!="boolean")return!0;return!1}function J(x){if(!x)return;let oe;return te=>(oe||(oe=(x()||Promise.resolve([])).then(me=>me?U(me):{})),oe.then(me=>!!me[te]))}function B(x){if(!x)return;let oe;return te=>{if(!oe){const me=x();oe=me?U(me):{}}return!!oe[te]}}function U(x){const oe={};for(const te of x)oe[te]=!0;return oe}function _(x){return x.flatMap(oe=>oe.patterns.map(te=>oe.baseUri?{baseUri:oe.baseUri,pattern:te}:te))}e.$UM={matchLines:100,charsPerLine:1e4}}),define(Re[42],Ce([1,0,18,8,20,4,3,62,14,136,22,13,2,7,27,5,11,234,48,64,29,19,15,9,74,32,6,38,59]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t,r,n,u,l,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qrc=e.$prc=void 0;function S(V,F,j){return new I.$ah(W=>b(W,j)).isEqual(V,F)}function R(V,F,j){return S(V.uri,F.uri,j)?0:(0,E.$Df)(V.uri.toString(),F.uri.toString())}function C(V,F,j){return V.index!==F.index?V.index<F.index?-1:1:S(V.uri,F.uri,j)?(0,E.$Df)(V.name,F.name):(0,E.$Df)(V.uri.toString(),F.uri.toString())}function w(V,F,j,W){const J=V.slice(0).sort((U,_)=>j(U,_,W)),B=F.slice(0).sort((U,_)=>j(U,_,W));return(0,s.$Ib)(J,B,(U,_)=>j(U,_,W))}function b(V,F){const j=F.getCapabilities(V.scheme);return!(j&&j&v.FileSystemProviderCapabilities.PathCaseSensitive)}class N extends d.$4i{static toExtHostWorkspace(F,j,W,J){if(!F)return{workspace:null,added:[],removed:[]};const{id:B,name:U,folders:_,configuration:x,transient:oe,isUntitled:te}=F,me=[],ce=j;j?_.forEach((be,ae)=>{const we=f.URI.revive(be.uri),$e=N.o(W||j,we,J);$e?($e.name=be.name,$e.index=be.index,me.push($e)):me.push({uri:we,name:be.name,index:ae})}):me.push(..._.map(({uri:be,name:ae,index:we})=>({uri:f.URI.revive(be),name:ae,index:we}))),me.sort((be,ae)=>be.index<ae.index?-1:1);const Y=new N(B,U,me,!!oe,x?f.URI.revive(x):null,!!te,be=>b(be,J)),{added:q,removed:se}=w(ce?ce.workspaceFolders:[],Y.workspaceFolders,R,J);return{workspace:Y,added:q,removed:se}}static o(F,j,W){for(let J=0;J<F.folders.length;J++){const B=F.workspaceFolders[J];if(S(B.uri,j,W))return B}}constructor(F,j,W,J,B,U,_){super(F,W.map(x=>new d.$5i(x)),J,B,_),this.t=j,this.u=U,this.q=[],this.s=A.$Qi.forUris(_,()=>!0),W.forEach(x=>{this.q.push(x),this.s.set(x.uri,x)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,j){return j&&this.s.get(F)&&(F=(0,I.$kh)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let L=class{constructor(F,j,W,J,B){this.c=new O.$qe,this.onDidChangeWorkspace=this.c.event,this.g=new O.$qe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.B=0,this.C=new O.$se,this.D=new Map,this.h=J,this.s=W,this.t=B,this.j=new c.$Sm,this.k=new h.$Jh,this.o=F.getProxy(g.$bO.MainThreadWorkspace),this.q=F.getProxy(g.$bO.MainThreadMessageService);const U=j.workspace;this.l=U?new N(U.id,U.name,[],!!U.transient,U.configuration?f.URI.revive(U.configuration):null,!!U.isUntitled,_=>b(_,W)):void 0}$initializeWorkspace(F,j){this.v=j,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?f.URI.from({scheme:p.Schemas.untitled,path:(0,I.$ih)((0,I.$kh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,j,W,...J){const B=[];if(Array.isArray(J)&&J.forEach(te=>{f.URI.isUri(te.uri)&&!B.some(me=>S(me.uri,te.uri,this.s))&&B.push({uri:te.uri,name:te.name||(0,I.$hh)(te.uri)})}),this.n||[j,W].some(te=>typeof te!="number"||te<0)||W===0&&B.length===0)return!1;const U=this.x?this.x.workspaceFolders:[];if(j+W>U.length)return!1;const _=U.slice(0);_.splice(j,W,...B.map(te=>({uri:te.uri,name:te.name||(0,I.$hh)(te.uri),index:void 0})));for(let te=0;te<_.length;te++){const me=_[te];if(_.some((ce,Y)=>Y!==te&&S(me.uri,ce.uri,this.s)))return!1}_.forEach((te,me)=>te.index=me);const{added:x,removed:oe}=w(U,_,C,this.s);if(x.length===0&&oe.length===0)return!1;if(this.o){const te=F.displayName||F.name;this.o.$updateWorkspaceFolders(te,j,W,B).then(void 0,me=>{this.n=void 0;const ce={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage($.Severity.Error,(0,P.localize)(2719,null,te,me.toString()),ce,[])})}return this.y(_),!0}getWorkspaceFolder(F,j){if(this.x)return this.x.getWorkspaceFolder(F,j)}async getWorkspaceFolder2(F,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,j)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,j){let W,J="";if(typeof F=="string"?(W=f.URI.file(F),J=F):typeof F<"u"&&(W=F,J=F.fsPath),!W)return J;const B=this.getWorkspaceFolder(W,!0);if(!B)return J;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let U=(0,I.$nh)(B.uri,W);return j&&B.name&&(U=`${B.name}/${U}`),U}y(F){this.x&&(this.n=N.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:j,added:W,removed:J}=N.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:W,removed:J}))}findFiles(F,j,W,J,B=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${J.value}, entryPoint: findFiles`);let U="",_=!0;return j===null?_=!1:j!==void 0&&(typeof j=="string"?U=j:U=j.pattern),this.z(F,void 0,{exclude:[U],maxResults:W,useExcludeSettings:_?k.ExcludeSettingOptions.FilesExclude:k.ExcludeSettingOptions.None,useIgnoreFiles:{local:!1}},B)}findFiles2(F,j={},W,J=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${W.value}, entryPoint: findFiles2`);const B=j.useDefaultExcludes??!0,U=j.useDefaultSearchExcludes??!0,_=B?U?k.ExcludeSettingOptions.SearchAndFilesExclude:k.ExcludeSettingOptions.FilesExclude:k.ExcludeSettingOptions.None,x={exclude:j.exclude?[j.exclude]:void 0,useIgnoreFiles:{local:j.useIgnoreFiles,global:j.useGlobalIgnoreFiles,parent:j.useParentIgnoreFiles},useExcludeSettings:_,followSymlinks:j.followSymlinks,maxResults:j.maxResults};return this.z(void 0,F!==void 0?[F]:[],x,J)}findFiles2New(F,j={},W,J=D.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2New: fileSearch, extension: ${W.value}, entryPoint: findFiles2New`),this.z(void 0,F,j,J)}async z(F,j,W,J=D.CancellationToken.None){if(J&&J.isCancellationRequested)return Promise.resolve([]);const U=(F!==void 0?[F]:j)?.map(_=>{const x=z(W.exclude),oe={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles?.local=="boolean"?!W.useIgnoreFiles.local:void 0,disregardGlobalIgnoreFiles:typeof W.useIgnoreFiles?.global=="boolean"?!W.useIgnoreFiles.global:void 0,disregardParentIgnoreFiles:typeof W.useIgnoreFiles?.parent=="boolean"?!W.useIgnoreFiles.parent:void 0,disregardExcludeSettings:W.useExcludeSettings!==void 0&&W.useExcludeSettings===k.ExcludeSettingOptions.None,disregardSearchExcludeSettings:W.useExcludeSettings!==void 0&&W.useExcludeSettings!==k.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:W.maxResults,excludePattern:x.length>0?x:void 0,_reason:"startFileSearch",shouldGlobSearch:F?void 0:!0},te=M(r.GlobPattern.from(_)),me=te?.folder;return F?oe.includePattern=te?.pattern:oe.filePattern=te?.pattern,{folder:me,options:oe}})??[];return this.A(U,J)}async A(F,j){return(await Promise.all(F?.map(J=>this.o.$startFileSearch(J.folder??null,J.options,j).then(B=>Array.isArray(B)?B.map(U=>f.URI.revive(U)):[]))??[])).flat()}findTextInFilesNew(F,j,W,J){this.h.trace(`extHostWorkspace#findTextInFilesNew: textSearch, extension: ${j.value}, entryPoint: findTextInFilesNew`);const B=te=>{if(!W)return{folder:void 0,options:{}};const me=te?M(r.GlobPattern.from(te)):void 0,ce=z(W.exclude);return{options:{ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useIgnoreFiles?.global=="boolean"?!W.useIgnoreFiles?.global:void 0,disregardParentIgnoreFiles:typeof W.useIgnoreFiles?.parent=="boolean"?!W.useIgnoreFiles?.parent:void 0,disregardExcludeSettings:W.useExcludeSettings!==void 0&&W.useExcludeSettings===k.ExcludeSettingOptions.None,disregardSearchExcludeSettings:W.useExcludeSettings!==void 0&&W.useExcludeSettings!==k.ExcludeSettingOptions.SearchAndFilesExclude,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:W.previewOptions?{matchLines:W.previewOptions?.numMatchLines??100,charsPerLine:W.previewOptions?.charsPerLine??1e4}:void 0,surroundingContext:W.surroundingContext,includePattern:me?.pattern,excludePattern:ce},folder:me?.folder}},_=(W?.include?.map(te=>B(te))??[B(void 0)]).filter(te=>!!te),x=Promise.resolve(void 0);return{results:new h.$$h(async te=>{const me=(ce,Y)=>((0,l.$yM)(ce)?te.emitOne(new k.$pM(Y,ce.rangeLocations.map(q=>({previewRange:new n.$fO(q.preview.startLineNumber,q.preview.startColumn,q.preview.endLineNumber,q.preview.endColumn),sourceRange:new n.$fO(q.source.startLineNumber,q.source.startColumn,q.source.endLineNumber,q.source.endColumn)})),ce.previewText)):te.emitOne(new k.$qM(Y,ce.text,ce.lineNumber)),ce);await x.then(ce=>this.findTextInFilesBase(F,_,me,J))}),complete:x.then(te=>({limitHit:te?.limitHit??!1}))}}async findTextInFilesBase(F,j,W,J=D.CancellationToken.None){const B=this.j.getNext();let U=!1;if(J.onCancellationRequested(_=>{U=!0}),this.u[B]=_=>{if(U)return;const x=f.URI.revive(_.resource);_.results.forEach(oe=>{const te=(0,y.$hi)(oe);W(te,x)})},J.isCancellationRequested)return{};try{const _=await Promise.all(j?.map(x=>this.o.$startTextSearch(F,x.folder??null,x.options,B,J)||{})??[]);return delete this.u[B],_.reduce((x,oe)=>({limitHit:x?.limitHit||(oe?.limitHit??!1),message:[x?.message??[],oe?.message??[]].flat()}),{})??{limitHit:!1}}catch(_){throw delete this.u[B],_}}async findTextInFiles(F,j,W,J,B=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${J.value}, entryPoint: findTextInFiles`);const U=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,_=M(r.GlobPattern.from(j.include)),x=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,oe={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof j.useSearchExclude=="boolean"?!j.useSearchExclude:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:U,surroundingContext:j.afterContext,includePattern:_?.pattern,excludePattern:x?[{pattern:x}]:void 0},te=(me,ce)=>{(0,l.$yM)(me)?W({uri:ce,preview:{text:me.previewText,matches:(0,s.$5b)(me.rangeLocations,Y=>new n.$fO(Y.preview.startLineNumber,Y.preview.startColumn,Y.preview.endLineNumber,Y.preview.endColumn))},ranges:(0,s.$5b)(me.rangeLocations,Y=>new n.$fO(Y.source.startLineNumber,Y.source.startColumn,Y.source.endLineNumber,Y.source.endColumn))}):W({uri:ce,text:me.text,lineNumber:me.lineNumber})};return this.findTextInFilesBase(F,[{options:oe,folder:_?.folder}],te,B)}$handleTextSearchResult(F,j){this.u[j]?.(F)}async save(F){const j=await this.o.$save(F,{saveAs:!1});return f.URI.revive(j)}async saveAs(F){const j=await this.o.$save(F,{saveAs:!0});return f.URI.revive(j)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}lookupAuthorization(F){return this.o.$lookupAuthorization(F)}lookupKerberosAuthorization(F){return this.o.$lookupKerberosAuthorization(F)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,j){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,j);const W=this.t.transformOutgoingScheme(F),J=this.B++;return this.o.$registerEditSessionIdentityProvider(J,W),(0,T.$Xc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(J)})}async $getEditSessionIdentifier(F,j){this.h.info("Getting edit session identifier for workspaceFolder",F);const W=await this.resolveWorkspaceFolder(f.URI.revive(F));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const J=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!J),!J)return;const B=await J.provideEditSessionIdentity(W,j);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(F,j,W,J){this.h.info("Getting edit session identifier for workspaceFolder",F);const B=await this.resolveWorkspaceFolder(f.URI.revive(F));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const U=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!U),!U)return;const _=await U.provideEditSessionIdentityMatch?.(j,W,J);if(this.h.info("Provider returned edit session identifier match result: ",_),!!_)return _}getOnWillCreateEditSessionIdentityEvent(F){return(j,W,J)=>{const B=function(_){j.call(W,_)};return B.extension=F,this.C.event(B,void 0,J)}}async $onWillCreateEditSessionIdentity(F,j,W){const J=await this.resolveWorkspaceFolder(f.URI.revive(F));if(J===void 0)throw new Error("Unable to resolve workspace folder");await this.C.fireAsync({workspaceFolder:J},j,async(B,U)=>{const _=Date.now();await Promise.resolve(B),Date.now()-_>W&&this.h.warn("SLOW edit session create-participant",U.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(F,j){if(this.D.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.D.set(F,j);const W=this.t.transformOutgoingScheme(F),J=this.B++;return this.o.$registerCanonicalUriProvider(J,W),(0,T.$Xc)(()=>{this.D.delete(F),this.o.$unregisterCanonicalUriProvider(J)})}async provideCanonicalUri(F,j,W){const J=this.D.get(F.scheme);if(!J)return;const B=await J.provideCanonicalUri?.(f.URI.revive(F),j,W);if(B)return B}async $provideCanonicalUri(F,j,W){return this.provideCanonicalUri(f.URI.revive(F),{targetScheme:j},W)}};e.$prc=L,e.$prc=L=Ye([We(0,t.$OQ),We(1,a.$5Q),We(2,i.$$qc),We(3,m.$fk),We(4,u.$nrc)],L),e.$qrc=(0,o.$Ki)("IExtHostWorkspace");function M(V){let F,j;if(V)return typeof V=="string"?F=V:(F=V.pattern,j=f.URI.revive(V.baseUri)),{pattern:F,folder:j}}function z(V){return(V?.map(F=>{if(typeof F=="string")return F===""?void 0:{pattern:F,uri:void 0};{const j=M(F);return j?{pattern:j.pattern,uri:j.folder}:void 0}})??[]).filter(F=>!!F)}}),define(Re[43],Ce([1,0,24,4,42,6,9,47,236,72,17,8,5,19,11,2]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$trc=e.$src=e.$rrc=void 0;function m(u,l){if(l){const g=l.split(".");let y=u;for(let k=0;y&&k<g.length;k++)y=y[g[k]];return y}}function $(u){return u instanceof o.URI}function d(u){return u&&u.uri instanceof o.URI&&u.languageId&&typeof u.languageId=="string"}function i(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function a(u){return u&&u.uri instanceof o.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function t(u){if($(u))return{resource:u};if(d(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(i(u))return{overrideIdentifier:u.languageId};if(a(u))return{resource:u.uri};if(u===null)return{resource:null}}let r=class{constructor(l,g,y){this.a=l.getProxy(O.$bO.MainThreadConfiguration),this.c=g,this.b=y,this.d=new E.$Jh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new n(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,g){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(l,g))}};e.$rrc=r,e.$rrc=r=Ye([We(0,P.$OQ),We(1,D.$qrc),We(2,v.$fk)],r);class n{constructor(l,g,y,k){this.a=new h.$qe,this.b=l,this.f=k,this.c=g,this.e=p.$Zo.parse(y,k),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,g){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Zo.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j(g,y))}getConfiguration(l,g,y){const k=t(g)||{},S=this.g(l?m(this.e.getValue(void 0,k,this.c.workspace),l):this.e.getValue(void 0,k,this.c.workspace));l&&this.h(l,k,y?.identifier);function R(w){if(w==null)return null;if(typeof w=="boolean")return w?A.ConfigurationTarget.USER:A.ConfigurationTarget.WORKSPACE;switch(w){case T.ConfigurationTarget.Global:return A.ConfigurationTarget.USER;case T.ConfigurationTarget.Workspace:return A.ConfigurationTarget.WORKSPACE;case T.ConfigurationTarget.WorkspaceFolder:return A.ConfigurationTarget.WORKSPACE_FOLDER}}const C={has(w){return typeof m(S,w)<"u"},get:(w,b)=>{this.h(l?`${l}.${w}`:w,k,y?.identifier);let N=m(S,w);if(typeof N>"u")N=b;else{let L;const M=(z,V)=>{if((0,I.$lg)(z)){let F;const j=()=>{L=L||(0,s.$mo)(S),F=F||m(L,V)};return new Proxy(z,{get:(W,J)=>{if(typeof J=="string"&&J.toLowerCase()==="tojson")return j(),()=>F;if(L)return F=F||m(L,V),F[J];const B=W[J];return typeof J=="string"?M(B,`${V}.${J}`):B},set:(W,J,B)=>(j(),F&&(F[J]=B),!0),deleteProperty:(W,J)=>(j(),F&&delete F[J],!0),defineProperty:(W,J,B)=>(j(),F&&Object.defineProperty(F,J,B),!0)})}return Array.isArray(z)?(0,s.$mo)(z):z};N=M(N,w)}return N},update:(w,b,N,L)=>{w=l?`${l}.${w}`:w;const M=R(N);return b!==void 0?this.b.$updateConfigurationOption(M,w,b,k,L):this.b.$removeConfigurationOption(M,w,k,L)},inspect:w=>{w=l?`${l}.${w}`:w;const b=this.e.inspect(w,k,this.c.workspace);if(b)return{key:w,defaultValue:(0,s.$mo)(b.policy?.value??b.default?.value),globalValue:(0,s.$mo)(b.user?.value??b.application?.value),workspaceValue:(0,s.$mo)(b.workspace?.value),workspaceFolderValue:(0,s.$mo)(b.workspaceFolder?.value),defaultLanguageValue:(0,s.$mo)(b.default?.override),globalLanguageValue:(0,s.$mo)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,s.$mo)(b.workspace?.override),workspaceFolderLanguageValue:(0,s.$mo)(b.workspaceFolder?.override),languageIds:(0,s.$mo)(b.overrideIdentifiers)}}};return typeof S=="object"&&(0,s.$po)(C,S,!1),Object.freeze(C)}g(l){const g=y=>(0,I.$lg)(y)?new Proxy(y,{get:(k,S)=>g(k[S]),set:(k,S,R)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(k,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(k,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:k=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return g(l)}h(l,g,y){const k=c.$Oo.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),S=y?`[${y.value}] `:"";if(c.ConfigurationScope.RESOURCE===k){typeof g?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===k){g?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,g){const y=new p.$2o(l,g,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(k,S)=>y.affectsConfiguration(k,t(S))})}k(l){return l.reduce((g,y)=>(g.set(y[0],y[1]),g),new Map)}}e.$src=n,e.$trc=(0,f.$Ki)("IExtHostConfiguration")}),define(Re[100],Ce([1,0,2,8,4,6,9,42,65,43,20,49,19,29,5,14,10,11,96,275,12,18]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9sc=e.$8sc=e.$7sc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,T=Ue(T),m=Ue(m);var r;(function(M){function z(F){if(F!=null)return F}M.from=z;function V(F){if(F!=null)return F}M.to=V})(r||(r={}));var n;(function(M){function z(F){if(F!=null)return F}M.from=z;function V(F){if(F!=null)return F}M.to=V})(n||(n={}));var u;(function(M){function z(F){if(F!=null)return F}M.from=z;function V(F){if(F!=null)return F}M.to=V})(u||(u={}));var l;(function(M){function z(j){if(j){const W=j;return W&&!!W.process}else return!1}M.is=z;function V(j){if(j==null)return;const W={process:j.process,args:j.args};return j.options&&(W.options=u.from(j.options)),W}M.from=V;function F(j){if(j!=null)return new T.$2O(j.process,j.args,j.options)}M.to=F})(l||(l={}));var g;(function(M){function z(F){if(F!=null)return F}M.from=z;function V(F){if(F!=null)return F}M.to=V})(g||(g={}));var y;(function(M){function z(j){if(j){const W=j;return W&&(!!W.commandLine||!!W.command)}else return!1}M.is=z;function V(j){if(j==null)return;const W={};return j.commandLine!==void 0?W.commandLine=j.commandLine:(W.command=j.command,W.args=j.args),j.options&&(W.options=g.from(j.options)),W}M.from=V;function F(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new T.$3O(j.commandLine,j.options):new T.$3O(j.command,j.args?j.args:[],j.options)}M.to=F})(y||(y={}));var k;(function(M){function z(j){if(j){const W=j;return W&&W.customExecution==="customExecution"}else return!1}M.is=z;function V(j){return{customExecution:"customExecution"}}M.from=V;function F(j,W){return W.get(j)}M.to=F})(k||(e.CustomExecutionDTO=k={}));var S;(function(M){function z(V,F){let j;return V.scope!==void 0&&typeof V.scope!="number"?j=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===T.TaskScope.Workspace&&F&&F.workspaceFile?j=F.workspaceFile:j=i.$iJ),{id:V._id,workspaceFolder:j}}M.from=z})(S||(e.TaskHandleDTO=S={}));var R;(function(M){function z(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}M.from=z})(R||(R={}));var C;(function(M){function z(j,W){if(j==null)return[];const J=[];for(const B of j){const U=V(B,W);U&&J.push(U)}return J}M.fromMany=z;function V(j,W){if(j==null)return;let J;j.execution instanceof T.$2O?J=l.from(j.execution):j.execution instanceof T.$3O?J=y.from(j.execution):j.execution&&j.execution instanceof T.$4O&&(J=k.from(j.execution));const B=r.from(j.definition);let U;return j.scope?typeof j.scope=="number"?U=j.scope:U=j.scope.uri:U=T.TaskScope.Workspace,!B||!U?void 0:{_id:j._id,definition:B,name:j.name,source:{extensionId:W.identifier.value,label:j.source,scope:U},execution:J,isBackground:j.isBackground,group:R.from(j.group),presentationOptions:n.from(j.presentationOptions),problemMatchers:(0,t.$6b)(j.problemMatchers),hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}M.from=V;async function F(j,W,J){if(j==null)return;let B;l.is(j.execution)?B=l.to(j.execution):y.is(j.execution)?B=y.to(j.execution):k.is(j.execution)&&(B=k.to(j._id,J));const U=r.to(j.definition);let _;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?_=j.source.scope:_=await W.resolveWorkspaceFolder(s.URI.revive(j.source.scope)):_=T.TaskScope.Workspace),!U||!_)return;const x=new T.$5O(U,_,j.name,j.source.label,B,j.problemMatchers);return j.isBackground!==void 0&&(x.isBackground=j.isBackground),j.group!==void 0&&(x.group=T.$1O.from(j.group._id),x.group&&j.group.isDefault&&(x.group=new T.$1O(x.group.id,x.group.label),j.group.isDefault===!0&&(x.group.isDefault=j.group.isDefault))),j.presentationOptions&&(x.presentationOptions=n.to(j.presentationOptions)),j._id&&(x._id=j._id),j.detail&&(x.detail=j.detail),x}M.to=F})(C||(e.TaskDTO=C={}));var w;(function(M){function z(F){return F}M.from=z;function V(F){if(F)return Object.assign(Object.create(null),F)}M.to=V})(w||(w={}));class b{#e;constructor(z,V,F){this._id=V,this.a=F,this.#e=z}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}let N=class{constructor(z,V,F,j,W,J,B,U){this.q=new D.$qe,this.r=new D.$qe,this.s=new D.$qe,this.u=new D.$qe,this.a=z.getProxy(O.$bO.MainThreadTask),this.b=F,this.c=j,this.d=W,this.e=J,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=B,this.g=U,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(z,V,F){if(!F)return new T.$dO(()=>{});const j=this.x();return this.j.set(j,{type:V,provider:F,extension:z}),this.a.$registerTaskProvider(j,V),new T.$dO(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(z,V){this.a.$registerTaskSystem(z,V)}fetchTasks(z){return this.a.$fetchTasks(w.from(z)).then(async V=>{const F=[];for(const j of V){const W=await C.to(j,this.b,this.m);W&&F.push(W)}return F})}get taskExecutions(){const z=[];return this.k.forEach(V=>z.push(V)),z}terminateTask(z){if(!(z instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(z._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(z,V,F){const j=this.m.get(z.id);j&&(this.o.set(z.id,j),this.e.attachPtyToTerminal(V,await j.callback(F))),this.p=z.id,this.q.fire({execution:await this.z(z)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(z){if(!this.l.has(z.id))return;const V=await this.z(z);this.l.delete(z.id),this.k.delete(z.id),this.B(z),this.r.fire({execution:V})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(z){const V=await this.z(z.id);this.s.fire({execution:V,processId:z.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(z){const V=await this.z(z.id);this.u.fire({execution:V,exitCode:z.exitCode})}$provideTasks(z,V){const F=this.j.get(z);if(!F)return Promise.reject(new Error("no handler found"));const j=[],W=(0,h.$Ch)(()=>F.provider.provideTasks(I.CancellationToken.None)).then(J=>this.v(V,j,F,J));return new Promise(J=>{W.then(B=>{Promise.all(j).then(()=>{J(B)})})})}async $resolveTask(z,V){const F=this.j.get(z);if(!F)return Promise.reject(new Error("no handler found"));if(V.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${F.type}].`);const j=await C.to(V,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const W=await F.provider.resolveTask(j,I.CancellationToken.None);if(!W)return;this.A(W,F);const J=C.from(W,F.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return k.is(J.execution)&&await this.y(J,W,!0),await this.w(J)}x(){return this.h++}async y(z,V,F){const j=await this.a.$createTaskId(z);!F&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,V.execution)),this.m.set(j,V.execution)}async z(z,V){if(typeof z=="string"){const W=this.l.get(z);if(!W)throw new a.$fb("Unexpected: The specified task is missing an execution");return W}const F=this.l.get(z.id);if(F)return F;let j;return V?j=Promise.resolve(new b(this,z.id,V)):j=C.to(z.task,this.b,this.m).then(W=>{if(!W)throw new a.$fb("Unexpected: Task does not exist.");return new b(this,z.id,W)}),this.l.set(z.id,j),j.then(W=>(this.k.set(z.id,W),W))}A(z,V){z._deprecated&&this.g.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}B(z){this.o.get(z.id)&&this.o.delete(z.id),this.n.has(z.id)&&this.p!==z.id&&(this.m.delete(z.id),this.n.delete(z.id));const F=this.n.values();let j=F.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=F.next()}};e.$7sc=N,e.$7sc=N=Ye([We(0,f.$OQ),We(1,P.$5Q),We(2,A.$qrc),We(3,p.$ZQ),We(4,c.$trc),We(5,E.$Rrc),We(6,$.$fk),We(7,d.$7qc)],N);let L=class extends N{constructor(z,V,F,j,W,J,B,U){super(z,V,F,j,W,J,B,U),this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:m.$k(m.Platform.Web)})}async executeTask(z,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const F=C.from(V,z);if(F===void 0)throw new Error("Task is not valid");if(k.is(F.execution))await this.y(F,V,!1);else throw new a.$db;const j=await this.z(await this.a.$getTaskExecution(F),V);return this.a.$executeTask(F).catch(W=>{throw new Error(W)}),j}v(z,V,F,j){const W=[];if(j)for(const J of j){if(this.A(J,F),!J.definition||!z[J.definition.type]){const U=J.source?J.source:"No task source";this.f.warn(`The task [${U}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`)}const B=C.from(J,F.extension);B&&k.is(B.execution)?(W.push(B),V.push(this.y(B,J,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:F.extension}}async w(z){if(k.is(z.execution))return z;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(z,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,V,F){}};e.$8sc=L,e.$8sc=L=Ye([We(0,f.$OQ),We(1,P.$5Q),We(2,A.$qrc),We(3,p.$ZQ),We(4,c.$trc),We(5,E.$Rrc),We(6,$.$fk),We(7,d.$7qc)],L),e.$9sc=(0,v.$Ki)("IExtHostTask")}),define(Re[336],Ce([1,0,32,30]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=void 0,e.$1M=D,e.$3M=O;function D(T){return"cellResults"in T}e.$2M="rawCell#";function O(T,A){let p=-1;const c=[];let I=[];return T.forEach(f=>{f.range.startLineNumber!==p&&I.length>0&&(c.push([...I]),I=[]),I.push(f),p=f.range.endLineNumber}),I.length>0&&c.push([...I]),c.map(f=>{const P=[],v=f[0].range.startLineNumber,o=f[f.length-1].range.endLineNumber;for(let m=v;m<=o;m++)P.push(A.getLineContent(m));return new s.$CM(P.join(`
`)+`
`,f.map(m=>new h.$Yt(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(Re[337],Ce([1,0,7,21,4,3,28,41,13,17,2,27,118,6,35,15,9,53,309,171,24,14,32,265,336,333]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t,r,n,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Isc=void 0,E=Ue(E),o=Ue(o),m=Ue(m);class g{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(k=>k.apiEditor)}constructor(k,S,R,C,w,b,N){this.q=R,this.r=C,this.s=w,this.t=b,this.u=N,this.f=new Map,this.g=new T.$Fc,this.h=new Map,this.j=new D.$qe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new D.$qe,this.onDidOpenNotebookDocument=this.m.event,this.n=new D.$qe,this.onDidCloseNotebookDocument=this.n.event,this.o=new D.$qe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new f.$5qc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=k.getProxy(P.$bO.MainThreadNotebook),this.c=k.getProxy(P.$bO.MainThreadNotebookDocuments),this.d=k.getProxy(P.$bO.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===A.MarshalledId.NotebookCellActionContext){const M=L.notebookEditor?.notebookUri,z=L.cell.handle,F=this.g.get(M)?.getCell(z);if(F)return F.apiCell}if(L&&L.$mid===A.MarshalledId.NotebookActionContext){const M=L.uri,z=this.g.get(M);if(z)return z.apiNotebook}return L}}),g.C(S)}getEditorById(k){const S=this.h.get(k);if(!S)throw new Error(`unknown text editor: ${k}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(k){for(const[S,R]of this.h)if(R.apiEditor===k)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(k,S){const R=this.g.get(k);if(!R&&!S)throw new Error(`NO notebook document for '${k}'`);return R}static w(k,S){if(!S)return;const R=S.filenamePattern.map(C=>o.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(S.filenamePattern&&!R){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:k.identifier,providerDisplayName:k.displayName||k.name,displayName:S.displayName,filenamePattern:R,priority:S.exclusive?l.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(k,S,R){const C=g.a++,w=typeof R.onDidChangeCellStatusBarItems=="function"?g.a++:void 0;this.f.set(C,R),this.b.$registerNotebookCellStatusBarItemProvider(C,w,S);let b;return w!==void 0&&(b=R.onDidChangeCellStatusBarItems(N=>this.b.$emitCellStatusBarEvent(w))),new m.$dO(()=>{this.f.delete(C),this.b.$unregisterNotebookCellStatusBarItemProvider(C,w),b?.dispose()})}async createNotebookDocument(k){const S=await this.c.$tryCreateNotebook({viewType:k.viewType,content:k.content&&o.NotebookData.from(k.content)});return I.URI.revive(S)}async openNotebookDocument(k){const S=this.g.get(k);if(S)return S.apiNotebook;const R=await this.c.$tryOpenNotebook(k),C=this.g.get(I.URI.revive(R));return(0,c.$ug)(C?.apiNotebook)}async showNotebookDocument(k,S){let R;typeof S=="object"?R={position:o.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(o.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0,label:S?.label}:R={preserveFocus:!1,pinned:!0};const C=S?.asRepl?"repl":k.notebookType,w=await this.d.$tryShowNotebookDocument(k.uri,C,R),b=w&&this.h.get(w)?.apiEditor;if(b)return b;throw w?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(k,S,R,C){const w=this.f.get(k),b=I.URI.revive(S),N=this.g.get(b);if(!N||!w)return;const L=N.getCellFromIndex(R);if(!L)return;const M=await w.provideCellStatusBarItems(L.apiCell,C);if(!M)return;const z=new O.$Yc,V=this.p.add([z]),j=(Array.isArray(M)?M:[M]).map(W=>o.NotebookStatusBarItem.from(W,this.i,z));return{cacheId:V,items:j}}$releaseNotebookCellStatusBarItems(k){this.p.delete(k)}registerNotebookSerializer(k,S,R,C,w){if((0,p.$hf)(S))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:S,serializer:R,options:C}),this.b.$registerNotebookSerializer(b,{id:k.identifier,location:k.extensionLocation},S,o.NotebookDocumentContentOptions.from(C),g.w(k,w)),(0,O.$Xc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(k,S,R){const C=this.y.get(k);if(!C)throw new Error("NO serializer found");const w=await C.serializer.deserializeNotebook(S.buffer,R);return new $.$9w(o.NotebookData.from(w))}async $notebookToData(k,S,R){const C=this.y.get(k);if(!C)throw new Error("NO serializer found");const w=await C.serializer.serializeNotebook(o.NotebookData.to(S.value),R);return h.$Se.wrap(w)}async $saveNotebook(k,S,R,C,w){const b=I.URI.revive(S),N=this.y.get(k);if(this.D(`enter saveNotebook(versionId: ${R}, ${b.toString()})`),!N)throw new Error("NO serializer found");const L=this.g.get(b);if(!L)throw new Error("Document NOT found");if(L.versionId!==R)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new E.$Al((0,s.localize)(2710,null,this.A(b)),E.FileOperationResult.FILE_PERMISSION_DENIED);const M={metadata:(0,a.$uo)(L.apiNotebook.metadata,W=>!(N.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of L.apiNotebook.getCells()){const J=new m.$IP(W.kind,W.document.getText(),W.document.languageId,W.mime,N.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);J.metadata=(0,a.$uo)(W.metadata,B=>!(N.options?.transientCellMetadata??{})[B]),M.cells.push(J)}if(await this.z(b,C),w.isCancellationRequested)throw new Error("canceled");const z=await N.serializer.serializeNotebook(M,w);if(w.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${R} ${b.toString()}`),await this.s.value.writeFile(b,z),this.D(`Finished write versionId: ${R} ${b.toString()}`);const V=this.s.getFileSystemProviderExtUri(b.scheme),F=await this.s.value.stat(b),j={name:V.basename(b),isFile:(F.type&E.FileType.File)!==0,isDirectory:(F.type&E.FileType.Directory)!==0,isSymbolicLink:(F.type&E.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&E.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((F.permissions??0)&E.FilePermission.Locked),etag:E.$Ll({mtime:F.mtime,size:F.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${R}, ${b.toString()})`),j}async $searchInNotebooks(k,S,R,C,w){const b=this.y.get(k)?.serializer;if(!b)return{limitHit:!1,results:[]};const N=new T.$Gc;await(async(F,j,W)=>{await Promise.all(F.map(async J=>await Promise.all(J.filenamePatterns.map(B=>{const U={_reason:W._reason,folderQueries:W.folderQueries,includePattern:W.includePattern,excludePattern:W.excludePattern,maxResults:W.maxResults,type:r.QueryType.File,filePattern:B};return this.t.doInternalFileSearchWithCustomCallback(U,j,_=>{_.forEach(x=>{N.has(x)||C.some(te=>J.isFromSettings&&!te.isFromSettings?!1:te.filenamePatterns.some(me=>(0,l.$PL)(me,x)))||N.add(x)})}).catch(_=>{if(_.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw _})}))))})(R,w,S);const M=new T.$Fc;let z=!1;const V=Array.from(N).map(async F=>{const j=[];try{if(w.isCancellationRequested)return;if(S.maxResults&&[...M.values()].reduce((U,_)=>U+_.cellResults.length,0)>S.maxResults){z=!0;return}const W=[],J=this.g.get(F);if(J)J.apiNotebook.getCells().forEach(_=>W.push({input:_.document.getText(),outputs:_.outputs.flatMap(x=>x.items.map(oe=>oe.data.toString()))}));else{const U=await this.s.value.readFile(F),_=h.$Se.fromString(U.toString()),x=await b.deserializeNotebook(_.buffer,w);if(w.isCancellationRequested)return;o.NotebookData.from(x).cells.forEach(te=>W.push({input:te.source,outputs:te.outputs.flatMap(me=>me.items.map(ce=>ce.valueBytes.toString()))}))}if(w.isCancellationRequested)return;W.forEach((U,_)=>{const x=S.contentPattern.pattern,oe=new n.$32b(U.input,void 0,U.outputs),te=oe.findInInputs(x),me=oe.findInOutputs(x),ce=me.flatMap(Y=>(0,u.$3M)(Y.matches,Y.textBuffer)).map((Y,q)=>(Y.webviewIndex=q,Y));if(te.length>0||me.length>0){const Y={index:_,contentResults:(0,u.$3M)(te,oe.inputTextBuffer),webviewResults:ce};j.push(Y)}});const B={resource:F,cellResults:j};M.set(F,B);return}catch{return}});return await Promise.all(V),{limitHit:z,results:[...M.values()]}}async z(k,S){const R=await this.s.value.stat(k);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==E.$Kl&&typeof R.mtime=="number"&&typeof R.size=="number"&&S.mtime<R.mtime&&S.etag!==E.$Ll({mtime:S.mtime,size:R.size}))throw new E.$Al((0,s.localize)(2711,null),E.FileOperationResult.FILE_MODIFIED_SINCE,S)}A(k){return k.scheme===t.Schemas.file?k.fsPath:k.toString()}B(k,S,R){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const C=new i.$usc(S,this.d,k,R.visibleRanges.map(o.NotebookRange.to),R.selections.map(o.NotebookRange.to),typeof R.viewColumn=="number"?o.ViewColumn.to(R.viewColumn):void 0);this.h.set(S,C)}$acceptDocumentAndEditorsDelta(k){if(k.value.removedDocuments)for(const R of k.value.removedDocuments){const C=I.URI.revive(R),w=this.g.get(C);w&&(w.dispose(),this.g.delete(C),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire(w.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===C.toString()&&this.h.delete(b.id)}if(k.value.addedDocuments){const R=[];for(const C of k.value.addedDocuments){const w=I.URI.revive(C.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const b=new d.$tsc(this.c,this.q,this.r,w,C);R.push(...C.cells.map(N=>d.$ssc.asModelAddData(N))),this.g.get(w)?.dispose(),this.g.set(w,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:R}),this.m.fire(b.apiNotebook)}}if(k.value.addedEditors)for(const R of k.value.addedEditors){if(this.h.has(R.id))return;const C=I.URI.revive(R.documentUri),w=this.g.get(C);w&&this.B(w,R.id,R)}const S=[];if(k.value.removedEditors)for(const R of k.value.removedEditors){const C=this.h.get(R);C&&(this.h.delete(R),this.k?.id===C.id&&(this.k=void 0),S.push(C))}if(k.value.visibleEditors){this.l=k.value.visibleEditors.map(C=>this.h.get(C)).filter(C=>!!C);const R=new Set;this.l.forEach(C=>R.add(C.id));for(const C of this.h.values()){const w=R.has(C.id);C._acceptVisibility(w)}this.l=[...this.h.values()].map(C=>C).filter(C=>C.visible),this.o.fire(this.visibleNotebookEditors)}k.value.newActiveEditor===null?this.k=void 0:k.value.newActiveEditor&&(this.h.get(k.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${k.value.newActiveEditor}`),this.k=this.h.get(k.value.newActiveEditor)),k.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(k){const S=v.$aR.String.with("notebookType","A notebook type"),R=new v.$cR("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new v.$aR("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>h.$Se.wrap(w))],new v.$bR("Notebook Data",w=>o.NotebookData.to(w.value))),C=new v.$cR("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new v.$aR("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new $.$9w(o.NotebookData.from(w)))],new v.$bR("Bytes",w=>w.buffer));k.registerApiCommand(R),k.registerApiCommand(C)}D(k){this.u.trace(`[Extension Host Notebook] ${k}`)}}e.$Isc=g}),define(Re[338],Ce([1,0,18,80,39,109,28,14,16,22,13,17,2,106,7,47,11,155,48,163,334,32]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0,e.$RN=r,e.$SN=n,e.$UN=w,s=Ue(s),h=Ue(h),D=Ue(D),p=Ue(p),I=Ue(I),v=Ue(v);function r(b){return typeof b=="object"&&"uri"in b&&"pattern"in b}function n(b){return typeof b=="string"?{pattern:b}:{pattern:b.pattern,uri:b.baseUri}}let u=class{constructor(N,L,M,z,V,F){this.a=N,this.b=L,this.c=M,this.d=z,this.f=V,this.g=F}text(N,L,M={}){N=this.h(N,M);const z=this.a.getValue(),V=L&&L.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.j(L?.map(d.$6i),M),type:t.QueryType.Text,contentPattern:N,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:z.search.usePCRE2||V||!1,surroundingContext:M.surroundingContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}h(N,L){const M=this.a.getValue();N.isRegExp&&(N.pattern=N.pattern.replace(/\r?\n/g,"\\n"));const z={...N,wordSeparators:M.editor.wordSeparators};return this.l(N,L)&&(z.isCaseSensitive=!0),this.m(N)&&(z.isMultiline=!0),L.notebookSearchConfig?.includeMarkupInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownInput=L.notebookSearchConfig.includeMarkupInput),L.notebookSearchConfig?.includeMarkupPreview&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownPreview=L.notebookSearchConfig.includeMarkupPreview),L.notebookSearchConfig?.includeCodeInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellInput=L.notebookSearchConfig.includeCodeInput),L.notebookSearchConfig?.includeOutput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellOutput=L.notebookSearchConfig.includeOutput),z}file(N,L={}){return{...this.j(N,L),type:t.QueryType.File,filePattern:L.filePattern?L.filePattern.trim():L.filePattern,exists:L.exists,sortByScore:L.sortByScore,cacheKey:L.cacheKey,shouldGlobMatchFilePattern:L.shouldGlobSearch}}i(N,L){if(!N)return{};if(Array.isArray(N)){if(N=N.filter(M=>M.length>0).map(S),!N.length)return{}}else N=S(N);return L?this.parseSearchPaths(N):{pattern:g(...Array.isArray(N)?N:[N])}}j(N=[],L={}){let M=Array.isArray(L.excludePattern)?L.excludePattern.map(B=>B.pattern).flat():L.excludePattern;M=M?.length===1?M[0]:M;const z=this.i(L.includePattern,L.expandPatterns),V=this.i(M,L.expandPatterns),F=N.length>1,j=(z.searchPaths&&z.searchPaths.length?z.searchPaths.map(B=>this.t(B,L,V)):N.map(B=>this.u(B,L,V,F))).filter(B=>!!B),W={_reason:L._reason,folderQueries:j,usingSearchPaths:!!(z.searchPaths&&z.searchPaths.length),extraFileResources:L.extraFileResources,excludePattern:V.pattern,includePattern:z.pattern,onlyOpenEditors:L.onlyOpenEditors,maxResults:L.maxResults,onlyFileScheme:L.onlyFileScheme};if(L.onlyOpenEditors){const B=s.$Lb(this.c.groups.flatMap(x=>x.editors.map(oe=>oe.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(B));const U=B.filter(x=>(0,t.$GM)(W,x.fsPath)),_=this.k(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(_)),{...W,..._}}const J=L.extraFileResources&&L.extraFileResources.filter(B=>(0,t.$GM)(W,B.fsPath));return W.extraFileResources=J&&J.length?J:void 0,W}k(N){const L=[],M=new T.$Fc,z={};let V=!1;return N.forEach(F=>{if(F.scheme===A.Schemas.walkThrough)return;if((0,c.$ph)(F)){const W=this.b.getWorkspaceFolder(F)?.uri??this.g.extUri.dirname(F);let J=M.get(W);J||(V=!0,J={folder:W,includePattern:{}},L.push(J),M.set(W,J));const B=p.$qc(W.fsPath,F.fsPath);(0,E.$ug)(J.includePattern)[B.replace(/\\/g,"/")]=!0}else F.fsPath&&(V=!0,z[F.fsPath]=!0)}),{folderQueries:L,includePattern:z,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}l(N,L){if(L.isSmartCase){if(N.isRegExp){if(I.$ag(N.pattern,!0))return!0}else if(I.$ag(N.pattern))return!0}return!!N.isCaseSensitive}m(N){return N.isMultiline||N.isRegExp&&(0,P.$AD)(N.pattern)||N.pattern.indexOf(`
`)>=0?!0:!!N.isMultiline}parseSearchPaths(N){const L=U=>p.$nc(U)||/^\.\.?([\/\\]|$)/.test(U),z=(Array.isArray(N)?N:y(N)).map(U=>{const _=this.f.resolvedUserHome;return _?(0,O.$bx)(U,_.scheme===A.Schemas.file?_.fsPath:_.path):U}),V=h.$e(z,U=>L(U)?"searchPaths":"exprSegments"),F=(V.exprSegments||[]).map(U=>I.$sf(U,"/")).map(U=>I.$sf(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),k(U))),j={},W=this.o(V.searchPaths||[]);W&&W.length&&(j.searchPaths=W);const J=F.flat(),B=g(...J);return B&&(j.pattern=B),j}n(N,L){return L.disregardExcludeSettings?void 0:(0,t.$FM)(N,!L.disregardSearchExcludeSettings)}o(N){if(!N||!N.length)return[];const L=N.flatMap(z=>{let{pathPortion:V,globPortion:F}=l(z);return F&&(F=R(F)),this.q(V).flatMap(W=>this.r(W,F))}),M=new Map;return L.forEach(z=>{const V=z.searchPath.toString(),F=M.get(V);F?z.pattern&&(F.pattern=F.pattern||{},F.pattern[z.pattern]=!0):M.set(V,{searchPath:z.searchPath,pattern:z.pattern?g(z.pattern):void 0})}),Array.from(M.values())}q(N){if(p.$nc(N)){const L=this.b.getWorkspace().folders;return L[0]&&L[0].uri.scheme!==A.Schemas.file?[{searchPath:L[0].uri.with({path:N})}]:[{searchPath:f.URI.file(p.$mc(N))}]}if(this.b.getWorkbenchState()===d.WorkbenchState.FOLDER){const L=this.b.getWorkspace().folders[0].uri;if(N=S(N),N.startsWith("../")||N===".."){const z=p.$lc.resolve(L.path,N);return[{searchPath:L.with({path:z})}]}const M=R(N);return[{searchPath:L,pattern:M}]}else{if(N==="./"||N===".\\")return[];{const L=N.replace(/^\.[\/\\]/,""),z=this.b.getWorkspace().folders.map(V=>{const F=L.match(new RegExp(`^${I.$mf(V.name)}(?:/(.*)|$)`));return F?{match:F,folder:V}:null}).filter(E.$rg);if(z.length)return z.map(V=>{const F=V.match[1];return{searchPath:V.folder.uri,pattern:F&&R(F)}});{const V=N.match(/\.[\/\\](.+)[\/\\]?/),F=V?V[1]:N,j=v.localize(12573,null,F);throw new Error(j)}}}}r(N,L){const M=N.pattern&&L?`${N.pattern}/${L}`:N.pattern||L,z=[{searchPath:N.searchPath,pattern:M}];return M&&!M.endsWith("**")&&z.push({searchPath:N.searchPath,pattern:M+"/**"}),z}t(N,L,M){const z=this.u((0,d.$6i)(N.searchPath),L,M,!1);return z?{...z,includePattern:N.pattern}:null}u(N,L,M,z){let V;const F=f.URI.isUri(N)?N:N.uri;let j=L.excludePattern?.map(x=>{const oe=L.excludePattern&&r(x)?x.uri:void 0;return!oe||!(f.URI.isUri(N)&&this.g.extUri.isEqual(N,oe))?oe:void 0});if(j?.length||(j=[void 0]),M.searchPaths){const x=M.searchPaths.filter(oe=>(0,c.$eh)(oe.searchPath,F))[0];if(x&&!x.pattern)return null;x&&(V=x.pattern)}const W=this.a.getValue({resource:F}),B={...this.n(W,L)||{},...V||{}},U=f.URI.isUri(N)?(0,c.$ih)(N):N.name,_=j.map(x=>Object.keys(B).length>0?{folder:x,pattern:B}:void 0).filter(x=>x);return{folder:F,folderName:z?U:void 0,excludePattern:_,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof L.disregardIgnoreFiles=="boolean"?L.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof L.disregardGlobalIgnoreFiles=="boolean"?L.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof L.disregardParentIgnoreFiles=="boolean"?L.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof L.ignoreSymlinks=="boolean"?L.ignoreSymlinks:!W.search.followSymlinks}}};e.$TN=u,e.$TN=u=Ye([We(0,o.$ej),We(1,d.$Ti),We(2,i.$OE),We(3,m.$fk),We(4,a.$PN),We(5,$.$Pl)],u);function l(b){const N=b.match(/[\*\{\}\(\)\[\]\?]/);if(N){const L=N.index,M=b.substr(0,L).match(/[/|\\][^/\\]*$/);if(M){let z=b.substr(0,M.index);return z.match(/[/\\]/)||(z+="/"),{pathPortion:z,globPortion:b.substr((M.index||0)+1)}}}return{pathPortion:b}}function g(...b){return b.length?b.reduce((N,L)=>(N[L]=!0,N),Object.create(null)):void 0}function y(b){return D.$Dk(b,",").map(N=>N.trim()).filter(N=>!!N.length)}function k(b){return[`**/${b}/**`,`**/${b}`].map(L=>L.replace(/\*\*\/\*\*/g,"**"))}function S(b){return b.replace(/\\/g,"/")}function R(b){return S(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function C(b){return b.replace(/([?*[\]])/g,"[$1]")}function w(b,N){b=s.$Qb(b,z=>z.toString());const L=[],M=N.getWorkspace();return b&&b.forEach(z=>{let V;if(N.getWorkbenchState()===d.WorkbenchState.FOLDER)V=(0,c.$nh)(M.folders[0].uri,z),V&&V!=="."&&(V="./"+V);else{const F=N.getWorkspaceFolder(z);if(F){const j=F.name;if(M.folders.filter(J=>J.name===j).length===1){const J=(0,c.$nh)(F.uri,z);J===""?V=`./${F.name}`:V=`./${F.name}/${J}`}else V=z.fsPath}}V&&L.push(C(V))}),L}}),define(Re[339],Ce([1,0,22,2,20,12,5,338,32,48,8]),function(ge,e,s,h,D,O,T,A,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VAb=f,e.$WAb=o,s=Ue(s),O=Ue(O);const E=7e3;function f(m,$){const d=$.activationEvents;if(!d)return Promise.resolve(void 0);const i=[],a=[];for(const g of d)if(/^workspaceContains:/.test(g)){const y=g.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||m.forceUsingSearch?a.push(y):i.push(y)}if(i.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:t,resolve:r}=(0,I.$Dh)(),n=g=>r({activationEvent:g}),u=Promise.all(i.map(g=>P(m,g,n))).then(()=>{}),l=v(m,$.identifier,a,n);return Promise.all([u,l]).then(()=>{r(void 0)}),t}async function P(m,$,d){for(const i of m.folders)if(await m.exists(s.$lh(h.URI.revive(i),$))){d(`workspaceContains:${$}`);return}}async function v(m,$,d,i){if(d.length===0)return Promise.resolve(void 0);const a=new D.$Be,t=m.checkExists(m.folders,d,a.token),r=setTimeout(async()=>{a.cancel(),m.logService.info(`Not activating extension '${$.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},E);let n=!1;try{n=await t}catch(u){O.$8(u)||O.$4(u)}a.dispose(),clearTimeout(r),n&&i(`workspaceContains:${d.join(",")}`)}function o(m,$,d,i){const a=m.get(T.$Ji),t=m.get(p.$xM),n=a.createInstance(A.$TN).file($.map(u=>(0,c.$6i)(h.URI.revive(u))),{_reason:"checkExists",includePattern:d,exists:!0});return t.fileSearch(n,i).then(u=>!!u.limitHit,u=>O.$8(u)?!1:Promise.reject(u))}}),define(Re[54],Ce([1,0,7,16,63,22,8,3,62,2,11,6,43,272,126,42,25,165,12,23,21,252,9,73,5,29,98,19,114,78,49,129,4,339,125,254,14,123,44,10,124]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t,r,n,u,l,g,y,k,S,R,C,w,b,N,L,M,z,V,F,j){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$9rc=e.$8rc=e.$7rc=e.$6rc=e.$5rc=void 0,s=Ue(s),h=Ue(h),D=Ue(D),d=Ue(d),e.$5rc=(0,u.$Ki)("IHostUtils");let J=W=class extends A.$Zc{constructor(Y,q,se,be,ae,we,$e,pe,Oe,Fe,He,Ze,xe){super(),this.Y=Ze,this.Z=xe,this.a=this.B(new w.$qe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=q,this.g=se,this.f=$e,this.j=be,this.m=ae,this.s=we,this.t=Oe,this.u=Fe,this.w=He,this.y=this.g.getProxy(E.$bO.MainThreadWorkspace),this.z=this.g.getProxy(E.$bO.MainThreadTelemetry),this.C=this.g.getProxy(E.$bO.MainThreadExtensionService),this.D=new T.$Jh,this.F=new T.$Jh,this.G=new T.$Jh,this.H=new T.$Jh,this.I=new me(this.f.extensions.activationEvents),this.L=new $.$lfc(this.I,this.f.extensions.allExtensions);const je=new i.$An(this.f.extensions.myExtensions);this.J=new $.$lfc(this.I,oe(this.L,je)),F.$w&&(this.s.info(`Creating extension host with the following global extensions: ${_(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${_(this.J)}`)),this.M=new v.$Nrc(this.g,this.s),this.N=new N.$Xrc(this.g),this.O=pe,this.h=this.q.add(Y.createChild(new k.$Ii([v.$Orc,this.M],[N.$Yrc,this.N]))),this.P=this.B(new P.$Mrc(this.J,this.L,{onExtensionActivationError:(qe,Ne,H)=>{this.C.$onExtensionActivationError(qe,d.$6(Ne),H)},actualActivateExtension:async(qe,Ne)=>{if($.$lfc.isHostExtension(qe,this.J,this.L))return await this.C.$activateExtension(qe,Ne),new P.$Lrc;const H=this.J.getExtensionDescription(qe);return this.fb(H,Ne)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),D.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){d.$4(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this.eb(ae))}catch{}await Promise.all(Y)}terminate(Y,q=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),d.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const se=this.$();Promise.race([(0,T.$Lh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const q=await this.C.$getExtension(Y);return q&&{...q,identifier:new i.$zn(q.identifier.value),extensionLocation:c.URI.revive(q.extensionLocation)}}ab(Y,q){return this.P.activateByEvent(Y,q)}bb(Y,q){return this.P.activateById(Y,q)}activateByIdWithErrors(Y,q){return this.bb(Y,q).then(()=>{const se=this.P.getActivatedExtension(Y);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===M.Schemas.file&&this.c.fsRealpath){const q=Y.fsPath;this.R.has(q)||this.R.set(q,this.c.fsRealpath(q));const se=await this.R.get(q);return c.URI.file(se)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new te(Y))),this.Q}async db(Y){const q=p.$Qi.forUris(se=>O.$ch.ignorePathCasing(se));return await Promise.all(Y.map(async se=>{if(this.wb(se)){const be=await this.cb(se.extensionLocation);q.set(be,se)}})),q}eb(Y){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return q;const se=this.P.getActivatedExtension(Y);if(!se)return q;try{typeof se.module.deactivate=="function"&&(q=Promise.resolve(se.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(be)}try{se.disposable.dispose()}catch(be){this.s.error(`An error occurred when disposing the subscriptions for extension '${Y.value}':`),this.s.error(be)}return q}async fb(Y,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,q).then(se=>{const be=se.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,q),this.gb(Y,q,"success",be),se},se=>{throw this.gb(Y,q,"failure"),se})}gb(Y,q,se,be){const ae=U(Y,q);this.z.$publicLog2("extensionActivationTimes",{...ae,...be||{},outcome:se})}hb(Y,q){const se=U(Y,q);this.z.$publicLog2("activatePlugin",se);const be=this.wb(Y);if(!be)return Promise.resolve(new P.$Krc(P.$Hrc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${Y.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const ae=new A.$Yc,we=new P.$Irc(q.startup);return Promise.all([this.xb(Y,(0,O.$lh)(Y.extensionLocation,be),we),this.ib(Y,ae)]).then($e=>(D.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),W.jb(this.s,Y.identifier,$e[0],$e[1],ae,we))).then($e=>(D.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),$e))}ib(Y,q){const se=this.Z.createLanguageModelAccessInformation(Y),be=q.add(new t.$Qrc(Y,this.M)),ae=q.add(new t.$Prc(Y.identifier.value,!1,this.M)),we=q.add(new L.$Zrc(Y,this.N)),$e=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,pe=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([be.whenReady,ae.whenReady,this.O.whenReady]).then(()=>{const Oe=this;let Fe,He;const Ze=(0,m.$CH)(Y,"ipc")?this.f.messagePorts?.get(i.$zn.toKey(Y.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:ae,secrets:we,subscriptions:[],get languageModelAccessInformation(){return se},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(xe){return h.$oc(Y.extensionLocation.fsPath,xe)},get storagePath(){return Oe.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return Oe.O.globalValue(Y).fsPath},get logPath(){return h.$oc(Oe.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return c.URI.joinPath(Oe.f.logsLocation,Y.identifier.value)},get storageUri(){return Oe.O.workspaceValue(Y)},get globalStorageUri(){return Oe.O.globalValue(Y)},get extensionMode(){return $e},get extension(){return Fe===void 0&&(Fe=new x(Oe,Y.identifier,Y,pe,!1)),Fe},get extensionRuntime(){return(0,m.$DH)(Y,"extensionRuntime"),Oe.extensionRuntime},get environmentVariableCollection(){return Oe.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!He){if(!Ze)return;const xe=w.Event.buffer(w.Event.fromDOMEventEmitter(Ze,"message",je=>je.data));Ze.start(),He={onDidReceiveMessage:xe,postMessage:Ze.postMessage.bind(Ze)}}return He}})})}static jb(Y,q,se,be,ae,we){return se=se||{activate:void 0,deactivate:void 0},this.kb(Y,q,se,be,we).then($e=>new P.$Jrc(!1,null,we.build(),se,$e,(0,A.$Xc)(()=>{ae.dispose(),(0,A.$Uc)(be.subscriptions)})))}static kb(Y,q,se,be,ae){if(typeof se.activate=="function")try{ae.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${q.value}`);const we=typeof global=="object"?global:self,$e=se.activate.apply(we,[be]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve($e).then(pe=>(ae.activateResolveStop(),pe))}catch(we){return Promise.reject(we)}else return Promise.resolve(se)}lb(Y,q){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:q}).then(void 0,se=>{this.s.error(se)})}mb(Y,q=0){const be=Date.now();(0,F.$E)(()=>{for(let ae=q;ae<Y.length;ae+=1){const we=Y[ae];for(const $e of we.activationEvents??[])if($e==="onStartupFinished")if(Date.now()-be>50){this.mb(Y,ae);break}else this.lb(we,$e)}})}nb(){this.C.$setPerformanceMarks(D.getMarks()),this.m.getConfigProvider().then(Y=>{const q=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(q)this.mb(se);else for(const be of se)if(be.activationEvents)for(const ae of be.activationEvents)ae==="onStartupFinished"&&this.lb(be,ae)})}ob(){const Y=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const q=this.j.workspace?this.j.workspace.folders:[],se=this.pb(q),be=this.rb(),ae=Promise.all([be,Y,se]).then(()=>{});return Promise.race([ae,(0,T.$Lh)(1e4)]).then(()=>{this.nb()}),ae}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.qb(Y,q))).then(()=>{})}async qb(Y,q){if(this.isActivated(q.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:Y.map(we=>we.uri),forceUsingSearch:se||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,$e,pe)=>this.y.$checkExists(we,$e,pe)},ae=await(0,b.$VAb)(be,q);if(ae)return this.bb(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:ae.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:q}=this.f.environment;if(!Y||!q)throw new Error(s.localize(2702,null));const se=await this.xb(null,q,new P.$Irc(!1));if(!se||typeof se.run!="function")throw new Error(s.localize(2703,null,q.toString()));return new Promise((be,ae)=>{const we=(Oe,Fe)=>{Oe?(F.$w&&this.s.error("Test runner called back with error",Oe),ae(Oe)):(F.$w&&(Fe?this.s.info(`Test runner called back with ${Fe} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof Fe=="number"&&Fe>0?1:0))},$e=(0,O.$_g)(q),pe=se.run($e,we);pe&&pe.then&&pe.then(()=>{F.$w&&this.s.info("Test runner finished successfully."),be(0)}).catch(Oe=>{F.$w&&this.s.error("Test runner finished with error",Oe),ae(Oe instanceof Error&&Oe.stack?Oe.stack:String(Oe))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,T.$Lh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,q){return this.S[Y]=q,(0,A.$Xc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:q}=await this.ub(Y);return q?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const q=Y.indexOf("+");if(q===-1)throw new r.$lO("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=Y.substr(0,q);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(Y,q){const se=V.$ke.create(!1),be=()=>`[resolveAuthority(${(0,n.$1l)(Y)},${q})][${se.elapsed()}ms] `,ae=G=>this.s.info(`${be()}${G}`),we=G=>this.s.warn(`${be()}${G}`),$e=(G,Z=void 0)=>this.s.error(`${be()}${G}`,Z),pe=G=>{if(G instanceof r.$lO)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},Oe=async G=>{ae(`activating resolver for ${G}...`);const{resolver:Z,authorityPrefix:ee}=await this.ub(G);if(!Z)throw $e(`no resolver for ${ee}`),new r.$lO(`No remote extension installed to resolve ${ee}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Z,authorityPrefix:ee,remoteAuthority:G}},Fe=Y.split(/@|%40/g).reverse();ae(`activating remote resolvers ${Fe.join(" -> ")}`);let He;try{He=await Promise.all(Fe.map(Oe)).catch(async G=>{if(!(G instanceof r.$lO)||G._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return we(`resolving nested authorities failed: ${G.message}`),[await Oe(Y)]})}catch(G){return pe(G)}const Ze=new T.$Vh;Ze.cancelAndSet(()=>ae("waiting..."),1e3);let xe,je;for(const[G,{authorityPrefix:Z,resolver:ee,remoteAuthority:ue}]of He.entries())try{if(G===He.length-1)ae("invoking final resolve()..."),D.mark(`code/extHost/willResolveAuthority/${Z}`),xe=await ee.resolve(ue,{resolveAttempt:q,execServer:je}),D.mark(`code/extHost/didResolveAuthorityOK/${Z}`),ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ee,r.$kO.isManagedResolvedAuthority(xe)?xe:void 0));else{if(ae(`invoking resolveExecServer() for ${ue}`),D.mark(`code/extHost/willResolveExecServer/${Z}`),je=await ee.resolveExecServer?.(ue,{resolveAttempt:q,execServer:je}),!je)throw new r.$lO(`Exec server was not available for ${ue}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);D.mark(`code/extHost/didResolveExecServerOK/${Z}`)}}catch(ye){return D.mark(`code/extHost/didResolveAuthorityError/${Z}`),$e("returned an error",ye),Ze.dispose(),pe(ye)}Ze.dispose();const qe={environmentTunnels:xe.environmentTunnels,features:xe.tunnelFeatures?{elevation:xe.tunnelFeatures.elevation,privacyOptions:xe.tunnelFeatures.privacyOptions,protocol:xe.tunnelFeatures.protocol===void 0?!0:xe.tunnelFeatures.protocol}:void 0},Ne={extensionHostEnv:xe.extensionHostEnv,isTrusted:xe.isTrusted,authenticationSession:xe.authenticationSessionForInitializingExtensions?{id:xe.authenticationSessionForInitializingExtensions.id,providerId:xe.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${r.$kO.isManagedResolvedAuthority(xe)?"managed authority":`${xe.host}:${xe.port}`}`);let H;if(r.$kO.isManagedResolvedAuthority(xe)){const G=q;this.Y.setFactory(G,xe.makeConnection),H={authority:Y,connectTo:new n.$Xl(G),connectionToken:xe.connectionToken}}else H={authority:Y,connectTo:new n.$Yl(xe.host,xe.port),connectionToken:xe.connectionToken};return{type:"ok",value:{authority:H,options:Ne,tunnelInformation:qe}}}async $getCanonicalURI(Y,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$1l)(Y)})`);const{resolver:se}=await this.ub(Y);if(!se)return null;const be=c.URI.revive(q);if(typeof se.getCanonicalURI>"u")return be;const ae=await(0,T.$Ch)(()=>se.getCanonicalURI(be));return ae||be}async $startExtensionHost(Y){Y.toAdd.forEach(we=>we.extensionLocation=c.URI.revive(we.extensionLocation));const{globalRegistry:q,myExtensions:se}=B(this.I,this.L,this.J,Y),be=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(q.getAllExtensionDescriptions()),this.J.set(se),F.$w&&(this.s.info(`$startExtensionHost: global extensions: ${_(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${_(this.J)}`)),this.tb()}$activateByEvent(Y,q){return q===m.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(Y,!1)):this.G.wait().then(se=>this.ab(Y,!1))}async $activate(Y,q){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,q),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(we=>we.extensionLocation=c.URI.revive(we.extensionLocation));const{globalRegistry:q,myExtensions:se}=B(this.I,this.L,this.J,Y),be=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(q.getAllExtensionDescriptions()),this.J.set(se),F.$w&&(this.s.info(`$deltaExtensions: global extensions: ${_(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${_(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const q=a.$Se.alloc(Y),se=Math.random()%256;for(let be=0;be<Y;be++)q.writeUInt8(se,be);return q}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$6rc=J,e.$6rc=J=W=Ye([We(0,u.$Ji),We(1,e.$5rc),We(2,y.$OQ),We(3,o.$qrc),We(4,f.$trc),We(5,I.$fk),We(6,l.$5Q),We(7,g.$wrc),We(8,S.$jHb),We(9,R.$Rrc),We(10,z.$2rc),We(11,j.$3rc),We(12,C.$Vrc)],J);function B(ce,Y,q,se){ce.addActivationEvents(se.addActivationEvents);const be=new $.$lfc(ce,Y.getAllExtensionDescriptions());be.deltaExtensions(se.toAdd,se.toRemove);const ae=new i.$An(q.getAllExtensionDescriptions().map($e=>$e.identifier));for(const $e of se.myToRemove)ae.delete($e);for(const $e of se.myToAdd)ae.add($e);const we=oe(be,ae);return{globalRegistry:be,myExtensions:we}}function U(ce,Y){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function _(ce){return ce.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$7rc=(0,u.$Ki)("IExtHostExtensionService");class x{#e;#t;#i;constructor(Y,q,se,be,ae){this.#e=Y,this.#t=q,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.$mc((0,O.$_g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=be,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$8rc=x;function oe(ce,Y){return ce.getAllExtensionDescriptions().filter(q=>Y.has(q.identifier))}class te{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$9rc=te;class me{constructor(Y){this.a=new i.$Bn,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const q of Object.keys(Y))this.a.set(q,Y[q])}}}),define(Re[340],Ce([1,0,63,2,6,43,25,23,19,29,5,54,11,13]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$mtc=void 0,s=Ue(s);let o=class{constructor(a,t,r,n,u,l,g){this.c=a,this.d=t,this.f=r,this.g=n,this.h=u,this.i=l,this.j=g,this.a=new Map,this.b=[]}async install(){this.k(),s.mark("code/extHost/willWaitForConfig");const a=await this.g.getConfigProvider();s.mark("code/extHost/didWaitForConfig");const t=await this.h.getExtensionPathIndex();this.register(new $(this.c,t,this.d,a,this.j)),this.register(this.f.createInstance(m)),this.i.remote.isRemote&&this.register(this.f.createInstance(d,t,this.i.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const t of a.nodeModuleName)this.a.set(t,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(t=>a.alternativeModuleName(t))}};e.$mtc=o,e.$mtc=o=Ye([We(2,I.$Ji),We(3,O.$trc),We(4,E.$7rc),We(5,c.$5Q),We(6,f.$fk)],o);let m=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&v.a.size){const t=(0,P.$mf)(this.c(a.environment.appRoot.fsPath)),r="[a-z0-9_.-]",n=`@${r}+\\/${r}+|${r}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${u}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const t=this.b.exec(this.c(a));if(!t)return;const[,r,n,u]=t,l=v.a.get(n);if(l!==void 0)return console.warn(`${n} as been renamed to ${l}, please update your imports`),r+l+u}c(a){return a.replace(/\\/g,"/")}};m=v=Ye([We(0,c.$5Q)],m);class ${constructor(a,t,r,n,u){this.c=a,this.d=t,this.e=r,this.f=n,this.g=u,this.nodeModuleName="vscode",this.a=new A.$Bn}load(a,t){const r=this.d.findSubstr(t);if(r){let n=this.a.get(r.identifier);return n||(n=this.c(r,this.e,this.f),this.a.set(r.identifier,n)),n}if(!this.b){let n="";this.d.forEach((u,l)=>n+=`	${l} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${n}`),this.b=this.c(T.$xH,this.e,this.f)}return this.b}}let d=class{constructor(a,t,r){this.e=a,this.f=t,this.nodeModuleName=["open","opn"],this.d=r.getProxy(D.$bO.MainThreadTelemetry);const n=r.getProxy(D.$bO.MainThreadWindow);this.c=(u,l)=>{const g=h.URI.parse(u);return l?this.g(u,l):g.scheme==="http"||g.scheme==="https"?n.$openUri(g,u,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?n.$openUri(g,u,{}):this.g(u,l)}}load(a,t,r){const n=this.e.findSubstr(t);return n&&(this.a=n.identifier.value,this.h()),this.b=r(a),this.c}g(a,t){return this.i(),this.b(a,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};d=Ye([We(2,p.$OQ)],d)}),define(Re[66],Ce([1,0,50,3,16,57,5,65,79,54,9,42,269,43]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$rc=e.$0rc=void 0,D=Ue(D),O=Ue(O),e.$0rc=(0,T.$Ki)("IExtHostVariableResolverProvider");class v extends f.$SR{constructor($,d,i,a,t,r,n){function u(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const g=a.tabGroups.all.find(y=>y.isActive)?.activeTab;if(g!==void 0){if(g.input instanceof I.$5P||g.input instanceof I.$0P)return g.input.modified;if(g.input instanceof I.$4P||g.input instanceof I.$9P||g.input instanceof I.$7P)return g.input.uri}}}super({getFolderUri:l=>{const g=r.folders.filter(y=>y.name===l);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(l,g)=>t.getConfiguration(void 0,l).get(g),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=u();if(l)return D.$mc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(d){const l=u();if(l){const g=d.getWorkspaceFolder(l);if(g)return D.$mc(g.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>$.getExtension(l)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(O.env))}}let o=class extends h.$Zc{constructor($,d,i,a,t){super(),this.b=$,this.c=d,this.g=i,this.h=a,this.j=t,this.a=new s.$Y(async()=>{const r=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,r,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$$rc=o,e.$$rc=o=Ye([We(0,c.$7rc),We(1,E.$qrc),We(2,A.$ZQ),We(3,P.$trc),We(4,p.$Frc)],o)}),define(Re[101],Ce([1,0,8,4,2,3,23,5,6,79,54,19,9,42,160,120,260,43,66,51,35,15,18,99]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$isc=e.$hsc=e.$gsc=e.$fsc=e.$esc=void 0,t=Ue(t),e.$esc=(0,A.$Ki)("IExtHostDebugService");let u=class extends O.$Zc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(C,w,b,N,L,M,z,V){super(),this.Y=w,this.Z=b,this.$=N,this.ab=L,this.bb=M,this.cb=z,this.db=V,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$qe),this.z=this.B(new h.$qe),this.C=this.B(new h.$qe),this.F=this.B(new h.$qe),this.u=C.getProxy(p.$bO.MainThreadDebugService),this.I=this.B(new h.$qe),this.L=this.B(new h.$qe),this.G=new g(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(F=>{this.B(F.onDidChange(j=>{this.fb(F)})),this.fb(F)})}async $getVisualizerTreeItem(C,w){const b=this.gb(w);if(!b)return;const N=await this.Q.get(C)?.getTreeItem?.(b);return N?this.eb(C,N):void 0}registerDebugVisualizationTree(C,w,b){const N=T.$zn.toKey(C.identifier),L=this.ub(N,w);if(this.P.has(L))throw new Error(`A debug visualization provider with id '${w}' is already registered`);return this.Q.set(L,b),this.u.$registerDebugVisualizerTree(L,!!b.editItem),(0,O.$Xc)(()=>{this.u.$unregisterDebugVisualizerTree(L),this.Q.delete(w)})}async $getVisualizerTreeItemChildren(C,w){const b=this.S.get(w)?.item;return b?(await this.Q.get(C)?.getChildren?.(b))?.map(L=>this.eb(C,L))||[]:[]}async $editVisualizerTreeItem(C,w){const b=this.S.get(C);if(!b)return;const N=await this.Q.get(b.provider)?.editItem?.(b.item,w);return this.eb(b.provider,N||b.item)}$disposeVisualizedTree(C){const w=this.S.get(C);if(!w)return;const b=[w.children];for(const N of b)if(N)for(const L of N)b.push(this.S.get(L)?.children),this.S.delete(L)}eb(C,w){let b=this.R.get(w);return b||(b=this.O++,this.R.set(w,b),this.S.set(b,{provider:C,item:w})),t.DebugTreeItem.from(w,b)}asDebugSourceUri(C,w){const b=C;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let N=`debug:${encodeURIComponent(b.path||"")}`,L="?";return w&&(N+=`${L}session=${encodeURIComponent(w.id)}`,L="&"),N+=`${L}ref=${b.sourceReference}`,D.URI.parse(N)}else{if(b.path)return D.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(C){const w=[];for(const b of C.getAllExtensionDescriptions())if(b.contributes){const N=b.contributes.debuggers;if(N&&N.length>0)for(const L of N)(0,m.$yI)(L)&&w.push(L.type)}this.u.$registerDebugTypes(w)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const C=[];return this.H.forEach(w=>C.push(w)),C}async $resolveDebugVisualizer(C,w){const b=this.W.get(C);if(!b)throw new Error(`No debug visualizer found with id '${C}'`);let{v:N,provider:L,extensionId:M}=b;if(N.visualization||(N=await L.resolveDebugVisualization?.(N,w)||N,b.v=N),!N.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${L}'`);return this.vb(M,N.visualization)}async $executeDebugVisualizerCommand(C){const w=this.W.get(C);if(!w)throw new Error(`No debug visualizer found with id '${C}'`);const b=w.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(C){const w=this.w.get(C.sessionId);return w&&{session:w.api,variable:C.variable,containerId:C.containerId,frameId:C.frameId,threadId:C.threadId}}async $provideDebugVisualizers(C,w,b,N){const L=this.gb(b),M=this.ub(C,w),z=this.P.get(M);if(!L||!z)return[];const V=await z.provideDebugVisualization(L,N);return V?V.map(F=>{const j=++this.X;this.W.set(j,{v:F,provider:z,extensionId:C});const W=F.iconPath?this.wb(F.iconPath):void 0;return{id:j,name:F.name,iconClass:W?.iconClass,iconPath:W?.iconPath,visualization:this.vb(C,F.visualization)}}):[]}$disposeDebugVisualizers(C){for(const w of C)this.W.delete(w)}registerDebugVisualizationProvider(C,w,b){if(!C.contributes?.debugVisualizers?.some(M=>M.id===w))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${w})`);const N=T.$zn.toKey(C.identifier),L=this.ub(N,w);if(this.P.has(L))throw new Error(`A debug visualization provider with id '${w}' is already registered`);return this.P.set(L,b),this.u.$registerDebugVisualizer(N,w),(0,O.$Xc)(()=>{this.u.$unregisterDebugVisualizer(N,w),this.P.delete(w)})}addBreakpoints(C){const w=C.filter(L=>{const M=L.id;return this.H.has(M)?!1:(this.H.set(M,L),!0)});this.rb(w,[],[]);const b=[],N=new Map;for(const L of w)if(L instanceof f.$hP){let M=N.get(L.location.uri.toString());M||(M={type:"sourceMulti",uri:L.location.uri,lines:[]},N.set(L.location.uri.toString(),M),b.push(M)),M.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character,mode:L.mode})}else L instanceof f.$iP&&b.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName,mode:L.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(C){const w=C.filter(M=>this.H.delete(M.id));this.rb([],w,[]);const b=w.filter(M=>M instanceof f.$hP).map(M=>M.id),N=w.filter(M=>M instanceof f.$iP).map(M=>M.id),L=w.filter(M=>M instanceof f.$jP).map(M=>M.id);return this.u.$unregisterBreakpoints(b,N,L)}startDebugging(C,w,b){const N=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(C?C.uri:void 0,w,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===f.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:N&&{runId:N.runId,taskId:N.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(C){return this.u.$stopDebugging(C?C.id:void 0)}registerDebugConfigurationProvider(C,w,b){if(!w)return new f.$dO(()=>{});const N=this.f++;return this.g.push({type:C,handle:N,provider:w}),this.u.$registerDebugConfigurationProvider(C,b,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,N),new f.$dO(()=>{this.g=this.g.filter(L=>L.provider!==w),this.u.$unregisterDebugConfigurationProvider(N)})}registerDebugAdapterDescriptorFactory(C,w,b){if(!b)return new f.$dO(()=>{});if(!this.nb(C,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.kb(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const N=this.h++;return this.j.push({type:w,handle:N,factory:b}),this.u.$registerDebugAdapterDescriptorFactory(w,N),new f.$dO(()=>{this.j=this.j.filter(L=>L.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(N)})}registerDebugAdapterTrackerFactory(C,w){if(!w)return new f.$dO(()=>{});const b=this.m++;return this.n.push({type:C,handle:b,factory:w}),new f.$dO(()=>{this.n=this.n.filter(N=>N.factory!==w)})}async $runInTerminal(C,w){return Promise.resolve(void 0)}async $substituteVariables(C,w){let b;const N=await this.tb(C);return N&&(b={uri:N.uri,name:N.name,index:N.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,w)}hb(C,w){if(C.type==="implementation")return new k(C.implementation)}ib(){}async $startDASession(C,w){const b=this,N=await this.sb(w);return this.pb(this.kb(N.type),N).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}' (extension might have failed to activate)`);const M=this.jb(L),z=this.hb(M,N);if(!z)throw new Error(`Couldn't create a debug adapter for type '${N.type}'.`);const V=z;return this.M.set(C,V),this.ob(N).then(F=>(F&&this.N.set(C,F),V.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const W=j,J={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const B=await this.U.sign(W.arguments.value);J.body={signature:B},V.sendResponse(J)}else throw new Error("no signer")}catch(B){J.success=!1,J.message=B.message,V.sendResponse(J)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(j),j=(0,m.$DI)(j,!0),b.u.$acceptDAMessage(C,j)}),V.onError(j=>{F&&F.onError&&F.onError(j),this.u.$acceptDAError(C,j.name,j.message,j.stack)}),V.onExit(j=>{F&&F.onExit&&F.onExit(j??void 0,void 0),this.u.$acceptDAExit(C,j??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),V.startSession()))})}$sendDAMessage(C,w){w=(0,m.$CI)(w,!1);const b=this.N.get(C);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(w),this.M.get(C)?.sendMessage(w)}$stopDASession(C){const w=this.N.get(C);this.N.delete(C),w&&w.onWillStopSession&&w.onWillStopSession();const b=this.M.get(C);return this.M.delete(C),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(C){const w=[],b=[],N=[];if(C.added)for(const L of C.added){const M=L.id;if(M&&!this.H.has(M)){let z;if(L.type==="function")z=new f.$iP(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode);else if(L.type==="data")z=new f.$jP(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage,L.mode);else{const V=D.URI.revive(L.uri);z=new f.$hP(new f.$rO(V,new f.$eO(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode)}(0,f.$fP)(z,M),this.H.set(M,z),w.push(z)}}if(C.removed)for(const L of C.removed){const M=this.H.get(L);M&&(this.H.delete(L),b.push(M))}if(C.changed){for(const L of C.changed)if(L.id){const M=this.H.get(L.id);if(M){if(M instanceof f.$iP&&L.type==="function"){const z=M;z.enabled=L.enabled,z.condition=L.condition,z.hitCondition=L.hitCondition,z.logMessage=L.logMessage,z.functionName=L.functionName}else if(M instanceof f.$hP&&L.type==="source"){const z=M;z.enabled=L.enabled,z.condition=L.condition,z.hitCondition=L.hitCondition,z.logMessage=L.logMessage,z.location=new f.$rO(D.URI.revive(L.uri),new f.$eO(L.line,L.character))}N.push(M)}}}this.rb(w,b,N)}async $acceptStackFrameFocus(C){let w;if(C){const b=await this.sb(C.sessionId);C.kind==="thread"?w=new f.$pP(b.api,C.threadId):w=new f.$oP(b.api,C.threadId,C.frameId)}this.J=w,this.L.fire(this.J)}$provideDebugConfigurations(C,w,b){return(0,s.$Ch)(async()=>{const N=this.mb(C);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.tb(w);return N.provideDebugConfigurations(L,b)}).then(N=>{if(!N)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return N})}$resolveDebugConfiguration(C,w,b,N){return(0,s.$Ch)(async()=>{const L=this.mb(C);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.tb(w);return L.resolveDebugConfiguration(M,b,N)})}$resolveDebugConfigurationWithSubstitutedVariables(C,w,b,N){return(0,s.$Ch)(async()=>{const L=this.mb(C);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.tb(w);return L.resolveDebugConfigurationWithSubstitutedVariables(M,b,N)})}async $provideDebugAdapter(C,w){const b=this.lb(C);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const N=await this.sb(w);return this.pb(b,N).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}'`);return this.jb(L)})}async $acceptDebugSessionStarted(C){const w=await this.sb(C);this.y.fire(w.api)}async $acceptDebugSessionTerminated(C){const w=await this.sb(C);w&&(this.z.fire(w.api),this.w.delete(w.id))}async $acceptDebugSessionActiveChanged(C){this.D=C?await this.sb(C):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(C,w){(await this.sb(C))?._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(C,w){const N={session:(await this.sb(C)).api,event:w.event,body:w.body};this.F.fire(N)}jb(C){if(C instanceof f.$kP)return{type:"executable",command:C.command,args:C.args,options:C.options};if(C instanceof f.$lP)return{type:"server",port:C.port,host:C.host};if(C instanceof f.$mP)return{type:"pipeServer",path:C.path};if(C instanceof f.$nP)return{type:"implementation",implementation:C.implementation};throw new Error("convertToDto unexpected type")}kb(C){const w=this.j.filter(b=>b.type===C);if(w.length>0)return w[0].factory}lb(C){const w=this.j.filter(b=>b.handle===C);if(w.length>0)return w[0].factory}mb(C){const w=this.g.filter(b=>b.handle===C);if(w.length>0)return w[0].provider}nb(C,w){if(C.contributes){const b=C.contributes.debuggers;if(b&&b.length>0){for(const N of b)if(N.label&&N.type&&N.type===w)return!0}}return!1}ob(C){const b=C.configuration.type,N=this.n.filter(L=>L.type===b||L.type==="*").map(L=>(0,s.$Ch)(()=>L.factory.createDebugAdapterTracker(C.api)).then(M=>M,M=>null));return Promise.race([Promise.all(N).then(L=>{const M=(0,r.$Lb)(L);if(M.length>0)return new y(M)}),new Promise(L=>setTimeout(()=>L(void 0),1e3))]).catch(L=>{})}async pb(C,w){const b=w.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new f.$lP(b));if(C){const L=await this.Z.getExtensionRegistry();return(0,s.$Ch)(()=>C.createDebugAdapterDescriptor(w.api,this.qb(w,L))).then(M=>{if(M)return M})}const N=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(w,N))}qb(C,w){}rb(C,w,b){(C.length>0||w.length>0||b.length>0)&&this.I.fire(Object.freeze({added:C,removed:w,changed:b}))}async sb(C){if(C)if(typeof C=="string"){const w=this.w.get(C);if(w)return w}else{let w=this.w.get(C.id);if(!w){const b=await this.tb(C.folderUri),N=C.parent?this.w.get(C.parent):void 0;w=new l(this.u,C.id,C.type,C.name,b,C.configuration,N?.api),this.w.set(w.id,w),this.u.$sessionCached(w.id)}return w}throw new Error("cannot find session")}tb(C){if(C){const w=D.URI.revive(C);return this.Y.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}ub(C,w){return`${C}\0${w}`}vb(C,w){if(w){if("title"in w&&"command"in w)return{type:o.DebugVisualizationType.Command};if("treeId"in w)return{type:o.DebugVisualizationType.Tree,id:`${C}\0${w.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(C){const w=this.xb(C);let b,N;return"id"in w?N=i.ThemeIcon.asClassName(w):b=w,{iconPath:b,iconClass:N}}xb(C){if(C instanceof f.$cP)return{id:C.id};const w=typeof C=="object"&&"dark"in C?C.dark:C,b=typeof C=="object"&&"light"in C?C.light:C;return{dark:typeof w=="string"?D.URI.file(w):w,light:typeof b=="string"?D.URI.file(b):b}}};e.$fsc=u,e.$fsc=u=Ye([We(0,E.$OQ),We(1,P.$qrc),We(2,I.$7rc),We(3,$.$trc),We(4,c.$Frc),We(5,d.$0rc),We(6,a.$$Q),We(7,n.$_rc)],u);class l{constructor(C,w,b,N,L,M,z){this.f=C,this.g=w,this.h=b,this.j=N,this.k=L,this.l=M,this.m=z}get api(){const C=this;return this.d??=Object.freeze({id:C.g,type:C.h,get name(){return C.j},set name(w){C.j=w,C.f.$setDebugSessionName(C.g,w)},parentSession:C.m,workspaceFolder:C.k,configuration:C.l,customRequest(w,b){return C.f.$customDebugAdapterRequest(C.g,w,b)},getDebugProtocolBreakpoint(w){return C.f.$getDebugProtocolBreakpoint(C.g,w.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(C){this.j=C}get configuration(){return this.l}}e.$gsc=l;class g{constructor(C){this.value=Object.freeze({append(w){C.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.$hsc=g;class y{constructor(C){this.d=C}onWillStartSession(){this.d.forEach(C=>C.onWillStartSession?C.onWillStartSession():void 0)}onWillReceiveMessage(C){this.d.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(C):void 0)}onDidSendMessage(C){this.d.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(C):void 0)}onWillStopSession(){this.d.forEach(C=>C.onWillStopSession?C.onWillStopSession():void 0)}onError(C){this.d.forEach(w=>w.onError?w.onError(C):void 0)}onExit(C,w){this.d.forEach(b=>b.onExit?b.onExit(C,w):void 0)}}class k extends v.$pwb{constructor(C){super(),this.h=C,C.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(C){this.h.handleMessage(C)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let S=class extends u{constructor(C,w,b,N,L,M,z,V){super(C,w,b,N,L,M,z,V)}};e.$isc=S,e.$isc=S=Ye([We(0,E.$OQ),We(1,P.$qrc),We(2,I.$7rc),We(3,$.$trc),We(4,c.$Frc),We(5,d.$0rc),We(6,a.$$Q),We(7,n.$_rc)],S)}),define(Re[341],Ce([1,0,12,63,2,6,290,11,89,114,29,229,19,74,54,95]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$otc=e.$ntc=void 0,s=Ue(s),h=Ue(h);class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const a=i.get(A.$fk),r=i.get(f.$OQ).getProxy(O.$bO.MainThreadErrors);s.setUnexpectedErrorHandler(n=>{a.error(n);const u=s.$6(n);r.$onUnexpectedError(u)})}static async installFullHandler(i){const a=i.get(A.$fk),t=i.get(f.$OQ),r=i.get(v.$7rc),n=i.get(o.$9Q),u=t.getProxy(O.$bO.MainThreadExtensionService),l=t.getProxy(O.$bO.MainThreadErrors),g=await r.getExtensionPathIndex(),y=new WeakMap;function k(C,w){if(y.has(C))return y.get(C).stack;let b="",N,L;for(const z of w)b+=`
	at ${z.toString()}`,L=z.getFileName(),!N&&L&&(N=g.findSubstr(D.URI.file(L)));const M=`${C.name||"Error"}: ${C.message||""}${b}`;return y.set(C,{extensionIdentifier:N?.identifier,stack:M}),M}const S=Symbol("prepareStackTrace wrapped");let R=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return R},set(C){if(C===k||!C||C[S]){R=C||k;return}R=function(w,b){return k(w,b),C.call(Error,w,b)},Object.assign(R,{[S]:!0})}}),s.setUnexpectedErrorHandler(C=>{a.error(C);const w=s.$6(C),b=y.get(C);if(!b?.extensionIdentifier){l.$onUnexpectedError(w);return}u.$onExtensionRuntimeError(b.extensionIdentifier,w);const N=n.onExtensionError(b.extensionIdentifier,C);a.trace("forwarded error to extension?",N,b)})}}e.$ntc=m;class ${constructor(i,a,t,r,n){this.a=t,this.b=new T.$tfc(i,null,r),a=$.e(a,this.b);const u=new c.$Ii(...(0,p.$3s)());u.set(I.$5Q,{_serviceBrand:void 0,...a,messagePorts:n}),u.set(f.$OQ,new f.$PQ(this.b)),u.set(P.$nrc,new P.$orc(r)),u.set(v.$5rc,t);const l=new E.$Gr(u,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(g=>g.get(A.$fk)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=l.invokeFunction(g=>g.get(v.$7rc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const a=this.b.getProxy(O.$bO.MainThreadExtensionService);return D.URI.revive(await a.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,a){i.extensions.allExtensions.forEach(r=>{r.extensionLocation=D.URI.revive(a.transformIncomingURIs(r.extensionLocation))}),i.environment.appRoot=D.URI.revive(a.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(r=>D.URI.revive(a.transformIncomingURIs(r)))),i.environment.extensionTestsLocationURI=D.URI.revive(a.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=D.URI.revive(a.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=D.URI.revive(a.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=D.URI.revive(a.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=D.URI.revive(a.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=D.URI.revive(a.transformIncomingURIs(i.logsLocation)),i.workspace=a.transformIncomingURIs(i.workspace),i}}e.$otc=$}),define(Re[342],Ce([1,0,8,10,7,222,153,101,79,54,19,49,9,66,42,261,262,43,35,99]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ytc=void 0,h=Ue(h),D=Ue(D);let a=class extends A.$fsc{constructor(l,g,y,k,S,R,C,w,b){super(l,g,y,k,R,C,w,b),this.Ab=S,this.yb=new n}hb(l,g){switch(l.type){case"server":return new o.$ttc(l);case"pipeServer":return new o.$utc(l);case"executable":return new o.$vtc(l,g.type)}return super.hb(l,g)}qb(l,g){const y=o.$vtc.platformAdapterExecutable(g.getAllExtensionDescriptions(),l.type);if(y)return new f.$kP(y.command,y.args,y.options)}ib(){return new T.$sjc}async $runInTerminal(l,g){if(l.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(V=>{this.yb.onTerminalClosed(V)})));const y=await this.$.getConfigProvider(),k=this.Ab.getDefaultShell(!0),S=this.Ab.getDefaultShellArgs(!0),R=l.title||D.localize(2732,null),C=JSON.stringify({shell:k,shellArgs:S});let w=await this.yb.checkout(C,R),b,N=!1;if(w)b=l.cwd;else{const V={shellPath:k,shellArgs:S,cwd:l.cwd,name:R,iconPath:new f.$cP("debug")};N=!0,w=this.Ab.createTerminalFromOptions(V,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(w,C)}w.show(!0);const L=await w.processId;N?await new Promise(V=>setTimeout(V,1e3)):(w.state.isInteractedWith&&(w.sendText(""),await(0,s.$Lh)(200)),y.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0||k.indexOf("cmd.exe")>=0?w.sendText("cls"):k.indexOf("bash")>=0?w.sendText("clear"):h.$l?w.sendText("cls"):w.sendText("clear")));const M=(0,m.$xtc)(k,l.args,!!l.argsCanBeInterpretedByShell,b,l.env);w.sendText(M);const z=this.onDidTerminateDebugSession(V=>{V.id===g&&(this.yb.free(w),z.dispose())});return L}else if(l.kind==="external")return r(l,await this.$.getConfigProvider());return super.$runInTerminal(l,g)}};e.$ytc=a,e.$ytc=a=Ye([We(0,I.$OQ),We(1,v.$qrc),We(2,c.$7rc),We(3,$.$trc),We(4,E.$Rrc),We(5,p.$Frc),We(6,P.$0rc),We(7,d.$$Q),We(8,i.$_rc)],a);let t;function r(u,l){if(!t)if(h.$l)t=new O.$aic;else if(h.$m)t=new O.$bic;else if(h.$n)t=new O.$cic;else throw new Error("external terminals not supported on this platform");const g=l.getConfiguration("terminal");return t.runInTerminal(u.title,u.cwd,u.args,u.env||{},g.external||{})}class n{constructor(){this.b=new Map}static{this.a=1e3}async checkout(l,g,y=!1){const S=[...this.b.entries()].map(([R,C])=>(0,s.$xh)(async w=>{if(R.name!==g||C.lastUsedAt!==-1&&await(0,m.$wtc)(await R.processId))return null;const b=Date.now();return C.lastUsedAt+n.a>b||w.isCancellationRequested?null:C.config!==l?(y&&R.dispose(),null):(C.lastUsedAt=b,R)}));return await(0,s.$Ph)(S,R=>!!R)}insert(l,g){this.b.set(l,{lastUsedAt:Date.now(),config:g})}free(l){const g=this.b.get(l);g&&(g.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}}),define(Re[343],Ce([1,0,16,2,111,42,65,43,48,49,19,29,100,14,11,96,22,69,66]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qtc=void 0,s=Ue(s),m=Ue(m);let i=class extends f.$7sc{constructor(t,r,n,u,l,g,y,k,S){super(t,r,n,u,l,g,y,k),this.C=n,this.D=S,r.remote.isRemote&&r.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:r.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,r){const n=r;if(!r.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const u=f.TaskHandleDTO.from(n,this.C),l=await this.a.$getTaskExecution(u);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const g=await this.z(l,r);return this.a.$executeTask(u).catch(()=>{}),g}else{const u=f.TaskDTO.from(r,t);if(u===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(u.execution)&&await this.y(u,r,!1);const l=await this.z(await this.a.$getTaskExecution(u),r);return this.a.$executeTask(u).catch(()=>{}),l}}v(t,r,n,u){const l=[];if(u)for(const g of u){this.A(g,n),(!g.definition||!t[g.definition.type])&&this.f.warn(`The task [${g.source}, ${g.name}] uses an undefined task type. The task will be ignored in the future.`);const y=f.TaskDTO.from(g,n.extension);y&&(l.push(y),f.CustomExecutionDTO.is(y.execution)&&r.push(this.y(y,g,!0)))}return{tasks:l,extension:n.extension}}async w(t){return t}async G(t){let r=t&&t.length>0?t[0]:void 0;if(!r){const n=h.URI.file((0,$.homedir)());r=new p.$5i({uri:n,name:m.$ih(n),index:0})}return{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,r){const n=h.URI.revive(t),u={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(n),g=await this.b.getWorkspaceFolders2()??[],y=await this.D.getResolver(),k=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(g);for(const S of r.variables)u.variables[S]=await y.resolveAsync(k,S);if(r.process!==void 0){let S;if(r.process.path!==void 0){S=r.process.path.split(s.$yc);for(let R=0;R<S.length;R++)S[R]=await y.resolveAsync(k,S[R])}u.process=await D.win32.findExecutable(await y.resolveAsync(k,r.process.name),r.process.cwd!==void 0?await y.resolveAsync(k,r.process.cwd):void 0,S)}return u}async $jsonTasksSupported(){return!0}async $findExecutable(t,r,n){return D.win32.findExecutable(t,r,n)}};e.$qtc=i,e.$qtc=i=Ye([We(0,I.$OQ),We(1,E.$5Q),We(2,O.$qrc),We(3,T.$ZQ),We(4,A.$trc),We(5,c.$Rrc),We(6,v.$fk),We(7,o.$7qc),We(8,d.$0rc)],i)}),define(Re[344],Ce([1,0,69,66]),function(ge,e,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0tc=void 0;class D extends h.$$rc{m(){return(0,s.homedir)()}}e.$0tc=D}),define(Re[130],Ce([1,0,18,32,59]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zsc=e.$ysc=e.$vsc=void 0,e.$wsc=c,e.$xsc=I,e.$Asc=v;function O(o){return"uri"in o&&"ranges"in o&&"preview"in o}function T(o){return o.folderOptions.map(m=>({folder:m.folder,excludes:m.excludes.map($=>typeof $=="string"?$:$.pattern),includes:m.includes,useGlobalIgnoreFiles:m.useIgnoreFiles.global,useIgnoreFiles:m.useIgnoreFiles.local,useParentIgnoreFiles:m.useIgnoreFiles.parent,followSymlinks:m.followSymlinks,maxResults:o.maxResults,session:o.session}))}class A{constructor(m){this.a=m}provideFileSearchResults(m,$,d){return(async()=>{const a=T($);return Promise.all(a.map(t=>this.a.provideFileSearchResults({pattern:m},t,d)))})().then(a=>(0,s.$Lb)(a).flat())}}e.$vsc=A;function p(o){return o.folderOptions.map(m=>({folder:m.folder,excludes:m.excludes.map($=>typeof $=="string"?$:$.pattern),includes:m.includes,useGlobalIgnoreFiles:m.useIgnoreFiles.global,useIgnoreFiles:m.useIgnoreFiles.local,useParentIgnoreFiles:m.useIgnoreFiles.parent,followSymlinks:m.followSymlinks,maxResults:o.maxResults,previewOptions:c(o.previewOptions),maxFileSize:o.maxFileSize,encoding:m.encoding,afterContext:o.surroundingContext,beforeContext:o.surroundingContext}))}function c(o){return{matchLines:o?.matchLines??h.$UM.matchLines,charsPerLine:o?.charsPerLine??h.$UM.charsPerLine}}function I(o){if(O(o)){const m=(0,s.$6b)(o.ranges).map(($,d)=>{const a=(0,s.$6b)(o.preview.matches)[d];return{sourceRange:$,previewRange:a}});return new D.$pM(o.uri,m,o.preview.text)}else return new D.$qM(o.uri,o.text,o.lineNumber)}class E{constructor(m){this.a=m}provideTextSearchResults(m,$,d,i){const a=n=>{P(n)&&d.report(I(n))};return(async()=>(0,s.$Lb)(await Promise.all(p($).map(n=>this.a.provideTextSearchResults(m,n,{report:u=>a(u)},i)))).reduce((n,u)=>({limitHit:n.limitHit||u.limitHit}),{limitHit:!1}))().then(n=>({limitHit:n.limitHit,message:(0,s.$Lb)((0,s.$6b)(n.message))}))}}e.$ysc=E;class f{constructor(m){this.a=m}provideAITextSearchResults(m,$,d,i){const a=n=>{P(n)&&d.report(I(n))};return(async()=>(0,s.$Lb)(await Promise.all(p($).map(n=>this.a.provideAITextSearchResults(m,n,{report:u=>a(u)},i)))).reduce((n,u)=>({limitHit:n.limitHit||u.limitHit}),{limitHit:!1}))().then(n=>({limitHit:n.limitHit,message:(0,s.$Lb)((0,s.$6b)(n.message))}))}}e.$zsc=f;function P(o){if(v(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}function v(o){return!!o.preview}}),define(Re[345],Ce([1,0,16,20,52,39,22,44,32,62,3,130]),function(ge,e,s,h,D,O,T,A,p,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bsc=void 0,s=Ue(s),O=Ue(O),T=Ue(T);class f{constructor(m,$,d){this.l=m,this.o=$,this.p=d,this.f=!1,this.g=0,this.h=!1,this.a=m.filePattern,this.b=m.includePattern&&O.$Fk(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.j=new Set,this.k=m.excludePattern&&O.$Fk(m.excludePattern)}cancel(){this.h=!0,this.j.forEach(m=>m.cancel()),this.j=new Set}search(m){const $=this.l.folderQueries||[];return new Promise((d,i)=>{const a=t=>{this.g++,m(t)};if(this.h)return d({limitHit:this.f});this.l.extraFileResources&&this.l.extraFileResources.forEach(t=>{const r=t.toString(),n=s.$sc(r);this.k&&this.k(r,n)||this.w(a,{base:t,basename:n})}),this.q($,a).then(t=>{d({limitHit:this.f,stats:t||void 0})},t=>{i(new Error((0,D.$vj)(t)))})})}async q(m,$){const d=new h.$Be,i=m.map(u=>this.r(u)),a=this.o instanceof E.$vsc?this.p?.tokenSource.token:this.p?.obj,t={folderOptions:i,maxResults:this.l.maxResults??p.$wM,session:a},r=c.$Qi.forUris();m.forEach(u=>{const l=new p.$QM(this.l,u),g=!l.hasSiblingExcludeClauses();r.set(u.folder,{queryTester:l,noSiblingsClauses:g,folder:u.folder,tree:this.s()})});let n;try{this.j.add(d),n=A.$ke.create();const u=await this.o.provideFileSearchResults(this.l.filePattern||"",t,d.token),l=n.elapsed(),g=A.$ke.create();return this.h&&!this.f||(u&&u.forEach(y=>{const k=r.findSubstr(y),S=s.$lc.relative(k.folder.path,y.path);if(k.noSiblingsClauses){const R=s.$sc(y.path);this.w($,{base:k.folder,relativePath:S,basename:R});return}this.u(k.tree,k.folder,S,$)}),this.h&&!this.f)?null:(r.forEach(y=>{this.v(y.tree,y.queryTester,$)}),{providerTime:l,postProcessTime:g.elapsed()})}finally{d.dispose(),this.j.delete(d)}}r(m){const $=(0,p.$PM)(this.l.includePattern,m.includePattern);let d=m.excludePattern?.map(a=>({folder:a.folder,patterns:(0,p.$PM)(this.l.excludePattern,a.pattern)}));d?.length||(d=[{folder:void 0,patterns:(0,p.$PM)(this.l.excludePattern,void 0)}]);const i=(0,p.$TM)(d);return{folder:m.folder,excludes:i,includes:$,useIgnoreFiles:{local:!m.disregardIgnoreFiles,parent:!m.disregardParentIgnoreFiles,global:!m.disregardGlobalIgnoreFiles},followSymlinks:!m.ignoreSymlinks}}s(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}u({pathToEntries:m},$,d,i){if(d===this.a){const t=s.$sc(this.a);this.w(i,{base:$,relativePath:this.a,basename:t})}function a(t){const r=s.$sc(t),n=s.$rc(t);let u=m[n];u||(u=m[n]=[],a(n)),u.push({base:$,relativePath:t,basename:r})}a(d)}v({rootEntries:m,pathToEntries:$},d,i){const a=this,t=this.a;function r(n){const u=(0,p.$SM)(()=>n.map(l=>l.basename));for(let l=0,g=n.length;l<g;l++){const y=n[l],{relativePath:k,basename:S}=y;if(d.matchesExcludesSync(k,S,t!==S?u:void 0))continue;const R=$[k];if(R)r(R);else{if(k===t)continue;a.w(i,y)}if(a.f)break}}r(m)}w(m,$){(!this.b||$.relativePath&&this.b($.relativePath,$.basename))&&((this.d||this.c&&this.g>=this.c)&&(this.f=!0,this.cancel()),this.f||m($))}}class P extends I.$Zc{constructor(){super(),this.obj=new Object,this.tokenSource=new h.$Be}dispose(){this.tokenSource.cancel(),super.dispose()}}class v{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,$,d,i){const a=this.c(m.cacheKey),t=new f(m,$,a);let r=0;const n=u=>{r+=u.length,d(u.map(l=>this.d(l)))};return this.f(t,v.a,n,i).then(u=>({limitHit:u.limitHit,stats:u.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:u.stats}:void 0,messages:[]}))}clearCache(m){this.b.get(m)?.dispose(),this.b.delete(m)}c(m){if(m)return this.b.has(m)||this.b.set(m,new P),this.b.get(m)}d(m){return m.relativePath?{resource:T.$lh(m.base,m.relativePath)}:{resource:m.base}}f(m,$,d,i){const a=i.onCancellationRequested(()=>{m.cancel()}),t=n=>{n&&(r.push(n),$>0&&r.length>=$&&(d(r),r=[]))};let r=[];return m.search(t).then(n=>(r.length&&d(r),a.dispose(),n),n=>(r.length&&d(r),a.dispose(),Promise.reject(n)))}}e.$Bsc=v}),define(Re[177],Ce([1,0,8,20,52,14,16,22,62,2,32,59]),function(ge,e,s,h,D,O,T,A,p,c,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Esc=e.$Dsc=e.$Csc=void 0,T=Ue(T),A=Ue(A);class f{constructor(d,i,a){this.f=d,this.g=i,this.h=a,this.b=null,this.c=!1,this.d=0}get j(){return this.f.query}search(d,i){const a=this.j.folderQueries||[],t=new h.$Be(i);return new Promise((r,n)=>{this.b=new v(d);let u=!1;const l=(g,y)=>{if(!u&&!this.c){const k=this.l(g);g instanceof E.$pM&&typeof this.j.maxResults=="number"&&this.d+k>this.j.maxResults&&(this.c=!0,u=!0,t.cancel(),g=this.m(g,this.j.maxResults-this.d));const S=this.l(g);this.d+=S;const R=g instanceof E.$pM;(S>0||!R)&&this.b.add(g,y)}};this.n(a,l,t.token).then(g=>{t.dispose(),this.b.flush(),r({limitHit:this.c||g?.limitHit,messages:this.k(g),stats:{type:this.h}})},g=>{t.dispose();const y=(0,D.$vj)(g);n(new Error(y))})})}k(d){return d?.message?Array.isArray(d.message)?d.message:[d.message]:[]}l(d){return d instanceof E.$pM?Array.isArray(d.ranges)?d.ranges.length:1:0}m(d,i){return new E.$pM(d.uri,d.ranges.slice(0,i),d.previewText)}async n(d,i,a){const t=p.$Qi.forUris();d.forEach((y,k)=>{const S=new I.$QM(this.j,y);t.set(y.folder,{queryTester:S,folder:y.folder,folderIdx:k})});const r=[],n={report:y=>{if(y.uri===void 0)throw Error("Text search result URI is undefined. Please check provider implementation.");const k=t.findSubstr(y.uri),S=k.folder.scheme===O.Schemas.file?(0,I.$RM)(()=>this.g.readdir(A.$kh(y.uri))):void 0,R=A.$nh(k.folder,y.uri);if(R){const C=k.queryTester.includedInQuery(R,T.$sc(R),S);(0,s.$wh)(C)?r.push(C.then(w=>{w&&i(y,k.folderIdx)})):C&&i(y,k.folderIdx)}}},l={folderOptions:d.map(y=>this.o(y)),maxFileSize:this.j.maxFileSize,maxResults:this.j.maxResults??I.$wM,previewOptions:this.j.previewOptions??I.$UM,surroundingContext:this.j.surroundingContext??0};"usePCRE2"in this.j&&(l.usePCRE2=this.j.usePCRE2);let g;return this.f.query.type===I.QueryType.aiText?g=await this.f.provider.provideAITextSearchResults(this.f.query.contentPattern,l,n,a):g=await this.f.provider.provideTextSearchResults(P(this.f.query.contentPattern),l,n,a),r.length&&await Promise.all(r),g}o(d){const i=(0,I.$PM)(this.j.includePattern,d.includePattern);let a=d.excludePattern?.map(n=>({folder:n.folder,patterns:(0,I.$PM)(this.j.excludePattern,n.pattern)}));(!a||a.length===0)&&(a=[{folder:void 0,patterns:(0,I.$PM)(this.j.excludePattern,void 0)}]);const t=(0,I.$TM)(a);return{folder:c.URI.from(d.folder),excludes:t,includes:i,useIgnoreFiles:{local:!d.disregardIgnoreFiles,parent:!d.disregardParentIgnoreFiles,global:!d.disregardGlobalIgnoreFiles},followSymlinks:!d.ignoreSymlinks,encoding:(d.fileEncoding&&this.g.toCanonicalName(d.fileEncoding))??""}}}e.$Csc=f;function P($){return{isCaseSensitive:$.isCaseSensitive||!1,isRegExp:$.isRegExp||!1,isWordMatch:$.isWordMatch||!1,isMultiline:$.isMultiline||!1,pattern:$.pattern}}class v{constructor(d){this.g=d,this.c=-1,this.f=null,this.b=new m(512,i=>this.j(i))}add(d,i){this.f&&(this.c!==i||!A.$eh(this.d,d.uri))&&(this.h(),this.f=null),this.f||(this.c=i,this.f={resource:d.uri,results:[]}),this.f.results.push(o(d))}h(){const d=this.f&&this.f.results?this.f.results.length:0;this.b.addItem(this.f,d)}flush(){this.h(),this.b.flush()}j(d){this.g(d)}}e.$Dsc=v;function o($){return $ instanceof E.$pM?{previewText:$.previewText,rangeLocations:$.ranges.map(d=>({preview:{startLineNumber:d.previewRange.start.line,startColumn:d.previewRange.start.character,endLineNumber:d.previewRange.end.line,endColumn:d.previewRange.end.character},source:{startLineNumber:d.sourceRange.start.line,startColumn:d.sourceRange.start.character,endLineNumber:d.sourceRange.end.line,endColumn:d.sourceRange.end.character}}))}:{text:$.text,lineNumber:$.lineNumber}}class m{static{this.b=4e3}static{this.c=50}constructor(d,i){this.j=d,this.k=i,this.d=0,this.f=[],this.g=0}addItem(d,i){d&&this.l(d,i)}addItems(d,i){d&&this.m(d,i)}l(d,i){this.f.push(d),this.g+=i,this.n()}m(d,i){this.f=this.f.concat(d),this.g+=i,this.n()}n(){this.d<m.c?this.flush():this.g>=this.j?this.flush():this.h||(this.h=setTimeout(()=>{this.flush()},m.b))}flush(){this.g&&(this.d+=this.g,this.k(this.f),this.f=[],this.g=0,this.h&&(clearTimeout(this.h),this.h=0))}}e.$Esc=m}),define(Re[102],Ce([1,0,3,6,5,345,19,74,11,2,177,38,130]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gsc=e.$Fsc=void 0,e.$Hsc=v,e.$Fsc=(0,D.$Ki)("IExtHostSearch");let P=class{constructor($,d,i){this.n=$,this.o=d,this.q=i,this.c=this.n.getProxy(h.$bO.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Bsc}s($){return this.o.transformOutgoingScheme($)}registerTextSearchProviderOld($,d){if(this.g.has($))throw new Error(`a text search provider for the scheme '${$}' is already registered`);this.g.add($);const i=this.d++;return this.e.set(i,new f.$ysc(d)),this.c.$registerTextSearchProvider(i,this.s($)),(0,s.$Xc)(()=>{this.g.delete($),this.e.delete(i),this.c.$unregisterProvider(i)})}registerTextSearchProvider($,d){if(this.g.has($))throw new Error(`a text search provider for the scheme '${$}' is already registered`);this.g.add($);const i=this.d++;return this.e.set(i,d),this.c.$registerTextSearchProvider(i,this.s($)),(0,s.$Xc)(()=>{this.g.delete($),this.e.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProviderOld($,d){if(this.i.has($))throw new Error(`an AI text search provider for the scheme '${$}'is already registered`);this.i.add($);const i=this.d++;return this.h.set(i,new f.$zsc(d)),this.c.$registerAITextSearchProvider(i,this.s($)),(0,s.$Xc)(()=>{this.i.delete($),this.h.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProvider($,d){if(this.i.has($))throw new Error(`an AI text search provider for the scheme '${$}'is already registered`);this.i.add($);const i=this.d++;return this.h.set(i,d),this.c.$registerAITextSearchProvider(i,this.s($)),(0,s.$Xc)(()=>{this.i.delete($),this.h.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProviderOld($,d){if(this.k.has($))throw new Error(`a file search provider for the scheme '${$}' is already registered`);this.k.add($);const i=this.d++;return this.j.set(i,new f.$vsc(d)),this.c.$registerFileSearchProvider(i,this.s($)),(0,s.$Xc)(()=>{this.k.delete($),this.j.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider($,d){if(this.k.has($))throw new Error(`a file search provider for the scheme '${$}' is already registered`);this.k.add($);const i=this.d++;return this.j.set(i,d),this.c.$registerFileSearchProvider(i,this.s($)),(0,s.$Xc)(()=>{this.k.delete($),this.j.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults($,d,i,a){const t=v(i),r=this.j.get($);if(r)return this.l.fileSearch(t,r,n=>{this.c.$handleFileMatch($,d,n.map(u=>u.resource))},a);throw new Error("unknown provider: "+$)}async doInternalFileSearchWithCustomCallback($,d,i){return{messages:[]}}$clearCache($){return this.l.clearCache($),Promise.resolve(void 0)}$provideTextSearchResults($,d,i,a){const t=this.e.get($);if(!t||!t.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${$}`);const r=v(i);return this.t(r,t).search(u=>this.c.$handleTextMatch($,d,u),a)}$provideAITextSearchResults($,d,i,a){const t=this.h.get($);if(!t||!t.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${$}`);const r=v(i);return this.v(r,t).search(u=>this.c.$handleTextMatch($,d,u),a)}$enableExtensionHostSearch(){}t($,d){return new I.$Csc({query:$,provider:d},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}v($,d){return new I.$Csc({query:$,provider:d},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"aiTextSearchProvider")}};e.$Gsc=P,e.$Gsc=P=Ye([We(0,T.$OQ),We(1,A.$nrc),We(2,p.$fk)],P);function v(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(o),extraFileResources:m.extraFileResources&&m.extraFileResources.map($=>c.URI.revive($))}}function o(m){return(0,E.$hi)(m)}});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[346],Ce([1,0,20,12,4,3,14,45,2,113,214,200,56,23,27,11,91,92,249,6,292,319,96,128,296,297,298,277,267,35,299,43,300,101,169,301,279,293,302,303,65,79,280,294,54,304,77,305,64,29,320,281,306,307,129,308,123,124,282,337,310,253,311,321,312,175,283,313,314,315,19,316,102,125,317,284,318,126,98,100,95,49,173,99,322,295,323,324,78,15,9,285,74,286,97,325,326,168,42,120,94,25,59]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t,r,n,u,l,g,y,k,S,R,C,w,b,N,L,M,z,V,F,j,W,J,B,U,_,x,oe,te,me,ce,Y,q,se,be,ae,we,$e,pe,Oe,Fe,He,Ze,xe,je,qe,Ne,H,G,Z,ee,ue,ye,Ae,Ve,Je,nt,ot,ht,at,lt,pt,it,Ie,re,le,Se,de,ke,ne,X,Pe,Ke,Xe,st,dt,gt,kt,At,Kt,ei,tt,Tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$itc=zt,h=Ue(h),A=Ht(A),E=Ue(E),v=Ue(v),ne=Ue(ne),X=Ue(X);function zt(wt){const Rt=wt.get(me.$5Q),ti=wt.get(te.$$qc),ii=wt.get(x.$vrc),Qt=wt.get(U.$7rc),vt=wt.get(At.$qrc),Lt=wt.get(lt.$9Q),ci=wt.get(C.$trc),Zt=wt.get(Ke.$nrc),et=wt.get(ee.$OQ),ni=wt.get(ot.$Orc),li=wt.get(ht.$wrc),hi=wt.get(o.$gk),It=wt.get(o.$fk),Ut=wt.get(ke.$jHb),Nt=wt.get(r.$7qc),Bt=wt.get(kt.$htc),ai=wt.get(Ae.$Yrc),ri=wt.get(W.$Frc),si=wt.get($e.$3rc),Jt=wt.get(n.$erc),Xt=wt.get(be.$Vrc);et.set(i.$cO.ExtHostFileSystemInfo,ti),et.set(i.$cO.ExtHostLogLevelServiceShape,hi),et.set(i.$cO.ExtHostWorkspace,vt),et.set(i.$cO.ExtHostConfiguration,ci),et.set(i.$cO.ExtHostExtensionService,Qt),et.set(i.$cO.ExtHostStorage,ni),et.set(i.$cO.ExtHostTunnelService,Ut),et.set(i.$cO.ExtHostWindow,Bt),et.set(i.$cO.ExtHostSecretState,ai),et.set(i.$cO.ExtHostTelemetry,Lt),et.set(i.$cO.ExtHostEditorTabs,ri),et.set(i.$cO.ExtHostManagedSockets,si),et.set(i.$cO.ExtHostAuthentication,Jt),et.set(i.$cO.ExtHostChatProvider,Xt);const ui=et.set(i.$cO.ExtHostDecorations,wt.get(N.$ksc)),Mt=et.set(i.$cO.ExtHostDocumentsAndEditors,wt.get(j.$ZQ)),Ct=et.set(i.$cO.ExtHostCommands,wt.get(S.$$Q)),yt=et.set(i.$cO.ExtHostTerminalService,wt.get(pt.$Rrc)),Yt=et.set(i.$cO.ExtHostTerminalShellIntegration,wt.get(it.$0sc)),St=et.set(i.$cO.ExtHostDebugService,wt.get(b.$esc)),oi=et.set(i.$cO.ExtHostSearch,wt.get(ye.$Fsc)),xt=et.set(i.$cO.ExtHostTask,wt.get(at.$9sc)),Mi=et.set(i.$cO.ExtHostOutputService,wt.get(qe.$Vsc)),di=et.set(i.$cO.ExtHostLocalization,wt.get(we.$2rc)),yi=et.set(i.$cO.ExtHostUrls,new Xe.$etc(et)),Wt=et.set(i.$cO.ExtHostDocuments,new F.$brc(et,Mt)),fi=et.set(i.$cO.ExtHostDocumentContentProviders,new z.$msc(et,Mt,It)),Fi=et.set(i.$cO.ExtHostDocumentSaveParticipant,new V.$nsc(It,Wt,et.getProxy(i.$bO.MainThreadBulkEdits))),Ot=et.set(i.$cO.ExtHostNotebook,new Oe.$Isc(et,Ct,Mt,Wt,ii,oi,It)),Ei=et.set(i.$cO.ExtHostNotebookDocuments,new He.$Psc(Ot)),Ti=et.set(i.$cO.ExtHostNotebookEditors,new Ze.$Qsc(It,Ot)),gi=et.set(i.$cO.ExtHostNotebookKernels,new xe.$Rsc(et,Rt,Ot,Ct,It)),ji=et.set(i.$cO.ExtHostNotebookRenderers,new je.$Tsc(et,Ot)),Ui=et.set(i.$cO.ExtHostNotebookDocumentSaveParticipant,new Fe.$Osc(It,Ot,et.getProxy(i.$bO.MainThreadBulkEdits))),jt=et.set(i.$cO.ExtHostEditors,new re.$krc(et,Mt)),Pi=et.set(i.$cO.ExtHostTreeViews,new de.$ctc(et.getProxy(i.$bO.MainThreadTreeViews),Ct,It)),Di=et.set(i.$cO.ExtHostEditorInsets,new k.$lrc(et.getProxy(i.$bO.MainThreadEditorInsets),jt,Rt.remote)),bi=et.set(i.$cO.ExtHostDiagnostics,new L.$arc(et,It,ti,Mt)),wi=et.set(i.$cO.ExtHostLanguages,new ae.$Msc(et,Wt,Ct.converter,Zt)),De=et.set(i.$cO.ExtHostLanguageFeatures,new q.$crc(et,Zt,Wt,Ct,bi,It,Nt,Lt)),Me=et.set(i.$cO.ExtHostFileSystem,new _.$qsc(et,De)),ve=et.set(i.$cO.ExtHostFileSystemEventService,new oe.$rsc(et,It,Mt)),ie=et.set(i.$cO.ExtHostQuickOpen,(0,Z.$Zsc)(et,vt,Ct)),Le=et.set(i.$cO.ExtHostSCM,new ue.$2sc(et,Ct,Wt,It)),Qe=et.set(i.$cO.ExtHostQuickDiff,new G.$Ysc(et,Zt)),rt=et.set(i.$cO.ExtHostShare,new Ve.$3sc(et,Zt)),Ge=et.set(i.$cO.ExtHostComments,(0,R.$mrc)(et,Ct,Wt)),ut=et.set(i.$cO.ExtHostProgress,new H.$Xsc(et.getProxy(i.$bO.MainThreadProgress))),$t=et.set(i.$cO.ExtHostLabelService,new Y.$Ksc(et)),Gt=et.set(i.$cO.ExtHostTheming,new le.$_sc(et)),Vt=et.set(i.$cO.ExtHostTimeline,new Se.$btc(et,Ct)),qt=et.set(i.$cO.ExtHostWebviews,new st.$Arc(et,Rt.remote,vt,It,Nt)),Li=et.set(i.$cO.ExtHostWebviewPanels,new dt.$Drc(et,qt,vt)),en=et.set(i.$cO.ExtHostCustomEditors,new w.$Erc(et,Wt,li,qt,Li)),Vi=et.set(i.$cO.ExtHostWebviewViews,new gt.$ftc(et,qt)),Si=et.set(i.$cO.ExtHostTesting,wt.get(Ie.$_rc)),tn=et.set(i.$cO.ExtHostUriOpeners,new Pe.$dtc(et)),nn=et.set(i.$cO.ExtHostProfileContentHandlers,new Ne.$Wsc(et));et.set(i.$cO.ExtHostInteractive,new ce.$Jsc(et,Ot,Mt,Ct,It));const zi=et.set(i.$cO.ExtHostChatAgents2,new l.$hrc(et,It,Ct,Wt)),rn=et.set(i.$cO.ExtHostChatVariables,new g.$irc(et)),Bi=et.set(i.$cO.ExtHostLanguageModelTools,new se.$Lsc(et)),Hi=et.set(i.$cO.ExtHostAiRelatedInformation,new a.$6qc(et)),sn=et.set(i.$cO.ExtHostAiEmbeddingVector,new B.$psc(et)),on=et.set(i.$cO.ExtHostStatusBar,new nt.$6sc(et,Ct.converter)),bn=et.set(i.$cO.ExtHostSpeech,new Je.$4sc(et)),Ri=et.set(i.$cO.ExtHostEmbeddings,new J.$osc(et)),Ki=Object.values(i.$cO);et.assertRegistered(Ki);const wn=new u.$grc(et,Mt),vn=new y.$jrc(et),qi=new pe.$Nsc(et,It),an=new M.$lsc(et);return t.$drc.register(Ct),function(Be,mi,Gi){function ft(he){return(Ee,ze,mt)=>{const Dt=he(Ft=>{try{Ee.call(ze,Ft)}catch(Oi){h.$5(new Error(`[ExtensionListenerError] Extension '${Be.identifier.value}' FAILED to handle event: ${Oi.toString()}`,{cause:Oi})),Lt.onExtensionError(Be.identifier,Oi)}});return mt?.push(Dt),Dt}}const Pt=function(){let he=!Be.isUnderDevelopment;function Ee(){he||(It.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),he=!0)}return function ze(mt){if(Array.isArray(mt))mt.forEach(ze);else if(typeof mt=="string")Ee();else{const Dt=mt;typeof Dt.scheme>"u"&&Ee(),typeof Dt.exclusive=="boolean"&&(0,tt.$DH)(Be,"documentFiltersExclusive")}return mt}}(),yn={getSession(he,Ee,ze){return typeof ze?.forceNewSession=="object"&&ze.forceNewSession.learnMore&&(0,tt.$DH)(Be,"authLearnMore"),Jt.getSession(Be,he,Ee,ze)},getAccounts(he){return Jt.getAccounts(he)},async hasSession(he,Ee){return(0,tt.$DH)(Be,"authSession"),!!await Jt.getSession(Be,he,Ee,{silent:!0})},get onDidChangeSessions(){return ft(Jt.onDidChangeSessions)},registerAuthenticationProvider(he,Ee,ze,mt){return Jt.registerAuthenticationProvider(he,Ee,ze,mt)}},Qi={registerCommand(he,Ee,ze){return Ct.registerCommand(!0,he,Ee,ze,void 0,Be)},registerTextEditorCommand(he,Ee,ze){return Ct.registerCommand(!0,he,(...mt)=>{const Dt=jt.getActiveTextEditor();if(!Dt){It.warn("Cannot execute "+he+" because there is no active text editor.");return}return Dt.edit(Ft=>{Ee.apply(ze,[Dt,Ft,...mt])}).then(Ft=>{Ft||It.warn("Edits from command "+he+" were not applied.")},Ft=>{It.warn("An error occurred while running command "+he,Ft)})},void 0,void 0,Be)},registerDiffInformationCommand:(he,Ee,ze)=>((0,tt.$DH)(Be,"diffCommand"),Ct.registerCommand(!0,he,async(...mt)=>{const Dt=Mt.activeEditor(!0);if(!Dt){It.warn("Cannot execute "+he+" because there is no active text editor.");return}const Ft=await jt.getDiffInformation(Dt.id);Ee.apply(ze,[Ft,...mt])},void 0,void 0,Be)),executeCommand(he,...Ee){return Ct.executeCommand(he,...Ee)},getCommands(he=!1){return Ct.getCommands(he)}},Ji={get machineId(){return Rt.telemetryInfo.machineId},get sessionId(){return Rt.telemetryInfo.sessionId},get language(){return Rt.environment.appLanguage},get appName(){return Rt.environment.appName},get appRoot(){return Rt.environment.appRoot?.fsPath??""},get appHost(){return Rt.environment.appHost},get uriScheme(){return Rt.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return yt.getDefaultShell(!1)},get onDidChangeShell(){return ft(yt.onDidChangeShell)},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ft(Lt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,tt.$DH)(Be,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$DH)(Be,"telemetry"),ft(Lt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,lt.$8Q)(Rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(he,Ee){return lt.$7Q.validateSender(he),Lt.instantiateLogger(Be,he,Ee)},openExternal(he,Ee){return Bt.openUri(he,{allowTunneling:!!Rt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(he){if(he.scheme===Rt.environment.appUriScheme)return yi.createAppUri(he);try{return await Bt.asExternalUri(he,{allowTunneling:!!Rt.remote.authority})}catch(Ee){if((0,T.$Tg)(he,T.Schemas.http)||(0,T.$Tg)(he,T.Schemas.https))return he;throw Ee}},get remoteName(){return(0,m.$qn)(Rt.remote.authority)},get remoteAuthority(){return(0,tt.$DH)(Be,"resolvers"),Rt.remote.authority},get uiKind(){return Rt.uiKind},get logLevel(){return It.getLevel()},get onDidChangeLogLevel(){return ft(It.onDidChangeLogLevel)},get appQuality(){return(0,tt.$DH)(Be,"resolvers"),Rt.quality},get appCommit(){return(0,tt.$DH)(Be,"resolvers"),Rt.commit}};Rt.environment.extensionTestsLocationURI||Object.freeze(Ji);const ki={createTestController(he,Ee,ze){return Si.createTestController(Be,he,Ee,ze)},createTestObserver(){return(0,tt.$DH)(Be,"testObserver"),Si.createTestObserver()},runTests(he){return(0,tt.$DH)(Be,"testObserver"),Si.runTests(he)},registerTestFollowupProvider(he){return(0,tt.$DH)(Be,"testObserver"),Si.registerTestFollowupProvider(he)},get onDidChangeTestResults(){return(0,tt.$DH)(Be,"testObserver"),ft(Si.onResultsChanged)},get testResults(){return(0,tt.$DH)(Be,"testObserver"),Si.results}},Ci=Rt.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,En={getExtension(he,Ee){(0,tt.$CH)(Be,"extensionsAny")||(Ee=!1);const ze=mi.mine.getExtensionDescription(he);if(ze)return new U.$8rc(Qt,Be.identifier,ze,Ci,!1);if(Ee){const mt=mi.all.getExtensionDescription(he);if(mt)return new U.$8rc(Qt,Be.identifier,mt,Ci,!0)}},get all(){const he=[];for(const Ee of mi.mine.getAllExtensionDescriptions())he.push(new U.$8rc(Qt,Be.identifier,Ee,Ci,!1));return he},get allAcrossExtensionHosts(){(0,tt.$DH)(Be,"extensionsAny");const he=new P.$An(mi.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),Ee=[];for(const ze of mi.all.getAllExtensionDescriptions()){const mt=!he.has(ze.identifier);Ee.push(new U.$8rc(Qt,Be.identifier,ze,Ci,mt))}return Ee},get onDidChange(){return(0,tt.$CH)(Be,"extensionsAny")?ft(D.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):ft(mi.mine.onDidChange)}},$i={createDiagnosticCollection(he){return bi.createDiagnosticCollection(Be.identifier,he)},get onDidChangeDiagnostics(){return ft(bi.onDidChangeDiagnostics)},getDiagnostics:he=>bi.getDiagnostics(he),getLanguages(){return wi.getLanguages()},setTextDocumentLanguage(he,Ee){return wi.changeLanguage(he.uri,Ee)},match(he,Ee){const ze=ne.LanguageSelector.from(he);let mt;return(0,I.$Hu)(ze)&&(mt=Ot.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Ft=>Ft.document===Ee))?.apiNotebook),(0,I.$Gu)(ze,Ee.uri,Ee.languageId,!0,mt?.uri,mt?.notebookType)},registerCodeActionsProvider(he,Ee,ze){return De.registerCodeActionProvider(Be,Pt(he),Ee,ze)},registerDocumentPasteEditProvider(he,Ee,ze){return(0,tt.$DH)(Be,"documentPaste"),De.registerDocumentPasteEditProvider(Be,Pt(he),Ee,ze)},registerCodeLensProvider(he,Ee){return De.registerCodeLensProvider(Be,Pt(he),Ee)},registerDefinitionProvider(he,Ee){return De.registerDefinitionProvider(Be,Pt(he),Ee)},registerDeclarationProvider(he,Ee){return De.registerDeclarationProvider(Be,Pt(he),Ee)},registerImplementationProvider(he,Ee){return De.registerImplementationProvider(Be,Pt(he),Ee)},registerTypeDefinitionProvider(he,Ee){return De.registerTypeDefinitionProvider(Be,Pt(he),Ee)},registerHoverProvider(he,Ee){return De.registerHoverProvider(Be,Pt(he),Ee,Be.identifier)},registerEvaluatableExpressionProvider(he,Ee){return De.registerEvaluatableExpressionProvider(Be,Pt(he),Ee,Be.identifier)},registerInlineValuesProvider(he,Ee){return De.registerInlineValuesProvider(Be,Pt(he),Ee,Be.identifier)},registerDocumentHighlightProvider(he,Ee){return De.registerDocumentHighlightProvider(Be,Pt(he),Ee)},registerMultiDocumentHighlightProvider(he,Ee){return De.registerMultiDocumentHighlightProvider(Be,Pt(he),Ee)},registerLinkedEditingRangeProvider(he,Ee){return De.registerLinkedEditingRangeProvider(Be,Pt(he),Ee)},registerReferenceProvider(he,Ee){return De.registerReferenceProvider(Be,Pt(he),Ee)},registerRenameProvider(he,Ee){return De.registerRenameProvider(Be,Pt(he),Ee)},registerNewSymbolNamesProvider(he,Ee){return(0,tt.$DH)(Be,"newSymbolNamesProvider"),De.registerNewSymbolNamesProvider(Be,Pt(he),Ee)},registerDocumentSymbolProvider(he,Ee,ze){return De.registerDocumentSymbolProvider(Be,Pt(he),Ee,ze)},registerWorkspaceSymbolProvider(he){return De.registerWorkspaceSymbolProvider(Be,he)},registerDocumentFormattingEditProvider(he,Ee){return De.registerDocumentFormattingEditProvider(Be,Pt(he),Ee)},registerDocumentRangeFormattingEditProvider(he,Ee){return De.registerDocumentRangeFormattingEditProvider(Be,Pt(he),Ee)},registerOnTypeFormattingEditProvider(he,Ee,ze,...mt){return De.registerOnTypeFormattingEditProvider(Be,Pt(he),Ee,[ze].concat(mt))},registerDocumentSemanticTokensProvider(he,Ee,ze){return De.registerDocumentSemanticTokensProvider(Be,Pt(he),Ee,ze)},registerDocumentRangeSemanticTokensProvider(he,Ee,ze){return De.registerDocumentRangeSemanticTokensProvider(Be,Pt(he),Ee,ze)},registerSignatureHelpProvider(he,Ee,ze,...mt){return typeof ze=="object"?De.registerSignatureHelpProvider(Be,Pt(he),Ee,ze):De.registerSignatureHelpProvider(Be,Pt(he),Ee,typeof ze>"u"?[]:[ze,...mt])},registerCompletionItemProvider(he,Ee,...ze){return De.registerCompletionItemProvider(Be,Pt(he),Ee,ze)},registerInlineCompletionItemProvider(he,Ee,ze){return Ee.handleDidShowCompletionItem&&(0,tt.$DH)(Be,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,tt.$DH)(Be,"inlineCompletionsAdditions"),ze&&(0,tt.$DH)(Be,"inlineCompletionsAdditions"),De.registerInlineCompletionsProvider(Be,Pt(he),Ee,ze)},registerInlineEditProvider(he,Ee){return(0,tt.$DH)(Be,"inlineEdit"),De.registerInlineEditProvider(Be,Pt(he),Ee)},registerDocumentLinkProvider(he,Ee){return De.registerDocumentLinkProvider(Be,Pt(he),Ee)},registerColorProvider(he,Ee){return De.registerColorProvider(Be,Pt(he),Ee)},registerFoldingRangeProvider(he,Ee){return De.registerFoldingRangeProvider(Be,Pt(he),Ee)},registerSelectionRangeProvider(he,Ee){return De.registerSelectionRangeProvider(Be,he,Ee)},registerCallHierarchyProvider(he,Ee){return De.registerCallHierarchyProvider(Be,he,Ee)},registerTypeHierarchyProvider(he,Ee){return De.registerTypeHierarchyProvider(Be,he,Ee)},setLanguageConfiguration:(he,Ee)=>De.setLanguageConfiguration(Be,he,Ee),getTokenInformationAtPosition(he,Ee){return(0,tt.$DH)(Be,"tokenInformation"),wi.tokenAtPosition(he,Ee)},registerInlayHintsProvider(he,Ee){return De.registerInlayHintsProvider(Be,he,Ee)},createLanguageStatusItem(he,Ee){return wi.createLanguageStatusItem(Be,he,Ee)},registerDocumentDropEditProvider(he,Ee,ze){return De.registerDocumentOnDropEditProvider(Be,he,Ee,(0,tt.$CH)(Be,"documentPaste")?ze:void 0)}},Wi={get activeTextEditor(){return jt.getActiveTextEditor()},get visibleTextEditors(){return jt.getVisibleTextEditors()},get activeTerminal(){return yt.activeTerminal},get terminals(){return yt.terminals},async showTextDocument(he,Ee,ze){p.URI.isUri(he)&&he.scheme===T.Schemas.vscodeRemote&&!he.authority&&Nt.report("workspace.showTextDocument",Be,"A URI of 'vscode-remote' scheme requires an authority.");const mt=await(p.URI.isUri(he)?Promise.resolve(Xi.openTextDocument(he)):Promise.resolve(he));return jt.showTextDocument(mt,Ee,ze)},createTextEditorDecorationType(he){return jt.createTextEditorDecorationType(Be,he)},onDidChangeActiveTextEditor(he,Ee,ze){return ft(jt.onDidChangeActiveTextEditor)(he,Ee,ze)},onDidChangeVisibleTextEditors(he,Ee,ze){return ft(jt.onDidChangeVisibleTextEditors)(he,Ee,ze)},onDidChangeTextEditorSelection(he,Ee,ze){return ft(jt.onDidChangeTextEditorSelection)(he,Ee,ze)},onDidChangeTextEditorOptions(he,Ee,ze){return ft(jt.onDidChangeTextEditorOptions)(he,Ee,ze)},onDidChangeTextEditorVisibleRanges(he,Ee,ze){return ft(jt.onDidChangeTextEditorVisibleRanges)(he,Ee,ze)},onDidChangeTextEditorViewColumn(he,Ee,ze){return ft(jt.onDidChangeTextEditorViewColumn)(he,Ee,ze)},onDidCloseTerminal(he,Ee,ze){return ft(yt.onDidCloseTerminal)(he,Ee,ze)},onDidOpenTerminal(he,Ee,ze){return ft(yt.onDidOpenTerminal)(he,Ee,ze)},onDidChangeActiveTerminal(he,Ee,ze){return ft(yt.onDidChangeActiveTerminal)(he,Ee,ze)},onDidChangeTerminalDimensions(he,Ee,ze){return(0,tt.$DH)(Be,"terminalDimensions"),ft(yt.onDidChangeTerminalDimensions)(he,Ee,ze)},onDidChangeTerminalState(he,Ee,ze){return ft(yt.onDidChangeTerminalState)(he,Ee,ze)},onDidWriteTerminalData(he,Ee,ze){return(0,tt.$DH)(Be,"terminalDataWriteEvent"),ft(yt.onDidWriteTerminalData)(he,Ee,ze)},onDidExecuteTerminalCommand(he,Ee,ze){return(0,tt.$DH)(Be,"terminalExecuteCommandEvent"),ft(yt.onDidExecuteTerminalCommand)(he,Ee,ze)},onDidChangeTerminalShellIntegration(he,Ee,ze){return ft(Yt.onDidChangeTerminalShellIntegration)(he,Ee,ze)},onDidStartTerminalShellExecution(he,Ee,ze){return ft(Yt.onDidStartTerminalShellExecution)(he,Ee,ze)},onDidEndTerminalShellExecution(he,Ee,ze){return ft(Yt.onDidEndTerminalShellExecution)(he,Ee,ze)},get state(){return Bt.getState()},onDidChangeWindowState(he,Ee,ze){return ft(Bt.onDidChangeWindowState)(he,Ee,ze)},showInformationMessage(he,...Ee){return qi.showMessage(Be,A.default.Info,he,Ee[0],Ee.slice(1))},showWarningMessage(he,...Ee){return qi.showMessage(Be,A.default.Warning,he,Ee[0],Ee.slice(1))},showErrorMessage(he,...Ee){return qi.showMessage(Be,A.default.Error,he,Ee[0],Ee.slice(1))},showQuickPick(he,Ee,ze){return ie.showQuickPick(Be,he,Ee,ze)},showWorkspaceFolderPick(he){return ie.showWorkspaceFolderPick(he)},showInputBox(he,Ee){return ie.showInput(he,Ee)},showOpenDialog(he){return an.showOpenDialog(Be,he)},showSaveDialog(he){return an.showSaveDialog(he)},createStatusBarItem(he,Ee,ze){let mt,Dt,Ft;return typeof he=="string"?(mt=he,Dt=Ee,Ft=ze):(Dt=he,Ft=Ee),on.createStatusBarEntry(Be,mt,Dt,Ft)},setStatusBarMessage(he,Ee){return on.setStatusBarMessage(he,Ee)},withScmProgress(he){return Nt.report("window.withScmProgress",Be,"Use 'withProgress' instead."),ut.withProgress(Be,{location:X.ProgressLocation.SourceControl},(Ee,ze)=>he({report(mt){}}))},withProgress(he,Ee){return ut.withProgress(Be,he,Ee)},createOutputChannel(he,Ee){return Mi.createOutputChannel(he,Ee,Be)},createWebviewPanel(he,Ee,ze,mt){return Li.createWebviewPanel(Be,he,Ee,ze,mt)},createWebviewTextEditorInset(he,Ee,ze,mt){return(0,tt.$DH)(Be,"editorInsets"),Di.createWebviewEditorInset(he,Ee,ze,mt,Be)},createTerminal(he,Ee,ze){return typeof he=="object"?"pty"in he?yt.createExtensionTerminal(he):yt.createTerminalFromOptions(he):yt.createTerminal(he,Ee,ze)},registerTerminalLinkProvider(he){return yt.registerLinkProvider(he)},registerTerminalProfileProvider(he,Ee){return yt.registerProfileProvider(Be,he,Ee)},registerTerminalQuickFixProvider(he,Ee){return(0,tt.$DH)(Be,"terminalQuickFixProvider"),yt.registerTerminalQuickFixProvider(he,Be.identifier.value,Ee)},registerTreeDataProvider(he,Ee){return Pi.registerTreeDataProvider(he,Ee,Be)},createTreeView(he,Ee){return Pi.createTreeView(he,Ee,Be)},registerWebviewPanelSerializer:(he,Ee)=>Li.registerWebviewPanelSerializer(Be,he,Ee),registerCustomEditorProvider:(he,Ee,ze={})=>en.registerCustomEditorProvider(Be,he,Ee,ze),registerFileDecorationProvider(he){return ui.registerFileDecorationProvider(he,Be)},registerUriHandler(he){return yi.registerUriHandler(Be,he)},createQuickPick(){return ie.createQuickPick(Be)},createInputBox(){return ie.createInputBox(Be)},get activeColorTheme(){return Gt.activeColorTheme},onDidChangeActiveColorTheme(he,Ee,ze){return ft(Gt.onDidChangeActiveColorTheme)(he,Ee,ze)},registerWebviewViewProvider(he,Ee,ze){return Vi.registerWebviewViewProvider(Be,he,Ee,ze?.webviewOptions)},get activeNotebookEditor(){return Ot.activeNotebookEditor},onDidChangeActiveNotebookEditor(he,Ee,ze){return ft(Ot.onDidChangeActiveNotebookEditor)(he,Ee,ze)},get visibleNotebookEditors(){return Ot.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ft(Ot.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(he,Ee,ze){return ft(Ti.onDidChangeNotebookEditorSelection)(he,Ee,ze)},onDidChangeNotebookEditorVisibleRanges(he,Ee,ze){return ft(Ti.onDidChangeNotebookEditorVisibleRanges)(he,Ee,ze)},showNotebookDocument(he,Ee){return Ot.showNotebookDocument(he,Ee)},registerExternalUriOpener(he,Ee,ze){return(0,tt.$DH)(Be,"externalUriOpener"),tn.registerExternalUriOpener(Be.identifier,he,Ee,ze)},registerProfileContentHandler(he,Ee){return(0,tt.$DH)(Be,"profileContentHandlers"),nn.registerProfileContentHandler(Be,he,Ee)},registerQuickDiffProvider(he,Ee,ze,mt){return(0,tt.$DH)(Be,"quickDiffProvider"),Qe.registerQuickDiffProvider(Pt(he),Ee,ze,mt)},get tabGroups(){return ri.tabGroups},registerShareProvider(he,Ee){return(0,tt.$DH)(Be,"shareProvider"),rt.registerShareProvider(Pt(he),Ee)}},Xi={get rootPath(){return Nt.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),vt.getPath()},set rootPath(he){throw new h.$ab("rootPath")},getWorkspaceFolder(he){return vt.getWorkspaceFolder(he)},get workspaceFolders(){return vt.getWorkspaceFolders()},get name(){return vt.name},set name(he){throw new h.$ab("name")},get workspaceFile(){return vt.workspaceFile},set workspaceFile(he){throw new h.$ab("workspaceFile")},updateWorkspaceFolders:(he,Ee,...ze)=>vt.updateWorkspaceFolders(Be,he,Ee||0,...ze),onDidChangeWorkspaceFolders:function(he,Ee,ze){return ft(vt.onDidChangeWorkspace)(he,Ee,ze)},asRelativePath:(he,Ee)=>vt.getRelativePath(he,Ee),findFiles:(he,Ee,ze,mt)=>vt.findFiles(he,Ee,ze,Be.identifier,mt),findFiles2:(he,Ee,ze)=>((0,tt.$DH)(Be,"findFiles2"),vt.findFiles2(he,Ee,Be.identifier,ze)),findFiles2New:(he,Ee,ze)=>((0,tt.$DH)(Be,"findFiles2New"),vt.findFiles2New(he,Ee,Be.identifier,ze)),findTextInFiles:(he,Ee,ze,mt)=>{(0,tt.$DH)(Be,"findTextInFiles");let Dt,Ft;return typeof Ee=="object"?(Dt=Ee,Ft=ze):(Dt={},Ft=Ee,mt=ze),vt.findTextInFiles(he,Dt||{},Ft,Be.identifier,mt)},findTextInFilesNew:(he,Ee,ze)=>((0,tt.$DH)(Be,"findTextInFilesNew"),(0,tt.$DH)(Be,"textSearchProviderNew"),vt.findTextInFilesNew(he,Be.identifier,Ee||{},ze)),save:he=>vt.save(he),saveAs:he=>vt.saveAs(he),saveAll:he=>vt.saveAll(he),applyEdit(he,Ee){return wn.applyWorkspaceEdit(he,Be,Ee)},createFileSystemWatcher:(he,Ee,ze,mt)=>{let Dt;return typeof Ee=="boolean"?Dt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!mt,correlate:!1}:Ee&&((0,tt.$DH)(Be,"createFileSystemWatcher"),Dt={...Ee,correlate:!0}),ve.createFileSystemWatcher(vt,Be,he,Dt)},get textDocuments(){return Wt.getAllDocumentData().map(he=>he.document)},set textDocuments(he){throw new h.$ab("textDocuments")},openTextDocument(he){let Ee;const ze=he;if(typeof he=="string")Ee=Promise.resolve(p.URI.file(he));else if(p.URI.isUri(he))Ee=Promise.resolve(he);else if(!ze||typeof ze=="object")Ee=Wt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(mt=>(It.trace(`openTextDocument from ${Be.identifier}`),mt.scheme===T.Schemas.vscodeRemote&&!mt.authority&&Nt.report("workspace.openTextDocument",Be,"A URI of 'vscode-remote' scheme requires an authority."),Wt.ensureDocumentData(mt).then(Dt=>Dt.document)))},onDidOpenTextDocument:(he,Ee,ze)=>ft(Wt.onDidAddDocument)(he,Ee,ze),onDidCloseTextDocument:(he,Ee,ze)=>ft(Wt.onDidRemoveDocument)(he,Ee,ze),onDidChangeTextDocument:(he,Ee,ze)=>ft(Wt.onDidChangeDocument)(he,Ee,ze),onDidSaveTextDocument:(he,Ee,ze)=>ft(Wt.onDidSaveDocument)(he,Ee,ze),onWillSaveTextDocument:(he,Ee,ze)=>ft(Fi.getOnWillSaveTextDocumentEvent(Be))(he,Ee,ze),get notebookDocuments(){return Ot.notebookDocuments.map(he=>he.apiNotebook)},async openNotebookDocument(he,Ee){let ze;if(p.URI.isUri(he))ze=he,await Ot.openNotebookDocument(he);else if(typeof he=="string")ze=p.URI.revive(await Ot.createNotebookDocument({viewType:he,content:Ee}));else throw new Error("Invalid arguments");return Ot.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(he,Ee,ze){return ft(Ei.onDidSaveNotebookDocument)(he,Ee,ze)},onDidChangeNotebookDocument(he,Ee,ze){return ft(Ei.onDidChangeNotebookDocument)(he,Ee,ze)},onWillSaveNotebookDocument(he,Ee,ze){return ft(Ui.getOnWillSaveNotebookDocumentEvent(Be))(he,Ee,ze)},get onDidOpenNotebookDocument(){return ft(Ot.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ft(Ot.onDidCloseNotebookDocument)},registerNotebookSerializer(he,Ee,ze,mt){return Ot.registerNotebookSerializer(Be,he,Ee,ze,(0,tt.$CH)(Be,"notebookLiveShare")?mt:void 0)},onDidChangeConfiguration:(he,Ee,ze)=>ft(Gi.onDidChangeConfiguration)(he,Ee,ze),getConfiguration(he,Ee){return Ee=arguments.length===1?void 0:Ee,Gi.getConfiguration(he,Ee,Be)},registerTextDocumentContentProvider(he,Ee){return fi.registerTextDocumentContentProvider(he,Ee)},registerTaskProvider:(he,Ee)=>(Nt.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),xt.registerTaskProvider(Be,he,Ee)),registerFileSystemProvider(he,Ee,ze){return(0,O.$Wc)(Me.registerFileSystemProvider(Be,he,Ee,ze),ii.addFileSystemProvider(he,Ee,ze))},get fs(){return ii.value},registerFileSearchProvider:(he,Ee)=>((0,tt.$DH)(Be,"fileSearchProvider"),oi.registerFileSearchProviderOld(he,Ee)),registerTextSearchProvider:(he,Ee)=>((0,tt.$DH)(Be,"textSearchProvider"),oi.registerTextSearchProviderOld(he,Ee)),registerAITextSearchProvider:(he,Ee)=>((0,tt.$DH)(Be,"aiTextSearchProvider"),(0,tt.$DH)(Be,"textSearchProvider"),oi.registerAITextSearchProviderOld(he,Ee)),registerFileSearchProviderNew:(he,Ee)=>((0,tt.$DH)(Be,"fileSearchProviderNew"),oi.registerFileSearchProvider(he,Ee)),registerTextSearchProviderNew:(he,Ee)=>((0,tt.$DH)(Be,"textSearchProviderNew"),oi.registerTextSearchProvider(he,Ee)),registerAITextSearchProviderNew:(he,Ee)=>((0,tt.$DH)(Be,"aiTextSearchProviderNew"),(0,tt.$DH)(Be,"textSearchProviderNew"),oi.registerAITextSearchProvider(he,Ee)),registerRemoteAuthorityResolver:(he,Ee)=>((0,tt.$DH)(Be,"resolvers"),Qt.registerRemoteAuthorityResolver(he,Ee)),registerResourceLabelFormatter:he=>((0,tt.$DH)(Be,"resolvers"),$t.$registerResourceLabelFormatter(he)),getRemoteExecServer:he=>((0,tt.$DH)(Be,"resolvers"),Qt.getRemoteExecServer(he)),onDidCreateFiles:(he,Ee,ze)=>ft(ve.onDidCreateFile)(he,Ee,ze),onDidDeleteFiles:(he,Ee,ze)=>ft(ve.onDidDeleteFile)(he,Ee,ze),onDidRenameFiles:(he,Ee,ze)=>ft(ve.onDidRenameFile)(he,Ee,ze),onWillCreateFiles:(he,Ee,ze)=>ft(ve.getOnWillCreateFileEvent(Be))(he,Ee,ze),onWillDeleteFiles:(he,Ee,ze)=>ft(ve.getOnWillDeleteFileEvent(Be))(he,Ee,ze),onWillRenameFiles:(he,Ee,ze)=>ft(ve.getOnWillRenameFileEvent(Be))(he,Ee,ze),openTunnel:he=>((0,tt.$DH)(Be,"tunnels"),Ut.openTunnel(Be,he).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,tt.$DH)(Be,"tunnels"),Ut.getTunnels()},onDidChangeTunnels:(he,Ee,ze)=>((0,tt.$DH)(Be,"tunnels"),ft(Ut.onDidChangeTunnels)(he,Ee,ze)),registerPortAttributesProvider:(he,Ee)=>((0,tt.$DH)(Be,"portsAttributes"),Ut.registerPortsAttributesProvider(he,Ee)),registerTunnelProvider:(he,Ee)=>((0,tt.$DH)(Be,"tunnelFactory"),Ut.registerTunnelProvider(he,Ee)),registerTimelineProvider:(he,Ee)=>((0,tt.$DH)(Be,"timeline"),Vt.registerTimelineProvider(he,Ee,Be.identifier,Ct.converter)),get isTrusted(){return vt.trusted},requestWorkspaceTrust:he=>((0,tt.$DH)(Be,"workspaceTrust"),vt.requestWorkspaceTrust(he)),onDidGrantWorkspaceTrust:(he,Ee,ze)=>ft(vt.onDidGrantWorkspaceTrust)(he,Ee,ze),registerEditSessionIdentityProvider:(he,Ee)=>((0,tt.$DH)(Be,"editSessionIdentityProvider"),vt.registerEditSessionIdentityProvider(he,Ee)),onWillCreateEditSessionIdentity:(he,Ee,ze)=>((0,tt.$DH)(Be,"editSessionIdentityProvider"),ft(vt.getOnWillCreateEditSessionIdentityEvent(Be))(he,Ee,ze)),registerCanonicalUriProvider:(he,Ee)=>((0,tt.$DH)(Be,"canonicalUriProvider"),vt.registerCanonicalUriProvider(he,Ee)),getCanonicalUri:(he,Ee,ze)=>((0,tt.$DH)(Be,"canonicalUriProvider"),vt.provideCanonicalUri(he,Ee,ze))},cn={get inputBox(){return Nt.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),Le.getLastInputBox(Be)},createSourceControl(he,Ee,ze){return Le.createSourceControl(Be,he,Ee,ze)}},ln={createCommentController(he,Ee){return Ge.createCommentController(Be,he,Ee)}},un={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get activeStackItem(){return St.activeStackItem},registerDebugVisualizationProvider(he,Ee){return(0,tt.$DH)(Be,"debugVisualization"),St.registerDebugVisualizationProvider(Be,he,Ee)},registerDebugVisualizationTreeProvider(he,Ee){return(0,tt.$DH)(Be,"debugVisualization"),St.registerDebugVisualizationTree(Be,he,Ee)},onDidStartDebugSession(he,Ee,ze){return ft(St.onDidStartDebugSession)(he,Ee,ze)},onDidTerminateDebugSession(he,Ee,ze){return ft(St.onDidTerminateDebugSession)(he,Ee,ze)},onDidChangeActiveDebugSession(he,Ee,ze){return ft(St.onDidChangeActiveDebugSession)(he,Ee,ze)},onDidReceiveDebugSessionCustomEvent(he,Ee,ze){return ft(St.onDidReceiveDebugSessionCustomEvent)(he,Ee,ze)},onDidChangeBreakpoints(he,Ee,ze){return ft(St.onDidChangeBreakpoints)(he,Ee,ze)},onDidChangeActiveStackItem(he,Ee,ze){return ft(St.onDidChangeActiveStackItem)(he,Ee,ze)},registerDebugConfigurationProvider(he,Ee,ze){return St.registerDebugConfigurationProvider(he,Ee,ze||Kt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(he,Ee){return St.registerDebugAdapterDescriptorFactory(Be,he,Ee)},registerDebugAdapterTrackerFactory(he,Ee){return St.registerDebugAdapterTrackerFactory(he,Ee)},startDebugging(he,Ee,ze){return!ze||typeof ze=="object"&&"configuration"in ze?St.startDebugging(he,Ee,{parentSession:ze}):St.startDebugging(he,Ee,ze||{})},stopDebugging(he){return St.stopDebugging(he)},addBreakpoints(he){return St.addBreakpoints(he)},removeBreakpoints(he){return St.removeBreakpoints(he)},asDebugSourceUri(he,Ee){return St.asDebugSourceUri(he,Ee)}},Sn={registerTaskProvider:(he,Ee)=>xt.registerTaskProvider(Be,he,Ee),fetchTasks:he=>xt.fetchTasks(he),executeTask:he=>xt.executeTask(Be,he),get taskExecutions(){return xt.taskExecutions},onDidStartTask:(he,Ee,ze)=>ft(xt.onDidStartTask)(he,Ee,ze),onDidEndTask:(he,Ee,ze)=>ft(xt.onDidEndTask)(he,Ee,ze),onDidStartTaskProcess:(he,Ee,ze)=>ft(xt.onDidStartTaskProcess)(he,Ee,ze),onDidEndTaskProcess:(he,Ee,ze)=>ft(xt.onDidEndTaskProcess)(he,Ee,ze)},hn={createNotebookController(he,Ee,ze,mt,Dt){return gi.createNotebookController(Be,he,Ee,ze,mt,(0,tt.$CH)(Be,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(he,Ee)=>Ot.registerNotebookCellStatusBarItemProvider(Be,he,Ee),createRendererMessaging(he){return ji.createRendererMessaging(Be,he)},createNotebookControllerDetectionTask(he){return(0,tt.$DH)(Be,"notebookKernelSource"),gi.createNotebookControllerDetectionTask(Be,he)},registerKernelSourceActionProvider(he,Ee){return(0,tt.$DH)(Be,"notebookKernelSource"),gi.registerKernelSourceActionProvider(Be,he,Ee)},onDidChangeNotebookCellExecutionState(he,Ee,ze){return(0,tt.$DH)(Be,"notebookCellExecutionState"),ft(gi.onDidChangeNotebookCellExecutionState)(he,Ee,ze)}},dn={t(...he){if(typeof he[0]=="string"){const Ee=he.shift(),ze=!he||typeof he[0]!="object"?he:he[0];return di.getMessage(Be.identifier.value,{message:Ee,args:ze})}return di.getMessage(Be.identifier.value,he[0])},get bundle(){return di.getBundle(Be.identifier.value)},get uri(){return di.getBundleUri(Be.identifier.value)}},kn={transferActiveChat(he){return(0,tt.$DH)(Be,"interactive"),zi.transferActiveChat(he)}},In={getRelatedInformation(he,Ee){return(0,tt.$DH)(Be,"aiRelatedInformation"),Hi.getRelatedInformation(Be,he,Ee)},registerRelatedInformationProvider(he,Ee){return(0,tt.$DH)(Be,"aiRelatedInformation"),Hi.registerRelatedInformationProvider(Be,he,Ee)},registerEmbeddingVectorProvider(he,Ee){return(0,tt.$DH)(Be,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Be,he,Ee)}},fn={registerChatResponseProvider(he,Ee,ze){return(0,tt.$DH)(Be,"chatProvider"),Xt.registerLanguageModel(Be,he,Ee,ze)},registerChatVariableResolver(he,Ee,ze,mt,Dt,Ft,Oi,Zi){return(0,tt.$DH)(Be,"chatVariableResolver"),rn.registerVariableResolver(Be,he,Ee,ze,mt,Dt,Ft,Oi,Zi?.id)},registerMappedEditsProvider(he,Ee){return(0,tt.$DH)(Be,"mappedEditsProvider"),De.registerMappedEditsProvider(Be,he,Ee)},createChatParticipant(he,Ee){return zi.createChatAgent(Be,he,Ee)},createDynamicChatParticipant(he,Ee,ze){return(0,tt.$DH)(Be,"chatParticipantPrivate"),zi.createDynamicChatAgent(Be,he,Ee,ze)},registerChatParticipantDetectionProvider(he){return(0,tt.$DH)(Be,"chatParticipantAdditions"),zi.registerChatParticipantDetectionProvider(he)}},Yi={selectChatModels:he=>Xt.selectLanguageModels(Be,he??{}),onDidChangeChatModels:(he,Ee,ze)=>Xt.onDidChangeProviders(he,Ee,ze),registerChatModelProvider:(he,Ee,ze)=>((0,tt.$DH)(Be,"chatProvider"),Xt.registerLanguageModel(Be,he,Ee,ze)),get embeddingModels(){return(0,tt.$DH)(Be,"embeddings"),Ri.embeddingsModels},onDidChangeEmbeddingModels:(he,Ee,ze)=>((0,tt.$DH)(Be,"embeddings"),Ri.onDidChange(he,Ee,ze)),registerEmbeddingsProvider(he,Ee){return(0,tt.$DH)(Be,"embeddings"),Ri.registerEmbeddingsProvider(Be,he,Ee)},async computeEmbeddings(he,Ee,ze){return(0,tt.$DH)(Be,"embeddings"),Ri.computeEmbeddings(he,Ee,ze)},registerTool(he,Ee){return(0,tt.$DH)(Be,"lmTools"),Bi.registerTool(Be,he,Ee)},invokeTool(he,Ee,ze){return(0,tt.$DH)(Be,"lmTools"),Bi.invokeTool(he,Ee,ze)},get tools(){return(0,tt.$DH)(Be,"lmTools"),Bi.tools}},gn={registerSpeechProvider(he,Ee){return(0,tt.$DH)(Be,"speech"),bn.registerProvider(Be.identifier,he,Ee)}};return{version:Rt.version,ai:In,authentication:yn,commands:Qi,comments:ln,chat:fn,debug:un,env:Ji,extensions:En,interactive:kn,l10n:dn,languages:$i,lm:Yi,notebooks:hn,scm:cn,speech:gn,tasks:Sn,tests:ki,window:Wi,workspace:Xi,Breakpoint:X.$gP,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatResultFeedbackKind:X.ChatResultFeedbackKind,ChatVariableLevel:X.ChatVariableLevel,ChatCompletionItem:X.$cQ,CallHierarchyIncomingCall:X.$EO,CallHierarchyItem:X.$DO,CallHierarchyOutgoingCall:X.$FO,CancellationError:h.$9,CancellationTokenSource:s.$Be,CandidatePortSource:i.CandidatePortSource,CodeAction:X.$AO,CodeActionKind:X.$BO,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$GO,Color:X.$TO,ColorInformation:X.$UO,ColorPresentation:X.$VO,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CommentThreadApplicability:X.CommentThreadApplicability,CommentThreadFocus:X.CommentThreadFocus,CompletionItem:X.$NO,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$OO,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$4O,DebugAdapterExecutable:X.$kP,DebugAdapterInlineImplementation:X.$nP,DebugAdapterNamedPipeServer:X.$mP,DebugAdapterServer:X.$lP,DebugConfigurationProviderTriggerKind:Kt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DebugVisualization:X.$DP,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$tO,DiagnosticRelatedInformation:X.$sO,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$dO,DocumentHighlight:X.$wO,DocumentHighlightKind:X.DocumentHighlightKind,MultiDocumentHighlight:X.$xO,DocumentLink:X.$SO,DocumentSymbol:X.$zO,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$qP,InlineValueText:X.$rP,InlineValueVariableLookup:X.$sP,InlineValueEvaluatableExpression:X.$tP,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:D.$qe,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$FP,FileDecoration2:X.$FP,FileSystemError:X.$wP,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:X.$xP,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$iP,InlineCompletionItem:X.$PO,InlineCompletionList:X.$QO,Hover:X.$uO,VerboseHover:X.$vO,HoverVerbosityAction:X.HoverVerbosityAction,IndentAction:E.IndentAction,Location:X.$rO,MarkdownString:X.$HO,OverviewRulerLane:f.OverviewRulerLane,ParameterInformation:X.$IO,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$eO,ProcessExecution:X.$2O,ProgressLocation:X.ProgressLocation,QuickInputButtonLocation:X.QuickInputButtonLocation,QuickInputButtons:X.$EP,Range:X.$fO,RelativePattern:X.$eP,Selection:X.$gO,SelectionRange:X.$CO,SemanticTokens:X.$AP,SemanticTokensBuilder:X.$zP,SemanticTokensEdit:X.$BP,SemanticTokensEdits:X.$CP,SemanticTokensLegend:X.$yP,ShellExecution:X.$3O,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$KO,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$JO,SnippetString:X.$qO,SourceBreakpoint:X.$hP,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$yO,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$5O,TaskGroup:X.$1O,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$WO,TerminalQuickFixTerminalCommand:X.$YO,TerminalQuickFixOpener:X.$XO,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$ZO,TerminalExitReason:X.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:X.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$mO,SnippetTextEdit:X.$oO,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,SyntaxTokenType:X.SyntaxTokenType,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$dP,ThemeIcon:X.$cP,TreeItem:X.$6O,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$3P,UIKind:ei.UIKind,Uri:p.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$pO,DocumentPasteTriggerKind:X.DocumentPasteTriggerKind,DocumentDropEdit:X.$_O,DocumentDropOrPasteEditKind:X.$aP,DocumentPasteEdit:X.$bP,InlayHint:X.$MO,InlayHintLabelPart:X.$LO,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$lO,ResolvedAuthority:X.$jO,ManagedResolvedAuthority:X.$kO,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$PP,NotebookRange:X.$HP,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$IP,NotebookData:X.$JP,NotebookRendererScript:X.$NP,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$LP,NotebookCellOutputItem:X.$KP,NotebookCellStatusBarItem:X.$MP,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$nO,NotebookKernelSourceAction:X.$OP,NotebookVariablesRequestKind:X.NotebookVariablesRequestKind,PortAttributes:X.$RP,LinkedEditingRanges:X.$QP,TestResultState:X.TestResultState,TestRunRequest:X.$SP,TestMessage:X.$TP,TestMessageStackFrame:X.$VP,TestTag:X.$UP,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:Tt.TextSearchCompleteMessageType,DataTransfer:X.$$O,DataTransferItem:X.$7O,TestCoverageCount:X.$WP,FileCoverage:X.$YP,FileCoverage2:X.$YP,StatementCoverage:X.$ZP,BranchCoverage:X.$1P,DeclarationCoverage:X.$2P,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$4P,TabInputTextDiff:X.$5P,TabInputTextMerge:X.$6P,TabInputCustom:X.$7P,TabInputNotebook:X.$9P,TabInputNotebookDiff:X.$0P,TabInputWebview:X.$8P,TabInputTerminal:X.$$P,TabInputInteractiveWindow:X.$_P,TabInputChat:X.$aQ,TabInputTextMultiDiff:X.$bQ,TelemetryTrustedValue:$.$Fp,LogLevel:o.LogLevel,EditSessionIdentityMatch:d.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,ChatCopyKind:X.ChatCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,DebugStackFrame:X.$oP,DebugThread:X.$pP,RelatedInformationType:X.RelatedInformationType,SpeechToTextStatus:X.SpeechToTextStatus,TextToSpeechStatus:X.TextToSpeechStatus,PartialAcceptTriggerKind:X.PartialAcceptTriggerKind,KeywordRecognitionStatus:X.KeywordRecognitionStatus,ChatResponseMarkdownPart:X.$dQ,ChatResponseFileTreePart:X.$hQ,ChatResponseAnchorPart:X.$iQ,ChatResponseProgressPart:X.$jQ,ChatResponseProgressPart2:X.$kQ,ChatResponseReferencePart:X.$nQ,ChatResponseReferencePart2:X.$nQ,ChatResponseCodeCitationPart:X.$oQ,ChatResponseWarningPart:X.$lQ,ChatResponseTextEditPart:X.$qQ,ChatResponseMarkdownWithVulnerabilitiesPart:X.$eQ,ChatResponseCommandButtonPart:X.$mQ,ChatResponseDetectedParticipantPart:X.$fQ,ChatResponseConfirmationPart:X.$gQ,ChatResponseMovePart:X.$pQ,ChatResponseReferencePartStatusKind:X.ChatResponseReferencePartStatusKind,ChatRequestTurn:X.$rQ,ChatResponseTurn:X.$sQ,ChatLocation:X.ChatLocation,ChatRequestEditorData:X.$tQ,ChatRequestNotebookData:X.$uQ,LanguageModelChatMessageRole:X.LanguageModelChatMessageRole,LanguageModelChatMessage:X.$wQ,LanguageModelChatMessageToolResultPart:X.$vQ,LanguageModelChatResponseTextPart:X.$yQ,LanguageModelChatResponseToolCallPart:X.$xQ,LanguageModelError:X.$CQ,NewSymbolName:X.$vP,NewSymbolNameTag:X.NewSymbolNameTag,NewSymbolNameTriggerKind:X.NewSymbolNameTriggerKind,InlineEdit:X.$DQ,InlineEditTriggerKind:X.InlineEditTriggerKind,ExcludeSettingOptions:Tt.ExcludeSettingOptions,TextSearchContextNew:Tt.$qM,TextSearchMatchNew:Tt.$pM,TextSearchCompleteMessageTypeNew:Tt.TextSearchCompleteMessageType}}}}),define(Re[347],Ce([1,0,89,175,42,169,43,35,65,49,100,101,102,126,78,96,168,77,64,125,95,79,167,11,66,123,124,128,129,173,99]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t,r,n,u,l,g,y,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.$2s)(l.$2rc,l.$1rc,s.InstantiationType.Delayed),(0,s.$2s)(n.$gk,r.$jtc,s.InstantiationType.Delayed),(0,s.$2s)(o.$7qc,o.$8qc,s.InstantiationType.Delayed),(0,s.$2s)(A.$$Q,A.$0Q,s.InstantiationType.Eager),(0,s.$2s)(y.$erc,y.$frc,s.InstantiationType.Eager),(0,s.$2s)(k.$Vrc,k.$Wrc,s.InstantiationType.Eager),(0,s.$2s)(T.$trc,T.$rrc,s.InstantiationType.Eager),(0,s.$2s)($.$vrc,$.$urc,s.InstantiationType.Eager),(0,s.$2s)(R.$_rc,R.$asc,s.InstantiationType.Eager),(0,s.$2s)(E.$esc,E.$isc,s.InstantiationType.Eager),(0,s.$2s)(O.$ksc,O.$jsc,s.InstantiationType.Eager),(0,s.$2s)(p.$ZQ,p.$YQ,s.InstantiationType.Eager),(0,s.$2s)(g.$3rc,g.$4rc,s.InstantiationType.Eager),(0,s.$2s)(d.$$qc,d.$0qc,s.InstantiationType.Eager),(0,s.$2s)(h.$Vsc,h.$Usc,s.InstantiationType.Delayed),(0,s.$2s)(f.$Fsc,f.$Gsc,s.InstantiationType.Eager),(0,s.$2s)(P.$Orc,P.$Nrc,s.InstantiationType.Eager),(0,s.$2s)(I.$9sc,I.$8sc,s.InstantiationType.Eager),(0,s.$2s)(c.$Rrc,c.$Urc,s.InstantiationType.Eager),(0,s.$2s)(S.$0sc,S.$$sc,s.InstantiationType.Eager),(0,s.$2s)(v.$jHb,v.$kHb,s.InstantiationType.Eager),(0,s.$2s)(m.$htc,m.$gtc,s.InstantiationType.Eager),(0,s.$2s)(D.$qrc,D.$prc,s.InstantiationType.Eager),(0,s.$2s)(i.$Yrc,i.$Xrc,s.InstantiationType.Eager),(0,s.$2s)(a.$9Q,a.$6Q,s.InstantiationType.Eager),(0,s.$2s)(t.$Frc,t.$Grc,s.InstantiationType.Eager),(0,s.$2s)(u.$0rc,u.$$rc,s.InstantiationType.Eager)}),define(Re[131],Ce([1,0,11,32,59]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ctc=void 0,e.$ztc=O,e.$Atc=T,e.$Btc=A,D=Ue(D);function O(c){return c.startsWith("**")||c.startsWith("/")?c:`/${c}`}function T(c){return new h.$DM(c.start.line,c.start.character,c.end.line,c.end.character)}function A(c){return new D.$oM(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn)}let p=class{constructor(I,E){this.a=I,this.b=E}appendLine(I){this.b.debug(`${this.a}#search`,I)}};e.$Ctc=p,e.$Ctc=p=Ye([We(1,s.$fk)],p)}),define(Re[348],Ce([1,0,58,16,83,33,10,13,131,349]),function(ge,e,s,h,D,O,T,A,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dtc=E,e.$Etc=m,e.$Ftc=d,s=Ue(s),h=Ue(h),O=Ue(O),A=Ue(A);const I=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function E(i,a,t,r,n){const u=f(i,a,t,r,n),l=a.folder.fsPath;return{cmd:s.spawn(I,u.args,{cwd:l}),rgDiskPath:I,siblingClauses:u.siblingClauses,rgArgs:u,cwd:l}}function f(i,a,t,r,n){const u=["--files","--hidden","--case-sensitive","--no-require-git"];v([a],t,!1).forEach(g=>{const y=(0,p.$ztc)(g);if(u.push("-g",y),T.$m){const k=(0,D.$tm)(y);k!==y&&u.push("-g",k)}});const l=P([a],r,void 0,!1);return l.globArgs.forEach(g=>{const y=`!${(0,p.$ztc)(g)}`;if(u.push("-g",y),T.$m){const k=(0,D.$tm)(y);k!==y&&u.push("-g",k)}}),a.disregardIgnoreFiles!==!1?u.push("--no-ignore"):a.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),a.ignoreSymlinks||u.push("--follow"),i.exists&&u.push("--quiet"),n&&u.push("--threads",`${n}`),u.push("--no-config"),a.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:l.siblingClauses}}function P(i,a,t,r=!0){const n=[];let u={};return i.forEach(l=>{const g=Object.assign({},l.excludePattern||{},a||{}),y=o(g,r?l.folder.fsPath:void 0,t);n.push(...y.globArgs),y.siblingClauses&&(u=Object.assign(u,y.siblingClauses))}),{globArgs:n,siblingClauses:u}}function v(i,a,t=!0){const r=[];return i.forEach(n=>{const u=Object.assign({},a||{},n.includePattern||{}),l=o(u,t?n.folder.fsPath:void 0);r.push(...l.globArgs)}),r}function o(i,a,t){const r=[],n={};return Object.keys(i).forEach(u=>{if(t&&t.has(u)||!u)return;const l=i[u];u=$(a?m(a,u):u),u.startsWith("\\\\")?u="\\\\"+u.substr(2).replace(/\\/g,"/"):u=u.replace(/\\/g,"/"),typeof l=="boolean"&&l?(u.startsWith("\\\\")&&(u+="**"),r.push(d(u))):l&&l.when&&(n[u]=l)}),{globArgs:r,siblingClauses:n}}function m(i,a){return h.$nc(a)?a:h.$oc(i,a)}function $(i){return i=A.$sf(i,"\\"),A.$sf(i,"/")}function d(i){return O.$Fg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(Re[350],Ce([1,0,58,46,16,351,18,52,39,83,33,10,44,13,17,34,32,348,144]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Htc=e.$Gtc=void 0,s=Ue(s),h=Ue(h),D=Ue(D),T=Ue(T),p=Ue(p),c=Ue(c),E=Ue(E),P=Ue(P),v=Ue(v);const i=new Set;process.on("exit",()=>{i.forEach(u=>u())});class a{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&p.$Fk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,d.$2r)(this.b).normalizedLowercase),this.u=l.excludePattern&&p.$Fk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(g=>{const y={};g.excludePattern?.forEach(S=>{Object.assign(y,S.pattern||{},this.a.excludePattern||{})}),g.excludePattern?.length||Object.assign(y,this.a.excludePattern||{});const k=g.folder.fsPath;l.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==k).forEach(S=>{(0,I.$Jg)(S,k)&&(y[D.$qc(k,S)]=!0)}),this.t.set(k,new r(y,k))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,g,y,k,S,R){if(this.m=f.$ke.create(!1),this.l)return R(null,this.j);g.forEach(C=>{const w=D.$sc(C.fsPath);this.u&&this.u(C.fsPath,w)||this.J(k,{relativePath:C.fsPath,searchPath:void 0})}),this.r=f.$ke.create(!1),this.w(l,(C,w)=>{this.x(this.y,this,C,y,k,S,b=>{if(b){const N=(0,A.$vj)(b);console.error(N),this.q.push(N),w(b,void 0)}else w(null,void 0)})},(C,w)=>{this.m.stop();const b=C?T.$Lb(C)[0]:null;R(b,this.j)})}w(l,g,y){const k=new Array(l.length),S=new Array(l.length);let R=!1,C=0;if(l.length===0)return y(null,[]);l.forEach((w,b)=>{g(w,(N,L)=>{if(N?(R=!0,k[b]=null,S[b]=N):(k[b]=L,S[b]=null),++C===l.length)return y(R?S:null,k)})})}x(l,g,...y){try{l.apply(g,y)}catch(k){y[y.length-1](k)}}y(l,g,y,k,S){const R=l.folder.fsPath,C=E.$m,w=()=>z&&z.kill();i.add(w);let b=W=>{i.delete(w),b=()=>{},S(W)},N="";const L=this.D(),M=(0,$.$Dtc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression,g),z=M.cmd,V=!Object.keys(M.siblingClauses).length,F=M.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let j=`${M.rgDiskPath} ${F}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),k({message:j}),this.s=0,this.z(z,"utf8",k,(W,J,B)=>{if(W){b(W);return}if(this.j){b();return}const _=(N+(C?c.$sm(J||""):J)).split(`
`);if(B){const x=_.length;_[x-1]=_[x-1].trim(),_[x-1]||_.pop()}else N=_.pop()||"";if(_.length&&_[0].indexOf(`
`)!==-1){b(new Error("Splitting up files failed"));return}if(this.s+=_.length,V){for(const x of _)if(this.J(y,{base:R,relativePath:x,searchPath:this.N(l,x)}),this.j){w();break}(B||this.j)&&b();return}this.G(l,L,R,_,y),B&&(this.H(L,R,y),b())})}spawnFindCmd(l){const g=this.t.get(l.folder.fsPath),y=g.getBasenameTerms(),k=g.getPathTerms(),S=["-L","."];if(y.length||k.length){S.push("-not","(","(");for(const R of y)S.push("-name",R),S.push("-o");for(const R of k)S.push("-path",R),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),s.spawn("find",S,{cwd:l.folder.fsPath})}readStdout(l,g,y){let k="";this.z(l,g,()=>{},(S,R,C)=>{if(S){y(S);return}k+=R,C&&y(null,k)})}z(l,g,y,k){let S=(w,b,N)=>{(w||N)&&(S=()=>{},this.r?.stop()),k(w,b,N)},R=!1;l.stdout?(this.A(l.stdout,g,S),l.stdout.once("data",()=>R=!0)):y({message:"stdout is null"});let C;l.stderr?C=this.B(l.stderr):y({message:"stderr is null"}),l.on("error",w=>{S(w)}),l.on("close",w=>{let b;!R&&(b=this.C(C,g))&&n(b)?S(new Error(`command failed with error code ${w}: ${this.C(C,g)}`)):(this.g&&w===0&&(this.j=!0),S(null,"",!0))})}A(l,g,y){const k=new O.StringDecoder(g);return l.on("data",S=>{y(null,k.write(S))}),k}B(l){const g=[];return l.on("data",y=>{g.push(y)}),g}C(l,g){const y=new O.StringDecoder(g);return l.map(k=>y.write(k)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:g},y,k,S){k.indexOf(this.b)!==-1&&this.J(S,{base:y,relativePath:this.b,searchPath:this.N(l,this.b)});const R=C=>{const w=D.$sc(C),b=D.$rc(C);let N=g[b];N||(N=g[b]=[],R(b)),N.push({base:y,relativePath:C,basename:w,searchPath:this.N(l,C)})};k.forEach(R)}H({rootEntries:l,pathToEntries:g},y,k){const S=this,R=this.t.get(y),C=this.b;function w(b){S.o++;const N=(0,m.$SM)(()=>b.map(L=>L.basename));for(let L=0,M=b.length;L<M;L++){const z=b[L],{relativePath:V,basename:F}=z;if(R.test(V,F,C!==F?N:void 0))continue;const j=g[V];if(j)w(j);else{if(S.p++,V===C)continue;S.J(k,z)}if(S.j)break}}w(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,g,y,k,S){const R=l.folder,C=(0,m.$SM)(()=>y);this.w(y,(w,b)=>{if(this.l||this.j)return b(null);const N=g?[g,w].join(D.sep):w;if(this.t.get(l.folder.fsPath).test(N,w,this.a.filePattern!==w?C:void 0))return b(null);const L=[R.fsPath,N].join(D.sep);h.lstat(L,(M,z)=>{if(M||this.l||this.j)return b(null);this.L(L,z,(V,F)=>V||this.l||this.j?b(null):F.isDirectory()?(this.o++,this.M(L,z,(j,W)=>j||this.l||this.j||(W=W||"",this.v[W])?b(null):(this.v[W]=!0,o.Promises.readdir(L).then(J=>{if(this.l||this.j)return b(null);this.I(l,N,J,k,B=>b(B||null))},J=>{b(null)})))):(this.p++,N===this.b||this.h&&v.$ng(F.size)&&F.size>this.h||this.J(k,{base:R.fsPath,relativePath:N,searchPath:this.N(l,N)}),b(null,void 0)))})},w=>{const b=w&&T.$Lb(w);return S(b&&b.length>0?b[0]:void 0)})}J(l,g){this.K(g)&&(!this.d||this.d(g.relativePath,D.$sc(g.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(g))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$NM)(l,this.c);if(this.b)return(0,m.$NM)(l,this.b,!1)}return!0}L(l,g,y){return g.isSymbolicLink()?h.stat(l,y):y(null,g)}M(l,g,y){return g.isSymbolicLink()?h.realpath(l,(k,S)=>k?y(k):y(null,S)):y(null,l)}N(l,g){return l.folderName?D.$oc(l.folderName,g):g}}e.$Gtc=a;class t{constructor(l,g){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.d=g,this.c=new a(l)}search(l,g,y){this.c.walk(this.a,this.b,this.d,l,g,(k,S)=>{y(k,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Htc=t;class r{constructor(l,g){this.expression=l,this.c=g,this.d(l)}d(l){let g,y;Object.keys(l).filter(k=>l[k]).forEach(k=>{D.$nc(k)?(g=g||p.$Ak(),g[k]=l[k]):(y=y||p.$Ak(),y[k]=l[k])}),this.a=g&&p.$Fk(g,{trimForExclusions:!0}),this.b=y&&p.$Fk(y,{trimForExclusions:!0})}test(l,g,y){return this.b&&this.b(l,g,y)||this.a&&this.a(D.$oc(this.c,l),g,y)}getBasenameTerms(){const l=[];return this.a&&l.push(...p.$Hk(this.a)),this.b&&l.push(...p.$Hk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...p.$Ik(this.a)),this.b&&l.push(...p.$Ik(this.b)),l}}function n(u){const l=u.trim().split(`
`),g=l[0].trim();if(g.startsWith("Error parsing regex"))return g;if(g.startsWith("regex parse error"))return P.$bg(l[l.length-1].trim());if(g.startsWith("error parsing glob")||g.startsWith("unsupported encoding"))return g.charAt(0).toUpperCase()+g.substr(1);if(g==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(g.startsWith("Literal "))return g}}),define(Re[352],Ce([1,0,103,21,145,20,18,133]),function(ge,e,s,h,D,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cF=e.$bF=e.$6E=e.DecodeStreamErrorKind=e.$5E=e.$4E=e.$3E=e.$1E=e.$ZE=e.$YE=e.$XE=void 0,e.$2E=p,e.$7E=m,e.$8E=$,e.$9E=d,e.$0E=i,e.$$E=a,e.$_E=k,e.$aF=S,e.$XE="utf8",e.$YE="utf8bom",e.$ZE="utf16be",e.$1E="utf16le";function p(R){return[e.$XE,e.$YE,e.$ZE,e.$1E].some(C=>C===R)}e.$3E=[254,255],e.$4E=[255,254],e.$5E=[239,187,191];const c=512,I=512,E=512*8,f=512*128;var P;(function(R){R[R.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class v extends Error{constructor(C,w){super(C),this.decodeStreamErrorKind=w}}e.$6E=v;class o{static async create(C){let w;if(C!==e.$XE)w=(await(0,D.$Bq)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(i(C));else{const b=new TextDecoder;w={write(N){return b.decode(N,{stream:!0})},end(){return b.decode()}}}return new o(w)}constructor(C){this.a=C}write(C){return this.a.write(C)}end(){return this.a.end()}}function m(R,C){const w=C.minBytesRequiredForDetection??C.guessEncoding?E:I;return new Promise((b,N)=>{const L=(0,s.$Ge)(W=>W.join("")),M=[];let z=0,V;const F=new O.$Be,j=async()=>{try{const W=await S({buffer:h.$Se.concat(M),bytesRead:z},C.guessEncoding,C.candidateGuessEncodings);if(W.seemsBinary&&C.acceptTextOnly)throw new v("Stream is binary but only text is accepted for decoding",P.STREAM_IS_BINARY);W.encoding=await C.overwriteEncoding(W.encoding),V=await o.create(W.encoding);const J=V.write(h.$Se.concat(M).buffer);L.write(J),M.length=0,z=0,b({stream:L,detected:W})}catch(W){F.cancel(),L.destroy(),N(W)}};(0,s.$Ke)(R,{onData:async W=>{V?L.write(V.write(W.buffer)):(M.push(W),z+=W.byteLength,z>=w&&(R.pause(),await j(),setTimeout(()=>R.resume())))},onError:W=>L.error(W),onEnd:async()=>{V||await j(),L.end(V?.end())}},F.token)})}async function $(R,C,w){const N=(await(0,D.$Bq)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(i(C),w);let L=!1,M=!1;return{read(){if(M)return null;const z=R.read();if(typeof z!="string"){if(M=!0,!L&&w?.addBOM)switch(C){case e.$XE:case e.$YE:return h.$Se.wrap(Uint8Array.from(e.$5E));case e.$ZE:return h.$Se.wrap(Uint8Array.from(e.$3E));case e.$1E:return h.$Se.wrap(Uint8Array.from(e.$4E))}const V=N.end();return V&&V.length>0?(L=!0,h.$Se.wrap(V)):null}return L=!0,h.$Se.wrap(N.write(z))}}}async function d(R){return(await(0,D.$Bq)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(i(R))}function i(R){return R===e.$YE||R===null?e.$XE:R}function a(R,C){if(!R||C<e.$3E.length)return null;const w=R.readUInt8(0),b=R.readUInt8(1);if(w===e.$3E[0]&&b===e.$3E[1])return e.$ZE;if(w===e.$4E[0]&&b===e.$4E[1])return e.$1E;if(C<e.$5E.length)return null;const N=R.readUInt8(2);return w===e.$5E[0]&&b===e.$5E[1]&&N===e.$5E[2]?e.$YE:null}const t=["ascii","utf-16","utf-32"];async function r(R,C){const w=await(0,D.$Bq)("jschardet",A.$V?"dist/jschardet.js":"dist/jschardet.min.js"),b=R.slice(0,f),N=y(b.buffer);C&&(C=(0,T.$Lb)(C.map(z=>g(z))),C.length===0&&(C=void 0));const L=w.detect(N,C?{detectEncodings:C}:void 0);if(!L||!L.encoding)return null;const M=L.encoding.toLowerCase();return 0<=t.indexOf(M)?null:l(L.encoding)}const n={ibm866:"cp866",big5:"cp950"};function u(R){return R.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function l(R){const C=u(R);return n[C]||C}function g(R){const C=u(R);return e.$cF[C].guessableName}function y(R){let C="";for(let w=0;w<R.length;w++)C+=String.fromCharCode(R[w]);return C}function k(R){switch(R){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const C=R.match(/windows(\d+)/);return C?"windows-"+C[1]:R}}}function S({buffer:R,bytesRead:C},w,b){let N=a(R,C),L=!1;if(N!==e.$ZE&&N!==e.$1E&&R){let M=!0,z=!0,V=!1;for(let F=0;F<C&&F<c;F++){const j=F%2===1,W=R.readUInt8(F)===0;if(W&&(V=!0),M&&(j&&!W||!j&&W)&&(M=!1),z&&(j&&W||!j&&!W)&&(z=!1),W&&!M&&!z)break}V&&(M?N=e.$1E:z?N=e.$ZE:L=!0)}return w&&!L&&!N&&R?r(R.slice(0,C),b).then(M=>({seemsBinary:!1,encoding:M})):{seemsBinary:L,encoding:N}}e.$bF={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$cF=(()=>{const R={};for(const C in e.$bF)e.$bF[C].guessableName&&(R[C]=e.$bF[C]);return R})()}),define(Re[178],Ce([1,0,352,34,177]),function(ge,e,s,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ptc=void 0,h=Ue(h);class O extends D.$Csc{constructor(A,p,c=h,I="searchProcess"){super({query:A,provider:p},{readdir:E=>c.Promises.readdir(E.fsPath),toCanonicalName:E=>(0,s.$_E)(E)},I)}}e.$Ptc=O}),define(Re[179],Ce([1,0,58,367,351,18,80,39,13,2,32,59,368,349,131,130]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jtc=e.$Itc=void 0,e.$Ktc=n,e.$Ltc=l,e.$Mtc=y,e.$Ntc=k,e.$Otc=R,s=Ue(s);const m=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class ${constructor(w,b){this.a=w,this.b=b}provideTextSearchResults(w,b,N,L){return Promise.all(b.folderOptions.map(M=>{const z={folderOptions:M,numThreads:this.b,maxResults:b.maxResults,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,surroundingContext:b.surroundingContext};return this.provideTextSearchResultsWithRgOptions(w,z,N,L)})).then(M=>({limitHit:M.some(V=>!!V&&V.limitHit)}))}provideTextSearchResultsWithRgOptions(w,b,N,L){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...b,folder:b.folderOptions.folder.toString()})}`),new Promise((M,z)=>{L.onCancellationRequested(()=>x());const V={...b,numThreads:this.b},F=n(w,V),j=b.folderOptions.folder.fsPath,W=F.map(Y=>Y.match(/^-/)?Y:`'${Y}'`).join(" ");this.a.appendLine(`${m} ${W}
 - cwd: ${j}`);let J=s.spawn(m,F,{cwd:j});J.on("error",Y=>{console.error(Y),this.a.appendLine("Error: "+(Y&&Y.message)),z((0,I.$JM)(new I.$HM(Y&&Y.message,I.SearchErrorCode.rgProcessError)))});let B=!1;const U=new a(b.maxResults??I.$wM,b.folderOptions.folder,(0,o.$wsc)(b.previewOptions));U.on("result",Y=>{B=!0,te="",N.report(Y)});let _=!1;const x=()=>{_=!0,J?.kill(),U?.cancel()};let oe=!1;U.on("hitLimit",()=>{oe=!0,x()});let te="";J.stdout.on("data",Y=>{U.handleData(Y),B||(te+=Y)});let me=!1;J.stdout.once("data",()=>me=!0);let ce="";J.stderr.on("data",Y=>{const q=Y.toString();this.a.appendLine(q),ce.length+q.length<1e6&&(ce+=q)}),J.on("close",()=>{if(this.a.appendLine(me?"Got data from stdout":"No data from stdout"),this.a.appendLine(B?"Got result from parser":"No result from parser"),te&&this.a.appendLine(`Got data without result: ${te}`),this.a.appendLine(""),_)M({limitHit:oe});else{U.flush(),J=null;let Y;ce&&!me&&(Y=d(ce))?z((0,I.$JM)(new I.$HM(Y.message,Y.code))):M({limitHit:oe})}})})}}e.$Itc=$;function d(C){const w=C.split(`
`),b=w[0].trim();if(w.some(L=>L.startsWith("regex parse error")))return new I.$HM(i(w),I.SearchErrorCode.regexParseError);const N=b.match(/grep config error: unknown encoding: (.*)/);if(N)return new I.$HM(`Unknown encoding: ${N[1]}`,I.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new I.$HM(b.charAt(0).toUpperCase()+b.substr(1),I.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new I.$HM(b.charAt(0).toUpperCase()+b.substr(1),I.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new I.$HM(b,I.SearchErrorCode.regexParseError)}function i(C){const w=["Regex parse error"],b=C.filter(N=>N.startsWith("PCRE2:"));if(b.length>=1){const N=b[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const L=N.split(":")[1];w.push(":"+L)}}return w.join("")}class a extends h.EventEmitter{constructor(w,b,N){super(),this.g=w,this.h=b,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new D.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,b){return super.on(w,b),this}handleData(w){if(this.b)return;const b=typeof w=="string"?w:this.d.write(w);this.k(b)}k(w){let b=w.indexOf(`
`);const N=this.a+w;if(b>=0)b+=this.a.length;else{this.a=N;return}let L=0;for(;b>=0;)this.m(N.substring(L,b).trim()),L=b+1,b=N.indexOf(`
`,L);this.a=N.substring(L)}m(w){if(this.b||!w)return;let b;try{b=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(b.type==="match"){const N=t(b.data.path),L=c.URI.joinPath(this.h,N),M=this.n(b.data,L);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const N=t(b.data.path),L=c.URI.joinPath(this.h,N);this.o(b.data,L).forEach(z=>this.p(z))}}n(w,b){const N=w.line_number-1,L=t(w.lines),M=Buffer.from(L);let z=0,V=0,F=N;w.submatches.length===0&&w.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const j=(0,O.$Lb)(w.submatches.map((B,U)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const _=t(B.match),x=M.slice(z,B.start).toString(),oe=r(x),te=oe.numLines>0?oe.lastLineLength:oe.lastLineLength+V,me=r(_),ce=oe.numLines+F,Y=me.numLines+ce,q=me.numLines>0?me.lastLineLength:me.lastLineLength+te;return z=B.end,V=q,F=Y,new E.$oM(ce,te,Y,q)})),W=(0,O.$5b)(j,v.$Atc),J=new I.$CM(L,W,this.j);return new E.$pM(b,J.rangeLocations.map(B=>({sourceRange:(0,v.$Btc)(B.source),previewRange:(0,v.$Btc)(B.preview)})),J.previewText)}o(w,b){const N=t(w.lines),L=w.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((M,z)=>new E.$qM(b,M,L+z))}p(w){this.emit("result",w)}}e.$Jtc=a;function t(C){return C.bytes?Buffer.from(C.bytes,"base64").toString():C.text}function r(C){const w=/\n/g;let b=0,N=-1,L;for(;L=w.exec(C);)b++,N=L.index;const M=N>=0?C.length-N-1:C.length;return{numLines:b,lastLineLength:M}}function n(C,w){const b=["--hidden","--no-require-git"];b.push(C.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:L}=(0,T.$e)(w.folderOptions.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const z=new Set;L.forEach(V=>{z.add(V)}),b.push("-g","!*"),z.forEach(V=>{u(V).map(v.$ztc).forEach(F=>{b.push("-g",F)})})}N&&N.length&&N.forEach(z=>{b.push("-g",z)}),w.folderOptions.excludes.map(z=>typeof z=="string"?z:z.pattern).map(v.$ztc).forEach(z=>b.push("-g",`!${z}`)),w.maxFileSize&&b.push("--max-filesize",w.maxFileSize+""),w.folderOptions.useIgnoreFiles.local?w.folderOptions.useIgnoreFiles.parent||b.push("--no-ignore-parent"):b.push("--no-ignore"),w.folderOptions.followSymlinks&&b.push("--follow"),w.folderOptions.encoding&&w.folderOptions.encoding!=="utf8"&&b.push("--encoding",w.folderOptions.encoding),w.numThreads&&b.push("--threads",`${w.numThreads}`),C.pattern==="--"&&(C.isRegExp=!0,C.pattern="\\-\\-"),C.isMultiline&&!C.isRegExp&&(C.pattern=(0,p.$mf)(C.pattern),C.isRegExp=!0),w.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),C.isRegExp&&(C.pattern=l(C.pattern),b.push("--engine","auto"));let M;if(C.isWordMatch){const V=(0,p.$vf)(C.pattern,!!C.isRegExp,{wholeWord:C.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",V)}else if(C.isRegExp){let z=y(C.pattern);z=k(z),b.push("--regexp",z)}else M=C.pattern,b.push("--fixed-strings");return b.push("--no-config"),w.folderOptions.useIgnoreFiles.global||b.push("--no-ignore-global"),b.push("--json"),C.isMultiline&&b.push("--multiline"),w.surroundingContext&&(b.push("--before-context",w.surroundingContext+""),b.push("--after-context",w.surroundingContext+"")),b.push("--"),M&&b.push(M),b.push("."),b}function u(C){return R(C).flatMap(b=>{const N=(0,A.$Dk)(b,"/");return N.map((L,M)=>N.slice(0,M+1).join("/"))})}function l(C){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;C.match(w);)C=C.replace(w,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;C.match(b);)C=C.replace(b,"$1\\x{$2}");return C}const g=C=>C.type==="Assertion"&&C.kind==="lookbehind";function y(C){let w;try{w=new f.RegExpParser().parsePattern(C)}catch{return C}let b="",N=0;const L=(V,F,j)=>{b+=C.slice(N,V)+j,N=F},M=[];return new f.RegExpVisitor({onCharacterEnter(V){if(V.raw!=="\\n")return;const F=M[0];if(!F)L(V.start,V.end,"\\r?\\n");else if(!M.some(g))if(F.type==="CharacterClass")if(F.negate){const j=C.slice(F.start+2,V.start)+C.slice(V.end,F.end-1);F.parent?.type==="Quantifier"?L(F.start,F.end,j?`[^${j}]`:"."):L(F.start,F.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=C.slice(F.start+1,V.start)+C.slice(V.end,F.end-1);L(F.start,F.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else F.type==="Quantifier"&&L(V.start,V.end,"(?:\\r?\\n)")},onQuantifierEnter(V){M.unshift(V)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(V){M.unshift(V)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(V){M.unshift(V)},onCharacterClassLeave(){M.shift()},onAssertionEnter(V){g(V)&&M.push(V)},onAssertionLeave(V){M[0]===V&&M.shift()}}).visit(w),b+=C.slice(N),b}function k(C){return C.replace(/\n/g,"\\r?\\n")}function S(C){let w=!1,b=!1,N="",L="";for(let M=0;M<C.length;M++){const z=C[M];switch(z){case"\\":b?(w?L+="\\"+z:N+="\\"+z,b=!1):b=!0;break;case"{":if(b)w?L+=z:N+=z,b=!1;else{if(w)return{strInBraces:N+"{"+L+"{"+C.substring(M+1)};w=!0}break;case"}":if(b)w?L+=z:N+=z,b=!1;else{if(w)return{fixedStart:N,strInBraces:L,fixedEnd:C.substring(M+1)};N+=z}break;default:w?L+=(b?"\\":"")+z:N+=(b?"\\":"")+z,b=!1;break}}return{strInBraces:N+(w?"{"+L:"")}}function R(C){const{fixedStart:w,strInBraces:b,fixedEnd:N}=S(C);if(w===void 0||N===void 0)return[b];let L=(0,A.$Dk)(b,",");L.length||(L=[""]);const M=R(N);return L.flatMap(z=>{const V=w+z;return M.map(F=>V+F)})}}),define(Re[353],Ce([1,0,20,179,90,14]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Stc=void 0;class T{constructor(c,I){this.b=c,this.c=I,this.a=new Set,process.once("exit",()=>this.f())}async provideTextSearchResults(c,I,E,f){const P=await this.c(),v=new h.$Itc(this.b,P);return Promise.all(I.folderOptions.map(o=>{const m={folderOptions:o,numThreads:P,maxResults:I.maxResults,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,surroundingContext:I.surroundingContext};if(o.folder.scheme===O.Schemas.vscodeUserData){const $={...m,folder:o.folder.with({scheme:O.Schemas.file})},d=new D.$Kw(i=>E.report({...i,uri:i.uri.with({scheme:o.folder.scheme})}));return this.d(f,i=>v.provideTextSearchResultsWithRgOptions(c,$,d,i))}else return this.d(f,$=>v.provideTextSearchResultsWithRgOptions(c,m,E,$))})).then(o=>({limitHit:o.some($=>!!$&&$.limitHit)}))}async d(c,I){const E=A(c);this.a.add(E);const f=await I(E.token);return this.a.delete(E),f}f(){this.a.forEach(c=>c.cancel())}}e.$Stc=T;function A(p){const c=new s.$Be;return p.onCancellationRequested(()=>c.cancel()),c}}),define(Re[354],Ce([1,0,34,32,179,178]),function(ge,e,s,h,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qtc=void 0,s=Ue(s);class T{constructor(c,I){this.a=c,this.b=I}search(c,I,E){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const f={appendLine(v){E({message:v})}},P=new O.$Ptc(this.a,new D.$Itc(f,this.b),s);return new Promise((v,o)=>P.search(m=>{I(m.map(A))},c).then(m=>v({limitHit:m.limitHit??!1,type:"success",stats:m.stats,messages:[]}),o))}}e.$Qtc=T;function A(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce((c,I)=>(0,h.$yM)(I)?c+I.rangeLocations.length:c+1,0)}}}),define(Re[355],Ce([1,0,18,8,12,4,144,38,16,44,2,27,32,350,354]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rtc=void 0,s=Ue(s);class o{static{this.a=512}constructor(t="searchProcess",r){this.d=t,this.f=r,this.b=Object.create(null)}fileSearch(t){let r;const n=d(t),u=new O.$qe({onDidAddFirstListener:()=>{r=(0,h.$xh)(async l=>{const g=await this.f?.();return this.doFileSearchWithEngine(P.$Htc,n,y=>u.fire(y),l,o.a,g)}),r.then(l=>u.fire(l),l=>u.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{r.cancel()}});return u.event}textSearch(t){let r;const n=d(t),u=new O.$qe({onDidAddFirstListener:()=>{r=(0,h.$xh)(l=>this.g(n,g=>u.fire(g),l)),r.then(l=>u.fire(l),l=>u.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{r.cancel()}});return u.event}async g(t,r,n){t.maxFileSize=this.h().maxFileSize;const u=await this.f?.();return new v.$Qtc(t,u).search(n,r,r)}h(){return{maxFileSize:16*E.$Nl.GB}}doFileSearch(t,r,n,u){return this.doFileSearchWithEngine(P.$Htc,t,n,u,o.a,r)}doFileSearchWithEngine(t,r,n,u,l=o.a,g){let y=0;const k=R=>{Array.isArray(R)?(y+=R.length,n(R.map(C=>this.j(C)))):R.relativePath?(y++,n(this.j(R))):n(R)};if(r.sortByScore){let R=this.n(r,k,u);if(!R){const C=r.maxResults?Object.assign({},r,{maxResults:null}):r,w=new t(C,g);R=this.k(w,r,n,k,u)}return new Promise((C,w)=>{R.then(([b,N])=>{const L=N.map(M=>this.j(M));this.q(L,n,l),C(b)},w)})}const S=new t(r,g);return this.s(S,k,l,u).then(R=>({limitHit:R.limitHit,type:"success",stats:{detailStats:R.stats,type:this.d,fromCache:!1,resultCount:y,sortingTime:void 0},messages:[]}))}j(t){return{path:t.base?(0,p.$oc)(t.base,t.relativePath):t.relativePath}}k(t,r,n,u,l){const g=new O.$qe;let y=(0,h.$xh)(S=>{let R=[];const C=w=>{Array.isArray(w)?R=w:(u(w),g.fire(w))};return this.s(t,C,-1,S).then(w=>[w,R])}),k;if(r.cacheKey){k=this.l(r.cacheKey);const S={promise:y,event:g.event,resolved:!1};k.resultsToSearchCache[r.filePattern||""]=S,y.then(()=>{S.resolved=!0},R=>{delete k.resultsToSearchCache[r.filePattern||""]}),y=this.t(y)}return y.then(([S,R])=>{const C=k?k.scorerCache:Object.create(null),w=(typeof r.maxResults!="number"||r.maxResults>0)&&c.$ke.create(!1);return this.o(r,R,C,l).then(b=>{const N=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:N,fromCache:!1,type:this.d,resultCount:b.length},messages:S.messages,limitHit:S.limitHit||typeof r.maxResults=="number"&&R.length>r.maxResults},b]})})}l(t){const r=this.b[t];return r||(this.b[t]=new m)}n(t,r,n){const u=t.cacheKey&&this.b[t.cacheKey];if(!u)return;const l=this.r(u,t.filePattern||"",r,n);if(l)return l.then(([g,y,k])=>{const S=c.$ke.create(!1);return this.o(t,y,u.scorerCache,n).then(R=>{const C=S.elapsed(),w={fromCache:!0,detailStats:k,type:this.d,resultCount:y.length,sortingTime:C};return[{type:"success",limitHit:g.limitHit||typeof t.maxResults=="number"&&y.length>t.maxResults,stats:w,messages:[]},R]})})}o(t,r,n,u){const l=(0,T.$2r)(t.filePattern||""),g=(k,S)=>(0,T.$1r)(k,S,l,!0,$,n),y=typeof t.maxResults=="number"?t.maxResults:f.$wM;return s.$Kb(r,g,y,1e4,u)}q(t,r,n){if(n&&n>0)for(let u=0;u<t.length;u+=n)r(t.slice(u,u+n));else r(t)}r(t,r,n,u){const l=c.$ke.create(!1),g=r.indexOf(p.sep)>=0;let y;for(const C in t.resultsToSearchCache)if(r.startsWith(C)){if(g&&C.indexOf(p.sep)<0&&C!=="")continue;const w=t.resultsToSearchCache[C];y={promise:this.t(w.promise),event:w.event,resolved:w.resolved};break}if(!y)return null;const k=l.elapsed(),S=c.$ke.create(!1),R=y.event(n);return u&&u.onCancellationRequested(()=>{R.dispose()}),y.promise.then(([C,w])=>{if(u&&u.isCancellationRequested)throw(0,D.$0)();const b=[],N=(0,T.$2r)(r).normalizedLowercase;for(const L of w)(0,f.$NM)(L,N)&&b.push(L);return[C,b,{cacheWasResolved:y.resolved,cacheLookupTime:k,cacheFilterTime:S.elapsed(),cacheEntryCount:w.length}]})}s(t,r,n,u){return new Promise((l,g)=>{let y=[];u?.onCancellationRequested(()=>t.cancel()),t.search(k=>{k&&(n?(y.push(k),n>0&&y.length>=n&&(r(y),y=[])):r(k))},k=>{r(k)},(k,S)=>{y.length&&r(y),k?(r({message:"Search finished. Error: "+k.message}),g(k)):(r({message:"Search finished. Stats: "+JSON.stringify(S.stats)}),l(S))})})}clearCache(t){return delete this.b[t],Promise.resolve(void 0)}t(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,n){return t.then(r,n)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.$Rtc=o;class m{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const $=new class{getItemLabel(a){return(0,p.$sc)(a.relativePath)}getItemDescription(a){return(0,p.$rc)(a.relativePath)}getItemPath(a){return a.relativePath}};function d(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(i),extraFileResources:a.extraFileResources&&a.extraFileResources.map(t=>I.URI.revive(t))}}function i(a){return(0,A.$hi)(a)}}),define(Re[356],Ce([1,0,3,14,2,34,11,43,29,19,102,74,32,355,353,131,178]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ttc=void 0,O=Ue(O);let $=class extends I.$Gsc{constructor(i,a,t,r,n){super(i,t,n),this.D=r,this.w=O,this.x=-1,this.y=null,this.z=!1,this.B=new s.$Yc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const u=new o.$Ctc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new v.$Stc(u,this.getNumThreadsCached))),a.remote.isRemote&&a.remote.authority&&this.F(),r.getConfigProvider().then(l=>{this.C||this.B.add(l.onDidChangeConfiguration(this.E))})}E(i){i.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const i=new o.$Ctc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new v.$Stc(i,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new P.$Rtc("fileSearchProvider",this.getNumThreadsCached)))}G(i,a){const t=this.d++;return this.y=a,this.x=t,this.c.$registerFileSearchProvider(t,this.s(i)),(0,s.$Xc)(()=>{this.y=null,this.c.$unregisterProvider(t)})}$provideFileSearchResults(i,a,t,r){const n=(0,I.$Hsc)(t);if(i===this.x){const u=Date.now();return this.H(i,a,n,r).then(l=>{const g=Date.now()-u;return this.q.debug(`Ext host file search time: ${g}ms`),l})}return super.$provideFileSearchResults(i,a,t,r)}async doInternalFileSearchWithCustomCallback(i,a,t){const r=u=>{if((0,f.$MM)(u)&&(u=[u]),Array.isArray(u)){t(u.map(l=>D.URI.file(l.path)));return}u.message&&this.q.debug("ExtHostSearch",u.message)};if(!this.y)throw new Error("No internal file search handler");const n=await this.getNumThreadsCached();return this.y.doFileSearch(i,n,r,a)}async H(i,a,t,r){return this.doInternalFileSearchWithCustomCallback(t,r,n=>{this.c.$handleFileMatch(i,a,n)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,a){return new m.$Ptc(i,a,void 0,"textSearchProvider")}};e.$Ttc=$,e.$Ttc=$=Ye([We(0,c.$OQ),We(1,p.$5Q),We(2,E.$nrc),We(3,A.$trc),We(4,T.$fk)],$)}),define(Re[132],Ce([1,0,369,68,69,370,21,12,4,3,16,10,31,87,70]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Bi=e.$Ai=e.$zi=void 0,e.$Ci=l,e.$Di=g,e.$Fi=S,e.$Gi=R;const o=3e4;class m{traceSocketEvent(w,b){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,b)}constructor(w,b=""){this.f=!0,this.debugLabel=b,this.socket=w,this.traceSocketEvent(v.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent(v.SocketDiagnosticsEventType.Error,{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,A.$4)(L)}},this.socket.on("error",this.a);let N;this.b=L=>{this.traceSocketEvent(v.SocketDiagnosticsEventType.Close,{hadError:L}),this.f=!1,N&&clearTimeout(N)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(v.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,N=setTimeout(()=>w.destroy(),o)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(w){const b=N=>{this.traceSocketEvent(v.SocketDiagnosticsEventType.Read,N),w(T.$Se.wrap(N))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(w){const b=N=>{w({type:v.SocketCloseEventType.NodeSocketCloseEvent,hadError:N,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(w){const b=()=>{w()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(w){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(v.SocketDiagnosticsEventType.Write,w),this.socket.write(w.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,A.$4)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,A.$4)(b)}}end(){this.traceSocketEvent(v.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(v.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((w,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(v.SocketDiagnosticsEventType.NodeDrainEnd),w();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent(v.SocketDiagnosticsEventType.NodeDrainEnd),w()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.$zi=m;var $;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var d;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(d||(d={}));class i extends c.$Zc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(w,b){this.socket.traceSocketEvent(w,b)}constructor(w,b,N,L){super(),this.f=this.B(new p.$qe),this.g=this.B(new p.$qe),this.h=!1,this.j={state:d.PeekHeader,readLen:$.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=w,this.traceSocketEvent(v.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:N?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new a(this,b,N,L,this.f,(M,z)=>this.m(M,z))),this.B(this.a.onError(M=>{console.error(M),(0,A.$4)(M),this.g.fire({type:v.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:M})})),this.b=new v.$ui,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this.f.event(w)}onClose(w){return this.g.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){let b=0;for(;b<w.byteLength;)this.a.writeMessage(w.slice(b,Math.min(b+$.MaxWebSocketMessageLength,w.byteLength)),{compressed:!0,opcode:2}),b+=$.MaxWebSocketMessageLength}m(w,{compressed:b,opcode:N}){if(this.h)return;this.traceSocketEvent(v.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,w);let L=$.MinHeaderByteSize;w.byteLength<126?L+=0:w.byteLength<2**16?L+=2:L+=8;const M=T.$Se.alloc(L),z=b?64:0,V=N&15;if(M.writeUInt8(128|z|V,0),w.byteLength<126)M.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){M.writeUInt8(126,1);let F=1;M.writeUInt8(w.byteLength>>>8&255,++F),M.writeUInt8(w.byteLength>>>0&255,++F)}else{M.writeUInt8(127,1);let F=1;M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(w.byteLength>>>24&255,++F),M.writeUInt8(w.byteLength>>>16&255,++F),M.writeUInt8(w.byteLength>>>8&255,++F),M.writeUInt8(w.byteLength>>>0&255,++F)}this.socket.write(T.$Se.concat([M,w]))}end(){this.h=!0,this.socket.end()}n(w){if(w.byteLength!==0){for(this.b.acceptChunk(w);this.b.byteLength>=this.j.readLen;)if(this.j.state===d.PeekHeader){const b=this.b.peek(this.j.readLen),N=b.readUInt8(0),L=(N&128)>>>7,M=(N&64)>>>6,z=N&15,V=b.readUInt8(1),F=(V&128)>>>7,j=V&127;this.j.state=d.ReadHeader,this.j.readLen=$.MinHeaderByteSize+(F?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!L,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent(v.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===d.ReadHeader){const b=this.b.read(this.j.readLen),N=b.readUInt8(1),L=(N&128)>>>7;let M=N&127,z=1;M===126?M=b.readUInt8(++z)*2**8+b.readUInt8(++z):M===127&&(M=b.readUInt8(++z)*0+b.readUInt8(++z)*0+b.readUInt8(++z)*0+b.readUInt8(++z)*0+b.readUInt8(++z)*2**24+b.readUInt8(++z)*2**16+b.readUInt8(++z)*2**8+b.readUInt8(++z));let V=0;L&&(V=b.readUInt8(++z)*2**24+b.readUInt8(++z)*2**16+b.readUInt8(++z)*2**8+b.readUInt8(++z)),this.j.state=d.ReadBody,this.j.readLen=M,this.j.mask=V,this.traceSocketEvent(v.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===d.ReadBody){const b=this.b.read(this.j.readLen);this.traceSocketEvent(v.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,b),n(b,this.j.mask),this.traceSocketEvent(v.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,b),this.j.state=d.PeekHeader,this.j.readLen=$.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(b,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(b,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(v.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(v.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$Ai=i;class a extends c.$Zc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Se.alloc(0)}constructor(w,b,N,L,M,z){super(),this.n=w,this.r=M,this.s=z,this.a=this.B(new p.$qe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$qe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$qe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,b?(this.b=this.B(new t(this.n,L,N,{windowBits:15})),this.f=this.B(new r(this.n,{windowBits:15})),this.B(this.b.onError(V=>this.a.fire(V))),this.B(this.f.onError(V=>this.a.fire(V)))):(this.b=null,this.f=null)}writeMessage(w,b){this.g.push({data:w,options:b}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:w,options:b}=this.g.shift();if(this.f&&b.compressed){const N=await this.w(this.f,w);this.s(N,b)}else this.s(w,{...b,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(w,b){return new Promise((N,L)=>{w.write(b),w.flush(M=>N(M))})}acceptFrame(w,b,N){this.h.push({data:w,isCompressed:b,isLastFrameOfMessage:N}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const w=this.h.shift();if(this.b&&w.isCompressed){const b=await this.C(this.b,w.data,w.isLastFrameOfMessage);this.r.fire(b)}else this.r.fire(w.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(w,b,N){return new Promise((L,M)=>{w.write(b),N&&w.write(T.$Se.fromByteArray([0,0,255,255])),w.flush(z=>L(z))})}}class t extends c.$Zc{get recordedInflateBytes(){return this.j?T.$Se.concat(this.f):T.$Se.alloc(0)}constructor(w,b,N,L){super(),this.h=w,this.j=b,this.a=this.B(new p.$qe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(L),this.b.on("error",M=>{this.h.traceSocketEvent(v.SocketDiagnosticsEventType.zlibInflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent(v.SocketDiagnosticsEventType.zlibInflateData,M),this.g.push(T.$Se.wrap(M))}),N&&(this.h.traceSocketEvent(v.SocketDiagnosticsEventType.zlibInflateInitialWrite,N.buffer),this.b.write(N.buffer),this.b.flush(()=>{this.h.traceSocketEvent(v.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(w){this.j&&this.f.push(w.clone()),this.h.traceSocketEvent(v.SocketDiagnosticsEventType.zlibInflateWrite,w),this.b.write(w.buffer)}flush(w){this.b.flush(()=>{this.h.traceSocketEvent(v.SocketDiagnosticsEventType.zlibInflateFlushFired);const b=T.$Se.concat(this.g);this.g.length=0,w(b)})}}class r extends c.$Zc{constructor(w,b){super(),this.g=w,this.a=this.B(new p.$qe),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",N=>{this.g.traceSocketEvent(v.SocketDiagnosticsEventType.zlibDeflateError,{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.g.traceSocketEvent(v.SocketDiagnosticsEventType.zlibDeflateData,N),this.f.push(T.$Se.wrap(N))})}write(w){this.g.traceSocketEvent(v.SocketDiagnosticsEventType.zlibDeflateWrite,w.buffer),this.b.write(w.buffer)}flush(w){this.b.flush(2,()=>{this.g.traceSocketEvent(v.SocketDiagnosticsEventType.zlibDeflateFlushFired);let b=T.$Se.concat(this.f);this.f.length=0,b=b.slice(0,b.byteLength-4),w(b)})}}function n(C,w){if(w===0)return;const b=C.byteLength>>>2;for(let F=0;F<b;F++){const j=C.readUInt32BE(F*4);C.writeUInt32BE(j^w,F*4)}const N=b*4,L=C.byteLength-N,M=w>>>24&255,z=w>>>16&255,V=w>>>8&255;L>=1&&C.writeUInt8(C.readUInt8(N)^M,N),L>=2&&C.writeUInt8(C.readUInt8(N+1)^z,N+1),L>=3&&C.writeUInt8(C.readUInt8(N+2)^V,N+2)}e.$Bi=process.env.XDG_RUNTIME_DIR;const u={[E.Platform.Linux]:107,[E.Platform.Mac]:103};function l(){const C=(0,f.$7g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const w=process.platform!=="darwin"&&e.$Bi?e.$Bi:(0,D.tmpdir)(),b=(0,I.$oc)(w,`vscode-ipc-${C}.sock`);return y(b),b}function g(C,w,b){const L=(0,s.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${b}-${w}-sock`;const M=b.substr(0,4),z=w.substr(0,6);let V;return process.platform!=="darwin"&&e.$Bi&&!process.env.VSCODE_PORTABLE?V=(0,I.$oc)(e.$Bi,`vscode-${L}-${M}-${z}.sock`):V=(0,I.$oc)(C,`${M}-${z}.sock`),y(V),V}function y(C){const w=u[E.$x];typeof w=="number"&&C.length>=w&&console.warn(`WARNING: IPC handle "${C}" is longer than ${w} chars, try a shorter --user-data-dir`)}class k extends P.$oi{static b(w){const b=p.Event.fromNodeEventEmitter(w,"connection");return p.Event.map(b,N=>({protocol:new v.$vi(new m(N,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(N,"close"))}))}constructor(w){super(k.b(w)),this.d=w}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ei=k;function S(C){return new Promise((w,b)=>{const N=(0,h.createServer)();N.on("error",b),N.listen(C,()=>{N.removeListener("error",b),w(new k(N))})})}function R(C,w){return new Promise((b,N)=>{const L=(0,h.createConnection)(C,()=>{L.removeListener("error",N),b(v.$wi.fromSocket(new m(L,`ipc-client${w}`),w))});L.once("error",N)})}}),define(Re[357],Ce([1,0,68,69,194,132,8,3,10,47,11,115,238,240,117,93,21]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=e.$pjc=e.$ojc=e.$njc=void 0,s=Ue(s),h=Ue(h);async function $(r,n,u,l,g){let y;for(let k=3;k&&(y?.dispose(),y=await new d(r,n,u,l,g).waitForReady(),!(g&&D.$0g[g]||!D.$0g[y.tunnelLocalPort]));k--);return y}class d extends A.$Zc{constructor(n,u,l,g,y){super(),this.m=u,this.n=y,this.privacy=o.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=s.createServer(),this.c=new T.$Jh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=g,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(u=>{u()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,u=(0,o.$Xw)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,D.$$g)(n,2,1e3,u),g=null;return this.b.listen(l,this.m),await this.c.wait(),g=this.b.address(),g||(l=0,this.b.listen(l,this.m),await this.c.wait(),g=this.b.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async r(n){n.pause();const u=(0,o.$Vw)(this.tunnelRemoteHost)||(0,o.$Xw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,f.$8l)(this.a,u,this.tunnelRemotePort),g=l.getSocket(),y=l.readEntireBuffer();l.dispose(),y.byteLength>0&&n.write(y.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),g.end()}),n.on("close",()=>g.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),g instanceof O.$zi?g.socket.destroy():g.end()}),g instanceof O.$zi?this.t(n,g):this.s(n,g),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),g.end()})}s(n,u){u.onClose(()=>n.destroy()),u.onEnd(()=>n.end()),u.onData(l=>n.write(l.buffer)),n.on("data",l=>u.write(m.$Se.wrap(l))),n.resume()}t(n,u){const l=u.socket;l.on("end",()=>n.end()),l.on("close",()=>n.end()),l.on("error",()=>{n.destroy()}),l.pipe(n),n.pipe(l)}}e.$njc=d;let i=class extends o.$1w{constructor(n,u,l,g,y){super(u,y),this.H=n,this.I=l,this.J=g}isPortPrivileged(n){return(0,o.$Yw)(n,this.t,p.OS,h.release())}F(n,u,l,g,y,k,S,R){const C=this.D(u,l);if(C)return++C.refcount,C.value;if((0,o.$Rw)(n))return this.G(n,u,l,y,k,S,R);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${l} on local port ${y}.`);const w={commit:this.J.commit,quality:this.J.quality,addressProvider:n,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},b=$(w,g,u,l,y);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(u,l,b),b}}};e.$ojc=i,e.$ojc=i=Ye([We(0,P.$2l),We(1,I.$fk),We(2,v.$5l),We(3,E.$yk),We(4,c.$ej)],i);let a=class extends i{constructor(n,u,l,g,y){super(n,u,l,g,y)}};e.$pjc=a,e.$pjc=a=Ye([We(0,P.$2l),We(1,I.$fk),We(2,v.$5l),We(3,E.$yk),We(4,c.$ej)],a);let t=class extends A.$Zc{constructor(n,u,l,g,y){super(),this.b=n,this.c=u,this.f=l,this.g=g,this.h=y,this.a=new Map}async openTunnel(n,u,l,g,y,k,S,R,C){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${g} on local port ${k}.`),!this.a.has(n)){const w=new a(this.b,this.c,this.g,this.f,this.h);this.B(w),this.a.set(n,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(u,l,g,y,k,S,R,C)}};e.$qjc=t,e.$qjc=t=Ye([We(0,P.$2l),We(1,I.$fk),We(2,E.$yk),We(3,v.$5l),We(4,c.$ej)],t)}),define(Re[358],Ce([1,0,132,119,46,35,2,11,48]),function(ge,e,s,h,D,O,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eR=e.$dR=void 0,h=Ue(h),D=Ue(D);class c{constructor(f,P,v){this.b=f,this.c=P,this.f=v,this.a=h.createServer((o,m)=>this.h(o,m)),this.g().catch(o=>(P.error(o),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",f=>this.c.error(f))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(f,P){const v=(m,$)=>{P.writeHead(m,{"content-type":"application/json"}),P.end(JSON.stringify($||null),d=>d&&this.c.error(d))},o=[];f.setEncoding("utf8"),f.on("data",m=>o.push(m)),f.on("end",async()=>{try{const m=JSON.parse(o.join(""));let $;switch(m.type){case"open":$=await this.i(m);break;case"openExternal":$=await this.j(m);break;case"status":$=await this.l(m);break;case"extensionManagement":$=await this.k(m);break;case"clipboard":$=await this.m(m);break;default:v(404,`Unknown message type: ${m.type}`);break}v(200,$)}catch(m){const $=m instanceof Error?m.message:JSON.stringify(m);v(500,$),this.c.error("Error while processing pipe request",m)}})}async i(f){const{fileURIs:P,folderURIs:v,forceNewWindow:o,diffMode:m,mergeMode:$,addMode:d,forceReuseWindow:i,gotoLineMode:a,waitMarkerFilePath:t,remoteAuthority:r}=f,n=[];if(Array.isArray(v))for(const y of v)try{n.push({folderUri:T.URI.parse(y)})}catch{}if(Array.isArray(P))for(const y of P)try{(0,p.$dj)(y)?n.push({workspaceUri:T.URI.parse(y)}):n.push({fileUri:T.URI.parse(y)})}catch{}const u=t?T.URI.file(t):void 0,g={forceNewWindow:o,diffMode:m,mergeMode:$,addMode:d,gotoLineMode:a,forceReuseWindow:i,preferNewWindow:!i&&!u&&!d,waitMarkerFileURI:u,remoteAuthority:r};this.b.executeCommand("_remoteCLI.windowOpen",n,g)}async j(f){for(const P of f.uris){const v=T.URI.parse(P),o=v.scheme==="file"?v:P;await this.b.executeCommand("_remoteCLI.openExternal",o)}}async k(f){const P=o=>o?.map(m=>/\.vsix$/i.test(m)?T.URI.parse(m):m),v={list:f.list,install:P(f.install),uninstall:P(f.uninstall),force:f.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(f){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}async m(f){return await this.b.executeCommand("_remoteCLI.setClipboard",f.content)}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&D.existsSync(this.f)&&D.unlinkSync(this.f)}}e.$dR=c;let I=class extends c{constructor(f,P){super(f,P,(0,s.$Ci)())}};e.$eR=I,e.$eR=I=Ye([We(0,O.$$Q),We(1,A.$fk)],I)}),define(Re[359],Ce([1,0,119,63,346,340,255,54,328,2,14,9,358,110,288,42,327]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ytc=void 0,s=Ue(s),h=Ue(h);class $ extends O.$mtc{k(){const a=this,t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(g,y,k){return g=u(g),a.a.has(g)?a.a.get(g).load(g,c.URI.file((0,P.$yr)(y.filename)),S=>r.apply(this,[S,y,k])):r.apply(this,arguments)};const n=t._resolveLookupPaths;t._resolveLookupPaths=(l,g)=>n.call(this,u(l),g);const u=l=>{for(const g of a.b){const y=g(l);if(y){l=y;break}}return l}}}class d extends A.$6rc{constructor(){super(...arguments),this.extensionRuntime=E.ExtensionRuntime.Node}async vb(){this.h.createInstance(v.$Wtc);const a=this.h.invokeFunction(D.$itc);if(this.h.createInstance(p.$Vtc),this.f.remote.isRemote&&this.f.remote.authority){const n=this.h.createInstance(f.$eR);process.env.VSCODE_IPC_HOOK_CLI=n.ipcHandlePath}this.h.createInstance(m.$Xtc),await this.h.createInstance($,a,{mine:this.J,all:this.L}).install(),h.mark("code/extHost/didInitAPI"),(async()=>{const n=process.env.VSCODE_IPC_HOOK_CLI,u=process.env.CODE_SERVER_SESSION_SOCKET;if(!n||!u)return;const g={workspace:this.h.invokeFunction(k=>k.get(o.$qrc).workspace),socketPath:n},y=JSON.stringify({entry:g});await new Promise((k,S)=>{const R={path:"/add-session",socketPath:u,method:"POST",headers:{"content-type":"application/json"}},C=s.request(R,w=>{w.on("error",S),w.on("end",()=>{try{w.statusCode===200?k():S(new Error("Unexpected status code: "+w.statusCode))}catch(b){S(b)}})});C.on("error",S),C.write(y),C.end()})})().catch(n=>{this.s.error(n)});const r=await this.m.getConfigProvider();await(0,T.$Utc)(this.j,r,this,this.s,this.z,this.f),h.mark("code/extHost/didInitProxyResolver")}wb(a){return a.main}async xb(a,t,r){if(t.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${t}', must be of file-scheme`);let n=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${t.toString(!0)}`),this.s.flush();const u=a?.identifier.value;a&&await this.w.initializeLocalizedMessages(a);try{u&&h.mark(`code/extHost/willLoadExtensionCode/${u}`),n=(ge.__$__nodeRequire??ge)(t.fsPath)}finally{u&&h.mark(`code/extHost/didLoadExtensionCode/${u}`),r.codeLoadingStop()}return n}async $setRemoteEnvironment(a){if(this.f.remote.isRemote)for(const t in a){const r=a[t];r===null?delete process.env[t]:process.env[t]=r}}}e.$Ytc=d}),define(Re[360],Ce([1,0,46,58,21,4,3,136,10,22,2,34,70,11,237,73,117,93,357,29,19,78,335]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7tc=void 0,e.$Ztc=n,e.$1tc=u,e.$2tc=l,e.$3tc=g,e.$4tc=k,e.$5tc=S,e.$6tc=R,s=Ue(s),c=Ue(c),E=Ue(E);function n(b){const N=b.trim().split(`
`),L=[];return N.forEach(z=>{const V=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);V&&V.length>=3&&L.push({pid:parseInt(V[1],10),socket:parseInt(V[2],10)})}),L.reduce((z,V)=>(z[V.socket]=V,z),{})}function u(...b){const N=[].concat(...b.map(g));return[...new Map(N.filter(L=>L.st==="0A").map(L=>{const M=L.local_address.split(":");return{socket:parseInt(L.inode,10),ip:l(M[0]),port:parseInt(M[1],16)}}).map(L=>[L.ip+":"+L.port,L])).values()]}function l(b){let N="";if(b.length===8)for(let L=b.length-2;L>=0;L-=2)N+=parseInt(b.substr(L,2),16),L!==0&&(N+=".");else for(let L=0;L<b.length;L+=8){const M=b.substring(L,L+8);let z="";for(let V=8;V>=2;V-=2)z+=M.substring(V-2,V),(V===6||V===2)&&(z=parseInt(z,16).toString(16),N+=`${z}`,z="",L+V!==b.length-6&&(N+=":"))}return N}function g(b){const N=b.trim().split(`
`),L=N.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return N.map(z=>z.trim().split(/\s+/).reduce((V,F,j)=>(V[L[j]||j]=F,V),{}))}function y(b){return!!b.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||b.indexOf("out/server-main.js")!==-1||b.indexOf("_productName=VSCode")!==-1}function k(b){const N=b.trim().split(`
`),L=[];return N.forEach(M=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(M);z&&z.length>=4&&L.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),L}async function S(b,N,L){const M=L.reduce((V,F)=>(V[F.pid]=F,V),{}),z=[];return b.forEach(({socket:V,ip:F,port:j})=>{const W=N[V]?N[V].pid:void 0,J=W?M[W]?.cmd:void 0;W&&J&&!y(J)&&z.push({host:F,port:j,detail:J,pid:W})}),z}function R(b,N,L){const M=new Map,z=k(N);for(const V of b){const F=L.get(V.port);if(F){M.set(V.port,F);continue}const j=z.find(W=>W.cmd.includes(`${V.port}`));if(j){let W=j,J;do J=z.find(B=>B.ppid===W.pid),J&&(W=J);while(J);M.set(V.port,{host:V.ip,port:V.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else M.set(V.port,{host:V.ip,port:V.port,ppid:Number.MAX_VALUE})}return M}let C=class extends t.$kHb{constructor(N,L,M,z){super(N,L,M),this.D=L,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,p.$n&&L.remote.isRemote&&L.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(N){if(N&&this.C)return;this.C=N;let L;this.y&&(L=this.y,await this.a.$onFoundNewCandidates(this.y));const M=new A.$Tm;let z=0;for(;this.C;){const V=new Date().getTime(),F=(await this.I()).filter(J=>(0,$.$Vw)(J.host)||(0,$.$Xw)(J.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(J=>J.port).join(", ")}`);const j=new Date().getTime()-V;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),z++>3&&M.update(j),(!L||JSON.stringify(L)!==JSON.stringify(F))&&(L=F,await this.a.$onFoundNewCandidates(L));const W=this.G(M.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${W} ms.`),await new Promise(J=>setTimeout(()=>J(),W))}}G(N){return Math.max(N*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(N=>N.port).join(", ")}`)}async I(){let N="",L="";try{N=await s.promises.readFile("/proc/net/tcp","utf8"),L=await s.promises.readFile("/proc/net/tcp6","utf8")}catch{}const M=u(N,L),z=await new Promise(_=>{(0,h.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,oe,te)=>{_(oe)})}),V=n(z),F=await E.Promises.readdir("/proc"),j=[];for(const _ of F)try{const x=Number(_),oe=c.$lh(I.URI.file("/proc"),_);if((await s.promises.stat(oe.fsPath)).isDirectory()&&!isNaN(x)){const me=await s.promises.readlink(c.$lh(oe,"cwd").fsPath),ce=await s.promises.readFile(c.$lh(oe,"cmdline").fsPath,"utf8");j.push({pid:x,cwd:me,cmd:ce})}}catch{}const W=[],J=M.filter(_=>{const x=V[_.socket];return x||W.push(_),x}),B=S(J,V,j);let U;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const _=await new Promise(x=>{(0,h.exec)("ps -F -A -l | grep root",(oe,te,me)=>{x(te)})});this.z=R(W,_,this.z),U=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(x=>x.port).join(", ")}`)}return B.then(_=>U?_.concat(U):_)}w(N){return async L=>{const M=new d.$njc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(V,F,j,W){const J=await N.makeConnection();return w.connect(J,F,j,W)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new o.$Xl(0),connectionToken:N.connectionToken})}},signService:this.F},"localhost",L.remoteAddress.host||"localhost",L.remoteAddress.port,L.localAddressPort);await M.waitForReady();const z=new O.$qe;return{localAddress:(0,r.$BN)(M.localAddress)??M.localAddress,remoteAddress:{port:M.tunnelRemotePort,host:M.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{M.dispose(),z.fire(),z.dispose()}}}}};e.$7tc=C,e.$7tc=C=Ye([We(0,a.$OQ),We(1,i.$5Q),We(2,P.$fk),We(3,m.$5l)],C);class w extends v.$Xzb{static connect(N,L,M,z){const V=new T.$Yc,F={onClose:V.add(new O.$qe),onData:V.add(new O.$qe),onEnd:V.add(new O.$qe)};V.add(N.onDidReceiveMessage(W=>F.onData.fire(D.$Se.wrap(W)))),V.add(N.onDidEnd(()=>F.onEnd.fire())),V.add(N.onDidClose(W=>F.onClose.fire({type:f.SocketCloseEventType.NodeSocketCloseEvent,error:W,hadError:!!W})));const j=new w(N,z,F);return j.B(V),(0,v.$Wzb)(j,L,M,z,F)}constructor(N,L,M){super(L,M),this.n=N}write(N){this.n.send(N.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Re[361],Ce([1,0,89,330,343,342,356,359,360,101,54,102,100,49,78,98,329,289,11,344,66,251,112,117,153]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d,i,a,t,r,n,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,s.$2s)(I.$7rc,A.$Ytc,s.InstantiationType.Eager),(0,s.$2s)(d.$gk,$.$9tc,s.InstantiationType.Delayed),(0,s.$2s)(d.$fk,new r.$Hi(t.$ltc,[!1],!0)),(0,s.$2s)(n.$5l,u.$sjc,s.InstantiationType.Delayed),(0,s.$2s)(o.$wrc,m.$8tc,s.InstantiationType.Eager),(0,s.$2s)(c.$esc,O.$ytc,s.InstantiationType.Eager),(0,s.$2s)(E.$Fsc,T.$Ttc,s.InstantiationType.Eager),(0,s.$2s)(f.$9sc,D.$qtc,s.InstantiationType.Eager),(0,s.$2s)(P.$Rrc,h.$ptc,s.InstantiationType.Eager),(0,s.$2s)(v.$jHb,p.$7tc,s.InstantiationType.Eager),(0,s.$2s)(a.$0rc,i.$0tc,s.InstantiationType.Eager)});var Ht=this&&this.__importDefault||function(ge){return ge&&ge.__esModule?ge:{default:ge}};define(Re[371],Ce([1,0,119,372,68,8,21,12,63,110,34,70,132,113,235,341,256,271,94,347,361]),function(ge,e,s,h,D,O,T,A,p,c,I,E,f,P,v,o,m,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),s=Ue(s),h=Ht(h),D=Ue(D),p=Ue(p),v=Ht(v),function(){for(let S=0;S<process.execArgv.length;S++)process.execArgv[S]==="--inspect-port=0"&&(process.execArgv.splice(S,1),S--)}();const i=(0,h.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const k=globalThis._VSCODE_NODE_MODULES.module,S=k._load;k._load=function(R){if(R==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return S.apply(this,arguments)}})();const a=process.exit.bind(process),t=process.on.bind(process);function r(k){process.exit=function(S){if(k)a(S);else{const R=new Error("An extension called process.exit() and this was prevented.");console.warn(R.stack)}},process.crash=function(){const S=new Error("An extension called process.crash() and this was prevented.");console.warn(S.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(S,R){S==="uncaughtException"&&(R=function(){try{return R.call(void 0,arguments)}catch{}}),t(S,R)}}let n=function(k){a()};function u(){const k=(0,$.$on)(process.env);if(k.type===$.ExtHostConnectionType.MessagePort)return new Promise((S,R)=>{const C=w=>{const b=w[0],N=new E.$xi;b.on("message",L=>N.fire(T.$Se.wrap(L.data))),b.on("close",()=>{n("renderer closed the MessagePort")}),b.start(),S({onMessage:N.event,send:L=>b.postMessage(L.buffer)})};process.parentPort.on("message",w=>C(w.ports))});if(k.type===$.ExtHostConnectionType.Socket)return new Promise((S,R)=>{let C=null;const w=setTimeout(()=>{n("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=E.ProtocolConstants.ReconnectionGraceTime,N=E.ProtocolConstants.ReconnectionShortGraceTime,L=new O.$Xh(()=>n("renderer disconnected for too long (1)"),b),M=new O.$Xh(()=>n("renderer disconnected for too long (2)"),N);process.on("message",(V,F)=>{if(V&&V.type==="VSCODE_EXTHOST_IPC_SOCKET"){F.setNoDelay(!0);const j=T.$Se.wrap(Buffer.from(V.initialDataChunk,"base64"));let W;if(V.skipWebSocketFrames)W=new f.$zi(F,"extHost-socket");else{const J=T.$Se.wrap(Buffer.from(V.inflateBytes,"base64"));W=new f.$Ai(new f.$zi(F,"extHost-socket"),V.permessageDeflate,J,!1)}C?(L.cancel(),M.cancel(),C.beginAcceptReconnection(W,j),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(w),C=new E.$yi({socket:W,initialChunk:j}),C.sendResume(),C.onDidDispose(()=>n("renderer disconnected")),S(C),C.onSocketClose(()=>{L.schedule()}))}if(V&&V.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(M.isScheduled())return;L.isScheduled()&&M.schedule()}});const z={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(z)});{const S=k.pipeName;return new Promise((R,C)=>{const w=D.createConnection(S,()=>{w.removeListener("error",C);const b=new E.$yi({socket:new f.$zi(w,"extHost-renderer")});b.sendResume(),R(b)});w.once("error",C),w.on("close",()=>{n("renderer closed the socket")})})}}async function l(){const k=await u();return new class{constructor(){this.a=new E.$xi,this.onMessage=this.a.event,this.b=!1,this.d=k.onMessage(S=>{(0,d.$Kn)(S,d.MessageType.Terminate)?(this.b=!0,this.d.dispose(),n("received terminate message from renderer")):this.a.fire(S)})}send(S){this.b||k.send(S)}async drain(){if(k.drain)return k.drain()}}}function g(k){return new Promise(S=>{const R=k.onMessage(C=>{R.dispose();const w=JSON.parse(C.toString()),b=w.commit,N=v.default.commit;if(b&&N&&b!==N&&a(d.ExtensionHostExitCode.VersionMismatch),w.parentPid){let L=0;setInterval(function(){try{process.kill(w.parentPid,0),L=0}catch(z){z&&z.code==="EPERM"?(L++,L>=3&&n(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):n(`parent process ${w.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let M;try{M=globalThis._VSCODE_NODE_MODULES["native-watchdog"],M.start(w.parentPid)}catch(z){(0,A.$4)(z)}}k.send((0,d.$Jn)(d.MessageType.Initialized)),S({protocol:k,initData:w})});k.send((0,d.$Jn)(d.MessageType.Ready))})}async function y(){const k=[];process.on("unhandledRejection",(L,M)=>{k.push(M),setTimeout(()=>{const z=k.indexOf(M);z>=0&&M.catch(V=>{k.splice(z,1),(0,A.$8)(V)||(console.warn(`rejected promise not handled within 1 second: ${V}`),V&&V.stack&&console.warn(`stack trace: ${V.stack}`),L&&(0,A.$4)(L))})},1e3)}),process.on("rejectionHandled",L=>{const M=k.indexOf(L);M>=0&&k.splice(M,1)}),process.on("uncaughtException",function(L){(0,A.$3)(L)||(0,A.$4)(L)}),p.mark("code/extHost/willConnectToRenderer");const S=await l();p.mark("code/extHost/didConnectToRenderer");const R=await g(S);p.mark("code/extHost/didWaitForInitData");const{initData:C}=R;r(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,P.boolean)(i.skipWorkspaceStorageLock,!1);const w=new class{constructor(){this.pid=process.pid}exit(M){a(M)}fsExists(M){return I.Promises.exists(M)}fsRealpath(M){return(0,c.$xr)(M)}};let b=null;C.remote.authority&&i.transformURIs&&(b=(0,m.$6s)(C.remote.authority));const N=new o.$otc(R.protocol,C,w,b);n=L=>{N.terminate(L);const M=process.env.VSCODE_IPC_HOOK_CLI,z=process.env.CODE_SERVER_SESSION_SOCKET;if(!M||!z)return;const V=JSON.stringify({socketPath:M}),F={path:"/delete-session",socketPath:z,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},j=s.request(F);j.write(V),j.end()}}y().catch(k=>console.log(k))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
