"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/base/common/charCode","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/marshalling","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/iterator","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/ternarySearchTree","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/lazy","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/services/search/common/searchExtTypes","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/base/common/extpath","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/services/search/common/searchExtConversionTypes","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Oe=function(be){for(var e=[],v=0,D=be.length;v<D;v++)e[v]=Re[be[v]];return e};define(Re[71],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=D,e.$di=P,e.$ei=L;function v(R){return(T,m,s)=>{let I=null,b=null;if(typeof s.value=="function"?(I="value",b=s.value):typeof s.get=="function"&&(I="get",b=s.get),!b)throw new Error("not supported");s[I]=R(b,m)}}function D(R,T,m){let s=null,I=null;if(typeof m.value=="function"?(s="value",I=m.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(s="get",I=m.get),!I)throw new Error("not supported");const b=`$memoize$${T}`;m[s]=function(...u){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[b]}}function P(R,T,m){return v((s,I)=>{const b=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...k){this[u]||(this[u]=m?m():void 0),clearTimeout(this[b]),T&&(this[u]=T(this[u],...k),k=[this[u]]),this[b]=setTimeout(()=>{s.apply(this,k),this[u]=m?m():void 0},R)}})}function L(R,T,m){return v((s,I)=>{const b=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,k=`$throttle$lastRun$${I}`,$=`$throttle$pending$${I}`;return function(...r){if(this[u]||(this[u]=m?m():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),T&&(this[u]=T(this[u],...r)),this[$])return;const a=this[k]+R;a<=Date.now()?(this[k]=Date.now(),s.apply(this,[this[u]]),this[u]=m?m():void 0):(this[$]=!0,this[b]=setTimeout(()=>{this[$]=!1,this[k]=Date.now(),s.apply(this,[this[u]]),this[u]=m?m():void 0},a-Date.now()))}})}});var Kn=this&&this.__createBinding||(Object.create?function(be,e,v,D){D===void 0&&(D=v);var P=Object.getOwnPropertyDescriptor(e,v);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(be,D,P)}:function(be,e,v,D){D===void 0&&(D=v),be[D]=e[v]}),Qn=this&&this.__setModuleDefault||(Object.create?function(be,e){Object.defineProperty(be,"default",{enumerable:!0,value:e})}:function(be,e){be.default=e}),Ve=this&&this.__importStar||function(be){if(be&&be.__esModule)return be;var e={};if(be!=null)for(var v in be)v!=="default"&&Object.prototype.hasOwnProperty.call(be,v)&&Kn(e,be,v);return Qn(e,be),e};define(Re[137],Oe([1,0,17]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$c=void 0,e.$_c=P,e.$ad=L,e.$bd=R,e.$cd=T,e.$dd=m,e.$ed=s,v=Ve(v);const D=(k,$)=>k===$;e.$$c=D;function P(k=e.$$c){return($,r)=>v.$yb($,r,k)}function L(){return(k,$)=>JSON.stringify(k)===JSON.stringify($)}function R(){return(k,$)=>k.equals($)}function T(k,$,r){if(r!==void 0){const a=k;return a==null||$===void 0||$===null?$===a:r(a,$)}else{const a=k;return(h,c)=>h==null||c===void 0||c===null?c===h:a(h,c)}}function m(k,$){if(k===$)return!0;if(Array.isArray(k)&&Array.isArray($)){if(k.length!==$.length)return!1;for(let r=0;r<k.length;r++)if(!m(k[r],$[r]))return!1;return!0}if(k&&typeof k=="object"&&$&&typeof $=="object"&&Object.getPrototypeOf(k)===Object.prototype&&Object.getPrototypeOf($)===Object.prototype){const r=k,a=$,h=Object.keys(r),c=Object.keys(a),i=new Set(c);if(h.length!==c.length)return!1;for(const n of h)if(!i.has(n)||!m(r[n],a[n]))return!1;return!0}return!1}function s(k){return JSON.stringify(u(k))}let I=0;const b=new WeakMap;function u(k){if(Array.isArray(k))return k.map(u);if(k&&typeof k=="object")if(Object.getPrototypeOf(k)===Object.prototype){const $=k,r=Object.create(null);for(const a of Object.keys($).sort())r[a]=u($[a]);return r}else{let $=b.get(k);return $===void 0&&($=I++,b.set(k,$)),$+"----2b76a038c20c4bcc"}return k}}),define(Re[97],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=e.$TQ=void 0;class v{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$TQ=v,e.$UQ=new v("id#")}),define(Re[138],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$5n=R,e.$6n=b,e.$7n=u,e.$8n=k,e.$9n=$,e.$0n=r,e.$$n=a,e.$_n=h,e.$ao=c,e.$bo=i,e.$co=n;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,o=!1){let l=0;const g=t.length;let f="",d=0,S=D.Unknown,E=v.None;function y(F){let G=0,x=0;for(;G<F;){const j=t.charCodeAt(l);if(j>=I._0&&j<=I._9)x=x*16+j-I._0;else if(j>=I.A&&j<=I.F)x=x*16+j-I.A+10;else if(j>=I.a&&j<=I.f)x=x*16+j-I.a+10;else break;l++,G++}return G<F&&(x=-1),x}function C(F){l=F,f="",d=0,S=D.Unknown,E=v.None}function O(){const F=l;if(t.charCodeAt(l)===I._0)l++;else for(l++;l<t.length&&s(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===I.dot)if(l++,l<t.length&&s(t.charCodeAt(l)))for(l++;l<t.length&&s(t.charCodeAt(l));)l++;else return E=v.UnexpectedEndOfNumber,t.substring(F,l);let G=l;if(l<t.length&&(t.charCodeAt(l)===I.E||t.charCodeAt(l)===I.e))if(l++,(l<t.length&&t.charCodeAt(l)===I.plus||t.charCodeAt(l)===I.minus)&&l++,l<t.length&&s(t.charCodeAt(l))){for(l++;l<t.length&&s(t.charCodeAt(l));)l++;G=l}else E=v.UnexpectedEndOfNumber;return t.substring(F,G)}function p(){let F="",G=l;for(;;){if(l>=g){F+=t.substring(G,l),E=v.UnexpectedEndOfString;break}const x=t.charCodeAt(l);if(x===I.doubleQuote){F+=t.substring(G,l),l++;break}if(x===I.backslash){if(F+=t.substring(G,l),l++,l>=g){E=v.UnexpectedEndOfString;break}switch(t.charCodeAt(l++)){case I.doubleQuote:F+='"';break;case I.backslash:F+="\\";break;case I.slash:F+="/";break;case I.b:F+="\b";break;case I.f:F+="\f";break;case I.n:F+=`
`;break;case I.r:F+="\r";break;case I.t:F+="	";break;case I.u:{const U=y(4);U>=0?F+=String.fromCharCode(U):E=v.InvalidUnicode;break}default:E=v.InvalidEscapeCharacter}G=l;continue}if(x>=0&&x<=31)if(m(x)){F+=t.substring(G,l),E=v.UnexpectedEndOfString;break}else E=v.InvalidCharacter;l++}return F}function w(){if(f="",E=v.None,d=l,l>=g)return d=g,S=D.EOF;let F=t.charCodeAt(l);if(T(F)){do l++,f+=String.fromCharCode(F),F=t.charCodeAt(l);while(T(F));return S=D.Trivia}if(m(F))return l++,f+=String.fromCharCode(F),F===I.carriageReturn&&t.charCodeAt(l)===I.lineFeed&&(l++,f+=`
`),S=D.LineBreakTrivia;switch(F){case I.openBrace:return l++,S=D.OpenBraceToken;case I.closeBrace:return l++,S=D.CloseBraceToken;case I.openBracket:return l++,S=D.OpenBracketToken;case I.closeBracket:return l++,S=D.CloseBracketToken;case I.colon:return l++,S=D.ColonToken;case I.comma:return l++,S=D.CommaToken;case I.doubleQuote:return l++,f=p(),S=D.StringLiteral;case I.slash:{const G=l-1;if(t.charCodeAt(l+1)===I.slash){for(l+=2;l<g&&!m(t.charCodeAt(l));)l++;return f=t.substring(G,l),S=D.LineCommentTrivia}if(t.charCodeAt(l+1)===I.asterisk){l+=2;const x=g-1;let j=!1;for(;l<x;){if(t.charCodeAt(l)===I.asterisk&&t.charCodeAt(l+1)===I.slash){l+=2,j=!0;break}l++}return j||(l++,E=v.UnexpectedEndOfComment),f=t.substring(G,l),S=D.BlockCommentTrivia}return f+=String.fromCharCode(F),l++,S=D.Unknown}case I.minus:if(f+=String.fromCharCode(F),l++,l===g||!s(t.charCodeAt(l)))return S=D.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return f+=O(),S=D.NumericLiteral;default:for(;l<g&&M(F);)l++,F=t.charCodeAt(l);if(d!==l){switch(f=t.substring(d,l),f){case"true":return S=D.TrueKeyword;case"false":return S=D.FalseKeyword;case"null":return S=D.NullKeyword}return S=D.Unknown}return f+=String.fromCharCode(F),l++,S=D.Unknown}}function M(F){if(T(F)||m(F))return!1;switch(F){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function A(){let F;do F=w();while(F>=D.LineCommentTrivia&&F<=D.Trivia);return F}return{setPosition:C,getPosition:()=>l,scan:o?A:w,getToken:()=>S,getTokenValue:()=>f,getTokenOffset:()=>d,getTokenLength:()=>l-d,getTokenError:()=>E}}function T(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function m(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function s(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function b(t,o){const l=[],g=new Object;let f;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function E(y,C,O,p){d.value=y,d.offset=C,d.length=O,d.type=p,d.colonOffset=void 0,f=d}try{i(t,{onObjectBegin:(y,C)=>{if(o<=y)throw g;f=void 0,S=o>y,l.push("")},onObjectProperty:(y,C,O)=>{if(o<C||(E(y,C,O,"property"),l[l.length-1]=y,o<=C+O))throw g},onObjectEnd:(y,C)=>{if(o<=y)throw g;f=void 0,l.pop()},onArrayBegin:(y,C)=>{if(o<=y)throw g;f=void 0,l.push(0)},onArrayEnd:(y,C)=>{if(o<=y)throw g;f=void 0,l.pop()},onLiteralValue:(y,C,O)=>{if(o<C||(E(y,C,O,n(y)),o<=C+O))throw g},onSeparator:(y,C,O)=>{if(o<=C)throw g;if(y===":"&&f&&f.type==="property")f.colonOffset=C,S=!1,f=void 0;else if(y===","){const p=l[l.length-1];typeof p=="number"?l[l.length-1]=p+1:(S=!0,l[l.length-1]=""),f=void 0}}})}catch(y){if(y!==g)throw y}return{path:l,previousNode:f,isAtPropertyKey:S,matches:y=>{let C=0;for(let O=0;C<y.length&&O<l.length;O++)if(y[C]===l[O]||y[C]==="*")C++;else if(y[C]!=="**")return!1;return C===y.length}}}function u(t,o=[],l=L.DEFAULT){let g=null,f=[];const d=[];function S(y){Array.isArray(f)?f.push(y):g!==null&&(f[g]=y)}return i(t,{onObjectBegin:()=>{const y={};S(y),d.push(f),f=y,g=null},onObjectProperty:y=>{g=y},onObjectEnd:()=>{f=d.pop()},onArrayBegin:()=>{const y=[];S(y),d.push(f),f=y,g=null},onArrayEnd:()=>{f=d.pop()},onLiteralValue:S,onError:(y,C,O)=>{o.push({error:y,offset:C,length:O})}},l),f[0]}function k(t,o=[],l=L.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(y){g.type==="property"&&(g.length=y-g.offset,g=g.parent)}function d(y){return g.children.push(y),y}i(t,{onObjectBegin:y=>{g=d({type:"object",offset:y,length:-1,parent:g,children:[]})},onObjectProperty:(y,C,O)=>{g=d({type:"property",offset:C,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:y,offset:C,length:O,parent:g})},onObjectEnd:(y,C)=>{g.length=y+C-g.offset,g=g.parent,f(y+C)},onArrayBegin:(y,C)=>{g=d({type:"array",offset:y,length:-1,parent:g,children:[]})},onArrayEnd:(y,C)=>{g.length=y+C-g.offset,g=g.parent,f(y+C)},onLiteralValue:(y,C,O)=>{d({type:n(y),offset:C,length:O,parent:g,value:y}),f(C+O)},onSeparator:(y,C,O)=>{g.type==="property"&&(y===":"?g.colonOffset=C:y===","&&f(C))},onError:(y,C,O)=>{o.push({error:y,offset:C,length:O})}},l);const E=g.children[0];return E&&delete E.parent,E}function $(t,o){if(!t)return;let l=t;for(const g of o)if(typeof g=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let f=!1;for(const d of l.children)if(Array.isArray(d.children)&&d.children[0].value===g){l=d.children[1],f=!0;break}if(!f)return}else{const f=g;if(l.type!=="array"||f<0||!Array.isArray(l.children)||f>=l.children.length)return;l=l.children[f]}return l}function r(t){if(!t.parent||!t.parent.children)return[];const o=r(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;o.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&o.push(l)}return o}function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const o=Object.create(null);for(const l of t.children){const g=l.children[1];g&&(o[l.children[0].value]=a(g))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function h(t,o,l=!1){return o>=t.offset&&o<t.offset+t.length||l&&o===t.offset+t.length}function c(t,o,l=!1){if(h(t,o,l)){const g=t.children;if(Array.isArray(g))for(let f=0;f<g.length&&g[f].offset<=o;f++){const d=c(g[f],o,l);if(d)return d}return t}}function i(t,o,l=L.DEFAULT){const g=R(t,!1);function f(ie){return ie?()=>ie(g.getTokenOffset(),g.getTokenLength()):()=>!0}function d(ie){return ie?ue=>ie(ue,g.getTokenOffset(),g.getTokenLength()):()=>!0}const S=f(o.onObjectBegin),E=d(o.onObjectProperty),y=f(o.onObjectEnd),C=f(o.onArrayBegin),O=f(o.onArrayEnd),p=d(o.onLiteralValue),w=d(o.onSeparator),M=f(o.onComment),A=d(o.onError),F=l&&l.disallowComments,G=l&&l.allowTrailingComma;function x(){for(;;){const ie=g.scan();switch(g.getTokenError()){case v.InvalidUnicode:j(P.InvalidUnicode);break;case v.InvalidEscapeCharacter:j(P.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:j(P.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:F||j(P.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:j(P.UnexpectedEndOfString);break;case v.InvalidCharacter:j(P.InvalidCharacter);break}switch(ie){case D.LineCommentTrivia:case D.BlockCommentTrivia:F?j(P.InvalidCommentToken):M();break;case D.Unknown:j(P.InvalidSymbol);break;case D.Trivia:case D.LineBreakTrivia:break;default:return ie}}}function j(ie,ue=[],_=[]){if(A(ie),ue.length+_.length>0){let $e=g.getToken();for(;$e!==D.EOF;){if(ue.indexOf($e)!==-1){x();break}else if(_.indexOf($e)!==-1)break;$e=x()}}}function U(ie){const ue=g.getTokenValue();return ie?p(ue):E(ue),x(),!0}function J(){switch(g.getToken()){case D.NumericLiteral:{let ie=0;try{ie=JSON.parse(g.getTokenValue()),typeof ie!="number"&&(j(P.InvalidNumberFormat),ie=0)}catch{j(P.InvalidNumberFormat)}p(ie);break}case D.NullKeyword:p(null);break;case D.TrueKeyword:p(!0);break;case D.FalseKeyword:p(!1);break;default:return!1}return x(),!0}function Z(){return g.getToken()!==D.StringLiteral?(j(P.PropertyNameExpected,[],[D.CloseBraceToken,D.CommaToken]),!1):(U(!1),g.getToken()===D.ColonToken?(w(":"),x(),oe()||j(P.ValueExpected,[],[D.CloseBraceToken,D.CommaToken])):j(P.ColonExpected,[],[D.CloseBraceToken,D.CommaToken]),!0)}function ae(){S(),x();let ie=!1;for(;g.getToken()!==D.CloseBraceToken&&g.getToken()!==D.EOF;){if(g.getToken()===D.CommaToken){if(ie||j(P.ValueExpected,[],[]),w(","),x(),g.getToken()===D.CloseBraceToken&&G)break}else ie&&j(P.CommaExpected,[],[]);Z()||j(P.ValueExpected,[],[D.CloseBraceToken,D.CommaToken]),ie=!0}return y(),g.getToken()!==D.CloseBraceToken?j(P.CloseBraceExpected,[D.CloseBraceToken],[]):x(),!0}function ee(){C(),x();let ie=!1;for(;g.getToken()!==D.CloseBracketToken&&g.getToken()!==D.EOF;){if(g.getToken()===D.CommaToken){if(ie||j(P.ValueExpected,[],[]),w(","),x(),g.getToken()===D.CloseBracketToken&&G)break}else ie&&j(P.CommaExpected,[],[]);oe()||j(P.ValueExpected,[],[D.CloseBracketToken,D.CommaToken]),ie=!0}return O(),g.getToken()!==D.CloseBracketToken?j(P.CloseBracketExpected,[D.CloseBracketToken],[]):x(),!0}function oe(){switch(g.getToken()){case D.OpenBracketToken:return ee();case D.OpenBraceToken:return ae();case D.StringLiteral:return U(!0);default:return J()}}return x(),g.getToken()===D.EOF?l.allowEmptyContent?!0:(j(P.ValueExpected,[],[]),!1):oe()?(g.getToken()!==D.EOF&&j(P.EndOfFileExpected,[],[]),!0):(j(P.ValueExpected,[],[]),!1)}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Re[139],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=v;function v(L){let R=!1;const T=new Map,m=new Map;if(P(L,r=>{if(L===r)return!0;const a=JSON.stringify(r);if(a.length<30)return!0;const h=T.get(a);if(!h){const c={schemas:[r]};return T.set(a,c),m.set(r,c),!0}return h.schemas.push(r),m.set(r,h),R=!0,!1}),T.clear(),!R)return JSON.stringify(L);let I="$defs";for(;L.hasOwnProperty(I);)I+="_";const b=[];function u(r){return JSON.stringify(r,(a,h)=>{if(h!==r){const c=m.get(h);if(c&&c.schemas.length>1)return c.id||(c.id=`_${b.length}`,b.push(c.schemas[0])),{$ref:`#/${I}/${c.id}`}}return h})}const k=u(L),$=[];for(let r=0;r<b.length;r++)$.push(`"_${r}":${u(b[r])}`);return $.length?`${k.substring(0,k.length-1)},"${I}":{${$.join(",")}}}`:k}function D(L){return typeof L=="object"&&L!==null}function P(L,R){if(!L||typeof L!="object")return;const T=(...k)=>{for(const $ of k)D($)&&b.push($)},m=(...k)=>{for(const $ of k)if(D($))for(const r in $){const a=$[r];D(a)&&b.push(a)}},s=(...k)=>{for(const $ of k)if(Array.isArray($))for(const r of $)D(r)&&b.push(r)},I=k=>{if(Array.isArray(k))for(const $ of k)D($)&&b.push($);else D(k)&&b.push(k)},b=[L];let u=b.pop();for(;u;)R(u)&&(T(u.additionalItems,u.additionalProperties,u.not,u.contains,u.propertyNames,u.if,u.then,u.else,u.unevaluatedItems,u.unevaluatedProperties),m(u.definitions,u.$defs,u.properties,u.patternProperties,u.dependencies,u.dependentSchemas),s(u.anyOf,u.allOf,u.oneOf,u.prefixItems),I(u.items)),u=b.pop()}}),function(be,e){typeof define=="function"&&define.amd?define(Re[140],Oe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}be.defaults=e();function v(Ye){be.defaults=Ye}const D=/[&<>"']/,P=new RegExp(D.source,"g"),L=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,R=new RegExp(L.source,"g"),T={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=Ye=>T[Ye];function s(Ye,he){if(he){if(D.test(Ye))return Ye.replace(P,m)}else if(L.test(Ye))return Ye.replace(R,m);return Ye}const I=/(^|[^\[])\^/g;function b(Ye,he){let pe=typeof Ye=="string"?Ye:Ye.source;he=he||"";const ye={replace:(Ce,fe)=>{let ve=typeof fe=="string"?fe:fe.source;return ve=ve.replace(I,"$1"),pe=pe.replace(Ce,ve),ye},getRegex:()=>new RegExp(pe,he)};return ye}function u(Ye){try{Ye=encodeURI(Ye).replace(/%25/g,"%")}catch{return null}return Ye}const k={exec:()=>null};function $(Ye,he){const pe=Ye.replace(/\|/g,(fe,ve,Y)=>{let W=!1,de=ve;for(;--de>=0&&Y[de]==="\\";)W=!W;return W?"|":" |"}),ye=pe.split(/ \|/);let Ce=0;if(ye[0].trim()||ye.shift(),ye.length>0&&!ye[ye.length-1].trim()&&ye.pop(),he)if(ye.length>he)ye.splice(he);else for(;ye.length<he;)ye.push("");for(;Ce<ye.length;Ce++)ye[Ce]=ye[Ce].trim().replace(/\\\|/g,"|");return ye}function r(Ye,he,pe){const ye=Ye.length;if(ye===0)return"";let Ce=0;for(;Ce<ye;){const fe=Ye.charAt(ye-Ce-1);if(fe===he&&!pe)Ce++;else if(fe!==he&&pe)Ce++;else break}return Ye.slice(0,ye-Ce)}function a(Ye,he){if(Ye.indexOf(he[1])===-1)return-1;let pe=0;for(let ye=0;ye<Ye.length;ye++)if(Ye[ye]==="\\")ye++;else if(Ye[ye]===he[0])pe++;else if(Ye[ye]===he[1]&&(pe--,pe<0))return ye;return-1}function h(Ye,he,pe,ye){const Ce=he.href,fe=he.title?s(he.title):null,ve=Ye[1].replace(/\\([\[\]])/g,"$1");if(Ye[0].charAt(0)!=="!"){ye.state.inLink=!0;const Y={type:"link",raw:pe,href:Ce,title:fe,text:ve,tokens:ye.inlineTokens(ve)};return ye.state.inLink=!1,Y}return{type:"image",raw:pe,href:Ce,title:fe,text:s(ve)}}function c(Ye,he){const pe=Ye.match(/^(\s+)(?:```)/);if(pe===null)return he;const ye=pe[1];return he.split(`
`).map(Ce=>{const fe=Ce.match(/^\s+/);if(fe===null)return Ce;const[ve]=fe;return ve.length>=ye.length?Ce.slice(ye.length):Ce}).join(`
`)}class i{options;rules;lexer;constructor(he){this.options=he||be.defaults}space(he){const pe=this.rules.block.newline.exec(he);if(pe&&pe[0].length>0)return{type:"space",raw:pe[0]}}code(he){const pe=this.rules.block.code.exec(he);if(pe){const ye=pe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:pe[0],codeBlockStyle:"indented",text:this.options.pedantic?ye:r(ye,`
`)}}}fences(he){const pe=this.rules.block.fences.exec(he);if(pe){const ye=pe[0],Ce=c(ye,pe[3]||"");return{type:"code",raw:ye,lang:pe[2]?pe[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):pe[2],text:Ce}}}heading(he){const pe=this.rules.block.heading.exec(he);if(pe){let ye=pe[2].trim();if(/#$/.test(ye)){const Ce=r(ye,"#");(this.options.pedantic||!Ce||/ $/.test(Ce))&&(ye=Ce.trim())}return{type:"heading",raw:pe[0],depth:pe[1].length,text:ye,tokens:this.lexer.inline(ye)}}}hr(he){const pe=this.rules.block.hr.exec(he);if(pe)return{type:"hr",raw:r(pe[0],`
`)}}blockquote(he){const pe=this.rules.block.blockquote.exec(he);if(pe){let ye=r(pe[0],`
`).split(`
`),Ce="",fe="";const ve=[];for(;ye.length>0;){let Y=!1;const W=[];let de;for(de=0;de<ye.length;de++)if(/^ {0,3}>/.test(ye[de]))W.push(ye[de]),Y=!0;else if(!Y)W.push(ye[de]);else break;ye=ye.slice(de);const je=W.join(`
`),He=je.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");Ce=Ce?`${Ce}
${je}`:je,fe=fe?`${fe}
${He}`:He;const st=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(He,ve,!0),this.lexer.state.top=st,ye.length===0)break;const dt=ve[ve.length-1];if(dt?.type==="code")break;if(dt?.type==="blockquote"){const mt=dt,Ot=mt.raw+`
`+ye.join(`
`),Tt=this.blockquote(Ot);ve[ve.length-1]=Tt,Ce=Ce.substring(0,Ce.length-mt.raw.length)+Tt.raw,fe=fe.substring(0,fe.length-mt.text.length)+Tt.text;break}else if(dt?.type==="list"){const mt=dt,Ot=mt.raw+`
`+ye.join(`
`),Tt=this.list(Ot);ve[ve.length-1]=Tt,Ce=Ce.substring(0,Ce.length-dt.raw.length)+Tt.raw,fe=fe.substring(0,fe.length-mt.raw.length)+Tt.raw,ye=Ot.substring(ve[ve.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:Ce,tokens:ve,text:fe}}}list(he){let pe=this.rules.block.list.exec(he);if(pe){let ye=pe[1].trim();const Ce=ye.length>1,fe={type:"list",raw:"",ordered:Ce,start:Ce?+ye.slice(0,-1):"",loose:!1,items:[]};ye=Ce?`\\d{1,9}\\${ye.slice(-1)}`:`\\${ye}`,this.options.pedantic&&(ye=Ce?ye:"[*+-]");const ve=new RegExp(`^( {0,3}${ye})((?:[	 ][^\\n]*)?(?:\\n|$))`);let Y=!1;for(;he;){let W=!1,de="",je="";if(!(pe=ve.exec(he))||this.rules.block.hr.test(he))break;de=pe[0],he=he.substring(de.length);let He=pe[2].split(`
`,1)[0].replace(/^\t+/,Ht=>" ".repeat(3*Ht.length)),st=he.split(`
`,1)[0],dt=!He.trim(),mt=0;if(this.options.pedantic?(mt=2,je=He.trimStart()):dt?mt=pe[1].length+1:(mt=pe[2].search(/[^ ]/),mt=mt>4?1:mt,je=He.slice(mt),mt+=pe[1].length),dt&&/^ *$/.test(st)&&(de+=st+`
`,he=he.substring(st.length+1),W=!0),!W){const Ht=new RegExp(`^ {0,${Math.min(3,mt-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),_t=new RegExp(`^ {0,${Math.min(3,mt-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),Xe=new RegExp(`^ {0,${Math.min(3,mt-1)}}(?:\`\`\`|~~~)`),At=new RegExp(`^ {0,${Math.min(3,mt-1)}}#`);for(;he;){const Ut=he.split(`
`,1)[0];if(st=Ut,this.options.pedantic&&(st=st.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(st)||At.test(st)||Ht.test(st)||_t.test(he))break;if(st.search(/[^ ]/)>=mt||!st.trim())je+=`
`+st.slice(mt);else{if(dt||He.search(/[^ ]/)>=4||Xe.test(He)||At.test(He)||_t.test(He))break;je+=`
`+st}!dt&&!st.trim()&&(dt=!0),de+=Ut+`
`,he=he.substring(Ut.length+1),He=st.slice(mt)}}fe.loose||(Y?fe.loose=!0:/\n *\n *$/.test(de)&&(Y=!0));let Ot=null,Tt;this.options.gfm&&(Ot=/^\[[ xX]\] /.exec(je),Ot&&(Tt=Ot[0]!=="[ ] ",je=je.replace(/^\[[ xX]\] +/,""))),fe.items.push({type:"list_item",raw:de,task:!!Ot,checked:Tt,loose:!1,text:je,tokens:[]}),fe.raw+=de}fe.items[fe.items.length-1].raw=fe.items[fe.items.length-1].raw.trimEnd(),fe.items[fe.items.length-1].text=fe.items[fe.items.length-1].text.trimEnd(),fe.raw=fe.raw.trimEnd();for(let W=0;W<fe.items.length;W++)if(this.lexer.state.top=!1,fe.items[W].tokens=this.lexer.blockTokens(fe.items[W].text,[]),!fe.loose){const de=fe.items[W].tokens.filter(He=>He.type==="space"),je=de.length>0&&de.some(He=>/\n.*\n/.test(He.raw));fe.loose=je}if(fe.loose)for(let W=0;W<fe.items.length;W++)fe.items[W].loose=!0;return fe}}html(he){const pe=this.rules.block.html.exec(he);if(pe)return{type:"html",block:!0,raw:pe[0],pre:pe[1]==="pre"||pe[1]==="script"||pe[1]==="style",text:pe[0]}}def(he){const pe=this.rules.block.def.exec(he);if(pe){const ye=pe[1].toLowerCase().replace(/\s+/g," "),Ce=pe[2]?pe[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",fe=pe[3]?pe[3].substring(1,pe[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):pe[3];return{type:"def",tag:ye,raw:pe[0],href:Ce,title:fe}}}table(he){const pe=this.rules.block.table.exec(he);if(!pe||!/[:|]/.test(pe[2]))return;const ye=$(pe[1]),Ce=pe[2].replace(/^\||\| *$/g,"").split("|"),fe=pe[3]&&pe[3].trim()?pe[3].replace(/\n[ \t]*$/,"").split(`
`):[],ve={type:"table",raw:pe[0],header:[],align:[],rows:[]};if(ye.length===Ce.length){for(const Y of Ce)/^ *-+: *$/.test(Y)?ve.align.push("right"):/^ *:-+: *$/.test(Y)?ve.align.push("center"):/^ *:-+ *$/.test(Y)?ve.align.push("left"):ve.align.push(null);for(let Y=0;Y<ye.length;Y++)ve.header.push({text:ye[Y],tokens:this.lexer.inline(ye[Y]),header:!0,align:ve.align[Y]});for(const Y of fe)ve.rows.push($(Y,ve.header.length).map((W,de)=>({text:W,tokens:this.lexer.inline(W),header:!1,align:ve.align[de]})));return ve}}lheading(he){const pe=this.rules.block.lheading.exec(he);if(pe)return{type:"heading",raw:pe[0],depth:pe[2].charAt(0)==="="?1:2,text:pe[1],tokens:this.lexer.inline(pe[1])}}paragraph(he){const pe=this.rules.block.paragraph.exec(he);if(pe){const ye=pe[1].charAt(pe[1].length-1)===`
`?pe[1].slice(0,-1):pe[1];return{type:"paragraph",raw:pe[0],text:ye,tokens:this.lexer.inline(ye)}}}text(he){const pe=this.rules.block.text.exec(he);if(pe)return{type:"text",raw:pe[0],text:pe[0],tokens:this.lexer.inline(pe[0])}}escape(he){const pe=this.rules.inline.escape.exec(he);if(pe)return{type:"escape",raw:pe[0],text:s(pe[1])}}tag(he){const pe=this.rules.inline.tag.exec(he);if(pe)return!this.lexer.state.inLink&&/^<a /i.test(pe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(pe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:pe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:pe[0]}}link(he){const pe=this.rules.inline.link.exec(he);if(pe){const ye=pe[2].trim();if(!this.options.pedantic&&/^</.test(ye)){if(!/>$/.test(ye))return;const ve=r(ye.slice(0,-1),"\\");if((ye.length-ve.length)%2===0)return}else{const ve=a(pe[2],"()");if(ve>-1){const W=(pe[0].indexOf("!")===0?5:4)+pe[1].length+ve;pe[2]=pe[2].substring(0,ve),pe[0]=pe[0].substring(0,W).trim(),pe[3]=""}}let Ce=pe[2],fe="";if(this.options.pedantic){const ve=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);ve&&(Ce=ve[1],fe=ve[3])}else fe=pe[3]?pe[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(ye)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),h(pe,{href:Ce&&Ce.replace(this.rules.inline.anyPunctuation,"$1"),title:fe&&fe.replace(this.rules.inline.anyPunctuation,"$1")},pe[0],this.lexer)}}reflink(he,pe){let ye;if((ye=this.rules.inline.reflink.exec(he))||(ye=this.rules.inline.nolink.exec(he))){const Ce=(ye[2]||ye[1]).replace(/\s+/g," "),fe=pe[Ce.toLowerCase()];if(!fe){const ve=ye[0].charAt(0);return{type:"text",raw:ve,text:ve}}return h(ye,fe,ye[0],this.lexer)}}emStrong(he,pe,ye=""){let Ce=this.rules.inline.emStrongLDelim.exec(he);if(!Ce||Ce[3]&&ye.match(/[\p{L}\p{N}]/u))return;if(!(Ce[1]||Ce[2]||"")||!ye||this.rules.inline.punctuation.exec(ye)){const ve=[...Ce[0]].length-1;let Y,W,de=ve,je=0;const He=Ce[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(He.lastIndex=0,pe=pe.slice(-1*he.length+ve);(Ce=He.exec(pe))!=null;){if(Y=Ce[1]||Ce[2]||Ce[3]||Ce[4]||Ce[5]||Ce[6],!Y)continue;if(W=[...Y].length,Ce[3]||Ce[4]){de+=W;continue}else if((Ce[5]||Ce[6])&&ve%3&&!((ve+W)%3)){je+=W;continue}if(de-=W,de>0)continue;W=Math.min(W,W+de+je);const st=[...Ce[0]][0].length,dt=he.slice(0,ve+Ce.index+st+W);if(Math.min(ve,W)%2){const Ot=dt.slice(1,-1);return{type:"em",raw:dt,text:Ot,tokens:this.lexer.inlineTokens(Ot)}}const mt=dt.slice(2,-2);return{type:"strong",raw:dt,text:mt,tokens:this.lexer.inlineTokens(mt)}}}}codespan(he){const pe=this.rules.inline.code.exec(he);if(pe){let ye=pe[2].replace(/\n/g," ");const Ce=/[^ ]/.test(ye),fe=/^ /.test(ye)&&/ $/.test(ye);return Ce&&fe&&(ye=ye.substring(1,ye.length-1)),ye=s(ye,!0),{type:"codespan",raw:pe[0],text:ye}}}br(he){const pe=this.rules.inline.br.exec(he);if(pe)return{type:"br",raw:pe[0]}}del(he){const pe=this.rules.inline.del.exec(he);if(pe)return{type:"del",raw:pe[0],text:pe[2],tokens:this.lexer.inlineTokens(pe[2])}}autolink(he){const pe=this.rules.inline.autolink.exec(he);if(pe){let ye,Ce;return pe[2]==="@"?(ye=s(pe[1]),Ce="mailto:"+ye):(ye=s(pe[1]),Ce=ye),{type:"link",raw:pe[0],text:ye,href:Ce,tokens:[{type:"text",raw:ye,text:ye}]}}}url(he){let pe;if(pe=this.rules.inline.url.exec(he)){let ye,Ce;if(pe[2]==="@")ye=s(pe[0]),Ce="mailto:"+ye;else{let fe;do fe=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])?.[0]??"";while(fe!==pe[0]);ye=s(pe[0]),pe[1]==="www."?Ce="http://"+pe[0]:Ce=pe[0]}return{type:"link",raw:pe[0],text:ye,href:Ce,tokens:[{type:"text",raw:ye,text:ye}]}}}inlineText(he){const pe=this.rules.inline.text.exec(he);if(pe){let ye;return this.lexer.state.inRawBlock?ye=pe[0]:ye=s(pe[0]),{type:"text",raw:pe[0],text:ye}}}}const n=/^(?: *(?:\n|$))+/,t=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,o=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,l=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,g=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,f=/(?:[*+-]|\d{1,9}[.)])/,d=b(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,f).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),S=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,E=/^[^\n]+/,y=/(?!\s*\])(?:\\.|[^\[\]\\])+/,C=b(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",y).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),O=b(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,f).getRegex(),p="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",w=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,M=b("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",w).replace("tag",p).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),A=b(S).replace("hr",l).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",p).getRegex(),G={blockquote:b(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",A).getRegex(),code:t,def:C,fences:o,heading:g,hr:l,html:M,lheading:d,list:O,newline:n,paragraph:A,table:k,text:E},x=b("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",l).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",p).getRegex(),j={...G,table:x,paragraph:b(S).replace("hr",l).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",x).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",p).getRegex()},U={...G,html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",w).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:k,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:b(S).replace("hr",l).replace("heading",` *#{1,6} *[^
]`).replace("lheading",d).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},J=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,Z=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,ae=/^( {2,}|\\)\n(?!\s*$)/,ee=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,oe="\\p{P}\\p{S}",ie=b(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,oe).getRegex(),ue=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,_=b(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,oe).getRegex(),$e=b("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,oe).getRegex(),Ie=b("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,oe).getRegex(),X=b(/\\([punct])/,"gu").replace(/punct/g,oe).getRegex(),V=b(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),re=b(w).replace("(?:-->|$)","-->").getRegex(),we=b("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",re).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),Pe=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Fe=b(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",Pe).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),Be=b(/^!?\[(label)\]\[(ref)\]/).replace("label",Pe).replace("ref",y).getRegex(),xe=b(/^!?\[(ref)\](?:\[\])?/).replace("ref",y).getRegex(),nt=b("reflink|nolink(?!\\()","g").replace("reflink",Be).replace("nolink",xe).getRegex(),ht={_backpedal:k,anyPunctuation:X,autolink:V,blockSkip:ue,br:ae,code:Z,del:k,emStrongLDelim:_,emStrongRDelimAst:$e,emStrongRDelimUnd:Ie,escape:J,link:Fe,nolink:xe,punctuation:ie,reflink:Be,reflinkSearch:nt,tag:we,text:ee,url:k},$t={...ht,link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",Pe).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Pe).getRegex()},ut={...ht,escape:b(J).replace("])","~|])").getRegex(),url:b(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},et={...ut,br:b(ae).replace("{2,}","*").getRegex(),text:b(ut.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},Le={normal:G,gfm:j,pedantic:U},Ne={normal:ht,gfm:ut,breaks:et,pedantic:$t};class Me{tokens;options;state;tokenizer;inlineQueue;constructor(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||be.defaults,this.options.tokenizer=this.options.tokenizer||new i,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const pe={block:Le.normal,inline:Ne.normal};this.options.pedantic?(pe.block=Le.pedantic,pe.inline=Ne.pedantic):this.options.gfm&&(pe.block=Le.gfm,this.options.breaks?pe.inline=Ne.breaks:pe.inline=Ne.gfm),this.tokenizer.rules=pe}static get rules(){return{block:Le,inline:Ne}}static lex(he,pe){return new Me(pe).lex(he)}static lexInline(he,pe){return new Me(pe).inlineTokens(he)}lex(he){he=he.replace(/\r\n|\r/g,`
`),this.blockTokens(he,this.tokens);for(let pe=0;pe<this.inlineQueue.length;pe++){const ye=this.inlineQueue[pe];this.inlineTokens(ye.src,ye.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(he,pe=[],ye=!1){this.options.pedantic?he=he.replace(/\t/g,"    ").replace(/^ +$/gm,""):he=he.replace(/^( *)(\t+)/gm,(Y,W,de)=>W+"    ".repeat(de.length));let Ce,fe,ve;for(;he;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(Y=>(Ce=Y.call({lexer:this},he,pe))?(he=he.substring(Ce.raw.length),pe.push(Ce),!0):!1))){if(Ce=this.tokenizer.space(he)){he=he.substring(Ce.raw.length),Ce.raw.length===1&&pe.length>0?pe[pe.length-1].raw+=`
`:pe.push(Ce);continue}if(Ce=this.tokenizer.code(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce);continue}if(Ce=this.tokenizer.fences(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.heading(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.hr(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.blockquote(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.list(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.html(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.def(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[Ce.tag]||(this.tokens.links[Ce.tag]={href:Ce.href,title:Ce.title});continue}if(Ce=this.tokenizer.table(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.lheading(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(ve=he,this.options.extensions&&this.options.extensions.startBlock){let Y=1/0;const W=he.slice(1);let de;this.options.extensions.startBlock.forEach(je=>{de=je.call({lexer:this},W),typeof de=="number"&&de>=0&&(Y=Math.min(Y,de))}),Y<1/0&&Y>=0&&(ve=he.substring(0,Y+1))}if(this.state.top&&(Ce=this.tokenizer.paragraph(ve))){fe=pe[pe.length-1],ye&&fe?.type==="paragraph"?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce),ye=ve.length!==he.length,he=he.substring(Ce.raw.length);continue}if(Ce=this.tokenizer.text(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce);continue}if(he){const Y="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return this.state.top=!0,pe}inline(he,pe=[]){return this.inlineQueue.push({src:he,tokens:pe}),pe}inlineTokens(he,pe=[]){let ye,Ce,fe,ve=he,Y,W,de;if(this.tokens.links){const je=Object.keys(this.tokens.links);if(je.length>0)for(;(Y=this.tokenizer.rules.inline.reflinkSearch.exec(ve))!=null;)je.includes(Y[0].slice(Y[0].lastIndexOf("[")+1,-1))&&(ve=ve.slice(0,Y.index)+"["+"a".repeat(Y[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Y=this.tokenizer.rules.inline.blockSkip.exec(ve))!=null;)ve=ve.slice(0,Y.index)+"["+"a".repeat(Y[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Y=this.tokenizer.rules.inline.anyPunctuation.exec(ve))!=null;)ve=ve.slice(0,Y.index)+"++"+ve.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;he;)if(W||(de=""),W=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(je=>(ye=je.call({lexer:this},he,pe))?(he=he.substring(ye.raw.length),pe.push(ye),!0):!1))){if(ye=this.tokenizer.escape(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.tag(he)){he=he.substring(ye.raw.length),Ce=pe[pe.length-1],Ce&&ye.type==="text"&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(ye=this.tokenizer.link(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.reflink(he,this.tokens.links)){he=he.substring(ye.raw.length),Ce=pe[pe.length-1],Ce&&ye.type==="text"&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(ye=this.tokenizer.emStrong(he,ve,de)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.codespan(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.br(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.del(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.autolink(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(!this.state.inLink&&(ye=this.tokenizer.url(he))){he=he.substring(ye.raw.length),pe.push(ye);continue}if(fe=he,this.options.extensions&&this.options.extensions.startInline){let je=1/0;const He=he.slice(1);let st;this.options.extensions.startInline.forEach(dt=>{st=dt.call({lexer:this},He),typeof st=="number"&&st>=0&&(je=Math.min(je,st))}),je<1/0&&je>=0&&(fe=he.substring(0,je+1))}if(ye=this.tokenizer.inlineText(fe)){he=he.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(de=ye.raw.slice(-1)),W=!0,Ce=pe[pe.length-1],Ce&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(he){const je="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return pe}}class q{options;parser;constructor(he){this.options=he||be.defaults}space(he){return""}code({text:he,lang:pe,escaped:ye}){const Ce=(pe||"").match(/^\S*/)?.[0],fe=he.replace(/\n$/,"")+`
`;return Ce?'<pre><code class="language-'+s(Ce)+'">'+(ye?fe:s(fe,!0))+`</code></pre>
`:"<pre><code>"+(ye?fe:s(fe,!0))+`</code></pre>
`}blockquote({tokens:he}){return`<blockquote>
${this.parser.parse(he)}</blockquote>
`}html({text:he}){return he}heading({tokens:he,depth:pe}){return`<h${pe}>${this.parser.parseInline(he)}</h${pe}>
`}hr(he){return`<hr>
`}list(he){const pe=he.ordered,ye=he.start;let Ce="";for(let Y=0;Y<he.items.length;Y++){const W=he.items[Y];Ce+=this.listitem(W)}const fe=pe?"ol":"ul",ve=pe&&ye!==1?' start="'+ye+'"':"";return"<"+fe+ve+`>
`+Ce+"</"+fe+`>
`}listitem(he){let pe="";if(he.task){const ye=this.checkbox({checked:!!he.checked});he.loose?he.tokens.length>0&&he.tokens[0].type==="paragraph"?(he.tokens[0].text=ye+" "+he.tokens[0].text,he.tokens[0].tokens&&he.tokens[0].tokens.length>0&&he.tokens[0].tokens[0].type==="text"&&(he.tokens[0].tokens[0].text=ye+" "+he.tokens[0].tokens[0].text)):he.tokens.unshift({type:"text",raw:ye+" ",text:ye+" "}):pe+=ye+" "}return pe+=this.parser.parse(he.tokens,!!he.loose),`<li>${pe}</li>
`}checkbox({checked:he}){return"<input "+(he?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:he}){return`<p>${this.parser.parseInline(he)}</p>
`}table(he){let pe="",ye="";for(let fe=0;fe<he.header.length;fe++)ye+=this.tablecell(he.header[fe]);pe+=this.tablerow({text:ye});let Ce="";for(let fe=0;fe<he.rows.length;fe++){const ve=he.rows[fe];ye="";for(let Y=0;Y<ve.length;Y++)ye+=this.tablecell(ve[Y]);Ce+=this.tablerow({text:ye})}return Ce&&(Ce=`<tbody>${Ce}</tbody>`),`<table>
<thead>
`+pe+`</thead>
`+Ce+`</table>
`}tablerow({text:he}){return`<tr>
${he}</tr>
`}tablecell(he){const pe=this.parser.parseInline(he.tokens),ye=he.header?"th":"td";return(he.align?`<${ye} align="${he.align}">`:`<${ye}>`)+pe+`</${ye}>
`}strong({tokens:he}){return`<strong>${this.parser.parseInline(he)}</strong>`}em({tokens:he}){return`<em>${this.parser.parseInline(he)}</em>`}codespan({text:he}){return`<code>${he}</code>`}br(he){return"<br>"}del({tokens:he}){return`<del>${this.parser.parseInline(he)}</del>`}link({href:he,title:pe,tokens:ye}){const Ce=this.parser.parseInline(ye),fe=u(he);if(fe===null)return Ce;he=fe;let ve='<a href="'+he+'"';return pe&&(ve+=' title="'+pe+'"'),ve+=">"+Ce+"</a>",ve}image({href:he,title:pe,text:ye}){const Ce=u(he);if(Ce===null)return ye;he=Ce;let fe=`<img src="${he}" alt="${ye}"`;return pe&&(fe+=` title="${pe}"`),fe+=">",fe}text(he){return"tokens"in he&&he.tokens?this.parser.parseInline(he.tokens):he.text}}class B{strong({text:he}){return he}em({text:he}){return he}codespan({text:he}){return he}del({text:he}){return he}html({text:he}){return he}text({text:he}){return he}link({text:he}){return""+he}image({text:he}){return""+he}br(){return""}}class H{options;renderer;textRenderer;constructor(he){this.options=he||be.defaults,this.options.renderer=this.options.renderer||new q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new B}static parse(he,pe){return new H(pe).parse(he)}static parseInline(he,pe){return new H(pe).parseInline(he)}parse(he,pe=!0){let ye="";for(let Ce=0;Ce<he.length;Ce++){const fe=he[Ce];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const Y=fe,W=this.options.extensions.renderers[Y.type].call({parser:this},Y);if(W!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Y.type)){ye+=W||"";continue}}const ve=fe;switch(ve.type){case"space":{ye+=this.renderer.space(ve);continue}case"hr":{ye+=this.renderer.hr(ve);continue}case"heading":{ye+=this.renderer.heading(ve);continue}case"code":{ye+=this.renderer.code(ve);continue}case"table":{ye+=this.renderer.table(ve);continue}case"blockquote":{ye+=this.renderer.blockquote(ve);continue}case"list":{ye+=this.renderer.list(ve);continue}case"html":{ye+=this.renderer.html(ve);continue}case"paragraph":{ye+=this.renderer.paragraph(ve);continue}case"text":{let Y=ve,W=this.renderer.text(Y);for(;Ce+1<he.length&&he[Ce+1].type==="text";)Y=he[++Ce],W+=`
`+this.renderer.text(Y);pe?ye+=this.renderer.paragraph({type:"paragraph",raw:W,text:W,tokens:[{type:"text",raw:W,text:W}]}):ye+=W;continue}default:{const Y='Token with "'+ve.type+'" type was not found.';if(this.options.silent)return console.error(Y),"";throw new Error(Y)}}}return ye}parseInline(he,pe){pe=pe||this.renderer;let ye="";for(let Ce=0;Ce<he.length;Ce++){const fe=he[Ce];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const Y=this.options.extensions.renderers[fe.type].call({parser:this},fe);if(Y!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type)){ye+=Y||"";continue}}const ve=fe;switch(ve.type){case"escape":{ye+=pe.text(ve);break}case"html":{ye+=pe.html(ve);break}case"link":{ye+=pe.link(ve);break}case"image":{ye+=pe.image(ve);break}case"strong":{ye+=pe.strong(ve);break}case"em":{ye+=pe.em(ve);break}case"codespan":{ye+=pe.codespan(ve);break}case"br":{ye+=pe.br(ve);break}case"del":{ye+=pe.del(ve);break}case"text":{ye+=pe.text(ve);break}default:{const Y='Token with "'+ve.type+'" type was not found.';if(this.options.silent)return console.error(Y),"";throw new Error(Y)}}}return ye}}class Q{options;constructor(he){this.options=he||be.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(he){return he}postprocess(he){return he}processAllTokens(he){return he}}class se{defaults=e();options=this.setOptions;parse=this.parseMarkdown(Me.lex,H.parse);parseInline=this.parseMarkdown(Me.lexInline,H.parseInline);Parser=H;Renderer=q;TextRenderer=B;Lexer=Me;Tokenizer=i;Hooks=Q;constructor(...he){this.use(...he)}walkTokens(he,pe){let ye=[];for(const Ce of he)switch(ye=ye.concat(pe.call(this,Ce)),Ce.type){case"table":{const fe=Ce;for(const ve of fe.header)ye=ye.concat(this.walkTokens(ve.tokens,pe));for(const ve of fe.rows)for(const Y of ve)ye=ye.concat(this.walkTokens(Y.tokens,pe));break}case"list":{const fe=Ce;ye=ye.concat(this.walkTokens(fe.items,pe));break}default:{const fe=Ce;this.defaults.extensions?.childTokens?.[fe.type]?this.defaults.extensions.childTokens[fe.type].forEach(ve=>{const Y=fe[ve].flat(1/0);ye=ye.concat(this.walkTokens(Y,pe))}):fe.tokens&&(ye=ye.concat(this.walkTokens(fe.tokens,pe)))}}return ye}use(...he){const pe=this.defaults.extensions||{renderers:{},childTokens:{}};return he.forEach(ye=>{const Ce={...ye};if(Ce.async=this.defaults.async||Ce.async||!1,ye.extensions&&(ye.extensions.forEach(fe=>{if(!fe.name)throw new Error("extension name required");if("renderer"in fe){const ve=pe.renderers[fe.name];ve?pe.renderers[fe.name]=function(...Y){let W=fe.renderer.apply(this,Y);return W===!1&&(W=ve.apply(this,Y)),W}:pe.renderers[fe.name]=fe.renderer}if("tokenizer"in fe){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const ve=pe[fe.level];ve?ve.unshift(fe.tokenizer):pe[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?pe.startBlock?pe.startBlock.push(fe.start):pe.startBlock=[fe.start]:fe.level==="inline"&&(pe.startInline?pe.startInline.push(fe.start):pe.startInline=[fe.start]))}"childTokens"in fe&&fe.childTokens&&(pe.childTokens[fe.name]=fe.childTokens)}),Ce.extensions=pe),ye.renderer){const fe=this.defaults.renderer||new q(this.defaults);for(const ve in ye.renderer){if(!(ve in fe))throw new Error(`renderer '${ve}' does not exist`);if(["options","parser"].includes(ve))continue;const Y=ve,W=ye.renderer[Y],de=fe[Y];fe[Y]=(...je)=>{let He=W.apply(fe,je);return He===!1&&(He=de.apply(fe,je)),He||""}}Ce.renderer=fe}if(ye.tokenizer){const fe=this.defaults.tokenizer||new i(this.defaults);for(const ve in ye.tokenizer){if(!(ve in fe))throw new Error(`tokenizer '${ve}' does not exist`);if(["options","rules","lexer"].includes(ve))continue;const Y=ve,W=ye.tokenizer[Y],de=fe[Y];fe[Y]=(...je)=>{let He=W.apply(fe,je);return He===!1&&(He=de.apply(fe,je)),He}}Ce.tokenizer=fe}if(ye.hooks){const fe=this.defaults.hooks||new Q;for(const ve in ye.hooks){if(!(ve in fe))throw new Error(`hook '${ve}' does not exist`);if(ve==="options")continue;const Y=ve,W=ye.hooks[Y],de=fe[Y];Q.passThroughHooks.has(ve)?fe[Y]=je=>{if(this.defaults.async)return Promise.resolve(W.call(fe,je)).then(st=>de.call(fe,st));const He=W.call(fe,je);return de.call(fe,He)}:fe[Y]=(...je)=>{let He=W.apply(fe,je);return He===!1&&(He=de.apply(fe,je)),He}}Ce.hooks=fe}if(ye.walkTokens){const fe=this.defaults.walkTokens,ve=ye.walkTokens;Ce.walkTokens=function(Y){let W=[];return W.push(ve.call(this,Y)),fe&&(W=W.concat(fe.call(this,Y))),W}}this.defaults={...this.defaults,...Ce}}),this}setOptions(he){return this.defaults={...this.defaults,...he},this}lexer(he,pe){return Me.lex(he,pe??this.defaults)}parser(he,pe){return H.parse(he,pe??this.defaults)}parseMarkdown(he,pe){return(Ce,fe)=>{const ve={...fe},Y={...this.defaults,...ve},W=this.onError(!!Y.silent,!!Y.async);if(this.defaults.async===!0&&ve.async===!1)return W(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof Ce>"u"||Ce===null)return W(new Error("marked(): input parameter is undefined or null"));if(typeof Ce!="string")return W(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected"));if(Y.hooks&&(Y.hooks.options=Y),Y.async)return Promise.resolve(Y.hooks?Y.hooks.preprocess(Ce):Ce).then(de=>he(de,Y)).then(de=>Y.hooks?Y.hooks.processAllTokens(de):de).then(de=>Y.walkTokens?Promise.all(this.walkTokens(de,Y.walkTokens)).then(()=>de):de).then(de=>pe(de,Y)).then(de=>Y.hooks?Y.hooks.postprocess(de):de).catch(W);try{Y.hooks&&(Ce=Y.hooks.preprocess(Ce));let de=he(Ce,Y);Y.hooks&&(de=Y.hooks.processAllTokens(de)),Y.walkTokens&&this.walkTokens(de,Y.walkTokens);let je=pe(de,Y);return Y.hooks&&(je=Y.hooks.postprocess(je)),je}catch(de){return W(de)}}}onError(he,pe){return ye=>{if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,he){const Ce="<p>An error occurred:</p><pre>"+s(ye.message+"",!0)+"</pre>";return pe?Promise.resolve(Ce):Ce}if(pe)return Promise.reject(ye);throw ye}}}const ge=new se;function Ee(Ye,he){return ge.parse(Ye,he)}Ee.options=Ee.setOptions=function(Ye){return ge.setOptions(Ye),Ee.defaults=ge.defaults,v(Ee.defaults),Ee},Ee.getDefaults=e,Ee.defaults=be.defaults,Ee.use=function(...Ye){return ge.use(...Ye),Ee.defaults=ge.defaults,v(Ee.defaults),Ee},Ee.walkTokens=function(Ye,he){return ge.walkTokens(Ye,he)},Ee.parseInline=ge.parseInline,Ee.Parser=H,Ee.parser=H.parse,Ee.Renderer=q,Ee.TextRenderer=B,Ee.Lexer=Me,Ee.lexer=Me.lex,Ee.Tokenizer=i,Ee.Hooks=Q,Ee.parse=Ee;const ze=Ee.options,Je=Ee.setOptions,_e=Ee.use,tt=Ee.walkTokens,ct=Ee.parseInline,it=Ee,at=H.parse,yt=Me.lex;be.Hooks=Q,be.Lexer=Me,be.Marked=se,be.Parser=H,be.Renderer=q,be.TextRenderer=B,be.Tokenizer=i,be.getDefaults=e,be.lexer=yt,be.marked=Ee,be.options=ze,be.parse=it,be.parseInline=ct,be.parser=at,be.setOptions=Je,be.use=_e,be.walkTokens=tt}),define(Re[141],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=v;function v(r){const a=L(r);if(a&&a.length>0)return new Uint32Array(a)}let D=0;const P=new Uint32Array(10);function L(r){if(D=0,R(r,b,m.InitialConsonant),D>0||(R(r,u,m.Vowel),D>0)||(R(r,k,m.FinalConsonant),D>0)||(R(r,$,m.CompatibilityJamo),D))return P.subarray(0,D);if(r>=44032&&r<=55203){const a=r-44032,h=a%588,c=Math.floor(a/588),i=Math.floor(h/28),n=h%28-1;if(c<b.length?R(c,b,0):m.InitialConsonant+c-m.CompatibilityJamo<$.length&&R(m.InitialConsonant+c,$,m.CompatibilityJamo),i<u.length?R(i,u,0):m.Vowel+i-m.CompatibilityJamo<$.length&&R(m.Vowel+i-m.CompatibilityJamo,$,m.CompatibilityJamo),n>=0&&(n<k.length?R(n,k,0):m.FinalConsonant+n-m.CompatibilityJamo<$.length&&R(m.FinalConsonant+n-m.CompatibilityJamo,$,m.CompatibilityJamo)),D>0)return P.subarray(0,D)}}function R(r,a,h){r>=h&&r<h+a.length&&T(a[r-h])}function T(r){r!==s.NUL&&(P[D++]=r&255,r>>8&&(P[D++]=r>>8&255),r>>16&&(P[D++]=r>>16&255))}var m;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var s;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(s||(s={}));var I;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(I||(I={}));const b=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),u=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l]),k=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,I.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),$=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.E,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,s.Q,I.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l])}),define(Re[142],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Qm=v,e.rot=D,e.$Vm=T;function v(m,s,I){return Math.min(Math.max(m,s),I)}function D(m,s){return(s+m%s)%s}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Sm=P;class L{constructor(){this.a=1,this.b=0}update(s){return this.b=this.b+(s-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Tm=L;class R{constructor(s){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(s),this.c.fill(0,0,s)}update(s){const I=this.c[this.d];return this.c[this.d]=s,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=s,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Um=R;function T(m,s,I,b,u,k,$,r){const a=$-I,h=r-b,c=u-I,i=k-b,n=m-I,t=s-b,o=a*a+h*h,l=a*c+h*i,g=a*n+h*t,f=c*c+i*i,d=c*n+i*t,S=1/(o*f-l*l),E=(f*g-l*d)*S,y=(o*d-l*g)*S;return E>=0&&y>=0&&E+y<1}}),define(Re[143],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fd=void 0,e.$gd=L,e.$hd=u;class v{constructor($,r,a){this.owner=$,this.debugNameSource=r,this.referenceFn=a}getDebugName($){return L($,this)}}e.$fd=v;const D=new Map,P=new WeakMap;function L(k,$){const r=P.get(k);if(r)return r;const a=R(k,$);if(a){let h=D.get(a)??0;h++,D.set(a,h);const c=h===1?a:`${a}#${h}`;return P.set(k,c),c}}function R(k,$){const r=P.get(k);if(r)return r;const a=$.owner?I($.owner)+".":"";let h;const c=$.debugNameSource;if(c!==void 0)if(typeof c=="function"){if(h=c(),h!==void 0)return a+h}else return a+c;const i=$.referenceFn;if(i!==void 0&&(h=u(i),h!==void 0))return a+h;if($.owner!==void 0){const n=T($.owner,k);if(n!==void 0)return a+n}}function T(k,$){for(const r in k)if(k[r]===$)return r}const m=new Map,s=new WeakMap;function I(k){const $=s.get(k);if($)return $;const r=b(k);let a=m.get(r)??0;a++,m.set(r,a);const h=a===1?r:`${r}#${a}`;return s.set(k,h),h}function b(k){const $=k.constructor;return $?$.name:"Object"}function u(k){const $=k.toString(),a=/\/\*\*\s*@description\s*([^*]*)\*\//.exec($);return(a?a[1]:void 0)?.trim()}}),define(Re[144],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0,e.$Pd=D,e.$Qd=P;let v;function D(r){v=r}function P(){return v}class L{constructor(){this.a=0,this.d=new WeakMap}b(a){return R([T(k("|  ",this.a)),a])}c(a){return a.hadValue?a.didChange?[T(" "),s(I(a.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),s(I(a.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),s(I(a.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(a,h){console.log(...this.b([m("observable value changed"),s(a.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(a){if(a.size!==0)return s(" (changed deps: "+[...a].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const h=a.handleChange;this.d.set(a,new Set),a.handleChange=(c,i)=>(this.d.get(a).add(c),h.apply(a,[c,i]))}handleDerivedRecomputed(a,h){const c=this.d.get(a);console.log(...this.b([m("derived recomputed"),s(a.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(c),{data:[{fn:a._debugNameData.referenceFn??a._computeFn}]}])),c.clear()}handleFromEventObservableTriggered(a,h){console.log(...this.b([m("observable from event triggered"),s(a.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const h=a.handleChange;this.d.set(a,new Set),a.handleChange=(c,i)=>(this.d.get(a).add(c),h.apply(a,[c,i]))}handleAutorunTriggered(a){const h=this.d.get(a);console.log(...this.b([m("autorun"),s(a.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:a._debugNameData.referenceFn??a._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(a){this.a--}handleBeginTransaction(a){let h=a.getDebugName();h===void 0&&(h=""),console.log(...this.b([m("transaction"),s(h,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Rd=L;function R(r){const a=new Array,h=[];let c="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(c+=`%c${t.text}`,a.push(t.style),t.data&&h.push(...t.data)):"data"in t&&h.push(...t.data)}i(r);const n=[c,...a];return n.push(...h),n}function T(r){return s(r,{color:"black"})}function m(r){return s($(`${r}: `,10),{color:"black",bold:!0})}function s(r,a={color:"black"}){function h(i){return Object.entries(i).reduce((n,[t,o])=>`${n}${t}:${o};`,"")}const c={color:a.color};return a.strikeThrough&&(c["text-decoration"]="line-through"),a.bold&&(c["font-weight"]="bold"),{text:r,style:h(c)}}function I(r,a){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=a?`"${r}"`:`"${r.substr(0,a-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?b(r,a):u(r,a);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function b(r,a){let h="[ ",c=!0;for(const i of r){if(c||(h+=", "),h.length-5>a){h+="...";break}c=!1,h+=`${I(i,a-h.length)}`}return h+=" ]",h}function u(r,a){let h="{ ",c=!0;for(const[i,n]of Object.entries(r)){if(c||(h+=", "),h.length-5>a){h+="...";break}c=!1,h+=`${i}: ${I(n,a-h.length)}`}return h+=" }",h}function k(r,a){let h="";for(let c=1;c<=a;c++)h+=r;return h}function $(r,a){for(;r.length<a;)r+=" ";return r}}),define(Re[145],Oe([1,0,137,143,144]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$_d=e.$0d=e.$5d=e.$4d=void 0,e.$1d=R,e.$2d=m,e.$3d=I,e.$6d=k,e.$7d=r,e.$8d=a,e.$9d=h,e.$$d=i,e.$ae=t;let L;function R(l){L=l}let T;function m(l){T=l}let s;function I(l){s=l}class b{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,f){const d=f===void 0?void 0:g,S=f===void 0?g:f;return s({owner:d,debugName:()=>{const E=(0,D.$hd)(S);if(E!==void 0)return E;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(C)return`${this.debugName}.${C[2]}`;if(!d)return`${this.debugName} (mapped)`},debugReferenceFn:S},E=>S(this.read(E),E))}flatten(){return s({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},g=>this.read(g).read(g))}recomputeInitiallyAndOnChange(g,f){return g.add(L(this,f)),this}keepObserved(g){return g.add(T(this)),this}get a(){return this.get()}}e.$4d=b;class u extends b{constructor(){super(...arguments),this.b=new Set}addObserver(g){const f=this.b.size;this.b.add(g),f===0&&this.c()}removeObserver(g){this.b.delete(g)&&this.b.size===0&&this.f()}c(){}f(){}}e.$5d=u;function k(l,g){const f=new c(l,g);try{l(f)}finally{f.finish()}}let $;function r(l){if($)l($);else{const g=new c(l,void 0);$=g;try{l(g)}finally{g.finish(),$=void 0}}}async function a(l,g){const f=new c(l,g);try{await l(f)}finally{f.finish()}}function h(l,g,f){l?g(l):k(g,f)}class c{constructor(g,f){this._fn=g,this.b=f,this.a=[],(0,P.$Qd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,D.$hd)(this._fn)}updateObserver(g,f){this.a.push({observer:g,observable:f}),g.beginUpdate(f)}finish(){const g=this.a;for(let f=0;f<g.length;f++){const{observer:d,observable:S}=g[f];d.endUpdate(S)}this.a=null,(0,P.$Qd)()?.handleEndTransaction()}}e.$0d=c;function i(l,g){let f;return typeof l=="string"?f=new D.$fd(void 0,l,void 0):f=new D.$fd(l,void 0,void 0),new n(f,g,v.$$c)}class n extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(g,f,d){super(),this.e=g,this.g=d,this.d=f}get(){return this.d}set(g,f,d){if(d===void 0&&this.g(this.d,g))return;let S;f||(f=S=new c(()=>{},()=>`Setting ${this.debugName}`));try{const E=this.d;this.h(g),(0,P.$Qd)()?.handleObservableChanged(this,{oldValue:E,newValue:g,change:d,didChange:!0,hadValue:!0});for(const y of this.b)f.updateObserver(y,this),y.handleChange(this,d)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(g){this.d=g}}e.$_d=n;function t(l,g){let f;return typeof l=="string"?f=new D.$fd(void 0,l,void 0):f=new D.$fd(l,void 0,void 0),new o(f,g,v.$$c)}class o extends n{h(g){this.d!==g&&(this.d&&this.d.dispose(),this.d=g)}dispose(){this.d?.dispose()}}e.$be=o}),function(){function be(P){const L=[];typeof P=="number"&&L.push("code/timeOrigin",P);function R(m){L.push(m,Date.now())}function T(){const m=[];for(let s=0;s<L.length;s+=2)m.push({name:L[s],startTime:L[s+1]});return m}return{mark:R,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(P+R.startTime)});return L}};if(typeof process=="object"){const P=performance?.timeOrigin;return be(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function v(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=v(D))}(),define(Re[146],Oe([1,0,41]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=void 0;const D=Symbol("unset");class P{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}get entries(){return this.a.children?.entries()||v.Iterable.empty()}insert(m,s,I){this.d(m,b=>b._value=s,I)}mutate(m,s){this.d(m,I=>I._value=s(I._value===D?void 0:I._value))}mutatePath(m,s){this.d(m,()=>{},I=>s(I))}delete(m){const s=this.c(m);if(!s)return;let I=s.length-1;const b=s[I].node._value;if(b!==D){for(this.b--,s[I].node._value=D;I>0;I--){const{node:u,part:k}=s[I];if(u.children?.size||u._value!==D)break;s[I-1].node.children.delete(k)}return b}}*deleteRecursive(m){const s=this.c(m);if(!s)return;const I=s[s.length-1].node;for(let b=s.length-1;b>0;b--){const u=s[b-1];if(u.node.children.delete(s[b].part),u.node.children.size>0||u.node._value!==D)break}for(const b of L(I))b._value!==D&&(this.b--,yield b._value)}find(m){let s=this.a;for(const I of m){const b=s.children?.get(I);if(!b)return;s=b}return s._value===D?void 0:s._value}hasKeyOrParent(m){let s=this.a;for(const I of m){const b=s.children?.get(I);if(!b)return!1;if(b._value!==D)return!0;s=b}return!1}hasKeyOrChildren(m){let s=this.a;for(const I of m){const b=s.children?.get(I);if(!b)return!1;s=b}return!0}hasKey(m){let s=this.a;for(const I of m){const b=s.children?.get(I);if(!b)return!1;s=b}return s._value!==D}c(m){const s=[{part:"",node:this.a}];let I=0;for(const b of m){const u=s[I].node.children?.get(b);if(!u)return;s.push({part:b,node:u}),I++}return s}d(m,s,I){let b=this.a;for(const $ of m){if(b.children)if(b.children.has($))b=b.children.get($);else{const r=new R;b.children.set($,r),b=r}else{const r=new R;b.children=new Map([[$,r]]),b=r}I?.(b)}const u=b._value===D?0:1;s(b);const k=b._value===D?0:1;this.b+=k-u}*values(){for(const{_value:m}of L(this.a))m!==D&&(yield m)}}e.$sJ=P;function*L(T){const m=[T];for(;m.length>0;){const s=m.pop();if(yield s,s.children)for(const I of s.children.values())m.push(I)}}class R{constructor(){this._value=D}get value(){return this._value===D?void 0:this._value}set value(m){this._value=m===void 0?D:m}}}),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var D in v)(typeof exports=="object"?exports:be)[D]=v[D]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function v(D){if(e[D])return e[D].exports;var P=e[D]={i:D,l:!1,exports:{}};return be[D].call(P.exports,P,P.exports,v),P.l=!0,P.exports}return v.m=be,v.c=e,v.d=function(D,P,L){v.o(D,P)||Object.defineProperty(D,P,{enumerable:!0,get:L})},v.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},v.t=function(D,P){if(1&P&&(D=v(D)),8&P||4&P&&typeof D=="object"&&D&&D.__esModule)return D;var L=Object.create(null);if(v.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:D}),2&P&&typeof D!="string")for(var R in D)v.d(L,R,function(T){return D[T]}.bind(null,R));return L},v.n=function(D){var P=D&&D.__esModule?function(){return D.default}:function(){return D};return v.d(P,"a",P),P},v.o=function(D,P){return Object.prototype.hasOwnProperty.call(D,P)},v.p="",v(v.s=0)}([function(be,e,v){(function(D){var P;e=be.exports=$e,P=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],m=e.src=[],s=0,I=s++;m[I]="0|[1-9]\\d*";var b=s++;m[b]="[0-9]+";var u=s++;m[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=s++;m[k]="("+m[I]+")\\.("+m[I]+")\\.("+m[I]+")";var $=s++;m[$]="("+m[b]+")\\.("+m[b]+")\\.("+m[b]+")";var r=s++;m[r]="(?:"+m[I]+"|"+m[u]+")";var a=s++;m[a]="(?:"+m[b]+"|"+m[u]+")";var h=s++;m[h]="(?:-("+m[r]+"(?:\\."+m[r]+")*))";var c=s++;m[c]="(?:-?("+m[a]+"(?:\\."+m[a]+")*))";var i=s++;m[i]="[0-9A-Za-z-]+";var n=s++;m[n]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var t=s++,o="v?"+m[k]+m[h]+"?"+m[n]+"?";m[t]="^"+o+"$";var l="[v=\\s]*"+m[$]+m[c]+"?"+m[n]+"?",g=s++;m[g]="^"+l+"$";var f=s++;m[f]="((?:<|>)?=?)";var d=s++;m[d]=m[b]+"|x|X|\\*";var S=s++;m[S]=m[I]+"|x|X|\\*";var E=s++;m[E]="[v=\\s]*("+m[S]+")(?:\\.("+m[S]+")(?:\\.("+m[S]+")(?:"+m[h]+")?"+m[n]+"?)?)?";var y=s++;m[y]="[v=\\s]*("+m[d]+")(?:\\.("+m[d]+")(?:\\.("+m[d]+")(?:"+m[c]+")?"+m[n]+"?)?)?";var C=s++;m[C]="^"+m[f]+"\\s*"+m[E]+"$";var O=s++;m[O]="^"+m[f]+"\\s*"+m[y]+"$";var p=s++;m[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var w=s++;m[w]="(?:~>?)";var M=s++;m[M]="(\\s*)"+m[w]+"\\s+",T[M]=new RegExp(m[M],"g");var A=s++;m[A]="^"+m[w]+m[E]+"$";var F=s++;m[F]="^"+m[w]+m[y]+"$";var G=s++;m[G]="(?:\\^)";var x=s++;m[x]="(\\s*)"+m[G]+"\\s+",T[x]=new RegExp(m[x],"g");var j=s++;m[j]="^"+m[G]+m[E]+"$";var U=s++;m[U]="^"+m[G]+m[y]+"$";var J=s++;m[J]="^"+m[f]+"\\s*("+l+")$|^$";var Z=s++;m[Z]="^"+m[f]+"\\s*("+o+")$|^$";var ae=s++;m[ae]="(\\s*)"+m[f]+"\\s*("+l+"|"+m[E]+")",T[ae]=new RegExp(m[ae],"g");var ee=s++;m[ee]="^\\s*("+m[E]+")\\s+-\\s+("+m[E]+")\\s*$";var oe=s++;m[oe]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var ie=s++;m[ie]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)P(ue,m[ue]),T[ue]||(T[ue]=new RegExp(m[ue]));function _(B,H){if(B instanceof $e)return B;if(typeof B!="string"||B.length>L||!(H?T[g]:T[t]).test(B))return null;try{return new $e(B,H)}catch{return null}}function $e(B,H){if(B instanceof $e){if(B.loose===H)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof $e))return new $e(B,H);P("SemVer",B,H),this.loose=H;var Q=B.trim().match(H?T[g]:T[t]);if(!Q)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var ge=+se;if(ge>=0&&ge<R)return ge}return se}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=_,e.valid=function(B,H){var Q=_(B,H);return Q?Q.version:null},e.clean=function(B,H){var Q=_(B.trim().replace(/^[=v]+/,""),H);return Q?Q.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(B){return P("SemVer.compare",this.version,this.loose,B),B instanceof $e||(B=new $e(B,this.loose)),this.compareMain(B)||this.comparePre(B)},$e.prototype.compareMain=function(B){return B instanceof $e||(B=new $e(B,this.loose)),X(this.major,B.major)||X(this.minor,B.minor)||X(this.patch,B.patch)},$e.prototype.comparePre=function(B){if(B instanceof $e||(B=new $e(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var H=0;do{var Q=this.prerelease[H],se=B.prerelease[H];if(P("prerelease compare",H,Q,se),Q===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(Q===void 0)return-1;if(Q!==se)return X(Q,se)}while(++H)},$e.prototype.inc=function(B,H){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,H,Q,se){typeof Q=="string"&&(se=Q,Q=void 0);try{return new $e(B,Q).inc(H,se).version}catch{return null}},e.diff=function(B,H){if(Pe(B,H))return null;var Q=_(B),se=_(H);if(Q.prerelease.length||se.prerelease.length){for(var ge in Q)if((ge==="major"||ge==="minor"||ge==="patch")&&Q[ge]!==se[ge])return"pre"+ge;return"prerelease"}for(var ge in Q)if((ge==="major"||ge==="minor"||ge==="patch")&&Q[ge]!==se[ge])return ge},e.compareIdentifiers=X;var Ie=/^[0-9]+$/;function X(B,H){var Q=Ie.test(B),se=Ie.test(H);return Q&&se&&(B=+B,H=+H),Q&&!se?-1:se&&!Q?1:B<H?-1:B>H?1:0}function V(B,H,Q){return new $e(B,Q).compare(new $e(H,Q))}function re(B,H,Q){return V(B,H,Q)>0}function we(B,H,Q){return V(B,H,Q)<0}function Pe(B,H,Q){return V(B,H,Q)===0}function Fe(B,H,Q){return V(B,H,Q)!==0}function Be(B,H,Q){return V(B,H,Q)>=0}function xe(B,H,Q){return V(B,H,Q)<=0}function nt(B,H,Q,se){var ge;switch(H){case"===":typeof B=="object"&&(B=B.version),typeof Q=="object"&&(Q=Q.version),ge=B===Q;break;case"!==":typeof B=="object"&&(B=B.version),typeof Q=="object"&&(Q=Q.version),ge=B!==Q;break;case"":case"=":case"==":ge=Pe(B,Q,se);break;case"!=":ge=Fe(B,Q,se);break;case">":ge=re(B,Q,se);break;case">=":ge=Be(B,Q,se);break;case"<":ge=we(B,Q,se);break;case"<=":ge=xe(B,Q,se);break;default:throw new TypeError("Invalid operator: "+H)}return ge}function ht(B,H){if(B instanceof ht){if(B.loose===H)return B;B=B.value}if(!(this instanceof ht))return new ht(B,H);P("comparator",B,H),this.loose=H,this.parse(B),this.semver===$t?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(B,H){return X(H,B)},e.major=function(B,H){return new $e(B,H).major},e.minor=function(B,H){return new $e(B,H).minor},e.patch=function(B,H){return new $e(B,H).patch},e.compare=V,e.compareLoose=function(B,H){return V(B,H,!0)},e.rcompare=function(B,H,Q){return V(H,B,Q)},e.sort=function(B,H){return B.sort(function(Q,se){return e.compare(Q,se,H)})},e.rsort=function(B,H){return B.sort(function(Q,se){return e.rcompare(Q,se,H)})},e.gt=re,e.lt=we,e.eq=Pe,e.neq=Fe,e.gte=Be,e.lte=xe,e.cmp=nt,e.Comparator=ht;var $t={};function ut(B,H){if(B instanceof ut)return B.loose===H?B:new ut(B.raw,H);if(B instanceof ht)return new ut(B.value,H);if(!(this instanceof ut))return new ut(B,H);if(this.loose=H,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function et(B){return!B||B.toLowerCase()==="x"||B==="*"}function Le(B,H,Q,se,ge,Ee,ze,Je,_e,tt,ct,it,at){return((H=et(Q)?"":et(se)?">="+Q+".0.0":et(ge)?">="+Q+"."+se+".0":">="+H)+" "+(Je=et(_e)?"":et(tt)?"<"+(+_e+1)+".0.0":et(ct)?"<"+_e+"."+(+tt+1)+".0":it?"<="+_e+"."+tt+"."+ct+"-"+it:"<="+Je)).trim()}function Ne(B,H){for(var Q=0;Q<B.length;Q++)if(!B[Q].test(H))return!1;if(H.prerelease.length){for(Q=0;Q<B.length;Q++)if(P(B[Q].semver),B[Q].semver!==$t&&B[Q].semver.prerelease.length>0){var se=B[Q].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function Me(B,H,Q){try{H=new ut(H,Q)}catch{return!1}return H.test(B)}function q(B,H,Q,se){var ge,Ee,ze,Je,_e;switch(B=new $e(B,se),H=new ut(H,se),Q){case">":ge=re,Ee=xe,ze=we,Je=">",_e=">=";break;case"<":ge=we,Ee=Be,ze=re,Je="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(B,H,se))return!1;for(var tt=0;tt<H.set.length;++tt){var ct=H.set[tt],it=null,at=null;if(ct.forEach(function(yt){yt.semver===$t&&(yt=new ht(">=0.0.0")),it=it||yt,at=at||yt,ge(yt.semver,it.semver,se)?it=yt:ze(yt.semver,at.semver,se)&&(at=yt)}),it.operator===Je||it.operator===_e||(!at.operator||at.operator===Je)&&Ee(B,at.semver)||at.operator===_e&&ze(B,at.semver))return!1}return!0}ht.prototype.parse=function(B){var H=this.loose?T[J]:T[Z],Q=B.match(H);if(!Q)throw new TypeError("Invalid comparator: "+B);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new $e(Q[2],this.loose):this.semver=$t},ht.prototype.toString=function(){return this.value},ht.prototype.test=function(B){return P("Comparator.test",B,this.loose),this.semver===$t||(typeof B=="string"&&(B=new $e(B,this.loose)),nt(B,this.operator,this.semver,this.loose))},ht.prototype.intersects=function(B,H){if(!(B instanceof ht))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new ut(B.value,H),Me(this.value,Q,H);if(B.operator==="")return Q=new ut(this.value,H),Me(B.semver,Q,H);var se=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Ee=this.semver.version===B.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Je=nt(this.semver,"<",B.semver,H)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),_e=nt(this.semver,">",B.semver,H)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return se||ge||Ee&&ze||Je||_e},e.Range=ut,ut.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},ut.prototype.toString=function(){return this.range},ut.prototype.parseRange=function(B){var H=this.loose;B=B.trim(),P("range",B,H);var Q=H?T[oe]:T[ee];B=B.replace(Q,Le),P("hyphen replace",B),B=B.replace(T[ae],"$1$2$3"),P("comparator trim",B,T[ae]),B=(B=(B=B.replace(T[M],"$1~")).replace(T[x],"$1^")).split(/\s+/).join(" ");var se=H?T[J]:T[Z],ge=B.split(" ").map(function(Ee){return function(ze,Je){return P("comp",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(ct){return function(it,at){P("caret",it,at);var yt=at?T[U]:T[j];return it.replace(yt,function(Ye,he,pe,ye,Ce){var fe;return P("caret",it,Ye,he,pe,ye,Ce),et(he)?fe="":et(pe)?fe=">="+he+".0.0 <"+(+he+1)+".0.0":et(ye)?fe=he==="0"?">="+he+"."+pe+".0 <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+".0 <"+(+he+1)+".0.0":Ce?(P("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),fe=he==="0"?pe==="0"?">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+pe+"."+(+ye+1):">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+"."+ye+Ce+" <"+(+he+1)+".0.0"):(P("no pr"),fe=he==="0"?pe==="0"?">="+he+"."+pe+"."+ye+" <"+he+"."+pe+"."+(+ye+1):">="+he+"."+pe+"."+ye+" <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+"."+ye+" <"+(+he+1)+".0.0"),P("caret return",fe),fe})}(ct,tt)}).join(" ")}(ze,Je),P("caret",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(ct){return function(it,at){var yt=at?T[F]:T[A];return it.replace(yt,function(Ye,he,pe,ye,Ce){var fe;return P("tilde",it,Ye,he,pe,ye,Ce),et(he)?fe="":et(pe)?fe=">="+he+".0.0 <"+(+he+1)+".0.0":et(ye)?fe=">="+he+"."+pe+".0 <"+he+"."+(+pe+1)+".0":Ce?(P("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),fe=">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+(+pe+1)+".0"):fe=">="+he+"."+pe+"."+ye+" <"+he+"."+(+pe+1)+".0",P("tilde return",fe),fe})}(ct,tt)}).join(" ")}(ze,Je),P("tildes",ze),ze=function(_e,tt){return P("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(ct){return function(it,at){it=it.trim();var yt=at?T[O]:T[C];return it.replace(yt,function(Ye,he,pe,ye,Ce,fe){P("xRange",it,Ye,he,pe,ye,Ce,fe);var ve=et(pe),Y=ve||et(ye),W=Y||et(Ce);return he==="="&&W&&(he=""),ve?Ye=he===">"||he==="<"?"<0.0.0":"*":he&&W?(Y&&(ye=0),W&&(Ce=0),he===">"?(he=">=",Y?(pe=+pe+1,ye=0,Ce=0):W&&(ye=+ye+1,Ce=0)):he==="<="&&(he="<",Y?pe=+pe+1:ye=+ye+1),Ye=he+pe+"."+ye+"."+Ce):Y?Ye=">="+pe+".0.0 <"+(+pe+1)+".0.0":W&&(Ye=">="+pe+"."+ye+".0 <"+pe+"."+(+ye+1)+".0"),P("xRange return",Ye),Ye})}(ct,tt)}).join(" ")}(ze,Je),P("xrange",ze),ze=function(_e,tt){return P("replaceStars",_e,tt),_e.trim().replace(T[ie],"")}(ze,Je),P("stars",ze),ze}(Ee,H)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(Ee){return!!Ee.match(se)})),ge=ge.map(function(Ee){return new ht(Ee,H)})},ut.prototype.intersects=function(B,H){if(!(B instanceof ut))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(se){return B.set.some(function(ge){return ge.every(function(Ee){return se.intersects(Ee,H)})})})})},e.toComparators=function(B,H){return new ut(B,H).set.map(function(Q){return Q.map(function(se){return se.value}).join(" ").trim().split(" ")})},ut.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new $e(B,this.loose));for(var H=0;H<this.set.length;H++)if(Ne(this.set[H],B))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(B,H,Q){var se=null,ge=null;try{var Ee=new ut(H,Q)}catch{return null}return B.forEach(function(ze){Ee.test(ze)&&(se&&ge.compare(ze)!==-1||(ge=new $e(se=ze,Q)))}),se},e.minSatisfying=function(B,H,Q){var se=null,ge=null;try{var Ee=new ut(H,Q)}catch{return null}return B.forEach(function(ze){Ee.test(ze)&&(se&&ge.compare(ze)!==1||(ge=new $e(se=ze,Q)))}),se},e.validRange=function(B,H){try{return new ut(B,H).range||"*"}catch{return null}},e.ltr=function(B,H,Q){return q(B,H,"<",Q)},e.gtr=function(B,H,Q){return q(B,H,">",Q)},e.outside=q,e.prerelease=function(B,H){var Q=_(B,H);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(B,H,Q){return B=new ut(B,Q),H=new ut(H,Q),B.intersects(H)},e.coerce=function(B){if(B instanceof $e)return B;if(typeof B!="string")return null;var H=B.match(T[p]);return H==null?null:_((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,v(1))},function(be,e){var v,D,P=be.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function T(a){if(v===setTimeout)return setTimeout(a,0);if((v===L||!v)&&setTimeout)return v=setTimeout,setTimeout(a,0);try{return v(a,0)}catch{try{return v.call(null,a,0)}catch{return v.call(this,a,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:L}catch{v=L}try{D=typeof clearTimeout=="function"?clearTimeout:R}catch{D=R}})();var m,s=[],I=!1,b=-1;function u(){I&&m&&(I=!1,m.length?s=m.concat(s):b=-1,s.length&&k())}function k(){if(!I){var a=T(u);I=!0;for(var h=s.length;h;){for(m=s,s=[];++b<h;)m&&m[b].run();b=-1,h=s.length}m=null,I=!1,function(c){if(D===clearTimeout)return clearTimeout(c);if((D===R||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(c);try{D(c)}catch{try{return D.call(null,c)}catch{return D.call(this,c)}}}(a)}}function $(a,h){this.fun=a,this.array=h}function r(){}P.nextTick=function(a){var h=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)h[c-1]=arguments[c];s.push(new $(a,h)),s.length!==1||I||T(k)},$.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(a){return[]},P.binding=function(a){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(a){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Re[147],Oe([1,0,6,4]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.$ot=e.$nt=e.ScrollbarVisibility=void 0;var P;(function(k){k[k.Auto=1]="Auto",k[k.Hidden=2]="Hidden",k[k.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class L{constructor($,r,a,h,c,i,n){this.c=$,this._scrollStateBrand=void 0,this.c&&(r=r|0,a=a|0,h=h|0,c=c|0,i=i|0,n=n|0),this.rawScrollLeft=h,this.rawScrollTop=n,r<0&&(r=0),h+r>a&&(h=a-r),h<0&&(h=0),c<0&&(c=0),n+c>i&&(n=i-c),n<0&&(n=0),this.width=r,this.scrollWidth=a,this.scrollLeft=h,this.height=c,this.scrollHeight=i,this.scrollTop=n}equals($){return this.rawScrollLeft===$.rawScrollLeft&&this.rawScrollTop===$.rawScrollTop&&this.width===$.width&&this.scrollWidth===$.scrollWidth&&this.scrollLeft===$.scrollLeft&&this.height===$.height&&this.scrollHeight===$.scrollHeight&&this.scrollTop===$.scrollTop}withScrollDimensions($,r){return new L(this.c,typeof $.width<"u"?$.width:this.width,typeof $.scrollWidth<"u"?$.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof $.height<"u"?$.height:this.height,typeof $.scrollHeight<"u"?$.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition($){return new L(this.c,this.width,this.scrollWidth,typeof $.scrollLeft<"u"?$.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof $.scrollTop<"u"?$.scrollTop:this.rawScrollTop)}createScrollEvent($,r){const a=this.width!==$.width,h=this.scrollWidth!==$.scrollWidth,c=this.scrollLeft!==$.scrollLeft,i=this.height!==$.height,n=this.scrollHeight!==$.scrollHeight,t=this.scrollTop!==$.scrollTop;return{inSmoothScrolling:r,oldWidth:$.width,oldScrollWidth:$.scrollWidth,oldScrollLeft:$.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:$.height,oldScrollHeight:$.scrollHeight,oldScrollTop:$.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:a,scrollWidthChanged:h,scrollLeftChanged:c,heightChanged:i,scrollHeightChanged:n,scrollTopChanged:t}}}e.$nt=L;class R extends D.$Zc{constructor($){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$qe),this.onScroll=this.j.event,this.c=$.smoothScrollDuration,this.f=$.scheduleAtNextAnimationFrame,this.g=new L($.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration($){this.c=$}validateScrollPosition($){return this.g.withScrollPosition($)}getScrollDimensions(){return this.g}setScrollDimensions($,r){const a=this.g.withScrollDimensions($,r);this.n(a,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow($){const r=this.g.withScrollPosition($);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth($,r){if(this.c===0)return this.setScrollPositionNow($);if(this.h){$={scrollLeft:typeof $.scrollLeft>"u"?this.h.to.scrollLeft:$.scrollLeft,scrollTop:typeof $.scrollTop>"u"?this.h.to.scrollTop:$.scrollTop};const a=this.g.withScrollPosition($);if(this.h.to.scrollLeft===a.scrollLeft&&this.h.to.scrollTop===a.scrollTop)return;let h;r?h=new I(this.h.from,a,this.h.startTime,this.h.duration):h=this.h.combine(this.g,a,this.c),this.h.dispose(),this.h=h}else{const a=this.g.withScrollPosition($);this.h=I.start(this.g,a,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const $=this.h.tick(),r=this.g.withScrollPosition($);if(this.n(r,!0),!!this.h){if($.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n($,r){const a=this.g;a.equals($)||(this.g=$,this.j.fire(this.g.createScrollEvent(a,r)))}}e.$ot=R;class T{constructor($,r,a){this.scrollLeft=$,this.scrollTop=r,this.isDone=a}}e.$pt=T;function m(k,$){const r=$-k;return function(a){return k+r*u(a)}}function s(k,$,r){return function(a){return a<r?k(a/r):$((a-r)/(1-r))}}class I{constructor($,r,a,h){this.from=$,this.to=r,this.duration=h,this.startTime=a,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f($,r,a){if(Math.abs($-r)>2.5*a){let c,i;return $<r?(c=$+.75*a,i=r-.75*a):(c=$-.75*a,i=r+.75*a),s(m($,c),m(i,r),.33)}return m($,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions($){this.to=$.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g($){const r=($-this.startTime)/this.duration;if(r<1){const a=this.c(r),h=this.d(r);return new T(a,h,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine($,r,a){return I.start($,r,a)}static start($,r,a){a=a+10;const h=Date.now()-10;return new I($,r,h,a)}}e.$qt=I;function b(k){return Math.pow(k,3)}function u(k){return 1-b(1-k)}}),define(Re[148],Oe([1,0,12,4]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=P,e.$Ee=L,e.$Fe=R,e.$Ge=T,e.$He=s,e.$Ie=I,e.$Je=b,e.$Ke=u,e.$Le=k,e.$Me=$,e.$Ne=r,e.$Oe=a,e.$Pe=h,e.$Qe=c,e.$Re=i;function P(n){const t=n;return t?typeof t.read=="function":!1}function L(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function R(n){const t=n;return t?L(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(n,t){return new m(n,t)}class m{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,v.$4)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let l;switch(t){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const g=l.indexOf(o);g>=0&&l.splice(g,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(n,t){const o=[];let l;for(;(l=n.read())!==null;)o.push(l);return t(o)}function I(n,t,o){const l=[];let g;for(;(g=n.read())!==null&&l.length<o;)l.push(g);return g===null&&l.length>0?t(l):{read:()=>{if(l.length>0)return l.shift();if(typeof g<"u"){const f=g;return g=void 0,f}return n.read()}}}function b(n,t){return new Promise((o,l)=>{const g=[];u(n,{onData:f=>{t&&g.push(f)},onError:f=>{t?l(f):o(void 0)},onEnd:()=>{o(t?t(g):void 0)}})})}function u(n,t,o){n.on("error",l=>{o?.isCancellationRequested||t.onError(l)}),n.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),n.on("data",l=>{o?.isCancellationRequested||t.onData(l)})}function k(n,t){return new Promise((o,l)=>{const g=new D.$Yc,f=[],d=y=>{if(f.push(y),f.length>t)return g.dispose(),n.pause(),o({stream:n,buffer:f,ended:!1})},S=y=>(g.dispose(),l(y)),E=()=>(g.dispose(),o({stream:n,buffer:f,ended:!0}));g.add((0,D.$Xc)(()=>n.removeListener("error",S))),n.on("error",S),g.add((0,D.$Xc)(()=>n.removeListener("end",E))),n.on("end",E),g.add((0,D.$Xc)(()=>n.removeListener("data",d))),n.on("data",d)})}function $(n,t){const o=T(t);return o.end(n),o}function r(){const n=T(()=>{throw new Error("not supported")});return n.end(),n}function a(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}function h(n,t,o){const l=T(o);return u(n,{onData:g=>l.write(t.data(g)),onError:g=>l.error(t.error?t.error(g):g),onEnd:()=>l.end()}),l}function c(n,t,o){let l=!1;return{read:()=>{const g=t.read();return l?g:(l=!0,g!==null?o([n,g]):n)}}}function i(n,t,o){let l=!1;const g=T(o);return u(t,{onData:f=>l?g.write(f):(l=!0,g.write(o([n,f]))),onError:f=>g.error(f),onEnd:()=>{l||(l=!0,g.write(n)),g.end()}}),g}}),define(Re[20],Oe([1,0,51,148]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=void 0,e.$Te=s,e.$Ue=I,e.$Ve=b,e.$We=u,e.$Xe=k,e.$Ye=$,e.$Ze=r,e.$1e=a,e.$2e=h,e.$3e=c,e.$4e=i,e.$5e=n,e.$6e=t,e.$7e=o,e.$8e=l,e.$9e=g,e.$0e=f,e.$$e=d,e.$_e=S,e.$af=C,D=Ve(D);const P=typeof Buffer<"u",L=new v.$Y(()=>new Uint8Array(256));let R,T;class m{static alloc(p){return P?new m(Buffer.allocUnsafe(p)):new m(new Uint8Array(p))}static wrap(p){return P&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new m(p)}static fromString(p,w){return!(w?.dontUseNodeBuffer||!1)&&P?new m(Buffer.from(p)):(R||(R=new TextEncoder),new m(R.encode(p)))}static fromByteArray(p){const w=m.alloc(p.length);for(let M=0,A=p.length;M<A;M++)w.buffer[M]=p[M];return w}static concat(p,w){if(typeof w>"u"){w=0;for(let F=0,G=p.length;F<G;F++)w+=p[F].byteLength}const M=m.alloc(w);let A=0;for(let F=0,G=p.length;F<G;F++){const x=p[F];M.set(x,A),A+=x.byteLength}return M}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=m.alloc(this.byteLength);return p.set(this),p}toString(){return P?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(p,w){return new m(this.buffer.subarray(p,w))}set(p,w){if(p instanceof m)this.buffer.set(p.buffer,w);else if(p instanceof Uint8Array)this.buffer.set(p,w);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),w);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return u(this.buffer,p)}writeUInt32BE(p,w){k(this.buffer,p,w)}readUInt32LE(p){return $(this.buffer,p)}writeUInt32LE(p,w){r(this.buffer,p,w)}readUInt8(p){return a(this.buffer,p)}writeUInt8(p,w){h(this.buffer,p,w)}indexOf(p,w=0){return s(this.buffer,p instanceof m?p.buffer:p,w)}}e.$Se=m;function s(O,p,w=0){const M=p.byteLength,A=O.byteLength;if(M===0)return 0;if(M===1)return O.indexOf(p[0]);if(M>A-w)return-1;const F=L.value;F.fill(p.length);for(let U=0;U<p.length;U++)F[p[U]]=p.length-U-1;let G=w+p.length-1,x=G,j=-1;for(;G<A;)if(O[G]===p[x]){if(x===0){j=G;break}G--,x--}else G+=Math.max(p.length-x,F[O[G]]),x=p.length-1;return j}function I(O,p){return O[p+0]<<0>>>0|O[p+1]<<8>>>0}function b(O,p,w){O[w+0]=p&255,p=p>>>8,O[w+1]=p&255}function u(O,p){return O[p]*2**24+O[p+1]*2**16+O[p+2]*2**8+O[p+3]}function k(O,p,w){O[w+3]=p,p=p>>>8,O[w+2]=p,p=p>>>8,O[w+1]=p,p=p>>>8,O[w]=p}function $(O,p){return O[p+0]<<0>>>0|O[p+1]<<8>>>0|O[p+2]<<16>>>0|O[p+3]<<24>>>0}function r(O,p,w){O[w+0]=p&255,p=p>>>8,O[w+1]=p&255,p=p>>>8,O[w+2]=p&255,p=p>>>8,O[w+3]=p&255}function a(O,p){return O[p]}function h(O,p,w){O[w]=p}function c(O){return D.$He(O,p=>m.concat(p))}function i(O){return D.$Oe(O)}function n(O){return D.$Je(O,p=>m.concat(p))}async function t(O){return O.ended?m.concat(O.buffer):m.concat([...O.buffer,await n(O.stream)])}function o(O){return D.$Me(O,p=>m.concat(p))}function l(O){return D.$Pe(O,{data:p=>typeof p=="string"?m.fromString(p):m.wrap(p)},p=>m.concat(p))}function g(O){return D.$Ge(p=>m.concat(p),O)}function f(O,p){return D.$Qe(O,p,w=>m.concat(w))}function d(O,p){return D.$Re(O,p,w=>m.concat(w))}function S(O){let p=0,w=0,M=0;const A=new Uint8Array(Math.floor(O.length/4*3)),F=x=>{switch(w){case 3:A[M++]=p|x,w=0;break;case 2:A[M++]=p|x>>>2,p=x<<6,w=3;break;case 1:A[M++]=p|x>>>4,p=x<<4,w=2;break;default:p=x<<2,w=1}};for(let x=0;x<O.length;x++){const j=O.charCodeAt(x);if(j>=65&&j<=90)F(j-65);else if(j>=97&&j<=122)F(j-97+26);else if(j>=48&&j<=57)F(j-48+52);else if(j===43||j===45)F(62);else if(j===47||j===95)F(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${O[x]}`)}}const G=M;for(;w>0;)F(0);return m.wrap(A).slice(0,G)}const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:O},p=!0,w=!1){const M=w?y:E;let A="";const F=O.byteLength%3;let G=0;for(;G<O.byteLength-F;G+=3){const x=O[G+0],j=O[G+1],U=O[G+2];A+=M[x>>>2],A+=M[(x<<4|j>>>4)&63],A+=M[(j<<2|U>>>6)&63],A+=M[U&63]}if(F===1){const x=O[G+0];A+=M[x>>>2],A+=M[x<<4&63],p&&(A+="==")}else if(F===2){const x=O[G+0],j=O[G+1];A+=M[x>>>2],A+=M[(x<<4|j>>>4)&63],A+=M[j<<2&63],p&&(A+="=")}return A}}),define(Re[36],Oe([1,0,98]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$$j=P;var D;(function(R){function T(m){return m&&typeof m=="object"&&typeof m.id=="string"}R.isThemeColor=T})(D||(e.ThemeColor=D={}));function P(R){return{id:R}}var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function m(c){const i=T.exec(c.id);if(!i)return m(v.$0j.error);const[,n,t]=i,o=["codicon","codicon-"+n];return t&&o.push("codicon-modifier-"+t.substring(1)),o}R.asClassNameArray=m;function s(c){return m(c).join(" ")}R.asClassName=s;function I(c){return"."+m(c).join(".")}R.asCSSSelector=I;function b(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||D.isThemeColor(c.color))}R.isThemeIcon=b;const u=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function k(c){const i=u.exec(c);if(!i)return;const[,n]=i;return{id:n}}R.fromString=k;function $(c){return{id:c}}R.fromId=$;function r(c,i){let n=c.id;const t=n.lastIndexOf("~");return t!==-1&&(n=n.substring(0,t)),i&&(n=`${n}~${i}`),{id:n}}R.modify=r;function a(c){const i=c.id.lastIndexOf("~");if(i!==-1)return c.id.substring(i+1)}R.getModifier=a;function h(c,i){return c.id===i.id&&c.color?.id===i.color?.id}R.isEqual=h})(L||(e.ThemeIcon=L={}))}),define(Re[149],Oe([1,0,30,27,141,13]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.FuzzyScore=e.$Nk=e.$Mk=void 0,e.or=R,e.$Ok=m,e.$Pk=s,e.$Qk=u,e.$Rk=E,e.$Sk=y,e.$Tk=A,e.$Uk=F,e.$Vk=G,e.$Wk=x,e.$Xk=re,e.$Zk=Be,e.$1k=ht,e.$2k=$t,L=Ve(L);function R(...Le){return function(Ne,Me){for(let q=0,B=Le.length;q<B;q++){const H=Le[q](Ne,Me);if(H)return H}return null}}e.$Mk=T.bind(void 0,!1),e.$Nk=T.bind(void 0,!0);function T(Le,Ne,Me){if(!Me||Me.length<Ne.length)return null;let q;return Le?q=L.$Lf(Me,Ne):q=Me.indexOf(Ne)===0,q?Ne.length>0?[{start:0,end:Ne.length}]:[]:null}function m(Le,Ne){const Me=Ne.toLowerCase().indexOf(Le.toLowerCase());return Me===-1?null:[{start:Me,end:Me+Le.length}]}function s(Le,Ne){return I(Le.toLowerCase(),Ne.toLowerCase(),0,0)}function I(Le,Ne,Me,q){if(Me===Le.length)return[];if(q===Ne.length)return null;if(Le[Me]===Ne[q]){let B=null;return(B=I(Le,Ne,Me+1,q+1))?t({start:q,end:q+1},B):null}return I(Le,Ne,Me,q+1)}function b(Le){return v.CharCode.a<=Le&&Le<=v.CharCode.z}function u(Le){return v.CharCode.A<=Le&&Le<=v.CharCode.Z}function k(Le){return v.CharCode.Digit0<=Le&&Le<=v.CharCode.Digit9}function $(Le){return Le===v.CharCode.Space||Le===v.CharCode.Tab||Le===v.CharCode.LineFeed||Le===v.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Le=>r.add(Le.charCodeAt(0)));function a(Le){return $(Le)||r.has(Le)}function h(Le,Ne){return Le===Ne||a(Le)&&a(Ne)}const c=new Map;function i(Le){if(c.has(Le))return c.get(Le);let Ne;const Me=(0,P.$Kk)(Le);return Me&&(Ne=Me),c.set(Le,Ne),Ne}function n(Le){return b(Le)||u(Le)||k(Le)}function t(Le,Ne){return Ne.length===0?Ne=[Le]:Le.end===Ne[0].start?Ne[0].start=Le.start:Ne.unshift(Le),Ne}function o(Le,Ne){for(let Me=Ne;Me<Le.length;Me++){const q=Le.charCodeAt(Me);if(u(q)||k(q)||Me>0&&!n(Le.charCodeAt(Me-1)))return Me}return Le.length}function l(Le,Ne,Me,q){if(Me===Le.length)return[];if(q===Ne.length)return null;if(Le[Me]!==Ne[q].toLowerCase())return null;{let B=null,H=q+1;for(B=l(Le,Ne,Me+1,q+1);!B&&(H=o(Ne,H))<Ne.length;)B=l(Le,Ne,Me+1,H),H++;return B===null?null:t({start:q,end:q+1},B)}}function g(Le){let Ne=0,Me=0,q=0,B=0,H=0;for(let ze=0;ze<Le.length;ze++)H=Le.charCodeAt(ze),u(H)&&Ne++,b(H)&&Me++,n(H)&&q++,k(H)&&B++;const Q=Ne/Le.length,se=Me/Le.length,ge=q/Le.length,Ee=B/Le.length;return{upperPercent:Q,lowerPercent:se,alphaPercent:ge,numericPercent:Ee}}function f(Le){const{upperPercent:Ne,lowerPercent:Me}=Le;return Me===0&&Ne>.6}function d(Le){const{upperPercent:Ne,lowerPercent:Me,alphaPercent:q,numericPercent:B}=Le;return Me>.2&&Ne<.8&&q>.6&&B<.2}function S(Le){let Ne=0,Me=0,q=0,B=0;for(let H=0;H<Le.length;H++)q=Le.charCodeAt(H),u(q)&&Ne++,b(q)&&Me++,$(q)&&B++;return(Ne===0||Me===0)&&B===0?Le.length<=30:Ne<=5}function E(Le,Ne){if(!Ne||(Ne=Ne.trim(),Ne.length===0)||!S(Le))return null;Ne.length>60&&(Ne=Ne.substring(0,60));const Me=g(Ne);if(!d(Me)){if(!f(Me))return null;Ne=Ne.toLowerCase()}let q=null,B=0;for(Le=Le.toLowerCase();B<Ne.length&&(q=l(Le,Ne,0,B))===null;)B=o(Ne,B+1);return q}function y(Le,Ne,Me=!1){if(!Ne||Ne.length===0)return null;let q=null,B=0;for(Le=Le.toLowerCase(),Ne=Ne.toLowerCase();B<Ne.length&&(q=C(Le,Ne,0,B,Me),q===null);)B=O(Ne,B+1);return q}function C(Le,Ne,Me,q,B){let H=0;if(Me===Le.length)return[];if(q===Ne.length)return null;if(!h(Le.charCodeAt(Me),Ne.charCodeAt(q))){const ge=i(Le.charCodeAt(Me));if(!ge)return null;for(let Ee=0;Ee<ge.length;Ee++)if(!h(ge[Ee],Ne.charCodeAt(q+Ee)))return null;H+=ge.length-1}let Q=null,se=q+H+1;if(Q=C(Le,Ne,Me+1,se,B),!B)for(;!Q&&(se=O(Ne,se))<Ne.length;)Q=C(Le,Ne,Me+1,se,B),se++;if(!Q)return null;if(Le.charCodeAt(Me)!==Ne.charCodeAt(q)){const ge=i(Le.charCodeAt(Me));if(!ge)return Q;for(let Ee=0;Ee<ge.length;Ee++)if(ge[Ee]!==Ne.charCodeAt(q+Ee))return Q}return t({start:q,end:q+H+1},Q)}function O(Le,Ne){for(let Me=Ne;Me<Le.length;Me++)if(a(Le.charCodeAt(Me))||Me>0&&a(Le.charCodeAt(Me-1)))return Me;return Le.length}const p=R(e.$Nk,E,m),w=R(e.$Nk,E,s),M=new D.$Ic(1e4);function A(Le,Ne,Me=!1){if(typeof Le!="string"||typeof Ne!="string")return null;let q=M.get(Le);q||(q=new RegExp(L.$tf(Le),"i"),M.set(Le,q));const B=q.exec(Ne);return B?[{start:B.index,end:B.index+B[0].length}]:Me?w(Le,Ne):p(Le,Ne)}function F(Le,Ne){const Me=Be(Le,Le.toLowerCase(),0,Ne,Ne.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?x(Me):null}function G(Le,Ne,Me,q,B,H){const Q=Math.min(13,Le.length);for(;Me<Q;Me++){const se=Be(Le,Ne,Me,q,B,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,H]}function x(Le){if(typeof Le>"u")return[];const Ne=[],Me=Le[1];for(let q=Le.length-1;q>1;q--){const B=Le[q]+Me,H=Ne[Ne.length-1];H&&H.end===B?H.end=B+1:Ne.push({start:B,end:B+1})}return Ne}const j=128;function U(){const Le=[],Ne=[];for(let Me=0;Me<=j;Me++)Ne[Me]=0;for(let Me=0;Me<=j;Me++)Le.push(Ne.slice(0));return Le}function J(Le){const Ne=[];for(let Me=0;Me<=Le;Me++)Ne[Me]=0;return Ne}const Z=J(2*j),ae=J(2*j),ee=U(),oe=U(),ie=U(),ue=!1;function _(Le,Ne,Me,q,B){function H(se,ge,Ee=" "){for(;se.length<ge;)se=Ee+se;return se}let Q=` |   |${q.split("").map(se=>H(se,3)).join("|")}
`;for(let se=0;se<=Me;se++)se===0?Q+=" |":Q+=`${Ne[se-1]}|`,Q+=Le[se].slice(0,B+1).map(ge=>H(ge.toString(),3)).join("|")+`
`;return Q}function $e(Le,Ne,Me,q){Le=Le.substr(Ne),Me=Me.substr(q),console.log(_(oe,Le,Le.length,Me,Me.length)),console.log(_(ie,Le,Le.length,Me,Me.length)),console.log(_(ee,Le,Le.length,Me,Me.length))}function Ie(Le,Ne){if(Ne<0||Ne>=Le.length)return!1;const Me=Le.codePointAt(Ne);switch(Me){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!L.$4f(Me)}}function X(Le,Ne){if(Ne<0||Ne>=Le.length)return!1;switch(Le.charCodeAt(Ne)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function V(Le,Ne,Me){return Ne[Le]!==Me[Le]}function re(Le,Ne,Me,q,B,H,Q=!1){for(;Ne<Me&&B<H;)Le[Ne]===q[B]&&(Q&&(Z[Ne]=B),Ne+=1),B+=1;return Ne===Me}var we;(function(Le){Le[Le.Diag=1]="Diag",Le[Le.Left=2]="Left",Le[Le.LeftLeft=3]="LeftLeft"})(we||(we={}));var Pe;(function(Le){Le.Default=[-100,0];function Ne(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}Le.isDefault=Ne})(Pe||(e.FuzzyScore=Pe={}));class Fe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ne,Me){this.firstMatchCanBeWeak=Ne,this.boostFullMatch=Me}}e.$Yk=Fe;function Be(Le,Ne,Me,q,B,H,Q=Fe.default){const se=Le.length>j?j:Le.length,ge=q.length>j?j:q.length;if(Me>=se||H>=ge||se-Me>ge-H||!re(Ne,Me,se,B,H,ge,!0))return;xe(se,ge,Me,H,Ne,B);let Ee=1,ze=1,Je=Me,_e=H;const tt=[!1];for(Ee=1,Je=Me;Je<se;Ee++,Je++){const Ye=Z[Je],he=ae[Je],pe=Je+1<se?ae[Je+1]:ge;for(ze=Ye-H+1,_e=Ye;_e<pe;ze++,_e++){let ye=Number.MIN_SAFE_INTEGER,Ce=!1;_e<=he&&(ye=nt(Le,Ne,Je,Me,q,B,_e,ge,H,ee[Ee-1][ze-1]===0,tt));let fe=0;ye!==Number.MAX_SAFE_INTEGER&&(Ce=!0,fe=ye+oe[Ee-1][ze-1]);const ve=_e>Ye,Y=ve?oe[Ee][ze-1]+(ee[Ee][ze-1]>0?-5:0):0,W=_e>Ye+1&&ee[Ee][ze-1]>0,de=W?oe[Ee][ze-2]+(ee[Ee][ze-2]>0?-5:0):0;if(W&&(!ve||de>=Y)&&(!Ce||de>=fe))oe[Ee][ze]=de,ie[Ee][ze]=we.LeftLeft,ee[Ee][ze]=0;else if(ve&&(!Ce||Y>=fe))oe[Ee][ze]=Y,ie[Ee][ze]=we.Left,ee[Ee][ze]=0;else if(Ce)oe[Ee][ze]=fe,ie[Ee][ze]=we.Diag,ee[Ee][ze]=ee[Ee-1][ze-1]+1;else throw new Error("not possible")}}if(ue&&$e(Le,Me,q,H),!tt[0]&&!Q.firstMatchCanBeWeak)return;Ee--,ze--;const ct=[oe[Ee][ze],H];let it=0,at=0;for(;Ee>=1;){let Ye=ze;do{const he=ie[Ee][Ye];if(he===we.LeftLeft)Ye=Ye-2;else if(he===we.Left)Ye=Ye-1;else break}while(Ye>=1);it>1&&Ne[Me+Ee-1]===B[H+ze-1]&&!V(Ye+H-1,q,B)&&it+1>ee[Ee][Ye]&&(Ye=ze),Ye===ze?it++:it=1,at||(at=Ye),Ee--,ze=Ye-1,ct.push(ze)}ge-H===se&&Q.boostFullMatch&&(ct[0]+=2);const yt=at-se;return ct[0]-=yt,ct}function xe(Le,Ne,Me,q,B,H){let Q=Le-1,se=Ne-1;for(;Q>=Me&&se>=q;)B[Q]===H[se]&&(ae[Q]=se,Q--),se--}function nt(Le,Ne,Me,q,B,H,Q,se,ge,Ee,ze){if(Ne[Me]!==H[Q])return Number.MIN_SAFE_INTEGER;let Je=1,_e=!1;return Q===Me-q?Je=Le[Me]===B[Q]?7:5:V(Q,B,H)&&(Q===0||!V(Q-1,B,H))?(Je=Le[Me]===B[Q]?7:5,_e=!0):Ie(H,Q)&&(Q===0||!Ie(H,Q-1))?Je=5:(Ie(H,Q-1)||X(H,Q-1))&&(Je=5,_e=!0),Je>1&&Me===q&&(ze[0]=!0),_e||(_e=V(Q,B,H)||Ie(H,Q-1)||X(H,Q-1)),Me===q?Q>ge&&(Je-=_e?3:5):Ee?Je+=_e?2:0:Je+=_e?0:1,Q+1===se&&(Je-=_e?3:5),Je}function ht(Le,Ne,Me,q,B,H,Q){return ut(Le,Ne,Me,q,B,H,!0,Q)}function $t(Le,Ne,Me,q,B,H,Q){return ut(Le,Ne,Me,q,B,H,!1,Q)}function ut(Le,Ne,Me,q,B,H,Q,se){let ge=Be(Le,Ne,Me,q,B,H,se);if(ge&&!Q)return ge;if(Le.length>=3){const Ee=Math.min(7,Le.length-1);for(let ze=Me+1;ze<Ee;ze++){const Je=et(Le,ze);if(Je){const _e=Be(Je,Je.toLowerCase(),Me,q,B,H,se);_e&&(_e[0]-=3,(!ge||_e[0]>ge[0])&&(ge=_e))}}}return ge}function et(Le,Ne){if(Ne+1>=Le.length)return;const Me=Le[Ne],q=Le[Ne+1];if(Me!==q)return Le.slice(0,Ne)+q+Me+Le.slice(Ne+2)}}),define(Re[99],Oe([1,0,149,13,36]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=m,e.$4k=I,e.$5k=u,e.$6k=k,e.$7k=r,e.$8k=a;const L="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${R.source}`,"g");function m(h){return h.replace(T,(c,i)=>i?c:`\\${c}`)}const s=new RegExp(`\\\\${R.source}`,"g");function I(h){return h.replace(s,c=>`\\${c}`)}const b=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function u(h){return h.indexOf(L)===-1?h:h.replace(b,(c,i,n,t)=>n?c:i||t||"")}function k(h){return h?h.replace(/\$\((.*?)\)/g,(c,i)=>` ${i} `).trim():""}const $=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(h){$.lastIndex=0;let c="";const i=[];let n=0;for(;;){const t=$.lastIndex,o=$.exec(h),l=h.substring(t,o?.index);if(l.length>0){c+=l;for(let g=0;g<l.length;g++)i.push(n)}if(!o)break;n+=o[0].length}return{text:c,iconOffsets:i}}function a(h,c,i=!1){const{text:n,iconOffsets:t}=c;if(!t||t.length===0)return(0,v.$Tk)(h,n,i);const o=(0,D.$rf)(n," "),l=n.length-o.length,g=(0,v.$Tk)(h,o,i);if(g)for(const f of g){const d=t[f.start+l]+l;f.start+=d,f.end+=d}return g}}),define(Re[37],Oe([1,0,13]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=Ve(v);var D;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(D||(D={})),function(P){const L="error",R="warning",T="warn",m="info",s="ignore";function I(u){return u?v.$Kf(L,u)?P.Error:v.$Kf(R,u)||v.$Kf(T,u)?P.Warning:v.$Kf(m,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function b(u){switch(u){case P.Error:return L;case P.Warning:return R;case P.Info:return m;default:return s}}P.toString=b}(D||(D={})),e.default=D}),define(Re[48],Oe([1,0,17,30,13]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class L{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const r=$.charCodeAt(0),a=this.b.charCodeAt(this.c);return r-a}value(){return this.b[this.c]}}e.$Mi=L;class R{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===D.CharCode.Period)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,P.$Ef)($,this.b,0,$.length,this.c,this.d):(0,P.$Gf)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ni=R;class T{constructor($=!0,r=!0){this.f=$,this.g=r}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let r=$.length-1;r>=0;r--,this.c--){const a=this.b.charCodeAt(r);if(!(a===D.CharCode.Slash||this.f&&a===D.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===D.CharCode.Slash||this.f&&r===D.CharCode.Backslash)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,P.$Ef)($,this.b,0,$.length,this.d,this.e):(0,P.$Gf)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Oi=T;var m;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(m||(m={}));class s{constructor($,r){this.f=$,this.g=r,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(m.Scheme),this.c.authority&&this.d.push(m.Authority),this.c.path&&(this.b=new T(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(m.Path)),this.g($)||(this.c.query&&this.d.push(m.Query),this.c.fragment&&this.d.push(m.Fragment)),this.e=0,this}next(){return this.d[this.e]===m.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===m.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===m.Scheme)return(0,P.$Ff)($,this.c.scheme);if(this.d[this.e]===m.Authority)return(0,P.$Ff)($,this.c.authority);if(this.d[this.e]===m.Path)return this.b.cmp($);if(this.d[this.e]===m.Query)return(0,P.$Df)($,this.c.query);if(this.d[this.e]===m.Fragment)return(0,P.$Df)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===m.Scheme)return this.c.scheme;if(this.d[this.e]===m.Authority)return this.c.authority;if(this.d[this.e]===m.Path)return this.b.value();if(this.d[this.e]===m.Query)return this.c.query;if(this.d[this.e]===m.Fragment)return this.c.fragment;throw new Error}}e.$Pi=s;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(b||(b={}));class u{static forUris($=()=>!1,r=()=>!1){return new u(new s($,r))}static forPaths($=!1){return new u(new T(void 0,!$))}static forStrings(){return new u(new L)}static forConfigKeys(){return new u(new R)}constructor($){this.b=$}clear(){this.c=void 0}fill($,r){if(r){const a=r.slice(0);(0,v.$1b)(a);for(const h of a)this.set(h,$)}else{const a=$.slice(0);(0,v.$1b)(a);for(const h of a)this.set(h[0],h[1])}}set($,r){const a=this.b.reset($);let h;this.c||(this.c=new I,this.c.segment=a.value());const c=[];for(h=this.c;;){const n=a.cmp(h.segment);if(n>0)h.left||(h.left=new I,h.left.segment=a.value()),c.push([b.Left,h]),h=h.left;else if(n<0)h.right||(h.right=new I,h.right.segment=a.value()),c.push([b.Right,h]),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new I,h.mid.segment=a.value()),c.push([b.Mid,h]),h=h.mid;else break}const i=h.value;h.value=r,h.key=$;for(let n=c.length-1;n>=0;n--){const t=c[n][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const l=c[n][0],g=c[n+1][0];if(l===b.Right&&g===b.Right)c[n][1]=t.rotateLeft();else if(l===b.Left&&g===b.Left)c[n][1]=t.rotateRight();else if(l===b.Right&&g===b.Left)t.right=c[n+1][1]=c[n+1][1].rotateRight(),c[n][1]=t.rotateLeft();else if(l===b.Left&&g===b.Right)t.left=c[n+1][1]=c[n+1][1].rotateLeft(),c[n][1]=t.rotateRight();else throw new Error;if(n>0)switch(c[n-1][0]){case b.Left:c[n-1][1].left=c[n][1];break;case b.Right:c[n-1][1].right=c[n][1];break;case b.Mid:c[n-1][1].mid=c[n][1];break}else this.c=c[0][1]}}return i}get($){return this.d($)?.value}d($){const r=this.b.reset($);let a=this.c;for(;a;){const h=r.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has($){const r=this.d($);return!(r?.value===void 0&&r?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,r){const a=this.b.reset($),h=[];let c=this.c;for(;c;){const i=a.cmp(c.segment);if(i>0)h.push([b.Left,c]),c=c.left;else if(i<0)h.push([b.Right,c]),c=c.right;else if(a.hasNext())a.next(),h.push([b.Mid,c]),c=c.mid;else break}if(c){if(r?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const i=this.f(c.right);if(i.key){const{key:n,value:t,segment:o}=i;this.e(i.key,!1),c.key=n,c.value=t,c.segment=o}}else{const i=c.left??c.right;if(h.length>0){const[n,t]=h[h.length-1];switch(n){case b.Left:t.left=i;break;case b.Mid:t.mid=i;break;case b.Right:t.right=i;break}}else this.c=i}for(let i=h.length-1;i>=0;i--){const n=h[i][1];n.updateHeight();const t=n.balanceFactor();if(t>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),h[i][1]=n.rotateLeft()):t<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),h[i][1]=n.rotateRight()),i>0)switch(h[i-1][0]){case b.Left:h[i-1][1].left=h[i][1];break;case b.Right:h[i-1][1].right=h[i][1];break;case b.Mid:h[i-1][1].mid=h[i][1];break}else this.c=h[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const r=this.b.reset($);let a=this.c,h;for(;a;){const c=r.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(r.hasNext())r.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr($){return this.g($,!1)}g($,r){const a=this.b.reset($);let h=this.c;for(;h;){const c=a.cmp(h.segment);if(c>0)h=h.left;else if(c<0)h=h.right;else if(a.hasNext())a.next(),h=h.mid;else return h.mid?this.h(h.mid):r?h.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[r,a]of this)$(a,r)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const r=[];return this.j($,r),r[Symbol.iterator]()}j($,r){$&&($.left&&this.j($.left,r),$.value&&r.push([$.key,$.value]),$.mid&&this.j($.mid,r),$.right&&this.j($.right,r))}_isBalanced(){const $=r=>{if(!r)return!0;const a=r.balanceFactor();return a<-1||a>1?!1:$(r.left)&&$(r.right)};return $(this.c)}}e.$Qi=u}),define(Re[33],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=void 0,e.$6g=D;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(P){return v.test(P)}e.$7g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(T){for(let m=0;m<T.length;m++)T[m]=Math.floor(Math.random()*256);return T};const L=new Uint8Array(16),R=[];for(let T=0;T<256;T++)R.push(T.toString(16).padStart(2,"0"));return function(){P(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let m=0,s="";return s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+="-",s+=R[L[m++]],s+=R[L[m++]],s+="-",s+=R[L[m++]],s+=R[L[m++]],s+="-",s+=R[L[m++]],s+=R[L[m++]],s+="-",s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s}}()}),define(Re[150],Oe([1,0,17,41,33]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Du=e.$Bu=void 0,e.$zu=L,e.$Au=R,e.$Cu=s;function L(b){return{asString:async()=>b,asFile:()=>{},value:typeof b=="string"?b:void 0}}function R(b,u,k){const $={id:(0,P.$7g)(),name:b,uri:u,data:k};return{asString:async()=>"",asFile:()=>$,value:void 0}}class T{constructor(){this.a=new Map}get size(){let u=0;for(const k of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const k=[...this.a.keys()];return D.Iterable.some(this,([$,r])=>r.asFile())&&k.push("files"),I(m(u),k)}get(u){return this.a.get(this.b(u))?.[0]}append(u,k){const $=this.a.get(u);$?$.push(k):this.a.set(this.b(u),[k])}replace(u,k){this.a.set(this.b(u),[k])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,k]of this.a)for(const $ of k)yield[u,$]}b(u){return m(u)}}e.$Bu=T;function m(b){return b.toLowerCase()}function s(b,u){return I(m(b),u.map(m))}function I(b,u){if(b==="*/*")return u.length>0;if(u.includes(b))return!0;const k=b.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[$,r,a]=k;return a==="*"?u.some(h=>h.startsWith(r+"/")):!1}e.$Du=Object.freeze({create:b=>(0,v.$Qb)(b.map(u=>u.toString())).join(`\r
`),split:b=>b.split(`\r
`),parse:b=>e.$Du.split(b).filter(u=>!u.startsWith("#"))})}),define(Re[151],Oe([1,0,30]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Ju=P;var D;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function P(L){let R=0,T=0,m=0,s=D.Unknown;for(let I=0,b=L.length;I<b;I++){const u=L.charCodeAt(I);u===v.CharCode.CarriageReturn?(R===0&&(T=I),R++,I+1<b&&L.charCodeAt(I+1)===v.CharCode.LineFeed?(s|=D.CRLF,I++):s|=D.Invalid,m=I+1):u===v.CharCode.LineFeed&&(s|=D.LF,R===0&&(T=I),R++,m=I+1)}return R===0&&(T=L.length),[R,T,L.length-m,s]}}),define(Re[152],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$vt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[153],Oe([1,0,30,154]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9u=e.$8u=e.IndentAction=void 0;var P;(function(m){m[m.None=0]="None",m[m.Indent=1]="Indent",m[m.IndentOutdent=2]="IndentOutdent",m[m.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class L{constructor(s){if(this.e=null,this.f=!1,this.open=s.open,this.close=s.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(s.notIn))for(let I=0,b=s.notIn.length;I<b;I++)switch(s.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(s){switch(s){case D.StandardTokenType.Other:return!0;case D.StandardTokenType.Comment:return this.c;case D.StandardTokenType.String:return this.b;case D.StandardTokenType.RegEx:return this.d}}shouldAutoClose(s,I){if(s.getTokenCount()===0)return!0;const b=s.findTokenIndexAtOffset(I-2),u=s.getStandardTokenType(b);return this.isOK(u)}g(s,I){for(let b=s;b<=I;b++){const u=String.fromCharCode(b);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$8u=L;class R{constructor(s){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of s)T(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),T(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),T(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),T(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&T(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$9u=R;function T(m,s,I){m.has(s)?m.get(s).push(I):m.set(s,[I])}}),define(Re[155],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qD=e.NodeColor=e.$pD=void 0,e.$rD=P,e.$sD=L,e.$tD=s,e.$uD=I,e.$vD=b,e.$wD=u,e.$xD=k,e.$yD=$;class v{constructor(a,h){this.piece=a,this.color=h,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$qD)return P(this.right);let a=this;for(;a.parent!==e.$qD&&a.parent.left!==a;)a=a.parent;return a.parent===e.$qD?e.$qD:a.parent}prev(){if(this.left!==e.$qD)return L(this.left);let a=this;for(;a.parent!==e.$qD&&a.parent.right!==a;)a=a.parent;return a.parent===e.$qD?e.$qD:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$pD=v;var D;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(D||(e.NodeColor=D={})),e.$qD=new v(null,D.Black),e.$qD.parent=e.$qD,e.$qD.left=e.$qD,e.$qD.right=e.$qD,e.$qD.color=D.Black;function P(r){for(;r.left!==e.$qD;)r=r.left;return r}function L(r){for(;r.right!==e.$qD;)r=r.right;return r}function R(r){return r===e.$qD?0:r.size_left+r.piece.length+R(r.right)}function T(r){return r===e.$qD?0:r.lf_left+r.piece.lineFeedCnt+T(r.right)}function m(){e.$qD.parent=e.$qD}function s(r,a){const h=a.right;h.size_left+=a.size_left+(a.piece?a.piece.length:0),h.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=h.left,h.left!==e.$qD&&(h.left.parent=a),h.parent=a.parent,a.parent===e.$qD?r.root=h:a.parent.left===a?a.parent.left=h:a.parent.right=h,h.left=a,a.parent=h}function I(r,a){const h=a.left;a.left=h.right,h.right!==e.$qD&&(h.right.parent=a),h.parent=a.parent,a.size_left-=h.size_left+(h.piece?h.piece.length:0),a.lf_left-=h.lf_left+(h.piece?h.piece.lineFeedCnt:0),a.parent===e.$qD?r.root=h:a===a.parent.right?a.parent.right=h:a.parent.left=h,h.right=a,a.parent=h}function b(r,a){let h,c;if(a.left===e.$qD?(c=a,h=c.right):a.right===e.$qD?(c=a,h=c.left):(c=P(a.right),h=c.right),c===r.root){r.root=h,h.color=D.Black,a.detach(),m(),r.root.parent=e.$qD;return}const i=c.color===D.Red;if(c===c.parent.left?c.parent.left=h:c.parent.right=h,c===a?(h.parent=c.parent,$(r,h)):(c.parent===a?h.parent=c:h.parent=c.parent,$(r,h),c.left=a.left,c.right=a.right,c.parent=a.parent,c.color=a.color,a===r.root?r.root=c:a===a.parent.left?a.parent.left=c:a.parent.right=c,c.left!==e.$qD&&(c.left.parent=c),c.right!==e.$qD&&(c.right.parent=c),c.size_left=a.size_left,c.lf_left=a.lf_left,$(r,c)),a.detach(),h.parent.left===h){const t=R(h),o=T(h);if(t!==h.parent.size_left||o!==h.parent.lf_left){const l=t-h.parent.size_left,g=o-h.parent.lf_left;h.parent.size_left=t,h.parent.lf_left=o,k(r,h.parent,l,g)}}if($(r,h.parent),i){m();return}let n;for(;h!==r.root&&h.color===D.Black;)h===h.parent.left?(n=h.parent.right,n.color===D.Red&&(n.color=D.Black,h.parent.color=D.Red,s(r,h.parent),n=h.parent.right),n.left.color===D.Black&&n.right.color===D.Black?(n.color=D.Red,h=h.parent):(n.right.color===D.Black&&(n.left.color=D.Black,n.color=D.Red,I(r,n),n=h.parent.right),n.color=h.parent.color,h.parent.color=D.Black,n.right.color=D.Black,s(r,h.parent),h=r.root)):(n=h.parent.left,n.color===D.Red&&(n.color=D.Black,h.parent.color=D.Red,I(r,h.parent),n=h.parent.left),n.left.color===D.Black&&n.right.color===D.Black?(n.color=D.Red,h=h.parent):(n.left.color===D.Black&&(n.right.color=D.Black,n.color=D.Red,s(r,n),n=h.parent.left),n.color=h.parent.color,h.parent.color=D.Black,n.left.color=D.Black,I(r,h.parent),h=r.root));h.color=D.Black,m()}function u(r,a){for($(r,a);a!==r.root&&a.parent.color===D.Red;)if(a.parent===a.parent.parent.left){const h=a.parent.parent.right;h.color===D.Red?(a.parent.color=D.Black,h.color=D.Black,a.parent.parent.color=D.Red,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,s(r,a)),a.parent.color=D.Black,a.parent.parent.color=D.Red,I(r,a.parent.parent))}else{const h=a.parent.parent.left;h.color===D.Red?(a.parent.color=D.Black,h.color=D.Black,a.parent.parent.color=D.Red,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,I(r,a)),a.parent.color=D.Black,a.parent.parent.color=D.Red,s(r,a.parent.parent))}r.root.color=D.Black}function k(r,a,h,c){for(;a!==r.root&&a!==e.$qD;)a.parent.left===a&&(a.parent.size_left+=h,a.parent.lf_left+=c),a=a.parent}function $(r,a){let h=0,c=0;if(a!==r.root){for(;a!==r.root&&a===a.parent.right;)a=a.parent;if(a!==r.root)for(a=a.parent,h=R(a.left)-a.size_left,c=T(a.left)-a.lf_left,a.size_left+=h,a.lf_left+=c;a!==r.root&&(h!==0||c!==0);)a.parent.left===a&&(a.parent.size_left+=h,a.parent.lf_left+=c),a=a.parent}}}),define(Re[100],Oe([1,0,30,101,32,52,155,102]),function(be,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JD=e.$ID=e.$HD=void 0,e.$FD=b,e.$GD=u;const m=65535;function s(c){let i;return c[c.length-1]<65536?i=new Uint16Array(c.length):i=new Uint32Array(c.length),i.set(c,0),i}class I{constructor(i,n,t,o,l){this.lineStarts=i,this.cr=n,this.lf=t,this.crlf=o,this.isBasicASCII=l}}function b(c,i=!0){const n=[0];let t=1;for(let o=0,l=c.length;o<l;o++){const g=c.charCodeAt(o);g===v.CharCode.CarriageReturn?o+1<l&&c.charCodeAt(o+1)===v.CharCode.LineFeed?(n[t++]=o+2,o++):n[t++]=o+1:g===v.CharCode.LineFeed&&(n[t++]=o+1)}return i?s(n):n}function u(c,i){c.length=0,c[0]=0;let n=1,t=0,o=0,l=0,g=!0;for(let d=0,S=i.length;d<S;d++){const E=i.charCodeAt(d);E===v.CharCode.CarriageReturn?d+1<S&&i.charCodeAt(d+1)===v.CharCode.LineFeed?(l++,c[n++]=d+2,d++):(t++,c[n++]=d+1):E===v.CharCode.LineFeed?(o++,c[n++]=d+1):g&&E!==v.CharCode.Tab&&(E<32||E>126)&&(g=!1)}const f=new I(s(c),t,o,l,g);return c.length=0,f}class k{constructor(i,n,t,o,l){this.bufferIndex=i,this.start=n,this.end=t,this.lineFeedCnt=o,this.length=l}}e.$HD=k;class ${constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$ID=$;class r{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==R.$qD&&i.iterate(i.root,t=>(t!==R.$qD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const t=this.b;for(let o=0;o<t.length;o++){const l=t[o];if(l.node.parent===null||l.nodeStartOffset>=i){t[o]=null,n=!0;continue}}if(n){const o=[];for(const l of t)l!==null&&o.push(l);this.b=o}}}class h{constructor(i,n,t){this.create(i,n,t)}create(i,n,t){this.a=[new $("",[0])],this.g={line:0,column:0},this.root=R.$qD,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=t;let o=null;for(let l=0,g=i.length;l<g;l++)if(i[l].buffer.length>0){i[l].lineStarts||(i[l].lineStarts=b(i[l].buffer));const f=new k(l+1,{line:0,column:0},{line:i[l].lineStarts.length-1,column:i[l].buffer.length-i[l].lineStarts[i[l].lineStarts.length-1]},i[l].lineStarts.length-1,i[l].buffer.length);this.a.push(i[l]),o=this.S(o,f)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=m,t=n-Math.floor(n/3),o=t*2;let l="",g=0;const f=[];if(this.iterate(this.root,d=>{const S=this.R(d),E=S.length;if(g<=t||g+E<o)return l+=S,g+=E,!0;const y=l.replace(/\r\n|\r|\n/g,i);return f.push(new $(y,b(y))),l=S,g=E,!0}),g>0){const d=l.replace(/\r\n|\r|\n/g,i);f.push(new $(d,b(d)))}this.create(f,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,o=>{if(o===R.$qD)return!0;const l=this.R(o),g=l.length,f=i.G(n),d=i.G(n+g),S=i.getValueInRange2(f,d);return n+=g,l===S})}getOffsetAt(i,n){let t=0,o=this.root;for(;o!==R.$qD;)if(o.left!==R.$qD&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const l=this.B(o,i-o.lf_left-2);return t+=l+n-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,t=0;const o=i;for(;n!==R.$qD;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const l=this.A(n,i-n.size_left);if(t+=n.lf_left+l.index,l.index===0){const g=this.getOffsetAt(t+1,1),f=o-g;return new D.$Xt(t+1,f+1)}return new D.$Xt(t+1,l.remainder+1)}else if(i-=n.size_left+n.piece.length,t+=n.lf_left+n.piece.lineFeedCnt,n.right===R.$qD){const l=this.getOffsetAt(t+1,1),g=o-i-l;return new D.$Xt(t+1,g+1)}else n=n.right;return new D.$Xt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),l=this.getValueInRange2(t,o);return n?n!==this.d||!this.f?l.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?l:l.replace(/\r\n|\r|\n/g,n):l}getValueInRange2(i,n){if(i.node===n.node){const f=i.node,d=this.a[f.piece.bufferIndex].buffer,S=this.u(f.piece.bufferIndex,f.piece.start);return d.substring(S+i.remainder,S+n.remainder)}let t=i.node;const o=this.a[t.piece.bufferIndex].buffer,l=this.u(t.piece.bufferIndex,t.piece.start);let g=o.substring(l+i.remainder,l+t.piece.length);for(t=t.next();t!==R.$qD;){const f=this.a[t.piece.bufferIndex].buffer,d=this.u(t.piece.bufferIndex,t.piece.start);if(t===n.node){g+=f.substring(d,d+n.remainder);break}else g+=f.substr(d,t.piece.length);t=t.next()}return g}getLinesContent(){const i=[];let n=0,t="",o=!1;return this.iterate(this.root,l=>{if(l===R.$qD)return!0;const g=l.piece;let f=g.length;if(f===0)return!0;const d=this.a[g.bufferIndex].buffer,S=this.a[g.bufferIndex].lineStarts,E=g.start.line,y=g.end.line;let C=S[E]+g.start.column;if(o&&(d.charCodeAt(C)===v.CharCode.LineFeed&&(C++,f--),i[n++]=t,t="",o=!1,f===0))return!0;if(E===y)return!this.f&&d.charCodeAt(C+f-1)===v.CharCode.CarriageReturn?(o=!0,t+=d.substr(C,f-1)):t+=d.substr(C,f),!0;t+=this.f?d.substring(C,Math.max(C,S[E+1]-this.e)):d.substring(C,S[E+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;for(let O=E+1;O<y;O++)t=this.f?d.substring(S[O],S[O+1]-this.e):d.substring(S[O],S[O+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;return!this.f&&d.charCodeAt(S[y]+g.end.column-1)===v.CharCode.CarriageReturn?(o=!0,g.end.column===0?n--:t=d.substr(S[y],g.end.column-1)):t=d.substr(S[y],g.end.column),!0}),o&&(i[n++]=t,t=""),i[n++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const t=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start);return t.buffer.charCodeAt(o)}else{const n=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(o)}}getLineCharCode(i,n){const t=this.H(i,n+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}getNearestChunk(i){const n=this.G(i);if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t||t===R.$qD)return"";const o=this.a[t.piece.bufferIndex],l=this.u(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(l,l+t.piece.length)}else{const t=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start),l=o+n.remainder,g=o+n.node.piece.length;return t.buffer.substring(l,g)}}findMatchesInNode(i,n,t,o,l,g,f,d,S,E,y){const C=this.a[i.piece.bufferIndex],O=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,l),w=this.u(i.piece.bufferIndex,g);let M;const A={line:0,column:0};let F,G;n._wordSeparators?(F=C.buffer.substring(p,w),G=x=>x+p,n.reset(0)):(F=C.buffer,G=x=>x,n.reset(p));do if(M=n.next(F),M){if(G(M.index)>=w)return E;this.s(i,G(M.index)-O,A);const x=this.t(i.piece.bufferIndex,l,A),j=A.line===l.line?A.column-l.column+o:A.column+1,U=j+M[0].length;if(y[E++]=(0,T.$BD)(new P.$Yt(t+x,j,t+x,U),M,d),G(M.index)+M[0].length>=w||E>=S)return E}while(M);return E}findMatchesLineByLine(i,n,t,o){const l=[];let g=0;const f=new T.$ED(n.wordSeparators,n.regex);let d=this.H(i.startLineNumber,i.startColumn);if(d===null)return[];const S=this.H(i.endLineNumber,i.endColumn);if(S===null)return[];let E=this.s(d.node,d.remainder);const y=this.s(S.node,S.remainder);if(d.node===S.node)return this.findMatchesInNode(d.node,f,i.startLineNumber,i.startColumn,E,y,n,t,o,g,l),l;let C=i.startLineNumber,O=d.node;for(;O!==S.node;){const w=this.t(O.piece.bufferIndex,E,O.piece.end);if(w>=1){const A=this.a[O.piece.bufferIndex].lineStarts,F=this.u(O.piece.bufferIndex,O.piece.start),G=A[E.line+w],x=C===i.startLineNumber?i.startColumn:1;if(g=this.findMatchesInNode(O,f,C,x,E,this.s(O,G-F),n,t,o,g,l),g>=o)return l;C+=w}const M=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const A=this.getLineContent(C).substring(M,i.endColumn-1);return g=this.n(n,f,A,i.endLineNumber,M,g,l,t,o),l}if(g=this.n(n,f,this.getLineContent(C).substr(M),C,M,g,l,t,o),g>=o)return l;C++,d=this.H(C,1),O=d.node,E=this.s(d.node,d.remainder)}if(C===i.endLineNumber){const w=C===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(C).substring(w,i.endColumn-1);return g=this.n(n,f,M,i.endLineNumber,w,g,l,t,o),l}const p=C===i.startLineNumber?i.startColumn:1;return g=this.findMatchesInNode(S.node,f,C,p,E,y,n,t,o,g,l),l}n(i,n,t,o,l,g,f,d,S){const E=i.wordSeparators;if(!d&&i.simpleSearch){const C=i.simpleSearch,O=C.length,p=t.length;let w=-O;for(;(w=t.indexOf(C,w+O))!==-1;)if((!E||(0,T.$DD)(E,t,p,w,O))&&(f[g++]=new L.$pw(new P.$Yt(o,w+1+l,o,w+1+O+l),null),g>=S))return g;return g}let y;n.reset(0);do if(y=n.next(t),y&&(f[g++]=(0,T.$BD)(new P.$Yt(o,y.index+1+l,o,y.index+1+y[0].length+l),y,d),g>=S))return g;while(y);return g}insert(i,n,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==R.$qD){const{node:o,remainder:l,nodeStartOffset:g}=this.G(i),f=o.piece,d=f.bufferIndex,S=this.s(o,l);if(o.piece.bufferIndex===0&&f.end.line===this.g.line&&f.end.column===this.g.column&&g+f.length===i&&n.length<m){this.F(o,n),this.y();return}if(g===i)this.o(n,o),this.h.validate(i);else if(g+o.piece.length>i){const E=[];let y=new k(f.bufferIndex,S,f.end,this.t(f.bufferIndex,S,f.end),this.u(d,f.end)-this.u(d,S));if(this.K()&&this.M(n)&&this.I(o,l)===10){const w={line:y.start.line+1,column:0};y=new k(y.bufferIndex,w,y.end,this.t(y.bufferIndex,w,y.end),y.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(o,l-1)===13){const w=this.s(o,l-1);this.C(o,w),n="\r"+n,o.piece.length===0&&E.push(o)}else this.C(o,S);else this.C(o,S);const C=this.w(n);y.length>0&&this.S(o,y);let O=o;for(let p=0;p<C.length;p++)O=this.S(O,C[p]);this.v(E)}else this.q(n,o)}else{const o=this.w(n);let l=this.T(null,o[0]);for(let g=1;g<o.length;g++)l=this.S(l,o[g])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===R.$qD)return;const t=this.G(i),o=this.G(i+n),l=t.node,g=o.node;if(l===g){const C=this.s(l,t.remainder),O=this.s(l,o.remainder);if(t.nodeStartOffset===i){if(n===l.piece.length){const p=l.next();(0,R.$vD)(this,l),this.N(p),this.y();return}this.D(l,O),this.h.validate(i),this.N(l),this.y();return}if(t.nodeStartOffset+l.piece.length===i+n){this.C(l,C),this.O(l),this.y();return}this.E(l,C,O),this.y();return}const f=[],d=this.s(l,t.remainder);this.C(l,d),this.h.validate(i),l.piece.length===0&&f.push(l);const S=this.s(g,o.remainder);this.D(g,S),g.piece.length===0&&f.push(g);const E=l.next();for(let C=E;C!==R.$qD&&C!==g;C=C.next())f.push(C);const y=l.piece.length===0?l.prev():l;this.v(f),this.O(y),this.y()}o(i,n){const t=[];if(this.K()&&this.M(i)&&this.L(n)){const g=n.piece,f={line:g.start.line+1,column:0},d=new k(g.bufferIndex,f,g.end,this.t(g.bufferIndex,f,g.end),g.length-1);n.piece=d,i+=`
`,(0,R.$xD)(this,n,-1,-1),n.piece.length===0&&t.push(n)}const o=this.w(i);let l=this.T(n,o[o.length-1]);for(let g=o.length-2;g>=0;g--)l=this.T(l,o[g]);this.N(l),this.v(t)}q(i,n){this.Q(i,n)&&(i+=`
`);const t=this.w(i),o=this.S(n,t[0]);let l=o;for(let g=1;g<t.length;g++)l=this.S(l,t[g]);this.N(o)}s(i,n,t){const o=i.piece,l=i.piece.bufferIndex,g=this.a[l].lineStarts,d=g[o.start.line]+o.start.column+n;let S=o.start.line,E=o.end.line,y=0,C=0,O=0;for(;S<=E&&(y=S+(E-S)/2|0,O=g[y],y!==E);)if(C=g[y+1],d<O)E=y-1;else if(d>=C)S=y+1;else break;return t?(t.line=y,t.column=d-O,null):{line:y,column:d-O}}t(i,n,t){if(t.column===0)return t.line-n.line;const o=this.a[i].lineStarts;if(t.line===o.length-1)return t.line-n.line;const l=o[t.line+1],g=o[t.line]+t.column;if(l>g+1)return t.line-n.line;const f=g-1;return this.a[i].buffer.charCodeAt(f)===13?t.line-n.line+1:t.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,R.$vD)(this,i[n])}w(i){if(i.length>m){const E=[];for(;i.length>m;){const C=i.charCodeAt(m-1);let O;C===v.CharCode.CarriageReturn||C>=55296&&C<=56319?(O=i.substring(0,m-1),i=i.substring(m-1)):(O=i.substring(0,m),i=i.substring(m));const p=b(O);E.push(new k(this.a.length,{line:0,column:0},{line:p.length-1,column:O.length-p[p.length-1]},p.length-1,O.length)),this.a.push(new $(O,p))}const y=b(i);return E.push(new k(this.a.length,{line:0,column:0},{line:y.length-1,column:i.length-y[y.length-1]},y.length-1,i.length)),this.a.push(new $(i,y)),E}let n=this.a[0].buffer.length;const t=b(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let E=0;E<t.length;E++)t[E]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let E=0;E<t.length;E++)t[E]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const l=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,f=l-this.a[0].lineStarts[g],d={line:g,column:f},S=new k(0,o,d,this.t(0,o,d),l-n);return this.g=d,[S]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let t=this.root,o="";const l=this.h.get2(i);if(l){t=l.node;const g=this.B(t,i-l.nodeStartLineNumber-1),f=this.a[t.piece.bufferIndex].buffer,d=this.u(t.piece.bufferIndex,t.piece.start);if(l.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=f.substring(d+g,d+t.piece.length);else{const S=this.B(t,i-l.nodeStartLineNumber);return f.substring(d+g,d+S-n)}}else{let g=0;const f=i;for(;t!==R.$qD;)if(t.left!==R.$qD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const d=this.B(t,i-t.lf_left-2),S=this.B(t,i-t.lf_left-1),E=this.a[t.piece.bufferIndex].buffer,y=this.u(t.piece.bufferIndex,t.piece.start);return g+=t.size_left,this.h.set({node:t,nodeStartOffset:g,nodeStartLineNumber:f-(i-1-t.lf_left)}),E.substring(y+d,y+S-n)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const d=this.B(t,i-t.lf_left-2),S=this.a[t.piece.bufferIndex].buffer,E=this.u(t.piece.bufferIndex,t.piece.start);o=S.substring(E+d,E+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==R.$qD;){const g=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const f=this.B(t,0),d=this.u(t.piece.bufferIndex,t.piece.start);return o+=g.substring(d,d+f-n),o}else{const f=this.u(t.piece.bufferIndex,t.piece.start);o+=g.substr(f,t.piece.length)}t=t.next()}return o}y(){let i=this.root,n=1,t=0;for(;i!==R.$qD;)n+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=t,this.h.validate(this.c)}A(i,n){const t=i.piece,o=this.s(i,n),l=o.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===n){const g=this.t(i.piece.bufferIndex,t.start,o);if(g!==l)return{index:g,remainder:0}}return{index:l,remainder:o.column}}B(i,n){if(n<0)return 0;const t=i.piece,o=this.a[t.bufferIndex].lineStarts,l=t.start.line+n+1;return l>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[l]-o[t.start.line]-t.start.column}C(i,n){const t=i.piece,o=t.lineFeedCnt,l=this.u(t.bufferIndex,t.end),g=n,f=this.u(t.bufferIndex,g),d=this.t(t.bufferIndex,t.start,g),S=d-o,E=f-l,y=t.length+E;i.piece=new k(t.bufferIndex,t.start,g,d,y),(0,R.$xD)(this,i,E,S)}D(i,n){const t=i.piece,o=t.lineFeedCnt,l=this.u(t.bufferIndex,t.start),g=n,f=this.t(t.bufferIndex,g,t.end),d=this.u(t.bufferIndex,g),S=f-o,E=l-d,y=t.length+E;i.piece=new k(t.bufferIndex,g,t.end,f,y),(0,R.$xD)(this,i,E,S)}E(i,n,t){const o=i.piece,l=o.start,g=o.end,f=o.length,d=o.lineFeedCnt,S=n,E=this.t(o.bufferIndex,o.start,S),y=this.u(o.bufferIndex,n)-this.u(o.bufferIndex,l);i.piece=new k(o.bufferIndex,o.start,S,E,y),(0,R.$xD)(this,i,y-f,E-d);const C=new k(o.bufferIndex,t,g,this.t(o.bufferIndex,t,g),this.u(o.bufferIndex,g)-this.u(o.bufferIndex,t)),O=this.S(i,C);this.N(O)}F(i,n){this.Q(n,i)&&(n+=`
`);const t=this.K()&&this.L(n)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=n;const l=b(n,!1);for(let O=0;O<l.length;O++)l[O]+=o;if(t){const O=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-O}}this.a[0].lineStarts=this.a[0].lineStarts.concat(l.slice(1));const g=this.a[0].lineStarts.length-1,f=this.a[0].buffer.length-this.a[0].lineStarts[g],d={line:g,column:f},S=i.piece.length+n.length,E=i.piece.lineFeedCnt,y=this.t(0,i.piece.start,d),C=y-E;i.piece=new k(i.piece.bufferIndex,i.piece.start,d,y,S),this.g=d,(0,R.$xD)(this,i,n.length,C)}G(i){let n=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;n!==R.$qD;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){o+=n.size_left;const l={node:n,remainder:i-n.size_left,nodeStartOffset:o};return this.h.set(l),l}else i-=n.size_left+n.piece.length,o+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let t=this.root,o=0;for(;t!==R.$qD;)if(t.left!==R.$qD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const l=this.B(t,i-t.lf_left-2),g=this.B(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(l+n-1,g),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const l=this.B(t,i-t.lf_left-2);if(l+n-1<=t.piece.length)return{node:t,remainder:l+n-1,nodeStartOffset:o};n-=t.piece.length-l;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==R.$qD;){if(t.piece.lineFeedCnt>0){const l=this.B(t,0),g=this.J(t);return{node:t,remainder:Math.min(n-1,l),nodeStartOffset:g}}else if(t.piece.length>=n-1){const l=this.J(t);return{node:t,remainder:n-1,nodeStartOffset:l}}else n-=t.piece.length;t=t.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+n;return t.buffer.charCodeAt(o)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$qD||i.piece.lineFeedCnt===0)return!1;const n=i.piece,t=this.a[n.bufferIndex].lineStarts,o=n.start.line,l=t[o]+n.start.column;return o===t.length-1||t[o+1]>l+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(l)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$qD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const t=[],o=this.a[i.piece.bufferIndex].lineStarts;let l;i.piece.end.column===0?l={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:l={line:i.piece.end.line,column:i.piece.end.column-1};const g=i.piece.length-1,f=i.piece.lineFeedCnt-1;i.piece=new k(i.piece.bufferIndex,i.piece.start,l,f,g),(0,R.$xD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const d={line:n.piece.start.line+1,column:0},S=n.piece.length-1,E=this.t(n.piece.bufferIndex,d,n.piece.end);n.piece=new k(n.piece.bufferIndex,d,n.piece.end,E,S),(0,R.$xD)(this,n,-1,-1),n.piece.length===0&&t.push(n);const y=this.w(`\r
`);this.S(i,y[0]);for(let C=0;C<t.length;C++)(0,R.$vD)(this,t[C])}Q(i,n){if(this.K()&&this.M(i)){const t=n.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,R.$vD)(this,t);else{const o=t.piece,l={line:o.start.line+1,column:0},g=o.length-1,f=this.t(o.bufferIndex,l,o.end);t.piece=new k(o.bufferIndex,l,o.end,f,g),(0,R.$xD)(this,t,-1,-1)}return!0}}return!1}iterate(i,n){if(i===R.$qD)return n(R.$qD);const t=this.iterate(i.left,n);return t&&n(i)&&this.iterate(i.right,n)}R(i){if(i===R.$qD)return"";const n=this.a[i.piece.bufferIndex],t=i.piece,o=this.u(t.bufferIndex,t.start),l=this.u(t.bufferIndex,t.end);return n.buffer.substring(o,l)}getPieceContent(i){const n=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return n.buffer.substring(t,o)}S(i,n){const t=new R.$pD(n,R.NodeColor.Red);if(t.left=R.$qD,t.right=R.$qD,t.parent=R.$qD,t.size_left=0,t.lf_left=0,this.root===R.$qD)this.root=t,t.color=R.NodeColor.Black;else if(i.right===R.$qD)i.right=t,t.parent=i;else{const l=(0,R.$rD)(i.right);l.left=t,t.parent=l}return(0,R.$wD)(this,t),t}T(i,n){const t=new R.$pD(n,R.NodeColor.Red);if(t.left=R.$qD,t.right=R.$qD,t.parent=R.$qD,t.size_left=0,t.lf_left=0,this.root===R.$qD)this.root=t,t.color=R.NodeColor.Black;else if(i.left===R.$qD)i.left=t,t.parent=i;else{const o=(0,R.$sD)(i.left);o.right=t,t.parent=o}return(0,R.$wD)(this,t),t}U(i){let n="";return this.iterate(i,t=>(n+=this.R(t),!0)),n}}e.$JD=h}),define(Re[156],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tab=e.$sab=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$sab=v;class D{constructor(L){this.identifier=L}}e.$tab=D}),define(Re[157],Oe([1,0,6,4,9]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0,e.$uj=I,P=Ve(P);class L extends D.$Zc{constructor(u,k="",$="",r=!0,a){super(),this.j=this.B(new v.$qe),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=k,this.w=$,this.z=r,this.D=a}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,k){this.D&&await this.D(u)}}e.$pj=L;class R extends D.$Zc{constructor(){super(...arguments),this.f=this.B(new v.$qe),this.onWillRun=this.f.event,this.m=this.B(new v.$qe),this.onDidRun=this.m.event}async run(u,k){if(!u.enabled)return;this.f.fire({action:u});let $;try{await this.u(u,k)}catch(r){$=r}this.m.fire({action:u,error:$})}async u(u,k){await u.run(k)}}e.$qj=R;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let k=[];for(const $ of u)$.length&&(k.length?k=[...k,new T,...$]:k=$);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$rj=T;class m{get actions(){return this.a}constructor(u,k,$,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=k,this.class=r,this.a=$}async run(){}}e.$sj=m;class s extends L{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,P.localize(41,null),void 0,!1)}}e.$tj=s;function I(b){return{id:b.id,label:b.label,tooltip:b.tooltip??b.label,class:b.class,enabled:b.enabled??!0,checked:b.checked,run:async(...u)=>b.run(...u)}}}),define(Re[158],Oe([1,0,9]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=s,e.$0m=I,e.$$m=b,e.$_m=u;const D=60,P=D*60,L=P*24,R=L*7,T=L*30,m=L*365;function s(k,$,r,a){typeof k!="number"&&(k=k.getTime());const h=Math.round((new Date().getTime()-k)/1e3);if(h<-30)return(0,v.localize)(42,null,s(new Date().getTime()+h*1e3,!1));if(!a&&h<30)return(0,v.localize)(43,null);let c;return h<D?(c=h,$?c===1?r?(0,v.localize)(44,null,c):(0,v.localize)(45,null,c):r?(0,v.localize)(46,null,c):(0,v.localize)(47,null,c):c===1?r?(0,v.localize)(48,null,c):(0,v.localize)(49,null,c):r?(0,v.localize)(50,null,c):(0,v.localize)(51,null,c)):h<P?(c=Math.floor(h/D),$?c===1?r?(0,v.localize)(52,null,c):(0,v.localize)(53,null,c):r?(0,v.localize)(54,null,c):(0,v.localize)(55,null,c):c===1?r?(0,v.localize)(56,null,c):(0,v.localize)(57,null,c):r?(0,v.localize)(58,null,c):(0,v.localize)(59,null,c)):h<L?(c=Math.floor(h/P),$?c===1?r?(0,v.localize)(60,null,c):(0,v.localize)(61,null,c):r?(0,v.localize)(62,null,c):(0,v.localize)(63,null,c):c===1?r?(0,v.localize)(64,null,c):(0,v.localize)(65,null,c):r?(0,v.localize)(66,null,c):(0,v.localize)(67,null,c)):h<R?(c=Math.floor(h/L),$?c===1?(0,v.localize)(68,null,c):(0,v.localize)(69,null,c):c===1?(0,v.localize)(70,null,c):(0,v.localize)(71,null,c)):h<T?(c=Math.floor(h/R),$?c===1?r?(0,v.localize)(72,null,c):(0,v.localize)(73,null,c):r?(0,v.localize)(74,null,c):(0,v.localize)(75,null,c):c===1?r?(0,v.localize)(76,null,c):(0,v.localize)(77,null,c):r?(0,v.localize)(78,null,c):(0,v.localize)(79,null,c)):h<m?(c=Math.floor(h/T),$?c===1?r?(0,v.localize)(80,null,c):(0,v.localize)(81,null,c):r?(0,v.localize)(82,null,c):(0,v.localize)(83,null,c):c===1?r?(0,v.localize)(84,null,c):(0,v.localize)(85,null,c):r?(0,v.localize)(86,null,c):(0,v.localize)(87,null,c)):(c=Math.floor(h/m),$?c===1?r?(0,v.localize)(88,null,c):(0,v.localize)(89,null,c):r?(0,v.localize)(90,null,c):(0,v.localize)(91,null,c):c===1?r?(0,v.localize)(92,null,c):(0,v.localize)(93,null,c):r?(0,v.localize)(94,null,c):(0,v.localize)(95,null,c))}function I(k,$,r){typeof k!="number"&&(k=k.getTime());const a=new Date;a.setHours(0,0,0,0);const h=new Date(a.getTime());return h.setDate(h.getDate()-1),k>a.getTime()?(0,v.localize)(96,null):k>h.getTime()?(0,v.localize)(97,null):s(k,$,r)}function b(k,$){const r=Math.abs(k/1e3);return r<1?$?(0,v.localize)(98,null,k):(0,v.localize)(99,null,k):r<D?$?(0,v.localize)(100,null,Math.round(k)/1e3):(0,v.localize)(101,null,Math.round(k)/1e3):r<P?$?(0,v.localize)(102,null,Math.round(k/(1e3*D))):(0,v.localize)(103,null,Math.round(k/(1e3*D))):r<L?$?(0,v.localize)(104,null,Math.round(k/(1e3*P))):(0,v.localize)(105,null,Math.round(k/(1e3*P))):(0,v.localize)(106,null,Math.round(k/(1e3*L)))}function u(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Re[42],Oe([1,0,17,14,9]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=m,e.$wj=s,e.$xj=I,v=Ve(v),D=Ve(D),P=Ve(P);function L(b,u){return u&&(b.stack||b.stacktrace)?P.localize(107,null,T(b),R(b.stack)||R(b.stacktrace)):T(b)}function R(b){return Array.isArray(b)?b.join(`
`):b}function T(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?P.localize(108,null,b.message):b.message||P.localize(109,null)}function m(b=null,u=!1){if(!b)return P.localize(110,null);if(Array.isArray(b)){const k=v.$Lb(b),$=m(k[0],u);return k.length>1?P.localize(111,null,$,k.length):$}if(D.$jg(b))return b;if(b.detail){const k=b.detail;if(k.error)return L(k.error,u);if(k.exception)return L(k.exception,u)}return b.stack?L(b,u):b.message?b.message:P.localize(112,null)}function s(b){const u=b;return u instanceof Error&&Array.isArray(u.actions)}function I(b,u){let k;return typeof b=="string"?k=new Error(b):k=b,k.actions=u,k}}),define(Re[159],Oe([1,0,51,22]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=T,e.$Lr=m,e.$Mr=s,e.$Nr=I,e.$Or=b,e.$Pr=u,e.$Qr=k,e.$Rr=$,e.$Sr=r,e.$Tr=a,e.$Ur=d,e.$Vr=S,e.$Wr=E;const P=new v.$Y(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),L=new v.$Y(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new v.$Y(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(y,C,O=!1){const p=y||"",w=C||"",M=P.value.collator.compare(p,w);return P.value.collatorIsNumeric&&M===0&&p!==w?p<w?-1:1:M}function m(y,C){const O=L.value.collator;return y=y||"",C=C||"",n(O,y,C)}function s(y,C){const O=L.value.collator;return y=y||"",C=C||"",g(y,C)||n(O,y,C)}function I(y,C){const O=L.value.collator;return y=y||"",C=C||"",l(y,C)||n(O,y,C)}function b(y,C){return y=y||"",C=C||"",y===C?0:y<C?-1:1}function u(y,C){const[O,p]=c(y),[w,M]=c(C);let A=P.value.collator.compare(p,M);if(A===0){if(P.value.collatorIsNumeric&&p!==M)return p<M?-1:1;if(A=P.value.collator.compare(O,w),P.value.collatorIsNumeric&&A===0&&O!==w)return O<w?-1:1}return A}function k(y,C){y=y||"",C=C||"";const O=i(y),p=i(C),w=L.value.collator,M=R.value.collator;return n(M,O,p)||n(w,y,C)}function $(y,C){y=y||"",C=C||"";const O=i(y),p=i(C),w=L.value.collator,M=R.value.collator;return n(M,O,p)||g(y,C)||n(w,y,C)}function r(y,C){y=y||"",C=C||"";const O=i(y),p=i(C),w=L.value.collator,M=R.value.collator;return n(M,O,p)||l(y,C)||n(w,y,C)}function a(y,C){y=y||"",C=C||"";const O=i(y).toLowerCase(),p=i(C).toLowerCase();return O!==p?O<p?-1:1:y!==C?y<C?-1:1:0}const h=/^(.*?)(\.([^.]*))?$/;function c(y,C=!1){const O=y?h.exec(y):[];let p=[O&&O[1]||"",O&&O[3]||""];return C&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function i(y){const C=y?h.exec(y):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function n(y,C,O){const p=y.compare(C,O);return p!==0?p:C.length!==O.length?C.length<O.length?-1:1:0}function t(y){const C=y.charAt(0);return C.toLocaleUpperCase()!==C}function o(y){const C=y.charAt(0);return C.toLocaleLowerCase()!==C}function l(y,C){return t(y)&&o(C)?-1:o(y)&&t(C)?1:0}function g(y,C){return o(y)&&t(C)?-1:t(y)&&o(C)?1:0}function f(y,C,O=!1){return O||(y=y&&y.toLowerCase(),C=C&&C.toLowerCase()),y===C?0:y<C?-1:1}function d(y,C,O=!1){const p=y.split(D.sep),w=C.split(D.sep),M=p.length-1,A=w.length-1;let F,G;for(let x=0;;x++){if(F=M===x,G=A===x,F&&G)return T(p[x],w[x],O);if(F)return-1;if(G)return 1;const j=f(p[x],w[x],O);if(j!==0)return j}}function S(y,C,O){const p=y.toLowerCase(),w=C.toLowerCase(),M=E(y,C,O);if(M)return M;const A=p.endsWith(O),F=w.endsWith(O);if(A!==F)return A?-1:1;const G=T(p,w);return G!==0?G:p.localeCompare(w)}function E(y,C,O){const p=y.toLowerCase(),w=C.toLowerCase(),M=p.startsWith(O),A=w.startsWith(O);if(M!==A)return M?-1:1;if(M&&A){if(p.length<w.length)return-1;if(p.length>w.length)return 1}return 0}}),define(Re[72],Oe([1,0,22]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=void 0,e.$jt=L,e.$kt=R,e.$lt=T,e.$mt=s,e.$it=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const D={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(I){const b=(0,v.$tc)(I),u=D[b.toLowerCase()];return u!==void 0?u:R(I)}function R(I){const b=(0,v.$tc)(I);return P[b.toLowerCase()]}function T(I){for(const b in P)if(P[b]===I)return b}const m=/^(.+)\/(.+?)(;.+)?$/;function s(I,b){const u=m.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:b?void 0:I}}),define(Re[34],Oe([1,0,20,2,38]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=L,e.$gi=R,e.$hi=m;function L(s){return JSON.stringify(s,T)}function R(s){let I=JSON.parse(s);return I=m(I),I}function T(s,I){return I instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function m(s,I=0){if(!s||I>200)return s;if(typeof s=="object"){switch(s.$mid){case P.MarshalledId.Uri:return D.URI.revive(s);case P.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case P.MarshalledId.Date:return new Date(s.source)}if(s instanceof v.$Se||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let b=0;b<s.length;++b)s[b]=m(s[b],I+1);else for(const b in s)Object.hasOwnProperty.call(s,b)&&(s[b]=m(s[b],I+1))}return s}}),define(Re[43],Oe([1,0,17,10,30,73,27,22,23,13]),function(be,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=void 0,e.$Ak=I,e.$Dk=r,e.$Ek=M,e.$Fk=A,e.$Gk=F,e.$Hk=G,e.$Ik=x,e.$Jk=Z;function I(){return Object.create(null)}e.$Bk="**",e.$Ck="/";const b="[/\\\\]",u="[^/\\\\]",k=/\//g;function $(ae,ee){switch(ae){case 0:return"";case 1:return`${u}*?`;default:return`(?:${b}|${u}+${b}${ee?`|${b}${u}+`:""})*?`}}function r(ae,ee){if(!ae)return[];const oe=[];let ie=!1,ue=!1,_="";for(const $e of ae){switch($e){case ee:if(!ie&&!ue){oe.push(_),_="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}_+=$e}return _&&oe.push(_),oe}function a(ae){if(!ae)return"";let ee="";const oe=r(ae,e.$Ck);if(oe.every(ie=>ie===e.$Bk))ee=".*";else{let ie=!1;oe.forEach((ue,_)=>{if(ue===e.$Bk){if(ie)return;ee+=$(2,_===oe.length-1)}else{let $e=!1,Ie="",X=!1,V="";for(const re of ue){if(re!=="}"&&$e){Ie+=re;continue}if(X&&(re!=="]"||!V)){let we;re==="-"?we=re:(re==="^"||re==="!")&&!V?we="^":re===e.$Ck?we="":we=(0,s.$mf)(re),V+=we;continue}switch(re){case"{":$e=!0;continue;case"[":X=!0;continue;case"}":{const Pe=`(?:${r(Ie,",").map(Fe=>a(Fe)).join("|")})`;ee+=Pe,$e=!1,Ie="";break}case"]":{ee+="["+V+"]",X=!1,V="";break}case"?":ee+=u;continue;case"*":ee+=$(1);continue;default:ee+=(0,s.$mf)(re)}}_<oe.length-1&&(oe[_+1]!==e.$Bk||_+2<oe.length)&&(ee+=b)}ie=ue===e.$Bk})}return ee}const h=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new R.$Ic(1e4),g=function(){return!1},f=function(){return null};function d(ae,ee){if(!ae)return f;let oe;typeof ae!="string"?oe=ae.pattern:oe=ae,oe=oe.trim();const ie=`${oe}_${!!ee.trimForExclusions}`;let ue=l.get(ie);if(ue)return S(ue,ae);let _;return h.test(oe)?ue=y(oe.substr(4),oe):(_=c.exec(E(oe,ee)))?ue=C(_[1],oe):(ee.trimForExclusions?n:i).test(oe)?ue=O(oe,ee):(_=t.exec(E(oe,ee)))?ue=p(_[1].substr(1),oe,!0):(_=o.exec(E(oe,ee)))?ue=p(_[1],oe,!1):ue=w(oe),l.set(ie,ue),S(ue,ae)}function S(ae,ee){if(typeof ee=="string")return ae;const oe=function(ie,ue){return(0,L.$Jg)(ie,ee.base,!m.$n)?ae((0,s.$rf)(ie.substr(ee.base.length),T.sep),ue):null};return oe.allBasenames=ae.allBasenames,oe.allPaths=ae.allPaths,oe.basenames=ae.basenames,oe.patterns=ae.patterns,oe}function E(ae,ee){return ee.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function y(ae,ee){return function(oe,ie){return typeof oe=="string"&&oe.endsWith(ae)?ee:null}}function C(ae,ee){const oe=`/${ae}`,ie=`\\${ae}`,ue=function($e,Ie){return typeof $e!="string"?null:Ie?Ie===ae?ee:null:$e===ae||$e.endsWith(oe)||$e.endsWith(ie)?ee:null},_=[ae];return ue.basenames=_,ue.patterns=[ee],ue.allBasenames=_,ue}function O(ae,ee){const oe=J(ae.slice(1,-1).split(",").map(Ie=>d(Ie,ee)).filter(Ie=>Ie!==f),ae),ie=oe.length;if(!ie)return f;if(ie===1)return oe[0];const ue=function(Ie,X){for(let V=0,re=oe.length;V<re;V++)if(oe[V](Ie,X))return ae;return null},_=oe.find(Ie=>!!Ie.allBasenames);_&&(ue.allBasenames=_.allBasenames);const $e=oe.reduce((Ie,X)=>X.allPaths?Ie.concat(X.allPaths):Ie,[]);return $e.length&&(ue.allPaths=$e),ue}function p(ae,ee,oe){const ie=T.sep===T.$lc.sep,ue=ie?ae:ae.replace(k,T.sep),_=T.sep+ue,$e=T.$lc.sep+ae;let Ie;return oe?Ie=function(X,V){return typeof X=="string"&&(X===ue||X.endsWith(_)||!ie&&(X===ae||X.endsWith($e)))?ee:null}:Ie=function(X,V){return typeof X=="string"&&(X===ue||!ie&&X===ae)?ee:null},Ie.allPaths=[(oe?"*/":"./")+ae],Ie}function w(ae){try{const ee=new RegExp(`^${a(ae)}$`);return function(oe){return ee.lastIndex=0,typeof oe=="string"&&ee.test(oe)?ae:null}}catch{return f}}function M(ae,ee,oe){return!ae||typeof ee!="string"?!1:A(ae)(ee,void 0,oe)}function A(ae,ee={}){if(!ae)return g;if(typeof ae=="string"||F(ae)){const oe=d(ae,ee);if(oe===f)return g;const ie=function(ue,_){return!!oe(ue,_)};return oe.allBasenames&&(ie.allBasenames=oe.allBasenames),oe.allPaths&&(ie.allPaths=oe.allPaths),ie}return j(ae,ee)}function F(ae){const ee=ae;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}function G(ae){return ae.allBasenames||[]}function x(ae){return ae.allPaths||[]}function j(ae,ee){const oe=J(Object.getOwnPropertyNames(ae).map(Ie=>U(Ie,ae[Ie],ee)).filter(Ie=>Ie!==f)),ie=oe.length;if(!ie)return f;if(!oe.some(Ie=>!!Ie.requiresSiblings)){if(ie===1)return oe[0];const Ie=function(re,we){let Pe;for(let Fe=0,Be=oe.length;Fe<Be;Fe++){const xe=oe[Fe](re,we);if(typeof xe=="string")return xe;(0,D.$wh)(xe)&&(Pe||(Pe=[]),Pe.push(xe))}return Pe?(async()=>{for(const Fe of Pe){const Be=await Fe;if(typeof Be=="string")return Be}return null})():null},X=oe.find(re=>!!re.allBasenames);X&&(Ie.allBasenames=X.allBasenames);const V=oe.reduce((re,we)=>we.allPaths?re.concat(we.allPaths):re,[]);return V.length&&(Ie.allPaths=V),Ie}const ue=function(Ie,X,V){let re,we;for(let Pe=0,Fe=oe.length;Pe<Fe;Pe++){const Be=oe[Pe];Be.requiresSiblings&&V&&(X||(X=(0,T.$sc)(Ie)),re||(re=X.substr(0,X.length-(0,T.$tc)(Ie).length)));const xe=Be(Ie,X,re,V);if(typeof xe=="string")return xe;(0,D.$wh)(xe)&&(we||(we=[]),we.push(xe))}return we?(async()=>{for(const Pe of we){const Fe=await Pe;if(typeof Fe=="string")return Fe}return null})():null},_=oe.find(Ie=>!!Ie.allBasenames);_&&(ue.allBasenames=_.allBasenames);const $e=oe.reduce((Ie,X)=>X.allPaths?Ie.concat(X.allPaths):Ie,[]);return $e.length&&(ue.allPaths=$e),ue}function U(ae,ee,oe){if(ee===!1)return f;const ie=d(ae,oe);if(ie===f)return f;if(typeof ee=="boolean")return ie;if(ee){const ue=ee.when;if(typeof ue=="string"){const _=($e,Ie,X,V)=>{if(!V||!ie($e,Ie))return null;const re=ue.replace("$(basename)",()=>X),we=V(re);return(0,D.$wh)(we)?we.then(Pe=>Pe?ae:null):we?ae:null};return _.requiresSiblings=!0,_}}return ie}function J(ae,ee){const oe=ae.filter(Ie=>!!Ie.basenames);if(oe.length<2)return ae;const ie=oe.reduce((Ie,X)=>{const V=X.basenames;return V?Ie.concat(V):Ie},[]);let ue;if(ee){ue=[];for(let Ie=0,X=ie.length;Ie<X;Ie++)ue.push(ee)}else ue=oe.reduce((Ie,X)=>{const V=X.patterns;return V?Ie.concat(V):Ie},[]);const _=function(Ie,X){if(typeof Ie!="string")return null;if(!X){let re;for(re=Ie.length;re>0;re--){const we=Ie.charCodeAt(re-1);if(we===P.CharCode.Slash||we===P.CharCode.Backslash)break}X=Ie.substr(re)}const V=ie.indexOf(X);return V!==-1?ue[V]:null};_.basenames=ie,_.patterns=ue,_.allBasenames=ie;const $e=ae.filter(Ie=>!Ie.basenames);return $e.push(_),$e}function Z(ae,ee){return(0,v.$yb)(ae,ee,(oe,ie)=>typeof oe=="string"&&typeof ie=="string"?oe===ie:typeof oe!="string"&&typeof ie!="string"?oe.base===ie.base&&oe.pattern===ie.pattern:!1)}}),define(Re[59],Oe([1,0,12,99,24,13,2]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.MarkdownStringTextNewlineStyle=void 0,e.$0k=s,e.$$k=I,e.$_k=b,e.$al=u,e.$bl=k,e.$cl=$,e.$dl=r,e.$el=a;var T;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class m{constructor(c="",i=!1){if(this.value=c,typeof this.value!="string")throw(0,v.$$)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(c,i=T.Paragraph){return this.value+=u(this.supportThemeIcons?(0,D.$3k)(c):c).replace(/([ \t]+)/g,(n,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,i){return this.value+=`
${k(i,c)}
`,this}appendLink(c,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(c),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(c,i){const n=new RegExp((0,L.$mf)(i),"g");return c.replace(n,(t,o)=>c.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.$9k=m;function s(h){return I(h)?!h.value:Array.isArray(h)?h.every(s):!0}function I(h){return h instanceof m?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function b(h,c){return h===c?!0:!h||!c?!1:h.value===c.value&&h.isTrusted===c.isTrusted&&h.supportThemeIcons===c.supportThemeIcons&&h.supportHtml===c.supportHtml&&(h.baseUri===c.baseUri||!!h.baseUri&&!!c.baseUri&&(0,P.$eh)(R.URI.from(h.baseUri),R.URI.from(c.baseUri)))}function u(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function k(h,c){const i=h.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,n=i>=3?i+1:3;return[`${"`".repeat(n)}${c}`,h,`${"`".repeat(n)}`].join(`
`)}function $(h){return h.replace(/"/g,"&quot;")}function r(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function a(h){const c=[],i=h.split("|").map(t=>t.trim());h=i[0];const n=i[1];if(n){const t=/height=(\d+)/.exec(n),o=/width=(\d+)/.exec(n),l=t?t[1]:"",g=o?o[1]:"",f=isFinite(parseInt(g)),d=isFinite(parseInt(l));f&&c.push(`width="${g}"`),d&&c.push(`height="${l}"`)}return{href:h,dimensions:c}}}),define(Re[103],Oe([1,0,17,73,22,23,24,13]),function(be,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$w=m,e.$_w=I,e.$ax=u,e.$bx=k,e.$cx=h,e.$dx=i,e.$ex=n,e.$fx=t,e.$gx=o,e.$hx=l;function m(f,d){const{os:S,tildify:E,relative:y}=d;if(y){const p=s(f,y,S);if(typeof p=="string")return p}let C=f.fsPath;if(S===L.OperatingSystem.Windows&&!L.$l?C=C.replace(/\//g,"\\"):S!==L.OperatingSystem.Windows&&L.$l&&(C=C.replace(/\\/g,"/")),S!==L.OperatingSystem.Windows&&E?.userHome){const p=E.userHome.fsPath;let w;f.scheme!==E.userHome.scheme&&f.path[0]===P.$lc.sep&&f.path[1]!==P.$lc.sep?w=E.userHome.with({path:f.path}).fsPath:w=C,C=u(w,p,S)}return(S===L.OperatingSystem.Windows?P.$kc:P.$lc).normalize(I(C,S===L.OperatingSystem.Windows))}function s(f,d,S){const E=S===L.OperatingSystem.Windows?P.$kc:P.$lc,y=S===L.OperatingSystem.Linux?R.$bh:R.$dh,C=d.getWorkspace(),O=(0,v.$Sb)(C.folders);if(!O)return;f.scheme!==O.uri.scheme&&f.path[0]===P.$lc.sep&&f.path[1]!==P.$lc.sep&&(f=O.uri.with({path:f.path}));const p=d.getWorkspaceFolder(f);if(!p)return;let w;if(y.isEqual(p.uri,f)?w="":w=y.relativePath(p.uri,f)??"",w&&(w=E.normalize(w)),C.folders.length>1&&!d.noPrefix){const M=p.name?p.name:y.basenameOrAuthority(p.uri);w=w?`${M} \u2022 ${w}`:M}return w}function I(f,d=L.$l){return(0,D.$Og)(f,d)?f.charAt(0).toUpperCase()+f.slice(1):f}let b=Object.create(null);function u(f,d,S=L.OS){if(S===L.OperatingSystem.Windows||!f||!d)return f;let E=b.original===d?b.normalized:void 0;E||(E=d,L.$l&&(E=(0,D.$Dg)(E)),E=`${(0,T.$sf)(E,P.$lc.sep)}${P.$lc.sep}`,b={original:d,normalized:E});let y=f;return L.$l&&(y=(0,D.$Dg)(y)),(S===L.OperatingSystem.Linux?y.startsWith(E):(0,T.$Lf)(y,E))?`~/${y.substr(E.length)}`:f}function k(f,d){return f.replace(/^~($|\/|\\)/,`${d}$1`)}const $="\u2026",r="\\\\",a="~";function h(f,d=P.sep){const S=new Array(f.length);let E=!1;for(let y=0;y<f.length;y++){const C=f[y];if(C===""){S[y]=`.${d}`;continue}if(!C){S[y]=C;continue}E=!0;let O="",p=C;p.indexOf(r)===0?(O=p.substr(0,p.indexOf(r)+r.length),p=p.substr(p.indexOf(r)+r.length)):p.indexOf(d)===0?(O=p.substr(0,p.indexOf(d)+d.length),p=p.substr(p.indexOf(d)+d.length)):p.indexOf(a)===0&&(O=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length));const w=p.split(d);for(let M=1;E&&M<=w.length;M++)for(let A=w.length-M;E&&A>=0;A--){E=!1;let F=w.slice(A,A+M).join(d);for(let G=0;!E&&G<f.length;G++)if(G!==y&&f[G]&&f[G].indexOf(F)>-1){const x=A+M===w.length,j=A>0&&f[G].indexOf(d)>-1?d+F:F,U=f[G].endsWith(j);E=!x||U}if(!E){let G="";(w[0].endsWith(":")||O!=="")&&(A===1&&(A=0,M++,F=w[0]+d+F),A>0&&(G=w[0]+d),G=O+G),A>0&&(G=G+$+d),G=G+F,A+M<w.length&&(G=G+d+$),S[y]=G}}E&&(S[y]=C)}return S}var c;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function i(f,d=Object.create(null)){const S=[];let E=!1,y="";for(const C of f)if(C==="$"||E&&C==="{")y&&S.push({value:y,type:c.TEXT}),y="",E=!0;else if(C==="}"&&E){const O=d[y];if(typeof O=="string")O.length&&S.push({value:O,type:c.VARIABLE});else if(O){const p=S[S.length-1];(!p||p.type!==c.SEPARATOR)&&S.push({value:O.label,type:c.SEPARATOR})}y="",E=!1}else y+=C;return y&&!E&&S.push({value:y,type:c.TEXT}),S.filter((C,O)=>{if(C.type===c.SEPARATOR){const p=S[O-1],w=S[O+1];return[p,w].every(M=>M&&(M.type===c.VARIABLE||M.type===c.TEXT)&&M.value.length>0)}return!0}).map(C=>C.value).join("")}function n(f,d){return L.$m||d?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$m?"&":"&&"):f.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function t(f,d){return L.$m||d?f.replace(/\(&&\w\)|&&/g,""):L.$l?f.replace(/&&|&/g,S=>S==="&"?"&&":"&"):f.replace(/&&/g,"_")}function o(f){return f.replace(/&/g,"&&")}function l(f){if(f.endsWith("]")){const d=f.lastIndexOf(" [",f.length-2);if(d!==-1){const S=g(f.substring(0,d)),E=f.substring(d);return{name:S.name+E,parentPath:S.parentPath}}}return g(f)}function g(f){const d=f.indexOf("/")!==-1?P.$lc:P.$kc,S=d.basename(f),E=d.dirname(f);return S.length?{name:S,parentPath:E}:{name:E,parentPath:""}}}),define(Re[160],Oe([1,0,20,38,2]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=void 0,e.$Wn=m,e.$Xn=I,e.$Yn=b;function L(u){return u.toJSON()}class R{constructor(k){this.a=k}transformIncoming(k){const $=this.a.transformIncoming(k);return $===k?k:L(P.URI.from($))}transformOutgoing(k){const $=this.a.transformOutgoing(k);return $===k?k:L(P.URI.from($))}transformOutgoingURI(k){const $=this.a.transformOutgoing(k);return $===k?k:P.URI.from($)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$Un=R,e.$Vn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function T(u,k,$){if(!u||$>200)return null;if(typeof u=="object"){if(u instanceof P.URI)return k.transformOutgoing(u);for(const r in u)if(Object.hasOwnProperty.call(u,r)){const a=T(u[r],k,$+1);a!==null&&(u[r]=a)}}return null}function m(u,k){const $=T(u,k,0);return $===null?u:$}function s(u,k,$,r){if(!u||r>200)return null;if(typeof u=="object"){if(u.$mid===D.MarshalledId.Uri)return $?P.URI.revive(k.transformIncoming(u)):k.transformIncoming(u);if(u instanceof v.$Se)return null;for(const a in u)if(Object.hasOwnProperty.call(u,a)){const h=s(u[a],k,$,r+1);h!==null&&(u[a]=h)}}return null}function I(u,k){const $=s(u,k,!1,0);return $===null?u:$}function b(u,k){const $=s(u,k,!0,0);return $===null?u:$}}),define(Re[161],Oe([1,0,10,6,4,34,14]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=e.StorageState=e.StorageHint=void 0,e.$lq=m;var T;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function m(u){const k=u;return k?.changed instanceof Map||k?.deleted instanceof Set}var s;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(s||(e.StorageState=s={}));class I extends P.$Zc{static{this.a=100}constructor(k,$=Object.create(null)){super(),this.r=k,this.s=$,this.b=this.B(new D.$te),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new v.$Ih(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach(($,r)=>this.w(r,$)),k.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(k,$){if(this.c===s.Closed)return;let r=!1;(0,R.$sg)($)?r=this.f.delete(k):this.f.get(k)!==$&&(this.f.set(k,$),r=!0),r&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,$){const r=this.f.get(k);return(0,R.$sg)(r)?$:r}getBoolean(k,$){const r=this.get(k);return(0,R.$sg)(r)?$:r==="true"}getNumber(k,$){const r=this.get(k);return(0,R.$sg)(r)?$:parseInt(r,10)}getObject(k,$){const r=this.get(k);return(0,R.$sg)(r)?$:(0,L.$gi)(r)}async set(k,$,r=!1){if(this.c===s.Closed)return;if((0,R.$sg)($))return this.delete(k,r);const a=(0,R.$lg)($)||Array.isArray($)?(0,L.$fi)($):String($);if(this.f.get(k)!==a)return this.f.set(k,a),this.j.set(k,a),this.h.delete(k),this.b.fire({key:k,external:r}),this.D()}async delete(k,$=!1){if(!(this.c===s.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:$}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(!(this.c===s.Closed||this.m))return this.D(k)}async D(k){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$mq=I;class b{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach(($,r)=>this.a.set(r,$)),k.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$nq=b}),define(Re[162],Oe([1,0,13,23,20]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=void 0,e.$mu=I,e.$nu=b,v=Ve(v),D=Ve(D),P=Ve(P);let L;function R(){return L||(L=new TextDecoder("UTF-16LE")),L}let T;function m(){return T||(T=new TextDecoder("UTF-16BE")),T}let s;function I(){return s||(s=D.$G()?R():m()),s}function b($,r,a){const h=new Uint16Array($.buffer,r,a);return a>0&&(h[0]===65279||h[0]===65534)?u($,r,a):R().decode(h)}function u($,r,a){const h=[];let c=0;for(let i=0;i<a;i++){const n=P.$Ue($,r);r+=2,h[c++]=String.fromCharCode(n)}return h.join("")}class k{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return I().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const a=this.a-this.d;a<=1&&(a===0||v.$Of(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const a=r.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=r;return}for(let h=0;h<a;h++)this.b[this.d++]=r.charCodeAt(h)}}e.$ou=k}),define(Re[163],Oe([1,0,20,162]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pu=void 0,e.$qu=R,v=Ve(v);function P(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(s,I,b,u){this.oldPosition=s,this.oldText=I,this.newPosition=b,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(s){return 4+2*s.length}static c(s,I,b){const u=I.length;v.$Xe(s,u,b),b+=4;for(let k=0;k<u;k++)v.$Ve(s,I.charCodeAt(k),b),b+=2;return b}static d(s,I){const b=v.$We(s,I);return I+=4,(0,D.$nu)(s,I,b)}writeSize(){return 8+L.a(this.oldText)+L.a(this.newText)}write(s,I){return v.$Xe(s,this.oldPosition,I),I+=4,v.$Xe(s,this.newPosition,I),I+=4,I=L.c(s,this.oldText,I),I=L.c(s,this.newText,I),I}static read(s,I,b){const u=v.$We(s,I);I+=4;const k=v.$We(s,I);I+=4;const $=L.d(s,I);I+=L.a($);const r=L.d(s,I);return I+=L.a(r),b.push(new L(u,$,k,r)),I}}e.$pu=L;function R(m,s){return m===null||m.length===0?s:new T(m,s).compress()}class T{constructor(s,I){this.a=s,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let s=0,I=0,b=this.n(s),u=this.l(I);for(;s<this.f||I<this.h;){if(b===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(b),b=this.n(++s);continue}if(u.oldEnd<=b.newPosition){this.k(u),u=this.l(++I);continue}if(b.newEnd<=u.oldPosition){this.m(b),b=this.n(++s);continue}if(u.oldPosition<b.newPosition){const[h,c]=T.r(u,b.newPosition-u.oldPosition);this.k(h),u=c;continue}if(b.newPosition<u.oldPosition){const[h,c]=T.q(b,u.oldPosition-b.newPosition);this.m(h),b=c;continue}let r,a;if(u.oldEnd===b.newEnd)r=b,a=u,b=this.n(++s),u=this.l(++I);else if(u.oldEnd<b.newEnd){const[h,c]=T.q(b,u.oldLength);r=h,a=u,b=c,u=this.l(++I)}else{const[h,c]=T.r(u,b.newLength);r=b,a=h,b=this.n(++s),u=c}this.d[this.e++]=new L(r.oldPosition,r.oldText,a.newPosition,a.newText),this.g+=r.newLength-r.oldLength,this.j+=a.newLength-a.oldLength}const k=T.s(this.d);return T.t(k)}k(s){this.d[this.e++]=T.o(this.g,s),this.j+=s.newLength-s.oldLength}l(s){return s<this.h?this.c[s]:null}m(s){this.d[this.e++]=T.p(this.j,s),this.g+=s.newLength-s.oldLength}n(s){return s<this.f?this.a[s]:null}static o(s,I){return new L(I.oldPosition-s,I.oldText,I.newPosition,I.newText)}static p(s,I){return new L(I.oldPosition,I.oldText,I.newPosition+s,I.newText)}static q(s,I){const b=s.newText.substr(0,I),u=s.newText.substr(I);return[new L(s.oldPosition,s.oldText,s.newPosition,b),new L(s.oldEnd,"",s.newPosition+I,u)]}static r(s,I){const b=s.oldText.substr(0,I),u=s.oldText.substr(I);return[new L(s.oldPosition,b,s.newPosition,s.newText),new L(s.oldPosition+I,u,s.newEnd,"")]}static s(s){if(s.length===0)return s;const I=[];let b=0,u=s[0];for(let k=1;k<s.length;k++){const $=s[k];u.oldEnd===$.oldPosition?u=new L(u.oldPosition,u.oldText+$.oldText,u.newPosition,u.newText+$.newText):(I[b++]=u,u=$)}return I[b++]=u,I}static t(s){if(s.length===0)return s;const I=[];let b=0;for(let u=0;u<s.length;u++){const k=s[u];k.oldText!==k.newText&&(I[b++]=k)}return I}}}),define(Re[164],Oe([1,0,43,22]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gu=P,e.$Hu=L;function P(R,T,m,s,I,b){if(Array.isArray(R)){let u=0;for(const k of R){const $=P(k,T,m,s,I,b);if($===10)return $;$>u&&(u=$)}return u}else{if(typeof R=="string")return s?R==="*"?5:R===m?10:0:0;if(R){const{language:u,pattern:k,scheme:$,hasAccessToAllModels:r,notebookType:a}=R;if(!s&&!r)return 0;a&&I&&(T=I);let h=0;if($)if($===T.scheme)h=10;else if($==="*")h=5;else return 0;if(u)if(u===m)h=10;else if(u==="*")h=Math.max(h,5);else return 0;if(a)if(a===b)h=10;else if(a==="*"&&b!==void 0)h=Math.max(h,5);else return 0;if(k){let c;if(typeof k=="string"?c=k:c={...k,base:(0,D.$mc)(k.base)},c===T.fsPath||(0,v.$Ek)(c,T.fsPath))h=10;else return 0}return h}else return 0}}function L(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(L):!!R.notebookType}}),define(Re[165],Oe([1,0,6,13,32,52,100,151,163,4]),function(be,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KD=void 0,D=Ve(D);class I extends s.$Zc{constructor(u,k,$,r,a,h,c){super(),this.m=this.B(new v.$qe),this.onDidChangeContent=this.m.event,this.f=k,this.j=!h,this.g=r,this.h=a,this.c=new R.$JD(u,$,c)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,k){return this.c.getOffsetAt(u,k)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,k){const $=u+k,r=this.getPositionAt(u),a=this.getPositionAt($);return new P.$Yt(r.lineNumber,r.column,a.lineNumber,a.column)}getValueInRange(u,k=L.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const $=this.n(k);return this.c.getValueInRange(u,$)}getValueLengthInRange(u,k=L.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const $=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let a=0;const h=this.n(k),c=this.getEOL();if(h.length!==c.length){const i=h.length-c.length,n=u.endLineNumber-u.startLineNumber;a=i*n}return r-$+a}getCharacterCountInRange(u,k=L.EndOfLinePreference.TextDefined){if(this.j){let $=0;const r=u.startLineNumber,a=u.endLineNumber;for(let h=r;h<=a;h++){const c=this.getLineContent(h),i=h===r?u.startColumn-1:0,n=h===a?u.endColumn-1:c.length;for(let t=i;t<n;t++)D.$Of(c.charCodeAt(t))?($=$+1,t=t+1):$=$+1}return $+=this.n(k).length*(a-r),$}return this.getValueLengthInRange(u,k)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,k){return this.c.getLineCharCode(u,k)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const k=D.$zf(this.getLineContent(u));return k===-1?0:k+1}getLineLastNonWhitespaceColumn(u){const k=D.$Bf(this.getLineContent(u));return k===-1?0:k+2}n(u){switch(u){case L.EndOfLinePreference.LF:return`
`;case L.EndOfLinePreference.CRLF:return`\r
`;case L.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,k,$){let r=this.g,a=this.h,h=this.j,c=!0,i=[];for(let d=0;d<u.length;d++){const S=u[d];c&&S._isTracked&&(c=!1);const E=S.range;if(S.text){let w=!0;h||(w=!D.$Zf(S.text),h=w),!r&&w&&(r=D.$Yf(S.text)),!a&&w&&(a=D.$2f(S.text))}let y="",C=0,O=0,p=0;if(S.text){let w;[C,O,p,w]=(0,T.$Ju)(S.text);const M=this.getEOL(),A=M===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;w===T.StringEOL.Unknown||w===A?y=S.text:y=S.text.replace(/\r\n|\r|\n/g,M)}i[d]={sortIndex:d,identifier:S.identifier||null,range:E,rangeOffset:this.getOffsetAt(E.startLineNumber,E.startColumn),rangeLength:this.getValueLengthInRange(E),text:y,eolCount:C,firstLineLength:O,lastLineLength:p,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}i.sort(I.u);let n=!1;for(let d=0,S=i.length-1;d<S;d++){const E=i[d].range.getEndPosition(),y=i[d+1].range.getStartPosition();if(y.isBeforeOrEqual(E)){if(y.isBefore(E))throw new Error("Overlapping ranges are not allowed!");n=!0}}c&&(i=this.s(i));const t=$||k?I._getInverseEditRanges(i):[],o=[];if(k)for(let d=0;d<i.length;d++){const S=i[d],E=t[d];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let y=E.startLineNumber;y<=E.endLineNumber;y++){let C="";y===E.startLineNumber&&(C=this.getLineContent(S.range.startLineNumber),D.$zf(C)!==-1)||o.push({lineNumber:y,oldContent:C})}}let l=null;if($){let d=0;l=[];for(let S=0;S<i.length;S++){const E=i[S],y=t[S],C=this.getValueInRange(E.range),O=E.rangeOffset+d;d+=E.text.length-C.length,l[S]={sortIndex:E.sortIndex,identifier:E.identifier,range:y,text:C,textChange:new m.$pu(E.rangeOffset,C,O,E.text)}}n||l.sort((S,E)=>S.sortIndex-E.sortIndex)}this.g=r,this.h=a,this.j=h;const g=this.t(i);let f=null;if(k&&o.length>0){o.sort((d,S)=>S.lineNumber-d.lineNumber),f=[];for(let d=0,S=o.length;d<S;d++){const E=o[d].lineNumber;if(d>0&&o[d-1].lineNumber===E)continue;const y=o[d].oldContent,C=this.getLineContent(E);C.length===0||C===y||D.$zf(C)!==-1||f.push(E)}}return this.m.fire(),new L.$tw(l,g,f)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let k=!1;const $=u[0].range,r=u[u.length-1].range,a=new P.$Yt($.startLineNumber,$.startColumn,r.endLineNumber,r.endColumn);let h=$.startLineNumber,c=$.startColumn;const i=[];for(let g=0,f=u.length;g<f;g++){const d=u[g],S=d.range;k=k||d.forceMoveMarkers,i.push(this.getValueInRange(new P.$Yt(h,c,S.startLineNumber,S.startColumn))),d.text.length>0&&i.push(d.text),h=S.endLineNumber,c=S.endColumn}const n=i.join(""),[t,o,l]=(0,T.$Ju)(n);return{sortIndex:0,identifier:u[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,L.EndOfLinePreference.TextDefined),text:n,eolCount:t,firstLineLength:o,lastLineLength:l,forceMoveMarkers:k,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const k=[];for(let $=0;$<u.length;$++){const r=u[$],a=r.range.startLineNumber,h=r.range.startColumn,c=r.range.endLineNumber,i=r.range.endColumn;if(a===c&&h===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const n=new P.$Yt(a,h,c,i);k.push({range:n,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return k}findMatchesLineByLine(u,k,$,r){return this.c.findMatchesLineByLine(u,k,$,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,k){const $=u.startLineNumber,r=u.startColumn,[a,h,c]=(0,T.$Ju)(k);let i;if(k.length>0){const n=a+1;n===1?i=new P.$Yt($,r,$,r+h):i=new P.$Yt($,r,$+n-1,c+1)}else i=new P.$Yt($,r,$,r);return i}static _getInverseEditRanges(u){const k=[];let $=0,r=0,a=null;for(let h=0,c=u.length;h<c;h++){const i=u[h];let n,t;a?a.range.endLineNumber===i.range.startLineNumber?(n=$,t=r+(i.range.startColumn-a.range.endColumn)):(n=$+(i.range.startLineNumber-a.range.endLineNumber),t=i.range.startColumn):(n=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const l=i.eolCount+1;l===1?o=new P.$Yt(n,t,n,t+i.firstLineLength):o=new P.$Yt(n,t,n+l-1,i.lastLineLength+1)}else o=new P.$Yt(n,t,n,t);$=o.endLineNumber,r=o.endColumn,k.push(o),a=i}return k}static u(u,k){const $=P.$Yt.compareRangesUsingEnds(u.range,k.range);return $===0?u.sortIndex-k.sortIndex:$}static w(u,k){const $=P.$Yt.compareRangesUsingEnds(u.range,k.range);return $===0?k.sortIndex-u.sortIndex:-$}}e.$KD=I}),define(Re[166],Oe([1,0,30,13,52,100,165]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LD=void 0,D=Ve(D);class T{constructor(I,b,u,k,$,r,a,h,c){this.a=I,this.b=b,this.c=u,this.d=k,this.e=$,this.f=r,this.g=a,this.h=h,this.j=c}k(I){const b=this.c+this.d+this.e,u=this.c+this.e;return b===0?I===P.DefaultEndOfLine.LF?`
`:`\r
`:u>b/2?`\r
`:`
`}create(I){const b=this.k(I),u=this.a;if(this.j&&(b===`\r
`&&(this.c>0||this.d>0)||b===`
`&&(this.c>0||this.e>0)))for(let $=0,r=u.length;$<r;$++){const a=u[$].buffer.replace(/\r\n|\r|\n/g,b),h=(0,L.$FD)(a);u[$]=new L.$ID(a,h)}const k=new R.$KD(u,this.b,b,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class m{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&D.$0f(I)&&(this.b=D.$9f,I=I.substr(1));const b=I.charCodeAt(I.length-1);b===v.CharCode.CarriageReturn||b>=55296&&b<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=b):(this.m(I,!1),this.c=!1,this.d=b)}m(I,b){!b&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const b=(0,L.$GD)(this.e,I);this.a.push(new L.$ID(I,b.lineStarts)),this.f+=b.cr,this.g+=b.lf,this.h+=b.crlf,b.isBasicASCII||(this.l=!1,this.j||(this.j=D.$Yf(I)),this.k||(this.k=D.$2f(I)))}finish(I=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const b=(0,L.$FD)(I.buffer);I.lineStarts=b,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$LD=m}),define(Re[104],Oe([1,0,20,23]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Feb=m,e.$Geb=I,D=Ve(D);var P;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(P||(P={}));function L(b){for(let u=0,k=b.length;u<k;u+=4){const $=b[u+0],r=b[u+1],a=b[u+2],h=b[u+3];b[u+0]=h,b[u+1]=a,b[u+2]=r,b[u+3]=$}}function R(b){const u=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return D.$G()||L(u),v.$Se.wrap(u)}function T(b){const u=b.buffer;if(D.$G()||L(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const k=new Uint8Array(u.byteLength);return k.set(u),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function m(b){const u=new Uint32Array(s(b));let k=0;if(u[k++]=b.id,b.type==="full")u[k++]=P.Full,u[k++]=b.data.length,u.set(b.data,k),k+=b.data.length;else{u[k++]=P.Delta,u[k++]=b.deltas.length;for(const $ of b.deltas)u[k++]=$.start,u[k++]=$.deleteCount,$.data?(u[k++]=$.data.length,u.set($.data,k),k+=$.data.length):u[k++]=0}return R(u)}function s(b){let u=0;if(u+=2,b.type==="full")u+=1+b.data.length;else{u+=1,u+=3*b.deltas.length;for(const k of b.deltas)k.data&&(u+=k.data.length)}return u}function I(b){const u=T(b);let k=0;const $=u[k++];if(u[k++]===P.Full){const c=u[k++],i=u.subarray(k,k+c);return k+=c,{id:$,type:"full",data:i}}const a=u[k++],h=[];for(let c=0;c<a;c++){const i=u[k++],n=u[k++],t=u[k++];let o;t>0&&(o=u.subarray(k,k+t),k+=t),h[c]={start:i,deleteCount:n,data:o}}return{id:$,type:"delta",deltas:h}}}),define(Re[167],Oe([1,0,30,12,9]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.TokenType=void 0;var L;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(L||(e.TokenType=L={}));function R(...I){switch(I.length){case 1:return(0,P.localize)(1693,null,I[0]);case 2:return(0,P.localize)(1694,null,I[0],I[1]);case 3:return(0,P.localize)(1695,null,I[0],I[1],I[2]);default:return}}const T=(0,P.localize)(1696,null),m=(0,P.localize)(1697,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case L.LParen:return"(";case L.RParen:return")";case L.Neg:return"!";case L.Eq:return b.isTripleEq?"===":"==";case L.NotEq:return b.isTripleEq?"!==":"!=";case L.Lt:return"<";case L.LtEq:return"<=";case L.Gt:return">=";case L.GtEq:return">=";case L.RegexOp:return"=~";case L.RegexStr:return b.lexeme;case L.True:return"true";case L.False:return"false";case L.In:return"in";case L.Not:return"not";case L.And:return"&&";case L.Or:return"||";case L.Str:return b.lexeme;case L.QuotedStr:return b.lexeme;case L.Error:return b.lexeme;case L.EOF:return"EOF";default:throw(0,D.$_)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",L.Not],["in",L.In],["false",L.False],["true",L.True]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(L.LParen);break;case v.CharCode.CloseParen:this.k(L.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const u=this.h(v.CharCode.Equals);this.f.push({type:L.NotEq,offset:this.d,isTripleEq:u})}else this.k(L.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const u=this.h(v.CharCode.Equals);this.f.push({type:L.Eq,offset:this.d,isTripleEq:u})}else this.h(v.CharCode.Tilde)?this.k(L.RegexOp):this.l(R("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?L.LtEq:L.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?L.GtEq:L.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(L.And):this.l(R("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(L.Or):this.l(R("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(L.EOF),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const u=this.d,k=this.c.substring(this.d,this.e),$={type:L.Error,offset:this.d,lexeme:k};this.g.push({offset:u,lexeme:k,additionalInfo:b}),this.f.push($)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const u=this.c.substring(this.d,this.e),k=s.b.get(u);k?this.k(k):this.f.push({type:L.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:L.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,u=!1,k=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(m);return}const r=this.c.charCodeAt(b);if(u)u=!1;else if(r===v.CharCode.Slash&&!k){b++;break}else r===v.CharCode.OpenSquareBracket?k=!0:r===v.CharCode.Backslash?u=!0:r===v.CharCode.CloseSquareBracket&&(k=!1);b++}for(;b<this.c.length&&s.a.has(this.c.charCodeAt(b));)b++;this.e=b;const $=this.c.substring(this.d,this.e);this.f.push({type:L.RegexStr,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fj=s}),define(Re[105],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribChatParticipantDetection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribChatParticipantDetection.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Re[74],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=void 0;class v{constructor(P,L=[],R=!1){this.ctor=P,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$Hi=v}),define(Re[60],Oe([1,0,74]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$2s=L,e.$3s=R;const D=[];var P;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function L(T,m,s){m instanceof v.$Hi||(m=new v.$Hi(m,[],!!s)),D.push([T,m])}function R(){return D}}),define(Re[168],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;class v{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Er=v;class D{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const T=this.lookupOrInsertNode(L),m=this.lookupOrInsertNode(R);T.outgoing.set(m.key,m),m.incoming.set(T.key,T)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const T of this.a.values())T.outgoing.delete(R),T.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let T=this.a.get(R);return T||(T=new v(R,L),this.a.set(R,T)),T}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,T]of this.a)L.push(`${R}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const T=new Set([L]),m=this.c(R,T);if(m)return m}}c(L,R){for(const[T,m]of L.outgoing){if(R.has(T))return[...R,T].join(" -> ");R.add(T);const s=this.c(m,R);if(s)return s;R.delete(T)}}}e.$Fr=D}),define(Re[3],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e._util=void 0,e.$Ki=P,e.$Li=L;var v;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function T(m){return m[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=T})(v||(e._util=v={})),e.$Ji=P("instantiationService");function D(R,T,m){T[v.DI_TARGET]===T?T[v.DI_DEPENDENCIES].push({id:R,index:m}):(T[v.DI_DEPENDENCIES]=[{id:R,index:m}],T[v.DI_TARGET]=T)}function P(R){if(v.serviceIds.has(R))return v.serviceIds.get(R);const T=function(m,s,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(T,m,I)};return T.toString=()=>R,v.serviceIds.set(R,T),T}function L(R){return R}}),define(Re[44],Oe([1,0,14,2,3]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$ej=void 0,e.$fj=L,e.$gj=R,e.$hj=m,e.$ij=s,e.$jj=I,e.$kj=b,e.$lj=u,e.$mj=$,e.$nj=r,e.$oj=a,v=Ve(v),e.$ej=(0,P.$Ki)("configurationService");function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof D.URI)}function R(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof D.URI)}var T;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function m(h){switch(h){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function s(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}function I(h,c){const i=Object.create(null);for(const n in h)b(i,n,h[n],c);return i}function b(h,c,i,n){const t=c.split("."),o=t.pop();let l=h;for(let g=0;g<t.length;g++){const f=t[g];let d=l[f];switch(typeof d){case"undefined":d=l[f]=Object.create(null);break;case"object":if(d===null){n(`Ignoring ${c} as ${t.slice(0,g+1).join(".")} is null`);return}break;default:n(`Ignoring ${c} as ${t.slice(0,g+1).join(".")} is ${JSON.stringify(d)}`);return}l=d}if(typeof l=="object"&&l!==null)try{l[o]=i}catch{n(`Ignoring ${c} as ${t.join(".")} is ${JSON.stringify(l)}`)}else n(`Ignoring ${c} as ${t.join(".")} is ${JSON.stringify(l)}`)}function u(h,c){const i=c.split(".");k(h,i)}function k(h,c){const i=c.shift();if(c.length===0){delete h[i];return}if(Object.keys(h).indexOf(i)!==-1){const n=h[i];typeof n=="object"&&!Array.isArray(n)&&(k(n,c),Object.keys(n).length===0&&delete h[i])}}function $(h,c,i){function n(l,g){let f=l;for(const d of g){if(typeof f!="object"||f===null)return;f=f[d]}return f}const t=c.split("."),o=n(h,t);return typeof o>"u"?i:o}function r(h,c,i){Object.keys(c).forEach(n=>{n!=="__proto__"&&(n in h?v.$lg(h[n])&&v.$lg(c[n])?r(h[n],c[n],i):i&&(h[n]=c[n]):h[n]=c[n])})}function a(h){return h.replace(/[\[\]]/g,"")}}),define(Re[31],Oe([1,0,30,23,13,167,3,9,12]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Ij=e.$Hj=e.ContextKeyExprType=void 0,e.$Gj=I,e.$Jj=g,e.$Kj=f,e.$4j=_;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",D.$m),s.set("isLinux",D.$n),s.set("isWindows",D.$l),s.set("isWeb",D.$r),s.set("isMacNative",D.$m&&!D.$r),s.set("isEdge",D.$K),s.set("isFirefox",D.$I),s.set("isChrome",D.$H),s.set("isSafari",D.$J);function I(X,V){if(s.get(X)!==void 0)throw(0,m.$$)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(X,V)}const b=Object.prototype.hasOwnProperty;var u;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const k={regexParsingWithErrorRecovery:!0},$=(0,T.localize)(1673,null),r=(0,T.localize)(1674,null),a=(0,T.localize)(1675,null),h=(0,T.localize)(1676,null),c=(0,T.localize)(1677,null),i=(0,T.localize)(1678,null),n=(0,T.localize)(1679,null),t=(0,T.localize)(1680,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=k){this.k=V,this.d=new L.$Fj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const re=this.l();if(!this.E()){const we=this.D(),Pe=we.type===L.TokenType.Str?i:void 0;throw this.h.push({message:c,offset:we.offset,lexeme:L.$Fj.getLexeme(we),additionalInfo:Pe}),o.c}return re}catch(re){if(re!==o.c)throw re;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(L.TokenType.Or);){const re=this.o();V.push(re)}return V.length===1?V[0]:l.or(...V)}o(){const V=[this.s()];for(;this.y(L.TokenType.And);){const re=this.s();V.push(re)}return V.length===1?V[0]:l.and(...V)}s(){if(this.y(L.TokenType.Neg)){const V=this.D();switch(V.type){case L.TokenType.True:return this.z(),S.INSTANCE;case L.TokenType.False:return this.z(),E.INSTANCE;case L.TokenType.LParen:{this.z();const re=this.l();return this.A(L.TokenType.RParen,h),re?.negate()}case L.TokenType.Str:return this.z(),M.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case L.TokenType.True:return this.z(),l.true();case L.TokenType.False:return this.z(),l.false();case L.TokenType.LParen:{this.z();const re=this.l();return this.A(L.TokenType.RParen,h),re}case L.TokenType.Str:{const re=V.lexeme;if(this.z(),this.y(L.TokenType.RegexOp)){const Pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Pe.type!==L.TokenType.RegexStr)throw this.B("REGEX",Pe);const Fe=Pe.lexeme,Be=Fe.lastIndexOf("/"),xe=Be===Fe.length-1?void 0:this.w(Fe.substring(Be+1));let nt;try{nt=new RegExp(Fe.substring(1,Be),xe)}catch{throw this.B("REGEX",Pe)}return U.create(re,nt)}switch(Pe.type){case L.TokenType.RegexStr:case L.TokenType.Error:{const Fe=[Pe.lexeme];this.z();let Be=this.D(),xe=0;for(let et=0;et<Pe.lexeme.length;et++)Pe.lexeme.charCodeAt(et)===v.CharCode.OpenParen?xe++:Pe.lexeme.charCodeAt(et)===v.CharCode.CloseParen&&xe--;for(;!this.E()&&Be.type!==L.TokenType.And&&Be.type!==L.TokenType.Or;){switch(Be.type){case L.TokenType.LParen:xe++;break;case L.TokenType.RParen:xe--;break;case L.TokenType.RegexStr:case L.TokenType.QuotedStr:for(let et=0;et<Be.lexeme.length;et++)Be.lexeme.charCodeAt(et)===v.CharCode.OpenParen?xe++:Pe.lexeme.charCodeAt(et)===v.CharCode.CloseParen&&xe--}if(xe<0)break;Fe.push(L.$Fj.getLexeme(Be)),this.z(),Be=this.D()}const nt=Fe.join(""),ht=nt.lastIndexOf("/"),$t=ht===nt.length-1?void 0:this.w(nt.substring(ht+1));let ut;try{ut=new RegExp(nt.substring(1,ht),$t)}catch{throw this.B("REGEX",Pe)}return l.regex(re,ut)}case L.TokenType.QuotedStr:{const Fe=Pe.lexeme;this.z();let Be=null;if(!(0,P.$hf)(Fe)){const xe=Fe.indexOf("/"),nt=Fe.lastIndexOf("/");if(xe!==nt&&xe>=0){const ht=Fe.slice(xe+1,nt),$t=Fe[nt+1]==="i"?"i":"";try{Be=new RegExp(ht,$t)}catch{throw this.B("REGEX",Pe)}}}if(Be===null)throw this.B("REGEX",Pe);return U.create(re,Be)}default:throw this.B("REGEX",this.D())}}if(this.y(L.TokenType.Not)){this.A(L.TokenType.In,a);const Pe=this.u();return l.notIn(re,Pe)}switch(this.D().type){case L.TokenType.Eq:{this.z();const Pe=this.u();if(this.x().type===L.TokenType.QuotedStr)return l.equals(re,Pe);switch(Pe){case"true":return l.has(re);case"false":return l.not(re);default:return l.equals(re,Pe)}}case L.TokenType.NotEq:{this.z();const Pe=this.u();if(this.x().type===L.TokenType.QuotedStr)return l.notEquals(re,Pe);switch(Pe){case"true":return l.not(re);case"false":return l.has(re);default:return l.notEquals(re,Pe)}}case L.TokenType.Lt:return this.z(),x.create(re,this.u());case L.TokenType.LtEq:return this.z(),j.create(re,this.u());case L.TokenType.Gt:return this.z(),F.create(re,this.u());case L.TokenType.GtEq:return this.z(),G.create(re,this.u());case L.TokenType.In:return this.z(),l.in(re,this.u());default:return l.has(re)}}case L.TokenType.EOF:throw this.h.push({message:n,offset:V.offset,lexeme:"",additionalInfo:t}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case L.TokenType.Str:case L.TokenType.QuotedStr:return this.z(),V.lexeme;case L.TokenType.True:return this.z(),"true";case L.TokenType.False:return this.z(),"false";case L.TokenType.In:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,re){if(this.C(V))return this.z();throw this.B(re,this.D())}B(V,re,we){const Pe=(0,T.localize)(1681,null,V,L.$Fj.getLexeme(re)),Fe=re.offset,Be=L.$Fj.getLexeme(re);return this.h.push({message:Pe,offset:Fe,lexeme:Be,additionalInfo:we}),o.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===L.TokenType.EOF}}e.$Hj=o;class l{static false(){return S.INSTANCE}static true(){return E.INSTANCE}static has(V){return y.create(V)}static equals(V,re){return C.create(V,re)}static notEquals(V,re){return w.create(V,re)}static regex(V,re){return U.create(V,re)}static in(V,re){return O.create(V,re)}static notIn(V,re){return p.create(V,re)}static not(V){return M.create(V)}static and(...V){return ae.create(V,null,!0)}static or(...V){return ee.create(V,null,!0)}static greater(V,re){return F.create(V,re)}static greaterEquals(V,re){return G.create(V,re)}static smaller(V,re){return x.create(V,re)}static smallerEquals(V,re){return j.create(V,re)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Ij=l;function g(X){const V=new o({regexParsingWithErrorRecovery:!1});return X.map(re=>(V.parse(re),V.lexingErrors.length>0?V.lexingErrors.map(we=>({errorMessage:we.additionalInfo?(0,T.localize)(1682,null,we.additionalInfo):(0,T.localize)(1683,null),offset:we.offset,length:we.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(we=>({errorMessage:we.additionalInfo?`${we.message}. ${we.additionalInfo}`:we.message,offset:we.offset,length:we.lexeme.length})):[]))}function f(X,V){const re=X?X.substituteConstants():void 0,we=V?V.substituteConstants():void 0;return!re&&!we?!0:!re||!we?!1:re.equals(we)}function d(X,V){return X.cmp(V)}class S{static{this.INSTANCE=new S}constructor(){this.type=u.False}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return E.INSTANCE}}e.$Lj=S;class E{static{this.INSTANCE=new E}constructor(){this.type=u.True}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return S.INSTANCE}}e.$Mj=E;class y{static create(V,re=null){const we=s.get(V);return typeof we=="boolean"?we?E.INSTANCE:S.INSTANCE:new y(V,re)}constructor(V,re){this.key=V,this.c=re,this.type=u.Defined}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=s.get(this.key);return typeof V=="boolean"?V?E.INSTANCE:S.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Nj=y;class C{static create(V,re,we=null){if(typeof re=="boolean")return re?y.create(V,we):M.create(V,we);const Pe=s.get(V);return typeof Pe=="boolean"?re===(Pe?"true":"false")?E.INSTANCE:S.INSTANCE:new C(V,re,we)}constructor(V,re,we){this.c=V,this.d=re,this.f=we,this.type=u.Equals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=s.get(this.c);if(typeof V=="boolean"){const re=V?"true":"false";return this.d===re?E.INSTANCE:S.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Oj=C;class O{static create(V,re){return new O(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=u.In,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const re=V.getValue(this.f),we=V.getValue(this.d);return Array.isArray(re)?re.includes(we):typeof we=="string"&&typeof re=="object"&&re!==null?b.call(re,we):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Pj=O;class p{static create(V,re){return new p(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=u.NotIn,this.c=O.create(V,re)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qj=p;class w{static create(V,re,we=null){if(typeof re=="boolean")return re?M.create(V,we):y.create(V,we);const Pe=s.get(V);return typeof Pe=="boolean"?re===(Pe?"true":"false")?S.INSTANCE:E.INSTANCE:new w(V,re,we)}constructor(V,re,we){this.c=V,this.d=re,this.f=we,this.type=u.NotEquals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=s.get(this.c);if(typeof V=="boolean"){const re=V?"true":"false";return this.d===re?S.INSTANCE:E.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Rj=w;class M{static create(V,re=null){const we=s.get(V);return typeof we=="boolean"?we?S.INSTANCE:E.INSTANCE:new M(V,re)}constructor(V,re){this.c=V,this.d=re,this.type=u.Not}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=s.get(this.c);return typeof V=="boolean"?V?S.INSTANCE:E.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Sj=M;function A(X,V){if(typeof X=="string"){const re=parseFloat(X);isNaN(re)||(X=re)}return typeof X=="string"||typeof X=="number"?V(X):S.INSTANCE}class F{static create(V,re,we=null){return A(re,Pe=>new F(V,Pe,we))}constructor(V,re,we){this.c=V,this.d=re,this.f=we,this.type=u.Greater}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Tj=F;class G{static create(V,re,we=null){return A(re,Pe=>new G(V,Pe,we))}constructor(V,re,we){this.c=V,this.d=re,this.f=we,this.type=u.GreaterEquals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Uj=G;class x{static create(V,re,we=null){return A(re,Pe=>new x(V,Pe,we))}constructor(V,re,we){this.c=V,this.d=re,this.f=we,this.type=u.Smaller}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Vj=x;class j{static create(V,re,we=null){return A(re,Pe=>new j(V,Pe,we))}constructor(V,re,we){this.c=V,this.d=re,this.f=we,this.type=u.SmallerEquals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Wj=j;class U{static create(V,re){return new U(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=u.Regex,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const re=this.f?this.f.source:"",we=V.f?V.f.source:"";return re<we?-1:re>we?1:0}equals(V){if(V.type===this.type){const re=this.f?this.f.source:"",we=V.f?V.f.source:"";return this.d===V.d&&re===we}return!1}substituteConstants(){return this}evaluate(V){const re=V.getValue(this.d);return this.f?this.f.test(re):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=J.create(this)),this.c}}e.$Xj=U;class J{static create(V){return new J(V)}constructor(V){this.c=V,this.type=u.NotRegex}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new J(this.c.map(V))}negate(){return this.c}}e.$Yj=J;function Z(X){let V=null;for(let re=0,we=X.length;re<we;re++){const Pe=X[re].substituteConstants();if(X[re]!==Pe&&V===null){V=[];for(let Fe=0;Fe<re;Fe++)V[Fe]=X[Fe]}V!==null&&(V[re]=Pe)}return V===null?X:V}class ae{static create(V,re,we){return ae.d(V,re,we)}constructor(V,re){this.expr=V,this.c=re,this.type=u.And}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let re=0,we=this.expr.length;re<we;re++){const Pe=d(this.expr[re],V.expr[re]);if(Pe!==0)return Pe}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let re=0,we=this.expr.length;re<we;re++)if(!this.expr[re].equals(V.expr[re]))return!1;return!0}return!1}substituteConstants(){const V=Z(this.expr);return V===this.expr?this:ae.create(V,this.c,!1)}evaluate(V){for(let re=0,we=this.expr.length;re<we;re++)if(!this.expr[re].evaluate(V))return!1;return!0}static d(V,re,we){const Pe=[];let Fe=!1;for(const Be of V)if(Be){if(Be.type===u.True){Fe=!0;continue}if(Be.type===u.False)return S.INSTANCE;if(Be.type===u.And){Pe.push(...Be.expr);continue}Pe.push(Be)}if(Pe.length===0&&Fe)return E.INSTANCE;if(Pe.length!==0){if(Pe.length===1)return Pe[0];Pe.sort(d);for(let Be=1;Be<Pe.length;Be++)Pe[Be-1].equals(Pe[Be])&&(Pe.splice(Be,1),Be--);if(Pe.length===1)return Pe[0];for(;Pe.length>1;){const Be=Pe[Pe.length-1];if(Be.type!==u.Or)break;Pe.pop();const xe=Pe.pop(),nt=Pe.length===0,ht=ee.create(Be.expr.map($t=>ae.create([$t,xe],null,we)),null,nt);ht&&(Pe.push(ht),Pe.sort(d))}if(Pe.length===1)return Pe[0];if(we){for(let Be=0;Be<Pe.length;Be++)for(let xe=Be+1;xe<Pe.length;xe++)if(Pe[Be].negate().equals(Pe[xe]))return S.INSTANCE;if(Pe.length===1)return Pe[0]}return new ae(Pe,re)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const re of this.expr)V.push(...re.keys());return V}map(V){return new ae(this.expr.map(re=>re.map(V)),null)}negate(){if(!this.c){const V=[];for(const re of this.expr)V.push(re.negate());this.c=ee.create(V,this,!0)}return this.c}}e.$Zj=ae;class ee{static create(V,re,we){return ee.d(V,re,we)}constructor(V,re){this.expr=V,this.c=re,this.type=u.Or}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let re=0,we=this.expr.length;re<we;re++){const Pe=d(this.expr[re],V.expr[re]);if(Pe!==0)return Pe}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let re=0,we=this.expr.length;re<we;re++)if(!this.expr[re].equals(V.expr[re]))return!1;return!0}return!1}substituteConstants(){const V=Z(this.expr);return V===this.expr?this:ee.create(V,this.c,!1)}evaluate(V){for(let re=0,we=this.expr.length;re<we;re++)if(this.expr[re].evaluate(V))return!0;return!1}static d(V,re,we){let Pe=[],Fe=!1;if(V){for(let Be=0,xe=V.length;Be<xe;Be++){const nt=V[Be];if(nt){if(nt.type===u.False){Fe=!0;continue}if(nt.type===u.True)return E.INSTANCE;if(nt.type===u.Or){Pe=Pe.concat(nt.expr);continue}Pe.push(nt)}}if(Pe.length===0&&Fe)return S.INSTANCE;Pe.sort(d)}if(Pe.length!==0){if(Pe.length===1)return Pe[0];for(let Be=1;Be<Pe.length;Be++)Pe[Be-1].equals(Pe[Be])&&(Pe.splice(Be,1),Be--);if(Pe.length===1)return Pe[0];if(we){for(let Be=0;Be<Pe.length;Be++)for(let xe=Be+1;xe<Pe.length;xe++)if(Pe[Be].negate().equals(Pe[xe]))return E.INSTANCE;if(Pe.length===1)return Pe[0]}return new ee(Pe,re)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const re of this.expr)V.push(...re.keys());return V}map(V){return new ee(this.expr.map(re=>re.map(V)),null)}negate(){if(!this.c){const V=[];for(const re of this.expr)V.push(re.negate());for(;V.length>1;){const re=V.shift(),we=V.shift(),Pe=[];for(const Fe of Ie(re))for(const Be of Ie(we))Pe.push(ae.create([Fe,Be],null,!1));V.unshift(ee.create(Pe,null,!1))}this.c=ee.create(V,this,!0)}return this.c}}e.$1j=ee;class oe extends y{static{this.d=[]}static all(){return oe.d.values()}constructor(V,re,we){super(V,null),this.f=re,typeof we=="object"?oe.d.push({...we,key:V}):we!==!0&&oe.d.push({key:V,description:we,type:re!=null?typeof re:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return C.create(this.key,V)}notEqualsTo(V){return w.create(this.key,V)}}e.$2j=oe,e.$3j=(0,R.$Ki)("contextKeyService");function ie(X,V){return X<V?-1:X>V?1:0}function ue(X,V,re,we){return X<re?-1:X>re?1:V<we?-1:V>we?1:0}function _(X,V){if(X.type===u.False||V.type===u.True)return!0;if(X.type===u.Or)return V.type===u.Or?$e(X.expr,V.expr):!1;if(V.type===u.Or){for(const re of V.expr)if(_(X,re))return!0;return!1}if(X.type===u.And){if(V.type===u.And)return $e(V.expr,X.expr);for(const re of X.expr)if(_(re,V))return!0;return!1}return X.equals(V)}function $e(X,V){let re=0,we=0;for(;re<X.length&&we<V.length;){const Pe=X[re].cmp(V[we]);if(Pe<0)return!1;Pe===0&&re++,we++}return re===X.length}function Ie(X){return X.type===u.Or?X.expr:[X]}}),define(Re[169],Oe([1,0,31,3]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=e.$Ct=e.AccessibilitySupport=e.$Bt=void 0,e.$Dt=L,e.$Bt=(0,D.$Ki)("accessibilityService");var P;(function(R){R[R.Unknown=0]="Unknown",R[R.Disabled=1]="Disabled",R[R.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$Ct=new v.$2j("accessibilityModeEnabled",!1);function L(R){return R&&typeof R=="object"&&typeof R.label=="string"&&(typeof R.role>"u"||typeof R.role=="string")}e.$Et="ACCESSIBLE_VIEW_SHOWN_"}),define(Re[106],Oe([1,0,17,25,23,147,280,152,170,9,169]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=l,e.stringSet=d,e.cursorStyleToString=A,e.filterValidationDecorations=Ne,v=Ve(v),D=Ve(D),P=Ve(P),s=Ve(s);var b;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(b||(e.EditorAutoIndentStrategy=b={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(W){this.c=W}hasChanged(W){return this.c[W]}}e.ConfigurationChangedEvent=u;class k{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=k;class ${constructor(W,de,je,He){this.id=W,this.name=de,this.defaultValue=je,this.schema=He}applyUpdate(W,de){return a(W,de)}compute(W,de,je){return je}}class r{constructor(W,de){this.newValue=W,this.didChange=de}}e.ApplyUpdateResult=r;function a(Y,W){if(typeof Y!="object"||typeof W!="object"||!Y||!W)return new r(W,Y!==W);if(Array.isArray(Y)||Array.isArray(W)){const je=Array.isArray(Y)&&Array.isArray(W)&&v.$yb(Y,W);return new r(W,!je)}let de=!1;for(const je in W)if(W.hasOwnProperty(je)){const He=a(Y[je],W[je]);He.didChange&&(Y[je]=He.newValue,de=!0)}return new r(Y,de)}class h{constructor(W){this.schema=void 0,this.id=W,this.name="_never_",this.defaultValue=void 0}applyUpdate(W,de){return a(W,de)}validate(W){return this.defaultValue}}class c{constructor(W,de,je,He){this.id=W,this.name=de,this.defaultValue=je,this.schema=He}applyUpdate(W,de){return a(W,de)}validate(W){return typeof W>"u"?this.defaultValue:W}compute(W,de,je){return je}}function i(Y,W){return typeof Y>"u"?W:Y==="false"?!1:!!Y}class n extends c{constructor(W,de,je,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=je),super(W,de,je,He)}validate(W){return i(W,this.defaultValue)}}function t(Y,W,de,je){if(typeof Y>"u")return W;let He=parseInt(Y,10);return isNaN(He)?W:(He=Math.max(de,He),He=Math.min(je,He),He|0)}class o extends c{static clampedInt(W,de,je,He){return t(W,de,je,He)}constructor(W,de,je,He,st,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=je,dt.minimum=He,dt.maximum=st),super(W,de,je,dt),this.minimum=He,this.maximum=st}validate(W){return o.clampedInt(W,this.defaultValue,this.minimum,this.maximum)}}function l(Y,W,de,je){if(typeof Y>"u")return W;const He=g.float(Y,W);return g.clamp(He,de,je)}class g extends c{static clamp(W,de,je){return W<de?de:W>je?je:W}static float(W,de){if(typeof W=="number")return W;if(typeof W>"u")return de;const je=parseFloat(W);return isNaN(je)?de:je}constructor(W,de,je,He,st){typeof st<"u"&&(st.type="number",st.default=je),super(W,de,je,st),this.validationFn=He}validate(W){return this.validationFn(g.float(W,this.defaultValue))}}class f extends c{static string(W,de){return typeof W!="string"?de:W}constructor(W,de,je,He=void 0){typeof He<"u"&&(He.type="string",He.default=je),super(W,de,je,He)}validate(W){return f.string(W,this.defaultValue)}}function d(Y,W,de,je){return typeof Y!="string"?W:je&&Y in je?je[Y]:de.indexOf(Y)===-1?W:Y}class S extends c{constructor(W,de,je,He,st=void 0){typeof st<"u"&&(st.type="string",st.enum=He,st.default=je),super(W,de,je,st),this.c=He}validate(W){return d(W,this.defaultValue,this.c)}}class E extends ${constructor(W,de,je,He,st,dt,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=st,mt.default=He),super(W,de,je,mt),this.c=st,this.d=dt}validate(W){return typeof W!="string"?this.defaultValue:this.c.indexOf(W)===-1?this.defaultValue:this.d(W)}}function y(Y){switch(Y){case"none":return b.None;case"keep":return b.Keep;case"brackets":return b.Brackets;case"advanced":return b.Advanced;case"full":return b.Full}}class C extends ${constructor(){super(ve.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(302,null),s.localize(303,null),s.localize(304,null)],default:"auto",tags:["accessibility"],description:s.localize(305,null)})}validate(W){switch(W){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(W,de,je){return je===I.AccessibilitySupport.Unknown?W.accessibilitySupport:je}}class O extends ${constructor(){const W={insertSpace:!0,ignoreEmptyLines:!0};super(ve.comments,"comments",W,{"editor.comments.insertSpace":{type:"boolean",default:W.insertSpace,description:s.localize(306,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:W.ignoreEmptyLines,description:s.localize(307,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{insertSpace:i(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var p;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(p||(e.TextEditorCursorBlinkingStyle=p={}));function w(Y){switch(Y){case"blink":return p.Blink;case"smooth":return p.Smooth;case"phase":return p.Phase;case"expand":return p.Expand;case"solid":return p.Solid}}var M;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function A(Y){switch(Y){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function F(Y){switch(Y){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class G extends h{constructor(){super(ve.editorClassName)}compute(W,de,je){const He=["monaco-editor"];return de.get(ve.extraEditorClassName)&&He.push(de.get(ve.extraEditorClassName)),W.extraEditorClassName&&He.push(W.extraEditorClassName),de.get(ve.mouseStyle)==="default"?He.push("mouse-default"):de.get(ve.mouseStyle)==="copy"&&He.push("mouse-copy"),de.get(ve.showUnused)&&He.push("showUnused"),de.get(ve.showDeprecated)&&He.push("showDeprecated"),He.join(" ")}}class x extends n{constructor(){super(ve.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(308,null)})}compute(W,de,je){return je&&W.emptySelectionClipboard}}class j extends ${constructor(){const W={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(ve.find,"find",W,{"editor.find.cursorMoveOnType":{type:"boolean",default:W.cursorMoveOnType,description:s.localize(309,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:W.seedSearchStringFromSelection,enumDescriptions:[s.localize(310,null),s.localize(311,null),s.localize(312,null)],description:s.localize(313,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:W.autoFindInSelection,enumDescriptions:[s.localize(314,null),s.localize(315,null),s.localize(316,null)],description:s.localize(317,null)},"editor.find.globalFindClipboard":{type:"boolean",default:W.globalFindClipboard,description:s.localize(318,null),included:P.$m},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:W.addExtraSpaceOnTop,description:s.localize(319,null)},"editor.find.loop":{type:"boolean",default:W.loop,description:s.localize(320,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{cursorMoveOnType:i(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof W.seedSearchStringFromSelection=="boolean"?W.seedSearchStringFromSelection?"always":"never":d(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof W.autoFindInSelection=="boolean"?W.autoFindInSelection?"always":"never":d(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(de.loop,this.defaultValue.loop)}}}class U extends ${static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(ve.fontLigatures,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:s.localize(321,null)},{type:"string",description:s.localize(322,null)}],description:s.localize(323,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"||W.length===0?U.OFF:W==="true"?U.ON:W:W?U.ON:U.OFF}}e.EditorFontLigatures=U;class J extends ${static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(ve.fontVariations,"fontVariations",J.OFF,{anyOf:[{type:"boolean",description:s.localize(324,null)},{type:"string",description:s.localize(325,null)}],description:s.localize(326,null),default:!1})}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W==="false"?J.OFF:W==="true"?J.TRANSLATE:W:W?J.TRANSLATE:J.OFF}compute(W,de,je){return W.fontInfo.fontVariationSettings}}e.EditorFontVariations=J;class Z extends h{constructor(){super(ve.fontInfo)}compute(W,de,je){return W.fontInfo}}class ae extends c{constructor(){super(ve.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(327,null)})}validate(W){const de=g.float(W,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(de,6,100)}compute(W,de,je){return W.fontInfo.fontSize}}class ee extends ${static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(ve.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ee.d,maximum:ee.e,errorMessage:s.localize(328,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ee.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(329,null)})}validate(W){return W==="normal"||W==="bold"?W:String(o.clampedInt(W,e.EDITOR_FONT_DEFAULTS.fontWeight,ee.d,ee.e))}}class oe extends ${constructor(){const W={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:W.multiple,enumDescriptions:[s.localize(330,null),s.localize(331,null),s.localize(332,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(ve.gotoLocation,"gotoLocation",W,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(333,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(334,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(335,null),...de},"editor.gotoLocation.multipleDeclarations":{description:s.localize(336,null),...de},"editor.gotoLocation.multipleImplementations":{description:s.localize(337,null),...de},"editor.gotoLocation.multipleReferences":{description:s.localize(338,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:W.alternativeDefinitionCommand,enum:je,description:s.localize(339,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:W.alternativeTypeDefinitionCommand,enum:je,description:s.localize(340,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:W.alternativeDeclarationCommand,enum:je,description:s.localize(341,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:W.alternativeImplementationCommand,enum:je,description:s.localize(342,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:W.alternativeReferenceCommand,enum:je,description:s.localize(343,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{multiple:d(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??d(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??d(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??d(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??d(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??d(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:de.multipleTests??d(de.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:f.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:f.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:f.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:f.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:f.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:f.string(de.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class ie extends ${constructor(){const W={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(ve.hover,"hover",W,{"editor.hover.enabled":{type:"boolean",default:W.enabled,description:s.localize(344,null)},"editor.hover.delay":{type:"number",default:W.delay,minimum:0,maximum:1e4,description:s.localize(345,null)},"editor.hover.sticky":{type:"boolean",default:W.sticky,description:s.localize(346,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:W.hidingDelay,description:s.localize(347,null)},"editor.hover.above":{type:"boolean",default:W.above,description:s.localize(348,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),delay:o.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:i(de.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(de.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(de.above,this.defaultValue.above)}}}var ue;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(ue||(e.RenderMinimap=ue={}));class _ extends h{constructor(){super(ve.layoutInfo)}compute(W,de,je){return _.computeLayout(de,{memory:W.memory,outerWidth:W.outerWidth,outerHeight:W.outerHeight,isDominatedByLongLines:W.isDominatedByLongLines,lineHeight:W.fontInfo.lineHeight,viewLineCount:W.viewLineCount,lineNumbersDigitCount:W.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:W.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:W.fontInfo.maxDigitWidth,pixelRatio:W.pixelRatio,glyphMarginDecorationLaneCount:W.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(W){const de=W.height/W.lineHeight,je=Math.floor(W.paddingTop/W.lineHeight);let He=Math.floor(W.paddingBottom/W.lineHeight);W.scrollBeyondLastLine&&(He=Math.max(He,de-1));const st=(je+W.viewLineCount+He)/(W.pixelRatio*W.height),dt=Math.floor(W.viewLineCount/st);return{typicalViewportLineCount:de,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:He,desiredRatio:st,minimapLineCount:dt}}static c(W,de){const je=W.outerWidth,He=W.outerHeight,st=W.pixelRatio;if(!W.minimap.enabled)return{renderMinimap:ue.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const dt=de.stableMinimapLayoutInput,mt=dt&&W.outerHeight===dt.outerHeight&&W.lineHeight===dt.lineHeight&&W.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&W.pixelRatio===dt.pixelRatio&&W.scrollBeyondLastLine===dt.scrollBeyondLastLine&&W.paddingTop===dt.paddingTop&&W.paddingBottom===dt.paddingBottom&&W.minimap.enabled===dt.minimap.enabled&&W.minimap.side===dt.minimap.side&&W.minimap.size===dt.minimap.size&&W.minimap.showSlider===dt.minimap.showSlider&&W.minimap.renderCharacters===dt.minimap.renderCharacters&&W.minimap.maxColumn===dt.minimap.maxColumn&&W.minimap.scale===dt.minimap.scale&&W.verticalScrollbarWidth===dt.verticalScrollbarWidth&&W.isViewportWrapping===dt.isViewportWrapping,Ot=W.lineHeight,Tt=W.typicalHalfwidthCharacterWidth,Ht=W.scrollBeyondLastLine,_t=W.minimap.renderCharacters;let Xe=st>=2?Math.round(W.minimap.scale*2):W.minimap.scale;const At=W.minimap.maxColumn,Ut=W.minimap.size,bt=W.minimap.side,Dt=W.verticalScrollbarWidth,ei=W.viewLineCount,ti=W.remainingWidth,Qt=W.isViewportWrapping,wt=_t?2:3;let Lt=Math.floor(st*He);const ci=Lt/st;let Yt=!1,Ge=!1,ii=wt*Xe,li=Xe/st,hi=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:ri,extraLinesBeforeFirstLine:Gt,extraLinesBeyondLastLine:Jt,desiredRatio:ui,minimapLineCount:Nt}=_.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Ht,paddingTop:W.paddingTop,paddingBottom:W.paddingBottom,height:He,lineHeight:Ot,pixelRatio:st});if(ei/Nt>1)Yt=!0,Ge=!0,Xe=1,ii=1,li=Xe/st;else{let vt=!1,Xt=Xe+1;if(Ut==="fit"){const Et=Math.ceil((Gt+ei+Jt)*ii);Qt&&mt&&ti<=de.stableFitRemainingWidth?(vt=!0,Xt=de.stableFitMaxMinimapScale):vt=Et>Lt}if(Ut==="fill"||vt){Yt=!0;const Et=Xe;ii=Math.min(Ot*st,Math.max(1,Math.floor(1/ui))),Qt&&mt&&ti<=de.stableFitRemainingWidth&&(Xt=de.stableFitMaxMinimapScale),Xe=Math.min(Xt,Math.max(1,Math.floor(ii/wt))),Xe>Et&&(hi=Math.min(2,Xe/Et)),li=Xe/st/hi,Lt=Math.ceil(Math.max(ri,Gt+ei+Jt)*ii),Qt?(de.stableMinimapLayoutInput=W,de.stableFitRemainingWidth=ti,de.stableFitMaxMinimapScale=Xe):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const kt=Math.floor(At*li),jt=Math.min(kt,Math.max(0,Math.floor((ti-Dt-2)*li/(Tt+li)))+e.MINIMAP_GUTTER_WIDTH);let Mt=Math.floor(st*jt);const Bt=Mt/st;Mt=Math.floor(Mt*hi);const ai=_t?ue.Text:ue.Blocks,ni=bt==="left"?0:je-jt-Dt;return{renderMinimap:ai,minimapLeft:ni,minimapWidth:jt,minimapHeightIsEditorHeight:Yt,minimapIsSampling:Ge,minimapScale:Xe,minimapLineHeight:ii,minimapCanvasInnerWidth:Mt,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:ci}}static computeLayout(W,de){const je=de.outerWidth|0,He=de.outerHeight|0,st=de.lineHeight|0,dt=de.lineNumbersDigitCount|0,mt=de.typicalHalfwidthCharacterWidth,Ot=de.maxDigitWidth,Tt=de.pixelRatio,Ht=de.viewLineCount,_t=W.get(ve.wordWrapOverride2),Xe=_t==="inherit"?W.get(ve.wordWrapOverride1):_t,At=Xe==="inherit"?W.get(ve.wordWrap):Xe,Ut=W.get(ve.wordWrapColumn),bt=de.isDominatedByLongLines,Dt=W.get(ve.glyphMargin),ei=W.get(ve.lineNumbers).renderType!==et.Off,ti=W.get(ve.lineNumbersMinChars),Qt=W.get(ve.scrollBeyondLastLine),wt=W.get(ve.padding),Lt=W.get(ve.minimap),ci=W.get(ve.scrollbar),Yt=ci.verticalScrollbarSize,Ge=ci.verticalHasArrows,ii=ci.arrowSize,li=ci.horizontalScrollbarSize,hi=W.get(ve.folding),kt=W.get(ve.showFoldingControls)!=="never";let jt=W.get(ve.lineDecorationsWidth);hi&&kt&&(jt+=16);let Mt=0;if(ei){const Zt=Math.max(dt,ti);Mt=Math.round(Zt*Ot)}let Bt=0;Dt&&(Bt=st*de.glyphMarginDecorationLaneCount);let ai=0,ni=ai+Bt,ri=ni+Mt,Gt=ri+jt;const Jt=je-Bt-Mt-jt;let ui=!1,Nt=!1,Ct=-1;Xe==="inherit"&&bt?(ui=!0,Nt=!0):At==="on"||At==="bounded"?Nt=!0:At==="wordWrapColumn"&&(Ct=Ut);const vt=_.c({outerWidth:je,outerHeight:He,lineHeight:st,typicalHalfwidthCharacterWidth:mt,pixelRatio:Tt,scrollBeyondLastLine:Qt,paddingTop:wt.top,paddingBottom:wt.bottom,minimap:Lt,verticalScrollbarWidth:Yt,viewLineCount:Ht,remainingWidth:Jt,isViewportWrapping:Nt},de.memory||new k);vt.renderMinimap!==ue.None&&vt.minimapLeft===0&&(ai+=vt.minimapWidth,ni+=vt.minimapWidth,ri+=vt.minimapWidth,Gt+=vt.minimapWidth);const Xt=Jt-vt.minimapWidth,Et=Math.max(1,Math.floor((Xt-Yt-2)/mt)),si=Ge?ii:0;return Nt&&(Ct=Math.max(1,Et),At==="bounded"&&(Ct=Math.min(Ct,Ut))),{width:je,height:He,glyphMarginLeft:ai,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:de.glyphMarginDecorationLaneCount,lineNumbersLeft:ni,lineNumbersWidth:Mt,decorationsLeft:ri,decorationsWidth:jt,contentLeft:Gt,contentWidth:Xt,minimap:vt,viewportColumn:Et,isWordWrapMinified:ui,isViewportWrapping:Nt,wrappingColumn:Ct,verticalScrollbarWidth:Yt,horizontalScrollbarHeight:li,overviewRuler:{top:si,width:Yt,height:He-2*si,right:0}}}}e.EditorLayoutInfoComputer=_;class $e extends ${constructor(){super(ve.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(349,null),s.localize(350,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(351,null)}})}validate(W){return d(W,"simple",["simple","advanced"])}compute(W,de,je){return de.get(ve.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":je}}var Ie;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(Ie||(e.ShowLightbulbIconMode=Ie={}));class X extends ${constructor(){const W={enabled:Ie.OnCode};super(ve.lightbulb,"lightbulb",W,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ie.Off,Ie.OnCode,Ie.On],default:W.enabled,enumDescriptions:[s.localize(352,null),s.localize(353,null),s.localize(354,null)],description:s.localize(355,null)}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{enabled:d(W.enabled,this.defaultValue.enabled,[Ie.Off,Ie.OnCode,Ie.On])}}}class V extends ${constructor(){const W={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(ve.stickyScroll,"stickyScroll",W,{"editor.stickyScroll.enabled":{type:"boolean",default:W.enabled,description:s.localize(356,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:W.maxLineCount,minimum:1,maximum:20,description:s.localize(357,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:W.defaultModel,description:s.localize(358,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:W.scrollWithEditor,description:s.localize(359,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(de.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:d(de.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(de.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends ${constructor(){const W={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(ve.inlayHints,"inlayHints",W,{"editor.inlayHints.enabled":{type:"string",default:W.enabled,description:s.localize(360,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(361,null),s.localize(362,null,P.$m?"Ctrl+Option":"Ctrl+Alt"),s.localize(363,null,P.$m?"Ctrl+Option":"Ctrl+Alt"),s.localize(364,null)]},"editor.inlayHints.fontSize":{type:"number",default:W.fontSize,markdownDescription:s.localize(365,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:W.fontFamily,markdownDescription:s.localize(366,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:W.padding,description:s.localize(367,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return typeof de.enabled=="boolean"&&(de.enabled=de.enabled?"on":"off"),{enabled:d(de.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:f.string(de.fontFamily,this.defaultValue.fontFamily),padding:i(de.padding,this.defaultValue.padding)}}}class we extends ${constructor(){super(ve.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(W){return typeof W=="string"&&/^\d+(\.\d+)?ch$/.test(W)?-parseFloat(W.substring(0,W.length-2)):o.clampedInt(W,this.defaultValue,0,1e3)}compute(W,de,je){return je<0?o.clampedInt(-je*W.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class Pe extends g{constructor(){super(ve.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,W=>g.clamp(W,0,150),{markdownDescription:s.localize(368,null)})}compute(W,de,je){return W.fontInfo.lineHeight}}class Fe extends ${constructor(){const W={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(ve.minimap,"minimap",W,{"editor.minimap.enabled":{type:"boolean",default:W.enabled,description:s.localize(369,null)},"editor.minimap.autohide":{type:"boolean",default:W.autohide,description:s.localize(370,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(371,null),s.localize(372,null),s.localize(373,null)],default:W.size,description:s.localize(374,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:W.side,description:s.localize(375,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:W.showSlider,description:s.localize(376,null)},"editor.minimap.scale":{type:"number",default:W.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(377,null)},"editor.minimap.renderCharacters":{type:"boolean",default:W.renderCharacters,description:s.localize(378,null)},"editor.minimap.maxColumn":{type:"number",default:W.maxColumn,description:s.localize(379,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:W.showRegionSectionHeaders,description:s.localize(380,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:W.showMarkSectionHeaders,description:s.localize(381,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:W.sectionHeaderFontSize,description:s.localize(382,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:W.sectionHeaderLetterSpacing,description:s.localize(383,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),autohide:i(de.autohide,this.defaultValue.autohide),size:d(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(de.side,this.defaultValue.side,["right","left"]),showSlider:d(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(de.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(de.scale,1,1,3),maxColumn:o.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(de.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(de.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:g.clamp(de.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:g.clamp(de.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function Be(Y){return Y==="ctrlCmd"?P.$m?"metaKey":"ctrlKey":"altKey"}class xe extends ${constructor(){super(ve.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(384,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(385,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{top:o.clampedInt(de.top,0,0,1e3),bottom:o.clampedInt(de.bottom,0,0,1e3)}}}class nt extends ${constructor(){const W={enabled:!0,cycle:!0};super(ve.parameterHints,"parameterHints",W,{"editor.parameterHints.enabled":{type:"boolean",default:W.enabled,description:s.localize(386,null)},"editor.parameterHints.cycle":{type:"boolean",default:W.cycle,description:s.localize(387,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),cycle:i(de.cycle,this.defaultValue.cycle)}}}class ht extends h{constructor(){super(ve.pixelRatio)}compute(W,de,je){return W.pixelRatio}}class $t extends ${constructor(){super(ve.placeholder,"placeholder",void 0)}validate(W){return typeof W>"u"?this.defaultValue:typeof W=="string"?W:this.defaultValue}}class ut extends ${constructor(){const W={other:"on",comments:"off",strings:"off"},de=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(388,null),s.localize(389,null),s.localize(390,null)]}];super(ve.quickSuggestions,"quickSuggestions",W,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:de,default:W.strings,description:s.localize(391,null)},comments:{anyOf:de,default:W.comments,description:s.localize(392,null)},other:{anyOf:de,default:W.other,description:s.localize(393,null)}},default:W,markdownDescription:s.localize(394,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=W}validate(W){if(typeof W=="boolean"){const Tt=W?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!W||typeof W!="object")return this.defaultValue;const{other:de,comments:je,strings:He}=W,st=["on","inline","off"];let dt,mt,Ot;return typeof de=="boolean"?dt=de?"on":"off":dt=d(de,this.defaultValue.other,st),typeof je=="boolean"?mt=je?"on":"off":mt=d(je,this.defaultValue.comments,st),typeof He=="boolean"?Ot=He?"on":"off":Ot=d(He,this.defaultValue.strings,st),{other:dt,comments:mt,strings:Ot}}}var et;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(et||(e.RenderLineNumbersType=et={}));class Le extends ${constructor(){super(ve.lineNumbers,"lineNumbers",{renderType:et.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(395,null),s.localize(396,null),s.localize(397,null),s.localize(398,null)],default:"on",description:s.localize(399,null)})}validate(W){let de=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof W<"u"&&(typeof W=="function"?(de=et.Custom,je=W):W==="interval"?de=et.Interval:W==="relative"?de=et.Relative:W==="on"?de=et.On:de=et.Off),{renderType:de,renderFn:je}}}function Ne(Y){const W=Y.get(ve.renderValidationDecorations);return W==="editable"?Y.get(ve.readOnly):W!=="on"}class Me extends ${constructor(){const W=[],de={type:"number",description:s.localize(400,null)};super(ve.rulers,"rulers",W,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:s.localize(401,null),format:"color-hex"}}}]},default:W,description:s.localize(402,null)})}validate(W){if(Array.isArray(W)){const de=[];for(const je of W)if(typeof je=="number")de.push({column:o.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const He=je;de.push({column:o.clampedInt(He.column,0,0,1e4),color:He.color})}return de.sort((je,He)=>je.column-He.column),de}return this.defaultValue}}class q extends ${constructor(){super(ve.readOnlyMessage,"readOnlyMessage",void 0)}validate(W){return!W||typeof W!="object"?this.defaultValue:W}}function B(Y,W){if(typeof Y!="string")return W;switch(Y){case"hidden":return L.ScrollbarVisibility.Hidden;case"visible":return L.ScrollbarVisibility.Visible;default:return L.ScrollbarVisibility.Auto}}class H extends ${constructor(){const W={vertical:L.ScrollbarVisibility.Auto,horizontal:L.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(ve.scrollbar,"scrollbar",W,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(403,null),s.localize(404,null),s.localize(405,null)],default:"auto",description:s.localize(406,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(407,null),s.localize(408,null),s.localize(409,null)],default:"auto",description:s.localize(410,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:W.verticalScrollbarSize,description:s.localize(411,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:W.horizontalScrollbarSize,description:s.localize(412,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:W.scrollByPage,description:s.localize(413,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:W.ignoreHorizontalScrollbarInContentHeight,description:s.localize(414,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W,je=o.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=o.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(de.vertical,this.defaultValue.vertical),horizontal:B(de.horizontal,this.defaultValue.horizontal),useShadows:i(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:o.clampedInt(de.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:He,verticalSliderSize:o.clampedInt(de.verticalSliderSize,He,0,1e3),scrollByPage:i(de.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(de.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends ${constructor(){const W={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(ve.unicodeHighlighting,"unicodeHighlight",W,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.nonBasicASCII,description:s.localize(415,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:W.invisibleCharacters,description:s.localize(416,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:W.ambiguousCharacters,description:s.localize(417,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeComments,description:s.localize(418,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:W.includeStrings,description:s.localize(419,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:W.allowedCharacters,description:s.localize(420,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:W.allowedLocales,description:s.localize(421,null)}})}applyUpdate(W,de){let je=!1;de.allowedCharacters&&W&&(D.$qo(W.allowedCharacters,de.allowedCharacters)||(W={...W,allowedCharacters:de.allowedCharacters},je=!0)),de.allowedLocales&&W&&(D.$qo(W.allowedLocales,de.allowedLocales)||(W={...W,allowedLocales:de.allowedLocales},je=!0));const He=super.applyUpdate(W,de);return je?new r(He.newValue,!0):He}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{nonBasicASCII:Je(de.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(de.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(de.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Je(de.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Je(de.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(W.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(W.allowedLocales,this.defaultValue.allowedLocales)}}c(W,de){if(typeof W!="object"||!W)return de;const je={};for(const[He,st]of Object.entries(W))st===!0&&(je[He]=!0);return je}}class se extends ${constructor(){const W={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(ve.inlineSuggest,"inlineSuggest",W,{"editor.inlineSuggest.enabled":{type:"boolean",default:W.enabled,description:s.localize(422,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:W.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(423,null),s.localize(424,null),s.localize(425,null)],description:s.localize(426,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:W.suppressSuggestions,description:s.localize(427,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:W.fontFamily,description:s.localize(428,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),mode:d(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(de.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(de.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(de.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:f.string(de.fontFamily,this.defaultValue.fontFamily)}}}class ge extends ${constructor(){const W={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(ve.inlineEdit,"experimentalInlineEdit",W,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:W.enabled,description:s.localize(429,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:W.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(430,null),s.localize(431,null),s.localize(432,null)],description:s.localize(433,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:W.fontFamily,description:s.localize(434,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),showToolbar:d(de.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:f.string(de.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(de.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ee extends ${constructor(){const W={enabled:T.$vt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$vt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(ve.bracketPairColorization,"bracketPairColorization",W,{"editor.bracketPairColorization.enabled":{type:"boolean",default:W.enabled,markdownDescription:s.localize(435,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:W.independentColorPoolPerBracketType,description:s.localize(436,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(de.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ze extends ${constructor(){const W={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(ve.guides,"guides",W,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(437,null),s.localize(438,null),s.localize(439,null)],default:W.bracketPairs,description:s.localize(440,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(441,null),s.localize(442,null),s.localize(443,null)],default:W.bracketPairsHorizontal,description:s.localize(444,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:W.highlightActiveBracketPair,description:s.localize(445,null)},"editor.guides.indentation":{type:"boolean",default:W.indentation,description:s.localize(446,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(447,null),s.localize(448,null),s.localize(449,null)],default:W.highlightActiveIndentation,description:s.localize(450,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{bracketPairs:Je(de.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Je(de.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(de.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(de.indentation,this.defaultValue.indentation),highlightActiveIndentation:Je(de.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Je(Y,W,de){const je=de.indexOf(Y);return je===-1?W:de[je]}class _e extends ${constructor(){const W={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(ve.suggest,"suggest",W,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(451,null),s.localize(452,null)],default:W.insertMode,description:s.localize(453,null)},"editor.suggest.filterGraceful":{type:"boolean",default:W.filterGraceful,description:s.localize(454,null)},"editor.suggest.localityBonus":{type:"boolean",default:W.localityBonus,description:s.localize(455,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:W.shareSuggestSelections,markdownDescription:s.localize(456,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(457,null),s.localize(458,null),s.localize(459,null),s.localize(460,null)],default:W.selectionMode,markdownDescription:s.localize(461,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:W.snippetsPreventQuickSuggestions,description:s.localize(462,null)},"editor.suggest.showIcons":{type:"boolean",default:W.showIcons,description:s.localize(463,null)},"editor.suggest.showStatusBar":{type:"boolean",default:W.showStatusBar,description:s.localize(464,null)},"editor.suggest.preview":{type:"boolean",default:W.preview,description:s.localize(465,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:W.showInlineDetails,description:s.localize(466,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(467,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(468,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(469,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(470,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(471,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(472,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(473,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(474,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(475,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(476,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(477,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(478,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(479,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(480,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(481,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(482,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(483,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(484,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(485,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(486,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(487,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(488,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(489,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(490,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(491,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(492,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(493,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(494,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(495,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(496,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(497,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(498,null)}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{insertMode:d(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(de.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(de.showIcons,this.defaultValue.showIcons),showStatusBar:i(de.showStatusBar,this.defaultValue.showStatusBar),preview:i(de.preview,this.defaultValue.preview),previewMode:d(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(de.showMethods,this.defaultValue.showMethods),showFunctions:i(de.showFunctions,this.defaultValue.showFunctions),showConstructors:i(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(de.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(de.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(de.showFields,this.defaultValue.showFields),showVariables:i(de.showVariables,this.defaultValue.showVariables),showClasses:i(de.showClasses,this.defaultValue.showClasses),showStructs:i(de.showStructs,this.defaultValue.showStructs),showInterfaces:i(de.showInterfaces,this.defaultValue.showInterfaces),showModules:i(de.showModules,this.defaultValue.showModules),showProperties:i(de.showProperties,this.defaultValue.showProperties),showEvents:i(de.showEvents,this.defaultValue.showEvents),showOperators:i(de.showOperators,this.defaultValue.showOperators),showUnits:i(de.showUnits,this.defaultValue.showUnits),showValues:i(de.showValues,this.defaultValue.showValues),showConstants:i(de.showConstants,this.defaultValue.showConstants),showEnums:i(de.showEnums,this.defaultValue.showEnums),showEnumMembers:i(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(de.showKeywords,this.defaultValue.showKeywords),showWords:i(de.showWords,this.defaultValue.showWords),showColors:i(de.showColors,this.defaultValue.showColors),showFiles:i(de.showFiles,this.defaultValue.showFiles),showReferences:i(de.showReferences,this.defaultValue.showReferences),showFolders:i(de.showFolders,this.defaultValue.showFolders),showTypeParameters:i(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(de.showSnippets,this.defaultValue.showSnippets),showUsers:i(de.showUsers,this.defaultValue.showUsers),showIssues:i(de.showIssues,this.defaultValue.showIssues)}}}class tt extends ${constructor(){super(ve.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(499,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(500,null),default:!0,type:"boolean"}})}validate(W){return!W||typeof W!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(W.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(W.selectSubwords,this.defaultValue.selectSubwords)}}}class ct extends ${constructor(){const W=[];super(ve.wordSegmenterLocales,"wordSegmenterLocales",W,{anyOf:[{description:s.localize(501,null),type:"string"},{description:s.localize(502,null),type:"array",items:{type:"string"}}]})}validate(W){if(typeof W=="string"&&(W=[W]),Array.isArray(W)){const de=[];for(const je of W)if(typeof je=="string")try{Intl.Segmenter.supportedLocalesOf(je).length>0&&de.push(je)}catch{}return de}return this.defaultValue}}var it;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(it||(e.WrappingIndent=it={}));class at extends ${constructor(){super(ve.wrappingIndent,"wrappingIndent",it.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(503,null),s.localize(504,null),s.localize(505,null),s.localize(506,null)],description:s.localize(507,null),default:"same"}})}validate(W){switch(W){case"none":return it.None;case"same":return it.Same;case"indent":return it.Indent;case"deepIndent":return it.DeepIndent}return it.Same}compute(W,de,je){return de.get(ve.accessibilitySupport)===I.AccessibilitySupport.Enabled?it.None:je}}class yt extends h{constructor(){super(ve.wrappingInfo)}compute(W,de,je){const He=de.get(ve.layoutInfo);return{isDominatedByLongLines:W.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class Ye extends ${constructor(){const W={enabled:!0,showDropSelector:"afterDrop"};super(ve.dropIntoEditor,"dropIntoEditor",W,{"editor.dropIntoEditor.enabled":{type:"boolean",default:W.enabled,markdownDescription:s.localize(508,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(509,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(510,null),s.localize(511,null)],default:"afterDrop"}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),showDropSelector:d(de.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class he extends ${constructor(){const W={enabled:!0,showPasteSelector:"afterPaste"};super(ve.pasteAs,"pasteAs",W,{"editor.pasteAs.enabled":{type:"boolean",default:W.enabled,markdownDescription:s.localize(512,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(513,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(514,null),s.localize(515,null)],default:"afterPaste"}})}validate(W){if(!W||typeof W!="object")return this.defaultValue;const de=W;return{enabled:i(de.enabled,this.defaultValue.enabled),showPasteSelector:d(de.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const pe="Consolas, 'Courier New', monospace",ye="Menlo, Monaco, 'Courier New', monospace",Ce="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$m?ye:P.$n?Ce:pe,fontWeight:"normal",fontSize:P.$m?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function fe(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var ve;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.inlineEdit=63]="inlineEdit",Y[Y.letterSpacing=64]="letterSpacing",Y[Y.lightbulb=65]="lightbulb",Y[Y.lineDecorationsWidth=66]="lineDecorationsWidth",Y[Y.lineHeight=67]="lineHeight",Y[Y.lineNumbers=68]="lineNumbers",Y[Y.lineNumbersMinChars=69]="lineNumbersMinChars",Y[Y.linkedEditing=70]="linkedEditing",Y[Y.links=71]="links",Y[Y.matchBrackets=72]="matchBrackets",Y[Y.minimap=73]="minimap",Y[Y.mouseStyle=74]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=76]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=78]="multiCursorModifier",Y[Y.multiCursorPaste=79]="multiCursorPaste",Y[Y.multiCursorLimit=80]="multiCursorLimit",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.placeholder=88]="placeholder",Y[Y.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=90]="quickSuggestions",Y[Y.quickSuggestionsDelay=91]="quickSuggestionsDelay",Y[Y.readOnly=92]="readOnly",Y[Y.readOnlyMessage=93]="readOnlyMessage",Y[Y.renameOnType=94]="renameOnType",Y[Y.renderControlCharacters=95]="renderControlCharacters",Y[Y.renderFinalNewline=96]="renderFinalNewline",Y[Y.renderLineHighlight=97]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=99]="renderValidationDecorations",Y[Y.renderWhitespace=100]="renderWhitespace",Y[Y.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",Y[Y.roundedSelection=102]="roundedSelection",Y[Y.rulers=103]="rulers",Y[Y.scrollbar=104]="scrollbar",Y[Y.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=106]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=107]="scrollPredominantAxis",Y[Y.selectionClipboard=108]="selectionClipboard",Y[Y.selectionHighlight=109]="selectionHighlight",Y[Y.selectOnLineNumbers=110]="selectOnLineNumbers",Y[Y.showFoldingControls=111]="showFoldingControls",Y[Y.showUnused=112]="showUnused",Y[Y.snippetSuggestions=113]="snippetSuggestions",Y[Y.smartSelect=114]="smartSelect",Y[Y.smoothScrolling=115]="smoothScrolling",Y[Y.stickyScroll=116]="stickyScroll",Y[Y.stickyTabStops=117]="stickyTabStops",Y[Y.stopRenderingLineAfter=118]="stopRenderingLineAfter",Y[Y.suggest=119]="suggest",Y[Y.suggestFontSize=120]="suggestFontSize",Y[Y.suggestLineHeight=121]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",Y[Y.suggestSelection=123]="suggestSelection",Y[Y.tabCompletion=124]="tabCompletion",Y[Y.tabIndex=125]="tabIndex",Y[Y.unicodeHighlighting=126]="unicodeHighlighting",Y[Y.unusualLineTerminators=127]="unusualLineTerminators",Y[Y.useShadowDOM=128]="useShadowDOM",Y[Y.useTabStops=129]="useTabStops",Y[Y.wordBreak=130]="wordBreak",Y[Y.wordSegmenterLocales=131]="wordSegmenterLocales",Y[Y.wordSeparators=132]="wordSeparators",Y[Y.wordWrap=133]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=136]="wordWrapColumn",Y[Y.wordWrapOverride1=137]="wordWrapOverride1",Y[Y.wordWrapOverride2=138]="wordWrapOverride2",Y[Y.wrappingIndent=139]="wrappingIndent",Y[Y.wrappingStrategy=140]="wrappingStrategy",Y[Y.showDeprecated=141]="showDeprecated",Y[Y.inlayHints=142]="inlayHints",Y[Y.editorClassName=143]="editorClassName",Y[Y.pixelRatio=144]="pixelRatio",Y[Y.tabFocusMode=145]="tabFocusMode",Y[Y.layoutInfo=146]="layoutInfo",Y[Y.wrappingInfo=147]="wrappingInfo",Y[Y.defaultColorDecorators=148]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(ve||(e.EditorOption=ve={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:fe(new n(ve.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(516,null)})),acceptSuggestionOnEnter:fe(new S(ve.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(517,null),""],markdownDescription:s.localize(518,null)})),accessibilitySupport:fe(new C),accessibilityPageSize:fe(new o(ve.accessibilityPageSize,"accessibilityPageSize",10,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(519,null),tags:["accessibility"]})),ariaLabel:fe(new f(ve.ariaLabel,"ariaLabel",s.localize(520,null))),ariaRequired:fe(new n(ve.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:fe(new n(ve.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(521,null),tags:["accessibility"]})),autoClosingBrackets:fe(new S(ve.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(522,null),s.localize(523,null),""],description:s.localize(524,null)})),autoClosingComments:fe(new S(ve.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(525,null),s.localize(526,null),""],description:s.localize(527,null)})),autoClosingDelete:fe(new S(ve.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(528,null),""],description:s.localize(529,null)})),autoClosingOvertype:fe(new S(ve.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(530,null),""],description:s.localize(531,null)})),autoClosingQuotes:fe(new S(ve.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(532,null),s.localize(533,null),""],description:s.localize(534,null)})),autoIndent:fe(new E(ve.autoIndent,"autoIndent",b.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[s.localize(535,null),s.localize(536,null),s.localize(537,null),s.localize(538,null),s.localize(539,null)],description:s.localize(540,null)})),automaticLayout:fe(new n(ve.automaticLayout,"automaticLayout",!1)),autoSurround:fe(new S(ve.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(541,null),s.localize(542,null),s.localize(543,null),""],description:s.localize(544,null)})),bracketPairColorization:fe(new Ee),bracketPairGuides:fe(new ze),stickyTabStops:fe(new n(ve.stickyTabStops,"stickyTabStops",!1,{description:s.localize(545,null)})),codeLens:fe(new n(ve.codeLens,"codeLens",!0,{description:s.localize(546,null)})),codeLensFontFamily:fe(new f(ve.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(547,null)})),codeLensFontSize:fe(new o(ve.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(548,null)})),colorDecorators:fe(new n(ve.colorDecorators,"colorDecorators",!0,{description:s.localize(549,null)})),colorDecoratorActivatedOn:fe(new S(ve.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(550,null),s.localize(551,null),s.localize(552,null)],description:s.localize(553,null)})),colorDecoratorsLimit:fe(new o(ve.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(554,null)})),columnSelection:fe(new n(ve.columnSelection,"columnSelection",!1,{description:s.localize(555,null)})),comments:fe(new O),contextmenu:fe(new n(ve.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:fe(new n(ve.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(556,null)})),cursorBlinking:fe(new E(ve.cursorBlinking,"cursorBlinking",p.Blink,"blink",["blink","smooth","phase","expand","solid"],w,{description:s.localize(557,null)})),cursorSmoothCaretAnimation:fe(new S(ve.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(558,null),s.localize(559,null),s.localize(560,null)],description:s.localize(561,null)})),cursorStyle:fe(new E(ve.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:s.localize(562,null)})),cursorSurroundingLines:fe(new o(ve.cursorSurroundingLines,"cursorSurroundingLines",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(563,null)})),cursorSurroundingLinesStyle:fe(new S(ve.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(564,null),s.localize(565,null)],markdownDescription:s.localize(566,null)})),cursorWidth:fe(new o(ve.cursorWidth,"cursorWidth",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(567,null)})),disableLayerHinting:fe(new n(ve.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:fe(new n(ve.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:fe(new n(ve.domReadOnly,"domReadOnly",!1)),dragAndDrop:fe(new n(ve.dragAndDrop,"dragAndDrop",!0,{description:s.localize(568,null)})),emptySelectionClipboard:fe(new x),dropIntoEditor:fe(new Ye),stickyScroll:fe(new V),experimentalWhitespaceRendering:fe(new S(ve.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(569,null),s.localize(570,null),s.localize(571,null)],description:s.localize(572,null)})),extraEditorClassName:fe(new f(ve.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:fe(new g(ve.fastScrollSensitivity,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:s.localize(573,null)})),find:fe(new j),fixedOverflowWidgets:fe(new n(ve.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:fe(new n(ve.folding,"folding",!0,{description:s.localize(574,null)})),foldingStrategy:fe(new S(ve.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(575,null),s.localize(576,null)],description:s.localize(577,null)})),foldingHighlight:fe(new n(ve.foldingHighlight,"foldingHighlight",!0,{description:s.localize(578,null)})),foldingImportsByDefault:fe(new n(ve.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(579,null)})),foldingMaximumRegions:fe(new o(ve.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(580,null)})),unfoldOnClickAfterEndOfLine:fe(new n(ve.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(581,null)})),fontFamily:fe(new f(ve.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(582,null)})),fontInfo:fe(new Z),fontLigatures2:fe(new U),fontSize:fe(new ae),fontWeight:fe(new ee),fontVariations:fe(new J),formatOnPaste:fe(new n(ve.formatOnPaste,"formatOnPaste",!1,{description:s.localize(583,null)})),formatOnType:fe(new n(ve.formatOnType,"formatOnType",!1,{description:s.localize(584,null)})),glyphMargin:fe(new n(ve.glyphMargin,"glyphMargin",!0,{description:s.localize(585,null)})),gotoLocation:fe(new oe),hideCursorInOverviewRuler:fe(new n(ve.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(586,null)})),hover:fe(new ie),inDiffEditor:fe(new n(ve.inDiffEditor,"inDiffEditor",!1)),letterSpacing:fe(new g(ve.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>g.clamp(Y,-5,20),{description:s.localize(587,null)})),lightbulb:fe(new X),lineDecorationsWidth:fe(new we),lineHeight:fe(new Pe),lineNumbers:fe(new Le),lineNumbersMinChars:fe(new o(ve.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:fe(new n(ve.linkedEditing,"linkedEditing",!1,{description:s.localize(588,null)})),links:fe(new n(ve.links,"links",!0,{description:s.localize(589,null)})),matchBrackets:fe(new S(ve.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(590,null)})),minimap:fe(new Fe),mouseStyle:fe(new S(ve.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:fe(new g(ve.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:s.localize(591,null)})),mouseWheelZoom:fe(new n(ve.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$m?s.localize(592,null):s.localize(593,null)})),multiCursorMergeOverlapping:fe(new n(ve.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(594,null)})),multiCursorModifier:fe(new E(ve.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Be,{markdownEnumDescriptions:[s.localize(595,null),s.localize(596,null)],markdownDescription:s.localize(597,null)})),multiCursorPaste:fe(new S(ve.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(598,null),s.localize(599,null)],markdownDescription:s.localize(600,null)})),multiCursorLimit:fe(new o(ve.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(601,null)})),occurrencesHighlight:fe(new S(ve.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(602,null),s.localize(603,null),s.localize(604,null)],markdownDescription:s.localize(605,null)})),overviewRulerBorder:fe(new n(ve.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(606,null)})),overviewRulerLanes:fe(new o(ve.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:fe(new xe),pasteAs:fe(new he),parameterHints:fe(new nt),peekWidgetDefaultFocus:fe(new S(ve.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(607,null),s.localize(608,null)],description:s.localize(609,null)})),placeholder:fe(new $t),definitionLinkOpensInPeek:fe(new n(ve.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(610,null)})),quickSuggestions:fe(new ut),quickSuggestionsDelay:fe(new o(ve.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(611,null)})),readOnly:fe(new n(ve.readOnly,"readOnly",!1)),readOnlyMessage:fe(new q),renameOnType:fe(new n(ve.renameOnType,"renameOnType",!1,{description:s.localize(612,null),markdownDeprecationMessage:s.localize(613,null)})),renderControlCharacters:fe(new n(ve.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(614,null),restricted:!0})),renderFinalNewline:fe(new S(ve.renderFinalNewline,"renderFinalNewline",P.$n?"dimmed":"on",["off","on","dimmed"],{description:s.localize(615,null)})),renderLineHighlight:fe(new S(ve.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(616,null)],description:s.localize(617,null)})),renderLineHighlightOnlyWhenFocus:fe(new n(ve.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(618,null)})),renderValidationDecorations:fe(new S(ve.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:fe(new S(ve.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(619,null),s.localize(620,null),s.localize(621,null),""],description:s.localize(622,null)})),revealHorizontalRightPadding:fe(new o(ve.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:fe(new n(ve.roundedSelection,"roundedSelection",!0,{description:s.localize(623,null)})),rulers:fe(new Me),scrollbar:fe(new H),scrollBeyondLastColumn:fe(new o(ve.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(624,null)})),scrollBeyondLastLine:fe(new n(ve.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(625,null)})),scrollPredominantAxis:fe(new n(ve.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(626,null)})),selectionClipboard:fe(new n(ve.selectionClipboard,"selectionClipboard",!0,{description:s.localize(627,null),included:P.$n})),selectionHighlight:fe(new n(ve.selectionHighlight,"selectionHighlight",!0,{description:s.localize(628,null)})),selectOnLineNumbers:fe(new n(ve.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:fe(new S(ve.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(629,null),s.localize(630,null),s.localize(631,null)],description:s.localize(632,null)})),showUnused:fe(new n(ve.showUnused,"showUnused",!0,{description:s.localize(633,null)})),showDeprecated:fe(new n(ve.showDeprecated,"showDeprecated",!0,{description:s.localize(634,null)})),inlayHints:fe(new re),snippetSuggestions:fe(new S(ve.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(635,null),s.localize(636,null),s.localize(637,null),s.localize(638,null)],description:s.localize(639,null)})),smartSelect:fe(new tt),smoothScrolling:fe(new n(ve.smoothScrolling,"smoothScrolling",!1,{description:s.localize(640,null)})),stopRenderingLineAfter:fe(new o(ve.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:fe(new _e),inlineSuggest:fe(new se),inlineEdit:fe(new ge),inlineCompletionsAccessibilityVerbose:fe(new n(ve.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(641,null)})),suggestFontSize:fe(new o(ve.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(642,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:fe(new o(ve.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(643,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:fe(new n(ve.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(644,null)})),suggestSelection:fe(new S(ve.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(645,null),s.localize(646,null),s.localize(647,null)],description:s.localize(648,null)})),tabCompletion:fe(new S(ve.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(649,null),s.localize(650,null),s.localize(651,null)],description:s.localize(652,null)})),tabIndex:fe(new o(ve.tabIndex,"tabIndex",0,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:fe(new Q),unusualLineTerminators:fe(new S(ve.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(653,null),s.localize(654,null),s.localize(655,null)],description:s.localize(656,null)})),useShadowDOM:fe(new n(ve.useShadowDOM,"useShadowDOM",!0)),useTabStops:fe(new n(ve.useTabStops,"useTabStops",!0,{description:s.localize(657,null)})),wordBreak:fe(new S(ve.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(658,null),s.localize(659,null)],description:s.localize(660,null)})),wordSegmenterLocales:fe(new ct),wordSeparators:fe(new f(ve.wordSeparators,"wordSeparators",m.$wt,{description:s.localize(661,null)})),wordWrap:fe(new S(ve.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(662,null),s.localize(663,null),s.localize(664,null),s.localize(665,null)],description:s.localize(666,null)})),wordWrapBreakAfterCharacters:fe(new f(ve.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:fe(new f(ve.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:fe(new o(ve.wordWrapColumn,"wordWrapColumn",80,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(667,null)})),wordWrapOverride1:fe(new S(ve.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:fe(new S(ve.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:fe(new G),defaultColorDecorators:fe(new n(ve.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(668,null)})),pixelRatio:fe(new ht),tabFocusMode:fe(new n(ve.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(669,null)})),layoutInfo:fe(new _),wrappingInfo:fe(new yt),wrappingIndent:fe(new at),wrappingStrategy:fe(new $e)}}),define(Re[107],Oe([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=void 0,e.$Ri=(0,v.$Ki)("environmentService"),e.$Si=(0,v.$Li)(e.$Ri)}),define(Re[28],Oe([1,0,48,22,13,14,2,9,3,23,15,51]),function(be,e,v,D,P,L,R,T,m,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Kl=e.FileKind=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.FileOperationResult=e.$Cl=e.$Bl=e.$Al=e.$yl=e.FileChangeType=e.$xl=e.FileOperation=e.$rl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$fl=void 0,e.$gl=u,e.$hl=a,e.$il=c,e.$jl=i,e.$kl=n,e.$ll=t,e.$ml=o,e.$nl=l,e.$ol=g,e.$pl=f,e.$ql=d,e.$sl=y,e.$tl=C,e.$ul=O,e.$vl=p,e.$wl=w,e.$zl=x,e.$Ll=ee,e.$Ml=oe,e.$Ol=ue,e.$fl=(0,m.$Ki)("fileService");function u(_){return _.create===!0}var k;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var $;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})($||(e.FilePermission=$={}));var r;(function(_){_[_.UPDATED=2]="UPDATED",_[_.ADDED=4]="ADDED",_[_.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function a(_){const $e=_;return!!$e&&typeof $e.onDidChange=="function"}var h;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(h||(e.FileSystemProviderCapabilities=h={}));function c(_){return!!(_.capabilities&h.FileReadWrite)}function i(_){return!!(_.capabilities&h.FileFolderCopy)}function n(_){return!!(_.capabilities&h.FileClone)}function t(_){return!!(_.capabilities&h.FileOpenReadWriteClose)}function o(_){return!!(_.capabilities&h.FileReadStream)}function l(_){return c(_)?!!(_.capabilities&h.FileAtomicRead):!1}function g(_){return c(_)?!!(_.capabilities&h.FileAtomicWrite):!1}function f(_){return!!(_.capabilities&h.FileAtomicDelete)}function d(_){return!!(_.capabilities&h.Readonly)}var S;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class E extends Error{static create($e,Ie){const X=new E($e.toString(),Ie);return O(X,Ie),X}constructor($e,Ie){super($e),this.code=Ie}}e.$rl=E;function y(_,$e){return E.create(_,$e)}function C(_){return _||y((0,T.localize)(1866,null),S.Unknown)}function O(_,$e){return _.name=$e?`${$e} (FileSystemError)`:"FileSystemError",_}function p(_){if(!_)return S.Unknown;if(_ instanceof E)return _.code;const $e=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!$e)return S.Unknown;switch($e[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function w(_){if(_ instanceof j)return _.fileOperationResult;switch(p(_)){case S.FileNotFound:return Z.FILE_NOT_FOUND;case S.FileIsADirectory:return Z.FILE_IS_DIRECTORY;case S.FileNotADirectory:return Z.FILE_NOT_DIRECTORY;case S.FileWriteLocked:return Z.FILE_WRITE_LOCKED;case S.NoPermissions:return Z.FILE_PERMISSION_DENIED;case S.FileExists:return Z.FILE_MOVE_CONFLICT;case S.FileTooLarge:return Z.FILE_TOO_LARGE;default:return Z.FILE_OTHER_ERROR}}var M;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class A{constructor($e,Ie,X){this.resource=$e,this.operation=Ie,this.target=X}isOperation($e){return this.operation===$e}}e.$xl=A;var F;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class G{static{this.a=null}constructor($e,Ie){this.c=Ie,this.b=void 0,this.d=new b.$Y(()=>{const X=v.$Qi.forUris(()=>this.c);return X.fill(this.rawAdded.map(V=>[V,!0])),X}),this.f=new b.$Y(()=>{const X=v.$Qi.forUris(()=>this.c);return X.fill(this.rawUpdated.map(V=>[V,!0])),X}),this.g=new b.$Y(()=>{const X=v.$Qi.forUris(()=>this.c);return X.fill(this.rawDeleted.map(V=>[V,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of $e){switch(X.type){case F.ADDED:this.rawAdded.push(X.resource);break;case F.UPDATED:this.rawUpdated.push(X.resource);break;case F.DELETED:this.rawDeleted.push(X.resource);break}this.b!==G.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains($e,...Ie){return this.h($e,{includeChildren:!1},...Ie)}affects($e,...Ie){return this.h($e,{includeChildren:!0},...Ie)}h($e,Ie,...X){if(!$e)return!1;const V=X.length>0;return!!((!V||X.includes(F.ADDED))&&(this.d.value.get($e)||Ie.includeChildren&&this.d.value.findSuperstr($e))||(!V||X.includes(F.UPDATED))&&(this.f.value.get($e)||Ie.includeChildren&&this.f.value.findSuperstr($e))||(!V||X.includes(F.DELETED))&&(this.g.value.findSubstr($e)||Ie.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$yl=G;function x(_,$e,Ie){return!_||!$e||_===$e||$e.length>_.length?!1:($e.charAt($e.length-1)!==D.sep&&($e+=D.sep),Ie?(0,P.$Lf)(_,$e):_.indexOf($e)===0)}class j extends Error{constructor($e,Ie,X){super($e),this.fileOperationResult=Ie,this.options=X}}e.$Al=j;class U extends j{constructor($e,Ie,X,V){super($e,Ie,V),this.fileOperationResult=Ie,this.size=X}}e.$Bl=U;class J extends j{constructor($e,Ie,X){super($e,Z.FILE_NOT_MODIFIED_SINCE,X),this.stat=Ie}}e.$Cl=J;var Z;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$Dl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$El={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Fl="files.associations",e.$Gl="files.exclude",e.$Hl="files.readonlyInclude",e.$Il="files.readonlyExclude",e.$Jl="files.readonlyFromPermissions";var ae;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae||(e.FileKind=ae={})),e.$Kl="";function ee(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}async function oe(_,$e){if(!$e.hasProvider(R.URI.from({scheme:_.scheme})))return new Promise(Ie=>{const X=$e.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===_.scheme&&V.added&&(X.dispose(),Ie())})})}class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize($e){return(0,L.$ng)($e)||($e=0),$e<ie.KB?(0,T.localize)(1867,null,$e.toFixed(0)):$e<ie.MB?(0,T.localize)(1868,null,($e/ie.KB).toFixed(2)):$e<ie.GB?(0,T.localize)(1869,null,($e/ie.MB).toFixed(2)):$e<ie.TB?(0,T.localize)(1870,null,($e/ie.GB).toFixed(2)):(0,T.localize)(1871,null,($e/ie.TB).toFixed(2))}}e.$Nl=ie;function ue(_){const $e=typeof _=="string"||_?.scheme===I.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===I.Schemas.file?1024*ie.MB:$e?10*ie.MB:s.$r?50*ie.MB:1024*ie.MB}}),define(Re[75],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=void 0;class v{constructor(...P){this.a=new Map;for(const[L,R]of P)this.set(L,R)}set(P,L){const R=this.a.get(P);return this.a.set(P,L),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Ii=v}),define(Re[171],Oe([1,0,10,12,4,74,168,3,75,172]),function(be,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=void 0;const I=!1;class b extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class u{constructor(a=new m.$Ii,h=!1,c,i=I){this.i=a,this.j=h,this.k=c,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Ji,this),this._globalGraph=i?c?._globalGraph??new R.$Fr(n=>n):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Uc)(this.h),this.h.clear();for(const a of this.g)(0,P.$Tc)(a)&&a.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(a,h){this.m();const c=this,i=new class extends u{dispose(){c.h.delete(i),super.dispose()}}(a,this.j,this,this.l);return this.h.add(i),h?.add(i),i}invokeFunction(a,...h){this.m();const c=$.traceInvocation(this.l,a);let i=!1;try{return a({get:t=>{if(i)throw(0,D.$_)("service accessor is only valid during the invocation of its target method");const o=this.s(t,c);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...h)}finally{i=!0,c.stop()}}createInstance(a,...h){this.m();let c,i;return a instanceof L.$Hi?(c=$.traceCreation(this.l,a.ctor),i=this.o(a.ctor,a.staticArguments.concat(h),c)):(c=$.traceCreation(this.l,a),i=this.o(a,h,c)),c.stop(),i}o(a,h=[],c){const i=T._util.getServiceDependencies(a).sort((o,l)=>o.index-l.index),n=[];for(const o of i){const l=this.s(o.id,c);l||this.y(`[createInstance] ${a.name} depends on UNKNOWN service ${o.id}.`,!1),n.push(l)}const t=i.length>0?i[0].index:h.length;if(h.length!==t){console.trace(`[createInstance] First service dependency of ${a.name} at position ${t+1} conflicts with ${h.length} static arguments`);const o=t-h.length;o>0?h=h.concat(new Array(o)):h=h.slice(0,t)}return Reflect.construct(a,h.concat(n))}q(a,h){if(this.i.get(a)instanceof L.$Hi)this.i.set(a,h);else if(this.k)this.k.q(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}r(a){const h=this.i.get(a);return!h&&this.k?this.k.r(a):h}s(a,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const c=this.r(a);return c instanceof L.$Hi?this.u(a,c,h.branch(a,!0)):(h.branch(a,!1),c)}u(a,h,c){if(this.t.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.t.add(a);try{return this.v(a,h,c)}finally{this.t.delete(a)}}v(a,h,c){const i=new R.$Fr(l=>l.id.toString());let n=0;const t=[{id:a,desc:h,_trace:c}],o=new Set;for(;t.length;){const l=t.pop();if(!o.has(String(l.id))){if(o.add(String(l.id)),i.lookupOrInsertNode(l),n++>1e3)throw new b(i);for(const g of T._util.getServiceDependencies(l.desc.ctor)){const f=this.r(g.id);if(f||this.y(`[createInstance] ${a} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(g.id)),f instanceof L.$Hi){const d={id:g.id,desc:f,_trace:l._trace.branch(g.id,!0)};i.insertEdge(l,d),t.push(d)}}}}for(;;){const l=i.roots();if(l.length===0){if(!i.isEmpty())throw new b(i);break}for(const{data:g}of l){if(this.r(g.id)instanceof L.$Hi){const d=this.w(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.q(g.id,d)}i.removeNode(g)}}return this.r(a)}w(a,h,c=[],i,n){if(this.i.get(a)instanceof L.$Hi)return this.x(a,h,c,i,n,this.g);if(this.k)return this.k.w(a,h,c,i,n);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}x(a,h,c=[],i,n,t){if(i){const o=new u(void 0,this.j,this,this.l);o.c=String(a);const l=new Map,g=new v.$4h(()=>{const f=o.o(h,c,n);for(const[d,S]of l){const E=f[d];if(typeof E=="function")for(const y of S)y.disposable=E.apply(f,y.listener)}return l.clear(),t.add(f),f});return new Proxy(Object.create(null),{get(f,d){if(!g.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let y=l.get(d);return y||(y=new s.$0c,l.set(d,y)),(O,p,w)=>{if(g.isInitialized)return g.value[d](O,p,w);{const M={listener:[O,p,w],disposable:void 0},A=y.push(M);return(0,P.$Xc)(()=>{A(),M.disposable?.dispose()})}}}if(d in f)return f[d];const S=g.value;let E=S[d];return typeof E!="function"||(E=E.bind(S),f[d]=E),E},set(f,d,S){return g.value[d]=S,!0},getPrototypeOf(f){return h.prototype}})}else{const o=this.o(h,c,n);return t.add(o),o}}y(a,h){if(h&&console.warn(a),this.j)throw new Error(a)}}e.$Gr=u;var k;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(k||(k={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(k.None,null)}stop(){}branch(){return this}}}static traceInvocation(a,h){return a?new $(k.Invocation,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(a,h){return a?new $(k.Creation,h.name):$.c}static{this.f=0}constructor(a,h){this.type=a,this.name=h,this.g=Date.now(),this.h=[]}branch(a,h){const c=new $(k.Branch,a.toString());return this.h.push([a,h,c]),c}stop(){const a=Date.now()-this.g;$.f+=a;let h=!1;function c(n,t){const o=[],l=new Array(n+1).join("	");for(const[g,f,d]of t.h)if(f&&d){h=!0,o.push(`${l}CREATES -> ${g}`);const S=c(n+1,d);S&&o.push(S)}else o.push(`${l}uses -> ${g}`);return o.join(`
`)}const i=[`${this.type===k.Creation?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(a>2||h)&&$.all.add(i.join(`
`))}}e.$Hr=$}),define(Re[11],Oe([1,0,9,42,6,76,4,27,23,24,14,2,31,3]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$ik=e.LogLevel=e.$gk=e.$fk=void 0,e.$hk=r,e.log=h,e.$tk=E,e.$uk=y,e.$vk=C,e.$wk=O,v=Ve(v),e.$fk=(0,k.$Ki)("logService"),e.$gk=(0,k.$Ki)("loggerService");function $(){return new Date().toISOString()}function r(p){return(0,I.$ng)(p)}var a;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(a||(e.LogLevel=a={})),e.$ik=a.Info;function h(p,w,M){switch(w){case a.Trace:p.trace(M);break;case a.Debug:p.debug(M);break;case a.Info:p.info(M);break;case a.Warning:p.warn(M);break;case a.Error:p.error(M);break;case a.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function c(p,w=!1){let M="";for(let A=0;A<p.length;A++){let F=p[A];if(F instanceof Error&&(F=(0,D.$vj)(F,w)),typeof F=="object")try{F=JSON.stringify(F)}catch{}M+=(A>0?" ":"")+F}return M}class i extends R.$Zc{constructor(){super(...arguments),this.b=e.$ik,this.c=this.B(new P.$qe),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==a.Off&&this.b<=w}}e.$kk=i;class n extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...M){this.f(a.Trace)&&this.g(a.Trace,c([w,...M],!0))}debug(w,...M){this.f(a.Debug)&&this.g(a.Debug,c([w,...M]))}info(w,...M){this.f(a.Info)&&this.g(a.Info,c([w,...M]))}warn(w,...M){this.f(a.Warning)&&this.g(a.Warning,c([w,...M]))}error(w,...M){if(this.f(a.Error))if(w instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=w.stack,this.g(a.Error,c(A))}else this.g(a.Error,c([w,...M]))}flush(){}}e.$lk=n;class t extends i{constructor(w=e.$ik){super(),this.setLevel(w),this.g=!m.$l}trace(w,...M){this.f(a.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,w,...M):console.log(`[main ${$()}]`,w,...M))}debug(w,...M){this.f(a.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,w,...M):console.log(`[main ${$()}]`,w,...M))}info(w,...M){this.f(a.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,w,...M):console.log(`[main ${$()}]`,w,...M))}warn(w,...M){this.f(a.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,w,...M):console.warn(`[main ${$()}]`,w,...M))}error(w,...M){this.f(a.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,w,...M):console.error(`[main ${$()}]`,w,...M))}flush(){}}e.$mk=t;class o extends i{constructor(w=e.$ik,M=!0){super(),this.g=M,this.setLevel(w)}trace(w,...M){this.f(a.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...M):console.log(w,...M))}debug(w,...M){this.f(a.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...M):console.log(w,...M))}info(w,...M){this.f(a.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...M):console.log(w,...M))}warn(w,...M){this.f(a.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...M):console.log(w,...M))}error(w,...M){this.f(a.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...M):console.error(w,...M))}flush(){}}e.$nk=o;class l extends i{constructor(w,M=e.$ik){super(),this.g=w,this.setLevel(M)}trace(w,...M){this.f(a.Trace)&&this.g.log(a.Trace,[this.h(w),...M])}debug(w,...M){this.f(a.Debug)&&this.g.log(a.Debug,[this.h(w),...M])}info(w,...M){this.f(a.Info)&&this.g.log(a.Info,[this.h(w),...M])}warn(w,...M){this.f(a.Warning)&&this.g.log(a.Warning,[this.h(w),...M])}error(w,...M){this.f(a.Error)&&this.g.log(a.Error,[this.h(w),...M])}h(w){return typeof w=="string"?w:(0,D.$vj)(w,this.f(a.Trace))}flush(){}}e.$ok=l;class g extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const M of this.g)M.setLevel(w);super.setLevel(w)}trace(w,...M){for(const A of this.g)A.trace(w,...M)}debug(w,...M){for(const A of this.g)A.debug(w,...M)}info(w,...M){for(const A of this.g)A.info(w,...M)}warn(w,...M){for(const A of this.g)A.warn(w,...M)}error(w,...M){for(const A of this.g)A.error(w,...M)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$pk=g;class f extends R.$Zc{constructor(w,M,A){if(super(),this.h=w,this.j=M,this.b=new T.$Fc,this.c=this.B(new P.$qe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$qe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$qe),this.onDidChangeVisibility=this.g.event,A)for(const F of A)this.b.set(F.resource,{logger:void 0,info:F})}m(w){return(0,I.$jg)(w)?[...this.b.values()].find(M=>M.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,M){const A=this.n(w),F=(0,I.$jg)(w)?w:M?.id??(0,L.$yj)(A.toString()).toString(16);let G=this.b.get(A)?.logger;const x=M?.logLevel==="always"?a.Trace:M?.logLevel;G||(G=this.s(A,x??this.getLogLevel(A)??this.h,{...M,id:F}));const j={logger:G,info:{resource:A,id:F,logLevel:x,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(j.info),this.b.set(A,j),G}n(w){return(0,I.$jg)(w)?(0,s.$lh)(this.j,`${w}.log`):w}setLogLevel(w,M){if(b.URI.isUri(w)){const A=w,F=M,G=this.b.get(A);G&&F!==G.info.logLevel&&(G.info.logLevel=F===this.h?void 0:F,G.logger?.setLevel(F),this.b.set(G.info.resource,G),this.f.fire([A,F]))}else{this.h=w;for(const[A,F]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,M){const A=this.m(w);A&&M!==!A.info.hidden&&(A.info.hidden=!M,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,M]))}getLogLevel(w){let M;return w&&(M=this.b.get(w)?.info.logLevel),M??this.h}registerLogger(w){const M=this.b.get(w.resource);M?M.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const M=this.b.get(w);M&&(M.logger&&M.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qk=f;class d{constructor(){this.onDidChangeLogLevel=new P.$qe().event}setLevel(w){}getLevel(){return a.Info}trace(w,...M){}debug(w,...M){}info(w,...M){}warn(w,...M){}error(w,...M){}critical(w,...M){}dispose(){}flush(){}}e.$rk=d;class S extends d{}e.$sk=S;function E(p){if(p.verbose)return a.Trace;if(typeof p.logLevel=="string"){const w=O(p.logLevel.toLowerCase());if(w!==void 0)return w}return e.$ik}function y(p){switch(p){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Off:return"off"}}function C(p){switch(p){case a.Trace:return{original:"Trace",value:v.localize(1960,null)};case a.Debug:return{original:"Debug",value:v.localize(1961,null)};case a.Info:return{original:"Info",value:v.localize(1962,null)};case a.Warning:return{original:"Warning",value:v.localize(1963,null)};case a.Error:return{original:"Error",value:v.localize(1964,null)};case a.Off:return{original:"Off",value:v.localize(1965,null)}}}function O(p){switch(p){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Error;case"off":return a.Off}}e.$xk=new u.$2j("logLevel",y(a.Info))}),define(Re[173],Oe([1,0,4,11]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dS=void 0;class P extends v.$Zc{constructor(R,T=[]){super(),this.a=new D.$pk([R,...T]),this.B(R.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...T){this.a.trace(R,...T)}debug(R,...T){this.a.debug(R,...T)}info(R,...T){this.a.info(R,...T)}warn(R,...T){this.a.warn(R,...T)}error(R,...T){this.a.error(R,...T)}flush(){this.a.flush()}}e.$dS=P});var oi=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Re[108],Oe([1,0,37,9,3]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=oi(v);var L;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(m){function s($,r){return r-$}m.compare=s;const I=Object.create(null);I[m.Error]=(0,D.localize)(1966,null),I[m.Warning]=(0,D.localize)(1967,null),I[m.Info]=(0,D.localize)(1968,null);function b($){return I[$]||""}m.toString=b;function u($){switch($){case v.default.Error:return m.Error;case v.default.Warning:return m.Warning;case v.default.Info:return m.Info;case v.default.Ignore:return m.Hint}}m.fromSeverity=u;function k($){switch($){case m.Error:return v.default.Error;case m.Warning:return v.default.Warning;case m.Info:return v.default.Info;case m.Hint:return v.default.Ignore}}m.toSeverity=k}(R||(e.MarkerSeverity=R={}));var T;(function(m){const s="";function I(u){return b(u,!0)}m.makeKey=I;function b(u,k){const $=[s];return u.source?$.push(u.source.replace("\xA6","\\\xA6")):$.push(s),u.code?typeof u.code=="string"?$.push(u.code.replace("\xA6","\\\xA6")):$.push(u.code.value.replace("\xA6","\\\xA6")):$.push(s),u.severity!==void 0&&u.severity!==null?$.push(R.toString(u.severity)):$.push(s),u.message&&k?$.push(u.message.replace("\xA6","\\\xA6")):$.push(s),u.startLineNumber!==void 0&&u.startLineNumber!==null?$.push(u.startLineNumber.toString()):$.push(s),u.startColumn!==void 0&&u.startColumn!==null?$.push(u.startColumn.toString()):$.push(s),u.endLineNumber!==void 0&&u.endLineNumber!==null?$.push(u.endLineNumber.toString()):$.push(s),u.endColumn!==void 0&&u.endColumn!==null?$.push(u.endColumn.toString()):$.push(s),$.push(s),$.join("\xA6")}m.makeKeyOptionalMessage=b})(T||(e.IMarkerData=T={})),e.$Qu=(0,P.$Ki)("markerService")});var oi=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Re[174],Oe([1,0,6,37,3]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Ew=e.Severity=void 0,e.$Fw=T,D=oi(D),e.Severity=D.default,e.$Ew=(0,P.$Ki)("notificationService");var L;(function(b){b[b.DEFAULT=0]="DEFAULT",b[b.SILENT=1]="SILENT",b[b.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(b){b[b.WORKSPACE=0]="WORKSPACE",b[b.PROFILE=1]="PROFILE",b[b.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function T(b){if(b){const u=b;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var m;(function(b){b[b.OFF=0]="OFF",b[b.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class s{constructor(){this.progress=new I,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Gw=s;class I{infinite(){}done(){}total(u){}worked(u){}}e.$Hw=I}),define(Re[109],Oe([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=void 0,e.$yk=(0,v.$Ki)("productService"),e.$zk="vscode://schemas/vscode-product"});var Qe=this&&this.__decorate||function(be,e,v,D){var P=arguments.length,L=P<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,v):D,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(be,e,v,D);else for(var T=be.length-1;T>=0;T--)(R=be[T])&&(L=(P<3?R(L):P>3?R(e,v,L):R(e,v))||L);return P>3&&L&&Object.defineProperty(e,v,L),L},We=this&&this.__param||function(be,e){return function(v,D){e(v,D,be)}};define(Re[77],Oe([1,0,10,19,4,3]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ow=e.$Nw=e.$Mw=e.$Lw=e.$Kw=e.$Jw=e.ProgressLocation=e.$Iw=void 0,e.$Iw=(0,L.$Ki)("progressService");var R;(function(b){b[b.Explorer=1]="Explorer",b[b.Scm=3]="Scm",b[b.Extensions=5]="Extensions",b[b.Window=10]="Window",b[b.Notification=15]="Notification",b[b.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Jw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Kw=T;class m{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const k=this.d;this.d=()=>{k?.(),u()}}):Promise.resolve()}}e.$Lw=m;let s=class extends P.$Zc{constructor(u,k){super(),this.a=new v.$8h,k.withProgress(u,$=>(this.b=$,this.c&&$.report(this.c),this.a.p)),this.B((0,P.$Xc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Mw=s,e.$Mw=s=Qe([We(1,e.$Iw)],s);class I extends P.$Zc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new P.$Yc)}start(u){this.stop();const k=++this.a,$=new D.$Be;return this.f=setTimeout(()=>{k===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,P.$Xc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Xc)(()=>$.cancel())),this.b.add((0,P.$Xc)(()=>this.c?this.c.done():void 0)),{id:k,token:$.token,stop:()=>this.h(k),isCurrent:()=>this.a===k}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Nw=I,e.$Ow=(0,L.$Ki)("editorProgressService")}),define(Re[29],Oe([1,0,61,14]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=void 0,v=Ve(v),D=Ve(D);class P{constructor(){this.a=new Map}add(R,T){v.ok(D.$jg(R)),v.ok(D.$lg(T)),v.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,T)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$zo=new P}),define(Re[78],Oe([1,0,6,139,29]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=void 0,P=Ve(P),e.$Ao={JSONContribution:"base.contributions.json"};function L(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class R{constructor(){this.b=new v.$qe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(s,I){this.a[L(s)]=I,this.b.fire(s)}notifySchemaChanged(s){this.b.fire(s)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(s){const I=this.a[s];return I?(0,D.$ak)(I):void 0}hasSchemaContent(s){return!!this.a[s]}}const T=new R;P.$zo.add(e.$Ao.JSONContribution,T)}),define(Re[53],Oe([1,0,17,6,14,9,44,78,29]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.ConfigurationScope=e.$Eo=e.EditPresentationTypes=void 0,e.$Po=r,e.$Qo=a,e.$Ro=h,e.$So=i,e.$To=n,e.$Uo=t,e.$Vo=o,P=Ve(P),L=Ve(L);var s;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$Eo={Configuration:"base.contributions.configuration"};var I;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho={properties:{},patternProperties:{}},e.$Io={properties:{},patternProperties:{}},e.$Jo={properties:{},patternProperties:{}},e.$Ko={properties:{},patternProperties:{}},e.$Lo="vscode://schemas/settings/resourceLanguage",e.$Mo="vscode://schemas/settings/configurationDefaults";const b=m.$zo.as(T.$Ao.JSONContribution);class u{constructor(){this.a=[],this.i=new Set,this.j=new D.$qe,this.onDidSchemaChange=this.j.event,this.k=new D.$qe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:L.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},b.registerSchema(e.$Lo,this.h),this.z()}registerConfiguration(g,f=!0){this.registerConfigurations([g],f)}registerConfigurations(g,f=!0){const d=new Set;this.r(g,f,d),b.registerSchema(e.$Lo,this.h),this.j.fire(),this.k.fire({properties:d})}deregisterConfigurations(g){const f=new Set;this.s(g,f),b.registerSchema(e.$Lo,this.h),this.j.fire(),this.k.fire({properties:f})}updateConfigurations({add:g,remove:f}){const d=new Set;this.s(f,d),this.r(g,!1,d),b.registerSchema(e.$Lo,this.h),this.j.fire(),this.k.fire({properties:d})}registerDefaultConfigurations(g){const f=new Set;this.l(g,f),this.j.fire(),this.k.fire({properties:f,defaultsOverrides:!0})}l(g,f){this.a.push(...g);const d=[];for(const{overrides:S,source:E}of g)for(const y in S){f.add(y);const C=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),O=S[y];if(C.configurationDefaultOverrides.push({value:O,source:E}),e.$Oo.test(y)){const p=this.o(y,O,E,C.configurationDefaultOverrideValue);if(!p)continue;C.configurationDefaultOverrideValue=p,this.n(y,p,E),d.push(...r(y))}else{const p=this.p(y,O,E,C.configurationDefaultOverrideValue);if(!p)continue;C.configurationDefaultOverrideValue=p;const w=this.e[y];w&&(this.A(y,w),this.w(y,w))}}this.q(d)}deregisterDefaultConfigurations(g){const f=new Set;this.m(g,f),this.j.fire(),this.k.fire({properties:f,defaultsOverrides:!0})}m(g,f){for(const d of g){const S=this.a.indexOf(d);S!==-1&&this.a.splice(S,1)}for(const{overrides:d,source:S}of g)for(const E in d){const y=this.b.get(E);if(!y)continue;const C=y.configurationDefaultOverrides.findIndex(O=>S?O.source?.id===S.id:O.value===d[E]);if(C!==-1){if(y.configurationDefaultOverrides.splice(C,1),y.configurationDefaultOverrides.length===0&&this.b.delete(E),e.$Oo.test(E)){let O;for(const p of y.configurationDefaultOverrides)O=this.o(E,p.value,p.source,O);O&&!P.$wg(O.value)?(y.configurationDefaultOverrideValue=O,this.n(E,O,S)):(this.b.delete(E),delete this.e[E],delete this.c.properties[E])}else{let O;for(const w of y.configurationDefaultOverrides)O=this.p(E,w.value,w.source,O);y.configurationDefaultOverrideValue=O;const p=this.e[E];p&&(this.A(E,p),this.w(E,p))}f.add(E)}}this.y()}n(g,f,d){const S={type:"object",default:f.value,description:L.localize(1663,null,(0,R.$oj)(g)),$ref:e.$Lo,defaultDefaultValue:f.value,source:d,defaultValueSource:d};this.e[g]=S,this.c.properties[g]=S}o(g,f,d,S){const E=S?.value||{},y=S?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const C of Object.keys(f)){const O=f[C];if(P.$lg(O)&&(P.$qg(E[C])||P.$lg(E[C]))){if(E[C]={...E[C]??{},...O},d)for(const w in O)y.set(`${C}.${w}`,d)}else E[C]=O,d?y.set(C,d):y.delete(C)}return{value:E,source:y}}p(g,f,d,S){const E=this.e[g],y=S?.value??E?.defaultDefaultValue;let C=d;if(P.$lg(f)&&(E!==void 0&&E.type==="object"||E===void 0&&(P.$qg(y)||P.$lg(y)))){if(C=S?.source??new Map,!(C instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const p in f)d&&C.set(`${g}.${p}`,d);f={...P.$lg(y)?y:{},...f}}return{value:f,source:C}}deltaConfiguration(g){let f=!1;const d=new Set;g.removedDefaults&&(this.m(g.removedDefaults,d),f=!0),g.addedDefaults&&(this.l(g.addedDefaults,d),f=!0),g.removedConfigurations&&this.s(g.removedConfigurations,d),g.addedConfigurations&&this.r(g.addedConfigurations,!1,d),this.j.fire(),this.k.fire({properties:d,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...g){this.j.fire()}registerOverrideIdentifiers(g){this.q(g),this.j.fire()}q(g){for(const f of g)this.i.add(f);this.y()}r(g,f,d){g.forEach(S=>{this.u(S,f,S.extensionInfo,S.restrictedProperties,void 0,d),this.d.push(S),this.v(S)})}s(g,f){const d=S=>{if(S.properties)for(const E in S.properties){f.add(E);const y=this.e[E];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[E],this.x(E,S.properties[E])}S.allOf?.forEach(E=>d(E))};for(const S of g){d(S);const E=this.d.indexOf(S);E!==-1&&this.d.splice(E,1)}}u(g,f=!0,d,S,E=I.WINDOW,y){E=P.$sg(g.scope)?E:g.scope;const C=g.properties;if(C)for(const p in C){const w=C[p];if(f&&i(p,w)){delete C[p];continue}if(w.source=d,w.defaultDefaultValue=C[p].default,this.A(p,w),e.$Oo.test(p)?w.scope=void 0:(w.scope=P.$sg(w.scope)?E:w.scope,w.restricted=P.$sg(w.restricted)?!!S?.includes(p):w.restricted),C[p].hasOwnProperty("included")&&!C[p].included){this.g[p]=C[p],delete C[p];continue}else this.e[p]=C[p],C[p].policy?.name&&this.f.set(C[p].policy.name,p);!C[p].deprecationMessage&&C[p].markdownDeprecationMessage&&(C[p].deprecationMessage=C[p].markdownDeprecationMessage),y.add(p)}const O=g.allOf;if(O)for(const p of O)this.u(p,f,d,S,E,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const g=new Map;for(const[f,d]of this.b)d.configurationDefaultOverrideValue&&g.set(f,d.configurationDefaultOverrideValue);return g}v(g){const f=d=>{const S=d.properties;if(S)for(const y in S)this.w(y,S[y]);d.allOf?.forEach(f)};f(g)}w(g,f){switch(e.$Fo.properties[g]=f,f.scope){case I.APPLICATION:e.$Go.properties[g]=f;break;case I.MACHINE:e.$Ho.properties[g]=f;break;case I.MACHINE_OVERRIDABLE:e.$Io.properties[g]=f;break;case I.WINDOW:e.$Jo.properties[g]=f;break;case I.RESOURCE:e.$Ko.properties[g]=f;break;case I.LANGUAGE_OVERRIDABLE:e.$Ko.properties[g]=f,this.h.properties[g]=f;break}}x(g,f){switch(delete e.$Fo.properties[g],f.scope){case I.APPLICATION:delete e.$Go.properties[g];break;case I.MACHINE:delete e.$Ho.properties[g];break;case I.MACHINE_OVERRIDABLE:delete e.$Io.properties[g];break;case I.WINDOW:delete e.$Jo.properties[g];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Ko.properties[g],delete this.h.properties[g];break}}y(){for(const g of this.i.values()){const f=`[${g}]`,d={type:"object",description:L.localize(1664,null),errorMessage:L.localize(1665,null),$ref:e.$Lo};this.A(f,d),e.$Fo.properties[f]=d,e.$Go.properties[f]=d,e.$Ho.properties[f]=d,e.$Io.properties[f]=d,e.$Jo.properties[f]=d,e.$Ko.properties[f]=d}}z(){const g={type:"object",description:L.localize(1666,null),errorMessage:L.localize(1667,null),$ref:e.$Lo};e.$Fo.patternProperties[e.$No]=g,e.$Go.patternProperties[e.$No]=g,e.$Ho.patternProperties[e.$No]=g,e.$Io.patternProperties[e.$No]=g,e.$Jo.patternProperties[e.$No]=g,e.$Ko.patternProperties[e.$No]=g,this.j.fire()}A(g,f){const d=this.b.get(g)?.configurationDefaultOverrideValue;let S,E;d&&(!f.disallowConfigurationDefault||!d.source)&&(S=d.value,E=d.source),P.$qg(S)&&(S=f.defaultDefaultValue,E=void 0),P.$qg(S)&&(S=h(f.type)),f.default=S,f.defaultValueSource=E}}const k="\\[([^\\]]+)\\]",$=new RegExp(k,"g");e.$No=`^(${k})+$`,e.$Oo=new RegExp(e.$No);function r(l){const g=[];if(e.$Oo.test(l)){let f=$.exec(l);for(;f?.length;){const d=f[1].trim();d&&g.push(d),f=$.exec(l)}}return(0,v.$Qb)(g)}function a(l){return l.reduce((g,f)=>`${g}[${f}]`,"")}function h(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const c=new u;m.$zo.add(e.$Eo.Configuration,c);function i(l,g){return l.trim()?e.$Oo.test(l)?L.localize(1669,null,l):c.getConfigurationProperties()[l]!==void 0?L.localize(1670,null,l):g.policy?.name&&c.getPolicyConfigurations().get(g.policy?.name)!==void 0?L.localize(1671,null,l,g.policy?.name,c.getPolicyConfigurations().get(g.policy?.name)):null:L.localize(1668,null)}function n(){const l=[],g=c.getConfigurationProperties();for(const f of Object.keys(g))l.push([f,g[f].scope]);return l.push(["launch",I.RESOURCE]),l.push(["task",I.RESOURCE]),l}function t(l){const g={};for(const f of l){const d=f.properties;if(P.$lg(d))for(const S in d)g[S]=d[S];f.allOf&&Object.assign(g,t(f.allOf))}return g}function o(l){switch(l){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Re[175],Oe([1,0,17,6,138,4,27,25,14,2,44,53,28,29]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$1o=n,v=Ve(v),P=Ve(P),T=Ve(T),m=Ve(m);function $(g){return Object.isFrozen(g)?g:T.$no(g)}class r{static createEmptyModel(f){return new r({},[],[],void 0,f)}constructor(f,d,S,E,y){this.b=f,this.c=d,this.d=S,this.raw=E,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const f=this.raw.map(d=>{if(d instanceof r)return d;const S=new a("",this.f);return S.parseRaw(d),S.configurationModel});this.g=f.reduce((d,S)=>S===d?S:d.merge(S),f[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(f){return f?(0,I.$mj)(this.contents,f):this.contents}inspect(f,d){const S=this;return{get value(){return $(S.rawConfiguration.getValue(f))},get override(){return d?$(S.rawConfiguration.getOverrideValue(f,d)):void 0},get merged(){return $(d?S.rawConfiguration.override(d).getValue(f):S.rawConfiguration.getValue(f))},get overrides(){const E=[];for(const{contents:y,identifiers:C,keys:O}of S.rawConfiguration.overrides){const p=new r(y,O,[],void 0,S.f).getValue(f);p!==void 0&&E.push({identifiers:C,value:p})}return E.length?$(E):void 0}}}getOverrideValue(f,d){const S=this.j(d);return S?f?(0,I.$mj)(S,f):S:void 0}getKeysForOverrideIdentifier(f){const d=[];for(const S of this.overrides)S.identifiers.includes(f)&&d.push(...S.keys);return v.$Qb(d)}getAllOverrideIdentifiers(){const f=[];for(const d of this.overrides)f.push(...d.identifiers);return v.$Qb(f)}override(f){let d=this.a.get(f);return d||(d=this.h(f),this.a.set(f,d)),d}merge(...f){const d=T.$mo(this.contents),S=T.$mo(this.overrides),E=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const C of f)if(y.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(d,C.contents);for(const O of C.overrides){const[p]=S.filter(w=>v.$yb(w.identifiers,O.identifiers));p?(this.i(p.contents,O.contents),p.keys.push(...O.keys),p.keys=v.$Qb(p.keys)):S.push(T.$mo(O))}for(const O of C.keys)E.indexOf(O)===-1&&E.push(O)}return new r(d,E,S,y.every(C=>C instanceof r)?void 0:y,this.f)}h(f){const d=this.j(f);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const S={};for(const E of v.$Qb([...Object.keys(this.contents),...Object.keys(d)])){let y=this.contents[E];const C=d[E];C&&(typeof y=="object"&&typeof C=="object"?(y=T.$mo(y),this.i(y,C)):y=C),S[E]=y}return new r(S,this.keys,this.overrides,void 0,this.f)}i(f,d){for(const S of Object.keys(d)){if(S in f&&m.$lg(f[S])&&m.$lg(d[S])){this.i(f[S],d[S]);continue}f[S]=T.$mo(d[S])}}j(f){let d=null,S=null;const E=y=>{y&&(S?this.i(S,y):S=T.$mo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===f?d=y.contents:y.identifiers.includes(f)&&E(y.contents);return E(d),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(f,d){this.k(f,d,!0)}setValue(f,d){this.k(f,d,!1)}removeValue(f){const d=this.keys.indexOf(f);d!==-1&&(this.keys.splice(d,1),(0,I.$lj)(this.contents,f),b.$Oo.test(f)&&this.overrides.splice(this.overrides.findIndex(S=>v.$yb(S.identifiers,(0,b.$Po)(f))),1))}k(f,d,S){if((0,I.$kj)(this.contents,f,d,E=>this.f.error(E)),S=S||this.keys.indexOf(f)===-1,S&&this.keys.push(f),b.$Oo.test(f)){const E=(0,b.$Po)(f),y={identifiers:E,keys:Object.keys(this.contents[f]),contents:(0,I.$jj)(this.contents[f],O=>this.f.error(O))},C=this.overrides.findIndex(O=>v.$yb(O.identifiers,E));C!==-1?this.overrides[C]=y:this.overrides.push(y)}}}e.$Wo=r;class a{constructor(f,d){this.f=f,this.g=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(f,d){if(!m.$sg(f)){const S=this.h(f);this.parseRaw(S,d)}}reparse(f){this.a&&this.parseRaw(this.a,f)}parseRaw(f,d){this.a=f;const{contents:S,keys:E,overrides:y,restricted:C,hasExcludedProperties:O}=this.i(f,d);this.b=new r(S,E,y,O?[f]:void 0,this.g),this.c=C||[]}h(f){let d={},S=null,E=[];const y=[],C=[];function O(w){Array.isArray(E)?E.push(w):S!==null&&(E[S]=w)}const p={onObjectBegin:()=>{const w={};O(w),y.push(E),E=w,S=null},onObjectProperty:w=>{S=w},onObjectEnd:()=>{E=y.pop()},onArrayBegin:()=>{const w=[];O(w),y.push(E),E=w,S=null},onArrayEnd:()=>{E=y.pop()},onLiteralValue:O,onError:(w,M,A)=>{C.push({error:w,offset:M,length:A})}};if(f)try{P.$bo(f,p),d=E[0]||{}}catch(w){this.g.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return d}i(f,d){const S=k.$zo.as(b.$Eo.Configuration).getConfigurationProperties(),E=this.j(f,S,!0,d);f=E.raw;const y=(0,I.$jj)(f,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`)),C=Object.keys(f),O=this.l(f,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:y,keys:C,overrides:O,restricted:E.restricted,hasExcludedProperties:E.hasExcludedProperties}}j(f,d,S,E){let y=!1;if(!E?.scopes&&!E?.skipRestricted&&!E?.exclude?.length)return{raw:f,restricted:[],hasExcludedProperties:y};const C={},O=[];for(const p in f)if(b.$Oo.test(p)&&S){const w=this.j(f[p],d,!1,E);C[p]=w.raw,y=y||w.hasExcludedProperties,O.push(...w.restricted)}else{const w=d[p],M=w?typeof w.scope<"u"?w.scope:b.ConfigurationScope.WINDOW:void 0;w?.restricted&&O.push(p),!E.exclude?.includes(p)&&(E.include?.includes(p)||(M===void 0||E.scopes===void 0||E.scopes.includes(M))&&!(E.skipRestricted&&w?.restricted))?C[p]=f[p]:y=!0}return{raw:C,restricted:O,hasExcludedProperties:y}}l(f,d){const S=[];for(const E of Object.keys(f))if(b.$Oo.test(E)){const y={};for(const C in f[E])y[C]=f[E][C];S.push({identifiers:(0,b.$Po)(E),keys:Object.keys(y),contents:(0,I.$jj)(y,d)})}return S}}e.$Xo=a;class h extends L.$Zc{constructor(f,d,S,E,y){super(),this.c=f,this.f=d,this.g=E,this.h=y,this.b=this.B(new D.$qe),this.onDidChange=this.b.event,this.a=new a(this.c.toString(),y),this.B(this.g.watch(S.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(u.FileOperation.CREATE)||C.isOperation(u.FileOperation.COPY)||C.isOperation(u.FileOperation.DELETE)||C.isOperation(u.FileOperation.WRITE))&&S.isEqual(C.resource,f)))(()=>this.b.fire()))}async loadConfiguration(){try{const f=await this.g.readFile(this.c);return this.a.parse(f.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(f){return f&&(this.f=f),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Yo=h;class c{constructor(f,d,S,E,y,C,O,p,w,M,A,F,G){this.a=f,this.b=d,this.c=S,this.overrideIdentifiers=E,this.d=y,this.f=C,this.g=O,this.h=p,this.i=w,this.j=M,this.k=A,this.l=F,this.m=G}get value(){return $(this.c)}n(f){return f?.value!==void 0||f?.override!==void 0||f?.overrides!==void 0?f:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(f,d,S,E,y,C,O,p,w,M){this.j=f,this.l=d,this.m=S,this.n=E,this.p=y,this.q=C,this.r=O,this.s=p,this.t=w,this.u=M,this.h=null,this.i=new R.$Fc,this.v=null}getValue(f,d,S){return this.w(f,d,S).getValue(f)}updateValue(f,d,S={}){let E;S.resource?(E=this.t.get(S.resource),E||(E=r.createEmptyModel(this.u),this.t.set(S.resource,E))):E=this.s,d===void 0?E.removeValue(f):E.setValue(f,d),S.resource||(this.h=null)}inspect(f,d,S){const E=this.w(f,d,S),y=this.A(d.resource,S),C=d.resource?this.t.get(d.resource)||this.s:this.s,O=new Set;for(const p of E.overrides)for(const w of p.identifiers)E.getOverrideValue(f,w)!==void 0&&O.add(w);return new c(f,d,E.getValue(f),O.size?[...O]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this.q:void 0,y||void 0,C)}keys(f){const d=this.A(void 0,f);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(f){this.j=f,this.h=null,this.i.clear()}updatePolicyConfiguration(f){this.l=f}updateApplicationConfiguration(f){this.m=f,this.h=null,this.i.clear()}updateLocalUserConfiguration(f){this.n=f,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(f){this.p=f,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(f){this.q=f,this.h=null,this.i.clear()}updateFolderConfiguration(f,d){this.r.set(f,d),this.i.delete(f)}deleteFolderConfiguration(f){this.folderConfigurations.delete(f),this.i.delete(f)}compareAndUpdateDefaultConfiguration(f,d){const S=[];if(!d){const{added:E,updated:y,removed:C}=o(this.j,f);d=[...E,...y,...C]}for(const E of d)for(const y of(0,b.$Po)(E)){const C=this.j.getKeysForOverrideIdentifier(y),O=f.getKeysForOverrideIdentifier(y),p=[...O.filter(w=>C.indexOf(w)===-1),...C.filter(w=>O.indexOf(w)===-1),...C.filter(w=>!T.$qo(this.j.override(y).getValue(w),f.override(y).getValue(w)))];S.push([y,p])}return this.updateDefaultConfiguration(f),{keys:d,overrides:S}}compareAndUpdatePolicyConfiguration(f){const{added:d,updated:S,removed:E}=o(this.l,f),y=[...d,...S,...E];return y.length&&this.updatePolicyConfiguration(f),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(f){const{added:d,updated:S,removed:E,overrides:y}=o(this.applicationConfiguration,f),C=[...d,...S,...E];return C.length&&this.updateApplicationConfiguration(f),{keys:C,overrides:y}}compareAndUpdateLocalUserConfiguration(f){const{added:d,updated:S,removed:E,overrides:y}=o(this.localUserConfiguration,f),C=[...d,...S,...E];return C.length&&this.updateLocalUserConfiguration(f),{keys:C,overrides:y}}compareAndUpdateRemoteUserConfiguration(f){const{added:d,updated:S,removed:E,overrides:y}=o(this.remoteUserConfiguration,f),C=[...d,...S,...E];return C.length&&this.updateRemoteUserConfiguration(f),{keys:C,overrides:y}}compareAndUpdateWorkspaceConfiguration(f){const{added:d,updated:S,removed:E,overrides:y}=o(this.workspaceConfiguration,f),C=[...d,...S,...E];return C.length&&this.updateWorkspaceConfiguration(f),{keys:C,overrides:y}}compareAndUpdateFolderConfiguration(f,d){const S=this.folderConfigurations.get(f),{added:E,updated:y,removed:C,overrides:O}=o(S,d),p=[...E,...y,...C];return(p.length||!S)&&this.updateFolderConfiguration(f,d),{keys:p,overrides:O}}compareAndDeleteFolderConfiguration(f){const d=this.folderConfigurations.get(f);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(f);const{added:S,updated:E,removed:y,overrides:C}=o(d,void 0);return{keys:[...S,...E,...y],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(f,d,S){let E=this.x(d,S);return d.overrideIdentifier&&(E=E.override(d.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(f)!==void 0&&(E=E.merge(this.l)),E}x({resource:f},d){let S=this.y();if(d&&f){const E=d.getFolder(f);E&&(S=this.z(E.uri)||S);const y=this.t.get(f);y&&(S=S.merge(y))}return S}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(f){let d=this.i.get(f);if(!d){const S=this.y(),E=this.r.get(f);E?(d=S.merge(E),this.i.set(f,d)):d=S}return d}A(f,d){if(d&&f){const S=d.getFolder(f);if(S)return this.r.get(S.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((f,d)=>{const{contents:S,overrides:E,keys:y}=this.r.get(d);return f.push([d,{contents:S,overrides:E,keys:y}]),f},[])}}allKeys(){const f=new Set;return this.j.keys.forEach(d=>f.add(d)),this.userConfiguration.keys.forEach(d=>f.add(d)),this.q.keys.forEach(d=>f.add(d)),this.r.forEach(d=>d.keys.forEach(S=>f.add(S))),[...f.values()]}B(){const f=new Set;return this.j.getAllOverrideIdentifiers().forEach(d=>f.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>f.add(d)),this.q.getAllOverrideIdentifiers().forEach(d=>f.add(d)),this.r.forEach(d=>d.getAllOverrideIdentifiers().forEach(S=>f.add(S))),[...f.values()]}D(f){const d=new Set;return this.j.getKeysForOverrideIdentifier(f).forEach(S=>d.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(f).forEach(S=>d.add(S)),this.q.getKeysForOverrideIdentifier(f).forEach(S=>d.add(S)),this.r.forEach(S=>S.getKeysForOverrideIdentifier(f).forEach(E=>d.add(E))),[...d.values()]}static parse(f,d){const S=this.E(f.defaults,d),E=this.E(f.policy,d),y=this.E(f.application,d),C=this.E(f.user,d),O=this.E(f.workspace,d),p=f.folders.reduce((w,M)=>(w.set(s.URI.revive(M[0]),this.E(M[1],d)),w),new R.$Fc);return new i(S,E,y,C,r.createEmptyModel(d),O,p,r.createEmptyModel(d),new R.$Fc,d)}static E(f,d){return new r(f.contents,f.keys,f.overrides,void 0,d)}}e.$Zo=i;function n(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const f=new Set,d=new Map;for(const E of g)E.keys.forEach(y=>f.add(y)),E.overrides.forEach(([y,C])=>{const O=(0,R.$Cc)(d,y,new Set);C.forEach(p=>O.add(p))});const S=[];return d.forEach((E,y)=>S.push([y,[...E.values()]])),{keys:[...f.values()],overrides:S}}class t{constructor(f,d,S,E,y){this.change=f,this.f=d,this.g=S,this.h=E,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of f.keys)this.affectedKeys.add(C);for(const[,C]of f.overrides)for(const O of C)this.affectedKeys.add(O);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(f,d){const S=this.a+f,E=this.d.indexOf(S);if(E<0)return!1;const y=E+S.length;if(y>=this.d.length)return!1;const C=this.d.charCodeAt(y);if(C!==this.b&&C!==this.c)return!1;if(d){const O=this.previousConfiguration?this.previousConfiguration.getValue(f,d,this.f?.workspace):void 0,p=this.g.getValue(f,d,this.h);return!T.$qo(O,p)}return!0}}e.$2o=t;function o(g,f){const{added:d,removed:S,updated:E}=l(f?.rawConfiguration,g?.rawConfiguration),y=[],C=g?.getAllOverrideIdentifiers()||[],O=f?.getAllOverrideIdentifiers()||[];if(f){const p=O.filter(w=>!C.includes(w));for(const w of p)y.push([w,f.getKeysForOverrideIdentifier(w)])}if(g){const p=C.filter(w=>!O.includes(w));for(const w of p)y.push([w,g.getKeysForOverrideIdentifier(w)])}if(f&&g){for(const p of C)if(O.includes(p)){const w=l({contents:g.getOverrideValue(void 0,p)||{},keys:g.getKeysForOverrideIdentifier(p)},{contents:f.getOverrideValue(void 0,p)||{},keys:f.getKeysForOverrideIdentifier(p)});y.push([p,[...w.added,...w.removed,...w.updated]])}}return{added:d,removed:S,updated:E,overrides:y}}function l(g,f){const d=g?f?g.keys.filter(y=>f.keys.indexOf(y)===-1):[...g.keys]:[],S=f?g?f.keys.filter(y=>g.keys.indexOf(y)===-1):[...f.keys]:[],E=[];if(g&&f){for(const y of f.keys)if(g.keys.indexOf(y)!==-1){const C=(0,I.$mj)(f.contents,y),O=(0,I.$mj)(g.contents,y);T.$qo(C,O)||E.push(y)}}return{added:d,removed:S,updated:E}}}),define(Re[110],Oe([1,0,12,3]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.RemoteAuthorityResolverErrorCode=e.$Yl=e.$Xl=e.RemoteConnectionType=e.$Wl=void 0,e.$1l=s,e.$Wl=(0,D.$Ki)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class L{constructor(b){this.id=b,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Xl=L;class R{constructor(b,u){this.host=b,this.port=u,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Yl=R;var T;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class m extends v.$fb{static isNotAvailable(b){return b instanceof m&&b._code===T.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof m&&b._code===T.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof m&&b._code===T.NoResolverFound}static isInvalidAuthority(b){return b instanceof m&&b._code===T.InvalidAuthority}static isHandled(b){return b instanceof m&&b.isHandled}constructor(b,u=T.Unknown,k){super(b),this._message=b,this._code=u,this._detail=k,this.isHandled=u===T.NotAvailable&&k===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Zl=m;function s(I){const b=I.indexOf("+");return b===-1?I:I.substring(0,b)}}),define(Re[62],Oe([1,0,15]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=D,e.$qn=P,e.$rn=L,e.$sn=R;function D(m){return m.scheme===v.Schemas.vscodeRemote?m.authority:void 0}function P(m){if(!m)return;const s=m.indexOf("+");return s<0?m:m.substr(0,s)}function L(m){const{host:s,port:I}=T(m);if(typeof I>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:I}}function R(m,s){let{host:I,port:b}=T(m);return typeof b>"u"&&(b=s),{host:I,port:b}}function T(m){const s=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const I=m.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const b=m.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:m,port:void 0}}}),define(Re[18],Oe([1,0,13,3,62]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=e.$Bn=e.$An=e.$zn=e.TargetPlatform=e.ExtensionType=e.$yn=e.$wn=e.$vn=e.$un=e.$tn=void 0,e.$xn=L,e.$Cn=b,e.$Dn=u,e.$En=k,e.$Fn=$,e.$Gn=r,e.$Hn=a,v=Ve(v),e.$tn="extensions.user.cache",e.$un="extensions.builtin.cache",e.$vn="undefined_publisher",e.$wn=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$yn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(R||(e.ExtensionType=R={}));var T;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class m{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,i){if(typeof c>"u"||c===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof c=="string"||typeof i=="string"){const n=typeof c=="string"?c:c.value,t=typeof i=="string"?i:i.value;return v.$Kf(n,t)}return c._lower===i._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$zn=m;class s{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const i of c)this.add(i)}add(c){this.c.add(m.toKey(c))}delete(c){return this.c.delete(m.toKey(c))}has(c){return this.c.has(m.toKey(c))}}e.$An=s;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(m.toKey(c))}get(c){return this.c.get(m.toKey(c))}has(c){return this.c.has(m.toKey(c))}set(c,i){this.c.set(m.toKey(c),i)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Bn=I;function b(h){return u(h)}function u(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function k(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function $(h,c){if(c){const i=`onResolveRemoteAuthority:${(0,P.$qn)(c)}`;return!!h.activationEvents?.includes(i)}return!1}function r(h){return h.map(c=>{const[i,n]=c.split("@");return{proposalName:i,version:n?parseInt(n):void 0}})}function a(h){return h.map(c=>c.split("@")[0])}e.$In=(0,D.$Ki)("IBuiltinExtensionsScannerService")}),define(Re[111],Oe([1,0,23,9,18,3]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.ExtensionManagementErrorCode=e.$up=e.ExtensionGalleryErrorCode=e.$tp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=void 0,e.$np=T,e.$op=m,e.$pp=s,e.$qp=I,e.$rp=b,e.$sp=u,e.$gp="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$hp=new RegExp(e.$gp),e.$ip="__web_extension",e.$jp="skipWalkthrough",e.$kp="extensionInstallSource",e.$lp="dependecyOrPackExtensionInstall",e.$mp="clientTargetPlatform";var R;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function T(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function m(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function s(t,o){switch(t){case v.Platform.Windows:return o==="x64"?P.TargetPlatform.WIN32_X64:o==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Linux:return o==="x64"?P.TargetPlatform.LINUX_X64:o==="arm64"?P.TargetPlatform.LINUX_ARM64:o==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?P.TargetPlatform.ALPINE_X64:o==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Mac:return o==="x64"?P.TargetPlatform.DARWIN_X64:o==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Web:return P.TargetPlatform.WEB}}function I(t,o){return o===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function b(t,o,l){return I(o,l)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===l}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var k;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var $;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})($||(e.SortOrder=$={}));var r;(function(t){t.Install="install",t.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var a;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(a||(e.InstallOperation=a={})),e.$tp=(0,L.$Ki)("extensionGalleryService");var h;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})(h||(e.ExtensionGalleryErrorCode=h={}));class c extends Error{constructor(o,l){super(o),this.code=l,this.name=l}}e.$up=c;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class n extends Error{constructor(o,l){super(o),this.code=l,this.name=l}}e.$vp=n,e.$wp=(0,L.$Ki)("extensionManagementService"),e.$xp="extensionsIdentifiers/disabled",e.$yp="extensionsIdentifiers/enabled",e.$zp=(0,L.$Ki)("IGlobalExtensionEnablementService"),e.$Ap=(0,L.$Ki)("IExtensionTipsService"),e.$Bp=(0,D.localize2)(1781,"Extensions"),e.$Cp=(0,D.localize2)(1782,"Preferences")}),define(Re[112],Oe([1,0,12,18]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jH=e.$iH=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,T){this.a.set(R,T)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const T=Object.create(null);for(const m of R){const s=this.readActivationEvents(m);s.length>0&&(T[D.$zn.toKey(m.identifier)]=s)}return T}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const T=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let m=0;m<T.length;m++)T[m]==="onUri"&&(T[m]=`onUri:${D.$zn.toKey(R.identifier)}`);if(!R.contributes)return T;for(const m in R.contributes){const s=this.a.get(m);if(!s)continue;const I=R.contributes[m],b=Array.isArray(I)?I:[I];try{s(b,T)}catch(u){(0,v.$4)(u)}}return T}}e.$iH=P,e.$jH=new P});var oi=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Re[176],Oe([1,0,24,37,9,281,18,105]),function(be,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=I,e.$9p=b,e.$0p=u,e.$$p=k,e.$_p=$,e.$aq=r,e.$bq=a,e.$cq=h,D=oi(D),P=Ve(P),L=Ve(L);const m=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function I(n){return n=n.trim(),n==="*"||m.test(n)}function b(n){if(!I(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=n.match(m);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(n){if(!n)return null;const t=n.majorBase,o=n.majorMustEqual,l=n.minorBase;let g=n.minorMustEqual;const f=n.patchBase;let d=n.patchMustEqual;n.hasCaret&&(t===0||(g=!1),d=!1);let S=0;if(n.preRelease){const E=s.exec(n.preRelease);if(E){const[,y,C,O]=E;S=Date.UTC(Number(y),Number(C)-1,Number(O))}}return{majorBase:t,majorMustEqual:o,minorBase:l,minorMustEqual:g,patchBase:f,patchMustEqual:d,isMinimum:n.hasGreaterEquals,notBefore:S}}function k(n,t,o){let l;typeof n=="string"?l=u(b(n)):l=n;let g;t instanceof Date?g=t.getTime():typeof t=="string"&&(g=new Date(t).getTime());let f;if(typeof o=="string"?f=u(b(o)):f=o,!l||!f)return!1;const d=l.majorBase,S=l.minorBase,E=l.patchBase;let y=f.majorBase,C=f.minorBase,O=f.patchBase;const p=f.notBefore;let w=f.majorMustEqual,M=f.minorMustEqual,A=f.patchMustEqual;return f.isMinimum?d>y?!0:d<y?!1:S>C?!0:S<C||g&&g<p?!1:E>=O:(d===1&&y===0&&(!w||!M||!A)&&(y=1,C=0,O=0,w=!0,M=!1,A=!1),d<y?!1:d>y?!w:S<C?!1:S>C?!M:E<O?!1:E>O?!A:!(g&&g<p))}function $(n,t,o,l,g,f){const d=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return d.push([D.default.Error,P.localize(1833,null)]),d;if(typeof l.name!="string")return d.push([D.default.Error,P.localize(1834,null,"name")]),d;if(typeof l.version!="string")return d.push([D.default.Error,P.localize(1835,null,"version")]),d;if(!l.engines)return d.push([D.default.Error,P.localize(1836,null,"engines")]),d;if(typeof l.engines.vscode!="string")return d.push([D.default.Error,P.localize(1837,null,"engines.vscode")]),d;if(typeof l.extensionDependencies<"u"&&!i(l.extensionDependencies))return d.push([D.default.Error,P.localize(1838,null,"extensionDependencies")]),d;if(typeof l.activationEvents<"u"){if(!i(l.activationEvents))return d.push([D.default.Error,P.localize(1839,null,"activationEvents")]),d;if(typeof l.main>"u"&&typeof l.browser>"u")return d.push([D.default.Error,P.localize(1840,null,"activationEvents","main","browser")]),d}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&d.push([D.default.Warning,P.localize(1841,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return d.push([D.default.Error,P.localize(1842,null,"main")]),d;{const y=(0,v.$lh)(o,l.main);(0,v.$fh)(y,o)||d.push([D.default.Warning,P.localize(1843,null,y.path,o.path)])}}if(typeof l.browser<"u"){if(typeof l.browser!="string")return d.push([D.default.Error,P.localize(1844,null,"browser")]),d;{const y=(0,v.$lh)(o,l.browser);(0,v.$fh)(y,o)||d.push([D.default.Warning,P.localize(1845,null,y.path,o.path)])}}if(!L.valid(l.version))return d.push([D.default.Error,P.localize(1846,null)]),d;const S=[];if(!r(n,t,l,g,S))for(const y of S)d.push([D.default.Error,y]);if(f&&l.enabledApiProposals?.length){const y=[];if(!h([...l.enabledApiProposals],y))for(const C of y)d.push([D.default.Error,C])}return d}function r(n,t,o,l,g){return l||typeof o.main>"u"&&typeof o.browser>"u"?!0:c(n,t,o.engines.vscode,g)}function a(n,t,o){return n==="*"||c(t,o,n)}function h(n,t){if(n.length===0)return!0;const o=Array.isArray(t)?t:void 0,l=(o?void 0:t)??T.allApiProposals,g=[],f=(0,R.$Gn)(n);for(const{proposalName:d,version:S}of f){const E=l[d];E&&S&&E.version!==S&&g.push(P.localize(1847,null,d))}return o?.push(...g),g.length===0}function c(n,t,o,l=[]){const g=u(b(o));if(!g)return l.push(P.localize(1848,null,o)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return l.push(P.localize(1849,null,o)),!1}else if(!g.majorMustEqual)return l.push(P.localize(1850,null,o)),!1;return k(n,t,g)?!0:(l.push(P.localize(1851,null,n,o)),!1)}function i(n){if(!Array.isArray(n))return!1;for(let t=0,o=n.length;t<o;t++)if(typeof n[t]!="string")return!1;return!0}}),define(Re[177],Oe([1,0,20,12,4,9,53,3,11,29]),function(be,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0,e.$fq=u,e.$gq=k,e.$hq=$,e.$iq=r,e.$jq=a,e.$kq=h,e.$dq=(0,T.$Ki)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const o in this.b)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.b[o];this.a=t}return this.a}}class b extends P.$Zc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,L.localize)(2051,null),when:m.$xk.isEqualTo((0,m.$uk)(m.LogLevel.Trace)).serialize()})}async c(t,o,l){const g=`${t} #${++this.b}: ${o.url}`;this.a.trace(`${g} - begin`,o.type,new I(o.headers??{}));try{const f=await l();return this.a.trace(`${g} - end`,o.type,f.res.statusCode,f.res.headers),f}catch(f){throw this.a.error(`${g} - error`,o.type,(0,D.$bb)(f)),f}}}e.$eq=b;function u(n){return n.res.statusCode&&n.res.statusCode>=200&&n.res.statusCode<300||n.res.statusCode===1223}function k(n){return n.res.statusCode===204}async function $(n){return k(n)?null:(await(0,v.$5e)(n.stream)).toString()}async function r(n){if(!u(n))throw new Error("Server returned "+n.res.statusCode);return $(n)}async function a(n){if(!u(n))throw new Error("Server returned "+n.res.statusCode);if(k(n))return null;const o=(await(0,v.$5e)(n.stream)).toString();try{return JSON.parse(o)}catch(l){throw l.message+=`:
`+o,l}}function h(n){i(n)}let c;function i(n){const t=s.$zo.as(R.$Eo.Configuration),o=c;c={id:"http",order:15,title:(0,L.localize)(2052,null),type:"object",scope:n,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2053,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2054,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(2055,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,L.localize)(2056,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(2057,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(2058,null),(0,L.localize)(2059,null),(0,L.localize)(2060,null),(0,L.localize)(2061,null)],default:"override",description:(0,L.localize)(2062,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(2063,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(2064,null),restricted:!0}}},t.updateConfigurations({add:[c],remove:o?[o]:[]})}i(R.ConfigurationScope.APPLICATION)}),define(Re[178],Oe([1,0,23,79,33]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=R,e.$Ep=T;function L(m){if(v.$x===v.Platform.Linux&&/^penguin(\.|$)/i.test(m))return"chromebook"}function R(m,s,I,b,u,k,$,r,a,h){const c=Object.create(null);c["common.machineId"]=k,c["common.sqmId"]=$,c["common.devDeviceId"]=r,c.sessionID=(0,P.$7g)()+Date.now(),c.commitHash=b,c.version=u,c["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,v.$k)(v.$x),c["common.nodePlatform"]=D.$ic,c["common.nodeArch"]=I,c["common.product"]=h||"desktop",a&&(c["common.msftInternal"]=a);let i=0;const n=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$o&&(c["common.snap"]="true");const t=L(s);return t&&(c["common.platformDetail"]=t),c}function T(m){const s=D.env.USERDNSDOMAIN;if(!s)return!1;const I=s.toLowerCase();return m.some(b=>I===b)}}),define(Re[113],Oe([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em=(0,v.$Ki)("telemetryService"),e.$fm=(0,v.$Ki)("customEndpointTelemetryService"),e.$gm="telemetry.currentSessionDate",e.$hm="telemetry.firstSessionDate",e.$im="telemetry.lastSessionDate",e.$jm="telemetry.machineId",e.$km="telemetry.sqmId",e.$lm="telemetry.devDeviceId",e.$mm="telemetry",e.$nm="telemetry.telemetryLevel",e.$om="telemetry.enableCrashReporter",e.$pm="telemetry.enableTelemetry";var D;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var P;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Re[63],Oe([1,0,25,14,62,178,113]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0,e.$Mp=I,e.$Np=b,e.$Op=u,e.$Pp=k,e.$Qp=r,e.$Rp=h,e.$Sp=c,e.$Tp=t;class T{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$Fp=T;class m{constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Gp=m,e.$Hp=new m;class s{async publicLog(l,g,f){}async publicLogError(l,g,f){}}e.$Ip=s,e.$Jp="telemetry",e.$Kp="extensionTelemetryLog",e.$Lp={log:()=>null,flush:()=>Promise.resolve(null)};function I(o,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!o.enableTelemetry)}function b(o,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function u(o){const l=o.getValue(R.$nm),g=o.getValue(R.$om);if(o.getValue(R.$pm)===!1||g===!1)return R.TelemetryLevel.NONE;switch(l??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function k(o){const l={},g={},f={};a(o,f);for(let d in f){d=d.length>150?d.substr(d.length-149):d;const S=f[d];typeof S=="number"?g[d]=S:typeof S=="boolean"?g[d]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${S.length}`),l[d]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(l[d]=S)}return{properties:l,measurements:g}}const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(o){if(!o)return"none";const l=(0,P.$qn)(o);return $.has(l)?l:"other"}function a(o,l,g=0,f){if(o)for(const d of Object.getOwnPropertyNames(o)){const S=o[d],E=f?f+d:d;Array.isArray(S)?l[E]=(0,v.$ro)(S):S instanceof Date?l[E]=S.toISOString():(0,D.$lg)(S)?g<2?a(S,l,g+1,E+"."):l[E]=(0,v.$ro)(S):l[E]=S}}function h(o,l){const g=o.msftInternalDomains||[],f=l.getValue("telemetry.internalTesting");return(0,L.$Ep)(g)||f}function c(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,l){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let g=o;const f=[];for(const y of l)for(;;){const C=y.exec(o);if(!C)break;f.push([C.index,y.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(g="";;){const y=S.exec(o);if(!y)break;const C=f.some(([O,p])=>y.index<p&&O<S.lastIndex);!d.test(y[0])&&!C&&(g+=o.substring(E,y.index)+"<REDACTED: user-file-path>",E=S.lastIndex)}return E<o.length&&(g+=o.substr(E)),g}function n(o){if(!o)return o;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of l)if(g.regex.test(o))return`<REDACTED: ${g.label}>`;return o}function t(o,l){return(0,v.$oo)(o,g=>{if(g instanceof T||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let f=g.replaceAll("%20"," ");f=i(f,l);for(const d of l)f=f.replace(d,"");return f=n(f),f}})}}),define(Re[179],Oe([1,0,13,111,18,23,2,12,79,63]),function(be,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$Vp=void 0,e.$Up=I,e.$Wp=$,e.$Xp=r,e.$Yp=a,e.$Zp=h,e.$1p=c,e.$2p=i,e.$3p=n,e.$5p=t,e.$6p=l;function I(g,f){return g.uuid&&f.uuid?g.uuid===f.uuid:g.id===f.id?!0:(0,v.$Ff)(g.id,f.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(f){const d=f.manifest?f.manifest.version:f.version,S=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new u(f.identifier,d,S)}static parse(f){const d=b.exec(f);return d&&d[1]&&d[2]?new u({id:d[1]},d[2],d[4]||void 0):null}constructor(f,d,S=P.TargetPlatform.UNDEFINED){this.identifier=f,this.version=d,this.targetPlatform=S,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof u?I(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.$Vp=u;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(g){const f=k.exec(g);return f&&f[1]?[a(f[1]),f[2]]:[a(g),void 0]}function r(g,f){return`${g}.${f}`}function a(g){return g.toLowerCase()}function h(g,f){return a(r(g??P.$vn,f))}function c(g,f){const d=[],S=E=>{for(const y of d)if(y.some(C=>I(f(C),f(E))))return y;return null};for(const E of g){const y=S(E);y?y.push(E):d.push([E])}return d}function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}function n(g){return{id:new s.$Fp(g.identifier.id),name:new s.$Fp(g.name),version:g.version,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),isSigned:g.isSigned,...g.telemetryData}}e.$4p=new P.$zn("pprice.better-merge");function t(g,f){const d=[],S=f.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const E=S.shift();if(E&&d.every(y=>!I(y.identifier,{id:E}))){const y=g.filter(C=>I(C.identifier,{id:E}));y.length===1&&(d.push(y[0]),S.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}async function o(g,f){if(!L.$n)return!1;let d;try{d=(await g.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await g.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(E){f.debug("Error while getting the os-release file.",(0,T.$bb)(E))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(g,f){const d=await o(g,f),S=(0,D.$pp)(d?"alpine":L.$x,m.$jc);return f.debug("ComputeTargetPlatform:",S),S}}),define(Re[180],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=v,e.$Qs=D,e.$Rs=P,e.$Ss=L,e.$Ts=R,e.$Us=T;function v(m){return[...m.entries()]}function D(m){return m?[...m.entries()]:[]}function P(m){return new Map(m)}function L(m){return new Map(m??[])}function R(m){return Array.from(m.entries()).map(s=>[s[0],v(s[1].map),D(s[1].descriptionMap)])}function T(m){return new Map(m.map(s=>[s[0],{map:P(s[1]),descriptionMap:L(s[2])}]))}}),define(Re[181],Oe([1,0,3,31,29]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=e.$Bs=e.$As=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$zs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ys=void 0,e.$ys=new D.$2j("terminalTabFocusMode",!1,!0);var L;(function(o){o.AutomationProfile="terminal.integrated.automationProfile.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(L||(e.TerminalSettingPrefix=L={}));var R;(function(o){o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationProfileLinux="terminal.integrated.automationProfile.linux",o.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",o.AutomationProfileWindows="terminal.integrated.automationProfile.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsDefaultColor="terminal.integrated.tabs.defaultColor",o.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.TabStopWidth="terminal.integrated.tabStopWidth",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorStyleInactive="terminal.integrated.cursorStyleInactive",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.TerminalTitleSeparator="terminal.integrated.tabs.separator",o.TerminalTitle="terminal.integrated.tabs.title",o.TerminalDescription="terminal.integrated.tabs.description",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.MiddleClickBehavior="terminal.integrated.middleClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.EnableVisualBell="terminal.integrated.enableVisualBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.TabFocusMode="terminal.integrated.tabFocusMode",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",o.HideOnStartup="terminal.integrated.hideOnStartup",o.CustomGlyphs="terminal.integrated.customGlyphs",o.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover",o.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",o.AutoReplies="terminal.integrated.autoReplies",o.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",o.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",o.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",o.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",o.EnableImages="terminal.integrated.enableImages",o.SmoothScrolling="terminal.integrated.smoothScrolling",o.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",o.FocusAfterRun="terminal.integrated.focusAfterRun",o.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",o.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",o.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var T;(function(o){o.Bash="bash",o.Fish="fish",o.Sh="sh",o.Csh="csh",o.Ksh="ksh",o.Zsh="zsh"})(T||(e.PosixShellType=T={}));var m;(function(o){o.CommandPrompt="cmd",o.Wsl="wsl",o.GitBash="gitbash"})(m||(e.WindowsShellType=m={}));var s;(function(o){o.PowerShell="pwsh",o.Python="python",o.Julia="julia",o.NuShell="nu"})(s||(e.GeneralShellType=s={}));var I;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence",o[o.Config=3]="Config"})(I||(e.TitleEventSource=I={}));var b;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.PtyHostWindow="ptyHostWindow",o.Logger="logger",o.Heartbeat="heartbeat"})(b||(e.TerminalIpcChannels=b={}));var u;(function(o){o.Cwd="cwd",o.InitialCwd="initialCwd",o.FixedDimensions="fixedDimensions",o.Title="title",o.ShellType="shellType",o.HasChildProcesses="hasChildProcesses",o.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",o.OverrideDimensions="overrideDimensions",o.FailedShellIntegrationActivation="failedShellIntegrationActivation",o.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(u||(e.ProcessPropertyType=u={})),e.$zs=(0,v.$Ki)("ptyService");var k;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k||(e.HeartbeatConstants=k={}));var $;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})($||(e.TerminalLocation=$={}));var r;(function(o){o.TerminalView="view",o.Editor="editor"})(r||(e.TerminalLocationString=r={}));var a;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var h;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(h||(e.FlowControlConstants=h={}));var c;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var i;(function(o){o[o.Off=0]="Off",o[o.FinalTerm=1]="FinalTerm",o[o.VSCode=2]="VSCode"})(i||(e.ShellIntegrationStatus=i={}));var n;(function(o){o[o.Unknown=0]="Unknown",o[o.Shutdown=1]="Shutdown",o[o.Process=2]="Process",o[o.User=3]="User",o[o.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$As={Backend:"workbench.contributions.terminal.processBackend"};class t{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(l){const g=this.b(l.remoteAuthority);if(this.a.has(g))throw new Error(`A terminal backend with remote authority '${g}' was already registered.`);this.a.set(g,l)}getTerminalBackend(l){return this.a.get(this.b(l))}b(l){return l?.toLowerCase()??""}}P.$zo.add(e.$As.Backend,new t),e.$Bs=(0,v.$Ki)("localPtyService"),e.$Cs=(0,v.$Ki)("terminalLogService")}),define(Re[182],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dAb=void 0;class v{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,L,R=5){const T=L(m=>{const s=typeof m=="string"?m:m.data;let I=this.a.get(P);if(I){I.data.push(s);return}const b=setTimeout(()=>this.flushBuffer(P),R);I={data:[s],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(P),T.dispose()}},this.a.set(P,I)});return T}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const L=this.a.get(P);L&&(this.a.delete(P),this.b(P,L.data.join("")))}}e.$dAb=v}),define(Re[183],Oe([1,0,10,98,282,36,6,14,2,9,78,29]),function(be,e,v,D,P,L,R,T,m,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tx=e.$Sx=e.$Rx=e.$Qx=e.$Px=e.$Ox=e.IconFontDefinition=e.IconContribution=e.$Lx=void 0,e.$Mx=a,e.$Nx=h,b=Ve(b),e.$Lx={IconContribution:"base.contributions.icons"};var u;(function(t){function o(l,g){let f=l.defaults;for(;L.ThemeIcon.isThemeIcon(f);){const d=r.getIcon(f.id);if(!d)return;f=d.defaults}return f}t.getDefinition=o})(u||(e.IconContribution=u={}));var k;(function(t){function o(g){return{weight:g.weight,style:g.style,src:g.src.map(f=>({format:f.format,location:f.location.toString()}))}}t.toJSONObject=o;function l(g){const f=d=>(0,T.$jg)(d)?d:void 0;if(g&&Array.isArray(g.src)&&g.src.every(d=>(0,T.$jg)(d.format)&&(0,T.$jg)(d.location)))return{weight:f(g.weight),style:f(g.style),src:g.src.map(d=>({format:d.format,location:m.URI.parse(d.location)}))}}t.fromJSONObject=l})(k||(e.IconFontDefinition=k={}));class ${constructor(){this.a=new R.$qe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,s.localize)(2365,null)},fontCharacter:{type:"string",description:(0,s.localize)(2366,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${L.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,l,g,f){const d=this.b[o];if(d){if(g&&!d.description){d.description=g,this.d.properties[o].markdownDescription=`${g} $(${o})`;const y=this.e.enum.indexOf(o);y!==-1&&(this.e.enumDescriptions[y]=g),this.a.fire()}return d}const S={id:o,description:g,defaults:l,deprecationMessage:f};this.b[o]=S;const E={$ref:"#/definitions/icons"};return f&&(E.deprecationMessage=f),g&&(E.markdownDescription=`${g}: $(${o})`),this.d.properties[o]=E,this.e.enum.push(o),this.e.enumDescriptions.push(g||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const l=this.e.enum.indexOf(o);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,l){const g=this.f[o];return g||(this.f[o]=l,this.a.fire(),l)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(d,S)=>d.id.localeCompare(S.id),l=d=>{for(;L.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.b).map(d=>this.b[d]);for(const d of f.filter(S=>!!S.description).sort(o))g.push(`|<i class="${l(d)}"></i>|${d.id}|${L.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const d of f.filter(S=>!L.ThemeIcon.isThemeIcon(S.defaults)).sort(o))g.push(`|<i class="${l(d)}"></i>|${d.id}|`);return g.join(`
`)}}const r=new $;b.$zo.add(e.$Lx.IconContribution,r);function a(t,o,l,g){return r.registerIcon(t,o,l,g)}function h(){return r}function c(){const t=(0,P.$6j)();for(const o in t){const l="\\"+t[o].toString(16);r.registerIcon(o,{fontCharacter:l})}}c(),e.$Ox="vscode://schemas/icons";const i=b.$zo.as(I.$Ao.JSONContribution);i.registerSchema(e.$Ox,r.getIconSchema());const n=new v.$Wh(()=>i.notifySchemaChanged(e.$Ox),200);r.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Px=a("widget-close",D.$0j.close,(0,s.localize)(2367,null)),e.$Qx=a("goto-previous-location",D.$0j.arrowUp,(0,s.localize)(2368,null)),e.$Rx=a("goto-next-location",D.$0j.arrowDown,(0,s.localize)(2369,null)),e.$Sx=L.ThemeIcon.modify(D.$0j.sync,"spin"),e.$Tx=L.ThemeIcon.modify(D.$0j.loading,"spin")}),define(Re[184],Oe([1,0,6,4,23,2,44,3,11]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1w=e.$Zw=e.$Ww=e.$Uw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Qw=e.$Pw=void 0,e.$Rw=b,e.$Sw=k,e.$Tw=$,e.$Vw=r,e.$Xw=a,e.$Yw=h,e.$Pw=(0,T.$Ki)("tunnelService"),e.$Qw=(0,T.$Ki)("sharedTunnelsService");var s;(function(n){n.Http="http",n.Https="https"})(s||(e.TunnelProtocol=s={}));var I;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(I||(e.TunnelPrivacyId=I={}));function b(n){return!!n.forwardPort}var u;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function k(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function $(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const o of t){const l=o.split("=")[1];if(/^https?:/.exec(l)){const g=k(L.URI.parse(l));if(g)return g}}}e.$Uw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(n){return e.$Uw.indexOf(n)>=0}e.$Ww=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(n){return e.$Ww.indexOf(n)>=0}function h(n,t,o,l){if(o===P.OperatingSystem.Windows)return!1;if(o===P.OperatingSystem.Macintosh&&a(t)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(g?.length===4&&parseInt(g[1])>=18)return!1}return n<1024}class c{constructor(t,o,l){this.remoteAddress=t,this.localAddress=o,this.b=l,this.a=new v.$qe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Zw=c;let i=class extends D.$Zc{constructor(t,o){super(),this.r=t,this.s=o,this.a=new v.$qe,this.onTunnelOpened=this.a.event,this.b=new v.$qe,this.onTunnelClosed=this.b.event,this.c=new v.$qe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],o=Array.from(this.f.values());for(const l of o){const g=Array.from(l.values());for(const f of g){const d=await f.value;d&&typeof d!="string"&&t.push(d)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:o}of t.values())await o.then(l=>typeof l!="string"?l?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,o,l,g,f){this.z(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:l,privacy:g,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(a(t)||r(t))&&(t=e.$Uw[0]);const l=this.D(t,o);if(l)return++l.refcount,l.value}openTunnel(t,o,l,g,f,d=!1,S,E){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${l} on local port ${f}.`);const y=this.g??t;if(!y)return;if(o||(o="localhost"),g||(g=this.t),this.g&&this.n.has(l)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(y,o,l,g,f,d,S,E);return C?C.then(O=>{if(O){if(typeof O=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(o,l),O}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(o,l);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.w(O);return(O.tunnelRemoteHost!==o||O.tunnelRemotePort!==l)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),S&&O.privacy!==S&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.f.get(t.tunnelRemoteHost);if(o){const l=o.get(t.tunnelRemotePort);l&&(l.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,l))}}}}async y(t,o,l){if(l.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const g=l.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(o),g}}async closeTunnel(t,o){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const l=this.f.get(t);if(l&&l.has(o)){const g=l.get(o);g.refcount=0,await this.y(t,o,g)}}z(t,o,l){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(o,{refcount:1,value:l})}async C(t,o){const l=this.f.get(t);if(l){const g=l.get(o),f=g?await g.value:void 0;(!f||typeof f=="string")&&l.delete(o),l.size===0&&this.f.delete(t)}}D(t,o){const l=[t];r(t)?(l.push(...e.$Uw),l.push(...e.$Ww)):a(t)&&l.push(...e.$Ww);const g=l.map(f=>this.f.get(f));for(const f of g){const d=f?.get(o);if(d)return d}}canTunnel(t){return!!k(t)}G(t,o,l,g,f,d,S){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${l} on local port ${g}.`);const E=l;this.n.add(E);const y=g===void 0?l:g,C={elevationRequired:f?this.isPortPrivileged(y):!1},O={remoteAddress:{host:o,port:l},localAddressPort:g,privacy:d,public:d?d!==I.Private:void 0,protocol:S},p=t.forwardPort(O,C);return p?(this.z(o,l,p),p.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(E)})):this.n.delete(E),p}};e.$1w=i,e.$1w=i=Qe([We(0,m.$fk),We(1,R.$ej)],i)}),define(Re[114],Oe([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0,e.$Pl=(0,v.$Ki)("IUriIdentityService")}),define(Re[185],Oe([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$2w=void 0,e.$2w=(0,v.$Ki)("editSessionIdentityService");var D;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(D||(e.EditSessionIdentityMatch=D={}))}),define(Re[186],Oe([1,0,15]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=D,e.$LN=P,e.$MN=L,e.$NN=R,e.$ON=T;function D(m){return m.scheme!==v.Schemas.file&&m.scheme!==v.Schemas.vscodeRemote}function P(m){if(m.folders.length)return m.folders.every(s=>D(s.uri))?m.folders[0].uri:void 0;if(m.configuration&&D(m.configuration))return m.configuration}function L(m){return P(m)?.scheme}function R(m){return P(m)?.authority}function T(m){return P(m)!==void 0}}),define(Re[49],Oe([1,0,9,22,48,24,2,3,15]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$0i=e.$9i=e.$8i=e.$7i=e.$5i=e.$4i=e.WorkbenchState=e.$Xi=e.$Wi=e.$Ti=void 0,e.$Ui=s,e.$Vi=I,e.$Yi=b,e.$Zi=u,e.$1i=k,e.$2i=r,e.$3i=a,e.$6i=i,e.$$i=n,e.$_i=t,e.$bj=o,e.$cj=l,e.$dj=g,e.$Ti=(0,T.$Ki)("contextService");function s(f){const d=f;return typeof d?.id=="string"&&R.URI.isUri(d.uri)}function I(f){return typeof f?.id=="string"&&!s(f)&&!u(f)}e.$Wi={id:"ext-dev"},e.$Xi={id:"empty-window"};function b(f,d){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,D.$sc)(f)}:d?e.$Wi:e.$Xi;const S=f;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function u(f){const d=f;return typeof d?.id=="string"&&R.URI.isUri(d.configPath)}function k(f){const d=f;if(d?.uri)return{id:d.id,uri:R.URI.revive(d.uri)};const S=f;if(S?.configPath)return{id:S.id,configPath:R.URI.revive(S.configPath)};if(f?.id)return{id:f.id}}var $;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function r(f){const d=f;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}function a(f){const d=f;return!!(d&&typeof d=="object"&&R.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}class h{constructor(d,S,E,y,C){this.h=d,this.j=E,this.k=y,this.l=C,this.c=P.$Qi.forUris(this.l,()=>!0),this.folders=S}update(d){this.h=d.id,this.k=d.configuration,this.j=d.transient,this.l=d.l,this.folders=d.folders}get folders(){return this.g}set folders(d){this.g=d,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(d){this.k=d}getFolder(d){return d&&this.c.findSubstr(d)||null}n(){this.c=P.$Qi.forUris(this.l,()=>!0);for(const d of this.folders)this.c.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$4i=h;class c{constructor(d,S){this.raw=S,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,L.$lh)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$5i=c;function i(f){return new c({uri:f,index:0,name:(0,L.$hh)(f)},{uri:f.toString()})}e.$7i="code-workspace",e.$8i=`.${e.$7i}`,e.$9i=[{name:(0,v.localize)(2490,null),extensions:[e.$7i]}],e.$0i="workspace.json";function n(f,d){return L.$ch.isEqualOrParent(f,d.untitledWorkspacesHome)}function t(f){let d;return R.URI.isUri(f)?d=f:d=f.configuration,d?.scheme===m.Schemas.tmp}e.$aj="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(f){return f.id===e.$aj}function l(f,d){return!n(f,d)&&!t(f)}function g(f){return(typeof f=="string"?(0,D.$tc)(f):(0,L.$jh)(f))===e.$8i}}),define(Re[115],Oe([1,0,76,6,4,24,2,9,107,28,3,11,49,27,114,10,33,13,14]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Rl=e.ProfileResourceType=void 0,e.$Ql=n,e.$Sl=t,e.$Tl=o;var i;(function(f){f.Settings="settings",f.Keybindings="keybindings",f.Snippets="snippets",f.Tasks="tasks",f.Extensions="extensions",f.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function n(f){const d=f;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&typeof d.isDefault=="boolean"&&typeof d.name=="string"&&R.URI.isUri(d.location)&&R.URI.isUri(d.globalStorageHome)&&R.URI.isUri(d.settingsResource)&&R.URI.isUri(d.keybindingsResource)&&R.URI.isUri(d.tasksResource)&&R.URI.isUri(d.snippetsHome)&&R.URI.isUri(d.extensionsResource))}e.$Rl=(0,I.$Ki)("IUserDataProfilesService");function t(f,d){return{id:f.id,isDefault:f.isDefault,name:f.name,shortName:f.shortName,icon:f.icon,location:R.URI.revive(f.location).with({scheme:d}),globalStorageHome:R.URI.revive(f.globalStorageHome).with({scheme:d}),settingsResource:R.URI.revive(f.settingsResource).with({scheme:d}),keybindingsResource:R.URI.revive(f.keybindingsResource).with({scheme:d}),tasksResource:R.URI.revive(f.tasksResource).with({scheme:d}),snippetsHome:R.URI.revive(f.snippetsHome).with({scheme:d}),extensionsResource:R.URI.revive(f.extensionsResource).with({scheme:d}),cacheHome:R.URI.revive(f.cacheHome).with({scheme:d}),useDefaultFlags:f.useDefaultFlags,isTransient:f.isTransient}}function o(f,d,S,E,y,C){return{id:f,name:d,location:S,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:C&&y?.useDefaultFlags?.globalState?C.globalStorageHome:(0,L.$lh)(S,"globalStorage"),settingsResource:C&&y?.useDefaultFlags?.settings?C.settingsResource:(0,L.$lh)(S,"settings.json"),keybindingsResource:C&&y?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,L.$lh)(S,"keybindings.json"),tasksResource:C&&y?.useDefaultFlags?.tasks?C.tasksResource:(0,L.$lh)(S,"tasks.json"),snippetsHome:C&&y?.useDefaultFlags?.snippets?C.snippetsHome:(0,L.$lh)(S,"snippets"),extensionsResource:C&&y?.useDefaultFlags?.extensions?C.extensionsResource:(0,L.$lh)(S,"extensions.json"),cacheHome:(0,L.$lh)(E,f),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let l=class extends P.$Zc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(d,S,E,y){super(),this.t=d,this.u=S,this.w=E,this.y=y,this.f=!0,this.h=this.B(new D.$qe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$qe),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$qe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$qe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new k.$Fc,workspaces:new k.$Fc,emptyWindows:new Map},this.profilesHome=(0,L.$lh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$lh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(d){this.f!==d&&(this.z=void 0,this.f=d)}isEnabled(){return this.f}get C(){if(!this.z){const d=this.D(),S=[d];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,c.$jg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}S.push(o((0,L.$ih)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},d))}}catch(C){this.y.error(C)}const E=new k.$Fc,y=new Map;if(S.length)try{const C=this.Q();if(C.workspaces)for(const[O,p]of Object.entries(C.workspaces)){const w=R.URI.parse(O),M=S.find(A=>A.id===p);M&&E.set(w,M)}if(C.emptyWindows)for(const[O,p]of Object.entries(C.emptyWindows)){const w=S.find(M=>M.id===p);w&&y.set(O,w)}}catch(C){this.y.error(C)}this.z={profiles:S,workspaces:E,emptyWindows:y}}return this.z}D(){const d=o("__default__profile__",(0,T.localize)(2443,null),this.t.userRoamingDataHome,this.g);return{...d,extensionsResource:this.S()??d.extensionsResource,isDefault:!0}}async createTransientProfile(d){const S="Temp",E=new RegExp(`${(0,h.$mf)(S)}\\s(\\d+)`);let y=0;for(const O of this.profiles){const p=E.exec(O.name),w=p?parseInt(p[1]):0;y=w>y?w:y}const C=`${S} ${y+1}`;return this.createProfile((0,v.$yj)((0,a.$7g)()).toString(16),C,{transient:!0},d)}async createNamedProfile(d,S,E){return this.createProfile((0,v.$yj)((0,a.$7g)()).toString(16),d,S,E)}async createProfile(d,S,E,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(d,S,E);return y&&await this.setProfileForWorkspace(y,C),C}async F(d,S,E){if(!(0,c.$jg)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(S);return y||(y=(async()=>{try{if(this.profiles.find(w=>w.name===S||w.id===d))throw new Error(`Profile with ${S} name already exists`);const O=o(d,S,(0,L.$lh)(this.profilesHome,d),this.g,E,this.defaultProfile);await this.u.createFolder(O.location);const p=[];return this.j.fire({profile:O,join(w){p.push(w)}}),await r.Promises.settled(p),this.I([O],[],[]),O}finally{this.r.delete(S)}})(),this.r.set(S,y)),y}async updateProfile(d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let E=this.profiles.find(y=>y.id===d.id);if(!E)throw new Error(`Profile '${d.name}' does not exist`);return E=o(E.id,S.name??E.name,E.location,this.g,{shortName:S.shortName??E.shortName,icon:S.icon===null?void 0:S.icon??E.icon,transient:S.transient??E.isTransient,useDefaultFlags:S.useDefaultFlags??E.useDefaultFlags},this.defaultProfile),this.I([],[],[E]),E}async removeProfile(d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(d.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(y=>y.id===d.id);if(!S)throw new Error(`Profile '${d.name}' does not exist`);const E=[];this.m.fire({profile:S,join(y){E.push(y)}});try{await Promise.allSettled(E)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(y){(0,s.$wl)(y)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=this.profiles.find(y=>y.id===S.id);if(!E)throw new Error(`Profile '${S.name}' does not exist`);this.L(d,E)}unsetWorkspace(d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(d,void 0,S)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const d=await this.u.resolve(this.profilesHome);await Promise.all((d.children||[]).filter(S=>S.isDirectory&&this.profiles.every(E=>!this.w.extUri.isEqual(E.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const d=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled(d.map(S=>this.removeProfile(S)))}getProfileForWorkspace(d){const S=this.G(d),E=R.URI.isUri(S)?this.C.workspaces.get(S):this.C.emptyWindows.get(S);return E||((0,u.$Ui)(d)?this.s.folders.get(d.uri):(0,u.$Zi)(d)?this.s.workspaces.get(d.configPath):this.s.emptyWindows.get(d.id))}G(d){return(0,u.$Ui)(d)?d.uri:(0,u.$Zi)(d)?d.configPath:d.id}H(d){return!!([...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.s.folders.values()].some(S=>this.w.extUri.isEqual(S.location,d.location)))}I(d,S,E){const y=[...this.profiles,...d],C=[],O=this.s.profiles;this.s.profiles=[];for(let p of y){if(p.isDefault||S.some(M=>p.id===M.id))continue;p=E.find(M=>p.id===M.id)??p;const w=O.find(M=>p.id===M.id);if(p.isTransient)this.s.profiles.push(p);else{if(w){for(const[M,A]of this.s.emptyWindows.entries())if(p.id===A.id){this.L({id:M},p);break}for(const[M,A]of this.s.workspaces.entries())if(p.id===A.id){this.L({id:"",configPath:M},p);break}for(const[M,A]of this.s.folders.entries())if(p.id===A.id){this.L({id:"",uri:M},p);break}}C.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags})}}this.P(C),this.z=void 0,this.J(d,S,E)}J(d,S,E){this.h.fire({added:d,removed:S,updated:E,all:this.profiles})}L(d,S,E){if(E=S?.isTransient?!0:E,E)(0,u.$Ui)(d)?(this.s.folders.delete(d.uri),S&&this.s.folders.set(d.uri,S)):(0,u.$Zi)(d)?(this.s.workspaces.delete(d.configPath),S&&this.s.workspaces.set(d.configPath,S)):(this.s.emptyWindows.delete(d.id),S&&this.s.emptyWindows.set(d.id,S));else{this.L(d,void 0,!0);const y=this.G(d);R.URI.isUri(y)?(this.C.workspaces.delete(y),S&&this.C.workspaces.set(y,S)):(this.C.emptyWindows.delete(y),S&&this.C.emptyWindows.set(y,S)),this.M()}}M(){const d={};for(const[E,y]of this.C.workspaces.entries())d[E.toString()]=y.id;const S={};for(const[E,y]of this.C.emptyWindows.entries())S[E.toString()]=y.id;this.R({workspaces:d,emptyWindows:S}),this.z=void 0}N(d){const S={},E=this.D();if(d.workspaces)for(const[C,O]of Object.entries(d.workspaces)){const p=R.URI.parse(O);S[C]=this.w.extUri.isEqual(p,E.location)?E.id:this.w.extUri.basename(p)}const y={};if(d.emptyWindows)for(const[C,O]of Object.entries(d.emptyWindows)){const p=R.URI.parse(O);y[C]=this.w.extUri.isEqual(p,E.location)?E.id:this.w.extUri.basename(p)}return{workspaces:S,emptyWindows:y}}O(){return[]}P(d){throw new Error("not implemented")}Q(){return{}}R(d){throw new Error("not implemented")}S(){}};e.$Ul=l,e.$Ul=l=Qe([We(0,m.$Ri),We(1,s.$fl),We(2,$.$Pl),We(3,b.$fk)],l);class g extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(d){this.a=d}Q(){return this.X}R(d){this.X=d}}e.$Vl=g}),define(Re[187],Oe([1,0,10,6,4,64,14,161,3,115]),function(be,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$sq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$qq=e.$pq=e.$oq=void 0,e.$rq=k,e.$tq=r,e.$vq=h,e.$oq="__$__isNewStorageMarker",e.$pq="__$__targetStorageMarker",e.$qq=(0,m.$Ki)("storageService");var I;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var b;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var u;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function k(c){const i=c.get(e.$pq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class $ extends P.$Zc{static{this.a=60*1e3}constructor(i={flushInterval:$.a}){super(),this.m=i,this.b=this.B(new D.$te),this.c=this.B(new D.$te),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$qe),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Wh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$1c),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,n,t){return D.Event.filter(this.b.event,o=>o.scope===i&&(n===void 0||o.key===n),t)}n(){this.j.value=(0,v.$1h)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Uc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,n){const{key:t,external:o}=n;if(t===e.$pq){switch(i){case b.APPLICATION:this.H=void 0;break;case b.PROFILE:this.F=void 0;break;case b.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:o})}w(i){this.f.fire({reason:i})}get(i,n,t){return this.P(n)?.get(i,t)}getBoolean(i,n,t){return this.P(n)?.getBoolean(i,t)}getNumber(i,n,t){return this.P(n)?.getNumber(i,t)}getObject(i,n,t){return this.P(n)?.getObject(i,t)}storeAll(i,n){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,n)})}store(i,n,t,o,l=!1){if((0,R.$sg)(n)){this.remove(i,t,l);return}this.y(()=>{this.z(i,t,o),this.P(t)?.set(i,n,l)})}remove(i,n,t=!1){this.y(()=>{this.z(i,n,void 0),this.P(n)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,n){const t=[],o=this.J(i);for(const l of Object.keys(o))o[l]===n&&t.push(l);return t}z(i,n,t,o=!1){const l=this.J(n);typeof t=="number"?l[i]!==t&&(l[i]=t,this.P(n)?.set(e.$pq,JSON.stringify(l),o)):typeof l[i]=="number"&&(delete l[i],this.P(n)?.set(e.$pq,JSON.stringify(l),o))}get D(){return this.C||(this.C=this.L(b.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(b.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(b.APPLICATION)),this.H}J(i){switch(i){case b.APPLICATION:return this.I;case b.PROFILE:return this.G;default:return this.D}}L(i){const n=this.P(i);return n?k(n):Object.create(null)}isNew(i){return this.getBoolean(e.$oq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const n=this.P(b.APPLICATION),t=this.P(b.PROFILE),o=this.P(b.WORKSPACE);switch(i){case I.NONE:await v.Promises.settled([n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await v.Promises.settled([n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(b.APPLICATION)?.items??new Map,n=this.P(b.PROFILE)?.items??new Map,t=this.P(b.WORKSPACE)?.items??new Map;return h(i,n,t,this.Q(b.APPLICATION)??"",this.Q(b.PROFILE)??"",this.Q(b.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,n){return this.w(I.NONE),(0,s.$Ql)(i)?this.R(i,n):this.S(i,n)}M(i,n){return!(i.id===n.id||r(n)&&r(i))}N(i,n,t){this.y(()=>{const o=new Set;for(const[l,g]of i)o.add(l),n.get(l)!==g&&this.u(t,{key:l,external:!0});for(const[l]of n.items)o.has(l)||this.u(t,{key:l,external:!0})})}}e.$sq=$;function r(c){return c.isDefault||!!c.useDefaultFlags?.globalState}class a extends ${constructor(){super(),this.U=this.B(new T.$mq(new T.$nq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$mq(new T.$nq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$mq(new T.$nq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(b.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(b.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(b.APPLICATION,i)))}P(i){switch(i){case b.APPLICATION:return this.U;case b.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case b.APPLICATION:return"inMemory (application)";case b.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$uq=a;async function h(c,i,n,t,o,l){const g=w=>{try{return JSON.parse(w)}catch{return w}},f=new Map,d=new Map;c.forEach((w,M)=>{f.set(M,w),d.set(M,g(w))});const S=new Map,E=new Map;i.forEach((w,M)=>{S.set(M,w),E.set(M,g(w))});const y=new Map,C=new Map;n.forEach((w,M)=>{y.set(M,w),C.set(M,g(w))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const O=[];if(f.forEach((w,M)=>{O.push({key:M,value:w})}),console.table(O),console.groupEnd(),console.log(d),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const w=[];S.forEach((M,A)=>{w.push({key:A,value:M})}),console.table(w),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${l})`);const p=[];y.forEach((w,M)=>{p.push({key:M,value:w})}),console.table(p),console.groupEnd(),console.log(C)}}),define(Re[80],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0;class v{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const L=this.c++;return this.b.set(L,P),this.e(),L}get(P,L){return this.b.has(P)?this.b.get(P)[L]:void 0}delete(P){this.b.delete(P),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$5qc=v}),define(Re[50],Oe([1,0,15,24,28,3]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=e.$0qc=void 0;class R{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new D.$ah(m=>{const s=this.b.get(m.scheme);return!(s===void 0||s&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(m,s){s===null?this.b.delete(m.scheme):this.b.set(m.scheme,s)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$0qc=R,e.$$qc=(0,L.$Ki)("IExtHostFileSystemInfo")}),define(Re[26],Oe([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0,e.$5Q=(0,v.$Ki)("IExtHostInitDataService")}),define(Re[188],Oe([1,0,9,11,173,26]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ltc=void 0;let R=class extends P.$dS{constructor(m,s,I){const b=I.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",u=I.remote.isRemote?(0,v.localize)(2707,null):m?(0,v.localize)(2708,null):(0,v.localize)(2709,null);super(s.createLogger(b,{name:u}))}};e.$ltc=R,e.$ltc=R=Qe([We(1,D.$gk),We(2,L.$5Q)],R)}),define(Re[189],Oe([1,0,10]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qrc=e.$Prc=void 0;class D{constructor(R,T,m){this.h=new Map,this.a=R,this.b=T,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(s=>(this.f=s,this)),this.g=this.c.onDidChangeStorage(s=>{s.shared===this.b&&s.key===this.a&&(this.f=s.value)}),this.i=new v.$Wh(()=>{const s=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of s.values())I.complete()}catch(I){for(const b of s.values())b.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,T){let m=this.f[R];return typeof m>"u"&&(m=T),m}update(R,T){this.f[R]=T;const m=this.h.get(R);if(m!==void 0)return m.p;const s=new v.$8h;return this.h.set(R,s),this.i.isScheduled()||this.i.schedule(),s.p}dispose(){this.g.dispose()}}e.$Prc=D;class P extends D{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,T){super(R.identifier.value,!0,T),this.j=R}}e.$Qrc=P}),define(Re[190],Oe([1,0,6,2]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Psc=void 0;class P{constructor(R){this.c=R,this.a=new v.$qe,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$qe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,T,m,s){const b=this.c.getNotebookDocument(D.URI.revive(R)).acceptModelChanged(T.value,m,s);this.b.fire(b)}$acceptDirtyStateChanged(R,T){this.c.getNotebookDocument(D.URI.revive(R)).acceptDirty(T)}$acceptModelSaved(R){const T=this.c.getNotebookDocument(D.URI.revive(R));this.a.fire(T.apiNotebook)}}e.$Psc=P}),define(Re[16],Oe([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.$OQ=void 0,e.$OQ=(0,v.$Ki)("IExtHostRpcService");class D{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$PQ=D}),define(Re[191],Oe([1,0,18,6,4]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zrc=void 0;class L{#e;constructor(T,m){this.disposables=new P.$Yc,this.a=v.$zn.toKey(T.identifier),this.#e=m,this.onDidChange=D.Event.map(D.Event.filter(this.#e.onDidChangePassword,s=>s.extensionId===this.a),s=>({key:s.key}),this.disposables)}dispose(){this.disposables.dispose()}get(T){return this.#e.get(this.a,T)}store(T,m){return this.#e.store(this.a,T,m)}delete(T){return this.#e.delete(this.a,T)}}e.$Zrc=L}),define(Re[65],Oe([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$orc=e.$nrc=void 0,e.$nrc=(0,v.$Ki)("IURITransformerService");class D{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$orc=D});var oi=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Re[116],Oe([1,0,9,14,2,4,3,29,28,15,42,157,37]),function(be,e,v,D,P,L,R,T,m,s,I,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$JG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$zG=e.EditorInputCapabilities=e.$yG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=void 0,e.$pG=r,e.$qG=a,e.$rG=h,e.$sG=c,e.$tG=i,e.$uG=n,e.$vG=t,e.$wG=o,e.$xG=l,e.$AG=y,e.$BG=O,e.$CG=p,e.$DG=w,e.$EG=M,e.$FG=A,e.$GG=F,e.$HG=G,e.$IG=ae,e.$KG=ie,e.$LG=_,e.$MG=$e,e.$NG=Ie,u=oi(u),e.$kG={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$lG={id:"default",displayName:(0,v.localize)(4060,null),providerDisplayName:(0,v.localize)(4061,null)},e.$mG="workbench.editor.sidebysideEditor",e.$nG="workbench.editors.textDiffEditor",e.$oG="workbench.editors.binaryResourceDiffEditor";var k;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var $;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function r(X){const V=X;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}function a(X){const V=X;return!!V&&typeof V.getScrollPosition=="function"&&typeof V.setScrollPosition=="function"&&!!V.onDidChangeScroll}function h(X,V,re){for(const we of re.visibleEditorPanes)if(we.group.id===V&&X.matches(we.input))return we.getViewState()}function c(X){if(y(X))return!1;const V=X;return P.URI.isUri(V?.resource)}function i(X){if(y(X))return!1;const V=X;return V?.original!==void 0&&V.modified!==void 0}function n(X){if(y(X))return!1;const V=X;return!V||V.resources&&!Array.isArray(V.resources)?!1:!!V.resources||!!V.multiDiffSource}function t(X){if(y(X)||i(X))return!1;const V=X;return V?.primary!==void 0&&V.secondary!==void 0}function o(X){if(y(X))return!1;const V=X;return V?V.resource===void 0||V.resource.scheme===s.Schemas.untitled||V.forceUntitled===!0:!1}function l(X){if(y(X))return!1;const V=X;return P.URI.isUri(V?.base?.resource)&&P.URI.isUri(V?.input1?.resource)&&P.URI.isUri(V?.input2?.resource)&&P.URI.isUri(V?.result?.resource)}var g;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var f;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f||(e.SaveReason=f={}));class d{constructor(){this.a=new Map}registerSource(V,re){let we=this.a.get(V);return we||(we={source:V,label:re},this.a.set(V,we)),we.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.$yG=new d;var S;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class E extends L.$Zc{}e.$zG=E;function y(X){return X instanceof E}function C(X){const V=X;return P.URI.isUri(V?.preferredResource)}function O(X){const V=X;return y(V?.primary)&&y(V?.secondary)}function p(X){const V=X;return y(V?.modified)&&y(V?.original)}function w(X,V,re,we,Pe){return Ie(we,[(0,b.$uj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(4062,null),run:()=>{const Fe={...re,limits:{size:Number.MAX_VALUE}};X.openEditor(V,Fe)}}),(0,b.$uj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(4063,null),run:()=>Pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function M(X){return y(X?.editor)}function A(X){const V=X;return M(X)&&V?.group!==void 0}function F(X){const V=X;return typeof V?.groupId=="number"&&y(V.editor)}function G(X){return typeof X?.groupId=="number"}var x;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(x||(e.EditorCloseContext=x={}));var j;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var U;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class J{getOriginalUri(V,re){if(!V)return;if(l(V))return e.$JG.getOriginalUri(V.result,re);if(re?.supportSideBySide){const{primary:Pe,secondary:Fe}=this.a(V);if(Pe&&Fe){if(re?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Pe,{filterByScheme:re.filterByScheme}),secondary:this.getOriginalUri(Fe,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===U.ANY)return this.getOriginalUri(Pe,{filterByScheme:re.filterByScheme})??this.getOriginalUri(Fe,{filterByScheme:re.filterByScheme});V=re.supportSideBySide===U.PRIMARY?Pe:Fe}}if(i(V)||n(V)||t(V)||l(V))return;const we=C(V)?V.preferredResource:V.resource;return!we||!re||!re.filterByScheme?we:this.b(we,re.filterByScheme)}a(V){return O(V)||t(V)?{primary:V.primary,secondary:V.secondary}:p(V)||i(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,re){if(!V)return;if(l(V))return e.$JG.getCanonicalUri(V.result,re);if(re?.supportSideBySide){const{primary:Pe,secondary:Fe}=this.a(V);if(Pe&&Fe){if(re?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Pe,{filterByScheme:re.filterByScheme}),secondary:this.getCanonicalUri(Fe,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===U.ANY)return this.getCanonicalUri(Pe,{filterByScheme:re.filterByScheme})??this.getCanonicalUri(Fe,{filterByScheme:re.filterByScheme});V=re.supportSideBySide===U.PRIMARY?Pe:Fe}}if(i(V)||n(V)||t(V)||l(V))return;const we=V.resource;return!we||!re||!re.filterByScheme?we:this.b(we,re.filterByScheme)}b(V,re){if(Array.isArray(re)){if(re.some(we=>V.scheme===we))return V}else if(re===V.scheme)return V}}var Z;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function ae(X,V,re,we){if(!X.isSticky(V))return!1;switch(we.preventPinnedEditorClose){case"keyboardAndMouse":return re===Z.MOUSE||re===Z.KEYBOARD;case"mouse":return re===Z.MOUSE;case"keyboard":return re===Z.KEYBOARD}return!1}e.$JG=new J;var ee;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(ee||(e.CloseDirection=ee={}));class oe{constructor(){this.c=new Map,this.d=new Map}start(V){const re=this.a=V.get(R.$Ji);for(const[we,Pe]of this.c)this.e(we,Pe,re);this.c.clear()}e(V,re,we){const Pe=we.createInstance(re);this.d.set(V,Pe)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,D.$ug)(this.b)}registerEditorSerializer(V,re){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,re,this.a):this.c.set(V,re),(0,L.$Xc)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}T.$zo.add(e.$kG.EditorFactory,new oe);async function ie(X,V,re){return!X||!X.length?[]:await Promise.all(X.map(async we=>{const Pe=P.URI.revive(we.fileUri);if(!Pe){re.info("Cannot resolve the path because it is not valid.",we);return}if(!await V.canHandleResource(Pe)){re.info("Cannot resolve the path because it cannot be handled",we);return}let Be=we.exists,xe=we.type;if(typeof Be!="boolean"||typeof xe!="number")try{xe=(await V.stat(Pe)).isDirectory?m.FileType.Directory:m.FileType.Unknown,Be=!0}catch(ht){re.error(ht),Be=!1}if(!Be&&we.openOnlyIfExists){re.info("Cannot resolve the path because it does not exist",we);return}if(xe===m.FileType.Directory){re.info("Cannot resolve the path because it is a directory",we);return}const nt={...we.options,pinned:!0};return Be?{resource:Pe,options:nt}:{resource:Pe,options:nt,forceUntitled:!0}}))}var ue;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function _(X){const V=X;if(!V)return!1;const re=V;if(re.modified)return _(re.modified);const we=V;return!!(we.contributionsState&&we.viewState&&Array.isArray(we.cursorState))}function $e(X){return(0,I.$wj)(X)}function Ie(X,V,re){const we=(0,I.$xj)(X,V);return we.forceMessage=re?.forceMessage,we.forceSeverity=re?.forceSeverity,we.allowDialog=re?.allowDialog,we}}),define(Re[192],Oe([1,0,6,9,3,4,27,29,25,98,183]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VG=e.$UG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$TG=e.ViewContentGroups=e.$RG=e.ViewContainerLocation=e.Extensions=e.$QG=e.$PG=e.$OG=void 0,e.$SG=k,e.$OG="views",e.$PG=(0,D.localize)(4223,null),e.$QG=(0,I.$Mx)("default-view-icon",s.$0j.window,(0,D.localize)(4224,null));var b;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$RG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function k(o){switch(o){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class $ extends L.$Zc{constructor(){super(...arguments),this.c=this.B(new v.$qe),this.onDidRegister=this.c.event,this.f=this.B(new v.$qe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(l,g,f){const d=this.get(l.id);if(d)return d;const S=l;return S.openCommandActionDescriptor=f?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$Cc)(this.g,g,[]).push(S),f?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:g}),S}deregisterViewContainer(l){for(const g of this.g.keys()){const f=this.g.get(g),d=f?.indexOf(l);if(d!==-1){f?.splice(d,1),f.length===0&&this.g.delete(g),this.f.fire({viewContainer:l,viewContainerLocation:g});return}}}get(l){return this.all.filter(g=>g.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(f=>f?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(g=>this.getViewContainerLocation(g)===l)}}T.$zo.add(b.ViewContainersRegistry,new $);var r;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(r||(e.ViewContentGroups=r={}));function a(o,l){const g=o.group??r.More,f=l.group??r.More;return g!==f?g.localeCompare(f):(o.order??5)-(l.order??5)}class h extends L.$Zc{constructor(){super(...arguments),this.c=this.B(new v.$qe),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$qe),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$qe),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$qe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Mc}registerViews(l,g){this.registerViews2([{views:l,viewContainer:g}])}registerViews2(l){l.forEach(({views:g,viewContainer:f})=>this.r(g,f)),this.c.fire(l)}deregisterViews(l,g){const f=this.s(l,g);f.length&&this.f.fire({views:f,viewContainer:g})}moveViews(l,g){for(const f of this.m.keys())if(f!==g){const d=this.s(l,f);d.length&&(this.r(d,g),this.g.fire({views:d,from:f,to:g}))}}getViews(l){return this.m.get(l)||[]}getView(l){for(const g of this.j){const f=(this.m.get(g)||[]).filter(d=>d.id===l)[0];if(f)return f}return null}getViewContainer(l){for(const g of this.j)if((this.m.get(g)||[]).filter(d=>d.id===l)[0])return g;return null}registerViewWelcomeContent(l,g){return this.n.add(l,g),this.h.fire(l),(0,L.$Xc)(()=>{this.n.delete(l,g),this.h.fire(l)})}registerViewWelcomeContent2(l,g){const f=new Map;for(const[d,S]of g)this.n.add(l,S),f.set(d,(0,L.$Xc)(()=>{this.n.delete(l,S),this.h.fire(l)}));return this.h.fire(l),f}getViewWelcomeContent(l){const g=[];return this.n.forEach(l,f=>g.push(f)),g.sort(a)}r(l,g){let f=this.m.get(g);f||(f=[],this.m.set(g,f),this.j.push(g));for(const d of l){if(this.getView(d.id)!==null)throw new Error((0,D.localize)(4225,null,d.id));f.push(d)}}s(l,g){const f=this.m.get(g);if(!f)return[];const d=[],S=[];for(const E of f)l.includes(E)?d.push(E):S.push(E);return d.length&&(S.length?this.m.set(g,S):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),d}}T.$zo.add(b.ViewsRegistry,new h),e.$TG=(0,P.$Ki)("viewDescriptorService");var c;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class n{constructor(l,g){this.c=!1,this.d=!1,(0,m.$po)(this,l),this.d=!!g,this.resolve=async f=>{if(g&&!this.c){const d=await g(f);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}f.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$UG=n;class t extends Error{constructor(l){super((0,D.localize)(4226,null,l)),this.name="NoTreeViewError"}static is(l){return!!l&&l.name==="NoTreeViewError"}}e.$VG=t}),define(Re[193],Oe([1,0,9,31]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=void 0,e.$ZG=new D.$2j("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(4721,null)}),e.$1G=new D.$2j("chatVoteUpEnabled",!1,{type:"boolean",description:(0,v.localize)(4722,null)}),e.$2G=new D.$2j("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(4723,null)}),e.$3G=new D.$2j("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(4724,null)}),e.$4G=new D.$2j("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(4725,null)}),e.$5G=new D.$2j("chatSessionResponseError",!1,{type:"boolean",description:(0,v.localize)(4726,null)}),e.$6G=new D.$2j("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(4727,null)}),e.$7G=new D.$2j("chatResponse",!1,{type:"boolean",description:(0,v.localize)(4728,null)}),e.$8G=new D.$2j("chatRequest",!1,{type:"boolean",description:(0,v.localize)(4729,null)}),e.$9G=new D.$2j("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(4730,null)}),e.$0G=new D.$2j("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(4731,null)}),e.$$G=new D.$2j("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(4732,null)}),e.$_G=new D.$2j("inChatInput",!1,{type:"boolean",description:(0,v.localize)(4733,null)}),e.$aH=new D.$2j("inChat",!1,{type:"boolean",description:(0,v.localize)(4734,null)}),e.$bH=new D.$2j("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(4735,null)}),e.$cH=new D.$2j("chatPanelParticipantRegistered",!1,{type:"boolean",description:(0,v.localize)(4736,null)}),e.$dH=new D.$2j("chatExtensionInvalid",!1,{type:"boolean",description:(0,v.localize)(4737,null)}),e.$eH=new D.$2j("chatCursorAtTop",!1),e.$fH=new D.$2j("chatInputHasAgent",!1),e.$gH=new D.$2j("chatLocation",void 0),e.$hH=new D.$2j("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(4738,null)})}),define(Re[117],Oe([1,0,283,10,19,6,41,4,34,145,13,31,18,3,11,109,177,187,193]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.ChatAgentLocation=void 0,e.$qI=g,e.$rI=f;var n;(function(d){d.Panel="panel",d.Terminal="terminal",d.Notebook="notebook",d.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(d){function S(E){switch(E){case"panel":return d.Panel;case"terminal":return d.Terminal;case"notebook":return d.Notebook;case"editor":return d.Editor}return d.Panel}d.fromRaw=S}(n||(e.ChatAgentLocation=n={})),e.$lI=(0,k.$Ki)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(S){this.g=S,this.b=new Map,this.d=new L.$qe,this.onDidChangeAgents=this.d.event,this.h=new Map,this.j=new Map,this.e=c.$bH.bindTo(this.g),this.f=c.$cH.bindTo(this.g)}registerAgent(S,E){if(this.getAgent(S))throw new Error(`Agent already registered: ${JSON.stringify(S)}`);E.isDefault&&this.f.set(!0);const C=this,O=E.slashCommands;E={...E,get slashCommands(){return O.filter(w=>!w.when||C.g.contextMatchesRules(b.$Ij.deserialize(w.when)))}};const p={data:E};return this.b.set(S,p),this.d.fire(void 0),(0,T.$Xc)(()=>{this.b.delete(S),E.isDefault&&this.f.set(!1),this.d.fire(void 0)})}registerAgentImplementation(S,E){const y=this.b.get(S);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(S)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(S)}`);return y.data.isDefault&&this.e.set(!0),y.impl=E,this.d.fire(new o(y.data,E)),(0,T.$Xc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(S,E){S.isDynamic=!0;const y={data:S,impl:E};return this.b.set(S.id,y),this.d.fire(new o(S,E)),(0,T.$Xc)(()=>{this.b.delete(S.id),this.d.fire(void 0)})}registerAgentCompletionProvider(S,E){return this.h.set(S,E),{dispose:()=>{this.h.delete(S)}}}async getAgentCompletionItems(S,E,y){return await this.h.get(S)?.(E,y)??[]}updateAgent(S,E){const y=this.b.get(S);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(S)} registered`);y.data.metadata={...y.data.metadata,...E},this.d.fire(new o(y.data,y.impl))}getDefaultAgent(S){return(0,v.$jb)(this.getActivatedAgents(),E=>!!E.isDefault&&E.locations.includes(S))}getContributedDefaultAgent(S){return this.getAgents().find(E=>!!E.isDefault&&E.locations.includes(S))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),S=>!!S.data.metadata.isSecondary)?.data}getAgent(S){if(this.i(S))return this.b.get(S)?.data}i(S){const E=this.b.get(S);return!E?.data.when||this.g.contextMatchesRules(b.$Ij.deserialize(E.data.when))}getAgentByFullyQualifiedId(S){const E=R.Iterable.find(this.b.values(),y=>g(y.data)===S)?.data;if(!(E&&!this.i(E.id)))return E}getAgents(){return Array.from(this.b.values()).map(S=>S.data).filter(S=>this.i(S.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(S=>!!S.impl).filter(S=>this.i(S.data.id)).map(S=>new o(S.data,S.impl))}getAgentsByName(S){return this.getAgents().filter(E=>E.name===S)}agentHasDupeName(S){const E=this.getAgent(S);return E?this.getAgentsByName(E.name).filter(y=>y.extensionId.value!==E.extensionId.value).length>0:!1}async invokeAgent(S,E,y,C,O){const p=this.b.get(S);if(!p?.impl)throw new Error(`No activated agent with id "${S}"`);return await p.impl.invoke(E,y,C,O)}async getFollowups(S,E,y,C,O){const p=this.b.get(S);if(!p?.impl)throw new Error(`No activated agent with id "${S}"`);return p.impl?.provideFollowups?p.impl.provideFollowups(E,y,C,O):[]}async getChatTitle(S,E,y){const C=this.b.get(S);if(!C?.impl)throw new Error(`No activated agent with id "${S}"`);if(C.impl?.provideChatTitle)return C.impl.provideChatTitle(E,y)}registerChatParticipantDetectionProvider(S,E){return this.j.set(S,E),(0,T.$Xc)(()=>{this.j.delete(S)})}hasChatParticipantDetectionProviders(){return this.j.size>0}async detectAgentOrCommand(S,E,y,C){const O=R.Iterable.first(this.j.values());if(!O)return;const p=this.getAgents().reduce((F,G)=>{F.push({participant:G.id,disambiguation:G.disambiguation??[]});for(const x of G.slashCommands)F.push({participant:G.id,command:x.name,disambiguation:x.disambiguation??[]});return F},[]),w=await O.provideParticipantDetection(S,E,{...y,participants:p},C);if(!w)return;const M=this.getAgent(w.participant);if(!M)return;if(!w.command)return{agent:M};const A=M?.slashCommands.find(F=>F.name===w.command);if(A)return{agent:M,command:A}}};e.$mI=t,e.$mI=t=Qe([We(0,b.$3j)],t);class o{constructor(S,E){this.b=S,this.d=E}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}get disambiguation(){return this.b.disambiguation}async invoke(S,E,y,C){return this.d.invoke(S,E,y,C)}async provideFollowups(S,E,y,C){return this.d.provideFollowups?this.d.provideFollowups(S,E,y,C):[]}provideWelcomeMessage(S,E){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(S,E)}provideSampleQuestions(S,E){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(S,E)}toJSON(){return this.b}}e.$nI=o,e.$oI=(0,k.$Ki)("chatAgentNameService");let l=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(S,E,y,C){if(this.g=E,this.h=y,this.i=C,this.e=(0,s.$$d)(this,Object.create(null)),this.f=!1,!S.chatParticipantRegistry)return;this.d=S.chatParticipantRegistry;const O=C.get(i.b,h.StorageScope.APPLICATION);try{this.e.set(JSON.parse(O??"{}"),void 0)}catch{C.remove(i.b,h.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(S=>this.h.warn("Failed to fetch chat participant registry",S)).then(()=>(0,D.$Lh)(5*60*1e3)).then(()=>this.j())}async k(){const S=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const E=await(0,a.$jq)(S);if(!E||E.version!==1)throw new Error("Unexpected chat participant registry response.");const y=E.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(i.b,JSON.stringify(y),h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}getAgentNameRestriction(S){const E=this.l(S.name,S).get(),y=!S.fullName||this.l(S.fullName.replace(/\s/g,""),S).get();return E&&y}l(S,E){return this.e.map(C=>C[S.toLowerCase()]).map(C=>C?C.some(O=>(0,I.$Kf)(O,O.includes(".")?E.extensionId.value:E.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$pI=l,e.$pI=l=i=Qe([We(0,r.$yk),We(1,a.$dq),We(2,$.$fk),We(3,h.$qq)],l);function g(d){return`${d.extensionId.value}.${d.id}`}function f(d){const S="name"in d?d:{...d,name:d.id};return"extensionPublisherId"in S||(S.extensionPublisherId=S.extensionPublisher??""),"extensionDisplayName"in S||(S.extensionDisplayName=""),"extensionId"in S||(S.extensionId=new u.$zn("")),(0,m.$hi)(S)}}),define(Re[194],Oe([1,0,2,32,3]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TH=e.$SH=e.ChatCopyKind=e.ChatAgentVoteDownReason=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$QH=L,e.$RH=R;function L(b){return!!b&&typeof b=="object"&&"uri"in b&&b.uri instanceof v.URI&&"version"in b&&typeof b.version=="number"&&"ranges"in b&&Array.isArray(b.ranges)&&b.ranges.every(D.$Yt.isIRange)}function R(b){return!!b&&typeof b=="object"&&"documents"in b&&Array.isArray(b.documents)&&b.documents.every(L)}var T;(function(b){b[b.Complete=1]="Complete",b[b.Partial=2]="Partial",b[b.Omitted=3]="Omitted"})(T||(e.ChatResponseReferencePartStatusKind=T={}));var m;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(m||(e.ChatAgentVoteDirection=m={}));var s;(function(b){b.IncorrectCode="incorrectCode",b.DidNotFollowInstructions="didNotFollowInstructions",b.IncompleteCode="incompleteCode",b.MissingContext="missingContext",b.PoorlyWrittenOrFormatted="poorlyWrittenOrFormatted",b.RefusedAValidRequest="refusedAValidRequest",b.OffensiveOrUnsafe="offensiveOrUnsafe",b.Other="other",b.WillReportIssue="willReportIssue"})(s||(e.ChatAgentVoteDownReason=s={}));var I;(function(b){b[b.Action=1]="Action",b[b.Toolbar=2]="Toolbar"})(I||(e.ChatCopyKind=I={})),e.$SH=(0,P.$Ki)("IChatService"),e.$TH="accessibility.voice.keywordActivation"}),define(Re[195],Oe([1,0,6,10,9]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pwb=void 0;class L{constructor(){this.f=new Map,this.m=[],this.n=new v.$qe,this.o=new v.$qe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,m,s,I){const b={command:T};if(m&&Object.keys(m).length>0&&(b.arguments=m),this.u("request",b),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const k=this.f.get(b.seq);if(k){this.f.delete(b.seq);const $={type:"response",seq:0,request_seq:b.seq,success:!1,command:T,message:(0,P.localize)(5738,null,I,T)};k($)}},I)}return s&&this.f.set(b.seq,s),b.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,m){return T.type!=="event"||m.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,D.$Lh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const m=T,s=this.f.get(m.request_seq);s&&(this.f.delete(m.request_seq),s(m));break}}}}u(T,m){m.type=T,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((m,s)=>T.set(s,m)),await(0,D.$Lh)(500),T.forEach((m,s)=>{m({type:"response",seq:0,request_seq:s,success:!1,command:"canceled",message:"canceled"}),this.f.delete(s)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$pwb=L}),define(Re[81],Oe([1,0,2,9,31,3]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$cL=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$aL=e.MemoryRangeType=e.State=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=void 0,e.$_K=m,e.$bL=I,D=Ve(D),e.$ZJ="workbench.view.debug",e.$1J="workbench.debug.variablesView",e.$2J="workbench.debug.watchExpressionsView",e.$3J="workbench.debug.callStackView",e.$4J="workbench.debug.loadedScriptsView",e.$5J="workbench.debug.breakPointsView",e.$6J="workbench.debug.disassemblyView",e.$7J="workbench.panel.repl",e.$8J="workbench.panel.repl.view",e.$9J=new P.$2j("debugType",void 0,{type:"string",description:D.localize(5739,null)}),e.$0J=new P.$2j("debugConfigurationType",void 0,{type:"string",description:D.localize(5740,null)}),e.$$J=new P.$2j("debugState","inactive",{type:"string",description:D.localize(5741,null)}),e.$_J="debugUx",e.$aK=new P.$2j(e.$_J,"default",{type:"string",description:D.localize(5742,null)}),e.$bK=new P.$2j("hasDebugged",!1,{type:"boolean",description:D.localize(5743,null)}),e.$cK=new P.$2j("inDebugMode",!1,{type:"boolean",description:D.localize(5744,null)}),e.$dK=new P.$2j("inDebugRepl",!1,{type:"boolean",description:D.localize(5745,null)}),e.$eK=new P.$2j("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(5746,null)}),e.$fK=new P.$2j("inBreakpointWidget",!1,{type:"boolean",description:D.localize(5747,null)}),e.$gK=new P.$2j("breakpointsFocused",!0,{type:"boolean",description:D.localize(5748,null)}),e.$hK=new P.$2j("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(5749,null)}),e.$iK=new P.$2j("watchExpressionsExist",!1,{type:"boolean",description:D.localize(5750,null)}),e.$jK=new P.$2j("variablesFocused",!0,{type:"boolean",description:D.localize(5751,null)}),e.$kK=new P.$2j("expressionSelected",!1,{type:"boolean",description:D.localize(5752,null)}),e.$lK=new P.$2j("breakpointInputFocused",!1,{type:"boolean",description:D.localize(5753,null)}),e.$mK=new P.$2j("callStackItemType",void 0,{type:"string",description:D.localize(5754,null)}),e.$nK=new P.$2j("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(5755,null)}),e.$oK=new P.$2j("callStackItemStopped",!1,{type:"boolean",description:D.localize(5756,null)}),e.$pK=new P.$2j("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(5757,null)}),e.$qK=new P.$2j("watchItemType",void 0,{type:"string",description:D.localize(5758,null)}),e.$rK=new P.$2j("canViewMemory",void 0,{type:"boolean",description:D.localize(5759,null)}),e.$sK=new P.$2j("breakpointItemType",void 0,{type:"string",description:D.localize(5760,null)}),e.$tK=new P.$2j("breakpointItemBytes",void 0,{type:"boolean",description:D.localize(5761,null)}),e.$uK=new P.$2j("breakpointHasModes",!1,{type:"boolean",description:D.localize(5762,null)}),e.$vK=new P.$2j("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(5763,null)}),e.$wK=new P.$2j("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(5764,null)}),e.$xK=new P.$2j("loadedScriptsItemType",void 0,{type:"string",description:D.localize(5765,null)}),e.$yK=new P.$2j("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(5766,null)}),e.$zK=new P.$2j("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(5767,null)}),e.$AK=new P.$2j("stepBackSupported",!1,{type:"boolean",description:D.localize(5768,null)}),e.$BK=new P.$2j("restartFrameSupported",!1,{type:"boolean",description:D.localize(5769,null)}),e.$CK=new P.$2j("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(5770,null)}),e.$DK=new P.$2j("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(5771,null)}),e.$EK=new P.$2j("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(5772,null)}),e.$FK=new P.$2j("breakpointsExist",!1,{type:"boolean",description:D.localize(5773,null)}),e.$GK=new P.$2j("debuggersAvailable",!1,{type:"boolean",description:D.localize(5774,null)}),e.$HK=new P.$2j("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(5775,null)}),e.$IK=new P.$2j("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(5776,null)}),e.$JK=new P.$2j("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(5777,null)}),e.$KK=new P.$2j("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:D.localize(5778,null)}),e.$LK=new P.$2j("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(5779,null)}),e.$MK=new P.$2j("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(5780,null)}),e.$NK=new P.$2j("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(5781,null)}),e.$OK=new P.$2j("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(5782,null)}),e.$PK=new P.$2j("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(5783,null)}),e.$QK=new P.$2j("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(5784,null)}),e.$RK=new P.$2j("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(5785,null)}),e.$SK=new P.$2j("variableIsReadonly",!1,{type:"boolean",description:D.localize(5786,null)}),e.$TK=new P.$2j("variableValue",!1,{type:"string",description:D.localize(5787,null)}),e.$UK=new P.$2j("variableType",!1,{type:"string",description:D.localize(5788,null)}),e.$VK=new P.$2j("variableInterfaces",!1,{type:"array",description:D.localize(5789,null)}),e.$WK=new P.$2j("variableName",!1,{type:"string",description:D.localize(5790,null)}),e.$XK=new P.$2j("variableLanguage",!1,{type:"string",description:D.localize(5791,null)}),e.$YK=new P.$2j("variableExtensionId",!1,{type:"string",description:D.localize(5792,null)}),e.$ZK=new P.$2j("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(5793,null)}),e.$1K=new P.$2j("multiSessionRepl",!1,{type:"boolean",description:D.localize(5794,null)}),e.$2K=new P.$2j("multiSessionDebug",!1,{type:"boolean",description:D.localize(5795,null)}),e.$3K=new P.$2j("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(5796,null)}),e.$4K=new P.$2j("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(5797,null)}),e.$5K=new P.$2j("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(5798,null)}),e.$6K=new P.$2j("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(5799,null)});const R=i=>D.localize(5800,null,i);e.$7K=R,e.$8K="editor.contrib.debug",e.$9K="editor.contrib.breakpoint",e.$0K="debug",e.$$K={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(5801,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function m(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var s;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$aL="vscode-debug-memory";function I(i){const n=i.presentationHint??i.source.presentationHint;return n==="deemphasize"||n==="subtle"}var b;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(b||(e.DataBreakpointSetType=b={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var k;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$cL=(0,L.$Ki)("debugService");var $;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})($||(e.BreakpointWidgetContext=$={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var a;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(a||(e.DebugTreeItemCollapsibleState=a={}));var h;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(h||(e.IDebugVisualizationTreeItem=h={}));var c;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:v.URI.revive(n.iconPath.light),dark:v.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(c||(e.IDebugVisualization=c={}))}),define(Re[196],Oe([1,0,13,2,22,25,15,32,19,17]),function(be,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GI=void 0,e.$uI=b,e.$vI=u,e.$wI=k,e.$xI=$,e.$yI=r,e.$zI=a,e.$AI=h,e.$BI=i,e.$CI=o,e.$DI=l,e.$EI=f,e.$FI=S;const I=/{([^}]+)}/g;function b(y,C,O){return y.replace(I,function(p,w){return C&&w.length>0&&w[0]!=="_"?p:O&&O.hasOwnProperty(w)?O[w]:p})}function u(y){const C={};for(const O of Object.keys(y))O.startsWith("!")||(C[O]=y[O]);return C}function k(y){return y.configuration.request==="attach"&&!$(y)&&(!y.parentSession||k(y.parentSession))}function $(y){let C=y.configuration.type;if(C)return C==="vslsShare"&&(C=y.configuration.adapterProxy.configuration.type),(0,v.$Kf)(C,"extensionhost")||(0,v.$Kf)(C,"pwa-extensionhost")?y:y.parentSession?$(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function a(y,C,O){let p,w=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let A=null;for(;A=M.exec(y);){const F=A.index+1,G=F+A[0].length;if(F<=C&&G>=O){p=A[0],w=F;break}}if(p){const F=/(\w|\p{L})+/gu;let G=null;for(;(G=F.exec(p))&&!(G.index+1+w+G[0].length>=O););G&&(p=p.substring(0,F.lastIndex))}return p?{start:w,end:w+p.length-1}:{start:0,end:0}}async function h(y,C,O,p){if(y.evaluatableExpressionProvider.has(C)){const w=y.evaluatableExpressionProvider.ordered(C),M=(0,s.$Lb)(await Promise.all(w.map(async A=>{try{return await A.provideEvaluatableExpression(C,O,p??m.CancellationToken.None)}catch{return}})));if(M.length>0){let A=M[0].expression;const F=M[0].range;return A||(A=C.getLineContent(O.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:A}}}else{const w=C.getLineContent(O.lineNumber),{start:M,end:A}=a(w,O.column,O.column),F=w.substring(M-1,A);return{matchingExpression:F,range:new T.$Yt(O.lineNumber,M,O.lineNumber,M+F.length)}}return null}const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(c))}function n(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return D.URI.parse(y.path);if((0,P.$nc)(y.path))return D.URI.file(y.path)}return y.path}function t(y){if(typeof y.path=="object"){const C=D.URI.revive(y.path);if(C)return C.scheme===R.Schemas.file?C.fsPath:C.toString()}return y.path}function o(y,C){const O=C?n:t,p=(0,L.$mo)(y);return g(p,(w,M)=>{w&&M&&(M.path=O(M))}),p}function l(y,C){const O=C?n:t,p=(0,L.$mo)(y);return g(p,(w,M)=>{!w&&M&&(M.path=O(M))}),p}function g(y,C){switch(y.type){case"event":{const O=y;switch(O.event){case"output":C(!1,O.body.source);break;case"loadedSource":C(!1,O.body.source);break;case"breakpoint":C(!1,O.body.breakpoint.source);break;default:break}break}case"request":{const O=y;switch(O.command){case"setBreakpoints":C(!0,O.arguments.source);break;case"breakpointLocations":C(!0,O.arguments.source);break;case"source":C(!0,O.arguments.source);break;case"gotoTargets":C(!0,O.arguments.source);break;case"launchVSCode":O.arguments.args.forEach(p=>C(!1,p));break;default:break}break}case"response":{const O=y;if(O.success&&O.body)switch(O.command){case"stackTrace":O.body.stackFrames.forEach(p=>C(!1,p.source));break;case"loadedSources":O.body.sources.forEach(p=>C(!1,p));break;case"scopes":O.body.scopes.forEach(p=>C(!1,p.source));break;case"setFunctionBreakpoints":O.body.breakpoints.forEach(p=>C(!1,p.source));break;case"setBreakpoints":O.body.breakpoints.forEach(p=>C(!1,p.source));break;case"disassemble":O.body?.instructions.forEach(w=>C(!1,w.location));break;case"locations":C(!1,O.body?.source);break;default:break}break}}}function f(y){return y.filter(C=>!C.presentation?.hidden).sort((C,O)=>C.presentation?O.presentation?C.presentation.group?O.presentation.group?C.presentation.group!==O.presentation.group?C.presentation.group.localeCompare(O.presentation.group):d(C.presentation.order,O.presentation.order):-1:O.presentation.group?1:d(C.presentation.order,O.presentation.order):-1:O.presentation?1:0)}function d(y,C){return typeof y!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:y-C}async function S(y,C){const O=y.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(O!=="none"&&(await C.saveAll(),O==="allEditorsInActiveGroup")){const p=C.activeEditorPane;p&&p.input.resource?.scheme===R.Schemas.untitled&&await C.save({editor:p.input,groupId:p.group.id})}await y.reloadConfiguration()}const E=(y,C)=>!y||!C?y===C:y.name===C.name&&y.path===C.path&&y.sourceReference===C.sourceReference;e.$GI=E}),define(Re[197],Oe([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.CellExecutionUpdateType=void 0;var D;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(D||(e.CellExecutionUpdateType=D={})),e.$kL=(0,v.$Ki)("INotebookExecutionService")}),define(Re[198],Oe([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oL=e.$nL=e.ProxyKernelState=e.$mL=void 0,e.$mL=100;var D;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(D||(e.ProxyKernelState=D={})),e.$nL=(0,v.$Ki)("INotebookKernelService"),e.$oL=(0,v.$Ki)("INotebookKernelHistoryService")}),define(Re[199],Oe([1,0,4,32,52,166,102]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$32b=void 0;class T extends v.$Zc{constructor(s,I,b){super(),this._source=s,this.b=I,this.c=b,this.a=void 0}f(s){const I=s.getLineCount();return new D.$Yt(1,1,I,this.g(s,I))}g(s,I){if(I<1||I>s.getLineCount())throw new Error("Illegal value for lineNumber");return s.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const s=new L.$LD;s.acceptChunk(this._source);const I=s.finish(!0),{textBuffer:b,disposable:u}=I.create(P.DefaultEndOfLine.LF);this.b=b,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(s=>{const I=new L.$LD;I.acceptChunk(s);const b=I.finish(!0),{textBuffer:u,disposable:k}=b.create(P.DefaultEndOfLine.LF);return this.B(k),u})),this.a}findInInputs(s){const b=new R.$zD(s,!1,!1,null).parseSearchRequest();if(!b)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,b,!0,5e3)}findInOutputs(s){const b=new R.$zD(s,!1,!1,null).parseSearchRequest();return b?this.outputTextBuffers.map(u=>{const k=u.findMatchesLineByLine(this.f(u),b,!0,5e3);if(k.length!==0)return{textBuffer:u,matches:k}}).filter(u=>!!u):[]}}e.$32b=T}),define(Re[54],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(L){L.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var D;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(D||(e.TestPosition=D={}));class P{static fromExtHostTestItem(R,T,m=R.parent){if(R._isRoot)return new P([T]);const s=[R.id];for(let I=m;I&&I.id!==T;I=I.parent)s.push(I.id);return s.push(T),new P(s.reverse())}static isRoot(R){return!R.includes(v.Delimiter)}static root(R){const T=R.indexOf(v.Delimiter);return T===-1?R:R.slice(0,T)}static fromString(R){return new P(R.split(v.Delimiter))}static join(R,T){return new P([...R.path,T])}static joinToString(R,T){return R.toString()+v.Delimiter+T}static parentId(R){const T=R.lastIndexOf(v.Delimiter);return T===-1?void 0:R.slice(0,T)}static localId(R){const T=R.lastIndexOf(v.Delimiter);return T===-1?R:R.slice(T+v.Delimiter.length)}static isChild(R,T){return T[R.length]===v.Delimiter&&T.startsWith(R)}static compare(R,T){return R===T?D.IsSame:P.isChild(R,T)?D.IsChild:P.isChild(T,R)?D.IsParent:D.Disconnected}static getLengthOfCommonPrefix(R,T){if(R===0)return 0;let m=0;for(;m<R-1;){for(let s=1;s<R;s++){const I=T(s-1),b=T(s);if(I.path[m]!==b.path[m])return m}m++}return m}constructor(R,T=R.length){if(this.path=R,this.d=T,R.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let T=0;T<R.d&&T<this.d;T++)if(R.path[T]!==this.path[T])return D.Disconnected;return R.d>this.d?D.IsChild:R.d<this.d?D.IsParent:D.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+=v.Delimiter,this.c+=this.path[R]}return this.c}}e.$tJ=P}),define(Re[55],Oe([1,0,2,101,32,54]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$BJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$AJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$zJ=e.$yJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$xJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$wJ=e.$vJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$uJ=e.TestResultState=void 0;var R;(function(U){U[U.Unset=0]="Unset",U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$uJ={[R.Unset]:"unset",[R.Queued]:"queued",[R.Running]:"running",[R.Passed]:"passed",[R.Failed]:"failed",[R.Skipped]:"skipped",[R.Errored]:"errored"};var T;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var m;(function(U){U[U.Refresh=2]="Refresh",U[U.CodeRelatedToTest=4]="CodeRelatedToTest",U[U.TestRelatedToCode=8]="TestRelatedToCode"})(m||(e.TestControllerCapability=m={}));var s;(function(U){U[U.Run=2]="Run",U[U.Debug=4]="Debug",U[U.Coverage=8]="Coverage",U[U.HasNonDefaultProfile=16]="HasNonDefaultProfile",U[U.HasConfigurable=32]="HasConfigurable",U[U.SupportsContinuousRun=64]="SupportsContinuousRun"})(s||(e.TestRunProfileBitset=s={})),e.$vJ=[s.Run,s.Debug,s.Coverage,s.HasNonDefaultProfile,s.HasConfigurable,s.SupportsContinuousRun];const I=U=>"runId"in U;e.$wJ=I;var b;(function(U){U.serialize=J=>({range:J.range.toJSON(),uri:J.uri.toJSON()}),U.deserialize=(J,Z)=>({range:P.$Yt.lift(Z.range),uri:J.asCanonicalUri(v.URI.revive(Z.uri))})})(b||(e.IRichLocation=b={}));var u;(function(U){U[U.Error=0]="Error",U[U.Output=1]="Output"})(u||(e.TestMessageType=u={}));var k;(function(U){U.serialize=J=>({label:J.label,uri:J.uri?.toJSON(),position:J.position?.toJSON()}),U.deserialize=(J,Z)=>({label:Z.label,uri:Z.uri?J.asCanonicalUri(v.URI.revive(Z.uri)):void 0,position:Z.position?D.$Xt.lift(Z.position):void 0})})(k||(e.ITestMessageStackFrame=k={}));var $;(function(U){U.serialize=J=>({message:J.message,type:u.Error,expected:J.expected,actual:J.actual,contextValue:J.contextValue,location:J.location&&b.serialize(J.location),stackTrace:J.stackTrace?.map(k.serialize)}),U.deserialize=(J,Z)=>({message:Z.message,type:u.Error,expected:Z.expected,actual:Z.actual,contextValue:Z.contextValue,location:Z.location&&b.deserialize(J,Z.location),stackTrace:Z.stackTrace&&Z.stackTrace.map(ae=>k.deserialize(J,ae))})})($||(e.ITestErrorMessage=$={}));const r=(U,J)=>`${J?"s":"e"}${U}`;e.$xJ=r;var a;(function(U){U.serialize=J=>({message:J.message,type:u.Output,offset:J.offset,length:J.length,location:J.location&&b.serialize(J.location)}),U.deserialize=(J,Z)=>({message:Z.message,type:u.Output,offset:Z.offset,length:Z.length,location:Z.location&&b.deserialize(J,Z.location)})})(a||(e.ITestOutputMessage=a={}));var h;(function(U){U.serialize=J=>J.type===u.Error?$.serialize(J):a.serialize(J),U.deserialize=(J,Z)=>Z.type===u.Error?$.deserialize(J,Z):a.deserialize(J,Z),U.isDiffable=J=>J.type===u.Error&&J.actual!==void 0&&J.expected!==void 0})(h||(e.ITestMessage=h={}));var c;(function(U){U.serializeWithoutMessages=J=>({state:J.state,duration:J.duration,messages:[]}),U.serialize=J=>({state:J.state,duration:J.duration,messages:J.messages.map(h.serialize)}),U.deserialize=(J,Z)=>({state:Z.state,duration:Z.duration,messages:Z.messages.map(ae=>h.deserialize(J,ae))})})(c||(e.ITestTaskState=c={}));const i="\0",n=(U,J)=>U+i+J;e.$yJ=n;const t=U=>{const J=U.indexOf(i);return{ctrlId:U.slice(0,J),tagId:U.slice(J+1)}};e.$zJ=t;var o;(function(U){U.serialize=J=>({extId:J.extId,label:J.label,tags:J.tags,busy:J.busy,children:void 0,uri:J.uri?.toJSON(),range:J.range?.toJSON()||null,description:J.description,error:J.error,sortText:J.sortText}),U.deserialize=(J,Z)=>({extId:Z.extId,label:Z.label,tags:Z.tags,busy:Z.busy,children:void 0,uri:Z.uri?J.asCanonicalUri(v.URI.revive(Z.uri)):void 0,range:Z.range?P.$Yt.lift(Z.range):null,description:Z.description,error:Z.error,sortText:Z.sortText})})(o||(e.ITestItem=o={}));var l;(function(U){U[U.NotExpandable=0]="NotExpandable",U[U.Expandable=1]="Expandable",U[U.BusyExpanding=2]="BusyExpanding",U[U.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var g;(function(U){U.serialize=J=>({expand:J.expand,item:o.serialize(J.item)}),U.deserialize=(J,Z)=>({controllerId:L.$tJ.root(Z.item.extId),expand:Z.expand,item:o.deserialize(J,Z.item)})})(g||(e.InternalTestItem=g={}));var f;(function(U){U.serialize=J=>{let Z;return J.item&&(Z={},J.item.label!==void 0&&(Z.label=J.item.label),J.item.tags!==void 0&&(Z.tags=J.item.tags),J.item.busy!==void 0&&(Z.busy=J.item.busy),J.item.uri!==void 0&&(Z.uri=J.item.uri?.toJSON()),J.item.range!==void 0&&(Z.range=J.item.range?.toJSON()),J.item.description!==void 0&&(Z.description=J.item.description),J.item.error!==void 0&&(Z.error=J.item.error),J.item.sortText!==void 0&&(Z.sortText=J.item.sortText)),{extId:J.extId,expand:J.expand,item:Z}},U.deserialize=J=>{let Z;return J.item&&(Z={},J.item.label!==void 0&&(Z.label=J.item.label),J.item.tags!==void 0&&(Z.tags=J.item.tags),J.item.busy!==void 0&&(Z.busy=J.item.busy),J.item.range!==void 0&&(Z.range=J.item.range?P.$Yt.lift(J.item.range):null),J.item.description!==void 0&&(Z.description=J.item.description),J.item.error!==void 0&&(Z.error=J.item.error),J.item.sortText!==void 0&&(Z.sortText=J.item.sortText)),{extId:J.extId,expand:J.expand,item:Z}}})(f||(e.ITestItemUpdate=f={}));const d=(U,J)=>{J.expand!==void 0&&(U.expand=J.expand),J.item!==void 0&&(U.item=U.item?Object.assign(U.item,J.item):J.item)};e.$AJ=d;var S;(function(U){U.serializeWithoutMessages=J=>({...g.serialize(J),ownComputedState:J.ownComputedState,computedState:J.computedState,tasks:J.tasks.map(c.serializeWithoutMessages)}),U.serialize=J=>({...g.serialize(J),ownComputedState:J.ownComputedState,computedState:J.computedState,tasks:J.tasks.map(c.serialize)}),U.deserialize=(J,Z)=>({...g.deserialize(J,Z),ownComputedState:Z.ownComputedState,computedState:Z.computedState,tasks:Z.tasks.map(ae=>c.deserialize(J,ae)),retired:!0})})(S||(e.TestResultItem=S={}));var E;(function(U){U.empty=()=>({covered:0,total:0}),U.sum=(J,Z)=>{J.covered+=Z.covered,J.total+=Z.total}})(E||(e.ICoverageCount=E={}));var y;(function(U){U.serialize=J=>({id:J.id,statement:J.statement,branch:J.branch,declaration:J.declaration,testIds:J.testIds,uri:J.uri.toJSON()}),U.deserialize=(J,Z)=>({id:Z.id,statement:Z.statement,branch:Z.branch,declaration:Z.declaration,testIds:Z.testIds,uri:J.asCanonicalUri(v.URI.revive(Z.uri))}),U.empty=(J,Z)=>({id:J,uri:Z,statement:E.empty()})})(y||(e.IFileCoverage=y={}));function C(U){return{...U,location:U.location?.toJSON()}}function O(U){return U.location=U.location?D.$Xt.isIPosition(U.location)?D.$Xt.lift(U.location):P.$Yt.lift(U.location):void 0,U}e.$BJ=3;var p;(function(U){U[U.Declaration=0]="Declaration",U[U.Statement=1]="Statement",U[U.Branch=2]="Branch"})(p||(e.DetailType=p={}));var w;(function(U){U.serialize=J=>J.type===p.Declaration?A.serialize(J):F.serialize(J),U.deserialize=J=>J.type===p.Declaration?A.deserialize(J):F.deserialize(J)})(w||(e.CoverageDetails=w={}));var M;(function(U){U.serialize=C,U.deserialize=O})(M||(e.IBranchCoverage=M={}));var A;(function(U){U.serialize=C,U.deserialize=O})(A||(e.IDeclarationCoverage=A={}));var F;(function(U){U.serialize=J=>({...C(J),branches:J.branches?.map(M.serialize)}),U.deserialize=J=>({...O(J),branches:J.branches?.map(M.deserialize)})})(F||(e.IStatementCoverage=F={}));var G;(function(U){U[U.Add=0]="Add",U[U.Update=1]="Update",U[U.DocumentSynced=2]="DocumentSynced",U[U.Remove=3]="Remove",U[U.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",U[U.Retire=5]="Retire",U[U.AddTag=6]="AddTag",U[U.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var x;(function(U){U.deserialize=(J,Z)=>Z.op===G.Add?{op:Z.op,item:g.deserialize(J,Z.item)}:Z.op===G.Update?{op:Z.op,item:f.deserialize(Z.item)}:Z.op===G.DocumentSynced?{op:Z.op,uri:J.asCanonicalUri(v.URI.revive(Z.uri)),docv:Z.docv}:Z,U.serialize=J=>J.op===G.Add?{op:J.op,item:g.serialize(J.item)}:J.op===G.Update?{op:J.op,item:f.serialize(J.item)}:J})(x||(e.TestsDiffOp=x={}));class j{constructor(J){this.l=J,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(J){const Z=this.x();for(const ae of J)switch(ae.op){case G.Add:this.p(g.deserialize(this.l,ae.item),Z);break;case G.Update:this.q(f.deserialize(ae.item),Z);break;case G.Remove:this.v(ae.itemId,Z);break;case G.Retire:this.w(ae.itemId);break;case G.IncrementPendingExtHosts:this.updatePendingRoots(ae.amount);break;case G.AddTag:this.f.set(ae.tag.id,ae.tag);break;case G.RemoveTag:this.f.delete(ae.id);break}Z.complete?.()}p(J,Z){const ae=L.$tJ.parentId(J.item.extId)?.toString();let ee;if(!ae)ee=this.y(J),this.h.add(ee),this.g.set(J.item.extId,ee);else if(this.g.has(ae)){const oe=this.g.get(ae);oe.children.add(J.item.extId),ee=this.y(J,oe),this.g.set(J.item.extId,ee)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(J)}`);return}return Z.add?.(ee),J.expand===l.BusyExpanding&&this.j++,ee}q(J,Z){const ae=this.g.get(J.extId);if(ae)return J.expand!==void 0&&(ae.expand===l.BusyExpanding&&this.j--,J.expand===l.BusyExpanding&&this.j++),(0,e.$AJ)(ae,J),Z.update?.(ae),ae}v(J,Z){const ae=this.g.get(J);if(!ae)return;const ee=L.$tJ.parentId(ae.item.extId)?.toString();ee?this.g.get(ee).children.delete(ae.item.extId):this.h.delete(ae);const oe=[[J]];for(;oe.length;)for(const ie of oe.pop()){const ue=this.g.get(ie);ue&&(oe.push(ue.children),this.g.delete(ie),Z.remove?.(ue,ue!==ae),ue.expand===l.BusyExpanding&&this.j--)}}w(J){}updatePendingRoots(J){this.k+=J}x(){return{}}}e.$CJ=j}),define(Re[200],Oe([1,0,99,9,55]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$NHb=e.$MHb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var L;(function(b){b.ViewletId="workbench.view.extension.test",b.ExplorerViewId="workbench.view.testing",b.OutputPeekContributionId="editor.contrib.testingOutputPeek",b.DecorationsContributionId="editor.contrib.testingDecorations",b.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",b.CoverageViewId="workbench.view.testCoverage",b.ResultsPanelId="workbench.panel.testResults",b.ResultsViewId="workbench.panel.testResults.view",b.MessageLanguageId="vscodeInternalTestMessage"})(L||(e.Testing=L={}));var R;(function(b){b.List="list",b.Tree="true"})(R||(e.TestExplorerViewMode=R={}));var T;(function(b){b.ByLocation="location",b.ByStatus="status",b.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const m={[P.TestResultState.Errored]:(0,D.localize)(10846,null),[P.TestResultState.Failed]:(0,D.localize)(10847,null),[P.TestResultState.Passed]:(0,D.localize)(10848,null),[P.TestResultState.Queued]:(0,D.localize)(10849,null),[P.TestResultState.Running]:(0,D.localize)(10850,null),[P.TestResultState.Skipped]:(0,D.localize)(10851,null),[P.TestResultState.Unset]:(0,D.localize)(10852,null)},s=(b,u)=>(0,D.localize)(10853,null,(0,v.$5k)(b),m[u]);e.$MHb=s,e.$NHb={[P.TestRunProfileBitset.Debug]:(0,D.localize)(10854,null),[P.TestRunProfileBitset.Run]:(0,D.localize)(10855,null),[P.TestRunProfileBitset.Coverage]:(0,D.localize)(10856,null)};var I;(function(b){b.CancelTestRefreshAction="testing.cancelTestRefresh",b.CancelTestRunAction="testing.cancelRun",b.ClearTestResultsAction="testing.clearTestResults",b.CollapseAllAction="testing.collapseAll",b.ConfigureTestProfilesAction="testing.configureProfile",b.ContinousRunUsingForTest="testing.continuousRunUsingForTest",b.CoverageAtCursor="testing.coverageAtCursor",b.CoverageByUri="testing.coverage.uri",b.CoverageClear="testing.coverage.close",b.CoverageCurrentFile="testing.coverageCurrentFile",b.CoverageFilterToTest="testing.coverageFilterToTest",b.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",b.CoverageLastRun="testing.coverageLastRun",b.CoverageSelectedAction="testing.coverageSelected",b.CoverageToggleToolbar="testing.coverageToggleToolbar",b.CoverageViewChangeSorting="testing.coverageViewChangeSorting",b.DebugAction="testing.debug",b.DebugAllAction="testing.debugAll",b.DebugAtCursor="testing.debugAtCursor",b.DebugByUri="testing.debug.uri",b.DebugCurrentFile="testing.debugCurrentFile",b.DebugFailedTests="testing.debugFailTests",b.DebugLastRun="testing.debugLastRun",b.DebugSelectedAction="testing.debugSelected",b.FilterAction="workbench.actions.treeView.testExplorer.filter",b.GetExplorerSelection="_testing.getExplorerSelection",b.GetSelectedProfiles="testing.getSelectedProfiles",b.GoToTest="testing.editFocusedTest",b.GoToRelatedTest="testing.goToRelatedTest",b.PeekRelatedTest="testing.peekRelatedTest",b.GoToRelatedCode="testing.goToRelatedCode",b.PeekRelatedCode="testing.peekRelatedCode",b.HideTestAction="testing.hideTest",b.OpenCoverage="testing.openCoverage",b.OpenOutputPeek="testing.openOutputPeek",b.RefreshTestsAction="testing.refreshTests",b.ReRunFailedTests="testing.reRunFailTests",b.ReRunLastRun="testing.reRunLastRun",b.RunAction="testing.run",b.RunAllAction="testing.runAll",b.RunAllWithCoverageAction="testing.coverageAll",b.RunAtCursor="testing.runAtCursor",b.RunByUri="testing.run.uri",b.RunCurrentFile="testing.runCurrentFile",b.RunSelectedAction="testing.runSelected",b.RunUsingProfileAction="testing.runUsing",b.RunWithCoverageAction="testing.coverage",b.SearchForTestExtension="testing.searchForTestExtension",b.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",b.ShowMostRecentOutputAction="testing.showMostRecentOutput",b.StartContinousRun="testing.startContinuousRun",b.StopContinousRun="testing.stopContinuousRun",b.TestingSortByDurationAction="testing.sortByDuration",b.TestingSortByLocationAction="testing.sortByLocation",b.TestingSortByStatusAction="testing.sortByStatus",b.TestingViewAsListAction="testing.viewAsList",b.TestingViewAsTreeAction="testing.viewAsTree",b.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",b.ToggleInlineTestOutput="testing.toggleInlineTestOutput",b.UnhideAllTestsAction="testing.unhideAllTests",b.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Re[82],Oe([1,0,10,6,4,61,55,54]),function(be,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=e.$HQ=e.$GQ=e.$FQ=e.$EQ=e.TestItemEventOp=void 0;var m;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const s=(c,i)=>c===i,b=Object.entries({range:(c,i)=>c===i?!0:!c||!i?!1:c.equalsRange(i),busy:s,label:s,description:s,error:s,sortText:s,tags:(c,i)=>!(c.length!==i.length||c.some(n=>!i.includes(n)))}),u=(c,i)=>{let n;for(const[t,o]of b)o(c[t],i[t])||(n?n[t]=i[t]:n={[t]:i[t]});return n};class k extends P.$Zc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Wh(()=>this.flushDiff(),200)),this.g=this.B(new D.$qe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case R.TestDiffOpType.DocumentSynced:{for(const n of this.m)if(n.op===R.TestDiffOpType.DocumentSynced&&n.uri===i.uri){n.docv=i.docv;return}break}case R.TestDiffOpType.Update:{const n=this.m[this.m.length-1];if(n){if(n.op===R.TestDiffOpType.Update&&n.item.extId===i.item.extId){(0,R.$AJ)(n.item,i.item);return}if(n.op===R.TestDiffOpType.Add&&n.item.item.extId===i.item.extId){(0,R.$AJ)(n.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,n){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||n>t.expandLevels)&&(t.expandLevels=n),t.expand===R.TestItemExpandState.Expandable){const o=this.M(t);return o.isOpen()?this.L(t,n-1):o.wait().then(()=>this.L(t,n-1))}else if(t.expand===R.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,n-1)):this.L(t,n-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,n){switch(n.op){case m.RemoveChild:this.O(T.$tJ.joinToString(i.fullId,n.id));break;case m.Upsert:this.z(n.item,i);break;case m.Bulk:for(const t of n.ops)this.w(i,t);break;case m.SetTags:this.C(n.new,n.old,i.fullId.toString());break;case m.UpdateCanResolveChildren:this.J(i);break;case m.SetProp:this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:n.update}});break;case m.DocumentSynced:this.y(i.actual.uri);break;default:(0,L.$jd)(n)}}y(i){i&&this.pushDiff({op:R.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,n){const t=T.$tJ.fromExtHostTestItem(i,this.root.id,n?.actual),o=this.s.getApiFor(i);o.parent&&o.parent!==n?.actual&&this.s.getChildren(o.parent).delete(i.id);let l=this.tree.get(t.toString());if(!l){l={fullId:t,actual:i,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:R.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(i,n),this.pushDiff({op:R.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(i)}}),this.I(i,l,n);return}if(l.actual===i){this.H(i,l,n);return}if(l.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,n);const g=this.s.getChildren(l.actual),f=l.actual,d=u(this.s.toITestItem(f),this.s.toITestItem(i));this.s.getApiFor(f).listener=void 0,l.actual=i,l.resolveBarrier=void 0,l.expand=R.TestItemExpandState.NotExpandable,d&&(d.hasOwnProperty("tags")&&(this.C(i.tags,f.tags,t.toString()),delete d.tags),this.w(l,{op:m.SetProp,update:d})),this.I(i,l,n);for(const[E,y]of g)this.s.getChildren(i).get(y.id)||this.O(T.$tJ.joinToString(t,y.id));const S=l.expandLevels;S!==void 0&&queueMicrotask(()=>{l.expand===R.TestItemExpandState.Expandable&&(l.expandLevels=void 0,this.expand(t.toString(),S))}),this.y(l.actual.uri)}C(i,n,t){const o=new Set(n.map(l=>l.id));for(const l of i)o.delete(l.id)||this.D(l);this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(l=>(0,R.$yJ)(this.s.controllerId,l.id))}}}),o.forEach(this.F,this)}D(i){const n=this.j.get(i.id);n?n.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:R.TestDiffOpType.AddTag,tag:{id:(0,R.$yJ)(this.s.controllerId,i.id)}}))}F(i){const n=this.j.get(i);n&&!--n.refCount&&(this.j.delete(i),this.pushDiff({op:R.TestDiffOpType.RemoveTag,id:(0,R.$yJ)(this.s.controllerId,i)}))}G(i,n){this.s.getApiFor(i).parent=n&&n.actual!==this.root?n.actual:void 0}H(i,n,t){this.G(i,t);const o=this.s.getApiFor(i);o.parent=t?.actual,o.listener=l=>this.w(n,l),this.J(n)}I(i,n,t){this.H(i,n,t);for(const[o,l]of this.s.getChildren(i))this.z(l,n)}J(i){let n;this.h?i.resolveBarrier?n=i.resolveBarrier.isOpen()?R.TestItemExpandState.Expanded:R.TestItemExpandState.BusyExpanding:n=i.actual.canResolveChildren?R.TestItemExpandState.Expandable:R.TestItemExpandState.NotExpandable:n=R.TestItemExpandState.NotExpandable,n!==i.expand&&(i.expand=n,this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:n}}),n===R.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,n){if(n<0)return;const t=[];for(const[o,l]of this.s.getChildren(i.actual)){const g=this.expand(T.$tJ.joinToString(i.fullId,l.id),n);(0,v.$wh)(g)&&t.push(g)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const l=new v.$Jh;return l.open(),l}i.expand=R.TestItemExpandState.BusyExpanding,this.N(i);const n=i.resolveBarrier=new v.$Jh,t=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let o;try{o=this.h(i.actual===this.root?void 0:i.actual)}catch(l){t(l)}return(0,v.$wh)(o)?o.catch(t).then(()=>{n.open(),this.J(i)}):(n.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const n=this.tree.get(i);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:R.TestDiffOpType.Remove,itemId:i});const t=[n];for(;t.length;){const o=t.pop();if(o){this.s.getApiFor(o.actual).listener=void 0;for(const l of o.actual.tags)this.F(l.id);this.tree.delete(o.fullId.toString());for(const[l,g]of this.s.getChildren(o.actual))t.push(this.tree.get(T.$tJ.joinToString(o.fullId,g.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$EQ=k;class $ extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$FQ=$;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$GQ=r;class a extends Error{constructor(i,n,t){super(`TestItem with ID "${i}" is from controller "${n}" and cannot be added as a child of an item from controller "${t}".`)}}e.$HQ=a;const h=(c,i,n)=>{let t=new Map;return{get size(){return t.size},forEach(o,l){for(const g of t.values())o.call(l,g,this)},[Symbol.iterator](){return t.entries()},replace(o){const l=new Map,g=new Set(t.keys()),f={op:m.Bulk,ops:[]};for(const d of o){if(!(d instanceof n))throw new r(d.id);const S=i(d).controllerId;if(S!==c.controllerId)throw new a(d.id,S,c.controllerId);if(l.has(d.id))throw new $(d.id);l.set(d.id,d),g.delete(d.id),f.ops.push({op:m.Upsert,item:d})}for(const d of g.keys())f.ops.push({op:m.RemoveChild,id:d});c.listener?.(f),t=l},add(o){if(!(o instanceof n))throw new r(o.id);t.set(o.id,o),c.listener?.({op:m.Upsert,item:o})},delete(o){t.delete(o)&&c.listener?.({op:m.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.$IQ=h}),define(Re[118],Oe([1,0,82]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=e.$JQ=void 0;const D=new WeakMap,P=(R,T)=>{const m={controllerId:T};return D.set(R,m),m};e.$JQ=P;const L=R=>{const T=D.get(R);if(!T)throw new v.$GQ(R?.id||"<unknown>");return T};e.$KQ=L}),define(Re[83],Oe([1,0,30,15,2]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EEb=e.$DEb=e.$CEb=void 0,e.$FEb=L,e.$GEb=T,e.$CEb="vscode-cdn.net",e.$DEb=`vscode-resource.${e.$CEb}`,e.$EEb=`'self' https://*.${e.$CEb}`;function L(m,s){return m.scheme===D.Schemas.http||m.scheme===D.Schemas.https?m:(s&&s.authority&&s.isRemote&&m.scheme===D.Schemas.file&&(m=P.URI.from({scheme:D.Schemas.vscodeRemote,authority:s.authority,path:m.path})),P.URI.from({scheme:D.Schemas.https,authority:`${m.scheme}+${R(m.authority)}.${e.$DEb}`,path:m.path,fragment:m.fragment,query:m.query}))}function R(m){return m.replace(/./g,s=>{const I=s.charCodeAt(0);return I>=v.CharCode.a&&I<=v.CharCode.z||I>=v.CharCode.A&&I<=v.CharCode.Z||I>=v.CharCode.Digit0&&I<=v.CharCode.Digit9?s:"-"+I.toString(16).padStart(4,"0")})}function T(m){return m.replace(/-([0-9a-f]{4})/g,(s,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Re[201],Oe([1,0,6,4,83]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lrc=void 0;class L{constructor(T,m,s){this.d=T,this.e=m,this.f=s,this.a=0,this.b=new D.$Yc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const I=m.getVisibleTextEditors();for(const b of this.c.values())I.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,m,s,I,b){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){u=i;break}if(!u)throw new Error("not a visible editor");const k=this,$=this.a++,r=new v.$qe,a=new v.$qe,h=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$FEb)(i,k.f)}get cspSource(){return P.$EEb}set options(i){this.b=i,k.d.$setOptions($,i)}get options(){return this.b}set html(i){this.a=i,k.d.$setHtml($,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return k.d.$postMessage($,i)}},c=new class{constructor(){this.editor=T,this.line=m,this.height=s,this.webview=h,this.onDidDispose=a.event}dispose(){k.c.has($)&&(k.c.delete($),k.d.$disposeEditorInset($),a.fire(),a.dispose(),r.dispose())}};return this.d.$createEditorInset($,u.id,u.value.document.uri,m+1,s,I||{},b.identifier,b.extensionLocation),this.c.set($,{editor:T,inset:c,onDidReceiveMessage:r}),c}$onDidDispose(T){const m=this.c.get(T);m&&m.inset.dispose()}$onDidReceiveMessage(T,m){this.c.get(T)?.onDidReceiveMessage.fire(m)}}e.$lrc=L}),define(Re[119],Oe([1,0,3]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=e.$eN=void 0,e.$eN="__",e.$fN=(0,v.$Ki)("IAuthenticationService"),e.$gN=(0,v.$Ki)("IAuthenticationExtensionsService")}),define(Re[202],Oe([1,0,3,12]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DR=e.VariableKind=e.$CR=void 0,e.$CR=(0,v.$Ki)("configurationResolverService");var P;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(P||(e.VariableKind=P={}));class L extends D.$fb{constructor(T,m){super(m),this.variable=T}}e.$DR=L}),define(Re[203],Oe([1,0,22,79,14,25,23,103,9,202,13]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SR=void 0,v=Ve(v),D=Ve(D),P=Ve(P),L=Ve(L);class b{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,$,r,a){this.h=new Map,this.a=k,this.b=$,this.g=r,a&&(this.c=a.then(h=>this.i(h)))}i(k){if(R.$l){const $=Object.create(null);return Object.keys(k).forEach(r=>{$[r.toLowerCase()]=k[r]}),$}return k}resolveWithEnvironment(k,$,r){return this.l({env:this.i(k),userHome:void 0},$?$.uri:void 0,r)}async resolveAsync(k,$){const r={env:await this.c,userHome:await this.g};return this.l(r,k?k.uri:void 0,$)}async j(k,$,r,a){const h=L.$mo($);R.$l&&h.windows?Object.keys(h.windows).forEach(i=>h[i]=h.windows[i]):R.$m&&h.osx?Object.keys(h.osx).forEach(i=>h[i]=h.osx[i]):R.$n&&h.linux&&Object.keys(h.linux).forEach(i=>h[i]=h.linux[i]),delete h.windows,delete h.osx,delete h.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,k?k.uri:void 0,h,r,a)}async resolveAnyAsync(k,$,r){return this.j(k,$,r)}async resolveAnyMap(k,$,r){const a=new Map;return{newConfig:await this.j(k,$,r,a),resolvedVariables:a}}resolveWithInteractionReplace(k,$,r,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,$,r,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,$){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,$)}async l(k,$,r,a,h){if(P.$jg(r))return this.m(k,$,r,a,h);if(Array.isArray(r))return Promise.all(r.map(c=>this.l(k,$,c,a,h)));if(P.$lg(r)){const c=Object.create(null),i=await Promise.all(Object.keys(r).map(async n=>[await this.m(k,$,n,a,h),await this.l(k,$,r[n],a,h)]));for(const[n,t]of i)c[n]=t;return c}return r}m(k,$,r,a,h){return(0,I.$Cf)(r,b.VARIABLE_REGEXP,async(c,i)=>{if(i.includes(b.VARIABLE_LHS))return c;let n=await this.o(k,c,i,$,a);return h?.set(i,n),n!==c&&P.$jg(n)&&n.match(b.VARIABLE_REGEXP)&&(n=await this.m(k,$,n,a,h)),n})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,$,r,a,h){let c;const i=r.split(":");i.length>1&&(r=i[0],c=i[1]);const n=l=>{const g=this.a.getFilePath();if(g)return(0,T.$_w)(g);throw new s.$DR(l,(0,m.localize)(12113,null,$))},t=l=>{const g=n(l);if(this.a.getWorkspaceFolderPathForFile){const f=this.a.getWorkspaceFolderPathForFile();if(f)return(0,T.$_w)(f)}throw new s.$DR(l,(0,m.localize)(12114,null,$,v.$sc(g)))},o=l=>{if(c){const g=this.a.getFolderUri(c);if(g)return g;throw new s.$DR(l,(0,m.localize)(12115,null,$,c))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new s.$DR(l,(0,m.localize)(12116,null,$)):new s.$DR(l,(0,m.localize)(12117,null,$))};switch(r){case"env":if(c){if(k.env){const l=k.env[R.$l?c.toLowerCase():c];if(P.$jg(l))return l}return""}throw new s.$DR(s.VariableKind.Env,(0,m.localize)(12118,null,$));case"config":if(c){const l=this.a.getConfigurationValue(a,c);if(P.$sg(l))throw new s.$DR(s.VariableKind.Config,(0,m.localize)(12119,null,$,c));if(P.$lg(l))throw new s.$DR(s.VariableKind.Config,(0,m.localize)(12120,null,$,c));return l}throw new s.$DR(s.VariableKind.Config,(0,m.localize)(12121,null,$));case"command":return this.p(s.VariableKind.Command,$,c,h,"command");case"input":return this.p(s.VariableKind.Input,$,c,h,"input");case"extensionInstallFolder":if(c){const l=await this.a.getExtension(c);if(!l)throw new s.$DR(s.VariableKind.ExtensionInstallFolder,(0,m.localize)(12122,null,$,c));return this.n(l.extensionLocation)}throw new s.$DR(s.VariableKind.ExtensionInstallFolder,(0,m.localize)(12123,null,$));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,T.$_w)(this.n(o(s.VariableKind.WorkspaceFolder)));case"cwd":return a||c?(0,T.$_w)(this.n(o(s.VariableKind.Cwd))):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$_w)(v.$sc(this.n(o(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new s.$DR(s.VariableKind.UserHome,(0,m.localize)(12124,null,$))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new s.$DR(s.VariableKind.LineNumber,(0,m.localize)(12125,null,$))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new s.$DR(s.VariableKind.SelectedText,(0,m.localize)(12126,null,$))}case"file":return n(s.VariableKind.File);case"fileWorkspaceFolder":return t(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$sc(t(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||c?v.$qc(this.n(o(s.VariableKind.RelativeFile)),n(s.VariableKind.RelativeFile)):n(s.VariableKind.RelativeFile);case"relativeFileDirname":{const l=v.$rc(n(s.VariableKind.RelativeFileDirname));if(a||c){const g=v.$qc(this.n(o(s.VariableKind.RelativeFileDirname)),l);return g.length===0?".":g}return l}case"fileDirname":return v.$rc(n(s.VariableKind.FileDirname));case"fileExtname":return v.$tc(n(s.VariableKind.FileExtname));case"fileBasename":return v.$sc(n(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=v.$sc(n(s.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-v.$tc(l).length)}case"fileDirnameBasename":return v.$sc(v.$rc(n(s.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||$}case"execInstallFolder":{const l=this.a.getAppRoot();return l||$}case"pathSeparator":case"/":return v.sep;default:try{const l=c?`${r}:${c}`:r;return this.p(s.VariableKind.Unknown,$,l,h,void 0)}catch{return $}}}}p(k,$,r,a,h){if(r&&a){const c=h===void 0?a[r]:a[h+":"+r];if(typeof c=="string")return c;throw new s.$DR(k,(0,m.localize)(12127,null,$))}return $}}e.$SR=b}),define(Re[120],Oe([1,0,3,116]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$OE=void 0,e.$PE=s,e.$QE=u,e.$RE=k,e.$OE=(0,v.$Ki)("editorGroupsService");var P;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var L;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var T;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EXPAND=1]="EXPAND",$[$.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var m;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function s($){const r=$;return(0,D.$AG)(r?.editor)&&(0,D.$AG)(r?.replacement)}var I;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var b;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(b||(e.OpenEditorContext=b={}));function u($){const r=$;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function k($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Re[204],Oe([1,0,3,120]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=e.$TE=e.$SE=void 0,e.$WE=P,e.$SE=(0,v.$Ki)("editorService"),e.$TE=-1,e.$UE=-2,e.$VE=-3;function P(L){const R=L;return typeof L=="number"||(0,D.$QE)(R)}}),define(Re[205],Oe([1,0,3,107]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0,e.$yN=(0,v.$Li)(D.$Ri)}),define(Re[121],Oe([1,0,18,6,22,4,10]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=e.$mfc=e.$lfc=e.$kfc=void 0,P=Ve(P);class T{constructor(c,i){this.versionId=c,this.removedDueToLooping=i}}e.$kfc=T;class m{static isHostExtension(c,i,n){if(i.getExtensionDescription(c))return!1;const t=n.getExtensionDescription(c);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(c,i){this.j=c,this.c=new D.$qe,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new v.$Bn,this.g=[],this.h=new Map;for(const c of this.e){if(this.f.has(c.identifier)){console.error("Extension `"+c.identifier.value+"` is already registered");continue}this.f.set(c.identifier,c),this.g.push(c);const i=this.j.readActivationEvents(c);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(c)}}set(c){return this.e=c,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(c,i){this.e=a(this.e,i),this.e=this.e.concat(c);const n=m.l(this.e);return this.e=a(this.e,n.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,n)}static l(c){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(g){this.d.has(g)||(this.d.add(g),this.e.push(g))}addArc(g,f){this.addNode(g),this.addNode(f),this.c.has(g)?this.c.get(g).push(f):this.c.set(g,[f])}getArcs(g){return this.c.has(g)?this.c.get(g):[]}hasOnlyGoodArcs(g,f){const d=i.getArcs(g);for(let S=0;S<d.length;S++)if(!f.has(d[S]))return!1;return!0}getNodes(){return this.e}},n=new v.$Bn;for(const g of c)if(n.set(g.identifier,g),g.extensionDependencies)for(const f of g.extensionDependencies)i.addArc(v.$zn.toKey(g.identifier),v.$zn.toKey(f));const t=new Set;i.getNodes().filter(g=>i.getArcs(g).length===0).forEach(g=>t.add(g));const o=i.getNodes().filter(g=>!t.has(g));let l;do{l=!1;for(let g=0;g<o.length;g++){const f=o[g];i.hasOnlyGoodArcs(f,t)&&(o.splice(g,1),g--,t.add(f),l=!0)}}while(l);return o.map(g=>n.get(g))}containsActivationEvent(c){return this.h.has(c)}containsExtension(c){return this.f.has(c)}getExtensionDescriptionsForActivationEvent(c){const i=this.h.get(c);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new s(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(c){const i=this.f.get(c);return i||void 0}getExtensionDescriptionByUUID(c){for(const i of this.g)if(i.uuid===c)return i}getExtensionDescriptionByIdOrUUID(c,i){return this.getExtensionDescription(c)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$lfc=m;class s{constructor(c,i){this.versionId=c,this.extensions=i}}e.$mfc=s;class I{constructor(c){this.d=new k,this.c=new m(c,[])}async acquireLock(c){const i=await this.d.acquire(c);return new b(this,i)}deltaExtensions(c,i,n){if(!c.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(c){return this.c.containsActivationEvent(c)}containsExtension(c){return this.c.containsExtension(c)}getExtensionDescriptionsForActivationEvent(c){return this.c.getExtensionDescriptionsForActivationEvent(c)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(c){return this.c.getExtensionDescription(c)}getExtensionDescriptionByUUID(c){return this.c.getExtensionDescriptionByUUID(c)}getExtensionDescriptionByIdOrUUID(c,i){return this.c.getExtensionDescriptionByIdOrUUID(c,i)}}e.$nfc=I;class b extends L.$Zc{constructor(c,i){super(),this.f=c,this.c=!1,this.B(i)}isAcquiredFor(c){return!this.c&&this.f===c}}e.$ofc=b;class u{constructor(c){this.name=c;const i=(0,R.$Dh)();this.promise=i.promise,this.c=i.resolve}resolve(c){this.c(c)}}class k{constructor(){this.c=[],this.d=!1}async acquire(c){const i=new u(c);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const c=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${c.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};c.resolve((0,L.$Xc)(t))}}var $;(function(h){h[h.Builtin=0]="Builtin",h[h.User=1]="User",h[h.Dev=2]="Dev"})($||($={}));function r(h,c){const i=h.isBuiltin?$.Builtin:h.isUnderDevelopment?$.Dev:$.User,n=c.isBuiltin?$.Builtin:c.isUnderDevelopment?$.Dev:$.User;if(i!==n)return i-n;const t=P.$lc.basename(h.extensionLocation.path),o=P.$lc.basename(c.extensionLocation.path);return t<o?-1:t>o?1:0}function a(h,c){const i=new v.$An(c);return h.filter(n=>!i.has(n.identifier))}}),define(Re[84],Oe([1,0,20]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Jn=R,e.$Kn=T;var D;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(D||(e.UIKind=D={}));var P;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var L;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(s){const I=v.$Se.alloc(1);switch(s){case L.Initialized:I.writeUInt8(1,0);break;case L.Ready:I.writeUInt8(2,0);break;case L.Terminate:I.writeUInt8(3,0);break}return I}function T(s,I){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return I===L.Initialized;case 2:return I===L.Ready;case 3:return I===L.Terminate;default:return!1}}var m;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Re[66],Oe([1,0,3,6,113,11,26,84,62,63,25,2,4,9]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Q=e.$7Q=e.$6Q=void 0,e.$8Q=a;let $=class extends u.$Zc{constructor(c,i){super(),this.s=c,this.t=i,this.a=this.B(new D.$qe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new D.$qe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=b.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:s.$Kp,name:(0,k.localize)(2714,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,L.$hk)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(c,i,n){const t=this.getTelemetryDetails(),o=new r(i,n,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),l=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...l,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(c,i,n){this.f=c,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const i=Object.create(null);switch(i["common.extname"]=`${c.publisher}.${c.name}`,i["common.extversion"]=c.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,m.$qn)((0,s.$Qp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const i=this.getTelemetryDetails();this.r.forEach((n,t)=>{const o=n.filter(l=>!l.isDisposed);o.length===0?this.r.delete(t):this.r.set(t,o)}),this.r.forEach(n=>{for(const t of n)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,i){const t=this.r.get(c.value)?.filter(l=>!l.isDisposed);if(!t)return this.r.delete(c.value),!1;let o=!1;for(const l of t)l.ignoreUnhandledExtHostErrors||(l.logError(i),o=!0);return o}};e.$6Q=$,e.$6Q=$=Qe([We(0,R.$5Q),We(1,L.$gk)],$);class r{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,i,n,t,o,l,g){this.g=n,this.h=t,this.i=o,this.j=l,this.a=new D.$qe,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(c,i){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let i="properties"in c?c.properties??{}:c;return i=(0,s.$Tp)(i,[]),this.c&&(i=(0,I.$po)(i,this.c)),this.b||(i=(0,I.$po)(i,this.j)),"properties"in c?c.properties=i:c=i,c}k(c,i){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(c,i),this.h.trace(c,i))}logUsage(c,i){this.d.isUsageEnabled&&this.k(c,i)}logError(c,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,i);else{const n={name:c.name,message:c.message,stack:c.stack,cause:c.cause},t=(0,s.$Tp)(n,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const c=this,i={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$7Q=r;function a(h){const c=Date.now()-new Date(h).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$9Q=(0,v.$Ki)("IExtHostTelemetry")}),define(Re[21],Oe([1,0,6,2,179,112,18,3]),function(be,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IH=e.ActivationKind=e.$FH=e.$EH=e.$BH=e.ExtensionHostStartup=e.$AH=e.$zH=e.$yH=e.$xH=void 0,e.$CH=u,e.$DH=k,e.$GH=h,e.$HH=c,e.$xH=Object.freeze({identifier:new R.$zn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1,targetPlatform:R.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$yH="extensions.webWorker",e.$zH=(0,T.$Ki)("extensionService");class m{constructor(t){this.dependency=t}}e.$AH=m;var s;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,o,l){this.c=t,this.d=o.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$jH.createActivationEventsMap(this.d)}}set(t,o,l){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const g=[],f=[],d=[],S=[],E=b(this.d),y=b(o),C=(A,F)=>A.extensionLocation.toString()===F.extensionLocation.toString()||A.isBuiltin===F.isBuiltin||A.isUserBuiltin===F.isUserBuiltin||A.isUnderDevelopment===F.isUnderDevelopment;for(const A of this.d){const F=y.get(A.identifier);if(!F){g.push(A.identifier),E.delete(A.identifier);continue}if(!C(A,F)){g.push(A.identifier),E.delete(A.identifier);continue}}for(const A of o){const F=E.get(A.identifier);if(!F){f.push(A);continue}if(!C(F,A)){g.push(F.identifier),E.delete(F.identifier);continue}}const O=new R.$An(this.e),p=new R.$An(l);for(const A of this.e)p.has(A)||d.push(A);for(const A of l)O.has(A)||S.push(A);const w=L.$jH.createActivationEventsMap(f),M={versionId:t,toRemove:g,toAdd:f,addActivationEvents:w,myToRemove:d,myToAdd:S};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:o,toAdd:l,myToRemove:g,myToAdd:f}=t,d=new R.$An(o),S=new R.$An(g);for(let E=0;E<this.d.length;E++)d.has(this.d[E].identifier)&&(this.d.splice(E,1),E--);for(let E=0;E<this.e.length;E++)S.has(this.e[E])&&(this.e.splice(E,1),E--);for(const E of l)this.d.push(E);for(const E of f)this.e.push(E);return this.f=null,t}containsExtension(t){for(const o of this.e)if(R.$zn.equals(o,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const o of this.d){if(!this.containsExtension(o.identifier))continue;const l=L.$jH.readActivationEvents(o);for(const g of l)t.add(g)}return t}}e.$BH=I;function b(n){const t=new R.$Bn;for(const o of n)t.set(o.identifier,o);return t}function u(n,t){return!0}function k(n,t){if(!u(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}class ${constructor(t,o,l,g){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=l,this.activationReason=g}}e.$EH=$;class r{constructor(t,o){this.description=t,this.value=o}}e.$FH=r;var a;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function h(n){return{type:n.isBuiltin?R.ExtensionType.System:R.ExtensionType.User,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,P.$Zp)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}function c(n,t){const o=(0,P.$Xp)(n.manifest.publisher,n.manifest.name);return{id:o,identifier:new R.$zn(o),isBuiltin:n.type===R.ExtensionType.System,isUserBuiltin:n.type===R.ExtensionType.User&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,publisherDisplayName:n.publisherDisplayName,...n.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$IH=i}),define(Re[206],Oe([1,0,12,4,121,18,21,11,10]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mrc=e.$Lrc=e.$Krc=e.$Jrc=e.$Irc=e.$Hrc=void 0,v=Ve(v);class s{static{this.NONE=new s(!1,-1,-1,-1)}constructor(c,i,n,t){this.startup=c,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=t}}e.$Hrc=s;class I{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,i){return c===-1||i===-1?-1:i-c}build(){return new s(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Irc=I;class b{constructor(c,i,n,t,o,l){this.activationFailed=c,this.activationFailedError=i,this.activationTimes=n,this.module=t,this.exports=o,this.disposable=l}}e.$Jrc=b;class u extends b{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,D.$Zc.None)}}e.$Krc=u;class k extends b{constructor(){super(!1,null,s.NONE,{activate:void 0,deactivate:void 0},void 0,D.$Zc.None)}}e.$Lrc=k;class $ extends b{constructor(c){super(!0,c,s.NONE,{activate:void 0,deactivate:void 0},void 0,D.$Zc.None)}}let r=class{constructor(c,i,n,t){this.g=t,this.a=c,this.b=i,this.c=n,this.d=new L.$Bn,this.f=Object.create(null)}dispose(){for(const[c,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const c=[];for(const[i,n]of this.d)c.push(n.wait());await Promise.all(c)}isActivated(c){const i=this.d.get(c);return!!(i&&i.value)}getActivatedExtension(c){const i=this.d.get(c);if(!i||!i.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return i.value}async activateByEvent(c,i){if(this.f[c])return;const n=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(n.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,i){const n=this.a.getExtensionDescription(c);if(!n)throw new Error(`Extension '${c.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(c){const i=c.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const i=this.a.getExtensionDescription(c.id);if(!i){const o=new Error(`Cannot activate unknown extension '${c.id.value}'`),l=this.k(c,null,[],new $(o));return this.c.onExtensionActivationError(c.id,o,new R.$AH(c.id.value)),l}const n=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this.m(o))continue;const l=this.d.get(o);if(l){n.push(l);continue}if(this.l(o)){n.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:c.reason}));continue}const g=this.a.getExtensionDescription(o);if(g){if(!g.main&&!g.browser)continue;n.push(this.j({id:g.identifier,reason:c.reason}));continue}const f=i.displayName||i.identifier.value,d=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${o}'`),S=this.k(c,i.displayName,[],new $(d));return this.c.onExtensionActivationError(i.identifier,d,new R.$AH(o)),S}return this.k(c,i.displayName,n,null)}k(c,i,n,t){const o=new a(c.id,i,c.reason,n,t,this.c,this.g);return this.d.set(c.id,o),o}l(c){return P.$lfc.isHostExtension(c,this.a,this.b)}m(c){const i=this.b.getExtensionDescription(c);return i?!i.main&&!i.browser:!1}};e.$Mrc=r,e.$Mrc=r=Qe([We(3,T.$fk)],r);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,i,n,t,o,l,g){this.c=c,this.d=i,this.f=n,this.g=t,this.h=o,this.j=l,this.k=g,this.a=new m.$Jh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const i=this.g[c];if(i.value&&!i.value.activationFailed){this.g.splice(c,1),c--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new $(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const i=new Error;if(c&&c.name&&(i.name=c.name),c&&c.message?i.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(i.stack=c.stack),this.h=new $(i),this.b&&v.$8(c))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};a=Qe([We(6,T.$fk)],a)});var oi=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Re[122],Oe([1,0,9,12,37,111,78,29,18,109,112,105]),function(be,e,v,D,P,L,R,T,m,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=void 0,v=Ve(v),P=oi(P);const u=T.$zo.as(R.$Ao.JSONContribution);class k{constructor(t,o,l){this.a=t,this.b=o,this.c=l}d(t,o){this.a({type:t,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(P.default.Error,t)}warn(t){this.d(P.default.Warning,t)}info(t){this.d(P.default.Info,t)}}e.$rH=k;class ${static a(t){const o=new m.$An;for(let l=0,g=t.length;l<g;l++)o.add(t[l].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new $(o,[]);if(!o||!o.length)return new $([],t);const l=this.a(t),g=this.a(o),f=o.filter(S=>!l.has(S.description.identifier)),d=t.filter(S=>!g.has(S.description.identifier));return new $(f,d)}constructor(t,o){this.added=t,this.removed=o}}e.$sH=$;class r{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=$.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,D.$4)(t)}}}e.$tH=r;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(12282,null),v.localize(12283,null)]},h="vscode://schemas/vscode-extensions";e.$uH={properties:{engines:{type:"object",description:v.localize(12284,null),properties:{vscode:{type:"string",description:v.localize(12285,null),default:"^1.22.0"}}},publisher:{description:v.localize(12286,null),type:"string"},displayName:{description:v.localize(12287,null),type:"string"},categories:{description:v.localize(12288,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$yn},{type:"string",const:"Languages",deprecationMessage:v.localize(12289,null)}]}},galleryBanner:{type:"object",description:v.localize(12290,null),properties:{color:{description:v.localize(12291,null),type:"string"},theme:{description:v.localize(12292,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(12293,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(12294,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(12295,null)},enabledApiProposals:{markdownDescription:v.localize(12296,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals).map(n=>n),markdownEnumDescriptions:Object.values(b.allApiProposals).map(n=>n.proposal)}},api:{markdownDescription:v.localize(12297,null),type:"string",enum:["none"],enumDescriptions:[v.localize(12298,null)]},activationEvents:{description:v.localize(12299,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(12300,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(12301,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(12302,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(12303,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(12304,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(12305,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(12306,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(12307,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(12308,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(12309,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(12310,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(12311,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(12312,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(12313,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(12314,null)},{label:"onUri",body:"onUri",description:v.localize(12315,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(12316,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(12317,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(12318,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(12319,null)},{label:"onRenderer",description:v.localize(12320,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(12321,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(12322,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(12323,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(12324,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(12325,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolId}",description:v.localize(12326,null)},{label:"*",description:v.localize(12327,null),body:"*"}]}},badges:{type:"array",description:v.localize(12328,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(12329,null)},href:{type:"string",description:v.localize(12330,null)},description:{type:"string",description:v.localize(12331,null)}}}},markdown:{type:"string",description:v.localize(12332,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(12333,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(12334,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$gp}},extensionPack:{description:v.localize(12335,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$gp}},extensionKind:{description:v.localize(12336,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(12337,null)},{body:["workspace"],description:v.localize(12338,null)},{body:["ui","workspace"],description:v.localize(12339,null)},{body:["workspace","ui"],description:v.localize(12340,null)},{body:[],description:v.localize(12341,null)}]},capabilities:{description:v.localize(12342,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(12343,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(12344,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(12345,null),v.localize(12346,null),v.localize(12347,null)]},description:{type:"string",markdownDescription:v.localize(12348,null)}}},untrustedWorkspaces:{description:v.localize(12349,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(12350,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(12351,null),v.localize(12352,null),v.localize(12353,null)]},restrictedConfigurations:{description:v.localize(12354,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(12355,null)}}}}},sponsor:{description:v.localize(12356,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(12357,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(12358,null),type:"string"},"vscode:uninstall":{description:v.localize(12359,null),type:"string"}}},icon:{type:"string",description:v.localize(12360,null)},l10n:{type:"string",description:v.localize(12361,null)},pricing:{type:"string",markdownDescription:v.localize(12362,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new r(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,o),t.activationEventsGenerator&&I.$jH.register(t.extensionPoint,t.activationEventsGenerator),e.$uH.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(h,e.$uH),o}getExtensionPoints(){return Array.from(this.a.values())}}e.$vH=c;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$zo.add(i.ExtensionsRegistry,new c),e.$wH=T.$zo.as(i.ExtensionsRegistry),u.registerSchema(h,e.$uH),u.registerSchema(s.$zk,{properties:{extensionEnabledApiProposals:{description:v.localize(12363,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals).map(n=>n.proposal)}}]}}}})}),define(Re[207],Oe([1,0,6,41,4,13,9,18,3,11,21,122]),function(be,e,v,D,P,L,R,T,m,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LH=e.$KH=e.$JH=e.ChatMessageRole=void 0;var u;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$JH=(0,m.$Ki)("ILanguageModelsService");const k={type:"object",properties:{vendor:{type:"string",description:(0,R.localize)(4744,null)}}};e.$KH=b.$wH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,R.localize)(4745,null),oneOf:[k,{type:"array",items:k}]},activationEventsGenerator:(r,a)=>{for(const h of r)a.push(`onLanguageModelChat:${h.vendor}`)}});let $=class{constructor(a,h){this.e=a,this.f=h,this.a=new P.$Yc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$qe),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$KH.setHandler(c=>{this.c.clear();for(const n of c){if(!(0,I.$CH)(n.description,"chatProvider")){n.collector.error((0,R.localize)(4746,null));continue}for(const t of D.Iterable.wrap(n.value)){if(this.c.has(t.vendor)){n.collector.error((0,R.localize)(4747,null,t.vendor));continue}if((0,L.$hf)(t.vendor)){n.collector.error((0,R.localize)(4748,null));continue}if(t.vendor.trim()!==t.vendor){n.collector.error((0,R.localize)(4749,null));continue}this.c.add(t.vendor)}}const i=[];for(const[n,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(n),i.push(n));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(a){return this.b.get(a)?.metadata}async selectLanguageModels(a){if(a.vendor)await this.e.activateByEvent(`onLanguageModelChat:${a.vendor}}`);else{const c=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(c)}const h=[];for(const[c,i]of this.b)(a.vendor===void 0||i.metadata.vendor===a.vendor)&&(a.family===void 0||i.metadata.family===a.family)&&(a.version===void 0||i.metadata.version===a.version)&&(a.identifier===void 0||i.metadata.id===a.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(n=>T.$zn.equals(n,a.extension)))&&h.push(c);return this.f.trace("[LM] selected language models",a,h),h}registerLanguageModelChat(a,h){if(this.f.trace("[LM] registering language model chat",a,h.metadata),!this.c.has(h.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${h.metadata.vendor}.`);if(this.b.has(a))throw new Error(`Chat response provider with identifier ${a} is already registered.`);return this.b.set(a,h),this.d.fire({added:[{identifier:a,metadata:h.metadata}]}),(0,P.$Xc)(()=>{this.b.delete(a)&&(this.d.fire({removed:[a]}),this.f.trace("[LM] UNregistered language model chat",a,h.metadata))})}async sendChatRequest(a,h,c,i,n){const t=this.b.get(a);if(!t)throw new Error(`Chat response provider with identifier ${a} is not registered.`);return t.sendChatRequest(c,h,i,n)}computeTokenLength(a,h,c){const i=this.b.get(a);if(!i)throw new Error(`Chat response provider with identifier ${a} is not registered.`);return i.provideTokenCount(h,c)}};e.$LH=$,e.$LH=$=Qe([We(0,I.$zH),We(1,s.$fk)],$)}),define(Re[208],Oe([1,0,9,14,25,122,31,6]),function(be,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hJ=void 0,v=Ve(v),D=Ve(D),P=Ve(P);const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(9883,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(9884,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(9885,null),default:""}}};var s;(function(u){function k($,r,a){if(!$)return;const h=D.$jg($.type)?$.type:void 0;if(!h||h.length===0){a.error(v.localize(9886,null));return}const c=[];if(Array.isArray($.required))for(const i of $.required)D.$jg(i)&&c.push(i);return{extensionId:r.value,taskType:h,required:c,properties:$.properties?P.$mo($.properties):{},when:$.when?R.$Ij.deserialize($.when):void 0}}u.from=k})(s||(s={}));const I=L.$wH.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,k)=>{for(const $ of u)$.type&&k.push(`onTaskType:${$.type}`)},jsonSchema:{description:v.localize(9887,null),type:"array",items:m}});class b{constructor(){this.d=new T.$qe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,$)=>{I.setHandler((r,a)=>{this.c=void 0;try{for(const h of a.removed){const c=h.value;for(const i of c)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const h of a.added){const c=h.value;for(const i of c){const n=s.from(i,h.description.identifier,h.collector);n&&(this.a[n.taskType]=n)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const $ of this.all()){const r={type:"object",additionalProperties:!1};$.required.length>0&&(r.required=$.required.slice(0)),$.properties!==void 0?r.properties=P.$mo($.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[$.taskType]},k.push(r)}this.c={oneOf:k}}return this.c}}e.$hJ=new b}),define(Re[209],Oe([1,0,9,14,24,25,31,208,44]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$rJ=e.JsonSchemaVersion=e.ExecutionEngine=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$lJ=e.ShellQuoting=e.$kJ=e.$jJ=e.$iJ=void 0,v=Ve(v),D=Ve(D),P=Ve(P),L=Ve(L),e.$iJ="settings",e.$jJ=new R.$2j("taskRunning",!1,v.localize(9888,null)),e.$kJ=v.localize2(9890,"Tasks");var s;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(s||(e.ShellQuoting=s={})),e.$lJ="$customized",function(j){function U(J){if(!J)return j.Strong;switch(J.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=U}(s||(e.ShellQuoting=s={}));var I;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var b;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(b||(e.RevealKind=b={})),function(j){function U(J){switch(J.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=U}(b||(e.RevealKind=b={}));var u;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(j){function U(J){switch(J.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=U}(u||(e.RevealProblemKind=u={}));var k;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(k||(e.PanelKind=k={})),function(j){function U(J){switch(J.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=U}(k||(e.PanelKind=k={}));var $;(function(j){j.defaults={echo:!0,reveal:b.Always,revealProblems:u.Never,focus:!1,panel:k.Shared,showReuseMessage:!0,clear:!1}})($||(e.PresentationOptions=$={}));var r;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(j){function U(Z){switch(Z.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=U;function J(Z){switch(Z){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=J}(r||(e.RuntimeType=r={}));var a;(function(j){function U(J){return D.$jg(J)?J:J.value}j.value=U})(a||(e.CommandString=a={}));var h;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function U(Z){return Z===j.Clean._id||Z===j.Build._id||Z===j.Rebuild._id||Z===j.Test._id}j.is=U;function J(Z){if(Z!==void 0)return D.$jg(Z)?U(Z)?{_id:Z,isDefault:!1}:void 0:Z}j.from=J})(h||(e.TaskGroup=h={}));var c;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var i;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function U(J){switch(J){case j.User:return m.ConfigurationTarget.USER;case j.WorkspaceFile:return m.ConfigurationTarget.WORKSPACE;default:return m.ConfigurationTarget.WORKSPACE_FOLDER}}j.toConfigurationTarget=U})(i||(e.TaskSourceKind=i={}));var n;(function(j){j.parallel="parallel",j.sequence="sequence"})(n||(e.DependsOrder=n={}));var t;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class l{constructor(U,J,Z,ae,ee,oe){this._label="",this._id=U,J&&(this._label=J),Z&&(this.type=Z),this.runOptions=ae,this.configurationProperties=ee,this._source=oe}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,J=!1){if(U===void 0)return!1;if(D.$jg(U))return U===this._label||U===this.configurationProperties.identifier||J&&U===this._id;const Z=this.getDefinition(!0);return Z!==void 0&&Z._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$mJ=l;class g extends l{constructor(U,J,Z,ae,ee,oe,ie,ue){super(U,Z,void 0,ie,ue,J),this.command={},this._source=J,this.hasDefinedMatchers=oe,ee&&(this.command=ee)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let J;switch(this.command?this.command.runtime:void 0){case r.Shell:J="shell";break;case r.Process:J="process";break;case r.CustomExecution:J="customExecution";break;case void 0:J="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:J,_key:this._id,id:this._id}}}static is(U){return U instanceof g}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$iJ:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let J=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(J+=this._source.kind);const Z={type:e.$lJ,folder:U,id:J};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ih(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new g(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$nJ=g;class f extends l{constructor(U,J,Z,ae,ee,oe,ie){super(U,Z,ae,oe,ie,J),this._source=J,this.configures=ee}static is(U){return U instanceof f}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ih(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$iJ:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let J=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(J+=this._source.kind);const Z={type:e.$lJ,folder:U,id:J};return JSON.stringify(Z)}}e.$oJ=f;class d extends l{constructor(U,J,Z,ae,ee,oe,ie,ue,_){super(U,Z,ae,ue,_,J),this.defines=ee,this.hasDefinedMatchers=ie,this.command=oe,this.icon=_.icon,this.hide=_.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof d}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===c.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new d(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$pJ=d;class S extends l{constructor(U,J,Z,ae,ee,oe){super(U,Z,ae,ee,oe,J),this._source=J}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new S(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$qJ=S;var E;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(E||(e.ExecutionEngine=E={})),function(j){j._default=j.Terminal}(E||(e.ExecutionEngine=E={}));var y;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class C{constructor(U){this.c=new Map;for(let J=0;J<U.length;J++)this.c.set(U[J].uri.toString(),J)}compare(U,J){const Z=U.getWorkspaceFolder(),ae=J.getWorkspaceFolder();if(Z&&ae){let ee=this.c.get(Z.uri.toString());ee=ee===void 0?0:ee+1;let oe=this.c.get(ae.uri.toString());return oe=oe===void 0?0:oe+1,ee===oe?U._label.localeCompare(J._label):ee-oe}else return!Z&&ae?-1:Z&&!ae?1:0}}e.$rJ=C;var O;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(O||(e.TaskEventKind=O={}));var p;(function(j){j.SingleRun="singleRun",j.Background="background"})(p||(e.TaskRunType=p={}));var w;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var M;(function(j){function U(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?p.Background:p.SingleRun,group:ue.configurationProperties.group,__task:ue}}function J(ue,_,$e){return{...U(ue),kind:O.Start,terminalId:_,resolvedVariables:$e}}j.start=J;function Z(ue,_,$e){return{...U(ue),kind:O.ProcessStarted,terminalId:_,processId:$e}}j.processStarted=Z;function ae(ue,_,$e){return{...U(ue),kind:O.ProcessEnded,terminalId:_,exitCode:$e}}j.processEnded=ae;function ee(ue,_,$e){return{...U(ue),kind:O.Terminated,exitReason:$e,terminalId:_}}j.terminated=ee;function oe(ue,_,$e){return{...U(_),kind:ue,terminalId:$e}}j.general=oe;function ie(){return{kind:O.Changed}}j.changed=ie})(M||(e.TaskEvent=M={}));var A;(function(j){function U(Z){const ae=Object.keys(Z).sort();let ee="";for(const oe of ae){let ie=Z[oe];ie instanceof Object?ie=U(ie):typeof ie=="string"&&(ie=ie.replace(/,/g,",,")),ee+=oe+","+ie+","}return ee}function J(Z){const ee={_key:U(Z),type:Z.taskType};return Object.assign(ee,Z),ee}j.create=J})(A||(e.KeyedTaskIdentifier=A={}));var F;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var G;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(G||(e.TasksSchemaProperties=G={}));var x;(function(j){function U(J,Z){const ae=T.$hJ.get(J.type);if(ae===void 0){const ue=L.$mo(J);return delete ue._key,A.create(ue)}const ee=Object.create(null);ee.type=ae.taskType;const oe=new Set;ae.required.forEach(ue=>oe.add(ue));const ie=ae.properties;for(const ue of Object.keys(ie)){const _=J[ue];if(_!=null)ee[ue]=_;else if(oe.has(ue)){const $e=ie[ue];if($e.default!==void 0)ee[ue]=L.$mo($e.default);else switch($e.type){case"boolean":ee[ue]=!1;break;case"number":case"integer":ee[ue]=0;break;case"string":ee[ue]="";break;default:Z.error(v.localize(9889,null,JSON.stringify(J,void 0,0),ue));return}}}return A.create(ee)}j.createTaskIdentifier=U})(x||(e.TaskDefinition=x={}))}),define(Re[210],Oe([1,0,12]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=e.$pfc=void 0;class D{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,T)=>{this.b=R,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,v.$4)(R))}then(R,T){return this.j().then(R,T)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$pfc=D;class P extends D{constructor(){super(),this.h=!0,this.i=new v.$9}}e.$qfc=P}),define(Re[39],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9w=e.$6w=void 0,e.$7w=P,e.$8w=L;class v{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++v.count}}e.$6w=v;const D=[];function P(T){const m=new v(T);return D[m.nid]=m,m}function L(T){return D[T].sid}class R{constructor(m){this.value=m}}e.$9w=R}),define(Re[5],Oe([1,0,39]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=e.$bO=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$aO=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(D||(e.TextEditorRevealType=D={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var L;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var T;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var m;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var s;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var I;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class b{static{this.a=0}static mixin(a){return a._id=b.a++,a}}e.$aO=b;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var k;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var $;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$bO={MainThreadAuthentication:(0,v.$7w)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$7w)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$7w)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$7w)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$7w)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$7w)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$7w)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$7w)("MainThreadClipboard"),MainThreadCommands:(0,v.$7w)("MainThreadCommands"),MainThreadComments:(0,v.$7w)("MainThreadComments"),MainThreadConfiguration:(0,v.$7w)("MainThreadConfiguration"),MainThreadConsole:(0,v.$7w)("MainThreadConsole"),MainThreadDebugService:(0,v.$7w)("MainThreadDebugService"),MainThreadDecorations:(0,v.$7w)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$7w)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$7w)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$7w)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$7w)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$7w)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$7w)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$7w)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$7w)("MainThreadErrors"),MainThreadTreeViews:(0,v.$7w)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$7w)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$7w)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$7w)("MainThreadLanguages"),MainThreadLogger:(0,v.$7w)("MainThreadLogger"),MainThreadMessageService:(0,v.$7w)("MainThreadMessageService"),MainThreadOutputService:(0,v.$7w)("MainThreadOutputService"),MainThreadProgress:(0,v.$7w)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$7w)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$7w)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$7w)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$7w)("MainThreadSecretState"),MainThreadStorage:(0,v.$7w)("MainThreadStorage"),MainThreadSpeech:(0,v.$7w)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$7w)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$7w)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$7w)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$7w)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$7w)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$7w)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$7w)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$7w)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$7w)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$7w)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$7w)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$7w)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$7w)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$7w)("MainThreadExtensionService"),MainThreadSCM:(0,v.$7w)("MainThreadSCM"),MainThreadSearch:(0,v.$7w)("MainThreadSearch"),MainThreadShare:(0,v.$7w)("MainThreadShare"),MainThreadTask:(0,v.$7w)("MainThreadTask"),MainThreadWindow:(0,v.$7w)("MainThreadWindow"),MainThreadLabelService:(0,v.$7w)("MainThreadLabelService"),MainThreadNotebook:(0,v.$7w)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$7w)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$7w)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$7w)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$7w)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$7w)("MainThreadInteractive"),MainThreadTheming:(0,v.$7w)("MainThreadTheming"),MainThreadTunnelService:(0,v.$7w)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$7w)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$7w)("MainThreadTimeline"),MainThreadTesting:(0,v.$7w)("MainThreadTesting"),MainThreadLocalization:(0,v.$7w)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$7w)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$7w)("MainThreadAiEmbeddingVector")},e.$cO={ExtHostCommands:(0,v.$7w)("ExtHostCommands"),ExtHostConfiguration:(0,v.$7w)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$7w)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$7w)("ExtHostDebugService"),ExtHostDecorations:(0,v.$7w)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$7w)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$7w)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$7w)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$7w)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$7w)("ExtHostEditors"),ExtHostTreeViews:(0,v.$7w)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$7w)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$7w)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$7w)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$7w)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$7w)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$7w)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$7w)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$7w)("ExtHostStatusBar"),ExtHostShare:(0,v.$7w)("ExtHostShare"),ExtHostExtensionService:(0,v.$7w)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$7w)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$7w)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$7w)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$7w)("ExtHostSCM"),ExtHostSearch:(0,v.$7w)("ExtHostSearch"),ExtHostTask:(0,v.$7w)("ExtHostTask"),ExtHostWorkspace:(0,v.$7w)("ExtHostWorkspace"),ExtHostWindow:(0,v.$7w)("ExtHostWindow"),ExtHostWebviews:(0,v.$7w)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$7w)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$7w)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$7w)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$7w)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$7w)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$7w)("ExtHostProgress"),ExtHostComments:(0,v.$7w)("ExtHostComments"),ExtHostSecretState:(0,v.$7w)("ExtHostSecretState"),ExtHostStorage:(0,v.$7w)("ExtHostStorage"),ExtHostUrls:(0,v.$7w)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$7w)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$7w)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$7w)("ExtHostOutputService"),ExtHostLabelService:(0,v.$7w)("ExtHostLabelService"),ExtHostNotebook:(0,v.$7w)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$7w)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$7w)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$7w)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$7w)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$7w)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$7w)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$7w)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$7w)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$7w)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$7w)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$7w)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$7w)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$7w)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$7w)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$7w)("ExtHostTheming"),ExtHostTunnelService:(0,v.$7w)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$7w)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$7w)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$7w)("ExtHostTimeline"),ExtHostTesting:(0,v.$7w)("ExtHostTesting"),ExtHostTelemetry:(0,v.$7w)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$7w)("ExtHostLocalization")}}),define(Re[85],Oe([1,0,3,11,5,16]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=e.$8qc=e.$7qc=void 0,P=Ve(P),e.$7qc=(0,v.$Ki)("IExtHostApiDeprecationService");let R=class{constructor(m,s){this.c=s,this.a=new Set,this.b=m.getProxy(P.$bO.MainThreadTelemetry)}report(m,s,I){const b=this.d(m,s);this.a.has(b)||(this.a.add(b),s.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:s.identifier.value,apiId:m}))}d(m,s){return`${m}-${s.identifier.value}`}};e.$8qc=R,e.$8qc=R=Qe([We(0,L.$OQ),We(1,D.$fk)],R),e.$9qc=Object.freeze(new class{report(T,m,s){}})}),define(Re[211],Oe([1,0,5]),function(be,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=void 0;class D{constructor(L){const R=L.getProxy(v.$bO.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(T){return R.$writeText(T)}})}}e.$jrc=D}),define(Re[212],Oe([1,0,25,5,26,16]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ktc=void 0;let R=class{constructor(I,b){this.a=I.getProxy(D.$bO.MainThreadConsole),this.b=b.consoleForward.includeStack,this.c=b.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,b){const u=this,k=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,b,k,arguments)}})}e(I,b,u,k){this.a.$logExtensionHostMessage({type:"__$console",severity:b,arguments:m(k,this.b)}),this.c&&this.f(I,u,k)}};e.$ktc=R,e.$ktc=R=Qe([We(0,L.$OQ),We(1,P.$5Q)],R);const T=1e5;function m(s,I){const b=[];if(s.length)for(let u=0;u<s.length;u++){let k=s[u];if(typeof k>"u")k="undefined";else if(k instanceof Error){const $=k;$.stack?k=$.stack:k=$.toString()}b.push(k)}if(I){const u=new Error().stack;u&&b.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,v.$ro)(b);return u.length>T?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Re[213],Oe([1,0,2,5,21]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lsc=void 0;class L{constructor(T){this.a=T.getProxy(D.$bO.MainThreadDialogs)}showOpenDialog(T,m){return m?.allowUIResources&&(0,P.$DH)(T,"showLocal"),this.a.$showOpenDialog(m).then(s=>s?s.map(I=>v.URI.revive(I)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(m=>m?v.URI.revive(m):void 0)}}e.$lsc=L}),define(Re[214],Oe([1,0,19,6,4,5]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$osc=void 0;class R{constructor(m){this.b=new Map,this.c=new D.$qe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=m.getProxy(L.$bO.MainThreadEmbeddings)}registerEmbeddingsProvider(m,s,I){if(this.d.has(s))throw new Error("An embeddings provider for this model is already registered");const b=this.e++;return this.a.$registerEmbeddingProvider(b,s),this.b.set(b,{id:s,provider:I}),(0,P.$Xc)(()=>{this.d.delete(s),this.a.$unregisterEmbeddingProvider(b),this.b.delete(b)})}async computeEmbeddings(m,s,I){I??=v.CancellationToken.None;let b=!1;typeof s=="string"&&(s=[s],b=!0);const u=await this.a.$computeEmbeddings(m,s,I);if(u.length!==s.length)throw new Error;if(b){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(m,s,I){const b=this.b.get(m);if(!b)return[];const u=await b.provider.provideEmbeddings(s,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(m){this.d=new Set(m),this.c.fire()}}e.$osc=R}),define(Re[215],Oe([1,0,4,5]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ksc=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(D.$bO.MainThreadLabelService)}$registerResourceLabelFormatter(R){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,R),(0,v.$Xc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$Ksc=P}),define(Re[86],Oe([1,0,23,13,2,3,11,5,26,16]),function(be,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2rc=e.$1rc=void 0;let I=class{constructor(u,k,$){this.f=$,this.d=new Map,this.a=k.getProxy(T.$bO.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===v.$j}getMessage(u,k){const{message:$,args:r,comment:a}=k;if(this.c)return(0,D.$jf)($,r??{});let h=$;a&&a.length>0&&(h+=`/${Array.isArray(a)?a.join(""):a}`);const c=this.d.get(u)?.contents[h];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,D.$jf)(c??$,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let k;const $=await this.g(u);if(!$){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents($),a=JSON.parse(r);k=u.isBuiltin?a.contents?.bundle:a}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${$}: ${r.message}`);return}k&&this.d.set(u.identifier.value,{contents:k,uri:$})}async g(u){if(u.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return P.URI.revive(k)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$1rc=I,e.$1rc=I=Qe([We(0,m.$5Q),We(1,s.$OQ),We(2,R.$fk)],I),e.$2rc=(0,L.$Ki)("IExtHostLocalizationService")}),define(Re[216],Oe([1,0,11,5,26,16,2,34]),function(be,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jtc=void 0;let m=class extends v.$qk{constructor(b,u){super(u.logLevel,u.logsLocation,u.loggers.map(k=>(0,T.$hi)(k))),this.r=b.getProxy(D.$bO.MainThreadLogger)}$setLogLevel(b,u){u?this.setLogLevel(R.URI.revive(u),b):this.setLogLevel(b)}setVisibility(b,u){super.setVisibility(b,u),this.r.$setVisibility(b,u)}s(b,u,k){return new s(this.r,b,u,k)}};e.$jtc=m,e.$jtc=m=Qe([We(0,L.$OQ),We(1,P.$5Q)],m);class s extends v.$lk{constructor(b,u,k,$){super($?.logLevel==="always"),this.r=b,this.s=u,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(u,$).then(()=>{this.u(this.n),this.m=!0})}g(b,u){const k=[[b,u]];this.m?this.u(k):this.n.push(...k)}u(b){this.r.$log(this.s,b)}flush(){this.r.$flush(this.s)}}}),define(Re[87],Oe([1,0,5,3,4,16,20]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4rc=e.$3rc=void 0,e.$3rc=(0,D.$Ki)("IExtHostManagedSockets");let T=class{constructor(b){this.b=0,this.c=null,this.d=new Map,this.a=b.getProxy(v.$bO.MainThreadManagedSockets)}setFactory(b,u){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(b,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(b){if(!this.c||this.c.socketFactoryId!==b)throw new Error(`No socket factory with id ${b}`);const u=++this.b,k=await this.c.makeConnection(),$=new P.$Yc;return this.d.set(u,new s(u,k,$)),$.add((0,P.$Xc)(()=>this.d.delete(u))),$.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),$.dispose()})),$.add(k.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),$.dispose()})),$.add(k.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,R.$Se.wrap(r)))),u}$remoteSocketWrite(b,u){this.d.get(b)?.actual.send(u.buffer)}$remoteSocketEnd(b){const u=this.d.get(b);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(b){await this.d.get(b)?.actual.drain?.()}};e.$4rc=T,e.$4rc=T=Qe([We(0,L.$OQ)],T);class m{constructor(b,u){this.socketFactoryId=b,this.makeConnection=u}}class s extends P.$Zc{constructor(b,u,k){super(),this.socketId=b,this.actual=u,this.B(k)}}}),define(Re[217],Oe([1,0,5,11,21]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nsc=void 0;function L(T){return T&&T.title}let R=class{constructor(m,s){this.b=s,this.a=m.getProxy(v.$bO.MainThreadMessageService)}showMessage(m,s,I,b,u){const k={source:{identifier:m.identifier,label:m.displayName||m.name}};let $;typeof b=="string"||L(b)?$=[b,...u]:(k.modal=b?.modal,k.useCustom=b?.useCustom,k.detail=b?.detail,$=u),k.useCustom&&(0,P.$DH)(m,"resolvers");const r=[];let a=!1;for(let h=0;h<$.length;h++){const c=$[h];if(typeof c=="string")r.push({title:c,handle:h,isCloseAffordance:!1});else if(typeof c=="object"){const{title:i,isCloseAffordance:n}=c;r.push({title:i,isCloseAffordance:!!n,handle:h}),n&&(a?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,c):a=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,c)}return this.a.$showMessage(s,I,k,r).then(h=>{if(typeof h=="number")return $[h]})}};e.$Nsc=R,e.$Nsc=R=Qe([We(1,D.$fk)],R)}),define(Re[218],Oe([1,0,4,14,2,21,5]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wsc=void 0;class T{constructor(s){this.b=new Map,this.a=s.getProxy(R.$bO.MainThreadProfileContentHandlers)}registerProfileContentHandler(s,I,b){if((0,L.$DH)(s,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,b),this.a.$registerProfileContentHandler(I,b.name,b.description,s.identifier.value),(0,v.$Xc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(s,I,b,u){const k=this.b.get(s);if(!k)throw new Error(`Unknown handler with id: ${s}`);return k.saveProfile(I,b,u)}async $readProfile(s,I,b){const u=this.b.get(s);if(!u)throw new Error(`Unknown handler with id: ${s}`);return u.readProfile((0,D.$jg)(I)?I:P.URI.revive(I),b)}}e.$Wsc=T}),define(Re[88],Oe([1,0,5,6,3]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yrc=e.$Xrc=void 0;class L{constructor(T){this.b=new D.$qe,this.onDidChangePassword=this.b.event,this.a=T.getProxy(v.$bO.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,m){return this.a.$getPassword(T,m)}store(T,m,s){return this.a.$setPassword(T,m,s)}delete(T,m){return this.a.$deletePassword(T,m)}}e.$Xrc=L,e.$Yrc=(0,P.$Ki)("IExtHostSecretState")}),define(Re[219],Oe([1,0,19,4,5]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4sc=void 0;class L{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(P.$bO.MainThreadSpeech)}async $createSpeechToTextSession(T,m,s){const I=this.c.get(T);if(!I)return;const b=new D.$Yc,u=new v.$Be;this.d.set(m,u);const k=await I.provideSpeechToTextSession(u.token,s?{language:s}:void 0);k&&(b.add(k.onDidChange($=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,$)})),b.add(u.token.onCancellationRequested(()=>b.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,m,s){const I=this.c.get(T);if(!I)return;const b=new D.$Yc,u=new v.$Be;this.d.set(m,u);const k=await I.provideTextToSpeechSession(u.token,s?{language:s}:void 0);k&&(this.f.set(m,k),b.add(k.onDidChange($=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,$)})),b.add(u.token.onCancellationRequested(()=>b.dispose())))}async $synthesizeSpeech(T,m){this.f.get(T)?.synthesize(m)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,m){const s=this.c.get(T);if(!s)return;const I=new D.$Yc,b=new v.$Be;this.d.set(m,b);const u=await s.provideKeywordRecognitionSession(b.token);u&&(I.add(u.onDidChange(k=>{b.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,k)})),I.add(b.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,m,s){const I=L.a++;return this.c.set(I,s),this.b.$registerProvider(I,m,{extension:T,displayName:T.value}),(0,D.$Xc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$4sc=L}),define(Re[89],Oe([1,0,5,6,3]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Orc=e.$Nrc=void 0;class L{constructor(T,m){this.c=m,this.b=new D.$qe,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(v.$bO.MainThreadStorage)}registerExtensionStorageKeysToSync(T,m){this.a.$registerExtensionStorageKeysToSync(T,m)}async initializeExtensionStorage(T,m,s){const I=await this.a.$initializeExtensionStorage(T,m);let b;return I&&(b=this.d(T,m,I)),b||s}setValue(T,m,s){return this.a.$setValue(T,m,s)}$acceptValue(T,m,s){const I=this.d(T,m,s);I&&this.b.fire({shared:T,key:m,value:I})}d(T,m,s){try{return JSON.parse(s)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${T}): ${I}`)}}}e.$Nrc=L,e.$Orc=(0,P.$Ki)("IExtHostStorage")}),define(Re[220],Oe([1,0,4,15,2,5]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dtc=void 0;class R{static{this.a=new Set([D.Schemas.http,D.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(L.$bO.MainThreadUriOpeners)}registerExternalUriOpener(m,s,I,b){if(this.c.has(s))throw new Error(`Opener with id '${s}' already registered`);const u=b.schemes.find(k=>!R.a.has(k));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(s,I),this.b.$registerUriOpener(s,b.schemes,m,b.label),(0,v.$Xc)(()=>{this.c.delete(s),this.b.$unregisterUriOpener(s)})}async $canOpenUri(m,s,I){const b=this.c.get(m);if(!b)throw new Error(`Unknown opener with id: ${m}`);const u=P.URI.revive(s);return b.canOpenExternalUri(u,I)}async $openUri(m,s,I){const b=this.c.get(m);if(!b)throw new Error(`Unknown opener id: '${m}'`);return b.openExternalUri(P.URI.revive(s.resolvedUri),{sourceUri:P.URI.revive(s.sourceUri)},I)}}e.$dtc=R}),define(Re[221],Oe([1,0,5,2,4,12,18]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$etc=void 0;class T{static{this.a=0}constructor(s){this.c=new R.$An,this.d=new Map,this.b=s.getProxy(v.$bO.MainThreadUrls)}registerUriHandler(s,I){const b=s.identifier;if(this.c.has(b))throw new Error(`Protocol handler already registered for extension ${b}`);const u=T.a++;return this.c.add(b),this.d.set(u,I),this.b.$registerUriHandler(u,b,s.displayName||s.name),(0,P.$Xc)(()=>{this.c.delete(b),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(s,I){const b=this.d.get(s);if(!b)return Promise.resolve(void 0);try{b.handleUri(D.URI.revive(I))}catch(u){(0,L.$4)(u)}return Promise.resolve(void 0)}async createAppUri(s){return D.URI.revive(await this.b.$createAppUri(s))}}e.$etc=T}),define(Re[222],Oe([1,0,20,5]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cwb=L,e.$dwb=T,D=Ve(D);class P{constructor(){this.buffers=[]}add(s){let I=this.buffers.indexOf(s);return I<0&&(I=this.buffers.length,this.buffers.push(s)),I}}function L(m,s){if(s.serializeBuffersForPostMessage){const I=new P,u=JSON.stringify(m,($,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r)};if(ArrayBuffer.isView(r)){const a=R(r);if(a)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r.buffer),view:{type:a,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),k=I.buffers.map($=>{const r=new Uint8Array($);return v.$Se.wrap(r)});return{message:u,buffers:k}}else return{message:JSON.stringify(m),buffers:[]}}function R(m){switch(m.constructor.name){case"Int8Array":return D.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return D.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return D.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return D.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return D.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return D.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return D.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return D.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return D.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return D.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return D.WebviewMessageArrayBufferViewType.BigUint64Array}}function T(m,s){const I=s.map(k=>{const $=new ArrayBuffer(k.byteLength);return new Uint8Array($).set(k.buffer),$}),b=s.length?(k,$)=>{if($&&typeof $=="object"&&$.$$vscode_array_buffer_reference$$){const r=$,{index:a}=r,h=I[a];if(r.view)switch(r.view.type){case D.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(h,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(h,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(h,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(h,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(h,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(h,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(h,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(h,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(h,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(h,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(h,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return $}:void 0;return{message:JSON.parse(m,b),arrayBuffers:I}}}),define(Re[67],Oe([1,0,6,4,15,25,2,176,222,83,5]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Arc=e.$yrc=void 0,e.$zrc=u,e.$Brc=r,e.$Crc=a,L=Ve(L),I=Ve(I);class b{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(n,t,o,l,g,f,d){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new v.$qe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$qe,this._onDidDispose=this.#h.event,this.#e=n,this.#t=t,this.#o=o,this.#n=l,this.#s=g,this.#r=f,this.#u=u(f),this.#d=k(f),this.#i=d}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#l=!0,(0,s.$FEb)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===P.Schemas.https||n.scheme===P.Schemas.http){let t=n.toString();return t.endsWith("/")||(t+="/"),t+" "+s.$EEb}return s.$EEb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),L.$qo(this.#o,n)||this.#t.$setOptions(this.#e,a(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const t=(0,m.$cwb)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,g,f,d,S,E)=>{const y=R.URI.from({scheme:d||"file",path:decodeURIComponent(S)}),C=(0,s.$FEb)(y,{isRemote:t,authority:o}).toString();return`${g}${C}${E}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,g,f,d,S,E)=>{const y=R.URI.from({scheme:d||"file",path:decodeURIComponent(S)}),C=(0,s.$FEb)(y,{isRemote:t,authority:o}).toString();return`${g}${C}${E}`})}}e.$yrc=b;function u(i){try{const n=(0,T.$0p)((0,T.$9p)(i.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}function k(i){try{const n=(0,T.$0p)((0,T.$9p)(i.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class $ extends D.$Zc{constructor(n,t,o,l,g){super(),this.c=t,this.f=o,this.g=l,this.h=g,this.b=new Map,this.a=n.getProxy(I.$bO.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,t,o){const l=this.j(n);if(l){const{message:g}=(0,m.$dwb)(t,o.value);l._onMessageEmitter.fire(g)}}$onMissingCsp(n,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,t,o){const l=new b(n,this.a,h(t),this.c,this.f,o,this.h);this.b.set(n,l);const g=l._onDidDispose(()=>{g.dispose(),this.deleteWebview(n)});return l}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$Arc=$;function r(i){return{id:i.identifier,location:i.extensionLocation}}function a(i,n,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||c(i,n)}}function h(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(n=>R.URI.from(n))}}function c(i,n){return[...(n?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Re[123],Oe([1,0,6,15,13,2,3,16,5]),function(be,e,v,D,P,L,R,T,m){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$htc=e.$gtc=void 0;let I=class{static{s=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new v.$qe,this.onDidChangeWindowState=this.c.event,this.d=s.a,this.b=u.getProxy(m.$bO.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:$})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",$)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,k){k!==this.d[u]&&(this.d={...this.d,[u]:k},this.c.fire(this.d))}openUri(u,k){let $;if(typeof u=="string"){$=u;try{u=L.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,P.$hf)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,$,k)}async asExternalUri(u,k){if((0,P.$hf)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const $=await this.b.$asExternalUri(u,k);return L.URI.from($)}};e.$gtc=I,e.$gtc=I=s=Qe([We(0,T.$OQ)],I),e.$htc=(0,R.$Ki)("IExtHostWindow")}),define(Re[223],Oe([1,0,212,26,16]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wvc=void 0;let L=class extends v.$ktc{constructor(T,m){super(T,m)}f(T,m,s){m.apply(console,s)}};e.$wvc=L,e.$wvc=L=Qe([We(0,P.$OQ),We(1,D.$5Q)],L)}),define(Re[224],Oe([1,0,10,20,19,30,12,6,4,38,160,210,39]),function(be,e,v,D,P,L,R,T,m,s,I,b,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.ResponsiveState=e.RequestInitiator=void 0,e.$rfc=c,e.$sfc=i,R=Ve(R);function $(M,A){try{return JSON.stringify(M,A)}catch{return"null"}}const r="$$ref$$",a={[r]:-1};class h{constructor(A,F){this.jsonString=A,this.referencedBuffers=F}}function c(M,A=null,F=!1){const G=[];return{jsonString:(F?$:JSON.stringify)(M,(j,U)=>{if(typeof U>"u")return a;if(typeof U=="object"){if(U instanceof D.$Se){const J=G.push(U)-1;return{[r]:J}}if(A)return A(j,U)}return U}),referencedBuffers:G}}function i(M,A,F){return JSON.parse(M,(G,x)=>{if(x){const j=x[r];if(typeof j=="number")return A[j];if(F&&x.$mid===s.MarshalledId.Uri)return F.transformIncoming(x)}return x})}function n(M,A){return JSON.stringify(M,A)}function t(M){return M?(A,F)=>F&&F.$mid===s.MarshalledId.Uri?M.transformOutgoing(F):F:null}var o;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var l;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const g=()=>{},f=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class S extends m.$Zc{static{k=f}static{this.a=3*1e3}constructor(A,F=null,G=null){super(),this[k]=!0,this.b=this.B(new T.$qe),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=F,this.g=G,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let x=0,j=u.$6w.count;x<j;x++)this.m[x]=null,this.s[x]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=l.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Wh(()=>this.H(),1e3)),this.B(this.c.onMessage(x=>this.L(x)))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const F=this.w[A];delete this.w[A],F.resolveErr(R.$0())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+S.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+S.a,this.z--,this.z===0&&this.D.cancel(),this.I(l.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(l.Unresponsive):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,I.$Xn)(A,this.g):A}getProxy(A){const{nid:F,sid:G}=A;return this.s[F]||(this.s[F]=this.J(F,G)),this.s[F]}J(A,F){const G={get:(x,j)=>(typeof j=="string"&&!x[j]&&j.charCodeAt(0)===L.CharCode.DollarSign&&(x[j]=(...U)=>this.U(A,j,U)),j===d?F:x[j])};return new Proxy(Object.create(null),G)}set(A,F){return this.m[A.nid]=F,F}assertRegistered(A){for(let F=0,G=A.length;F<G;F++){const x=A[F];if(!this.m[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}L(A){if(this.j)return;const F=A.byteLength,G=y.read(A,0),x=G.readUInt8(),j=G.readUInt32();switch(x){case p.RequestJSONArgs:case p.RequestJSONArgsWithCancellation:{let{rpcId:U,method:J,args:Z}=O.deserializeRequestJSONArgs(G);this.g&&(Z=(0,I.$Xn)(Z,this.g)),this.M(F,j,U,J,Z,x===p.RequestJSONArgsWithCancellation);break}case p.RequestMixedArgs:case p.RequestMixedArgsWithCancellation:{let{rpcId:U,method:J,args:Z}=O.deserializeRequestMixedArgs(G);this.g&&(Z=(0,I.$Xn)(Z,this.g)),this.M(F,j,U,J,Z,x===p.RequestMixedArgsWithCancellation);break}case p.Acknowledged:{this.f?.logIncoming(F,j,o.LocalSide,"ack"),this.G(j);break}case p.Cancel:{this.N(F,j);break}case p.ReplyOKEmpty:{this.O(F,j,void 0);break}case p.ReplyOKJSON:{let U=O.deserializeReplyOKJSON(G);this.g&&(U=(0,I.$Xn)(U,this.g)),this.O(F,j,U);break}case p.ReplyOKJSONWithBuffers:{const U=O.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(F,j,U);break}case p.ReplyOKVSBuffer:{const U=O.deserializeReplyOKVSBuffer(G);this.O(F,j,U);break}case p.ReplyErrError:{let U=O.deserializeReplyErrError(G);this.g&&(U=(0,I.$Xn)(U,this.g)),this.P(F,j,U);break}case p.ReplyErrEmpty:{this.P(F,j,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,F,G,x,j,U){this.f?.logIncoming(A,F,o.OtherSide,`receiveRequest ${(0,u.$8w)(G)}.${x}(`,j);const J=String(F);let Z,ae;if(U){const oe=new P.$Be;j.push(oe.token),Z=this.Q(G,x,j),ae=()=>oe.cancel()}else Z=this.Q(G,x,j),ae=g;this.u[J]=ae;const ee=O.serializeAcknowledged(F);this.f?.logOutgoing(ee.byteLength,F,o.OtherSide,"ack"),this.c.send(ee),Z.then(oe=>{delete this.u[J];const ie=O.serializeReplyOK(F,oe,this.h);this.f?.logOutgoing(ie.byteLength,F,o.OtherSide,"reply:",oe),this.c.send(ie)},oe=>{delete this.u[J];const ie=O.serializeReplyErr(F,oe);this.f?.logOutgoing(ie.byteLength,F,o.OtherSide,"replyErr:",oe),this.c.send(ie)})}N(A,F){this.f?.logIncoming(A,F,o.OtherSide,"receiveCancel");const G=String(F);this.u[G]?.()}O(A,F,G){this.f?.logIncoming(A,F,o.LocalSide,"receiveReply:",G);const x=String(F);if(!this.w.hasOwnProperty(x))return;const j=this.w[x];delete this.w[x],j.resolveOk(G)}P(A,F,G){this.f?.logIncoming(A,F,o.LocalSide,"receiveReplyErr:",G);const x=String(F);if(!this.w.hasOwnProperty(x))return;const j=this.w[x];delete this.w[x];let U;G&&(G.$isError?(U=new Error,U.name=G.name,U.message=G.message,U.stack=G.stack):U=G),j.resolveErr(U)}Q(A,F,G){try{return Promise.resolve(this.S(A,F,G))}catch(x){return Promise.reject(x)}}S(A,F,G){const x=this.m[A];if(!x)throw new Error("Unknown actor "+(0,u.$8w)(A));const j=x[F];if(typeof j!="function")throw new Error("Unknown method "+F+" on actor "+(0,u.$8w)(A));return j.apply(x,G)}U(A,F,G){if(this.j)return new b.$qfc;let x=null;if(G.length>0&&P.CancellationToken.isCancellationToken(G[G.length-1])&&(x=G.pop()),x&&x.isCancellationRequested)return Promise.reject(R.$0());const j=O.serializeRequestArguments(G,this.h),U=++this.t,J=String(U),Z=new b.$pfc,ae=new m.$Yc;x&&ae.add(x.onCancellationRequested(()=>{const oe=O.serializeCancel(U);this.f?.logOutgoing(oe.byteLength,U,o.LocalSide,"cancel"),this.c.send(O.serializeCancel(U))})),this.w[J]=new E(Z,ae),this.F(U);const ee=O.serializeRequest(U,A,F,j,!!x);return this.f?.logOutgoing(ee.byteLength,U,o.LocalSide,`request: ${(0,u.$8w)(A)}.${F}(`,G),this.c.send(ee),Z}}e.$tfc=S;class E{constructor(A,F){this.a=A,this.b=F}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class y{static alloc(A,F,G){const x=new y(D.$Se.alloc(G+1+4),0);return x.writeUInt8(A),x.writeUInt32(F),x}static read(A,F){return new y(A,F)}get buffer(){return this.a}constructor(A,F){this.a=A,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+A).toString();return this.b+=A,G}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+A).toString();return this.b+=A,G}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+A);return this.b+=A,F}static sizeMixedArray(A){let F=0;F+=1;for(let G=0,x=A.length;G<x;G++){const j=A[G];switch(F+=1,j.type){case w.String:F+=this.sizeLongString(j.value);break;case w.VSBuffer:F+=this.sizeVSBuffer(j.value);break;case w.SerializedObjectWithBuffers:F+=this.sizeUInt32,F+=this.sizeLongString(j.value);for(let U=0;U<j.buffers.length;++U)F+=this.sizeVSBuffer(j.buffers[U]);break;case w.Undefined:break}}return F}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let F=0,G=A.length;F<G;F++){const x=A[F];switch(x.type){case w.String:this.writeUInt8(w.String),this.writeLongString(x.value);break;case w.VSBuffer:this.writeUInt8(w.VSBuffer),this.writeVSBuffer(x.value);break;case w.SerializedObjectWithBuffers:this.writeUInt8(w.SerializedObjectWithBuffers),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let j=0;j<x.buffers.length;++j)this.writeBuffer(x.buffers[j]);break;case w.Undefined:this.writeUInt8(w.Undefined);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const F=new Array(A);for(let G=0;G<A;G++)switch(this.readUInt8()){case w.String:F[G]=this.readLongString();break;case w.VSBuffer:F[G]=this.readVSBuffer();break;case w.SerializedObjectWithBuffers:{const j=this.readUInt32(),U=this.readLongString(),J=[];for(let Z=0;Z<j;++Z)J.push(this.readVSBuffer());F[G]=new u.$9w(i(U,J,null));break}case w.Undefined:F[G]=void 0;break}return F}}var C;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(C||(C={}));class O{static a(A){for(let F=0,G=A.length;F<G;F++)if(A[F]instanceof D.$Se||A[F]instanceof u.$9w||typeof A[F]>"u")return!0;return!1}static serializeRequestArguments(A,F){if(this.a(A)){const G=[];for(let x=0,j=A.length;x<j;x++){const U=A[x];if(U instanceof D.$Se)G[x]={type:w.VSBuffer,value:U};else if(typeof U>"u")G[x]={type:w.Undefined};else if(U instanceof u.$9w){const{jsonString:J,referencedBuffers:Z}=c(U.value,F);G[x]={type:w.SerializedObjectWithBuffers,value:D.$Se.fromString(J),buffers:Z}}else G[x]={type:w.String,value:D.$Se.fromString(n(U,F))}}return{type:C.Mixed,args:G}}return{type:C.Simple,args:n(A,F)}}static serializeRequest(A,F,G,x,j){switch(x.type){case C.Simple:return this.b(A,F,G,x.args,j);case C.Mixed:return this.c(A,F,G,x.args,j)}}static b(A,F,G,x,j){const U=D.$Se.fromString(G),J=D.$Se.fromString(x);let Z=0;Z+=y.sizeUInt8(),Z+=y.sizeShortString(U),Z+=y.sizeLongString(J);const ae=y.alloc(j?p.RequestJSONArgsWithCancellation:p.RequestJSONArgs,A,Z);return ae.writeUInt8(F),ae.writeShortString(U),ae.writeLongString(J),ae.buffer}static deserializeRequestJSONArgs(A){const F=A.readUInt8(),G=A.readShortString(),x=A.readLongString();return{rpcId:F,method:G,args:JSON.parse(x)}}static c(A,F,G,x,j){const U=D.$Se.fromString(G);let J=0;J+=y.sizeUInt8(),J+=y.sizeShortString(U),J+=y.sizeMixedArray(x);const Z=y.alloc(j?p.RequestMixedArgsWithCancellation:p.RequestMixedArgs,A,J);return Z.writeUInt8(F),Z.writeShortString(U),Z.writeMixedArray(x),Z.buffer}static deserializeRequestMixedArgs(A){const F=A.readUInt8(),G=A.readShortString(),x=A.readMixedArray(),j=new Array(x.length);for(let U=0,J=x.length;U<J;U++){const Z=x[U];typeof Z=="string"?j[U]=JSON.parse(Z):j[U]=Z}return{rpcId:F,method:G,args:j}}static serializeAcknowledged(A){return y.alloc(p.Acknowledged,A,0).buffer}static serializeCancel(A){return y.alloc(p.Cancel,A,0).buffer}static serializeReplyOK(A,F,G){if(typeof F>"u")return this.d(A);if(F instanceof D.$Se)return this.e(A,F);if(F instanceof u.$9w){const{jsonString:x,referencedBuffers:j}=c(F.value,G,!0);return this.g(A,x,j)}else return this.f(A,$(F,G))}static d(A){return y.alloc(p.ReplyOKEmpty,A,0).buffer}static e(A,F){let G=0;G+=y.sizeVSBuffer(F);const x=y.alloc(p.ReplyOKVSBuffer,A,G);return x.writeVSBuffer(F),x.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,F){const G=D.$Se.fromString(F);let x=0;x+=y.sizeLongString(G);const j=y.alloc(p.ReplyOKJSON,A,x);return j.writeLongString(G),j.buffer}static g(A,F,G){const x=D.$Se.fromString(F);let j=0;j+=y.sizeUInt32,j+=y.sizeLongString(x);for(const J of G)j+=y.sizeVSBuffer(J);const U=y.alloc(p.ReplyOKJSONWithBuffers,A,j);U.writeUInt32(G.length),U.writeLongString(x);for(const J of G)U.writeBuffer(J);return U.buffer}static deserializeReplyOKJSON(A){const F=A.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(A,F){const G=A.readUInt32(),x=A.readLongString(),j=[];for(let U=0;U<G;++U)j.push(A.readVSBuffer());return new u.$9w(i(x,j,F))}static serializeReplyErr(A,F){const G=F?$(R.$6(F),null):void 0;if(typeof G!="string")return this.h(A);const x=D.$Se.fromString(G);let j=0;j+=y.sizeLongString(x);const U=y.alloc(p.ReplyErrError,A,j);return U.writeLongString(x),U.buffer}static deserializeReplyErrError(A){const F=A.readLongString();return JSON.parse(F)}static h(A){return y.alloc(p.ReplyErrEmpty,A,0).buffer}}var p;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var w;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(w||(w={}))}),define(Re[225],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yvc=void 0;const v=function(L){const R=T=>{globalThis.removeEventListener("message",R);const m=T.data;Object.defineProperties(globalThis,{postMessage:{value(s,I){m.postMessage(s,I)}},onmessage:{get(){return m.onmessage},set(s){m.onmessage=s}}}),m.addEventListener("message",s=>{globalThis.dispatchEvent(new MessageEvent("message",{data:s.data,ports:s.ports?[...s.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",R)}.toString();class D extends EventTarget{constructor(L,R,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${v})('${R}'))`,s=new Blob([m],{type:"application/javascript"}),I=URL.createObjectURL(s),b=new MessageChannel,u=I,k={type:"_newWorker",id:u,port:b.port2,url:I,options:T};L(k,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{L({type:"_terminateWorker",id:u}),URL.revokeObjectURL(I),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set($){b.port1.onmessage=$}},onmessageerror:{get(){return b.port1.onmessageerror},set($){b.port1.onmessageerror=$}}}),b.port1.addEventListener("messageerror",$=>{const r=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(r)}),b.port1.addEventListener("message",$=>{const r=new MessageEvent("message",{data:$.data});this.dispatchEvent(r)}),b.port1.start()}}e.$yvc=D}),define(Re[226],Oe([1,0,20,27,15,60,3]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$QL=void 0,e.$RL=I,e.$SL=b,e.$TL=u,e.$UL=k,e.$QL=(0,R.$Ki)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${T.join("")}]+`),s=7;function I(r){if(r.scheme!==P.Schemas.vscodeNotebookCell)return;const a=r.fragment.indexOf("s");if(a<0)return;const h=parseInt(r.fragment.substring(0,a).replace(m,""),s),c=(0,v.$_e)(r.fragment.substring(a+1)).toString();if(!isNaN(h))return{handle:h,notebook:r.with({scheme:c,fragment:null})}}function b(r,a){const h=a.toString(s),i=`${h.length<T.length?T[h.length-1]:"z"}${h}s${(0,v.$af)(v.$Se.fromString(r.scheme),!0,!0)}`;return r.with({scheme:P.Schemas.vscodeNotebookCell,fragment:i})}function u(r){if(r.scheme!==P.Schemas.vscodeNotebookMetadata)return;const a=(0,v.$_e)(r.fragment).toString();return r.with({scheme:a,fragment:null})}function k(r){const a=`${(0,v.$af)(v.$Se.fromString(r.scheme),!0,!0)}`;return r.with({scheme:P.Schemas.vscodeNotebookMetadata,fragment:a})}class ${constructor(){this.a=new D.$Fc}getNotebook(a){if(a.scheme===P.Schemas.vscodeNotebookCell){const h=I(a);if(h){const c=this.a.get(h.notebook);if(c)return c}}return this.a.get(a)}addNotebookDocument(a){this.a.set(a.uri,a)}removeNotebookDocument(a){this.a.delete(a.uri)}}e.$VL=$,(0,L.$2s)(e.$QL,$,L.InstantiationType.Delayed)}),define(Re[90],Oe([1,0,20,43,41,72,15,22,23,31,226]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$bM=e.CellStatusbarAlignment=e.$aM=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$0L=e.$9L=e.$7L=e.CellUri=e.NotebookUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$6L=e.$5L=e.$4L=e.$3L=e.CellKind=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=void 0,e.$8L=g,e.$$L=S,e.$_L=E,e.$cM=O,e.$dM=w,D=Ve(D),e.$WL="workbench.editor.notebook",e.$XL="workbench.editor.notebookTextDiffEditor",e.$YL="workbench.editor.notebookMultiTextDiffEditor",e.$ZL="workbench.editor.interactive",e.$1L="workbench.editor.repl",e.$2L="replNotebook.input.execute";var b;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(b||(e.CellKind=b={})),e.$3L=["application/json","application/javascript","text/html","image/svg+xml",L.$it.latex,L.$it.markdown,"image/png","image/jpeg",L.$it.text],e.$4L=[L.$it.latex,L.$it.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$it.text],e.$5L=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$6L="_notAvailable";var u;(function(Z){Z[Z.Running=1]="Running",Z[Z.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var k;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(k||(e.NotebookCellExecutionState=k={}));var $;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})($||(e.NotebookExecutionState=$={}));var r;(function(Z){Z[Z.WithHardKernelDependency=0]="WithHardKernelDependency",Z[Z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Z[Z.Pure=2]="Pure",Z[Z.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var a;(function(Z){Z.Always="always",Z.Never="never",Z.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var h;(function(Z){Z[Z.ModelChange=1]="ModelChange",Z[Z.Move=2]="Move",Z[Z.ChangeCellLanguage=5]="ChangeCellLanguage",Z[Z.Initialize=6]="Initialize",Z[Z.ChangeCellMetadata=7]="ChangeCellMetadata",Z[Z.Output=8]="Output",Z[Z.OutputItem=9]="OutputItem",Z[Z.ChangeCellContent=10]="ChangeCellContent",Z[Z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Z[Z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Z[Z.ChangeCellMime=13]="ChangeCellMime",Z[Z.Unknown=100]="Unknown"})(h||(e.NotebookCellsChangeType=h={}));var c;(function(Z){Z[Z.Handle=0]="Handle",Z[Z.Index=1]="Index"})(c||(e.SelectionStateType=c={}));var i;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Output=2]="Output",Z[Z.Metadata=3]="Metadata",Z[Z.CellLanguage=4]="CellLanguage",Z[Z.DocumentMetadata=5]="DocumentMetadata",Z[Z.Move=6]="Move",Z[Z.OutputItems=7]="OutputItems",Z[Z.PartialMetadata=8]="PartialMetadata",Z[Z.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(Z){Z.scheme=R.Schemas.vscodeNotebookMetadata;function ae(oe){return(0,I.$UL)(oe)}Z.generate=ae;function ee(oe){return(0,I.$TL)(oe)}Z.parse=ee})(n||(e.NotebookUri=n={}));var t;(function(Z){Z.scheme=R.Schemas.vscodeNotebookCell;function ae($e,Ie){return(0,I.$SL)($e,Ie)}Z.generate=ae;function ee($e){return(0,I.$RL)($e)}Z.parse=ee;function oe($e,Ie){return $e.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${Ie??""},${$e.scheme!==R.Schemas.file?$e.scheme:""}`})}Z.generateCellOutputUri=oe;function ie($e){if($e.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const Ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!Ie)return;const X=Ie[1]&&Ie[1]!==""?Ie[1]:void 0,V=Ie[2];return{outputId:X,notebook:$e.with({scheme:V||R.Schemas.file,fragment:null})}}Z.parseCellOutputUri=ie;function ue($e,Ie,X){return Z.generate($e,Ie).with({scheme:X})}Z.generateCellPropertyUri=ue;function _($e,Ie){if($e.scheme===Ie)return Z.parse($e.with({scheme:Z.scheme}))}Z.parseCellPropertyUri=_})(t||(e.CellUri=t={}));const o=Z=>m.$l?Z.replace(/\//g,"\\"):Z;class l{constructor(ae=[],ee=e.$3L){this.e=ee,this.d=[...new Set(ae)].map(oe=>({pattern:oe,matches:D.$Fk(o(oe))}))}sort(ae){const ee=new Map(P.Iterable.map(ae,ie=>[ie,o(ie)]));let oe=[];for(const{matches:ie}of this.d)for(const[ue,_]of ee)if(ie(_)){oe.push(ue),ee.delete(ue);break}return ee.size&&(oe=oe.concat([...ee.keys()].sort((ie,ue)=>this.e.indexOf(ie)-this.e.indexOf(ue)))),oe}prioritize(ae,ee){const oe=this.f(ae);if(oe===-1){this.d.unshift({pattern:ae,matches:D.$Fk(o(ae))});return}const ie=new Set(ee.map(_=>this.f(_,oe)));ie.delete(-1);const ue=Array.from(ie).sort();this.d.splice(oe+1,0,...ue.map(_=>this.d[_]));for(let _=ue.length-1;_>=0;_--)this.d.splice(ue[_],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,ee=this.d.length){const oe=o(ae);for(let ie=0;ie<ee;ie++)if(this.d[ie].matches(oe))return ie;return-1}}e.$7L=l;function g(Z,ae,ee,oe=(ie,ue)=>ie===ue){const ie=[];function ue(Ie,X,V){if(X===0&&V.length===0)return;const re=ie[ie.length-1];re&&re.start+re.deleteCount===Ie?(re.deleteCount+=X,re.toInsert.push(...V)):ie.push({start:Ie,deleteCount:X,toInsert:V})}let _=0,$e=0;for(;;){if(_===Z.length){ue(_,0,ae.slice($e));break}if($e===ae.length){ue(_,Z.length-_,[]);break}const Ie=Z[_],X=ae[$e];if(oe(Ie,X)){_+=1,$e+=1;continue}ee(X)?(ue(_,1,[]),_+=1):(ue(_,0,[X]),$e+=1)}return ie}e.$9L=new s.$2j("notebookEditorCursorAtBoundary","none"),e.$0L=new s.$2j("notebookEditorCursorAtLineBoundary","none");var f;(function(Z){Z.default="default",Z.option="option"})(f||(e.NotebookEditorPriority=f={}));var d;(function(Z){Z.Cells="cells",Z.Text="text",Z.None="none"})(d||(e.NotebookFindScopeType=d={}));function S(Z){const ae=Z;return!!((typeof ae.include=="string"||D.$Gk(ae.include))&&(typeof ae.exclude=="string"||D.$Gk(ae.exclude)))}function E(Z,ae,ee){if(Array.isArray(Z.viewType)&&Z.viewType.indexOf(ae)>=0||Z.viewType===ae)return!0;if(Z.filenamePattern){const oe=S(Z.filenamePattern)?Z.filenamePattern.include:Z.filenamePattern,ie=S(Z.filenamePattern)?Z.filenamePattern.exclude:void 0;if(D.$Ek(oe,(0,T.$sc)(ee.fsPath).toLowerCase()))return!(ie&&D.$Ek(ie,(0,T.$sc)(ee.fsPath).toLowerCase()))}return!1}e.$aM={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var y;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class C{static{this.d="notebook/"}static create(ae){return`${C.d}${ae}`}static parse(ae){if(ae.startsWith(C.d))return ae.substring(C.d.length)}}e.$bM=C;function O(Z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Z)}const p=new TextDecoder;function w(Z){const ae=[];let ee=!1;for(const _ of Z)(ae.length===0||ee)&&(ae.push(_),ee=!0);let oe=F(ae);const ie=v.$Se.concat(ae.map(_=>v.$Se.wrap(_))),ue=J(ie);return oe=oe||ue.byteLength!==ie.byteLength,{data:ue,didCompression:oe}}e.$eM="\x1B[A";const M=e.$eM.split("").map(Z=>Z.charCodeAt(0)),A=10;function F(Z){let ae=!1;return Z.forEach((ee,oe)=>{if(oe===0||ee.length<e.$eM.length)return;const ie=Z[oe-1],ue=ee.subarray(0,e.$eM.length);if(ue[0]===M[0]&&ue[1]===M[1]&&ue[2]===M[2]){const _=ie.lastIndexOf(A);if(_===-1)return;ae=!0,Z[oe-1]=ie.subarray(0,_),Z[oe]=ee.subarray(e.$eM.length)}}),ae}function G(Z){let ae=Z;do Z=ae,ae=Z.replace(/[^\n]\x08/gm,"");while(ae.length<Z.length);return Z}function x(Z){for(Z=Z.replace(/\r+\n/gm,`
`);Z.search(/\r[^$]/g)>-1;){const ae=Z.match(/^(.*)\r+/m)[1];let ee=Z.match(/\r+(.*)$/m)[1];ee=ee+ae.slice(ee.length,ae.length),Z=Z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return Z}const j=8,U=13;function J(Z){return!Z.buffer.includes(j)&&!Z.buffer.includes(U)?Z:v.$Se.fromString(x(G(p.decode(Z.buffer))))}}),define(Re[7],Oe([1,0,17,12,59,27,72,13,14,2,33,18,28,110,90]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$){"use strict";var r,a,h,c,i,n,t,o,l,g,f,d,S,E,y,C,O;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$DQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$CQ=e.$BQ=e.$AQ=e.$zQ=e.$yQ=e.$xQ=e.$wQ=e.$vQ=e.LanguageModelChatMessageRole=e.$uQ=e.$tQ=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$sQ=e.$rQ=e.$qQ=e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=e.$iQ=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.$dQ=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$cQ=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$bQ=e.$aQ=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.$3P=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$2P=e.$1P=e.$ZP=e.$YP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.TestRunProfileKind=e.TestResultState=e.$RP=e.$QP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$PP=e.NotebookVariablesRequestKind=e.$OP=e.$NP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$MP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.ColorThemeKind=e.$GP=e.$FP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$EP=e.QuickInputButtonLocation=e.$DP=e.DebugConsoleMode=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$xP=e.$wP=e.FileChangeType=e.$vP=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$uP=e.$tP=e.$sP=e.$rP=e.InlineCompletionTriggerKind=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.$eP=e.ConfigurationTarget=e.$dP=e.$cP=e.$bP=e.$aP=e.DocumentPasteTriggerKind=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$7O=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$6O=e.ViewBadge=e.ProgressLocation=e.$5O=e.$4O=e.TaskScope=e.ShellQuoting=e.$3O=e.$2O=e.$1O=e.TaskPanelKind=e.TaskRevealKind=e.$ZO=e.TerminalLocation=e.$YO=e.$XO=e.$WO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$VO=e.$UO=e.$TO=e.$SO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$QO=e.$PO=e.$OO=e.$NO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$MO=e.$LO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.LanguageStatusSeverity=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.CodeActionTriggerKind=e.$zO=e.$yO=e.SymbolTag=e.SymbolKind=e.$xO=e.$wO=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.DiagnosticSeverity=e.DiagnosticTag=e.$qO=e.$pO=e.FileEditType=e.$oO=e.$nO=e.$mO=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$lO=e.$kO=e.$jO=e.$gO=e.$fO=e.$eO=e.$dO=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$hO=j,e.$iO=U,e.$RO=dt,e.$fP=ji,e.$XP=Cn;function p(z){return Object.assign(z,{apply:function(...ne){if(ne.length===0)return Reflect.construct(z,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(z,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(z,[]);{const[Se,...Ke]=ne;return Reflect.construct(z,Ke,Se.constructor)}}})}var w;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(w||(e.TerminalOutputAnchor=w={}));var M;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let A=r=class{static from(...N){let ne=N;return new r(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$dO=A,e.$dO=A=r=Qe([p],A);let F=a=class{static Min(...N){if(N.length===0)throw new TypeError;let ne=N[0];for(let Se=1;Se<N.length;Se++){const Ke=N[Se];Ke.isBefore(ne)&&(ne=Ke)}return ne}static Max(...N){if(N.length===0)throw new TypeError;let ne=N[0];for(let Se=1;Se<N.length;Se++){const Ke=N[Se];Ke.isAfter(ne)&&(ne=Ke)}return ne}static isPosition(N){if(!N)return!1;if(N instanceof a)return!0;const{line:ne,character:Se}=N;return typeof ne=="number"&&typeof Se=="number"}static of(N){if(N instanceof a)return N;if(this.isPosition(N))return new a(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,ne){if(N<0)throw(0,D.$$)("line must be non-negative");if(ne<0)throw(0,D.$$)("character must be non-negative");this.c=N,this.e=ne}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,ne=0){if(N===null||ne===null)throw(0,D.$$)();let Se;return typeof N>"u"?Se=0:typeof N=="number"?Se=N:(Se=typeof N.lineDelta=="number"?N.lineDelta:0,ne=typeof N.characterDelta=="number"?N.characterDelta:0),Se===0&&ne===0?this:new a(this.line+Se,this.character+ne)}with(N,ne=this.character){if(N===null||ne===null)throw(0,D.$$)();let Se;return typeof N>"u"?Se=this.line:typeof N=="number"?Se=N:(Se=typeof N.line=="number"?N.line:this.line,ne=typeof N.character=="number"?N.character:this.character),Se===this.line&&ne===this.character?this:new a(Se,ne)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$eO=F,e.$eO=F=a=Qe([p],F);let G=h=class{static isRange(N){return N instanceof h?!0:N?F.isPosition(N.start)&&F.isPosition(N.end):!1}static of(N){if(N instanceof h)return N;if(this.isRange(N))return new h(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,ne,Se,Ke){let rt,pt;if(typeof N=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ke=="number"?(rt=new F(N,ne),pt=new F(Se,Ke)):F.isPosition(N)&&F.isPosition(ne)&&(rt=F.of(N),pt=F.of(ne)),!rt||!pt)throw new Error("Invalid arguments");rt.isBefore(pt)?(this.c=rt,this.e=pt):(this.c=pt,this.e=rt)}contains(N){return h.isRange(N)?this.contains(N.start)&&this.contains(N.end):F.isPosition(N)?!(F.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const ne=F.Max(N.start,this.c),Se=F.Min(N.end,this.e);if(!ne.isAfter(Se))return new h(ne,Se)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ne=F.Min(N.start,this.c),Se=F.Max(N.end,this.end);return new h(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,ne=this.end){if(N===null||ne===null)throw(0,D.$$)();let Se;return N?F.isPosition(N)?Se=N:(Se=N.start||this.start,ne=N.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new h(Se,ne)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return j(this)}};e.$fO=G,e.$fO=G=h=Qe([p],G);let x=c=class extends G{static isSelection(N){return N instanceof c?!0:N?G.isRange(N)&&F.isPosition(N.anchor)&&F.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,ne,Se,Ke){let rt,pt;if(typeof N=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ke=="number"?(rt=new F(N,ne),pt=new F(Se,Ke)):F.isPosition(N)&&F.isPosition(ne)&&(rt=F.of(N),pt=F.of(ne)),!rt||!pt)throw new Error("Invalid arguments");super(rt,pt),this.f=rt,this.g=pt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return U(this)}};e.$gO=x,e.$gO=x=c=Qe([p],x);function j(z){return z.isEmpty?`[${z.start.line}:${z.start.character})`:`[${z.start.line}:${z.start.character} -> ${z.end.line}:${z.end.character})`}function U(z){let N=j(z);return z.isEmpty||(z.active.isEqual(z.start)?N=`|${N}`:N=`${N}|`),N}const J=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,D.$$)("connectionToken")};class Z{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ne,Se){if(typeof N!="string"||N.length===0)throw(0,D.$$)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,D.$$)("port");typeof Se<"u"&&J(Se),this.host=N,this.port=Math.round(ne),this.connectionToken=Se}}e.$jO=Z;class ae{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ne){this.makeConnection=N,this.connectionToken=ne,typeof ne<"u"&&J(ne)}}e.$kO=ae;class ee extends Error{static NotAvailable(N,ne){return new ee(N,k.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(N){return new ee(N,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ne=k.RemoteAuthorityResolverErrorCode.Unknown,Se){super(N),this._message=N,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,ee.prototype)}}e.$lO=ee;var oe;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(oe||(e.EndOfLine=oe={}));var ie;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(ie||(e.EnvironmentVariableMutatorType=ie={}));let ue=i=class{static isTextEdit(N){return N instanceof i?!0:N?G.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ne){return new i(N,ne)}static insert(N,ne){return i.replace(new G(N,N),ne)}static delete(N){return i.replace(N,"")}static setEndOfLine(N){const ne=new i(new G(new F(0,0),new F(0,0)),"");return ne.newEol=N,ne}get range(){return this.c}set range(N){if(N&&!G.isRange(N))throw(0,D.$$)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,D.$$)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,D.$$)("newEol");this.f=N}constructor(N,ne){this.c=N,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$mO=ue,e.$mO=ue=i=Qe([p],ue);let _=n=class{static isNotebookCellEdit(N){return N instanceof n?!0:N?ki.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ne){return new n(N,ne)}static insertCells(N,ne){return new n(new ki(N,N),ne)}static deleteCells(N){return new n(N,[])}static updateCellMetadata(N,ne){const Se=new n(new ki(N,N),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(N){const ne=new n(new ki(0,0),[]);return ne.newNotebookMetadata=N,ne}constructor(N,ne){this.range=N,this.newCells=ne}};e.$nO=_,e.$nO=_=n=Qe([p],_);class $e{static isSnippetTextEdit(N){return N instanceof $e?!0:N?G.isRange(N.range)&&V.isSnippetString(N.snippet):!1}static replace(N,ne){return new $e(N,ne)}static insert(N,ne){return $e.replace(new G(N,N),ne)}constructor(N,ne){this.range=N,this.snippet=ne}}e.$oO=$e;var Ie;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ie||(e.FileEditType=Ie={}));let X=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,ne,Se,Ke){this.c.push({_type:Ie.File,from:N,to:ne,options:Se,metadata:Ke})}createFile(N,ne,Se){this.c.push({_type:Ie.File,from:void 0,to:N,options:ne,metadata:Se})}deleteFile(N,ne,Se){this.c.push({_type:Ie.File,from:N,to:void 0,options:ne,metadata:Se})}e(N,ne,Se){this.c.push({_type:Ie.Cell,metadata:Se,uri:N,edit:{editType:$.CellEditType.DocumentMetadata,metadata:ne},notebookMetadata:ne})}f(N,ne,Se,Ke){const rt=ne.start,pt=ne.end;(rt!==pt||Se.length>0)&&this.c.push({_type:Ie.CellReplace,uri:N,index:rt,count:pt-rt,cells:Se,metadata:Ke})}g(N,ne,Se,Ke){this.c.push({_type:Ie.Cell,metadata:Ke,uri:N,edit:{editType:$.CellEditType.Metadata,index:ne,metadata:Se}})}replace(N,ne,Se,Ke){this.c.push({_type:Ie.Text,uri:N,edit:new ue(ne,Se),metadata:Ke})}insert(N,ne,Se,Ke){this.replace(N,new G(ne,ne),Se,Ke)}delete(N,ne,Se){this.replace(N,ne,"",Se)}has(N){return this.c.some(ne=>ne._type===Ie.Text&&ne.uri.toString()===N.toString())}set(N,ne){if(ne)for(const Se of ne){if(!Se)continue;let Ke,rt;Array.isArray(Se)?(Ke=Se[0],rt=Se[1]):Ke=Se,_.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(N,Ke.range.start,Ke.newCellMetadata,rt):Ke.newNotebookMetadata?this.e(N,Ke.newNotebookMetadata,rt):this.f(N,Ke.range,Ke.newCells,rt):$e.isSnippetTextEdit(Ke)?this.c.push({_type:Ie.Snippet,uri:N,range:Ke.range,edit:Ke.snippet,metadata:rt}):this.c.push({_type:Ie.Text,uri:N,edit:Ke,metadata:rt})}else{for(let Se=0;Se<this.c.length;Se++){const Ke=this.c[Se];switch(Ke._type){case Ie.Text:case Ie.Snippet:case Ie.Cell:case Ie.CellReplace:Ke.uri.toString()===N.toString()&&(this.c[Se]=void 0);break}}(0,v.$Mb)(this.c)}}get(N){const ne=[];for(const Se of this.c)Se._type===Ie.Text&&Se.uri.toString()===N.toString()&&ne.push(Se.edit);return ne}entries(){const N=new L.$Fc;for(const ne of this.c)if(ne._type===Ie.Text){let Se=N.get(ne.uri);Se||(Se=[ne.uri,[]],N.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$pO=X,e.$pO=X=Qe([p],X);let V=t=class{static isSnippetString(N){return N instanceof t?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=t.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ne=this.e++){if(typeof N=="function"){const Se=new t;Se.e=this.e,N(Se),this.e=Se.e,N=Se.value}else N=t.c(N);return this.value+="${",this.value+=ne,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ne=this.e++){const Se=N.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(N,ne){if(typeof ne=="function"){const Se=new t;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$qO=V,e.$qO=V=t=Qe([p],V);var re;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(re||(e.DiagnosticTag=re={}));var we;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(we||(e.DiagnosticSeverity=we={}));let Pe=o=class{static isLocation(N){return N instanceof o?!0:N?G.isRange(N.range)&&s.URI.isUri(N.uri):!1}constructor(N,ne){if(this.uri=N,ne)if(G.isRange(ne))this.range=G.of(ne);else if(F.isPosition(ne))this.range=new G(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$rO=Pe,e.$rO=Pe=o=Qe([p],Pe);let Fe=class{static is(N){return N?typeof N.message=="string"&&N.location&&G.isRange(N.location.range)&&s.URI.isUri(N.location.uri):!1}constructor(N,ne){this.location=N,this.message=ne}static isEqual(N,ne){return N===ne?!0:!N||!ne?!1:N.message===ne.message&&N.location.range.isEqual(ne.location.range)&&N.location.uri.toString()===ne.location.uri.toString()}};e.$sO=Fe,e.$sO=Fe=Qe([p],Fe);let Be=class{constructor(N,ne,Se=we.Error){if(!G.isRange(N))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=N,this.message=ne,this.severity=Se}toJSON(){return{severity:we[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ne){return N===ne?!0:!N||!ne?!1:N.message===ne.message&&N.severity===ne.severity&&N.code===ne.code&&N.severity===ne.severity&&N.source===ne.source&&N.range.isEqual(ne.range)&&(0,v.$yb)(N.tags,ne.tags)&&(0,v.$yb)(N.relatedInformation,ne.relatedInformation,Fe.isEqual)}};e.$tO=Be,e.$tO=Be=Qe([p],Be);let xe=class{constructor(N,ne){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ne}};e.$uO=xe,e.$uO=xe=Qe([p],xe);let nt=class extends xe{constructor(N,ne,Se,Ke){super(N,ne),this.canIncreaseVerbosity=Se,this.canDecreaseVerbosity=Ke}};e.$vO=nt,e.$vO=nt=Qe([p],nt);var ht;(function(z){z[z.Increase=0]="Increase",z[z.Decrease=1]="Decrease"})(ht||(e.HoverVerbosityAction=ht={}));var $t;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})($t||(e.DocumentHighlightKind=$t={}));let ut=class{constructor(N,ne=$t.Text){this.range=N,this.kind=ne}toJSON(){return{range:this.range,kind:$t[this.kind]}}};e.$wO=ut,e.$wO=ut=Qe([p],ut);let et=class{constructor(N,ne){this.uri=N,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(N=>N.toJSON())}}};e.$xO=et,e.$xO=et=Qe([p],et);var Le;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Le||(e.SymbolKind=Le={}));var Ne;(function(z){z[z.Deprecated=1]="Deprecated"})(Ne||(e.SymbolTag=Ne={}));let Me=l=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ne,Se,Ke,rt){this.name=N,this.kind=ne,this.containerName=rt,typeof Se=="string"&&(this.containerName=Se),Ke instanceof Pe?this.location=Ke:Se instanceof G&&(this.location=new Pe(Ke,Se)),l.validate(this)}toJSON(){return{name:this.name,kind:Le[this.kind],location:this.location,containerName:this.containerName}}};e.$yO=Me,e.$yO=Me=l=Qe([p],Me);let q=g=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(g.validate)}constructor(N,ne,Se,Ke,rt){this.name=N,this.detail=ne,this.kind=Se,this.range=Ke,this.selectionRange=rt,this.children=[],g.validate(this)}};e.$zO=q,e.$zO=q=g=Qe([p],q);var B;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let H=class{constructor(N,ne){this.title=N,this.kind=ne}};e.$AO=H,e.$AO=H=Qe([p],H);let Q=class{static{f=this}static{this.c="."}constructor(N){this.value=N}append(N){return new f(this.value?this.value+f.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+f.c)}};e.$BO=Q,e.$BO=Q=f=Qe([p],Q),Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorMove=Q.Refactor.append("move"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll"),Q.Notebook=Q.Empty.append("notebook");let se=class{constructor(N,ne){if(this.range=N,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$CO=se,e.$CO=se=Qe([p],se);class ge{constructor(N,ne,Se,Ke,rt,pt){this.kind=N,this.name=ne,this.detail=Se,this.uri=Ke,this.range=rt,this.selectionRange=pt}}e.$DO=ge;class Ee{constructor(N,ne){this.fromRanges=ne,this.from=N}}e.$EO=Ee;class ze{constructor(N,ne){this.fromRanges=ne,this.to=N}}e.$FO=ze;var Je;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Je||(e.LanguageStatusSeverity=Je={}));let _e=class{constructor(N,ne){this.range=N,this.command=ne}get isResolved(){return!!this.command}};e.$GO=_e,e.$GO=_e=Qe([p],_e);let tt=d=class{#e;static isMarkdownString(N){return N instanceof d?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ne=!1){this.#e=new P.$9k(N,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,ne){return this.#e.appendCodeblock(ne??"",N),this}};e.$HO=tt,e.$HO=tt=d=Qe([p],tt);let ct=class{constructor(N,ne){this.label=N,this.documentation=ne}};e.$IO=ct,e.$IO=ct=Qe([p],ct);let it=class{constructor(N,ne){this.label=N,this.documentation=ne,this.parameters=[]}};e.$JO=it,e.$JO=it=Qe([p],it);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$KO=at,e.$KO=at=Qe([p],at);var yt;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(yt||(e.SignatureHelpTriggerKind=yt={}));var Ye;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Ye||(e.InlayHintKind=Ye={}));let he=class{constructor(N){this.value=N}};e.$LO=he,e.$LO=he=Qe([p],he);let pe=class{constructor(N,ne,Se){this.position=N,this.label=ne,this.kind=Se}};e.$MO=pe,e.$MO=pe=Qe([p],pe);var ye;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ye||(e.CompletionTriggerKind=ye={}));var Ce;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ce||(e.CompletionItemKind=Ce={}));var fe;(function(z){z[z.Deprecated=1]="Deprecated"})(fe||(e.CompletionItemTag=fe={}));let ve=class{constructor(N,ne){this.label=N,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$NO=ve,e.$NO=ve=Qe([p],ve);let Y=class{constructor(N=[],ne=!1){this.items=N,this.isIncomplete=ne}};e.$OO=Y,e.$OO=Y=Qe([p],Y);let W=class{constructor(N,ne,Se){this.insertText=N,this.range=ne,this.command=Se}};e.$PO=W,e.$PO=W=Qe([p],W);let de=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$QO=de,e.$QO=de=Qe([p],de);var je;(function(z){z[z.Unknown=0]="Unknown",z[z.Word=1]="Word",z[z.Line=2]="Line",z[z.Suggest=3]="Suggest"})(je||(e.PartialAcceptTriggerKind=je={}));var He;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(He||(e.ViewColumn=He={}));var st;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function dt(z,N){return`${b.$zn.toKey(z)}.${N}`}var mt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval"})(mt||(e.TextEditorLineNumbersStyle=mt={}));var Ot;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ot||(e.TextDocumentSaveReason=Ot={}));var Tt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Tt||(e.TextEditorRevealType=Tt={}));var Ht;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Ht||(e.TextEditorSelectionChangeKind=Ht={}));var _t;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Xe;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Xe||(e.DecorationRangeBehavior=Xe={})),function(z){function N(ne){switch(ne){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=N}(Ht||(e.TextEditorSelectionChangeKind=Ht={}));var At;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(At||(e.SyntaxTokenType=At={})),function(z){function N(ne){switch(ne){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=N}(At||(e.SyntaxTokenType=At={}));let Ut=class{constructor(N,ne){if(ne&&!s.URI.isUri(ne))throw(0,D.$$)("target");if(!G.isRange(N)||N.isEmpty)throw(0,D.$$)("range");this.range=N,this.target=ne}};e.$SO=Ut,e.$SO=Ut=Qe([p],Ut);let bt=class{constructor(N,ne,Se,Ke){this.red=N,this.green=ne,this.blue=Se,this.alpha=Ke}};e.$TO=bt,e.$TO=bt=Qe([p],bt);let Dt=class{constructor(N,ne){if(ne&&!(ne instanceof bt))throw(0,D.$$)("color");if(!G.isRange(N)||N.isEmpty)throw(0,D.$$)("range");this.range=N,this.color=ne}};e.$UO=Dt,e.$UO=Dt=Qe([p],Dt);let ei=class{constructor(N){if(!N||typeof N!="string")throw(0,D.$$)("label");this.label=N}};e.$VO=ei,e.$VO=ei=Qe([p],ei);var ti;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var Qt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Qt||(e.SourceControlInputBoxValidationType=Qt={}));var wt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(wt||(e.TerminalExitReason=wt={}));var Lt;(function(z){z[z.Low=0]="Low",z[z.Medium=1]="Medium",z[z.High=2]="High"})(Lt||(e.TerminalShellExecutionCommandLineConfidence=Lt={}));class ci{constructor(N,ne,Se){if(this.startIndex=N,this.length=ne,this.tooltip=Se,typeof N!="number"||N<0)throw(0,D.$$)("startIndex");if(typeof ne!="number"||ne<1)throw(0,D.$$)("length");if(Se!==void 0&&typeof Se!="string")throw(0,D.$$)("tooltip")}}e.$WO=ci;class Yt{constructor(N){this.uri=N}}e.$XO=Yt;class Ge{constructor(N){this.terminalCommand=N}}e.$YO=Ge;var ii;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(ii||(e.TerminalLocation=ii={}));class li{constructor(N){if(this.options=N,typeof N!="object")throw(0,D.$$)("options")}}e.$ZO=li;var hi;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(hi||(e.TaskRevealKind=hi={}));var kt;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let jt=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(N){switch(N){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(N,ne){if(this.label=ne,typeof N!="string"||typeof ne!="string")throw(0,D.$$)("name");this.c=N}get id(){return this.c}};e.$1O=jt,e.$1O=jt=S=Qe([p],jt);function Mt(z){let N="";for(let ne=0;ne<z.length;ne++)N+=z[ne].replace(/,/g,",,")+",";return N}let Bt=class{constructor(N,ne,Se){if(typeof N!="string")throw(0,D.$$)("process");this.e=[],this.c=N,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,D.$$)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)N.push(ne);return Mt(N)}};e.$2O=Bt,e.$2O=Bt=Qe([p],Bt);let ai=class{constructor(N,ne,Se){if(this.f=[],Array.isArray(ne)){if(!N)throw(0,D.$$)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,D.$$)("command");this.e=N,this.f=ne,this.g=Se}else{if(typeof N!="string")throw(0,D.$$)("commandLine");this.c=N,this.g=ne}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,D.$$)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,D.$$)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)N.push(typeof ne=="string"?ne:ne.value);return Mt(N)}};e.$3O=ai,e.$3O=ai=Qe([p],ai);var ni;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var ri;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class Gt{constructor(N){this.c=N}computeId(){return"customExecution"+(0,I.$7g)()}set callback(N){this.c=N}get callback(){return this.c}}e.$4O=Gt;let Jt=class{static{E=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,ne,Se,Ke,rt,pt){this.k=!1,this.l=this.definition=N;let St;typeof ne=="string"?(this.o=this.name=ne,this.w=this.source=Se,this.execution=Ke,St=rt,this.k=!0):ne===ri.Global||ne===ri.Workspace?(this.target=ne,this.o=this.name=Se,this.w=this.source=Ke,this.execution=rt,St=pt):(this.target=ne,this.o=this.name=Se,this.w=this.source=Ke,this.execution=rt,St=pt),typeof St=="string"?(this.r=[St],this.t=!0):Array.isArray(St)?(this.r=St,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(N){this.j=N}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Bt?this.l={type:E.e,id:this.q.computeId()}:this.q instanceof ai?this.l={type:E.f,id:this.q.computeId()}:this.q instanceof Gt?this.l={type:E.c,id:this.q.computeId()}:this.l={type:E.g,id:(0,I.$7g)()}}get definition(){return this.l}set definition(N){if(N==null)throw(0,D.$$)("Kind can't be undefined or null");this.B(),this.l=N}get scope(){return this.m}set target(N){this.B(),this.m=N}get name(){return this.o}set name(N){if(typeof N!="string")throw(0,D.$$)("name");this.B(),this.o=N}get execution(){return this.q}set execution(N){N===null&&(N=void 0),this.B(),this.q=N;const ne=this.l.type;(E.g===ne||E.e===ne||E.f===ne||E.c===ne)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(N){if(Array.isArray(N))this.B(),this.r=N,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.B(),this.u=N}get source(){return this.w}set source(N){if(typeof N!="string"||N.length===0)throw(0,D.$$)("source must be a string of length > 0");this.B(),this.w=N}get group(){return this.x}set group(N){N===null&&(N=void 0),this.B(),this.x=N}get detail(){return this.A}set detail(N){N===null&&(N=void 0),this.A=N}get presentationOptions(){return this.y}set presentationOptions(N){N==null&&(N=Object.create(null)),this.B(),this.y=N}get runOptions(){return this.z}set runOptions(N){N==null&&(N=Object.create(null)),this.B(),this.z=N}};e.$5O=Jt,e.$5O=Jt=E=Qe([p],Jt);var ui;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(ui||(e.ProgressLocation=ui={}));var Nt;(function(z){function N(ne){const Se=ne;return(0,m.$ng)(Se.value)?Se.tooltip&&!(0,m.$jg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}z.isViewBadge=N})(Nt||(e.ViewBadge=Nt={}));let Ct=y=class{static isTreeItem(N,ne){const Se=N;if(Se.checkboxState!==void 0){const Ke=(0,m.$ng)(Se.checkboxState)?Se.checkboxState:(0,m.$lg)(Se.checkboxState)&&(0,m.$ng)(Se.checkboxState.state)?Se.checkboxState.state:void 0,rt=!(0,m.$ng)(Se.checkboxState)&&(0,m.$lg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Xt.Checked&&Ke!==Xt.Unchecked||rt!==void 0&&!(0,m.$jg)(rt))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(N instanceof y)return!0;if(Se.label!==void 0&&!(0,m.$jg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,m.$jg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,m.$jg)(Se.iconPath)&&!s.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,m.$jg)(Se.iconPath.id))){const Ke=Se.iconPath;if(!Ke||!(0,m.$jg)(Ke.light)&&!s.URI.isUri(Ke.light)&&!(0,m.$jg)(Ke.dark)&&!s.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,m.$jg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!s.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,m.$jg)(Se.tooltip)&&!(Se.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<vt.None&&Se.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,m.$jg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(N,ne=vt.None){this.collapsibleState=ne,s.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$6O=Ct,e.$6O=Ct=y=Qe([p],Ct);var vt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var Xt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(Xt||(e.TreeItemCheckboxState=Xt={}));let Et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$7O=Et,e.$7O=Et=Qe([p],Et);class si extends Et{}e.$8O=si;class Zt extends si{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$9O=Zt;class Ni{constructor(N,ne,Se,Ke){this.name=N,this.uri=ne,this._itemId=Se,this.c=Ke}data(){return this.c()}}e.$0O=Ni;let di=class{#e=new Map;constructor(N){for(const[ne,Se]of N??[]){const Ke=this.#e.get(this.#t(ne));Ke?Ke.push(Se):this.#e.set(this.#t(ne),[Se])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,ne){this.#e.set(this.#t(N),[ne])}forEach(N,ne){for(const[Se,Ke]of this.#e)for(const rt of Ke)N.call(ne,rt,Se,this)}*[Symbol.iterator](){for(const[N,ne]of this.#e)for(const Se of ne)yield[N,Se]}#t(N){return N.toLowerCase()}};e.$$O=di,e.$$O=di=Qe([p],di);let yi=class{constructor(N,ne,Se){this.insertText=N,this.title=ne,this.kind=Se}};e.$_O=yi,e.$_O=yi=Qe([p],yi);var Wt;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(Wt||(e.DocumentPasteTriggerKind=Wt={}));class fi{static{this.c="."}constructor(N){this.value=N}append(...N){return new fi((this.value?[this.value,...N]:N).join(fi.c))}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+fi.c)}}e.$aP=fi,fi.Empty=new fi("");class Fi{constructor(N,ne,Se){this.title=ne,this.insertText=N,this.kind=Se}}e.$bP=Fi;let Rt=class{constructor(N,ne){this.id=N,this.color=ne}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$cP=Rt,e.$cP=Rt=Qe([p],Rt),Rt.File=new Rt("file"),Rt.Folder=new Rt("folder");let Si=class{constructor(N){this.id=N}};e.$dP=Si,e.$dP=Si=Qe([p],Si);var Ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ai||(e.ConfigurationTarget=Ai={}));let gi=class{get base(){return this.c}set base(N){this.c=N,this.e=s.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,ne){if(typeof N!="string"&&(!N||!s.URI.isUri(N)&&!s.URI.isUri(N.uri)))throw(0,D.$$)("base");if(typeof ne!="string")throw(0,D.$$)("pattern");typeof N=="string"?this.baseUri=s.URI.file(N):s.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$eP=gi,e.$eP=gi=Qe([p],gi);const zi=new WeakMap;function ji(z,N){zi.set(z,N)}let zt=class{constructor(N,ne,Se,Ke,rt){this.enabled=typeof N=="boolean"?N:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Ke=="string"&&(this.logMessage=Ke),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=zi.get(this)??(0,I.$7g)()),this.c}};e.$gP=zt,e.$gP=zt=Qe([p],zt);let Pi=class extends zt{constructor(N,ne,Se,Ke,rt,pt){if(super(ne,Se,Ke,rt,pt),N===null)throw(0,D.$$)("location");this.location=N}};e.$hP=Pi,e.$hP=Pi=Qe([p],Pi);let Di=class extends zt{constructor(N,ne,Se,Ke,rt,pt){super(ne,Se,Ke,rt,pt),this.functionName=N}};e.$iP=Di,e.$iP=Di=Qe([p],Di);let bi=class extends zt{constructor(N,ne,Se,Ke,rt,pt,St,xt){if(super(Ke,rt,pt,St,xt),!ne)throw(0,D.$$)("dataId");this.label=N,this.dataId=ne,this.canPersist=Se}};e.$jP=bi,e.$jP=bi=Qe([p],bi);let wi=class{constructor(N,ne,Se){this.command=N,this.args=ne||[],this.options=Se}};e.$kP=wi,e.$kP=wi=Qe([p],wi);let me=class{constructor(N,ne){this.port=N,this.host=ne}};e.$lP=me,e.$lP=me=Qe([p],me);let De=class{constructor(N){this.path=N}};e.$mP=De,e.$mP=De=Qe([p],De);let ce=class{constructor(N){this.implementation=N}};e.$nP=ce,e.$nP=ce=Qe([p],ce);class K{constructor(N,ne,Se){this.session=N,this.threadId=ne,this.frameId=Se}}e.$oP=K;class ke{constructor(N,ne){this.session=N,this.threadId=ne}}e.$pP=ke;let qe=class{constructor(N,ne){this.range=N,this.expression=ne}};e.$qP=qe,e.$qP=qe=Qe([p],qe);var Ze;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Ze||(e.InlineCompletionTriggerKind=Ze={}));let Ue=class{constructor(N,ne){this.range=N,this.text=ne}};e.$rP=Ue,e.$rP=Ue=Qe([p],Ue);let ot=class{constructor(N,ne,Se=!0){this.range=N,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$sP=ot,e.$sP=ot=Qe([p],ot);let gt=class{constructor(N,ne){this.range=N,this.expression=ne}};e.$tP=gt,e.$tP=gt=Qe([p],gt);let Kt=class{constructor(N,ne){this.frameId=N,this.stoppedLocation=ne}};e.$uP=Kt,e.$uP=Kt=Qe([p],Kt);var Vt;(function(z){z[z.AIGenerated=1]="AIGenerated"})(Vt||(e.NewSymbolNameTag=Vt={}));var qt;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(qt||(e.NewSymbolNameTriggerKind=qt={}));class Li{constructor(N,ne){this.newSymbolName=N,this.tags=ne}}e.$vP=Li;var en;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let Vi=C=class extends Error{static FileExists(N){return new C(N,u.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(N){return new C(N,u.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(N){return new C(N,u.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(N){return new C(N,u.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(N){return new C(N,u.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(N){return new C(N,u.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(N,ne=u.FileSystemProviderErrorCode.Unknown,Se){super(s.URI.isUri(N)?N.toString(!0):N),this.code=Se?.name??"Unknown",(0,u.$ul)(this,ne),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$wP=Vi,e.$wP=Vi=C=Qe([p],Vi);let Ei=class{constructor(N,ne,Se){this.start=N,this.end=ne,this.kind=Se}};e.$xP=Ei,e.$xP=Ei=Qe([p],Ei);var tn;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var Ui;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var rn;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var Bi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Bi||(e.CommentThreadState=Bi={}));var Hi;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(Hi||(e.CommentThreadApplicability=Hi={}));var sn;(function(z){z[z.Reply=1]="Reply",z[z.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(N,ne=[]){this.tokenTypes=N,this.tokenModifiers=ne}}e.$yP=on;function bn(z){return typeof z>"u"||(0,m.$kg)(z)}class Ci{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,N){this.m=!0;for(let ne=0,Se=N.tokenTypes.length;ne<Se;ne++)this.k.set(N.tokenTypes[ne],ne);for(let ne=0,Se=N.tokenModifiers.length;ne<Se;ne++)this.l.set(N.tokenModifiers[ne],ne)}}push(N,ne,Se,Ke,rt){if(typeof N=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ke=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(N,ne,Se,Ke,rt);if(G.isRange(N)&&typeof ne=="string"&&bn(Se))return this.o(N,ne,Se);throw(0,D.$$)()}o(N,ne,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ke=N.start.line,rt=N.start.character,pt=N.end.character-N.start.character,St=this.k.get(ne);let xt=0;if(Se)for(const $i of Se){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const vi=this.l.get($i);xt|=1<<vi>>>0}this.q(Ke,rt,pt,St,xt)}q(N,ne,Se,Ke,rt){if(this.f&&(N<this.c||N===this.c&&ne<this.e)){this.f=!1;const xt=this.g.length/5|0;let $i=0,vi=0;for(let Ii=0;Ii<xt;Ii++){let Ti=this.g[5*Ii],xi=this.g[5*Ii+1];Ti===0?(Ti=$i,xi+=vi):Ti+=$i,this.g[5*Ii]=Ti,this.g[5*Ii+1]=xi,$i=Ti,vi=xi}}let pt=N,St=ne;this.f&&this.j>0&&(pt-=this.c,pt===0&&(St-=this.e)),this.g[this.j++]=pt,this.g[this.j++]=St,this.g[this.j++]=Se,this.g[this.j++]=Ke,this.g[this.j++]=rt,this.c=N,this.e=ne}static r(N){const ne=[],Se=N.length/5|0;for(let St=0;St<Se;St++)ne[St]=St;ne.sort((St,xt)=>{const $i=N[5*St],vi=N[5*xt];if($i===vi){const Ii=N[5*St+1],Ti=N[5*xt+1];return Ii-Ti}return $i-vi});const Ke=new Uint32Array(N.length);let rt=0,pt=0;for(let St=0;St<Se;St++){const xt=5*ne[St],$i=N[xt+0],vi=N[xt+1],Ii=N[xt+2],Ti=N[xt+3],xi=N[xt+4],Hn=$i-rt,Nr=Hn===0?vi-pt:vi,_i=5*St;Ke[_i+0]=Hn,Ke[_i+1]=Nr,Ke[_i+2]=Ii,Ke[_i+3]=Ti,Ke[_i+4]=xi,rt=$i,pt=vi}return Ke}build(N){return this.f?new Ki(new Uint32Array(this.g),N):new Ki(Ci.r(this.g),N)}}e.$zP=Ci;class Ki{constructor(N,ne){this.resultId=ne,this.data=N}}e.$AP=Ki;class wn{constructor(N,ne,Se){this.start=N,this.deleteCount=ne,this.data=Se}}e.$BP=wn;class vn{constructor(N,ne){this.resultId=ne,this.edits=N}}e.$CP=vn;var qi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(qi||(e.DebugConsoleMode=qi={}));class an{constructor(N){this.name=N}}e.$DP=an;var Ae;(function(z){z[z.Title=1]="Title",z[z.Inline=2]="Inline"})(Ae||(e.QuickInputButtonLocation=Ae={}));let mi=class{static{this.Back={iconPath:new Rt("arrow-left")}}constructor(){}};e.$EP=mi,e.$EP=mi=Qe([p],mi);var Qi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var lt;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(lt||(e.InputBoxValidationSeverity=lt={}));var It;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(It||(e.ExtensionKind=It={}));class yn{static validate(N){if(typeof N.badge=="string"){let ne=(0,T.$Uf)(N.badge,0);if(ne<N.badge.length&&(ne+=(0,T.$Uf)(N.badge,ne)),N.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Rt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ne,Se){this.badge=N,this.tooltip=ne,this.color=Se}}e.$FP=yn;let Gi=class{constructor(N){this.kind=N}};e.$GP=Gi,e.$GP=Gi=Qe([p],Gi);var Ji;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ji||(e.ColorThemeKind=Ji={}));class ki{static isNotebookRange(N){return N instanceof ki?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,ne){if(N<0)throw(0,D.$$)("start must be positive");if(ne<0)throw(0,D.$$)("end must be positive");N<=ne?(this.c=N,this.e=ne):(this.c=ne,this.e=N)}with(N){let ne=this.c,Se=this.e;return N.start!==void 0&&(ne=N.start),N.end!==void 0&&(Se=N.end),ne===this.c&&Se===this.e?this:new ki(ne,Se)}}e.$HP=ki;class Ri{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ne=>Ri.isNotebookCellData(ne))}static isNotebookCellData(N){return!0}constructor(N,ne,Se,Ke,rt,pt,St){this.kind=N,this.value=ne,this.languageId=Se,this.mime=Ke,this.outputs=rt??[],this.metadata=pt,this.executionSummary=St,Ri.validate(this)}}e.$IP=Ri;class Sn{constructor(N){this.cells=N}}e.$JP=Sn;class pi{static isNotebookCellOutputItem(N){return N instanceof pi?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ne={name:N.name,message:N.message,stack:N.stack};return pi.json(ne,"application/vnd.code.notebook.error")}static stdout(N){return pi.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return pi.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ne="application/octet-stream"){return new pi(N,ne)}static#e=new TextEncoder;static text(N,ne=R.$it.text){const Se=pi.#e.encode(String(N));return new pi(Se,ne)}static json(N,ne="text/x-json"){const Se=JSON.stringify(N,void 0,"	");return pi.text(Se,ne)}constructor(N,ne){this.data=N,this.mime=ne;const Se=(0,R.$mt)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$KP=pi;class Wi{static isNotebookCellOutput(N){return N instanceof Wi?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ne=!1){const Se=new Set,Ke=new Set;for(let rt=0;rt<N.length;rt++){const pt=N[rt],St=(0,R.$mt)(pt.mime);if(!Se.has(St)||(0,$.$cM)(St)){Se.add(St);continue}Ke.add(rt),ne&&console.warn(`DUPLICATED mime type '${pt.mime}' will be dropped`)}return Ke.size===0?N:N.filter((rt,pt)=>!Ke.has(pt))}constructor(N,ne,Se){this.items=Wi.ensureUniqueMimeTypes(N,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,I.$7g)(),this.metadata=ne??Se)}}e.$LP=Wi;var Xi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Xi||(e.NotebookCellKind=Xi={}));var cn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(cn||(e.NotebookCellExecutionState=cn={}));var ln;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ln||(e.NotebookCellStatusBarAlignment=ln={}));var un;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(un||(e.NotebookEditorRevealType=un={}));class En{constructor(N,ne){this.text=N,this.alignment=ne}}e.$MP=En;var hn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(hn||(e.NotebookControllerAffinity=hn={}));var dn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(dn||(e.NotebookControllerAffinity2=dn={}));class kn{constructor(N,ne=[]){this.uri=N,this.provides=(0,v.$6b)(ne)}}e.$NP=kn;class In{constructor(N){this.label=N}}e.$OP=In;var fn;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Yi=class{constructor(N,ne){this.label=N,this.timestamp=ne}};e.$PP=Yi,e.$PP=Yi=Qe([p],Yi);var gn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var te;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(te||(e.ExtensionRuntime=te={}));var le;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(le||(e.StandardTokenType=le={}));class Te{constructor(N,ne){this.ranges=N,this.wordPattern=ne}}e.$QP=Te;class ft{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$RP=ft;var Pt;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Pt||(e.TestResultState=Pt={}));var Ft;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(Ft||(e.TestRunProfileKind=Ft={}));let Oi=class{constructor(N=void 0,ne=void 0,Se=void 0,Ke=!1,rt=!0){this.include=N,this.exclude=ne,this.profile=Se,this.continuous=Ke,this.preserveFocus=rt}};e.$SP=Oi,e.$SP=Oi=Qe([p],Oi);let Zi=O=class{static diff(N,ne,Se){const Ke=new O(N);return Ke.expectedOutput=ne,Ke.actualOutput=Se,Ke}constructor(N){this.message=N}};e.$TP=Zi,e.$TP=Zi=O=Qe([p],Zi);let Pn=class{constructor(N){this.id=N}};e.$UP=Pn,e.$UP=Pn=Qe([p],Pn);class Gn{constructor(N,ne,Se){this.label=N,this.uri=ne,this.position=Se}}e.$VP=Gn;class mn{constructor(N,ne){this.covered=N,this.total=ne,Cn(this)}}e.$WP=mn;function Cn(z){if(z){if(z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`);if(z.total<0)throw new Error(`The number of covered items (${z.total}) cannot be negative`)}}class Dn{static fromDetails(N,ne){const Se=new mn(0,0),Ke=new mn(0,0),rt=new mn(0,0);for(const St of ne)if("branches"in St){Se.total+=1,Se.covered+=St.executed?1:0;for(const xt of St.branches)Ke.total+=1,Ke.covered+=xt.executed?1:0}else rt.total+=1,rt.covered+=St.executed?1:0;const pt=new Dn(N,Se,Ke.total>0?Ke:void 0,rt.total>0?rt:void 0);return pt.detailedCoverage=ne,pt}constructor(N,ne,Se,Ke,rt=[]){this.uri=N,this.statementCoverage=ne,this.branchCoverage=Se,this.declarationCoverage=Ke,this.fromTests=rt}}e.$YP=Dn;class Jn{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ne,Se=[]){this.executed=N,this.location=ne,this.branches=Se}}e.$ZP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ne,Se){this.executed=N,this.location=ne,this.label=Se}}e.$1P=Xn;class Yn{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ne,Se){this.name=N,this.executed=ne,this.location=Se}}e.$2P=Yn;var Rn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Rn||(e.ExternalUriOpenerPriority=Rn={}));var On;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(On||(e.WorkspaceTrustState=On={}));var Tn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class Zn{constructor(N,ne,Se,Ke,rt,pt){this.kind=N,this.name=ne,this.detail=Se,this.uri=Ke,this.range=rt,this.selectionRange=pt}}e.$3P=Zn;class xn{constructor(N){this.uri=N}}e.$4P=xn;class _n{constructor(N,ne){this.original=N,this.modified=ne}}e.$5P=_n;class er{constructor(N,ne,Se,Ke){this.base=N,this.input1=ne,this.input2=Se,this.result=Ke}}e.$6P=er;class tr{constructor(N,ne){this.uri=N,this.viewType=ne}}e.$7P=tr;class ir{constructor(N){this.viewType=N}}e.$8P=ir;class nr{constructor(N,ne){this.uri=N,this.notebookType=ne}}e.$9P=nr;class rr{constructor(N,ne,Se){this.original=N,this.modified=ne,this.notebookType=Se}}e.$0P=rr;class sr{constructor(){}}e.$$P=sr;class or{constructor(N,ne){this.uri=N,this.inputBoxUri=ne}}e.$_P=or;class ar{constructor(){}}e.$aQ=ar;class cr{constructor(N){this.textDiffs=N}}e.$bQ=cr;var An;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(An||(e.InteractiveSessionVoteDirection=An={}));var Ln;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(Ln||(e.ChatCopyKind=Ln={}));var Mn;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(Mn||(e.ChatVariableLevel=Mn={}));class lr{constructor(N,ne,Se){this.id=N,this.label=ne,this.values=Se}}e.$cQ=lr;var Nn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(Nn||(e.InteractiveEditorResponseFeedbackKind=Nn={}));var Fn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(Fn||(e.ChatResultFeedbackKind=Fn={}));class ur{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new tt(N):N}}e.$dQ=ur;class hr{constructor(N,ne){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new tt(N):N,this.vulnerabilities=ne}}e.$eQ=hr;class dr{constructor(N,ne){this.participant=N,this.command=ne}}e.$fQ=dr;class fr{constructor(N,ne,Se,Ke){this.title=N,this.message=ne,this.data=Se,this.buttons=Ke}}e.$gQ=fr;class gr{constructor(N,ne){this.value=N,this.baseUri=ne}}e.$hQ=gr;class mr{constructor(N,ne){this.value=N,this.title=ne}}e.$iQ=mr;class pr{constructor(N){this.value=N}}e.$jQ=pr;class $r{constructor(N,ne){this.value=N,this.task=ne}}e.$kQ=$r;class br{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new tt(N):N}}e.$lQ=br;class wr{constructor(N){this.value=N}}e.$mQ=wr;class vr{constructor(N,ne,Se){this.value=N,this.iconPath=ne,this.options=Se}}e.$nQ=vr;class yr{constructor(N,ne,Se){this.value=N,this.license=ne,this.snippet=Se}}e.$oQ=yr;class Sr{constructor(N,ne){this.uri=N,this.range=ne}}e.$pQ=Sr;class Er{constructor(N,ne){this.uri=N,this.edits=Array.isArray(ne)?ne:[ne]}}e.$qQ=Er;class kr{constructor(N,ne,Se,Ke){this.prompt=N,this.command=ne,this.references=Se,this.participant=Ke}}e.$rQ=kr;class Ir{constructor(N,ne,Se,Ke){this.response=N,this.result=ne,this.participant=Se,this.command=Ke}}e.$sQ=Ir;var zn;(function(z){z[z.Panel=1]="Panel",z[z.Terminal=2]="Terminal",z[z.Notebook=3]="Notebook",z[z.Editor=4]="Editor"})(zn||(e.ChatLocation=zn={}));var Un;(function(z){z[z.Complete=1]="Complete",z[z.Partial=2]="Partial",z[z.Omitted=3]="Omitted"})(Un||(e.ChatResponseReferencePartStatusKind=Un={}));class Pr{constructor(N,ne,Se){this.document=N,this.selection=ne,this.wholeRange=Se}}e.$tQ=Pr;class Dr{constructor(N){this.cell=N}}e.$uQ=Dr;var pn;(function(z){z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.System=3]="System"})(pn||(e.LanguageModelChatMessageRole=pn={}));class Cr{constructor(N,ne,Se){this.toolCallId=N,this.content=ne,this.isError=Se??!1}}e.$vQ=Cr;class $n{static User(N,ne){const Se=new $n(pn.User,typeof N=="string"?N:"",ne);return Se.content2=[N],Se}static Assistant(N,ne){return new $n(pn.Assistant,N,ne)}constructor(N,ne,Se){this.role=N,this.content=ne,this.content2=[ne],this.name=Se}}e.$wQ=$n;class Rr{constructor(N,ne,Se){this.name=N,this.toolCallId=ne,this.parameters=Se}}e.$xQ=Rr;class Or{constructor(N){this.value=N}}e.$yQ=Or;class Tr{constructor(N){this.content=N}}e.$zQ=Tr;class Ar{constructor(N,ne){this.content=N,this.name=ne}}e.$AQ=Ar;class Lr{constructor(N,ne){this.content=N,this.name=ne}}e.$BQ=Lr;class Mi extends Error{static NotFound(N){return new Mi(N,Mi.NotFound.name)}static NoPermissions(N){return new Mi(N,Mi.NoPermissions.name)}static Blocked(N){return new Mi(N,Mi.Blocked.name)}constructor(N,ne,Se){super(N,{cause:Se}),this.name="LanguageModelError",this.code=ne??""}}e.$CQ=Mi;var jn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(jn||(e.RelatedInformationType=jn={}));var Bn;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped",z[z.Error=5]="Error"})(Bn||(e.SpeechToTextStatus=Bn={}));var qn;(function(z){z[z.Started=1]="Started",z[z.Stopped=2]="Stopped",z[z.Error=3]="Error"})(qn||(e.TextToSpeechStatus=qn={}));var Wn;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(Wn||(e.KeywordRecognitionStatus=Wn={}));class Mr{constructor(N,ne){this.text=N,this.range=ne}}e.$DQ=Mr;var Vn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(Re[227],Oe([1,0,5,7]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(v.$bO.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,T,m){if(this.a.size===0)throw new Error("No related information providers registered");const s=this.a.get(R);if(!s)throw new Error("related information provider not found");return await s.provideRelatedInformation(T,m)??[]}getRelatedInformation(R,T,m){return this.c.$getAiRelatedInformation(T,m)}registerRelatedInformationProvider(R,T,m){const s=this.b;return this.b++,this.a.set(s,m),this.c.$registerAiRelatedInformationProvider(s,T),new D.$dO(()=>{this.c.$unregisterAiRelatedInformationProvider(s),this.a.delete(s)})}}e.$6qc=P}),define(Re[91],Oe([1,0,6,5,7,18,119,3,16]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=e.$erc=void 0,e.$erc=(0,T.$Ki)("IExtHostAuthentication");let s=class{constructor(u){this.b=new Map,this.c=new v.$qe,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=u.getProxy(D.$bO.MainThreadAuthentication)}async getSession(u,k,$,r={}){const a=L.$zn.toKey(u.identifier),h=[...$].sort().join(" ");return await this.d.getOrCreate(`${a} ${k} ${h}`,async()=>{await this.a.$ensureProvider(k);const c=u.displayName||u.name;return this.a.$getSession(k,$,a,c,r)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,k){const $=this.b.get(u);return $?$.provider.removeSession(k):this.a.$removeSession(u,k)}registerAuthenticationProvider(u,k,$,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:k,provider:$,options:r??{supportsMultipleAccounts:!1}});const a=$.onDidChangeSessions(h=>this.a.$sendDidChangeSessions(u,h));return this.a.$registerAuthenticationProvider(u,k,r?.supportsMultipleAccounts??!1),new P.$dO(()=>{a.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,k,$){const r=this.b.get(u);if(r)return await r.provider.createSession(k,$);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,k){const $=this.b.get(u);if($)return await $.provider.removeSession(k);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,k,$){const r=this.b.get(u);if(r)return await r.provider.getSessions(k,$);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,k){return u.startsWith(R.$eN)||this.c.fire({provider:{id:u,label:k}}),Promise.resolve()}};e.$frc=s,e.$frc=s=Qe([We(0,m.$OQ)],s);class I{constructor(){this.a=new Map}getOrCreate(u,k){const $=this.a.get(u);if($)return $;const r=k().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(Re[124],Oe([1,0,2,5,7,3,16,11,17,13,22,21]),function(be,e,v,D,P,L,R,T,m,s,I,b){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$ksc=e.$jsc=void 0;let k=class{static{u=this}static{this.c=0}static{this.d=250}constructor(r,a){this.h=a,this.f=new Map,this.g=r.getProxy(D.$bO.MainThreadDecorations)}registerFileDecorationProvider(r,a){const h=u.c++;this.f.set(h,{provider:r,extensionDescription:a}),this.g.$registerDecorationProvider(h,a.identifier.value);const c=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(h,null);return}const n=(0,m.$6b)(i);if(n.length<=u.d){this.g.$onDidChange(h,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,n.length);const t=n.map(g=>({uri:g,rank:(0,s.$nf)(g.path,"/")})),o=(0,m.$Db)(t,(g,f)=>g.rank-f.rank||(0,s.$Df)(g.uri.path,f.uri.path)),l=[];e:for(const g of o){let f;for(const d of g){const S=(0,I.$rc)(d.uri.path);if(f!==S&&(f=S,l.push(d.uri)>=u.d))break e}}this.g.$onDidChange(h,l)});return new P.$dO(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(h),this.f.delete(h)})}async $provideDecorations(r,a,h){if(!this.f.has(r))return Object.create(null);const c=Object.create(null),{provider:i,extensionDescription:n}=this.f.get(r);return await Promise.all(a.map(async t=>{try{const{uri:o,id:l}=t,g=await Promise.resolve(i.provideFileDecoration(v.URI.revive(o),h));if(!g)return;try{P.$FP.validate(g),g.badge&&typeof g.badge!="string"&&(0,b.$DH)(n,"codiconDecoration"),c[l]=[g.propagate,g.tooltip,g.badge,g.color]}catch(f){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${f}`)}}catch(o){this.h.error(o)}})),c}};e.$jsc=k,e.$jsc=k=u=Qe([We(0,R.$OQ),We(1,T.$fk)],k),e.$ksc=(0,L.$Ki)("IExtHostDecorations")}),define(Re[228],Oe([1,0,12,2,7,5,15,19,13]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$msc=void 0;class s{static{this.a=0}constructor(b,u,k){this.d=u,this.e=k,this.b=new Map,this.c=b.getProxy(L.$bO.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,u){if(Object.keys(R.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const k=s.a++;this.b.set(k,u),this.c.$registerTextContentProvider(k,b);let $;if(typeof u.onDidChange=="function"){let r;$=u.onDidChange(async a=>{if(a.scheme!==b){this.e.warn(`Provider for scheme '${b}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;r&&await r;const h=this.$provideTextDocumentContent(k,a).then(async c=>{if(!c&&typeof c!="string")return;const i=this.d.getDocument(a);if(!i)return;const n=(0,m.$xf)(c);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(a,c)}).catch(v.$4).finally(()=>{r===h&&(r=void 0)});r=h})}return new P.$dO(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(b,u){const k=this.b.get(b);return k?Promise.resolve(k.provideTextDocumentContent(D.URI.revive(u),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$msc=s}),define(Re[125],Oe([1,0,61,15,13,284,170,7,17]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=e.$RQ=void 0,e.$QQ=I;const s=new Map;function I($,r){r?s.set($,r):s.delete($)}function b($){return s.get($)}class u extends L.$Aw{constructor(r,a,h,c,i,n,t){super(a,h,c,i),this.o=r,this.p=n,this.q=t,this.n=!1}dispose(){(0,v.ok)(!this.n),this.n=!0,this.q=!1}equalLines(r){return(0,m.$yb)(this.b,r)}get document(){if(!this.m){const r=this;this.m={get uri(){return r.a},get fileName(){return r.a.fsPath},get isUntitled(){return r.a.scheme===D.Schemas.untitled},get languageId(){return r.p},get version(){return r.d},get isClosed(){return r.n},get isDirty(){return r.q},save(){return r.r()},getText(a){return a?r.s(a):r.getText()},get eol(){return r.c===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return r.b.length},lineAt(a){return r.t(a)},offsetAt(a){return r.u(a)},positionAt(a){return r.v(a)},validateRange(a){return r.w(a)},validatePosition(a){return r.x(a)},getWordRangeAtPosition(a,h){return r.y(a,h)},[Symbol.for("debug.description")](){return`TextDocument(${r.a.toString()})`}}}return Object.freeze(this.m)}_acceptLanguageId(r){(0,v.ok)(!this.n),this.p=r}_acceptIsDirty(r){(0,v.ok)(!this.n),this.q=r}r(){return this.n?Promise.reject(new Error("Document has been closed")):this.o.$trySaveDocument(this.a)}s(r){const a=this.w(r);if(a.isEmpty)return"";if(a.isSingleLine)return this.b[a.start.line].substring(a.start.character,a.end.character);const h=this.c,c=a.start.line,i=a.end.line,n=[];n.push(this.b[c].substring(a.start.character));for(let t=c+1;t<i;t++)n.push(this.b[t]);return n.push(this.b[i].substring(0,a.end.character)),n.join(h)}t(r){let a;if(r instanceof T.$eO?a=r.line:typeof r=="number"&&(a=r),typeof a!="number"||a<0||a>=this.b.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new k(a,this.b[a],a===this.b.length-1)}u(r){return r=this.x(r),this.h(),this.f.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.h();const a=this.f.getIndexOf(r),h=this.b[a.index].length;return new T.$eO(a.index,Math.min(a.remainder,h))}w(r){if(!(r instanceof T.$fO))throw new Error("Invalid argument");const a=this.x(r.start),h=this.x(r.end);return a===r.start&&h===r.end?r:new T.$fO(a.line,a.character,h.line,h.character)}x(r){if(!(r instanceof T.$eO))throw new Error("Invalid argument");if(this.b.length===0)return r.with(0,0);let{line:a,character:h}=r,c=!1;if(a<0)a=0,h=0,c=!0;else if(a>=this.b.length)a=this.b.length-1,h=this.b[a].length,c=!0;else{const i=this.b[a].length;h<0?(h=0,c=!0):h>i&&(h=i,c=!0)}return c?new T.$eO(a,h):r}y(r,a){const h=this.x(r);if(!a)a=b(this.p);else if((0,P.$wf)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const c=(0,R.$At)(h.character+1,(0,R.$yt)(a),this.b[h.line],0);if(c)return new T.$fO(h.line,c.startColumn-1,h.line,c.endColumn-1)}}e.$RQ=u;class k{constructor(r,a,h){this.a=r,this.b=a,this.c=h}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$fO(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$fO(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$SQ=k}),define(Re[229],Oe([1,0,5,7]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$psc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(v.$bO.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,T,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const s=this.a.get(R);if(!s)throw new Error("Embedding vector provider not found");const I=await s.provideEmbeddingVector(T,m);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(R,T,m){const s=this.b;return this.b++,this.a.set(s,m),this.c.$registerAiEmbeddingVectorProvider(T,s),new D.$dO(()=>{this.c.$unregisterAiEmbeddingVectorProvider(s),this.a.delete(s)})}}e.$psc=P}),define(Re[68],Oe([1,0,5,28,7,20,3,16,50,4,10,24,15]),function(be,e,v,D,P,L,R,T,m,s,I,b,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$vrc=e.$urc=void 0,D=Ve(D);let $=k=class{constructor(a,h){this.b=new Map,this.c=new I.$Th,this.a=a.getProxy(v.$bO.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(i){try{let n;const t=c.b.get(i.scheme);return t?(await c.a.$ensureActivation(i.scheme),n=await t.impl.stat(i)):n=await c.a.$stat(i),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===D.FilePermission.Readonly?1:void 0}}catch(n){k.e(n)}},async readDirectory(i){try{const n=c.b.get(i.scheme);return n?(await c.a.$ensureActivation(i.scheme),(await n.impl.readDirectory(i)).slice()):await c.a.$readdir(i)}catch(n){return k.e(n)}},async createDirectory(i){try{const n=c.b.get(i.scheme);return n&&!n.isReadonly?(await c.a.$ensureActivation(i.scheme),await c.d(n.impl,n.extUri,i)):await c.a.$mkdir(i)}catch(n){return k.e(n)}},async readFile(i){try{const n=c.b.get(i.scheme);return n?(await c.a.$ensureActivation(i.scheme),(await n.impl.readFile(i)).slice()):(await c.a.$readFile(i)).buffer}catch(n){return k.e(n)}},async writeFile(i,n){try{const t=c.b.get(i.scheme);return t&&!t.isReadonly?(await c.a.$ensureActivation(i.scheme),await c.d(t.impl,t.extUri,t.extUri.dirname(i)),await c.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,n,{create:!0,overwrite:!0})))):await c.a.$writeFile(i,L.$Se.wrap(n))}catch(t){return k.e(t)}},async delete(i,n){try{const t=c.b.get(i.scheme);return t&&!t.isReadonly&&!n?.useTrash?(await c.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...n})):await c.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(t){return k.e(t)}},async rename(i,n,t){try{return await c.a.$rename(i,n,{overwrite:!1,...t})}catch(o){return k.e(o)}},async copy(i,n,t){try{return await c.a.$copy(i,n,{overwrite:!1,...t})}catch(o){return k.e(o)}},isWritableFileSystem(i){const n=h.getCapabilities(i);if(typeof n=="number")return!(n&D.FileSystemProviderCapabilities.Readonly)}})}async d(a,h,c){const i=[];for(;!h.isEqual(c,h.dirname(c));)try{if(!((await a.stat(c)).type&D.FileType.Directory))throw P.$wP.FileExists(`Unable to create folder '${c.scheme===u.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(D.$vl(n)!==D.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(h.basename(c)),c=h.dirname(c)}for(let n=i.length-1;n>=0;n--){c=h.joinPath(c,i[n]);try{await a.createDirectory(c)}catch(t){if(D.$vl(t)!==D.FileSystemProviderErrorCode.FileExists)throw t}}}static e(a){if(a instanceof P.$wP)throw a;if(a instanceof D.$rl)switch(a.code){case D.FileSystemProviderErrorCode.FileExists:throw P.$wP.FileExists(a.message);case D.FileSystemProviderErrorCode.FileNotFound:throw P.$wP.FileNotFound(a.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw P.$wP.FileNotADirectory(a.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw P.$wP.FileIsADirectory(a.message);case D.FileSystemProviderErrorCode.NoPermissions:throw P.$wP.NoPermissions(a.message);case D.FileSystemProviderErrorCode.Unavailable:throw P.$wP.Unavailable(a.message);default:throw new P.$wP(a.message,a.name)}if(!(a instanceof Error))throw new P.$wP(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw P.$wP.Unavailable(a.message);switch(a.name){case D.FileSystemProviderErrorCode.FileExists:throw P.$wP.FileExists(a.message);case D.FileSystemProviderErrorCode.FileNotFound:throw P.$wP.FileNotFound(a.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw P.$wP.FileNotADirectory(a.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw P.$wP.FileIsADirectory(a.message);case D.FileSystemProviderErrorCode.NoPermissions:throw P.$wP.NoPermissions(a.message);case D.FileSystemProviderErrorCode.Unavailable:throw P.$wP.Unavailable(a.message);default:throw new P.$wP(a.message,a.name)}}addFileSystemProvider(a,h,c){return this.b.set(a,{impl:h,extUri:c?.isCaseSensitive?b.$bh:b.$dh,isReadonly:!!c?.isReadonly}),(0,s.$Xc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??b.$bh}};e.$urc=$,e.$urc=$=k=Qe([We(0,T.$OQ),We(1,m.$$qc)],$),e.$vrc=(0,R.$Ki)("IExtHostConsumerFileSystem")}),define(Re[92],Oe([1,0,3,26,11,68,2]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xrc=e.$wrc=void 0,e.$wrc=(0,v.$Ki)("IExtensionStoragePaths");let T=class{constructor(s,I,b){this.d=I,this.f=b,this.a=s.workspace??void 0,this.b=s.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(s){return R.URI.joinPath(this.b.workspaceStorageHome,s)}async h(){if(!this.a)return Promise.resolve(void 0);const s=this.a.id,I=await this.g(s);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(R.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(b){this.d.error("[ExtHostStorage]",b);return}}workspaceValue(s){if(this.c)return R.URI.joinPath(this.c,s.identifier.value)}globalValue(s){return R.URI.joinPath(this.b.globalStorageHome,s.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$xrc=T,e.$xrc=T=Qe([We(0,D.$5Q),We(1,P.$fk),We(2,L.$vrc)],T)}),define(Re[230],Oe([1,0,7,16,6]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_sc=void 0;let L=class{constructor(T){this.a=new v.$GP(v.ColorThemeKind.Dark),this.b=new P.$qe}get activeColorTheme(){return this.a}$onColorThemeChange(T){let m;switch(T){case"light":m=v.ColorThemeKind.Light;break;case"hcDark":m=v.ColorThemeKind.HighContrast;break;case"hcLight":m=v.ColorThemeKind.HighContrastLight;break;default:m=v.ColorThemeKind.Dark}this.a=new v.$GP(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$_sc=L,e.$_sc=L=Qe([We(0,D.$OQ)],L)}),define(Re[93],Oe([1,0,19,6,4,9,3,11,184,5,26,16,7]),function(be,e,v,D,P,L,R,T,m,s,I,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kHb=e.$jHb=e.TunnelDtoConverter=void 0,L=Ve(L),u=Ve(u);class k extends m.$Zw{}var $;(function(a){function h(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}a.fromApiTunnel=h;function c(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}a.fromServiceTunnel=c})($||(e.TunnelDtoConverter=$={})),e.$jHb=(0,R.$Ki)("IExtHostTunnelService");let r=class extends P.$Zc{constructor(h,c,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new D.$qe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=h.getProxy(s.$bO.MainThreadTunnelService)}async openTunnel(h,c){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const i=await this.a.$openTunnel(c,h.displayName);if(i){const n=new k(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(h,c){h.portRange===void 0&&h.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:h,provider:c}),this.a.$registerPortsAttributesProvider(h,i),new u.$dO(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(h,c,i,n,t){const o=[];for(const g of h){const f=this.r.get(g);if(!f)return[];o.push(...await Promise.all(c.map(async d=>{let S;try{S=await f.provider.providePortAttributes({port:d,pid:i,commandLine:n},t)}catch{S=await f.provider.providePortAttributes(d,i,n,t)}return{providedAttributes:S,port:d}})))}const l=o.filter(g=>!!g.providedAttributes);return l.length>0?l.map(g=>({autoForwardAction:g.providedAttributes.autoForwardAction,port:g.port})):[]}async $registerCandidateFinder(h){}registerTunnelProvider(h,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,t)=>await h.provideTunnel(n,t,v.CancellationToken.None)??void 0;const i=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions,protocol:c.tunnelFeatures.protocol===void 0?!0:c.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Xc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(h,c){if(h){h.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this.f=h.showCandidatePort,this.a.$setCandidateFilter());const i=h.tunnelFactory??(c?this.w(c):void 0);if(i){this.b=i;let n=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:L.localize(2717,null),themeIcon:"lock"},{id:"public",label:L.localize(2718,null),themeIcon:"eye"}]);const t=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,P.$Xc)(()=>{this.b=void 0})}w(h){}async $closeTunnel(h,c){if(this.g.has(h.host)){const i=this.g.get(h.host);i.has(h.port)&&(c&&i.get(h.port).disposeListener.dispose(),await i.get(h.port).tunnel.dispose(),i.delete(h.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(h,c){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(h,c);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const n=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(h.remoteAddress.host)||this.g.set(h.remoteAddress.host,new Map);const t=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:n,disposeListener:t}),$.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(h){const c=await Promise.all(h.map(n=>this.f(n.host,n.port,n.detail??""))),i=h.filter((n,t)=>c[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(n=>n.port).join(", ")} to ${i.map(n=>n.port).join(", ")}`),i}};e.$kHb=r,e.$kHb=r=Qe([We(0,b.$OQ),We(1,I.$5Q),We(2,T.$fk)],r)}),define(Re[8],Oe([1,0,17,20,150,231,59,27,140,34,72,25,146,24,36,14,2,106,32,154,94,52,108,77,118,116,117,207,81,90,54,55,204,7]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n,t,o,l,g,f,d,S,E,y,C,O,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatLanguageModelToolReference=e.ChatPromptReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseMovePart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$LQ=ie,e.$MQ=_,e.$NQ=$e,R=Ve(R),m=Ve(m),c=Ve(c),i=Ve(i),n=Ve(n),S=Ve(S),y=Ve(y),w=Ve(w);var M;(function(me){function De(K){const{selectionStartLineNumber:ke,selectionStartColumn:qe,positionLineNumber:Ze,positionColumn:Ue}=K,ot=new w.$eO(ke-1,qe-1),gt=new w.$eO(Ze-1,Ue-1);return new w.$gO(ot,gt)}me.to=De;function ce(K){const{anchor:ke,active:qe}=K;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}me.from=ce})(M||(e.Selection=M={}));var A;(function(me){function De(K){if(!K)return;const{start:ke,end:qe}=K;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}me.from=De;function ce(K){if(!K)return;const{startLineNumber:ke,startColumn:qe,endLineNumber:Ze,endColumn:Ue}=K;return new w.$fO(ke-1,qe-1,Ze-1,Ue-1)}me.to=ce})(A||(e.Range=A={}));var F;(function(me){function De(K){return{uri:K.uri,range:A.from(K.range)}}me.from=De;function ce(K){return new w.$rO(a.URI.revive(K.uri),A.to(K.range))}me.to=ce})(F||(e.Location=F={}));var G;(function(me){function De(ce){switch(ce){case i.StandardTokenType.Comment:return w.StandardTokenType.Comment;case i.StandardTokenType.Other:return w.StandardTokenType.Other;case i.StandardTokenType.RegEx:return w.StandardTokenType.RegEx;case i.StandardTokenType.String:return w.StandardTokenType.String}}me.to=De})(G||(e.TokenType=G={}));var x;(function(me){function De(K){return new w.$eO(K.lineNumber-1,K.column-1)}me.to=De;function ce(K){return{lineNumber:K.line+1,column:K.character+1}}me.from=ce})(x||(e.Position=x={}));var j;(function(me){function De(ke,qe,Ze){return(0,v.$Lb)((0,v.$6b)(ke).map(Ue=>ce(Ue,qe,Ze)))}me.from=De;function ce(ke,qe,Ze){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Ze?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:K(ke.scheme,qe),pattern:He.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Ze?.isBuiltin}}function K(ke,qe){return qe&&typeof ke=="string"?qe.transformOutgoingScheme(ke):ke}})(j||(e.DocumentSelector=j={}));var U;(function(me){function De(K){switch(K){case w.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case w.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}me.from=De;function ce(K){switch(K){case o.MarkerTag.Unnecessary:return w.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return w.DiagnosticTag.Deprecated;default:return}}me.to=ce})(U||(e.DiagnosticTag=U={}));var J;(function(me){function De(K){let ke;return K.code&&((0,r.$jg)(K.code)||(0,r.$ng)(K.code)?ke=String(K.code):ke={value:String(K.code.value),target:K.code.target}),{...A.from(K.range),message:K.message,source:K.source,code:ke,severity:ae.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(Z.from),tags:Array.isArray(K.tags)?(0,v.$Lb)(K.tags.map(U.from)):void 0}}me.from=De;function ce(K){const ke=new w.$tO(A.to(K),K.message,ae.to(K.severity));return ke.source=K.source,ke.code=(0,r.$jg)(K.code)?K.code:K.code?.value,ke.relatedInformation=K.relatedInformation&&K.relatedInformation.map(Z.to),ke.tags=K.tags&&(0,v.$Lb)(K.tags.map(U.to)),ke}me.to=ce})(J||(e.Diagnostic=J={}));var Z;(function(me){function De(K){return{...A.from(K.location.range),message:K.message,resource:K.location.uri}}me.from=De;function ce(K){return new w.$sO(new w.$rO(K.resource,A.to(K)),K.message)}me.to=ce})(Z||(e.DiagnosticRelatedInformation=Z={}));var ae;(function(me){function De(K){switch(K){case w.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}me.from=De;function ce(K){switch(K){case o.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}me.to=ce})(ae||(e.DiagnosticSeverity=ae={}));var ee;(function(me){function De(K){return typeof K=="number"&&K>=w.ViewColumn.One?K-1:K===w.ViewColumn.Beside?p.$UE:p.$TE}me.from=De;function ce(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=ce})(ee||(e.ViewColumn=ee={}));function oe(me){return typeof me.range<"u"}function ie(me){return me.length===0?!0:!!oe(me[0])}var ue;(function(me){function De(Ue){return Ue.map(me.from)}me.fromMany=De;function ce(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function K(Ue){let ot;if(ce(Ue)){const{language:Vt,value:qt}=Ue;ot={value:"```"+Vt+`
`+qt+"\n```\n"}}else w.$HO.isMarkdownString(Ue)?ot={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml,baseUri:Ue.baseUri}:typeof Ue=="string"?ot={value:Ue}:ot={value:""};const gt=Object.create(null);ot.uris=gt;const Kt=({href:Vt})=>{try{let qt=a.URI.parse(Vt,!0);qt=qt.with({query:ke(qt.query,gt)}),gt[Vt]=qt}catch{}return""};return m.marked.walkTokens(m.marked.lexer(ot.value),Vt=>{Vt.type==="link"?Kt({href:Vt.href}):Vt.type==="image"&&typeof Vt.href=="string"&&Kt(R.$el(Vt.href))}),ot}me.from=K;function ke(Ue,ot){if(!Ue)return Ue;let gt;try{gt=(0,s.$gi)(Ue)}catch{}if(!gt)return Ue;let Kt=!1;return gt=(0,b.$oo)(gt,Vt=>{if(a.URI.isUri(Vt)){const qt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[qt]=Vt,Kt=!0,qt}else return}),Kt?JSON.stringify(gt):Ue}function qe(Ue){const ot=new w.$HO(Ue.value,Ue.supportThemeIcons);return ot.isTrusted=Ue.isTrusted,ot.supportHtml=Ue.supportHtml,ot.baseUri=Ue.baseUri?a.URI.from(Ue.baseUri):void 0,ot}me.to=qe;function Ze(Ue){if(Ue)return typeof Ue=="string"?Ue:me.from(Ue)}me.fromStrict=Ze})(ue||(e.MarkdownString=ue={}));function _(me){return ie(me)?me.map(De=>({range:A.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?ue.fromMany(De.hoverMessage):De.hoverMessage?ue.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):me.map(De=>({range:A.from(De)}))}function $e(me){return typeof me>"u"?me:typeof me=="string"?a.URI.file(me):me}var Ie;(function(me){function De(ce){return typeof ce>"u"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?$e(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}me.from=De})(Ie||(e.ThemableDecorationAttachmentRenderOptions=Ie={}));var X;(function(me){function De(ce){return typeof ce>"u"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?$e(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?Ie.from(ce.before):void 0,after:ce.after?Ie.from(ce.after):void 0}}me.from=De})(X||(e.ThemableDecorationRenderOptions=X={}));var V;(function(me){function De(ce){if(typeof ce>"u")return ce;switch(ce){case w.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case w.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case w.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}me.from=De})(V||(e.DecorationRangeBehavior=V={}));var re;(function(me){function De(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?V.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?X.from(ce.light):void 0,dark:ce.dark?X.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?$e(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?Ie.from(ce.before):void 0,after:ce.after?Ie.from(ce.after):void 0}}me.from=De})(re||(e.DecorationRenderOptions=re={}));var we;(function(me){function De(K){return{text:K.newText,eol:K.newEol&&ve.from(K.newEol),range:A.from(K.range)}}me.from=De;function ce(K){const ke=new w.$mO(A.to(K.range),K.text);return ke.newEol=typeof K.eol>"u"?void 0:ve.to(K.eol),ke}me.to=ce})(we||(e.TextEdit=we={}));var Pe;(function(me){function De(K,ke){const qe={edits:[]};if(K instanceof w.$pO){const Ze=new T.$Gc;for(const Ue of K._allEntries())Ue._type===w.FileEditType.File&&a.URI.isUri(Ue.to)&&Ue.from===void 0&&Ze.add(Ue.to);for(const Ue of K._allEntries())if(Ue._type===w.FileEditType.File){let ot;Ue.options?.contents&&(ArrayBuffer.isView(Ue.options.contents)?ot={type:"base64",value:(0,D.$af)(D.$Se.wrap(Ue.options.contents))}:ot={type:"dataTransferItem",id:Ue.options.contents._itemId}),qe.edits.push({oldResource:Ue.from,newResource:Ue.to,options:{...Ue.options,contents:ot},metadata:Ue.metadata})}else Ue._type===w.FileEditType.Text?qe.edits.push({resource:Ue.uri,textEdit:we.from(Ue.edit),versionId:Ze.has(Ue.uri)?void 0:ke?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===w.FileEditType.Snippet?qe.edits.push({resource:Ue.uri,textEdit:{range:A.from(Ue.range),text:Ue.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ue.uri)?void 0:ke?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===w.FileEditType.Cell?qe.edits.push({metadata:Ue.metadata,resource:Ue.uri,cellEdit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(Ue.uri)}):Ue._type===w.FileEditType.CellReplace&&qe.edits.push({metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:ke?.getNotebookDocumentVersion(Ue.uri),cellEdit:{editType:y.CellEditType.Replace,index:Ue.index,count:Ue.count,cells:Ue.cells.map(Xe.from)}})}return qe}me.from=De;function ce(K){const ke=new w.$pO,qe=new T.$Fc;for(const Ze of K.edits)if(Ze.textEdit){const Ue=Ze,ot=a.URI.revive(Ue.resource),gt=A.to(Ue.textEdit.range),Kt=Ue.textEdit.text,Vt=Ue.textEdit.insertAsSnippet;let qt;Vt?qt=w.$oO.replace(gt,new w.$qO(Kt)):qt=w.$mO.replace(gt,Kt);const Li=qe.get(ot);Li?Li.push(qt):qe.set(ot,[qt])}else ke.renameFile(a.URI.revive(Ze.oldResource),a.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ue]of qe)ke.set(Ze,Ue);return ke}me.to=ce})(Pe||(e.WorkspaceEdit=Pe={}));var Fe;(function(me){const De=Object.create(null);De[w.SymbolKind.File]=n.SymbolKind.File,De[w.SymbolKind.Module]=n.SymbolKind.Module,De[w.SymbolKind.Namespace]=n.SymbolKind.Namespace,De[w.SymbolKind.Package]=n.SymbolKind.Package,De[w.SymbolKind.Class]=n.SymbolKind.Class,De[w.SymbolKind.Method]=n.SymbolKind.Method,De[w.SymbolKind.Property]=n.SymbolKind.Property,De[w.SymbolKind.Field]=n.SymbolKind.Field,De[w.SymbolKind.Constructor]=n.SymbolKind.Constructor,De[w.SymbolKind.Enum]=n.SymbolKind.Enum,De[w.SymbolKind.Interface]=n.SymbolKind.Interface,De[w.SymbolKind.Function]=n.SymbolKind.Function,De[w.SymbolKind.Variable]=n.SymbolKind.Variable,De[w.SymbolKind.Constant]=n.SymbolKind.Constant,De[w.SymbolKind.String]=n.SymbolKind.String,De[w.SymbolKind.Number]=n.SymbolKind.Number,De[w.SymbolKind.Boolean]=n.SymbolKind.Boolean,De[w.SymbolKind.Array]=n.SymbolKind.Array,De[w.SymbolKind.Object]=n.SymbolKind.Object,De[w.SymbolKind.Key]=n.SymbolKind.Key,De[w.SymbolKind.Null]=n.SymbolKind.Null,De[w.SymbolKind.EnumMember]=n.SymbolKind.EnumMember,De[w.SymbolKind.Struct]=n.SymbolKind.Struct,De[w.SymbolKind.Event]=n.SymbolKind.Event,De[w.SymbolKind.Operator]=n.SymbolKind.Operator,De[w.SymbolKind.TypeParameter]=n.SymbolKind.TypeParameter;function ce(ke){return typeof De[ke]=="number"?De[ke]:n.SymbolKind.Property}me.from=ce;function K(ke){for(const qe in De)if(De[qe]===ke)return Number(qe);return w.SymbolKind.Property}me.to=K})(Fe||(e.SymbolKind=Fe={}));var Be;(function(me){function De(K){switch(K){case w.SymbolTag.Deprecated:return n.SymbolTag.Deprecated}}me.from=De;function ce(K){switch(K){case n.SymbolTag.Deprecated:return w.SymbolTag.Deprecated}}me.to=ce})(Be||(e.SymbolTag=Be={}));var xe;(function(me){function De(K){return{name:K.name,kind:Fe.from(K.kind),tags:K.tags&&K.tags.map(Be.from),containerName:K.containerName,location:et.from(K.location)}}me.from=De;function ce(K){const ke=new w.$yO(K.name,Fe.to(K.kind),K.containerName,et.to(K.location));return ke.tags=K.tags&&K.tags.map(Be.to),ke}me.to=ce})(xe||(e.WorkspaceSymbol=xe={}));var nt;(function(me){function De(K){const ke={name:K.name||"!!MISSING: name!!",detail:K.detail,range:A.from(K.range),selectionRange:A.from(K.selectionRange),kind:Fe.from(K.kind),tags:K.tags?.map(Be.from)??[]};return K.children&&(ke.children=K.children.map(De)),ke}me.from=De;function ce(K){const ke=new w.$zO(K.name,K.detail,Fe.to(K.kind),A.to(K.range),A.to(K.selectionRange));return(0,v.$Pb)(K.tags)&&(ke.tags=K.tags.map(Be.to)),K.children&&(ke.children=K.children.map(ce)),ke}me.to=ce})(nt||(e.DocumentSymbol=nt={}));var ht;(function(me){function De(K){const ke=new w.$DO(Fe.to(K.kind),K.name,K.detail||"",a.URI.revive(K.uri),A.to(K.range),A.to(K.selectionRange));return ke._sessionId=K._sessionId,ke._itemId=K._itemId,ke}me.to=De;function ce(K,ke,qe){if(ke=ke??K._sessionId,qe=qe??K._itemId,ke===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:qe,name:K.name,detail:K.detail,kind:Fe.from(K.kind),uri:K.uri,range:A.from(K.range),selectionRange:A.from(K.selectionRange),tags:K.tags?.map(Be.from)}}me.from=ce})(ht||(e.CallHierarchyItem=ht={}));var $t;(function(me){function De(ce){return new w.$EO(ht.to(ce.from),ce.fromRanges.map(K=>A.to(K)))}me.to=De})($t||(e.CallHierarchyIncomingCall=$t={}));var ut;(function(me){function De(ce){return new w.$FO(ht.to(ce.to),ce.fromRanges.map(K=>A.to(K)))}me.to=De})(ut||(e.CallHierarchyOutgoingCall=ut={}));var et;(function(me){function De(K){return{range:K.range&&A.from(K.range),uri:K.uri}}me.from=De;function ce(K){return new w.$rO(a.URI.revive(K.uri),A.to(K.range))}me.to=ce})(et||(e.location=et={}));var Le;(function(me){function De(K){const ke=K,qe=K;return{originSelectionRange:ke.originSelectionRange?A.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:qe.uri,range:A.from(ke.targetRange?ke.targetRange:qe.range),targetSelectionRange:ke.targetSelectionRange?A.from(ke.targetSelectionRange):void 0}}me.from=De;function ce(K){return{targetUri:a.URI.revive(K.uri),targetRange:A.to(K.range),targetSelectionRange:K.targetSelectionRange?A.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?A.to(K.originSelectionRange):void 0}}me.to=ce})(Le||(e.DefinitionLink=Le={}));var Ne;(function(me){function De(K){return{range:A.from(K.range),contents:ue.fromMany(K.contents),canIncreaseVerbosity:K.canIncreaseVerbosity,canDecreaseVerbosity:K.canDecreaseVerbosity}}me.from=De;function ce(K){const ke=K.contents.map(ue.to),qe=A.to(K.range),Ze=K.canIncreaseVerbosity,Ue=K.canDecreaseVerbosity;return new w.$vO(ke,qe,Ze,Ue)}me.to=ce})(Ne||(e.Hover=Ne={}));var Me;(function(me){function De(K){return{range:A.from(K.range),expression:K.expression}}me.from=De;function ce(K){return new w.$qP(A.to(K.range),K.expression)}me.to=ce})(Me||(e.EvaluatableExpression=Me={}));var q;(function(me){function De(K){if(K instanceof w.$rP)return{type:"text",range:A.from(K.range),text:K.text};if(K instanceof w.$sP)return{type:"variable",range:A.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof w.$tP)return{type:"expression",range:A.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}me.from=De;function ce(K){switch(K.type){case"text":return{range:A.to(K.range),text:K.text};case"variable":return{range:A.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:A.to(K.range),expression:K.expression}}}me.to=ce})(q||(e.InlineValue=q={}));var B;(function(me){function De(K){return{frameId:K.frameId,stoppedLocation:A.from(K.stoppedLocation)}}me.from=De;function ce(K){return new w.$uP(K.frameId,A.to(K.stoppedLocation))}me.to=ce})(B||(e.InlineValueContext=B={}));var H;(function(me){function De(K){return{range:A.from(K.range),kind:K.kind}}me.from=De;function ce(K){return new w.$wO(A.to(K.range),K.kind)}me.to=ce})(H||(e.DocumentHighlight=H={}));var Q;(function(me){function De(K){return{uri:K.uri,highlights:K.highlights.map(H.from)}}me.from=De;function ce(K){return new w.$xO(a.URI.revive(K.uri),K.highlights.map(H.to))}me.to=ce})(Q||(e.MultiDocumentHighlight=Q={}));var se;(function(me){function De(ce){switch(ce){case n.CompletionTriggerKind.TriggerCharacter:return w.CompletionTriggerKind.TriggerCharacter;case n.CompletionTriggerKind.TriggerForIncompleteCompletions:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case n.CompletionTriggerKind.Invoke:default:return w.CompletionTriggerKind.Invoke}}me.to=De})(se||(e.CompletionTriggerKind=se={}));var ge;(function(me){function De(ce){return{triggerKind:se.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}me.to=De})(ge||(e.CompletionContext=ge={}));var Ee;(function(me){function De(K){switch(K){case w.CompletionItemTag.Deprecated:return n.CompletionItemTag.Deprecated}}me.from=De;function ce(K){switch(K){case n.CompletionItemTag.Deprecated:return w.CompletionItemTag.Deprecated}}me.to=ce})(Ee||(e.CompletionItemTag=Ee={}));var ze;(function(me){const De=new Map([[w.CompletionItemKind.Method,n.CompletionItemKind.Method],[w.CompletionItemKind.Function,n.CompletionItemKind.Function],[w.CompletionItemKind.Constructor,n.CompletionItemKind.Constructor],[w.CompletionItemKind.Field,n.CompletionItemKind.Field],[w.CompletionItemKind.Variable,n.CompletionItemKind.Variable],[w.CompletionItemKind.Class,n.CompletionItemKind.Class],[w.CompletionItemKind.Interface,n.CompletionItemKind.Interface],[w.CompletionItemKind.Struct,n.CompletionItemKind.Struct],[w.CompletionItemKind.Module,n.CompletionItemKind.Module],[w.CompletionItemKind.Property,n.CompletionItemKind.Property],[w.CompletionItemKind.Unit,n.CompletionItemKind.Unit],[w.CompletionItemKind.Value,n.CompletionItemKind.Value],[w.CompletionItemKind.Constant,n.CompletionItemKind.Constant],[w.CompletionItemKind.Enum,n.CompletionItemKind.Enum],[w.CompletionItemKind.EnumMember,n.CompletionItemKind.EnumMember],[w.CompletionItemKind.Keyword,n.CompletionItemKind.Keyword],[w.CompletionItemKind.Snippet,n.CompletionItemKind.Snippet],[w.CompletionItemKind.Text,n.CompletionItemKind.Text],[w.CompletionItemKind.Color,n.CompletionItemKind.Color],[w.CompletionItemKind.File,n.CompletionItemKind.File],[w.CompletionItemKind.Reference,n.CompletionItemKind.Reference],[w.CompletionItemKind.Folder,n.CompletionItemKind.Folder],[w.CompletionItemKind.Event,n.CompletionItemKind.Event],[w.CompletionItemKind.Operator,n.CompletionItemKind.Operator],[w.CompletionItemKind.TypeParameter,n.CompletionItemKind.TypeParameter],[w.CompletionItemKind.Issue,n.CompletionItemKind.Issue],[w.CompletionItemKind.User,n.CompletionItemKind.User]]);function ce(qe){return De.get(qe)??n.CompletionItemKind.Property}me.from=ce;const K=new Map([[n.CompletionItemKind.Method,w.CompletionItemKind.Method],[n.CompletionItemKind.Function,w.CompletionItemKind.Function],[n.CompletionItemKind.Constructor,w.CompletionItemKind.Constructor],[n.CompletionItemKind.Field,w.CompletionItemKind.Field],[n.CompletionItemKind.Variable,w.CompletionItemKind.Variable],[n.CompletionItemKind.Class,w.CompletionItemKind.Class],[n.CompletionItemKind.Interface,w.CompletionItemKind.Interface],[n.CompletionItemKind.Struct,w.CompletionItemKind.Struct],[n.CompletionItemKind.Module,w.CompletionItemKind.Module],[n.CompletionItemKind.Property,w.CompletionItemKind.Property],[n.CompletionItemKind.Unit,w.CompletionItemKind.Unit],[n.CompletionItemKind.Value,w.CompletionItemKind.Value],[n.CompletionItemKind.Constant,w.CompletionItemKind.Constant],[n.CompletionItemKind.Enum,w.CompletionItemKind.Enum],[n.CompletionItemKind.EnumMember,w.CompletionItemKind.EnumMember],[n.CompletionItemKind.Keyword,w.CompletionItemKind.Keyword],[n.CompletionItemKind.Snippet,w.CompletionItemKind.Snippet],[n.CompletionItemKind.Text,w.CompletionItemKind.Text],[n.CompletionItemKind.Color,w.CompletionItemKind.Color],[n.CompletionItemKind.File,w.CompletionItemKind.File],[n.CompletionItemKind.Reference,w.CompletionItemKind.Reference],[n.CompletionItemKind.Folder,w.CompletionItemKind.Folder],[n.CompletionItemKind.Event,w.CompletionItemKind.Event],[n.CompletionItemKind.Operator,w.CompletionItemKind.Operator],[n.CompletionItemKind.TypeParameter,w.CompletionItemKind.TypeParameter],[n.CompletionItemKind.User,w.CompletionItemKind.User],[n.CompletionItemKind.Issue,w.CompletionItemKind.Issue]]);function ke(qe){return K.get(qe)??w.CompletionItemKind.Property}me.to=ke})(ze||(e.CompletionItemKind=ze={}));var Je;(function(me){function De(ce,K){const ke=new w.$NO(ce.label);return ke.insertText=ce.insertText,ke.kind=ze.to(ce.kind),ke.tags=ce.tags?.map(Ee.to),ke.detail=ce.detail,ke.documentation=R.$$k(ce.documentation)?ue.to(ce.documentation):ce.documentation,ke.sortText=ce.sortText,ke.filterText=ce.filterText,ke.preselect=ce.preselect,ke.commitCharacters=ce.commitCharacters,c.$Yt.isIRange(ce.range)?ke.range=A.to(ce.range):typeof ce.range=="object"&&(ke.range={inserting:A.to(ce.range.insert),replacing:A.to(ce.range.replace)}),ke.keepWhitespace=typeof ce.insertTextRules>"u"?!1:!!(ce.insertTextRules&n.CompletionItemInsertTextRule.KeepWhitespace),typeof ce.insertTextRules<"u"&&ce.insertTextRules&n.CompletionItemInsertTextRule.InsertAsSnippet?ke.insertText=new w.$qO(ce.insertText):(ke.insertText=ce.insertText,ke.textEdit=ke.range instanceof w.$fO?new w.$mO(ke.range,ke.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(ke.additionalTextEdits=ce.additionalTextEdits.map(qe=>we.to(qe))),ke.command=K&&ce.command?K.fromInternal(ce.command):void 0,ke}me.to=De})(Je||(e.CompletionItem=Je={}));var _e;(function(me){function De(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:ue.fromStrict(K.documentation)}}me.from=De;function ce(K){return{label:K.label,documentation:R.$$k(K.documentation)?ue.to(K.documentation):K.documentation}}me.to=ce})(_e||(e.ParameterInformation=_e={}));var tt;(function(me){function De(K){return{label:K.label,documentation:ue.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(_e.from):[],activeParameter:K.activeParameter}}me.from=De;function ce(K){return{label:K.label,documentation:R.$$k(K.documentation)?ue.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(_e.to):[],activeParameter:K.activeParameter}}me.to=ce})(tt||(e.SignatureInformation=tt={}));var ct;(function(me){function De(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(tt.from):[]}}me.from=De;function ce(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(tt.to):[]}}me.to=ce})(ct||(e.SignatureHelp=ct={}));var it;(function(me){function De(ce,K){const ke=new w.$MO(x.to(K.position),typeof K.label=="string"?K.label:K.label.map(at.to.bind(void 0,ce)),K.kind&&yt.to(K.kind));return ke.textEdits=K.textEdits&&K.textEdits.map(we.to),ke.tooltip=R.$$k(K.tooltip)?ue.to(K.tooltip):K.tooltip,ke.paddingLeft=K.paddingLeft,ke.paddingRight=K.paddingRight,ke}me.to=De})(it||(e.InlayHint=it={}));var at;(function(me){function De(ce,K){const ke=new w.$LO(K.label);return ke.tooltip=R.$$k(K.tooltip)?ue.to(K.tooltip):K.tooltip,n.Command.is(K.command)&&(ke.command=ce.fromInternal(K.command)),K.location&&(ke.location=et.to(K.location)),ke}me.to=De})(at||(e.InlayHintLabelPart=at={}));var yt;(function(me){function De(K){return K}me.from=De;function ce(K){return K}me.to=ce})(yt||(e.InlayHintKind=yt={}));var Ye;(function(me){function De(K){return{range:A.from(K.range),url:K.target,tooltip:K.tooltip}}me.from=De;function ce(K){let ke;if(K.url)try{ke=typeof K.url=="string"?a.URI.parse(K.url,!0):a.URI.revive(K.url)}catch{}const qe=new w.$SO(A.to(K.range),ke);return qe.tooltip=K.tooltip,qe}me.to=ce})(Ye||(e.DocumentLink=Ye={}));var he;(function(me){function De(K){const ke=new w.$VO(K.label);return K.textEdit&&(ke.textEdit=we.to(K.textEdit)),K.additionalTextEdits&&(ke.additionalTextEdits=K.additionalTextEdits.map(qe=>we.to(qe))),ke}me.to=De;function ce(K){return{label:K.label,textEdit:K.textEdit?we.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(ke=>we.from(ke)):void 0}}me.from=ce})(he||(e.ColorPresentation=he={}));var pe;(function(me){function De(K){return new w.$TO(K[0],K[1],K[2],K[3])}me.to=De;function ce(K){return[K.red,K.green,K.blue,K.alpha]}me.from=ce})(pe||(e.Color=pe={}));var ye;(function(me){function De(K){return{range:A.from(K.range)}}me.from=De;function ce(K){return new w.$CO(A.to(K.range))}me.to=ce})(ye||(e.SelectionRange=ye={}));var Ce;(function(me){function De(ce){switch(ce){case f.SaveReason.AUTO:return w.TextDocumentSaveReason.AfterDelay;case f.SaveReason.EXPLICIT:return w.TextDocumentSaveReason.Manual;case f.SaveReason.FOCUS_CHANGE:case f.SaveReason.WINDOW_CHANGE:return w.TextDocumentSaveReason.FocusOut}}me.to=De})(Ce||(e.TextDocumentSaveReason=Ce={}));var fe;(function(me){function De(K){switch(K){case w.TextEditorLineNumbersStyle.Off:return h.RenderLineNumbersType.Off;case w.TextEditorLineNumbersStyle.Relative:return h.RenderLineNumbersType.Relative;case w.TextEditorLineNumbersStyle.Interval:return h.RenderLineNumbersType.Interval;case w.TextEditorLineNumbersStyle.On:default:return h.RenderLineNumbersType.On}}me.from=De;function ce(K){switch(K){case h.RenderLineNumbersType.Off:return w.TextEditorLineNumbersStyle.Off;case h.RenderLineNumbersType.Relative:return w.TextEditorLineNumbersStyle.Relative;case h.RenderLineNumbersType.Interval:return w.TextEditorLineNumbersStyle.Interval;case h.RenderLineNumbersType.On:default:return w.TextEditorLineNumbersStyle.On}}me.to=ce})(fe||(e.TextEditorLineNumbersStyle=fe={}));var ve;(function(me){function De(K){if(K===w.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(K===w.EndOfLine.LF)return t.EndOfLineSequence.LF}me.from=De;function ce(K){if(K===t.EndOfLineSequence.CRLF)return w.EndOfLine.CRLF;if(K===t.EndOfLineSequence.LF)return w.EndOfLine.LF}me.to=ce})(ve||(e.EndOfLine=ve={}));var Y;(function(me){function De(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case w.ProgressLocation.SourceControl:return l.ProgressLocation.Scm;case w.ProgressLocation.Window:return l.ProgressLocation.Window;case w.ProgressLocation.Notification:return l.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}me.from=De})(Y||(e.ProgressLocation=Y={}));var W;(function(me){function De(K){const ke={start:K.start+1,end:K.end+1};return K.kind&&(ke.kind=de.from(K.kind)),ke}me.from=De;function ce(K){const ke={start:K.start-1,end:K.end-1};return K.kind&&(ke.kind=de.to(K.kind)),ke}me.to=ce})(W||(e.FoldingRange=W={}));var de;(function(me){function De(K){if(K)switch(K){case w.FoldingRangeKind.Comment:return n.$Zu.Comment;case w.FoldingRangeKind.Imports:return n.$Zu.Imports;case w.FoldingRangeKind.Region:return n.$Zu.Region}}me.from=De;function ce(K){if(K)switch(K.value){case n.$Zu.Comment.value:return w.FoldingRangeKind.Comment;case n.$Zu.Imports.value:return w.FoldingRangeKind.Imports;case n.$Zu.Region.value:return w.FoldingRangeKind.Region}}me.to=ce})(de||(e.FoldingRangeKind=de={}));var je;(function(me){function De(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?A.from(ce.selection):void 0,override:typeof ce.override=="boolean"?f.$lG.id:void 0}}me.from=De})(je||(e.TextEditorOpenOptions=je={}));var He;(function(me){function De(qe){return qe instanceof w.$eP?qe.toJSON():typeof qe=="string"?qe:ce(qe)||K(qe)?new w.$eP(qe.baseUri??qe.base,qe.pattern).toJSON():qe}me.from=De;function ce(qe){const Ze=qe;return Ze?a.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function K(qe){const Ze=qe;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function ke(qe){return typeof qe=="string"?qe:new w.$eP(a.URI.revive(qe.baseUri),qe.pattern)}me.to=ke})(He||(e.GlobPattern=He={}));var st;(function(me){function De(ce){if(ce){if(Array.isArray(ce))return ce.map(De);if(typeof ce=="string")return ce;{const K=ce;return{language:K.language,scheme:K.scheme,pattern:He.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}me.from=De})(st||(e.LanguageSelector=st={}));var dt;(function(me){function De(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(ke=>Array.isArray(ke)&&ke.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&a.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(Ze=>Ze instanceof w.$fO)))}me.is=De;function ce(K){return{documents:K.documents.map(ke=>ke.map(qe=>({uri:a.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(Ze=>A.from(Ze))})))}}me.from=ce})(dt||(e.MappedEditsContext=dt={}));var mt;(function(me){function De(K){return{start:K.start,end:K.end}}me.from=De;function ce(K){return new w.$HP(K.start,K.end)}me.to=ce})(mt||(e.NotebookRange=mt={}));var Ot;(function(me){function De(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}me.to=De;function ce(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}me.from=ce})(Ot||(e.NotebookCellExecutionSummary=Ot={}));var Tt;(function(me){function De(ce){if(ce===y.NotebookCellExecutionState.Unconfirmed)return w.NotebookCellExecutionState.Pending;if(ce===y.NotebookCellExecutionState.Pending)return;if(ce===y.NotebookCellExecutionState.Executing)return w.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ce}`)}me.to=De})(Tt||(e.NotebookCellExecutionState=Tt={}));var Ht;(function(me){function De(K){switch(K){case w.NotebookCellKind.Markup:return y.CellKind.Markup;case w.NotebookCellKind.Code:default:return y.CellKind.Code}}me.from=De;function ce(K){switch(K){case y.CellKind.Markup:return w.NotebookCellKind.Markup;case y.CellKind.Code:default:return w.NotebookCellKind.Code}}me.to=ce})(Ht||(e.NotebookCellKind=Ht={}));var _t;(function(me){function De(K){const ke={metadata:K.metadata??Object.create(null),cells:[]};for(const qe of K.cells)w.$IP.validate(qe),ke.cells.push(Xe.from(qe));return ke}me.from=De;function ce(K){const ke=new w.$JP(K.cells.map(Xe.to));return(0,r.$wg)(K.metadata)||(ke.metadata=K.metadata),ke}me.to=ce})(_t||(e.NotebookData=_t={}));var Xe;(function(me){function De(K){return{cellKind:Ht.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ot.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Ut.from):[]}}me.from=De;function ce(K){return new w.$IP(Ht.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Ut.to):void 0,K.metadata,K.internalMetadata?Ot.to(K.internalMetadata):void 0)}me.to=ce})(Xe||(e.NotebookCellData=Xe={}));var At;(function(me){function De(K){return{mime:K.mime,valueBytes:D.$Se.wrap(K.data)}}me.from=De;function ce(K){return new w.$KP(K.valueBytes.buffer,K.mime)}me.to=ce})(At||(e.NotebookCellOutputItem=At={}));var Ut;(function(me){function De(K){return{outputId:K.id,items:K.items.map(At.from),metadata:K.metadata}}me.from=De;function ce(K){const ke=K.items.map(At.to);return new w.$LP(ke,K.outputId,K.metadata)}me.to=ce})(Ut||(e.NotebookCellOutput=Ut={}));var bt;(function(me){function De(ke){return K(ke)?{include:He.from(ke.include)??void 0,exclude:He.from(ke.exclude)??void 0}:He.from(ke)??void 0}me.from=De;function ce(ke){return K(ke)?{include:He.to(ke.include),exclude:He.to(ke.exclude)}:He.to(ke)}me.to=ce;function K(ke){const qe=ke;return qe?!(0,r.$sg)(qe.include)&&!(0,r.$sg)(qe.exclude):!1}})(bt||(e.NotebookExclusiveDocumentPattern=bt={}));var Dt;(function(me){function De(ce,K,ke){const qe=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===w.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:K.toInternal(qe,ke),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}me.from=De})(Dt||(e.NotebookStatusBarItem=Dt={}));var ei;(function(me){function De(ce,K,ke){const qe=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{command:K.toInternal(qe,ke),label:ce.label,description:ce.description,detail:ce.detail,documentation:ce.documentation}}me.from=De})(ei||(e.NotebookKernelSourceAction=ei={}));var ti;(function(me){function De(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{},cellContentMetadata:ce?.cellContentMetadata??{}}}me.from=De})(ti||(e.NotebookDocumentContentOptions=ti={}));var Qt;(function(me){function De(K){return{uri:K.uri,provides:K.provides}}me.from=De;function ce(K){return new w.$NP(a.URI.revive(K.uri),K.provides)}me.to=ce})(Qt||(e.NotebookRendererScript=Qt={}));var wt;(function(me){function De(K){return{message:ue.fromStrict(K.message)||"",type:O.TestMessageType.Error,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:A.from(K.location.range),uri:K.location.uri},stackTrace:K.stackTrace?.map(ke=>({label:ke.label,position:ke.position&&x.from(ke.position),uri:ke.uri&&a.URI.revive(ke.uri).toJSON()}))}}me.from=De;function ce(K){const ke=new w.$TP(typeof K.message=="string"?K.message:ue.to(K.message));return ke.actualOutput=K.actual,ke.expectedOutput=K.expected,ke.contextValue=K.contextValue,ke.location=K.location?et.to(K.location):void 0,ke}me.to=ce})(wt||(e.TestMessage=wt={}));var Lt;(function(me){me.namespace=O.$yJ,me.denamespace=O.$zJ})(Lt||(e.TestTag=Lt={}));var ci;(function(me){function De(K){const ke=(0,g.$KQ)(K).controllerId;return{extId:C.$tJ.fromExtHostTestItem(K,ke).toString(),label:K.label,uri:a.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(qe=>Lt.namespace(ke,qe.id)),range:c.$Yt.lift(A.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&ue.fromStrict(K.error)||null}}me.from=De;function ce(K){return{parent:void 0,error:void 0,id:C.$tJ.fromString(K.extId).localId,label:K.label,uri:a.URI.revive(K.uri),tags:(K.tags||[]).map(ke=>{const{tagId:qe}=Lt.denamespace(ke);return new w.$UP(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:A.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}me.toPlain=ce})(ci||(e.TestItem=ci={})),function(me){function De(K){return{id:K.id}}me.from=De;function ce(K){return new w.$UP(K.id)}me.to=ce}(Lt||(e.TestTag=Lt={}));var Yt;(function(me){const De=(K,ke)=>{const qe=K.value;if(!qe)return;const Ze={...ci.toPlain(qe.item),parent:ke,taskStates:qe.tasks.map(Ue=>({state:Ue.state,duration:Ue.duration,messages:Ue.messages.filter(ot=>ot.type===O.TestMessageType.Error).map(wt.to)})),children:[]};if(K.children)for(const Ue of K.children.values()){const ot=De(Ue,Ze);ot&&Ze.children.push(ot)}return Ze};function ce(K){const ke=new u.$sJ;for(const Ue of K.items)ke.insert(C.$tJ.fromString(Ue.item.extId).path,Ue);const qe=[ke.nodes],Ze=[];for(;qe.length;)for(const Ue of qe.pop())Ue.value?Ze.push(Ue):Ue.children&&qe.push(Ue.children.values());return{completedAt:K.completedAt,results:Ze.map(Ue=>De(Ue)).filter(r.$rg)}}me.to=ce})(Yt||(e.TestResults=Yt={}));var Ge;(function(me){function De(Ue){return{covered:Ue.covered,total:Ue.total}}function ce(Ue){return"line"in Ue?x.from(Ue):A.from(Ue)}function K(Ue){if(Ue)return"endLineNumber"in Ue?A.to(Ue):x.to(Ue)}function ke(Ue){if(Ue.type===O.DetailType.Statement){const ot=[];if(Ue.branches)for(const gt of Ue.branches)ot.push({executed:gt.count,location:K(gt.location),label:gt.label});return new w.$ZP(Ue.count,K(Ue.location),Ue.branches?.map(gt=>new w.$1P(gt.count,K(gt.location),gt.label)))}else return new w.$2P(Ue.name,Ue.count,K(Ue.location))}me.to=ke;function qe(Ue){if(typeof Ue.executed=="number"&&Ue.executed<0)throw new Error(`Invalid coverage count ${Ue.executed}`);return"branches"in Ue?{count:Ue.executed,location:ce(Ue.location),type:O.DetailType.Statement,branches:Ue.branches.length?Ue.branches.map(ot=>({count:ot.executed,location:ot.location&&ce(ot.location),label:ot.label})):void 0}:{type:O.DetailType.Declaration,name:Ue.name,count:Ue.executed,location:ce(Ue.location)}}me.fromDetails=qe;function Ze(Ue,ot,gt){return w.$XP(gt.statementCoverage),w.$XP(gt.branchCoverage),w.$XP(gt.declarationCoverage),{id:ot,uri:gt.uri,statement:De(gt.statementCoverage),branch:gt.branchCoverage&&De(gt.branchCoverage),declaration:gt.declarationCoverage&&De(gt.declarationCoverage),testIds:gt instanceof w.$YP&&gt.fromTests.length?gt.fromTests.map(Kt=>C.$tJ.fromExtHostTestItem(Kt,Ue).toString()):void 0}}me.fromFile=Ze})(Ge||(e.TestCoverage=Ge={}));var ii;(function(me){function De(ce){switch(ce){case n.CodeActionTriggerType.Invoke:return w.CodeActionTriggerKind.Invoke;case n.CodeActionTriggerType.Auto:return w.CodeActionTriggerKind.Automatic}}me.to=De})(ii||(e.CodeActionTriggerKind=ii={}));var li;(function(me){function De(K){const ke=new w.$3P(Fe.to(K.kind),K.name,K.detail||"",a.URI.revive(K.uri),A.to(K.range),A.to(K.selectionRange));return ke._sessionId=K._sessionId,ke._itemId=K._itemId,ke}me.to=De;function ce(K,ke,qe){if(ke=ke??K._sessionId,qe=qe??K._itemId,ke===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:qe,kind:Fe.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:A.from(K.range),selectionRange:A.from(K.selectionRange),tags:K.tags?.map(Be.from)}}me.from=ce})(li||(e.TypeHierarchyItem=li={}));var hi;(function(me){function De(ce){if(ce)return{value:ce.value,tooltip:ce.tooltip}}me.from=De})(hi||(e.ViewBadge=hi={}));var kt;(function(me){function De(qe,Ze,Ue){const ot=Ze.fileData;return ot?new w.$9O(new w.$0O(ot.name,a.URI.revive(ot.uri),ot.id,(0,L.$hb)(()=>Ue(ot.id)))):qe===I.$it.uriList&&Ze.uriListData?new w.$8O(ke(Ze.uriListData)):new w.$8O(Ze.asString)}me.to=De;async function ce(qe,Ze){const Ue=await Ze.asString();if(qe===I.$it.uriList)return{asString:Ue,fileData:void 0,uriListData:K(Ue)};const ot=Ze.asFile();return{asString:Ue,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}me.from=ce;function K(qe){return P.$Du.split(qe).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return a.URI.parse(Ze)}catch{}return Ze})}function ke(qe){return P.$Du.create(qe.map(Ze=>typeof Ze=="string"?Ze:a.URI.revive(Ze)))}})(kt||(e.DataTransferItem=kt={}));var jt;(function(me){function De(K,ke){const qe=K.items.map(([Ze,Ue])=>[Ze,kt.to(Ze,Ue,ke)]);return new w.$$O(qe)}me.toDataTransfer=De;async function ce(K){const ke={items:[]},qe=[];for(const[Ze,Ue]of K)qe.push((async()=>{ke.items.push([Ze,await kt.from(Ze,Ue)])})());return await Promise.all(qe),ke}me.from=ce})(jt||(e.DataTransfer=jt={}));var Mt;(function(me){function De(K,ke){return{kind:"reply",agentId:K.participant??ke?.agentId??"",subCommand:K.command??ke?.command,message:K.prompt,title:K.label}}me.from=De;function ce(K){return{prompt:K.message,label:K.title,participant:K.agentId,command:K.subCommand}}me.to=ce})(Mt||(e.ChatFollowup=Mt={}));var Bt;(function(me){function De(K){switch(K){case S.ChatMessageRole.System:return w.LanguageModelChatMessageRole.System;case S.ChatMessageRole.User:return w.LanguageModelChatMessageRole.User;case S.ChatMessageRole.Assistant:return w.LanguageModelChatMessageRole.Assistant}}me.to=De;function ce(K){switch(K){case w.LanguageModelChatMessageRole.System:return S.ChatMessageRole.System;case w.LanguageModelChatMessageRole.User:return S.ChatMessageRole.User;case w.LanguageModelChatMessageRole.Assistant:return S.ChatMessageRole.Assistant}return S.ChatMessageRole.User}me.from=ce})(Bt||(e.LanguageModelChatMessageRole=Bt={}));var ai;(function(me){function De(K){const ke=K.content.map(ot=>ot.type==="text"?ot.value:ot.type==="tool_result"?new w.$vQ(ot.toolCallId,ot.value,ot.isError):new w.$xQ(ot.name,ot.toolCallId,ot.parameters)),qe=ke.find(ot=>typeof ot=="string")??"",Ze=Bt.to(K.role),Ue=new w.$wQ(Ze,qe,K.name);return Ue.content2=ke,Ue}me.to=De;function ce(K){const ke=Bt.from(K.role),qe=K.name,Ze=K.content2.map(Ue=>{if(Ue instanceof w.$vQ)return{type:"tool_result",toolCallId:Ue.toolCallId,value:Ue.content,isError:Ue.isError};if(Ue instanceof w.$xQ)return{type:"tool_use",toolCallId:Ue.toolCallId,name:Ue.name,parameters:Ue.parameters};if(typeof Ue!="string")throw new Error("Unexpected chat message content type");return{type:"text",value:Ue}});return{role:ke,name:qe,content:Ze}}me.from=ce})(ai||(e.LanguageModelChatMessage=ai={}));var ni;(function(me){function De(K){return{kind:"markdownContent",content:ue.from(K.value)}}me.from=De;function ce(K){return new w.$dQ(ue.to(K.content))}me.to=ce})(ni||(e.ChatResponseMarkdownPart=ni={}));var ri;(function(me){function De(K){return{kind:"markdownVuln",content:ue.from(K.value),vulnerabilities:K.vulnerabilities}}me.from=De;function ce(K){return new w.$eQ(ue.to(K.content),K.vulnerabilities)}me.to=ce})(ri||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ri={}));var Gt;(function(me){function De(K){return{kind:"agentDetection",agentId:K.participant,command:K.command}}me.from=De;function ce(K){return new w.$fQ(K.agentId,K.command)}me.to=ce})(Gt||(e.ChatResponseDetectedParticipantPart=Gt={}));var Jt;(function(me){function De(ce){return{kind:"confirmation",title:ce.title,message:ce.message,data:ce.data,buttons:ce.buttons}}me.from=De})(Jt||(e.ChatResponseConfirmationPart=Jt={}));var ui;(function(me){function De(K){const{value:ke,baseUri:qe}=K;function Ze(Ue,ot){return Ue.map(gt=>{const Kt=a.URI.joinPath(ot,gt.name);return{label:gt.name,uri:Kt,children:gt.children&&Ze(gt.children,Kt)}})}return{kind:"treeData",treeData:{label:(0,k.$ih)(qe),uri:qe,children:Ze(ke,qe)}}}me.from=De;function ce(K){const ke=(0,s.$hi)(K.treeData);function qe(ot){return ot.map(gt=>({name:gt.label,children:gt.children&&qe(gt.children)}))}const Ze=ke.uri,Ue=ke.children?qe(ke.children):[];return new w.$hQ(Ue,Ze)}me.to=ce})(ui||(e.ChatResponseFilesPart=ui={}));var Nt;(function(me){function De(K){const ke=qe=>a.URI.isUri(qe);return{kind:"inlineReference",name:K.title,inlineReference:ke(K.value)?K.value:F.from(K.value)}}me.from=De;function ce(K){const ke=(0,s.$hi)(K);return new w.$iQ(a.URI.isUri(ke.inlineReference)?ke.inlineReference:F.to(ke.inlineReference),K.name)}me.to=ce})(Nt||(e.ChatResponseAnchorPart=Nt={}));var Ct;(function(me){function De(K){return{kind:"progressMessage",content:ue.from(K.value)}}me.from=De;function ce(K){return new w.$jQ(K.content.value)}me.to=ce})(Ct||(e.ChatResponseProgressPart=Ct={}));var vt;(function(me){function De(K){return{kind:"warning",content:ue.from(K.value)}}me.from=De;function ce(K){return new w.$lQ(K.content.value)}me.to=ce})(vt||(e.ChatResponseWarningPart=vt={}));var Xt;(function(me){function De(K){return{kind:"move",uri:K.uri,range:A.from(K.range)}}me.from=De;function ce(K){return new w.$pQ(a.URI.revive(K.uri),A.to(K.range))}me.to=ce})(Xt||(e.ChatResponseMovePart=Xt={}));var Et;(function(me){function De(ce){return{kind:"progressTask",content:ue.from(ce.value)}}me.from=De})(Et||(e.ChatTask=Et={}));var si;(function(me){function De(ce){return{kind:"progressTaskResult",content:typeof ce=="string"?ue.from(ce):void 0}}me.from=De})(si||(e.ChatTaskResult=si={}));var Zt;(function(me){function De(K,ke,qe){return{kind:"command",command:ke.toInternal(K.value,qe)??{command:K.value.command,title:K.value.title}}}me.from=De;function ce(K,ke){return new w.$mQ(ke.fromInternal(K.command)??{command:K.command.id,title:K.command.title})}me.to=ce})(Zt||(e.ChatResponseCommandButtonPart=Zt={}));var Ni;(function(me){function De(K){return{kind:"textEdit",uri:K.uri,edits:K.edits.map(ke=>we.from(ke))}}me.from=De;function ce(K){return new w.$qQ(a.URI.revive(K.uri),K.edits.map(ke=>we.to(ke)))}me.to=ce})(Ni||(e.ChatResponseTextEditPart=Ni={}));var di;(function(me){function De(K){const ke=$.ThemeIcon.isThemeIcon(K.iconPath)?K.iconPath:a.URI.isUri(K.iconPath)?{light:a.URI.revive(K.iconPath)}:K.iconPath&&"light"in K.iconPath&&"dark"in K.iconPath&&a.URI.isUri(K.iconPath.light)&&a.URI.isUri(K.iconPath.dark)?{light:a.URI.revive(K.iconPath.light),dark:a.URI.revive(K.iconPath.dark)}:void 0;return typeof K.value=="object"&&"variableName"in K.value?{kind:"reference",reference:{variableName:K.value.variableName,value:a.URI.isUri(K.value.value)||!K.value.value?K.value.value:F.from(K.value.value)},iconPath:ke,options:K.options}:{kind:"reference",reference:a.URI.isUri(K.value)||typeof K.value=="string"?K.value:F.from(K.value),iconPath:ke,options:K.options}}me.from=De;function ce(K){const ke=(0,s.$hi)(K),qe=Ze=>a.URI.isUri(Ze)?Ze:F.to(Ze);return new w.$nQ(typeof ke.reference=="string"?ke.reference:"variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&qe(ke.reference.value)}:qe(ke.reference))}me.to=ce})(di||(e.ChatResponseReferencePart=di={}));var yi;(function(me){function De(ce){return{kind:"codeCitation",value:ce.value,license:ce.license,snippet:ce.snippet}}me.from=De})(yi||(e.ChatResponseCodeCitationPart=yi={}));var Wt;(function(me){function De(ke,qe,Ze){return ke instanceof w.$dQ?ni.from(ke):ke instanceof w.$iQ?Nt.from(ke):ke instanceof w.$nQ?di.from(ke):ke instanceof w.$jQ?Ct.from(ke):ke instanceof w.$hQ?ui.from(ke):ke instanceof w.$mQ?Zt.from(ke,qe,Ze):ke instanceof w.$qQ?Ni.from(ke):ke instanceof w.$eQ?ri.from(ke):ke instanceof w.$fQ?Gt.from(ke):ke instanceof w.$lQ?vt.from(ke):ke instanceof w.$gQ?Jt.from(ke):ke instanceof w.$oQ?yi.from(ke):ke instanceof w.$pQ?Xt.from(ke):{kind:"markdownContent",content:ue.from("")}}me.from=De;function ce(ke,qe){switch(ke.kind){case"reference":return di.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return K(ke,qe)}}me.to=ce;function K(ke,qe){switch(ke.kind){case"markdownContent":return ni.to(ke);case"inlineReference":return Nt.to(ke);case"progressMessage":return;case"treeData":return ui.to(ke);case"command":return Zt.to(ke,qe)}}me.toContent=K})(Wt||(e.ChatResponsePart=Wt={}));var fi;(function(me){function De(ce,K){const ke=ce.variables.variables.filter(Ze=>Ze.isTool),qe=ce.variables.variables.filter(Ze=>!Ze.isTool);return{prompt:ce.message,command:ce.command,attempt:ce.attempt??0,enableCommandDetection:ce.enableCommandDetection??!0,isParticipantDetected:ce.isParticipantDetected??!1,references:qe.map(Rt.to),toolReferences:ke.map(Si.to),location:Fi.to(ce.location),acceptedConfirmationData:ce.acceptedConfirmationData,rejectedConfirmationData:ce.rejectedConfirmationData,location2:K}}me.to=De})(fi||(e.ChatAgentRequest=fi={}));var Fi;(function(me){function De(K){switch(K){case d.ChatAgentLocation.Notebook:return w.ChatLocation.Notebook;case d.ChatAgentLocation.Terminal:return w.ChatLocation.Terminal;case d.ChatAgentLocation.Panel:return w.ChatLocation.Panel;case d.ChatAgentLocation.Editor:return w.ChatLocation.Editor}}me.to=De;function ce(K){switch(K){case w.ChatLocation.Notebook:return d.ChatAgentLocation.Notebook;case w.ChatLocation.Terminal:return d.ChatAgentLocation.Terminal;case w.ChatLocation.Panel:return d.ChatAgentLocation.Panel;case w.ChatLocation.Editor:return d.ChatAgentLocation.Editor}}me.from=ce})(Fi||(e.ChatLocation=Fi={}));var Rt;(function(me){function De(ce){const K=ce.value;if(!K)throw new Error("Invalid value reference");return{id:ce.id,name:ce.name,range:ce.range&&[ce.range.start,ce.range.endExclusive],value:(0,a.$Ac)(K)?a.URI.revive(K):K&&typeof K=="object"&&"uri"in K&&"range"in K&&(0,a.$Ac)(K.uri)?F.to((0,s.$hi)(K)):K,modelDescription:ce.modelDescription}}me.to=De})(Rt||(e.ChatPromptReference=Rt={}));var Si;(function(me){function De(ce){if(ce.value)throw new Error("Invalid tool reference");return{id:ce.id,range:ce.range&&[ce.range.start,ce.range.endExclusive]}}me.to=De})(Si||(e.ChatLanguageModelToolReference=Si={}));var Ai;(function(me){function De(ce,K,ke){return{id:ce.id,label:ce.label,fullName:ce.fullName,icon:ce.icon?.id,value:ce.values[0].value,insertText:ce.insertText,detail:ce.detail,documentation:ce.documentation,command:K.toInternal(ce.command,ke)}}me.from=De})(Ai||(e.ChatAgentCompletionItem=Ai={}));var gi;(function(me){function De(ce){return{errorDetails:ce.errorDetails,metadata:ce.metadata,nextQuestion:ce.nextQuestion}}me.to=De})(gi||(e.ChatAgentResult=gi={}));var zi;(function(me){function De(ce,K,ke){if(K.action.kind==="vote")return;const qe=gi.to(ce);if(K.action.kind==="command"){const Ze=K.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ke.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:qe}}else return K.action.kind==="followUp"?{action:{kind:"followUp",followup:Mt.to(K.action.followup)},result:qe}:K.action.kind==="inlineChat"?{action:{kind:"editor",accepted:K.action.action==="accepted"},result:qe}:{action:K.action,result:qe}}me.to=De})(zi||(e.ChatAgentUserActionEvent=zi={}));var ji;(function(me){function De(K){return{...K,string:K.toString()}}me.from=De;function ce(K){const ke={...K,toString:()=>K.string};return delete ke.string,ke}me.to=ce})(ji||(e.LanguageModelToolResult=ji={}));var zt;(function(me){function De(ce,K,ke){return"terminalCommand"in ce?{terminalCommand:ce.terminalCommand,shouldExecute:ce.shouldExecute}:"uri"in ce?{uri:ce.uri}:K.toInternal(ce,ke)}me.from=De})(zt||(e.TerminalQuickFix=zt={}));var Pi;(function(me){function De(ce){return{kind:Di.to(ce.kind)}}me.to=De})(Pi||(e.PartialAcceptInfo=Pi={}));var Di;(function(me){function De(ce){switch(ce){case n.PartialAcceptTriggerKind.Word:return w.PartialAcceptTriggerKind.Word;case n.PartialAcceptTriggerKind.Line:return w.PartialAcceptTriggerKind.Line;case n.PartialAcceptTriggerKind.Suggest:return w.PartialAcceptTriggerKind.Suggest;default:return w.PartialAcceptTriggerKind.Unknown}}me.to=De})(Di||(e.PartialAcceptTriggerKind=Di={}));var bi;(function(me){function De(ce,K){return{id:K,label:ce.label,description:ce.description,canEdit:ce.canEdit,collapsibleState:ce.collapsibleState||E.DebugTreeItemCollapsibleState.None,contextValue:ce.contextValue}}me.from=De})(bi||(e.DebugTreeItem=bi={}));var wi;(function(me){function De(ce){return{id:ce.id,modelDescription:ce.modelDescription,parametersSchema:ce.parametersSchema,displayName:ce.displayName}}me.to=De})(wi||(e.LanguageModelToolDescription=wi={}))}),define(Re[232],Oe([1,0,5,16,8,39]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$grc=void 0;let R=class{constructor(m,s){this.a=m.getProxy(v.$bO.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>s.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,s,I){const b=new L.$9w(P.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(b,void 0,I?.isRefactoring??!1)}};e.$grc=R,e.$grc=R=Qe([We(0,D.$OQ)],R)}),define(Re[233],Oe([1,0,17,10,42,6,41,4,34,69,14,2,18,5,8,7,117,194,21]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=void 0,$=Ve($),r=Ve(r);class i{constructor(l,g,f,d,S){this.j=l,this.k=g,this.l=f,this.m=d,this.n=S,this.b=s.$ke.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let g=function(d){if(l.c){const S=new Error("Response stream has been closed");throw Error.captureStackTrace(S,d),S}};const l=this;this.b.reset();const f=(d,S)=>{if(typeof this.d>"u"&&(d.kind==="markdownContent"||d.kind==="markdownVuln")&&(this.d=this.b.elapsed()),S){const E=this.l.$handleProgressChunk(this.k.requestId,d),y={report:C=>{E?.then(O=>{O&&(r.$HO.isMarkdownString(C.value)?this.l.$handleProgressChunk(this.k.requestId,$.ChatResponseWarningPart.from(C),O):this.l.$handleProgressChunk(this.k.requestId,$.ChatResponseReferencePart.from(C),O))})}};Promise.all([E,S?.(y)]).then(([C,O])=>{C!==void 0&&this.l.$handleProgressChunk(this.k.requestId,$.ChatTaskResult.from(O),C)})}else this.l.$handleProgressChunk(this.k.requestId,d)};this.g={markdown(d){g(this.markdown);const S=new r.$dQ(d),E=$.ChatResponseMarkdownPart.from(S);return f(E),this},markdownWithVulnerabilities(d,S){g(this.markdown),S&&(0,c.$DH)(l.j,"chatParticipantAdditions");const E=new r.$eQ(d,S),y=$.ChatResponseMarkdownWithVulnerabilitiesPart.from(E);return f(y),this},filetree(d,S){g(this.filetree);const E=new r.$hQ(d,S),y=$.ChatResponseFilesPart.from(E);return f(y),this},anchor(d,S){g(this.anchor);const E=new r.$iQ(d,S),y=$.ChatResponseAnchorPart.from(E);return f(y),this},button(d){g(this.anchor);const S=new r.$mQ(d),E=$.ChatResponseCommandButtonPart.from(S,l.m,l.n);return f(E),this},progress(d,S){g(this.progress);const E=new r.$kQ(d,S),y=S?$.ChatTask.from(E):$.ChatResponseProgressPart.from(E);return f(y,S),this},warning(d){g(this.progress),(0,c.$DH)(l.j,"chatParticipantAdditions");const S=new r.$lQ(d),E=$.ChatResponseWarningPart.from(S);return f(E),this},reference(d,S){return this.reference2(d,S)},reference2(d,S,E){if(g(this.reference),typeof d=="object"&&"variableName"in d&&(0,c.$DH)(l.j,"chatParticipantAdditions"),typeof d=="object"&&"variableName"in d&&!d.value){const y=l.k.variables.variables.find(C=>C.name===d.variableName);if(y){let C;if(y.references?.length)C=y.references.map(O=>({kind:"reference",reference:{variableName:d.variableName,value:O.reference}}));else{const O=new r.$nQ(d,S,E);C=[$.ChatResponseReferencePart.from(O)]}return C.forEach(O=>f(O)),this}}else{const y=new r.$nQ(d,S,E),C=$.ChatResponseReferencePart.from(y);f(C)}return this},codeCitation(d,S,E){g(this.codeCitation),(0,c.$DH)(l.j,"chatParticipantAdditions");const y=new r.$oQ(d,S,E),C=$.ChatResponseCodeCitationPart.from(y);f(C)},textEdit(d,S){g(this.textEdit),(0,c.$DH)(l.j,"chatParticipantAdditions");const E=new r.$qQ(d,S),y=$.ChatResponseTextEditPart.from(E);return f(y),this},detectedParticipant(d,S){g(this.detectedParticipant),(0,c.$DH)(l.j,"chatParticipantAdditions");const E=new r.$fQ(d,S),y=$.ChatResponseDetectedParticipantPart.from(E);return f(y),this},confirmation(d,S,E,y){g(this.confirmation),(0,c.$DH)(l.j,"chatParticipantAdditions");const C=new r.$gQ(d,S,E,y),O=$.ChatResponseConfirmationPart.from(C);return f(O),this},push(d){if(g(this.push),(d instanceof r.$qQ||d instanceof r.$eQ||d instanceof r.$fQ||d instanceof r.$lQ||d instanceof r.$gQ||d instanceof r.$oQ||d instanceof r.$pQ)&&(0,c.$DH)(l.j,"chatParticipantAdditions"),d instanceof r.$nQ)this.reference2(d.value,d.iconPath,d.options);else{const S=$.ChatResponsePart.from(d,l.m,l.n);f(S)}return this}}}return this.g}}class n extends T.$Zc{static{this.b=0}static{this.j=0}constructor(l,g,f,d){super(),this.t=g,this.u=f,this.w=d,this.c=new Map,this.m=new Map,this.n=this.B(new T.$9c),this.s=this.B(new T.$9c),this.g=l.getProxy(k.$bO.MainThreadChatAgents2)}transferActiveChat(l){this.g.$transferActiveChatSession(l)}createChatAgent(l,g,f){const d=n.b++,S=new t(l,g,this.g,d,f);return this.c.set(d,S),this.g.$registerAgent(d,l.identifier,g,{},void 0),S.apiAgent}createDynamicChatAgent(l,g,f,d){const S=n.b++,E=new t(l,g,this.g,S,d);return this.c.set(S,E),this.g.$registerAgent(S,l.identifier,g,{isSticky:!0},f),E.apiAgent}registerChatParticipantDetectionProvider(l){const g=n.j++;return this.m.set(g,l),this.g.$registerChatParticipantDetectionProvider(g),(0,T.$Xc)(()=>{this.m.delete(g),this.g.$unregisterChatParticipantDetectionProvider(g)})}async $detectChatParticipant(l,g,f,d,S){const{request:E,location:y,history:C}=await this.y(g,f),O=this.m.get(l);if(O)return O.provideParticipantDetection($.ChatAgentRequest.to(E,y),{history:C},{participants:d.participants,location:$.ChatLocation.to(d.location)},S)}async y(l,g){const f=(0,m.$hi)(l),d=await this.z(f.agentId,g);let S;if(f.locationData?.type===a.ChatAgentLocation.Editor){const E=this.w.getDocument(f.locationData.document);S=new r.$tQ(E,$.Selection.to(f.locationData.selection),$.Range.to(f.locationData.wholeRange))}else if(f.locationData?.type===a.ChatAgentLocation.Notebook){const E=this.w.getDocument(f.locationData.sessionInputUri);S=new r.$uQ(E)}else f.locationData?.type,a.ChatAgentLocation.Terminal;return{request:f,location:S,history:d}}async $invokeAgent(l,g,f,d){const S=this.c.get(l);if(!S)throw new Error(`[CHAT](${l}) CANNOT invoke agent because the agent is not registered`);let E;try{const{request:y,location:C,history:O}=await this.y(g,f);let p=this.n.get(y.sessionId);p||(p=new T.$Yc,this.n.set(y.sessionId,p)),E=new i(S.extension,y,this.g,this.u.converter,p);const w=S.invoke($.ChatAgentRequest.to(y,C),{history:O},E.apiObject,d);return await(0,D.$yh)(Promise.resolve(w).then(M=>{if(M?.metadata)try{JSON.stringify(M.metadata)}catch(F){const G=`result.metadata MUST be JSON.stringify-able. Got error: ${F.message}`;return this.t.error(`[${S.extension.identifier.value}] [@${S.id}] ${G}`,S.extension),{errorDetails:{message:G},timings:E?.timings,nextQuestion:M.nextQuestion}}let A;return M?.errorDetails&&(A={...M.errorDetails,responseIsIncomplete:!0}),A?.responseIsRedacted&&(0,c.$DH)(S.extension,"chatParticipantPrivate"),{errorDetails:A,timings:E?.timings,metadata:M?.metadata,nextQuestion:M?.nextQuestion}}),d)}catch(y){return this.t.error(y,S.extension),y instanceof r.$CQ&&y.cause&&(y=y.cause),{errorDetails:{message:(0,P.$vj)(y),responseIsIncomplete:!0}}}finally{E?.close()}}async z(l,g){const f=[];for(const d of g.history){const S=$.ChatAgentResult.to(d.result),E=l===d.request.agentId?S:{...S,metadata:void 0},y=d.request.variables.variables.filter(w=>!w.isTool).map($.ChatPromptReference.to),C=d.request.variables.variables.filter(w=>w.isTool).map($.ChatLanguageModelToolReference.to),O=new r.$rQ(d.request.message,d.request.command,y,d.request.agentId);O.toolReferences=C,f.push(O);const p=(0,v.$Lb)(d.response.map(w=>$.ChatResponsePart.toContent(w,this.u.converter)));f.push(new r.$sQ(p,E,d.request.agentId,d.request.command))}return f}$releaseSession(l){this.n.deleteAndDispose(l)}async $provideFollowups(l,g,f,d,S){const E=this.c.get(g);if(!E)return Promise.resolve([]);const y=(0,m.$hi)(l),C=await this.z(E.id,d),O=$.ChatAgentResult.to(f);return(await E.provideFollowups(O,{history:C},S)).filter(p=>{const w=!p.participant||R.Iterable.some(this.c.values(),M=>M.id===p.participant&&u.$zn.equals(M.extension.identifier,E.extension.identifier));return w||this.t.warn(`[@${E.id}] ChatFollowup refers to an unknown participant: ${p.participant}`),w}).map(p=>$.ChatFollowup.from(p,y))}$acceptFeedback(l,g,f){const d=this.c.get(l);if(!d)return;const S=$.ChatAgentResult.to(g);let E;switch(f.direction){case h.ChatAgentVoteDirection.Down:E=r.ChatResultFeedbackKind.Unhelpful;break;case h.ChatAgentVoteDirection.Up:E=r.ChatResultFeedbackKind.Helpful;break}const y={result:S,kind:E,unhelpfulReason:(0,c.$CH)(d.extension,"chatParticipantAdditions")?f.reason:void 0};d.acceptFeedback(Object.freeze(y))}$acceptAction(l,g,f){const d=this.c.get(l);if(!d||f.action.kind==="vote")return;const S=$.ChatAgentUserActionEvent.to(g,f,this.u.converter);S&&d.acceptAction(Object.freeze(S))}async $invokeCompletionProvider(l,g,f){const d=this.c.get(l);if(!d)return[];let S=this.s.get(l);return S?S.clear():(S=new T.$Yc,this.s.set(l,S)),(await d.invokeCompletionProvider(g,f)).map(y=>$.ChatAgentCompletionItem.from(y,this.u.converter,S))}async $provideWelcomeMessage(l,g,f){const d=this.c.get(l);if(d)return await d.provideWelcomeMessage($.ChatLocation.to(g),f)}async $provideChatTitle(l,g,f){const d=this.c.get(l);if(!d)return;const S=await this.z(d.id,{history:g});return await d.provideTitle({history:S},f)}async $provideSampleQuestions(l,g,f){const d=this.c.get(l);if(d)return(await d.provideSampleQuestions($.ChatLocation.to(g),f)).map(S=>$.ChatFollowup.from(S,void 0))}}e.$hrc=n;class t{constructor(l,g,f,d,S){this.extension=l,this.id=g,this.w=f,this.x=d,this.y=S,this.l=new L.$qe,this.m=new L.$qe}acceptFeedback(l){this.l.fire(l)}acceptAction(l){this.m.fire(l)}async invokeCompletionProvider(l,g){return this.o?await this.o.provider.provideCompletionItems(l,g)??[]:[]}async provideFollowups(l,g,f){if(!this.b)return[];const d=await this.b.provideFollowups(l,g,f);return d?d.filter(S=>!(S&&"commandId"in S)).filter(S=>!(S&&"message"in S)):[]}async provideWelcomeMessage(l,g){if(!this.q)return[];const f=await this.q.provideWelcomeMessage(l,g);return f?f.map(d=>typeof d=="string"?d:$.MarkdownString.from(d)):[]}async provideTitle(l,g){if(this.s)return await this.s.provideChatTitle(l,g)??void 0}async provideSampleQuestions(l,g){if(!this.q||!this.q.provideSampleQuestions)return[];const f=await this.q.provideSampleQuestions(l,g);return f||[]}get apiAgent(){let l=!1,g=!1;const f=()=>{l||g||(g=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof b.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof r.$cP?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.k,helpTextPrefix:!this.d||typeof this.d=="string"?this.d:$.MarkdownString.from(this.d),helpTextVariablesPrefix:!this.g||typeof this.g=="string"?this.g:$.MarkdownString.from(this.g),helpTextPostfix:!this.j||typeof this.j=="string"?this.j:$.MarkdownString.from(this.j),supportIssueReporting:this.n,requester:this.t,supportsSlowVariables:this.u}),g=!1}))},d=this;return{get id(){return d.id},get iconPath(){return d.c},set iconPath(S){d.c=S,f()},get requestHandler(){return d.y},set requestHandler(S){(0,I.$tg)(typeof S=="function","Invalid request handler"),d.y=S},get followupProvider(){return d.b},set followupProvider(S){d.b=S,f()},get helpTextPrefix(){return(0,c.$DH)(d.extension,"defaultChatParticipant"),d.d},set helpTextPrefix(S){(0,c.$DH)(d.extension,"defaultChatParticipant"),d.d=S,f()},get helpTextVariablesPrefix(){return(0,c.$DH)(d.extension,"defaultChatParticipant"),d.g},set helpTextVariablesPrefix(S){(0,c.$DH)(d.extension,"defaultChatParticipant"),d.g=S,f()},get helpTextPostfix(){return(0,c.$DH)(d.extension,"defaultChatParticipant"),d.j},set helpTextPostfix(S){(0,c.$DH)(d.extension,"defaultChatParticipant"),d.j=S,f()},get isSecondary(){return(0,c.$DH)(d.extension,"defaultChatParticipant"),d.k},set isSecondary(S){(0,c.$DH)(d.extension,"defaultChatParticipant"),d.k=S,f()},get supportIssueReporting(){return(0,c.$DH)(d.extension,"chatParticipantPrivate"),d.n},set supportIssueReporting(S){(0,c.$DH)(d.extension,"chatParticipantPrivate"),d.n=S,f()},get onDidReceiveFeedback(){return d.l.event},set participantVariableProvider(S){if((0,c.$DH)(d.extension,"chatParticipantAdditions"),d.o=S,S){if(!S.triggerCharacters.length)throw new Error("triggerCharacters are required");d.w.$registerAgentCompletionsProvider(d.x,d.id,S.triggerCharacters)}else d.w.$unregisterAgentCompletionsProvider(d.x,d.id)},get participantVariableProvider(){return(0,c.$DH)(d.extension,"chatParticipantAdditions"),d.o},set welcomeMessageProvider(S){(0,c.$DH)(d.extension,"defaultChatParticipant"),d.q=S,f()},get welcomeMessageProvider(){return(0,c.$DH)(d.extension,"defaultChatParticipant"),d.q},set titleProvider(S){(0,c.$DH)(d.extension,"defaultChatParticipant"),d.s=S,f()},get titleProvider(){return(0,c.$DH)(d.extension,"defaultChatParticipant"),d.s},onDidPerformAction:(0,c.$CH)(this.extension,"chatParticipantAdditions")?this.m.event:void 0,set requester(S){d.t=S,f()},get requester(){return d.t},set supportsSlowReferences(S){(0,c.$DH)(d.extension,"chatParticipantPrivate"),d.u=S,f()},get supportsSlowReferences(){return(0,c.$DH)(d.extension,"chatParticipantPrivate"),d.u},dispose(){l=!0,d.b=void 0,d.l.dispose(),d.w.$unregisterAgent(d.x)}}}invoke(l,g,f,d){return this.y(l,g,f,d)}}}),define(Re[234],Oe([1,0,12,4,36,5,8,7,21]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=void 0,R=Ve(R),T=Ve(T);class s{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(L.$bO.MainThreadChatVariables)}async $resolveVariable(u,k,$,r){const a=this.b.get(u);if(a)try{if(a.resolver.resolve2){(0,m.$DH)(a.extension,"chatParticipantAdditions");const h=new I(k,this.c),c=await a.resolver.resolve2(a.data.name,{prompt:$},h.apiObject,r);if(c&&c[0])return c[0].value}else{const h=await a.resolver.resolve(a.data.name,{prompt:$},r);if(h&&h[0])return h[0].value}}catch(h){(0,v.$5)(h)}}registerVariableResolver(u,k,$,r,a,h,c,i,n){const t=s.a++,o=n?P.ThemeIcon.fromId(n):void 0;return this.b.set(t,{extension:u,data:{id:k,name:$,description:r,modelDescription:a,icon:o},resolver:c}),this.c.$registerVariable(t,{id:k,name:$,description:r,modelDescription:a,isSlow:h,fullName:i,icon:o}),(0,D.$Xc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$irc=s;class I{constructor(u,k){this.c=u,this.d=k,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let k=function(r){if(u.a){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,r),a}};const u=this,$=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){k(this.progress);const a=new T.$jQ(r),h=R.ChatResponseProgressPart.from(a);return $(h),this},reference(r){k(this.reference);const a=new T.$nQ(r),h=R.ChatResponseReferencePart.from(a);return $(h),this},push(r){return k(this.push),r instanceof T.$nQ?$(R.ChatResponseReferencePart.from(r)):r instanceof T.$jQ&&$(R.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Re[235],Oe([1,0,10,71,6,4,38,2,94,18,8,7,5,21]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=$,m=Ve(m),I=Ve(I),b=Ve(b);function $(r,a,h){const c=r.getProxy(u.$bO.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new s.$Bn,a.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===R.MarshalledId.CommentController){const C=this.b.get(y.handle);return C?C.value:y}else if(y&&y.$mid===R.MarshalledId.CommentThread){const C=y,O=this.b.get(C.commentControlHandle);if(!O)return C;const p=O.getCommentThread(C.commentThreadHandle);return p?p.value:C}else if(y&&(y.$mid===R.MarshalledId.CommentThreadReply||y.$mid===R.MarshalledId.CommentThreadInstance)){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const O=C.getCommentThread(y.thread.commentThreadHandle);return O?y.$mid===R.MarshalledId.CommentThreadInstance?O.value:{thread:O.value,text:y.text}:y}else if(y&&y.$mid===R.MarshalledId.CommentNode){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const O=C.getCommentThread(y.thread.commentThreadHandle);if(!O)return y;const p=y.commentUniqueId,w=O.getCommentByUniqueId(p);return w||y}else if(y&&y.$mid===R.MarshalledId.CommentThreadNode){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const O=C.getCommentThread(y.thread.commentThreadHandle);if(!O)return y;const p=y.text,w=y.commentUniqueId,M=O.getCommentByUniqueId(w);return M?(typeof M.body=="string"?M.body=p:M.body=new b.$HO(p),M):y}return y}})}createCommentController(y,C,O){const p=i.a++,w=new t(y,p,C,O);this.b.set(w.handle,w);const M=this.c.get(y.identifier)||[];return M.push(w),this.c.set(y.identifier,M),w.value}async $createCommentThreadTemplate(y,C,O,p){const w=this.b.get(y);w&&w.$createCommentThreadTemplate(C,O,p)}async $setActiveComment(y,C){const O=this.b.get(y);O&&O.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(y,C,O){const p=this.b.get(y);p&&p.$updateCommentThreadTemplate(C,O)}$deleteCommentThread(y,C){this.b.get(y)?.$deleteCommentThread(C)}async $provideCommentingRanges(y,C,O){const p=this.b.get(y);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const w=await h.ensureDocumentData(T.URI.revive(C));return(0,v.$Ch)(async()=>{const M=await p.commentingRangeProvider.provideCommentingRanges(w.document,O);let A;return Array.isArray(M)?A={ranges:M,fileComments:!1}:M?A={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:A=M??void 0,A}).then(M=>{let A;return M&&(A={ranges:M.ranges.map(F=>I.Range.from(F)),fileComments:M.fileComments}),A})}$toggleReaction(y,C,O,p,w){const M=this.b.get(y);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,v.$Ch)(()=>{const A=M.getCommentThread(C);if(A){const F=A.getCommentByUniqueId(p.uniqueIdInThread);if(M!==void 0&&F&&M.reactionHandler)return M.reactionHandler(F,g(w))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,k.$DH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,C,O,p,w,M,A,F,G){this.m=C,this.n=O,this.o=p,this.p=w,this.q=M,this.extensionDescription=A,this.r=F,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$qe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$1c,this.l.value=new L.$Yc,this.n===void 0&&(this.n=`${y}.${this.handle}`),c.$createCommentThread(C,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(j=>o(this,j,this.k,this.extensionDescription)),A.identifier,this.r,G),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{c.$deleteCommentThread(C,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(j){x.range=j},get comments(){return x.comments},set comments(j){x.comments=j},get collapsibleState(){return x.collapsibleState},set collapsibleState(j){x.collapsibleState=j},get canReply(){return x.canReply},set canReply(j){x.canReply=j},get contextValue(){return x.contextValue},set contextValue(j){x.contextValue=j},get label(){return x.label},set label(j){x.label=j},get state(){return x.state},set state(j){x.state=j},reveal:(j,U)=>x.reveal(j,U),hide:()=>x.hide(),dispose:()=>{x.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Yc);const y=O=>Object.prototype.hasOwnProperty.call(this.b,O),C={};y("range")&&(C.range=I.Range.from(this.p)),y("label")&&(C.label=this.label),y("contextValue")&&(C.contextValue=this.contextValue??null),y("comments")&&(C.comments=this.q.map(O=>o(this,O,this.k,this.extensionDescription))),y("collapsibleState")&&(C.collapseState=f(this.g)),y("canReply")&&(C.canReply=this.canReply),y("state")&&(C.state=d(this.h)),y("applicability")&&(C.applicability=S(this.h)),y("isTemplate")&&(C.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(y){for(const C of this.k){const O=C[0],p=C[1];if(y===p)return O}}async reveal(y,C){(0,k.$DH)(this.extensionDescription,"commentReveal");let O;y&&y.body!==void 0?O=y:C=C??y;let p=O?this.k.get(O):void 0;p??=this.k.get(this.q[0]);let w=!0,M=!1;return C?.focus===b.CommentThreadFocus.Reply?(M=!0,w=!1):C?.focus===b.CommentThreadFocus.Comment&&(w=!1),c.$revealCommentThread(this.m,this.handle,p,{preserveFocus:w,focusReply:M})}async hide(){return c.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Qe([(0,D.$di)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,k.$DH)(this.h,"commentingRangeHint"),c.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,k.$DH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,k.$DH)(this.h,"activeComment"),this.f?.value}constructor(y,C,O,p){this.h=y,this.i=C,this.j=O,this.k=p,this.a=new Map,c.$registerCommentController(this.handle,O,p,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(M){w.options=M},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(M){w.commentingRangeProvider=M},get reactionHandler(){return w.reactionHandler},set reactionHandler(M){w.reactionHandler=M},get activeCommentThread(){return w.activeCommentThread},createCommentThread(M,A,F){return w.createCommentThread(M,A,F).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(y,C,O){C===void 0&&(0,k.$DH)(this.h,"fileComments");const p=new n(this.id,this.handle,void 0,y,C,O,this.h,!1);return this.a.set(p.handle,p),p}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const C=this.a.get(y.commentThreadHandle);C&&(this.e=y.uniqueIdInThread?C.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(y,C,O){const p=new n(this.id,this.handle,void 0,T.URI.revive(y),I.Range.to(C),[],this.h,!0,O);return p.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(y,C){const O=this.a.get(y);O&&(O.range=I.Range.to(C))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function o(E,y,C,O){let p=C.get(y);return p||(p=++E.commentHandle,C.set(y,p)),y.state!==void 0&&(0,k.$DH)(O,"commentsDraftState"),y.reactions?.some(w=>w.reactors!==void 0)&&(0,k.$DH)(O,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:p,body:typeof y.body=="string"?y.body:I.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(w=>l(w)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function l(E){return{label:E.label,iconPath:E.iconPath?I.$NQ(E.iconPath):void 0,count:E.count,hasReacted:E.authorHasReacted,reactors:E.reactors&&E.reactors.length>0&&typeof E.reactors[0]!="string"?E.reactors.map(y=>y.name):E.reactors}}function g(E){return{label:E.label||"",count:E.count||0,iconPath:E.iconPath?T.URI.revive(E.iconPath):"",authorHasReacted:E.hasReacted||!1,reactors:E.reactors?.map(y=>({name:y}))}}function f(E){if(E!==void 0)switch(E){case b.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case b.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function d(E){let y;if(typeof E=="object"?y=E.resolved:y=E,y!==void 0)switch(y){case b.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case b.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}function S(E){let y;if(typeof E=="object"&&(y=E.applicability),y!==void 0)switch(y){case b.CommentThreadApplicability.Current:return m.CommentThreadApplicability.Current;case b.CommentThreadApplicability.Outdated:return m.CommentThreadApplicability.Outdated}return m.CommentThreadApplicability.Current}return new i}}),define(Re[236],Oe([1,0,19,76,4,15,24,2,8,67,80,5,7]),function(be,e,v,D,P,L,R,T,m,s,I,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Erc=void 0,m=Ve(m),b=Ve(b),u=Ve(u);class k{constructor(l,g){this.document=l,this.b=g,this.a=1,this.c=new I.$5qc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,g){await this.f(l).undo(),g||this.disposeBackup()}async redo(l,g){await this.f(l).redo(),g||this.disposeBackup()}disposeEdits(l){for(const g of l)this.c.delete(g)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=t(this.document.uri)+this.a++;return(0,R.$lh)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const g=this.c.get(l,0);if(!g)throw new Error("No edit found");return g}}class ${constructor(){this.a=new Map}get(l,g){return this.a.get(this.b(l,g))}add(l,g,f){const d=this.b(l,g.uri);if(this.a.has(d))throw new Error(`Document already exists for viewType:${l} resource:${g.uri}`);const S=new k(g,f);return this.a.set(d,S),S}delete(l,g){const f=this.b(l,g.uri);this.a.delete(f)}b(l,g){return`${l}@@@${g}`}}var r;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(r||(r={}));class a{constructor(){this.a=new Map}addTextProvider(l,g,f){return this.b(l,{type:r.Text,extension:g,provider:f})}addCustomProvider(l,g,f){return this.b(l,{type:r.Custom,extension:g,provider:f})}get(l){return this.a.get(l)}b(l,g){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,g),new u.$dO(()=>this.a.delete(l))}}class h{constructor(l,g,f,d,S){this.d=g,this.f=f,this.g=d,this.h=S,this.b=new a,this.c=new $,this.a=l.getProxy(b.$bO.MainThreadCustomEditors)}registerCustomEditorProvider(l,g,f,d){const S=new P.$Yc;return i(f)?(S.add(this.b.addTextProvider(g,l,f)),this.a.$registerTextEditorProvider((0,s.$Brc)(l),g,d.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,s.$zrc)(l))):(S.add(this.b.addCustomProvider(g,l,f)),c(f)&&S.add(f.onDidChangeCustomDocument(E=>{const y=this.i(g,E.document.uri);if(n(E)){const C=y.addEdit(E);this.a.$onDidEdit(E.document.uri,g,C,E.label)}else this.a.$onContentChange(E.document.uri,g)})),this.a.$registerCustomEditorProvider((0,s.$Brc)(l),g,d.webviewOptions||{},!!d.supportsMultipleEditorsPerDocument,(0,s.$zrc)(l))),u.$dO.from(S,new u.$dO(()=>{this.a.$unregisterEditorProvider(g)}))}async $createCustomDocument(l,g,f,d,S){const E=this.b.get(g);if(!E)throw new Error(`No provider found for '${g}'`);if(E.type!==r.Custom)throw new Error(`Invalid provide type for '${g}'`);const y=T.URI.revive(l),C=await E.provider.openCustomDocument(y,{backupId:f,untitledDocumentData:d?.buffer},S);let O;return c(E.provider)&&this.f&&(O=this.f.workspaceValue(E.extension)??this.f.globalValue(E.extension)),this.c.add(g,C,O),{editable:c(E.provider)}}async $disposeCustomDocument(l,g){const f=this.b.get(g);if(!f)throw new Error(`No provider found for '${g}'`);if(f.type!==r.Custom)throw new Error(`Invalid provider type for '${g}'`);const d=T.URI.revive(l),{document:S}=this.i(g,d);this.c.delete(g,S),S.dispose()}async $resolveCustomEditor(l,g,f,d,S,E){const y=this.b.get(f);if(!y)throw new Error(`No provider found for '${f}'`);const C=m.ViewColumn.to(S),O=this.g.createNewWebview(g,d.contentOptions,y.extension),p=this.h.createNewWebviewPanel(g,f,d.title,C,d.options,O,d.active),w=T.URI.revive(l);switch(y.type){case r.Custom:{const{document:M}=this.i(f,w);return y.provider.resolveCustomEditor(M,p,E)}case r.Text:{const M=this.d.getDocument(w);return y.provider.resolveCustomTextEditor(M,p,E)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,g,f){this.i(g,l).disposeEdits(f)}async $onMoveCustomEditor(l,g,f){const d=this.b.get(f);if(!d)throw new Error(`No provider found for '${f}'`);if(!d.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const S=this.h.getWebviewPanel(l);if(!S)throw new Error("No webview found");const E=T.URI.revive(g),y=this.d.getDocument(E);await d.provider.moveCustomTextEditor(y,S,v.CancellationToken.None)}async $undo(l,g,f,d){return this.i(g,l).undo(f,d)}async $redo(l,g,f,d){return this.i(g,l).redo(f,d)}async $revert(l,g,f){const d=this.i(g,l);await this.j(g).revertCustomDocument(d.document,f),d.disposeBackup()}async $onSave(l,g,f){const d=this.i(g,l);await this.j(g).saveCustomDocument(d.document,f),d.disposeBackup()}async $onSaveAs(l,g,f,d){const S=this.i(g,l);return this.j(g).saveCustomDocumentAs(S.document,T.URI.revive(f),d)}async $backup(l,g,f){const d=this.i(g,l),E=await this.j(g).backupCustomDocument(d.document,{destination:d.getNewBackupUri()},f);return d.updateBackup(E),E.id}i(l,g){const f=this.c.get(l,T.URI.revive(g));if(!f)throw new Error("No custom document found");return f}j(l){const f=this.b.get(l)?.provider;if(!f||!c(f))throw new Error("Custom document is not editable");return f}}e.$Erc=h;function c(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function n(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const l=o.scheme===L.Schemas.file||o.scheme===L.Schemas.untitled?o.fsPath:o.toString();return(0,D.$yj)(l)+""}}),define(Re[237],Oe([1,0,9,108,2,5,7,8,6,11,27,50]),function(be,e,v,D,P,L,R,T,m,s,I,b){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=e.$_qc=void 0,T=Ve(T);class k{#e;#t;#i;constructor(a,h,c,i,n,t,o,l){this.d=a,this.e=h,this.f=c,this.g=i,this.h=n,this.c=!1,this.f=Math.max(i,c),this.#i=new I.$Fc(g=>t.getComparisonKey(g)),this.#e=o,this.#t=l}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(a,h){if(!a){this.clear();return}this.j();let c=[];if(P.URI.isUri(a)){if(!h){this.delete(a);return}this.#i.set(a,h.slice()),c=[a]}else if(Array.isArray(a)){c=[];let t;a=[...a].sort(k.k);for(const o of a){const[l,g]=o;if((!t||l.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=l,c.push(l),this.#i.set(l,[])),g)this.#i.get(l)?.push(...g);else{const f=this.#i.get(l);f&&(f.length=0)}}}if(this.#t.fire(c),!this.#e)return;const i=[];let n=0;for(const t of c){let o=[];const l=this.#i.get(t);if(l)if(l.length>this.g){o=[];const g=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const d of l)if(d.severity===g[f]&&o.push({...T.Diagnostic.from(d),modelVersionId:this.h(t)})===this.g)break e;o.push({severity:D.MarkerSeverity.Info,message:(0,v.localize)(2701,null,l.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=l.map(g=>({...T.Diagnostic.from(g),modelVersionId:this.h(t)}));if(i.push([t,o]),n+=o.length,n>this.f)break}this.#e.$changeMany(this.e,i)}delete(a){this.j(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this.e,[[a,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(a,h){this.j();for(const[c,i]of this)a.call(h,c,i,this)}*[Symbol.iterator](){this.j();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this.j();const h=this.#i.get(a);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(a){return this.j(),Array.isArray(this.#i.get(a))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(a,h){return a[0].toString()<h[0].toString()?-1:a[0].toString()>h[0].toString()?1:0}}e.$_qc=k;let $=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(a){const h=new I.$Fc;for(const c of a)h.set(c,c);return{uris:Object.freeze(Array.from(h.values()))}}constructor(a,h,c,i){this.j=h,this.k=c,this.l=i,this.g=new Map,this.h=new m.$ue({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,u._mapper),this.f=a.getProxy(L.$bO.MainThreadDiagnostics)}createDiagnosticCollection(a,h){const{g:c,f:i,h:n,j:t,k:o,l}=this,g=new class{$changeMany(S,E){i.$changeMany(S,E),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,S,E.length===0?"CLEARING":E)}$clear(S){i.$clear(S),t.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,S)}dispose(){i.dispose()}};let f;if(!h)h="_generated_diagnostic_collection_name_#"+u.c++,f=h;else if(!c.has(h))f=h;else{this.j.warn(`DiagnosticCollection with name '${h}' does already exist.`);do f=h+u.c++;while(c.has(f))}return new class extends k{constructor(){super(h,f,u.e,u.d,S=>l.getDocument(S)?.version,o.extUri,g,n),c.set(f,this)}dispose(){super.dispose(),c.delete(f)}}}getDiagnostics(a){if(a)return this.m(a);{const h=new Map,c=[];for(const i of this.g.values())i.forEach((n,t)=>{let o=h.get(n.toString());typeof o>"u"&&(o=c.length,h.set(n.toString(),o),c.push([n,[]])),c[o][1]=c[o][1].concat(...t)});return c}}m(a){let h=[];for(const c of this.g.values())c.has(a)&&(h=h.concat(c.get(a)));return h}$acceptMarkersChange(a){if(!this.n){const h="_generated_mirror",c=new k(h,h,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(h,c),this.n=c}for(const[h,c]of a)this.n.set(P.URI.revive(h),c.map(T.Diagnostic.to))}};e.$arc=$,e.$arc=$=u=Qe([We(1,s.$fk),We(2,b.$$qc)],$)}),define(Re[238],Oe([1,0,2,12,7,8,172,39]),function(be,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nsc=void 0;class m{constructor(I,b,u,k={timeout:1500,errors:3}){this.c=I,this.d=b,this.f=u,this.g=k,this.a=new R.$0c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(b,u,k)=>{const r={dispose:this.a.push([b,u,I])};return Array.isArray(k)&&k.push(r),r}}async $participateInSave(I,b){const u=v.URI.revive(I);let k=!1;const $=setTimeout(()=>k=!0,this.g.timeout),r=[];try{for(const a of[...this.a]){if(k)break;const h=this.d.getDocument(u),c=await this.h(a,{document:h,reason:L.TextDocumentSaveReason.to(b)});r.push(c)}}finally{clearTimeout($)}return r}h([I,b,u],k){const $=this.b.get(I);return typeof $=="number"&&$>this.g.errors?Promise.resolve(!1):this.i(u,I,b,k).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const a=this.b.get(I);this.b.set(I,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,b,u,k){const $=[],r=Date.now(),{document:a,reason:h}=k,{version:c}=a,i=Object.freeze({document:a,reason:h,waitUntil(n){if(Object.isFrozen($))throw(0,D.$_)("waitUntil can not be called async");$.push(Promise.resolve(n))}});try{b.apply(u,[i])}catch(n){return Promise.reject(n)}return Object.freeze($),new Promise((n,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all($).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(o),n(l)}).catch(l=>{clearTimeout(o),t(l)})}).then(n=>{const t={edits:[]};for(const o of n)if(Array.isArray(o)&&o.every(l=>l instanceof P.$mO))for(const{newText:l,newEol:g,range:f}of o)t.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:f&&L.Range.from(f),text:l,eol:g&&L.EndOfLine.from(g)}});if(t.edits.length!==0)return c===a.version?this.f.$tryApplyWorkspaceEdit(new T.$9w(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$nsc=m}),define(Re[239],Oe([1,0,6,4,2,5,125,8,14,25,7]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$brc=void 0,T=Ve(T);class b{constructor(k,$){this.a=new v.$qe,this.b=new v.$qe,this.c=new v.$qe,this.d=new v.$qe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new D.$Yc,this.h=new Map,this.f=k.getProxy(L.$bO.MainThreadDocuments),this.g=$,this.g.onDidRemoveDocuments(r=>{for(const a of r)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const a of r)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const $=this.g.getDocument(k);if($)return $}getDocument(k){const $=this.getDocumentData(k);if(!$?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return $.document}ensureDocumentData(k){const $=this.g.getDocument(k);if($)return Promise.resolve($);let r=this.h.get(k.toString());return r||(r=this.f.$tryOpenDocument(k).then(a=>{this.h.delete(k.toString());const h=P.URI.revive(a);return(0,m.$ug)(this.g.getDocument(h))},a=>(this.h.delete(k.toString()),Promise.reject(a))),this.h.set(k.toString(),r)),r}createDocumentData(k){return this.f.$tryCreateDocument(k).then($=>P.URI.revive($))}$acceptModelLanguageChanged(k,$){const r=P.URI.revive(k),a=this.g.getDocument(r);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId($),this.a.fire(a.document)}$acceptModelSaved(k){const $=P.URI.revive(k),r=this.g.getDocument($);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(k,$){const r=P.URI.revive(k),a=this.g.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty($),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,$,r){const a=P.URI.revive(k),h=this.g.getDocument(a);if(!h)throw new Error("unknown document");h._acceptIsDirty(r),h.onEvents($);let c;$.isUndoing?c=I.TextDocumentChangeReason.Undo:$.isRedoing&&(c=I.TextDocumentChangeReason.Redo),this.c.fire((0,s.$no)({document:h.document,contentChanges:$.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:c}))}setWordDefinitionFor(k,$){(0,R.$QQ)(k,$)}}e.$brc=b}),define(Re[70],Oe([1,0,240,6,14,2,3,5,16,8,7]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Grc=e.$Frc=void 0,s=Ve(s),e.$Frc=(0,R.$Ki)("IExtHostEditorTabs");class b{constructor(a,h,c){this.e=c,this.d=h,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,h={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(h)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new I.$4P(L.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new I.$5P(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new I.$6P(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new I.$7P(L.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new I.$8P(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new I.$9P(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new I.$0P(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new I.$$P;case T.TabInputKind.InteractiveEditorInput:return new I.$_P(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new I.$aQ;case T.TabInputKind.MultiDiffEditorInput:return new I.$bQ(this.b.input.diffEditors.map(a=>new I.$5P(L.URI.revive(a.original),L.URI.revive(a.modified))));default:return}}}class u{constructor(a,h){this.c=[],this.d="",this.b=a,this.e=h;for(const c of a.tabs)c.isActive&&(this.d=c.id),this.c.push(new b(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,h={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return s.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(c=>c.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(c=>c.apiObject))}};this.a=Object.freeze(h)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===T.TabModelOperationKind.TAB_OPEN){const c=new b(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,c),a.tabDto.isActive&&(this.d=c.tabId),c}else if(a.kind===T.TabModelOperationKind.TAB_CLOSE){const c=this.c.splice(a.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(a.kind===T.TabModelOperationKind.TAB_MOVE){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(a.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,c),c}const h=this.c.find(c=>c.tabId===a.tabDto.id);if(!h)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),h.acceptDtoUpdate(a.tabDto),h}activeTabId(){return this.d}}let k=class{constructor(a){this.b=new D.$qe,this.c=new D.$qe,this.e=[],this.a=a.getProxy(T.$bO.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,h={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(c=>c.apiObject))},get activeTabGroup(){const c=a.d;return(0,P.$ug)(a.e.find(n=>n.groupId===c)?.apiObject)},close:async(c,i)=>{const n=Array.isArray(c)?c:[c];return n.length?$(n[0])?this.j(n,i):this.i(n,i):!0}};this.f=Object.freeze(h)}return this.f}$acceptEditorTabModel(a){const h=new Set(this.e.map(g=>g.groupId)),c=new Set(a.map(g=>g.groupId)),i=(0,v.$f)(h,c),n=this.e.filter(g=>i.removed.includes(g.groupId)).map(g=>g.apiObject),t=[],o=[];this.e=a.map(g=>{const f=new u(g,()=>this.d);return i.added.includes(f.groupId)?t.push(f.apiObject):o.push(f.apiObject),f});const l=(0,P.$ug)(a.find(g=>g.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:t,closed:n,changed:o}))}$acceptTabGroupUpdate(a){const h=this.e.find(c=>c.groupId===a.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const h=this.e.find(i=>i.groupId===a.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const c=h.acceptTabOperation(a);switch(a.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(a){for(const h of this.e)for(const c of h.tabs)if(c.apiObject===a)return c}h(a){return this.e.find(h=>h.apiObject===a)}async i(a,h){const c=[];for(const i of a){const n=this.g(i);if(!n)throw new Error("Tab close: Invalid tab not found!");c.push(n.tabId)}return this.a.$closeTab(c,h)}async j(a,h){const c=[];for(const i of a){const n=this.h(i);if(!n)throw new Error("Group close: Invalid group not found!");c.push(n.groupId)}return this.a.$closeGroup(c,h)}};e.$Grc=k,e.$Grc=k=Qe([We(0,m.$OQ)],k);function $(r){return r.tabs!==void 0}}),define(Re[241],Oe([1,0,2,5,28,4,7,8,285,13,30,20,21,59]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qsc=void 0,P=Ve(P),T=Ve(T);class ${constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const c=this.a.indexOf(h);c>=0&&(this.a.splice(c,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),c=[];let i,n,t=m.State.LastKnownState,o=m.State.LastKnownState;for(const l of h){let g=i?(0,s.$Mf)(i,l):0;for(g===0?n=m.State.Start:n=o;g<l.length;g++)g+1===l.length?(t=o,o=m.State.BeforeColon):o+=1,c.push([n,l.toUpperCase().charCodeAt(g),o]),c.push([n,l.toLowerCase().charCodeAt(g),o]),n=o;i=l,o=t}c.push([m.State.BeforeColon,I.CharCode.Colon,m.State.AfterColon]),c.push([m.State.AfterColon,I.CharCode.Slash,m.State.End]),this.b=new m.$g5(c)}}provideDocumentLinks(h){this.c();const c=[],i=m.$h5.computeLinks({getLineContent(n){return h.lineAt(n-1).text},getLineCount(){return h.lineCount}},this.b);for(const n of i){const t=T.DocumentLink.to(n);t.target&&c.push(t)}return c}}class r{constructor(h,c){this.i=c,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(D.$bO.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,c,i,n={}){if(r.j(i),this.d.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const t=this.h++;this.b.add(c),this.d.add(c),this.c.set(t,i);let o=P.FileSystemProviderCapabilities.FileReadWrite;n.isCaseSensitive&&(o+=P.FileSystemProviderCapabilities.PathCaseSensitive),n.isReadonly&&(o+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$DH)(h,"fsChunks"),o+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let l;n.isReadonly&&(0,k.$$k)(n.isReadonly)&&n.isReadonly.value!==""&&(l={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,c,o,l).catch(f=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${c}`),console.error(f)});const g=i.onDidChangeFile(f=>{const d=[];for(const S of f){const{uri:E,type:y}=S;if(E.scheme!==c)continue;let C;switch(y){case R.FileChangeType.Changed:C=P.FileChangeType.UPDATED;break;case R.FileChangeType.Created:C=P.FileChangeType.ADDED;break;case R.FileChangeType.Deleted:C=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:E,type:C})}this.a.$onFileSystemChange(t,d)});return(0,L.$Xc)(()=>{g.dispose(),this.b.delete(c),this.d.delete(c),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:c,ctime:i,mtime:n,size:t,permissions:o}=h;return{type:c,ctime:i,mtime:n,size:t,permissions:o}}$stat(h,c){return Promise.resolve(this.l(h).stat(v.URI.revive(c))).then(i=>r.k(i))}$readdir(h,c){return Promise.resolve(this.l(h).readDirectory(v.URI.revive(c)))}$readFile(h,c){return Promise.resolve(this.l(h).readFile(v.URI.revive(c))).then(i=>b.$Se.wrap(i))}$writeFile(h,c,i,n){return Promise.resolve(this.l(h).writeFile(v.URI.revive(c),i.buffer,n))}$delete(h,c,i){return Promise.resolve(this.l(h).delete(v.URI.revive(c),i))}$rename(h,c,i,n){return Promise.resolve(this.l(h).rename(v.URI.revive(c),v.URI.revive(i),n))}$copy(h,c,i,n){const t=this.l(h);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(c),v.URI.revive(i),n))}$mkdir(h,c){return Promise.resolve(this.l(h).createDirectory(v.URI.revive(c)))}$watch(h,c,i,n){const t=this.l(h).watch(v.URI.revive(i),n);this.f.set(c,t)}$unwatch(h,c){const i=this.f.get(c);i&&(i.dispose(),this.f.delete(c))}$open(h,c,i){const n=this.l(h);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(v.URI.revive(c),i))}$close(h,c){const i=this.l(h);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(c))}$read(h,c,i,n){const t=this.l(h);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=b.$Se.alloc(n);return Promise.resolve(t.read(c,i,o.buffer,0,n)).then(l=>o.slice(0,l))}$write(h,c,i,n){const t=this.l(h);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(c,i,n.buffer,0,n.byteLength))}l(h){const c=this.c.get(h);if(!c){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return c}}e.$qsc=r}),define(Re[242],Oe([1,0,6,43,2,5,8,7,28,51]),function(be,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rsc=void 0,R=Ve(R);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor($,r,a,h,c,i){this.a=Math.random(),this.b=new v.$qe,this.c=new v.$qe,this.d=new v.$qe,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,D.$Fk)(c),t=typeof c=="string",o=i?.correlate,l=h(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(o&&typeof g.session>"u")){if(!i?.ignoreCreateEvents)for(const f of g.created){const d=P.URI.revive(f);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this.b.fire(d)}if(!i?.ignoreChangeEvents)for(const f of g.changed){const d=P.URI.revive(f);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this.c.fire(d)}if(!i?.ignoreDeleteEvents)for(const f of g.deleted){const d=P.URI.revive(f);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=T.$dO.from(this.i($,a,c,i,i?.correlate),this.b,this.c,this.d,l)}i($,r,a,h,c){const i=T.$dO.from();if(typeof a=="string"||h?.ignoreChangeEvents&&h?.ignoreCreateEvents&&h?.ignoreDeleteEvents)return i;const n=$.getProxy(L.$bO.MainThreadFileSystemEventService);let t=!1;(a.pattern.includes(D.$Bk)||a.pattern.includes(D.$Ck))&&(t=!0);let o;return c&&(h?.ignoreChangeEvents||h?.ignoreCreateEvents||h?.ignoreDeleteEvents)&&(o=m.FileChangeFilter.UPDATED|m.FileChangeFilter.ADDED|m.FileChangeFilter.DELETED,h?.ignoreChangeEvents&&(o&=~m.FileChangeFilter.UPDATED),h?.ignoreCreateEvents&&(o&=~m.FileChangeFilter.ADDED),h?.ignoreDeleteEvents&&(o&=~m.FileChangeFilter.DELETED)),n.$watch(r.identifier.value,this.a,a.baseUri,{recursive:t,excludes:h?.excludes??[],filter:o},!!c),T.$dO.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class b{constructor($){this.a=$,this.session=this.a.session,this.b=new s.$Y(()=>this.a.created.map(P.URI.revive)),this.c=new s.$Y(()=>this.a.changed.map(P.URI.revive)),this.d=new s.$Y(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor($,r,a){this.j=$,this.k=r,this.l=a,this.a=new v.$qe,this.b=new v.$qe,this.c=new v.$qe,this.d=new v.$qe,this.g=new v.$se,this.h=new v.$se,this.i=new v.$se,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher($,r,a,h){return new I(this.j,$,r,this.a.event,R.GlobPattern.from(a),h)}$onFileEvent($){this.a.fire(new b($))}$onDidRunFileOperation($,r){switch($){case m.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(a=>({oldUri:P.URI.revive(a.source),newUri:P.URI.revive(a.target)}))}));break;case m.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(a=>P.URI.revive(a.target))}));break;case m.FileOperation.CREATE:case m.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(a=>P.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent($){return this.m($,this.g)}getOnWillCreateFileEvent($){return this.m($,this.h)}getOnWillDeleteFileEvent($){return this.m($,this.i)}m($,r){return(a,h,c)=>{const i=function(t){a.call(h,t)};return i.extension=$,r.event(i,void 0,c)}}async $onWillRunFileOperation($,r,a,h){switch($){case m.FileOperation.MOVE:return await this.n(this.g,{files:r.map(c=>({oldUri:P.URI.revive(c.source),newUri:P.URI.revive(c.target)}))},a,h);case m.FileOperation.DELETE:return await this.n(this.i,{files:r.map(c=>P.URI.revive(c.target))},a,h);case m.FileOperation.CREATE:case m.FileOperation.COPY:return await this.n(this.h,{files:r.map(c=>P.URI.revive(c.target))},a,h)}}async n($,r,a,h){const c=new Set,i=[];if(await $.fireAsync(r,h,async(t,o)=>{const l=Date.now(),g=await Promise.resolve(t);g instanceof T.$pO&&(i.push([o.extension,g]),c.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-l>a&&this.k.warn("SLOW file-participant",o.extension.identifier)}),h.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,t]of i){const{edits:o}=R.WorkspaceEdit.from(t,{getTextDocumentVersion:l=>this.l.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(o)}return{edit:n,extensionNames:Array.from(c)}}}e.$rsc=u}),define(Re[243],Oe([1,0,17,10,19,12,97,4,25,69,13,14,2,32,286,94,104,9,18,8,7,21,80,5]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n,t,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crc=void 0,r=Ve(r),i=Ve(i),l=Ve(l);class g{constructor(q,B){this.d=q,this.e=B}async provideDocumentSymbols(q,B){const H=this.d.getDocument(q),Q=await this.e.provideDocumentSymbols(H,B);if(!(0,v.$Ob)(Q))return Q[0]instanceof n.$zO?Q.map(i.DocumentSymbol.from):g.f(Q)}static f(q){q=q.slice(0).sort((Q,se)=>{let ge=Q.location.range.start.compareTo(se.location.range.start);return ge===0&&(ge=se.location.range.end.compareTo(Q.location.range.end)),ge});const B=[],H=[];for(const Q of q){const se={name:Q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Q.kind),tags:Q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:i.Range.from(Q.location.range),selectionRange:i.Range.from(Q.location.range),children:[]};for(;;){if(H.length===0){H.push(se),B.push(se);break}const ge=H[H.length-1];if(k.$Yt.containsRange(ge.range,se.range)&&!k.$Yt.equalsRange(ge.range,se.range)){ge.children?.push(se),H.push(se);break}H.pop()}}return B}}class f{constructor(q,B,H,Q,se,ge){this.f=q,this.g=B,this.h=H,this.j=Q,this.k=se,this.l=ge,this.d=new o.$5qc("CodeLens"),this.e=new Map}async provideCodeLenses(q,B){const H=this.f.getDocument(q),Q=await this.h.provideCodeLenses(H,B);if(!Q||B.isCancellationRequested)return;const se=this.d.add(Q),ge=new T.$Yc;this.e.set(se,ge);const Ee={cacheId:se,lenses:[]};for(let ze=0;ze<Q.length;ze++)Ee.lenses.push({cacheId:[se,ze],range:i.Range.from(Q[ze].range),command:this.g.toInternal(Q[ze].command,ge)});return Ee}async resolveCodeLens(q,B){const H=q.cacheId&&this.d.get(...q.cacheId);if(!H)return;let Q;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?Q=H:Q=await this.h.resolveCodeLens(H,B),Q||(Q=H),B.isCancellationRequested)return;const se=q.cacheId&&this.e.get(q.cacheId[0]);if(se){if(!Q.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ge),this.l.error(ge);return}return q.command=this.g.toInternal(Q.command,se),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function d(Me){return Array.isArray(Me)?Me.map(i.DefinitionLink.from):Me?[i.DefinitionLink.from(Me)]:[]}class S{constructor(q,B){this.d=q,this.e=B}async provideDefinition(q,B,H){const Q=this.d.getDocument(q),se=i.Position.to(B),ge=await this.e.provideDefinition(Q,se,H);return d(ge)}}class E{constructor(q,B){this.d=q,this.e=B}async provideDeclaration(q,B,H){const Q=this.d.getDocument(q),se=i.Position.to(B),ge=await this.e.provideDeclaration(Q,se,H);return d(ge)}}class y{constructor(q,B){this.d=q,this.e=B}async provideImplementation(q,B,H){const Q=this.d.getDocument(q),se=i.Position.to(B),ge=await this.e.provideImplementation(Q,se,H);return d(ge)}}class C{constructor(q,B){this.d=q,this.e=B}async provideTypeDefinition(q,B,H){const Q=this.d.getDocument(q),se=i.Position.to(B),ge=await this.e.provideTypeDefinition(Q,se,H);return d(ge)}}class O{static{this.f=10}constructor(q,B){this.g=q,this.h=B,this.d=0,this.e=new Map}async provideHover(q,B,H,Q){const se=this.g.getDocument(q),ge=i.Position.to(B);let Ee;if(H&&H.verbosityRequest){const tt=H.verbosityRequest.previousHover.id,ct=this.e.get(tt);if(!ct)throw new Error(`Hover with id ${tt} not found`);const it={verbosityDelta:H.verbosityRequest.verbosityDelta,previousHover:ct};Ee=await this.h.provideHover(se,ge,Q,it)}else Ee=await this.h.provideHover(se,ge,Q);if(!Ee||(0,v.$Ob)(Ee.contents))return;Ee.range||(Ee.range=se.getWordRangeAtPosition(ge)),Ee.range||(Ee.range=new n.$fO(ge,ge));const ze=i.Hover.from(Ee),Je=this.d;if(this.e.size===O.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Je,Ee),this.d+=1,{...ze,id:Je}}releaseHover(q){this.e.delete(q)}}class p{constructor(q,B){this.d=q,this.e=B}async provideEvaluatableExpression(q,B,H){const Q=this.d.getDocument(q),se=i.Position.to(B),ge=await this.e.provideEvaluatableExpression(Q,se,H);if(ge)return i.EvaluatableExpression.from(ge)}}class w{constructor(q,B){this.d=q,this.e=B}async provideInlineValues(q,B,H,Q){const se=this.d.getDocument(q),ge=await this.e.provideInlineValues(se,i.Range.to(B),i.InlineValueContext.to(H),Q);if(Array.isArray(ge))return ge.map(Ee=>i.InlineValue.from(Ee))}}class M{constructor(q,B){this.d=q,this.e=B}async provideDocumentHighlights(q,B,H){const Q=this.d.getDocument(q),se=i.Position.to(B),ge=await this.e.provideDocumentHighlights(Q,se,H);if(Array.isArray(ge))return ge.map(i.DocumentHighlight.from)}}class A{constructor(q,B){this.d=q,this.e=B}async provideMultiDocumentHighlights(q,B,H,Q){const se=this.d.getDocument(q),ge=H.map(Je=>this.d.getDocument(Je)),Ee=i.Position.to(B),ze=await this.e.provideMultiDocumentHighlights(se,Ee,ge,Q);if(Array.isArray(ze))return ze.map(i.MultiDocumentHighlight.from)}}class F{constructor(q,B){this.d=q,this.e=B}async provideLinkedEditingRanges(q,B,H){const Q=this.d.getDocument(q),se=i.Position.to(B),ge=await this.e.provideLinkedEditingRanges(Q,se,H);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,v.$Lb)(ge.ranges.map(i.Range.from)),wordPattern:ge.wordPattern}}}class G{constructor(q,B){this.d=q,this.e=B}async provideReferences(q,B,H,Q){const se=this.d.getDocument(q),ge=i.Position.to(B),Ee=await this.e.provideReferences(se,ge,H,Q);if(Array.isArray(Ee))return Ee.map(i.location.from)}}class x{static{this.d=1e3}constructor(q,B,H,Q,se,ge,Ee){this.g=q,this.h=B,this.j=H,this.k=Q,this.l=se,this.m=ge,this.n=Ee,this.e=new o.$5qc("CodeAction"),this.f=new Map}async provideCodeActions(q,B,H,Q){const se=this.g.getDocument(q),ge=$.$1t.isISelection(B)?i.Selection.to(B):i.Range.to(B),Ee=[];for(const it of this.j.getDiagnostics(q))if(ge.intersection(it.range)&&Ee.push(it)>x.d)break;const ze={diagnostics:Ee,only:H.only?new n.$BO(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},Je=await this.k.provideCodeActions(se,ge,ze,Q);if(!(0,v.$Pb)(Je)||Q.isCancellationRequested)return;const _e=this.e.add(Je),tt=new T.$Yc;this.f.set(_e,tt);const ct=[];for(let it=0;it<Je.length;it++){const at=Je[it];if(at)if(x.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ct.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,tt)});else{ze.only&&(at.kind?ze.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const yt=at.ranges??[];ct.push({cacheId:[_e,it],title:at.title,command:at.command&&this.h.toInternal(at.command,tt),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.$CH)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,t.$CH)(this.m,"codeActionRanges")?(0,v.$Lb)(yt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:_e,actions:ct}}async resolveCodeAction(q,B){const[H,Q]=q,se=this.e.get(H,Q);if(!se||x.o(se))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(se,B)??se;let Ee;ge.edit&&(Ee=i.WorkspaceEdit.from(ge.edit,void 0));let ze;if(ge.command){const Je=this.f.get(H);Je&&(ze=this.h.toInternal(ge.command,Je))}return{edit:Ee,command:ze}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class j{constructor(q,B,H,Q,se){this.e=q,this.f=B,this.g=H,this.h=Q,this.j=se,this.d=new o.$5qc("DocumentPasteEdit")}async prepareDocumentPaste(q,B,H,Q){if(!this.g.prepareDocumentPaste)return;const se=this.f.getDocument(q),ge=B.map(Je=>i.Range.to(Je)),Ee=i.DataTransfer.toDataTransfer(H,()=>{throw new L.$cb});if(await this.g.prepareDocumentPaste(se,ge,Ee,Q),Q.isCancellationRequested)return;const ze=Array.from(Ee).filter(([,Je])=>!(Je instanceof n.$8O));return i.DataTransfer.from(ze)}async providePasteEdits(q,B,H,Q,se,ge){if(!this.g.provideDocumentPasteEdits)return[];const Ee=this.f.getDocument(B),ze=H.map(ct=>i.Range.to(ct)),Je=i.DataTransfer.toDataTransfer(Q,async ct=>(await this.e.$resolvePasteFileData(this.h,q,ct)).buffer),_e=await this.g.provideDocumentPasteEdits(Ee,ze,Je,{only:se.only?new n.$aP(se.only):void 0,triggerKind:se.triggerKind},ge);if(!_e||ge.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((ct,it)=>({_cacheId:[tt,it],title:ct.title??(0,h.localize)(2704,null,this.j.displayName||this.j.name),kind:ct.kind,yieldTo:ct.yieldTo?.map(at=>at.value),insertText:typeof ct.insertText=="string"?ct.insertText:{snippet:ct.insertText.value},additionalEdit:ct.additionalEdit?i.WorkspaceEdit.from(ct.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,B){const[H,Q]=q,se=this.d.get(H,Q);if(!se||!this.g.resolveDocumentPasteEdit)return{};const ge=await this.g.resolveDocumentPasteEdit(se,B)??se;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class U{constructor(q,B){this.d=q,this.e=B}async provideDocumentFormattingEdits(q,B,H){const Q=this.d.getDocument(q),se=await this.e.provideDocumentFormattingEdits(Q,B,H);if(Array.isArray(se))return se.map(i.TextEdit.from)}}class J{constructor(q,B){this.d=q,this.e=B}async provideDocumentRangeFormattingEdits(q,B,H,Q){const se=this.d.getDocument(q),ge=i.Range.to(B),Ee=await this.e.provideDocumentRangeFormattingEdits(se,ge,H,Q);if(Array.isArray(Ee))return Ee.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,B,H,Q){(0,b.$tg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const se=this.d.getDocument(q),ge=B.map(i.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(se,ge,H,Q);if(Array.isArray(Ee))return Ee.map(i.TextEdit.from)}}class Z{constructor(q,B){this.d=q,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,B,H,Q,se){const ge=this.d.getDocument(q),Ee=i.Position.to(B),ze=await this.e.provideOnTypeFormattingEdits(ge,Ee,H,Q,se);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class ae{constructor(q,B){this.e=q,this.f=B,this.d=new o.$5qc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,B){const H=await this.e.provideWorkspaceSymbols(q,B);if(!(0,v.$Pb)(H))return{symbols:[]};const Q=this.d.add(H),se={cacheId:Q,symbols:[]};for(let ge=0;ge<H.length;ge++){const Ee=H[ge];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}se.symbols.push({...i.WorkspaceSymbol.from(Ee),cacheId:[Q,ge]})}return se}async resolveWorkspaceSymbol(q,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const H=this.d.get(...q.cacheId);if(H){const Q=await this.e.resolveWorkspaceSymbol(H,B);return Q&&(0,m.$po)(q,i.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class ee{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,B,H){this.d=q,this.e=B,this.f=H}async provideRenameEdits(q,B,H,Q){const se=this.d.getDocument(q),ge=i.Position.to(B);try{const Ee=await this.e.provideRenameEdits(se,ge,H,Q);return Ee?i.WorkspaceEdit.from(Ee):void 0}catch(Ee){const ze=ee.g(Ee);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(q,B,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(q),se=i.Position.to(B);try{const ge=await this.e.prepareRename(Q,se,H);let Ee,ze;if(n.$fO.isRange(ge)?(Ee=ge,ze=Q.getText(ge)):(0,b.$lg)(ge)&&(Ee=ge.range,ze=ge.placeholder),!Ee||!ze)return;if(Ee.start.line>se.line||Ee.end.line<se.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ee),text:ze}}catch(ge){const Ee=ee.g(ge);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(ge)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class oe{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:n.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:n.NewSymbolNameTriggerKind.Automatic}}constructor(q,B,H){this.e=q,this.f=B,this.g=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(q,B,H,Q){const se=this.e.getDocument(q),ge=i.Range.to(B);try{const Ee=oe.d[H],ze=await this.f.provideNewSymbolNames(se,ge,Ee,Q);return ze?ze.map(Je=>typeof Je=="string"?{newSymbolName:Je}:{newSymbolName:Je.newSymbolName,tags:Je.tags}):void 0}catch(Ee){this.g.error(oe.h(Ee)??JSON.stringify(Ee,null,"	"));return}}static h(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ie{constructor(q,B){this.resultId=q,this.tokens=B}}class ue{constructor(q,B){this.f=q,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,B,H){const Q=this.f.getDocument(q),se=B!==0?this.d.get(B):null;let ge=typeof se?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,se.resultId,H):await this.g.provideDocumentSemanticTokens(Q,H);return se&&this.d.delete(B),ge?(ge=ue.h(ge),this.o(ue.n(se,ge),ge)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return ue.j(q)?ue.k(q)?q:new n.$AP(new Uint32Array(q.data),q.resultId):ue.l(q)?ue.m(q)?q:new n.$CP(q.edits.map(B=>new n.$BP(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const B of q.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(q,B){if(!ue.j(B)||!q||!q.tokens)return B;const H=q.tokens,Q=H.length,se=B.data,ge=se.length;let Ee=0;const ze=Math.min(Q,ge);for(;Ee<ze&&H[Ee]===se[Ee];)Ee++;if(Ee===Q&&Ee===ge)return new n.$CP([],B.resultId);let Je=0;const _e=ze-Ee;for(;Je<_e&&H[Q-Je-1]===se[ge-Je-1];)Je++;return new n.$CP([{start:Ee,deleteCount:Q-Ee-Je,data:se.subarray(Ee,ge-Je)}],B.resultId)}o(q,B){if(ue.j(q)){const H=this.e++;return this.d.set(H,new ie(q.resultId,q.data)),(0,a.$Feb)({id:H,type:"full",data:q.data})}if(ue.l(q)){const H=this.e++;return ue.j(B)?this.d.set(H,new ie(B.resultId,B.data)):this.d.set(H,new ie(q.resultId)),(0,a.$Feb)({id:H,type:"delta",deltas:(q.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class _{constructor(q,B){this.d=q,this.e=B}async provideDocumentRangeSemanticTokens(q,B,H){const Q=this.d.getDocument(q),se=await this.e.provideDocumentRangeSemanticTokens(Q,i.Range.to(B),H);return se?this.f(se):null}f(q){return(0,a.$Feb)({id:0,type:"full",data:q.data})}}class $e{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,B,H,Q,se){this.f=q,this.g=B,this.h=H,this.j=Q,this.k=se,this.d=new o.$5qc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,B,H,Q){const se=this.f.getDocument(q),ge=i.Position.to(B),Ee=se.getWordRangeAtPosition(ge)||new n.$fO(ge,ge),ze=Ee.with({end:ge}),Je=new s.$ke,_e=await this.h.provideCompletionItems(se,ge,Q,i.CompletionContext.to(H));if(!_e||Q.isCancellationRequested)return;const tt=Array.isArray(_e)?new n.$OO(_e):_e,ct=$e.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),it=new T.$Yc;this.e.set(ct,it);const at=[],yt={x:ct,[l.ISuggestResultDtoField.completions]:at,[l.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ee),insert:i.Range.from(ze)},[l.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[l.ISuggestResultDtoField.duration]:Je.elapsed()};for(let Ye=0;Ye<tt.items.length;Ye++){const he=tt.items[Ye],pe=this.l(he,[ct,Ye],ze,Ee);at.push(pe)}return yt}async resolveCompletionItem(q,B){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...q);if(!H)return;const Q=this.l(H,q),se=await this.h.resolveCompletionItem(H,B);if(!se)return;const ge=this.l(se,q);return(Q[l.ISuggestDataDtoField.insertText]!==ge[l.ISuggestDataDtoField.insertText]||Q[l.ISuggestDataDtoField.insertTextRules]!==ge[l.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q[l.ISuggestDataDtoField.commandIdent]!==ge[l.ISuggestDataDtoField.commandIdent]||Q[l.ISuggestDataDtoField.commandId]!==ge[l.ISuggestDataDtoField.commandId]||!(0,m.$qo)(Q[l.ISuggestDataDtoField.commandArguments],ge[l.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,[l.ISuggestDataDtoField.documentation]:ge[l.ISuggestDataDtoField.documentation],[l.ISuggestDataDtoField.detail]:ge[l.ISuggestDataDtoField.detail],[l.ISuggestDataDtoField.additionalTextEdits]:ge[l.ISuggestDataDtoField.additionalTextEdits],[l.ISuggestDataDtoField.insertText]:ge[l.ISuggestDataDtoField.insertText],[l.ISuggestDataDtoField.insertTextRules]:ge[l.ISuggestDataDtoField.insertTextRules],[l.ISuggestDataDtoField.commandIdent]:ge[l.ISuggestDataDtoField.commandIdent],[l.ISuggestDataDtoField.commandId]:ge[l.ISuggestDataDtoField.commandId],[l.ISuggestDataDtoField.commandArguments]:ge[l.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,B,H,Q){const se=this.e.get(B[0]);if(!se)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(q.command,se),Ee={x:B,[l.ISuggestDataDtoField.label]:q.label,[l.ISuggestDataDtoField.kind]:q.kind!==void 0?i.CompletionItemKind.from(q.kind):void 0,[l.ISuggestDataDtoField.kindModifier]:q.tags&&q.tags.map(i.CompletionItemTag.from),[l.ISuggestDataDtoField.detail]:q.detail,[l.ISuggestDataDtoField.documentation]:typeof q.documentation>"u"?void 0:i.MarkdownString.fromStrict(q.documentation),[l.ISuggestDataDtoField.sortText]:q.sortText!==q.label?q.sortText:void 0,[l.ISuggestDataDtoField.filterText]:q.filterText!==q.label?q.filterText:void 0,[l.ISuggestDataDtoField.preselect]:q.preselect||void 0,[l.ISuggestDataDtoField.insertTextRules]:q.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[l.ISuggestDataDtoField.commitCharacters]:q.commitCharacters?.join(""),[l.ISuggestDataDtoField.additionalTextEdits]:q.additionalTextEdits&&q.additionalTextEdits.map(i.TextEdit.from),[l.ISuggestDataDtoField.commandIdent]:ge?.$ident,[l.ISuggestDataDtoField.commandId]:ge?.id,[l.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee[l.ISuggestDataDtoField.insertText]=q.textEdit.newText):typeof q.insertText=="string"?Ee[l.ISuggestDataDtoField.insertText]=q.insertText:q.insertText instanceof n.$qO&&(Ee[l.ISuggestDataDtoField.insertText]=q.insertText.value,Ee[l.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let ze;return q.textEdit?ze=q.textEdit.range:q.range&&(ze=q.range),n.$fO.isRange(ze)?Ee[l.ISuggestDataDtoField.range]=i.Range.from(ze):ze&&(!H?.isEqual(ze.inserting)||!Q?.isEqual(ze.replacing))&&(Ee[l.ISuggestDataDtoField.range]={insert:i.Range.from(ze.inserting),replace:i.Range.from(ze.replacing)}),Ee}}class Ie{async provideInlineCompletions(q,B,H,Q){}async provideInlineEdits(q,B,H,Q){}disposeCompletions(q){}handleDidShowCompletionItem(q,B,H){}handlePartialAccept(q,B,H,Q){}}class X extends Ie{constructor(q,B,H,Q){super(),this.f=q,this.g=B,this.h=H,this.j=Q,this.d=new re,this.e=(0,t.$CH)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:n.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:n.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$CH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,B,H,Q){const se=this.g.getDocument(q),ge=i.Position.to(B),Ee=await this.h.provideInlineCompletionItems(se,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},Q);if(!Ee||Q.isCancellationRequested)return;const ze=Array.isArray(Ee)?Ee:Ee.items,Je=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((it,at)=>{let yt;it.command&&(tt||(tt=new T.$Yc),yt=this.j.toInternal(it.command,tt));const Ye=it.insertText;return{insertText:typeof Ye=="string"?Ye:{snippet:Ye.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:yt,idx:at,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Je.map(it=>(tt||(tt=new T.$Yc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(q,B,H,Q){if(!this.h.provideInlineEdits)return;(0,t.$DH)(this.f,"inlineCompletionsAdditions");const se=this.g.getDocument(q),ge=i.Range.to(B),Ee=await this.h.provideInlineEdits(se,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind],userPrompt:H.userPrompt},Q);if(!Ee||Q.isCancellationRequested)return;const ze=Array.isArray(Ee)?Ee:Ee.items,Je=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((it,at)=>{let yt;it.command&&(tt||(tt=new T.$Yc),yt=this.j.toInternal(it.command,tt));const Ye=it.insertText;return{insertText:typeof Ye=="string"?Ye:{snippet:Ye.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:yt,idx:at,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Je.map(it=>(tt||(tt=new T.$Yc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,B,H){const Q=this.d.get(q)?.items[B];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,H)}handlePartialAccept(q,B,H,Q){const se=this.d.get(q)?.items[B];se&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(se,H),this.h.handleDidPartiallyAcceptCompletionItem(se,i.PartialAcceptInfo.to(Q)))}}class V{async provideInlineEdits(q,B,H){const Q=this.f.getDocument(q),se=await this.g.provideInlineEdit(Q,{triggerKind:this.e[B.triggerKind]},H);if(!se||H.isCancellationRequested)return;let ge;const Ee=this.d.createReferenceId({dispose(){ge?.dispose()},item:se});let ze;se.accepted&&(ge||(ge=new T.$Yc),ze=this.h.toInternal(se.accepted,ge));let Je;return se.rejected&&(ge||(ge=new T.$Yc),Je=this.h.toInternal(se.rejected,ge)),{pid:Ee,text:se.text,range:i.Range.from(se.range),accepted:ze,rejected:Je}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,B,H,Q){this.f=B,this.g=H,this.h=Q,this.d=new re,this.e={[r.InlineEditTriggerKind.Automatic]:n.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:n.InlineEditTriggerKind.Invoke}}}class re{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const B=this.e++;return this.d.set(B,q),B}disposeReferenceId(q){const B=this.d.get(q);return this.d.delete(q),B}get(q){return this.d.get(q)}}class we{constructor(q,B){this.e=q,this.f=B,this.d=new o.$5qc("SignatureHelp")}async provideSignatureHelp(q,B,H,Q){const se=this.e.getDocument(q),ge=i.Position.to(B),Ee=this.g(H),ze=await this.f.provideSignatureHelp(se,ge,Q,Ee);if(ze){const Je=this.d.add([ze]);return{...i.SignatureHelp.from(ze),id:Je}}}g(q){let B;if(q.activeSignatureHelp){const H=i.SignatureHelp.to(q.activeSignatureHelp),Q=this.d.get(q.activeSignatureHelp.id,0);Q?(B=Q,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...q,activeSignatureHelp:B}}releaseSignatureHelp(q){this.d.delete(q)}}class Pe{constructor(q,B,H,Q,se){this.f=q,this.g=B,this.h=H,this.j=Q,this.k=se,this.d=new o.$5qc("InlayHints"),this.e=new Map}async provideInlayHints(q,B,H){const Q=this.f.getDocument(q),se=i.Range.to(B),ge=await this.h.provideInlayHints(Q,se,H);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`);return}if(H.isCancellationRequested)return;const Ee=this.d.add(ge);this.e.set(Ee,new T.$Yc);const ze={hints:[],cacheId:Ee};for(let Je=0;Je<ge.length;Je++)this.l(ge[Je],se)&&ze.hints.push(this.m(ge[Je],[Ee,Je]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`),ze}async resolveInlayHint(q,B){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...q);if(!H)return;const Q=await this.h.resolveInlayHint(H,B);if(Q&&this.l(Q))return this.m(Q,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,B){return q.label.length===0||Array.isArray(q.label)&&q.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(B&&!B.contains(q.position))}m(q,B){const H=this.e.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:B,tooltip:i.MarkdownString.fromStrict(q.tooltip),position:i.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(i.TextEdit.from),kind:q.kind&&i.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")Q.label=q.label;else{const se=[];Q.label=se;for(const ge of q.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:ge.value,tooltip:i.MarkdownString.fromStrict(ge.tooltip)};n.$rO.isLocation(ge.location)&&(Ee.location=i.location.from(ge.location)),ge.command&&(Ee.command=this.g.toInternal(ge.command,H)),se.push(Ee)}}return Q}}class Fe{constructor(q,B){this.e=q,this.f=B,this.d=new o.$5qc("DocumentLink")}async provideLinks(q,B){const H=this.e.getDocument(q),Q=await this.f.provideDocumentLinks(H,B);if(!(!Array.isArray(Q)||Q.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(Fe.g).map(i.DocumentLink.from)};{const se=this.d.add(Q),ge={links:[],cacheId:se};for(let Ee=0;Ee<Q.length;Ee++){if(!Fe.g(Q[Ee]))continue;const ze=i.DocumentLink.from(Q[Ee]);ze.cacheId=[se,Ee],ge.links.push(ze)}return ge}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,B){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...q);if(!H)return;const Q=await this.f.resolveDocumentLink(H,B);if(!(!Q||!Fe.g(Q)))return i.DocumentLink.from(Q)}releaseLinks(q){this.d.delete(q)}}class Be{constructor(q,B){this.d=q,this.e=B}async provideColors(q,B){const H=this.d.getDocument(q),Q=await this.e.provideDocumentColors(H,B);return Array.isArray(Q)?Q.map(ge=>({color:i.Color.from(ge.color),range:i.Range.from(ge.range)})):[]}async provideColorPresentations(q,B,H){const Q=this.d.getDocument(q),se=i.Range.to(B.range),ge=i.Color.to(B.color),Ee=await this.e.provideColorPresentations(ge,{document:Q,range:se},H);if(Array.isArray(Ee))return Ee.map(i.ColorPresentation.from)}}class xe{constructor(q,B){this.d=q,this.e=B}async provideFoldingRanges(q,B,H){const Q=this.d.getDocument(q),se=await this.e.provideFoldingRanges(Q,B,H);if(Array.isArray(se))return se.map(i.FoldingRange.from)}}class nt{constructor(q,B,H){this.d=q,this.e=B,this.f=H}async provideSelectionRanges(q,B,H){const Q=this.d.getDocument(q),se=B.map(i.Position.to),ge=await this.e.provideSelectionRanges(Q,se,H);if(!(0,v.$Pb)(ge))return[];if(ge.length!==se.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let ze=0;ze<se.length;ze++){const Je=[];Ee.push(Je);let _e=se[ze],tt=ge[ze];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Je.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ee}}class ht{constructor(q,B){this.f=q,this.g=B,this.d=new R.$TQ(""),this.e=new Map}async prepareSession(q,B,H){const Q=this.f.getDocument(q),se=i.Position.to(B),ge=await this.g.prepareCallHierarchy(Q,se,H);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ee,ze)):[this.h(Ee,ge)]}async provideCallsTo(q,B,H){const Q=this.j(q,B);if(!Q)throw new Error("missing call hierarchy item");const se=await this.g.provideCallHierarchyIncomingCalls(Q,H);if(se)return se.map(ge=>({from:this.h(q,ge.from),fromRanges:ge.fromRanges.map(Ee=>i.Range.from(Ee))}))}async provideCallsFrom(q,B,H){const Q=this.j(q,B);if(!Q)throw new Error("missing call hierarchy item");const se=await this.g.provideCallHierarchyOutgoingCalls(Q,H);if(se)return se.map(ge=>({to:this.h(q,ge.to),fromRanges:ge.fromRanges.map(Ee=>i.Range.from(Ee))}))}releaseSession(q){this.e.delete(q)}h(q,B){const H=this.e.get(q),Q=i.CallHierarchyItem.from(B,q,H.size.toString(36));return H.set(Q._itemId,B),Q}j(q,B){return this.e.get(q)?.get(B)}}class $t{constructor(q,B){this.f=q,this.g=B,this.d=new R.$TQ(""),this.e=new Map}async prepareSession(q,B,H){const Q=this.f.getDocument(q),se=i.Position.to(B),ge=await this.g.prepareTypeHierarchy(Q,se,H);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ee,ze)):[this.h(Ee,ge)]}async provideSupertypes(q,B,H){const Q=this.j(q,B);if(!Q)throw new Error("missing type hierarchy item");const se=await this.g.provideTypeHierarchySupertypes(Q,H);if(se)return se.map(ge=>this.h(q,ge))}async provideSubtypes(q,B,H){const Q=this.j(q,B);if(!Q)throw new Error("missing type hierarchy item");const se=await this.g.provideTypeHierarchySubtypes(Q,H);if(se)return se.map(ge=>this.h(q,ge))}releaseSession(q){this.e.delete(q)}h(q,B){const H=this.e.get(q),Q=i.TypeHierarchyItem.from(B,q,H.size.toString(36));return H.set(Q._itemId,B),Q}j(q,B){return this.e.get(q)?.get(B)}}class ut{constructor(q,B,H,Q,se){this.e=q,this.f=B,this.g=H,this.h=Q,this.j=se,this.d=new o.$5qc("DocumentDropEdit")}async provideDocumentOnDropEdits(q,B,H,Q,se){const ge=this.f.getDocument(B),Ee=i.Position.to(H),ze=i.DataTransfer.toDataTransfer(Q,async ct=>(await this.e.$resolveDocumentOnDropFileData(this.h,q,ct)).buffer),Je=await this.g.provideDocumentDropEdits(ge,Ee,ze,se);if(!Je)return;const _e=(0,v.$6b)(Je),tt=this.d.add(_e);return _e.map((ct,it)=>({_cacheId:[tt,it],title:ct.title??(0,h.localize)(2705,null,this.j.displayName||this.j.name),kind:ct.kind?.value,yieldTo:ct.yieldTo?.map(at=>at.value),insertText:typeof ct.insertText=="string"?ct.insertText:{snippet:ct.insertText.value},additionalEdit:ct.additionalEdit?i.WorkspaceEdit.from(ct.additionalEdit,void 0):void 0}))}async resolveDropEdit(q,B){const[H,Q]=q,se=this.d.get(H,Q);if(!se||!this.g.resolveDocumentDropEdit)return{};const ge=await this.g.resolveDocumentDropEdit(se,B)??se;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(q){this.d.delete(q)}}class et{constructor(q,B){this.d=q,this.e=B}async provideMappedEdits(q,B,H,Q){const se=u.URI.revive(q),ge=this.d.getDocument(se),Ee=H.documents.map(_e=>_e.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(ct=>i.Range.to(ct))}))),ze={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},Je=await this.e.provideMappedEdits(ge,B,ze,Q);return Je?i.WorkspaceEdit.from(Je):null}}class Le{constructor(q,B){this.adapter=q,this.extension=B}}class Ne{static{this.d=0}constructor(q,B,H,Q,se,ge,Ee,ze){this.g=B,this.h=H,this.j=Q,this.k=se,this.l=ge,this.m=Ee,this.n=ze,this.f=new Map,this.e=q.getProxy(l.$bO.MainThreadLanguageFeatures)}o(q,B){return i.DocumentSelector.from(q,this.g,B)}p(q){return new n.$dO(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Ne.d++}async s(q,B,H,Q,se,ge=!1){const Ee=this.f.get(q);if(!Ee||!(Ee.adapter instanceof B))return Q;const ze=Date.now();ge||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Je=H(Ee.adapter,Ee.extension);return Promise.resolve(Je).catch(_e=>{(0,L.$8)(_e)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ee.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),P.CancellationToken.isCancellationToken(se)?(0,D.$zh)(Je,se):Je}t(q,B){const H=this.q();return this.f.set(H,new Le(q,B)),H}static u(q){return q.displayName||q.name}static w(q){return q.identifier.value}registerDocumentSymbolProvider(q,B,H,Q){const se=this.t(new g(this.h,H),q),ge=Q&&Q.label||Ne.u(q);return this.e.$registerDocumentSymbolProvider(se,this.o(B,q),ge),this.p(se)}$provideDocumentSymbols(q,B,H){return this.s(q,g,Q=>Q.provideDocumentSymbols(u.URI.revive(B),H),void 0,H)}registerCodeLensProvider(q,B,H){const Q=this.q(),se=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new Le(new f(this.h,this.j.converter,H,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(Q,this.o(B,q),se);let ge=this.p(Q);if(se!==void 0){const Ee=H.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(se));ge=n.$dO.from(ge,Ee)}return ge}$provideCodeLenses(q,B,H){return this.s(q,f,Q=>Q.provideCodeLenses(u.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveCodeLens(q,B,H){return this.s(q,f,Q=>Q.resolveCodeLens(B,H),void 0,void 0,!0)}$releaseCodeLenses(q,B){this.s(q,f,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0,!0)}registerDefinitionProvider(q,B,H){const Q=this.t(new S(this.h,H),q);return this.e.$registerDefinitionSupport(Q,this.o(B,q)),this.p(Q)}$provideDefinition(q,B,H,Q){return this.s(q,S,se=>se.provideDefinition(u.URI.revive(B),H,Q),[],Q)}registerDeclarationProvider(q,B,H){const Q=this.t(new E(this.h,H),q);return this.e.$registerDeclarationSupport(Q,this.o(B,q)),this.p(Q)}$provideDeclaration(q,B,H,Q){return this.s(q,E,se=>se.provideDeclaration(u.URI.revive(B),H,Q),[],Q)}registerImplementationProvider(q,B,H){const Q=this.t(new y(this.h,H),q);return this.e.$registerImplementationSupport(Q,this.o(B,q)),this.p(Q)}$provideImplementation(q,B,H,Q){return this.s(q,y,se=>se.provideImplementation(u.URI.revive(B),H,Q),[],Q)}registerTypeDefinitionProvider(q,B,H){const Q=this.t(new C(this.h,H),q);return this.e.$registerTypeDefinitionSupport(Q,this.o(B,q)),this.p(Q)}$provideTypeDefinition(q,B,H,Q){return this.s(q,C,se=>se.provideTypeDefinition(u.URI.revive(B),H,Q),[],Q)}registerHoverProvider(q,B,H,Q){const se=this.t(new O(this.h,H),q);return this.e.$registerHoverProvider(se,this.o(B,q)),this.p(se)}$provideHover(q,B,H,Q,se){return this.s(q,O,ge=>ge.provideHover(u.URI.revive(B),H,Q,se),void 0,se)}$releaseHover(q,B){this.s(q,O,H=>Promise.resolve(H.releaseHover(B)),void 0,void 0)}registerEvaluatableExpressionProvider(q,B,H,Q){const se=this.t(new p(this.h,H),q);return this.e.$registerEvaluatableExpressionProvider(se,this.o(B,q)),this.p(se)}$provideEvaluatableExpression(q,B,H,Q){return this.s(q,p,se=>se.provideEvaluatableExpression(u.URI.revive(B),H,Q),void 0,Q)}registerInlineValuesProvider(q,B,H,Q){const se=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new w(this.h,H),q);this.e.$registerInlineValuesProvider(ge,this.o(B,q),se);let Ee=this.p(ge);if(se!==void 0){const ze=H.onDidChangeInlineValues(Je=>this.e.$emitInlineValuesEvent(se));Ee=n.$dO.from(Ee,ze)}return Ee}$provideInlineValues(q,B,H,Q,se){return this.s(q,w,ge=>ge.provideInlineValues(u.URI.revive(B),H,Q,se),void 0,se)}registerDocumentHighlightProvider(q,B,H){const Q=this.t(new M(this.h,H),q);return this.e.$registerDocumentHighlightProvider(Q,this.o(B,q)),this.p(Q)}registerMultiDocumentHighlightProvider(q,B,H){const Q=this.t(new A(this.h,H),q);return this.e.$registerMultiDocumentHighlightProvider(Q,this.o(B,q)),this.p(Q)}$provideDocumentHighlights(q,B,H,Q){return this.s(q,M,se=>se.provideDocumentHighlights(u.URI.revive(B),H,Q),void 0,Q)}$provideMultiDocumentHighlights(q,B,H,Q,se){return this.s(q,A,ge=>ge.provideMultiDocumentHighlights(u.URI.revive(B),H,Q.map(Ee=>u.URI.revive(Ee)),se),void 0,se)}registerLinkedEditingRangeProvider(q,B,H){const Q=this.t(new F(this.h,H),q);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(B,q)),this.p(Q)}$provideLinkedEditingRanges(q,B,H,Q){return this.s(q,F,async se=>{const ge=await se.provideLinkedEditingRanges(u.URI.revive(B),H,Q);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Ne.y(ge.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(q,B,H){const Q=this.t(new G(this.h,H),q);return this.e.$registerReferenceSupport(Q,this.o(B,q)),this.p(Q)}$provideReferences(q,B,H,Q,se){return this.s(q,G,ge=>ge.provideReferences(u.URI.revive(B),H,Q,se),void 0,se)}registerCodeActionProvider(q,B,H,Q){const se=new T.$Yc,ge=this.t(new x(this.h,this.j.converter,this.k,H,this.l,q,this.m),q);return this.e.$registerCodeActionSupport(ge,this.o(B,q),{providedKinds:Q?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:Q?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,se)}))},Ne.u(q),Ne.w(q),!!H.resolveCodeAction),se.add(this.p(ge)),se}$provideCodeActions(q,B,H,Q,se){return this.s(q,x,ge=>ge.provideCodeActions(u.URI.revive(B),H,Q,se),void 0,se)}$resolveCodeAction(q,B,H){return this.s(q,x,Q=>Q.resolveCodeAction(B,H),{},void 0)}$releaseCodeActions(q,B){this.s(q,x,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(q,B,H){const Q=this.t(new U(this.h,H),q);return this.e.$registerDocumentFormattingSupport(Q,this.o(B,q),q.identifier,q.displayName||q.name),this.p(Q)}$provideDocumentFormattingEdits(q,B,H,Q){return this.s(q,U,se=>se.provideDocumentFormattingEdits(u.URI.revive(B),H,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(q,B,H){const Q=typeof H.provideDocumentRangesFormattingEdits=="function",se=this.t(new J(this.h,H),q);return this.e.$registerRangeFormattingSupport(se,this.o(B,q),q.identifier,q.displayName||q.name,Q),this.p(se)}$provideDocumentRangeFormattingEdits(q,B,H,Q,se){return this.s(q,J,ge=>ge.provideDocumentRangeFormattingEdits(u.URI.revive(B),H,Q,se),void 0,se)}$provideDocumentRangesFormattingEdits(q,B,H,Q,se){return this.s(q,J,ge=>ge.provideDocumentRangesFormattingEdits(u.URI.revive(B),H,Q,se),void 0,se)}registerOnTypeFormattingEditProvider(q,B,H,Q){const se=this.t(new Z(this.h,H),q);return this.e.$registerOnTypeFormattingSupport(se,this.o(B,q),Q,q.identifier),this.p(se)}$provideOnTypeFormattingEdits(q,B,H,Q,se,ge){return this.s(q,Z,Ee=>Ee.provideOnTypeFormattingEdits(u.URI.revive(B),H,Q,se,ge),void 0,ge)}registerWorkspaceSymbolProvider(q,B){const H=this.t(new ae(B,this.l),q);return this.e.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(q,B,H){return this.s(q,ae,Q=>Q.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(q,B,H){return this.s(q,ae,Q=>Q.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(q,B){this.s(q,ae,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(q,B,H){const Q=this.t(new ee(this.h,H,this.l),q);return this.e.$registerRenameSupport(Q,this.o(B,q),ee.supportsResolving(H)),this.p(Q)}$provideRenameEdits(q,B,H,Q,se){return this.s(q,ee,ge=>ge.provideRenameEdits(u.URI.revive(B),H,Q,se),void 0,se)}$resolveRenameLocation(q,B,H,Q){return this.s(q,ee,se=>se.resolveRenameLocation(u.URI.revive(B),H,Q),void 0,Q)}registerNewSymbolNamesProvider(q,B,H){const Q=this.t(new oe(this.h,H,this.l),q);return this.e.$registerNewSymbolNamesProvider(Q,this.o(B,q)),this.p(Q)}$supportsAutomaticNewSymbolNamesTriggerKind(q){return this.s(q,oe,B=>B.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(q,B,H,Q,se){return this.s(q,oe,ge=>ge.provideNewSymbolNames(u.URI.revive(B),H,Q,se),void 0,se)}registerDocumentSemanticTokensProvider(q,B,H,Q){const se=this.t(new ue(this.h,H),q),ge=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(se,this.o(B,q),Q,ge);let Ee=this.p(se);if(ge){const ze=H.onDidChangeSemanticTokens(Je=>this.e.$emitDocumentSemanticTokensEvent(ge));Ee=n.$dO.from(Ee,ze)}return Ee}$provideDocumentSemanticTokens(q,B,H,Q){return this.s(q,ue,se=>se.provideDocumentSemanticTokens(u.URI.revive(B),H,Q),null,Q)}$releaseDocumentSemanticTokens(q,B){this.s(q,ue,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,B,H,Q){const se=this.t(new _(this.h,H),q);return this.e.$registerDocumentRangeSemanticTokensProvider(se,this.o(B,q),Q),this.p(se)}$provideDocumentRangeSemanticTokens(q,B,H,Q){return this.s(q,_,se=>se.provideDocumentRangeSemanticTokens(u.URI.revive(B),H,Q),null,Q)}registerCompletionItemProvider(q,B,H,Q){const se=this.t(new $e(this.h,this.j.converter,H,this.m,q),q);return this.e.$registerCompletionsProvider(se,this.o(B,q),Q,$e.supportsResolving(H),q.identifier),this.p(se)}$provideCompletionItems(q,B,H,Q,se){return this.s(q,$e,ge=>ge.provideCompletionItems(u.URI.revive(B),H,Q,se),void 0,se)}$resolveCompletionItem(q,B,H){return this.s(q,$e,Q=>Q.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(q,B){this.s(q,$e,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(q,B,H,Q){const se=new X(q,this.h,H,this.j.converter),ge=this.t(se,q);return this.e.$registerInlineCompletionsSupport(ge,this.o(B,q),se.supportsHandleEvents,c.$zn.toKey(q.identifier.value),Q?.yieldTo?.map(Ee=>c.$zn.toKey(Ee))||[]),this.p(ge)}$provideInlineCompletions(q,B,H,Q,se){return this.s(q,Ie,ge=>ge.provideInlineCompletions(u.URI.revive(B),H,Q,se),void 0,se)}$provideInlineEdits(q,B,H,Q,se){return this.s(q,Ie,ge=>ge.provideInlineEdits(u.URI.revive(B),H,Q,se),void 0,se)}$handleInlineCompletionDidShow(q,B,H,Q){this.s(q,Ie,async se=>{se.handleDidShowCompletionItem(B,H,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,B,H,Q,se){this.s(q,Ie,async ge=>{ge.handlePartialAccept(B,H,Q,se)},void 0,void 0)}$freeInlineCompletionsList(q,B){this.s(q,Ie,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerInlineEditProvider(q,B,H){const Q=new V(q,this.h,H,this.j.converter),se=this.t(Q,q);return this.e.$registerInlineEditProvider(se,this.o(B,q),q.identifier),this.p(se)}$provideInlineEdit(q,B,H,Q){return this.s(q,V,se=>se.provideInlineEdits(u.URI.revive(B),H,Q),void 0,Q)}$freeInlineEdit(q,B){this.s(q,V,async H=>{H.disposeEdit(B)},void 0,void 0)}registerSignatureHelpProvider(q,B,H,Q){const se=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,ge=this.t(new we(this.h,H),q);return this.e.$registerSignatureHelpProvider(ge,this.o(B,q),se),this.p(ge)}$provideSignatureHelp(q,B,H,Q,se){return this.s(q,we,ge=>ge.provideSignatureHelp(u.URI.revive(B),H,Q,se),void 0,se)}$releaseSignatureHelp(q,B){this.s(q,we,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(q,B,H){const Q=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,se=this.t(new Pe(this.h,this.j.converter,H,this.l,q),q);this.e.$registerInlayHintsProvider(se,this.o(B,q),typeof H.resolveInlayHint=="function",Q,Ne.u(q));let ge=this.p(se);if(Q!==void 0){const Ee=H.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(Q));ge=n.$dO.from(ge,Ee)}return ge}$provideInlayHints(q,B,H,Q){return this.s(q,Pe,se=>se.provideInlayHints(u.URI.revive(B),H,Q),void 0,Q)}$resolveInlayHint(q,B,H){return this.s(q,Pe,Q=>Q.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(q,B){this.s(q,Pe,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(q,B,H){const Q=this.t(new Fe(this.h,H),q);return this.e.$registerDocumentLinkProvider(Q,this.o(B,q),typeof H.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(q,B,H){return this.s(q,Fe,Q=>Q.provideLinks(u.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(q,B,H){return this.s(q,Fe,Q=>Q.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(q,B){this.s(q,Fe,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(q,B,H){const Q=this.t(new Be(this.h,H),q);return this.e.$registerDocumentColorProvider(Q,this.o(B,q)),this.p(Q)}$provideDocumentColors(q,B,H){return this.s(q,Be,Q=>Q.provideColors(u.URI.revive(B),H),[],H)}$provideColorPresentations(q,B,H,Q){return this.s(q,Be,se=>se.provideColorPresentations(u.URI.revive(B),H,Q),void 0,Q)}registerFoldingRangeProvider(q,B,H){const Q=this.q(),se=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new Le(new xe(this.h,H),q)),this.e.$registerFoldingRangeProvider(Q,this.o(B,q),q.identifier,se);let ge=this.p(Q);if(se!==void 0){const Ee=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(se));ge=n.$dO.from(ge,Ee)}return ge}$provideFoldingRanges(q,B,H,Q){return this.s(q,xe,se=>se.provideFoldingRanges(u.URI.revive(B),H,Q),void 0,Q)}registerSelectionRangeProvider(q,B,H){const Q=this.t(new nt(this.h,H,this.l),q);return this.e.$registerSelectionRangeProvider(Q,this.o(B,q)),this.p(Q)}$provideSelectionRanges(q,B,H,Q){return this.s(q,nt,se=>se.provideSelectionRanges(u.URI.revive(B),H,Q),[],Q)}registerCallHierarchyProvider(q,B,H){const Q=this.t(new ht(this.h,H),q);return this.e.$registerCallHierarchyProvider(Q,this.o(B,q)),this.p(Q)}$prepareCallHierarchy(q,B,H,Q){return this.s(q,ht,se=>Promise.resolve(se.prepareSession(u.URI.revive(B),H,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(q,B,H,Q){return this.s(q,ht,se=>se.provideCallsTo(B,H,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(q,B,H,Q){return this.s(q,ht,se=>se.provideCallsFrom(B,H,Q),void 0,Q)}$releaseCallHierarchy(q,B){this.s(q,ht,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(q,B,H){const Q=this.t(new $t(this.h,H),q);return this.e.$registerTypeHierarchyProvider(Q,this.o(B,q)),this.p(Q)}$prepareTypeHierarchy(q,B,H,Q){return this.s(q,$t,se=>Promise.resolve(se.prepareSession(u.URI.revive(B),H,Q)),void 0,Q)}$provideTypeHierarchySupertypes(q,B,H,Q){return this.s(q,$t,se=>se.provideSupertypes(B,H,Q),void 0,Q)}$provideTypeHierarchySubtypes(q,B,H,Q){return this.s(q,$t,se=>se.provideSubtypes(B,H,Q),void 0,Q)}$releaseTypeHierarchy(q,B){this.s(q,$t,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(q,B,H,Q){const se=this.q();return this.f.set(se,new Le(new ut(this.e,this.h,H,se,q),q)),this.e.$registerDocumentOnDropEditProvider(se,this.o(B,q),(0,t.$CH)(q,"documentPaste")&&Q?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:Q.dropMimeTypes}:void 0),this.p(se)}$provideDocumentOnDropEdits(q,B,H,Q,se,ge){return this.s(q,ut,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(B,u.URI.revive(H),Q,se,ge)),void 0,void 0)}$resolveDropEdit(q,B,H){return this.s(q,ut,Q=>Q.resolveDropEdit(B,H),{},void 0)}$releaseDocumentOnDropEdits(q,B){this.s(q,ut,H=>Promise.resolve(H.releaseDropEdits(B)),void 0,void 0)}registerMappedEditsProvider(q,B,H){const Q=this.t(new et(this.h,H),q);return this.e.$registerMappedEditsProvider(Q,this.o(B,q),q.displayName??q.name),this.p(Q)}$provideMappedEdits(q,B,H,Q,se){return this.s(q,et,ge=>Promise.resolve(ge.provideMappedEdits(B,H,Q,se)),null,se)}registerDocumentPasteEditProvider(q,B,H,Q){const se=this.q();return this.f.set(se,new Le(new j(this.e,this.h,H,se,q),q)),this.e.$registerPasteEditProvider(se,this.o(B,q),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:Q.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(se)}$prepareDocumentPaste(q,B,H,Q,se){return this.s(q,j,ge=>ge.prepareDocumentPaste(u.URI.revive(B),H,Q,se),void 0,se)}$providePasteEdits(q,B,H,Q,se,ge,Ee){return this.s(q,j,ze=>ze.providePasteEdits(B,u.URI.revive(H),Q,se,ge,Ee),void 0,Ee)}$resolvePasteEdit(q,B,H){return this.s(q,j,Q=>Q.resolvePasteEdit(B,H),{},void 0)}$releasePasteEdits(q,B){this.s(q,j,H=>Promise.resolve(H.releasePasteEdits(B)),void 0,void 0)}static y(q){return{pattern:q.source,flags:q.flags}}static z(q){return{decreaseIndentPattern:Ne.y(q.decreaseIndentPattern),increaseIndentPattern:Ne.y(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ne.y(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ne.y(q.unIndentedLinePattern):void 0}}static B(q){return{beforeText:Ne.y(q.beforeText),afterText:q.afterText?Ne.y(q.afterText):void 0,previousLineText:q.previousLineText?Ne.y(q.previousLineText):void 0,action:q.action}}static C(q){return q.map(Ne.B)}static D(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(B=>n.SyntaxTokenType.toString(B)):void 0}}static E(q){return q.map(Ne.D)}setLanguageConfiguration(q,B,H){const{wordPattern:Q}=H;if(Q&&(0,I.$wf)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(B,Q):this.h.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const se=this.q(),ge={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Ne.y(H.wordPattern):void 0,indentationRules:H.indentationRules?Ne.z(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Ne.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Ne.E(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(se,B,ge),this.p(se)}$setWordDefinitions(q){for(const B of q)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.$crc=Ne}),define(Re[244],Oe([1,0,10,19,12,4,34,33,5,8]),function(be,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lsc=void 0,s=Ve(s);class I{constructor(u){this.a=new Map,this.c=new Map,this.d=new Map,this.b=u.getProxy(m.$bO.MainThreadLanguageModelTools),this.b.$getTools().then(k=>{for(const $ of k)this.d.set($.id,(0,R.$hi)($))})}async $countTokensForInvocation(u,k,$){const r=this.c.get(u);if(!r)throw new Error(`Tool invocation call ${u} not found`);return await r(k,$)}async invokeTool(u,k,$){const r=(0,T.$7g)();k.tokenOptions&&this.c.set(r,k.tokenOptions.countTokens);try{const a=await this.b.$invokeTool({toolId:u,callId:r,parameters:k.parameters,tokenBudget:k.tokenOptions?.tokenBudget},$);return s.LanguageModelToolResult.to(a)}finally{this.c.delete(r)}}$onDidChangeTools(u){this.d.clear();for(const k of u)this.d.set(k.id,k)}get tools(){return Array.from(this.d.values()).map(u=>s.LanguageModelToolDescription.to(u))}async $invokeTool(u,k){const $=this.a.get(u.toolId);if(!$)throw new Error(`Unknown tool ${u.toolId}`);const r={parameters:u.parameters};u.tokenBudget!==void 0&&(r.tokenOptions={tokenBudget:u.tokenBudget,countTokens:this.c.get(u.callId)||((h,c=D.CancellationToken.None)=>this.b.$countTokensForInvocation(u.callId,h,c))});const a=await(0,v.$yh)(Promise.resolve($.tool.invoke(r,k)),k);if(!a)throw new P.$9;for(const h of Object.keys(a))if(a[h]instanceof Promise)throw new Error(`Tool result for '${h}' cannot be a Promise`);return s.LanguageModelToolResult.from(a)}registerTool(u,k,$){return this.a.set(k,{extension:u,tool:$}),this.b.$registerTool(k),(0,L.$Xc)(()=>{this.a.delete(k),this.b.$unregisterTool(k)})}}e.$Lsc=I}),define(Re[95],Oe([1,0,10,19,42,12,6,41,4,9,18,3,11,77,5,91,16,8,7,119,21]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wrc=e.$Vrc=void 0,h=Ve(h),c=Ve(c),e.$Vrc=(0,b.$Ki)("IExtHostLanguageModels");class o{constructor(d,S){this.option=d,this.stream=new v.$bi,this.stream=S??new v.$bi}}class l{constructor(){this.a=new Map,this.b=new v.$bi,this.c=!1;const d=this;this.apiObject={get stream(){return d.b.asyncIterable},get text(){return v.$$h.map(d.b.asyncIterable,S=>{if(S instanceof c.$yQ)return S.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;let S=this.a.get(d.index);S||(this.a.size===0?S=new o(d.index,this.b):S=new o(d.index),this.a.set(d.index,S));let E;d.part.type==="text"?E=new c.$yQ(d.part.value):E=new c.$xQ(d.part.name,d.part.toolCallId,d.part.parameters),S.stream.emitOne(E)}reject(d){this.c=!0;for(const S of this.d())S.reject(d)}resolve(){this.c=!0;for(const d of this.d())d.resolve()}}let g=class{static{t=this}static{this.a=1}constructor(d,S,E){this.j=S,this.k=E,this.c=new R.$qe,this.d=new R.$qe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$Bn,this.i=new Map,this.s=new Set,this.b=d.getProxy($.$bO.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,S,E,y){const C=t.a++;this.f.set(C,{extension:d.identifier,provider:E,languageModelId:S});let O;y.auth&&(O={providerLabel:d.displayName||d.name,accountLabel:typeof y.auth=="object"?y.auth.label:void 0}),this.b.$registerLanguageModelProvider(C,`${I.$zn.toKey(d.identifier)}/${C}/${S}`,{extension:d.identifier,id:S,vendor:y.vendor??I.$zn.toKey(d.identifier),name:y.name??"",family:y.family??"",version:y.version,maxInputTokens:y.maxInputTokens,maxOutputTokens:y.maxOutputTokens,auth:O,targetExtensions:y.extensions});const p=E.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:M,tokenCount:A})=>{this.b.$whenLanguageModelChatRequestMade(S,new I.$zn(w),M,A)});return(0,m.$Xc)(()=>{this.f.delete(C),this.b.$unregisterProvider(C),p?.dispose()})}async $startChatRequest(d,S,E,y,C,O){const p=this.f.get(d);if(!p)throw new Error("Provider not found");const w=new k.$Kw(async A=>{if(O.isCancellationRequested){this.j.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let F;if(A.part instanceof c.$xQ?F={type:"tool_use",name:A.part.name,parameters:A.part.parameters,toolCallId:A.part.toolCallId}:A.part instanceof c.$yQ&&(F={type:"text",value:A.part.value}),!F){this.j.warn(`[CHAT](${p.extension.value}) UNKNOWN part ${JSON.stringify(A)}`);return}this.b.$reportResponsePart(S,{index:A.index,part:F})});let M;if(p.provider.provideLanguageModelResponse2)M=Promise.resolve(p.provider.provideLanguageModelResponse2(y.map(h.LanguageModelChatMessage.to),C,I.$zn.toKey(E),w,O));else{const A=new k.$Kw(async F=>{w.report({index:F.index,part:new c.$yQ(F.part)})});M=Promise.resolve(p.provider.provideLanguageModelResponse(y.map(h.LanguageModelChatMessage.to),C?.modelOptions??{},I.$zn.toKey(E),A,O))}M.then(()=>{this.b.$reportResponseDone(S,void 0)},A=>{this.b.$reportResponseDone(S,(0,L.$6)(A))})}$provideTokenLength(d,S,E){const y=this.f.get(d);return y?Promise.resolve(y.provider.provideTokenCount(S,E)):Promise.resolve(0)}$acceptChatModelMetadata(d){if(d.added)for(const{identifier:S,metadata:E}of d.added)this.g.set(S,{metadata:E,apiObjects:new I.$Bn});if(d.removed)for(const S of d.removed){this.g.delete(S);for(const[E,y]of this.i)y.languageModelId===S&&(y.res.reject(new L.$9),this.i.delete(E))}d.added?.forEach(S=>this.q(S.metadata)),this.d.fire(void 0)}async selectLanguageModels(d,S){const E=await this.b.$selectChatModels({...S,extension:d.identifier}),y=[],C=this;for(const O of E){const p=this.g.get(O);if(!p)continue;this.o(d.identifier,p.metadata)&&await this.q(p.metadata);let w=p.apiObjects.get(d.identifier);w||(w={id:O,vendor:p.metadata.vendor,family:p.metadata.family,version:p.metadata.version,name:p.metadata.name,maxInputTokens:p.metadata.maxInputTokens,countTokens(M,A){if(!C.g.has(O))throw c.$CQ.NotFound(O);return C.r(O,M,A??D.CancellationToken.None)},sendRequest(M,A,F){if(!C.g.has(O))throw c.$CQ.NotFound(O);return C.l(d,O,M,A??{},F??D.CancellationToken.None)}},Object.freeze(w),p.apiObjects.set(d.identifier,w)),y.push(w)}return y}async l(d,S,E,y,C){const O=this.m(d,E),p=d.identifier,w=this.g.get(S)?.metadata;if(!w||!this.g.has(S))throw c.$CQ.NotFound(`Language model '${S}' is unknown.`);if(this.o(p,w)&&(!await this.n(d,{identifier:w.extension,displayName:w.auth.providerLabel},y.justification,!1)||!this.h.get(p)?.has(w.extension)))throw c.$CQ.NoPermissions(`Language model '${S}' cannot be used by '${p.value}'.`);try{const M=Math.random()*1e6|0,A=new l;this.i.set(M,{languageModelId:S,res:A});try{await this.b.$tryStartChatRequest(p,S,M,O,y,C)}catch(F){throw this.i.delete(M),F}return A.apiObject}catch(M){throw M.name===c.$CQ.name?M:new c.$CQ(`Language model '${S}' errored: ${(0,P.$vj)(M)}`,"Unknown",M)}}m(d,S){const E=[];for(const y of S)y.role===c.LanguageModelChatMessageRole.System&&(0,n.$DH)(d,"languageModelSystem"),y.content2.some(C=>C instanceof c.$vQ)&&(0,n.$DH)(d,"lmTools"),E.push(h.LanguageModelChatMessage.from(y));return E}async $acceptResponsePart(d,S){const E=this.i.get(d);E&&E.res.handleFragment(S)}async $acceptResponseDone(d,S){const E=this.i.get(d);E&&(this.i.delete(d),S?E.res.reject((0,L.$7)(S)):E.res.resolve())}async n(d,S,E,y){const C=i.$eN+S.identifier.value;if(await this.k.getSession(d,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:S.identifier,enabled:!0}]),!0;if(y)return!1;try{const p=E?(0,s.localize)(2706,null,S.displayName,E):void 0;return await this.k.getSession(d,C,[],{forceNewSession:{detail:p}}),this.$updateModelAccesslist([{from:d.identifier,to:S.identifier,enabled:!0}]),!0}catch{return!1}}o(d,S){return!!S.auth&&!I.$zn.equals(S.extension,d)}async q(d){if(d.auth)for(const S of this.s)try{await this.n(S,{identifier:d.extension,displayName:""},void 0,!0)}catch(E){this.j.error("Fake Auth request failed"),this.j.error(E)}}async r(d,S,E){if(!this.g.get(d))throw c.$CQ.NotFound(`Language model '${d}' is unknown.`);const C=T.Iterable.find(this.f.values(),O=>O.languageModelId===d);return C?C.provider.provideTokenCount(S,E):this.b.$countTokens(d,typeof S=="string"?S:h.LanguageModelChatMessage.from(S),E)}$updateModelAccesslist(d){const S=new Array;for(const{from:E,to:y,enabled:C}of d){const O=this.h.get(E)??new I.$An;if(O.has(y)!==C){C?O.add(y):O.delete(y),this.h.set(E,O);const w={from:E,to:y};S.push(w),this.c.fire(w)}}}createLanguageModelAccessInformation(d){this.s.add(d);const S=this,E=R.Event.signal(R.Event.filter(this.c.event,C=>I.$zn.equals(C.from,d.identifier))),y=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(E,y)},canSendRequest(C){let O;e:for(const[w,M]of S.g)for(const A of M.apiObjects.values())if(A===C){O=M.metadata;break e}if(!O)return;if(!S.o(d.identifier,O))return!0;const p=S.h.get(d.identifier);if(p)return p.has(O.extension)}}}};e.$Wrc=g,e.$Wrc=g=t=Qe([We(0,a.$OQ),We(1,u.$fk),We(2,r.$erc)],g)});var oi=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Re[245],Oe([1,0,5,8,7,37,10,4,21]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Msc=void 0,D=Ve(D),L=oi(L);class s{constructor(b,u,k,$){this.c=u,this.d=k,this.e=$,this.b=[],this.f=0,this.g=new Set,this.a=b.getProxy(v.$bO.MainThreadLanguages)}$acceptLanguageIds(b){this.b=b}async getLanguages(){return this.b.slice(0)}async changeLanguage(b,u){await this.a.$changeLanguage(b,u);const k=this.c.getDocumentData(b);if(!k)throw new Error(`document '${b.toString()}' NOT found`);return k.document}async tokenAtPosition(b,u){const k=b.version,$=D.Position.from(u),r=await this.a.$tokensAtPosition(b.uri,$),a={type:P.StandardTokenType.Other,range:b.getWordRangeAtPosition(u)??new P.$fO(u.line,u.character,u.line,u.character)};if(!r)return a;const h={range:D.Range.to(r.range),type:D.TokenType.to(r.type)};return!h.range.contains(u)||k!==b.version?a:h}createLanguageStatusItem(b,u,k){const $=this.f++,r=this.a,a=this.g,h=`${b.identifier.value}/${u}`;if(a.has(h))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);a.add(h);const c={selector:k,id:u,name:b.displayName??b.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const n=new T.$Yc,t=()=>{if(i?.dispose(),!a.has(h)){console.warn(`LanguageStatusItem (${u}) from ${b.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$Mh)(()=>{n.clear(),this.a.$setLanguageStatus($,{id:h,name:c.name??b.displayName??b.name,source:b.displayName??b.name,selector:D.DocumentSelector.from(c.selector,this.e),label:c.text,detail:c.detail??"",severity:c.severity===P.LanguageStatusSeverity.Error?L.default.Error:c.severity===P.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:c.command&&this.d.toInternal(c.command,n),accessibilityInfo:c.accessibilityInformation,busy:c.busy})},0)},o={dispose(){n.dispose(),i?.dispose(),r.$removeLanguageStatus($),a.delete(h)},get id(){return c.id},get name(){return c.name},set name(l){c.name=l,t()},get selector(){return c.selector},set selector(l){c.selector=l,t()},get text(){return c.text},set text(l){c.text=l,t()},set text2(l){(0,m.$DH)(b,"languageStatusText"),c.text=l,t()},get text2(){return(0,m.$DH)(b,"languageStatusText"),c.text},get detail(){return c.detail},set detail(l){c.detail=l,t()},get severity(){return c.severity},set severity(l){c.severity=l,t()},get accessibilityInformation(){return c.accessibilityInformation},set accessibilityInformation(l){c.accessibilityInformation=l,t()},get command(){return c.command},set command(l){c.command=l,t()},get busy(){return c.busy},set busy(l){c.busy=l,t()}};return t(),o}}e.$Msc=s}),define(Re[246],Oe([1,0,15,2,8,7,90]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tsc=e.$ssc=void 0,P=Ve(P),R=Ve(R);class T{constructor(b,u,k,$){this.start=b,this.deletedCount=u,this.deletedItems=k,this.items=$}asApiEvent(){return{range:new L.$HP(this.start,this.start+this.deletedCount),addedCells:this.items.map(b=>b.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(b){return{EOL:b.eol,lines:b.source,languageId:b.language,uri:b.uri,isDirty:!1,versionId:1}}constructor(b,u,k){this.notebook=b,this.h=u,this.j=k,this.handle=k.handle,this.uri=D.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(P.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const b=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return b.g},set mime($){b.g=$},get outputs(){return b.a.slice(0)},get metadata(){return b.b},get executionSummary(){return b.d}};this.f=Object.freeze(k)}return this.f}setOutputs(b){this.a=b.map(P.NotebookCellOutput.to)}setOutputItems(b,u,k){const $=k.map(P.NotebookCellOutputItem.to),r=this.a.find(a=>a.id===b);if(r&&(u||(r.items.length=0),r.items.push(...$),r.items.length>1&&r.items.every(a=>R.$cM(a.mime)))){const a=new Map,h=[];r.items.forEach(c=>{let i;a.has(c.mime)?i=a.get(c.mime):(i=[],a.set(c.mime,i),h.push(c.mime)),i.push(c.data)}),r.items.length=0,h.forEach(c=>{const i=R.$dM(a.get(c));r.items.push({mime:c,data:i.data.buffer})})}}setMetadata(b){this.b=Object.freeze(b)}setInternalMetadata(b){this.e=b,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.$ssc=m;class s{static{this.a=0}constructor(b,u,k,$,r){this.k=b,this.l=u,this.m=k,this.uri=$,this.handle=s.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const b=this,u={get uri(){return b.uri},get version(){return b.g},get notebookType(){return b.d},get isDirty(){return b.h},get isUntitled(){return b.uri.scheme===v.Schemas.untitled},get isClosed(){return b.j},get metadata(){return b.f},get cellCount(){return b.b.length},cellAt(k){return k=b.n(k),b.b[k].apiCell},getCells(k){return(k?b.p(k):b.b).map(r=>r.apiCell)},save(){return b.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(b){b.metadata&&(this.f=Object.freeze({...this.f,...b.metadata}))}acceptDirty(b){this.h=b}acceptModelChanged(b,u,k){this.g=b.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:k});const $={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},r=[];for(const h of b.rawEvents)h.kind===R.NotebookCellsChangeType.ModelChange?this.r(h.changes,!1,$.contentChanges):h.kind===R.NotebookCellsChangeType.Move?this.s(h.index,h.length,h.newIdx,$.contentChanges):h.kind===R.NotebookCellsChangeType.Output?(this.t(h.index,h.outputs),r.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===R.NotebookCellsChangeType.OutputItem?(this.u(h.index,h.outputId,h.append,h.outputItems),r.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(h.index,h.language),r.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document})):h.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document}):h.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(h.index,h.mime):h.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(h.index,h.metadata),r.push({cell:this.b[h.index].apiCell,metadata:this.b[h.index].apiCell.metadata})):h.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(h.index,h.internalMetadata),r.push({cell:this.b[h.index].apiCell,executionSummary:this.b[h.index].apiCell.executionSummary}));const a=new Map;for(let h=0;h<r.length;h++){const c=r[h],i=a.get(c.cell);if(i===void 0){const n=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});a.set(c.cell,n-1)}else $.cellChanges[i]={...$.cellChanges[i],...c}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(b){return b=b|0,b<0?0:b>=this.b.length?this.b.length-1:b}o(b){let u=b.start|0,k=b.end|0;return u<0&&(u=0),k>this.b.length&&(k=this.b.length),b.with({start:u,end:k})}p(b){b=this.o(b);const u=[];for(let k=b.start;k<b.end;k++)u.push(this.b[k]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(b,u,k){if(this.j)return;const $=[],r=[],a=[];if(b.reverse().forEach(h=>{const i=h[2].map(o=>{const l=new m(this,this.l,o);return u||r.push(m.asModelAddData(o)),l}),n=new T(h[0],h[1],[],i),t=this.b.splice(h[0],h[1],...i);for(const o of t)a.push(o.uri),n.deletedItems.push(o.apiCell);$.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:a}),k)for(const h of $)k.push(h.asApiEvent())}s(b,u,k,$){const r=this.b.splice(b,u);this.b.splice(k,0,...r);const a=[new T(b,u,r.map(h=>h.apiCell),[]),new T(k,0,[],r)];for(const h of a)$.push(h.asApiEvent())}t(b,u){this.b[b].setOutputs(u)}u(b,u,k,$){this.b[b].setOutputItems(u,k,$)}v(b,u){const k=this.b[b];k.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(k.uri,u)}w(b,u){const k=this.b[b];k.apiCell.mime=u}x(b,u){this.b[b].setMetadata(u)}y(b,u){this.b[b].setInternalMetadata(u)}getCellFromApiCell(b){return this.b.find(u=>u.apiCell===b)}getCellFromIndex(b){return this.b[b]}getCell(b){return this.b.find(u=>u.handle===b)}getCellIndex(b){return this.b.indexOf(b)}}e.$tsc=s}),define(Re[247],Oe([1,0,6,2,8,7,39]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Osc=void 0;class T{constructor(s,I,b,u={timeout:1500,errors:3}){this.b=s,this.c=I,this.d=b,this.f=u,this.a=new v.$se}dispose(){}getOnWillSaveNotebookDocumentEvent(s){return(I,b,u)=>{const k=function(r){I.call(b,r)};return k.extension=s,this.a.event(k,void 0,u)}}async $participateInSave(s,I,b){const u=D.URI.revive(s),k=this.c.getNotebookDocument(u);if(!k)throw new Error("Unable to resolve notebook document");const $=[];if(await this.a.fireAsync({notebook:k.apiNotebook,reason:P.TextDocumentSaveReason.to(I)},b,async(a,h)=>{const c=Date.now(),i=await await Promise.resolve(a);Date.now()-c>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier),!b.isCancellationRequested&&i&&(i instanceof L.$pO?$.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier,"ignored due to invalid data"))}),b.isCancellationRequested)return!1;if($.length===0)return!0;const r={edits:[]};for(const a of $){const{edits:h}=P.WorkspaceEdit.from(a);r.edits=r.edits.concat(h)}return this.d.$tryApplyWorkspaceEdit(new R.$9w(r))}}e.$Osc=T}),define(Re[126],Oe([1,0,12,8,7]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$usc=void 0,D=Ve(D),P=Ve(P);class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,m,s,I,b,u){this.id=T,this.f=m,this.notebookData=s,this.a=[],this.b=[],this.d=!1,this.a=b,this.b=I,this.c=u}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(m){this.selections=[m]},get selections(){return T.a},set selections(m){if(!Array.isArray(m)||!m.every(P.$HP.isNotebookRange))throw(0,v.$$)("selections");T.a=m,T.g(m)},get visibleRanges(){return T.b},revealRange(m,s){T.f.$tryRevealRange(T.id,D.NotebookRange.from(m),s??P.NotebookEditorRevealType.Default)},get viewColumn(){return T.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(D.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$usc=L}),define(Re[248],Oe([1,0,6,11,8]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qsc=void 0,P=Ve(P);let L=class{constructor(T,m){this.c=T,this.d=m,this.a=new v.$qe,this.b=new v.$qe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,m);const s=this.d.getEditorById(T);m.visibleRanges&&s._acceptVisibleRanges(m.visibleRanges.ranges.map(P.NotebookRange.to)),m.selections&&s._acceptSelections(m.selections.selections.map(P.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:s.apiEditor,visibleRanges:s.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:s.apiEditor,selections:s.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const m in T)this.d.getEditorById(m)._acceptViewColumn(P.ViewColumn.to(T[m]))}};e.$Qsc=L,e.$Qsc=L=Qe([We(0,D.$fk)],L)}),define(Re[249],Oe([1,0,6,5,126]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tsc=void 0;class L{constructor(T,m){this.c=m,this.a=new Map,this.b=T.getProxy(D.$bO.MainThreadNotebookRenderers)}$postRendererMessage(T,m,s){const I=this.c.getEditorById(T);this.a.get(m)?.fire({editor:I.apiEditor,message:s})}createRendererMessaging(T,m){if(!T.contributes?.notebookRenderer?.some(I=>I.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(I,b,u)=>this.d(m).event(I,b,u),postMessage:(I,b)=>{P.$usc.apiEditorsToExtHost.has(I)&&([I,b]=[b,I]);const u=b&&P.$usc.apiEditorsToExtHost.get(b);return this.b.$postMessage(u?.id,m,I)}}}d(T){let m=this.a.get(T);return m||(m=new v.$qe({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(T)}}),this.a.set(T,m),m)}}e.$Tsc=L}),define(Re[250],Oe([1,0,8,77,19,71,12]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xsc=void 0;class T{constructor(b){this.b=0,this.c=new Map,this.a=b}async withProgress(b,u,k){const $=this.b++,{title:r,location:a,cancellable:h}=u,c={label:b.displayName||b.name,id:b.identifier.value};return this.a.$startProgress($,{location:v.ProgressLocation.from(a),title:r,source:c,cancellable:h},b.isUnderDevelopment?void 0:b.identifier.value).catch(R.$5),this.d($,k,!!h)}d(b,u,k){let $;k&&($=new P.$Be,this.c.set(b,$));const r=h=>{this.a.$progressEnd(h),this.c.delete(h),$?.dispose()};let a;try{a=u(new s(this.a,b),k&&$?$.token:P.CancellationToken.None)}catch(h){throw r(b),h}return a.then(h=>r(b),h=>r(b)),a}$acceptProgressCanceled(b){const u=this.c.get(b);u&&(u.cancel(),this.c.delete(b))}}e.$Xsc=T;function m(I,b){return I.message=b.message,typeof b.increment=="number"&&(typeof I.increment=="number"?I.increment+=b.increment:I.increment=b.increment),I}class s extends D.$Kw{constructor(b,u){super(k=>this.throttledReport(k)),this.c=b,this.d=u}throttledReport(b){this.c.$progressReport(this.d,b)}}Qe([(0,L.$ei)(100,(I,b)=>m(I,b),()=>Object.create(null))],s.prototype,"throttledReport",null)}),define(Re[251],Oe([1,0,2,5,10,8]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ysc=void 0;class R{static{this.a=0}constructor(m,s){this.d=s,this.c=new Map,this.b=m.getProxy(D.$bO.MainThreadQuickDiff)}$provideOriginalResource(m,s,I){const b=v.URI.revive(s),u=this.c.get(m);return u?(0,P.$Ch)(()=>u.provideOriginalResource(b,I)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(m,s,I,b){const u=R.a++;return this.c.set(u,s),this.b.$registerQuickDiffProvider(u,L.DocumentSelector.from(m,this.d),I,b),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Ysc=R});var oi=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Re[252],Oe([1,0,19,6,4,5,2,7,12,17,37,36,21,8]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zsc=$,I=oi(I);function $(r,a,h){const c=r.getProxy(L.$bO.MainThreadQuickOpen);class i{constructor(E,y){this.e=new Map,this.f=0,this.a=E,this.b=y}showQuickPick(E,y,C,O=v.CancellationToken.None){this.c=void 0;const p=Promise.resolve(y),w=++this.f,M=c.$show(w,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},O),A={},F=M.then(()=>A);return Promise.race([F,p]).then(G=>{if(G===A)return;const x=(0,u.$CH)(E,"quickPickItemTooltip");return p.then(j=>{const U=[];for(let J=0;J<j.length;J++){const Z=j[J];if(typeof Z=="string")U.push({label:Z,handle:J});else if(Z.kind===T.QuickPickItemKind.Separator)U.push({type:"separator",label:Z.label});else{Z.tooltip&&!x&&console.warn(`Extension '${E.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`);const ae=Z.iconPath?g(Z.iconPath):void 0;U.push({label:Z.label,iconPath:ae?.iconPath,iconClass:ae?.iconClass,description:Z.description,detail:Z.detail,picked:Z.picked,alwaysShow:Z.alwaysShow,tooltip:x?k.MarkdownString.fromStrict(Z.tooltip):void 0,handle:J})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=J=>{C.onDidSelectItem(j[J])}),c.$setItems(w,U),M.then(J=>{if(typeof J=="number")return j[J];if(Array.isArray(J))return J.map(Z=>j[Z])})})}).then(void 0,G=>{if(!(0,m.$8)(G))return c.$setError(w,G),Promise.reject(G)})}$onItemSelected(E){this.c?.(E)}showInput(E,y=v.CancellationToken.None){return this.d=E?.validateInput,c.$input(E,typeof this.d=="function",y).then(void 0,C=>{if(!(0,m.$8)(C))return Promise.reject(C)})}async $validateInput(E){if(!this.d)return;const y=await this.d(E);if(!y||typeof y=="string")return y;let C;switch(y.severity){case T.InputBoxValidationSeverity.Info:C=I.default.Info;break;case T.InputBoxValidationSeverity.Warning:C=I.default.Warning;break;case T.InputBoxValidationSeverity.Error:C=I.default.Error;break;default:C=y.message?I.default.Error:I.default.Ignore;break}return{content:y.message,severity:C}}async showWorkspaceFolderPick(E,y=v.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[E]);if(!C)return;const O=await this.a.getWorkspaceFolders2();if(O)return O.find(p=>p.uri.toString()===C.uri.toString())}createQuickPick(E){const y=new f(E,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(E){const y=new d(E,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(E,y){this.e.get(E)?._fireDidChangeValue(y)}$onDidAccept(E){this.e.get(E)?._fireDidAccept()}$onDidChangeActive(E,y){const C=this.e.get(E);C instanceof f&&C._fireDidChangeActive(y)}$onDidChangeSelection(E,y){const C=this.e.get(E);C instanceof f&&C._fireDidChangeSelection(y)}$onDidTriggerButton(E,y){this.e.get(E)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(E,y,C){const O=this.e.get(E);O instanceof f&&O._fireDidTriggerItemButton(y,C)}$onDidHide(E){this.e.get(E)?._fireDidHide()}}class n{static{this.a=1}constructor(E,y){this.x=E,this.y=y,this._id=f.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new D.$qe,this.q=new D.$qe,this.r=new D.$qe,this.s=new D.$qe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(E){this.b=E,this.z({title:E})}get step(){return this.c}set step(E){this.c=E,this.z({step:E})}get totalSteps(){return this.d}set totalSteps(E){this.d=E,this.z({totalSteps:E})}get enabled(){return this.g}set enabled(E){this.g=E,this.z({enabled:E})}get busy(){return this.j}set busy(E){this.j=E,this.z({busy:E})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(E){this.k=E,this.z({ignoreFocusOut:E})}get value(){return this.l}set value(E){this.l=E,this.z({value:E})}get placeholder(){return this.m}set placeholder(E){this.m=E,this.z({placeholder:E})}get buttons(){return this.n}set buttons(E){const y=(0,u.$CH)(this.x,"quickInputButtonLocation");!y&&E.some(C=>C.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=E.slice(),this.o.clear(),E.forEach((C,O)=>{const p=C===T.$EP.Back?-1:O;this.o.set(p,C)}),this.z({buttons:E.map((C,O)=>({...g(C.iconPath),tooltip:C.tooltip,handle:C===T.$EP.Back?-1:O,location:y?C.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(E){this.l=E,this.q.fire(E)}_fireDidTriggerButton(E){const y=this.o.get(E);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Uc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(E){if(!this.v){for(const y of Object.keys(E)){const C=E[y];this.u[y]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function t(S){if(S instanceof T.$cP)return{id:S.id};const E=l(S),y=o(S);return{dark:typeof E=="string"?R.URI.file(E):E,light:typeof y=="string"?R.URI.file(y):y}}function o(S){return typeof S=="object"&&"light"in S?S.light:S}function l(S){return typeof S=="object"&&"dark"in S?S.dark:S}function g(S){const E=t(S);let y,C;return"id"in E?C=b.ThemeIcon.asClassName(E):y=E,{iconPath:y,iconClass:C}}class f extends n{constructor(E,y){super(E,y),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new D.$qe,this.L=[],this.M=new D.$qe,this.N=new D.$qe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(E){this.B=E.slice(),this.C.clear(),this.D.clear(),E.forEach((O,p)=>{this.C.set(p,O),this.D.set(O,p)});const y=(0,u.$CH)(this.x,"quickPickItemTooltip"),C=[];for(let O=0;O<E.length;O++){const p=E[O];if(p.kind===T.QuickPickItemKind.Separator)C.push({type:"separator",label:p.label});else{p.tooltip&&!y&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const w=p.iconPath?g(p.iconPath):void 0;C.push({handle:O,label:p.label,iconPath:w?.iconPath,iconClass:w?.iconClass,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:y?k.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((M,A)=>({...g(M.iconPath),tooltip:M.tooltip,handle:A}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(E){this.E=E,this.z({canSelectMany:E})}get matchOnDescription(){return this.F}set matchOnDescription(E){this.F=E,this.z({matchOnDescription:E})}get matchOnDetail(){return this.G}set matchOnDetail(E){this.G=E,this.z({matchOnDetail:E})}get sortByLabel(){return this.H}set sortByLabel(E){this.H=E,this.z({sortByLabel:E})}get keepScrollPosition(){return this.I}set keepScrollPosition(E){this.I=E,this.z({keepScrollPosition:E})}get activeItems(){return this.J}set activeItems(E){this.J=E.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(E){this.L=E.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(E){const y=(0,s.$Lb)(E.map(C=>this.C.get(C)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(E){const y=(0,s.$Lb)(E.map(C=>this.C.get(C)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(E,y){const C=this.C.get(E);if(!C||!C.buttons||!C.buttons.length)return;const O=C.buttons[y];O&&this.N.fire({button:O,item:C})}}class d extends n{constructor(E,y){super(E,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(E){this.B=E,this.z({password:E})}get prompt(){return this.C}set prompt(E){this.C=E,this.z({prompt:E})}get valueSelection(){return this.D}set valueSelection(E){this.D=E,this.z({valueSelection:E})}get validationMessage(){return this.E}set validationMessage(E){this.E=E,E?typeof E=="string"?this.z({validationMessage:E,severity:I.default.Error}):this.z({validationMessage:E.message,severity:E.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(a,h)}}),define(Re[253],Oe([1,0,2,6,71,4,10,5,17,159,11,18,38,36,8,21,15,23]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$2sc=e.$1sc=void 0;function i(A){return A instanceof v.URI}function n(A,F){return A.scheme===a.Schemas.file&&F.scheme===a.Schemas.file&&h.$n?A.toString()===F.toString():A.toString().toLowerCase()===F.toString().toLowerCase()}function t(A){if(A)return typeof A.iconPath=="string"?v.URI.file(A.iconPath):v.URI.isUri(A.iconPath)||k.ThemeIcon.isThemeIcon(A.iconPath)?A.iconPath:void 0}function o(A){if(A){if(v.URI.isUri(A))return A;if(k.ThemeIcon.isThemeIcon(A))return A;{const F=A;return{light:F.light,dark:F.dark}}}else return}function l(A){const F=o(A.icon),G=A.labels?.map(x=>({title:x.title,icon:o(x.icon)}));return{...A,icon:F,labels:G}}function g(A,F){if(!A.iconPath&&!F.iconPath)return 0;if(A.iconPath){if(!F.iconPath)return 1}else return-1;const G=typeof A.iconPath=="string"?A.iconPath:v.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id,x=typeof F.iconPath=="string"?F.iconPath:v.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,s.$Ur)(G,x)}function f(A,F){let G=0;if(A.strikeThrough!==F.strikeThrough)return A.strikeThrough?1:-1;if(A.faded!==F.faded)return A.faded?1:-1;if(A.tooltip!==F.tooltip)return(A.tooltip||"").localeCompare(F.tooltip||"");if(G=g(A,F),G!==0)return G;if(A.light&&F.light)G=g(A.light,F.light);else{if(A.light)return 1;if(F.light)return-1}if(G!==0)return G;if(A.dark&&F.dark)G=g(A.dark,F.dark);else{if(A.dark)return 1;if(F.dark)return-1}return G}function d(A,F){if(A.command!==F.command)return A.command<F.command?-1:1;if(A.title!==F.title)return A.title<F.title?-1:1;if(A.tooltip!==F.tooltip){if(A.tooltip!==void 0&&F.tooltip!==void 0)return A.tooltip<F.tooltip?-1:1;if(A.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(A.arguments===F.arguments)return 0;if(A.arguments)if(F.arguments){if(A.arguments.length!==F.arguments.length)return A.arguments.length-F.arguments.length}else return 1;else return-1;for(let G=0;G<A.arguments.length;G++){const x=A.arguments[G],j=F.arguments[G];if(x!==j&&!(i(x)&&i(j)&&n(x,j)))return x<j?-1:1}return 0}function S(A,F){let G=(0,s.$Ur)(A.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(G!==0)return G;if(A.command&&F.command)G=d(A.command,F.command);else{if(A.command)return 1;if(F.command)return-1}if(G!==0)return G;if(A.decorations&&F.decorations)G=f(A.decorations,F.decorations);else{if(A.decorations)return 1;if(F.decorations)return-1}if(A.multiFileDiffEditorModifiedUri&&F.multiFileDiffEditorModifiedUri)G=(0,s.$Ur)(A.multiFileDiffEditorModifiedUri.fsPath,F.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(A.multiFileDiffEditorModifiedUri)return 1;if(F.multiFileDiffEditorModifiedUri)return-1}if(A.multiDiffEditorOriginalUri&&F.multiDiffEditorOriginalUri)G=(0,s.$Ur)(A.multiDiffEditorOriginalUri.fsPath,F.multiDiffEditorOriginalUri.fsPath,!0);else{if(A.multiDiffEditorOriginalUri)return 1;if(F.multiDiffEditorOriginalUri)return-1}return G}function E(A,F){for(let G=0;G<A.length;G++)if(A[G]!==F[G])return!1;return!0}function y(A,F){return A.command===F.command&&A.title===F.title&&A.tooltip===F.tooltip&&(A.arguments&&F.arguments?E(A.arguments,F.arguments):A.arguments===F.arguments)}function C(A,F){return(0,m.$yb)(A,F,y)}class O{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.m,F),this.o(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.m,F),this.f=F}get validateInput(){return(0,r.$DH)(this.k,"scmValidation"),this.g}set validateInput(F){if((0,r.$DH)(this.k,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.m,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.m,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.m,F))}get document(){return(0,r.$DH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(F,G,x,j,U){this.k=F,this.m=j,this.n=U,this.d="",this.e=new D.$qe,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=x}showValidationMessage(F,G){(0,r.$DH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,F,G)}$onInputBoxValueChange(F){this.o(F)}o(F){this.d=F,this.e.fire(F)}}e.$1sc=O;class p{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(F){this.w=F,this.s.$updateGroupLabel(this.u,this.handle,F)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(F){this.q=F,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,G,x,j,U,J,Z){this.s=F,this.t=G,this.u=x,this.v=j,this.w=U,this.multiDiffEditorEnableViewChanges=J,this.x=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new D.$qe,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new D.$qe,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=p.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,G){const x=this.h.get(F);return x?(0,R.$Ch)(()=>this.t.executeCommand(x.command,...x.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(S),x=(0,m.$Hb)(this.p,F,S).map(J=>{const Z=J.toInsert.map(ae=>{const ee=this.e++;this.g.set(ee,ae);const oe=ae.resourceUri;let ie;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"||ae.command.command==="vscode.changes"){const nt=new L.$Yc;ie=this.t.converter.toInternal(ae.command,nt),this.j.set(ee,nt)}else this.h.set(ee,ae.command);const ue=(0,r.$CH)(this.x,"scmMultiDiffEditor"),_=ue?ae.multiDiffEditorOriginalUri:void 0,$e=ue?ae.multiFileDiffEditorModifiedUri:void 0,Ie=t(ae.decorations),X=ae.decorations&&t(ae.decorations.light)||Ie,V=ae.decorations&&t(ae.decorations.dark)||Ie,re=[X,V],we=ae.decorations&&ae.decorations.tooltip||"",Pe=ae.decorations&&!!ae.decorations.strikeThrough,Fe=ae.decorations&&!!ae.decorations.faded,Be=ae.contextValue||"";return{rawResource:[ee,oe,re,we,Pe,Fe,Be,ie,_,$e],handle:ee}});return{start:J.start,deleteCount:J.deleteCount,toInsert:Z}}),j=x.map(({start:J,deleteCount:Z,toInsert:ae})=>[J,Z,ae.map(ee=>ee.rawResource)]),U=x.reverse();for(const{start:J,deleteCount:Z,toInsert:ae}of U){const ee=ae.map(ie=>ie.handle),oe=this.o.splice(J,Z,...ee);for(const ie of oe)this.g.delete(ie),this.h.delete(ie),this.j.get(ie)?.dispose(),this.j.delete(ie)}return this.p=F,j}dispose(){this.m=!0,this.n.fire()}}class w{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.x,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let G;(0,r.$CH)(this.y,"quickDiffProvider")&&(G=F?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!F,quickDiffLabel:G})}get historyProvider(){return(0,r.$DH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(F){(0,r.$DH)(this.y,"scmHistoryProvider"),this.j=F,this.k.value=new L.$Yc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!F}),F&&this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this.m=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(F){F!==this.n&&(this.n=F,this.#e.$updateSourceControl(this.x,{commitTemplate:F}))}get acceptInputCommand(){return this.p}set acceptInputCommand(F){this.o.value=new L.$Yc,this.p=F;const G=this.z.converter.toInternal(F,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:G})}get actionButton(){return(0,r.$DH)(this.y,"scmActionButton"),this.s}set actionButton(F){(0,r.$DH)(this.y,"scmActionButton"),this.q.value=new L.$Yc,this.s=F;const G=F!==void 0?{command:this.z.converter.toInternal(F.command,this.q.value),secondaryCommands:F.secondaryCommands?.map(x=>x.map(j=>this.z.converter.toInternal(j,this.q.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:G??null})}get statusBarCommands(){return this.u}set statusBarCommands(F){if(this.u&&F&&C(this.u,F))return;this.t.value=new L.$Yc,this.u=F;const G=(F||[]).map(x=>this.z.converter.toInternal(x,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:G})}get selected(){return this.v}constructor(F,G,x,j,U,J,Z){this.y=F,this.z=j,this.A=U,this.B=J,this.C=Z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$1c,this.n=void 0,this.o=new L.$1c,this.p=void 0,this.q=new L.$1c,this.t=new L.$1c,this.u=void 0,this.v=!1,this.w=new D.$qe,this.onDidChangeSelection=this.w.event,this.x=w.d++,this.D=new Map,this.E=new Set,this.#e=x;const ae=v.URI.from({scheme:a.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:Z?`rootUri=${encodeURIComponent(Z.toString())}`:void 0});this.f=new O(F,G,this.#e,this.x,ae),this.#e.$registerSourceControl(this.x,U,J,Z,ae)}createResourceGroup(F,G,x){const j=(0,r.$CH)(this.y,"scmMultiDiffEditor")&&x?.multiDiffEditorEnableViewChanges===!0,U=new p(this.#e,this.z,this.x,F,G,j,this.y),J=D.Event.once(U.onDidDispose)(()=>this.D.delete(U));return this.D.set(U,J),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const F=[],G=[];for(const[x,j]of this.D){j.dispose();const U=x.onDidUpdateResourceStates(()=>{this.E.add(x),this.eventuallyUpdateResourceStates()});D.Event.once(x.onDidDispose)(()=>{this.E.delete(x),U.dispose(),this.e.delete(x.handle),this.#e.$unregisterGroup(this.x,x.handle)}),F.push([x.handle,x.id,x.label,x.features,x.multiDiffEditorEnableViewChanges]);const J=x._takeResourceStateSnapshot();J.length>0&&G.push([x.handle,J]),this.e.set(x.handle,x)}this.#e.$registerGroups(this.x,F,G),this.D.clear()}eventuallyUpdateResourceStates(){const F=[];this.E.forEach(G=>{const x=G._takeResourceStateSnapshot();x.length!==0&&F.push([G.handle,x])}),F.length>0&&this.#e.$spliceResourceStates(this.x,F),this.E.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.v=F,this.w.fire(F)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.x)}}Qe([(0,P.$di)(100)],w.prototype,"eventuallyAddResourceGroups",null),Qe([(0,P.$di)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{c=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(F,G,x,j){this.m=G,this.n=x,this.o=j,this.g=new Map,this.h=new b.$Bn,this.j=new D.$qe,this.e=F.getProxy(T.$bO.MainThreadSCM),this.f=F.getProxy(T.$bO.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===u.MarshalledId.ScmResource){const J=this.g.get(U.sourceControlHandle);if(!J)return U;const Z=J.getResourceGroup(U.groupHandle);return Z?Z.getResourceState(U.handle):U}else if(U&&U.$mid===u.MarshalledId.ScmResourceGroup){const J=this.g.get(U.sourceControlHandle);return J?J.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===u.MarshalledId.ScmProvider){const J=this.g.get(U.handle);return J||U}return U}})}createSourceControl(F,G,x,j){this.o.trace("ExtHostSCM#createSourceControl",F.identifier.value,G,x,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const U=c.d++,J=new w(F,this.n,this.e,this.m,G,x,j);this.g.set(U,J);const Z=this.h.get(F.identifier)||[];return Z.push(J),this.h.set(F.identifier,Z),J}getLastInputBox(F){this.o.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const G=this.h.get(F.identifier),x=G&&G[G.length-1];return x&&x.inputBox}$provideOriginalResource(F,G,x){const j=v.URI.revive(G);this.o.trace("ExtHostSCM#$provideOriginalResource",F,j.toString());const U=this.g.get(F);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Ch)(()=>U.quickDiffProvider.provideOriginalResource(j,x)).then(J=>J||null)}$onInputBoxValueChange(F,G){this.o.trace("ExtHostSCM#$onInputBoxValueChange",F);const x=this.g.get(F);return x&&x.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(F,G,x,j){this.o.trace("ExtHostSCM#$executeResourceCommand",F,G,x);const U=this.g.get(F);if(!U)return Promise.resolve(void 0);const J=U.getResourceGroup(G);return J?J.$executeResourceCommand(x,j):Promise.resolve(void 0)}$validateInput(F,G,x){this.o.trace("ExtHostSCM#$validateInput",F);const j=this.g.get(F);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Ch)(()=>j.inputBox.validateInput(G,x)).then(U=>{if(!U)return Promise.resolve(void 0);const J=$.MarkdownString.fromStrict(U.message);return J?Promise.resolve([J,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.g.get(F)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(F,G,x,j){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,x,j)??void 0}async $resolveHistoryItemGroupCommonAncestor2(F,G,x){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(G,x)??void 0}async $provideHistoryItems(F,G,x,j){return(await this.g.get(F)?.historyProvider?.provideHistoryItems(G,x,j))?.map(Z=>l(Z))??void 0}async $provideHistoryItems2(F,G,x){return(await this.g.get(F)?.historyProvider?.provideHistoryItems2(G,x))?.map(J=>l(J))??void 0}async $provideHistoryItemSummary(F,G,x,j){const U=this.g.get(F)?.historyProvider;if(typeof U?.provideHistoryItemSummary!="function")return;const J=await U.provideHistoryItemSummary(G,x,j);return J?l(J):void 0}async $provideHistoryItemChanges(F,G,x,j){return await this.g.get(F)?.historyProvider?.provideHistoryItemChanges(G,x,j)??void 0}};e.$2sc=M,e.$2sc=M=c=Qe([We(3,I.$fk)],M)}),define(Re[254],Oe([1,0,5,8,2]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3sc=void 0;class L{static{this.a=0}constructor(T,m){this.d=m,this.c=new Map,this.b=T.getProxy(v.$bO.MainThreadShare)}async $provideShare(T,m,s){return await this.c.get(T)?.provideShare({selection:D.Range.to(m.selection),resourceUri:P.URI.revive(m.resourceUri)},s)??void 0}registerShareProvider(T,m){const s=L.a++;return this.c.set(s,m),this.b.$registerShareProvider(s,D.DocumentSelector.from(T,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(s),this.c.delete(s)}}}}e.$3sc=L}),define(Re[255],Oe([1,0,7,5,9,4,8,14]),function(be,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6sc=e.$5sc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$dP("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$dP("statusBarItem.warningForeground")]])}#e;#t;constructor(u,k,$,r,a,h=v.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new L.$Yc,this.#e=u,this.#t=k,a&&r){this.c=(0,v.$RO)(r.identifier,a);const i=$.get(this.c);i&&(h=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,c=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(m.a++);this.e=r,this.f=a,this.g=h,this.h=this.u(c)}u(u){if((0,T.$ng)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!m.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new L.$Yc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let k;this.m?k=this.m:k=(0,P.localize)(2712,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=m.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,k,this.k,r,this.r?.internal,$,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$5sc=m;class s{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(2713,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const k={message:u};return this.b.unshift(k),this.c(),new v.$dO(()=>{const $=this.b.indexOf(k);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(u,k){this.e=new Map,this.a=u.getProxy(D.$bO.MainThreadStatusBar),this.b=k,this.c=new s(this)}$acceptStaticEntries(u){for(const k of u)this.e.set(k.entryId,k)}createStatusBarEntry(u,k,$,r){return new m(this.a,this.b,this.e,u,k,$,r)}setStatusBarMessage(u,k){const $=this.c.setMessage(u);let r;return typeof k=="number"?r=setTimeout(()=>$.dispose(),k):typeof k<"u"&&k.then(()=>$.dispose(),()=>$.dispose()),new v.$dO(()=>{$.dispose(),clearTimeout(r)})}}e.$6sc=I}),define(Re[127],Oe([1,0,32,118,54,82,55,8,2]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Q=e.$3Q=e.$2Q=e.$1Q=void 0,v=Ve(v),T=Ve(T);const s=(i,n,t,o)=>{let l=n;return{enumerable:!0,configurable:!1,get(){return l},set(g){if(!t(l,g)){const f=l;l=g,i.listener?.(o(g,f))}}}},I=(i,n)=>i===n,b={range:(i,n)=>i===n?!0:!i||!n?!1:i.isEqual(n),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,n)=>!(i.length!==n.length||i.some(t=>!n.find(o=>t.id===o.id)))},u=i=>n=>({op:L.TestItemEventOp.SetProp,update:i(n)}),k=(i,n)=>({range:(()=>{let t;const o=u(l=>({range:v.$Yt.lift(T.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return t},set(l){i.listener?.({op:L.TestItemEventOp.DocumentSynced}),b.range(t,l)||(t=l,i.listener?.(o(l)))}}})(),label:s(i,n,b.label,u(t=>({label:t}))),description:s(i,void 0,b.description,u(t=>({description:t}))),sortText:s(i,void 0,b.sortText,u(t=>({sortText:t}))),canResolveChildren:s(i,!1,b.canResolveChildren,t=>({op:L.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:s(i,!1,b.busy,u(t=>({busy:t}))),error:s(i,void 0,b.error,u(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:s(i,[],b.tags,(t,o)=>({op:L.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:o.map(T.TestTag.from)}))}),$=i=>{const n=P.$tJ.fromString(i.extId),t=new a(n.controllerId,n.localId,i.label,m.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>T.TestTag.to({id:(0,R.$zJ)(o).tagId})),t},r=i=>{let n;for(const t of i.tests){const o=$(t.item);(0,D.$KQ)(o).parent=n,n=o}return n};e.$1Q=r;class a{constructor(n,t,o,l){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const g=(0,D.$JQ)(this,n);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof h?void 0:g.parent}},children:{value:(0,L.$IQ)(g,D.$KQ,a),enumerable:!0,writable:!1},...k(g,o)})}}e.$2Q=a;class h extends a{constructor(n,t){super(n,n,t,void 0),this._isRoot=!0}}e.$3Q=h;class c extends L.$EQ{constructor(n,t,o){super({controllerId:n,getDocumentVersion:l=>l&&o.getDocument(l)?.version,getApiFor:D.$KQ,getChildren:l=>l.children,root:new h(n,t),toITestItem:T.TestItem.from})}}e.$4Q=c}),define(Re[35],Oe([1,0,14,7,8,25,5,17,11,34,32,101,2,4,3,16,127,20,39,42,69,63,66,33]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n,t,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=e.$bR=e.$aR=e.$_Q=e.$$Q=e.$0Q=void 0,D=Ve(D),P=Ve(P);let g=class{#e;#t;#i;constructor(C,O,p){this.b=new Map,this.c=new Map,this.#e=C.getProxy(R.$bO.MainThreadCommands),this.d=O,this.#i=p,this.#t=C.getProxy(R.$bO.MainThreadTelemetry),this.converter=new f(this,w=>{const M=this.c.get(w);return M?.result===S.Void?M:void 0},O),this.f=[{processArgument(w){return(0,s.$hi)(w)}},{processArgument(w){return(0,L.$oo)(w,function(M){if(I.$Yt.isIRange(M))return P.Range.to(M);if(b.$Xt.isIPosition(M))return P.Position.to(M);if(I.$Yt.isIRange(M.range)&&u.URI.isUri(M.uri))return P.location.to(M);if(M instanceof h.$Se)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const O=this.registerCommand(!1,C.id,async(...p)=>{const w=C.args.map((A,F)=>{if(!A.validate(p[F]))throw new Error(`Invalid argument '${A.name}' when running '${C.id}', received: ${typeof p[F]=="object"?JSON.stringify(p[F],null,"	"):p[F]} `);return A.convert(p[F])}),M=await this.executeCommand(C.internalId,...w);return C.result.convert(M,p,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new D.$dO(()=>{O.dispose(),this.c.delete(C.id)})}registerCommand(C,O,p,w,M,A){if(this.d.trace("ExtHostCommands#registerCommand",O),!O.trim().length)throw new Error("invalid id");if(this.b.has(O))throw new Error(`command '${O}' already exists`);return this.b.set(O,{callback:p,thisArg:w,metadata:M,extension:A}),C&&this.#e.$registerCommand(O),new D.$dO(()=>{this.b.delete(O)&&C&&this.#e.$unregisterCommand(O)})}executeCommand(C,...O){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,O,!0)}async g(C,O,p){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,O,!1);{let w=!1;const M=(0,L.$oo)(O,function(A){if(A instanceof D.$eO)return P.Position.from(A);if(A instanceof D.$fO)return P.Range.from(A);if(A instanceof D.$rO)return P.location.from(A);if(D.$HP.isNotebookRange(A))return P.NotebookRange.from(A);if(A instanceof ArrayBuffer)return w=!0,h.$Se.wrap(new Uint8Array(A));if(A instanceof Uint8Array)return w=!0,h.$Se.wrap(A);if(A instanceof h.$Se)return w=!0,A;if(!Array.isArray(A))return A});try{const A=await this.#e.$executeCommand(C,w?new c.$9w(M):M,p);return(0,s.$hi)(A)}catch(A){if(A instanceof Error&&A.message==="$executeCommand:retry")return this.g(C,O,!1);throw A}}}async h(C,O,p){const w=this.b.get(C);if(!w)throw new Error("Unknown command");const{callback:M,thisArg:A,metadata:F}=w;if(F?.args)for(let x=0;x<F.args.length;x++)try{(0,v.$Ag)(O[x],F.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${F.args[x].name}' - ${F.args[x].description}`)}const G=n.$ke.create();try{return await M.apply(A,O)}catch(x){if(C===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...O);j&&(C=j.command)}if(this.d.error(x,C,w.extension?.identifier),!p)throw x;if(w.extension?.identifier){const j=this.#i.onExtensionError(w.extension.identifier,x);this.d.trace("forwarded error to extension?",j,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$vj)(x)),this.id=C,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,C,G.elapsed())}}j(C,O,p){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$Fp(O),duration:p})}$executeContributedCommand(C,...O){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const p=this.b.get(C);return p?(O=O.map(w=>this.f.reduce((M,A)=>A.processArgument(M,p.extension?.identifier),w)),this.h(C,O,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(O=>(C&&(O=O.filter(p=>p[0]!=="_")),O))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[O,p]of this.b){const{metadata:w}=p;w&&(C[O]=w)}return Promise.resolve(C)}};e.$0Q=g,e.$0Q=g=Qe([We(0,r.$OQ),We(1,m.$fk),We(2,o.$9Q)],g),e.$$Q=(0,$.$Ki)("IExtHostCommands");class f{constructor(C,O,p){this.d=C,this.f=O,this.g=p,this.delegatingCommandId=`__vsc${(0,l.$7g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,O){if(!C)return;const p={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return p;const w=this.f(C.command);if(w)p.id=w.internalId,p.arguments=w.args.map((M,A)=>M.convert(C.arguments&&C.arguments[A]));else if((0,T.$Pb)(C.arguments)){const M=`${C.command} /${++this.c}`;this.b.set(M,C),O.add((0,k.$Xc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),p.$ident=M,p.id=this.delegatingCommandId,p.arguments=[M],this.g.trace("CommandsConverter#CREATE",C.command,M)}return p}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const O=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],O?O.command:"MISSING"),O?this.d.executeCommand(O.command,...O.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$_Q=f;class d{static{this.Uri=new d("uri","Uri of a text document",C=>u.URI.isUri(C),C=>C)}static{this.Position=new d("position","A position in a text document",C=>D.$eO.isPosition(C),P.Position.from)}static{this.Range=new d("range","A range in a text document",C=>D.$fO.isRange(C),P.Range.from)}static{this.Selection=new d("selection","A selection in a text document",C=>D.$gO.isSelection(C),P.Selection.from)}static{this.Number=new d("number","",C=>typeof C=="number",C=>C)}static{this.String=new d("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=d.Arr(d.String)}static Arr(C){return new d(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,O=>Array.isArray(O)&&O.every(p=>C.validate(p)),O=>O.map(p=>C.convert(p)))}static{this.CallHierarchyItem=new d("item","A call hierarchy item",C=>C instanceof D.$DO,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new d("item","A type hierarchy item",C=>C instanceof D.$3P,P.TypeHierarchyItem.from)}static{this.TestItem=new d("testItem","A VS Code TestItem",C=>C instanceof a.$2Q,P.TestItem.from)}constructor(C,O,p,w){this.name=C,this.description=O,this.validate=p,this.convert=w}optional(){return new d(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,O){return new d(C??this.name,O??this.description,this.validate,this.convert)}}e.$aR=d;class S{static{this.Void=new S("no result",C=>C)}constructor(C,O){this.description=C,this.convert=O}}e.$bR=S;class E{constructor(C,O,p,w,M){this.id=C,this.internalId=O,this.description=p,this.args=w,this.result=M}}e.$cR=E}),define(Re[256],Oe([1,0,17,15,2,94,104,31,35,8,7]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=void 0,L=Ve(L),s=Ve(s),I=Ve(I);const b=[new m.$cR("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of DocumentHighlight-instances.",k(s.DocumentHighlight.to))),new m.$cR("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$aR.Uri],new m.$bR("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,a)=>{if((0,v.$Ob)(r))return;class h extends I.$yO{static to(i){const n=new h(i.name,s.SymbolKind.to(i.kind),i.containerName||"",new I.$rO(a[0],s.Range.to(i.range)));return n.detail=i.detail,n.range=n.location.range,n.selectionRange=s.Range.to(i.selectionRange),n.children=i.children?i.children.map(h.to):[],n}}return r.map(h.to)})),new m.$cR("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$aR.Uri,new m.$aR("options","Formatting options",r=>!0,r=>r)],new m.$bR("A promise that resolves to an array of TextEdits.",k(s.TextEdit.to))),new m.$cR("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$aR.Uri,m.$aR.Range,new m.$aR("options","Formatting options",r=>!0,r=>r)],new m.$bR("A promise that resolves to an array of TextEdits.",k(s.TextEdit.to))),new m.$cR("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$aR.Uri,m.$aR.Position,new m.$aR("ch","Trigger character",r=>typeof r=="string",r=>r),new m.$aR("options","Formatting options",r=>!0,r=>r)],new m.$bR("A promise that resolves to an array of TextEdits.",k(s.TextEdit.to))),new m.$cR("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$cR("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$cR("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$cR("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$cR("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$cR("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$cR("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$cR("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$cR("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of Location-instances.",k(s.location.to))),new m.$cR("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of Location-instances.",k(s.location.to))),new m.$cR("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of Hover-instances.",k(s.Hover.to))),new m.$cR("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of Hover-instances.",k(s.Hover.to))),new m.$cR("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$aR.Uri,new m.$aR("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>I.$eO.isPosition(a)),r=>r.map(s.Position.from))],new m.$bR("A promise that resolves to an array of ranges.",r=>r.map(a=>{let h;for(const c of a.reverse())h=new I.$CO(s.Range.to(c),h);return h}))),new m.$cR("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$aR.String.with("query","Search string")],new m.$bR("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(s.WorkspaceSymbol.to))),new m.$cR("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(s.CallHierarchyItem.to))),new m.$cR("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$aR.CallHierarchyItem],new m.$bR("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(s.CallHierarchyIncomingCall.to))),new m.$cR("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$aR.CallHierarchyItem],new m.$bR("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(s.CallHierarchyOutgoingCall.to))),new m.$cR("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:s.Range.to(r.range),placeholder:r.text}})),new m.$cR("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$aR.Uri,m.$aR.Position,m.$aR.String.with("newName","The new symbol name")],new m.$bR("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return s.WorkspaceEdit.to(r)}})),new m.$cR("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$aR.Uri,m.$aR.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$bR("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(s.DocumentLink.to))),new m.$cR("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$aR.Uri],new m.$bR("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$yP(r.tokenTypes,r.tokenModifiers)})),new m.$cR("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$aR.Uri],new m.$bR("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,R.$Geb)(r);if(a.type==="full")return new I.$AP(a.data,void 0)})),new m.$cR("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$aR.Uri,m.$aR.Range.optional()],new m.$bR("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$yP(r.tokenTypes,r.tokenModifiers)})),new m.$cR("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$aR.Uri,m.$aR.Range],new m.$bR("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,R.$Geb)(r);if(a.type==="full")return new I.$AP(a.data,void 0)})),new m.$cR("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$aR.Uri,m.$aR.Position,m.$aR.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$aR.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$bR("A promise that resolves to a CompletionList-instance.",(r,a,h)=>{if(!r)return new I.$OO([]);const c=r.suggestions.map(i=>s.CompletionItem.to(i,h));return new I.$OO(c,r.incomplete)})),new m.$cR("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$aR.Uri,m.$aR.Position,m.$aR.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$bR("A promise that resolves to SignatureHelp.",r=>{if(r)return s.SignatureHelp.to(r)})),new m.$cR("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$aR.Uri,m.$aR.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$bR("A promise that resolves to an array of CodeLens-instances.",(r,a,h)=>k(c=>new I.$GO(s.Range.to(c.range),c.command&&h.fromInternal(c.command)))(r))),new m.$cR("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$aR.Uri,new m.$aR("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$fO.isRange(r),r=>I.$gO.isSelection(r)?s.Selection.from(r):s.Range.from(r)),m.$aR.String.with("kind","Code action kind to return code actions for").optional(),m.$aR.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$bR("A promise that resolves to an array of Command-instances.",(r,a,h)=>k(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(c.command)}else{const i=new I.$AO(c.title,c.kind?new I.$BO(c.kind):void 0);return c.edit&&(i.edit=s.WorkspaceEdit.to(c.edit)),c.command&&(i.command=h.fromInternal(c.command)),i.isPreferred=c.isPreferred,i}})(r))),new m.$cR("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$aR.Uri],new m.$bR("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new I.$UO(s.Range.to(a.range),s.Color.to(a.color))):[])),new m.$cR("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$aR("color","The color to show and insert",r=>r instanceof I.$TO,s.Color.from),new m.$aR("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:s.Range.from(r.range)}))],new m.$bR("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(s.ColorPresentation.to):[])),new m.$cR("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$aR.Uri,m.$aR.Range],new m.$bR("A promise that resolves to an array of Inlay objects",(r,a,h)=>r.map(s.InlayHint.to.bind(void 0,h)))),new m.$cR("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$aR.Uri],new m.$bR("A promise that resolves to an array of FoldingRange objects",(r,a)=>{if(r)return r.map(s.FoldingRange.to)})),new m.$cR("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$bR("A promise that resolves to an array of NotebookContentProvider static info objects.",k(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>s.NotebookExclusiveDocumentPattern.to(a))})))),new m.$cR("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$aR.Uri,m.$aR.Range,new m.$aR("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.$fO,r=>s.InlineValueContext.from(r))],new m.$bR("A promise that resolves to an array of InlineValue objects",r=>r.map(s.InlineValue.to))),new m.$cR("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$aR("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,D.$Ug)(r,D.Schemas.http,D.Schemas.https),r=>r),new m.$aR("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional(),m.$aR.String.with("label","").optional()],m.$bR.Void),new m.$cR("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$aR.Uri.with("resource","Resource to open"),m.$aR.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$aR("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional()],m.$bR.Void),new m.$cR("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$aR.Uri.with("left","Left-hand side resource of the diff editor"),m.$aR.Uri.with("right","Right-hand side resource of the diff editor"),m.$aR.String.with("title","Human readable title for the diff editor").optional(),new m.$aR("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)]).optional()],m.$bR.Void),new m.$cR("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$aR.String.with("title","Human readable title for the changes editor"),new m.$aR("resourceList","List of resources to compare",r=>{for(const a of r){if(a.length!==3)return!1;const[h,c,i]=a;if(!P.URI.isUri(h)||!P.URI.isUri(c)&&c!==void 0&&c!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],m.$bR.Void),new m.$cR("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$aR.Uri,m.$aR.Position],new m.$bR("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new m.$cR("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$aR.TypeHierarchyItem],new m.$bR("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new m.$cR("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$aR.TypeHierarchyItem],new m.$bR("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new m.$cR("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$aR.TestItem],m.$bR.Void),new m.$cR("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$aR.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$bR.Void),new m.$cR("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$aR.String.with("name","The context key name"),new m.$aR("value","The context key value",()=>!0,r=>r)],m.$bR.Void),new m.$cR("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$aR.Uri,m.$aR.StringArray,new m.$aR("MappedEditsContext","Mapped Edits Context",r=>s.MappedEditsContext.is(r),r=>s.MappedEditsContext.from(r))],new m.$bR("A promise that resolves to a workspace edit or null",r=>r?s.WorkspaceEdit.to(r):null)),new m.$cR("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$aR("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?s.Range.from(r.initialRange):void 0,initialSelection:I.$gO.isSelection(r.initialSelection)?s.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?s.Position.from(r.position):void 0}})],m.$bR.Void)];class u{static register(a){b.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",T.$Jj)}}e.$drc=u;function k(r){return a=>{if(Array.isArray(a))return a.map(r)}}function $(r){if(!Array.isArray(r))return;const a=[];for(const h of r)L.$Vu(h)?a.push(s.DefinitionLink.to(h)):a.push(s.location.to(h));return a}}),define(Re[257],Oe([1,0,2,35]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jsc=void 0;class P{constructor(R,T,m,s,I){this.a=T,this.b=m,this.c=s;const b=new D.$cR("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new D.$aR("showOptions","Show Options",u=>!0,u=>u),new D.$aR("resource","Interactive resource Uri",u=>!0,u=>u),new D.$aR("controllerId","Notebook controller Id",u=>!0,u=>u),new D.$aR("title","Interactive editor title",u=>!0,u=>u)],new D.$bR("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const k=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri),notebookEditor:k.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri)}}));this.c.registerApiCommand(b)}$willAddInteractiveDocument(R,T,m,s){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:m,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Jsc=P}),define(Re[258],Oe([1,0,17,10,19,6,4,27,2,18,11,5,35,8,7,83,197,21,39,198]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rsc=void 0,e.$Ssc=d,k=Ve(k);let n=class{constructor(E,y,C,O,p){this.m=y,this.n=C,this.o=O,this.q=p,this.b=new T.$Fc,this.c=new T.$Fc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new L.$qe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=E.getProxy(b.$bO.MainThreadNotebookKernels);const w=new u.$cR("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$aR("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const F=this.n.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:F}}else if(A&&"notebookEditor"in A){const F=this.n.getIdByEditor(A.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return A})],u.$bR.Void),M=new u.$cR("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$aR.Uri],new u.$bR("A promise that resolves to an array of variables",(A,F)=>A.map(G=>({variable:{name:G.name,value:G.value,expression:G.expression,type:G.type,language:G.language},hasNamedChildren:G.hasNamedChildren,indexedChildrenCount:G.indexedChildrenCount}))));this.o.registerApiCommand(w),this.o.registerApiCommand(M)}createNotebookController(E,y,C,O,p,w){for(const _ of this.j.values())if(_.controller.id===y&&s.$zn.equals(E.identifier,_.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const M=this.k++,A=this;this.q.trace(`NotebookController[${M}], CREATED by ${E.identifier.value}, ${y}`);const F=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${E.identifier}'`);let G=!1;const x=new L.$qe,j=new L.$qe,U={id:d(E.identifier,y),notebookType:C,extensionId:E.identifier,extensionLocation:E.extensionLocation,label:O||E.identifier.value,preloads:w?w.map(k.NotebookRendererScript.from):[]};let J=p??F,Z,ae;this.a.$addKernel(M,U).catch(_=>{console.log(_),G=!0});let ee=0;const oe=()=>{if(G)return;const _=++ee;Promise.resolve().then(()=>{_===ee&&this.a.$updateKernel(M,U)})},ie=new T.$Fc,ue={get id(){return y},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return U.label},set label(_){U.label=_??E.displayName??E.name,oe()},get detail(){return U.detail??""},set detail(_){U.detail=_,oe()},get description(){return U.description??""},set description(_){U.description=_,oe()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(_){U.supportedLanguages=_,oe()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(_){U.supportsExecutionOrder=_,oe()},get rendererScripts(){return U.preloads?U.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return J},set executeHandler(_){J=_??F},get interruptHandler(){return Z},set interruptHandler(_){Z=_,U.supportsInterrupt=!!_,oe()},set variableProvider(_){(0,h.$DH)(E,"notebookVariableProvider"),ae=_,U.hasVariableProvider=!!_,_?.onDidChangeVariables($e=>A.a.$variablesUpdated($e.uri)),oe()},get variableProvider(){return ae},createNotebookCellExecution(_){if(G)throw new Error("notebook controller is DISPOSED");if(!ie.has(_.notebook.uri))throw A.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map($e=>$e.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.notebook.uri.toString()}`);return A._createNotebookCellExecution(_,d(E.identifier,this.id))},createNotebookExecution(_){if((0,h.$DH)(E,"notebookExecution"),G)throw new Error("notebook controller is DISPOSED");if(!ie.has(_.uri))throw A.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map($e=>$e.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.uri.toString()}`);return A._createNotebookExecution(_,d(E.identifier,this.id))},dispose:()=>{G||(this.q.trace(`NotebookController[${M}], DISPOSED`),G=!0,this.j.delete(M),x.dispose(),j.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(_,$e){$e===$.NotebookControllerAffinity2.Hidden&&(0,h.$DH)(E,"notebookControllerAffinityHidden"),A.a.$updateNotebookPriority(M,_.uri,$e)},onDidReceiveMessage:j.event,postMessage(_,$e){return(0,h.$DH)(E,"notebookMessaging"),A.a.$postMessage(M,$e&&A.n.getIdByEditor($e),_)},asWebviewUri(_){return(0,h.$DH)(E,"notebookMessaging"),(0,r.$FEb)(_,A.m.remote)}};return this.j.set(M,{extensionId:E.identifier,controller:ue,onDidReceiveMessage:j,onDidChangeSelection:x,associatedNotebooks:ie}),ue}getIdByController(E){for(const[y,C]of this.j)if(C.controller===E)return d(C.extensionId,E.id);return null}createNotebookControllerDetectionTask(E,y){const C=this.g++,O=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${E.identifier.value}`),this.a.$addKernelDetectionTask(C,y);const p={dispose:()=>{this.f.delete(C),O.a.$removeKernelDetectionTask(C)}};return this.f.set(C,p),p}registerKernelSourceActionProvider(E,y,C){const O=this.i++,p=typeof C.onDidChangeNotebookKernelSourceActions=="function"?O:void 0,w=this;this.h.set(O,C),this.q.trace(`NotebookKernelSourceActionProvider[${O}], CREATED by ${E.identifier.value}`),this.a.$addKernelSourceActionProvider(O,O,y);let M;return p!==void 0&&(M=C.onDidChangeNotebookKernelSourceActions(A=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(O),w.a.$removeKernelSourceActionProvider(O,O),M?.dispose()}}}async $provideKernelSourceActions(E,y){const C=this.h.get(E);if(C){const O=new R.$Yc;return(await C.provideNotebookKernelSourceActions(y)??[]).map(w=>k.NotebookKernelSourceAction.from(w,this.o.converter,O))}return[]}$acceptNotebookAssociation(E,y,C){const O=this.j.get(E);if(O){const p=this.n.getNotebookDocument(m.URI.revive(y));C?O.associatedNotebooks.set(p.uri,!0):O.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${E}] ASSOCIATE notebook`,p.uri.toString(),C),O.onDidChangeSelection.fire({selected:C,notebook:p.apiNotebook})}}async $executeCells(E,y,C){const O=this.j.get(E);if(!O)return;const p=this.n.getNotebookDocument(m.URI.revive(y)),w=[];for(const M of C){const A=p.getCell(M);A&&w.push(A.apiCell)}try{this.q.trace(`NotebookController[${E}] EXECUTE cells`,p.uri.toString(),w.length),await O.controller.executeHandler.call(O.controller,w,p.apiNotebook,O.controller)}catch(M){this.q.error(`NotebookController[${E}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(E,y,C){const O=this.j.get(E);if(!O)return;const p=this.n.getNotebookDocument(m.URI.revive(y));if(O.controller.interruptHandler)await O.controller.interruptHandler.call(O.controller,p.apiNotebook);else for(const w of C){const M=p.getCell(w);M&&this.b.get(M.uri)?.cancel()}if(O.controller.interruptHandler){const w=this.c.get(p.uri);this.c.delete(p.uri),C.length&&Array.isArray(w)&&w.length&&w.forEach(M=>M.dispose())}}async $provideVariables(E,y,C,O,p,w,M){const A=this.j.get(E);if(!A)return;const F=this.n.getNotebookDocument(m.URI.revive(C)),G=A.controller.variableProvider;if(!G)return;let x;if(O!==void 0){if(x=this.s[O],!x)return}else this.s={};const j=p==="named"?$.NotebookVariablesRequestKind.Named:$.NotebookVariablesRequestKind.Indexed,U=G.provideVariables(F.apiNotebook,x,j,w,M);let J=0;for await(const Z of U){if(M.isCancellationRequested)return;const ae={id:this.r++,name:Z.variable.name,value:Z.variable.value,type:Z.variable.type,interfaces:Z.variable.interfaces,language:Z.variable.language,expression:Z.variable.expression,hasNamedChildren:Z.hasNamedChildren,indexedChildrenCount:Z.indexedChildrenCount,extensionId:A.extensionId.value};if(this.s[ae.id]=Z.variable,this.a.$receiveVariable(y,ae),J++>=i.$mL)return}}$acceptKernelMessageFromRenderer(E,y,C){const O=this.j.get(E);if(!O)return;const p=this.n.getEditorById(y);O.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:C}))}$cellExecutionChanged(E,y,C){const p=this.n.getNotebookDocument(m.URI.revive(E)).getCell(y);if(p){const w=C?k.NotebookCellExecutionState.to(C):$.NotebookCellExecutionState.Idle;w!==void 0&&this.l.fire({cell:p.apiCell,state:w})}}_createNotebookCellExecution(E,y){if(E.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const O=this.n.getNotebookDocument(E.notebook.uri).getCellFromApiCell(E);if(!O)throw new Error("invalid cell");if(this.b.has(O.uri))throw new Error(`duplicate execution for ${O.uri}`);const p=new o(y,O,this.a);this.b.set(O.uri,p);const w=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),w.dispose(),this.b.delete(O.uri))});return p.asApiObject()}_createNotebookExecution(E,y){const C=this.n.getNotebookDocument(E.uri),O=E.getCells().find(M=>{const A=C.getCellFromApiCell(M);return A&&this.b.has(A.uri)});if(O)throw new Error(`duplicate cell execution for ${O.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const p=new g(y,C,this.a),w=p.onDidChangeState(()=>{p.state===l.Resolved&&(p.dispose(),w.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[p,w]),p.asApiObject()}};e.$Rsc=n,e.$Rsc=n=Qe([We(4,I.$fk)],n);var t;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(t||(t={}));class o extends R.$Zc{static{this.a=0}get state(){return this.f}constructor(E,y,C){super(),this.m=y,this.n=C,this.b=o.a++,this.c=new L.$qe,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new P.$Be),this.h=new f(10,O=>this.s(O)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,E,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(E){await this.h.addItem(E)}async s(E){const y=Array.isArray(E)?E:[E];return this.n.$updateExecution(this.b,new c.$9w(y))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(E){let y=this.m;if(E&&(y=this.m.notebook.getCellFromApiCell(E)),!y)throw new Error("INVALID cell");return y.handle}y(E){return E.map(y=>{const C=$.$LP.ensureUniqueMimeTypes(y.items,!0);return C===y.items?k.NotebookCellOutput.from(y):k.NotebookCellOutput.from({items:C,id:y.id,metadata:y.metadata})})}async z(E,y,C){const O=this.w(y),p=this.y((0,v.$6b)(E));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:O,append:C,outputs:p})}async C(E,y,C){return E=$.$LP.ensureUniqueMimeTypes((0,v.$6b)(E),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:E.map(k.NotebookCellOutputItem.from),outputId:y.id,append:C})}asApiObject(){const E=this;return Object.freeze({get token(){return E.g.token},get cell(){return E.m.apiCell},get executionOrder(){return E.j},set executionOrder(C){E.j=C,E.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:E.j}])},start(C){if(E.f===t.Resolved||E.f===t.Started)throw new Error("Cannot call start again");E.f=t.Started,E.c.fire(),E.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,O,p){if(E.f===t.Resolved)throw new Error("Cannot call resolve twice");E.f=t.Resolved,E.c.fire(),E.h.flush();const w=p?{message:p.message,stack:p.stack,location:p?.location?{startLineNumber:p.location.start.line,startColumn:p.location.start.character,endLineNumber:p.location.end.line,endColumn:p.location.end.character}:void 0,uri:p.uri}:void 0;E.n.$completeExecution(E.b,new c.$9w({runEndTime:O,lastRunSuccess:C,error:w}))},clearOutput(C){return E.t(),E.z([],C,!1)},appendOutput(C,O){return E.t(),E.z(C,O,!0)},replaceOutput(C,O){return E.t(),E.z(C,O,!1)},appendOutputItems(C,O){return E.t(),E.C(C,O,!0)},replaceOutputItems(C,O){return E.t(),E.C(C,O,!1)}})}}var l;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(l||(l={}));class g extends R.$Zc{static{this.a=0}get state(){return this.f}constructor(E,y,C){super(),this.h=y,this.j=C,this.b=g.a++,this.c=new L.$qe,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new P.$Be),this.j.$createNotebookExecution(this.b,E,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class f{constructor(E,y){this.f=E,this.g=y,this.a=[],this.b=Date.now()}addItem(E){return this.a.push(E),this.c||(this.c=new D.$8h,this.b=Date.now(),(0,D.$Lh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const E=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>E.complete())}}function d(S,E){return`${S.value}/${E}`}}),define(Re[56],Oe([1,0,6,5,3,2,16,4,7,9,12,180,19,33,181,182,36,10,8,35,38]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=e.$Trc=e.$Src=e.$Rrc=void 0,e.$Rrc=(0,P.$Ki)("IExtHostTerminalService");class t extends T.$Zc{constructor(p,w,M,A){super(),this.u=p,this._id=w,this.w=M,this.y=A,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$qe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(G=>this.g=G);const F=this;this.value={get name(){return F.y||""},get processId(){return F.b},get creationOptions(){return F.w},get exitStatus(){return F.j},get state(){return F.m},get selection(){return F.n},get shellIntegration(){return F.shellIntegration},sendText(G,x=!0){F.C(),F.u.$sendText(F._id,G,x)},show(G){F.C(),F.u.$show(F._id,G)},hide(){F.C(),F.u.$hide(F._id)},dispose(){F.a||(F.a=!0,F.u.$dispose(F._id))},get dimensions(){if(!(F.f===void 0||F.h===void 0))return{columns:F.f,rows:F.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??w?.cwd??void 0,env:p.env??void 0,icon:E(p.iconPath)??void 0,color:a.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:w?.forceShellIntegration??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.z(p.location,w?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,w,M,A,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:A,color:a.ThemeColor.isThemeColor(F)?F.id:void 0,location:w?.location||this.z(p,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,w){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in p?{viewColumn:c.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,w){this.j=Object.freeze({code:p,reason:w})}setDimensions(p,w){return p===this.f&&w===this.h||p===0||w===0?!1:(this.f=p,this.h=w,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(w=>{w!==p&&(this.b=Promise.resolve(p))})}}e.$Src=t;class o{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new v.$qe,this.onProcessData=this.a.event,this.b=new v.$qe,this.d=new v.$qe,this.onDidChangeProperty=this.d.event,this.f=new v.$qe,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,w){this.g.setDimensions?.({columns:p,rows:w})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:$.ProcessPropertyType.OverrideDimensions,value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:$.ProcessPropertyType.Title,value:w})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,g=class extends T.$Zc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,w,M){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$1c),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$qe,this.onDidCloseTerminal=this.H.event,this.I=new v.$qe,this.onDidOpenTerminal=this.I.event,this.J=new v.$qe,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$qe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$qe,this.onDidChangeTerminalState=this.M.event,this.N=new v.$qe,this.onDidChangeShell=this.N.event,this.O=new v.$qe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$qe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(D.$bO.MainThreadTerminalService),this.y=new r.$dAb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:A=>{const F=G=>{const x=G;return this.getTerminalById(x.instanceId)?.value};switch(A?.$mid){case n.MarshalledId.TerminalContext:return F(A);default:{if(Array.isArray(A))for(let G=0;G<A.length&&A[G].$mid===n.MarshalledId.TerminalContext;G++)A[G]=F(A[G]);return A}}}}),this.B({dispose:()=>{for(const[A,F]of this.g)F.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,w){const M=new t(this.a,(0,k.$7g)(),p,p.name),A=new o(p.pty);return M.createExtensionTerminal(p.location,w,this.R(p,w).resolvedExtHostIdentifier,E(p.iconPath),y(p.color)).then(F=>{const G=this.S(F,A);this.h[F]=G}),this.f.push(M),M.value}R(p,w){if(w=w||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const M=p.location.parentTerminal;if(M){const A=this.f.find(F=>F.value===M);A&&(w.resolvedExtHostIdentifier=A._id)}}else p.location&&typeof p.location!="object"?w.location=p.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(p,w){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const A=new o(w),F=this.S(p,A);this.h[p]=F}async $acceptActiveTerminalChanged(p){const w=this.b;if(p===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById(p);M&&(this.b=M,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,w){const M=this.getTerminalById(p);M&&this.O.fire({terminal:M.value,data:w})}async $acceptTerminalDimensions(p,w,M){const A=this.getTerminalById(p);A&&A.setDimensions(w,M)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(p,w){const M=this.getTerminalById(p);M&&this.P.fire({terminal:M.value,...w})}async $acceptTerminalMaximumDimensions(p,w,M){this.g.get(p)?.resize(w,M)}async $acceptTerminalTitleChange(p,w){const M=this.getTerminalById(p);M&&(M.name=w)}async $acceptTerminalClosed(p,w,M){const A=this.X(this.f,p);if(A!==null){const F=this.f.splice(A,1)[0];F.setExitStatus(w,M),this.H.fire(F.value)}}$acceptTerminalOpened(p,w,M,A){if(w){const x=this.X(this.f,w);if(x!==null){this.f[x]._id=p,this.I.fire(this.terminals[x]),this.f[x].isOpen=!0;return}}const F={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:L.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},G=new t(this.a,p,F,M);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(p,w){this.getTerminalById(p)?._setProcessId(w)}async $startExtensionTerminal(p,w){const M=this.getTerminalById(p);if(!M)return{message:(0,s.localize)(2715,null,p)};M.isOpen||await new Promise(F=>{const G=this.onDidOpenTerminal(async x=>{x===M.value&&(G.dispose(),F())})});const A=this.g.get(p);A?A.startSendingEvents(w):this.j[p]={initialDimensions:w}}S(p,w){const M=new T.$Yc;M.add(w.onProcessReady(F=>this.a.$sendProcessReady(p,F.pid,F.cwd,F.windowsPty))),M.add(w.onDidChangeProperty(F=>this.a.$sendProcessProperty(p,F))),this.y.startBuffering(p,w.onProcessData),M.add(w.onProcessExit(F=>this.U(p,F))),this.g.set(p,w);const A=this.j[p];return A&&w instanceof o&&(w.startSendingEvents(A.initialDimensions),delete this.j[p]),M}$acceptProcessAckDataEvent(p,w){this.g.get(p)?.acknowledgeDataEvent(w)}$acceptProcessInput(p,w){this.g.get(p)?.input(w)}$acceptTerminalInteraction(p){const w=this.getTerminalById(p);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(p,w){this.getTerminalById(p)?.setSelection(w)}$acceptProcessResize(p,w,M){try{this.g.get(p)?.resize(w,M)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(p,w){this.g.get(p)?.shutdown(w)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(p,{type:$.ProcessPropertyType.InitialCwd,value:w}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(w=>this.a.$sendProcessProperty(p,{type:$.ProcessPropertyType.Cwd,value:w}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new m.$dO(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,w,M){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,M),this.a.$registerProfileProvider(w,p.identifier.value),new m.$dO(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(p,w,M){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,M),this.a.$registerQuickFixProvider(p,w),new m.$dO(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,w){const M=new u.$Be().token;if(M.isCancellationRequested)return;const A=this.D.get(p);if(!A)return;const F=await A.provideTerminalQuickFixes(w,M);if(F===null||Array.isArray(F)&&F.length===0)return;const G=new T.$Yc;if(this.w.value=G,!Array.isArray(F))return F?c.TerminalQuickFix.from(F,this.Q.converter,G):void 0;const x=[];for(const j of F){const U=c.TerminalQuickFix.from(j,this.Q.converter,G);U&&x.push(U)}return x}async $createContributedProfileTerminal(p,w){const M=new u.$Be().token;let A=await this.C.get(p)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,w);return}this.createTerminalFromOptions(A.options,w)}}async $provideLinks(p,w){const M=this.getTerminalById(p);if(!M)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const F=new u.$Be;this.G.set(p,F);const G=[],x={terminal:M.value,line:w},j=[];for(const Z of this.z)j.push(h.Promises.withAsyncBody(async ae=>{F.token.onCancellationRequested(()=>ae({provider:Z,links:[]}));const ee=await Z.provideTerminalLinks(x,F.token)||[];F.token.isCancellationRequested||ae({provider:Z,links:ee})}));const U=await Promise.all(j);if(F.token.isCancellationRequested)return[];const J=new Map;for(const Z of U)Z&&Z.links.length>0&&G.push(...Z.links.map(ae=>{const ee={id:l++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return J.set(ee.id,{provider:Z.provider,link:ae}),ee}));return this.F.set(p,J),G}$activateLink(p,w){const M=this.F.get(p)?.get(w);M&&M.provider.handleTerminalLink(M.link)}U(p,w){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const M=this.h[p];M&&(M.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,w)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const w=this.f.findIndex(M=>M.value===p);return w>=0?w:null}W(p,w){const M=this.X(p,w);return M!==null?p[M]:null}X(p,w){const M=p.findIndex(A=>A._id===w);return M>=0?M:null}getEnvironmentVariableCollection(p){let w=this.n.get(p.identifier.value);return w||(w=this.B(new f),this.Z(p.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Y(p,w){const M=(0,b.$Ps)(w.map),A=(0,b.$Qs)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(p,w.persistent,M.length===0?void 0:M,A)}$initEnvironmentVariableCollections(p){p.forEach(w=>{const M=w[0],A=this.B(new f(w[1]));this.Z(M,A)})}$acceptDefaultProfile(p,w){const M=this.s;this.s=p,this.u=w,M?.path!==p.path&&this.N.fire(p.path)}Z(p,w){this.n.set(p,w),this.B(w.onDidChangeCollection(()=>{this.Y(p,w)}))}};e.$Trc=g,e.$Trc=g=Qe([We(1,i.$$Q),We(2,R.$OQ)],g);class f extends T.$Zc{get persistent(){return this.b}set persistent(p){this.b=p,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(p){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$qe,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const w=this.j(p);let M=this.a.get(w);return M||(M=new d(this,p),this.a.set(w,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace(p,w,M,A){this.g(p,{value:w,type:m.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:A})}append(p,w,M,A){this.g(p,{value:w,type:m.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:A})}prepend(p,w,M,A){this.g(p,{value:w,type:m.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:A})}g(p,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h(p,w.scope),A=this.map.get(M),F=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==w.value||A.type!==w.type||A.options?.applyAtProcessCreation!==F.applyAtProcessCreation||A.options?.applyAtShellIntegration!==F.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const G=this.h(p,w.scope),x={variable:p,...w,options:F};this.map.set(G,x),this.f.fire()}}get(p,w){const M=this.h(p,w),A=this.map.get(M);return A?C(A):void 0}h(p,w){const M=this.j(w);return M.length?`${p}:::${M}`:p}j(p){return this.m(p?.workspaceFolder)??""}m(p){return p?p.uri.toString():void 0}getVariableMap(p){const w=new Map;for(const[M,A]of this.map)this.j(A.scope)===this.j(p)&&w.set(A.variable,C(A));return w}delete(p,w){const M=this.h(p,w);this.map.delete(M),this.f.fire()}clear(p){if(p?.workspaceFolder){for(const[w,M]of this.map)M.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(w);this.n(p)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(p,w){const M=this.j(w),A=this.descriptionMap.get(M);if(!A||A.description!==p){let F;typeof p=="string"?F=p:F=p?.value.split(`

`)[0];const G={description:F,scope:w};this.descriptionMap.set(M,G),this.f.fire()}}getDescription(p){const w=this.j(p);return this.descriptionMap.get(w)?.description}n(p){const w=this.j(p);this.descriptionMap.delete(w)}}class d{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,w){this.b=p,this.d=w,this.a=new v.$qe}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,w,M){this.b.replace(p,w,M,this.d)}append(p,w,M){this.b.append(p,w,M,this.d)}prepend(p,w,M){this.b.prepend(p,w,M,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,w){this.b.getVariableMap(this.d).forEach((M,A)=>p.call(w,A,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let S=class extends g{constructor(p,w){super(!1,p,w)}createTerminal(p,w,M){throw new I.$db}createTerminalFromOptions(p,w){throw new I.$db}};e.$Urc=S,e.$Urc=S=Qe([We(0,i.$$Q),We(1,R.$OQ)],S);function E(O){if(!(!O||typeof O=="string"))return"id"in O?{id:O.id,color:O.color}:O}function y(O){return a.ThemeColor.isThemeColor(O)?O:void 0}function C(O){const p={...O};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(Re[128],Oe([1,0,7,4,3,5,16,56,6,2,10]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$sc=e.$0sc=void 0,e.$0sc=(0,P.$Ki)("IExtHostTerminalShellIntegration");let b=class extends D.$Zc{constructor(a,h){super(),this.h=h,this.b=new Map,this.c=new m.$qe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$qe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$qe,this.onDidEndTerminalShellExecution=this.g.event,this.a=a.getProxy(L.$bO.MainThreadTerminalShellIntegration),this.B((0,D.$Xc)(()=>{for(const[c,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(a){const h=this.h.getTerminalById(a);if(!h)return;const c=h.value;let i=this.b.get(a);i||(i=new u(h.value,this.f),this.b.set(a,i),i.store.add(h.onWillDispose(()=>this.b.get(a)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this.a.$executeCommand(a,n))),i.store.add(i.onDidRequestEndExecution(n=>this.g.fire(n))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this.c.fire(n))),h.shellIntegration=i.value),this.c.fire({terminal:c,shellIntegration:i.value})}$shellExecutionStart(a,h,c,i,n){this.b.has(a)||this.$shellIntegrationChange(a);const t={value:h,confidence:c,isTrusted:i};this.b.get(a)?.startShellExecution(t,s.URI.revive(n))}$shellExecutionEnd(a,h,c,i,n){const t={value:h,confidence:c,isTrusted:i};this.b.get(a)?.endShellExecution(t,n)}$shellExecutionData(a,h){this.b.get(a)?.emitData(h)}$cwdChange(a,h){this.b.get(a)?.setCwd(s.URI.revive(h))}$closeTerminal(a){this.b.get(a)?.dispose(),this.b.delete(a)}};e.$$sc=b,e.$$sc=b=Qe([We(0,R.$OQ),We(1,T.$Rrc)],b);class u extends D.$Zc{get currentExecution(){return this.a}constructor(a,h){super(),this.j=a,this.m=h,this.b=!1,this.store=this.B(new D.$Yc),this.f=this.B(new m.$qe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$qe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$qe),this.onDidRequestEndExecution=this.h.event;const c=this;this.value={get cwd(){return c.c},executeCommand(i,n){let t=i;n&&(t+=` "${n.map(g=>`${g.replaceAll('"','\\"')}`).join('" "')}"`),c.g.fire(t);const o={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=c.startShellExecution(o,c.c,!0).value;return c.b=!0,l}}}startShellExecution(a,h,c){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new k(a,h??this.c);c?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(a){this.currentExecution?.emitData(a)}endShellExecution(a,h){this.a&&(this.a.endExecution(a),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:h}),this.a=void 0)}setCwd(a){let h=!1;s.URI.isUri(this.c)?h=!s.URI.isUri(a)||this.c.toString()!==a.toString():this.c!==a&&(h=!0),h&&(this.c=a,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class k{constructor(a,h){this.c=a,this.cwd=h,this.b=!1;const c=this;this.value={get commandLine(){return c.c},get cwd(){return c.cwd},read(){return c.d()}}}d(){if(!this.a){if(this.b)return I.$$h.EMPTY;this.a=new $}return this.a.createIterable()}emitData(a){this.a?.emitData(a)}endExecution(a){a&&(this.c=a),this.a?.endExecution(),this.a=void 0,this.b=!0}}class $ extends D.$Zc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Jh);const a=this.a;return new I.$$h(async c=>{this.b.push(c),await a.wait()})}emitData(a){for(const h of this.b)h.emitOne(a)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Re[129],Oe([1,0,61,12,97,8,7]),function(be,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XQ=e.$WQ=e.$VQ=void 0,L=Ve(L);class T{static{this.c=new P.$TQ("TextEditorDecorationType")}constructor(u,k,$){const r=T.c.nextId();u.$registerTextEditorDecorationType(k.identifier,r,L.DecorationRenderOptions.from($)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$VQ=T;class m{constructor(u,k){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,k){this.k();let $=null;if(u instanceof R.$eO)$=new R.$fO(u,u);else if(u instanceof R.$fO)$=u;else throw new Error("Unrecognized location");this.l($,k,!1)}insert(u,k){this.k(),this.l(new R.$fO(u,u),k,!0)}delete(u){this.k();let k=null;if(u instanceof R.$fO)k=u;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(u,k,$){const r=this.c.validateRange(u);this.g.push({range:r,text:k,forceMoveMarkers:$})}setEndOfLine(u){if(this.k(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,D.$$)("endOfLine");this.h=u}}class s{constructor(u,k,$,r){this.c=u,this.d=k,this._accept($),this.e=r;const a=this;this.value={get tabSize(){return a.f},set tabSize(h){a.n(h)},get indentSize(){return a.g},set indentSize(h){a.p(h)},get insertSpaces(){return a.j},set insertSpaces(h){a.s(h)},get cursorStyle(){return a.k},set cursorStyle(h){a.t(h)},get lineNumbers(){return a.l},set lineNumbers(h){a.u(h)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=L.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const k=Math.floor(u);return k>0?k:null}if(typeof u=="string"){const k=parseInt(u,10);return isNaN(k)?null:k>0?k:null}return null}n(u){const k=this.m(u);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const k=Math.floor(u);return k>0?k:null}if(typeof u=="string"){const k=parseInt(u,10);return isNaN(k)?null:k>0?k:null}return null}p(u){const k=this.o(u);if(k!==null){if(typeof k=="number"){if(this.h===k)return;this.g=k,this.h=k}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const k=this.q(u);if(typeof k=="boolean"){if(this.j===k)return;this.j=k}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(u)})))}assign(u){const k={};let $=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?($=!0,k.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,$=!0,k.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?($=!0,k.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,$=!0,k.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?($=!0,k.insertSpaces=r):this.j!==r&&(this.j=r,$=!0,k.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,$=!0,k.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,$=!0,k.lineNumbers=L.TextEditorLineNumbersStyle.from(u.lineNumbers)),$&&this.v("setOptions",this.c.$trySetOptions(this.d,k))}v(u,k){k.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn($)})}}e.$WQ=s;class I{constructor(u,k,$,r,a,h,c,i){this.id=u,this.j=k,this.k=$,this.g=!1,this.h=new Set,this.c=a,this.d=new s(this.j,this.id,h,$),this.e=c,this.f=i;const n=this;this.value=Object.freeze({get document(){return r.value},set document(t){throw new D.$ab("document")},get selection(){return n.c&&n.c[0]},set selection(t){if(!(t instanceof R.$gO))throw(0,D.$$)("selection");n.c=[t],n.l()},get selections(){return n.c},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof R.$gO)))throw(0,D.$$)("selections");n.c=t,n.l()},get visibleRanges(){return n.e},set visibleRanges(t){throw new D.$ab("visibleRanges")},get options(){return n.d.value},set options(t){n.g||n.d.assign(t)},get viewColumn(){return n.f},set viewColumn(t){throw new D.$ab("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new m(r.value,o);return t(l),n.m(l)},insertSnippet(t,o,l={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let g;if(!o||Array.isArray(o)&&o.length===0)g=n.c.map(f=>L.Range.from(f));else if(o instanceof R.$eO){const{lineNumber:f,column:d}=L.Position.from(o);g=[{startLineNumber:f,startColumn:d,endLineNumber:f,endColumn:d}]}else if(o instanceof R.$fO)g=[L.Range.from(o)];else{g=[];for(const f of o)if(f instanceof R.$fO)g.push(L.Range.from(f));else{const{lineNumber:d,column:S}=L.Position.from(f);g.push({startLineNumber:d,startColumn:S,endLineNumber:d,endColumn:S})}}return k.$tryInsertSnippet(u,r.value.version,t.value,g,l)},setDecorations(t,o){const l=o.length===0;l&&!n.h.has(t.key)||(l?n.h.delete(t.key):n.h.add(t.key),n.n(()=>{if(L.$LQ(o))return k.$trySetDecorations(u,t.key,L.$MQ(o));{const g=new Array(4*o.length);for(let f=0,d=o.length;f<d;f++){const S=o[f];g[4*f]=S.start.line+1,g[4*f+1]=S.start.character+1,g[4*f+2]=S.end.line+1,g[4*f+3]=S.end.character+1}return k.$trySetDecorationsFast(u,t.key,g)}}))},revealRange(t,o){n.n(()=>k.$tryRevealRange(u,L.Range.from(t),o||R.TextEditorRevealType.Default))},show(t){k.$tryShowEditor(u,L.ViewColumn.from(t))},hide(){k.$tryHideEditor(u)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,v.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,v.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,v.ok)(!this.g),this.f=u}_acceptSelections(u){(0,v.ok)(!this.g),this.c=u}async l(){const u=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const k=u.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const $=k.edits.map(a=>a.range);$.sort((a,h)=>a.end.line===h.end.line?a.end.character===h.end.character?a.start.line===h.start.line?a.start.character-h.start.character:a.start.line-h.start.line:a.end.character-h.end.character:a.end.line-h.end.line);for(let a=0,h=$.length-1;a<h;a++){const c=$[a].end;if($[a+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=k.edits.map(a=>({range:L.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,r,{setEndOfLine:typeof k.setEndOfLine=="number"?L.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$XQ=I}),define(Re[57],Oe([1,0,61,6,4,2,3,5,125,16,129,8,11,27,15,41,51]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZQ=e.$YQ=void 0,v=Ve(v),b=Ve(b);class h{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(n,t){this.h=n,this.i=t,this.a=null,this.b=new Map,this.c=new k.$Fc,this.d=new D.$qe,this.e=new D.$qe,this.f=new D.$qe,this.g=new D.$qe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const t=[],o=[],l=[];if(n.removedDocuments)for(const g of n.removedDocuments){const f=L.URI.revive(g),d=this.c.get(f);d?.unref()&&(this.c.delete(f),t.push(d.value))}if(n.addedDocuments)for(const g of n.addedDocuments){const f=L.URI.revive(g.uri);let d=this.c.get(f);if(d&&f.scheme!==$.Schemas.vscodeNotebookCell&&f.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);d||(d=new h(new m.$RQ(this.h.getProxy(T.$bO.MainThreadDocuments),f,g.lines,g.EOL,g.versionId,g.languageId,g.isDirty)),this.c.set(f,d),o.push(d.value)),d.ref()}if(n.removedEditors)for(const g of n.removedEditors){const f=this.b.get(g);this.b.delete(g),f&&l.push(f)}if(n.addedEditors)for(const g of n.addedEditors){const f=L.URI.revive(g.documentUri);v.ok(this.c.has(f),`document '${f}' does not exist`),v.ok(!this.b.has(g.id),`editor '${g.id}' already exists!`);const d=this.c.get(f).value,S=new I.$XQ(g.id,this.h.getProxy(T.$bO.MainThreadTextEditors),this.i,new a.$Y(()=>d.document),g.selections.map(b.Selection.to),g.options,g.visibleRanges.map(E=>b.Range.to(E)),typeof g.editorPosition=="number"?b.ViewColumn.to(g.editorPosition):void 0);this.b.set(g.id,S)}n.newActiveEditor!==void 0&&(v.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,P.$Uc)(t),(0,P.$Uc)(l),n.removedDocuments&&this.e.fire(t),n.addedDocuments&&this.d.fire(o),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(g=>g.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return r.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const t=this.b.get(this.a);return n?t:t?.value}allEditors(){return[...this.b.values()]}};e.$YQ=c,e.$YQ=c=Qe([We(0,s.$OQ),We(1,u.$fk)],c),e.$ZQ=(0,R.$Ki)("IExtHostDocumentsAndEditors")}),define(Re[96],Oe([1,0,10,20,19,6,231,76,4,38,14,2,33,3,11,5,35,57,16,127,8,7,200,54,82,55,21]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n,t,o,l,g,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsc=e.$csc=e.$bsc=e.$asc=e.$_rc=void 0,n=Ve(n);let S=0;const E=new WeakMap;e.$_rc=(0,k.$Ki)("IExtHostTesting");let y=class extends m.$Zc{constructor(ee,oe,ie,ue){super(),this.C=oe,this.D=ie,this.F=ue,this.f=this.B(new L.$qe),this.g=new Map,this.w=this.B(new L.$qe),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=ee.getProxy(r.$bO.MainThreadTesting),this.m=new x(this.h),this.j=new w(this.h,oe),ie.registerArgumentProcessor({processArgument:_=>{switch(_?.$mid){case s.MarshalledId.TestItemContext:{const $e=_,Ie=$e.tests[$e.tests.length-1].item.extId;return this.g.get(l.$tJ.root(Ie))?.collection.tree.get(Ie)?.actual??(0,i.$1Q)(_)}case s.MarshalledId.TestMessageMenuArgs:{const{test:$e,message:Ie}=_,X=$e.item.extId;return{test:this.g.get(l.$tJ.root(X))?.collection.tree.get(X)?.actual??(0,i.$1Q)({$mid:s.MarshalledId.TestItemContext,tests:[$e]}),message:n.TestMessage.to(Ie)}}default:return _}}}),ie.registerCommand(!1,"testing.getExplorerSelection",async()=>{const _=await ie.executeCommand(o.TestCommandId.GetExplorerSelection),$e=Ie=>{const X=this.g.get(l.$tJ.root(Ie));if(X)return l.$tJ.isRoot(Ie)?X.controller:X.collection.tree.get(Ie)?.actual};return{include:_?.include.map($e).filter(I.$rg)||[],exclude:_?.exclude.map($e).filter(I.$rg)||[]}})}createTestController(ee,oe,ie,ue){if(this.g.has(oe))throw new Error(`Attempt to insert a duplicate controller with ID "${oe}"`);const _=new m.$Yc,$e=_.add(new i.$4Q(oe,ie,this.F));$e.root.label=ie;const Ie=new Map,X=new Set,V=this.h,re=()=>{let Fe=0;ue&&(Fe|=f.TestControllerCapability.Refresh);const Be=Pe.relatedCodeProvider;return Be&&(Be?.provideRelatedTests&&(Fe|=f.TestControllerCapability.TestRelatedToCode),Be?.provideRelatedCode&&(Fe|=f.TestControllerCapability.CodeRelatedToTest)),Fe},we={items:$e.root.children,get label(){return ie},set label(Fe){ie=Fe,$e.root.label=Fe,V.$updateController(oe,{label:ie})},get refreshHandler(){return ue},set refreshHandler(Fe){ue=Fe,V.$updateController(oe,{capabilities:re()})},get id(){return oe},get relatedCodeProvider(){return Pe.relatedCodeProvider},set relatedCodeProvider(Fe){(0,d.$DH)(ee,"testRelatedCode"),Pe.relatedCodeProvider=Fe,V.$updateController(oe,{capabilities:re()})},createRunProfile:(Fe,Be,xe,nt,ht,$t)=>{let ut=(0,T.$yj)(Fe);for(;Ie.has(ut);)ut++;return new U(this.h,Ie,X,this.w.event,oe,ut,Fe,Be,xe,nt,ht,$t)},createTestItem(Fe,Be,xe){return new i.$2Q(oe,Fe,Be,xe)},createTestRun:(Fe,Be,xe=!0)=>this.j.createTestRun(ee,oe,$e,Fe,Be,xe),invalidateTestResults:Fe=>{if(Fe===void 0)this.h.$markTestRetired(void 0);else{const Be=Fe instanceof Array?Fe:[Fe];this.h.$markTestRetired(Be.map(xe=>l.$tJ.fromExtHostTestItem(xe,oe).toString()))}},set resolveHandler(Fe){$e.resolveHandler=Fe},get resolveHandler(){return $e.resolveHandler},dispose:()=>{_.dispose()}},Pe={controller:we,collection:$e,profiles:Ie,extension:ee,activeProfiles:X};return V.$registerTestController(oe,ie,re()),_.add((0,m.$Xc)(()=>V.$unregisterTestController(oe))),this.g.set(oe,Pe),_.add((0,m.$Xc)(()=>this.g.delete(oe))),_.add($e.onDidGenerateDiff(Fe=>V.$publishDiff(oe,Fe.map(f.TestsDiffOp.serialize)))),we}createTestObserver(){return this.m.checkout()}async runTests(ee,oe=P.CancellationToken.None){const ie=M(ee);if(!ie)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ue=this.g.get(ie.controllerId);if(!ue)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:ee.preserveFocus??!0,group:J[ie.kind],targets:[{testIds:ee.include?.map(_=>l.$tJ.fromExtHostTestItem(_,ue.collection.root.id).toString())??[ue.collection.root.id],profileId:ie.profileId,controllerId:ie.controllerId}],exclude:ee.exclude?.map(_=>_.id)},oe)}registerTestFollowupProvider(ee){return this.y.add(ee),{dispose:()=>{this.y.delete(ee)}}}async $getTestsRelatedToCode(ee,oe,ie){const ue=this.F.getDocument(b.URI.revive(ee));if(!ue)return[];const _=n.Position.to(oe),$e=[];return await Promise.all([...this.g.values()].map(async Ie=>{let X;try{X=await Ie.relatedCodeProvider?.provideRelatedTests?.(ue.document,_,ie)}catch(V){ie.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${Ie.controller.label}`,V)}if(X){for(const V of X)$e.push(l.$tJ.fromExtHostTestItem(V,Ie.controller.id).toString());Ie.collection.flushDiff()}})),$e}async $getCodeRelatedToTest(ee,oe){const ie=this.g.get(l.$tJ.root(ee));if(!ie)return[];const ue=ie.collection.tree.get(ee);return ue?(await ie.relatedCodeProvider?.provideRelatedCode?.(ue.actual,oe))?.map(n.location.from)??[]:[]}$syncTests(){for(const{collection:ee}of this.g.values())ee.flushDiff();return Promise.resolve()}async $getCoverageDetails(ee,oe,ie){return(await this.j.getCoverageDetails(ee,oe,ie))?.map(n.TestCoverage.fromDetails)}async $disposeRun(ee){this.j.disposeTestRun(ee)}$configureRunProfile(ee,oe){this.g.get(ee)?.profiles.get(oe)?.configureHandler?.()}$setDefaultRunProfiles(ee){const oe=new Map;for(const[ie,ue]of Object.entries(ee)){const _=this.g.get(ie);if(!_)continue;const $e=new Map,Ie=ue.filter(V=>!_.activeProfiles.has(V)),X=[..._.activeProfiles].filter(V=>!ue.includes(V));for(const V of Ie)$e.set(V,!0),_.activeProfiles.add(V);for(const V of X)$e.set(V,!1),_.activeProfiles.delete(V);$e.size&&oe.set(ie,$e)}this.w.fire(oe)}async $refreshTests(ee,oe){await this.g.get(ee)?.controller.refreshHandler?.(oe)}$publishTestResults(ee){this.results=Object.freeze(ee.map(oe=>{const ie=n.TestResults.to(oe),ue=oe.tasks.findIndex(_=>_.hasCoverage);return ue!==-1&&(ie.getDetailedCoverage=(_,$e=P.CancellationToken.None)=>this.h.$getCoverageDetails(oe.id,ue,_,$e).then(Ie=>Ie.map(n.TestCoverage.to))),E.set(ie,oe.id),ie}).concat(this.results).sort((oe,ie)=>ie.completedAt-oe.completedAt).slice(0,32)),this.f.fire()}async $expandTest(ee,oe){const ie=this.g.get(l.$tJ.fromString(ee).controllerId)?.collection;ie&&(await ie.expand(ee,oe<0?1/0:oe),ie.flushDiff())}$acceptDiff(ee){this.m.applyDiff(ee.map(oe=>f.TestsDiffOp.deserialize({asCanonicalUri:ie=>ie},oe)))}async $runControllerTests(ee,oe){return Promise.all(ee.map(ie=>this.G(ie,!1,oe)))}async $startContinuousRun(ee,oe){const ie=new P.$Be(oe),ue=await Promise.all(ee.map(_=>this.G(_,!0,ie.token)));return!oe.isCancellationRequested&&!ue.some(_=>_.error)&&await new Promise(_=>oe.onCancellationRequested(_)),ie.dispose(!0),ue}async $provideTestFollowups(ee,oe){const ie=this.results.find($e=>E.get($e)===ee.resultId),ue=ie&&Z(l.$tJ.fromString(ee.extId),ie?.results);if(!ue)return[];let _=[];return await Promise.all([...this.y].map(async $e=>{try{const Ie=await $e.provideFollowup(ie,ue,ee.taskIndex,ee.messageIndex,oe);Ie&&(_=_.concat(Ie))}catch(Ie){this.C.error("Error thrown while providing followup for test message",Ie)}})),oe.isCancellationRequested?[]:_.map($e=>{const Ie=S++;return this.z.set(Ie,$e),{title:$e.title,id:Ie}})}$disposeTestFollowups(ee){for(const oe of ee)this.z.delete(oe)}$executeTestFollowup(ee){const oe=this.z.get(ee);return oe?this.D.executeCommand(oe.command,...oe.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(ee,oe){ee===void 0?this.j.cancelAllRuns():this.j.cancelRunById(ee,oe)}getMetadataForRun(ee){for(const oe of this.j.trackers){const ie=oe.getTaskIdForRun(ee);if(ie)return{taskId:ie,runId:oe.id}}}async G(ee,oe,ie){const ue=this.g.get(ee.controllerId);if(!ue)return{};const{collection:_,profiles:$e,extension:Ie}=ue,X=$e.get(ee.profileId);if(!X)return{};const V=ee.testIds.map(Fe=>_.tree.get(Fe)).filter(I.$rg),re=ee.excludeExtIds.map(Fe=>ue.collection.tree.get(Fe)).filter(I.$rg).filter(Fe=>V.some(Be=>Be.fullId.compare(Fe.fullId)===l.TestPosition.IsChild));if(!V.length)return{};const we=new t.$SP(V.some(Fe=>Fe.actual instanceof i.$3Q)?void 0:V.map(Fe=>Fe.actual),re.map(Fe=>Fe.actual),X,oe),Pe=(0,f.$wJ)(ee)&&this.j.prepareForMainThreadTestRun(Ie,we,A.fromInternal(ee,ue.collection),X,ie);try{return await X.runHandler(we,ie),{}}catch(Fe){return{error:String(Fe)}}finally{Pe&&Pe.hasRunningTasks&&!ie.isCancellationRequested&&await L.Event.toPromise(Pe.onEnd)}}};e.$asc=y,e.$asc=y=Qe([We(0,c.$OQ),We(1,$.$fk),We(2,a.$$Q),We(3,h.$ZQ)],y);const C=1e4;var O;(function(ae){ae[ae.Running=0]="Running",ae[ae.Cancelling=1]="Cancelling",ae[ae.Ended=2]="Ended"})(O||(O={}));class p extends m.$Zc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(ee,oe,ie,ue,_,$e){super(),this.C=ee,this.D=oe,this.F=ie,this.G=ue,this.H=_,this.f=O.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new L.$qe),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new P.$Be($e));const Ie=this.B(new v.$Wh(()=>this.I(),C));this.B(this.m.token.onCancellationRequested(()=>Ie.schedule()));const X=new L.$qe;this.y=X.event,this.B((0,m.$Xc)(()=>{X.fire(),X.dispose()}))}getTaskIdForRun(ee){for(const[oe,{run:ie}]of this.h)if(ie===ee)return oe}cancel(ee){ee?this.h.get(ee)?.cts.cancel():this.f===O.Running?(this.m.cancel(),this.f=O.Cancelling):this.f===O.Cancelling&&this.I()}async getCoverageDetails(ee,oe,ie){const[,ue]=l.$tJ.fromString(ee).path,_=this.z.get(ee);if(!_)return[];const{report:$e,extIds:Ie}=_,X=this.h.get(ue);if(!X)throw new Error("unreachable: run task was not found");let V;if(oe&&$e instanceof t.$YP){const we=Ie.indexOf(oe);if(we===-1)return[];V=$e.fromTests[we]}return await(V?this.G?.loadDetailedCoverageForTest?.(X.run,$e,V,ie):this.G?.loadDetailedCoverage?.(X.run,$e,ie))??[]}createRun(ee){const oe=this.C.id,ie=this.C.controllerId,ue=(0,u.$7g)(),_=re=>(we,...Pe)=>{if(Ie){this.F.warn(`Setting the state of test "${we.id}" is a no-op after the run ends.`);return}this.L(we),re(we,...Pe)},$e=(re,we)=>{const Pe=we instanceof Array?we.map(n.TestMessage.from):[n.TestMessage.from(we)];if(re.uri&&re.range){const Fe={range:n.Range.from(re.range),uri:re.uri};for(const Be of Pe)Be.location=Be.location||Fe}this.D.$appendTestMessagesInRun(oe,ue,l.$tJ.fromExtHostTestItem(re,ie).toString(),Pe)};let Ie=!1;const X=this.B(new P.$Be(this.m.token)),V={isPersisted:this.C.isPersisted,token:X.token,name:ee,onDidDispose:this.y,addCoverage:re=>{if(Ie)return;const we=re instanceof t.$YP?re.fromTests:[];if(we.length){(0,d.$DH)(this.H,"attributableCoverage");for(const Be of we)this.L(Be)}const Pe=re.uri.toString(),Fe=new l.$tJ([oe,ue,Pe]).toString();this.z.set(Fe,{report:re,extIds:we.map(Be=>l.$tJ.fromExtHostTestItem(Be,ie).toString())}),this.D.$appendCoverage(oe,ue,n.TestCoverage.fromFile(ie,Fe,re))},enqueued:_(re=>{this.D.$updateTestStateInRun(oe,ue,l.$tJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Queued)}),skipped:_(re=>{this.D.$updateTestStateInRun(oe,ue,l.$tJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Skipped)}),started:_(re=>{this.D.$updateTestStateInRun(oe,ue,l.$tJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Running)}),errored:_((re,we,Pe)=>{$e(re,we),this.D.$updateTestStateInRun(oe,ue,l.$tJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Errored,Pe)}),failed:_((re,we,Pe)=>{$e(re,we),this.D.$updateTestStateInRun(oe,ue,l.$tJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Failed,Pe)}),passed:_((re,we)=>{this.D.$updateTestStateInRun(oe,ue,l.$tJ.fromExtHostTestItem(re,this.C.controllerId).toString(),f.TestResultState.Passed,we)}),appendOutput:(re,we,Pe)=>{Ie||(Pe&&this.L(Pe),this.D.$appendOutputToRun(oe,ue,D.$Se.fromString(re),we&&n.location.from(we),Pe&&l.$tJ.fromExtHostTestItem(Pe,ie).toString()))},end:()=>{Ie||(Ie=!0,this.D.$finishedTestRunTask(oe,ue),--this.g||this.J())}};return this.g++,this.h.set(ue,{run:V,cts:X}),this.D.$startedTestRunTask(oe,{id:ue,ctrlId:this.C.controllerId,name:ee||this.H.displayName||this.H.identifier.value,running:!0}),V}I(){for(const{run:ee}of this.h.values())ee.end()}J(){this.f!==O.Ended&&(this.f=O.Ended,this.w.fire())}L(ee){if(!(ee instanceof i.$2Q))throw new g.$GQ(ee.id);if(this.j.has(l.$tJ.fromExtHostTestItem(ee,this.C.controllerId).toString()))return;const oe=[],ie=this.C.colllection.root;for(;;){const ue=n.TestItem.from(ee);if(oe.unshift(ue),this.j.has(ue.extId)||(this.j.add(ue.extId),ee===ie))break;ee=ee.parent||ie}this.D.$addTestsToRun(this.C.controllerId,this.C.id,oe)}dispose(){this.J(),super.dispose()}}class w{get trackers(){return this.f.values()}constructor(ee,oe){this.h=ee,this.j=oe,this.f=new Map,this.g=new Map}getCoverageDetails(ee,oe,ie){const ue=l.$tJ.root(ee);return this.g.get(ue)?.getCoverageDetails(ee,oe,ie)||[]}disposeTestRun(ee){this.g.get(ee)?.dispose(),this.g.delete(ee);for(const[oe,{id:ie}]of this.f)ie===ee&&this.f.delete(oe)}prepareForMainThreadTestRun(ee,oe,ie,ue,_){return this.k(oe,ie,ue,ee,_)}cancelRunById(ee,oe){this.g.get(ee)?.cancel(oe)}cancelAllRuns(){for(const ee of this.f.values())ee.cancel()}createTestRun(ee,oe,ie,ue,_,$e){const Ie=this.f.get(ue);if(Ie)return Ie.createRun(_);const X=A.fromPublic(oe,ie,ue,$e),V=M(ue);this.h.$startedExtensionTestRun({controllerId:oe,continuous:!!ue.continuous,profile:V&&{group:J[V.kind],id:V.profileId},exclude:ue.exclude?.map(we=>l.$tJ.fromExtHostTestItem(we,ie.root.id).toString())??[],id:X.id,include:ue.include?.map(we=>l.$tJ.fromExtHostTestItem(we,ie.root.id).toString())??[ie.root.id],preserveFocus:ue.preserveFocus??!0,persist:$e});const re=this.k(ue,X,ue.profile,ee);return L.Event.once(re.onEnd)(()=>{this.h.$finishedExtensionTestRun(X.id)}),re.createRun(_)}k(ee,oe,ie,ue,_){const $e=new p(oe,this.h,this.j,ie,ue,_);return this.f.set(ee,$e),this.g.set($e.id,$e),$e}}e.$bsc=w;const M=ae=>{if(ae.profile){if(!(ae.profile instanceof U))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ae.profile}};class A{static fromPublic(ee,oe,ie,ue){return new A(ee,(0,u.$7g)(),ue,oe)}static fromInternal(ee,oe){return new A(ee.controllerId,ee.runId,!0,oe)}constructor(ee,oe,ie,ue){this.controllerId=ee,this.id=oe,this.isPersisted=ie,this.colllection=ue}}e.$csc=A;class F{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(ee){this.k=ee,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(ee){this.f.add(ee)}update(ee){Object.assign(ee.revived,n.TestItem.toPlain(ee.item)),this.f.has(ee)||this.g.add(ee)}remove(ee){if(this.f.has(ee)){this.f.delete(ee);return}this.g.delete(ee);const oe=l.$tJ.parentId(ee.item.extId);if(oe&&this.j.has(oe.toString())){this.j.add(ee.item.extId);return}this.h.add(ee)}getChangeEvent(){const{f:ee,g:oe,h:ie}=this;return{get added(){return[...ee].map(ue=>ue.revived)},get updated(){return[...oe].map(ue=>ue.revived)},get removed(){return[...ie].map(ue=>ue.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class G extends f.$CJ{constructor(){super(...arguments),this.z=new L.$qe,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(ee){return this.g.get(ee)}getMirroredTestDataByReference(ee){return this.g.get(ee.id)}y(ee,oe){return{...ee,revived:n.TestItem.toPlain(ee.item),depth:oe?oe.depth+1:0,children:new Set}}x(){return new F(this.z)}}class x{constructor(ee){this.g=ee}checkout(){this.f||(this.f=this.h());const ee=this.f;return ee.observers++,{onDidChangeTest:ee.tests.onDidChangeTests,get tests(){return[...ee.tests.rootTests].map(oe=>oe.revived)},dispose:(0,R.$hb)(()=>{--ee.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(ee){return this.f?.tests.getMirroredTestDataByReference(ee)}applyDiff(ee){this.f?.tests.apply(ee)}h(){const ee=new G({asCanonicalUri:oe=>oe});return this.g.$subscribeToDiffs(),{observers:0,tests:ee}}}const j=(ae,ee,oe,ie)=>{oe?Object.assign(oe,ie):ee.$updateTestRunConfig(ae.controllerId,ae.profileId,ie)};class U{#e;#t;#i;#n;#s;get label(){return this.g}set label(ee){ee!==this.g&&(this.g=ee,j(this,this.#e,this.#n,{label:ee}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(ee){ee!==this.h&&(this.h=ee,j(this,this.#e,this.#n,{supportsContinuousRun:ee}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(ee){ee!==this.isDefault&&(ee?this.#t.add(this.profileId):this.#t.delete(this.profileId),j(this,this.#e,this.#n,{isDefault:ee}))}get tag(){return this._tag}set tag(ee){ee?.id!==this._tag?.id&&(this._tag=ee,j(this,this.#e,this.#n,{tag:ee?n.TestTag.namespace(this.controllerId,ee.id):null}))}get configureHandler(){return this.f}set configureHandler(ee){ee!==this.f&&(this.f=ee,j(this,this.#e,this.#n,{hasConfigurationHandler:!!ee}))}get onDidChangeDefault(){return L.Event.chain(this.#i,ee=>ee.map(oe=>oe.get(this.controllerId)?.get(this.profileId)).filter(I.$rg))}constructor(ee,oe,ie,ue,_,$e,Ie,X,V,re=!1,we=void 0,Pe=!1){this.controllerId=_,this.profileId=$e,this.g=Ie,this.kind=X,this.runHandler=V,this._tag=we,this.h=Pe,this.#e=ee,this.#s=oe,this.#t=ie,this.#i=ue,oe.set($e,this);const Fe=J[X];if(typeof Fe!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);re&&ie.add($e),this.#n={profileId:$e,controllerId:_,tag:we?n.TestTag.namespace(this.controllerId,we.id):null,label:Ie,group:Fe,isDefault:re,hasConfigurationHandler:!1,supportsContinuousRun:Pe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$dsc=U;const J={[t.TestRunProfileKind.Coverage]:f.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:f.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:f.TestRunProfileBitset.Run};function Z(ae,ee){for(let oe=0;oe<ae.path.length;oe++){const ie=ee.find(ue=>ue.id===ae.path[oe]);if(!ie)return;if(oe===ae.path.length-1)return ie;ee=ie.children}}}),define(Re[259],Oe([1,0,17,6,4,5,129,8,7]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=void 0,v=Ve(v),T=Ve(T);class s extends P.$Zc{constructor(b,u){super(),this.m=u,this.a=new D.$qe,this.b=new D.$qe,this.c=new D.$qe,this.f=new D.$qe,this.g=new D.$qe,this.h=new D.$qe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=b.getProxy(L.$bO.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(k=>this.h.fire(k))),this.B(this.m.onDidChangeActiveTextEditor(k=>this.g.fire(k)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(b){const u=this.m.allEditors();return b?u:u.map(k=>k.value)}async showTextDocument(b,u,k){let $;typeof u=="number"?$={position:T.ViewColumn.from(u),preserveFocus:k}:typeof u=="object"?$={position:T.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?T.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:$={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(b.uri,$),a=r&&this.m.getEditor(r);if(a)return a.value;throw r?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}createTextEditorDecorationType(b,u){return new R.$VQ(this.j,b,u).value}$acceptEditorPropertiesChanged(b,u){const k=this.m.getEditor(b);if(!k)throw new Error("unknown text editor");if(u.options&&k._acceptOptions(u.options),u.selections){const $=u.selections.selections.map(T.Selection.to);k._acceptSelections($)}if(u.visibleRanges){const $=v.$Lb(u.visibleRanges.map(T.Range.to));k._acceptVisibleRanges($)}if(u.options&&this.b.fire({textEditor:k.value,options:{...u.options,lineNumbers:T.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const $=m.TextEditorSelectionChangeKind.fromValue(u.selections.source),r=u.selections.selections.map(T.Selection.to);this.a.fire({textEditor:k.value,selections:r,kind:$})}if(u.visibleRanges){const $=v.$Lb(u.visibleRanges.map(T.Range.to));this.c.fire({textEditor:k.value,visibleRanges:$})}}$acceptEditorPositionData(b){for(const u in b){const k=this.m.getEditor(u);if(!k)throw new Error("Unknown text editor");const $=T.ViewColumn.to(b[u]);k.value.viewColumn!==$&&(k._acceptViewColumn($),this.f.fire({textEditor:k.value,viewColumn:$}))}}getDiffInformation(b){return Promise.resolve(this.j.$getDiffInformation(b))}}e.$krc=s}),define(Re[260],Oe([1,0,2,3,5,4,7,8,18,38,14]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$btc=e.$atc=void 0,e.$atc=(0,D.$Ki)("IExtHostTimeline");class b{constructor($,r){this.b=new Map,this.c=new Map,this.a=$.getProxy(P.$bO.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(a,h)=>{if(a&&a.$mid===s.MarshalledId.TimelineActionContext)if(this.b.get(a.source)&&m.$zn.equals(h,this.b.get(a.source)?.extension)){const c=a.uri===void 0?void 0:v.URI.revive(a.uri);return this.c.get(a.source)?.get(u(c))?.get(a.handle)}else return;return a}})}async $getTimeline($,r,a,h){return this.b.get($)?.provider.provideTimeline(v.URI.revive(r),a,h)}registerTimelineProvider($,r,a,h){const c=new L.$Yc,i=this.d(r.id,h,c).bind(this);let n;r.onDidChange&&(n=r.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:r.id}),this));const t=this.c;return this.f({...r,scheme:$,onDidChange:void 0,async provideTimeline(o,l,g){l?.resetCache&&(c.clear(),t.get(r.id)?.clear());const f=await r.provideTimeline(o,l,g);if(f==null)return;const d=i(o,l);return{...f,source:r.id,items:f.items.map(d)}},dispose(){for(const o of t.values())o.get(r.id)?.clear();n?.dispose(),c.dispose()}},a)}d($,r,a){return(h,c)=>{let i;if(c?.cacheResults){let n=this.c.get($);n===void 0&&(n=new Map,this.c.set($,n));const t=u(h);i=n.get(t),i===void 0&&(i=new Map,n.set(t,i))}return n=>{const{iconPath:t,...o}=n,l=`${$}|${n.id??n.timestamp}`;i?.set(l,n);let g,f,d;n.iconPath&&(t instanceof R.$cP?d={id:t.id,color:t.color}:v.URI.isUri(t)?(g=t,f=t):{light:g,dark:f}=t);let S;return R.$HO.isMarkdownString(o.tooltip)?S=T.MarkdownString.from(o.tooltip):(0,I.$jg)(o.tooltip)?S=o.tooltip:R.$HO.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=T.MarkdownString.from(o.detail)):(0,I.$jg)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=o.detail),{...o,id:o.id??void 0,handle:l,source:$,command:n.command?r.toInternal(n.command,a):void 0,icon:g,iconDark:f,themeIcon:d,tooltip:S,accessibilityInformation:n.accessibilityInformation}}}}f($,r){if(this.b.get($.id))throw new Error(`Timeline Provider ${$.id} already exists.`);return this.a.$registerTimelineProvider({id:$.id,label:$.label,scheme:$.scheme}),this.b.set($.id,{provider:$,extension:r}),(0,L.$Xc)(()=>{for(const h of this.c.values())h.get($.id)?.clear();this.b.delete($.id),this.a.$unregisterTimelineProvider($.id),$.dispose()})}}e.$btc=b;function u(k){return k?.toString()}}),define(Re[261],Oe([1,0,9,24,2,6,4,192,10,7,14,17,8,59,19,156,21]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ctc=void 0,s=Ve(s);function h(n,t){if((0,I.$jg)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let o;return Array.isArray(n.highlights)&&(o=n.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),o=o.length?o:void 0),{label:n.label,highlights:o}}}class c extends R.$Zc{constructor(t,o,l){super(),this.f=t,this.g=o,this.h=l,this.a=new Map,this.b=new r.$sab;function g(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:f=>g(f)?this.r(f):Array.isArray(f)&&f.length>0?f.map(d=>g(d)?this.r(d):d):f})}registerTreeDataProvider(t,o,l){const g=this.createTreeView(t,{treeDataProvider:o},l);return{dispose:()=>g.dispose()}}createTreeView(t,o,l){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=o.dragAndDropController?.dropMimeTypes??[],f=o.dragAndDropController?.dragMimeTypes??[],d=!!o.dragAndDropController?.handleDrag,S=!!o.dragAndDropController?.handleDrop,E=this.m(t,o,l),y={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:g,dragMimeTypes:f,hasHandleDrag:d,hasHandleDrop:S,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,y),O={get onDidCollapseElement(){return E.onDidCollapseElement},get onDidExpandElement(){return E.onDidExpandElement},get selection(){return E.selectedElements},get onDidChangeSelection(){return E.onDidChangeSelection},get activeItem(){return(0,a.$DH)(l,"treeViewActiveItem"),E.focusedElement},get onDidChangeActiveItem(){return(0,a.$DH)(l,"treeViewActiveItem"),E.onDidChangeActiveItem},get visible(){return E.visible},get onDidChangeVisibility(){return E.onDidChangeVisibility},get onDidChangeCheckboxState(){return E.onDidChangeCheckboxState},get message(){return E.message},set message(p){(0,k.$$k)(p)&&(0,a.$DH)(l,"treeViewMarkdownMessage"),E.message=p},get title(){return E.title},set title(p){E.title=p},get description(){return E.description},set description(p){E.description=p},get badge(){return E.badge},set badge(p){p!==void 0&&s.ViewBadge.isViewBadge(p)?E.badge={value:Math.floor(Math.abs(p.value)),tooltip:p.tooltip}:p===void 0&&(E.badge=void 0)},reveal:(p,w)=>E.reveal(p,w),dispose:async()=>{await C,this.a.delete(t),E.dispose()}};return this.B(O),O}$getChildren(t,o){const l=this.a.get(t);return l?l.getChildren(o):Promise.reject(new T.$VG(t))}async $handleDrop(t,o,l,g,f,d,S,E){const y=this.a.get(t);if(!y)return Promise.reject(new T.$VG(t));const C=u.DataTransfer.toDataTransfer(l,async O=>(await this.f.$resolveDropFileData(t,o,O)).buffer);return S===t&&E&&await this.j(C,y,E,f,d),y.onDrop(C,g,f)}async j(t,o,l,g,f){const d=this.b.removeDragOperationTransfer(f);if(d)(await d)?.forEach((S,E)=>{S&&t.set(E,S)});else if(f&&o.handleDrag){const S=o.handleDrag(l,t,g);this.b.addDragOperationTransfer(f,S),await S}return t}async $handleDrag(t,o,l,g){const f=this.a.get(t);if(!f)return Promise.reject(new T.$VG(t));const d=await this.j(new s.$$O,f,o,g,l);if(!(!d||g.isCancellationRequested))return u.DataTransfer.from(d)}async $hasResolve(t){const o=this.a.get(t);if(!o)throw new T.$VG(t);return o.hasResolve}$resolve(t,o,l){const g=this.a.get(t);if(!g)throw new T.$VG(t);return g.resolveTreeItem(o,l)}$setExpanded(t,o,l){const g=this.a.get(t);if(!g)throw new T.$VG(t);g.setExpanded(o,l)}$setSelectionAndFocus(t,o,l){const g=this.a.get(t);if(!g)throw new T.$VG(t);g.setSelectionAndFocus(o,l)}$setVisible(t,o){const l=this.a.get(t);if(!l){if(!o)return;throw new T.$VG(t)}l.setVisible(o)}$changeCheckboxState(t,o){const l=this.a.get(t);if(!l)throw new T.$VG(t);l.setCheckboxState(o)}m(t,o,l){const g=this.B(new i(t,o,this.f,this.g.converter,this.h,l));return this.a.set(t,g),g}r(t){const o=this.a.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.$ctc=c;class i extends R.$Zc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$sg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,o,l,g,f,d){if(super(),this.I=t,this.J=l,this.L=g,this.M=f,this.N=d,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$qe),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$qe),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$qe),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$qe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$qe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$qe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$qe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$Be,d.contributes&&d.contributes.views)for(const C in d.contributes.views)for(const O of d.contributes.views[C])O.id===t&&(this.P=O.name);this.f=o.treeDataProvider,this.g=o.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let S,E;const y=L.Event.debounce(this.F.event,(C,O)=>(C||(C={message:!1,elements:[]}),O.element!==!1&&(S||(S=new Promise(p=>E=p),this.G=this.G.then(()=>S)),Array.isArray(O.element)?C.elements.push(...O.element):C.elements.push(O.element)),O.message&&(C.message=!0),C),200,!0);this.B(y(({message:C,elements:O})=>{O.length&&(this.H=this.H.then(()=>{const p=E;return S=null,this.$(O).then(()=>p())})),C&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let l=this.X(t);return l||(l=await this.Y(o)),l?l.map(g=>g.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const l=(0,I.$sg)(o.select)?!0:o.select,g=(0,I.$sg)(o.focus)?!1:o.focus,f=(0,I.$sg)(o.expand)?!1:o.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(d=>this.W(t,d[d.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:d.map(E=>E.item)},{select:l,focus:g,expand:f})),d=>this.M.error(d)):this.J.$reveal(this.I,void 0,{select:l,focus:g,expand:f})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,o){const l=this.getExtensionElement(t);l&&(o?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(t,o){const l=!(0,b.$yb)(this.s,t);this.s=t;const g=this.t!==o;this.t=o,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),g&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async l=>{const g=this.getExtensionElement(l.treeItemHandle);return g?{extensionItem:g,treeItem:await this.f.getTreeItem(g),newState:l.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);o.forEach(l=>{l.treeItem.checkboxState=l.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}),this.D.fire({items:o.map(l=>[l.extensionItem,l.newState])})}async handleDrag(t,o,l){const g=[];for(const f of t){const d=this.getExtensionElement(f);d&&g.push(d)}if(!(!this.g?.handleDrag||g.length===0))return await this.g.handleDrag(g,o,l),o}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,o,l){const g=o?this.getExtensionElement(o):void 0;if(!(!g&&o||!this.g?.handleDrop))return(0,m.$Ch)(()=>this.g?.handleDrop?this.g.handleDrop(g,t,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,o){if(!this.f.resolveTreeItem)return;const l=this.j.get(t);if(l){const g=this.m.get(l);if(g){const f=await this.f.resolveTreeItem(g.extensionItem,l,o)??g.extensionItem;return this.hb(f),g.item.tooltip=this.eb(f.tooltip),g.item.command=this.fb(g.disposableStore,f.command),g.item}}}S(t){return this.U(t).then(o=>o?this.S(o).then(l=>this.W(o,l[l.length-1]).then(g=>(l.push(g),l))):Promise.resolve([]))}U(t){const o=this.m.get(t);return o?Promise.resolve(o.parent?this.j.get(o.parent.item.handle):void 0):(0,m.$Ch)(()=>this.f.getParent(t))}W(t,o){const l=this.m.get(t);return l?Promise.resolve(l):(0,m.$Ch)(()=>this.f.getTreeItem(t)).then(g=>this.kb(t,g,o,!0)).then(g=>this.getChildren(o?o.item.handle:void 0).then(()=>{const f=this.getExtensionElement(g);if(f){const d=this.m.get(f);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${g} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let o;if(typeof t=="string"){const l=this.getExtensionElement(t);o=l?this.m.get(l):void 0}else o=t;return o&&o.children||void 0}return this.h}async Y(t){this.rb(t);const o=new $.$Be(this.Z.token);try{const l=t?this.m.get(t):void 0,g=await this.f.getChildren(t);if(o.token.isCancellationRequested)return;const f=(0,b.$Lb)(g||[]),d=await Promise.all((0,b.$Lb)(f).map(E=>this.f.getTreeItem(E)));if(o.token.isCancellationRequested)return;const S=d.map((E,y)=>E?this.db(f[y],E,l):null);return(0,b.$Lb)(S)}finally{o.dispose()}}$(t){if(t.some(l=>!l))return this.Z.dispose(!0),this.Z=new $.$Be,this.tb(),this.J.$refresh(this.I);{const l=this.ab(t);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(t){const o=new Set,l=t.map(f=>this.m.get(f));for(const f of l)if(f&&!o.has(f.item.handle)){let d=f;for(;d&&d.parent&&l.findIndex(S=>d&&d.parent&&S&&S.item.handle===d.parent.item.handle)===-1;){const S=this.j.get(d.parent.item.handle);d=S?this.m.get(S):void 0}d&&!d.parent&&o.add(f.item.handle)}const g=[];return o.forEach(f=>{const d=this.j.get(f);if(d){const S=this.m.get(d);S&&(!S.parent||!o.has(S.parent.item.handle))&&g.push(f)}}),g}bb(t){const o={};return Promise.all(t.map(l=>this.cb(l).then(g=>{g&&(o[l]=g.item)}))).then(()=>Object.keys(o).length?this.J.$refresh(this.I,o):void 0)}cb(t){const o=this.getExtensionElement(t);if(o){const l=this.m.get(o);if(l)return this.rb(o),(0,m.$Ch)(()=>this.f.getTreeItem(o)).then(g=>{if(g){const f=this.ib(o,g,l.parent);return this.pb(o,f,l,l.parent),l.dispose(),f}return null})}return Promise.resolve(null)}db(t,o,l){const g=this.ib(t,o,l);if(o.id&&this.j.has(g.item.handle))throw new Error((0,v.localize)(2716,null,o.id));return this.ob(t,g),this.qb(g,l),g}eb(t){return s.$HO.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,o){return o?{...this.L.toInternal(o,t),originalId:o.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let o,l,g;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,l=t.checkboxState.tooltip,g=t.checkboxState.accessibilityInformation),{isChecked:o===s.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:g}}hb(t){if(!s.$6O.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,o,l){this.hb(o);const g=this.B(new R.$Yc),f=this.kb(t,o,l),d=this.lb(o);return{item:{handle:f,parentHandle:l?l.item.handle:void 0,label:h(o.label,this.N),description:o.description,resourceUri:o.resourceUri,tooltip:this.eb(o.tooltip),command:this.fb(g,o.command),contextValue:o.contextValue,icon:d,iconDark:this.mb(o)||d,themeIcon:this.jb(o),collapsibleState:(0,I.$sg)(o.collapsibleState)?s.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.gb(o)},extensionItem:o,parent:l,children:void 0,disposableStore:g,dispose(){g.dispose()}}}jb(t){return t.iconPath instanceof s.$cP?t.iconPath:void 0}kb(t,{id:o,label:l,resourceUri:g},f,d){if(o)return`${i.b}/${o}`;const S=h(l,this.N),E=f?f.item.handle:i.a;let y=S?S.label:g?(0,D.$ih)(g):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,O=this.X(f)||[];let p,w=0;do{if(p=`${E}/${w}:${y}`,d||!this.j.has(p)||C===p)break;w++}while(w<=O.length);return p}lb(t){if(t.iconPath&&!(t.iconPath instanceof s.$cP))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof s.$cP)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return P.URI.isUri(t)?t:P.URI.file(t)}ob(t,o){this.j.set(o.item.handle,t),this.m.set(t,o)}pb(t,o,l,g){this.j.delete(o.item.handle),this.m.delete(t),o.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(t,o);const f=this.X(g)||[],d=f.filter(S=>S.item.handle===l.item.handle)[0];d&&f.splice(f.indexOf(d),1,o)}qb(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const o=this.m.get(t);if(o){if(o.children)for(const l of o.children){const g=this.j.get(l.item.handle);g&&this.sb(g)}o.children=void 0}}else this.tb()}sb(t){const o=this.m.get(t);if(o){if(o.children)for(const l of o.children){const g=this.j.get(l.item.handle);g&&this.sb(g)}this.m.delete(t),this.j.delete(o.item.handle),o.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[262],Oe([1,0,6,4,2,33,8,67,5,7]),function(be,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=void 0,R=Ve(R),m=Ve(m),s=Ve(s);class I extends D.$Zc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor($,r,a,h){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new v.$qe),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$qe),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=r,this.#n=a,this.#i=h.viewType,this.#s=h.panelOptions,this.#o=h.viewColumn,this.#r=h.title,this.#l=h.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title($){this.c(),this.#r!==$&&(this.#r=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#a}set iconPath($){this.c(),this.#a!==$&&(this.#a=$,this.#t.$setIconPath(this.#e,P.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState($){this.#u||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#l=$.active,this.#c=$.visible,this.#o=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:R.ViewColumn.from($),preserveFocus:!!r})}c(){if(this.#u)throw new Error("Webview is disposed")}}class b extends D.$Zc{static c(){return(0,L.$7g)()}constructor($,r,a){super(),this.j=r,this.m=a,this.g=new Map,this.h=new Map,this.f=$.getProxy(m.$bO.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,r,a,h,c={}){const i=typeof h=="object"?h.viewColumn:h,n={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof h=="object"&&!!h.preserveFocus},t=(0,T.$zrc)($),o=b.c();this.f.$createWebviewPanel((0,T.$Brc)($),o,r,{title:a,panelOptions:u(c),webviewOptions:(0,T.$Crc)($,this.m,c),serializeBuffersForPostMessage:t},n);const l=this.j.createNewWebview(o,c,$);return this.createNewWebviewPanel(o,r,a,i,c,l,!0)}$onDidChangeWebviewPanelViewStates($){const r=Object.keys($);r.sort((a,h)=>{const c=$[a],i=$[h];return c.active?1:i.active?-1:+c.visible-+i.visible});for(const a of r){const h=this.getWebviewPanel(a);if(!h)continue;const c=$[a];h._updateViewState({active:c.active,visible:c.visible,viewColumn:R.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.j.deleteWebview($)}registerWebviewPanelSerializer($,r,a){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:a,extension:$}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,T.$zrc)($)}),new s.$dO(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel($,r,a,h){const c=this.h.get(r);if(!c)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:n}=c,t=this.j.createNewWebview($,a.webviewOptions,n),o=this.createNewWebviewPanel($,r,a.title,h,a.panelOptions,t,a.active);await i.deserializeWebviewPanel(o,a.state)}createNewWebviewPanel($,r,a,h,c,i,n){const t=new I($,this.f,i,{viewType:r,title:a,viewColumn:h,panelOptions:c,active:n});return this.g.set($,t),t}getWebviewPanel($){return this.g.get($)}}e.$Drc=b;function u(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(Re[263],Oe([1,0,6,4,67,8,5,7]),function(be,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ftc=void 0,R=Ve(R),T=Ve(T);class m extends D.$Zc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(b,u,k,$,r,a){super(),this.#s=!1,this.#l=this.B(new v.$qe),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new v.$qe),this.onDidDispose=this.#u.event,this.#i=k,this.#a=$,this.#e=b,this.#t=u,this.#n=r,this.#r=a}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(b){this.a(),this.#a!==b&&(this.#a=b,this.#t.$setWebviewViewTitle(this.#e,b))}get description(){return this.a(),this.#o}set description(b){this.a(),this.#o!==b&&(this.#o=b,this.#t.$setWebviewViewDescription(this.#e,b))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(b){b===this.#r||this.#s||(this.#r=b,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(b){this.a(),!(b?.value===this.#c?.value&&b?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(b),this.#t.$setWebviewViewBadge(this.#e,b))}show(b){this.a(),this.#t.$show(this.#e,!!b)}a(){if(this.#s)throw new Error("Webview is disposed")}}class s{constructor(b,u){this.d=u,this.b=new Map,this.c=new Map,this.a=b.getProxy(R.$bO.MainThreadWebviewViews)}registerWebviewViewProvider(b,u,k,$){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:k,extension:b}),this.a.$registerWebviewViewProvider((0,P.$Brc)(b),u,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$zrc)(b)}),new T.$dO(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(b,u,k,$,r){const a=this.b.get(u);if(!a)throw new Error(`No view provider found for '${u}'`);const{provider:h,extension:c}=a,i=this.d.createNewWebview(b,{},c),n=new m(b,this.a,u,k,i,!0);this.c.set(b,n),await h.resolveWebviewView(n,{state:$},r)}async $onDidChangeWebviewViewVisibility(b,u){this.e(b)._setVisible(u)}async $disposeWebviewView(b){const u=this.e(b);this.c.delete(b),u.dispose(),this.d.deleteWebview(b)}e(b){const u=this.c.get(b);if(!u)throw new Error("No webview found");return u}}e.$ftc=s}),define(Re[264],Oe([1,0,6,29,31,3]),function(be,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=e.$wN=e.OutputChannelUpdateMode=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=void 0,e.$kN="text/x-code-output",e.$lN="Log",e.$mN="text/x-code-log-output",e.$nN="log",e.$oN="workbench.panel.output",e.$pN=new P.$2j("inOutput",!1),e.$qN=new P.$2j("activeLogOutput",!1),e.$rN=new P.$2j("activeLogOutput.levelSettable",!1),e.$sN=new P.$2j("activeLogOutput.level",""),e.$tN=new P.$2j("activeLogOutput.levelIsDefault",!1),e.$uN=new P.$2j("outputView.scrollLock",!1),e.$vN=(0,L.$Ki)("outputService");var R;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$wN={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new v.$qe,this.onDidRegisterChannel=this.b.event,this.c=new v.$qe,this.onDidRemoveChannel=this.c.event}registerChannel(s){this.a.has(s.id)||(this.a.set(s.id,s),this.b.fire(s.id))}getChannels(){const s=[];return this.a.forEach(I=>s.push(I)),s}getChannel(s){return this.a.get(s)}removeChannel(s){this.a.delete(s),this.c.fire(s)}}D.$zo.add(e.$wN.OutputChannels,new T),e.$xN=new P.$2j("activeOutputChannel","")}),define(Re[130],Oe([1,0,5,3,16,18,11,264,68,26,50,158,20,14,28,6,4]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vsc=e.$Usc=void 0;class h extends R.$lk{get disposed(){return this.n}constructor(t,o,l,g,f){super(),this.id=t,this.name=o,this.r=l,this.s=g,this.extension=f,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(d=>this.setLevel(d)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,o),this.visible&&this.r.flush()}show(t,o){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.s.$close(this.id)}g(t,o){this.m+=u.$Se.fromString(o).byteLength,(0,R.log)(this.r,t,o),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class c extends h{appendLine(t){this.append(t)}}let i=class{constructor(t,o,l,g,f,d){this.i=o,this.j=l,this.k=g,this.l=f,this.m=d,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$bO.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,b.$_m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[o,l]of this.g)l.visible=o===this.h}createOutputChannel(t,o,l){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const g=typeof o=="object"&&o.log,f=(0,k.$jg)(o)?o:void 0;if((0,k.$jg)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let d;const S=this.i.environment.extensionLogLevel?.find(([y])=>L.$zn.equals(l.identifier,y))?.[1];S&&(d=(0,R.$wk)(S));const E=g?this.o(t,d,l):this.n(t,f,l);return E.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),g?this.r(t,d??this.m.getLevel(),E):this.q(t,E)}async n(t,o,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const g=await this.c,f=this.k.extUri.joinPath(g,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.l.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(t,f,o,l.identifier.value);return new h(S,t,d,this.a,l)}async o(t,o,l){const g=await this.p(l),f=t.replace(/[\\/:\*\?"<>\|]/g,""),d=this.k.extUri.joinPath(g,`${f}.log`),S=`${l.identifier.value}.${f}`,E=this.l.createLogger(d,{id:S,name:t,logLevel:o,extensionId:l.identifier.value});return new c(S,t,E,this.a,l)}p(t){let o=this.d.get(t.identifier.value);if(!o){const l=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(l)}catch(g){if((0,$.$vl)(g)!==$.FileSystemProviderErrorCode.FileExists)throw g}return l})())}return o}q(t,o){let l=!1;const g=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return t},append(f){g(),o.then(d=>d.append(f))},appendLine(f){g(),o.then(d=>d.appendLine(f))},clear(){g(),o.then(f=>f.clear())},replace(f){g(),o.then(d=>d.replace(f))},show(f,d){g(),o.then(S=>S.show(f,d))},hide(){g(),o.then(f=>f.hide())},dispose(){l=!0,o.then(f=>f.dispose())}}}r(t,o,l){const g=new a.$Yc,f=()=>{if(g.isDisposed)throw new Error("Channel has been closed")},d=g.add(new r.$qe);function S(E){o=E,d.fire(E)}return l.then(E=>{g.add(E),E.logLevel!==o&&S(E.logLevel),g.add(E.onDidChangeLogLevel(y=>S(y)))}),{...this.q(t,l),get logLevel(){return o},onDidChangeLogLevel:d.event,trace(E,...y){f(),l.then(C=>C.trace(E,...y))},debug(E,...y){f(),l.then(C=>C.debug(E,...y))},info(E,...y){f(),l.then(C=>C.info(E,...y))},warn(E,...y){f(),l.then(C=>C.warn(E,...y))},error(E,...y){f(),l.then(C=>C.error(E,...y))},dispose(){g.dispose()}}}};e.$Usc=i,e.$Usc=i=Qe([We(0,P.$OQ),We(1,s.$5Q),We(2,m.$vrc),We(3,I.$$qc),We(4,R.$gk),We(5,R.$fk)],i),e.$Vsc=(0,D.$Ki)("IExtHostOutputService")}),define(Re[131],Oe([1,0,3,10]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$2m=(0,v.$Ki)("remoteAgentService"),e.$3m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let L=1/0;for(let T=0;T<this.maxSampleCount;T++){const m=await P.getRoundTripTime();if(m===void 0)return;L=Math.min(L,m/2),await(0,D.$Lh)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((T,m)=>T+m,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((T,m)=>T+m,0)/this.average.length,high:typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[265],Oe([1,0,9,53,29,49,44,4,6,131,23,25,10,115]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=void 0,e.$CL=Object.freeze({id:"application",order:100,title:(0,v.localize)(3980,null),type:"object"}),e.$DL=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(3981,null),type:"object"}),e.$EL=Object.freeze({id:"security",scope:D.ConfigurationScope.APPLICATION,title:(0,v.localize)(3982,null),type:"object",order:7}),e.$FL=Object.freeze({id:"problems",title:(0,v.localize)(3983,null),type:"object",order:101}),e.$GL=Object.freeze({id:"window",order:8,title:(0,v.localize)(3984,null),type:"object"}),e.$HL={ConfigurationMigration:"base.contributions.configuration.migration"};class ${constructor(){this.migrations=[],this.a=new m.$qe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new $;P.$zo.add(e.$HL.ConfigurationMigration,r);let a=class extends T.$Zc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const l of o.added)await this.f(l,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(o=>this.g(o,n?.uri))])}async g(n,t){const o=this.a.inspect(n.key,{resource:t}),l=this.b.getWorkbenchState()===L.WorkbenchState.WORKSPACE?[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE],["workspaceFolder",R.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE]];for(const[g,f]of l){const d=o[g];if(!d)continue;const S=[];if(d.value!==void 0){const E=await this.h(n,g,d.value,t,void 0);for(const y of E??[])S.push([y,[]])}for(const{identifiers:E,value:y}of d.overrides??[])if(y!==void 0){const C=await this.h(n,g,y,t,E);for(const O of C??[])S.push([O,E])}S.length&&await Promise.allSettled(S.map(async([[E,y],C])=>this.a.updateValue(E,y.value,{resource:t,overrideIdentifiers:C},f)))}}async h(n,t,o,l,g){const f=S=>{const y=this.a.inspect(S,{resource:l})[t];if(y)return g?y.overrides?.find(({identifiers:C})=>(0,b.$qo)(C,g))?.value:y.value},d=await n.migrateFn(o,f);return Array.isArray(d)?d:[[n.key,d]]}};e.$IL=a,e.$IL=a=Qe([We(0,R.$ej),We(1,L.$Ti)],a);let h=class extends T.$Zc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new u.$8h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$l&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;P.$zo.as(D.$Eo.Configuration).registerConfiguration({...e.$EL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(3985,null)},default:[],markdownDescription:(0,v.localize)(3986,null),scope:D.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(3987,null),scope:D.ConfigurationScope.MACHINE}}})}};e.$JL=h,e.$JL=h=Qe([We(0,s.$2m)],h),e.$KL="window.newWindowProfile";let c=class extends T.$Zc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,t){super(),this.c=n,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(o=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(o=>{o.source!==R.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.$KL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=P.$zo.as(D.$Eo.Configuration),t={...e.$GL,properties:{[e.$KL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(o=>o.name),null],enumItemLabels:[...this.c.profiles.map(o=>""),(0,v.localize)(3988,null)],description:(0,v.localize)(3989,null),scope:D.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[t],remove:[this.a]}):n.registerConfiguration(t),this.a=t}h(){const n=this.f.getValue(e.$KL);this.b=n?this.c.profiles.find(t=>t.name===n):void 0}j(){const n=this.f.getValue(e.$KL);if(!n)return;const t=this.b?this.c.profiles.find(o=>o.id===this.b.id):void 0;n!==t?.name&&this.f.updateValue(e.$KL,t?.name)}};e.$LL=c,e.$LL=c=Qe([We(0,k.$Rl),We(1,R.$ej)],c)}),define(Re[266],Oe([1,0,43,15,22,24,9,265,53,3,29]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$NL=e.$ML=void 0,e.$OL=r,e.$PL=a,v=Ve(v),e.$ML=(0,s.$Ki)("editorResolverService"),e.$NL="workbench.editorAssociations";const b=I.$zo.as(m.$Eo.Configuration),u={...T.$DL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(12180,null),additionalProperties:{type:"string"}}}};b.registerConfiguration(u);var k;(function(h){h.builtin="builtin",h.option="option",h.exclusive="exclusive",h.default="default"})(k||(e.RegisteredEditorPriority=k={}));var $;(function(h){h[h.ABORT=1]="ABORT",h[h.NONE=2]="NONE"})($||(e.ResolvedStatus=$={}));function r(h){switch(h){case k.exclusive:return 5;case k.default:return 4;case k.builtin:return 3;case k.option:default:return 1}}function a(h,c){if(new Set([D.Schemas.extension,D.Schemas.webviewPanel,D.Schemas.vscodeWorkspaceTrust,D.Schemas.vscodeSettings]).has(c.scheme))return!1;const t=typeof h=="string"&&h.indexOf(P.$lc.sep)>=0?`${c.scheme}:${c.path}`:(0,L.$ih)(c);return v.$Ek(typeof h=="string"?h.toLowerCase():h,t.toLowerCase())}}),define(Re[267],Oe([1,0,73,15,22,23,24,2,3,186,49,205,131]),function(be,e,v,D,P,L,R,T,m,s,I,b,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=e.$PN=void 0,e.$PN=(0,m.$Ki)("pathService");let $=k=class{constructor(a,h,c,i){this.d=a,this.e=h,this.f=c,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??a})()}hasValidBasename(a,h,c){return typeof h=="string"||typeof h>"u"?this.a.then(i=>this.h(a,i,h)):this.h(a,h,c)}h(a,h,c){return a.scheme===D.Schemas.file||a.scheme===D.Schemas.vscodeRemote?(0,v.$Hg)(c??(0,R.$ih)(a),h===L.OperatingSystem.Windows):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,h){if(a.remoteAuthority)return D.Schemas.vscodeRemote;const c=(0,s.$MN)(h.getWorkspace());if(c)return c;const i=h.getWorkspace().folders[0];if(i)return i.uri.scheme;const n=h.getWorkspace().configuration;return n?n.scheme:D.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===L.OperatingSystem.Windows?P.$kc:P.$lc)}async fileURI(a){let h="";if(await this.a===L.OperatingSystem.Windows&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const i=a.indexOf("/",2);i===-1?(h=a.substring(2),a="/"):(h=a.substring(2,i),a=a.substring(i)||"/")}return T.URI.from({scheme:D.Schemas.file,authority:h,path:a,query:"",fragment:""})}};e.$QN=$,e.$QN=$=k=Qe([We(1,u.$2m),We(2,b.$yN),We(3,I.$Ti)],$)}),define(Re[58],Oe([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.ExcludeSettingOptions=e.$qM=e.$pM=e.$oM=e.$nM=void 0;class v{constructor(s,I){this.line=s,this.character=I}isBefore(s){return!1}isBeforeOrEqual(s){return!1}isAfter(s){return!1}isAfterOrEqual(s){return!1}isEqual(s){return!1}compareTo(s){return 0}translate(s,I){return new v(0,0)}with(s){return new v(0,0)}}e.$nM=v;class D{constructor(s,I,b,u){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(s,I),this.end=new v(b,u)}contains(s){return!1}isEqual(s){return!1}intersection(s){}union(s){return new D(0,0,0,0)}with(s){return new D(0,0,0,0)}}e.$oM=D;class P{constructor(s,I,b){this.uri=s,this.ranges=I,this.previewText=b}}e.$pM=P;class L{constructor(s,I,b){this.uri=s,this.text=I,this.lineNumber=b}}e.$qM=L;var R;(function(m){m[m.None=1]="None",m[m.FilesExclude=2]="FilesExclude",m[m.SearchAndFilesExclude=3]="SearchAndFilesExclude"})(R||(e.ExcludeSettingOptions=R={}));var T;(function(m){m[m.Information=1]="Information",m[m.Warning=2]="Warning"})(T||(e.TextSearchCompleteMessageType=T={}))}),define(Re[40],Oe([1,0,17,43,25,73,13,3,22,12,58,10]),function(be,e,v,D,P,L,R,T,m,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$QM=e.$OM=e.$HM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$EM=e.$DM=e.$CM=e.$BM=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.TextSearchCompleteMessageType=void 0,e.$yM=h,e.$zM=c,e.$AM=i,e.$FM=E,e.$GM=y,e.$IM=p,e.$JM=w,e.$KM=M,e.$LM=A,e.$MM=F,e.$NM=G,e.$PM=j,e.$RM=Z,e.$SM=ae,e.$TM=oe,D=Ve(D),P=Ve(P),L=Ve(L),m=Ve(m),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$rM="workbench.view.search",e.$sM="workbench.panel.search",e.$tM="workbench.view.search",e.$uM="search-result",e.$vM="search.exclude",e.$wM=2e4;const u="\u27EA ",k=" characters skipped \u27EB",$=(u.length+k.length+5)*2;e.$xM=(0,T.$Ki)("searchService");var r;(function(ie){ie[ie.file=0]="file",ie[ie.text=1]="text",ie[ie.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var a;(function(ie){ie[ie.File=1]="File",ie[ie.Text=2]="Text",ie[ie.aiText=3]="aiText"})(a||(e.QueryType=a={}));function h(ie){return!!ie.rangeLocations&&!!ie.previewText}function c(ie){return!!ie.resource}function i(ie){return!!ie.message}var n;(function(ie){ie[ie.Normal=0]="Normal",ie[ie.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class t{constructor(ue){this.resource=ue,this.results=[]}}e.$BM=t;class o{constructor(ue,_,$e,Ie){this.rangeLocations=[],this.webviewIndex=Ie;const X=Array.isArray(_)?_:[_];if($e&&$e.matchLines===1&&l(X)){ue=(0,R.$cg)(ue,$e.matchLines);let V="",re=0,we=0;const Pe=Math.floor($e.charsPerLine/5);for(const Fe of X){const Be=Math.max(Fe.startColumn-Pe,0),xe=Fe.startColumn+$e.charsPerLine;if(Be>we+Pe+$){const nt=u+(Be-we)+k;V+=nt+ue.slice(Be,xe),re+=Be-(we+nt.length)}else V+=ue.slice(we,xe);we=xe,this.rangeLocations.push({source:Fe,preview:new f(0,Fe.startColumn-re,Fe.endColumn-re)})}this.previewText=V}else{const V=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber,re=(0,v.$5b)(_,we=>({preview:new g(we.startLineNumber-V,we.startColumn,we.endLineNumber-V,we.endColumn),source:we}));this.rangeLocations=Array.isArray(re)?re:[re],this.previewText=ue}}}e.$CM=o;function l(ie){const ue=ie[0].startLineNumber;for(const _ of ie)if(_.startLineNumber!==ue||_.endLineNumber!==ue)return!1;return!0}class g{constructor(ue,_,$e,Ie){this.startLineNumber=ue,this.startColumn=_,this.endLineNumber=$e,this.endColumn=Ie}}e.$DM=g;class f extends g{constructor(ue,_,$e){super(ue,_,ue,$e)}}e.$EM=f;var d;(function(ie){ie.List="list",ie.Tree="tree"})(d||(e.ViewMode=d={}));var S;(function(ie){ie.Default="default",ie.FileNames="fileNames",ie.Type="type",ie.Modified="modified",ie.CountDescending="countDescending",ie.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function E(ie,ue=!0){const _=ie&&ie.files&&ie.files.exclude,$e=ue&&ie&&ie.search&&ie.search.exclude;if(!_&&!$e)return;if(!_||!$e)return _||$e||void 0;let Ie=Object.create(null);return Ie=P.$po(Ie,P.$mo(_)),Ie=P.$po(Ie,P.$mo($e),!0),Ie}function y(ie,ue){return ie.excludePattern&&D.$Ek(ie.excludePattern,ue)?!1:ie.includePattern||ie.usingSearchPaths?ie.includePattern&&D.$Ek(ie.includePattern,ue)?!0:ie.usingSearchPaths?!!ie.folderQueries&&ie.folderQueries.some(_=>{const $e=_.folder.fsPath;if(L.$Jg(ue,$e)){const Ie=m.$qc($e,ue);return!_.includePattern||!!D.$Ek(_.includePattern,Ie)}else return!1}):!1:!0}var C;(function(ie){ie[ie.unknownEncoding=1]="unknownEncoding",ie[ie.regexParseError=2]="regexParseError",ie[ie.globParseError=3]="globParseError",ie[ie.invalidLiteral=4]="invalidLiteral",ie[ie.rgProcessError=5]="rgProcessError",ie[ie.other=6]="other",ie[ie.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class O extends Error{constructor(ue,_){super(ue),this.code=_}}e.$HM=O;function p(ie){const ue=ie.message;if((0,s.$8)(ie))return new O(ue,C.canceled);try{const _=JSON.parse(ue);return new O(_.message,_.code)}catch{return new O(ue,C.other)}}function w(ie){const ue={message:ie.message,code:ie.code};return new Error(JSON.stringify(ue))}function M(ie){return ie.type==="error"?!0:ie.type==="success"}function A(ie){return ie.type==="success"}function F(ie){return!!ie.path}function G(ie,ue,_=!0){const $e=ie.searchPath?ie.searchPath:ie.relativePath;return _?(0,R.$_f)($e,ue):D.$Ek(ue,$e)}class x{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$OM=x;function j(ie,ue){const _={...ie||{},...ue||{}};return Object.keys(_).filter($e=>{const Ie=_[$e];return typeof Ie=="boolean"&&Ie})}class U{constructor(ue,_){this.c=null,this.a=_.excludePattern?.map(Ie=>({...ue.excludePattern||{},...Ie.pattern||{}}))??[],this.a.length===0&&(this.a=[ue.excludePattern||{}]),this.b=this.a.map(Ie=>D.$Fk(Ie));let $e=ue.includePattern;_.includePattern&&($e?$e={...$e,..._.includePattern}:$e=_.includePattern),$e&&(this.c=D.$Fk($e))}d(ue,_,$e){let Ie=null;for(const X of this.b){const V=X(ue,_,$e);if(typeof V=="string"){Ie=V;break}}return Ie}matchesExcludesSync(ue,_,$e){return!!(this.b&&this.d(ue,_,$e))}includedInQuerySync(ue,_,$e){return!(this.b&&this.d(ue,_,$e)||this.c&&!this.c(ue,_,$e))}includedInQuery(ue,_,$e){const Ie=()=>this.c?!!this.c(ue,_,$e):!0;return Promise.all(this.b.map(X=>{const V=X(ue,_,$e);return(0,b.$wh)(V)?V.then(re=>re?!1:Ie()):Ie()})).then(X=>X.some(V=>!!V))}hasSiblingExcludeClauses(){return this.a.reduce((ue,_)=>J(_)||ue,!1)}}e.$QM=U;function J(ie){for(const ue in ie)if(typeof ie[ue]!="boolean")return!0;return!1}function Z(ie){if(!ie)return;let ue;return _=>(ue||(ue=(ie()||Promise.resolve([])).then($e=>$e?ee($e):{})),ue.then($e=>!!$e[_]))}function ae(ie){if(!ie)return;let ue;return _=>{if(!ue){const $e=ie();ue=$e?ee($e):{}}return!!ue[_]}}function ee(ie){const ue={};for(const _ of ie)ue[_]=!0;return ue}function oe(ie){return ie.flatMap(ue=>ue.patterns.map(_=>ue.baseUri?{baseUri:ue.baseUri,pattern:_}:_))}e.$UM={matchLines:100,charsPerLine:1e4}}),define(Re[45],Oe([1,0,17,10,19,6,4,48,15,142,24,13,2,9,28,3,11,174,49,50,26,16,8,7,65,40,5,34,58]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n,t,o,l,g,f,d,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qrc=e.$prc=void 0;function y(x,j,U){return new I.$ah(J=>w(J,U)).isEqual(x,j)}function C(x,j,U){return y(x.uri,j.uri,U)?0:(0,b.$Df)(x.uri.toString(),j.uri.toString())}function O(x,j,U){return x.index!==j.index?x.index<j.index?-1:1:y(x.uri,j.uri,U)?(0,b.$Df)(x.name,j.name):(0,b.$Df)(x.uri.toString(),j.uri.toString())}function p(x,j,U,J){const Z=x.slice(0).sort((ee,oe)=>U(ee,oe,J)),ae=j.slice(0).sort((ee,oe)=>U(ee,oe,J));return(0,v.$Ib)(Z,ae,(ee,oe)=>U(ee,oe,J))}function w(x,j){const U=j.getCapabilities(x.scheme);return!(U&&U&$.FileSystemProviderCapabilities.PathCaseSensitive)}class M extends c.$4i{static toExtHostWorkspace(j,U,J,Z){if(!j)return{workspace:null,added:[],removed:[]};const{id:ae,name:ee,folders:oe,configuration:ie,transient:ue,isUntitled:_}=j,$e=[],Ie=U;U?oe.forEach((we,Pe)=>{const Fe=u.URI.revive(we.uri),Be=M.o(J||U,Fe,Z);Be?(Be.name=we.name,Be.index=we.index,$e.push(Be)):$e.push({uri:Fe,name:we.name,index:Pe})}):$e.push(...oe.map(({uri:we,name:Pe,index:Fe})=>({uri:u.URI.revive(we),name:Pe,index:Fe}))),$e.sort((we,Pe)=>we.index<Pe.index?-1:1);const X=new M(ae,ee,$e,!!ue,ie?u.URI.revive(ie):null,!!_,we=>w(we,Z)),{added:V,removed:re}=p(Ie?Ie.workspaceFolders:[],X.workspaceFolders,C,Z);return{workspace:X,added:V,removed:re}}static o(j,U,J){for(let Z=0;Z<j.folders.length;Z++){const ae=j.workspaceFolders[Z];if(y(ae.uri,U,J))return ae}}constructor(j,U,J,Z,ae,ee,oe){super(j,J.map(ie=>new c.$5i(ie)),Z,ae,oe),this.t=U,this.u=ee,this.q=[],this.s=T.$Qi.forUris(oe,()=>!0),J.forEach(ie=>{this.q.push(ie),this.s.set(ie.uri,ie)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,U){return U&&this.s.get(j)&&(j=(0,I.$kh)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let A=class{constructor(j,U,J,Z,ae){this.c=new L.$qe,this.onDidChangeWorkspace=this.c.event,this.g=new L.$qe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.B=0,this.C=new L.$se,this.D=new Map,this.h=Z,this.s=J,this.t=ae,this.j=new s.$Sm,this.k=new D.$Jh,this.o=j.getProxy(d.$bO.MainThreadWorkspace),this.q=j.getProxy(d.$bO.MainThreadMessageService);const ee=U.workspace;this.l=ee?new M(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,oe=>w(oe,J)):void 0}$initializeWorkspace(j,U){this.v=U,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:m.Schemas.untitled,path:(0,I.$ih)((0,I.$kh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,U,J,...Z){const ae=[];if(Array.isArray(Z)&&Z.forEach(_=>{u.URI.isUri(_.uri)&&!ae.some($e=>y($e.uri,_.uri,this.s))&&ae.push({uri:_.uri,name:_.name||(0,I.$hh)(_.uri)})}),this.n||[U,J].some(_=>typeof _!="number"||_<0)||J===0&&ae.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(U+J>ee.length)return!1;const oe=ee.slice(0);oe.splice(U,J,...ae.map(_=>({uri:_.uri,name:_.name||(0,I.$hh)(_.uri),index:void 0})));for(let _=0;_<oe.length;_++){const $e=oe[_];if(oe.some((Ie,X)=>X!==_&&y($e.uri,Ie.uri,this.s)))return!1}oe.forEach((_,$e)=>_.index=$e);const{added:ie,removed:ue}=p(ee,oe,O,this.s);if(ie.length===0&&ue.length===0)return!1;if(this.o){const _=j.displayName||j.name;this.o.$updateWorkspaceFolders(_,U,J,ae).then(void 0,$e=>{this.n=void 0;const Ie={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(h.Severity.Error,(0,k.localize)(2719,null,_,$e.toString()),Ie,[])})}return this.y(oe),!0}getWorkspaceFolder(j,U){if(this.x)return this.x.getWorkspaceFolder(j,U)}async getWorkspaceFolder2(j,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,U)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,U){let J,Z="";if(typeof j=="string"?(J=u.URI.file(j),Z=j):typeof j<"u"&&(J=j,Z=j.fsPath),!J)return Z;const ae=this.getWorkspaceFolder(J,!0);if(!ae)return Z;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ee=(0,I.$nh)(ae.uri,J);return U&&ae.name&&(ee=`${ae.name}/${ee}`),ee}y(j){this.x&&(this.n=M.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:U,added:J,removed:Z}=M.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:J,removed:Z}))}findFiles(j,U,J,Z,ae=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Z.value}, entryPoint: findFiles`);let ee="",oe=!0;return U===null?oe=!1:U!==void 0&&(typeof U=="string"?ee=U:ee=U.pattern),this.z(j,void 0,{exclude:[ee],maxResults:J,useExcludeSettings:oe?E.ExcludeSettingOptions.FilesExclude:E.ExcludeSettingOptions.None,useIgnoreFiles:{local:!1}},ae)}findFiles2(j,U={},J,Z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${J.value}, entryPoint: findFiles2`);const ae=U.useDefaultExcludes??!0,ee=U.useDefaultSearchExcludes??!0,oe=ae?ee?E.ExcludeSettingOptions.SearchAndFilesExclude:E.ExcludeSettingOptions.FilesExclude:E.ExcludeSettingOptions.None,ie={exclude:U.exclude?[U.exclude]:void 0,useIgnoreFiles:{local:U.useIgnoreFiles,global:U.useGlobalIgnoreFiles,parent:U.useParentIgnoreFiles},useExcludeSettings:oe,followSymlinks:U.followSymlinks,maxResults:U.maxResults};return this.z(void 0,j!==void 0?[j]:[],ie,Z)}findFiles2New(j,U={},J,Z=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2New: fileSearch, extension: ${J.value}, entryPoint: findFiles2New`),this.z(void 0,j,U,Z)}async z(j,U,J,Z=P.CancellationToken.None){if(Z&&Z.isCancellationRequested)return Promise.resolve([]);const ee=(j!==void 0?[j]:U)?.map(oe=>{const ie=G(J.exclude),ue={ignoreSymlinks:typeof J.followSymlinks=="boolean"?!J.followSymlinks:void 0,disregardIgnoreFiles:typeof J.useIgnoreFiles?.local=="boolean"?!J.useIgnoreFiles.local:void 0,disregardGlobalIgnoreFiles:typeof J.useIgnoreFiles?.global=="boolean"?!J.useIgnoreFiles.global:void 0,disregardParentIgnoreFiles:typeof J.useIgnoreFiles?.parent=="boolean"?!J.useIgnoreFiles.parent:void 0,disregardExcludeSettings:J.useExcludeSettings!==void 0&&J.useExcludeSettings===E.ExcludeSettingOptions.None,disregardSearchExcludeSettings:J.useExcludeSettings!==void 0&&J.useExcludeSettings!==E.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:J.maxResults,excludePattern:ie.length>0?ie:void 0,_reason:"startFileSearch",shouldGlobSearch:j?void 0:!0},_=F(o.GlobPattern.from(oe)),$e=_?.folder;return j?ue.includePattern=_?.pattern:ue.filePattern=_?.pattern,{folder:$e,options:ue}})??[];return this.A(ee,Z)}async A(j,U){return(await Promise.all(j?.map(Z=>this.o.$startFileSearch(Z.folder??null,Z.options,U).then(ae=>Array.isArray(ae)?ae.map(ee=>u.URI.revive(ee)):[]))??[])).flat()}findTextInFilesNew(j,U,J,Z){this.h.trace(`extHostWorkspace#findTextInFilesNew: textSearch, extension: ${U.value}, entryPoint: findTextInFilesNew`);const ae=_=>{if(!J)return{folder:void 0,options:{}};const $e=_?F(o.GlobPattern.from(_)):void 0,Ie=G(J.exclude);return{options:{ignoreSymlinks:typeof J.followSymlinks=="boolean"?!J.followSymlinks:void 0,disregardIgnoreFiles:typeof J.useIgnoreFiles=="boolean"?!J.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof J.useIgnoreFiles?.global=="boolean"?!J.useIgnoreFiles?.global:void 0,disregardParentIgnoreFiles:typeof J.useIgnoreFiles?.parent=="boolean"?!J.useIgnoreFiles?.parent:void 0,disregardExcludeSettings:J.useExcludeSettings!==void 0&&J.useExcludeSettings===E.ExcludeSettingOptions.None,disregardSearchExcludeSettings:J.useExcludeSettings!==void 0&&J.useExcludeSettings!==E.ExcludeSettingOptions.SearchAndFilesExclude,fileEncoding:J.encoding,maxResults:J.maxResults,previewOptions:J.previewOptions?{matchLines:J.previewOptions?.numMatchLines??100,charsPerLine:J.previewOptions?.charsPerLine??1e4}:void 0,surroundingContext:J.surroundingContext,includePattern:$e?.pattern,excludePattern:Ie},folder:$e?.folder}},oe=(J?.include?.map(_=>ae(_))??[ae(void 0)]).filter(_=>!!_),ie=Promise.resolve(void 0);return{results:new D.$$h(async _=>{const $e=(Ie,X)=>((0,f.$yM)(Ie)?_.emitOne(new E.$pM(X,Ie.rangeLocations.map(V=>({previewRange:new l.$fO(V.preview.startLineNumber,V.preview.startColumn,V.preview.endLineNumber,V.preview.endColumn),sourceRange:new l.$fO(V.source.startLineNumber,V.source.startColumn,V.source.endLineNumber,V.source.endColumn)})),Ie.previewText)):_.emitOne(new E.$qM(X,Ie.text,Ie.lineNumber)),Ie);await ie.then(Ie=>this.findTextInFilesBase(j,oe,$e,Z))}),complete:ie.then(_=>({limitHit:_?.limitHit??!1}))}}async findTextInFilesBase(j,U,J,Z=P.CancellationToken.None){const ae=this.j.getNext();let ee=!1;if(Z.onCancellationRequested(oe=>{ee=!0}),this.u[ae]=oe=>{if(ee)return;const ie=u.URI.revive(oe.resource);oe.results.forEach(ue=>{const _=(0,S.$hi)(ue);J(_,ie)})},Z.isCancellationRequested)return{};try{const oe=await Promise.all(U?.map(ie=>this.o.$startTextSearch(j,ie.folder??null,ie.options,ae,Z)||{})??[]);return delete this.u[ae],oe.reduce((ie,ue)=>({limitHit:ie?.limitHit||(ue?.limitHit??!1),message:[ie?.message??[],ue?.message??[]].flat()}),{})??{limitHit:!1}}catch(oe){throw delete this.u[ae],oe}}async findTextInFiles(j,U,J,Z,ae=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Z.value}, entryPoint: findTextInFiles`);const ee=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,oe=F(o.GlobPattern.from(U.include)),ie=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ue={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof U.useSearchExclude=="boolean"?!U.useSearchExclude:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ee,surroundingContext:U.afterContext,includePattern:oe?.pattern,excludePattern:ie?[{pattern:ie}]:void 0},_=($e,Ie)=>{(0,f.$yM)($e)?J({uri:Ie,preview:{text:$e.previewText,matches:(0,v.$5b)($e.rangeLocations,X=>new l.$fO(X.preview.startLineNumber,X.preview.startColumn,X.preview.endLineNumber,X.preview.endColumn))},ranges:(0,v.$5b)($e.rangeLocations,X=>new l.$fO(X.source.startLineNumber,X.source.startColumn,X.source.endLineNumber,X.source.endColumn))}):J({uri:Ie,text:$e.text,lineNumber:$e.lineNumber})};return this.findTextInFilesBase(j,[{options:ue,folder:oe?.folder}],_,ae)}$handleTextSearchResult(j,U){this.u[U]?.(j)}async save(j){const U=await this.o.$save(j,{saveAs:!1});return u.URI.revive(U)}async saveAs(j){const U=await this.o.$save(j,{saveAs:!0});return u.URI.revive(U)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}lookupAuthorization(j){return this.o.$lookupAuthorization(j)}lookupKerberosAuthorization(j){return this.o.$lookupKerberosAuthorization(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,U){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,U);const J=this.t.transformOutgoingScheme(j),Z=this.B++;return this.o.$registerEditSessionIdentityProvider(Z,J),(0,R.$Xc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(Z)})}async $getEditSessionIdentifier(j,U){this.h.info("Getting edit session identifier for workspaceFolder",j);const J=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!J){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",J);const Z=this.w.get(J.uri.scheme);if(this.h.info(`Provider for scheme ${J.uri.scheme} is defined: `,!!Z),!Z)return;const ae=await Z.provideEditSessionIdentity(J,U);if(this.h.info("Provider returned edit session identifier: ",ae),!!ae)return ae}async $provideEditSessionIdentityMatch(j,U,J,Z){this.h.info("Getting edit session identifier for workspaceFolder",j);const ae=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!ae){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ae);const ee=this.w.get(ae.uri.scheme);if(this.h.info(`Provider for scheme ${ae.uri.scheme} is defined: `,!!ee),!ee)return;const oe=await ee.provideEditSessionIdentityMatch?.(U,J,Z);if(this.h.info("Provider returned edit session identifier match result: ",oe),!!oe)return oe}getOnWillCreateEditSessionIdentityEvent(j){return(U,J,Z)=>{const ae=function(oe){U.call(J,oe)};return ae.extension=j,this.C.event(ae,void 0,Z)}}async $onWillCreateEditSessionIdentity(j,U,J){const Z=await this.resolveWorkspaceFolder(u.URI.revive(j));if(Z===void 0)throw new Error("Unable to resolve workspace folder");await this.C.fireAsync({workspaceFolder:Z},U,async(ae,ee)=>{const oe=Date.now();await Promise.resolve(ae),Date.now()-oe>J&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(j,U){if(this.D.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.D.set(j,U);const J=this.t.transformOutgoingScheme(j),Z=this.B++;return this.o.$registerCanonicalUriProvider(Z,J),(0,R.$Xc)(()=>{this.D.delete(j),this.o.$unregisterCanonicalUriProvider(Z)})}async provideCanonicalUri(j,U,J){const Z=this.D.get(j.scheme);if(!Z)return;const ae=await Z.provideCanonicalUri?.(u.URI.revive(j),U,J);if(ae)return ae}async $provideCanonicalUri(j,U,J){return this.provideCanonicalUri(u.URI.revive(j),{targetScheme:U},J)}};e.$prc=A,e.$prc=A=Qe([We(0,t.$OQ),We(1,n.$5Q),We(2,i.$$qc),We(3,a.$fk),We(4,g.$nrc)],A),e.$qrc=(0,r.$Ki)("IExtHostWorkspace");function F(x){let j,U;if(x)return typeof x=="string"?j=x:(j=x.pattern,U=u.URI.revive(x.baseUri)),{pattern:j,folder:U}}function G(x){return(x?.map(j=>{if(typeof j=="string")return j===""?void 0:{pattern:j,uri:void 0};{const U=F(j);return U?{pattern:U.pattern,uri:U.folder}:void 0}})??[]).filter(j=>!!j)}}),define(Re[46],Oe([1,0,25,6,45,5,7,44,175,53,14,10,3,16,11,2]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$trc=e.$src=e.$rrc=void 0;function a(g,f){if(f){const d=f.split(".");let S=g;for(let E=0;S&&E<d.length;E++)S=S[d[E]];return S}}function h(g){return g instanceof r.URI}function c(g){return g&&g.uri instanceof r.URI&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function n(g){return g&&g.uri instanceof r.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function t(g){if(h(g))return{resource:g};if(c(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(i(g))return{overrideIdentifier:g.languageId};if(n(g))return{resource:g.uri};if(g===null)return{resource:null}}let o=class{constructor(f,d,S){this.a=f.getProxy(L.$bO.MainThreadConfiguration),this.c=d,this.b=S,this.d=new b.$Jh,this.e=null}getConfigProvider(){return this.d.wait().then(f=>this.e)}$initializeConfiguration(f){this.e=new l(this.a,this.c,f,this.b),this.d.open()}$acceptConfigurationChanged(f,d){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(f,d))}};e.$rrc=o,e.$rrc=o=Qe([We(0,k.$OQ),We(1,P.$qrc),We(2,$.$fk)],o);class l{constructor(f,d,S,E){this.a=new D.$qe,this.b=f,this.f=E,this.c=d,this.e=m.$Zo.parse(S,E),this.d=this.k(S.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(f,d){const S={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$Zo.parse(f,this.f),this.d=this.k(f.configurationScopes),this.a.fire(this.j(d,S))}getConfiguration(f,d,S){const E=t(d)||{},y=this.g(f?a(this.e.getValue(void 0,E,this.c.workspace),f):this.e.getValue(void 0,E,this.c.workspace));f&&this.h(f,E,S?.identifier);function C(p){if(p==null)return null;if(typeof p=="boolean")return p?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(p){case R.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case R.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case R.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const O={has(p){return typeof a(y,p)<"u"},get:(p,w)=>{this.h(f?`${f}.${p}`:p,E,S?.identifier);let M=a(y,p);if(typeof M>"u")M=w;else{let A;const F=(G,x)=>{if((0,I.$lg)(G)){let j;const U=()=>{A=A||(0,v.$mo)(y),j=j||a(A,x)};return new Proxy(G,{get:(J,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return U(),()=>j;if(A)return j=j||a(A,x),j[Z];const ae=J[Z];return typeof Z=="string"?F(ae,`${x}.${Z}`):ae},set:(J,Z,ae)=>(U(),j&&(j[Z]=ae),!0),deleteProperty:(J,Z)=>(U(),j&&delete j[Z],!0),defineProperty:(J,Z,ae)=>(U(),j&&Object.defineProperty(j,Z,ae),!0)})}return Array.isArray(G)?(0,v.$mo)(G):G};M=F(M,p)}return M},update:(p,w,M,A)=>{p=f?`${f}.${p}`:p;const F=C(M);return w!==void 0?this.b.$updateConfigurationOption(F,p,w,E,A):this.b.$removeConfigurationOption(F,p,E,A)},inspect:p=>{p=f?`${f}.${p}`:p;const w=this.e.inspect(p,E,this.c.workspace);if(w)return{key:p,defaultValue:(0,v.$mo)(w.policy?.value??w.default?.value),globalValue:(0,v.$mo)(w.user?.value??w.application?.value),workspaceValue:(0,v.$mo)(w.workspace?.value),workspaceFolderValue:(0,v.$mo)(w.workspaceFolder?.value),defaultLanguageValue:(0,v.$mo)(w.default?.override),globalLanguageValue:(0,v.$mo)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,v.$mo)(w.workspace?.override),workspaceFolderLanguageValue:(0,v.$mo)(w.workspaceFolder?.override),languageIds:(0,v.$mo)(w.overrideIdentifiers)}}};return typeof y=="object"&&(0,v.$po)(O,y,!1),Object.freeze(O)}g(f){const d=S=>(0,I.$lg)(S)?new Proxy(S,{get:(E,y)=>d(E[y]),set:(E,y,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(E,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(E,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:E=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return d(f)}h(f,d,S){const E=s.$Oo.test(f)?s.ConfigurationScope.RESOURCE:this.d.get(f),y=S?`[${S.value}] `:"";if(s.ConfigurationScope.RESOURCE===E){typeof d?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${f}', provide the URI of a resource or 'null' for any resource.`);return}if(s.ConfigurationScope.WINDOW===E){d?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${f}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(f,d){const S=new m.$2o(f,d,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(E,y)=>S.affectsConfiguration(E,t(y))})}k(f){return f.reduce((d,S)=>(d.set(S[0],S[1]),d),new Map)}}e.$src=l,e.$trc=(0,u.$Ki)("IExtHostConfiguration")}),define(Re[132],Oe([1,0,2,10,6,5,7,45,57,46,19,56,16,26,3,15,23,11,85,209,12,17]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9sc=e.$8sc=e.$7sc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,R=Ve(R),a=Ve(a);var o;(function(F){function G(j){if(j!=null)return j}F.from=G;function x(j){if(j!=null)return j}F.to=x})(o||(o={}));var l;(function(F){function G(j){if(j!=null)return j}F.from=G;function x(j){if(j!=null)return j}F.to=x})(l||(l={}));var g;(function(F){function G(j){if(j!=null)return j}F.from=G;function x(j){if(j!=null)return j}F.to=x})(g||(g={}));var f;(function(F){function G(U){if(U){const J=U;return J&&!!J.process}else return!1}F.is=G;function x(U){if(U==null)return;const J={process:U.process,args:U.args};return U.options&&(J.options=g.from(U.options)),J}F.from=x;function j(U){if(U!=null)return new R.$2O(U.process,U.args,U.options)}F.to=j})(f||(f={}));var d;(function(F){function G(j){if(j!=null)return j}F.from=G;function x(j){if(j!=null)return j}F.to=x})(d||(d={}));var S;(function(F){function G(U){if(U){const J=U;return J&&(!!J.commandLine||!!J.command)}else return!1}F.is=G;function x(U){if(U==null)return;const J={};return U.commandLine!==void 0?J.commandLine=U.commandLine:(J.command=U.command,J.args=U.args),U.options&&(J.options=d.from(U.options)),J}F.from=x;function j(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new R.$3O(U.commandLine,U.options):new R.$3O(U.command,U.args?U.args:[],U.options)}F.to=j})(S||(S={}));var E;(function(F){function G(U){if(U){const J=U;return J&&J.customExecution==="customExecution"}else return!1}F.is=G;function x(U){return{customExecution:"customExecution"}}F.from=x;function j(U,J){return J.get(U)}F.to=j})(E||(e.CustomExecutionDTO=E={}));var y;(function(F){function G(x,j){let U;return x.scope!==void 0&&typeof x.scope!="number"?U=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===R.TaskScope.Workspace&&j&&j.workspaceFile?U=j.workspaceFile:U=i.$iJ),{id:x._id,workspaceFolder:U}}F.from=G})(y||(e.TaskHandleDTO=y={}));var C;(function(F){function G(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}F.from=G})(C||(C={}));var O;(function(F){function G(U,J){if(U==null)return[];const Z=[];for(const ae of U){const ee=x(ae,J);ee&&Z.push(ee)}return Z}F.fromMany=G;function x(U,J){if(U==null)return;let Z;U.execution instanceof R.$2O?Z=f.from(U.execution):U.execution instanceof R.$3O?Z=S.from(U.execution):U.execution&&U.execution instanceof R.$4O&&(Z=E.from(U.execution));const ae=o.from(U.definition);let ee;return U.scope?typeof U.scope=="number"?ee=U.scope:ee=U.scope.uri:ee=R.TaskScope.Workspace,!ae||!ee?void 0:{_id:U._id,definition:ae,name:U.name,source:{extensionId:J.identifier.value,label:U.source,scope:ee},execution:Z,isBackground:U.isBackground,group:C.from(U.group),presentationOptions:l.from(U.presentationOptions),problemMatchers:(0,t.$6b)(U.problemMatchers),hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}F.from=x;async function j(U,J,Z){if(U==null)return;let ae;f.is(U.execution)?ae=f.to(U.execution):S.is(U.execution)?ae=S.to(U.execution):E.is(U.execution)&&(ae=E.to(U._id,Z));const ee=o.to(U.definition);let oe;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?oe=U.source.scope:oe=await J.resolveWorkspaceFolder(v.URI.revive(U.source.scope)):oe=R.TaskScope.Workspace),!ee||!oe)return;const ie=new R.$5O(ee,oe,U.name,U.source.label,ae,U.problemMatchers);return U.isBackground!==void 0&&(ie.isBackground=U.isBackground),U.group!==void 0&&(ie.group=R.$1O.from(U.group._id),ie.group&&U.group.isDefault&&(ie.group=new R.$1O(ie.group.id,ie.group.label),U.group.isDefault===!0&&(ie.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ie.presentationOptions=l.to(U.presentationOptions)),U._id&&(ie._id=U._id),U.detail&&(ie.detail=U.detail),ie}F.to=j})(O||(e.TaskDTO=O={}));var p;(function(F){function G(j){return j}F.from=G;function x(j){if(j)return Object.assign(Object.create(null),j)}F.to=x})(p||(p={}));class w{#e;constructor(G,x,j){this._id=x,this.a=j,this.#e=G}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(G){}fireDidEndProcess(G){}}let M=class{constructor(G,x,j,U,J,Z,ae,ee){this.q=new P.$qe,this.r=new P.$qe,this.s=new P.$qe,this.u=new P.$qe,this.a=G.getProxy(L.$bO.MainThreadTask),this.b=j,this.c=U,this.d=J,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ae,this.g=ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(G,x,j){if(!j)return new R.$dO(()=>{});const U=this.x();return this.j.set(U,{type:x,provider:j,extension:G}),this.a.$registerTaskProvider(U,x),new R.$dO(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(G,x){this.a.$registerTaskSystem(G,x)}fetchTasks(G){return this.a.$fetchTasks(p.from(G)).then(async x=>{const j=[];for(const U of x){const J=await O.to(U,this.b,this.m);J&&j.push(J)}return j})}get taskExecutions(){const G=[];return this.k.forEach(x=>G.push(x)),G}terminateTask(G){if(!(G instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(G._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(G,x,j){const U=this.m.get(G.id);U&&(this.o.set(G.id,U),this.e.attachPtyToTerminal(x,await U.callback(j))),this.p=G.id,this.q.fire({execution:await this.z(G)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(G){if(!this.l.has(G.id))return;const x=await this.z(G);this.l.delete(G.id),this.k.delete(G.id),this.B(G),this.r.fire({execution:x})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(G){const x=await this.z(G.id);this.s.fire({execution:x,processId:G.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(G){const x=await this.z(G.id);this.u.fire({execution:x,exitCode:G.exitCode})}$provideTasks(G,x){const j=this.j.get(G);if(!j)return Promise.reject(new Error("no handler found"));const U=[],J=(0,D.$Ch)(()=>j.provider.provideTasks(I.CancellationToken.None)).then(Z=>this.v(x,U,j,Z));return new Promise(Z=>{J.then(ae=>{Promise.all(U).then(()=>{Z(ae)})})})}async $resolveTask(G,x){const j=this.j.get(G);if(!j)return Promise.reject(new Error("no handler found"));if(x.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${j.type}].`);const U=await O.to(x,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const J=await j.provider.resolveTask(U,I.CancellationToken.None);if(!J)return;this.A(J,j);const Z=O.from(J,j.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(J.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(Z.execution)&&await this.y(Z,J,!0),await this.w(Z)}x(){return this.h++}async y(G,x,j){const U=await this.a.$createTaskId(G);!j&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,x.execution)),this.m.set(U,x.execution)}async z(G,x){if(typeof G=="string"){const J=this.l.get(G);if(!J)throw new n.$fb("Unexpected: The specified task is missing an execution");return J}const j=this.l.get(G.id);if(j)return j;let U;return x?U=Promise.resolve(new w(this,G.id,x)):U=O.to(G.task,this.b,this.m).then(J=>{if(!J)throw new n.$fb("Unexpected: Task does not exist.");return new w(this,G.id,J)}),this.l.set(G.id,U),U.then(J=>(this.k.set(G.id,J),J))}A(G,x){G._deprecated&&this.g.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}B(G){this.o.get(G.id)&&this.o.delete(G.id),this.n.has(G.id)&&this.p!==G.id&&(this.m.delete(G.id),this.n.delete(G.id));const j=this.n.values();let U=j.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=j.next()}};e.$7sc=M,e.$7sc=M=Qe([We(0,u.$OQ),We(1,k.$5Q),We(2,T.$qrc),We(3,m.$ZQ),We(4,s.$trc),We(5,b.$Rrc),We(6,h.$fk),We(7,c.$7qc)],M);let A=class extends M{constructor(G,x,j,U,J,Z,ae,ee){super(G,x,j,U,J,Z,ae,ee),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:a.$k(a.Platform.Web)})}async executeTask(G,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const j=O.from(x,G);if(j===void 0)throw new Error("Task is not valid");if(E.is(j.execution))await this.y(j,x,!1);else throw new n.$db;const U=await this.z(await this.a.$getTaskExecution(j),x);return this.a.$executeTask(j).catch(J=>{throw new Error(J)}),U}v(G,x,j,U){const J=[];if(U)for(const Z of U){if(this.A(Z,j),!Z.definition||!G[Z.definition.type]){const ee=Z.source?Z.source:"No task source";this.f.warn(`The task [${ee}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`)}const ae=O.from(Z,j.extension);ae&&E.is(ae.execution)?(J.push(ae),x.push(this.y(ae,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:J,extension:j.extension}}async w(G){if(E.is(G.execution))return G;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(G,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(G,x,j){}};e.$8sc=A,e.$8sc=A=Qe([We(0,u.$OQ),We(1,k.$5Q),We(2,T.$qrc),We(3,m.$ZQ),We(4,s.$trc),We(5,b.$Rrc),We(6,h.$fk),We(7,c.$7qc)],A),e.$9sc=(0,$.$Ki)("IExtHostTask")}),define(Re[268],Oe([1,0,40,32]),function(be,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=void 0,e.$1M=P,e.$3M=L;function P(R){return"cellResults"in R}e.$2M="rawCell#";function L(R,T){let m=-1;const s=[];let I=[];return R.forEach(u=>{u.range.startLineNumber!==m&&I.length>0&&(s.push([...I]),I=[]),I.push(u),m=u.range.endLineNumber}),I.length>0&&s.push([...I]),s.map(u=>{const k=[],$=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let a=$;a<=r;a++)k.push(T.getLineContent(a));return new v.$CM(k.join(`
`)+`
`,u.map(a=>new D.$Yt(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}}),define(Re[269],Oe([1,0,9,20,6,4,27,38,13,14,2,28,80,5,35,8,7,39,246,126,25,15,40,199,268,266]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n,t,o,l,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Isc=void 0,b=Ve(b),r=Ve(r),a=Ve(a);class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,y,C,O,p,w,M){this.q=C,this.r=O,this.s=p,this.t=w,this.u=M,this.f=new Map,this.g=new R.$Fc,this.h=new Map,this.j=new P.$qe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$qe,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$qe,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$qe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$5qc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=E.getProxy(k.$bO.MainThreadNotebook),this.c=E.getProxy(k.$bO.MainThreadNotebookDocuments),this.d=E.getProxy(k.$bO.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===T.MarshalledId.NotebookCellActionContext){const F=A.notebookEditor?.notebookUri,G=A.cell.handle,j=this.g.get(F)?.getCell(G);if(j)return j.apiCell}if(A&&A.$mid===T.MarshalledId.NotebookActionContext){const F=A.uri,G=this.g.get(F);if(G)return G.apiNotebook}return A}}),d.C(y)}getEditorById(E){const y=this.h.get(E);if(!y)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(E){for(const[y,C]of this.h)if(C.apiEditor===E)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,y){const C=this.g.get(E);if(!C&&!y)throw new Error(`NO notebook document for '${E}'`);return C}static w(E,y){if(!y)return;const C=y.filenamePattern.map(O=>r.NotebookExclusiveDocumentPattern.from(O)).filter(O=>O!==void 0);if(y.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:y.displayName,filenamePattern:C,priority:y.exclusive?f.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(E,y,C){const O=d.a++,p=typeof C.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(O,C),this.b.$registerNotebookCellStatusBarItemProvider(O,p,y);let w;return p!==void 0&&(w=C.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent(p))),new a.$dO(()=>{this.f.delete(O),this.b.$unregisterNotebookCellStatusBarItemProvider(O,p),w?.dispose()})}async createNotebookDocument(E){const y=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&r.NotebookData.from(E.content)});return I.URI.revive(y)}async openNotebookDocument(E){const y=this.g.get(E);if(y)return y.apiNotebook;const C=await this.c.$tryOpenNotebook(E),O=this.g.get(I.URI.revive(C));return(0,s.$ug)(O?.apiNotebook)}async showNotebookDocument(E,y){let C;typeof y=="object"?C={position:r.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(r.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0,label:y?.label}:C={preserveFocus:!1,pinned:!0};const O=y?.asRepl?"repl":E.notebookType,p=await this.d.$tryShowNotebookDocument(E.uri,O,C),w=p&&this.h.get(p)?.apiEditor;if(w)return w;throw p?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,y,C,O){const p=this.f.get(E),w=I.URI.revive(y),M=this.g.get(w);if(!M||!p)return;const A=M.getCellFromIndex(C);if(!A)return;const F=await p.provideCellStatusBarItems(A.apiCell,O);if(!F)return;const G=new L.$Yc,x=this.p.add([G]),U=(Array.isArray(F)?F:[F]).map(J=>r.NotebookStatusBarItem.from(J,this.i,G));return{cacheId:x,items:U}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,y,C,O,p){if((0,m.$hf)(y))throw new Error("viewType cannot be empty or just whitespace");const w=this.x++;return this.y.set(w,{viewType:y,serializer:C,options:O}),this.b.$registerNotebookSerializer(w,{id:E.identifier,location:E.extensionLocation},y,r.NotebookDocumentContentOptions.from(O),d.w(E,p)),(0,L.$Xc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(E,y,C){const O=this.y.get(E);if(!O)throw new Error("NO serializer found");const p=await O.serializer.deserializeNotebook(y.buffer,C);return new h.$9w(r.NotebookData.from(p))}async $notebookToData(E,y,C){const O=this.y.get(E);if(!O)throw new Error("NO serializer found");const p=await O.serializer.serializeNotebook(r.NotebookData.to(y.value),C);return D.$Se.wrap(p)}async $saveNotebook(E,y,C,O,p){const w=I.URI.revive(y),M=this.y.get(E);if(this.D(`enter saveNotebook(versionId: ${C}, ${w.toString()})`),!M)throw new Error("NO serializer found");const A=this.g.get(w);if(!A)throw new Error("Document NOT found");if(A.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new b.$Al((0,v.localize)(2710,null,this.A(w)),b.FileOperationResult.FILE_PERMISSION_DENIED);const F={metadata:(0,n.$uo)(A.apiNotebook.metadata,J=>!(M.options?.transientDocumentMetadata??{})[J]),cells:[]};for(const J of A.apiNotebook.getCells()){const Z=new a.$IP(J.kind,J.document.getText(),J.document.languageId,J.mime,M.options?.transientOutputs?[]:[...J.outputs],J.metadata,J.executionSummary);Z.metadata=(0,n.$uo)(J.metadata,ae=>!(M.options?.transientCellMetadata??{})[ae]),F.cells.push(Z)}if(await this.z(w,O),p.isCancellationRequested)throw new Error("canceled");const G=await M.serializer.serializeNotebook(F,p);if(p.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${w.toString()}`),await this.s.value.writeFile(w,G),this.D(`Finished write versionId: ${C} ${w.toString()}`);const x=this.s.getFileSystemProviderExtUri(w.scheme),j=await this.s.value.stat(w),U={name:x.basename(w),isFile:(j.type&b.FileType.File)!==0,isDirectory:(j.type&b.FileType.Directory)!==0,isSymbolicLink:(j.type&b.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&b.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((j.permissions??0)&b.FilePermission.Locked),etag:b.$Ll({mtime:j.mtime,size:j.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${w.toString()})`),U}async $searchInNotebooks(E,y,C,O,p){const w=this.y.get(E)?.serializer;if(!w)return{limitHit:!1,results:[]};const M=new R.$Gc;await(async(j,U,J)=>{await Promise.all(j.map(async Z=>await Promise.all(Z.filenamePatterns.map(ae=>{const ee={_reason:J._reason,folderQueries:J.folderQueries,includePattern:J.includePattern,excludePattern:J.excludePattern,maxResults:J.maxResults,type:o.QueryType.File,filePattern:ae};return this.t.doInternalFileSearchWithCustomCallback(ee,U,oe=>{oe.forEach(ie=>{M.has(ie)||O.some(_=>Z.isFromSettings&&!_.isFromSettings?!1:_.filenamePatterns.some($e=>(0,f.$PL)($e,ie)))||M.add(ie)})}).catch(oe=>{if(oe.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw oe})}))))})(C,p,y);const F=new R.$Fc;let G=!1;const x=Array.from(M).map(async j=>{const U=[];try{if(p.isCancellationRequested)return;if(y.maxResults&&[...F.values()].reduce((ee,oe)=>ee+oe.cellResults.length,0)>y.maxResults){G=!0;return}const J=[],Z=this.g.get(j);if(Z)Z.apiNotebook.getCells().forEach(oe=>J.push({input:oe.document.getText(),outputs:oe.outputs.flatMap(ie=>ie.items.map(ue=>ue.data.toString()))}));else{const ee=await this.s.value.readFile(j),oe=D.$Se.fromString(ee.toString()),ie=await w.deserializeNotebook(oe.buffer,p);if(p.isCancellationRequested)return;r.NotebookData.from(ie).cells.forEach(_=>J.push({input:_.source,outputs:_.outputs.flatMap($e=>$e.items.map(Ie=>Ie.valueBytes.toString()))}))}if(p.isCancellationRequested)return;J.forEach((ee,oe)=>{const ie=y.contentPattern.pattern,ue=new l.$32b(ee.input,void 0,ee.outputs),_=ue.findInInputs(ie),$e=ue.findInOutputs(ie),Ie=$e.flatMap(X=>(0,g.$3M)(X.matches,X.textBuffer)).map((X,V)=>(X.webviewIndex=V,X));if(_.length>0||$e.length>0){const X={index:oe,contentResults:(0,g.$3M)(_,ue.inputTextBuffer),webviewResults:Ie};U.push(X)}});const ae={resource:j,cellResults:U};F.set(j,ae);return}catch{return}});return await Promise.all(x),{limitHit:G,results:[...F.values()]}}async z(E,y){const C=await this.s.value.stat(E);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==b.$Kl&&typeof C.mtime=="number"&&typeof C.size=="number"&&y.mtime<C.mtime&&y.etag!==b.$Ll({mtime:y.mtime,size:C.size}))throw new b.$Al((0,v.localize)(2711,null),b.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(E){return E.scheme===t.Schemas.file?E.fsPath:E.toString()}B(E,y,C){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const O=new i.$usc(y,this.d,E,C.visibleRanges.map(r.NotebookRange.to),C.selections.map(r.NotebookRange.to),typeof C.viewColumn=="number"?r.ViewColumn.to(C.viewColumn):void 0);this.h.set(y,O)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const C of E.value.removedDocuments){const O=I.URI.revive(C),p=this.g.get(O);p&&(p.dispose(),this.g.delete(O),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(p.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===O.toString()&&this.h.delete(w.id)}if(E.value.addedDocuments){const C=[];for(const O of E.value.addedDocuments){const p=I.URI.revive(O.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const w=new c.$tsc(this.c,this.q,this.r,p,O);C.push(...O.cells.map(M=>c.$ssc.asModelAddData(M))),this.g.get(p)?.dispose(),this.g.set(p,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(w.apiNotebook)}}if(E.value.addedEditors)for(const C of E.value.addedEditors){if(this.h.has(C.id))return;const O=I.URI.revive(C.documentUri),p=this.g.get(O);p&&this.B(p,C.id,C)}const y=[];if(E.value.removedEditors)for(const C of E.value.removedEditors){const O=this.h.get(C);O&&(this.h.delete(C),this.k?.id===O.id&&(this.k=void 0),y.push(O))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(O=>this.h.get(O)).filter(O=>!!O);const C=new Set;this.l.forEach(O=>C.add(O.id));for(const O of this.h.values()){const p=C.has(O.id);O._acceptVisibility(p)}this.l=[...this.h.values()].map(O=>O).filter(O=>O.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.h.get(E.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${E.value.newActiveEditor}`),this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(E){const y=$.$aR.String.with("notebookType","A notebook type"),C=new $.$cR("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new $.$aR("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>D.$Se.wrap(p))],new $.$bR("Notebook Data",p=>r.NotebookData.to(p.value))),O=new $.$cR("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new $.$aR("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new h.$9w(r.NotebookData.from(p)))],new $.$bR("Bytes",p=>p.buffer));E.registerApiCommand(C),E.registerApiCommand(O)}D(E){this.u.trace(`[Extension Host Notebook] ${E}`)}}e.$Isc=d}),define(Re[270],Oe([1,0,17,240,43,103,27,15,22,24,13,14,2,102,9,44,11,114,49,120,267,40]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0,e.$RN=o,e.$SN=l,e.$UN=p,v=Ve(v),D=Ve(D),P=Ve(P),m=Ve(m),I=Ve(I),$=Ve($);function o(w){return typeof w=="object"&&"uri"in w&&"pattern"in w}function l(w){return typeof w=="string"?{pattern:w}:{pattern:w.pattern,uri:w.baseUri}}let g=class{constructor(M,A,F,G,x,j){this.a=M,this.b=A,this.c=F,this.d=G,this.f=x,this.g=j}text(M,A,F={}){M=this.h(M,F);const G=this.a.getValue(),x=A&&A.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.j(A?.map(c.$6i),F),type:t.QueryType.Text,contentPattern:M,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:G.search.usePCRE2||x||!1,surroundingContext:F.surroundingContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}h(M,A){const F=this.a.getValue();M.isRegExp&&(M.pattern=M.pattern.replace(/\r?\n/g,"\\n"));const G={...M,wordSeparators:F.editor.wordSeparators};return this.l(M,A)&&(G.isCaseSensitive=!0),this.m(M)&&(G.isMultiline=!0),A.notebookSearchConfig?.includeMarkupInput&&(G.notebookInfo||(G.notebookInfo={}),G.notebookInfo.isInNotebookMarkdownInput=A.notebookSearchConfig.includeMarkupInput),A.notebookSearchConfig?.includeMarkupPreview&&(G.notebookInfo||(G.notebookInfo={}),G.notebookInfo.isInNotebookMarkdownPreview=A.notebookSearchConfig.includeMarkupPreview),A.notebookSearchConfig?.includeCodeInput&&(G.notebookInfo||(G.notebookInfo={}),G.notebookInfo.isInNotebookCellInput=A.notebookSearchConfig.includeCodeInput),A.notebookSearchConfig?.includeOutput&&(G.notebookInfo||(G.notebookInfo={}),G.notebookInfo.isInNotebookCellOutput=A.notebookSearchConfig.includeOutput),G}file(M,A={}){return{...this.j(M,A),type:t.QueryType.File,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey,shouldGlobMatchFilePattern:A.shouldGlobSearch}}i(M,A){if(!M)return{};if(Array.isArray(M)){if(M=M.filter(F=>F.length>0).map(y),!M.length)return{}}else M=y(M);return A?this.parseSearchPaths(M):{pattern:d(...Array.isArray(M)?M:[M])}}j(M=[],A={}){let F=Array.isArray(A.excludePattern)?A.excludePattern.map(ae=>ae.pattern).flat():A.excludePattern;F=F?.length===1?F[0]:F;const G=this.i(A.includePattern,A.expandPatterns),x=this.i(F,A.expandPatterns),j=M.length>1,U=(G.searchPaths&&G.searchPaths.length?G.searchPaths.map(ae=>this.t(ae,A,x)):M.map(ae=>this.u(ae,A,x,j))).filter(ae=>!!ae),J={_reason:A._reason,folderQueries:U,usingSearchPaths:!!(G.searchPaths&&G.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:x.pattern,includePattern:G.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults,onlyFileScheme:A.onlyFileScheme};if(A.onlyOpenEditors){const ae=v.$Lb(this.c.groups.flatMap(ie=>ie.editors.map(ue=>ue.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(ae));const ee=ae.filter(ie=>(0,t.$GM)(J,ie.fsPath)),oe=this.k(ee);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(oe)),{...J,...oe}}const Z=A.extraFileResources&&A.extraFileResources.filter(ae=>(0,t.$GM)(J,ae.fsPath));return J.extraFileResources=Z&&Z.length?Z:void 0,J}k(M){const A=[],F=new R.$Fc,G={};let x=!1;return M.forEach(j=>{if(j.scheme===T.Schemas.walkThrough)return;if((0,s.$ph)(j)){const J=this.b.getWorkspaceFolder(j)?.uri??this.g.extUri.dirname(j);let Z=F.get(J);Z||(x=!0,Z={folder:J,includePattern:{}},A.push(Z),F.set(J,Z));const ae=m.$qc(J.fsPath,j.fsPath);(0,b.$ug)(Z.includePattern)[ae.replace(/\\/g,"/")]=!0}else j.fsPath&&(x=!0,G[j.fsPath]=!0)}),{folderQueries:A,includePattern:G,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}l(M,A){if(A.isSmartCase){if(M.isRegExp){if(I.$ag(M.pattern,!0))return!0}else if(I.$ag(M.pattern))return!0}return!!M.isCaseSensitive}m(M){return M.isMultiline||M.isRegExp&&(0,k.$AD)(M.pattern)||M.pattern.indexOf(`
`)>=0?!0:!!M.isMultiline}parseSearchPaths(M){const A=ee=>m.$nc(ee)||/^\.\.?([\/\\]|$)/.test(ee),G=(Array.isArray(M)?M:S(M)).map(ee=>{const oe=this.f.resolvedUserHome;return oe?(0,L.$bx)(ee,oe.scheme===T.Schemas.file?oe.fsPath:oe.path):ee}),x=D.$e(G,ee=>A(ee)?"searchPaths":"exprSegments"),j=(x.exprSegments||[]).map(ee=>I.$sf(ee,"/")).map(ee=>I.$sf(ee,"\\")).map(ee=>(ee[0]==="."&&(ee="*"+ee),E(ee))),U={},J=this.o(x.searchPaths||[]);J&&J.length&&(U.searchPaths=J);const Z=j.flat(),ae=d(...Z);return ae&&(U.pattern=ae),U}n(M,A){return A.disregardExcludeSettings?void 0:(0,t.$FM)(M,!A.disregardSearchExcludeSettings)}o(M){if(!M||!M.length)return[];const A=M.flatMap(G=>{let{pathPortion:x,globPortion:j}=f(G);return j&&(j=C(j)),this.q(x).flatMap(J=>this.r(J,j))}),F=new Map;return A.forEach(G=>{const x=G.searchPath.toString(),j=F.get(x);j?G.pattern&&(j.pattern=j.pattern||{},j.pattern[G.pattern]=!0):F.set(x,{searchPath:G.searchPath,pattern:G.pattern?d(G.pattern):void 0})}),Array.from(F.values())}q(M){if(m.$nc(M)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==T.Schemas.file?[{searchPath:A[0].uri.with({path:M})}]:[{searchPath:u.URI.file(m.$mc(M))}]}if(this.b.getWorkbenchState()===c.WorkbenchState.FOLDER){const A=this.b.getWorkspace().folders[0].uri;if(M=y(M),M.startsWith("../")||M===".."){const G=m.$lc.resolve(A.path,M);return[{searchPath:A.with({path:G})}]}const F=C(M);return[{searchPath:A,pattern:F}]}else{if(M==="./"||M===".\\")return[];{const A=M.replace(/^\.[\/\\]/,""),G=this.b.getWorkspace().folders.map(x=>{const j=A.match(new RegExp(`^${I.$mf(x.name)}(?:/(.*)|$)`));return j?{match:j,folder:x}:null}).filter(b.$rg);if(G.length)return G.map(x=>{const j=x.match[1];return{searchPath:x.folder.uri,pattern:j&&C(j)}});{const x=M.match(/\.[\/\\](.+)[\/\\]?/),j=x?x[1]:M,U=$.localize(12573,null,j);throw new Error(U)}}}}r(M,A){const F=M.pattern&&A?`${M.pattern}/${A}`:M.pattern||A,G=[{searchPath:M.searchPath,pattern:F}];return F&&!F.endsWith("**")&&G.push({searchPath:M.searchPath,pattern:F+"/**"}),G}t(M,A,F){const G=this.u((0,c.$6i)(M.searchPath),A,F,!1);return G?{...G,includePattern:M.pattern}:null}u(M,A,F,G){let x;const j=u.URI.isUri(M)?M:M.uri;let U=A.excludePattern?.map(ie=>{const ue=A.excludePattern&&o(ie)?ie.uri:void 0;return!ue||!(u.URI.isUri(M)&&this.g.extUri.isEqual(M,ue))?ue:void 0});if(U?.length||(U=[void 0]),F.searchPaths){const ie=F.searchPaths.filter(ue=>(0,s.$eh)(ue.searchPath,j))[0];if(ie&&!ie.pattern)return null;ie&&(x=ie.pattern)}const J=this.a.getValue({resource:j}),ae={...this.n(J,A)||{},...x||{}},ee=u.URI.isUri(M)?(0,s.$ih)(M):M.name,oe=U.map(ie=>Object.keys(ae).length>0?{folder:ie,pattern:ae}:void 0).filter(ie=>ie);return{folder:j,folderName:G?ee:void 0,excludePattern:oe,fileEncoding:J.files&&J.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!J.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!J.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!J.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!J.search.followSymlinks}}};e.$TN=g,e.$TN=g=Qe([We(0,r.$ej),We(1,c.$Ti),We(2,i.$OE),We(3,a.$fk),We(4,n.$PN),We(5,h.$Pl)],g);function f(w){const M=w.match(/[\*\{\}\(\)\[\]\?]/);if(M){const A=M.index,F=w.substr(0,A).match(/[/|\\][^/\\]*$/);if(F){let G=w.substr(0,F.index);return G.match(/[/\\]/)||(G+="/"),{pathPortion:G,globPortion:w.substr((F.index||0)+1)}}}return{pathPortion:w}}function d(...w){return w.length?w.reduce((M,A)=>(M[A]=!0,M),Object.create(null)):void 0}function S(w){return P.$Dk(w,",").map(M=>M.trim()).filter(M=>!!M.length)}function E(w){return[`**/${w}/**`,`**/${w}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function y(w){return w.replace(/\\/g,"/")}function C(w){return y(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function O(w){return w.replace(/([?*[\]])/g,"[$1]")}function p(w,M){w=v.$Qb(w,G=>G.toString());const A=[],F=M.getWorkspace();return w&&w.forEach(G=>{let x;if(M.getWorkbenchState()===c.WorkbenchState.FOLDER)x=(0,s.$nh)(F.folders[0].uri,G),x&&x!=="."&&(x="./"+x);else{const j=M.getWorkspaceFolder(G);if(j){const U=j.name;if(F.folders.filter(Z=>Z.name===U).length===1){const Z=(0,s.$nh)(j.uri,G);Z===""?x=`./${j.name}`:x=`./${j.name}/${Z}`}else x=G.fsPath}}x&&A.push(O(x))}),A}}),define(Re[271],Oe([1,0,24,2,19,12,3,270,40,49,10]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VAb=u,e.$WAb=r,v=Ve(v),L=Ve(L);const b=7e3;function u(a,h){const c=h.activationEvents;if(!c)return Promise.resolve(void 0);const i=[],n=[];for(const d of c)if(/^workspaceContains:/.test(d)){const S=d.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||a.forceUsingSearch?n.push(S):i.push(S)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,I.$Dh)(),l=d=>o({activationEvent:d}),g=Promise.all(i.map(d=>k(a,d,l))).then(()=>{}),f=$(a,h.identifier,n,l);return Promise.all([g,f]).then(()=>{o(void 0)}),t}async function k(a,h,c){for(const i of a.folders)if(await a.exists(v.$lh(D.URI.revive(i),h))){c(`workspaceContains:${h}`);return}}async function $(a,h,c,i){if(c.length===0)return Promise.resolve(void 0);const n=new P.$Be,t=a.checkExists(a.folders,c,n.token),o=setTimeout(async()=>{n.cancel(),a.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${c.join(",")}`)},b);let l=!1;try{l=await t}catch(g){L.$8(g)||L.$4(g)}n.dispose(),clearTimeout(o),l&&i(`workspaceContains:${c.join(",")}`)}function r(a,h,c,i){const n=a.get(R.$Ji),t=a.get(m.$xM),l=n.createInstance(T.$TN).file(h.map(g=>(0,s.$6i)(D.URI.revive(g))),{_reason:"checkExists",includePattern:c,exists:!0});return t.fileSearch(l,i).then(g=>!!g.limitHit,g=>L.$8(g)?!1:Promise.reject(g))}}),define(Re[47],Oe([1,0,9,22,64,24,10,4,48,2,11,5,46,206,89,45,21,121,12,18,20,189,7,110,3,26,92,16,75,93,56,95,6,271,88,191,15,86,69,23,87]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n,t,o,l,g,f,d,S,E,y,C,O,p,w,M,A,F,G,x,j,U){"use strict";var J;Object.defineProperty(e,"__esModule",{value:!0}),e.$9rc=e.$8rc=e.$7rc=e.$6rc=e.$5rc=void 0,v=Ve(v),D=Ve(D),P=Ve(P),c=Ve(c),e.$5rc=(0,g.$Ki)("IHostUtils");let Z=J=class extends T.$Zc{constructor(X,V,re,we,Pe,Fe,Be,xe,nt,ht,$t,ut,et){super(),this.Y=ut,this.Z=et,this.a=this.B(new p.$qe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=V,this.g=re,this.f=Be,this.j=we,this.m=Pe,this.s=Fe,this.t=nt,this.u=ht,this.w=$t,this.y=this.g.getProxy(b.$bO.MainThreadWorkspace),this.z=this.g.getProxy(b.$bO.MainThreadTelemetry),this.C=this.g.getProxy(b.$bO.MainThreadExtensionService),this.D=new R.$Jh,this.F=new R.$Jh,this.G=new R.$Jh,this.H=new R.$Jh,this.I=new $e(this.f.extensions.activationEvents),this.L=new h.$lfc(this.I,this.f.extensions.allExtensions);const Le=new i.$An(this.f.extensions.myExtensions);this.J=new h.$lfc(this.I,ue(this.L,Le)),j.$w&&(this.s.info(`Creating extension host with the following global extensions: ${oe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${oe(this.J)}`)),this.M=new $.$Nrc(this.g,this.s),this.N=new M.$Xrc(this.g),this.O=xe,this.h=this.q.add(X.createChild(new E.$Ii([$.$Orc,this.M],[M.$Yrc,this.N]))),this.P=this.B(new k.$Mrc(this.J,this.L,{onExtensionActivationError:(Ne,Me,q)=>{this.C.$onExtensionActivationError(Ne,c.$6(Me),q)},actualActivateExtension:async(Ne,Me)=>{if(h.$lfc.isHostExtension(Ne,this.J,this.L))return await this.C.$activateExtension(Ne,Me),new k.$Lrc;const q=this.J.getExtensionDescription(Ne);return this.fb(q,Me)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(X){c.$4(X)}}async $(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(Pe=>Pe.identifier).filter(Pe=>this.isActivated(Pe)).map(Pe=>this.eb(Pe))}catch{}await Promise.all(X)}terminate(X,V=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),c.setUnexpectedErrorHandler(we=>{this.s.error(we)}),this.g.dispose();const re=this.$();Promise.race([(0,R.$Lh)(5e3),re]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const V=await this.C.$getExtension(X);return V&&{...V,identifier:new i.$zn(V.identifier.value),extensionLocation:s.URI.revive(V.extensionLocation)}}ab(X,V){return this.P.activateByEvent(X,V)}bb(X,V){return this.P.activateById(X,V)}activateByIdWithErrors(X,V){return this.bb(X,V).then(()=>{const re=this.P.getActivatedExtension(X);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async cb(X){if(X.scheme===F.Schemas.file&&this.c.fsRealpath){const V=X.fsPath;this.R.has(V)||this.R.set(V,this.c.fsRealpath(V));const re=await this.R.get(V);return s.URI.file(re)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(X=>new _(X))),this.Q}async db(X){const V=m.$Qi.forUris(re=>L.$ch.ignorePathCasing(re));return await Promise.all(X.map(async re=>{if(this.wb(re)){const we=await this.cb(re.extensionLocation);V.set(we,re)}})),V}eb(X){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return V;const re=this.P.getActivatedExtension(X);if(!re)return V;try{typeof re.module.deactivate=="function"&&(V=Promise.resolve(re.module.deactivate()).then(void 0,we=>(this.s.error(we),Promise.resolve(void 0))))}catch(we){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(we)}try{re.disposable.dispose()}catch(we){this.s.error(`An error occurred when disposing the subscriptions for extension '${X.value}':`),this.s.error(we)}return V}async fb(X,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.hb(X,V).then(re=>{const we=re.activationTimes;return this.C.$onDidActivateExtension(X.identifier,we.codeLoadingTime,we.activateCallTime,we.activateResolvedTime,V),this.gb(X,V,"success",we),re},re=>{throw this.gb(X,V,"failure"),re})}gb(X,V,re,we){const Pe=ee(X,V);this.z.$publicLog2("extensionActivationTimes",{...Pe,...we||{},outcome:re})}hb(X,V){const re=ee(X,V);this.z.$publicLog2("activatePlugin",re);const we=this.wb(X);if(!we)return Promise.resolve(new k.$Krc(k.$Hrc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${X.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Pe=new T.$Yc,Fe=new k.$Irc(V.startup);return Promise.all([this.xb(X,(0,L.$lh)(X.extensionLocation,we),Fe),this.ib(X,Pe)]).then(Be=>(P.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),J.jb(this.s,X.identifier,Be[0],Be[1],Pe,Fe))).then(Be=>(P.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),Be))}ib(X,V){const re=this.Z.createLanguageModelAccessInformation(X),we=V.add(new t.$Qrc(X,this.M)),Pe=V.add(new t.$Prc(X.identifier.value,!1,this.M)),Fe=V.add(new A.$Zrc(X,this.N)),Be=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,xe=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([we.whenReady,Pe.whenReady,this.O.whenReady]).then(()=>{const nt=this;let ht,$t;const ut=(0,a.$CH)(X,"ipc")?this.f.messagePorts?.get(i.$zn.toKey(X.identifier)):void 0;return Object.freeze({globalState:we,workspaceState:Pe,secrets:Fe,subscriptions:[],get languageModelAccessInformation(){return re},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(et){return D.$oc(X.extensionLocation.fsPath,et)},get storagePath(){return nt.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return nt.O.globalValue(X).fsPath},get logPath(){return D.$oc(nt.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return s.URI.joinPath(nt.f.logsLocation,X.identifier.value)},get storageUri(){return nt.O.workspaceValue(X)},get globalStorageUri(){return nt.O.globalValue(X)},get extensionMode(){return Be},get extension(){return ht===void 0&&(ht=new ie(nt,X.identifier,X,xe,!1)),ht},get extensionRuntime(){return(0,a.$DH)(X,"extensionRuntime"),nt.extensionRuntime},get environmentVariableCollection(){return nt.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!$t){if(!ut)return;const et=p.Event.buffer(p.Event.fromDOMEventEmitter(ut,"message",Le=>Le.data));ut.start(),$t={onDidReceiveMessage:et,postMessage:ut.postMessage.bind(ut)}}return $t}})})}static jb(X,V,re,we,Pe,Fe){return re=re||{activate:void 0,deactivate:void 0},this.kb(X,V,re,we,Fe).then(Be=>new k.$Jrc(!1,null,Fe.build(),re,Be,(0,T.$Xc)(()=>{Pe.dispose(),(0,T.$Uc)(we.subscriptions)})))}static kb(X,V,re,we,Pe){if(typeof re.activate=="function")try{Pe.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Fe=typeof global=="object"?global:self,Be=re.activate.apply(Fe,[we]);return Pe.activateCallStop(),Pe.activateResolveStart(),Promise.resolve(Be).then(xe=>(Pe.activateResolveStop(),xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(re)}lb(X,V){this.bb(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:V}).then(void 0,re=>{this.s.error(re)})}mb(X,V=0){const we=Date.now();(0,j.$E)(()=>{for(let Pe=V;Pe<X.length;Pe+=1){const Fe=X[Pe];for(const Be of Fe.activationEvents??[])if(Be==="onStartupFinished")if(Date.now()-we>50){this.mb(X,Pe);break}else this.lb(Fe,Be)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(X=>{const V=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this.J.getAllExtensionDescriptions();if(V)this.mb(re);else for(const we of re)if(we.activationEvents)for(const Pe of we.activationEvents)Pe==="onStartupFinished"&&this.lb(we,Pe)})}ob(){const X=this.ab("*",!0).then(void 0,Fe=>{this.s.error(Fe)});this.B(this.j.onDidChangeWorkspace(Fe=>this.pb(Fe.added)));const V=this.j.workspace?this.j.workspace.folders:[],re=this.pb(V),we=this.rb(),Pe=Promise.all([we,X,re]).then(()=>{});return Promise.race([Pe,(0,R.$Lh)(1e4)]).then(()=>{this.nb()}),Pe}pb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.qb(X,V))).then(()=>{})}async qb(X,V){if(this.isActivated(V.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,we={logService:this.s,folders:X.map(Fe=>Fe.uri),forceUsingSearch:re||!this.c.fsExists,exists:Fe=>this.c.fsExists(Fe.fsPath),checkExists:(Fe,Be,xe)=>this.y.$checkExists(Fe,Be,xe)},Pe=await(0,w.$VAb)(we,V);if(Pe)return this.bb(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Pe.activationEvent}).then(void 0,Fe=>this.s.error(Fe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(X){throw console.error(X),X}}async sb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:V}=this.f.environment;if(!X||!V)throw new Error(v.localize(2702,null));const re=await this.xb(null,V,new k.$Irc(!1));if(!re||typeof re.run!="function")throw new Error(v.localize(2703,null,V.toString()));return new Promise((we,Pe)=>{const Fe=(nt,ht)=>{nt?(j.$w&&this.s.error("Test runner called back with error",nt),Pe(nt)):(j.$w&&(ht?this.s.info(`Test runner called back with ${ht} failures.`):this.s.info("Test runner called back with successful outcome.")),we(typeof ht=="number"&&ht>0?1:0))},Be=(0,L.$_g)(V),xe=re.run(Be,Fe);xe&&xe.then&&xe.then(()=>{j.$w&&this.s.info("Test runner finished successfully."),we(0)}).catch(nt=>{j.$w&&this.s.error("Test runner finished with error",nt),Pe(nt instanceof Error&&nt.stack?nt.stack:String(nt))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Lh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,V){return this.S[X]=V,(0,T.$Xc)(()=>{delete this.S[X]})}async getRemoteExecServer(X){const{resolver:V}=await this.ub(X);return V?.resolveExecServer?.(X,{resolveAttempt:0})}async ub(X){const V=X.indexOf("+");if(V===-1)throw new o.$lO("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=X.substr(0,V);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.S[re]}}async $resolveAuthority(X,V){const re=x.$ke.create(!1),we=()=>`[resolveAuthority(${(0,l.$1l)(X)},${V})][${re.elapsed()}ms] `,Pe=B=>this.s.info(`${we()}${B}`),Fe=B=>this.s.warn(`${we()}${B}`),Be=(B,H=void 0)=>this.s.error(`${we()}${B}`,H),xe=B=>{if(B instanceof o.$lO)return{type:"error",error:{code:B._code,message:B._message,detail:B._detail}};throw B},nt=async B=>{Pe(`activating resolver for ${B}...`);const{resolver:H,authorityPrefix:Q}=await this.ub(B);if(!H)throw Be(`no resolver for ${Q}`),new o.$lO(`No remote extension installed to resolve ${Q}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:Q,remoteAuthority:B}},ht=X.split(/@|%40/g).reverse();Pe(`activating remote resolvers ${ht.join(" -> ")}`);let $t;try{$t=await Promise.all(ht.map(nt)).catch(async B=>{if(!(B instanceof o.$lO)||B._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw B;return Fe(`resolving nested authorities failed: ${B.message}`),[await nt(X)]})}catch(B){return xe(B)}const ut=new R.$Vh;ut.cancelAndSet(()=>Pe("waiting..."),1e3);let et,Le;for(const[B,{authorityPrefix:H,resolver:Q,remoteAuthority:se}]of $t.entries())try{if(B===$t.length-1)Pe("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${H}`),et=await Q.resolve(se,{resolveAttempt:V,execServer:Le}),P.mark(`code/extHost/didResolveAuthorityOK/${H}`),Pe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,o.$kO.isManagedResolvedAuthority(et)?et:void 0));else{if(Pe(`invoking resolveExecServer() for ${se}`),P.mark(`code/extHost/willResolveExecServer/${H}`),Le=await Q.resolveExecServer?.(se,{resolveAttempt:V,execServer:Le}),!Le)throw new o.$lO(`Exec server was not available for ${se}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ge){return P.mark(`code/extHost/didResolveAuthorityError/${H}`),Be("returned an error",ge),ut.dispose(),xe(ge)}ut.dispose();const Ne={environmentTunnels:et.environmentTunnels,features:et.tunnelFeatures?{elevation:et.tunnelFeatures.elevation,privacyOptions:et.tunnelFeatures.privacyOptions,protocol:et.tunnelFeatures.protocol===void 0?!0:et.tunnelFeatures.protocol}:void 0},Me={extensionHostEnv:et.extensionHostEnv,isTrusted:et.isTrusted,authenticationSession:et.authenticationSessionForInitializingExtensions?{id:et.authenticationSessionForInitializingExtensions.id,providerId:et.authenticationSessionForInitializingExtensions.providerId}:void 0};Pe(`returned ${o.$kO.isManagedResolvedAuthority(et)?"managed authority":`${et.host}:${et.port}`}`);let q;if(o.$kO.isManagedResolvedAuthority(et)){const B=V;this.Y.setFactory(B,et.makeConnection),q={authority:X,connectTo:new l.$Xl(B),connectionToken:et.connectionToken}}else q={authority:X,connectTo:new l.$Yl(et.host,et.port),connectionToken:et.connectionToken};return{type:"ok",value:{authority:q,options:Me,tunnelInformation:Ne}}}async $getCanonicalURI(X,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$1l)(X)})`);const{resolver:re}=await this.ub(X);if(!re)return null;const we=s.URI.revive(V);if(typeof re.getCanonicalURI>"u")return we;const Pe=await(0,R.$Ch)(()=>re.getCanonicalURI(we));return Pe||we}async $startExtensionHost(X){X.toAdd.forEach(Fe=>Fe.extensionLocation=s.URI.revive(Fe.extensionLocation));const{globalRegistry:V,myExtensions:re}=ae(this.I,this.L,this.J,X),we=await this.db(re);return(await this.getExtensionPathIndex()).setSearchTree(we),this.L.set(V.getAllExtensionDescriptions()),this.J.set(re),j.$w&&(this.s.info(`$startExtensionHost: global extensions: ${oe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${oe(this.J)}`)),this.tb()}$activateByEvent(X,V){return V===a.ActivationKind.Immediate?this.D.wait().then(re=>this.ab(X,!1)):this.G.wait().then(re=>this.ab(X,!1))}async $activate(X,V){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.bb(X,V),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(Fe=>Fe.extensionLocation=s.URI.revive(Fe.extensionLocation));const{globalRegistry:V,myExtensions:re}=ae(this.I,this.L,this.J,X),we=await this.db(re);return(await this.getExtensionPathIndex()).setSearchTree(we),this.L.set(V.getAllExtensionDescriptions()),this.J.set(re),j.$w&&(this.s.info(`$deltaExtensions: global extensions: ${oe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${oe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const V=n.$Se.alloc(X),re=Math.random()%256;for(let we=0;we<X;we++)V.writeUInt8(re,we);return V}async $updateRemoteConnectionData(X){this.X=X,this.a.fire()}};e.$6rc=Z,e.$6rc=Z=J=Qe([We(0,g.$Ji),We(1,e.$5rc),We(2,S.$OQ),We(3,r.$qrc),We(4,u.$trc),We(5,I.$fk),We(6,f.$5Q),We(7,d.$wrc),We(8,y.$jHb),We(9,C.$Rrc),We(10,G.$2rc),We(11,U.$3rc),We(12,O.$Vrc)],Z);function ae(Ie,X,V,re){Ie.addActivationEvents(re.addActivationEvents);const we=new h.$lfc(Ie,X.getAllExtensionDescriptions());we.deltaExtensions(re.toAdd,re.toRemove);const Pe=new i.$An(V.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of re.myToRemove)Pe.delete(Be);for(const Be of re.myToAdd)Pe.add(Be);const Fe=ue(we,Pe);return{globalRegistry:we,myExtensions:Fe}}function ee(Ie,X){return{id:Ie.identifier.value,name:Ie.name,extensionVersion:Ie.version,publisherDisplayName:Ie.publisher,activationEvents:Ie.activationEvents?Ie.activationEvents.join(","):null,isBuiltin:Ie.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function oe(Ie){return Ie.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$7rc=(0,g.$Ki)("IExtHostExtensionService");class ie{#e;#t;#i;constructor(X,V,re,we,Pe){this.#e=X,this.#t=V,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=D.$mc((0,L.$_g)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=we,this.isFromDifferentExtensionHost=Pe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$8rc=ie;function ue(Ie,X){return Ie.getAllExtensionDescriptions().filter(V=>X.has(V.identifier))}class _{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$9rc=_;class $e{constructor(X){this.a=new i.$Bn,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const V of Object.keys(X))this.a.set(V,X[V])}}}),define(Re[272],Oe([1,0,64,2,5,46,21,18,16,26,3,47,11,13]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$mtc=void 0,v=Ve(v);let r=class{constructor(n,t,o,l,g,f,d){this.c=n,this.d=t,this.f=o,this.g=l,this.h=g,this.i=f,this.j=d,this.a=new Map,this.b=[]}async install(){this.k(),v.mark("code/extHost/willWaitForConfig");const n=await this.g.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.h.getExtensionPathIndex();this.register(new h(this.c,t,this.d,n,this.j)),this.register(this.f.createInstance(a)),this.i.remote.isRemote&&this.register(this.f.createInstance(c,t,this.i.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const t of n.nodeModuleName)this.a.set(t,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(t=>n.alternativeModuleName(t))}};e.$mtc=r,e.$mtc=r=Qe([We(2,I.$Ji),We(3,L.$trc),We(4,b.$7rc),We(5,s.$5Q),We(6,u.$fk)],r);let a=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&$.a.size){const t=(0,k.$mf)(this.c(n.environment.appRoot.fsPath)),o="[a-z0-9_.-]",l=`@${o}+\\/${o}+|${o}+`,g="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${g}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const t=this.b.exec(this.c(n));if(!t)return;const[,o,l,g]=t,f=$.a.get(l);if(f!==void 0)return console.warn(`${l} as been renamed to ${f}, please update your imports`),o+f+g}c(n){return n.replace(/\\/g,"/")}};a=$=Qe([We(0,s.$5Q)],a);class h{constructor(n,t,o,l,g){this.c=n,this.d=t,this.e=o,this.f=l,this.g=g,this.nodeModuleName="vscode",this.a=new T.$Bn}load(n,t){const o=this.d.findSubstr(t);if(o){let l=this.a.get(o.identifier);return l||(l=this.c(o,this.e,this.f),this.a.set(o.identifier,l)),l}if(!this.b){let l="";this.d.forEach((g,f)=>l+=`	${f} -> ${g.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${l}`),this.b=this.c(R.$xH,this.e,this.f)}return this.b}}let c=class{constructor(n,t,o){this.e=n,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(P.$bO.MainThreadTelemetry);const l=o.getProxy(P.$bO.MainThreadWindow);this.c=(g,f)=>{const d=D.URI.parse(g);return f?this.g(g,f):d.scheme==="http"||d.scheme==="https"?l.$openUri(d,g,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this.f?l.$openUri(d,g,{}):this.g(g,f)}}load(n,t,o){const l=this.e.findSubstr(t);return l&&(this.a=l.identifier.value,this.h()),this.b=o(n),this.c}g(n,t){return this.i(),this.b(n,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=Qe([We(2,m.$OQ)],c)}),define(Re[133],Oe([1,0,51,4,22,79,3,57,70,47,7,45,203,46]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$rc=e.$0rc=void 0,P=Ve(P),L=Ve(L),e.$0rc=(0,R.$Ki)("IExtHostVariableResolverProvider");class $ extends u.$SR{constructor(h,c,i,n,t,o,l){function g(){if(i){const f=i.activeEditor();if(f)return f.document.uri;const d=n.tabGroups.all.find(S=>S.isActive)?.activeTab;if(d!==void 0){if(d.input instanceof I.$5P||d.input instanceof I.$0P)return d.input.modified;if(d.input instanceof I.$4P||d.input instanceof I.$9P||d.input instanceof I.$7P)return d.input.uri}}}super({getFolderUri:f=>{const d=o.folders.filter(S=>S.name===f);if(d&&d.length>0)return d[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(f,d)=>t.getConfiguration(void 0,f).get(d),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=g();if(f)return P.$mc(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const f=g();if(f){const d=c.getWorkspaceFolder(f);if(d)return P.$mc(d.uri.fsPath)}}},getSelectedText:()=>{if(i){const f=i.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(i){const f=i.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>h.getExtension(f)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(L.env))}}let r=class extends D.$Zc{constructor(h,c,i,n,t){super(),this.b=h,this.c=c,this.g=i,this.h=n,this.j=t,this.a=new v.$Y(async()=>{const o=await this.h.getConfigProvider(),g={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async f=>{g.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,o,g,this.m())})}getResolver(){return this.a.value}m(){}};e.$$rc=r,e.$$rc=r=Qe([We(0,s.$7rc),We(1,b.$qrc),We(2,T.$ZQ),We(3,k.$trc),We(4,m.$Frc)],r)}),define(Re[134],Oe([1,0,10,6,2,4,18,3,5,70,47,16,7,45,195,81,196,46,133,36,35,8,17,96]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n,t,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$isc=e.$hsc=e.$gsc=e.$fsc=e.$esc=void 0,t=Ve(t),e.$esc=(0,T.$Ki)("IExtHostDebugService");let g=class extends L.$Zc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(O,p,w,M,A,F,G,x){super(),this.Y=p,this.Z=w,this.$=M,this.ab=A,this.bb=F,this.cb=G,this.db=x,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new D.$qe),this.z=this.B(new D.$qe),this.C=this.B(new D.$qe),this.F=this.B(new D.$qe),this.u=O.getProxy(m.$bO.MainThreadDebugService),this.I=this.B(new D.$qe),this.L=this.B(new D.$qe),this.G=new d(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(j=>{this.B(j.onDidChange(U=>{this.fb(j)})),this.fb(j)})}async $getVisualizerTreeItem(O,p){const w=this.gb(p);if(!w)return;const M=await this.Q.get(O)?.getTreeItem?.(w);return M?this.eb(O,M):void 0}registerDebugVisualizationTree(O,p,w){const M=R.$zn.toKey(O.identifier),A=this.ub(M,p);if(this.P.has(A))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.Q.set(A,w),this.u.$registerDebugVisualizerTree(A,!!w.editItem),(0,L.$Xc)(()=>{this.u.$unregisterDebugVisualizerTree(A),this.Q.delete(p)})}async $getVisualizerTreeItemChildren(O,p){const w=this.S.get(p)?.item;return w?(await this.Q.get(O)?.getChildren?.(w))?.map(A=>this.eb(O,A))||[]:[]}async $editVisualizerTreeItem(O,p){const w=this.S.get(O);if(!w)return;const M=await this.Q.get(w.provider)?.editItem?.(w.item,p);return this.eb(w.provider,M||w.item)}$disposeVisualizedTree(O){const p=this.S.get(O);if(!p)return;const w=[p.children];for(const M of w)if(M)for(const A of M)w.push(this.S.get(A)?.children),this.S.delete(A)}eb(O,p){let w=this.R.get(p);return w||(w=this.O++,this.R.set(p,w),this.S.set(w,{provider:O,item:p})),t.DebugTreeItem.from(p,w)}asDebugSourceUri(O,p){const w=O;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let M=`debug:${encodeURIComponent(w.path||"")}`,A="?";return p&&(M+=`${A}session=${encodeURIComponent(p.id)}`,A="&"),M+=`${A}ref=${w.sourceReference}`,P.URI.parse(M)}else{if(w.path)return P.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(O){const p=[];for(const w of O.getAllExtensionDescriptions())if(w.contributes){const M=w.contributes.debuggers;if(M&&M.length>0)for(const A of M)(0,a.$yI)(A)&&p.push(A.type)}this.u.$registerDebugTypes(p)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const O=[];return this.H.forEach(p=>O.push(p)),O}async $resolveDebugVisualizer(O,p){const w=this.W.get(O);if(!w)throw new Error(`No debug visualizer found with id '${O}'`);let{v:M,provider:A,extensionId:F}=w;if(M.visualization||(M=await A.resolveDebugVisualization?.(M,p)||M,w.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${A}'`);return this.vb(F,M.visualization)}async $executeDebugVisualizerCommand(O){const p=this.W.get(O);if(!p)throw new Error(`No debug visualizer found with id '${O}'`);const w=p.v.visualization;w&&"command"in w&&this.cb.executeCommand(w.command,...w.arguments||[])}gb(O){const p=this.w.get(O.sessionId);return p&&{session:p.api,variable:O.variable,containerId:O.containerId,frameId:O.frameId,threadId:O.threadId}}async $provideDebugVisualizers(O,p,w,M){const A=this.gb(w),F=this.ub(O,p),G=this.P.get(F);if(!A||!G)return[];const x=await G.provideDebugVisualization(A,M);return x?x.map(j=>{const U=++this.X;this.W.set(U,{v:j,provider:G,extensionId:O});const J=j.iconPath?this.wb(j.iconPath):void 0;return{id:U,name:j.name,iconClass:J?.iconClass,iconPath:J?.iconPath,visualization:this.vb(O,j.visualization)}}):[]}$disposeDebugVisualizers(O){for(const p of O)this.W.delete(p)}registerDebugVisualizationProvider(O,p,w){if(!O.contributes?.debugVisualizers?.some(F=>F.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const M=R.$zn.toKey(O.identifier),A=this.ub(M,p);if(this.P.has(A))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.P.set(A,w),this.u.$registerDebugVisualizer(M,p),(0,L.$Xc)(()=>{this.u.$unregisterDebugVisualizer(M,p),this.P.delete(p)})}addBreakpoints(O){const p=O.filter(A=>{const F=A.id;return this.H.has(F)?!1:(this.H.set(F,A),!0)});this.rb(p,[],[]);const w=[],M=new Map;for(const A of p)if(A instanceof u.$hP){let F=M.get(A.location.uri.toString());F||(F={type:"sourceMulti",uri:A.location.uri,lines:[]},M.set(A.location.uri.toString(),F),w.push(F)),F.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character,mode:A.mode})}else A instanceof u.$iP&&w.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName,mode:A.mode});return this.u.$registerBreakpoints(w)}removeBreakpoints(O){const p=O.filter(F=>this.H.delete(F.id));this.rb([],p,[]);const w=p.filter(F=>F instanceof u.$hP).map(F=>F.id),M=p.filter(F=>F instanceof u.$iP).map(F=>F.id),A=p.filter(F=>F instanceof u.$jP).map(F=>F.id);return this.u.$unregisterBreakpoints(w,M,A)}startDebugging(O,p,w){const M=w.testRun&&this.db.getMetadataForRun(w.testRun);return this.u.$startDebugging(O?O.uri:void 0,p,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(O){return this.u.$stopDebugging(O?O.id:void 0)}registerDebugConfigurationProvider(O,p,w){if(!p)return new u.$dO(()=>{});const M=this.f++;return this.g.push({type:O,handle:M,provider:p}),this.u.$registerDebugConfigurationProvider(O,w,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,M),new u.$dO(()=>{this.g=this.g.filter(A=>A.provider!==p),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(O,p,w){if(!w)return new u.$dO(()=>{});if(!this.nb(O,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.kb(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:p,handle:M,factory:w}),this.u.$registerDebugAdapterDescriptorFactory(p,M),new u.$dO(()=>{this.j=this.j.filter(A=>A.factory!==w),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(O,p){if(!p)return new u.$dO(()=>{});const w=this.m++;return this.n.push({type:O,handle:w,factory:p}),new u.$dO(()=>{this.n=this.n.filter(M=>M.factory!==p)})}async $runInTerminal(O,p){return Promise.resolve(void 0)}async $substituteVariables(O,p){let w;const M=await this.tb(O);return M&&(w={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(w,p)}hb(O,p){if(O.type==="implementation")return new E(O.implementation)}ib(){}async $startDASession(O,p){const w=this,M=await this.sb(p);return this.pb(this.kb(M.type),M).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const F=this.jb(A),G=this.hb(F,M);if(!G)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const x=G;return this.M.set(O,x),this.ob(M).then(j=>(j&&this.N.set(O,j),x.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const J=U,Z={type:"response",seq:0,command:J.command,request_seq:J.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const ae=await this.U.sign(J.arguments.value);Z.body={signature:ae},x.sendResponse(Z)}else throw new Error("no signer")}catch(ae){Z.success=!1,Z.message=ae.message,x.sendResponse(Z)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(U),U=(0,a.$DI)(U,!0),w.u.$acceptDAMessage(O,U)}),x.onError(U=>{j&&j.onError&&j.onError(U),this.u.$acceptDAError(O,U.name,U.message,U.stack)}),x.onExit(U=>{j&&j.onExit&&j.onExit(U??void 0,void 0),this.u.$acceptDAExit(O,U??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),x.startSession()))})}$sendDAMessage(O,p){p=(0,a.$CI)(p,!1);const w=this.N.get(O);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(p),this.M.get(O)?.sendMessage(p)}$stopDASession(O){const p=this.N.get(O);this.N.delete(O),p&&p.onWillStopSession&&p.onWillStopSession();const w=this.M.get(O);return this.M.delete(O),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(O){const p=[],w=[],M=[];if(O.added)for(const A of O.added){const F=A.id;if(F&&!this.H.has(F)){let G;if(A.type==="function")G=new u.$iP(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage,A.mode);else if(A.type==="data")G=new u.$jP(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage,A.mode);else{const x=P.URI.revive(A.uri);G=new u.$hP(new u.$rO(x,new u.$eO(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage,A.mode)}(0,u.$fP)(G,F),this.H.set(F,G),p.push(G)}}if(O.removed)for(const A of O.removed){const F=this.H.get(A);F&&(this.H.delete(A),w.push(F))}if(O.changed){for(const A of O.changed)if(A.id){const F=this.H.get(A.id);if(F){if(F instanceof u.$iP&&A.type==="function"){const G=F;G.enabled=A.enabled,G.condition=A.condition,G.hitCondition=A.hitCondition,G.logMessage=A.logMessage,G.functionName=A.functionName}else if(F instanceof u.$hP&&A.type==="source"){const G=F;G.enabled=A.enabled,G.condition=A.condition,G.hitCondition=A.hitCondition,G.logMessage=A.logMessage,G.location=new u.$rO(P.URI.revive(A.uri),new u.$eO(A.line,A.character))}M.push(F)}}}this.rb(p,w,M)}async $acceptStackFrameFocus(O){let p;if(O){const w=await this.sb(O.sessionId);O.kind==="thread"?p=new u.$pP(w.api,O.threadId):p=new u.$oP(w.api,O.threadId,O.frameId)}this.J=p,this.L.fire(this.J)}$provideDebugConfigurations(O,p,w){return(0,v.$Ch)(async()=>{const M=this.mb(O);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.tb(p);return M.provideDebugConfigurations(A,w)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(O,p,w,M){return(0,v.$Ch)(async()=>{const A=this.mb(O);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.tb(p);return A.resolveDebugConfiguration(F,w,M)})}$resolveDebugConfigurationWithSubstitutedVariables(O,p,w,M){return(0,v.$Ch)(async()=>{const A=this.mb(O);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.tb(p);return A.resolveDebugConfigurationWithSubstitutedVariables(F,w,M)})}async $provideDebugAdapter(O,p){const w=this.lb(O);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb(p);return this.pb(w,M).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(A)})}async $acceptDebugSessionStarted(O){const p=await this.sb(O);this.y.fire(p.api)}async $acceptDebugSessionTerminated(O){const p=await this.sb(O);p&&(this.z.fire(p.api),this.w.delete(p.id))}async $acceptDebugSessionActiveChanged(O){this.D=O?await this.sb(O):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(O,p){(await this.sb(O))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(O,p){const M={session:(await this.sb(O)).api,event:p.event,body:p.body};this.F.fire(M)}jb(O){if(O instanceof u.$kP)return{type:"executable",command:O.command,args:O.args,options:O.options};if(O instanceof u.$lP)return{type:"server",port:O.port,host:O.host};if(O instanceof u.$mP)return{type:"pipeServer",path:O.path};if(O instanceof u.$nP)return{type:"implementation",implementation:O.implementation};throw new Error("convertToDto unexpected type")}kb(O){const p=this.j.filter(w=>w.type===O);if(p.length>0)return p[0].factory}lb(O){const p=this.j.filter(w=>w.handle===O);if(p.length>0)return p[0].factory}mb(O){const p=this.g.filter(w=>w.handle===O);if(p.length>0)return p[0].provider}nb(O,p){if(O.contributes){const w=O.contributes.debuggers;if(w&&w.length>0){for(const M of w)if(M.label&&M.type&&M.type===p)return!0}}return!1}ob(O){const w=O.configuration.type,M=this.n.filter(A=>A.type===w||A.type==="*").map(A=>(0,v.$Ch)(()=>A.factory.createDebugAdapterTracker(O.api)).then(F=>F,F=>null));return Promise.race([Promise.all(M).then(A=>{const F=(0,o.$Lb)(A);if(F.length>0)return new S(F)}),new Promise(A=>setTimeout(()=>A(void 0),1e3))]).catch(A=>{})}async pb(O,p){const w=p.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new u.$lP(w));if(O){const A=await this.Z.getExtensionRegistry();return(0,v.$Ch)(()=>O.createDebugAdapterDescriptor(p.api,this.qb(p,A))).then(F=>{if(F)return F})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(p,M))}qb(O,p){}rb(O,p,w){(O.length>0||p.length>0||w.length>0)&&this.I.fire(Object.freeze({added:O,removed:p,changed:w}))}async sb(O){if(O)if(typeof O=="string"){const p=this.w.get(O);if(p)return p}else{let p=this.w.get(O.id);if(!p){const w=await this.tb(O.folderUri),M=O.parent?this.w.get(O.parent):void 0;p=new f(this.u,O.id,O.type,O.name,w,O.configuration,M?.api),this.w.set(p.id,p),this.u.$sessionCached(p.id)}return p}throw new Error("cannot find session")}tb(O){if(O){const p=P.URI.revive(O);return this.Y.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}ub(O,p){return`${O}\0${p}`}vb(O,p){if(p){if("title"in p&&"command"in p)return{type:r.DebugVisualizationType.Command};if("treeId"in p)return{type:r.DebugVisualizationType.Tree,id:`${O}\0${p.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(O){const p=this.xb(O);let w,M;return"id"in p?M=i.ThemeIcon.asClassName(p):w=p,{iconPath:w,iconClass:M}}xb(O){if(O instanceof u.$cP)return{id:O.id};const p=typeof O=="object"&&"dark"in O?O.dark:O,w=typeof O=="object"&&"light"in O?O.light:O;return{dark:typeof p=="string"?P.URI.file(p):p,light:typeof w=="string"?P.URI.file(w):w}}};e.$fsc=g,e.$fsc=g=Qe([We(0,b.$OQ),We(1,k.$qrc),We(2,I.$7rc),We(3,h.$trc),We(4,s.$Frc),We(5,c.$0rc),We(6,n.$$Q),We(7,l.$_rc)],g);class f{constructor(O,p,w,M,A,F,G){this.f=O,this.g=p,this.h=w,this.j=M,this.k=A,this.l=F,this.m=G}get api(){const O=this;return this.d??=Object.freeze({id:O.g,type:O.h,get name(){return O.j},set name(p){O.j=p,O.f.$setDebugSessionName(O.g,p)},parentSession:O.m,workspaceFolder:O.k,configuration:O.l,customRequest(p,w){return O.f.$customDebugAdapterRequest(O.g,p,w)},getDebugProtocolBreakpoint(p){return O.f.$getDebugProtocolBreakpoint(O.g,p.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(O){this.j=O}get configuration(){return this.l}}e.$gsc=f;class d{constructor(O){this.value=Object.freeze({append(p){O.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.$hsc=d;class S{constructor(O){this.d=O}onWillStartSession(){this.d.forEach(O=>O.onWillStartSession?O.onWillStartSession():void 0)}onWillReceiveMessage(O){this.d.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(O):void 0)}onDidSendMessage(O){this.d.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(O):void 0)}onWillStopSession(){this.d.forEach(O=>O.onWillStopSession?O.onWillStopSession():void 0)}onError(O){this.d.forEach(p=>p.onError?p.onError(O):void 0)}onExit(O,p){this.d.forEach(w=>w.onExit?w.onExit(O,p):void 0)}}class E extends $.$pwb{constructor(O){super(),this.h=O,O.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(O){this.h.handleMessage(O)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends g{constructor(O,p,w,M,A,F,G,x){super(O,p,w,M,A,F,G,x)}};e.$isc=y,e.$isc=y=Qe([We(0,b.$OQ),We(1,k.$qrc),We(2,I.$7rc),We(3,h.$trc),We(4,s.$Frc),We(5,c.$0rc),We(6,n.$$Q),We(7,l.$_rc)],y)}),define(Re[273],Oe([1,0,12,64,2,5,224,11,60,75,26,171,16,65,47,66]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$otc=e.$ntc=void 0,v=Ve(v),D=Ve(D);class a{static async installEarlyHandler(i){Error.stackTraceLimit=100;const n=i.get(T.$fk),o=i.get(u.$OQ).getProxy(L.$bO.MainThreadErrors);v.setUnexpectedErrorHandler(l=>{n.error(l);const g=v.$6(l);o.$onUnexpectedError(g)})}static async installFullHandler(i){const n=i.get(T.$fk),t=i.get(u.$OQ),o=i.get($.$7rc),l=i.get(r.$9Q),g=t.getProxy(L.$bO.MainThreadExtensionService),f=t.getProxy(L.$bO.MainThreadErrors),d=await o.getExtensionPathIndex(),S=new WeakMap;function E(O,p){if(S.has(O))return S.get(O).stack;let w="",M,A;for(const G of p)w+=`
	at ${G.toString()}`,A=G.getFileName(),!M&&A&&(M=d.findSubstr(P.URI.file(A)));const F=`${O.name||"Error"}: ${O.message||""}${w}`;return S.set(O,{extensionIdentifier:M?.identifier,stack:F}),F}const y=Symbol("prepareStackTrace wrapped");let C=E;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(O){if(O===E||!O||O[y]){C=O||E;return}C=function(p,w){return E(p,w),O.call(Error,p,w)},Object.assign(C,{[y]:!0})}}),v.setUnexpectedErrorHandler(O=>{n.error(O);const p=v.$6(O),w=S.get(O);if(!w?.extensionIdentifier){f.$onUnexpectedError(p);return}g.$onExtensionRuntimeError(w.extensionIdentifier,p);const M=l.onExtensionError(w.extensionIdentifier,O);n.trace("forwarded error to extension?",M,w)})}}e.$ntc=a;class h{constructor(i,n,t,o,l){this.a=t,this.b=new R.$tfc(i,null,o),n=h.e(n,this.b);const g=new s.$Ii(...(0,m.$3s)());g.set(I.$5Q,{_serviceBrand:void 0,...n,messagePorts:l}),g.set(u.$OQ,new u.$PQ(this.b)),g.set(k.$nrc,new k.$orc(o)),g.set($.$5rc,t);const f=new b.$Gr(g,!0);f.invokeFunction(a.installEarlyHandler),this.d=f.invokeFunction(d=>d.get(T.$fk)),D.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=f.invokeFunction(d=>d.get($.$7rc)),this.c.initialize(),f.invokeFunction(a.installFullHandler)}async asBrowserUri(i){const n=this.b.getProxy(L.$bO.MainThreadExtensionService);return P.URI.revive(await n.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,n){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=P.URI.revive(n.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=P.URI.revive(n.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>P.URI.revive(n.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(n.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(n.transformIncomingURIs(i.logsLocation)),i.workspace=n.transformIncomingURIs(i.workspace),i}}e.$otc=h}),define(Re[135],Oe([1,0,17,40,58]),function(be,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zsc=e.$ysc=e.$vsc=void 0,e.$wsc=s,e.$xsc=I,e.$Asc=$;function L(r){return"uri"in r&&"ranges"in r&&"preview"in r}function R(r){return r.folderOptions.map(a=>({folder:a.folder,excludes:a.excludes.map(h=>typeof h=="string"?h:h.pattern),includes:a.includes,useGlobalIgnoreFiles:a.useIgnoreFiles.global,useIgnoreFiles:a.useIgnoreFiles.local,useParentIgnoreFiles:a.useIgnoreFiles.parent,followSymlinks:a.followSymlinks,maxResults:r.maxResults,session:r.session}))}class T{constructor(a){this.a=a}provideFileSearchResults(a,h,c){return(async()=>{const n=R(h);return Promise.all(n.map(t=>this.a.provideFileSearchResults({pattern:a},t,c)))})().then(n=>(0,v.$Lb)(n).flat())}}e.$vsc=T;function m(r){return r.folderOptions.map(a=>({folder:a.folder,excludes:a.excludes.map(h=>typeof h=="string"?h:h.pattern),includes:a.includes,useGlobalIgnoreFiles:a.useIgnoreFiles.global,useIgnoreFiles:a.useIgnoreFiles.local,useParentIgnoreFiles:a.useIgnoreFiles.parent,followSymlinks:a.followSymlinks,maxResults:r.maxResults,previewOptions:s(r.previewOptions),maxFileSize:r.maxFileSize,encoding:a.encoding,afterContext:r.surroundingContext,beforeContext:r.surroundingContext}))}function s(r){return{matchLines:r?.matchLines??D.$UM.matchLines,charsPerLine:r?.charsPerLine??D.$UM.charsPerLine}}function I(r){if(L(r)){const a=(0,v.$6b)(r.ranges).map((h,c)=>{const n=(0,v.$6b)(r.preview.matches)[c];return{sourceRange:h,previewRange:n}});return new P.$pM(r.uri,a,r.preview.text)}else return new P.$qM(r.uri,r.text,r.lineNumber)}class b{constructor(a){this.a=a}provideTextSearchResults(a,h,c,i){const n=l=>{k(l)&&c.report(I(l))};return(async()=>(0,v.$Lb)(await Promise.all(m(h).map(l=>this.a.provideTextSearchResults(a,l,{report:g=>n(g)},i)))).reduce((l,g)=>({limitHit:l.limitHit||g.limitHit}),{limitHit:!1}))().then(l=>({limitHit:l.limitHit,message:(0,v.$Lb)((0,v.$6b)(l.message))}))}}e.$ysc=b;class u{constructor(a){this.a=a}provideAITextSearchResults(a,h,c,i){const n=l=>{k(l)&&c.report(I(l))};return(async()=>(0,v.$Lb)(await Promise.all(m(h).map(l=>this.a.provideAITextSearchResults(a,l,{report:g=>n(g)},i)))).reduce((l,g)=>({limitHit:l.limitHit||g.limitHit}),{limitHit:!1}))().then(l=>({limitHit:l.limitHit,message:(0,v.$Lb)((0,v.$6b)(l.message))}))}}e.$zsc=u;function k(r){if($(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}function $(r){return!!r.preview}}),define(Re[274],Oe([1,0,22,19,42,43,24,69,40,48,4,135]),function(be,e,v,D,P,L,R,T,m,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bsc=void 0,v=Ve(v),L=Ve(L),R=Ve(R);class u{constructor(a,h,c){this.l=a,this.o=h,this.p=c,this.f=!1,this.g=0,this.h=!1,this.a=a.filePattern,this.b=a.includePattern&&L.$Fk(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.j=new Set,this.k=a.excludePattern&&L.$Fk(a.excludePattern)}cancel(){this.h=!0,this.j.forEach(a=>a.cancel()),this.j=new Set}search(a){const h=this.l.folderQueries||[];return new Promise((c,i)=>{const n=t=>{this.g++,a(t)};if(this.h)return c({limitHit:this.f});this.l.extraFileResources&&this.l.extraFileResources.forEach(t=>{const o=t.toString(),l=v.$sc(o);this.k&&this.k(o,l)||this.w(n,{base:t,basename:l})}),this.q(h,n).then(t=>{c({limitHit:this.f,stats:t||void 0})},t=>{i(new Error((0,P.$vj)(t)))})})}async q(a,h){const c=new D.$Be,i=a.map(g=>this.r(g)),n=this.o instanceof b.$vsc?this.p?.tokenSource.token:this.p?.obj,t={folderOptions:i,maxResults:this.l.maxResults??m.$wM,session:n},o=s.$Qi.forUris();a.forEach(g=>{const f=new m.$QM(this.l,g),d=!f.hasSiblingExcludeClauses();o.set(g.folder,{queryTester:f,noSiblingsClauses:d,folder:g.folder,tree:this.s()})});let l;try{this.j.add(c),l=T.$ke.create();const g=await this.o.provideFileSearchResults(this.l.filePattern||"",t,c.token),f=l.elapsed(),d=T.$ke.create();return this.h&&!this.f||(g&&g.forEach(S=>{const E=o.findSubstr(S),y=v.$lc.relative(E.folder.path,S.path);if(E.noSiblingsClauses){const C=v.$sc(S.path);this.w(h,{base:E.folder,relativePath:y,basename:C});return}this.u(E.tree,E.folder,y,h)}),this.h&&!this.f)?null:(o.forEach(S=>{this.v(S.tree,S.queryTester,h)}),{providerTime:f,postProcessTime:d.elapsed()})}finally{c.dispose(),this.j.delete(c)}}r(a){const h=(0,m.$PM)(this.l.includePattern,a.includePattern);let c=a.excludePattern?.map(n=>({folder:n.folder,patterns:(0,m.$PM)(this.l.excludePattern,n.pattern)}));c?.length||(c=[{folder:void 0,patterns:(0,m.$PM)(this.l.excludePattern,void 0)}]);const i=(0,m.$TM)(c);return{folder:a.folder,excludes:i,includes:h,useIgnoreFiles:{local:!a.disregardIgnoreFiles,parent:!a.disregardParentIgnoreFiles,global:!a.disregardGlobalIgnoreFiles},followSymlinks:!a.ignoreSymlinks}}s(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}u({pathToEntries:a},h,c,i){if(c===this.a){const t=v.$sc(this.a);this.w(i,{base:h,relativePath:this.a,basename:t})}function n(t){const o=v.$sc(t),l=v.$rc(t);let g=a[l];g||(g=a[l]=[],n(l)),g.push({base:h,relativePath:t,basename:o})}n(c)}v({rootEntries:a,pathToEntries:h},c,i){const n=this,t=this.a;function o(l){const g=(0,m.$SM)(()=>l.map(f=>f.basename));for(let f=0,d=l.length;f<d;f++){const S=l[f],{relativePath:E,basename:y}=S;if(c.matchesExcludesSync(E,y,t!==y?g:void 0))continue;const C=h[E];if(C)o(C);else{if(E===t)continue;n.w(i,S)}if(n.f)break}}o(a)}w(a,h){(!this.b||h.relativePath&&this.b(h.relativePath,h.basename))&&((this.d||this.c&&this.g>=this.c)&&(this.f=!0,this.cancel()),this.f||a(h))}}class k extends I.$Zc{constructor(){super(),this.obj=new Object,this.tokenSource=new D.$Be}dispose(){this.tokenSource.cancel(),super.dispose()}}class ${constructor(){this.b=new Map}static{this.a=512}fileSearch(a,h,c,i){const n=this.c(a.cacheKey),t=new u(a,h,n);let o=0;const l=g=>{o+=g.length,c(g.map(f=>this.d(f)))};return this.f(t,$.a,l,i).then(g=>({limitHit:g.limitHit,stats:g.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:o,detailStats:g.stats}:void 0,messages:[]}))}clearCache(a){this.b.get(a)?.dispose(),this.b.delete(a)}c(a){if(a)return this.b.has(a)||this.b.set(a,new k),this.b.get(a)}d(a){return a.relativePath?{resource:R.$lh(a.base,a.relativePath)}:{resource:a.base}}f(a,h,c,i){const n=i.onCancellationRequested(()=>{a.cancel()}),t=l=>{l&&(o.push(l),h>0&&o.length>=h&&(c(o),o=[]))};let o=[];return a.search(t).then(l=>(o.length&&c(o),n.dispose(),l),l=>(o.length&&c(o),n.dispose(),Promise.reject(l)))}}e.$Bsc=$}),define(Re[275],Oe([1,0,10,19,42,15,22,24,48,2,40,58]),function(be,e,v,D,P,L,R,T,m,s,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Esc=e.$Dsc=e.$Csc=void 0,R=Ve(R),T=Ve(T);class u{constructor(c,i,n){this.f=c,this.g=i,this.h=n,this.b=null,this.c=!1,this.d=0}get j(){return this.f.query}search(c,i){const n=this.j.folderQueries||[],t=new D.$Be(i);return new Promise((o,l)=>{this.b=new $(c);let g=!1;const f=(d,S)=>{if(!g&&!this.c){const E=this.l(d);d instanceof b.$pM&&typeof this.j.maxResults=="number"&&this.d+E>this.j.maxResults&&(this.c=!0,g=!0,t.cancel(),d=this.m(d,this.j.maxResults-this.d));const y=this.l(d);this.d+=y;const C=d instanceof b.$pM;(y>0||!C)&&this.b.add(d,S)}};this.n(n,f,t.token).then(d=>{t.dispose(),this.b.flush(),o({limitHit:this.c||d?.limitHit,messages:this.k(d),stats:{type:this.h}})},d=>{t.dispose();const S=(0,P.$vj)(d);l(new Error(S))})})}k(c){return c?.message?Array.isArray(c.message)?c.message:[c.message]:[]}l(c){return c instanceof b.$pM?Array.isArray(c.ranges)?c.ranges.length:1:0}m(c,i){return new b.$pM(c.uri,c.ranges.slice(0,i),c.previewText)}async n(c,i,n){const t=m.$Qi.forUris();c.forEach((S,E)=>{const y=new I.$QM(this.j,S);t.set(S.folder,{queryTester:y,folder:S.folder,folderIdx:E})});const o=[],l={report:S=>{if(S.uri===void 0)throw Error("Text search result URI is undefined. Please check provider implementation.");const E=t.findSubstr(S.uri),y=E.folder.scheme===L.Schemas.file?(0,I.$RM)(()=>this.g.readdir(T.$kh(S.uri))):void 0,C=T.$nh(E.folder,S.uri);if(C){const O=E.queryTester.includedInQuery(C,R.$sc(C),y);(0,v.$wh)(O)?o.push(O.then(p=>{p&&i(S,E.folderIdx)})):O&&i(S,E.folderIdx)}}},f={folderOptions:c.map(S=>this.o(S)),maxFileSize:this.j.maxFileSize,maxResults:this.j.maxResults??I.$wM,previewOptions:this.j.previewOptions??I.$UM,surroundingContext:this.j.surroundingContext??0};"usePCRE2"in this.j&&(f.usePCRE2=this.j.usePCRE2);let d;return this.f.query.type===I.QueryType.aiText?d=await this.f.provider.provideAITextSearchResults(this.f.query.contentPattern,f,l,n):d=await this.f.provider.provideTextSearchResults(k(this.f.query.contentPattern),f,l,n),o.length&&await Promise.all(o),d}o(c){const i=(0,I.$PM)(this.j.includePattern,c.includePattern);let n=c.excludePattern?.map(l=>({folder:l.folder,patterns:(0,I.$PM)(this.j.excludePattern,l.pattern)}));(!n||n.length===0)&&(n=[{folder:void 0,patterns:(0,I.$PM)(this.j.excludePattern,void 0)}]);const t=(0,I.$TM)(n);return{folder:s.URI.from(c.folder),excludes:t,includes:i,useIgnoreFiles:{local:!c.disregardIgnoreFiles,parent:!c.disregardParentIgnoreFiles,global:!c.disregardGlobalIgnoreFiles},followSymlinks:!c.ignoreSymlinks,encoding:(c.fileEncoding&&this.g.toCanonicalName(c.fileEncoding))??""}}}e.$Csc=u;function k(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class ${constructor(c){this.g=c,this.c=-1,this.f=null,this.b=new a(512,i=>this.j(i))}add(c,i){this.f&&(this.c!==i||!T.$eh(this.d,c.uri))&&(this.h(),this.f=null),this.f||(this.c=i,this.f={resource:c.uri,results:[]}),this.f.results.push(r(c))}h(){const c=this.f&&this.f.results?this.f.results.length:0;this.b.addItem(this.f,c)}flush(){this.h(),this.b.flush()}j(c){this.g(c)}}e.$Dsc=$;function r(h){return h instanceof b.$pM?{previewText:h.previewText,rangeLocations:h.ranges.map(c=>({preview:{startLineNumber:c.previewRange.start.line,startColumn:c.previewRange.start.character,endLineNumber:c.previewRange.end.line,endColumn:c.previewRange.end.character},source:{startLineNumber:c.sourceRange.start.line,startColumn:c.sourceRange.start.character,endLineNumber:c.sourceRange.end.line,endColumn:c.sourceRange.end.character}}))}:{text:h.text,lineNumber:h.lineNumber}}class a{static{this.b=4e3}static{this.c=50}constructor(c,i){this.j=c,this.k=i,this.d=0,this.f=[],this.g=0}addItem(c,i){c&&this.l(c,i)}addItems(c,i){c&&this.m(c,i)}l(c,i){this.f.push(c),this.g+=i,this.n()}m(c,i){this.f=this.f.concat(c),this.g+=i,this.n()}n(){this.d<a.c?this.flush():this.g>=this.j?this.flush():this.h||(this.h=setTimeout(()=>{this.flush()},a.b))}flush(){this.g&&(this.d+=this.g,this.k(this.f),this.f=[],this.g=0,this.h&&(clearTimeout(this.h),this.h=0))}}e.$Esc=a}),define(Re[136],Oe([1,0,4,5,3,274,16,65,11,2,275,34,135]),function(be,e,v,D,P,L,R,T,m,s,I,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gsc=e.$Fsc=void 0,e.$Hsc=$,e.$Fsc=(0,P.$Ki)("IExtHostSearch");let k=class{constructor(h,c,i){this.n=h,this.o=c,this.q=i,this.c=this.n.getProxy(D.$bO.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new L.$Bsc}s(h){return this.o.transformOutgoingScheme(h)}registerTextSearchProviderOld(h,c){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const i=this.d++;return this.e.set(i,new u.$ysc(c)),this.c.$registerTextSearchProvider(i,this.s(h)),(0,v.$Xc)(()=>{this.g.delete(h),this.e.delete(i),this.c.$unregisterProvider(i)})}registerTextSearchProvider(h,c){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const i=this.d++;return this.e.set(i,c),this.c.$registerTextSearchProvider(i,this.s(h)),(0,v.$Xc)(()=>{this.g.delete(h),this.e.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProviderOld(h,c){if(this.i.has(h))throw new Error(`an AI text search provider for the scheme '${h}'is already registered`);this.i.add(h);const i=this.d++;return this.h.set(i,new u.$zsc(c)),this.c.$registerAITextSearchProvider(i,this.s(h)),(0,v.$Xc)(()=>{this.i.delete(h),this.h.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProvider(h,c){if(this.i.has(h))throw new Error(`an AI text search provider for the scheme '${h}'is already registered`);this.i.add(h);const i=this.d++;return this.h.set(i,c),this.c.$registerAITextSearchProvider(i,this.s(h)),(0,v.$Xc)(()=>{this.i.delete(h),this.h.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProviderOld(h,c){if(this.k.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.k.add(h);const i=this.d++;return this.j.set(i,new u.$vsc(c)),this.c.$registerFileSearchProvider(i,this.s(h)),(0,v.$Xc)(()=>{this.k.delete(h),this.j.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(h,c){if(this.k.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.k.add(h);const i=this.d++;return this.j.set(i,c),this.c.$registerFileSearchProvider(i,this.s(h)),(0,v.$Xc)(()=>{this.k.delete(h),this.j.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(h,c,i,n){const t=$(i),o=this.j.get(h);if(o)return this.l.fileSearch(t,o,l=>{this.c.$handleFileMatch(h,c,l.map(g=>g.resource))},n);throw new Error("unknown provider: "+h)}async doInternalFileSearchWithCustomCallback(h,c,i){return{messages:[]}}$clearCache(h){return this.l.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,c,i,n){const t=this.e.get(h);if(!t||!t.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${h}`);const o=$(i);return this.t(o,t).search(g=>this.c.$handleTextMatch(h,c,g),n)}$provideAITextSearchResults(h,c,i,n){const t=this.h.get(h);if(!t||!t.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${h}`);const o=$(i);return this.v(o,t).search(g=>this.c.$handleTextMatch(h,c,g),n)}$enableExtensionHostSearch(){}t(h,c){return new I.$Csc({query:h,provider:c},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}v(h,c){return new I.$Csc({query:h,provider:c},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"aiTextSearchProvider")}};e.$Gsc=k,e.$Gsc=k=Qe([We(0,R.$OQ),We(1,T.$nrc),We(2,m.$fk)],k);function $(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(r),extraFileResources:a.extraFileResources&&a.extraFileResources.map(h=>s.URI.revive(h))}}function r(a){return(0,b.$hi)(a)}});var oi=this&&this.__importDefault||function(be){return be&&be.__esModule?be:{default:be}};define(Re[276],Oe([1,0,19,12,6,4,15,37,2,106,164,153,52,18,28,11,62,63,185,5,227,256,85,91,232,233,234,211,201,35,235,46,236,134,124,237,213,228,238,239,57,70,214,229,47,241,68,242,50,26,257,215,243,244,95,245,86,87,217,269,247,190,248,258,249,130,218,250,251,252,16,253,136,88,254,219,255,89,92,132,66,56,128,96,259,230,260,261,93,8,7,220,65,221,67,262,263,123,45,81,84,21,58]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n,t,o,l,g,f,d,S,E,y,C,O,p,w,M,A,F,G,x,j,U,J,Z,ae,ee,oe,ie,ue,_,$e,Ie,X,V,re,we,Pe,Fe,Be,xe,nt,ht,$t,ut,et,Le,Ne,Me,q,B,H,Q,se,ge,Ee,ze,Je,_e,tt,ct,it,at,yt,Ye,he,pe,ye,Ce,fe,ve,Y,W,de,je,He,st,dt,mt,Ot,Tt,Ht,_t,Xe,At){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$itc=Ut,D=Ve(D),T=oi(T),b=Ve(b),$=Ve($),Y=Ve(Y),W=Ve(W);function Ut(bt){const Dt=bt.get($e.$5Q),ei=bt.get(_.$$qc),ti=bt.get(ie.$vrc),Qt=bt.get(ee.$7rc),wt=bt.get(Tt.$qrc),Lt=bt.get(at.$9Q),ci=bt.get(O.$trc),Yt=bt.get(je.$nrc),Ge=bt.get(Q.$OQ),ii=bt.get(tt.$Orc),li=bt.get(ct.$wrc),hi=bt.get(r.$gk),kt=bt.get(r.$fk),jt=bt.get(ve.$jHb),Mt=bt.get(o.$7qc),Bt=bt.get(Ot.$htc),ai=bt.get(Ee.$Yrc),ni=bt.get(J.$Frc),ri=bt.get(Be.$3rc),Gt=bt.get(l.$erc),Jt=bt.get(we.$Vrc);Ge.set(i.$cO.ExtHostFileSystemInfo,ei),Ge.set(i.$cO.ExtHostLogLevelServiceShape,hi),Ge.set(i.$cO.ExtHostWorkspace,wt),Ge.set(i.$cO.ExtHostConfiguration,ci),Ge.set(i.$cO.ExtHostExtensionService,Qt),Ge.set(i.$cO.ExtHostStorage,ii),Ge.set(i.$cO.ExtHostTunnelService,jt),Ge.set(i.$cO.ExtHostWindow,Bt),Ge.set(i.$cO.ExtHostSecretState,ai),Ge.set(i.$cO.ExtHostTelemetry,Lt),Ge.set(i.$cO.ExtHostEditorTabs,ni),Ge.set(i.$cO.ExtHostManagedSockets,ri),Ge.set(i.$cO.ExtHostAuthentication,Gt),Ge.set(i.$cO.ExtHostChatProvider,Jt);const ui=Ge.set(i.$cO.ExtHostDecorations,bt.get(M.$ksc)),Nt=Ge.set(i.$cO.ExtHostDocumentsAndEditors,bt.get(U.$ZQ)),Ct=Ge.set(i.$cO.ExtHostCommands,bt.get(y.$$Q)),vt=Ge.set(i.$cO.ExtHostTerminalService,bt.get(yt.$Rrc)),Xt=Ge.set(i.$cO.ExtHostTerminalShellIntegration,bt.get(Ye.$0sc)),Et=Ge.set(i.$cO.ExtHostDebugService,bt.get(w.$esc)),si=Ge.set(i.$cO.ExtHostSearch,bt.get(ge.$Fsc)),Zt=Ge.set(i.$cO.ExtHostTask,bt.get(it.$9sc)),Ni=Ge.set(i.$cO.ExtHostOutputService,bt.get(Ne.$Vsc)),di=Ge.set(i.$cO.ExtHostLocalization,bt.get(Fe.$2rc)),yi=Ge.set(i.$cO.ExtHostUrls,new He.$etc(Ge)),Wt=Ge.set(i.$cO.ExtHostDocuments,new j.$brc(Ge,Nt)),fi=Ge.set(i.$cO.ExtHostDocumentContentProviders,new G.$msc(Ge,Nt,kt)),Fi=Ge.set(i.$cO.ExtHostDocumentSaveParticipant,new x.$nsc(kt,Wt,Ge.getProxy(i.$bO.MainThreadBulkEdits))),Rt=Ge.set(i.$cO.ExtHostNotebook,new nt.$Isc(Ge,Ct,Nt,Wt,ti,si,kt)),Si=Ge.set(i.$cO.ExtHostNotebookDocuments,new $t.$Psc(Rt)),Ai=Ge.set(i.$cO.ExtHostNotebookEditors,new ut.$Qsc(kt,Rt)),gi=Ge.set(i.$cO.ExtHostNotebookKernels,new et.$Rsc(Ge,Dt,Rt,Ct,kt)),zi=Ge.set(i.$cO.ExtHostNotebookRenderers,new Le.$Tsc(Ge,Rt)),ji=Ge.set(i.$cO.ExtHostNotebookDocumentSaveParticipant,new ht.$Osc(kt,Rt,Ge.getProxy(i.$bO.MainThreadBulkEdits))),zt=Ge.set(i.$cO.ExtHostEditors,new pe.$krc(Ge,Nt)),Pi=Ge.set(i.$cO.ExtHostTreeViews,new fe.$ctc(Ge.getProxy(i.$bO.MainThreadTreeViews),Ct,kt)),Di=Ge.set(i.$cO.ExtHostEditorInsets,new E.$lrc(Ge.getProxy(i.$bO.MainThreadEditorInsets),zt,Dt.remote)),bi=Ge.set(i.$cO.ExtHostDiagnostics,new A.$arc(Ge,kt,ei,Nt)),wi=Ge.set(i.$cO.ExtHostLanguages,new Pe.$Msc(Ge,Wt,Ct.converter,Yt)),me=Ge.set(i.$cO.ExtHostLanguageFeatures,new V.$crc(Ge,Yt,Wt,Ct,bi,kt,Mt,Lt)),De=Ge.set(i.$cO.ExtHostFileSystem,new oe.$qsc(Ge,me)),ce=Ge.set(i.$cO.ExtHostFileSystemEventService,new ue.$rsc(Ge,kt,Nt)),K=Ge.set(i.$cO.ExtHostQuickOpen,(0,H.$Zsc)(Ge,wt,Ct)),ke=Ge.set(i.$cO.ExtHostSCM,new se.$2sc(Ge,Ct,Wt,kt)),qe=Ge.set(i.$cO.ExtHostQuickDiff,new B.$Ysc(Ge,Yt)),Ze=Ge.set(i.$cO.ExtHostShare,new ze.$3sc(Ge,Yt)),Ue=Ge.set(i.$cO.ExtHostComments,(0,C.$mrc)(Ge,Ct,Wt)),ot=Ge.set(i.$cO.ExtHostProgress,new q.$Xsc(Ge.getProxy(i.$bO.MainThreadProgress))),gt=Ge.set(i.$cO.ExtHostLabelService,new X.$Ksc(Ge)),Kt=Ge.set(i.$cO.ExtHostTheming,new ye.$_sc(Ge)),Vt=Ge.set(i.$cO.ExtHostTimeline,new Ce.$btc(Ge,Ct)),qt=Ge.set(i.$cO.ExtHostWebviews,new st.$Arc(Ge,Dt.remote,wt,kt,Mt)),Li=Ge.set(i.$cO.ExtHostWebviewPanels,new dt.$Drc(Ge,qt,wt)),en=Ge.set(i.$cO.ExtHostCustomEditors,new p.$Erc(Ge,Wt,li,qt,Li)),Vi=Ge.set(i.$cO.ExtHostWebviewViews,new mt.$ftc(Ge,qt)),Ei=Ge.set(i.$cO.ExtHostTesting,bt.get(he.$_rc)),tn=Ge.set(i.$cO.ExtHostUriOpeners,new de.$dtc(Ge)),nn=Ge.set(i.$cO.ExtHostProfileContentHandlers,new Me.$Wsc(Ge));Ge.set(i.$cO.ExtHostInteractive,new Ie.$Jsc(Ge,Rt,Nt,Ct,kt));const Ui=Ge.set(i.$cO.ExtHostChatAgents2,new f.$hrc(Ge,kt,Ct,Wt)),rn=Ge.set(i.$cO.ExtHostChatVariables,new d.$irc(Ge)),Bi=Ge.set(i.$cO.ExtHostLanguageModelTools,new re.$Lsc(Ge)),Hi=Ge.set(i.$cO.ExtHostAiRelatedInformation,new n.$6qc(Ge)),sn=Ge.set(i.$cO.ExtHostAiEmbeddingVector,new ae.$psc(Ge)),on=Ge.set(i.$cO.ExtHostStatusBar,new _e.$6sc(Ge,Ct.converter)),bn=Ge.set(i.$cO.ExtHostSpeech,new Je.$4sc(Ge)),Ci=Ge.set(i.$cO.ExtHostEmbeddings,new Z.$osc(Ge)),Ki=Object.values(i.$cO);Ge.assertRegistered(Ki);const wn=new g.$grc(Ge,Nt),vn=new S.$jrc(Ge),qi=new xe.$Nsc(Ge,kt),an=new F.$lsc(Ge);return t.$drc.register(Ct),function(Ae,mi,Qi){function lt(te){return(le,Te,ft)=>{const Pt=te(Ft=>{try{le.call(Te,Ft)}catch(Oi){D.$5(new Error(`[ExtensionListenerError] Extension '${Ae.identifier.value}' FAILED to handle event: ${Oi.toString()}`,{cause:Oi})),Lt.onExtensionError(Ae.identifier,Oi)}});return ft?.push(Pt),Pt}}const It=function(){let te=!Ae.isUnderDevelopment;function le(){te||(kt.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(ft){if(Array.isArray(ft))ft.forEach(Te);else if(typeof ft=="string")le();else{const Pt=ft;typeof Pt.scheme>"u"&&le(),typeof Pt.exclusive=="boolean"&&(0,Xe.$DH)(Ae,"documentFiltersExclusive")}return ft}}(),yn={getSession(te,le,Te){return typeof Te?.forceNewSession=="object"&&Te.forceNewSession.learnMore&&(0,Xe.$DH)(Ae,"authLearnMore"),Gt.getSession(Ae,te,le,Te)},getAccounts(te){return Gt.getAccounts(te)},async hasSession(te,le){return(0,Xe.$DH)(Ae,"authSession"),!!await Gt.getSession(Ae,te,le,{silent:!0})},get onDidChangeSessions(){return lt(Gt.onDidChangeSessions)},registerAuthenticationProvider(te,le,Te,ft){return Gt.registerAuthenticationProvider(te,le,Te,ft)}},Gi={registerCommand(te,le,Te){return Ct.registerCommand(!0,te,le,Te,void 0,Ae)},registerTextEditorCommand(te,le,Te){return Ct.registerCommand(!0,te,(...ft)=>{const Pt=zt.getActiveTextEditor();if(!Pt){kt.warn("Cannot execute "+te+" because there is no active text editor.");return}return Pt.edit(Ft=>{le.apply(Te,[Pt,Ft,...ft])}).then(Ft=>{Ft||kt.warn("Edits from command "+te+" were not applied.")},Ft=>{kt.warn("An error occurred while running command "+te,Ft)})},void 0,void 0,Ae)},registerDiffInformationCommand:(te,le,Te)=>((0,Xe.$DH)(Ae,"diffCommand"),Ct.registerCommand(!0,te,async(...ft)=>{const Pt=Nt.activeEditor(!0);if(!Pt){kt.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ft=await zt.getDiffInformation(Pt.id);le.apply(Te,[Ft,...ft])},void 0,void 0,Ae)),executeCommand(te,...le){return Ct.executeCommand(te,...le)},getCommands(te=!1){return Ct.getCommands(te)}},Ji={get machineId(){return Dt.telemetryInfo.machineId},get sessionId(){return Dt.telemetryInfo.sessionId},get language(){return Dt.environment.appLanguage},get appName(){return Dt.environment.appName},get appRoot(){return Dt.environment.appRoot?.fsPath??""},get appHost(){return Dt.environment.appHost},get uriScheme(){return Dt.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return lt(vt.onDidChangeShell)},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(Lt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$DH)(Ae,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$DH)(Ae,"telemetry"),lt(Lt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.$8Q)(Dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,le){return at.$7Q.validateSender(te),Lt.instantiateLogger(Ae,te,le)},openExternal(te,le){return Bt.openUri(te,{allowTunneling:!!Dt.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Dt.environment.appUriScheme)return yi.createAppUri(te);try{return await Bt.asExternalUri(te,{allowTunneling:!!Dt.remote.authority})}catch(le){if((0,R.$Tg)(te,R.Schemas.http)||(0,R.$Tg)(te,R.Schemas.https))return te;throw le}},get remoteName(){return(0,a.$qn)(Dt.remote.authority)},get remoteAuthority(){return(0,Xe.$DH)(Ae,"resolvers"),Dt.remote.authority},get uiKind(){return Dt.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return lt(kt.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$DH)(Ae,"resolvers"),Dt.quality},get appCommit(){return(0,Xe.$DH)(Ae,"resolvers"),Dt.commit}};Dt.environment.extensionTestsLocationURI||Object.freeze(Ji);const ki={createTestController(te,le,Te){return Ei.createTestController(Ae,te,le,Te)},createTestObserver(){return(0,Xe.$DH)(Ae,"testObserver"),Ei.createTestObserver()},runTests(te){return(0,Xe.$DH)(Ae,"testObserver"),Ei.runTests(te)},registerTestFollowupProvider(te){return(0,Xe.$DH)(Ae,"testObserver"),Ei.registerTestFollowupProvider(te)},get onDidChangeTestResults(){return(0,Xe.$DH)(Ae,"testObserver"),lt(Ei.onResultsChanged)},get testResults(){return(0,Xe.$DH)(Ae,"testObserver"),Ei.results}},Ri=Dt.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Sn={getExtension(te,le){(0,Xe.$CH)(Ae,"extensionsAny")||(le=!1);const Te=mi.mine.getExtensionDescription(te);if(Te)return new ee.$8rc(Qt,Ae.identifier,Te,Ri,!1);if(le){const ft=mi.all.getExtensionDescription(te);if(ft)return new ee.$8rc(Qt,Ae.identifier,ft,Ri,!0)}},get all(){const te=[];for(const le of mi.mine.getAllExtensionDescriptions())te.push(new ee.$8rc(Qt,Ae.identifier,le,Ri,!1));return te},get allAcrossExtensionHosts(){(0,Xe.$DH)(Ae,"extensionsAny");const te=new k.$An(mi.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),le=[];for(const Te of mi.all.getAllExtensionDescriptions()){const ft=!te.has(Te.identifier);le.push(new ee.$8rc(Qt,Ae.identifier,Te,Ri,ft))}return le},get onDidChange(){return(0,Xe.$CH)(Ae,"extensionsAny")?lt(P.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):lt(mi.mine.onDidChange)}},pi={createDiagnosticCollection(te){return bi.createDiagnosticCollection(Ae.identifier,te)},get onDidChangeDiagnostics(){return lt(bi.onDidChangeDiagnostics)},getDiagnostics:te=>bi.getDiagnostics(te),getLanguages(){return wi.getLanguages()},setTextDocumentLanguage(te,le){return wi.changeLanguage(te.uri,le)},match(te,le){const Te=Y.LanguageSelector.from(te);let ft;return(0,I.$Hu)(Te)&&(ft=Rt.notebookDocuments.find(Pt=>Pt.apiNotebook.getCells().find(Ft=>Ft.document===le))?.apiNotebook),(0,I.$Gu)(Te,le.uri,le.languageId,!0,ft?.uri,ft?.notebookType)},registerCodeActionsProvider(te,le,Te){return me.registerCodeActionProvider(Ae,It(te),le,Te)},registerDocumentPasteEditProvider(te,le,Te){return(0,Xe.$DH)(Ae,"documentPaste"),me.registerDocumentPasteEditProvider(Ae,It(te),le,Te)},registerCodeLensProvider(te,le){return me.registerCodeLensProvider(Ae,It(te),le)},registerDefinitionProvider(te,le){return me.registerDefinitionProvider(Ae,It(te),le)},registerDeclarationProvider(te,le){return me.registerDeclarationProvider(Ae,It(te),le)},registerImplementationProvider(te,le){return me.registerImplementationProvider(Ae,It(te),le)},registerTypeDefinitionProvider(te,le){return me.registerTypeDefinitionProvider(Ae,It(te),le)},registerHoverProvider(te,le){return me.registerHoverProvider(Ae,It(te),le,Ae.identifier)},registerEvaluatableExpressionProvider(te,le){return me.registerEvaluatableExpressionProvider(Ae,It(te),le,Ae.identifier)},registerInlineValuesProvider(te,le){return me.registerInlineValuesProvider(Ae,It(te),le,Ae.identifier)},registerDocumentHighlightProvider(te,le){return me.registerDocumentHighlightProvider(Ae,It(te),le)},registerMultiDocumentHighlightProvider(te,le){return me.registerMultiDocumentHighlightProvider(Ae,It(te),le)},registerLinkedEditingRangeProvider(te,le){return me.registerLinkedEditingRangeProvider(Ae,It(te),le)},registerReferenceProvider(te,le){return me.registerReferenceProvider(Ae,It(te),le)},registerRenameProvider(te,le){return me.registerRenameProvider(Ae,It(te),le)},registerNewSymbolNamesProvider(te,le){return(0,Xe.$DH)(Ae,"newSymbolNamesProvider"),me.registerNewSymbolNamesProvider(Ae,It(te),le)},registerDocumentSymbolProvider(te,le,Te){return me.registerDocumentSymbolProvider(Ae,It(te),le,Te)},registerWorkspaceSymbolProvider(te){return me.registerWorkspaceSymbolProvider(Ae,te)},registerDocumentFormattingEditProvider(te,le){return me.registerDocumentFormattingEditProvider(Ae,It(te),le)},registerDocumentRangeFormattingEditProvider(te,le){return me.registerDocumentRangeFormattingEditProvider(Ae,It(te),le)},registerOnTypeFormattingEditProvider(te,le,Te,...ft){return me.registerOnTypeFormattingEditProvider(Ae,It(te),le,[Te].concat(ft))},registerDocumentSemanticTokensProvider(te,le,Te){return me.registerDocumentSemanticTokensProvider(Ae,It(te),le,Te)},registerDocumentRangeSemanticTokensProvider(te,le,Te){return me.registerDocumentRangeSemanticTokensProvider(Ae,It(te),le,Te)},registerSignatureHelpProvider(te,le,Te,...ft){return typeof Te=="object"?me.registerSignatureHelpProvider(Ae,It(te),le,Te):me.registerSignatureHelpProvider(Ae,It(te),le,typeof Te>"u"?[]:[Te,...ft])},registerCompletionItemProvider(te,le,...Te){return me.registerCompletionItemProvider(Ae,It(te),le,Te)},registerInlineCompletionItemProvider(te,le,Te){return le.handleDidShowCompletionItem&&(0,Xe.$DH)(Ae,"inlineCompletionsAdditions"),le.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$DH)(Ae,"inlineCompletionsAdditions"),Te&&(0,Xe.$DH)(Ae,"inlineCompletionsAdditions"),me.registerInlineCompletionsProvider(Ae,It(te),le,Te)},registerInlineEditProvider(te,le){return(0,Xe.$DH)(Ae,"inlineEdit"),me.registerInlineEditProvider(Ae,It(te),le)},registerDocumentLinkProvider(te,le){return me.registerDocumentLinkProvider(Ae,It(te),le)},registerColorProvider(te,le){return me.registerColorProvider(Ae,It(te),le)},registerFoldingRangeProvider(te,le){return me.registerFoldingRangeProvider(Ae,It(te),le)},registerSelectionRangeProvider(te,le){return me.registerSelectionRangeProvider(Ae,te,le)},registerCallHierarchyProvider(te,le){return me.registerCallHierarchyProvider(Ae,te,le)},registerTypeHierarchyProvider(te,le){return me.registerTypeHierarchyProvider(Ae,te,le)},setLanguageConfiguration:(te,le)=>me.setLanguageConfiguration(Ae,te,le),getTokenInformationAtPosition(te,le){return(0,Xe.$DH)(Ae,"tokenInformation"),wi.tokenAtPosition(te,le)},registerInlayHintsProvider(te,le){return me.registerInlayHintsProvider(Ae,te,le)},createLanguageStatusItem(te,le){return wi.createLanguageStatusItem(Ae,te,le)},registerDocumentDropEditProvider(te,le,Te){return me.registerDocumentOnDropEditProvider(Ae,te,le,(0,Xe.$CH)(Ae,"documentPaste")?Te:void 0)}},Wi={get activeTextEditor(){return zt.getActiveTextEditor()},get visibleTextEditors(){return zt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(te,le,Te){m.URI.isUri(te)&&te.scheme===R.Schemas.vscodeRemote&&!te.authority&&Mt.report("workspace.showTextDocument",Ae,"A URI of 'vscode-remote' scheme requires an authority.");const ft=await(m.URI.isUri(te)?Promise.resolve(Xi.openTextDocument(te)):Promise.resolve(te));return zt.showTextDocument(ft,le,Te)},createTextEditorDecorationType(te){return zt.createTextEditorDecorationType(Ae,te)},onDidChangeActiveTextEditor(te,le,Te){return lt(zt.onDidChangeActiveTextEditor)(te,le,Te)},onDidChangeVisibleTextEditors(te,le,Te){return lt(zt.onDidChangeVisibleTextEditors)(te,le,Te)},onDidChangeTextEditorSelection(te,le,Te){return lt(zt.onDidChangeTextEditorSelection)(te,le,Te)},onDidChangeTextEditorOptions(te,le,Te){return lt(zt.onDidChangeTextEditorOptions)(te,le,Te)},onDidChangeTextEditorVisibleRanges(te,le,Te){return lt(zt.onDidChangeTextEditorVisibleRanges)(te,le,Te)},onDidChangeTextEditorViewColumn(te,le,Te){return lt(zt.onDidChangeTextEditorViewColumn)(te,le,Te)},onDidCloseTerminal(te,le,Te){return lt(vt.onDidCloseTerminal)(te,le,Te)},onDidOpenTerminal(te,le,Te){return lt(vt.onDidOpenTerminal)(te,le,Te)},onDidChangeActiveTerminal(te,le,Te){return lt(vt.onDidChangeActiveTerminal)(te,le,Te)},onDidChangeTerminalDimensions(te,le,Te){return(0,Xe.$DH)(Ae,"terminalDimensions"),lt(vt.onDidChangeTerminalDimensions)(te,le,Te)},onDidChangeTerminalState(te,le,Te){return lt(vt.onDidChangeTerminalState)(te,le,Te)},onDidWriteTerminalData(te,le,Te){return(0,Xe.$DH)(Ae,"terminalDataWriteEvent"),lt(vt.onDidWriteTerminalData)(te,le,Te)},onDidExecuteTerminalCommand(te,le,Te){return(0,Xe.$DH)(Ae,"terminalExecuteCommandEvent"),lt(vt.onDidExecuteTerminalCommand)(te,le,Te)},onDidChangeTerminalShellIntegration(te,le,Te){return lt(Xt.onDidChangeTerminalShellIntegration)(te,le,Te)},onDidStartTerminalShellExecution(te,le,Te){return lt(Xt.onDidStartTerminalShellExecution)(te,le,Te)},onDidEndTerminalShellExecution(te,le,Te){return lt(Xt.onDidEndTerminalShellExecution)(te,le,Te)},get state(){return Bt.getState()},onDidChangeWindowState(te,le,Te){return lt(Bt.onDidChangeWindowState)(te,le,Te)},showInformationMessage(te,...le){return qi.showMessage(Ae,T.default.Info,te,le[0],le.slice(1))},showWarningMessage(te,...le){return qi.showMessage(Ae,T.default.Warning,te,le[0],le.slice(1))},showErrorMessage(te,...le){return qi.showMessage(Ae,T.default.Error,te,le[0],le.slice(1))},showQuickPick(te,le,Te){return K.showQuickPick(Ae,te,le,Te)},showWorkspaceFolderPick(te){return K.showWorkspaceFolderPick(te)},showInputBox(te,le){return K.showInput(te,le)},showOpenDialog(te){return an.showOpenDialog(Ae,te)},showSaveDialog(te){return an.showSaveDialog(te)},createStatusBarItem(te,le,Te){let ft,Pt,Ft;return typeof te=="string"?(ft=te,Pt=le,Ft=Te):(Pt=te,Ft=le),on.createStatusBarEntry(Ae,ft,Pt,Ft)},setStatusBarMessage(te,le){return on.setStatusBarMessage(te,le)},withScmProgress(te){return Mt.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),ot.withProgress(Ae,{location:W.ProgressLocation.SourceControl},(le,Te)=>te({report(ft){}}))},withProgress(te,le){return ot.withProgress(Ae,te,le)},createOutputChannel(te,le){return Ni.createOutputChannel(te,le,Ae)},createWebviewPanel(te,le,Te,ft){return Li.createWebviewPanel(Ae,te,le,Te,ft)},createWebviewTextEditorInset(te,le,Te,ft){return(0,Xe.$DH)(Ae,"editorInsets"),Di.createWebviewEditorInset(te,le,Te,ft,Ae)},createTerminal(te,le,Te){return typeof te=="object"?"pty"in te?vt.createExtensionTerminal(te):vt.createTerminalFromOptions(te):vt.createTerminal(te,le,Te)},registerTerminalLinkProvider(te){return vt.registerLinkProvider(te)},registerTerminalProfileProvider(te,le){return vt.registerProfileProvider(Ae,te,le)},registerTerminalQuickFixProvider(te,le){return(0,Xe.$DH)(Ae,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(te,Ae.identifier.value,le)},registerTreeDataProvider(te,le){return Pi.registerTreeDataProvider(te,le,Ae)},createTreeView(te,le){return Pi.createTreeView(te,le,Ae)},registerWebviewPanelSerializer:(te,le)=>Li.registerWebviewPanelSerializer(Ae,te,le),registerCustomEditorProvider:(te,le,Te={})=>en.registerCustomEditorProvider(Ae,te,le,Te),registerFileDecorationProvider(te){return ui.registerFileDecorationProvider(te,Ae)},registerUriHandler(te){return yi.registerUriHandler(Ae,te)},createQuickPick(){return K.createQuickPick(Ae)},createInputBox(){return K.createInputBox(Ae)},get activeColorTheme(){return Kt.activeColorTheme},onDidChangeActiveColorTheme(te,le,Te){return lt(Kt.onDidChangeActiveColorTheme)(te,le,Te)},registerWebviewViewProvider(te,le,Te){return Vi.registerWebviewViewProvider(Ae,te,le,Te?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,le,Te){return lt(Rt.onDidChangeActiveNotebookEditor)(te,le,Te)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,le,Te){return lt(Ai.onDidChangeNotebookEditorSelection)(te,le,Te)},onDidChangeNotebookEditorVisibleRanges(te,le,Te){return lt(Ai.onDidChangeNotebookEditorVisibleRanges)(te,le,Te)},showNotebookDocument(te,le){return Rt.showNotebookDocument(te,le)},registerExternalUriOpener(te,le,Te){return(0,Xe.$DH)(Ae,"externalUriOpener"),tn.registerExternalUriOpener(Ae.identifier,te,le,Te)},registerProfileContentHandler(te,le){return(0,Xe.$DH)(Ae,"profileContentHandlers"),nn.registerProfileContentHandler(Ae,te,le)},registerQuickDiffProvider(te,le,Te,ft){return(0,Xe.$DH)(Ae,"quickDiffProvider"),qe.registerQuickDiffProvider(It(te),le,Te,ft)},get tabGroups(){return ni.tabGroups},registerShareProvider(te,le){return(0,Xe.$DH)(Ae,"shareProvider"),Ze.registerShareProvider(It(te),le)}},Xi={get rootPath(){return Mt.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(te){throw new D.$ab("rootPath")},getWorkspaceFolder(te){return wt.getWorkspaceFolder(te)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(te){throw new D.$ab("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(te){throw new D.$ab("workspaceFile")},updateWorkspaceFolders:(te,le,...Te)=>wt.updateWorkspaceFolders(Ae,te,le||0,...Te),onDidChangeWorkspaceFolders:function(te,le,Te){return lt(wt.onDidChangeWorkspace)(te,le,Te)},asRelativePath:(te,le)=>wt.getRelativePath(te,le),findFiles:(te,le,Te,ft)=>wt.findFiles(te,le,Te,Ae.identifier,ft),findFiles2:(te,le,Te)=>((0,Xe.$DH)(Ae,"findFiles2"),wt.findFiles2(te,le,Ae.identifier,Te)),findFiles2New:(te,le,Te)=>((0,Xe.$DH)(Ae,"findFiles2New"),wt.findFiles2New(te,le,Ae.identifier,Te)),findTextInFiles:(te,le,Te,ft)=>{(0,Xe.$DH)(Ae,"findTextInFiles");let Pt,Ft;return typeof le=="object"?(Pt=le,Ft=Te):(Pt={},Ft=le,ft=Te),wt.findTextInFiles(te,Pt||{},Ft,Ae.identifier,ft)},findTextInFilesNew:(te,le,Te)=>((0,Xe.$DH)(Ae,"findTextInFilesNew"),(0,Xe.$DH)(Ae,"textSearchProviderNew"),wt.findTextInFilesNew(te,Ae.identifier,le||{},Te)),save:te=>wt.save(te),saveAs:te=>wt.saveAs(te),saveAll:te=>wt.saveAll(te),applyEdit(te,le){return wn.applyWorkspaceEdit(te,Ae,le)},createFileSystemWatcher:(te,le,Te,ft)=>{let Pt;return typeof le=="boolean"?Pt={ignoreCreateEvents:!!le,ignoreChangeEvents:!!Te,ignoreDeleteEvents:!!ft,correlate:!1}:le&&((0,Xe.$DH)(Ae,"createFileSystemWatcher"),Pt={...le,correlate:!0}),ce.createFileSystemWatcher(wt,Ae,te,Pt)},get textDocuments(){return Wt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new D.$ab("textDocuments")},openTextDocument(te){let le;const Te=te;if(typeof te=="string")le=Promise.resolve(m.URI.file(te));else if(m.URI.isUri(te))le=Promise.resolve(te);else if(!Te||typeof Te=="object")le=Wt.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ft=>(kt.trace(`openTextDocument from ${Ae.identifier}`),ft.scheme===R.Schemas.vscodeRemote&&!ft.authority&&Mt.report("workspace.openTextDocument",Ae,"A URI of 'vscode-remote' scheme requires an authority."),Wt.ensureDocumentData(ft).then(Pt=>Pt.document)))},onDidOpenTextDocument:(te,le,Te)=>lt(Wt.onDidAddDocument)(te,le,Te),onDidCloseTextDocument:(te,le,Te)=>lt(Wt.onDidRemoveDocument)(te,le,Te),onDidChangeTextDocument:(te,le,Te)=>lt(Wt.onDidChangeDocument)(te,le,Te),onDidSaveTextDocument:(te,le,Te)=>lt(Wt.onDidSaveDocument)(te,le,Te),onWillSaveTextDocument:(te,le,Te)=>lt(Fi.getOnWillSaveTextDocumentEvent(Ae))(te,le,Te),get notebookDocuments(){return Rt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,le){let Te;if(m.URI.isUri(te))Te=te,await Rt.openNotebookDocument(te);else if(typeof te=="string")Te=m.URI.revive(await Rt.createNotebookDocument({viewType:te,content:le}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,le,Te){return lt(Si.onDidSaveNotebookDocument)(te,le,Te)},onDidChangeNotebookDocument(te,le,Te){return lt(Si.onDidChangeNotebookDocument)(te,le,Te)},onWillSaveNotebookDocument(te,le,Te){return lt(ji.getOnWillSaveNotebookDocumentEvent(Ae))(te,le,Te)},get onDidOpenNotebookDocument(){return lt(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(te,le,Te,ft){return Rt.registerNotebookSerializer(Ae,te,le,Te,(0,Xe.$CH)(Ae,"notebookLiveShare")?ft:void 0)},onDidChangeConfiguration:(te,le,Te)=>lt(Qi.onDidChangeConfiguration)(te,le,Te),getConfiguration(te,le){return le=arguments.length===1?void 0:le,Qi.getConfiguration(te,le,Ae)},registerTextDocumentContentProvider(te,le){return fi.registerTextDocumentContentProvider(te,le)},registerTaskProvider:(te,le)=>(Mt.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),Zt.registerTaskProvider(Ae,te,le)),registerFileSystemProvider(te,le,Te){return(0,L.$Wc)(De.registerFileSystemProvider(Ae,te,le,Te),ti.addFileSystemProvider(te,le,Te))},get fs(){return ti.value},registerFileSearchProvider:(te,le)=>((0,Xe.$DH)(Ae,"fileSearchProvider"),si.registerFileSearchProviderOld(te,le)),registerTextSearchProvider:(te,le)=>((0,Xe.$DH)(Ae,"textSearchProvider"),si.registerTextSearchProviderOld(te,le)),registerAITextSearchProvider:(te,le)=>((0,Xe.$DH)(Ae,"aiTextSearchProvider"),(0,Xe.$DH)(Ae,"textSearchProvider"),si.registerAITextSearchProviderOld(te,le)),registerFileSearchProviderNew:(te,le)=>((0,Xe.$DH)(Ae,"fileSearchProviderNew"),si.registerFileSearchProvider(te,le)),registerTextSearchProviderNew:(te,le)=>((0,Xe.$DH)(Ae,"textSearchProviderNew"),si.registerTextSearchProvider(te,le)),registerAITextSearchProviderNew:(te,le)=>((0,Xe.$DH)(Ae,"aiTextSearchProviderNew"),(0,Xe.$DH)(Ae,"textSearchProviderNew"),si.registerAITextSearchProvider(te,le)),registerRemoteAuthorityResolver:(te,le)=>((0,Xe.$DH)(Ae,"resolvers"),Qt.registerRemoteAuthorityResolver(te,le)),registerResourceLabelFormatter:te=>((0,Xe.$DH)(Ae,"resolvers"),gt.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Xe.$DH)(Ae,"resolvers"),Qt.getRemoteExecServer(te)),onDidCreateFiles:(te,le,Te)=>lt(ce.onDidCreateFile)(te,le,Te),onDidDeleteFiles:(te,le,Te)=>lt(ce.onDidDeleteFile)(te,le,Te),onDidRenameFiles:(te,le,Te)=>lt(ce.onDidRenameFile)(te,le,Te),onWillCreateFiles:(te,le,Te)=>lt(ce.getOnWillCreateFileEvent(Ae))(te,le,Te),onWillDeleteFiles:(te,le,Te)=>lt(ce.getOnWillDeleteFileEvent(Ae))(te,le,Te),onWillRenameFiles:(te,le,Te)=>lt(ce.getOnWillRenameFileEvent(Ae))(te,le,Te),openTunnel:te=>((0,Xe.$DH)(Ae,"tunnels"),jt.openTunnel(Ae,te).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,Xe.$DH)(Ae,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(te,le,Te)=>((0,Xe.$DH)(Ae,"tunnels"),lt(jt.onDidChangeTunnels)(te,le,Te)),registerPortAttributesProvider:(te,le)=>((0,Xe.$DH)(Ae,"portsAttributes"),jt.registerPortsAttributesProvider(te,le)),registerTunnelProvider:(te,le)=>((0,Xe.$DH)(Ae,"tunnelFactory"),jt.registerTunnelProvider(te,le)),registerTimelineProvider:(te,le)=>((0,Xe.$DH)(Ae,"timeline"),Vt.registerTimelineProvider(te,le,Ae.identifier,Ct.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:te=>((0,Xe.$DH)(Ae,"workspaceTrust"),wt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,le,Te)=>lt(wt.onDidGrantWorkspaceTrust)(te,le,Te),registerEditSessionIdentityProvider:(te,le)=>((0,Xe.$DH)(Ae,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(te,le)),onWillCreateEditSessionIdentity:(te,le,Te)=>((0,Xe.$DH)(Ae,"editSessionIdentityProvider"),lt(wt.getOnWillCreateEditSessionIdentityEvent(Ae))(te,le,Te)),registerCanonicalUriProvider:(te,le)=>((0,Xe.$DH)(Ae,"canonicalUriProvider"),wt.registerCanonicalUriProvider(te,le)),getCanonicalUri:(te,le,Te)=>((0,Xe.$DH)(Ae,"canonicalUriProvider"),wt.provideCanonicalUri(te,le,Te))},cn={get inputBox(){return Mt.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),ke.getLastInputBox(Ae)},createSourceControl(te,le,Te){return ke.createSourceControl(Ae,te,le,Te)}},ln={createCommentController(te,le){return Ue.createCommentController(Ae,te,le)}},un={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){return Et.activeStackItem},registerDebugVisualizationProvider(te,le){return(0,Xe.$DH)(Ae,"debugVisualization"),Et.registerDebugVisualizationProvider(Ae,te,le)},registerDebugVisualizationTreeProvider(te,le){return(0,Xe.$DH)(Ae,"debugVisualization"),Et.registerDebugVisualizationTree(Ae,te,le)},onDidStartDebugSession(te,le,Te){return lt(Et.onDidStartDebugSession)(te,le,Te)},onDidTerminateDebugSession(te,le,Te){return lt(Et.onDidTerminateDebugSession)(te,le,Te)},onDidChangeActiveDebugSession(te,le,Te){return lt(Et.onDidChangeActiveDebugSession)(te,le,Te)},onDidReceiveDebugSessionCustomEvent(te,le,Te){return lt(Et.onDidReceiveDebugSessionCustomEvent)(te,le,Te)},onDidChangeBreakpoints(te,le,Te){return lt(Et.onDidChangeBreakpoints)(te,le,Te)},onDidChangeActiveStackItem(te,le,Te){return lt(Et.onDidChangeActiveStackItem)(te,le,Te)},registerDebugConfigurationProvider(te,le,Te){return Et.registerDebugConfigurationProvider(te,le,Te||Ht.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,le){return Et.registerDebugAdapterDescriptorFactory(Ae,te,le)},registerDebugAdapterTrackerFactory(te,le){return Et.registerDebugAdapterTrackerFactory(te,le)},startDebugging(te,le,Te){return!Te||typeof Te=="object"&&"configuration"in Te?Et.startDebugging(te,le,{parentSession:Te}):Et.startDebugging(te,le,Te||{})},stopDebugging(te){return Et.stopDebugging(te)},addBreakpoints(te){return Et.addBreakpoints(te)},removeBreakpoints(te){return Et.removeBreakpoints(te)},asDebugSourceUri(te,le){return Et.asDebugSourceUri(te,le)}},En={registerTaskProvider:(te,le)=>Zt.registerTaskProvider(Ae,te,le),fetchTasks:te=>Zt.fetchTasks(te),executeTask:te=>Zt.executeTask(Ae,te),get taskExecutions(){return Zt.taskExecutions},onDidStartTask:(te,le,Te)=>lt(Zt.onDidStartTask)(te,le,Te),onDidEndTask:(te,le,Te)=>lt(Zt.onDidEndTask)(te,le,Te),onDidStartTaskProcess:(te,le,Te)=>lt(Zt.onDidStartTaskProcess)(te,le,Te),onDidEndTaskProcess:(te,le,Te)=>lt(Zt.onDidEndTaskProcess)(te,le,Te)},hn={createNotebookController(te,le,Te,ft,Pt){return gi.createNotebookController(Ae,te,le,Te,ft,(0,Xe.$CH)(Ae,"notebookMessaging")?Pt:void 0)},registerNotebookCellStatusBarItemProvider:(te,le)=>Rt.registerNotebookCellStatusBarItemProvider(Ae,te,le),createRendererMessaging(te){return zi.createRendererMessaging(Ae,te)},createNotebookControllerDetectionTask(te){return(0,Xe.$DH)(Ae,"notebookKernelSource"),gi.createNotebookControllerDetectionTask(Ae,te)},registerKernelSourceActionProvider(te,le){return(0,Xe.$DH)(Ae,"notebookKernelSource"),gi.registerKernelSourceActionProvider(Ae,te,le)},onDidChangeNotebookCellExecutionState(te,le,Te){return(0,Xe.$DH)(Ae,"notebookCellExecutionState"),lt(gi.onDidChangeNotebookCellExecutionState)(te,le,Te)}},dn={t(...te){if(typeof te[0]=="string"){const le=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return di.getMessage(Ae.identifier.value,{message:le,args:Te})}return di.getMessage(Ae.identifier.value,te[0])},get bundle(){return di.getBundle(Ae.identifier.value)},get uri(){return di.getBundleUri(Ae.identifier.value)}},kn={transferActiveChat(te){return(0,Xe.$DH)(Ae,"interactive"),Ui.transferActiveChat(te)}},In={getRelatedInformation(te,le){return(0,Xe.$DH)(Ae,"aiRelatedInformation"),Hi.getRelatedInformation(Ae,te,le)},registerRelatedInformationProvider(te,le){return(0,Xe.$DH)(Ae,"aiRelatedInformation"),Hi.registerRelatedInformationProvider(Ae,te,le)},registerEmbeddingVectorProvider(te,le){return(0,Xe.$DH)(Ae,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Ae,te,le)}},fn={registerChatResponseProvider(te,le,Te){return(0,Xe.$DH)(Ae,"chatProvider"),Jt.registerLanguageModel(Ae,te,le,Te)},registerChatVariableResolver(te,le,Te,ft,Pt,Ft,Oi,Zi){return(0,Xe.$DH)(Ae,"chatVariableResolver"),rn.registerVariableResolver(Ae,te,le,Te,ft,Pt,Ft,Oi,Zi?.id)},registerMappedEditsProvider(te,le){return(0,Xe.$DH)(Ae,"mappedEditsProvider"),me.registerMappedEditsProvider(Ae,te,le)},createChatParticipant(te,le){return Ui.createChatAgent(Ae,te,le)},createDynamicChatParticipant(te,le,Te){return(0,Xe.$DH)(Ae,"chatParticipantPrivate"),Ui.createDynamicChatAgent(Ae,te,le,Te)},registerChatParticipantDetectionProvider(te){return(0,Xe.$DH)(Ae,"chatParticipantAdditions"),Ui.registerChatParticipantDetectionProvider(te)}},Yi={selectChatModels:te=>Jt.selectLanguageModels(Ae,te??{}),onDidChangeChatModels:(te,le,Te)=>Jt.onDidChangeProviders(te,le,Te),registerChatModelProvider:(te,le,Te)=>((0,Xe.$DH)(Ae,"chatProvider"),Jt.registerLanguageModel(Ae,te,le,Te)),get embeddingModels(){return(0,Xe.$DH)(Ae,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(te,le,Te)=>((0,Xe.$DH)(Ae,"embeddings"),Ci.onDidChange(te,le,Te)),registerEmbeddingsProvider(te,le){return(0,Xe.$DH)(Ae,"embeddings"),Ci.registerEmbeddingsProvider(Ae,te,le)},async computeEmbeddings(te,le,Te){return(0,Xe.$DH)(Ae,"embeddings"),Ci.computeEmbeddings(te,le,Te)},registerTool(te,le){return(0,Xe.$DH)(Ae,"lmTools"),Bi.registerTool(Ae,te,le)},invokeTool(te,le,Te){return(0,Xe.$DH)(Ae,"lmTools"),Bi.invokeTool(te,le,Te)},get tools(){return(0,Xe.$DH)(Ae,"lmTools"),Bi.tools}},gn={registerSpeechProvider(te,le){return(0,Xe.$DH)(Ae,"speech"),bn.registerProvider(Ae.identifier,te,le)}};return{version:Dt.version,ai:In,authentication:yn,commands:Gi,comments:ln,chat:fn,debug:un,env:Ji,extensions:Sn,interactive:kn,l10n:dn,languages:pi,lm:Yi,notebooks:hn,scm:cn,speech:gn,tasks:En,tests:ki,window:Wi,workspace:Xi,Breakpoint:W.$gP,TerminalOutputAnchor:W.TerminalOutputAnchor,ChatResultFeedbackKind:W.ChatResultFeedbackKind,ChatVariableLevel:W.ChatVariableLevel,ChatCompletionItem:W.$cQ,CallHierarchyIncomingCall:W.$EO,CallHierarchyItem:W.$DO,CallHierarchyOutgoingCall:W.$FO,CancellationError:D.$9,CancellationTokenSource:v.$Be,CandidatePortSource:i.CandidatePortSource,CodeAction:W.$AO,CodeActionKind:W.$BO,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.$GO,Color:W.$TO,ColorInformation:W.$UO,ColorPresentation:W.$VO,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentState:W.CommentState,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CommentThreadState:W.CommentThreadState,CommentThreadApplicability:W.CommentThreadApplicability,CommentThreadFocus:W.CommentThreadFocus,CompletionItem:W.$NO,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.$OO,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.$4O,DebugAdapterExecutable:W.$kP,DebugAdapterInlineImplementation:W.$nP,DebugAdapterNamedPipeServer:W.$mP,DebugAdapterServer:W.$lP,DebugConfigurationProviderTriggerKind:Ht.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DebugVisualization:W.$DP,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.$tO,DiagnosticRelatedInformation:W.$sO,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.$dO,DocumentHighlight:W.$wO,DocumentHighlightKind:W.DocumentHighlightKind,MultiDocumentHighlight:W.$xO,DocumentLink:W.$SO,DocumentSymbol:W.$zO,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.$qP,InlineValueText:W.$rP,InlineValueVariableLookup:W.$sP,InlineValueEvaluatableExpression:W.$tP,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:P.$qe,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.$FP,FileDecoration2:W.$FP,FileSystemError:W.$wP,FileType:$.FileType,FilePermission:$.FilePermission,FoldingRange:W.$xP,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.$iP,InlineCompletionItem:W.$PO,InlineCompletionList:W.$QO,Hover:W.$uO,VerboseHover:W.$vO,HoverVerbosityAction:W.HoverVerbosityAction,IndentAction:b.IndentAction,Location:W.$rO,MarkdownString:W.$HO,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:W.$IO,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.$eO,ProcessExecution:W.$2O,ProgressLocation:W.ProgressLocation,QuickInputButtonLocation:W.QuickInputButtonLocation,QuickInputButtons:W.$EP,Range:W.$fO,RelativePattern:W.$eP,Selection:W.$gO,SelectionRange:W.$CO,SemanticTokens:W.$AP,SemanticTokensBuilder:W.$zP,SemanticTokensEdit:W.$BP,SemanticTokensEdits:W.$CP,SemanticTokensLegend:W.$yP,ShellExecution:W.$3O,ShellQuoting:W.ShellQuoting,SignatureHelp:W.$KO,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.$JO,SnippetString:W.$qO,SourceBreakpoint:W.$hP,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.$yO,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.$5O,TaskGroup:W.$1O,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.$WO,TerminalQuickFixTerminalCommand:W.$YO,TerminalQuickFixOpener:W.$XO,TerminalLocation:W.TerminalLocation,TerminalProfile:W.$ZO,TerminalExitReason:W.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:W.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.$mO,SnippetTextEdit:W.$oO,TextEditorCursorStyle:s.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,SyntaxTokenType:W.SyntaxTokenType,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.$dP,ThemeIcon:W.$cP,TreeItem:W.$6O,TreeItemCheckboxState:W.TreeItemCheckboxState,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.$3P,UIKind:_t.UIKind,Uri:m.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.$pO,DocumentPasteTriggerKind:W.DocumentPasteTriggerKind,DocumentDropEdit:W.$_O,DocumentDropOrPasteEditKind:W.$aP,DocumentPasteEdit:W.$bP,InlayHint:W.$MO,InlayHintLabelPart:W.$LO,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.$lO,ResolvedAuthority:W.$jO,ManagedResolvedAuthority:W.$kO,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.$PP,NotebookRange:W.$HP,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.$IP,NotebookData:W.$JP,NotebookRendererScript:W.$NP,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.$LP,NotebookCellOutputItem:W.$KP,NotebookCellStatusBarItem:W.$MP,NotebookControllerAffinity:W.NotebookControllerAffinity,NotebookControllerAffinity2:W.NotebookControllerAffinity2,NotebookEdit:W.$nO,NotebookKernelSourceAction:W.$OP,NotebookVariablesRequestKind:W.NotebookVariablesRequestKind,PortAttributes:W.$RP,LinkedEditingRanges:W.$QP,TestResultState:W.TestResultState,TestRunRequest:W.$SP,TestMessage:W.$TP,TestMessageStackFrame:W.$VP,TestTag:W.$UP,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:At.TextSearchCompleteMessageType,DataTransfer:W.$$O,DataTransferItem:W.$7O,TestCoverageCount:W.$WP,FileCoverage:W.$YP,FileCoverage2:W.$YP,StatementCoverage:W.$ZP,BranchCoverage:W.$1P,DeclarationCoverage:W.$2P,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity,QuickPickItemKind:W.QuickPickItemKind,InputBoxValidationSeverity:W.InputBoxValidationSeverity,TabInputText:W.$4P,TabInputTextDiff:W.$5P,TabInputTextMerge:W.$6P,TabInputCustom:W.$7P,TabInputNotebook:W.$9P,TabInputNotebookDiff:W.$0P,TabInputWebview:W.$8P,TabInputTerminal:W.$$P,TabInputInteractiveWindow:W.$_P,TabInputChat:W.$aQ,TabInputTextMultiDiff:W.$bQ,TelemetryTrustedValue:h.$Fp,LogLevel:r.LogLevel,EditSessionIdentityMatch:c.EditSessionIdentityMatch,InteractiveSessionVoteDirection:W.InteractiveSessionVoteDirection,ChatCopyKind:W.ChatCopyKind,InteractiveEditorResponseFeedbackKind:W.InteractiveEditorResponseFeedbackKind,DebugStackFrame:W.$oP,DebugThread:W.$pP,RelatedInformationType:W.RelatedInformationType,SpeechToTextStatus:W.SpeechToTextStatus,TextToSpeechStatus:W.TextToSpeechStatus,PartialAcceptTriggerKind:W.PartialAcceptTriggerKind,KeywordRecognitionStatus:W.KeywordRecognitionStatus,ChatResponseMarkdownPart:W.$dQ,ChatResponseFileTreePart:W.$hQ,ChatResponseAnchorPart:W.$iQ,ChatResponseProgressPart:W.$jQ,ChatResponseProgressPart2:W.$kQ,ChatResponseReferencePart:W.$nQ,ChatResponseReferencePart2:W.$nQ,ChatResponseCodeCitationPart:W.$oQ,ChatResponseWarningPart:W.$lQ,ChatResponseTextEditPart:W.$qQ,ChatResponseMarkdownWithVulnerabilitiesPart:W.$eQ,ChatResponseCommandButtonPart:W.$mQ,ChatResponseDetectedParticipantPart:W.$fQ,ChatResponseConfirmationPart:W.$gQ,ChatResponseMovePart:W.$pQ,ChatResponseReferencePartStatusKind:W.ChatResponseReferencePartStatusKind,ChatRequestTurn:W.$rQ,ChatResponseTurn:W.$sQ,ChatLocation:W.ChatLocation,ChatRequestEditorData:W.$tQ,ChatRequestNotebookData:W.$uQ,LanguageModelChatMessageRole:W.LanguageModelChatMessageRole,LanguageModelChatMessage:W.$wQ,LanguageModelChatMessageToolResultPart:W.$vQ,LanguageModelChatResponseTextPart:W.$yQ,LanguageModelChatResponseToolCallPart:W.$xQ,LanguageModelError:W.$CQ,NewSymbolName:W.$vP,NewSymbolNameTag:W.NewSymbolNameTag,NewSymbolNameTriggerKind:W.NewSymbolNameTriggerKind,InlineEdit:W.$DQ,InlineEditTriggerKind:W.InlineEditTriggerKind,ExcludeSettingOptions:At.ExcludeSettingOptions,TextSearchContextNew:At.$qM,TextSearchMatchNew:At.$pM,TextSearchCompleteMessageTypeNew:At.TextSearchCompleteMessageType}}}}),define(Re[277],Oe([1,0,60,130,45,124,46,35,57,56,132,134,136,89,93,85,123,68,50,88,66,70,216,11,133,86,87,91,95,128,96]),function(be,e,v,D,P,L,R,T,m,s,I,b,u,k,$,r,a,h,c,i,n,t,o,l,g,f,d,S,E,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$2s)(f.$2rc,f.$1rc,v.InstantiationType.Delayed),(0,v.$2s)(l.$gk,o.$jtc,v.InstantiationType.Delayed),(0,v.$2s)(r.$7qc,r.$8qc,v.InstantiationType.Delayed),(0,v.$2s)(T.$$Q,T.$0Q,v.InstantiationType.Eager),(0,v.$2s)(S.$erc,S.$frc,v.InstantiationType.Eager),(0,v.$2s)(E.$Vrc,E.$Wrc,v.InstantiationType.Eager),(0,v.$2s)(R.$trc,R.$rrc,v.InstantiationType.Eager),(0,v.$2s)(h.$vrc,h.$urc,v.InstantiationType.Eager),(0,v.$2s)(C.$_rc,C.$asc,v.InstantiationType.Eager),(0,v.$2s)(b.$esc,b.$isc,v.InstantiationType.Eager),(0,v.$2s)(L.$ksc,L.$jsc,v.InstantiationType.Eager),(0,v.$2s)(m.$ZQ,m.$YQ,v.InstantiationType.Eager),(0,v.$2s)(d.$3rc,d.$4rc,v.InstantiationType.Eager),(0,v.$2s)(c.$$qc,c.$0qc,v.InstantiationType.Eager),(0,v.$2s)(D.$Vsc,D.$Usc,v.InstantiationType.Delayed),(0,v.$2s)(u.$Fsc,u.$Gsc,v.InstantiationType.Eager),(0,v.$2s)(k.$Orc,k.$Nrc,v.InstantiationType.Eager),(0,v.$2s)(I.$9sc,I.$8sc,v.InstantiationType.Eager),(0,v.$2s)(s.$Rrc,s.$Urc,v.InstantiationType.Eager),(0,v.$2s)(y.$0sc,y.$$sc,v.InstantiationType.Eager),(0,v.$2s)($.$jHb,$.$kHb,v.InstantiationType.Eager),(0,v.$2s)(a.$htc,a.$gtc,v.InstantiationType.Eager),(0,v.$2s)(P.$qrc,P.$prc,v.InstantiationType.Eager),(0,v.$2s)(i.$Yrc,i.$Xrc,v.InstantiationType.Eager),(0,v.$2s)(n.$9Q,n.$6Q,v.InstantiationType.Eager),(0,v.$2s)(t.$Frc,t.$Grc,v.InstantiationType.Eager),(0,v.$2s)(g.$0rc,g.$$rc,v.InstantiationType.Eager)}),define(Re[278],Oe([1,0,276,47,2,272,7,10,223]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xvc=void 0;class s extends L.$mtc{k(){}getModule(k,$){for(const r of this.b){const a=r(k);if(a){k=a;break}}if(this.a.has(k))return this.a.get(k).load(k,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends D.$6rc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(m.$wvc);const k=this.h.invokeFunction(v.$itc);this.r=this.h.createInstance(s,k,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(k){return k.browser}async xb(k,$,r){$=$.with({path:b($.path,".js")});const a=k?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const h=P.URI.revive(await this.C.$asBrowserUri($)),c=await fetch(h.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),c.status!==200)throw new Error(c.statusText);const i=await c.text(),n=`${$.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${n}`;let o;try{o=new Function("module","exports","require",t)}catch(d){throw console.error(a?`Loading code for extension ${a} failed: ${d.message}`:`Loading code failed: ${d.message}`),console.error(`${$.toString(!0)}${typeof d.line=="number"?` line ${d.line}`:""}${typeof d.column=="number"?` column ${d.column}`:""}`),console.error(d),d}k&&await this.w.initializeLocalizedMessages(k);const l={},g={exports:l},f=d=>{const S=this.r.getModule(d,$);if(S===void 0)throw new Error(`Cannot load module '${d}'`);return S};try{return r.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),o(g,l,f),g.exports!==l?g.exports:l}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),r.codeLoadingStop()}}async $setRemoteEnvironment(k){}async Bb(k=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+k;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Lh)(10)}}e.$xvc=I;function b(u,k){return u.endsWith(k)?u:u+k}}),define(Re[279],Oe([1,0,74,60,11,47,188,92,278]),function(be,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$2s)(P.$fk,new v.$Hi(R.$ltc,[!0],!0)),(0,D.$2s)(L.$7rc,m.$xvc,D.InstantiationType.Eager),(0,D.$2s)(T.$wrc,T.$xrc,D.InstantiationType.Eager)}),define(Re[287],Oe([1,0,20,6,84,273,225,22,64,15,2,277,279]),function(be,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,T=Ve(T),m=Ve(m);const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function k(o){return/^(file|vscode-remote):/i.test(o)}const $=fetch.bind(self);function r(o){self.fetch=async function(l,g){return l instanceof Request||k(String(l))&&(l=(await o(I.URI.parse(String(l)))).toString(!0)),$(l,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,g,f,d,S){(async()=>(k(g.toString())&&(g=(await o(I.URI.parse(g.toString()))).toString(!0)),super.open(l,g,f??!0,d,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.Worker;Worker=function(l,g){if(/^file:/i.test(l.toString()))l=s.$5g.uriToBrowserUri(I.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const d=`(${function(C){function O(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const p=fetch.bind(self);self.fetch=function(M,A){return M instanceof Request?p(M,A):p(O(M),A)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,A,F,G,x){return super.open(M,O(A),F??!0,G,x)}};const w=importScripts.bind(self);self.importScripts=(...M)=>{w(...M.map(O))},w(C)}.toString()}('${l}'))`;g=g||{},g.name=`${name} -> ${g.name||T.$sc(l.toString())}`;const S=new Blob([d],{type:"application/javascript"}),E=URL.createObjectURL(S);return new o(E,g)}}else self.Worker=class extends R.$yvc{constructor(o,l){super(u,o,{name:T.$sc(o.toString()),...l})}};const a=new class{constructor(){this.pid=void 0}exit(o){b()}};class h{constructor(){const l=new MessageChannel,g=new D.$qe;let f=!1;u(l.port2,[l.port2]),l.port1.onmessage=d=>{const{data:S}=d;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const E=v.$Se.wrap(new Uint8Array(S,0,S.byteLength));if((0,P.$Kn)(E,P.MessageType.Terminate)){f=!0,i("received terminate message from renderer");return}g.fire(E)},this.protocol={onMessage:g.event,send:d=>{if(!f){const S=d.buffer.buffer.slice(d.buffer.byteOffset,d.buffer.byteOffset+d.buffer.byteLength);l.port1.postMessage(S,[S])}}}}}function c(o){return new Promise(l=>{const g=o.onMessage(f=>{g.dispose();const d=JSON.parse(f.toString());o.send((0,P.$Jn)(P.MessageType.Initialized)),l({protocol:o,initData:d})});o.send((0,P.$Jn)(P.MessageType.Ready))})}let i=o=>b();function n(o){return!!o&&typeof o=="object"&&o.type==="vscode.init"&&o.data instanceof Map}function t(){m.mark("code/extHost/willConnectToRenderer");const o=new h;return{onmessage(l){n(l)&&c(o.protocol).then(g=>{m.mark("code/extHost/didWaitForInitData");const f=new L.$otc(g.protocol,g.initData,a,null,l.data);r(d=>f.asBrowserUri(d)),i=d=>f.terminate(d)})}}}})}).call(this);

//# sourceMappingURL=extensionHostWorker.js.map
